/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/async","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/nls","vs/base/common/types","vs/base/common/network","vs/base/common/errors","electron","vs/platform/files/common/files","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/resources","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/node/pfs","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","vs/base/common/strings","os","vs/platform/product/common/productService","vs/platform/telemetry/common/telemetry","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/base/common/map","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/base/common/objects","vs/base/common/process","vs/base/parts/ipc/electron-main/ipcMain","vs/platform/environment/common/environment","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/json","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/hash","fs","vs/base/common/labels","child_process","vs/platform/update/common/update","vs/base/common/decorators","vs/base/common/errorMessage","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/ternarySearchTree","vs/platform/remote/common/remoteHosts","vs/platform/window/common/window","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/lazy","vs/base/common/stream","vs/platform/environment/node/argvHelper","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindows","vs/platform/backup/electron-main/backup","vs/platform/files/common/watcher","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/theme/electron-main/themeMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/iterator","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/codicons","vs/base/common/processes","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/storage/electron-main/storageMainService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/functional","vs/base/common/normalization","crypto","net","vs/base/node/id","vs/base/node/processes","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/shell/node/shellEnv","vs/platform/sign/common/sign","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/themables","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","path","vs/platform/contextkey/common/contextkey","vs/platform/dialogs/common/dialogs","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/base/node/unc","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/platform/windows/electron-main/windowImpl","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/electron-main/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/electronRemoteResources","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/telemetryUtils","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/userData/common/fileUserDataProvider","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/launch/electron-main/launchMainService","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/terminal/electron-main/electronPtyHostStarter","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindow","vs/platform/auxiliaryWindow/electron-main/auxiliaryWindowsMainService","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","string_decoder","vs/code/electron-main/main"],ae=function(X){for(var e=[],P=0,R=X.length;P<R;P++)e[P]=oe[X[P]];return e};define(oe[135],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function P(w,g,$){const d=R(w,g);if(d!==-1)return w[d]}e.$fb=P;function R(w,g,$=w.length-1){for(let d=$;d>=0;d--){const h=w[d];if(g(h))return d}return-1}e.$gb=R;function s(w,g){const $=j(w,g);return $===-1?void 0:w[$]}e.$hb=s;function j(w,g,$=0,d=w.length){let h=$,m=d;for(;h<m;){const c=Math.floor((h+m)/2);g(w[c])?h=c+1:m=c}return h-1}e.$ib=j;function D(w,g){const $=S(w,g);return $===w.length?void 0:w[$]}e.$jb=D;function S(w,g,$=0,d=w.length){let h=$,m=d;for(;h<m;){const c=Math.floor((h+m)/2);g(w[c])?m=c:h=c+1}return h}e.$kb=S;function f(w,g,$=0,d=w.length){const h=S(w,g,$,d);return h===w.length?-1:h}e.$lb=f;class l{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(l.assertInvariants){if(this.d){for(const d of this.e)if(this.d(d)&&!g(d))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const $=j(this.e,g,this.c);return this.c=$+1,$===-1?void 0:this.e[$]}}e.$mb=l;function p(w,g){if(w.length===0)return;let $=w[0];for(let d=1;d<w.length;d++){const h=w[d];g(h,$)>0&&($=h)}return $}e.$nb=p;function k(w,g){if(w.length===0)return;let $=w[0];for(let d=1;d<w.length;d++){const h=w[d];g(h,$)>=0&&($=h)}return $}e.$ob=k;function v(w,g){return p(w,($,d)=>-g($,d))}e.$pb=v;function u(w,g){if(w.length===0)return-1;let $=0;for(let d=1;d<w.length;d++){const h=w[d];g(h,w[$])>0&&($=d)}return $}e.$qb=u;function y(w,g){for(const $ of w){const d=g($);if(d!==void 0)return d}}e.$rb=y}),define(oe[136],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function P(D,S){const f=Object.create(null);for(const l of D){const p=S(l);let k=f[p];k||(k=f[p]=[]),k.push(l)}return f}e.$K=P;function R(D,S){const f=[],l=[];for(const p of D)S.has(p)||f.push(p);for(const p of S)D.has(p)||l.push(p);return{removed:f,added:l}}e.$L=R;function s(D,S){const f=[],l=[];for(const[p,k]of D)S.has(p)||f.push(k);for(const[p,k]of S)D.has(p)||l.push(k);return{removed:f,added:l}}e.$M=s;function j(D,S){const f=new Set;for(const l of S)D.has(l)&&f.add(l);return f}e.$N=j}),define(oe[137],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mt=e.$lt=e.$kt=e.$jt=void 0;function P(S,f){const l=Math.pow(10,f);return Math.round(S*l)/l}class R{constructor(f,l,p,k=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,f))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.r===l.r&&f.g===l.g&&f.b===l.b&&f.a===l.a}}e.$jt=R;class s{constructor(f,l,p,k){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.l=P(Math.max(Math.min(1,p),0),3),this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.l===l.l&&f.a===l.a}static fromRGBA(f){const l=f.r/255,p=f.g/255,k=f.b/255,v=f.a,u=Math.max(l,p,k),y=Math.min(l,p,k);let w=0,g=0;const $=(y+u)/2,d=u-y;if(d>0){switch(g=Math.min($<=.5?d/(2*$):d/(2-2*$),1),u){case l:w=(p-k)/d+(p<k?6:0);break;case p:w=(k-l)/d+2;break;case k:w=(l-p)/d+4;break}w*=60,w=Math.round(w)}return new s(w,g,$,v)}static i(f,l,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?f+(l-f)*6*p:p<1/2?l:p<2/3?f+(l-f)*(2/3-p)*6:f}static toRGBA(f){const l=f.h/360,{s:p,l:k,a:v}=f;let u,y,w;if(p===0)u=y=w=k;else{const g=k<.5?k*(1+p):k+p-k*p,$=2*k-g;u=s.i($,g,l+1/3),y=s.i($,g,l),w=s.i($,g,l-1/3)}return new R(Math.round(u*255),Math.round(y*255),Math.round(w*255),v)}}e.$kt=s;class j{constructor(f,l,p,k){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,f),0)|0,this.s=P(Math.max(Math.min(1,l),0),3),this.v=P(Math.max(Math.min(1,p),0),3),this.a=P(Math.max(Math.min(1,k),0),3)}static equals(f,l){return f.h===l.h&&f.s===l.s&&f.v===l.v&&f.a===l.a}static fromRGBA(f){const l=f.r/255,p=f.g/255,k=f.b/255,v=Math.max(l,p,k),u=Math.min(l,p,k),y=v-u,w=v===0?0:y/v;let g;return y===0?g=0:v===l?g=((p-k)/y%6+6)%6:v===p?g=(k-l)/y+2:g=(l-p)/y+4,new j(Math.round(g*60),w,v,f.a)}static toRGBA(f){const{h:l,s:p,v:k,a:v}=f,u=k*p,y=u*(1-Math.abs(l/60%2-1)),w=k-u;let[g,$,d]=[0,0,0];return l<60?(g=u,$=y):l<120?(g=y,$=u):l<180?($=u,d=y):l<240?($=y,d=u):l<300?(g=y,d=u):l<=360&&(g=u,d=y),g=Math.round((g+w)*255),$=Math.round(($+w)*255),d=Math.round((d+w)*255),new R(g,$,d,v)}}e.$lt=j;class D{static fromHex(f){return D.Format.CSS.parseHex(f)||D.red}static equals(f,l){return!f&&!l?!0:!f||!l?!1:f.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:j.fromRGBA(this.rgba)}constructor(f){if(f)if(f instanceof R)this.rgba=f;else if(f instanceof s)this.i=f,this.rgba=s.toRGBA(f);else if(f instanceof j)this.j=f,this.rgba=j.toRGBA(f);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(f){return!!f&&R.equals(this.rgba,f.rgba)&&s.equals(this.hsla,f.hsla)&&j.equals(this.hsva,f.hsva)}getRelativeLuminance(){const f=D.k(this.rgba.r),l=D.k(this.rgba.g),p=D.k(this.rgba.b),k=.2126*f+.7152*l+.0722*p;return P(k,4)}static k(f){const l=f/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(f){const l=this.getRelativeLuminance(),p=f.getRelativeLuminance();return l>p?(l+.05)/(p+.05):(p+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(f){const l=this.getRelativeLuminance(),p=f.getRelativeLuminance();return l>p}isDarkerThan(f){const l=this.getRelativeLuminance(),p=f.getRelativeLuminance();return l<p}lighten(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*f,this.hsla.a))}darken(f){return new D(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*f,this.hsla.a))}transparent(f){const{r:l,g:p,b:k,a:v}=this.rgba;return new D(new R(l,p,k,v*f))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new D(new R(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(f){const l=f.rgba,p=this.rgba.a,k=l.a,v=p+k*(1-p);if(v<1e-6)return D.transparent;const u=this.rgba.r*p/v+l.r*k*(1-p)/v,y=this.rgba.g*p/v+l.g*k*(1-p)/v,w=this.rgba.b*p/v+l.b*k*(1-p)/v;return new D(new R(u,y,w,v))}makeOpaque(f){if(this.isOpaque()||f.rgba.a!==1)return this;const{r:l,g:p,b:k,a:v}=this.rgba;return new D(new R(f.rgba.r-v*(f.rgba.r-l),f.rgba.g-v*(f.rgba.g-p),f.rgba.b-v*(f.rgba.b-k),1))}flatten(...f){const l=f.reduceRight((p,k)=>D.o(k,p));return D.o(this,l)}static o(f,l){const p=1-f.rgba.a;return new D(new R(p*l.rgba.r+f.rgba.a*f.rgba.r,p*l.rgba.g+f.rgba.a*f.rgba.g,p*l.rgba.b+f.rgba.a*f.rgba.b))}toString(){return this.u||(this.u=D.Format.CSS.format(this)),this.u}static getLighterColor(f,l,p){if(f.isLighterThan(l))return f;p=p||.5;const k=f.getRelativeLuminance(),v=l.getRelativeLuminance();return p=p*(v-k)/v,f.lighten(p)}static getDarkerColor(f,l,p){if(f.isDarkerThan(l))return f;p=p||.5;const k=f.getRelativeLuminance(),v=l.getRelativeLuminance();return p=p*(k-v)/k,f.darken(p)}static{this.white=new D(new R(255,255,255,1))}static{this.black=new D(new R(0,0,0,1))}static{this.red=new D(new R(255,0,0,1))}static{this.blue=new D(new R(0,0,255,1))}static{this.green=new D(new R(0,255,0,1))}static{this.cyan=new D(new R(0,255,255,1))}static{this.lightgrey=new D(new R(211,211,211,1))}static{this.transparent=new D(new R(0,0,0,0))}}e.$mt=D,function(S){let f;(function(l){let p;(function(k){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:S.Format.CSS.formatRGBA(t)}k.formatRGB=v;function u(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}k.formatRGBA=u;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:S.Format.CSS.formatHSLA(t)}k.formatHSL=y;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}k.formatHSLA=w;function g(t){const o=t.toString(16);return o.length!==2?"0"+o:o}function $(t){return`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}`}k.formatHex=$;function d(t,o=!1){return o&&t.rgba.a===1?S.Format.CSS.formatHex(t):`#${g(t.rgba.r)}${g(t.rgba.g)}${g(t.rgba.b)}${g(Math.round(t.rgba.a*255))}`}k.formatHexA=d;function h(t){return t.isOpaque()?S.Format.CSS.formatHex(t):S.Format.CSS.formatRGBA(t)}k.format=h;function m(t){const o=t.length;if(o===0||t.charCodeAt(0)!==35)return null;if(o===7){const r=16*c(t.charCodeAt(1))+c(t.charCodeAt(2)),i=16*c(t.charCodeAt(3))+c(t.charCodeAt(4)),n=16*c(t.charCodeAt(5))+c(t.charCodeAt(6));return new S(new R(r,i,n,1))}if(o===9){const r=16*c(t.charCodeAt(1))+c(t.charCodeAt(2)),i=16*c(t.charCodeAt(3))+c(t.charCodeAt(4)),n=16*c(t.charCodeAt(5))+c(t.charCodeAt(6)),a=16*c(t.charCodeAt(7))+c(t.charCodeAt(8));return new S(new R(r,i,n,a/255))}if(o===4){const r=c(t.charCodeAt(1)),i=c(t.charCodeAt(2)),n=c(t.charCodeAt(3));return new S(new R(16*r+r,16*i+i,16*n+n))}if(o===5){const r=c(t.charCodeAt(1)),i=c(t.charCodeAt(2)),n=c(t.charCodeAt(3)),a=c(t.charCodeAt(4));return new S(new R(16*r+r,16*i+i,16*n+n,(16*a+a)/255))}return null}k.parseHex=m;function c(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=l.CSS||(l.CSS={}))})(f=S.Format||(S.Format={}))}(D||(e.$mt=D={}))}),define(oe[50],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function P(D){return(S,f,l)=>{let p=null,k=null;if(typeof l.value=="function"?(p="value",k=l.value):typeof l.get=="function"&&(p="get",k=l.get),!k)throw new Error("not supported");l[p]=D(k,f)}}function R(D,S,f){let l=null,p=null;if(typeof f.value=="function"?(l="value",p=f.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof f.get=="function"&&(l="get",p=f.get),!p)throw new Error("not supported");const k=`$memoize$${S}`;f[l]=function(...v){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,v)}),this[k]}}e.$xh=R;function s(D,S,f){return P((l,p)=>{const k=`$debounce$${p}`,v=`$debounce$result$${p}`;return function(...u){this[v]||(this[v]=f?f():void 0),clearTimeout(this[k]),S&&(this[v]=S(this[v],...u),u=[this[v]]),this[k]=setTimeout(()=>{l.apply(this,u),this[v]=f?f():void 0},D)}})}e.$yh=s;function j(D,S,f){return P((l,p)=>{const k=`$throttle$timer$${p}`,v=`$throttle$result$${p}`,u=`$throttle$lastRun$${p}`,y=`$throttle$pending$${p}`;return function(...w){if(this[v]||(this[v]=f?f():void 0),(this[u]===null||this[u]===void 0)&&(this[u]=-Number.MAX_VALUE),S&&(this[v]=S(this[v],...w)),this[y])return;const g=this[u]+D;g<=Date.now()?(this[u]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0):(this[y]=!0,this[k]=setTimeout(()=>{this[y]=!1,this[u]=Date.now(),l.apply(this,[this[v]]),this[v]=f?f():void 0},g-Date.now()))}})}e.$zh=j}),define(oe[14],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class P{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?h.isErrorNoTelemetry(t)?new h(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(o=>{o(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=P,e.$X=new P;function R(c){e.$X.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=R;function s(c){if(!c||typeof c!="object")return!1;const t=c;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=s;function j(c){l(c)||e.$X.onUnexpectedError(c)}e.$1=j;function D(c){l(c)||e.$X.onUnexpectedExternalError(c)}e.$2=D;function S(c){if(c instanceof Error){const{name:t,message:o}=c,r=c.stacktrace||c.stack;return{$isError:!0,name:t,message:o,stack:r,noTelemetry:h.isErrorNoTelemetry(c)}}return c}e.$3=S;const f="Canceled";function l(c){return c instanceof p?!0:c instanceof Error&&c.name===f&&c.message===f}e.$4=l;class p extends Error{constructor(){super(f),this.name=this.message}}e.$5=p;function k(){const c=new Error(f);return c.name=c.message,c}e.$6=k;function v(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.$7=v;function u(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.$8=u;class y extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=y;function w(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.$0=w;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class $ extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=$;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=d;class h extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof h)return t;const o=new h;return o.message=t.message,o.stack=t.stack,o}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=h;class m extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,m.prototype)}}e.$cb=m}),define(oe[22],ae([0,1,14,135]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function s(z,x=0){return z[z.length-(1+x)]}e.$sb=s;function j(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$tb=j;function D(z,x,N=(B,Q)=>B===Q){if(z===x)return!0;if(!z||!x||z.length!==x.length)return!1;for(let B=0,Q=z.length;B<Q;B++)if(!N(z[B],x[B]))return!1;return!0}e.$ub=D;function S(z,x){const N=z.length-1;x<N&&(z[x]=z[N]),z.pop()}e.$vb=S;function f(z,x,N){return l(z.length,B=>N(z[B],x))}e.$wb=f;function l(z,x){let N=0,B=z-1;for(;N<=B;){const Q=(N+B)/2|0,se=x(Q);if(se<0)N=Q+1;else if(se>0)B=Q-1;else return Q}return-(N+1)}e.$xb=l;function p(z,x,N){if(z=z|0,z>=x.length)throw new TypeError("invalid index");const B=x[Math.floor(x.length*Math.random())],Q=[],se=[],le=[];for(const ge of x){const be=N(ge,B);be<0?Q.push(ge):be>0?se.push(ge):le.push(ge)}return z<Q.length?p(z,Q,N):z<Q.length+le.length?le[0]:p(z-(Q.length+le.length),se,N)}e.$yb=p;function k(z,x){const N=[];let B;for(const Q of z.slice(0).sort(x))!B||x(B[0],Q)!==0?(B=[Q],N.push(B)):B.push(Q);return N}e.$zb=k;function*v(z,x){let N,B;for(const Q of z)B!==void 0&&x(B,Q)?N.push(Q):(N&&(yield N),N=[Q]),B=Q;N&&(yield N)}e.$Ab=v;function u(z,x){for(let N=0;N<=z.length;N++)x(N===0?void 0:z[N-1],N===z.length?void 0:z[N])}e.$Bb=u;function y(z,x){for(let N=0;N<z.length;N++)x(N===0?void 0:z[N-1],z[N],N+1===z.length?void 0:z[N+1])}e.$Cb=y;function w(z,x,N){const B=[];function Q(ge,be,Se){if(be===0&&Se.length===0)return;const Ae=B[B.length-1];Ae&&Ae.start+Ae.deleteCount===ge?(Ae.deleteCount+=be,Ae.toInsert.push(...Se)):B.push({start:ge,deleteCount:be,toInsert:Se})}let se=0,le=0;for(;;){if(se===z.length){Q(se,0,x.slice(le));break}if(le===x.length){Q(se,z.length-se,[]);break}const ge=z[se],be=x[le],Se=N(ge,be);Se===0?(se+=1,le+=1):Se<0?(Q(se,1,[]),se+=1):Se>0&&(Q(se,0,[be]),le+=1)}return B}e.$Db=w;function g(z,x,N){const B=w(z,x,N),Q=[],se=[];for(const le of B)Q.push(...z.slice(le.start,le.start+le.deleteCount)),se.push(...le.toInsert);return{removed:Q,added:se}}e.$Eb=g;function $(z,x,N){if(N===0)return[];const B=z.slice(0,N).sort(x);return h(z,x,B,N,z.length),B}e.top=$;function d(z,x,N,B,Q){return N===0?Promise.resolve([]):new Promise((se,le)=>{(async()=>{const ge=z.length,be=z.slice(0,N).sort(x);for(let Se=N,Ae=Math.min(N+B,ge);Se<ge;Se=Ae,Ae=Math.min(Ae+B,ge)){if(Se>N&&await new Promise(Le=>setTimeout(Le)),Q&&Q.isCancellationRequested)throw new P.$5;h(z,x,be,Se,Ae)}return be})().then(se,le)})}e.$Gb=d;function h(z,x,N,B,Q){for(const se=N.length;B<Q;B++){const le=z[B];if(x(le,N[se-1])<0){N.pop();const ge=(0,R.$kb)(N,be=>x(le,be)<0);N.splice(ge,0,le)}}}function m(z){return z.filter(x=>!!x)}e.$Hb=m;function c(z){let x=0;for(let N=0;N<z.length;N++)z[N]&&(z[x]=z[N],x+=1);z.length=x}e.$Ib=c;function t(z,x,N){z.splice(N,0,z.splice(x,1)[0])}e.$Jb=t;function o(z){return!Array.isArray(z)||z.length===0}e.$Kb=o;function r(z){return Array.isArray(z)&&z.length>0}e.$Lb=r;function i(z,x=N=>N){const N=new Set;return z.filter(B=>{const Q=x(B);return N.has(Q)?!1:(N.add(Q),!0)})}e.$Mb=i;function n(z){const x=new Set;return N=>{const B=z(N);return x.has(B)?!1:(x.add(B),!0)}}e.$Nb=n;function a(z,x){return z.length>0?z[0]:x}e.$Ob=a;function b(z,x){return z.length>0?z[z.length-1]:x}e.$Pb=b;function C(z,x,N=(B,Q)=>B===Q){let B=0;for(let Q=0,se=Math.min(z.length,x.length);Q<se&&N(z[Q],x[Q]);Q++)B++;return B}e.$Qb=C;function I(z){return[].concat(...z)}e.$Rb=I;function E(z,x){let N=typeof x=="number"?z:0;typeof x=="number"?N=z:(N=0,x=z);const B=[];if(N<=x)for(let Q=N;Q<x;Q++)B.push(Q);else for(let Q=N;Q>x;Q--)B.push(Q);return B}e.$Sb=E;function A(z,x,N){return z.reduce((B,Q)=>(B[x(Q)]=N?N(Q):Q,B),Object.create(null))}e.$Tb=A;function M(z,x){return z.push(x),()=>T(z,x)}e.$Ub=M;function T(z,x){const N=z.indexOf(x);if(N>-1)return z.splice(N,1),x}e.$Vb=T;function W(z,x,N){const B=z.slice(0,x),Q=z.slice(x);return B.concat(N,Q)}e.$Wb=W;function G(z,x){let N;if(typeof x=="number"){let B=x;N=()=>{const Q=Math.sin(B++)*179426549;return Q-Math.floor(Q)}}else N=Math.random;for(let B=z.length-1;B>0;B-=1){const Q=Math.floor(N()*(B+1)),se=z[B];z[B]=z[Q],z[Q]=se}}e.$Xb=G;function J(z,x){const N=z.indexOf(x);N>-1&&(z.splice(N,1),z.unshift(x))}e.$Yb=J;function ce(z,x){const N=z.indexOf(x);N>-1&&(z.splice(N,1),z.push(x))}e.$Zb=ce;function re(z,x){for(const N of x)z.push(N)}e.$1b=re;function ue(z,x){return Array.isArray(z)?z.map(x):x(z)}e.$2b=ue;function Z(z){return Array.isArray(z)?z:[z]}e.$3b=Z;function Y(z){return z[Math.floor(Math.random()*z.length)]}e.$4b=Y;function V(z,x,N){const B=U(z,x),Q=z.length,se=N.length;z.length=Q+se;for(let le=Q-1;le>=B;le--)z[le+se]=z[le];for(let le=0;le<se;le++)z[le+B]=N[le]}e.$5b=V;function L(z,x,N,B){const Q=U(z,x);let se=z.splice(Q,N);return se===void 0&&(se=[]),V(z,Q,B),se}e.$6b=L;function U(z,x){return x<0?Math.max(x+z.length,0):Math.min(x,z.length)}var H;(function(z){function x(se){return se<0}z.isLessThan=x;function N(se){return se<=0}z.isLessThanOrEqual=N;function B(se){return se>0}z.isGreaterThan=B;function Q(se){return se===0}z.isNeitherLessOrGreaterThan=Q,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(H||(e.CompareResult=H={}));function q(z,x){return(N,B)=>x(z(N),z(B))}e.$7b=q;function ee(...z){return(x,N)=>{for(const B of z){const Q=B(x,N);if(!H.isNeitherLessOrGreaterThan(Q))return Q}return H.neitherLessOrGreaterThan}}e.$8b=ee;const he=(z,x)=>z-x;e.$9b=he;const K=(z,x)=>(0,e.$9b)(z?1:0,x?1:0);e.$0b=K;function O(z){return(x,N)=>-z(x,N)}e.$$b=O;class F{constructor(x){this.g=x,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(x){let N=this.c;for(;N<this.g.length&&x(this.g[N]);)N++;const B=N===this.c?null:this.g.slice(this.c,N);return this.c=N,B}takeFromEndWhile(x){let N=this.d;for(;N>=0&&x(this.g[N]);)N--;const B=N===this.d?null:this.g.slice(N+1,this.d+1);return this.d=N,B}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const x=this.g[this.c];return this.c++,x}removeLast(){const x=this.g[this.d];return this.d--,x}takeCount(x){const N=this.g.slice(this.c,this.c+x);return this.c+=x,N}}e.$_b=F;class _{static{this.empty=new _(x=>{})}constructor(x){this.iterate=x}forEach(x){this.iterate(N=>(x(N),!0))}toArray(){const x=[];return this.iterate(N=>(x.push(N),!0)),x}filter(x){return new _(N=>this.iterate(B=>x(B)?N(B):!0))}map(x){return new _(N=>this.iterate(B=>N(x(B))))}some(x){let N=!1;return this.iterate(B=>(N=x(B),!N)),N}findFirst(x){let N;return this.iterate(B=>x(B)?(N=B,!1):!0),N}findLast(x){let N;return this.iterate(B=>(x(B)&&(N=B),!0)),N}findLastMaxBy(x){let N,B=!0;return this.iterate(Q=>((B||H.isGreaterThan(x(Q,N)))&&(B=!1,N=Q),!0)),N}}e.$ac=_}),define(oe[138],ae([0,1,14]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function R(f,l){if(!f)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=R;function s(f,l="Unreachable"){throw new Error(l)}e.$6c=s;function j(f){if(!f)throw new P.$cb("Assertion Failed")}e.$7c=j;function D(f){if(!f()){debugger;f(),(0,P.$1)(new P.$cb("Assertion Failed"))}}e.$8c=D;function S(f,l){let p=0;for(;p<f.length-1;){const k=f[p],v=f[p+1];if(!l(k,v))return!1;p++}return!0}e.$9c=S}),define(oe[84],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function P(R,s){const j=this;let D=!1,S;return function(){if(D)return S;if(D=!0,s)try{S=R.apply(j,arguments)}finally{s()}else S=R.apply(j,arguments);return S}}e.$db=P}),define(oe[72],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var P;(function(R){function s(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}R.is=s;const j=Object.freeze([]);function D(){return j}R.empty=D;function*S(t){yield t}R.single=S;function f(t){return s(t)?t:S(t)}R.wrap=f;function l(t){return t||j}R.from=l;function*p(t){for(let o=t.length-1;o>=0;o--)yield t[o]}R.reverse=p;function k(t){return!t||t[Symbol.iterator]().next().done===!0}R.isEmpty=k;function v(t){return t[Symbol.iterator]().next().value}R.first=v;function u(t,o){for(const r of t)if(o(r))return!0;return!1}R.some=u;function y(t,o){for(const r of t)if(o(r))return r}R.find=y;function*w(t,o){for(const r of t)o(r)&&(yield r)}R.filter=w;function*g(t,o){let r=0;for(const i of t)yield o(i,r++)}R.map=g;function*$(...t){for(const o of t)yield*o}R.concat=$;function d(t,o,r){let i=r;for(const n of t)i=o(i,n);return i}R.reduce=d;function*h(t,o,r=t.length){for(o<0&&(o+=t.length),r<0?r+=t.length:r>t.length&&(r=t.length);o<r;o++)yield t[o]}R.slice=h;function m(t,o=Number.POSITIVE_INFINITY){const r=[];if(o===0)return[r,t];const i=t[Symbol.iterator]();for(let n=0;n<o;n++){const a=i.next();if(a.done)return[r,R.empty()];r.push(a.value)}return[r,{[Symbol.iterator](){return i}}]}R.consume=m;async function c(t){const o=[];for await(const r of t)o.push(r);return Promise.resolve(o)}R.asyncToArray=c})(P||(e.Iterable=P={}))}),define(oe[42],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var P;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(P||(e.ScanError=P={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var j;(function(t){t.DEFAULT={allowTrailingComma:!0}})(j||(e.ParseOptions=j={}));function D(t,o=!1){let r=0;const i=t.length;let n="",a=0,b=16,C=0;function I(J){let ce=0,re=0;for(;ce<J;){const ue=t.charCodeAt(r);if(ue>=48&&ue<=57)re=re*16+ue-48;else if(ue>=65&&ue<=70)re=re*16+ue-65+10;else if(ue>=97&&ue<=102)re=re*16+ue-97+10;else break;r++,ce++}return ce<J&&(re=-1),re}function E(J){r=J,n="",a=0,b=16,C=0}function A(){const J=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&l(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&l(t.charCodeAt(r)))for(r++;r<t.length&&l(t.charCodeAt(r));)r++;else return C=3,t.substring(J,r);let ce=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&l(t.charCodeAt(r))){for(r++;r<t.length&&l(t.charCodeAt(r));)r++;ce=r}else C=3;return t.substring(J,ce)}function M(){let J="",ce=r;for(;;){if(r>=i){J+=t.substring(ce,r),C=2;break}const re=t.charCodeAt(r);if(re===34){J+=t.substring(ce,r),r++;break}if(re===92){if(J+=t.substring(ce,r),r++,r>=i){C=2;break}switch(t.charCodeAt(r++)){case 34:J+='"';break;case 92:J+="\\";break;case 47:J+="/";break;case 98:J+="\b";break;case 102:J+="\f";break;case 110:J+=`
`;break;case 114:J+="\r";break;case 116:J+="	";break;case 117:{const Z=I(4);Z>=0?J+=String.fromCharCode(Z):C=4;break}default:C=5}ce=r;continue}if(re>=0&&re<=31)if(f(re)){J+=t.substring(ce,r),C=2;break}else C=6;r++}return J}function T(){if(n="",C=0,a=r,r>=i)return a=i,b=17;let J=t.charCodeAt(r);if(S(J)){do r++,n+=String.fromCharCode(J),J=t.charCodeAt(r);while(S(J));return b=15}if(f(J))return r++,n+=String.fromCharCode(J),J===13&&t.charCodeAt(r)===10&&(r++,n+=`
`),b=14;switch(J){case 123:return r++,b=1;case 125:return r++,b=2;case 91:return r++,b=3;case 93:return r++,b=4;case 58:return r++,b=6;case 44:return r++,b=5;case 34:return r++,n=M(),b=10;case 47:{const ce=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<i&&!f(t.charCodeAt(r));)r++;return n=t.substring(ce,r),b=12}if(t.charCodeAt(r+1)===42){r+=2;const re=i-1;let ue=!1;for(;r<re;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,ue=!0;break}r++}return ue||(r++,C=1),n=t.substring(ce,r),b=13}return n+=String.fromCharCode(J),r++,b=16}case 45:if(n+=String.fromCharCode(J),r++,r===i||!l(t.charCodeAt(r)))return b=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return n+=A(),b=11;default:for(;r<i&&W(J);)r++,J=t.charCodeAt(r);if(a!==r){switch(n=t.substring(a,r),n){case"true":return b=8;case"false":return b=9;case"null":return b=7}return b=16}return n+=String.fromCharCode(J),r++,b=16}}function W(J){if(S(J)||f(J))return!1;switch(J){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let J;do J=T();while(J>=12&&J<=15);return J}return{setPosition:E,getPosition:()=>r,scan:o?G:T,getToken:()=>b,getTokenValue:()=>n,getTokenOffset:()=>a,getTokenLength:()=>r-a,getTokenError:()=>C}}e.$an=D;function S(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function f(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function k(t,o){const r=[],i=new Object;let n;const a={value:{},offset:0,length:0,type:"object",parent:void 0};let b=!1;function C(I,E,A,M){a.value=I,a.offset=E,a.length=A,a.type=M,a.colonOffset=void 0,n=a}try{h(t,{onObjectBegin:(I,E)=>{if(o<=I)throw i;n=void 0,b=o>I,r.push("")},onObjectProperty:(I,E,A)=>{if(o<E||(C(I,E,A,"property"),r[r.length-1]=I,o<=E+A))throw i},onObjectEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onArrayBegin:(I,E)=>{if(o<=I)throw i;n=void 0,r.push(0)},onArrayEnd:(I,E)=>{if(o<=I)throw i;n=void 0,r.pop()},onLiteralValue:(I,E,A)=>{if(o<E||(C(I,E,A,c(I)),o<=E+A))throw i},onSeparator:(I,E,A)=>{if(o<=E)throw i;if(I===":"&&n&&n.type==="property")n.colonOffset=E,b=!1,n=void 0;else if(I===","){const M=r[r.length-1];typeof M=="number"?r[r.length-1]=M+1:(b=!0,r[r.length-1]=""),n=void 0}}})}catch(I){if(I!==i)throw I}return{path:r,previousNode:n,isAtPropertyKey:b,matches:I=>{let E=0;for(let A=0;E<I.length&&A<r.length;A++)if(I[E]===r[A]||I[E]==="*")E++;else if(I[E]!=="**")return!1;return E===I.length}}}e.$bn=k;function v(t,o=[],r=j.DEFAULT){let i=null,n=[];const a=[];function b(I){Array.isArray(n)?n.push(I):i!==null&&(n[i]=I)}return h(t,{onObjectBegin:()=>{const I={};b(I),a.push(n),n=I,i=null},onObjectProperty:I=>{i=I},onObjectEnd:()=>{n=a.pop()},onArrayBegin:()=>{const I=[];b(I),a.push(n),n=I,i=null},onArrayEnd:()=>{n=a.pop()},onLiteralValue:b,onError:(I,E,A)=>{o.push({error:I,offset:E,length:A})}},r),n[0]}e.$cn=v;function u(t,o=[],r=j.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function n(I){i.type==="property"&&(i.length=I-i.offset,i=i.parent)}function a(I){return i.children.push(I),I}h(t,{onObjectBegin:I=>{i=a({type:"object",offset:I,length:-1,parent:i,children:[]})},onObjectProperty:(I,E,A)=>{i=a({type:"property",offset:E,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:I,offset:E,length:A,parent:i})},onObjectEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onArrayBegin:(I,E)=>{i=a({type:"array",offset:I,length:-1,parent:i,children:[]})},onArrayEnd:(I,E)=>{i.length=I+E-i.offset,i=i.parent,n(I+E)},onLiteralValue:(I,E,A)=>{a({type:c(I),offset:E,length:A,parent:i,value:I}),n(E+A)},onSeparator:(I,E,A)=>{i.type==="property"&&(I===":"?i.colonOffset=E:I===","&&n(E))},onError:(I,E,A)=>{o.push({error:I,offset:E,length:A})}},r);const C=i.children[0];return C&&delete C.parent,C}e.$dn=u;function y(t,o){if(!t)return;let r=t;for(const i of o)if(typeof i=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let n=!1;for(const a of r.children)if(Array.isArray(a.children)&&a.children[0].value===i){r=a.children[1],n=!0;break}if(!n)return}else{const n=i;if(r.type!=="array"||n<0||!Array.isArray(r.children)||n>=r.children.length)return;r=r.children[n]}return r}e.$en=y;function w(t){if(!t.parent||!t.parent.children)return[];const o=w(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;o.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&o.push(r)}return o}e.$fn=w;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const o=Object.create(null);for(const r of t.children){const i=r.children[1];i&&(o[r.children[0].value]=g(i))}return o}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$gn=g;function $(t,o,r=!1){return o>=t.offset&&o<t.offset+t.length||r&&o===t.offset+t.length}e.$hn=$;function d(t,o,r=!1){if($(t,o,r)){const i=t.children;if(Array.isArray(i))for(let n=0;n<i.length&&i[n].offset<=o;n++){const a=d(i[n],o,r);if(a)return a}return t}}e.$in=d;function h(t,o,r=j.DEFAULT){const i=D(t,!1);function n(q){return q?()=>q(i.getTokenOffset(),i.getTokenLength()):()=>!0}function a(q){return q?ee=>q(ee,i.getTokenOffset(),i.getTokenLength()):()=>!0}const b=n(o.onObjectBegin),C=a(o.onObjectProperty),I=n(o.onObjectEnd),E=n(o.onArrayBegin),A=n(o.onArrayEnd),M=a(o.onLiteralValue),T=a(o.onSeparator),W=n(o.onComment),G=a(o.onError),J=r&&r.disallowComments,ce=r&&r.allowTrailingComma;function re(){for(;;){const q=i.scan();switch(i.getTokenError()){case 4:ue(14);break;case 5:ue(15);break;case 3:ue(13);break;case 1:J||ue(11);break;case 2:ue(12);break;case 6:ue(16);break}switch(q){case 12:case 13:J?ue(10):W();break;case 16:ue(1);break;case 15:case 14:break;default:return q}}}function ue(q,ee=[],he=[]){if(G(q),ee.length+he.length>0){let K=i.getToken();for(;K!==17;){if(ee.indexOf(K)!==-1){re();break}else if(he.indexOf(K)!==-1)break;K=re()}}}function Z(q){const ee=i.getTokenValue();return q?M(ee):C(ee),re(),!0}function Y(){switch(i.getToken()){case 11:{let q=0;try{q=JSON.parse(i.getTokenValue()),typeof q!="number"&&(ue(2),q=0)}catch{ue(2)}M(q);break}case 7:M(null);break;case 8:M(!0);break;case 9:M(!1);break;default:return!1}return re(),!0}function V(){return i.getToken()!==10?(ue(3,[],[2,5]),!1):(Z(!1),i.getToken()===6?(T(":"),re(),H()||ue(4,[],[2,5])):ue(5,[],[2,5]),!0)}function L(){b(),re();let q=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),T(","),re(),i.getToken()===2&&ce)break}else q&&ue(6,[],[]);V()||ue(4,[],[2,5]),q=!0}return I(),i.getToken()!==2?ue(7,[2],[]):re(),!0}function U(){E(),re();let q=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(q||ue(4,[],[]),T(","),re(),i.getToken()===4&&ce)break}else q&&ue(6,[],[]);H()||ue(4,[],[4,5]),q=!0}return A(),i.getToken()!==4?ue(8,[4],[]):re(),!0}function H(){switch(i.getToken()){case 3:return U();case 1:return L();case 10:return Z(!0);default:return Y()}}return re(),i.getToken()===17?r.allowEmptyContent?!0:(ue(4,[],[]),!1):H()?(i.getToken()!==17&&ue(9,[],[]),!0):(ue(4,[],[]),!1)}e.$jn=h;function m(t,o){const r=D(t),i=[];let n,a=0,b;do switch(b=r.getPosition(),n=r.scan(),n){case 12:case 13:case 17:a!==b&&i.push(t.substring(a,b)),o!==void 0&&i.push(r.getTokenValue().replace(/[^\r\n]/g,o)),a=r.getPosition();break}while(n!==17);return i.join("")}e.$kn=m;function c(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=c}),define(oe[139],ae([0,1,42]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=void 0;function R(l,p,k){let v,u,y,w,g;if(p){for(w=p.offset,g=w+p.length,y=w;y>0&&!f(l,y-1);)y--;let b=g;for(;b<l.length&&!f(l,b);)b++;u=l.substring(y,b),v=D(u,k)}else u=l,v=0,y=0,w=0,g=l.length;const $=S(k,l);let d=!1,h=0,m;k.insertSpaces?m=j(" ",k.tabSize||4):m="	";const c=(0,P.$an)(u,!1);let t=!1;function o(){return $+j(m,v+h)}function r(){let b=c.scan();for(d=!1;b===15||b===14;)d=d||b===14,b=c.scan();return t=b===16||c.getTokenError()!==0,b}const i=[];function n(b,C,I){!t&&C<g&&I>w&&l.substring(C,I)!==b&&i.push({offset:C,length:I-C,content:b})}let a=r();if(a!==17){const b=c.getTokenOffset()+y,C=j(m,v);n(C,y,b)}for(;a!==17;){let b=c.getTokenOffset()+c.getTokenLength()+y,C=r(),I="";for(;!d&&(C===12||C===13);){const A=c.getTokenOffset()+y;n(" ",b,A),b=c.getTokenOffset()+c.getTokenLength()+y,I=C===12?o():"",C=r()}if(C===2)a!==1&&(h--,I=o());else if(C===4)a!==3&&(h--,I=o());else{switch(a){case 3:case 1:h++,I=o();break;case 5:case 12:I=o();break;case 13:d?I=o():I=" ";break;case 6:I=" ";break;case 10:if(C===6){I="";break}case 7:case 8:case 9:case 11:case 2:case 4:C===12||C===13?I=" ":C!==5&&C!==17&&(t=!0);break;case 16:t=!0;break}d&&(C===12||C===13)&&(I=o())}const E=c.getTokenOffset()+y;n(I,b,E),a=C}return i}e.$mn=R;function s(l,p){const k=JSON.stringify(l,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?k.replace(/\r\n|\r|\n/g,p.eol):k}e.$nn=s;function j(l,p){let k="";for(let v=0;v<p;v++)k+=l;return k}function D(l,p){let k=0,v=0;const u=p.tabSize||4;for(;k<l.length;){const y=l.charAt(k);if(y===" ")v++;else if(y==="	")v+=u;else break;k++}return Math.floor(v/u)}function S(l,p){for(let k=0;k<p.length;k++){const v=p.charAt(k);if(v==="\r")return k+1<p.length&&p.charAt(k+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return l&&l.eol||`
`}e.$on=S;function f(l,p){return`\r
`.indexOf(l.charAt(p))!==-1}e.$pn=f}),define(oe[101],ae([0,1,42,139]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function s(l,p,k){return j(l,p,void 0,k)}e.$qn=s;function j(l,p,k,v,u){const y=p.slice(),w=[],g=(0,P.$dn)(l,w);let $,d;for(;y.length>0&&(d=y.pop(),$=(0,P.$en)(g,y),$===void 0&&k!==void 0);)typeof d=="string"?k={[d]:k}:k=[k];if($)if($.type==="object"&&typeof d=="string"&&Array.isArray($.children)){const h=(0,P.$en)($,[d]);if(h!==void 0)if(k===void 0){if(!h.parent)throw new Error("Malformed AST");const m=$.children.indexOf(h.parent);let c,t=h.parent.offset+h.parent.length;if(m>0){const o=$.children[m-1];c=o.offset+o.length}else c=$.offset+1,$.children.length>1&&(t=$.children[1].offset);return D(l,{offset:c,length:t-c,content:""},v)}else return D(l,{offset:h.offset,length:h.length,content:JSON.stringify(k)},v);else{if(k===void 0)return[];const m=`${JSON.stringify(d)}: ${JSON.stringify(k)}`,c=u?u($.children.map(o=>o.children[0].value)):$.children.length;let t;if(c>0){const o=$.children[c-1];t={offset:o.offset+o.length,length:0,content:","+m}}else $.children.length===0?t={offset:$.offset+1,length:0,content:m}:t={offset:$.offset+1,length:0,content:m+","};return D(l,t,v)}}else if($.type==="array"&&typeof d=="number"&&Array.isArray($.children))if(k!==void 0){const h=`${JSON.stringify(k)}`;let m;if($.children.length===0||d===0)m={offset:$.offset+1,length:0,content:$.children.length===0?h:h+","};else{const c=d===-1||d>$.children.length?$.children.length:d,t=$.children[c-1];m={offset:t.offset+t.length,length:0,content:","+h}}return D(l,m,v)}else{const h=d,m=$.children[h];let c;if($.children.length===1)c={offset:$.offset+1,length:$.length-2,content:""};else if($.children.length-1===h){const t=$.children[h-1],o=t.offset+t.length,r=$.offset+$.length;c={offset:o,length:r-2-o,content:""}}else c={offset:m.offset,length:$.children[h+1].offset-m.offset,content:""};return D(l,c,v)}else throw new Error(`Can not add ${typeof d!="number"?"index":"property"} to parent of type ${$.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return D(l,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(k)},v)}}e.$rn=j;function D(l,p,k){let v=S(l,p),u=p.offset,y=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;u>0&&!(0,R.$pn)(v,u-1);)u--;for(;y<v.length&&!(0,R.$pn)(v,y);)y++}const w=(0,R.$mn)(v,{offset:u,length:y-u},k);for(let $=w.length-1;$>=0;$--){const d=w[$];v=S(v,d),u=Math.min(u,d.offset),y=Math.max(y,d.offset+d.length),y+=d.content.length-d.length}const g=l.length-(v.length-y)-u;return[{offset:u,length:g,content:v.substring(u,y)}]}e.$sn=D;function S(l,p){return l.substring(0,p.offset)+p.content+l.substring(p.offset+p.length)}e.$tn=S;function f(l,p){const k=p.slice(0).sort((u,y)=>{const w=u.offset-y.offset;return w===0?u.length-y.length:w});let v=l.length;for(let u=k.length-1;u>=0;u--){const y=k[u];if(y.offset+y.length<=v)l=S(l,y);else throw new Error("Overlapping edit");v=y.offset}return l}e.$un=f}),define(oe[62],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class P{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=P}),define(oe[102],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class P{static{this.Undefined=new P(void 0)}constructor(j){this.element=j,this.next=P.Undefined,this.prev=P.Undefined}}class R{constructor(){this.a=P.Undefined,this.b=P.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===P.Undefined}clear(){let j=this.a;for(;j!==P.Undefined;){const D=j.next;j.prev=P.Undefined,j.next=P.Undefined,j=D}this.a=P.Undefined,this.b=P.Undefined,this.c=0}unshift(j){return this.d(j,!1)}push(j){return this.d(j,!0)}d(j,D){const S=new P(j);if(this.a===P.Undefined)this.a=S,this.b=S;else if(D){const l=this.b;this.b=S,S.prev=l,l.next=S}else{const l=this.a;this.a=S,S.next=l,l.prev=S}this.c+=1;let f=!1;return()=>{f||(f=!0,this.e(S))}}shift(){if(this.a!==P.Undefined){const j=this.a.element;return this.e(this.a),j}}pop(){if(this.b!==P.Undefined){const j=this.b.element;return this.e(this.b),j}}e(j){if(j.prev!==P.Undefined&&j.next!==P.Undefined){const D=j.prev;D.next=j.next,j.next.prev=D}else j.prev===P.Undefined&&j.next===P.Undefined?(this.a=P.Undefined,this.b=P.Undefined):j.next===P.Undefined?(this.b=this.b.prev,this.b.next=P.Undefined):j.prev===P.Undefined&&(this.a=this.a.next,this.a.prev=P.Undefined);this.c-=1}*[Symbol.iterator](){let j=this.a;for(;j!==P.Undefined;)yield j.element,j=j.next}}e.$4c=R}),define(oe[31],ae([0,1]),function(X,e){"use strict";var P,R,s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function j(h,m,c){let t=h.get(m);return t===void 0&&(t=c,h.set(m,t)),t}e.$xc=j;function D(h){const m=[];return h.forEach((c,t)=>{m.push(`${t} => ${c}`)}),`Map(${h.size}) {${m.join(", ")}}`}e.$yc=D;function S(h){const m=[];return h.forEach(c=>{m.push(c)}),`Set(${h.size}) {${m.join(", ")}}`}e.$zc=S;class f{constructor(m,c){this.uri=m,this.value=c}}function l(h){return Array.isArray(h)}class p{static{this.c=m=>m.toString()}constructor(m,c){if(this[P]="ResourceMap",m instanceof p)this.d=new Map(m.d),this.e=c??p.c;else if(l(m)){this.d=new Map,this.e=c??p.c;for(const[t,o]of m)this.set(t,o)}else this.d=new Map,this.e=m??p.c}set(m,c){return this.d.set(this.e(m),new f(m,c)),this}get(m){return this.d.get(this.e(m))?.value}has(m){return this.d.has(this.e(m))}get size(){return this.d.size}clear(){this.d.clear()}delete(m){return this.d.delete(this.e(m))}forEach(m,c){typeof c<"u"&&(m=m.bind(c));for(const[t,o]of this.d)m(o.value,o.uri,this)}*values(){for(const m of this.d.values())yield m.value}*keys(){for(const m of this.d.values())yield m.uri}*entries(){for(const m of this.d.values())yield[m.uri,m.value]}*[(P=Symbol.toStringTag,Symbol.iterator)](){for(const[,m]of this.d)yield[m.uri,m.value]}}e.$Ac=p;class k{constructor(m,c){this[R]="ResourceSet",!m||typeof m=="function"?this.c=new p(m):(this.c=new p(c),m.forEach(this.add,this))}get size(){return this.c.size}add(m){return this.c.set(m,m),this}clear(){this.c.clear()}delete(m){return this.c.delete(m)}forEach(m,c){this.c.forEach((t,o)=>m.call(c,o,o,this))}has(m){return this.c.has(m)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=k;var v;(function(h){h[h.None=0]="None",h[h.AsOld=1]="AsOld",h[h.AsNew=2]="AsNew"})(v||(e.Touch=v={}));class u{constructor(){this[s]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(m){return this.c.has(m)}get(m,c=0){const t=this.c.get(m);if(t)return c!==0&&this.l(t,c),t.value}set(m,c,t=0){let o=this.c.get(m);if(o)o.value=c,t!==0&&this.l(o,t);else{switch(o={key:m,value:c,next:void 0,previous:void 0},t){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(m,o),this.f++}return this}delete(m){return!!this.remove(m)}remove(m){const c=this.c.get(m);if(c)return this.c.delete(m),this.k(c),this.f--,c.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const m=this.d;return this.c.delete(m.key),this.k(m),this.f--,m.value}forEach(m,c){const t=this.g;let o=this.d;for(;o;){if(c?m.bind(c)(o.value,o.key,this):m(o.value,o.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const m=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(m.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.key,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}values(){const m=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(m.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:t.value,done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}entries(){const m=this,c=this.g;let t=this.d;const o={[Symbol.iterator](){return o},next(){if(m.g!==c)throw new Error("LinkedMap got modified during iteration.");if(t){const r={value:[t.key,t.value],done:!1};return t=t.next,r}else return{value:void 0,done:!0}}};return o}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(m){if(m>=this.size)return;if(m===0){this.clear();return}let c=this.d,t=this.size;for(;c&&t>m;)this.c.delete(c.key),c=c.next,t--;this.d=c,this.f=t,c&&(c.previous=void 0),this.g++}i(m){if(!this.d&&!this.e)this.e=m;else if(this.d)m.next=this.d,this.d.previous=m;else throw new Error("Invalid list");this.d=m,this.g++}j(m){if(!this.d&&!this.e)this.d=m;else if(this.e)m.previous=this.e,this.e.next=m;else throw new Error("Invalid list");this.e=m,this.g++}k(m){if(m===this.d&&m===this.e)this.d=void 0,this.e=void 0;else if(m===this.d){if(!m.next)throw new Error("Invalid list");m.next.previous=void 0,this.d=m.next}else if(m===this.e){if(!m.previous)throw new Error("Invalid list");m.previous.next=void 0,this.e=m.previous}else{const c=m.next,t=m.previous;if(!c||!t)throw new Error("Invalid list");c.previous=t,t.next=c}m.next=void 0,m.previous=void 0,this.g++}l(m,c){if(!this.d||!this.e)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(m===this.d)return;const t=m.next,o=m.previous;m===this.e?(o.next=void 0,this.e=o):(t.previous=o,o.next=t),m.previous=void 0,m.next=this.d,this.d.previous=m,this.d=m,this.g++}else if(c===2){if(m===this.e)return;const t=m.next,o=m.previous;m===this.d?(t.previous=void 0,this.d=t):(t.previous=o,o.next=t),m.next=void 0,m.previous=this.e,this.e.next=m,this.e=m,this.g++}}}toJSON(){const m=[];return this.forEach((c,t)=>{m.push([t,c])}),m}fromJSON(m){this.clear();for(const[c,t]of m)this.set(c,t)}}e.$Cc=u;class y extends u{constructor(m,c=1){super(),this.m=m,this.n=Math.min(Math.max(0,c),1)}get limit(){return this.m}set limit(m){this.m=m,this.o()}get ratio(){return this.n}set ratio(m){this.n=Math.min(Math.max(0,m),1),this.o()}get(m,c=2){return super.get(m,c)}peek(m){return super.get(m,0)}set(m,c){return super.set(m,c,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=y;class w{constructor(){this.c=new Map}add(m){return this.c.set(m,(this.c.get(m)||0)+1),this}delete(m){let c=this.c.get(m)||0;return c===0?!1:(c--,c===0?this.c.delete(m):this.c.set(m,c),!0)}has(m){return this.c.has(m)}}e.$Ec=w;class g{constructor(m){if(this.c=new Map,this.d=new Map,m)for(const[c,t]of m)this.set(c,t)}clear(){this.c.clear(),this.d.clear()}set(m,c){this.c.set(m,c),this.d.set(c,m)}get(m){return this.c.get(m)}getKey(m){return this.d.get(m)}delete(m){const c=this.c.get(m);return c===void 0?!1:(this.c.delete(m),this.d.delete(c),!0)}forEach(m,c){this.c.forEach((t,o)=>{m.call(c,t,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=g;class ${constructor(){this.c=new Map}add(m,c){let t=this.c.get(m);t||(t=new Set,this.c.set(m,t)),t.add(c)}delete(m,c){const t=this.c.get(m);t&&(t.delete(c),t.size===0&&this.c.delete(m))}forEach(m,c){const t=this.c.get(m);t&&t.forEach(c)}get(m){const c=this.c.get(m);return c||new Set}}e.$Gc=$;function d(h,m){if(h===m)return!0;if(h.size!==m.size)return!1;for(const[c,t]of h)if(!m.has(c)||m.get(c)!==t)return!1;for(const[c]of m)if(!h.has(c))return!1;return!0}e.$Hc=d}),define(oe[2],ae([0,1,22,136,31,84,72]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const S=!1;let f=null;class l{constructor(){this.b=new Map}static{this.a=0}c(M){let T=this.b.get(M);return T||(T={parent:null,source:null,isSingleton:!1,value:M,idx:l.a++},this.b.set(M,T)),T}trackDisposable(M){const T=this.c(M);T.source||(T.source=new Error().stack)}setParent(M,T){const W=this.c(M);W.parent=T}markAsDisposed(M){this.b.delete(M)}markAsSingleton(M){this.c(M).isSingleton=!0}f(M,T){const W=T.get(M);if(W)return W;const G=M.parent?this.f(this.c(M.parent),T):M;return T.set(M,G),G}getTrackedDisposables(){const M=new Map;return[...this.b.entries()].filter(([,W])=>W.source!==null&&!this.f(W,M).isSingleton).flatMap(([W])=>W)}computeLeakingDisposables(M=10,T){let W;if(T)W=T;else{const ue=new Map,Z=[...this.b.values()].filter(V=>V.source!==null&&!this.f(V,ue).isSingleton);if(Z.length===0)return;const Y=new Set(Z.map(V=>V.value));if(W=Z.filter(V=>!(V.parent&&Y.has(V.parent))),W.length===0)throw new Error("There are cyclic diposable chains!")}if(!W)return;function G(ue){function Z(V,L){for(;V.length>0&&L.some(U=>typeof U=="string"?U===V[0]:V[0].match(U));)V.shift()}const Y=ue.source.split(`
`).map(V=>V.trim().replace("at ","")).filter(V=>V!=="");return Z(Y,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Y.reverse()}const J=new s.$Gc;for(const ue of W){const Z=G(ue);for(let Y=0;Y<=Z.length;Y++)J.add(Z.slice(0,Y).join(`
`),ue)}W.sort((0,P.$7b)(ue=>ue.idx,P.$9b));let ce="",re=0;for(const ue of W.slice(0,M)){re++;const Z=G(ue),Y=[];for(let V=0;V<Z.length;V++){let L=Z[V];L=`(shared with ${J.get(Z.slice(0,V+1).join(`
`)).size}/${W.length} leaks) at ${L}`;const H=J.get(Z.slice(0,V).join(`
`)),q=(0,R.$K)([...H].map(ee=>G(ee)[V]),ee=>ee);delete q[Z[V]];for(const[ee,he]of Object.entries(q))Y.unshift(`    - stacktraces of ${he.length} other leaks continue with ${ee}`);Y.unshift(L)}ce+=`


==================== Leaking disposable ${re}/${W.length}: ${ue.value.constructor.name} ====================
${Y.join(`
`)}
============================================================

`}return W.length>M&&(ce+=`


... and ${W.length-M} more leaking disposables

`),{leaks:W,details:ce}}}e.$Ic=l;function p(A){f=A}if(e.$Jc=p,S){const A="__is_disposable_tracked__";p(new class{trackDisposable(M){const T=new Error("Potentially leaked disposable").stack;setTimeout(()=>{M[A]||console.log(T)},3e3)}setParent(M,T){if(M&&M!==t.None)try{M[A]=!0}catch{}}markAsDisposed(M){if(M&&M!==t.None)try{M[A]=!0}catch{}}markAsSingleton(M){}})}function k(A){return f?.trackDisposable(A),A}e.$Kc=k;function v(A){f?.markAsDisposed(A)}e.$Lc=v;function u(A,M){f?.setParent(A,M)}function y(A,M){if(f)for(const T of A)f.setParent(T,M)}function w(A){return f?.markAsSingleton(A),A}e.$Mc=w;function g(A){return typeof A.dispose=="function"&&A.dispose.length===0}e.$Nc=g;function $(A){if(D.Iterable.is(A)){const M=[];for(const T of A)if(T)try{T.dispose()}catch(W){M.push(W)}if(M.length===1)throw M[0];if(M.length>1)throw new AggregateError(M,"Encountered errors while disposing of store");return Array.isArray(A)?[]:A}else if(A)return A.dispose(),A}e.$Oc=$;function d(A){for(const M of A)g(M)&&M.dispose();return[]}e.$Pc=d;function h(...A){const M=m(()=>$(A));return y(A,M),M}e.$Qc=h;function m(A){const M=k({dispose:(0,j.$db)(()=>{v(M),A()})});return M}e.$Rc=m;class c{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(v(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{$(this.f)}finally{this.f.clear()}}add(M){if(!M)return M;if(M===this)throw new Error("Cannot register a disposable on itself!");return u(M,this),this.g?c.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(M),M}delete(M){if(M){if(M===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(M),M.dispose()}}deleteAndLeak(M){M&&this.f.has(M)&&(this.f.delete(M),u(M,null))}}e.$Sc=c;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new c,k(this),u(this.q,this)}dispose(){v(this),this.q.dispose()}B(M){if(M===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(M)}}e.$Tc=t;class o{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(M){this.b||M===this.a||(this.a?.dispose(),M&&u(M,this),this.a=M)}clear(){this.value=void 0}dispose(){this.b=!0,v(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const M=this.a;return this.a=void 0,M&&u(M,null),M}}e.$Uc=o;class r{constructor(M){this.a=new o,this.b=!1,this.a.value=M}get value(){return this.a.value}set value(M){this.b||M===this.a.value||(this.a.value=M)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=r;class i{constructor(M){this.b=M,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=i;class n{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(M){let T=M;return this.unset=()=>T=void 0,this.isset=()=>T!==void 0,this.dispose=()=>{T&&(T(),T=void 0,v(this))},this}}e.$Xc=n;class a{constructor(){this.a=new Map}acquire(M,...T){let W=this.a.get(M);W||(W={counter:0,object:this.b(M,...T)},this.a.set(M,W));const{object:G}=W,J=(0,j.$db)(()=>{--W.counter===0&&(this.c(M,W.object),this.a.delete(M))});return W.counter++,{object:G,dispose:J}}}e.$Yc=a;class b{constructor(M){this.a=M}async acquire(M,...T){const W=this.a.acquire(M,...T);try{return{object:await W.object,dispose:()=>W.dispose()}}catch(G){throw W.dispose(),G}}}e.$Zc=b;class C{constructor(M){this.object=M}dispose(){}}e.$1c=C;function I(A){const M=new c;try{A(M)}finally{M.dispose()}}e.$2c=I;class E{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){v(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{$(this.a.values())}finally{this.a.clear()}}has(M){return this.a.has(M)}get size(){return this.a.size}get(M){return this.a.get(M)}set(M,T,W=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),W||this.a.get(M)?.dispose(),this.a.set(M,T)}deleteAndDispose(M){this.a.get(M)?.dispose(),this.a.delete(M)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=E}),define(oe[85],ae([0,1,31]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=void 0;const R=new P.$Dc(1e4);function s(l){return f(l,"NFC",R)}e.$Gl=s;const j=new P.$Dc(1e4);function D(l){return f(l,"NFD",j)}e.$Hl=D;const S=/[^\u0000-\u0080]/;function f(l,p,k){if(!l)return l;const v=k.get(l);if(v)return v;let u;return S.test(l)?u=l.normalize(p):u=l,k.set(l,u),u}e.$Il=function(){const l=/[\u0300-\u036f]/g;return function(p){return D(p).replace(l,"")}}()}),define(oe[140],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function P(S,f,l){return Math.min(Math.max(S,f),l)}e.$7l=P;function R(S,f){return(f+S%f)%f}e.rot=R;class s{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=s;class j{constructor(){this.a=1,this.b=0}update(f){return this.b=this.b+(f-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=j;class D{constructor(f){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(f),this.c.fill(0,0,f)}update(f){const l=this.c[this.d];return this.c[this.d]=f,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=f,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=D}),function(){function X(s){const j=[];typeof s=="number"&&j.push("code/timeOrigin",s);function D(f){j.push(f,Date.now())}function S(){const f=[];for(let l=0;l<j.length;l+=2)f.push({name:j[l],startTime:j[l+1]});return f}return{mark:D,getMarks:S}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const j=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const D of performance.getEntriesByType("mark"))j.push({name:D.name,startTime:Math.round(s+D.startTime)});return j}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function P(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return P(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=P(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=P(R))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var P=e();for(var R in P)(typeof exports=="object"?exports:X)[R]=P[R]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function P(R){if(e[R])return e[R].exports;var s=e[R]={i:R,l:!1,exports:{}};return X[R].call(s.exports,s,s.exports,P),s.l=!0,s.exports}return P.m=X,P.c=e,P.d=function(R,s,j){P.o(R,s)||Object.defineProperty(R,s,{enumerable:!0,get:j})},P.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},P.t=function(R,s){if(1&s&&(R=P(R)),8&s||4&s&&typeof R=="object"&&R&&R.__esModule)return R;var j=Object.create(null);if(P.r(j),Object.defineProperty(j,"default",{enumerable:!0,value:R}),2&s&&typeof R!="string")for(var D in R)P.d(j,D,function(S){return R[S]}.bind(null,D));return j},P.n=function(R){var s=R&&R.__esModule?function(){return R.default}:function(){return R};return P.d(s,"a",s),s},P.o=function(R,s){return Object.prototype.hasOwnProperty.call(R,s)},P.p="",P(P.s=0)}([function(X,e,P){(function(R){var s;e=X.exports=he,s=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var j=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,S=e.re=[],f=e.src=[],l=0,p=l++;f[p]="0|[1-9]\\d*";var k=l++;f[k]="[0-9]+";var v=l++;f[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var u=l++;f[u]="("+f[p]+")\\.("+f[p]+")\\.("+f[p]+")";var y=l++;f[y]="("+f[k]+")\\.("+f[k]+")\\.("+f[k]+")";var w=l++;f[w]="(?:"+f[p]+"|"+f[v]+")";var g=l++;f[g]="(?:"+f[k]+"|"+f[v]+")";var $=l++;f[$]="(?:-("+f[w]+"(?:\\."+f[w]+")*))";var d=l++;f[d]="(?:-?("+f[g]+"(?:\\."+f[g]+")*))";var h=l++;f[h]="[0-9A-Za-z-]+";var m=l++;f[m]="(?:\\+("+f[h]+"(?:\\."+f[h]+")*))";var c=l++,t="v?"+f[u]+f[$]+"?"+f[m]+"?";f[c]="^"+t+"$";var o="[v=\\s]*"+f[y]+f[d]+"?"+f[m]+"?",r=l++;f[r]="^"+o+"$";var i=l++;f[i]="((?:<|>)?=?)";var n=l++;f[n]=f[k]+"|x|X|\\*";var a=l++;f[a]=f[p]+"|x|X|\\*";var b=l++;f[b]="[v=\\s]*("+f[a]+")(?:\\.("+f[a]+")(?:\\.("+f[a]+")(?:"+f[$]+")?"+f[m]+"?)?)?";var C=l++;f[C]="[v=\\s]*("+f[n]+")(?:\\.("+f[n]+")(?:\\.("+f[n]+")(?:"+f[d]+")?"+f[m]+"?)?)?";var I=l++;f[I]="^"+f[i]+"\\s*"+f[b]+"$";var E=l++;f[E]="^"+f[i]+"\\s*"+f[C]+"$";var A=l++;f[A]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var M=l++;f[M]="(?:~>?)";var T=l++;f[T]="(\\s*)"+f[M]+"\\s+",S[T]=new RegExp(f[T],"g");var W=l++;f[W]="^"+f[M]+f[b]+"$";var G=l++;f[G]="^"+f[M]+f[C]+"$";var J=l++;f[J]="(?:\\^)";var ce=l++;f[ce]="(\\s*)"+f[J]+"\\s+",S[ce]=new RegExp(f[ce],"g");var re=l++;f[re]="^"+f[J]+f[b]+"$";var ue=l++;f[ue]="^"+f[J]+f[C]+"$";var Z=l++;f[Z]="^"+f[i]+"\\s*("+o+")$|^$";var Y=l++;f[Y]="^"+f[i]+"\\s*("+t+")$|^$";var V=l++;f[V]="(\\s*)"+f[i]+"\\s*("+o+"|"+f[b]+")",S[V]=new RegExp(f[V],"g");var L=l++;f[L]="^\\s*("+f[b]+")\\s+-\\s+("+f[b]+")\\s*$";var U=l++;f[U]="^\\s*("+f[C]+")\\s+-\\s+("+f[C]+")\\s*$";var H=l++;f[H]="(<|>)?=?\\s*\\*";for(var q=0;q<35;q++)s(q,f[q]),S[q]||(S[q]=new RegExp(f[q]));function ee(te,fe){if(te instanceof he)return te;if(typeof te!="string"||te.length>j||!(fe?S[r]:S[c]).test(te))return null;try{return new he(te,fe)}catch{return null}}function he(te,fe){if(te instanceof he){if(te.loose===fe)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>j)throw new TypeError("version is longer than "+j+" characters");if(!(this instanceof he))return new he(te,fe);s("SemVer",te,fe),this.loose=fe;var $e=te.trim().match(fe?S[r]:S[c]);if(!$e)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+$e[1],this.minor=+$e[2],this.patch=+$e[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");$e[4]?this.prerelease=$e[4].split(".").map(function(Pe){if(/^[0-9]+$/.test(Pe)){var je=+Pe;if(je>=0&&je<D)return je}return Pe}):this.prerelease=[],this.build=$e[5]?$e[5].split("."):[],this.format()}e.parse=ee,e.valid=function(te,fe){var $e=ee(te,fe);return $e?$e.version:null},e.clean=function(te,fe){var $e=ee(te.trim().replace(/^[=v]+/,""),fe);return $e?$e.version:null},e.SemVer=he,he.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},he.prototype.toString=function(){return this.version},he.prototype.compare=function(te){return s("SemVer.compare",this.version,this.loose,te),te instanceof he||(te=new he(te,this.loose)),this.compareMain(te)||this.comparePre(te)},he.prototype.compareMain=function(te){return te instanceof he||(te=new he(te,this.loose)),O(this.major,te.major)||O(this.minor,te.minor)||O(this.patch,te.patch)},he.prototype.comparePre=function(te){if(te instanceof he||(te=new he(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var fe=0;do{var $e=this.prerelease[fe],Pe=te.prerelease[fe];if(s("prerelease compare",fe,$e,Pe),$e===void 0&&Pe===void 0)return 0;if(Pe===void 0)return 1;if($e===void 0)return-1;if($e!==Pe)return O($e,Pe)}while(++fe)},he.prototype.inc=function(te,fe){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var $e=this.prerelease.length;--$e>=0;)typeof this.prerelease[$e]=="number"&&(this.prerelease[$e]++,$e=-2);$e===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,fe,$e,Pe){typeof $e=="string"&&(Pe=$e,$e=void 0);try{return new he(te,$e).inc(fe,Pe).version}catch{return null}},e.diff=function(te,fe){if(x(te,fe))return null;var $e=ee(te),Pe=ee(fe);if($e.prerelease.length||Pe.prerelease.length){for(var je in $e)if((je==="major"||je==="minor"||je==="patch")&&$e[je]!==Pe[je])return"pre"+je;return"prerelease"}for(var je in $e)if((je==="major"||je==="minor"||je==="patch")&&$e[je]!==Pe[je])return je},e.compareIdentifiers=O;var K=/^[0-9]+$/;function O(te,fe){var $e=K.test(te),Pe=K.test(fe);return $e&&Pe&&(te=+te,fe=+fe),$e&&!Pe?-1:Pe&&!$e?1:te<fe?-1:te>fe?1:0}function F(te,fe,$e){return new he(te,$e).compare(new he(fe,$e))}function _(te,fe,$e){return F(te,fe,$e)>0}function z(te,fe,$e){return F(te,fe,$e)<0}function x(te,fe,$e){return F(te,fe,$e)===0}function N(te,fe,$e){return F(te,fe,$e)!==0}function B(te,fe,$e){return F(te,fe,$e)>=0}function Q(te,fe,$e){return F(te,fe,$e)<=0}function se(te,fe,$e,Pe){var je;switch(fe){case"===":typeof te=="object"&&(te=te.version),typeof $e=="object"&&($e=$e.version),je=te===$e;break;case"!==":typeof te=="object"&&(te=te.version),typeof $e=="object"&&($e=$e.version),je=te!==$e;break;case"":case"=":case"==":je=x(te,$e,Pe);break;case"!=":je=N(te,$e,Pe);break;case">":je=_(te,$e,Pe);break;case">=":je=B(te,$e,Pe);break;case"<":je=z(te,$e,Pe);break;case"<=":je=Q(te,$e,Pe);break;default:throw new TypeError("Invalid operator: "+fe)}return je}function le(te,fe){if(te instanceof le){if(te.loose===fe)return te;te=te.value}if(!(this instanceof le))return new le(te,fe);s("comparator",te,fe),this.loose=fe,this.parse(te),this.semver===ge?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(te,fe){return O(fe,te)},e.major=function(te,fe){return new he(te,fe).major},e.minor=function(te,fe){return new he(te,fe).minor},e.patch=function(te,fe){return new he(te,fe).patch},e.compare=F,e.compareLoose=function(te,fe){return F(te,fe,!0)},e.rcompare=function(te,fe,$e){return F(fe,te,$e)},e.sort=function(te,fe){return te.sort(function($e,Pe){return e.compare($e,Pe,fe)})},e.rsort=function(te,fe){return te.sort(function($e,Pe){return e.rcompare($e,Pe,fe)})},e.gt=_,e.lt=z,e.eq=x,e.neq=N,e.gte=B,e.lte=Q,e.cmp=se,e.Comparator=le;var ge={};function be(te,fe){if(te instanceof be)return te.loose===fe?te:new be(te.raw,fe);if(te instanceof le)return new be(te.value,fe);if(!(this instanceof be))return new be(te,fe);if(this.loose=fe,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function($e){return this.parseRange($e.trim())},this).filter(function($e){return $e.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function Se(te){return!te||te.toLowerCase()==="x"||te==="*"}function Ae(te,fe,$e,Pe,je,Te,Me,Je,Be,Ve,He,ie,de){return((fe=Se($e)?"":Se(Pe)?">="+$e+".0.0":Se(je)?">="+$e+"."+Pe+".0":">="+fe)+" "+(Je=Se(Be)?"":Se(Ve)?"<"+(+Be+1)+".0.0":Se(He)?"<"+Be+"."+(+Ve+1)+".0":ie?"<="+Be+"."+Ve+"."+He+"-"+ie:"<="+Je)).trim()}function Le(te,fe){for(var $e=0;$e<te.length;$e++)if(!te[$e].test(fe))return!1;if(fe.prerelease.length){for($e=0;$e<te.length;$e++)if(s(te[$e].semver),te[$e].semver!==ge&&te[$e].semver.prerelease.length>0){var Pe=te[$e].semver;if(Pe.major===fe.major&&Pe.minor===fe.minor&&Pe.patch===fe.patch)return!0}return!1}return!0}function ke(te,fe,$e){try{fe=new be(fe,$e)}catch{return!1}return fe.test(te)}function pe(te,fe,$e,Pe){var je,Te,Me,Je,Be;switch(te=new he(te,Pe),fe=new be(fe,Pe),$e){case">":je=_,Te=Q,Me=z,Je=">",Be=">=";break;case"<":je=z,Te=B,Me=_,Je="<",Be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(te,fe,Pe))return!1;for(var Ve=0;Ve<fe.set.length;++Ve){var He=fe.set[Ve],ie=null,de=null;if(He.forEach(function(we){we.semver===ge&&(we=new le(">=0.0.0")),ie=ie||we,de=de||we,je(we.semver,ie.semver,Pe)?ie=we:Me(we.semver,de.semver,Pe)&&(de=we)}),ie.operator===Je||ie.operator===Be||(!de.operator||de.operator===Je)&&Te(te,de.semver)||de.operator===Be&&Me(te,de.semver))return!1}return!0}le.prototype.parse=function(te){var fe=this.loose?S[Z]:S[Y],$e=te.match(fe);if(!$e)throw new TypeError("Invalid comparator: "+te);this.operator=$e[1],this.operator==="="&&(this.operator=""),$e[2]?this.semver=new he($e[2],this.loose):this.semver=ge},le.prototype.toString=function(){return this.value},le.prototype.test=function(te){return s("Comparator.test",te,this.loose),this.semver===ge||(typeof te=="string"&&(te=new he(te,this.loose)),se(te,this.operator,this.semver,this.loose))},le.prototype.intersects=function(te,fe){if(!(te instanceof le))throw new TypeError("a Comparator is required");var $e;if(this.operator==="")return $e=new be(te.value,fe),ke(this.value,$e,fe);if(te.operator==="")return $e=new be(this.value,fe),ke(te.semver,$e,fe);var Pe=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),Te=this.semver.version===te.semver.version,Me=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),Je=se(this.semver,"<",te.semver,fe)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),Be=se(this.semver,">",te.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return Pe||je||Te&&Me||Je||Be},e.Range=be,be.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},be.prototype.toString=function(){return this.range},be.prototype.parseRange=function(te){var fe=this.loose;te=te.trim(),s("range",te,fe);var $e=fe?S[U]:S[L];te=te.replace($e,Ae),s("hyphen replace",te),te=te.replace(S[V],"$1$2$3"),s("comparator trim",te,S[V]),te=(te=(te=te.replace(S[T],"$1~")).replace(S[ce],"$1^")).split(/\s+/).join(" ");var Pe=fe?S[Z]:S[Y],je=te.split(" ").map(function(Te){return function(Me,Je){return s("comp",Me),Me=function(Be,Ve){return Be.trim().split(/\s+/).map(function(He){return function(ie,de){s("caret",ie,de);var we=de?S[ue]:S[re];return ie.replace(we,function(Ee,ye,Re,We,qe){var Qe;return s("caret",ie,Ee,ye,Re,We,qe),Se(ye)?Qe="":Se(Re)?Qe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(We)?Qe=ye==="0"?">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+".0 <"+(+ye+1)+".0.0":qe?(s("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Qe=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+We+qe+" <"+ye+"."+Re+"."+(+We+1):">="+ye+"."+Re+"."+We+qe+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+We+qe+" <"+(+ye+1)+".0.0"):(s("no pr"),Qe=ye==="0"?Re==="0"?">="+ye+"."+Re+"."+We+" <"+ye+"."+Re+"."+(+We+1):">="+ye+"."+Re+"."+We+" <"+ye+"."+(+Re+1)+".0":">="+ye+"."+Re+"."+We+" <"+(+ye+1)+".0.0"),s("caret return",Qe),Qe})}(He,Ve)}).join(" ")}(Me,Je),s("caret",Me),Me=function(Be,Ve){return Be.trim().split(/\s+/).map(function(He){return function(ie,de){var we=de?S[G]:S[W];return ie.replace(we,function(Ee,ye,Re,We,qe){var Qe;return s("tilde",ie,Ee,ye,Re,We,qe),Se(ye)?Qe="":Se(Re)?Qe=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(We)?Qe=">="+ye+"."+Re+".0 <"+ye+"."+(+Re+1)+".0":qe?(s("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Qe=">="+ye+"."+Re+"."+We+qe+" <"+ye+"."+(+Re+1)+".0"):Qe=">="+ye+"."+Re+"."+We+" <"+ye+"."+(+Re+1)+".0",s("tilde return",Qe),Qe})}(He,Ve)}).join(" ")}(Me,Je),s("tildes",Me),Me=function(Be,Ve){return s("replaceXRanges",Be,Ve),Be.split(/\s+/).map(function(He){return function(ie,de){ie=ie.trim();var we=de?S[E]:S[I];return ie.replace(we,function(Ee,ye,Re,We,qe,Qe){s("xRange",ie,Ee,ye,Re,We,qe,Qe);var xe=Se(Re),Xe=xe||Se(We),Ze=Xe||Se(qe);return ye==="="&&Ze&&(ye=""),xe?Ee=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ze?(Xe&&(We=0),Ze&&(qe=0),ye===">"?(ye=">=",Xe?(Re=+Re+1,We=0,qe=0):Ze&&(We=+We+1,qe=0)):ye==="<="&&(ye="<",Xe?Re=+Re+1:We=+We+1),Ee=ye+Re+"."+We+"."+qe):Xe?Ee=">="+Re+".0.0 <"+(+Re+1)+".0.0":Ze&&(Ee=">="+Re+"."+We+".0 <"+Re+"."+(+We+1)+".0"),s("xRange return",Ee),Ee})}(He,Ve)}).join(" ")}(Me,Je),s("xrange",Me),Me=function(Be,Ve){return s("replaceStars",Be,Ve),Be.trim().replace(S[H],"")}(Me,Je),s("stars",Me),Me}(Te,fe)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(Te){return!!Te.match(Pe)})),je=je.map(function(Te){return new le(Te,fe)})},be.prototype.intersects=function(te,fe){if(!(te instanceof be))throw new TypeError("a Range is required");return this.set.some(function($e){return $e.every(function(Pe){return te.set.some(function(je){return je.every(function(Te){return Pe.intersects(Te,fe)})})})})},e.toComparators=function(te,fe){return new be(te,fe).set.map(function($e){return $e.map(function(Pe){return Pe.value}).join(" ").trim().split(" ")})},be.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new he(te,this.loose));for(var fe=0;fe<this.set.length;fe++)if(Le(this.set[fe],te))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(te,fe,$e){var Pe=null,je=null;try{var Te=new be(fe,$e)}catch{return null}return te.forEach(function(Me){Te.test(Me)&&(Pe&&je.compare(Me)!==-1||(je=new he(Pe=Me,$e)))}),Pe},e.minSatisfying=function(te,fe,$e){var Pe=null,je=null;try{var Te=new be(fe,$e)}catch{return null}return te.forEach(function(Me){Te.test(Me)&&(Pe&&je.compare(Me)!==1||(je=new he(Pe=Me,$e)))}),Pe},e.validRange=function(te,fe){try{return new be(te,fe).range||"*"}catch{return null}},e.ltr=function(te,fe,$e){return pe(te,fe,"<",$e)},e.gtr=function(te,fe,$e){return pe(te,fe,">",$e)},e.outside=pe,e.prerelease=function(te,fe){var $e=ee(te,fe);return $e&&$e.prerelease.length?$e.prerelease:null},e.intersects=function(te,fe,$e){return te=new be(te,$e),fe=new be(fe,$e),te.intersects(fe)},e.coerce=function(te){if(te instanceof he)return te;if(typeof te!="string")return null;var fe=te.match(S[A]);return fe==null?null:ee((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,P(1))},function(X,e){var P,R,s=X.exports={};function j(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function S(g){if(P===setTimeout)return setTimeout(g,0);if((P===j||!P)&&setTimeout)return P=setTimeout,setTimeout(g,0);try{return P(g,0)}catch{try{return P.call(null,g,0)}catch{return P.call(this,g,0)}}}(function(){try{P=typeof setTimeout=="function"?setTimeout:j}catch{P=j}try{R=typeof clearTimeout=="function"?clearTimeout:D}catch{R=D}})();var f,l=[],p=!1,k=-1;function v(){p&&f&&(p=!1,f.length?l=f.concat(l):k=-1,l.length&&u())}function u(){if(!p){var g=S(v);p=!0;for(var $=l.length;$;){for(f=l,l=[];++k<$;)f&&f[k].run();k=-1,$=l.length}f=null,p=!1,function(d){if(R===clearTimeout)return clearTimeout(d);if((R===D||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(d);try{R(d)}catch{try{return R.call(null,d)}catch{return R.call(this,d)}}}(g)}}function y(g,$){this.fun=g,this.array=$}function w(){}s.nextTick=function(g){var $=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)$[d-1]=arguments[d];l.push(new y(g,$)),l.length!==1||p||S(u)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function(g){return[]},s.binding=function(g){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(g){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(oe[141],ae([0,1]),function(X,e){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0;class R{constructor(S,f,l){this.level=S,this.key=f,this.value=l,this.forward=[]}}const s=void 0;class j{constructor(S,f=2**16){this.comparator=S,this[P]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(f)|0),this.e=new R(this.c,s,s)}get size(){return this.f}clear(){this.e=new R(this.c,s,s),this.f=0}has(S){return!!j.g(this,S,this.comparator)}get(S){return j.g(this,S,this.comparator)?.value}set(S,f){return j.h(this,S,f,this.comparator)&&(this.f+=1),this}delete(S){const f=j.k(this,S,this.comparator);return f&&(this.f-=1),f}forEach(S,f){let l=this.e.forward[0];for(;l;)S.call(f,l.value,l.key,this),l=l.forward[0]}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let S=this.e.forward[0];for(;S;)yield[S.key,S.value],S=S.forward[0]}*keys(){let S=this.e.forward[0];for(;S;)yield S.key,S=S.forward[0]}*values(){let S=this.e.forward[0];for(;S;)yield S.value,S=S.forward[0]}toString(){let S="[SkipList]:",f=this.e.forward[0];for(;f;)S+=`node(${f.key}, ${f.value}, lvl:${f.level})`,f=f.forward[0];return S}static g(S,f,l){let p=S.e;for(let k=S.d-1;k>=0;k--)for(;p.forward[k]&&l(p.forward[k].key,f)<0;)p=p.forward[k];if(p=p.forward[0],p&&l(p.key,f)===0)return p}static h(S,f,l,p){const k=[];let v=S.e;for(let u=S.d-1;u>=0;u--){for(;v.forward[u]&&p(v.forward[u].key,f)<0;)v=v.forward[u];k[u]=v}if(v=v.forward[0],v&&p(v.key,f)===0)return v.value=l,!1;{const u=j.j(S);if(u>S.d){for(let y=S.d;y<u;y++)k[y]=S.e;S.d=u}v=new R(u,f,l);for(let y=0;y<u;y++)v.forward[y]=k[y].forward[y],k[y].forward[y]=v;return!0}}static j(S,f=.5){let l=1;for(;Math.random()<f&&l<S.c;)l+=1;return l}static k(S,f,l){const p=[];let k=S.e;for(let v=S.d-1;v>=0;v--){for(;k.forward[v]&&l(k.forward[v].key,f)<0;)k=k.forward[v];p[v]=k}if(k=k.forward[0],!k||l(k.key,f)!==0)return!1;for(let v=0;v<S.d&&p[v].forward[v]===k;v++)p[v].forward[v]=k.forward[v];for(;S.d>0&&S.e.forward[S.d-1]===s;)S.d-=1;return!0}}e.$1r=j}),define(oe[73],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0;const P=globalThis.performance&&typeof globalThis.performance.now=="function";class R{static create(j){return new R(j)}constructor(j){this.c=P&&j===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Rd=R}),define(oe[3],ae([0,1,14,84,2,102,73]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.Event=void 0;const S=!1,f=!1;var l;(function(I){I.None=()=>s.$Tc.None;function E(Q){if(f){const{onDidAddListener:se}=Q,le=y.create();let ge=0;Q.onDidAddListener=()=>{++ge===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),se?.()}}}function A(Q,se){return Y(Q,()=>{},0,void 0,!0,void 0,se)}I.defer=A;function M(Q){return(se,le=null,ge)=>{let be=!1,Se;return Se=Q(Ae=>{if(!be)return Se?Se.dispose():be=!0,se.call(le,Ae)},null,ge),be&&Se.dispose(),Se}}I.once=M;function T(Q,se,le){return ue((ge,be=null,Se)=>Q(Ae=>ge.call(be,se(Ae)),null,Se),le)}I.map=T;function W(Q,se,le){return ue((ge,be=null,Se)=>Q(Ae=>{se(Ae),ge.call(be,Ae)},null,Se),le)}I.forEach=W;function G(Q,se,le){return ue((ge,be=null,Se)=>Q(Ae=>se(Ae)&&ge.call(be,Ae),null,Se),le)}I.filter=G;function J(Q){return Q}I.signal=J;function ce(...Q){return(se,le=null,ge)=>{const be=(0,s.$Qc)(...Q.map(Se=>Se(Ae=>se.call(le,Ae))));return Z(be,ge)}}I.any=ce;function re(Q,se,le,ge){let be=le;return T(Q,Se=>(be=se(be,Se),be),ge)}I.reduce=re;function ue(Q,se){let le;const ge={onWillAddFirstListener(){le=Q(be.fire,be)},onDidRemoveLastListener(){le?.dispose()}};se||E(ge);const be=new h(ge);return se?.add(be),be.event}function Z(Q,se){return se instanceof Array?se.push(Q):se&&se.add(Q),Q}function Y(Q,se,le=100,ge=!1,be=!1,Se,Ae){let Le,ke,pe,te=0,fe;const $e={leakWarningThreshold:Se,onWillAddFirstListener(){Le=Q(je=>{te++,ke=se(ke,je),ge&&!pe&&(Pe.fire(ke),ke=void 0),fe=()=>{const Te=ke;ke=void 0,pe=void 0,(!ge||te>1)&&Pe.fire(Te),te=0},typeof le=="number"?(clearTimeout(pe),pe=setTimeout(fe,le)):pe===void 0&&(pe=0,queueMicrotask(fe))})},onWillRemoveListener(){be&&te>0&&fe?.()},onDidRemoveLastListener(){fe=void 0,Le.dispose()}};Ae||E($e);const Pe=new h($e);return Ae?.add(Pe),Pe.event}I.debounce=Y;function V(Q,se=0,le){return I.debounce(Q,(ge,be)=>ge?(ge.push(be),ge):[be],se,void 0,!0,void 0,le)}I.accumulate=V;function L(Q,se=(ge,be)=>ge===be,le){let ge=!0,be;return G(Q,Se=>{const Ae=ge||!se(Se,be);return ge=!1,be=Se,Ae},le)}I.latch=L;function U(Q,se,le){return[I.filter(Q,se,le),I.filter(Q,ge=>!se(ge),le)]}I.split=U;function H(Q,se=!1,le=[],ge){let be=le.slice(),Se=Q(ke=>{be?be.push(ke):Le.fire(ke)});ge&&ge.add(Se);const Ae=()=>{be?.forEach(ke=>Le.fire(ke)),be=null},Le=new h({onWillAddFirstListener(){Se||(Se=Q(ke=>Le.fire(ke)),ge&&ge.add(Se))},onDidAddFirstListener(){be&&(se?setTimeout(Ae):Ae())},onDidRemoveLastListener(){Se&&Se.dispose(),Se=null}});return ge&&ge.add(Le),Le.event}I.buffer=H;function q(Q,se){return(ge,be,Se)=>{const Ae=se(new he);return Q(function(Le){const ke=Ae.evaluate(Le);ke!==ee&&ge.call(be,ke)},void 0,Se)}}I.chain=q;const ee=Symbol("HaltChainable");class he{constructor(){this.f=[]}map(se){return this.f.push(se),this}forEach(se){return this.f.push(le=>(se(le),le)),this}filter(se){return this.f.push(le=>se(le)?le:ee),this}reduce(se,le){let ge=le;return this.f.push(be=>(ge=se(ge,be),ge)),this}latch(se=(le,ge)=>le===ge){let le=!0,ge;return this.f.push(be=>{const Se=le||!se(be,ge);return le=!1,ge=be,Se?be:ee}),this}evaluate(se){for(const le of this.f)if(se=le(se),se===ee)break;return se}}function K(Q,se,le=ge=>ge){const ge=(...Le)=>Ae.fire(le(...Le)),be=()=>Q.on(se,ge),Se=()=>Q.removeListener(se,ge),Ae=new h({onWillAddFirstListener:be,onDidRemoveLastListener:Se});return Ae.event}I.fromNodeEventEmitter=K;function O(Q,se,le=ge=>ge){const ge=(...Le)=>Ae.fire(le(...Le)),be=()=>Q.addEventListener(se,ge),Se=()=>Q.removeEventListener(se,ge),Ae=new h({onWillAddFirstListener:be,onDidRemoveLastListener:Se});return Ae.event}I.fromDOMEventEmitter=O;function F(Q){return new Promise(se=>M(Q)(se))}I.toPromise=F;function _(Q){const se=new h;return Q.then(le=>{se.fire(le)},()=>{se.fire(void 0)}).finally(()=>{se.dispose()}),se.event}I.fromPromise=_;function z(Q,se,le){return se(le),Q(ge=>se(ge))}I.runAndSubscribe=z;class x{constructor(se,le){this._observable=se,this.f=0,this.g=!1;const ge={onWillAddFirstListener:()=>{se.addObserver(this)},onDidRemoveLastListener:()=>{se.removeObserver(this)}};le||E(ge),this.emitter=new h(ge),le&&le.add(this.emitter)}beginUpdate(se){this.f++}handlePossibleChange(se){}handleChange(se,le){this.g=!0}endUpdate(se){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function N(Q,se){return new x(Q,se).emitter.event}I.fromObservable=N;function B(Q){return(se,le,ge)=>{let be=0,Se=!1;const Ae={beginUpdate(){be++},endUpdate(){be--,be===0&&(Q.reportChanges(),Se&&(Se=!1,se.call(le)))},handlePossibleChange(){},handleChange(){Se=!0}};Q.addObserver(Ae),Q.reportChanges();const Le={dispose(){Q.removeObserver(Ae)}};return ge instanceof s.$Sc?ge.add(Le):Array.isArray(ge)&&ge.push(Le),Le}}I.fromObservableLight=B})(l||(e.Event=l={}));class p{static{this.all=new Set}static{this.f=0}constructor(E){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${E}_${p.f++}`,p.all.add(this)}start(E){this.g=new D.$Rd,this.listenerCount=E}stop(){if(this.g){const E=this.g.elapsed();this.durations.push(E),this.elapsedOverall+=E,this.invocationCount+=1,this.g=void 0}}}e.$Td=p;let k=-1;function v(I){const E=k;return k=I,{dispose(){k=E}}}e.$Ud=v;class u{constructor(E,A=Math.random().toString(18).slice(2,5)){this.threshold=E,this.name=A,this.g=0}dispose(){this.f?.clear()}check(E,A){const M=this.threshold;if(M<=0||A<M)return;this.f||(this.f=new Map);const T=this.f.get(E.value)||0;if(this.f.set(E.value,T+1),this.g-=1,this.g<=0){this.g=M*.5;let W,G=0;for(const[J,ce]of this.f)(!W||G<ce)&&(W=J,G=ce);console.warn(`[${this.name}] potential listener LEAK detected, having ${A} listeners already. MOST frequent listener (${G}):`),console.warn(W)}return()=>{const W=this.f.get(E.value)||0;this.f.set(E.value,W-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(E){this.value=E}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let w=0;class g{constructor(E){this.value=E,this.id=w++}}const $=2,d=(I,E)=>{if(I instanceof g)E(I);else for(let A=0;A<I.length;A++){const M=I[A];M&&E(M)}};class h{constructor(E){this.w=0,this.f=E,this.g=k>0||this.f?.leakWarningThreshold?new u(this.f?.leakWarningThreshold??k):void 0,this.j=this.f?._profName?new p(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(S){const E=this.t;queueMicrotask(()=>{d(E,A=>A.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(E,A,M)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.$Tc.None;if(this.m)return s.$Tc.None;A&&(E=E.bind(A));const T=new g(E);let W,G;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(T.stack=y.create(),W=this.g.check(T.stack,this.w+1)),S&&(T.stack=G??y.create()),this.t?this.t instanceof g?(this.u??=new c,this.t=[this.t,T]):this.t.push(T):(this.f?.onWillAddFirstListener?.(this),this.t=T,this.f?.onDidAddFirstListener?.(this)),this.w++;const J=(0,s.$Rc)(()=>{W?.(),this.x(T)});return M instanceof s.$Sc?M.add(J):Array.isArray(M)&&M.push(J),J},this.q}x(E){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const A=this.t,M=A.indexOf(E);if(M===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,A[M]=void 0;const T=this.u.current===this;if(this.w*$<=A.length){let W=0;for(let G=0;G<A.length;G++)A[G]?A[W++]=A[G]:T&&(this.u.end--,W<this.u.i&&this.u.i--);A.length=W}}y(E,A){if(!E)return;const M=this.f?.onListenerError||P.$1;if(!M){E.value(A);return}try{E.value(A)}catch(T){M(T)}}z(E){const A=E.current.t;for(;E.i<E.end;)this.y(A[E.i++],E.value);E.reset()}fire(E){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,E);else{const A=this.u;A.enqueue(this,E,this.t.length),this.z(A)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Vd=h;const m=()=>new c;e.$Wd=m;class c{constructor(){this.i=-1,this.end=0}enqueue(E,A,M){this.i=0,this.end=M,this.current=E,this.value=A}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends h{async fireAsync(E,A,M){if(this.t)for(this.h||(this.h=new j.$4c),d(this.t,T=>this.h.push([T.value,E]));this.h.size>0&&!A.isCancellationRequested;){const[T,W]=this.h.shift(),G=[],J={...W,token:A,waitUntil:ce=>{if(Object.isFrozen(G))throw new Error("waitUntil can NOT be called asynchronous");M&&(ce=M(ce,T)),G.push(ce)}};try{T(J)}catch(ce){(0,P.$1)(ce);continue}Object.freeze(G),await Promise.allSettled(G).then(ce=>{for(const re of ce)re.status==="rejected"&&(0,P.$1)(re.reason)})}}}e.$Xd=t;class o extends h{get isPaused(){return this.h!==0}constructor(E){super(E),this.h=0,this.s=new j.$4c,this.A=E?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const E=Array.from(this.s);this.s.clear(),super.fire(this.A(E))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(E){this.w&&(this.h!==0?this.s.push(E):super.fire(E))}}e.$Yd=o;class r extends o{constructor(E){super(E),this.k=E.delay??100}fire(E){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(E)}}e.$Zd=r;class i extends h{constructor(E){super(E),this.h=[],this.k=E?.merge}fire(E){this.hasListeners()&&(this.h.push(E),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(A=>super.fire(A)),this.h=[]}))}}e.$1d=i;class n{constructor(){this.g=!1,this.h=[],this.f=new h({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(E){const A={event:E,listener:null};this.h.push(A),this.g&&this.m(A);const M=()=>{this.g&&this.o(A);const T=this.h.indexOf(A);this.h.splice(T,1)};return(0,s.$Rc)((0,R.$db)(M))}j(){this.g=!0,this.h.forEach(E=>this.m(E))}k(){this.g=!1,this.h.forEach(E=>this.o(E))}m(E){E.listener=E.event(A=>this.f.fire(A))}o(E){E.listener&&E.listener.dispose(),E.listener=null}dispose(){this.f.dispose()}}e.$2d=n;class a{constructor(E,A,M,T){this.f=new s.$Sc;const W=this.f.add(new n),G=this.f.add(new s.$3c);function J(ce){G.set(ce,W.add(T(ce)))}for(const ce of E)J(ce);this.f.add(A(ce=>{J(ce)})),this.f.add(M(ce=>{G.deleteAndDispose(ce)})),this.event=W.event}dispose(){this.f.dispose()}}e.$3d=a;class b{constructor(){this.f=[]}wrapEvent(E){return(A,M,T)=>E(W=>{const G=this.f[this.f.length-1];G?G.push(()=>A.call(M,W)):A.call(M,W)},void 0,T)}bufferEvents(E){const A=[];this.f.push(A);const M=E();return this.f.pop(),A.forEach(T=>T()),M}}e.$4d=b;class C{constructor(){this.f=!1,this.g=l.None,this.h=s.$Tc.None,this.j=new h({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(E){this.g=E,this.f&&(this.h.dispose(),this.h=E(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$5d=C}),define(oe[23],ae([0,1,3]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.CancellationToken=void 0;const R=Object.freeze(function(S,f){const l=setTimeout(S.bind(f),0);return{dispose(){clearTimeout(l)}}});var s;(function(S){function f(l){return l===S.None||l===S.Cancelled||l instanceof j?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}S.isCancellationToken=f,S.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:P.Event.None}),S.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(s||(e.CancellationToken=s={}));class j{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new P.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class D{constructor(f){this.f=void 0,this.g=void 0,this.g=f&&f.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new j),this.f}cancel(){this.f?this.f instanceof j&&this.f.cancel():this.f=s.Cancelled}dispose(f=!1){f&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof j&&this.f.dispose():this.f=s.None}}e.$6d=D}),define(oe[142],ae([0,1,23]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=void 0;class R{constructor(S){this.b=S,this.a=null}get(){if(this.a)return this.a;const S=new P.$6d,f=this.b(S.token);return this.a={promise:f,dispose:()=>{this.a=null,S.cancel(),S.dispose()}},this.a}}e.$Ee=R;class s{constructor(S){this.c=S,this.a=void 0,this.b=void 0}get(S){const f=JSON.stringify(S);return this.b!==f&&(this.b=f,this.a=this.c(S)),this.a}}e.$Fe=s;class j{get cachedValues(){return this.a}constructor(S){this.b=S,this.a=new Map}get(S){if(this.a.has(S))return this.a.get(S);const f=this.b(S);return this.a.set(S,f),f}}e.$Ge=j}),define(oe[63],ae([0,1,14,2]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function s(m){const c=m;return c?typeof c.read=="function":!1}e.$7d=s;function j(m){const c=m;return c?[c.on,c.pause,c.resume,c.destroy].every(t=>typeof t=="function"):!1}e.$8d=j;function D(m){const c=m;return c?j(c.stream)&&Array.isArray(c.buffer)&&typeof c.ended=="boolean":!1}e.$9d=D;function S(m,c){return new f(m,c)}e.$0d=S;class f{constructor(c,t){this.e=c,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(c){if(!this.a.destroyed){if(this.a.flowing)this.g(c);else if(this.b.data.push(c),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(c){this.a.destroyed||(this.a.flowing?this.h(c):this.b.error.push(c))}end(c){this.a.destroyed||(typeof c<"u"&&this.write(c),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(c){this.c.data.slice(0).forEach(t=>t(c))}h(c){this.c.error.length===0?(0,P.$1)(c):this.c.error.slice(0).forEach(t=>t(c))}i(){this.c.end.slice(0).forEach(c=>c())}on(c,t){if(!this.a.destroyed)switch(c){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(c,t){if(this.a.destroyed)return;let o;switch(c){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const r=o.indexOf(t);r>=0&&o.splice(r,1)}}j(){if(this.b.data.length>0){const c=this.e(this.b.data);this.g(c),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const c of this.b.error)this.h(c);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(m,c){const t=[];let o;for(;(o=m.read())!==null;)t.push(o);return c(t)}e.$$d=l;function p(m,c,t){const o=[];let r;for(;(r=m.read())!==null&&o.length<t;)o.push(r);return r===null&&o.length>0?c(o):{read:()=>{if(o.length>0)return o.shift();if(typeof r<"u"){const i=r;return r=void 0,i}return m.read()}}}e.$_d=p;function k(m,c){return new Promise((t,o)=>{const r=[];v(m,{onData:i=>{c&&r.push(i)},onError:i=>{c?o(i):t(void 0)},onEnd:()=>{t(c?c(r):void 0)}})})}e.$ae=k;function v(m,c,t){m.on("error",o=>{t?.isCancellationRequested||c.onError(o)}),m.on("end",()=>{t?.isCancellationRequested||c.onEnd()}),m.on("data",o=>{t?.isCancellationRequested||c.onData(o)})}e.$be=v;function u(m,c){return new Promise((t,o)=>{const r=new R.$Sc,i=[],n=C=>{if(i.push(C),i.length>c)return r.dispose(),m.pause(),t({stream:m,buffer:i,ended:!1})},a=C=>(r.dispose(),o(C)),b=()=>(r.dispose(),t({stream:m,buffer:i,ended:!0}));r.add((0,R.$Rc)(()=>m.removeListener("error",a))),m.on("error",a),r.add((0,R.$Rc)(()=>m.removeListener("end",b))),m.on("end",b),r.add((0,R.$Rc)(()=>m.removeListener("data",n))),m.on("data",n)})}e.$ce=u;function y(m,c){const t=S(c);return t.end(m),t}e.$de=y;function w(){const m=S(()=>{throw new Error("not supported")});return m.end(),m}e.$ee=w;function g(m){let c=!1;return{read:()=>c?null:(c=!0,m)}}e.$fe=g;function $(m,c,t){const o=S(t);return v(m,{onData:r=>o.write(c.data(r)),onError:r=>o.error(c.error?c.error(r):r),onEnd:()=>o.end()}),o}e.$ge=$;function d(m,c,t){let o=!1;return{read:()=>{const r=c.read();return o?r:(o=!0,r!==null?t([m,r]):m)}}}e.$he=d;function h(m,c,t){let o=!1;const r=S(t);return v(c,{onData:i=>o?r.write(i):(o=!0,r.write(t([m,i]))),onError:i=>r.error(i),onEnd:()=>{o||(o=!0,r.write(m)),r.end()}}),r}e.$ie=h}),define(oe[17],ae([0,1,62,63]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const s=typeof Buffer<"u",j=new P.$V(()=>new Uint8Array(256));let D,S;class f{static alloc(A){return s?new f(Buffer.allocUnsafe(A)):new f(new Uint8Array(A))}static wrap(A){return s&&!Buffer.isBuffer(A)&&(A=Buffer.from(A.buffer,A.byteOffset,A.byteLength)),new f(A)}static fromString(A,M){return!(M?.dontUseNodeBuffer||!1)&&s?new f(Buffer.from(A)):(D||(D=new TextEncoder),new f(D.encode(A)))}static fromByteArray(A){const M=f.alloc(A.length);for(let T=0,W=A.length;T<W;T++)M.buffer[T]=A[T];return M}static concat(A,M){if(typeof M>"u"){M=0;for(let G=0,J=A.length;G<J;G++)M+=A[G].byteLength}const T=f.alloc(M);let W=0;for(let G=0,J=A.length;G<J;G++){const ce=A[G];T.set(ce,W),W+=ce.byteLength}return T}constructor(A){this.buffer=A,this.byteLength=this.buffer.byteLength}clone(){const A=f.alloc(this.byteLength);return A.set(this),A}toString(){return s?this.buffer.toString():(S||(S=new TextDecoder),S.decode(this.buffer))}slice(A,M){return new f(this.buffer.subarray(A,M))}set(A,M){if(A instanceof f)this.buffer.set(A.buffer,M);else if(A instanceof Uint8Array)this.buffer.set(A,M);else if(A instanceof ArrayBuffer)this.buffer.set(new Uint8Array(A),M);else if(ArrayBuffer.isView(A))this.buffer.set(new Uint8Array(A.buffer,A.byteOffset,A.byteLength),M);else throw new Error("Unknown argument 'array'")}readUInt32BE(A){return v(this.buffer,A)}writeUInt32BE(A,M){u(this.buffer,A,M)}readUInt32LE(A){return y(this.buffer,A)}writeUInt32LE(A,M){w(this.buffer,A,M)}readUInt8(A){return g(this.buffer,A)}writeUInt8(A,M){$(this.buffer,A,M)}indexOf(A,M=0){return l(this.buffer,A instanceof f?A.buffer:A,M)}}e.$je=f;function l(E,A,M=0){const T=A.byteLength,W=E.byteLength;if(T===0)return 0;if(T===1)return E.indexOf(A[0]);if(T>W-M)return-1;const G=j.value;G.fill(A.length);for(let ue=0;ue<A.length;ue++)G[A[ue]]=A.length-ue-1;let J=M+A.length-1,ce=J,re=-1;for(;J<W;)if(E[J]===A[ce]){if(ce===0){re=J;break}J--,ce--}else J+=Math.max(A.length-ce,G[E[J]]),ce=A.length-1;return re}e.$ke=l;function p(E,A){return E[A+0]<<0>>>0|E[A+1]<<8>>>0}e.$le=p;function k(E,A,M){E[M+0]=A&255,A=A>>>8,E[M+1]=A&255}e.$me=k;function v(E,A){return E[A]*2**24+E[A+1]*2**16+E[A+2]*2**8+E[A+3]}e.$ne=v;function u(E,A,M){E[M+3]=A,A=A>>>8,E[M+2]=A,A=A>>>8,E[M+1]=A,A=A>>>8,E[M]=A}e.$oe=u;function y(E,A){return E[A+0]<<0>>>0|E[A+1]<<8>>>0|E[A+2]<<16>>>0|E[A+3]<<24>>>0}e.$pe=y;function w(E,A,M){E[M+0]=A&255,A=A>>>8,E[M+1]=A&255,A=A>>>8,E[M+2]=A&255,A=A>>>8,E[M+3]=A&255}e.$qe=w;function g(E,A){return E[A]}e.$re=g;function $(E,A,M){E[M]=A}e.$se=$;function d(E){return R.$$d(E,A=>f.concat(A))}e.$te=d;function h(E){return R.$fe(E)}e.$ue=h;function m(E){return R.$ae(E,A=>f.concat(A))}e.$ve=m;async function c(E){return E.ended?f.concat(E.buffer):f.concat([...E.buffer,await m(E.stream)])}e.$we=c;function t(E){return R.$de(E,A=>f.concat(A))}e.$xe=t;function o(E){return R.$ge(E,{data:A=>typeof A=="string"?f.fromString(A):f.wrap(A)},A=>f.concat(A))}e.$ye=o;function r(E){return R.$0d(A=>f.concat(A),E)}e.$ze=r;function i(E,A){return R.$he(E,A,M=>f.concat(M))}e.$Ae=i;function n(E,A){return R.$ie(E,A,M=>f.concat(M))}e.$Be=n;function a(E){let A=0,M=0,T=0;const W=new Uint8Array(Math.floor(E.length/4*3)),G=ce=>{switch(M){case 3:W[T++]=A|ce,M=0;break;case 2:W[T++]=A|ce>>>2,A=ce<<6,M=3;break;case 1:W[T++]=A|ce>>>4,A=ce<<4,M=2;break;default:A=ce<<2,M=1}};for(let ce=0;ce<E.length;ce++){const re=E.charCodeAt(ce);if(re>=65&&re<=90)G(re-65);else if(re>=97&&re<=122)G(re-97+26);else if(re>=48&&re<=57)G(re-48+52);else if(re===43||re===45)G(62);else if(re===47||re===95)G(63);else{if(re===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ce]}`)}}const J=T;for(;M>0;)G(0);return f.wrap(W).slice(0,J)}e.$Ce=a;const b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function I({buffer:E},A=!0,M=!1){const T=M?C:b;let W="";const G=E.byteLength%3;let J=0;for(;J<E.byteLength-G;J+=3){const ce=E[J+0],re=E[J+1],ue=E[J+2];W+=T[ce>>>2],W+=T[(ce<<4|re>>>4)&63],W+=T[(re<<2|ue>>>6)&63],W+=T[ue&63]}if(G===1){const ce=E[J+0];W+=T[ce>>>2],W+=T[ce<<4&63],A&&(W+="==")}else if(G===2){const ce=E[J+0],re=E[J+1];W+=T[ce>>>2],W+=T[(ce<<4|re>>>4)&63],W+=T[re<<2&63],A&&(W+="=")}return W}e.$De=I}),define(oe[25],ae([0,1,142,62]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.GraphemeBreakType=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=void 0;function s(ie){return!ie||typeof ie!="string"?!0:ie.trim().length===0}e.$Je=s;const j=/{(\d+)}/g;function D(ie,...de){return de.length===0?ie:ie.replace(j,function(we,Ee){const ye=parseInt(Ee,10);return isNaN(ye)||ye<0||ye>=de.length?we:de[ye]})}e.$Ke=D;const S=/{([^}]+)}/g;function f(ie,de){return Object.keys(de).length===0?ie:ie.replace(S,(we,Ee)=>de[Ee]??we)}e.$Le=f;function l(ie){return ie.replace(/[<>"'&]/g,de=>{switch(de){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return de})}e.$Me=l;function p(ie){return ie.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.$Ne=p;function k(ie){return ie.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Oe=k;function v(ie,de){let we=0;const Ee=de.charCodeAt(0);for(let ye=ie.length-1;ye>=0;ye--)ie.charCodeAt(ye)===Ee&&we++;return we}e.$Pe=v;function u(ie,de,we="\u2026"){return ie.length<=de?ie:`${ie.substr(0,de)}${we}`}e.$Qe=u;function y(ie,de,we="\u2026"){if(ie.length<=de)return ie;const Ee=Math.ceil(de/2)-we.length/2,ye=Math.floor(de/2)-we.length/2;return`${ie.substr(0,Ee)}${we}${ie.substr(ie.length-ye)}`}e.$Re=y;function w(ie,de=" "){const we=g(ie,de);return $(we,de)}e.$Se=w;function g(ie,de){if(!ie||!de)return ie;const we=de.length;if(we===0||ie.length===0)return ie;let Ee=0;for(;ie.indexOf(de,Ee)===Ee;)Ee=Ee+we;return ie.substring(Ee)}e.$Te=g;function $(ie,de){if(!ie||!de)return ie;const we=de.length,Ee=ie.length;if(we===0||Ee===0)return ie;let ye=Ee,Re=-1;for(;Re=ie.lastIndexOf(de,ye-1),!(Re===-1||Re+we!==ye);){if(Re===0)return"";ye=Re}return ie.substring(0,ye)}e.$Ue=$;function d(ie){return ie.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ve=d;function h(ie){return ie.replace(/\*/g,"")}e.$We=h;function m(ie,de,we={}){if(!ie)throw new Error("Cannot create regex from empty string");de||(ie=k(ie)),we.wholeWord&&(/\B/.test(ie.charAt(0))||(ie="\\b"+ie),/\B/.test(ie.charAt(ie.length-1))||(ie=ie+"\\b"));let Ee="";return we.global&&(Ee+="g"),we.matchCase||(Ee+="i"),we.multiline&&(Ee+="m"),we.unicode&&(Ee+="u"),new RegExp(ie,Ee)}e.$Xe=m;function c(ie){return ie.source==="^"||ie.source==="^$"||ie.source==="$"||ie.source==="^\\s*$"?!1:!!(ie.exec("")&&ie.lastIndex===0)}e.$Ye=c;function t(ie){return ie.split(/\r\n|\r|\n/)}e.$Ze=t;function o(ie){for(let de=0,we=ie.length;de<we;de++){const Ee=ie.charCodeAt(de);if(Ee!==32&&Ee!==9)return de}return-1}e.$1e=o;function r(ie,de=0,we=ie.length){for(let Ee=de;Ee<we;Ee++){const ye=ie.charCodeAt(Ee);if(ye!==32&&ye!==9)return ie.substring(de,Ee)}return ie.substring(de,we)}e.$2e=r;function i(ie,de=ie.length-1){for(let we=de;we>=0;we--){const Ee=ie.charCodeAt(we);if(Ee!==32&&Ee!==9)return we}return-1}e.$3e=i;function n(ie,de,we){const Ee=[];let ye=0;for(const Re of ie.matchAll(de)){if(Ee.push(ie.slice(ye,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");ye=Re.index+Re[0].length,Ee.push(we(Re[0],...Re.slice(1),Re.index,ie,Re.groups))}return Ee.push(ie.slice(ye)),Promise.all(Ee).then(Re=>Re.join(""))}e.$4e=n;function a(ie,de){return ie<de?-1:ie>de?1:0}e.$5e=a;function b(ie,de,we=0,Ee=ie.length,ye=0,Re=de.length){for(;we<Ee&&ye<Re;we++,ye++){const Qe=ie.charCodeAt(we),xe=de.charCodeAt(ye);if(Qe<xe)return-1;if(Qe>xe)return 1}const We=Ee-we,qe=Re-ye;return We<qe?-1:We>qe?1:0}e.$6e=b;function C(ie,de){return I(ie,de,0,ie.length,0,de.length)}e.$7e=C;function I(ie,de,we=0,Ee=ie.length,ye=0,Re=de.length){for(;we<Ee&&ye<Re;we++,ye++){let Qe=ie.charCodeAt(we),xe=de.charCodeAt(ye);if(Qe===xe)continue;if(Qe>=128||xe>=128)return b(ie.toLowerCase(),de.toLowerCase(),we,Ee,ye,Re);A(Qe)&&(Qe-=32),A(xe)&&(xe-=32);const Xe=Qe-xe;if(Xe!==0)return Xe}const We=Ee-we,qe=Re-ye;return We<qe?-1:We>qe?1:0}e.$8e=I;function E(ie){return ie>=48&&ie<=57}e.$9e=E;function A(ie){return ie>=97&&ie<=122}e.$0e=A;function M(ie){return ie>=65&&ie<=90}e.$$e=M;function T(ie,de){return ie.length===de.length&&I(ie,de)===0}e.$_e=T;function W(ie,de){const we=de.length;return de.length>ie.length?!1:I(ie,de,0,we)===0}e.$af=W;function G(ie,de){const we=Math.min(ie.length,de.length);let Ee;for(Ee=0;Ee<we;Ee++)if(ie.charCodeAt(Ee)!==de.charCodeAt(Ee))return Ee;return we}e.$bf=G;function J(ie,de){const we=Math.min(ie.length,de.length);let Ee;const ye=ie.length-1,Re=de.length-1;for(Ee=0;Ee<we;Ee++)if(ie.charCodeAt(ye-Ee)!==de.charCodeAt(Re-Ee))return Ee;return we}e.$cf=J;function ce(ie){return 55296<=ie&&ie<=56319}e.$df=ce;function re(ie){return 56320<=ie&&ie<=57343}e.$ef=re;function ue(ie,de){return(ie-55296<<10)+(de-56320)+65536}e.$ff=ue;function Z(ie,de,we){const Ee=ie.charCodeAt(we);if(ce(Ee)&&we+1<de){const ye=ie.charCodeAt(we+1);if(re(ye))return ue(Ee,ye)}return Ee}e.$gf=Z;function Y(ie,de){const we=ie.charCodeAt(de-1);if(re(we)&&de>1){const Ee=ie.charCodeAt(de-2);if(ce(Ee))return ue(Ee,we)}return we}class V{get offset(){return this.e}constructor(de,we=0){this.c=de,this.d=de.length,this.e=we}setOffset(de){this.e=de}prevCodePoint(){const de=Y(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=Z(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.$hf=V;class L{get offset(){return this.c.offset}constructor(de,we=0){this.c=new V(de,we)}nextGraphemeLength(){const de=Pe.getInstance(),we=this.c,Ee=we.offset;let ye=de.getGraphemeBreakType(we.nextCodePoint());for(;!we.eol();){const Re=we.offset,We=de.getGraphemeBreakType(we.nextCodePoint());if(fe(ye,We)){we.setOffset(Re);break}ye=We}return we.offset-Ee}prevGraphemeLength(){const de=Pe.getInstance(),we=this.c,Ee=we.offset;let ye=de.getGraphemeBreakType(we.prevCodePoint());for(;we.offset>0;){const Re=we.offset,We=de.getGraphemeBreakType(we.prevCodePoint());if(fe(We,ye)){we.setOffset(Re);break}ye=We}return Ee-we.offset}eol(){return this.c.eol()}}e.$if=L;function U(ie,de){return new L(ie,de).nextGraphemeLength()}e.$jf=U;function H(ie,de){return new L(ie,de).prevGraphemeLength()}e.$kf=H;function q(ie,de){de>0&&re(ie.charCodeAt(de))&&de--;const we=de+U(ie,de);return[we-H(ie,we),we]}e.$lf=q;function ee(ie){const de=new L(ie);let we=0;for(;!de.eol();)we++,de.nextGraphemeLength();return we}e.$mf=ee;let he;function K(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function O(ie){return he||(he=K()),he.test(ie)}e.$nf=O;const F=/^[\t\n\r\x20-\x7E]*$/;function _(ie){return F.test(ie)}e.$of=_,e.$pf=/[\u2028\u2029]/;function z(ie){return e.$pf.test(ie)}e.$qf=z;function x(ie){return ie>=11904&&ie<=55215||ie>=63744&&ie<=64255||ie>=65281&&ie<=65374}e.$rf=x;function N(ie){return ie>=127462&&ie<=127487||ie===8986||ie===8987||ie===9200||ie===9203||ie>=9728&&ie<=10175||ie===11088||ie===11093||ie>=127744&&ie<=128591||ie>=128640&&ie<=128764||ie>=128992&&ie<=129008||ie>=129280&&ie<=129535||ie>=129648&&ie<=129782}e.$sf=N;function B(ie,de,we=""){const Ee=ie.trimStart();if(Ee.length<de)return Ee;const ye=/\b/g;let Re=0;for(;ye.test(Ee)&&!(Ee.length-ye.lastIndex<de);)Re=ye.lastIndex,ye.lastIndex+=1;return Re===0?Ee:we+Ee.substring(Re).trimStart()}e.$tf=B;const Q=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,se=/\x1b\].*?\x07/g;function le(ie){return ie&&(ie=ie.replace(Q,"").replace(se,"")),ie}e.$uf=le,e.$vf=String.fromCharCode(65279);function ge(ie){return!!(ie&&ie.length>0&&ie.charCodeAt(0)===65279)}e.$wf=ge;function be(ie){return ge(ie)?ie.substr(1):ie}e.$xf=be;function Se(ie,de){if(!ie||!de||ie.length<de.length)return!1;const we=de.length,Ee=ie.toLowerCase();let ye=0,Re=-1;for(;ye<we;){const We=Ee.indexOf(de[ye],Re+1);if(We<0)return!1;Re=We,ye++}return!0}e.$yf=Se;function Ae(ie,de=!1){return ie?(de&&(ie=ie.replace(/\\./g,"")),ie.toLowerCase()!==ie):!1}e.$zf=Ae;function Le(ie){return ie.charAt(0).toUpperCase()+ie.slice(1)}e.$Af=Le;function ke(ie,de=1){if(de===0)return"";let we=-1;do we=ie.indexOf(`
`,we+1),de--;while(de>0&&we>=0);return we===-1?ie:(ie[we-1]==="\r"&&we--,ie.substr(0,we))}e.$Bf=ke;function pe(ie){return ie=ie%(2*26),ie<26?String.fromCharCode(97+ie):String.fromCharCode(65+ie-26)}e.$Cf=pe;function te(ie){return Pe.getInstance().getGraphemeBreakType(ie)}e.$Df=te;function fe(ie,de){return ie===0?de!==5&&de!==7:ie===2&&de===3?!1:ie===4||ie===2||ie===3||de===4||de===2||de===3?!0:!(ie===8&&(de===8||de===9||de===11||de===12)||(ie===11||ie===9)&&(de===9||de===10)||(ie===12||ie===10)&&de===10||de===5||de===13||de===7||ie===1||ie===13&&de===14||ie===6&&de===6)}var $e;(function(ie){ie[ie.Other=0]="Other",ie[ie.Prepend=1]="Prepend",ie[ie.CR=2]="CR",ie[ie.LF=3]="LF",ie[ie.Control=4]="Control",ie[ie.Extend=5]="Extend",ie[ie.Regional_Indicator=6]="Regional_Indicator",ie[ie.SpacingMark=7]="SpacingMark",ie[ie.L=8]="L",ie[ie.V=9]="V",ie[ie.T=10]="T",ie[ie.LV=11]="LV",ie[ie.LVT=12]="LVT",ie[ie.ZWJ=13]="ZWJ",ie[ie.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class Pe{static{this.c=null}static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=je()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const we=this.d,Ee=we.length/3;let ye=1;for(;ye<=Ee;)if(de<we[3*ye])ye=2*ye;else if(de>we[3*ye+1])ye=2*ye+1;else return we[3*ye+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Te(ie,de){if(ie===0)return 0;const we=Me(ie,de);if(we!==void 0)return we;const Ee=new V(de,ie);return Ee.prevCodePoint(),Ee.offset}e.$Ef=Te;function Me(ie,de){const we=new V(de,ie);let Ee=we.prevCodePoint();for(;Je(Ee)||Ee===65039||Ee===8419;){if(we.offset===0)return;Ee=we.prevCodePoint()}if(!N(Ee))return;let ye=we.offset;return ye>0&&we.prevCodePoint()===8205&&(ye=we.offset),ye}function Je(ie){return 127995<=ie&&ie<=127999}var Be;(function(ie){ie[ie.zwj=8205]="zwj",ie[ie.emojiVariantSelector=65039]="emojiVariantSelector",ie[ie.enclosingKeyCap=8419]="enclosingKeyCap"})(Be||(Be={})),e.$Ff="\xA0";class Ve{static{this.c=new R.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new P.$Fe(de=>{function we(Xe){const Ze=new Map;for(let nt=0;nt<Xe.length;nt+=2)Ze.set(Xe[nt],Xe[nt+1]);return Ze}function Ee(Xe,Ze){const nt=new Map(Xe);for(const[st,ot]of Ze)nt.set(st,ot);return nt}function ye(Xe,Ze){if(!Xe)return Ze;const nt=new Map;for(const[st,ot]of Xe)Ze.has(st)&&nt.set(st,ot);return nt}const Re=this.c.value;let We=de.filter(Xe=>!Xe.startsWith("_")&&Xe in Re);We.length===0&&(We=["_default"]);let qe;for(const Xe of We){const Ze=we(Re[Xe]);qe=ye(qe,Ze)}const Qe=we(Re._common),xe=Ee(Qe,qe);return new Ve(xe)})}static getInstance(de){return Ve.d.get(Array.from(de))}static{this.e=new R.$V(()=>Object.keys(Ve.c.value).filter(de=>!de.startsWith("_")))}static getLocales(){return Ve.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Gf=Ve;class He{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(He.c())),this.d}static isInvisibleCharacter(de){return He.e().has(de)}static get codePoints(){return He.e()}}e.$Hf=He}),define(oe[45],ae([0,1,25]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function R($){return s($,0)}e.$Ti=R;function s($,d){switch(typeof $){case"object":return $===null?j(349,d):Array.isArray($)?f($,d):l($,d);case"string":return S($,d);case"boolean":return D($,d);case"number":return j($,d);case"undefined":return j(937,d);default:return j(617,d)}}e.$Ui=s;function j($,d){return(d<<5)-d+$|0}e.$Vi=j;function D($,d){return j($?433:863,d)}function S($,d){d=j(149417,d);for(let h=0,m=$.length;h<m;h++)d=j($.charCodeAt(h),d);return d}e.$Wi=S;function f($,d){return d=j(104579,d),$.reduce((h,m)=>s(m,h),d)}function l($,d){return d=j(181387,d),Object.keys($).sort().reduce((h,m)=>(h=S(m,h),s($[m],h)),d)}class p{constructor(){this.g=0}get value(){return this.g}hash(d){return this.g=s(d,this.g),this.g}}e.$Xi=p;var k;(function($){$[$.BLOCK_SIZE=64]="BLOCK_SIZE",$[$.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function v($,d,h=32){const m=h-d,c=~((1<<m)-1);return($<<d|(c&$)>>>m)>>>0}function u($,d=0,h=$.byteLength,m=0){for(let c=0;c<h;c++)$[d+c]=m}function y($,d,h="0"){for(;$.length<d;)$=h+$;return $}function w($,d=32){return $ instanceof ArrayBuffer?Array.from(new Uint8Array($)).map(h=>h.toString(16).padStart(2,"0")).join(""):y(($>>>0).toString(16),d/4)}e.$Yi=w;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(d){const h=d.length;if(h===0)return;const m=this.p;let c=this.r,t=this.u,o,r;for(t!==0?(o=t,r=-1,t=0):(o=d.charCodeAt(0),r=0);;){let i=o;if(P.$df(o))if(r+1<h){const n=d.charCodeAt(r+1);P.$ef(n)?(r++,i=P.$ff(o,n)):i=65533}else{t=o;break}else P.$ef(o)&&(i=65533);if(c=this.w(m,c,i),r++,r<h)o=d.charCodeAt(r);else break}this.r=c,this.u=t}w(d,h,m){return m<128?d[h++]=m:m<2048?(d[h++]=192|(m&1984)>>>6,d[h++]=128|(m&63)>>>0):m<65536?(d[h++]=224|(m&61440)>>>12,d[h++]=128|(m&4032)>>>6,d[h++]=128|(m&63)>>>0):(d[h++]=240|(m&1835008)>>>18,d[h++]=128|(m&258048)>>>12,d[h++]=128|(m&4032)>>>6,d[h++]=128|(m&63)>>>0),h>=64&&(this.y(),h-=64,this.t+=64,d[0]=d[64+0],d[1]=d[64+1],d[2]=d[64+2]),h}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,u(this.p,this.r),this.r>56&&(this.y(),u(this.p));const d=8*this.t;this.q.setUint32(56,Math.floor(d/4294967296),!1),this.q.setUint32(60,d%4294967296,!1),this.y()}y(){const d=g.g,h=this.q;for(let b=0;b<64;b+=4)d.setUint32(b,h.getUint32(b,!1),!1);for(let b=64;b<320;b+=4)d.setUint32(b,v(d.getUint32(b-12,!1)^d.getUint32(b-32,!1)^d.getUint32(b-56,!1)^d.getUint32(b-64,!1),1),!1);let m=this.h,c=this.l,t=this.m,o=this.n,r=this.o,i,n,a;for(let b=0;b<80;b++)b<20?(i=c&t|~c&o,n=1518500249):b<40?(i=c^t^o,n=1859775393):b<60?(i=c&t|c&o|t&o,n=2400959708):(i=c^t^o,n=3395469782),a=v(m,5)+i+r+n+d.getUint32(b*4,!1)&4294967295,r=o,o=t,t=v(c,30),c=m,m=a;this.h=this.h+m&4294967295,this.l=this.l+c&4294967295,this.m=this.m+t&4294967295,this.n=this.n+o&4294967295,this.o=this.o+r&4294967295}}e.$Zi=g}),define(oe[74],ae([0,1,25]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(R||(R={})),function(s){const j="error",D="warning",S="warn",f="info",l="ignore";function p(v){return v?P.$_e(j,v)?s.Error:P.$_e(D,v)||P.$_e(S,v)?s.Warning:P.$_e(f,v)?s.Info:s.Ignore:s.Ignore}s.fromValue=p;function k(v){switch(v){case s.Error:return j;case s.Warning:return D;case s.Info:return f;default:return l}}s.toString=k}(R||(R={})),e.default=R}),define(oe[143],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(oe[58],ae([0,1,22,25]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class s{constructor(){this.b="",this.c=0}reset(u){return this.b=u,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(u){const y=u.charCodeAt(0),w=this.b.charCodeAt(this.c);return y-w}value(){return this.b[this.c]}}e.$8h=s;class j{constructor(u=!0){this.e=u}reset(u){return this.b=u,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let u=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(u)this.c++;else break;else u=!1;return this}cmp(u){return this.e?(0,R.$6e)(u,this.b,0,u.length,this.c,this.d):(0,R.$8e)(u,this.b,0,u.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=j;class D{constructor(u=!0,y=!0){this.f=u,this.g=y}reset(u){this.d=0,this.e=0,this.b=u,this.c=u.length;for(let y=u.length-1;y>=0;y--,this.c--){const w=this.b.charCodeAt(y);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let u=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(u)this.d++;else break;else u=!1}return this}cmp(u){return this.g?(0,R.$6e)(u,this.b,0,u.length,this.d,this.e):(0,R.$8e)(u,this.b,0,u.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=D;var S;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(S||(S={}));class f{constructor(u,y){this.f=u,this.g=y,this.d=[],this.e=0}reset(u){return this.c=u,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new D(!1,!this.f(u)),this.b.reset(u.path),this.b.value()&&this.d.push(3)),this.g(u)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(u){if(this.d[this.e]===1)return(0,R.$7e)(u,this.c.scheme);if(this.d[this.e]===2)return(0,R.$7e)(u,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(u);if(this.d[this.e]===4)return(0,R.$5e)(u,this.c.query);if(this.d[this.e]===5)return(0,R.$5e)(u,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=f;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const u=this.right;return this.right=u.left,u.left=this,this.updateHeight(),u.updateHeight(),u}rotateRight(){const u=this.left;return this.left=u.right,u.right=this,this.updateHeight(),u.updateHeight(),u}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(p||(p={}));class k{static forUris(u=()=>!1,y=()=>!1){return new k(new f(u,y))}static forPaths(u=!1){return new k(new D(void 0,!u))}static forStrings(){return new k(new s)}static forConfigKeys(){return new k(new j)}constructor(u){this.b=u}clear(){this.c=void 0}fill(u,y){if(y){const w=y.slice(0);(0,P.$Xb)(w);for(const g of w)this.set(g,u)}else{const w=u.slice(0);(0,P.$Xb)(w);for(const g of w)this.set(g[0],g[1])}}set(u,y){const w=this.b.reset(u);let g;this.c||(this.c=new l,this.c.segment=w.value());const $=[];for(g=this.c;;){const h=w.cmp(g.segment);if(h>0)g.left||(g.left=new l,g.left.segment=w.value()),$.push([-1,g]),g=g.left;else if(h<0)g.right||(g.right=new l,g.right.segment=w.value()),$.push([1,g]),g=g.right;else if(w.hasNext())w.next(),g.mid||(g.mid=new l,g.mid.segment=w.value()),$.push([0,g]),g=g.mid;else break}const d=g.value;g.value=y,g.key=u;for(let h=$.length-1;h>=0;h--){const m=$[h][1];m.updateHeight();const c=m.balanceFactor();if(c<-1||c>1){const t=$[h][0],o=$[h+1][0];if(t===1&&o===1)$[h][1]=m.rotateLeft();else if(t===-1&&o===-1)$[h][1]=m.rotateRight();else if(t===1&&o===-1)m.right=$[h+1][1]=$[h+1][1].rotateRight(),$[h][1]=m.rotateLeft();else if(t===-1&&o===1)m.left=$[h+1][1]=$[h+1][1].rotateLeft(),$[h][1]=m.rotateRight();else throw new Error;if(h>0)switch($[h-1][0]){case-1:$[h-1][1].left=$[h][1];break;case 1:$[h-1][1].right=$[h][1];break;case 0:$[h-1][1].mid=$[h][1];break}else this.c=$[0][1]}}return d}get(u){return this.d(u)?.value}d(u){const y=this.b.reset(u);let w=this.c;for(;w;){const g=y.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(u){const y=this.d(u);return!(y?.value===void 0&&y?.mid===void 0)}delete(u){return this.e(u,!1)}deleteSuperstr(u){return this.e(u,!0)}e(u,y){const w=this.b.reset(u),g=[];let $=this.c;for(;$;){const d=w.cmp($.segment);if(d>0)g.push([-1,$]),$=$.left;else if(d<0)g.push([1,$]),$=$.right;else if(w.hasNext())w.next(),g.push([0,$]),$=$.mid;else break}if($){if(y?($.left=void 0,$.mid=void 0,$.right=void 0,$.height=1):($.key=void 0,$.value=void 0),!$.mid&&!$.value)if($.left&&$.right){const d=this.f($.right);if(d.key){const{key:h,value:m,segment:c}=d;this.e(d.key,!1),$.key=h,$.value=m,$.segment=c}}else{const d=$.left??$.right;if(g.length>0){const[h,m]=g[g.length-1];switch(h){case-1:m.left=d;break;case 0:m.mid=d;break;case 1:m.right=d;break}}else this.c=d}for(let d=g.length-1;d>=0;d--){const h=g[d][1];h.updateHeight();const m=h.balanceFactor();if(m>1?(h.right.balanceFactor()>=0||(h.right=h.right.rotateRight()),g[d][1]=h.rotateLeft()):m<-1&&(h.left.balanceFactor()<=0||(h.left=h.left.rotateLeft()),g[d][1]=h.rotateRight()),d>0)switch(g[d-1][0]){case-1:g[d-1][1].left=g[d][1];break;case 1:g[d-1][1].right=g[d][1];break;case 0:g[d-1][1].mid=g[d][1];break}else this.c=g[0][1]}}}f(u){for(;u.left;)u=u.left;return u}findSubstr(u){const y=this.b.reset(u);let w=this.c,g;for(;w;){const $=y.cmp(w.segment);if($>0)w=w.left;else if($<0)w=w.right;else if(y.hasNext())y.next(),g=w.value||g,w=w.mid;else break}return w&&w.value||g}findSuperstr(u){return this.g(u,!1)}g(u,y){const w=this.b.reset(u);let g=this.c;for(;g;){const $=w.cmp(g.segment);if($>0)g=g.left;else if($<0)g=g.right;else if(w.hasNext())w.next(),g=g.mid;else return g.mid?this.h(g.mid):y?g.value:void 0}}hasElementOrSubtree(u){return this.g(u,!0)!==void 0}forEach(u){for(const[y,w]of this)u(w,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(u){const y=[];return this.j(u,y),y[Symbol.iterator]()}j(u,y){u&&(u.left&&this.j(u.left,y),u.value&&y.push([u.key,u.value]),u.mid&&this.j(u.mid,y),u.right&&this.j(u.right,y))}_isBalanced(){const u=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:u(y.left)&&u(y.right)};return u(this.c)}}e.$_h=k}),define(oe[12],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=void 0;function P(c){return typeof c=="string"}e.$If=P;function R(c){return Array.isArray(c)&&c.every(t=>P(t))}e.$Jf=R;function s(c){return typeof c=="object"&&c!==null&&!Array.isArray(c)&&!(c instanceof RegExp)&&!(c instanceof Date)}e.$Kf=s;function j(c){const t=Object.getPrototypeOf(Uint8Array);return typeof c=="object"&&c instanceof t}e.$Lf=j;function D(c){return typeof c=="number"&&!isNaN(c)}e.$Mf=D;function S(c){return!!c&&typeof c[Symbol.iterator]=="function"}e.$Nf=S;function f(c){return c===!0||c===!1}e.$Of=f;function l(c){return typeof c>"u"}e.$Pf=l;function p(c){return!k(c)}e.$Qf=p;function k(c){return l(c)||c===null}e.$Rf=k;function v(c,t){if(!c)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Sf=v;function u(c){if(k(c))throw new Error("Assertion Failed: argument is undefined or null");return c}e.$Tf=u;function y(...c){const t=[];for(let o=0;o<c.length;o++){const r=c[o];if(k(r))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);t.push(r)}return t}e.$Uf=y;const w=Object.prototype.hasOwnProperty;function g(c){if(!s(c))return!1;for(const t in c)if(w.call(c,t))return!1;return!0}e.$Vf=g;function $(c){return typeof c=="function"}e.$Wf=$;function d(...c){return c.length>0&&c.every($)}e.$Xf=d;function h(c,t){const o=Math.min(c.length,t.length);for(let r=0;r<o;r++)m(c[r],t[r])}e.$Yf=h;function m(c,t){if(P(t)){if(typeof c!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if($(t)){try{if(c instanceof t)return}catch{}if(!k(c)&&c.constructor===t||t.length===1&&t.call(void 0,c)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Zf=m}),define(oe[75],ae([0,1,12]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=void 0;const R=Object.create(null);function s(S,f){if((0,P.$If)(f)){const l=R[f];if(l===void 0)throw new Error(`${S} references an unknown codicon: ${f}`);f=l}return R[S]=f,{id:S}}function j(){return R}e.$0j=j;function D(){return Object.values(e.$_j)}e.$$j=D,e.$_j={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),gitPullRequestLabel:s("git-pull-request-label",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugBreakpointPending:s("debug-breakpoint-pending",60377),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),gitPullRequestMilestone:s("git-pull-request-milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),gitPullRequestReviewer:s("git-pull-request-reviewer",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),gitPullRequestAssignee:s("git-pull-request-assignee",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),mic:s("mic",60434),thumbsDownFilled:s("thumbsdown-filled",60435),thumbsUpFilled:s("thumbsup-filled",60436),coffee:s("coffee",60437),snake:s("snake",60438),game:s("game",60439),vr:s("vr",60440),chip:s("chip",60441),piano:s("piano",60442),music:s("music",60443),micFilled:s("mic-filled",60444),gitFetch:s("git-fetch",60445),copilot:s("copilot",60446),lightbulbSparkle:s("lightbulb-sparkle",60447),lightbulbSparkleAutofix:s("lightbulb-sparkle-autofix",60447),robot:s("robot",60448),sparkleFilled:s("sparkle-filled",60449),diffSingle:s("diff-single",60450),diffMultiple:s("diff-multiple",60451),surroundWith:s("surround-with",60452),gitStash:s("git-stash",60454),gitStashApply:s("git-stash-apply",60455),gitStashPop:s("git-stash-pop",60456),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(oe[35],ae([0,1,12]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function R($){if(!$||typeof $!="object"||$ instanceof RegExp)return $;const d=Array.isArray($)?[]:{};return Object.entries($).forEach(([h,m])=>{d[h]=m&&typeof m=="object"?R(m):m}),d}e.$vn=R;function s($){if(!$||typeof $!="object")return $;const d=[$];for(;d.length>0;){const h=d.shift();Object.freeze(h);for(const m in h)if(j.call(h,m)){const c=h[m];typeof c=="object"&&!Object.isFrozen(c)&&!(0,P.$Lf)(c)&&d.push(c)}}return $}e.$wn=s;const j=Object.prototype.hasOwnProperty;function D($,d){return S($,d,new Set)}e.$xn=D;function S($,d,h){if((0,P.$Rf)($))return $;const m=d($);if(typeof m<"u")return m;if(Array.isArray($)){const c=[];for(const t of $)c.push(S(t,d,h));return c}if((0,P.$Kf)($)){if(h.has($))throw new Error("Cannot clone recursive data-structure");h.add($);const c={};for(const t in $)j.call($,t)&&(c[t]=S($[t],d,h));return h.delete($),c}return $}function f($,d,h=!0){return(0,P.$Kf)($)?((0,P.$Kf)(d)&&Object.keys(d).forEach(m=>{m in $?h&&((0,P.$Kf)($[m])&&(0,P.$Kf)(d[m])?f($[m],d[m],h):$[m]=d[m]):$[m]=d[m]}),$):d}e.$yn=f;function l($,d){if($===d)return!0;if($==null||d===null||d===void 0||typeof $!=typeof d||typeof $!="object"||Array.isArray($)!==Array.isArray(d))return!1;let h,m;if(Array.isArray($)){if($.length!==d.length)return!1;for(h=0;h<$.length;h++)if(!l($[h],d[h]))return!1}else{const c=[];for(m in $)c.push(m);c.sort();const t=[];for(m in d)t.push(m);if(t.sort(),!l(c,t))return!1;for(h=0;h<c.length;h++)if(!l($[c[h]],d[c[h]]))return!1}return!0}e.$zn=l;function p($){const d=new Set;return JSON.stringify($,(h,m)=>{if((0,P.$Kf)(m)||Array.isArray(m)){if(d.has(m))return"[Circular]";d.add(m)}return m})}e.$An=p;function k($,d){const h=Object.create(null);return!$||!d||Object.keys(d).forEach(c=>{const t=$[c],o=d[c];l(t,o)||(h[c]=o)}),h}e.$Bn=k;function v($,d){const h=d.toLowerCase(),m=Object.keys($).find(c=>c.toLowerCase()===h);return m?$[m]:$[d]}e.$Cn=v;function u($,d){const h=Object.create(null);for(const[m,c]of Object.entries($))d(m,c)&&(h[m]=c);return h}e.$Dn=u;function y($){let d=[];for(;Object.prototype!==$;)d=d.concat(Object.getOwnPropertyNames($)),$=Object.getPrototypeOf($);return d}e.$En=y;function w($){const d=[];for(const h of y($))typeof $[h]=="function"&&d.push(h);return d}e.$Fn=w;function g($,d){const h=c=>function(){const t=Array.prototype.slice.call(arguments,0);return d(c,t)},m={};for(const c of $)m[c]=h(c);return m}e.$Gn=g}),define(oe[103],ae([0,1,75]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var R;(function(D){function S(f){return f&&typeof f=="object"&&typeof f.id=="string"}D.isThemeColor=S})(R||(e.ThemeColor=R={}));function s(D){return{id:D}}e.$ak=s;var j;(function(D){D.iconNameSegment="[A-Za-z0-9]+",D.iconNameExpression="[A-Za-z0-9-]+",D.iconModifierExpression="~[A-Za-z]+",D.iconNameCharacter="[A-Za-z0-9~-]";const S=new RegExp(`^(${D.iconNameExpression})(${D.iconModifierExpression})?$`);function f(d){const h=S.exec(d.id);if(!h)return f(P.$_j.error);const[,m,c]=h,t=["codicon","codicon-"+m];return c&&t.push("codicon-modifier-"+c.substring(1)),t}D.asClassNameArray=f;function l(d){return f(d).join(" ")}D.asClassName=l;function p(d){return"."+f(d).join(".")}D.asCSSSelector=p;function k(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||R.isThemeColor(d.color))}D.isThemeIcon=k;const v=new RegExp(`^\\$\\((${D.iconNameExpression}(?:${D.iconModifierExpression})?)\\)$`);function u(d){const h=v.exec(d);if(!h)return;const[,m]=h;return{id:m}}D.fromString=u;function y(d){return{id:d}}D.fromId=y;function w(d,h){let m=d.id;const c=m.lastIndexOf("~");return c!==-1&&(m=m.substring(0,c)),h&&(m=`${m}~${h}`),{id:m}}D.modify=w;function g(d){const h=d.id.lastIndexOf("~");if(h!==-1)return d.id.substring(h+1)}D.getModifier=g;function $(d,h){return d.id===h.id&&d.color?.id===h.color?.id}D.isEqual=$})(j||(e.ThemeIcon=j={}))}),define(oe[32],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const P=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(s){return P.test(s)}e.$pg=R,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(S){for(let f=0;f<S.length;f++)S[f]=Math.floor(Math.random()*256);return S};const j=new Uint8Array(16),D=[];for(let S=0;S<256;S++)D.push(S.toString(16).padStart(2,"0"));return function(){s(j),j[6]=j[6]&15|64,j[8]=j[8]&63|128;let f=0,l="";return l+=D[j[f++]],l+=D[j[f++]],l+=D[j[f++]],l+=D[j[f++]],l+="-",l+=D[j[f++]],l+=D[j[f++]],l+="-",l+=D[j[f++]],l+=D[j[f++]],l+="-",l+=D[j[f++]],l+=D[j[f++]],l+="-",l+=D[j[f++]],l+=D[j[f++]],l+=D[j[f++]],l+=D[j[f++]],l+=D[j[f++]],l+=D[j[f++]],l}}()}),define(oe[144],ae([0,1,86,46,84]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vU=void 0;async function j(D,S){if(await new Promise((p,k)=>{const v=R.createReadStream(D),u=P.createHash("sha256");v.pipe(u);const y=(0,s.$db)((w,g)=>{v.removeAllListeners(),u.removeAllListeners(),w?k(w):p(g)});v.once("error",y),v.once("end",y),u.once("error",y),u.once("data",w=>y(void 0,w.toString("hex")))})!==S)throw new Error("Hash mismatch")}e.$vU=j}),define(oe[145],ae([0,1,26]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0;const R=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(D){const S=D.replace(/\-/g,":").toLowerCase();return!R.has(S)}function j(){const D=(0,P.networkInterfaces)();for(const S in D){const f=D[S];if(f){for(const{mac:l}of f)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$9m=j}),define(oe[104],ae([0,1,87]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=e.$tg=e.$sg=void 0;function R(S,f,l,p=1){let k=!1;return new Promise(v=>{const u=setTimeout(()=>{if(!k)return k=!0,v(0)},l);s(S,f,p,y=>{if(!k)return k=!0,clearTimeout(u),v(y)})})}e.$sg=R;function s(S,f,l,p){if(f===0)return p(0);const k=new P.Socket;k.once("connect",()=>(D(k),s(S+l,f-1,l,p))),k.once("data",()=>{}),k.once("error",v=>(D(k),v.code!=="ECONNREFUSED"?s(S+l,f-1,l,p):p(S))),k.connect(S,"127.0.0.1")}e.$tg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function j(S,f,l,p="127.0.0.1"){let k=!1,v,u=1;const y=P.createServer({pauseOnConnect:!0});function w(g,$){k||(k=!0,y.removeAllListeners(),y.close(),v&&clearTimeout(v),$(g))}return new Promise(g=>{v=setTimeout(()=>{w(0,g)},l),y.on("listening",()=>{w(S,g)}),y.on("error",$=>{$&&($.code==="EADDRINUSE"||$.code==="EACCES")&&u<f?(S++,u++,y.listen(S,p)):w(0,g)}),y.on("close",()=>{w(0,g)}),y.listen(S,p)})}e.$ug=j;function D(S){try{S.removeAllListeners("connect"),S.removeAllListeners("error"),S.end(),S.destroy(),S.unref()}catch(f){console.error(f)}}}),function(){function X(){function e(){return process.uncHostAllowlist}function P(f){const l=new Set;if(Array.isArray(f))for(const p of f)typeof p=="string"&&l.add(p);return Array.from(l)}function R(){const f=e();return f?Array.from(f):[]}function s(f){if(process.platform!=="win32")return;const l=e();if(l)if(typeof f=="string")l.add(f.toLowerCase());else for(const p of P(f))s(p)}function j(f){if(typeof f!="string")return;const l=["\\\\.\\UNC\\","\\\\?\\UNC\\","\\\\"];let p;for(const k of l){if(f.indexOf(k)!==0)continue;const u=f.indexOf("\\",k.length);if(u===-1)continue;const y=f.substring(k.length,u);if(y){p=y;break}}return p}function D(){process.platform==="win32"&&(process.restrictUNCAccess=!1)}function S(){return process.platform!=="win32"?!0:process.restrictUNCAccess===!1}return{getUNCHostAllowlist:R,addUNCHostToAllowlist:s,getUNCHost:j,disableUNCAccessRestrictions:D,isUNCAccessRestrictionsDisabled:S}}typeof define=="function"?define("vs/base/node/unc",[],function(){return X()}):typeof module=="object"&&typeof module.exports=="object"?module.exports=X():console.trace("vs/base/node/unc defined in UNKNOWN context (neither requirejs or commonjs)")}(),define(oe[146],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zU=e.$yU=void 0,e.$yU="vscode:contextmenu",e.$zU="vscode:onCloseContextMenu"}),define(oe[147],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$GU=void 0;class P{constructor(s,j){this.a=s,this.onMessage=j}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.$GU=P}),define(oe[148],ae([11,10]),function(X,e){return X.create("vs/base/common/date",e)}),define(oe[149],ae([0,1,148]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const R=60,s=R*60,j=s*24,D=j*7,S=j*30,f=j*365;function l(k,v,u,y){typeof k!="number"&&(k=k.getTime());const w=Math.round((new Date().getTime()-k)/1e3);if(w<-30)return(0,P.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,P.localize)(1,null);let g;return w<R?(g=w,v?g===1?u?(0,P.localize)(2,null,g):(0,P.localize)(3,null,g):u?(0,P.localize)(4,null,g):(0,P.localize)(5,null,g):g===1?u?(0,P.localize)(6,null,g):(0,P.localize)(7,null,g):u?(0,P.localize)(8,null,g):(0,P.localize)(9,null,g)):w<s?(g=Math.floor(w/R),v?g===1?u?(0,P.localize)(10,null,g):(0,P.localize)(11,null,g):u?(0,P.localize)(12,null,g):(0,P.localize)(13,null,g):g===1?u?(0,P.localize)(14,null,g):(0,P.localize)(15,null,g):u?(0,P.localize)(16,null,g):(0,P.localize)(17,null,g)):w<j?(g=Math.floor(w/s),v?g===1?u?(0,P.localize)(18,null,g):(0,P.localize)(19,null,g):u?(0,P.localize)(20,null,g):(0,P.localize)(21,null,g):g===1?u?(0,P.localize)(22,null,g):(0,P.localize)(23,null,g):u?(0,P.localize)(24,null,g):(0,P.localize)(25,null,g)):w<D?(g=Math.floor(w/j),v?g===1?(0,P.localize)(26,null,g):(0,P.localize)(27,null,g):g===1?(0,P.localize)(28,null,g):(0,P.localize)(29,null,g)):w<S?(g=Math.floor(w/D),v?g===1?u?(0,P.localize)(30,null,g):(0,P.localize)(31,null,g):u?(0,P.localize)(32,null,g):(0,P.localize)(33,null,g):g===1?u?(0,P.localize)(34,null,g):(0,P.localize)(35,null,g):u?(0,P.localize)(36,null,g):(0,P.localize)(37,null,g)):w<f?(g=Math.floor(w/S),v?g===1?u?(0,P.localize)(38,null,g):(0,P.localize)(39,null,g):u?(0,P.localize)(40,null,g):(0,P.localize)(41,null,g):g===1?u?(0,P.localize)(42,null,g):(0,P.localize)(43,null,g):u?(0,P.localize)(44,null,g):(0,P.localize)(45,null,g)):(g=Math.floor(w/f),v?g===1?u?(0,P.localize)(46,null,g):(0,P.localize)(47,null,g):u?(0,P.localize)(48,null,g):(0,P.localize)(49,null,g):g===1?u?(0,P.localize)(50,null,g):(0,P.localize)(51,null,g):u?(0,P.localize)(52,null,g):(0,P.localize)(53,null,g))}e.$vm=l;function p(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=p}),define(oe[150],ae([11,10]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(oe[51],ae([0,1,22,12,150]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function j(k,v){return v&&(k.stack||k.stacktrace)?s.localize(0,null,S(k),D(k.stack)||D(k.stacktrace)):S(k)}function D(k){return Array.isArray(k)?k.join(`
`):k}function S(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?s.localize(1,null,k.message):k.message||s.localize(2,null)}function f(k=null,v=!1){if(!k)return s.localize(3,null);if(Array.isArray(k)){const u=P.$Hb(k),y=f(u[0],v);return u.length>1?s.localize(4,null,y,u.length):y}if(R.$If(k))return k;if(k.detail){const u=k.detail;if(u.error)return j(u.error,v);if(u.exception)return j(u.exception,v)}return k.stack?j(k,v):k.message?k.message:s.localize(5,null)}e.$Qi=f;function l(k){const v=k;return v instanceof Error&&Array.isArray(v.actions)}e.$Ri=l;function p(k,v){let u;return typeof k=="string"?u=new Error(k):u=k,u.actions=v,u}e.$Si=p}),define(oe[151],ae([11,10]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(oe[152],ae([0,1,151]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;function R(s){switch(s){case 1:return(0,P.localize)(0,null);case 2:return(0,P.localize)(1,null);case 3:return(0,P.localize)(2,null);case 4:return(0,P.localize)(3,null);case 5:return(0,P.localize)(4,null);case 6:return(0,P.localize)(5,null);case 7:return(0,P.localize)(6,null);case 8:return(0,P.localize)(7,null);case 9:return(0,P.localize)(8,null);default:return""}}e.$Xp=R}),define(oe[153],ae([11,10]),function(X,e){return X.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,153]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let R=!1,s=!1,j=!1,D=!1,S=!1,f=!1,l=!1,p=!1,k=!1,v=!1,u,y=e.$g,w=e.$g,g,$;const d=globalThis;let h;typeof d.vscode<"u"&&typeof d.vscode.process<"u"?h=d.vscode.process:typeof process<"u"&&(h=process);const m=typeof h?.versions?.electron=="string",c=m&&h?.type==="renderer";if(typeof h=="object"){R=h.platform==="win32",s=h.platform==="darwin",j=h.platform==="linux",D=j&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,l=m,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,u=e.$g,y=e.$g;const E=h.env.VSCODE_NLS_CONFIG;if(E)try{const A=JSON.parse(E),M=A.availableLanguages["*"];u=A.locale,w=A.osLocale,y=M||e.$g,g=A._translationsConfigFile}catch{}S=!0}else typeof navigator=="object"&&!c?($=navigator.userAgent,R=$.indexOf("Windows")>=0,s=$.indexOf("Macintosh")>=0,p=($.indexOf("Macintosh")>=0||$.indexOf("iPad")>=0||$.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,j=$.indexOf("Linux")>=0,v=$?.indexOf("Mobi")>=0,f=!0,u=P.getConfiguredDefaultLocale(P.localize(0,null))||e.$g,y=u,w=navigator.language):console.error("Unable to resolve platform.");var t;(function(E){E[E.Web=0]="Web",E[E.Mac=1]="Mac",E[E.Linux=2]="Linux",E[E.Windows=3]="Windows"})(t||(e.Platform=t={}));function o(E){switch(E){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let r=0;s?r=1:R?r=3:j&&(r=2),e.$i=R,e.$j=s,e.$k=j,e.$l=D,e.$m=S,e.$n=l,e.$o=f,e.$p=f&&typeof d.importScripts=="function",e.$q=e.$p?d.origin:void 0,e.$r=p,e.$s=v,e.$t=k,e.$u=r,e.$v=$,e.$w=y;var i;(function(E){function A(){return e.$w}E.value=A;function M(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}E.isDefaultVariant=M;function T(){return e.$w==="en"}E.isDefault=T})(i||(e.Language=i={})),e.$x=u,e.$y=w,e.$z=g,e.$A=typeof d.postMessage=="function"&&!d.importScripts,e.$B=(()=>{if(e.$A){const E=[];d.addEventListener("message",M=>{if(M.data&&M.data.vscodeScheduleAsyncWork)for(let T=0,W=E.length;T<W;T++){const G=E[T];if(G.id===M.data.vscodeScheduleAsyncWork){E.splice(T,1),G.callback();return}}});let A=0;return M=>{const T=++A;E.push({id:T,callback:M}),d.postMessage({vscodeScheduleAsyncWork:T},"*")}}return E=>setTimeout(E)})();var n;(function(E){E[E.Windows=1]="Windows",E[E.Macintosh=2]="Macintosh",E[E.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||p?2:R?1:3;let a=!0,b=!1;function C(){if(!b){b=!0;const E=new Uint8Array(2);E[0]=1,E[1]=2,a=new Uint16Array(E.buffer)[0]===(2<<8)+1}return a}e.$D=C,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function I(E){return parseFloat(E)>=20}e.$J=I}),define(oe[36],ae([0,1,4]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.process<"u"){const j=s.process;R={get platform(){return j.platform},get arch(){return j.arch},get env(){return j.env},cwd(){return j.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return P.$i?"win32":P.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.$dc=R.platform,e.$ec=R.arch}),define(oe[9],ae([0,1,36]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const R=65,s=97,j=90,D=122,S=46,f=47,l=92,p=58,k=63;class v extends Error{constructor(o,r,i){let n;typeof r=="string"&&r.indexOf("not ")===0?(n="must not be",r=r.replace(/^not /,"")):n="must be";const a=o.indexOf(".")!==-1?"property":"argument";let b=`The "${o}" ${a} ${n} of type ${r}`;b+=`. Received type ${typeof i}`,super(b),this.code="ERR_INVALID_ARG_TYPE"}}function u(t,o){if(t===null||typeof t!="object")throw new v(o,"Object",t)}function y(t,o){if(typeof t!="string")throw new v(o,"string",t)}const w=P.$dc==="win32";function g(t){return t===f||t===l}function $(t){return t===f}function d(t){return t>=R&&t<=j||t>=s&&t<=D}function h(t,o,r,i){let n="",a=0,b=-1,C=0,I=0;for(let E=0;E<=t.length;++E){if(E<t.length)I=t.charCodeAt(E);else{if(i(I))break;I=f}if(i(I)){if(!(b===E-1||C===1))if(C===2){if(n.length<2||a!==2||n.charCodeAt(n.length-1)!==S||n.charCodeAt(n.length-2)!==S){if(n.length>2){const A=n.lastIndexOf(r);A===-1?(n="",a=0):(n=n.slice(0,A),a=n.length-1-n.lastIndexOf(r)),b=E,C=0;continue}else if(n.length!==0){n="",a=0,b=E,C=0;continue}}o&&(n+=n.length>0?`${r}..`:"..",a=2)}else n.length>0?n+=`${r}${t.slice(b+1,E)}`:n=t.slice(b+1,E),a=E-b-1;b=E,C=0}else I===S&&C!==-1?++C:C=-1}return n}function m(t,o){u(o,"pathObject");const r=o.dir||o.root,i=o.base||`${o.name||""}${o.ext||""}`;return r?r===o.root?`${r}${i}`:`${r}${t}${i}`:i}e.$fc={resolve(...t){let o="",r="",i=!1;for(let n=t.length-1;n>=-1;n--){let a;if(n>=0){if(a=t[n],y(a,"path"),a.length===0)continue}else o.length===0?a=P.cwd():(a=P.env[`=${o}`]||P.cwd(),(a===void 0||a.slice(0,2).toLowerCase()!==o.toLowerCase()&&a.charCodeAt(2)===l)&&(a=`${o}\\`));const b=a.length;let C=0,I="",E=!1;const A=a.charCodeAt(0);if(b===1)g(A)&&(C=1,E=!0);else if(g(A))if(E=!0,g(a.charCodeAt(1))){let M=2,T=M;for(;M<b&&!g(a.charCodeAt(M));)M++;if(M<b&&M!==T){const W=a.slice(T,M);for(T=M;M<b&&g(a.charCodeAt(M));)M++;if(M<b&&M!==T){for(T=M;M<b&&!g(a.charCodeAt(M));)M++;(M===b||M!==T)&&(I=`\\\\${W}\\${a.slice(T,M)}`,C=M)}}}else C=1;else d(A)&&a.charCodeAt(1)===p&&(I=a.slice(0,2),C=2,b>2&&g(a.charCodeAt(2))&&(E=!0,C=3));if(I.length>0)if(o.length>0){if(I.toLowerCase()!==o.toLowerCase())continue}else o=I;if(i){if(o.length>0)break}else if(r=`${a.slice(C)}\\${r}`,i=E,E&&o.length>0)break}return r=h(r,!i,"\\",g),i?`${o}\\${r}`:`${o}${r}`||"."},normalize(t){y(t,"path");const o=t.length;if(o===0)return".";let r=0,i,n=!1;const a=t.charCodeAt(0);if(o===1)return $(a)?"\\":t;if(g(a))if(n=!0,g(t.charCodeAt(1))){let C=2,I=C;for(;C<o&&!g(t.charCodeAt(C));)C++;if(C<o&&C!==I){const E=t.slice(I,C);for(I=C;C<o&&g(t.charCodeAt(C));)C++;if(C<o&&C!==I){for(I=C;C<o&&!g(t.charCodeAt(C));)C++;if(C===o)return`\\\\${E}\\${t.slice(I)}\\`;C!==I&&(i=`\\\\${E}\\${t.slice(I,C)}`,r=C)}}}else r=1;else d(a)&&t.charCodeAt(1)===p&&(i=t.slice(0,2),r=2,o>2&&g(t.charCodeAt(2))&&(n=!0,r=3));let b=r<o?h(t.slice(r),!n,"\\",g):"";return b.length===0&&!n&&(b="."),b.length>0&&g(t.charCodeAt(o-1))&&(b+="\\"),i===void 0?n?`\\${b}`:b:n?`${i}\\${b}`:`${i}${b}`},isAbsolute(t){y(t,"path");const o=t.length;if(o===0)return!1;const r=t.charCodeAt(0);return g(r)||o>2&&d(r)&&t.charCodeAt(1)===p&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let o,r;for(let a=0;a<t.length;++a){const b=t[a];y(b,"path"),b.length>0&&(o===void 0?o=r=b:o+=`\\${b}`)}if(o===void 0)return".";let i=!0,n=0;if(typeof r=="string"&&g(r.charCodeAt(0))){++n;const a=r.length;a>1&&g(r.charCodeAt(1))&&(++n,a>2&&(g(r.charCodeAt(2))?++n:i=!1))}if(i){for(;n<o.length&&g(o.charCodeAt(n));)n++;n>=2&&(o=`\\${o.slice(n)}`)}return e.$fc.normalize(o)},relative(t,o){if(y(t,"from"),y(o,"to"),t===o)return"";const r=e.$fc.resolve(t),i=e.$fc.resolve(o);if(r===i||(t=r.toLowerCase(),o=i.toLowerCase(),t===o))return"";let n=0;for(;n<t.length&&t.charCodeAt(n)===l;)n++;let a=t.length;for(;a-1>n&&t.charCodeAt(a-1)===l;)a--;const b=a-n;let C=0;for(;C<o.length&&o.charCodeAt(C)===l;)C++;let I=o.length;for(;I-1>C&&o.charCodeAt(I-1)===l;)I--;const E=I-C,A=b<E?b:E;let M=-1,T=0;for(;T<A;T++){const G=t.charCodeAt(n+T);if(G!==o.charCodeAt(C+T))break;G===l&&(M=T)}if(T!==A){if(M===-1)return i}else{if(E>A){if(o.charCodeAt(C+T)===l)return i.slice(C+T+1);if(T===2)return i.slice(C+T)}b>A&&(t.charCodeAt(n+T)===l?M=T:T===2&&(M=3)),M===-1&&(M=0)}let W="";for(T=n+M+1;T<=a;++T)(T===a||t.charCodeAt(T)===l)&&(W+=W.length===0?"..":"\\..");return C+=M,W.length>0?`${W}${i.slice(C,I)}`:(i.charCodeAt(C)===l&&++C,i.slice(C,I))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const o=e.$fc.resolve(t);if(o.length<=2)return t;if(o.charCodeAt(0)===l){if(o.charCodeAt(1)===l){const r=o.charCodeAt(2);if(r!==k&&r!==S)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(d(o.charCodeAt(0))&&o.charCodeAt(1)===p&&o.charCodeAt(2)===l)return`\\\\?\\${o}`;return t},dirname(t){y(t,"path");const o=t.length;if(o===0)return".";let r=-1,i=0;const n=t.charCodeAt(0);if(o===1)return g(n)?t:".";if(g(n)){if(r=i=1,g(t.charCodeAt(1))){let C=2,I=C;for(;C<o&&!g(t.charCodeAt(C));)C++;if(C<o&&C!==I){for(I=C;C<o&&g(t.charCodeAt(C));)C++;if(C<o&&C!==I){for(I=C;C<o&&!g(t.charCodeAt(C));)C++;if(C===o)return t;C!==I&&(r=i=C+1)}}}}else d(n)&&t.charCodeAt(1)===p&&(r=o>2&&g(t.charCodeAt(2))?3:2,i=r);let a=-1,b=!0;for(let C=o-1;C>=i;--C)if(g(t.charCodeAt(C))){if(!b){a=C;break}}else b=!1;if(a===-1){if(r===-1)return".";a=r}return t.slice(0,a)},basename(t,o){o!==void 0&&y(o,"ext"),y(t,"path");let r=0,i=-1,n=!0,a;if(t.length>=2&&d(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(r=2),o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,C=-1;for(a=t.length-1;a>=r;--a){const I=t.charCodeAt(a);if(g(I)){if(!n){r=a+1;break}}else C===-1&&(n=!1,C=a+1),b>=0&&(I===o.charCodeAt(b)?--b===-1&&(i=a):(b=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=r;--a)if(g(t.charCodeAt(a))){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let o=0,r=-1,i=0,n=-1,a=!0,b=0;t.length>=2&&t.charCodeAt(1)===p&&d(t.charCodeAt(0))&&(o=i=2);for(let C=t.length-1;C>=o;--C){const I=t.charCodeAt(C);if(g(I)){if(!a){i=C+1;break}continue}n===-1&&(a=!1,n=C+1),I===S?r===-1?r=C:b!==1&&(b=1):r!==-1&&(b=-1)}return r===-1||n===-1||b===0||b===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:m.bind(null,"\\"),parse(t){y(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.length;let i=0,n=t.charCodeAt(0);if(r===1)return g(n)?(o.root=o.dir=t,o):(o.base=o.name=t,o);if(g(n)){if(i=1,g(t.charCodeAt(1))){let M=2,T=M;for(;M<r&&!g(t.charCodeAt(M));)M++;if(M<r&&M!==T){for(T=M;M<r&&g(t.charCodeAt(M));)M++;if(M<r&&M!==T){for(T=M;M<r&&!g(t.charCodeAt(M));)M++;M===r?i=M:M!==T&&(i=M+1)}}}}else if(d(n)&&t.charCodeAt(1)===p){if(r<=2)return o.root=o.dir=t,o;if(i=2,g(t.charCodeAt(2))){if(r===3)return o.root=o.dir=t,o;i=3}}i>0&&(o.root=t.slice(0,i));let a=-1,b=i,C=-1,I=!0,E=t.length-1,A=0;for(;E>=i;--E){if(n=t.charCodeAt(E),g(n)){if(!I){b=E+1;break}continue}C===-1&&(I=!1,C=E+1),n===S?a===-1?a=E:A!==1&&(A=1):a!==-1&&(A=-1)}return C!==-1&&(a===-1||A===0||A===1&&a===C-1&&a===b+1?o.base=o.name=t.slice(b,C):(o.name=t.slice(b,a),o.base=t.slice(b,C),o.ext=t.slice(a,C))),b>0&&b!==i?o.dir=t.slice(0,b-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const c=(()=>{if(w){const t=/\\/g;return()=>{const o=P.cwd().replace(t,"/");return o.slice(o.indexOf("/"))}}return()=>P.cwd()})();e.$gc={resolve(...t){let o="",r=!1;for(let i=t.length-1;i>=-1&&!r;i--){const n=i>=0?t[i]:c();y(n,"path"),n.length!==0&&(o=`${n}/${o}`,r=n.charCodeAt(0)===f)}return o=h(o,!r,"/",$),r?`/${o}`:o.length>0?o:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f,r=t.charCodeAt(t.length-1)===f;return t=h(t,!o,"/",$),t.length===0?o?"/":r?"./":".":(r&&(t+="/"),o?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===f},join(...t){if(t.length===0)return".";let o;for(let r=0;r<t.length;++r){const i=t[r];y(i,"path"),i.length>0&&(o===void 0?o=i:o+=`/${i}`)}return o===void 0?".":e.$gc.normalize(o)},relative(t,o){if(y(t,"from"),y(o,"to"),t===o||(t=e.$gc.resolve(t),o=e.$gc.resolve(o),t===o))return"";const r=1,i=t.length,n=i-r,a=1,b=o.length-a,C=n<b?n:b;let I=-1,E=0;for(;E<C;E++){const M=t.charCodeAt(r+E);if(M!==o.charCodeAt(a+E))break;M===f&&(I=E)}if(E===C)if(b>C){if(o.charCodeAt(a+E)===f)return o.slice(a+E+1);if(E===0)return o.slice(a+E)}else n>C&&(t.charCodeAt(r+E)===f?I=E:E===0&&(I=0));let A="";for(E=r+I+1;E<=i;++E)(E===i||t.charCodeAt(E)===f)&&(A+=A.length===0?"..":"/..");return`${A}${o.slice(a+I)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const o=t.charCodeAt(0)===f;let r=-1,i=!0;for(let n=t.length-1;n>=1;--n)if(t.charCodeAt(n)===f){if(!i){r=n;break}}else i=!1;return r===-1?o?"/":".":o&&r===1?"//":t.slice(0,r)},basename(t,o){o!==void 0&&y(o,"ext"),y(t,"path");let r=0,i=-1,n=!0,a;if(o!==void 0&&o.length>0&&o.length<=t.length){if(o===t)return"";let b=o.length-1,C=-1;for(a=t.length-1;a>=0;--a){const I=t.charCodeAt(a);if(I===f){if(!n){r=a+1;break}}else C===-1&&(n=!1,C=a+1),b>=0&&(I===o.charCodeAt(b)?--b===-1&&(i=a):(b=-1,i=C))}return r===i?i=C:i===-1&&(i=t.length),t.slice(r,i)}for(a=t.length-1;a>=0;--a)if(t.charCodeAt(a)===f){if(!n){r=a+1;break}}else i===-1&&(n=!1,i=a+1);return i===-1?"":t.slice(r,i)},extname(t){y(t,"path");let o=-1,r=0,i=-1,n=!0,a=0;for(let b=t.length-1;b>=0;--b){const C=t.charCodeAt(b);if(C===f){if(!n){r=b+1;break}continue}i===-1&&(n=!1,i=b+1),C===S?o===-1?o=b:a!==1&&(a=1):o!==-1&&(a=-1)}return o===-1||i===-1||a===0||a===1&&o===i-1&&o===r+1?"":t.slice(o,i)},format:m.bind(null,"/"),parse(t){y(t,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return o;const r=t.charCodeAt(0)===f;let i;r?(o.root="/",i=1):i=0;let n=-1,a=0,b=-1,C=!0,I=t.length-1,E=0;for(;I>=i;--I){const A=t.charCodeAt(I);if(A===f){if(!C){a=I+1;break}continue}b===-1&&(C=!1,b=I+1),A===S?n===-1?n=I:E!==1&&(E=1):n!==-1&&(E=-1)}if(b!==-1){const A=a===0&&r?1:a;n===-1||E===0||E===1&&n===b-1&&n===a+1?o.base=o.name=t.slice(A,b):(o.name=t.slice(A,n),o.base=t.slice(A,b),o.ext=t.slice(n,b))}return a>0?o.dir=t.slice(0,a-1):r&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=w?e.$fc.normalize:e.$gc.normalize,e.$ic=w?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=w?e.$fc.join:e.$gc.join,e.$kc=w?e.$fc.resolve:e.$gc.resolve,e.$lc=w?e.$fc.relative:e.$gc.relative,e.$mc=w?e.$fc.dirname:e.$gc.dirname,e.$nc=w?e.$fc.basename:e.$gc.basename,e.$oc=w?e.$fc.extname:e.$gc.extname,e.$pc=w?e.$fc.format:e.$gc.format,e.$qc=w?e.$fc.parse:e.$gc.parse,e.$rc=w?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=w?e.$fc.sep:e.$gc.sep,e.$tc=w?e.$fc.delimiter:e.$gc.delimiter}),define(oe[33],ae([0,1,9,4,25,12]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function D(a){return a===47||a===92}e.$1f=D;function S(a){return a.replace(/[\\/]/g,P.$gc.sep)}e.$2f=S;function f(a){return a.indexOf("/")===-1&&(a=S(a)),/^[a-zA-Z]:(\/|$)/.test(a)&&(a="/"+a),a}e.$3f=f;function l(a,b=P.$gc.sep){if(!a)return"";const C=a.length,I=a.charCodeAt(0);if(D(I)){if(D(a.charCodeAt(1))&&!D(a.charCodeAt(2))){let A=3;const M=A;for(;A<C&&!D(a.charCodeAt(A));A++);if(M!==A&&!D(a.charCodeAt(A+1))){for(A+=1;A<C;A++)if(D(a.charCodeAt(A)))return a.slice(0,A+1).replace(/[\\/]/g,b)}}return b}else if($(I)&&a.charCodeAt(1)===58)return D(a.charCodeAt(2))?a.slice(0,2)+b:a.slice(0,2);let E=a.indexOf("://");if(E!==-1){for(E+=3;E<C;E++)if(D(a.charCodeAt(E)))return a.slice(0,E+1)}return""}e.$4f=l;function p(a){if(!R.$i||!a||a.length<5)return!1;let b=a.charCodeAt(0);if(b!==92||(b=a.charCodeAt(1),b!==92))return!1;let C=2;const I=C;for(;C<a.length&&(b=a.charCodeAt(C),b!==92);C++);return!(I===C||(b=a.charCodeAt(C+1),isNaN(b)||b===92))}e.$5f=p;const k=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,u=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(a,b=R.$i){const C=b?k:v;return!(!a||a.length===0||/^\s+$/.test(a)||(C.lastIndex=0,C.test(a))||b&&u.test(a)||a==="."||a===".."||b&&a[a.length-1]==="."||b&&a.length!==a.trim().length||a.length>255)}e.$6f=y;function w(a,b,C){const I=a===b;return!C||I?I:!a||!b?!1:(0,s.$_e)(a,b)}e.$7f=w;function g(a,b,C,I=P.sep){if(a===b)return!0;if(!a||!b||b.length>a.length)return!1;if(C){if(!(0,s.$af)(a,b))return!1;if(b.length===a.length)return!0;let A=b.length;return b.charAt(b.length-1)===I&&A--,a.charAt(A)===I}return b.charAt(b.length-1)!==I&&(b+=I),a.indexOf(b)===0}e.$8f=g;function $(a){return a>=65&&a<=90||a>=97&&a<=122}e.$9f=$;function d(a,b){return R.$i&&a.endsWith(":")&&(a+=P.sep),(0,P.$ic)(a)||(a=(0,P.$jc)(b,a)),a=(0,P.$hc)(a),R.$i?(a=(0,s.$Ue)(a,P.sep),a.endsWith(":")&&(a+=P.sep)):(a=(0,s.$Ue)(a,P.sep),a||(a=P.sep)),a}e.$0f=d;function h(a){const b=(0,P.$hc)(a);return R.$i?a.length>3?!1:m(b)&&(a.length===2||b.charCodeAt(2)===92):b===P.$gc.sep}e.$$f=h;function m(a,b=R.$i){return b?$(a.charCodeAt(0))&&a.charCodeAt(1)===58:!1}e.$_f=m;function c(a,b=R.$i){return m(a,b)?a[0]:void 0}e.$ag=c;function t(a,b,C){return b.length>a.length?-1:a===b?0:(C&&(a=a.toLowerCase(),b=b.toLowerCase()),a.indexOf(b))}e.$bg=t;function o(a){const b=a.split(":");let C,I,E;for(const A of b){const M=Number(A);(0,j.$Mf)(M)?I===void 0?I=M:E===void 0&&(E=M):C=C?[C,A].join(":"):A}if(!C)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:C,line:I!==void 0?I:void 0,column:E!==void 0?E:I!==void 0?1:void 0}}e.$cg=o;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function n(a,b,C=8){let I="";for(let A=0;A<C;A++){let M;A===0&&R.$i&&!b&&(C===3||C===4)?M=i:M=r,I+=M.charAt(Math.floor(Math.random()*M.length))}let E;return b?E=`${b}-${I}`:E=I,a?(0,P.$jc)(a,E):E}e.$dg=n}),define(oe[76],ae([0,1,4]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var R;(function(S){S[S.stdout=0]="stdout",S[S.stderr=1]="stderr"})(R||(e.Source=R={}));var s;(function(S){S[S.Success=0]="Success",S[S.Unknown=1]="Unknown",S[S.AccessDenied=2]="AccessDenied",S[S.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function j(S,...f){const l=f.reduce((v,u)=>(v[u]=!0,v),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(S).filter(v=>!l[v]).forEach(v=>{for(let u=0;u<p.length;u++)if(v.search(p[u])!==-1){delete S[v];break}})}e.$Rl=j;function D(S){S&&(delete S.DEBUG,P.$j&&delete S.DYLD_LIBRARY_PATH,P.$k&&delete S.LD_PRELOAD)}e.$Sl=D}),define(oe[7],ae([0,1,9,4]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,j=/^\//,D=/^\/\//;function S(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!j.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(D.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function f(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==k&&(n=k+n):n=k;break}return n}const p="",k="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{static isUri(n){return n instanceof u?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,a,b,C,I,E=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=f(n,E),this.authority=a||p,this.path=l(this.scheme,b||p),this.query=C||p,this.fragment=I||p,S(this,E))}get fsPath(){return m(this,!1)}with(n){if(!n)return this;let{scheme:a,authority:b,path:C,query:I,fragment:E}=n;return a===void 0?a=this.scheme:a===null&&(a=p),b===void 0?b=this.authority:b===null&&(b=p),C===void 0?C=this.path:C===null&&(C=p),I===void 0?I=this.query:I===null&&(I=p),E===void 0?E=this.fragment:E===null&&(E=p),a===this.scheme&&b===this.authority&&C===this.path&&I===this.query&&E===this.fragment?this:new g(a,b,C,I,E)}static parse(n,a=!1){const b=v.exec(n);return b?new g(b[2]||p,r(b[4]||p),r(b[5]||p),r(b[7]||p),r(b[9]||p),a):new g(p,p,p,p,p)}static file(n){let a=p;if(R.$i&&(n=n.replace(/\\/g,k)),n[0]===k&&n[1]===k){const b=n.indexOf(k,2);b===-1?(a=n.substring(2),n=k):(a=n.substring(2,b),n=n.substring(b)||k)}return new g("file",a,n,p,p)}static from(n,a){return new g(n.scheme,n.authority,n.path,n.query,n.fragment,a)}static joinPath(n,...a){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let b;return R.$i&&n.scheme==="file"?b=u.file(P.$fc.join(m(n,!0),...a)).path:b=P.$gc.join(n.path,...a),n.with({path:b})}toString(n=!1){return c(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof u)return n;{const a=new g(n);return a._formatted=n.external??null,a._fsPath=n._sep===w?n.fsPath??null:null,a}}else return n}}e.URI=u;function y(i){return!i||typeof i!="object"?!1:typeof i.scheme=="string"&&(typeof i.authority=="string"||typeof i.authority>"u")&&(typeof i.path=="string"||typeof i.path>"u")&&(typeof i.query=="string"||typeof i.query>"u")&&(typeof i.fragment=="string"||typeof i.fragment>"u")}e.$vc=y;const w=R.$i?1:void 0;class g extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=m(this,!1)),this._fsPath}toString(n=!1){return n?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=w),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const $={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(i,n,a){let b,C=-1;for(let I=0;I<i.length;I++){const E=i.charCodeAt(I);if(E>=97&&E<=122||E>=65&&E<=90||E>=48&&E<=57||E===45||E===46||E===95||E===126||n&&E===47||a&&E===91||a&&E===93||a&&E===58)C!==-1&&(b+=encodeURIComponent(i.substring(C,I)),C=-1),b!==void 0&&(b+=i.charAt(I));else{b===void 0&&(b=i.substr(0,I));const A=$[E];A!==void 0?(C!==-1&&(b+=encodeURIComponent(i.substring(C,I)),C=-1),b+=A):C===-1&&(C=I)}}return C!==-1&&(b+=encodeURIComponent(i.substring(C))),b!==void 0?b:i}function h(i){let n;for(let a=0;a<i.length;a++){const b=i.charCodeAt(a);b===35||b===63?(n===void 0&&(n=i.substr(0,a)),n+=$[b]):n!==void 0&&(n+=i[a])}return n!==void 0?n:i}function m(i,n){let a;return i.authority&&i.path.length>1&&i.scheme==="file"?a=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?a=i.path.substr(1):a=i.path[1].toLowerCase()+i.path.substr(2):a=i.path,R.$i&&(a=a.replace(/\//g,"\\")),a}e.$wc=m;function c(i,n){const a=n?h:d;let b="",{scheme:C,authority:I,path:E,query:A,fragment:M}=i;if(C&&(b+=C,b+=":"),(I||C==="file")&&(b+=k,b+=k),I){let T=I.indexOf("@");if(T!==-1){const W=I.substr(0,T);I=I.substr(T+1),T=W.lastIndexOf(":"),T===-1?b+=a(W,!1,!1):(b+=a(W.substr(0,T),!1,!1),b+=":",b+=a(W.substr(T+1),!1,!0)),b+="@"}I=I.toLowerCase(),T=I.lastIndexOf(":"),T===-1?b+=a(I,!1,!0):(b+=a(I.substr(0,T),!1,!0),b+=I.substr(T))}if(E){if(E.length>=3&&E.charCodeAt(0)===47&&E.charCodeAt(2)===58){const T=E.charCodeAt(1);T>=65&&T<=90&&(E=`/${String.fromCharCode(T+32)}:${E.substr(3)}`)}else if(E.length>=2&&E.charCodeAt(1)===58){const T=E.charCodeAt(0);T>=65&&T<=90&&(E=`${String.fromCharCode(T+32)}:${E.substr(2)}`)}b+=a(E,!0,!1)}return A&&(b+="?",b+=a(A,!1,!1)),M&&(b+="#",b+=n?M:d(M,!1,!1)),b}function t(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+t(i.substr(3)):i}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(o)?i.replace(o,n=>t(n)):i}}),define(oe[154],ae([0,1,7]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function R(l){const p=l;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.$mq=R;function s(l){const p=[];let k;try{const v=JSON.parse(l.arguments),u=v[v.length-1];u&&u.__$stack&&(v.pop(),k=u.__$stack),p.push(...v)}catch{p.push("Unable to log remote console arguments",l.arguments)}return{args:p,stack:k}}e.$nq=s;function j(l){if(typeof l!="string")return j(s(l).stack);const p=l;if(p){const k=D(p),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(v&&v.length===4)return{uri:P.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.$oq=j;function D(l){if(!l)return l;const p=l.indexOf(`
`);return p===-1?l:l.substring(0,p)}function S(l,p){const{args:k,stack:v}=s(l),u=typeof k[0]=="string"&&k.length===1;let y=D(v);y&&(y=`(${y.trim()})`);let w=[];if(typeof k[0]=="string"?y&&u?w=[`%c[${p}] %c${k[0]} %c${y}`,f("blue"),f(""),f("grey")]:w=[`%c[${p}] %c${k[0]}`,f("blue"),f(""),...k.slice(1)]:w=[`%c[${p}]%`,f("blue"),...k],y&&!u&&w.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,w)}e.log=S;function f(l){return`color: ${l}`}}),define(oe[77],ae([0,1,17,7]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function s(f){return JSON.stringify(f,D)}e.$Ah=s;function j(f){let l=JSON.parse(f);return l=S(l),l}e.$Bh=j;function D(f,l){return l instanceof RegExp?{$mid:2,source:l.source,flags:l.flags}:l}function S(f,l=0){if(!f||l>200)return f;if(typeof f=="object"){switch(f.$mid){case 1:return R.URI.revive(f);case 2:return new RegExp(f.source,f.flags);case 17:return new Date(f.source)}if(f instanceof P.$je||f instanceof Uint8Array)return f;if(Array.isArray(f))for(let p=0;p<f.length;++p)f[p]=S(f[p],l+1);else for(const p in f)Object.hasOwnProperty.call(f,p)&&(f[p]=S(f[p],l+1))}return f}e.$Ch=S}),define(oe[13],ae([0,1,14,4,25,7]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var D;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeManagedRemoteResource="vscode-managed-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeChatSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(D||(e.Schemas=D={}));function S(v,u){return j.URI.isUri(v)?(0,s.$_e)(v.scheme,u):(0,s.$af)(v,u+":")}e.$eg=S;function f(v,...u){return u.some(y=>S(v,y))}e.$fg=f,e.$gg="vscode-tkn",e.$hg="tkn";class l{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${D.vscodeRemoteResource}`}setPreferredWebSchema(u){this.d=u}setDelegate(u){this.e=u}setServerRootPath(u){this.f=`${u}/${D.vscodeRemoteResource}`}set(u,y,w){this.a[u]=y,this.b[u]=w}setConnectionToken(u,y){this.c[u]=y}getPreferredWebSchema(){return this.d}rewrite(u){if(this.e)try{return this.e(u)}catch(h){return P.$1(h),u}const y=u.authority;let w=this.a[y];w&&w.indexOf(":")!==-1&&w.indexOf("[")===-1&&(w=`[${w}]`);const g=this.b[y],$=this.c[y];let d=`path=${encodeURIComponent(u.path)}`;return typeof $=="string"&&(d+=`&${e.$hg}=${encodeURIComponent($)}`),j.URI.from({scheme:R.$o?this.d:D.vscodeRemoteResource,authority:`${w}:${g}`,path:this.f,query:d})}}e.$ig=new l,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class p{static{this.a=e.$ng}asBrowserUri(u){const y=this.b(u,X);return this.uriToBrowserUri(y)}uriToBrowserUri(u){return u.scheme===D.vscodeRemote?e.$ig.rewrite(u):u.scheme===D.file&&(R.$m||R.$q===`${D.vscodeFileResource}://${p.a}`)?u.with({scheme:D.vscodeFileResource,authority:u.authority||p.a,query:null,fragment:null}):u}asFileUri(u){const y=this.b(u,X);return this.uriToFileUri(y)}uriToFileUri(u){return u.scheme===D.vscodeFileResource?u.with({scheme:D.file,authority:u.authority!==p.a?u.authority:null,query:null,fragment:null}):u}b(u,y){return j.URI.isUri(u)?u:j.URI.parse(y.toUrl(u))}}e.$og=new p;var k;(function(v){const u=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(u.get("3"));const y="vscode-coi";function w($){let d;typeof $=="string"?d=new URL($).searchParams:$ instanceof URL?d=$.searchParams:j.URI.isUri($)&&(d=new URL($.toString(!0)).searchParams);const h=d?.get(y);if(h)return u.get(h)}v.getHeadersFromQuery=w;function g($,d,h){if(!globalThis.crossOriginIsolated)return;const m=d&&h?"3":h?"2":"1";$ instanceof URLSearchParams?$.set(y,m):$[y]=m}v.addSearchParam=g})(k||(e.COI=k={}))}),define(oe[19],ae([0,1,33,13,9,4,25,7]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function f(u){return(0,S.$wc)(u,!0)}e.$vg=f;class l{constructor(y){this.a=y}compare(y,w,g=!1){return y===w?0:(0,D.$5e)(this.getComparisonKey(y,g),this.getComparisonKey(w,g))}isEqual(y,w,g=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,g)===this.getComparisonKey(w,g)}getComparisonKey(y,w=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,w,g=!1){if(y.scheme===w.scheme){if(y.scheme===R.Schemas.file)return P.$8f(f(y),f(w),this.a(y))&&y.query===w.query&&(g||y.fragment===w.fragment);if((0,e.$Mg)(y.authority,w.authority))return P.$8f(y.path,w.path,this.a(y),"/")&&y.query===w.query&&(g||y.fragment===w.fragment)}return!1}joinPath(y,...w){return S.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.$Eg)(y)||y.authority}basename(y){return s.$gc.basename(y.path)}extname(y){return s.$gc.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===R.Schemas.file?w=S.URI.file(s.$mc(f(y))).path:(w=s.$gc.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===R.Schemas.file?w=S.URI.file(s.$hc(f(y))).path:w=s.$gc.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.$Mg)(y.authority,w.authority))return;if(y.scheme===R.Schemas.file){const d=s.$lc(f(y),f(w));return j.$i?P.$2f(d):d}let g=y.path||"/";const $=w.path||"/";if(this.a(y)){let d=0;for(const h=Math.min(g.length,$.length);d<h&&!(g.charCodeAt(d)!==$.charCodeAt(d)&&g.charAt(d).toLowerCase()!==$.charAt(d).toLowerCase());d++);g=$.substr(0,d)+g.substr(d)}return s.$gc.relative(g,$)}resolvePath(y,w){if(y.scheme===R.Schemas.file){const g=S.URI.file(s.$kc(f(y),w));return y.with({authority:g.authority,path:g.path})}return w=P.$3f(w),y.with({path:s.$gc.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,D.$_e)(y,w)}hasTrailingPathSeparator(y,w=s.sep){if(y.scheme===R.Schemas.file){const g=f(y);return g.length>P.$4f(g).length&&g[g.length-1]===w}else{const g=y.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=s.sep){return(0,e.$Ng)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=s.sep){let g=!1;if(y.scheme===R.Schemas.file){const $=f(y);g=$!==void 0&&$.length===P.$4f($).length&&$[$.length-1]===w}else{w="/";const $=y.path;g=$.length===1&&$.charCodeAt($.length-1)===47}return!g&&!(0,e.$Ng)(y,w)?y.with({path:y.path+"/"}):y}}e.$wg=l,e.$xg=new l(()=>!1),e.$yg=new l(u=>u.scheme===R.Schemas.file?!j.$k:!0),e.$zg=new l(u=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function p(u,y){const w=[];for(let g=0;g<u.length;g++){const $=y(u[g]);u.some((d,h)=>h===g?!1:(0,e.$Bg)($,y(d)))||w.push(u[g])}return w}e.$Qg=p;var k;(function(u){u.META_DATA_LABEL="label",u.META_DATA_DESCRIPTION="description",u.META_DATA_SIZE="size",u.META_DATA_MIME="mime";function y(w){const g=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(h=>{const[m,c]=h.split(":");m&&c&&g.set(m,c)});const d=w.path.substring(0,w.path.indexOf(";"));return d&&g.set(u.META_DATA_MIME,d),g}u.parseMetaData=y})(k||(e.DataUri=k={}));function v(u,y,w){if(y){let g=u.path;return g&&g[0]!==s.$gc.sep&&(g=s.$gc.sep+g),u.with({scheme:w,authority:y,path:g})}return u.with({scheme:w})}e.$Rg=v}),define(oe[8],ae([0,1,23,14,3,2,19,4,143,62]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function p(N){return!!N&&typeof N.then=="function"}e.$Sg=p;function k(N){const B=new P.$6d,Q=N(B.token),se=new Promise((le,ge)=>{const be=B.token.onCancellationRequested(()=>{be.dispose(),ge(new R.$5)});Promise.resolve(Q).then(Se=>{be.dispose(),B.dispose(),le(Se)},Se=>{be.dispose(),B.dispose(),ge(Se)})});return new class{cancel(){B.cancel(),B.dispose()}then(le,ge){return se.then(le,ge)}catch(le){return this.then(void 0,le)}finally(le){return se.finally(le)}}}e.$Tg=k;function v(N,B,Q){return new Promise((se,le)=>{const ge=B.onCancellationRequested(()=>{ge.dispose(),se(Q)});N.then(se,le).finally(()=>ge.dispose())})}e.$Ug=v;function u(N,B){return new Promise((Q,se)=>{const le=B.onCancellationRequested(()=>{le.dispose(),se(new R.$5)});N.then(Q,se).finally(()=>le.dispose())})}e.$Vg=u;async function y(N){let B=-1;const Q=N.map((se,le)=>se.then(ge=>(B=le,ge)));try{return await Promise.race(Q)}finally{N.forEach((se,le)=>{le!==B&&se.cancel()})}}e.$Wg=y;function w(N,B,Q){let se;const le=setTimeout(()=>{se?.(void 0),Q?.()},B);return Promise.race([N.finally(()=>clearTimeout(le)),new Promise(ge=>se=ge)])}e.$Xg=w;function g(N){return new Promise((B,Q)=>{const se=N();p(se)?se.then(B,Q):B(se)})}e.$Yg=g;class ${constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(B){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=B,!this.b){const Q=()=>{if(this.b=null,this.f)return;const se=this.queue(this.d);return this.d=null,se};this.b=new Promise(se=>{this.a.then(Q,Q).then(se)})}return new Promise((Q,se)=>{this.b.then(Q,se)})}return this.a=B(),new Promise((Q,se)=>{this.a.then(le=>{this.a=null,Q(le)},le=>{this.a=null,se(le)})})}dispose(){this.f=!0}}e.$Zg=$;class d{constructor(){this.a=Promise.resolve(null)}queue(B){return this.a=this.a.then(()=>B(),()=>B())}}e.$1g=d;class h{constructor(){this.a=new Map}queue(B,Q){const le=(this.a.get(B)??Promise.resolve()).catch(()=>{}).then(Q).finally(()=>{this.a.get(B)===le&&this.a.delete(B)});return this.a.set(B,le),le}}e.$2g=h;const m=(N,B)=>{let Q=!0;const se=setTimeout(()=>{Q=!1,B()},N);return{isTriggered:()=>Q,dispose:()=>{clearTimeout(se),Q=!1}}},c=N=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,N())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};class t{constructor(B){this.defaultDelay=B,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(B,Q=this.defaultDelay){this.g=B,this.h(),this.b||(this.b=new Promise((le,ge)=>{this.d=le,this.f=ge}).then(()=>{if(this.b=null,this.d=null,this.g){const le=this.g;return this.g=null,le()}}));const se=()=>{this.a=null,this.d?.(null)};return this.a=Q===f.$Sd?c(se):m(Q,se),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=t;class o{constructor(B){this.a=new t(B),this.b=new $}trigger(B,Q){return this.a.trigger(()=>this.b.queue(B),Q)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=o;class r{constructor(){this.a=!1,this.b=new Promise((B,Q)=>{this.d=B})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=r;class i extends r{constructor(B){super(),this.f=setTimeout(()=>this.open(),B)}open(){clearTimeout(this.f),super.open()}}e.$6g=i;function n(N,B){return B?new Promise((Q,se)=>{const le=setTimeout(()=>{ge.dispose(),Q()},N),ge=B.onCancellationRequested(()=>{clearTimeout(le),ge.dispose(),se(new R.$5)})}):k(Q=>n(N,Q))}e.$7g=n;function a(N,B=0,Q){const se=setTimeout(()=>{N(),Q&&le.dispose()},B),le=(0,j.$Rc)(()=>{clearTimeout(se),Q?.deleteAndLeak(le)});return Q?.add(le),le}e.$8g=a;function b(N){const B=[];let Q=0;const se=N.length;function le(){return Q<se?N[Q++]():null}function ge(be){be!=null&&B.push(be);const Se=le();return Se?Se.then(ge):Promise.resolve(B)}return Promise.resolve(null).then(ge)}e.$9g=b;function C(N,B=se=>!!se,Q=null){let se=0;const le=N.length,ge=()=>{if(se>=le)return Promise.resolve(Q);const be=N[se++];return Promise.resolve(be()).then(Ae=>B(Ae)?Promise.resolve(Ae):ge())};return ge()}e.$0g=C;function I(N,B=se=>!!se,Q=null){if(N.length===0)return Promise.resolve(Q);let se=N.length;const le=()=>{se=-1;for(const ge of N)ge.cancel?.()};return new Promise((ge,be)=>{for(const Se of N)Se.then(Ae=>{--se>=0&&B(Ae)?(le(),ge(Ae)):se===0&&ge(Q)}).catch(Ae=>{--se>=0&&(le(),be(Ae))})})}e.$$g=I;class E{constructor(B){this.a=0,this.b=!1,this.f=B,this.g=[],this.d=0,this.h=new s.$Vd}whenIdle(){return this.size>0?s.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(B){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Q,se)=>{this.g.push({factory:B,c:Q,e:se}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const B=this.g.shift();this.d++;const Q=B.factory();Q.then(B.c,B.e),Q.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=E;class A extends E{constructor(){super(1)}}e.$ah=A;class M{constructor(){this.a=new L,this.b=0}queue(B){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,B())):this.a.run(this.b++,B())}}e.$bh=M;class T{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const B=new q;return this.b.add(B),B.p}g(){for(const[,B]of this.a)if(B.size>0)return!1;return!0}queueSize(B,Q=D.$xg){const se=Q.getComparisonKey(B);return this.a.get(se)?.size??0}queueFor(B,Q,se=D.$xg){const le=se.getComparisonKey(B);let ge=this.a.get(le);if(!ge){ge=new A;const be=this.f++,Se=s.Event.once(ge.onDrained)(()=>{ge?.dispose(),this.a.delete(le),this.h(),this.d?.deleteAndDispose(be),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new j.$3c),this.d.set(be,Se),this.a.set(le,ge)}return ge.queue(Q)}h(){this.g()&&this.j()}j(){for(const B of this.b)B.complete();this.b.clear()}dispose(){for(const[,B]of this.a)B.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=T;class W{constructor(B,Q){this.a=-1,typeof B=="function"&&typeof Q=="number"&&this.setIfNotSet(B,Q)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(B,Q){this.cancel(),this.a=setTimeout(()=>{this.a=-1,B()},Q)}setIfNotSet(B,Q){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,B()},Q))}}e.$dh=W;class G{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(B,Q,se=globalThis){this.cancel();const le=se.setInterval(()=>{B()},Q);this.d=(0,j.$Rc)(()=>{se.clearInterval(le),this.d=void 0})}dispose(){this.cancel()}}e.$eh=G;class J{constructor(B,Q){this.b=-1,this.a=B,this.d=Q,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(B=this.d){this.cancel(),this.b=setTimeout(this.f,B)}get delay(){return this.d}set delay(B){this.d=B}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=J;class ce{constructor(B,Q){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.a=B,this.b=Q,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(B=this.b){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(B/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=ce;class re extends J{constructor(B,Q){super(B,Q),this.j=[]}work(B){this.j.push(B),this.isScheduled()||this.schedule()}h(){const B=this.j;this.j=[],this.a?.(B)}dispose(){this.j=[],super.dispose()}}e.$hh=re;class ue extends j.$Tc{constructor(B,Q){super(),this.g=B,this.h=Q,this.a=[],this.b=this.B(new j.$Uc),this.f=!1}get pending(){return this.a.length}work(B){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+B.length>this.g.maxBufferedWork)return!1}else if(this.pending+B.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Q of B)this.a.push(Q);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new J(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=ue,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(N,B)=>{(0,S.$B)(()=>{if(Q)return;const se=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,se-Date.now())}}))});let Q=!1;return{dispose(){Q||(Q=!0)}}}:e.$kh=(N,B,Q)=>{const se=N.requestIdleCallback(B,typeof Q=="number"?{timeout:Q}:void 0);let le=!1;return{dispose(){le||(le=!0,N.cancelIdleCallback(se))}}},e.$jh=N=>(0,e.$kh)(globalThis,N)}();class Z{constructor(B,Q){this.g=!1,this.d=()=>{try{this.j=Q()}catch(se){this.l=se}finally{this.g=!0}},this.f=(0,e.$kh)(B,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=Z;class Y extends Z{constructor(B){super(globalThis,B)}}e.$mh=Y;async function V(N,B,Q){let se;for(let le=0;le<Q;le++)try{return await N()}catch(ge){se=ge,await n(B)}throw se}e.$nh=V;class L{isRunning(B){return typeof B=="number"?this.a?.taskId===B:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(B,Q,se){return this.a={taskId:B,cancel:()=>se?.(),promise:Q},Q.then(()=>this.d(B),()=>this.d(B)),Q}d(B){this.a&&B===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const B=this.b;this.b=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}queue(B){if(this.b)this.b.run=B;else{let Q,se;const le=new Promise((ge,be)=>{Q=ge,se=be});this.b={run:B,promise:le,promiseResolve:Q,promiseReject:se}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=L;class U{constructor(B,Q=()=>Date.now()){this.d=B,this.f=Q,this.a=0,this.b=0}increment(){const B=this.f();return B-this.a>this.d&&(this.a=B,this.b=0),this.b++,this.b}}e.$ph=U;var H;(function(N){N[N.Resolved=0]="Resolved",N[N.Rejected=1]="Rejected"})(H||(H={}));class q{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((B,Q)=>{this.a=B,this.b=Q})}complete(B){return new Promise(Q=>{this.a(B),this.d={outcome:0,value:B},Q()})}error(B){return new Promise(Q=>{this.b(B),this.d={outcome:1,value:B},Q()})}cancel(){return this.error(new R.$5)}}e.$qh=q;var ee;(function(N){async function B(se){let le;const ge=await Promise.all(se.map(be=>be.then(Se=>Se,Se=>{le||(le=Se)})));if(typeof le<"u")throw le;return ge}N.settled=B;function Q(se){return new Promise(async(le,ge)=>{try{await se(le,ge)}catch(be){ge(be)}})}N.withAsyncBody=Q})(ee||(e.Promises=ee={}));class he{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(B){this.a=void 0,this.b=void 0,this.d=!1,this.promise=B.then(Q=>(this.a=Q,this.d=!0,Q),Q=>{throw this.b=Q,this.d=!0,Q})}requireValue(){if(!this.d)throw new R.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=he;class K{constructor(B){this.b=B,this.a=new l.$V(()=>new he(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=K;var O;(function(N){N[N.Initial=0]="Initial",N[N.DoneOK=1]="DoneOK",N[N.DoneError=2]="DoneError"})(O||(O={}));class F{static fromArray(B){return new F(Q=>{Q.emitMany(B)})}static fromPromise(B){return new F(async Q=>{Q.emitMany(await B)})}static fromPromises(B){return new F(async Q=>{await Promise.all(B.map(async se=>Q.emitOne(await se)))})}static merge(B){return new F(async Q=>{await Promise.all(B.map(async se=>{for await(const le of se)Q.emitOne(le)}))})}static{this.EMPTY=F.fromArray([])}constructor(B){this.a=0,this.b=[],this.d=null,this.f=new s.$Vd,queueMicrotask(async()=>{const Q={emitOne:se=>this.g(se),emitMany:se=>this.h(se),reject:se=>this.k(se)};try{await Promise.resolve(B(Q)),this.j()}catch(se){this.k(se)}finally{Q.emitOne=void 0,Q.emitMany=void 0,Q.reject=void 0}})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(B<this.b.length)return{done:!1,value:this.b[B++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(B,Q){return new F(async se=>{for await(const le of B)se.emitOne(Q(le))})}map(B){return F.map(this,B)}static filter(B,Q){return new F(async se=>{for await(const le of B)Q(le)&&se.emitOne(le)})}filter(B){return F.filter(this,B)}static coalesce(B){return F.filter(B,Q=>!!Q)}coalesce(){return F.coalesce(this)}static async toPromise(B){const Q=[];for await(const se of B)Q.push(se);return Q}toPromise(){return F.toPromise(this)}g(B){this.a===0&&(this.b.push(B),this.f.fire())}h(B){this.a===0&&(this.b=this.b.concat(B),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(B){this.a===0&&(this.a=2,this.d=B,this.f.fire())}}e.$th=F;class _ extends F{constructor(B,Q){super(Q),this.l=B}cancel(){this.l.cancel()}}e.$uh=_;function z(N){const B=new P.$6d,Q=N(B.token);return new _(B,async se=>{const le=B.token.onCancellationRequested(()=>{le.dispose(),B.dispose(),se.reject(new R.$5)});try{for await(const ge of Q){if(B.token.isCancellationRequested)return;se.emitOne(ge)}le.dispose(),B.dispose()}catch(ge){le.dispose(),B.dispose(),se.reject(ge)}})}e.$vh=z;class x{constructor(){this.a=new q,this.b=new F(se=>{if(B){se.reject(B);return}return Q&&se.emitMany(Q),this.d=le=>se.reject(le),this.f=le=>se.emitOne(le),this.a.p});let B,Q;this.f=se=>{Q||(Q=[]),Q.push(se)},this.d=se=>{B||(B=se)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(B){this.d(B),this.a.complete()}emitOne(B){this.f(B)}}e.$wh=x}),define(oe[105],ae([0,1,22,8,33,31,9,4,25]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function l(){return Object.create(null)}e.$Hj=l,e.$Ij="**",e.$Jj="/";const p="[/\\\\]",k="[^/\\\\]",v=/\//g;function u(Y,V){switch(Y){case 0:return"";case 1:return`${k}*?`;default:return`(?:${p}|${k}+${p}${V?`|${p}${k}+`:""})*?`}}function y(Y,V){if(!Y)return[];const L=[];let U=!1,H=!1,q="";for(const ee of Y){switch(ee){case V:if(!U&&!H){L.push(q),q="";continue}break;case"{":U=!0;break;case"}":U=!1;break;case"[":H=!0;break;case"]":H=!1;break}q+=ee}return q&&L.push(q),L}e.$Kj=y;function w(Y){if(!Y)return"";let V="";const L=y(Y,e.$Jj);if(L.every(U=>U===e.$Ij))V=".*";else{let U=!1;L.forEach((H,q)=>{if(H===e.$Ij){if(U)return;V+=u(2,q===L.length-1)}else{let ee=!1,he="",K=!1,O="";for(const F of H){if(F!=="}"&&ee){he+=F;continue}if(K&&(F!=="]"||!O)){let _;F==="-"?_=F:(F==="^"||F==="!")&&!O?_="^":F===e.$Jj?_="":_=(0,f.$Oe)(F),O+=_;continue}switch(F){case"{":ee=!0;continue;case"[":K=!0;continue;case"}":{const z=`(?:${y(he,",").map(x=>w(x)).join("|")})`;V+=z,ee=!1,he="";break}case"]":{V+="["+O+"]",K=!1,O="";break}case"?":V+=k;continue;case"*":V+=u(1);continue;default:V+=(0,f.$Oe)(F)}}q<L.length-1&&(L[q+1]!==e.$Ij||q+2<L.length)&&(V+=p)}U=H===e.$Ij})}return V}const g=/^\*\*\/\*\.[\w\.-]+$/,$=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,h=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,m=/^\*\*((\/[\w\.-]+)+)\/?$/,c=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new j.$Dc(1e4),o=function(){return!1},r=function(){return null};function i(Y,V){if(!Y)return r;let L;typeof Y!="string"?L=Y.pattern:L=Y,L=L.trim();const U=`${L}_${!!V.trimForExclusions}`;let H=t.get(U);if(H)return n(H,Y);let q;return g.test(L)?H=b(L.substr(4),L):(q=$.exec(a(L,V)))?H=C(q[1],L):(V.trimForExclusions?h:d).test(L)?H=I(L,V):(q=m.exec(a(L,V)))?H=E(q[1].substr(1),L,!0):(q=c.exec(a(L,V)))?H=E(q[1],L,!1):H=A(L),t.set(U,H),n(H,Y)}function n(Y,V){if(typeof V=="string")return Y;const L=function(U,H){return(0,s.$8f)(U,V.base,!S.$k)?Y((0,f.$Te)(U.substr(V.base.length),D.sep),H):null};return L.allBasenames=Y.allBasenames,L.allPaths=Y.allPaths,L.basenames=Y.basenames,L.patterns=Y.patterns,L}function a(Y,V){return V.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function b(Y,V){return function(L,U){return typeof L=="string"&&L.endsWith(Y)?V:null}}function C(Y,V){const L=`/${Y}`,U=`\\${Y}`,H=function(ee,he){return typeof ee!="string"?null:he?he===Y?V:null:ee===Y||ee.endsWith(L)||ee.endsWith(U)?V:null},q=[Y];return H.basenames=q,H.patterns=[V],H.allBasenames=q,H}function I(Y,V){const L=ue(Y.slice(1,-1).split(",").map(he=>i(he,V)).filter(he=>he!==r),Y),U=L.length;if(!U)return r;if(U===1)return L[0];const H=function(he,K){for(let O=0,F=L.length;O<F;O++)if(L[O](he,K))return Y;return null},q=L.find(he=>!!he.allBasenames);q&&(H.allBasenames=q.allBasenames);const ee=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return ee.length&&(H.allPaths=ee),H}function E(Y,V,L){const U=D.sep===D.$gc.sep,H=U?Y:Y.replace(v,D.sep),q=D.sep+H,ee=D.$gc.sep+Y;let he;return L?he=function(K,O){return typeof K=="string"&&(K===H||K.endsWith(q)||!U&&(K===Y||K.endsWith(ee)))?V:null}:he=function(K,O){return typeof K=="string"&&(K===H||!U&&K===Y)?V:null},he.allPaths=[(L?"*/":"./")+Y],he}function A(Y){try{const V=new RegExp(`^${w(Y)}$`);return function(L){return V.lastIndex=0,typeof L=="string"&&V.test(L)?Y:null}}catch{return r}}function M(Y,V,L){return!Y||typeof V!="string"?!1:T(Y)(V,void 0,L)}e.$Lj=M;function T(Y,V={}){if(!Y)return o;if(typeof Y=="string"||W(Y)){const L=i(Y,V);if(L===r)return o;const U=function(H,q){return!!L(H,q)};return L.allBasenames&&(U.allBasenames=L.allBasenames),L.allPaths&&(U.allPaths=L.allPaths),U}return ce(Y,V)}e.$Mj=T;function W(Y){const V=Y;return V?typeof V.base=="string"&&typeof V.pattern=="string":!1}e.$Nj=W;function G(Y){return Y.allBasenames||[]}e.$Oj=G;function J(Y){return Y.allPaths||[]}e.$Pj=J;function ce(Y,V){const L=ue(Object.getOwnPropertyNames(Y).map(he=>re(he,Y[he],V)).filter(he=>he!==r)),U=L.length;if(!U)return r;if(!L.some(he=>!!he.requiresSiblings)){if(U===1)return L[0];const he=function(F,_){let z;for(let x=0,N=L.length;x<N;x++){const B=L[x](F,_);if(typeof B=="string")return B;(0,R.$Sg)(B)&&(z||(z=[]),z.push(B))}return z?(async()=>{for(const x of z){const N=await x;if(typeof N=="string")return N}return null})():null},K=L.find(F=>!!F.allBasenames);K&&(he.allBasenames=K.allBasenames);const O=L.reduce((F,_)=>_.allPaths?F.concat(_.allPaths):F,[]);return O.length&&(he.allPaths=O),he}const H=function(he,K,O){let F,_;for(let z=0,x=L.length;z<x;z++){const N=L[z];N.requiresSiblings&&O&&(K||(K=(0,D.$nc)(he)),F||(F=K.substr(0,K.length-(0,D.$oc)(he).length)));const B=N(he,K,F,O);if(typeof B=="string")return B;(0,R.$Sg)(B)&&(_||(_=[]),_.push(B))}return _?(async()=>{for(const z of _){const x=await z;if(typeof x=="string")return x}return null})():null},q=L.find(he=>!!he.allBasenames);q&&(H.allBasenames=q.allBasenames);const ee=L.reduce((he,K)=>K.allPaths?he.concat(K.allPaths):he,[]);return ee.length&&(H.allPaths=ee),H}function re(Y,V,L){if(V===!1)return r;const U=i(Y,L);if(U===r)return r;if(typeof V=="boolean")return U;if(V){const H=V.when;if(typeof H=="string"){const q=(ee,he,K,O)=>{if(!O||!U(ee,he))return null;const F=H.replace("$(basename)",()=>K),_=O(F);return(0,R.$Sg)(_)?_.then(z=>z?Y:null):_?Y:null};return q.requiresSiblings=!0,q}}return U}function ue(Y,V){const L=Y.filter(he=>!!he.basenames);if(L.length<2)return Y;const U=L.reduce((he,K)=>{const O=K.basenames;return O?he.concat(O):he},[]);let H;if(V){H=[];for(let he=0,K=U.length;he<K;he++)H.push(V)}else H=L.reduce((he,K)=>{const O=K.patterns;return O?he.concat(O):he},[]);const q=function(he,K){if(typeof he!="string")return null;if(!K){let F;for(F=he.length;F>0;F--){const _=he.charCodeAt(F-1);if(_===47||_===92)break}K=he.substr(F)}const O=U.indexOf(K);return O!==-1?H[O]:null};q.basenames=U,q.patterns=H,q.allBasenames=U;const ee=Y.filter(he=>!he.basenames);return ee.push(q),ee}function Z(Y,V){return(0,P.$ub)(Y,V,(L,U)=>typeof L=="string"&&typeof U=="string"?L===U:typeof L!="string"&&typeof U!="string"?L.base===U.base&&L.pattern===U.pattern:!1)}e.$Qj=Z}),define(oe[47],ae([0,1,22,33,9,4,19,25]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function f(i,n){const{os:a,tildify:b,relative:C}=n;if(C){const A=l(i,C,a);if(typeof A=="string")return A}let I=i.fsPath;if(a===1&&!j.$i?I=I.replace(/\//g,"\\"):a!==1&&j.$i&&(I=I.replace(/\\/g,"/")),a!==1&&b?.userHome){const A=b.userHome.fsPath;let M;i.scheme!==b.userHome.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep?M=b.userHome.with({path:i.path}).fsPath:M=I,I=v(M,A,a)}return(a===1?s.$fc:s.$gc).normalize(p(I,a===1))}e.$Vv=f;function l(i,n,a){const b=a===1?s.$fc:s.$gc,C=a===3?D.$xg:D.$zg,I=n.getWorkspace(),E=(0,P.$Ob)(I.folders);if(!E)return;i.scheme!==E.uri.scheme&&i.path[0]===s.$gc.sep&&i.path[1]!==s.$gc.sep&&(i=E.uri.with({path:i.path}));const A=n.getWorkspaceFolder(i);if(!A)return;let M;if(C.isEqual(A.uri,i)?M="":M=C.relativePath(A.uri,i)??"",M&&(M=b.normalize(M)),I.folders.length>1&&!n.noPrefix){const T=A.name?A.name:C.basenameOrAuthority(A.uri);M=M?`${T} \u2022 ${M}`:T}return M}function p(i,n=j.$i){return(0,R.$_f)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.$Wv=p;let k=Object.create(null);function v(i,n,a=j.OS){if(a===1||!i||!n)return i;let b=k.original===n?k.normalized:void 0;b||(b=n,j.$i&&(b=(0,R.$2f)(b)),b=`${(0,S.$Ue)(b,s.$gc.sep)}${s.$gc.sep}`,k={original:n,normalized:b});let C=i;return j.$i&&(C=(0,R.$2f)(C)),(a===3?C.startsWith(b):(0,S.$af)(C,b))?`~/${C.substr(b.length)}`:i}e.$Xv=v;function u(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.$Yv=u;const y="\u2026",w="\\\\",g="~";function $(i,n=s.sep){const a=new Array(i.length);let b=!1;for(let C=0;C<i.length;C++){const I=i[C];if(I===""){a[C]=`.${n}`;continue}if(!I){a[C]=I;continue}b=!0;let E="",A=I;A.indexOf(w)===0?(E=A.substr(0,A.indexOf(w)+w.length),A=A.substr(A.indexOf(w)+w.length)):A.indexOf(n)===0?(E=A.substr(0,A.indexOf(n)+n.length),A=A.substr(A.indexOf(n)+n.length)):A.indexOf(g)===0&&(E=A.substr(0,A.indexOf(g)+g.length),A=A.substr(A.indexOf(g)+g.length));const M=A.split(n);for(let T=1;b&&T<=M.length;T++)for(let W=M.length-T;b&&W>=0;W--){b=!1;let G=M.slice(W,W+T).join(n);for(let J=0;!b&&J<i.length;J++)if(J!==C&&i[J]&&i[J].indexOf(G)>-1){const ce=W+T===M.length,re=W>0&&i[J].indexOf(n)>-1?n+G:G,ue=i[J].endsWith(re);b=!ce||ue}if(!b){let J="";(M[0].endsWith(":")||E!=="")&&(W===1&&(W=0,T++,G=M[0]+n+G),W>0&&(J=M[0]+n),J=E+J),W>0&&(J=J+y+n),J=J+G,W+T<M.length&&(J=J+n+y),a[C]=J}}b&&(a[C]=I)}return a}e.$Zv=$;var d;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function h(i,n=Object.create(null)){const a=[];let b=!1,C="";for(const I of i)if(I==="$"||b&&I==="{")C&&a.push({value:C,type:d.TEXT}),C="",b=!0;else if(I==="}"&&b){const E=n[C];if(typeof E=="string")E.length&&a.push({value:E,type:d.VARIABLE});else if(E){const A=a[a.length-1];(!A||A.type!==d.SEPARATOR)&&a.push({value:E.label,type:d.SEPARATOR})}C="",b=!1}else C+=I;return C&&!b&&a.push({value:C,type:d.TEXT}),a.filter((I,E)=>{if(I.type===d.SEPARATOR){const A=a[E-1],M=a[E+1];return[A,M].every(T=>T&&(T.type===d.VARIABLE||T.type===d.TEXT)&&T.value.length>0)}return!0}).map(I=>I.value).join("")}e.$1v=h;function m(i,n){return j.$j||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,j.$j?"&":"&&"):i.replace(/&&|&/g,a=>a==="&"?"&&":"&")}e.$2v=m;function c(i,n){return j.$j||n?i.replace(/\(&&\w\)|&&/g,""):j.$i?i.replace(/&&|&/g,a=>a==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.$3v=c;function t(i){return i.replace(/&/g,"&&")}e.$4v=t;function o(i){if(i.endsWith("]")){const n=i.lastIndexOf(" [",i.length-2);if(n!==-1){const a=r(i.substring(0,n)),b=i.substring(n);return{name:a.name+b,parentPath:a.parentPath}}}return r(i)}e.$5v=o;function r(i){const n=i.indexOf("/")!==-1?s.$gc:s.$fc,a=n.basename(i),b=n.dirname(i);return a.length?{name:a,parentPath:b}:{name:b,parentPath:""}}}),define(oe[155],ae([0,1,17,7]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function s(k){return k.toJSON()}class j{constructor(v){this.a=v}transformIncoming(v){const u=this.a.transformIncoming(v);return u===v?v:s(R.URI.from(u))}transformOutgoing(v){const u=this.a.transformOutgoing(v);return u===v?v:s(R.URI.from(u))}transformOutgoingURI(v){const u=this.a.transformOutgoing(v);return u===v?v:R.URI.from(u)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.$4m=j,e.$5m=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function D(k,v,u){if(!k||u>200)return null;if(typeof k=="object"){if(k instanceof R.URI)return v.transformOutgoing(k);for(const y in k)if(Object.hasOwnProperty.call(k,y)){const w=D(k[y],v,u+1);w!==null&&(k[y]=w)}}return null}function S(k,v){const u=D(k,v,0);return u===null?k:u}e.$6m=S;function f(k,v,u,y){if(!k||y>200)return null;if(typeof k=="object"){if(k.$mid===1)return u?R.URI.revive(v.transformIncoming(k)):v.transformIncoming(k);if(k instanceof P.$je)return null;for(const w in k)if(Object.hasOwnProperty.call(k,w)){const g=f(k[w],v,u,y+1);g!==null&&(k[w]=g)}}return null}function l(k,v){const u=f(k,v,!1,0);return u===null?k:u}e.$7m=l;function p(k,v){const u=f(k,v,!0,0);return u===null?k:u}e.$8m=p}),define(oe[88],ae([0,1,26,58,32,145,4]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=new class{c(v){return this.a||(this.a=R.$_h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,u=0;const y=(0,P.networkInterfaces)();for(const w in y){const g=y[w];if(g)for(const{mac:$,internal:d}of g)d||(u+=1,this.c($.toUpperCase())&&(v+=1))}this.b=u>0?v/u:0}return this.b}};let S;async function f(v){return S||(S=(async()=>await l(v)||s.$qg())()),S}e.$$m=f;async function l(v){try{const u=await new Promise((w,g)=>{X(["crypto"],w,g)}),y=(0,j.$9m)();return u.createHash("sha256").update(y,"utf8").digest("hex")}catch(u){v(u);return}}const p="Software\\Microsoft\\SQMClient";async function k(v){if(D.$i){const u=await new Promise((y,w)=>{X(["@vscode/windows-registry"],y,w)});try{return u.GetStringRegKey("HKEY_LOCAL_MACHINE",p,"MachineId")||""}catch(y){return v(y),""}}return""}e.$_m=k}),define(oe[21],ae([0,1,46,26,156,8,33,85,9,4,19,7]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(re){re[re.UNLINK=0]="UNLINK",re[re.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function u(re,ue=v.UNLINK,Z){if((0,D.$$f)(re))throw new Error("rimraf - will refuse to recursively delete root");return ue===v.UNLINK?w(re):y(re,Z)}async function y(re,ue=(0,D.$dg)((0,R.tmpdir)())){try{try{await P.promises.rename(re,ue)}catch(Z){return Z.code==="ENOENT"?void 0:w(re)}w(ue).catch(Z=>{})}catch(Z){if(Z.code!=="ENOENT")throw Z}}async function w(re){return(0,s.promisify)(P.rm)(re,{recursive:!0,force:!0,maxRetries:3})}function g(re){if((0,D.$$f)(re))throw new Error("rimraf - will refuse to recursively delete root");P.rmSync(re,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function $(re,ue){return m(await(ue?d(re):(0,s.promisify)(P.readdir)(re)))}async function d(re){try{return await(0,s.promisify)(P.readdir)(re,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const ue=[],Z=await $(re);for(const Y of Z){let V=!1,L=!1,U=!1;try{const H=await e.Promises.lstat((0,f.$jc)(re,Y));V=H.isFile(),L=H.isDirectory(),U=H.isSymbolicLink()}catch(H){console.warn("[node.js fs] unexpected error from lstat after readdir: ",H)}ue.push({name:Y,isFile:()=>V,isDirectory:()=>L,isSymbolicLink:()=>U})}return ue}function h(re){return m(P.readdirSync(re))}e.readdirSync=h;function m(re){return re.map(ue=>typeof ue=="string"?l.$j?(0,S.$Gl)(ue):ue:(ue.name=l.$j?(0,S.$Gl)(ue.name):ue.name,ue))}async function c(re){const ue=await $(re),Z=[];for(const Y of ue)await o.existsDirectory((0,f.$jc)(re,Y))&&Z.push(Y);return Z}function t(re,ue=1e3){return new Promise(Z=>{let Y=!1;const V=setInterval(()=>{Y||(Y=!0,P.access(re,L=>{Y=!1,L&&(clearInterval(V),Z(void 0))}))},ue)})}e.whenDeleted=t;var o;(function(re){async function ue(V){let L;try{if(L=await e.Promises.lstat(V),!L.isSymbolicLink())return{stat:L}}catch{}try{return{stat:await e.Promises.stat(V),symbolicLink:L?.isSymbolicLink()?{dangling:!1}:void 0}}catch(U){if(U.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};if(l.$i&&U.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(V)),symbolicLink:{dangling:!1}}}catch(H){if(H.code==="ENOENT"&&L)return{stat:L,symbolicLink:{dangling:!0}};throw H}throw U}}re.stat=ue;async function Z(V){try{const{stat:L,symbolicLink:U}=await re.stat(V);return L.isFile()&&U?.dangling!==!0}catch{}return!1}re.existsFile=Z;async function Y(V){try{const{stat:L,symbolicLink:U}=await re.stat(V);return L.isDirectory()&&U?.dangling!==!0}catch{}return!1}re.existsDirectory=Y})(o||(e.SymlinkSupport=o={}));const r=new j.$ch;function i(re,ue,Z){return r.queueFor(k.URI.file(re),()=>{const Y=I(Z);return new Promise((V,L)=>b(re,ue,Y,U=>U?L(U):V()))},p.$yg)}let n=!0;function a(re){n=re}e.configureFlushOnWrite=a;function b(re,ue,Z,Y){if(!n)return P.writeFile(re,ue,{mode:Z.mode,flag:Z.flag},Y);P.open(re,Z.flag,Z.mode,(V,L)=>{if(V)return Y(V);P.writeFile(L,ue,U=>{if(U)return P.close(L,()=>Y(U));P.fdatasync(L,H=>(H&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",H),a(!1)),P.close(L,q=>Y(q))))})})}function C(re,ue,Z){const Y=I(Z);if(!n)return P.writeFileSync(re,ue,{mode:Y.mode,flag:Y.flag});const V=P.openSync(re,Y.flag,Y.mode);try{P.writeFileSync(V,ue);try{P.fdatasyncSync(V)}catch(L){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",L),a(!1)}}finally{P.closeSync(V)}}e.writeFileSync=C;function I(re){return re?{mode:typeof re.mode=="number"?re.mode:438,flag:typeof re.flag=="string"?re.flag:"w"}:{mode:438,flag:"w"}}async function E(re,ue,Z=6e4){if(re!==ue)try{l.$i&&typeof Z=="number"?await A(re,ue,Date.now(),Z):await(0,s.promisify)(P.rename)(re,ue)}catch(Y){if(re.toLowerCase()!==ue.toLowerCase()&&Y.code==="EXDEV"||re.endsWith("."))await M(re,ue,{preserveSymlinks:!1}),await u(re,v.MOVE);else throw Y}}async function A(re,ue,Z,Y,V=0){try{return await(0,s.promisify)(P.rename)(re,ue)}catch(L){if(L.code!=="EACCES"&&L.code!=="EPERM"&&L.code!=="EBUSY")throw L;if(Date.now()-Z>=Y)throw console.error(`[node.js fs] rename failed after ${V} retries with error: ${L}`),L;if(V===0){let U=!1;try{const{stat:H}=await o.stat(ue);H.isFile()||(U=!0)}catch{}if(U)throw L}return await(0,j.$7g)(Math.min(100,V*10)),A(re,ue,Z,Y,V+1)}}async function M(re,ue,Z){return W(re,ue,{root:{source:re,target:ue},options:Z,handledSourcePaths:new Set})}const T=511;async function W(re,ue,Z){if(Z.handledSourcePaths.has(re))return;Z.handledSourcePaths.add(re);const{stat:Y,symbolicLink:V}=await o.stat(re);if(V){if(Z.options.preserveSymlinks)try{return await ce(re,ue,Z)}catch{}if(V.dangling)return}return Y.isDirectory()?G(re,ue,Y.mode&T,Z):J(re,ue,Y.mode&T)}async function G(re,ue,Z,Y){await e.Promises.mkdir(ue,{recursive:!0,mode:Z});const V=await $(re);for(const L of V)await W((0,f.$jc)(re,L),(0,f.$jc)(ue,L),Y)}async function J(re,ue,Z){await e.Promises.copyFile(re,ue),await e.Promises.chmod(ue,Z)}async function ce(re,ue,Z){let Y=await e.Promises.readlink(re);(0,D.$8f)(Y,Z.root.source,!l.$k)&&(Y=(0,f.$jc)(Z.root.target,Y.substr(Z.root.source.length+1))),await e.Promises.symlink(Y,ue)}e.Promises=new class{get access(){return(0,s.promisify)(P.access)}get stat(){return(0,s.promisify)(P.stat)}get lstat(){return(0,s.promisify)(P.lstat)}get utimes(){return(0,s.promisify)(P.utimes)}get read(){return(re,ue,Z,Y,V)=>new Promise((L,U)=>{P.read(re,ue,Z,Y,V,(H,q,ee)=>H?U(H):L({bytesRead:q,buffer:ee}))})}get readFile(){return(0,s.promisify)(P.readFile)}get write(){return(re,ue,Z,Y,V)=>new Promise((L,U)=>{P.write(re,ue,Z,Y,V,(H,q,ee)=>H?U(H):L({bytesWritten:q,buffer:ee}))})}get appendFile(){return(0,s.promisify)(P.appendFile)}get fdatasync(){return(0,s.promisify)(P.fdatasync)}get truncate(){return(0,s.promisify)(P.truncate)}get copyFile(){return(0,s.promisify)(P.copyFile)}get open(){return(0,s.promisify)(P.open)}get close(){return(0,s.promisify)(P.close)}get symlink(){return(0,s.promisify)(P.symlink)}get readlink(){return(0,s.promisify)(P.readlink)}get chmod(){return(0,s.promisify)(P.chmod)}get mkdir(){return(0,s.promisify)(P.mkdir)}get unlink(){return(0,s.promisify)(P.unlink)}get rmdir(){return(0,s.promisify)(P.rmdir)}get realpath(){return(0,s.promisify)(P.realpath)}async exists(re){try{return await e.Promises.access(re),!0}catch{return!1}}get readdir(){return $}get readDirsInDir(){return c}get writeFile(){return i}get rm(){return u}get rename(){return E}get copy(){return M}}}),define(oe[106],ae([0,1,46,9,4,25,21]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=void 0;function S(v){if(s.$k)return v;const u=(0,R.$mc)(v);if(v===u)return v;const y=((0,R.$nc)(v)||v).toLowerCase();try{const g=(0,D.readdirSync)(u).filter($=>$.toLowerCase()===y);if(g.length===1){const $=S(u);if($)return(0,R.$jc)($,g[0])}else if(g.length>1){const $=g.indexOf(y);if($>=0){const d=S(u);if(d)return(0,R.$jc)(d,g[$])}}}catch{}return null}e.$tq=S;async function f(v){if(s.$k)return v;const u=(0,R.$mc)(v);if(v===u)return v;const y=((0,R.$nc)(v)||v).toLowerCase();try{const g=(await D.Promises.readdir(u)).filter($=>$.toLowerCase()===y);if(g.length===1){const $=await f(u);if($)return(0,R.$jc)($,g[0])}else if(g.length>1){const $=g.indexOf(y);if($>=0){const d=await f(u);if(d)return(0,R.$jc)(d,g[$])}}}catch{}return null}e.$uq=f;async function l(v){try{return await D.Promises.realpath(v)}catch{const y=k(v);return await D.Promises.access(y,P.constants.R_OK),y}}e.$vq=l;function p(v){try{return P.realpathSync(v)}catch{const y=k(v);return P.accessSync(y,P.constants.R_OK),y}}e.$wq=p;function k(v){return(0,j.$Ue)((0,R.$hc)(v),R.sep)}}),define(oe[107],ae([0,1,26,9,21]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const j=/^\d+$/,D=/^Microsoft.PowerShell_.*/,S=/^Microsoft.PowerShellPreview_.*/;var f;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(f||(f={}));let l;switch(process.arch){case"ia32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class k{constructor(c,t,o){this.exePath=c,this.displayName=t,this.a=o}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:m=!1}={}){return m?l===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function u({useAlternateBitness:m=!1,findPreview:c=!1}={}){const t=v({useAlternateBitness:m});if(!t)return null;const o=R.$jc(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(o))return null;let r=-1,i=null;for(const b of await s.Promises.readdir(o)){let C=-1;if(c){const E=b.indexOf("-");if(E<0)continue;const A=b.substring(0,E);if(!j.test(A)||b.substring(E+1)!=="preview")continue;C=parseInt(A,10)}else{if(!j.test(b))continue;C=parseInt(b,10)}if(C<=r)continue;const I=R.$jc(o,b,"pwsh.exe");await s.SymlinkSupport.existsFile(I)&&(i=I,r=C)}if(!i)return null;const n=t.includes("x86")?" (x86)":"",a=c?" Preview":"";return new k(i,`PowerShell${a}${n}`,!0)}async function y({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const c=R.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:t,pwshMsixName:o}=m?{pwshMsixDirRegex:S,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:D,pwshMsixName:"PowerShell (Store)"};for(const r of await s.Promises.readdir(c))if(t.test(r)){const i=R.$jc(c,r,"pwsh.exe");return new k(i,o)}return null}function w(){const m=R.$jc(P.homedir(),".dotnet","tools","pwsh.exe");return new k(m,".NET Core PowerShell Global Tool")}function g(){const m=R.$jc(process.env.windir,l===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(m,"Windows PowerShell",!0)}async function*$(){let m=await u();m&&(yield m),m=await u({useAlternateBitness:!0}),m&&(yield m),m=await y(),m&&(yield m),m=w(),m&&(yield m),m=await u({findPreview:!0}),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await u({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=g(),m&&(yield m)}async function*d(){for await(const m of $())await m.exists()&&(yield m)}e.$Pl=d;async function h(){for await(const m of d())return m;return null}e.$Ql=h}),define(oe[89],ae([0,1,9,4,36,76,12,21]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return j.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return j.TerminateResponseCode}});function f(k=s.env){return k.comspec||"cmd.exe"}e.$Tl=f;function l(k){let v=[],u=!1;const y=function(w){if(u){v.push(w);return}(!k.send(w,$=>{if($&&console.error($),u=!1,v.length>0){const d=v.slice(0);v=[],d.forEach(h=>y(h))}})||R.$i)&&(u=!0)};return{send:y}}e.$Ul=l;var p;(function(k){async function v(u,y,w){if(P.$ic(u))return u;if(y===void 0&&(y=s.cwd()),P.$mc(u)!=="."||(w===void 0&&D.$If(s.env.PATH)&&(w=s.env.PATH.split(P.$tc)),w===void 0||w.length===0))return P.$jc(y,u);async function $(d){if(await S.Promises.exists(d)){let h;try{h=await S.Promises.stat(d)}catch(m){m.message.startsWith("EACCES")&&(h=await S.Promises.lstat(d))}return h?!h.isDirectory():!1}return!1}for(const d of w){let h;if(P.$ic(d)?h=P.$jc(d,u):h=P.$jc(y,d,u),await $(h))return h;let m=h+".com";if(await $(m)||(m=h+".exe",await $(m)))return m}return P.$jc(y,u)}k.findExecutable=v})(p||(e.win32=p={}))}),define(oe[108],ae([0,1,48,13]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;function s(D){return new Promise((S,f)=>{let l;const p=new Map;function k(u,y,w,g,$){const d=p.get(y);if(u===D||d){const h={name:v(w),cmd:w,pid:u,ppid:y,load:g,mem:$};p.set(u,h),u===D&&(l=h),d&&(d.children||(d.children=[]),d.children.push(h),d.children.length>1&&(d.children=d.children.sort((m,c)=>m.pid-c.pid)))}}function v(u){const y=/--utility-sub-type=network/i,w=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,$=/conhost\.exe.+--headless/i,d=/--type=([a-zA-Z-]+)/;if(w.exec(u))return"electron-crash-reporter";if(g.exec(u))return"winpty-agent";if($.exec(u))return"conpty-agent";let h=d.exec(u);if(h&&h.length===2)return h[1]==="renderer"?"window":h[1]==="utility"?y.exec(u)?"utility-network-service":"utility-process":h[1]==="extensionHost"?"extension-host":h[1];const m=/[a-zA-Z-]+\.js/g;let c="";do h=m.exec(u),h&&(c+=h+" ");while(h);return c&&u.indexOf("node ")<0&&u.indexOf("node.exe")<0?`electron-nodejs (${c})`:u}if(process.platform==="win32"){const u=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substring(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substring(5):y;new Promise((y,w)=>{X(["@vscode/windows-process-tree"],y,w)}).then(y=>{y.getProcessList(D,w=>{if(!w){f(new Error(`Root process ${D} not found`));return}y.getProcessCpuUsage(w,g=>{const $=new Map;g.forEach(d=>{const h=u(d.commandLine||"");$.set(d.pid,{name:v(h),cmd:h,pid:d.pid,ppid:d.ppid,load:d.cpu||0,mem:d.memory||0})}),l=$.get(D),l?($.forEach(d=>{const h=$.get(d.ppid);h&&(h.children||(h.children=[]),h.children.push(d))}),$.forEach(d=>{d.children&&(d.children=d.children.sort((h,m)=>h.pid-m.pid))}),S(l)):f(new Error(`Root process ${D} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let u=function(){let y=[l];const w=[];for(;y.length;){const $=y.shift();$&&(w.push($.pid),$.children&&(y=y.concat($.children)))}let g=JSON.stringify(R.$og.asFileUri("vs/base/node/cpuUsage.sh").fsPath);g+=" "+w.join(" "),(0,P.exec)(g,{},($,d,h)=>{if($||h)f($||new Error(h.toString()));else{const m=d.toString().split(`
`);for(let c=0;c<w.length;c++){const t=p.get(w[c]);t.load=parseFloat(m[c])}if(!l){f(new Error(`Root process ${D} not found`));return}S(l)}})};(0,P.exec)("which ps",{},(y,w,g)=>{if(y||g)if(process.platform!=="linux")f(y||new Error(g.toString()));else{const $=JSON.stringify(R.$og.asFileUri("vs/base/node/ps.sh").fsPath);(0,P.exec)($,{},(d,h,m)=>{d||m?f(d||new Error(m.toString())):(j(h,k),u())})}else{const $=w.toString().trim(),d="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,P.exec)(`${$} ${d}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,m,c)=>{h||c&&!c.includes("screen size is bogus")?f(h||new Error(c.toString())):(j(m,k),process.platform==="linux"?u():l?S(l):f(new Error(`Root process ${D} not found`)))})}})}})}e.$5r=s;function j(D,S){const f=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=D.toString().split(`
`);for(const p of l){const k=f.exec(p.trim());k&&k.length===6&&S(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(oe[109],ae([0,1,26,4,107,89]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=void 0;async function D(k,v){return k===1?R.$i?p():j.$Tl(v):f(k,v)}e.$Vl=D;let S=null;function f(k,v){if(R.$k&&k===2||R.$j&&k===3)return"/bin/bash";if(!S){let u;if(R.$i)u="/bin/bash";else{if(u=v.SHELL,!u)try{u=(0,P.userInfo)().shell}catch{}u||(u="sh"),u==="/bin/false"&&(u="/bin/bash")}S=u}return S}let l=null;async function p(){return l||(l=(await(0,s.$Ql)()).exePath),l}});var ve=this&&this.__decorate||function(X,e,P,R){var s=arguments.length,j=s<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,P):R,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")j=Reflect.decorate(X,e,P,R);else for(var S=X.length-1;S>=0;S--)(D=X[S])&&(j=(s<3?D(j):s>3?D(e,P,j):D(e,P))||j);return s>3&&j&&Object.defineProperty(e,P,j),j};define(oe[43],ae([0,1,22,8,17,23,50,14,3,2,77,25,12]),function(X,e,P,R,s,j,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var u;(function(V){V[V.Promise=100]="Promise",V[V.PromiseCancel=101]="PromiseCancel",V[V.EventListen=102]="EventListen",V[V.EventDispose=103]="EventDispose"})(u||(u={}));function y(V){switch(V){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(V){V[V.Initialize=200]="Initialize",V[V.PromiseSuccess=201]="PromiseSuccess",V[V.PromiseError=202]="PromiseError",V[V.PromiseErrorObj=203]="PromiseErrorObj",V[V.EventFire=204]="EventFire"})(w||(w={}));function g(V){switch(V){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var $;(function(V){V[V.Uninitialized=0]="Uninitialized",V[V.Idle=1]="Idle"})($||($={}));function d(V){let L=0;for(let U=0;;U+=7){const H=V.read(1);if(L|=(H.buffer[0]&127)<<U,!(H.buffer[0]&128))return L}}const h=r(0);function m(V,L){if(L===0){V.write(h);return}let U=0;for(let q=L;q!==0;q=q>>>7)U++;const H=s.$je.alloc(U);for(let q=0;L!==0;q++)H.buffer[q]=L&127,L=L>>>7,L>0&&(H.buffer[q]|=128);V.write(H)}class c{constructor(L){this.b=L,this.a=0}read(L){const U=this.b.slice(this.a,this.a+L);return this.a+=U.byteLength,U}}e.$Dh=c;class t{constructor(){this.a=[]}get buffer(){return s.$je.concat(this.a)}write(L){this.a.push(L)}}e.$Eh=t;var o;(function(V){V[V.Undefined=0]="Undefined",V[V.String=1]="String",V[V.Buffer=2]="Buffer",V[V.VSBuffer=3]="VSBuffer",V[V.Array=4]="Array",V[V.Object=5]="Object",V[V.Int=6]="Int"})(o||(o={}));function r(V){const L=s.$je.alloc(1);return L.writeUInt8(V,0),L}const i={Undefined:r(o.Undefined),String:r(o.String),Buffer:r(o.Buffer),VSBuffer:r(o.VSBuffer),Array:r(o.Array),Object:r(o.Object),Uint:r(o.Int)},n=typeof Buffer<"u";function a(V,L){if(typeof L>"u")V.write(i.Undefined);else if(typeof L=="string"){const U=s.$je.fromString(L);V.write(i.String),m(V,U.byteLength),V.write(U)}else if(n&&Buffer.isBuffer(L)){const U=s.$je.wrap(L);V.write(i.Buffer),m(V,U.byteLength),V.write(U)}else if(L instanceof s.$je)V.write(i.VSBuffer),m(V,L.byteLength),V.write(L);else if(Array.isArray(L)){V.write(i.Array),m(V,L.length);for(const U of L)a(V,U)}else if(typeof L=="number"&&(L|0)===L)V.write(i.Uint),m(V,L);else{const U=s.$je.fromString(JSON.stringify(L));V.write(i.Object),m(V,U.byteLength),V.write(U)}}e.$Fh=a;function b(V){switch(V.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return V.read(d(V)).toString();case o.Buffer:return V.read(d(V)).buffer;case o.VSBuffer:return V.read(d(V));case o.Array:{const U=d(V),H=[];for(let q=0;q<U;q++)H.push(b(V));return H}case o.Object:return JSON.parse(V.read(d(V)).toString());case o.Int:return d(V)}}e.$Gh=b;class C{constructor(L,U,H=null,q=1e3){this.h=L,this.j=U,this.k=H,this.l=q,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ee=>this.q(ee)),this.m({type:200})}registerChannel(L,U){this.b.set(L,U),setTimeout(()=>this.w(L),0)}m(L){switch(L.type){case 200:{const U=this.o([L.type]);this.k?.logOutgoing(U,0,1,g(L.type));return}case 201:case 202:case 204:case 203:{const U=this.o([L.type,L.id],L.data);this.k?.logOutgoing(U,L.id,1,g(L.type),L.data);return}}}o(L,U=void 0){const H=new t;return a(H,L),a(H,U),this.p(H.buffer)}p(L){try{return this.h.send(L),L.byteLength}catch{return 0}}q(L){const U=new c(L),H=b(U),q=b(U),ee=H[0];switch(ee){case 100:return this.k?.logIncoming(L.byteLength,H[1],1,`${y(ee)}: ${H[2]}.${H[3]}`,q),this.s({type:ee,id:H[1],channelName:H[2],name:H[3],arg:q});case 102:return this.k?.logIncoming(L.byteLength,H[1],1,`${y(ee)}: ${H[2]}.${H[3]}`,q),this.t({type:ee,id:H[1],channelName:H[2],name:H[3],arg:q});case 101:return this.k?.logIncoming(L.byteLength,H[1],1,`${y(ee)}`),this.u({type:ee,id:H[1]});case 103:return this.k?.logIncoming(L.byteLength,H[1],1,`${y(ee)}`),this.u({type:ee,id:H[1]})}}s(L){const U=this.b.get(L.channelName);if(!U){this.v(L);return}const H=new j.$6d;let q;try{q=U.call(this.j,L.name,L.arg,H.token)}catch(K){q=Promise.reject(K)}const ee=L.id;q.then(K=>{this.m({id:ee,data:K,type:201})},K=>{K instanceof Error?this.m({id:ee,data:{message:K.message,name:K.name,stack:K.stack?K.stack.split?K.stack.split(`
`):K.stack:void 0},type:202}):this.m({id:ee,data:K,type:203})}).finally(()=>{he.dispose(),this.d.delete(L.id)});const he=(0,l.$Rc)(()=>H.cancel());this.d.set(L.id,he)}t(L){const U=this.b.get(L.channelName);if(!U){this.v(L);return}const H=L.id,ee=U.listen(this.j,L.name,L.arg)(he=>this.m({id:H,data:he,type:204}));this.d.set(L.id,ee)}u(L){const U=this.d.get(L.id);U&&(U.dispose(),this.d.delete(L.id))}v(L){let U=this.g.get(L.channelName);U||(U=[],this.g.set(L.channelName,U));const H=setTimeout(()=>{console.error(`Unknown channel: ${L.channelName}`),L.type===100&&this.m({id:L.id,data:{name:"Unknown channel",message:`Channel name '${L.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);U.push({request:L,timeoutTimer:H})}w(L){const U=this.g.get(L);if(U){for(const H of U)switch(clearTimeout(H.timeoutTimer),H.request.type){case 100:this.s(H.request);break;case 102:this.t(H.request);break}this.g.delete(L)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=C;var I;(function(V){V[V.LocalSide=0]="LocalSide",V[V.OtherSide=1]="OtherSide"})(I||(e.RequestInitiator=I={}));class E{constructor(L,U=null){this.l=L,this.a=!1,this.b=$.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new f.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(H=>this.s(H)),this.j=U}getChannel(L){const U=this;return{call(H,q,ee){return U.a?Promise.reject(new S.$5):U.m(L,H,q,ee)},listen(H,q){return U.a?f.Event.None:U.o(L,H,q)}}}m(L,U,H,q=j.CancellationToken.None){const ee=this.g++,K={id:ee,type:100,channelName:L,name:U,arg:H};if(q.isCancellationRequested)return Promise.reject(new S.$5);let O;return new Promise((_,z)=>{if(q.isCancellationRequested)return z(new S.$5);const x=()=>{const se=le=>{switch(le.type){case 201:this.f.delete(ee),_(le.data);break;case 202:{this.f.delete(ee);const ge=new Error(le.data.message);ge.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ge.name=le.data.name,z(ge);break}case 203:this.f.delete(ee),z(le.data);break}};this.f.set(ee,se),this.p(K)};let N=null;this.b===$.Idle?x():(N=(0,R.$Tg)(se=>this.u()),N.then(()=>{N=null,x()}));const B=()=>{N?(N.cancel(),N=null):this.p({id:ee,type:101}),z(new S.$5)},Q=q.onCancellationRequested(B);O=(0,l.$Qc)((0,l.$Rc)(B),Q),this.d.add(O)}).finally(()=>{O.dispose(),this.d.delete(O)})}o(L,U,H){const q=this.g++,he={id:q,type:102,channelName:L,name:U,arg:H};let K=null;const O=new f.$Vd({onWillAddFirstListener:()=>{K=(0,R.$Tg)(_=>this.u()),K.then(()=>{K=null,this.d.add(O),this.p(he)})},onDidRemoveLastListener:()=>{K?(K.cancel(),K=null):(this.d.delete(O),this.p({id:q,type:103}))}}),F=_=>O.fire(_.data);return this.f.set(q,F),O.event}p(L){switch(L.type){case 100:case 102:{const U=this.q([L.type,L.id,L.channelName,L.name],L.arg);this.j?.logOutgoing(U,L.id,0,`${y(L.type)}: ${L.channelName}.${L.name}`,L.arg);return}case 101:case 103:{const U=this.q([L.type,L.id]);this.j?.logOutgoing(U,L.id,0,y(L.type));return}}}q(L,U=void 0){const H=new t;return a(H,L),a(H,U),this.r(H.buffer)}r(L){try{return this.l.send(L),L.byteLength}catch{return 0}}s(L){const U=new c(L),H=b(U),q=b(U),ee=H[0];switch(ee){case 200:return this.j?.logIncoming(L.byteLength,0,0,g(ee)),this.t({type:H[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(L.byteLength,H[1],0,g(ee),q),this.t({type:H[0],id:H[1],data:q})}}t(L){if(L.type===200){this.b=$.Idle,this.k.fire();return}this.f.get(L.id)?.(L)}get onDidInitializePromise(){return f.Event.toPromise(this.onDidInitialize)}u(){return this.b===$.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=E,ve([D.$xh],E.prototype,"onDidInitializePromise",null);class A{get connections(){const L=[];return this.f.forEach(U=>L.push(U)),L}constructor(L){this.a=new Map,this.f=new Set,this.g=new f.$Vd,this.onDidAddConnection=this.g.event,this.h=new f.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new l.$Sc,this.j.add(L(({protocol:U,onDidClientDisconnect:H})=>{const q=f.Event.once(U.onMessage);this.j.add(q(ee=>{const he=new c(ee),K=b(he),O=new C(U,K),F=new E(U);this.a.forEach((z,x)=>O.registerChannel(x,z));const _={channelServer:O,channelClient:F,ctx:K};this.f.add(_),this.g.fire(_),this.j.add(H(()=>{O.dispose(),F.dispose(),this.f.delete(_),this.h.fire(_)}))}))}))}getChannel(L,U){const H=this;return{call(q,ee,he){let K;if((0,v.$Wf)(U)){const F=(0,P.$4b)(H.connections.filter(U));K=F?Promise.resolve(F):f.Event.toPromise(f.Event.filter(H.onDidAddConnection,U))}else K=U.routeCall(H,q,ee);const O=K.then(F=>F.channelClient.getChannel(L));return T(O).call(q,ee,he)},listen(q,ee){if((0,v.$Wf)(U))return H.k(L,U,q,ee);const he=U.routeEvent(H,q,ee).then(K=>K.channelClient.getChannel(L));return T(he).listen(q,ee)}}}k(L,U,H,q){const ee=this;let he;const K=new f.$Vd({onWillAddFirstListener:()=>{he=new l.$Sc;const O=new f.$2d,F=new Map,_=x=>{const B=x.channelClient.getChannel(L).listen(H,q),Q=O.add(B);F.set(x,Q)},z=x=>{const N=F.get(x);N&&(N.dispose(),F.delete(x))};ee.connections.filter(U).forEach(_),f.Event.filter(ee.onDidAddConnection,U)(_,void 0,he),ee.onDidRemoveConnection(z,void 0,he),O.event(K.fire,K,he),he.add(O)},onDidRemoveLastListener:()=>{he?.dispose(),he=void 0}});return K.event}registerChannel(L,U){this.a.set(L,U);for(const H of this.f)H.channelServer.registerChannel(L,U)}dispose(){this.j.dispose();for(const L of this.f)L.channelClient.dispose(),L.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=A;class M{constructor(L,U,H=null){const q=new t;a(q,U),L.send(q.buffer),this.a=new E(L,H),this.d=new C(L,U,H)}getChannel(L){return this.a.getChannel(L)}registerChannel(L,U){this.d.registerChannel(L,U)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=M;function T(V){return{call(L,U,H){return V.then(q=>q.call(L,U,H))},listen(L,U){const H=new f.$5d;return V.then(q=>H.input=q.listen(L,U)),H.event}}}e.$Lh=T;function W(V){let L=!1;return{call(U,H,q){return L?V.call(U,H,q):(0,R.$7g)(0).then(()=>L=!0).then(()=>V.call(U,H,q))},listen(U,H){if(L)return V.listen(U,H);const q=new f.$5d;return(0,R.$7g)(0).then(()=>L=!0).then(()=>q.input=V.listen(U,H)),q.event}}}e.$Mh=W;class G{constructor(L){this.a=L}routeCall(L){return this.b(L)}routeEvent(L){return this.b(L)}async b(L){for(const U of L.connections)if(await Promise.resolve(this.a(U.ctx)))return Promise.resolve(U);return await f.Event.toPromise(L.onDidAddConnection),await this.b(L)}}e.$Nh=G;var J;(function(V){function L(ee,he,K){const O=ee,F=K&&K.disableMarshalling,_=new Map;for(const z in O)H(z)&&_.set(z,f.Event.buffer(O[z],!0,void 0,he));return new class{listen(z,x,N){const B=_.get(x);if(B)return B;if(q(x)){const Q=O[x];if(typeof Q=="function")return Q.call(O,N)}throw new S.$bb(`Event not found: ${x}`)}call(z,x,N){const B=O[x];if(typeof B=="function"){if(!F&&Array.isArray(N))for(let se=0;se<N.length;se++)N[se]=(0,p.$Ch)(N[se]);let Q=B.apply(O,N);return Q instanceof Promise||(Q=Promise.resolve(Q)),Q}throw new S.$bb(`Method not found: ${x}`)}}}V.fromService=L;function U(ee,he){const K=he&&he.disableMarshalling;return new Proxy({},{get(O,F){if(typeof F=="string")return he?.properties?.has(F)?he.properties.get(F):q(F)?function(_){return ee.listen(F,_)}:H(F)?ee.listen(F):async function(..._){let z;he&&!(0,v.$Rf)(he.context)?z=[he.context,..._]:z=_;const x=await ee.call(F,z);return K?x:(0,p.$Ch)(x)};throw new S.$bb(`Property not found: ${String(F)}`)}})}V.toService=U;function H(ee){return ee[0]==="o"&&ee[1]==="n"&&k.$$e(ee.charCodeAt(2))}function q(ee){return/^onDynamic/.test(ee)&&k.$$e(ee.charCodeAt(9))}})(J||(e.ProxyChannel=J={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function re(V){if(Array.isArray(V))return V;if(V&&typeof V=="object"&&typeof V.toString=="function"){const L=V.toString();if(L!=="[object Object]")return L}return V}function ue(V){return Array.isArray(V)?V.map(re):re(V)}function Z(V,L,U,H,q,ee,he){he=ue(he);const K=ce[q],O=K[H%K.length];let F=[`%c[${V}]%c[${String(L).padStart(7," ")}]%c[len: ${String(U).padStart(5," ")}]%c${String(H).padStart(5," ")} - ${ee}`,"color: darkgreen","color: grey","color: grey",`color: ${O}`];/\($/.test(ee)?(F=F.concat(he),F.push(")")):F.push(he),console.log.apply(console,F)}class Y{constructor(L,U){this.d=L,this.f=U,this.a=0,this.b=0}logOutgoing(L,U,H,q,ee){this.b+=L,Z(this.d,this.b,L,U,H,q,ee)}logIncoming(L,U,H,q,ee){this.a+=L,Z(this.f,this.a,L,U,H,q,ee)}}e.$Oh=Y}),define(oe[157],ae([0,1,17,3,43]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EU=e.$DU=void 0;class j{constructor(f){this.a=f,this.onMessage=R.Event.fromDOMEventEmitter(this.a,"message",l=>l.data?P.$je.wrap(l.data):P.$je.alloc(0)),f.start()}send(f){this.a.postMessage(f.buffer)}disconnect(){this.a.close()}}e.$DU=j;class D extends s.$Kh{constructor(f,l){const p=new j(f);super(p,l),this.b=p}dispose(){this.b.disconnect(),super.dispose()}}e.$EU=D}),define(oe[110],ae([0,1,17,3,2,43]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.ProtocolConstants=e.$Ph=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var D;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(D||(e.SocketDiagnosticsEventType=D={}));var S;(function(i){i.enableDiagnostics=!1,i.records=[];const n=new WeakMap;let a=0;function b(I,E){if(!n.has(I)){const A=String(++a);n.set(I,A)}return n.get(I)}function C(I,E,A,M){if(!i.enableDiagnostics)return;const T=b(I,E);if(M instanceof P.$je||M instanceof Uint8Array||M instanceof ArrayBuffer||ArrayBuffer.isView(M)){const W=P.$je.alloc(M.byteLength);W.set(M),i.records.push({timestamp:Date.now(),id:T,label:E,type:A,buff:W})}else i.records.push({timestamp:Date.now(),id:T,label:E,type:A,data:M})}i.traceSocketEvent=C})(S||(e.SocketDiagnostics=S={}));var f;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(f||(e.SocketCloseEventType=f={}));let l=null;function p(){return l||(l=P.$je.alloc(0)),l}class k{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,a){if(n===0)return p();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const E=this.a[0];return a&&(this.a.shift(),this.b-=n),E}if(this.a[0].byteLength>n){const E=this.a[0].slice(0,n);return a&&(this.a[0]=this.a[0].slice(n),this.b-=n),E}const b=P.$je.alloc(n);let C=0,I=0;for(;n>0;){const E=this.a[I];if(E.byteLength>n){const A=E.slice(0,n);b.set(A,C),C+=n,a&&(this.a[I]=E.slice(n),this.b-=n),n-=n}else b.set(E,C),C+=E.byteLength,a?(this.a.shift(),this.b-=E.byteLength):I++,n-=E.byteLength}return b}}e.$Ph=k;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume",i[i.KeepAlive=9]="KeepAlive"})(v||(v={}));function u(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var y;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",i[i.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(y||(e.ProtocolConstants=y={}));class w{constructor(n,a,b,C){this.type=n,this.id=a,this.ack=b,this.data=C,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends s.$Tc{constructor(n){super(),this.f=this.B(new R.$Vd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new k,this.B(this.a.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const a=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=a.readUInt32BE(9),this.g.messageType=a.readUInt8(0),this.g.id=a.readUInt32BE(1),this.g.ack=a.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:u(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const b=this.g.messageType,C=this.g.id,I=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",a),this.f.fire(new w(b,C,I,a)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class ${constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=P.$je.alloc(13);a.writeUInt8(n.type,0),a.writeUInt32BE(n.id,1),a.writeUInt32BE(n.ack,5),a.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:u(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(a,n.data)}g(n,a){const b=this.f===0;return this.d.push(n,a),this.f+=n.byteLength+a.byteLength,b}h(){const n=P.$je.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,a){this.g(n,a)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class d extends s.$Tc{constructor(n){super(),this.f=new R.$Vd,this.onMessage=this.f.event,this.g=new R.$Vd,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new $(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(a=>{a.type===1&&this.f.fire(a.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new w(1,0,0,n))}}e.$Qh=d;class h extends j.$Kh{static fromSocket(n,a){return new h(new d(n),a)}get onDidDispose(){return this.b.onDidDispose}constructor(n,a,b=null){super(n,a,b),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.$Rh=h;class m{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new R.$Vd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.$Sh=m;class c{constructor(n){this.data=n,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let n=0,a=this.a;for(;a;)a=a.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let a=0,b=this.a;for(;b;)n[a++]=b.data,b=b.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const a=new c(n);if(!this.a){this.a=a,this.b=a;return}this.b.next=a,this.b=a}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const n=Date.now();for(let a=0;a<o.a;a++)this.c[a]=n-1e3*a;setInterval(()=>{for(let a=o.a;a>=1;a--)this.c[a]=this.c[a-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),a=(1+o.a)*1e3;let b=0;for(let C=0;C<o.a;C++)n-this.c[C]<=a&&b++;return 1-b/o.a}hasHighLoad(){return this.d()>=.5}}class r{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.u=new m,this.onControlMessage=this.u.event,this.v=new m,this.onMessage=this.v.event,this.w=new m,this.onDidDispose=this.w.event,this.x=new m,this.onSocketClose=this.x.event,this.y=new m,this.onSocketTimeout=this.y.event,this.s=n.loadEstimator??o.getInstance(),this.t=n.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new s.$Sc,this.o=n.socket,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new w(5,0,0,p());this.p.write(n),this.p.flush()}sendPause(){const n=new w(7,0,0,p());this.p.write(n)}sendResume(){const n=new w(8,0,0,p());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,a){this.a=!0,this.r.dispose(),this.r=new s.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.r.add(new $(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(b=>this.z(b))),this.r.add(this.o.onClose(b=>this.x.fire(b))),this.q.acceptChunk(a)}endAcceptReconnection(){this.a=!1,this.h=this.g;const n=new w(3,0,this.h,p());this.p.write(n);const a=this.b.toArray();for(let b=0,C=a.length;b<C;b++)this.p.write(a[b]);this.B()}acceptDisconnect(){this.w.fire()}z(n){if(n.ack>this.d){this.d=n.ack;do{const a=this.b.peek();if(a&&a.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const a=Date.now();a-this.m>1e4&&(this.m=a,this.p.write(new w(6,0,0,p())))}else this.g=n.id,this.j=Date.now(),this.A(),this.v.fire(n.data);break}case 2:{this.u.fire(n.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const a=this.b.toArray();for(let b=0,C=a.length;b<C;b++)this.p.write(a[b]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const a=++this.c;this.h=this.g;const b=new w(1,a,this.h,n);this.b.push(b),this.a||(this.p.write(b),this.B())}sendControl(n){const a=new w(2,0,0,n);this.p.write(a)}A(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-n+5)}B(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),a=Date.now()-n.writtenTime,b=Date.now()-this.q.lastReadTime,C=Date.now()-this.n;if(a>=2e4&&b>=2e4&&C>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:a,timeSinceLastReceivedSomeData:b});return}const I=Math.max(2e4-a,2e4-b,2e4-C,500);this.f=setTimeout(()=>{this.f=null,this.B()},I)}C(){if(this.g<=this.h)return;this.h=this.g;const n=new w(3,0,this.h,p());this.p.write(n)}D(){this.h=this.g;const n=new w(9,0,this.h,p());this.p.write(n)}}e.$Th=r}),define(oe[37],ae([0,1,15,14,13]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$AU=void 0;class j{constructor(){this.a=new WeakMap}on(S,f){const l=(p,...k)=>{this.b(S,p)&&f(p,...k)};return this.a.set(f,l),P.ipcMain.on(S,l),this}once(S,f){return P.ipcMain.once(S,(l,...p)=>{this.b(S,l)&&f(l,...p)}),this}handle(S,f){return P.ipcMain.handle(S,(l,...p)=>this.b(S,l)?f(l,...p):Promise.reject(`Invalid channel '${S}' or sender for ipcMain.handle() usage.`)),this}removeHandler(S){return P.ipcMain.removeHandler(S),this}removeListener(S,f){const l=this.a.get(f);return l&&(P.ipcMain.removeListener(S,l),this.a.delete(f)),this}b(S,f){if(!S||!S.startsWith("vscode:"))return(0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because the channel is unknown.`),!1;const l=f.senderFrame,p=l.url;if(!p||p==="about:blank")return!0;let k="unknown";try{k=new URL(p).host}catch{return(0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because of a malformed URL '${p}'.`),!1}return k!==s.$ng?((0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because of a bad origin of '${k}'.`),!1):l.parent!==null?((0,R.$1)(`Refused to handle ipcMain event for channel '${S}' because sender of origin '${k}' is not a main frame.`),!1):!0}}e.$AU=new j}),define(oe[158],ae([0,1,15,37,146]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BU=void 0;function j(){R.$AU.on(s.$yU,(S,f,l,p,k)=>{const v=D(S,p,l);v.popup({x:k?k.x:void 0,y:k?k.y:void 0,positioningItem:k?k.positioningItem:void 0,callback:()=>{v&&S.sender.send(s.$zU,f)}})})}e.$BU=j;function D(S,f,l){const p=new P.Menu;return l.forEach(k=>{let v;k.type==="separator"?v=new P.MenuItem({type:k.type}):Array.isArray(k.submenu)?v=new P.MenuItem({submenu:D(S,f,k.submenu),label:k.label}):v=new P.MenuItem({label:k.label,type:k.type,accelerator:k.accelerator,checked:k.checked,enabled:k.enabled,visible:k.visible,click:(u,y,w)=>S.sender.send(f,k.id,w)}),p.append(v)}),p}}),define(oe[159],ae([0,1,37,17,3,2,43,147]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HU=void 0;function f(p,k){const v=s.Event.fromNodeEventEmitter(P.$AU,k,(y,w)=>({event:y,message:w})),u=s.Event.filter(v,({event:y})=>y.sender.id===p);return s.Event.map(u,({message:y})=>y&&R.$je.wrap(y))}class l extends D.$Jh{static{this.b=new Map}static d(){const k=s.Event.fromNodeEventEmitter(P.$AU,"vscode:hello",({sender:v})=>v);return s.Event.map(k,v=>{const u=v.id;l.b.get(u)?.dispose();const w=new s.$Vd;l.b.set(u,(0,j.$Rc)(()=>w.fire()));const g=f(u,"vscode:message"),$=s.Event.any(s.Event.signal(f(u,"vscode:disconnect")),w.event);return{protocol:new S.$GU(v,g),onDidClientDisconnect:$}})}constructor(){super(l.d())}}e.$HU=l}),define(oe[111],ae([0,1,37,3,32,157]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JU=e.$IU=void 0;class D extends j.$EU{constructor(l,p){super({addEventListener:(k,v)=>l.addListener(k,v),removeEventListener:(k,v)=>l.removeListener(k,v),postMessage:k=>l.postMessage(k),start:()=>l.start(),close:()=>l.close()},p)}}e.$IU=D;async function S(f){if(f.isDestroyed()||f.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.$qg)();f.webContents.send("vscode:createMessageChannel",l);const p=R.Event.fromNodeEventEmitter(P.$AU,"vscode:createMessageChannelResult",(v,u)=>({nonce:u,port:v.ports[0]})),{port:k}=await R.Event.toPromise(R.Event.once(R.Event.filter(p,v=>v.nonce===l)));return k}e.$JU=S}),define(oe[160],ae([0,1,48,8,17,23,154,14,3,2,35,89,76,43]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class y extends u.$Hh{constructor($){super({send:d=>{try{process.send?.(d.buffer.toString("base64"))}catch{}},onMessage:f.Event.fromNodeEventEmitter(process,"message",d=>s.$je.wrap(Buffer.from(d,"base64")))},$),process.once("disconnect",()=>this.dispose())}}e.$qq=y;class w{constructor($,d){this.i=$,this.j=d,this.c=new Set,this.g=new Map,this.h=new f.$Vd,this.onDidProcessExit=this.h.event;const h=d&&d.timeout?d.timeout:6e4;this.b=new R.$3g(h),this.d=null,this.f=null}getChannel($){const d=this;return{call(h,m,c){return d.k($,h,m,c)},listen(h,m){return d.l($,h,m)}}}k($,d,h,m=j.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(S.$6());this.b.cancel();const c=this.n($),t=(0,R.$Tg)(i=>c.call(d,h,i)),o=m.onCancellationRequested(()=>t.cancel()),r=(0,l.$Rc)(()=>t.cancel());return this.c.add(r),t.finally(()=>{o.dispose(),this.c.delete(r),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l($,d,h){if(!this.b)return f.Event.None;this.b.cancel();let m;const c=new f.$Vd({onWillAddFirstListener:()=>{m=this.n($).listen(d,h)(c.fire,c),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return c.event}get m(){if(!this.f){const $=this.j&&this.j.args?this.j.args:[],d=Object.create(null);d.env={...(0,p.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(d.env={...d.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(d.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(d.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(d.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),d.execArgv===void 0&&(d.execArgv=process.execArgv.filter(n=>!/^--inspect(-brk)?=/.test(n)).filter(n=>!n.startsWith("--vscode-"))),(0,v.$Sl)(d.env),this.d=(0,P.fork)(this.i,$,d);const h=new f.$Vd;f.Event.fromNodeEventEmitter(this.d,"message",n=>n)(n=>{if((0,D.$mq)(n)){(0,D.log)(n,`IPC Library: ${this.j.serverName}`);return}h.fire(s.$je.wrap(Buffer.from(n,"base64")))});const c=this.j.useQueue?(0,k.$Ul)(this.d):this.d,t=n=>this.d&&this.d.connected&&c.send(n.buffer.toString("base64")),o=h.event,r={send:t,onMessage:o};this.f=new u.$Ih(r);const i=()=>this.o();process.once("exit",i),this.d.on("error",n=>console.warn('IPC "'+this.j.serverName+'" errored with '+n)),this.d.on("exit",(n,a)=>{process.removeListener("exit",i),this.c.forEach(b=>(0,l.$Oc)(b)),this.c.clear(),n!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+n+" and signal "+a),this.b?.cancel(),this.o(),this.h.fire({code:n,signal:a})})}return this.f}n($){let d=this.g.get($);return d||(d=this.m.getChannel($),this.g.set($,d)),d}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=w}),define(oe[112],ae([0,1,8,3,2,77,12]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.StorageState=e.$pp=e.StorageHint=void 0;var S;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S||(e.StorageHint=S={}));function f(v){const u=v;return u?.changed instanceof Map||u?.deleted instanceof Set}e.$pp=f;var l;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(l||(e.StorageState=l={}));class p extends s.$Tc{static{this.a=100}constructor(u,y=Object.create(null)){super(),this.r=u,this.s=y,this.b=this.B(new R.$Yd),this.onDidChangeStorage=this.b.event,this.c=l.None,this.f=new Map,this.g=this.B(new P.$4g(p.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(u=>this.u(u)))}u(u){this.b.pause();try{u.changed?.forEach((y,w)=>this.w(w,y)),u.deleted?.forEach(y=>this.w(y,void 0))}finally{this.b.resume()}}w(u,y){if(this.c===l.Closed)return;let w=!1;(0,D.$Rf)(y)?w=this.f.delete(u):this.f.get(u)!==y&&(this.f.set(u,y),w=!0),w&&this.b.fire({key:u,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===l.None&&(this.c=l.Initialized,this.s.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(u,y){const w=this.f.get(u);return(0,D.$Rf)(w)?y:w}getBoolean(u,y){const w=this.get(u);return(0,D.$Rf)(w)?y:w==="true"}getNumber(u,y){const w=this.get(u);return(0,D.$Rf)(w)?y:parseInt(w,10)}getObject(u,y){const w=this.get(u);return(0,D.$Rf)(w)?y:(0,j.$Bh)(w)}async set(u,y,w=!1){if(this.c===l.Closed)return;if((0,D.$Rf)(y))return this.delete(u,w);const g=(0,D.$Kf)(y)||Array.isArray(y)?(0,j.$Ah)(y):String(y);if(this.f.get(u)!==g)return this.f.set(u,g),this.j.set(u,g),this.h.delete(u),this.b.fire({key:u,external:w}),this.D()}async delete(u,y=!1){if(!(this.c===l.Closed||!this.f.delete(u)))return this.h.has(u)||this.h.add(u),this.j.delete(u),this.b.fire({key:u,external:y}),this.D()}async optimize(){if(this.c!==l.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=l.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const u={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(u).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(u){if(this.z)return this.D(u)}async D(u){return this.s.hint===S.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),u)}async whenFlushed(){if(this.z)return new Promise(u=>this.n.push(u))}isInMemory(){return this.s.hint===S.STORAGE_IN_MEMORY}}e.$qp=p;class k{constructor(){this.onDidChangeItemsExternal=R.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(u){u.insert?.forEach((y,w)=>this.a.set(w,y)),u.delete?.forEach(y=>this.a.delete(y))}async optimize(){}async close(){}}e.$rp=k}),define(oe[161],ae([0,1,8,3,31,9,21]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6U=void 0;class S{static{this.IN_MEMORY_PATH=":memory:"}get onDidChangeItemsExternal(){return R.Event.None}static{this.a=2e3}static{this.b=256}constructor(p,k=Object.create(null)){this.g=p,this.h=k,this.c=(0,j.$nc)(this.g),this.d=new f(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,k=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(u=>k.set(u.key,u.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${k.size} rows`),k}async updateItems(p){const k=await this.f;return this.j(k,p)}j(p,k){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${k.insert?(0,s.$yc)(k.insert):"0"}), delete(${k.delete?(0,s.$zc)(k.delete):"0"})`),this.t(p,()=>{const v=k.insert,u=k.delete;if(v&&v.size>0){const y=[];y.push([]);let w=0;v.forEach((g,$)=>{let d=y[w];d.length>S.b&&(w++,d=[],y.push(d)),d.push($,g)}),y.forEach(g=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(g.length/2).fill("(?,?)").join(",")}`,$=>$.run(g),()=>{const $=[];let d=0;return v.forEach((h,m)=>{$.push(m),d+=h.length}),`Keys: ${$.join(", ")} Length: ${d}`})})}if(u&&u.size){const y=[];y.push([]);let w=0;u.forEach(g=>{let $=y[w];$.length>S.b&&(w++,$=[],y.push($)),$.push(g)}),y.forEach(g=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(g.length).fill("?").join(",")})`,$=>$.run(g),()=>{const $=[];return u.forEach(d=>{$.push(d)}),`Keys: ${$.join(", ")}`})})}})}async optimize(){this.d.trace(`[storage ${this.c}] vacuum()`);const p=await this.f;return this.q(p,"VACUUM")}async close(p){this.d.trace(`[storage ${this.c}] close()`);const k=await this.f;return this.k(k,p)}k(p,k){return new Promise((v,u)=>{p.db.close(y=>(y&&this.o(p,`[storage ${this.c}] close(): ${y}`),this.g===S.IN_MEMORY_PATH?v():!p.isErroneous&&!p.isInMemory?this.l().then(v,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),v())):typeof k=="function"?D.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const g=()=>this.k(w,void 0);return this.j(w,{insert:k()}).then(()=>g(),$=>(g(),Promise.reject($)))})).then(v,u):u(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return D.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const k=await this.f,v=await this.r(k,p?"PRAGMA integrity_check":"PRAGMA quick_check"),u=p?v.integrity_check:v.quick_check;return k.isErroneous?`${u} (last error: ${k.lastError})`:k.isInMemory?`${u} (in-memory!)`:u}async n(p,k=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${k})`);try{return await this.p(p)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&k)return await(0,P.$7g)(S.a),this.n(p,!1);try{await D.Promises.unlink(p);try{await D.Promises.rename(this.m(p),p,!1)}catch{}return await this.p(p)}catch(u){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${u}`),this.p(S.IN_MEMORY_PATH)}}}o(p,k){p.isErroneous=!0,p.lastError=k,this.d.error(k)}p(p){return new Promise((k,v)=>{new Promise((u,y)=>{X(["@vscode/sqlite3"],u,y)}).then(u=>{const y={db:new(this.d.isTracing?u.verbose().Database:u.Database)(p,w=>w?y.db&&w.code!=="SQLITE_CANTOPEN"?y.db.close(()=>v(w)):v(w):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>k(y),g=>y.db.close(()=>v(g)))),isInMemory:p===S.IN_MEMORY_PATH};y.db.on("error",w=>this.o(y,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&y.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},v)})}q(p,k){return new Promise((v,u)=>{p.db.exec(k,y=>y?(this.o(p,`[storage ${this.c}] exec(): ${y}`),u(y)):v())})}r(p,k){return new Promise((v,u)=>{p.db.get(k,(y,w)=>y?(this.o(p,`[storage ${this.c}] get(): ${y}`),u(y)):v(w))})}s(p,k){return new Promise((v,u)=>{p.db.all(k,(y,w)=>y?(this.o(p,`[storage ${this.c}] all(): ${y}`),u(y)):v(w))})}t(p,k){return new Promise((v,u)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),k(),p.db.run("END TRANSACTION",y=>y?(this.o(p,`[storage ${this.c}] transaction(): ${y}`),u(y)):v())})})}u(p,k,v,u){const y=p.db.prepare(k),w=g=>{this.o(p,`[storage ${this.c}] prepare(): ${g} (${k}). Details: ${u()}`)};y.on("error",w),v(y),y.finalize(g=>{g&&w(g),y.removeListener("error",w)})}}e.$6U=S;class f{static{this.a="VSCODE_TRACE_STORAGE"}constructor(p){p&&typeof p.logTrace=="function"&&process.env[f.a]&&(this.b=p.logTrace),p&&typeof p.logError=="function"&&(this.c=p.logError)}get isTracing(){return!!this.b}trace(p){this.b?.(p)}error(p){this.c?.(p)}}}),define(oe[162],ae([11,10]),function(X,e){return X.create("vs/code/electron-main/app",e)}),define(oe[163],ae([11,10]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[164],ae([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[165],ae([11,10]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(oe[166],ae([11,10]),function(X,e){return X.create("vs/platform/dialogs/common/dialogs",e)}),define(oe[167],ae([11,10]),function(X,e){return X.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(oe[168],ae([11,10]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(oe[169],ae([11,10]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(oe[170],ae([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[171],ae([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[172],ae([11,10]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[173],ae([11,10]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[174],ae([11,10]),function(X,e){return X.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(oe[175],ae([11,10]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(oe[176],ae([11,10]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(oe[177],ae([11,10]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(oe[178],ae([11,10]),function(X,e){return X.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(oe[179],ae([11,10]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[180],ae([11,10]),function(X,e){return X.create("vs/platform/issue/electron-main/issueMainService",e)}),define(oe[181],ae([11,10]),function(X,e){return X.create("vs/platform/menubar/electron-main/menubar",e)}),define(oe[182],ae([11,10]),function(X,e){return X.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(oe[183],ae([11,10]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(oe[184],ae([11,10]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(oe[185],ae([11,10]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[186],ae([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[187],ae([11,10]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[188],ae([11,10]),function(X,e){return X.create("vs/platform/update/common/update.config.contribution",e)}),define(oe[189],ae([11,10]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[190],ae([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowImpl",e)}),define(oe[191],ae([11,10]),function(X,e){return X.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(oe[192],ae([11,10]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(oe[193],ae([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(oe[194],ae([11,10]),function(X,e){return X.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(oe[195],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ccb=e.$Bcb=void 0;function P(s){return s&&s.hasOwnProperty("folderUri")}e.$Bcb=P;function R(s){return s&&s.hasOwnProperty("workspace")}e.$Ccb=R}),define(oe[196],ae([0,1,7]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E0b=e.$D0b=e.$C0b=void 0;function R(D){return typeof D?.backupFolder=="string"}e.$C0b=R;function s(D){let S=[];try{Array.isArray(D.workspaces)&&(S=D.workspaces.map(f=>({workspace:{id:f.id,configPath:P.URI.parse(f.configURIPath)},remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$D0b=s;function j(D){let S=[];try{Array.isArray(D.folders)&&(S=D.folders.map(f=>({folderUri:P.URI.parse(f.folderUri),remoteAuthority:f.remoteAuthority})))}catch{}return S}e.$E0b=j}),define(oe[197],ae([0,1,14,165]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function j(...l){switch(l.length){case 1:return(0,R.localize)(0,null,l[0]);case 2:return(0,R.localize)(1,null,l[0],l[1]);case 3:return(0,R.localize)(2,null,l[0],l[1],l[2]);default:return}}const D=(0,R.localize)(3,null),S=(0,R.localize)(4,null);class f{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,P.$8)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(j("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(j("&&"));break;case 124:this.h(124)?this.k(16):this.l(j("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const k=this.d,v=this.c.substring(this.d,this.e),u={type:19,offset:this.d,lexeme:v};this.g.push({offset:k,lexeme:v,additionalInfo:p}),this.f.push(u)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const k=this.c.substring(this.d,this.e),v=f.b.get(k);v?this.k(v):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(D);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,k=!1,v=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(S);return}const y=this.c.charCodeAt(p);if(k)k=!1;else if(y===47&&!v){p++;break}else y===91?v=!0:y===92?k=!0:y===93&&(v=!1);p++}for(;p<this.c.length&&f.a.has(this.c.charCodeAt(p));)p++;this.e=p;const u=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:u,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=f}),define(oe[198],ae([0,1,3,2]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$co=e.$bo=void 0;class s{constructor(){this.a=new P.$Vd,this.b=new P.$Vd,this.c=new P.$Vd,this.d=new P.$Vd}static{this.ChannelName="extensionhostdebugservice"}call(S,f,l){switch(f){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(S,f,l){switch(f){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.$bo=s;class j extends R.$Tc{constructor(S){super(),this.b=S}reload(S){this.b.call("reload",[S])}get onReload(){return this.b.listen("reload")}close(S){this.b.call("close",[S])}get onClose(){return this.b.listen("close")}attachSession(S,f,l){this.b.call("attach",[S,f,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(S,f){this.b.call("terminate",[S,f])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(S,f){return this.b.call("openExtensionDevelopmentHostWindow",[S,f])}}e.$co=j}),define(oe[199],ae([0,1,149,50,13,9,36,19,7]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$xm=/^([^.]+\..+)[:=](.+)$/;class l{get appRoot(){return(0,j.$mc)(s.$og.asFileUri("").fsPath)}get userHome(){return f.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return f.URI.file((0,j.$jc)(this.userDataPath,"User"))}get tmpDir(){return f.URI.file(this.b.tmpDir)}get cacheHome(){return f.URI.file(this.userDataPath)}get stateResource(){return(0,S.$Hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:s.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,S.$Hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const u=(0,P.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,j.$jc)(this.userDataPath,"logs",u)}return f.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,S.$Hg)(f.URI.file((0,j.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,S.$Hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,S.$Hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,S.$Hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const u=D.env.VSCODE_PORTABLE;return u?f.URI.file((0,j.$jc)(u,"argv.json")):(0,S.$Hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return f.URI.file((0,j.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const u=this.args["builtin-extensions-dir"];return u?(0,j.$kc)(u):(0,j.$hc)((0,j.$jc)(s.$og.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const u=this.args["extensions-download-dir"];return u?f.URI.file((0,j.$kc)(u)):f.URI.file((0,j.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const u=this.args["extensions-dir"];if(u)return(0,j.$kc)(u);const y=D.env.VSCODE_EXTENSIONS;if(y)return y;const w=D.env.VSCODE_PORTABLE;return w?(0,j.$jc)(w,"extensions"):(0,S.$Hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const u=this.args.extensionDevelopmentPath;if(Array.isArray(u))return u.map(y=>/^[^:/?#]+?:\/\//.test(y)?f.URI.parse(y):f.URI.file((0,j.$hc)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(u=>u==="ui"||u==="workspace"||u==="web"?u:"workspace")}get extensionTestsLocationURI(){const u=this.args.extensionTestsPath;if(u)return/^[^:/?#]+?:\/\//.test(u)?f.URI.parse(u):f.URI.file((0,j.$hc)(u))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const u=this.args["disable-extension"];if(u){if(typeof u=="string")return[u];if(Array.isArray(u)&&u.length>0)return u}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!D.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(u=>!e.$xm.test(u))}get extensionLogLevel(){const u=[];for(const y of this.args.log||[]){const w=e.$xm.exec(y);w&&w[1]&&w[2]&&u.push([w[1],w[2]])}return u.length?u:void 0}get serviceMachineIdResource(){return(0,S.$Hg)(f.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const u=D.env.VSCODE_PORTABLE;return u?f.URI.file((0,j.$jc)(u,"policy.json")):(0,S.$Hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(u){this.args.continueOn=u}get args(){return this.a}constructor(u,y,w){this.a=u,this.b=y,this.c=w,this.editSessionId=this.args.editSessionId}}e.$ym=l,ve([R.$xh],l.prototype,"appRoot",null),ve([R.$xh],l.prototype,"userHome",null),ve([R.$xh],l.prototype,"userDataPath",null),ve([R.$xh],l.prototype,"appSettingsHome",null),ve([R.$xh],l.prototype,"tmpDir",null),ve([R.$xh],l.prototype,"cacheHome",null),ve([R.$xh],l.prototype,"stateResource",null),ve([R.$xh],l.prototype,"userRoamingDataHome",null),ve([R.$xh],l.prototype,"userDataSyncHome",null),ve([R.$xh],l.prototype,"sync",null),ve([R.$xh],l.prototype,"machineSettingsResource",null),ve([R.$xh],l.prototype,"workspaceStorageHome",null),ve([R.$xh],l.prototype,"localHistoryHome",null),ve([R.$xh],l.prototype,"keyboardLayoutResource",null),ve([R.$xh],l.prototype,"argvResource",null),ve([R.$xh],l.prototype,"isExtensionDevelopment",null),ve([R.$xh],l.prototype,"untitledWorkspacesHome",null),ve([R.$xh],l.prototype,"builtinExtensionsPath",null),ve([R.$xh],l.prototype,"extensionsPath",null),ve([R.$xh],l.prototype,"extensionDevelopmentLocationURI",null),ve([R.$xh],l.prototype,"extensionDevelopmentKind",null),ve([R.$xh],l.prototype,"extensionTestsLocationURI",null),ve([R.$xh],l.prototype,"debugExtensionHost",null),ve([R.$xh],l.prototype,"logLevel",null),ve([R.$xh],l.prototype,"extensionLogLevel",null),ve([R.$xh],l.prototype,"serviceMachineIdResource",null),ve([R.$xh],l.prototype,"disableTelemetry",null),ve([R.$xh],l.prototype,"disableWorkspaceTrust",null),ve([R.$xh],l.prototype,"useInMemorySecretStorage",null),ve([R.$xh],l.prototype,"policyFile",null);function p(v,u){return k(v["inspect-extensions"],v["inspect-brk-extensions"],5870,u,v.debugId,v.extensionEnvironment)}e.$zm=p;function k(v,u,y,w,g,$){const h=Number(u||v)||(w?null:y),m=h?!!u:!1;let c;if($)try{c=JSON.parse($)}catch{}return{port:h,break:m,debugId:g,env:c}}e.$Am=k}),define(oe[113],ae([0,1,309,4,168]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0;const j={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.$Wl=["tunnel","serve-web"],e.$Xl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,s.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,s.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const D={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function S(w,g,$=D){const d=w.find(a=>a.length>0&&a[0]!=="-"),h={},m=["_"],c=[],t={};let o;for(const a in g){const b=g[a];b.type==="subcommand"?a===d&&(o=b):(b.alias&&(h[a]=b.alias),b.type==="string"||b.type==="string[]"?(m.push(a),b.deprecates&&m.push(...b.deprecates)):b.type==="boolean"&&(c.push(a),b.deprecates&&c.push(...b.deprecates)),b.global&&(t[a]=b))}if(o&&d){const a=t;for(const E in o.options)a[E]=o.options[E];const b=w.filter(E=>E!==d),C=$.getSubcommandReporter?$.getSubcommandReporter(d):void 0,I=S(b,a,C);return{[d]:I,_:[]}}const r=P(w,{string:m,boolean:c,alias:h}),i={},n=r;i._=r._.map(a=>String(a)).filter(a=>a.length>0),delete n._;for(const a in g){const b=g[a];if(b.type==="subcommand")continue;b.alias&&delete n[b.alias];let C=n[a];if(b.deprecates)for(const I of b.deprecates)n.hasOwnProperty(I)&&(C||(C=n[I],C&&$.onDeprecatedOption(I,b.deprecationMessage||(0,s.localize)(38,null,a))),delete n[I]);if(typeof C<"u"){if(b.type==="string[]"){if(Array.isArray(C)||(C=[C]),!b.allowEmptyValue){const I=C.filter(E=>E.length>0);I.length!==C.length&&($.onEmptyValue(a),C=I.length>0?I:void 0)}}else b.type==="string"&&(Array.isArray(C)?(C=C.pop(),$.onMultipleValues(a,C)):!C&&!b.allowEmptyValue&&($.onEmptyValue(a),C=void 0));i[a]=C,b.deprecationMessage&&$.onDeprecatedOption(a,b.deprecationMessage)}delete n[a]}for(const a in n)$.onUnknownOption(a);return i}e.$Yl=S;function f(w,g){let $="";return g.args&&(Array.isArray(g.args)?$=` <${g.args.join("> <")}>`:$=` <${g.args}>`),g.alias?`-${g.alias} --${w}${$}`:`--${w}${$}`}function l(w,g){const $=[];for(const d in w){const h=w[d],m=f(d,h);$.push([m,h.description])}return p($,g)}e.$Zl=l;function p(w,g){const d=w.reduce((c,t)=>Math.max(c,t[0].length),12)+2+1;if(g-d<25)return w.reduce((c,t)=>c.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const h=g-d-1,m=[];for(const c of w){const t=c[0],o=v(c[1],h),r=k(d-t.length-2);m.push("  "+t+r+o[0]);for(let i=1;i<o.length;i++)m.push(k(d)+o[i])}return m}function k(w){return" ".repeat(w)}function v(w,g){const $=[];for(;w.length;){const d=w.length<g?w.length:w.lastIndexOf(" ",g),h=w.slice(0,d).trim();w=w.slice(d),$.push(h)}return $}function u(w,g,$,d,h){const m=process.stdout.isTTY&&process.stdout.columns||80,c=h?.noInputFiles!==!0?`[${(0,s.localize)(39,null)}...]`:"",t=[`${w} ${$}`];t.push(""),t.push(`${(0,s.localize)(40,null)}: ${g} [${(0,s.localize)(41,null)}]${c}`),t.push(""),h?.noPipe!==!0&&(R.$i?t.push((0,s.localize)(42,null,g)):t.push((0,s.localize)(43,null,g)),t.push(""));const o={},r=[];for(const i in d){const n=d[i];if(n.type==="subcommand")n.description&&r.push({command:i,description:n.description});else if(n.description&&n.cat){let a=o[n.cat];a||(o[n.cat]=a={}),a[i]=n}}for(const i in o){const n=i,a=o[n];a&&(t.push(j[n]),t.push(...l(a,m)),t.push(""))}return r.length&&(t.push((0,s.localize)(44,null)),t.push(...p(r.map(i=>[i.command,i.description]),m)),t.push("")),t.join(`
`)}e.$1l=u;function y(w,g){return`${w||(0,s.localize)(45,null)}
${g||(0,s.localize)(46,null)}
${process.arch}`}e.$2l=y}),define(oe[200],ae([0,1,87,198,113]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h$b=void 0;class j extends R.$bo{constructor(S){super(),this.f=S}call(S,f,l){return f==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(S,f,l)}async g(S,f){const l=(0,s.$Yl)(S,s.$Xl);l.debugRenderer=f;const p=l.extensionDevelopmentPath;if(!p)return{success:!1};const[k]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!f)return{success:!0};const v=k.win;if(!v)return{success:!0};const u=v.webContents.debugger;let y=u.isAttached()?1/0:0;const w=(0,P.createServer)(g=>{y++===0&&u.attach();let $=!1;const d=c=>{$||g.write(JSON.stringify(c)+"\0")},h=(c,t,o,r)=>d({method:t,params:o,sessionId:r});v.on("close",()=>{u.removeListener("message",h),g.end(),$=!0}),u.addListener("message",h);let m=Buffer.alloc(0);g.on("data",c=>{m=Buffer.concat([m,c]);for(let t=m.indexOf(0);t!==-1;t=m.indexOf(0)){let o;try{const r=m.slice(0,t).toString("utf8");m=m.slice(t+1),o=JSON.parse(r)}catch(r){console.error("error reading cdp line",r)}u.sendCommand(o.method,o.params,o.sessionId).then(r=>d({id:o.id,sessionId:o.sessionId,result:r})).catch(r=>d({id:o.id,sessionId:o.sessionId,error:{code:0,message:r.message}}))}}),g.on("error",c=>{console.error("error on cdp pipe:",c)}),g.on("close",()=>{$=!0,--y===0&&u.detach()})});return await new Promise(g=>w.listen(0,g)),v.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.$h$b=j}),define(oe[64],ae([0,1,310,169,113]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6l=e.$5l=e.$4l=e.$3l=void 0;function j(k,v){const u=(h,m)=>{console.warn((0,R.localize)(0,null,h,m))},y=h=>{console.warn((0,R.localize)(1,null,h))},w=(h,m)=>{console.warn((0,R.localize)(2,null,h,m))},g=h=>({onUnknownOption:m=>{s.$Wl.includes(h)||console.warn((0,R.localize)(3,null,m,h))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:s.$Wl.includes(h)?g:void 0}),$={onUnknownOption:h=>{console.warn((0,R.localize)(4,null,h))},onMultipleValues:u,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:g},d=(0,s.$Yl)(k,s.$Xl,v?$:void 0);return d.goto&&d._.forEach(h=>P(/^(\w:)?[^:]+(:\d*){0,2}:?$/.test(h),(0,R.localize)(5,null))),d}function D(k){const v=k.findIndex(u=>!/^-/.test(u));if(v>-1)return[...k.slice(0,v),...k.slice(v+1)]}function S(k){let[,...v]=k;process.env.VSCODE_DEV&&(v=D(v)||[]);const u=!p(process.env);return j(v,u)}e.$3l=S;function f(k){let[,,...v]=k;return process.env.VSCODE_DEV&&(v=D(v)||[]),j(v,!0)}e.$4l=f;function l(k,...v){const u=k.indexOf("--");return u===-1?k.push(...v):k.splice(u,0,...v),k}e.$5l=l;function p(k){return k.VSCODE_CLI==="1"}e.$6l=p}),function(){"use strict";function X(e,P,R){function s(D,S){const f=j(D,S),l=[f];return e.isAbsolute(f)||l.unshift(R),e.resolve(...l)}function j(D,S){process.env.VSCODE_DEV&&(S="code-oss-dev");const f=process.env.VSCODE_PORTABLE;if(f)return e.join(f,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,S);const p=D["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(k,"AppData","Roaming")}break;case"darwin":l=e.join(P.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(P.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,S)}return{getUserDataPath:s}}if(typeof define=="function")define(oe[201],ae([114,26,36]),function(e,P,R){return X(e,P,R.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),P=require("os");module.exports=X(e,P,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[90],ae([0,1,26,199,201]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=void 0;class j extends R.$ym{constructor(l,p){super(l,{homeDir:(0,P.homedir)(),tmpDir:(0,P.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,p.nameShort)},p)}}e.$Bm=j;function D(f,l){return(0,R.$Am)(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,l,f.extensionEnvironment)}e.$Cm=D;function S(f,l){return(0,R.$Am)(f["inspect-sharedprocess"],f["inspect-brk-sharedprocess"],5879,l,f.extensionEnvironment)}e.$Dm=S}),define(oe[202],ae([0,1,46,26,33]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$z_b=void 0;function j(D){const S=(0,s.$dg)((0,R.tmpdir)());try{return(0,P.writeFileSync)(S,""),D&&console.log(`Marker file for --wait created: ${S}`),S}catch(f){D&&console.error(`Failed to create marker file for --wait: ${f}`);return}}e.$z_b=j}),define(oe[203],ae([0,1,12,171]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;function s(D,S,f,l){try{j(D,S,f,l)}catch(p){D.error(p?.message??p)}return S}e.$Yp=s;function j(D,S,f,l){const p=(k,v,u)=>{const y=k[v];if((0,P.$If)(y)){const w=y,g=w.length;if(g>1&&w[0]==="%"&&w[g-1]==="%"){const $=w.substr(1,g-2);let d=f[$];d===void 0&&l&&(d=l[$]);const h=typeof d=="string"?d:d?.message,m=l?.[$],c=typeof m=="string"?m:m?.message;if(!h){c||D.warn(`[${S.name}]: ${(0,R.localize)(0,null,$)}`);return}if(u&&(v==="title"||v==="category")&&c&&c!==h){const t={value:h,original:c};k[v]=t}else k[v]=h}}else if((0,P.$Kf)(y))for(const w in y)y.hasOwnProperty(w)&&(w==="commands"?p(y,w,!0):p(y,w,u));else if(Array.isArray(y))for(let w=0;w<y.length;w++)p(y,w,u)};for(const k in S)S.hasOwnProperty(k)&&p(S,k)}}),define(oe[204],ae([0,1,19,74,173,205]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,S=/^-(\d{4})(\d{2})(\d{2})$/;function f($){return $=$.trim(),$==="*"||D.test($)}e.$ap=f;function l($){if(!f($))return null;if($=$.trim(),$==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=$.match(D);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.$bp=l;function p($){if(!$)return null;const d=$.majorBase,h=$.majorMustEqual,m=$.minorBase;let c=$.minorMustEqual;const t=$.patchBase;let o=$.patchMustEqual;$.hasCaret&&(d===0||(c=!1),o=!1);let r=0;if($.preRelease){const i=S.exec($.preRelease);if(i){const[,n,a,b]=i;r=Date.UTC(Number(n),Number(a)-1,Number(b))}}return{majorBase:d,majorMustEqual:h,minorBase:m,minorMustEqual:c,patchBase:t,patchMustEqual:o,isMinimum:$.hasGreaterEquals,notBefore:r}}e.$cp=p;function k($,d,h){let m;typeof $=="string"?m=p(l($)):m=$;let c;d instanceof Date?c=d.getTime():typeof d=="string"&&(c=new Date(d).getTime());let t;if(typeof h=="string"?t=p(l(h)):t=h,!m||!t)return!1;const o=m.majorBase,r=m.minorBase,i=m.patchBase;let n=t.majorBase,a=t.minorBase,b=t.patchBase;const C=t.notBefore;let I=t.majorMustEqual,E=t.minorMustEqual,A=t.patchMustEqual;return t.isMinimum?o>n?!0:o<n?!1:r>a?!0:r<a||c&&c<C?!1:i>=b:(o===1&&n===0&&(!I||!E||!A)&&(n=1,a=0,b=0,I=!0,E=!1,A=!1),o<n?!1:o>n?!I:r<a?!1:r>a?!E:i<b?!1:i>b?!A:!(c&&c<C))}e.$dp=k;function v($,d,h,m,c){const t=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return t.push([R.default.Error,s.localize(0,null)]),t;if(typeof m.name!="string")return t.push([R.default.Error,s.localize(1,null,"name")]),t;if(typeof m.version!="string")return t.push([R.default.Error,s.localize(2,null,"version")]),t;if(!m.engines)return t.push([R.default.Error,s.localize(3,null,"engines")]),t;if(typeof m.engines.vscode!="string")return t.push([R.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof m.extensionDependencies<"u"&&!g(m.extensionDependencies))return t.push([R.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof m.activationEvents<"u"){if(!g(m.activationEvents))return t.push([R.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof m.main>"u"&&typeof m.browser>"u")return t.push([R.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&t.push([R.default.Warning,s.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return t.push([R.default.Error,s.localize(9,null,"main")]),t;{const i=(0,P.$Hg)(h,m.main);(0,P.$Bg)(i,h)||t.push([R.default.Warning,s.localize(10,null,i.path,h.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return t.push([R.default.Error,s.localize(11,null,"browser")]),t;{const i=(0,P.$Hg)(h,m.browser);(0,P.$Bg)(i,h)||t.push([R.default.Warning,s.localize(12,null,i.path,h.path)])}}if(!j.valid(m.version))return t.push([R.default.Error,s.localize(13,null)]),t;const o=[];if(!u($,d,m,c,o))for(const i of o)t.push([R.default.Error,i]);return t}e.$ep=v;function u($,d,h,m,c){return m||typeof h.main>"u"&&typeof h.browser>"u"?!0:w($,d,h.engines.vscode,c)}e.$fp=u;function y($,d,h){return $==="*"||w(d,h,$)}e.$gp=y;function w($,d,h,m=[]){const c=p(l(h));if(!c)return m.push(s.localize(14,null,h)),!1;if(c.majorBase===0){if(!c.majorMustEqual||!c.minorMustEqual)return m.push(s.localize(15,null,h)),!1}else if(!c.majorMustEqual)return m.push(s.localize(16,null,h)),!1;return k($,d,c)?!0:(m.push(s.localize(17,null,$,h)),!1)}function g($){if(!Array.isArray($))return!1;for(let d=0,h=$.length;d<h;d++)if(typeof $[d]!="string")return!1;return!0}}),define(oe[206],ae([0,1,17,32]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function s(j,D,S){let f=S&&S.get("storage.serviceMachineId",-1)||null;if(f)return f;try{const p=(await D.readFile(j.serviceMachineIdResource)).value.toString();f=(0,R.$pg)(p)?p:null}catch{f=null}if(!f){f=(0,R.$qg)();try{await D.writeFile(j.serviceMachineIdResource,P.$je.fromString(f))}catch{}}return S?.store("storage.serviceMachineId",f,-1,1),f}e.$Ap=s}),define(oe[78],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class P{constructor(s,j=[],D=!1){this.ctor=s,this.staticArguments=j,this.supportsDelayedInstantiation=D}}e.$3h=P}),define(oe[207],ae([0,1,78]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const R=[];var s;(function(S){S[S.Eager=0]="Eager",S[S.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function j(S,f,l){f instanceof P.$3h||(f=new P.$3h(f,[],!!l)),R.push([S,f])}e.$Yr=j;function D(){return R}e.$Zr=D}),define(oe[208],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class P{constructor(j,D){this.key=j,this.data=D,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=P;class R{constructor(j){this.b=j,this.a=new Map}roots(){const j=[];for(const D of this.a.values())D.outgoing.size===0&&j.push(D);return j}insertEdge(j,D){const S=this.lookupOrInsertNode(j),f=this.lookupOrInsertNode(D);S.outgoing.set(f.key,f),f.incoming.set(S.key,S)}removeNode(j){const D=this.b(j);this.a.delete(D);for(const S of this.a.values())S.outgoing.delete(D),S.incoming.delete(D)}lookupOrInsertNode(j){const D=this.b(j);let S=this.a.get(D);return S||(S=new P(D,j),this.a.set(D,S)),S}lookup(j){return this.a.get(this.b(j))}isEmpty(){return this.a.size===0}toString(){const j=[];for(const[D,S]of this.a)j.push(`${D}
	(-> incoming)[${[...S.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...S.outgoing.keys()].join(",")}]
`);return j.join(`
`)}findCycleSlow(){for(const[j,D]of this.a){const S=new Set([j]),f=this.c(D,S);if(f)return f}}c(j,D){for(const[S,f]of j.outgoing){if(D.has(S))return[...D,S].join(" -> ");D.add(S);const l=this.c(f,D);if(l)return l;D.delete(S)}}}e.$Dq=R}),define(oe[6],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var P;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function S(f){return f[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=S})(P||(e._util=P={})),e.$5h=s("instantiationService");function R(D,S,f){S[P.DI_TARGET]===S?S[P.DI_DEPENDENCIES].push({id:D,index:f}):(S[P.DI_DEPENDENCIES]=[{id:D,index:f}],S[P.DI_TARGET]=S)}function s(D){if(P.serviceIds.has(D))return P.serviceIds.get(D);const S=function(f,l,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(S,f,p)};return S.toString=()=>D,P.serviceIds.set(D,S),S}e.$6h=s;function j(D){return D}e.$7h=j}),define(oe[65],ae([0,1,13,6]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0b=e.$L0b=void 0,e.$L0b=(0,R.$6h)("auxiliaryWindowsMainService");function s(j){return j?.opener?.url.startsWith(`${P.Schemas.vscodeFileResource}://${P.$ng}/`)}e.$M0b=s}),define(oe[66],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F0b=void 0,e.$F0b=(0,P.$6h)("backupMainService")}),define(oe[18],ae([0,1,12,7,6]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,s.$6h)("configurationService");function j($){return $&&typeof $=="object"&&(!$.overrideIdentifier||typeof $.overrideIdentifier=="string")&&(!$.resource||$.resource instanceof R.URI)}e.$Ai=j;function D($){return $&&typeof $=="object"&&(!$.overrideIdentifiers||Array.isArray($.overrideIdentifiers))&&!$.overrideIdentifier&&(!$.resource||$.resource instanceof R.URI)}e.$Bi=D;var S;(function($){$[$.APPLICATION=1]="APPLICATION",$[$.USER=2]="USER",$[$.USER_LOCAL=3]="USER_LOCAL",$[$.USER_REMOTE=4]="USER_REMOTE",$[$.WORKSPACE=5]="WORKSPACE",$[$.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",$[$.DEFAULT=7]="DEFAULT",$[$.MEMORY=8]="MEMORY"})(S||(e.ConfigurationTarget=S={}));function f($){switch($){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=f;function l($){return $.applicationValue!==void 0||$.userValue!==void 0||$.userLocalValue!==void 0||$.userRemoteValue!==void 0||$.workspaceValue!==void 0||$.workspaceFolderValue!==void 0}e.$Di=l;function p($,d){const h=Object.create(null);for(const m in $)k(h,m,$[m],d);return h}e.$Ei=p;function k($,d,h,m){const c=d.split("."),t=c.pop();let o=$;for(let r=0;r<c.length;r++){const i=c[r];let n=o[i];switch(typeof n){case"undefined":n=o[i]=Object.create(null);break;case"object":break;default:m(`Ignoring ${d} as ${c.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}o=n}if(typeof o=="object"&&o!==null)try{o[t]=h}catch{m(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(o)}`)}else m(`Ignoring ${d} as ${c.join(".")} is ${JSON.stringify(o)}`)}e.$Fi=k;function v($,d){const h=d.split(".");u($,h)}e.$Gi=v;function u($,d){const h=d.shift();if(d.length===0){delete $[h];return}if(Object.keys($).indexOf(h)!==-1){const m=$[h];typeof m=="object"&&!Array.isArray(m)&&(u(m,d),Object.keys(m).length===0&&delete $[h])}}function y($,d,h){function m(o,r){let i=o;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const c=d.split("."),t=m($,c);return typeof t>"u"?h:t}e.$Hi=y;function w($,d,h){Object.keys(d).forEach(m=>{m!=="__proto__"&&(m in $?P.$Kf($[m])&&P.$Kf(d[m])?w($[m],d[m],h):h&&($[m]=d[m]):$[m]=d[m])})}e.$Ii=w;function g($){return $.replace(/[\[\]]/g,"")}e.$Ji=g}),define(oe[115],ae([0,1,4,25,197,6,164,14]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const f=new Map;f.set("false",!1),f.set("true",!0),f.set("isMac",P.$j),f.set("isLinux",P.$k),f.set("isWindows",P.$i),f.set("isWeb",P.$o),f.set("isMacNative",P.$j&&!P.$o),f.set("isEdge",P.$H),f.set("isFirefox",P.$F),f.set("isChrome",P.$E),f.set("isSafari",P.$G);function l(K,O){if(f.get(K)!==void 0)throw(0,S.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");f.set(K,O)}e.$2i=l;const p=Object.prototype.hasOwnProperty;var k;(function(K){K[K.False=0]="False",K[K.True=1]="True",K[K.Defined=2]="Defined",K[K.Not=3]="Not",K[K.Equals=4]="Equals",K[K.NotEquals=5]="NotEquals",K[K.And=6]="And",K[K.Regex=7]="Regex",K[K.NotRegex=8]="NotRegex",K[K.Or=9]="Or",K[K.In=10]="In",K[K.NotIn=11]="NotIn",K[K.Greater=12]="Greater",K[K.GreaterEquals=13]="GreaterEquals",K[K.Smaller=14]="Smaller",K[K.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const v={regexParsingWithErrorRecovery:!0},u=(0,D.localize)(0,null),y=(0,D.localize)(1,null),w=(0,D.localize)(2,null),g=(0,D.localize)(3,null),$=(0,D.localize)(4,null),d=(0,D.localize)(5,null),h=(0,D.localize)(6,null),m=(0,D.localize)(7,null);class c{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(O=v){this.k=O,this.d=new s.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(O){if(O===""){this.h.push({message:u,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(O).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const _=this.D(),z=_.type===17?d:void 0;throw this.h.push({message:$,offset:_.offset,lexeme:s.$1i.getLexeme(_),additionalInfo:z}),c.c}return F}catch(F){if(F!==c.c)throw F;return}}l(){return this.m()}m(){const O=[this.o()];for(;this.y(16);){const F=this.o();O.push(F)}return O.length===1?O[0]:t.or(...O)}o(){const O=[this.s()];for(;this.y(15);){const F=this.s();O.push(F)}return O.length===1?O[0]:t.and(...O)}s(){if(this.y(2)){const O=this.D();switch(O.type){case 11:return this.z(),n.INSTANCE;case 12:return this.z(),a.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,g),F?.negate()}case 17:return this.z(),M.create(O.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",O)}}return this.t()}t(){const O=this.D();switch(O.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,g),F}case 17:{const F=O.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const x=z.lexeme,N=x.lastIndexOf("/"),B=N===x.length-1?void 0:this.w(x.substring(N+1));let Q;try{Q=new RegExp(x.substring(1,N),B)}catch{throw this.B("REGEX",z)}return re.create(F,Q)}switch(z.type){case 10:case 19:{const x=[z.lexeme];this.z();let N=this.D(),B=0;for(let be=0;be<z.lexeme.length;be++)z.lexeme.charCodeAt(be)===40?B++:z.lexeme.charCodeAt(be)===41&&B--;for(;!this.E()&&N.type!==15&&N.type!==16;){switch(N.type){case 0:B++;break;case 1:B--;break;case 10:case 18:for(let be=0;be<N.lexeme.length;be++)N.lexeme.charCodeAt(be)===40?B++:z.lexeme.charCodeAt(be)===41&&B--}if(B<0)break;x.push(s.$1i.getLexeme(N)),this.z(),N=this.D()}const Q=x.join(""),se=Q.lastIndexOf("/"),le=se===Q.length-1?void 0:this.w(Q.substring(se+1));let ge;try{ge=new RegExp(Q.substring(1,se),le)}catch{throw this.B("REGEX",z)}return t.regex(F,ge)}case 18:{const x=z.lexeme;this.z();let N=null;if(!(0,R.$Je)(x)){const B=x.indexOf("/"),Q=x.lastIndexOf("/");if(B!==Q&&B>=0){const se=x.slice(B+1,Q),le=x[Q+1]==="i"?"i":"";try{N=new RegExp(se,le)}catch{throw this.B("REGEX",z)}}}if(N===null)throw this.B("REGEX",z);return re.create(F,N)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const z=this.u();return t.notIn(F,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return t.equals(F,z);switch(z){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return t.notEquals(F,z);switch(z){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,z)}}case 5:return this.z(),J.create(F,this.u());case 6:return this.z(),ce.create(F,this.u());case 7:return this.z(),W.create(F,this.u());case 8:return this.z(),G.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:h,offset:O.offset,lexeme:"",additionalInfo:m}),c.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const O=this.D();switch(O.type){case 17:case 18:return this.z(),O.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(O){return O.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(O){return this.C(O)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(O,F){if(this.C(O))return this.z();throw this.B(F,this.D())}B(O,F,_){const z=(0,D.localize)(8,null,O,s.$1i.getLexeme(F)),x=F.offset,N=s.$1i.getLexeme(F);return this.h.push({message:z,offset:x,lexeme:N,additionalInfo:_}),c.c}C(O){return this.D().type===O}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=c;class t{static false(){return n.INSTANCE}static true(){return a.INSTANCE}static has(O){return b.create(O)}static equals(O,F){return C.create(O,F)}static notEquals(O,F){return A.create(O,F)}static regex(O,F){return re.create(O,F)}static in(O,F){return I.create(O,F)}static notIn(O,F){return E.create(O,F)}static not(O){return M.create(O)}static and(...O){return Y.create(O,null,!0)}static or(...O){return V.create(O,null,!0)}static greater(O,F){return W.create(O,F)}static greaterEquals(O,F){return G.create(O,F)}static smaller(O,F){return J.create(O,F)}static smallerEquals(O,F){return ce.create(O,F)}static{this.c=new c({regexParsingWithErrorRecovery:!1})}static deserialize(O){return O==null?void 0:this.c.parse(O)}}e.$4i=t;function o(K){const O=new c({regexParsingWithErrorRecovery:!1});return K.map(F=>(O.parse(F),O.lexingErrors.length>0?O.lexingErrors.map(_=>({errorMessage:_.additionalInfo?(0,D.localize)(9,null,_.additionalInfo):(0,D.localize)(10,null),offset:_.offset,length:_.lexeme.length})):O.parsingErrors.length>0?O.parsingErrors.map(_=>({errorMessage:_.additionalInfo?`${_.message}. ${_.additionalInfo}`:_.message,offset:_.offset,length:_.lexeme.length})):[]))}e.$5i=o;function r(K,O){const F=K?K.substituteConstants():void 0,_=O?O.substituteConstants():void 0;return!F&&!_?!0:!F||!_?!1:F.equals(_)}e.$6i=r;function i(K,O){return K.cmp(O)}class n{static{this.INSTANCE=new n}constructor(){this.type=0}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!1}serialize(){return"false"}keys(){return[]}map(O){return this}negate(){return a.INSTANCE}}e.$7i=n;class a{static{this.INSTANCE=new a}constructor(){this.type=1}cmp(O){return this.type-O.type}equals(O){return O.type===this.type}substituteConstants(){return this}evaluate(O){return!0}serialize(){return"true"}keys(){return[]}map(O){return this}negate(){return n.INSTANCE}}e.$8i=a;class b{static create(O,F=null){const _=f.get(O);return typeof _=="boolean"?_?a.INSTANCE:n.INSTANCE:new b(O,F)}constructor(O,F){this.key=O,this.c=F,this.type=2}cmp(O){return O.type!==this.type?this.type-O.type:U(this.key,O.key)}equals(O){return O.type===this.type?this.key===O.key:!1}substituteConstants(){const O=f.get(this.key);return typeof O=="boolean"?O?a.INSTANCE:n.INSTANCE:this}evaluate(O){return!!O.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(O){return O.mapDefined(this.key)}negate(){return this.c||(this.c=M.create(this.key,this)),this.c}}e.$9i=b;class C{static create(O,F,_=null){if(typeof F=="boolean")return F?b.create(O,_):M.create(O,_);const z=f.get(O);return typeof z=="boolean"?F===(z?"true":"false")?a.INSTANCE:n.INSTANCE:new C(O,F,_)}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=4}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?a.INSTANCE:n.INSTANCE}return this}evaluate(O){return O.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(O){return O.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=A.create(this.c,this.d,this)),this.f}}e.$0i=C;class I{static create(O,F){return new I(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=10,this.c=null}cmp(O){return O.type!==this.type?this.type-O.type:H(this.d,this.f,O.d,O.f)}equals(O){return O.type===this.type?this.d===O.d&&this.f===O.f:!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.f),_=O.getValue(this.d);return Array.isArray(F)?F.includes(_):typeof _=="string"&&typeof F=="object"&&F!==null?p.call(F,_):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(O){return O.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$$i=I;class E{static create(O,F){return new E(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=11,this.c=I.create(O,F)}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(O){return O.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=E;class A{static create(O,F,_=null){if(typeof F=="boolean")return F?M.create(O,_):b.create(O,_);const z=f.get(O);return typeof z=="boolean"?F===(z?"true":"false")?n.INSTANCE:a.INSTANCE:new A(O,F,_)}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=5}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){const O=f.get(this.c);if(typeof O=="boolean"){const F=O?"true":"false";return this.d===F?n.INSTANCE:a.INSTANCE}return this}evaluate(O){return O.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(O){return O.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.$aj=A;class M{static create(O,F=null){const _=f.get(O);return typeof _=="boolean"?_?n.INSTANCE:a.INSTANCE:new M(O,F)}constructor(O,F){this.c=O,this.d=F,this.type=3}cmp(O){return O.type!==this.type?this.type-O.type:U(this.c,O.c)}equals(O){return O.type===this.type?this.c===O.c:!1}substituteConstants(){const O=f.get(this.c);return typeof O=="boolean"?O?n.INSTANCE:a.INSTANCE:this}evaluate(O){return!O.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(O){return O.mapNot(this.c)}negate(){return this.d||(this.d=b.create(this.c,this)),this.d}}e.$bj=M;function T(K,O){if(typeof K=="string"){const F=parseFloat(K);isNaN(F)||(K=F)}return typeof K=="string"||typeof K=="number"?O(K):n.INSTANCE}class W{static create(O,F,_=null){return T(F,z=>new W(O,z,_))}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=12}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ce.create(this.c,this.d,this)),this.f}}e.$cj=W;class G{static create(O,F,_=null){return T(F,z=>new G(O,z,_))}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=13}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(O){return O.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$dj=G;class J{static create(O,F,_=null){return T(F,z=>new J(O,z,_))}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=14}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.$ej=J;class ce{static create(O,F,_=null){return T(F,z=>new ce(O,z,_))}constructor(O,F,_){this.c=O,this.d=F,this.f=_,this.type=15}cmp(O){return O.type!==this.type?this.type-O.type:H(this.c,this.d,O.c,O.d)}equals(O){return O.type===this.type?this.c===O.c&&this.d===O.d:!1}substituteConstants(){return this}evaluate(O){return typeof this.d=="string"?!1:parseFloat(O.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(O){return O.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$fj=ce;class re{static create(O,F){return new re(O,F)}constructor(O,F){this.d=O,this.f=F,this.type=7,this.c=null}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.d<O.d)return-1;if(this.d>O.d)return 1;const F=this.f?this.f.source:"",_=O.f?O.f.source:"";return F<_?-1:F>_?1:0}equals(O){if(O.type===this.type){const F=this.f?this.f.source:"",_=O.f?O.f.source:"";return this.d===O.d&&F===_}return!1}substituteConstants(){return this}evaluate(O){const F=O.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const O=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${O}`}keys(){return[this.d]}map(O){return O.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ue.create(this)),this.c}}e.$gj=re;class ue{static create(O){return new ue(O)}constructor(O){this.c=O,this.type=8}cmp(O){return O.type!==this.type?this.type-O.type:this.c.cmp(O.c)}equals(O){return O.type===this.type?this.c.equals(O.c):!1}substituteConstants(){return this}evaluate(O){return!this.c.evaluate(O)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(O){return new ue(this.c.map(O))}negate(){return this.c}}e.$hj=ue;function Z(K){let O=null;for(let F=0,_=K.length;F<_;F++){const z=K[F].substituteConstants();if(K[F]!==z&&O===null){O=[];for(let x=0;x<F;x++)O[x]=K[x]}O!==null&&(O[F]=z)}return O===null?K:O}class Y{static create(O,F,_){return Y.d(O,F,_)}constructor(O,F){this.expr=O,this.c=F,this.type=6}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const z=i(this.expr[F],O.expr[F]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:Y.create(O,this.c,!1)}evaluate(O){for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].evaluate(O))return!1;return!0}static d(O,F,_){const z=[];let x=!1;for(const N of O)if(N){if(N.type===1){x=!0;continue}if(N.type===0)return n.INSTANCE;if(N.type===6){z.push(...N.expr);continue}z.push(N)}if(z.length===0&&x)return a.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(i);for(let N=1;N<z.length;N++)z[N-1].equals(z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0];for(;z.length>1;){const N=z[z.length-1];if(N.type!==9)break;z.pop();const B=z.pop(),Q=z.length===0,se=V.create(N.expr.map(le=>Y.create([le,B],null,_)),null,Q);se&&(z.push(se),z.sort(i))}if(z.length===1)return z[0];if(_){for(let N=0;N<z.length;N++)for(let B=N+1;B<z.length;B++)if(z[N].negate().equals(z[B]))return n.INSTANCE;if(z.length===1)return z[0]}return new Y(z,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" && ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new Y(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());this.c=V.create(O,this,!0)}return this.c}}e.$ij=Y;class V{static create(O,F,_){return V.d(O,F,_)}constructor(O,F){this.expr=O,this.c=F,this.type=9}cmp(O){if(O.type!==this.type)return this.type-O.type;if(this.expr.length<O.expr.length)return-1;if(this.expr.length>O.expr.length)return 1;for(let F=0,_=this.expr.length;F<_;F++){const z=i(this.expr[F],O.expr[F]);if(z!==0)return z}return 0}equals(O){if(O.type===this.type){if(this.expr.length!==O.expr.length)return!1;for(let F=0,_=this.expr.length;F<_;F++)if(!this.expr[F].equals(O.expr[F]))return!1;return!0}return!1}substituteConstants(){const O=Z(this.expr);return O===this.expr?this:V.create(O,this.c,!1)}evaluate(O){for(let F=0,_=this.expr.length;F<_;F++)if(this.expr[F].evaluate(O))return!0;return!1}static d(O,F,_){let z=[],x=!1;if(O){for(let N=0,B=O.length;N<B;N++){const Q=O[N];if(Q){if(Q.type===0){x=!0;continue}if(Q.type===1)return a.INSTANCE;if(Q.type===9){z=z.concat(Q.expr);continue}z.push(Q)}}if(z.length===0&&x)return n.INSTANCE;z.sort(i)}if(z.length!==0){if(z.length===1)return z[0];for(let N=1;N<z.length;N++)z[N-1].equals(z[N])&&(z.splice(N,1),N--);if(z.length===1)return z[0];if(_){for(let N=0;N<z.length;N++)for(let B=N+1;B<z.length;B++)if(z[N].negate().equals(z[B]))return a.INSTANCE;if(z.length===1)return z[0]}return new V(z,F)}}serialize(){return this.expr.map(O=>O.serialize()).join(" || ")}keys(){const O=[];for(const F of this.expr)O.push(...F.keys());return O}map(O){return new V(this.expr.map(F=>F.map(O)),null)}negate(){if(!this.c){const O=[];for(const F of this.expr)O.push(F.negate());for(;O.length>1;){const F=O.shift(),_=O.shift(),z=[];for(const x of he(F))for(const N of he(_))z.push(Y.create([x,N],null,!1));O.unshift(V.create(z,null,!1))}this.c=V.create(O,this,!0)}return this.c}}e.$jj=V;class L extends b{static{this.d=[]}static all(){return L.d.values()}constructor(O,F,_){super(O,null),this.f=F,typeof _=="object"?L.d.push({..._,key:O}):_!==!0&&L.d.push({key:O,description:_,type:F!=null?typeof F:void 0})}bindTo(O){return O.createKey(this.key,this.f)}getValue(O){return O.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(O){return C.create(this.key,O)}notEqualsTo(O){return A.create(this.key,O)}}e.$kj=L,e.$lj=(0,j.$6h)("contextKeyService");function U(K,O){return K<O?-1:K>O?1:0}function H(K,O,F,_){return K<F?-1:K>F?1:O<_?-1:O>_?1:0}function q(K,O){if(K.type===0||O.type===1)return!0;if(K.type===9)return O.type===9?ee(K.expr,O.expr):!1;if(O.type===9){for(const F of O.expr)if(q(K,F))return!0;return!1}if(K.type===6){if(O.type===6)return ee(O.expr,K.expr);for(const F of K.expr)if(q(F,O))return!0;return!1}return K.equals(O)}e.$mj=q;function ee(K,O){let F=0,_=0;for(;F<K.length&&_<O.length;){const z=K[F].cmp(O[_]);if(z<0)return!1;z===0&&F++,_++}return F===K.length}function he(K){return K.type===9?K.expr:[K]}}),define(oe[91],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=e.$Im=e.ID=void 0,e.ID="diagnosticsService",e.$Im=(0,P.$6h)(e.ID);function R(j){return!!j.hostName&&!!j.errorMessage}e.$Jm=R;class s{async getPerformanceInfo(D,S){return{}}async getSystemInfo(D,S){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(D,S){return""}async getWorkspaceFileExtensions(D){return{extensions:[]}}async reportWorkspaceStats(D){}}e.$Km=s}),define(oe[116],ae([0,1,19,74,166,6,47,4,35]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.ConfirmResult=e.$8v=e.$7v=e.$6v=void 0,e.$6v=(0,j.$6h)("dialogService");var l;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(l||(l={}));class p{a(g){return this.d(g,l.Confirmation)}b(g){return this.d(g,l.Prompt)}c(g){return this.d(g,l.Input)}d(g,$){const d=[];switch($){case l.Confirmation:{const h=g;h.primaryButton?d.push(h.primaryButton):d.push((0,s.localize)(0,null)),h.cancelButton?d.push(h.cancelButton):d.push((0,s.localize)(1,null));break}case l.Prompt:{const h=g;Array.isArray(h.buttons)&&h.buttons.length>0&&d.push(...h.buttons.map(m=>m.label)),h.cancelButton&&(h.cancelButton===!0?d.push((0,s.localize)(2,null)):typeof h.cancelButton=="string"?d.push(h.cancelButton):h.cancelButton.label?d.push(h.cancelButton.label):d.push((0,s.localize)(3,null))),d.length===0&&d.push((0,s.localize)(4,null));break}case l.Input:{const h=g;h.primaryButton?d.push(h.primaryButton):d.push((0,s.localize)(5,null)),h.cancelButton?d.push(h.cancelButton):d.push((0,s.localize)(6,null));break}}return d}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===R.default.Info?"info":g===R.default.Error?"error":g===R.default.Warning?"warning":"none"}f(g,$,d){const h=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&h.push(g.cancelButton);let m=h[$]?.run({checkboxChecked:d});return m instanceof Promise||(m=Promise.resolve(m)),{result:m,checkboxChecked:d}}}e.$7v=p,e.$8v=(0,j.$6h)("fileDialogService");var k;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(k||(e.ConfirmResult=k={}));const v=10;function u(w){const g=[];return g.push(...w.slice(0,v).map($=>typeof $=="string"?$:(0,P.$Eg)($))),w.length>v&&(w.length-v===1?g.push((0,s.localize)(7,null)):g.push((0,s.localize)(8,null,w.length-v))),g.push(""),g.join(`
`)}e.$9v=u;function y(w,g){const $=(0,f.$vn)(w);let d=($.buttons??[]).map(t=>(0,D.$3v)(t)),h=(w.buttons||[]).map((t,o)=>o),m=0,c=$.cancelId??d.length-1;if(d.length>1){const t=typeof c=="number"?d[c]:void 0;if(S.$k||S.$j){if(typeof t=="string"&&d.length>1&&c!==1){d.splice(c,1),d.splice(1,0,t);const o=h[c];h.splice(c,1),h.splice(1,0,o),c=1}S.$k&&d.length>1&&(d=d.reverse(),h=h.reverse(),m=d.length-1,typeof t=="string"&&(c=m-1))}else if(S.$i&&typeof t=="string"&&d.length>1&&c!==d.length-1){d.splice(c,1),d.push(t);const o=h[c];h.splice(c,1),h.push(o),c=d.length-1}}return $.buttons=d,$.defaultId=m,$.cancelId=c,$.noLink=!0,$.title=$.title||g.nameLong,{options:$,buttonIndeces:h}}e.$0v=y}),define(oe[117],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lV=e.$kV=e.KnownStorageProvider=e.PasswordStoreCLIOption=e.$jV=e.$iV=void 0,e.$iV=(0,P.$6h)("encryptionService"),e.$jV=(0,P.$6h)("encryptionMainService");var R;(function(S){S.kwallet="kwallet",S.kwallet5="kwallet5",S.gnome="gnome",S.gnomeKeyring="gnome-keyring",S.gnomeLibsecret="gnome-libsecret",S.basic="basic"})(R||(e.PasswordStoreCLIOption=R={}));var s;(function(S){S.unknown="unknown",S.basicText="basic_text",S.gnomeAny="gnome_any",S.gnomeLibsecret="gnome_libsecret",S.gnomeKeyring="gnome_keyring",S.kwallet="kwallet",S.kwallet5="kwallet5",S.kwallet6="kwallet6",S.dplib="dpapi",S.keychainAccess="keychain_access"})(s||(e.KnownStorageProvider=s={}));function j(S){return S==="kwallet"||S==="kwallet5"||S==="kwallet6"}e.$kV=j;function D(S){return S==="gnome_any"||S==="gnome_libsecret"||S==="gnome_keyring"}e.$lV=D}),define(oe[38],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,P.$6h)("environmentService"),e.$bi=(0,P.$7h)(e.$ai)}),define(oe[118],ae([0,1,170,6]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function s(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=s;function j(h){switch(h){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=j;function D(h,m){switch(h){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=D;function S(h,m){return m==="web"&&!h.includes("web")}e.$vo=S;function f(h,m,c){return S(m,c)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===c}e.$wo=f;function l(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.$xo=l;var p;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(p||(e.SortBy=p={}));var k;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(k||(e.SortOrder=k={}));var v;(function(h){h.Install="install",h.Uninstall="uninstall"})(v||(e.StatisticType=v={}));var u;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(u||(e.InstallOperation=u={})),e.$yo=(0,R.$6h)("extensionGalleryService");var y;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.DownloadSignature="DownloadSignature",h.UpdateMetadata="UpdateMetadata",h.Extract="Extract",h.Scanning="Scanning",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.NotAllowed="NotAllowed",h.Gallery="Gallery",h.Unknown="Unknown",h.Internal="Internal"})(y||(e.ExtensionManagementErrorCode=y={}));var w;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(w||(e.ExtensionSignaturetErrorCode=w={}));class g extends Error{constructor(m,c){super(m),this.code=c,this.name=c}}e.$zo=g;var $;(function(h){h.Timeout="Timeout",h.Cancelled="Cancelled",h.Failed="Failed"})($||(e.ExtensionGalleryErrorCode=$={}));class d extends Error{constructor(m,c){super(m),this.code=c,this.name=c}}e.$Ao=d,e.$Bo=(0,R.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,R.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,R.$6h)("IExtensionTipsService"),e.$Go=(0,P.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,P.localize2)(1,"Preferences")}),define(oe[209],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p$b=e.$o$b=void 0,e.$o$b=(0,P.$6h)("extensionHostStarter"),e.$p$b="extensionHostStarter"}),define(oe[210],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v3b=e.$u3b=void 0,e.$u3b=(0,P.$6h)("externalTerminal"),e.$v3b="Terminal.app"}),define(oe[211],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$r$b=void 0,e.$r$b=(0,P.$6h)("externalTerminal")}),define(oe[212],ae([0,1,48,50,13,9,4,76,21,89,174,210]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$b=e.$t$b=e.$s$b=void 0;const v=p.localize(0,null);class u{async getDefaultTerminalForPlatforms(){return{windows:y.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class y extends u{static{this.b="cmd.exe"}openTerminal(c,t){return this.spawnTerminal(P,c,l.$Tl(),t)}spawnTerminal(c,t,o,r){const i=t.windowsExec||y.getDefaultTerminalWindows();r&&r[1]===":"&&(r=r[0].toUpperCase()+r.substr(1));const n=j.$nc(i,".exe").toLowerCase();if(n==="cmder")return c.spawn(i,r?[r]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return i.indexOf(" ")>=0&&a.push('""'),a.push(i),n==="wt"&&a.push("-d ."),new Promise((b,C)=>{const I=$(process),E=c.spawn(o,a,{cwd:r,env:I,detached:!0});E.on("error",C),E.on("exit",()=>b())})}async runInTerminal(c,t,o,r,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:y.getDefaultTerminalWindows(),a=await y.f();return new Promise((b,C)=>{const I=`"${t} - ${v}"`,E=`""${o.join('" "')}" & pause"`,A=Object.assign({},$(process),r);Object.keys(A).filter(J=>A[J]===null).forEach(J=>delete A[J]);const M={cwd:t,env:A,windowsVerbatimArguments:!0};let T,W;j.$nc(n,".exe")==="wt"?(T=n,W=["-d",".",y.b,"/c",E]):a?(T=a,W=["-d",t,n,"/c",E]):(T=y.b,W=["/c","start",I,"/wait",n,"/c",E]),P.spawn(T,W,M).on("error",J=>{C(d(J))}),b(void 0)})}static getDefaultTerminalWindows(){if(!y.d){const c=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");y.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${c?"Sysnative":"System32"}\\cmd.exe`}return y.d}static async f(){try{const c=await l.win32.findExecutable("wt");return await f.Promises.exists(c)?c:void 0}catch{return}}}e.$s$b=y,ve([R.$xh],y,"f",null);class w extends u{static{this.b="/usr/bin/osascript"}openTerminal(c,t){return this.spawnTerminal(P,c,t)}runInTerminal(c,t,o,r,i){const n=i.osxExec||k.$v3b;return new Promise((a,b)=>{if(n===k.$v3b||n==="iTerm.app"){const C=n===k.$v3b?"TerminalHelper":"iTermHelper",E=[s.$og.asFileUri(`vs/workbench/contrib/externalTerminal/node/${C}.scpt`).fsPath,"-t",c||v,"-w",t];for(const T of o)E.push("-a"),E.push(T);if(r){const T=Object.assign({},$(process),r);for(const W in T){const G=T[W];G===null?(E.push("-u"),E.push(W)):(E.push("-e"),E.push(`${W}=${G}`))}}let A="";const M=P.spawn(w.b,E);M.on("error",T=>{b(d(T))}),M.stderr.on("data",T=>{A+=T.toString()}),M.on("exit",T=>{if(T===0)a(void 0);else if(A){const W=A.split(`
`,1);b(new Error(W[0]))}else b(new Error(p.localize(1,null,C,T)))})}else b(new Error(p.localize(2,null,n)))})}spawnTerminal(c,t,o){const r=t.osxExec||k.$v3b;return new Promise((i,n)=>{const a=["-a",r];o&&a.push(o);const b=$(process),C=c.spawn("/usr/bin/open",a,{cwd:o,env:b});C.on("error",n),C.on("exit",()=>i())})}}e.$t$b=w;class g extends u{static{this.b=p.localize(3,null)}openTerminal(c,t){return this.spawnTerminal(P,c,t)}runInTerminal(c,t,o,r,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((a,b)=>{const C=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?C.push("-x"):C.push("-e"),C.push("bash"),C.push("-c");const E=`${h(o)}; echo; read -p "${g.b}" -n1;`;C.push(`''${E}''`);const A=Object.assign({},$(process),r);Object.keys(A).filter(G=>A[G]===null).forEach(G=>delete A[G]);const M={cwd:t,env:A};let T="";const W=P.spawn(I,C,M);W.on("error",G=>{b(d(G))}),W.stderr.on("data",G=>{T+=G.toString()}),W.on("exit",G=>{if(G===0)a(void 0);else if(T){const J=T.split(`
`,1);b(new Error(J[0]))}else b(new Error(p.localize(4,null,I,G)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!D.$k)g.d=Promise.resolve("xterm");else{const c=await f.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{c?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(c,t,o){const r=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{r.then(a=>{const b=$(process),C=c.spawn(a,[],{cwd:o,env:b});C.on("error",n),C.on("exit",()=>i())})})}}e.$u$b=g;function $(m){const c={...m.env};return(0,S.$Rl)(c),c}function d(m){return"errno"in m&&m.errno==="ENOENT"&&"path"in m&&typeof m.path=="string"?new Error(p.localize(5,null,m.path)):m}function h(m){let c="";for(const t of m)t.indexOf(" ")>=0?c+='"'+t+'"':c+=t,c+=" ";return c}}),define(oe[16],ae([0,1,58,9,25,12,7,176,6,4,13,62]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,f.$6h)("fileService");function v(q){return q.create===!0}e.$rk=v;var u;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(u||(e.FileType=u={}));var y;(function(q){q[q.Readonly=1]="Readonly",q[q.Locked=2]="Locked"})(y||(e.FilePermission=y={}));function w(q){const ee=q;return!!ee&&typeof ee.onDidChange=="function"}e.$sk=w;var g;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileAtomicWrite=32768]="FileAtomicWrite",q[q.FileAtomicDelete=65536]="FileAtomicDelete",q[q.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function $(q){return!!(q.capabilities&2)}e.$tk=$;function d(q){return!!(q.capabilities&8)}e.$uk=d;function h(q){return!!(q.capabilities&131072)}e.$vk=h;function m(q){return!!(q.capabilities&4)}e.$wk=m;function c(q){return!!(q.capabilities&16)}e.$xk=c;function t(q){return $(q)?!!(q.capabilities&16384):!1}e.$yk=t;function o(q){return $(q)?!!(q.capabilities&32768):!1}e.$zk=o;function r(q){return!!(q.capabilities&65536)}e.$Ak=r;function i(q){return!!(q.capabilities&2048)}e.$Bk=i;var n;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(n||(e.FileSystemProviderErrorCode=n={}));class a extends Error{static create(ee,he){const K=new a(ee.toString(),he);return I(K,he),K}constructor(ee,he){super(ee),this.code=he}}e.$Ck=a;function b(q,ee){return a.create(q,ee)}e.$Dk=b;function C(q){return q||b((0,S.localize)(0,null),n.Unknown)}e.$Ek=C;function I(q,ee){return q.name=ee?`${ee} (FileSystemError)`:"FileSystemError",q}e.$Fk=I;function E(q){if(!q)return n.Unknown;if(q instanceof a)return q.code;const ee=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ee)return n.Unknown;switch(ee[1]){case n.FileExists:return n.FileExists;case n.FileIsADirectory:return n.FileIsADirectory;case n.FileNotADirectory:return n.FileNotADirectory;case n.FileNotFound:return n.FileNotFound;case n.FileTooLarge:return n.FileTooLarge;case n.FileWriteLocked:return n.FileWriteLocked;case n.NoPermissions:return n.NoPermissions;case n.Unavailable:return n.Unavailable}return n.Unknown}e.$Gk=E;function A(q){if(q instanceof ce)return q.fileOperationResult;switch(E(q)){case n.FileNotFound:return 1;case n.FileIsADirectory:return 0;case n.FileNotADirectory:return 9;case n.FileWriteLocked:return 5;case n.NoPermissions:return 6;case n.FileExists:return 4;case n.FileTooLarge:return 7;default:return 10}}e.$Hk=A;var M;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(M||(e.FileOperation=M={}));class T{constructor(ee,he,K){this.resource=ee,this.operation=he,this.target=K}isOperation(ee){return this.operation===ee}}e.$Ik=T;var W;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class G{static{this.a=null}constructor(ee,he){this.c=he,this.b=void 0,this.d=new k.$V(()=>{const K=P.$_h.forUris(()=>this.c);return K.fill(this.rawAdded.map(O=>[O,!0])),K}),this.f=new k.$V(()=>{const K=P.$_h.forUris(()=>this.c);return K.fill(this.rawUpdated.map(O=>[O,!0])),K}),this.g=new k.$V(()=>{const K=P.$_h.forUris(()=>this.c);return K.fill(this.rawDeleted.map(O=>[O,!0])),K}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const K of ee){switch(K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}this.b!==G.a&&(typeof K.cId=="number"?this.b===void 0?this.b=K.cId:this.b!==K.cId&&(this.b=G.a):this.b!==void 0&&(this.b=G.a))}}contains(ee,...he){return this.h(ee,{includeChildren:!1},...he)}affects(ee,...he){return this.h(ee,{includeChildren:!0},...he)}h(ee,he,...K){if(!ee)return!1;const O=K.length>0;return!!((!O||K.includes(1))&&(this.d.value.get(ee)||he.includeChildren&&this.d.value.findSuperstr(ee))||(!O||K.includes(0))&&(this.f.value.get(ee)||he.includeChildren&&this.f.value.findSuperstr(ee))||(!O||K.includes(2))&&(this.g.value.findSubstr(ee)||he.includeChildren&&this.g.value.findSuperstr(ee)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ee){return this.b===ee}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=G;function J(q,ee,he){return!q||!ee||q===ee||ee.length>q.length?!1:(ee.charAt(ee.length-1)!==R.sep&&(ee+=R.sep),he?(0,s.$af)(q,ee):q.indexOf(ee)===0)}e.$Kk=J;class ce extends Error{constructor(ee,he,K){super(ee),this.fileOperationResult=he,this.options=K}}e.$Lk=ce;class re extends ce{constructor(ee,he,K,O){super(ee,he,O),this.fileOperationResult=he,this.size=K}}e.$Mk=re;class ue extends ce{constructor(ee,he,K){super(ee,2,K),this.stat=he}}e.$Nk=ue;var Z;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var Y;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(Y||(e.FileKind=Y={})),e.$Vk="";function V(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.$Wk=V;async function L(q,ee){if(!ee.hasProvider(D.URI.from({scheme:q.scheme})))return new Promise(he=>{const K=ee.onDidChangeFileSystemProviderRegistrations(O=>{O.scheme===q.scheme&&O.added&&(K.dispose(),he())})})}e.$Xk=L;class U{static{this.KB=1024}static{this.MB=U.KB*U.KB}static{this.GB=U.MB*U.KB}static{this.TB=U.GB*U.KB}static formatSize(ee){return(0,j.$Mf)(ee)||(ee=0),ee<U.KB?(0,S.localize)(1,null,ee.toFixed(0)):ee<U.MB?(0,S.localize)(2,null,(ee/U.KB).toFixed(2)):ee<U.GB?(0,S.localize)(3,null,(ee/U.MB).toFixed(2)):ee<U.TB?(0,S.localize)(4,null,(ee/U.GB).toFixed(2)):(0,S.localize)(5,null,(ee/U.TB).toFixed(2))}}e.$Yk=U;function H(q){const ee=typeof q=="string"||q?.scheme===p.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===p.Schemas.file?1024*U.MB:ee?10*U.MB:l.$o?50*U.MB:1024*U.MB}e.$Zk=H}),define(oe[119],ae([0,1,17,14,177,16]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;async function D(p,k,v,u,y,w){let g;try{await S(p,k,v,u,y,w)}catch($){g=$}finally{g&&y.errorTransformer&&(g=y.errorTransformer(g)),typeof g<"u"&&v.error(g),v.end()}}e.$bq=D;async function S(p,k,v,u,y,w){f(w);const g=await p.open(k,{create:!1});try{f(w);let $=0,d=0,h=y&&typeof y.length=="number"?y.length:void 0,m=P.$je.alloc(Math.min(y.bufferSize,typeof h=="number"?h:y.bufferSize)),c=y&&typeof y.position=="number"?y.position:0,t=0;do d=await p.read(g,c,m.buffer,t,m.byteLength-t),c+=d,t+=d,$+=d,typeof h=="number"&&(h-=d),t===m.byteLength&&(await v.write(u(m)),m=P.$je.alloc(Math.min(y.bufferSize,typeof h=="number"?h:y.bufferSize)),t=0);while(d>0&&(typeof h!="number"||h>0)&&f(w)&&l($,y));if(t>0){let o=t;typeof h=="number"&&(o=Math.min(t,h)),v.write(u(m.slice(0,o)))}}catch($){throw(0,j.$Ek)($)}finally{await p.close(g)}}function f(p){if(p.isCancellationRequested)throw(0,R.$6)();return!0}function l(p,k){if(typeof k?.limits?.size=="number"&&p>k.limits.size)throw(0,j.$Dk)((0,s.localize)(0,null),j.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[67],ae([0,1,105,2,9,4,7,16]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;function f($){return $.recursive===!0}e.$dq=f;class l extends R.$Tc{static{this.a=5}constructor(d,h,m,c){super(),this.h=d,this.j=h,this.m=m,this.n=c,this.c=this.B(new R.$Uc),this.f=void 0,this.g=0}s(){const d=new R.$Sc;this.c.value=d,this.b=this.r(d),this.b.setVerboseLogging(this.m),d.add(this.b.onDidChangeFile(h=>this.h(h))),d.add(this.b.onDidLogMessage(h=>this.j(h))),d.add(this.b.onDidError(h=>this.t(h)))}t(d){this.n.restartOnError?this.g<l.a&&this.f?(this.w(`restarting watcher after error: ${d}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${d}`):this.w(d)}u(d){this.g++,this.s(),this.watch(d)}async watch(d){this.f=d,await this.b?.watch(d)}async setVerboseLogging(d){this.m=d,await this.b?.setVerboseLogging(d)}w(d){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${d}`})}y(d){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${d}`})}dispose(){return this.b=void 0,super.dispose()}}e.$eq=l;class p extends l{constructor(d,h,m){super(d,h,m,{type:"node.js",restartOnError:!1})}}e.$fq=p;class k extends l{constructor(d,h,m){super(d,h,m,{type:"universal",restartOnError:!0})}}e.$gq=k;function v($){return $.map(d=>({type:d.type,resource:D.URI.revive(d.resource),cId:d.cId}))}e.$hq=v;function u($){const d=new g;for(const h of $)d.processEvent(h);return d.coalesce()}e.$iq=u;function y($,d){return typeof d=="string"&&!d.startsWith(P.$Ij)&&!(0,s.$ic)(d)?{base:$,pattern:d}:d}e.$jq=y;function w($,d){const h=[];for(const m of d)h.push((0,P.$Mj)(y($,m)));return h}e.$kq=w;class g{constructor(){this.a=new Set,this.b=new Map}c(d){return j.$k?d.resource.fsPath:d.resource.fsPath.toLowerCase()}processEvent(d){const h=this.b.get(this.c(d));let m=!1;if(h){const c=h.type,t=d.type;h.resource.fsPath!==d.resource.fsPath&&(d.type===2||d.type===1)?m=!0:c===1&&t===2?(this.b.delete(this.c(d)),this.a.delete(h)):c===2&&t===1?h.type=0:c===1&&t===0||(h.type=t)}else m=!0;m&&(this.a.add(d),this.b.set(this.c(d),d))}coalesce(){const d=[],h=[];return Array.from(this.a).filter(m=>m.type!==2?(d.push(m),!1):!0).sort((m,c)=>m.resource.fsPath.length-c.resource.fsPath.length).filter(m=>h.some(c=>(0,S.$Kk)(m.resource.fsPath,c,!j.$k))?!1:(h.push(m.resource.fsPath),!0)).concat(d)}}}),define(oe[213],ae([0,1,17,51,14,3,2,63,32,16,67]),function(X,e,P,R,s,j,D,S,f,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0,e.$kO="localFilesystem";class k extends D.$Tc{constructor(u,y){super(),this.a=u,this.b=y,this.onDidChangeCapabilities=j.Event.None,this.f=this.B(new j.$Vd),this.onDidChangeFile=this.f.event,this.g=this.B(new j.$Vd),this.onDidWatchError=this.g.event,this.h=(0,f.$qg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(u){return this.a.call("stat",[u])}readdir(u){return this.a.call("readdir",[u])}async readFile(u,y){const{buffer:w}=await this.a.call("readFile",[u,y]);return w}readFileStream(u,y,w){const g=(0,S.$0d)(d=>P.$je.concat(d.map(h=>P.$je.wrap(h))).buffer),$=new D.$Sc;return $.add(this.a.listen("readFileStream",[u,y])(d=>{if(d instanceof P.$je)g.write(d.buffer);else{if(d==="end")g.end();else{let h;if(d instanceof Error)h=d;else{const m=d;h=(0,l.$Dk)(m.message??(0,R.$Qi)(m),m.code??l.FileSystemProviderErrorCode.Unknown)}g.error(h),g.end()}$.dispose()}})),$.add(w.onCancellationRequested(()=>{g.error((0,s.$6)()),g.end(),$.dispose()})),g}writeFile(u,y,w){return this.a.call("writeFile",[u,P.$je.wrap(y),w])}open(u,y){return this.a.call("open",[u,y])}close(u){return this.a.call("close",[u])}async read(u,y,w,g,$){const[d,h]=await this.a.call("read",[u,y,$]);return w.set(d.buffer.slice(0,h),g),h}write(u,y,w,g,$){return this.a.call("write",[u,y,P.$je.wrap(w),g,$])}mkdir(u){return this.a.call("mkdir",[u])}delete(u,y){return this.a.call("delete",[u,y])}rename(u,y,w){return this.a.call("rename",[u,y,w])}copy(u,y,w){return this.a.call("copy",[u,y,w])}cloneFile(u,y){return this.a.call("cloneFile",[u,y])}j(){this.B(this.a.listen("fileChange",[this.h])(u=>{if(Array.isArray(u)){const y=u;this.f.fire((0,p.$hq)(y))}else{const y=u;this.g.fire(y)}}))}watch(u,y){const w=(0,f.$qg)();return this.a.call("watch",[this.h,w,u,y]),(0,D.$Rc)(()=>this.a.call("unwatch",[this.h,w]))}}e.$lO=k}),define(oe[214],ae([0,1,46,8,23,33,2,85,9,4,19,7,106,21,67]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0;class w extends D.$Tc{static{this.a=100}static{this.b=75}constructor(d,h,m,c){super(),this.m=d,this.n=h,this.r=m,this.s=c,this.c=this.B(new R.$ih({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new R.$hh(t=>this.z(t),w.b)),this.g=(0,y.$kq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,y.$kq)(this.m.path,this.m.includes):void 0,this.j=new s.$6d,this.ready=this.t()}async t(){try{const d=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const h=await u.Promises.stat(d);this.B(await this.w(d,h.isDirectory()))}catch(d){d.code!=="ENOENT"?this.D(d):this.G(d)}}async u(d){let h=d.path;try{h=await u.Promises.realpath(d.path),d.path===h&&(h=await(0,v.$uq)(d.path)??d.path),d.path!==h&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${d.path}, real: ${h})`)}catch{}return h}async w(d,h){if(l.$j&&(0,j.$8f)(d,"/Volumes/",!0))return this.D(`Refusing to watch ${d} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),D.$Tc.None;const m=new s.$6d(this.j.token),c=new D.$Sc;try{const t=k.URI.file(this.m.path),o=(0,f.$nc)(d),r=(0,P.watch)(d);c.add((0,D.$Rc)(()=>{r.removeAllListeners(),r.close()})),this.G(`Started watching: '${d}'`);const i=new Set;if(h)try{for(const a of await u.Promises.readdir(d))i.add(a)}catch(a){this.D(a)}const n=new Map;c.add((0,D.$Rc)(()=>{for(const[,a]of n)a.dispose();n.clear()})),r.on("error",(a,b)=>{this.D(`Failed to watch ${d} for changes using fs.watch() (${a}, ${b})`),this.dispose()}),r.on("change",(a,b)=>{if(m.token.isCancellationRequested)return;this.G(`[raw] ["${a}"] ${b}`);let C="";if(b&&(C=b.toString(),l.$j&&(C=(0,S.$Gl)(C))),!(!C||a!=="change"&&a!=="rename"))if(h)if(a==="rename"){n.get(C)?.dispose();const I=setTimeout(async()=>{if(n.delete(C),C===o&&!await u.Promises.exists(d)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const E=await this.C((0,f.$jc)(d,C));if(m.token.isCancellationRequested)return;let A;E?i.has(C)?A=0:(A=1,i.add(C)):(i.delete(C),A=2),this.y({resource:(0,p.$Hg)(t,C),type:A,cId:this.m.correlationId})},w.a);n.set(C,(0,D.$Rc)(()=>clearTimeout(I)))}else{let I;i.has(C)?I=0:(I=1,i.add(C)),this.y({resource:(0,p.$Hg)(t,C),type:I,cId:this.m.correlationId})}else if(a==="rename"||C!==o){const I=setTimeout(async()=>{const E=await u.Promises.exists(d);m.token.isCancellationRequested||(E?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),c.add(await this.w(d,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},w.a);c.clear(),c.add((0,D.$Rc)(()=>clearTimeout(I)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await u.Promises.exists(d)&&!m.token.isCancellationRequested&&this.D(`Failed to watch ${d} for changes using fs.watch() (${t.toString()})`)}return(0,D.$Rc)(()=>{m.dispose(!0),c.dispose()})}y(d,h=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.resource.fsPath}`),!h&&this.g.some(m=>m(d.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${d.resource.fsPath}`):!h&&this.h&&this.h.length>0&&!this.h.some(m=>m(d.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${d.resource.fsPath}`):this.f.work(d))}z(d){const h=(0,y.$iq)(d);if(h.length>0){if(this.s)for(const c of h)this.G(` >> normalized ${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.resource.fsPath}`);this.c.work(h)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(d){if(l.$k)return u.Promises.exists(d);try{const h=(0,f.$nc)(d);return(await u.Promises.readdir((0,f.$mc)(d))).some(c=>c===h)}catch(h){return this.G(h),!1}}setVerboseLogging(d){this.s=d}D(d){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${d}`})}F(d){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${d}`})}G(d){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${d}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$xq=w;async function g($,d,h,m,c=512){const t=await u.Promises.open($,"r"),o=Buffer.allocUnsafe(c),r=new s.$6d(m);let i,n=!1;const a={path:$,excludes:[],recursive:!1},b=new w(a,C=>{(async()=>{for(const{type:I}of C)if(I===0){if(n)return;n=!0;try{for(;!r.token.isCancellationRequested;){const{bytesRead:E}=await u.Promises.read(t,o,0,c,null);if(!E||r.token.isCancellationRequested)break;d(o.slice(0,E))}}catch(E){i=new Error(E),r.dispose(!0)}finally{n=!1}}})()});return await b.ready,h(),new Promise((C,I)=>{r.token.onCancellationRequested(async()=>{b.dispose();try{await u.Promises.close(t)}catch(E){i=new Error(E)}i?I(i):C()})})}e.$yq=g}),define(oe[215],ae([0,1,3,105,2,4,214]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class S extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new P.$Vd),this.onDidChangeFile=this.a.event,this.b=this.B(new P.$Vd),this.onDidLogMessage=this.b.event,this.onDidError=P.Event.None,this.c=new Map,this.f=!1}async watch(l){const p=this.j(l),k=p.filter(u=>{const y=this.c.get(u.path);return y?!(0,R.$Qj)(y.request.excludes,u.excludes)||!(0,R.$Qj)(y.request.includes,u.includes):!0}),v=Array.from(this.c.values()).filter(({request:u})=>!p.find(y=>y.path===u.path&&(0,R.$Qj)(y.excludes,u.excludes)&&(0,R.$Qj)(y.includes,u.includes))).map(({request:u})=>u.path);k.length&&this.m(`Request to start watching: ${k.map(u=>`${u.path} (excludes: ${u.excludes.length>0?u.excludes:"<none>"}, includes: ${u.includes&&u.includes.length>0?JSON.stringify(u.includes):"<all>"}, correlationId: ${typeof u.correlationId=="number"?u.correlationId:"<none>"})`).join(",")}`),v.length&&this.m(`Request to stop watching: ${v.join(",")}`);for(const u of v)this.h(u);for(const u of k)this.g(u)}g(l){const p=new D.$xq(l,v=>this.a.fire(v),v=>this.b.fire(v),this.f),k={request:l,instance:p};this.c.set(l.path,k)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const p=this.c.get(l);p&&(this.c.delete(l),p.instance.dispose())}j(l){const p=new Map;for(const k of l){const v=j.$k?k.path:k.path.toLowerCase();let u=p.get(k.correlationId);u||(u=new Map,p.set(k.correlationId,u)),u.set(v,k)}return Array.from(p.values()).map(k=>Array.from(k.values())).flat()}async setVerboseLogging(l){this.f=l;for(const[,p]of this.c)p.instance.setVerboseLogging(l)}m(l){this.f&&this.b.fire({type:"trace",message:this.n(l)})}n(l,p){return p?`[File Watcher (node.js)] ${l} (path: ${p.request.path})`:`[File Watcher (node.js)] ${l}`}}e.$zq=S}),define(oe[216],ae([0,1,67,215]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class s extends P.$fq{constructor(D,S,f){super(D,S,f),this.s()}r(D){return D.add(new R.$zq)}}e.$Aq=s}),define(oe[217],ae([0,1,13,43,160,67]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class D extends j.$gq{constructor(f,l,p){super(f,l,p),this.s()}r(f){const l=f.add(new s.$rq(P.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return f.add(l.onDidProcessExit(({code:p,signal:k})=>this.t(`terminated by itself with code ${p}, signal: ${k}`))),R.ProxyChannel.toService((0,R.$Mh)(l.getChannel("watcher")))}}e.$sq=D}),define(oe[92],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class P{constructor(...s){this.a=new Map;for(const[j,D]of s)this.set(j,D)}set(s,j){const D=this.a.get(s);return this.a.set(s,j),D}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.$4h=P}),define(oe[218],ae([0,1,8,14,2,78,208,6,92,102]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const p=!1;class k extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class v{constructor(g=new f.$4h,$=!1,d,h=p){this.f=g,this.g=$,this.h=d,this.i=h,this.o=new Set,this.f.set(S.$5h,this),this._globalGraph=h?d?._globalGraph??new D.$Dq(m=>m):void 0}createChild(g){return new v(g,this.g,this,this.i)}invokeFunction(g,...$){const d=y.traceInvocation(this.i,g);let h=!1;try{return g({get:c=>{if(h)throw(0,R.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(c,d);if(!t)throw new Error(`[invokeFunction] unknown service '${c}'`);return t}},...$)}finally{h=!0,d.stop()}}createInstance(g,...$){let d,h;return g instanceof j.$3h?(d=y.traceCreation(this.i,g.ctor),h=this.j(g.ctor,g.staticArguments.concat($),d)):(d=y.traceCreation(this.i,g),h=this.j(g,$,d)),d.stop(),h}j(g,$=[],d){const h=S._util.getServiceDependencies(g).sort((t,o)=>t.index-o.index),m=[];for(const t of h){const o=this.m(t.id,d);o||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),m.push(o)}const c=h.length>0?h[0].index:$.length;if($.length!==c){console.trace(`[createInstance] First service dependency of ${g.name} at position ${c+1} conflicts with ${$.length} static arguments`);const t=c-$.length;t>0?$=$.concat(new Array(t)):$=$.slice(0,c)}return Reflect.construct(g,$.concat(m))}k(g,$){if(this.f.get(g)instanceof j.$3h)this.f.set(g,$);else if(this.h)this.h.k(g,$);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const $=this.f.get(g);return!$&&this.h?this.h.l(g):$}m(g,$){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const d=this.l(g);return d instanceof j.$3h?this.q(g,d,$.branch(g,!0)):($.branch(g,!1),d)}q(g,$,d){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,$,d)}finally{this.o.delete(g)}}r(g,$,d){const h=new D.$Dq(t=>t.id.toString());let m=0;const c=[{id:g,desc:$,_trace:d}];for(;c.length;){const t=c.pop();if(h.lookupOrInsertNode(t),m++>1e3)throw new k(h);for(const o of S._util.getServiceDependencies(t.desc.ctor)){const r=this.l(o.id);if(r||this.u(`[createInstance] ${g} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(o.id)),r instanceof j.$3h){const i={id:o.id,desc:r,_trace:t._trace.branch(o.id,!0)};h.insertEdge(t,i),c.push(i)}}}for(;;){const t=h.roots();if(t.length===0){if(!h.isEmpty())throw new k(h);break}for(const{data:o}of t){if(this.l(o.id)instanceof j.$3h){const i=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,i)}h.removeNode(o)}}return this.l(g)}s(g,$,d=[],h,m){if(this.f.get(g)instanceof j.$3h)return this.t(g,$,d,h,m);if(this.h)return this.h.s(g,$,d,h,m);throw new Error(`illegalState - creating UNKNOWN service instance ${$.name}`)}t(g,$,d=[],h,m){if(h){const c=new v(void 0,this.g,this,this.i);c.c=String(g);const t=new Map,o=new P.$mh(()=>{const r=c.j($,d,m);for(const[i,n]of t){const a=r[i];if(typeof a=="function")for(const b of n)b.disposable=a.apply(r,b.listener)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,i){if(!o.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let b=t.get(i);return b||(b=new l.$4c,t.set(i,b)),(I,E,A)=>{if(o.isInitialized)return o.value[i](I,E,A);{const M={listener:[I,E,A],disposable:void 0},T=b.push(M);return(0,s.$Rc)(()=>{T(),M.disposable?.dispose()})}}}if(i in r)return r[i];const n=o.value;let a=n[i];return typeof a!="function"||(a=a.bind(n),r[i]=a),a},set(r,i,n){return o.value[i]=n,!0},getPrototypeOf(r){return $.prototype}})}else return this.j($,d,m)}u(g,$){if($&&console.warn(g),this.g)throw new Error(g)}}e.$Eq=v;var u;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(u||(u={}));class y{static{this.all=new Set}static{this.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,$){return g?new y(2,$.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(g,$){return g?new y(1,$.name):y.c}static{this.f=0}constructor(g,$){this.type=g,this.name=$,this.g=Date.now(),this.h=[]}branch(g,$){const d=new y(3,g.toString());return this.h.push([g,$,d]),d}stop(){const g=Date.now()-this.g;y.f+=g;let $=!1;function d(m,c){const t=[],o=new Array(m+1).join("	");for(const[r,i,n]of c.h)if(i&&n){$=!0,t.push(`${o}CREATES -> ${r}`);const a=d(m+1,n);a&&t.push(a)}else t.push(`${o}uses -> ${r}`);return t.join(`
`)}const h=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(g>2||$)&&y.all.add(h.join(`
`))}}e.$Fq=y}),define(oe[219],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0zb=e.IssueType=void 0;var R;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(R||(e.IssueType=R={})),e.$0zb=(0,P.$6h)("issueService")}),define(oe[5],ae([0,1,51,3,45,2,31,4,19,12,7,115,6]),function(X,e,P,R,s,j,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,v.$6h)("logService"),e.$oj=(0,v.$6h)("loggerService");function u(){return new Date().toISOString()}function y(I){return(0,l.$Mf)(I)}e.$pj=y;var w;(function(I){I[I.Off=0]="Off",I[I.Trace=1]="Trace",I[I.Debug=2]="Debug",I[I.Info=3]="Info",I[I.Warning=4]="Warning",I[I.Error=5]="Error"})(w||(e.LogLevel=w={})),e.$qj=w.Info;function g(I,E,A){switch(E){case w.Trace:I.trace(A);break;case w.Debug:I.debug(A);break;case w.Info:I.info(A);break;case w.Warning:I.warn(A);break;case w.Error:I.error(A);break;case w.Off:break;default:throw new Error(`Invalid log level ${E}`)}}e.log=g;function $(I,E=!1){let A="";for(let M=0;M<I.length;M++){let T=I[M];if(T instanceof Error&&(T=(0,P.$Qi)(T,E)),typeof T=="object")try{T=JSON.stringify(T)}catch{}A+=(M>0?" ":"")+T}return A}class d extends j.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new R.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(E){this.b!==E&&(this.b=E,this.c.fire(this.b))}getLevel(){return this.b}f(E){return this.b!==w.Off&&this.b<=E}}e.$sj=d;class h extends d{constructor(E){super(),this.h=E}f(E){return this.h||super.f(E)}trace(E,...A){this.f(w.Trace)&&this.g(w.Trace,$([E,...A],!0))}debug(E,...A){this.f(w.Debug)&&this.g(w.Debug,$([E,...A]))}info(E,...A){this.f(w.Info)&&this.g(w.Info,$([E,...A]))}warn(E,...A){this.f(w.Warning)&&this.g(w.Warning,$([E,...A]))}error(E,...A){if(this.f(w.Error))if(E instanceof Error){const M=Array.prototype.slice.call(arguments);M[0]=E.stack,this.g(w.Error,$(M))}else this.g(w.Error,$([E,...A]))}flush(){}}e.$tj=h;class m extends d{constructor(E=e.$qj){super(),this.setLevel(E),this.g=!S.$i}trace(E,...A){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...A):console.log(`[main ${u()}]`,E,...A))}debug(E,...A){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...A):console.log(`[main ${u()}]`,E,...A))}info(E,...A){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${u()}]\x1B[0m`,E,...A):console.log(`[main ${u()}]`,E,...A))}warn(E,...A){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${u()}]\x1B[0m`,E,...A):console.warn(`[main ${u()}]`,E,...A))}error(E,...A){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${u()}]\x1B[0m`,E,...A):console.error(`[main ${u()}]`,E,...A))}flush(){}}e.$uj=m;class c extends d{constructor(E=e.$qj,A=!0){super(),this.g=A,this.setLevel(E)}trace(E,...A){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",E,...A):console.log(E,...A))}debug(E,...A){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",E,...A):console.log(E,...A))}info(E,...A){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",E,...A):console.log(E,...A))}warn(E,...A){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",E,...A):console.log(E,...A))}error(E,...A){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",E,...A):console.error(E,...A))}flush(){}}e.$vj=c;class t extends d{constructor(E,A=e.$qj){super(),this.g=E,this.setLevel(A)}trace(E,...A){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(E),...A])}debug(E,...A){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(E),...A])}info(E,...A){this.f(w.Info)&&this.g.log(w.Info,[this.h(E),...A])}warn(E,...A){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(E),...A])}error(E,...A){this.f(w.Error)&&this.g.log(w.Error,[this.h(E),...A])}h(E){return typeof E=="string"?E:(0,P.$Qi)(E,this.f(w.Trace))}flush(){}}e.$wj=t;class o extends d{constructor(E){super(),this.g=E,E.length&&this.setLevel(E[0].getLevel())}setLevel(E){for(const A of this.g)A.setLevel(E);super.setLevel(E)}trace(E,...A){for(const M of this.g)M.trace(E,...A)}debug(E,...A){for(const M of this.g)M.debug(E,...A)}info(E,...A){for(const M of this.g)M.info(E,...A)}warn(E,...A){for(const M of this.g)M.warn(E,...A)}error(E,...A){for(const M of this.g)M.error(E,...A)}flush(){for(const E of this.g)E.flush()}dispose(){for(const E of this.g)E.dispose();super.dispose()}}e.$xj=o;class r extends j.$Tc{constructor(E,A,M){if(super(),this.h=E,this.j=A,this.b=new D.$Ac,this.c=this.B(new R.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.$Vd),this.onDidChangeVisibility=this.g.event,M)for(const T of M)this.b.set(T.resource,{logger:void 0,info:T})}m(E){return(0,l.$If)(E)?[...this.b.values()].find(A=>A.info.id===E):this.b.get(E)}getLogger(E){return this.m(E)?.logger}createLogger(E,A){const M=this.n(E),T=(0,l.$If)(E)?E:A?.id??(0,s.$Ti)(M.toString()).toString(16);let W=this.b.get(M)?.logger;const G=A?.logLevel==="always"?w.Trace:A?.logLevel;W||(W=this.s(M,G??this.getLogLevel(M)??this.h,{...A,id:T}));const J={logger:W,info:{resource:M,id:T,logLevel:G,name:A?.name,hidden:A?.hidden,extensionId:A?.extensionId,when:A?.when}};return this.registerLogger(J.info),this.b.set(M,J),W}n(E){return(0,l.$If)(E)?(0,f.$Hg)(this.j,`${E}.log`):E}setLogLevel(E,A){if(p.URI.isUri(E)){const M=E,T=A,W=this.b.get(M);W&&T!==W.info.logLevel&&(W.info.logLevel=T===this.h?void 0:T,W.logger?.setLevel(T),this.b.set(W.info.resource,W),this.f.fire([M,T]))}else{this.h=E;for(const[M,T]of this.b.entries())this.b.get(M)?.info.logLevel===void 0&&T.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(E,A){const M=this.m(E);M&&A!==!M.info.hidden&&(M.info.hidden=!A,this.b.set(M.info.resource,M),this.g.fire([M.info.resource,A]))}getLogLevel(E){let A;return E&&(A=this.b.get(E)?.info.logLevel),A??this.h}registerLogger(E){const A=this.b.get(E.resource);A?A.info.hidden!==E.hidden&&this.setVisibility(E.resource,!E.hidden):(this.b.set(E.resource,{info:E,logger:void 0}),this.c.fire({added:[E],removed:[]}))}deregisterLogger(E){const A=this.b.get(E);A&&(A.logger&&A.logger.dispose(),this.b.delete(E),this.c.fire({added:[],removed:[A.info]}))}*getRegisteredLoggers(){for(const E of this.b.values())yield E.info}getRegisteredLogger(E){return this.b.get(E)?.info}dispose(){this.b.forEach(E=>E.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=r;class i{constructor(){this.onDidChangeLogLevel=new R.$Vd().event}setLevel(E){}getLevel(){return w.Info}trace(E,...A){}debug(E,...A){}info(E,...A){}warn(E,...A){}error(E,...A){}critical(E,...A){}dispose(){}flush(){}}e.$zj=i;class n extends i{}e.$Aj=n;function a(I){if(I.verbose)return w.Trace;if(typeof I.logLevel=="string"){const E=C(I.logLevel.toLowerCase());if(E!==void 0)return E}return e.$qj}e.$Bj=a;function b(I){switch(I){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.$Cj=b;function C(I){switch(I){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.$Dj=C,e.$Ej=new k.$kj("logLevel",b(w.Info))});var ne=this&&this.__param||function(X,e){return function(P,R){e(P,R,X)}};define(oe[220],ae([0,1,15,4,5]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$n$b=void 0;const j=P.safeStorage;let D=class{constructor(f){this.a=f,P.app.commandLine.getSwitchValue("password-store")==="basic"&&j.setUsePlainTextEncryption?.(!0)}async encrypt(f){this.a.trace("[EncryptionMainService] Encrypting value.");try{const l=JSON.stringify(j.encryptString(f));return this.a.trace("[EncryptionMainService] Encrypted value."),l}catch(l){throw this.a.error(l),l}}async decrypt(f){let l;try{if(l=JSON.parse(f),!l.data)throw new Error(`[EncryptionMainService] Invalid encrypted value: ${f}`);const p=Buffer.from(l.data);this.a.trace("[EncryptionMainService] Decrypting value.");const k=j.decryptString(p);return this.a.trace("[EncryptionMainService] Decrypted value."),k}catch(p){throw this.a.error(p),p}}isEncryptionAvailable(){return Promise.resolve(j.isEncryptionAvailable())}getKeyStorageProvider(){if(R.$i)return Promise.resolve("dpapi");if(R.$j)return Promise.resolve("keychain_access");if(j.getSelectedStorageBackend)try{const f=j.getSelectedStorageBackend();return Promise.resolve(f)}catch(f){this.a.error(f)}return Promise.resolve("unknown")}async setUsePlainTextEncryption(){if(R.$i)throw new Error("Setting plain text encryption is not supported on Windows.");if(R.$j)throw new Error("Setting plain text encryption is not supported on macOS.");if(!j.setUsePlainTextEncryption)throw new Error("Setting plain text encryption is not supported.");j.setUsePlainTextEncryption(!0)}};e.$n$b=D,e.$n$b=D=ve([ne(0,s.$nj)],D)}),define(oe[221],ae([0,1,22,8,14,3,2,9,67,5]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class p extends D.$Tc{constructor(v,u){super(),this.a=v,this.b=u,this.c=this.B(new j.$Vd),this.onDidChangeFile=this.c.event,this.g=this.B(new j.$Vd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new R.$4g(0)),this.w=[],this.y=this.B(new R.$4g(0))}watch(v,u){return u.recursive||this.b?.watcher?.forceUniversal?this.n(v,u):this.z(v,u)}n(v,u){const y={path:this.H(v),excludes:u.excludes,includes:u.includes,recursive:u.recursive,correlationId:u.correlationId},w=(0,P.$Ub)(this.j,y);return this.r(),(0,D.$Rc)(()=>{w(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(v=>(0,s.$1)(v))}s(){this.h||(this.h=this.B(this.t(u=>this.c.fire((0,f.$hq)(u)),u=>this.G(u),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const u of this.j)(0,f.$dq)(u)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const u of this.j)(0,f.$dq)(u)&&v.includes(u.path)&&(u.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(v,u){const y={path:this.H(v),excludes:u.excludes,includes:u.includes,recursive:!1,correlationId:u.correlationId},w=(0,P.$Ub)(this.w,y);return this.C(),(0,D.$Rc)(()=>{w(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(v=>(0,s.$1)(v))}D(){return this.u||(this.u=this.B(this.F(v=>this.c.fire((0,f.$hq)(v)),v=>this.G(v),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.u.watch(this.w)}G(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}H(v){return(0,S.$hc)(v.fsPath)}}e.$lq=p}),define(oe[222],ae([0,1,22,8,17,23,3,45,72,2,58,13,68,19,63,175,16,119,5,14]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;let c=class extends l.$Tc{static{m=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new D.$Vd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new D.$Vd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new D.$Vd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new D.$Vd),this.onDidRunOperation=this.r.event,this.X=this.B(new D.$Vd),this.Y=this.B(new D.$Vd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new D.$Vd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new R.$ch)}registerProvider(o,r){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${o}`);const i=new l.$Sc;return this.h.set(o,r),this.c.fire({added:!0,scheme:o,provider:r}),i.add(r.onDidChangeFile(n=>{const a=new g.$Jk(n,!this.S(r));this.X.fire(a),a.hasCorrelation()||this.Y.fire(a)})),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.Z.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:o}))),(0,l.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:r}),this.h.delete(o),(0,l.$Oc)(i)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const r=[];this.f.fire({scheme:o,join(i){r.push(i)}}),!this.h.has(o)&&await R.Promises.settled(r)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,r){const i=this.h.get(o.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return f.Iterable.map(this.h,([o,r])=>({scheme:o,capabilities:r.capabilities}))}async j(o){if(!(0,u.$Lg)(o))throw new g.$Lk((0,w.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const r=this.h.get(o.scheme);if(!r){const i=new h.$bb;throw i.message=(0,w.localize)(1,null,o.toString()),i}return r}async m(o){const r=await this.j(o);if((0,g.$wk)(r)||(0,g.$tk)(r)||(0,g.$xk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const r=await this.j(o);if((0,g.$wk)(r)||(0,g.$tk)(r))return r;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,r){try{return await this.s(o,r)}catch(i){throw(0,g.$Gk)(i)===g.FileSystemProviderErrorCode.FileNotFound?new g.$Lk((0,w.localize)(2,null,this.sb(o)),1):(0,g.$Ek)(i)}}async s(o,r){const i=await this.j(o),n=this.S(i),a=r?.resolveTo,b=r?.resolveSingleChildDescendants,C=r?.resolveMetadata,I=await i.stat(o);let E;return this.t(i,o,I,void 0,!!C,(A,M)=>(E||(E=p.$_h.forUris(()=>!n),E.set(o,!0),a&&E.fill(!0,a)),E.get(A.resource)||E.findSuperstr(A.resource.with({query:null,fragment:null}))?!0:A.isDirectory&&b?M===1:!1))}async t(o,r,i,n,a,b){const{providerExtUri:C}=this.R(o),I={resource:r,name:C.basename(r),isFile:(i.type&g.FileType.File)!==0,isDirectory:(i.type&g.FileType.Directory)!==0,isSymbolicLink:(i.type&g.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&g.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((i.permissions??0)&g.FilePermission.Locked),etag:(0,g.$Wk)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&b(I,n)){try{const E=await o.readdir(r),A=await R.Promises.settled(E.map(async([M,T])=>{try{const W=C.joinPath(r,M),G=a?await o.stat(W):{type:T};return await this.t(o,W,G,E.length,a,b)}catch(W){return this.b.trace(W),null}}));I.children=(0,P.$Hb)(A)}catch(E){this.b.trace(E),I.children=[]}return I}return I}async resolveAll(o){return R.Promises.settled(o.map(async r=>{try{return{stat:await this.s(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(o){const r=await this.j(o),i=await r.stat(o);return this.t(r,o,i,void 0,!0,()=>!1)}async exists(o){const r=await this.j(o);try{return!!await r.stat(o)}catch{return!1}}async canCreateFile(o,r){try{await this.u(o,r)}catch(i){return i}return!0}async u(o,r){if(!r?.overwrite&&await this.exists(o))throw new g.$Lk((0,w.localize)(3,null,this.sb(o)),3,r)}async createFile(o,r=s.$je.fromString(""),i){await this.u(o,i);const n=await this.writeFile(o,r);return this.r.fire(new g.$Ik(o,0,n)),n}async writeFile(o,r,i){const n=this.qb(await this.n(o),o),{providerExtUri:a}=this.R(n);let b=i;if((0,g.$zk)(n)&&!b?.atomic){const C=n.enforceAtomicWriteFile?.(o);C&&(b={...i,atomic:C})}try{await this.w(n,o,b)||await this.U(n,a.dirname(o));let I;if((0,g.$tk)(n)&&!(r instanceof s.$je))if((0,y.$8d)(r)){const E=await(0,y.$ce)(r,3);E.ended?I=s.$je.concat(E.buffer):I=E}else I=(0,y.$_d)(r,E=>s.$je.concat(E),3);else I=r;!(0,g.$wk)(n)||(0,g.$tk)(n)&&I instanceof s.$je||(0,g.$tk)(n)&&(0,g.$zk)(n)&&b?.atomic?await this.hb(n,o,b,I):await this.db(n,o,b,I instanceof s.$je?(0,s.$ue)(I):I),this.r.fire(new g.$Ik(o,4))}catch(C){throw new g.$Lk((0,w.localize)(4,null,this.sb(o),(0,g.$Ek)(C).toString()),(0,g.$Hk)(C),b)}return this.resolve(o,{resolveMetadata:!0})}async w(o,r,i){const n=!!i?.unlock;if(n&&!(o.capabilities&8192))throw new Error((0,w.localize)(5,null,this.sb(r)));if(!!i?.atomic){if(!(o.capabilities&32768))throw new Error((0,w.localize)(6,null,this.sb(r)));if(!(o.capabilities&2))throw new Error((0,w.localize)(7,null,this.sb(r)));if(n)throw new Error((0,w.localize)(8,null,this.sb(r)))}let b;try{b=await o.stat(r)}catch{return}if(b.type&g.FileType.Directory)throw new g.$Lk((0,w.localize)(9,null,this.sb(r)),0,i);if(this.rb(r,b),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==g.$Vk&&typeof b.mtime=="number"&&typeof b.size=="number"&&i.mtime<b.mtime&&i.etag!==(0,g.$Wk)({mtime:i.mtime,size:b.size}))throw new g.$Lk((0,w.localize)(10,null),3,i);return b}async readFile(o,r,i){const n=await this.m(o);return r?.atomic?this.z(n,o,r,i):this.C(n,o,r,i)}async z(o,r,i,n){return new Promise((a,b)=>{this.cb.queueFor(r,async()=>{try{const C=await this.C(o,r,i,n);a(C)}catch(C){b(C)}},this.R(o).providerExtUri)})}async C(o,r,i,n){const a=await this.D(o,r,{...i,preferUnbuffered:!0},n);return{...a,value:await(0,s.$ve)(a.value)}}async readFileStream(o,r,i){const n=await this.m(o);return this.D(n,o,r,i)}async D(o,r,i,n){const a=new j.$6d(n);let b=i;(0,g.$yk)(o)&&o.enforceAtomicReadFile?.(r)&&(b={...i,atomic:!0});const C=this.J(r,b).then(E=>E,E=>{throw a.dispose(!0),E});let I;try{return typeof b?.etag=="string"&&b.etag!==g.$Vk&&await C,b?.atomic&&(0,g.$yk)(o)||!((0,g.$wk)(o)||(0,g.$xk)(o))||(0,g.$tk)(o)&&b?.preferUnbuffered?I=this.I(o,r,b):(0,g.$xk)(o)?I=this.G(o,r,a.token,b):I=this.H(o,r,a.token,b),I.on("end",()=>a.dispose()),I.on("error",()=>a.dispose()),{...await C,value:I}}catch(E){throw I&&await(0,y.$ae)(I),this.F(E,r,b)}}F(o,r,i){const n=(0,w.localize)(11,null,this.sb(r),(0,g.$Ek)(o).toString());return o instanceof g.$Nk?new g.$Nk(n,o.stat,i):o instanceof g.$Mk?new g.$Mk(n,o.fileOperationResult,o.size,o.options):new g.$Lk(n,(0,g.$Hk)(o),i)}G(o,r,i,n=Object.create(null)){const a=o.readFileStream(r,n,i);return(0,y.$ge)(a,{data:b=>b instanceof s.$je?b:s.$je.wrap(b),error:b=>this.F(b,r,n)},b=>s.$je.concat(b))}H(o,r,i,n=Object.create(null)){const a=(0,s.$ze)();return(0,$.$bq)(o,r,a,b=>b,{...n,bufferSize:this.a,errorTransformer:b=>this.F(b,r,n)},i),a}I(o,r,i){const n=(0,y.$0d)(a=>s.$je.concat(a));return(async()=>{try{let a;i?.atomic&&(0,g.$yk)(o)?a=await o.readFile(r,{atomic:!0}):a=await o.readFile(r),typeof i?.position=="number"&&(a=a.slice(i.position)),typeof i?.length=="number"&&(a=a.slice(0,i.length)),this.L(r,a.byteLength,i),n.end(s.$je.wrap(a))}catch(a){n.error(a),n.end()}})(),n}async J(o,r){const i=await this.resolve(o,{resolveMetadata:!0});if(i.isDirectory)throw new g.$Lk((0,w.localize)(12,null,this.sb(o)),0,r);if(typeof r?.etag=="string"&&r.etag!==g.$Vk&&r.etag===i.etag)throw new g.$Nk((0,w.localize)(13,null),i,r);return this.L(o,i.size,r),i}L(o,r,i){if(typeof i?.limits?.size=="number"&&r>i.limits.size)throw new g.$Mk((0,w.localize)(14,null,this.sb(o)),7,r,i)}async canMove(o,r,i){return this.M(o,r,"move",i)}async canCopy(o,r,i){return this.M(o,r,"copy",i)}async M(o,r,i,n){if(o.toString()!==r.toString())try{const a=i==="move"?this.qb(await this.n(o),o):await this.m(o),b=this.qb(await this.n(r),r);await this.Q(a,o,b,r,i,n)}catch(a){return a}return!0}async move(o,r,i){const n=this.qb(await this.n(o),o),a=this.qb(await this.n(r),r),b=await this.N(n,o,a,r,"move",!!i),C=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$Ik(o,b==="move"?2:3,C)),C}async copy(o,r,i){const n=await this.m(o),a=this.qb(await this.n(r),r),b=await this.N(n,o,a,r,"copy",!!i),C=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$Ik(o,b==="copy"?3:2,C)),C}async N(o,r,i,n,a,b){if(r.toString()===n.toString())return a;const{exists:C,isSameResourceWithDifferentPathCase:I}=await this.Q(o,r,i,n,a,b);if(C&&!I&&b&&await this.del(n,{recursive:!0}),await this.U(i,this.R(i).providerExtUri.dirname(n)),a==="copy"){if(o===i&&(0,g.$uk)(o))await o.copy(r,n,{overwrite:b});else{const E=await this.resolve(r);E.isDirectory?await this.P(o,E,i,n):await this.O(o,r,i,n)}return a}else return o===i?(await o.rename(r,n,{overwrite:b}),a):(await this.N(o,r,i,n,"copy",b),await this.del(r,{recursive:!0}),"copy")}async O(o,r,i,n){if((0,g.$wk)(o)&&(0,g.$wk)(i))return this.jb(o,r,i,n);if((0,g.$wk)(o)&&(0,g.$tk)(i))return this.pb(o,r,i,n);if((0,g.$tk)(o)&&(0,g.$wk)(i))return this.nb(o,r,i,n);if((0,g.$tk)(o)&&(0,g.$tk)(i))return this.lb(o,r,i,n)}async P(o,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await R.Promises.settled(r.children.map(async a=>{const b=this.R(i).providerExtUri.joinPath(n,a.name);return a.isDirectory?this.P(o,await this.resolve(a.resource),i,b):this.O(o,a.resource,i,b)}))}async Q(o,r,i,n,a,b){let C=!1;if(o===i){const{providerExtUri:E,isPathCaseSensitive:A}=this.R(o);if(A||(C=E.isEqual(r,n)),C&&a==="copy")throw new Error((0,w.localize)(15,null,this.sb(r),this.sb(n)));if(!C&&E.isEqualOrParent(n,r))throw new Error((0,w.localize)(16,null,this.sb(r),this.sb(n)))}const I=await this.exists(n);if(I&&!C){if(!b)throw new g.$Lk((0,w.localize)(17,null,this.sb(r),this.sb(n)),4);if(o===i){const{providerExtUri:E}=this.R(o);if(E.isEqualOrParent(r,n))throw new Error((0,w.localize)(18,null,this.sb(r),this.sb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:C}}R(o){const r=this.S(o);return{providerExtUri:r?u.$xg:u.$zg,isPathCaseSensitive:r}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const r=this.qb(await this.j(o),o);await this.U(r,o);const i=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new g.$Ik(o,0,i)),i}async U(o,r){const i=[],{providerExtUri:n}=this.R(o);for(;!n.isEqual(r,n.dirname(r));)try{if(!((await o.stat(r)).type&g.FileType.Directory))throw new Error((0,w.localize)(19,null,this.sb(r)));break}catch(a){if((0,g.$Gk)(a)!==g.FileSystemProviderErrorCode.FileNotFound)throw a;i.push(n.basename(r)),r=n.dirname(r)}for(let a=i.length-1;a>=0;a--){r=n.joinPath(r,i[a]);try{await o.mkdir(r)}catch(b){if((0,g.$Gk)(b)!==g.FileSystemProviderErrorCode.FileExists)throw b}}}async canDelete(o,r){try{await this.W(o,r)}catch(i){return i}return!0}async W(o,r){const i=this.qb(await this.j(o),o),n=!!r?.useTrash;if(n&&!(i.capabilities&4096))throw new Error((0,w.localize)(20,null,this.sb(o)));const a=r?.atomic;if(a&&!(i.capabilities&65536))throw new Error((0,w.localize)(21,null,this.sb(o)));if(n&&a)throw new Error((0,w.localize)(22,null,this.sb(o)));let b;try{b=await i.stat(o)}catch{}if(b)this.rb(o,b);else throw new g.$Lk((0,w.localize)(23,null,this.sb(o)),1);if(!!!r?.recursive){const I=await this.resolve(o);if(I.isDirectory&&Array.isArray(I.children)&&I.children.length>0)throw new Error((0,w.localize)(24,null,this.sb(o)))}return i}async del(o,r){const i=await this.W(o,r);let n=r;if((0,g.$Ak)(i)&&!n?.atomic){const I=i.enforceAtomicDelete?.(o);I&&(n={...r,atomic:I})}const a=!!n?.useTrash,b=!!n?.recursive,C=n?.atomic??!1;await i.delete(o,{recursive:b,useTrash:a,atomic:C}),this.r.fire(new g.$Ik(o,1))}async cloneFile(o,r){const i=await this.j(o),n=this.qb(await this.n(r),r);if(!(i===n&&this.R(i).providerExtUri.isEqual(o,r)))return i===n&&(0,g.$vk)(i)?i.cloneFile(o,r):(await this.U(n,this.R(n).providerExtUri.dirname(r)),i===n&&(0,g.$uk)(i)?this.cb.queueFor(o,()=>i.copy(o,r,{overwrite:!0}),this.R(i).providerExtUri):this.cb.queueFor(o,()=>this.O(i,o,n,r),this.R(i).providerExtUri))}static{this.ab=0}createWatcher(o,r){return this.watch(o,{...r,correlationId:m.ab++})}watch(o,r={recursive:!1,excludes:[]}){const i=new l.$Sc;let n=!1,a=()=>{n=!0};i.add((0,l.$Rc)(()=>a())),(async()=>{try{const C=await this.bb(o,r);n?(0,l.$Oc)(C):a=()=>(0,l.$Oc)(C)}catch(C){this.b.error(C)}})();const b=r.correlationId;if(typeof b=="number"){const C=i.add(new D.$Vd);return i.add(this.X.event(E=>{E.correlates(b)&&C.fire(E)})),{onDidChange:C.event,dispose:()=>i.dispose()}}return i}async bb(o,r){const i=await this.j(o),n=(0,S.$Ti)([this.R(i).providerExtUri.getComparisonKey(o),r]);let a=this.$.get(n);return a||(a={count:0,disposable:i.watch(o,r)},this.$.set(n,a)),a.count+=1,(0,l.$Rc)(()=>{a&&(a.count--,a.count===0&&((0,l.$Oc)(a.disposable),this.$.delete(n)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,l.$Oc)(o.disposable);this.$.clear()}async db(o,r,i,n){return this.cb.queueFor(r,async()=>{const a=await o.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,y.$8d)(n)||(0,y.$9d)(n)?await this.eb(o,a,n):await this.fb(o,a,n)}catch(b){throw(0,g.$Ek)(b)}finally{await o.close(a)}},this.R(o).providerExtUri)}async eb(o,r,i){let n=0,a;if((0,y.$9d)(i)){if(i.buffer.length>0){const b=s.$je.concat(i.buffer);await this.gb(o,r,b,b.byteLength,n,0),n+=b.byteLength}if(i.ended)return;a=i.stream}else a=i;return new Promise((b,C)=>{(0,y.$be)(a,{onData:async I=>{a.pause();try{await this.gb(o,r,I,I.byteLength,n,0)}catch(E){return C(E)}n+=I.byteLength,setTimeout(()=>a.resume())},onError:I=>C(I),onEnd:()=>b()})})}async fb(o,r,i){let n=0,a;for(;(a=i.read())!==null;)await this.gb(o,r,a,a.byteLength,n,0),n+=a.byteLength}async gb(o,r,i,n,a,b){let C=0;for(;C<n;){const I=await o.write(r,a+C,i.buffer,b+C,n-C);C+=I}}async hb(o,r,i,n){return this.cb.queueFor(r,()=>this.ib(o,r,i,n),this.R(o).providerExtUri)}async ib(o,r,i,n){let a;n instanceof s.$je?a=n:(0,y.$8d)(n)?a=await(0,s.$ve)(n):(0,y.$9d)(n)?a=await(0,s.$we)(n):a=(0,s.$te)(n),await o.writeFile(r,a.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1,atomic:i?.atomic??!1})}async jb(o,r,i,n){return this.cb.queueFor(n,()=>this.kb(o,r,i,n),this.R(i).providerExtUri)}async kb(o,r,i,n){let a,b;try{a=await o.open(r,{create:!1}),b=await i.open(n,{create:!0,unlock:!1});const C=s.$je.alloc(this.a);let I=0,E=0,A=0;do A=await o.read(a,I,C.buffer,E,C.byteLength-E),await this.gb(i,b,C,A,I,E),I+=A,E+=A,E===C.byteLength&&(E=0);while(A>0)}catch(C){throw(0,g.$Ek)(C)}finally{await R.Promises.settled([typeof a=="number"?o.close(a):Promise.resolve(),typeof b=="number"?i.close(b):Promise.resolve()])}}async lb(o,r,i,n){return this.cb.queueFor(n,()=>this.mb(o,r,i,n),this.R(i).providerExtUri)}async mb(o,r,i,n){return i.writeFile(n,await o.readFile(r),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,r,i,n){return this.cb.queueFor(n,()=>this.ob(o,r,i,n),this.R(i).providerExtUri)}async ob(o,r,i,n){const a=await i.open(n,{create:!0,unlock:!1});try{const b=await o.readFile(r);await this.gb(i,a,s.$je.wrap(b),b.byteLength,0,0)}catch(b){throw(0,g.$Ek)(b)}finally{await i.close(a)}}async pb(o,r,i,n){const a=await(0,s.$ve)(this.H(o,r,j.CancellationToken.None));await this.hb(i,n,void 0,a)}qb(o,r){if(o.capabilities&2048)throw new g.$Lk((0,w.localize)(25,null,this.sb(r)),6);return o}rb(o,r){if((r.permissions??0)&g.FilePermission.Readonly)throw new g.$Lk((0,w.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===k.Schemas.file?o.fsPath:o.toString(!0)}};e.$cq=c,e.$cq=c=m=ve([ne(0,d.$nj)],c)}),define(oe[93],ae([0,1,46,311,8,31,17,3,33,2,9,4,19,63,21,179,16,119,221,51,217,216]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0,(()=>{try{(0,R.gracefulify)(P)}catch(o){console.error(`Error enabling graceful-fs: ${(0,h.$Qi)(o)}`)}})();class t extends d.$lq{static{this.I=!1}constructor(r,i){super(r,i),this.onDidChangeCapabilities=S.Event.None,this.N=new j.$Ac(n=>v.$yg.getComparisonKey(n)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,k.$k&&(this.J|=1024)),this.J}async stat(r){try{const{stat:i,symbolicLink:n}=await y.SymlinkSupport.stat(this.H(r));return{type:this.M(i,n),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size,permissions:i.mode&128?void 0:g.FilePermission.Locked}}catch(i){throw this.fb(i)}}async L(r){try{return await this.stat(r)}catch{return}}async readdir(r){try{const i=await y.Promises.readdir(this.H(r),{withFileTypes:!0}),n=[];return await Promise.all(i.map(async a=>{try{let b;a.isSymbolicLink()?b=(await this.stat((0,v.$Hg)(r,a.name))).type:b=this.M(a),n.push([a.name,b])}catch(b){this.a.trace(b)}})),n}catch(i){throw this.fb(i)}}M(r,i){let n;return i?.dangling?n=g.FileType.Unknown:r.isFile()?n=g.FileType.File:r.isDirectory()?n=g.FileType.Directory:n=g.FileType.Unknown,i&&(n|=g.FileType.SymbolicLink),n}async O(r){const i=this.H(r);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let n;for(;n=this.N.get(r);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await n.wait();const a=new s.$5g;return this.N.set(r,a),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,l.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.N.get(r)===a&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.N.delete(r)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),a.open()})}async readFile(r,i){let n;try{i?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(r)})`),n=await this.O(r));const a=this.H(r);return await y.Promises.readFile(a)}catch(a){throw this.fb(a)}finally{n?.dispose()}}P(r){t.I&&this.a.trace(r)}readFileStream(r,i,n){const a=(0,u.$0d)(b=>D.$je.concat(b.map(C=>D.$je.wrap(C))).buffer);return(0,$.$bq)(this,r,a,b=>b.buffer,{...i,bufferSize:256*1024},n),a}async writeFile(r,i,n){return n?.atomic!==!1&&n?.atomic?.postfix&&await this.Q(r)?this.R(r,(0,v.$Hg)((0,v.$Gg)(r),`${(0,v.$Eg)(r)}${n.atomic.postfix}`),i,n):this.S(r,i,n)}async Q(r){try{const i=this.H(r),{symbolicLink:n}=await y.SymlinkSupport.stat(i);if(n)return!1}catch{}return!0}async R(r,i,n,a){const b=new l.$Sc;try{b.add(await this.O(r)),b.add(await this.O(i)),await this.S(i,n,a,!0);try{await this.rename(i,r,{overwrite:!0})}catch(C){try{await this.delete(i,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw C}}finally{b.dispose()}}async S(r,i,n,a){let b;try{const C=this.H(r);if(!n.create||!n.overwrite){if(await y.Promises.exists(C)){if(!n.overwrite)throw(0,g.$Dk)((0,w.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!n.create)throw(0,g.$Dk)((0,w.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}b=await this.open(r,{create:!0,unlock:n.unlock},a),await this.write(b,0,i,0,i.byteLength)}catch(C){throw await this.gb(r,C)}finally{typeof b=="number"&&await this.close(b)}}static{this.Y=!0}static configureFlushOnWrite(r){t.Y=r}async open(r,i,n){const a=this.H(r);let b;(0,g.$rk)(i)&&!n&&(b=await this.O(r));let C;try{if((0,g.$rk)(i)&&i.unlock)try{const{stat:E}=await y.SymlinkSupport.stat(a);E.mode&128||await y.Promises.chmod(a,E.mode|128)}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}let I;if((0,g.$rk)(i)){if(k.$i)try{await y.Promises.truncate(a,0),I="r+"}catch(E){E.code!=="ENOENT"&&this.a.trace(E)}I||(I="w")}else I="r";C=await y.Promises.open(a,I)}catch(I){throw b?.dispose(),(0,g.$rk)(i)?await this.gb(r,I):this.fb(I)}if(this.U.set(C,0),(0,g.$rk)(i)&&this.X.set(C,r),b){const I=this.W.get(C);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${C} (${a})`),this.W.set(C,b),I&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${C} (${a})`),I.dispose())}return C}async close(r){const i=this.W.get(r);try{if(this.U.delete(r),this.X.delete(r)&&t.Y)try{await y.Promises.fdatasync(r)}catch(n){t.configureFlushOnWrite(!1),this.a.error(n)}return await y.Promises.close(r)}catch(n){throw this.fb(n)}finally{i&&(this.W.get(r)===i&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${r}`),this.W.delete(r)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${r}`),i.dispose())}}async read(r,i,n,a,b){const C=this.Z(r,i);let I=null;try{I=(await y.Promises.read(r,n,a,b,C)).bytesRead}catch(E){throw this.fb(E)}finally{this.$(r,C,I)}return I}Z(r,i){return i===this.U.get(r)?null:i}$(r,i,n){const a=this.U.get(r);typeof a=="number"&&(typeof i=="number"||(typeof n=="number"?this.U.set(r,a+n):this.U.delete(r)))}async write(r,i,n,a,b){return(0,s.$nh)(()=>this.ab(r,i,n,a,b),100,3)}async ab(r,i,n,a,b){const C=this.Z(r,i);let I=null;try{I=(await y.Promises.write(r,n,a,b,C)).bytesWritten}catch(E){throw await this.gb(this.X.get(r),E)}finally{this.$(r,C,I)}return I}async mkdir(r){try{await y.Promises.mkdir(this.H(r))}catch(i){throw this.fb(i)}}async delete(r,i){try{const n=this.H(r);if(i.recursive){let a;i?.atomic!==!1&&i.atomic.postfix&&(a=(0,p.$jc)((0,p.$mc)(n),`${(0,p.$nc)(n)}${i.atomic.postfix}`)),await y.Promises.rm(n,y.RimRafMode.MOVE,a)}else try{await y.Promises.unlink(n)}catch(a){if(a.code==="EPERM"||a.code==="EISDIR"){let b=!1;try{const{stat:C,symbolicLink:I}=await y.SymlinkSupport.stat(n);b=C.isDirectory()&&!I}catch{}if(b)await y.Promises.rmdir(n);else throw a}else throw a}}catch(n){throw this.fb(n)}}async rename(r,i,n){const a=this.H(r),b=this.H(i);if(a!==b)try{await this.bb(r,i,"move",n.overwrite),await y.Promises.rename(a,b)}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,w.localize)(2,null,(0,p.$nc)(a),(0,p.$nc)((0,p.$mc)(b)),C.toString()))),this.fb(C)}}async copy(r,i,n){const a=this.H(r),b=this.H(i);if(a!==b)try{await this.bb(r,i,"copy",n.overwrite),await y.Promises.copy(a,b,{preserveSymlinks:!0})}catch(C){throw(C.code==="EINVAL"||C.code==="EBUSY"||C.code==="ENAMETOOLONG")&&(C=new Error((0,w.localize)(3,null,(0,p.$nc)(a),(0,p.$nc)((0,p.$mc)(b)),C.toString()))),this.fb(C)}}async bb(r,i,n,a){const b=this.H(r),C=this.H(i);let I=!1;if(!!(this.capabilities&1024)||(I=(0,f.$7f)(b,C,!0)),I){if(n==="copy")throw(0,g.$Dk)((0,w.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(n==="move")return}const A=await this.L(r);if(!A)throw(0,g.$Dk)((0,w.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const M=await this.L(i);if(M){if(!a)throw(0,g.$Dk)((0,w.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);A.type&g.FileType.File&&M.type&g.FileType.File||await this.delete(i,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(r,i){return this.cb(r,i,!1)}async cb(r,i,n){const a=this.H(r),b=this.H(i),C=!!(this.capabilities&1024);if((0,f.$7f)(a,b,!C))return;const I=new l.$Sc;try{I.add(await this.O(r)),I.add(await this.O(i)),n&&await y.Promises.mkdir((0,p.$mc)(b),{recursive:!0}),await y.Promises.copyFile(a,b)}catch(E){if(E.code==="ENOENT"&&!n)return this.cb(r,i,!0);throw this.fb(E)}finally{I.dispose()}}t(r,i,n){return new m.$sq(a=>r(a),a=>i(a),n)}F(r,i,n){return new c.$Aq(a=>r(a),a=>i(a),n)}fb(r){if(r instanceof g.$Ck)return r;let i=r,n;switch(r.code){case"ENOENT":n=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${r.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,n=g.FileSystemProviderErrorCode.Unknown;break;default:n=g.FileSystemProviderErrorCode.Unknown}return(0,g.$Dk)(i,n)}async gb(r,i){let n=this.fb(i);if(r&&n.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:a}=await y.SymlinkSupport.stat(this.H(r));a.mode&128||(n=(0,g.$Dk)(i,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(a){this.a.trace(a)}return n}}e.$Bq=t}),define(oe[223],ae([0,1,3,93,2,17,63,23]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_r=e.$$r=void 0;class f extends s.$Tc{constructor(k,v){super(),this.a=k,this.b=v,this.F=new Map,this.G=new Map}call(k,v,u){const y=this.c(k);switch(v){case"stat":return this.g(y,u[0]);case"readdir":return this.h(y,u[0]);case"open":return this.r(y,u[0],u[1]);case"close":return this.s(u[0]);case"read":return this.t(u[0],u[1],u[2]);case"readFile":return this.j(y,u[0],u[1]);case"write":return this.u(u[0],u[1],u[2],u[3],u[4]);case"writeFile":return this.n(y,u[0],u[1],u[2]);case"rename":return this.z(y,u[0],u[1],u[2]);case"copy":return this.C(y,u[0],u[1],u[2]);case"cloneFile":return this.D(y,u[0],u[1]);case"mkdir":return this.w(y,u[0]);case"delete":return this.y(y,u[0],u[1]);case"watch":return this.I(y,u[0],u[1],u[2],u[3]);case"unwatch":return this.J(u[0],u[1])}throw new Error(`IPC Command ${v} not found`)}listen(k,v,u){const y=this.c(k);switch(v){case"fileChange":return this.H(y,u[0]);case"readFileStream":return this.m(y,u[0],u[1])}throw new Error(`Unknown event ${v}`)}g(k,v){const u=this.f(k,v,!0);return this.a.stat(u)}h(k,v){const u=this.f(k,v);return this.a.readdir(u)}async j(k,v,u){const y=this.f(k,v,!0),w=await this.a.readFile(y,u);return j.$je.wrap(w)}m(k,v,u){const y=this.f(k,v,!0),w=new S.$6d,g=new P.$Vd({onDidRemoveLastListener:()=>{w.cancel()}}),$=this.a.readFileStream(y,u,w.token);return(0,D.$be)($,{onData:d=>g.fire(j.$je.wrap(d)),onError:d=>g.fire(d),onEnd:()=>{g.fire("end"),g.dispose(),w.dispose()}}),g.event}n(k,v,u,y){const w=this.f(k,v);return this.a.writeFile(w,u.buffer,y)}r(k,v,u){const y=this.f(k,v,!0);return this.a.open(y,u)}s(k){return this.a.close(k)}async t(k,v,u){const y=j.$je.alloc(u),w=0,g=await this.a.read(k,v,y.buffer,w,u);return[y,g]}u(k,v,u,y,w){return this.a.write(k,v,u.buffer,y,w)}w(k,v){const u=this.f(k,v);return this.a.mkdir(u)}y(k,v,u){const y=this.f(k,v);return this.a.delete(y,u)}z(k,v,u,y){const w=this.f(k,v),g=this.f(k,u);return this.a.rename(w,g,y)}C(k,v,u,y){const w=this.f(k,v),g=this.f(k,u);return this.a.copy(w,g,y)}D(k,v,u){const y=this.f(k,v),w=this.f(k,u);return this.a.cloneFile(y,w)}H(k,v){const u=new P.$Vd({onWillAddFirstListener:()=>{this.F.set(v,this.L(k,u))},onDidRemoveLastListener:()=>{(0,s.$Oc)(this.F.get(v)),this.F.delete(v)}});return u.event}async I(k,v,u,y,w){const g=this.F.get(v);if(g){const $=this.f(k,y),d=g.watch(u,$,w);this.G.set(v+u,d)}}async J(k,v){const u=k+v,y=this.G.get(u);y&&((0,s.$Oc)(y),this.G.delete(u))}dispose(){super.dispose();for(const[,k]of this.G)k.dispose();this.G.clear();for(const[,k]of this.F)k.dispose();this.F.clear()}}e.$$r=f;class l extends s.$Tc{constructor(k,v,u,y){super(),this.c=k,this.f=u,this.g=y,this.a=new Map,this.b=this.B(new R.$Bq(this.f,{watcher:{recursive:this.j(this.g)}})),this.h(v)}h(k){const v=this.B(new P.$Vd);this.B(v.event(u=>{k.fire(u.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type,cId:y.cId})))})),this.B(this.b.onDidChangeFile(u=>v.fire(u))),this.B(this.b.onDidWatchError(u=>k.fire(u)))}j(k){}m(k){}watch(k,v,u){const y=this.m(this.g);return Array.isArray(y)&&(u.excludes=[...u.excludes,...y]),this.a.set(k,this.b.watch(v,u)),(0,s.$Rc)(()=>{(0,s.$Oc)(this.a.get(k)),this.a.delete(k)})}dispose(){for(const[,k]of this.a)k.dispose();this.a.clear(),super.dispose()}}e.$_r=l}),define(oe[224],ae([0,1,15,178,4,7,16,9,223,155]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v$b=void 0;class p extends f.$$r{constructor(u,y,w){super(u,y),this.M=w}c(u){return l.$5m}f(u,y){return j.URI.revive(y)}async y(u,y,w){if(!w.useTrash)return super.y(u,y,w);const g=this.f(u,y),$=(0,S.$hc)(g.fsPath);try{await P.shell.trashItem($)}catch{throw(0,D.$Dk)(s.$i?(0,R.localize)(0,null,(0,S.$nc)($)):(0,R.localize)(1,null,(0,S.$nc)($)),D.FileSystemProviderErrorCode.Unknown)}}L(u,y){return new k(u,y,this.b,this.M)}}e.$v$b=p;class k extends f.$_r{watch(u,y,w){if(w.recursive)throw(0,D.$Dk)("Recursive file watching is not supported from main process for performance reasons.",D.FileSystemProviderErrorCode.Unavailable);return super.watch(u,y,w)}}}),define(oe[225],ae([0,1,5]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j8b=void 0;class R extends P.$tj{constructor(j=P.$qj){super(),this.m=[],this.n=void 0,this.setLevel(j),this.B(this.onDidChangeLogLevel(D=>{this.n?.setLevel(D)}))}set logger(j){this.n=j;for(const{level:D,message:S}of this.m)(0,P.log)(j,D,S);this.m=[]}g(j,D){this.n?(0,P.log)(this.n,j,D):this.getLevel()<=j&&this.m.push({level:j,message:D})}dispose(){this.n?.dispose(),super.dispose()}flush(){this.n?.flush()}}e.$j8b=R}),define(oe[226],ae([0,1,7,3,5,2]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=void 0;class D extends s.$yj{constructor(k,v,u,y,w){super(v,u,y),this.r=k,this.t=w,this.B(w.listen("onDidChangeLogLevel",k)(g=>{(0,s.$pj)(g)?super.setLogLevel(g):super.setLogLevel(P.URI.revive(g[0]),g[1])})),this.B(w.listen("onDidChangeVisibility",k)(([g,$])=>super.setVisibility(P.URI.revive(g),$))),this.B(w.listen("onDidChangeLoggers",k)(({added:g,removed:$})=>{for(const d of g)super.registerLogger({...d,resource:P.URI.revive(d.resource)});for(const d of $)super.deregisterLogger(d.resource)}))}createConsoleMainLogger(){return new s.$wj({log:(k,v)=>{this.t.call("consoleLog",[k,v])}})}registerLogger(k){super.registerLogger(k),this.t.call("registerLogger",[k,this.r])}deregisterLogger(k){super.deregisterLogger(k),this.t.call("deregisterLogger",[k,this.r])}setLogLevel(k,v){super.setLogLevel(k,v),this.t.call("setLogLevel",[k,v])}setVisibility(k,v){super.setVisibility(k,v),this.t.call("setVisibility",[this.n(k),v])}s(k,v,u){return new S(this.t,k,v,u,this.r)}static setLogLevel(k,v,u){return k.call("setLogLevel",[v,u])}}e.$Ar=D;class S extends s.$tj{constructor(k,v,u,y,w){super(y?.logLevel==="always"),this.r=k,this.s=v,this.m=!1,this.n=[],this.setLevel(u),this.r.call("createLogger",[v,y,w]).then(()=>{this.u(this.n),this.m=!0})}g(k,v){const u=[[k,v]];this.m?this.u(u):this.n.push(...u)}u(k){this.r.call("log",[this.s,k])}}class f{constructor(k,v){this.a=k,this.b=v}listen(k,v){const u=this.b(k);switch(v){case"onDidChangeLoggers":return R.Event.map(this.a.onDidChangeLoggers,y=>({added:[...y.added].map(w=>this.c(w,u)),removed:[...y.removed].map(w=>this.c(w,u))}));case"onDidChangeVisibility":return R.Event.map(this.a.onDidChangeVisibility,y=>[u.transformOutgoingURI(y[0]),y[1]]);case"onDidChangeLogLevel":return R.Event.map(this.a.onDidChangeLogLevel,y=>(0,s.$pj)(y)?y:[u.transformOutgoingURI(y[0]),y[1]])}throw new Error(`Event not found: ${v}`)}async call(k,v,u){const y=this.b(k);switch(v){case"setLogLevel":return(0,s.$pj)(u[0])?this.a.setLogLevel(u[0]):this.a.setLogLevel(P.URI.revive(y.transformIncoming(u[0][0])),u[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(w=>this.c(w,y)))}throw new Error(`Call not found: ${v}`)}c(k,v){return{...k,resource:v.transformOutgoingURI(k.resource)}}}e.$Br=f;class l extends j.$Tc{constructor(k,v){super(),v.call("setLogLevel",[k.getLogLevel()]),this.B(k.onDidChangeLogLevel(u=>v.call("setLogLevel",[u]))),v.call("getRegisteredLoggers").then(u=>{for(const y of u)k.registerLogger({...y,resource:P.URI.revive(y.resource)})}),this.B(v.listen("onDidChangeVisibility")(([u,y])=>k.setVisibility(P.URI.revive(u),y))),this.B(v.listen("onDidChangeLoggers")(({added:u,removed:y})=>{for(const w of u)k.registerLogger({...w,resource:P.URI.revive(w.resource)});for(const w of y)k.deregisterLogger(w.resource)}))}}e.$Cr=l}),define(oe[227],ae([0,1,2,5]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=void 0;class s extends P.$Tc{constructor(D,S=[]){super(),this.a=new R.$xj([D,...S]),this.B(D.onDidChangeLogLevel(f=>this.setLevel(f)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(D){this.a.setLevel(D)}getLevel(){return this.a.getLevel()}trace(D,...S){this.a.trace(D,...S)}debug(D,...S){this.a.debug(D,...S)}info(D,...S){this.a.info(D,...S)}warn(D,...S){this.a.warn(D,...S)}error(D,...S){this.a.error(D,...S)}flush(){this.a.flush()}}e.$CO=s}),define(oe[228],ae([0,1,31,7,5]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$p_b=void 0;class j{constructor(S){this.b=S,this.a=new P.$Ac}listen(S,f,l){switch(f){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${f}`)}async call(S,f,l){switch(f){case"createLogger":this.c(R.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(R.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.$pj)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(R.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(R.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:R.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(R.URI.revive(l[0]))}throw new Error(`Call not found: ${f}`)}c(S,f,l){this.a.set(S,this.b.createLogger(S,f,l))}d(S,f){let l=console.log;switch(S){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...f)}e(S,f){const l=this.a.get(S);if(!l)throw new Error("Create the logger before logging");for(const[p,k]of f)(0,s.log)(l,p,k)}}e.$p_b=j}),define(oe[229],ae([0,1,16,5]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function j(l,p,k,v,u){try{const y=await new Promise((g,$)=>{X(["@vscode/spdlog"],g,$)});y.setFlushOn(s.Trace);const w=await y.createAsyncRotatingLogger(l,p,k,v);return u?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function D(l,p,k){switch(p){case R.LogLevel.Trace:l.trace(k);break;case R.LogLevel.Debug:l.debug(k);break;case R.LogLevel.Info:l.info(k);break;case R.LogLevel.Warning:l.warn(k);break;case R.LogLevel.Error:l.error(k);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function S(l,p){switch(p){case R.LogLevel.Trace:l.setLevel(s.Trace);break;case R.LogLevel.Debug:l.setLevel(s.Debug);break;case R.LogLevel.Info:l.setLevel(s.Info);break;case R.LogLevel.Warning:l.setLevel(s.Warning);break;case R.LogLevel.Error:l.setLevel(s.Error);break;case R.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class f extends R.$tj{constructor(p,k,v,u,y){super(),this.m=[],this.setLevel(y),this.n=this.s(p,k,v,u),this.B(this.onDidChangeLogLevel(w=>{this.r&&S(this.r,w)}))}async s(p,k,v,u){const y=v?6:1,w=30/y*P.$Yk.MB,g=await j(p,k,w,y,u);if(g){this.r=g,S(this.r,this.getLevel());for(const{level:$,message:d}of this.m)D(this.r,$,d);this.m=[]}}g(p,k){this.r?D(this.r,p,k):this.getLevel()<=p&&this.m.push({level:p,message:k})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$rO=f}),define(oe[230],ae([0,1,32,5,229]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=void 0;class j extends R.$yj{s(S,f,l){return new s.$rO((0,P.$qg)(),S.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,f)}}e.$sO=j}),define(oe[69],ae([0,1,31,3,6,5,230]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$40b=e.$30b=void 0,e.$30b=(0,s.$7h)(j.$oj);class S extends D.$sO{constructor(){super(...arguments),this.u=new P.$Ac}createLogger(l,p,k){k!==void 0&&this.u.set(this.n(l),k);try{return super.createLogger(l,p)}catch(v){throw this.u.delete(this.n(l)),v}}registerLogger(l,p){p!==void 0&&this.u.set(l.resource,p),super.registerLogger(l)}deregisterLogger(l){this.u.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const p=[];for(const k of super.getRegisteredLoggers())l===this.u.get(k.resource)&&p.push(k);return p}getOnDidChangeLogLevelEvent(l){return R.Event.filter(this.onDidChangeLogLevel,p=>(0,j.$pj)(p)||this.w(p[0],l))}getOnDidChangeVisibilityEvent(l){return R.Event.filter(this.onDidChangeVisibility,([p])=>this.w(p,l))}getOnDidChangeLoggersEvent(l){return R.Event.filter(R.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(v=>this.w(v.resource,l)),removed:[...p.removed].filter(v=>this.w(v.resource,l))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(l){for(const[p,k]of this.u)k===l&&this.deregisterLogger(p)}w(l,p){const k=this.u.get(l);return k===void 0||k===p}dispose(){super.dispose(),this.u.clear()}}e.$40b=S}),define(oe[231],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K$b=e.$J$b=e.$I$b=e.$H$b=void 0;function P(D){return D.submenu!==void 0}e.$H$b=P;function R(D){return D.id==="vscode.menubar.separator"}e.$I$b=R;function s(D){return D.uri!==void 0}e.$J$b=s;function j(D){return!P(D)&&!R(D)&&!s(D)}e.$K$b=j}),define(oe[39],ae([0,1,3,72,2,6]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=void 0,e.$Jn=(0,j.$6h)("policy");class D extends s.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new P.$Vd),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const p=Object.keys(this.f).length;return this.f={...l,...this.f},p!==Object.keys(this.f).length&&await this.j(l),R.Iterable.reduce(this.g.entries(),(k,[v,u])=>({...k,[v]:u}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return R.Iterable.reduce(Object.entries(this.f),(l,[p,k])=>({...l,[p]:{definition:k,value:this.g.get(p)}}),{})}}e.$Kn=D;class S{constructor(){this.onDidChange=P.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Ln=S}),define(oe[232],ae([0,1,8,3,72,12,16,5,39]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;function l(k,v){const u=[];for(const y of new Set(s.Iterable.concat(k.keys(),v.keys())))k.get(y)!==v.get(y)&&u.push(y);return u}let p=class extends f.$Kn{constructor(v,u,y){super(),this.m=v,this.n=u,this.s=y,this.c=this.B(new P.$4g(500));const w=R.Event.filter(u.onDidFilesChange,g=>g.affects(v));this.B(u.watch(v)),this.B(w(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const u=await this.n.readFile(this.m),y=JSON.parse(u.value.toString());if(!(0,j.$Kf)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.f[w]&&v.set(w,y[w])}catch(u){u.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",u)}return v}async w(){const v=await this.u(),u=l(this.g,v);this.g=v,u.length>0&&this.h.fire(u)}};e.$I_b=p,e.$I_b=p=ve([ne(1,D.$qk),ne(2,S.$nj)],p)}),define(oe[233],ae([0,1,3,2,39]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=e.$g_b=void 0;class j{constructor(f){this.b=f,this.a=new R.$Sc}listen(f,l){switch(l){case"onDidChange":return P.Event.map(this.b.onDidChange,p=>p.reduce((k,v)=>({...k,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(f,l,p){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.$g_b=j;class D extends s.$Kn{constructor(f,l){super(),this.a=l;for(const p in f){const{definition:k,value:v}=f[p];this.f[p]=k,v!==void 0&&this.g.set(p,v)}this.a.listen("onDidChange")(p=>{for(const k in p){const v=p[k];v===null?this.g.delete(k):this.g.set(k,v)}this.h.fire(Object.keys(p))})}async j(f){const l=await this.a.call("updatePolicyDefinitions",f);for(const p in l)this.g.set(p,l[p])}}e.$h_b=D}),define(oe[234],ae([0,1,39,8,2,5]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=void 0;let D=class extends P.$Kn{constructor(f,l){super(),this.m=f,this.n=l,this.a=new R.$Zg,this.b=this.B(new s.$Uc)}async j(f){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(f).length} policy definitions`);const{createWatcher:l}=await new Promise((p,k)=>{X(["@vscode/policy-watcher"],p,k)});await this.a.queue(()=>new Promise((p,k)=>{try{this.b.value=l(this.n,f,v=>{this.t(v),p()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),k(v)}}))}t(f){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(f)}`);for(const l in f){const p=f[l];p===void 0?this.g.delete(l):this.g.set(l,p)}this.h.fire(Object.keys(f))}};e.$H_b=D,e.$H_b=D=ve([ne(0,j.$nj)],D)}),define(oe[79],ae([0,1,36]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let R;const s=globalThis.vscode;if(typeof s<"u"&&typeof s.context<"u"){const j=s.context.configuration();if(j)R=j.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(R=globalThis._VSCODE_PRODUCT_JSON,P.env.VSCODE_DEV&&Object.assign(R,{nameShort:`${R.nameShort} Dev`,nameLong:`${R.nameLong} Dev`,dataFolderName:`${R.dataFolderName}-dev`,serverDataFolderName:R.serverDataFolderName?`${R.serverDataFolderName}-dev`:void 0}),!R.version){const j=globalThis._VSCODE_PACKAGE_JSON;Object.assign(R,{version:j.version})}}else R={},Object.keys(R).length===0&&Object.assign(R,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=R}),define(oe[27],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,P.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"}),define(oe[235],ae([0,1,8,5]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$y$b=void 0;let s=class{constructor(D,S,f){this.a=D,this.b=S,this.c=f}async inspect(D){await this.d();const S=this.a.webContents.debugger;await S.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,P.$7g)(D);const f=await S.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),f.profile}async d(){const D=this.a.webContents.debugger;D.attach(),await D.sendCommand("Profiler.enable")}async e(){const D=this.a.webContents.debugger;await D.sendCommand("Profiler.disable"),D.detach()}};e.$y$b=s,e.$y$b=s=ve([ne(2,R.$nj)],s)}),define(oe[80],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I0b=void 0,e.$I0b=(0,P.$6h)("protocolMainService")}),define(oe[44],ae([0,1,138,12]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class s{constructor(){this.a=new Map}add(D,S){P.ok(R.$If(D)),P.ok(R.$Kf(S)),P.ok(!this.a.has(D),"There is already an extension with this id"),this.a.set(D,S)}knows(D){return this.a.has(D)}as(D){return this.a.get(D)||null}}e.$Hn=new s}),define(oe[236],ae([0,1,3,44]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function s(S){return S.length>0&&S.charAt(S.length-1)==="#"?S.substring(0,S.length-1):S}class j{constructor(){this.b=new P.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(f,l){this.a[s(f)]=l,this.b.fire(f)}notifySchemaChanged(f){this.b.fire(f)}getSchemaContributions(){return{schemas:this.a}}}const D=new j;R.$Hn.add(e.$In.JSONContribution,D)}),define(oe[52],ae([0,1,22,3,12,163,18,236,44]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var l;(function(c){c.Multiline="multilineText",c.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.$Mn={Configuration:"base.contributions.configuration"};var p;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.MACHINE=2]="MACHINE",c[c.WINDOW=3]="WINDOW",c[c.RESOURCE=4]="RESOURCE",c[c.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",c[c.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const k=f.$Hn.as(S.$In.JSONContribution);class v{constructor(){this.h=new Set,this.i=new R.$Vd,this.onDidSchemaChange=this.i.event,this.j=new R.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:j.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(t,o=!0){this.registerConfigurations([t],o)}registerConfigurations(t,o=!0){const r=new Set;this.n(t,o,r),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const o=new Set;this.o(t,o),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:t,remove:o}){const r=new Set;this.o(o,r),this.n(t,!1,r),k.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const o=new Set;this.k(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(t,o){const r=[];for(const{overrides:i,source:n}of t)for(const a in i)if(o.add(a),e.$Wn.test(a)){const b=this.a.get(a),C=b?.valuesSources??new Map;if(n)for(const M of Object.keys(i[a]))C.set(M,n);const I={...b?.value||{},...i[a]};this.a.set(a,{source:n,value:I,valuesSources:C});const E=(0,D.$Ji)(a),A={type:"object",default:I,description:j.localize(1,null,E),$ref:e.$Tn,defaultDefaultValue:I,source:s.$If(n)?void 0:n,defaultValueSource:n};r.push(...w(a)),this.d[a]=A,this.b.properties[a]=A}else{this.a.set(a,{value:i[a],source:n});const b=this.d[a];b&&(this.w(a,b),this.r(a,b))}this.m(r)}deregisterDefaultConfigurations(t){const o=new Set;this.l(t,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(t,o){for(const{overrides:r,source:i}of t)for(const n in r){const a=this.a.get(n),b=s.$If(i)?i:i?.id,C=s.$If(a?.source)?a?.source:a?.source?.id;if(b===C)if(o.add(n),this.a.delete(n),e.$Wn.test(n))delete this.d[n],delete this.b.properties[n];else{const I=this.d[n];I&&(this.w(n,I),this.r(n,I))}}this.u()}deltaConfiguration(t){let o=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),o=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),o=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const o of t)this.h.add(o);this.u()}n(t,o,r){t.forEach(i=>{this.p(i,o,i.extensionInfo,i.restrictedProperties,void 0,r),this.c.push(i),this.q(i)})}o(t,o){const r=i=>{if(i.properties)for(const n in i.properties){o.add(n);const a=this.d[n];a?.policy?.name&&this.e.delete(a.policy.name),delete this.d[n],this.s(n,i.properties[n])}i.allOf?.forEach(n=>r(n))};for(const i of t){r(i);const n=this.c.indexOf(i);n!==-1&&this.c.splice(n,1)}}p(t,o=!0,r,i,n=3,a){n=s.$Rf(t.scope)?n:t.scope;const b=t.properties;if(b)for(const I in b){const E=b[I];if(o&&h(I,E)){delete b[I];continue}if(E.source=r,E.defaultDefaultValue=b[I].default,this.w(I,E),e.$Wn.test(I)?E.scope=void 0:(E.scope=s.$Rf(E.scope)?n:E.scope,E.restricted=s.$Rf(E.restricted)?!!i?.includes(I):E.restricted),b[I].hasOwnProperty("included")&&!b[I].included){this.f[I]=b[I],delete b[I];continue}else this.d[I]=b[I],b[I].policy?.name&&this.e.set(b[I].policy.name,I);!b[I].deprecationMessage&&b[I].markdownDeprecationMessage&&(b[I].deprecationMessage=b[I].markdownDeprecationMessage),a.add(I)}const C=t.allOf;if(C)for(const I of C)this.p(I,o,r,i,n,a)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const o=r=>{const i=r.properties;if(i)for(const a in i)this.r(a,i[a]);r.allOf?.forEach(o)};o(t)}r(t,o){switch(e.$Nn.properties[t]=o,o.scope){case 1:e.$On.properties[t]=o;break;case 2:e.$Pn.properties[t]=o;break;case 6:e.$Qn.properties[t]=o;break;case 3:e.$Rn.properties[t]=o;break;case 4:e.$Sn.properties[t]=o;break;case 5:e.$Sn.properties[t]=o,this.g.properties[t]=o;break}}s(t,o){switch(delete e.$Nn.properties[t],o.scope){case 1:delete e.$On.properties[t];break;case 2:delete e.$Pn.properties[t];break;case 6:delete e.$Qn.properties[t];break;case 3:delete e.$Rn.properties[t];break;case 4:case 5:delete e.$Sn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const o=`[${t}]`,r={type:"object",description:j.localize(2,null),errorMessage:j.localize(3,null),$ref:e.$Tn};this.w(o,r),e.$Nn.properties[o]=r,e.$On.properties[o]=r,e.$Pn.properties[o]=r,e.$Qn.properties[o]=r,e.$Rn.properties[o]=r,e.$Sn.properties[o]=r}}v(){const t={type:"object",description:j.localize(4,null),errorMessage:j.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=t,e.$On.patternProperties[e.$Vn]=t,e.$Pn.patternProperties[e.$Vn]=t,e.$Qn.patternProperties[e.$Vn]=t,e.$Rn.patternProperties[e.$Vn]=t,e.$Sn.patternProperties[e.$Vn]=t,this.i.fire()}w(t,o){const r=this.a.get(t);let i=r?.value,n=r?.source;s.$Pf(i)&&(i=o.defaultDefaultValue,n=void 0),s.$Pf(i)&&(i=$(o.type)),o.default=i,o.defaultValueSource=n}}const u="\\[([^\\]]+)\\]",y=new RegExp(u,"g");e.$Vn=`^(${u})+$`,e.$Wn=new RegExp(e.$Vn);function w(c){const t=[];if(e.$Wn.test(c)){let o=y.exec(c);for(;o?.length;){const r=o[1].trim();r&&t.push(r),o=y.exec(c)}}return(0,P.$Mb)(t)}e.$Xn=w;function g(c){return c.reduce((t,o)=>`${t}[${o}]`,"")}e.$Yn=g;function $(c){switch(Array.isArray(c)?c[0]:c){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=$;const d=new v;f.$Hn.add(e.$Mn.Configuration,d);function h(c,t){return c.trim()?e.$Wn.test(c)?j.localize(7,null,c):d.getConfigurationProperties()[c]!==void 0?j.localize(8,null,c):t.policy?.name&&d.getPolicyConfigurations().get(t.policy?.name)!==void 0?j.localize(9,null,c,t.policy?.name,d.getPolicyConfigurations().get(t.policy?.name)):null:j.localize(6,null)}e.$1n=h;function m(){const c=[],t=d.getConfigurationProperties();for(const o of Object.keys(t))c.push([o,t[o].scope]);return c.push(["launch",4]),c.push(["task",4]),c}e.$2n=m}),define(oe[120],ae([0,1,22,3,42,2,31,35,12,7,18,52,44]),function(X,e,P,R,s,j,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function u(o){return Object.isFrozen(o)?o:S.$wn(o)}class y{constructor(r={},i=[],n=[],a){this.b=r,this.c=i,this.d=n,this.raw=a,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(i=>{if(i instanceof y)return i;const n=new w("");return n.parseRaw(i),n.configurationModel});this.f=r.reduce((i,n)=>n===i?n:i.merge(n),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,p.$Hi)(this.contents,r):this.contents}inspect(r,i){const n=this.rawConfiguration.getValue(r),a=i?this.rawConfiguration.getOverrideValue(r,i):void 0,b=i?this.rawConfiguration.override(i).getValue(r):n;return{value:n,override:a,merged:b}}getOverrideValue(r,i){const n=this.i(i);return n?r?(0,p.$Hi)(n,r):n:void 0}getKeysForOverrideIdentifier(r){const i=[];for(const n of this.overrides)n.identifiers.includes(r)&&i.push(...n.keys);return P.$Mb(i)}getAllOverrideIdentifiers(){const r=[];for(const i of this.overrides)r.push(...i.identifiers);return P.$Mb(r)}override(r){let i=this.a.get(r);return i||(i=this.g(r),this.a.set(r,i)),i}merge(...r){const i=S.$vn(this.contents),n=S.$vn(this.overrides),a=[...this.keys],b=this.raw?.length?[...this.raw]:[this];for(const C of r)if(b.push(...C.raw?.length?C.raw:[C]),!C.isEmpty()){this.h(i,C.contents);for(const I of C.overrides){const[E]=n.filter(A=>P.$ub(A.identifiers,I.identifiers));E?(this.h(E.contents,I.contents),E.keys.push(...I.keys),E.keys=P.$Mb(E.keys)):n.push(S.$vn(I))}for(const I of C.keys)a.indexOf(I)===-1&&a.push(I)}return new y(i,a,n,b.every(C=>C instanceof y)?void 0:b)}g(r){const i=this.i(r);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const n={};for(const a of P.$Mb([...Object.keys(this.contents),...Object.keys(i)])){let b=this.contents[a];const C=i[a];C&&(typeof b=="object"&&typeof C=="object"?(b=S.$vn(b),this.h(b,C)):b=C),n[a]=b}return new y(n,this.keys,this.overrides)}h(r,i){for(const n of Object.keys(i)){if(n in r&&f.$Kf(r[n])&&f.$Kf(i[n])){this.h(r[n],i[n]);continue}r[n]=S.$vn(i[n])}}i(r){let i=null,n=null;const a=b=>{b&&(n?this.h(n,b):n=S.$vn(b))};for(const b of this.overrides)b.identifiers.length===1&&b.identifiers[0]===r?i=b.contents:b.identifiers.includes(r)&&a(b.contents);return a(i),n}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,i){this.j(r,i,!0)}setValue(r,i){this.j(r,i,!1)}removeValue(r){const i=this.keys.indexOf(r);i!==-1&&(this.keys.splice(i,1),(0,p.$Gi)(this.contents,r),k.$Wn.test(r)&&this.overrides.splice(this.overrides.findIndex(n=>P.$ub(n.identifiers,(0,k.$Xn)(r))),1))}j(r,i,n){(0,p.$Fi)(this.contents,r,i,a=>console.error(a)),n=n||this.keys.indexOf(r)===-1,n&&this.keys.push(r),k.$Wn.test(r)&&this.overrides.push({identifiers:(0,k.$Xn)(r),keys:Object.keys(this.contents[r]),contents:(0,p.$Ei)(this.contents[r],a=>console.error(a))})}}e.$3n=y;class w{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,i){if(!f.$Rf(r)){const n=this.g(r);this.parseRaw(n,i)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,i){this.a=r;const{contents:n,keys:a,overrides:b,restricted:C,hasExcludedProperties:I}=this.h(r,i);this.b=new y(n,a,b,I?[r]:void 0),this.c=C||[]}g(r){let i={},n=null,a=[];const b=[],C=[];function I(A){Array.isArray(a)?a.push(A):n!==null&&(a[n]=A)}const E={onObjectBegin:()=>{const A={};I(A),b.push(a),a=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{a=b.pop()},onArrayBegin:()=>{const A=[];I(A),b.push(a),a=A,n=null},onArrayEnd:()=>{a=b.pop()},onLiteralValue:I,onError:(A,M,T)=>{C.push({error:A,offset:M,length:T})}};if(r)try{s.$jn(r,E),i=a[0]||{}}catch(A){console.error(`Error while parsing settings file ${this.f}: ${A}`),this.d=[A]}return i}h(r,i){const n=v.$Hn.as(k.$Mn.Configuration).getConfigurationProperties(),a=this.i(r,n,!0,i);r=a.raw;const b=(0,p.$Ei)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),C=Object.keys(r),I=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:b,keys:C,overrides:I,restricted:a.restricted,hasExcludedProperties:a.hasExcludedProperties}}i(r,i,n,a){let b=!1;if(!a?.scopes&&!a?.skipRestricted&&!a?.exclude?.length)return{raw:r,restricted:[],hasExcludedProperties:b};const C={},I=[];for(const E in r)if(k.$Wn.test(E)&&n){const A=this.i(r[E],i,!1,a);C[E]=A.raw,b=b||A.hasExcludedProperties,I.push(...A.restricted)}else{const A=i[E],M=A?typeof A.scope<"u"?A.scope:3:void 0;A?.restricted&&I.push(E),!a.exclude?.includes(E)&&(a.include?.includes(E)||(M===void 0||a.scopes===void 0||a.scopes.includes(M))&&!(a.skipRestricted&&A?.restricted))?C[E]=r[E]:b=!0}return{raw:C,restricted:I,hasExcludedProperties:b}}j(r,i){const n=[];for(const a of Object.keys(r))if(k.$Wn.test(a)){const b={};for(const C in r[a])b[C]=r[a][C];n.push({identifiers:(0,k.$Xn)(a),keys:Object.keys(b),contents:(0,p.$Ei)(b,i)})}return n}}e.$4n=w;class g extends j.$Tc{constructor(r,i,n,a){super(),this.c=r,this.f=i,this.g=a,this.b=this.B(new R.$Vd),this.onDidChange=this.b.event,this.a=new w(this.c.toString()),this.B(this.g.watch(n.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(R.Event.any(R.Event.filter(this.g.onDidFilesChange,b=>b.contains(this.c)),R.Event.filter(this.g.onDidRunOperation,b=>(b.isOperation(0)||b.isOperation(3)||b.isOperation(1)||b.isOperation(4))&&n.isEqual(b.resource,r)))(()=>this.b.fire()))}async loadConfiguration(){try{const r=await this.g.readFile(this.c);return this.a.parse(r.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new y}}reparse(r){return r&&(this.f=r),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=g;class ${constructor(r,i,n,a,b,C,I,E,A,M,T,W,G){this.a=r,this.b=i,this.c=n,this.overrideIdentifiers=a,this.d=b,this.f=C,this.g=I,this.h=E,this.i=A,this.j=M,this.k=T,this.l=W,this.m=G}get value(){return u(this.c)}n(r,i,n){const a=r.inspect(i,n);return{get value(){return u(a.value)},get override(){return u(a.override)},get merged(){return u(a.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(r,i,n,a,b=new y,C=new y,I=new D.$Ac,E=new y,A=new D.$Ac){this.c=r,this.d=i,this.f=n,this.g=a,this.h=b,this.i=C,this.j=I,this.l=E,this.m=A,this.a=null,this.b=new D.$Ac,this.n=null}getValue(r,i,n){return this.p(r,i,n).getValue(r)}updateValue(r,i,n={}){let a;n.resource?(a=this.m.get(n.resource),a||(a=new y,this.m.set(n.resource,a))):a=this.l,i===void 0?a.removeValue(r):a.setValue(r,i),n.resource||(this.a=null)}inspect(r,i,n){const a=this.p(r,i,n),b=this.t(i.resource,n),C=i.resource?this.m.get(i.resource)||this.l:this.l,I=new Set;for(const E of a.overrides)for(const A of E.identifiers)a.getOverrideValue(r,A)!==void 0&&I.add(A);return new $(r,i,a.getValue(r),I.size?[...I]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,n?this.i:void 0,b||void 0,C)}keys(r){const i=this.t(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,i){this.j.set(r,i),this.b.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,i){const n=[];if(!i){const{added:a,updated:b,removed:C}=c(this.c,r);i=[...a,...b,...C]}for(const a of i)for(const b of(0,k.$Xn)(a)){const C=this.c.getKeysForOverrideIdentifier(b),I=r.getKeysForOverrideIdentifier(b),E=[...I.filter(A=>C.indexOf(A)===-1),...C.filter(A=>I.indexOf(A)===-1),...C.filter(A=>!S.$zn(this.c.override(b).getValue(A),r.override(b).getValue(A)))];n.push([b,E])}return this.updateDefaultConfiguration(r),{keys:i,overrides:n}}compareAndUpdatePolicyConfiguration(r){const{added:i,updated:n,removed:a}=c(this.d,r),b=[...i,...n,...a];return b.length&&this.updatePolicyConfiguration(r),{keys:b,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:i,updated:n,removed:a,overrides:b}=c(this.applicationConfiguration,r),C=[...i,...n,...a];return C.length&&this.updateApplicationConfiguration(r),{keys:C,overrides:b}}compareAndUpdateLocalUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:b}=c(this.localUserConfiguration,r),C=[...i,...n,...a];return C.length&&this.updateLocalUserConfiguration(r),{keys:C,overrides:b}}compareAndUpdateRemoteUserConfiguration(r){const{added:i,updated:n,removed:a,overrides:b}=c(this.remoteUserConfiguration,r),C=[...i,...n,...a];return C.length&&this.updateRemoteUserConfiguration(r),{keys:C,overrides:b}}compareAndUpdateWorkspaceConfiguration(r){const{added:i,updated:n,removed:a,overrides:b}=c(this.workspaceConfiguration,r),C=[...i,...n,...a];return C.length&&this.updateWorkspaceConfiguration(r),{keys:C,overrides:b}}compareAndUpdateFolderConfiguration(r,i){const n=this.folderConfigurations.get(r),{added:a,updated:b,removed:C,overrides:I}=c(n,i),E=[...a,...b,...C];return(E.length||!n)&&this.updateFolderConfiguration(r,i),{keys:E,overrides:I}}compareAndDeleteFolderConfiguration(r){const i=this.folderConfigurations.get(r);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:n,updated:a,removed:b,overrides:C}=c(i,void 0);return{keys:[...n,...a,...b],overrides:C}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(r,i,n){let a=this.q(i,n);return i.overrideIdentifier&&(a=a.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(a=a.merge(this.d)),a}q({resource:r},i){let n=this.r();if(i&&r){const a=i.getFolder(r);a&&(n=this.s(a.uri)||n);const b=this.m.get(r);b&&(n=n.merge(b))}return n}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(r){let i=this.b.get(r);if(!i){const n=this.r(),a=this.j.get(r);a?(i=n.merge(a),this.b.set(r,i)):i=n}return i}t(r,i){if(i&&r){const n=i.getFolder(r);if(n)return this.j.get(n.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,i)=>{const{contents:n,overrides:a,keys:b}=this.j.get(i);return r.push([i,{contents:n,overrides:a,keys:b}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(i=>r.add(i)),this.userConfiguration.keys.forEach(i=>r.add(i)),this.i.keys.forEach(i=>r.add(i)),this.j.forEach(i=>i.keys.forEach(n=>r.add(n))),[...r.values()]}u(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>r.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(n=>r.add(n))),[...r.values()]}v(r){const i=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.i.getKeysForOverrideIdentifier(r).forEach(n=>i.add(n)),this.j.forEach(n=>n.getKeysForOverrideIdentifier(r).forEach(a=>i.add(a))),[...i.values()]}static parse(r){const i=this.w(r.defaults),n=this.w(r.policy),a=this.w(r.application),b=this.w(r.user),C=this.w(r.workspace),I=r.folders.reduce((E,A)=>(E.set(l.URI.revive(A[0]),this.w(A[1])),E),new D.$Ac);return new d(i,n,a,b,new y,C,I,new y,new D.$Ac)}static w(r){return new y(r.contents,r.keys,r.overrides)}}e.$6n=d;function h(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const r=new Set,i=new Map;for(const a of o)a.keys.forEach(b=>r.add(b)),a.overrides.forEach(([b,C])=>{const I=(0,D.$xc)(i,b,new Set);C.forEach(E=>I.add(E))});const n=[];return i.forEach((a,b)=>n.push([b,[...a.values()]])),{keys:[...r.values()],overrides:n}}e.$7n=h;class m{constructor(r,i,n,a){this.change=r,this.f=i,this.g=n,this.h=a,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const b of r.keys)this.affectedKeys.add(b);for(const[,b]of r.overrides)for(const C of b)this.affectedKeys.add(C);this.d=this.a;for(const b of this.affectedKeys)this.d+=b+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(r,i){const n=this.a+r,a=this.d.indexOf(n);if(a<0)return!1;const b=a+n.length;if(b>=this.d.length)return!1;const C=this.d.charCodeAt(b);if(C!==this.b&&C!==this.c)return!1;if(i){const I=this.previousConfiguration?this.previousConfiguration.getValue(r,i,this.f?.workspace):void 0,E=this.g.getValue(r,i,this.h);return!S.$zn(I,E)}return!0}}e.$8n=m;function c(o,r){const{added:i,removed:n,updated:a}=t(r?.rawConfiguration,o?.rawConfiguration),b=[],C=o?.getAllOverrideIdentifiers()||[],I=r?.getAllOverrideIdentifiers()||[];if(r){const E=I.filter(A=>!C.includes(A));for(const A of E)b.push([A,r.getKeysForOverrideIdentifier(A)])}if(o){const E=C.filter(A=>!I.includes(A));for(const A of E)b.push([A,o.getKeysForOverrideIdentifier(A)])}if(r&&o){for(const E of C)if(I.includes(E)){const A=t({contents:o.getOverrideValue(void 0,E)||{},keys:o.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});b.push([E,[...A.added,...A.removed,...A.updated]])}}return{added:i,removed:n,updated:a,overrides:b}}function t(o,r){const i=o?r?o.keys.filter(b=>r.keys.indexOf(b)===-1):[...o.keys]:[],n=r?o?r.keys.filter(b=>o.keys.indexOf(b)===-1):[...r.keys]:[],a=[];if(o&&r){for(const b of r.keys)if(o.keys.indexOf(b)!==-1){const C=(0,p.$Hi)(r.contents,b),I=(0,p.$Hi)(o.contents,b);S.$zn(C,I)||a.push(b)}}return{added:i,removed:n,updated:a}}}),define(oe[237],ae([0,1,22,3,2,35,12,120,52,5,39,44]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=void 0;class v extends s.$Tc{constructor(){super(...arguments),this.a=this.B(new R.$Vd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$3n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(k.$Hn.as(f.$Mn.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:$})=>this.c(Array.from(g),$))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(g,$){this.h(g,k.$Hn.as(f.$Mn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}f(){return{}}g(){this.b=new S.$3n;const g=k.$Hn.as(f.$Mn.Configuration).getConfigurationProperties();this.h(Object.keys(g),g)}h(g,$){const d=this.f();for(const h of g){const m=d[h],c=$[h];m!==void 0?this.b.addValue(h,m):c?this.b.addValue(h,c.default):this.b.removeValue(h)}}}e.$9n=v;class u{constructor(){this.onDidChangeConfiguration=R.Event.None,this.configurationModel=new S.$3n}async initialize(){return this.configurationModel}}e.$0n=u;let y=class extends s.$Tc{get configurationModel(){return this.b}constructor(g,$,d){super(),this.c=g,this.f=$,this.g=d,this.a=this.B(new R.$Vd),this.onDidChangeConfiguration=this.a.event,this.b=new S.$3n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const $={},d=[],h=k.$Hn.as(f.$Mn.Configuration).getConfigurationProperties();for(const m of g){const c=h[m];if(!c){d.push(m);continue}if(c.policy){if(c.type!=="string"&&c.type!=="number"){this.g.warn(`Policy ${c.policy.name} has unsupported type ${c.type}`);continue}d.push(m),$[c.policy.name]={type:c.type}}}return(0,D.$Vf)($)||await this.f.updatePolicyDefinitions($),d}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const $=k.$Hn.as(f.$Mn.Configuration).getPolicyConfigurations(),d=(0,P.$Hb)(g.map(h=>$.get(h)));this.m(d,!0)}m(g,$){this.g.trace("PolicyConfiguration#update",g);const d=k.$Hn.as(f.$Mn.Configuration).getConfigurationProperties(),h=[],m=this.b.isEmpty();for(const c of g){const t=d[c]?.policy?.name;if(t){const o=this.f.getPolicyValue(t);(m?o!==void 0:!(0,j.$zn)(this.b.getValue(c),o))&&h.push([c,o])}else this.b.getValue(c)!==void 0&&h.push([c,void 0])}if(h.length){this.g.trace("PolicyConfiguration#changed",h);const c=this.b;this.b=new S.$3n;for(const t of c.keys)this.b.setValue(t,c.getValue(t));for(const[t,o]of h)o===void 0?this.b.removeValue(t):this.b.setValue(t,o);$&&this.a.fire(this.b)}}};e.$$n=y,e.$$n=y=ve([ne(1,p.$Jn),ne(2,l.$nj)],y)}),define(oe[238],ae([0,1,22,8,17,3,42,101,2,35,4,19,18,120,52,237,39]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=void 0;class $ extends f.$Tc{constructor(m,c,t,o){super(),this.m=m,this.h=this.B(new j.$Vd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new w.$9n),this.c=t instanceof g.$Ln?new w.$0n:this.B(new w.$$n(this.b,t,o)),this.f=this.B(new u.$5n(this.m,{},k.$yg,c)),this.a=new u.$6n(this.b.configurationModel,this.c.configurationModel,new u.$3n,new u.$3n),this.j=new d(m,c,this),this.g=this.B(new R.$fh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:i})=>this.r(r,i))),this.B(this.c.onDidChangeConfiguration(r=>this.s(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,c,t]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new u.$6n(m,c,new u.$3n,t)}getConfigurationData(){return this.a.toData()}getValue(m,c){const t=typeof m=="string"?m:void 0,o=(0,v.$Ai)(m)?m:(0,v.$Ai)(c)?c:{};return this.a.getValue(t,o,void 0)}async updateValue(m,c,t,o,r){const i=(0,v.$Bi)(t)?t:(0,v.$Ai)(t)?{resource:t.resource,overrideIdentifiers:t.overrideIdentifier?[t.overrideIdentifier]:void 0}:void 0,n=i?o:t;if(n!==void 0&&n!==3&&n!==2)throw new Error(`Unable to write ${m} to target ${n}.`);i?.overrideIdentifiers&&(i.overrideIdentifiers=(0,P.$Mb)(i.overrideIdentifiers),i.overrideIdentifiers=i.overrideIdentifiers.length?i.overrideIdentifiers:void 0);const a=this.inspect(m,{resource:i?.resource,overrideIdentifier:i?.overrideIdentifiers?i.overrideIdentifiers[0]:void 0});if(a.policyValue!==void 0)throw new Error(`Unable to write ${m} because it is configured in system policy.`);if((0,l.$zn)(c,a.defaultValue)&&(c=void 0),i?.overrideIdentifiers?.length&&i.overrideIdentifiers.length>1){const C=i.overrideIdentifiers.sort(),I=this.a.localUserConfiguration.overrides.find(E=>(0,P.$ub)([...E.identifiers].sort(),C));I&&(i.overrideIdentifiers=I.identifiers)}const b=i?.overrideIdentifiers?.length?[(0,y.$Yn)(i.overrideIdentifiers),m]:[m];await this.j.write(b,c),await this.reloadConfiguration()}inspect(m,c={}){return this.a.inspect(m,c,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.n(m)}n(m){const c=this.a.toData(),t=this.a.compareAndUpdateLocalUserConfiguration(m);this.t(t,c,2)}r(m,c){const t=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(m,c);this.t(o,t,7)}s(m){const c=this.a.toData(),t=this.a.compareAndUpdatePolicyConfiguration(m);this.t(t,c,7)}t(m,c,t){const o=new u.$8n(m,{data:c},this.a);o.source=t,this.h.fire(o)}}e.$_n=$;class d{constructor(m,c,t){this.b=m,this.c=c,this.d=t,this.a=new R.$ah}write(m,c){return this.a.queue(()=>this.e(m,c))}async e(m,c){let t;try{t=(await this.c.readFile(this.b)).value.toString()}catch(i){if(i.fileOperationResult===1)t="{}";else throw i}const o=[];if((0,D.$cn)(t,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const r=this.f(t,m,c);t=(0,S.$un)(t,r),await this.c.writeFile(this.b,s.$je.fromString(t))}f(m,c,t){const{tabSize:o,insertSpaces:r,eol:i}=this.h;if(!c.length){const n=JSON.stringify(t,null,r?" ".repeat(o):"	");return[{content:n,length:n.length,offset:0}]}return(0,S.$rn)(m,c,t,{tabSize:o,insertSpaces:r,eol:i})}get h(){if(!this.g){let m=p.OS===3||p.OS===2?`
`:`\r
`;const c=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});c&&typeof c=="string"&&c!=="auto"&&(m=c),this.g={eol:m,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(oe[239],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w_b=e.$v_b=e.$u_b=void 0,e.$u_b="request",e.$v_b="remoteResourceHandler";class P{async routeCall(s,j,D){if(j!==e.$u_b)throw new Error(`Call not found: ${j}`);const S=D[0];if(S?.authority){const f=s.connections.find(l=>l.ctx===S.authority);if(f)return f}throw new Error("Caller not found")}routeEvent(s,j){throw new Error(`Event not found: ${j}`)}}e.$w_b=P}),define(oe[240],ae([0,1,14,6]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,R.$6h)("remoteAuthorityResolverService");var s;(function(p){p[p.WebSocket=0]="WebSocket",p[p.Managed=1]="Managed"})(s||(e.RemoteConnectionType=s={}));class j{constructor(k){this.id=k,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=j;class D{constructor(k,v){this.host=k,this.port=v,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=D;var S;(function(p){p.Unknown="Unknown",p.NotAvailable="NotAvailable",p.TemporarilyNotAvailable="TemporarilyNotAvailable",p.NoResolverFound="NoResolverFound",p.InvalidAuthority="InvalidAuthority"})(S||(e.RemoteAuthorityResolverErrorCode=S={}));class f extends P.$bb{static isNotAvailable(k){return k instanceof f&&k._code===S.NotAvailable}static isTemporarilyNotAvailable(k){return k instanceof f&&k._code===S.TemporarilyNotAvailable}static isNoResolverFound(k){return k instanceof f&&k._code===S.NoResolverFound}static isInvalidAuthority(k){return k instanceof f&&k._code===S.InvalidAuthority}static isHandled(k){return k instanceof f&&k.isHandled}constructor(k,v=S.Unknown,u){super(k),this._message=k,this._code=v,this._detail=u,this.isHandled=v===S.NotAvailable&&u===!0,Object.setPrototypeOf(this,f.prototype)}}e.$$k=f;function l(p){const k=p.indexOf("+");return k===-1?p:p.substring(0,k)}e.$_k=l}),define(oe[59],ae([0,1,13]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function R(l){return l.scheme===P.Schemas.vscodeRemote?l.authority:void 0}e.$al=R;function s(l){if(!l)return;const p=l.indexOf("+");return p<0?l:l.substr(0,p)}e.$bl=s;function j(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.$cl=j;function D(l){const{host:p,port:k}=f(l);if(typeof k>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:p,port:k}}e.$dl=D;function S(l,p){let{host:k,port:v}=f(l);return typeof v>"u"&&(v=p),{host:k,port:v}}e.$el=S;function f(l){const p=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const k=l.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(oe[121],ae([0,1,25,6,59]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function j(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.$jm=j,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var D;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(D||(e.ExtensionType=D={}));var S;(function(w){w.WIN32_X64="win32-x64",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(S||(e.TargetPlatform=S={}));class f{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,$){if(typeof g>"u"||g===null)return typeof $>"u"||$===null;if(typeof $>"u"||$===null)return!1;if(typeof g=="string"||typeof $=="string"){const d=typeof g=="string"?g:g.value,h=typeof $=="string"?$:$.value;return P.$_e(d,h)}return g._lower===$._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$lm=f;class l{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const $ of g)this.add($)}add(g){this.c.add(f.toKey(g))}delete(g){return this.c.delete(f.toKey(g))}has(g){return this.c.has(f.toKey(g))}}e.$mm=l;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(f.toKey(g))}get(g){return this.c.get(f.toKey(g))}has(g){return this.c.has(f.toKey(g))}set(g,$){this.c.set(f.toKey(g),$)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=p;function k(w){return v(w)}e.$om=k;function v(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.$pm=v;function u(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.$qm=u;function y(w,g){if(g){const $=`onResolveRemoteAuthority:${(0,s.$bl)(g)}`;return!!w.activationEvents?.includes($)}return!1}e.$rm=y,e.$sm=(0,R.$6h)("IBuiltinExtensionsScannerService")}),define(oe[241],ae([0,1,8,17,23,14,3,2,68,73,32,110,240,59]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.PersistentConnectionEventType=e.$ll=e.$kl=e.$jl=e.ConnectionType=void 0;const y=30*1e3;var w;(function(K){K[K.Management=1]="Management",K[K.ExtensionHost=2]="ExtensionHost",K[K.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function g(K){switch(K){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function $(K){const O=new s.$6d;return setTimeout(()=>O.cancel(),K),O.token}function d(K,O){if(K.isCancellationRequested||O.isCancellationRequested)return s.CancellationToken.Cancelled;const F=new s.$6d;return K.onCancellationRequested(()=>F.cancel()),O.onCancellationRequested(()=>F.cancel()),F.token}class h{get didTimeout(){return this.c==="timedout"}constructor(O){this.c="pending",this.d=new S.$Sc,this.promise=new Promise((F,_)=>{this.f=F,this.g=_}),O.isCancellationRequested?this.h():this.d.add(O.onCancellationRequested(()=>this.h()))}registerDisposable(O){this.c==="pending"?this.d.add(O):O.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const O=new Error("Time limit reached");return O.code="ETIMEDOUT",O.syscall="connect",O}resolve(O){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(O))}reject(O){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(O))}}function m(K,O){const F=new h(O);return F.registerDisposable(K.onControlMessage(_=>{const z=JSON.parse(_.toString()),x=L(z);x?F.reject(x):F.resolve(z)})),F.promise}function c(K,O,F,_,z,x,N,B){const Q=new h(B),se=l.$Rd.create(!1);return K.info(`Creating a socket (${N})...`),f.mark(`code/willCreateSocket/${x}`),O.connect(F,_,z,N).then(le=>{Q.didTimeout?(f.mark(`code/didCreateSocketError/${x}`),K.info(`Creating a socket (${N}) finished after ${se.elapsed()} ms, but this is too late and has timed out already.`),le?.dispose()):(f.mark(`code/didCreateSocketOK/${x}`),K.info(`Creating a socket (${N}) was successful after ${se.elapsed()} ms.`),Q.resolve(le))},le=>{f.mark(`code/didCreateSocketError/${x}`),K.info(`Creating a socket (${N}) returned an error after ${se.elapsed()} ms.`),K.error(le),Q.reject(le)}),Q.promise}function t(K,O){const F=new h(O);return K.then(_=>{F.didTimeout||F.resolve(_)},_=>{F.didTimeout||F.reject(_)}),F.promise}async function o(K,O,F,_){const z=ee(K,O);K.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let x;try{x=await c(K.logService,K.remoteSocketFactoryService,K.connectTo,(0,u.$cl)(K),`reconnectionToken=${K.reconnectionToken}&reconnection=${K.reconnectionProtocol?"true":"false"}`,g(O),`renderer-${g(O)}-${K.reconnectionToken}`,_)}catch(le){throw K.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),K.logService.error(le),le}K.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let N,B;K.reconnectionProtocol?(K.reconnectionProtocol.beginAcceptReconnection(x,null),N=K.reconnectionProtocol,B=!1):(N=new k.$Th({socket:x}),B=!0),K.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const Q=await t(K.signService.createNewMessage((0,p.$qg)()),_),se={type:"auth",auth:K.connectionToken||"00000000000000000000",data:Q.data};N.sendControl(R.$je.fromString(JSON.stringify(se)));try{const le=await m(N,d(_,$(1e4)));if(le.type!=="sign"||typeof le.data!="string"){const Ae=new Error("Unexpected handshake message");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}if(K.logService.trace(`${z} 4/6. received SignRequest control message.`),!await t(K.signService.validate(Q,le.signedData),_)){const Ae=new Error("Refused to connect to unsupported server");throw Ae.code="VSCODE_CONNECTION_ERROR",Ae}const be=await t(K.signService.sign(le.data),_),Se={type:"connectionType",commit:K.commit,signedData:be,desiredConnectionType:O};return F&&(Se.args=F),K.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(R.$je.fromString(JSON.stringify(Se))),{protocol:N,ownsProtocol:B}}catch(le){throw le&&le.code==="ETIMEDOUT"&&(K.logService.error(`${z} the handshake timed out. Error:`),K.logService.error(le)),le&&le.code==="VSCODE_CONNECTION_ERROR"&&(K.logService.error(`${z} received error control message when negotiating connection. Error:`),K.logService.error(le)),B&&V(N),le}}async function r(K,O,F,_){const z=Date.now(),x=ee(K,O),{protocol:N,ownsProtocol:B}=await o(K,O,F,_),Q=new h(_);return Q.registerDisposable(N.onControlMessage(se=>{const le=JSON.parse(se.toString()),ge=L(le);ge?(K.logService.error(`${x} received error control message when negotiating connection. Error:`),K.logService.error(ge),B&&V(N),Q.reject(ge)):(K.reconnectionProtocol?.endAcceptReconnection(),K.logService.trace(`${x} 6/6. handshake finished, connection is up and running after ${he(z)}!`),Q.resolve({protocol:N,firstMessage:le}))})),Q.promise}async function i(K,O){const{protocol:F}=await r(K,1,void 0,O);return{protocol:F}}async function n(K,O,F){const{protocol:_,firstMessage:z}=await r(K,2,O,F),x=z&&z.debugPort;return{protocol:_,debugPort:x}}async function a(K,O,F){const _=Date.now(),z=ee(K,3),{protocol:x}=await o(K,3,O,F);return K.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${he(_)}!`),x}async function b(K,O,F){const{connectTo:_,connectionToken:z}=await K.addressProvider.getAddress();return{commit:K.commit,quality:K.quality,connectTo:_,connectionToken:z,reconnectionToken:O,reconnectionProtocol:F,remoteSocketFactoryService:K.remoteSocketFactoryService,signService:K.signService,logService:K.logService}}async function C(K,O,F){return E(K,async _=>{const{protocol:z}=await i(_,s.CancellationToken.None);return new Z(K,O,F,_.reconnectionToken,z)})}e.$jl=C;async function I(K,O){return E(K,async F=>{const{protocol:_,debugPort:z}=await n(F,O,s.CancellationToken.None);return new Y(K,O,F.reconnectionToken,_,z)})}e.$kl=I;async function E(K,O){for(let _=1;;_++)try{const z=(0,p.$qg)(),x=await b(K,z,null);return await O(x)}catch(z){if(_<5)K.logService.error(`[remote-connection][attempt ${_}] An error occurred in initial connection! Will retry... Error:`),K.logService.error(z);else throw K.logService.error(`[remote-connection][attempt ${_}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),K.logService.error(z),ue.triggerPermanentFailure(0,0,v.$$k.isHandled(z)),z}}async function A(K,O,F){const _=await b(K,(0,p.$qg)(),null);return await a(_,{host:O,port:F},s.CancellationToken.None)}e.$ll=A;function M(K){return(0,P.$Tg)(O=>new Promise((F,_)=>{const z=setTimeout(F,K*1e3);O.onCancellationRequested(()=>{clearTimeout(z),F()})}))}var T;(function(K){K[K.ConnectionLost=0]="ConnectionLost",K[K.ReconnectionWait=1]="ReconnectionWait",K[K.ReconnectionRunning=2]="ReconnectionRunning",K[K.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",K[K.ConnectionGain=4]="ConnectionGain"})(T||(e.PersistentConnectionEventType=T={}));class W{constructor(O,F){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.type=0}}e.$ml=W;class G{constructor(O,F,_,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.durationSeconds=_,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$nl=G;class J{constructor(O,F,_){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=_,this.type=2}}e.$ol=J;class ce{constructor(O,F,_){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=_,this.type=4}}e.$pl=ce;class re{constructor(O,F,_,z){this.reconnectionToken=O,this.millisSinceLastIncomingData=F,this.attempt=_,this.handled=z,this.type=3}}e.$ql=re;class ue extends S.$Tc{static triggerPermanentFailure(O,F,_){this._permanentFailure=!0,this.f=O,this.g=F,this.h=_,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(O=>O.y())}static debugPauseSocketWriting(){this.j.forEach(O=>O.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||ue._permanentFailure}constructor(O,F,_,z,x){super(),this.t=O,this.u=F,this.reconnectionToken=_,this.protocol=z,this.w=x,this.m=this.B(new D.$Vd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new ce(this.reconnectionToken,0,0)),this.B(z.onSocketClose(N=>{const B=q(this.t,this.reconnectionToken,!0);N?N.type===0?(this.u.logService.info(`${B} received socket close event (hadError: ${N.hadError}).`),N.error&&this.u.logService.error(N.error)):(this.u.logService.info(`${B} received socket close event (wasClean: ${N.wasClean}, code: ${N.code}, reason: ${N.reason}).`),N.event&&this.u.logService.error(N.event)):this.u.logService.info(`${B} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(N=>{const B=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${B} received socket timeout event (unacknowledgedMsgCount: ${N.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${N.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${N.timeSinceLastReceivedSomeData}).`),this.y()})),ue.j.push(this),this.B((0,S.$Rc)(()=>{const N=ue.j.indexOf(this);N>=0&&ue.j.splice(N,1)})),this.n&&this.D(ue.f,ue.g,ue.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const O=q(this.t,this.reconnectionToken,!0);this.u.logService.info(`${O} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let _=-1;do{_++;const z=_<F.length?F[_]:F[F.length-1];try{if(z>0){const N=M(z);this.m.fire(new G(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,N)),this.u.logService.info(`${O} waiting for ${z} seconds before reconnecting...`);try{await N}catch{}}if(this.n){this.u.logService.error(`${O} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new J(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1)),this.u.logService.info(`${O} resolving connection...`);const x=await b(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${O} connecting to ${x.connectTo}...`),await this.G(x,$(y)),this.u.logService.info(`${O} reconnected!`),this.m.fire(new ce(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),_+1));break}catch(x){if(x.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${O} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(_>360){this.u.logService.error(`${O} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}if(v.$$k.isTemporarilyNotAvailable(x)){this.u.logService.info(`${O} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if((x.code==="ETIMEDOUT"||x.code==="ENETUNREACH"||x.code==="ECONNREFUSED"||x.code==="ECONNRESET")&&x.syscall==="connect"){this.u.logService.info(`${O} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if((0,j.$4)(x)){this.u.logService.info(`${O} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(x);continue}if(x instanceof v.$$k){this.u.logService.error(`${O} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,v.$$k.isHandled(x));break}this.u.logService.error(`${O} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(x),this.C(this.protocol.getMillisSinceLastIncomingData(),_+1,!1);break}}while(!this.n&&!this.s)}C(O,F,_){this.w?ue.triggerPermanentFailure(O,F,_):this.D(O,F,_)}D(O,F,_){this.m.fire(new re(this.reconnectionToken,O,F,_)),V(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$rl=ue;class Z extends ue{constructor(O,F,_,z,x){super(1,O,z,x,!0),this.client=this.B(new k.$Rh(x,{remoteAuthority:F,clientId:_},O.ipcLogger))}async G(O,F){await i(O,F)}}e.$sl=Z;class Y extends ue{constructor(O,F,_,z,x){super(2,O,_,z,!1),this.H=F,this.debugPort=x}async G(O,F){await n(O,this.H,F)}}e.$tl=Y;function V(K){try{K.acceptDisconnect();const O=K.getSocket();K.dispose(),O.dispose()}catch(O){(0,j.$1)(O)}}function L(K){if(K&&K.type==="error"){const O=new Error(`Connection error: ${K.reason}`);return O.code="VSCODE_CONNECTION_ERROR",O}return null}function U(K,O){for(;K.length<O;)K+=" ";return K}function H(K,O){return`[remote-connection][${U(g(K),13)}][${O.substr(0,5)}\u2026]`}function q(K,O,F){return`${H(K,O)}[${F?"reconnect":"initial"}]`}function ee(K,O){return`${q(O,K.reconnectionToken,!!K.reconnectionProtocol)}[${K.connectTo}]`}function he(K){return`${Date.now()-K} ms`}}),define(oe[242],ae([0,1,2,6]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=void 0,e.$fl=(0,R.$6h)("remoteSocketFactoryService");class s{constructor(){this.a={}}register(D,S){return this.a[D]??=[],this.a[D].push(S),(0,P.$Rc)(()=>{const f=this.a[D]?.indexOf(S);typeof f=="number"&&f>=0&&this.a[D]?.splice(f,1)})}b(D){return(this.a[D.type]||[]).find(f=>f.supports(D))}connect(D,S,f,l){const p=this.b(D);if(!p)throw new Error(`No socket factory found for ${D}`);return p.connect(D,S,f,l)}}e.$gl=s}),define(oe[243],ae([0,1,26,48,21,114]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x$b=void 0;let D;async function S(u=!1){return(D===void 0||u)&&(D=f()),D}e.$x$b=S;async function f(){const u=l();if(u===void 0)return!1;if(u>=22e3){const y=k();if(y)return new Promise(w=>{R.execFile(y,["--status"],g=>w(!g))})}else{const y=v();if(y)try{if((await s.Promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const u=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());if(u)return parseInt(u[3])}function p(u){const y=process.env.SystemRoot;if(y){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return j.join(y,w?"Sysnative":"System32",u)}}function k(){return p("wsl.exe")}function v(){return p("lxss\\LxssManager.dll")}}),define(oe[53],ae([0,1,17,14,2,183,52,6,5,44]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=void 0,e.$hp=(0,S.$6h)("requestService");class p{constructor(c){this.b=c}toJSON(){if(!this.a){const c=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?c[t]="*****":c[t]=this.b[t];this.a=c}return this.a}}class k extends s.$Tc{constructor(c){super(),this.b=0,this.a=c.createLogger("network",{name:(0,j.localize)(0,null),when:f.$Ej.isEqualTo((0,f.$Cj)(f.LogLevel.Trace)).serialize()})}async c(c,t,o){const r=`${c} #${++this.b}: ${t.url}`;this.a.trace(`${r} - begin`,t.type,new p(t.headers??{}));try{const i=await o();return this.a.trace(`${r} - end`,t.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${r} - error`,t.type,(0,R.$0)(i)),i}}}e.$ip=k;function v(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}e.$jp=v;function u(m){return m.res.statusCode===204}e.$kp=u;async function y(m){return u(m)?null:(await(0,P.$ve)(m.stream)).toString()}e.$lp=y;async function w(m){if(!v(m))throw new Error("Server returned "+m.res.statusCode);return y(m)}e.$mp=w;async function g(m){if(!v(m))throw new Error("Server returned "+m.res.statusCode);if(u(m))return null;const t=(await(0,P.$ve)(m.stream)).toString();try{return JSON.parse(t)}catch(o){throw o.message+=`:
`+t,o}}e.$np=g;function $(m){h(m)}e.$op=$;let d;function h(m){const c=l.$Hn.as(D.$Mn.Configuration),t=d;d={id:"http",order:15,title:(0,j.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,j.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,j.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,j.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,j.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,j.localize)(6,null),(0,j.localize)(7,null),(0,j.localize)(8,null),(0,j.localize)(9,null)],default:"override",description:(0,j.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,j.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,j.localize)(12,null),restricted:!0}}},c.updateConfigurations({add:[d],remove:t?[t]:[]})}h(1)}),define(oe[244],ae([0,1,17,23]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0;class s{constructor(S){this.a=S}listen(S,f){throw new Error("Invalid listen")}call(S,f,l,p=R.CancellationToken.None){switch(f){case"request":return this.a.request(l[0],p).then(async({res:k,stream:v})=>{const u=await(0,P.$ve)(v);return[{statusCode:k.statusCode,headers:k.headers},u]});case"resolveProxy":return this.a.resolveProxy(l[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$kr=s;class j{constructor(S){this.a=S}async request(S,f){const[l,p]=await this.a.call("request",[S],f);return{res:l,stream:(0,P.$xe)(p)}}async resolveProxy(S){return this.a.call("resolveProxy",[S])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$lr=j}),define(oe[245],ae([0,1,246,12]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;function s(D,S){return D.protocol==="http:"?S.HTTP_PROXY||S.http_proxy||null:D.protocol==="https:"&&(S.HTTPS_PROXY||S.https_proxy||S.HTTP_PROXY||S.http_proxy)||null}async function j(D,S,f={}){const l=(0,P.parse)(D),p=f.proxyUrl||s(l,S);if(!p)return null;const k=(0,P.parse)(p);if(!/^https?:$/.test(k.protocol||""))return null;const v={host:k.hostname||"",port:(k.port?+k.port:0)||(k.protocol==="https"?443:80),auth:k.auth,rejectUnauthorized:(0,R.$Of)(f.strictSSL)?f.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((u,y)=>{X(["http-proxy-agent"],u,y)})).HttpProxyAgent(p,v):new(await new Promise((u,y)=>{X(["https-proxy-agent"],u,y)})).HttpsProxyAgent(p,v)}e.$mr=j}),define(oe[247],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=e.$R$b=e.$Q$b=void 0,e.$Q$b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$R$b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$S$b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(oe[94],ae([0,1,48,9,184,23,51,14,4,32,109,64,8,140]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=void 0;let y;async function w($,d,h,m){return h["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):f.$i?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,k.$6l)(m)&&!h["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,k.$6l)(m)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=v.Promises.withAsyncBody(async(c,t)=>{const o=new j.$6d;let r=1e4;const i=$.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(r=(0,u.$7l)(i,1,120)*1e3);const n=setTimeout(()=>{o.dispose(!0),t(new Error((0,s.localize)(0,null)))},r);try{c(await g(d,o.token))}catch(a){!(0,S.$4)(a)&&!o.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,D.$Qi)(a)))):c({})}finally{clearTimeout(n),o.dispose()}})),y)}e.$_l=w;async function g($,d){const h=process.env.ELECTRON_RUN_AS_NODE;$.trace("getUnixShellEnvironment#runAsNode",h);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;$.trace("getUnixShellEnvironment#noAttach",m);const c=(0,l.$qg)().replace(/-/g,"").substr(0,12),t=new RegExp(c+"({.*})"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};$.trace("getUnixShellEnvironment#env",o);const r=await(0,p.$Vl)(f.OS,o);return $.trace("getUnixShellEnvironment#shell",r),new Promise((i,n)=>{if(d.isCancellationRequested)return n(new S.$5);const a=(0,R.$nc)(r);let b,C;const I="";/^pwsh(-preview)?$/.test(a)?(b=`& '${process.execPath}' ${I} -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,C=["-Login","-Command"]):a==="nu"?(b=`^'${process.execPath}' ${I} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,C=["-i","-l","-c"]):a==="xonsh"?(b=`import os, json; print("${c}", json.dumps(dict(os.environ)), "${c}")`,C=["-i","-l","-c"]):(b=`'${process.execPath}' ${I} -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,a==="tcsh"||a==="csh"?C=["-ic"]:C=["-i","-l","-c"]),$.trace("getUnixShellEnvironment#spawn",JSON.stringify(C),b);const E=(0,P.spawn)(r,[...C,b],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});d.onCancellationRequested(()=>(E.kill(),n(new S.$5))),E.on("error",T=>{$.error("getUnixShellEnvironment#errorChildProcess",(0,D.$Qi)(T)),n(T)});const A=[];E.stdout.on("data",T=>A.push(T));const M=[];E.stderr.on("data",T=>M.push(T)),E.on("close",(T,W)=>{const G=Buffer.concat(A).toString("utf8");$.trace("getUnixShellEnvironment#raw",G);const J=Buffer.concat(M).toString("utf8");if(J.trim()&&$.trace("getUnixShellEnvironment#stderr",J),T||W)return n(new Error((0,s.localize)(2,null,T,W)));const ce=t.exec(G),re=ce?ce[1]:"{}";try{const ue=JSON.parse(re);h?ue.ELECTRON_RUN_AS_NODE=h:delete ue.ELECTRON_RUN_AS_NODE,m?ue.ELECTRON_NO_ATTACH_CONSOLE=m:delete ue.ELECTRON_NO_ATTACH_CONSOLE,delete ue.VSCODE_RESOLVING_ENVIRONMENT,delete ue.XDG_RUNTIME_DIR,$.trace("getUnixShellEnvironment#result",ue),i(ue)}catch(ue){$.error("getUnixShellEnvironment#errorCaught",(0,D.$Qi)(ue)),n(ue)}})})}}),define(oe[248],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;class P{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(s){try{const j=await this.c();if(j){const D=String(P.a++);return this.b.set(D,j),{id:D,data:j.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,j){if(!s.id)return!0;const D=this.b.get(s.id);if(!D)return!1;this.b.delete(s.id);try{return D.validate(j)==="ok"}catch{return!1}finally{D.dispose?.()}}async sign(s){try{return await this.d(s)}catch{}return s}}e.$L7b=P}),define(oe[95],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl="signService",e.$il=(0,P.$6h)(e.$hl)}),define(oe[249],ae([0,1,248]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=void 0;class R extends P.$L7b{c(){return this.h().then(j=>new j.validator)}d(j){return this.h().then(D=>new D.signer().sign(j))}h(){return new Promise((j,D)=>X(["vsda"],j,D))}}e.$G_b=R}),define(oe[34],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=void 0,e.$tO=(0,P.$6h)("stateReadService"),e.$uO=(0,P.$6h)("stateService")}),define(oe[122],ae([0,1,8,17,2,12,38,16,5]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xO=e.$wO=e.$vO=e.SaveStrategy=void 0;var l;(function(u){u[u.IMMEDIATE=0]="IMMEDIATE",u[u.DELAYED=1]="DELAYED"})(l||(e.SaveStrategy=l={}));class p extends s.$Tc{constructor(y,w,g,$){super(),this.h=y,this.j=w,this.m=g,this.n=$,this.a=Object.create(null),this.b="",this.c=this.B(new P.$4g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(y){y.fileOperationResult!==1&&this.m.error(y)}}getItem(y,w){const g=this.a[y];return(0,j.$Rf)(g)?w:g}setItem(y,w){this.setItems([{key:y,data:w}])}setItems(y){let w=!1;for(const{key:g,data:$}of y)this.a[g]!==$&&((0,j.$Rf)($)?(0,j.$Pf)(this.a[g])||(this.a[g]=void 0,w=!0):(this.a[g]=$,w=!0));w&&this.s()}removeItem(y){(0,j.$Pf)(this.a[y])||(this.a[y]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const y=JSON.stringify(this.a,null,4);if(y!==this.b)try{await this.n.writeFile(this.h,R.$je.fromString(y),{atomic:{postfix:".vsctmp"}}),this.b=y}catch(w){this.m.error(w)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$vO=p;let k=class extends s.$Tc{constructor(y,w,g,$){super(),this.a=this.B(new p(w.stateResource,y,g,$))}async init(){await this.a.init()}getItem(y,w){return this.a.getItem(y,w)}};e.$wO=k,e.$wO=k=ve([ne(1,D.$ai),ne(2,f.$nj),ne(3,S.$qk)],k);class v extends k{setItem(y,w){this.a.setItem(y,w)}setItems(y){this.a.setItems(y)}removeItem(y){this.a.removeItem(y)}close(){return this.a.close()}}e.$xO=v}),define(oe[123],ae([0,1,4,36,32]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function j(f){if(P.$u===2&&/^penguin(\.|$)/i.test(f))return"chromebook"}function D(f,l,p,k,v,u,y,w,g){const $=Object.create(null);$["common.machineId"]=u,$["common.sqmId"]=y,$.sessionID=(0,s.$qg)()+Date.now(),$.commitHash=k,$.version=v,$["common.platformVersion"]=(f||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),$["common.platform"]=(0,P.$h)(P.$u),$["common.nodePlatform"]=R.$dc,$["common.nodeArch"]=p,$["common.product"]=g||"desktop",w&&($["common.msftInternal"]=w);let d=0;const h=Date.now();Object.defineProperties($,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),P.$l&&($["common.snap"]="true");const m=j(l);return m&&($["common.platformDetail"]=m),$}e.$Jo=D;function S(f){const l=R.env.USERDNSDOMAIN;if(!l)return!1;const p=l.toLowerCase();return f.some(k=>p===k)}e.$Ko=S}),define(oe[28],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,P.$6h)("telemetryService"),e.$vl=(0,P.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var R;(function(j){j[j.NONE=0]="NONE",j[j.CRASH=1]="CRASH",j[j.ERROR=2]="ERROR",j[j.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var s;(function(j){j.OFF="off",j.CRASH="crash",j.ERROR="error",j.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(oe[250],ae([0,1,26,8,42,13,9,4,7,88,21,108,91,16,27,28]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=e.$7r=e.$6r=void 0;const g=new Map;async function $(t,o){const r=`${t}::${o.join(":")}`,i=g.get(r);if(i)return i;const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,b=new Map,C=2e4;function I(A,M,T,W){const G=M.substring(A.length+1);return R.Promises.withAsyncBody(async J=>{let ce;try{ce=await p.Promises.readdir(M,{withFileTypes:!0})}catch{J();return}if(W.count>=C){W.count+=ce.length,W.maxReached=!0,J();return}let re=ce.length;if(re===0){J();return}let ue=ce;W.count+ce.length>C&&(W.maxReached=!0,re=C-W.count,ue=ce.slice(0,re)),W.count+=ce.length;for(const Z of ue)if(Z.isDirectory()){if(T.includes(Z.name)||await I(A,(0,D.$jc)(M,Z.name),T,W),--re===0){J();return}}else{const Y=Z.name.lastIndexOf(".");if(Y>=0){const V=Z.name.substring(Y+1);V&&a.set(V,(a.get(V)??0)+1)}for(const V of n)V.relativePathPattern?.test(G)!==!1&&V.filePattern.test(Z.name)&&b.set(V.tag,(b.get(V.tag)??0)+1);if(--re===0){J();return}}})}const E=R.Promises.withAsyncBody(async A=>{const M={count:0,maxReached:!1};await I(t,t,o,M);const T=await m(t);A({configFiles:d(b),fileTypes:d(a),fileCount:M.count,maxFilesReached:M.maxReached,launchConfigFiles:T})});return g.set(r,E),E}e.$6r=$;function d(t){return Array.from(t.entries(),([o,r])=>({name:o,count:r})).sort((o,r)=>r.count-o.count)}function h(){const t={os:`${P.type()} ${P.arch()} ${P.release()}`,memory:`${(P.totalmem()/u.$Yk.GB).toFixed(2)}GB (${(P.freemem()/u.$Yk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.$0m.value()*100)}%`},o=P.cpus();return o&&o.length>0&&(t.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),t}e.$7r=h;async function m(t){try{const o=new Map,r=(0,D.$jc)(t,".vscode","launch.json"),i=await p.Promises.readFile(r),n=[],a=(0,s.$cn)(i.toString(),n);if(n.length)return console.log(`Unable to parse ${r}`),[];if((0,s.$ln)(a)==="object"&&a.configurations)for(const b of a.configurations){const C=b.type;C&&(o.has(C)?o.set(C,o.get(C)+1):o.set(C,1))}return d(o)}catch{return[]}}e.$8r=m;let c=class{constructor(o,r){this.c=o,this.d=r}f(o){const r=[];return r.push(`OS Version:       ${o.os}`),r.push(`CPUs:             ${o.cpus}`),r.push(`Memory (System):  ${o.memory}`),r.push(`VM:               ${o.vmHint}`),r.join(`
`)}g(o){const r=[];r.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),r.push(`OS Version:       ${P.type()} ${P.arch()} ${P.release()}`);const i=P.cpus();return i&&i.length>0&&r.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),r.push(`Memory (System):  ${(P.totalmem()/u.$Yk.GB).toFixed(2)}GB (${(P.freemem()/u.$Yk.GB).toFixed(2)}GB free)`),S.$i||r.push(`Load (avg):       ${P.loadavg().map(n=>Math.round(n)).join(", ")}`),r.push(`VM:               ${Math.round(l.$0m.value()*100)}%`),r.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),r.push(`Process Argv:     ${o.mainArguments.join(" ")}`),r.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),r.join(`
`)}async getPerformanceInfo(o,r){return Promise.all([(0,k.$5r)(o.mainPID),this.k(o)]).then(async i=>{let[n,a]=i,b=this.m(o,n);return r.forEach(C=>{if((0,v.$Jm)(C))b+=`
${C.errorMessage}`,a+=`
${C.errorMessage}`;else if(b+=`

Remote: ${C.hostName}`,C.processes&&(b+=`
${this.m(o,C.processes)}`),C.workspaceMetadata){a+=`
|  Remote: ${C.hostName}`;for(const I of Object.keys(C.workspaceMetadata)){const E=C.workspaceMetadata[I];let A=`${E.fileCount} files`;E.maxFilesReached&&(A=`more than ${A}`),a+=`|    Folder (${I}): ${A}`,a+=this.h(E)}}}),{processInfo:b,workspaceInfo:a}})}async getSystemInfo(o,r){const{memory:i,vmHint:n,os:a,cpus:b}=h(),C={os:a,memory:i,cpus:b,vmHint:n,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:r};return S.$i||(C.load=`${P.loadavg().map(I=>Math.round(I)).join(", ")}`),S.$k&&(C.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(C)}async getDiagnostics(o,r){const i=[];return(0,k.$5r)(o.mainPID).then(async n=>(i.push(""),i.push(this.g(o)),i.push(""),i.push(this.m(o,n)),o.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(o))),r.forEach(a=>{if((0,v.$Jm)(a))i.push(`
${a.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${a.hostName}`),i.push(this.f(a.machineInfo)),a.processes&&i.push(this.m(o,a.processes)),a.workspaceMetadata)for(const b of Object.keys(a.workspaceMetadata)){const C=a.workspaceMetadata[b];let I=`${C.fileCount} files`;C.maxFilesReached&&(I=`more than ${I}`),i.push(`Folder (${b}): ${I}`),i.push(this.h(C))}}),i.push(""),i.push(""),i.join(`
`)))}h(o){const r=[];let n=0;const a=(E,A)=>{const M=` ${E}(${A})`;n+M.length>60?(r.push(b),b="|                 ",n=b.length):n+=M.length,b+=M};let b="|      File types:";const C=10,I=o.fileTypes.length>C?C:o.fileTypes.length;for(let E=0;E<I;E++){const A=o.fileTypes[E];a(A.name,A.count)}if(r.push(b),o.configFiles.length>=0&&(b="|      Conf files:",n=0,o.configFiles.forEach(E=>{a(E.name,E.count)}),r.push(b)),o.launchConfigFiles.length>0){let E="|      Launch Configs:";o.launchConfigFiles.forEach(A=>{const M=A.count>1?` ${A.name}(${A.count})`:` ${A.name}`;E+=M}),r.push(E)}return r.join(`
`)}j(o){const r=Math.max(...Object.keys(o).map(i=>i.length));return Object.keys(o).map(i=>`${i}:  ${" ".repeat(r-i.length)}  ${o[i]}`).join(`
                  `)}k(o){const r=[],i=[];return o.windows.forEach(n=>{n.folderURIs.length===0||n.remoteAuthority||(r.push(`|  Window (${n.title})`),n.folderURIs.forEach(a=>{const b=f.URI.revive(a);if(b.scheme===j.Schemas.file){const C=b.fsPath;i.push($(C,["node_modules",".git"]).then(I=>{let E=`${I.fileCount} files`;I.maxFilesReached&&(E=`more than ${E}`),r.push(`|    Folder (${(0,D.$nc)(C)}): ${E}`),r.push(this.h(I))}).catch(I=>{r.push(`|      Error: Unable to collect workspace stats for folder ${C} (${I.toString()})`)}))}else r.push(`|    Folder (${b.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(n=>r.join(`
`)).catch(n=>`Unable to collect workspace stats: ${n}`)}m(o,r){const i=new Map;o.windows.forEach(a=>i.set(a.pid,`window [${a.id}] (${a.title})`)),o.pidToNames.forEach(({pid:a,name:b})=>i.set(a,b));const n=[];return n.push("CPU %	Mem MB	   PID	Process"),r&&this.n(o.mainPID,i,n,r,0),n.join(`
`)}n(o,r,i,n,a){const b=a===0;let C;b?C=n.pid===o?`${this.d.applicationName} main`:"remote agent":r.has(n.pid)?C=r.get(n.pid):C=`${"  ".repeat(a)} ${n.name}`;const I=process.platform==="win32"?n.mem:P.totalmem()*(n.mem/100);i.push(`${n.load.toFixed(0).padStart(5," ")}	${(I/u.$Yk.MB).toFixed(0).padStart(6," ")}	${n.pid.toFixed(0).padStart(6," ")}	${C}`),Array.isArray(n.children)&&n.children.forEach(E=>this.n(o,r,i,E,a+1))}async getWorkspaceFileExtensions(o){const r=new Set;for(const{uri:i}of o.folders){const n=f.URI.revive(i);if(n.scheme!==j.Schemas.file)continue;const a=n.fsPath;try{(await $(a,["node_modules",".git"])).fileTypes.forEach(C=>r.add(C.name))}catch{}}return{extensions:[...r]}}async reportWorkspaceStats(o){for(const{uri:r}of o.folders){const i=f.URI.revive(r);if(i.scheme!==j.Schemas.file)continue;const n=i.fsPath;try{const a=await $(n,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),a.fileTypes.forEach(b=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),a.launchConfigFiles.forEach(b=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})}),a.configFiles.forEach(b=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:b.name,count:b.count})})}catch{}}}};e.$9r=c,e.$9r=c=ve([ne(0,w.$ul),ne(1,y.$Fj)],c)}),define(oe[251],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=e.$V$b=void 0;class P{constructor(j){this.b=j}listen(j,D){throw new Error(`Event not found: ${D}`)}call(j,D,{eventName:S,data:f}){return this.b.forEach(l=>l.log(S,f)),Promise.resolve(null)}}e.$V$b=P;class R{constructor(j){this.b=j}log(j,D){return this.b.call("log",{eventName:j,data:D}).then(void 0,S=>`Failed to log telemetry: ${console.warn(S)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$W$b=R}),define(oe[54],ae([0,1,35,12,59,123,28]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class S{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$Lo=S;class f{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=f,e.$No=new f;class l{async publicLog(o,r,i){}async publicLogError(o,r,i){}}e.$Oo=l,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function p(t,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!t.enableTelemetry)}e.$So=p;function k(t,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$To=k;function v(t){const o=t.getValue(D.$Cl),r=t.getValue(D.$Dl);if(t.getValue(D.$El)===!1||r===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=v;function u(t){const o={},r={},i={};g(t,i);for(let n in i){n=n.length>150?n.substr(n.length-149):n;const a=i[n];typeof a=="number"?r[n]=a:typeof a=="boolean"?r[n]=a?1:0:typeof a=="string"?(a.length>8192&&console.warn(`Telemetry property: ${n} has been trimmed to 8192, the original length is ${a.length}`),o[n]=a.substring(0,8191)):typeof a<"u"&&a!==null&&(o[n]=a)}return{properties:o,measurements:r}}e.$Vo=u;const y=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function w(t){if(!t)return"none";const o=(0,s.$bl)(t);return y.has(o)?o:"other"}e.$Wo=w;function g(t,o,r=0,i){if(t)for(const n of Object.getOwnPropertyNames(t)){const a=t[n],b=i?i+n:n;Array.isArray(a)?o[b]=(0,P.$An)(a):a instanceof Date?o[b]=a.toISOString():(0,R.$Kf)(a)?r<2?g(a,o,r+1,b+"."):o[b]=(0,P.$An)(a):o[b]=a}}function $(t,o){const r=t.msftInternalDomains||[],i=o.getValue("telemetry.internalTesting");return(0,j.$Ko)(r)||i}e.$Xo=$;function d(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Yo=d;function h(t,o){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let r=t;const i=[];for(const C of o)for(;;){const I=C.exec(t);if(!I)break;i.push([I.index,C.lastIndex])}const n=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,a=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(r="";;){const C=a.exec(t);if(!C)break;const I=i.some(([E,A])=>C.index<A&&E<a.lastIndex);!n.test(C[0])&&!I&&(r+=t.substring(b,C.index)+"<REDACTED: user-file-path>",b=a.lastIndex)}return b<t.length&&(r+=t.substr(b)),r}function m(t){if(!t)return t;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const r of o)if(r.regex.test(t))return`<REDACTED: ${r.label}>`;return t}function c(t,o){return(0,P.$xn)(t,r=>{if(r instanceof S||Object.hasOwnProperty.call(r,"isTrustedTelemetryValue"))return r.value;if(typeof r=="string"){let i=r.replaceAll("%20"," ");i=h(i,o);for(const n of o)i=i.replace(n,"");return i=m(i),i}})}e.$Zo=c}),define(oe[124],ae([0,1,25,118,121,4,7,14,36,54]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function p(r,i){return r.uuid&&i.uuid?r.uuid===i.uuid:r.id===i.id?!0:(0,P.$7e)(r.id,i.id)===0}e.$1o=p;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(i){const n=i.manifest?i.manifest.version:i.version,a=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new v(i.identifier,n,a)}static parse(i){const n=k.exec(i);return n&&n[1]&&n[2]?new v({id:n[1]},n[2],n[4]||void 0):null}constructor(i,n,a="undefined"){this.version=n,this.targetPlatform=a,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof v?p(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.$2o=v;const u=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const i=u.exec(r);return i&&i[1]?[g(i[1]),i[2]]:[g(r),void 0]}e.$3o=y;function w(r,i){return`${r}.${i}`}e.$4o=w;function g(r){return r.toLowerCase()}e.$5o=g;function $(r,i){return g(w(r??s.$hm,i))}e.$6o=$;function d(r,i){const n=[],a=b=>{for(const C of n)if(C.some(I=>p(i(I),i(b))))return C;return null};for(const b of r){const C=a(b);C?C.push(b):n.push([b])}return n}e.$7o=d;function h(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.$8o=h;function m(r){return{id:new l.$Lo(r.identifier.id),name:new l.$Lo(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.$9o=m,e.$0o=new s.$lm("pprice.better-merge");function c(r,i){const n=[],a=i.manifest.extensionDependencies?.slice(0)??[];for(;a.length;){const b=a.shift();if(b&&n.every(C=>!p(C.identifier,{id:b}))){const C=r.filter(I=>p(I.identifier,{id:b}));C.length===1&&(n.push(C[0]),a.push(...C[0].manifest.extensionDependencies?.slice(0)??[]))}}return n}e.$$o=c;async function t(r,i){if(!j.$k)return!1;let n;try{n=(await r.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{n=(await r.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(b){i.debug("Error while getting the os-release file.",(0,S.$0)(b))}}return!!n&&(n.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(r,i){const n=await t(r,i),a=(0,R.$uo)(n?"alpine":j.$u,f.$ec);return i.debug("ComputeTargetPlatform:",a),a}e.$_o=o}),define(oe[252],ae([0,1,206,54]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;async function s(j,D,S,f,l,p,k){const v={"X-Market-Client-Id":`VSCode ${j}`,"User-Agent":`VSCode ${j} (${D.nameShort})`};if((0,R.$So)(D,S)&&(0,R.$Uo)(f)===3){const u=await(0,P.$Ap)(S,l,p);v["X-Market-User-Id"]=u,v["VSCode-SessionId"]=k.machineId||u}return v}e.$Bp=s}),define(oe[253],ae([0,1,2,35,4,25,185,18,52,79,27,44,28,54]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;let y=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor($,d,h){this.k=d,this.l=h,this.d={},this.i=new P.$Sc,this.j=[],this.b=$.appenders,this.c=$.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=$.piiPaths||[],this.g=3,this.h=!!$.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,j.$Oe)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,j.$Oe)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(v.$Cl)||m.affectsConfiguration(v.$El)||m.affectsConfiguration(v.$Dl))&&this.m()}))}setExperimentProperty($,d){this.d[$]=d}m(){let $=(0,u.$Uo)(this.k);const d=this.l.enabledTelemetryLevels;if(d){this.h=this.sendErrorTelemetry?d.error:!1;const h=d.usage?3:d.error?2:0;$=Math.min($,h)}this.g=$}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n($,d,h){this.g<d||(h=(0,R.$yn)(h,this.d),h=(0,u.$Zo)(h,this.j),h=(0,R.$yn)(h,this.c),this.b.forEach(m=>m.log($,h)))}publicLog($,d){this.n($,3,d)}publicLog2($,d){this.publicLog($,d)}publicLogError($,d){this.h&&this.n($,2,d)}publicLogError2($,d){this.publicLogError($,d)}};e.$pr=y,e.$pr=y=ve([ne(1,S.$zi),ne(2,p.$Fj)],y);function w(){const g=(0,D.localize)(0,null,l.default.nameLong),$=l.default.privacyStatementUrl?(0,D.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,D.localize)(1,null,"https://aka.ms/vscode-telemetry"),d=s.$o?"":(0,D.localize)(3,null),h=(0,D.localize)(4,null),m=(0,D.localize)(5,null),c=(0,D.localize)(6,null),t=(0,D.localize)(7,null),o=`
|       | ${h} | ${m} | ${c} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,D.localize)(8,null);return`
${g} ${$} ${d}

&nbsp;

${t}
${o}

&nbsp;

${r}
`}k.$Hn.as(f.$Mn.Configuration).registerConfiguration({id:v.$Bl,order:1,type:"object",title:(0,D.localize)(9,null),properties:{[v.$Cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,D.localize)(10,null),(0,D.localize)(11,null),(0,D.localize)(12,null),(0,D.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),k.$Hn.as(f.$Mn.Configuration).registerConfiguration({id:v.$Bl,order:110,type:"object",title:(0,D.localize)(14,null),properties:{[v.$El]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,D.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,D.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,D.localize)(17,null,`\`#${v.$Cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[254],ae([0,1,4,88,28]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=e.$l_b=void 0;async function j(S,f){let l=S.getItem(s.$zl);return(typeof l!="string"||P.$j&&l==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(l=await(0,R.$$m)(f.error.bind(f))),l}e.$l_b=j;async function D(S,f){let l=S.getItem(s.$Al);return typeof l!="string"&&(l=await(0,R.$_m)(f.error.bind(f))),l}e.$m_b=D}),define(oe[255],ae([0,1,28,254]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$o_b=e.$n_b=void 0;async function s(D,S){const f=await(0,R.$l_b)(D,S);return D.setItem(P.$zl,f),f}e.$n_b=s;async function j(D,S){const f=await(0,R.$m_b)(D,S);return D.setItem(P.$Al,f),f}e.$o_b=j}),define(oe[125],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var P;(function(R){R[R.Replace=1]="Replace",R[R.Append=2]="Append",R[R.Prepend=3]="Prepend"})(P||(e.EnvironmentVariableMutatorType=P={}))}),define(oe[256],ae([0,1,4,125]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0;const s=new Map([[R.EnvironmentVariableMutatorType.Append,"APPEND"],[R.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[R.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class j{constructor(p){this.collections=p,this.a=new Map,this.b=new Map,p.forEach((k,v)=>{this.d(k,v);const u=k.map.entries();let y=u.next();for(;!y.done;){const w=y.value[1],g=y.value[0];let $=this.a.get(g);if($||($=[],this.a.set(g,$)),$.length>0&&$[0].type===R.EnvironmentVariableMutatorType.Replace){y=u.next();continue}const d={extensionIdentifier:v,value:w.value,type:w.type,scope:w.scope,variable:w.variable,options:w.options};d.scope||delete d.scope,$.unshift(d),y=u.next()}})}async applyToProcessEnvironment(p,k,v){let u;P.$i&&(u={},Object.keys(p).forEach(y=>u[y.toLowerCase()]=y));for(const[y,w]of this.getVariableMap(k)){const g=P.$i&&u[y.toLowerCase()]||y;for(const $ of w){const d=v?await v($.value):$.value;if($.options?.applyAtProcessCreation??!0)switch($.type){case R.EnvironmentVariableMutatorType.Append:p[g]=(p[g]||"")+d;break;case R.EnvironmentVariableMutatorType.Prepend:p[g]=d+(p[g]||"");break;case R.EnvironmentVariableMutatorType.Replace:p[g]=d;break}if($.options?.applyAtShellIntegration??!1){const h=`VSCODE_ENV_${s.get($.type)}`;p[h]=(p[h]?p[h]+":":"")+y+"="+this.c(d)}}}}c(p){return p.replaceAll(":","\\x3a")}diff(p,k){const v=new Map,u=new Map,y=new Map;if(p.getVariableMap(k).forEach((w,g)=>{const $=this.getVariableMap(k).get(g),d=S(w,$);d&&v.set(g,d)}),this.getVariableMap(k).forEach((w,g)=>{const $=p.getVariableMap(k).get(g),d=S(w,$);d&&y.set(g,d)}),this.getVariableMap(k).forEach((w,g)=>{const $=p.getVariableMap(k).get(g),d=f(w,$);d&&u.set(g,d)}),!(v.size===0&&u.size===0&&y.size===0))return{added:v,changed:u,removed:y}}getVariableMap(p){const k=new Map;for(const v of this.a.values()){const u=v.filter(y=>D(y,p));u.length>0&&k.set(u[0].variable,u)}return k}getDescriptionMap(p){const k=new Map;for(const v of this.b.values()){const u=v.filter(y=>D(y,p,!0));for(const y of u)k.set(y.extensionIdentifier,y.description)}return k}d(p,k){if(!p.descriptionMap)return;const v=p.descriptionMap.entries();let u=v.next();for(;!u.done;){const y=u.value[1],w=u.value[0];let g=this.b.get(w);g||(g=[],this.b.set(w,g));const $={extensionIdentifier:k,scope:y.scope,description:y.description};$.scope||delete $.scope,g.push($),u=v.next()}}}e.$Sr=j;function D(l,p,k=!1){return l.scope?!!(l.scope.workspaceFolder&&p?.workspaceFolder&&l.scope.workspaceFolder.index===p.workspaceFolder.index):k?p===l.scope:!0}function S(l,p){if(!p)return l;const k=new Set;p.forEach(u=>k.add(u.extensionIdentifier));const v=[];return l.forEach(u=>{k.has(u.extensionIdentifier)||v.push(u)}),v.length===0?void 0:v}function f(l,p){if(!p)return;const k=new Map;p.forEach(u=>k.set(u.extensionIdentifier,u));const v=[];return l.forEach(u=>{const y=k.get(u.extensionIdentifier);y&&(u.type!==y.type||u.value!==y.value||u.scope?.workspaceFolder?.index!==y.scope?.workspaceFolder?.index)&&v.push(y)}),v.length===0?void 0:v}}),define(oe[257],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function P(f){return[...f.entries()]}e.$Mr=P;function R(f){return f?[...f.entries()]:[]}e.$Nr=R;function s(f){return new Map(f)}e.$Or=s;function j(f){return new Map(f??[])}e.$Pr=j;function D(f){return Array.from(f.entries()).map(l=>[l[0],P(l[1].map),R(l[1].descriptionMap)])}e.$Qr=D;function S(f){return new Map(f.map(l=>[l[0],{map:s(l[1]),descriptionMap:j(l[2])}]))}e.$Rr=S}),define(oe[258],ae([0,1,8,23,3,2,5]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;let S=class extends j.$Tc{constructor(l,p){super(),this.h=p,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new s.$Vd),this.onCreateRequest=this.g.event,this.b=l===void 0?15e3:l,this.B((0,j.$Rc)(()=>{for(const k of this.f.values())(0,j.$Oc)(k)}))}createRequest(l){return new Promise((p,k)=>{const v=++this.a;this.c.set(v,p),this.g.fire({requestId:v,...l});const u=new R.$6d;(0,P.$7g)(this.b,u.token).then(()=>k(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,j.$Rc)(()=>u.cancel())])})}acceptReply(l,p){const k=this.c.get(l);k?(this.c.delete(l),(0,j.$Oc)(this.f.get(l)||[]),this.f.delete(l),k(p)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${l}`)}};e.$Dr=S,e.$Dr=S=ve([ne(1,D.$nj)],S)}),define(oe[126],ae([0,1,6,115,44]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=e.$xr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$wr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$vr=void 0,e.$vr=new R.$kj("terminalTabFocusMode",!1,!0);var j;(function(c){c.AutomationProfile="terminal.integrated.automationProfile.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(j||(e.TerminalSettingPrefix=j={}));var D;(function(c){c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.TabStopWidth="terminal.integrated.tabStopWidth",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorStyleInactive="terminal.integrated.cursorStyleInactive",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.TabFocusMode="terminal.integrated.tabFocusMode",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.HideOnStartup="terminal.integrated.hideOnStartup",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",c.EnableImages="terminal.integrated.enableImages",c.SmoothScrolling="terminal.integrated.smoothScrolling",c.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",c.FocusAfterRun="terminal.integrated.focusAfterRun",c.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",c.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",c.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",c.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",c.MouseWheelZoom="terminal.integrated.mouseWheelZoom",c.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",c.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",c.DevMode="terminal.integrated.developer.devMode"})(D||(e.TerminalSettingId=D={}));var S;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(S||(e.PosixShellType=S={}));var f;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(f||(e.WindowsShellType=f={}));var l;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(l||(e.TitleEventSource=l={}));var p;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.PtyHostWindow="ptyHostWindow",c.Logger="logger",c.Heartbeat="heartbeat"})(p||(e.TerminalIpcChannels=p={}));var k;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(k||(e.ProcessPropertyType=k={})),e.$wr=(0,P.$6h)("ptyService");var v;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(v||(e.HeartbeatConstants=v={}));var u;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(u||(e.TerminalLocation=u={}));var y;(function(c){c.TerminalView="view",c.Editor="editor"})(y||(e.TerminalLocationString=y={}));var w;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(w||(e.LocalReconnectConstants=w={}));var g;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(g||(e.FlowControlConstants=g={}));var $;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})($||(e.ProfileSource=$={}));var d;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(d||(e.ShellIntegrationStatus=d={}));var h;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(h||(e.TerminalExitReason=h={})),e.$xr={Backend:"workbench.contributions.terminal.processBackend"};class m{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(t){const o=this.b(t.remoteAuthority);if(this.a.has(o))throw new Error(`A terminal backend with remote authority '${o}' was already registered.`);this.a.set(o,t)}getTerminalBackend(t){return this.a.get(this.b(t))}b(t){return t?.toLowerCase()??""}}s.$Hn.add(e.$xr.Backend,new m),e.$yr=(0,P.$6h)("localPtyService"),e.$zr=(0,P.$6h)("terminalLogService")}),define(oe[259],ae([0,1,75,7,187,103]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hr=e.$Gr=e.$Fr=e.$Er=void 0;function D(v,u){const y=[{name:null,description:(0,s.localize)(0,null)}];return y.push(...v.map(w=>({name:w.profileName,description:S(w)}))),u&&y.push(...u.map(w=>({name:w.title,description:f(w)}))),{values:y.map(w=>w.name),markdownDescriptions:y.map(w=>w.description)}}e.$Er=D;function S(v){let u=`$(${j.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:P.$_j.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?u+=`
- args: "${v.args}"`:u+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(u+=`
- overrideName: ${v.overrideName}`),v.color&&(u+=`
- color: ${v.color}`),v.env&&(u+=`
- env: ${JSON.stringify(v.env)}`),u}function f(v){return`$(${j.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:P.$_j.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function l(v,u){if(!v&&!u)return!0;if(typeof v=="string"&&typeof u=="string")return v===u;if(Array.isArray(v)&&Array.isArray(u)){if(v.length!==u.length)return!1;for(let y=0;y<v.length;y++)if(v[y]!==u[y])return!1;return!0}return!1}e.$Fr=l;function p(v,u){if(!v&&!u)return!0;if(!v||!u)return!1;if(j.ThemeIcon.isThemeIcon(v)&&j.ThemeIcon.isThemeIcon(u))return v.id===u.id&&v.color===u.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof u=="object"&&"light"in u&&"dark"in u){const y=v,w=u;if((R.URI.isUri(y.light)||k(y.light))&&(R.URI.isUri(y.dark)||k(y.dark))&&(R.URI.isUri(w.light)||k(w.light))&&(R.URI.isUri(w.dark)||k(w.dark)))return y.light.path===w.light.path&&y.dark.path===w.dark.path}if(R.URI.isUri(v)&&R.URI.isUri(u)||k(v)||k(u)){const y=v,w=u;return y.path===w.path&&y.scheme===w.scheme}return!1}e.$Gr=p;function k(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.$Hr=k}),define(oe[260],ae([0,1,75,4,186,52,44,259]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lr=e.$Kr=e.$Jr=e.$Ir=void 0,e.$Ir={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.$Jr={type:"string",enum:Array.from((0,P.$$j)(),g=>g.id),markdownEnumDescriptions:Array.from((0,P.$$j)(),g=>`$(${g.id})`)};const f={args:{description:(0,s.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,s.localize)(1,null),type:"boolean"},icon:{description:(0,s.localize)(2,null),...e.$Jr},color:{description:(0,s.localize)(3,null),...e.$Ir},env:{markdownDescription:(0,s.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},l={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(5,null),type:["string","array"],items:{type:"string"}},...f}},p={type:"object",required:["path"],properties:{path:{description:(0,s.localize)(6,null),type:["string"],items:{type:"string"}},...f}};function k(g){const $=g===2?"linux":g===1?"osx":"windows";return(0,s.localize)(7,null,(0,R.$h)(g),'```json\n"terminal.integrated.profile.'+$+'": {\n  "bash": null\n}\n```',"[","](https://code.visualstudio.com/docs/terminal/profiles)")}const v={id:"terminal",order:100,title:(0,s.localize)(8,null),type:"object",properties:{["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(9,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(10,null),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(11,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},p],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:k(3),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,s.localize)(12,null),enum:["PowerShell","Git Bash"]},...f}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(13,null),type:"string"},id:{description:(0,s.localize)(14,null),type:"string"},title:{description:(0,s.localize)(15,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:k(1),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(16,null),type:"string"},id:{description:(0,s.localize)(17,null),type:"string"},title:{description:(0,s.localize)(18,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:k(2),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,s.localize)(19,null),type:"string"},id:{description:(0,s.localize)(20,null),type:"string"},title:{description:(0,s.localize)(21,null),type:"string"},...f}},{type:"null"},l]}},["terminal.integrated.useWslProfiles"]:{description:(0,s.localize)(22,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,s.localize)(23,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,s.localize)(24,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,s.localize)(25,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{markdownDescription:(0,s.localize)(26,null,"`#terminal.integrated.confirmOnKill#`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function u(){D.$Hn.as(j.$Mn.Configuration).registerConfiguration(v),w()}e.$Kr=u;let y;function w(g,$){const d=D.$Hn.as(j.$Mn.Configuration);let h;g&&(h=(0,S.$Er)(g?.profiles,$));const m=y;y={id:"terminal",order:100,title:(0,s.localize)(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,s.localize)(28,null),type:["string","null"],default:null,enum:g?.os===3?h?.values:void 0,markdownEnumDescriptions:g?.os===3?h?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,s.localize)(29,null),type:["string","null"],default:null,enum:g?.os===2?h?.values:void 0,markdownEnumDescriptions:g?.os===2?h?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,s.localize)(30,null),type:["string","null"],default:null,enum:g?.os===1?h?.values:void 0,markdownEnumDescriptions:g?.os===1?h?.markdownDescriptions:void 0}}},d.updateConfigurations({add:[y],remove:m?[m]:[]})}e.$Lr=w}),define(oe[261],ae([0,1,26,13,35,9,4,36,25,12,21,125,257,256]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=e.$Tr=void 0;function y(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(P.release());let n=0;return i&&i.length===4&&(n=parseInt(i[3])),n}e.$Tr=y;async function w(i,n,a,b=S.env,C=p.Promises.exists){if(j.$ic(i))return await C(i)?i:void 0;if(n===void 0&&(n=S.cwd()),j.$mc(i)!=="."){const M=j.$jc(n,i);return await C(M)?M:void 0}const E=(0,s.$Cn)(b,"PATH");if(a===void 0&&(0,l.$If)(E)&&(a=E.split(j.$tc)),a===void 0||a.length===0){const M=j.$jc(n,i);return await C(M)?M:void 0}for(const M of a){let T;if(j.$ic(M)?T=j.$jc(M,i):T=j.$jc(n,M,i),await C(T))return T;if(D.$i){let W=T+".com";if(await C(W)||(W=T+".exe",await C(W)))return W}}const A=j.$jc(n,i);return await C(A)?A:void 0}e.$Ur=w;function g(i,n,a,b,C){const I=D.$i&&(!n.windowsEnableConpty||y()<18309);if(!n.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||I)return;const E=i.args,A=S.$dc==="win32"?j.$nc(i.executable).toLowerCase():j.$nc(i.executable),M=j.$mc(R.$og.asFileUri("").fsPath);let T;const W={VSCODE_INJECTION:"1"};if(n.shellIntegration.nonce&&(W.VSCODE_NONCE=n.shellIntegration.nonce),D.$i){if(A==="pwsh.exe"||A==="powershell.exe")return!E||o(E)?T=h.get(d.WindowsPwsh):t(E)&&(T=h.get(d.WindowsPwshLogin)),T?(T=[...T],T[T.length-1]=(0,f.$Ke)(T[T.length-1],M,""),n.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),{newArgs:T,envMixin:W}):void 0;b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(A){case"bash":return!E||E.length===0?T=h.get(d.Bash):r(E)&&(W.VSCODE_SHELL_LOGIN="1",$(n,W),T=h.get(d.Bash)),T?(T=[...T],T[T.length-1]=(0,f.$Ke)(T[T.length-1],M),{newArgs:T,envMixin:W}):void 0;case"fish":{const G=a?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",J=j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return W.XDG_DATA_DIRS=`${G}:${J}`,$(n,W),{newArgs:void 0,envMixin:W}}case"pwsh":return!E||o(E)?T=h.get(d.Pwsh):t(E)&&(T=h.get(d.PwshLogin)),T?(n.shellIntegration.suggestEnabled&&(W.VSCODE_SUGGEST="1"),T=[...T],T[T.length-1]=(0,f.$Ke)(T[T.length-1],M,""),{newArgs:T,envMixin:W}):void 0;case"zsh":{if(!E||E.length===0?T=h.get(d.Zsh):r(E)?(T=h.get(d.ZshLogin),$(n,W)):(E===h.get(d.Zsh)||E===h.get(d.ZshLogin))&&(T=E),!T)return;T=[...T],T[T.length-1]=(0,f.$Ke)(T[T.length-1],M);let G;try{G=P.userInfo().username}catch{G="unknown"}const J=j.$jc(P.tmpdir(),`${G}-${C.applicationName}-zsh`);W.ZDOTDIR=J;const ce=a?.ZDOTDIR??P.homedir()??"~";W.USER_ZDOTDIR=ce;const re=[];return re.push({source:j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:j.$jc(J,".zshrc")}),re.push({source:j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:j.$jc(J,".zprofile")}),re.push({source:j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:j.$jc(J,".zshenv")}),re.push({source:j.$jc(M,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:j.$jc(J,".zlogin")}),{newArgs:T,envMixin:W,filesToCopy:re}}}b.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.$Vr=g;function $(i,n){if(D.$j&&i.environmentVariableCollections){const a=(0,v.$Rr)(i.environmentVariableCollections),C=new u.$Sr(a).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),I=[];if(C)for(const E of C)E.type===k.EnvironmentVariableMutatorType.Prepend&&I.push(E.value);I.length>0&&(n.VSCODE_PATH_PREFIX=I.join(""))}}var d;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(d||(d={}));const h=new Map;h.set(d.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(d.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),h.set(d.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),h.set(d.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),h.set(d.Zsh,["-i"]),h.set(d.ZshLogin,["-il"]),h.set(d.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const m=["-login","-l"],c=["-nol","-nologo"];function t(i){return typeof i=="string"?m.includes(i.toLowerCase()):i.length===1&&m.includes(i[0].toLowerCase())||i.length===2&&(m.includes(i[0].toLowerCase())||m.includes(i[1].toLowerCase()))&&(c.includes(i[0].toLowerCase())||c.includes(i[1].toLowerCase()))}function o(i){return typeof i=="string"?c.includes(i.toLowerCase()):i.length===0||i?.length===1&&c.includes(i[0].toLowerCase())}function r(i){return i==="string"&&m.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&m.includes(i[0].toLowerCase())}}),define(oe[262],ae([0,1,48,75,9,4,12,21,107,261,114]),function(X,e,P,R,s,j,D,S,f,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wr=void 0;var k;(function(a){a.UnixShellsPath="/etc/shells"})(k||(k={}));let v,u=!0;function y(a,b,C,I,E=process.env,A,M,T,W){return A=A||{existsFile:S.SymlinkSupport.existsFile,readFile:S.Promises.readFile},j.$i?w(C,A,E,M,I.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?{...a}:I.getValue("terminal.integrated.profiles.windows"),typeof b=="string"?b:I.getValue("terminal.integrated.defaultProfile.windows"),W,T):r(A,M,C,a&&typeof a=="object"?{...a}:I.getValue(j.$k?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof b=="string"?b:I.getValue(j.$k?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),W,T,E)}e.$Wr=y;async function w(a,b,C,I,E,A,M,T,W){const G=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),J=`${process.env.windir}\\${G?"Sysnative":"System32"}`;let ce=!1;(0,l.$Tr)()>=16299&&(ce=!0),await h(T);const re=new Map;if(a){re.set("PowerShell",{source:"PowerShell",icon:R.$_j.terminalPowershell,isAutoDetected:!0}),re.set("Windows PowerShell",{path:`${J}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:R.$_j.terminalPowershell,isAutoDetected:!0}),re.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),re.set("Command Prompt",{path:`${J}\\cmd.exe`,icon:R.$_j.terminalCmd,isAutoDetected:!0}),re.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),re.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:R.$_j.terminalBash,isAutoDetected:!0});const Z=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;re.set("Cmder",{path:`${J}\\cmd.exe`,args:["/K",Z],requiresPath:process.env.CMDER_ROOT?Z:{path:Z,isUnsafe:!0},isAutoDetected:!0})}i(A,re);const ue=await g(re.entries(),M,b,C,I,W);if(a&&E)try{const Z=await t(`${J}\\${ce?"wsl":"bash"}.exe`,M);for(const Y of Z)(!A||!(Y.profileName in A))&&ue.push(Y)}catch{u&&(I?.info("WSL is not installed, so could not detect WSL profiles"),u=!1)}return ue}async function g(a,b,C,I=process.env,E,A){const M=[];for(const[T,W]of a)M.push($(T,W,b,C,I,E,A));return(await Promise.all(M)).filter(T=>!!T)}async function $(a,b,C,I,E=process.env,A,M){if(b===null)return;let T,W,G;if("source"in b&&!("path"in b)){const ue=v?.get(b.source);if(!ue)return;T=ue.paths,W=b.args||ue.args,b.icon?G=d(b.icon):ue.icon&&(G=ue.icon)}else T=Array.isArray(b.path)?b.path:[b.path],W=j.$i||Array.isArray(b.args)?b.args:void 0,G=d(b.icon);let J;if(M){const ue=T.map(Y=>typeof Y=="string"?Y:Y.path),Z=await M(ue);J=new Array(T.length);for(let Y=0;Y<T.length;Y++)typeof T[Y]=="string"?J[Y]=Z[Y]:J[Y]={path:Z[Y],isUnsafe:!0}}else J=T.slice();let ce;if(b.requiresPath){let ue;if((0,D.$If)(b.requiresPath)?ue=b.requiresPath:(ue=b.requiresPath.path,b.requiresPath.isUnsafe&&(ce=ue)),!await I.existsFile(ue))return}const re=await n(a,C,J,I,E,W,b.env,b.overrideName,b.isAutoDetected,ce);if(!re){A?.debug("Terminal profile not validated",a,T);return}return re.isAutoDetected=b.isAutoDetected,re.icon=G,re.color=b.color,re}function d(a){return typeof a=="string"?{id:a}:a}async function h(a){if(v&&!a)return;const[b,C]=await Promise.all([m(),a||c()]);v=new Map,v.set("Git Bash",{profileName:"Git Bash",paths:b,args:["--login","-i"]}),v.set("PowerShell",{profileName:"PowerShell",paths:C,icon:R.$_j.terminalPowershell})}async function m(){const a=new Set,b=await(0,l.$Ur)("git.exe");if(b){const E=(0,p.dirname)(b);a.add((0,p.resolve)(E,"../.."))}function C(E,A){A&&E.add(A)}C(a,process.env.ProgramW6432),C(a,process.env.ProgramFiles),C(a,process.env["ProgramFiles(X86)"]),C(a,`${process.env.LocalAppData}\\Program`);const I=[];for(const E of a)I.push(`${E}\\Git\\bin\\bash.exe`,`${E}\\Git\\usr\\bin\\bash.exe`,`${E}\\usr\\bin\\bash.exe`);return I.push(`${process.env.UserProfile}\\scoop\\apps\\git\\current\\bin\\bash.exe`),I.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),I}async function c(){const a=[];for await(const b of(0,f.$Pl)())a.push(b.exePath);return a}async function t(a,b){const C=[],I=await new Promise((M,T)=>{P.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(W,G)=>{if(W)return T("Problem occurred when getting wsl distros");M(G)})});if(!I)return[];const E=new RegExp(/[\r?\n]/),A=I.split(E).filter(M=>M.trim().length>0&&M!=="");for(const M of A){if(M===""||M.startsWith("docker-desktop"))continue;const T=`${M} (WSL)`,W={profileName:T,path:a,args:["-d",`${M}`],isDefault:T===b,icon:o(M),isAutoDetected:!1};C.push(W)}return C}function o(a){return a.includes("Ubuntu")?R.$_j.terminalUbuntu:a.includes("Debian")?R.$_j.terminalDebian:R.$_j.terminalLinux}async function r(a,b,C,I,E,A,M,T){const W=new Map;if(C&&await a.existsFile("/etc/shells")){const G=(await a.readFile("/etc/shells")).toString(),J=(A||G.split(`
`)).map(re=>{const ue=re.indexOf("#");return ue===-1?re:re.substring(0,ue)}).filter(re=>re.trim().length>0),ce=new Map;for(const re of J){let ue=(0,s.$nc)(re),Z=ce.get(ue)||0;Z++,Z>1&&(ue=`${ue} (${Z})`),ce.set(ue,Z),W.set(ue,{path:re,isAutoDetected:!0})}}return i(I,W),await g(W.entries(),E,a,T,b,M)}function i(a,b){if(a)for(const[C,I]of Object.entries(a))I===null||typeof I!="object"||!("path"in I)&&!("source"in I)?b.delete(C):(I.icon=I.icon||b.get(C)?.icon,b.set(C,I))}async function n(a,b,C,I,E,A,M,T,W,G){if(C.length===0)return Promise.resolve(void 0);const J=C.shift();if(J==="")return n(a,b,C,I,E,A,M,T,W);const ce=typeof J!="string"&&J.isUnsafe,re=typeof J=="string"?J:J.path,ue={profileName:a,path:re,args:A,env:M,overrideName:T,isAutoDetected:W,isDefault:a===b,isUnsafePath:ce,requiresUnsafePath:G};if((0,s.$nc)(re)===re){const Y=E.PATH?E.PATH.split(s.$tc):void 0,V=await(0,l.$Ur)(re,void 0,Y,void 0,I.existsFile);return V?(ue.path=V,ue.isFromPath=!0,ue):n(a,b,C,I,E,A)}return await I.existsFile((0,s.$hc)(re))?ue:n(a,b,C,I,E,A,M,T,W)}}),define(oe[263],ae([0,1,3,2,4,43,18,5,226,94,258,126,260,262,109,73]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=void 0;var g;(function(d){d[d.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let $=class extends R.$Tc{get c(){return this.h(),this.a}get f(){return this.h(),this.b}get g(){return this.b}h(){this.a||this.U()}constructor(h,m,c,t){super(),this.M=h,this.N=m,this.O=c,this.P=t,this.m=!1,this.n=0,this.r=!0,this.u=this.B(new P.$Vd),this.onPtyHostExit=this.u.event,this.w=this.B(new P.$Vd),this.onPtyHostStart=this.w.event,this.y=this.B(new P.$Vd),this.onPtyHostUnresponsive=this.y.event,this.z=this.B(new P.$Vd),this.onPtyHostResponsive=this.z.event,this.C=this.B(new P.$Vd),this.onPtyHostRequestResolveVariables=this.C.event,this.D=this.B(new P.$Vd),this.onProcessData=this.D.event,this.F=this.B(new P.$Vd),this.onProcessReady=this.F.event,this.G=this.B(new P.$Vd),this.onProcessReplay=this.G.event,this.H=this.B(new P.$Vd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new P.$Vd),this.onDidRequestDetach=this.I.event,this.J=this.B(new P.$Vd),this.onDidChangeProperty=this.J.event,this.L=this.B(new P.$Vd),this.onProcessExit=this.L.event,(0,v.$Kr)(),this.B(this.M),this.B((0,R.$Rc)(()=>this.W())),this.j=this.B(new p.$Dr(void 0,this.O)),this.j.onCreateRequest(this.C.fire,this.C),this.M.onRequestConnection&&P.Event.once(this.M.onRequestConnection)(()=>this.h()),this.M.onWillShutdown?.(()=>this.m=!0)}get Q(){return this.N.getValue("terminal.integrated.ignoreProcessNames")}async R(){return this.g?.refreshIgnoreProcessNames?.(this.Q)}async S(){if(s.$i)return process.env;try{return await(0,l.$_l)(this.N,this.O,{_:[]},process.env)}catch(h){return this.O.error("ptyHost was unable to resolve shell environment",h),{}}}U(){const h=this.M.start(),m=h.client;this.O.getLevel()===S.LogLevel.Trace&&this.O.trace("PtyHostService#_startPtyHost",new Error().stack?.replace(/^Error/,"")),j.ProxyChannel.toService(m.getChannel(k.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.X()),this.X(!0),this.B(h.onDidProcessExit(o=>{this.u.fire(o.code),!this.m&&!this.q.isDisposed&&(this.n<=g.MaxRestarts?(this.O.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.n++,this.restartPtyHost()):this.O.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))}));const t=j.ProxyChannel.toService(m.getChannel(k.TerminalIpcChannels.PtyHost));return this.B(t.onProcessData(o=>this.D.fire(o))),this.B(t.onProcessReady(o=>this.F.fire(o))),this.B(t.onProcessExit(o=>this.L.fire(o))),this.B(t.onDidChangeProperty(o=>this.J.fire(o))),this.B(t.onProcessReplay(o=>this.G.fire(o))),this.B(t.onProcessOrphanQuestion(o=>this.H.fire(o))),this.B(t.onDidRequestDetach(o=>this.I.fire(o))),this.B(new f.$Cr(this.P,m.getChannel(k.TerminalIpcChannels.Logger))),this.a=h,this.b=t,this.w.fire(),this.B(this.N.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.R()})),this.R(),[h,t]}async createProcess(h,m,c,t,o,r,i,n,a,b,C){const I=setTimeout(()=>this.$(),k.HeartbeatConstants.CreateProcessTimeout),E=await this.f.createProcess(h,m,c,t,o,r,i,n,a,b,C);return clearTimeout(I),E}updateTitle(h,m,c){return this.f.updateTitle(h,m,c)}updateIcon(h,m,c,t){return this.f.updateIcon(h,m,c,t)}attachToProcess(h){return this.f.attachToProcess(h)}detachFromProcess(h,m){return this.f.detachFromProcess(h,m)}shutdownAll(){return this.f.shutdownAll()}listProcesses(){return this.f.listProcesses()}async getPerformanceMarks(){return this.g?.getPerformanceMarks()??[]}async reduceConnectionGraceTime(){return this.g?.reduceConnectionGraceTime()}start(h){return this.f.start(h)}shutdown(h,m){return this.f.shutdown(h,m)}input(h,m){return this.f.input(h,m)}processBinary(h,m){return this.f.processBinary(h,m)}resize(h,m,c){return this.f.resize(h,m,c)}clearBuffer(h){return this.f.clearBuffer(h)}acknowledgeDataEvent(h,m){return this.f.acknowledgeDataEvent(h,m)}setUnicodeVersion(h,m){return this.f.setUnicodeVersion(h,m)}getInitialCwd(h){return this.f.getInitialCwd(h)}getCwd(h){return this.f.getCwd(h)}async getLatency(){const h=new w.$Rd,m=await this.f.getLatency();return h.stop(),[{label:"ptyhostservice<->ptyhost",latency:h.elapsed()},...m]}orphanQuestionReply(h){return this.f.orphanQuestionReply(h)}installAutoReply(h,m){return this.f.installAutoReply(h,m)}uninstallAllAutoReplies(){return this.f.uninstallAllAutoReplies()}uninstallAutoReply(h){return this.f.uninstallAutoReply(h)}getDefaultSystemShell(h){return this.g?.getDefaultSystemShell(h)??(0,y.$Vl)(h??s.OS,process.env)}async getProfiles(h,m,c,t=!1){const o=await this.S();return(0,u.$Wr)(m,c,t,this.N,o,void 0,this.O,this.bb.bind(this,h))}async getEnvironment(){return this.b?this.f.getEnvironment():{...process.env}}getWslPath(h,m){return this.f.getWslPath(h,m)}getRevivedPtyNewId(h,m){return this.f.getRevivedPtyNewId(h,m)}setTerminalLayoutInfo(h){return this.f.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return this.g?.getTerminalLayoutInfo(h)}async requestDetachInstance(h,m){return this.f.requestDetachInstance(h,m)}async acceptDetachInstanceReply(h,m){return this.f.acceptDetachInstanceReply(h,m)}async freePortKillProcess(h){if(!this.f.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.f.freePortKillProcess(h)}async serializeTerminalState(h){return this.f.serializeTerminalState(h)}async reviveTerminalProcesses(h,m,c){return this.f.reviveTerminalProcesses(h,m,c)}async refreshProperty(h,m){return this.f.refreshProperty(h,m)}async updateProperty(h,m,c){return this.f.updateProperty(h,m,c)}async restartPtyHost(){this.W(),this.r=!0,this.U()}W(){this.f.shutdownAll(),this.c.store.dispose()}X(h){this.ab(),this.s=setTimeout(()=>this.Y(),h?k.HeartbeatConstants.ConnectingBeatInterval:k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier),this.r||(this.r=!0,this.z.fire())}Y(){this.O.warn(`No ptyHost heartbeat after ${k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.s=void 0,this.t=setTimeout(()=>this.Z(),k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.SecondWaitMultiplier)}Z(){this.O.error(`No ptyHost heartbeat after ${(k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier+k.HeartbeatConstants.BeatInterval*k.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.t=void 0,this.r&&(this.r=!1,this.y.fire())}$(){this.ab(),this.O.error(`No ptyHost response to createProcess after ${k.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.r&&(this.r=!1,this.y.fire())}ab(){this.s&&(clearTimeout(this.s),this.s=void 0),this.t&&(clearTimeout(this.t),this.t=void 0)}bb(h,m){return this.j.createRequest({workspaceId:h,originalText:m})}async acceptPtyHostResolvedVariables(h,m){this.j.acceptReply(h,m)}};e.$Xr=$,e.$Xr=$=ve([ne(1,D.$zi),ne(2,S.$nj),ne(3,S.$oj)],$)}),define(oe[70],ae([0,1,15,3,2,4,18,6,34]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K0b=e.$J0b=void 0;const l="#FFFFFF",p="#1E1E1E",k="#000000",v="#FFFFFF",u="theme",y="themeBackground",w="windowSplash";e.$J0b=(0,S.$6h)("themeMainService");let g=class extends s.$Tc{constructor(d,h){super(),this.b=d,this.c=h,this.a=this.B(new R.$Vd),this.onDidChangeColorScheme=this.a.event,this.B(this.c.onDidChangeConfiguration(m=>{m.affectsConfiguration("window.systemColorTheme")&&this.f()})),this.f(),this.B(R.Event.fromNodeEventEmitter(P.nativeTheme,"updated")(()=>this.a.fire(this.getColorScheme())))}f(){switch(this.c.getValue("window.systemColorTheme")){case"dark":P.nativeTheme.themeSource="dark";break;case"light":P.nativeTheme.themeSource="light";break;case"auto":switch(this.g()){case"vs":P.nativeTheme.themeSource="light";break;case"vs-dark":P.nativeTheme.themeSource="dark";break;default:P.nativeTheme.themeSource="system"}break;default:P.nativeTheme.themeSource="system";break}}getColorScheme(){if(j.$i){if(P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(j.$j){if(P.nativeTheme.shouldUseInvertedColorScheme||P.nativeTheme.shouldUseHighContrastColors)return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(j.$k&&P.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:P.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const d=this.getColorScheme();if(d.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return d.dark?k:v;let h=this.b.getItem(y,null);if(!h)switch(this.g()){case"vs":h=l;break;case"hc-black":h=k;break;case"hc-light":h=v;break;default:h=p}return j.$j&&h.toUpperCase()===p&&(h="#171717"),h}g(){switch(this.b.getItem(u,"vs-dark").split(" ")[0]){case"vs":return"vs";case"hc-black":return"hc-black";case"hc-light":return"hc-light";default:return"vs-dark"}}saveWindowSplash(d,h){this.b.setItems([{key:u,data:h.baseTheme},{key:y,data:h.colorInfo.background},{key:w,data:h}]),typeof d=="number"&&this.h(d,h),this.f()}h(d,h){for(const m of P.BrowserWindow.getAllWindows())if(m.id===d){m.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.$K0b=g,e.$K0b=g=ve([ne(0,f.$uO),ne(1,D.$zi)],g)}),define(oe[127],ae([0,1,3,18,6,5]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,s.$6h)("tunnelService"),e.$Bv=(0,s.$6h)("sharedTunnelsService");var D;(function(g){g.Http="http",g.Https="https"})(D||(e.TunnelProtocol=D={}));var S;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(S||(e.TunnelPrivacyId=S={}));function f(g){return!!g.forwardPort}e.$Cv=f;var l;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(l||(e.ProvidedOnAutoForward=l={}));function p(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const $=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if($)return{address:$[1],port:+$[2]}}e.$Dv=p,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function k(g){return e.$Ev.indexOf(g)>=0}e.$Fv=k,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function v(g){return e.$Gv.indexOf(g)>=0}e.$Hv=v;function u(g,$,d,h){if(d===1)return!1;if(d===2&&v($)){const m=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(m?.length===4&&parseInt(m[1])>=18)return!1}return g<1024}e.$Iv=u;class y{constructor($,d,h){this.remoteAddress=$,this.localAddress=d,this.b=h,this.a=new P.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=y;let w=class{constructor($,d){this.k=$,this.l=d,this.a=new P.$Vd,this.onTunnelOpened=this.a.event,this.b=new P.$Vd,this.onTunnelClosed=this.b.event,this.c=new P.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const $=this.l.getValue("remote.localPortHost");return!$||$==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider($){return this.f=$,$?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures($){this.g=$.elevation,this.i=$.privacyOptions,this.h=$.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const $=[],d=Array.from(this.e.values());for(const h of d){const m=Array.from(h.values());for(const c of m){const t=await c.value;t&&typeof t!="string"&&$.push(t)}}return $}async dispose(){for(const $ of this.e.values()){for(const{value:d}of $.values())await d.then(h=>typeof h!="string"?h?.dispose():void 0);$.clear()}this.e.clear()}setEnvironmentTunnel($,d,h,m,c){this.q($,d,Promise.resolve({tunnelRemoteHost:$,tunnelRemotePort:d,localAddress:h,privacy:m,protocol:c,dispose:()=>Promise.resolve()}))}async getExistingTunnel($,d){(v($)||k($))&&($=e.$Ev[0]);const h=this.s($,d);if(h)return++h.refcount,h.value}openTunnel($,d,h,m,c,t=!1,o,r){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${h} on local port ${c}.`);const i=this.f??$;if(!i)return;if(d||(d="localhost"),m||(m=this.m),this.f&&this.j.has(h)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const n=this.t(i,d,h,m,c,t,o,r);return n?n.then(a=>{if(a){if(typeof a=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(d,h),a}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(d,h);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.o(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==h)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&a.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(b),b}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}o($){return{tunnelRemotePort:$.tunnelRemotePort,tunnelRemoteHost:$.tunnelRemoteHost,tunnelLocalPort:$.tunnelLocalPort,localAddress:$.localAddress,privacy:$.privacy,protocol:$.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${$.tunnelRemoteHost}:${$.tunnelRemotePort} `);const d=this.e.get($.tunnelRemoteHost);if(d){const h=d.get($.tunnelRemotePort);h&&(h.refcount--,await this.p($.tunnelRemoteHost,$.tunnelRemotePort,h))}}}}async p($,d,h){if(h.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${$}:${d}.`);const m=h.value.then(async c=>{c&&typeof c!="string"&&(await c.dispose(!0),this.b.fire({host:c.tunnelRemoteHost,port:c.tunnelRemotePort}))});return this.e.has($)&&this.e.get($).delete(d),m}}async closeTunnel($,d){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${$}:${d} `);const h=this.e.get($);if(h&&h.has(d)){const m=h.get(d);m.refcount=0,await this.p($,d,m)}}q($,d,h){this.e.has($)||this.e.set($,new Map),this.e.get($).set(d,{refcount:1,value:h})}async r($,d){const h=this.e.get($);if(h){const m=h.get(d),c=m?await m.value:void 0;(!c||typeof c=="string")&&h.delete(d),h.size===0&&this.e.delete($)}}s($,d){const h=[$];k($)?(h.push(...e.$Ev),h.push(...e.$Gv)):v($)&&h.push(...e.$Gv);const m=h.map(c=>this.e.get(c));for(const c of m){const t=c?.get(d);if(t)return t}}canTunnel($){return!!p($)}u($,d,h,m,c,t,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${h} on local port ${m}.`);const r=h;this.j.add(r);const i=m===void 0?h:m,n={elevationRequired:c?this.isPortPrivileged(i):!1},a={remoteAddress:{host:d,port:h},localAddressPort:m,privacy:t,public:t?t!==S.Private:void 0,protocol:o},b=$.forwardPort(a,n);return b?(this.q(d,h,b),b.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(r)})):this.j.delete(r),b}};e.$Kv=w,e.$Kv=w=ve([ne(0,j.$nj),ne(1,R.$zi)],w)}),define(oe[49],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zV=e.$yV=e.DisablementReason=e.UpdateType=e.StateType=void 0;var R;(function(D){D.Uninitialized="uninitialized",D.Idle="idle",D.Disabled="disabled",D.CheckingForUpdates="checking for updates",D.AvailableForDownload="available for download",D.Downloading="downloading",D.Downloaded="downloaded",D.Updating="updating",D.Ready="ready"})(R||(e.StateType=R={}));var s;(function(D){D[D.Setup=0]="Setup",D[D.Archive=1]="Archive",D[D.Snap=2]="Snap"})(s||(e.UpdateType=s={}));var j;(function(D){D[D.NotBuilt=0]="NotBuilt",D[D.DisabledByEnvironment=1]="DisabledByEnvironment",D[D.ManuallyDisabled=2]="ManuallyDisabled",D[D.MissingConfiguration=3]="MissingConfiguration",D[D.InvalidConfiguration=4]="InvalidConfiguration",D[D.RunningAsAdmin=5]="RunningAsAdmin"})(j||(e.DisablementReason=j={})),e.$yV={Uninitialized:{type:"uninitialized"},Disabled:D=>({type:"disabled",reason:D}),Idle:(D,S)=>({type:"idle",updateType:D,error:S}),CheckingForUpdates:D=>({type:"checking for updates",explicit:D}),AvailableForDownload:D=>({type:"available for download",update:D}),Downloading:D=>({type:"downloading",update:D}),Downloaded:D=>({type:"downloaded",update:D}),Updating:D=>({type:"updating",update:D}),Ready:D=>({type:"ready",update:D})},e.$zV=(0,P.$6h)("updateService")}),define(oe[264],ae([0,1,4,188,52,44]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),j.$Hn.as(s.$Mn.Configuration).registerConfiguration({id:"update",order:15,title:(0,R.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,R.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,R.localize)(2,null),(0,R.localize)(3,null),(0,R.localize)(4,null),(0,R.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,R.localize)(6,null),deprecationMessage:(0,R.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,R.localize)(8,null),description:(0,R.localize)(9,null),included:P.$i&&!P.$o},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,R.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(oe[265],ae([0,1,3,49]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y$b=e.$X$b=void 0;class s{constructor(S){this.a=S}listen(S,f){switch(f){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${f}`)}call(S,f,l){switch(f){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${f}`)}}e.$X$b=s;class j{get state(){return this.b}set state(S){this.b=S,this.a.fire(S)}constructor(S){this.c=S,this.a=new P.$Vd,this.onStateChange=this.a.event,this.b=R.$yV.Uninitialized,this.c.listen("onStateChange")(f=>this.state=f),this.c.call("_getInitialState").then(f=>this.state=f)}checkForUpdates(S){return this.c.call("checkForUpdates",S)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(S){return this.c.call("_applySpecificUpdate",S)}}e.$Y$b=j}),define(oe[40],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=void 0,e.$1k=(0,P.$6h)("IUriIdentityService")}),define(oe[266],ae([0,1,40,207,16,19,141,3,2]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;class l{static{this._clock=0}constructor(v){this.uri=v,this.time=l._clock++}touch(){return this.time=l._clock++,this}}let p=class{constructor(v){this.g=v,this.c=new f.$Sc,this.f=2**16;const u=new Map,y=w=>{let g=u.get(w.scheme);return g===void 0&&(g=v.hasProvider(w)&&!this.g.hasCapability(w,1024),u.set(w.scheme,g)),g};this.c.add(S.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(w=>{u.delete(w.scheme)})),this.extUri=new j.$wg(y),this.d=new D.$1r((w,g)=>this.extUri.compare(w,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,j.$Ig)(v));const u=this.d.get(v);return u?u.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new l(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);l._clock=0,this.d.clear();const u=this.f*.5;for(let y=0;y<u;y++)this.d.set(v[y][0],v[y][1].touch())}};e.$2r=p,e.$2r=p=ve([ne(0,s.$qk)],p),(0,R.$Yr)(P.$1k,p,1)}),define(oe[128],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pV=void 0,e.$pV=(0,P.$6h)("urlService")}),define(oe[267],ae([0,1,7]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8$b=e.$7$b=e.$6$b=void 0;class R{constructor(S){this.a=S}listen(S,f){throw new Error(`Event not found: ${f}`)}call(S,f,l){switch(f){case"handleURL":return this.a.handleURL(P.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${f}`)}}e.$6$b=R;class s{constructor(S){this.a=S}handleURL(S,f){return this.a.call("handleURL",[S.toJSON(),f])}}e.$7$b=s;class j{constructor(S,f){this.a=S,this.b=f}async routeCall(S,f,l,p){if(f!=="handleURL")throw new Error(`Call not found: ${f}`);if(Array.isArray(l)&&l.length>0){const k=P.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",k.toString(!0)),k.query){const v=/\bwindowId=(\d+)/.exec(k.query);if(v){const u=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${u}"`,k.toString(!0));const y=new RegExp(`window:${u}`),w=S.connections.find(g=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",g.ctx),y.test(g.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",k.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",k.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",k.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(S,f,l,p)}routeEvent(S,f){throw new Error(`Event not found: ${f}`)}}e.$8$b=j}),define(oe[268],ae([0,1,8,2,7,27]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rV=e.$qV=void 0;class D extends R.$Tc{constructor(){super(...arguments),this.a=new Set}open(l,p){const k=[...this.a.values()];return(0,P.$0g)(k.map(v=>()=>v.handleURL(l,p)),void 0,!1).then(v=>v||!1)}registerHandler(l){return this.a.add(l),(0,R.$Rc)(()=>this.a.delete(l))}}e.$qV=D;let S=class extends D{constructor(l){super(),this.b=l}create(l){let{authority:p,path:k,query:v,fragment:u}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&k&&k.indexOf("/")!==0&&(k=`/${k}`),s.URI.from({scheme:this.b.urlProtocol,authority:p,path:k,query:v,fragment:u})}};e.$rV=S,e.$rV=S=ve([ne(0,j.$Fj)],S)}),define(oe[269],ae([0,1,15,8,3,2,4,7]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9$b=void 0;class f extends j.$Tc{constructor(p,k,v,u,y,w){if(super(),this.c=k,this.f=w,this.a=[],this.b=0,p&&(w.trace("ElectronURLListener initialUrisToHandle:",p.map(d=>d.originalUrl)),this.a=p),D.$i){const d=u.isBuilt?[]:[`"${u.appRoot}"`];d.push("--open-url","--"),P.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,d)}const g=s.Event.map(s.Event.fromNodeEventEmitter(P.app,"open-url",(d,h)=>({event:d,url:h})),({event:d,url:h})=>(d.preventDefault(),h));this.B(g(d=>{const h=this.g(d);h&&this.c.open(h,{originalUrl:d})})),v.getWindows().filter(d=>d.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.h()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),this.B(s.Event.once(v.onDidSignalReadyWindow)(()=>this.h())))}g(p){try{return S.URI.parse(p)}catch{return}}async h(){if(this.b++>10){this.f.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.f.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const k of this.a)await this.c.open(k.uri,{originalUrl:k.originalUrl})?this.f.trace("ElectronURLListener#flush(): URL was handled",k.originalUrl):(this.f.trace("ElectronURLListener#flush(): URL was not yet handled",k.originalUrl),p.push(k));p.length!==0&&(this.a=p,(0,R.$8g)(()=>this.h(),500,this.q))}}e.$9$b=f}),define(oe[270],ae([0,1,3,2,16,58,31]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;class S extends R.$Tc{constructor(l,p,k,v,u,y){super(),this.f=l,this.g=p,this.h=k,this.j=v,this.m=u,this.n=y,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new P.$Vd),this.onDidChangeFile=this.a.event,this.b=j.$_h.forUris(()=>!(this.capabilities&1024)),this.c=new D.$Bc(w=>this.m.extUri.getComparisonKey(this.t(w))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(w=>this.s(w)))}r(){this.c.clear();for(const l of this.j.profiles)this.c.add(l.settingsResource),this.c.add(l.keybindingsResource),this.c.add(l.tasksResource),this.c.add(l.extensionsResource)}open(l,p){return this.g.open(this.t(l),p)}close(l){return this.g.close(l)}read(l,p,k,v,u){return this.g.read(l,p,k,v,u)}write(l,p,k,v,u){return this.g.write(l,p,k,v,u)}watch(l,p){this.b.set(l,l);const k=this.g.watch(this.t(l),p);return(0,R.$Rc)(()=>{this.b.delete(l),k.dispose()})}stat(l){return this.g.stat(this.t(l))}mkdir(l){return this.g.mkdir(this.t(l))}rename(l,p,k){return this.g.rename(this.t(l),this.t(p),k)}readFile(l,p){return this.g.readFile(this.t(l),p)}readFileStream(l,p,k){return this.g.readFileStream(this.t(l),p,k)}readdir(l){return this.g.readdir(this.t(l))}enforceAtomicReadFile(l){return this.c.has(l)}writeFile(l,p,k){return this.g.writeFile(this.t(l),p,k)}enforceAtomicWriteFile(l){return this.c.has(l)?{postfix:".vsctmp"}:!1}delete(l,p){return this.g.delete(this.t(l),p)}copy(l,p,k){if((0,s.$uk)(this.g))return this.g.copy(this.t(l),this.t(p),k);throw new Error("copy not supported")}cloneFile(l,p){if((0,s.$vk)(this.g))return this.g.cloneFile(this.t(l),this.t(p));throw new Error("clone not supported")}s(l){const p=[];for(const k of l){if(k.resource.scheme!==this.f)continue;const v=this.u(k.resource);this.b.findSubstr(v)&&p.push({resource:v,type:k.type,cId:k.cId})}p.length&&(this.n.debug("User data changed"),this.a.fire(p))}t(l){return l.with({scheme:this.f})}u(l){return l.with({scheme:this.h})}}e.$J_b=S}),define(oe[271],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$q_b=void 0,e.$q_b="utilityProcessWorker"}),define(oe[272],ae([0,1,6]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0$b=void 0,e.$0$b=(0,P.$6h)("webviewManagerService")}),define(oe[273],ae([0,1,15,2,13,7]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$$b=void 0;class D extends R.$Tc{static{this.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}constructor(){super();const f=this.b.bind(this);P.protocol.registerFileProtocol(s.Schemas.vscodeWebview,f)}b(f,l){try{const p=j.URI.parse(f.url),k=D.a.get(p.path);if(typeof k=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${k}`,u=s.$og.asFileUri(v);return l({path:u.fsPath,headers:{...s.COI.getHeadersFromQuery(f.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.$$$b=D}),define(oe[60],ae([0,1,4]),function(X,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WC=e.$VC=e.$UC=e.$TC=e.$SC=e.$RC=e.$QC=e.$PC=e.$OC=e.$NC=void 0,e.$NC={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function R(v){return typeof v.parentId=="number"}e.$OC=R;function s(v){return!!v.workspaceUri}e.$PC=s;function j(v){return!!v.folderUri}e.$QC=j;function D(v){return!!v.fileUri}e.$RC=D;function S(v){const u=f(v),y=v.getValue("window.menuBarVisibility");return y==="default"||u==="native"&&y==="compact"||P.$j&&P.$m?"classic":y}e.$SC=S;function f(v){if(P.$o)return"custom";const u=v.getValue("window");if(u){if(P.$j&&u.nativeTabs===!0||P.$j&&u.nativeFullScreen===!1)return"native";const g=u.titleBarStyle;if(g==="native"||g==="custom")return g}return P.$k?"native":"custom"}e.$TC=f;function l(v){return!(!P.$i||P.$o||f(v)==="native")}e.$UC=l;function p(v){const u=v.getValue("window");return!u||typeof u.nativeFullScreen!="boolean"||u.nativeTabs?!0:u.nativeFullScreen!==!1}e.$VC=p;function k(v=0){return Math.pow(1.2,v)}e.$WC=k}),define(oe[129],ae([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.$z0b=e.UnloadReason=e.LoadReason=void 0;var P;(function(S){S[S.INITIAL=1]="INITIAL",S[S.LOAD=2]="LOAD",S[S.RELOAD=3]="RELOAD"})(P||(e.LoadReason=P={}));var R;(function(S){S[S.CLOSE=1]="CLOSE",S[S.QUIT=2]="QUIT",S[S.RELOAD=3]="RELOAD",S[S.LOAD=4]="LOAD"})(R||(e.UnloadReason=R={}));const s=function(S=1){return{width:1024,height:768,mode:S}};e.$z0b=s;var j;(function(S){S[S.Maximized=0]="Maximized",S[S.Normal=1]="Normal",S[S.Minimized=2]="Minimized",S[S.Fullscreen=3]="Fullscreen"})(j||(e.WindowMode=j={}));var D;(function(S){S[S.UNRESPONSIVE=1]="UNRESPONSIVE",S[S.PROCESS_GONE=2]="PROCESS_GONE",S[S.LOAD=3]="LOAD"})(D||(e.WindowError=D={}))}),define(oe[274],ae([0,1,8,3,2]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=void 0;class j extends s.$Tc{constructor({onDidOpenMainWindow:S,onDidFocusMainWindow:f,getActiveWindowId:l}){super(),this.a=this.B(new s.$Sc),R.Event.latch(R.Event.any(S,f))(this.f,this,this.a),this.b=(0,P.$Tg)(()=>l()),(async()=>{try{const k=await this.b;this.c=typeof this.c=="number"?this.c:k}catch{}finally{this.b=void 0}})()}f(S){this.b&&(this.b.cancel(),this.b=void 0),this.c=S}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$e_b=j}),define(oe[30],ae([0,1,192,9,58,19,7,6,13]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,S.$6h)("contextService");function l(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.uri)}e.$di=l;function p(i){return typeof i?.id=="string"&&!l(i)&&!v(i)}e.$ei=p,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function k(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,R.$nc)(i)}:n?e.$fi:e.$gi;const a=i;return a.configuration?{id:a.id,configPath:a.configuration}:a.folders.length===1?{id:a.id,uri:a.folders[0].uri}:{id:a.id}}e.$hi=k;function v(i){const n=i;return typeof n?.id=="string"&&D.URI.isUri(n.configPath)}e.$ii=v;function u(i){const n=i;if(n?.uri)return{id:n.id,uri:D.URI.revive(n.uri)};const a=i;if(a?.configPath)return{id:a.id,configPath:D.URI.revive(a.configPath)};if(i?.id)return{id:i.id}}e.$ji=u;var y;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.$ki=w;function g(i){const n=i;return!!(n&&typeof n=="object"&&D.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.$li=g;class ${constructor(n,a,b,C,I){this.h=n,this.j=b,this.l=C,this.n=I,this.c=s.$_h.forUris(this.n,()=>!0),this.folders=a}update(n){this.h=n.id,this.l=n.configuration,this.j=n.transient,this.n=n.n,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.o()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.l}set configuration(n){this.l=n}getFolder(n){return n&&this.c.findSubstr(n)||null}o(){this.c=s.$_h.forUris(this.n,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=$;class d{constructor(n,a){this.raw=a,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,j.$Hg)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=d;function h(i){return new d({uri:i,index:0,name:(0,j.$Dg)(i)},{uri:i.toString()})}e.$oi=h,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,P.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function m(i,n){return j.$yg.isEqualOrParent(i,n.untitledWorkspacesHome)}e.$ti=m;function c(i){let n;return D.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===f.Schemas.tmp}e.$ui=c,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(i){return i.id===e.$vi}e.$wi=t;function o(i,n){return!m(i,n)&&!c(i)}e.$xi=o;function r(i){return(typeof i=="string"?(0,R.$oc)(i):(0,j.$Fg)(i))===e.$qi}e.$yi=r}),define(oe[55],ae([0,1,15,8,45,47,2,85,4,21,167,116,6,5,27,30]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H0b=e.$G0b=void 0,e.$G0b=(0,v.$6h)("dialogMainService");let g=class{constructor(d,h){this.d=d,this.e=h,this.a=new Map,this.b=new Map,this.c=new R.$ah}pickFileFolder(d,h){return this.f({...d,pickFolders:!0,pickFiles:!0,title:(0,p.localize)(0,null)},h)}pickFolder(d,h){return this.f({...d,pickFolders:!0,title:(0,p.localize)(1,null)},h)}pickFile(d,h){return this.f({...d,pickFiles:!0,title:(0,p.localize)(2,null)},h)}pickWorkspace(d,h){const m=(0,p.localize)(3,null),c=(0,j.$3v)((0,p.localize)(4,null)),t=w.$ri;return this.f({...d,pickFiles:!0,title:m,filters:t,buttonLabel:c},h)}async f(d,h){const m={title:d.title,buttonLabel:d.buttonLabel,filters:d.filters,defaultPath:d.defaultPath};(typeof d.pickFiles=="boolean"||typeof d.pickFolders=="boolean")&&(m.properties=void 0,d.pickFiles&&d.pickFolders&&(m.properties=["multiSelections","openDirectory","openFile","createDirectory"])),m.properties||(m.properties=["multiSelections",d.pickFolders?"openDirectory":"openFile","createDirectory"]),f.$j&&m.properties.push("treatPackageAsDirectory");const c=await this.showOpenDialog(m,(h||P.BrowserWindow.getFocusedWindow())??void 0);if(c&&c.filePaths&&c.filePaths.length>0)return c.filePaths}g(d){if(d){let h=this.b.get(d.id);return h||(h=new R.$ah,this.b.set(d.id,h)),h}else return this.c}showMessageBox(d,h){return this.g(h).queue(async()=>{const{options:m,buttonIndeces:c}=(0,k.$0v)(d,this.e);let t;return h?t=await P.dialog.showMessageBox(h,m):t=await P.dialog.showMessageBox(m),{response:c[t.response],checkboxChecked:t.checkboxChecked}})}async showSaveDialog(d,h){const m=this.j(d,h);if(!m)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(h).queue(async()=>{let c;return h?c=await P.dialog.showSaveDialog(h,d):c=await P.dialog.showSaveDialog(d),c.filePath=this.h(c.filePath),c})}finally{(0,D.$Oc)(m)}}h(d){return d&&f.$j&&(d=(0,S.$Gl)(d)),d}i(d){return d.map(h=>this.h(h))}async showOpenDialog(d,h){d.defaultPath&&(await l.Promises.exists(d.defaultPath)||(d.defaultPath=void 0));const m=this.j(d,h);if(!m)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(h).queue(async()=>{let c;return h?c=await P.dialog.showOpenDialog(h,d):c=await P.dialog.showOpenDialog(d),c.filePaths=this.i(c.filePaths),c})}finally{(0,D.$Oc)(m)}}j(d,h){if(!h)return D.$Tc.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",d);let m=this.a.get(h.id);m||(m=new Set,this.a.set(h.id,m));const c=(0,s.$Ti)(d);if(!m.has(c))return this.d.trace("[DialogMainService]: new file dialog lock created",d),m.add(c),(0,D.$Rc)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",d),m?.delete(c),m?.size===0&&this.a.delete(h.id)})}};e.$H0b=g,e.$H0b=g=ve([ne(0,u.$nj),ne(1,y.$Fj)],g)}),define(oe[275],ae([0,1,3,2,77,30]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U$b=void 0;class D extends R.$Tc{static{this.a=100}constructor(f,l){super(),this.f=f,this.g=l,this.b=this.B(new P.$Vd),this.c=new Map,this.h(l.applicationStorage,this.b)}h(f,l){this.B(P.Event.debounce(f.onDidChangeStorage,(p,k)=>(p?p.push(k):p=[k],p),D.a)(p=>{p.length&&l.fire(this.j(p,f))}))}j(f,l){const p=new Map,k=new Set;return f.forEach(v=>{const u=l.get(v.key);typeof u=="string"?p.set(v.key,u):k.add(v.key)}),{changed:Array.from(p.entries()),deleted:Array.from(k.values())}}listen(f,l,p){switch(l){case"onDidChangeStorage":{const k=p.profile?(0,s.$Ch)(p.profile):void 0;if(!k)return this.b.event;let v=this.c.get(k.id);return v||(v=this.B(new P.$Vd),this.h(this.g.profileStorage(k),v),this.c.set(k.id,v)),v.event}}throw new Error(`Event not found: ${l}`)}async call(f,l,p){const k=p.profile?(0,s.$Ch)(p.profile):void 0,v=(0,j.$ji)(p.workspace),u=await this.m(k,v);switch(l){case"getItems":return Array.from(u.items.entries());case"updateItems":{const y=p;if(y.insert)for(const[w,g]of y.insert)u.set(w,g);y.delete?.forEach(w=>u.delete(w));break}case"optimize":return u.optimize();case"isUsed":{const y=p.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async m(f,l){let p;l?p=this.g.workspaceStorage(l):f?p=this.g.profileStorage(f):p=this.g.applicationStorage;try{await p.init()}catch(k){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":f?"profile":"application"} storage due to ${k}`)}return p}}e.$U$b=D}),define(oe[41],ae([0,1,45,3,2,19,7,189,38,16,6,5,30,31,40,8,32,25,12]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.ProfileResourceType=void 0;var h;(function(i){i.Settings="settings",i.Keybindings="keybindings",i.Snippets="snippets",i.Tasks="tasks",i.Extensions="extensions",i.GlobalState="globalState"})(h||(e.ProfileResourceType=h={}));function m(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&D.URI.isUri(n.location)&&D.URI.isUri(n.globalStorageHome)&&D.URI.isUri(n.settingsResource)&&D.URI.isUri(n.keybindingsResource)&&D.URI.isUri(n.tasksResource)&&D.URI.isUri(n.snippetsHome)&&D.URI.isUri(n.extensionsResource))}e.$2k=m,e.$3k=(0,p.$6h)("IUserDataProfilesService");function c(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,icon:i.icon,location:D.URI.revive(i.location).with({scheme:n}),globalStorageHome:D.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:D.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:D.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:D.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:D.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:D.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:D.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.$4k=c;function t(i,n,a,b,C,I){return{id:i,name:n,location:a,isDefault:!1,shortName:C?.shortName,icon:C?.icon,globalStorageHome:I&&C?.useDefaultFlags?.globalState?I.globalStorageHome:(0,j.$Hg)(a,"globalStorage"),settingsResource:I&&C?.useDefaultFlags?.settings?I.settingsResource:(0,j.$Hg)(a,"settings.json"),keybindingsResource:I&&C?.useDefaultFlags?.keybindings?I.keybindingsResource:(0,j.$Hg)(a,"keybindings.json"),tasksResource:I&&C?.useDefaultFlags?.tasks?I.tasksResource:(0,j.$Hg)(a,"tasks.json"),snippetsHome:I&&C?.useDefaultFlags?.snippets?I.snippetsHome:(0,j.$Hg)(a,"snippets"),extensionsResource:I&&C?.useDefaultFlags?.extensions?I.extensionsResource:(0,j.$Hg)(a,"extensions.json"),cacheHome:(0,j.$Hg)(b,i),useDefaultFlags:C?.useDefaultFlags,isTransient:C?.transient}}e.$5k=t;let o=class extends s.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(n,a,b,C){super(),this.t=n,this.u=a,this.w=b,this.y=C,this.f=!0,this.h=this.B(new R.$Vd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new R.$Vd),this.onWillCreateProfile=this.j.event,this.m=this.B(new R.$Vd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new R.$Vd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new u.$Ac,emptyWindows:new Map},this.profilesHome=(0,j.$Hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,j.$Hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(n){this.f!==n&&(this.z=void 0,this.f=n)}isEnabled(){return this.f}get C(){if(!this.z){const n=this.D(),a=[n];if(this.f)try{for(const I of this.O()){if(!I.name||!(0,d.$If)(I.name)||!I.location){this.y.warn("Skipping the invalid stored profile",I.location||I.name);continue}a.push(t((0,j.$Eg)(I.location),I.name,I.location,this.g,{shortName:I.shortName,icon:I.icon,useDefaultFlags:I.useDefaultFlags},n))}}catch(I){this.y.error(I)}const b=new u.$Ac,C=new Map;if(a.length)try{const I=this.Q();if(I.workspaces)for(const[E,A]of Object.entries(I.workspaces)){const M=D.URI.parse(E),T=a.find(W=>W.id===A);T&&b.set(M,T)}if(I.emptyWindows)for(const[E,A]of Object.entries(I.emptyWindows)){const M=a.find(T=>T.id===A);M&&C.set(E,M)}}catch(I){this.y.error(I)}this.z={profiles:a,workspaces:b,emptyWindows:C}}return this.z}D(){const n=t("__default__profile__",(0,S.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...n,extensionsResource:this.S()??n.extensionsResource,isDefault:!0}}async createTransientProfile(n){const a="Temp",b=new RegExp(`${(0,$.$Oe)(a)}\\s(\\d+)`);let C=0;for(const E of this.profiles){const A=b.exec(E.name),M=A?parseInt(A[1]):0;C=M>C?M:C}const I=`${a} ${C+1}`;return this.createProfile((0,P.$Ti)((0,g.$qg)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,a,b){return this.createProfile((0,P.$Ti)((0,g.$qg)()).toString(16),n,a,b)}async createProfile(n,a,b,C){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.F(n,a,b);return C&&await this.setProfileForWorkspace(C,I),I}async F(n,a,b){if(!(0,d.$If)(a)||!a)throw new Error("Name of the profile is mandatory and must be of type `string`");let C=this.r.get(a);return C||(C=(async()=>{try{const I=this.profiles.find(M=>M.name===a||M.id===n);if(I)return I;const E=t(n,a,(0,j.$Hg)(this.profilesHome,n),this.g,b,this.defaultProfile);await this.u.createFolder(E.location);const A=[];return this.j.fire({profile:E,join(M){A.push(M)}}),await w.Promises.settled(A),this.I([E],[],[]),E}finally{this.r.delete(a)}})(),this.r.set(a,C)),C}async updateProfile(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let b=this.profiles.find(C=>C.id===n.id);if(!b)throw new Error(`Profile '${n.name}' does not exist`);return b=t(b.id,a.name??b.name,b.location,this.g,{shortName:a.shortName??b.shortName,icon:a.icon===null?void 0:a.icon??b.icon,transient:a.transient??b.isTransient,useDefaultFlags:a.useDefaultFlags??b.useDefaultFlags},this.defaultProfile),this.I([],[],[b]),b}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const a=this.profiles.find(C=>C.id===n.id);if(!a)throw new Error(`Profile '${n.name}' does not exist`);const b=[];this.m.fire({profile:a,join(C){b.push(C)}});try{await Promise.allSettled(b)}catch(C){this.y.error(C)}for(const C of[...this.C.emptyWindows.keys()])a.id===this.C.emptyWindows.get(C)?.id&&this.C.emptyWindows.delete(C);for(const C of[...this.C.workspaces.keys()])a.id===this.C.workspaces.get(C)?.id&&this.C.workspaces.delete(C);this.M(),this.I([],[a],[]);try{await this.u.del(a.cacheHome,{recursive:!0})}catch(C){(0,l.$Hk)(C)!==1&&this.y.error(C)}}async setProfileForWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=this.profiles.find(C=>C.id===a.id);if(!b)throw new Error(`Profile '${a.name}' does not exist`);this.L(n,b)}unsetWorkspace(n,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(n,void 0,a)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const n=await this.u.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(a=>a.isDirectory&&this.profiles.every(b=>!this.w.extUri.isEqual(b.location,a.resource))).map(a=>this.u.del(a.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.s.profiles.filter(a=>!this.H(a));await Promise.allSettled(n.map(a=>this.removeProfile(a)))}getProfileForWorkspace(n){const a=this.G(n);return D.URI.isUri(a)?this.s.workspaces.get(a)??this.C.workspaces.get(a):this.s.emptyWindows.get(a)??this.C.emptyWindows.get(a)}G(n){return(0,v.$di)(n)?n.uri:(0,v.$ii)(n)?n.configPath:n.id}H(n){return!!([...this.s.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.s.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.emptyWindows.values()].some(a=>this.w.extUri.isEqual(a.location,n.location))||[...this.C.workspaces.values()].some(a=>this.w.extUri.isEqual(a.location,n.location)))}I(n,a,b){const C=[...this.profiles,...n],I=[];this.s.profiles=[];for(let E of C)E.isDefault||a.some(A=>E.id===A.id)||(E=b.find(A=>E.id===A.id)??E,E.isTransient?this.s.profiles.push(E):I.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(I),this.z=void 0,this.J(n,a,b)}J(n,a,b){this.h.fire({added:n,removed:a,updated:b,all:this.profiles})}L(n,a,b){b=a?.isTransient?!0:b,b||this.L(n,void 0,!0);const C=this.G(n),I=b?this.s:this.C;D.URI.isUri(C)?(I.workspaces.delete(C),a&&I.workspaces.set(C,a)):(I.emptyWindows.delete(C),a&&I.emptyWindows.set(C,a)),b||this.M()}M(){const n={};for(const[b,C]of this.C.workspaces.entries())n[b.toString()]=C.id;const a={};for(const[b,C]of this.C.emptyWindows.entries())a[b.toString()]=C.id;this.R({workspaces:n,emptyWindows:a}),this.z=void 0}N(n){const a={},b=this.D();if(n.workspaces)for(const[I,E]of Object.entries(n.workspaces)){const A=D.URI.parse(E);a[I]=this.w.extUri.isEqual(A,b.location)?b.id:this.w.extUri.basename(A)}const C={};if(n.emptyWindows)for(const[I,E]of Object.entries(n.emptyWindows)){const A=D.URI.parse(E);C[I]=this.w.extUri.isEqual(A,b.location)?b.id:this.w.extUri.basename(A)}return{workspaces:a,emptyWindows:C}}O(){return[]}P(n){throw new Error("not implemented")}Q(){return{}}R(n){throw new Error("not implemented")}S(){}};e.$6k=o,e.$6k=o=ve([ne(0,f.$ai),ne(1,l.$qk),ne(2,y.$1k),ne(3,k.$nj)],o);class r extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(n){this.a=n}Q(){return this.X}R(n){this.X=n}}e.$7k=r}),define(oe[81],ae([0,1,8,17,2,3,31,7,118,124,16,6,5,41,40,12,14,28]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.ExtensionsProfileScanningErrorCode=void 0;var d;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(d||(e.ExtensionsProfileScanningErrorCode=d={}));class h extends Error{constructor(r,i){super(r),this.code=i}}e.$Up=h,e.$Vp=(0,k.$6h)("IExtensionsProfileScannerService");let m=class extends s.$Tc{constructor(r,i,n,a,b,C){super(),this.j=r,this.m=i,this.n=n,this.r=a,this.s=b,this.t=C,this.b=this.B(new j.$Vd),this.onAddExtensions=this.b.event,this.c=this.B(new j.$Vd),this.onDidAddExtensions=this.c.event,this.f=this.B(new j.$Vd),this.onRemoveExtensions=this.f.event,this.g=this.B(new j.$Vd),this.onDidRemoveExtensions=this.g.event,this.h=new D.$Ac}scanProfileExtensions(r,i){return this.u(r,void 0,i)}async addExtensionsToProfile(r,i){const n=[],a=[];try{return await this.u(i,b=>{const C=[];for(const I of b)r.some(([E])=>(0,l.$1o)(E.identifier,I.identifier)&&E.manifest.version!==I.version)?n.push(I):C.push(I);for(const[I,E]of r){const A=C.findIndex(T=>(0,l.$1o)(T.identifier,I.identifier)&&T.version===I.manifest.version),M={identifier:I.identifier,version:I.manifest.version,location:I.location,metadata:E};A===-1?(a.push(M),C.push(M)):C.splice(A,1,M)}return a.length&&this.b.fire({extensions:a,profileLocation:i}),n.length&&this.f.fire({extensions:n,profileLocation:i}),C}),a.length&&this.c.fire({extensions:a,profileLocation:i}),n.length&&this.g.fire({extensions:n,profileLocation:i}),a}catch(b){throw a.length&&this.c.fire({extensions:a,error:b,profileLocation:i}),n.length&&this.g.fire({extensions:n,error:b,profileLocation:i}),b}}async updateMetadata(r,i){const n=[];return await this.u(i,a=>{const b=[];for(const C of a){const I=r.find(([E])=>(0,l.$1o)(E.identifier,C.identifier)&&E.manifest.version===C.version);I&&(C.metadata={...C.metadata,...I[1]},n.push(C)),b.push(C)}return b}),n}async removeExtensionFromProfile(r,i){const n=[];try{await this.u(i,a=>{const b=[];for(const C of a)(0,l.$1o)(C.identifier,r.identifier)?n.push(C):b.push(C);return n.length&&this.f.fire({extensions:n,profileLocation:i}),b}),n.length&&this.g.fire({extensions:n,profileLocation:i})}catch(a){throw n.length&&this.g.fire({extensions:n,error:a,profileLocation:i}),a}}async u(r,i,n){return this.F(r).queue(async()=>{let a=[],b;try{const C=await this.m.readFile(r);b=JSON.parse(C.value.toString().trim()||"[]")}catch(C){if((0,p.$Hk)(C)!==1)throw C;if(this.r.extUri.isEqual(r,this.n.defaultProfile.extensionsResource)&&(b=await this.D()),!b&&n?.bailOutWhenFileNotFound)throw new h((0,g.$0)(C),"ERROR_PROFILE_NOT_FOUND")}if(b){Array.isArray(b)||this.w(r);let C=!1;for(const I of b){c(I)||this.w(r);let E;if((0,w.$If)(I.relativeLocation)&&I.relativeLocation)E=this.z(I.relativeLocation);else if((0,w.$If)(I.location))E=this.z(I.location),C=!0,I.relativeLocation=I.location,I.location=E.toJSON();else{E=S.URI.revive(I.location);const A=this.y(E);A&&(C=!0,I.relativeLocation=A)}a.push({identifier:I.identifier,location:E,version:I.version,metadata:I.metadata})}C&&await this.m.writeFile(r,R.$je.fromString(JSON.stringify(b)))}if(i){a=i(a);const C=a.map(I=>({identifier:I.identifier,version:I.version,location:I.location.toJSON(),relativeLocation:this.y(I.location),metadata:I.metadata}));await this.m.writeFile(r,R.$je.fromString(JSON.stringify(C)))}return a})}w(r){const i=new h(`Invalid extensions content in ${r.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}y(r){return this.r.extUri.isEqual(this.r.extUri.dirname(r),this.j)?this.r.extUri.basename(r):void 0}z(r){return this.r.extUri.joinPath(this.j,r)}async D(){return this.C||(this.C=(async()=>{const r=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),i=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let n;try{n=(await this.m.readFile(r)).value.toString()}catch(b){if((0,p.$Hk)(b)===1)return;throw b}this.t.info("Migrating extensions from old default profile location",r.toString());let a;try{const b=JSON.parse(n);Array.isArray(b)&&b.every(C=>c(C))?a=b:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",b)}catch(b){this.t.error(b)}if(a)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,R.$je.fromString(JSON.stringify(a)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",r.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(b){if((0,p.$Hk)(b)===3)this.t.info("Migration from old default profile location to new location is done by another window",r.toString(),this.n.defaultProfile.extensionsResource.toString());else throw b}try{await this.m.del(r)}catch(b){(0,p.$Hk)(b)!==1&&this.t.error(b)}try{await this.m.del(i)}catch(b){(0,p.$Hk)(b)!==1&&this.t.error(b)}return a})()),this.C}F(r){let i=this.h.get(r);return i||(i=new P.$ah,this.h.set(r,i)),i}};e.$Wp=m,e.$Wp=m=ve([ne(1,p.$qk),ne(2,u.$3k),ne(3,y.$1k),ne(4,$.$ul),ne(5,v.$nj)],m);function c(o){return(0,w.$Kf)(o)&&(0,f.$xo)(o.identifier)&&(t(o.location)||(0,w.$If)(o.location)&&o.location)&&((0,w.$Pf)(o.relativeLocation)||(0,w.$If)(o.relativeLocation))&&o.version&&(0,w.$If)(o.version)}function t(o){return o?(0,w.$If)(o.path)&&(0,w.$If)(o.scheme):!1}}),define(oe[130],ae([0,1,22,8,35,17,14,42,152,2,13,9,4,19,205,74,12,7,172,38,124,121,204,16,6,5,27,3,77,81,41,40,203]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t,o,r,i,n,a,b,C,I,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.Translations=void 0;var M;(function(ue){function Z(Y,V){if(Y===V)return!0;const L=Object.keys(Y),U=new Set;for(const H of Object.keys(V))U.add(H);if(L.length!==U.size)return!1;for(const H of L){if(Y[H]!==V[H])return!1;U.delete(H)}return U.size===0}ue.equals=Z})(M||(e.Translations=M={})),e.$Zp=(0,r.$6h)("IExtensionsScannerService");let T=class extends l.$Tc{constructor(Z,Y,V,L,U,H,q,ee,he,K,O,F){super(),this.systemExtensionsLocation=Z,this.userExtensionsLocation=Y,this.r=V,this.s=L,this.t=U,this.u=H,this.w=q,this.y=ee,this.z=he,this.C=K,this.D=O,this.F=F,this.g=this.B(new a.$Vd),this.onDidChangeCache=this.g.event,this.h=(0,u.$Hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(J,this.s,this.h)),this.m=this.B(this.F.createInstance(J,this.s,this.h)),this.n=this.B(this.F.createInstance(G,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$_o)(this.w,this.y)),this.G}async scanAllExtensions(Z,Y,V){const[L,U]=await Promise.all([this.scanSystemExtensions(Z),this.scanUserExtensions(Y)]),H=V?await this.scanExtensionsUnderDevelopment(Z,[...L,...U]):[];return this.L(L,U,H,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Z){const Y=[];Y.push(this.M(!!Z.useCache,Z.language)),Y.push(this.N(Z.language,!!Z.checkControlFile));const[V,L]=await Promise.all(Y);return this.J([...V,...L],0,Z,!1)}async scanUserExtensions(Z){const Y=Z.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Y);const V=this.D.extUri.isEqual(Z.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,L=await this.P(Y,!!Z.profileLocation,1,!Z.includeUninstalled,Z.language,!0,V),U=Z.useCache&&!L.devMode&&L.excludeObsolete?this.m:this.n;let H;try{H=await U.scanExtensions(L)}catch(q){if(q instanceof C.$Up&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),H=await U.scanExtensions(L);else throw q}return H=await this.J(H,1,Z,!0),this.y.trace("Scanned user extensions:",H.length),H}async scanExtensionsUnderDevelopment(Z,Y){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const V=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(L=>L.scheme===p.Schemas.file).map(async L=>{const U=await this.P(L,!1,1,!0,Z.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(U)).map(q=>(q.type=Y.find(ee=>(0,m.$1o)(ee.identifier,q.identifier))?.type??q.type,this.n.validate(q,U)))}))).flat();return this.J(V,"development",Z,!0)}return[]}async scanExistingExtension(Z,Y,V){const L=await this.P(Z,!1,Y,!0,V.language,!0,void 0),U=await this.n.scanExtension(L);return!U||!V.includeInvalid&&!U.isValid?null:U}async scanOneOrMultipleExtensions(Z,Y,V){const L=await this.P(Z,!1,Y,!0,V.language,!0,void 0),U=await this.n.scanOneOrMultipleExtensions(L);return this.J(U,Y,V,!0)}async scanMetadata(Z){const Y=(0,u.$Hg)(Z,"package.json"),V=(await this.w.readFile(Y)).value.toString();return JSON.parse(V).__metadata}async updateMetadata(Z,Y){const V=(0,u.$Hg)(Z,"package.json"),L=(await this.w.readFile(V)).value.toString(),U=JSON.parse(L);Y.isMachineScoped===!1&&delete Y.isMachineScoped,Y.isBuiltin===!1&&delete Y.isBuiltin,U.__metadata={...U.__metadata,...Y},await this.w.writeFile((0,u.$Hg)(Z,"package.json"),j.$je.fromString(JSON.stringify(U,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Z){if(Z instanceof C.$Up&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw Z}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Z=await this.scanUserExtensions({includeInvalid:!0});if(Z.length)await this.u.addExtensionsToProfile(Z.map(Y=>[Y,Y.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,j.$je.fromString(JSON.stringify([])))}catch(Y){(0,o.$Hk)(Y)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,D.$0)(Y))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Z){this.y.error(Z)}finally{this.H=void 0}})()),this.H}async J(Z,Y,V,L){return V.includeAllVersions||(Z=this.L(Y===0?Z:void 0,Y===1?Z:void 0,Y==="development"?Z:void 0,await this.getTargetPlatform(),L)),V.includeInvalid||(Z=Z.filter(U=>U.isValid)),Z.sort((U,H)=>{const q=k.$nc(U.location.fsPath),ee=k.$nc(H.location.fsPath);return q<ee?-1:q>ee?1:0})}L(Z,Y,V,L,U){const H=(ee,he,K)=>{if(ee.isValid&&!he.isValid)return!1;if(ee.isValid===he.isValid){if(U&&y.gt(ee.manifest.version,he.manifest.version))return this.y.debug(`Skipping extension ${he.location.path} with lower version ${he.manifest.version} in favour of ${ee.location.path} with version ${ee.manifest.version}`),!1;if(y.eq(ee.manifest.version,he.manifest.version)){if(ee.type===0)return this.y.debug(`Skipping extension ${he.location.path} in favour of system extension ${ee.location.path} with same version`),!1;if(ee.targetPlatform===L)return this.y.debug(`Skipping extension ${he.location.path} from different target platform ${he.targetPlatform}`),!1}}return K?this.y.warn(`Overwriting user extension ${ee.location.path} with ${he.location.path}.`):this.y.debug(`Overwriting user extension ${ee.location.path} with ${he.location.path}.`),!0},q=new c.$nm;return Z?.forEach(ee=>{const he=q.get(ee.identifier.id);(!he||H(he,ee,!1))&&q.set(ee.identifier.id,ee)}),Y?.forEach(ee=>{const he=q.get(ee.identifier.id);if(!he&&Z&&ee.type===0){this.y.debug(`Skipping obsolete system extension ${ee.location.path}.`);return}(!he||H(he,ee,!1))&&q.set(ee.identifier.id,ee)}),V?.forEach(ee=>{const he=q.get(ee.identifier.id);(!he||H(he,ee,!0))&&q.set(ee.identifier.id,ee),q.set(ee.identifier.id,ee)}),[...q.values()]}async M(Z,Y){this.y.trace("Started scanning system extensions");const V=await this.P(this.systemExtensionsLocation,!1,0,!0,Y,!0,void 0),U=await(Z&&!V.devMode?this.j:this.n).scanExtensions(V);return this.y.trace("Scanned system extensions:",U.length),U}async N(Z,Y){const V=this.z.isBuilt?[]:this.C.builtInExtensions;if(!V?.length)return[];this.y.trace("Started scanning dev system extensions");const L=Y?await this.O():{},U=[],H=$.URI.file(k.$hc(k.$jc(p.$og.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ee of V){const he=L[ee.name]||"marketplace";switch(he){case"disabled":break;case"marketplace":U.push((0,u.$Hg)(H,ee.name));break;default:U.push($.URI.file(he));break}}const q=await Promise.all(U.map(async ee=>this.n.scanExtension(await this.P(ee,!1,0,!0,Z,!0,void 0))));return this.y.trace("Scanned dev system extensions:",q.length),(0,P.$Hb)(q)}async O(){try{const Z=await this.w.readFile(this.r);return JSON.parse(Z.value.toString())}catch{return{}}}async P(Z,Y,V,L,U,H,q){const ee=await this.f(U??v.$w),he=await this.Q(Z),K=Y&&!this.D.extUri.isEqual(Z,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,O=K?await this.Q(K):void 0;return new W(Z,he,K,O,Y,q,V,L,H,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,U,ee)}async Q(Z){try{const Y=await this.w.stat(Z);if(typeof Y.mtime=="number")return Y.mtime}catch{}}};e.$1p=T,e.$1p=T=ve([ne(4,I.$3k),ne(5,C.$Vp),ne(6,o.$qk),ne(7,i.$nj),ne(8,h.$ai),ne(9,n.$Fj),ne(10,E.$1k),ne(11,r.$5h)],T);class W{constructor(Z,Y,V,L,U,H,q,ee,he,K,O,F,_,z,x){this.location=Z,this.mtime=Y,this.applicationExtensionslocation=V,this.applicationExtensionslocationMtime=L,this.profile=U,this.profileScanOptions=H,this.type=q,this.excludeObsolete=ee,this.validate=he,this.productVersion=K,this.productDate=O,this.productCommit=F,this.devMode=_,this.language=z,this.translations=x}static createNlsConfiguration(Z){return{language:Z.language,pseudo:Z.language==="pseudo",devMode:Z.devMode,translations:Z.translations}}static equals(Z,Y){return(0,u.$Ag)(Z.location,Y.location)&&Z.mtime===Y.mtime&&(0,u.$Ag)(Z.applicationExtensionslocation,Y.applicationExtensionslocation)&&Z.applicationExtensionslocationMtime===Y.applicationExtensionslocationMtime&&Z.profile===Y.profile&&s.$zn(Z.profileScanOptions,Y.profileScanOptions)&&Z.type===Y.type&&Z.excludeObsolete===Y.excludeObsolete&&Z.validate===Y.validate&&Z.productVersion===Y.productVersion&&Z.productDate===Y.productDate&&Z.productCommit===Y.productCommit&&Z.devMode===Y.devMode&&Z.language===Y.language&&M.equals(Z.translations,Y.translations)}}e.$2p=W;let G=class extends l.$Tc{constructor(Z,Y,V,L,U){super(),this.f=Z,this.g=Y,this.h=V,this.j=L,this.m=U}async scanExtensions(Z){const Y=Z.profile?await this.r(Z):await this.n(Z);let V={};if(Z.excludeObsolete&&Z.type===1)try{const L=(await this.j.readFile(this.f)).value.toString();V=JSON.parse(L)}catch{}return(0,g.$Vf)(V)?Y:Y.filter(L=>!V[m.$2o.create(L).toString()])}async n(Z){const Y=await this.j.resolve(Z.location);if(!Y.children?.length)return[];const V=await Promise.all(Y.children.map(async L=>{if(!L.isDirectory||Z.type===1&&(0,u.$Eg)(L.resource).indexOf(".")===0)return null;const U=new W(L.resource,Z.mtime,Z.applicationExtensionslocation,Z.applicationExtensionslocationMtime,Z.profile,Z.profileScanOptions,Z.type,Z.excludeObsolete,Z.validate,Z.productVersion,Z.productDate,Z.productCommit,Z.devMode,Z.language,Z.translations);return this.scanExtension(U)}));return(0,P.$Hb)(V).sort((L,U)=>L.location.path<U.location.path?-1:1)}async r(Z){let Y=await this.s(Z.location,()=>!0,Z);if(Z.applicationExtensionslocation&&!this.h.extUri.isEqual(Z.location,Z.applicationExtensionslocation)){Y=Y.filter(L=>!L.metadata?.isApplicationScoped);const V=await this.s(Z.applicationExtensionslocation,L=>!!L.metadata?.isBuiltin||!!L.metadata?.isApplicationScoped,Z);Y.push(...V)}return Y}async s(Z,Y,V){const L=await this.g.scanProfileExtensions(Z,V.profileScanOptions);if(!L.length)return[];const U=await Promise.all(L.map(async H=>{if(Y(H)){const q=new W(H.location,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(q,H.metadata)}return null}));return(0,P.$Hb)(U)}async scanOneOrMultipleExtensions(Z){try{if(await this.j.exists((0,u.$Hg)(Z.location,"package.json"))){const Y=await this.scanExtension(Z);return Y?[Y]:[]}else return await this.scanExtensions(Z)}catch(Y){return this.m.error(`Error scanning extensions at ${Z.location.path}:`,(0,D.$0)(Y)),[]}}async scanExtension(Z,Y){try{let V=await this.scanExtensionManifest(Z.location);if(V){V.publisher||(V.publisher=c.$hm),Y=Y??V.__metadata,delete V.__metadata;const L=(0,m.$6o)(V.publisher,V.name),U=Y?.id?{id:L,uuid:Y.id}:{id:L},H=Y?.isSystem?0:Z.type,q=H===0||!!Y?.isBuiltin;V=await this.t(Z.location,V,W.createNlsConfiguration(Z));const ee={type:H,identifier:U,manifest:V,location:Z.location,isBuiltin:q,targetPlatform:Y?.targetPlatform??"undefined",metadata:Y,isValid:!0,validations:[]};return Z.validate?this.validate(ee,Z):ee}}catch(V){Z.type!==0&&this.m.error(V)}return null}validate(Z,Y){let V=!0;const L=(0,t.$ep)(Y.productVersion,Y.productDate,Y.location,Z.manifest,Z.isBuiltin);for(const[U,H]of L)U===w.default.Error&&(V=!1,this.m.error(this.z(Y.location,H)));return Z.isValid=V,Z.validations=L,Z}async scanExtensionManifest(Z){const Y=(0,u.$Hg)(Z,"package.json");let V;try{V=(await this.j.readFile(Y)).value.toString()}catch(U){return(0,o.$Hk)(U)!==1&&this.m.error(this.z(Z,(0,d.localize)(0,null,Y.path,U.message))),null}let L;try{L=JSON.parse(V)}catch{const H=[];(0,S.$cn)(V,H);for(const q of H)this.m.error(this.z(Z,(0,d.localize)(1,null,Y.path,q.offset,q.length,(0,f.$Xp)(q.error))));return null}return(0,S.$ln)(L)!=="object"?(this.m.error(this.z(Z,(0,d.localize)(2,null,Y.path))),null):L}async t(Z,Y,V){const L=await this.u(Z,Y,V);if(L)try{const U=[],H=await this.w(L.default,U);if(U.length>0)return U.forEach(ee=>{this.m.error(this.z(Z,(0,d.localize)(3,null,L.default?.path,(0,f.$Xp)(ee.error))))}),Y;if((0,S.$ln)(L)!=="object")return this.m.error(this.z(Z,(0,d.localize)(4,null,L.default?.path))),Y;const q=L.values||Object.create(null);return(0,A.$Yp)(this.m,Y,q,H)}catch{}return Y}async u(Z,Y,V){const L=(0,u.$Hg)(Z,"package.nls.json"),U=(he,K)=>{K.forEach(O=>{this.m.error(this.z(Z,(0,d.localize)(5,null,he?.path,(0,f.$Xp)(O.error))))})},H=he=>{this.m.error(this.z(Z,(0,d.localize)(6,null,he?.path)))},q=`${Y.publisher}.${Y.name}`,ee=V.translations[q];if(ee)try{const he=$.URI.file(ee),K=(await this.j.readFile(he)).value.toString(),O=[],F=(0,S.$cn)(K,O);return O.length>0?(U(he,O),{values:void 0,default:L}):(0,S.$ln)(F)!=="object"?(H(he),{values:void 0,default:L}):{values:F.contents?F.contents.package:void 0,default:L}}catch{return{values:void 0,default:L}}else{if(!await this.j.exists(L))return;let K;try{K=await this.y(Z,V)}catch{return}if(!K.localized)return{values:void 0,default:K.original};try{const O=(await this.j.readFile(K.localized)).value.toString(),F=[],_=(0,S.$cn)(O,F);return F.length>0?(U(K.localized,F),{values:void 0,default:K.original}):(0,S.$ln)(_)!=="object"?(H(K.localized),{values:void 0,default:K.original}):{values:_,default:K.original}}catch{return{values:void 0,default:K.original}}}}async w(Z,Y){if(Z)try{const V=(await this.j.readFile(Z)).value.toString();return(0,S.$cn)(V,Y)}catch{}}y(Z,Y){return new Promise((V,L)=>{const U=H=>{const q=(0,u.$Hg)(Z,`package.nls.${H}.json`);this.j.exists(q).then(ee=>{ee&&V({localized:q,original:(0,u.$Hg)(Z,"package.nls.json")});const he=H.lastIndexOf("-");he===-1?V({localized:(0,u.$Hg)(Z,"package.nls.json"),original:null}):(H=H.substring(0,he),U(H))})};if(Y.devMode||Y.pseudo||!Y.language)return V({localized:(0,u.$Hg)(Z,"package.nls.json"),original:null});U(Y.language)})}z(Z,Y){return`[${Z.path}]: ${Y}`}};G=ve([ne(1,C.$Vp),ne(2,E.$1k),ne(3,o.$qk),ne(4,i.$nj)],G);let J=class extends G{constructor(Z,Y,V,L,U,H,q){super(Y,L,U,H,q),this.G=Z,this.H=V,this.D=this.B(new R.$4g(3e3)),this.F=this.B(new a.$Vd),this.onDidChangeCache=this.F.event}async scanExtensions(Z){const Y=this.M(Z),V=await this.I(Y);if(this.C=Z,V&&V.input&&W.equals(V.input,this.C))return this.m.debug("Using cached extensions scan result",Z.location.toString()),this.D.trigger(()=>this.L()),V.result.map(U=>(U.location=$.URI.revive(U.location),U));const L=await super.scanExtensions(Z);return await this.J(Y,{input:Z,result:L}),L}async I(Z){try{const Y=await this.j.readFile(Z),V=JSON.parse(Y.value.toString());return{result:V.result,input:(0,b.$Ch)(V.input)}}catch(Y){this.m.debug("Error while reading the extension cache file:",Z.path,(0,D.$0)(Y))}return null}async J(Z,Y){try{await this.j.writeFile(Z,j.$je.fromString(JSON.stringify(Y)))}catch(V){this.m.debug("Error while writing the extension cache file:",Z.path,(0,D.$0)(V))}}async L(){if(!this.C)return;const Z=this.M(this.C),Y=await this.I(Z);if(!Y)return;const V=Y.result,L=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!s.$zn(L,V))try{this.m.info("Invalidating Cache",V,L),await this.j.del(Z),this.F.fire()}catch(U){this.m.error(U)}}M(Z){const Y=this.N(Z);return this.h.extUri.joinPath(Y.cacheHome,Z.type===0?c.$gm:c.$fm)}N(Z){return Z.type===0?this.H.defaultProfile:Z.profile?this.h.extUri.isEqual(Z.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Y=>this.h.extUri.isEqual(Z.location,Y.extensionsResource))??this.G:this.H.defaultProfile}};J=ve([ne(2,I.$3k),ne(3,C.$Vp),ne(4,E.$1k),ne(5,o.$qk),ne(6,i.$nj)],J);function ce(ue,Z){const Y=(0,m.$4o)(ue.manifest.publisher,ue.manifest.name);return{id:Y,identifier:new c.$lm(Y),isBuiltin:ue.type===0,isUserBuiltin:ue.type===1&&ue.isBuiltin,isUnderDevelopment:Z,extensionLocation:ue.location,uuid:ue.identifier.uuid,targetPlatform:ue.targetPlatform,...ue.manifest}}e.$3p=ce;class re extends T{constructor(Z,Y,V,L,U,H,q,ee,he,K,O,F){super(Z,Y,(0,u.$Hg)(V,".vscode-oss-dev","extensions","control.json"),L,U,H,q,ee,he,K,O,F),this.R=(async()=>{if(v.$z)try{const _=await this.w.readFile($.URI.file(v.$z));return JSON.parse(_.value.toString())}catch{}return Object.create(null)})()}f(Z){return this.R}}e.$4p=re}),define(oe[276],ae([0,1,5,41,40,28,81,16,38,7]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;let p=class extends D.$Wp{constructor(v,u,y,w,g,$){super(l.URI.file(v.extensionsPath),u,y,w,g,$)}};e.$BO=p,e.$BO=p=ve([ne(0,f.$bi),ne(1,S.$qk),ne(2,R.$3k),ne(3,s.$1k),ne(4,j.$ul),ne(5,P.$nj)],p)}),define(oe[277],ae([0,1,7,38,81,130,16,6,5,27,40,41]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=void 0;let v=class extends j.$4p{constructor(y,w,g,$,d,h,m,c){super(P.URI.file(d.builtinExtensionsPath),P.URI.file(d.extensionsPath),d.userHome,y.defaultProfile,y,w,g,$,d,h,m,c)}};e.$i_b=v,e.$i_b=v=ve([ne(0,k.$3k),ne(1,s.$Vp),ne(2,D.$qk),ne(3,f.$nj),ne(4,R.$bi),ne(5,l.$Fj),ne(6,p.$1k),ne(7,S.$5h)],v)}),define(oe[278],ae([0,1,15,2,13,9,4,58,7,32,37,38,5,41]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A_b=void 0;let y=class extends R.$Tc{constructor(g,$,d){super(),this.c=g,this.f=d,this.a=S.$_h.forPaths(!D.$k),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(g.appRoot),this.addValidFileRoot(g.extensionsPath),this.addValidFileRoot($.defaultProfile.globalStorageHome.with({scheme:s.Schemas.file}).fsPath),this.addValidFileRoot(g.workspaceStorageHome.with({scheme:s.Schemas.file}).fsPath),this.g()}g(){const{defaultSession:g}=P.session;g.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,($,d)=>this.j($,d)),g.protocol.interceptFileProtocol(s.Schemas.file,($,d)=>this.h($,d)),this.B((0,R.$Rc)(()=>{g.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),g.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(g){const $=(0,j.$hc)(g);return this.a.get($)?R.$Tc.None:(this.a.set($,!0),(0,R.$Rc)(()=>this.a.delete($)))}h(g,$){const d=f.URI.parse(g.url);return this.f.error(`Refused to load resource ${d.fsPath} from ${s.Schemas.file}: protocol (original URL: ${g.url})`),$({error:-3})}j(g,$){const d=this.m(g);let h;return this.c.crossOriginIsolated&&((0,j.$nc)(d)==="workbench.html"||(0,j.$nc)(d)==="workbench-dev.html"?h=s.COI.CoopAndCoep:h=s.COI.getHeadersFromQuery(g.url)),this.a.findSubstr(d)?$({path:d,headers:h}):this.b.has((0,j.$oc)(d).toLowerCase())?$({path:d}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${d} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${g.url})`),$({error:-3}))}m(g){const $=f.URI.parse(g.url),d=s.$og.uriToFileUri($);return(0,j.$hc)(d.fsPath)}createIPCObjectUrl(){let g;const $=f.URI.from({scheme:"vscode",path:(0,l.$qg)()}),d=$.toString(),h=async()=>g;return p.$AU.handle(d,h),this.f.trace(`IPC Object URL: Registered new channel ${d}.`),{resource:$,update:m=>g=m,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${d}.`),p.$AU.removeHandler(d)}}}};e.$A_b=y,e.$A_b=y=ve([ne(0,k.$bi),ne(1,u.$3k),ne(2,v.$nj)],y)}),define(oe[96],ae([0,1,8,3,2,68,12,112,6,41]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$up=e.$tp=e.$sp=void 0,e.$sp="__$__isNewStorageMarker",e.$tp="__$__targetStorageMarker",e.$up=(0,f.$6h)("storageService");var p;(function(d){d[d.NONE=0]="NONE",d[d.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var k;(function(d){d[d.APPLICATION=-1]="APPLICATION",d[d.PROFILE=0]="PROFILE",d[d.WORKSPACE=1]="WORKSPACE"})(k||(e.StorageScope=k={}));var v;(function(d){d[d.USER=0]="USER",d[d.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function u(d){const h=d.get(e.$tp);if(h)try{return JSON.parse(h)}catch{}return Object.create(null)}e.$vp=u;class y extends s.$Tc{static{this.a=60*1e3}constructor(h={flushInterval:y.a}){super(),this.m=h,this.b=this.B(new R.$Yd),this.c=this.B(new R.$Yd),this.onDidChangeTarget=this.c.event,this.f=this.B(new R.$Vd),this.onWillSaveState=this.f.event,this.h=this.B(new P.$fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new s.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(h,m,c){return R.Event.filter(this.b.event,t=>t.scope===h&&(m===void 0||t.key===m),c)}n(){this.j.value=(0,P.$jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,s.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,j.mark)("code/willInitStorage");try{await this.O()}finally{(0,j.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(h,m){const{key:c,external:t}=m;if(c===e.$tp){switch(h){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:h})}else this.b.fire({scope:h,key:c,target:this.J(h)[c],external:t})}w(h){this.f.fire({reason:h})}get(h,m,c){return this.P(m)?.get(h,c)}getBoolean(h,m,c){return this.P(m)?.getBoolean(h,c)}getNumber(h,m,c){return this.P(m)?.getNumber(h,c)}getObject(h,m,c){return this.P(m)?.getObject(h,c)}storeAll(h,m){this.y(()=>{for(const c of h)this.store(c.key,c.value,c.scope,c.target,m)})}store(h,m,c,t,o=!1){if((0,D.$Rf)(m)){this.remove(h,c,o);return}this.y(()=>{this.z(h,c,t),this.P(c)?.set(h,m,o)})}remove(h,m,c=!1){this.y(()=>{this.z(h,m,void 0),this.P(m)?.delete(h,c)})}y(h){this.b.pause(),this.c.pause();try{h()}finally{this.b.resume(),this.c.resume()}}keys(h,m){const c=[],t=this.J(h);for(const o of Object.keys(t))t[o]===m&&c.push(o);return c}z(h,m,c,t=!1){const o=this.J(m);typeof c=="number"?o[h]!==c&&(o[h]=c,this.P(m)?.set(e.$tp,JSON.stringify(o),t)):typeof o[h]=="number"&&(delete o[h],this.P(m)?.set(e.$tp,JSON.stringify(o),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(h){switch(h){case-1:return this.I;case 0:return this.G;default:return this.D}}L(h){const m=this.P(h);return m?u(m):Object.create(null)}isNew(h){return this.getBoolean(e.$sp,h)===!0}async flush(h=p.NONE){this.f.fire({reason:h});const m=this.P(-1),c=this.P(0),t=this.P(1);switch(h){case p.NONE:await P.Promises.settled([m?.whenFlushed()??Promise.resolve(),c?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await P.Promises.settled([m?.flush(0)??Promise.resolve(),c?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const h=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,c=this.P(1)?.items??new Map;return $(h,m,c,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(h){return await this.flush(),this.P(h)?.optimize()}async switch(h,m){return this.w(p.NONE),(0,l.$2k)(h)?this.R(h,m):this.S(h,m)}M(h,m){return!(h.id===m.id||w(m)&&w(h))}N(h,m,c){this.y(()=>{const t=new Set;for(const[o,r]of h)t.add(o),m.get(o)!==r&&this.u(c,{key:o,external:!0});for(const[o]of m.items)t.has(o)||this.u(c,{key:o,external:!0})})}}e.$wp=y;function w(d){return d.isDefault||!!d.useDefaultFlags?.globalState}e.$xp=w;class g extends y{constructor(){super(),this.U=this.B(new S.$qp(new S.$rp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new S.$qp(new S.$rp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new S.$qp(new S.$rp,{hint:S.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(h=>this.u(1,h))),this.B(this.W.onDidChangeStorage(h=>this.u(0,h))),this.B(this.U.onDidChangeStorage(h=>this.u(-1,h)))}P(h){switch(h){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(h){switch(h){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(h){return!1}}e.$yp=g;async function $(d,h,m,c,t,o){const r=M=>{try{return JSON.parse(M)}catch{return M}},i=new Map,n=new Map;d.forEach((M,T)=>{i.set(T,M),n.set(T,r(M))});const a=new Map,b=new Map;h.forEach((M,T)=>{a.set(T,M),b.set(T,r(M))});const C=new Map,I=new Map;m.forEach((M,T)=>{C.set(T,M),I.set(T,r(M))}),console.group(c!==t?`Storage: Application (path: ${c})`:`Storage: Application & Profile (path: ${c}, default profile)`);const E=[];if(i.forEach((M,T)=>{E.push({key:T,value:M})}),console.table(E),console.groupEnd(),console.log(n),c!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const M=[];a.forEach((T,W)=>{M.push({key:W,value:T})}),console.table(M),console.groupEnd(),console.log(b)}console.group(`Storage: Workspace (path: ${o})`);const A=[];C.forEach((M,T)=>{A.push({key:T,value:M})}),console.table(A),console.groupEnd(),console.log(I)}e.$zp=$}),define(oe[279],ae([0,1,22,8,3,2,9,73,7,21,112,161,5,96,28,30,13]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a$b=e.$_0b=e.$$0b=e.$00b=void 0;class $ extends j.$Tc{static{this.a=2e3}get storage(){return this.f}constructor(r,i){super(),this.m=r,this.n=i,this.b=this.B(new s.$Vd),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.$Vd),this.onDidCloseStorage=this.c.event,this.f=this.B(new p.$qp(new p.$rp,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.g=void 0,this.h=new R.$qh,this.whenInit=this.h.p,this.j=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.j===p.StorageState.None)try{const r=this.B(await this.t());this.f.dispose(),this.f=r,this.B(r.onDidChangeStorage(n=>this.b.fire(n))),await this.s(r);const i=r.getBoolean(u.$sp);i===void 0?r.set(u.$sp,!0):i&&r.set(u.$sp,!1)}catch(r){this.m.error(`[storage main] initialize(): Unable to init storage due to ${r}`)}finally{this.j=p.StorageState.Initialized,this.h.complete()}})()),this.g}r(){return{logTrace:this.m.getLevel()===v.LogLevel.Trace?r=>this.m.trace(r):void 0,logError:r=>this.m.error(r)}}s(r){return r.init()}get items(){return this.f.items}get(r,i){return this.f.get(r,i)}set(r,i){return this.f.set(r,i)}delete(r){return this.f.delete(r)}optimize(){return this.f.optimize()}async close(){const r=new S.$Rd(!1);await this.w(),r.stop(),r.elapsed()>$.a&&await this.u(r),this.c.fire()}async u(r){if(this.path)try{const i=(0,P.top)(Array.from(this.f.items.entries()).map(([a,b])=>({key:a,length:b.length})),(a,b)=>b.length-a.length,5).map(a=>`${a.key}:${a.length}`).join(", "),n=(await this.n.stat(f.URI.file(this.path))).size;this.m.warn(`[storage main] detected slow close() operation: Time: ${r.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.m.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async w(){this.g&&await this.g,this.j=p.StorageState.Closed,await this.f.close()}}class d extends ${static{this.y="state.vscdb"}get path(){if(!this.C.useInMemoryStorage)return(0,D.$jc)(this.z.globalStorageHome.with({scheme:g.Schemas.file}).fsPath,d.y)}constructor(r,i,n,a){super(n,a),this.z=r,this.C=i}async t(){return new p.$qp(new k.$6U(this.path??k.$6U.IN_MEMORY_PATH,{logging:this.r()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}class h extends d{constructor(r,i,n,a){super(r,i,n,a)}}e.$00b=h;class m extends d{constructor(r,i,n,a){super(i.defaultProfile,r,n,a)}async s(r){await super.s(r),this.G(r)}G(r){r.get(y.$xl,void 0)===void 0&&r.set(y.$xl,new Date().toUTCString());const n=r.get(y.$wl,void 0),a=new Date().toUTCString();r.set(y.$yl,typeof n>"u"?null:n),r.set(y.$wl,a)}}e.$$0b=m;class c extends ${static{this.y="state.vscdb"}static{this.z="workspace.json"}get path(){if(!this.D.useInMemoryStorage)return(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.C.id,c.y)}constructor(r,i,n,a,b){super(n,b),this.C=r,this.D=i,this.F=a}async t(){const{storageFilePath:r,wasCreated:i}=await this.H();return new p.$qp(new k.$6U(r,{logging:this.r()}),{hint:this.D.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async H(){if(this.D.useInMemoryStorage)return{storageFilePath:k.$6U.IN_MEMORY_PATH,wasCreated:!0};const r=(0,D.$jc)(this.F.workspaceStorageHome.with({scheme:g.Schemas.file}).fsPath,this.C.id),i=(0,D.$jc)(r,c.y);return await l.Promises.exists(r)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(r,{recursive:!0}),this.I(r),{storageFilePath:i,wasCreated:!0})}async I(r){let i;if((0,w.$di)(this.C)?i={folder:this.C.uri.toString()}:(0,w.$ii)(this.C)&&(i={workspace:this.C.configPath.toString()}),i)try{const n=(0,D.$jc)(r,c.z);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.m.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.$_0b=c;class t extends ${get path(){}async t(){return new p.$qp(new p.$rp,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.$a$b=t}),define(oe[280],ae([0,1,3,2,96]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$k_b=void 0;class j extends R.$Tc{constructor(S,f,l){super(),this.b=S,this.c=f,this.f=l;const p=this.B(new R.$Uc);this.a=this.B(new P.$Vd({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const S=new R.$Sc;return S.add(P.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(f,l)=>(f?f.push(l.key):f=[l.key],f),100)(f=>this.h(f))),S.add(P.Event.debounce(this.b.onDidChangeProfileStorage,(f,l)=>{f||(f=new Map);let p=f.get(l.profile.id);return p||f.set(l.profile.id,p={profile:l.profile,keys:[],storage:l.storage}),p.keys.push(l.key),f},100)(f=>this.j(f))),S}h(S){const f=S.includes(s.$tp)?[this.c.defaultProfile]:[],l=[];if(S=S.filter(p=>p!==s.$tp),S.length){const p=(0,s.$vp)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:S.map(k=>({key:k,scope:0,target:p[k]}))})}this.m(f,l)}j(S){const f=[],l=new Map;for(const[p,k]of S.entries()){k.keys.includes(s.$tp)&&f.push(k.profile);const v=k.keys.filter(u=>u!==s.$tp);if(v.length){const u=(0,s.$vp)(k.storage.storage);l.set(p,{profile:k.profile,changes:v.map(y=>({key:y,scope:0,target:u[y]}))})}}this.m(f,[...l.values()])}m(S,f){(S.length||f.length)&&this.a.fire({valueChanges:f,targetChanges:S})}listen(S,f,l){switch(f){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${f}`)}async call(S,f){throw new Error(`Call not found: ${f}`)}}e.$k_b=j}),define(oe[281],ae([0,1,7,38,16,5,34,40,41,12,122]),function(X,e,P,R,s,j,D,S,f,l,p){"use strict";var k,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=e.$yO=void 0;let u=class extends f.$6k{static{k=this}static{this.a="profileAssociationsMigration"}constructor($,d,h,m,c){super(h,m,d,c),this.U=$,this.W=h}O(){return this.U.getItem(k.b,[]).map(d=>({...d,location:(0,l.$If)(d.location)?this.w.extUri.joinPath(this.profilesHome,d.location):P.URI.revive(d.location)}))}Q(){const $=this.U.getItem(k.c,{});return this.U.getItem(k.a,!1)?$:this.N($)}S(){return this.w.extUri.joinPath(P.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$yO=u,e.$yO=u=k=ve([ne(0,D.$tO),ne(1,S.$1k),ne(2,R.$bi),ne(3,s.$qk),ne(4,j.$nj)],u);let y=v=class extends u{constructor($,d,h,m,c){super($,d,h,m,c),this.$=$}P($){$.length?this.$.setItem(v.b,$.map(d=>({...d,location:this.w.extUri.basename(d.location)}))):this.$.removeItem(v.b)}O(){const $=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P($),this.$.setItem("userDataProfilesMigration",!0)),$}R($){$.emptyWindows||$.workspaces?this.$.setItem(v.c,$):this.$.removeItem(v.c)}Q(){const $="workspaceAndProfileInfo",d=this.$.getItem($,void 0);if(d){this.$.removeItem($);const m=d.reduce((c,{workspace:t,profile:o})=>(c[P.URI.revive(t).toString()]=P.URI.revive(o).toString(),c),{});this.$.setItem(v.c,{workspaces:m})}const h=super.Q();return this.$.getItem(v.a,!1)||(this.R(h),this.$.setItem(v.a,!0)),h}};e.$zO=y,e.$zO=y=v=ve([ne(0,D.$uO),ne(1,S.$1k),ne(2,R.$bi),ne(3,s.$qk),ne(4,j.$nj)],y);let w=class extends y{constructor($,d,h,m){super(new p.$xO(0,d,m,h),$,d,h,m)}async init(){return await this.$.init(),super.init()}};e.$AO=w,e.$AO=w=ve([ne(0,S.$1k),ne(1,R.$bi),ne(2,s.$qk),ne(3,j.$nj)],w)}),define(oe[56],ae([0,1,38,16,6,5,40,41,281,34]),function(X,e,P,R,s,j,D,S,f,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S0b=e.$R0b=void 0,e.$R0b=(0,s.$7h)(S.$3k);let p=class extends f.$zO{constructor(v,u,y,w,g){super(v,u,y,w,g)}getAssociatedEmptyWindows(){const v=[];for(const u of this.C.emptyWindows.keys())v.push({id:u});return v}};e.$S0b=p,e.$S0b=p=ve([ne(0,l.$uO),ne(1,D.$1k),ne(2,P.$bi),ne(3,R.$qk),ne(4,j.$nj)],p)}),define(oe[131],ae([0,1,19,7,30]),function(X,e,P,R,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V0b=e.$U0b=e.$T0b=void 0;async function j(f,l,p){for(const v of f){const u=v.openedWorkspace;if((0,s.$ii)(u)){const y=await p(u);if(y){if(y.folders.some(w=>P.$yg.isEqualOrParent(l,w.uri)))return v}else if(P.$yg.isEqualOrParent(l,u.configPath))return v}}const k=f.filter(v=>(0,s.$di)(v.openedWorkspace)&&P.$yg.isEqualOrParent(l,v.openedWorkspace.uri));if(k.length)return k.sort((v,u)=>-(v.openedWorkspace.uri.path.length-u.openedWorkspace.uri.path.length))[0]}e.$T0b=j;function D(f,l){for(const p of f)if((0,s.$ii)(p.openedWorkspace)&&P.$yg.isEqual(p.openedWorkspace.configPath,l)||(0,s.$di)(p.openedWorkspace)&&P.$yg.isEqual(p.openedWorkspace.uri,l))return p}e.$U0b=D;function S(f,l){const p=k=>l.some(v=>P.$yg.isEqual(R.URI.file(v),R.URI.file(k)));for(const k of f)if(k.config?.extensionDevelopmentPath?.some(v=>p(v)))return k}e.$V0b=S}),define(oe[97],ae([0,1,33,42,101,47,13,9,4,19,7,6,59,30]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mcb=e.$Lcb=e.$Kcb=e.$Jcb=e.$Icb=e.$Hcb=e.$Gcb=e.$Fcb=e.$Ecb=e.$Dcb=void 0,e.$Dcb=(0,k.$6h)("workspacesService");function y(I){return I.hasOwnProperty("workspace")}e.$Ecb=y;function w(I){return I.hasOwnProperty("folderUri")}e.$Fcb=w;function g(I){return I.hasOwnProperty("fileUri")}e.$Gcb=g;function $(I){return d(I)||h(I)}e.$Hcb=$;function d(I){const E=I;return typeof E?.path=="string"&&(!E.name||typeof E.name=="string")}function h(I){const E=I;return typeof E?.uri=="string"&&(!E.name||typeof E.name=="string")}function m(I,E,A,M,T){if(I.scheme!==M.scheme)return{name:A,uri:I.toString(!0)};let W=E?void 0:T.relativePath(M,I);if(W!==void 0)W.length===0?W=".":f.$i&&(W=c(W));else if(I.scheme===D.Schemas.file)W=I.fsPath,f.$i&&(W=c(W));else if(T.isEqualAuthority(I.authority,M.authority))W=I.path;else return{name:A,uri:I.toString(!0)};return{name:A,path:W}}e.$Icb=m;function c(I){return I=(0,j.$Wv)(I),(0,P.$5f)(I)||(I=(0,P.$2f)(I)),I}function t(I,E,A){const M=[],T=new Set,W=A.dirname(E);for(const G of I){let J;if(d(G))G.path&&(J=A.resolvePath(W,G.path));else if(h(G))try{J=p.URI.parse(G.uri),J.path[0]!==S.$gc.sep&&(J=J.with({path:S.$gc.sep+J.path}))}catch(ce){console.warn(ce)}if(J){const ce=A.getComparisonKey(J);if(!T.has(ce)){T.add(ce);const re=G.name||A.basenameOrAuthority(J);M.push(new u.$ni({uri:J,name:re,index:M.length},G))}}}return M}e.$Jcb=t;function o(I,E,A,M,T){const W=r(E,I),G=T.dirname(E),J=T.dirname(M),ce=[];for(const Y of W.folders){const V=d(Y)?T.resolvePath(G,Y.path):p.URI.parse(Y.uri);let L;A?L=!1:L=!d(Y)||(0,S.$ic)(Y.path),ce.push(m(V,L,Y.name,J,T))}const re={insertSpaces:!1,tabSize:4,eol:f.$k||f.$j?`
`:`\r
`},ue=s.$rn(I,["folders"],ce,re);let Z=s.$un(I,ue);return(0,l.$Mg)(W.remoteAuthority,(0,v.$al)(M))&&(Z=s.$un(Z,s.$qn(Z,["remoteAuthority"],re))),Z}e.$Kcb=o;function r(I,E){const A=R.$cn(E);if(A&&Array.isArray(A.folders))A.folders=A.folders.filter(M=>$(M));else throw new Error(`${I} looks like an invalid workspace file.`);return A}function i(I){return I.workspace&&typeof I.workspace=="object"&&typeof I.workspace.id=="string"&&typeof I.workspace.configPath=="string"}function n(I){return typeof I.folderUri=="string"}function a(I){return typeof I.fileUri=="string"}function b(I,E){const A={workspaces:[],files:[]};if(I){const M=function(W,G){for(let J=0;J<W.length;J++)try{G(W[J],J)}catch(ce){E.warn(`Error restoring recent entry ${JSON.stringify(W[J])}: ${ce.toString()}. Skip entry.`)}},T=I;Array.isArray(T.entries)&&M(T.entries,W=>{const G=W.label,J=W.remoteAuthority;i(W)?A.workspaces.push({label:G,remoteAuthority:J,workspace:{id:W.workspace.id,configPath:p.URI.parse(W.workspace.configPath)}}):n(W)?A.workspaces.push({label:G,remoteAuthority:J,folderUri:p.URI.parse(W.folderUri)}):a(W)&&A.files.push({label:G,remoteAuthority:J,fileUri:p.URI.parse(W.fileUri)})})}return A}e.$Lcb=b;function C(I){const E={entries:[]};for(const A of I.workspaces)w(A)?E.entries.push({folderUri:A.folderUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority}):E.entries.push({workspace:{id:A.workspace.id,configPath:A.workspace.configPath.toString()},label:A.label,remoteAuthority:A.remoteAuthority});for(const A of I.files)E.entries.push({fileUri:A.fileUri.toString(),label:A.label,remoteAuthority:A.remoteAuthority});return E}e.$Mcb=C}),define(oe[98],ae([0,1,86,13,4,19]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=e.$Y0b=e.$X0b=e.$W0b=void 0,e.$W0b=128/4;function D(l){function p(){let k=l.scheme===R.Schemas.file?(0,j.$vg)(l):l.toString();return s.$k||(k=k.toLowerCase()),(0,P.createHash)("md5").update(k).digest("hex")}return{id:p(),configPath:l}}e.$X0b=D;function S(l,p){function k(){if(l.scheme!==R.Schemas.file)return(0,P.createHash)("md5").update(l.toString()).digest("hex");if(!p)return;let u;return s.$k?u=p.ino:s.$j?u=p.birthtime.getTime():s.$i&&(typeof p.birthtimeMs=="number"?u=Math.floor(p.birthtimeMs):u=p.birthtime.getTime()),(0,P.createHash)("md5").update(l.fsPath).update(u?String(u):"").digest("hex")}const v=k();if(typeof v=="string")return{id:v,uri:l}}e.$Y0b=S;function f(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$Z0b=f}),define(oe[99],ae([0,1,86,87,26,282,17,14,3,2,9,4,32,43,110]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class w{traceSocketEvent(E,A){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,E,A)}constructor(E,A=""){this.f=!0,this.debugLabel=A,this.socket=E,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=M=>{if(this.traceSocketEvent("error",{code:M?.code,message:M?.message}),M){if(M.code==="EPIPE")return;(0,S.$1)(M)}},this.socket.on("error",this.a),this.b=M=>{this.traceSocketEvent("close",{hadError:M}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(E){const A=M=>{this.traceSocketEvent("read",M),E(D.$je.wrap(M))};return this.socket.on("data",A),{dispose:()=>this.socket.off("data",A)}}onClose(E){const A=M=>{E({type:0,hadError:M,error:void 0})};return this.socket.on("close",A),{dispose:()=>this.socket.off("close",A)}}onEnd(E){const A=()=>{E()};return this.socket.on("end",A),{dispose:()=>this.socket.off("end",A)}}write(E){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",E),this.socket.write(E.buffer,A=>{if(A){if(A.code==="EPIPE")return;(0,S.$1)(A)}})}catch(A){if(A.code==="EPIPE")return;(0,S.$1)(A)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((E,A)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),E();return}const M=()=>{this.socket.off("close",M),this.socket.off("end",M),this.socket.off("error",M),this.socket.off("timeout",M),this.socket.off("drain",M),this.traceSocketEvent("nodeDrainEnd"),E()};this.socket.on("close",M),this.socket.on("end",M),this.socket.on("error",M),this.socket.on("timeout",M),this.socket.on("drain",M)})}}e.$Uh=w;var g;(function(I){I[I.MinHeaderByteSize=2]="MinHeaderByteSize",I[I.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var $;(function(I){I[I.PeekHeader=1]="PeekHeader",I[I.ReadHeader=2]="ReadHeader",I[I.ReadBody=3]="ReadBody",I[I.Fin=4]="Fin"})($||($={}));class d extends l.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(E,A){this.socket.traceSocketEvent(E,A)}constructor(E,A,M,T){super(),this.f=this.B(new f.$Vd),this.g=this.B(new f.$Vd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=E,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:A,inflateBytesLength:M?.byteLength||0,recordInflateBytes:T}),this.a=this.B(new h(this,A,M,T,this.f,(W,G)=>this.m(W,G))),this.B(this.a.onError(W=>{console.error(W),(0,S.$1)(W),this.g.fire({type:0,hadError:!0,error:W})})),this.b=new y.$Ph,this.B(this.socket.onData(W=>this.n(W))),this.B(this.socket.onClose(async W=>{this.a.isProcessingReadQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(W)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(E){return this.f.event(E)}onClose(E){return this.g.event(E)}onEnd(E){return this.socket.onEnd(E)}write(E){let A=0;for(;A<E.byteLength;)this.a.writeMessage(E.slice(A,Math.min(A+262144,E.byteLength)),{compressed:!0,opcode:2}),A+=262144}m(E,{compressed:A,opcode:M}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",E);let T=2;E.byteLength<126?T+=0:E.byteLength<2**16?T+=2:T+=8;const W=D.$je.alloc(T),G=A?64:0,J=M&15;if(W.writeUInt8(128|G|J,0),E.byteLength<126)W.writeUInt8(E.byteLength,1);else if(E.byteLength<2**16){W.writeUInt8(126,1);let ce=1;W.writeUInt8(E.byteLength>>>8&255,++ce),W.writeUInt8(E.byteLength>>>0&255,++ce)}else{W.writeUInt8(127,1);let ce=1;W.writeUInt8(0,++ce),W.writeUInt8(0,++ce),W.writeUInt8(0,++ce),W.writeUInt8(0,++ce),W.writeUInt8(E.byteLength>>>24&255,++ce),W.writeUInt8(E.byteLength>>>16&255,++ce),W.writeUInt8(E.byteLength>>>8&255,++ce),W.writeUInt8(E.byteLength>>>0&255,++ce)}this.socket.write(D.$je.concat([W,E]))}end(){this.h=!0,this.socket.end()}n(E){if(E.byteLength!==0){for(this.b.acceptChunk(E);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const A=this.b.peek(this.j.readLen),M=A.readUInt8(0),T=(M&128)>>>7,W=(M&64)>>>6,G=M&15,J=A.readUInt8(1),ce=(J&128)>>>7,re=J&127;this.j.state=2,this.j.readLen=2+(ce?4:0)+(re===126?2:0)+(re===127?8:0),this.j.fin=T,this.j.firstFrameOfMessage&&(this.j.compressed=!!W),this.j.firstFrameOfMessage=!!T,this.j.mask=0,this.j.opcode=G,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const A=this.b.read(this.j.readLen),M=A.readUInt8(1),T=(M&128)>>>7;let W=M&127,G=1;W===126?W=A.readUInt8(++G)*2**8+A.readUInt8(++G):W===127&&(W=A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*0+A.readUInt8(++G)*2**24+A.readUInt8(++G)*2**16+A.readUInt8(++G)*2**8+A.readUInt8(++G));let J=0;T&&(J=A.readUInt8(++G)*2**24+A.readUInt8(++G)*2**16+A.readUInt8(++G)*2**8+A.readUInt8(++G)),this.j.state=3,this.j.readLen=W,this.j.mask=J,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const A=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",A),t(A,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",A),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(A,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(A,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await f.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Vh=d;class h extends l.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:D.$je.alloc(0)}constructor(E,A,M,T,W,G){super(),this.n=E,this.r=W,this.s=G,this.a=this.B(new f.$Vd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new f.$Vd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new f.$Vd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,A?(this.b=this.B(new m(this.n,T,M,{windowBits:15})),this.f=this.B(new c(this.n,{windowBits:15})),this.B(this.b.onError(J=>this.a.fire(J))),this.B(this.f.onError(J=>this.a.fire(J)))):(this.b=null,this.f=null)}writeMessage(E,A){this.g.push({data:E,options:A}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:E,options:A}=this.g.shift();if(this.f&&A.compressed){const M=await this.w(this.f,E);this.s(M,A)}else this.s(E,{...A,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(E,A){return new Promise((M,T)=>{E.write(A),E.flush(W=>M(W))})}acceptFrame(E,A,M){this.h.push({data:E,isCompressed:A,isLastFrameOfMessage:M}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const E=this.h.shift();if(this.b&&E.isCompressed){const A=await this.C(this.b,E.data,E.isLastFrameOfMessage);this.r.fire(A)}else this.r.fire(E.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(E,A,M){return new Promise((T,W)=>{E.write(A),M&&E.write(D.$je.fromByteArray([0,0,255,255])),E.flush(G=>T(G))})}}class m extends l.$Tc{get recordedInflateBytes(){return this.j?D.$je.concat(this.f):D.$je.alloc(0)}constructor(E,A,M,T){super(),this.h=E,this.j=A,this.a=this.B(new f.$Vd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,j.createInflateRaw)(T),this.b.on("error",W=>{this.h.traceSocketEvent("zlibInflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.h.traceSocketEvent("zlibInflateData",W),this.g.push(D.$je.wrap(W))}),M&&(this.h.traceSocketEvent("zlibInflateInitialWrite",M.buffer),this.b.write(M.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(E){this.j&&this.f.push(E.clone()),this.h.traceSocketEvent("zlibInflateWrite",E),this.b.write(E.buffer)}flush(E){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const A=D.$je.concat(this.g);this.g.length=0,E(A)})}}class c extends l.$Tc{constructor(E,A){super(),this.g=E,this.a=this.B(new f.$Vd),this.onError=this.a.event,this.f=[],this.b=(0,j.createDeflateRaw)({windowBits:15}),this.b.on("error",M=>{this.g.traceSocketEvent("zlibDeflateError",{message:M?.message,code:M?.code}),this.a.fire(M)}),this.b.on("data",M=>{this.g.traceSocketEvent("zlibDeflateData",M),this.f.push(D.$je.wrap(M))})}write(E){this.g.traceSocketEvent("zlibDeflateWrite",E.buffer),this.b.write(E.buffer)}flush(E){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let A=D.$je.concat(this.f);this.f.length=0,A=A.slice(0,A.byteLength-4),E(A)})}}function t(I,E){if(E===0)return;const A=I.byteLength>>>2;for(let ce=0;ce<A;ce++){const re=I.readUInt32BE(ce*4);I.writeUInt32BE(re^E,ce*4)}const M=A*4,T=I.byteLength-M,W=E>>>24&255,G=E>>>16&255,J=E>>>8&255;T>=1&&I.writeUInt8(I.readUInt8(M)^W,M),T>=2&&I.writeUInt8(I.readUInt8(M+1)^G,M+1),T>=3&&I.writeUInt8(I.readUInt8(M+2)^J,M+2)}e.$Wh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function r(){const I=(0,v.$qg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${I}-sock`;const E=process.platform!=="darwin"&&e.$Wh?e.$Wh:(0,s.tmpdir)(),A=(0,p.$jc)(E,`vscode-ipc-${I}.sock`);return n(A),A}e.$Xh=r;function i(I,E,A){const T=(0,P.createHash)("sha256").update(I).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${T}-${A}-${E}-sock`;const W=A.substr(0,4),G=E.substr(0,6);let J;return process.platform!=="darwin"&&e.$Wh&&!process.env.VSCODE_PORTABLE?J=(0,p.$jc)(e.$Wh,`vscode-${T}-${W}-${G}.sock`):J=(0,p.$jc)(I,`${W}-${G}.sock`),n(J),J}e.$Yh=i;function n(I){const E=o[k.$u];typeof E=="number"&&I.length>=E&&console.warn(`WARNING: IPC handle "${I}" is longer than ${E} chars, try a shorter --user-data-dir`)}class a extends u.$Jh{static b(E){const A=f.Event.fromNodeEventEmitter(E,"connection");return f.Event.map(A,M=>({protocol:new y.$Qh(new w(M,"ipc-server-connection")),onDidClientDisconnect:f.Event.once(f.Event.fromNodeEventEmitter(M,"close"))}))}constructor(E){super(a.b(E)),this.d=E}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Zh=a;function b(I){return new Promise((E,A)=>{const M=(0,R.createServer)();M.on("error",A),M.listen(I,()=>{M.removeListener("error",A),E(new a(M))})})}e.$1h=b;function C(I,E){return new Promise((A,M)=>{const T=(0,R.createConnection)(I,()=>{T.removeListener("error",M),A(y.$Rh.fromSocket(new w(T,`ipc-client${E}`),E))});T.once("error",M)})}e.$2h=C}),define(oe[24],ae([0,1,50,9,4,99,38,90,6]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$B0b=e.$A0b=void 0,e.$A0b=(0,f.$7h)(D.$ai);class l extends S.$Bm{constructor(){super(...arguments),this.d={}}get cachedLanguagesPath(){return(0,R.$jc)(this.userDataPath,"clp")}get backupHome(){return(0,R.$jc)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,j.$Yh)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,R.$jc)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}unsetSnapExportedVariables(){if(s.$k){for(const k in process.env)if(k.endsWith("_VSCODE_SNAP_ORIG")){const v=k.slice(0,-17);if(this.d[v])continue;process.env[v]&&(this.d[v]=process.env[v]),process.env[k]?process.env[v]=process.env[k]:delete process.env[v]}}}restoreSnapExportedVariables(){if(s.$k)for(const k in this.d)process.env[k]=this.d[k],delete this.d[k]}}e.$B0b=l,ve([P.$xh],l.prototype,"cachedLanguagesPath",null),ve([P.$xh],l.prototype,"backupHome",null),ve([P.$xh],l.prototype,"mainIPCHandle",null),ve([P.$xh],l.prototype,"mainLockfile",null),ve([P.$xh],l.prototype,"disableUpdates",null),ve([P.$xh],l.prototype,"crossOriginIsolated",null),ve([P.$xh],l.prototype,"codeCachePath",null),ve([P.$xh],l.prototype,"useCodeCache",null)}),define(oe[283],ae([0,1,86,33,13,9,4,19,21,196,18,24,34,16,5,195,30,98]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$g$b=void 0;let h=class{static{d=this}static{this.a="backupWorkspaces"}constructor(c,t,o,r){this.j=c,this.k=t,this.l=o,this.m=r,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=S.$yg,this.i={isEqual:(i,n)=>(0,R.$7f)(i,n,!D.$k)}}async initialize(){const c=this.m.getItem(d.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(c.emptyWindows),this.d=await this.u((0,l.$D0b)(c)),this.e=await this.v((0,l.$E0b)(c)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==u.$Pk.OFF}q(){return this.s()===u.$Pk.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||u.$Pk.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(c,t){this.d.some(r=>c.workspace.id===r.workspace.id)||(this.d.push(c),this.C());const o=(0,j.$jc)(this.c,c.workspace.id);return t?this.t(o,t).then(()=>o):o}async t(c,t){if(await f.Promises.exists(c)&&await this.z(c),await f.Promises.exists(t))try{await f.Promises.rename(t,c,!1)}catch(o){this.l.error(`Backup: Could not move backup folder to new location: ${o.toString()}`)}}registerFolderBackup(c){return this.e.some(t=>this.h.isEqual(c.folderUri,t.folderUri))||(this.e.push(c),this.C()),(0,j.$jc)(this.c,this.D(c))}registerEmptyWindowBackup(c){return this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,c.backupFolder))||(this.g.push(c),this.C()),(0,j.$jc)(this.c,c.backupFolder)}async u(c){if(!Array.isArray(c))return[];const t=new Set,o=[];for(const r of c){const i=r.workspace;if(!(0,g.$ii)(i))return[];if(!t.has(i.id)){t.add(i.id);const n=(0,j.$jc)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await f.Promises.exists(i.configPath.fsPath)?o.push(r):await this.z(n):await this.x(n)}}return o}async v(c){if(!Array.isArray(c))return[];const t=[],o=new Set;for(const r of c){const i=r.folderUri,n=this.h.getComparisonKey(i);if(!o.has(n)){o.add(n);const a=(0,j.$jc)(this.c,this.D(r));await this.B(a)?i.scheme!==s.Schemas.file||await f.Promises.exists(i.fsPath)?t.push(r):await this.z(a):await this.x(a)}}return t}async w(c){if(!Array.isArray(c))return[];const t=[],o=new Set;for(const r of c){const i=r.backupFolder;if(typeof i!="string")return[];if(!o.has(i)){o.add(i);const n=(0,j.$jc)(this.c,i);await this.B(n)?t.push(r):await this.x(n)}}return t}async x(c){try{await f.Promises.rm(c,f.RimRafMode.MOVE)}catch(t){this.l.error(`Backup: Could not delete stale backup: ${t.toString()}`)}}y(){let c=(0,$.$Z0b)();for(;this.g.some(t=>!!t.backupFolder&&this.i.isEqual(t.backupFolder,c.id));)c=(0,$.$Z0b)();return{backupFolder:c.id}}async z(c){const t=this.y(),o=(0,j.$jc)(this.c,t.backupFolder);try{await f.Promises.rename(c,o,!1)}catch(r){return this.l.error(`Backup: Could not rename backup folder: ${r.toString()}`),!1}return this.g.push(t),!0}async getDirtyWorkspaces(){const c=[];for(const t of this.d)await this.A(t)&&c.push(t);for(const t of this.e)await this.A(t)&&c.push(t);return c}A(c){let t;return(0,l.$C0b)(c)?t=(0,j.$jc)(this.c,c.backupFolder):(0,w.$Bcb)(c)?t=(0,j.$jc)(this.c,this.D(c)):t=(0,j.$jc)(this.c,c.workspace.id),this.B(t)}async B(c){try{const t=await f.Promises.readdir(c);for(const o of t)try{if((await f.Promises.readdir((0,j.$jc)(c,o))).length>0)return!0}catch{}}catch{}return!1}C(){const c={workspaces:this.d.map(({workspace:t,remoteAuthority:o})=>{const r={id:t.id,configURIPath:t.configPath.toString()};return o&&(r.remoteAuthority=o),r}),folders:this.e.map(({folderUri:t,remoteAuthority:o})=>{const r={folderUri:t.toString()};return o&&(r.remoteAuthority=o),r}),emptyWindows:this.g.map(({backupFolder:t,remoteAuthority:o})=>{const r={backupFolder:t};return o&&(r.remoteAuthority=o),r})};this.m.setItem(d.a,c)}D(c){const t=c.folderUri;let o;return t.scheme===s.Schemas.file?o=D.$k?t.fsPath:t.fsPath.toLowerCase():o=t.toString().toLowerCase(),(0,P.createHash)("md5").update(o).digest("hex")}};e.$g$b=h,e.$g$b=h=d=ve([ne(0,k.$A0b),ne(1,p.$zi),ne(2,y.$nj),ne(3,v.$uO)],h)}),define(oe[20],ae([0,1,15,37,8,3,2,4,36,12,6,5,34,24]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$90b=e.LifecycleMainPhase=e.ShutdownReason=e.$80b=void 0,e.$80b=(0,p.$6h)("lifecycleMainService");var w;(function(d){d[d.QUIT=1]="QUIT",d[d.KILL=2]="KILL"})(w||(e.ShutdownReason=w={}));var g;(function(d){d[d.Starting=1]="Starting",d[d.Ready=2]="Ready",d[d.AfterWindowOpen=3]="AfterWindowOpen",d[d.Eventually=4]="Eventually"})(g||(e.LifecycleMainPhase=g={}));let $=class extends D.$Tc{static{y=this}static{this.b="lifecycle.quitAndRestart"}get quitRequested(){return this.j}get wasRestarted(){return this.m}get phase(){return this.n}constructor(h,m,c){super(),this.F=h,this.G=m,this.H=c,this.c=this.B(new j.$Vd),this.onBeforeShutdown=this.c.event,this.f=this.B(new j.$Vd),this.onWillShutdown=this.f.event,this.g=this.B(new j.$Vd),this.onWillLoadWindow=this.g.event,this.h=this.B(new j.$Vd),this.onBeforeCloseWindow=this.h.event,this.j=!1,this.m=!1,this.n=1,this.r=new Set,this.s=0,this.t=0,this.u=void 0,this.w=void 0,this.y=void 0,this.z=new Map,this.C=new Map,this.D=void 0,this.I(),this.when(2).then(()=>this.J())}I(){this.m=!!this.G.getItem(y.b),this.m&&this.G.removeItem(y.b)}J(){const h=()=>{this.j||(this.S("Lifecycle#app.on(before-quit)"),this.j=!0,this.S("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),S.$j&&this.t===0&&this.L(1))};P.app.addListener("before-quit",h);const m=()=>{this.S("Lifecycle#app.on(window-all-closed)"),(this.j||!S.$j)&&P.app.quit()};P.app.addListener("window-all-closed",m),P.app.once("will-quit",c=>{this.S("Lifecycle#app.on(will-quit) - begin"),c.preventDefault(),this.L(1).finally(()=>{this.S("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.O(!1),P.app.removeListener("before-quit",h),P.app.removeListener("window-all-closed",m),this.S("Lifecycle#app.on(will-quit) - calling app.quit()"),P.app.quit()})})}L(h){if(this.y)return this.y;const m=this.F;this.S("Lifecycle#onWillShutdown.fire()");const c=[];return this.f.fire({reason:h,join(t,o){m.trace(`Lifecycle#onWillShutdown - begin '${t}'`),c.push(o.finally(()=>{m.trace(`Lifecycle#onWillShutdown - end '${t}'`)}))}}),this.y=(async()=>{try{await s.Promises.settled(c)}catch(t){this.F.error(t)}try{await this.G.close()}catch(t){this.F.error(t)}})(),this.y}set phase(h){if(h<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.n===h)return;this.S(`lifecycle (main): phase changed (value: ${h})`),this.n=h;const m=this.C.get(this.n);m&&(m.open(),this.C.delete(this.n))}async when(h){if(h<=this.n)return;let m=this.C.get(h);m||(m=new s.$5g,this.C.set(h,m)),await m.wait()}registerWindow(h){const m=new D.$Sc;this.t++,m.add(h.onWillLoad(t=>this.g.fire({window:h,workspace:t.workspace,reason:t.reason})));const c=(0,l.$Tf)(h.win);c.on("close",t=>{const o=h.id;if(this.r.has(o)){this.r.delete(o);return}this.S(`Lifecycle#window.on('close') - window ID ${h.id}`),t.preventDefault(),this.unload(h,1).then(r=>{if(r){this.r.delete(o);return}this.r.add(o),this.S(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${o}`),this.h.fire(h),h.close()})}),c.on("closed",()=>{this.S(`Lifecycle#window.on('closed') - window ID ${h.id}`),this.t--,m.dispose(),this.t===0&&(!S.$j||this.j)&&this.L(1)})}registerAuxWindow(h){const m=(0,l.$Tf)(h.win);m.on("close",c=>{this.S(`Lifecycle#auxWindow.on('close') - window ID ${h.id}`),this.j&&(this.S("Lifecycle#auxWindow.on('close') - preventDefault() because quit requested"),c.preventDefault())}),m.on("closed",()=>{this.S(`Lifecycle#auxWindow.on('closed') - window ID ${h.id}`)})}async reload(h,m){await this.unload(h,3)||h.reload(m)}unload(h,m){const c=this.z.get(h.id);if(c)return c;const t=this.M(h,m).finally(()=>{this.z.delete(h.id)});return this.z.set(h.id,t),t}async M(h,m){if(!h.isReady)return!1;this.S(`Lifecycle#unload() - window ID ${h.id}`);const c=this.j?2:m,t=await this.P(h,c);return t?(this.S(`Lifecycle#unload() - veto in renderer (window ID ${h.id})`),this.N(t)):(await this.Q(h,c),!1)}N(h){return h?(this.O(!0),this.j=!1,!0):!1}O(h){this.w&&(this.w(h),this.w=void 0,this.u=void 0)}P(h,m){return new Promise(c=>{const t=this.s++,o=`vscode:ok${t}`,r=`vscode:cancel${t}`;R.$AU.once(o,()=>{c(!1)}),R.$AU.once(r,()=>{c(!0)}),h.send("vscode:onBeforeUnload",{okChannel:o,cancelChannel:r,reason:m})})}Q(h,m){return new Promise(c=>{const o=`vscode:reply${this.s++}`;R.$AU.once(o,()=>c()),h.send("vscode:onWillUnload",{replyChannel:o,reason:m})})}quit(h){return this.R(h).then(m=>{if(!m&&h)try{if(S.$i){const c=(0,f.cwd)();c!==process.cwd()&&process.chdir(c)}}catch(c){this.F.error(c)}return m})}R(h){return this.S(`Lifecycle#quit() - begin (willRestart: ${h})`),this.u?(this.S("Lifecycle#quit() - returning pending quit promise"),this.u):(h&&this.G.setItem(y.b,!0),this.u=new Promise(m=>{this.w=m,this.S("Lifecycle#quit() - calling app.quit()"),P.app.quit()}),this.u)}S(h){this.H.args["enable-smoke-test-driver"]?this.F.info(h):this.F.trace(h)}setRelaunchHandler(h){this.D=h}async relaunch(h){this.S("Lifecycle#relaunch()");const m=process.argv.slice(1);if(h?.addArgs&&m.push(...h.addArgs),h?.removeArgs)for(const o of h.removeArgs){const r=m.indexOf(o);r>=0&&m.splice(r,1)}const c=()=>{this.D?.handleRelaunch(h)||(this.S("Lifecycle#relaunch() - calling app.relaunch()"),P.app.relaunch({args:m}))};P.app.once("quit",c),await this.quit(!0)&&P.app.removeListener("quit",c)}async kill(h){this.S("Lifecycle#kill()"),await this.L(2),await Promise.race([(0,s.$7g)(1e3),(async()=>{for(const m of P.BrowserWindow.getAllWindows())if(m&&!m.isDestroyed()){let c;m.webContents&&!m.webContents.isDestroyed()?c=new Promise(t=>m.once("closed",t)):c=Promise.resolve(),m.destroy(),await c}})()]),P.app.exit(h)}};e.$90b=$,e.$90b=$=y=ve([ne(0,k.$nj),ne(1,v.$uO),ne(2,u.$A0b)],$)}),define(oe[284],ae([0,1,4,3,2,6,20]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$D$b=e.$C$b=void 0,e.$C$b=(0,j.$6h)("keyboardLayoutMainService");let S=class extends s.$Tc{constructor(p){super(),this.a=this.B(new R.$Vd),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((k,v)=>{X(["native-keymap"],k,v)});this.c=f(p),P.$t||p.onDidChangeKeyboardLayout(()=>{this.c=f(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.$D$b=S,e.$D$b=S=ve([ne(0,D.$80b)],S);function f(l){const p=l.getKeyMap(),k=l.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:k}}}),define(oe[285],ae([0,1,246,8,17,14,12,18,38,94,5,53,245,282]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;let y=class extends k.$ip{constructor(d,h,m,c){super(c),this.m=d,this.n=h,this.r=m,this.s(),this.B(d.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.s()}))}s(){const d=this.m.getValue("http");this.f=d?.proxy,this.g=!!d?.proxyStrictSSL,this.h=d?.proxyAuthorization}async request(d,h){const{f:m,g:c}=this;let t;try{t=await(0,l.$_l)(this.m,this.r,this.n.args,process.env)}catch(i){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,j.$0)(i)))}const o={...process.env,...t},r=d.agent?d.agent:await(0,v.$mr)(d.url||"",o,{proxyUrl:m,strictSSL:c});return d.agent=r,d.strictSSL=c,this.h&&(d.headers={...d.headers||{},"Proxy-Authorization":this.h}),this.c(d.isChromiumNetwork?"electron":"node",d,()=>g(d,h))}async resolveProxy(d){}async loadCertificates(){return(await new Promise((h,m)=>{X(["@vscode/proxy-agent"],h,m)})).loadSystemCertificates({log:this.r})}};e.$nr=y,e.$nr=y=ve([ne(0,S.$zi),ne(1,f.$bi),ne(2,p.$nj),ne(3,p.$oj)],y);async function w($){return((0,P.parse)($.url).protocol==="https:"?await new Promise((m,c)=>{X(["https"],m,c)}):await new Promise((m,c)=>{X(["http"],m,c)})).request}async function g($,d){return R.Promises.withAsyncBody(async(h,m)=>{const c=(0,P.parse)($.url),t=$.getRawRequest?$.getRawRequest($):await w($),o={hostname:c.hostname,port:c.port?parseInt(c.port):c.protocol==="https:"?443:80,protocol:c.protocol,path:c.path,method:$.type||"GET",headers:$.headers,agent:$.agent,rejectUnauthorized:(0,D.$Of)($.strictSSL)?$.strictSSL:!0};$.user&&$.password&&(o.auth=$.user+":"+$.password);const r=t(o,i=>{const n=(0,D.$Mf)($.followRedirects)?$.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)g({...$,url:i.headers.location,followRedirects:n-1},d).then(h,m);else{let a=i;!$.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(a=i.pipe((0,u.createGunzip)())),h({res:i,stream:(0,s.$ye)(a)})}});r.on("error",m),$.timeout&&r.setTimeout($.timeout),$.isChromiumNetwork&&r.removeHeader("Content-Length"),$.data&&typeof $.data=="string"&&r.write($.data),r.end(),d.onCancellationRequested(()=>{r.abort(),m(new j.$5)})})}e.$or=g}),define(oe[286],ae([0,1,15,285]),function(X,e,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$F_b=void 0;function s(D){return P.net.request}class j extends R.$nr{request(S,f){return super.request({...S||{},getRawRequest:s,isChromiumNetwork:!0},f)}}e.$F_b=j}),define(oe[82],ae([0,1,7,3,2,38,16,6,20,5,96,279,41,56,40,13]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e$b=e.$d$b=e.$c$b=e.$b$b=void 0,e.$b$b=(0,S.$6h)("storageMainService");let g=class extends s.$Tc{constructor(h,m,c,t,o,r){super(),this.c=h,this.f=m,this.g=c,this.h=t,this.j=o,this.m=r,this.a=void 0,this.b=this.B(new R.$Vd),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.B(this.s()),this.t=new Map,this.w=new Map,this.r()}n(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}r(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(h=>{h.window.profile&&this.profileStorage(h.window.profile).init(),h.workspace&&this.workspaceStorage(h.workspace).init()})),this.B(this.h.onWillShutdown(h=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=h.reason,h.join("applicationStorage",this.applicationStorage.close());for(const[,m]of this.t)h.join("profileStorage",m.close());for(const[,m]of this.w)h.join("workspaceStorage",m.close())})),this.B(this.g.onWillCreateProfile(h=>{h.join((async()=>{await this.j.exists(h.profile.globalStorageHome)||await this.j.createFolder(h.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(h=>{const m=this.t.get(h.profile.id);m&&h.join(m.close())}))}s(){this.c.trace("StorageMainService: creating application storage");const h=new k.$$0b(this.n(),this.g,this.c,this.j);return this.B(R.Event.once(h.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")})),h}profileStorage(h){if((0,p.$xp)(h))return this.applicationStorage;let m=this.t.get(h.id);if(!m){this.c.trace(`StorageMainService: creating profile storage (${h.name})`),m=this.B(this.u(h)),this.t.set(h.id,m);const c=this.B(m.onDidChangeStorage(t=>this.b.fire({...t,storage:m,profile:h})));this.B(R.Event.once(m.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${h.name})`),this.t.delete(h.id),c.dispose()}))}return m}u(h){return this.a===2?new k.$a$b(this.c,this.j):new k.$00b(h,this.n(),this.c,this.j)}workspaceStorage(h){let m=this.w.get(h.id);return m||(this.c.trace(`StorageMainService: creating workspace storage (${h.id})`),m=this.B(this.y(h)),this.w.set(h.id,m),this.B(R.Event.once(m.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${h.id})`),this.w.delete(h.id)}))),m}y(h){return this.a===2?new k.$a$b(this.c,this.j):new k.$_0b(h,this.n(),this.c,this.f,this.j)}isUsed(h){const m=P.URI.file(h);for(const c of[this.applicationStorage,...this.t.values(),...this.w.values()])if(c.path&&this.m.extUri.isEqualOrParent(P.URI.file(c.path),m))return!0;return!1}};e.$c$b=g,e.$c$b=g=ve([ne(0,l.$nj),ne(1,j.$ai),ne(2,u.$R0b),ne(3,f.$80b),ne(4,D.$qk),ne(5,y.$1k)],g),e.$d$b=(0,S.$6h)("applicationStorageMainService");let $=class extends p.$wp{constructor(h,m){super(),this.s=h,this.U=m,this.whenReady=this.U.applicationStorage.whenInit}O(){return this.U.applicationStorage.whenInit}P(h){if(h===-1)return this.U.applicationStorage.storage}Q(h){if(h===-1)return this.s.defaultProfile.globalStorageHome.with({scheme:w.Schemas.file}).fsPath}r(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}R(){throw new Error("Switching storage profile is unsupported from main process")}S(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.$e$b=$,e.$e$b=$=ve([ne(0,v.$3k),ne(1,e.$b$b)],$)}),define(oe[287],ae([0,1,87,26,104,99,8,2,4,18,5,27,241,242,95,127,17]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=e.$D_b=e.$C_b=e.$B_b=void 0;async function $(t,o,r,i,n){let a;for(let b=3;b&&(a?.dispose(),a=await new d(t,o,r,i,n).waitForReady(),!(n&&s.$tg[n]||!s.$tg[a.tunnelLocalPort]));b--);return a}class d extends S.$Tc{constructor(o,r,i,n,a){super(),this.m=r,this.n=a,this.privacy=w.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=P.createServer(),this.c=new D.$5g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=b=>this.r(b),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=n,this.tunnelRemoteHost=i}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(r=>{r()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,r=(0,w.$Hv)(this.m)?"0.0.0.0":"127.0.0.1";let i=await(0,s.$ug)(o,2,1e3,r),n=null;return this.b.listen(i,this.m),await this.c.wait(),n=this.b.address(),n||(i=0,this.b.listen(i,this.m),await this.c.wait(),n=this.b.address()),this.tunnelLocalPort=n.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${n.port}`,this}async r(o){o.pause();const r=(0,w.$Fv)(this.tunnelRemoteHost)||(0,w.$Hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,i=await(0,v.$ll)(this.a,r,this.tunnelRemotePort),n=i.getSocket(),a=i.readEntireBuffer();i.dispose(),a.byteLength>0&&o.write(a.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),n.end()}),o.on("close",()=>n.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),n instanceof j.$Uh?n.socket.destroy():n.end()}),n instanceof j.$Uh?this.t(o,n):this.s(o,n),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),n.end()})}s(o,r){r.onClose(()=>o.destroy()),r.onEnd(()=>o.end()),r.onData(i=>o.write(i.buffer)),o.on("data",i=>r.write(g.$je.wrap(i))),o.resume()}t(o,r){const i=r.socket;i.on("end",()=>o.end()),i.on("close",()=>o.end()),i.on("error",()=>{o.destroy()}),i.pipe(o),o.pipe(i)}}e.$B_b=d;let h=class extends w.$Kv{constructor(o,r,i,n,a){super(r,a),this.v=o,this.w=i,this.y=n}isPortPrivileged(o){return(0,w.$Iv)(o,this.m,f.OS,R.release())}t(o,r,i,n,a,b,C,I){const E=this.s(r,i);if(E)return++E.refcount,E.value;if((0,w.$Cv)(o))return this.u(o,r,i,a,b,C,I);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${r}:${i} on local port ${a}.`);const A={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},M=$(A,n,r,i,a);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(r,i,M),M}}};e.$C_b=h,e.$C_b=h=ve([ne(0,u.$fl),ne(1,p.$nj),ne(2,y.$il),ne(3,k.$Fj),ne(4,l.$zi)],h);let m=class extends h{constructor(o,r,i,n,a){super(o,r,i,n,a)}};e.$D_b=m,e.$D_b=m=ve([ne(0,u.$fl),ne(1,p.$nj),ne(2,y.$il),ne(3,k.$Fj),ne(4,l.$zi)],m);let c=class extends S.$Tc{constructor(o,r,i,n,a){super(),this.b=o,this.c=r,this.f=i,this.g=n,this.h=a,this.a=new Map}async openTunnel(o,r,i,n,a,b,C,I,E){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${i}:${n} on local port ${b}.`),!this.a.has(o)){const A=new m(this.b,this.c,this.g,this.f,this.h);this.B(A),this.a.set(o,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(r,i,n,a,b,C,I,E)}};e.$E_b=c,e.$E_b=c=ve([ne(0,u.$fl),ne(1,p.$nj),ne(2,k.$Fj),ne(3,y.$il),ne(4,l.$zi)],c)}),define(oe[100],ae([0,1,8,23,3,18,24,20,5,27,53,49]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1$b=e.$Z$b=void 0;function v(y,w,g){return`${g.updateUrl}/api/update/${y}/${w}/${g.commit}`}e.$Z$b=v;let u=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,g,$,d,h,m){this.f=w,this.g=g,this.h=$,this.i=d,this.j=h,this.k=m,this.b=k.$yV.Uninitialized,this.c=new s.$Vd,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt){this.d(k.$yV.Disabled(0));return}if(this.h.disableUpdates){this.d(k.$yV.Disabled(1)),this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.d(k.$yV.Disabled(3)),this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),g=this.m(w);if(!g){this.d(k.$yV.Disabled(2)),this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(g),!this.a){this.d(k.$yV.Disabled(4)),this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.g.getValue("_update.prss")){const $=new URL(this.a);$.searchParams.set("prss","true"),this.a=$.toString()}if(this.d(k.$yV.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,$=>this.j.error($))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,P.$7g)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},R.CancellationToken.None)).res.statusCode===204}catch(g){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(g);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.$1$b=u,e.$1$b=u=ve([ne(0,S.$80b),ne(1,j.$zi),ne(2,D.$A0b),ne(3,p.$hp),ne(4,f.$nj),ne(5,l.$Fj)],u)}),define(oe[288],ae([0,1,15,50,3,45,2,18,24,20,5,27,53,28,49,100]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2$b=void 0;let g=class extends w.$1$b{get v(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"error",(d,h)=>h)}get w(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-available",(d,h,m)=>({url:h,version:m,productVersion:m}))}get y(){return s.Event.fromNodeEventEmitter(P.autoUpdater,"update-downloaded",(d,h,m,c)=>({releaseNotes:h,version:m,productVersion:m,date:c}))}constructor(d,h,m,c,t,o,r){super(d,h,c,t,o,r),this.z=m,this.u=new D.$Sc,d.setRelaunchHandler(this)}handleRelaunch(d){return d?.addArgs||d?.removeArgs||this.state.type!=="ready"?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(d){this.z.publicLog2("update:error",{messageHash:String((0,j.$Ti)(String(d)))}),this.j.error("UpdateService error:",d);const h=this.state.type==="checking for updates"&&this.state.explicit?d:void 0;this.d(y.$yV.Idle(1,h))}s(d){let h;this.k.darwinUniversalAssetId?h=this.k.darwinUniversalAssetId:h=process.arch==="x64"?"darwin":"darwin-arm64";const m=(0,w.$Z$b)(h,d,this.k);try{P.autoUpdater.setFeedURL({url:m})}catch(c){this.j.error("Failed to set update feed URL",c);return}return m}t(d){this.d(y.$yV.CheckingForUpdates(d)),P.autoUpdater.checkForUpdates()}E(d){this.state.type==="checking for updates"&&this.d(y.$yV.Downloading(d))}F(d){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:d.version}),this.d(y.$yV.Ready(d)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(y.$yV.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),P.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};e.$2$b=g,ve([R.$xh],g.prototype,"v",null),ve([R.$xh],g.prototype,"w",null),ve([R.$xh],g.prototype,"x",null),ve([R.$xh],g.prototype,"y",null),e.$2$b=g=ve([ne(0,l.$80b),ne(1,S.$zi),ne(2,u.$ul),ne(3,f.$A0b),ne(4,v.$hp),ne(5,p.$nj),ne(6,k.$Fj)],g)}),define(oe[289],ae([0,1,48,46,8,3,9,24,20,5,28,49]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4$b=void 0;let v=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,g,$){if(this.f=w,this.g=$,this.a=k.$yV.Uninitialized,this.b=new j.$Vd,this.onStateChange=this.b.event,g.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(k.$yV.Idle(this.k())),this.h(30*1e3).then(void 0,d=>this.g.error(d))}h(w=60*60*1e3){return(0,s.$7g)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};v=ve([ne(0,f.$80b),ne(1,S.$A0b),ne(2,l.$nj)],v);let u=class extends v{constructor(w,g,$,d,h,m){super($,d,h),this.o=w,this.p=g,this.q=m;const c=(0,R.watch)(D.$mc(this.o)),t=j.Event.fromNodeEventEmitter(c,"change",(n,a)=>a),o=j.Event.filter(t,n=>n==="current"),i=j.Event.debounce(o,(n,a)=>a,2e3)(()=>this.checkForUpdates(!1));$.onWillShutdown(()=>{i.dispose(),c.close()})}m(){this.d(k.$yV.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(k.$yV.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(k.$yV.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(k.$yV.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,P.spawn)("sleep 3 && "+D.$nc(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise(($,d)=>(0,R.realpath)(`${D.$mc(this.o)}/current`,(h,m)=>h?d(h):$(m))),g=D.$nc(w);return this.p!==g}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.$4$b=u,e.$4$b=u=ve([ne(2,f.$80b),ne(3,S.$A0b),ne(4,l.$nj),ne(5,p.$ul)],u)}),define(oe[29],ae([0,1,4,6,60,70,27,18,24,9,65,137]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q0b=e.$P0b=e.$O0b=e.OpenContext=e.$N0b=void 0,e.$N0b=(0,R.$6h)("windowsMainService");var v;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(v||(e.OpenContext=v={}));function u(g,$,d){const h=g.get(j.$J0b),m=g.get(D.$Fj),c=g.get(S.$zi),t=g.get(f.$A0b),o=c.getValue("window"),r={backgroundColor:h.getBackgroundColor(),minWidth:s.$NC.WIDTH,minHeight:s.$NC.HEIGHT,title:m.nameLong,...d,webPreferences:{enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,s.$WC)($?.zoomLevel??o?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...d?.webPreferences,sandbox:!0},experimentalDarkMode:!0};if($&&(r.x=$.x,r.y=$.y,r.width=$.width,r.height=$.height),P.$k?r.icon=(0,l.$jc)(t.appRoot,"resources/linux/code.png"):P.$i&&!t.isBuilt&&(r.icon=(0,l.$jc)(t.appRoot,"resources/win32/code_150x150.png")),P.$j&&(r.acceptFirstMouse=!0,o?.clickThroughInactive===!1&&(r.acceptFirstMouse=!1)),P.$j&&!(0,s.$VC)(c)&&(r.fullscreenable=!1),P.$j&&o?.nativeTabs===!0&&(r.tabbingIdentifier=m.nameShort),(0,s.$TC)(c)==="custom"&&(r.titleBarStyle="hidden",P.$j||(r.frame=!1),(0,s.$UC)(c))){const a=h.getWindowSplash()?.colorInfo.titleBarBackground??h.getBackgroundColor(),b=k.$mt.fromHex(a).isDarker()?"#FFFFFF":"#000000";r.titleBarOverlay={height:29,color:a,symbolColor:b}}return r}e.$O0b=u;function y(g){const $=g.get(e.$N0b),d=g.get(p.$L0b),h=$.getFocusedWindow()??d.getFocusedWindow();if(h)return h;const m=$.getLastActiveWindow(),c=d.getLastActiveWindow();return m&&c?m.lastFocusTime<c.lastFocusTime?c:m:m??c}e.$P0b=y;function w(g){let $,d=Number.MIN_VALUE;for(const h of g)h.lastFocusTime>d&&(d=h.lastFocusTime,$=h);return $}e.$Q0b=w}),define(oe[290],ae([0,1,15,23,3,45,2,32,117,5,82,29]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f$b=void 0;var v;(function(y){y[y.Initial=1]="Initial",y[y.StoredCredentialsUsed=2]="StoredCredentialsUsed",y[y.LoginDialogShown=3]="LoginDialogShown"})(v||(v={}));let u=class extends D.$Tc{constructor(w,g,$,d){super(),this.g=w,this.h=g,this.j=$,this.m=d,this.a="proxy-credentials://",this.b=void 0,this.c=v.Initial,this.f=void 0,this.n()}n(){const w=s.Event.fromNodeEventEmitter(P.app,"login",(g,$,d,h,m)=>({event:g,webContents:$,req:d,authInfo:h,callback:m}));this.B(w(this.r,this))}async r({event:w,authInfo:g,req:$,callback:d}){if(!g.isProxy)return;if(!this.b&&this.c===v.LoginDialogShown&&$.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}w.preventDefault();let h;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),h=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.s(g);try{h=await this.b}finally{this.b=void 0}}d(h?.username,h?.password)}async s(w){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.t(w);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async t(w){this.g.trace("auth#doResolveProxyCredentials - enter",w);const g=String((0,j.$Ti)({scheme:w.scheme,host:w.host,port:w.port}));let $,d;try{const t=this.m.get(this.a+g,-1);if(t){const o=JSON.parse(await this.j.decrypt(t));$=o.username,d=o.password}}catch(t){this.g.error(t)}if(this.c!==v.StoredCredentialsUsed&&typeof $=="string"&&typeof d=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=v.StoredCredentialsUsed,{username:$,password:d};const h=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!h){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${h.id} to handle proxy login`);const m={authInfo:w,username:this.f?.username??$,password:this.f?.password??d,replyChannel:`vscode:proxyAuthResponse:${(0,S.$qg)()}`};h.sendWhenReady("vscode:openProxyAuthenticationDialog",R.CancellationToken.None,m),this.c=v.LoginDialogShown;const c=await new Promise(t=>{const o=async(r,i,n)=>{if(i===m.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${h.id}`),h.win?.webContents.off("ipc-message",o),n){const a={username:n.username,password:n.password};try{if(n.remember){const b=await this.j.encrypt(JSON.stringify(a));this.m.store(this.a+g,b,-1,1)}else this.m.remove(this.a+g,-1)}catch(b){this.g.error(b)}t({username:a.username,password:a.password})}else t(void 0)};h.win?.webContents.on("ipc-message",o)});return this.f=c,c}};e.$f$b=u,e.$f$b=u=ve([ne(0,l.$nj),ne(1,k.$N0b),ne(2,f.$jV),ne(3,p.$d$b)],u)}),define(oe[291],ae([0,1,15,22,4,7,21,18,64,6,5,128,29]),function(X,e,P,R,s,j,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G$b=e.$F$b=e.ID=void 0,e.ID="launchMainService",e.$F$b=(0,l.$6h)(e.ID);let u=class{constructor(w,g,$,d){this.a=w,this.b=g,this.c=$,this.d=d}async start(w,g){this.a.trace("Received data from other instance: ",w,g),s.$j&&P.app.focus({steal:!0});const $=this.e(w);if($.length){let d=Promise.resolve();if(this.b.getWindowCount()===0){const h=(0,R.$Ob)(await this.b.openEmptyWindow({context:4}));h&&(d=h.ready())}d.then(()=>{for(const{uri:h,originalUrl:m}of $)this.c.open(h,{originalUrl:m})})}else return this.f(w,g)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,R.$Hb)(w._urls.map(g=>{try{return{uri:j.URI.parse(g),originalUrl:g}}catch{return null}})):[]}async f(w,g){const $=(0,f.$6l)(g)?0:4;let d=[];const h=w.wait&&w.waitMarkerFilePath?j.URI.file(w.waitMarkerFilePath):void 0,m=w.remote||void 0,c={context:$,cli:w,userEnv:w["preserve-env"]||$===0?g:void 0,waitMarkerFileURI:h,remoteAuthority:m,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,c);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||c.forceProfile||c.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.$j}if(t)d=await this.b.open({...c,forceNewWindow:!0,forceEmpty:!0});else{const o=this.b.getLastActiveWindow();o?(this.b.openExistingWindow(o,c),d=[o]):d=await this.b.open({...c,forceEmpty:!0})}}else d=await this.b.open({...c,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(h&&d.length===1&&d[0])return Promise.race([d[0].whenClosedOrLoaded,(0,D.whenDeleted)(h.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.$G$b=u,e.$G$b=u=ve([ne(0,p.$nj),ne(1,v.$N0b),ne(2,k.$pV),ne(3,S.$zi)],u)}),define(oe[292],ae([0,1,2,20,56,30,8,29]),function(X,e,P,R,s,j,D,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$j_b=void 0;let f=class extends P.$Tc{constructor(p,k,v){super(),this.a=k,this.b=v,this.B(p.onWillLoadWindow(u=>{u.reason===2&&this.c(u.window)})),this.B(p.onBeforeCloseWindow(u=>this.c(u))),this.B(new D.$fh(()=>this.g(),30*1e3)).schedule()}async c(p){const k=this.f(p),v=this.a.getProfileForWorkspace(k);v?.isTransient&&(this.a.unsetWorkspace(k,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,j.$hi)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const k=this.b.getWindows().map(v=>this.f(v));for(const v of p)k.some(u=>u.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.$j_b=f,e.$j_b=f=ve([ne(0,R.$80b),ne(1,s.$R0b),ne(2,S.$N0b)],f)}),define(oe[61],ae([0,1,15,2,3,5,312,8,13,29,74,28,20,76,35,4,132]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$j$b=e.$i$b=void 0;function d(c){return typeof c.responseWindowId=="number"}let h=class extends R.$Tc{static{$=this}static{this.a=0}static{this.b=new Map}static getAll(){return Array.from($.b.values())}constructor(t,o,r){super(),this.u=t,this.w=o,this.y=r,this.c=String(++$.a),this.f=this.B(new s.$Vd),this.onStdout=this.f.event,this.g=this.B(new s.$Vd),this.onStderr=this.g.event,this.h=this.B(new s.$Vd),this.onMessage=this.h.event,this.j=this.B(new s.$Vd),this.onSpawn=this.j.event,this.m=this.B(new s.$Vd),this.onExit=this.m.event,this.n=this.B(new s.$Vd),this.onCrash=this.n.event,this.r=void 0,this.s=void 0,this.t=void 0}z(t,o){let r;switch(this.t?.correlationId?r=`[UtilityProcess id: ${this.t?.correlationId}, type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`:r=`[UtilityProcess type: ${this.t?.type}, pid: ${this.s??"<none>"}]: ${t}`,o){case p.default.Error:this.u.error(r);break;case p.default.Warning:this.u.warn(r);break;case p.default.Info:this.u.trace(r);break}}C(){return this.r?(this.z("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(t){const o=this.D(t);return o&&t.payload&&this.postMessage(t.payload),o}D(t){if(!this.C())return!1;this.t=t;const o=`${this.t.type}-${this.c}`,r=f.$og.asFileUri("bootstrap-fork.js").fsPath,i=this.t.args??[],n=this.t.execArgv??[],a=this.t.allowLoadingUnsignedLibraries,b=this.t.forceAllocationsToV8Sandbox,C="pipe",I=this.F(t);return this.z("creating new...",p.default.Info),this.r=P.utilityProcess.fork(r,i,{serviceName:o,env:I,execArgv:n,allowLoadingUnsignedLibraries:a,forceAllocationsToV8Sandbox:b,stdio:C}),this.G(this.r,this.t,o),!0}F(t){const o=t.env?{...t.env}:{...(0,y.$vn)(process.env)};o.VSCODE_AMD_ENTRYPOINT=t.entryPoint,typeof t.parentLifecycleBound=="number"&&(o.VSCODE_PARENT_PID=String(t.parentLifecycleBound)),o.VSCODE_CRASH_REPORTER_PROCESS_TYPE=t.type,w.$i&&((0,g.isUNCAccessRestrictionsDisabled)()?o.NODE_DISABLE_UNC_ACCESS_CHECKS="1":o.NODE_UNC_HOST_ALLOWLIST=(0,g.getUNCHostAllowlist)().join("\\")),(0,u.$Sl)(o);for(const r of Object.keys(o))o[r]=String(o[r]);return o}G(t,o,r){if(t.stdout){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stdout,"data")(n=>this.f.fire(typeof n=="string"?n:i.write(n))))}if(t.stderr){const i=new D.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(t.stderr,"data")(n=>this.g.fire(typeof n=="string"?n:i.write(n))))}this.B(s.Event.fromNodeEventEmitter(t,"message")(i=>this.h.fire(i))),this.B(s.Event.fromNodeEventEmitter(t,"spawn")(()=>{this.s=t.pid,typeof t.pid=="number"&&$.b.set(t.pid,{pid:t.pid,name:d(o)?`${o.type} [${o.responseWindowId}]`:o.type}),this.z("successfully created",p.default.Info),this.j.fire(t.pid)})),this.B(s.Event.fromNodeEventEmitter(t,"exit")(i=>{this.z(`received exit event with code ${i}`,p.default.Info),this.m.fire({pid:this.s,code:i,signal:"unknown"}),this.H()})),this.B(s.Event.fromNodeEventEmitter(P.app,"child-process-gone",(i,n)=>({event:i,details:n}))(({details:i})=>{i.type==="Utility"&&i.name===r&&(this.z(`crashed with code ${i.exitCode} and reason '${i.reason}'`,p.default.Error),this.w.publicLog2("utilityprocesscrash",{type:o.type,reason:i.reason,code:i.exitCode}),this.n.fire({pid:this.s,code:i.exitCode,reason:i.reason}),this.H())}))}once(t,o){const r=this.B(this.h.event(i=>{i===t&&(r.dispose(),o())}))}postMessage(t,o){this.r&&this.r.postMessage(t,o)}connect(t){const{port1:o,port2:r}=new P.MessageChannelMain;return this.postMessage(t,[r]),o}enableInspectPort(){if(!this.r||typeof this.s!="number")return!1;this.z("enabling inspect port",p.default.Info);const t=process;return typeof t._debugProcess=="function"?(t._debugProcess(this.s),!0):!1}kill(){if(!this.r)return;this.z("attempting to kill the process...",p.default.Info),this.r.kill()?(this.z("successfully killed the process",p.default.Info),this.H()):this.z("unable to kill the process",p.default.Warning)}H(){typeof this.s=="number"&&$.b.delete(this.s),this.r=void 0}async waitForExit(t){this.r&&(this.z("waiting to exit...",p.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,S.$7g)(t)]),this.r&&(this.z(`did not exit within ${t}ms, will kill it now...`,p.default.Info),this.kill()))}};e.$i$b=h,e.$i$b=h=$=ve([ne(0,j.$nj),ne(1,k.$ul),ne(2,v.$80b)],h);let m=class extends h{constructor(t,o,r,i){super(t,r,i),this.I=o}start(t){const o=this.I.getWindowById(t.responseWindowId);if(!o?.win||o.win.isDestroyed()||o.win.webContents.isDestroyed())return this.z("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.D(t))return!1;this.J(o.win,t);const i=this.connect(t.payload);return o.win.webContents.postMessage(t.responseChannel,t.responseNonce,[i]),!0}J(t,o){o.windowLifecycleBound&&(this.B(s.Event.filter(this.y.onWillLoadWindow,r=>r.window.win===t)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(t,"closed")(()=>this.kill())))}};e.$j$b=m,e.$j$b=m=ve([ne(0,j.$nj),ne(1,l.$N0b),ne(2,k.$ul),ne(3,v.$80b)],m)}),define(oe[293],ae([0,1,14,3,5,20,8,61,29,28]),function(X,e,P,R,s,j,D,S,f,l){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$q$b=void 0;let k=class{static{p=this}static{this.a=0}constructor(u,y,w,g){this.d=u,this.f=y,this.g=w,this.h=g,this.b=new Map,this.c=!1,this.f.onWillShutdown($=>{this.c=!0,$.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(u){const y=this.b.get(u);if(!y)throw new Error("Unknown extension host!");return y}onDynamicStdout(u){return this.i(u).onStdout}onDynamicStderr(u){return this.i(u).onStderr}onDynamicMessage(u){return this.i(u).onMessage}onDynamicExit(u){return this.i(u).onExit}async createExtensionHost(){if(this.c)throw(0,P.$6)();const u=String(++p.a),y=new S.$j$b(this.d,this.g,this.h,this.f);return this.b.set(u,y),y.onExit(({pid:w,code:g,signal:$})=>{this.d.info(`Extension host with pid ${w} exited with code: ${g}, signal: ${$}.`),setTimeout(()=>{y.dispose(),this.b.delete(u)}),setTimeout(()=>{try{process.kill(w,0),this.d.error(`Extension host with pid ${w} still exists, forcefully killing it...`),process.kill(w)}catch{}},1e3)}),{id:u}}async start(u,y){if(this.c)throw(0,P.$6)();const w=this.i(u);return w.start({...y,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:y.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:u}),{pid:await R.Event.toPromise(w.onSpawn)}}async enableInspectPort(u){if(this.c)throw(0,P.$6)();const y=this.b.get(u);return y?y.enableInspectPort():!1}async kill(u){if(this.c)throw(0,P.$6)();const y=this.b.get(u);y&&y.kill()}async _killAllNow(){for(const[,u]of this.b)u.kill()}async _waitForAllExit(u){const y=[];for(const[,w]of this.b)y.push(w.waitForExit(u));return D.Promises.settled(y).then(()=>{})}};e.$q$b=k,e.$q$b=k=p=ve([ne(0,s.$nj),ne(1,j.$80b),ne(2,f.$N0b),ne(3,l.$ul)],k)}),define(oe[294],ae([0,1,37,8,2,24,20,5,41,39,69,61,54,90,12,247]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T$b=void 0;let g=class extends s.$Tc{constructor(d,h,m,c,t,o,r,i){super(),this.c=d,this.f=h,this.g=m,this.h=c,this.j=t,this.m=o,this.n=r,this.r=i,this.a=new R.$5g,this.b=void 0,this.w=void 0,this.y=void 0,this.s()}s(){P.$AU.on(w.$R$b.request,(d,h)=>this.t(d,h,w.$R$b.response)),P.$AU.on(w.$S$b.request,(d,h)=>this.t(d,h,w.$S$b.response)),this.B(this.j.onWillShutdown(()=>this.u()))}async t(d,h,m){this.m.trace(`[SharedProcess] onWindowConnection for: ${m}`),this.a.isOpen()||this.a.open(),await this.whenReady();const c=await this.connect(m);if(d.sender.isDestroyed())return c.close();d.sender.postMessage(m,h,[c])}u(){this.m.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage(w.$Q$b.exit),this.b=void 0}whenReady(){return this.w||(this.w=(async()=>{await this.z;const d=new R.$qh;this.b?this.b.once(w.$Q$b.initDone,()=>d.complete()):P.$AU.once(w.$Q$b.initDone,()=>d.complete()),await d.p,this.m.trace("[SharedProcess] Overall ready")})()),this.w}get z(){return this.y||(this.y=(async()=>{await this.a.wait(),this.C();const d=new R.$qh;this.b?this.b.once(w.$Q$b.ipcReady,()=>d.complete()):P.$AU.once(w.$Q$b.ipcReady,()=>d.complete()),await d.p,this.m.trace("[SharedProcess] IPC ready")})()),this.y}C(){this.b=this.B(new k.$i$b(this.m,v.$No,this.j));const d=(0,u.$Dm)(this.g.args,this.g.isBuilt);let h;d.port&&(h=["--nolazy"],d.break?h.push(`--inspect-brk=${d.port}`):h.push(`--inspect=${d.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.D(),execArgv:h})}D(){return{machineId:this.c,sqmId:this.f,codeCachePath:this.g.codeCachePath,profiles:{home:this.h.profilesHome,all:this.h.profiles},args:this.g.args,logLevel:this.n.getLogLevel(),loggers:this.n.getRegisteredLoggers(),policiesData:this.r.serialize()}}async connect(d){return await this.z,(0,y.$Tf)(this.b).connect(d)}};e.$T$b=g,e.$T$b=g=ve([ne(2,j.$A0b),ne(3,f.$3k),ne(4,D.$80b),ne(5,S.$nj),ne(6,p.$30b),ne(7,l.$Jn)],g)}),define(oe[295],ae([0,1,24,90,20,5,54,61,111,37,2,3,35,18,13]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t_b=void 0;let w=class extends p.$Tc{constructor($,d,h,m,c){super(),this.f=$,this.g=d,this.h=h,this.j=m,this.m=c,this.a=void 0,this.b=new k.$Vd,this.onRequestConnection=this.b.event,this.c=new k.$Vd,this.onWillShutdown=this.c.event,this.j.onWillShutdown(()=>this.c.fire()),l.$AU.on("vscode:createPtyHostMessageChannel",(t,o)=>this.r(t,o)),this.B((0,p.$Rc)(()=>{l.$AU.removeHandler("vscode:createPtyHostMessageChannel")}))}start(){this.a=new S.$i$b(this.m,D.$No,this.j);const $=(0,R.$Cm)(this.h.args,this.h.isBuilt),d=$.port?["--nolazy",`--inspect${$.break?"-brk":""}=${$.port}`]:void 0;this.a.start({type:"ptyHost",entryPoint:"vs/platform/terminal/node/ptyHostMain",execArgv:d,args:["--logsPath",this.h.logsHome.with({scheme:y.Schemas.file}).fsPath],env:this.n()});const h=this.a.connect(),m=new f.$IU(h,"ptyHost"),c=new p.$Sc;return c.add(m),c.add((0,p.$Rc)(()=>{this.a?.kill(),this.a?.dispose(),this.a=void 0})),{client:m,store:c,onDidProcessExit:this.a.onExit}}n(){this.h.unsetSnapExportedVariables();const $={...(0,v.$vn)(process.env),VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:String(this.f.graceTime),VSCODE_RECONNECT_SHORT_GRACE_TIME:String(this.f.shortGraceTime),VSCODE_RECONNECT_SCROLLBACK:String(this.f.scrollback)},d=this.g.getValue("terminal.integrated.developer.ptyHost.latency");d&&typeof d=="number"&&($.VSCODE_LATENCY=String(d));const h=this.g.getValue("terminal.integrated.developer.ptyHost.startupDelay");return h&&typeof h=="number"&&($.VSCODE_STARTUP_DELAY=String(h)),this.h.restoreSnapExportedVariables(),$}r($,d){this.b.fire();const h=this.a.connect();if($.sender.isDestroyed()){h.close();return}$.sender.postMessage("vscode:createPtyHostMessageChannelResult",d,[h])}};e.$t_b=w,e.$t_b=w=ve([ne(1,u.$zi),ne(2,P.$A0b),ne(3,s.$80b),ne(4,j.$nj)],w)}),define(oe[296],ae([0,1,2,6,5,29,61,28,45,3,8,20]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$s_b=e.$r_b=void 0,e.$r_b=(0,R.$6h)("utilityProcessWorker");let v=class extends P.$Tc{constructor(w,g,$,d){super(),this.b=w,this.c=g,this.f=$,this.g=d,this.a=new Map}async createWorker(w){const g=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${g})`);const $=this.h(w);this.a.has($)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${g})`),this.disposeWorker(w));const d=new u(this.b,this.c,this.f,this.g,w);if(!d.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set($,d);const h=new p.$qh;return l.Event.once(d.onDidTerminate)(m=>{m.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${m.code}, signal: ${m.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${m.code}, signal: ${m.signal}`),this.a.delete($),h.complete({reason:m})}),h.p}h(w){return(0,f.$Ti)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const g=this.h(w),$=this.a.get(g);$&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),$.kill(),this.a.delete(g))}};e.$s_b=v,e.$s_b=v=ve([ne(0,s.$nj),ne(1,j.$N0b),ne(2,S.$ul),ne(3,k.$80b)],v);let u=class extends P.$Tc{constructor(w,g,$,d,h){super(),this.c=w,this.f=g,this.g=$,this.h=d,this.j=h,this.a=this.B(new l.$Vd),this.onDidTerminate=this.a.event,this.b=new D.$j$b(this.c,this.f,this.g,this.h),this.m()}m(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const g=this.f.getWindowById(this.j.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.j.process.type,entryPoint:this.j.process.moduleId,parentLifecycleBound:g,windowLifecycleBound:!0,correlationId:`${this.j.reply.windowId}`,responseWindowId:this.j.reply.windowId,responseChannel:this.j.reply.channel,responseNonce:this.j.reply.nonce})}kill(){this.b.kill()}};u=ve([ne(0,s.$nj),ne(1,j.$N0b),ne(2,S.$ul),ne(3,k.$80b)],u)}),define(oe[297],ae([0,1,15,3,2,273,29]),function(X,e,P,R,s,j,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_$b=void 0;let S=class extends s.$Tc{constructor(l){super(),this.b=l,this.a=this.B(new R.$Vd),this.onFoundInFrame=this.a.event,this.B(new j.$$$b)}async setIgnoreMenuShortcuts(l,p){let k;if(typeof l.windowId=="number"){const{windowId:v}=l,u=this.b.getWindowById(v);if(!u?.win)throw new Error(`Invalid windowId: ${v}`);k=u.win.webContents}else{const{webContentsId:v}=l;if(k=P.webContents.fromId(v),!k)throw new Error(`Invalid webContentsId: ${v}`)}k.isDestroyed()||k.setIgnoreMenuShortcuts(p)}async findInFrame(l,p,k,v){const y=this.c(l,p);if(typeof y.findInFrame=="function"){y.findInFrame(k,{findNext:v.findNext,forward:v.forward});const w=(g,$)=>{$.finalUpdate&&(this.a.fire($),y.removeListener("found-in-frame",w))};y.on("found-in-frame",w)}}async stopFindInFrame(l,p,k){const u=this.c(l,p);typeof u.stopFindInFrame=="function"&&u.stopFindInFrame(k.keepSelection?"keepSelection":"clearSelection")}c(l,p){const k=this.b.getWindowById(l.windowId);if(!k?.win)throw new Error(`Invalid windowId: ${l}`);const v=k.win.webContents.mainFrame.framesInSubtree.find(u=>u.name===p);if(!v)throw new Error(`Unknown frame: ${p}`);return v}};e.$_$b=S,e.$_$b=S=ve([ne(0,D.$N0b)],S)}),define(oe[298],ae([0,1,15,2,4,19,7,18,20,5,34,29,129,30]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.$c_b=e.$b_b=e.$a_b=void 0;let w=class extends R.$Tc{static{y=this}static{this.a="windowsState"}get state(){return this.b}constructor(c,t,o,r,i){super(),this.g=c,this.h=t,this.j=o,this.m=r,this.n=i,this.b=g(this.h.getItem(y.a)),this.c=void 0,this.f=!1,this.r()}r(){P.app.on("browser-window-blur",()=>{this.f||this.t()}),this.j.onBeforeCloseWindow(c=>this.u(c)),this.j.onBeforeShutdown(()=>this.s()),this.g.onDidChangeWindowsCount(c=>{c.newCount-c.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(c=>this.u(c))}s(){this.f=!0,this.t()}t(){const c=new Set,t={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!t.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(t.lastActiveWindow=this.w(i),t.lastActiveWindow.uiState.mode===3&&c.add(t.lastActiveWindow.uiState.display))}const o=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);o&&(t.lastPluginDevelopmentHostWindow=this.w(o),t.lastPluginDevelopmentHostWindow.uiState.mode===3&&(c.has(t.lastPluginDevelopmentHostWindow.uiState.display)?s.$j&&!o.win?.isSimpleFullScreen()&&(t.lastPluginDevelopmentHostWindow.uiState.mode=1):c.add(t.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(t.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.w(i);return n.uiState.mode===3&&(c.has(n.uiState.display)?s.$j&&n.windowId!==t.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):c.add(n.uiState.display)),n}));const r=d(t);this.h.setItem(y.a,r),this.f&&this.m.trace("[WindowsStateHandler] onBeforeShutdown",r)}u(c){if(this.j.quitRequested)return;const t=this.w(c);c.isExtensionDevelopmentHost&&!c.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=t:!c.isExtensionDevelopmentHost&&c.openedWorkspace&&this.b.openedWindows.forEach(o=>{const r=(0,u.$ii)(c.openedWorkspace)&&o.workspace?.id===c.openedWorkspace.id,i=(0,u.$di)(c.openedWorkspace)&&o.folderUri&&j.$yg.isEqual(o.folderUri,c.openedWorkspace.uri);(r||i)&&(o.uiState=t.uiState)}),this.g.getWindowCount()===1&&(this.c=t)}w(c){return{windowId:c.id,workspace:(0,u.$ii)(c.openedWorkspace)?c.openedWorkspace:void 0,folderUri:(0,u.$di)(c.openedWorkspace)?c.openedWorkspace.uri:void 0,backupPath:c.backupPath,remoteAuthority:c.remoteAuthority,uiState:c.serializeWindowState()}}getNewWindowState(c){const t=this.z(c),o=this.n.getValue("window");if(t.mode===3){let r;t.hasDefaultState?r=!!(o?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(o.newWindowDimensions)>=0):r=!!(this.j.wasRestarted||o?.restoreFullscreen),r||(t.mode=1)}return t}z(c){const t=this.g.getLastActiveWindow();if(!c.extensionTestsPath){if(c.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const b=c.workspace;if((0,u.$ii)(b)){const I=this.state.openedWindows.filter(E=>E.workspace&&E.workspace.id===b.id).map(E=>E.uiState);if(I.length)return I[0]}if((0,u.$di)(b)){const I=this.state.openedWindows.filter(E=>E.folderUri&&j.$yg.isEqual(E.folderUri,b.uri)).map(E=>E.uiState);if(I.length)return I[0]}else if(c.backupPath){const I=this.state.openedWindows.filter(E=>E.backupPath===c.backupPath).map(E=>E.uiState);if(I.length)return I[0]}const C=this.c||this.state.lastActiveWindow;if(!t&&C)return C.uiState}let o;const r=P.screen.getAllDisplays();if(r.length===1)o=r[0];else{if(s.$j){const b=P.screen.getCursorScreenPoint();o=P.screen.getDisplayNearestPoint(b)}!o&&t&&(o=P.screen.getDisplayMatching(t.getBounds())),o||(o=P.screen.getPrimaryDisplay()||r[0])}let i=(0,v.$z0b)();i.x=Math.round(o.bounds.x+o.bounds.width/2-i.width/2),i.y=Math.round(o.bounds.y+o.bounds.height/2-i.height/2);const n=this.n.getValue("window");let a=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,a=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,a=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&t){const b=t.serializeWindowState();b.mode===3?i.mode=3:i={...b,zoomLevel:void 0},a=i.mode!==3&&n.newWindowDimensions==="offset"}}return a&&(i=this.C(i)),i.hasDefaultState=!0,i}C(c){if(this.g.getWindows().length===0)return c;c.x=typeof c.x=="number"?c.x:0,c.y=typeof c.y=="number"?c.y:0;const t=this.g.getWindows().map(o=>o.getBounds());for(;t.some(o=>o.x===c.x||o.y===c.y);)c.x+=30,c.y+=30;return c}};e.$a_b=w,e.$a_b=w=y=ve([ne(0,k.$N0b),ne(1,p.$uO),ne(2,f.$80b),ne(3,l.$nj),ne(4,S.$zi)],w);function g(m){const c={openedWindows:[]},t=m||{openedWindows:[]};return t.lastActiveWindow&&(c.lastActiveWindow=$(t.lastActiveWindow)),t.lastPluginDevelopmentHostWindow&&(c.lastPluginDevelopmentHostWindow=$(t.lastPluginDevelopmentHostWindow)),Array.isArray(t.openedWindows)&&(c.openedWindows=t.openedWindows.map(o=>$(o))),c}e.$b_b=g;function $(m){const c={uiState:m.uiState};return m.backupPath&&(c.backupPath=m.backupPath),m.remoteAuthority&&(c.remoteAuthority=m.remoteAuthority),m.folder&&(c.folderUri=D.URI.parse(m.folder)),m.workspaceIdentifier&&(c.workspace={id:m.workspaceIdentifier.id,configPath:D.URI.parse(m.workspaceIdentifier.configURIPath)}),c}function d(m){return{lastActiveWindow:m.lastActiveWindow&&h(m.lastActiveWindow),lastPluginDevelopmentHostWindow:m.lastPluginDevelopmentHostWindow&&h(m.lastPluginDevelopmentHostWindow),openedWindows:m.openedWindows.map(c=>h(c))}}e.$c_b=d;function h(m){return{workspaceIdentifier:m.workspace&&{id:m.workspace.id,configURIPath:m.workspace.configPath.toString()},folder:m.folderUri&&m.folderUri.toString(),backupPath:m.backupPath,remoteAuthority:m.remoteAuthority,uiState:m.uiState}}}),define(oe[57],ae([0,1,15,3,42,2,13,9,19,21,194,66,55,24,6,5,56,131,30,97,98]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$20b=e.$10b=void 0,e.$10b=(0,y.$6h)("workspacesManagementMainService");let c=class extends j.$Tc{constructor(o,r,i,n,a){super(),this.g=o,this.h=r,this.j=i,this.m=n,this.n=a,this.a=this.B(new R.$Vd),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new R.$Vd),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const o=(await l.Promises.readdir(this.c.with({scheme:D.Schemas.file}).fsPath)).map(r=>(0,f.$Hg)(this.c,r,d.$si));for(const r of o){const i=(0,m.$X0b)(r),n=await this.resolveLocalWorkspace(r);n?this.f.push({workspace:i,remoteAuthority:n.remoteAuthority}):await this.deleteUntitledWorkspace(i)}}catch(o){o.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${o}).`)}}resolveLocalWorkspace(o){return this.r(o,r=>l.Promises.readFile(r,"utf8"))}r(o,r){if(this.s(o)&&o.scheme===D.Schemas.file)try{const i=r(o.fsPath);return i instanceof Promise?i.then(n=>this.t(o,n),n=>{}):this.t(o,i)}catch{return}}s(o){return(0,d.$ti)(o,this.g)||(0,d.$yi)(o)}t(o,r){try{const i=this.u(o,r),n=(0,m.$X0b)(o);return{id:n.id,configPath:n.configPath,folders:(0,h.$Jcb)(i.folders,n.configPath,f.$yg),remoteAuthority:i.remoteAuthority,transient:i.transient}}catch(i){this.h.warn(i.toString())}}u(o,r){const i=(0,s.$cn)(r);if(i&&Array.isArray(i.folders))i.folders=i.folders.filter(n=>(0,h.$Hcb)(n));else throw new Error(`${o.toString(!0)} looks like an invalid workspace file.`);return i}async createUntitledWorkspace(o,r){const{workspace:i,storedWorkspace:n}=this.w(o,r),a=i.configPath.fsPath;return await l.Promises.mkdir((0,S.$mc)(a),{recursive:!0}),await l.Promises.writeFile(a,JSON.stringify(n,null,"	")),this.f.push({workspace:i,remoteAuthority:r}),i}w(o=[],r){const i=(Date.now()+Math.round(Math.random()*1e3)).toString(),n=(0,f.$Hg)(this.c,i),a=(0,f.$Hg)(n,d.$si),b=[];for(const C of o)b.push((0,h.$Icb)(C.uri,!0,C.name,n,f.$yg));return{workspace:(0,m.$X0b)(a),storedWorkspace:{folders:b,remoteAuthority:r}}}async getWorkspaceIdentifier(o){return(0,m.$X0b)(o)}isUntitledWorkspace(o){return(0,d.$ti)(o.configPath,this.g)}async deleteUntitledWorkspace(o){this.isUntitledWorkspace(o)&&(await this.y(o),this.j.isEnabled()&&this.j.unsetWorkspace(o),this.a.fire(o))}async y(o){const r=(0,f.$vg)(o.configPath);try{await l.Promises.rm((0,S.$mc)(r));const i=(0,S.$jc)(this.g.workspaceStorageHome.with({scheme:D.Schemas.file}).fsPath,o.id);await l.Promises.exists(i)&&await l.Promises.writeFile((0,S.$jc)(i,"obsolete"),""),this.f=this.f.filter(n=>n.workspace.id!==o.id)}catch(i){this.h.warn(`Unable to delete untitled workspace ${r} (${i}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(o,r,i){if(!o||!o.win||!o.isReady||!await this.z(o,r,i))return;const a=await this.C(o,(0,m.$X0b)(i));if(a)return this.b.fire({window:o,workspace:a.workspace}),a}async z(o,r,i){return i?(0,d.$ii)(o.openedWorkspace)&&f.$yg.isEqual(o.openedWorkspace.configPath,i)?!1:(0,$.$U0b)(r,i)?(await this.n.showMessageBox({type:"info",buttons:[(0,p.localize)(0,null)],message:(0,p.localize)(1,null,(0,f.$Eg)(i)),detail:(0,p.localize)(2,null)},P.BrowserWindow.getFocusedWindow()??void 0),!1):!0:!0}async C(o,r){if(!o.config)return;o.focus();let i;return o.config.extensionDevelopmentPath||(o.config.backupPath?i=await this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority},o.config.backupPath):i=this.m.registerWorkspaceBackup({workspace:r,remoteAuthority:o.remoteAuthority})),(0,d.$ii)(o.openedWorkspace)&&this.isUntitledWorkspace(o.openedWorkspace)&&await this.deleteUntitledWorkspace(o.openedWorkspace),o.config.workspace=r,o.config.backupPath=i,{workspace:r,backupPath:i}}};e.$20b=c,e.$20b=c=ve([ne(0,u.$A0b),ne(1,w.$nj),ne(2,g.$R0b),ne(3,k.$F0b),ne(4,v.$G0b)],c)}),define(oe[133],ae([0,1,15,37,23,6,29,30,57,12,5,61]),function(X,e,P,R,s,j,D,S,f,l,p,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m$b=e.$l$b=e.ID=void 0,e.ID="diagnosticsMainService",e.$l$b=(0,j.$6h)(e.ID);let v=class{constructor(y,w,g){this.a=y,this.b=w,this.c=g}async getRemoteDiagnostics(y){const w=this.a.getWindows();return(await Promise.all(w.map(async $=>{const d=$.remoteAuthority;if(!d)return;const h=`vscode:getDiagnosticInfoResponse${$.id}`,m={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f($):void 0};return new Promise(c=>{$.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:h,args:m}),R.$AU.once(h,(t,o)=>{o||c({hostName:d,errorMessage:`Unable to resolve connection to '${d}'.`}),c(o)}),setTimeout(()=>{c({hostName:d,errorMessage:`Connection to '${d}' could not be established`})},5e3)})}))).filter($=>!!$)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const g of P.BrowserWindow.getAllWindows()){const $=this.a.getWindowById(g.id);$?y.push(await this.d($)):y.push(this.e(g))}const w=[];for(const{pid:g,name:$}of k.$i$b.getAll())w.push({pid:g,name:$});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:w,screenReader:!!P.app.accessibilitySupportEnabled,gpuFeatureStatus:P.app.getGPUFeatureStatus()}}async d(y){const w=await this.f(y),g=(0,l.$Tf)(y.win);return this.e(g,w,y.remoteAuthority)}e(y,w=[],g){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:w,remoteAuthority:g}}async f(y){const w=[],g=y.openedWorkspace;if((0,S.$di)(g))w.push(g.uri);else if((0,S.$ii)(g)){const $=await this.b.resolveLocalWorkspace(g.configPath);$&&$.folders.forEach(h=>{w.push(h.uri)})}return w}};e.$m$b=v,e.$m$b=v=ve([ne(0,D.$N0b),ne(1,f.$10b),ne(2,p.$nj)],v)}),define(oe[71],ae([0,1,48,15,26,156,50,3,2,13,9,4,7,106,88,21,104,182,55,24,6,20,5,27,70,29,30,57,17,243,235,65,14]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t,o,r,i,n,a,b,C,I,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$A$b=e.$z$b=void 0,e.$z$b=(0,m.$6h)("nativeHostMainService");let M=class extends f.$Tc{constructor(W,G,J,ce,re,ue,Z,Y,V,L){super(),this.a=W,this.b=G,this.c=J,this.f=ce,this.g=re,this.h=ue,this.j=Z,this.m=Y,this.n=V,this.r=L,this.onDidOpenMainWindow=S.Event.map(this.a.onDidOpenWindow,U=>U.id),this.onDidTriggerWindowSystemContextMenu=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidTriggerSystemContextMenu,({window:U,x:H,y:q})=>({windowId:U.id,x:H,y:q})),({windowId:U})=>!!this.a.getWindowById(U)),S.Event.filter(S.Event.map(this.b.onDidTriggerSystemContextMenu,({window:U,x:H,y:q})=>({windowId:U.id,x:H,y:q})),({windowId:U})=>!!this.b.getWindowById(U))),this.onDidMaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidMaximizeWindow,U=>U.id),U=>!!this.a.getWindowById(U)),S.Event.filter(S.Event.map(this.b.onDidMaximizeWindow,U=>U.id),U=>!!this.b.getWindowById(U))),this.onDidUnmaximizeWindow=S.Event.any(S.Event.filter(S.Event.map(this.a.onDidUnmaximizeWindow,U=>U.id),U=>!!this.a.getWindowById(U)),S.Event.filter(S.Event.map(this.b.onDidUnmaximizeWindow,U=>U.id),U=>!!this.b.getWindowById(U))),this.onDidChangeWindowFullScreen=S.Event.any(S.Event.map(this.a.onDidChangeFullScreen,U=>({windowId:U.window.id,fullscreen:U.fullscreen})),S.Event.map(this.b.onDidChangeFullScreen,U=>({windowId:U.window.id,fullscreen:U.fullscreen}))),this.onDidBlurMainWindow=S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(U,H)=>H.id),U=>!!this.a.getWindowById(U)),this.onDidFocusMainWindow=S.Event.any(S.Event.map(S.Event.filter(S.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),U=>!!U),U=>U.id),S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(U,H)=>H.id),U=>!!this.a.getWindowById(U))),this.onDidBlurMainOrAuxiliaryWindow=S.Event.any(this.onDidBlurMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-blur",(U,H)=>H),U=>(0,E.$M0b)(U.webContents)),U=>U.id)),this.onDidFocusMainOrAuxiliaryWindow=S.Event.any(this.onDidFocusMainWindow,S.Event.map(S.Event.filter(S.Event.fromNodeEventEmitter(R.app,"browser-window-focus",(U,H)=>H),U=>(0,E.$M0b)(U.webContents)),U=>U.id)),this.onDidResumeOS=S.Event.fromNodeEventEmitter(R.powerMonitor,"resume"),this.onDidChangeColorScheme=this.m.onDidChangeColorScheme,this.s=this.B(new S.$Vd),this.onDidChangePassword=this.s.event,this.onDidChangeDisplay=S.Event.debounce(S.Event.any(S.Event.filter(S.Event.fromNodeEventEmitter(R.screen,"display-metrics-changed",(U,H,q)=>q),U=>!(Array.isArray(U)&&U.length===1&&U[0]==="workArea")),S.Event.fromNodeEventEmitter(R.screen,"display-added"),S.Event.fromNodeEventEmitter(R.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(W,G){const J=this.a.getWindows().map(re=>({id:re.id,workspace:re.openedWorkspace??(0,n.$hi)(re.backupPath,re.isExtensionDevelopmentHost),title:re.win?.getTitle()??"",filename:re.getRepresentedFilename(),dirty:re.isDocumentEdited()})),ce=[];return G.includeAuxiliaryWindows&&ce.push(...this.b.getWindows().map(re=>({id:re.id,parentId:re.parentId,title:re.win?.getTitle()??"",filename:re.getRepresentedFilename()}))),[...J,...ce]}async getWindowCount(W){return this.a.getWindowCount()}async getActiveWindowId(W){const G=this.a.getFocusedWindow()||this.a.getLastActiveWindow();if(G)return G.id}openWindow(W,G,J){return Array.isArray(G)?this.t(W,G,J):this.u(W,G)}async t(W,G,J=Object.create(null)){G.length>0&&await this.a.open({context:5,contextWindowId:W,urisToOpen:G,cli:this.g.args,forceNewWindow:J.forceNewWindow,forceReuseWindow:J.forceReuseWindow,preferNewWindow:J.preferNewWindow,diffMode:J.diffMode,mergeMode:J.mergeMode,addMode:J.addMode,gotoLineMode:J.gotoLineMode,noRecentEntry:J.noRecentEntry,waitMarkerFileURI:J.waitMarkerFileURI,remoteAuthority:J.remoteAuthority||void 0,forceProfile:J.forceProfile,forceTempProfile:J.forceTempProfile})}async u(W,G){await this.a.openEmptyWindow({context:5,contextWindowId:W},G)}async toggleFullScreen(W,G){this.D(G?.targetWindowId,W)?.toggleFullScreen()}async handleTitleDoubleClick(W,G){this.D(G?.targetWindowId,W)?.handleTitleDoubleClick()}async getCursorScreenPoint(W){const G=R.screen.getCursorScreenPoint(),J=R.screen.getDisplayNearestPoint(G);return{point:G,display:J.bounds}}async isMaximized(W,G){return this.D(G?.targetWindowId,W)?.win?.isMaximized()??!1}async maximizeWindow(W,G){this.D(G?.targetWindowId,W)?.win?.maximize()}async unmaximizeWindow(W,G){this.D(G?.targetWindowId,W)?.win?.unmaximize()}async minimizeWindow(W,G){this.D(G?.targetWindowId,W)?.win?.minimize()}async moveWindowTop(W,G){this.D(G?.targetWindowId,W)?.win?.moveTop()}async positionWindow(W,G,J){const ce=this.D(J?.targetWindowId,W);if(ce?.win){if(ce.win.isFullScreen()){const re=S.Event.toPromise(S.Event.once(S.Event.fromNodeEventEmitter(ce.win,"leave-full-screen")));ce.win.setFullScreen(!1),await re}ce.win.setBounds(G)}}async updateWindowControls(W,G){this.D(G?.targetWindowId,W)?.updateWindowControls(G)}async focusWindow(W,G){this.D(G?.targetWindowId,W)?.focus({force:G?.force??!1})}async setMinimumSize(W,G,J){const ce=this.F(W);if(ce?.win){const[re,ue]=ce.win.getSize(),[Z,Y]=ce.win.getMinimumSize(),[V,L]=[G??Z,J??Y],[U,H]=[Math.max(re,V),Math.max(ue,L)];(Z!==V||Y!==L)&&ce.win.setMinimumSize(V,L),(re!==U||ue!==H)&&ce.win.setSize(U,H)}}async saveWindowSplash(W,G){this.m.saveWindowSplash(W,G)}async installShellCommand(W){const{source:G,target:J}=await this.w();try{const{symbolicLink:ce}=await w.SymlinkSupport.stat(G);if(ce&&!ce.dangling){const re=await(0,u.$vq)(G);if(J===re)return}await w.Promises.unlink(G)}catch(ce){if(ce.code!=="ENOENT")throw ce}try{await w.Promises.symlink(J,G)}catch(ce){if(ce.code!=="EACCES"&&ce.code!=="ENOENT")throw ce;const{response:re}=await this.showMessageBox(W,{type:"info",message:(0,$.localize)(0,null,this.j.nameShort),buttons:[(0,$.localize)(1,null),(0,$.localize)(2,null)]});if(re===1)throw new A.$5;try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${J}' '${G}'\\" with administrator privileges"`;await(0,j.promisify)(P.exec)(ue)}catch{throw new Error((0,$.localize)(3,null,G))}}}async uninstallShellCommand(W){const{source:G}=await this.w();try{await w.Promises.unlink(G)}catch(J){switch(J.code){case"EACCES":{const{response:ce}=await this.showMessageBox(W,{type:"info",message:(0,$.localize)(4,null,this.j.nameShort),buttons:[(0,$.localize)(5,null),(0,$.localize)(6,null)]});if(ce===1)throw new A.$5;try{const re=`osascript -e "do shell script \\"rm '${G}'\\" with administrator privileges"`;await(0,j.promisify)(P.exec)(re)}catch{throw new Error((0,$.localize)(7,null,G))}break}case"ENOENT":break;default:throw J}}}async w(){const W=(0,p.$kc)(this.g.appRoot,"bin","code"),G=`/usr/local/bin/${this.j.applicationName}`;if(!await w.Promises.exists(W))throw new Error((0,$.localize)(8,null,W));return{source:G,target:W}}async showMessageBox(W,G){const J=this.H(W);return this.c.showMessageBox(G,J?.win??void 0)}async showSaveDialog(W,G){const J=this.H(W);return this.c.showSaveDialog(G,J?.win??void 0)}async showOpenDialog(W,G){const J=this.H(W);return this.c.showOpenDialog(G,J?.win??void 0)}async pickFileFolderAndOpen(W,G){const J=await this.c.pickFileFolder(G);J&&await this.z(await Promise.all(J.map(async ce=>await w.SymlinkSupport.existsDirectory(ce)?{folderUri:v.URI.file(ce)}:{fileUri:v.URI.file(ce)})),G,W)}async pickFolderAndOpen(W,G){const J=await this.c.pickFolder(G);J&&await this.z(J.map(ce=>({folderUri:v.URI.file(ce)})),G,W)}async pickFileAndOpen(W,G){const J=await this.c.pickFile(G);J&&await this.z(J.map(ce=>({fileUri:v.URI.file(ce)})),G,W)}async pickWorkspaceAndOpen(W,G){const J=await this.c.pickWorkspace(G);J&&await this.z(J.map(ce=>({workspaceUri:v.URI.file(ce)})),G,W)}async z(W,G,J){await this.a.open({context:3,contextWindowId:J,cli:this.g.args,urisToOpen:W,forceNewWindow:G.forceNewWindow})}async showItemInFolder(W,G){R.shell.showItemInFolder(G)}async setRepresentedFilename(W,G,J){this.D(J?.targetWindowId,W)?.setRepresentedFilename(G)}async setDocumentEdited(W,G,J){this.D(J?.targetWindowId,W)?.setDocumentEdited(G)}async openExternal(W,G){return this.g.unsetSnapExportedVariables(),R.shell.openExternal(G),this.g.restoreSnapExportedVariables(),!0}moveItemToTrash(W,G){return R.shell.trashItem(G)}async isAdmin(){let W;return k.$i?W=(await new Promise((G,J)=>{X(["native-is-elevated"],G,J)}))():W=process.getuid?.()===0,W}async writeElevated(W,G,J,ce){const re=await new Promise((ue,Z)=>{X(["@vscode/sudo-prompt"],ue,Z)});return new Promise((ue,Z)=>{const Y=[`"${this.C}"`];ce?.unlock&&Y.push("--file-chmod"),Y.push("--file-write",`"${G.fsPath}"`,`"${J.fsPath}"`);const V={name:this.j.nameLong.replace("-",""),icns:k.$j&&this.g.isBuilt?(0,p.$jc)((0,p.$mc)(this.g.appRoot),`${this.j.nameShort}.icns`):void 0};re.exec(Y.join(" "),V,(L,U,H)=>{U&&this.h.trace(`[sudo-prompt] received stdout: ${U}`),H&&this.h.trace(`[sudo-prompt] received stderr: ${H}`),L?Z(L):ue(void 0)})})}async isRunningUnderARM64Translation(){return k.$k||k.$i?!1:R.app.runningUnderARM64Translation}get C(){return k.$i?this.g.isBuilt?(0,p.$jc)((0,p.$mc)(process.execPath),"bin",`${this.j.applicationName}.cmd`):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.bat"):k.$k?this.g.isBuilt?(0,p.$jc)((0,p.$mc)(process.execPath),"bin",`${this.j.applicationName}`):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.sh"):this.g.isBuilt?(0,p.$jc)(this.g.appRoot,"bin","code"):(0,p.$jc)(this.g.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.$0m.value()}async getOSColorScheme(){return this.m.getColorScheme()}async hasWSLFeatureInstalled(){return k.$i&&(0,C.$x$b)()}async killProcess(W,G,J){process.kill(G,J)}async readClipboardText(W,G){return R.clipboard.readText(G)}async writeClipboardText(W,G,J){return R.clipboard.writeText(G,J)}async readClipboardFindText(W){return R.clipboard.readFindText()}async writeClipboardFindText(W,G){return R.clipboard.writeFindText(G)}async writeClipboardBuffer(W,G,J,ce){return R.clipboard.writeBuffer(G,Buffer.from(J.buffer),ce)}async readClipboardBuffer(W,G){return b.$je.wrap(R.clipboard.readBuffer(G))}async hasClipboard(W,G,J){return R.clipboard.has(G,J)}async newWindowTab(){await this.a.open({context:5,cli:this.g.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.g.args.remote||void 0})}async showPreviousWindowTab(){R.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){R.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){R.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){R.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){R.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(W,G){this.F(W)?.updateTouchBar(G)}async notifyReady(W){this.F(W)?.setReady()}async relaunch(W,G){return this.f.relaunch(G)}async reload(W,G){const J=this.F(W);if(J){if((0,n.$ii)(J.openedWorkspace)){const ce=J.openedWorkspace.configPath;if(ce.scheme===l.Schemas.file&&(await this.n.resolveLocalWorkspace(ce))?.transient)return this.openWindow(J.id,{forceReuseWindow:!0})}return this.f.reload(J,G?.disableExtensions!==void 0?{_:[],"disable-extensions":G.disableExtensions}:void 0)}}async closeWindow(W,G){return this.D(G?.targetWindowId,W)?.win?.close()}async quit(W){const G=this.a.getLastActiveWindow();G?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&G.win?G.win.close():this.f.quit()}async exit(W,G){await this.f.kill(G)}async resolveProxy(W,G){return this.F(W)?.win?.webContents?.session?.resolveProxy(G)}async loadCertificates(W){return(await new Promise((J,ce)=>{X(["@vscode/proxy-agent"],J,ce)})).loadSystemCertificates({log:this.h})}findFreePort(W,G,J,ce,re=1){return(0,g.$sg)(G,J,ce,re)}async openDevTools(W,G){this.H(W)?.win?.webContents.openDevTools(G)}async toggleDevTools(W){this.H(W)?.win?.webContents.toggleDevTools()}async profileRenderer(W,G,J){const ce=this.F(W);if(!ce||!ce.win)throw new Error;return await new I.$y$b(ce.win,G,this.h).inspect(J)}async windowsGetStringRegKey(W,G,J,ce){if(!k.$i)return;const re=await new Promise((ue,Z)=>{X(["@vscode/windows-registry"],ue,Z)});try{return re.GetStringRegKey(G,J,ce)}catch{return}}D(W,G){return this.F(W)??this.G(W)??this.F(G)}F(W){if(typeof W=="number")return this.a.getWindowById(W)}G(W){if(typeof W=="number")return this.b.getWindowById(W)}H(W){let G=this.r.invokeFunction(i.$P0b);return G||(G=this.D(W)),G}};e.$A$b=M,ve([D.$xh],M.prototype,"C",null),e.$A$b=M=ve([ne(0,i.$N0b),ne(1,E.$L0b),ne(2,d.$G0b),ne(3,c.$80b),ne(4,h.$A0b),ne(5,t.$nj),ne(6,o.$Fj),ne(7,r.$J0b),ne(8,a.$10b),ne(9,m.$5h)],M)}),define(oe[299],ae([0,1,15,26,8,23,33,2,13,4,7,108,37,180,91,133,55,24,5,71,79,27,80,34,61,60,29]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t,o,r,i,n){"use strict";var a;Object.defineProperty(e,"__esModule",{value:!0}),e.$B$b=void 0;const b="issue.processExplorerWindowState";let C=class{static{a=this}static{this.a="#1E1E1E"}constructor(A,M,T,W,G,J,ce,re,ue,Z,Y){this.g=A,this.h=M,this.i=T,this.j=W,this.k=G,this.l=J,this.m=ce,this.n=re,this.o=ue,this.p=Z,this.q=Y,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){v.$AU.on("vscode:listProcesses",async A=>{const M=[];try{M.push({name:(0,u.localize)(0,null),rootProcess:await(0,k.$5r)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(W=>{(0,y.$Jm)(W)?M.push({name:W.hostName,rootProcess:W}):W.processes&&M.push({name:W.hostName,rootProcess:W.processes})})}catch(T){this.i.error(`Listing processes failed: ${T}`)}this.t(A,"vscode:listProcessesResponse",M)}),v.$AU.on("vscode:workbenchCommand",(A,M)=>{const{id:T,from:W,args:G}=M;let J;switch(W){case"processExplorer":J=this.f;break;default:throw new Error(`Unexpected command source: ${W}`)}J?.webContents.send("vscode:runAction",{id:T,from:W,args:G})}),v.$AU.on("vscode:closeProcessExplorer",A=>{this.d?.close()}),v.$AU.on("vscode:pidToNameRequest",async A=>{const M=await this.k.getMainDiagnostics(),T=[];for(const W of M.windows)T.push([W.pid,`window [${W.id}] (${W.title})`]);for(const{pid:W,name:G}of r.$i$b.getAll())T.push([W,G]);this.t(A,"vscode:pidToNameResponse",T)})}async openReporter(A){if(!this.b&&(this.c=P.BrowserWindow.getFocusedWindow(),this.c)){const M=new S.$Sc,T=M.add(this.n.createIPCObjectUrl()),W=this.v(this.c,700,800);this.b=this.u(W,T,{backgroundColor:A.styles.backgroundColor,title:(0,u.localize)(1,null),zoomLevel:A.zoomLevel,alwaysOnTop:!1},"issue-reporter"),T.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:A,disableExtensions:!!this.h.disableExtensions,os:{type:(0,R.type)(),arch:(0,R.arch)(),release:(0,R.release)()},product:m.default}),this.b.loadURL(f.$og.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,M.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,M.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(A){if(!this.d&&(this.f=P.BrowserWindow.getFocusedWindow(),this.f)){const M=new S.$Sc,T=M.add(this.n.createIPCObjectUrl()),W=this.p.getItem(b,void 0),G=I(W)?W:this.v(this.f,800,500);this.d=this.u(G,T,{backgroundColor:A.styles.backgroundColor,title:(0,u.localize)(2,null),zoomLevel:A.zoomLevel,alwaysOnTop:!0},"process-explorer"),T.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:A,product:m.default}),this.d.loadURL(f.$og.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,M.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,M.dispose())});const J=()=>{if(!this.d)return;const ce=this.d.getSize(),re=this.d.getPosition();if(!ce||!re)return;const ue={width:ce[0],height:ce[1],x:re[0],y:re[1]};this.p.setItem(b,ue)};this.d.on("moved",J),this.d.on("resized",J)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const A=await P.contentTracing.stopRecording(`${(0,D.$dg)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,u.localize)(3,null),detail:(0,u.localize)(4,null,A),buttons:[(0,u.localize)(5,null)]},P.BrowserWindow.getFocusedWindow()??void 0),this.m.showItemInFolder(void 0,A)}async getSystemStatus(){const[A,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(A,M)}async $getSystemInfo(){const[A,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(A,M)}async $getPerformanceInfo(){try{const[A,M]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(A,M)}catch(A){throw this.i.warn("issueService#getPerformanceInfo ",A.message),A}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(A){this.i.error(A)}}async $showConfirmCloseDialog(){if(this.b){const{response:A}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(6,null),buttons:[(0,u.localize)(7,null),(0,u.localize)(8,null)]},this.b);A===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:A}=await this.l.showMessageBox({type:"warning",message:(0,u.localize)(9,null),buttons:[(0,u.localize)(10,null),(0,u.localize)(11,null)]},this.b);return A===0}return!1}issueReporterWindowCheck(){if(!this.c)throw new Error("Issue reporter window not available");const A=this.q.getWindowById(this.c.id);if(!A)throw new Error("Window not found");return A}async $getIssueReporterUri(A){const M=this.issueReporterWindowCheck(),T=`vscode:triggerIssueUriRequestHandlerResponse${M.id}`;return s.Promises.withAsyncBody(async(W,G)=>{const J=new j.$6d;M.sendWhenReady("vscode:triggerIssueUriRequestHandler",J.token,{replyChannel:T,extensionId:A}),v.$AU.once(T,(ce,re)=>{W(p.URI.parse(re))});try{await(0,s.$7g)(5e3),J.cancel(),G(new Error("Timed out waiting for issue reporter URI"))}finally{v.$AU.removeHandler(T)}})}async $getIssueReporterData(A){const M=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataProviderResponse${M.id}`;return s.Promises.withAsyncBody(async W=>{const G=new j.$6d;M.sendWhenReady("vscode:triggerIssueDataProvider",G.token,{replyChannel:T,extensionId:A}),v.$AU.once(T,(J,ce)=>{W(ce)});try{await(0,s.$7g)(5e3),G.cancel(),W("Error: Extension timed out waiting for issue reporter data")}finally{v.$AU.removeHandler(T)}})}async $getIssueReporterTemplate(A){const M=this.issueReporterWindowCheck(),T=`vscode:triggerIssueDataTemplateResponse${M.id}`;return s.Promises.withAsyncBody(async W=>{const G=new j.$6d;M.sendWhenReady("vscode:triggerIssueDataTemplate",G.token,{replyChannel:T,extensionId:A}),v.$AU.once(T,(J,ce)=>{W(ce)});try{await(0,s.$7g)(5e3),G.cancel(),W("Error: Extension timed out waiting for issue reporter template")}finally{v.$AU.removeHandler(T)}})}async $getReporterStatus(A,M){const T=[!1,!1],W=this.issueReporterWindowCheck(),G="vscode:triggerReporterStatus",J=new j.$6d;return W.sendWhenReady(G,J.token,{replyChannel:G,extensionId:A,extensionName:M}),await(0,s.$Xg)(new Promise(re=>v.$AU.once("vscode:triggerReporterStatusResponse",(ue,Z)=>re(Z))),2e3,()=>{this.i.error("Error: Extension timed out waiting for reporter status"),J.cancel()})??T}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(A){A.isMinimized()&&A.restore(),A.focus()}t(A,M,...T){A.sender.isDestroyed()||A.sender.send(M,...T)}u(A,M,T,W){const G=new P.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:A.width,height:A.height,minWidth:300,minHeight:200,x:A.x,y:A.y,title:T.title,backgroundColor:T.backgroundColor||a.a,webPreferences:{preload:f.$og.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${M.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,i.$WC)(T.zoomLevel),sandbox:!0},alwaysOnTop:T.alwaysOnTop,experimentalDarkMode:!0});return G.setMenuBarVisibility(!1),G}v(A,M,T){let W;const G=P.screen.getAllDisplays();if(G.length===1)W=G[0];else{if(l.$j){const re=P.screen.getCursorScreenPoint();W=P.screen.getDisplayNearestPoint(re)}!W&&A&&(W=P.screen.getDisplayMatching(A.getBounds())),W||(W=P.screen.getPrimaryDisplay()||G[0])}const J=W.bounds,ce={width:M,height:T,x:J.x+J.width/2-M/2,y:J.y+J.height/2-T/2};return J.width>0&&J.height>0&&(ce.x<J.x&&(ce.x=J.x),ce.y<J.y&&(ce.y=J.y),ce.x>J.x+J.width&&(ce.x=J.x),ce.y>J.y+J.height&&(ce.y=J.y),ce.width>J.width&&(ce.width=J.width),ce.height>J.height&&(ce.height=J.height)),ce}};e.$B$b=C,e.$B$b=C=a=ve([ne(1,$.$A0b),ne(2,d.$nj),ne(3,y.$Im),ne(4,w.$l$b),ne(5,g.$G0b),ne(6,h.$z$b),ne(7,t.$I0b),ne(8,c.$Fj),ne(9,o.$uO),ne(10,n.$N0b)],C);function I(E){return typeof E!="object"||E===null?!1:"x"in E&&"y"in E&&"width"in E&&"height"in E}}),define(oe[300],ae([0,1,23,18,24,20,5,71,27,53,28,49,100]),function(X,e,P,R,s,j,D,S,f,l,p,k,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3$b=void 0;let u=class extends v.$1$b{constructor(w,g,$,d,h,m,c,t){super(w,g,d,h,m,t),this.e=$,this.u=c}s(w){return(0,v.$Z$b)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(k.$yV.CheckingForUpdates(w)),this.i.request({url:this.a},P.CancellationToken.None).then(l.$np).then(g=>{!g||!g.url||!g.version||!g.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(k.$yV.Idle(1))):this.d(k.$yV.AvailableForDownload(g))}).then(void 0,g=>{this.j.error(g);const $=w?g.message||g:void 0;this.d(k.$yV.Idle(1,$))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(k.$yV.Idle(1))}};e.$3$b=u,e.$3$b=u=ve([ne(0,j.$80b),ne(1,R.$zi),ne(2,p.$ul),ne(3,s.$A0b),ne(4,l.$hp),ne(5,D.$nj),ne(6,S.$z$b),ne(7,f.$Fj)],u)}),define(oe[301],ae([0,1,48,46,26,8,23,50,45,9,7,144,21,18,24,16,20,5,71,27,53,28,49,100]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5$b=void 0;async function r(b,C=1e3){for(;!b();)await(0,j.$7g)(C)}let i;function n(){return typeof i>"u"&&(i=R.existsSync(l.$jc(l.$mc(process.execPath),"unins000.exe"))?0:1),i}let a=class extends o.$1$b{get cachePath(){const C=l.$jc((0,s.tmpdir)(),`vscode-${this.k.quality}-${this.k.target}-${process.arch}`);return v.Promises.mkdir(C,{recursive:!0}).then(()=>C)}constructor(C,I,E,A,M,T,W,G,J){super(C,I,A,M,T,J),this.u=E,this.v=W,this.w=G,C.setRelaunchHandler(this)}handleRelaunch(C){return C?.addArgs||C?.removeArgs||this.state.type!=="ready"||!this.e?!1:(this.j.trace("update#handleRelaunch(): running raw#quitAndInstall()"),this.r(),!0)}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.d(t.$yV.Disabled(5)),this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(C){let I=`win32-${process.arch}`;return n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,o.$Z$b)(I,C,this.k)}t(C){this.a&&(this.d(t.$yV.CheckingForUpdates(C)),this.i.request({url:this.a},D.CancellationToken.None).then(m.$np).then(I=>{const E=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!C}),this.d(t.$yV.Idle(E)),Promise.resolve(null)):E===1?(this.d(t.$yV.AvailableForDownload(I)),Promise.resolve(null)):(this.d(t.$yV.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(A=>v.Promises.exists(A).then(M=>{if(M)return Promise.resolve(A);const T=`${A}.tmp`;return this.i.request({url:I.url},D.CancellationToken.None).then(W=>this.v.writeFile(p.URI.file(T),W.stream)).then(I.sha256hash?()=>(0,k.$vU)(T,I.sha256hash):()=>{}).then(()=>v.Promises.rename(T,A,!1)).then(()=>A)})).then(A=>{const M=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:A},M?this.k.target==="user"?this.p():this.d(t.$yV.Downloaded(I)):this.d(t.$yV.Ready(I))})))}).then(void 0,I=>{this.u.publicLog2("update:error",{messageHash:String((0,f.$Ti)(String(I)))}),this.j.error(I);const E=C?I.message||I:void 0;this.d(t.$yV.Idle(n(),E))}))}async o(C){C.update.url&&this.w.openExternal(void 0,C.update.url),this.d(t.$yV.Idle(n()))}async B(C){const I=await this.cachePath;return l.$jc(I,`CodeSetup-${this.k.quality}-${C}.exe`)}async C(C=null){const I=C?T=>!new RegExp(`${this.k.quality}-${C}\\.exe$`).test(T):()=>!0,E=await this.cachePath,M=(await v.Promises.readdir(E)).filter(I).map(async T=>{try{await v.Promises.unlink(l.$jc(E,T))}catch{}});await Promise.all(M)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const C=this.state.update;this.d(t.$yV.Updating(C));const I=await this.cachePath;this.e.updateFilePath=l.$jc(I,`CodeSetup-${this.k.quality}-${C.version}.flag`),await v.Promises.writeFile(this.e.updateFilePath,"flag"),(0,P.spawn)(this.e.packagePath,["/verysilent","/log",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(t.$yV.Idle(n()))});const A=`${this.k.win32MutexName}-ready`,M=await new Promise((T,W)=>{X(["@vscode/windows-mutex"],T,W)});r(()=>M.isActive(A)).then(()=>this.d(t.$yV.Ready(C)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.e.updateFilePath?R.unlinkSync(this.e.updateFilePath):(0,P.spawn)(this.e.packagePath,["/silent","/log","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(C){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),E={version:"unknown",productVersion:"unknown"};this.d(t.$yV.Downloading(E)),this.e={packagePath:C},I?this.k.target==="user"?this.p():this.d(t.$yV.Downloaded(E)):this.d(t.$yV.Ready(E))}};e.$5$b=a,ve([S.$xh],a.prototype,"cachePath",null),e.$5$b=a=ve([ne(0,g.$80b),ne(1,u.$zi),ne(2,c.$ul),ne(3,y.$A0b),ne(4,m.$hp),ne(5,$.$nj),ne(6,w.$qk),ne(7,d.$z$b),ne(8,h.$Fj)],a)}),define(oe[134],ae([0,1,15,8,23,51,3,2,13,68,4,7,190,26,66,18,55,24,64,16,20,5,27,80,252,82,28,103,70,60,29,30,57,129,39,34,56,69,22,6]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t,o,r,i,n,a,b,C,I,E,A,M,T,W,G,J,ce,re){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$60b=e.$50b=void 0;var ue;(function(V){V[V.NONE=0]="NONE",V[V.NAVIGATING=1]="NAVIGATING",V[V.READY=2]="READY"})(ue||(ue={}));class Z extends S.$Tc{get lastFocusTime(){return this.j}get win(){return this.m}n(L){this.m=L,this.B(D.Event.fromNodeEventEmitter(L,"maximize")(()=>this.b.fire())),this.B(D.Event.fromNodeEventEmitter(L,"unmaximize")(()=>this.c.fire())),this.B(D.Event.fromNodeEventEmitter(L,"closed")(()=>{this.a.fire(),this.dispose()})),this.B(D.Event.fromNodeEventEmitter(L,"focus")(()=>{this.j=Date.now()})),this.B(D.Event.fromNodeEventEmitter(this.m,"enter-full-screen")(()=>this.g.fire())),this.B(D.Event.fromNodeEventEmitter(this.m,"leave-full-screen")(()=>this.h.fire()));const U=(0,C.$TC)(this.r)==="custom";if(p.$j&&U&&L.setSheetOffset((0,p.$J)((0,u.release)())?28:22),U&&(p.$i&&(0,C.$UC)(this.r)||p.$j)){const H=this.s.getItem(Z.z);H&&this.updateWindowControls({height:H})}p.$i&&U&&L.hookWindowMessage(278,()=>{const[q,ee]=L.getPosition(),he=P.screen.getCursorScreenPoint(),K=he.x-q,O=he.y-ee;return(()=>!(K>30&&O>=0&&O<=Math.max(L.getBounds().height*.15,35)))()||(L.setEnabled(!1),L.setEnabled(!0),this.f.fire({x:K,y:O})),0}),this.t.args["open-devtools"]===!0&&L.webContents.openDevTools()}constructor(L,U,H){super(),this.r=L,this.s=U,this.t=H,this.a=this.B(new D.$Vd),this.onDidClose=this.a.event,this.b=this.B(new D.$Vd),this.onDidMaximize=this.b.event,this.c=this.B(new D.$Vd),this.onDidUnmaximize=this.c.event,this.f=this.B(new D.$Vd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=this.B(new D.$Vd),this.onDidEnterFullScreen=this.g.event,this.h=this.B(new D.$Vd),this.onDidLeaveFullScreen=this.h.event,this.j=Date.now(),this.m=null,this.C=(0,C.$UC)(this.r),this.D=void 0,this.F=void 0}setRepresentedFilename(L){p.$j?this.win?.setRepresentedFilename(L):this.u=L}getRepresentedFilename(){return p.$j?this.win?.getRepresentedFilename():this.u}setDocumentEdited(L){p.$j&&this.win?.setDocumentEdited(L),this.w=L}isDocumentEdited(){return p.$j?!!this.win?.isDocumentEdited():!!this.w}focus(L){p.$j&&L?.force&&P.app.focus({steal:!0});const U=this.win;U&&(U.isMinimized()&&U.restore(),U.focus())}handleTitleDoubleClick(){const L=this.win;if(L)if(p.$j)switch(P.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":L.minimize();break;case"None":break;case"Maximize":default:L.isMaximized()?L.unmaximize():L.maximize()}else L.isMaximized()?L.unmaximize():L.maximize()}static{this.z="windowControlHeight"}updateWindowControls(L){const U=this.win;if(U){if(L.height&&this.s.setItem(Y.z,L.height),p.$i&&this.C)U.setTitleBarOverlay({color:L.backgroundColor?.trim()===""?void 0:L.backgroundColor,symbolColor:L.foregroundColor?.trim()===""?void 0:L.foregroundColor,height:L.height?L.height-1:void 0});else if(p.$j&&L.height!==void 0){const H=(L.height-15)/2;H?U.setWindowButtonPosition({x:H,y:H}):U.setWindowButtonPosition(null)}}}toggleFullScreen(){this.G(!this.isFullScreen)}G(L){(0,C.$VC)(this.r)?this.H(L):this.J(L)}get isFullScreen(){if(p.$j&&typeof this.D=="boolean")return this.D;const L=this.win,U=L?.isFullScreen(),H=L?.isSimpleFullScreen();return!!(U||H)}H(L){const U=this.win;U?.isSimpleFullScreen()&&U?.setSimpleFullScreen(!1),this.I(L)}I(L){p.$j&&(this.D=L,this.F=new R.$qh,Promise.race([this.F.p,(0,R.$7g)(1e4)]).finally(()=>{this.D=void 0})),this.win?.setFullScreen(L)}J(L){const U=this.win;U?.isFullScreen()&&this.I(!1),U?.setSimpleFullScreen(L),U?.webContents.focus()}dispose(){super.dispose(),this.m=null}}e.$50b=Z;let Y=class extends Z{get id(){return this.O}get backupPath(){return this.Q?.backupPath}get openedWorkspace(){return this.Q?.workspace}get profile(){if(!this.config)return;const L=this.gb.profiles.find(U=>U.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&L?L:this.gb.getProfileForWorkspace(this.config.workspace??(0,E.$hi)(this.backupPath,this.isExtensionDevelopmentHost))??this.gb.defaultProfile}get remoteAuthority(){return this.Q?.remoteAuthority}get config(){return this.Q}get isExtensionDevelopmentHost(){return!!this.Q?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.Q?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.Q?.debugId}constructor(L,U,H,q,ee,he,K,O,F,_,z,x,N,B,Q,se,le,ge,be,Se,Ae){super(_,Se,q),this.db=U,this.eb=H,this.fb=ee,this.gb=he,this.hb=K,this.ib=O,this.jb=F,this.kb=z,this.lb=x,this.mb=N,this.nb=B,this.ob=Q,this.pb=se,this.qb=le,this.rb=ge,this.sb=be,this.L=this.B(new D.$Vd),this.onWillLoad=this.L.event,this.M=this.B(new D.$Vd),this.onDidSignalReady=this.M.event,this.N=this.B(new D.$Vd),this.onDidDestroy=this.N.event,this.U=[],this.W=[],this.X=void 0,this.Y=void 0,this.Z=void 0,this.$=this.B(this.rb.createIPCObjectUrl()),this.bb=!1,this.tb=0;{const[Le,ke]=this.Db(L.state);this.R=Le,this.db.trace("window#ctor: using window state",Le);const pe=this.R.mode===0||this.R.mode===3,te=Ae.invokeFunction(I.$O0b,this.R,{show:!pe,webPreferences:{preload:f.$og.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.$.resource.toString()}`],v8CacheOptions:this.t.useCodeCache?"bypassHeatCheck":"none"}});(0,l.mark)("code/willCreateCodeBrowserWindow"),this.m=new P.BrowserWindow(te),(0,l.mark)("code/didCreateCodeBrowserWindow"),this.O=this.m.id,this.n(this.m);const fe=this.r.getValue("window"),$e=p.$j&&fe?.nativeTabs===!0;(p.$j||p.$i)&&ke&&(!$e||P.BrowserWindow.getAllWindows().length===1)&&[this.R.width,this.R.height,this.R.x,this.R.y].every(Pe=>typeof Pe=="number")&&this.m.setBounds({width:this.R.width,height:this.R.height,x:this.R.x,y:this.R.y}),pe&&((0,l.mark)("code/willMaximizeCodeWindow"),this.m.maximize(),this.R.mode===3&&this.G(!0),this.m.show(),(0,l.mark)("code/didMaximizeCodeWindow")),this.j=Date.now()}this.Ab(),this.Lb(),this.ub()}setReady(){for(this.db.trace(`window#load: window reported ready (id: ${this.O})`),this.tb=2;this.U.length;)this.U.pop()(this);this.M.fire()}ready(){return new Promise(L=>{if(this.isReady)return L(this);this.U.push(L)})}get isReady(){return this.tb===2}get whenClosedOrLoaded(){return new Promise(L=>{function U(){H.dispose(),q.dispose(),L()}const H=this.onDidClose(()=>U()),q=this.onWillLoad(()=>U())})}ub(){this.m.on("unresponsive",()=>this.xb(1)),this.m.webContents.on("render-process-gone",(U,H)=>this.xb(2,{...H})),this.m.webContents.on("did-fail-load",(U,H,q)=>this.xb(3,{reason:q,exitCode:H})),this.m.webContents.on("will-prevent-unload",U=>{U.preventDefault()}),this.m.webContents.on("did-finish-load",()=>{this.ab&&(this.Q=this.ab,this.ab=void 0)}),this.B(this.onDidMaximize(()=>{this.Q&&(this.Q.maximized=!0)})),this.B(this.onDidUnmaximize(()=>{this.Q&&(this.Q.maximized=!1)})),this.B(this.onDidEnterFullScreen(()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.F?.complete(),this.F=void 0})),this.B(this.onDidLeaveFullScreen(()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.F?.complete(),this.F=void 0})),this.B(this.r.onDidChangeConfiguration(U=>this.Ab(U))),this.B(this.lb.onDidDeleteUntitledWorkspace(U=>this.zb(U)));const L=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.m.webContents.session.webRequest.onBeforeSendHeaders({urls:L},async(U,H)=>{const q=await this.wb();H({cancel:!1,requestHeaders:Object.assign(U.requestHeaders,q)})})}wb(){return this.vb||(this.vb=(0,r.$Bp)(this.qb.version,this.qb,this.t,this.r,this.hb,this.ib,this.nb)),this.vb}async xb(L,U){switch(L){case 2:this.db.error(`CodeWindow: renderer process gone (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break;case 1:this.db.error("CodeWindow: detected unresponsive");break;case 3:this.db.error(`CodeWindow: failed to load (reason: ${U?.reason||"<unknown>"}, code: ${U?.exitCode||"<unknown>"})`);break}switch(this.nb.publicLog2("windowerror",{type:L,reason:U?.reason,code:U?.exitCode}),L){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.pb.kill(1);return}if(this.t.args["enable-smoke-test-driver"]){await this.yb(!1,!1),this.pb.quit();return}if(L===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.m&&this.m.webContents&&this.m.webContents.isDevToolsOpened())return;const{response:H,checkboxChecked:q}=await this.ob.showMessageBox({type:"warning",buttons:[(0,v.localize)(0,null),(0,v.localize)(1,null),(0,v.localize)(2,null)],message:(0,v.localize)(3,null),detail:(0,v.localize)(4,null),checkboxLabel:this.Q?.workspace?(0,v.localize)(5,null):void 0},this.m);if(H!==2){const ee=H===0;await this.yb(ee,q)}}else if(L===2){let H;U?H=(0,v.localize)(7,null,U.reason,U.exitCode??"<unknown>"):H=(0,v.localize)(6,null);const{response:q,checkboxChecked:ee}=await this.ob.showMessageBox({type:"warning",buttons:[this.Q?.workspace?(0,v.localize)(8,null):(0,v.localize)(9,null),(0,v.localize)(10,null)],message:H,detail:this.Q?.workspace?(0,v.localize)(11,null):(0,v.localize)(12,null),checkboxLabel:this.Q?.workspace?(0,v.localize)(13,null):void 0},this.m),he=q===0;await this.yb(he,ee)}break}}async yb(L,U){const H=this.Q?.workspace;if(U&&H)try{const q=this.jb.workspaceStorage(H);await q.init(),q.delete("memento/workbench.parts.editor"),await q.close()}catch(q){this.db.error(q)}this.N.fire();try{if(L&&this.Q){let q,ee;(0,E.$di)(H)?q={folderUri:H.uri}:(0,E.$ii)(H)?q={workspaceUri:H.configPath}:ee=!0,(0,ce.$Ob)(await this.sb.open({context:5,userEnv:this.Q.userEnv,cli:{...this.t.args,_:[]},urisToOpen:q?[q]:void 0,forceEmpty:ee,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}finally{this.m?.destroy()}}zb(L){this.Q?.workspace?.id===L.id&&(this.Q.workspace=void 0)}Ab(L){if(!L||L.affectsConfiguration("window.menuBarVisibility")){const U=this.Hb();U!==this.S&&(this.S=U,this.Ib(U))}if(!L||L.affectsConfiguration("http.proxy")){let U=(this.r.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;U?.endsWith("/")&&(U=U.substr(0,U.length-1));const H=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((U||"").indexOf("@")===-1&&(U!==this.X||H!==this.Y)){this.X=U,this.Y=H;const q=U||"",ee=H?`${H},<local>`:"<local>";this.db.trace(`Setting proxy to '${q}', bypassing '${ee}'`),this.m.webContents.session.setProxy({proxyRules:q,proxyBypassRules:ee,pacScript:""})}}}addTabbedWindow(L){p.$j&&L.win&&this.m.addTabbedWindow(L.win)}load(L,U=Object.create(null)){this.db.trace(`window#load: attempt to load window (id: ${this.O})`),this.isDocumentEdited()&&(!U.isReload||!this.mb.isHotExitEnabled())&&this.setDocumentEdited(!1),U.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.m.setTitle(this.qb.nameLong)),this.Bb(L,U),this.tb===0?this.Q=L:this.ab=L,this.tb=1,this.m.loadURL(f.$og.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.t.isBuilt?"":"-dev"}.html`).toString(!0));const H=this.bb;this.bb=!0,!this.t.isBuilt&&!this.t.extensionTestsLocationURI&&this.B(new R.$fh(()=>{this.m&&!this.m.isVisible()&&!this.m.isMinimized()&&(this.m.show(),this.focus({force:!0}),this.m.webContents.openDevTools())},1e4)).schedule(),this.L.fire({workspace:L.workspace,reason:U.isReload?3:H?2:1})}Bb(L,U){const H=(this.Q??this.ab)?.userEnv;if(H){const q=(0,d.$6l)(H)&&!(0,d.$6l)(L.userEnv),ee=this.isExtensionDevelopmentHost;(q||ee)&&(L.userEnv={...H,...L.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(L.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),U.disableExtensions!==void 0&&(L["disable-extensions"]=U.disableExtensions),L.fullscreen=this.isFullScreen,L.maximized=this.m.isMaximized(),L.partsSplash=this.kb.getWindowSplash(),L.zoomLevel=this.Kb(),L.isCustomZoomLevel=typeof this.Z=="number",L.isCustomZoomLevel&&L.partsSplash&&(L.partsSplash.zoomLevel=L.zoomLevel),(0,l.mark)("code/willOpenNewWindow"),L.perfMarks=(0,l.getMarks)(),this.$.update(L)}async reload(L){const U=Object.assign({},this.Q);U.workspace=await this.Cb(U),delete U.filesToOpenOrCreate,delete U.filesToDiff,delete U.filesToMerge,delete U.filesToWait,this.isExtensionDevelopmentHost&&L&&(U.verbose=L.verbose,U.debugId=L.debugId,U.extensionEnvironment=L.extensionEnvironment,U["inspect-extensions"]=L["inspect-extensions"],U["inspect-brk-extensions"]=L["inspect-brk-extensions"],U["extensions-dir"]=L["extensions-dir"]),U.accessibilitySupport=P.app.isAccessibilitySupportEnabled(),U.isInitialStartup=!1,U.policiesData=this.fb.serialize(),U.continueOn=this.t.continueOn,U.profiles={all:this.gb.profiles,profile:this.profile||this.gb.defaultProfile,home:this.gb.profilesHome},U.logLevel=this.eb.getLogLevel(),U.loggers={window:this.eb.getRegisteredLoggers(this.id),global:this.eb.getRegisteredLoggers()},this.load(U,{isReload:!0,disableExtensions:L?.["disable-extensions"]})}async Cb(L){if((0,E.$ii)(L.workspace)){const U=L.workspace.configPath;if(U.scheme===f.Schemas.file&&!await this.hb.exists(U))return}else if((0,E.$di)(L.workspace)){const U=L.workspace.uri;if(U.scheme===f.Schemas.file&&!await this.hb.exists(U))return}return L.workspace}serializeWindowState(){if(!this.m)return(0,M.$z0b)();if(this.isFullScreen){let H;try{H=P.screen.getDisplayMatching(this.getBounds())}catch{}const q=(0,M.$z0b)();return{mode:3,display:H?H.id:void 0,width:this.R.width||q.width,height:this.R.height||q.height,x:this.R.x||0,y:this.R.y||0,zoomLevel:this.Z}}const L=Object.create(null);let U;if(!p.$j&&this.m.isMaximized()?U=0:U=1,U===0?L.mode=0:L.mode=1,U===1||U===0){let H;U===1?H=this.getBounds():H=this.m.getNormalBounds(),L.x=H.x,L.y=H.y,L.width=H.width,L.height=H.height}return L.zoomLevel=this.Z,L}Db(L){(0,l.mark)("code/willRestoreCodeWindowState");let U=!1;if(L){this.Z=L.zoomLevel;try{const H=P.screen.getAllDisplays();U=H.length>1,L=this.Eb(L,H)}catch(H){this.db.warn(`Unexpected error validating window state: ${H}
${H.stack}`)}}return(0,l.mark)("code/didRestoreCodeWindowState"),[L||(0,M.$z0b)(),U]}Eb(L,U){if(this.db.trace(`window#validateWindowState: validating window state on ${U.length} display(s)`,L),typeof L.x!="number"||typeof L.y!="number"||typeof L.width!="number"||typeof L.height!="number"){this.db.trace("window#validateWindowState: unexpected type of state values");return}if(L.width<=0||L.height<=0){this.db.trace("window#validateWindowState: unexpected negative values");return}if(U.length===1){const ee=this.Fb(U[0]);if(ee){let he=function(){!L||typeof L.x!="number"||typeof L.y!="number"||!ee||(L.x<ee.x&&(L.x=ee.x),L.y<ee.y&&(L.y=ee.y))};this.db.trace("window#validateWindowState: 1 monitor working area",ee),he(),L.width>ee.width&&(L.width=ee.width),L.height>ee.height&&(L.height=ee.height),L.x>ee.x+ee.width-128&&(L.x=ee.x+ee.width-L.width),L.y>ee.y+ee.height-128&&(L.y=ee.y+ee.height-L.height),he()}return L}if(L.display&&L.mode===3){const ee=U.find(he=>he.id===L.display);if(ee&&typeof ee.bounds?.x=="number"&&typeof ee.bounds?.y=="number"){this.db.trace("window#validateWindowState: restoring fullscreen to previous display");const he=(0,M.$z0b)(3);return he.x=ee.bounds.x,he.y=ee.bounds.y,he}}let H,q;try{H=P.screen.getDisplayMatching({x:L.x,y:L.y,width:L.width,height:L.height}),q=this.Fb(H)}catch{}if(H&&q&&L.x+L.width>q.x&&L.y+L.height>q.y&&L.x<q.x+q.width&&L.y<q.y+q.height)return this.db.trace("window#validateWindowState: multi-monitor working area",q),L}Fb(L){if(L.workArea.width>0&&L.workArea.height>0)return L.workArea;if(L.bounds.width>0&&L.bounds.height>0)return L.bounds}getBounds(){const[L,U]=this.m.getPosition(),[H,q]=this.m.getSize();return{x:L,y:U,width:H,height:q}}G(L){super.G(L),this.sendWhenReady(L?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.S&&this.Ib(this.S,!1)}Hb(){let L=(0,C.$SC)(this.r);return["visible","toggle","hidden"].indexOf(L)<0&&(L="classic"),L}Ib(L,U=!0){p.$j||(L==="toggle"&&U&&this.send("vscode:showInfoMessage",(0,v.localize)(14,null)),L==="hidden"?setTimeout(()=>{this.Jb(L)}):this.Jb(L))}Jb(L){const U=this.isFullScreen;switch(L){case"classic":this.m.setMenuBarVisibility(!U),this.m.autoHideMenuBar=U;break;case"visible":this.m.setMenuBarVisibility(!0),this.m.autoHideMenuBar=!1;break;case"toggle":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!0;break;case"hidden":this.m.setMenuBarVisibility(!1),this.m.autoHideMenuBar=!1;break}}notifyZoomLevel(L){this.Z=L}Kb(){return typeof this.Z=="number"?this.Z:this.r.getValue("window")?.zoomLevel}close(){this.m?.close()}sendWhenReady(L,U,...H){this.isReady?this.send(L,...H):this.ready().then(()=>{U.isCancellationRequested||this.send(L,...H)})}send(L,...U){if(this.m){if(this.m.isDestroyed()||this.m.webContents.isDestroyed()){this.db.warn(`Sending IPC message to channel '${L}' for window that is destroyed`);return}try{this.m.webContents.send(L,...U)}catch(H){this.db.warn(`Error sending IPC message to channel '${L}' of window ${this.O}: ${(0,j.$Qi)(H)}`)}}}updateTouchBar(L){p.$j&&this.W.forEach((U,H)=>{const q=L[H];U.segments=this.Nb(q)})}Lb(){if(p.$j){for(let L=0;L<10;L++){const U=this.Mb();this.W.push(U)}this.m.setTouchBar(new P.TouchBar({items:this.W}))}}Mb(L=[]){const U=this.Nb(L),H=new P.TouchBar.TouchBarSegmentedControl({segments:U,mode:"buttons",segmentStyle:"automatic",change:q=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:H.segments[q].id,from:"touchbar"})}});return H}Nb(L=[]){return L.map(H=>{let q;H.icon&&!a.ThemeIcon.isThemeIcon(H.icon)&&H.icon?.dark?.scheme===f.Schemas.file&&(q=P.nativeImage.createFromPath(k.URI.revive(H.icon.dark).fsPath),q.isEmpty()&&(q=void 0));let ee;return typeof H.title=="string"?ee=H.title:ee=H.title.value,{id:H.id,label:q?void 0:ee,icon:q}})}dispose(){super.dispose(),this.eb.deregisterLoggers(this.id)}};e.$60b=Y,e.$60b=Y=ve([ne(1,c.$nj),ne(2,J.$30b),ne(3,$.$A0b),ne(4,T.$Jn),ne(5,G.$R0b),ne(6,h.$qk),ne(7,i.$d$b),ne(8,i.$b$b),ne(9,w.$zi),ne(10,b.$J0b),ne(11,A.$10b),ne(12,y.$F0b),ne(13,n.$ul),ne(14,g.$G0b),ne(15,m.$80b),ne(16,t.$Fj),ne(17,o.$I0b),ne(18,I.$N0b),ne(19,W.$uO),ne(20,re.$5h)],Y)}),define(oe[302],ae([0,1,15,18,24,20,5,34,134]),function(X,e,P,R,s,j,D,S,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$70b=void 0;let l=class extends f.$50b{get win(){return super.win||this.tryClaimWindow(),super.win}constructor(k,v,u,y,w,g){super(y,w,v),this.L=k,this.M=u,this.N=g,this.id=this.L.id,this.parentId=-1,this.tryClaimWindow()}tryClaimWindow(){if(this.m||this.q.isDisposed||this.L.isDestroyed())return;const k=P.BrowserWindow.fromWebContents(this.L);k&&(this.M.trace("[aux window] Claimed browser window instance"),this.n(k),k.setMenu(null),this.N.registerAuxWindow(this))}};e.$70b=l,e.$70b=l=ve([ne(1,s.$A0b),ne(2,D.$nj),ne(3,R.$zi),ne(4,S.$uO),ne(5,j.$80b)],l)}),define(oe[303],ae([0,1,15,3,2,13,37,302,6,5,29]),function(X,e,P,R,s,j,D,S,f,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$x_b=void 0;let k=class extends s.$Tc{constructor(u,y){super(),this.h=u,this.j=y,this.a=this.B(new R.$Vd),this.onDidMaximizeWindow=this.a.event,this.b=this.B(new R.$Vd),this.onDidUnmaximizeWindow=this.b.event,this.c=this.B(new R.$Vd),this.onDidChangeFullScreen=this.c.event,this.f=this.B(new R.$Vd),this.onDidTriggerSystemContextMenu=this.f.event,this.g=new Map,this.m()}m(){P.app.on("browser-window-created",(u,y)=>{const w=this.getWindowById(y.id);w&&(this.j.trace('[aux window] app.on("browser-window-created"): Trying to claim auxiliary window'),w.tryClaimWindow())}),D.$AU.handle("vscode:registerAuxiliaryWindow",async(u,y)=>{const w=this.getWindowById(u.sender.id);return w&&(this.j.trace("[aux window] vscode:registerAuxiliaryWindow: Registering auxiliary window to main window"),w.parentId=y),u.sender.id})}createWindow(){return this.h.invokeFunction(p.$O0b,void 0,{webPreferences:{preload:j.$og.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload-aux.js").fsPath}})}registerWindow(u){const y=new s.$Sc,w=this.h.createInstance(S.$70b,u);this.g.set(w.id,w),y.add((0,s.$Rc)(()=>this.g.delete(w.id))),y.add(w.onDidMaximize(()=>this.a.fire(w))),y.add(w.onDidUnmaximize(()=>this.b.fire(w))),y.add(w.onDidEnterFullScreen(()=>this.c.fire({window:w,fullscreen:!0}))),y.add(w.onDidLeaveFullScreen(()=>this.c.fire({window:w,fullscreen:!1}))),y.add(w.onDidTriggerSystemContextMenu(({x:g,y:$})=>this.f.fire({window:w,x:g,y:$}))),R.Event.once(w.onDidClose)(()=>y.dispose())}getWindowById(u){return this.g.get(u)}getFocusedWindow(){const u=P.BrowserWindow.getFocusedWindow();if(u)return this.getWindowById(u.id)}getLastActiveWindow(){return(0,p.$Q0b)(Array.from(this.g.values()))}getWindows(){return Array.from(this.g.values())}};e.$x_b=k,e.$x_b=k=ve([ne(0,f.$5h),ne(1,l.$nj)],k)}),define(oe[83],ae([0,1,15,22,8,3,47,2,13,4,19,7,21,193,6,20,5,82,97,30,57,31,55]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$M$b=e.$L$b=void 0,e.$L$b=(0,y.$6h)("workspacesHistoryMainService");let r=class extends S.$Tc{static{o=this}static{this.a=500}static{this.b="history.recentlyOpenedPathsList"}constructor(n,a,b,C,I){super(),this.f=n,this.g=a,this.h=b,this.j=C,this.m=I,this.c=this.B(new j.$Vd),this.onDidChangeRecentlyOpened=this.c.event,this.H=this.B(new s.$4g(800)),this.n()}n(){this.h.when(4).then(()=>this.I()),this.B(this.g.onDidEnterWorkspace(n=>this.addRecentlyOpened([{workspace:n.workspace,remoteAuthority:n.window.remoteAuthority}])))}async addRecentlyOpened(n){let a=[],b=[];for(const I of n)if((0,d.$Ecb)(I))!this.g.isUntitledWorkspace(I.workspace)&&!this.w(a,I.workspace)&&a.push(I);else if((0,d.$Fcb)(I))this.y(a,I.folderUri)||a.push(I);else{const E=this.z(b,I.fileUri),A=I.fileUri.scheme===f.Schemas.file&&o.G.indexOf((0,p.$Eg)(I.fileUri))>=0;!E&&!A&&(b.push(I),l.$i&&I.fileUri.scheme===f.Schemas.file&&P.app.addRecentDocument(I.fileUri.fsPath))}const C=await this.r({workspaces:a,files:b});a=C.workspaces,b=C.files,a.length>o.a&&(a.length=o.a),b.length>o.a&&(b.length=o.a),await this.t({workspaces:a,files:b}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N())}async removeRecentlyOpened(n){const a=E=>{const A=this.u(E);for(const M of n)if(p.$yg.isEqual(M,A))return!1;return!0},b=await this.getRecentlyOpened(),C=b.workspaces.filter(a),I=b.files.filter(a);(C.length!==b.workspaces.length||I.length!==b.files.length)&&(await this.t({files:I,workspaces:C}),this.c.fire(),l.$j&&this.H.trigger(()=>this.N()))}async clearRecentlyOpened(n){if(n?.confirm){const{response:a}=await this.m.showMessageBox({type:"warning",buttons:[(0,u.localize)(0,null),(0,u.localize)(1,null)],message:(0,u.localize)(2,null),detail:(0,u.localize)(3,null),cancelId:1});if(a!==0)return}await this.t({workspaces:[],files:[]}),P.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.r()}async r(n){const a=new c.$Ac(I=>p.$yg.getComparisonKey(I));if(n?.workspaces)for(const I of n.workspaces)a.set(this.u(I),I);const b=new c.$Ac(I=>p.$yg.getComparisonKey(I));if(n?.files)for(const I of n.files)b.set(this.u(I),I);const C=await this.s();for(const I of C.workspaces){const E=a.get(this.u(I));E?E.label=E.label??I.label:a.set(this.u(I),I)}for(const I of C.files){const E=b.get(this.u(I));E?E.label=E.label??I.label:b.set(this.u(I),I)}return{workspaces:[...a.values()],files:[...b.values()]}}async s(){await this.j.whenReady;let n;const a=this.j.get(o.b,-1);if(typeof a=="string")try{n=JSON.parse(a)}catch(b){this.f.error("Unexpected error parsing opened paths list",b)}return(0,d.$Lcb)(n,this.f)}async t(n){await this.j.whenReady,this.j.store(o.b,JSON.stringify((0,d.$Mcb)(n)),-1,1)}u(n){return(0,d.$Fcb)(n)?n.folderUri:(0,d.$Gcb)(n)?n.fileUri:n.workspace.configPath}w(n,a){return!!n.find(b=>(0,d.$Ecb)(b)&&b.workspace.id===a.id)}y(n,a){return!!n.find(b=>(0,d.$Fcb)(b)&&p.$yg.isEqual(b.folderUri,a))}z(n,a){return!!n.find(b=>p.$yg.isEqual(b.fileUri,a))}static{this.C=7}static{this.D=10}static{this.F=7}static{this.G=["COMMIT_EDITMSG","MERGE_MSG"]}async I(){l.$i&&(await this.J(),this.B(this.onDidChangeRecentlyOpened(()=>this.J())))}async J(){if(!l.$i)return;const n=[];if(n.push({type:"tasks",items:[{type:"task",title:(0,u.localize)(4,null),description:(0,u.localize)(5,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const a=[];for(const I of P.app.getJumpListSettings().removedItems){const E=I.args;if(E){const A=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(E);A&&a.push(k.URI.parse(A[2]))}}await this.removeRecentlyOpened(a);let b=!1;const C=(0,R.$Hb)((await this.getRecentlyOpened()).workspaces.slice(0,o.F).map(I=>{const E=(0,d.$Ecb)(I)?I.workspace:I.folderUri,{title:A,description:M}=this.L(E,I.label);let T;return k.URI.isUri(E)?T=`--folder-uri "${E.toString()}"`:(b=!0,T=`--file-uri "${E.configPath.toString()}"`),{type:"task",title:A.substr(0,255),description:M.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));C.length>0&&n.push({type:"custom",name:b?(0,u.localize)(6,null):(0,u.localize)(7,null),items:C})}n.push({type:"recent"});try{const a=P.app.setJumpList(n);a&&a!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${a}`)}catch(a){this.f.warn("updateWindowsJumpList#setJumpList",a)}}L(n,a){if(a)return{title:(0,D.$5v)(a).name,description:a};if(k.URI.isUri(n))return{title:(0,p.$Eg)(n),description:this.M(n)};if(this.g.isUntitledWorkspace(n))return{title:(0,u.localize)(8,null),description:""};let b=(0,p.$Eg)(n.configPath);return b.endsWith(h.$pi)&&(b=b.substr(0,b.length-h.$pi.length-1)),{title:(0,u.localize)(9,null,b),description:this.M(n.configPath)}}M(n){return n.scheme==="file"?(0,D.$Wv)(n.fsPath):n.toString()}async N(){if(!l.$j)return;P.app.clearRecentDocuments();const n=await this.getRecentlyOpened(),a=[];let b=0;for(let I=0;I<n.workspaces.length&&b<o.C;I++){const E=this.u(n.workspaces[I]);if(E.scheme===f.Schemas.file){const A=(0,p.$vg)(E);await v.Promises.exists(A)&&(a.push(A),b++)}}const C=[];for(let I=0;I<n.files.length&&b<o.D;I++){const E=this.u(n.files[I]);if(E.scheme===f.Schemas.file){const A=(0,p.$vg)(E);if(o.G.includes((0,p.$Eg)(E))||a.includes(A))continue;await v.Promises.exists(A)&&(C.push(A),b++)}}C.reverse().forEach(I=>P.app.addRecentDocument(I)),a.reverse().forEach(I=>P.app.addRecentDocument(I))}};e.$M$b=r,e.$M$b=r=o=ve([ne(0,g.$nj),ne(1,m.$10b),ne(2,w.$80b),ne(3,$.$d$b),ne(4,t.$G0b)],r)}),define(oe[304],ae([0,1,15,8,23,47,4,7,181,65,18,24,20,5,231,71,27,34,28,49,60,29,83]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$N$b=void 0;const r="menu";let i=class{static{o=this}static{this.a="lastKnownMenubarData"}constructor(b,C,I,E,A,M,T,W,G,J,ce,re){this.n=b,this.o=C,this.p=I,this.q=E,this.r=A,this.s=M,this.t=T,this.u=W,this.v=G,this.w=J,this.x=ce,this.y=re,this.m=Object.create(null),this.g=new R.$fh(()=>this.F(),0),this.h=new R.$fh(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(D.$j||(0,m.$TC)(this.o)==="native")&&this.z(),this.A(),this.d=!1,this.f=!1,this.j=[],this.I(),this.B()}z(){const b=this.t.getItem(o.a);b&&(b.menus&&(this.k=b.menus),b.keybindings&&(this.l=b.keybindings))}A(){this.m["workbench.action.files.newUntitledFile"]=(M,T,W)=>{this.Y({type:"commandId",commandId:"workbench.action.files.newUntitledFile"})||this.p.openEmptyWindow({context:2,contextWindowId:T?.id})},this.m["workbench.action.newWindow"]=(M,T,W)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(M,T,W)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.files.openFolder"]=(M,T,W)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.openWorkspace"]=(M,T,W)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.R(W),telemetryExtraData:{from:r}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened({confirm:!0});const b=this.x.youTubeUrl;b&&(this.m["workbench.action.openYouTubeUrl"]=()=>this.ab(b,"openYouTubeUrl"));const C=this.x.requestFeatureUrl;C&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.ab(C,"openUserVoiceUrl"));const I=this.x.reportIssueUrl;I&&(this.m["workbench.action.openIssueReporter"]=()=>this.ab(I,"openReportIssues"));const E=this.x.licenseUrl;E&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(D.$w){const M=E.indexOf("?")>0?"&":"?";this.ab(`${E}${M}lang=${D.$w}`,"openLicenseUrl")}else this.ab(E,"openLicenseUrl")});const A=this.x.privacyStatementUrl;A&&E&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.ab(A,"openPrivacyStatement")})}B(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(b=>this.G(b)),this.w.onDidBlurMainWindow(()=>this.H()),this.w.onDidFocusMainWindow(()=>this.H())}get C(){const b=this.o.getValue("window.enableMenuBarMnemonics");return typeof b!="boolean"?!0:b}get D(){if(!D.$j)return!1;const b=this.o.getValue("window.nativeTabs");return typeof b!="boolean"?!1:b}updateMenu(b,C){this.k=b.menus,this.l=b.keybindings,this.t.setItem(o.a,b),this.E()}E(){this.g.schedule()}F(){this.b||setTimeout(()=>{this.b||this.I()},10)}G(b){D.$j&&(b.oldCount===0&&b.newCount>0||b.oldCount>0&&b.newCount===0)&&(this.d=b.newCount===0,this.E())}H(){if(!D.$j)return;const b=P.BrowserWindow.getFocusedWindow();this.f=!b||!!this.y.getWindowById(b.id),this.E()}I(){const b=P.Menu.getApplicationMenu();if(b&&this.j.push(b),Object.keys(this.k).length===0){this.J(D.$j?new P.Menu:null);return}const C=new P.Menu;let I;if(D.$j){const A=new P.Menu;I=new P.MenuItem({label:this.x.nameShort,submenu:A}),this.K(A),C.append(I)}if(D.$j&&!this.c){this.c=!0;const A=new P.Menu;A.append(new P.MenuItem({label:this.cb(f.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),P.app.dock.setMenu(A)}if(this.M("File")){const A=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(1,null)),submenu:A});this.O(A,"File"),C.append(M)}if(this.M("Edit")){const A=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(2,null)),submenu:A});this.O(A,"Edit"),C.append(M)}if(this.M("Selection")){const A=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(3,null)),submenu:A});this.O(A,"Selection"),C.append(M)}if(this.M("View")){const A=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(4,null)),submenu:A});this.O(A,"View"),C.append(M)}if(this.M("Go")){const A=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(5,null)),submenu:A});this.O(A,"Go"),C.append(M)}if(this.M("Run")){const A=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(6,null)),submenu:A});this.O(A,"Run"),C.append(M)}if(this.M("Terminal")){const A=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(7,null)),submenu:A});this.O(A,"Terminal"),C.append(M)}let E;if(this.M("Window")){const A=new P.Menu;E=new P.MenuItem({label:this.cb(f.localize(8,null)),submenu:A,role:"window"}),this.U(A)}if(E&&C.append(E),this.M("Help")){const A=new P.Menu,M=new P.MenuItem({label:this.cb(f.localize(9,null)),submenu:A,role:"help"});this.O(A,"Help"),C.append(M)}C.items&&C.items.length>0?this.J(C):this.J(null),this.h.schedule()}J(b){if(P.Menu.setApplicationMenu(b),b)for(const C of this.y.getWindows())C.win?.setMenu(null)}K(b){const C=this.W(f.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),I=this.V();let E;if(this.M("Preferences")){const re=new P.Menu;this.O(re,"Preferences"),E=new P.MenuItem({label:this.cb(f.localize(11,null)),submenu:re})}const A=new P.Menu,M=new P.MenuItem({label:f.localize(12,null),role:"services",submenu:A}),T=new P.MenuItem({label:f.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),W=new P.MenuItem({label:f.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),G=new P.MenuItem({label:f.localize(15,null),role:"unhide"}),J=new P.MenuItem(this.$("workbench.action.quit",{label:f.localize(16,null,this.x.nameLong),click:async(re,ue,Z)=>{const Y=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||P.BrowserWindow.getFocusedWindow()||Y?.win?.isMinimized())&&await this.L(Z)&&this.w.quit(void 0)}})),ce=[C];ce.push(...I),E&&ce.push(n(),E),ce.push(n(),M,n(),T,W,G,n(),J),ce.forEach(re=>b.append(re))}async L(b){if(this.p.getWindowCount()===0)return!0;const C=this.o.getValue("window.confirmBeforeClose");if(C==="always"||C==="keyboardOnly"&&this.S(b)){const{response:I}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[f.localize(17,null),f.localize(18,null)],message:f.localize(19,null)});return I===0}return!0}M(b){if(!D.$j&&(0,m.$TC)(this.o)==="custom")return!1;switch(b){case"File":case"Help":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[b];case"Window":if(D.$j)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[b]}}N(b,C){C.forEach(I=>{if((0,y.$I$b)(I))b.append(n());else if((0,y.$H$b)(I)){const E=new P.Menu,A=new P.MenuItem({label:this.cb(I.label),submenu:E});this.N(E,I.submenu.items),b.append(A)}else(0,y.$J$b)(I)?b.append(this.Q(I)):(0,y.$K$b)(I)&&(I.id==="workbench.action.showAboutDialog"&&this.P(b),D.$j?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[I.id]?b.append(new P.MenuItem(this.$(I.id,{label:this.cb(I.label),click:this.m[I.id]}))):b.append(this.W(I.label,I.id,!1,I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)):b.append(this.W(I.label,I.id,I.enabled!==!1,!!I.checked)))})}O(b,C){this.k&&this.k[C]&&this.N(b,this.k[C].items)}P(b){const C=this.V();C.length&&(C.forEach(I=>b.append(I)),b.append(n()))}Q(b){const C=S.URI.revive(b.uri),I=b.id,E=I==="openRecentFile"?{fileUri:C}:I==="openRecentWorkspace"?{workspaceUri:C}:{folderUri:C};return new P.MenuItem(this.$(I,{label:b.label,click:async(A,M,T)=>{const W=this.R(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[E],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:b.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([C])}},!1))}R(b){return!!(b&&(!D.$j&&(b.ctrlKey||b.shiftKey)||D.$j&&(b.metaKey||b.altKey)))}S(b){return!!(b.triggeredByAccelerator||b.altKey||b.ctrlKey||b.metaKey||b.shiftKey)}T(b,C,I){const E={label:this.cb(b),role:I,enabled:!0};return new P.MenuItem(this.Z(C,E))}U(b){const C=new P.MenuItem({label:f.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),I=new P.MenuItem({label:f.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),E=new P.MenuItem({label:f.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),A=this.W(f.localize(23,null),"workbench.action.switchWindow"),M=[];this.D&&(M.push(n()),M.push(this.W(f.localize(24,null),"workbench.action.newWindowTab")),M.push(this.T(f.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),M.push(this.T(f.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),M.push(this.T(f.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),M.push(this.T(f.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[C,I,n(),A,...M,n(),E].forEach(T=>b.append(T))}V(){switch(this.n.state.type){case"idle":return[new P.MenuItem({label:this.cb(f.localize(29,null)),click:()=>setTimeout(()=>{this.bb("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new P.MenuItem({label:f.localize(30,null),enabled:!1})];case"available for download":return[new P.MenuItem({label:this.cb(f.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new P.MenuItem({label:f.localize(32,null),enabled:!1})];case"downloaded":return[new P.MenuItem({label:this.cb(f.localize(33,null)),click:()=>{this.bb("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new P.MenuItem({label:f.localize(34,null),enabled:!1})];case"ready":return[new P.MenuItem({label:this.cb(f.localize(35,null)),click:()=>{this.bb("RestartToUpdate"),this.n.quitAndInstall()}})];default:return[]}}W(b,C,I,E){const A=this.cb(b),M=typeof C=="function"?C:(ce,re,ue)=>{const Z=ce?ce.userSettingsLabel:null;let Y=C;Array.isArray(C)&&(Y=this.R(ue)?C[1]:C[0]),Z&&ue.triggeredByAccelerator?this.Y({type:"keybinding",userSettingsLabel:Z}):this.Y({type:"commandId",commandId:Y})},T=typeof I=="boolean"?I:this.p.getWindowCount()>0,W=typeof E=="boolean"?E:!1,G={label:A,click:M,enabled:T};W&&(G.type="checkbox",G.checked=W);let J;return typeof C=="string"?J=C:Array.isArray(C)&&(J=C[0]),D.$j&&(J==="editor.action.clipboardCutAction"?G.role="cut":J==="editor.action.clipboardCopyAction"?G.role="copy":J==="editor.action.clipboardPasteAction"&&(G.role="paste"),J==="undo"?G.click=this.X(M,{inDevTools:ce=>ce.undo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("undo:")}):J==="redo"?G.click=this.X(M,{inDevTools:ce=>ce.redo(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("redo:")}):J==="editor.action.selectAll"&&(G.click=this.X(M,{inDevTools:ce=>ce.selectAll(),inNoWindow:()=>P.Menu.sendActionToFirstResponder("selectAll:")}))),new P.MenuItem(this.Z(J,G))}X(b,C){return(I,E,A)=>{const M=P.BrowserWindow.getFocusedWindow();if(!M)return C.inNoWindow();if(M.webContents.isDevToolsFocused()&&M.webContents.devToolsWebContents)return C.inDevTools(M.webContents.devToolsWebContents);b(I,E||M,A)}}Y(b){let C=P.BrowserWindow.getFocusedWindow();if(C){const E=this.y.getWindowById(C.id);E&&(C=this.p.getWindowById(E.parentId)?.win??null)}if(!C){const E=this.p.getLastActiveWindow();E?.win?.isMinimized()&&(C=E.win)}const I=C?this.p.getWindowById(C.id):void 0;if(I){if(this.v.trace("menubar#runActionInRenderer",b),D.$j&&!this.q.isBuilt&&!I.isReady&&(b.type==="commandId"&&b.commandId==="workbench.action.toggleDevTools"||b.type!=="commandId"&&b.userSettingsLabel==="alt+cmd+i"))return!1;if(b.type==="commandId"){const E={id:b.commandId,from:"menu"};I.sendWhenReady("vscode:runAction",s.CancellationToken.None,E)}else{const E={userSettingsLabel:b.userSettingsLabel};I.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,E)}return!0}else return this.v.trace("menubar#runActionInRenderer: no active window found",b),!1}Z(b,C){const I=typeof b=="string"?this.l[b]:void 0;if(I?.label){if(I.isNative!==!1)C.accelerator=I.label,C.userSettingsLabel=I.userSettingsLabel;else if(typeof C.label=="string"){const E=C.label.indexOf("[");E>=0?C.label=`${C.label.substr(0,E)} [${I.label}]`:C.label=`${C.label} [${I.label}]`}}else C.accelerator=void 0;return C}$(b,C,I=!C.accelerator){I&&(C=this.Z(b,C));const E=C.click;return C.click=(A,M,T)=>{this.bb(b),E?.(A,M,T)},C}ab(b,C){this.w.openExternal(void 0,b),this.bb(C)}bb(b){this.r.publicLog2("workbenchActionExecuted",{id:b,from:r})}cb(b){return(0,j.$2v)(b,!this.C)}};e.$N$b=i,e.$N$b=i=o=ve([ne(0,h.$zV),ne(1,p.$zi),ne(2,c.$N0b),ne(3,k.$A0b),ne(4,d.$ul),ne(5,t.$L$b),ne(6,$.$uO),ne(7,v.$80b),ne(8,u.$nj),ne(9,w.$z$b),ne(10,g.$Fj),ne(11,l.$L0b)],i);function n(){return new P.MenuItem({type:"separator"})}}),define(oe[305],ae([0,1,6,20,5,304]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$P$b=e.$O$b=void 0,e.$O$b=(0,P.$6h)("menubarMainService");let D=class{constructor(f,l,p){this.b=f,this.c=l,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(j.$N$b)}async updateMenubar(f,l){this.d.trace("menubarService#updateMenubar",f),(await this.a).updateMenu(l,f)}};e.$P$b=D,e.$P$b=D=ve([ne(0,P.$5h),ne(1,R.$80b),ne(2,s.$nj)],D)}),define(oe[306],ae([0,1,15,21,132,26,22,23,3,33,47,2,13,9,68,4,36,19,12,7,191,66,18,55,24,16,6,20,5,79,80,59,34,60,134,29,131,298,30,98,83,57,70,39,56,69,65]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t,o,r,i,n,a,b,C,I,E,A,M,T,W,G,J,ce,re,ue,Z,Y,V,L,U,H){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d_b=void 0;function q(K){return(0,ce.$ii)(K?.workspace)}function ee(K){return(0,ce.$di)(K?.workspace)}let he=class extends k.$Tc{constructor(O,F,_,z,x,N,B,Q,se,le,ge,be,Se,Ae,Le,ke,pe,te,fe,$e){super(),this.s=O,this.t=F,this.u=_,this.w=z,this.z=x,this.C=N,this.D=B,this.F=Q,this.G=se,this.H=le,this.I=ge,this.J=be,this.L=Se,this.M=Ae,this.N=Le,this.O=ke,this.P=pe,this.Q=te,this.R=fe,this.S=$e,this.a=this.B(new f.$Vd),this.onDidOpenWindow=this.a.event,this.b=this.B(new f.$Vd),this.onDidSignalReadyWindow=this.b.event,this.c=this.B(new f.$Vd),this.onDidDestroyWindow=this.c.event,this.f=this.B(new f.$Vd),this.onDidChangeWindowsCount=this.f.event,this.g=this.B(new f.$Vd),this.onDidMaximizeWindow=this.g.event,this.h=this.B(new f.$Vd),this.onDidUnmaximizeWindow=this.h.event,this.j=this.B(new f.$Vd),this.onDidChangeFullScreen=this.j.event,this.m=this.B(new f.$Vd),this.onDidTriggerSystemContextMenu=this.m.event,this.n=new Map,this.r=this.B(new J.$a_b(this,this.C,this.H,this.w,this.J)),this.U()}U(){this.B(this.M.onDidEnterWorkspace(O=>this.b.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const F=new k.$Sc;if(F.add(f.Event.any(O.onDidClose,O.onDidDestroy)(()=>F.dispose())),O.config.extensionDevelopmentPath)for(const _ of O.config.extensionDevelopmentPath)F.add(this.Q.addValidFileRoot(_));O.config.extensionTestsPath&&F.add(this.Q.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,F){const _=this.F.args,z=F?.remoteAuthority||void 0,x=!0,N=F?.forceReuseWindow,B=!N;return this.open({...O,cli:_,forceEmpty:x,forceNewWindow:B,forceReuseWindow:N,remoteAuthority:z})}openExistingWindow(O,F){O.focus(),this.W(F,[O])}async open(O){this.w.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const F=[],_=[],z=[],x=[],N=[];let B,Q=0;const se=await this.cb(O);this.w.trace("windowsManager#open pathsToOpen",se);for(const Ae of se)ee(Ae)?O.addMode?F.push(Ae):_.push(Ae):q(Ae)?z.push(Ae):Ae.fileUri?(B||(B={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Ae.remoteAuthority}),B.filesToOpenOrCreate.push(Ae)):Ae.backupPath?N.push({backupFolder:(0,u.$nc)(Ae.backupPath),remoteAuthority:Ae.remoteAuthority}):Q++;O.diffMode&&B&&B.filesToOpenOrCreate.length>=2&&(B.filesToDiff=B.filesToOpenOrCreate.slice(0,2),B.filesToOpenOrCreate=[]),O.mergeMode&&B&&B.filesToOpenOrCreate.length===4&&(B.filesToMerge=B.filesToOpenOrCreate.slice(0,4),B.filesToOpenOrCreate=[],B.filesToDiff=[]),B&&O.waitMarkerFileURI&&(B.filesToWait={paths:(0,D.$Hb)([...B.filesToDiff,B.filesToMerge[3],...B.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(x.push(...this.M.getUntitledWorkspaces()),z.push(...x),N.push(...this.I.getEmptyWindowBackups())):N.length=0;const{windows:le,filesOpenedInWindow:ge}=await this.X(O,z,_,N,Q,B,F);if(this.w.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${z.length}, foldersToOpen: ${_.length}, emptyToRestore: ${N.length}, emptyToOpen: ${Q})`),le.length>1)if(ge)ge.focus();else{const Ae=this.r.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Le=!0,ke=!0;if(Ae){const pe=le.filter(te=>this.r.state.lastActiveWindow&&te.backupPath===this.r.state.lastActiveWindow.backupPath);pe.length&&(pe[0].focus(),Le=!1,ke=!1)}if(Le)for(let pe=le.length-1;pe>=0;pe--){const te=le[pe];if(!(te.openedWorkspace&&x.some(fe=>te.openedWorkspace&&fe.workspace.id===te.openedWorkspace.id)||te.backupPath&&N.some(fe=>te.backupPath&&fe.backupFolder===(0,u.$nc)(te.backupPath)))){te.focus(),ke=!1;break}}ke&&le[le.length-1].focus()}const be=B&&B.filesToDiff.length>0,Se=B&&B.filesToMerge.length>0;if(!le.some(Ae=>Ae.isExtensionDevelopmentHost)&&!be&&!Se&&!O.noRecentEntry){const Ae=[];for(const Le of se)q(Le)&&!Le.transient?Ae.push({label:Le.label,workspace:Le.workspace,remoteAuthority:Le.remoteAuthority}):ee(Le)?Ae.push({label:Le.label,folderUri:Le.workspace.uri,remoteAuthority:Le.remoteAuthority}):Le.fileUri&&Ae.push({label:Le.label,fileUri:Le.fileUri,remoteAuthority:Le.remoteAuthority});this.L.addRecentlyOpened(Ae)}return this.W(O,le),le}W(O,F){const _=O.waitMarkerFileURI;O.context===0&&_&&F.length===1&&F[0]&&(async()=>{await F[0].whenClosedOrLoaded;try{await this.P.del(_)}catch{}})()}async X(O,F,_,z,x,N,B){const Q=[];let se;function le(pe,te){Q.push(pe),te&&(se=pe,N=void 0)}let{openFolderInNewWindow:ge,openFilesInNewWindow:be}=this.ob(O);if(!O.initialStartup&&B.length>0){const pe=B[0].remoteAuthority,te=this.ub(pe);te&&le(this.$(te,B.map(fe=>fe.workspace.uri)))}const Se=_.length+F.length+z.length;if(N&&Se===0){const pe=N.filesToOpenOrCreate[0]||N.filesToDiff[0]||N.filesToMerge[3],te=this.getWindows().filter($e=>N&&(0,$.$Mg)($e.remoteAuthority,N.remoteAuthority));let fe;pe?.fileUri&&!be&&((O.context===4||O.context===0||O.context===1)&&(fe=await(0,G.$T0b)(te,pe.fileUri,async $e=>$e.configPath.scheme===v.Schemas.file?this.M.resolveLocalWorkspace($e.configPath):void 0)),fe||(fe=this.vb(te))),fe?(0,ce.$ii)(fe.openedWorkspace)?F.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):(0,ce.$di)(fe.openedWorkspace)?_.push({workspace:fe.openedWorkspace,remoteAuthority:fe.remoteAuthority}):le(this.Y(O,fe,N),!0):le(await this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Ae=(0,D.$Mb)(F,pe=>pe.workspace.id);if(Ae.length>0){const pe=(0,D.$Hb)(Ae.map(te=>(0,G.$U0b)(this.getWindows(),te.workspace.configPath)));if(pe.length>0){const te=pe[0],fe=(0,$.$Mg)(N?.remoteAuthority,te.remoteAuthority)?N:void 0;le(this.Y(O,te,fe),!!fe),ge=!0}for(const te of Ae){if(pe.some(Pe=>Pe.openedWorkspace&&Pe.openedWorkspace.id===te.workspace.id))continue;const fe=te.remoteAuthority,$e=(0,$.$Mg)(N?.remoteAuthority,fe)?N:void 0;le(await this.bb(O,te,ge,$e),!!$e),ge=!0}}const Le=(0,D.$Mb)(_,pe=>$.$yg.getComparisonKey(pe.workspace.uri));if(Le.length>0){const pe=(0,D.$Hb)(Le.map(te=>(0,G.$U0b)(this.getWindows(),te.workspace.uri)));if(pe.length>0){const te=pe[0],fe=(0,$.$Mg)(N?.remoteAuthority,te.remoteAuthority)?N:void 0;le(this.Y(O,te,fe),!!fe),ge=!0}for(const te of Le){if(pe.some(Pe=>(0,ce.$di)(Pe.openedWorkspace)&&$.$yg.isEqual(Pe.openedWorkspace.uri,te.workspace.uri)))continue;const fe=te.remoteAuthority,$e=(0,$.$Mg)(N?.remoteAuthority,fe)?N:void 0;le(await this.bb(O,te,ge,$e),!!$e),ge=!0}}const ke=(0,D.$Mb)(z,pe=>pe.backupFolder);if(ke.length>0)for(const pe of ke){const te=pe.remoteAuthority,fe=(0,$.$Mg)(N?.remoteAuthority,te)?N:void 0;le(await this.ab(O,!0,te,fe,pe),!!fe),ge=!0}if(Q.length===0||N){N&&!x&&x++;const pe=N?N.remoteAuthority:O.remoteAuthority;for(let te=0;te<x;te++)le(await this.ab(O,ge,pe,N),!!N),ge=!0}return{windows:(0,D.$Mb)(Q),filesOpenedInWindow:se}}Y(O,F,_){this.w.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:_}),this.Z(F);const z={filesToOpenOrCreate:_?.filesToOpenOrCreate,filesToDiff:_?.filesToDiff,filesToMerge:_?.filesToMerge,filesToWait:_?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return F.sendWhenReady("vscode:openFiles",S.CancellationToken.None,z),F}Z(O){let F=O;const _=P.BrowserWindow.getFocusedWindow();if(_&&_.id!==O.id){const z=this.S.getWindowById(_.id);z&&z.parentId===O.id&&(F=z)}F.focus()}$(O,F){this.w.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:F}),O.focus();const _={foldersToAdd:F};return O.sendWhenReady("vscode:addFolders",S.CancellationToken.None,_),O}ab(O,F,_,z,x){this.w.trace("windowsManager#doOpenEmpty",{restore:!!x,remoteAuthority:_,filesToOpen:z,forceNewWindow:F});let N;return!F&&typeof O.contextWindowId=="number"&&(N=this.getWindowById(O.contextWindowId)),this.pb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:_,forceNewWindow:F,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:N,emptyWindowBackupInfo:x,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}bb(O,F,_,z,x){return this.w.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:F,filesToOpen:z}),!_&&!x&&typeof O.contextWindowId=="number"&&(x=this.getWindowById(O.contextWindowId)),this.pb({workspace:F.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:F.remoteAuthority,forceNewWindow:_,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:z,windowToUse:x,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async cb(O){let F,_=!1,z=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(F=await this.db(O),_=!0):O.forceEmpty?F=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(F=await this.eb(O.cli),F.length===0&&F.push(Object.create(null)),_=!0):(F=await this.gb(),F.length===0&&F.push(Object.create(null)),z=!0),!O.addMode&&_){const x=F.filter(N=>ee(N));if(x.length>1){const N=x[0].remoteAuthority;if(x.every(B=>(0,$.$Mg)(B.remoteAuthority,N))){const B=await this.M.createUntitledWorkspace(x.map(Q=>({uri:Q.workspace.uri})));F.push({workspace:B,remoteAuthority:N}),F=F.filter(Q=>!ee(Q))}}}if(O.initialStartup&&!z&&this.J.getValue("window")?.restoreWindows==="preserve"){const x=await this.gb();F.unshift(...x.filter(N=>q(N)||ee(N)||N.backupPath))}return F}async db(O){const F={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},_=await Promise.all((0,D.$Hb)(O.urisToOpen||[]).map(async z=>{const x=await this.ib(z,F);if(x)return x.label=z.label,x;const N=this.kb(z);this.O.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:N.scheme===v.Schemas.file?(0,m.localize)(1,null):(0,m.localize)(2,null),detail:N.scheme===v.Schemas.file?(0,m.localize)(3,null,(0,p.$Vv)(N,{os:w.OS,tildify:this.F})):(0,m.localize)(4,null,N.toString(!0))},P.BrowserWindow.getFocusedWindow()??void 0)}));return(0,D.$Hb)(_)}async eb(O){const F=[],_={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},z=O["folder-uri"];if(z){const B=await Promise.all(z.map(Q=>{const se=this.fb(Q);if(se)return this.ib({folderUri:se},_)}));F.push(...(0,D.$Hb)(B))}const x=O["file-uri"];if(x){const B=await Promise.all(x.map(Q=>{const se=this.fb(Q);if(se)return this.ib((0,ce.$yi)(Q)?{workspaceUri:se}:{fileUri:se},_)}));F.push(...(0,D.$Hb)(B))}const N=await Promise.all(O._.map(B=>_.remoteAuthority?this.nb(B,_):this.lb(B,_)));return F.push(...(0,D.$Hb)(N)),F}fb(O){try{const F=h.URI.parse(O);if(!F.scheme){this.w.error(`Invalid URI input string, scheme missing: ${O}`);return}return F.path?F:F.with({path:"/"})}catch(F){this.w.error(`Invalid URI input string: ${O}, ${F.message}`)}}async gb(){const O=this.hb();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const F=[];O!=="one"&&F.push(...this.r.state.openedWindows),this.r.state.lastActiveWindow&&F.push(this.r.state.lastActiveWindow);const _=await Promise.all(F.map(async z=>{if(z.workspace){const x=await this.ib({workspaceUri:z.workspace.configPath},{remoteAuthority:z.remoteAuthority,rejectTransientWorkspaces:!0});if(q(x))return x}else if(z.folderUri){const x=await this.ib({folderUri:z.folderUri},{remoteAuthority:z.remoteAuthority});if(ee(x))return x}else if(O!=="folders"&&z.backupPath)return{backupPath:z.backupPath,remoteAuthority:z.remoteAuthority}}));return(0,D.$Hb)(_)}}}hb(){let O;return this.H.wasRestarted?O="all":(O=this.J.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ib(O,F=Object.create(null)){const _=this.kb(O);return _.scheme===v.Schemas.file?((0,M.$RC)(O)&&(F={...F,forceOpenWorkspaceAsFile:!0}),this.lb(_.fsPath,F)):this.jb(O,F)}jb(O,F){let _=this.kb(O);const z=(0,E.$al)(_)||F.remoteAuthority;if(_=(0,$.$Og)((0,$.$Ig)(_)),(0,M.$RC)(O)){if(F.gotoLineMode){const{path:x,line:N,column:B}=(0,l.$cg)(_.path);return{fileUri:_.with({path:x}),options:{selection:N?{startLineNumber:N,startColumn:B||1}:void 0},remoteAuthority:z}}return{fileUri:_,remoteAuthority:z}}else if((0,M.$PC)(O))return{workspace:(0,re.$X0b)(_),remoteAuthority:z};return{workspace:(0,re.$Y0b)(_),remoteAuthority:z}}kb(O){return(0,M.$PC)(O)?O.workspaceUri:(0,M.$QC)(O)?O.folderUri:O.fileUri}async lb(O,F,_){let z,x;F.gotoLineMode&&({path:O,line:z,column:x}=(0,l.$cg)(O)),O=(0,l.$0f)((0,u.$hc)(O),(0,g.cwd)());try{const N=await R.Promises.stat(O);if(N.isFile()){if(!F.forceOpenWorkspaceAsFile){const B=await this.M.resolveLocalWorkspace(h.URI.file(O));if(B)return B.transient&&F.rejectTransientWorkspaces?void 0:{workspace:{id:B.id,configPath:B.configPath},type:i.FileType.File,exists:!0,remoteAuthority:B.remoteAuthority,transient:B.transient}}return{fileUri:h.URI.file(O),type:i.FileType.File,exists:!0,options:{selection:z?{startLineNumber:z,startColumn:x||1}:void 0}}}else{if(N.isDirectory())return{workspace:(0,re.$Y0b)(h.URI.file(O),N),type:i.FileType.Directory,exists:!0};if(!w.$i&&O==="/dev/null")return{fileUri:h.URI.file(O),type:i.FileType.File,exists:!0}}}catch(N){if(N.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!_)return this.mb(O,F);const B=h.URI.file(O);if(this.L.removeRecentlyOpened([B]),F.ignoreFileNotFound)return{fileUri:B,type:i.FileType.File,exists:!1}}}async mb(O,F){const _=h.URI.file(O),{response:z,checkboxChecked:x}=await this.O.showMessageBox({type:"warning",buttons:[(0,m.localize)(5,null),(0,m.localize)(6,null),(0,m.localize)(7,null)],message:(0,m.localize)(8,null,_.authority),detail:(0,m.localize)(9,null,(0,p.$Vv)(_,{os:w.OS,tildify:this.F})),checkboxLabel:(0,m.localize)(10,null,_.authority),cancelId:1});if(z===0){if((0,s.addUNCHostToAllowlist)(_.authority),x){const N={channel:"vscode:configureAllowedUNCHost",args:_.authority};this.sendToFocused(N.channel,N.args),this.sendToOpeningWindow(N.channel,N.args)}return this.lb(O,F,!0)}if(z===2)return P.shell.openExternal("https://aka.ms/vscode-windows-unc"),this.mb(O,F)}nb(O,F){const _=O.charCodeAt(0),z=F.remoteAuthority;let x,N;F.gotoLineMode&&({path:O,line:x,column:N}=(0,l.$cg)(O)),_!==47&&((0,l.$9f)(_)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,l.$2f)(O)),O=`/${O}`);const B=h.URI.from({scheme:v.Schemas.vscodeRemote,authority:z,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,ce.$yi)(O))return F.forceOpenWorkspaceAsFile?{fileUri:B,options:{selection:x?{startLineNumber:x,startColumn:N||1}:void 0},remoteAuthority:F.remoteAuthority}:{workspace:(0,re.$X0b)(B),remoteAuthority:z};if(F.gotoLineMode||u.$gc.basename(O).indexOf(".")!==-1)return{fileUri:B,options:{selection:x?{startLineNumber:x,startColumn:N||1}:void 0},remoteAuthority:z}}return{workspace:(0,re.$Y0b)(B),remoteAuthority:z}}ob(O){const F=this.J.getValue("window"),_=F?.openFoldersInNewWindow||"default",z=F?.openFilesInNewWindow||"off";let x=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(_==="on"||_==="off")&&(x=_==="on");let N=!1;return O.forceNewWindow||O.forceReuseWindow?N=!!O.forceNewWindow&&!O.forceReuseWindow:(w.$j?O.context===1&&(N=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!O.cli.extensionDevelopmentPath&&(z==="on"||z==="off")&&(N=z==="on")),{openFolderInNewWindow:!!x,openFilesInNewWindow:N}}async openExtensionDevelopmentHostWindow(O,F){const _=(0,G.$V0b)(this.getWindows(),O);if(_)return this.H.reload(_,F.cli),_.focus(),[_];let z=F.cli["folder-uri"]||[],x=F.cli["file-uri"]||[],N=F.cli._;if(!N.length&&!z.length&&!x.length&&!F.cli.extensionTestsPath){const se=this.r.state.lastPluginDevelopmentHostWindow,le=se?.workspace??se?.folderUri;le&&(h.URI.isUri(le)?le.scheme===v.Schemas.file?N=[le.fsPath]:z=[le.toString()]:le.configPath.scheme===v.Schemas.file?N=[(0,$.$vg)(le.configPath)]:x=[le.configPath.toString()])}let B=F.remoteAuthority;for(const se of O)if(se.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const le=h.URI.parse(se),ge=(0,E.$al)(le);ge&&(B?(0,$.$Mg)(ge,B)||this.w.error("more than one extension development path authority"):B=ge)}N=N.filter(se=>{const le=h.URI.file(se);return(0,G.$U0b)(this.getWindows(),le)?!1:(0,$.$Mg)((0,E.$al)(le),B)}),z=z.filter(se=>{const le=this.fb(se);return le&&(0,G.$U0b)(this.getWindows(),le)?!1:le?(0,$.$Mg)((0,E.$al)(le),B):!1}),x=x.filter(se=>{const le=this.fb(se);return le&&(0,G.$U0b)(this.getWindows(),le)?!1:le?(0,$.$Mg)((0,E.$al)(le),B):!1}),F.cli._=N,F.cli["folder-uri"]=z,F.cli["file-uri"]=x;const Q={context:F.context,cli:F.cli,forceNewWindow:!0,forceEmpty:!N.length&&!z.length&&!x.length,userEnv:F.userEnv,noRecentEntry:!0,waitMarkerFileURI:F.waitMarkerFileURI,remoteAuthority:B,forceProfile:F.forceProfile,forceTempProfile:F.forceTempProfile};return this.open(Q)}async pb(O){const F=this.J.getValue("window"),_=this.getLastActiveWindow(),z=_?.profile??this.G.defaultProfile;let x;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(x=O.windowToUse||_,x&&x.focus());const N={...this.F.args,...O.cli,machineId:this.s,sqmId:this.t,windowId:-1,mainPid:process.pid,appRoot:this.F.appRoot,execPath:process.execPath,codeCachePath:this.F.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,u.$jc)(this.F.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.G.profilesHome,all:this.G.profiles,profile:z},homeDir:this.F.userHome.with({scheme:v.Schemas.file}).fsPath,tmpDir:this.F.tmpDir.with({scheme:v.Schemas.file}).fsPath,userDataDir:this.F.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.u,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.z.getLogLevel(),loggers:{window:[],global:this.z.getRegisteredLoggers()},logsPath:this.F.logsHome.with({scheme:v.Schemas.file}).fsPath,product:C.default,isInitialStartup:O.initialStartup,perfMarks:(0,y.getMarks)(),os:{release:(0,j.release)(),hostname:(0,j.hostname)(),arch:(0,j.arch)()},autoDetectHighContrast:F?.autoDetectHighContrast??!0,autoDetectColorScheme:F?.autoDetectColorScheme??!1,accessibilitySupport:P.app.accessibilitySupportEnabled,colorScheme:this.R.getColorScheme(),policiesData:this.D.serialize(),continueOn:this.F.continueOn};if(x){const B=x.config;!N.extensionDevelopmentPath&&B?.extensionDevelopmentPath&&(N.extensionDevelopmentPath=B.extensionDevelopmentPath,N.extensionDevelopmentKind=B.extensionDevelopmentKind,N["enable-proposed-api"]=B["enable-proposed-api"],N.verbose=B.verbose,N["inspect-extensions"]=B["inspect-extensions"],N["inspect-brk-extensions"]=B["inspect-brk-extensions"],N.debugId=B.debugId,N.extensionEnvironment=B.extensionEnvironment,N["extensions-dir"]=B["extensions-dir"],N["disable-extensions"]=B["disable-extensions"]),N.loggers={global:N.loggers.global,window:B?.loggers.window??N.loggers.window}}else{const B=this.r.getNewWindowState(N);(0,y.mark)("code/willCreateCodeWindow");const Q=x=this.N.createInstance(T.$60b,{state:B,extensionDevelopmentPath:N.extensionDevelopmentPath,isExtensionTestHost:!!N.extensionTestsPath});(0,y.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(Q),this.n.set(Q.id,Q),this.a.fire(Q),this.f.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()});const se=new k.$Sc;se.add(Q.onDidSignalReady(()=>this.b.fire(Q))),se.add(f.Event.once(Q.onDidClose)(()=>this.sb(Q,se))),se.add(f.Event.once(Q.onDidDestroy)(()=>this.tb(Q))),se.add(Q.onDidMaximize(()=>this.g.fire(Q))),se.add(Q.onDidUnmaximize(()=>this.h.fire(Q))),se.add(Q.onDidEnterFullScreen(()=>this.j.fire({window:Q,fullscreen:!0}))),se.add(Q.onDidLeaveFullScreen(()=>this.j.fire({window:Q,fullscreen:!1}))),se.add(Q.onDidTriggerSystemContextMenu(({x:ge,y:be})=>this.m.fire({window:Q,x:ge,y:be})));const le=(0,d.$Tf)(Q.win?.webContents);le.removeAllListeners("devtools-reload-page"),le.on("devtools-reload-page",()=>this.H.reload(Q)),this.H.registerWindow(Q)}return N.windowId=x.id,x.isReady?this.H.unload(x,4).then(async B=>{B||await this.qb(x,N,O,z)}):await this.qb(x,N,O,z),x}async qb(O,F,_,z){if(F.extensionDevelopmentPath||((0,ce.$ii)(F.workspace)?F.backupPath=this.I.registerWorkspaceBackup({workspace:F.workspace,remoteAuthority:F.remoteAuthority}):(0,ce.$di)(F.workspace)?F.backupPath=this.I.registerFolderBackup({folderUri:F.workspace.uri,remoteAuthority:F.remoteAuthority}):F.backupPath=this.I.registerEmptyWindowBackup({backupFolder:_.emptyWindowBackupInfo?.backupFolder??(0,re.$Z0b)().id,remoteAuthority:F.remoteAuthority})),this.G.isEnabled()){const x=F.workspace??(0,ce.$hi)(F.backupPath,!1),N=this.rb(_,x,z),B=N instanceof Promise?await N:N;F.profiles.profile=B,F.extensionDevelopmentPath||await this.G.setProfileForWorkspace(x,B)}O.load(F)}rb(O,F,_){return O.forceProfile?this.G.profiles.find(z=>z.name===O.forceProfile)??this.G.createNamedProfile(O.forceProfile):O.forceTempProfile?this.G.createTransientProfile():this.G.getProfileForWorkspace(F)??_}sb(O,F){this.n.delete(O.id),this.f.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()}),F.dispose()}tb(O){this.n.delete(O.id),this.c.fire(O)}getFocusedWindow(){const O=P.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.vb(this.getWindows())}ub(O){return this.vb(this.getWindows().filter(F=>(0,$.$Mg)(F.remoteAuthority,O)))}vb(O){return(0,W.$Q0b)(O)}sendToFocused(O,...F){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,S.CancellationToken.None,...F)}sendToOpeningWindow(O,...F){this.B(f.Event.once(this.onDidSignalReadyWindow)(_=>{_.sendWhenReady(O,S.CancellationToken.None,...F)}))}sendToAll(O,F,_){for(const z of this.getWindows())_&&_.indexOf(z.id)>=0||z.sendWhenReady(O,S.CancellationToken.None,F)}getWindows(){return Array.from(this.n.values())}getWindowCount(){return this.n.size}getWindowById(O){return this.n.get(O)}getWindowByWebContents(O){const F=P.BrowserWindow.fromWebContents(O);if(F)return this.getWindowById(F.id)}};e.$d_b=he,e.$d_b=he=ve([ne(3,b.$nj),ne(4,U.$30b),ne(5,A.$uO),ne(6,V.$Jn),ne(7,r.$A0b),ne(8,L.$R0b),ne(9,a.$80b),ne(10,c.$F0b),ne(11,t.$zi),ne(12,ue.$L$b),ne(13,Z.$10b),ne(14,n.$5h),ne(15,o.$G0b),ne(16,i.$qk),ne(17,I.$I0b),ne(18,Y.$J0b),ne(19,H.$L0b)],he)}),define(oe[307],ae([0,1,66,29,83,57]),function(X,e,P,R,s,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$f_b=void 0;let D=class{constructor(f,l,p,k){this.a=f,this.b=l,this.c=p,this.d=k,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(f,l){const p=this.b.getWindowById(f);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),l)}createUntitledWorkspace(f,l,p){return this.a.createUntitledWorkspace(l,p)}deleteUntitledWorkspace(f,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(f,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(f){return this.c.getRecentlyOpened()}addRecentlyOpened(f,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(f,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(f){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.$f_b=D,e.$f_b=D=ve([ne(0,j.$10b),ne(1,R.$N0b),ne(2,s.$L$b),ne(3,P.$F0b)],D)}),define(oe[308],ae([0,1,15,132,37,26,17,51,14,33,3,42,47,2,13,9,4,12,7,32,158,43,159,111,290,162,66,283,18,200,91,133,55,117,220,24,64,94,209,293,211,212,213,16,224,93,78,6,92,219,299,284,291,20,5,305,71,27,59,294,95,34,275,82,123,28,251,253,54,49,265,288,300,289,301,128,267,268,269,272,297,60,29,306,274,30,97,83,307,57,39,233,56,244,53,81,130,277,292,280,8,255,276,228,69,296,271,22,126,295,263,239,62,65,303]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t,o,r,i,n,a,b,C,I,E,A,M,T,W,G,J,ce,re,ue,Z,Y,V,L,U,H,q,ee,he,K,O,F,_,z,x,N,B,Q,se,le,ge,be,Se,Ae,Le,ke,pe,te,fe,$e,Pe,je,Te,Me,Je,Be,Ve,He,ie,de,we,Ee,ye,Re,We,qe,Qe,xe,Xe,Ze,nt,st,ot,pt,yt,vt,kt,Et,St,at,gt,Pt,It,At,ct,Dt,$t,lt,Ct,Rt,ut,Ot,ht,jt){"use strict";var ft;Object.defineProperty(e,"__esModule",{value:!0}),e.$y_b=void 0;let dt=class extends u.$Tc{static{ft=this}static{this.a={[y.Schemas.file]:"security.promptForLocalFileProtocolHandling",[y.Schemas.vscodeRemote]:"security.promptForRemoteFileProtocolHandling"}}constructor(Ie,De,Oe,me,Ce,Ne,ze,Ke,Fe,Ue,Ge,Ye){super(),this.g=Ie,this.h=De,this.j=Oe,this.m=me,this.n=Ce,this.s=Ne,this.t=ze,this.u=Ke,this.w=Fe,this.y=Ue,this.z=Ge,this.C=Ye,this.D(),this.F()}D(){const Ie=Fe=>Fe?.startsWith(`${y.Schemas.vscodeWebview}://`),De=new Set(["clipboard-read","clipboard-sanitized-write"]);P.session.defaultSession.setPermissionRequestHandler((Fe,Ue,Ge,Ye)=>Ie(Ye.requestingUrl)?Ge(De.has(Ue)):Ge(!1)),P.session.defaultSession.setPermissionCheckHandler((Fe,Ue,Ge,Ye)=>Ie(Ye.requestingUrl)?De.has(Ue):!1);const Oe=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,y.Schemas.vscodeManagedRemoteResource,"devtools"]),me=Fe=>{for(let Ue=Fe;Ue;Ue=Ue.parent)if(Ue.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Ce=Fe=>Fe.resourceType==="xhr"||me(Fe.frame),Ne=Fe=>{const Ue=Fe.frame;if(!Ue||!this.b)return!1;const Ge=P.BrowserWindow.getAllWindows();for(const Ye of Ge)if(Ue.processId===Ye.webContents.mainFrame.processId)return!0;return!1},ze=(Fe,Ue)=>{if(Fe.path!=="/index.html")return!0;const Ge=Ue.frame;if(!Ge||!this.b)return!1;for(const Ye of this.b.getWindows())if(Ye.win&&Ge.processId===Ye.win.webContents.mainFrame.processId)return!0;return!1};P.session.defaultSession.webRequest.onBeforeRequest((Fe,Ue)=>{const Ge=d.URI.parse(Fe.url);return Ge.scheme===y.Schemas.vscodeWebview&&!ze(Ge,Fe)?(this.m.error("Blocked vscode-webview request",Fe.url),Ue({cancel:!0})):Ge.scheme===y.Schemas.vscodeFileResource&&!Ne(Fe)?(this.m.error("Blocked vscode-file request",Fe.url),Ue({cancel:!0})):Ge.path.endsWith(".svg")&&!Oe.has(Ge.scheme)?Ue({cancel:!Ce(Fe)}):Ue({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Fe,Ue)=>{const Ge=Fe.responseHeaders,Ye=Ge["content-type"]||Ge["Content-Type"];if(Ye&&Array.isArray(Ye)){const _e=d.URI.parse(Fe.url);if(_e.path.endsWith(".svg")&&Oe.has(_e.scheme))return Ge["Content-Type"]=["image/svg+xml"],Ue({cancel:!1,responseHeaders:Ge});if(!_e.path.endsWith(y.Schemas.vscodeRemoteResource)&&Ye.some(tt=>tt.toLowerCase().includes("image/svg")))return Ue({cancel:!Ce(Fe)})}return Ue({cancel:!1})}),P.session.defaultSession.webRequest.onHeadersReceived((Fe,Ue)=>{if(Fe.url.startsWith("https://vscode.download.prss.microsoft.com/")){const Ge=Fe.responseHeaders??Object.create(null);if(Ge["Access-Control-Allow-Origin"]===void 0)return Ge["Access-Control-Allow-Origin"]=["*"],Ue({cancel:!1,responseHeaders:Ge})}return Ue({cancel:!1})});const Ke=P.session.defaultSession;typeof Ke.setCodeCachePath=="function"&&this.s.codeCachePath&&Ke.setCodeCachePath((0,w.$jc)(this.s.codeCachePath,"chrome")),g.$i&&(this.u.getValue("security.restrictUNCAccess")===!1?(0,R.disableUNCAccessRestrictions)():(0,R.addUNCHostToAllowlist)(this.u.getValue("security.allowedUNCHosts")))}F(){(0,f.setUnexpectedErrorHandler)(Oe=>this.H(Oe)),process.on("uncaughtException",Oe=>{(0,f.$Z)(Oe)||(0,f.$1)(Oe)}),process.on("unhandledRejection",Oe=>(0,f.$1)(Oe)),this.t.onWillShutdown(()=>this.dispose()),(0,m.$BU)(),P.app.on("accessibility-support-changed",(Oe,me)=>{this.b?.sendToAll("vscode:accessibilitySupportChanged",me)}),P.app.on("activate",async(Oe,me)=>{this.m.trace("app#activate"),me||await this.b?.openEmptyWindow({context:1})}),P.app.on("web-contents-created",(Oe,me)=>{(0,ht.$M0b)(me)&&(this.m.trace('[aux window]  app.on("web-contents-created"): Registering auxiliary window'),this.c?.registerWindow(me)),me.on("will-navigate",Ce=>{this.m.error("webContents#will-navigate: Prevented webcontent navigation"),Ce.preventDefault()}),me.setWindowOpenHandler(Ce=>Ce.url==="about:blank"?(this.m.trace("[aux window] webContents#setWindowOpenHandler: Allowing auxiliary window to open on about:blank"),{action:"allow",overrideBrowserWindowOptions:this.c?.createWindow()}):(this.m.trace(`webContents#setWindowOpenHandler: Prevented opening window with URL ${Ce.url}}`),this.f?.openExternal(void 0,Ce.url),{action:"deny"}))});let Ie=[],De;P.app.on("open-file",(Oe,me)=>{this.m.trace("app#open-file: ",me),Oe.preventDefault(),Ie.push((0,We.$yi)(me)?{workspaceUri:d.URI.file(me)}:{fileUri:d.URI.file(me)}),De!==void 0&&(clearTimeout(De),De=void 0),De=setTimeout(async()=>{await this.b?.open({context:1,cli:this.s.args,urisToOpen:Ie,gotoLineMode:!1,preferNewWindow:!0}),Ie=[],De=void 0},100)}),P.app.on("new-window-for-tab",async()=>{await this.b?.openEmptyWindow({context:4})}),s.$AU.handle("vscode:fetchShellEnv",Oe=>{const me=this.b?.getWindowByWebContents(Oe.sender);let Ce,Ne;return me?.config?(Ce=me.config,Ne={...process.env,...me.config.userEnv}):(Ce=this.s.args,Ne=process.env),this.X(Ce,Ne,!1)}),s.$AU.handle("vscode:writeNlsFile",(Oe,me,Ce)=>{const Ne=this.G([me]);if(!Ne||typeof Ce!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.y.writeFile(Ne,D.$je.fromString(Ce))}),s.$AU.handle("vscode:readNlsFile",async(Oe,...me)=>{const Ce=this.G(me);if(!Ce)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.y.readFile(Ce)).value.toString()}),s.$AU.on("vscode:toggleDevTools",Oe=>Oe.sender.toggleDevTools()),s.$AU.on("vscode:openDevTools",Oe=>Oe.sender.openDevTools()),s.$AU.on("vscode:reloadWindow",Oe=>Oe.sender.reload()),s.$AU.handle("vscode:notifyZoomLevel",async(Oe,me)=>{const Ce=this.b?.getWindowById(Oe.sender.id);Ce&&Ce.notifyZoomLevel(me)})}G(Ie){let De;for(const Oe of Ie)typeof Oe=="string"&&(typeof De!="string"?De=Oe:De=(0,w.$jc)(De,Oe));if(!(typeof De!="string"||!(0,w.$ic)(De)||!(0,l.$8f)(De,this.s.cachedLanguagesPath,!g.$k)))return d.URI.file(De)}H(Ie){if(Ie){const De={message:`[uncaught exception in main]: ${Ie.message}`,stack:Ie.stack};this.b?.sendToFocused("vscode:reportError",JSON.stringify(De))}this.m.error(`[uncaught exception in main]: ${Ie}`),Ie.stack&&this.m.error(Ie.stack)}async startup(){this.m.debug("Starting VS Code"),this.m.debug(`from: ${this.s.appRoot}`),this.m.debug("args:",this.s.args);const Ie=this.z.win32AppUserModelId;g.$i&&Ie&&P.app.setAppUserModelId(Ie);try{g.$j&&this.u.getValue("window.nativeTabs")===!0&&!P.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&P.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ue){this.m.error(Ue)}const De=new t.$HU;this.t.onWillShutdown(Ue=>{Ue.reason===2&&De.dispose()}),this.m.trace("Resolving machine identifier...");const[Oe,me]=await Promise.all([(0,gt.$n_b)(this.w,this.m),(0,gt.$o_b)(this.w,this.m)]);this.m.trace(`Resolved machine identifier: ${Oe}`);const{sharedProcessReady:Ce,sharedProcessClient:Ne}=this.P(Oe,me),ze=await this.Q(Oe,me,Ce);this.B(ze.createInstance(r.$f$b)),this.B(ze.createInstance(Et.$j_b)),ze.invokeFunction(Ue=>this.R(Ue,De,Ne));const Ke=await ze.invokeFunction(Ue=>this.I(Ue,De));this.J(De),this.t.phase=2,await ze.invokeFunction(Ue=>this.S(Ue,Ke)),this.t.phase=3,this.U(),this.B(new at.$fh(()=>{this.B((0,at.$jh)(()=>this.t.phase=4,2500))},2500)).schedule()}async I(Ie,De){const Oe=this.b=Ie.get(Ee.$N0b),me=Ie.get(Je.$pV),Ce=this.f=Ie.get(N.$z$b),Ne=Ie.get(A.$G0b),ze=this;me.registerHandler({async handleURL(_e,tt){return ze.O(Oe,Ne,me,_e,tt)}});const Ke=this.B(new Re.$e_b({onDidOpenMainWindow:Ce.onDidOpenMainWindow,onDidFocusMainWindow:Ce.onDidFocusMainWindow,getActiveWindowId:()=>Ce.getActiveWindowId(-1)})),Fe=new c.$Nh(_e=>Ke.getActiveClientId().then(tt=>_e===tt)),Ue=new Be.$8$b(Fe,this.m),Ge=De.getChannel("urlHandler",Ue);me.registerHandler(new Be.$7$b(Ge));const Ye=await this.L(Oe,Ne);return this.B(new He.$9$b(Ye?.urls,me,Oe,this.s,this.z,this.m)),Ye}J(Ie){const De=()=>({statusCode:404,data:"Not found"}),Oe=new Ot.$V(()=>Ie.getChannel(ut.$v_b,new ut.$w_b));P.protocol.registerBufferProtocol(y.Schemas.vscodeManagedRemoteResource,(me,Ce)=>{const Ne=d.URI.parse(me.url);if(!Ne.authority.startsWith("window:"))return Ce(De());Oe.value.call(ut.$u_b,[Ne]).then(ze=>Ce({...ze,data:Buffer.from(ze.body,"base64")}),ze=>{this.m.warn("error dispatching remote resource call",ze),Ce({statusCode:500,data:String(ze)})})})}async L(Ie,De){const Oe=this.s.args["open-url"]?this.s.args._urls||[]:[];Oe.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",Oe);const me=global.getOpenUrls()||[];if(me.length>0&&this.m.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",me),Oe.length+me.length===0)return;const Ce=[...Oe,...me].map(Ke=>{try{return{uri:d.URI.parse(Ke),originalUrl:Ke}}catch{this.m.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Ke);return}}),Ne=[],ze=[];for(const Ke of Ce){if(!Ke)continue;const Fe=this.N(Ke.uri);if(Fe)if(await this.M(Fe,Ie,De)){this.m.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Ke.uri.toString(!0));continue}else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Ke.uri.toString(!0),Fe),Ne.push(Fe);else this.m.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Ke.uri.toString(!0)),ze.push(Ke)}return{urls:ze,openables:Ne}}async M(Ie,De,Oe){let me,Ce;if((0,we.$PC)(Ie)?(me=Ie.workspaceUri,Ce=(0,i.localize)(0,null,me.scheme===y.Schemas.file?(0,v.$Vv)(me,{os:g.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)):(0,we.$QC)(Ie)?(me=Ie.folderUri,Ce=(0,i.localize)(1,null,me.scheme===y.Schemas.file?(0,v.$Vv)(me,{os:g.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)):(me=Ie.fileUri,Ce=(0,i.localize)(2,null,me.scheme===y.Schemas.file?(0,v.$Vv)(me,{os:g.OS,tildify:this.s}):me.toString(!0),this.z.nameShort)),me.scheme!==y.Schemas.file&&me.scheme!==y.Schemas.vscodeRemote||this.u.getValue(ft.a[me.scheme])===!1)return!1;const{response:ze,checkboxChecked:Ke}=await Oe.showMessageBox({type:"warning",buttons:[(0,i.localize)(3,null),(0,i.localize)(4,null)],message:Ce,detail:(0,i.localize)(5,null),checkboxLabel:me.scheme===y.Schemas.file?(0,i.localize)(6,null):(0,i.localize)(7,null),cancelId:1});if(ze!==0)return!0;if(Ke){const Fe={channel:"vscode:disablePromptForProtocolHandling",args:me.scheme===y.Schemas.file?"local":"remote"};De.sendToFocused(Fe.channel,Fe.args),De.sendToOpeningWindow(Fe.channel,Fe.args)}return!1}N(Ie){if(Ie.path){if(Ie.authority===y.Schemas.file){const De=d.URI.file(Ie.fsPath);return(0,We.$yi)(De)?{workspaceUri:De}:{fileUri:De}}else if(Ie.authority===y.Schemas.vscodeRemote){const De=Ie.path.indexOf(w.$gc.sep,1);if(De!==-1){const Oe=Ie.path.substring(1,De),me=Ie.path.substring(De);let Ce=Ie.query;const Ne=new URLSearchParams(Ie.query);Ne.get("windowId")==="_blank"&&(Ne.delete("windowId"),Ce=Ne.toString());const ze=d.URI.from({scheme:y.Schemas.vscodeRemote,authority:Oe,path:me,query:Ce,fragment:Ie.fragment});return(0,We.$yi)(me)?{workspaceUri:ze}:/:[\d]+$/.test(me)?{fileUri:ze}:{folderUri:ze}}}}}async O(Ie,De,Oe,me,Ce){this.m.trace("app#handleProtocolUrl():",me.toString(!0),Ce),me.scheme===this.z.urlProtocol&&me.path==="workspace"&&(me=me.with({authority:"file",path:d.URI.parse(me.query).path,query:""}));let Ne=!1;const ze=new URLSearchParams(me.query);ze.get("windowId")==="_blank"?(this.m.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",me.toString(!0)),ze.delete("windowId"),me=me.with({query:ze.toString()}),Ne=!0):g.$j&&Ie.getWindowCount()===0&&(this.m.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",me.toString(!0)),Ne=!0);const Ke=ze.get("continueOn");Ke!==null&&(this.m.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",me.toString(!0)),ze.delete("continueOn"),me=me.with({query:ze.toString()}),this.s.continueOn=Ke??void 0);const Fe=this.N(me);return Fe?await this.M(Fe,Ie,De)?(this.m.trace("app#handleProtocolUrl() protocol url was blocked:",me.toString(!0)),!0):(this.m.trace("app#handleProtocolUrl() opening protocol url as window:",Fe,me.toString(!0)),(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},urisToOpen:[Fe],forceNewWindow:Ne,gotoLineMode:!0}))?.focus(),!0):Ne?(this.m.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",me.toString(!0)),await(0,$t.$Ob)(await Ie.open({context:5,cli:{...this.s.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Q.$al)(me)}))?.ready(),Oe.open(me,Ce)):(this.m.trace("app#handleProtocolUrl(): not handled",me.toString(!0),Ce),!1)}P(Ie,De){const Oe=this.B(this.j.createInstance(se.$T$b,Ie,De)),me=(async()=>{this.m.trace("Main->SharedProcess#connect");const Ne=await Oe.connect();return this.m.trace("Main->SharedProcess#connect: connection established"),new o.$IU(Ne,"main")})();return{sharedProcessReady:(async()=>(await Oe.whenReady(),me))(),sharedProcessClient:me}}async Q(Ie,De,Oe){const me=new ee.$4h;switch(process.platform){case"win32":me.set(fe.$zV,new H.$3h(Me.$5$b));break;case"linux":g.$l?me.set(fe.$zV,new H.$3h(Te.$4$b,[process.env.SNAP,process.env.SNAP_REVISION])):me.set(fe.$zV,new H.$3h(je.$3$b));break;case"darwin":me.set(fe.$zV,new H.$3h(Pe.$2$b));break}me.set(Ee.$N0b,new H.$3h(ye.$d_b,[Ie,De,this.h],!1)),me.set(ht.$L0b,new H.$3h(jt.$x_b,void 0,!1));const Ce=new A.$H0b(this.m,this.z);me.set(A.$G0b,Ce),me.set(F.$F$b,new H.$3h(F.$G$b,void 0,!1)),me.set(E.$l$b,new H.$3h(E.$m$b,void 0,!1)),me.set(I.$Im,c.ProxyChannel.toService((0,c.$Lh)(Oe.then(Ue=>Ue.getChannel("diagnostics"))))),me.set(he.$0zb,new H.$3h(K.$B$b,[this.h])),me.set(M.$jV,new H.$3h(T.$n$b)),me.set(O.$C$b,new H.$3h(O.$D$b)),me.set(N.$z$b,new H.$3h(N.$A$b,void 0,!1)),me.set(ie.$0$b,new H.$3h(de.$_$b)),me.set(x.$O$b,new H.$3h(x.$P$b)),me.set(ce.$o$b,new H.$3h(re.$q$b)),me.set(Se.$b$b,new H.$3h(Se.$c$b)),me.set(Se.$d$b,new H.$3h(Se.$e$b));const Ne=new Ct.$t_b({graceTime:6e4,shortGraceTime:6e3,scrollback:this.u.getValue("terminal.integrated.persistentSessionScrollback")??100},this.u,this.s,this.t,this.m),ze=new Rt.$Xr(Ne,this.u,this.m,this.n);me.set(lt.$yr,ze),g.$i?me.set(ue.$r$b,new H.$3h(Z.$s$b)):g.$j?me.set(ue.$r$b,new H.$3h(Z.$t$b)):g.$k&&me.set(ue.$r$b,new H.$3h(Z.$u$b));const Ke=new a.$g$b(this.s,this.u,this.m,this.w);me.set(n.$F0b,Ke);const Fe=new Xe.$20b(this.s,this.m,this.C,Ke,Ce);if(me.set(Xe.$10b,Fe),me.set(qe.$Dcb,new H.$3h(xe.$f_b,void 0,!1)),me.set(Qe.$L$b,new H.$3h(Qe.$M$b,void 0,!1)),me.set(Je.$pV,new H.$3h(Ve.$rV,void 0,!1)),(0,te.$So)(this.z,this.s)){const Ue=(0,te.$Xo)(this.z,this.u),Ge=(0,c.$Lh)(Oe.then(rt=>rt.getChannel("telemetryAppender"))),Ye=new ke.$W$b(Ge),_e=(0,Ae.$Jo)((0,j.release)(),(0,j.hostname)(),process.arch,this.z.commit,this.z.version,Ie,De,Ue),tt=(0,te.$Yo)(this.s),it={appenders:[Ye],commonProperties:_e,piiPaths:tt,sendErrorTelemetry:!0};me.set(Le.$ul,new H.$3h(pe.$pr,[it],!1))}else me.set(Le.$ul,te.$No);return me.set(yt.$Vp,new H.$3h(Pt.$BO,void 0,!0)),me.set(vt.$Zp,new H.$3h(kt.$i_b,void 0,!0)),me.set(ct.$r_b,new H.$3h(ct.$s_b,void 0,!0)),await at.Promises.settled([Ke.initialize(),Fe.initialize()]),this.j.createChild(me)}R(Ie,De,Oe){const me=this.B(new u.$Sc),Ce=c.ProxyChannel.fromService(Ie.get(F.$F$b),me,{disableMarshalling:!0});this.g.registerChannel("launch",Ce);const Ne=c.ProxyChannel.fromService(Ie.get(E.$l$b),me,{disableMarshalling:!0});this.g.registerChannel("diagnostics",Ne);const ze=new nt.$g_b(Ie.get(Ze.$Jn));De.registerChannel("policy",ze),Oe.then(et=>et.registerChannel("policy",ze));const Ke=this.y.getProvider(y.Schemas.file);(0,$.$Sf)(Ke instanceof U.$Bq);const Fe=new L.$v$b(Ke,this.m,this.s);De.registerChannel(Y.$kO,Fe),Oe.then(et=>et.registerChannel(Y.$kO,Fe));const Ue=c.ProxyChannel.fromService(Ie.get(st.$R0b),me);De.registerChannel("userDataProfiles",Ue),Oe.then(et=>et.registerChannel("userDataProfiles",Ue));const Ge=new ot.$kr(Ie.get(pt.$hp));Oe.then(et=>et.registerChannel("request",Ge));const Ye=new $e.$X$b(Ie.get(fe.$zV));De.registerChannel("update",Ye);const _e=c.ProxyChannel.fromService(Ie.get(he.$0zb),me);De.registerChannel("issue",_e);const tt=c.ProxyChannel.fromService(Ie.get(M.$jV),me);De.registerChannel("encryption",tt);const it=c.ProxyChannel.fromService(Ie.get(le.$il),me);De.registerChannel("sign",it);const rt=c.ProxyChannel.fromService(Ie.get(O.$C$b),me);De.registerChannel("keyboardLayout",rt),this.f=Ie.get(N.$z$b);const mt=c.ProxyChannel.fromService(this.f,me);De.registerChannel("nativeHost",mt),Oe.then(et=>et.registerChannel("nativeHost",mt));const Mt=c.ProxyChannel.fromService(Ie.get(qe.$Dcb),me);De.registerChannel("workspaces",Mt);const Lt=c.ProxyChannel.fromService(Ie.get(x.$O$b),me);De.registerChannel("menubar",Lt);const Ft=c.ProxyChannel.fromService(Ie.get(Je.$pV),me);De.registerChannel("url",Ft);const Ut=c.ProxyChannel.fromService(Ie.get(ie.$0$b),me);De.registerChannel("webview",Ut);const wt=this.B(new be.$U$b(this.m,Ie.get(Se.$b$b)));De.registerChannel("storage",wt),Oe.then(et=>et.registerChannel("storage",wt));const Wt=this.B(new St.$k_b(Ie.get(Se.$b$b),Ie.get(st.$R0b),this.m));Oe.then(et=>et.registerChannel("profileStorageListener",Wt));const Tt=c.ProxyChannel.fromService(Ie.get(lt.$yr),me);De.registerChannel(lt.TerminalIpcChannels.LocalPty,Tt);const Nt=c.ProxyChannel.fromService(Ie.get(ue.$r$b),me);De.registerChannel("externalTerminal",Nt);const bt=new It.$p_b(Ie.get(At.$30b));De.registerChannel("logger",bt),Oe.then(et=>et.registerChannel("logger",bt));const zt=new C.$h$b(Ie.get(Ee.$N0b));De.registerChannel("extensionhostdebugservice",zt);const Bt=c.ProxyChannel.fromService(Ie.get(ce.$o$b),me);De.registerChannel(ce.$p$b,Bt);const qt=c.ProxyChannel.fromService(Ie.get(ct.$r_b),me);De.registerChannel(Dt.$q_b,qt)}async S(Ie,De){const Oe=this.b=Ie.get(Ee.$N0b);this.c=Ie.get(ht.$L0b);const me=(0,G.$6l)(process.env)?0:4,Ce=this.s.args;if(De){if(De.openables.length>0)return Oe.open({context:me,cli:Ce,urisToOpen:De.openables,gotoLineMode:!0,initialStartup:!0});if(De.urls.length>0)for(const it of De.urls){const rt=new URLSearchParams(it.uri.query);if(rt.get("windowId")==="_blank")return rt.delete("windowId"),it.originalUrl=it.uri.toString(!0),it.uri=it.uri.with({query:rt.toString()}),Oe.open({context:me,cli:Ce,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const Ne=global.macOpenFiles,ze=Ce._.length,Ke=!!Ce["folder-uri"],Fe=!!Ce["file-uri"],Ue=Ce["skip-add-to-recently-opened"]===!0,Ge=Ce.wait&&Ce.waitMarkerFilePath?d.URI.file(Ce.waitMarkerFilePath):void 0,Ye=Ce.remote||void 0,_e=Ce.profile,tt=Ce["profile-temp"];if(!ze&&!Ke&&!Fe){if(Ce["new-window"]||_e||tt)return Oe.open({context:me,cli:Ce,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ue,waitMarkerFileURI:Ge,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:tt});if(Ne.length)return Oe.open({context:1,cli:Ce,urisToOpen:Ne.map(it=>(0,We.$yi)(it)?{workspaceUri:d.URI.file(it)}:{fileUri:d.URI.file(it)}),noRecentEntry:Ue,waitMarkerFileURI:Ge,initialStartup:!0})}return Oe.open({context:me,cli:Ce,forceNewWindow:Ce["new-window"]||!ze&&Ce["unity-launch"],diffMode:Ce.diff,mergeMode:Ce.merge,noRecentEntry:Ue,waitMarkerFileURI:Ge,gotoLineMode:Ce.goto,initialStartup:!0,remoteAuthority:Ye,forceProfile:_e,forceTempProfile:tt})}U(){this.W(),P.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(Ie,De)=>{De({url:Ie.url.replace(/^vscode-remote-resource:/,"http:"),method:Ie.method})}),this.X(this.s.args,process.env,!0),this.Y(),g.$j&&P.app.runningUnderARM64Translation&&this.b?.sendToFocused("vscode:showTranslatedBuildWarning")}async W(){const Ie=this.z.win32MutexName;if(g.$i&&Ie)try{const De=await new Promise((me,Ce)=>{X(["@vscode/windows-mutex"],me,Ce)}),Oe=new De.Mutex(Ie);p.Event.once(this.t.onWillShutdown)(()=>Oe.release())}catch(De){this.m.error(De)}}async X(Ie,De,Oe){try{return await(0,J.$_l)(this.u,this.m,Ie,De)}catch(me){const Ce=(0,S.$Qi)(me);Oe?this.b?.sendToFocused("vscode:showResolveShellEnvError",Ce):this.m.error(Ce)}return{}}async Y(){try{const De=(await this.y.readFile(this.s.argvResource)).value.toString(),Oe=JSON.parse((0,k.$kn)(De)),Ce=(0,te.$Uo)(this.u)>=1;if(Oe["enable-crash-reporter"]===void 0){const Ne=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Ce},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,h.$qg)()}"`,"}"],ze=De.substring(0,De.length-2).concat(`,
`,Ne.join(`
`));await this.y.writeFile(this.s.argvResource,D.$je.fromString(ze))}else{const Ne=De.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Ce},`);Ne!==De&&await this.y.writeFile(this.s.argvResource,D.$je.fromString(Ne))}}catch(Ie){this.m.error(Ie)}}};e.$y_b=dt,e.$y_b=dt=ft=ve([ne(2,q.$5h),ne(3,z.$nj),ne(4,z.$oj),ne(5,W.$A0b),ne(6,_.$80b),ne(7,b.$zi),ne(8,ge.$uO),ne(9,V.$qk),ne(10,B.$Fj),ne(11,st.$R0b)],dt)}),define(oe[313],ae([0,1,15,46,7,22,8,51,14,33,3,47,13,9,68,4,36,25,21,43,99,308,10,18,238,250,24,64,202,16,222,93,78,218,92,20,225,5,79,27,80,278,127,287,53,286,95,249,34,54,70,56,39,234,232,2,40,266,69,227,116,122,270,264]),function(X,e,P,R,s,j,D,S,f,l,p,k,v,u,y,w,g,$,d,h,m,c,t,o,r,i,n,a,b,C,I,E,A,M,T,W,G,J,ce,re,ue,Z,Y,V,L,U,H,q,ee,he,K,O,F,_,z,x,N,B,Q,se,le,ge,be){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Se{main(){try{this.a()}catch(ke){console.error(ke.message),P.app.exit(1)}}async a(){(0,f.setUnexpectedErrorHandler)(Me=>console.error(Me));const[ke,pe,te,fe,$e,Pe,je,Te]=this.b();try{try{await this.d(te,Te,fe,$e,je)}catch(Me){throw this.f(te,je,Me),Me}await ke.invokeFunction(async Me=>{const Je=Me.get(J.$nj),Be=Me.get(W.$80b),Ve=Me.get(C.$qk),He=Me.get(J.$oj),ie=await this.e(Je,te,Be,ke,je,!0);return d.Promises.writeFile(te.mainLockfile,String(process.pid)).catch(de=>{Je.warn(`app#startup(): Error writing main lockfile: ${de.stack}`)}),Pe.logger=He.createLogger("main",{name:(0,t.localize)(0,null)}),p.Event.once(Be.onWillShutdown)(de=>{Ve.dispose(),fe.dispose(),de.join("instanceLockfile",d.Promises.unlink(te.mainLockfile).catch(()=>{}))}),ke.createInstance(c.$y_b,ie,pe).startup()})}catch(Me){ke.invokeFunction(this.i,Me)}}b(){const ke=new T.$4h,pe=new x.$Sc;process.once("exit",()=>pe.dispose());const te={_serviceBrand:void 0,...ce.default};ke.set(re.$Fj,te);const fe=new n.$B0b(this.j(),te),$e=this.c(fe);ke.set(n.$A0b,fe);const Pe=new Q.$40b((0,J.$Bj)(fe),fe.logsHome);ke.set(Q.$30b,Pe);const je=new G.$j8b(Pe.getLogLevel()),Te=pe.add(new se.$CO(je,[new J.$uj(Pe.getLogLevel())]));ke.set(J.$nj,Te);const Me=new I.$cq(Te);ke.set(C.$qk,Me);const Je=new E.$Bq(Te);Me.registerProvider(v.Schemas.file,Je);const Be=new B.$2r(Me);ke.set(N.$1k,Be);const Ve=new ge.$xO(1,fe,Te,Me);ke.set(ee.$tO,Ve),ke.set(ee.$uO,Ve);const He=new O.$S0b(Ve,Be,fe,Me,Te);ke.set(O.$R0b,He),Me.registerProvider(v.Schemas.vscodeUserData,new be.$J_b(v.Schemas.file,Je,v.Schemas.vscodeUserData,He,Be,Te));const ie=w.$i&&te.win32RegValueName?pe.add(new _.$H_b(Te,te.win32RegValueName)):fe.policyFile?pe.add(new z.$I_b(fe.policyFile,Me,Te)):new F.$Ln;ke.set(F.$Jn,ie);const de=new r.$_n(He.defaultProfile.settingsResource,Me,ie,Te);return ke.set(o.$zi,de),ke.set(W.$80b,new A.$3h(W.$90b,void 0,!1)),ke.set(L.$hp,new A.$3h(U.$F_b,void 0,!0)),ke.set(K.$J0b,new A.$3h(K.$K0b)),ke.set(H.$il,new A.$3h(q.$G_b,void 0,!1)),ke.set(Y.$Av,new A.$3h(V.$D_b)),ke.set(ue.$I0b,new Z.$A_b(fe,He,Te)),[new M.$Eq(ke,!0),$e,fe,de,Ve,je,te,He]}c(ke){const pe={VSCODE_IPC_HOOK:ke.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(te=>{const fe=process.env[te];typeof fe=="string"&&(pe[te]=fe)}),Object.assign(process.env,pe),pe}async d(ke,pe,te,fe,$e){await D.Promises.settled([Promise.all([ke.extensionsPath,ke.codeCachePath,ke.logsHome.with({scheme:v.Schemas.file}).fsPath,pe.defaultProfile.globalStorageHome.with({scheme:v.Schemas.file}).fsPath,ke.workspaceStorageHome.with({scheme:v.Schemas.file}).fsPath,ke.localHistoryHome.with({scheme:v.Schemas.file}).fsPath,ke.backupHome].map(Pe=>Pe?d.Promises.mkdir(Pe,{recursive:!0}):void 0)),fe.init(),te.initialize()]),pe.init()}async e(ke,pe,te,fe,$e,Pe){let je;try{(0,y.mark)("code/willStartMainServer"),je=await(0,m.$1h)(pe.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),p.Event.once(te.onWillShutdown)(()=>je.dispose())}catch(Te){if(Te.code!=="EADDRINUSE")throw this.f(pe,$e,Te),Te;let Me;try{Me=await(0,m.$2h)(pe.mainIPCHandle,"main")}catch(He){if(!Pe||w.$i||He.code!=="ECONNREFUSED")throw He.code==="EPERM"&&this.g((0,t.localize)(1,null,$e.nameShort),(0,t.localize)(2,null),$e),He;try{(0,R.unlinkSync)(pe.mainIPCHandle)}catch(ie){throw ke.warn("Could not delete obsolete instance handle",ie),ie}return this.e(ke,pe,te,fe,$e,!1)}if(pe.extensionTestsLocationURI&&!pe.debugExtensionHost.break){const He=`Running extension tests from the command line is currently only supported if no other instance of ${$e.nameShort} is running.`;throw ke.error(He),Me.dispose(),new Error(He)}let Je;!pe.args.wait&&!pe.args.status&&(Je=setTimeout(()=>{this.g((0,t.localize)(3,null,$e.nameShort),(0,t.localize)(4,null),$e)},1e4));const Be=h.ProxyChannel.toService(Me.getChannel("launch"),{disableMarshalling:!0}),Ve=h.ProxyChannel.toService(Me.getChannel("diagnostics"),{disableMarshalling:!0});if(pe.args.status)return fe.invokeFunction(async()=>{const He=new i.$9r(he.$No,$e),ie=await Ve.getMainDiagnostics(),de=await Ve.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),we=await He.getDiagnostics(ie,de);throw console.log(we),new f.$ab});throw w.$i&&await this.h(Be,ke),ke.trace("Sending env to running instance..."),await Be.start(pe.args,process.env),Me.dispose(),Je&&clearTimeout(Je),new f.$ab("Sent env to running instance. Terminating...")}if(pe.args.status)throw console.log((0,t.localize)(5,null,$e.nameShort)),new f.$ab("Terminating...");return process.env.VSCODE_PID=String(process.pid),je}f(ke,pe,te){if(te.code==="EACCES"||te.code==="EPERM"){const fe=(0,j.$Hb)([ke.userDataPath,ke.extensionsPath,m.$Wh]).map($e=>(0,k.$Vv)(s.URI.file($e),{os:w.OS,tildify:ke}));this.g((0,t.localize)(6,null),(0,t.localize)(7,null,(0,S.$Qi)(te),fe.join(`
`)),pe)}}g(ke,pe,te){P.dialog.showMessageBoxSync((0,le.$0v)({type:"warning",buttons:[(0,t.localize)(8,null)],message:ke,detail:pe},te).options)}async h(ke,pe){if(w.$i){const te=await ke.getMainProcessId();pe.trace("Sending some foreground love to the running instance:",te);try{(await new Promise((fe,$e)=>{X(["windows-foreground-love"],fe,$e)})).allowSetForegroundWindow(te)}catch(fe){pe.error(fe)}}}i(ke,pe){const te=ke.get(J.$nj),fe=ke.get(W.$80b);let $e=0;pe&&(pe.isExpected?pe.message&&te.trace(pe.message):($e=1,pe.stack?te.error(pe.stack):te.error(`Startup error: ${pe.toString()}`))),fe.kill($e)}j(){const ke=this.k((0,a.$3l)(process.argv));if(ke.wait&&!ke.waitMarkerFilePath){const pe=(0,b.$z_b)(ke.verbose);pe&&((0,a.$5l)(process.argv,"--waitMarkerFilePath",pe),ke.waitMarkerFilePath=pe)}return ke}k(ke){if(ke["open-url"]&&(ke._urls=ke._,ke._=[]),!ke.remote){const pe=this.l(ke._,ke.goto);ke._=pe}return ke}l(ke,pe){const te=(0,g.cwd)(),fe=ke.map(je=>{let Te=String(je),Me;pe&&(Me=(0,l.$cg)(Te),Te=Me.path),Te&&(Te=this.m(te,Te));const Je=(0,l.$0f)(Te,te),Be=(0,u.$nc)(Je);return Be&&!(0,l.$6f)(Be)?null:pe&&Me?(Me.path=Je,this.n(Me)):Je}),$e=w.$i||w.$j,Pe=(0,j.$Mb)(fe,je=>je&&$e?je.toLowerCase():je||"");return(0,j.$Hb)(Pe)}m(ke,pe){return w.$i&&(pe=(0,$.$Ue)(pe,'"')),pe=(0,$.$Se)((0,$.$Se)(pe," "),"	"),w.$i&&(pe=(0,u.$kc)(ke,pe),pe=(0,$.$Ue)(pe,".")),pe}n(ke){const pe=[ke.path];return typeof ke.line=="number"&&pe.push(String(ke.line)),typeof ke.column=="number"&&pe.push(String(ke.column)),pe.join(":")}}new Se().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/271fb7fbd599b49a1482ea7284a50b3229317f96/core/vs/code/electron-main/main.js.map
