/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ie=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/platform/log/common/log","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/base/common/errors","vs/nls","vs/base/common/async","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/common/cancellation","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/strings","vs/base/common/map","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","fs","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/base/common/extpath","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain"],ne=function(J){for(var e=[],L=0,D=J.length;L<D;L++)e[L]=ie[J[L]];return e};define(ie[70],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class L{static get(){const R=new Map,N=new Map,A=new Map,k=new Map;function u(f,b){f.has(b.detail)||f.set(b.detail,-b.timestamp)}function a(f,b){const S=f.get(b.detail);S&&(S>=0||f.set(b.detail,S+b.timestamp))}let v=[];typeof J=="function"&&typeof J.getStats=="function"&&(v=J.getStats().slice(0).sort((f,b)=>f.timestamp-b.timestamp));for(const f of v)switch(f.type){case 10:u(R,f);break;case 11:case 12:a(R,f);break;case 21:u(N,f);break;case 22:a(N,f);break;case 33:u(A,f);break;case 34:a(A,f);break;case 31:u(k,f);break;case 32:a(k,f);break}let E=0;A.forEach(f=>E+=f);function m(f){const b=[];return f.forEach((S,$)=>b.push([$,S])),b}return{amdLoad:m(R),amdInvoke:m(N),nodeRequire:m(A),nodeEval:m(k),nodeRequireTotal:E}}static toMarkdownTable(R,N){let A="";const k=[];return R.forEach((u,a)=>{k[a]=u.length}),N.forEach(u=>{u.forEach((a,v)=>{typeof a>"u"&&(a=u[v]="-");const E=a.toString().length;k[v]=Math.max(E,k[v])})}),R.forEach((u,a)=>{A+=`| ${u+" ".repeat(k[a]-u.toString().length)} `}),A+=`|
`,R.forEach((u,a)=>{A+=`| ${"-".repeat(k[a])} `}),A+=`|
`,N.forEach(u=>{u.forEach((a,v)=>{typeof a<"u"&&(A+=`| ${a+" ".repeat(k[v]-a.toString().length)} `)}),A+=`|
`}),A}}e.$U=L}),define(ie[53],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function L(A){return(k,u,a)=>{let v=null,E=null;if(typeof a.value=="function"?(v="value",E=a.value):typeof a.get=="function"&&(v="get",E=a.get),!E)throw new Error("not supported");a[v]=A(E,u)}}function D(A,k,u){let a=null,v=null;if(typeof u.value=="function"?(a="value",v=u.value,v.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(a="get",v=u.get),!v)throw new Error("not supported");const E=`$memoize$${k}`;u[a]=function(...m){return this.hasOwnProperty(E)||Object.defineProperty(this,E,{configurable:!1,enumerable:!1,writable:!1,value:v.apply(this,m)}),this[E]}}e.$xh=D;function R(A,k,u){return L((a,v)=>{const E=`$debounce$${v}`,m=`$debounce$result$${v}`;return function(...f){this[m]||(this[m]=u?u():void 0),clearTimeout(this[E]),k&&(this[m]=k(this[m],...f),f=[this[m]]),this[E]=setTimeout(()=>{a.apply(this,f),this[m]=u?u():void 0},A)}})}e.$yh=R;function N(A,k,u){return L((a,v)=>{const E=`$throttle$timer$${v}`,m=`$throttle$result$${v}`,f=`$throttle$lastRun$${v}`,b=`$throttle$pending$${v}`;return function(...S){if(this[m]||(this[m]=u?u():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[m]=k(this[m],...S)),this[b])return;const $=this[f]+A;$<=Date.now()?(this[f]=Date.now(),a.apply(this,[this[m]]),this[m]=u?u():void 0):(this[b]=!0,this[E]=setTimeout(()=>{this[b]=!1,this[f]=Date.now(),a.apply(this,[this[m]]),this[m]=u?u():void 0},$-Date.now()))}})}e.$zh=N}),define(ie[71],ne([0,1,7]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function D(u,a){if(!u)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}e.ok=D;function R(u,a="Unreachable"){throw new Error(a)}e.$6c=R;function N(u){if(!u)throw new L.$cb("Assertion Failed")}e.$7c=N;function A(u){if(!u()){debugger;u(),(0,L.$1)(new L.$cb("Assertion Failed"))}}e.$8c=A;function k(u,a){let v=0;for(;v<u.length-1;){const E=u[v],m=u[v+1];if(!a(E,m))return!1;v++}return!0}e.$9c=k}),define(ie[38],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var L;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(L||(e.ScanError=L={}));var D;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(D||(e.SyntaxKind=D={}));var R;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(R||(e.ParseErrorCode=R={}));var N;(function(i){i.DEFAULT={allowTrailingComma:!0}})(N||(e.ParseOptions=N={}));function A(i,r=!1){let t=0;const n=i.length;let s="",o=0,c=16,I=0;function O(re){let he=0,ce=0;for(;he<re;){const ae=i.charCodeAt(t);if(ae>=48&&ae<=57)ce=ce*16+ae-48;else if(ae>=65&&ae<=70)ce=ce*16+ae-65+10;else if(ae>=97&&ae<=102)ce=ce*16+ae-97+10;else break;t++,he++}return he<re&&(ce=-1),ce}function y(re){t=re,s="",o=0,c=16,I=0}function j(){const re=t;if(i.charCodeAt(t)===48)t++;else for(t++;t<i.length&&a(i.charCodeAt(t));)t++;if(t<i.length&&i.charCodeAt(t)===46)if(t++,t<i.length&&a(i.charCodeAt(t)))for(t++;t<i.length&&a(i.charCodeAt(t));)t++;else return I=3,i.substring(re,t);let he=t;if(t<i.length&&(i.charCodeAt(t)===69||i.charCodeAt(t)===101))if(t++,(t<i.length&&i.charCodeAt(t)===43||i.charCodeAt(t)===45)&&t++,t<i.length&&a(i.charCodeAt(t))){for(t++;t<i.length&&a(i.charCodeAt(t));)t++;he=t}else I=3;return i.substring(re,he)}function H(){let re="",he=t;for(;;){if(t>=n){re+=i.substring(he,t),I=2;break}const ce=i.charCodeAt(t);if(ce===34){re+=i.substring(he,t),t++;break}if(ce===92){if(re+=i.substring(he,t),t++,t>=n){I=2;break}switch(i.charCodeAt(t++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const q=O(4);q>=0?re+=String.fromCharCode(q):I=4;break}default:I=5}he=t;continue}if(ce>=0&&ce<=31)if(u(ce)){re+=i.substring(he,t),I=2;break}else I=6;t++}return re}function te(){if(s="",I=0,o=t,t>=n)return o=n,c=17;let re=i.charCodeAt(t);if(k(re)){do t++,s+=String.fromCharCode(re),re=i.charCodeAt(t);while(k(re));return c=15}if(u(re))return t++,s+=String.fromCharCode(re),re===13&&i.charCodeAt(t)===10&&(t++,s+=`
`),c=14;switch(re){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,s=H(),c=10;case 47:{const he=t-1;if(i.charCodeAt(t+1)===47){for(t+=2;t<n&&!u(i.charCodeAt(t));)t++;return s=i.substring(he,t),c=12}if(i.charCodeAt(t+1)===42){t+=2;const ce=n-1;let ae=!1;for(;t<ce;){if(i.charCodeAt(t)===42&&i.charCodeAt(t+1)===47){t+=2,ae=!0;break}t++}return ae||(t++,I=1),s=i.substring(he,t),c=13}return s+=String.fromCharCode(re),t++,c=16}case 45:if(s+=String.fromCharCode(re),t++,t===n||!a(i.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=j(),c=11;default:for(;t<n&&_(re);)t++,re=i.charCodeAt(t);if(o!==t){switch(s=i.substring(o,t),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(re),t++,c=16}}function _(re){if(k(re)||u(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function oe(){let re;do re=te();while(re>=12&&re<=15);return re}return{setPosition:y,getPosition:()=>t,scan:r?oe:te,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>I}}e.$an=A;function k(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function u(i){return i===10||i===13||i===8232||i===8233}function a(i){return i>=48&&i<=57}var v;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(v||(v={}));function E(i,r){const t=[],n=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function I(O,y,j,H){o.value=O,o.offset=y,o.length=j,o.type=H,o.colonOffset=void 0,s=o}try{p(i,{onObjectBegin:(O,y)=>{if(r<=O)throw n;s=void 0,c=r>O,t.push("")},onObjectProperty:(O,y,j)=>{if(r<y||(I(O,y,j,"property"),t[t.length-1]=O,r<=y+j))throw n},onObjectEnd:(O,y)=>{if(r<=O)throw n;s=void 0,t.pop()},onArrayBegin:(O,y)=>{if(r<=O)throw n;s=void 0,t.push(0)},onArrayEnd:(O,y)=>{if(r<=O)throw n;s=void 0,t.pop()},onLiteralValue:(O,y,j)=>{if(r<y||(I(O,y,j,g(O)),r<=y+j))throw n},onSeparator:(O,y,j)=>{if(r<=y)throw n;if(O===":"&&s&&s.type==="property")s.colonOffset=y,c=!1,s=void 0;else if(O===","){const H=t[t.length-1];typeof H=="number"?t[t.length-1]=H+1:(c=!0,t[t.length-1]=""),s=void 0}}})}catch(O){if(O!==n)throw O}return{path:t,previousNode:s,isAtPropertyKey:c,matches:O=>{let y=0;for(let j=0;y<O.length&&j<t.length;j++)if(O[y]===t[j]||O[y]==="*")y++;else if(O[y]!=="**")return!1;return y===O.length}}}e.$bn=E;function m(i,r=[],t=N.DEFAULT){let n=null,s=[];const o=[];function c(O){Array.isArray(s)?s.push(O):n!==null&&(s[n]=O)}return p(i,{onObjectBegin:()=>{const O={};c(O),o.push(s),s=O,n=null},onObjectProperty:O=>{n=O},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const O=[];c(O),o.push(s),s=O,n=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(O,y,j)=>{r.push({error:O,offset:y,length:j})}},t),s[0]}e.$cn=m;function f(i,r=[],t=N.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(O){n.type==="property"&&(n.length=O-n.offset,n=n.parent)}function o(O){return n.children.push(O),O}p(i,{onObjectBegin:O=>{n=o({type:"object",offset:O,length:-1,parent:n,children:[]})},onObjectProperty:(O,y,j)=>{n=o({type:"property",offset:y,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:O,offset:y,length:j,parent:n})},onObjectEnd:(O,y)=>{n.length=O+y-n.offset,n=n.parent,s(O+y)},onArrayBegin:(O,y)=>{n=o({type:"array",offset:O,length:-1,parent:n,children:[]})},onArrayEnd:(O,y)=>{n.length=O+y-n.offset,n=n.parent,s(O+y)},onLiteralValue:(O,y,j)=>{o({type:g(O),offset:y,length:j,parent:n,value:O}),s(y+j)},onSeparator:(O,y,j)=>{n.type==="property"&&(O===":"?n.colonOffset=y:O===","&&s(y))},onError:(O,y,j)=>{r.push({error:O,offset:y,length:j})}},t);const I=n.children[0];return I&&delete I.parent,I}e.$dn=f;function b(i,r){if(!i)return;let t=i;for(const n of r)if(typeof n=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===n){t=o.children[1],s=!0;break}if(!s)return}else{const s=n;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.$en=b;function S(i){if(!i.parent||!i.parent.children)return[];const r=S(i.parent);if(i.parent.type==="property"){const t=i.parent.children[0].value;r.push(t)}else if(i.parent.type==="array"){const t=i.parent.children.indexOf(i);t!==-1&&r.push(t)}return r}e.$fn=S;function $(i){switch(i.type){case"array":return i.children.map($);case"object":{const r=Object.create(null);for(const t of i.children){const n=t.children[1];n&&(r[t.children[0].value]=$(n))}return r}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$gn=$;function l(i,r,t=!1){return r>=i.offset&&r<i.offset+i.length||t&&r===i.offset+i.length}e.$hn=l;function w(i,r,t=!1){if(l(i,r,t)){const n=i.children;if(Array.isArray(n))for(let s=0;s<n.length&&n[s].offset<=r;s++){const o=w(n[s],r,t);if(o)return o}return i}}e.$in=w;function p(i,r,t=N.DEFAULT){const n=A(i,!1);function s(Z){return Z?()=>Z(n.getTokenOffset(),n.getTokenLength()):()=>!0}function o(Z){return Z?x=>Z(x,n.getTokenOffset(),n.getTokenLength()):()=>!0}const c=s(r.onObjectBegin),I=o(r.onObjectProperty),O=s(r.onObjectEnd),y=s(r.onArrayBegin),j=s(r.onArrayEnd),H=o(r.onLiteralValue),te=o(r.onSeparator),_=s(r.onComment),oe=o(r.onError),re=t&&t.disallowComments,he=t&&t.allowTrailingComma;function ce(){for(;;){const Z=n.scan();switch(n.getTokenError()){case 4:ae(14);break;case 5:ae(15);break;case 3:ae(13);break;case 1:re||ae(11);break;case 2:ae(12);break;case 6:ae(16);break}switch(Z){case 12:case 13:re?ae(10):_();break;case 16:ae(1);break;case 15:case 14:break;default:return Z}}}function ae(Z,x=[],F=[]){if(oe(Z),x.length+F.length>0){let C=n.getToken();for(;C!==17;){if(x.indexOf(C)!==-1){ce();break}else if(F.indexOf(C)!==-1)break;C=ce()}}}function q(Z){const x=n.getTokenValue();return Z?H(x):I(x),ce(),!0}function Q(){switch(n.getToken()){case 11:{let Z=0;try{Z=JSON.parse(n.getTokenValue()),typeof Z!="number"&&(ae(2),Z=0)}catch{ae(2)}H(Z);break}case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return ce(),!0}function M(){return n.getToken()!==10?(ae(3,[],[2,5]),!1):(q(!1),n.getToken()===6?(te(":"),ce(),X()||ae(4,[],[2,5])):ae(5,[],[2,5]),!0)}function T(){c(),ce();let Z=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(Z||ae(4,[],[]),te(","),ce(),n.getToken()===2&&he)break}else Z&&ae(6,[],[]);M()||ae(4,[],[2,5]),Z=!0}return O(),n.getToken()!==2?ae(7,[2],[]):ce(),!0}function B(){y(),ce();let Z=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(Z||ae(4,[],[]),te(","),ce(),n.getToken()===4&&he)break}else Z&&ae(6,[],[]);X()||ae(4,[],[4,5]),Z=!0}return j(),n.getToken()!==4?ae(8,[4],[]):ce(),!0}function X(){switch(n.getToken()){case 3:return B();case 1:return T();case 10:return q(!0);default:return Q()}}return ce(),n.getToken()===17?t.allowEmptyContent?!0:(ae(4,[],[]),!1):X()?(n.getToken()!==17&&ae(9,[],[]),!0):(ae(4,[],[]),!1)}e.$jn=p;function h(i,r){const t=A(i),n=[];let s,o=0,c;do switch(c=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==c&&n.push(i.substring(o,c)),r!==void 0&&n.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return n.join("")}e.$kn=h;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=g}),define(ie[72],ne([0,1,38]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=void 0;function D(a,v,E){let m,f,b,S,$;if(v){for(S=v.offset,$=S+v.length,b=S;b>0&&!u(a,b-1);)b--;let c=$;for(;c<a.length&&!u(a,c);)c++;f=a.substring(b,c),m=A(f,E)}else f=a,m=0,b=0,S=0,$=a.length;const l=k(E,a);let w=!1,p=0,h;E.insertSpaces?h=N(" ",E.tabSize||4):h="	";const g=(0,L.$an)(f,!1);let i=!1;function r(){return l+N(h,m+p)}function t(){let c=g.scan();for(w=!1;c===15||c===14;)w=w||c===14,c=g.scan();return i=c===16||g.getTokenError()!==0,c}const n=[];function s(c,I,O){!i&&I<$&&O>S&&a.substring(I,O)!==c&&n.push({offset:I,length:O-I,content:c})}let o=t();if(o!==17){const c=g.getTokenOffset()+b,I=N(h,m);s(I,b,c)}for(;o!==17;){let c=g.getTokenOffset()+g.getTokenLength()+b,I=t(),O="";for(;!w&&(I===12||I===13);){const j=g.getTokenOffset()+b;s(" ",c,j),c=g.getTokenOffset()+g.getTokenLength()+b,O=I===12?r():"",I=t()}if(I===2)o!==1&&(p--,O=r());else if(I===4)o!==3&&(p--,O=r());else{switch(o){case 3:case 1:p++,O=r();break;case 5:case 12:O=r();break;case 13:w?O=r():O=" ";break;case 6:O=" ";break;case 10:if(I===6){O="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?O=" ":I!==5&&I!==17&&(i=!0);break;case 16:i=!0;break}w&&(I===12||I===13)&&(O=r())}const y=g.getTokenOffset()+b;s(O,c,y),o=I}return n}e.$mn=D;function R(a,v){const E=JSON.stringify(a,void 0,v.insertSpaces?v.tabSize||4:"	");return v.eol!==void 0?E.replace(/\r\n|\r|\n/g,v.eol):E}e.$nn=R;function N(a,v){let E="";for(let m=0;m<v;m++)E+=a;return E}function A(a,v){let E=0,m=0;const f=v.tabSize||4;for(;E<a.length;){const b=a.charAt(E);if(b===" ")m++;else if(b==="	")m+=f;else break;E++}return Math.floor(m/f)}function k(a,v){for(let E=0;E<v.length;E++){const m=v.charAt(E);if(m==="\r")return E+1<v.length&&v.charAt(E+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return a&&a.eol||`
`}e.$on=k;function u(a,v){return`\r
`.indexOf(a.charAt(v))!==-1}e.$pn=u}),define(ie[73],ne([0,1,38,72]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function R(a,v,E){return N(a,v,void 0,E)}e.$qn=R;function N(a,v,E,m,f){const b=v.slice(),S=[],$=(0,L.$dn)(a,S);let l,w;for(;b.length>0&&(w=b.pop(),l=(0,L.$en)($,b),l===void 0&&E!==void 0);)typeof w=="string"?E={[w]:E}:E=[E];if(l)if(l.type==="object"&&typeof w=="string"&&Array.isArray(l.children)){const p=(0,L.$en)(l,[w]);if(p!==void 0)if(E===void 0){if(!p.parent)throw new Error("Malformed AST");const h=l.children.indexOf(p.parent);let g,i=p.parent.offset+p.parent.length;if(h>0){const r=l.children[h-1];g=r.offset+r.length}else g=l.offset+1,l.children.length>1&&(i=l.children[1].offset);return A(a,{offset:g,length:i-g,content:""},m)}else return A(a,{offset:p.offset,length:p.length,content:JSON.stringify(E)},m);else{if(E===void 0)return[];const h=`${JSON.stringify(w)}: ${JSON.stringify(E)}`,g=f?f(l.children.map(r=>r.children[0].value)):l.children.length;let i;if(g>0){const r=l.children[g-1];i={offset:r.offset+r.length,length:0,content:","+h}}else l.children.length===0?i={offset:l.offset+1,length:0,content:h}:i={offset:l.offset+1,length:0,content:h+","};return A(a,i,m)}}else if(l.type==="array"&&typeof w=="number"&&Array.isArray(l.children))if(E!==void 0){const p=`${JSON.stringify(E)}`;let h;if(l.children.length===0||w===0)h={offset:l.offset+1,length:0,content:l.children.length===0?p:p+","};else{const g=w===-1||w>l.children.length?l.children.length:w,i=l.children[g-1];h={offset:i.offset+i.length,length:0,content:","+p}}return A(a,h,m)}else{const p=w,h=l.children[p];let g;if(l.children.length===1)g={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===p){const i=l.children[p-1],r=i.offset+i.length,t=l.offset+l.length;g={offset:r,length:t-2-r,content:""}}else g={offset:h.offset,length:l.children[p+1].offset-h.offset,content:""};return A(a,g,m)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${l.type}`);else{if(E===void 0)throw new Error("Can not delete in empty document");return A(a,{offset:$?$.offset:0,length:$?$.length:0,content:JSON.stringify(E)},m)}}e.$rn=N;function A(a,v,E){let m=k(a,v),f=v.offset,b=v.offset+v.content.length;if(v.length===0||v.content.length===0){for(;f>0&&!(0,D.$pn)(m,f-1);)f--;for(;b<m.length&&!(0,D.$pn)(m,b);)b++}const S=(0,D.$mn)(m,{offset:f,length:b-f},E);for(let l=S.length-1;l>=0;l--){const w=S[l];m=k(m,w),f=Math.min(f,w.offset),b=Math.max(b,w.offset+w.length),b+=w.content.length-w.length}const $=a.length-(m.length-b)-f;return[{offset:f,length:$,content:m.substring(f,b)}]}e.$sn=A;function k(a,v){return a.substring(0,v.offset)+v.content+a.substring(v.offset+v.length)}e.$tn=k;function u(a,v){const E=v.slice(0).sort((f,b)=>{const S=f.offset-b.offset;return S===0?f.length-b.length:S});let m=a.length;for(let f=E.length-1;f>=0;f--){const b=E[f];if(b.offset+b.length<=m)a=k(a,b);else throw new Error("Overlapping edit");m=b.offset}return a}e.$un=u}),define(ie[74],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function L(k,u,a){return Math.min(Math.max(k,u),a)}e.$7l=L;function D(k,u){return(u+k%u)%u}e.rot=D;class R{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=R;class N{constructor(){this.a=1,this.b=0}update(u){return this.b=this.b+(u-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=N;class A{constructor(u){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(u),this.c.fill(0,0,u)}update(u){const a=this.c[this.d];return this.c[this.d]=u,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=u,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=A}),function(){function J(R){const N=[];typeof R=="number"&&N.push("code/timeOrigin",R);function A(u){N.push(u,Date.now())}function k(){const u=[];for(let a=0;a<N.length;a+=2)u.push({name:N[a],startTime:N[a+1]});return u}return{mark:A,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?J():{mark(R){performance.mark(R)},getMarks(){let R=performance.timeOrigin;typeof R!="number"&&(R=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const N=[{name:"code/timeOrigin",startTime:Math.round(R)}];for(const A of performance.getEntriesByType("mark"))N.push({name:A.name,startTime:Math.round(R+A.startTime)});return N}};if(typeof process=="object"){const R=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return J(R)}else return console.trace("perf-util loaded in UNKNOWN environment"),J()}function L(R){return R.MonacoPerformanceMarks||(R.MonacoPerformanceMarks=e()),R.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return L(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=L(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=L(D))}(),function(J,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var L=e();for(var D in L)(typeof exports=="object"?exports:J)[D]=L[D]}}(typeof self<"u"?self:this,function(){return function(J){var e={};function L(D){if(e[D])return e[D].exports;var R=e[D]={i:D,l:!1,exports:{}};return J[D].call(R.exports,R,R.exports,L),R.l=!0,R.exports}return L.m=J,L.c=e,L.d=function(D,R,N){L.o(D,R)||Object.defineProperty(D,R,{enumerable:!0,get:N})},L.r=function(D){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},L.t=function(D,R){if(1&R&&(D=L(D)),8&R||4&R&&typeof D=="object"&&D&&D.__esModule)return D;var N=Object.create(null);if(L.r(N),Object.defineProperty(N,"default",{enumerable:!0,value:D}),2&R&&typeof D!="string")for(var A in D)L.d(N,A,function(k){return D[k]}.bind(null,A));return N},L.n=function(D){var R=D&&D.__esModule?function(){return D.default}:function(){return D};return L.d(R,"a",R),R},L.o=function(D,R){return Object.prototype.hasOwnProperty.call(D,R)},L.p="",L(L.s=0)}([function(J,e,L){(function(D){var R;e=J.exports=F,R=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var V=Array.prototype.slice.call(arguments,0);V.unshift("SEMVER"),console.log.apply(console,V)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var N=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],u=e.src=[],a=0,v=a++;u[v]="0|[1-9]\\d*";var E=a++;u[E]="[0-9]+";var m=a++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=a++;u[f]="("+u[v]+")\\.("+u[v]+")\\.("+u[v]+")";var b=a++;u[b]="("+u[E]+")\\.("+u[E]+")\\.("+u[E]+")";var S=a++;u[S]="(?:"+u[v]+"|"+u[m]+")";var $=a++;u[$]="(?:"+u[E]+"|"+u[m]+")";var l=a++;u[l]="(?:-("+u[S]+"(?:\\."+u[S]+")*))";var w=a++;u[w]="(?:-?("+u[$]+"(?:\\."+u[$]+")*))";var p=a++;u[p]="[0-9A-Za-z-]+";var h=a++;u[h]="(?:\\+("+u[p]+"(?:\\."+u[p]+")*))";var g=a++,i="v?"+u[f]+u[l]+"?"+u[h]+"?";u[g]="^"+i+"$";var r="[v=\\s]*"+u[b]+u[w]+"?"+u[h]+"?",t=a++;u[t]="^"+r+"$";var n=a++;u[n]="((?:<|>)?=?)";var s=a++;u[s]=u[E]+"|x|X|\\*";var o=a++;u[o]=u[v]+"|x|X|\\*";var c=a++;u[c]="[v=\\s]*("+u[o]+")(?:\\.("+u[o]+")(?:\\.("+u[o]+")(?:"+u[l]+")?"+u[h]+"?)?)?";var I=a++;u[I]="[v=\\s]*("+u[s]+")(?:\\.("+u[s]+")(?:\\.("+u[s]+")(?:"+u[w]+")?"+u[h]+"?)?)?";var O=a++;u[O]="^"+u[n]+"\\s*"+u[c]+"$";var y=a++;u[y]="^"+u[n]+"\\s*"+u[I]+"$";var j=a++;u[j]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var H=a++;u[H]="(?:~>?)";var te=a++;u[te]="(\\s*)"+u[H]+"\\s+",k[te]=new RegExp(u[te],"g");var _=a++;u[_]="^"+u[H]+u[c]+"$";var oe=a++;u[oe]="^"+u[H]+u[I]+"$";var re=a++;u[re]="(?:\\^)";var he=a++;u[he]="(\\s*)"+u[re]+"\\s+",k[he]=new RegExp(u[he],"g");var ce=a++;u[ce]="^"+u[re]+u[c]+"$";var ae=a++;u[ae]="^"+u[re]+u[I]+"$";var q=a++;u[q]="^"+u[n]+"\\s*("+r+")$|^$";var Q=a++;u[Q]="^"+u[n]+"\\s*("+i+")$|^$";var M=a++;u[M]="(\\s*)"+u[n]+"\\s*("+r+"|"+u[c]+")",k[M]=new RegExp(u[M],"g");var T=a++;u[T]="^\\s*("+u[c]+")\\s+-\\s+("+u[c]+")\\s*$";var B=a++;u[B]="^\\s*("+u[I]+")\\s+-\\s+("+u[I]+")\\s*$";var X=a++;u[X]="(<|>)?=?\\s*\\*";for(var Z=0;Z<35;Z++)R(Z,u[Z]),k[Z]||(k[Z]=new RegExp(u[Z]));function x(V,Y){if(V instanceof F)return V;if(typeof V!="string"||V.length>N||!(Y?k[t]:k[g]).test(V))return null;try{return new F(V,Y)}catch{return null}}function F(V,Y){if(V instanceof F){if(V.loose===Y)return V;V=V.version}else if(typeof V!="string")throw new TypeError("Invalid Version: "+V);if(V.length>N)throw new TypeError("version is longer than "+N+" characters");if(!(this instanceof F))return new F(V,Y);R("SemVer",V,Y),this.loose=Y;var K=V.trim().match(Y?k[t]:k[g]);if(!K)throw new TypeError("Invalid Version: "+V);if(this.raw=V,this.major=+K[1],this.minor=+K[2],this.patch=+K[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");K[4]?this.prerelease=K[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var ye=+ge;if(ye>=0&&ye<A)return ye}return ge}):this.prerelease=[],this.build=K[5]?K[5].split("."):[],this.format()}e.parse=x,e.valid=function(V,Y){var K=x(V,Y);return K?K.version:null},e.clean=function(V,Y){var K=x(V.trim().replace(/^[=v]+/,""),Y);return K?K.version:null},e.SemVer=F,F.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},F.prototype.toString=function(){return this.version},F.prototype.compare=function(V){return R("SemVer.compare",this.version,this.loose,V),V instanceof F||(V=new F(V,this.loose)),this.compareMain(V)||this.comparePre(V)},F.prototype.compareMain=function(V){return V instanceof F||(V=new F(V,this.loose)),d(this.major,V.major)||d(this.minor,V.minor)||d(this.patch,V.patch)},F.prototype.comparePre=function(V){if(V instanceof F||(V=new F(V,this.loose)),this.prerelease.length&&!V.prerelease.length)return-1;if(!this.prerelease.length&&V.prerelease.length)return 1;if(!this.prerelease.length&&!V.prerelease.length)return 0;var Y=0;do{var K=this.prerelease[Y],ge=V.prerelease[Y];if(R("prerelease compare",Y,K,ge),K===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(K===void 0)return-1;if(K!==ge)return d(K,ge)}while(++Y)},F.prototype.inc=function(V,Y){switch(V){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Y);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Y);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Y),this.inc("pre",Y);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Y),this.inc("pre",Y);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var K=this.prerelease.length;--K>=0;)typeof this.prerelease[K]=="number"&&(this.prerelease[K]++,K=-2);K===-1&&this.prerelease.push(0)}Y&&(this.prerelease[0]===Y?isNaN(this.prerelease[1])&&(this.prerelease=[Y,0]):this.prerelease=[Y,0]);break;default:throw new Error("invalid increment argument: "+V)}return this.format(),this.raw=this.version,this},e.inc=function(V,Y,K,ge){typeof K=="string"&&(ge=K,K=void 0);try{return new F(V,K).inc(Y,ge).version}catch{return null}},e.diff=function(V,Y){if(W(V,Y))return null;var K=x(V),ge=x(Y);if(K.prerelease.length||ge.prerelease.length){for(var ye in K)if((ye==="major"||ye==="minor"||ye==="patch")&&K[ye]!==ge[ye])return"pre"+ye;return"prerelease"}for(var ye in K)if((ye==="major"||ye==="minor"||ye==="patch")&&K[ye]!==ge[ye])return ye},e.compareIdentifiers=d;var C=/^[0-9]+$/;function d(V,Y){var K=C.test(V),ge=C.test(Y);return K&&ge&&(V=+V,Y=+Y),K&&!ge?-1:ge&&!K?1:V<Y?-1:V>Y?1:0}function P(V,Y,K){return new F(V,K).compare(new F(Y,K))}function z(V,Y,K){return P(V,Y,K)>0}function U(V,Y,K){return P(V,Y,K)<0}function W(V,Y,K){return P(V,Y,K)===0}function G(V,Y,K){return P(V,Y,K)!==0}function ee(V,Y,K){return P(V,Y,K)>=0}function ue(V,Y,K){return P(V,Y,K)<=0}function fe(V,Y,K,ge){var ye;switch(Y){case"===":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),ye=V===K;break;case"!==":typeof V=="object"&&(V=V.version),typeof K=="object"&&(K=K.version),ye=V!==K;break;case"":case"=":case"==":ye=W(V,K,ge);break;case"!=":ye=G(V,K,ge);break;case">":ye=z(V,K,ge);break;case">=":ye=ee(V,K,ge);break;case"<":ye=U(V,K,ge);break;case"<=":ye=ue(V,K,ge);break;default:throw new TypeError("Invalid operator: "+Y)}return ye}function $e(V,Y){if(V instanceof $e){if(V.loose===Y)return V;V=V.value}if(!(this instanceof $e))return new $e(V,Y);R("comparator",V,Y),this.loose=Y,this.parse(V),this.semver===we?this.value="":this.value=this.operator+this.semver.version,R("comp",this)}e.rcompareIdentifiers=function(V,Y){return d(Y,V)},e.major=function(V,Y){return new F(V,Y).major},e.minor=function(V,Y){return new F(V,Y).minor},e.patch=function(V,Y){return new F(V,Y).patch},e.compare=P,e.compareLoose=function(V,Y){return P(V,Y,!0)},e.rcompare=function(V,Y,K){return P(Y,V,K)},e.sort=function(V,Y){return V.sort(function(K,ge){return e.compare(K,ge,Y)})},e.rsort=function(V,Y){return V.sort(function(K,ge){return e.rcompare(K,ge,Y)})},e.gt=z,e.lt=U,e.eq=W,e.neq=G,e.gte=ee,e.lte=ue,e.cmp=fe,e.Comparator=$e;var we={};function de(V,Y){if(V instanceof de)return V.loose===Y?V:new de(V.raw,Y);if(V instanceof $e)return new de(V.value,Y);if(!(this instanceof de))return new de(V,Y);if(this.loose=Y,this.raw=V,this.set=V.split(/\s*\|\|\s*/).map(function(K){return this.parseRange(K.trim())},this).filter(function(K){return K.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+V);this.format()}function le(V){return!V||V.toLowerCase()==="x"||V==="*"}function pe(V,Y,K,ge,ye,De,Se,ze,Ie,Ne,Te,Oe,Ae){return((Y=le(K)?"":le(ge)?">="+K+".0.0":le(ye)?">="+K+"."+ge+".0":">="+Y)+" "+(ze=le(Ie)?"":le(Ne)?"<"+(+Ie+1)+".0.0":le(Te)?"<"+Ie+"."+(+Ne+1)+".0":Oe?"<="+Ie+"."+Ne+"."+Te+"-"+Oe:"<="+ze)).trim()}function ve(V,Y){for(var K=0;K<V.length;K++)if(!V[K].test(Y))return!1;if(Y.prerelease.length){for(K=0;K<V.length;K++)if(R(V[K].semver),V[K].semver!==we&&V[K].semver.prerelease.length>0){var ge=V[K].semver;if(ge.major===Y.major&&ge.minor===Y.minor&&ge.patch===Y.patch)return!0}return!1}return!0}function ke(V,Y,K){try{Y=new de(Y,K)}catch{return!1}return Y.test(V)}function je(V,Y,K,ge){var ye,De,Se,ze,Ie;switch(V=new F(V,ge),Y=new de(Y,ge),K){case">":ye=z,De=ue,Se=U,ze=">",Ie=">=";break;case"<":ye=U,De=ee,Se=z,ze="<",Ie="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ke(V,Y,ge))return!1;for(var Ne=0;Ne<Y.set.length;++Ne){var Te=Y.set[Ne],Oe=null,Ae=null;if(Te.forEach(function(Ce){Ce.semver===we&&(Ce=new $e(">=0.0.0")),Oe=Oe||Ce,Ae=Ae||Ce,ye(Ce.semver,Oe.semver,ge)?Oe=Ce:Se(Ce.semver,Ae.semver,ge)&&(Ae=Ce)}),Oe.operator===ze||Oe.operator===Ie||(!Ae.operator||Ae.operator===ze)&&De(V,Ae.semver)||Ae.operator===Ie&&Se(V,Ae.semver))return!1}return!0}$e.prototype.parse=function(V){var Y=this.loose?k[q]:k[Q],K=V.match(Y);if(!K)throw new TypeError("Invalid comparator: "+V);this.operator=K[1],this.operator==="="&&(this.operator=""),K[2]?this.semver=new F(K[2],this.loose):this.semver=we},$e.prototype.toString=function(){return this.value},$e.prototype.test=function(V){return R("Comparator.test",V,this.loose),this.semver===we||(typeof V=="string"&&(V=new F(V,this.loose)),fe(V,this.operator,this.semver,this.loose))},$e.prototype.intersects=function(V,Y){if(!(V instanceof $e))throw new TypeError("a Comparator is required");var K;if(this.operator==="")return K=new de(V.value,Y),ke(this.value,K,Y);if(V.operator==="")return K=new de(this.value,Y),ke(V.semver,K,Y);var ge=!(this.operator!==">="&&this.operator!==">"||V.operator!==">="&&V.operator!==">"),ye=!(this.operator!=="<="&&this.operator!=="<"||V.operator!=="<="&&V.operator!=="<"),De=this.semver.version===V.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||V.operator!==">="&&V.operator!=="<="),ze=fe(this.semver,"<",V.semver,Y)&&(this.operator===">="||this.operator===">")&&(V.operator==="<="||V.operator==="<"),Ie=fe(this.semver,">",V.semver,Y)&&(this.operator==="<="||this.operator==="<")&&(V.operator===">="||V.operator===">");return ge||ye||De&&Se||ze||Ie},e.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(V){return V.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(V){var Y=this.loose;V=V.trim(),R("range",V,Y);var K=Y?k[B]:k[T];V=V.replace(K,pe),R("hyphen replace",V),V=V.replace(k[M],"$1$2$3"),R("comparator trim",V,k[M]),V=(V=(V=V.replace(k[te],"$1~")).replace(k[he],"$1^")).split(/\s+/).join(" ");var ge=Y?k[q]:k[Q],ye=V.split(" ").map(function(De){return function(Se,ze){return R("comp",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Te){return function(Oe,Ae){R("caret",Oe,Ae);var Ce=Ae?k[ae]:k[ce];return Oe.replace(Ce,function(Le,be,Ee,Pe,Re){var Fe;return R("caret",Oe,Le,be,Ee,Pe,Re),le(be)?Fe="":le(Ee)?Fe=">="+be+".0.0 <"+(+be+1)+".0.0":le(Pe)?Fe=be==="0"?">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+".0 <"+(+be+1)+".0.0":Re?(R("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Pe+Re+" <"+be+"."+Ee+"."+(+Pe+1):">="+be+"."+Ee+"."+Pe+Re+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Pe+Re+" <"+(+be+1)+".0.0"):(R("no pr"),Fe=be==="0"?Ee==="0"?">="+be+"."+Ee+"."+Pe+" <"+be+"."+Ee+"."+(+Pe+1):">="+be+"."+Ee+"."+Pe+" <"+be+"."+(+Ee+1)+".0":">="+be+"."+Ee+"."+Pe+" <"+(+be+1)+".0.0"),R("caret return",Fe),Fe})}(Te,Ne)}).join(" ")}(Se,ze),R("caret",Se),Se=function(Ie,Ne){return Ie.trim().split(/\s+/).map(function(Te){return function(Oe,Ae){var Ce=Ae?k[oe]:k[_];return Oe.replace(Ce,function(Le,be,Ee,Pe,Re){var Fe;return R("tilde",Oe,Le,be,Ee,Pe,Re),le(be)?Fe="":le(Ee)?Fe=">="+be+".0.0 <"+(+be+1)+".0.0":le(Pe)?Fe=">="+be+"."+Ee+".0 <"+be+"."+(+Ee+1)+".0":Re?(R("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=">="+be+"."+Ee+"."+Pe+Re+" <"+be+"."+(+Ee+1)+".0"):Fe=">="+be+"."+Ee+"."+Pe+" <"+be+"."+(+Ee+1)+".0",R("tilde return",Fe),Fe})}(Te,Ne)}).join(" ")}(Se,ze),R("tildes",Se),Se=function(Ie,Ne){return R("replaceXRanges",Ie,Ne),Ie.split(/\s+/).map(function(Te){return function(Oe,Ae){Oe=Oe.trim();var Ce=Ae?k[y]:k[O];return Oe.replace(Ce,function(Le,be,Ee,Pe,Re,Fe){R("xRange",Oe,Le,be,Ee,Pe,Re,Fe);var qe=le(Ee),Ue=qe||le(Pe),Me=Ue||le(Re);return be==="="&&Me&&(be=""),qe?Le=be===">"||be==="<"?"<0.0.0":"*":be&&Me?(Ue&&(Pe=0),Me&&(Re=0),be===">"?(be=">=",Ue?(Ee=+Ee+1,Pe=0,Re=0):Me&&(Pe=+Pe+1,Re=0)):be==="<="&&(be="<",Ue?Ee=+Ee+1:Pe=+Pe+1),Le=be+Ee+"."+Pe+"."+Re):Ue?Le=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Me&&(Le=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),R("xRange return",Le),Le})}(Te,Ne)}).join(" ")}(Se,ze),R("xrange",Se),Se=function(Ie,Ne){return R("replaceStars",Ie,Ne),Ie.trim().replace(k[X],"")}(Se,ze),R("stars",Se),Se}(De,Y)}).join(" ").split(/\s+/);return this.loose&&(ye=ye.filter(function(De){return!!De.match(ge)})),ye=ye.map(function(De){return new $e(De,Y)})},de.prototype.intersects=function(V,Y){if(!(V instanceof de))throw new TypeError("a Range is required");return this.set.some(function(K){return K.every(function(ge){return V.set.some(function(ye){return ye.every(function(De){return ge.intersects(De,Y)})})})})},e.toComparators=function(V,Y){return new de(V,Y).set.map(function(K){return K.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},de.prototype.test=function(V){if(!V)return!1;typeof V=="string"&&(V=new F(V,this.loose));for(var Y=0;Y<this.set.length;Y++)if(ve(this.set[Y],V))return!0;return!1},e.satisfies=ke,e.maxSatisfying=function(V,Y,K){var ge=null,ye=null;try{var De=new de(Y,K)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(ge&&ye.compare(Se)!==-1||(ye=new F(ge=Se,K)))}),ge},e.minSatisfying=function(V,Y,K){var ge=null,ye=null;try{var De=new de(Y,K)}catch{return null}return V.forEach(function(Se){De.test(Se)&&(ge&&ye.compare(Se)!==1||(ye=new F(ge=Se,K)))}),ge},e.validRange=function(V,Y){try{return new de(V,Y).range||"*"}catch{return null}},e.ltr=function(V,Y,K){return je(V,Y,"<",K)},e.gtr=function(V,Y,K){return je(V,Y,">",K)},e.outside=je,e.prerelease=function(V,Y){var K=x(V,Y);return K&&K.prerelease.length?K.prerelease:null},e.intersects=function(V,Y,K){return V=new de(V,K),Y=new de(Y,K),V.intersects(Y)},e.coerce=function(V){if(V instanceof F)return V;if(typeof V!="string")return null;var Y=V.match(k[j]);return Y==null?null:x((Y[1]||"0")+"."+(Y[2]||"0")+"."+(Y[3]||"0"))}}).call(this,L(1))},function(J,e){var L,D,R=J.exports={};function N(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function k($){if(L===setTimeout)return setTimeout($,0);if((L===N||!L)&&setTimeout)return L=setTimeout,setTimeout($,0);try{return L($,0)}catch{try{return L.call(null,$,0)}catch{return L.call(this,$,0)}}}(function(){try{L=typeof setTimeout=="function"?setTimeout:N}catch{L=N}try{D=typeof clearTimeout=="function"?clearTimeout:A}catch{D=A}})();var u,a=[],v=!1,E=-1;function m(){v&&u&&(v=!1,u.length?a=u.concat(a):E=-1,a.length&&f())}function f(){if(!v){var $=k(m);v=!0;for(var l=a.length;l;){for(u=a,a=[];++E<l;)u&&u[E].run();E=-1,l=a.length}u=null,v=!1,function(w){if(D===clearTimeout)return clearTimeout(w);if((D===A||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(w);try{D(w)}catch{try{return D.call(null,w)}catch{return D.call(this,w)}}}($)}}function b($,l){this.fun=$,this.array=l}function S(){}R.nextTick=function($){var l=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)l[w-1]=arguments[w];a.push(new b($,l)),a.length!==1||v||k(f)},b.prototype.run=function(){this.fun.apply(null,this.array)},R.title="browser",R.browser=!0,R.env={},R.argv=[],R.version="",R.versions={},R.on=S,R.addListener=S,R.once=S,R.off=S,R.removeListener=S,R.removeAllListeners=S,R.emit=S,R.prependListener=S,R.prependOnceListener=S,R.listeners=function($){return[]},R.binding=function($){throw new Error("process.binding is not supported")},R.cwd=function(){return"/"},R.chdir=function($){throw new Error("process.chdir is not supported")},R.umask=function(){return 0}}])}),define(ie[75],ne([0,1]),function(J,e){"use strict";var L;Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0;class D{constructor(k,u,a){this.level=k,this.key=u,this.value=a,this.forward=[]}}const R=void 0;class N{constructor(k,u=2**16){this.comparator=k,this[L]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(u)|0),this.e=new D(this.c,R,R)}get size(){return this.f}clear(){this.e=new D(this.c,R,R),this.f=0}has(k){return!!N.g(this,k,this.comparator)}get(k){return N.g(this,k,this.comparator)?.value}set(k,u){return N.h(this,k,u,this.comparator)&&(this.f+=1),this}delete(k){const u=N.k(this,k,this.comparator);return u&&(this.f-=1),u}forEach(k,u){let a=this.e.forward[0];for(;a;)k.call(u,a.value,a.key,this),a=a.forward[0]}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",u=this.e.forward[0];for(;u;)k+=`node(${u.key}, ${u.value}, lvl:${u.level})`,u=u.forward[0];return k}static g(k,u,a){let v=k.e;for(let E=k.d-1;E>=0;E--)for(;v.forward[E]&&a(v.forward[E].key,u)<0;)v=v.forward[E];if(v=v.forward[0],v&&a(v.key,u)===0)return v}static h(k,u,a,v){const E=[];let m=k.e;for(let f=k.d-1;f>=0;f--){for(;m.forward[f]&&v(m.forward[f].key,u)<0;)m=m.forward[f];E[f]=m}if(m=m.forward[0],m&&v(m.key,u)===0)return m.value=a,!1;{const f=N.j(k);if(f>k.d){for(let b=k.d;b<f;b++)E[b]=k.e;k.d=f}m=new D(f,u,a);for(let b=0;b<f;b++)m.forward[b]=E[b].forward[b],E[b].forward[b]=m;return!0}}static j(k,u=.5){let a=1;for(;Math.random()<u&&a<k.c;)a+=1;return a}static k(k,u,a){const v=[];let E=k.e;for(let m=k.d-1;m>=0;m--){for(;E.forward[m]&&a(E.forward[m].key,u)<0;)E=E.forward[m];v[m]=E}if(E=E.forward[0],!E||a(E.key,u)!==0)return!1;for(let m=0;m<k.d&&v[m].forward[m]===E;m++)v[m].forward[m]=E.forward[m];for(;k.d>0&&k.e.forward[k.d-1]===R;)k.d-=1;return!0}}e.$1r=N}),define(ie[46],ne([0,1,7,2]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function R(h){const g=h;return g?typeof g.read=="function":!1}e.$7d=R;function N(h){const g=h;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.$8d=N;function A(h){const g=h;return g?N(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.$9d=A;function k(h,g){return new u(h,g)}e.$0d=k;class u{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,L.$1)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let r;switch(g){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(i);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(h,g){const i=[];let r;for(;(r=h.read())!==null;)i.push(r);return g(i)}e.$$d=a;function v(h,g,i){const r=[];let t;for(;(t=h.read())!==null&&r.length<i;)r.push(t);return t===null&&r.length>0?g(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const n=t;return t=void 0,n}return h.read()}}}e.$_d=v;function E(h,g){return new Promise((i,r)=>{const t=[];m(h,{onData:n=>{g&&t.push(n)},onError:n=>{g?r(n):i(void 0)},onEnd:()=>{i(g?g(t):void 0)}})})}e.$ae=E;function m(h,g,i){h.on("error",r=>{i?.isCancellationRequested||g.onError(r)}),h.on("end",()=>{i?.isCancellationRequested||g.onEnd()}),h.on("data",r=>{i?.isCancellationRequested||g.onData(r)})}e.$be=m;function f(h,g){return new Promise((i,r)=>{const t=new D.$Sc,n=[],s=I=>{if(n.push(I),n.length>g)return t.dispose(),h.pause(),i({stream:h,buffer:n,ended:!1})},o=I=>(t.dispose(),r(I)),c=()=>(t.dispose(),i({stream:h,buffer:n,ended:!0}));t.add((0,D.$Rc)(()=>h.removeListener("error",o))),h.on("error",o),t.add((0,D.$Rc)(()=>h.removeListener("end",c))),h.on("end",c),t.add((0,D.$Rc)(()=>h.removeListener("data",s))),h.on("data",s)})}e.$ce=f;function b(h,g){const i=k(g);return i.end(h),i}e.$de=b;function S(){const h=k(()=>{throw new Error("not supported")});return h.end(),h}e.$ee=S;function $(h){let g=!1;return{read:()=>g?null:(g=!0,h)}}e.$fe=$;function l(h,g,i){const r=k(i);return m(h,{onData:t=>r.write(g.data(t)),onError:t=>r.error(g.error?g.error(t):t),onEnd:()=>r.end()}),r}e.$ge=l;function w(h,g,i){let r=!1;return{read:()=>{const t=g.read();return r?t:(r=!0,t!==null?i([h,t]):h)}}}e.$he=w;function p(h,g,i){let r=!1;const t=k(i);return m(g,{onData:n=>r?t.write(n):(r=!0,t.write(i([h,n]))),onError:n=>t.error(n),onEnd:()=>{r||(r=!0,t.write(h)),t.end()}}),t}e.$ie=p}),define(ie[14],ne([0,1,166,46]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const R=typeof Buffer<"u",N=new L.$V(()=>new Uint8Array(256));let A,k;class u{static alloc(j){return R?new u(Buffer.allocUnsafe(j)):new u(new Uint8Array(j))}static wrap(j){return R&&!Buffer.isBuffer(j)&&(j=Buffer.from(j.buffer,j.byteOffset,j.byteLength)),new u(j)}static fromString(j,H){return!(H?.dontUseNodeBuffer||!1)&&R?new u(Buffer.from(j)):(A||(A=new TextEncoder),new u(A.encode(j)))}static fromByteArray(j){const H=u.alloc(j.length);for(let te=0,_=j.length;te<_;te++)H.buffer[te]=j[te];return H}static concat(j,H){if(typeof H>"u"){H=0;for(let oe=0,re=j.length;oe<re;oe++)H+=j[oe].byteLength}const te=u.alloc(H);let _=0;for(let oe=0,re=j.length;oe<re;oe++){const he=j[oe];te.set(he,_),_+=he.byteLength}return te}constructor(j){this.buffer=j,this.byteLength=this.buffer.byteLength}clone(){const j=u.alloc(this.byteLength);return j.set(this),j}toString(){return R?this.buffer.toString():(k||(k=new TextDecoder),k.decode(this.buffer))}slice(j,H){return new u(this.buffer.subarray(j,H))}set(j,H){if(j instanceof u)this.buffer.set(j.buffer,H);else if(j instanceof Uint8Array)this.buffer.set(j,H);else if(j instanceof ArrayBuffer)this.buffer.set(new Uint8Array(j),H);else if(ArrayBuffer.isView(j))this.buffer.set(new Uint8Array(j.buffer,j.byteOffset,j.byteLength),H);else throw new Error("Unknown argument 'array'")}readUInt32BE(j){return m(this.buffer,j)}writeUInt32BE(j,H){f(this.buffer,j,H)}readUInt32LE(j){return b(this.buffer,j)}writeUInt32LE(j,H){S(this.buffer,j,H)}readUInt8(j){return $(this.buffer,j)}writeUInt8(j,H){l(this.buffer,j,H)}indexOf(j,H=0){return a(this.buffer,j instanceof u?j.buffer:j,H)}}e.$je=u;function a(y,j,H=0){const te=j.byteLength,_=y.byteLength;if(te===0)return 0;if(te===1)return y.indexOf(j[0]);if(te>_-H)return-1;const oe=N.value;oe.fill(j.length);for(let ae=0;ae<j.length;ae++)oe[j[ae]]=j.length-ae-1;let re=H+j.length-1,he=re,ce=-1;for(;re<_;)if(y[re]===j[he]){if(he===0){ce=re;break}re--,he--}else re+=Math.max(j.length-he,oe[y[re]]),he=j.length-1;return ce}e.$ke=a;function v(y,j){return y[j+0]<<0>>>0|y[j+1]<<8>>>0}e.$le=v;function E(y,j,H){y[H+0]=j&255,j=j>>>8,y[H+1]=j&255}e.$me=E;function m(y,j){return y[j]*2**24+y[j+1]*2**16+y[j+2]*2**8+y[j+3]}e.$ne=m;function f(y,j,H){y[H+3]=j,j=j>>>8,y[H+2]=j,j=j>>>8,y[H+1]=j,j=j>>>8,y[H]=j}e.$oe=f;function b(y,j){return y[j+0]<<0>>>0|y[j+1]<<8>>>0|y[j+2]<<16>>>0|y[j+3]<<24>>>0}e.$pe=b;function S(y,j,H){y[H+0]=j&255,j=j>>>8,y[H+1]=j&255,j=j>>>8,y[H+2]=j&255,j=j>>>8,y[H+3]=j&255}e.$qe=S;function $(y,j){return y[j]}e.$re=$;function l(y,j,H){y[H]=j}e.$se=l;function w(y){return D.$$d(y,j=>u.concat(j))}e.$te=w;function p(y){return D.$fe(y)}e.$ue=p;function h(y){return D.$ae(y,j=>u.concat(j))}e.$ve=h;async function g(y){return y.ended?u.concat(y.buffer):u.concat([...y.buffer,await h(y.stream)])}e.$we=g;function i(y){return D.$de(y,j=>u.concat(j))}e.$xe=i;function r(y){return D.$ge(y,{data:j=>typeof j=="string"?u.fromString(j):u.wrap(j)},j=>u.concat(j))}e.$ye=r;function t(y){return D.$0d(j=>u.concat(j),y)}e.$ze=t;function n(y,j){return D.$he(y,j,H=>u.concat(H))}e.$Ae=n;function s(y,j){return D.$ie(y,j,H=>u.concat(H))}e.$Be=s;function o(y){let j=0,H=0,te=0;const _=new Uint8Array(Math.floor(y.length/4*3)),oe=he=>{switch(H){case 3:_[te++]=j|he,H=0;break;case 2:_[te++]=j|he>>>2,j=he<<6,H=3;break;case 1:_[te++]=j|he>>>4,j=he<<4,H=2;break;default:j=he<<2,H=1}};for(let he=0;he<y.length;he++){const ce=y.charCodeAt(he);if(ce>=65&&ce<=90)oe(ce-65);else if(ce>=97&&ce<=122)oe(ce-97+26);else if(ce>=48&&ce<=57)oe(ce-48+52);else if(ce===43||ce===45)oe(62);else if(ce===47||ce===95)oe(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${y[he]}`)}}const re=te;for(;H>0;)oe(0);return u.wrap(_).slice(0,re)}e.$Ce=o;const c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function O({buffer:y},j=!0,H=!1){const te=H?I:c;let _="";const oe=y.byteLength%3;let re=0;for(;re<y.byteLength-oe;re+=3){const he=y[re+0],ce=y[re+1],ae=y[re+2];_+=te[he>>>2],_+=te[(he<<4|ce>>>4)&63],_+=te[(ce<<2|ae>>>6)&63],_+=te[ae&63]}if(oe===1){const he=y[re+0];_+=te[he>>>2],_+=te[he<<4&63],j&&(_+="==")}else if(oe===2){const he=y[re+0],ce=y[re+1];_+=te[he>>>2],_+=te[(he<<4|ce>>>4)&63],_+=te[ce<<2&63],j&&(_+="=")}return _}e.$De=O}),define(ie[43],ne([0,1,30]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function D(l){return R(l,0)}e.$Ti=D;function R(l,w){switch(typeof l){case"object":return l===null?N(349,w):Array.isArray(l)?u(l,w):a(l,w);case"string":return k(l,w);case"boolean":return A(l,w);case"number":return N(l,w);case"undefined":return N(937,w);default:return N(617,w)}}e.$Ui=R;function N(l,w){return(w<<5)-w+l|0}e.$Vi=N;function A(l,w){return N(l?433:863,w)}function k(l,w){w=N(149417,w);for(let p=0,h=l.length;p<h;p++)w=N(l.charCodeAt(p),w);return w}e.$Wi=k;function u(l,w){return w=N(104579,w),l.reduce((p,h)=>R(h,p),w)}function a(l,w){return w=N(181387,w),Object.keys(l).sort().reduce((p,h)=>(p=k(h,p),R(l[h],p)),w)}class v{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=R(w,this.g),this.g}}e.$Xi=v;var E;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(E||(E={}));function m(l,w,p=32){const h=p-w,g=~((1<<h)-1);return(l<<w|(g&l)>>>h)>>>0}function f(l,w=0,p=l.byteLength,h=0){for(let g=0;g<p;g++)l[w+g]=h}function b(l,w,p="0"){for(;l.length<w;)l=p+l;return l}function S(l,w=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(p=>p.toString(16).padStart(2,"0")).join(""):b((l>>>0).toString(16),w/4)}e.$Yi=S;class ${static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const p=w.length;if(p===0)return;const h=this.p;let g=this.r,i=this.u,r,t;for(i!==0?(r=i,t=-1,i=0):(r=w.charCodeAt(0),t=0);;){let n=r;if(L.$df(r))if(t+1<p){const s=w.charCodeAt(t+1);L.$ef(s)?(t++,n=L.$ff(r,s)):n=65533}else{i=r;break}else L.$ef(r)&&(n=65533);if(g=this.w(h,g,n),t++,t<p)r=w.charCodeAt(t);else break}this.r=g,this.u=i}w(w,p,h){return h<128?w[p++]=h:h<2048?(w[p++]=192|(h&1984)>>>6,w[p++]=128|(h&63)>>>0):h<65536?(w[p++]=224|(h&61440)>>>12,w[p++]=128|(h&4032)>>>6,w[p++]=128|(h&63)>>>0):(w[p++]=240|(h&1835008)>>>18,w[p++]=128|(h&258048)>>>12,w[p++]=128|(h&4032)>>>6,w[p++]=128|(h&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,w[0]=w[64+0],w[1]=w[64+1],w[2]=w[64+2]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),S(this.h)+S(this.l)+S(this.m)+S(this.n)+S(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=$.g,p=this.q;for(let c=0;c<64;c+=4)w.setUint32(c,p.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)w.setUint32(c,m(w.getUint32(c-12,!1)^w.getUint32(c-32,!1)^w.getUint32(c-56,!1)^w.getUint32(c-64,!1),1),!1);let h=this.h,g=this.l,i=this.m,r=this.n,t=this.o,n,s,o;for(let c=0;c<80;c++)c<20?(n=g&i|~g&r,s=1518500249):c<40?(n=g^i^r,s=1859775393):c<60?(n=g&i|g&r|i&r,s=2400959708):(n=g^i^r,s=3395469782),o=m(h,5)+n+t+s+w.getUint32(c*4,!1)&4294967295,t=r,r=i,i=m(g,30),g=h,h=o;this.h=this.h+h&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.$Zi=$}),define(ie[54],ne([0,1,30]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var D;(function(R){R[R.Ignore=0]="Ignore",R[R.Info=1]="Info",R[R.Warning=2]="Warning",R[R.Error=3]="Error"})(D||(D={})),function(R){const N="error",A="warning",k="warn",u="info",a="ignore";function v(m){return m?L.$_e(N,m)?R.Error:L.$_e(A,m)||L.$_e(k,m)?R.Warning:L.$_e(u,m)?R.Info:R.Ignore:R.Ignore}R.fromValue=v;function E(m){switch(m){case R.Error:return N;case R.Warning:return A;case R.Info:return u;default:return a}}R.toString=E}(D||(D={})),e.default=D}),define(ie[27],ne([0,1,3]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function D(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const w=Array.isArray(l)?[]:{};return Object.entries(l).forEach(([p,h])=>{w[p]=h&&typeof h=="object"?D(h):h}),w}e.$vn=D;function R(l){if(!l||typeof l!="object")return l;const w=[l];for(;w.length>0;){const p=w.shift();Object.freeze(p);for(const h in p)if(N.call(p,h)){const g=p[h];typeof g=="object"&&!Object.isFrozen(g)&&!(0,L.$Lf)(g)&&w.push(g)}}return l}e.$wn=R;const N=Object.prototype.hasOwnProperty;function A(l,w){return k(l,w,new Set)}e.$xn=A;function k(l,w,p){if((0,L.$Rf)(l))return l;const h=w(l);if(typeof h<"u")return h;if(Array.isArray(l)){const g=[];for(const i of l)g.push(k(i,w,p));return g}if((0,L.$Kf)(l)){if(p.has(l))throw new Error("Cannot clone recursive data-structure");p.add(l);const g={};for(const i in l)N.call(l,i)&&(g[i]=k(l[i],w,p));return p.delete(l),g}return l}function u(l,w,p=!0){return(0,L.$Kf)(l)?((0,L.$Kf)(w)&&Object.keys(w).forEach(h=>{h in l?p&&((0,L.$Kf)(l[h])&&(0,L.$Kf)(w[h])?u(l[h],w[h],p):l[h]=w[h]):l[h]=w[h]}),l):w}e.$yn=u;function a(l,w){if(l===w)return!0;if(l==null||w===null||w===void 0||typeof l!=typeof w||typeof l!="object"||Array.isArray(l)!==Array.isArray(w))return!1;let p,h;if(Array.isArray(l)){if(l.length!==w.length)return!1;for(p=0;p<l.length;p++)if(!a(l[p],w[p]))return!1}else{const g=[];for(h in l)g.push(h);g.sort();const i=[];for(h in w)i.push(h);if(i.sort(),!a(g,i))return!1;for(p=0;p<g.length;p++)if(!a(l[g[p]],w[g[p]]))return!1}return!0}e.$zn=a;function v(l){const w=new Set;return JSON.stringify(l,(p,h)=>{if((0,L.$Kf)(h)||Array.isArray(h)){if(w.has(h))return"[Circular]";w.add(h)}return h})}e.$An=v;function E(l,w){const p=Object.create(null);return!l||!w||Object.keys(w).forEach(g=>{const i=l[g],r=w[g];a(i,r)||(p[g]=r)}),p}e.$Bn=E;function m(l,w){const p=w.toLowerCase(),h=Object.keys(l).find(g=>g.toLowerCase()===p);return h?l[h]:l[w]}e.$Cn=m;function f(l,w){const p=Object.create(null);for(const[h,g]of Object.entries(l))w(h,g)&&(p[h]=g);return p}e.$Dn=f;function b(l){let w=[];for(;Object.prototype!==l;)w=w.concat(Object.getOwnPropertyNames(l)),l=Object.getPrototypeOf(l);return w}e.$En=b;function S(l){const w=[];for(const p of b(l))typeof l[p]=="function"&&w.push(p);return w}e.$Fn=S;function $(l,w){const p=g=>function(){const i=Array.prototype.slice.call(arguments,0);return w(g,i)},h={};for(const g of l)h[g]=p(g);return h}e.$Gn=$}),define(ie[28],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const L=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function D(R){return L.test(R)}e.$pg=D,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(k){for(let u=0;u<k.length;u++)k[u]=Math.floor(Math.random()*256);return k};const N=new Uint8Array(16),A=[];for(let k=0;k<256;k++)A.push(k.toString(16).padStart(2,"0"));return function(){R(N),N[6]=N[6]&15|64,N[8]=N[8]&63|128;let u=0,a="";return a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+="-",a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a+=A[N[u++]],a}}()}),define(ie[76],ne([0,1,33]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0;const D=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function R(A){const k=A.replace(/\-/g,":").toLowerCase();return!D.has(k)}function N(){const A=(0,L.networkInterfaces)();for(const k in A){const u=A[k];if(u){for(const{mac:a}of u)if(R(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$9m=N}),define(ie[77],ne([8,5]),function(J,e){return J.create("vs/base/common/date",e)}),define(ie[78],ne([0,1,77]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const D=60,R=D*60,N=R*24,A=N*7,k=N*30,u=N*365;function a(E,m,f,b){typeof E!="number"&&(E=E.getTime());const S=Math.round((new Date().getTime()-E)/1e3);if(S<-30)return(0,L.localize)(0,null,a(new Date().getTime()+S*1e3,!1));if(!b&&S<30)return(0,L.localize)(1,null);let $;return S<D?($=S,m?$===1?f?(0,L.localize)(2,null,$):(0,L.localize)(3,null,$):f?(0,L.localize)(4,null,$):(0,L.localize)(5,null,$):$===1?f?(0,L.localize)(6,null,$):(0,L.localize)(7,null,$):f?(0,L.localize)(8,null,$):(0,L.localize)(9,null,$)):S<R?($=Math.floor(S/D),m?$===1?f?(0,L.localize)(10,null,$):(0,L.localize)(11,null,$):f?(0,L.localize)(12,null,$):(0,L.localize)(13,null,$):$===1?f?(0,L.localize)(14,null,$):(0,L.localize)(15,null,$):f?(0,L.localize)(16,null,$):(0,L.localize)(17,null,$)):S<N?($=Math.floor(S/R),m?$===1?f?(0,L.localize)(18,null,$):(0,L.localize)(19,null,$):f?(0,L.localize)(20,null,$):(0,L.localize)(21,null,$):$===1?f?(0,L.localize)(22,null,$):(0,L.localize)(23,null,$):f?(0,L.localize)(24,null,$):(0,L.localize)(25,null,$)):S<A?($=Math.floor(S/N),m?$===1?(0,L.localize)(26,null,$):(0,L.localize)(27,null,$):$===1?(0,L.localize)(28,null,$):(0,L.localize)(29,null,$)):S<k?($=Math.floor(S/A),m?$===1?f?(0,L.localize)(30,null,$):(0,L.localize)(31,null,$):f?(0,L.localize)(32,null,$):(0,L.localize)(33,null,$):$===1?f?(0,L.localize)(34,null,$):(0,L.localize)(35,null,$):f?(0,L.localize)(36,null,$):(0,L.localize)(37,null,$)):S<u?($=Math.floor(S/k),m?$===1?f?(0,L.localize)(38,null,$):(0,L.localize)(39,null,$):f?(0,L.localize)(40,null,$):(0,L.localize)(41,null,$):$===1?f?(0,L.localize)(42,null,$):(0,L.localize)(43,null,$):f?(0,L.localize)(44,null,$):(0,L.localize)(45,null,$)):($=Math.floor(S/u),m?$===1?f?(0,L.localize)(46,null,$):(0,L.localize)(47,null,$):f?(0,L.localize)(48,null,$):(0,L.localize)(49,null,$):$===1?f?(0,L.localize)(50,null,$):(0,L.localize)(51,null,$):f?(0,L.localize)(52,null,$):(0,L.localize)(53,null,$))}e.$vm=a;function v(E){return E.getFullYear()+"-"+String(E.getMonth()+1).padStart(2,"0")+"-"+String(E.getDate()).padStart(2,"0")+"T"+String(E.getHours()).padStart(2,"0")+":"+String(E.getMinutes()).padStart(2,"0")+":"+String(E.getSeconds()).padStart(2,"0")+"."+(E.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=v}),define(ie[79],ne([8,5]),function(J,e){return J.create("vs/base/common/errorMessage",e)}),define(ie[34],ne([0,1,19,3,79]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function N(E,m){return m&&(E.stack||E.stacktrace)?R.localize(0,null,k(E),A(E.stack)||A(E.stacktrace)):k(E)}function A(E){return Array.isArray(E)?E.join(`
`):E}function k(E){return E.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${E.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof E.code=="string"&&typeof E.errno=="number"&&typeof E.syscall=="string"?R.localize(1,null,E.message):E.message||R.localize(2,null)}function u(E=null,m=!1){if(!E)return R.localize(3,null);if(Array.isArray(E)){const f=L.$Hb(E),b=u(f[0],m);return f.length>1?R.localize(4,null,b,f.length):b}if(D.$If(E))return E;if(E.detail){const f=E.detail;if(f.error)return N(f.error,m);if(f.exception)return N(f.exception,m)}return E.stack?N(E,m):E.message?E.message:R.localize(5,null)}e.$Qi=u;function a(E){const m=E;return m instanceof Error&&Array.isArray(m.actions)}e.$Ri=a;function v(E,m){let f;return typeof E=="string"?f=new Error(E):f=E,f.actions=m,f}e.$Si=v}),define(ie[80],ne([8,5]),function(J,e){return J.create("vs/base/common/jsonErrorMessages",e)}),define(ie[81],ne([0,1,80]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;function D(R){switch(R){case 1:return(0,L.localize)(0,null);case 2:return(0,L.localize)(1,null);case 3:return(0,L.localize)(2,null);case 4:return(0,L.localize)(3,null);case 5:return(0,L.localize)(4,null);case 6:return(0,L.localize)(5,null);case 7:return(0,L.localize)(6,null);case 8:return(0,L.localize)(7,null);case 9:return(0,L.localize)(8,null);default:return""}}e.$Xp=D}),define(ie[55],ne([0,1,12]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var D;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(D||(e.Source=D={}));var R;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(R||(e.TerminateResponseCode=R={}));function N(k,...u){const a=u.reduce((m,f)=>(m[f]=!0,m),{}),v=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(m=>!a[m]).forEach(m=>{for(let f=0;f<v.length;f++)if(m.search(v[f])!==-1){delete k[m];break}})}e.$Rl=N;function A(k){k&&(delete k.DEBUG,L.$j&&delete k.DYLD_LIBRARY_PATH,L.$k&&delete k.LD_PRELOAD)}e.$Sl=A}),define(ie[82],ne([0,1,11]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function D(a){const v=a;return v&&typeof v.type=="string"&&typeof v.severity=="string"}e.$mq=D;function R(a){const v=[];let E;try{const m=JSON.parse(a.arguments),f=m[m.length-1];f&&f.__$stack&&(m.pop(),E=f.__$stack),v.push(...m)}catch{v.push("Unable to log remote console arguments",a.arguments)}return{args:v,stack:E}}e.$nq=R;function N(a){if(typeof a!="string")return N(R(a).stack);const v=a;if(v){const E=A(v),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(E||"");if(m&&m.length===4)return{uri:L.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$oq=N;function A(a){if(!a)return a;const v=a.indexOf(`
`);return v===-1?a:a.substring(0,v)}function k(a,v){const{args:E,stack:m}=R(a),f=typeof E[0]=="string"&&E.length===1;let b=A(m);b&&(b=`(${b.trim()})`);let S=[];if(typeof E[0]=="string"?b&&f?S=[`%c[${v}] %c${E[0]} %c${b}`,u("blue"),u(""),u("grey")]:S=[`%c[${v}] %c${E[0]}`,u("blue"),u(""),...E.slice(1)]:S=[`%c[${v}]%`,u("blue"),...E],b&&!f&&S.push(b),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,S)}e.log=k;function u(a){return`color: ${a}`}}),define(ie[47],ne([0,1,14,11]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function R(u){return JSON.stringify(u,A)}e.$Ah=R;function N(u){let a=JSON.parse(u);return a=k(a),a}e.$Bh=N;function A(u,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function k(u,a=0){if(!u||a>200)return u;if(typeof u=="object"){switch(u.$mid){case 1:return D.URI.revive(u);case 2:return new RegExp(u.source,u.flags);case 17:return new Date(u.source)}if(u instanceof L.$je||u instanceof Uint8Array)return u;if(Array.isArray(u))for(let v=0;v<u.length;++v)u[v]=k(u[v],a+1);else for(const v in u)Object.hasOwnProperty.call(u,v)&&(u[v]=k(u[v],a+1))}return u}e.$Ch=k}),define(ie[83],ne([0,1,70,15,12,11]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0;class A{constructor(m,f,b){this.id=m,this.dependencies=f,this.callback=b}}class k{static{this.INSTANCE=new k}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,f,b)=>{typeof m!="string"&&(b=f,f=m,m=null),(typeof f!="object"||!Array.isArray(f))&&(b=f,f=null),this.c.push(new A(m,f,b))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const f=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!f)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(f.dependencies)&&f.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${f.dependencies.join(", ")}`);return typeof f.callback=="function"?f.callback([]):f.callback}h(m){return new Promise((f,b)=>{const S=document.createElement("script");S.setAttribute("async","async"),S.setAttribute("type","text/javascript");const $=()=>{S.removeEventListener("load",l),S.removeEventListener("error",w)},l=p=>{$(),f(this.c.pop())},w=p=>{$(),b(p)};S.addEventListener("load",l),S.addEventListener("error",w),this.f&&(m=this.f.createScriptURL(m)),S.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(S)})}i(m){return new Promise((f,b)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),f(this.c.pop())}catch(S){b(S)}})}async j(m){try{const f=globalThis._VSCODE_NODE_MODULES.fs,b=globalThis._VSCODE_NODE_MODULES.vm,S=globalThis._VSCODE_NODE_MODULES.module,$=N.URI.parse(m).fsPath,l=f.readFileSync($).toString(),w=S.wrap(l.replace(/^#!.*/,""));return new b.Script(w).runInThisContext().apply(),this.c.pop()}catch(f){throw f}}}const u=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function v(E,m,f){if(L.$T){f===void 0&&(f=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[E]&&(E=a[E]);const b=`${E}/${m}`;if(u.has(b))return u.get(b);let S;if(/^\w[\w\d+.-]*:\/\//.test(b))S=b;else{const p=`${f&&!R.$o?D.$lg:D.$kg}/${b}`;S=D.$og.asBrowserUri(p).toString(!0)}const $=k.INSTANCE.load(S);return u.set(b,$),$}else return await new Promise((b,S)=>{J([E],b,S)})}e.$fD=v}),define(ie[84],ne([0,1,33,48,28,76,12]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=new class{c(m){return this.a||(this.a=D.$_h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,f=0;const b=(0,L.networkInterfaces)();for(const S in b){const $=b[S];if($)for(const{mac:l,internal:w}of $)w||(f+=1,this.c(l.toUpperCase())&&(m+=1))}this.b=f>0?m/f:0}return this.b}};let k;async function u(m){return k||(k=(async()=>await a(m)||R.$qg())()),k}e.$$m=u;async function a(m){try{const f=await new Promise((S,$)=>{J(["crypto"],S,$)}),b=(0,N.$9m)();return f.createHash("sha256").update(b,"utf8").digest("hex")}catch(f){m(f);return}}const v="Software\\Microsoft\\SQMClient";async function E(m){if(A.$i){const f=await new Promise((b,S)=>{J(["@vscode/windows-registry"],b,S)});try{return f.GetStringRegKey("HKEY_LOCAL_MACHINE",v,"MachineId")||""}catch(b){return m(b),""}}return""}e.$_m=E}),define(ie[85],ne([0,1,33,16,24]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const N=/^\d+$/,A=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var u;(function(h){h[h.x64=0]="x64",h[h.x86=1]="x86",h[h.ARM=2]="ARM"})(u||(u={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let v;process.env.PROCESSOR_ARCHITEW6432?v=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?v=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?v=1:v=0;class E{constructor(g,i,r){this.exePath=g,this.displayName=i,this.a=r}async exists(){return this.a===void 0&&(this.a=await R.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:h=!1}={}){return h?a===0?process.env["ProgramFiles(x86)"]||null:v===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:h=!1,findPreview:g=!1}={}){const i=m({useAlternateBitness:h});if(!i)return null;const r=D.$jc(i,"PowerShell");if(!await R.SymlinkSupport.existsDirectory(r))return null;let t=-1,n=null;for(const c of await R.Promises.readdir(r)){let I=-1;if(g){const y=c.indexOf("-");if(y<0)continue;const j=c.substring(0,y);if(!N.test(j)||c.substring(y+1)!=="preview")continue;I=parseInt(j,10)}else{if(!N.test(c))continue;I=parseInt(c,10)}if(I<=t)continue;const O=D.$jc(r,c,"pwsh.exe");await R.SymlinkSupport.existsFile(O)&&(n=O,t=I)}if(!n)return null;const s=i.includes("x86")?" (x86)":"",o=g?" Preview":"";return new E(n,`PowerShell${o}${s}`,!0)}async function b({findPreview:h}={}){if(!process.env.LOCALAPPDATA)return null;const g=D.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await R.SymlinkSupport.existsDirectory(g))return null;const{pwshMsixDirRegex:i,pwshMsixName:r}=h?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await R.Promises.readdir(g))if(i.test(t)){const n=D.$jc(g,t,"pwsh.exe");return new E(n,r)}return null}function S(){const h=D.$jc(L.homedir(),".dotnet","tools","pwsh.exe");return new E(h,".NET Core PowerShell Global Tool")}function $(){const h=D.$jc(process.env.windir,a===1&&v!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new E(h,"Windows PowerShell",!0)}async function*l(){let h=await f();h&&(yield h),h=await f({useAlternateBitness:!0}),h&&(yield h),h=await b(),h&&(yield h),h=S(),h&&(yield h),h=await f({findPreview:!0}),h&&(yield h),h=await b({findPreview:!0}),h&&(yield h),h=await f({useAlternateBitness:!0,findPreview:!0}),h&&(yield h),h=$(),h&&(yield h)}async function*w(){for await(const h of l())await h.exists()&&(yield h)}e.$Pl=w;async function p(){for await(const h of w())return h;return null}e.$Ql=p}),define(ie[56],ne([0,1,16,12,35,55,3,24]),function(J,e,L,D,R,N,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return N.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return N.TerminateResponseCode}});function u(E=R.env){return E.comspec||"cmd.exe"}e.$Tl=u;function a(E){let m=[],f=!1;const b=function(S){if(f){m.push(S);return}(!E.send(S,l=>{if(l&&console.error(l),f=!1,m.length>0){const w=m.slice(0);m=[],w.forEach(p=>b(p))}})||D.$i)&&(f=!0)};return{send:b}}e.$Ul=a;var v;(function(E){async function m(f,b,S){if(L.$ic(f))return f;if(b===void 0&&(b=R.cwd()),L.$mc(f)!=="."||(S===void 0&&A.$If(R.env.PATH)&&(S=R.env.PATH.split(L.$tc)),S===void 0||S.length===0))return L.$jc(b,f);async function l(w){if(await k.Promises.exists(w)){let p;try{p=await k.Promises.stat(w)}catch(h){h.message.startsWith("EACCES")&&(p=await k.Promises.lstat(w))}return p?!p.isDirectory():!1}return!1}for(const w of S){let p;if(L.$ic(w)?p=L.$jc(w,f):p=L.$jc(b,w,f),await l(p))return p;let h=p+".com";if(await l(h)||(h=p+".exe",await l(h)))return h}return L.$jc(b,f)}E.findExecutable=m})(v||(e.win32=v={}))}),define(ie[86],ne([0,1,33,12,85,56]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=void 0;async function A(E,m){return E===1?D.$i?v():N.$Tl(m):u(E,m)}e.$Vl=A;let k=null;function u(E,m){if(D.$k&&E===2||D.$j&&E===3)return"/bin/bash";if(!k){let f;if(D.$i)f="/bin/bash";else{if(f=m.SHELL,!f)try{f=(0,L.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}k=f}return k}let a=null;async function v(){return a||(a=(await(0,R.$Ql)()).exePath),a}});var me=this&&this.__decorate||function(J,e,L,D){var R=arguments.length,N=R<3?e:D===null?D=Object.getOwnPropertyDescriptor(e,L):D,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")N=Reflect.decorate(J,e,L,D);else for(var k=J.length-1;k>=0;k--)(A=J[k])&&(N=(R<3?A(N):R>3?A(e,L,N):A(e,L))||N);return R>3&&N&&Object.defineProperty(e,L,N),N};define(ie[57],ne([0,1,19,9,14,20,53,7,6,2,47,30,3]),function(J,e,L,D,R,N,A,k,u,a,v,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var f;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(f||(f={}));function b(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(S||(S={}));function $(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));function w(M){let T=0;for(let B=0;;B+=7){const X=M.read(1);if(T|=(X.buffer[0]&127)<<B,!(X.buffer[0]&128))return T}}const p=t(0);function h(M,T){if(T===0){M.write(p);return}let B=0;for(let Z=T;Z!==0;Z=Z>>>7)B++;const X=R.$je.alloc(B);for(let Z=0;T!==0;Z++)X.buffer[Z]=T&127,T=T>>>7,T>0&&(X.buffer[Z]|=128);M.write(X)}class g{constructor(T){this.b=T,this.a=0}read(T){const B=this.b.slice(this.a,this.a+T);return this.a+=B.byteLength,B}}e.$Dh=g;class i{constructor(){this.a=[]}get buffer(){return R.$je.concat(this.a)}write(T){this.a.push(T)}}e.$Eh=i;var r;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object",M[M.Int=6]="Int"})(r||(r={}));function t(M){const T=R.$je.alloc(1);return T.writeUInt8(M,0),T}const n={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(M,T){if(typeof T>"u")M.write(n.Undefined);else if(typeof T=="string"){const B=R.$je.fromString(T);M.write(n.String),h(M,B.byteLength),M.write(B)}else if(s&&Buffer.isBuffer(T)){const B=R.$je.wrap(T);M.write(n.Buffer),h(M,B.byteLength),M.write(B)}else if(T instanceof R.$je)M.write(n.VSBuffer),h(M,T.byteLength),M.write(T);else if(Array.isArray(T)){M.write(n.Array),h(M,T.length);for(const B of T)o(M,B)}else if(typeof T=="number"&&(T|0)===T)M.write(n.Uint),h(M,T);else{const B=R.$je.fromString(JSON.stringify(T));M.write(n.Object),h(M,B.byteLength),M.write(B)}}e.$Fh=o;function c(M){switch(M.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return M.read(w(M)).toString();case r.Buffer:return M.read(w(M)).buffer;case r.VSBuffer:return M.read(w(M));case r.Array:{const B=w(M),X=[];for(let Z=0;Z<B;Z++)X.push(c(M));return X}case r.Object:return JSON.parse(M.read(w(M)).toString());case r.Int:return w(M)}}e.$Gh=c;class I{constructor(T,B,X=null,Z=1e3){this.h=T,this.j=B,this.k=X,this.l=Z,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(T,B){this.b.set(T,B),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const B=this.o([T.type]);this.k?.logOutgoing(B,0,1,$(T.type));return}case 201:case 202:case 204:case 203:{const B=this.o([T.type,T.id],T.data);this.k?.logOutgoing(B,T.id,1,$(T.type),T.data);return}}}o(T,B=void 0){const X=new i;return o(X,T),o(X,B),this.p(X.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const B=new g(T),X=c(B),Z=c(B),x=X[0];switch(x){case 100:return this.k?.logIncoming(T.byteLength,X[1],1,`${b(x)}: ${X[2]}.${X[3]}`,Z),this.s({type:x,id:X[1],channelName:X[2],name:X[3],arg:Z});case 102:return this.k?.logIncoming(T.byteLength,X[1],1,`${b(x)}: ${X[2]}.${X[3]}`,Z),this.t({type:x,id:X[1],channelName:X[2],name:X[3],arg:Z});case 101:return this.k?.logIncoming(T.byteLength,X[1],1,`${b(x)}`),this.u({type:x,id:X[1]});case 103:return this.k?.logIncoming(T.byteLength,X[1],1,`${b(x)}`),this.u({type:x,id:X[1]})}}s(T){const B=this.b.get(T.channelName);if(!B){this.v(T);return}const X=new N.$6d;let Z;try{Z=B.call(this.j,T.name,T.arg,X.token)}catch(C){Z=Promise.reject(C)}const x=T.id;Z.then(C=>{this.m({id:x,data:C,type:201})},C=>{C instanceof Error?this.m({id:x,data:{message:C.message,name:C.name,stack:C.stack?C.stack.split?C.stack.split(`
`):C.stack:void 0},type:202}):this.m({id:x,data:C,type:203})}).finally(()=>{F.dispose(),this.d.delete(T.id)});const F=(0,a.$Rc)(()=>X.cancel());this.d.set(T.id,F)}t(T){const B=this.b.get(T.channelName);if(!B){this.v(T);return}const X=T.id,x=B.listen(this.j,T.name,T.arg)(F=>this.m({id:X,data:F,type:204}));this.d.set(T.id,x)}u(T){const B=this.d.get(T.id);B&&(B.dispose(),this.d.delete(T.id))}v(T){let B=this.g.get(T.channelName);B||(B=[],this.g.set(T.channelName,B));const X=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);B.push({request:T,timeoutTimer:X})}w(T){const B=this.g.get(T);if(B){for(const X of B)switch(clearTimeout(X.timeoutTimer),X.request.type){case 100:this.s(X.request);break;case 102:this.t(X.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=I;var O;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(O||(e.RequestInitiator=O={}));class y{constructor(T,B=null){this.l=T,this.a=!1,this.b=l.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new u.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(X=>this.s(X)),this.j=B}getChannel(T){const B=this;return{call(X,Z,x){return B.a?Promise.reject(new k.$5):B.m(T,X,Z,x)},listen(X,Z){return B.a?u.Event.None:B.o(T,X,Z)}}}m(T,B,X,Z=N.CancellationToken.None){const x=this.g++,C={id:x,type:100,channelName:T,name:B,arg:X};if(Z.isCancellationRequested)return Promise.reject(new k.$5);let d;return new Promise((z,U)=>{if(Z.isCancellationRequested)return U(new k.$5);const W=()=>{const fe=$e=>{switch($e.type){case 201:this.f.delete(x),z($e.data);break;case 202:{this.f.delete(x);const we=new Error($e.data.message);we.stack=Array.isArray($e.data.stack)?$e.data.stack.join(`
`):$e.data.stack,we.name=$e.data.name,U(we);break}case 203:this.f.delete(x),U($e.data);break}};this.f.set(x,fe),this.p(C)};let G=null;this.b===l.Idle?W():(G=(0,D.$Tg)(fe=>this.u()),G.then(()=>{G=null,W()}));const ee=()=>{G?(G.cancel(),G=null):this.p({id:x,type:101}),U(new k.$5)},ue=Z.onCancellationRequested(ee);d=(0,a.$Qc)((0,a.$Rc)(ee),ue),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(T,B,X){const Z=this.g++,F={id:Z,type:102,channelName:T,name:B,arg:X};let C=null;const d=new u.$Vd({onWillAddFirstListener:()=>{C=(0,D.$Tg)(z=>this.u()),C.then(()=>{C=null,this.d.add(d),this.p(F)})},onDidRemoveLastListener:()=>{C?(C.cancel(),C=null):(this.d.delete(d),this.p({id:Z,type:103}))}}),P=z=>d.fire(z.data);return this.f.set(Z,P),d.event}p(T){switch(T.type){case 100:case 102:{const B=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(B,T.id,0,`${b(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const B=this.q([T.type,T.id]);this.j?.logOutgoing(B,T.id,0,b(T.type));return}}}q(T,B=void 0){const X=new i;return o(X,T),o(X,B),this.r(X.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const B=new g(T),X=c(B),Z=c(B),x=X[0];switch(x){case 200:return this.j?.logIncoming(T.byteLength,0,0,$(x)),this.t({type:X[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,X[1],0,$(x),Z),this.t({type:X[0],id:X[1],data:Z})}}t(T){if(T.type===200){this.b=l.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}u(){return this.b===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=y,me([A.$xh],y.prototype,"onDidInitializePromise",null);class j{get connections(){const T=[];return this.f.forEach(B=>T.push(B)),T}constructor(T){this.a=new Map,this.f=new Set,this.g=new u.$Vd,this.onDidAddConnection=this.g.event,this.h=new u.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new a.$Sc,this.j.add(T(({protocol:B,onDidClientDisconnect:X})=>{const Z=u.Event.once(B.onMessage);this.j.add(Z(x=>{const F=new g(x),C=c(F),d=new I(B,C),P=new y(B);this.a.forEach((U,W)=>d.registerChannel(W,U));const z={channelServer:d,channelClient:P,ctx:C};this.f.add(z),this.g.fire(z),this.j.add(X(()=>{d.dispose(),P.dispose(),this.f.delete(z),this.h.fire(z)}))}))}))}getChannel(T,B){const X=this;return{call(Z,x,F){let C;if((0,m.$Wf)(B)){const P=(0,L.$4b)(X.connections.filter(B));C=P?Promise.resolve(P):u.Event.toPromise(u.Event.filter(X.onDidAddConnection,B))}else C=B.routeCall(X,Z,x);const d=C.then(P=>P.channelClient.getChannel(T));return te(d).call(Z,x,F)},listen(Z,x){if((0,m.$Wf)(B))return X.k(T,B,Z,x);const F=B.routeEvent(X,Z,x).then(C=>C.channelClient.getChannel(T));return te(F).listen(Z,x)}}}k(T,B,X,Z){const x=this;let F;const C=new u.$Vd({onWillAddFirstListener:()=>{F=new a.$Sc;const d=new u.$2d,P=new Map,z=W=>{const ee=W.channelClient.getChannel(T).listen(X,Z),ue=d.add(ee);P.set(W,ue)},U=W=>{const G=P.get(W);G&&(G.dispose(),P.delete(W))};x.connections.filter(B).forEach(z),u.Event.filter(x.onDidAddConnection,B)(z,void 0,F),x.onDidRemoveConnection(U,void 0,F),d.event(C.fire,C,F),F.add(d)},onDidRemoveLastListener:()=>{F?.dispose(),F=void 0}});return C.event}registerChannel(T,B){this.a.set(T,B);for(const X of this.f)X.channelServer.registerChannel(T,B)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=j;class H{constructor(T,B,X=null){const Z=new i;o(Z,B),T.send(Z.buffer),this.a=new y(T,X),this.d=new I(T,B,X)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,B){this.d.registerChannel(T,B)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=H;function te(M){return{call(T,B,X){return M.then(Z=>Z.call(T,B,X))},listen(T,B){const X=new u.$5d;return M.then(Z=>X.input=Z.listen(T,B)),X.event}}}e.$Lh=te;function _(M){let T=!1;return{call(B,X,Z){return T?M.call(B,X,Z):(0,D.$7g)(0).then(()=>T=!0).then(()=>M.call(B,X,Z))},listen(B,X){if(T)return M.listen(B,X);const Z=new u.$5d;return(0,D.$7g)(0).then(()=>T=!0).then(()=>Z.input=M.listen(B,X)),Z.event}}}e.$Mh=_;class oe{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const B of T.connections)if(await Promise.resolve(this.a(B.ctx)))return Promise.resolve(B);return await u.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$Nh=oe;var re;(function(M){function T(x,F,C){const d=x,P=C&&C.disableMarshalling,z=new Map;for(const U in d)X(U)&&z.set(U,u.Event.buffer(d[U],!0,void 0,F));return new class{listen(U,W,G){const ee=z.get(W);if(ee)return ee;if(Z(W)){const ue=d[W];if(typeof ue=="function")return ue.call(d,G)}throw new k.$bb(`Event not found: ${W}`)}call(U,W,G){const ee=d[W];if(typeof ee=="function"){if(!P&&Array.isArray(G))for(let fe=0;fe<G.length;fe++)G[fe]=(0,v.$Ch)(G[fe]);let ue=ee.apply(d,G);return ue instanceof Promise||(ue=Promise.resolve(ue)),ue}throw new k.$bb(`Method not found: ${W}`)}}}M.fromService=T;function B(x,F){const C=F&&F.disableMarshalling;return new Proxy({},{get(d,P){if(typeof P=="string")return F?.properties?.has(P)?F.properties.get(P):Z(P)?function(z){return x.listen(P,z)}:X(P)?x.listen(P):async function(...z){let U;F&&!(0,m.$Rf)(F.context)?U=[F.context,...z]:U=z;const W=await x.call(P,U);return C?W:(0,v.$Ch)(W)};throw new k.$bb(`Property not found: ${String(P)}`)}})}M.toService=B;function X(x){return x[0]==="o"&&x[1]==="n"&&E.$$e(x.charCodeAt(2))}function Z(x){return/^onDynamic/.test(x)&&E.$$e(x.charCodeAt(9))}})(re||(e.ProxyChannel=re={}));const he=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ce(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const T=M.toString();if(T!=="[object Object]")return T}return M}function ae(M){return Array.isArray(M)?M.map(ce):ce(M)}function q(M,T,B,X,Z,x,F){F=ae(F);const C=he[Z],d=C[X%C.length];let P=[`%c[${M}]%c[${String(T).padStart(7," ")}]%c[len: ${String(B).padStart(5," ")}]%c${String(X).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(x)?(P=P.concat(F),P.push(")")):P.push(F),console.log.apply(console,P)}class Q{constructor(T,B){this.d=T,this.f=B,this.a=0,this.b=0}logOutgoing(T,B,X,Z,x){this.b+=T,q(this.d,this.b,T,B,X,Z,x)}logIncoming(T,B,X,Z,x){this.a+=T,q(this.f,this.a,T,B,X,Z,x)}}e.$Oh=Q}),define(ie[87],ne([0,1,58,9,14,20,82,7,6,2,27,56,55,57]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class b extends f.$Hh{constructor(l){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:u.Event.fromNodeEventEmitter(process,"message",w=>R.$je.wrap(Buffer.from(w,"base64")))},l),process.once("disconnect",()=>this.dispose())}}e.$qq=b;class S{constructor(l,w){this.i=l,this.j=w,this.c=new Set,this.g=new Map,this.h=new u.$Vd,this.onDidProcessExit=this.h.event;const p=w&&w.timeout?w.timeout:6e4;this.b=new D.$3g(p),this.d=null,this.f=null}getChannel(l){const w=this;return{call(p,h,g){return w.k(l,p,h,g)},listen(p,h){return w.l(l,p,h)}}}k(l,w,p,h=N.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(h.isCancellationRequested)return Promise.reject(k.$6());this.b.cancel();const g=this.n(l),i=(0,D.$Tg)(n=>g.call(w,p,n)),r=h.onCancellationRequested(()=>i.cancel()),t=(0,a.$Rc)(()=>i.cancel());return this.c.add(t),i.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(l,w,p){if(!this.b)return u.Event.None;this.b.cancel();let h;const g=new u.$Vd({onWillAddFirstListener:()=>{h=this.n(l).listen(w,p)(g.fire,g),this.c.add(h)},onDidRemoveLastListener:()=>{this.c.delete(h),h.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return g.event}get m(){if(!this.f){const l=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,v.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,m.$Sl)(w.env),this.d=(0,L.fork)(this.i,l,w);const p=new u.$Vd;u.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,A.$mq)(s)){(0,A.log)(s,`IPC Library: ${this.j.serverName}`);return}p.fire(R.$je.wrap(Buffer.from(s,"base64")))});const g=this.j.useQueue?(0,E.$Ul)(this.d):this.d,i=s=>this.d&&this.d.connected&&g.send(s.buffer.toString("base64")),r=p.event,t={send:i,onMessage:r};this.f=new f.$Ih(t);const n=()=>this.o();process.once("exit",n),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",n),this.c.forEach(c=>(0,a.$Oc)(c)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(l){let w=this.g.get(l);return w||(w=this.m.getChannel(l),this.g.set(l,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=S}),define(ie[88],ne([0,1,9,6,2,47,3]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.StorageState=e.$pp=e.StorageHint=void 0;var k;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(k||(e.StorageHint=k={}));function u(m){const f=m;return f?.changed instanceof Map||f?.deleted instanceof Set}e.$pp=u;var a;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(a||(e.StorageState=a={}));class v extends R.$Tc{static{this.a=100}constructor(f,b=Object.create(null)){super(),this.r=f,this.s=b,this.b=this.B(new D.$Yd),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new L.$4g(v.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(f=>this.u(f)))}u(f){this.b.pause();try{f.changed?.forEach((b,S)=>this.w(S,b)),f.deleted?.forEach(b=>this.w(b,void 0))}finally{this.b.resume()}}w(f,b){if(this.c===a.Closed)return;let S=!1;(0,A.$Rf)(b)?S=this.f.delete(f):this.f.get(f)!==b&&(this.f.set(f,b),S=!0),S&&this.b.fire({key:f,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==k.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(f,b){const S=this.f.get(f);return(0,A.$Rf)(S)?b:S}getBoolean(f,b){const S=this.get(f);return(0,A.$Rf)(S)?b:S==="true"}getNumber(f,b){const S=this.get(f);return(0,A.$Rf)(S)?b:parseInt(S,10)}getObject(f,b){const S=this.get(f);return(0,A.$Rf)(S)?b:(0,N.$Bh)(S)}async set(f,b,S=!1){if(this.c===a.Closed)return;if((0,A.$Rf)(b))return this.delete(f,S);const $=(0,A.$Kf)(b)||Array.isArray(b)?(0,N.$Ah)(b):String(b);if(this.f.get(f)!==$)return this.f.set(f,$),this.j.set(f,$),this.h.delete(f),this.b.fire({key:f,external:S}),this.D()}async delete(f,b=!1){if(!(this.c===a.Closed||!this.f.delete(f)))return this.h.has(f)||this.h.add(f),this.j.delete(f),this.b.fire({key:f,external:b}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const f={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(f).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(f){if(this.z)return this.D(f)}async D(f){return this.s.hint===k.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),f)}async whenFlushed(){if(this.z)return new Promise(f=>this.n.push(f))}isInMemory(){return this.s.hint===k.STORAGE_IN_MEMORY}}e.$qp=v;class E{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(f){f.insert?.forEach((b,S)=>this.a.set(S,b)),f.delete?.forEach(b=>this.a.delete(b))}async optimize(){}async close(){}}e.$rp=E}),define(ie[89],ne([8,5]),function(J,e){return J.create("vs/base/node/zip",e)}),define(ie[49],ne([0,1,90,9,16,3,24,89]),function(J,e,L,D,R,N,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.zip=e.$Mp=e.$Lp=void 0,e.$Lp="end of central directory record signature not found";const u=new RegExp(e.$Lp);class a extends Error{constructor(g,i){let r=i.message;switch(g){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=g,this.cause=i}}e.$Mp=a;function v(h){const g=h.externalFileAttributes>>16||33188;return[448,56,7].map(i=>g&i).reduce((i,r)=>i+r,g&61440)}function E(h){if(h instanceof a)return h;let g;return u.test(h.message)&&(g="CorruptZip"),new a(g,h)}function m(h,g,i,r,t,n){const s=R.$mc(g),o=R.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(k.localize(0,null,g)));const c=R.$jc(r,g);let I;return n.onCancellationRequested(()=>{I?.destroy()}),Promise.resolve(A.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((O,y)=>{if(!n.isCancellationRequested)try{I=(0,L.createWriteStream)(c,{mode:i}),I.once("close",()=>O()),I.once("error",y),h.once("error",y),h.pipe(I)}catch(j){y(j)}}))}function f(h,g,i,r){let t=(0,D.$Tg)(()=>Promise.resolve()),n=0;const s=r.onCancellationRequested(()=>{t.cancel(),h.close()});return new Promise((o,c)=>{const I=new D.$1g,O=y=>{y.isCancellationRequested||(n++,h.readEntry())};h.once("error",c),h.once("close",()=>t.then(()=>{r.isCancellationRequested||h.entryCount===n?o():c(new a("Incomplete",new Error(k.localize(1,null,n,h.entryCount))))},c)),h.readEntry(),h.on("entry",y=>{if(r.isCancellationRequested)return;if(!i.sourcePathRegex.test(y.fileName)){O(r);return}const j=y.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(j)){const _=R.$jc(g,j);t=(0,D.$Tg)(oe=>A.Promises.mkdir(_,{recursive:!0}).then(()=>O(oe)).then(void 0,c));return}const H=S(h,y),te=v(y);t=(0,D.$Tg)(_=>I.queue(()=>H.then(oe=>m(oe,j,te,g,i,_).then(()=>O(_)))).then(null,c))})}).finally(()=>s.dispose())}async function b(h,g=!1){const{open:i}=await new Promise((r,t)=>{J(["yauzl"],r,t)});return new Promise((r,t)=>{i(h,g?{lazyEntries:!0}:void 0,(n,s)=>{n?t(E(n)):r((0,N.$Tf)(s))})})}function S(h,g){return new Promise((i,r)=>{h.openReadStream(g,(t,n)=>{t?r(E(t)):i((0,N.$Tf)(n))})})}async function $(h,g){const{ZipFile:i}=await new Promise((r,t)=>{J(["yazl"],r,t)});return new Promise((r,t)=>{const n=new i;g.forEach(o=>{o.contents?n.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&n.addFile(o.localPath,o.path)}),n.end();const s=(0,L.createWriteStream)(h);n.outputStream.pipe(s),n.outputStream.once("error",t),s.once("error",t),s.once("finish",()=>r(h))})}e.zip=$;function l(h,g,i={},r){const t=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let n=b(h,!0);return i.overwrite&&(n=n.then(s=>A.Promises.rm(g).then(()=>s))),n.then(s=>f(s,g,{sourcePathRegex:t},r))}e.$Op=l;function w(h,g){return b(h).then(i=>new Promise((r,t)=>{i.on("entry",n=>{n.fileName===g&&S(i,n).then(s=>r(s),s=>t(s))}),i.once("close",()=>t(new Error(k.localize(2,null,g))))}))}function p(h,g){return w(h,g).then(i=>new Promise((r,t)=>{const n=[];i.once("error",t),i.on("data",s=>n.push(s)),i.on("end",()=>r(Buffer.concat(n)))}))}e.$Pp=p}),define(ie[91],ne([8,5]),function(J,e){return J.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ie[92],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/contextkey",e)}),define(ie[93],ne([8,5]),function(J,e){return J.create("vs/platform/contextkey/common/scanner",e)}),define(ie[94],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(ie[95],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ie[96],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(ie[97],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(ie[98],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(ie[99],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(ie[100],ne([8,5]),function(J,e){return J.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(ie[101],ne([8,5]),function(J,e){return J.create("vs/platform/extensions/common/extensionValidator",e)}),define(ie[102],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/fileService",e)}),define(ie[103],ne([8,5]),function(J,e){return J.create("vs/platform/files/common/io",e)}),define(ie[104],ne([8,5]),function(J,e){return J.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ie[105],ne([8,5]),function(J,e){return J.create("vs/platform/languagePacks/common/languagePacks",e)}),define(ie[106],ne([8,5]),function(J,e){return J.create("vs/platform/request/common/request",e)}),define(ie[107],ne([8,5]),function(J,e){return J.create("vs/platform/shell/node/shellEnv",e)}),define(ie[108],ne([8,5]),function(J,e){return J.create("vs/platform/telemetry/common/telemetryService",e)}),define(ie[109],ne([8,5]),function(J,e){return J.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ie[110],ne([8,5]),function(J,e){return J.create("vs/platform/workspace/common/workspace",e)}),define(ie[111],ne([0,1,7,93]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var R;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(R||(e.TokenType=R={}));function N(...a){switch(a.length){case 1:return(0,D.localize)(0,null,a[0]);case 2:return(0,D.localize)(1,null,a[0],a[1]);case 3:return(0,D.localize)(2,null,a[0],a[1],a[2]);default:return}}const A=(0,D.localize)(3,null),k=(0,D.localize)(4,null);class u{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(v){switch(v.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return v.isTripleEq?"===":"==";case 4:return v.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return v.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return v.lexeme;case 18:return v.lexeme;case 19:return v.lexeme;case 20:return"EOF";default:throw(0,L.$8)(`unhandled token type: ${JSON.stringify(v)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(v){return this.c=v,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const E=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:E})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const E=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:E})}else this.h(126)?this.k(9):this.l(N("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(N("&&"));break;case 124:this.h(124)?this.k(16):this.l(N("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(v){return this.r()||this.c.charCodeAt(this.e)!==v?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(v){this.f.push({type:v,offset:this.d})}l(v){const E=this.d,m=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:m};this.g.push({offset:E,lexeme:m,additionalInfo:v}),this.f.push(f)}n(){this.m.lastIndex=this.d;const v=this.m.exec(this.c);if(v){this.e=this.d+v[0].length;const E=this.c.substring(this.d,this.e),m=u.b.get(E);m?this.k(m):this.f.push({type:17,lexeme:E,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let v=this.e,E=!1,m=!1;for(;;){if(v>=this.c.length){this.e=v,this.l(k);return}const b=this.c.charCodeAt(v);if(E)E=!1;else if(b===47&&!m){v++;break}else b===91?m=!0:b===92?E=!0:b===93&&(m=!1);v++}for(;v<this.c.length&&u.a.has(this.c.charCodeAt(v));)v++;this.e=v;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=u}),define(ie[112],ne([0,1,78,53,15,16,35,17,11]),function(J,e,L,D,R,N,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$xm=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,N.$mc)(R.$og.asFileUri("").fsPath)}get userHome(){return u.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.b.tmpDir)}get cacheHome(){return u.URI.file(this.userDataPath)}get stateResource(){return(0,k.$Hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:R.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,k.$Hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,L.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,N.$jc)(this.userDataPath,"logs",f)}return u.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.$Hg)(u.URI.file((0,N.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.$Hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.$Hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.$Hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=A.env.VSCODE_PORTABLE;return f?u.URI.file((0,N.$jc)(f,"argv.json")):(0,k.$Hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,N.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,N.$kc)(f):(0,N.$hc)((0,N.$jc)(R.$og.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?u.URI.file((0,N.$kc)(f)):u.URI.file((0,N.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,N.$kc)(f);const b=A.env.VSCODE_EXTENSIONS;if(b)return b;const S=A.env.VSCODE_PORTABLE;return S?(0,N.$jc)(S,"extensions"):(0,k.$Hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(b=>/^[^:/?#]+?:\/\//.test(b)?u.URI.parse(b):u.URI.file((0,N.$hc)(b)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?u.URI.parse(f):u.URI.file((0,N.$hc)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return v(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.$xm.test(f))}get extensionLogLevel(){const f=[];for(const b of this.args.log||[]){const S=e.$xm.exec(b);S&&S[1]&&S[2]&&f.push([S[1],S[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,k.$Hg)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=A.env.VSCODE_PORTABLE;return f?u.URI.file((0,N.$jc)(f,"policy.json")):(0,k.$Hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,b,S){this.a=f,this.b=b,this.c=S,this.editSessionId=this.args.editSessionId}}e.$ym=a,me([D.$xh],a.prototype,"appRoot",null),me([D.$xh],a.prototype,"userHome",null),me([D.$xh],a.prototype,"userDataPath",null),me([D.$xh],a.prototype,"appSettingsHome",null),me([D.$xh],a.prototype,"tmpDir",null),me([D.$xh],a.prototype,"cacheHome",null),me([D.$xh],a.prototype,"stateResource",null),me([D.$xh],a.prototype,"userRoamingDataHome",null),me([D.$xh],a.prototype,"userDataSyncHome",null),me([D.$xh],a.prototype,"sync",null),me([D.$xh],a.prototype,"machineSettingsResource",null),me([D.$xh],a.prototype,"workspaceStorageHome",null),me([D.$xh],a.prototype,"localHistoryHome",null),me([D.$xh],a.prototype,"keyboardLayoutResource",null),me([D.$xh],a.prototype,"argvResource",null),me([D.$xh],a.prototype,"isExtensionDevelopment",null),me([D.$xh],a.prototype,"untitledWorkspacesHome",null),me([D.$xh],a.prototype,"builtinExtensionsPath",null),me([D.$xh],a.prototype,"extensionsPath",null),me([D.$xh],a.prototype,"extensionDevelopmentLocationURI",null),me([D.$xh],a.prototype,"extensionDevelopmentKind",null),me([D.$xh],a.prototype,"extensionTestsLocationURI",null),me([D.$xh],a.prototype,"debugExtensionHost",null),me([D.$xh],a.prototype,"logLevel",null),me([D.$xh],a.prototype,"extensionLogLevel",null),me([D.$xh],a.prototype,"serviceMachineIdResource",null),me([D.$xh],a.prototype,"disableTelemetry",null),me([D.$xh],a.prototype,"disableWorkspaceTrust",null),me([D.$xh],a.prototype,"useInMemorySecretStorage",null),me([D.$xh],a.prototype,"policyFile",null);function v(m,f){return E(m["inspect-extensions"],m["inspect-brk-extensions"],5870,f,m.debugId,m.extensionEnvironment)}e.$zm=v;function E(m,f,b,S,$,l){const p=Number(f||m)||(S?null:b),h=p?!!f:!1;let g;if(l)try{g=JSON.parse(l)}catch{}return{port:p,break:h,debugId:$,env:g}}e.$Am=E}),function(){"use strict";function J(e,L,D){function R(A,k){const u=N(A,k),a=[u];return e.isAbsolute(u)||a.unshift(D),e.resolve(...a)}function N(A,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const u=process.env.VSCODE_PORTABLE;if(u)return e.join(u,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,k);const v=A["user-data-dir"];if(v)return v;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const E=process.env.USERPROFILE;if(typeof E!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(E,"AppData","Roaming")}break;case"darwin":a=e.join(L.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(L.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,k)}return{getUserDataPath:R}}if(typeof define=="function")define(ie[113],ne([167,33,35]),function(e,L,D){return J(e,L,D.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),L=require("os");module.exports=J(e,L,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(ie[114],ne([0,1,33,112,113]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=void 0;class N extends D.$ym{constructor(a,v){super(a,{homeDir:(0,L.homedir)(),tmpDir:(0,L.tmpdir)(),userDataDir:(0,R.getUserDataPath)(a,v.nameShort)},v)}}e.$Bm=N;function A(u,a){return(0,D.$Am)(u["inspect-ptyhost"],u["inspect-brk-ptyhost"],5877,a,u.extensionEnvironment)}e.$Cm=A;function k(u,a){return(0,D.$Am)(u["inspect-sharedprocess"],u["inspect-brk-sharedprocess"],5879,a,u.extensionEnvironment)}e.$Dm=k}),define(ie[115],ne([0,1,3,97]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;function R(A,k,u,a){try{N(A,k,u,a)}catch(v){A.error(v?.message??v)}return k}e.$Yp=R;function N(A,k,u,a){const v=(E,m,f)=>{const b=E[m];if((0,L.$If)(b)){const S=b,$=S.length;if($>1&&S[0]==="%"&&S[$-1]==="%"){const l=S.substr(1,$-2);let w=u[l];w===void 0&&a&&(w=a[l]);const p=typeof w=="string"?w:w?.message,h=a?.[l],g=typeof h=="string"?h:h?.message;if(!p){g||A.warn(`[${k.name}]: ${(0,D.localize)(0,null,l)}`);return}if(f&&(m==="title"||m==="category")&&g&&g!==p){const i={value:p,original:g};E[m]=i}else E[m]=p}}else if((0,L.$Kf)(b))for(const S in b)b.hasOwnProperty(S)&&(S==="commands"?v(b,S,!0):v(b,S,f));else if(Array.isArray(b))for(let S=0;S<b.length;S++)v(b,S,f)};for(const E in k)k.hasOwnProperty(E)&&v(k,E)}}),define(ie[116],ne([0,1,49,100]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;function R(N){return(0,L.$Pp)(N,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,D.localize)(0,null))}})}e.$7p=R}),define(ie[50],ne([0,1,17,54,101,44]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function u(l){return l=l.trim(),l==="*"||A.test(l)}e.$ap=u;function a(l){if(!u(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=l.match(A);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}e.$bp=a;function v(l){if(!l)return null;const w=l.majorBase,p=l.majorMustEqual,h=l.minorBase;let g=l.minorMustEqual;const i=l.patchBase;let r=l.patchMustEqual;l.hasCaret&&(w===0||(g=!1),r=!1);let t=0;if(l.preRelease){const n=k.exec(l.preRelease);if(n){const[,s,o,c]=n;t=Date.UTC(Number(s),Number(o)-1,Number(c))}}return{majorBase:w,majorMustEqual:p,minorBase:h,minorMustEqual:g,patchBase:i,patchMustEqual:r,isMinimum:l.hasGreaterEquals,notBefore:t}}e.$cp=v;function E(l,w,p){let h;typeof l=="string"?h=v(a(l)):h=l;let g;w instanceof Date?g=w.getTime():typeof w=="string"&&(g=new Date(w).getTime());let i;if(typeof p=="string"?i=v(a(p)):i=p,!h||!i)return!1;const r=h.majorBase,t=h.minorBase,n=h.patchBase;let s=i.majorBase,o=i.minorBase,c=i.patchBase;const I=i.notBefore;let O=i.majorMustEqual,y=i.minorMustEqual,j=i.patchMustEqual;return i.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||g&&g<I?!1:n>=c:(r===1&&s===0&&(!O||!y||!j)&&(s=1,o=0,c=0,O=!0,y=!1,j=!1),r<s?!1:r>s?!O:t<o?!1:t>o?!y:n<c?!1:n>c?!j:!(g&&g<I))}e.$dp=E;function m(l,w,p,h,g){const i=[];if(typeof h.publisher<"u"&&typeof h.publisher!="string")return i.push([D.default.Error,R.localize(0,null)]),i;if(typeof h.name!="string")return i.push([D.default.Error,R.localize(1,null,"name")]),i;if(typeof h.version!="string")return i.push([D.default.Error,R.localize(2,null,"version")]),i;if(!h.engines)return i.push([D.default.Error,R.localize(3,null,"engines")]),i;if(typeof h.engines.vscode!="string")return i.push([D.default.Error,R.localize(4,null,"engines.vscode")]),i;if(typeof h.extensionDependencies<"u"&&!$(h.extensionDependencies))return i.push([D.default.Error,R.localize(5,null,"extensionDependencies")]),i;if(typeof h.activationEvents<"u"){if(!$(h.activationEvents))return i.push([D.default.Error,R.localize(6,null,"activationEvents")]),i;if(typeof h.main>"u"&&typeof h.browser>"u")return i.push([D.default.Error,R.localize(7,null,"activationEvents","main","browser")]),i}if(typeof h.extensionKind<"u"&&typeof h.main>"u"&&i.push([D.default.Warning,R.localize(8,null,"extensionKind")]),typeof h.main<"u"){if(typeof h.main!="string")return i.push([D.default.Error,R.localize(9,null,"main")]),i;{const n=(0,L.$Hg)(p,h.main);(0,L.$Bg)(n,p)||i.push([D.default.Warning,R.localize(10,null,n.path,p.path)])}}if(typeof h.browser<"u"){if(typeof h.browser!="string")return i.push([D.default.Error,R.localize(11,null,"browser")]),i;{const n=(0,L.$Hg)(p,h.browser);(0,L.$Bg)(n,p)||i.push([D.default.Warning,R.localize(12,null,n.path,p.path)])}}if(!N.valid(h.version))return i.push([D.default.Error,R.localize(13,null)]),i;const r=[];if(!f(l,w,h,g,r))for(const n of r)i.push([D.default.Error,n]);return i}e.$ep=m;function f(l,w,p,h,g){return h||typeof p.main>"u"&&typeof p.browser>"u"?!0:S(l,w,p.engines.vscode,g)}e.$fp=f;function b(l,w,p){return l==="*"||S(w,p,l)}e.$gp=b;function S(l,w,p,h=[]){const g=v(a(p));if(!g)return h.push(R.localize(14,null,p)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return h.push(R.localize(15,null,p)),!1}else if(!g.majorMustEqual)return h.push(R.localize(16,null,p)),!1;return E(l,w,g)?!0:(h.push(R.localize(17,null,l,p)),!1)}function $(l){if(!Array.isArray(l))return!1;for(let w=0,p=l.length;w<p;w++)if(typeof l[w]!="string")return!1;return!0}}),define(ie[117],ne([0,1,14,28]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function R(N,A,k){let u=k&&k.get("storage.serviceMachineId",-1)||null;if(u)return u;try{const v=(await A.readFile(N.serviceMachineIdResource)).value.toString();u=(0,D.$pg)(v)?v:null}catch{u=null}if(!u){u=(0,D.$qg)();try{await A.writeFile(N.serviceMachineIdResource,L.$je.fromString(u))}catch{}}return k?.store("storage.serviceMachineId",u,-1,1),u}e.$Ap=R}),define(ie[51],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class L{constructor(R,N=[],A=!1){this.ctor=R,this.staticArguments=N,this.supportsDelayedInstantiation=A}}e.$3h=L}),define(ie[118],ne([0,1,51]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const D=[];var R;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(R||(e.InstantiationType=R={}));function N(k,u,a){u instanceof L.$3h||(u=new L.$3h(u,[],!!a)),D.push([k,u])}e.$Yr=N;function A(){return D}e.$Zr=A}),define(ie[119],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class L{constructor(N,A){this.key=N,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=L;class D{constructor(N){this.b=N,this.a=new Map}roots(){const N=[];for(const A of this.a.values())A.outgoing.size===0&&N.push(A);return N}insertEdge(N,A){const k=this.lookupOrInsertNode(N),u=this.lookupOrInsertNode(A);k.outgoing.set(u.key,u),u.incoming.set(k.key,k)}removeNode(N){const A=this.b(N);this.a.delete(A);for(const k of this.a.values())k.outgoing.delete(A),k.incoming.delete(A)}lookupOrInsertNode(N){const A=this.b(N);let k=this.a.get(A);return k||(k=new L(A,N),this.a.set(A,k)),k}lookup(N){return this.a.get(this.b(N))}isEmpty(){return this.a.size===0}toString(){const N=[];for(const[A,k]of this.a)N.push(`${A}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return N.join(`
`)}findCycleSlow(){for(const[N,A]of this.a){const k=new Set([N]),u=this.c(A,k);if(u)return u}}c(N,A){for(const[k,u]of N.outgoing){if(A.has(k))return[...A,k].join(" -> ");A.add(k);const a=this.c(u,A);if(a)return a;A.delete(k)}}}e.$Dq=D}),define(ie[29],ne([0,1,3,11,10]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,R.$6h)("configurationService");function N(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof D.URI)}e.$Ai=N;function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof D.URI)}e.$Bi=A;var k;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function u(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=u;function a(l){return l.applicationValue!==void 0||l.userValue!==void 0||l.userLocalValue!==void 0||l.userRemoteValue!==void 0||l.workspaceValue!==void 0||l.workspaceFolderValue!==void 0}e.$Di=a;function v(l,w){const p=Object.create(null);for(const h in l)E(p,h,l[h],w);return p}e.$Ei=v;function E(l,w,p,h){const g=w.split("."),i=g.pop();let r=l;for(let t=0;t<g.length;t++){const n=g[t];let s=r[n];switch(typeof s){case"undefined":s=r[n]=Object.create(null);break;case"object":break;default:h(`Ignoring ${w} as ${g.slice(0,t+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[i]=p}catch{h(`Ignoring ${w} as ${g.join(".")} is ${JSON.stringify(r)}`)}else h(`Ignoring ${w} as ${g.join(".")} is ${JSON.stringify(r)}`)}e.$Fi=E;function m(l,w){const p=w.split(".");f(l,p)}e.$Gi=m;function f(l,w){const p=w.shift();if(w.length===0){delete l[p];return}if(Object.keys(l).indexOf(p)!==-1){const h=l[p];typeof h=="object"&&!Array.isArray(h)&&(f(h,w),Object.keys(h).length===0&&delete l[p])}}function b(l,w,p){function h(r,t){let n=r;for(const s of t){if(typeof n!="object"||n===null)return;n=n[s]}return n}const g=w.split("."),i=h(l,g);return typeof i>"u"?p:i}e.$Hi=b;function S(l,w,p){Object.keys(w).forEach(h=>{h!=="__proto__"&&(h in l?L.$Kf(l[h])&&L.$Kf(w[h])?S(l[h],w[h],p):p&&(l[h]=w[h]):l[h]=w[h])})}e.$Ii=S;function $(l){return l.replace(/[\[\]]/g,"")}e.$Ji=$}),define(ie[120],ne([0,1,12,30,111,10,92,7]),function(J,e,L,D,R,N,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const u=new Map;u.set("false",!1),u.set("true",!0),u.set("isMac",L.$j),u.set("isLinux",L.$k),u.set("isWindows",L.$i),u.set("isWeb",L.$o),u.set("isMacNative",L.$j&&!L.$o),u.set("isEdge",L.$H),u.set("isFirefox",L.$F),u.set("isChrome",L.$E),u.set("isSafari",L.$G);function a(C,d){if(u.get(C)!==void 0)throw(0,k.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");u.set(C,d)}e.$2i=a;const v=Object.prototype.hasOwnProperty;var E;(function(C){C[C.False=0]="False",C[C.True=1]="True",C[C.Defined=2]="Defined",C[C.Not=3]="Not",C[C.Equals=4]="Equals",C[C.NotEquals=5]="NotEquals",C[C.And=6]="And",C[C.Regex=7]="Regex",C[C.NotRegex=8]="NotRegex",C[C.Or=9]="Or",C[C.In=10]="In",C[C.NotIn=11]="NotIn",C[C.Greater=12]="Greater",C[C.GreaterEquals=13]="GreaterEquals",C[C.Smaller=14]="Smaller",C[C.SmallerEquals=15]="SmallerEquals"})(E||(e.ContextKeyExprType=E={}));const m={regexParsingWithErrorRecovery:!0},f=(0,A.localize)(0,null),b=(0,A.localize)(1,null),S=(0,A.localize)(2,null),$=(0,A.localize)(3,null),l=(0,A.localize)(4,null),w=(0,A.localize)(5,null),p=(0,A.localize)(6,null),h=(0,A.localize)(7,null);class g{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=m){this.k=d,this.d=new R.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:b});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const P=this.l();if(!this.E()){const z=this.D(),U=z.type===17?w:void 0;throw this.h.push({message:l,offset:z.offset,lexeme:R.$1i.getLexeme(z),additionalInfo:U}),g.c}return P}catch(P){if(P!==g.c)throw P;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(16);){const P=this.o();d.push(P)}return d.length===1?d[0]:i.or(...d)}o(){const d=[this.s()];for(;this.y(15);){const P=this.s();d.push(P)}return d.length===1?d[0]:i.and(...d)}s(){if(this.y(2)){const d=this.D();switch(d.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const P=this.l();return this.A(1,$),P?.negate()}case 17:return this.z(),H.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const P=this.l();return this.A(1,$),P}case 17:{const P=d.lexeme;if(this.z(),this.y(9)){const U=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),U.type!==10)throw this.B("REGEX",U);const W=U.lexeme,G=W.lastIndexOf("/"),ee=G===W.length-1?void 0:this.w(W.substring(G+1));let ue;try{ue=new RegExp(W.substring(1,G),ee)}catch{throw this.B("REGEX",U)}return ce.create(P,ue)}switch(U.type){case 10:case 19:{const W=[U.lexeme];this.z();let G=this.D(),ee=0;for(let de=0;de<U.lexeme.length;de++)U.lexeme.charCodeAt(de)===40?ee++:U.lexeme.charCodeAt(de)===41&&ee--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let de=0;de<G.lexeme.length;de++)G.lexeme.charCodeAt(de)===40?ee++:U.lexeme.charCodeAt(de)===41&&ee--}if(ee<0)break;W.push(R.$1i.getLexeme(G)),this.z(),G=this.D()}const ue=W.join(""),fe=ue.lastIndexOf("/"),$e=fe===ue.length-1?void 0:this.w(ue.substring(fe+1));let we;try{we=new RegExp(ue.substring(1,fe),$e)}catch{throw this.B("REGEX",U)}return i.regex(P,we)}case 18:{const W=U.lexeme;this.z();let G=null;if(!(0,D.$Je)(W)){const ee=W.indexOf("/"),ue=W.lastIndexOf("/");if(ee!==ue&&ee>=0){const fe=W.slice(ee+1,ue),$e=W[ue+1]==="i"?"i":"";try{G=new RegExp(fe,$e)}catch{throw this.B("REGEX",U)}}}if(G===null)throw this.B("REGEX",U);return ce.create(P,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,S);const U=this.u();return i.notIn(P,U)}switch(this.D().type){case 3:{this.z();const U=this.u();if(this.x().type===18)return i.equals(P,U);switch(U){case"true":return i.has(P);case"false":return i.not(P);default:return i.equals(P,U)}}case 4:{this.z();const U=this.u();if(this.x().type===18)return i.notEquals(P,U);switch(U){case"true":return i.not(P);case"false":return i.has(P);default:return i.notEquals(P,U)}}case 5:return this.z(),re.create(P,this.u());case 6:return this.z(),he.create(P,this.u());case 7:return this.z(),_.create(P,this.u());case 8:return this.z(),oe.create(P,this.u());case 13:return this.z(),i.in(P,this.u());default:return i.has(P)}}case 20:throw this.h.push({message:p,offset:d.offset,lexeme:"",additionalInfo:h}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case 17:case 18:return this.z(),d.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,P){if(this.C(d))return this.z();throw this.B(P,this.D())}B(d,P,z){const U=(0,A.localize)(8,null,d,R.$1i.getLexeme(P)),W=P.offset,G=R.$1i.getLexeme(P);return this.h.push({message:U,offset:W,lexeme:G,additionalInfo:z}),g.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=g;class i{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(d){return c.create(d)}static equals(d,P){return I.create(d,P)}static notEquals(d,P){return j.create(d,P)}static regex(d,P){return ce.create(d,P)}static in(d,P){return O.create(d,P)}static notIn(d,P){return y.create(d,P)}static not(d){return H.create(d)}static and(...d){return Q.create(d,null,!0)}static or(...d){return M.create(d,null,!0)}static greater(d,P){return _.create(d,P)}static greaterEquals(d,P){return oe.create(d,P)}static smaller(d,P){return re.create(d,P)}static smallerEquals(d,P){return he.create(d,P)}static{this.c=new g({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$4i=i;function r(C){const d=new g({regexParsingWithErrorRecovery:!1});return C.map(P=>(d.parse(P),d.lexingErrors.length>0?d.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,A.localize)(9,null,z.additionalInfo):(0,A.localize)(10,null),offset:z.offset,length:z.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}e.$5i=r;function t(C,d){const P=C?C.substituteConstants():void 0,z=d?d.substituteConstants():void 0;return!P&&!z?!0:!P||!z?!1:P.equals(z)}e.$6i=t;function n(C,d){return C.cmp(d)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return o.INSTANCE}}e.$7i=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return s.INSTANCE}}e.$8i=o;class c{static create(d,P=null){const z=u.get(d);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new c(d,P)}constructor(d,P){this.key=d,this.c=P,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:B(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=u.get(this.key);return typeof d=="boolean"?d?o.INSTANCE:s.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=H.create(this.key,this)),this.c}}e.$9i=c;class I{static create(d,P,z=null){if(typeof P=="boolean")return P?c.create(d,z):H.create(d,z);const U=u.get(d);return typeof U=="boolean"?P===(U?"true":"false")?o.INSTANCE:s.INSTANCE:new I(d,P,z)}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=u.get(this.c);if(typeof d=="boolean"){const P=d?"true":"false";return this.d===P?o.INSTANCE:s.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.$0i=I;class O{static create(d,P){return new O(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=10,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:X(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const P=d.getValue(this.f),z=d.getValue(this.d);return Array.isArray(P)?P.includes(z):typeof z=="string"&&typeof P=="object"&&P!==null?v.call(P,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=y.create(this.d,this.f)),this.c}}e.$$i=O;class y{static create(d,P){return new y(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=11,this.c=O.create(d,P)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=y;class j{static create(d,P,z=null){if(typeof P=="boolean")return P?H.create(d,z):c.create(d,z);const U=u.get(d);return typeof U=="boolean"?P===(U?"true":"false")?s.INSTANCE:o.INSTANCE:new j(d,P,z)}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=u.get(this.c);if(typeof d=="boolean"){const P=d?"true":"false";return this.d===P?s.INSTANCE:o.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$aj=j;class H{static create(d,P=null){const z=u.get(d);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new H(d,P)}constructor(d,P){this.c=d,this.d=P,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:B(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=u.get(this.c);return typeof d=="boolean"?d?s.INSTANCE:o.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.$bj=H;function te(C,d){if(typeof C=="string"){const P=parseFloat(C);isNaN(P)||(C=P)}return typeof C=="string"||typeof C=="number"?d(C):s.INSTANCE}class _{static create(d,P,z=null){return te(P,U=>new _(d,U,z))}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=he.create(this.c,this.d,this)),this.f}}e.$cj=_;class oe{static create(d,P,z=null){return te(P,U=>new oe(d,U,z))}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=re.create(this.c,this.d,this)),this.f}}e.$dj=oe;class re{static create(d,P,z=null){return te(P,U=>new re(d,U,z))}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=oe.create(this.c,this.d,this)),this.f}}e.$ej=re;class he{static create(d,P,z=null){return te(P,U=>new he(d,U,z))}constructor(d,P,z){this.c=d,this.d=P,this.f=z,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:X(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.$fj=he;class ce{static create(d,P){return new ce(d,P)}constructor(d,P){this.d=d,this.f=P,this.type=7,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const P=this.f?this.f.source:"",z=d.f?d.f.source:"";return P<z?-1:P>z?1:0}equals(d){if(d.type===this.type){const P=this.f?this.f.source:"",z=d.f?d.f.source:"";return this.d===d.d&&P===z}return!1}substituteConstants(){return this}evaluate(d){const P=d.getValue(this.d);return this.f?this.f.test(P):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ae.create(this)),this.c}}e.$gj=ce;class ae{static create(d){return new ae(d)}constructor(d){this.c=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new ae(this.c.map(d))}negate(){return this.c}}e.$hj=ae;function q(C){let d=null;for(let P=0,z=C.length;P<z;P++){const U=C[P].substituteConstants();if(C[P]!==U&&d===null){d=[];for(let W=0;W<P;W++)d[W]=C[W]}d!==null&&(d[P]=U)}return d===null?C:d}class Q{static create(d,P,z){return Q.d(d,P,z)}constructor(d,P){this.expr=d,this.c=P,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const U=n(this.expr[P],d.expr[P]);if(U!==0)return U}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(d.expr[P]))return!1;return!0}return!1}substituteConstants(){const d=q(this.expr);return d===this.expr?this:Q.create(d,this.c,!1)}evaluate(d){for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].evaluate(d))return!1;return!0}static d(d,P,z){const U=[];let W=!1;for(const G of d)if(G){if(G.type===1){W=!0;continue}if(G.type===0)return s.INSTANCE;if(G.type===6){U.push(...G.expr);continue}U.push(G)}if(U.length===0&&W)return o.INSTANCE;if(U.length!==0){if(U.length===1)return U[0];U.sort(n);for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];for(;U.length>1;){const G=U[U.length-1];if(G.type!==9)break;U.pop();const ee=U.pop(),ue=U.length===0,fe=M.create(G.expr.map($e=>Q.create([$e,ee],null,z)),null,ue);fe&&(U.push(fe),U.sort(n))}if(U.length===1)return U[0];if(z){for(let G=0;G<U.length;G++)for(let ee=G+1;ee<U.length;ee++)if(U[G].negate().equals(U[ee]))return s.INSTANCE;if(U.length===1)return U[0]}return new Q(U,P)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const P of this.expr)d.push(...P.keys());return d}map(d){return new Q(this.expr.map(P=>P.map(d)),null)}negate(){if(!this.c){const d=[];for(const P of this.expr)d.push(P.negate());this.c=M.create(d,this,!0)}return this.c}}e.$ij=Q;class M{static create(d,P,z){return M.d(d,P,z)}constructor(d,P){this.expr=d,this.c=P,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let P=0,z=this.expr.length;P<z;P++){const U=n(this.expr[P],d.expr[P]);if(U!==0)return U}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let P=0,z=this.expr.length;P<z;P++)if(!this.expr[P].equals(d.expr[P]))return!1;return!0}return!1}substituteConstants(){const d=q(this.expr);return d===this.expr?this:M.create(d,this.c,!1)}evaluate(d){for(let P=0,z=this.expr.length;P<z;P++)if(this.expr[P].evaluate(d))return!0;return!1}static d(d,P,z){let U=[],W=!1;if(d){for(let G=0,ee=d.length;G<ee;G++){const ue=d[G];if(ue){if(ue.type===0){W=!0;continue}if(ue.type===1)return o.INSTANCE;if(ue.type===9){U=U.concat(ue.expr);continue}U.push(ue)}}if(U.length===0&&W)return s.INSTANCE;U.sort(n)}if(U.length!==0){if(U.length===1)return U[0];for(let G=1;G<U.length;G++)U[G-1].equals(U[G])&&(U.splice(G,1),G--);if(U.length===1)return U[0];if(z){for(let G=0;G<U.length;G++)for(let ee=G+1;ee<U.length;ee++)if(U[G].negate().equals(U[ee]))return o.INSTANCE;if(U.length===1)return U[0]}return new M(U,P)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const P of this.expr)d.push(...P.keys());return d}map(d){return new M(this.expr.map(P=>P.map(d)),null)}negate(){if(!this.c){const d=[];for(const P of this.expr)d.push(P.negate());for(;d.length>1;){const P=d.shift(),z=d.shift(),U=[];for(const W of F(P))for(const G of F(z))U.push(Q.create([W,G],null,!1));d.unshift(M.create(U,null,!1))}this.c=M.create(d,this,!0)}return this.c}}e.$jj=M;class T extends c{static{this.d=[]}static all(){return T.d.values()}constructor(d,P,z){super(d,null),this.f=P,typeof z=="object"?T.d.push({...z,key:d}):z!==!0&&T.d.push({key:d,description:z,type:P!=null?typeof P:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return I.create(this.key,d)}notEqualsTo(d){return j.create(this.key,d)}}e.$kj=T,e.$lj=(0,N.$6h)("contextKeyService");function B(C,d){return C<d?-1:C>d?1:0}function X(C,d,P,z){return C<P?-1:C>P?1:d<z?-1:d>z?1:0}function Z(C,d){if(C.type===0||d.type===1)return!0;if(C.type===9)return d.type===9?x(C.expr,d.expr):!1;if(d.type===9){for(const P of d.expr)if(Z(C,P))return!0;return!1}if(C.type===6){if(d.type===6)return x(d.expr,C.expr);for(const P of C.expr)if(Z(P,d))return!0;return!1}return C.equals(d)}e.$mj=Z;function x(C,d){let P=0,z=0;for(;P<C.length&&z<d.length;){const U=C[P].cmp(d[z]);if(U<0)return!1;U===0&&P++,z++}return P===C.length}function F(C){return C.type===9?C.expr:[C]}}),define(ie[59],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do=(0,L.$6h)("downloadService")}),define(ie[18],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,L.$6h)("environmentService"),e.$bi=(0,L.$7h)(e.$ai)}),define(ie[21],ne([0,1,95,10]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function R(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=R;function N(p){switch(p){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=N;function A(p,h){switch(p){case 3:return h==="x64"?"win32-x64":h==="arm64"?"win32-arm64":"unknown";case 2:return h==="x64"?"linux-x64":h==="arm64"?"linux-arm64":h==="arm"?"linux-armhf":"unknown";case"alpine":return h==="x64"?"alpine-x64":h==="arm64"?"alpine-arm64":"unknown";case 1:return h==="x64"?"darwin-x64":h==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=A;function k(p,h){return h==="web"&&!p.includes("web")}e.$vo=k;function u(p,h,g){return k(h,g)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===g}e.$wo=u;function a(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}e.$xo=a;var v;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(v||(e.SortBy=v={}));var E;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var m;(function(p){p.Install="install",p.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var f;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$yo=(0,D.$6h)("extensionGalleryService");var b;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.DownloadSignature="DownloadSignature",p.UpdateMetadata="UpdateMetadata",p.Extract="Extract",p.Scanning="Scanning",p.Delete="Delete",p.Rename="Rename",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Signature="Signature",p.NotAllowed="NotAllowed",p.Gallery="Gallery",p.Unknown="Unknown",p.Internal="Internal"})(b||(e.ExtensionManagementErrorCode=b={}));var S;(function(p){p.UnknownError="UnknownError",p.PackageIsInvalidZip="PackageIsInvalidZip",p.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(S||(e.ExtensionSignaturetErrorCode=S={}));class $ extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$zo=$;var l;(function(p){p.Timeout="Timeout",p.Cancelled="Cancelled",p.Failed="Failed"})(l||(e.ExtensionGalleryErrorCode=l={}));class w extends Error{constructor(h,g){super(h),this.code=g,this.name=g}}e.$Ao=w,e.$Bo=(0,D.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,D.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,D.$6h)("IExtensionTipsService"),e.$Go=(0,L.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,L.localize2)(1,"Preferences")}),define(ie[60],ne([0,1,14,7,103,13]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;async function A(v,E,m,f,b,S){let $;try{await k(v,E,m,f,b,S)}catch(l){$=l}finally{$&&b.errorTransformer&&($=b.errorTransformer($)),typeof $<"u"&&m.error($),m.end()}}e.$bq=A;async function k(v,E,m,f,b,S){u(S);const $=await v.open(E,{create:!1});try{u(S);let l=0,w=0,p=b&&typeof b.length=="number"?b.length:void 0,h=L.$je.alloc(Math.min(b.bufferSize,typeof p=="number"?p:b.bufferSize)),g=b&&typeof b.position=="number"?b.position:0,i=0;do w=await v.read($,g,h.buffer,i,h.byteLength-i),g+=w,i+=w,l+=w,typeof p=="number"&&(p-=w),i===h.byteLength&&(await m.write(f(h)),h=L.$je.alloc(Math.min(b.bufferSize,typeof p=="number"?p:b.bufferSize)),i=0);while(w>0&&(typeof p!="number"||p>0)&&u(S)&&a(l,b));if(i>0){let r=i;typeof p=="number"&&(r=Math.min(i,p)),m.write(f(h.slice(0,r)))}}catch(l){throw(0,N.$Ek)(l)}finally{await v.close($)}}function u(v){if(v.isCancellationRequested)throw(0,D.$6)();return!0}function a(v,E){if(typeof E?.limits?.size=="number"&&v>E.limits.size)throw(0,N.$Dk)((0,R.localize)(0,null),N.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ie[121],ne([0,1,6,168,2,12,169]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class k extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new L.$Vd),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$Vd),this.onDidLogMessage=this.b.event,this.onDidError=L.Event.None,this.c=new Map,this.f=!1}async watch(a){const v=this.j(a),E=v.filter(f=>{const b=this.c.get(f.path);return b?!(0,D.$Qj)(b.request.excludes,f.excludes)||!(0,D.$Qj)(b.request.includes,f.includes):!0}),m=Array.from(this.c.values()).filter(({request:f})=>!v.find(b=>b.path===f.path&&(0,D.$Qj)(b.excludes,f.excludes)&&(0,D.$Qj)(b.includes,f.includes))).map(({request:f})=>f.path);E.length&&this.m(`Request to start watching: ${E.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"}, correlationId: ${typeof f.correlationId=="number"?f.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const f of m)this.h(f);for(const f of E)this.g(f)}g(a){const v=new A.$xq(a,m=>this.a.fire(m),m=>this.b.fire(m),this.f),E={request:a,instance:v};this.c.set(a.path,E)}async stop(){for(const[a]of this.c)this.h(a);this.c.clear()}h(a){const v=this.c.get(a);v&&(this.c.delete(a),v.instance.dispose())}j(a){const v=new Map;for(const E of a){const m=N.$k?E.path:E.path.toLowerCase();let f=v.get(E.correlationId);f||(f=new Map,v.set(E.correlationId,f)),f.set(m,E)}return Array.from(v.values()).map(E=>Array.from(E.values())).flat()}async setVerboseLogging(a){this.f=a;for(const[,v]of this.c)v.instance.setVerboseLogging(a)}m(a){this.f&&this.b.fire({type:"trace",message:this.n(a)})}n(a,v){return v?`[File Watcher (node.js)] ${a} (path: ${v.request.path})`:`[File Watcher (node.js)] ${a}`}}e.$zq=k}),define(ie[122],ne([0,1,61,121]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class R extends L.$fq{constructor(A,k,u){super(A,k,u),this.s()}r(A){return A.add(new D.$zq)}}e.$Aq=R}),define(ie[123],ne([0,1,15,57,87,61]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class A extends N.$gq{constructor(u,a,v){super(u,a,v),this.s()}r(u){const a=u.add(new R.$rq(L.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return u.add(a.onDidProcessExit(({code:v,signal:E})=>this.t(`terminated by itself with code ${v}, signal: ${E}`))),D.ProxyChannel.toService((0,D.$Mh)(a.getChannel("watcher")))}}e.$sq=A}),define(ie[62],ne([0,1]),function(J,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class L{constructor(...R){this.a=new Map;for(const[N,A]of R)this.set(N,A)}set(R,N){const A=this.a.get(R);return this.a.set(R,N),A}has(R){return this.a.has(R)}get(R){return this.a.get(R)}}e.$4h=L}),define(ie[124],ne([0,1,9,7,2,51,119,10,62,170]),function(J,e,L,D,R,N,A,k,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const v=!1;class E extends Error{constructor($){super("cyclic dependency between services"),this.message=$.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${$.toString()}`}}class m{constructor($=new u.$4h,l=!1,w,p=v){this.f=$,this.g=l,this.h=w,this.i=p,this.o=new Set,this.f.set(k.$5h,this),this._globalGraph=p?w?._globalGraph??new A.$Dq(h=>h):void 0}createChild($){return new m($,this.g,this,this.i)}invokeFunction($,...l){const w=b.traceInvocation(this.i,$);let p=!1;try{return $({get:g=>{if(p)throw(0,D.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(g,w);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...l)}finally{p=!0,w.stop()}}createInstance($,...l){let w,p;return $ instanceof N.$3h?(w=b.traceCreation(this.i,$.ctor),p=this.j($.ctor,$.staticArguments.concat(l),w)):(w=b.traceCreation(this.i,$),p=this.j($,l,w)),w.stop(),p}j($,l=[],w){const p=k._util.getServiceDependencies($).sort((i,r)=>i.index-r.index),h=[];for(const i of p){const r=this.m(i.id,w);r||this.u(`[createInstance] ${$.name} depends on UNKNOWN service ${i.id}.`,!1),h.push(r)}const g=p.length>0?p[0].index:l.length;if(l.length!==g){console.trace(`[createInstance] First service dependency of ${$.name} at position ${g+1} conflicts with ${l.length} static arguments`);const i=g-l.length;i>0?l=l.concat(new Array(i)):l=l.slice(0,g)}return Reflect.construct($,l.concat(h))}k($,l){if(this.f.get($)instanceof N.$3h)this.f.set($,l);else if(this.h)this.h.k($,l);else throw new Error("illegalState - setting UNKNOWN service instance")}l($){const l=this.f.get($);return!l&&this.h?this.h.l($):l}m($,l){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String($));const w=this.l($);return w instanceof N.$3h?this.q($,w,l.branch($,!0)):(l.branch($,!1),w)}q($,l,w){if(this.o.has($))throw new Error(`illegal state - RECURSIVELY instantiating service '${$}'`);this.o.add($);try{return this.r($,l,w)}finally{this.o.delete($)}}r($,l,w){const p=new A.$Dq(i=>i.id.toString());let h=0;const g=[{id:$,desc:l,_trace:w}];for(;g.length;){const i=g.pop();if(p.lookupOrInsertNode(i),h++>1e3)throw new E(p);for(const r of k._util.getServiceDependencies(i.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${$} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(r.id)),t instanceof N.$3h){const n={id:r.id,desc:t,_trace:i._trace.branch(r.id,!0)};p.insertEdge(i,n),g.push(n)}}}for(;;){const i=p.roots();if(i.length===0){if(!p.isEmpty())throw new E(p);break}for(const{data:r}of i){if(this.l(r.id)instanceof N.$3h){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}p.removeNode(r)}}return this.l($)}s($,l,w=[],p,h){if(this.f.get($)instanceof N.$3h)return this.t($,l,w,p,h);if(this.h)return this.h.s($,l,w,p,h);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}t($,l,w=[],p,h){if(p){const g=new m(void 0,this.g,this,this.i);g.c=String($);const i=new Map,r=new L.$mh(()=>{const t=g.j(l,w,h);for(const[n,s]of i){const o=t[n];if(typeof o=="function")for(const c of s)c.disposable=o.apply(t,c.listener)}return i.clear(),t});return new Proxy(Object.create(null),{get(t,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let c=i.get(n);return c||(c=new a.$4c,i.set(n,c)),(O,y,j)=>{if(r.isInitialized)return r.value[n](O,y,j);{const H={listener:[O,y,j],disposable:void 0},te=c.push(H);return(0,R.$Rc)(()=>{te(),H.disposable?.dispose()})}}}if(n in t)return t[n];const s=r.value;let o=s[n];return typeof o!="function"||(o=o.bind(s),t[n]=o),o},set(t,n,s){return r.value[n]=s,!0},getPrototypeOf(t){return l.prototype}})}else return this.j(l,w,h)}u($,l){if(l&&console.warn($),this.g)throw new Error($)}}e.$Eq=m;var f;(function(S){S[S.None=0]="None",S[S.Creation=1]="Creation",S[S.Invocation=2]="Invocation",S[S.Branch=3]="Branch"})(f||(f={}));class b{static{this.all=new Set}static{this.c=new class extends b{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation($,l){return $?new b(2,l.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):b.c}static traceCreation($,l){return $?new b(1,l.name):b.c}static{this.f=0}constructor($,l){this.type=$,this.name=l,this.g=Date.now(),this.h=[]}branch($,l){const w=new b(3,$.toString());return this.h.push([$,l,w]),w}stop(){const $=Date.now()-this.g;b.f+=$;let l=!1;function w(h,g){const i=[],r=new Array(h+1).join("	");for(const[t,n,s]of g.h)if(n&&s){l=!0,i.push(`${r}CREATES -> ${t}`);const o=w(h+1,s);o&&i.push(o)}else i.push(`${r}uses -> ${t}`);return i.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${$.toFixed(2)}ms (grand total ${b.f.toFixed(2)}ms)`];($>2||l)&&b.all.add(p.join(`
`))}}e.$Fq=b});var se=this&&this.__param||function(J,e){return function(L,D){e(L,D,J)}};define(ie[63],ne([0,1,20,2,12,105,21,10]),function(J,e,L,D,R,N,A,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=void 0;function u(v){return v.tags.find(E=>E.startsWith("lp-"))?.split("lp-")[1]}e.$gr=u,e.$hr=(0,k.$6h)("languagePackService");let a=class extends D.$Tc{constructor(E){super(),this.c=E}async getAvailableLanguages(){const E=new L.$6d;setTimeout(()=>E.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const b=m.firstPage.filter(S=>S.properties.localizedLanguages?.length&&S.tags.some($=>$.startsWith("lp-"))).map(S=>{const $=S.properties.localizedLanguages?.[0],l=u(S);return{...this.f(l,$,S),extensionId:S.identifier.id,galleryExtension:S}});return b.push(this.f("en","English")),b}f(E,m,f){const b=m??E;let S;if(b!==E&&(S=`(${E})`),E.toLowerCase()===R.$w.toLowerCase()&&(S??="",S+=(0,N.localize)(0,null)),f?.installCount){S??="";const $=f.installCount;let l;$>1e6?l=`${Math.floor($/1e5)/10}M`:$>1e3?l=`${Math.floor($/1e3)}K`:l=String($),S+=` $(cloud-download) ${l}`}return{id:E,label:b,description:S}}};e.$ir=a,e.$ir=a=me([se(0,A.$yo)],a)}),define(ie[4],ne([0,1,34,6,43,2,31,12,17,3,11,120,10]),function(J,e,L,D,R,N,A,k,u,a,v,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,m.$6h)("logService"),e.$oj=(0,m.$6h)("loggerService");function f(){return new Date().toISOString()}function b(O){return(0,a.$Mf)(O)}e.$pj=b;var S;(function(O){O[O.Off=0]="Off",O[O.Trace=1]="Trace",O[O.Debug=2]="Debug",O[O.Info=3]="Info",O[O.Warning=4]="Warning",O[O.Error=5]="Error"})(S||(e.LogLevel=S={})),e.$qj=S.Info;function $(O,y,j){switch(y){case S.Trace:O.trace(j);break;case S.Debug:O.debug(j);break;case S.Info:O.info(j);break;case S.Warning:O.warn(j);break;case S.Error:O.error(j);break;case S.Off:break;default:throw new Error(`Invalid log level ${y}`)}}e.log=$;function l(O,y=!1){let j="";for(let H=0;H<O.length;H++){let te=O[H];if(te instanceof Error&&(te=(0,L.$Qi)(te,y)),typeof te=="object")try{te=JSON.stringify(te)}catch{}j+=(H>0?" ":"")+te}return j}class w extends N.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new D.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(y){this.b!==y&&(this.b=y,this.c.fire(this.b))}getLevel(){return this.b}f(y){return this.b!==S.Off&&this.b<=y}}e.$sj=w;class p extends w{constructor(y){super(),this.h=y}f(y){return this.h||super.f(y)}trace(y,...j){this.f(S.Trace)&&this.g(S.Trace,l([y,...j],!0))}debug(y,...j){this.f(S.Debug)&&this.g(S.Debug,l([y,...j]))}info(y,...j){this.f(S.Info)&&this.g(S.Info,l([y,...j]))}warn(y,...j){this.f(S.Warning)&&this.g(S.Warning,l([y,...j]))}error(y,...j){if(this.f(S.Error))if(y instanceof Error){const H=Array.prototype.slice.call(arguments);H[0]=y.stack,this.g(S.Error,l(H))}else this.g(S.Error,l([y,...j]))}flush(){}}e.$tj=p;class h extends w{constructor(y=e.$qj){super(),this.setLevel(y),this.g=!k.$i}trace(y,...j){this.f(S.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,y,...j):console.log(`[main ${f()}]`,y,...j))}debug(y,...j){this.f(S.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,y,...j):console.log(`[main ${f()}]`,y,...j))}info(y,...j){this.f(S.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,y,...j):console.log(`[main ${f()}]`,y,...j))}warn(y,...j){this.f(S.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,y,...j):console.warn(`[main ${f()}]`,y,...j))}error(y,...j){this.f(S.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,y,...j):console.error(`[main ${f()}]`,y,...j))}flush(){}}e.$uj=h;class g extends w{constructor(y=e.$qj,j=!0){super(),this.g=j,this.setLevel(y)}trace(y,...j){this.f(S.Trace)&&(this.g?console.log("%cTRACE","color: #888",y,...j):console.log(y,...j))}debug(y,...j){this.f(S.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",y,...j):console.log(y,...j))}info(y,...j){this.f(S.Info)&&(this.g?console.log("%c INFO","color: #33f",y,...j):console.log(y,...j))}warn(y,...j){this.f(S.Warning)&&(this.g?console.log("%c WARN","color: #993",y,...j):console.log(y,...j))}error(y,...j){this.f(S.Error)&&(this.g?console.log("%c  ERR","color: #f33",y,...j):console.error(y,...j))}flush(){}}e.$vj=g;class i extends w{constructor(y,j=e.$qj){super(),this.g=y,this.setLevel(j)}trace(y,...j){this.f(S.Trace)&&this.g.log(S.Trace,[this.h(y),...j])}debug(y,...j){this.f(S.Debug)&&this.g.log(S.Debug,[this.h(y),...j])}info(y,...j){this.f(S.Info)&&this.g.log(S.Info,[this.h(y),...j])}warn(y,...j){this.f(S.Warning)&&this.g.log(S.Warning,[this.h(y),...j])}error(y,...j){this.f(S.Error)&&this.g.log(S.Error,[this.h(y),...j])}h(y){return typeof y=="string"?y:(0,L.$Qi)(y,this.f(S.Trace))}flush(){}}e.$wj=i;class r extends w{constructor(y){super(),this.g=y,y.length&&this.setLevel(y[0].getLevel())}setLevel(y){for(const j of this.g)j.setLevel(y);super.setLevel(y)}trace(y,...j){for(const H of this.g)H.trace(y,...j)}debug(y,...j){for(const H of this.g)H.debug(y,...j)}info(y,...j){for(const H of this.g)H.info(y,...j)}warn(y,...j){for(const H of this.g)H.warn(y,...j)}error(y,...j){for(const H of this.g)H.error(y,...j)}flush(){for(const y of this.g)y.flush()}dispose(){for(const y of this.g)y.dispose();super.dispose()}}e.$xj=r;class t extends N.$Tc{constructor(y,j,H){if(super(),this.h=y,this.j=j,this.b=new A.$Ac,this.c=this.B(new D.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new D.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new D.$Vd),this.onDidChangeVisibility=this.g.event,H)for(const te of H)this.b.set(te.resource,{logger:void 0,info:te})}m(y){return(0,a.$If)(y)?[...this.b.values()].find(j=>j.info.id===y):this.b.get(y)}getLogger(y){return this.m(y)?.logger}createLogger(y,j){const H=this.n(y),te=(0,a.$If)(y)?y:j?.id??(0,R.$Ti)(H.toString()).toString(16);let _=this.b.get(H)?.logger;const oe=j?.logLevel==="always"?S.Trace:j?.logLevel;_||(_=this.s(H,oe??this.getLogLevel(H)??this.h,{...j,id:te}));const re={logger:_,info:{resource:H,id:te,logLevel:oe,name:j?.name,hidden:j?.hidden,extensionId:j?.extensionId,when:j?.when}};return this.registerLogger(re.info),this.b.set(H,re),_}n(y){return(0,a.$If)(y)?(0,u.$Hg)(this.j,`${y}.log`):y}setLogLevel(y,j){if(v.URI.isUri(y)){const H=y,te=j,_=this.b.get(H);_&&te!==_.info.logLevel&&(_.info.logLevel=te===this.h?void 0:te,_.logger?.setLevel(te),this.b.set(_.info.resource,_),this.f.fire([H,te]))}else{this.h=y;for(const[H,te]of this.b.entries())this.b.get(H)?.info.logLevel===void 0&&te.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(y,j){const H=this.m(y);H&&j!==!H.info.hidden&&(H.info.hidden=!j,this.b.set(H.info.resource,H),this.g.fire([H.info.resource,j]))}getLogLevel(y){let j;return y&&(j=this.b.get(y)?.info.logLevel),j??this.h}registerLogger(y){const j=this.b.get(y.resource);j?j.info.hidden!==y.hidden&&this.setVisibility(y.resource,!y.hidden):(this.b.set(y.resource,{info:y,logger:void 0}),this.c.fire({added:[y],removed:[]}))}deregisterLogger(y){const j=this.b.get(y);j&&(j.logger&&j.logger.dispose(),this.b.delete(y),this.c.fire({added:[],removed:[j.info]}))}*getRegisteredLoggers(){for(const y of this.b.values())yield y.info}getRegisteredLogger(y){return this.b.get(y)?.info}dispose(){this.b.forEach(y=>y.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=t;class n{constructor(){this.onDidChangeLogLevel=new D.$Vd().event}setLevel(y){}getLevel(){return S.Info}trace(y,...j){}debug(y,...j){}info(y,...j){}warn(y,...j){}error(y,...j){}critical(y,...j){}dispose(){}flush(){}}e.$zj=n;class s extends n{}e.$Aj=s;function o(O){if(O.verbose)return S.Trace;if(typeof O.logLevel=="string"){const y=I(O.logLevel.toLowerCase());if(y!==void 0)return y}return e.$qj}e.$Bj=o;function c(O){switch(O){case S.Trace:return"trace";case S.Debug:return"debug";case S.Info:return"info";case S.Warning:return"warn";case S.Error:return"error";case S.Off:return"off"}}e.$Cj=c;function I(O){switch(O){case"trace":return S.Trace;case"debug":return S.Debug;case"info":return S.Info;case"warn":return S.Warning;case"error":return S.Error;case"critical":return S.Error;case"off":return S.Off}}e.$Dj=I,e.$Ej=new E.$kj("logLevel",c(S.Info))}),define(ie[64],ne([0,1,7,10,4]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=void 0,e.$Fp=(0,D.$6h)("IExtensionSignatureVerificationService");let N=class{constructor(k){this.b=k}c(){return this.a||(this.a=new Promise((k,u)=>J(["node-vsce-sign"],async a=>k(a),u))),this.a}async verify(k,u,a){let v;try{v=await this.c()}catch(E){return this.b.error("Could not load vsce-sign module",(0,L.$0)(E)),!1}return v.verify(k,u,a)}};e.$Gp=N,e.$Gp=N=me([se(0,R.$nj)],N)}),define(ie[125],ne([0,1,19,9,7,6,2,16,61,4]),function(J,e,L,D,R,N,A,k,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class v extends A.$Tc{constructor(m,f){super(),this.a=m,this.b=f,this.c=this.B(new N.$Vd),this.onDidChangeFile=this.c.event,this.g=this.B(new N.$Vd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new D.$4g(0)),this.w=[],this.y=this.B(new D.$4g(0))}watch(m,f){return f.recursive||this.b?.watcher?.forceUniversal?this.n(m,f):this.z(m,f)}n(m,f){const b={path:this.H(m),excludes:f.excludes,includes:f.includes,recursive:f.recursive,correlationId:f.correlationId},S=(0,L.$Ub)(this.j,b);return this.r(),(0,A.$Rc)(()=>{S(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,R.$1)(m))}s(){this.h||(this.h=this.B(this.t(f=>this.c.fire((0,u.$hq)(f)),f=>this.G(f),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const f of this.j)(0,u.$dq)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const f of this.j)(0,u.$dq)(f)&&m.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,f){const b={path:this.H(m),excludes:f.excludes,includes:f.includes,recursive:!1,correlationId:f.correlationId},S=(0,L.$Ub)(this.w,b);return this.C(),(0,A.$Rc)(()=>{S(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,R.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,u.$hq)(m)),m=>this.G(m),this.a.getLevel()===a.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===a.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,k.$hc)(m.fsPath)}}e.$lq=v}),define(ie[126],ne([0,1,19,9,14,20,6,43,65,2,48,15,127,17,46,102,13,60,4,7]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w,p){"use strict";var h;Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;let g=class extends a.$Tc{static{h=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new A.$Vd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new A.$Vd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new A.$Vd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new A.$Vd),this.onDidRunOperation=this.r.event,this.X=this.B(new A.$Vd),this.Y=this.B(new A.$Vd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new A.$Vd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new D.$ch)}registerProvider(r,t){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${r}`);const n=new a.$Sc;return this.h.set(r,t),this.c.fire({added:!0,scheme:r,provider:t}),n.add(t.onDidChangeFile(s=>{const o=new $.$Jk(s,!this.S(t));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof t.onDidWatchError=="function"&&n.add(t.onDidWatchError(s=>this.Z.fire(new Error(s)))),n.add(t.onDidChangeCapabilities(()=>this.g.fire({provider:t,scheme:r}))),(0,a.$Rc)(()=>{this.c.fire({added:!1,scheme:r,provider:t}),this.h.delete(r),(0,a.$Oc)(n)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const t=[];this.f.fire({scheme:r,join(n){t.push(n)}}),!this.h.has(r)&&await D.Promises.settled(t)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,t){const n=this.h.get(r.scheme);return!!(n&&n.capabilities&t)}listCapabilities(){return u.Iterable.map(this.h,([r,t])=>({scheme:r,capabilities:t.capabilities}))}async j(r){if(!(0,f.$Lg)(r))throw new $.$Lk((0,S.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const t=this.h.get(r.scheme);if(!t){const n=new p.$bb;throw n.message=(0,S.localize)(1,null,r.toString()),n}return t}async m(r){const t=await this.j(r);if((0,$.$wk)(t)||(0,$.$tk)(t)||(0,$.$xk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const t=await this.j(r);if((0,$.$wk)(t)||(0,$.$tk)(t))return t;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,t){try{return await this.s(r,t)}catch(n){throw(0,$.$Gk)(n)===$.FileSystemProviderErrorCode.FileNotFound?new $.$Lk((0,S.localize)(2,null,this.sb(r)),1):(0,$.$Ek)(n)}}async s(r,t){const n=await this.j(r),s=this.S(n),o=t?.resolveTo,c=t?.resolveSingleChildDescendants,I=t?.resolveMetadata,O=await n.stat(r);let y;return this.t(n,r,O,void 0,!!I,(j,H)=>(y||(y=v.$_h.forUris(()=>!s),y.set(r,!0),o&&y.fill(!0,o)),y.get(j.resource)||y.findSuperstr(j.resource.with({query:null,fragment:null}))?!0:j.isDirectory&&c?H===1:!1))}async t(r,t,n,s,o,c){const{providerExtUri:I}=this.R(r),O={resource:t,name:I.basename(t),isFile:(n.type&$.FileType.File)!==0,isDirectory:(n.type&$.FileType.Directory)!==0,isSymbolicLink:(n.type&$.FileType.SymbolicLink)!==0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:!!((n.permissions??0)&$.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((n.permissions??0)&$.FilePermission.Locked),etag:(0,$.$Wk)({mtime:n.mtime,size:n.size}),children:void 0};if(O.isDirectory&&c(O,s)){try{const y=await r.readdir(t),j=await D.Promises.settled(y.map(async([H,te])=>{try{const _=I.joinPath(t,H),oe=o?await r.stat(_):{type:te};return await this.t(r,_,oe,y.length,o,c)}catch(_){return this.b.trace(_),null}}));O.children=(0,L.$Hb)(j)}catch(y){this.b.trace(y),O.children=[]}return O}return O}async resolveAll(r){return D.Promises.settled(r.map(async t=>{try{return{stat:await this.s(t.resource,t.options),success:!0}}catch(n){return this.b.trace(n),{stat:void 0,success:!1}}}))}async stat(r){const t=await this.j(r),n=await t.stat(r);return this.t(t,r,n,void 0,!0,()=>!1)}async exists(r){const t=await this.j(r);try{return!!await t.stat(r)}catch{return!1}}async canCreateFile(r,t){try{await this.u(r,t)}catch(n){return n}return!0}async u(r,t){if(!t?.overwrite&&await this.exists(r))throw new $.$Lk((0,S.localize)(3,null,this.sb(r)),3,t)}async createFile(r,t=R.$je.fromString(""),n){await this.u(r,n);const s=await this.writeFile(r,t);return this.r.fire(new $.$Ik(r,0,s)),s}async writeFile(r,t,n){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let c=n;if((0,$.$zk)(s)&&!c?.atomic){const I=s.enforceAtomicWriteFile?.(r);I&&(c={...n,atomic:I})}try{await this.w(s,r,c)||await this.U(s,o.dirname(r));let O;if((0,$.$tk)(s)&&!(t instanceof R.$je))if((0,b.$8d)(t)){const y=await(0,b.$ce)(t,3);y.ended?O=R.$je.concat(y.buffer):O=y}else O=(0,b.$_d)(t,y=>R.$je.concat(y),3);else O=t;!(0,$.$wk)(s)||(0,$.$tk)(s)&&O instanceof R.$je||(0,$.$tk)(s)&&(0,$.$zk)(s)&&c?.atomic?await this.hb(s,r,c,O):await this.db(s,r,c,O instanceof R.$je?(0,R.$ue)(O):O),this.r.fire(new $.$Ik(r,4))}catch(I){throw new $.$Lk((0,S.localize)(4,null,this.sb(r),(0,$.$Ek)(I).toString()),(0,$.$Hk)(I),c)}return this.resolve(r,{resolveMetadata:!0})}async w(r,t,n){const s=!!n?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,S.localize)(5,null,this.sb(t)));if(!!n?.atomic){if(!(r.capabilities&32768))throw new Error((0,S.localize)(6,null,this.sb(t)));if(!(r.capabilities&2))throw new Error((0,S.localize)(7,null,this.sb(t)));if(s)throw new Error((0,S.localize)(8,null,this.sb(t)))}let c;try{c=await r.stat(t)}catch{return}if(c.type&$.FileType.Directory)throw new $.$Lk((0,S.localize)(9,null,this.sb(t)),0,n);if(this.rb(t,c),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==$.$Vk&&typeof c.mtime=="number"&&typeof c.size=="number"&&n.mtime<c.mtime&&n.etag!==(0,$.$Wk)({mtime:n.mtime,size:c.size}))throw new $.$Lk((0,S.localize)(10,null),3,n);return c}async readFile(r,t,n){const s=await this.m(r);return t?.atomic?this.z(s,r,t,n):this.C(s,r,t,n)}async z(r,t,n,s){return new Promise((o,c)=>{this.cb.queueFor(t,async()=>{try{const I=await this.C(r,t,n,s);o(I)}catch(I){c(I)}},this.R(r).providerExtUri)})}async C(r,t,n,s){const o=await this.D(r,t,{...n,preferUnbuffered:!0},s);return{...o,value:await(0,R.$ve)(o.value)}}async readFileStream(r,t,n){const s=await this.m(r);return this.D(s,r,t,n)}async D(r,t,n,s){const o=new N.$6d(s);let c=n;(0,$.$yk)(r)&&r.enforceAtomicReadFile?.(t)&&(c={...n,atomic:!0});const I=this.J(t,c).then(y=>y,y=>{throw o.dispose(!0),y});let O;try{return typeof c?.etag=="string"&&c.etag!==$.$Vk&&await I,c?.atomic&&(0,$.$yk)(r)||!((0,$.$wk)(r)||(0,$.$xk)(r))||(0,$.$tk)(r)&&c?.preferUnbuffered?O=this.I(r,t,c):(0,$.$xk)(r)?O=this.G(r,t,o.token,c):O=this.H(r,t,o.token,c),O.on("end",()=>o.dispose()),O.on("error",()=>o.dispose()),{...await I,value:O}}catch(y){throw O&&await(0,b.$ae)(O),this.F(y,t,c)}}F(r,t,n){const s=(0,S.localize)(11,null,this.sb(t),(0,$.$Ek)(r).toString());return r instanceof $.$Nk?new $.$Nk(s,r.stat,n):r instanceof $.$Mk?new $.$Mk(s,r.fileOperationResult,r.size,r.options):new $.$Lk(s,(0,$.$Hk)(r),n)}G(r,t,n,s=Object.create(null)){const o=r.readFileStream(t,s,n);return(0,b.$ge)(o,{data:c=>c instanceof R.$je?c:R.$je.wrap(c),error:c=>this.F(c,t,s)},c=>R.$je.concat(c))}H(r,t,n,s=Object.create(null)){const o=(0,R.$ze)();return(0,l.$bq)(r,t,o,c=>c,{...s,bufferSize:this.a,errorTransformer:c=>this.F(c,t,s)},n),o}I(r,t,n){const s=(0,b.$0d)(o=>R.$je.concat(o));return(async()=>{try{let o;n?.atomic&&(0,$.$yk)(r)?o=await r.readFile(t,{atomic:!0}):o=await r.readFile(t),typeof n?.position=="number"&&(o=o.slice(n.position)),typeof n?.length=="number"&&(o=o.slice(0,n.length)),this.L(t,o.byteLength,n),s.end(R.$je.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,t){const n=await this.resolve(r,{resolveMetadata:!0});if(n.isDirectory)throw new $.$Lk((0,S.localize)(12,null,this.sb(r)),0,t);if(typeof t?.etag=="string"&&t.etag!==$.$Vk&&t.etag===n.etag)throw new $.$Nk((0,S.localize)(13,null),n,t);return this.L(r,n.size,t),n}L(r,t,n){if(typeof n?.limits?.size=="number"&&t>n.limits.size)throw new $.$Mk((0,S.localize)(14,null,this.sb(r)),7,t,n)}async canMove(r,t,n){return this.M(r,t,"move",n)}async canCopy(r,t,n){return this.M(r,t,"copy",n)}async M(r,t,n,s){if(r.toString()!==t.toString())try{const o=n==="move"?this.qb(await this.n(r),r):await this.m(r),c=this.qb(await this.n(t),t);await this.Q(o,r,c,t,n,s)}catch(o){return o}return!0}async move(r,t,n){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(t),t),c=await this.N(s,r,o,t,"move",!!n),I=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$Ik(r,c==="move"?2:3,I)),I}async copy(r,t,n){const s=await this.m(r),o=this.qb(await this.n(t),t),c=await this.N(s,r,o,t,"copy",!!n),I=await this.resolve(t,{resolveMetadata:!0});return this.r.fire(new $.$Ik(r,c==="copy"?3:2,I)),I}async N(r,t,n,s,o,c){if(t.toString()===s.toString())return o;const{exists:I,isSameResourceWithDifferentPathCase:O}=await this.Q(r,t,n,s,o,c);if(I&&!O&&c&&await this.del(s,{recursive:!0}),await this.U(n,this.R(n).providerExtUri.dirname(s)),o==="copy"){if(r===n&&(0,$.$uk)(r))await r.copy(t,s,{overwrite:c});else{const y=await this.resolve(t);y.isDirectory?await this.P(r,y,n,s):await this.O(r,t,n,s)}return o}else return r===n?(await r.rename(t,s,{overwrite:c}),o):(await this.N(r,t,n,s,"copy",c),await this.del(t,{recursive:!0}),"copy")}async O(r,t,n,s){if((0,$.$wk)(r)&&(0,$.$wk)(n))return this.jb(r,t,n,s);if((0,$.$wk)(r)&&(0,$.$tk)(n))return this.pb(r,t,n,s);if((0,$.$tk)(r)&&(0,$.$wk)(n))return this.nb(r,t,n,s);if((0,$.$tk)(r)&&(0,$.$tk)(n))return this.lb(r,t,n,s)}async P(r,t,n,s){await n.mkdir(s),Array.isArray(t.children)&&await D.Promises.settled(t.children.map(async o=>{const c=this.R(n).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),n,c):this.O(r,o.resource,n,c)}))}async Q(r,t,n,s,o,c){let I=!1;if(r===n){const{providerExtUri:y,isPathCaseSensitive:j}=this.R(r);if(j||(I=y.isEqual(t,s)),I&&o==="copy")throw new Error((0,S.localize)(15,null,this.sb(t),this.sb(s)));if(!I&&y.isEqualOrParent(s,t))throw new Error((0,S.localize)(16,null,this.sb(t),this.sb(s)))}const O=await this.exists(s);if(O&&!I){if(!c)throw new $.$Lk((0,S.localize)(17,null,this.sb(t),this.sb(s)),4);if(r===n){const{providerExtUri:y}=this.R(r);if(y.isEqualOrParent(t,s))throw new Error((0,S.localize)(18,null,this.sb(t),this.sb(s)))}}return{exists:O,isSameResourceWithDifferentPathCase:I}}R(r){const t=this.S(r);return{providerExtUri:t?f.$xg:f.$zg,isPathCaseSensitive:t}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const t=this.qb(await this.j(r),r);await this.U(t,r);const n=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new $.$Ik(r,0,n)),n}async U(r,t){const n=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(t,s.dirname(t));)try{if(!((await r.stat(t)).type&$.FileType.Directory))throw new Error((0,S.localize)(19,null,this.sb(t)));break}catch(o){if((0,$.$Gk)(o)!==$.FileSystemProviderErrorCode.FileNotFound)throw o;n.push(s.basename(t)),t=s.dirname(t)}for(let o=n.length-1;o>=0;o--){t=s.joinPath(t,n[o]);try{await r.mkdir(t)}catch(c){if((0,$.$Gk)(c)!==$.FileSystemProviderErrorCode.FileExists)throw c}}}async canDelete(r,t){try{await this.W(r,t)}catch(n){return n}return!0}async W(r,t){const n=this.qb(await this.j(r),r),s=!!t?.useTrash;if(s&&!(n.capabilities&4096))throw new Error((0,S.localize)(20,null,this.sb(r)));const o=t?.atomic;if(o&&!(n.capabilities&65536))throw new Error((0,S.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,S.localize)(22,null,this.sb(r)));let c;try{c=await n.stat(r)}catch{}if(c)this.rb(r,c);else throw new $.$Lk((0,S.localize)(23,null,this.sb(r)),1);if(!!!t?.recursive){const O=await this.resolve(r);if(O.isDirectory&&Array.isArray(O.children)&&O.children.length>0)throw new Error((0,S.localize)(24,null,this.sb(r)))}return n}async del(r,t){const n=await this.W(r,t);let s=t;if((0,$.$Ak)(n)&&!s?.atomic){const O=n.enforceAtomicDelete?.(r);O&&(s={...t,atomic:O})}const o=!!s?.useTrash,c=!!s?.recursive,I=s?.atomic??!1;await n.delete(r,{recursive:c,useTrash:o,atomic:I}),this.r.fire(new $.$Ik(r,1))}async cloneFile(r,t){const n=await this.j(r),s=this.qb(await this.n(t),t);if(!(n===s&&this.R(n).providerExtUri.isEqual(r,t)))return n===s&&(0,$.$vk)(n)?n.cloneFile(r,t):(await this.U(s,this.R(s).providerExtUri.dirname(t)),n===s&&(0,$.$uk)(n)?this.cb.queueFor(r,()=>n.copy(r,t,{overwrite:!0}),this.R(n).providerExtUri):this.cb.queueFor(r,()=>this.O(n,r,s,t),this.R(n).providerExtUri))}static{this.ab=0}createWatcher(r,t){return this.watch(r,{...t,correlationId:h.ab++})}watch(r,t={recursive:!1,excludes:[]}){const n=new a.$Sc;let s=!1,o=()=>{s=!0};n.add((0,a.$Rc)(()=>o())),(async()=>{try{const I=await this.bb(r,t);s?(0,a.$Oc)(I):o=()=>(0,a.$Oc)(I)}catch(I){this.b.error(I)}})();const c=t.correlationId;if(typeof c=="number"){const I=n.add(new A.$Vd);return n.add(this.X.event(y=>{y.correlates(c)&&I.fire(y)})),{onDidChange:I.event,dispose:()=>n.dispose()}}return n}async bb(r,t){const n=await this.j(r),s=(0,k.$Ti)([this.R(n).providerExtUri.getComparisonKey(r),t]);let o=this.$.get(s);return o||(o={count:0,disposable:n.watch(r,t)},this.$.set(s,o)),o.count+=1,(0,a.$Rc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Oc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Oc)(r.disposable);this.$.clear()}async db(r,t,n,s){return this.cb.queueFor(t,async()=>{const o=await r.open(t,{create:!0,unlock:n?.unlock??!1});try{(0,b.$8d)(s)||(0,b.$9d)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(c){throw(0,$.$Ek)(c)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,t,n){let s=0,o;if((0,b.$9d)(n)){if(n.buffer.length>0){const c=R.$je.concat(n.buffer);await this.gb(r,t,c,c.byteLength,s,0),s+=c.byteLength}if(n.ended)return;o=n.stream}else o=n;return new Promise((c,I)=>{(0,b.$be)(o,{onData:async O=>{o.pause();try{await this.gb(r,t,O,O.byteLength,s,0)}catch(y){return I(y)}s+=O.byteLength,setTimeout(()=>o.resume())},onError:O=>I(O),onEnd:()=>c()})})}async fb(r,t,n){let s=0,o;for(;(o=n.read())!==null;)await this.gb(r,t,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,t,n,s,o,c){let I=0;for(;I<s;){const O=await r.write(t,o+I,n.buffer,c+I,s-I);I+=O}}async hb(r,t,n,s){return this.cb.queueFor(t,()=>this.ib(r,t,n,s),this.R(r).providerExtUri)}async ib(r,t,n,s){let o;s instanceof R.$je?o=s:(0,b.$8d)(s)?o=await(0,R.$ve)(s):(0,b.$9d)(s)?o=await(0,R.$we)(s):o=(0,R.$te)(s),await r.writeFile(t,o.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1,atomic:n?.atomic??!1})}async jb(r,t,n,s){return this.cb.queueFor(s,()=>this.kb(r,t,n,s),this.R(n).providerExtUri)}async kb(r,t,n,s){let o,c;try{o=await r.open(t,{create:!1}),c=await n.open(s,{create:!0,unlock:!1});const I=R.$je.alloc(this.a);let O=0,y=0,j=0;do j=await r.read(o,O,I.buffer,y,I.byteLength-y),await this.gb(n,c,I,j,O,y),O+=j,y+=j,y===I.byteLength&&(y=0);while(j>0)}catch(I){throw(0,$.$Ek)(I)}finally{await D.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof c=="number"?n.close(c):Promise.resolve()])}}async lb(r,t,n,s){return this.cb.queueFor(s,()=>this.mb(r,t,n,s),this.R(n).providerExtUri)}async mb(r,t,n,s){return n.writeFile(s,await r.readFile(t),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,t,n,s){return this.cb.queueFor(s,()=>this.ob(r,t,n,s),this.R(n).providerExtUri)}async ob(r,t,n,s){const o=await n.open(s,{create:!0,unlock:!1});try{const c=await r.readFile(t);await this.gb(n,o,R.$je.wrap(c),c.byteLength,0,0)}catch(c){throw(0,$.$Ek)(c)}finally{await n.close(o)}}async pb(r,t,n,s){const o=await(0,R.$ve)(this.H(r,t,N.CancellationToken.None));await this.hb(n,s,void 0,o)}qb(r,t){if(r.capabilities&2048)throw new $.$Lk((0,S.localize)(25,null,this.sb(t)),6);return r}rb(r,t){if((t.permissions??0)&$.FilePermission.Readonly)throw new $.$Lk((0,S.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===E.Schemas.file?r.fsPath:r.toString(!0)}};e.$cq=g,e.$cq=g=h=me([se(0,w.$nj)],g)}),define(ie[128],ne([0,1,90,171,9,31,14,6,172,2,16,12,17,46,24,104,13,60,125,34,123,122]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0,(()=>{try{(0,D.gracefulify)(L)}catch(r){console.error(`Error enabling graceful-fs: ${(0,p.$Qi)(r)}`)}})();class i extends w.$lq{static{this.I=!1}constructor(t,n){super(t,n),this.onDidChangeCapabilities=k.Event.None,this.N=new N.$Ac(s=>m.$yg.getComparisonKey(s)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,E.$k&&(this.J|=1024)),this.J}async stat(t){try{const{stat:n,symbolicLink:s}=await b.SymlinkSupport.stat(this.H(t));return{type:this.M(n,s),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size,permissions:n.mode&128?void 0:$.FilePermission.Locked}}catch(n){throw this.fb(n)}}async L(t){try{return await this.stat(t)}catch{return}}async readdir(t){try{const n=await b.Promises.readdir(this.H(t),{withFileTypes:!0}),s=[];return await Promise.all(n.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,m.$Hg)(t,o.name))).type:c=this.M(o),s.push([o.name,c])}catch(c){this.a.trace(c)}})),s}catch(n){throw this.fb(n)}}M(t,n){let s;return n?.dangling?s=$.FileType.Unknown:t.isFile()?s=$.FileType.File:t.isDirectory()?s=$.FileType.Directory:s=$.FileType.Unknown,n&&(s|=$.FileType.SymbolicLink),s}async O(t){const n=this.H(t);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let s;for(;s=this.N.get(t);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await s.wait();const o=new R.$5g;return this.N.set(t,o),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,a.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.N.get(t)===o&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.N.delete(t)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),o.open()})}async readFile(t,n){let s;try{n?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(t)})`),s=await this.O(t));const o=this.H(t);return await b.Promises.readFile(o)}catch(o){throw this.fb(o)}finally{s?.dispose()}}P(t){i.I&&this.a.trace(t)}readFileStream(t,n,s){const o=(0,f.$0d)(c=>A.$je.concat(c.map(I=>A.$je.wrap(I))).buffer);return(0,l.$bq)(this,t,o,c=>c.buffer,{...n,bufferSize:256*1024},s),o}async writeFile(t,n,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.Q(t)?this.R(t,(0,m.$Hg)((0,m.$Gg)(t),`${(0,m.$Eg)(t)}${s.atomic.postfix}`),n,s):this.S(t,n,s)}async Q(t){try{const n=this.H(t),{symbolicLink:s}=await b.SymlinkSupport.stat(n);if(s)return!1}catch{}return!0}async R(t,n,s,o){const c=new a.$Sc;try{c.add(await this.O(t)),c.add(await this.O(n)),await this.S(n,s,o,!0);try{await this.rename(n,t,{overwrite:!0})}catch(I){try{await this.delete(n,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{c.dispose()}}async S(t,n,s,o){let c;try{const I=this.H(t);if(!s.create||!s.overwrite){if(await b.Promises.exists(I)){if(!s.overwrite)throw(0,$.$Dk)((0,S.localize)(0,null),$.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,$.$Dk)((0,S.localize)(1,null),$.FileSystemProviderErrorCode.FileNotFound)}c=await this.open(t,{create:!0,unlock:s.unlock},o),await this.write(c,0,n,0,n.byteLength)}catch(I){throw await this.gb(t,I)}finally{typeof c=="number"&&await this.close(c)}}static{this.Y=!0}static configureFlushOnWrite(t){i.Y=t}async open(t,n,s){const o=this.H(t);let c;(0,$.$rk)(n)&&!s&&(c=await this.O(t));let I;try{if((0,$.$rk)(n)&&n.unlock)try{const{stat:y}=await b.SymlinkSupport.stat(o);y.mode&128||await b.Promises.chmod(o,y.mode|128)}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}let O;if((0,$.$rk)(n)){if(E.$i)try{await b.Promises.truncate(o,0),O="r+"}catch(y){y.code!=="ENOENT"&&this.a.trace(y)}O||(O="w")}else O="r";I=await b.Promises.open(o,O)}catch(O){throw c?.dispose(),(0,$.$rk)(n)?await this.gb(t,O):this.fb(O)}if(this.U.set(I,0),(0,$.$rk)(n)&&this.X.set(I,t),c){const O=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${o})`),this.W.set(I,c),O&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${o})`),O.dispose())}return I}async close(t){const n=this.W.get(t);try{if(this.U.delete(t),this.X.delete(t)&&i.Y)try{await b.Promises.fdatasync(t)}catch(s){i.configureFlushOnWrite(!1),this.a.error(s)}return await b.Promises.close(t)}catch(s){throw this.fb(s)}finally{n&&(this.W.get(t)===n&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.W.delete(t)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),n.dispose())}}async read(t,n,s,o,c){const I=this.Z(t,n);let O=null;try{O=(await b.Promises.read(t,s,o,c,I)).bytesRead}catch(y){throw this.fb(y)}finally{this.$(t,I,O)}return O}Z(t,n){return n===this.U.get(t)?null:n}$(t,n,s){const o=this.U.get(t);typeof o=="number"&&(typeof n=="number"||(typeof s=="number"?this.U.set(t,o+s):this.U.delete(t)))}async write(t,n,s,o,c){return(0,R.$nh)(()=>this.ab(t,n,s,o,c),100,3)}async ab(t,n,s,o,c){const I=this.Z(t,n);let O=null;try{O=(await b.Promises.write(t,s,o,c,I)).bytesWritten}catch(y){throw await this.gb(this.X.get(t),y)}finally{this.$(t,I,O)}return O}async mkdir(t){try{await b.Promises.mkdir(this.H(t))}catch(n){throw this.fb(n)}}async delete(t,n){try{const s=this.H(t);if(n.recursive){let o;n?.atomic!==!1&&n.atomic.postfix&&(o=(0,v.$jc)((0,v.$mc)(s),`${(0,v.$nc)(s)}${n.atomic.postfix}`)),await b.Promises.rm(s,b.RimRafMode.MOVE,o)}else try{await b.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let c=!1;try{const{stat:I,symbolicLink:O}=await b.SymlinkSupport.stat(s);c=I.isDirectory()&&!O}catch{}if(c)await b.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.fb(s)}}async rename(t,n,s){const o=this.H(t),c=this.H(n);if(o!==c)try{await this.bb(t,n,"move",s.overwrite),await b.Promises.rename(o,c)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,S.localize)(2,null,(0,v.$nc)(o),(0,v.$nc)((0,v.$mc)(c)),I.toString()))),this.fb(I)}}async copy(t,n,s){const o=this.H(t),c=this.H(n);if(o!==c)try{await this.bb(t,n,"copy",s.overwrite),await b.Promises.copy(o,c,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,S.localize)(3,null,(0,v.$nc)(o),(0,v.$nc)((0,v.$mc)(c)),I.toString()))),this.fb(I)}}async bb(t,n,s,o){const c=this.H(t),I=this.H(n);let O=!1;if(!!(this.capabilities&1024)||(O=(0,u.$7f)(c,I,!0)),O){if(s==="copy")throw(0,$.$Dk)((0,S.localize)(4,null),$.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const j=await this.L(t);if(!j)throw(0,$.$Dk)((0,S.localize)(5,null),$.FileSystemProviderErrorCode.FileNotFound);const H=await this.L(n);if(H){if(!o)throw(0,$.$Dk)((0,S.localize)(6,null),$.FileSystemProviderErrorCode.FileExists);j.type&$.FileType.File&&H.type&$.FileType.File||await this.delete(n,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(t,n){return this.cb(t,n,!1)}async cb(t,n,s){const o=this.H(t),c=this.H(n),I=!!(this.capabilities&1024);if((0,u.$7f)(o,c,!I))return;const O=new a.$Sc;try{O.add(await this.O(t)),O.add(await this.O(n)),s&&await b.Promises.mkdir((0,v.$mc)(c),{recursive:!0}),await b.Promises.copyFile(o,c)}catch(y){if(y.code==="ENOENT"&&!s)return this.cb(t,n,!0);throw this.fb(y)}finally{O.dispose()}}t(t,n,s){return new h.$sq(o=>t(o),o=>n(o),s)}F(t,n,s){return new g.$Aq(o=>t(o),o=>n(o),s)}fb(t){if(t instanceof $.$Ck)return t;let n=t,s;switch(t.code){case"ENOENT":s=$.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=$.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=$.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=$.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=$.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=$.FileSystemProviderErrorCode.Unknown;break;default:s=$.FileSystemProviderErrorCode.Unknown}return(0,$.$Dk)(n,s)}async gb(t,n){let s=this.fb(n);if(t&&s.code===$.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await b.SymlinkSupport.stat(this.H(t));o.mode&128||(s=(0,$.$Dk)(n,$.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$Bq=i}),define(ie[129],ne([0,1,2,4]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=void 0;class R extends L.$Tc{constructor(A,k=[]){super(),this.a=new D.$xj([A,...k]),this.B(A.onDidChangeLogLevel(u=>this.setLevel(u)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...k){this.a.trace(A,...k)}debug(A,...k){this.a.debug(A,...k)}info(A,...k){this.a.info(A,...k)}warn(A,...k){this.a.warn(A,...k)}error(A,...k){this.a.error(A,...k)}flush(){this.a.flush()}}e.$CO=R}),define(ie[130],ne([0,1,13,4]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=void 0;var R;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(R||(R={}));async function N(a,v,E,m,f){try{const b=await new Promise(($,l)=>{J(["@vscode/spdlog"],$,l)});b.setFlushOn(R.Trace);const S=await b.createAsyncRotatingLogger(a,v,E,m);return f?S.clearFormatters():S.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),S}catch(b){console.error(b)}return null}function A(a,v,E){switch(v){case D.LogLevel.Trace:a.trace(E);break;case D.LogLevel.Debug:a.debug(E);break;case D.LogLevel.Info:a.info(E);break;case D.LogLevel.Warning:a.warn(E);break;case D.LogLevel.Error:a.error(E);break;case D.LogLevel.Off:break;default:throw new Error(`Invalid log level ${v}`)}}function k(a,v){switch(v){case D.LogLevel.Trace:a.setLevel(R.Trace);break;case D.LogLevel.Debug:a.setLevel(R.Debug);break;case D.LogLevel.Info:a.setLevel(R.Info);break;case D.LogLevel.Warning:a.setLevel(R.Warning);break;case D.LogLevel.Error:a.setLevel(R.Error);break;case D.LogLevel.Off:a.setLevel(R.Off);break;default:throw new Error(`Invalid log level ${v}`)}}class u extends D.$tj{constructor(v,E,m,f,b){super(),this.m=[],this.setLevel(b),this.n=this.s(v,E,m,f),this.B(this.onDidChangeLogLevel(S=>{this.r&&k(this.r,S)}))}async s(v,E,m,f){const b=m?6:1,S=30/b*L.$Yk.MB,$=await N(v,E,S,b,f);if($){this.r=$,k(this.r,this.getLevel());for(const{level:l,message:w}of this.m)A(this.r,l,w);this.m=[]}}g(v,E){this.r?A(this.r,v,E):this.getLevel()<=v&&this.m.push({level:v,message:E})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$rO=u}),define(ie[131],ne([0,1,28,4,130]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=void 0;class N extends D.$yj{s(k,u,a){return new R.$rO((0,L.$qg)(),k.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,u)}}e.$sO=N}),define(ie[39],ne([0,1,6,65,2,10]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=void 0,e.$Jn=(0,N.$6h)("policy");class A extends R.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new L.$Vd),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const v=Object.keys(this.f).length;return this.f={...a,...this.f},v!==Object.keys(this.f).length&&await this.j(a),D.Iterable.reduce(this.g.entries(),(E,[m,f])=>({...E,[m]:f}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return D.Iterable.reduce(Object.entries(this.f),(a,[v,E])=>({...a,[v]:{definition:E,value:this.g.get(v)}}),{})}}e.$Kn=A;class k{constructor(){this.onDidChange=L.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Ln=k}),define(ie[132],ne([0,1,9,6,65,3,13,4,39]),function(J,e,L,D,R,N,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$I_b=void 0;function a(E,m){const f=[];for(const b of new Set(R.Iterable.concat(E.keys(),m.keys())))E.get(b)!==m.get(b)&&f.push(b);return f}let v=class extends u.$Kn{constructor(m,f,b){super(),this.m=m,this.n=f,this.s=b,this.c=this.B(new L.$4g(500));const S=D.Event.filter(f.onDidFilesChange,$=>$.affects(m));this.B(f.watch(m)),this.B(S(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const m=new Map;try{const f=await this.n.readFile(this.m),b=JSON.parse(f.value.toString());if(!(0,N.$Kf)(b))throw new Error("Policy file isn't a JSON object");for(const S of Object.keys(b))this.f[S]&&m.set(S,b[S])}catch(f){f.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",f)}return m}async w(){const m=await this.u(),f=a(this.g,m);this.g=m,f.length>0&&this.h.fire(f)}};e.$I_b=v,e.$I_b=v=me([se(1,A.$qk),se(2,k.$nj)],v)}),define(ie[133],ne([0,1,39,9,2,4]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$H_b=void 0;let A=class extends L.$Kn{constructor(u,a){super(),this.m=u,this.n=a,this.a=new D.$Zg,this.b=this.B(new R.$Uc)}async j(u){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(u).length} policy definitions`);const{createWatcher:a}=await new Promise((v,E)=>{J(["@vscode/policy-watcher"],v,E)});await this.a.queue(()=>new Promise((v,E)=>{try{this.b.value=a(this.n,u,m=>{this.t(m),v()})}catch(m){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",m),E(m)}}))}t(u){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(u)}`);for(const a in u){const v=u[a];v===void 0?this.g.delete(a):this.g.set(a,v)}this.h.fire(Object.keys(u))}};e.$H_b=A,e.$H_b=A=me([se(0,N.$nj)],A)}),define(ie[32],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,L.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"}),define(ie[36],ne([0,1,71,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class R{constructor(){this.a=new Map}add(A,k){L.ok(D.$If(A)),L.ok(D.$Kf(k)),L.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,k)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$Hn=new R}),define(ie[134],ne([0,1,6,36]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function R(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class N{constructor(){this.b=new L.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(u,a){this.a[R(u)]=a,this.b.fire(u)}notifySchemaChanged(u){this.b.fire(u)}getSchemaContributions(){return{schemas:this.a}}}const A=new N;D.$Hn.add(e.$In.JSONContribution,A)}),define(ie[40],ne([0,1,19,6,3,91,29,134,36]),function(J,e,L,D,R,N,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var a;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$Mn={Configuration:"base.contributions.configuration"};var v;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(v||(e.ConfigurationScope=v={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const E=u.$Hn.as(k.$In.JSONContribution);class m{constructor(){this.h=new Set,this.i=new D.$Vd,this.onDidSchemaChange=this.i.event,this.j=new D.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:N.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},E.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(i,r=!0){this.registerConfigurations([i],r)}registerConfigurations(i,r=!0){const t=new Set;this.n(i,r,t),E.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(i){const r=new Set;this.o(i,r),E.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:i,remove:r}){const t=new Set;this.o(r,t),this.n(i,!1,t),E.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(i){const r=new Set;this.k(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(i,r){const t=[];for(const{overrides:n,source:s}of i)for(const o in n)if(r.add(o),e.$Wn.test(o)){const c=this.a.get(o),I=c?.valuesSources??new Map;if(s)for(const H of Object.keys(n[o]))I.set(H,s);const O={...c?.value||{},...n[o]};this.a.set(o,{source:s,value:O,valuesSources:I});const y=(0,A.$Ji)(o),j={type:"object",default:O,description:N.localize(1,null,y),$ref:e.$Tn,defaultDefaultValue:O,source:R.$If(s)?void 0:s,defaultValueSource:s};t.push(...S(o)),this.d[o]=j,this.b.properties[o]=j}else{this.a.set(o,{value:n[o],source:s});const c=this.d[o];c&&(this.w(o,c),this.r(o,c))}this.m(t)}deregisterDefaultConfigurations(i){const r=new Set;this.l(i,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(i,r){for(const{overrides:t,source:n}of i)for(const s in t){const o=this.a.get(s),c=R.$If(n)?n:n?.id,I=R.$If(o?.source)?o?.source:o?.source?.id;if(c===I)if(r.add(s),this.a.delete(s),e.$Wn.test(s))delete this.d[s],delete this.b.properties[s];else{const O=this.d[s];O&&(this.w(s,O),this.r(s,O))}}this.u()}deltaConfiguration(i){let r=!1;const t=new Set;i.removedDefaults&&(this.l(i.removedDefaults,t),r=!0),i.addedDefaults&&(this.k(i.addedDefaults,t),r=!0),i.removedConfigurations&&this.o(i.removedConfigurations,t),i.addedConfigurations&&this.n(i.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const r of i)this.h.add(r);this.u()}n(i,r,t){i.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,t),this.c.push(n),this.q(n)})}o(i,r){const t=n=>{if(n.properties)for(const s in n.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,n.properties[s])}n.allOf?.forEach(s=>t(s))};for(const n of i){t(n);const s=this.c.indexOf(n);s!==-1&&this.c.splice(s,1)}}p(i,r=!0,t,n,s=3,o){s=R.$Rf(i.scope)?s:i.scope;const c=i.properties;if(c)for(const O in c){const y=c[O];if(r&&p(O,y)){delete c[O];continue}if(y.source=t,y.defaultDefaultValue=c[O].default,this.w(O,y),e.$Wn.test(O)?y.scope=void 0:(y.scope=R.$Rf(y.scope)?s:y.scope,y.restricted=R.$Rf(y.restricted)?!!n?.includes(O):y.restricted),c[O].hasOwnProperty("included")&&!c[O].included){this.f[O]=c[O],delete c[O];continue}else this.d[O]=c[O],c[O].policy?.name&&this.e.set(c[O].policy.name,O);!c[O].deprecationMessage&&c[O].markdownDeprecationMessage&&(c[O].deprecationMessage=c[O].markdownDeprecationMessage),o.add(O)}const I=i.allOf;if(I)for(const O of I)this.p(O,r,t,n,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const r=t=>{const n=t.properties;if(n)for(const o in n)this.r(o,n[o]);t.allOf?.forEach(r)};r(i)}r(i,r){switch(e.$Nn.properties[i]=r,r.scope){case 1:e.$On.properties[i]=r;break;case 2:e.$Pn.properties[i]=r;break;case 6:e.$Qn.properties[i]=r;break;case 3:e.$Rn.properties[i]=r;break;case 4:e.$Sn.properties[i]=r;break;case 5:e.$Sn.properties[i]=r,this.g.properties[i]=r;break}}s(i,r){switch(delete e.$Nn.properties[i],r.scope){case 1:delete e.$On.properties[i];break;case 2:delete e.$Pn.properties[i];break;case 6:delete e.$Qn.properties[i];break;case 3:delete e.$Rn.properties[i];break;case 4:case 5:delete e.$Sn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const r=`[${i}]`,t={type:"object",description:N.localize(2,null),errorMessage:N.localize(3,null),$ref:e.$Tn};this.w(r,t),e.$Nn.properties[r]=t,e.$On.properties[r]=t,e.$Pn.properties[r]=t,e.$Qn.properties[r]=t,e.$Rn.properties[r]=t,e.$Sn.properties[r]=t}}v(){const i={type:"object",description:N.localize(4,null),errorMessage:N.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=i,e.$On.patternProperties[e.$Vn]=i,e.$Pn.patternProperties[e.$Vn]=i,e.$Qn.patternProperties[e.$Vn]=i,e.$Rn.patternProperties[e.$Vn]=i,e.$Sn.patternProperties[e.$Vn]=i,this.i.fire()}w(i,r){const t=this.a.get(i);let n=t?.value,s=t?.source;R.$Pf(n)&&(n=r.defaultDefaultValue,s=void 0),R.$Pf(n)&&(n=l(r.type)),r.default=n,r.defaultValueSource=s}}const f="\\[([^\\]]+)\\]",b=new RegExp(f,"g");e.$Vn=`^(${f})+$`,e.$Wn=new RegExp(e.$Vn);function S(g){const i=[];if(e.$Wn.test(g)){let r=b.exec(g);for(;r?.length;){const t=r[1].trim();t&&i.push(t),r=b.exec(g)}}return(0,L.$Mb)(i)}e.$Xn=S;function $(g){return g.reduce((i,r)=>`${i}[${r}]`,"")}e.$Yn=$;function l(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=l;const w=new m;u.$Hn.add(e.$Mn.Configuration,w);function p(g,i){return g.trim()?e.$Wn.test(g)?N.localize(7,null,g):w.getConfigurationProperties()[g]!==void 0?N.localize(8,null,g):i.policy?.name&&w.getPolicyConfigurations().get(i.policy?.name)!==void 0?N.localize(9,null,g,i.policy?.name,w.getPolicyConfigurations().get(i.policy?.name)):null:N.localize(6,null)}e.$1n=p;function h(){const g=[],i=w.getConfigurationProperties();for(const r of Object.keys(i))g.push([r,i[r].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.$2n=h}),define(ie[66],ne([0,1,19,6,38,2,31,27,3,11,29,40,36]),function(J,e,L,D,R,N,A,k,u,a,v,E,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function f(r){return Object.isFrozen(r)?r:k.$wn(r)}class b{constructor(t={},n=[],s=[],o){this.b=t,this.c=n,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(n=>{if(n instanceof b)return n;const s=new S("");return s.parseRaw(n),s.configurationModel});this.f=t.reduce((n,s)=>s===n?s:n.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,v.$Hi)(this.contents,t):this.contents}inspect(t,n){const s=this.rawConfiguration.getValue(t),o=n?this.rawConfiguration.getOverrideValue(t,n):void 0,c=n?this.rawConfiguration.override(n).getValue(t):s;return{value:s,override:o,merged:c}}getOverrideValue(t,n){const s=this.i(n);return s?t?(0,v.$Hi)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const n=[];for(const s of this.overrides)s.identifiers.includes(t)&&n.push(...s.keys);return L.$Mb(n)}getAllOverrideIdentifiers(){const t=[];for(const n of this.overrides)t.push(...n.identifiers);return L.$Mb(t)}override(t){let n=this.a.get(t);return n||(n=this.g(t),this.a.set(t,n)),n}merge(...t){const n=k.$vn(this.contents),s=k.$vn(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const I of t)if(c.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(n,I.contents);for(const O of I.overrides){const[y]=s.filter(j=>L.$ub(j.identifiers,O.identifiers));y?(this.h(y.contents,O.contents),y.keys.push(...O.keys),y.keys=L.$Mb(y.keys)):s.push(k.$vn(O))}for(const O of I.keys)o.indexOf(O)===-1&&o.push(O)}return new b(n,o,s,c.every(I=>I instanceof b)?void 0:c)}g(t){const n=this.i(t);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const s={};for(const o of L.$Mb([...Object.keys(this.contents),...Object.keys(n)])){let c=this.contents[o];const I=n[o];I&&(typeof c=="object"&&typeof I=="object"?(c=k.$vn(c),this.h(c,I)):c=I),s[o]=c}return new b(s,this.keys,this.overrides)}h(t,n){for(const s of Object.keys(n)){if(s in t&&u.$Kf(t[s])&&u.$Kf(n[s])){this.h(t[s],n[s]);continue}t[s]=k.$vn(n[s])}}i(t){let n=null,s=null;const o=c=>{c&&(s?this.h(s,c):s=k.$vn(c))};for(const c of this.overrides)c.identifiers.length===1&&c.identifiers[0]===t?n=c.contents:c.identifiers.includes(t)&&o(c.contents);return o(n),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,n){this.j(t,n,!0)}setValue(t,n){this.j(t,n,!1)}removeValue(t){const n=this.keys.indexOf(t);n!==-1&&(this.keys.splice(n,1),(0,v.$Gi)(this.contents,t),E.$Wn.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>L.$ub(s.identifiers,(0,E.$Xn)(t))),1))}j(t,n,s){(0,v.$Fi)(this.contents,t,n,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),E.$Wn.test(t)&&this.overrides.push({identifiers:(0,E.$Xn)(t),keys:Object.keys(this.contents[t]),contents:(0,v.$Ei)(this.contents[t],o=>console.error(o))})}}e.$3n=b;class S{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new b}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,n){if(!u.$Rf(t)){const s=this.g(t);this.parseRaw(s,n)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,n){this.a=t;const{contents:s,keys:o,overrides:c,restricted:I,hasExcludedProperties:O}=this.h(t,n);this.b=new b(s,o,c,O?[t]:void 0),this.c=I||[]}g(t){let n={},s=null,o=[];const c=[],I=[];function O(j){Array.isArray(o)?o.push(j):s!==null&&(o[s]=j)}const y={onObjectBegin:()=>{const j={};O(j),c.push(o),o=j,s=null},onObjectProperty:j=>{s=j},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const j=[];O(j),c.push(o),o=j,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:O,onError:(j,H,te)=>{I.push({error:j,offset:H,length:te})}};if(t)try{R.$jn(t,y),n=o[0]||{}}catch(j){console.error(`Error while parsing settings file ${this.f}: ${j}`),this.d=[j]}return n}h(t,n){const s=m.$Hn.as(E.$Mn.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,n);t=o.raw;const c=(0,v.$Ei)(t,y=>console.error(`Conflict in settings file ${this.f}: ${y}`)),I=Object.keys(t),O=this.j(t,y=>console.error(`Conflict in settings file ${this.f}: ${y}`));return{contents:c,keys:I,overrides:O,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,n,s,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:t,restricted:[],hasExcludedProperties:c};const I={},O=[];for(const y in t)if(E.$Wn.test(y)&&s){const j=this.i(t[y],n,!1,o);I[y]=j.raw,c=c||j.hasExcludedProperties,O.push(...j.restricted)}else{const j=n[y],H=j?typeof j.scope<"u"?j.scope:3:void 0;j?.restricted&&O.push(y),!o.exclude?.includes(y)&&(o.include?.includes(y)||(H===void 0||o.scopes===void 0||o.scopes.includes(H))&&!(o.skipRestricted&&j?.restricted))?I[y]=t[y]:c=!0}return{raw:I,restricted:O,hasExcludedProperties:c}}j(t,n){const s=[];for(const o of Object.keys(t))if(E.$Wn.test(o)){const c={};for(const I in t[o])c[I]=t[o][I];s.push({identifiers:(0,E.$Xn)(o),keys:Object.keys(c),contents:(0,v.$Ei)(c,n)})}return s}}e.$4n=S;class $ extends N.$Tc{constructor(t,n,s,o){super(),this.c=t,this.f=n,this.g=o,this.b=this.B(new D.$Vd),this.onDidChange=this.b.event,this.a=new S(this.c.toString()),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(D.Event.any(D.Event.filter(this.g.onDidFilesChange,c=>c.contains(this.c)),D.Event.filter(this.g.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,t)))(()=>this.b.fire()))}async loadConfiguration(){try{const t=await this.g.readFile(this.c);return this.a.parse(t.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new b}}reparse(t){return t&&(this.f=t),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=$;class l{constructor(t,n,s,o,c,I,O,y,j,H,te,_,oe){this.a=t,this.b=n,this.c=s,this.overrideIdentifiers=o,this.d=c,this.f=I,this.g=O,this.h=y,this.i=j,this.j=H,this.k=te,this.l=_,this.m=oe}get value(){return f(this.c)}n(t,n,s){const o=t.inspect(n,s);return{get value(){return f(o.value)},get override(){return f(o.override)},get merged(){return f(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class w{constructor(t,n,s,o,c=new b,I=new b,O=new A.$Ac,y=new b,j=new A.$Ac){this.c=t,this.d=n,this.f=s,this.g=o,this.h=c,this.i=I,this.j=O,this.l=y,this.m=j,this.a=null,this.b=new A.$Ac,this.n=null}getValue(t,n,s){return this.p(t,n,s).getValue(t)}updateValue(t,n,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new b,this.m.set(s.resource,o))):o=this.l,n===void 0?o.removeValue(t):o.setValue(t,n),s.resource||(this.a=null)}inspect(t,n,s){const o=this.p(t,n,s),c=this.t(n.resource,s),I=n.resource?this.m.get(n.resource)||this.l:this.l,O=new Set;for(const y of o.overrides)for(const j of y.identifiers)o.getOverrideValue(t,j)!==void 0&&O.add(j);return new l(t,n,o.getValue(t),O.size?[...O]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,c||void 0,I)}keys(t){const n=this.t(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,n){this.j.set(t,n),this.b.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,n){const s=[];if(!n){const{added:o,updated:c,removed:I}=g(this.c,t);n=[...o,...c,...I]}for(const o of n)for(const c of(0,E.$Xn)(o)){const I=this.c.getKeysForOverrideIdentifier(c),O=t.getKeysForOverrideIdentifier(c),y=[...O.filter(j=>I.indexOf(j)===-1),...I.filter(j=>O.indexOf(j)===-1),...I.filter(j=>!k.$zn(this.c.override(c).getValue(j),t.override(c).getValue(j)))];s.push([c,y])}return this.updateDefaultConfiguration(t),{keys:n,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:n,updated:s,removed:o}=g(this.d,t),c=[...n,...s,...o];return c.length&&this.updatePolicyConfiguration(t),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:n,updated:s,removed:o,overrides:c}=g(this.applicationConfiguration,t),I=[...n,...s,...o];return I.length&&this.updateApplicationConfiguration(t),{keys:I,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:c}=g(this.localUserConfiguration,t),I=[...n,...s,...o];return I.length&&this.updateLocalUserConfiguration(t),{keys:I,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:n,updated:s,removed:o,overrides:c}=g(this.remoteUserConfiguration,t),I=[...n,...s,...o];return I.length&&this.updateRemoteUserConfiguration(t),{keys:I,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:n,updated:s,removed:o,overrides:c}=g(this.workspaceConfiguration,t),I=[...n,...s,...o];return I.length&&this.updateWorkspaceConfiguration(t),{keys:I,overrides:c}}compareAndUpdateFolderConfiguration(t,n){const s=this.folderConfigurations.get(t),{added:o,updated:c,removed:I,overrides:O}=g(s,n),y=[...o,...c,...I];return(y.length||!s)&&this.updateFolderConfiguration(t,n),{keys:y,overrides:O}}compareAndDeleteFolderConfiguration(t){const n=this.folderConfigurations.get(t);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:c,overrides:I}=g(n,void 0);return{keys:[...s,...o,...c],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(t,n,s){let o=this.q(n,s);return n.overrideIdentifier&&(o=o.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}q({resource:t},n){let s=this.r();if(n&&t){const o=n.getFolder(t);o&&(s=this.s(o.uri)||s);const c=this.m.get(t);c&&(s=s.merge(c))}return s}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(t){let n=this.b.get(t);if(!n){const s=this.r(),o=this.j.get(t);o?(n=s.merge(o),this.b.set(t,n)):n=s}return n}t(t,n){if(n&&t){const s=n.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,n)=>{const{contents:s,overrides:o,keys:c}=this.j.get(n);return t.push([n,{contents:s,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(n=>t.add(n)),this.userConfiguration.keys.forEach(n=>t.add(n)),this.i.keys.forEach(n=>t.add(n)),this.j.forEach(n=>n.keys.forEach(s=>t.add(s))),[...t.values()]}u(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>t.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}v(t){const n=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>n.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>n.add(o))),[...n.values()]}static parse(t){const n=this.w(t.defaults),s=this.w(t.policy),o=this.w(t.application),c=this.w(t.user),I=this.w(t.workspace),O=t.folders.reduce((y,j)=>(y.set(a.URI.revive(j[0]),this.w(j[1])),y),new A.$Ac);return new w(n,s,o,c,new b,I,O,new b,new A.$Ac)}static w(t){return new b(t.contents,t.keys,t.overrides)}}e.$6n=w;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,n=new Map;for(const o of r)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,I])=>{const O=(0,A.$xc)(n,c,new Set);I.forEach(y=>O.add(y))});const s=[];return n.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.$7n=p;class h{constructor(t,n,s,o){this.change=t,this.f=n,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of t.keys)this.affectedKeys.add(c);for(const[,c]of t.overrides)for(const I of c)this.affectedKeys.add(I);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=w.parse(this.f.data)),this.i}affectsConfiguration(t,n){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const c=o+s.length;if(c>=this.d.length)return!1;const I=this.d.charCodeAt(c);if(I!==this.b&&I!==this.c)return!1;if(n){const O=this.previousConfiguration?this.previousConfiguration.getValue(t,n,this.f?.workspace):void 0,y=this.g.getValue(t,n,this.h);return!k.$zn(O,y)}return!0}}e.$8n=h;function g(r,t){const{added:n,removed:s,updated:o}=i(t?.rawConfiguration,r?.rawConfiguration),c=[],I=r?.getAllOverrideIdentifiers()||[],O=t?.getAllOverrideIdentifiers()||[];if(t){const y=O.filter(j=>!I.includes(j));for(const j of y)c.push([j,t.getKeysForOverrideIdentifier(j)])}if(r){const y=I.filter(j=>!O.includes(j));for(const j of y)c.push([j,r.getKeysForOverrideIdentifier(j)])}if(t&&r){for(const y of I)if(O.includes(y)){const j=i({contents:r.getOverrideValue(void 0,y)||{},keys:r.getKeysForOverrideIdentifier(y)},{contents:t.getOverrideValue(void 0,y)||{},keys:t.getKeysForOverrideIdentifier(y)});c.push([y,[...j.added,...j.removed,...j.updated]])}}return{added:n,removed:s,updated:o,overrides:c}}function i(r,t){const n=r?t?r.keys.filter(c=>t.keys.indexOf(c)===-1):[...r.keys]:[],s=t?r?t.keys.filter(c=>r.keys.indexOf(c)===-1):[...t.keys]:[],o=[];if(r&&t){for(const c of t.keys)if(r.keys.indexOf(c)!==-1){const I=(0,v.$Hi)(t.contents,c),O=(0,v.$Hi)(r.contents,c);k.$zn(I,O)||o.push(c)}}return{added:n,removed:s,updated:o}}}),define(ie[135],ne([0,1,19,6,2,27,3,66,40,4,39,36]),function(J,e,L,D,R,N,A,k,u,a,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=void 0;class m extends R.$Tc{constructor(){super(...arguments),this.a=this.B(new D.$Vd),this.onDidChangeConfiguration=this.a.event,this.b=new k.$3n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(E.$Hn.as(u.$Mn.Configuration).onDidUpdateConfiguration(({properties:$,defaultsOverrides:l})=>this.c(Array.from($),l))),this.configurationModel}reload(){return this.g(),this.configurationModel}c($,l){this.h($,E.$Hn.as(u.$Mn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:$})}f(){return{}}g(){this.b=new k.$3n;const $=E.$Hn.as(u.$Mn.Configuration).getConfigurationProperties();this.h(Object.keys($),$)}h($,l){const w=this.f();for(const p of $){const h=w[p],g=l[p];h!==void 0?this.b.addValue(p,h):g?this.b.addValue(p,g.default):this.b.removeValue(p)}}}e.$9n=m;class f{constructor(){this.onDidChangeConfiguration=D.Event.None,this.configurationModel=new k.$3n}async initialize(){return this.configurationModel}}e.$0n=f;let b=class extends R.$Tc{get configurationModel(){return this.b}constructor($,l,w){super(),this.c=$,this.f=l,this.g=w,this.a=this.B(new D.$Vd),this.onDidChangeConfiguration=this.a.event,this.b=new k.$3n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange($=>this.j($))),this.B(this.c.onDidChangeConfiguration(async({properties:$})=>this.m(await this.h($),!0))),this.b}async h($){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",$);const l={},w=[],p=E.$Hn.as(u.$Mn.Configuration).getConfigurationProperties();for(const h of $){const g=p[h];if(!g){w.push(h);continue}if(g.policy){if(g.type!=="string"&&g.type!=="number"){this.g.warn(`Policy ${g.policy.name} has unsupported type ${g.type}`);continue}w.push(h),l[g.policy.name]={type:g.type}}}return(0,A.$Vf)(l)||await this.f.updatePolicyDefinitions(l),w}j($){this.g.trace("PolicyConfiguration#onDidChangePolicies",$);const l=E.$Hn.as(u.$Mn.Configuration).getPolicyConfigurations(),w=(0,L.$Hb)($.map(p=>l.get(p)));this.m(w,!0)}m($,l){this.g.trace("PolicyConfiguration#update",$);const w=E.$Hn.as(u.$Mn.Configuration).getConfigurationProperties(),p=[],h=this.b.isEmpty();for(const g of $){const i=w[g]?.policy?.name;if(i){const r=this.f.getPolicyValue(i);(h?r!==void 0:!(0,N.$zn)(this.b.getValue(g),r))&&p.push([g,r])}else this.b.getValue(g)!==void 0&&p.push([g,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const g=this.b;this.b=new k.$3n;for(const i of g.keys)this.b.setValue(i,g.getValue(i));for(const[i,r]of p)r===void 0?this.b.removeValue(i):this.b.setValue(i,r);l&&this.a.fire(this.b)}}};e.$$n=b,e.$$n=b=me([se(1,v.$Jn),se(2,a.$nj)],b)}),define(ie[136],ne([0,1,19,9,14,6,38,73,2,27,12,17,29,66,40,135,39]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=void 0;class l extends u.$Tc{constructor(h,g,i,r){super(),this.m=h,this.h=this.B(new N.$Vd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new S.$9n),this.c=i instanceof $.$Ln?new S.$0n:this.B(new S.$$n(this.b,i,r)),this.f=this.B(new f.$5n(this.m,{},E.$yg,g)),this.a=new f.$6n(this.b.configurationModel,this.c.configurationModel,new f.$3n,new f.$3n),this.j=new w(h,g,this),this.g=this.B(new D.$fh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:n})=>this.r(t,n))),this.B(this.c.onDidChangeConfiguration(t=>this.s(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[h,g,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new f.$6n(h,g,new f.$3n,i)}getConfigurationData(){return this.a.toData()}getValue(h,g){const i=typeof h=="string"?h:void 0,r=(0,m.$Ai)(h)?h:(0,m.$Ai)(g)?g:{};return this.a.getValue(i,r,void 0)}async updateValue(h,g,i,r,t){const n=(0,m.$Bi)(i)?i:(0,m.$Ai)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,s=n?r:i;if(s!==void 0&&s!==3&&s!==2)throw new Error(`Unable to write ${h} to target ${s}.`);n?.overrideIdentifiers&&(n.overrideIdentifiers=(0,L.$Mb)(n.overrideIdentifiers),n.overrideIdentifiers=n.overrideIdentifiers.length?n.overrideIdentifiers:void 0);const o=this.inspect(h,{resource:n?.resource,overrideIdentifier:n?.overrideIdentifiers?n.overrideIdentifiers[0]:void 0});if(o.policyValue!==void 0)throw new Error(`Unable to write ${h} because it is configured in system policy.`);if((0,a.$zn)(g,o.defaultValue)&&(g=void 0),n?.overrideIdentifiers?.length&&n.overrideIdentifiers.length>1){const I=n.overrideIdentifiers.sort(),O=this.a.localUserConfiguration.overrides.find(y=>(0,L.$ub)([...y.identifiers].sort(),I));O&&(n.overrideIdentifiers=O.identifiers)}const c=n?.overrideIdentifiers?.length?[(0,b.$Yn)(n.overrideIdentifiers),h]:[h];await this.j.write(c,g),await this.reloadConfiguration()}inspect(h,g={}){return this.a.inspect(h,g,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const h=await this.f.loadConfiguration();this.n(h)}n(h){const g=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(h);this.t(i,g,2)}r(h,g){const i=this.a.toData(),r=this.a.compareAndUpdateDefaultConfiguration(h,g);this.t(r,i,7)}s(h){const g=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(h);this.t(i,g,7)}t(h,g,i){const r=new f.$8n(h,{data:g},this.a);r.source=i,this.h.fire(r)}}e.$_n=l;class w{constructor(h,g,i){this.b=h,this.c=g,this.d=i,this.a=new D.$ah}write(h,g){return this.a.queue(()=>this.e(h,g))}async e(h,g){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(n){if(n.fileOperationResult===1)i="{}";else throw n}const r=[];if((0,A.$cn)(i,r,{allowTrailingComma:!0,allowEmptyContent:!0}),r.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(i,h,g);i=(0,k.$un)(i,t),await this.c.writeFile(this.b,R.$je.fromString(i))}f(h,g,i){const{tabSize:r,insertSpaces:t,eol:n}=this.h;if(!g.length){const s=JSON.stringify(i,null,t?" ".repeat(r):"	");return[{content:s,length:s.length,offset:0}]}return(0,k.$rn)(h,g,i,{tabSize:r,insertSpaces:t,eol:n})}get h(){if(!this.g){let h=v.OS===3||v.OS===2?`
`:`\r
`;const g=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});g&&typeof g=="string"&&g!=="auto"&&(h=g),this.g={eol:h,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(ie[67],ne([0,1,15]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function D(a){return a.scheme===L.Schemas.vscodeRemote?a.authority:void 0}e.$al=D;function R(a){if(!a)return;const v=a.indexOf("+");return v<0?a:a.substr(0,v)}e.$bl=R;function N(a){return`/${a.quality??"oss"}-${a.commit??"dev"}`}e.$cl=N;function A(a){const{host:v,port:E}=u(a);if(typeof E>"u")throw new Error(`Invalid remote authority: ${a}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:v,port:E}}e.$dl=A;function k(a,v){let{host:E,port:m}=u(a);return typeof m>"u"&&(m=v),{host:E,port:m}}e.$el=k;function u(a){const v=a.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(v)return{host:v[1],port:parseInt(v[2],10)};const E=a.match(/^(\[[0-9a-z:]+\])$/);if(E)return{host:E[1],port:void 0};const m=a.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:a,port:void 0}}}),define(ie[37],ne([0,1,30,10,67]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function N(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.$jm=N,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(A||(e.ExtensionType=A={}));var k;(function(S){S.WIN32_X64="win32-x64",S.WIN32_ARM64="win32-arm64",S.LINUX_X64="linux-x64",S.LINUX_ARM64="linux-arm64",S.LINUX_ARMHF="linux-armhf",S.ALPINE_X64="alpine-x64",S.ALPINE_ARM64="alpine-arm64",S.DARWIN_X64="darwin-x64",S.DARWIN_ARM64="darwin-arm64",S.WEB="web",S.UNIVERSAL="universal",S.UNKNOWN="unknown",S.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class u{constructor($){this.value=$,this._lower=$.toLowerCase()}static equals($,l){if(typeof $>"u"||$===null)return typeof l>"u"||l===null;if(typeof l>"u"||l===null)return!1;if(typeof $=="string"||typeof l=="string"){const w=typeof $=="string"?$:$.value,p=typeof l=="string"?l:l.value;return L.$_e(w,p)}return $._lower===l._lower}static toKey($){return typeof $=="string"?$.toLowerCase():$._lower}}e.$lm=u;class a{get size(){return this.c.size}constructor($){if(this.c=new Set,$)for(const l of $)this.add(l)}add($){this.c.add(u.toKey($))}delete($){return this.c.delete(u.toKey($))}has($){return this.c.has(u.toKey($))}}e.$mm=a;class v{constructor(){this.c=new Map}clear(){this.c.clear()}delete($){this.c.delete(u.toKey($))}get($){return this.c.get(u.toKey($))}has($){return this.c.has(u.toKey($))}set($,l){this.c.set(u.toKey($),l)}values(){return this.c.values()}forEach($){this.c.forEach($)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=v;function E(S){return m(S)}e.$om=E;function m(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.$pm=m;function f(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.$qm=f;function b(S,$){if($){const l=`onResolveRemoteAuthority:${(0,R.$bl)($)}`;return!!S.activationEvents?.includes(l)}return!1}e.$rm=b,e.$sm=(0,D.$6h)("IBuiltinExtensionsScannerService")}),define(ie[137],ne([0,1,2,37,13]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class N extends L.$Tc{constructor(k,u,a,v,E){super(),this.a=k,this.b=u,this.c=a,this.f=E,this.B(v.onDidInstallExtensions(m=>this.g(m))),this.B(v.onDidUninstallExtension(m=>this.h(m)))}g(k){for(const u of k)u.local&&this.invalidate(u.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const u of this.a.profiles)this.c.extUri.isEqual(u.extensionsResource,k)&&await this.j(u);else await this.j(this.a.defaultProfile)}async j(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,D.$fm))}catch(u){(0,R.$Hk)(u)!==1&&this.f.error(u)}}}e.$8p=N}),define(ie[45],ne([0,1,14,7,2,106,40,10,4,36]),function(J,e,L,D,R,N,A,k,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=void 0,e.$hp=(0,k.$6h)("requestService");class v{constructor(g){this.b=g}toJSON(){if(!this.a){const g=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?g[i]="*****":g[i]=this.b[i];this.a=g}return this.a}}class E extends R.$Tc{constructor(g){super(),this.b=0,this.a=g.createLogger("network",{name:(0,N.localize)(0,null),when:u.$Ej.isEqualTo((0,u.$Cj)(u.LogLevel.Trace)).serialize()})}async c(g,i,r){const t=`${g} #${++this.b}: ${i.url}`;this.a.trace(`${t} - begin`,i.type,new v(i.headers??{}));try{const n=await r();return this.a.trace(`${t} - end`,i.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${t} - error`,i.type,(0,D.$0)(n)),n}}}e.$ip=E;function m(h){return h.res.statusCode&&h.res.statusCode>=200&&h.res.statusCode<300||h.res.statusCode===1223}e.$jp=m;function f(h){return h.res.statusCode===204}e.$kp=f;async function b(h){return f(h)?null:(await(0,L.$ve)(h.stream)).toString()}e.$lp=b;async function S(h){if(!m(h))throw new Error("Server returned "+h.res.statusCode);return b(h)}e.$mp=S;async function $(h){if(!m(h))throw new Error("Server returned "+h.res.statusCode);if(f(h))return null;const i=(await(0,L.$ve)(h.stream)).toString();try{return JSON.parse(i)}catch(r){throw r.message+=`:
`+i,r}}e.$np=$;function l(h){p(h)}e.$op=l;let w;function p(h){const g=a.$Hn.as(A.$Mn.Configuration),i=w;w={id:"http",order:15,title:(0,N.localize)(1,null),type:"object",scope:h,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,N.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,N.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,N.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,N.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,N.localize)(6,null),(0,N.localize)(7,null),(0,N.localize)(8,null),(0,N.localize)(9,null)],default:"override",description:(0,N.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,N.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,N.localize)(12,null),restricted:!0}}},g.updateConfigurations({add:[w],remove:i?[i]:[]})}p(1)}),define(ie[138],ne([0,1,20,15,13,45]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=void 0;let A=class{constructor(u,a){this.a=u,this.b=a}async download(u,a,v=L.CancellationToken.None){if(u.scheme===D.Schemas.file||u.scheme===D.Schemas.vscodeRemote){await this.b.copy(u,a);return}const E={type:"GET",url:u.toString(!0)},m=await this.a.request(E,v);if(m.res.statusCode===200)await this.b.writeFile(a,m.stream);else{const f=await(0,N.$mp)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${f}`)}}};e.$RO=A,e.$RO=A=me([se(0,N.$hp),se(1,R.$qk)],A)}),define(ie[139],ne([0,1,140,3]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mr=void 0;function R(A,k){return A.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:A.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function N(A,k,u={}){const a=(0,L.parse)(A),v=u.proxyUrl||R(a,k);if(!v)return null;const E=(0,L.parse)(v);if(!/^https?:$/.test(E.protocol||""))return null;const m={host:E.hostname||"",port:(E.port?+E.port:0)||(E.protocol==="https"?443:80),auth:E.auth,rejectUnauthorized:(0,D.$Of)(u.strictSSL)?u.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((f,b)=>{J(["http-proxy-agent"],f,b)})).HttpProxyAgent(v,m):new(await new Promise((f,b)=>{J(["https-proxy-agent"],f,b)})).HttpsProxyAgent(v,m)}e.$mr=N}),define(ie[141],ne([0,1,58,16,107,20,34,7,12,28,86,173,9,74]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_l=void 0;let b;async function S(l,w,p,h){return p["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):u.$i?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,E.$6l)(h)&&!p["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,E.$6l)(h)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),b||(b=m.Promises.withAsyncBody(async(g,i)=>{const r=new N.$6d;let t=1e4;const n=l.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(t=(0,f.$7l)(n,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),i(new Error((0,R.localize)(0,null)))},t);try{g(await $(w,r.token))}catch(o){!(0,k.$4)(o)&&!r.token.isCancellationRequested?i(new Error((0,R.localize)(1,null,(0,A.$Qi)(o)))):g({})}finally{clearTimeout(s),r.dispose()}})),b)}e.$_l=S;async function $(l,w){const p=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",p);const h=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",h);const g=(0,a.$qg)().replace(/-/g,"").substr(0,12),i=new RegExp(g+"({.*})"+g),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};l.trace("getUnixShellEnvironment#env",r);const t=await(0,v.$Vl)(u.OS,r);return l.trace("getUnixShellEnvironment#shell",t),new Promise((n,s)=>{if(w.isCancellationRequested)return s(new k.$5);const o=(0,D.$nc)(t);let c,I;const O="";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${O} -p '''${g}'' + JSON.stringify(process.env) + ''${g}'''`,I=["-Login","-Command"]):o==="nu"?(c=`^'${process.execPath}' ${O} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,I=["-i","-l","-c"]):o==="xonsh"?(c=`import os, json; print("${g}", json.dumps(dict(os.environ)), "${g}")`,I=["-i","-l","-c"]):(c=`'${process.execPath}' ${O} -p '"${g}" + JSON.stringify(process.env) + "${g}"'`,o==="tcsh"||o==="csh"?I=["-ic"]:I=["-i","-l","-c"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),c);const y=(0,L.spawn)(t,[...I,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});w.onCancellationRequested(()=>(y.kill(),s(new k.$5))),y.on("error",te=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.$Qi)(te)),s(te)});const j=[];y.stdout.on("data",te=>j.push(te));const H=[];y.stderr.on("data",te=>H.push(te)),y.on("close",(te,_)=>{const oe=Buffer.concat(j).toString("utf8");l.trace("getUnixShellEnvironment#raw",oe);const re=Buffer.concat(H).toString("utf8");if(re.trim()&&l.trace("getUnixShellEnvironment#stderr",re),te||_)return s(new Error((0,R.localize)(2,null,te,_)));const he=i.exec(oe),ce=he?he[1]:"{}";try{const ae=JSON.parse(ce);p?ae.ELECTRON_RUN_AS_NODE=p:delete ae.ELECTRON_RUN_AS_NODE,h?ae.ELECTRON_NO_ATTACH_CONSOLE=h:delete ae.ELECTRON_NO_ATTACH_CONSOLE,delete ae.VSCODE_RESOLVING_ENVIRONMENT,delete ae.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",ae),n(ae)}catch(ae){l.error("getUnixShellEnvironment#errorCaught",(0,A.$Qi)(ae)),s(ae)}})})}}),define(ie[142],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uO=e.$tO=void 0,e.$tO=(0,L.$6h)("stateReadService"),e.$uO=(0,L.$6h)("stateService")}),define(ie[68],ne([0,1,9,14,2,3,18,13,4]),function(J,e,L,D,R,N,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xO=e.$wO=e.$vO=e.SaveStrategy=void 0;var a;(function(f){f[f.IMMEDIATE=0]="IMMEDIATE",f[f.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class v extends R.$Tc{constructor(b,S,$,l){super(),this.h=b,this.j=S,this.m=$,this.n=l,this.a=Object.create(null),this.b="",this.c=this.B(new L.$4g(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch(b){b.fileOperationResult!==1&&this.m.error(b)}}getItem(b,S){const $=this.a[b];return(0,N.$Rf)($)?S:$}setItem(b,S){this.setItems([{key:b,data:S}])}setItems(b){let S=!1;for(const{key:$,data:l}of b)this.a[$]!==l&&((0,N.$Rf)(l)?(0,N.$Pf)(this.a[$])||(this.a[$]=void 0,S=!0):(this.a[$]=l,S=!0));S&&this.s()}removeItem(b){(0,N.$Pf)(this.a[b])||(this.a[b]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const b=JSON.stringify(this.a,null,4);if(b!==this.b)try{await this.n.writeFile(this.h,D.$je.fromString(b),{atomic:{postfix:".vsctmp"}}),this.b=b}catch(S){this.m.error(S)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$vO=v;let E=class extends R.$Tc{constructor(b,S,$,l){super(),this.a=this.B(new v(S.stateResource,b,$,l))}async init(){await this.a.init()}getItem(b,S){return this.a.getItem(b,S)}};e.$wO=E,e.$wO=E=me([se(1,A.$ai),se(2,u.$nj),se(3,k.$qk)],E);class m extends E{setItem(b,S){this.a.setItem(b,S)}setItems(b){this.a.setItems(b)}removeItem(b){this.a.removeItem(b)}close(){return this.a.close()}}e.$xO=m}),define(ie[69],ne([0,1,12,35,28]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function N(u){if(L.$u===2&&/^penguin(\.|$)/i.test(u))return"chromebook"}function A(u,a,v,E,m,f,b,S,$){const l=Object.create(null);l["common.machineId"]=f,l["common.sqmId"]=b,l.sessionID=(0,R.$qg)()+Date.now(),l.commitHash=E,l.version=m,l["common.platformVersion"]=(u||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),l["common.platform"]=(0,L.$h)(L.$u),l["common.nodePlatform"]=D.$dc,l["common.nodeArch"]=v,l["common.product"]=$||"desktop",S&&(l["common.msftInternal"]=S);let w=0;const p=Date.now();Object.defineProperties(l,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),L.$l&&(l["common.snap"]="true");const h=N(a);return h&&(l["common.platformDetail"]=h),l}e.$Jo=A;function k(u){const a=D.env.USERDNSDOMAIN;if(!a)return!1;const v=a.toLowerCase();return u.some(E=>v===E)}e.$Ko=k}),define(ie[25],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,L.$6h)("telemetryService"),e.$vl=(0,L.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var D;(function(N){N[N.NONE=0]="NONE",N[N.CRASH=1]="CRASH",N[N.ERROR=2]="ERROR",N[N.USAGE=3]="USAGE"})(D||(e.TelemetryLevel=D={}));var R;(function(N){N.OFF="off",N.CRASH="crash",N.ERROR="error",N.ON="all"})(R||(e.TelemetryConfiguration=R={}))}),define(ie[41],ne([0,1,27,3,67,69,25]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class k{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$Lo=k;class u{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=u,e.$No=new u;class a{async publicLog(r,t,n){}async publicLogError(r,t,n){}}e.$Oo=a,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function v(i,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!i.enableTelemetry)}e.$So=v;function E(i,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$To=E;function m(i){const r=i.getValue(A.$Cl),t=i.getValue(A.$Dl);if(i.getValue(A.$El)===!1||t===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=m;function f(i){const r={},t={},n={};$(i,n);for(let s in n){s=s.length>150?s.substr(s.length-149):s;const o=n[s];typeof o=="number"?t[s]=o:typeof o=="boolean"?t[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:t}}e.$Vo=f;const b=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function S(i){if(!i)return"none";const r=(0,R.$bl)(i);return b.has(r)?r:"other"}e.$Wo=S;function $(i,r,t=0,n){if(i)for(const s of Object.getOwnPropertyNames(i)){const o=i[s],c=n?n+s:s;Array.isArray(o)?r[c]=(0,L.$An)(o):o instanceof Date?r[c]=o.toISOString():(0,D.$Kf)(o)?t<2?$(o,r,t+1,c+"."):r[c]=(0,L.$An)(o):r[c]=o}}function l(i,r){const t=i.msftInternalDomains||[],n=r.getValue("telemetry.internalTesting");return(0,N.$Ko)(t)||n}e.$Xo=l;function w(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Yo=w;function p(i,r){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let t=i;const n=[];for(const I of r)for(;;){const O=I.exec(i);if(!O)break;n.push([O.index,I.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(t="";;){const I=o.exec(i);if(!I)break;const O=n.some(([y,j])=>I.index<j&&y<o.lastIndex);!s.test(I[0])&&!O&&(t+=i.substring(c,I.index)+"<REDACTED: user-file-path>",c=o.lastIndex)}return c<i.length&&(t+=i.substr(c)),t}function h(i){if(!i)return i;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const t of r)if(t.regex.test(i))return`<REDACTED: ${t.label}>`;return i}function g(i,r){return(0,L.$xn)(i,t=>{if(t instanceof k||Object.hasOwnProperty.call(t,"isTrustedTelemetryValue"))return t.value;if(typeof t=="string"){let n=t.replaceAll("%20"," ");n=p(n,r);for(const s of r)n=n.replace(s,"");return n=h(n),n}})}e.$Zo=g}),define(ie[26],ne([0,1,30,21,37,12,11,7,35,41]),function(J,e,L,D,R,N,A,k,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function v(t,n){return t.uuid&&n.uuid?t.uuid===n.uuid:t.id===n.id?!0:(0,L.$7e)(t.id,n.id)===0}e.$1o=v;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(n){const s=n.manifest?n.manifest.version:n.version,o=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new m(n.identifier,s,o)}static parse(n){const s=E.exec(n);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(n,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof m?v(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.$2o=m;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function b(t){const n=f.exec(t);return n&&n[1]?[$(n[1]),n[2]]:[$(t),void 0]}e.$3o=b;function S(t,n){return`${t}.${n}`}e.$4o=S;function $(t){return t.toLowerCase()}e.$5o=$;function l(t,n){return $(S(t??R.$hm,n))}e.$6o=l;function w(t,n){const s=[],o=c=>{for(const I of s)if(I.some(O=>v(n(O),n(c))))return I;return null};for(const c of t){const I=o(c);I?I.push(c):s.push([c])}return s}e.$7o=w;function p(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.$8o=p;function h(t){return{id:new a.$Lo(t.identifier.id),name:new a.$Lo(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.$9o=h,e.$0o=new R.$lm("pprice.better-merge");function g(t,n){const s=[],o=n.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&s.every(I=>!v(I.identifier,{id:c}))){const I=t.filter(O=>v(O.identifier,{id:c}));I.length===1&&(s.push(I[0]),o.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.$$o=g;async function i(t,n){if(!N.$k)return!1;let s;try{s=(await t.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){n.debug("Error while getting the os-release file.",(0,k.$0)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,n){const s=await i(t,n),o=(0,D.$uo)(s?"alpine":N.$u,u.$ec);return n.debug("ComputeTargetPlatform:",o),o}e.$_o=r}),define(ie[143],ne([0,1,20,7,15,17,44,11,96,21,26,37]),function(J,e,L,D,R,N,A,k,u,a,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=void 0;const m=S=>(0,u.localize)(0,null,S),f=(0,u.localize)(1,null,"ms-dotnettools.csharp");let b=class{constructor($,l,w){this.a=$,this.b=l,this.d=w}get f(){}async listExtensions($,l,w){let p=await this.b.getInstalled(1,w);const h=E.$km.map(i=>i.toLowerCase());if(l&&l!==""){if(h.indexOf(l.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(i=>i.manifest.categories?i.manifest.categories.map(t=>t.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){this.a.info("Possible Categories: "),h.forEach(i=>{this.a.info(i)});return}this.f&&this.a.info((0,u.localize)(2,null,this.f)),p=p.sort((i,r)=>i.identifier.id.localeCompare(r.identifier.id));let g;for(const i of p)g!==i.identifier.id&&(g=i.identifier.id,this.a.info($?`${g}@${i.manifest.version}`:g))}async installExtensions($,l,w,p){const h=[];try{const g=[];$.length&&this.a.info(this.f?(0,u.localize)(3,null,this.f):(0,u.localize)(4,null));const i=[];let r=[];const t=(s,o,c)=>{r.push({id:s,version:o!=="prerelease"?o:void 0,installOptions:{...w,isBuiltin:c,installPreReleaseVersion:o==="prerelease"||w.installPreReleaseVersion}})};for(const s of $)if(s instanceof k.URI)i.push({vsix:s,installOptions:w});else{const[o,c]=(0,v.$3o)(s);t(o,c,!1)}for(const s of l)if(s instanceof k.URI)i.push({vsix:s,installOptions:{...w,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[o,c]=(0,v.$3o)(s);t(o,c,!0)}const n=await this.b.getInstalled(1,w.profileLocation);if(i.length&&await Promise.all(i.map(async({vsix:s,installOptions:o})=>{try{const c=await this.g(s,o,p,n);c&&g.push(c)}catch(c){this.a.error(c),h.push(s.toString())}})),r.length&&(r=r.filter(({id:s,version:o})=>{const c=n.find(I=>(0,v.$1o)(I.identifier,{id:s}));if(c){if(!p&&(!o||o==="prerelease"&&c.preRelease))return this.a.info((0,u.localize)(5,null,s,c.manifest.version,s)),!1;if(o&&c.manifest.version===o)return this.a.info((0,u.localize)(6,null,`${s}@${o}`)),!1}return!0}),r.length)){const s=await this.h(r);await Promise.all(r.map(async o=>{const c=s.get(o.id.toLowerCase());if(c)try{const I=await this.j(o,c,n);I&&g.push(I)}catch(I){this.a.error(I.message||I.stack||I),h.push(o.id)}else this.a.error(`${m(o.version?`${o.id}@${o.version}`:o.id)}
${f}`),h.push(o.id)}))}}catch(g){throw this.a.error((0,u.localize)(7,null,(0,D.$0)(g))),g}if(h.length)throw new Error((0,u.localize)(8,null,h.join(", ")))}async updateExtensions($){const l=await this.b.getInstalled(1,$),w=[];for(const i of l)i.identifier.uuid&&w.push({...i.identifier,preRelease:i.preRelease});this.a.trace((0,u.localize)(9,null,w.length));const p=await this.d.getExtensions(w,{compatible:!0},L.CancellationToken.None),h=[];for(const i of p)for(const r of l)(0,v.$1o)(r.identifier,i.identifier)&&(0,A.gt)(i.version,r.manifest.version)&&h.push({extension:i,options:{operation:3,installPreReleaseVersion:r.isPreReleaseVersion}});if(!h.length){this.a.info((0,u.localize)(10,null));return}this.a.info((0,u.localize)(11,null,h.map(i=>i.extension.identifier.id).join(", ")));const g=await this.b.installGalleryExtensions(h);for(const i of g)i.error?this.a.error((0,u.localize)(12,null,i.identifier.id,(0,D.$0)(i.error))):this.a.info((0,u.localize)(13,null,i.identifier.id,i.local?.manifest.version))}async g($,l,w,p){const h=await this.b.getManifest($);if(!h)throw new Error("Invalid vsix");if(await this.l(h,w,l.profileLocation,p))try{return await this.b.install($,l),this.a.info((0,u.localize)(14,null,(0,N.$Eg)($))),h}catch(i){if((0,D.$4)(i))return this.a.info((0,u.localize)(15,null,(0,N.$Eg)($))),null;throw i}return null}async h($){const l=new Map,w=$.some(g=>g.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),h=[];for(const g of $)a.$no.test(g.id)&&h.push({...g,preRelease:w});if(h.length){const g=await this.d.getExtensions(h,{targetPlatform:p},L.CancellationToken.None);for(const i of g)l.set(i.identifier.id.toLowerCase(),i)}return l}async j({id:$,version:l,installOptions:w},p,h){const g=await this.d.getManifest(p,L.CancellationToken.None);if(g&&!this.k(g))return null;const i=h.find(r=>(0,v.$1o)(r.identifier,p.identifier));if(i){if(p.version===i.manifest.version)return this.a.info((0,u.localize)(16,null,l?`${$}@${l}`:$)),null;this.a.info((0,u.localize)(17,null,$,p.version))}try{w.isBuiltin?this.a.info(l?(0,u.localize)(18,null,$,l):(0,u.localize)(19,null,$)):this.a.info(l?(0,u.localize)(20,null,$,l):(0,u.localize)(21,null,$));const r=await this.b.installFromGallery(p,{...w,installGivenVersion:!!l});return this.a.info((0,u.localize)(22,null,$,r.manifest.version)),g}catch(r){if((0,D.$4)(r))return this.a.info((0,u.localize)(23,null,$)),null;throw r}}k($){return!0}async l($,l,w,p){if(!l){const h={id:(0,v.$6o)($.publisher,$.name)},g=p.find(i=>(0,v.$1o)(h,i.identifier)&&(0,A.gt)(i.manifest.version,$.version));if(g)return this.a.info((0,u.localize)(24,null,g.identifier.id,g.manifest.version,$.version)),!1}return this.k($)}async uninstallExtensions($,l,w){const p=async g=>{if(g instanceof k.URI){const i=await this.b.getManifest(g);return(0,v.$4o)(i.publisher,i.name)}return g},h=[];for(const g of $){const i=await p(g),t=(await this.b.getInstalled(void 0,w)).filter(n=>(0,v.$1o)(n.identifier,{id:i}));if(!t.length)throw new Error(`${this.m(i)}
${f}`);if(t.some(n=>n.type===0)){this.a.info((0,u.localize)(25,null,i));return}if(!l&&t.some(n=>n.isBuiltin)){this.a.info((0,u.localize)(26,null,i));return}this.a.info((0,u.localize)(27,null,i));for(const n of t)await this.b.uninstall(n,{profileLocation:w}),h.push(n);this.f?this.a.info((0,u.localize)(28,null,i,this.f)):this.a.info((0,u.localize)(29,null,i))}}async locateExtension($){const l=await this.b.getInstalled();$.forEach(w=>{l.forEach(p=>{if(p.identifier.id===w&&p.location.scheme===R.Schemas.file){this.a.info(p.location.fsPath);return}})})}m($){return this.f?(0,u.localize)(30,null,$,this.f):(0,u.localize)(31,null,$)}};e.$Hp=b,e.$Hp=b=me([se(1,a.$Bo),se(2,a.$yo)],b)}),define(ie[144],ne([0,1,9,7,2,15,17,44,3,28,24,49,29,18,21,26,64,13,4]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w){"use strict";var p;Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;let h=class extends R.$Tc{static{p=this}static{this.c=".sigzip"}constructor(i,r,t,n,s,o){super(),this.h=r,this.j=t,this.m=n,this.n=s,this.r=o,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,r,t){await this.g;const n=(0,A.$Hg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,n,o=>this.j.download(i,o,r))}catch(o){throw new b.$zo(o.message,b.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.t(i)){const o=await this.u(i);try{s=await this.n.verify(n.fsPath,o.fsPath,this.r.getLevel()===w.LogLevel.Trace)}catch(c){const I=c;if(s=I.code,I.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${I.output}`),s===b.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===b.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(n)}catch(O){this.r.error(O)}throw new b.$zo(E.$Lp,b.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(o)}catch(c){this.r.error(c)}}}return s===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):s===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${s}': ${i.identifier.id}`),{location:n,verificationStatus:s}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const r=this.m.getValue("extensions.verifySignature");return(0,u.$Of)(r)?r:!0}async u(i){await this.g;const r=(0,A.$Hg)(this.extensionsDownloadDir,`${this.z(i)}${p.c}`);try{await this.w(i,r,t=>this.j.downloadSignatureArchive(i,t))}catch(t){throw new b.$zo(t.message,b.ExtensionManagementErrorCode.DownloadSignature)}return r}async w(i,r,t){if(await this.h.exists(r))return;if(r.scheme!==N.Schemas.file){await t(r);return}const n=(0,A.$Hg)(this.extensionsDownloadDir,`.${(0,a.$qg)()}`);await this.h.exists(n)||await t(n);try{await v.Promises.rename(n.fsPath,r.fsPath,2*60*1e3)}catch(s){try{await this.h.del(n)}catch{}if(s.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,r.path);else throw this.r.info(`Rename failed because of ${(0,D.$0)(s)}. Deleted the file from downloaded location`,n.path),s}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const r=[],t=[],n=[];for(const c of i.children)if(c.name.endsWith(p.c))n.push(c.resource);else{const I=S.$2o.parse(c.name);I&&t.push([I,c])}const s=(0,S.$7o)(t,([c])=>c),o=[];for(const c of s)c.sort((I,O)=>k.rcompare(I[0].version,O[0].version)),r.push(...c.slice(1).map(I=>I[1].resource)),o.push(c[0][1]);o.sort((c,I)=>c.mtime-I.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(c=>c.resource)),r.push(...n),await L.Promises.settled(r.map(c=>(this.r.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(i){this.r.error(i)}}z(i){return this.f?S.$2o.create(i).toString().toLowerCase():(0,a.$qg)()}};e.$5p=h,e.$5p=h=p=me([se(0,f.$bi),se(1,l.$qk),se(2,b.$yo),se(3,m.$zi),se(4,$.$Fp),se(5,w.$nj)],h)}),define(ie[145],ne([0,1,6,2,31,26,37]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class k extends D.$Tc{constructor(a,v,E,m,f,b,S){super(),this.f=a,this.g=v,this.h=E,this.j=m,this.m=f,this.n=b,this.r=S,this.a=this.B(new L.$Vd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new D.$3c),this.s().then(null,$=>S.error($))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(v=>(this.c.set(v.id,(0,D.$Qc)(this.n.watch(this.m.extUri.dirname(v.extensionsResource)),this.n.watch(v.extensionsResource))),this.G(v.extensionsResource))))}catch(v){throw this.r.error(v),v}}async w(a){for(const v of a.extensions)this.I(this.L(v.identifier,v.version),a.profileLocation)}async y(a){for(const v of a.extensions){const E=this.L(v.identifier,v.version);a.error?this.J(E,a.profileLocation):this.I(E,a.profileLocation)}}async z(a){for(const v of a.extensions)this.J(this.L(v.identifier,v.version),a.profileLocation)}async C(a){const v=[],E=[];for(const m of a.extensions){const f=this.L(m.identifier,m.version);a.error?this.I(f,a.profileLocation):(this.J(f,a.profileLocation),this.b.has(f)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),E.push(this.f.scanInstalledExtensionAtLocation(m.location).then(b=>{b?v.push(b):this.r.info("Extension not found at the location",m.location.toString())},b=>this.r.error(b)))))}try{await Promise.all(E),v.length&&await this.H(v)}catch(m){this.r.error(m)}}D(a){for(const v of this.h.profiles)a.contains(v.extensionsResource,0,1)&&this.F(v.extensionsResource)}async F(a){const v=[],E=[],m=await this.j.scanProfileExtensions(a),f=new Set,b=new Set;for(const[S,$]of this.b)$.has(a)&&b.add(S);for(const S of m){const $=this.L(S.identifier,S.version);f.add($),b.has($)||(v.push(S.identifier),this.I($,a))}for(const S of b)if(!f.has(S)){const $=this.M(S);$&&(E.push($.identifier),this.J(S,a))}(v.length||E.length)&&this.a.fire({added:v.length?{extensions:v,profileLocation:a}:void 0,removed:E.length?{extensions:E,profileLocation:a}:void 0})}async G(a){const v=await this.j.scanProfileExtensions(a);for(const E of v)this.I(this.L(E.identifier,E.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(E=>!this.b.has(this.L(E.identifier,E.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,v){let E=this.b.get(a);E||this.b.set(a,E=new R.$Bc(m=>this.m.extUri.getComparisonKey(m))),E.add(v)}J(a,v){const E=this.b.get(a);E&&E.delete(v),E?.size||this.b.delete(a)}L(a,v){return`${A.$lm.toKey(a.id)}@${v}`}M(a){const[v,E]=(0,N.$3o)(a);return E?{identifier:{id:v},version:E}:void 0}}e.$9p=k}),define(ie[146],ne([0,1,117,41]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;async function R(N,A,k,u,a,v,E){const m={"X-Market-Client-Id":`VSCode ${N}`,"User-Agent":`VSCode ${N} (${A.nameShort})`};if((0,D.$So)(A,k)&&(0,D.$Uo)(u)===3){const f=await(0,L.$Ap)(k,a,v);m["X-Market-User-Id"]=f,m["VSCode-SessionId"]=E.machineId||f}return m}e.$Bp=R}),define(ie[147],ne([0,1,174,19,9,2,15,16,24,18,21,26,4,63,11]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;let S=class extends f.$ir{constructor(p,h,g,i){super(g),this.h=p,this.j=i,this.g=this.B(new $(h,i)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(p,h){const i=(await this.g.getLanguagePacks())[h];if(!i){this.j.warn(`No language pack found for ${h}`);return}const r=i.translations[p];return r?b.URI.file(r):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),h=Object.keys(p).map(g=>{const i=p[g];return{...this.f(g,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return h.push(this.f("en","English")),h.sort((g,i)=>g.label.localeCompare(i.label)),h}async m(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",p.identifier.id),await this.update())}async n(p){const h=await this.g.getLanguagePacks();Object.keys(h).some(g=>h[g]&&h[g].extensions.some(i=>(0,E.$1o)(i.extensionIdentifier,p.identifier)))&&(this.j.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,h]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),g=await this.g.update(h);return!(0,D.$ub)(Object.keys(p),Object.keys(g))}};e.$jr=S,e.$jr=S=me([se(0,v.$Bo),se(1,a.$bi),se(2,v.$yo),se(3,m.$nj)],S);let $=class extends N.$Tc{constructor(p,h){super(),this.j=h,this.c={},this.f=(0,k.$jc)(p.userDataPath,"languagepacks.json"),this.g=new R.$ah}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.s(h=>{Object.keys(h).forEach(g=>delete h[g]),this.m(h,...p)}).then(()=>this.c)}m(p,...h){for(const g of h)g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&this.n(p,g);Object.keys(p).forEach(g=>this.r(p[g]))}n(p,h){const g=h.identifier,i=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const r of i)if(h.location.scheme===A.Schemas.file&&l(r)){let t=p[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},p[r.languageId]=t);const n=t.extensions.filter(s=>(0,E.$1o)(s.extensionIdentifier,g))[0];n?n.version=h.manifest.version:t.extensions.push({extensionIdentifier:g,version:h.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,k.$jc)(h.location.fsPath,s.path)}}r(p){if(p){const h=(0,L.createHash)("md5");for(const g of p.extensions)h.update(g.extensionIdentifier.uuid||g.extensionIdentifier.id).update(g.version);p.hash=h.digest("hex")}}s(p=()=>null){return this.g.queue(()=>{let h=null;return u.Promises.readFile(this.f,"utf8").then(void 0,g=>g.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(g)).then(g=>{try{return JSON.parse(g)}catch{return{}}}).then(g=>(h=p(g),g)).then(g=>{for(const r of Object.keys(g))g[r]||delete g[r];this.c=g,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),u.Promises.writeFile(this.f,i)}).then(()=>h,g=>this.j.error(g))})}};$=me([se(0,a.$bi),se(1,m.$nj)],$);function l(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const p of w.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(ie[148],ne([0,1,83,7,27,41]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=void 0;const A="https://mobile.events.data.microsoft.com/OneCollector/1.0",k="https://mobile.events.data.microsoft.com/ping";async function u(v,E,m){const f=await(0,L.$fD)("@microsoft/1ds-core-js","dist/ms.core.js"),b=await(0,L.$fD)("@microsoft/1ds-post-js","dist/ms.post.js"),S=new f.AppInsightsCore,$=new b.PostChannel,l={instrumentationKey:v,endpointUrl:A,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[$]]};if(m){l.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};l.extensionConfig[$.identifier]=w}return S.initialize(l,[]),S.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',E&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),S}class a{constructor(E,m,f,b,S){this.e=E,this.f=m,this.g=f,this.h=S,this.c=A,this.d=k,this.g||(this.g={}),typeof b=="function"?this.a=b():this.a=b,this.b=null}i(E){if(this.a){if(typeof this.a!="string"){E(this.a);return}this.b||(this.b=u(this.a,this.e,this.h)),this.b.then(m=>{E(m)},m=>{(0,D.$1)(m),console.error(m)})}}log(E,m){if(!this.a)return;m=(0,R.$yn)(m,this.g),m=(0,N.$Vo)(m);const f=this.f+"/"+E;try{this.i(b=>{b.pluginVersionString=m?.properties.version??"Unknown",b.track({name:f,baseData:{name:f,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(E=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,E(void 0)})})}):Promise.resolve(void 0)}}e.$pO=a}),define(ie[149],ne([0,1,2,27,12,30,108,29,40,150,32,36,25,41]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;let b=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(l,w,p){this.k=w,this.l=p,this.d={},this.i=new L.$Sc,this.j=[],this.b=l.appenders,this.c=l.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=l.piiPaths||[],this.g=3,this.h=!!l.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const h of this.f)this.j.push(new RegExp((0,N.$Oe)(h),"gi")),h.indexOf("\\")>=0&&this.j.push(new RegExp((0,N.$Oe)(h.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(h=>{(h.affectsConfiguration(m.$Cl)||h.affectsConfiguration(m.$El)||h.affectsConfiguration(m.$Dl))&&this.m()}))}setExperimentProperty(l,w){this.d[l]=w}m(){let l=(0,f.$Uo)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const p=w.usage?3:w.error?2:0;l=Math.min(l,p)}this.g=l}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(l,w,p){this.g<w||(p=(0,D.$yn)(p,this.d),p=(0,f.$Zo)(p,this.j),p=(0,D.$yn)(p,this.c),this.b.forEach(h=>h.log(l,p)))}publicLog(l,w){this.n(l,3,w)}publicLog2(l,w){this.publicLog(l,w)}publicLogError(l,w){this.h&&this.n(l,2,w)}publicLogError2(l,w){this.publicLogError(l,w)}};e.$pr=b,e.$pr=b=me([se(1,k.$zi),se(2,v.$Fj)],b);function S(){const $=(0,A.localize)(0,null,a.default.nameLong),l=a.default.privacyStatementUrl?(0,A.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,A.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=R.$o?"":(0,A.localize)(3,null),p=(0,A.localize)(4,null),h=(0,A.localize)(5,null),g=(0,A.localize)(6,null),i=(0,A.localize)(7,null),r=`
|       | ${p} | ${h} | ${g} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,A.localize)(8,null);return`
${$} ${l} ${w}

&nbsp;

${i}
${r}

&nbsp;

${t}
`}E.$Hn.as(u.$Mn.Configuration).registerConfiguration({id:m.$Bl,order:1,type:"object",title:(0,A.localize)(9,null),properties:{[m.$Cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,A.localize)(10,null),(0,A.localize)(11,null),(0,A.localize)(12,null),(0,A.localize)(13,null)],markdownDescription:S(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),E.$Hn.as(u.$Mn.Configuration).registerConfiguration({id:m.$Bl,order:110,type:"object",title:(0,A.localize)(14,null),properties:{[m.$El]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,A.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,A.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,A.localize)(17,null,`\`#${m.$Cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(ie[151],ne([0,1,14,20,175,148]),function(J,e,L,D,R,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=void 0;async function A(v,E){const m=await E.request(v,D.CancellationToken.None),f=(await(0,L.$ve)(m.stream)).toString(),b=m.res.statusCode??200;return{headers:m.res.headers,statusCode:b,responseData:f}}async function k(v){const E={method:v.type,headers:v.headers};return new Promise((f,b)=>{const S=R.request(v.url??"",E,$=>{$.on("data",function(l){f({headers:$.headers,statusCode:$.statusCode??200,responseData:l.toString()})}),$.on("error",function(l){b(l)})});S.write(v.data,$=>{$&&b($)}),S.end()})}async function u(v,E,m){const f=typeof E.data=="string"?E.data:new TextDecoder().decode(E.data),b={type:"POST",headers:{...E.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(E.data).toString()},url:E.urlString,data:f};try{const S=v?await A(b,v):await k(b);m(S.statusCode,S.headers,S.responseData)}catch{m(0,{})}}class a extends N.$pO{constructor(E,m,f,b,S){const $={sendPOST:(l,w)=>{u(E,l,w)}};super(m,f,b,S,$)}}e.$qO=a}),define(ie[152],ne([0,1,16,24]),function(J,e,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8_b=void 0;async function R(N,A){const k=Object.create(null),u=(v,E)=>{const m=JSON.parse(v);k[E]=m};if(A){const v=[],E=await D.Promises.readdir(A);for(const f of E)try{(await D.Promises.stat((0,L.$jc)(A,f))).isDirectory()&&v.push(f)}catch{}const m=[];for(const f of v)(await D.Promises.readdir((0,L.$jc)(A,f))).filter(S=>S==="telemetry.json").length===1&&m.push(f);for(const f of m){const b=(await D.Promises.readFile((0,L.$jc)(A,f,"telemetry.json"))).toString();u(b,f)}}let a=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-core.json"))).toString();return u(a,"vscode-core"),a=(await D.Promises.readFile((0,L.$jc)(N,"telemetry-extensions.json"))).toString(),u(a,"vscode-extensions"),JSON.stringify(k,null,4)}e.$8_b=R}),define(ie[153],ne([0,1,12,84,25]),function(J,e,L,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$m_b=e.$l_b=void 0;async function N(k,u){let a=k.getItem(R.$zl);return(typeof a!="string"||L.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,D.$$m)(u.error.bind(u))),a}e.$l_b=N;async function A(k,u){let a=k.getItem(R.$Al);return typeof a!="string"&&(a=await(0,D.$_m)(u.error.bind(u))),a}e.$m_b=A}),define(ie[22],ne([0,1,10]),function(J,e,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=void 0,e.$1k=(0,L.$6h)("IUriIdentityService")}),define(ie[154],ne([0,1,22,118,13,17,75,6,2]),function(J,e,L,D,R,N,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;class a{static{this._clock=0}constructor(m){this.uri=m,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let v=class{constructor(m){this.g=m,this.c=new u.$Sc,this.f=2**16;const f=new Map,b=S=>{let $=f.get(S.scheme);return $===void 0&&($=m.hasProvider(S)&&!this.g.hasCapability(S,1024),f.set(S.scheme,$)),$};this.c.add(k.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(S=>{f.delete(S.scheme)})),this.extUri=new N.$wg(b),this.d=new A.$1r((S,$)=>this.extUri.compare(S,$,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,N.$Ig)(m));const f=this.d.get(m);return f?f.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new a(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((b,S)=>b[1].time<S[1].time?1:b[1].time>S[1].time?-1:0);a._clock=0,this.d.clear();const f=this.f*.5;for(let b=0;b<f;b++)this.d.set(m[b][0],m[b][1].touch())}};e.$2r=v,e.$2r=v=me([se(0,R.$qk)],v),(0,D.$Yr)(L.$1k,v,1)}),define(ie[155],ne([0,1,6,2,13,48,31]),function(J,e,L,D,R,N,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;class k extends D.$Tc{constructor(a,v,E,m,f,b){super(),this.f=a,this.g=v,this.h=E,this.j=m,this.m=f,this.n=b,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new L.$Vd),this.onDidChangeFile=this.a.event,this.b=N.$_h.forUris(()=>!(this.capabilities&1024)),this.c=new A.$Bc(S=>this.m.extUri.getComparisonKey(this.t(S))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(S=>this.s(S)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,v){return this.g.open(this.t(a),v)}close(a){return this.g.close(a)}read(a,v,E,m,f){return this.g.read(a,v,E,m,f)}write(a,v,E,m,f){return this.g.write(a,v,E,m,f)}watch(a,v){this.b.set(a,a);const E=this.g.watch(this.t(a),v);return(0,D.$Rc)(()=>{this.b.delete(a),E.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,v,E){return this.g.rename(this.t(a),this.t(v),E)}readFile(a,v){return this.g.readFile(this.t(a),v)}readFileStream(a,v,E){return this.g.readFileStream(this.t(a),v,E)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,v,E){return this.g.writeFile(this.t(a),v,E)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,v){return this.g.delete(this.t(a),v)}copy(a,v,E){if((0,R.$uk)(this.g))return this.g.copy(this.t(a),this.t(v),E);throw new Error("copy not supported")}cloneFile(a,v){if((0,R.$vk)(this.g))return this.g.cloneFile(this.t(a),this.t(v));throw new Error("clone not supported")}s(a){const v=[];for(const E of a){if(E.resource.scheme!==this.f)continue;const m=this.u(E.resource);this.b.findSubstr(m)&&v.push({resource:m,type:E.type,cId:E.cId})}v.length&&(this.n.debug("User data changed"),this.a.fire(v))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$J_b=k}),define(ie[156],ne([0,1,110,16,48,17,11,10,15]),function(J,e,L,D,R,N,A,k,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,k.$6h)("contextService");function a(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.uri)}e.$di=a;function v(n){return typeof n?.id=="string"&&!a(n)&&!m(n)}e.$ei=v,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function E(n,s){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,D.$nc)(n)}:s?e.$fi:e.$gi;const o=n;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.$hi=E;function m(n){const s=n;return typeof s?.id=="string"&&A.URI.isUri(s.configPath)}e.$ii=m;function f(n){const s=n;if(s?.uri)return{id:s.id,uri:A.URI.revive(s.uri)};const o=n;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(n?.id)return{id:n.id}}e.$ji=f;var b;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(b||(e.WorkbenchState=b={}));function S(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.$ki=S;function $(n){const s=n;return!!(s&&typeof s=="object"&&A.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.$li=$;class l{constructor(s,o,c,I,O){this.h=s,this.j=c,this.l=I,this.n=O,this.c=R.$_h.forUris(this.n,()=>!0),this.folders=o}update(s){this.h=s.id,this.l=s.configuration,this.j=s.transient,this.n=s.n,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.o()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.l}set configuration(s){this.l=s}getFolder(s){return s&&this.c.findSubstr(s)||null}o(){this.c=R.$_h.forUris(this.n,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=l;class w{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,N.$Hg)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=w;function p(n){return new w({uri:n,index:0,name:(0,N.$Dg)(n)},{uri:n.toString()})}e.$oi=p,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,L.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function h(n,s){return N.$yg.isEqualOrParent(n,s.untitledWorkspacesHome)}e.$ti=h;function g(n){let s;return A.URI.isUri(n)?s=n:s=n.configuration,s?.scheme===u.Schemas.tmp}e.$ui=g,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(n){return n.id===e.$vi}e.$wi=i;function r(n,s){return!h(n,s)&&!g(n)}e.$xi=r;function t(n){return(typeof n=="string"?(0,D.$oc)(n):(0,N.$Fg)(n))===e.$qi}e.$yi=t}),define(ie[23],ne([0,1,43,6,2,17,11,109,18,13,10,4,156,31,22,9,28,30,3]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.ProfileResourceType=void 0;var p;(function(n){n.Settings="settings",n.Keybindings="keybindings",n.Snippets="snippets",n.Tasks="tasks",n.Extensions="extensions",n.GlobalState="globalState"})(p||(e.ProfileResourceType=p={}));function h(n){const s=n;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&A.URI.isUri(s.location)&&A.URI.isUri(s.globalStorageHome)&&A.URI.isUri(s.settingsResource)&&A.URI.isUri(s.keybindingsResource)&&A.URI.isUri(s.tasksResource)&&A.URI.isUri(s.snippetsHome)&&A.URI.isUri(s.extensionsResource))}e.$2k=h,e.$3k=(0,v.$6h)("IUserDataProfilesService");function g(n,s){return{id:n.id,isDefault:n.isDefault,name:n.name,shortName:n.shortName,icon:n.icon,location:A.URI.revive(n.location).with({scheme:s}),globalStorageHome:A.URI.revive(n.globalStorageHome).with({scheme:s}),settingsResource:A.URI.revive(n.settingsResource).with({scheme:s}),keybindingsResource:A.URI.revive(n.keybindingsResource).with({scheme:s}),tasksResource:A.URI.revive(n.tasksResource).with({scheme:s}),snippetsHome:A.URI.revive(n.snippetsHome).with({scheme:s}),extensionsResource:A.URI.revive(n.extensionsResource).with({scheme:s}),cacheHome:A.URI.revive(n.cacheHome).with({scheme:s}),useDefaultFlags:n.useDefaultFlags,isTransient:n.isTransient}}e.$4k=g;function i(n,s,o,c,I,O){return{id:n,name:s,location:o,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:O&&I?.useDefaultFlags?.globalState?O.globalStorageHome:(0,N.$Hg)(o,"globalStorage"),settingsResource:O&&I?.useDefaultFlags?.settings?O.settingsResource:(0,N.$Hg)(o,"settings.json"),keybindingsResource:O&&I?.useDefaultFlags?.keybindings?O.keybindingsResource:(0,N.$Hg)(o,"keybindings.json"),tasksResource:O&&I?.useDefaultFlags?.tasks?O.tasksResource:(0,N.$Hg)(o,"tasks.json"),snippetsHome:O&&I?.useDefaultFlags?.snippets?O.snippetsHome:(0,N.$Hg)(o,"snippets"),extensionsResource:O&&I?.useDefaultFlags?.extensions?O.extensionsResource:(0,N.$Hg)(o,"extensions.json"),cacheHome:(0,N.$Hg)(c,n),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$5k=i;let r=class extends R.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,c,I){super(),this.t=s,this.u=o,this.w=c,this.y=I,this.f=!0,this.h=this.B(new D.$Vd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new D.$Vd),this.onWillCreateProfile=this.j.event,this.m=this.B(new D.$Vd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new D.$Vd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new f.$Ac,emptyWindows:new Map},this.profilesHome=(0,N.$Hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,N.$Hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const O of this.O()){if(!O.name||!(0,w.$If)(O.name)||!O.location){this.y.warn("Skipping the invalid stored profile",O.location||O.name);continue}o.push(i((0,N.$Eg)(O.location),O.name,O.location,this.g,{shortName:O.shortName,icon:O.icon,useDefaultFlags:O.useDefaultFlags},s))}}catch(O){this.y.error(O)}const c=new f.$Ac,I=new Map;if(o.length)try{const O=this.Q();if(O.workspaces)for(const[y,j]of Object.entries(O.workspaces)){const H=A.URI.parse(y),te=o.find(_=>_.id===j);te&&c.set(H,te)}if(O.emptyWindows)for(const[y,j]of Object.entries(O.emptyWindows)){const H=o.find(te=>te.id===j);H&&I.set(y,H)}}catch(O){this.y.error(O)}this.z={profiles:o,workspaces:c,emptyWindows:I}}return this.z}D(){const s=i("__default__profile__",(0,k.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",c=new RegExp(`${(0,l.$Oe)(o)}\\s(\\d+)`);let I=0;for(const y of this.profiles){const j=c.exec(y.name),H=j?parseInt(j[1]):0;I=H>I?H:I}const O=`${o} ${I+1}`;return this.createProfile((0,L.$Ti)((0,$.$qg)()).toString(16),O,{transient:!0},s)}async createNamedProfile(s,o,c){return this.createProfile((0,L.$Ti)((0,$.$qg)()).toString(16),s,o,c)}async createProfile(s,o,c,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const O=await this.F(s,o,c);return I&&await this.setProfileForWorkspace(I,O),O}async F(s,o,c){if(!(0,w.$If)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(o);return I||(I=(async()=>{try{const O=this.profiles.find(H=>H.name===o||H.id===s);if(O)return O;const y=i(s,o,(0,N.$Hg)(this.profilesHome,s),this.g,c,this.defaultProfile);await this.u.createFolder(y.location);const j=[];return this.j.fire({profile:y,join(H){j.push(H)}}),await S.Promises.settled(j),this.I([y],[],[]),y}finally{this.r.delete(o)}})(),this.r.set(o,I)),I}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let c=this.profiles.find(I=>I.id===s.id);if(!c)throw new Error(`Profile '${s.name}' does not exist`);return c=i(c.id,o.name??c.name,c.location,this.g,{shortName:o.shortName??c.shortName,icon:o.icon===null?void 0:o.icon??c.icon,transient:o.transient??c.isTransient,useDefaultFlags:o.useDefaultFlags??c.useDefaultFlags},this.defaultProfile),this.I([],[],[c]),c}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(I=>I.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const c=[];this.m.fire({profile:o,join(I){c.push(I)}});try{await Promise.allSettled(c)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(I){(0,a.$Hk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const c=this.profiles.find(I=>I.id===o.id);if(!c)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,c)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(c=>!this.w.extUri.isEqual(c.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return A.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,m.$di)(s)?s.uri:(0,m.$ii)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,c){const I=[...this.profiles,...s],O=[];this.s.profiles=[];for(let y of I)y.isDefault||o.some(j=>y.id===j.id)||(y=c.find(j=>y.id===j.id)??y,y.isTransient?this.s.profiles.push(y):O.push({location:y.location,name:y.name,shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags}));this.P(O),this.z=void 0,this.J(s,o,c)}J(s,o,c){this.h.fire({added:s,removed:o,updated:c,all:this.profiles})}L(s,o,c){c=o?.isTransient?!0:c,c||this.L(s,void 0,!0);const I=this.G(s),O=c?this.s:this.C;A.URI.isUri(I)?(O.workspaces.delete(I),o&&O.workspaces.set(I,o)):(O.emptyWindows.delete(I),o&&O.emptyWindows.set(I,o)),c||this.M()}M(){const s={};for(const[c,I]of this.C.workspaces.entries())s[c.toString()]=I.id;const o={};for(const[c,I]of this.C.emptyWindows.entries())o[c.toString()]=I.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},c=this.D();if(s.workspaces)for(const[O,y]of Object.entries(s.workspaces)){const j=A.URI.parse(y);o[O]=this.w.extUri.isEqual(j,c.location)?c.id:this.w.extUri.basename(j)}const I={};if(s.emptyWindows)for(const[O,y]of Object.entries(s.emptyWindows)){const j=A.URI.parse(y);I[O]=this.w.extUri.isEqual(j,c.location)?c.id:this.w.extUri.basename(j)}return{workspaces:o,emptyWindows:I}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$6k=r,e.$6k=r=me([se(0,u.$ai),se(1,a.$qk),se(2,b.$1k),se(3,E.$nj)],r);class t extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$7k=t}),define(ie[157],ne([0,1,19,9,20,7,6,2,12,3,11,94,21,26,37,4,32,25,22,23]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=e.$Qp=void 0;let h=class extends k.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(s,o,c,I,O,y){super(),this.z=s,this.C=o,this.D=c,this.F=I,this.G=O,this.H=y,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new A.$Vd),this.s=this.B(new A.$Vd),this.t=this.B(new A.$Vd),this.u=this.B(new A.$Vd),this.w=this.B(new A.$Vd),this.y=[],this.B((0,k.$Rc)(()=>{this.j.forEach(({task:j})=>j.cancel()),this.m.forEach(j=>j.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(s){const o=await this.getTargetPlatform();return s.allTargetPlatforms.some(c=>(0,m.$wo)(c,s.allTargetPlatforms,o))}async installFromGallery(s,o={}){try{const I=(await this.installGalleryExtensions([{extension:s,options:o}])).find(({identifier:O})=>(0,f.$1o)(O,s.identifier));if(I?.local)return I?.local;throw I?.error?I.error:new m.$zo(`Unknown error while installing extension ${s.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(c){throw i(c)}}async installGalleryExtensions(s){if(!this.z.isEnabled())throw new m.$zo(E.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const o=[],c=[];await Promise.allSettled(s.map(async({extension:I,options:O})=>{try{const y=await this.O(I,!!O?.installGivenVersion,!!O?.installPreReleaseVersion);c.push({...y,options:O})}catch(y){o.push({identifier:I.identifier,operation:2,source:I,error:y})}})),c.length&&o.push(...await this.I(c));for(const I of o)I.error&&(this.F.error("Failed to install extension.",I.identifier.id),this.F.error(I.error),I.source&&!v.URI.isUri(I.source)&&r(this.C,"extensionGallery:install",{extensionData:(0,f.$9o)(I.source),error:I.error}));return o}async uninstall(s,o={}){return this.F.trace("ExtensionManagementService#uninstall",s.identifier.id),this.Q(s,o)}async toggleAppliationScope(s,o){if((0,b.$om)(s.manifest)||s.isBuiltin)return s;if(s.isApplicationScoped){let c=await this.updateMetadata(s,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)||(c=await this.ab(s,this.H.defaultProfile.extensionsResource,o));for(const I of this.H.profiles){const O=(await this.getInstalled(1,I.extensionsResource)).find(y=>(0,f.$1o)(y.identifier,s.identifier));O?this.w.fire(O):this.u.fire({identifier:s.identifier,profileLocation:I.extensionsResource})}return c}else{const c=this.D.extUri.isEqual(o,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(s,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(s,o,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:c.identifier,operation:2,local:c,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),c}}getExtensionsControlManifest(){const s=new Date().getTime();return(!this.g||s-this.h>1e3*60*5)&&(this.g=this.X(),this.h=s),this.g}registerParticipant(s){this.y.push(s)}async I(s){const o=[];return await Promise.allSettled(s.map(async c=>{try{const I=await this.J(c,(O,y)=>s.some(j=>(0,f.$5o)(y.identifier.id)===(0,f.$6o)(j.manifest.publisher,j.manifest.name))?!1:this.L(O,y));o.push(...I)}catch(I){o.push({identifier:{id:(0,f.$6o)(c.manifest.publisher,c.manifest.name)},operation:2,source:c.extension,error:I})}})),this.s.fire(o),o}async J({manifest:s,extension:o,options:c},I){const O=c.isApplicationScoped||c.isBuiltin||(0,b.$om)(s),y={...c,installOnlyNewlyAddedFromExtensionPack:v.URI.isUri(o)?c.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:O,profileLocation:O?this.H.defaultProfile.extensionsResource:c.profileLocation??this.Y()},j=he=>`${f.$2o.create(he).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!v.URI.isUri(o)){const he=this.j.get(j(o));if(he)return this.F.info("Extensions is already requested to install",o.identifier.id),await he.task.waitUntilTaskIsFinished(),[]}const H=[],te=[],_=[],oe=this.Z(s,o,y);v.URI.isUri(o)||this.j.set(j(o),{task:oe,waitingTasks:[]}),this.n.fire({identifier:oe.identifier,source:o,profileLocation:y.profileLocation}),this.F.info("Installing extension:",oe.identifier.id),H.push({task:oe,manifest:s});let re=!1;try{if(y.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",oe.identifier.id);else try{const ce=await this.N(oe.identifier,s,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),ae=await this.getInstalled(void 0,y.profileLocation),q={...y,donotIncludePackAndDependencies:!0,context:{...y.context,[m.$ro]:!0}};for(const{gallery:Q,manifest:M}of(0,L.$Mb)(ce,({gallery:T})=>T.identifier.id)){re=re||!!M.extensionDependencies?.some(X=>(0,f.$1o)({id:X},oe.identifier));const T=j(Q),B=this.j.get(T);if(B){if(I(oe,B.task)){const X=B.task.identifier;this.F.info("Waiting for already requested installing extension",X.id,oe.identifier.id),B.waitingTasks.push(oe),te.push(A.Event.toPromise(A.Event.filter(this.onDidInstallExtensions,Z=>Z.some(x=>(0,f.$1o)(x.identifier,X)))).then(Z=>{if(this.F.info("Finished waiting for already requested installing extension",X.id,oe.identifier.id),!Z.find(F=>(0,f.$1o)(F.identifier,X))?.local)throw new Error(`Extension ${X.id} is not installed`)}))}}else if(!ae.some(({identifier:X})=>(0,f.$1o)(X,Q.identifier))){const X=this.Z(M,Q,q);this.j.set(T,{task:X,waitingTasks:[oe]}),this.n.fire({identifier:X.identifier,source:Q,profileLocation:y.profileLocation}),this.F.info("Installing extension:",X.identifier.id,oe.identifier.id),H.push({task:X,manifest:M})}}}catch(ce){if(v.URI.isUri(oe.source))(0,L.$Lb)(s.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",oe.identifier.id,ce.message),(0,L.$Lb)(s.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",oe.identifier.id,ce.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",oe.identifier.id),ce}const he=H.reduce((ce,{task:ae,manifest:q})=>(ce.set(ae.identifier.id.toLowerCase(),{task:ae,manifest:q}),ce),new Map);for(;he.size;){let ce;const ae=[...he.values()].filter(({manifest:q})=>!q.extensionDependencies?.some(Q=>he.has(Q.toLowerCase())));ae.length?ce=he.size===1?ae:ae.filter(({task:q})=>!(q===oe&&!re)):(this.F.info("Found extensions with circular dependencies",ae.map(({task:q})=>q.identifier.id)),ce=[...he.values()]),await this.M(ce.map(async({task:q})=>{const Q=new Date().getTime();try{const M=await q.run();if(await this.M(this.y.map(T=>T.postInstall(M,q.source,y,R.CancellationToken.None))),!v.URI.isUri(q.source)){const T=q.operation===3,B=T?void 0:(new Date().getTime()-q.source.lastUpdated)/1e3;if(r(this.C,T?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,f.$9o)(q.source),verificationStatus:q.verificationStatus,duration:new Date().getTime()-Q,durationSinceUpdate:B}),u.$o&&q.operation!==3)try{await this.z.reportStatistic(M.manifest.publisher,M.manifest.name,M.manifest.version,"install")}catch{}}_.push({local:M,identifier:q.identifier,operation:q.operation,source:q.source,context:q.options.context,profileLocation:q.profileLocation,applicationScoped:M.isApplicationScoped})}catch(M){throw this.F.error("Error while installing the extension",q.identifier.id,(0,N.$0)(M)),M}finally{he.delete(q.identifier.id.toLowerCase())}}))}return te.length&&await this.M(te),_.forEach(({identifier:ce})=>this.F.info("Extension installed successfully:",ce.id)),_}catch(he){if(H.forEach(({task:ce})=>ce.cancel()),_.length)try{const ce=await Promise.allSettled(_.map(({local:ae})=>this.$(ae,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let ae=0;ae<ce.length;ae++){const q=ce[ae],{identifier:Q}=_[ae];q.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Q.id):this.F.warn("Rollback: Error while uninstalling extension",Q.id,(0,N.$0)(q.reason))}}catch(ce){this.F.warn("Error while rolling back extensions",(0,N.$0)(ce),_.map(({identifier:ae})=>ae.id))}return H.map(({task:ce})=>({identifier:ce.identifier,operation:2,source:ce.source,context:y.context,profileLocation:y.profileLocation,error:he}))}finally{for(const{task:he}of H)he.source&&!v.URI.isUri(he.source)&&this.j.delete(j(he.source))}}L(s,o){for(const[,{task:c,waitingTasks:I}]of this.j.entries())if(c===s&&(I.includes(o)||I.some(O=>this.L(O,o)))||c===o&&I[0]&&!this.L(s,I[0]))return!1;return!0}async M(s){const o=[],c=[],I=await Promise.allSettled(s);for(const O of I)O.status==="fulfilled"?o.push(O.value):c.push(O.reason);if(c.length)throw g(c);return o}async N(s,o,c,I,O){if(!this.z.isEnabled())return[];const y=await this.getInstalled(void 0,O),j=[],H=[],te=async(_,oe)=>{j.push(_);const re=oe.extensionDependencies||[],he=[...re];if(oe.extensionPack){const ce=c?y.find(ae=>(0,f.$1o)(ae.identifier,_)):void 0;for(const ae of oe.extensionPack)ce&&ce.manifest.extensionPack&&ce.manifest.extensionPack.some(q=>(0,f.$1o)({id:q},{id:ae}))||he.every(q=>!(0,f.$1o)({id:q},{id:ae}))&&he.push(ae)}if(he.length){const ce=he.filter(ae=>j.every(q=>!(0,f.$1o)(q,{id:ae})));if(ce.length){const ae=await this.z.getExtensions(ce.map(q=>({id:q,preRelease:I})),R.CancellationToken.None);for(const q of ae){if(j.find(T=>(0,f.$1o)(T,q.identifier)))continue;const Q=re.some(T=>(0,f.$1o)({id:T},q.identifier));let M;try{M=await this.O(q,!1,I)}catch(T){if(Q)throw T;this.F.info("Skipping the packed extension as it cannot be installed",q.identifier.id,(0,N.$0)(T));continue}H.push({gallery:M.extension,manifest:M.manifest}),await te(M.extension.identifier,M.manifest)}}}};return await te(s,o),H}async O(s,o,c){let I;const O=await this.getExtensionsControlManifest();if(O.malicious.some(H=>(0,f.$1o)(s.identifier,H)))throw new m.$zo(E.localize(1,null,s.identifier.id),m.ExtensionManagementErrorCode.Malicious);const y=O.deprecated[s.identifier.id.toLowerCase()];if(y?.extension?.autoMigrate){if(this.F.info(`The '${s.identifier.id}' extension is deprecated, fetching the compatible '${y.extension.id}' extension instead.`),I=(await this.z.getExtensions([{id:y.extension.id,preRelease:y.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},R.CancellationToken.None))[0],!I)throw new m.$zo(E.localize(2,null,s.identifier.id,y.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(s)){const H=await this.getTargetPlatform();throw new m.$zo(E.localize(3,null,s.identifier.id,this.G.nameLong,(0,m.$so)(H)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(I=await this.P(s,o,c),!I)throw!c&&s.properties.isPreReleaseVersion&&(await this.z.getExtensions([s.identifier],R.CancellationToken.None))[0]?new m.$zo(E.localize(4,null,s.displayName??s.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$zo(E.localize(5,null,s.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",I.identifier.id);const j=await this.z.getManifest(I,R.CancellationToken.None);if(j===null)throw new m.$zo(`Missing manifest for extension ${I.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(j.version!==I.version)throw new m.$zo(`Cannot install '${I.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:I,manifest:j}}async P(s,o,c){const I=await this.getTargetPlatform();let O=null;return!o&&s.hasPreReleaseVersion&&s.properties.isPreReleaseVersion!==c&&(O=(await this.z.getExtensions([{...s.identifier,preRelease:c}],{targetPlatform:I,compatible:!0},R.CancellationToken.None))[0]||null),!O&&await this.z.isExtensionCompatible(s,c,I)&&(O=s),O||(o?O=(await this.z.getExtensions([{...s.identifier,version:s.version}],{targetPlatform:I,compatible:!0},R.CancellationToken.None))[0]||null:O=await this.z.getCompatibleExtension(s,c,I)),O}async Q(s,o){const c={...o,profileLocation:s.isApplicationScoped?this.H.defaultProfile.extensionsResource:o.profileLocation??this.Y()},I=_=>`${_.id.toLowerCase()}${c.versionOnly?`-${s.manifest.version}`:""}${c.profileLocation?`@${c.profileLocation.toString()}`:""}`,O=this.m.get(I(s.identifier));if(O)return this.F.info("Extensions is already requested to uninstall",s.identifier.id),O.waitUntilTaskIsFinished();const y=_=>{const oe=this.$(_,c);return this.m.set(I(oe.extension.identifier),oe),c.profileLocation?this.F.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString()):this.F.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this.t.fire({identifier:_.identifier,profileLocation:c.profileLocation,applicationScoped:_.isApplicationScoped}),oe},j=(_,oe)=>{oe?c.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString(),oe.message):this.F.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,oe.message):c.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,c.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),r(this.C,"extensionGallery:uninstall",{extensionData:(0,f.$8o)(_),error:oe}),this.u.fire({identifier:_.identifier,error:oe?.code,profileLocation:c.profileLocation,applicationScoped:_.isApplicationScoped})},H=[],te=[];try{H.push(y(s));const _=await this.getInstalled(1,c.profileLocation);if(c.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${s.identifier.id}@${s.manifest.version}`);else{const oe=this.U(s,_);for(const re of oe)this.m.has(I(re.identifier))?this.F.info("Extensions is already requested to uninstall",re.identifier.id):H.push(y(re))}c.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${s.identifier.id}@${s.manifest.version}`):this.R(H.map(oe=>oe.extension),_,s),await this.M(H.map(async oe=>{try{if(await oe.run(),await this.M(this.y.map(re=>re.postUninstall(oe.extension,c,R.CancellationToken.None))),oe.extension.identifier.uuid)try{await this.z.reportStatistic(oe.extension.manifest.publisher,oe.extension.manifest.name,oe.extension.manifest.version,"uninstall")}catch{}j(oe.extension)}catch(re){const he=re instanceof m.$zo?re:new m.$zo((0,N.$0)(re),m.ExtensionManagementErrorCode.Internal);throw j(oe.extension,he),he}finally{te.push(oe)}}))}catch(_){const oe=_ instanceof m.$zo?_:new m.$zo((0,N.$0)(_),m.ExtensionManagementErrorCode.Internal);for(const re of H){try{re.cancel()}catch{}te.includes(re)||j(re.extension,oe)}throw oe}finally{for(const _ of H)this.m.delete(I(_.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}R(s,o,c){for(const I of s){const O=this.W(I,o);if(O.length){const y=O.filter(j=>!s.some(H=>(0,f.$1o)(H.identifier,j.identifier)));if(y.length)throw new Error(this.S(I,y,c))}}}S(s,o,c){return c===s?o.length===1?E.localize(6,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(7,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(8,null,c.manifest.displayName||c.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?E.localize(9,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?E.localize(10,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):E.localize(11,null,c.manifest.displayName||c.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}U(s,o,c=[]){if(c.indexOf(s)!==-1)return[];c.push(s);const I=s.manifest.extensionPack?s.manifest.extensionPack:[];if(I.length){const O=o.filter(j=>!j.isBuiltin&&I.some(H=>(0,f.$1o)({id:H},j.identifier))),y=[];for(const j of O)y.push(...this.U(j,o,c));return[...O,...y]}return[]}W(s,o){return o.filter(c=>c.manifest.extensionDependencies&&c.manifest.extensionDependencies.some(I=>(0,f.$1o)({id:I},s.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const s=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",s),s}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Qp=h,e.$Qp=h=me([se(0,m.$yo),se(1,l.$ul),se(2,w.$1k),se(3,S.$nj),se(4,$.$Fj),se(5,p.$3k)],h);function g(n){const s=Array.isArray(n)?n:[n];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,c)=>new Error(`${o.message}${o.message?",":""}${c instanceof Error?c.message:c}`),new Error(""))}e.$Rp=g;function i(n){if(n instanceof m.$zo)return n;if(n instanceof m.$Ao){const o=new m.$zo(n.message,m.ExtensionManagementErrorCode.Gallery);return o.stack=n.stack,o}const s=new m.$zo(n.message,m.ExtensionManagementErrorCode.Internal);return s.stack=n.stack,s}e.$Sp=i;function r(n,s,{extensionData:o,verificationStatus:c,duration:I,error:O,durationSinceUpdate:y}){let j,H;(0,a.$Qf)(c)&&(c===!0?c="Verified":(c===!1||(j=m.ExtensionManagementErrorCode.Signature,H=c),c="Unverified")),O&&(O instanceof m.$zo||O instanceof m.$Ao?(j=O.code,O.code===m.ExtensionManagementErrorCode.Signature&&(H=O.message)):j=m.ExtensionManagementErrorCode.Internal),n.publicLog(s,{...o,verificationStatus:c,success:!O,duration:I,errorcode:j,errorcodeDetail:H,durationSinceUpdate:y})}class t{constructor(){this.d=new D.$5g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,D.$Tg)(s=>this.h(s))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,D.$Tg)(s=>new Promise((o,c)=>{const I=s.onCancellationRequested(()=>{I.dispose(),c(new N.$5)})})),this.d.open()),this.g.cancel()}}e.$Tp=t}),define(ie[42],ne([0,1,9,14,2,6,31,11,21,26,13,10,4,23,22,3,7,25]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class p extends Error{constructor(t,n){super(t),this.code=n}}e.$Up=p,e.$Vp=(0,E.$6h)("IExtensionsProfileScannerService");let h=class extends R.$Tc{constructor(t,n,s,o,c,I){super(),this.j=t,this.m=n,this.n=s,this.r=o,this.s=c,this.t=I,this.b=this.B(new N.$Vd),this.onAddExtensions=this.b.event,this.c=this.B(new N.$Vd),this.onDidAddExtensions=this.c.event,this.f=this.B(new N.$Vd),this.onRemoveExtensions=this.f.event,this.g=this.B(new N.$Vd),this.onDidRemoveExtensions=this.g.event,this.h=new A.$Ac}scanProfileExtensions(t,n){return this.u(t,void 0,n)}async addExtensionsToProfile(t,n){const s=[],o=[];try{return await this.u(n,c=>{const I=[];for(const O of c)t.some(([y])=>(0,a.$1o)(y.identifier,O.identifier)&&y.manifest.version!==O.version)?s.push(O):I.push(O);for(const[O,y]of t){const j=I.findIndex(te=>(0,a.$1o)(te.identifier,O.identifier)&&te.version===O.manifest.version),H={identifier:O.identifier,version:O.manifest.version,location:O.location,metadata:y};j===-1?(o.push(H),I.push(H)):I.splice(j,1,H)}return o.length&&this.b.fire({extensions:o,profileLocation:n}),s.length&&this.f.fire({extensions:s,profileLocation:n}),I}),o.length&&this.c.fire({extensions:o,profileLocation:n}),s.length&&this.g.fire({extensions:s,profileLocation:n}),o}catch(c){throw o.length&&this.c.fire({extensions:o,error:c,profileLocation:n}),s.length&&this.g.fire({extensions:s,error:c,profileLocation:n}),c}}async updateMetadata(t,n){const s=[];return await this.u(n,o=>{const c=[];for(const I of o){const O=t.find(([y])=>(0,a.$1o)(y.identifier,I.identifier)&&y.manifest.version===I.version);O&&(I.metadata={...I.metadata,...O[1]},s.push(I)),c.push(I)}return c}),s}async removeExtensionFromProfile(t,n){const s=[];try{await this.u(n,o=>{const c=[];for(const I of o)(0,a.$1o)(I.identifier,t.identifier)?s.push(I):c.push(I);return s.length&&this.f.fire({extensions:s,profileLocation:n}),c}),s.length&&this.g.fire({extensions:s,profileLocation:n})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:n}),o}}async u(t,n,s){return this.F(t).queue(async()=>{let o=[],c;try{const I=await this.m.readFile(t);c=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,v.$Hk)(I)!==1)throw I;if(this.r.extUri.isEqual(t,this.n.defaultProfile.extensionsResource)&&(c=await this.D()),!c&&s?.bailOutWhenFileNotFound)throw new p((0,$.$0)(I),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.w(t);let I=!1;for(const O of c){g(O)||this.w(t);let y;if((0,S.$If)(O.relativeLocation)&&O.relativeLocation)y=this.z(O.relativeLocation);else if((0,S.$If)(O.location))y=this.z(O.location),I=!0,O.relativeLocation=O.location,O.location=y.toJSON();else{y=k.URI.revive(O.location);const j=this.y(y);j&&(I=!0,O.relativeLocation=j)}o.push({identifier:O.identifier,location:y,version:O.version,metadata:O.metadata})}I&&await this.m.writeFile(t,D.$je.fromString(JSON.stringify(c)))}if(n){o=n(o);const I=o.map(O=>({identifier:O.identifier,version:O.version,location:O.location.toJSON(),relativeLocation:this.y(O.location),metadata:O.metadata}));await this.m.writeFile(t,D.$je.fromString(JSON.stringify(I)))}return o})}w(t){const n=new p(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}y(t){return this.r.extUri.isEqual(this.r.extUri.dirname(t),this.j)?this.r.extUri.basename(t):void 0}z(t){return this.r.extUri.joinPath(this.j,t)}async D(){return this.C||(this.C=(async()=>{const t=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),n=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(t)).value.toString()}catch(c){if((0,v.$Hk)(c)===1)return;throw c}this.t.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(I=>g(I))?o=c:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.t.error(c)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,D.$je.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",t.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(c){if((0,v.$Hk)(c)===3)this.t.info("Migration from old default profile location to new location is done by another window",t.toString(),this.n.defaultProfile.extensionsResource.toString());else throw c}try{await this.m.del(t)}catch(c){(0,v.$Hk)(c)!==1&&this.t.error(c)}try{await this.m.del(n)}catch(c){(0,v.$Hk)(c)!==1&&this.t.error(c)}return o})()),this.C}F(t){let n=this.h.get(t);return n||(n=new L.$ah,this.h.set(t,n)),n}};e.$Wp=h,e.$Wp=h=me([se(1,v.$qk),se(2,f.$3k),se(3,b.$1k),se(4,l.$ul),se(5,m.$nj)],h);function g(r){return(0,S.$Kf)(r)&&(0,u.$xo)(r.identifier)&&(i(r.location)||(0,S.$If)(r.location)&&r.location)&&((0,S.$Pf)(r.relativeLocation)||(0,S.$If)(r.relativeLocation))&&r.version&&(0,S.$If)(r.version)}function i(r){return r?(0,S.$If)(r.path)&&(0,S.$If)(r.scheme):!1}}),define(ie[52],ne([0,1,19,9,27,14,7,38,81,2,15,16,12,17,44,54,3,11,98,18,26,37,50,13,10,4,32,6,47,42,23,22,115]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w,p,h,g,i,r,t,n,s,o,c,I,O,y,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.Translations=void 0;var H;(function(ae){function q(Q,M){if(Q===M)return!0;const T=Object.keys(Q),B=new Set;for(const X of Object.keys(M))B.add(X);if(T.length!==B.size)return!1;for(const X of T){if(Q[X]!==M[X])return!1;B.delete(X)}return B.size===0}ae.equals=q})(H||(e.Translations=H={})),e.$Zp=(0,t.$6h)("IExtensionsScannerService");let te=class extends a.$Tc{constructor(q,Q,M,T,B,X,Z,x,F,C,d,P){super(),this.systemExtensionsLocation=q,this.userExtensionsLocation=Q,this.r=M,this.s=T,this.t=B,this.u=X,this.w=Z,this.y=x,this.z=F,this.C=C,this.D=d,this.F=P,this.g=this.B(new o.$Vd),this.onDidChangeCache=this.g.event,this.h=(0,f.$Hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(re,this.s,this.h)),this.m=this.B(this.F.createInstance(re,this.s,this.h)),this.n=this.B(this.F.createInstance(oe,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,h.$_o)(this.w,this.y)),this.G}async scanAllExtensions(q,Q,M){const[T,B]=await Promise.all([this.scanSystemExtensions(q),this.scanUserExtensions(Q)]),X=M?await this.scanExtensionsUnderDevelopment(q,[...T,...B]):[];return this.L(T,B,X,await this.getTargetPlatform(),!0)}async scanSystemExtensions(q){const Q=[];Q.push(this.M(!!q.useCache,q.language)),Q.push(this.N(q.language,!!q.checkControlFile));const[M,T]=await Promise.all(Q);return this.J([...M,...T],0,q,!1)}async scanUserExtensions(q){const Q=q.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Q);const M=this.D.extUri.isEqual(q.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(Q,!!q.profileLocation,1,!q.includeUninstalled,q.language,!0,M),B=q.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let X;try{X=await B.scanExtensions(T)}catch(Z){if(Z instanceof I.$Up&&Z.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),X=await B.scanExtensions(T);else throw Z}return X=await this.J(X,1,q,!0),this.y.trace("Scanned user extensions:",X.length),X}async scanExtensionsUnderDevelopment(q,Q){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const M=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===v.Schemas.file).map(async T=>{const B=await this.P(T,!1,1,!0,q.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(B)).map(Z=>(Z.type=Q.find(x=>(0,h.$1o)(x.identifier,Z.identifier))?.type??Z.type,this.n.validate(Z,B)))}))).flat();return this.J(M,"development",q,!0)}return[]}async scanExistingExtension(q,Q,M){const T=await this.P(q,!1,Q,!0,M.language,!0,void 0),B=await this.n.scanExtension(T);return!B||!M.includeInvalid&&!B.isValid?null:B}async scanOneOrMultipleExtensions(q,Q,M){const T=await this.P(q,!1,Q,!0,M.language,!0,void 0),B=await this.n.scanOneOrMultipleExtensions(T);return this.J(B,Q,M,!0)}async scanMetadata(q){const Q=(0,f.$Hg)(q,"package.json"),M=(await this.w.readFile(Q)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(q,Q){const M=(0,f.$Hg)(q,"package.json"),T=(await this.w.readFile(M)).value.toString(),B=JSON.parse(T);Q.isMachineScoped===!1&&delete Q.isMachineScoped,Q.isBuiltin===!1&&delete Q.isBuiltin,B.__metadata={...B.__metadata,...Q},await this.w.writeFile((0,f.$Hg)(q,"package.json"),N.$je.fromString(JSON.stringify(B,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(q){if(q instanceof I.$Up&&q.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw q}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const q=await this.scanUserExtensions({includeInvalid:!0});if(q.length)await this.u.addExtensionsToProfile(q.map(Q=>[Q,Q.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,N.$je.fromString(JSON.stringify([])))}catch(Q){(0,r.$Hk)(Q)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,A.$0)(Q))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(q){this.y.error(q)}finally{this.H=void 0}})()),this.H}async J(q,Q,M,T){return M.includeAllVersions||(q=this.L(Q===0?q:void 0,Q===1?q:void 0,Q==="development"?q:void 0,await this.getTargetPlatform(),T)),M.includeInvalid||(q=q.filter(B=>B.isValid)),q.sort((B,X)=>{const Z=E.$nc(B.location.fsPath),x=E.$nc(X.location.fsPath);return Z<x?-1:Z>x?1:0})}L(q,Q,M,T,B){const X=(x,F,C)=>{if(x.isValid&&!F.isValid)return!1;if(x.isValid===F.isValid){if(B&&b.gt(x.manifest.version,F.manifest.version))return this.y.debug(`Skipping extension ${F.location.path} with lower version ${F.manifest.version} in favour of ${x.location.path} with version ${x.manifest.version}`),!1;if(b.eq(x.manifest.version,F.manifest.version)){if(x.type===0)return this.y.debug(`Skipping extension ${F.location.path} in favour of system extension ${x.location.path} with same version`),!1;if(x.targetPlatform===T)return this.y.debug(`Skipping extension ${F.location.path} from different target platform ${F.targetPlatform}`),!1}}return C?this.y.warn(`Overwriting user extension ${x.location.path} with ${F.location.path}.`):this.y.debug(`Overwriting user extension ${x.location.path} with ${F.location.path}.`),!0},Z=new g.$nm;return q?.forEach(x=>{const F=Z.get(x.identifier.id);(!F||X(F,x,!1))&&Z.set(x.identifier.id,x)}),Q?.forEach(x=>{const F=Z.get(x.identifier.id);if(!F&&q&&x.type===0){this.y.debug(`Skipping obsolete system extension ${x.location.path}.`);return}(!F||X(F,x,!1))&&Z.set(x.identifier.id,x)}),M?.forEach(x=>{const F=Z.get(x.identifier.id);(!F||X(F,x,!0))&&Z.set(x.identifier.id,x),Z.set(x.identifier.id,x)}),[...Z.values()]}async M(q,Q){this.y.trace("Started scanning system extensions");const M=await this.P(this.systemExtensionsLocation,!1,0,!0,Q,!0,void 0),B=await(q&&!M.devMode?this.j:this.n).scanExtensions(M);return this.y.trace("Scanned system extensions:",B.length),B}async N(q,Q){const M=this.z.isBuilt?[]:this.C.builtInExtensions;if(!M?.length)return[];this.y.trace("Started scanning dev system extensions");const T=Q?await this.O():{},B=[],X=l.URI.file(E.$hc(E.$jc(v.$og.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const x of M){const F=T[x.name]||"marketplace";switch(F){case"disabled":break;case"marketplace":B.push((0,f.$Hg)(X,x.name));break;default:B.push(l.URI.file(F));break}}const Z=await Promise.all(B.map(async x=>this.n.scanExtension(await this.P(x,!1,0,!0,q,!0,void 0))));return this.y.trace("Scanned dev system extensions:",Z.length),(0,L.$Hb)(Z)}async O(){try{const q=await this.w.readFile(this.r);return JSON.parse(q.value.toString())}catch{return{}}}async P(q,Q,M,T,B,X,Z){const x=await this.f(B??m.$w),F=await this.Q(q),C=Q&&!this.D.extUri.isEqual(q,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,d=C?await this.Q(C):void 0;return new _(q,F,C,d,Q,Z,M,T,X,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,B,x)}async Q(q){try{const Q=await this.w.stat(q);if(typeof Q.mtime=="number")return Q.mtime}catch{}}};e.$1p=te,e.$1p=te=me([se(4,O.$3k),se(5,I.$Vp),se(6,r.$qk),se(7,n.$nj),se(8,p.$ai),se(9,s.$Fj),se(10,y.$1k),se(11,t.$5h)],te);class _{constructor(q,Q,M,T,B,X,Z,x,F,C,d,P,z,U,W){this.location=q,this.mtime=Q,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=T,this.profile=B,this.profileScanOptions=X,this.type=Z,this.excludeObsolete=x,this.validate=F,this.productVersion=C,this.productDate=d,this.productCommit=P,this.devMode=z,this.language=U,this.translations=W}static createNlsConfiguration(q){return{language:q.language,pseudo:q.language==="pseudo",devMode:q.devMode,translations:q.translations}}static equals(q,Q){return(0,f.$Ag)(q.location,Q.location)&&q.mtime===Q.mtime&&(0,f.$Ag)(q.applicationExtensionslocation,Q.applicationExtensionslocation)&&q.applicationExtensionslocationMtime===Q.applicationExtensionslocationMtime&&q.profile===Q.profile&&R.$zn(q.profileScanOptions,Q.profileScanOptions)&&q.type===Q.type&&q.excludeObsolete===Q.excludeObsolete&&q.validate===Q.validate&&q.productVersion===Q.productVersion&&q.productDate===Q.productDate&&q.productCommit===Q.productCommit&&q.devMode===Q.devMode&&q.language===Q.language&&H.equals(q.translations,Q.translations)}}e.$2p=_;let oe=class extends a.$Tc{constructor(q,Q,M,T,B){super(),this.f=q,this.g=Q,this.h=M,this.j=T,this.m=B}async scanExtensions(q){const Q=q.profile?await this.r(q):await this.n(q);let M={};if(q.excludeObsolete&&q.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();M=JSON.parse(T)}catch{}return(0,$.$Vf)(M)?Q:Q.filter(T=>!M[h.$2o.create(T).toString()])}async n(q){const Q=await this.j.resolve(q.location);if(!Q.children?.length)return[];const M=await Promise.all(Q.children.map(async T=>{if(!T.isDirectory||q.type===1&&(0,f.$Eg)(T.resource).indexOf(".")===0)return null;const B=new _(T.resource,q.mtime,q.applicationExtensionslocation,q.applicationExtensionslocationMtime,q.profile,q.profileScanOptions,q.type,q.excludeObsolete,q.validate,q.productVersion,q.productDate,q.productCommit,q.devMode,q.language,q.translations);return this.scanExtension(B)}));return(0,L.$Hb)(M).sort((T,B)=>T.location.path<B.location.path?-1:1)}async r(q){let Q=await this.s(q.location,()=>!0,q);if(q.applicationExtensionslocation&&!this.h.extUri.isEqual(q.location,q.applicationExtensionslocation)){Q=Q.filter(T=>!T.metadata?.isApplicationScoped);const M=await this.s(q.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,q);Q.push(...M)}return Q}async s(q,Q,M){const T=await this.g.scanProfileExtensions(q,M.profileScanOptions);if(!T.length)return[];const B=await Promise.all(T.map(async X=>{if(Q(X)){const Z=new _(X.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(Z,X.metadata)}return null}));return(0,L.$Hb)(B)}async scanOneOrMultipleExtensions(q){try{if(await this.j.exists((0,f.$Hg)(q.location,"package.json"))){const Q=await this.scanExtension(q);return Q?[Q]:[]}else return await this.scanExtensions(q)}catch(Q){return this.m.error(`Error scanning extensions at ${q.location.path}:`,(0,A.$0)(Q)),[]}}async scanExtension(q,Q){try{let M=await this.scanExtensionManifest(q.location);if(M){M.publisher||(M.publisher=g.$hm),Q=Q??M.__metadata,delete M.__metadata;const T=(0,h.$6o)(M.publisher,M.name),B=Q?.id?{id:T,uuid:Q.id}:{id:T},X=Q?.isSystem?0:q.type,Z=X===0||!!Q?.isBuiltin;M=await this.t(q.location,M,_.createNlsConfiguration(q));const x={type:X,identifier:B,manifest:M,location:q.location,isBuiltin:Z,targetPlatform:Q?.targetPlatform??"undefined",metadata:Q,isValid:!0,validations:[]};return q.validate?this.validate(x,q):x}}catch(M){q.type!==0&&this.m.error(M)}return null}validate(q,Q){let M=!0;const T=(0,i.$ep)(Q.productVersion,Q.productDate,Q.location,q.manifest,q.isBuiltin);for(const[B,X]of T)B===S.default.Error&&(M=!1,this.m.error(this.z(Q.location,X)));return q.isValid=M,q.validations=T,q}async scanExtensionManifest(q){const Q=(0,f.$Hg)(q,"package.json");let M;try{M=(await this.j.readFile(Q)).value.toString()}catch(B){return(0,r.$Hk)(B)!==1&&this.m.error(this.z(q,(0,w.localize)(0,null,Q.path,B.message))),null}let T;try{T=JSON.parse(M)}catch{const X=[];(0,k.$cn)(M,X);for(const Z of X)this.m.error(this.z(q,(0,w.localize)(1,null,Q.path,Z.offset,Z.length,(0,u.$Xp)(Z.error))));return null}return(0,k.$ln)(T)!=="object"?(this.m.error(this.z(q,(0,w.localize)(2,null,Q.path))),null):T}async t(q,Q,M){const T=await this.u(q,Q,M);if(T)try{const B=[],X=await this.w(T.default,B);if(B.length>0)return B.forEach(x=>{this.m.error(this.z(q,(0,w.localize)(3,null,T.default?.path,(0,u.$Xp)(x.error))))}),Q;if((0,k.$ln)(T)!=="object")return this.m.error(this.z(q,(0,w.localize)(4,null,T.default?.path))),Q;const Z=T.values||Object.create(null);return(0,j.$Yp)(this.m,Q,Z,X)}catch{}return Q}async u(q,Q,M){const T=(0,f.$Hg)(q,"package.nls.json"),B=(F,C)=>{C.forEach(d=>{this.m.error(this.z(q,(0,w.localize)(5,null,F?.path,(0,u.$Xp)(d.error))))})},X=F=>{this.m.error(this.z(q,(0,w.localize)(6,null,F?.path)))},Z=`${Q.publisher}.${Q.name}`,x=M.translations[Z];if(x)try{const F=l.URI.file(x),C=(await this.j.readFile(F)).value.toString(),d=[],P=(0,k.$cn)(C,d);return d.length>0?(B(F,d),{values:void 0,default:T}):(0,k.$ln)(P)!=="object"?(X(F),{values:void 0,default:T}):{values:P.contents?P.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let C;try{C=await this.y(q,M)}catch{return}if(!C.localized)return{values:void 0,default:C.original};try{const d=(await this.j.readFile(C.localized)).value.toString(),P=[],z=(0,k.$cn)(d,P);return P.length>0?(B(C.localized,P),{values:void 0,default:C.original}):(0,k.$ln)(z)!=="object"?(X(C.localized),{values:void 0,default:C.original}):{values:z,default:C.original}}catch{return{values:void 0,default:C.original}}}}async w(q,Q){if(q)try{const M=(await this.j.readFile(q)).value.toString();return(0,k.$cn)(M,Q)}catch{}}y(q,Q){return new Promise((M,T)=>{const B=X=>{const Z=(0,f.$Hg)(q,`package.nls.${X}.json`);this.j.exists(Z).then(x=>{x&&M({localized:Z,original:(0,f.$Hg)(q,"package.nls.json")});const F=X.lastIndexOf("-");F===-1?M({localized:(0,f.$Hg)(q,"package.nls.json"),original:null}):(X=X.substring(0,F),B(X))})};if(Q.devMode||Q.pseudo||!Q.language)return M({localized:(0,f.$Hg)(q,"package.nls.json"),original:null});B(Q.language)})}z(q,Q){return`[${q.path}]: ${Q}`}};oe=me([se(1,I.$Vp),se(2,y.$1k),se(3,r.$qk),se(4,n.$nj)],oe);let re=class extends oe{constructor(q,Q,M,T,B,X,Z){super(Q,T,B,X,Z),this.G=q,this.H=M,this.D=this.B(new D.$4g(3e3)),this.F=this.B(new o.$Vd),this.onDidChangeCache=this.F.event}async scanExtensions(q){const Q=this.M(q),M=await this.I(Q);if(this.C=q,M&&M.input&&_.equals(M.input,this.C))return this.m.debug("Using cached extensions scan result",q.location.toString()),this.D.trigger(()=>this.L()),M.result.map(B=>(B.location=l.URI.revive(B.location),B));const T=await super.scanExtensions(q);return await this.J(Q,{input:q,result:T}),T}async I(q){try{const Q=await this.j.readFile(q),M=JSON.parse(Q.value.toString());return{result:M.result,input:(0,c.$Ch)(M.input)}}catch(Q){this.m.debug("Error while reading the extension cache file:",q.path,(0,A.$0)(Q))}return null}async J(q,Q){try{await this.j.writeFile(q,N.$je.fromString(JSON.stringify(Q)))}catch(M){this.m.debug("Error while writing the extension cache file:",q.path,(0,A.$0)(M))}}async L(){if(!this.C)return;const q=this.M(this.C),Q=await this.I(q);if(!Q)return;const M=Q.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!R.$zn(T,M))try{this.m.info("Invalidating Cache",M,T),await this.j.del(q),this.F.fire()}catch(B){this.m.error(B)}}M(q){const Q=this.N(q);return this.h.extUri.joinPath(Q.cacheHome,q.type===0?g.$gm:g.$fm)}N(q){return q.type===0?this.H.defaultProfile:q.profile?this.h.extUri.isEqual(q.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Q=>this.h.extUri.isEqual(q.location,Q.extensionsResource))??this.G:this.H.defaultProfile}};re=me([se(2,O.$3k),se(3,I.$Vp),se(4,y.$1k),se(5,r.$qk),se(6,n.$nj)],re);function he(ae,q){const Q=(0,h.$4o)(ae.manifest.publisher,ae.manifest.name);return{id:Q,identifier:new g.$lm(Q),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:q,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}e.$3p=he;class ce extends te{constructor(q,Q,M,T,B,X,Z,x,F,C,d,P){super(q,Q,(0,f.$Hg)(M,".vscode-oss-dev","extensions","control.json"),T,B,X,Z,x,F,C,d,P),this.R=(async()=>{if(m.$z)try{const z=await this.w.readFile(l.URI.file(m.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(q){return this.R}}e.$4p=ce}),define(ie[158],ne([0,1,58,9,34,6,2,15,16,24,4,23]),function(J,e,L,D,R,N,A,k,u,a,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=void 0;let m=class extends A.$Tc{constructor(b,S){super(),this.b=b,this.f=S,this.a=new D.$_g(5)}async postUninstall(b){const S=this.g(b,"uninstall");S&&(this.f.info(b.identifier.id,b.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(S.script,"uninstall",S.args,!0,b),this.f.info("Finished running post uninstall script",b.identifier.id,b.manifest.version)}catch($){this.f.error("Failed to run post uninstall script",b.identifier.id,b.manifest.version),this.f.error($)}}));try{await a.Promises.rm(this.m(b))}catch($){this.f.error("Error while removing extension storage path",b.identifier.id),this.f.error($)}}g(b,S){const $=`vscode:${S}`;if(b.location.scheme===k.Schemas.file&&b.manifest&&b.manifest.scripts&&typeof b.manifest.scripts[$]=="string"){const l=b.manifest.scripts[$].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.f.warn(b.identifier.id,b.manifest.version,`${$} should be a node script`),null):{script:(0,u.$jc)(b.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}h(b,S,$,l,w){return new Promise((p,h)=>{const g=this.j(b,S,$,w);let i;const r=t=>{i&&(clearTimeout(i),i=null),t?h(t):p(void 0)};g.on("error",t=>{r((0,R.$Qi)(t)||"Unknown")}),g.on("exit",(t,n)=>{r(t?`post-${S} process exited with code ${t}`:void 0)}),l&&(i=setTimeout(()=>{i=null,g.kill(),h("timed out")},5e3))})}j(b,S,$,l){const w={silent:!0,execArgv:void 0},p=(0,L.fork)(b,[`--type=extension-post-${S}`,...$],w);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const h=N.Event.fromNodeEventEmitter(p.stdout,"data"),g=N.Event.fromNodeEventEmitter(p.stderr,"data");h(t=>this.f.info(l.identifier.id,l.manifest.version,`post-${S}`,t)),g(t=>this.f.error(l.identifier.id,l.manifest.version,`post-${S}`,t));const i=N.Event.any(N.Event.map(h,t=>({data:`%c${t}`,format:[""]})),N.Event.map(g,t=>({data:`%c${t}`,format:["color: red"]})));return N.Event.debounce(i,(t,n)=>t?{data:t.data+n.data,format:[...t.format,...n.format]}:{data:n.data,format:n.format},100)(t=>{console.group(l.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),p}m(b){return(0,u.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,b.identifier.id.toLowerCase())}};e.$6p=m,e.$6p=m=me([se(0,E.$3k),se(1,v.$nj)],m)}),define(ie[159],ne([0,1,9,14,20,34,7,6,43,2,31,15,16,17,44,3,11,28,24,49,99,59,18,157,21,26,42,52,144,158,116,137,145,50,13,10,4,32,25,22,23]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w,p,h,g,i,r,t,n,s,o,c,I,O,y,j,H,te,_,oe,re,he,ce,ae){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=void 0,e.$0p=(0,_.$7h)(t.$Bo);const q=".vsctmp";let Q=class extends r.$Qp{constructor(F,C,d,P,z,U,W,G,ee,ue,fe,$e){super(F,C,fe,d,ue,$e),this.fb=z,this.gb=U,this.hb=W,this.ib=ee,this.eb=new Map,this.rb=new v.$Bc;const we=this.B(G.createInstance(I.$6p));this.bb=this.B(G.createInstance(M,le=>we.postUninstall(le))),this.cb=this.B(new y.$8p($e,ee,fe,this,this.F)),this.db=this.B(G.createInstance(c.$5p));const de=this.B(new j.$9p(this,this.fb,$e,U,fe,ee,d));this.B(de.onDidChangeExtensionsByAnotherSource(le=>this.qb(le))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,n.$_o)(this.ib,this.F)),this.jb}async zip(F){this.F.trace("ExtensionManagementService#zip",F.identifier.id);const C=await this.pb(F),d=await(0,p.zip)((0,f.$Hg)(this.db.extensionsDownloadDir,(0,l.$qg)()).fsPath,C);return $.URI.file(d)}async unzip(F){return this.F.trace("ExtensionManagementService#unzip",F.toString()),(await this.install(F)).identifier}async getManifest(F){const{location:C,cleanup:d}=await this.lb(F),P=m.$kc(C.fsPath);try{return await(0,O.$7p)(P)}finally{await d()}}getInstalled(F,C=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(F??null,C)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(F){return this.bb.scanUserExtensionAtLocation(F)}async install(F,C={}){this.F.trace("ExtensionManagementService#install",F.toString());const{location:d,cleanup:P}=await this.lb(F);try{const z=await(0,O.$7p)(m.$kc(d.fsPath)),U=(0,n.$6o)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,H.$gp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(h.localize(0,null,U,this.G.version));const G=(await this.I([{manifest:z,extension:d,options:C}])).find(({identifier:ee})=>(0,n.$1o)(ee,{id:U}));if(G?.local)return G.local;throw G?.error?G.error:(0,r.$Sp)(new Error(`Unknown error while installing extension ${U}`))}finally{await P()}}async installFromLocation(F,C){this.F.trace("ExtensionManagementService#installFromLocation",F.toString());const d=await this.bb.scanUserExtensionAtLocation(F);if(!d)throw new Error(`Cannot find a valid extension from the location ${F.toString()}`);return await this.ub([[d,void 0]],C),this.F.info("Successfully installed extension",d.identifier.id,C.toString()),d}async installExtensionsFromProfile(F,C,d){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",F,C.toString(),d.toString());const P=(await this.bb.scanExtensions(1,C)).filter(z=>F.some(U=>(0,n.$1o)(U,z.identifier)));if(P.length){const z=await Promise.all(P.map(U=>this.bb.scanMetadata(U,C)));await this.ub(P.map((U,W)=>[U,z[W]]),d),this.F.info("Successfully installed extensions",P.map(U=>U.identifier.id),d.toString())}return P}async updateMetadata(F,C,d=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",F.identifier.id),C.isPreReleaseVersion&&(C.preRelease=!0),C.isMachineScoped===!1&&(C.isMachineScoped=void 0),C.isBuiltin===!1&&(C.isBuiltin=void 0),C.pinned===!1&&(C.pinned=void 0),F=await this.bb.updateMetadata(F,C,d),this.cb.invalidate(d),this.w.fire(F),F}async reinstallFromGallery(F){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",F.identifier.id),!this.z.isEnabled())throw new Error(h.localize(1,null));const C=await this.getTargetPlatform(),[d]=await this.z.getExtensions([{...F.identifier,preRelease:F.preRelease}],{targetPlatform:C,compatible:!0},R.CancellationToken.None);if(!d)throw new Error(h.localize(2,null));await this.bb.setUninstalled(F);try{await this.bb.removeUninstalledExtension(F)}catch(P){throw new Error(h.localize(3,null,(0,N.$Qi)(P)))}return this.installFromGallery(d)}ab(F,C,d,P){return this.bb.copyExtension(F,C,d,P)}copyExtensions(F,C){return this.bb.copyExtensions(F,C)}markAsUninstalled(...F){return this.bb.setUninstalled(...F)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(F){this.F.error(F)}}async download(F,C,d){const{location:P}=await this.db.download(F,C,!d);return P}async lb(F){if(F.scheme===E.Schemas.file)return{location:F,async cleanup(){}};this.F.trace("Downloading extension from",F.toString());const C=(0,f.$Hg)(this.db.extensionsDownloadDir,(0,l.$qg)());return await this.hb.download(F,C),this.F.info("Downloaded extension to",C.toString()),{location:C,cleanup:async()=>{try{await this.ib.del(C)}catch(P){this.F.error(P)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(F,C,d){if($.URI.isUri(C))return new X(F,C,d,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const P=n.$2o.create(C).toString();let z=this.eb.get(P);return z||(this.eb.set(P,z=new B(F,C,d,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.eb.delete(P))),z}$(F,C){return new Z(F,C.profileLocation,this.gb)}async pb(F){const C=async P=>{let z=await w.Promises.readdir(P);z=z.map(G=>m.$jc(P,G));const U=await Promise.all(z.map(G=>w.Promises.stat(G)));let W=Promise.resolve([]);return U.forEach((G,ee)=>{const ue=z[ee];G.isFile()&&(W=W.then(fe=>[...fe,ue])),G.isDirectory()&&(W=W.then(fe=>C(ue).then($e=>[...fe,...$e])))}),W};return(await C(F.location.fsPath)).map(P=>({path:`extension/${m.$lc(F.location.fsPath,P)}`,localPath:P}))}async qb({added:F,removed:C}){if(C){const d=F&&this.D.extUri.isEqual(C.profileLocation,F.profileLocation)?C.extensions.filter(P=>F.extensions.every(z=>!(0,n.$1o)(z,P))):C.extensions;for(const P of d)this.F.info("Extensions removed from another source",P.id,C.profileLocation.toString()),this.u.fire({identifier:P,profileLocation:C.profileLocation})}if(F){const P=(await this.bb.scanExtensions(1,F.profileLocation)).filter(z=>F.extensions.some(U=>(0,n.$1o)(U,z.identifier)));this.s.fire(P.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,F.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:F.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(C=>this.rb.add(C)));const F=await this.ib.resolve(this.fb.userExtensionsLocation);for(const C of F.children??[])C.isDirectory&&this.rb.add(C.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(C=>this.tb(C)))}async tb(F){if(!F.affects(this.fb.userExtensionsLocation,1))return;const C=[];for(const d of F.rawAdded){if(this.rb.has(d)||!this.D.extUri.isEqual(this.D.extUri.dirname(d),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(d,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(d).startsWith(".")||!(await this.ib.stat(d)).isDirectory)continue;const P=await this.bb.scanUserExtensionAtLocation(d);P&&P.installedTimestamp===void 0&&(this.rb.add(d),C.push(P))}C.length&&(await this.ub(C.map(d=>[d,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",C.map(d=>d.identifier.id)))}async ub(F,C){const d=F.map(P=>P[0]);await this.vb(d),await this.gb.addExtensionsToProfile(F,C),this.s.fire(d.map(P=>({local:P,identifier:P.identifier,operation:1,profileLocation:C})))}async vb(F){const C=await this.bb.getUninstalledExtensions();for(const d of F){const P=n.$2o.create(d);C[P.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",P.id),await this.bb.setInstalled(P),this.F.info("Removed the extension from uninstalled list:",P.id))}}};e.$$p=Q,e.$$p=Q=me([se(0,t.$yo),se(1,he.$ul),se(2,oe.$nj),se(3,i.$bi),se(4,o.$Zp),se(5,s.$Vp),se(6,g.$do),se(7,_.$5h),se(8,te.$qk),se(9,re.$Fj),se(10,ce.$1k),se(11,ae.$3k)],Q);let M=class extends a.$Tc{constructor(F,C,d,P,z,U){super(),this.j=F,this.m=C,this.n=d,this.s=P,this.t=z,this.u=U,this.h=this.B(new k.$Vd),this.onExtract=this.h.event,this.c=(0,f.$Hg)(this.n.userExtensionsLocation,".obsolete"),this.g=new L.$ah}async cleanUp(){await this.H(),await this.G()}async scanExtensions(F,C){const d={includeInvalid:!0,profileLocation:C};let P=[];return F===null||F===0?P.push(...await this.n.scanAllExtensions({includeInvalid:!0},d,!1)):F===1&&P.push(...await this.n.scanUserExtensions(d)),P=F!==null?P.filter(z=>z.type===F):P,Promise.all(P.map(z=>this.F(z)))}async scanAllUserExtensions(F){const C=await this.n.scanUserExtensions({includeAllVersions:!F,includeInvalid:!0});return Promise.all(C.map(d=>this.F(d)))}async scanUserExtensionAtLocation(F){try{const C=await this.n.scanExistingExtension(F,1,{includeInvalid:!0});if(C)return await this.F(C)}catch(C){this.u.error(C)}return null}async extractUserExtension(F,C,d,P,z){const U=F.toString(),W=$.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,l.$qg)()}`)),G=$.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,U));let ee=await this.m.exists(G);if(ee&&P){try{await this.y(F.id,G,"removeExisting")}catch{throw new t.$zo(h.localize(4,null,G.fsPath,F.id),t.ExtensionManagementErrorCode.Delete)}ee=!1}if(!ee)try{try{this.u.trace(`Started extracting the extension from ${C} to ${G.fsPath}`),await(0,p.$Op)(C,W.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${G}:`,F.id)}catch(ue){let fe=t.ExtensionManagementErrorCode.Extract;throw ue instanceof p.$Mp&&(ue.type==="CorruptZip"?fe=t.ExtensionManagementErrorCode.CorruptZip:ue.type==="Incomplete"&&(fe=t.ExtensionManagementErrorCode.IncompleteZip)),new t.$zo(ue.message,fe)}await this.n.updateMetadata(W,d);try{this.u.trace(`Started renaming the extension from ${W.fsPath} to ${G.fsPath}`),await this.C(W.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(ue){if(ue.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",F.id);else throw this.u.info(`Rename failed because of ${(0,A.$0)(ue)}. Deleted from extracted location`,W),ue}this.h.fire(G)}catch(ue){try{await this.m.del(W,{recursive:!0})}catch{}throw ue}return this.D(G,1)}async scanMetadata(F,C){return C?(await this.w(F,C))?.metadata:this.n.scanMetadata(F.location)}async w(F,C){return(await this.s.scanProfileExtensions(C)).find(P=>(0,n.$1o)(P.identifier,F.identifier))}async updateMetadata(F,C,d){return d?await this.s.updateMetadata([[F,C]],d):await this.n.updateMetadata(F.location,C),this.D(F.location,F.type,d)}getUninstalledExtensions(){return this.z()}async setUninstalled(...F){const C=F.map(d=>n.$2o.create(d));await this.z(d=>C.forEach(P=>{d[P.toString()]=!0,this.u.info("Marked extension as uninstalled",P.toString())}))}async setInstalled(F){await this.z(C=>delete C[F.toString()])}async removeExtension(F,C){if(this.t.extUri.isEqualOrParent(F.location,this.n.userExtensionsLocation))return this.y(F.identifier.id,F.location,C)}async removeUninstalledExtension(F){await this.removeExtension(F,"uninstalled"),await this.z(C=>delete C[n.$2o.create(F).toString()])}async copyExtension(F,C,d,P){const z=await this.w(F,C),U=await this.w(F,d);return P={...z?.metadata,...P},U?await this.s.updateMetadata([[F,{...U.metadata,...P}]],d):await this.s.addExtensionsToProfile([[F,P]],d),this.D(F.location,F.type,d)}async copyExtensions(F,C){const d=await this.scanExtensions(1,F),P=await Promise.all(d.filter(z=>!z.isApplicationScoped).map(async z=>[z,await this.scanMetadata(z,F)]));await this.s.addExtensionsToProfile(P,C)}async y(F,C,d){this.u.trace(`Deleting ${d} extension from disk`,F,C.fsPath);const P=this.t.extUri.joinPath(this.t.extUri.dirname(C),`${this.t.extUri.basename(C)}.${(0,u.$Ti)((0,l.$qg)()).toString(16)}${q}`);await this.C(C.fsPath,P.fsPath),await this.m.del(P,{recursive:!0}),this.u.info(`Deleted ${d} extension from disk`,F,C.fsPath)}async z(F){return this.g.queue(async()=>{let C;try{C=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(P){if((0,te.$Hk)(P)!==1)throw P}let d={};if(C)try{d=JSON.parse(C)}catch{}return F&&(F(d),Object.keys(d).length?await this.m.writeFile(this.c,D.$je.fromString(JSON.stringify(d))):await this.m.del(this.c)),d})}async C(F,C){try{await w.Promises.rename(F,C,2*60*1e3)}catch(d){throw new t.$zo(d.message||h.localize(5,null,F,C),d.code||t.ExtensionManagementErrorCode.Rename)}}async D(F,C,d){if(d){const z=(await this.n.scanUserExtensions({profileLocation:d})).find(U=>this.t.extUri.isEqual(U.location,F));if(z)return this.F(z)}else{const P=await this.n.scanExistingExtension(F,C,{includeInvalid:!0});if(P)return this.F(P)}throw new Error(h.localize(6,null,F.path))}async F(F){const C=await this.m.resolve(F.location);let d,P;return C.children&&(d=C.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,P=C.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:F.identifier,type:F.type,isBuiltin:F.isBuiltin||!!F.metadata?.isBuiltin,location:F.location,manifest:F.manifest,targetPlatform:F.targetPlatform,validations:F.validations,isValid:F.isValid,readmeUrl:d,changelogUrl:P,publisherDisplayName:F.metadata?.publisherDisplayName||null,publisherId:F.metadata?.publisherId||null,isApplicationScoped:!!F.metadata?.isApplicationScoped,isMachineScoped:!!F.metadata?.isMachineScoped,isPreReleaseVersion:!!F.metadata?.isPreReleaseVersion,preRelease:!!F.metadata?.preRelease,installedTimestamp:F.metadata?.installedTimestamp,updated:!!F.metadata?.updated,pinned:!!F.metadata?.pinned}}async G(){const F=await this.getUninstalledExtensions();if(Object.keys(F).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(F));const C=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),d=new Set;for(const z of C)F[n.$2o.create(z).toString()]||d.add(z.identifier.id.toLowerCase());try{const z=(0,n.$7o)(C,U=>U.identifier);await L.Promises.settled(z.map(async U=>{const W=U.sort((G,ee)=>b.rcompare(G.manifest.version,ee.manifest.version))[0];d.has(W.identifier.id.toLowerCase())||await this.j(await this.F(W))}))}catch(z){this.u.error(z)}const P=C.filter(z=>z.metadata&&F[n.$2o.create(z).toString()]);await Promise.allSettled(P.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let F;try{F=await this.m.resolve(this.n.userExtensionsLocation)}catch(C){(0,te.$Hk)(C)!==1&&this.u.error(C);return}if(F?.children)try{await Promise.allSettled(F.children.map(async C=>{if(!(!C.isDirectory||!C.name.endsWith(q))){this.u.trace("Deleting the temporarily deleted folder",C.resource.toString());try{await this.m.del(C.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",C.resource.toString())}catch(d){(0,te.$Hk)(d)!==1&&this.u.error(d)}}}))}catch{}}};e.$_p=M,e.$_p=M=me([se(1,te.$qk),se(2,o.$Zp),se(3,s.$Vp),se(4,ce.$1k),se(5,oe.$nj)],M);class T extends r.$Tp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,S.$Pf)(this.options.operation)?this.l:this.options.operation}constructor(F,C,d,P,z,U,W,G,ee){super(),this.identifier=F,this.source=C,this.options=d,this.m=P,this.n=z,this.o=U,this.p=W,this.q=G,this.s=ee,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(F){const[C,d]=await this.x(F);return this.j=C.isBuiltin||C.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[C,d]],this.j),C}async u({zipPath:F,key:C,metadata:d},P,z){let U=await this.v(C);return U||(this.s.trace("Extracting extension...",C.id),U=await this.m.extractUserExtension(C,F,d,P,z),this.s.info("Extracting extension completed.",C.id)),U}async v(F){return await this.w(F)?(this.s.trace("Removing the extension from uninstalled list:",F.id),await this.m.setInstalled(F),this.s.info("Removed the extension from uninstalled list:",F.id),(await this.m.scanAllUserExtensions(!0)).find(P=>n.$2o.create(P).equals(F))):void 0}async w(F){return!!(await this.m.getUninstalledExtensions())[F.toString()]}}class B extends T{constructor(F,C,d,P,z,U,W,G,ee,ue){super(C.identifier,C,d,z,U,W,G,ee,ue),this.y=C,this.z=P}async x(F){let C;try{C=await this.m.scanExtensions(null,this.options.profileLocation)}catch(W){throw new t.$zo(W,t.ExtensionManagementErrorCode.Scanning)}const d=C.find(W=>(0,n.$1o)(W.identifier,this.y.identifier));d&&(this.l=3);const P={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||d?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||d?.isMachineScoped,isBuiltin:this.options.isBuiltin||d?.isBuiltin,isSystem:d?.type===0?!0:void 0,updated:!!d,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??d?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,S.$Of)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:d?.preRelease)};if(d?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(d,P),P]}catch(W){throw new t.$zo((0,A.$0)(W),t.ExtensionManagementErrorCode.UpdateMetadata)}const{location:z,verificationStatus:U}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=U,this.B(z.fsPath),[await this.u({zipPath:z.fsPath,key:n.$2o.create(this.y),metadata:P},!1,F),P]}catch(W){try{await this.z.delete(z)}catch(G){this.s.warn("Error while deleting the downloaded file",z.toString(),(0,A.$0)(G))}throw W}}async B(F){try{await(0,O.$7p)(F)}catch(C){throw new t.$zo((0,r.$Rp)(C).message,t.ExtensionManagementErrorCode.Invalid)}}}e.$aq=B;class X extends T{constructor(F,C,d,P,z,U,W,G,ee,ue){super({id:(0,n.$6o)(F.publisher,F.name)},C,d,z,U,W,G,ee,ue),this.y=F,this.z=C,this.A=P}async h(F){const C=await super.h(F);return this.D(C,F),C}async x(F){const C=new n.$2o(this.identifier,this.y.version),P=(await this.m.scanExtensions(1,this.options.profileLocation)).find(W=>(0,n.$1o)(this.identifier,W.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||P?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||P?.isMachineScoped,isBuiltin:this.options.isBuiltin||P?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??P?.pinned};if(P)if(this.l=3,C.equals(new n.$2o(P.identifier,P.manifest.version)))try{await this.m.removeExtension(P,"existing")}catch{throw new Error(h.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&b.gt(P.manifest.version,this.y.version)&&await this.m.setUninstalled(P);else{const W=await this.v(C);if(W)try{await this.m.removeExtension(W,"existing")}catch{throw new Error(h.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$kc(this.z.fsPath),key:C,metadata:z},!0,F),z]}async D(F,C){try{let[d]=await this.A.getExtensions([{id:F.identifier.id,version:F.manifest.version}],C);if(d||([d]=await this.A.getExtensions([{id:F.identifier.id}],C)),d){const P={id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId,isPreReleaseVersion:d.properties.isPreReleaseVersion,preRelease:d.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(F,P,this.options.profileLocation)}}catch{}}}class Z extends r.$Tp{constructor(F,C,d){super(),this.extension=F,this.j=C,this.k=d}async h(F){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(ie[160],ne([0,1,4,23,22,25,42,13,18,11]),function(J,e,L,D,R,N,A,k,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;let v=class extends A.$Wp{constructor(m,f,b,S,$,l){super(a.URI.file(m.extensionsPath),f,b,S,$,l)}};e.$BO=v,e.$BO=v=me([se(0,u.$bi),se(1,k.$qk),se(2,D.$3k),se(3,R.$1k),se(4,N.$ul),se(5,L.$nj)],v)}),define(ie[161],ne([0,1,11,18,42,52,13,10,4,32,22,23]),function(J,e,L,D,R,N,A,k,u,a,v,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=void 0;let m=class extends N.$4p{constructor(b,S,$,l,w,p,h,g){super(L.URI.file(w.builtinExtensionsPath),L.URI.file(w.extensionsPath),w.userHome,b.defaultProfile,b,S,$,l,w,p,h,g)}};e.$i_b=m,e.$i_b=m=me([se(0,E.$3k),se(1,R.$Vp),se(2,A.$qk),se(3,u.$nj),se(4,D.$bi),se(5,a.$Fj),se(6,v.$1k),se(7,k.$5h)],m)}),define(ie[162],ne([0,1,9,6,2,127,3,88,10,23]),function(J,e,L,D,R,N,A,k,u,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$up=e.$tp=e.$sp=void 0,e.$sp="__$__isNewStorageMarker",e.$tp="__$__targetStorageMarker",e.$up=(0,u.$6h)("storageService");var v;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(v||(e.WillSaveStateReason=v={}));var E;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(E||(e.StorageScope=E={}));var m;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function f(w){const p=w.get(e.$tp);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}e.$vp=f;class b extends R.$Tc{static{this.a=60*1e3}constructor(p={flushInterval:b.a}){super(),this.m=p,this.b=this.B(new D.$Yd),this.c=this.B(new D.$Yd),this.onDidChangeTarget=this.c.event,this.f=this.B(new D.$Vd),this.onWillSaveState=this.f.event,this.h=this.B(new L.$fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new R.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(p,h,g){return D.Event.filter(this.b.event,i=>i.scope===p&&(h===void 0||i.key===h),g)}n(){this.j.value=(0,L.$jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,R.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,N.mark)("code/willInitStorage");try{await this.O()}finally{(0,N.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(p,h){const{key:g,external:i}=h;if(g===e.$tp){switch(p){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:g,target:this.J(p)[g],external:i})}w(p){this.f.fire({reason:p})}get(p,h,g){return this.P(h)?.get(p,g)}getBoolean(p,h,g){return this.P(h)?.getBoolean(p,g)}getNumber(p,h,g){return this.P(h)?.getNumber(p,g)}getObject(p,h,g){return this.P(h)?.getObject(p,g)}storeAll(p,h){this.y(()=>{for(const g of p)this.store(g.key,g.value,g.scope,g.target,h)})}store(p,h,g,i,r=!1){if((0,A.$Rf)(h)){this.remove(p,g,r);return}this.y(()=>{this.z(p,g,i),this.P(g)?.set(p,h,r)})}remove(p,h,g=!1){this.y(()=>{this.z(p,h,void 0),this.P(h)?.delete(p,g)})}y(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,h){const g=[],i=this.J(p);for(const r of Object.keys(i))i[r]===h&&g.push(r);return g}z(p,h,g,i=!1){const r=this.J(h);typeof g=="number"?r[p]!==g&&(r[p]=g,this.P(h)?.set(e.$tp,JSON.stringify(r),i)):typeof r[p]=="number"&&(delete r[p],this.P(h)?.set(e.$tp,JSON.stringify(r),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(p){switch(p){case-1:return this.I;case 0:return this.G;default:return this.D}}L(p){const h=this.P(p);return h?f(h):Object.create(null)}isNew(p){return this.getBoolean(e.$sp,p)===!0}async flush(p=v.NONE){this.f.fire({reason:p});const h=this.P(-1),g=this.P(0),i=this.P(1);switch(p){case v.NONE:await L.Promises.settled([h?.whenFlushed()??Promise.resolve(),g?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case v.SHUTDOWN:await L.Promises.settled([h?.flush(0)??Promise.resolve(),g?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.P(-1)?.items??new Map,h=this.P(0)?.items??new Map,g=this.P(1)?.items??new Map;return l(p,h,g,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(p){return await this.flush(),this.P(p)?.optimize()}async switch(p,h){return this.w(v.NONE),(0,a.$2k)(p)?this.R(p,h):this.S(p,h)}M(p,h){return!(p.id===h.id||S(h)&&S(p))}N(p,h,g){this.y(()=>{const i=new Set;for(const[r,t]of p)i.add(r),h.get(r)!==t&&this.u(g,{key:r,external:!0});for(const[r]of h.items)i.has(r)||this.u(g,{key:r,external:!0})})}}e.$wp=b;function S(w){return w.isDefault||!!w.useDefaultFlags?.globalState}e.$xp=S;class $ extends b{constructor(){super(),this.U=this.B(new k.$qp(new k.$rp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new k.$qp(new k.$rp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new k.$qp(new k.$rp,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(p=>this.u(1,p))),this.B(this.W.onDidChangeStorage(p=>this.u(0,p))),this.B(this.U.onDidChangeStorage(p=>this.u(-1,p)))}P(p){switch(p){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(p){return!1}}e.$yp=$;async function l(w,p,h,g,i,r){const t=H=>{try{return JSON.parse(H)}catch{return H}},n=new Map,s=new Map;w.forEach((H,te)=>{n.set(te,H),s.set(te,t(H))});const o=new Map,c=new Map;p.forEach((H,te)=>{o.set(te,H),c.set(te,t(H))});const I=new Map,O=new Map;h.forEach((H,te)=>{I.set(te,H),O.set(te,t(H))}),console.group(g!==i?`Storage: Application (path: ${g})`:`Storage: Application & Profile (path: ${g}, default profile)`);const y=[];if(n.forEach((H,te)=>{y.push({key:te,value:H})}),console.table(y),console.groupEnd(),console.log(s),g!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const H=[];o.forEach((te,_)=>{H.push({key:_,value:te})}),console.table(H),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const j=[];I.forEach((H,te)=>{j.push({key:te,value:H})}),console.table(j),console.groupEnd(),console.log(O)}e.$zp=l}),define(ie[163],ne([0,1,19,20,7,12,35,3,11,29,18,21,26,50,13,4,32,45,146,162,25,176]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w,p,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=void 0;const i=N.$o?"web":(0,E.$uo)(N.$u,A.$ec),r="X-Market-Search-Activity-Id";var t;(function(P){P[P.None=0]="None",P[P.IncludeVersions=1]="IncludeVersions",P[P.IncludeFiles=2]="IncludeFiles",P[P.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",P[P.IncludeSharedAccounts=8]="IncludeSharedAccounts",P[P.IncludeVersionProperties=16]="IncludeVersionProperties",P[P.ExcludeNonValidated=32]="ExcludeNonValidated",P[P.IncludeInstallationTargets=64]="IncludeInstallationTargets",P[P.IncludeAssetUri=128]="IncludeAssetUri",P[P.IncludeStatistics=256]="IncludeStatistics",P[P.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",P[P.Unpublished=4096]="Unpublished",P[P.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(t||(t={}));function n(...P){return String(P.reduce((z,U)=>z|U,0))}var s;(function(P){P[P.Tag=1]="Tag",P[P.ExtensionId=4]="ExtensionId",P[P.Category=5]="Category",P[P.ExtensionName=7]="ExtensionName",P[P.Target=8]="Target",P[P.Featured=9]="Featured",P[P.SearchText=10]="SearchText",P[P.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},c={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},O={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:t.None,criteria:[],assetTypes:[]};class y{constructor(z=O){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,U=this.d.pageSize){return new y({...this.d,pageNumber:z,pageSize:U})}withFilter(z,...U){const W=[...this.d.criteria,...U.length?U.map(G=>({filterType:z,value:G})):[{filterType:z}]];return new y({...this.d,criteria:W})}withSortBy(z){return new y({...this.d,sortBy:z})}withSortOrder(z){return new y({...this.d,sortOrder:z})}withFlags(...z){return new y({...this.d,flags:z.reduce((U,W)=>U|W,0)})}withAssetTypes(...z){return new y({...this.d,assetTypes:z})}withSource(z){return new y({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:U,pageSize:W,sortBy:G,sortOrder:ee,flags:ue,assetTypes:fe}=this.d;return{filters:[{criteria:z,pageNumber:U,pageSize:W,sortBy:G,sortOrder:ee}],assetTypes:fe,flags:ue}}get searchText(){const z=this.d.criteria.filter(U=>U.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function j(P,z){const U=(P||[]).filter(W=>W.statisticName===z)[0];return U?U.value:0}function H(P){const z="Microsoft.VisualStudio.Code.Translation.";return P.files.filter(W=>W.assetType.indexOf(z)===0).reduce((W,G)=>{const ee=oe(P,G.assetType);return ee&&W.push([G.assetType.substring(z.length),ee]),W},[])}function te(P){if(P.properties){const z=P.properties.filter(G=>G.key===o.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),W=z.filter(G=>U.test(G.value))[0];return W?{uri:W.value,fallbackUri:W.value}:null}return oe(P,o.Repository)}function _(P){return{uri:`${P.fallbackAssetUri}/${o.VSIX}?redirect=true${P.targetPlatform?`&targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${o.VSIX}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}}function oe(P,z){return P.files.filter(W=>W.assetType===z)[0]?{uri:`${P.assetUri}/${z}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`,fallbackUri:`${P.fallbackAssetUri}/${z}${P.targetPlatform?`?targetPlatform=${P.targetPlatform}`:""}`}:null}function re(P,z){const U=P.properties?P.properties.filter(G=>G.key===z):[],W=U.length>0&&U[0].value;return W?W.split(",").map(G=>(0,m.$5o)(G)):[]}function he(P){const z=P.properties?P.properties.filter(U=>U.key===c.Engine):[];return z.length>0&&z[0].value||""}function ce(P){const z=P.properties?P.properties.filter(U=>U.key===c.PreRelease):[];return z.length>0&&z[0].value==="true"}function ae(P){const z=P.properties?P.properties.filter(W=>W.key===c.LocalizedLanguages):[],U=z.length>0&&z[0].value||"";return U?U.split(","):[]}function q(P){return P.properties?.find(z=>z.key===c.SponsorLink)?.value}function Q(P){return P.properties?.find(z=>z.key===c.SupportLink)?.value}function M(P){return P.indexOf("preview")!==-1}function T(P){return P.targetPlatform?(0,E.$to)(P.targetPlatform):"undefined"}function B(P){const z=(0,L.$Mb)(P.versions.map(T)),U=!!P.tags?.includes(E.$oo),W=z.indexOf("web");return U?W===-1&&z.push("web"):W!==-1&&z.splice(W,1),z}function X(P,z){for(let U=0;U<P.length;U++){const W=P[U];if(W.version===P[U-1]?.version){let G=U;if(T(W)===z)for(;G>0&&P[G-1].version===W.version;)G--;G!==U&&(P.splice(U,1),P.splice(G,0,W))}}return P}e.$Cp=X;function Z(P,z,U){P.telemetryData={index:z,querySource:U,queryActivityId:P.queryContext?.[r]}}function x(P,z,U,W){const G=P.versions[0],ee={manifest:oe(z,o.Manifest),readme:oe(z,o.Details),changelog:oe(z,o.Changelog),license:oe(z,o.License),repository:te(z),download:_(z),icon:oe(z,o.Icon),signature:oe(z,o.Signature),coreTranslations:H(z)};return{identifier:{id:(0,m.$6o)(P.publisher.publisherName,P.extensionName),uuid:P.extensionId},name:P.extensionName,version:z.version,displayName:P.displayName,publisherId:P.publisher.publisherId,publisher:P.publisher.publisherName,publisherDisplayName:P.publisher.displayName,publisherDomain:P.publisher.domain?{link:P.publisher.domain,verified:!!P.publisher.isDomainVerified}:void 0,publisherSponsorLink:q(G),description:P.shortDescription||"",installCount:j(P.statistics,"install"),rating:j(P.statistics,"averagerating"),ratingCount:j(P.statistics,"ratingcount"),categories:P.categories||[],tags:P.tags||[],releaseDate:Date.parse(P.releaseDate),lastUpdated:Date.parse(P.lastUpdated),allTargetPlatforms:U,assets:ee,properties:{dependencies:re(z,c.Dependency),extensionPack:re(z,c.ExtensionPack),engine:he(z),localizedLanguages:ae(z),targetPlatform:T(z),isPreReleaseVersion:ce(z)},hasPreReleaseVersion:ce(G),hasReleaseVersion:!0,preview:M(P.flags),isSigned:!!ee.signature,queryContext:W,supportLink:Q(G)}}let F=class{constructor(z,U,W,G,ee,ue,fe,$e){this.k=U,this.l=W,this.n=G,this.o=ee,this.q=ue,this.u=fe,this.w=$e;const we=fe.extensionsGallery,de=we?.servicePPEUrl&&$e.getValue("_extensionsGallery.enablePPE");this.d=de?we.servicePPEUrl:we?.serviceUrl,this.g=de?void 0:we?.searchUrl,this.h=we?.controlUrl,this.j=(0,w.$Bp)(fe.version,fe,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,U,W){const G=D.CancellationToken.isCancellationToken(U)?{}:U,ee=D.CancellationToken.isCancellationToken(U)?U:W,ue=[],fe=[],$e=[],we=[];let de=!0;for(const ve of z){ve.uuid?fe.push(ve.uuid):ue.push(ve.id);const ke=!!(ve.version||ve.preRelease);$e.push({id:ve.id,uuid:ve.uuid,includePreRelease:ke}),ve.version&&we.push({id:ve.id,uuid:ve.uuid,version:ve.version}),de=de&&!!ve.hasPreRelease&&!ke}if(!fe.length&&!ue.length)return[];let le=new y().withPage(1,z.length);fe.length&&(le=le.withFilter(s.ExtensionId,...fe)),ue.length&&(le=le.withFilter(s.ExtensionName,...ue)),(G.queryAllVersions||de)&&(le=le.withFlags(le.flags,t.IncludeVersions)),G.source&&(le=le.withSource(G.source));const{extensions:pe}=await this.z(le,{targetPlatform:G.targetPlatform??i,includePreRelease:$e,versions:we,compatible:!!G.compatible},ee);return G.source&&pe.forEach((ve,ke)=>Z(ve,ke,G.source)),pe}async getCompatibleExtension(z,U,W){if((0,E.$vo)(z.allTargetPlatforms,W))return null;if(await this.isExtensionCompatible(z,U,W))return z;const G=new y().withFlags(t.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:ee}=await this.z(G,{targetPlatform:W,compatible:!0,includePreRelease:U},D.CancellationToken.None);return ee[0]||null}async isExtensionCompatible(z,U,W){if(!(0,E.$wo)(z.properties.targetPlatform,z.allTargetPlatforms,W)||!U&&z.properties.isPreReleaseVersion)return!1;let G=z.properties.engine;if(!G){const ee=await this.getManifest(z,D.CancellationToken.None);if(!ee)throw new Error("Manifest was not found");G=ee.engines.vscode}return(0,f.$gp)(G,this.u.version,this.u.date)}async y(z,U,W,G,ee){if(!(0,E.$wo)(T(z),G,ee)||U!=="any"&&ce(z)!==(U==="prerelease"))return!1;if(W)try{const ue=await this.E(z);if(!(0,f.$gp)(ue,this.u.version,this.u.date))return!1}catch(ue){return this.l.error(`Error while getting the engine for the version ${z.version}.`,(0,R.$0)(ue)),!1}return!0}async query(z,U){let W=z.text||"";const G=z.pageSize??50;let ee=new y().withPage(1,G);W?(W=W.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,le,pe)=>(ee=ee.withFilter(s.Category,pe||le),"")),W=W.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,le,pe)=>(ee=ee.withFilter(s.Tag,pe||le),"")),W=W.replace(/\bfeatured(\s+|\b|$)/g,()=>(ee=ee.withFilter(s.Featured),"")),W=W.trim(),W&&(W=W.length<200?W:W.substring(0,200),ee=ee.withFilter(s.SearchText,W)),ee=ee.withSortBy(0)):z.ids?ee=ee.withFilter(s.ExtensionId,...z.ids):z.names?ee=ee.withFilter(s.ExtensionName,...z.names):ee=ee.withSortBy(4),typeof z.sortBy=="number"&&(ee=ee.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(ee=ee.withSortOrder(z.sortOrder)),z.source&&(ee=ee.withSource(z.source));const ue=async(de,le)=>{const{extensions:pe,total:ve}=await this.z(de,{targetPlatform:i,compatible:!1,includePreRelease:!!z.includePreRelease},le);return pe.forEach((ke,je)=>Z(ke,(de.pageNumber-1)*de.pageSize+je,z.source)),{extensions:pe,total:ve}},{extensions:fe,total:$e}=await ue(ee,U),we=async(de,le)=>{if(le.isCancellationRequested)throw new R.$5;const{extensions:pe}=await ue(ee.withPage(de+1),le);return pe};return{firstPage:fe,total:$e,pageSize:ee.pageSize,getPage:we}}async z(z,U,W){const G=z.flags;z.flags&t.IncludeLatestVersionOnly&&z.flags&t.IncludeVersions&&(z=z.withFlags(z.flags&~t.IncludeVersions,t.IncludeLatestVersionOnly)),!(z.flags&t.IncludeLatestVersionOnly)&&!(z.flags&t.IncludeVersions)&&(z=z.withFlags(z.flags,t.IncludeLatestVersionOnly)),U.versions?.length&&(z=z.withFlags(z.flags&~t.IncludeLatestVersionOnly,t.IncludeVersions)),z=z.withFlags(z.flags,t.IncludeAssetUri,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeStatistics,t.IncludeVersionProperties);const{galleryExtensions:ee,total:ue,context:fe}=await this.B(z,W);if(!(z.flags&t.IncludeLatestVersionOnly)){const le=[];for(const pe of ee){const ve=await this.A(pe,U,fe);ve&&le.push(ve)}return{extensions:le,total:ue}}const we=[],de=new Map;for(let le=0;le<ee.length;le++){const pe=ee[le],ve={id:(0,m.$6o)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},ke=(0,k.$Of)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(V=>(0,m.$1o)(V,ve))?.includePreRelease;if(U.compatible&&(0,E.$vo)(B(pe),U.targetPlatform))continue;const je=await this.A(pe,U,fe);!je||je.properties.isPreReleaseVersion&&(!ke||!je.hasReleaseVersion)||!je.properties.isPreReleaseVersion&&je.properties.targetPlatform!==U.targetPlatform&&je.hasPreReleaseVersion?de.set(pe.extensionId,le):we.push([le,je])}if(de.size){const le=new g.$Rd,pe=new y().withFlags(G&~t.IncludeLatestVersionOnly,t.IncludeVersions).withPage(1,de.size).withFilter(s.ExtensionId,...de.keys()),{extensions:ve}=await this.z(pe,U,W);this.o.publicLog2("galleryService:additionalQuery",{duration:le.elapsed(),count:de.size});for(const ke of ve){const je=de.get(ke.identifier.uuid);we.push([je,ke])}}return{extensions:we.sort((le,pe)=>le[0]-pe[0]).map(([,le])=>le),total:ue}}async A(z,U,W){const G={id:(0,m.$6o)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},ee=U.versions?.find(we=>(0,m.$1o)(we,G))?.version,ue=(0,k.$Of)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(we=>(0,m.$1o)(we,G))?.includePreRelease,fe=B(z),$e=X(z.versions,U.targetPlatform);if(U.compatible&&(0,E.$vo)(fe,U.targetPlatform))return null;for(let we=0;we<$e.length;we++){const de=$e[we];if(!(ee&&de.version!==ee)){if(await this.y(de,ue?"any":"release",U.compatible,fe,U.targetPlatform))return x(z,de,fe,W);if(ee&&de.version===ee)return null}}return ee||U.compatible?null:x(z,z.versions[0],fe)}async B(z,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,t.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,n(t.Unpublished));const W=await this.j,G=JSON.stringify(z.raw),ee={...W,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},ue=new g.$Rd;let fe,$e,we=0;try{if(fe=await this.k.request({type:"POST",url:this.g&&z.criteria.some(le=>le.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:ee},U),fe.res.statusCode&&fe.res.statusCode>=400&&fe.res.statusCode<500)return{galleryExtensions:[],total:we};const de=await(0,l.$np)(fe);if(de){const le=de.results[0],pe=le.extensions,ve=le.resultMetadata&&le.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return we=ve&&ve.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:pe,total:we,context:{[r]:fe.res.headers.activityid}}}return{galleryExtensions:[],total:we}}catch(de){const le=(0,R.$4)(de)?E.ExtensionGalleryErrorCode.Cancelled:(0,R.$0)(de).startsWith("XHR timeout")?E.ExtensionGalleryErrorCode.Timeout:E.ExtensionGalleryErrorCode.Failed;throw $e=new E.$Ao((0,R.$0)(de),le),$e}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(G.length),duration:ue.elapsed(),success:!!fe&&(0,l.$jp)(fe),responseBodySize:fe?.res.headers["Content-Length"],statusCode:fe?String(fe.res.statusCode):void 0,errorCode:$e?.code,count:String(we)})}}async reportStatistic(z,U,W,G){if(!this.isEnabled())return;const ee=N.$o?this.x(`/itemName/${z}.${U}/version/${W}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${U}/${W}/stats?statType=${G}`),ue=N.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",$e={...await this.j,Accept:ue};try{await this.k.request({type:"POST",url:ee,headers:$e},D.CancellationToken.None)}catch{}}async download(z,U,W){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const G=(0,m.$9o)(z),ee=new Date().getTime(),ue=le=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:le}),fe=W===2?"install":W===3?"update":"",$e=fe?{uri:`${z.assets.download.uri}${u.URI.parse(z.assets.download.uri).query?"&":"?"}${fe}=true`,fallbackUri:`${z.assets.download.fallbackUri}${u.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${fe}=true`}:z.assets.download,we=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,de=await this.D($e,we?{headers:we}:void 0);await this.q.writeFile(U,de.stream),ue(new Date().getTime()-ee)}async downloadSignatureArchive(z,U){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const W=await this.D(z.assets.signature);await this.q.writeFile(U,W.stream)}async getReadme(z,U){if(z.assets.readme){const W=await this.D(z.assets.readme,{},U);return await(0,l.$mp)(W)||""}return""}async getManifest(z,U){if(z.assets.manifest){const W=await this.D(z.assets.manifest,{},U),G=await(0,l.$mp)(W);return G?JSON.parse(G):null}return null}async C(z,U){const W=oe(z,o.Manifest);if(!W)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},ee=await this.D(W,{headers:G});return await(0,l.$np)(ee)}async getCoreTranslation(z,U){const W=z.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if(W){const G=await this.D(W[1]),ee=await(0,l.$mp)(G);return ee?JSON.parse(ee):null}return null}async getChangelog(z,U){if(z.assets.changelog){const W=await this.D(z.assets.changelog,{},U);return await(0,l.$mp)(W)||""}return""}async getAllCompatibleVersions(z,U,W){let G=new y().withFlags(t.IncludeVersions,t.IncludeCategoryAndTags,t.IncludeFiles,t.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?G=G.withFilter(s.ExtensionId,z.identifier.uuid):G=G.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:ee}=await this.B(G,D.CancellationToken.None);if(!ee.length)return[];const ue=B(ee[0]);if((0,E.$vo)(ue,W))return[];const fe=[];await Promise.all(ee[0].versions.map(async de=>{try{await this.y(de,U?"any":"release",!0,ue,W)&&fe.push(de)}catch{}}));const $e=[],we=new Set;for(const de of X(fe,W))we.has(de.version)||(we.add(de.version),$e.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:ce(de)}));return $e}async D(z,U={},W=D.CancellationToken.None){const G=await this.j,ee={type:"GET"},ue={...G,...U.headers||{}};U={...U,...ee,headers:ue};const fe=z.uri,$e=z.fallbackUri,we={...U,url:fe};try{const de=await this.k.request(we,W);if(de.res.statusCode===200)return de;const le=await(0,l.$mp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${le}`)}catch(de){if((0,R.$4)(de))throw de;const le=(0,R.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{url:fe,message:le});const pe={...U,url:$e};return this.k.request(pe,W)}}async E(z){let U=he(z);if(!U){const W=await this.C(z,D.CancellationToken.None);if(!W)throw new Error("Manifest was not found");U=W.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},D.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.$np)(z),W=[],G={},ee=[];if(U){for(const ue of U.malicious)W.push({id:ue});if(U.migrateToPreRelease)for(const[ue,fe]of Object.entries(U.migrateToPreRelease))(!fe.engine||(0,f.$gp)(fe.engine,this.u.version,this.u.date))&&(G[ue.toLowerCase()]={disallowInstall:!0,extension:{id:fe.id,displayName:fe.displayName,autoMigrate:{storage:!!fe.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[ue,fe]of Object.entries(U.deprecated))fe&&(G[ue.toLowerCase()]=(0,k.$Of)(fe)?{}:fe);if(U.search)for(const ue of U.search)ee.push(ue)}return{malicious:W,deprecated:G,search:ee}}};F=me([se(1,l.$hp),se(2,S.$nj),se(3,v.$ai),se(4,h.$ul),se(5,b.$qk),se(6,$.$Fj),se(7,a.$zi)],F);let C=class extends F{constructor(z,U,W,G,ee,ue,fe,$e){super(z,U,W,G,ee,ue,fe,$e)}};e.$Dp=C,e.$Dp=C=me([se(0,p.$up),se(1,l.$hp),se(2,S.$nj),se(3,v.$ai),se(4,h.$ul),se(5,b.$qk),se(6,$.$Fj),se(7,a.$zi)],C);let d=class extends F{constructor(z,U,W,G,ee,ue,fe){super(void 0,z,U,W,G,ee,ue,fe)}};e.$Ep=d,e.$Ep=d=me([se(0,l.$hp),se(1,S.$nj),se(2,v.$ai),se(3,h.$ul),se(4,b.$qk),se(5,$.$Fj),se(6,a.$zi)],d)}),define(ie[164],ne([0,1,11,18,13,4,142,22,23,3,68]),function(J,e,L,D,R,N,A,k,u,a,v){"use strict";var E,m;Object.defineProperty(e,"__esModule",{value:!0}),e.$AO=e.$zO=e.$yO=void 0;let f=class extends u.$6k{static{E=this}static{this.a="profileAssociationsMigration"}constructor(l,w,p,h,g){super(p,h,w,g),this.U=l,this.W=p}O(){return this.U.getItem(E.b,[]).map(w=>({...w,location:(0,a.$If)(w.location)?this.w.extUri.joinPath(this.profilesHome,w.location):L.URI.revive(w.location)}))}Q(){const l=this.U.getItem(E.c,{});return this.U.getItem(E.a,!1)?l:this.N(l)}S(){return this.w.extUri.joinPath(L.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$yO=f,e.$yO=f=E=me([se(0,A.$tO),se(1,k.$1k),se(2,D.$bi),se(3,R.$qk),se(4,N.$nj)],f);let b=m=class extends f{constructor(l,w,p,h,g){super(l,w,p,h,g),this.$=l}P(l){l.length?this.$.setItem(m.b,l.map(w=>({...w,location:this.w.extUri.basename(w.location)}))):this.$.removeItem(m.b)}O(){const l=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(l),this.$.setItem("userDataProfilesMigration",!0)),l}R(l){l.emptyWindows||l.workspaces?this.$.setItem(m.c,l):this.$.removeItem(m.c)}Q(){const l="workspaceAndProfileInfo",w=this.$.getItem(l,void 0);if(w){this.$.removeItem(l);const h=w.reduce((g,{workspace:i,profile:r})=>(g[L.URI.revive(i).toString()]=L.URI.revive(r).toString(),g),{});this.$.setItem(m.c,{workspaces:h})}const p=super.Q();return this.$.getItem(m.a,!1)||(this.R(p),this.$.setItem(m.a,!0)),p}};e.$zO=b,e.$zO=b=m=me([se(0,A.$uO),se(1,k.$1k),se(2,D.$bi),se(3,R.$qk),se(4,N.$nj)],b);let S=class extends b{constructor(l,w,p,h){super(new v.$xO(0,w,h,p),l,w,p,h)}async init(){return await this.$.init(),super.init()}};e.$AO=S,e.$AO=S=me([se(0,k.$1k),se(1,D.$bi),se(2,R.$qk),se(3,N.$nj)],S)}),define(ie[165],ne([0,1,140,9,14,7,3,29,18,141,4,45,139,177]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$or=e.$nr=void 0;let b=class extends E.$ip{constructor(w,p,h,g){super(g),this.m=w,this.n=p,this.r=h,this.s(),this.B(w.onDidChangeConfiguration(i=>{i.affectsConfiguration("http")&&this.s()}))}s(){const w=this.m.getValue("http");this.f=w?.proxy,this.g=!!w?.proxyStrictSSL,this.h=w?.proxyAuthorization}async request(w,p){const{f:h,g}=this;let i;try{i=await(0,a.$_l)(this.m,this.r,this.n.args,process.env)}catch(n){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,N.$0)(n)))}const r={...process.env,...i},t=w.agent?w.agent:await(0,m.$mr)(w.url||"",r,{proxyUrl:h,strictSSL:g});return w.agent=t,w.strictSSL=g,this.h&&(w.headers={...w.headers||{},"Proxy-Authorization":this.h}),this.c(w.isChromiumNetwork?"electron":"node",w,()=>$(w,p))}async resolveProxy(w){}async loadCertificates(){return(await new Promise((p,h)=>{J(["@vscode/proxy-agent"],p,h)})).loadSystemCertificates({log:this.r})}};e.$nr=b,e.$nr=b=me([se(0,k.$zi),se(1,u.$bi),se(2,v.$nj),se(3,v.$oj)],b);async function S(l){return((0,L.parse)(l.url).protocol==="https:"?await new Promise((h,g)=>{J(["https"],h,g)}):await new Promise((h,g)=>{J(["http"],h,g)})).request}async function $(l,w){return D.Promises.withAsyncBody(async(p,h)=>{const g=(0,L.parse)(l.url),i=l.getRawRequest?l.getRawRequest(l):await S(l),r={hostname:g.hostname,port:g.port?parseInt(g.port):g.protocol==="https:"?443:80,protocol:g.protocol,path:g.path,method:l.type||"GET",headers:l.headers,agent:l.agent,rejectUnauthorized:(0,A.$Of)(l.strictSSL)?l.strictSSL:!0};l.user&&l.password&&(r.auth=l.user+":"+l.password);const t=i(r,n=>{const s=(0,A.$Mf)(l.followRedirects)?l.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&s>0&&n.headers.location)$({...l,url:n.headers.location,followRedirects:s-1},w).then(p,h);else{let o=n;!l.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(o=n.pipe((0,f.createGunzip)())),p({res:n,stream:(0,R.$ye)(o)})}});t.on("error",h),l.timeout&&t.setTimeout(l.timeout),l.isChromiumNetwork&&t.removeHeader("Content-Length"),l.data&&typeof l.data=="string"&&t.write(l.data),t.end(),w.onCancellationRequested(()=>{t.abort(),h(new N.$5)})})}e.$or=$}),define(ie[178],ne([0,1,33,9,34,7,2,15,16,12,35,11,24,29,136,59,138,18,114,163,21,64,143,42,52,159,161,13,126,128,51,124,62,63,147,4,132,39,133,150,32,45,165,68,69,25,149,41,151,152,22,154,23,164,153,160,129,131,5,155]),function(J,e,L,D,R,N,A,k,u,a,v,E,m,f,b,S,$,l,w,p,h,g,i,r,t,n,s,o,c,I,O,y,j,H,te,_,oe,re,he,ce,ae,q,Q,M,T,B,X,Z,x,F,C,d,P,z,U,W,G,ee,ue,fe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class $e extends A.$Tc{constructor(le){super(),this.b=le,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[le,pe]=await this.f();return le.invokeFunction(async ve=>{const ke=ve.get(_.$nj),je=ve.get(o.$qk),V=ve.get(l.$bi),Y=ve.get(P.$3k);ke.info("CLI main",this.b),this.g(ke),await this.h(V,je,Y,le),await Promise.all(pe.map(K=>{(0,D.$Xg)(K.flush(),1e3)}))})}async f(){const le=new j.$4h,pe={_serviceBrand:void 0,...ce.default};le.set(ae.$Fj,pe);const ve=new w.$Bm(this.b,pe);le.set(l.$bi,ve),await Promise.all([ve.appSettingsHome.with({scheme:k.Schemas.file}).fsPath,ve.extensionsPath].map(Le=>Le?m.Promises.mkdir(Le,{recursive:!0}):void 0));const ke=new ee.$sO((0,_.$Bj)(ve),ve.logsHome);le.set(_.$oj,ke);const je=this.B(ke.createLogger("cli",{name:(0,ue.localize)(0,null)})),V=[];ke.getLogLevel()===_.LogLevel.Trace&&V.push(new _.$vj(ke.getLogLevel()));const Y=this.B(new G.$CO(je,V));le.set(_.$nj,Y);const K=this.B(new c.$cq(Y));le.set(o.$qk,K);const ge=this.B(new I.$Bq(Y));K.registerProvider(k.Schemas.file,ge);const ye=new d.$2r(K);le.set(C.$1k,ye);const De=new M.$wO(1,ve,Y,K),Se=new z.$yO(De,ye,ve,K,Y);le.set(P.$3k,Se),K.registerProvider(k.Schemas.vscodeUserData,new fe.$J_b(k.Schemas.file,ge,k.Schemas.vscodeUserData,Se,ye,Y));const ze=a.$i&&pe.win32RegValueName?this.B(new he.$H_b(Y,pe.win32RegValueName)):ve.policyFile?this.B(new oe.$I_b(ve.policyFile,K,Y)):new re.$Ln;le.set(re.$Jn,ze);const Ie=this.B(new b.$_n(Se.defaultProfile.settingsResource,K,ze,Y));le.set(f.$zi,Ie),await Promise.all([De.init(),Ie.initialize()]);let Ne;try{Ne=await(0,U.$l_b)(De,Y)}catch(Le){Le.code!=="ENOENT"&&Y.error(Le)}const Te=await(0,U.$m_b)(De,Y);Se.init(),le.set(C.$1k,new d.$2r(K));const Oe=new Q.$nr(Ie,ve,Y,ke);le.set(q.$hp,Oe),le.set(S.$do,new O.$3h($.$RO,void 0,!0)),le.set(r.$Vp,new O.$3h(W.$BO,void 0,!0)),le.set(t.$Zp,new O.$3h(s.$i_b,void 0,!0)),le.set(g.$Fp,new O.$3h(g.$Gp,void 0,!0)),le.set(n.$0p,new O.$3h(n.$$p,void 0,!0)),le.set(h.$yo,new O.$3h(p.$Ep,void 0,!0)),le.set(H.$hr,new O.$3h(te.$jr,void 0,!1));const Ae=[],Ce=(0,Z.$Xo)(pe,Ie);if((0,Z.$So)(pe,ve)){pe.aiConfig&&pe.aiConfig.ariaKey&&Ae.push(new x.$qO(Oe,Ce,"monacoworkbench",null,pe.aiConfig.ariaKey));const Le={appenders:Ae,sendErrorTelemetry:!1,commonProperties:(0,T.$Jo)((0,L.release)(),(0,L.hostname)(),process.arch,pe.commit,pe.version,Ne,Te,Ce),piiPaths:(0,Z.$Yo)(ve)};le.set(B.$ul,new O.$3h(X.$pr,[Le],!1))}else le.set(B.$ul,Z.$No);return[new y.$Eq(le),Ae]}g(le){(0,N.setUnexpectedErrorHandler)(pe=>{const ve=(0,R.$Qi)(pe,!0);ve&&le.error(`[uncaught exception in CLI]: ${ve}`)}),process.on("uncaughtException",pe=>{(0,N.$Z)(pe)||(0,N.$1)(pe)}),process.on("unhandledRejection",pe=>(0,N.$1)(pe))}async h(le,pe,ve,ke){let je;if(le.args.profile&&(je=ve.profiles.find(Y=>Y.name===le.args.profile),!je))throw new Error(`Profile '${le.args.profile}' not found.`);const V=(je??ve.defaultProfile).extensionsResource;if(this.b["list-extensions"])return ke.createInstance(i.$Hp,new _.$vj(_.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,V);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const Y={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:V};return ke.createInstance(i.$Hp,new _.$vj(_.LogLevel.Info,!1)).installExtensions(this.j(this.b["install-extension"]||[]),this.j(this.b["install-builtin-extension"]||[]),Y,!!this.b.force)}else{if(this.b["uninstall-extension"])return ke.createInstance(i.$Hp,new _.$vj(_.LogLevel.Info,!1)).uninstallExtensions(this.j(this.b["uninstall-extension"]),!!this.b.force,V);if(this.b["update-extensions"])return ke.createInstance(i.$Hp,new _.$vj(_.LogLevel.Info,!1)).updateExtensions(V);if(this.b["locate-extension"])return ke.createInstance(i.$Hp,new _.$vj(_.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,F.$8_b)(le.appRoot,le.extensionsPath))}}j(le){return le.map(pe=>/\.vsix$/i.test(pe)?E.URI.file((0,u.$ic)(pe)?pe:(0,u.$jc)((0,v.cwd)(),pe)):pe)}}async function we(de){const le=new $e(de);try{await le.run()}finally{le.dispose()}}e.main=we})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/271fb7fbd599b49a1482ea7284a50b3229317f96/core/vs/code/node/cliProcessMain.js.map
