/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/base/common/platform","vs/base/common/async","vs/base/common/errors","vs/platform/log/common/log","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/types","vs/nls","vs/base/common/buffer","vs/platform/environment/common/environment","vs/base/common/path","vs/base/common/arrays","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/telemetry/common/telemetry","vs/base/common/network","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/cancellation","vs/base/common/strings","vs/platform/uriIdentity/common/uriIdentity","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/objects","vs/base/node/pfs","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/json","vs/base/common/map","os","vs/base/common/process","vs/base/common/errorMessage","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/jsonFormatter","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/base/common/extpath","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/lazy","vs/base/common/hash","fs","vs/base/common/semver/semver","vs/platform/ipc/common/mainProcessService","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/iterator","vs/base/common/jsonEdit","vs/base/common/stopwatch","net","vs/base/common/date","vs/base/common/marshalling","child_process","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/content","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/severity","vs/base/common/processes","vs/base/common/glob","vs/base/common/uriIpc","vs/base/parts/ipc/node/ipc.cp","vs/platform/contextkey/common/contextkey","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/userDataSync/common/userDataSyncStoreService","vs/base/parts/ipc/node/ipc.net","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/skipList","vs/base/common/cache","vs/base/common/symbols","vs/base/node/macAddress","vs/base/node/nodeStreams","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/extpath","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/native/common/nativeHostService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/common/sharedProcess","vs/platform/sign/common/abstractSignService","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/code/node/sharedProcess/contrib/extensions","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataSyncLocalStoreService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","stream","util","path","graceful-fs","https","zlib","vs/code/node/sharedProcess/sharedProcessMain"],he=function(se){for(var e=[],O=0,L=se.length;O<L;O++)e[O]=le[se[O]];return e};define(le[124],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class O{static get(){const D=new Map,A=new Map,I=new Map,P=new Map;function k(l,$){l.has($.detail)||l.set($.detail,-$.timestamp)}function g(l,$){const b=l.get($.detail);b&&(b>=0||l.set($.detail,b+$.timestamp))}let C=[];typeof se=="function"&&typeof se.getStats=="function"&&(C=se.getStats().slice(0).sort((l,$)=>l.timestamp-$.timestamp));for(const l of C)switch(l.type){case 10:k(D,l);break;case 11:case 12:g(D,l);break;case 21:k(A,l);break;case 22:g(A,l);break;case 33:k(I,l);break;case 34:g(I,l);break;case 31:k(P,l);break;case 32:g(P,l);break}let S=0;I.forEach(l=>S+=l);function m(l){const $=[];return l.forEach((b,w)=>$.push([w,b])),$}return{amdLoad:m(D),amdInvoke:m(A),nodeRequire:m(I),nodeEval:m(P),nodeRequireTotal:S}}static toMarkdownTable(D,A){let I="";const P=[];return D.forEach((k,g)=>{P[g]=k.length}),A.forEach(k=>{k.forEach((g,C)=>{typeof g>"u"&&(g=k[C]="-");const S=g.toString().length;P[C]=Math.max(S,P[C])})}),D.forEach((k,g)=>{I+=`| ${k+" ".repeat(P[g]-k.toString().length)} `}),I+=`|
`,D.forEach((k,g)=>{I+=`| ${"-".repeat(P[g])} `}),I+=`|
`,A.forEach(k=>{k.forEach((g,C)=>{typeof g<"u"&&(I+=`| ${g+" ".repeat(P[C]-g.toString().length)} `)}),I+=`|
`}),I}}e.$U=O}),define(le[125],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function O(b,w,h){const f=L(b,w);if(f!==-1)return b[f]}e.$fb=O;function L(b,w,h=b.length-1){for(let f=h;f>=0;f--){const d=b[f];if(w(d))return f}return-1}e.$gb=L;function D(b,w){const h=A(b,w);return h===-1?void 0:b[h]}e.$hb=D;function A(b,w,h=0,f=b.length){let d=h,c=f;for(;d<c;){const v=Math.floor((d+c)/2);w(b[v])?d=v+1:c=v}return d-1}e.$ib=A;function I(b,w){const h=P(b,w);return h===b.length?void 0:b[h]}e.$jb=I;function P(b,w,h=0,f=b.length){let d=h,c=f;for(;d<c;){const v=Math.floor((d+c)/2);w(b[v])?c=v:d=v+1}return d}e.$kb=P;function k(b,w,h=0,f=b.length){const d=P(b,w,h,f);return d===b.length?-1:d}e.$lb=k;class g{static{this.assertInvariants=!1}constructor(w){this.e=w,this.c=0}findLastMonotonous(w){if(g.assertInvariants){if(this.d){for(const f of this.e)if(this.d(f)&&!w(f))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=w}const h=A(this.e,w,this.c);return this.c=h+1,h===-1?void 0:this.e[h]}}e.$mb=g;function C(b,w){if(b.length===0)return;let h=b[0];for(let f=1;f<b.length;f++){const d=b[f];w(d,h)>0&&(h=d)}return h}e.$nb=C;function S(b,w){if(b.length===0)return;let h=b[0];for(let f=1;f<b.length;f++){const d=b[f];w(d,h)>=0&&(h=d)}return h}e.$ob=S;function m(b,w){return C(b,(h,f)=>-w(h,f))}e.$pb=m;function l(b,w){if(b.length===0)return-1;let h=0;for(let f=1;f<b.length;f++){const d=b[f];w(d,b[h])>0&&(h=f)}return h}e.$qb=l;function $(b,w){for(const h of b){const f=w(h);if(f!==void 0)return f}}e.$rb=$}),define(le[126],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function O(I,P){const k=Object.create(null);for(const g of I){const C=P(g);let S=k[C];S||(S=k[C]=[]),S.push(g)}return k}e.$K=O;function L(I,P){const k=[],g=[];for(const C of I)P.has(C)||k.push(C);for(const C of P)I.has(C)||g.push(C);return{removed:k,added:g}}e.$L=L;function D(I,P){const k=[],g=[];for(const[C,S]of I)P.has(C)||k.push(S);for(const[C,S]of P)I.has(C)||g.push(S);return{removed:k,added:g}}e.$M=D;function A(I,P){const k=new Set;for(const g of P)I.has(g)&&k.add(g);return k}e.$N=A}),define(le[85],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function O(I){return(P,k,g)=>{let C=null,S=null;if(typeof g.value=="function"?(C="value",S=g.value):typeof g.get=="function"&&(C="get",S=g.get),!S)throw new Error("not supported");g[C]=I(S,k)}}function L(I,P,k){let g=null,C=null;if(typeof k.value=="function"?(g="value",C=k.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof k.get=="function"&&(g="get",C=k.get),!C)throw new Error("not supported");const S=`$memoize$${P}`;k[g]=function(...m){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,m)}),this[S]}}e.$xh=L;function D(I,P,k){return O((g,C)=>{const S=`$debounce$${C}`,m=`$debounce$result$${C}`;return function(...l){this[m]||(this[m]=k?k():void 0),clearTimeout(this[S]),P&&(this[m]=P(this[m],...l),l=[this[m]]),this[S]=setTimeout(()=>{g.apply(this,l),this[m]=k?k():void 0},I)}})}e.$yh=D;function A(I,P,k){return O((g,C)=>{const S=`$throttle$timer$${C}`,m=`$throttle$result$${C}`,l=`$throttle$lastRun$${C}`,$=`$throttle$pending$${C}`;return function(...b){if(this[m]||(this[m]=k?k():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),P&&(this[m]=P(this[m],...b)),this[$])return;const w=this[l]+I;w<=Date.now()?(this[l]=Date.now(),g.apply(this,[this[m]]),this[m]=k?k():void 0):(this[$]=!0,this[S]=setTimeout(()=>{this[$]=!1,this[l]=Date.now(),g.apply(this,[this[m]]),this[m]=k?k():void 0},w-Date.now()))}})}e.$zh=A}),define(le[7],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class O{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(o=>{o(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=O,e.$X=new O;function L(v){e.$X.setUnexpectedErrorHandler(v)}e.setUnexpectedErrorHandler=L;function D(v){if(!v||typeof v!="object")return!1;const i=v;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=D;function A(v){g(v)||e.$X.onUnexpectedError(v)}e.$1=A;function I(v){g(v)||e.$X.onUnexpectedExternalError(v)}e.$2=I;function P(v){if(v instanceof Error){const{name:i,message:o}=v,n=v.stacktrace||v.stack;return{$isError:!0,name:i,message:o,stack:n,noTelemetry:d.isErrorNoTelemetry(v)}}return v}e.$3=P;const k="Canceled";function g(v){return v instanceof C?!0:v instanceof Error&&v.name===k&&v.message===k}e.$4=g;class C extends Error{constructor(){super(k),this.name=this.message}}e.$5=C;function S(){const v=new Error(k);return v.name=v.message,v}e.$6=S;function m(v){return v?new Error(`Illegal argument: ${v}`):new Error("Illegal argument")}e.$7=m;function l(v){return v?new Error(`Illegal state: ${v}`):new Error("Illegal state")}e.$8=l;class $ extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function b(v){return v?v.message?v.message:v.stack?v.stack.split(`
`)[0]:String(v):"Error"}e.$0=b;class w extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=w;class h extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=h;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=f;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const o=new d;return o.message=i.message,o.stack=i.stack,o}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=d;class c extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,c.prototype)}}e.$cb=c}),define(le[17],he([0,1,7,125]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function D(z,_=0){return z[z.length-(1+_)]}e.$sb=D;function A(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.$tb=A;function I(z,_,G=(J,te)=>J===te){if(z===_)return!0;if(!z||!_||z.length!==_.length)return!1;for(let J=0,te=z.length;J<te;J++)if(!G(z[J],_[J]))return!1;return!0}e.$ub=I;function P(z,_){const G=z.length-1;_<G&&(z[_]=z[G]),z.pop()}e.$vb=P;function k(z,_,G){return g(z.length,J=>G(z[J],_))}e.$wb=k;function g(z,_){let G=0,J=z-1;for(;G<=J;){const te=(G+J)/2|0,ne=_(te);if(ne<0)G=te+1;else if(ne>0)J=te-1;else return te}return-(G+1)}e.$xb=g;function C(z,_,G){if(z=z|0,z>=_.length)throw new TypeError("invalid index");const J=_[Math.floor(_.length*Math.random())],te=[],ne=[],ce=[];for(const de of _){const $e=G(de,J);$e<0?te.push(de):$e>0?ne.push(de):ce.push(de)}return z<te.length?C(z,te,G):z<te.length+ce.length?ce[0]:C(z-(te.length+ce.length),ne,G)}e.$yb=C;function S(z,_){const G=[];let J;for(const te of z.slice(0).sort(_))!J||_(J[0],te)!==0?(J=[te],G.push(J)):J.push(te);return G}e.$zb=S;function*m(z,_){let G,J;for(const te of z)J!==void 0&&_(J,te)?G.push(te):(G&&(yield G),G=[te]),J=te;G&&(yield G)}e.$Ab=m;function l(z,_){for(let G=0;G<=z.length;G++)_(G===0?void 0:z[G-1],G===z.length?void 0:z[G])}e.$Bb=l;function $(z,_){for(let G=0;G<z.length;G++)_(G===0?void 0:z[G-1],z[G],G+1===z.length?void 0:z[G+1])}e.$Cb=$;function b(z,_,G){const J=[];function te(de,$e,me){if($e===0&&me.length===0)return;const Ee=J[J.length-1];Ee&&Ee.start+Ee.deleteCount===de?(Ee.deleteCount+=$e,Ee.toInsert.push(...me)):J.push({start:de,deleteCount:$e,toInsert:me})}let ne=0,ce=0;for(;;){if(ne===z.length){te(ne,0,_.slice(ce));break}if(ce===_.length){te(ne,z.length-ne,[]);break}const de=z[ne],$e=_[ce],me=G(de,$e);me===0?(ne+=1,ce+=1):me<0?(te(ne,1,[]),ne+=1):me>0&&(te(ne,0,[$e]),ce+=1)}return J}e.$Db=b;function w(z,_,G){const J=b(z,_,G),te=[],ne=[];for(const ce of J)te.push(...z.slice(ce.start,ce.start+ce.deleteCount)),ne.push(...ce.toInsert);return{removed:te,added:ne}}e.$Eb=w;function h(z,_,G){if(G===0)return[];const J=z.slice(0,G).sort(_);return d(z,_,J,G,z.length),J}e.top=h;function f(z,_,G,J,te){return G===0?Promise.resolve([]):new Promise((ne,ce)=>{(async()=>{const de=z.length,$e=z.slice(0,G).sort(_);for(let me=G,Ee=Math.min(G+J,de);me<de;me=Ee,Ee=Math.min(Ee+J,de)){if(me>G&&await new Promise(Re=>setTimeout(Re)),te&&te.isCancellationRequested)throw new O.$5;d(z,_,$e,me,Ee)}return $e})().then(ne,ce)})}e.$Gb=f;function d(z,_,G,J,te){for(const ne=G.length;J<te;J++){const ce=z[J];if(_(ce,G[ne-1])<0){G.pop();const de=(0,L.$kb)(G,$e=>_(ce,$e)<0);G.splice(de,0,ce)}}}function c(z){return z.filter(_=>!!_)}e.$Hb=c;function v(z){let _=0;for(let G=0;G<z.length;G++)z[G]&&(z[_]=z[G],_+=1);z.length=_}e.$Ib=v;function i(z,_,G){z.splice(G,0,z.splice(_,1)[0])}e.$Jb=i;function o(z){return!Array.isArray(z)||z.length===0}e.$Kb=o;function n(z){return Array.isArray(z)&&z.length>0}e.$Lb=n;function s(z,_=G=>G){const G=new Set;return z.filter(J=>{const te=_(J);return G.has(te)?!1:(G.add(te),!0)})}e.$Mb=s;function t(z){const _=new Set;return G=>{const J=z(G);return _.has(J)?!1:(_.add(J),!0)}}e.$Nb=t;function r(z,_){return z.length>0?z[0]:_}e.$Ob=r;function a(z,_){return z.length>0?z[z.length-1]:_}e.$Pb=a;function E(z,_,G=(J,te)=>J===te){let J=0;for(let te=0,ne=Math.min(z.length,_.length);te<ne&&G(z[te],_[te]);te++)J++;return J}e.$Qb=E;function y(z){return[].concat(...z)}e.$Rb=y;function u(z,_){let G=typeof _=="number"?z:0;typeof _=="number"?G=z:(G=0,_=z);const J=[];if(G<=_)for(let te=G;te<_;te++)J.push(te);else for(let te=G;te>_;te--)J.push(te);return J}e.$Sb=u;function p(z,_,G){return z.reduce((J,te)=>(J[_(te)]=G?G(te):te,J),Object.create(null))}e.$Tb=p;function R(z,_){return z.push(_),()=>N(z,_)}e.$Ub=R;function N(z,_){const G=z.indexOf(_);if(G>-1)return z.splice(G,1),_}e.$Vb=N;function T(z,_,G){const J=z.slice(0,_),te=z.slice(_);return J.concat(G,te)}e.$Wb=T;function M(z,_){let G;if(typeof _=="number"){let J=_;G=()=>{const te=Math.sin(J++)*179426549;return te-Math.floor(te)}}else G=Math.random;for(let J=z.length-1;J>0;J-=1){const te=Math.floor(G()*(J+1)),ne=z[J];z[J]=z[te],z[te]=ne}}e.$Xb=M;function U(z,_){const G=z.indexOf(_);G>-1&&(z.splice(G,1),z.unshift(_))}e.$Yb=U;function Y(z,_){const G=z.indexOf(_);G>-1&&(z.splice(G,1),z.push(_))}e.$Zb=Y;function Q(z,_){for(const G of _)z.push(G)}e.$1b=Q;function x(z,_){return Array.isArray(z)?z.map(_):_(z)}e.$2b=x;function H(z){return Array.isArray(z)?z:[z]}e.$3b=H;function Z(z){return z[Math.floor(Math.random()*z.length)]}e.$4b=Z;function W(z,_,G){const J=ie(z,_),te=z.length,ne=G.length;z.length=te+ne;for(let ce=te-1;ce>=J;ce--)z[ce+ne]=z[ce];for(let ce=0;ce<ne;ce++)z[ce+J]=G[ce]}e.$5b=W;function V(z,_,G,J){const te=ie(z,_);let ne=z.splice(te,G);return ne===void 0&&(ne=[]),W(z,te,J),ne}e.$6b=V;function ie(z,_){return _<0?Math.max(_+z.length,0):Math.min(_,z.length)}var re;(function(z){function _(ne){return ne<0}z.isLessThan=_;function G(ne){return ne<=0}z.isLessThanOrEqual=G;function J(ne){return ne>0}z.isGreaterThan=J;function te(ne){return ne===0}z.isNeitherLessOrGreaterThan=te,z.greaterThan=1,z.lessThan=-1,z.neitherLessOrGreaterThan=0})(re||(e.CompareResult=re={}));function ee(z,_){return(G,J)=>_(z(G),z(J))}e.$7b=ee;function ae(...z){return(_,G)=>{for(const J of z){const te=J(_,G);if(!re.isNeitherLessOrGreaterThan(te))return te}return re.neitherLessOrGreaterThan}}e.$8b=ae;const K=(z,_)=>z-_;e.$9b=K;const q=(z,_)=>(0,e.$9b)(z?1:0,_?1:0);e.$0b=q;function j(z){return(_,G)=>-z(_,G)}e.$$b=j;class F{constructor(_){this.g=_,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(_){let G=this.c;for(;G<this.g.length&&_(this.g[G]);)G++;const J=G===this.c?null:this.g.slice(this.c,G);return this.c=G,J}takeFromEndWhile(_){let G=this.d;for(;G>=0&&_(this.g[G]);)G--;const J=G===this.d?null:this.g.slice(G+1,this.d+1);return this.d=G,J}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const _=this.g[this.c];return this.c++,_}removeLast(){const _=this.g[this.d];return this.d--,_}takeCount(_){const G=this.g.slice(this.c,this.c+_);return this.c+=_,G}}e.$_b=F;class B{static{this.empty=new B(_=>{})}constructor(_){this.iterate=_}forEach(_){this.iterate(G=>(_(G),!0))}toArray(){const _=[];return this.iterate(G=>(_.push(G),!0)),_}filter(_){return new B(G=>this.iterate(J=>_(J)?G(J):!0))}map(_){return new B(G=>this.iterate(J=>G(_(J))))}some(_){let G=!1;return this.iterate(J=>(G=_(J),!G)),G}findFirst(_){let G;return this.iterate(J=>_(J)?(G=J,!1):!0),G}findLast(_){let G;return this.iterate(J=>(_(J)&&(G=J),!0)),G}findLastMaxBy(_){let G,J=!0;return this.iterate(te=>((J||re.isGreaterThan(_(te,G)))&&(J=!1,G=te),!0)),G}}e.$ac=B}),define(le[127],he([0,1,7]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function L(k,g){if(!k)throw new Error(g?`Assertion failed (${g})`:"Assertion Failed")}e.ok=L;function D(k,g="Unreachable"){throw new Error(g)}e.$6c=D;function A(k){if(!k)throw new O.$cb("Assertion Failed")}e.$7c=A;function I(k){if(!k()){debugger;k(),(0,O.$1)(new O.$cb("Assertion Failed"))}}e.$8c=I;function P(k,g){let C=0;for(;C<k.length-1;){const S=k[C],m=k[C+1];if(!g(S,m))return!1;C++}return!0}e.$9c=P}),define(le[86],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function O(L,D){const A=this;let I=!1,P;return function(){if(I)return P;if(I=!0,D)try{P=L.apply(A,arguments)}finally{D()}else P=L.apply(A,arguments);return P}}e.$db=O}),define(le[61],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var O;(function(L){function D(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}L.is=D;const A=Object.freeze([]);function I(){return A}L.empty=I;function*P(i){yield i}L.single=P;function k(i){return D(i)?i:P(i)}L.wrap=k;function g(i){return i||A}L.from=g;function*C(i){for(let o=i.length-1;o>=0;o--)yield i[o]}L.reverse=C;function S(i){return!i||i[Symbol.iterator]().next().done===!0}L.isEmpty=S;function m(i){return i[Symbol.iterator]().next().value}L.first=m;function l(i,o){for(const n of i)if(o(n))return!0;return!1}L.some=l;function $(i,o){for(const n of i)if(o(n))return n}L.find=$;function*b(i,o){for(const n of i)o(n)&&(yield n)}L.filter=b;function*w(i,o){let n=0;for(const s of i)yield o(s,n++)}L.map=w;function*h(...i){for(const o of i)yield*o}L.concat=h;function f(i,o,n){let s=n;for(const t of i)s=o(s,t);return s}L.reduce=f;function*d(i,o,n=i.length){for(o<0&&(o+=i.length),n<0?n+=i.length:n>i.length&&(n=i.length);o<n;o++)yield i[o]}L.slice=d;function c(i,o=Number.POSITIVE_INFINITY){const n=[];if(o===0)return[n,i];const s=i[Symbol.iterator]();for(let t=0;t<o;t++){const r=s.next();if(r.done)return[n,L.empty()];n.push(r.value)}return[n,{[Symbol.iterator](){return s}}]}L.consume=c;async function v(i){const o=[];for await(const n of i)o.push(n);return Promise.resolve(o)}L.asyncToArray=v})(O||(e.Iterable=O={}))}),define(le[34],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var O;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(O||(e.ScanError=O={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L||(e.SyntaxKind=L={}));var D;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(D||(e.ParseErrorCode=D={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A||(e.ParseOptions=A={}));function I(i,o=!1){let n=0;const s=i.length;let t="",r=0,a=16,E=0;function y(U){let Y=0,Q=0;for(;Y<U;){const x=i.charCodeAt(n);if(x>=48&&x<=57)Q=Q*16+x-48;else if(x>=65&&x<=70)Q=Q*16+x-65+10;else if(x>=97&&x<=102)Q=Q*16+x-97+10;else break;n++,Y++}return Y<U&&(Q=-1),Q}function u(U){n=U,t="",r=0,a=16,E=0}function p(){const U=n;if(i.charCodeAt(n)===48)n++;else for(n++;n<i.length&&g(i.charCodeAt(n));)n++;if(n<i.length&&i.charCodeAt(n)===46)if(n++,n<i.length&&g(i.charCodeAt(n)))for(n++;n<i.length&&g(i.charCodeAt(n));)n++;else return E=3,i.substring(U,n);let Y=n;if(n<i.length&&(i.charCodeAt(n)===69||i.charCodeAt(n)===101))if(n++,(n<i.length&&i.charCodeAt(n)===43||i.charCodeAt(n)===45)&&n++,n<i.length&&g(i.charCodeAt(n))){for(n++;n<i.length&&g(i.charCodeAt(n));)n++;Y=n}else E=3;return i.substring(U,Y)}function R(){let U="",Y=n;for(;;){if(n>=s){U+=i.substring(Y,n),E=2;break}const Q=i.charCodeAt(n);if(Q===34){U+=i.substring(Y,n),n++;break}if(Q===92){if(U+=i.substring(Y,n),n++,n>=s){E=2;break}switch(i.charCodeAt(n++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const H=y(4);H>=0?U+=String.fromCharCode(H):E=4;break}default:E=5}Y=n;continue}if(Q>=0&&Q<=31)if(k(Q)){U+=i.substring(Y,n),E=2;break}else E=6;n++}return U}function N(){if(t="",E=0,r=n,n>=s)return r=s,a=17;let U=i.charCodeAt(n);if(P(U)){do n++,t+=String.fromCharCode(U),U=i.charCodeAt(n);while(P(U));return a=15}if(k(U))return n++,t+=String.fromCharCode(U),U===13&&i.charCodeAt(n)===10&&(n++,t+=`
`),a=14;switch(U){case 123:return n++,a=1;case 125:return n++,a=2;case 91:return n++,a=3;case 93:return n++,a=4;case 58:return n++,a=6;case 44:return n++,a=5;case 34:return n++,t=R(),a=10;case 47:{const Y=n-1;if(i.charCodeAt(n+1)===47){for(n+=2;n<s&&!k(i.charCodeAt(n));)n++;return t=i.substring(Y,n),a=12}if(i.charCodeAt(n+1)===42){n+=2;const Q=s-1;let x=!1;for(;n<Q;){if(i.charCodeAt(n)===42&&i.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,E=1),t=i.substring(Y,n),a=13}return t+=String.fromCharCode(U),n++,a=16}case 45:if(t+=String.fromCharCode(U),n++,n===s||!g(i.charCodeAt(n)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return t+=p(),a=11;default:for(;n<s&&T(U);)n++,U=i.charCodeAt(n);if(r!==n){switch(t=i.substring(r,n),t){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return t+=String.fromCharCode(U),n++,a=16}}function T(U){if(P(U)||k(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function M(){let U;do U=N();while(U>=12&&U<=15);return U}return{setPosition:u,getPosition:()=>n,scan:o?M:N,getToken:()=>a,getTokenValue:()=>t,getTokenOffset:()=>r,getTokenLength:()=>n-r,getTokenError:()=>E}}e.$an=I;function P(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function k(i){return i===10||i===13||i===8232||i===8233}function g(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function S(i,o){const n=[],s=new Object;let t;const r={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function E(y,u,p,R){r.value=y,r.offset=u,r.length=p,r.type=R,r.colonOffset=void 0,t=r}try{d(i,{onObjectBegin:(y,u)=>{if(o<=y)throw s;t=void 0,a=o>y,n.push("")},onObjectProperty:(y,u,p)=>{if(o<u||(E(y,u,p,"property"),n[n.length-1]=y,o<=u+p))throw s},onObjectEnd:(y,u)=>{if(o<=y)throw s;t=void 0,n.pop()},onArrayBegin:(y,u)=>{if(o<=y)throw s;t=void 0,n.push(0)},onArrayEnd:(y,u)=>{if(o<=y)throw s;t=void 0,n.pop()},onLiteralValue:(y,u,p)=>{if(o<u||(E(y,u,p,v(y)),o<=u+p))throw s},onSeparator:(y,u,p)=>{if(o<=u)throw s;if(y===":"&&t&&t.type==="property")t.colonOffset=u,a=!1,t=void 0;else if(y===","){const R=n[n.length-1];typeof R=="number"?n[n.length-1]=R+1:(a=!0,n[n.length-1]=""),t=void 0}}})}catch(y){if(y!==s)throw y}return{path:n,previousNode:t,isAtPropertyKey:a,matches:y=>{let u=0;for(let p=0;u<y.length&&p<n.length;p++)if(y[u]===n[p]||y[u]==="*")u++;else if(y[u]!=="**")return!1;return u===y.length}}}e.$bn=S;function m(i,o=[],n=A.DEFAULT){let s=null,t=[];const r=[];function a(y){Array.isArray(t)?t.push(y):s!==null&&(t[s]=y)}return d(i,{onObjectBegin:()=>{const y={};a(y),r.push(t),t=y,s=null},onObjectProperty:y=>{s=y},onObjectEnd:()=>{t=r.pop()},onArrayBegin:()=>{const y=[];a(y),r.push(t),t=y,s=null},onArrayEnd:()=>{t=r.pop()},onLiteralValue:a,onError:(y,u,p)=>{o.push({error:y,offset:u,length:p})}},n),t[0]}e.$cn=m;function l(i,o=[],n=A.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function t(y){s.type==="property"&&(s.length=y-s.offset,s=s.parent)}function r(y){return s.children.push(y),y}d(i,{onObjectBegin:y=>{s=r({type:"object",offset:y,length:-1,parent:s,children:[]})},onObjectProperty:(y,u,p)=>{s=r({type:"property",offset:u,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:y,offset:u,length:p,parent:s})},onObjectEnd:(y,u)=>{s.length=y+u-s.offset,s=s.parent,t(y+u)},onArrayBegin:(y,u)=>{s=r({type:"array",offset:y,length:-1,parent:s,children:[]})},onArrayEnd:(y,u)=>{s.length=y+u-s.offset,s=s.parent,t(y+u)},onLiteralValue:(y,u,p)=>{r({type:v(y),offset:u,length:p,parent:s,value:y}),t(u+p)},onSeparator:(y,u,p)=>{s.type==="property"&&(y===":"?s.colonOffset=u:y===","&&t(u))},onError:(y,u,p)=>{o.push({error:y,offset:u,length:p})}},n);const E=s.children[0];return E&&delete E.parent,E}e.$dn=l;function $(i,o){if(!i)return;let n=i;for(const s of o)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let t=!1;for(const r of n.children)if(Array.isArray(r.children)&&r.children[0].value===s){n=r.children[1],t=!0;break}if(!t)return}else{const t=s;if(n.type!=="array"||t<0||!Array.isArray(n.children)||t>=n.children.length)return;n=n.children[t]}return n}e.$en=$;function b(i){if(!i.parent||!i.parent.children)return[];const o=b(i.parent);if(i.parent.type==="property"){const n=i.parent.children[0].value;o.push(n)}else if(i.parent.type==="array"){const n=i.parent.children.indexOf(i);n!==-1&&o.push(n)}return o}e.$fn=b;function w(i){switch(i.type){case"array":return i.children.map(w);case"object":{const o=Object.create(null);for(const n of i.children){const s=n.children[1];s&&(o[n.children[0].value]=w(s))}return o}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.$gn=w;function h(i,o,n=!1){return o>=i.offset&&o<i.offset+i.length||n&&o===i.offset+i.length}e.$hn=h;function f(i,o,n=!1){if(h(i,o,n)){const s=i.children;if(Array.isArray(s))for(let t=0;t<s.length&&s[t].offset<=o;t++){const r=f(s[t],o,n);if(r)return r}return i}}e.$in=f;function d(i,o,n=A.DEFAULT){const s=I(i,!1);function t(ee){return ee?()=>ee(s.getTokenOffset(),s.getTokenLength()):()=>!0}function r(ee){return ee?ae=>ee(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const a=t(o.onObjectBegin),E=r(o.onObjectProperty),y=t(o.onObjectEnd),u=t(o.onArrayBegin),p=t(o.onArrayEnd),R=r(o.onLiteralValue),N=r(o.onSeparator),T=t(o.onComment),M=r(o.onError),U=n&&n.disallowComments,Y=n&&n.allowTrailingComma;function Q(){for(;;){const ee=s.scan();switch(s.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:U||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(ee){case 12:case 13:U?x(10):T();break;case 16:x(1);break;case 15:case 14:break;default:return ee}}}function x(ee,ae=[],K=[]){if(M(ee),ae.length+K.length>0){let q=s.getToken();for(;q!==17;){if(ae.indexOf(q)!==-1){Q();break}else if(K.indexOf(q)!==-1)break;q=Q()}}}function H(ee){const ae=s.getTokenValue();return ee?R(ae):E(ae),Q(),!0}function Z(){switch(s.getToken()){case 11:{let ee=0;try{ee=JSON.parse(s.getTokenValue()),typeof ee!="number"&&(x(2),ee=0)}catch{x(2)}R(ee);break}case 7:R(null);break;case 8:R(!0);break;case 9:R(!1);break;default:return!1}return Q(),!0}function W(){return s.getToken()!==10?(x(3,[],[2,5]),!1):(H(!1),s.getToken()===6?(N(":"),Q(),re()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function V(){a(),Q();let ee=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),Q(),s.getToken()===2&&Y)break}else ee&&x(6,[],[]);W()||x(4,[],[2,5]),ee=!0}return y(),s.getToken()!==2?x(7,[2],[]):Q(),!0}function ie(){u(),Q();let ee=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(ee||x(4,[],[]),N(","),Q(),s.getToken()===4&&Y)break}else ee&&x(6,[],[]);re()||x(4,[],[4,5]),ee=!0}return p(),s.getToken()!==4?x(8,[4],[]):Q(),!0}function re(){switch(s.getToken()){case 3:return ie();case 1:return V();case 10:return H(!0);default:return Z()}}return Q(),s.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):re()?(s.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}e.$jn=d;function c(i,o){const n=I(i),s=[];let t,r=0,a;do switch(a=n.getPosition(),t=n.scan(),t){case 12:case 13:case 17:r!==a&&s.push(i.substring(r,a)),o!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,o)),r=n.getPosition();break}while(t!==17);return s.join("")}e.$kn=c;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=v}),define(le[42],he([0,1,34]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pn=e.$on=e.$nn=e.$mn=void 0;function L(g,C,S){let m,l,$,b,w;if(C){for(b=C.offset,w=b+C.length,$=b;$>0&&!k(g,$-1);)$--;let a=w;for(;a<g.length&&!k(g,a);)a++;l=g.substring($,a),m=I(l,S)}else l=g,m=0,$=0,b=0,w=g.length;const h=P(S,g);let f=!1,d=0,c;S.insertSpaces?c=A(" ",S.tabSize||4):c="	";const v=(0,O.$an)(l,!1);let i=!1;function o(){return h+A(c,m+d)}function n(){let a=v.scan();for(f=!1;a===15||a===14;)f=f||a===14,a=v.scan();return i=a===16||v.getTokenError()!==0,a}const s=[];function t(a,E,y){!i&&E<w&&y>b&&g.substring(E,y)!==a&&s.push({offset:E,length:y-E,content:a})}let r=n();if(r!==17){const a=v.getTokenOffset()+$,E=A(c,m);t(E,$,a)}for(;r!==17;){let a=v.getTokenOffset()+v.getTokenLength()+$,E=n(),y="";for(;!f&&(E===12||E===13);){const p=v.getTokenOffset()+$;t(" ",a,p),a=v.getTokenOffset()+v.getTokenLength()+$,y=E===12?o():"",E=n()}if(E===2)r!==1&&(d--,y=o());else if(E===4)r!==3&&(d--,y=o());else{switch(r){case 3:case 1:d++,y=o();break;case 5:case 12:y=o();break;case 13:f?y=o():y=" ";break;case 6:y=" ";break;case 10:if(E===6){y="";break}case 7:case 8:case 9:case 11:case 2:case 4:E===12||E===13?y=" ":E!==5&&E!==17&&(i=!0);break;case 16:i=!0;break}f&&(E===12||E===13)&&(y=o())}const u=v.getTokenOffset()+$;t(y,a,u),r=E}return s}e.$mn=L;function D(g,C){const S=JSON.stringify(g,void 0,C.insertSpaces?C.tabSize||4:"	");return C.eol!==void 0?S.replace(/\r\n|\r|\n/g,C.eol):S}e.$nn=D;function A(g,C){let S="";for(let m=0;m<C;m++)S+=g;return S}function I(g,C){let S=0,m=0;const l=C.tabSize||4;for(;S<g.length;){const $=g.charAt(S);if($===" ")m++;else if($==="	")m+=l;else break;S++}return Math.floor(m/l)}function P(g,C){for(let S=0;S<C.length;S++){const m=C.charAt(S);if(m==="\r")return S+1<C.length&&C.charAt(S+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return g&&g.eol||`
`}e.$on=P;function k(g,C){return`\r
`.indexOf(g.charAt(C))!==-1}e.$pn=k}),define(le[62],he([0,1,34,42]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$un=e.$tn=e.$sn=e.$rn=e.$qn=void 0;function D(g,C,S){return A(g,C,void 0,S)}e.$qn=D;function A(g,C,S,m,l){const $=C.slice(),b=[],w=(0,O.$dn)(g,b);let h,f;for(;$.length>0&&(f=$.pop(),h=(0,O.$en)(w,$),h===void 0&&S!==void 0);)typeof f=="string"?S={[f]:S}:S=[S];if(h)if(h.type==="object"&&typeof f=="string"&&Array.isArray(h.children)){const d=(0,O.$en)(h,[f]);if(d!==void 0)if(S===void 0){if(!d.parent)throw new Error("Malformed AST");const c=h.children.indexOf(d.parent);let v,i=d.parent.offset+d.parent.length;if(c>0){const o=h.children[c-1];v=o.offset+o.length}else v=h.offset+1,h.children.length>1&&(i=h.children[1].offset);return I(g,{offset:v,length:i-v,content:""},m)}else return I(g,{offset:d.offset,length:d.length,content:JSON.stringify(S)},m);else{if(S===void 0)return[];const c=`${JSON.stringify(f)}: ${JSON.stringify(S)}`,v=l?l(h.children.map(o=>o.children[0].value)):h.children.length;let i;if(v>0){const o=h.children[v-1];i={offset:o.offset+o.length,length:0,content:","+c}}else h.children.length===0?i={offset:h.offset+1,length:0,content:c}:i={offset:h.offset+1,length:0,content:c+","};return I(g,i,m)}}else if(h.type==="array"&&typeof f=="number"&&Array.isArray(h.children))if(S!==void 0){const d=`${JSON.stringify(S)}`;let c;if(h.children.length===0||f===0)c={offset:h.offset+1,length:0,content:h.children.length===0?d:d+","};else{const v=f===-1||f>h.children.length?h.children.length:f,i=h.children[v-1];c={offset:i.offset+i.length,length:0,content:","+d}}return I(g,c,m)}else{const d=f,c=h.children[d];let v;if(h.children.length===1)v={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===d){const i=h.children[d-1],o=i.offset+i.length,n=h.offset+h.length;v={offset:o,length:n-2-o,content:""}}else v={offset:c.offset,length:h.children[d+1].offset-c.offset,content:""};return I(g,v,m)}else throw new Error(`Can not add ${typeof f!="number"?"index":"property"} to parent of type ${h.type}`);else{if(S===void 0)throw new Error("Can not delete in empty document");return I(g,{offset:w?w.offset:0,length:w?w.length:0,content:JSON.stringify(S)},m)}}e.$rn=A;function I(g,C,S){let m=P(g,C),l=C.offset,$=C.offset+C.content.length;if(C.length===0||C.content.length===0){for(;l>0&&!(0,L.$pn)(m,l-1);)l--;for(;$<m.length&&!(0,L.$pn)(m,$);)$++}const b=(0,L.$mn)(m,{offset:l,length:$-l},S);for(let h=b.length-1;h>=0;h--){const f=b[h];m=P(m,f),l=Math.min(l,f.offset),$=Math.max($,f.offset+f.length),$+=f.content.length-f.length}const w=g.length-(m.length-$)-l;return[{offset:l,length:w,content:m.substring(l,$)}]}e.$sn=I;function P(g,C){return g.substring(0,C.offset)+C.content+g.substring(C.offset+C.length)}e.$tn=P;function k(g,C){const S=C.slice(0).sort((l,$)=>{const b=l.offset-$.offset;return b===0?l.length-$.length:b});let m=g.length;for(let l=S.length-1;l>=0;l--){const $=S[l];if($.offset+$.length<=m)g=P(g,$);else throw new Error("Overlapping edit");m=$.offset}return g}e.$un=k}),define(le[52],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class O{constructor(D){this.d=D,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(D){this.c=D}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=O}),define(le[87],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class O{static{this.Undefined=new O(void 0)}constructor(A){this.element=A,this.next=O.Undefined,this.prev=O.Undefined}}class L{constructor(){this.a=O.Undefined,this.b=O.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===O.Undefined}clear(){let A=this.a;for(;A!==O.Undefined;){const I=A.next;A.prev=O.Undefined,A.next=O.Undefined,A=I}this.a=O.Undefined,this.b=O.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,I){const P=new O(A);if(this.a===O.Undefined)this.a=P,this.b=P;else if(I){const g=this.b;this.b=P,P.prev=g,g.next=P}else{const g=this.a;this.a=P,P.next=g,g.prev=P}this.c+=1;let k=!1;return()=>{k||(k=!0,this.e(P))}}shift(){if(this.a!==O.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==O.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==O.Undefined&&A.next!==O.Undefined){const I=A.prev;I.next=A.next,A.next.prev=I}else A.prev===O.Undefined&&A.next===O.Undefined?(this.a=O.Undefined,this.b=O.Undefined):A.next===O.Undefined?(this.b=this.b.prev,this.b.next=O.Undefined):A.prev===O.Undefined&&(this.a=this.a.next,this.a.prev=O.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==O.Undefined;)yield A.element,A=A.next}}e.$4c=L}),define(le[35],he([0,1]),function(se,e){"use strict";var O,L,D;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function A(d,c,v){let i=d.get(c);return i===void 0&&(i=v,d.set(c,i)),i}e.$xc=A;function I(d){const c=[];return d.forEach((v,i)=>{c.push(`${i} => ${v}`)}),`Map(${d.size}) {${c.join(", ")}}`}e.$yc=I;function P(d){const c=[];return d.forEach(v=>{c.push(v)}),`Set(${d.size}) {${c.join(", ")}}`}e.$zc=P;class k{constructor(c,v){this.uri=c,this.value=v}}function g(d){return Array.isArray(d)}class C{static{this.c=c=>c.toString()}constructor(c,v){if(this[O]="ResourceMap",c instanceof C)this.d=new Map(c.d),this.e=v??C.c;else if(g(c)){this.d=new Map,this.e=v??C.c;for(const[i,o]of c)this.set(i,o)}else this.d=new Map,this.e=c??C.c}set(c,v){return this.d.set(this.e(c),new k(c,v)),this}get(c){return this.d.get(this.e(c))?.value}has(c){return this.d.has(this.e(c))}get size(){return this.d.size}clear(){this.d.clear()}delete(c){return this.d.delete(this.e(c))}forEach(c,v){typeof v<"u"&&(c=c.bind(v));for(const[i,o]of this.d)c(o.value,o.uri,this)}*values(){for(const c of this.d.values())yield c.value}*keys(){for(const c of this.d.values())yield c.uri}*entries(){for(const c of this.d.values())yield[c.uri,c.value]}*[(O=Symbol.toStringTag,Symbol.iterator)](){for(const[,c]of this.d)yield[c.uri,c.value]}}e.$Ac=C;class S{constructor(c,v){this[L]="ResourceSet",!c||typeof c=="function"?this.c=new C(c):(this.c=new C(v),c.forEach(this.add,this))}get size(){return this.c.size}add(c){return this.c.set(c,c),this}clear(){this.c.clear()}delete(c){return this.c.delete(c)}forEach(c,v){this.c.forEach((i,o)=>c.call(v,o,o,this))}has(c){return this.c.has(c)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=S;var m;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class l{constructor(){this[D]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(c){return this.c.has(c)}get(c,v=0){const i=this.c.get(c);if(i)return v!==0&&this.l(i,v),i.value}set(c,v,i=0){let o=this.c.get(c);if(o)o.value=v,i!==0&&this.l(o,i);else{switch(o={key:c,value:v,next:void 0,previous:void 0},i){case 0:this.j(o);break;case 1:this.i(o);break;case 2:this.j(o);break;default:this.j(o);break}this.c.set(c,o),this.f++}return this}delete(c){return!!this.remove(c)}remove(c){const v=this.c.get(c);if(v)return this.c.delete(c),this.k(v),this.f--,v.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const c=this.d;return this.c.delete(c.key),this.k(c),this.f--,c.value}forEach(c,v){const i=this.g;let o=this.d;for(;o;){if(v?c.bind(v)(o.value,o.key,this):c(o.value,o.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");o=o.next}}keys(){const c=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.key,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}values(){const c=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:i.value,done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}entries(){const c=this,v=this.g;let i=this.d;const o={[Symbol.iterator](){return o},next(){if(c.g!==v)throw new Error("LinkedMap got modified during iteration.");if(i){const n={value:[i.key,i.value],done:!1};return i=i.next,n}else return{value:void 0,done:!0}}};return o}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(c){if(c>=this.size)return;if(c===0){this.clear();return}let v=this.d,i=this.size;for(;v&&i>c;)this.c.delete(v.key),v=v.next,i--;this.d=v,this.f=i,v&&(v.previous=void 0),this.g++}i(c){if(!this.d&&!this.e)this.e=c;else if(this.d)c.next=this.d,this.d.previous=c;else throw new Error("Invalid list");this.d=c,this.g++}j(c){if(!this.d&&!this.e)this.d=c;else if(this.e)c.previous=this.e,this.e.next=c;else throw new Error("Invalid list");this.e=c,this.g++}k(c){if(c===this.d&&c===this.e)this.d=void 0,this.e=void 0;else if(c===this.d){if(!c.next)throw new Error("Invalid list");c.next.previous=void 0,this.d=c.next}else if(c===this.e){if(!c.previous)throw new Error("Invalid list");c.previous.next=void 0,this.e=c.previous}else{const v=c.next,i=c.previous;if(!v||!i)throw new Error("Invalid list");v.previous=i,i.next=v}c.next=void 0,c.previous=void 0,this.g++}l(c,v){if(!this.d||!this.e)throw new Error("Invalid list");if(!(v!==1&&v!==2)){if(v===1){if(c===this.d)return;const i=c.next,o=c.previous;c===this.e?(o.next=void 0,this.e=o):(i.previous=o,o.next=i),c.previous=void 0,c.next=this.d,this.d.previous=c,this.d=c,this.g++}else if(v===2){if(c===this.e)return;const i=c.next,o=c.previous;c===this.d?(i.previous=void 0,this.d=i):(i.previous=o,o.next=i),c.next=void 0,c.previous=this.e,this.e.next=c,this.e=c,this.g++}}}toJSON(){const c=[];return this.forEach((v,i)=>{c.push([i,v])}),c}fromJSON(c){this.clear();for(const[v,i]of c)this.set(v,i)}}e.$Cc=l;class $ extends l{constructor(c,v=1){super(),this.m=c,this.n=Math.min(Math.max(0,v),1)}get limit(){return this.m}set limit(c){this.m=c,this.o()}get ratio(){return this.n}set ratio(c){this.n=Math.min(Math.max(0,c),1),this.o()}get(c,v=2){return super.get(c,v)}peek(c){return super.get(c,0)}set(c,v){return super.set(c,v,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class b{constructor(){this.c=new Map}add(c){return this.c.set(c,(this.c.get(c)||0)+1),this}delete(c){let v=this.c.get(c)||0;return v===0?!1:(v--,v===0?this.c.delete(c):this.c.set(c,v),!0)}has(c){return this.c.has(c)}}e.$Ec=b;class w{constructor(c){if(this.c=new Map,this.d=new Map,c)for(const[v,i]of c)this.set(v,i)}clear(){this.c.clear(),this.d.clear()}set(c,v){this.c.set(c,v),this.d.set(v,c)}get(c){return this.c.get(c)}getKey(c){return this.d.get(c)}delete(c){const v=this.c.get(c);return v===void 0?!1:(this.c.delete(c),this.d.delete(v),!0)}forEach(c,v){this.c.forEach((i,o)=>{c.call(v,i,o,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=w;class h{constructor(){this.c=new Map}add(c,v){let i=this.c.get(c);i||(i=new Set,this.c.set(c,i)),i.add(v)}delete(c,v){const i=this.c.get(c);i&&(i.delete(v),i.size===0&&this.c.delete(c))}forEach(c,v){const i=this.c.get(c);i&&i.forEach(v)}get(c){const v=this.c.get(c);return v||new Set}}e.$Gc=h;function f(d,c){if(d===c)return!0;if(d.size!==c.size)return!1;for(const[v,i]of d)if(!c.has(v)||c.get(v)!==i)return!1;for(const[v]of c)if(!d.has(v))return!1;return!0}e.$Hc=f}),define(le[2],he([0,1,17,126,35,86,61]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const P=!1;let k=null;class g{constructor(){this.b=new Map}static{this.a=0}c(R){let N=this.b.get(R);return N||(N={parent:null,source:null,isSingleton:!1,value:R,idx:g.a++},this.b.set(R,N)),N}trackDisposable(R){const N=this.c(R);N.source||(N.source=new Error().stack)}setParent(R,N){const T=this.c(R);T.parent=N}markAsDisposed(R){this.b.delete(R)}markAsSingleton(R){this.c(R).isSingleton=!0}f(R,N){const T=N.get(R);if(T)return T;const M=R.parent?this.f(this.c(R.parent),N):R;return N.set(R,M),M}getTrackedDisposables(){const R=new Map;return[...this.b.entries()].filter(([,T])=>T.source!==null&&!this.f(T,R).isSingleton).flatMap(([T])=>T)}computeLeakingDisposables(R=10,N){let T;if(N)T=N;else{const x=new Map,H=[...this.b.values()].filter(W=>W.source!==null&&!this.f(W,x).isSingleton);if(H.length===0)return;const Z=new Set(H.map(W=>W.value));if(T=H.filter(W=>!(W.parent&&Z.has(W.parent))),T.length===0)throw new Error("There are cyclic diposable chains!")}if(!T)return;function M(x){function H(W,V){for(;W.length>0&&V.some(ie=>typeof ie=="string"?ie===W[0]:W[0].match(ie));)W.shift()}const Z=x.source.split(`
`).map(W=>W.trim().replace("at ","")).filter(W=>W!=="");return H(Z,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),Z.reverse()}const U=new D.$Gc;for(const x of T){const H=M(x);for(let Z=0;Z<=H.length;Z++)U.add(H.slice(0,Z).join(`
`),x)}T.sort((0,O.$7b)(x=>x.idx,O.$9b));let Y="",Q=0;for(const x of T.slice(0,R)){Q++;const H=M(x),Z=[];for(let W=0;W<H.length;W++){let V=H[W];V=`(shared with ${U.get(H.slice(0,W+1).join(`
`)).size}/${T.length} leaks) at ${V}`;const re=U.get(H.slice(0,W).join(`
`)),ee=(0,L.$K)([...re].map(ae=>M(ae)[W]),ae=>ae);delete ee[H[W]];for(const[ae,K]of Object.entries(ee))Z.unshift(`    - stacktraces of ${K.length} other leaks continue with ${ae}`);Z.unshift(V)}Y+=`


==================== Leaking disposable ${Q}/${T.length}: ${x.value.constructor.name} ====================
${Z.join(`
`)}
============================================================

`}return T.length>R&&(Y+=`


... and ${T.length-R} more leaking disposables

`),{leaks:T,details:Y}}}e.$Ic=g;function C(p){k=p}if(e.$Jc=C,P){const p="__is_disposable_tracked__";C(new class{trackDisposable(R){const N=new Error("Potentially leaked disposable").stack;setTimeout(()=>{R[p]||console.log(N)},3e3)}setParent(R,N){if(R&&R!==i.None)try{R[p]=!0}catch{}}markAsDisposed(R){if(R&&R!==i.None)try{R[p]=!0}catch{}}markAsSingleton(R){}})}function S(p){return k?.trackDisposable(p),p}e.$Kc=S;function m(p){k?.markAsDisposed(p)}e.$Lc=m;function l(p,R){k?.setParent(p,R)}function $(p,R){if(k)for(const N of p)k.setParent(N,R)}function b(p){return k?.markAsSingleton(p),p}e.$Mc=b;function w(p){return typeof p.dispose=="function"&&p.dispose.length===0}e.$Nc=w;function h(p){if(I.Iterable.is(p)){const R=[];for(const N of p)if(N)try{N.dispose()}catch(T){R.push(T)}if(R.length===1)throw R[0];if(R.length>1)throw new AggregateError(R,"Encountered errors while disposing of store");return Array.isArray(p)?[]:p}else if(p)return p.dispose(),p}e.$Oc=h;function f(p){for(const R of p)w(R)&&R.dispose();return[]}e.$Pc=f;function d(...p){const R=c(()=>h(p));return $(p,R),R}e.$Qc=d;function c(p){const R=S({dispose:(0,A.$db)(()=>{m(R),p()})});return R}e.$Rc=c;class v{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,S(this)}dispose(){this.g||(m(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{h(this.f)}finally{this.f.clear()}}add(R){if(!R)return R;if(R===this)throw new Error("Cannot register a disposable on itself!");return l(R,this),this.g?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(R),R}delete(R){if(R){if(R===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(R),R.dispose()}}deleteAndLeak(R){R&&this.f.has(R)&&(this.f.delete(R),l(R,null))}}e.$Sc=v;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new v,S(this),l(this.q,this)}dispose(){m(this),this.q.dispose()}B(R){if(R===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(R)}}e.$Tc=i;class o{constructor(){this.b=!1,S(this)}get value(){return this.b?void 0:this.a}set value(R){this.b||R===this.a||(this.a?.dispose(),R&&l(R,this),this.a=R)}clear(){this.value=void 0}dispose(){this.b=!0,m(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const R=this.a;return this.a=void 0,R&&l(R,null),R}}e.$Uc=o;class n{constructor(R){this.a=new o,this.b=!1,this.a.value=R}get value(){return this.a.value}set value(R){this.b||R===this.a.value||(this.a.value=R)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=n;class s{constructor(R){this.b=R,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=s;class t{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,S(this)}set(R){let N=R;return this.unset=()=>N=void 0,this.isset=()=>N!==void 0,this.dispose=()=>{N&&(N(),N=void 0,m(this))},this}}e.$Xc=t;class r{constructor(){this.a=new Map}acquire(R,...N){let T=this.a.get(R);T||(T={counter:0,object:this.b(R,...N)},this.a.set(R,T));const{object:M}=T,U=(0,A.$db)(()=>{--T.counter===0&&(this.c(R,T.object),this.a.delete(R))});return T.counter++,{object:M,dispose:U}}}e.$Yc=r;class a{constructor(R){this.a=R}async acquire(R,...N){const T=this.a.acquire(R,...N);try{return{object:await T.object,dispose:()=>T.dispose()}}catch(M){throw T.dispose(),M}}}e.$Zc=a;class E{constructor(R){this.object=R}dispose(){}}e.$1c=E;function y(p){const R=new v;try{p(R)}finally{R.dispose()}}e.$2c=y;class u{constructor(){this.a=new Map,this.b=!1,S(this)}dispose(){m(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{h(this.a.values())}finally{this.a.clear()}}has(R){return this.a.has(R)}get size(){return this.a.size}get(R){return this.a.get(R)}set(R,N,T=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),T||this.a.get(R)?.dispose(),this.a.set(R,N)}deleteAndDispose(R){this.a.get(R)?.dispose(),this.a.delete(R)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=u}),define(le[88],he([0,1,35]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=void 0;const L=new O.$Dc(1e4);function D(g){return k(g,"NFC",L)}e.$Gl=D;const A=new O.$Dc(1e4);function I(g){return k(g,"NFD",A)}e.$Hl=I;const P=/[^\u0000-\u0080]/;function k(g,C,S){if(!g)return g;const m=S.get(g);if(m)return m;let l;return P.test(g)?l=g.normalize(C):l=g,S.set(g,l),l}e.$Il=function(){const g=/[\u0300-\u036f]/g;return function(C){return I(C).replace(g,"")}}()}),function(){function se(D){const A=[];typeof D=="number"&&A.push("code/timeOrigin",D);function I(k){A.push(k,Date.now())}function P(){const k=[];for(let g=0;g<A.length;g+=2)k.push({name:A[g],startTime:A[g+1]});return k}return{mark:I,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?se():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const I of performance.getEntriesByType("mark"))A.push({name:I.name,startTime:Math.round(D+I.startTime)});return A}};if(typeof process=="object"){const D=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return se(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),se()}function O(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=O(L))}(),function(se,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var O=e();for(var L in O)(typeof exports=="object"?exports:se)[L]=O[L]}}(typeof self<"u"?self:this,function(){return function(se){var e={};function O(L){if(e[L])return e[L].exports;var D=e[L]={i:L,l:!1,exports:{}};return se[L].call(D.exports,D,D.exports,O),D.l=!0,D.exports}return O.m=se,O.c=e,O.d=function(L,D,A){O.o(L,D)||Object.defineProperty(L,D,{enumerable:!0,get:A})},O.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},O.t=function(L,D){if(1&D&&(L=O(L)),8&D||4&D&&typeof L=="object"&&L&&L.__esModule)return L;var A=Object.create(null);if(O.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:L}),2&D&&typeof L!="string")for(var I in L)O.d(A,I,function(P){return L[P]}.bind(null,I));return A},O.n=function(L){var D=L&&L.__esModule?function(){return L.default}:function(){return L};return O.d(D,"a",D),D},O.o=function(L,D){return Object.prototype.hasOwnProperty.call(L,D)},O.p="",O(O.s=0)}([function(se,e,O){(function(L){var D;e=se.exports=K,D=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var ue=Array.prototype.slice.call(arguments,0);ue.unshift("SEMVER"),console.log.apply(console,ue)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var A=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],k=e.src=[],g=0,C=g++;k[C]="0|[1-9]\\d*";var S=g++;k[S]="[0-9]+";var m=g++;k[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var l=g++;k[l]="("+k[C]+")\\.("+k[C]+")\\.("+k[C]+")";var $=g++;k[$]="("+k[S]+")\\.("+k[S]+")\\.("+k[S]+")";var b=g++;k[b]="(?:"+k[C]+"|"+k[m]+")";var w=g++;k[w]="(?:"+k[S]+"|"+k[m]+")";var h=g++;k[h]="(?:-("+k[b]+"(?:\\."+k[b]+")*))";var f=g++;k[f]="(?:-?("+k[w]+"(?:\\."+k[w]+")*))";var d=g++;k[d]="[0-9A-Za-z-]+";var c=g++;k[c]="(?:\\+("+k[d]+"(?:\\."+k[d]+")*))";var v=g++,i="v?"+k[l]+k[h]+"?"+k[c]+"?";k[v]="^"+i+"$";var o="[v=\\s]*"+k[$]+k[f]+"?"+k[c]+"?",n=g++;k[n]="^"+o+"$";var s=g++;k[s]="((?:<|>)?=?)";var t=g++;k[t]=k[S]+"|x|X|\\*";var r=g++;k[r]=k[C]+"|x|X|\\*";var a=g++;k[a]="[v=\\s]*("+k[r]+")(?:\\.("+k[r]+")(?:\\.("+k[r]+")(?:"+k[h]+")?"+k[c]+"?)?)?";var E=g++;k[E]="[v=\\s]*("+k[t]+")(?:\\.("+k[t]+")(?:\\.("+k[t]+")(?:"+k[f]+")?"+k[c]+"?)?)?";var y=g++;k[y]="^"+k[s]+"\\s*"+k[a]+"$";var u=g++;k[u]="^"+k[s]+"\\s*"+k[E]+"$";var p=g++;k[p]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var R=g++;k[R]="(?:~>?)";var N=g++;k[N]="(\\s*)"+k[R]+"\\s+",P[N]=new RegExp(k[N],"g");var T=g++;k[T]="^"+k[R]+k[a]+"$";var M=g++;k[M]="^"+k[R]+k[E]+"$";var U=g++;k[U]="(?:\\^)";var Y=g++;k[Y]="(\\s*)"+k[U]+"\\s+",P[Y]=new RegExp(k[Y],"g");var Q=g++;k[Q]="^"+k[U]+k[a]+"$";var x=g++;k[x]="^"+k[U]+k[E]+"$";var H=g++;k[H]="^"+k[s]+"\\s*("+o+")$|^$";var Z=g++;k[Z]="^"+k[s]+"\\s*("+i+")$|^$";var W=g++;k[W]="(\\s*)"+k[s]+"\\s*("+o+"|"+k[a]+")",P[W]=new RegExp(k[W],"g");var V=g++;k[V]="^\\s*("+k[a]+")\\s+-\\s+("+k[a]+")\\s*$";var ie=g++;k[ie]="^\\s*("+k[E]+")\\s+-\\s+("+k[E]+")\\s*$";var re=g++;k[re]="(<|>)?=?\\s*\\*";for(var ee=0;ee<35;ee++)D(ee,k[ee]),P[ee]||(P[ee]=new RegExp(k[ee]));function ae(ue,ge){if(ue instanceof K)return ue;if(typeof ue!="string"||ue.length>A||!(ge?P[n]:P[v]).test(ue))return null;try{return new K(ue,ge)}catch{return null}}function K(ue,ge){if(ue instanceof K){if(ue.loose===ge)return ue;ue=ue.version}else if(typeof ue!="string")throw new TypeError("Invalid Version: "+ue);if(ue.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof K))return new K(ue,ge);D("SemVer",ue,ge),this.loose=ge;var we=ue.trim().match(ge?P[n]:P[v]);if(!we)throw new TypeError("Invalid Version: "+ue);if(this.raw=ue,this.major=+we[1],this.minor=+we[2],this.patch=+we[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");we[4]?this.prerelease=we[4].split(".").map(function(Ce){if(/^[0-9]+$/.test(Ce)){var Pe=+Ce;if(Pe>=0&&Pe<I)return Pe}return Ce}):this.prerelease=[],this.build=we[5]?we[5].split("."):[],this.format()}e.parse=ae,e.valid=function(ue,ge){var we=ae(ue,ge);return we?we.version:null},e.clean=function(ue,ge){var we=ae(ue.trim().replace(/^[=v]+/,""),ge);return we?we.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(ue){return D("SemVer.compare",this.version,this.loose,ue),ue instanceof K||(ue=new K(ue,this.loose)),this.compareMain(ue)||this.comparePre(ue)},K.prototype.compareMain=function(ue){return ue instanceof K||(ue=new K(ue,this.loose)),j(this.major,ue.major)||j(this.minor,ue.minor)||j(this.patch,ue.patch)},K.prototype.comparePre=function(ue){if(ue instanceof K||(ue=new K(ue,this.loose)),this.prerelease.length&&!ue.prerelease.length)return-1;if(!this.prerelease.length&&ue.prerelease.length)return 1;if(!this.prerelease.length&&!ue.prerelease.length)return 0;var ge=0;do{var we=this.prerelease[ge],Ce=ue.prerelease[ge];if(D("prerelease compare",ge,we,Ce),we===void 0&&Ce===void 0)return 0;if(Ce===void 0)return 1;if(we===void 0)return-1;if(we!==Ce)return j(we,Ce)}while(++ge)},K.prototype.inc=function(ue,ge){switch(ue){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ge);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ge);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ge),this.inc("pre",ge);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ge),this.inc("pre",ge);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var we=this.prerelease.length;--we>=0;)typeof this.prerelease[we]=="number"&&(this.prerelease[we]++,we=-2);we===-1&&this.prerelease.push(0)}ge&&(this.prerelease[0]===ge?isNaN(this.prerelease[1])&&(this.prerelease=[ge,0]):this.prerelease=[ge,0]);break;default:throw new Error("invalid increment argument: "+ue)}return this.format(),this.raw=this.version,this},e.inc=function(ue,ge,we,Ce){typeof we=="string"&&(Ce=we,we=void 0);try{return new K(ue,we).inc(ge,Ce).version}catch{return null}},e.diff=function(ue,ge){if(_(ue,ge))return null;var we=ae(ue),Ce=ae(ge);if(we.prerelease.length||Ce.prerelease.length){for(var Pe in we)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&we[Pe]!==Ce[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in we)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&we[Pe]!==Ce[Pe])return Pe},e.compareIdentifiers=j;var q=/^[0-9]+$/;function j(ue,ge){var we=q.test(ue),Ce=q.test(ge);return we&&Ce&&(ue=+ue,ge=+ge),we&&!Ce?-1:Ce&&!we?1:ue<ge?-1:ue>ge?1:0}function F(ue,ge,we){return new K(ue,we).compare(new K(ge,we))}function B(ue,ge,we){return F(ue,ge,we)>0}function z(ue,ge,we){return F(ue,ge,we)<0}function _(ue,ge,we){return F(ue,ge,we)===0}function G(ue,ge,we){return F(ue,ge,we)!==0}function J(ue,ge,we){return F(ue,ge,we)>=0}function te(ue,ge,we){return F(ue,ge,we)<=0}function ne(ue,ge,we,Ce){var Pe;switch(ge){case"===":typeof ue=="object"&&(ue=ue.version),typeof we=="object"&&(we=we.version),Pe=ue===we;break;case"!==":typeof ue=="object"&&(ue=ue.version),typeof we=="object"&&(we=we.version),Pe=ue!==we;break;case"":case"=":case"==":Pe=_(ue,we,Ce);break;case"!=":Pe=G(ue,we,Ce);break;case">":Pe=B(ue,we,Ce);break;case">=":Pe=J(ue,we,Ce);break;case"<":Pe=z(ue,we,Ce);break;case"<=":Pe=te(ue,we,Ce);break;default:throw new TypeError("Invalid operator: "+ge)}return Pe}function ce(ue,ge){if(ue instanceof ce){if(ue.loose===ge)return ue;ue=ue.value}if(!(this instanceof ce))return new ce(ue,ge);D("comparator",ue,ge),this.loose=ge,this.parse(ue),this.semver===de?this.value="":this.value=this.operator+this.semver.version,D("comp",this)}e.rcompareIdentifiers=function(ue,ge){return j(ge,ue)},e.major=function(ue,ge){return new K(ue,ge).major},e.minor=function(ue,ge){return new K(ue,ge).minor},e.patch=function(ue,ge){return new K(ue,ge).patch},e.compare=F,e.compareLoose=function(ue,ge){return F(ue,ge,!0)},e.rcompare=function(ue,ge,we){return F(ge,ue,we)},e.sort=function(ue,ge){return ue.sort(function(we,Ce){return e.compare(we,Ce,ge)})},e.rsort=function(ue,ge){return ue.sort(function(we,Ce){return e.rcompare(we,Ce,ge)})},e.gt=B,e.lt=z,e.eq=_,e.neq=G,e.gte=J,e.lte=te,e.cmp=ne,e.Comparator=ce;var de={};function $e(ue,ge){if(ue instanceof $e)return ue.loose===ge?ue:new $e(ue.raw,ge);if(ue instanceof ce)return new $e(ue.value,ge);if(!(this instanceof $e))return new $e(ue,ge);if(this.loose=ge,this.raw=ue,this.set=ue.split(/\s*\|\|\s*/).map(function(we){return this.parseRange(we.trim())},this).filter(function(we){return we.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ue);this.format()}function me(ue){return!ue||ue.toLowerCase()==="x"||ue==="*"}function Ee(ue,ge,we,Ce,Pe,Me,je,qe,Fe,Te,Ue,oe,fe){return((ge=me(we)?"":me(Ce)?">="+we+".0.0":me(Pe)?">="+we+"."+Ce+".0":">="+ge)+" "+(qe=me(Fe)?"":me(Te)?"<"+(+Fe+1)+".0.0":me(Ue)?"<"+Fe+"."+(+Te+1)+".0":oe?"<="+Fe+"."+Te+"."+Ue+"-"+oe:"<="+qe)).trim()}function Re(ue,ge){for(var we=0;we<ue.length;we++)if(!ue[we].test(ge))return!1;if(ge.prerelease.length){for(we=0;we<ue.length;we++)if(D(ue[we].semver),ue[we].semver!==de&&ue[we].semver.prerelease.length>0){var Ce=ue[we].semver;if(Ce.major===ge.major&&Ce.minor===ge.minor&&Ce.patch===ge.patch)return!0}return!1}return!0}function Oe(ue,ge,we){try{ge=new $e(ge,we)}catch{return!1}return ge.test(ue)}function Ne(ue,ge,we,Ce){var Pe,Me,je,qe,Fe;switch(ue=new K(ue,Ce),ge=new $e(ge,Ce),we){case">":Pe=B,Me=te,je=z,qe=">",Fe=">=";break;case"<":Pe=z,Me=J,je=B,qe="<",Fe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Oe(ue,ge,Ce))return!1;for(var Te=0;Te<ge.set.length;++Te){var Ue=ge.set[Te],oe=null,fe=null;if(Ue.forEach(function(be){be.semver===de&&(be=new ce(">=0.0.0")),oe=oe||be,fe=fe||be,Pe(be.semver,oe.semver,Ce)?oe=be:je(be.semver,fe.semver,Ce)&&(fe=be)}),oe.operator===qe||oe.operator===Fe||(!fe.operator||fe.operator===qe)&&Me(ue,fe.semver)||fe.operator===Fe&&je(ue,fe.semver))return!1}return!0}ce.prototype.parse=function(ue){var ge=this.loose?P[H]:P[Z],we=ue.match(ge);if(!we)throw new TypeError("Invalid comparator: "+ue);this.operator=we[1],this.operator==="="&&(this.operator=""),we[2]?this.semver=new K(we[2],this.loose):this.semver=de},ce.prototype.toString=function(){return this.value},ce.prototype.test=function(ue){return D("Comparator.test",ue,this.loose),this.semver===de||(typeof ue=="string"&&(ue=new K(ue,this.loose)),ne(ue,this.operator,this.semver,this.loose))},ce.prototype.intersects=function(ue,ge){if(!(ue instanceof ce))throw new TypeError("a Comparator is required");var we;if(this.operator==="")return we=new $e(ue.value,ge),Oe(this.value,we,ge);if(ue.operator==="")return we=new $e(this.value,ge),Oe(ue.semver,we,ge);var Ce=!(this.operator!==">="&&this.operator!==">"||ue.operator!==">="&&ue.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||ue.operator!=="<="&&ue.operator!=="<"),Me=this.semver.version===ue.semver.version,je=!(this.operator!==">="&&this.operator!=="<="||ue.operator!==">="&&ue.operator!=="<="),qe=ne(this.semver,"<",ue.semver,ge)&&(this.operator===">="||this.operator===">")&&(ue.operator==="<="||ue.operator==="<"),Fe=ne(this.semver,">",ue.semver,ge)&&(this.operator==="<="||this.operator==="<")&&(ue.operator===">="||ue.operator===">");return Ce||Pe||Me&&je||qe||Fe},e.Range=$e,$e.prototype.format=function(){return this.range=this.set.map(function(ue){return ue.join(" ").trim()}).join("||").trim(),this.range},$e.prototype.toString=function(){return this.range},$e.prototype.parseRange=function(ue){var ge=this.loose;ue=ue.trim(),D("range",ue,ge);var we=ge?P[ie]:P[V];ue=ue.replace(we,Ee),D("hyphen replace",ue),ue=ue.replace(P[W],"$1$2$3"),D("comparator trim",ue,P[W]),ue=(ue=(ue=ue.replace(P[N],"$1~")).replace(P[Y],"$1^")).split(/\s+/).join(" ");var Ce=ge?P[H]:P[Z],Pe=ue.split(" ").map(function(Me){return function(je,qe){return D("comp",je),je=function(Fe,Te){return Fe.trim().split(/\s+/).map(function(Ue){return function(oe,fe){D("caret",oe,fe);var be=fe?P[x]:P[Q];return oe.replace(be,function(ve,ye,ke,Ie,De){var Le;return D("caret",oe,ve,ye,ke,Ie,De),me(ye)?Le="":me(ke)?Le=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(Ie)?Le=ye==="0"?">="+ye+"."+ke+".0 <"+ye+"."+(+ke+1)+".0":">="+ye+"."+ke+".0 <"+(+ye+1)+".0.0":De?(D("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Le=ye==="0"?ke==="0"?">="+ye+"."+ke+"."+Ie+De+" <"+ye+"."+ke+"."+(+Ie+1):">="+ye+"."+ke+"."+Ie+De+" <"+ye+"."+(+ke+1)+".0":">="+ye+"."+ke+"."+Ie+De+" <"+(+ye+1)+".0.0"):(D("no pr"),Le=ye==="0"?ke==="0"?">="+ye+"."+ke+"."+Ie+" <"+ye+"."+ke+"."+(+Ie+1):">="+ye+"."+ke+"."+Ie+" <"+ye+"."+(+ke+1)+".0":">="+ye+"."+ke+"."+Ie+" <"+(+ye+1)+".0.0"),D("caret return",Le),Le})}(Ue,Te)}).join(" ")}(je,qe),D("caret",je),je=function(Fe,Te){return Fe.trim().split(/\s+/).map(function(Ue){return function(oe,fe){var be=fe?P[M]:P[T];return oe.replace(be,function(ve,ye,ke,Ie,De){var Le;return D("tilde",oe,ve,ye,ke,Ie,De),me(ye)?Le="":me(ke)?Le=">="+ye+".0.0 <"+(+ye+1)+".0.0":me(Ie)?Le=">="+ye+"."+ke+".0 <"+ye+"."+(+ke+1)+".0":De?(D("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Le=">="+ye+"."+ke+"."+Ie+De+" <"+ye+"."+(+ke+1)+".0"):Le=">="+ye+"."+ke+"."+Ie+" <"+ye+"."+(+ke+1)+".0",D("tilde return",Le),Le})}(Ue,Te)}).join(" ")}(je,qe),D("tildes",je),je=function(Fe,Te){return D("replaceXRanges",Fe,Te),Fe.split(/\s+/).map(function(Ue){return function(oe,fe){oe=oe.trim();var be=fe?P[u]:P[y];return oe.replace(be,function(ve,ye,ke,Ie,De,Le){D("xRange",oe,ve,ye,ke,Ie,De,Le);var Ve=me(ke),ze=Ve||me(Ie),Be=ze||me(De);return ye==="="&&Be&&(ye=""),Ve?ve=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Be?(ze&&(Ie=0),Be&&(De=0),ye===">"?(ye=">=",ze?(ke=+ke+1,Ie=0,De=0):Be&&(Ie=+Ie+1,De=0)):ye==="<="&&(ye="<",ze?ke=+ke+1:Ie=+Ie+1),ve=ye+ke+"."+Ie+"."+De):ze?ve=">="+ke+".0.0 <"+(+ke+1)+".0.0":Be&&(ve=">="+ke+"."+Ie+".0 <"+ke+"."+(+Ie+1)+".0"),D("xRange return",ve),ve})}(Ue,Te)}).join(" ")}(je,qe),D("xrange",je),je=function(Fe,Te){return D("replaceStars",Fe,Te),Fe.trim().replace(P[re],"")}(je,qe),D("stars",je),je}(Me,ge)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Me){return!!Me.match(Ce)})),Pe=Pe.map(function(Me){return new ce(Me,ge)})},$e.prototype.intersects=function(ue,ge){if(!(ue instanceof $e))throw new TypeError("a Range is required");return this.set.some(function(we){return we.every(function(Ce){return ue.set.some(function(Pe){return Pe.every(function(Me){return Ce.intersects(Me,ge)})})})})},e.toComparators=function(ue,ge){return new $e(ue,ge).set.map(function(we){return we.map(function(Ce){return Ce.value}).join(" ").trim().split(" ")})},$e.prototype.test=function(ue){if(!ue)return!1;typeof ue=="string"&&(ue=new K(ue,this.loose));for(var ge=0;ge<this.set.length;ge++)if(Re(this.set[ge],ue))return!0;return!1},e.satisfies=Oe,e.maxSatisfying=function(ue,ge,we){var Ce=null,Pe=null;try{var Me=new $e(ge,we)}catch{return null}return ue.forEach(function(je){Me.test(je)&&(Ce&&Pe.compare(je)!==-1||(Pe=new K(Ce=je,we)))}),Ce},e.minSatisfying=function(ue,ge,we){var Ce=null,Pe=null;try{var Me=new $e(ge,we)}catch{return null}return ue.forEach(function(je){Me.test(je)&&(Ce&&Pe.compare(je)!==1||(Pe=new K(Ce=je,we)))}),Ce},e.validRange=function(ue,ge){try{return new $e(ue,ge).range||"*"}catch{return null}},e.ltr=function(ue,ge,we){return Ne(ue,ge,"<",we)},e.gtr=function(ue,ge,we){return Ne(ue,ge,">",we)},e.outside=Ne,e.prerelease=function(ue,ge){var we=ae(ue,ge);return we&&we.prerelease.length?we.prerelease:null},e.intersects=function(ue,ge,we){return ue=new $e(ue,we),ge=new $e(ge,we),ue.intersects(ge)},e.coerce=function(ue){if(ue instanceof K)return ue;if(typeof ue!="string")return null;var ge=ue.match(P[p]);return ge==null?null:ae((ge[1]||"0")+"."+(ge[2]||"0")+"."+(ge[3]||"0"))}}).call(this,O(1))},function(se,e){var O,L,D=se.exports={};function A(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function P(w){if(O===setTimeout)return setTimeout(w,0);if((O===A||!O)&&setTimeout)return O=setTimeout,setTimeout(w,0);try{return O(w,0)}catch{try{return O.call(null,w,0)}catch{return O.call(this,w,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:A}catch{O=A}try{L=typeof clearTimeout=="function"?clearTimeout:I}catch{L=I}})();var k,g=[],C=!1,S=-1;function m(){C&&k&&(C=!1,k.length?g=k.concat(g):S=-1,g.length&&l())}function l(){if(!C){var w=P(m);C=!0;for(var h=g.length;h;){for(k=g,g=[];++S<h;)k&&k[S].run();S=-1,h=g.length}k=null,C=!1,function(f){if(L===clearTimeout)return clearTimeout(f);if((L===I||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(f);try{L(f)}catch{try{return L.call(null,f)}catch{return L.call(this,f)}}}(w)}}function $(w,h){this.fun=w,this.array=h}function b(){}D.nextTick=function(w){var h=new Array(arguments.length-1);if(arguments.length>1)for(var f=1;f<arguments.length;f++)h[f-1]=arguments[f];g.push(new $(w,h)),g.length!==1||C||P(l)},$.prototype.run=function(){this.fun.apply(null,this.array)},D.title="browser",D.browser=!0,D.env={},D.argv=[],D.version="",D.versions={},D.on=b,D.addListener=b,D.once=b,D.off=b,D.removeListener=b,D.removeAllListeners=b,D.emit=b,D.prependListener=b,D.prependOnceListener=b,D.listeners=function(w){return[]},D.binding=function(w){throw new Error("process.binding is not supported")},D.cwd=function(){return"/"},D.chdir=function(w){throw new Error("process.chdir is not supported")},D.umask=function(){return 0}}])}),define(le[128],he([0,1]),function(se,e){"use strict";var O;Object.defineProperty(e,"__esModule",{value:!0}),e.$1r=void 0;class L{constructor(P,k,g){this.level=P,this.key=k,this.value=g,this.forward=[]}}const D=void 0;class A{constructor(P,k=2**16){this.comparator=P,this[O]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(k)|0),this.e=new L(this.c,D,D)}get size(){return this.f}clear(){this.e=new L(this.c,D,D),this.f=0}has(P){return!!A.g(this,P,this.comparator)}get(P){return A.g(this,P,this.comparator)?.value}set(P,k){return A.h(this,P,k,this.comparator)&&(this.f+=1),this}delete(P){const k=A.k(this,P,this.comparator);return k&&(this.f-=1),k}forEach(P,k){let g=this.e.forward[0];for(;g;)P.call(k,g.value,g.key,this),g=g.forward[0]}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",k=this.e.forward[0];for(;k;)P+=`node(${k.key}, ${k.value}, lvl:${k.level})`,k=k.forward[0];return P}static g(P,k,g){let C=P.e;for(let S=P.d-1;S>=0;S--)for(;C.forward[S]&&g(C.forward[S].key,k)<0;)C=C.forward[S];if(C=C.forward[0],C&&g(C.key,k)===0)return C}static h(P,k,g,C){const S=[];let m=P.e;for(let l=P.d-1;l>=0;l--){for(;m.forward[l]&&C(m.forward[l].key,k)<0;)m=m.forward[l];S[l]=m}if(m=m.forward[0],m&&C(m.key,k)===0)return m.value=g,!1;{const l=A.j(P);if(l>P.d){for(let $=P.d;$<l;$++)S[$]=P.e;P.d=l}m=new L(l,k,g);for(let $=0;$<l;$++)m.forward[$]=S[$].forward[$],S[$].forward[$]=m;return!0}}static j(P,k=.5){let g=1;for(;Math.random()<k&&g<P.c;)g+=1;return g}static k(P,k,g){const C=[];let S=P.e;for(let m=P.d-1;m>=0;m--){for(;S.forward[m]&&g(S.forward[m].key,k)<0;)S=S.forward[m];C[m]=S}if(S=S.forward[0],!S||g(S.key,k)!==0)return!1;for(let m=0;m<P.d&&C[m].forward[m]===S;m++)C[m].forward[m]=S.forward[m];for(;P.d>0&&P.e.forward[P.d-1]===D;)P.d-=1;return!0}}e.$1r=A}),define(le[63],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0;const O=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this.c=O&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Rd=L}),define(le[3],he([0,1,7,86,2,87,63]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.Event=void 0;const P=!1,k=!1;var g;(function(y){y.None=()=>D.$Tc.None;function u(te){if(k){const{onDidAddListener:ne}=te,ce=$.create();let de=0;te.onDidAddListener=()=>{++de===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),ce.print()),ne?.()}}}function p(te,ne){return Z(te,()=>{},0,void 0,!0,void 0,ne)}y.defer=p;function R(te){return(ne,ce=null,de)=>{let $e=!1,me;return me=te(Ee=>{if(!$e)return me?me.dispose():$e=!0,ne.call(ce,Ee)},null,de),$e&&me.dispose(),me}}y.once=R;function N(te,ne,ce){return x((de,$e=null,me)=>te(Ee=>de.call($e,ne(Ee)),null,me),ce)}y.map=N;function T(te,ne,ce){return x((de,$e=null,me)=>te(Ee=>{ne(Ee),de.call($e,Ee)},null,me),ce)}y.forEach=T;function M(te,ne,ce){return x((de,$e=null,me)=>te(Ee=>ne(Ee)&&de.call($e,Ee),null,me),ce)}y.filter=M;function U(te){return te}y.signal=U;function Y(...te){return(ne,ce=null,de)=>{const $e=(0,D.$Qc)(...te.map(me=>me(Ee=>ne.call(ce,Ee))));return H($e,de)}}y.any=Y;function Q(te,ne,ce,de){let $e=ce;return N(te,me=>($e=ne($e,me),$e),de)}y.reduce=Q;function x(te,ne){let ce;const de={onWillAddFirstListener(){ce=te($e.fire,$e)},onDidRemoveLastListener(){ce?.dispose()}};ne||u(de);const $e=new d(de);return ne?.add($e),$e.event}function H(te,ne){return ne instanceof Array?ne.push(te):ne&&ne.add(te),te}function Z(te,ne,ce=100,de=!1,$e=!1,me,Ee){let Re,Oe,Ne,ue=0,ge;const we={leakWarningThreshold:me,onWillAddFirstListener(){Re=te(Pe=>{ue++,Oe=ne(Oe,Pe),de&&!Ne&&(Ce.fire(Oe),Oe=void 0),ge=()=>{const Me=Oe;Oe=void 0,Ne=void 0,(!de||ue>1)&&Ce.fire(Me),ue=0},typeof ce=="number"?(clearTimeout(Ne),Ne=setTimeout(ge,ce)):Ne===void 0&&(Ne=0,queueMicrotask(ge))})},onWillRemoveListener(){$e&&ue>0&&ge?.()},onDidRemoveLastListener(){ge=void 0,Re.dispose()}};Ee||u(we);const Ce=new d(we);return Ee?.add(Ce),Ce.event}y.debounce=Z;function W(te,ne=0,ce){return y.debounce(te,(de,$e)=>de?(de.push($e),de):[$e],ne,void 0,!0,void 0,ce)}y.accumulate=W;function V(te,ne=(de,$e)=>de===$e,ce){let de=!0,$e;return M(te,me=>{const Ee=de||!ne(me,$e);return de=!1,$e=me,Ee},ce)}y.latch=V;function ie(te,ne,ce){return[y.filter(te,ne,ce),y.filter(te,de=>!ne(de),ce)]}y.split=ie;function re(te,ne=!1,ce=[],de){let $e=ce.slice(),me=te(Oe=>{$e?$e.push(Oe):Re.fire(Oe)});de&&de.add(me);const Ee=()=>{$e?.forEach(Oe=>Re.fire(Oe)),$e=null},Re=new d({onWillAddFirstListener(){me||(me=te(Oe=>Re.fire(Oe)),de&&de.add(me))},onDidAddFirstListener(){$e&&(ne?setTimeout(Ee):Ee())},onDidRemoveLastListener(){me&&me.dispose(),me=null}});return de&&de.add(Re),Re.event}y.buffer=re;function ee(te,ne){return(de,$e,me)=>{const Ee=ne(new K);return te(function(Re){const Oe=Ee.evaluate(Re);Oe!==ae&&de.call($e,Oe)},void 0,me)}}y.chain=ee;const ae=Symbol("HaltChainable");class K{constructor(){this.f=[]}map(ne){return this.f.push(ne),this}forEach(ne){return this.f.push(ce=>(ne(ce),ce)),this}filter(ne){return this.f.push(ce=>ne(ce)?ce:ae),this}reduce(ne,ce){let de=ce;return this.f.push($e=>(de=ne(de,$e),de)),this}latch(ne=(ce,de)=>ce===de){let ce=!0,de;return this.f.push($e=>{const me=ce||!ne($e,de);return ce=!1,de=$e,me?$e:ae}),this}evaluate(ne){for(const ce of this.f)if(ne=ce(ne),ne===ae)break;return ne}}function q(te,ne,ce=de=>de){const de=(...Re)=>Ee.fire(ce(...Re)),$e=()=>te.on(ne,de),me=()=>te.removeListener(ne,de),Ee=new d({onWillAddFirstListener:$e,onDidRemoveLastListener:me});return Ee.event}y.fromNodeEventEmitter=q;function j(te,ne,ce=de=>de){const de=(...Re)=>Ee.fire(ce(...Re)),$e=()=>te.addEventListener(ne,de),me=()=>te.removeEventListener(ne,de),Ee=new d({onWillAddFirstListener:$e,onDidRemoveLastListener:me});return Ee.event}y.fromDOMEventEmitter=j;function F(te){return new Promise(ne=>R(te)(ne))}y.toPromise=F;function B(te){const ne=new d;return te.then(ce=>{ne.fire(ce)},()=>{ne.fire(void 0)}).finally(()=>{ne.dispose()}),ne.event}y.fromPromise=B;function z(te,ne,ce){return ne(ce),te(de=>ne(de))}y.runAndSubscribe=z;class _{constructor(ne,ce){this._observable=ne,this.f=0,this.g=!1;const de={onWillAddFirstListener:()=>{ne.addObserver(this)},onDidRemoveLastListener:()=>{ne.removeObserver(this)}};ce||u(de),this.emitter=new d(de),ce&&ce.add(this.emitter)}beginUpdate(ne){this.f++}handlePossibleChange(ne){}handleChange(ne,ce){this.g=!0}endUpdate(ne){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function G(te,ne){return new _(te,ne).emitter.event}y.fromObservable=G;function J(te){return(ne,ce,de)=>{let $e=0,me=!1;const Ee={beginUpdate(){$e++},endUpdate(){$e--,$e===0&&(te.reportChanges(),me&&(me=!1,ne.call(ce)))},handlePossibleChange(){},handleChange(){me=!0}};te.addObserver(Ee),te.reportChanges();const Re={dispose(){te.removeObserver(Ee)}};return de instanceof D.$Sc?de.add(Re):Array.isArray(de)&&de.push(Re),Re}}y.fromObservableLight=J})(g||(e.Event=g={}));class C{static{this.all=new Set}static{this.f=0}constructor(u){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${u}_${C.f++}`,C.all.add(this)}start(u){this.g=new I.$Rd,this.listenerCount=u}stop(){if(this.g){const u=this.g.elapsed();this.durations.push(u),this.elapsedOverall+=u,this.invocationCount+=1,this.g=void 0}}}e.$Td=C;let S=-1;function m(y){const u=S;return S=y,{dispose(){S=u}}}e.$Ud=m;class l{constructor(u,p=Math.random().toString(18).slice(2,5)){this.threshold=u,this.name=p,this.g=0}dispose(){this.f?.clear()}check(u,p){const R=this.threshold;if(R<=0||p<R)return;this.f||(this.f=new Map);const N=this.f.get(u.value)||0;if(this.f.set(u.value,N+1),this.g-=1,this.g<=0){this.g=R*.5;let T,M=0;for(const[U,Y]of this.f)(!T||M<Y)&&(T=U,M=Y);console.warn(`[${this.name}] potential listener LEAK detected, having ${p} listeners already. MOST frequent listener (${M}):`),console.warn(T)}return()=>{const T=this.f.get(u.value)||0;this.f.set(u.value,T-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(u){this.value=u}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let b=0;class w{constructor(u){this.value=u,this.id=b++}}const h=2,f=(y,u)=>{if(y instanceof w)u(y);else for(let p=0;p<y.length;p++){const R=y[p];R&&u(R)}};class d{constructor(u){this.w=0,this.f=u,this.g=S>0||this.f?.leakWarningThreshold?new l(this.f?.leakWarningThreshold??S):void 0,this.j=this.f?._profName?new C(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(P){const u=this.t;queueMicrotask(()=>{f(u,p=>p.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(u,p,R)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),D.$Tc.None;if(this.m)return D.$Tc.None;p&&(u=u.bind(p));const N=new w(u);let T,M;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(N.stack=$.create(),T=this.g.check(N.stack,this.w+1)),P&&(N.stack=M??$.create()),this.t?this.t instanceof w?(this.u??=new v,this.t=[this.t,N]):this.t.push(N):(this.f?.onWillAddFirstListener?.(this),this.t=N,this.f?.onDidAddFirstListener?.(this)),this.w++;const U=(0,D.$Rc)(()=>{T?.(),this.x(N)});return R instanceof D.$Sc?R.add(U):Array.isArray(R)&&R.push(U),U},this.q}x(u){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const p=this.t,R=p.indexOf(u);if(R===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,p[R]=void 0;const N=this.u.current===this;if(this.w*h<=p.length){let T=0;for(let M=0;M<p.length;M++)p[M]?p[T++]=p[M]:N&&(this.u.end--,T<this.u.i&&this.u.i--);p.length=T}}y(u,p){if(!u)return;const R=this.f?.onListenerError||O.$1;if(!R){u.value(p);return}try{u.value(p)}catch(N){R(N)}}z(u){const p=u.current.t;for(;u.i<u.end;)this.y(p[u.i++],u.value);u.reset()}fire(u){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof w)this.y(this.t,u);else{const p=this.u;p.enqueue(this,u,this.t.length),this.z(p)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Vd=d;const c=()=>new v;e.$Wd=c;class v{constructor(){this.i=-1,this.end=0}enqueue(u,p,R){this.i=0,this.end=R,this.current=u,this.value=p}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends d{async fireAsync(u,p,R){if(this.t)for(this.h||(this.h=new A.$4c),f(this.t,N=>this.h.push([N.value,u]));this.h.size>0&&!p.isCancellationRequested;){const[N,T]=this.h.shift(),M=[],U={...T,token:p,waitUntil:Y=>{if(Object.isFrozen(M))throw new Error("waitUntil can NOT be called asynchronous");R&&(Y=R(Y,N)),M.push(Y)}};try{N(U)}catch(Y){(0,O.$1)(Y);continue}Object.freeze(M),await Promise.allSettled(M).then(Y=>{for(const Q of Y)Q.status==="rejected"&&(0,O.$1)(Q.reason)})}}}e.$Xd=i;class o extends d{get isPaused(){return this.h!==0}constructor(u){super(u),this.h=0,this.s=new A.$4c,this.A=u?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const u=Array.from(this.s);this.s.clear(),super.fire(this.A(u))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(u){this.w&&(this.h!==0?this.s.push(u):super.fire(u))}}e.$Yd=o;class n extends o{constructor(u){super(u),this.k=u.delay??100}fire(u){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(u)}}e.$Zd=n;class s extends d{constructor(u){super(u),this.h=[],this.k=u?.merge}fire(u){this.hasListeners()&&(this.h.push(u),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(p=>super.fire(p)),this.h=[]}))}}e.$1d=s;class t{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(u){const p={event:u,listener:null};this.h.push(p),this.g&&this.m(p);const R=()=>{this.g&&this.o(p);const N=this.h.indexOf(p);this.h.splice(N,1)};return(0,D.$Rc)((0,L.$db)(R))}j(){this.g=!0,this.h.forEach(u=>this.m(u))}k(){this.g=!1,this.h.forEach(u=>this.o(u))}m(u){u.listener=u.event(p=>this.f.fire(p))}o(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.f.dispose()}}e.$2d=t;class r{constructor(u,p,R,N){this.f=new D.$Sc;const T=this.f.add(new t),M=this.f.add(new D.$3c);function U(Y){M.set(Y,T.add(N(Y)))}for(const Y of u)U(Y);this.f.add(p(Y=>{U(Y)})),this.f.add(R(Y=>{M.deleteAndDispose(Y)})),this.event=T.event}dispose(){this.f.dispose()}}e.$3d=r;class a{constructor(){this.f=[]}wrapEvent(u){return(p,R,N)=>u(T=>{const M=this.f[this.f.length-1];M?M.push(()=>p.call(R,T)):p.call(R,T)},void 0,N)}bufferEvents(u){const p=[];this.f.push(p);const R=u();return this.f.pop(),p.forEach(N=>N()),R}}e.$4d=a;class E{constructor(){this.f=!1,this.g=g.None,this.h=D.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(u){this.g=u,this.f&&(this.h.dispose(),this.h=u(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$5d=E}),define(le[26],he([0,1,3]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.CancellationToken=void 0;const L=Object.freeze(function(P,k){const g=setTimeout(P.bind(k),0);return{dispose(){clearTimeout(g)}}});var D;(function(P){function k(g){return g===P.None||g===P.Cancelled||g instanceof A?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}P.isCancellationToken=k,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:O.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D||(e.CancellationToken=D={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new O.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(k){this.f=void 0,this.g=void 0,this.g=k&&k.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=D.Cancelled}dispose(k=!1){k&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=D.None}}e.$6d=I}),define(le[129],he([0,1,26]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=void 0;class L{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new O.$6d,k=this.b(P.token);return this.a={promise:k,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.$Ee=L;class D{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const k=JSON.stringify(P);return this.b!==k&&(this.b=k,this.a=this.c(P)),this.a}}e.$Fe=D;class A{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const k=this.b(P);return this.a.set(P,k),k}}e.$Ge=A}),define(le[47],he([0,1,7,2]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function D(c){const v=c;return v?typeof v.read=="function":!1}e.$7d=D;function A(c){const v=c;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.$8d=A;function I(c){const v=c;return v?A(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.$9d=I;function P(c,v){return new k(c,v)}e.$0d=P;class k{constructor(v,i){this.e=v,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(i=>i(v))}h(v){this.c.error.length===0?(0,O.$1)(v):this.c.error.slice(0).forEach(i=>i(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,i){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(v,i){if(this.a.destroyed)return;let o;switch(v){case"data":o=this.c.data;break;case"end":o=this.c.end;break;case"error":o=this.c.error;break}if(o){const n=o.indexOf(i);n>=0&&o.splice(n,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(o=>o())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function g(c,v){const i=[];let o;for(;(o=c.read())!==null;)i.push(o);return v(i)}e.$$d=g;function C(c,v,i){const o=[];let n;for(;(n=c.read())!==null&&o.length<i;)o.push(n);return n===null&&o.length>0?v(o):{read:()=>{if(o.length>0)return o.shift();if(typeof n<"u"){const s=n;return n=void 0,s}return c.read()}}}e.$_d=C;function S(c,v){return new Promise((i,o)=>{const n=[];m(c,{onData:s=>{v&&n.push(s)},onError:s=>{v?o(s):i(void 0)},onEnd:()=>{i(v?v(n):void 0)}})})}e.$ae=S;function m(c,v,i){c.on("error",o=>{i?.isCancellationRequested||v.onError(o)}),c.on("end",()=>{i?.isCancellationRequested||v.onEnd()}),c.on("data",o=>{i?.isCancellationRequested||v.onData(o)})}e.$be=m;function l(c,v){return new Promise((i,o)=>{const n=new L.$Sc,s=[],t=E=>{if(s.push(E),s.length>v)return n.dispose(),c.pause(),i({stream:c,buffer:s,ended:!1})},r=E=>(n.dispose(),o(E)),a=()=>(n.dispose(),i({stream:c,buffer:s,ended:!0}));n.add((0,L.$Rc)(()=>c.removeListener("error",r))),c.on("error",r),n.add((0,L.$Rc)(()=>c.removeListener("end",a))),c.on("end",a),n.add((0,L.$Rc)(()=>c.removeListener("data",t))),c.on("data",t)})}e.$ce=l;function $(c,v){const i=P(v);return i.end(c),i}e.$de=$;function b(){const c=P(()=>{throw new Error("not supported")});return c.end(),c}e.$ee=b;function w(c){let v=!1;return{read:()=>v?null:(v=!0,c)}}e.$fe=w;function h(c,v,i){const o=P(i);return m(c,{onData:n=>o.write(v.data(n)),onError:n=>o.error(v.error?v.error(n):n),onEnd:()=>o.end()}),o}e.$ge=h;function f(c,v,i){let o=!1;return{read:()=>{const n=v.read();return o?n:(o=!0,n!==null?i([c,n]):c)}}}e.$he=f;function d(c,v,i){let o=!1;const n=P(i);return m(v,{onData:s=>o?n.write(s):(o=!0,n.write(i([c,s]))),onError:s=>n.error(s),onEnd:()=>{o||(o=!0,n.write(c)),n.end()}}),n}e.$ie=d}),define(le[14],he([0,1,52,47]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const D=typeof Buffer<"u",A=new O.$V(()=>new Uint8Array(256));let I,P;class k{static alloc(p){return D?new k(Buffer.allocUnsafe(p)):new k(new Uint8Array(p))}static wrap(p){return D&&!Buffer.isBuffer(p)&&(p=Buffer.from(p.buffer,p.byteOffset,p.byteLength)),new k(p)}static fromString(p,R){return!(R?.dontUseNodeBuffer||!1)&&D?new k(Buffer.from(p)):(I||(I=new TextEncoder),new k(I.encode(p)))}static fromByteArray(p){const R=k.alloc(p.length);for(let N=0,T=p.length;N<T;N++)R.buffer[N]=p[N];return R}static concat(p,R){if(typeof R>"u"){R=0;for(let M=0,U=p.length;M<U;M++)R+=p[M].byteLength}const N=k.alloc(R);let T=0;for(let M=0,U=p.length;M<U;M++){const Y=p[M];N.set(Y,T),T+=Y.byteLength}return N}constructor(p){this.buffer=p,this.byteLength=this.buffer.byteLength}clone(){const p=k.alloc(this.byteLength);return p.set(this),p}toString(){return D?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(p,R){return new k(this.buffer.subarray(p,R))}set(p,R){if(p instanceof k)this.buffer.set(p.buffer,R);else if(p instanceof Uint8Array)this.buffer.set(p,R);else if(p instanceof ArrayBuffer)this.buffer.set(new Uint8Array(p),R);else if(ArrayBuffer.isView(p))this.buffer.set(new Uint8Array(p.buffer,p.byteOffset,p.byteLength),R);else throw new Error("Unknown argument 'array'")}readUInt32BE(p){return m(this.buffer,p)}writeUInt32BE(p,R){l(this.buffer,p,R)}readUInt32LE(p){return $(this.buffer,p)}writeUInt32LE(p,R){b(this.buffer,p,R)}readUInt8(p){return w(this.buffer,p)}writeUInt8(p,R){h(this.buffer,p,R)}indexOf(p,R=0){return g(this.buffer,p instanceof k?p.buffer:p,R)}}e.$je=k;function g(u,p,R=0){const N=p.byteLength,T=u.byteLength;if(N===0)return 0;if(N===1)return u.indexOf(p[0]);if(N>T-R)return-1;const M=A.value;M.fill(p.length);for(let x=0;x<p.length;x++)M[p[x]]=p.length-x-1;let U=R+p.length-1,Y=U,Q=-1;for(;U<T;)if(u[U]===p[Y]){if(Y===0){Q=U;break}U--,Y--}else U+=Math.max(p.length-Y,M[u[U]]),Y=p.length-1;return Q}e.$ke=g;function C(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0}e.$le=C;function S(u,p,R){u[R+0]=p&255,p=p>>>8,u[R+1]=p&255}e.$me=S;function m(u,p){return u[p]*2**24+u[p+1]*2**16+u[p+2]*2**8+u[p+3]}e.$ne=m;function l(u,p,R){u[R+3]=p,p=p>>>8,u[R+2]=p,p=p>>>8,u[R+1]=p,p=p>>>8,u[R]=p}e.$oe=l;function $(u,p){return u[p+0]<<0>>>0|u[p+1]<<8>>>0|u[p+2]<<16>>>0|u[p+3]<<24>>>0}e.$pe=$;function b(u,p,R){u[R+0]=p&255,p=p>>>8,u[R+1]=p&255,p=p>>>8,u[R+2]=p&255,p=p>>>8,u[R+3]=p&255}e.$qe=b;function w(u,p){return u[p]}e.$re=w;function h(u,p,R){u[R]=p}e.$se=h;function f(u){return L.$$d(u,p=>k.concat(p))}e.$te=f;function d(u){return L.$fe(u)}e.$ue=d;function c(u){return L.$ae(u,p=>k.concat(p))}e.$ve=c;async function v(u){return u.ended?k.concat(u.buffer):k.concat([...u.buffer,await c(u.stream)])}e.$we=v;function i(u){return L.$de(u,p=>k.concat(p))}e.$xe=i;function o(u){return L.$ge(u,{data:p=>typeof p=="string"?k.fromString(p):k.wrap(p)},p=>k.concat(p))}e.$ye=o;function n(u){return L.$0d(p=>k.concat(p),u)}e.$ze=n;function s(u,p){return L.$he(u,p,R=>k.concat(R))}e.$Ae=s;function t(u,p){return L.$ie(u,p,R=>k.concat(R))}e.$Be=t;function r(u){let p=0,R=0,N=0;const T=new Uint8Array(Math.floor(u.length/4*3)),M=Y=>{switch(R){case 3:T[N++]=p|Y,R=0;break;case 2:T[N++]=p|Y>>>2,p=Y<<6,R=3;break;case 1:T[N++]=p|Y>>>4,p=Y<<4,R=2;break;default:p=Y<<2,R=1}};for(let Y=0;Y<u.length;Y++){const Q=u.charCodeAt(Y);if(Q>=65&&Q<=90)M(Q-65);else if(Q>=97&&Q<=122)M(Q-97+26);else if(Q>=48&&Q<=57)M(Q-48+52);else if(Q===43||Q===45)M(62);else if(Q===47||Q===95)M(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${u[Y]}`)}}const U=N;for(;R>0;)M(0);return k.wrap(T).slice(0,U)}e.$Ce=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function y({buffer:u},p=!0,R=!1){const N=R?E:a;let T="";const M=u.byteLength%3;let U=0;for(;U<u.byteLength-M;U+=3){const Y=u[U+0],Q=u[U+1],x=u[U+2];T+=N[Y>>>2],T+=N[(Y<<4|Q>>>4)&63],T+=N[(Q<<2|x>>>6)&63],T+=N[x&63]}if(M===1){const Y=u[U+0];T+=N[Y>>>2],T+=N[Y<<4&63],p&&(T+="==")}else if(M===2){const Y=u[U+0],Q=u[U+1];T+=N[Y>>>2],T+=N[(Y<<4|Q>>>4)&63],T+=N[Q<<2&63],p&&(T+="=")}return T}e.$De=y}),define(le[27],he([0,1,129,52]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.GraphemeBreakType=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=void 0;function D(oe){return!oe||typeof oe!="string"?!0:oe.trim().length===0}e.$Je=D;const A=/{(\d+)}/g;function I(oe,...fe){return fe.length===0?oe:oe.replace(A,function(be,ve){const ye=parseInt(ve,10);return isNaN(ye)||ye<0||ye>=fe.length?be:fe[ye]})}e.$Ke=I;const P=/{([^}]+)}/g;function k(oe,fe){return Object.keys(fe).length===0?oe:oe.replace(P,(be,ve)=>fe[ve]??be)}e.$Le=k;function g(oe){return oe.replace(/[<>"'&]/g,fe=>{switch(fe){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return fe})}e.$Me=g;function C(oe){return oe.replace(/[<>&]/g,function(fe){switch(fe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return fe}})}e.$Ne=C;function S(oe){return oe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Oe=S;function m(oe,fe){let be=0;const ve=fe.charCodeAt(0);for(let ye=oe.length-1;ye>=0;ye--)oe.charCodeAt(ye)===ve&&be++;return be}e.$Pe=m;function l(oe,fe,be="\u2026"){return oe.length<=fe?oe:`${oe.substr(0,fe)}${be}`}e.$Qe=l;function $(oe,fe,be="\u2026"){if(oe.length<=fe)return oe;const ve=Math.ceil(fe/2)-be.length/2,ye=Math.floor(fe/2)-be.length/2;return`${oe.substr(0,ve)}${be}${oe.substr(oe.length-ye)}`}e.$Re=$;function b(oe,fe=" "){const be=w(oe,fe);return h(be,fe)}e.$Se=b;function w(oe,fe){if(!oe||!fe)return oe;const be=fe.length;if(be===0||oe.length===0)return oe;let ve=0;for(;oe.indexOf(fe,ve)===ve;)ve=ve+be;return oe.substring(ve)}e.$Te=w;function h(oe,fe){if(!oe||!fe)return oe;const be=fe.length,ve=oe.length;if(be===0||ve===0)return oe;let ye=ve,ke=-1;for(;ke=oe.lastIndexOf(fe,ye-1),!(ke===-1||ke+be!==ye);){if(ke===0)return"";ye=ke}return oe.substring(0,ye)}e.$Ue=h;function f(oe){return oe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ve=f;function d(oe){return oe.replace(/\*/g,"")}e.$We=d;function c(oe,fe,be={}){if(!oe)throw new Error("Cannot create regex from empty string");fe||(oe=S(oe)),be.wholeWord&&(/\B/.test(oe.charAt(0))||(oe="\\b"+oe),/\B/.test(oe.charAt(oe.length-1))||(oe=oe+"\\b"));let ve="";return be.global&&(ve+="g"),be.matchCase||(ve+="i"),be.multiline&&(ve+="m"),be.unicode&&(ve+="u"),new RegExp(oe,ve)}e.$Xe=c;function v(oe){return oe.source==="^"||oe.source==="^$"||oe.source==="$"||oe.source==="^\\s*$"?!1:!!(oe.exec("")&&oe.lastIndex===0)}e.$Ye=v;function i(oe){return oe.split(/\r\n|\r|\n/)}e.$Ze=i;function o(oe){for(let fe=0,be=oe.length;fe<be;fe++){const ve=oe.charCodeAt(fe);if(ve!==32&&ve!==9)return fe}return-1}e.$1e=o;function n(oe,fe=0,be=oe.length){for(let ve=fe;ve<be;ve++){const ye=oe.charCodeAt(ve);if(ye!==32&&ye!==9)return oe.substring(fe,ve)}return oe.substring(fe,be)}e.$2e=n;function s(oe,fe=oe.length-1){for(let be=fe;be>=0;be--){const ve=oe.charCodeAt(be);if(ve!==32&&ve!==9)return be}return-1}e.$3e=s;function t(oe,fe,be){const ve=[];let ye=0;for(const ke of oe.matchAll(fe)){if(ve.push(oe.slice(ye,ke.index)),ke.index===void 0)throw new Error("match.index should be defined");ye=ke.index+ke[0].length,ve.push(be(ke[0],...ke.slice(1),ke.index,oe,ke.groups))}return ve.push(oe.slice(ye)),Promise.all(ve).then(ke=>ke.join(""))}e.$4e=t;function r(oe,fe){return oe<fe?-1:oe>fe?1:0}e.$5e=r;function a(oe,fe,be=0,ve=oe.length,ye=0,ke=fe.length){for(;be<ve&&ye<ke;be++,ye++){const Le=oe.charCodeAt(be),Ve=fe.charCodeAt(ye);if(Le<Ve)return-1;if(Le>Ve)return 1}const Ie=ve-be,De=ke-ye;return Ie<De?-1:Ie>De?1:0}e.$6e=a;function E(oe,fe){return y(oe,fe,0,oe.length,0,fe.length)}e.$7e=E;function y(oe,fe,be=0,ve=oe.length,ye=0,ke=fe.length){for(;be<ve&&ye<ke;be++,ye++){let Le=oe.charCodeAt(be),Ve=fe.charCodeAt(ye);if(Le===Ve)continue;if(Le>=128||Ve>=128)return a(oe.toLowerCase(),fe.toLowerCase(),be,ve,ye,ke);p(Le)&&(Le-=32),p(Ve)&&(Ve-=32);const ze=Le-Ve;if(ze!==0)return ze}const Ie=ve-be,De=ke-ye;return Ie<De?-1:Ie>De?1:0}e.$8e=y;function u(oe){return oe>=48&&oe<=57}e.$9e=u;function p(oe){return oe>=97&&oe<=122}e.$0e=p;function R(oe){return oe>=65&&oe<=90}e.$$e=R;function N(oe,fe){return oe.length===fe.length&&y(oe,fe)===0}e.$_e=N;function T(oe,fe){const be=fe.length;return fe.length>oe.length?!1:y(oe,fe,0,be)===0}e.$af=T;function M(oe,fe){const be=Math.min(oe.length,fe.length);let ve;for(ve=0;ve<be;ve++)if(oe.charCodeAt(ve)!==fe.charCodeAt(ve))return ve;return be}e.$bf=M;function U(oe,fe){const be=Math.min(oe.length,fe.length);let ve;const ye=oe.length-1,ke=fe.length-1;for(ve=0;ve<be;ve++)if(oe.charCodeAt(ye-ve)!==fe.charCodeAt(ke-ve))return ve;return be}e.$cf=U;function Y(oe){return 55296<=oe&&oe<=56319}e.$df=Y;function Q(oe){return 56320<=oe&&oe<=57343}e.$ef=Q;function x(oe,fe){return(oe-55296<<10)+(fe-56320)+65536}e.$ff=x;function H(oe,fe,be){const ve=oe.charCodeAt(be);if(Y(ve)&&be+1<fe){const ye=oe.charCodeAt(be+1);if(Q(ye))return x(ve,ye)}return ve}e.$gf=H;function Z(oe,fe){const be=oe.charCodeAt(fe-1);if(Q(be)&&fe>1){const ve=oe.charCodeAt(fe-2);if(Y(ve))return x(ve,be)}return be}class W{get offset(){return this.e}constructor(fe,be=0){this.c=fe,this.d=fe.length,this.e=be}setOffset(fe){this.e=fe}prevCodePoint(){const fe=Z(this.c,this.e);return this.e-=fe>=65536?2:1,fe}nextCodePoint(){const fe=H(this.c,this.d,this.e);return this.e+=fe>=65536?2:1,fe}eol(){return this.e>=this.d}}e.$hf=W;class V{get offset(){return this.c.offset}constructor(fe,be=0){this.c=new W(fe,be)}nextGraphemeLength(){const fe=Ce.getInstance(),be=this.c,ve=be.offset;let ye=fe.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const ke=be.offset,Ie=fe.getGraphemeBreakType(be.nextCodePoint());if(ge(ye,Ie)){be.setOffset(ke);break}ye=Ie}return be.offset-ve}prevGraphemeLength(){const fe=Ce.getInstance(),be=this.c,ve=be.offset;let ye=fe.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const ke=be.offset,Ie=fe.getGraphemeBreakType(be.prevCodePoint());if(ge(Ie,ye)){be.setOffset(ke);break}ye=Ie}return ve-be.offset}eol(){return this.c.eol()}}e.$if=V;function ie(oe,fe){return new V(oe,fe).nextGraphemeLength()}e.$jf=ie;function re(oe,fe){return new V(oe,fe).prevGraphemeLength()}e.$kf=re;function ee(oe,fe){fe>0&&Q(oe.charCodeAt(fe))&&fe--;const be=fe+ie(oe,fe);return[be-re(oe,be),be]}e.$lf=ee;function ae(oe){const fe=new V(oe);let be=0;for(;!fe.eol();)be++,fe.nextGraphemeLength();return be}e.$mf=ae;let K;function q(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function j(oe){return K||(K=q()),K.test(oe)}e.$nf=j;const F=/^[\t\n\r\x20-\x7E]*$/;function B(oe){return F.test(oe)}e.$of=B,e.$pf=/[\u2028\u2029]/;function z(oe){return e.$pf.test(oe)}e.$qf=z;function _(oe){return oe>=11904&&oe<=55215||oe>=63744&&oe<=64255||oe>=65281&&oe<=65374}e.$rf=_;function G(oe){return oe>=127462&&oe<=127487||oe===8986||oe===8987||oe===9200||oe===9203||oe>=9728&&oe<=10175||oe===11088||oe===11093||oe>=127744&&oe<=128591||oe>=128640&&oe<=128764||oe>=128992&&oe<=129008||oe>=129280&&oe<=129535||oe>=129648&&oe<=129782}e.$sf=G;function J(oe,fe,be=""){const ve=oe.trimStart();if(ve.length<fe)return ve;const ye=/\b/g;let ke=0;for(;ye.test(ve)&&!(ve.length-ye.lastIndex<fe);)ke=ye.lastIndex,ye.lastIndex+=1;return ke===0?ve:be+ve.substring(ke).trimStart()}e.$tf=J;const te=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ne=/\x1b\].*?\x07/g;function ce(oe){return oe&&(oe=oe.replace(te,"").replace(ne,"")),oe}e.$uf=ce,e.$vf=String.fromCharCode(65279);function de(oe){return!!(oe&&oe.length>0&&oe.charCodeAt(0)===65279)}e.$wf=de;function $e(oe){return de(oe)?oe.substr(1):oe}e.$xf=$e;function me(oe,fe){if(!oe||!fe||oe.length<fe.length)return!1;const be=fe.length,ve=oe.toLowerCase();let ye=0,ke=-1;for(;ye<be;){const Ie=ve.indexOf(fe[ye],ke+1);if(Ie<0)return!1;ke=Ie,ye++}return!0}e.$yf=me;function Ee(oe,fe=!1){return oe?(fe&&(oe=oe.replace(/\\./g,"")),oe.toLowerCase()!==oe):!1}e.$zf=Ee;function Re(oe){return oe.charAt(0).toUpperCase()+oe.slice(1)}e.$Af=Re;function Oe(oe,fe=1){if(fe===0)return"";let be=-1;do be=oe.indexOf(`
`,be+1),fe--;while(fe>0&&be>=0);return be===-1?oe:(oe[be-1]==="\r"&&be--,oe.substr(0,be))}e.$Bf=Oe;function Ne(oe){return oe=oe%(2*26),oe<26?String.fromCharCode(97+oe):String.fromCharCode(65+oe-26)}e.$Cf=Ne;function ue(oe){return Ce.getInstance().getGraphemeBreakType(oe)}e.$Df=ue;function ge(oe,fe){return oe===0?fe!==5&&fe!==7:oe===2&&fe===3?!1:oe===4||oe===2||oe===3||fe===4||fe===2||fe===3?!0:!(oe===8&&(fe===8||fe===9||fe===11||fe===12)||(oe===11||oe===9)&&(fe===9||fe===10)||(oe===12||oe===10)&&fe===10||fe===5||fe===13||fe===7||oe===1||oe===13&&fe===14||oe===6&&fe===6)}var we;(function(oe){oe[oe.Other=0]="Other",oe[oe.Prepend=1]="Prepend",oe[oe.CR=2]="CR",oe[oe.LF=3]="LF",oe[oe.Control=4]="Control",oe[oe.Extend=5]="Extend",oe[oe.Regional_Indicator=6]="Regional_Indicator",oe[oe.SpacingMark=7]="SpacingMark",oe[oe.L=8]="L",oe[oe.V=9]="V",oe[oe.T=10]="T",oe[oe.LV=11]="LV",oe[oe.LVT=12]="LVT",oe[oe.ZWJ=13]="ZWJ",oe[oe.Extended_Pictographic=14]="Extended_Pictographic"})(we||(e.GraphemeBreakType=we={}));class Ce{static{this.c=null}static getInstance(){return Ce.c||(Ce.c=new Ce),Ce.c}constructor(){this.d=Pe()}getGraphemeBreakType(fe){if(fe<32)return fe===10?3:fe===13?2:4;if(fe<127)return 0;const be=this.d,ve=be.length/3;let ye=1;for(;ye<=ve;)if(fe<be[3*ye])ye=2*ye;else if(fe>be[3*ye+1])ye=2*ye+1;else return be[3*ye+2];return 0}}function Pe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(oe,fe){if(oe===0)return 0;const be=je(oe,fe);if(be!==void 0)return be;const ve=new W(fe,oe);return ve.prevCodePoint(),ve.offset}e.$Ef=Me;function je(oe,fe){const be=new W(fe,oe);let ve=be.prevCodePoint();for(;qe(ve)||ve===65039||ve===8419;){if(be.offset===0)return;ve=be.prevCodePoint()}if(!G(ve))return;let ye=be.offset;return ye>0&&be.prevCodePoint()===8205&&(ye=be.offset),ye}function qe(oe){return 127995<=oe&&oe<=127999}var Fe;(function(oe){oe[oe.zwj=8205]="zwj",oe[oe.emojiVariantSelector=65039]="emojiVariantSelector",oe[oe.enclosingKeyCap=8419]="enclosingKeyCap"})(Fe||(Fe={})),e.$Ff="\xA0";class Te{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new O.$Fe(fe=>{function be(ze){const Be=new Map;for(let We=0;We<ze.length;We+=2)Be.set(ze[We],ze[We+1]);return Be}function ve(ze,Be){const We=new Map(ze);for(const[Ze,et]of Be)We.set(Ze,et);return We}function ye(ze,Be){if(!ze)return Be;const We=new Map;for(const[Ze,et]of ze)Be.has(Ze)&&We.set(Ze,et);return We}const ke=this.c.value;let Ie=fe.filter(ze=>!ze.startsWith("_")&&ze in ke);Ie.length===0&&(Ie=["_default"]);let De;for(const ze of Ie){const Be=be(ke[ze]);De=ye(De,Be)}const Le=be(ke._common),Ve=ve(Le,De);return new Te(Ve)})}static getInstance(fe){return Te.d.get(Array.from(fe))}static{this.e=new L.$V(()=>Object.keys(Te.c.value).filter(fe=>!fe.startsWith("_")))}static getLocales(){return Te.e.value}constructor(fe){this.f=fe}isAmbiguous(fe){return this.f.has(fe)}getPrimaryConfusable(fe){return this.f.get(fe)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Gf=Te;class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(fe){return Ue.e().has(fe)}static get codePoints(){return Ue.e()}}e.$Hf=Ue}),define(le[53],he([0,1,27]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function L(h){return D(h,0)}e.$Ti=L;function D(h,f){switch(typeof h){case"object":return h===null?A(349,f):Array.isArray(h)?k(h,f):g(h,f);case"string":return P(h,f);case"boolean":return I(h,f);case"number":return A(h,f);case"undefined":return A(937,f);default:return A(617,f)}}e.$Ui=D;function A(h,f){return(f<<5)-f+h|0}e.$Vi=A;function I(h,f){return A(h?433:863,f)}function P(h,f){f=A(149417,f);for(let d=0,c=h.length;d<c;d++)f=A(h.charCodeAt(d),f);return f}e.$Wi=P;function k(h,f){return f=A(104579,f),h.reduce((d,c)=>D(c,d),f)}function g(h,f){return f=A(181387,f),Object.keys(h).sort().reduce((d,c)=>(d=P(c,d),D(h[c],d)),f)}class C{constructor(){this.g=0}get value(){return this.g}hash(f){return this.g=D(f,this.g),this.g}}e.$Xi=C;var S;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(S||(S={}));function m(h,f,d=32){const c=d-f,v=~((1<<c)-1);return(h<<f|(v&h)>>>c)>>>0}function l(h,f=0,d=h.byteLength,c=0){for(let v=0;v<d;v++)h[f+v]=c}function $(h,f,d="0"){for(;h.length<f;)h=d+h;return h}function b(h,f=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(d=>d.toString(16).padStart(2,"0")).join(""):$((h>>>0).toString(16),f/4)}e.$Yi=b;class w{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(f){const d=f.length;if(d===0)return;const c=this.p;let v=this.r,i=this.u,o,n;for(i!==0?(o=i,n=-1,i=0):(o=f.charCodeAt(0),n=0);;){let s=o;if(O.$df(o))if(n+1<d){const t=f.charCodeAt(n+1);O.$ef(t)?(n++,s=O.$ff(o,t)):s=65533}else{i=o;break}else O.$ef(o)&&(s=65533);if(v=this.w(c,v,s),n++,n<d)o=f.charCodeAt(n);else break}this.r=v,this.u=i}w(f,d,c){return c<128?f[d++]=c:c<2048?(f[d++]=192|(c&1984)>>>6,f[d++]=128|(c&63)>>>0):c<65536?(f[d++]=224|(c&61440)>>>12,f[d++]=128|(c&4032)>>>6,f[d++]=128|(c&63)>>>0):(f[d++]=240|(c&1835008)>>>18,f[d++]=128|(c&258048)>>>12,f[d++]=128|(c&4032)>>>6,f[d++]=128|(c&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,f[0]=f[64+0],f[1]=f[64+1],f[2]=f[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),b(this.h)+b(this.l)+b(this.m)+b(this.n)+b(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const f=8*this.t;this.q.setUint32(56,Math.floor(f/4294967296),!1),this.q.setUint32(60,f%4294967296,!1),this.y()}y(){const f=w.g,d=this.q;for(let a=0;a<64;a+=4)f.setUint32(a,d.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)f.setUint32(a,m(f.getUint32(a-12,!1)^f.getUint32(a-32,!1)^f.getUint32(a-56,!1)^f.getUint32(a-64,!1),1),!1);let c=this.h,v=this.l,i=this.m,o=this.n,n=this.o,s,t,r;for(let a=0;a<80;a++)a<20?(s=v&i|~v&o,t=1518500249):a<40?(s=v^i^o,t=1859775393):a<60?(s=v&i|v&o|i&o,t=2400959708):(s=v^i^o,t=3395469782),r=m(c,5)+s+n+t+f.getUint32(a*4,!1)&4294967295,n=o,o=i,i=m(v,30),v=c,c=r;this.h=this.h+c&4294967295,this.l=this.l+v&4294967295,this.m=this.m+i&4294967295,this.n=this.n+o&4294967295,this.o=this.o+n&4294967295}}e.$Zi=w}),define(le[89],he([0,1,27]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(D){D[D.Ignore=0]="Ignore",D[D.Info=1]="Info",D[D.Warning=2]="Warning",D[D.Error=3]="Error"})(L||(L={})),function(D){const A="error",I="warning",P="warn",k="info",g="ignore";function C(m){return m?O.$_e(A,m)?D.Error:O.$_e(I,m)||O.$_e(P,m)?D.Warning:O.$_e(k,m)?D.Info:D.Ignore:D.Ignore}D.fromValue=C;function S(m){switch(m){case D.Error:return A;case D.Warning:return I;case D.Info:return k;default:return g}}D.toString=S}(L||(L={})),e.default=L}),define(le[130],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(le[48],he([0,1,17,27]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class D{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const $=l.charCodeAt(0),b=this.b.charCodeAt(this.c);return $-b}value(){return this.b[this.c]}}e.$8h=D;class A{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,L.$6e)(l,this.b,0,l.length,this.c,this.d):(0,L.$8e)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=A;class I{constructor(l=!0,$=!0){this.f=l,this.g=$}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let $=l.length-1;$>=0;$--,this.c--){const b=this.b.charCodeAt($);if(!(b===47||this.f&&b===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,L.$6e)(l,this.b,0,l.length,this.d,this.e):(0,L.$8e)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=I;var P;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(P||(P={}));class k{constructor(l,$){this.f=l,this.g=$,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,L.$7e)(l,this.c.scheme);if(this.d[this.e]===2)return(0,L.$7e)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,L.$5e)(l,this.c.query);if(this.d[this.e]===5)return(0,L.$5e)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=k;class g{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(C||(C={}));class S{static forUris(l=()=>!1,$=()=>!1){return new S(new k(l,$))}static forPaths(l=!1){return new S(new I(void 0,!l))}static forStrings(){return new S(new D)}static forConfigKeys(){return new S(new A)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,$){if($){const b=$.slice(0);(0,O.$Xb)(b);for(const w of b)this.set(w,l)}else{const b=l.slice(0);(0,O.$Xb)(b);for(const w of b)this.set(w[0],w[1])}}set(l,$){const b=this.b.reset(l);let w;this.c||(this.c=new g,this.c.segment=b.value());const h=[];for(w=this.c;;){const d=b.cmp(w.segment);if(d>0)w.left||(w.left=new g,w.left.segment=b.value()),h.push([-1,w]),w=w.left;else if(d<0)w.right||(w.right=new g,w.right.segment=b.value()),h.push([1,w]),w=w.right;else if(b.hasNext())b.next(),w.mid||(w.mid=new g,w.mid.segment=b.value()),h.push([0,w]),w=w.mid;else break}const f=w.value;w.value=$,w.key=l;for(let d=h.length-1;d>=0;d--){const c=h[d][1];c.updateHeight();const v=c.balanceFactor();if(v<-1||v>1){const i=h[d][0],o=h[d+1][0];if(i===1&&o===1)h[d][1]=c.rotateLeft();else if(i===-1&&o===-1)h[d][1]=c.rotateRight();else if(i===1&&o===-1)c.right=h[d+1][1]=h[d+1][1].rotateRight(),h[d][1]=c.rotateLeft();else if(i===-1&&o===1)c.left=h[d+1][1]=h[d+1][1].rotateLeft(),h[d][1]=c.rotateRight();else throw new Error;if(d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}return f}get(l){return this.d(l)?.value}d(l){const $=this.b.reset(l);let b=this.c;for(;b;){const w=$.cmp(b.segment);if(w>0)b=b.left;else if(w<0)b=b.right;else if($.hasNext())$.next(),b=b.mid;else break}return b}has(l){const $=this.d(l);return!($?.value===void 0&&$?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,$){const b=this.b.reset(l),w=[];let h=this.c;for(;h;){const f=b.cmp(h.segment);if(f>0)w.push([-1,h]),h=h.left;else if(f<0)w.push([1,h]),h=h.right;else if(b.hasNext())b.next(),w.push([0,h]),h=h.mid;else break}if(h){if($?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const f=this.f(h.right);if(f.key){const{key:d,value:c,segment:v}=f;this.e(f.key,!1),h.key=d,h.value=c,h.segment=v}}else{const f=h.left??h.right;if(w.length>0){const[d,c]=w[w.length-1];switch(d){case-1:c.left=f;break;case 0:c.mid=f;break;case 1:c.right=f;break}}else this.c=f}for(let f=w.length-1;f>=0;f--){const d=w[f][1];d.updateHeight();const c=d.balanceFactor();if(c>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),w[f][1]=d.rotateLeft()):c<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),w[f][1]=d.rotateRight()),f>0)switch(w[f-1][0]){case-1:w[f-1][1].left=w[f][1];break;case 1:w[f-1][1].right=w[f][1];break;case 0:w[f-1][1].mid=w[f][1];break}else this.c=w[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const $=this.b.reset(l);let b=this.c,w;for(;b;){const h=$.cmp(b.segment);if(h>0)b=b.left;else if(h<0)b=b.right;else if($.hasNext())$.next(),w=b.value||w,b=b.mid;else break}return b&&b.value||w}findSuperstr(l){return this.g(l,!1)}g(l,$){const b=this.b.reset(l);let w=this.c;for(;w;){const h=b.cmp(w.segment);if(h>0)w=w.left;else if(h<0)w=w.right;else if(b.hasNext())b.next(),w=w.mid;else return w.mid?this.h(w.mid):$?w.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[$,b]of this)l(b,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const $=[];return this.j(l,$),$[Symbol.iterator]()}j(l,$){l&&(l.left&&this.j(l.left,$),l.value&&$.push([l.key,l.value]),l.mid&&this.j(l.mid,$),l.right&&this.j(l.right,$))}_isBalanced(){const l=$=>{if(!$)return!0;const b=$.balanceFactor();return b<-1||b>1?!1:l($.left)&&l($.right)};return l(this.c)}}e.$_h=S}),define(le[12],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=void 0;function O(v){return typeof v=="string"}e.$If=O;function L(v){return Array.isArray(v)&&v.every(i=>O(i))}e.$Jf=L;function D(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.$Kf=D;function A(v){const i=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof i}e.$Lf=A;function I(v){return typeof v=="number"&&!isNaN(v)}e.$Mf=I;function P(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.$Nf=P;function k(v){return v===!0||v===!1}e.$Of=k;function g(v){return typeof v>"u"}e.$Pf=g;function C(v){return!S(v)}e.$Qf=C;function S(v){return g(v)||v===null}e.$Rf=S;function m(v,i){if(!v)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Sf=m;function l(v){if(S(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.$Tf=l;function $(...v){const i=[];for(let o=0;o<v.length;o++){const n=v[o];if(S(n))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);i.push(n)}return i}e.$Uf=$;const b=Object.prototype.hasOwnProperty;function w(v){if(!D(v))return!1;for(const i in v)if(b.call(v,i))return!1;return!0}e.$Vf=w;function h(v){return typeof v=="function"}e.$Wf=h;function f(...v){return v.length>0&&v.every(h)}e.$Xf=f;function d(v,i){const o=Math.min(v.length,i.length);for(let n=0;n<o;n++)c(v[n],i[n])}e.$Yf=d;function c(v,i){if(O(i)){if(typeof v!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(v instanceof i)return}catch{}if(!S(v)&&v.constructor===i||i.length===1&&i.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Zf=c}),define(le[30],he([0,1,12]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function L(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const f=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([d,c])=>{f[d]=c&&typeof c=="object"?L(c):c}),f}e.$vn=L;function D(h){if(!h||typeof h!="object")return h;const f=[h];for(;f.length>0;){const d=f.shift();Object.freeze(d);for(const c in d)if(A.call(d,c)){const v=d[c];typeof v=="object"&&!Object.isFrozen(v)&&!(0,O.$Lf)(v)&&f.push(v)}}return h}e.$wn=D;const A=Object.prototype.hasOwnProperty;function I(h,f){return P(h,f,new Set)}e.$xn=I;function P(h,f,d){if((0,O.$Rf)(h))return h;const c=f(h);if(typeof c<"u")return c;if(Array.isArray(h)){const v=[];for(const i of h)v.push(P(i,f,d));return v}if((0,O.$Kf)(h)){if(d.has(h))throw new Error("Cannot clone recursive data-structure");d.add(h);const v={};for(const i in h)A.call(h,i)&&(v[i]=P(h[i],f,d));return d.delete(h),v}return h}function k(h,f,d=!0){return(0,O.$Kf)(h)?((0,O.$Kf)(f)&&Object.keys(f).forEach(c=>{c in h?d&&((0,O.$Kf)(h[c])&&(0,O.$Kf)(f[c])?k(h[c],f[c],d):h[c]=f[c]):h[c]=f[c]}),h):f}e.$yn=k;function g(h,f){if(h===f)return!0;if(h==null||f===null||f===void 0||typeof h!=typeof f||typeof h!="object"||Array.isArray(h)!==Array.isArray(f))return!1;let d,c;if(Array.isArray(h)){if(h.length!==f.length)return!1;for(d=0;d<h.length;d++)if(!g(h[d],f[d]))return!1}else{const v=[];for(c in h)v.push(c);v.sort();const i=[];for(c in f)i.push(c);if(i.sort(),!g(v,i))return!1;for(d=0;d<v.length;d++)if(!g(h[v[d]],f[v[d]]))return!1}return!0}e.$zn=g;function C(h){const f=new Set;return JSON.stringify(h,(d,c)=>{if((0,O.$Kf)(c)||Array.isArray(c)){if(f.has(c))return"[Circular]";f.add(c)}return c})}e.$An=C;function S(h,f){const d=Object.create(null);return!h||!f||Object.keys(f).forEach(v=>{const i=h[v],o=f[v];g(i,o)||(d[v]=o)}),d}e.$Bn=S;function m(h,f){const d=f.toLowerCase(),c=Object.keys(h).find(v=>v.toLowerCase()===d);return c?h[c]:h[f]}e.$Cn=m;function l(h,f){const d=Object.create(null);for(const[c,v]of Object.entries(h))f(c,v)&&(d[c]=v);return d}e.$Dn=l;function $(h){let f=[];for(;Object.prototype!==h;)f=f.concat(Object.getOwnPropertyNames(h)),h=Object.getPrototypeOf(h);return f}e.$En=$;function b(h){const f=[];for(const d of $(h))typeof h[d]=="function"&&f.push(d);return f}e.$Fn=b;function w(h,f){const d=v=>function(){const i=Array.prototype.slice.call(arguments,0);return f(v,i)},c={};for(const v of h)c[v]=d(v);return c}e.$Gn=w}),define(le[32],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const O=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(D){return O.test(D)}e.$pg=L,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let D;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?D=crypto.getRandomValues.bind(crypto):D=function(P){for(let k=0;k<P.length;k++)P[k]=Math.floor(Math.random()*256);return P};const A=new Uint8Array(16),I=[];for(let P=0;P<256;P++)I.push(P.toString(16).padStart(2,"0"));return function(){D(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let k=0,g="";return g+=I[A[k++]],g+=I[A[k++]],g+=I[A[k++]],g+=I[A[k++]],g+="-",g+=I[A[k++]],g+=I[A[k++]],g+="-",g+=I[A[k++]],g+=I[A[k++]],g+="-",g+=I[A[k++]],g+=I[A[k++]],g+="-",g+=I[A[k++]],g+=I[A[k++]],g+=I[A[k++]],g+=I[A[k++]],g+=I[A[k++]],g+=I[A[k++]],g}}()}),define(le[131],he([0,1,36]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9m=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(I){const P=I.replace(/\-/g,":").toLowerCase();return!L.has(P)}function A(){const I=(0,O.networkInterfaces)();for(const P in I){const k=I[P];if(k){for(const{mac:g}of k)if(D(g))return g}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.$9m=A}),define(le[132],he([0,1,267,14]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wU=void 0;class D extends O.Transform{constructor(I){if(super(),typeof I=="number")this.b=I,this.c=1;else{const P=Buffer.isBuffer(I)?I:Buffer.from(I);this.b=P.length===1?P[0]:P,this.c=P.length}}_transform(I,P,k){this.a?this.a=Buffer.concat([this.a,I]):this.a=I;let g=0;for(;g<this.a.length;){const C=typeof this.b=="number"?this.a.indexOf(this.b,g):(0,L.$ke)(this.a,this.b,g);if(C===-1)break;this.push(this.a.slice(g,C+this.c)),g=C+this.c}this.a=g===this.a.length?void 0:this.a.slice(g),k()}_flush(I){this.a&&this.push(this.a),I()}}e.$wU=D}),define(le[133],he([0,1,64]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=e.$tg=e.$sg=void 0;function L(P,k,g,C=1){let S=!1;return new Promise(m=>{const l=setTimeout(()=>{if(!S)return S=!0,m(0)},g);D(P,k,C,$=>{if(!S)return S=!0,clearTimeout(l),m($)})})}e.$sg=L;function D(P,k,g,C){if(k===0)return C(0);const S=new O.Socket;S.once("connect",()=>(I(S),D(P+g,k-1,g,C))),S.once("data",()=>{}),S.once("error",m=>(I(S),m.code!=="ECONNREFUSED"?D(P+g,k-1,g,C):C(P))),S.connect(P,"127.0.0.1")}e.$tg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function A(P,k,g,C="127.0.0.1"){let S=!1,m,l=1;const $=O.createServer({pauseOnConnect:!0});function b(w,h){S||(S=!0,$.removeAllListeners(),$.close(),m&&clearTimeout(m),h(w))}return new Promise(w=>{m=setTimeout(()=>{b(0,w)},g),$.on("listening",()=>{b(P,w)}),$.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&l<k?(P++,l++,$.listen(P,C)):b(0,w)}),$.on("close",()=>{b(0,w)}),$.listen(P,C)})}e.$ug=A;function I(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(k){console.error(k)}}}),define(le[134],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MU=void 0;function O(L){return!!L.parentPort}e.$MU=O}),define(le[135],he([13,9]),function(se,e){return se.create("vs/base/common/date",e)}),define(le[65],he([0,1,135]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const L=60,D=L*60,A=D*24,I=A*7,P=A*30,k=A*365;function g(S,m,l,$){typeof S!="number"&&(S=S.getTime());const b=Math.round((new Date().getTime()-S)/1e3);if(b<-30)return(0,O.localize)(0,null,g(new Date().getTime()+b*1e3,!1));if(!$&&b<30)return(0,O.localize)(1,null);let w;return b<L?(w=b,m?w===1?l?(0,O.localize)(2,null,w):(0,O.localize)(3,null,w):l?(0,O.localize)(4,null,w):(0,O.localize)(5,null,w):w===1?l?(0,O.localize)(6,null,w):(0,O.localize)(7,null,w):l?(0,O.localize)(8,null,w):(0,O.localize)(9,null,w)):b<D?(w=Math.floor(b/L),m?w===1?l?(0,O.localize)(10,null,w):(0,O.localize)(11,null,w):l?(0,O.localize)(12,null,w):(0,O.localize)(13,null,w):w===1?l?(0,O.localize)(14,null,w):(0,O.localize)(15,null,w):l?(0,O.localize)(16,null,w):(0,O.localize)(17,null,w)):b<A?(w=Math.floor(b/D),m?w===1?l?(0,O.localize)(18,null,w):(0,O.localize)(19,null,w):l?(0,O.localize)(20,null,w):(0,O.localize)(21,null,w):w===1?l?(0,O.localize)(22,null,w):(0,O.localize)(23,null,w):l?(0,O.localize)(24,null,w):(0,O.localize)(25,null,w)):b<I?(w=Math.floor(b/A),m?w===1?(0,O.localize)(26,null,w):(0,O.localize)(27,null,w):w===1?(0,O.localize)(28,null,w):(0,O.localize)(29,null,w)):b<P?(w=Math.floor(b/I),m?w===1?l?(0,O.localize)(30,null,w):(0,O.localize)(31,null,w):l?(0,O.localize)(32,null,w):(0,O.localize)(33,null,w):w===1?l?(0,O.localize)(34,null,w):(0,O.localize)(35,null,w):l?(0,O.localize)(36,null,w):(0,O.localize)(37,null,w)):b<k?(w=Math.floor(b/P),m?w===1?l?(0,O.localize)(38,null,w):(0,O.localize)(39,null,w):l?(0,O.localize)(40,null,w):(0,O.localize)(41,null,w):w===1?l?(0,O.localize)(42,null,w):(0,O.localize)(43,null,w):l?(0,O.localize)(44,null,w):(0,O.localize)(45,null,w)):(w=Math.floor(b/k),m?w===1?l?(0,O.localize)(46,null,w):(0,O.localize)(47,null,w):l?(0,O.localize)(48,null,w):(0,O.localize)(49,null,w):w===1?l?(0,O.localize)(50,null,w):(0,O.localize)(51,null,w):l?(0,O.localize)(52,null,w):(0,O.localize)(53,null,w))}e.$vm=g;function C(S){return S.getFullYear()+"-"+String(S.getMonth()+1).padStart(2,"0")+"-"+String(S.getDate()).padStart(2,"0")+"T"+String(S.getHours()).padStart(2,"0")+":"+String(S.getMinutes()).padStart(2,"0")+":"+String(S.getSeconds()).padStart(2,"0")+"."+(S.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=C}),define(le[136],he([13,9]),function(se,e){return se.create("vs/base/common/errorMessage",e)}),define(le[38],he([0,1,17,12,136]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function A(S,m){return m&&(S.stack||S.stacktrace)?D.localize(0,null,P(S),I(S.stack)||I(S.stacktrace)):P(S)}function I(S){return Array.isArray(S)?S.join(`
`):S}function P(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?D.localize(1,null,S.message):S.message||D.localize(2,null)}function k(S=null,m=!1){if(!S)return D.localize(3,null);if(Array.isArray(S)){const l=O.$Hb(S),$=k(l[0],m);return l.length>1?D.localize(4,null,$,l.length):$}if(L.$If(S))return S;if(S.detail){const l=S.detail;if(l.error)return A(l.error,m);if(l.exception)return A(l.exception,m)}return S.stack?A(S,m):S.message?S.message:D.localize(5,null)}e.$Qi=k;function g(S){const m=S;return m instanceof Error&&Array.isArray(m.actions)}e.$Ri=g;function C(S,m){let l;return typeof S=="string"?l=new Error(S):l=S,l.actions=m,l}e.$Si=C}),define(le[137],he([13,9]),function(se,e){return se.create("vs/base/common/jsonErrorMessages",e)}),define(le[138],he([0,1,137]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xp=void 0;function L(D){switch(D){case 1:return(0,O.localize)(0,null);case 2:return(0,O.localize)(1,null);case 3:return(0,O.localize)(2,null);case 4:return(0,O.localize)(3,null);case 5:return(0,O.localize)(4,null);case 6:return(0,O.localize)(5,null);case 7:return(0,O.localize)(6,null);case 8:return(0,O.localize)(7,null);case 9:return(0,O.localize)(8,null);default:return""}}e.$Xp=L}),define(le[139],he([13,9]),function(se,e){return se.create("vs/base/common/platform",e)}),define(le[5],he([0,1,139]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let L=!1,D=!1,A=!1,I=!1,P=!1,k=!1,g=!1,C=!1,S=!1,m=!1,l,$=e.$g,b=e.$g,w,h;const f=globalThis;let d;typeof f.vscode<"u"&&typeof f.vscode.process<"u"?d=f.vscode.process:typeof process<"u"&&(d=process);const c=typeof d?.versions?.electron=="string",v=c&&d?.type==="renderer";if(typeof d=="object"){L=d.platform==="win32",D=d.platform==="darwin",A=d.platform==="linux",I=A&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,g=c,S=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=e.$g,$=e.$g;const u=d.env.VSCODE_NLS_CONFIG;if(u)try{const p=JSON.parse(u),R=p.availableLanguages["*"];l=p.locale,b=p.osLocale,$=R||e.$g,w=p._translationsConfigFile}catch{}P=!0}else typeof navigator=="object"&&!v?(h=navigator.userAgent,L=h.indexOf("Windows")>=0,D=h.indexOf("Macintosh")>=0,C=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=h.indexOf("Linux")>=0,m=h?.indexOf("Mobi")>=0,k=!0,l=O.getConfiguredDefaultLocale(O.localize(0,null))||e.$g,$=l,b=navigator.language):console.error("Unable to resolve platform.");var i;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(i||(e.Platform=i={}));function o(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=o;let n=0;D?n=1:L?n=3:A&&(n=2),e.$i=L,e.$j=D,e.$k=A,e.$l=I,e.$m=P,e.$n=g,e.$o=k,e.$p=k&&typeof f.importScripts=="function",e.$q=e.$p?f.origin:void 0,e.$r=C,e.$s=m,e.$t=S,e.$u=n,e.$v=h,e.$w=$;var s;(function(u){function p(){return e.$w}u.value=p;function R(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}u.isDefaultVariant=R;function N(){return e.$w==="en"}u.isDefault=N})(s||(e.Language=s={})),e.$x=l,e.$y=b,e.$z=w,e.$A=typeof f.postMessage=="function"&&!f.importScripts,e.$B=(()=>{if(e.$A){const u=[];f.addEventListener("message",R=>{if(R.data&&R.data.vscodeScheduleAsyncWork)for(let N=0,T=u.length;N<T;N++){const M=u[N];if(M.id===R.data.vscodeScheduleAsyncWork){u.splice(N,1),M.callback();return}}});let p=0;return R=>{const N=++p;u.push({id:N,callback:R}),f.postMessage({vscodeScheduleAsyncWork:N},"*")}}return u=>setTimeout(u)})();var t;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(t||(e.OperatingSystem=t={})),e.OS=D||C?2:L?1:3;let r=!0,a=!1;function E(){if(!a){a=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}e.$D=E,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function y(u){return parseFloat(u)>=20}e.$J=y}),define(le[37],he([0,1,5]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.process<"u"){const A=D.process;L={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return O.$i?"win32":O.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(le[16],he([0,1,37]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,D=97,A=90,I=122,P=46,k=47,g=92,C=58,S=63;class m extends Error{constructor(o,n,s){let t;typeof n=="string"&&n.indexOf("not ")===0?(t="must not be",n=n.replace(/^not /,"")):t="must be";const r=o.indexOf(".")!==-1?"property":"argument";let a=`The "${o}" ${r} ${t} of type ${n}`;a+=`. Received type ${typeof s}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function l(i,o){if(i===null||typeof i!="object")throw new m(o,"Object",i)}function $(i,o){if(typeof i!="string")throw new m(o,"string",i)}const b=O.$dc==="win32";function w(i){return i===k||i===g}function h(i){return i===k}function f(i){return i>=L&&i<=A||i>=D&&i<=I}function d(i,o,n,s){let t="",r=0,a=-1,E=0,y=0;for(let u=0;u<=i.length;++u){if(u<i.length)y=i.charCodeAt(u);else{if(s(y))break;y=k}if(s(y)){if(!(a===u-1||E===1))if(E===2){if(t.length<2||r!==2||t.charCodeAt(t.length-1)!==P||t.charCodeAt(t.length-2)!==P){if(t.length>2){const p=t.lastIndexOf(n);p===-1?(t="",r=0):(t=t.slice(0,p),r=t.length-1-t.lastIndexOf(n)),a=u,E=0;continue}else if(t.length!==0){t="",r=0,a=u,E=0;continue}}o&&(t+=t.length>0?`${n}..`:"..",r=2)}else t.length>0?t+=`${n}${i.slice(a+1,u)}`:t=i.slice(a+1,u),r=u-a-1;a=u,E=0}else y===P&&E!==-1?++E:E=-1}return t}function c(i,o){l(o,"pathObject");const n=o.dir||o.root,s=o.base||`${o.name||""}${o.ext||""}`;return n?n===o.root?`${n}${s}`:`${n}${i}${s}`:s}e.$fc={resolve(...i){let o="",n="",s=!1;for(let t=i.length-1;t>=-1;t--){let r;if(t>=0){if(r=i[t],$(r,"path"),r.length===0)continue}else o.length===0?r=O.cwd():(r=O.env[`=${o}`]||O.cwd(),(r===void 0||r.slice(0,2).toLowerCase()!==o.toLowerCase()&&r.charCodeAt(2)===g)&&(r=`${o}\\`));const a=r.length;let E=0,y="",u=!1;const p=r.charCodeAt(0);if(a===1)w(p)&&(E=1,u=!0);else if(w(p))if(u=!0,w(r.charCodeAt(1))){let R=2,N=R;for(;R<a&&!w(r.charCodeAt(R));)R++;if(R<a&&R!==N){const T=r.slice(N,R);for(N=R;R<a&&w(r.charCodeAt(R));)R++;if(R<a&&R!==N){for(N=R;R<a&&!w(r.charCodeAt(R));)R++;(R===a||R!==N)&&(y=`\\\\${T}\\${r.slice(N,R)}`,E=R)}}}else E=1;else f(p)&&r.charCodeAt(1)===C&&(y=r.slice(0,2),E=2,a>2&&w(r.charCodeAt(2))&&(u=!0,E=3));if(y.length>0)if(o.length>0){if(y.toLowerCase()!==o.toLowerCase())continue}else o=y;if(s){if(o.length>0)break}else if(n=`${r.slice(E)}\\${n}`,s=u,u&&o.length>0)break}return n=d(n,!s,"\\",w),s?`${o}\\${n}`:`${o}${n}`||"."},normalize(i){$(i,"path");const o=i.length;if(o===0)return".";let n=0,s,t=!1;const r=i.charCodeAt(0);if(o===1)return h(r)?"\\":i;if(w(r))if(t=!0,w(i.charCodeAt(1))){let E=2,y=E;for(;E<o&&!w(i.charCodeAt(E));)E++;if(E<o&&E!==y){const u=i.slice(y,E);for(y=E;E<o&&w(i.charCodeAt(E));)E++;if(E<o&&E!==y){for(y=E;E<o&&!w(i.charCodeAt(E));)E++;if(E===o)return`\\\\${u}\\${i.slice(y)}\\`;E!==y&&(s=`\\\\${u}\\${i.slice(y,E)}`,n=E)}}}else n=1;else f(r)&&i.charCodeAt(1)===C&&(s=i.slice(0,2),n=2,o>2&&w(i.charCodeAt(2))&&(t=!0,n=3));let a=n<o?d(i.slice(n),!t,"\\",w):"";return a.length===0&&!t&&(a="."),a.length>0&&w(i.charCodeAt(o-1))&&(a+="\\"),s===void 0?t?`\\${a}`:a:t?`${s}\\${a}`:`${s}${a}`},isAbsolute(i){$(i,"path");const o=i.length;if(o===0)return!1;const n=i.charCodeAt(0);return w(n)||o>2&&f(n)&&i.charCodeAt(1)===C&&w(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let o,n;for(let r=0;r<i.length;++r){const a=i[r];$(a,"path"),a.length>0&&(o===void 0?o=n=a:o+=`\\${a}`)}if(o===void 0)return".";let s=!0,t=0;if(typeof n=="string"&&w(n.charCodeAt(0))){++t;const r=n.length;r>1&&w(n.charCodeAt(1))&&(++t,r>2&&(w(n.charCodeAt(2))?++t:s=!1))}if(s){for(;t<o.length&&w(o.charCodeAt(t));)t++;t>=2&&(o=`\\${o.slice(t)}`)}return e.$fc.normalize(o)},relative(i,o){if($(i,"from"),$(o,"to"),i===o)return"";const n=e.$fc.resolve(i),s=e.$fc.resolve(o);if(n===s||(i=n.toLowerCase(),o=s.toLowerCase(),i===o))return"";let t=0;for(;t<i.length&&i.charCodeAt(t)===g;)t++;let r=i.length;for(;r-1>t&&i.charCodeAt(r-1)===g;)r--;const a=r-t;let E=0;for(;E<o.length&&o.charCodeAt(E)===g;)E++;let y=o.length;for(;y-1>E&&o.charCodeAt(y-1)===g;)y--;const u=y-E,p=a<u?a:u;let R=-1,N=0;for(;N<p;N++){const M=i.charCodeAt(t+N);if(M!==o.charCodeAt(E+N))break;M===g&&(R=N)}if(N!==p){if(R===-1)return s}else{if(u>p){if(o.charCodeAt(E+N)===g)return s.slice(E+N+1);if(N===2)return s.slice(E+N)}a>p&&(i.charCodeAt(t+N)===g?R=N:N===2&&(R=3)),R===-1&&(R=0)}let T="";for(N=t+R+1;N<=r;++N)(N===r||i.charCodeAt(N)===g)&&(T+=T.length===0?"..":"\\..");return E+=R,T.length>0?`${T}${s.slice(E,y)}`:(s.charCodeAt(E)===g&&++E,s.slice(E,y))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const o=e.$fc.resolve(i);if(o.length<=2)return i;if(o.charCodeAt(0)===g){if(o.charCodeAt(1)===g){const n=o.charCodeAt(2);if(n!==S&&n!==P)return`\\\\?\\UNC\\${o.slice(2)}`}}else if(f(o.charCodeAt(0))&&o.charCodeAt(1)===C&&o.charCodeAt(2)===g)return`\\\\?\\${o}`;return i},dirname(i){$(i,"path");const o=i.length;if(o===0)return".";let n=-1,s=0;const t=i.charCodeAt(0);if(o===1)return w(t)?i:".";if(w(t)){if(n=s=1,w(i.charCodeAt(1))){let E=2,y=E;for(;E<o&&!w(i.charCodeAt(E));)E++;if(E<o&&E!==y){for(y=E;E<o&&w(i.charCodeAt(E));)E++;if(E<o&&E!==y){for(y=E;E<o&&!w(i.charCodeAt(E));)E++;if(E===o)return i;E!==y&&(n=s=E+1)}}}}else f(t)&&i.charCodeAt(1)===C&&(n=o>2&&w(i.charCodeAt(2))?3:2,s=n);let r=-1,a=!0;for(let E=o-1;E>=s;--E)if(w(i.charCodeAt(E))){if(!a){r=E;break}}else a=!1;if(r===-1){if(n===-1)return".";r=n}return i.slice(0,r)},basename(i,o){o!==void 0&&$(o,"ext"),$(i,"path");let n=0,s=-1,t=!0,r;if(i.length>=2&&f(i.charCodeAt(0))&&i.charCodeAt(1)===C&&(n=2),o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=n;--r){const y=i.charCodeAt(r);if(w(y)){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(y===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=n;--r)if(w(i.charCodeAt(r))){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){$(i,"path");let o=0,n=-1,s=0,t=-1,r=!0,a=0;i.length>=2&&i.charCodeAt(1)===C&&f(i.charCodeAt(0))&&(o=s=2);for(let E=i.length-1;E>=o;--E){const y=i.charCodeAt(E);if(w(y)){if(!r){s=E+1;break}continue}t===-1&&(r=!1,t=E+1),y===P?n===-1?n=E:a!==1&&(a=1):n!==-1&&(a=-1)}return n===-1||t===-1||a===0||a===1&&n===t-1&&n===s+1?"":i.slice(n,t)},format:c.bind(null,"\\"),parse(i){$(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.length;let s=0,t=i.charCodeAt(0);if(n===1)return w(t)?(o.root=o.dir=i,o):(o.base=o.name=i,o);if(w(t)){if(s=1,w(i.charCodeAt(1))){let R=2,N=R;for(;R<n&&!w(i.charCodeAt(R));)R++;if(R<n&&R!==N){for(N=R;R<n&&w(i.charCodeAt(R));)R++;if(R<n&&R!==N){for(N=R;R<n&&!w(i.charCodeAt(R));)R++;R===n?s=R:R!==N&&(s=R+1)}}}}else if(f(t)&&i.charCodeAt(1)===C){if(n<=2)return o.root=o.dir=i,o;if(s=2,w(i.charCodeAt(2))){if(n===3)return o.root=o.dir=i,o;s=3}}s>0&&(o.root=i.slice(0,s));let r=-1,a=s,E=-1,y=!0,u=i.length-1,p=0;for(;u>=s;--u){if(t=i.charCodeAt(u),w(t)){if(!y){a=u+1;break}continue}E===-1&&(y=!1,E=u+1),t===P?r===-1?r=u:p!==1&&(p=1):r!==-1&&(p=-1)}return E!==-1&&(r===-1||p===0||p===1&&r===E-1&&r===a+1?o.base=o.name=i.slice(a,E):(o.name=i.slice(a,r),o.base=i.slice(a,E),o.ext=i.slice(r,E))),a>0&&a!==s?o.dir=i.slice(0,a-1):o.dir=o.root,o},sep:"\\",delimiter:";",win32:null,posix:null};const v=(()=>{if(b){const i=/\\/g;return()=>{const o=O.cwd().replace(i,"/");return o.slice(o.indexOf("/"))}}return()=>O.cwd()})();e.$gc={resolve(...i){let o="",n=!1;for(let s=i.length-1;s>=-1&&!n;s--){const t=s>=0?i[s]:v();$(t,"path"),t.length!==0&&(o=`${t}/${o}`,n=t.charCodeAt(0)===k)}return o=d(o,!n,"/",h),n?`/${o}`:o.length>0?o:"."},normalize(i){if($(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k,n=i.charCodeAt(i.length-1)===k;return i=d(i,!o,"/",h),i.length===0?o?"/":n?"./":".":(n&&(i+="/"),o?`/${i}`:i)},isAbsolute(i){return $(i,"path"),i.length>0&&i.charCodeAt(0)===k},join(...i){if(i.length===0)return".";let o;for(let n=0;n<i.length;++n){const s=i[n];$(s,"path"),s.length>0&&(o===void 0?o=s:o+=`/${s}`)}return o===void 0?".":e.$gc.normalize(o)},relative(i,o){if($(i,"from"),$(o,"to"),i===o||(i=e.$gc.resolve(i),o=e.$gc.resolve(o),i===o))return"";const n=1,s=i.length,t=s-n,r=1,a=o.length-r,E=t<a?t:a;let y=-1,u=0;for(;u<E;u++){const R=i.charCodeAt(n+u);if(R!==o.charCodeAt(r+u))break;R===k&&(y=u)}if(u===E)if(a>E){if(o.charCodeAt(r+u)===k)return o.slice(r+u+1);if(u===0)return o.slice(r+u)}else t>E&&(i.charCodeAt(n+u)===k?y=u:u===0&&(y=0));let p="";for(u=n+y+1;u<=s;++u)(u===s||i.charCodeAt(u)===k)&&(p+=p.length===0?"..":"/..");return`${p}${o.slice(r+y)}`},toNamespacedPath(i){return i},dirname(i){if($(i,"path"),i.length===0)return".";const o=i.charCodeAt(0)===k;let n=-1,s=!0;for(let t=i.length-1;t>=1;--t)if(i.charCodeAt(t)===k){if(!s){n=t;break}}else s=!1;return n===-1?o?"/":".":o&&n===1?"//":i.slice(0,n)},basename(i,o){o!==void 0&&$(o,"ext"),$(i,"path");let n=0,s=-1,t=!0,r;if(o!==void 0&&o.length>0&&o.length<=i.length){if(o===i)return"";let a=o.length-1,E=-1;for(r=i.length-1;r>=0;--r){const y=i.charCodeAt(r);if(y===k){if(!t){n=r+1;break}}else E===-1&&(t=!1,E=r+1),a>=0&&(y===o.charCodeAt(a)?--a===-1&&(s=r):(a=-1,s=E))}return n===s?s=E:s===-1&&(s=i.length),i.slice(n,s)}for(r=i.length-1;r>=0;--r)if(i.charCodeAt(r)===k){if(!t){n=r+1;break}}else s===-1&&(t=!1,s=r+1);return s===-1?"":i.slice(n,s)},extname(i){$(i,"path");let o=-1,n=0,s=-1,t=!0,r=0;for(let a=i.length-1;a>=0;--a){const E=i.charCodeAt(a);if(E===k){if(!t){n=a+1;break}continue}s===-1&&(t=!1,s=a+1),E===P?o===-1?o=a:r!==1&&(r=1):o!==-1&&(r=-1)}return o===-1||s===-1||r===0||r===1&&o===s-1&&o===n+1?"":i.slice(o,s)},format:c.bind(null,"/"),parse(i){$(i,"path");const o={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return o;const n=i.charCodeAt(0)===k;let s;n?(o.root="/",s=1):s=0;let t=-1,r=0,a=-1,E=!0,y=i.length-1,u=0;for(;y>=s;--y){const p=i.charCodeAt(y);if(p===k){if(!E){r=y+1;break}continue}a===-1&&(E=!1,a=y+1),p===P?t===-1?t=y:u!==1&&(u=1):t!==-1&&(u=-1)}if(a!==-1){const p=r===0&&n?1:r;t===-1||u===0||u===1&&t===a-1&&t===r+1?o.base=o.name=i.slice(p,a):(o.name=i.slice(p,t),o.base=i.slice(p,a),o.ext=i.slice(t,a))}return r>0?o.dir=i.slice(0,r-1):n&&(o.dir="/"),o},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=b?e.$fc.normalize:e.$gc.normalize,e.$ic=b?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=b?e.$fc.join:e.$gc.join,e.$kc=b?e.$fc.resolve:e.$gc.resolve,e.$lc=b?e.$fc.relative:e.$gc.relative,e.$mc=b?e.$fc.dirname:e.$gc.dirname,e.$nc=b?e.$fc.basename:e.$gc.basename,e.$oc=b?e.$fc.extname:e.$gc.extname,e.$pc=b?e.$fc.format:e.$gc.format,e.$qc=b?e.$fc.parse:e.$gc.parse,e.$rc=b?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=b?e.$fc.sep:e.$gc.sep,e.$tc=b?e.$fc.delimiter:e.$gc.delimiter}),define(le[49],he([0,1,16,5,27,12]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function I(r){return r===47||r===92}e.$1f=I;function P(r){return r.replace(/[\\/]/g,O.$gc.sep)}e.$2f=P;function k(r){return r.indexOf("/")===-1&&(r=P(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.$3f=k;function g(r,a=O.$gc.sep){if(!r)return"";const E=r.length,y=r.charCodeAt(0);if(I(y)){if(I(r.charCodeAt(1))&&!I(r.charCodeAt(2))){let p=3;const R=p;for(;p<E&&!I(r.charCodeAt(p));p++);if(R!==p&&!I(r.charCodeAt(p+1))){for(p+=1;p<E;p++)if(I(r.charCodeAt(p)))return r.slice(0,p+1).replace(/[\\/]/g,a)}}return a}else if(h(y)&&r.charCodeAt(1)===58)return I(r.charCodeAt(2))?r.slice(0,2)+a:r.slice(0,2);let u=r.indexOf("://");if(u!==-1){for(u+=3;u<E;u++)if(I(r.charCodeAt(u)))return r.slice(0,u+1)}return""}e.$4f=g;function C(r){if(!L.$i||!r||r.length<5)return!1;let a=r.charCodeAt(0);if(a!==92||(a=r.charCodeAt(1),a!==92))return!1;let E=2;const y=E;for(;E<r.length&&(a=r.charCodeAt(E),a!==92);E++);return!(y===E||(a=r.charCodeAt(E+1),isNaN(a)||a===92))}e.$5f=C;const S=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(r,a=L.$i){const E=a?S:m;return!(!r||r.length===0||/^\s+$/.test(r)||(E.lastIndex=0,E.test(r))||a&&l.test(r)||r==="."||r===".."||a&&r[r.length-1]==="."||a&&r.length!==r.trim().length||r.length>255)}e.$6f=$;function b(r,a,E){const y=r===a;return!E||y?y:!r||!a?!1:(0,D.$_e)(r,a)}e.$7f=b;function w(r,a,E,y=O.sep){if(r===a)return!0;if(!r||!a||a.length>r.length)return!1;if(E){if(!(0,D.$af)(r,a))return!1;if(a.length===r.length)return!0;let p=a.length;return a.charAt(a.length-1)===y&&p--,r.charAt(p)===y}return a.charAt(a.length-1)!==y&&(a+=y),r.indexOf(a)===0}e.$8f=w;function h(r){return r>=65&&r<=90||r>=97&&r<=122}e.$9f=h;function f(r,a){return L.$i&&r.endsWith(":")&&(r+=O.sep),(0,O.$ic)(r)||(r=(0,O.$jc)(a,r)),r=(0,O.$hc)(r),L.$i?(r=(0,D.$Ue)(r,O.sep),r.endsWith(":")&&(r+=O.sep)):(r=(0,D.$Ue)(r,O.sep),r||(r=O.sep)),r}e.$0f=f;function d(r){const a=(0,O.$hc)(r);return L.$i?r.length>3?!1:c(a)&&(r.length===2||a.charCodeAt(2)===92):a===O.$gc.sep}e.$$f=d;function c(r,a=L.$i){return a?h(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.$_f=c;function v(r,a=L.$i){return c(r,a)?r[0]:void 0}e.$ag=v;function i(r,a,E){return a.length>r.length?-1:r===a?0:(E&&(r=r.toLowerCase(),a=a.toLowerCase()),r.indexOf(a))}e.$bg=i;function o(r){const a=r.split(":");let E,y,u;for(const p of a){const R=Number(p);(0,A.$Mf)(R)?y===void 0?y=R:u===void 0&&(u=R):E=E?[E,p].join(":"):p}if(!E)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:E,line:y!==void 0?y:void 0,column:u!==void 0?u:y!==void 0?1:void 0}}e.$cg=o;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function t(r,a,E=8){let y="";for(let p=0;p<E;p++){let R;p===0&&L.$i&&!a&&(E===3||E===4)?R=s:R=n,y+=R.charAt(Math.floor(Math.random()*R.length))}let u;return a?u=`${a}-${y}`:u=y,r?(0,O.$jc)(r,u):u}e.$dg=t}),define(le[140],he([0,1,16]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},D={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function A(C){const S=(0,O.$oc)(C),m=L[S.toLowerCase()];return m!==void 0?m:I(C)}e.$gs=A;function I(C){const S=(0,O.$oc)(C);return D[S.toLowerCase()]}e.$hs=I;function P(C){for(const S in D)if(D[S]===C)return S}e.$is=P;const k=/^(.+)\/(.+?)(;.+)?$/;function g(C,S){const m=k.exec(C);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:S?void 0:C}e.$js=g}),define(le[90],he([0,1,5]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var L;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(L||(e.Source=L={}));var D;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(D||(e.TerminateResponseCode=D={}));function A(P,...k){const g=k.reduce((m,l)=>(m[l]=!0,m),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(m=>!g[m]).forEach(m=>{for(let l=0;l<C.length;l++)if(m.search(C[l])!==-1){delete P[m];break}})}e.$Rl=A;function I(P){P&&(delete P.DEBUG,O.$j&&delete P.DYLD_LIBRARY_PATH,O.$k&&delete P.LD_PRELOAD)}e.$Sl=I}),define(le[10],he([0,1,16,5]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,A=/^\//,I=/^\/\//;function P(s,t){if(!s.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!A.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function k(s,t){return!s&&!t?"file":s}function g(s,t){switch(s){case"https":case"http":case"file":t?t[0]!==S&&(t=S+t):t=S;break}return t}const C="",S="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(t){return t instanceof l?!0:t?typeof t.authority=="string"&&typeof t.fragment=="string"&&typeof t.path=="string"&&typeof t.query=="string"&&typeof t.scheme=="string"&&typeof t.fsPath=="string"&&typeof t.with=="function"&&typeof t.toString=="function":!1}constructor(t,r,a,E,y,u=!1){typeof t=="object"?(this.scheme=t.scheme||C,this.authority=t.authority||C,this.path=t.path||C,this.query=t.query||C,this.fragment=t.fragment||C):(this.scheme=k(t,u),this.authority=r||C,this.path=g(this.scheme,a||C),this.query=E||C,this.fragment=y||C,P(this,u))}get fsPath(){return c(this,!1)}with(t){if(!t)return this;let{scheme:r,authority:a,path:E,query:y,fragment:u}=t;return r===void 0?r=this.scheme:r===null&&(r=C),a===void 0?a=this.authority:a===null&&(a=C),E===void 0?E=this.path:E===null&&(E=C),y===void 0?y=this.query:y===null&&(y=C),u===void 0?u=this.fragment:u===null&&(u=C),r===this.scheme&&a===this.authority&&E===this.path&&y===this.query&&u===this.fragment?this:new w(r,a,E,y,u)}static parse(t,r=!1){const a=m.exec(t);return a?new w(a[2]||C,n(a[4]||C),n(a[5]||C),n(a[7]||C),n(a[9]||C),r):new w(C,C,C,C,C)}static file(t){let r=C;if(L.$i&&(t=t.replace(/\\/g,S)),t[0]===S&&t[1]===S){const a=t.indexOf(S,2);a===-1?(r=t.substring(2),t=S):(r=t.substring(2,a),t=t.substring(a)||S)}return new w("file",r,t,C,C)}static from(t,r){return new w(t.scheme,t.authority,t.path,t.query,t.fragment,r)}static joinPath(t,...r){if(!t.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return L.$i&&t.scheme==="file"?a=l.file(O.$fc.join(c(t,!0),...r)).path:a=O.$gc.join(t.path,...r),t.with({path:a})}toString(t=!1){return v(this,t)}toJSON(){return this}static revive(t){if(t){if(t instanceof l)return t;{const r=new w(t);return r._formatted=t.external??null,r._fsPath=t._sep===b?t.fsPath??null:null,r}}else return t}}e.URI=l;function $(s){return!s||typeof s!="object"?!1:typeof s.scheme=="string"&&(typeof s.authority=="string"||typeof s.authority>"u")&&(typeof s.path=="string"||typeof s.path>"u")&&(typeof s.query=="string"||typeof s.query>"u")&&(typeof s.fragment=="string"||typeof s.fragment>"u")}e.$vc=$;const b=L.$i?1:void 0;class w extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(t=!1){return t?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const t={$mid:1};return this._fsPath&&(t.fsPath=this._fsPath,t._sep=b),this._formatted&&(t.external=this._formatted),this.path&&(t.path=this.path),this.scheme&&(t.scheme=this.scheme),this.authority&&(t.authority=this.authority),this.query&&(t.query=this.query),this.fragment&&(t.fragment=this.fragment),t}}const h={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function f(s,t,r){let a,E=-1;for(let y=0;y<s.length;y++){const u=s.charCodeAt(y);if(u>=97&&u<=122||u>=65&&u<=90||u>=48&&u<=57||u===45||u===46||u===95||u===126||t&&u===47||r&&u===91||r&&u===93||r&&u===58)E!==-1&&(a+=encodeURIComponent(s.substring(E,y)),E=-1),a!==void 0&&(a+=s.charAt(y));else{a===void 0&&(a=s.substr(0,y));const p=h[u];p!==void 0?(E!==-1&&(a+=encodeURIComponent(s.substring(E,y)),E=-1),a+=p):E===-1&&(E=y)}}return E!==-1&&(a+=encodeURIComponent(s.substring(E))),a!==void 0?a:s}function d(s){let t;for(let r=0;r<s.length;r++){const a=s.charCodeAt(r);a===35||a===63?(t===void 0&&(t=s.substr(0,r)),t+=h[a]):t!==void 0&&(t+=s[r])}return t!==void 0?t:s}function c(s,t){let r;return s.authority&&s.path.length>1&&s.scheme==="file"?r=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?t?r=s.path.substr(1):r=s.path[1].toLowerCase()+s.path.substr(2):r=s.path,L.$i&&(r=r.replace(/\//g,"\\")),r}e.$wc=c;function v(s,t){const r=t?d:f;let a="",{scheme:E,authority:y,path:u,query:p,fragment:R}=s;if(E&&(a+=E,a+=":"),(y||E==="file")&&(a+=S,a+=S),y){let N=y.indexOf("@");if(N!==-1){const T=y.substr(0,N);y=y.substr(N+1),N=T.lastIndexOf(":"),N===-1?a+=r(T,!1,!1):(a+=r(T.substr(0,N),!1,!1),a+=":",a+=r(T.substr(N+1),!1,!0)),a+="@"}y=y.toLowerCase(),N=y.lastIndexOf(":"),N===-1?a+=r(y,!1,!0):(a+=r(y.substr(0,N),!1,!0),a+=y.substr(N))}if(u){if(u.length>=3&&u.charCodeAt(0)===47&&u.charCodeAt(2)===58){const N=u.charCodeAt(1);N>=65&&N<=90&&(u=`/${String.fromCharCode(N+32)}:${u.substr(3)}`)}else if(u.length>=2&&u.charCodeAt(1)===58){const N=u.charCodeAt(0);N>=65&&N<=90&&(u=`${String.fromCharCode(N+32)}:${u.substr(2)}`)}a+=r(u,!0,!1)}return p&&(a+="?",a+=r(p,!1,!1)),R&&(a+="#",a+=t?R:f(R,!1,!1)),a}function i(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+i(s.substr(3)):s}}const o=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function n(s){return s.match(o)?s.replace(o,t=>i(t)):s}}),define(le[141],he([0,1,10]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function L(g){const C=g;return C&&typeof C.type=="string"&&typeof C.severity=="string"}e.$mq=L;function D(g){const C=[];let S;try{const m=JSON.parse(g.arguments),l=m[m.length-1];l&&l.__$stack&&(m.pop(),S=l.__$stack),C.push(...m)}catch{C.push("Unable to log remote console arguments",g.arguments)}return{args:C,stack:S}}e.$nq=D;function A(g){if(typeof g!="string")return A(D(g).stack);const C=g;if(C){const S=I(C),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(S||"");if(m&&m.length===4)return{uri:O.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.$oq=A;function I(g){if(!g)return g;const C=g.indexOf(`
`);return C===-1?g:g.substring(0,C)}function P(g,C){const{args:S,stack:m}=D(g),l=typeof S[0]=="string"&&S.length===1;let $=I(m);$&&($=`(${$.trim()})`);let b=[];if(typeof S[0]=="string"?$&&l?b=[`%c[${C}] %c${S[0]} %c${$}`,k("blue"),k(""),k("grey")]:b=[`%c[${C}] %c${S[0]}`,k("blue"),k(""),...S.slice(1)]:b=[`%c[${C}]%`,k("blue"),...S],$&&!l&&b.push($),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,b)}e.log=P;function k(g){return`color: ${g}`}}),define(le[66],he([0,1,14,10]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function D(k){return JSON.stringify(k,I)}e.$Ah=D;function A(k){let g=JSON.parse(k);return g=P(g),g}e.$Bh=A;function I(k,g){return g instanceof RegExp?{$mid:2,source:g.source,flags:g.flags}:g}function P(k,g=0){if(!k||g>200)return k;if(typeof k=="object"){switch(k.$mid){case 1:return L.URI.revive(k);case 2:return new RegExp(k.source,k.flags);case 17:return new Date(k.source)}if(k instanceof O.$je||k instanceof Uint8Array)return k;if(Array.isArray(k))for(let C=0;C<k.length;++C)k[C]=P(k[C],g+1);else for(const C in k)Object.hasOwnProperty.call(k,C)&&(k[C]=P(k[C],g+1))}return k}e.$Ch=P}),define(le[23],he([0,1,7,5,27,10]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var I;(function(m){m.inMemory="inmemory",m.vscode="vscode",m.internal="private",m.walkThrough="walkThrough",m.walkThroughSnippet="walkThroughSnippet",m.http="http",m.https="https",m.file="file",m.mailto="mailto",m.untitled="untitled",m.data="data",m.command="command",m.vscodeRemote="vscode-remote",m.vscodeRemoteResource="vscode-remote-resource",m.vscodeManagedRemoteResource="vscode-managed-remote-resource",m.vscodeUserData="vscode-userdata",m.vscodeCustomEditor="vscode-custom-editor",m.vscodeNotebookCell="vscode-notebook-cell",m.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",m.vscodeNotebookCellOutput="vscode-notebook-cell-output",m.vscodeInteractiveInput="vscode-interactive-input",m.vscodeSettings="vscode-settings",m.vscodeWorkspaceTrust="vscode-workspace-trust",m.vscodeTerminal="vscode-terminal",m.vscodeChatSesssion="vscode-chat-editor",m.webviewPanel="webview-panel",m.vscodeWebview="vscode-webview",m.extension="extension",m.vscodeFileResource="vscode-file",m.tmp="tmp",m.vsls="vsls",m.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={}));function P(m,l){return A.URI.isUri(m)?(0,D.$_e)(m.scheme,l):(0,D.$af)(m,l+":")}e.$eg=P;function k(m,...l){return l.some($=>P(m,$))}e.$fg=k,e.$gg="vscode-tkn",e.$hg="tkn";class g{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(l){this.d=l}setDelegate(l){this.e=l}setServerRootPath(l){this.f=`${l}/${I.vscodeRemoteResource}`}set(l,$,b){this.a[l]=$,this.b[l]=b}setConnectionToken(l,$){this.c[l]=$}getPreferredWebSchema(){return this.d}rewrite(l){if(this.e)try{return this.e(l)}catch(d){return O.$1(d),l}const $=l.authority;let b=this.a[$];b&&b.indexOf(":")!==-1&&b.indexOf("[")===-1&&(b=`[${b}]`);const w=this.b[$],h=this.c[$];let f=`path=${encodeURIComponent(l.path)}`;return typeof h=="string"&&(f+=`&${e.$hg}=${encodeURIComponent(h)}`),A.URI.from({scheme:L.$o?this.d:I.vscodeRemoteResource,authority:`${b}:${w}`,path:this.f,query:f})}}e.$ig=new g,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class C{static{this.a=e.$ng}asBrowserUri(l){const $=this.b(l,se);return this.uriToBrowserUri($)}uriToBrowserUri(l){return l.scheme===I.vscodeRemote?e.$ig.rewrite(l):l.scheme===I.file&&(L.$m||L.$q===`${I.vscodeFileResource}://${C.a}`)?l.with({scheme:I.vscodeFileResource,authority:l.authority||C.a,query:null,fragment:null}):l}asFileUri(l){const $=this.b(l,se);return this.uriToFileUri($)}uriToFileUri(l){return l.scheme===I.vscodeFileResource?l.with({scheme:I.file,authority:l.authority!==C.a?l.authority:null,query:null,fragment:null}):l}b(l,$){return A.URI.isUri(l)?l:A.URI.parse($.toUrl(l))}}e.$og=new C;var S;(function(m){const l=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);m.CoopAndCoep=Object.freeze(l.get("3"));const $="vscode-coi";function b(h){let f;typeof h=="string"?f=new URL(h).searchParams:h instanceof URL?f=h.searchParams:A.URI.isUri(h)&&(f=new URL(h.toString(!0)).searchParams);const d=f?.get($);if(d)return l.get(d)}m.getHeadersFromQuery=b;function w(h,f,d){if(!globalThis.crossOriginIsolated)return;const c=f&&d?"3":d?"2":"1";h instanceof URLSearchParams?h.set($,c):h[$]=c}m.addSearchParam=w})(S||(e.COI=S={}))}),define(le[142],he([0,1,124,23,5,10]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0;class I{constructor(m,l,$){this.id=m,this.dependencies=l,this.callback=$}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(m,l,$)=>{typeof m!="string"&&($=l,l=m,m=null),(typeof l!="object"||!Array.isArray(l))&&($=l,l=null),this.c.push(new I(m,l,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){if(m.startsWith(window.location.origin)||m.startsWith("vscode-file://vscode-app"))return m;throw new Error(`[trusted_script_src] Invalid script url: ${m}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(m){return m}})))}async load(m){this.g();const l=await(this.a?this.i(m):this.b?this.h(m):this.j(m));if(!l)throw new Error(`Did not receive a define call from script ${m}`);if(Array.isArray(l.dependencies)&&l.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${m}. The dependencies are: ${l.dependencies.join(", ")}`);return typeof l.callback=="function"?l.callback([]):l.callback}h(m){return new Promise((l,$)=>{const b=document.createElement("script");b.setAttribute("async","async"),b.setAttribute("type","text/javascript");const w=()=>{b.removeEventListener("load",h),b.removeEventListener("error",f)},h=d=>{w(),l(this.c.pop())},f=d=>{w(),$(d)};b.addEventListener("load",h),b.addEventListener("error",f),this.f&&(m=this.f.createScriptURL(m)),b.setAttribute("src",m),window.document.getElementsByTagName("head")[0].appendChild(b)})}i(m){return new Promise((l,$)=>{try{this.f&&(m=this.f.createScriptURL(m)),importScripts(m),l(this.c.pop())}catch(b){$(b)}})}async j(m){try{const l=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,b=globalThis._VSCODE_NODE_MODULES.module,w=A.URI.parse(m).fsPath,h=l.readFileSync(w).toString(),f=b.wrap(h.replace(/^#!.*/,""));return new $.Script(f).runInThisContext().apply(),this.c.pop()}catch(l){throw l}}}const k=new Map;let g={};typeof globalThis.require=="object"&&(g=globalThis.require.paths??{});async function C(S,m,l){if(O.$T){l===void 0&&(l=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),g[S]&&(S=g[S]);const $=`${S}/${m}`;if(k.has($))return k.get($);let b;if(/^\w[\w\d+.-]*:\/\//.test($))b=$;else{const d=`${l&&!D.$o?L.$lg:L.$kg}/${$}`;b=L.$og.asBrowserUri(d).toString(!0)}const w=P.INSTANCE.load(b);return k.set($,w),w}else return await new Promise(($,b)=>{se([S],$,b)})}e.$fD=C}),define(le[20],he([0,1,49,23,16,5,27,10]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function k(l){return(0,P.$wc)(l,!0)}e.$vg=k;class g{constructor($){this.a=$}compare($,b,w=!1){return $===b?0:(0,I.$5e)(this.getComparisonKey($,w),this.getComparisonKey(b,w))}isEqual($,b,w=!1){return $===b?!0:!$||!b?!1:this.getComparisonKey($,w)===this.getComparisonKey(b,w)}getComparisonKey($,b=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:b?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,b,w=!1){if($.scheme===b.scheme){if($.scheme===L.Schemas.file)return O.$8f(k($),k(b),this.a($))&&$.query===b.query&&(w||$.fragment===b.fragment);if((0,e.$Mg)($.authority,b.authority))return O.$8f($.path,b.path,this.a($),"/")&&$.query===b.query&&(w||$.fragment===b.fragment)}return!1}joinPath($,...b){return P.URI.joinPath($,...b)}basenameOrAuthority($){return(0,e.$Eg)($)||$.authority}basename($){return D.$gc.basename($.path)}extname($){return D.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let b;return $.scheme===L.Schemas.file?b=P.URI.file(D.$mc(k($))).path:(b=D.$gc.dirname($.path),$.authority&&b.length&&b.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),b="/")),$.with({path:b})}normalizePath($){if(!$.path.length)return $;let b;return $.scheme===L.Schemas.file?b=P.URI.file(D.$hc(k($))).path:b=D.$gc.normalize($.path),$.with({path:b})}relativePath($,b){if($.scheme!==b.scheme||!(0,e.$Mg)($.authority,b.authority))return;if($.scheme===L.Schemas.file){const f=D.$lc(k($),k(b));return A.$i?O.$2f(f):f}let w=$.path||"/";const h=b.path||"/";if(this.a($)){let f=0;for(const d=Math.min(w.length,h.length);f<d&&!(w.charCodeAt(f)!==h.charCodeAt(f)&&w.charAt(f).toLowerCase()!==h.charAt(f).toLowerCase());f++);w=h.substr(0,f)+w.substr(f)}return D.$gc.relative(w,h)}resolvePath($,b){if($.scheme===L.Schemas.file){const w=P.URI.file(D.$kc(k($),b));return $.with({authority:w.authority,path:w.path})}return b=O.$3f(b),$.with({path:D.$gc.resolve($.path,b)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,b){return $===b||$!==void 0&&b!==void 0&&(0,I.$_e)($,b)}hasTrailingPathSeparator($,b=D.sep){if($.scheme===L.Schemas.file){const w=k($);return w.length>O.$4f(w).length&&w[w.length-1]===b}else{const w=$.path;return w.length>1&&w.charCodeAt(w.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,b=D.sep){return(0,e.$Ng)($,b)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,b=D.sep){let w=!1;if($.scheme===L.Schemas.file){const h=k($);w=h!==void 0&&h.length===O.$4f(h).length&&h[h.length-1]===b}else{b="/";const h=$.path;w=h.length===1&&h.charCodeAt(h.length-1)===47}return!w&&!(0,e.$Ng)($,b)?$.with({path:$.path+"/"}):$}}e.$wg=g,e.$xg=new g(()=>!1),e.$yg=new g(l=>l.scheme===L.Schemas.file?!A.$k:!0),e.$zg=new g(l=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function C(l,$){const b=[];for(let w=0;w<l.length;w++){const h=$(l[w]);l.some((f,d)=>d===w?!1:(0,e.$Bg)(h,$(f)))||b.push(l[w])}return b}e.$Qg=C;var S;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function $(b){const w=new Map;b.path.substring(b.path.indexOf(";")+1,b.path.lastIndexOf(";")).split(";").forEach(d=>{const[c,v]=d.split(":");c&&v&&w.set(c,v)});const f=b.path.substring(0,b.path.indexOf(";"));return f&&w.set(l.META_DATA_MIME,f),w}l.parseMetaData=$})(S||(e.DataUri=S={}));function m(l,$,b){if($){let w=l.path;return w&&w[0]!==D.$gc.sep&&(w=D.$gc.sep+w),l.with({scheme:b,authority:$,path:w})}return l.with({scheme:b})}e.$Rg=m}),define(le[6],he([0,1,26,7,3,2,20,5,130,52]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function C(G){return!!G&&typeof G.then=="function"}e.$Sg=C;function S(G){const J=new O.$6d,te=G(J.token),ne=new Promise((ce,de)=>{const $e=J.token.onCancellationRequested(()=>{$e.dispose(),de(new L.$5)});Promise.resolve(te).then(me=>{$e.dispose(),J.dispose(),ce(me)},me=>{$e.dispose(),J.dispose(),de(me)})});return new class{cancel(){J.cancel(),J.dispose()}then(ce,de){return ne.then(ce,de)}catch(ce){return this.then(void 0,ce)}finally(ce){return ne.finally(ce)}}}e.$Tg=S;function m(G,J,te){return new Promise((ne,ce)=>{const de=J.onCancellationRequested(()=>{de.dispose(),ne(te)});G.then(ne,ce).finally(()=>de.dispose())})}e.$Ug=m;function l(G,J){return new Promise((te,ne)=>{const ce=J.onCancellationRequested(()=>{ce.dispose(),ne(new L.$5)});G.then(te,ne).finally(()=>ce.dispose())})}e.$Vg=l;async function $(G){let J=-1;const te=G.map((ne,ce)=>ne.then(de=>(J=ce,de)));try{return await Promise.race(te)}finally{G.forEach((ne,ce)=>{ce!==J&&ne.cancel()})}}e.$Wg=$;function b(G,J,te){let ne;const ce=setTimeout(()=>{ne?.(void 0),te?.()},J);return Promise.race([G.finally(()=>clearTimeout(ce)),new Promise(de=>ne=de)])}e.$Xg=b;function w(G){return new Promise((J,te)=>{const ne=G();C(ne)?ne.then(J,te):J(ne)})}e.$Yg=w;class h{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(J){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=J,!this.b){const te=()=>{if(this.b=null,this.f)return;const ne=this.queue(this.d);return this.d=null,ne};this.b=new Promise(ne=>{this.a.then(te,te).then(ne)})}return new Promise((te,ne)=>{this.b.then(te,ne)})}return this.a=J(),new Promise((te,ne)=>{this.a.then(ce=>{this.a=null,te(ce)},ce=>{this.a=null,ne(ce)})})}dispose(){this.f=!0}}e.$Zg=h;class f{constructor(){this.a=Promise.resolve(null)}queue(J){return this.a=this.a.then(()=>J(),()=>J())}}e.$1g=f;class d{constructor(){this.a=new Map}queue(J,te){const ce=(this.a.get(J)??Promise.resolve()).catch(()=>{}).then(te).finally(()=>{this.a.get(J)===ce&&this.a.delete(J)});return this.a.set(J,ce),ce}}e.$2g=d;const c=(G,J)=>{let te=!0;const ne=setTimeout(()=>{te=!1,J()},G);return{isTriggered:()=>te,dispose:()=>{clearTimeout(ne),te=!1}}},v=G=>{let J=!0;return queueMicrotask(()=>{J&&(J=!1,G())}),{isTriggered:()=>J,dispose:()=>{J=!1}}};class i{constructor(J){this.defaultDelay=J,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(J,te=this.defaultDelay){this.g=J,this.h(),this.b||(this.b=new Promise((ce,de)=>{this.d=ce,this.f=de}).then(()=>{if(this.b=null,this.d=null,this.g){const ce=this.g;return this.g=null,ce()}}));const ne=()=>{this.a=null,this.d?.(null)};return this.a=te===k.$Sd?v(ne):c(te,ne),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=i;class o{constructor(J){this.a=new i(J),this.b=new h}trigger(J,te){return this.a.trigger(()=>this.b.queue(J),te)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=o;class n{constructor(){this.a=!1,this.b=new Promise((J,te)=>{this.d=J})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=n;class s extends n{constructor(J){super(),this.f=setTimeout(()=>this.open(),J)}open(){clearTimeout(this.f),super.open()}}e.$6g=s;function t(G,J){return J?new Promise((te,ne)=>{const ce=setTimeout(()=>{de.dispose(),te()},G),de=J.onCancellationRequested(()=>{clearTimeout(ce),de.dispose(),ne(new L.$5)})}):S(te=>t(G,te))}e.$7g=t;function r(G,J=0,te){const ne=setTimeout(()=>{G(),te&&ce.dispose()},J),ce=(0,A.$Rc)(()=>{clearTimeout(ne),te?.deleteAndLeak(ce)});return te?.add(ce),ce}e.$8g=r;function a(G){const J=[];let te=0;const ne=G.length;function ce(){return te<ne?G[te++]():null}function de($e){$e!=null&&J.push($e);const me=ce();return me?me.then(de):Promise.resolve(J)}return Promise.resolve(null).then(de)}e.$9g=a;function E(G,J=ne=>!!ne,te=null){let ne=0;const ce=G.length,de=()=>{if(ne>=ce)return Promise.resolve(te);const $e=G[ne++];return Promise.resolve($e()).then(Ee=>J(Ee)?Promise.resolve(Ee):de())};return de()}e.$0g=E;function y(G,J=ne=>!!ne,te=null){if(G.length===0)return Promise.resolve(te);let ne=G.length;const ce=()=>{ne=-1;for(const de of G)de.cancel?.()};return new Promise((de,$e)=>{for(const me of G)me.then(Ee=>{--ne>=0&&J(Ee)?(ce(),de(Ee)):ne===0&&de(te)}).catch(Ee=>{--ne>=0&&(ce(),$e(Ee))})})}e.$$g=y;class u{constructor(J){this.a=0,this.b=!1,this.f=J,this.g=[],this.d=0,this.h=new D.$Vd}whenIdle(){return this.size>0?D.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(J){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((te,ne)=>{this.g.push({factory:J,c:te,e:ne}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const J=this.g.shift();this.d++;const te=J.factory();te.then(J.c,J.e),te.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=u;class p extends u{constructor(){super(1)}}e.$ah=p;class R{constructor(){this.a=new V,this.b=0}queue(J){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,J())):this.a.run(this.b++,J())}}e.$bh=R;class N{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const J=new ee;return this.b.add(J),J.p}g(){for(const[,J]of this.a)if(J.size>0)return!1;return!0}queueSize(J,te=I.$xg){const ne=te.getComparisonKey(J);return this.a.get(ne)?.size??0}queueFor(J,te,ne=I.$xg){const ce=ne.getComparisonKey(J);let de=this.a.get(ce);if(!de){de=new p;const $e=this.f++,me=D.Event.once(de.onDrained)(()=>{de?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose($e),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set($e,me),this.a.set(ce,de)}return de.queue(te)}h(){this.g()&&this.j()}j(){for(const J of this.b)J.complete();this.b.clear()}dispose(){for(const[,J]of this.a)J.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=N;class T{constructor(J,te){this.a=-1,typeof J=="function"&&typeof te=="number"&&this.setIfNotSet(J,te)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(J,te){this.cancel(),this.a=setTimeout(()=>{this.a=-1,J()},te)}setIfNotSet(J,te){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,J()},te))}}e.$dh=T;class M{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(J,te,ne=globalThis){this.cancel();const ce=ne.setInterval(()=>{J()},te);this.d=(0,A.$Rc)(()=>{ne.clearInterval(ce),this.d=void 0})}dispose(){this.cancel()}}e.$eh=M;class U{constructor(J,te){this.b=-1,this.a=J,this.d=te,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(J=this.d){this.cancel(),this.b=setTimeout(this.f,J)}get delay(){return this.d}set delay(J){this.d=J}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=U;class Y{constructor(J,te){te%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${te}ms is not a multiple of 1000ms.`),this.a=J,this.b=te,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(J=this.b){J%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${J}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(J/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=Y;class Q extends U{constructor(J,te){super(J,te),this.j=[]}work(J){this.j.push(J),this.isScheduled()||this.schedule()}h(){const J=this.j;this.j=[],this.a?.(J)}dispose(){this.j=[],super.dispose()}}e.$hh=Q;class x extends A.$Tc{constructor(J,te){super(),this.g=J,this.h=te,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(J){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+J.length>this.g.maxBufferedWork)return!1}else if(this.pending+J.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const te of J)this.a.push(te);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new U(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=x,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(G,J)=>{(0,P.$B)(()=>{if(te)return;const ne=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ne-Date.now())}}))});let te=!1;return{dispose(){te||(te=!0)}}}:e.$kh=(G,J,te)=>{const ne=G.requestIdleCallback(J,typeof te=="number"?{timeout:te}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,G.cancelIdleCallback(ne))}}},e.$jh=G=>(0,e.$kh)(globalThis,G)}();class H{constructor(J,te){this.g=!1,this.d=()=>{try{this.j=te()}catch(ne){this.l=ne}finally{this.g=!0}},this.f=(0,e.$kh)(J,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=H;class Z extends H{constructor(J){super(globalThis,J)}}e.$mh=Z;async function W(G,J,te){let ne;for(let ce=0;ce<te;ce++)try{return await G()}catch(de){ne=de,await t(J)}throw ne}e.$nh=W;class V{isRunning(J){return typeof J=="number"?this.a?.taskId===J:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(J,te,ne){return this.a={taskId:J,cancel:()=>ne?.(),promise:te},te.then(()=>this.d(J),()=>this.d(J)),te}d(J){this.a&&J===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const J=this.b;this.b=void 0,J.run().then(J.promiseResolve,J.promiseReject)}}queue(J){if(this.b)this.b.run=J;else{let te,ne;const ce=new Promise((de,$e)=>{te=de,ne=$e});this.b={run:J,promise:ce,promiseResolve:te,promiseReject:ne}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=V;class ie{constructor(J,te=()=>Date.now()){this.d=J,this.f=te,this.a=0,this.b=0}increment(){const J=this.f();return J-this.a>this.d&&(this.a=J,this.b=0),this.b++,this.b}}e.$ph=ie;var re;(function(G){G[G.Resolved=0]="Resolved",G[G.Rejected=1]="Rejected"})(re||(re={}));class ee{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((J,te)=>{this.a=J,this.b=te})}complete(J){return new Promise(te=>{this.a(J),this.d={outcome:0,value:J},te()})}error(J){return new Promise(te=>{this.b(J),this.d={outcome:1,value:J},te()})}cancel(){return this.error(new L.$5)}}e.$qh=ee;var ae;(function(G){async function J(ne){let ce;const de=await Promise.all(ne.map($e=>$e.then(me=>me,me=>{ce||(ce=me)})));if(typeof ce<"u")throw ce;return de}G.settled=J;function te(ne){return new Promise(async(ce,de)=>{try{await ne(ce,de)}catch($e){de($e)}})}G.withAsyncBody=te})(ae||(e.Promises=ae={}));class K{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(J){this.a=void 0,this.b=void 0,this.d=!1,this.promise=J.then(te=>(this.a=te,this.d=!0,te),te=>{throw this.b=te,this.d=!0,te})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=K;class q{constructor(J){this.b=J,this.a=new g.$V(()=>new K(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=q;var j;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(j||(j={}));class F{static fromArray(J){return new F(te=>{te.emitMany(J)})}static fromPromise(J){return new F(async te=>{te.emitMany(await J)})}static fromPromises(J){return new F(async te=>{await Promise.all(J.map(async ne=>te.emitOne(await ne)))})}static merge(J){return new F(async te=>{await Promise.all(J.map(async ne=>{for await(const ce of ne)te.emitOne(ce)}))})}static{this.EMPTY=F.fromArray([])}constructor(J){this.a=0,this.b=[],this.d=null,this.f=new D.$Vd,queueMicrotask(async()=>{const te={emitOne:ne=>this.g(ne),emitMany:ne=>this.h(ne),reject:ne=>this.k(ne)};try{await Promise.resolve(J(te)),this.j()}catch(ne){this.k(ne)}finally{te.emitOne=void 0,te.emitMany=void 0,te.reject=void 0}})}[Symbol.asyncIterator](){let J=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(J<this.b.length)return{done:!1,value:this.b[J++]};if(this.a===1)return{done:!0,value:void 0};await D.Event.toPromise(this.f.event)}while(!0)}}}static map(J,te){return new F(async ne=>{for await(const ce of J)ne.emitOne(te(ce))})}map(J){return F.map(this,J)}static filter(J,te){return new F(async ne=>{for await(const ce of J)te(ce)&&ne.emitOne(ce)})}filter(J){return F.filter(this,J)}static coalesce(J){return F.filter(J,te=>!!te)}coalesce(){return F.coalesce(this)}static async toPromise(J){const te=[];for await(const ne of J)te.push(ne);return te}toPromise(){return F.toPromise(this)}g(J){this.a===0&&(this.b.push(J),this.f.fire())}h(J){this.a===0&&(this.b=this.b.concat(J),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(J){this.a===0&&(this.a=2,this.d=J,this.f.fire())}}e.$th=F;class B extends F{constructor(J,te){super(te),this.l=J}cancel(){this.l.cancel()}}e.$uh=B;function z(G){const J=new O.$6d,te=G(J.token);return new B(J,async ne=>{const ce=J.token.onCancellationRequested(()=>{ce.dispose(),J.dispose(),ne.reject(new L.$5)});try{for await(const de of te){if(J.token.isCancellationRequested)return;ne.emitOne(de)}ce.dispose(),J.dispose()}catch(de){ce.dispose(),J.dispose(),ne.reject(de)}})}e.$vh=z;class _{constructor(){this.a=new ee,this.b=new F(ne=>{if(J){ne.reject(J);return}return te&&ne.emitMany(te),this.d=ce=>ne.reject(ce),this.f=ce=>ne.emitOne(ce),this.a.p});let J,te;this.f=ne=>{te||(te=[]),te.push(ne)},this.d=ne=>{J||(J=ne)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(J){this.d(J),this.a.complete()}emitOne(J){this.f(J)}}e.$wh=_}),define(le[91],he([0,1,17,6,49,35,16,5,27]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function g(){return Object.create(null)}e.$Hj=g,e.$Ij="**",e.$Jj="/";const C="[/\\\\]",S="[^/\\\\]",m=/\//g;function l(Z,W){switch(Z){case 0:return"";case 1:return`${S}*?`;default:return`(?:${C}|${S}+${C}${W?`|${C}${S}+`:""})*?`}}function $(Z,W){if(!Z)return[];const V=[];let ie=!1,re=!1,ee="";for(const ae of Z){switch(ae){case W:if(!ie&&!re){V.push(ee),ee="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":re=!0;break;case"]":re=!1;break}ee+=ae}return ee&&V.push(ee),V}e.$Kj=$;function b(Z){if(!Z)return"";let W="";const V=$(Z,e.$Jj);if(V.every(ie=>ie===e.$Ij))W=".*";else{let ie=!1;V.forEach((re,ee)=>{if(re===e.$Ij){if(ie)return;W+=l(2,ee===V.length-1)}else{let ae=!1,K="",q=!1,j="";for(const F of re){if(F!=="}"&&ae){K+=F;continue}if(q&&(F!=="]"||!j)){let B;F==="-"?B=F:(F==="^"||F==="!")&&!j?B="^":F===e.$Jj?B="":B=(0,k.$Oe)(F),j+=B;continue}switch(F){case"{":ae=!0;continue;case"[":q=!0;continue;case"}":{const z=`(?:${$(K,",").map(_=>b(_)).join("|")})`;W+=z,ae=!1,K="";break}case"]":{W+="["+j+"]",q=!1,j="";break}case"?":W+=S;continue;case"*":W+=l(1);continue;default:W+=(0,k.$Oe)(F)}}ee<V.length-1&&(V[ee+1]!==e.$Ij||ee+2<V.length)&&(W+=C)}ie=re===e.$Ij})}return W}const w=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,f=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new A.$Dc(1e4),o=function(){return!1},n=function(){return null};function s(Z,W){if(!Z)return n;let V;typeof Z!="string"?V=Z.pattern:V=Z,V=V.trim();const ie=`${V}_${!!W.trimForExclusions}`;let re=i.get(ie);if(re)return t(re,Z);let ee;return w.test(V)?re=a(V.substr(4),V):(ee=h.exec(r(V,W)))?re=E(ee[1],V):(W.trimForExclusions?d:f).test(V)?re=y(V,W):(ee=c.exec(r(V,W)))?re=u(ee[1].substr(1),V,!0):(ee=v.exec(r(V,W)))?re=u(ee[1],V,!1):re=p(V),i.set(ie,re),t(re,Z)}function t(Z,W){if(typeof W=="string")return Z;const V=function(ie,re){return(0,D.$8f)(ie,W.base,!P.$k)?Z((0,k.$Te)(ie.substr(W.base.length),I.sep),re):null};return V.allBasenames=Z.allBasenames,V.allPaths=Z.allPaths,V.basenames=Z.basenames,V.patterns=Z.patterns,V}function r(Z,W){return W.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function a(Z,W){return function(V,ie){return typeof V=="string"&&V.endsWith(Z)?W:null}}function E(Z,W){const V=`/${Z}`,ie=`\\${Z}`,re=function(ae,K){return typeof ae!="string"?null:K?K===Z?W:null:ae===Z||ae.endsWith(V)||ae.endsWith(ie)?W:null},ee=[Z];return re.basenames=ee,re.patterns=[W],re.allBasenames=ee,re}function y(Z,W){const V=x(Z.slice(1,-1).split(",").map(K=>s(K,W)).filter(K=>K!==n),Z),ie=V.length;if(!ie)return n;if(ie===1)return V[0];const re=function(K,q){for(let j=0,F=V.length;j<F;j++)if(V[j](K,q))return Z;return null},ee=V.find(K=>!!K.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=V.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return ae.length&&(re.allPaths=ae),re}function u(Z,W,V){const ie=I.sep===I.$gc.sep,re=ie?Z:Z.replace(m,I.sep),ee=I.sep+re,ae=I.$gc.sep+Z;let K;return V?K=function(q,j){return typeof q=="string"&&(q===re||q.endsWith(ee)||!ie&&(q===Z||q.endsWith(ae)))?W:null}:K=function(q,j){return typeof q=="string"&&(q===re||!ie&&q===Z)?W:null},K.allPaths=[(V?"*/":"./")+Z],K}function p(Z){try{const W=new RegExp(`^${b(Z)}$`);return function(V){return W.lastIndex=0,typeof V=="string"&&W.test(V)?Z:null}}catch{return n}}function R(Z,W,V){return!Z||typeof W!="string"?!1:N(Z)(W,void 0,V)}e.$Lj=R;function N(Z,W={}){if(!Z)return o;if(typeof Z=="string"||T(Z)){const V=s(Z,W);if(V===n)return o;const ie=function(re,ee){return!!V(re,ee)};return V.allBasenames&&(ie.allBasenames=V.allBasenames),V.allPaths&&(ie.allPaths=V.allPaths),ie}return Y(Z,W)}e.$Mj=N;function T(Z){const W=Z;return W?typeof W.base=="string"&&typeof W.pattern=="string":!1}e.$Nj=T;function M(Z){return Z.allBasenames||[]}e.$Oj=M;function U(Z){return Z.allPaths||[]}e.$Pj=U;function Y(Z,W){const V=x(Object.getOwnPropertyNames(Z).map(K=>Q(K,Z[K],W)).filter(K=>K!==n)),ie=V.length;if(!ie)return n;if(!V.some(K=>!!K.requiresSiblings)){if(ie===1)return V[0];const K=function(F,B){let z;for(let _=0,G=V.length;_<G;_++){const J=V[_](F,B);if(typeof J=="string")return J;(0,L.$Sg)(J)&&(z||(z=[]),z.push(J))}return z?(async()=>{for(const _ of z){const G=await _;if(typeof G=="string")return G}return null})():null},q=V.find(F=>!!F.allBasenames);q&&(K.allBasenames=q.allBasenames);const j=V.reduce((F,B)=>B.allPaths?F.concat(B.allPaths):F,[]);return j.length&&(K.allPaths=j),K}const re=function(K,q,j){let F,B;for(let z=0,_=V.length;z<_;z++){const G=V[z];G.requiresSiblings&&j&&(q||(q=(0,I.$nc)(K)),F||(F=q.substr(0,q.length-(0,I.$oc)(K).length)));const J=G(K,q,F,j);if(typeof J=="string")return J;(0,L.$Sg)(J)&&(B||(B=[]),B.push(J))}return B?(async()=>{for(const z of B){const _=await z;if(typeof _=="string")return _}return null})():null},ee=V.find(K=>!!K.allBasenames);ee&&(re.allBasenames=ee.allBasenames);const ae=V.reduce((K,q)=>q.allPaths?K.concat(q.allPaths):K,[]);return ae.length&&(re.allPaths=ae),re}function Q(Z,W,V){if(W===!1)return n;const ie=s(Z,V);if(ie===n)return n;if(typeof W=="boolean")return ie;if(W){const re=W.when;if(typeof re=="string"){const ee=(ae,K,q,j)=>{if(!j||!ie(ae,K))return null;const F=re.replace("$(basename)",()=>q),B=j(F);return(0,L.$Sg)(B)?B.then(z=>z?Z:null):B?Z:null};return ee.requiresSiblings=!0,ee}}return ie}function x(Z,W){const V=Z.filter(K=>!!K.basenames);if(V.length<2)return Z;const ie=V.reduce((K,q)=>{const j=q.basenames;return j?K.concat(j):K},[]);let re;if(W){re=[];for(let K=0,q=ie.length;K<q;K++)re.push(W)}else re=V.reduce((K,q)=>{const j=q.patterns;return j?K.concat(j):K},[]);const ee=function(K,q){if(typeof K!="string")return null;if(!q){let F;for(F=K.length;F>0;F--){const B=K.charCodeAt(F-1);if(B===47||B===92)break}q=K.substr(F)}const j=ie.indexOf(q);return j!==-1?re[j]:null};ee.basenames=ie,ee.patterns=re,ee.allBasenames=ie;const ae=Z.filter(K=>!K.basenames);return ae.push(ee),ae}function H(Z,W){return(0,O.$ub)(Z,W,(V,ie)=>typeof V=="string"&&typeof ie=="string"?V===ie:typeof V!="string"&&typeof ie!="string"?V.base===ie.base&&V.pattern===ie.pattern:!1)}e.$Qj=H}),define(le[92],he([0,1,14,10]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function D(S){return S.toJSON()}class A{constructor(m){this.a=m}transformIncoming(m){const l=this.a.transformIncoming(m);return l===m?m:D(L.URI.from(l))}transformOutgoing(m){const l=this.a.transformOutgoing(m);return l===m?m:D(L.URI.from(l))}transformOutgoingURI(m){const l=this.a.transformOutgoing(m);return l===m?m:L.URI.from(l)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.$4m=A,e.$5m=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function I(S,m,l){if(!S||l>200)return null;if(typeof S=="object"){if(S instanceof L.URI)return m.transformOutgoing(S);for(const $ in S)if(Object.hasOwnProperty.call(S,$)){const b=I(S[$],m,l+1);b!==null&&(S[$]=b)}}return null}function P(S,m){const l=I(S,m,0);return l===null?S:l}e.$6m=P;function k(S,m,l,$){if(!S||$>200)return null;if(typeof S=="object"){if(S.$mid===1)return l?L.URI.revive(m.transformIncoming(S)):m.transformIncoming(S);if(S instanceof O.$je)return null;for(const b in S)if(Object.hasOwnProperty.call(S,b)){const w=k(S[b],m,l,$+1);w!==null&&(S[b]=w)}}return null}function g(S,m){const l=k(S,m,!1,0);return l===null?S:l}e.$7m=g;function C(S,m){const l=k(S,m,!0,0);return l===null?S:l}e.$8m=C}),define(le[143],he([0,1,36,48,32,131,5]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_m=e.$$m=e.$0m=void 0,e.$0m=new class{c(m){return this.a||(this.a=L.$_h.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(m)}value(){if(this.b===void 0){let m=0,l=0;const $=(0,O.networkInterfaces)();for(const b in $){const w=$[b];if(w)for(const{mac:h,internal:f}of w)f||(l+=1,this.c(h.toUpperCase())&&(m+=1))}this.b=l>0?m/l:0}return this.b}};let P;async function k(m){return P||(P=(async()=>await g(m)||D.$qg())()),P}e.$$m=k;async function g(m){try{const l=await new Promise((b,w)=>{se(["crypto"],b,w)}),$=(0,A.$9m)();return l.createHash("sha256").update($,"utf8").digest("hex")}catch(l){m(l);return}}const C="Software\\Microsoft\\SQMClient";async function S(m){if(I.$i){const l=await new Promise(($,b)=>{se(["@vscode/windows-registry"],$,b)});try{return l.GetStringRegKey("HKEY_LOCAL_MACHINE",C,"MachineId")||""}catch($){return m($),""}}return""}e.$_m=S}),define(le[31],he([0,1,54,36,268,6,49,88,16,5,20,10]),function(se,e,O,L,D,A,I,P,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(Q){Q[Q.UNLINK=0]="UNLINK",Q[Q.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function l(Q,x=m.UNLINK,H){if((0,I.$$f)(Q))throw new Error("rimraf - will refuse to recursively delete root");return x===m.UNLINK?b(Q):$(Q,H)}async function $(Q,x=(0,I.$dg)((0,L.tmpdir)())){try{try{await O.promises.rename(Q,x)}catch(H){return H.code==="ENOENT"?void 0:b(Q)}b(x).catch(H=>{})}catch(H){if(H.code!=="ENOENT")throw H}}async function b(Q){return(0,D.promisify)(O.rm)(Q,{recursive:!0,force:!0,maxRetries:3})}function w(Q){if((0,I.$$f)(Q))throw new Error("rimraf - will refuse to recursively delete root");O.rmSync(Q,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=w;async function h(Q,x){return c(await(x?f(Q):(0,D.promisify)(O.readdir)(Q)))}async function f(Q){try{return await(0,D.promisify)(O.readdir)(Q,{withFileTypes:!0})}catch(Z){console.warn("[node.js fs] readdir with filetypes failed with error: ",Z)}const x=[],H=await h(Q);for(const Z of H){let W=!1,V=!1,ie=!1;try{const re=await e.Promises.lstat((0,k.$jc)(Q,Z));W=re.isFile(),V=re.isDirectory(),ie=re.isSymbolicLink()}catch(re){console.warn("[node.js fs] unexpected error from lstat after readdir: ",re)}x.push({name:Z,isFile:()=>W,isDirectory:()=>V,isSymbolicLink:()=>ie})}return x}function d(Q){return c(O.readdirSync(Q))}e.readdirSync=d;function c(Q){return Q.map(x=>typeof x=="string"?g.$j?(0,P.$Gl)(x):x:(x.name=g.$j?(0,P.$Gl)(x.name):x.name,x))}async function v(Q){const x=await h(Q),H=[];for(const Z of x)await o.existsDirectory((0,k.$jc)(Q,Z))&&H.push(Z);return H}function i(Q,x=1e3){return new Promise(H=>{let Z=!1;const W=setInterval(()=>{Z||(Z=!0,O.access(Q,V=>{Z=!1,V&&(clearInterval(W),H(void 0))}))},x)})}e.whenDeleted=i;var o;(function(Q){async function x(W){let V;try{if(V=await e.Promises.lstat(W),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(W),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(ie){if(ie.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(g.$i&&ie.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(W)),symbolicLink:{dangling:!1}}}catch(re){if(re.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw re}throw ie}}Q.stat=x;async function H(W){try{const{stat:V,symbolicLink:ie}=await Q.stat(W);return V.isFile()&&ie?.dangling!==!0}catch{}return!1}Q.existsFile=H;async function Z(W){try{const{stat:V,symbolicLink:ie}=await Q.stat(W);return V.isDirectory()&&ie?.dangling!==!0}catch{}return!1}Q.existsDirectory=Z})(o||(e.SymlinkSupport=o={}));const n=new A.$ch;function s(Q,x,H){return n.queueFor(S.URI.file(Q),()=>{const Z=y(H);return new Promise((W,V)=>a(Q,x,Z,ie=>ie?V(ie):W()))},C.$yg)}let t=!0;function r(Q){t=Q}e.configureFlushOnWrite=r;function a(Q,x,H,Z){if(!t)return O.writeFile(Q,x,{mode:H.mode,flag:H.flag},Z);O.open(Q,H.flag,H.mode,(W,V)=>{if(W)return Z(W);O.writeFile(V,x,ie=>{if(ie)return O.close(V,()=>Z(ie));O.fdatasync(V,re=>(re&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",re),r(!1)),O.close(V,ee=>Z(ee))))})})}function E(Q,x,H){const Z=y(H);if(!t)return O.writeFileSync(Q,x,{mode:Z.mode,flag:Z.flag});const W=O.openSync(Q,Z.flag,Z.mode);try{O.writeFileSync(W,x);try{O.fdatasyncSync(W)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),r(!1)}}finally{O.closeSync(W)}}e.writeFileSync=E;function y(Q){return Q?{mode:typeof Q.mode=="number"?Q.mode:438,flag:typeof Q.flag=="string"?Q.flag:"w"}:{mode:438,flag:"w"}}async function u(Q,x,H=6e4){if(Q!==x)try{g.$i&&typeof H=="number"?await p(Q,x,Date.now(),H):await(0,D.promisify)(O.rename)(Q,x)}catch(Z){if(Q.toLowerCase()!==x.toLowerCase()&&Z.code==="EXDEV"||Q.endsWith("."))await R(Q,x,{preserveSymlinks:!1}),await l(Q,m.MOVE);else throw Z}}async function p(Q,x,H,Z,W=0){try{return await(0,D.promisify)(O.rename)(Q,x)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-H>=Z)throw console.error(`[node.js fs] rename failed after ${W} retries with error: ${V}`),V;if(W===0){let ie=!1;try{const{stat:re}=await o.stat(x);re.isFile()||(ie=!0)}catch{}if(ie)throw V}return await(0,A.$7g)(Math.min(100,W*10)),p(Q,x,H,Z,W+1)}}async function R(Q,x,H){return T(Q,x,{root:{source:Q,target:x},options:H,handledSourcePaths:new Set})}const N=511;async function T(Q,x,H){if(H.handledSourcePaths.has(Q))return;H.handledSourcePaths.add(Q);const{stat:Z,symbolicLink:W}=await o.stat(Q);if(W){if(H.options.preserveSymlinks)try{return await Y(Q,x,H)}catch{}if(W.dangling)return}return Z.isDirectory()?M(Q,x,Z.mode&N,H):U(Q,x,Z.mode&N)}async function M(Q,x,H,Z){await e.Promises.mkdir(x,{recursive:!0,mode:H});const W=await h(Q);for(const V of W)await T((0,k.$jc)(Q,V),(0,k.$jc)(x,V),Z)}async function U(Q,x,H){await e.Promises.copyFile(Q,x),await e.Promises.chmod(x,H)}async function Y(Q,x,H){let Z=await e.Promises.readlink(Q);(0,I.$8f)(Z,H.root.source,!g.$k)&&(Z=(0,k.$jc)(H.root.target,Z.substr(H.root.source.length+1))),await e.Promises.symlink(Z,x)}e.Promises=new class{get access(){return(0,D.promisify)(O.access)}get stat(){return(0,D.promisify)(O.stat)}get lstat(){return(0,D.promisify)(O.lstat)}get utimes(){return(0,D.promisify)(O.utimes)}get read(){return(Q,x,H,Z,W)=>new Promise((V,ie)=>{O.read(Q,x,H,Z,W,(re,ee,ae)=>re?ie(re):V({bytesRead:ee,buffer:ae}))})}get readFile(){return(0,D.promisify)(O.readFile)}get write(){return(Q,x,H,Z,W)=>new Promise((V,ie)=>{O.write(Q,x,H,Z,W,(re,ee,ae)=>re?ie(re):V({bytesWritten:ee,buffer:ae}))})}get appendFile(){return(0,D.promisify)(O.appendFile)}get fdatasync(){return(0,D.promisify)(O.fdatasync)}get truncate(){return(0,D.promisify)(O.truncate)}get copyFile(){return(0,D.promisify)(O.copyFile)}get open(){return(0,D.promisify)(O.open)}get close(){return(0,D.promisify)(O.close)}get symlink(){return(0,D.promisify)(O.symlink)}get readlink(){return(0,D.promisify)(O.readlink)}get chmod(){return(0,D.promisify)(O.chmod)}get mkdir(){return(0,D.promisify)(O.mkdir)}get unlink(){return(0,D.promisify)(O.unlink)}get rmdir(){return(0,D.promisify)(O.rmdir)}get realpath(){return(0,D.promisify)(O.realpath)}async exists(Q){try{return await e.Promises.access(Q),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return v}get writeFile(){return s}get rm(){return l}get rename(){return u}get copy(){return R}}}),define(le[144],he([0,1,54,16,5,27,31]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=void 0;function P(m){if(D.$k)return m;const l=(0,L.$mc)(m);if(m===l)return m;const $=((0,L.$nc)(m)||m).toLowerCase();try{const w=(0,I.readdirSync)(l).filter(h=>h.toLowerCase()===$);if(w.length===1){const h=P(l);if(h)return(0,L.$jc)(h,w[0])}else if(w.length>1){const h=w.indexOf($);if(h>=0){const f=P(l);if(f)return(0,L.$jc)(f,w[h])}}}catch{}return null}e.$tq=P;async function k(m){if(D.$k)return m;const l=(0,L.$mc)(m);if(m===l)return m;const $=((0,L.$nc)(m)||m).toLowerCase();try{const w=(await I.Promises.readdir(l)).filter(h=>h.toLowerCase()===$);if(w.length===1){const h=await k(l);if(h)return(0,L.$jc)(h,w[0])}else if(w.length>1){const h=w.indexOf($);if(h>=0){const f=await k(l);if(f)return(0,L.$jc)(f,w[h])}}}catch{}return null}e.$uq=k;async function g(m){try{return await I.Promises.realpath(m)}catch{const $=S(m);return await I.Promises.access($,O.constants.R_OK),$}}e.$vq=g;function C(m){try{return O.realpathSync(m)}catch{const $=S(m);return O.accessSync($,O.constants.R_OK),$}}e.$wq=C;function S(m){return(0,A.$Ue)((0,L.$hc)(m),L.sep)}}),define(le[145],he([0,1,16,5,37,90,12,31]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function k(S=D.env){return S.comspec||"cmd.exe"}e.$Tl=k;function g(S){let m=[],l=!1;const $=function(b){if(l){m.push(b);return}(!S.send(b,h=>{if(h&&console.error(h),l=!1,m.length>0){const f=m.slice(0);m=[],f.forEach(d=>$(d))}})||L.$i)&&(l=!0)};return{send:$}}e.$Ul=g;var C;(function(S){async function m(l,$,b){if(O.$ic(l))return l;if($===void 0&&($=D.cwd()),O.$mc(l)!=="."||(b===void 0&&I.$If(D.env.PATH)&&(b=D.env.PATH.split(O.$tc)),b===void 0||b.length===0))return O.$jc($,l);async function h(f){if(await P.Promises.exists(f)){let d;try{d=await P.Promises.stat(f)}catch(c){c.message.startsWith("EACCES")&&(d=await P.Promises.lstat(f))}return d?!d.isDirectory():!1}return!1}for(const f of b){let d;if(O.$ic(f)?d=O.$jc(f,l):d=O.$jc($,f,l),await h(d))return d;let c=d+".com";if(await h(c)||(c=d+".exe",await h(c)))return c}return O.$jc($,l)}S.findExecutable=m})(C||(e.win32=C={}))}),define(le[146],he([0,1,67,23]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;function D(I){return new Promise((P,k)=>{let g;const C=new Map;function S(l,$,b,w,h){const f=C.get($);if(l===I||f){const d={name:m(b),cmd:b,pid:l,ppid:$,load:w,mem:h};C.set(l,d),l===I&&(g=d),f&&(f.children||(f.children=[]),f.children.push(d),f.children.length>1&&(f.children=f.children.sort((c,v)=>c.pid-v.pid)))}}function m(l){const $=/--utility-sub-type=network/i,b=/--crashes-directory/i,w=/\\pipe\\winpty-control/i,h=/conhost\.exe.+--headless/i,f=/--type=([a-zA-Z-]+)/;if(b.exec(l))return"electron-crash-reporter";if(w.exec(l))return"winpty-agent";if(h.exec(l))return"conpty-agent";let d=f.exec(l);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(l)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const c=/[a-zA-Z-]+\.js/g;let v="";do d=c.exec(l),d&&(v+=d+" ");while(d);return v&&l.indexOf("node ")<0&&l.indexOf("node.exe")<0?`electron-nodejs (${v})`:l}if(process.platform==="win32"){const l=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,b)=>{se(["@vscode/windows-process-tree"],$,b)}).then($=>{$.getProcessList(I,b=>{if(!b){k(new Error(`Root process ${I} not found`));return}$.getProcessCpuUsage(b,w=>{const h=new Map;w.forEach(f=>{const d=l(f.commandLine||"");h.set(f.pid,{name:m(d),cmd:d,pid:f.pid,ppid:f.ppid,load:f.cpu||0,mem:f.memory||0})}),g=h.get(I),g?(h.forEach(f=>{const d=h.get(f.ppid);d&&(d.children||(d.children=[]),d.children.push(f))}),h.forEach(f=>{f.children&&(f.children=f.children.sort((d,c)=>d.pid-c.pid))}),P(g)):k(new Error(`Root process ${I} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let l=function(){let $=[g];const b=[];for(;$.length;){const h=$.shift();h&&(b.push(h.pid),h.children&&($=$.concat(h.children)))}let w=JSON.stringify(L.$og.asFileUri("vs/base/node/cpuUsage.sh").fsPath);w+=" "+b.join(" "),(0,O.exec)(w,{},(h,f,d)=>{if(h||d)k(h||new Error(d.toString()));else{const c=f.toString().split(`
`);for(let v=0;v<b.length;v++){const i=C.get(b[v]);i.load=parseFloat(c[v])}if(!g){k(new Error(`Root process ${I} not found`));return}P(g)}})};(0,O.exec)("which ps",{},($,b,w)=>{if($||w)if(process.platform!=="linux")k($||new Error(w.toString()));else{const h=JSON.stringify(L.$og.asFileUri("vs/base/node/ps.sh").fsPath);(0,O.exec)(h,{},(f,d,c)=>{f||c?k(f||new Error(c.toString())):(A(d,S),l())})}else{const h=b.toString().trim(),f="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,O.exec)(`${h} ${f}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,c,v)=>{d||v&&!v.includes("screen size is bogus")?k(d||new Error(v.toString())):(A(c,S),process.platform==="linux"?l():g?P(g):k(new Error(`Root process ${I} not found`)))})}})}})}e.$5r=D;function A(I,P){const k=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=I.toString().split(`
`);for(const C of g){const S=k.exec(C.trim());S&&S.length===6&&P(parseInt(S[1]),parseInt(S[2]),S[5],parseFloat(S[3]),parseFloat(S[4]))}}});var pe=this&&this.__decorate||function(se,e,O,L){var D=arguments.length,A=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,O):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(se,e,O,L);else for(var P=se.length-1;P>=0;P--)(I=se[P])&&(A=(D<3?I(A):D>3?I(e,O,A):I(e,O))||A);return D>3&&A&&Object.defineProperty(e,O,A),A};define(le[40],he([0,1,17,6,14,26,85,7,3,2,66,27,12]),function(se,e,O,L,D,A,I,P,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var l;(function(W){W[W.Promise=100]="Promise",W[W.PromiseCancel=101]="PromiseCancel",W[W.EventListen=102]="EventListen",W[W.EventDispose=103]="EventDispose"})(l||(l={}));function $(W){switch(W){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var b;(function(W){W[W.Initialize=200]="Initialize",W[W.PromiseSuccess=201]="PromiseSuccess",W[W.PromiseError=202]="PromiseError",W[W.PromiseErrorObj=203]="PromiseErrorObj",W[W.EventFire=204]="EventFire"})(b||(b={}));function w(W){switch(W){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(W){W[W.Uninitialized=0]="Uninitialized",W[W.Idle=1]="Idle"})(h||(h={}));function f(W){let V=0;for(let ie=0;;ie+=7){const re=W.read(1);if(V|=(re.buffer[0]&127)<<ie,!(re.buffer[0]&128))return V}}const d=n(0);function c(W,V){if(V===0){W.write(d);return}let ie=0;for(let ee=V;ee!==0;ee=ee>>>7)ie++;const re=D.$je.alloc(ie);for(let ee=0;V!==0;ee++)re.buffer[ee]=V&127,V=V>>>7,V>0&&(re.buffer[ee]|=128);W.write(re)}class v{constructor(V){this.b=V,this.a=0}read(V){const ie=this.b.slice(this.a,this.a+V);return this.a+=ie.byteLength,ie}}e.$Dh=v;class i{constructor(){this.a=[]}get buffer(){return D.$je.concat(this.a)}write(V){this.a.push(V)}}e.$Eh=i;var o;(function(W){W[W.Undefined=0]="Undefined",W[W.String=1]="String",W[W.Buffer=2]="Buffer",W[W.VSBuffer=3]="VSBuffer",W[W.Array=4]="Array",W[W.Object=5]="Object",W[W.Int=6]="Int"})(o||(o={}));function n(W){const V=D.$je.alloc(1);return V.writeUInt8(W,0),V}const s={Undefined:n(o.Undefined),String:n(o.String),Buffer:n(o.Buffer),VSBuffer:n(o.VSBuffer),Array:n(o.Array),Object:n(o.Object),Uint:n(o.Int)},t=typeof Buffer<"u";function r(W,V){if(typeof V>"u")W.write(s.Undefined);else if(typeof V=="string"){const ie=D.$je.fromString(V);W.write(s.String),c(W,ie.byteLength),W.write(ie)}else if(t&&Buffer.isBuffer(V)){const ie=D.$je.wrap(V);W.write(s.Buffer),c(W,ie.byteLength),W.write(ie)}else if(V instanceof D.$je)W.write(s.VSBuffer),c(W,V.byteLength),W.write(V);else if(Array.isArray(V)){W.write(s.Array),c(W,V.length);for(const ie of V)r(W,ie)}else if(typeof V=="number"&&(V|0)===V)W.write(s.Uint),c(W,V);else{const ie=D.$je.fromString(JSON.stringify(V));W.write(s.Object),c(W,ie.byteLength),W.write(ie)}}e.$Fh=r;function a(W){switch(W.read(1).readUInt8(0)){case o.Undefined:return;case o.String:return W.read(f(W)).toString();case o.Buffer:return W.read(f(W)).buffer;case o.VSBuffer:return W.read(f(W));case o.Array:{const ie=f(W),re=[];for(let ee=0;ee<ie;ee++)re.push(a(W));return re}case o.Object:return JSON.parse(W.read(f(W)).toString());case o.Int:return f(W)}}e.$Gh=a;class E{constructor(V,ie,re=null,ee=1e3){this.h=V,this.j=ie,this.k=re,this.l=ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ae=>this.q(ae)),this.m({type:200})}registerChannel(V,ie){this.b.set(V,ie),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const ie=this.o([V.type]);this.k?.logOutgoing(ie,0,1,w(V.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([V.type,V.id],V.data);this.k?.logOutgoing(ie,V.id,1,w(V.type),V.data);return}}}o(V,ie=void 0){const re=new i;return r(re,V),r(re,ie),this.p(re.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const ie=new v(V),re=a(ie),ee=a(ie),ae=re[0];switch(ae){case 100:return this.k?.logIncoming(V.byteLength,re[1],1,`${$(ae)}: ${re[2]}.${re[3]}`,ee),this.s({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 102:return this.k?.logIncoming(V.byteLength,re[1],1,`${$(ae)}: ${re[2]}.${re[3]}`,ee),this.t({type:ae,id:re[1],channelName:re[2],name:re[3],arg:ee});case 101:return this.k?.logIncoming(V.byteLength,re[1],1,`${$(ae)}`),this.u({type:ae,id:re[1]});case 103:return this.k?.logIncoming(V.byteLength,re[1],1,`${$(ae)}`),this.u({type:ae,id:re[1]})}}s(V){const ie=this.b.get(V.channelName);if(!ie){this.v(V);return}const re=new A.$6d;let ee;try{ee=ie.call(this.j,V.name,V.arg,re.token)}catch(q){ee=Promise.reject(q)}const ae=V.id;ee.then(q=>{this.m({id:ae,data:q,type:201})},q=>{q instanceof Error?this.m({id:ae,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:ae,data:q,type:203})}).finally(()=>{K.dispose(),this.d.delete(V.id)});const K=(0,g.$Rc)(()=>re.cancel());this.d.set(V.id,K)}t(V){const ie=this.b.get(V.channelName);if(!ie){this.v(V);return}const re=V.id,ae=ie.listen(this.j,V.name,V.arg)(K=>this.m({id:re,data:K,type:204}));this.d.set(V.id,ae)}u(V){const ie=this.d.get(V.id);ie&&(ie.dispose(),this.d.delete(V.id))}v(V){let ie=this.g.get(V.channelName);ie||(ie=[],this.g.set(V.channelName,ie));const re=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:V,timeoutTimer:re})}w(V){const ie=this.g.get(V);if(ie){for(const re of ie)switch(clearTimeout(re.timeoutTimer),re.request.type){case 100:this.s(re.request);break;case 102:this.t(re.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=E;var y;(function(W){W[W.LocalSide=0]="LocalSide",W[W.OtherSide=1]="OtherSide"})(y||(e.RequestInitiator=y={}));class u{constructor(V,ie=null){this.l=V,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new k.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(re=>this.s(re)),this.j=ie}getChannel(V){const ie=this;return{call(re,ee,ae){return ie.a?Promise.reject(new P.$5):ie.m(V,re,ee,ae)},listen(re,ee){return ie.a?k.Event.None:ie.o(V,re,ee)}}}m(V,ie,re,ee=A.CancellationToken.None){const ae=this.g++,q={id:ae,type:100,channelName:V,name:ie,arg:re};if(ee.isCancellationRequested)return Promise.reject(new P.$5);let j;return new Promise((B,z)=>{if(ee.isCancellationRequested)return z(new P.$5);const _=()=>{const ne=ce=>{switch(ce.type){case 201:this.f.delete(ae),B(ce.data);break;case 202:{this.f.delete(ae);const de=new Error(ce.data.message);de.stack=Array.isArray(ce.data.stack)?ce.data.stack.join(`
`):ce.data.stack,de.name=ce.data.name,z(de);break}case 203:this.f.delete(ae),z(ce.data);break}};this.f.set(ae,ne),this.p(q)};let G=null;this.b===h.Idle?_():(G=(0,L.$Tg)(ne=>this.u()),G.then(()=>{G=null,_()}));const J=()=>{G?(G.cancel(),G=null):this.p({id:ae,type:101}),z(new P.$5)},te=ee.onCancellationRequested(J);j=(0,g.$Qc)((0,g.$Rc)(J),te),this.d.add(j)}).finally(()=>{j.dispose(),this.d.delete(j)})}o(V,ie,re){const ee=this.g++,K={id:ee,type:102,channelName:V,name:ie,arg:re};let q=null;const j=new k.$Vd({onWillAddFirstListener:()=>{q=(0,L.$Tg)(B=>this.u()),q.then(()=>{q=null,this.d.add(j),this.p(K)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(j),this.p({id:ee,type:103}))}}),F=B=>j.fire(B.data);return this.f.set(ee,F),j.event}p(V){switch(V.type){case 100:case 102:{const ie=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(ie,V.id,0,`${$(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const ie=this.q([V.type,V.id]);this.j?.logOutgoing(ie,V.id,0,$(V.type));return}}}q(V,ie=void 0){const re=new i;return r(re,V),r(re,ie),this.r(re.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const ie=new v(V),re=a(ie),ee=a(ie),ae=re[0];switch(ae){case 200:return this.j?.logIncoming(V.byteLength,0,0,w(ae)),this.t({type:re[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,re[1],0,w(ae),ee),this.t({type:re[0],id:re[1],data:ee})}}t(V){if(V.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return k.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,g.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=u,pe([I.$xh],u.prototype,"onDidInitializePromise",null);class p{get connections(){const V=[];return this.f.forEach(ie=>V.push(ie)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new k.$Vd,this.onDidAddConnection=this.g.event,this.h=new k.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new g.$Sc,this.j.add(V(({protocol:ie,onDidClientDisconnect:re})=>{const ee=k.Event.once(ie.onMessage);this.j.add(ee(ae=>{const K=new v(ae),q=a(K),j=new E(ie,q),F=new u(ie);this.a.forEach((z,_)=>j.registerChannel(_,z));const B={channelServer:j,channelClient:F,ctx:q};this.f.add(B),this.g.fire(B),this.j.add(re(()=>{j.dispose(),F.dispose(),this.f.delete(B),this.h.fire(B)}))}))}))}getChannel(V,ie){const re=this;return{call(ee,ae,K){let q;if((0,m.$Wf)(ie)){const F=(0,O.$4b)(re.connections.filter(ie));q=F?Promise.resolve(F):k.Event.toPromise(k.Event.filter(re.onDidAddConnection,ie))}else q=ie.routeCall(re,ee,ae);const j=q.then(F=>F.channelClient.getChannel(V));return N(j).call(ee,ae,K)},listen(ee,ae){if((0,m.$Wf)(ie))return re.k(V,ie,ee,ae);const K=ie.routeEvent(re,ee,ae).then(q=>q.channelClient.getChannel(V));return N(K).listen(ee,ae)}}}k(V,ie,re,ee){const ae=this;let K;const q=new k.$Vd({onWillAddFirstListener:()=>{K=new g.$Sc;const j=new k.$2d,F=new Map,B=_=>{const J=_.channelClient.getChannel(V).listen(re,ee),te=j.add(J);F.set(_,te)},z=_=>{const G=F.get(_);G&&(G.dispose(),F.delete(_))};ae.connections.filter(ie).forEach(B),k.Event.filter(ae.onDidAddConnection,ie)(B,void 0,K),ae.onDidRemoveConnection(z,void 0,K),j.event(q.fire,q,K),K.add(j)},onDidRemoveLastListener:()=>{K?.dispose(),K=void 0}});return q.event}registerChannel(V,ie){this.a.set(V,ie);for(const re of this.f)re.channelServer.registerChannel(V,ie)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=p;class R{constructor(V,ie,re=null){const ee=new i;r(ee,ie),V.send(ee.buffer),this.a=new u(V,re),this.d=new E(V,ie,re)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,ie){this.d.registerChannel(V,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=R;function N(W){return{call(V,ie,re){return W.then(ee=>ee.call(V,ie,re))},listen(V,ie){const re=new k.$5d;return W.then(ee=>re.input=ee.listen(V,ie)),re.event}}}e.$Lh=N;function T(W){let V=!1;return{call(ie,re,ee){return V?W.call(ie,re,ee):(0,L.$7g)(0).then(()=>V=!0).then(()=>W.call(ie,re,ee))},listen(ie,re){if(V)return W.listen(ie,re);const ee=new k.$5d;return(0,L.$7g)(0).then(()=>V=!0).then(()=>ee.input=W.listen(ie,re)),ee.event}}}e.$Mh=T;class M{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const ie of V.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await k.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$Nh=M;var U;(function(W){function V(ae,K,q){const j=ae,F=q&&q.disableMarshalling,B=new Map;for(const z in j)re(z)&&B.set(z,k.Event.buffer(j[z],!0,void 0,K));return new class{listen(z,_,G){const J=B.get(_);if(J)return J;if(ee(_)){const te=j[_];if(typeof te=="function")return te.call(j,G)}throw new P.$bb(`Event not found: ${_}`)}call(z,_,G){const J=j[_];if(typeof J=="function"){if(!F&&Array.isArray(G))for(let ne=0;ne<G.length;ne++)G[ne]=(0,C.$Ch)(G[ne]);let te=J.apply(j,G);return te instanceof Promise||(te=Promise.resolve(te)),te}throw new P.$bb(`Method not found: ${_}`)}}}W.fromService=V;function ie(ae,K){const q=K&&K.disableMarshalling;return new Proxy({},{get(j,F){if(typeof F=="string")return K?.properties?.has(F)?K.properties.get(F):ee(F)?function(B){return ae.listen(F,B)}:re(F)?ae.listen(F):async function(...B){let z;K&&!(0,m.$Rf)(K.context)?z=[K.context,...B]:z=B;const _=await ae.call(F,z);return q?_:(0,C.$Ch)(_)};throw new P.$bb(`Property not found: ${String(F)}`)}})}W.toService=ie;function re(ae){return ae[0]==="o"&&ae[1]==="n"&&S.$$e(ae.charCodeAt(2))}function ee(ae){return/^onDynamic/.test(ae)&&S.$$e(ae.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const Y=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(W){if(Array.isArray(W))return W;if(W&&typeof W=="object"&&typeof W.toString=="function"){const V=W.toString();if(V!=="[object Object]")return V}return W}function x(W){return Array.isArray(W)?W.map(Q):Q(W)}function H(W,V,ie,re,ee,ae,K){K=x(K);const q=Y[ee],j=q[re%q.length];let F=[`%c[${W}]%c[${String(V).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(re).padStart(5," ")} - ${ae}`,"color: darkgreen","color: grey","color: grey",`color: ${j}`];/\($/.test(ae)?(F=F.concat(K),F.push(")")):F.push(K),console.log.apply(console,F)}class Z{constructor(V,ie){this.d=V,this.f=ie,this.a=0,this.b=0}logOutgoing(V,ie,re,ee,ae){this.b+=V,H(this.d,this.b,V,ie,re,ee,ae)}logIncoming(V,ie,re,ee,ae){this.a+=V,H(this.f,this.a,V,ie,re,ee,ae)}}e.$Oh=Z}),define(le[68],he([0,1,14,3,2,40]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.ProtocolConstants=e.$Ph=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var I;(function(s){s.Created="created",s.Read="read",s.Write="write",s.Open="open",s.Error="error",s.Close="close",s.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",s.NodeEndReceived="nodeEndReceived",s.NodeEndSent="nodeEndSent",s.NodeDrainBegin="nodeDrainBegin",s.NodeDrainEnd="nodeDrainEnd",s.zlibInflateError="zlibInflateError",s.zlibInflateData="zlibInflateData",s.zlibInflateInitialWrite="zlibInflateInitialWrite",s.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",s.zlibInflateWrite="zlibInflateWrite",s.zlibInflateFlushFired="zlibInflateFlushFired",s.zlibDeflateError="zlibDeflateError",s.zlibDeflateData="zlibDeflateData",s.zlibDeflateWrite="zlibDeflateWrite",s.zlibDeflateFlushFired="zlibDeflateFlushFired",s.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",s.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",s.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",s.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",s.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",s.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",s.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",s.ProtocolHeaderRead="protocolHeaderRead",s.ProtocolMessageRead="protocolMessageRead",s.ProtocolHeaderWrite="protocolHeaderWrite",s.ProtocolMessageWrite="protocolMessageWrite",s.ProtocolWrite="protocolWrite"})(I||(e.SocketDiagnosticsEventType=I={}));var P;(function(s){s.enableDiagnostics=!1,s.records=[];const t=new WeakMap;let r=0;function a(y,u){if(!t.has(y)){const p=String(++r);t.set(y,p)}return t.get(y)}function E(y,u,p,R){if(!s.enableDiagnostics)return;const N=a(y,u);if(R instanceof O.$je||R instanceof Uint8Array||R instanceof ArrayBuffer||ArrayBuffer.isView(R)){const T=O.$je.alloc(R.byteLength);T.set(R),s.records.push({timestamp:Date.now(),id:N,label:u,type:p,buff:T})}else s.records.push({timestamp:Date.now(),id:N,label:u,type:p,data:R})}s.traceSocketEvent=E})(P||(e.SocketDiagnostics=P={}));var k;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(k||(e.SocketCloseEventType=k={}));let g=null;function C(){return g||(g=O.$je.alloc(0)),g}class S{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(t){this.a.push(t),this.b+=t.byteLength}read(t){return this.c(t,!0)}peek(t){return this.c(t,!1)}c(t,r){if(t===0)return C();if(t>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===t){const u=this.a[0];return r&&(this.a.shift(),this.b-=t),u}if(this.a[0].byteLength>t){const u=this.a[0].slice(0,t);return r&&(this.a[0]=this.a[0].slice(t),this.b-=t),u}const a=O.$je.alloc(t);let E=0,y=0;for(;t>0;){const u=this.a[y];if(u.byteLength>t){const p=u.slice(0,t);a.set(p,E),E+=t,r&&(this.a[y]=u.slice(t),this.b-=t),t-=t}else a.set(u,E),E+=u.byteLength,r?(this.a.shift(),this.b-=u.byteLength):y++,t-=u.byteLength}return a}}e.$Ph=S;var m;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest",s[s.Pause=7]="Pause",s[s.Resume=8]="Resume",s[s.KeepAlive=9]="KeepAlive"})(m||(m={}));function l(s){switch(s){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var $;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.TimeoutTime=2e4]="TimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",s[s.KeepAliveSendTime=5e3]="KeepAliveSendTime"})($||(e.ProtocolConstants=$={}));class b{constructor(t,r,a,E){this.type=t,this.id=r,this.ack=a,this.data=E,this.writtenTime=0}get size(){return this.data.byteLength}}class w extends D.$Tc{constructor(t){super(),this.f=this.B(new L.$Vd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=t,this.b=!1,this.c=new S,this.B(this.a.onData(r=>this.acceptChunk(r))),this.lastReadTime=Date.now()}acceptChunk(t){if(!(!t||t.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(t);this.c.byteLength>=this.g.readLen;){const r=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=r.readUInt32BE(9),this.g.messageType=r.readUInt8(0),this.g.id=r.readUInt32BE(1),this.g.ack=r.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:l(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const a=this.g.messageType,E=this.g.id,y=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",r),this.f.fire(new b(a,E,y,r)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(t){this.k=null,this.a=!1,this.b=!1,this.c=t,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(t){if(this.a)return;t.writtenTime=Date.now(),this.lastWriteTime=Date.now();const r=O.$je.alloc(13);r.writeUInt8(t.type,0),r.writeUInt32BE(t.id,1),r.writeUInt32BE(t.ack,5),r.writeUInt32BE(t.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:l(t.type),id:t.id,ack:t.ack,messageSize:t.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",t.data),this.j(r,t.data)}g(t,r){const a=this.f===0;return this.d.push(t,r),this.f+=t.byteLength+r.byteLength,a}h(){const t=O.$je.concat(this.d,this.f);return this.d.length=0,this.f=0,t}j(t,r){this.g(t,r)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const t=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:t.byteLength}),this.c.write(t)}}class f extends D.$Tc{constructor(t){super(),this.f=new L.$Vd,this.onMessage=this.f.event,this.g=new L.$Vd,this.onDidDispose=this.g.event,this.a=t,this.b=this.B(new h(this.a)),this.c=this.B(new w(this.a)),this.B(this.c.onMessage(r=>{r.type===1&&this.f.fire(r.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(t){this.b.write(new b(1,0,0,t))}}e.$Qh=f;class d extends A.$Kh{static fromSocket(t,r){return new d(new f(t),r)}get onDidDispose(){return this.b.onDidDispose}constructor(t,r,a=null){super(t,r,a),this.b=t}dispose(){super.dispose();const t=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),t.end()}}e.$Rh=d;class c{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new L.$Vd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(t){this.b?this.d.length>0?this.d.push(t):this.a.fire(t):this.d.push(t)}flushBuffer(){this.d=[]}}e.$Sh=c;class v{constructor(t){this.data=t,this.next=null}}class i{constructor(){this.a=null,this.b=null}length(){let t=0,r=this.a;for(;r;)r=r.next,t++;return t}peek(){return this.a?this.a.data:null}toArray(){const t=[];let r=0,a=this.a;for(;a;)t[r++]=a.data,a=a.next;return t}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(t){const r=new v(t);if(!this.a){this.a=r,this.b=r;return}this.b.next=r,this.b=r}}class o{static{this.a=10}static{this.b=null}static getInstance(){return o.b||(o.b=new o),o.b}constructor(){this.c=[];const t=Date.now();for(let r=0;r<o.a;r++)this.c[r]=t-1e3*r;setInterval(()=>{for(let r=o.a;r>=1;r--)this.c[r]=this.c[r-1];this.c[0]=Date.now()},1e3)}d(){const t=Date.now(),r=(1+o.a)*1e3;let a=0;for(let E=0;E<o.a;E++)t-this.c[E]<=r&&a++;return 1-a/o.a}hasHighLoad(){return this.d()>=.5}}class n{get unacknowledgedCount(){return this.c-this.d}constructor(t){this.u=new c,this.onControlMessage=this.u.event,this.v=new c,this.onMessage=this.v.event,this.w=new c,this.onDidDispose=this.w.event,this.x=new c,this.onSocketClose=this.x.event,this.y=new c,this.onSocketTimeout=this.y.event,this.s=t.loadEstimator??o.getInstance(),this.t=t.sendKeepAlive??!0,this.a=!1,this.b=new i,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new D.$Sc,this.o=t.socket,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(r=>this.z(r))),this.r.add(this.o.onClose(r=>this.x.fire(r))),t.initialChunk&&this.q.acceptChunk(t.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const t=new b(5,0,0,C());this.p.write(t),this.p.flush()}sendPause(){const t=new b(7,0,0,C());this.p.write(t)}sendResume(){const t=new b(8,0,0,C());this.p.write(t)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(t,r){this.a=!0,this.r.dispose(),this.r=new D.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=t,this.p=this.r.add(new h(this.o)),this.q=this.r.add(new w(this.o)),this.r.add(this.q.onMessage(a=>this.z(a))),this.r.add(this.o.onClose(a=>this.x.fire(a))),this.q.acceptChunk(r)}endAcceptReconnection(){this.a=!1,this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t);const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B()}acceptDisconnect(){this.w.fire()}z(t){if(t.ack>this.d){this.d=t.ack;do{const r=this.b.peek();if(r&&r.id<=t.ack)this.b.pop();else break}while(!0)}switch(t.type){case 0:break;case 1:{if(t.id>this.g)if(t.id!==this.g+1){const r=Date.now();r-this.m>1e4&&(this.m=r,this.p.write(new b(6,0,0,C())))}else this.g=t.id,this.j=Date.now(),this.A(),this.v.fire(t.data);break}case 2:{this.u.fire(t.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const r=this.b.toArray();for(let a=0,E=r.length;a<E;a++)this.p.write(r[a]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(t){const r=++this.c;this.h=this.g;const a=new b(1,r,this.h,t);this.b.push(a),this.a||(this.p.write(a),this.B())}sendControl(t){const r=new b(2,0,0,t);this.p.write(r)}A(){if(this.g<=this.h||this.k)return;const t=Date.now()-this.j;if(t>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-t+5)}B(){if(this.c<=this.d||this.f||this.a)return;const t=this.b.peek(),r=Date.now()-t.writtenTime,a=Date.now()-this.q.lastReadTime,E=Date.now()-this.n;if(r>=2e4&&a>=2e4&&E>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:r,timeSinceLastReceivedSomeData:a});return}const y=Math.max(2e4-r,2e4-a,2e4-E,500);this.f=setTimeout(()=>{this.f=null,this.B()},y)}C(){if(this.g<=this.h)return;this.h=this.g;const t=new b(3,0,this.h,C());this.p.write(t)}D(){this.h=this.g;const t=new b(9,0,this.h,C());this.p.write(t)}}e.$Th=n}),define(le[93],he([0,1,67,6,14,26,141,7,3,2,30,145,90,40]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class $ extends l.$Hh{constructor(h){super({send:f=>{try{process.send?.(f.buffer.toString("base64"))}catch{}},onMessage:k.Event.fromNodeEventEmitter(process,"message",f=>D.$je.wrap(Buffer.from(f,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.$qq=$;class b{constructor(h,f){this.i=h,this.j=f,this.c=new Set,this.g=new Map,this.h=new k.$Vd,this.onDidProcessExit=this.h.event;const d=f&&f.timeout?f.timeout:6e4;this.b=new L.$3g(d),this.d=null,this.f=null}getChannel(h){const f=this;return{call(d,c,v){return f.k(h,d,c,v)},listen(d,c){return f.l(h,d,c)}}}k(h,f,d,c=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(c.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const v=this.n(h),i=(0,L.$Tg)(s=>v.call(f,d,s)),o=c.onCancellationRequested(()=>i.cancel()),n=(0,g.$Rc)(()=>i.cancel());return this.c.add(n),i.finally(()=>{o.dispose(),this.c.delete(n),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(h,f,d){if(!this.b)return k.Event.None;this.b.cancel();let c;const v=new k.$Vd({onWillAddFirstListener:()=>{c=this.n(h).listen(f,d)(v.fire,v),this.c.add(c)},onDidRemoveLastListener:()=>{this.c.delete(c),c.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return v.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],f=Object.create(null);f.env={...(0,C.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(f.env={...f.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(f.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(f.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(f.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),f.execArgv===void 0&&(f.execArgv=process.execArgv.filter(t=>!/^--inspect(-brk)?=/.test(t)).filter(t=>!t.startsWith("--vscode-"))),(0,m.$Sl)(f.env),this.d=(0,O.fork)(this.i,h,f);const d=new k.$Vd;k.Event.fromNodeEventEmitter(this.d,"message",t=>t)(t=>{if((0,I.$mq)(t)){(0,I.log)(t,`IPC Library: ${this.j.serverName}`);return}d.fire(D.$je.wrap(Buffer.from(t,"base64")))});const v=this.j.useQueue?(0,S.$Ul)(this.d):this.d,i=t=>this.d&&this.d.connected&&v.send(t.buffer.toString("base64")),o=d.event,n={send:i,onMessage:o};this.f=new l.$Ih(n);const s=()=>this.o();process.once("exit",s),this.d.on("error",t=>console.warn('IPC "'+this.j.serverName+'" errored with '+t)),this.d.on("exit",(t,r)=>{process.removeListener("exit",s),this.c.forEach(a=>(0,g.$Oc)(a)),this.c.clear(),t!==0&&r!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+t+" and signal "+r),this.b?.cancel(),this.o(),this.h.fire({code:t,signal:r})})}return this.f}n(h){let f=this.g.get(h);return f||(f=this.m.getChannel(h),this.g.set(h,f)),f}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=b}),define(le[147],he([0,1,134,14,40,3,12,17]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OU=e.$NU=void 0;class k{constructor(m){this.a=m,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",l=>l.data?L.$je.wrap(l.data):L.$je.alloc(0)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class g extends D.$Jh{static b(m){(0,I.$Sf)((0,O.$MU)(process),"Electron Utility Process");const l=new A.$Vd;return process.parentPort.on("message",$=>{if(m?.handledClientConnection($))return;const b=(0,P.$Ob)($.ports);b&&l.fire(b)}),A.Event.map(l.event,$=>({protocol:new k($),onDidClientDisconnect:A.Event.fromNodeEventEmitter($,"close")}))}constructor(m){super(g.b(m))}}e.$NU=g;function C(S,m,l){const $=b=>{b.data===m&&(S.removeListener("message",$),l())};S.on("message",$)}e.$OU=C}),define(le[69],he([0,1,6,3,2,66,12]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.StorageState=e.$pp=e.StorageHint=void 0;var P;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function k(m){const l=m;return l?.changed instanceof Map||l?.deleted instanceof Set}e.$pp=k;var g;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(g||(e.StorageState=g={}));class C extends D.$Tc{static{this.a=100}constructor(l,$=Object.create(null)){super(),this.r=l,this.s=$,this.b=this.B(new L.$Yd),this.onDidChangeStorage=this.b.event,this.c=g.None,this.f=new Map,this.g=this.B(new O.$4g(C.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(l=>this.u(l)))}u(l){this.b.pause();try{l.changed?.forEach(($,b)=>this.w(b,$)),l.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(l,$){if(this.c===g.Closed)return;let b=!1;(0,I.$Rf)($)?b=this.f.delete(l):this.f.get(l)!==$&&(this.f.set(l,$),b=!0),b&&this.b.fire({key:l,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===g.None&&(this.c=g.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(l,$){const b=this.f.get(l);return(0,I.$Rf)(b)?$:b}getBoolean(l,$){const b=this.get(l);return(0,I.$Rf)(b)?$:b==="true"}getNumber(l,$){const b=this.get(l);return(0,I.$Rf)(b)?$:parseInt(b,10)}getObject(l,$){const b=this.get(l);return(0,I.$Rf)(b)?$:(0,A.$Bh)(b)}async set(l,$,b=!1){if(this.c===g.Closed)return;if((0,I.$Rf)($))return this.delete(l,b);const w=(0,I.$Kf)($)||Array.isArray($)?(0,A.$Ah)($):String($);if(this.f.get(l)!==w)return this.f.set(l,w),this.j.set(l,w),this.h.delete(l),this.b.fire({key:l,external:b}),this.D()}async delete(l,$=!1){if(!(this.c===g.Closed||!this.f.delete(l)))return this.h.has(l)||this.h.add(l),this.j.delete(l),this.b.fire({key:l,external:$}),this.D()}async optimize(){if(this.c!==g.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=g.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const l={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(l).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(l){if(this.z)return this.D(l)}async D(l){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),l)}async whenFlushed(){if(this.z)return new Promise(l=>this.n.push(l))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$qp=C;class S{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(l){l.insert?.forEach(($,b)=>this.a.set(b,$)),l.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$rp=S}),define(le[148],he([13,9]),function(se,e){return se.create("vs/base/node/zip",e)}),define(le[70],he([0,1,54,6,16,12,31,148]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pp=e.$Op=e.zip=e.$Mp=e.$Lp=void 0,e.$Lp="end of central directory record signature not found";const k=new RegExp(e.$Lp);class g extends Error{constructor(v,i){let o=i.message;switch(v){case"CorruptZip":o=`Corrupt ZIP: ${o}`;break}super(o),this.type=v,this.cause=i}}e.$Mp=g;function C(c){const v=c.externalFileAttributes>>16||33188;return[448,56,7].map(i=>v&i).reduce((i,o)=>i+o,v&61440)}function S(c){if(c instanceof g)return c;let v;return k.test(c.message)&&(v="CorruptZip"),new g(v,c)}function m(c,v,i,o,n,s){const t=D.$mc(v),r=D.$jc(o,t);if(!r.startsWith(o))return Promise.reject(new Error(P.localize(0,null,v)));const a=D.$jc(o,v);let E;return s.onCancellationRequested(()=>{E?.destroy()}),Promise.resolve(I.Promises.mkdir(r,{recursive:!0})).then(()=>new Promise((y,u)=>{if(!s.isCancellationRequested)try{E=(0,O.createWriteStream)(a,{mode:i}),E.once("close",()=>y()),E.once("error",u),c.once("error",u),c.pipe(E)}catch(p){u(p)}}))}function l(c,v,i,o){let n=(0,L.$Tg)(()=>Promise.resolve()),s=0;const t=o.onCancellationRequested(()=>{n.cancel(),c.close()});return new Promise((r,a)=>{const E=new L.$1g,y=u=>{u.isCancellationRequested||(s++,c.readEntry())};c.once("error",a),c.once("close",()=>n.then(()=>{o.isCancellationRequested||c.entryCount===s?r():a(new g("Incomplete",new Error(P.localize(1,null,s,c.entryCount))))},a)),c.readEntry(),c.on("entry",u=>{if(o.isCancellationRequested)return;if(!i.sourcePathRegex.test(u.fileName)){y(o);return}const p=u.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(p)){const T=D.$jc(v,p);n=(0,L.$Tg)(M=>I.Promises.mkdir(T,{recursive:!0}).then(()=>y(M)).then(void 0,a));return}const R=b(c,u),N=C(u);n=(0,L.$Tg)(T=>E.queue(()=>R.then(M=>m(M,p,N,v,i,T).then(()=>y(T)))).then(null,a))})}).finally(()=>t.dispose())}async function $(c,v=!1){const{open:i}=await new Promise((o,n)=>{se(["yauzl"],o,n)});return new Promise((o,n)=>{i(c,v?{lazyEntries:!0}:void 0,(s,t)=>{s?n(S(s)):o((0,A.$Tf)(t))})})}function b(c,v){return new Promise((i,o)=>{c.openReadStream(v,(n,s)=>{n?o(S(n)):i((0,A.$Tf)(s))})})}async function w(c,v){const{ZipFile:i}=await new Promise((o,n)=>{se(["yazl"],o,n)});return new Promise((o,n)=>{const s=new i;v.forEach(r=>{r.contents?s.addBuffer(typeof r.contents=="string"?Buffer.from(r.contents,"utf8"):r.contents,r.path):r.localPath&&s.addFile(r.localPath,r.path)}),s.end();const t=(0,O.createWriteStream)(c);s.outputStream.pipe(t),s.outputStream.once("error",n),t.once("error",n),t.once("finish",()=>o(c))})}e.zip=w;function h(c,v,i={},o){const n=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let s=$(c,!0);return i.overwrite&&(s=s.then(t=>I.Promises.rm(v).then(()=>t))),s.then(t=>l(t,v,{sourcePathRegex:n},o))}e.$Op=h;function f(c,v){return $(c).then(i=>new Promise((o,n)=>{i.on("entry",s=>{s.fileName===v&&b(i,s).then(t=>o(t),t=>n(t))}),i.once("close",()=>n(new Error(P.localize(2,null,v))))}))}function d(c,v){return f(c,v).then(i=>new Promise((o,n)=>{const s=[];i.once("error",n),i.on("data",t=>s.push(t)),i.on("end",()=>o(Buffer.concat(s)))}))}e.$Pp=d}),define(le[149],he([13,9]),function(se,e){return se.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[150],he([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/contextkey",e)}),define(le[151],he([13,9]),function(se,e){return se.create("vs/platform/contextkey/common/scanner",e)}),define(le[152],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(le[153],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[154],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(le[155],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(le[156],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[157],he([13,9]),function(se,e){return se.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[158],he([13,9]),function(se,e){return se.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[159],he([13,9]),function(se,e){return se.create("vs/platform/files/common/fileService",e)}),define(le[160],he([13,9]),function(se,e){return se.create("vs/platform/files/common/files",e)}),define(le[161],he([13,9]),function(se,e){return se.create("vs/platform/files/common/io",e)}),define(le[162],he([13,9]),function(se,e){return se.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[163],he([13,9]),function(se,e){return se.create("vs/platform/languagePacks/common/languagePacks",e)}),define(le[164],he([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(le[165],he([13,9]),function(se,e){return se.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(le[166],he([13,9]),function(se,e){return se.create("vs/platform/request/common/request",e)}),define(le[167],he([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(le[168],he([13,9]),function(se,e){return se.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[169],he([13,9]),function(se,e){return se.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(le[170],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(le[171],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(le[172],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/settingsSync",e)}),define(le[173],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(le[174],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSync",e)}),define(le[175],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(le[176],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(le[177],he([13,9]),function(se,e){return se.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(le[178],he([13,9]),function(se,e){return se.create("vs/platform/workspace/common/workspace",e)}),define(le[179],he([0,1,7,151]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var D;(function(g){g[g.LParen=0]="LParen",g[g.RParen=1]="RParen",g[g.Neg=2]="Neg",g[g.Eq=3]="Eq",g[g.NotEq=4]="NotEq",g[g.Lt=5]="Lt",g[g.LtEq=6]="LtEq",g[g.Gt=7]="Gt",g[g.GtEq=8]="GtEq",g[g.RegexOp=9]="RegexOp",g[g.RegexStr=10]="RegexStr",g[g.True=11]="True",g[g.False=12]="False",g[g.In=13]="In",g[g.Not=14]="Not",g[g.And=15]="And",g[g.Or=16]="Or",g[g.Str=17]="Str",g[g.QuotedStr=18]="QuotedStr",g[g.Error=19]="Error",g[g.EOF=20]="EOF"})(D||(e.TokenType=D={}));function A(...g){switch(g.length){case 1:return(0,L.localize)(0,null,g[0]);case 2:return(0,L.localize)(1,null,g[0],g[1]);case 3:return(0,L.localize)(2,null,g[0],g[1],g[2]);default:return}}const I=(0,L.localize)(3,null),P=(0,L.localize)(4,null);class k{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(C){switch(C.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return C.isTripleEq?"===":"==";case 4:return C.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return C.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return C.lexeme;case 18:return C.lexeme;case 19:return C.lexeme;case 20:return"EOF";default:throw(0,O.$8)(`unhandled token type: ${JSON.stringify(C)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(C=>C.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(C){return this.c=C,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(C){return this.r()||this.c.charCodeAt(this.e)!==C?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(C){this.f.push({type:C,offset:this.d})}l(C){const S=this.d,m=this.c.substring(this.d,this.e),l={type:19,offset:this.d,lexeme:m};this.g.push({offset:S,lexeme:m,additionalInfo:C}),this.f.push(l)}n(){this.m.lastIndex=this.d;const C=this.m.exec(this.c);if(C){this.e=this.d+C[0].length;const S=this.c.substring(this.d,this.e),m=k.b.get(S);m?this.k(m):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let C=this.e,S=!1,m=!1;for(;;){if(C>=this.c.length){this.e=C,this.l(P);return}const $=this.c.charCodeAt(C);if(S)S=!1;else if($===47&&!m){C++;break}else $===91?m=!0:$===92?S=!0:$===93&&(m=!1);C++}for(;C<this.c.length&&k.a.has(this.c.charCodeAt(C));)C++;this.e=C;const l=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:l,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=k}),define(le[180],he([0,1,65,85,23,16,37,20,10]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$xm=/^([^.]+\..+)[:=](.+)$/;class g{get appRoot(){return(0,A.$mc)(D.$og.asFileUri("").fsPath)}get userHome(){return k.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return k.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return k.URI.file(this.b.tmpDir)}get cacheHome(){return k.URI.file(this.userDataPath)}get stateResource(){return(0,P.$Hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:D.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$Hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const l=(0,O.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",l)}return k.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$Hg)(k.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$Hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$Hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$Hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const l=I.env.VSCODE_PORTABLE;return l?k.URI.file((0,A.$jc)(l,"argv.json")):(0,P.$Hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return k.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const l=this.args["builtin-extensions-dir"];return l?(0,A.$kc)(l):(0,A.$hc)((0,A.$jc)(D.$og.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const l=this.args["extensions-download-dir"];return l?k.URI.file((0,A.$kc)(l)):k.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const l=this.args["extensions-dir"];if(l)return(0,A.$kc)(l);const $=I.env.VSCODE_EXTENSIONS;if($)return $;const b=I.env.VSCODE_PORTABLE;return b?(0,A.$jc)(b,"extensions"):(0,P.$Hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const l=this.args.extensionDevelopmentPath;if(Array.isArray(l))return l.map($=>/^[^:/?#]+?:\/\//.test($)?k.URI.parse($):k.URI.file((0,A.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(l=>l==="ui"||l==="workspace"||l==="web"?l:"workspace")}get extensionTestsLocationURI(){const l=this.args.extensionTestsPath;if(l)return/^[^:/?#]+?:\/\//.test(l)?k.URI.parse(l):k.URI.file((0,A.$hc)(l))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const l=this.args["disable-extension"];if(l){if(typeof l=="string")return[l];if(Array.isArray(l)&&l.length>0)return l}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(l=>!e.$xm.test(l))}get extensionLogLevel(){const l=[];for(const $ of this.args.log||[]){const b=e.$xm.exec($);b&&b[1]&&b[2]&&l.push([b[1],b[2]])}return l.length?l:void 0}get serviceMachineIdResource(){return(0,P.$Hg)(k.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const l=I.env.VSCODE_PORTABLE;return l?k.URI.file((0,A.$jc)(l,"policy.json")):(0,P.$Hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(l){this.args.continueOn=l}get args(){return this.a}constructor(l,$,b){this.a=l,this.b=$,this.c=b,this.editSessionId=this.args.editSessionId}}e.$ym=g,pe([L.$xh],g.prototype,"appRoot",null),pe([L.$xh],g.prototype,"userHome",null),pe([L.$xh],g.prototype,"userDataPath",null),pe([L.$xh],g.prototype,"appSettingsHome",null),pe([L.$xh],g.prototype,"tmpDir",null),pe([L.$xh],g.prototype,"cacheHome",null),pe([L.$xh],g.prototype,"stateResource",null),pe([L.$xh],g.prototype,"userRoamingDataHome",null),pe([L.$xh],g.prototype,"userDataSyncHome",null),pe([L.$xh],g.prototype,"sync",null),pe([L.$xh],g.prototype,"machineSettingsResource",null),pe([L.$xh],g.prototype,"workspaceStorageHome",null),pe([L.$xh],g.prototype,"localHistoryHome",null),pe([L.$xh],g.prototype,"keyboardLayoutResource",null),pe([L.$xh],g.prototype,"argvResource",null),pe([L.$xh],g.prototype,"isExtensionDevelopment",null),pe([L.$xh],g.prototype,"untitledWorkspacesHome",null),pe([L.$xh],g.prototype,"builtinExtensionsPath",null),pe([L.$xh],g.prototype,"extensionsPath",null),pe([L.$xh],g.prototype,"extensionDevelopmentLocationURI",null),pe([L.$xh],g.prototype,"extensionDevelopmentKind",null),pe([L.$xh],g.prototype,"extensionTestsLocationURI",null),pe([L.$xh],g.prototype,"debugExtensionHost",null),pe([L.$xh],g.prototype,"logLevel",null),pe([L.$xh],g.prototype,"extensionLogLevel",null),pe([L.$xh],g.prototype,"serviceMachineIdResource",null),pe([L.$xh],g.prototype,"disableTelemetry",null),pe([L.$xh],g.prototype,"disableWorkspaceTrust",null),pe([L.$xh],g.prototype,"useInMemorySecretStorage",null),pe([L.$xh],g.prototype,"policyFile",null);function C(m,l){return S(m["inspect-extensions"],m["inspect-brk-extensions"],5870,l,m.debugId,m.extensionEnvironment)}e.$zm=C;function S(m,l,$,b,w,h){const d=Number(l||m)||(b?null:$),c=d?!!l:!1;let v;if(h)try{v=JSON.parse(h)}catch{}return{port:d,break:c,debugId:w,env:v}}e.$Am=S}),function(){"use strict";function se(e,O,L){function D(I,P){const k=A(I,P),g=[k];return e.isAbsolute(k)||g.unshift(L),e.resolve(...g)}function A(I,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const k=process.env.VSCODE_PORTABLE;if(k)return e.join(k,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,P);const C=I["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const S=process.env.USERPROFILE;if(typeof S!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(S,"AppData","Roaming")}break;case"darwin":g=e.join(O.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,P)}return{getUserDataPath:D}}if(typeof define=="function")define(le[181],he([269,36,37]),function(e,O,L){return se(e,O,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),O=require("os");module.exports=se(e,O,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[182],he([0,1,36,180,181]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=void 0;class A extends L.$ym{constructor(g,C){super(g,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,D.getUserDataPath)(g,C.nameShort)},C)}}e.$Bm=A;function I(k,g){return(0,L.$Am)(k["inspect-ptyhost"],k["inspect-brk-ptyhost"],5877,g,k.extensionEnvironment)}e.$Cm=I;function P(k,g){return(0,L.$Am)(k["inspect-sharedprocess"],k["inspect-brk-sharedprocess"],5879,g,k.extensionEnvironment)}e.$Dm=P}),define(le[183],he([0,1,12,154]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yp=void 0;function D(I,P,k,g){try{A(I,P,k,g)}catch(C){I.error(C?.message??C)}return P}e.$Yp=D;function A(I,P,k,g){const C=(S,m,l)=>{const $=S[m];if((0,O.$If)($)){const b=$,w=b.length;if(w>1&&b[0]==="%"&&b[w-1]==="%"){const h=b.substr(1,w-2);let f=k[h];f===void 0&&g&&(f=g[h]);const d=typeof f=="string"?f:f?.message,c=g?.[h],v=typeof c=="string"?c:c?.message;if(!d){v||I.warn(`[${P.name}]: ${(0,L.localize)(0,null,h)}`);return}if(l&&(m==="title"||m==="category")&&v&&v!==d){const i={value:d,original:v};S[m]=i}else S[m]=d}}else if((0,O.$Kf)($))for(const b in $)$.hasOwnProperty(b)&&(b==="commands"?C($,b,!0):C($,b,l));else if(Array.isArray($))for(let b=0;b<$.length;b++)C($,b,l)};for(const S in P)P.hasOwnProperty(S)&&C(P,S)}}),define(le[184],he([0,1,70,157]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7p=void 0;function D(A){return(0,O.$Pp)(A,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch{throw new Error((0,L.localize)(0,null))}})}e.$7p=D}),define(le[185],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dac=e.$Cac=void 0;class O{constructor(A){this.a=A}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(A){return this.a.call("promptImportantExtensionsInstallNotification",[A])}promptWorkspaceRecommendations(A){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.$Cac=O;class L{constructor(A){this.a=A}listen(A,I){throw new Error(`Event not found: ${I}`)}call(A,I,P){switch(I){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(P[0])}throw new Error(`Call not found: ${I}`)}}e.$Dac=L}),define(le[71],he([0,1,20,89,158,55]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const I=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function k(h){return h=h.trim(),h==="*"||I.test(h)}e.$ap=k;function g(h){if(!k(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const f=h.match(I);return f?{hasCaret:f[1]==="^",hasGreaterEquals:f[1]===">=",majorBase:f[2]==="x"?0:parseInt(f[2],10),majorMustEqual:f[2]!=="x",minorBase:f[4]==="x"?0:parseInt(f[4],10),minorMustEqual:f[4]!=="x",patchBase:f[6]==="x"?0:parseInt(f[6],10),patchMustEqual:f[6]!=="x",preRelease:f[8]||null}:null}e.$bp=g;function C(h){if(!h)return null;const f=h.majorBase,d=h.majorMustEqual,c=h.minorBase;let v=h.minorMustEqual;const i=h.patchBase;let o=h.patchMustEqual;h.hasCaret&&(f===0||(v=!1),o=!1);let n=0;if(h.preRelease){const s=P.exec(h.preRelease);if(s){const[,t,r,a]=s;n=Date.UTC(Number(t),Number(r)-1,Number(a))}}return{majorBase:f,majorMustEqual:d,minorBase:c,minorMustEqual:v,patchBase:i,patchMustEqual:o,isMinimum:h.hasGreaterEquals,notBefore:n}}e.$cp=C;function S(h,f,d){let c;typeof h=="string"?c=C(g(h)):c=h;let v;f instanceof Date?v=f.getTime():typeof f=="string"&&(v=new Date(f).getTime());let i;if(typeof d=="string"?i=C(g(d)):i=d,!c||!i)return!1;const o=c.majorBase,n=c.minorBase,s=c.patchBase;let t=i.majorBase,r=i.minorBase,a=i.patchBase;const E=i.notBefore;let y=i.majorMustEqual,u=i.minorMustEqual,p=i.patchMustEqual;return i.isMinimum?o>t?!0:o<t?!1:n>r?!0:n<r||v&&v<E?!1:s>=a:(o===1&&t===0&&(!y||!u||!p)&&(t=1,r=0,a=0,y=!0,u=!1,p=!1),o<t?!1:o>t?!y:n<r?!1:n>r?!u:s<a?!1:s>a?!p:!(v&&v<E))}e.$dp=S;function m(h,f,d,c,v){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([L.default.Error,D.localize(0,null)]),i;if(typeof c.name!="string")return i.push([L.default.Error,D.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([L.default.Error,D.localize(2,null,"version")]),i;if(!c.engines)return i.push([L.default.Error,D.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([L.default.Error,D.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!w(c.extensionDependencies))return i.push([L.default.Error,D.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!w(c.activationEvents))return i.push([L.default.Error,D.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([L.default.Error,D.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([L.default.Warning,D.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([L.default.Error,D.localize(9,null,"main")]),i;{const s=(0,O.$Hg)(d,c.main);(0,O.$Bg)(s,d)||i.push([L.default.Warning,D.localize(10,null,s.path,d.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([L.default.Error,D.localize(11,null,"browser")]),i;{const s=(0,O.$Hg)(d,c.browser);(0,O.$Bg)(s,d)||i.push([L.default.Warning,D.localize(12,null,s.path,d.path)])}}if(!A.valid(c.version))return i.push([L.default.Error,D.localize(13,null)]),i;const o=[];if(!l(h,f,c,v,o))for(const s of o)i.push([L.default.Error,s]);return i}e.$ep=m;function l(h,f,d,c,v){return c||typeof d.main>"u"&&typeof d.browser>"u"?!0:b(h,f,d.engines.vscode,v)}e.$fp=l;function $(h,f,d){return h==="*"||b(f,d,h)}e.$gp=$;function b(h,f,d,c=[]){const v=C(g(d));if(!v)return c.push(D.localize(14,null,d)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return c.push(D.localize(15,null,d)),!1}else if(!v.majorMustEqual)return c.push(D.localize(16,null,d)),!1;return S(h,f,v)?!0:(c.push(D.localize(17,null,h,d)),!1)}function w(h){if(!Array.isArray(h))return!1;for(let f=0,d=h.length;f<d;f++)if(typeof h[f]!="string")return!1;return!0}}),define(le[43],he([0,1,14,32]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ap=void 0;async function D(A,I,P){let k=P&&P.get("storage.serviceMachineId",-1)||null;if(k)return k;try{const C=(await I.readFile(A.serviceMachineIdResource)).value.toString();k=(0,L.$pg)(C)?C:null}catch{k=null}if(!k){k=(0,L.$qg)();try{await I.writeFile(A.serviceMachineIdResource,O.$je.fromString(k))}catch{}}return P?.store("storage.serviceMachineId",k,-1,1),k}e.$Ap=D}),define(le[72],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class O{constructor(D,A=[],I=!1){this.ctor=D,this.staticArguments=A,this.supportsDelayedInstantiation=I}}e.$3h=O}),define(le[186],he([0,1,72]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const L=[];var D;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(D||(e.InstantiationType=D={}));function A(P,k,g){k instanceof O.$3h||(k=new O.$3h(k,[],!!g)),L.push([P,k])}e.$Yr=A;function I(){return L}e.$Zr=I}),define(le[187],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class O{constructor(A,I){this.key=A,this.data=I,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=O;class L{constructor(A){this.b=A,this.a=new Map}roots(){const A=[];for(const I of this.a.values())I.outgoing.size===0&&A.push(I);return A}insertEdge(A,I){const P=this.lookupOrInsertNode(A),k=this.lookupOrInsertNode(I);P.outgoing.set(k.key,k),k.incoming.set(P.key,P)}removeNode(A){const I=this.b(A);this.a.delete(I);for(const P of this.a.values())P.outgoing.delete(I),P.incoming.delete(I)}lookupOrInsertNode(A){const I=this.b(A);let P=this.a.get(I);return P||(P=new O(I,A),this.a.set(I,P)),P}lookup(A){return this.a.get(this.b(A))}isEmpty(){return this.a.size===0}toString(){const A=[];for(const[I,P]of this.a)A.push(`${I}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return A.join(`
`)}findCycleSlow(){for(const[A,I]of this.a){const P=new Set([A]),k=this.c(I,P);if(k)return k}}c(A,I){for(const[P,k]of A.outgoing){if(I.has(P))return[...I,P].join(" -> ");I.add(P);const g=this.c(k,I);if(g)return g;I.delete(P)}}}e.$Dq=L}),define(le[4],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var O;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function P(k){return k[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=P})(O||(e._util=O={})),e.$5h=D("instantiationService");function L(I,P,k){P[O.DI_TARGET]===P?P[O.DI_DEPENDENCIES].push({id:I,index:k}):(P[O.DI_DEPENDENCIES]=[{id:I,index:k}],P[O.DI_TARGET]=P)}function D(I){if(O.serviceIds.has(I))return O.serviceIds.get(I);const P=function(k,g,C){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(P,k,C)};return P.toString=()=>I,O.serviceIds.set(I,P),P}e.$6h=D;function A(I){return I}e.$7h=A}),define(le[188],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cac=void 0,e.$cac=(0,O.$6h)("checksumService")}),define(le[21],he([0,1,12,10,4]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,D.$6h)("configurationService");function A(h){return h&&typeof h=="object"&&(!h.overrideIdentifier||typeof h.overrideIdentifier=="string")&&(!h.resource||h.resource instanceof L.URI)}e.$Ai=A;function I(h){return h&&typeof h=="object"&&(!h.overrideIdentifiers||Array.isArray(h.overrideIdentifiers))&&!h.overrideIdentifier&&(!h.resource||h.resource instanceof L.URI)}e.$Bi=I;var P;(function(h){h[h.APPLICATION=1]="APPLICATION",h[h.USER=2]="USER",h[h.USER_LOCAL=3]="USER_LOCAL",h[h.USER_REMOTE=4]="USER_REMOTE",h[h.WORKSPACE=5]="WORKSPACE",h[h.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",h[h.DEFAULT=7]="DEFAULT",h[h.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function k(h){switch(h){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=k;function g(h){return h.applicationValue!==void 0||h.userValue!==void 0||h.userLocalValue!==void 0||h.userRemoteValue!==void 0||h.workspaceValue!==void 0||h.workspaceFolderValue!==void 0}e.$Di=g;function C(h,f){const d=Object.create(null);for(const c in h)S(d,c,h[c],f);return d}e.$Ei=C;function S(h,f,d,c){const v=f.split("."),i=v.pop();let o=h;for(let n=0;n<v.length;n++){const s=v[n];let t=o[s];switch(typeof t){case"undefined":t=o[s]=Object.create(null);break;case"object":break;default:c(`Ignoring ${f} as ${v.slice(0,n+1).join(".")} is ${JSON.stringify(t)}`);return}o=t}if(typeof o=="object"&&o!==null)try{o[i]=d}catch{c(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(o)}`)}else c(`Ignoring ${f} as ${v.join(".")} is ${JSON.stringify(o)}`)}e.$Fi=S;function m(h,f){const d=f.split(".");l(h,d)}e.$Gi=m;function l(h,f){const d=f.shift();if(f.length===0){delete h[d];return}if(Object.keys(h).indexOf(d)!==-1){const c=h[d];typeof c=="object"&&!Array.isArray(c)&&(l(c,f),Object.keys(c).length===0&&delete h[d])}}function $(h,f,d){function c(o,n){let s=o;for(const t of n){if(typeof s!="object"||s===null)return;s=s[t]}return s}const v=f.split("."),i=c(h,v);return typeof i>"u"?d:i}e.$Hi=$;function b(h,f,d){Object.keys(f).forEach(c=>{c!=="__proto__"&&(c in h?O.$Kf(h[c])&&O.$Kf(f[c])?b(h[c],f[c],d):d&&(h[c]=f[c]):h[c]=f[c])})}e.$Ii=b;function w(h){return h.replace(/[\[\]]/g,"")}e.$Ji=w}),define(le[94],he([0,1,5,27,179,4,150,7]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const k=new Map;k.set("false",!1),k.set("true",!0),k.set("isMac",O.$j),k.set("isLinux",O.$k),k.set("isWindows",O.$i),k.set("isWeb",O.$o),k.set("isMacNative",O.$j&&!O.$o),k.set("isEdge",O.$H),k.set("isFirefox",O.$F),k.set("isChrome",O.$E),k.set("isSafari",O.$G);function g(q,j){if(k.get(q)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");k.set(q,j)}e.$2i=g;const C=Object.prototype.hasOwnProperty;var S;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const m={regexParsingWithErrorRecovery:!0},l=(0,I.localize)(0,null),$=(0,I.localize)(1,null),b=(0,I.localize)(2,null),w=(0,I.localize)(3,null),h=(0,I.localize)(4,null),f=(0,I.localize)(5,null),d=(0,I.localize)(6,null),c=(0,I.localize)(7,null);class v{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(j=m){this.k=j,this.d=new D.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(j){if(j===""){this.h.push({message:l,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(j).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const B=this.D(),z=B.type===17?f:void 0;throw this.h.push({message:h,offset:B.offset,lexeme:D.$1i.getLexeme(B),additionalInfo:z}),v.c}return F}catch(F){if(F!==v.c)throw F;return}}l(){return this.m()}m(){const j=[this.o()];for(;this.y(16);){const F=this.o();j.push(F)}return j.length===1?j[0]:i.or(...j)}o(){const j=[this.s()];for(;this.y(15);){const F=this.s();j.push(F)}return j.length===1?j[0]:i.and(...j)}s(){if(this.y(2)){const j=this.D();switch(j.type){case 11:return this.z(),t.INSTANCE;case 12:return this.z(),r.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,w),F?.negate()}case 17:return this.z(),R.create(j.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",j)}}return this.t()}t(){const j=this.D();switch(j.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const F=this.l();return this.A(1,w),F}case 17:{const F=j.lexeme;if(this.z(),this.y(9)){const z=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),z.type!==10)throw this.B("REGEX",z);const _=z.lexeme,G=_.lastIndexOf("/"),J=G===_.length-1?void 0:this.w(_.substring(G+1));let te;try{te=new RegExp(_.substring(1,G),J)}catch{throw this.B("REGEX",z)}return Q.create(F,te)}switch(z.type){case 10:case 19:{const _=[z.lexeme];this.z();let G=this.D(),J=0;for(let $e=0;$e<z.lexeme.length;$e++)z.lexeme.charCodeAt($e)===40?J++:z.lexeme.charCodeAt($e)===41&&J--;for(;!this.E()&&G.type!==15&&G.type!==16;){switch(G.type){case 0:J++;break;case 1:J--;break;case 10:case 18:for(let $e=0;$e<G.lexeme.length;$e++)G.lexeme.charCodeAt($e)===40?J++:z.lexeme.charCodeAt($e)===41&&J--}if(J<0)break;_.push(D.$1i.getLexeme(G)),this.z(),G=this.D()}const te=_.join(""),ne=te.lastIndexOf("/"),ce=ne===te.length-1?void 0:this.w(te.substring(ne+1));let de;try{de=new RegExp(te.substring(1,ne),ce)}catch{throw this.B("REGEX",z)}return i.regex(F,de)}case 18:{const _=z.lexeme;this.z();let G=null;if(!(0,L.$Je)(_)){const J=_.indexOf("/"),te=_.lastIndexOf("/");if(J!==te&&J>=0){const ne=_.slice(J+1,te),ce=_[te+1]==="i"?"i":"";try{G=new RegExp(ne,ce)}catch{throw this.B("REGEX",z)}}}if(G===null)throw this.B("REGEX",z);return Q.create(F,G)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,b);const z=this.u();return i.notIn(F,z)}switch(this.D().type){case 3:{this.z();const z=this.u();if(this.x().type===18)return i.equals(F,z);switch(z){case"true":return i.has(F);case"false":return i.not(F);default:return i.equals(F,z)}}case 4:{this.z();const z=this.u();if(this.x().type===18)return i.notEquals(F,z);switch(z){case"true":return i.not(F);case"false":return i.has(F);default:return i.notEquals(F,z)}}case 5:return this.z(),U.create(F,this.u());case 6:return this.z(),Y.create(F,this.u());case 7:return this.z(),T.create(F,this.u());case 8:return this.z(),M.create(F,this.u());case 13:return this.z(),i.in(F,this.u());default:return i.has(F)}}case 20:throw this.h.push({message:d,offset:j.offset,lexeme:"",additionalInfo:c}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const j=this.D();switch(j.type){case 17:case 18:return this.z(),j.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(j){return j.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(j){return this.C(j)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(j,F){if(this.C(j))return this.z();throw this.B(F,this.D())}B(j,F,B){const z=(0,I.localize)(8,null,j,D.$1i.getLexeme(F)),_=F.offset,G=D.$1i.getLexeme(F);return this.h.push({message:z,offset:_,lexeme:G,additionalInfo:B}),v.c}C(j){return this.D().type===j}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=v;class i{static false(){return t.INSTANCE}static true(){return r.INSTANCE}static has(j){return a.create(j)}static equals(j,F){return E.create(j,F)}static notEquals(j,F){return p.create(j,F)}static regex(j,F){return Q.create(j,F)}static in(j,F){return y.create(j,F)}static notIn(j,F){return u.create(j,F)}static not(j){return R.create(j)}static and(...j){return Z.create(j,null,!0)}static or(...j){return W.create(j,null,!0)}static greater(j,F){return T.create(j,F)}static greaterEquals(j,F){return M.create(j,F)}static smaller(j,F){return U.create(j,F)}static smallerEquals(j,F){return Y.create(j,F)}static{this.c=new v({regexParsingWithErrorRecovery:!1})}static deserialize(j){return j==null?void 0:this.c.parse(j)}}e.$4i=i;function o(q){const j=new v({regexParsingWithErrorRecovery:!1});return q.map(F=>(j.parse(F),j.lexingErrors.length>0?j.lexingErrors.map(B=>({errorMessage:B.additionalInfo?(0,I.localize)(9,null,B.additionalInfo):(0,I.localize)(10,null),offset:B.offset,length:B.lexeme.length})):j.parsingErrors.length>0?j.parsingErrors.map(B=>({errorMessage:B.additionalInfo?`${B.message}. ${B.additionalInfo}`:B.message,offset:B.offset,length:B.lexeme.length})):[]))}e.$5i=o;function n(q,j){const F=q?q.substituteConstants():void 0,B=j?j.substituteConstants():void 0;return!F&&!B?!0:!F||!B?!1:F.equals(B)}e.$6i=n;function s(q,j){return q.cmp(j)}class t{static{this.INSTANCE=new t}constructor(){this.type=0}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!1}serialize(){return"false"}keys(){return[]}map(j){return this}negate(){return r.INSTANCE}}e.$7i=t;class r{static{this.INSTANCE=new r}constructor(){this.type=1}cmp(j){return this.type-j.type}equals(j){return j.type===this.type}substituteConstants(){return this}evaluate(j){return!0}serialize(){return"true"}keys(){return[]}map(j){return this}negate(){return t.INSTANCE}}e.$8i=r;class a{static create(j,F=null){const B=k.get(j);return typeof B=="boolean"?B?r.INSTANCE:t.INSTANCE:new a(j,F)}constructor(j,F){this.key=j,this.c=F,this.type=2}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.key,j.key)}equals(j){return j.type===this.type?this.key===j.key:!1}substituteConstants(){const j=k.get(this.key);return typeof j=="boolean"?j?r.INSTANCE:t.INSTANCE:this}evaluate(j){return!!j.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(j){return j.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.$9i=a;class E{static create(j,F,B=null){if(typeof F=="boolean")return F?a.create(j,B):R.create(j,B);const z=k.get(j);return typeof z=="boolean"?F===(z?"true":"false")?r.INSTANCE:t.INSTANCE:new E(j,F,B)}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=4}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=k.get(this.c);if(typeof j=="boolean"){const F=j?"true":"false";return this.d===F?r.INSTANCE:t.INSTANCE}return this}evaluate(j){return j.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(j){return j.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=p.create(this.c,this.d,this)),this.f}}e.$0i=E;class y{static create(j,F){return new y(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=10,this.c=null}cmp(j){return j.type!==this.type?this.type-j.type:re(this.d,this.f,j.d,j.f)}equals(j){return j.type===this.type?this.d===j.d&&this.f===j.f:!1}substituteConstants(){return this}evaluate(j){const F=j.getValue(this.f),B=j.getValue(this.d);return Array.isArray(F)?F.includes(B):typeof B=="string"&&typeof F=="object"&&F!==null?C.call(F,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(j){return j.mapIn(this.d,this.f)}negate(){return this.c||(this.c=u.create(this.d,this.f)),this.c}}e.$$i=y;class u{static create(j,F){return new u(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=11,this.c=y.create(j,F)}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(j){return j.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=u;class p{static create(j,F,B=null){if(typeof F=="boolean")return F?R.create(j,B):a.create(j,B);const z=k.get(j);return typeof z=="boolean"?F===(z?"true":"false")?t.INSTANCE:r.INSTANCE:new p(j,F,B)}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=5}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){const j=k.get(this.c);if(typeof j=="boolean"){const F=j?"true":"false";return this.d===F?t.INSTANCE:r.INSTANCE}return this}evaluate(j){return j.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(j){return j.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=E.create(this.c,this.d,this)),this.f}}e.$aj=p;class R{static create(j,F=null){const B=k.get(j);return typeof B=="boolean"?B?t.INSTANCE:r.INSTANCE:new R(j,F)}constructor(j,F){this.c=j,this.d=F,this.type=3}cmp(j){return j.type!==this.type?this.type-j.type:ie(this.c,j.c)}equals(j){return j.type===this.type?this.c===j.c:!1}substituteConstants(){const j=k.get(this.c);return typeof j=="boolean"?j?t.INSTANCE:r.INSTANCE:this}evaluate(j){return!j.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(j){return j.mapNot(this.c)}negate(){return this.d||(this.d=a.create(this.c,this)),this.d}}e.$bj=R;function N(q,j){if(typeof q=="string"){const F=parseFloat(q);isNaN(F)||(q=F)}return typeof q=="string"||typeof q=="number"?j(q):t.INSTANCE}class T{static create(j,F,B=null){return N(F,z=>new T(j,z,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=12}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=Y.create(this.c,this.d,this)),this.f}}e.$cj=T;class M{static create(j,F,B=null){return N(F,z=>new M(j,z,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=13}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(j){return j.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.$dj=M;class U{static create(j,F,B=null){return N(F,z=>new U(j,z,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=14}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$ej=U;class Y{static create(j,F,B=null){return N(F,z=>new Y(j,z,B))}constructor(j,F,B){this.c=j,this.d=F,this.f=B,this.type=15}cmp(j){return j.type!==this.type?this.type-j.type:re(this.c,this.d,j.c,j.d)}equals(j){return j.type===this.type?this.c===j.c&&this.d===j.d:!1}substituteConstants(){return this}evaluate(j){return typeof this.d=="string"?!1:parseFloat(j.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(j){return j.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$fj=Y;class Q{static create(j,F){return new Q(j,F)}constructor(j,F){this.d=j,this.f=F,this.type=7,this.c=null}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.d<j.d)return-1;if(this.d>j.d)return 1;const F=this.f?this.f.source:"",B=j.f?j.f.source:"";return F<B?-1:F>B?1:0}equals(j){if(j.type===this.type){const F=this.f?this.f.source:"",B=j.f?j.f.source:"";return this.d===j.d&&F===B}return!1}substituteConstants(){return this}evaluate(j){const F=j.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const j=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${j}`}keys(){return[this.d]}map(j){return j.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=x.create(this)),this.c}}e.$gj=Q;class x{static create(j){return new x(j)}constructor(j){this.c=j,this.type=8}cmp(j){return j.type!==this.type?this.type-j.type:this.c.cmp(j.c)}equals(j){return j.type===this.type?this.c.equals(j.c):!1}substituteConstants(){return this}evaluate(j){return!this.c.evaluate(j)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(j){return new x(this.c.map(j))}negate(){return this.c}}e.$hj=x;function H(q){let j=null;for(let F=0,B=q.length;F<B;F++){const z=q[F].substituteConstants();if(q[F]!==z&&j===null){j=[];for(let _=0;_<F;_++)j[_]=q[_]}j!==null&&(j[F]=z)}return j===null?q:j}class Z{static create(j,F,B){return Z.d(j,F,B)}constructor(j,F){this.expr=j,this.c=F,this.type=6}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const z=s(this.expr[F],j.expr[F]);if(z!==0)return z}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(j.expr[F]))return!1;return!0}return!1}substituteConstants(){const j=H(this.expr);return j===this.expr?this:Z.create(j,this.c,!1)}evaluate(j){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(j))return!1;return!0}static d(j,F,B){const z=[];let _=!1;for(const G of j)if(G){if(G.type===1){_=!0;continue}if(G.type===0)return t.INSTANCE;if(G.type===6){z.push(...G.expr);continue}z.push(G)}if(z.length===0&&_)return r.INSTANCE;if(z.length!==0){if(z.length===1)return z[0];z.sort(s);for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];for(;z.length>1;){const G=z[z.length-1];if(G.type!==9)break;z.pop();const J=z.pop(),te=z.length===0,ne=W.create(G.expr.map(ce=>Z.create([ce,J],null,B)),null,te);ne&&(z.push(ne),z.sort(s))}if(z.length===1)return z[0];if(B){for(let G=0;G<z.length;G++)for(let J=G+1;J<z.length;J++)if(z[G].negate().equals(z[J]))return t.INSTANCE;if(z.length===1)return z[0]}return new Z(z,F)}}serialize(){return this.expr.map(j=>j.serialize()).join(" && ")}keys(){const j=[];for(const F of this.expr)j.push(...F.keys());return j}map(j){return new Z(this.expr.map(F=>F.map(j)),null)}negate(){if(!this.c){const j=[];for(const F of this.expr)j.push(F.negate());this.c=W.create(j,this,!0)}return this.c}}e.$ij=Z;class W{static create(j,F,B){return W.d(j,F,B)}constructor(j,F){this.expr=j,this.c=F,this.type=9}cmp(j){if(j.type!==this.type)return this.type-j.type;if(this.expr.length<j.expr.length)return-1;if(this.expr.length>j.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const z=s(this.expr[F],j.expr[F]);if(z!==0)return z}return 0}equals(j){if(j.type===this.type){if(this.expr.length!==j.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(j.expr[F]))return!1;return!0}return!1}substituteConstants(){const j=H(this.expr);return j===this.expr?this:W.create(j,this.c,!1)}evaluate(j){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(j))return!0;return!1}static d(j,F,B){let z=[],_=!1;if(j){for(let G=0,J=j.length;G<J;G++){const te=j[G];if(te){if(te.type===0){_=!0;continue}if(te.type===1)return r.INSTANCE;if(te.type===9){z=z.concat(te.expr);continue}z.push(te)}}if(z.length===0&&_)return t.INSTANCE;z.sort(s)}if(z.length!==0){if(z.length===1)return z[0];for(let G=1;G<z.length;G++)z[G-1].equals(z[G])&&(z.splice(G,1),G--);if(z.length===1)return z[0];if(B){for(let G=0;G<z.length;G++)for(let J=G+1;J<z.length;J++)if(z[G].negate().equals(z[J]))return r.INSTANCE;if(z.length===1)return z[0]}return new W(z,F)}}serialize(){return this.expr.map(j=>j.serialize()).join(" || ")}keys(){const j=[];for(const F of this.expr)j.push(...F.keys());return j}map(j){return new W(this.expr.map(F=>F.map(j)),null)}negate(){if(!this.c){const j=[];for(const F of this.expr)j.push(F.negate());for(;j.length>1;){const F=j.shift(),B=j.shift(),z=[];for(const _ of K(F))for(const G of K(B))z.push(Z.create([_,G],null,!1));j.unshift(W.create(z,null,!1))}this.c=W.create(j,this,!0)}return this.c}}e.$jj=W;class V extends a{static{this.d=[]}static all(){return V.d.values()}constructor(j,F,B){super(j,null),this.f=F,typeof B=="object"?V.d.push({...B,key:j}):B!==!0&&V.d.push({key:j,description:B,type:F!=null?typeof F:void 0})}bindTo(j){return j.createKey(this.key,this.f)}getValue(j){return j.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(j){return E.create(this.key,j)}notEqualsTo(j){return p.create(this.key,j)}}e.$kj=V,e.$lj=(0,A.$6h)("contextKeyService");function ie(q,j){return q<j?-1:q>j?1:0}function re(q,j,F,B){return q<F?-1:q>F?1:j<B?-1:j>B?1:0}function ee(q,j){if(q.type===0||j.type===1)return!0;if(q.type===9)return j.type===9?ae(q.expr,j.expr):!1;if(j.type===9){for(const F of j.expr)if(ee(q,F))return!0;return!1}if(q.type===6){if(j.type===6)return ae(j.expr,q.expr);for(const F of q.expr)if(ee(F,j))return!0;return!1}return q.equals(j)}e.$mj=ee;function ae(q,j){let F=0,B=0;for(;F<q.length&&B<j.length;){const z=q[F].cmp(j[B]);if(z<0)return!1;z===0&&F++,B++}return F===q.length}function K(q){return q.type===9?q.expr:[q]}}),define(le[95],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Km=e.$Jm=e.$Im=e.ID=void 0,e.ID="diagnosticsService",e.$Im=(0,O.$6h)(e.ID);function L(A){return!!A.hostName&&!!A.errorMessage}e.$Jm=L;class D{async getPerformanceInfo(I,P){return{}}async getSystemInfo(I,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(I,P){return""}async getWorkspaceFileExtensions(I){return{extensions:[]}}async reportWorkspaceStats(I){}}e.$Km=D}),define(le[96],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$do=void 0,e.$do=(0,O.$6h)("downloadService")}),define(le[15],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,O.$6h)("environmentService"),e.$bi=(0,O.$7h)(e.$ai)}),define(le[29],he([0,1,153,4]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function D(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=D;function A(d){switch(d){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=A;function I(d,c){switch(d){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=I;function P(d,c){return c==="web"&&!d.includes("web")}e.$vo=P;function k(d,c,v){return P(c,v)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===v}e.$wo=k;function g(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.$xo=g;var C;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(C||(e.SortBy=C={}));var S;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(S||(e.SortOrder=S={}));var m;(function(d){d.Install="install",d.Uninstall="uninstall"})(m||(e.StatisticType=m={}));var l;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(l||(e.InstallOperation=l={})),e.$yo=(0,L.$6h)("extensionGalleryService");var $;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.DownloadSignature="DownloadSignature",d.UpdateMetadata="UpdateMetadata",d.Extract="Extract",d.Scanning="Scanning",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.NotAllowed="NotAllowed",d.Gallery="Gallery",d.Unknown="Unknown",d.Internal="Internal"})($||(e.ExtensionManagementErrorCode=$={}));var b;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(b||(e.ExtensionSignaturetErrorCode=b={}));class w extends Error{constructor(c,v){super(c),this.code=v,this.name=v}}e.$zo=w;var h;(function(d){d.Timeout="Timeout",d.Cancelled="Cancelled",d.Failed="Failed"})(h||(e.ExtensionGalleryErrorCode=h={}));class f extends Error{constructor(c,v){super(c),this.code=v,this.name=v}}e.$Ao=f,e.$Bo=(0,L.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,L.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,L.$6h)("IExtensionTipsService"),e.$Go=(0,O.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,O.localize2)(1,"Preferences")}),define(le[189],he([0,1,3,2,30,10,92,29]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=e.$Jp=e.$Ip=void 0;function k(w,h){return w?A.URI.revive(h?h.transformIncoming(w):w):void 0}function g(w,h){return h?h.transformOutgoingURI(w):w}function C(w,h){h=h||I.$5m;const f=w.manifest;return{...(0,I.$8m)({...w,manifest:void 0},h),manifest:f}}function S(w,h){return w?.profileLocation?(0,I.$8m)(w,h??I.$5m):w}function m(w,h){return h?(0,D.$xn)(w,f=>f instanceof A.URI?h.transformOutgoingURI(f):void 0):w}class l{constructor(h,f){this.a=h,this.b=f,this.onInstallExtension=O.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=O.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=O.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=O.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=O.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,f){const d=this.b(h);switch(f){case"onInstallExtension":return O.Event.map(this.onInstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidInstallExtensions":return O.Event.map(this.onDidInstallExtensions,c=>c.map(v=>({...v,local:v.local?m(v.local,d):v.local,profileLocation:v.profileLocation?g(v.profileLocation,d):v.profileLocation})));case"onUninstallExtension":return O.Event.map(this.onUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidUninstallExtension":return O.Event.map(this.onDidUninstallExtension,c=>({...c,profileLocation:c.profileLocation?g(c.profileLocation,d):c.profileLocation}));case"onDidUpdateExtensionMetadata":return O.Event.map(this.onDidUpdateExtensionMetadata,c=>m(c,d))}throw new Error("Invalid listen")}async call(h,f,d){const c=this.b(h);switch(f){case"zip":{const v=C(d[0],c),i=await this.a.zip(v);return g(i,c)}case"unzip":return this.a.unzip(k(d[0],c));case"install":return this.a.install(k(d[0],c),S(d[1],c));case"installFromLocation":return this.a.installFromLocation(k(d[0],c),k(d[1],c));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],k(d[1],c),k(d[2],c));case"getManifest":return this.a.getManifest(k(d[0],c));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],S(d[1],c));case"installGalleryExtensions":{const v=d[0];return this.a.installGalleryExtensions(v.map(({extension:i,options:o})=>({extension:i,options:S(o,c)??{}})))}case"uninstall":return this.a.uninstall(C(d[0],c),S(d[1],c));case"reinstallFromGallery":return this.a.reinstallFromGallery(C(d[0],c));case"getInstalled":return(await this.a.getInstalled(d[0],k(d[1],c))).map(i=>m(i,c));case"toggleAppliationScope":{const v=await this.a.toggleAppliationScope(C(d[0],c),k(d[1],c));return m(v,c)}case"copyExtensions":return this.a.copyExtensions(k(d[0],c),k(d[1],c));case"updateMetadata":{const v=await this.a.updateMetadata(C(d[0],c),d[1],k(d[2],c));return m(v,c)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.$Ip=l;class $ extends L.$Tc{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.m=h,this.c=this.B(new O.$Vd),this.f=this.B(new O.$Vd),this.g=this.B(new O.$Vd),this.h=this.B(new O.$Vd),this.j=this.B(new O.$Vd),this.B(this.m.listen("onInstallExtension")(f=>this.n(this.c,{...f,source:this.r(f.source)?A.URI.revive(f.source):f.source,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidInstallExtensions")(f=>this.n(this.f,f.map(d=>({...d,local:d.local?C(d.local,null):d.local,source:this.r(d.source)?A.URI.revive(d.source):d.source,profileLocation:A.URI.revive(d.profileLocation)}))))),this.B(this.m.listen("onUninstallExtension")(f=>this.n(this.g,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUninstallExtension")(f=>this.n(this.h,{...f,profileLocation:A.URI.revive(f.profileLocation)}))),this.B(this.m.listen("onDidUpdateExtensionMetadata")(f=>this.j.fire(C(f,null))))}n(h,f){h.fire(f)}r(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.s||(this.s=this.m.call("getTargetPlatform")),this.s}async canInstall(h){const f=await this.getTargetPlatform();return h.allTargetPlatforms.some(d=>(0,P.$wo)(d,h.allTargetPlatforms,f))}zip(h){return Promise.resolve(this.m.call("zip",[h]).then(f=>A.URI.revive(f)))}unzip(h){return Promise.resolve(this.m.call("unzip",[h]))}install(h,f){return Promise.resolve(this.m.call("install",[h,f])).then(d=>C(d,null))}installFromLocation(h,f){return Promise.resolve(this.m.call("installFromLocation",[h,f])).then(d=>C(d,null))}async installExtensionsFromProfile(h,f,d){return(await this.m.call("installExtensionsFromProfile",[h,f,d])).map(v=>C(v,null))}getManifest(h){return Promise.resolve(this.m.call("getManifest",[h]))}installFromGallery(h,f){return Promise.resolve(this.m.call("installFromGallery",[h,f])).then(d=>C(d,null))}async installGalleryExtensions(h){return(await this.m.call("installGalleryExtensions",[h])).map(d=>({...d,local:d.local?C(d.local,null):d.local,source:this.r(d.source)?A.URI.revive(d.source):d.source,profileLocation:A.URI.revive(d.profileLocation)}))}uninstall(h,f){return Promise.resolve(this.m.call("uninstall",[h,f]))}reinstallFromGallery(h){return Promise.resolve(this.m.call("reinstallFromGallery",[h])).then(f=>C(f,null))}getInstalled(h=null,f){return Promise.resolve(this.m.call("getInstalled",[h,f])).then(d=>d.map(c=>C(c,null)))}updateMetadata(h,f,d){return Promise.resolve(this.m.call("updateMetadata",[h,f,d])).then(c=>C(c,null))}toggleAppliationScope(h,f){return this.m.call("toggleAppliationScope",[h,f]).then(d=>C(d,null))}copyExtensions(h,f){return this.m.call("copyExtensions",[h,f])}getExtensionsControlManifest(){return Promise.resolve(this.m.call("getExtensionsControlManifest"))}async download(h,f,d){const c=await this.m.call("download",[h,f,d]);return A.URI.revive(c)}async cleanUp(){return this.m.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.$Jp=$;class b{constructor(h){this.a=h}listen(h,f){throw new Error("Invalid listen")}call(h,f,d){switch(f){case"getConfigBasedTips":return this.a.getConfigBasedTips(A.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.$Kp=b}),define(le[97],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TZb=e.RecommendationsNotificationResult=e.$SZb=e.RecommendationSource=void 0;var L;(function(I){I[I.FILE=1]="FILE",I[I.WORKSPACE=2]="WORKSPACE",I[I.EXE=3]="EXE"})(L||(e.RecommendationSource=L={}));function D(I){switch(I){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.$SZb=D;var A;(function(I){I.Ignored="ignored",I.Cancelled="cancelled",I.TooMany="toomany",I.IncompatibleWindow="incompatibleWindow",I.Accepted="reacted"})(A||(e.RecommendationsNotificationResult=A={})),e.$TZb=(0,O.$6h)("IExtensionRecommendationNotificationService")}),define(le[11],he([0,1,48,16,27,12,10,160,4,5,23,52]),function(se,e,O,L,D,A,I,P,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,k.$6h)("fileService");function m(ee){return ee.create===!0}e.$rk=m;var l;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(l||(e.FileType=l={}));var $;(function(ee){ee[ee.Readonly=1]="Readonly",ee[ee.Locked=2]="Locked"})($||(e.FilePermission=$={}));function b(ee){const ae=ee;return!!ae&&typeof ae.onDidChange=="function"}e.$sk=b;var w;(function(ee){ee[ee.None=0]="None",ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileAtomicWrite=32768]="FileAtomicWrite",ee[ee.FileAtomicDelete=65536]="FileAtomicDelete",ee[ee.FileClone=131072]="FileClone"})(w||(e.FileSystemProviderCapabilities=w={}));function h(ee){return!!(ee.capabilities&2)}e.$tk=h;function f(ee){return!!(ee.capabilities&8)}e.$uk=f;function d(ee){return!!(ee.capabilities&131072)}e.$vk=d;function c(ee){return!!(ee.capabilities&4)}e.$wk=c;function v(ee){return!!(ee.capabilities&16)}e.$xk=v;function i(ee){return h(ee)?!!(ee.capabilities&16384):!1}e.$yk=i;function o(ee){return h(ee)?!!(ee.capabilities&32768):!1}e.$zk=o;function n(ee){return!!(ee.capabilities&65536)}e.$Ak=n;function s(ee){return!!(ee.capabilities&2048)}e.$Bk=s;var t;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsStorageQuota="EntryExceedsStorageQuota",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(t||(e.FileSystemProviderErrorCode=t={}));class r extends Error{static create(ae,K){const q=new r(ae.toString(),K);return y(q,K),q}constructor(ae,K){super(ae),this.code=K}}e.$Ck=r;function a(ee,ae){return r.create(ee,ae)}e.$Dk=a;function E(ee){return ee||a((0,P.localize)(0,null),t.Unknown)}e.$Ek=E;function y(ee,ae){return ee.name=ae?`${ae} (FileSystemError)`:"FileSystemError",ee}e.$Fk=y;function u(ee){if(!ee)return t.Unknown;if(ee instanceof r)return ee.code;const ae=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!ae)return t.Unknown;switch(ae[1]){case t.FileExists:return t.FileExists;case t.FileIsADirectory:return t.FileIsADirectory;case t.FileNotADirectory:return t.FileNotADirectory;case t.FileNotFound:return t.FileNotFound;case t.FileTooLarge:return t.FileTooLarge;case t.FileWriteLocked:return t.FileWriteLocked;case t.NoPermissions:return t.NoPermissions;case t.Unavailable:return t.Unavailable}return t.Unknown}e.$Gk=u;function p(ee){if(ee instanceof Y)return ee.fileOperationResult;switch(u(ee)){case t.FileNotFound:return 1;case t.FileIsADirectory:return 0;case t.FileNotADirectory:return 9;case t.FileWriteLocked:return 5;case t.NoPermissions:return 6;case t.FileExists:return 4;case t.FileTooLarge:return 7;default:return 10}}e.$Hk=p;var R;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(R||(e.FileOperation=R={}));class N{constructor(ae,K,q){this.resource=ae,this.operation=K,this.target=q}isOperation(ae){return this.operation===ae}}e.$Ik=N;var T;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(T||(e.FileChangeType=T={}));class M{static{this.a=null}constructor(ae,K){this.c=K,this.b=void 0,this.d=new S.$V(()=>{const q=O.$_h.forUris(()=>this.c);return q.fill(this.rawAdded.map(j=>[j,!0])),q}),this.f=new S.$V(()=>{const q=O.$_h.forUris(()=>this.c);return q.fill(this.rawUpdated.map(j=>[j,!0])),q}),this.g=new S.$V(()=>{const q=O.$_h.forUris(()=>this.c);return q.fill(this.rawDeleted.map(j=>[j,!0])),q}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const q of ae){switch(q.type){case 1:this.rawAdded.push(q.resource);break;case 0:this.rawUpdated.push(q.resource);break;case 2:this.rawDeleted.push(q.resource);break}this.b!==M.a&&(typeof q.cId=="number"?this.b===void 0?this.b=q.cId:this.b!==q.cId&&(this.b=M.a):this.b!==void 0&&(this.b=M.a))}}contains(ae,...K){return this.h(ae,{includeChildren:!1},...K)}affects(ae,...K){return this.h(ae,{includeChildren:!0},...K)}h(ae,K,...q){if(!ae)return!1;const j=q.length>0;return!!((!j||q.includes(1))&&(this.d.value.get(ae)||K.includeChildren&&this.d.value.findSuperstr(ae))||(!j||q.includes(0))&&(this.f.value.get(ae)||K.includeChildren&&this.f.value.findSuperstr(ae))||(!j||q.includes(2))&&(this.g.value.findSubstr(ae)||K.includeChildren&&this.g.value.findSuperstr(ae)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(ae){return this.b===ae}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=M;function U(ee,ae,K){return!ee||!ae||ee===ae||ae.length>ee.length?!1:(ae.charAt(ae.length-1)!==L.sep&&(ae+=L.sep),K?(0,D.$af)(ee,ae):ee.indexOf(ae)===0)}e.$Kk=U;class Y extends Error{constructor(ae,K,q){super(ae),this.fileOperationResult=K,this.options=q}}e.$Lk=Y;class Q extends Y{constructor(ae,K,q,j){super(ae,K,j),this.fileOperationResult=K,this.size=q}}e.$Mk=Q;class x extends Y{constructor(ae,K,q){super(ae,2,q),this.stat=K}}e.$Nk=x;var H;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(H||(e.FileOperationResult=H={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var Z;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(Z||(e.FileKind=Z={})),e.$Vk="";function W(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}e.$Wk=W;async function V(ee,ae){if(!ae.hasProvider(I.URI.from({scheme:ee.scheme})))return new Promise(K=>{const q=ae.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===ee.scheme&&j.added&&(q.dispose(),K())})})}e.$Xk=V;class ie{static{this.KB=1024}static{this.MB=ie.KB*ie.KB}static{this.GB=ie.MB*ie.KB}static{this.TB=ie.GB*ie.KB}static formatSize(ae){return(0,A.$Mf)(ae)||(ae=0),ae<ie.KB?(0,P.localize)(1,null,ae.toFixed(0)):ae<ie.MB?(0,P.localize)(2,null,(ae/ie.KB).toFixed(2)):ae<ie.GB?(0,P.localize)(3,null,(ae/ie.MB).toFixed(2)):ae<ie.TB?(0,P.localize)(4,null,(ae/ie.GB).toFixed(2)):(0,P.localize)(5,null,(ae/ie.TB).toFixed(2))}}e.$Yk=ie;function re(ee){const ae=typeof ee=="string"||ee?.scheme===C.Schemas.vscodeRemote;return typeof ee!="string"&&ee?.scheme===C.Schemas.file?1024*ie.MB:ae?10*ie.MB:g.$o?50*ie.MB:1024*ie.MB}e.$Zk=re});var X=this&&this.__param||function(se,e){return function(O,L){e(O,L,se)}};define(le[190],he([0,1,73,47,11]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dac=void 0;let A=class{constructor(P){this.a=P}async checksum(P){const k=(await this.a.readFileStream(P)).value;return new Promise((g,C)=>{const S=(0,O.createHash)("sha256");(0,L.$be)(k,{onData:m=>S.update(m.buffer),onError:m=>C(m),onEnd:()=>g(S.digest("base64").replace(/=+$/,""))})})}};e.$dac=A,e.$dac=A=pe([X(0,D.$qk)],A)}),define(le[98],he([0,1,14,7,161,11]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;async function I(C,S,m,l,$,b){let w;try{await P(C,S,m,l,$,b)}catch(h){w=h}finally{w&&$.errorTransformer&&(w=$.errorTransformer(w)),typeof w<"u"&&m.error(w),m.end()}}e.$bq=I;async function P(C,S,m,l,$,b){k(b);const w=await C.open(S,{create:!1});try{k(b);let h=0,f=0,d=$&&typeof $.length=="number"?$.length:void 0,c=O.$je.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),v=$&&typeof $.position=="number"?$.position:0,i=0;do f=await C.read(w,v,c.buffer,i,c.byteLength-i),v+=f,i+=f,h+=f,typeof d=="number"&&(d-=f),i===c.byteLength&&(await m.write(l(c)),c=O.$je.alloc(Math.min($.bufferSize,typeof d=="number"?d:$.bufferSize)),i=0);while(f>0&&(typeof d!="number"||d>0)&&k(b)&&g(h,$));if(i>0){let o=i;typeof d=="number"&&(o=Math.min(i,d)),m.write(l(c.slice(0,o)))}}catch(h){throw(0,A.$Ek)(h)}finally{await C.close(w)}}function k(C){if(C.isCancellationRequested)throw(0,L.$6)();return!0}function g(C,S){if(typeof S?.limits?.size=="number"&&C>S.limits.size)throw(0,A.$Dk)((0,D.localize)(0,null),A.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(le[50],he([0,1,91,2,16,5,10,11]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;function k(h){return h.recursive===!0}e.$dq=k;class g extends L.$Tc{static{this.a=5}constructor(f,d,c,v){super(),this.h=f,this.j=d,this.m=c,this.n=v,this.c=this.B(new L.$Uc),this.f=void 0,this.g=0}s(){const f=new L.$Sc;this.c.value=f,this.b=this.r(f),this.b.setVerboseLogging(this.m),f.add(this.b.onDidChangeFile(d=>this.h(d))),f.add(this.b.onDidLogMessage(d=>this.j(d))),f.add(this.b.onDidError(d=>this.t(d)))}t(f){this.n.restartOnError?this.g<g.a&&this.f?(this.w(`restarting watcher after error: ${f}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${f}`):this.w(f)}u(f){this.g++,this.s(),this.watch(f)}async watch(f){this.f=f,await this.b?.watch(f)}async setVerboseLogging(f){this.m=f,await this.b?.setVerboseLogging(f)}w(f){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${f}`})}y(f){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${f}`})}dispose(){return this.b=void 0,super.dispose()}}e.$eq=g;class C extends g{constructor(f,d,c){super(f,d,c,{type:"node.js",restartOnError:!1})}}e.$fq=C;class S extends g{constructor(f,d,c){super(f,d,c,{type:"universal",restartOnError:!0})}}e.$gq=S;function m(h){return h.map(f=>({type:f.type,resource:I.URI.revive(f.resource),cId:f.cId}))}e.$hq=m;function l(h){const f=new w;for(const d of h)f.processEvent(d);return f.coalesce()}e.$iq=l;function $(h,f){return typeof f=="string"&&!f.startsWith(O.$Ij)&&!(0,D.$ic)(f)?{base:h,pattern:f}:f}e.$jq=$;function b(h,f){const d=[];for(const c of f)d.push((0,O.$Mj)($(h,c)));return d}e.$kq=b;class w{constructor(){this.a=new Set,this.b=new Map}c(f){return A.$k?f.resource.fsPath:f.resource.fsPath.toLowerCase()}processEvent(f){const d=this.b.get(this.c(f));let c=!1;if(d){const v=d.type,i=f.type;d.resource.fsPath!==f.resource.fsPath&&(f.type===2||f.type===1)?c=!0:v===1&&i===2?(this.b.delete(this.c(f)),this.a.delete(d)):v===2&&i===1?d.type=0:v===1&&i===0||(d.type=i)}else c=!0;c&&(this.a.add(f),this.b.set(this.c(f),f))}coalesce(){const f=[],d=[];return Array.from(this.a).filter(c=>c.type!==2?(f.push(c),!1):!0).sort((c,v)=>c.resource.fsPath.length-v.resource.fsPath.length).filter(c=>d.some(v=>(0,P.$Kk)(c.resource.fsPath,v,!A.$k))?!1:(d.push(c.resource.fsPath),!0)).concat(f)}}}),define(le[191],he([0,1,14,38,7,3,2,47,32,11,50]),function(se,e,O,L,D,A,I,P,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lO=e.$kO=void 0,e.$kO="localFilesystem";class S extends I.$Tc{constructor(l,$){super(),this.a=l,this.b=$,this.onDidChangeCapabilities=A.Event.None,this.f=this.B(new A.$Vd),this.onDidChangeFile=this.f.event,this.g=this.B(new A.$Vd),this.onDidWatchError=this.g.event,this.h=(0,k.$qg)(),this.j()}get capabilities(){return this.c||(this.c=253982,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(l){return this.a.call("stat",[l])}readdir(l){return this.a.call("readdir",[l])}async readFile(l,$){const{buffer:b}=await this.a.call("readFile",[l,$]);return b}readFileStream(l,$,b){const w=(0,P.$0d)(f=>O.$je.concat(f.map(d=>O.$je.wrap(d))).buffer),h=new I.$Sc;return h.add(this.a.listen("readFileStream",[l,$])(f=>{if(f instanceof O.$je)w.write(f.buffer);else{if(f==="end")w.end();else{let d;if(f instanceof Error)d=f;else{const c=f;d=(0,g.$Dk)(c.message??(0,L.$Qi)(c),c.code??g.FileSystemProviderErrorCode.Unknown)}w.error(d),w.end()}h.dispose()}})),h.add(b.onCancellationRequested(()=>{w.error((0,D.$6)()),w.end(),h.dispose()})),w}writeFile(l,$,b){return this.a.call("writeFile",[l,O.$je.wrap($),b])}open(l,$){return this.a.call("open",[l,$])}close(l){return this.a.call("close",[l])}async read(l,$,b,w,h){const[f,d]=await this.a.call("read",[l,$,h]);return b.set(f.buffer.slice(0,d),w),d}write(l,$,b,w,h){return this.a.call("write",[l,$,O.$je.wrap(b),w,h])}mkdir(l){return this.a.call("mkdir",[l])}delete(l,$){return this.a.call("delete",[l,$])}rename(l,$,b){return this.a.call("rename",[l,$,b])}copy(l,$,b){return this.a.call("copy",[l,$,b])}cloneFile(l,$){return this.a.call("cloneFile",[l,$])}j(){this.B(this.a.listen("fileChange",[this.h])(l=>{if(Array.isArray(l)){const $=l;this.f.fire((0,C.$hq)($))}else{const $=l;this.g.fire($)}}))}watch(l,$){const b=(0,k.$qg)();return this.a.call("watch",[this.h,b,l,$]),(0,I.$Rc)(()=>this.a.call("unwatch",[this.h,b]))}}e.$lO=S}),define(le[192],he([0,1,54,6,26,49,2,88,16,5,20,10,144,31,50]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0;class b extends I.$Tc{static{this.a=100}static{this.b=75}constructor(f,d,c,v){super(),this.m=f,this.n=d,this.r=c,this.s=v,this.c=this.B(new L.$ih({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},i=>this.n(i))),this.f=this.B(new L.$hh(i=>this.z(i),b.b)),this.g=(0,$.$kq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,$.$kq)(this.m.path,this.m.includes):void 0,this.j=new D.$6d,this.ready=this.t()}async t(){try{const f=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const d=await l.Promises.stat(f);this.B(await this.w(f,d.isDirectory()))}catch(f){f.code!=="ENOENT"?this.D(f):this.G(f)}}async u(f){let d=f.path;try{d=await l.Promises.realpath(f.path),f.path===d&&(d=await(0,m.$uq)(f.path)??f.path),f.path!==d&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${f.path}, real: ${d})`)}catch{}return d}async w(f,d){if(g.$j&&(0,A.$8f)(f,"/Volumes/",!0))return this.D(`Refusing to watch ${f} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),I.$Tc.None;const c=new D.$6d(this.j.token),v=new I.$Sc;try{const i=S.URI.file(this.m.path),o=(0,k.$nc)(f),n=(0,O.watch)(f);v.add((0,I.$Rc)(()=>{n.removeAllListeners(),n.close()})),this.G(`Started watching: '${f}'`);const s=new Set;if(d)try{for(const r of await l.Promises.readdir(f))s.add(r)}catch(r){this.D(r)}const t=new Map;v.add((0,I.$Rc)(()=>{for(const[,r]of t)r.dispose();t.clear()})),n.on("error",(r,a)=>{this.D(`Failed to watch ${f} for changes using fs.watch() (${r}, ${a})`),this.dispose()}),n.on("change",(r,a)=>{if(c.token.isCancellationRequested)return;this.G(`[raw] ["${r}"] ${a}`);let E="";if(a&&(E=a.toString(),g.$j&&(E=(0,P.$Gl)(E))),!(!E||r!=="change"&&r!=="rename"))if(d)if(r==="rename"){t.get(E)?.dispose();const y=setTimeout(async()=>{if(t.delete(E),E===o&&!await l.Promises.exists(f)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const u=await this.C((0,k.$jc)(f,E));if(c.token.isCancellationRequested)return;let p;u?s.has(E)?p=0:(p=1,s.add(E)):(s.delete(E),p=2),this.y({resource:(0,C.$Hg)(i,E),type:p,cId:this.m.correlationId})},b.a);t.set(E,(0,I.$Rc)(()=>clearTimeout(y)))}else{let y;s.has(E)?y=0:(y=1,s.add(E)),this.y({resource:(0,C.$Hg)(i,E),type:y,cId:this.m.correlationId})}else if(r==="rename"||E!==o){const y=setTimeout(async()=>{const u=await l.Promises.exists(f);c.token.isCancellationRequested||(u?(this.y({resource:i,type:0,cId:this.m.correlationId},!0),v.add(await this.w(f,!1))):(this.y({resource:i,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},b.a);v.clear(),v.add((0,I.$Rc)(()=>clearTimeout(y)))}else this.y({resource:i,type:0,cId:this.m.correlationId},!0)})}catch(i){await l.Promises.exists(f)&&!c.token.isCancellationRequested&&this.D(`Failed to watch ${f} for changes using fs.watch() (${i.toString()})`)}return(0,I.$Rc)(()=>{c.dispose(!0),v.dispose()})}y(f,d=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.resource.fsPath}`),!d&&this.g.some(c=>c(f.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${f.resource.fsPath}`):!d&&this.h&&this.h.length>0&&!this.h.some(c=>c(f.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${f.resource.fsPath}`):this.f.work(f))}z(f){const d=(0,$.$iq)(f);if(d.length>0){if(this.s)for(const v of d)this.G(` >> normalized ${v.type===1?"[ADDED]":v.type===2?"[DELETED]":"[CHANGED]"} ${v.resource.fsPath}`);this.c.work(d)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${d.length}, most recent change: ${d[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(f){if(g.$k)return l.Promises.exists(f);try{const d=(0,k.$nc)(f);return(await l.Promises.readdir((0,k.$mc)(f))).some(v=>v===d)}catch(d){return this.G(d),!1}}setVerboseLogging(f){this.s=f}D(f){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${f}`})}F(f){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${f}`})}G(f){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${f}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$xq=b;async function w(h,f,d,c,v=512){const i=await l.Promises.open(h,"r"),o=Buffer.allocUnsafe(v),n=new D.$6d(c);let s,t=!1;const r={path:h,excludes:[],recursive:!1},a=new b(r,E=>{(async()=>{for(const{type:y}of E)if(y===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:u}=await l.Promises.read(i,o,0,v,null);if(!u||n.token.isCancellationRequested)break;f(o.slice(0,u))}}catch(u){s=new Error(u),n.dispose(!0)}finally{t=!1}}})()});return await a.ready,d(),new Promise((E,y)=>{n.token.onCancellationRequested(async()=>{a.dispose();try{await l.Promises.close(i)}catch(u){s=new Error(u)}s?y(s):E()})})}e.$yq=w}),define(le[193],he([0,1,3,91,2,5,192]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class P extends D.$Tc{constructor(){super(...arguments),this.a=this.B(new O.$Vd),this.onDidChangeFile=this.a.event,this.b=this.B(new O.$Vd),this.onDidLogMessage=this.b.event,this.onDidError=O.Event.None,this.c=new Map,this.f=!1}async watch(g){const C=this.j(g),S=C.filter(l=>{const $=this.c.get(l.path);return $?!(0,L.$Qj)($.request.excludes,l.excludes)||!(0,L.$Qj)($.request.includes,l.includes):!0}),m=Array.from(this.c.values()).filter(({request:l})=>!C.find($=>$.path===l.path&&(0,L.$Qj)($.excludes,l.excludes)&&(0,L.$Qj)($.includes,l.includes))).map(({request:l})=>l.path);S.length&&this.m(`Request to start watching: ${S.map(l=>`${l.path} (excludes: ${l.excludes.length>0?l.excludes:"<none>"}, includes: ${l.includes&&l.includes.length>0?JSON.stringify(l.includes):"<all>"}, correlationId: ${typeof l.correlationId=="number"?l.correlationId:"<none>"})`).join(",")}`),m.length&&this.m(`Request to stop watching: ${m.join(",")}`);for(const l of m)this.h(l);for(const l of S)this.g(l)}g(g){const C=new I.$xq(g,m=>this.a.fire(m),m=>this.b.fire(m),this.f),S={request:g,instance:C};this.c.set(g.path,S)}async stop(){for(const[g]of this.c)this.h(g);this.c.clear()}h(g){const C=this.c.get(g);C&&(this.c.delete(g),C.instance.dispose())}j(g){const C=new Map;for(const S of g){const m=A.$k?S.path:S.path.toLowerCase();let l=C.get(S.correlationId);l||(l=new Map,C.set(S.correlationId,l)),l.set(m,S)}return Array.from(C.values()).map(S=>Array.from(S.values())).flat()}async setVerboseLogging(g){this.f=g;for(const[,C]of this.c)C.instance.setVerboseLogging(g)}m(g){this.f&&this.b.fire({type:"trace",message:this.n(g)})}n(g,C){return C?`[File Watcher (node.js)] ${g} (path: ${C.request.path})`:`[File Watcher (node.js)] ${g}`}}e.$zq=P}),define(le[194],he([0,1,50,193]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class D extends O.$fq{constructor(I,P,k){super(I,P,k),this.s()}r(I){return I.add(new L.$zq)}}e.$Aq=D}),define(le[195],he([0,1,23,40,93,50]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class I extends A.$gq{constructor(k,g,C){super(k,g,C),this.s()}r(k){const g=k.add(new D.$rq(O.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return k.add(g.onDidProcessExit(({code:C,signal:S})=>this.t(`terminated by itself with code ${C}, signal: ${S}`))),L.ProxyChannel.toService((0,L.$Mh)(g.getChannel("watcher")))}}e.$sq=I}),define(le[74],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class O{constructor(...D){this.a=new Map;for(const[A,I]of D)this.set(A,I)}set(D,A){const I=this.a.get(D);return this.a.set(D,A),I}has(D){return this.a.has(D)}get(D){return this.a.get(D)}}e.$4h=O}),define(le[196],he([0,1,6,7,2,72,187,4,74,87]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const C=!1;class S extends Error{constructor(w){super("cyclic dependency between services"),this.message=w.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${w.toString()}`}}class m{constructor(w=new k.$4h,h=!1,f,d=C){this.f=w,this.g=h,this.h=f,this.i=d,this.o=new Set,this.f.set(P.$5h,this),this._globalGraph=d?f?._globalGraph??new I.$Dq(c=>c):void 0}createChild(w){return new m(w,this.g,this,this.i)}invokeFunction(w,...h){const f=$.traceInvocation(this.i,w);let d=!1;try{return w({get:v=>{if(d)throw(0,L.$8)("service accessor is only valid during the invocation of its target method");const i=this.m(v,f);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...h)}finally{d=!0,f.stop()}}createInstance(w,...h){let f,d;return w instanceof A.$3h?(f=$.traceCreation(this.i,w.ctor),d=this.j(w.ctor,w.staticArguments.concat(h),f)):(f=$.traceCreation(this.i,w),d=this.j(w,h,f)),f.stop(),d}j(w,h=[],f){const d=P._util.getServiceDependencies(w).sort((i,o)=>i.index-o.index),c=[];for(const i of d){const o=this.m(i.id,f);o||this.u(`[createInstance] ${w.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(o)}const v=d.length>0?d[0].index:h.length;if(h.length!==v){console.trace(`[createInstance] First service dependency of ${w.name} at position ${v+1} conflicts with ${h.length} static arguments`);const i=v-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,v)}return Reflect.construct(w,h.concat(c))}k(w,h){if(this.f.get(w)instanceof A.$3h)this.f.set(w,h);else if(this.h)this.h.k(w,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(w){const h=this.f.get(w);return!h&&this.h?this.h.l(w):h}m(w,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(w));const f=this.l(w);return f instanceof A.$3h?this.q(w,f,h.branch(w,!0)):(h.branch(w,!1),f)}q(w,h,f){if(this.o.has(w))throw new Error(`illegal state - RECURSIVELY instantiating service '${w}'`);this.o.add(w);try{return this.r(w,h,f)}finally{this.o.delete(w)}}r(w,h,f){const d=new I.$Dq(i=>i.id.toString());let c=0;const v=[{id:w,desc:h,_trace:f}];for(;v.length;){const i=v.pop();if(d.lookupOrInsertNode(i),c++>1e3)throw new S(d);for(const o of P._util.getServiceDependencies(i.desc.ctor)){const n=this.l(o.id);if(n||this.u(`[createInstance] ${w} depends on ${o.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(o.id)),n instanceof A.$3h){const s={id:o.id,desc:n,_trace:i._trace.branch(o.id,!0)};d.insertEdge(i,s),v.push(s)}}}for(;;){const i=d.roots();if(i.length===0){if(!d.isEmpty())throw new S(d);break}for(const{data:o}of i){if(this.l(o.id)instanceof A.$3h){const s=this.s(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this.k(o.id,s)}d.removeNode(o)}}return this.l(w)}s(w,h,f=[],d,c){if(this.f.get(w)instanceof A.$3h)return this.t(w,h,f,d,c);if(this.h)return this.h.s(w,h,f,d,c);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(w,h,f=[],d,c){if(d){const v=new m(void 0,this.g,this,this.i);v.c=String(w);const i=new Map,o=new O.$mh(()=>{const n=v.j(h,f,c);for(const[s,t]of i){const r=n[s];if(typeof r=="function")for(const a of t)a.disposable=r.apply(n,a.listener)}return i.clear(),n});return new Proxy(Object.create(null),{get(n,s){if(!o.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let a=i.get(s);return a||(a=new g.$4c,i.set(s,a)),(y,u,p)=>{if(o.isInitialized)return o.value[s](y,u,p);{const R={listener:[y,u,p],disposable:void 0},N=a.push(R);return(0,D.$Rc)(()=>{N(),R.disposable?.dispose()})}}}if(s in n)return n[s];const t=o.value;let r=t[s];return typeof r!="function"||(r=r.bind(t),n[s]=r),r},set(n,s,t){return o.value[s]=t,!0},getPrototypeOf(n){return h.prototype}})}else return this.j(h,f,c)}u(w,h){if(h&&console.warn(w),this.g)throw new Error(w)}}e.$Eq=m;var l;(function(b){b[b.None=0]="None",b[b.Creation=1]="Creation",b[b.Invocation=2]="Invocation",b[b.Branch=3]="Branch"})(l||(l={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(w,h){return w?new $(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(w,h){return w?new $(1,h.name):$.c}static{this.f=0}constructor(w,h){this.type=w,this.name=h,this.g=Date.now(),this.h=[]}branch(w,h){const f=new $(3,w.toString());return this.h.push([w,h,f]),f}stop(){const w=Date.now()-this.g;$.f+=w;let h=!1;function f(c,v){const i=[],o=new Array(c+1).join("	");for(const[n,s,t]of v.h)if(s&&t){h=!0,i.push(`${o}CREATES -> ${n}`);const r=f(c+1,t);r&&i.push(r)}else i.push(`${o}uses -> ${n}`);return i.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${f(1,this)}`,`DONE, took ${w.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(w>2||h)&&$.all.add(d.join(`
`))}}e.$Fq=$}),define(le[56],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L_b=e.$K_b=void 0,e.$K_b=(0,O.$6h)("mainProcessService");class L{constructor(A,I){this.a=A,this.b=I}getChannel(A){return this.a.getChannel(A,this.b)}registerChannel(A,I){this.a.registerChannel(A,I)}}e.$L_b=L}),define(le[75],he([0,1,26,2,5,163,29,4]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=e.$gr=void 0;function k(C){return C.tags.find(S=>S.startsWith("lp-"))?.split("lp-")[1]}e.$gr=k,e.$hr=(0,P.$6h)("languagePackService");let g=class extends L.$Tc{constructor(S){super(),this.c=S}async getAvailableLanguages(){const S=new O.$6d;setTimeout(()=>S.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},S.token)}catch{return[]}const $=m.firstPage.filter(b=>b.properties.localizedLanguages?.length&&b.tags.some(w=>w.startsWith("lp-"))).map(b=>{const w=b.properties.localizedLanguages?.[0],h=k(b);return{...this.f(h,w,b),extensionId:b.identifier.id,galleryExtension:b}});return $.push(this.f("en","English")),$}f(S,m,l){const $=m??S;let b;if($!==S&&(b=`(${S})`),S.toLowerCase()===D.$w.toLowerCase()&&(b??="",b+=(0,A.localize)(0,null)),l?.installCount){b??="";const w=l.installCount;let h;w>1e6?h=`${Math.floor(w/1e5)/10}M`:w>1e3?h=`${Math.floor(w/1e3)}K`:h=String(w),b+=` $(cloud-download) ${h}`}return{id:S,label:$,description:b}}};e.$ir=g,e.$ir=g=pe([X(0,I.$yo)],g)}),define(le[197],he([0,1,2,75]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$__b=void 0;let D=class extends O.$Tc{constructor(I){super(),this.a=I,this.b()}b(){this.a.update()}};e.$__b=D,e.$__b=D=pe([X(0,L.$hr)],D)}),define(le[8],he([0,1,38,3,53,2,35,5,20,12,10,94,4]),function(se,e,O,L,D,A,I,P,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,m.$6h)("logService"),e.$oj=(0,m.$6h)("loggerService");function l(){return new Date().toISOString()}function $(y){return(0,g.$Mf)(y)}e.$pj=$;var b;(function(y){y[y.Off=0]="Off",y[y.Trace=1]="Trace",y[y.Debug=2]="Debug",y[y.Info=3]="Info",y[y.Warning=4]="Warning",y[y.Error=5]="Error"})(b||(e.LogLevel=b={})),e.$qj=b.Info;function w(y,u,p){switch(u){case b.Trace:y.trace(p);break;case b.Debug:y.debug(p);break;case b.Info:y.info(p);break;case b.Warning:y.warn(p);break;case b.Error:y.error(p);break;case b.Off:break;default:throw new Error(`Invalid log level ${u}`)}}e.log=w;function h(y,u=!1){let p="";for(let R=0;R<y.length;R++){let N=y[R];if(N instanceof Error&&(N=(0,O.$Qi)(N,u)),typeof N=="object")try{N=JSON.stringify(N)}catch{}p+=(R>0?" ":"")+N}return p}class f extends A.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new L.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(u){this.b!==u&&(this.b=u,this.c.fire(this.b))}getLevel(){return this.b}f(u){return this.b!==b.Off&&this.b<=u}}e.$sj=f;class d extends f{constructor(u){super(),this.h=u}f(u){return this.h||super.f(u)}trace(u,...p){this.f(b.Trace)&&this.g(b.Trace,h([u,...p],!0))}debug(u,...p){this.f(b.Debug)&&this.g(b.Debug,h([u,...p]))}info(u,...p){this.f(b.Info)&&this.g(b.Info,h([u,...p]))}warn(u,...p){this.f(b.Warning)&&this.g(b.Warning,h([u,...p]))}error(u,...p){if(this.f(b.Error))if(u instanceof Error){const R=Array.prototype.slice.call(arguments);R[0]=u.stack,this.g(b.Error,h(R))}else this.g(b.Error,h([u,...p]))}flush(){}}e.$tj=d;class c extends f{constructor(u=e.$qj){super(),this.setLevel(u),this.g=!P.$i}trace(u,...p){this.f(b.Trace)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}debug(u,...p){this.f(b.Debug)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}info(u,...p){this.f(b.Info)&&(this.g?console.log(`\x1B[90m[main ${l()}]\x1B[0m`,u,...p):console.log(`[main ${l()}]`,u,...p))}warn(u,...p){this.f(b.Warning)&&(this.g?console.warn(`\x1B[93m[main ${l()}]\x1B[0m`,u,...p):console.warn(`[main ${l()}]`,u,...p))}error(u,...p){this.f(b.Error)&&(this.g?console.error(`\x1B[91m[main ${l()}]\x1B[0m`,u,...p):console.error(`[main ${l()}]`,u,...p))}flush(){}}e.$uj=c;class v extends f{constructor(u=e.$qj,p=!0){super(),this.g=p,this.setLevel(u)}trace(u,...p){this.f(b.Trace)&&(this.g?console.log("%cTRACE","color: #888",u,...p):console.log(u,...p))}debug(u,...p){this.f(b.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",u,...p):console.log(u,...p))}info(u,...p){this.f(b.Info)&&(this.g?console.log("%c INFO","color: #33f",u,...p):console.log(u,...p))}warn(u,...p){this.f(b.Warning)&&(this.g?console.log("%c WARN","color: #993",u,...p):console.log(u,...p))}error(u,...p){this.f(b.Error)&&(this.g?console.log("%c  ERR","color: #f33",u,...p):console.error(u,...p))}flush(){}}e.$vj=v;class i extends f{constructor(u,p=e.$qj){super(),this.g=u,this.setLevel(p)}trace(u,...p){this.f(b.Trace)&&this.g.log(b.Trace,[this.h(u),...p])}debug(u,...p){this.f(b.Debug)&&this.g.log(b.Debug,[this.h(u),...p])}info(u,...p){this.f(b.Info)&&this.g.log(b.Info,[this.h(u),...p])}warn(u,...p){this.f(b.Warning)&&this.g.log(b.Warning,[this.h(u),...p])}error(u,...p){this.f(b.Error)&&this.g.log(b.Error,[this.h(u),...p])}h(u){return typeof u=="string"?u:(0,O.$Qi)(u,this.f(b.Trace))}flush(){}}e.$wj=i;class o extends f{constructor(u){super(),this.g=u,u.length&&this.setLevel(u[0].getLevel())}setLevel(u){for(const p of this.g)p.setLevel(u);super.setLevel(u)}trace(u,...p){for(const R of this.g)R.trace(u,...p)}debug(u,...p){for(const R of this.g)R.debug(u,...p)}info(u,...p){for(const R of this.g)R.info(u,...p)}warn(u,...p){for(const R of this.g)R.warn(u,...p)}error(u,...p){for(const R of this.g)R.error(u,...p)}flush(){for(const u of this.g)u.flush()}dispose(){for(const u of this.g)u.dispose();super.dispose()}}e.$xj=o;class n extends A.$Tc{constructor(u,p,R){if(super(),this.h=u,this.j=p,this.b=new I.$Ac,this.c=this.B(new L.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Vd),this.onDidChangeVisibility=this.g.event,R)for(const N of R)this.b.set(N.resource,{logger:void 0,info:N})}m(u){return(0,g.$If)(u)?[...this.b.values()].find(p=>p.info.id===u):this.b.get(u)}getLogger(u){return this.m(u)?.logger}createLogger(u,p){const R=this.n(u),N=(0,g.$If)(u)?u:p?.id??(0,D.$Ti)(R.toString()).toString(16);let T=this.b.get(R)?.logger;const M=p?.logLevel==="always"?b.Trace:p?.logLevel;T||(T=this.s(R,M??this.getLogLevel(R)??this.h,{...p,id:N}));const U={logger:T,info:{resource:R,id:N,logLevel:M,name:p?.name,hidden:p?.hidden,extensionId:p?.extensionId,when:p?.when}};return this.registerLogger(U.info),this.b.set(R,U),T}n(u){return(0,g.$If)(u)?(0,k.$Hg)(this.j,`${u}.log`):u}setLogLevel(u,p){if(C.URI.isUri(u)){const R=u,N=p,T=this.b.get(R);T&&N!==T.info.logLevel&&(T.info.logLevel=N===this.h?void 0:N,T.logger?.setLevel(N),this.b.set(T.info.resource,T),this.f.fire([R,N]))}else{this.h=u;for(const[R,N]of this.b.entries())this.b.get(R)?.info.logLevel===void 0&&N.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(u,p){const R=this.m(u);R&&p!==!R.info.hidden&&(R.info.hidden=!p,this.b.set(R.info.resource,R),this.g.fire([R.info.resource,p]))}getLogLevel(u){let p;return u&&(p=this.b.get(u)?.info.logLevel),p??this.h}registerLogger(u){const p=this.b.get(u.resource);p?p.info.hidden!==u.hidden&&this.setVisibility(u.resource,!u.hidden):(this.b.set(u.resource,{info:u,logger:void 0}),this.c.fire({added:[u],removed:[]}))}deregisterLogger(u){const p=this.b.get(u);p&&(p.logger&&p.logger.dispose(),this.b.delete(u),this.c.fire({added:[],removed:[p.info]}))}*getRegisteredLoggers(){for(const u of this.b.values())yield u.info}getRegisteredLogger(u){return this.b.get(u)?.info}dispose(){this.b.forEach(u=>u.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=n;class s{constructor(){this.onDidChangeLogLevel=new L.$Vd().event}setLevel(u){}getLevel(){return b.Info}trace(u,...p){}debug(u,...p){}info(u,...p){}warn(u,...p){}error(u,...p){}critical(u,...p){}dispose(){}flush(){}}e.$zj=s;class t extends s{}e.$Aj=t;function r(y){if(y.verbose)return b.Trace;if(typeof y.logLevel=="string"){const u=E(y.logLevel.toLowerCase());if(u!==void 0)return u}return e.$qj}e.$Bj=r;function a(y){switch(y){case b.Trace:return"trace";case b.Debug:return"debug";case b.Info:return"info";case b.Warning:return"warn";case b.Error:return"error";case b.Off:return"off"}}e.$Cj=a;function E(y){switch(y){case"trace":return b.Trace;case"debug":return b.Debug;case"info":return b.Info;case"warn":return b.Warning;case"error":return b.Error;case"critical":return b.Error;case"off":return b.Off}}e.$Dj=E,e.$Ej=new S.$kj("logLevel",a(b.Info))}),define(le[198],he([0,1,6,7,2,23,16,20,31,15,8]),function(se,e,O,L,D,A,I,P,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aac=void 0;let S=class extends D.$Tc{constructor(l,$){super(),this.a=l,this.b=$,this.B(new O.$fh(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const l=(0,P.$Eg)(this.a.logsHome),$=(0,P.$Gg)(this.a.logsHome.with({scheme:A.Schemas.file})).fsPath,h=(await k.Promises.readdir($)).filter(d=>/^\d{8}T\d{6}$/.test(d)).sort().filter(d=>d!==l),f=h.slice(0,Math.max(0,h.length-9));f.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${f.join(", ")}'`),await Promise.all(f.map(d=>k.Promises.rm((0,I.$jc)($,d)))))}catch(l){(0,L.$1)(l)}}};e.$aac=S,e.$aac=S=pe([X(0,g.$ai),X(1,C.$nj)],S)}),define(le[99],he([0,1,7,4,8]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gp=e.$Fp=void 0,e.$Fp=(0,L.$6h)("IExtensionSignatureVerificationService");let A=class{constructor(P){this.b=P}c(){return this.a||(this.a=new Promise((P,k)=>se(["node-vsce-sign"],async g=>P(g),k))),this.a}async verify(P,k,g){let C;try{C=await this.c()}catch(S){return this.b.error("Could not load vsce-sign module",(0,O.$0)(S)),!1}return C.verify(P,k,g)}};e.$Gp=A,e.$Gp=A=pe([X(0,D.$nj)],A)}),define(le[199],he([0,1,17,6,7,3,2,16,50,8]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class C extends I.$Tc{constructor(m,l){super(),this.a=m,this.b=l,this.c=this.B(new A.$Vd),this.onDidChangeFile=this.c.event,this.g=this.B(new A.$Vd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new L.$4g(0)),this.w=[],this.y=this.B(new L.$4g(0))}watch(m,l){return l.recursive||this.b?.watcher?.forceUniversal?this.n(m,l):this.z(m,l)}n(m,l){const $={path:this.H(m),excludes:l.excludes,includes:l.includes,recursive:l.recursive,correlationId:l.correlationId},b=(0,O.$Ub)(this.j,$);return this.r(),(0,I.$Rc)(()=>{b(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(m=>(0,D.$1)(m))}s(){this.h||(this.h=this.B(this.t(l=>this.c.fire((0,k.$hq)(l)),l=>this.G(l),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const l of this.j)(0,k.$dq)(l)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const l of this.j)(0,k.$dq)(l)&&m.includes(l.path)&&(l.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(m,l){const $={path:this.H(m),excludes:l.excludes,includes:l.includes,recursive:!1,correlationId:l.correlationId},b=(0,O.$Ub)(this.w,$);return this.C(),(0,I.$Rc)(()=>{b(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(m=>(0,D.$1)(m))}D(){return this.u||(this.u=this.B(this.F(m=>this.c.fire((0,k.$hq)(m)),m=>this.G(m),this.a.getLevel()===g.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===g.LogLevel.Trace)}))),this.u.watch(this.w)}G(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}H(m){return(0,P.$hc)(m.fsPath)}}e.$lq=C}),define(le[200],he([0,1,17,6,14,26,3,53,61,2,48,23,100,20,47,159,11,98,8,7]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=void 0;let v=class extends g.$Tc{static{c=this}constructor(o){super(),this.b=o,this.a=256*1024,this.c=this.B(new I.$Vd),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new I.$Vd),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new I.$Vd),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new I.$Vd),this.onDidRunOperation=this.r.event,this.X=this.B(new I.$Vd),this.Y=this.B(new I.$Vd),this.onDidFilesChange=this.Y.event,this.Z=this.B(new I.$Vd),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new L.$ch)}registerProvider(o,n){if(this.h.has(o))throw new Error(`A filesystem provider for the scheme '${o}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${o}`);const s=new g.$Sc;return this.h.set(o,n),this.c.fire({added:!0,scheme:o,provider:n}),s.add(n.onDidChangeFile(t=>{const r=new w.$Jk(t,!this.S(n));this.X.fire(r),r.hasCorrelation()||this.Y.fire(r)})),typeof n.onDidWatchError=="function"&&s.add(n.onDidWatchError(t=>this.Z.fire(new Error(t)))),s.add(n.onDidChangeCapabilities(()=>this.g.fire({provider:n,scheme:o}))),(0,g.$Rc)(()=>{this.c.fire({added:!1,scheme:o,provider:n}),this.h.delete(o),(0,g.$Oc)(s)})}getProvider(o){return this.h.get(o)}async activateProvider(o){const n=[];this.f.fire({scheme:o,join(s){n.push(s)}}),!this.h.has(o)&&await L.Promises.settled(n)}async canHandleResource(o){return await this.activateProvider(o.scheme),this.hasProvider(o)}hasProvider(o){return this.h.has(o.scheme)}hasCapability(o,n){const s=this.h.get(o.scheme);return!!(s&&s.capabilities&n)}listCapabilities(){return k.Iterable.map(this.h,([o,n])=>({scheme:o,capabilities:n.capabilities}))}async j(o){if(!(0,l.$Lg)(o))throw new w.$Lk((0,b.localize)(0,null,this.sb(o)),8);await this.activateProvider(o.scheme);const n=this.h.get(o.scheme);if(!n){const s=new d.$bb;throw s.message=(0,b.localize)(1,null,o.toString()),s}return n}async m(o){const n=await this.j(o);if((0,w.$wk)(n)||(0,w.$tk)(n)||(0,w.$xk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(o){const n=await this.j(o);if((0,w.$wk)(n)||(0,w.$tk)(n))return n;throw new Error(`Filesystem provider for scheme '${o.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(o,n){try{return await this.s(o,n)}catch(s){throw(0,w.$Gk)(s)===w.FileSystemProviderErrorCode.FileNotFound?new w.$Lk((0,b.localize)(2,null,this.sb(o)),1):(0,w.$Ek)(s)}}async s(o,n){const s=await this.j(o),t=this.S(s),r=n?.resolveTo,a=n?.resolveSingleChildDescendants,E=n?.resolveMetadata,y=await s.stat(o);let u;return this.t(s,o,y,void 0,!!E,(p,R)=>(u||(u=C.$_h.forUris(()=>!t),u.set(o,!0),r&&u.fill(!0,r)),u.get(p.resource)||u.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&a?R===1:!1))}async t(o,n,s,t,r,a){const{providerExtUri:E}=this.R(o),y={resource:n,name:E.basename(n),isFile:(s.type&w.FileType.File)!==0,isDirectory:(s.type&w.FileType.Directory)!==0,isSymbolicLink:(s.type&w.FileType.SymbolicLink)!==0,mtime:s.mtime,ctime:s.ctime,size:s.size,readonly:!!((s.permissions??0)&w.FilePermission.Readonly)||!!(o.capabilities&2048),locked:!!((s.permissions??0)&w.FilePermission.Locked),etag:(0,w.$Wk)({mtime:s.mtime,size:s.size}),children:void 0};if(y.isDirectory&&a(y,t)){try{const u=await o.readdir(n),p=await L.Promises.settled(u.map(async([R,N])=>{try{const T=E.joinPath(n,R),M=r?await o.stat(T):{type:N};return await this.t(o,T,M,u.length,r,a)}catch(T){return this.b.trace(T),null}}));y.children=(0,O.$Hb)(p)}catch(u){this.b.trace(u),y.children=[]}return y}return y}async resolveAll(o){return L.Promises.settled(o.map(async n=>{try{return{stat:await this.s(n.resource,n.options),success:!0}}catch(s){return this.b.trace(s),{stat:void 0,success:!1}}}))}async stat(o){const n=await this.j(o),s=await n.stat(o);return this.t(n,o,s,void 0,!0,()=>!1)}async exists(o){const n=await this.j(o);try{return!!await n.stat(o)}catch{return!1}}async canCreateFile(o,n){try{await this.u(o,n)}catch(s){return s}return!0}async u(o,n){if(!n?.overwrite&&await this.exists(o))throw new w.$Lk((0,b.localize)(3,null,this.sb(o)),3,n)}async createFile(o,n=D.$je.fromString(""),s){await this.u(o,s);const t=await this.writeFile(o,n);return this.r.fire(new w.$Ik(o,0,t)),t}async writeFile(o,n,s){const t=this.qb(await this.n(o),o),{providerExtUri:r}=this.R(t);let a=s;if((0,w.$zk)(t)&&!a?.atomic){const E=t.enforceAtomicWriteFile?.(o);E&&(a={...s,atomic:E})}try{await this.w(t,o,a)||await this.U(t,r.dirname(o));let y;if((0,w.$tk)(t)&&!(n instanceof D.$je))if((0,$.$8d)(n)){const u=await(0,$.$ce)(n,3);u.ended?y=D.$je.concat(u.buffer):y=u}else y=(0,$.$_d)(n,u=>D.$je.concat(u),3);else y=n;!(0,w.$wk)(t)||(0,w.$tk)(t)&&y instanceof D.$je||(0,w.$tk)(t)&&(0,w.$zk)(t)&&a?.atomic?await this.hb(t,o,a,y):await this.db(t,o,a,y instanceof D.$je?(0,D.$ue)(y):y),this.r.fire(new w.$Ik(o,4))}catch(E){throw new w.$Lk((0,b.localize)(4,null,this.sb(o),(0,w.$Ek)(E).toString()),(0,w.$Hk)(E),a)}return this.resolve(o,{resolveMetadata:!0})}async w(o,n,s){const t=!!s?.unlock;if(t&&!(o.capabilities&8192))throw new Error((0,b.localize)(5,null,this.sb(n)));if(!!s?.atomic){if(!(o.capabilities&32768))throw new Error((0,b.localize)(6,null,this.sb(n)));if(!(o.capabilities&2))throw new Error((0,b.localize)(7,null,this.sb(n)));if(t)throw new Error((0,b.localize)(8,null,this.sb(n)))}let a;try{a=await o.stat(n)}catch{return}if(a.type&w.FileType.Directory)throw new w.$Lk((0,b.localize)(9,null,this.sb(n)),0,s);if(this.rb(n,a),typeof s?.mtime=="number"&&typeof s.etag=="string"&&s.etag!==w.$Vk&&typeof a.mtime=="number"&&typeof a.size=="number"&&s.mtime<a.mtime&&s.etag!==(0,w.$Wk)({mtime:s.mtime,size:a.size}))throw new w.$Lk((0,b.localize)(10,null),3,s);return a}async readFile(o,n,s){const t=await this.m(o);return n?.atomic?this.z(t,o,n,s):this.C(t,o,n,s)}async z(o,n,s,t){return new Promise((r,a)=>{this.cb.queueFor(n,async()=>{try{const E=await this.C(o,n,s,t);r(E)}catch(E){a(E)}},this.R(o).providerExtUri)})}async C(o,n,s,t){const r=await this.D(o,n,{...s,preferUnbuffered:!0},t);return{...r,value:await(0,D.$ve)(r.value)}}async readFileStream(o,n,s){const t=await this.m(o);return this.D(t,o,n,s)}async D(o,n,s,t){const r=new A.$6d(t);let a=s;(0,w.$yk)(o)&&o.enforceAtomicReadFile?.(n)&&(a={...s,atomic:!0});const E=this.J(n,a).then(u=>u,u=>{throw r.dispose(!0),u});let y;try{return typeof a?.etag=="string"&&a.etag!==w.$Vk&&await E,a?.atomic&&(0,w.$yk)(o)||!((0,w.$wk)(o)||(0,w.$xk)(o))||(0,w.$tk)(o)&&a?.preferUnbuffered?y=this.I(o,n,a):(0,w.$xk)(o)?y=this.G(o,n,r.token,a):y=this.H(o,n,r.token,a),y.on("end",()=>r.dispose()),y.on("error",()=>r.dispose()),{...await E,value:y}}catch(u){throw y&&await(0,$.$ae)(y),this.F(u,n,a)}}F(o,n,s){const t=(0,b.localize)(11,null,this.sb(n),(0,w.$Ek)(o).toString());return o instanceof w.$Nk?new w.$Nk(t,o.stat,s):o instanceof w.$Mk?new w.$Mk(t,o.fileOperationResult,o.size,o.options):new w.$Lk(t,(0,w.$Hk)(o),s)}G(o,n,s,t=Object.create(null)){const r=o.readFileStream(n,t,s);return(0,$.$ge)(r,{data:a=>a instanceof D.$je?a:D.$je.wrap(a),error:a=>this.F(a,n,t)},a=>D.$je.concat(a))}H(o,n,s,t=Object.create(null)){const r=(0,D.$ze)();return(0,h.$bq)(o,n,r,a=>a,{...t,bufferSize:this.a,errorTransformer:a=>this.F(a,n,t)},s),r}I(o,n,s){const t=(0,$.$0d)(r=>D.$je.concat(r));return(async()=>{try{let r;s?.atomic&&(0,w.$yk)(o)?r=await o.readFile(n,{atomic:!0}):r=await o.readFile(n),typeof s?.position=="number"&&(r=r.slice(s.position)),typeof s?.length=="number"&&(r=r.slice(0,s.length)),this.L(n,r.byteLength,s),t.end(D.$je.wrap(r))}catch(r){t.error(r),t.end()}})(),t}async J(o,n){const s=await this.resolve(o,{resolveMetadata:!0});if(s.isDirectory)throw new w.$Lk((0,b.localize)(12,null,this.sb(o)),0,n);if(typeof n?.etag=="string"&&n.etag!==w.$Vk&&n.etag===s.etag)throw new w.$Nk((0,b.localize)(13,null),s,n);return this.L(o,s.size,n),s}L(o,n,s){if(typeof s?.limits?.size=="number"&&n>s.limits.size)throw new w.$Mk((0,b.localize)(14,null,this.sb(o)),7,n,s)}async canMove(o,n,s){return this.M(o,n,"move",s)}async canCopy(o,n,s){return this.M(o,n,"copy",s)}async M(o,n,s,t){if(o.toString()!==n.toString())try{const r=s==="move"?this.qb(await this.n(o),o):await this.m(o),a=this.qb(await this.n(n),n);await this.Q(r,o,a,n,s,t)}catch(r){return r}return!0}async move(o,n,s){const t=this.qb(await this.n(o),o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"move",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$Ik(o,a==="move"?2:3,E)),E}async copy(o,n,s){const t=await this.m(o),r=this.qb(await this.n(n),n),a=await this.N(t,o,r,n,"copy",!!s),E=await this.resolve(n,{resolveMetadata:!0});return this.r.fire(new w.$Ik(o,a==="copy"?3:2,E)),E}async N(o,n,s,t,r,a){if(n.toString()===t.toString())return r;const{exists:E,isSameResourceWithDifferentPathCase:y}=await this.Q(o,n,s,t,r,a);if(E&&!y&&a&&await this.del(t,{recursive:!0}),await this.U(s,this.R(s).providerExtUri.dirname(t)),r==="copy"){if(o===s&&(0,w.$uk)(o))await o.copy(n,t,{overwrite:a});else{const u=await this.resolve(n);u.isDirectory?await this.P(o,u,s,t):await this.O(o,n,s,t)}return r}else return o===s?(await o.rename(n,t,{overwrite:a}),r):(await this.N(o,n,s,t,"copy",a),await this.del(n,{recursive:!0}),"copy")}async O(o,n,s,t){if((0,w.$wk)(o)&&(0,w.$wk)(s))return this.jb(o,n,s,t);if((0,w.$wk)(o)&&(0,w.$tk)(s))return this.pb(o,n,s,t);if((0,w.$tk)(o)&&(0,w.$wk)(s))return this.nb(o,n,s,t);if((0,w.$tk)(o)&&(0,w.$tk)(s))return this.lb(o,n,s,t)}async P(o,n,s,t){await s.mkdir(t),Array.isArray(n.children)&&await L.Promises.settled(n.children.map(async r=>{const a=this.R(s).providerExtUri.joinPath(t,r.name);return r.isDirectory?this.P(o,await this.resolve(r.resource),s,a):this.O(o,r.resource,s,a)}))}async Q(o,n,s,t,r,a){let E=!1;if(o===s){const{providerExtUri:u,isPathCaseSensitive:p}=this.R(o);if(p||(E=u.isEqual(n,t)),E&&r==="copy")throw new Error((0,b.localize)(15,null,this.sb(n),this.sb(t)));if(!E&&u.isEqualOrParent(t,n))throw new Error((0,b.localize)(16,null,this.sb(n),this.sb(t)))}const y=await this.exists(t);if(y&&!E){if(!a)throw new w.$Lk((0,b.localize)(17,null,this.sb(n),this.sb(t)),4);if(o===s){const{providerExtUri:u}=this.R(o);if(u.isEqualOrParent(n,t))throw new Error((0,b.localize)(18,null,this.sb(n),this.sb(t)))}}return{exists:y,isSameResourceWithDifferentPathCase:E}}R(o){const n=this.S(o);return{providerExtUri:n?l.$xg:l.$zg,isPathCaseSensitive:n}}S(o){return!!(o.capabilities&1024)}async createFolder(o){const n=this.qb(await this.j(o),o);await this.U(n,o);const s=await this.resolve(o,{resolveMetadata:!0});return this.r.fire(new w.$Ik(o,0,s)),s}async U(o,n){const s=[],{providerExtUri:t}=this.R(o);for(;!t.isEqual(n,t.dirname(n));)try{if(!((await o.stat(n)).type&w.FileType.Directory))throw new Error((0,b.localize)(19,null,this.sb(n)));break}catch(r){if((0,w.$Gk)(r)!==w.FileSystemProviderErrorCode.FileNotFound)throw r;s.push(t.basename(n)),n=t.dirname(n)}for(let r=s.length-1;r>=0;r--){n=t.joinPath(n,s[r]);try{await o.mkdir(n)}catch(a){if((0,w.$Gk)(a)!==w.FileSystemProviderErrorCode.FileExists)throw a}}}async canDelete(o,n){try{await this.W(o,n)}catch(s){return s}return!0}async W(o,n){const s=this.qb(await this.j(o),o),t=!!n?.useTrash;if(t&&!(s.capabilities&4096))throw new Error((0,b.localize)(20,null,this.sb(o)));const r=n?.atomic;if(r&&!(s.capabilities&65536))throw new Error((0,b.localize)(21,null,this.sb(o)));if(t&&r)throw new Error((0,b.localize)(22,null,this.sb(o)));let a;try{a=await s.stat(o)}catch{}if(a)this.rb(o,a);else throw new w.$Lk((0,b.localize)(23,null,this.sb(o)),1);if(!!!n?.recursive){const y=await this.resolve(o);if(y.isDirectory&&Array.isArray(y.children)&&y.children.length>0)throw new Error((0,b.localize)(24,null,this.sb(o)))}return s}async del(o,n){const s=await this.W(o,n);let t=n;if((0,w.$Ak)(s)&&!t?.atomic){const y=s.enforceAtomicDelete?.(o);y&&(t={...n,atomic:y})}const r=!!t?.useTrash,a=!!t?.recursive,E=t?.atomic??!1;await s.delete(o,{recursive:a,useTrash:r,atomic:E}),this.r.fire(new w.$Ik(o,1))}async cloneFile(o,n){const s=await this.j(o),t=this.qb(await this.n(n),n);if(!(s===t&&this.R(s).providerExtUri.isEqual(o,n)))return s===t&&(0,w.$vk)(s)?s.cloneFile(o,n):(await this.U(t,this.R(t).providerExtUri.dirname(n)),s===t&&(0,w.$uk)(s)?this.cb.queueFor(o,()=>s.copy(o,n,{overwrite:!0}),this.R(s).providerExtUri):this.cb.queueFor(o,()=>this.O(s,o,t,n),this.R(s).providerExtUri))}static{this.ab=0}createWatcher(o,n){return this.watch(o,{...n,correlationId:c.ab++})}watch(o,n={recursive:!1,excludes:[]}){const s=new g.$Sc;let t=!1,r=()=>{t=!0};s.add((0,g.$Rc)(()=>r())),(async()=>{try{const E=await this.bb(o,n);t?(0,g.$Oc)(E):r=()=>(0,g.$Oc)(E)}catch(E){this.b.error(E)}})();const a=n.correlationId;if(typeof a=="number"){const E=s.add(new I.$Vd);return s.add(this.X.event(u=>{u.correlates(a)&&E.fire(u)})),{onDidChange:E.event,dispose:()=>s.dispose()}}return s}async bb(o,n){const s=await this.j(o),t=(0,P.$Ti)([this.R(s).providerExtUri.getComparisonKey(o),n]);let r=this.$.get(t);return r||(r={count:0,disposable:s.watch(o,n)},this.$.set(t,r)),r.count+=1,(0,g.$Rc)(()=>{r&&(r.count--,r.count===0&&((0,g.$Oc)(r.disposable),this.$.delete(t)))})}dispose(){super.dispose();for(const[,o]of this.$)(0,g.$Oc)(o.disposable);this.$.clear()}async db(o,n,s,t){return this.cb.queueFor(n,async()=>{const r=await o.open(n,{create:!0,unlock:s?.unlock??!1});try{(0,$.$8d)(t)||(0,$.$9d)(t)?await this.eb(o,r,t):await this.fb(o,r,t)}catch(a){throw(0,w.$Ek)(a)}finally{await o.close(r)}},this.R(o).providerExtUri)}async eb(o,n,s){let t=0,r;if((0,$.$9d)(s)){if(s.buffer.length>0){const a=D.$je.concat(s.buffer);await this.gb(o,n,a,a.byteLength,t,0),t+=a.byteLength}if(s.ended)return;r=s.stream}else r=s;return new Promise((a,E)=>{(0,$.$be)(r,{onData:async y=>{r.pause();try{await this.gb(o,n,y,y.byteLength,t,0)}catch(u){return E(u)}t+=y.byteLength,setTimeout(()=>r.resume())},onError:y=>E(y),onEnd:()=>a()})})}async fb(o,n,s){let t=0,r;for(;(r=s.read())!==null;)await this.gb(o,n,r,r.byteLength,t,0),t+=r.byteLength}async gb(o,n,s,t,r,a){let E=0;for(;E<t;){const y=await o.write(n,r+E,s.buffer,a+E,t-E);E+=y}}async hb(o,n,s,t){return this.cb.queueFor(n,()=>this.ib(o,n,s,t),this.R(o).providerExtUri)}async ib(o,n,s,t){let r;t instanceof D.$je?r=t:(0,$.$8d)(t)?r=await(0,D.$ve)(t):(0,$.$9d)(t)?r=await(0,D.$we)(t):r=(0,D.$te)(t),await o.writeFile(n,r.buffer,{create:!0,overwrite:!0,unlock:s?.unlock??!1,atomic:s?.atomic??!1})}async jb(o,n,s,t){return this.cb.queueFor(t,()=>this.kb(o,n,s,t),this.R(s).providerExtUri)}async kb(o,n,s,t){let r,a;try{r=await o.open(n,{create:!1}),a=await s.open(t,{create:!0,unlock:!1});const E=D.$je.alloc(this.a);let y=0,u=0,p=0;do p=await o.read(r,y,E.buffer,u,E.byteLength-u),await this.gb(s,a,E,p,y,u),y+=p,u+=p,u===E.byteLength&&(u=0);while(p>0)}catch(E){throw(0,w.$Ek)(E)}finally{await L.Promises.settled([typeof r=="number"?o.close(r):Promise.resolve(),typeof a=="number"?s.close(a):Promise.resolve()])}}async lb(o,n,s,t){return this.cb.queueFor(t,()=>this.mb(o,n,s,t),this.R(s).providerExtUri)}async mb(o,n,s,t){return s.writeFile(t,await o.readFile(n),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(o,n,s,t){return this.cb.queueFor(t,()=>this.ob(o,n,s,t),this.R(s).providerExtUri)}async ob(o,n,s,t){const r=await s.open(t,{create:!0,unlock:!1});try{const a=await o.readFile(n);await this.gb(s,r,D.$je.wrap(a),a.byteLength,0,0)}catch(a){throw(0,w.$Ek)(a)}finally{await s.close(r)}}async pb(o,n,s,t){const r=await(0,D.$ve)(this.H(o,n,A.CancellationToken.None));await this.hb(s,t,void 0,r)}qb(o,n){if(o.capabilities&2048)throw new w.$Lk((0,b.localize)(25,null,this.sb(n)),6);return o}rb(o,n){if((n.permissions??0)&w.FilePermission.Readonly)throw new w.$Lk((0,b.localize)(26,null,this.sb(o)),6)}sb(o){return o.scheme===S.Schemas.file?o.fsPath:o.toString(!0)}};e.$cq=v,e.$cq=v=c=pe([X(0,f.$nj)],v)}),define(le[201],he([0,1,54,270,6,35,14,3,49,2,16,5,20,47,31,162,11,98,199,38,195,194]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0,(()=>{try{(0,L.gracefulify)(O)}catch(o){console.error(`Error enabling graceful-fs: ${(0,d.$Qi)(o)}`)}})();class i extends f.$lq{static{this.I=!1}constructor(n,s){super(n,s),this.onDidChangeCapabilities=P.Event.None,this.N=new A.$Ac(t=>m.$yg.getComparisonKey(t)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,S.$k&&(this.J|=1024)),this.J}async stat(n){try{const{stat:s,symbolicLink:t}=await $.SymlinkSupport.stat(this.H(n));return{type:this.M(s,t),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size,permissions:s.mode&128?void 0:w.FilePermission.Locked}}catch(s){throw this.fb(s)}}async L(n){try{return await this.stat(n)}catch{return}}async readdir(n){try{const s=await $.Promises.readdir(this.H(n),{withFileTypes:!0}),t=[];return await Promise.all(s.map(async r=>{try{let a;r.isSymbolicLink()?a=(await this.stat((0,m.$Hg)(n,r.name))).type:a=this.M(r),t.push([r.name,a])}catch(a){this.a.trace(a)}})),t}catch(s){throw this.fb(s)}}M(n,s){let t;return s?.dangling?t=w.FileType.Unknown:n.isFile()?t=w.FileType.File:n.isDirectory()?t=w.FileType.Directory:t=w.FileType.Unknown,s&&(t|=w.FileType.SymbolicLink),t}async O(n){const s=this.H(n);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${s})`);let t;for(;t=this.N.get(n);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${s})`),await t.wait();const r=new D.$5g;return this.N.set(n,r),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${s})`),(0,g.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${s})`),this.N.get(n)===r&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${s})`),this.N.delete(n)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${s})`),r.open()})}async readFile(n,s){let t;try{s?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(n)})`),t=await this.O(n));const r=this.H(n);return await $.Promises.readFile(r)}catch(r){throw this.fb(r)}finally{t?.dispose()}}P(n){i.I&&this.a.trace(n)}readFileStream(n,s,t){const r=(0,l.$0d)(a=>I.$je.concat(a.map(E=>I.$je.wrap(E))).buffer);return(0,h.$bq)(this,n,r,a=>a.buffer,{...s,bufferSize:256*1024},t),r}async writeFile(n,s,t){return t?.atomic!==!1&&t?.atomic?.postfix&&await this.Q(n)?this.R(n,(0,m.$Hg)((0,m.$Gg)(n),`${(0,m.$Eg)(n)}${t.atomic.postfix}`),s,t):this.S(n,s,t)}async Q(n){try{const s=this.H(n),{symbolicLink:t}=await $.SymlinkSupport.stat(s);if(t)return!1}catch{}return!0}async R(n,s,t,r){const a=new g.$Sc;try{a.add(await this.O(n)),a.add(await this.O(s)),await this.S(s,t,r,!0);try{await this.rename(s,n,{overwrite:!0})}catch(E){try{await this.delete(s,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw E}}finally{a.dispose()}}async S(n,s,t,r){let a;try{const E=this.H(n);if(!t.create||!t.overwrite){if(await $.Promises.exists(E)){if(!t.overwrite)throw(0,w.$Dk)((0,b.localize)(0,null),w.FileSystemProviderErrorCode.FileExists)}else if(!t.create)throw(0,w.$Dk)((0,b.localize)(1,null),w.FileSystemProviderErrorCode.FileNotFound)}a=await this.open(n,{create:!0,unlock:t.unlock},r),await this.write(a,0,s,0,s.byteLength)}catch(E){throw await this.gb(n,E)}finally{typeof a=="number"&&await this.close(a)}}static{this.Y=!0}static configureFlushOnWrite(n){i.Y=n}async open(n,s,t){const r=this.H(n);let a;(0,w.$rk)(s)&&!t&&(a=await this.O(n));let E;try{if((0,w.$rk)(s)&&s.unlock)try{const{stat:u}=await $.SymlinkSupport.stat(r);u.mode&128||await $.Promises.chmod(r,u.mode|128)}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}let y;if((0,w.$rk)(s)){if(S.$i)try{await $.Promises.truncate(r,0),y="r+"}catch(u){u.code!=="ENOENT"&&this.a.trace(u)}y||(y="w")}else y="r";E=await $.Promises.open(r,y)}catch(y){throw a?.dispose(),(0,w.$rk)(s)?await this.gb(n,y):this.fb(y)}if(this.U.set(E,0),(0,w.$rk)(s)&&this.X.set(E,n),a){const y=this.W.get(E);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${r})`),this.W.set(E,a),y&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${r})`),y.dispose())}return E}async close(n){const s=this.W.get(n);try{if(this.U.delete(n),this.X.delete(n)&&i.Y)try{await $.Promises.fdatasync(n)}catch(t){i.configureFlushOnWrite(!1),this.a.error(t)}return await $.Promises.close(n)}catch(t){throw this.fb(t)}finally{s&&(this.W.get(n)===s&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${n}`),this.W.delete(n)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${n}`),s.dispose())}}async read(n,s,t,r,a){const E=this.Z(n,s);let y=null;try{y=(await $.Promises.read(n,t,r,a,E)).bytesRead}catch(u){throw this.fb(u)}finally{this.$(n,E,y)}return y}Z(n,s){return s===this.U.get(n)?null:s}$(n,s,t){const r=this.U.get(n);typeof r=="number"&&(typeof s=="number"||(typeof t=="number"?this.U.set(n,r+t):this.U.delete(n)))}async write(n,s,t,r,a){return(0,D.$nh)(()=>this.ab(n,s,t,r,a),100,3)}async ab(n,s,t,r,a){const E=this.Z(n,s);let y=null;try{y=(await $.Promises.write(n,t,r,a,E)).bytesWritten}catch(u){throw await this.gb(this.X.get(n),u)}finally{this.$(n,E,y)}return y}async mkdir(n){try{await $.Promises.mkdir(this.H(n))}catch(s){throw this.fb(s)}}async delete(n,s){try{const t=this.H(n);if(s.recursive){let r;s?.atomic!==!1&&s.atomic.postfix&&(r=(0,C.$jc)((0,C.$mc)(t),`${(0,C.$nc)(t)}${s.atomic.postfix}`)),await $.Promises.rm(t,$.RimRafMode.MOVE,r)}else try{await $.Promises.unlink(t)}catch(r){if(r.code==="EPERM"||r.code==="EISDIR"){let a=!1;try{const{stat:E,symbolicLink:y}=await $.SymlinkSupport.stat(t);a=E.isDirectory()&&!y}catch{}if(a)await $.Promises.rmdir(t);else throw r}else throw r}}catch(t){throw this.fb(t)}}async rename(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"move",t.overwrite),await $.Promises.rename(r,a)}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,b.localize)(2,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),E.toString()))),this.fb(E)}}async copy(n,s,t){const r=this.H(n),a=this.H(s);if(r!==a)try{await this.bb(n,s,"copy",t.overwrite),await $.Promises.copy(r,a,{preserveSymlinks:!0})}catch(E){throw(E.code==="EINVAL"||E.code==="EBUSY"||E.code==="ENAMETOOLONG")&&(E=new Error((0,b.localize)(3,null,(0,C.$nc)(r),(0,C.$nc)((0,C.$mc)(a)),E.toString()))),this.fb(E)}}async bb(n,s,t,r){const a=this.H(n),E=this.H(s);let y=!1;if(!!(this.capabilities&1024)||(y=(0,k.$7f)(a,E,!0)),y){if(t==="copy")throw(0,w.$Dk)((0,b.localize)(4,null),w.FileSystemProviderErrorCode.FileExists);if(t==="move")return}const p=await this.L(n);if(!p)throw(0,w.$Dk)((0,b.localize)(5,null),w.FileSystemProviderErrorCode.FileNotFound);const R=await this.L(s);if(R){if(!r)throw(0,w.$Dk)((0,b.localize)(6,null),w.FileSystemProviderErrorCode.FileExists);p.type&w.FileType.File&&R.type&w.FileType.File||await this.delete(s,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(n,s){return this.cb(n,s,!1)}async cb(n,s,t){const r=this.H(n),a=this.H(s),E=!!(this.capabilities&1024);if((0,k.$7f)(r,a,!E))return;const y=new g.$Sc;try{y.add(await this.O(n)),y.add(await this.O(s)),t&&await $.Promises.mkdir((0,C.$mc)(a),{recursive:!0}),await $.Promises.copyFile(r,a)}catch(u){if(u.code==="ENOENT"&&!t)return this.cb(n,s,!0);throw this.fb(u)}finally{y.dispose()}}t(n,s,t){return new c.$sq(r=>n(r),r=>s(r),t)}F(n,s,t){return new v.$Aq(r=>n(r),r=>s(r),t)}fb(n){if(n instanceof w.$Ck)return n;let s=n,t;switch(n.code){case"ENOENT":t=w.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":t=w.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":t=w.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":t=w.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":t=w.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":s=`${n.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,t=w.FileSystemProviderErrorCode.Unknown;break;default:t=w.FileSystemProviderErrorCode.Unknown}return(0,w.$Dk)(s,t)}async gb(n,s){let t=this.fb(s);if(n&&t.code===w.FileSystemProviderErrorCode.NoPermissions)try{const{stat:r}=await $.SymlinkSupport.stat(this.H(n));r.mode&128||(t=(0,w.$Dk)(s,w.FileSystemProviderErrorCode.FileWriteLocked))}catch(r){this.a.trace(r)}return t}}e.$Bq=i}),define(le[101],he([0,1,3,2,4,8]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aac=e.$zac=void 0,e.$zac=(0,D.$6h)("sharedProcessLifecycleService");let I=class extends L.$Tc{constructor(k){super(),this.b=k,this.a=this.B(new O.$Vd),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.$Aac=I,e.$Aac=I=pe([X(0,A.$nj)],I)}),define(le[202],he([0,1,10,3,8,2]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=void 0;class I extends D.$yj{constructor(S,m,l,$,b){super(m,l,$),this.r=S,this.t=b,this.B(b.listen("onDidChangeLogLevel",S)(w=>{(0,D.$pj)(w)?super.setLogLevel(w):super.setLogLevel(O.URI.revive(w[0]),w[1])})),this.B(b.listen("onDidChangeVisibility",S)(([w,h])=>super.setVisibility(O.URI.revive(w),h))),this.B(b.listen("onDidChangeLoggers",S)(({added:w,removed:h})=>{for(const f of w)super.registerLogger({...f,resource:O.URI.revive(f.resource)});for(const f of h)super.deregisterLogger(f.resource)}))}createConsoleMainLogger(){return new D.$wj({log:(S,m)=>{this.t.call("consoleLog",[S,m])}})}registerLogger(S){super.registerLogger(S),this.t.call("registerLogger",[S,this.r])}deregisterLogger(S){super.deregisterLogger(S),this.t.call("deregisterLogger",[S,this.r])}setLogLevel(S,m){super.setLogLevel(S,m),this.t.call("setLogLevel",[S,m])}setVisibility(S,m){super.setVisibility(S,m),this.t.call("setVisibility",[this.n(S),m])}s(S,m,l){return new P(this.t,S,m,l,this.r)}static setLogLevel(S,m,l){return S.call("setLogLevel",[m,l])}}e.$Ar=I;class P extends D.$tj{constructor(S,m,l,$,b){super($?.logLevel==="always"),this.r=S,this.s=m,this.m=!1,this.n=[],this.setLevel(l),this.r.call("createLogger",[m,$,b]).then(()=>{this.u(this.n),this.m=!0})}g(S,m){const l=[[S,m]];this.m?this.u(l):this.n.push(...l)}u(S){this.r.call("log",[this.s,S])}}class k{constructor(S,m){this.a=S,this.b=m}listen(S,m){const l=this.b(S);switch(m){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(b=>this.c(b,l)),removed:[...$.removed].map(b=>this.c(b,l))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,$=>[l.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,$=>(0,D.$pj)($)?$:[l.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${m}`)}async call(S,m,l){const $=this.b(S);switch(m){case"setLogLevel":return(0,D.$pj)(l[0])?this.a.setLogLevel(l[0]):this.a.setLogLevel(O.URI.revive($.transformIncoming(l[0][0])),l[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(b=>this.c(b,$)))}throw new Error(`Call not found: ${m}`)}c(S,m){return{...S,resource:m.transformOutgoingURI(S.resource)}}}e.$Br=k;class g extends A.$Tc{constructor(S,m){super(),m.call("setLogLevel",[S.getLogLevel()]),this.B(S.onDidChangeLogLevel(l=>m.call("setLogLevel",[l]))),m.call("getRegisteredLoggers").then(l=>{for(const $ of l)S.registerLogger({...$,resource:O.URI.revive($.resource)})}),this.B(m.listen("onDidChangeVisibility")(([l,$])=>S.setVisibility(O.URI.revive(l),$))),this.B(m.listen("onDidChangeLoggers")(({added:l,removed:$})=>{for(const b of l)S.registerLogger({...b,resource:O.URI.revive(b.resource)});for(const b of $)S.deregisterLogger(b.resource)}))}}e.$Cr=g}),define(le[203],he([0,1,2,8]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=void 0;class D extends O.$Tc{constructor(I,P=[]){super(),this.a=new L.$xj([I,...P]),this.B(I.onDidChangeLogLevel(k=>this.setLevel(k)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...P){this.a.trace(I,...P)}debug(I,...P){this.a.debug(I,...P)}info(I,...P){this.a.info(I,...P)}warn(I,...P){this.a.warn(I,...P)}error(I,...P){this.a.error(I,...P)}flush(){this.a.flush()}}e.$CO=D}),define(le[57],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$w$b=void 0,e.$w$b=(0,O.$6h)("nativeHostService")}),define(le[204],he([0,1,40,56]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q_b=void 0;let D=class{constructor(I,P){return this.windowId=I,O.ProxyChannel.toService(P.getChannel("nativeHost"),{context:I,properties:(()=>{const k=new Map;return k.set("windowId",I),k})()})}};e.$Q_b=D,e.$Q_b=D=pe([X(1,L.$K_b)],D)}),define(le[58],he([0,1,3,61,2,4]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ln=e.$Kn=e.$Jn=void 0,e.$Jn=(0,A.$6h)("policy");class I extends D.$Tc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new O.$Vd),this.onDidChange=this.h.event}async updatePolicyDefinitions(g){const C=Object.keys(this.f).length;return this.f={...g,...this.f},C!==Object.keys(this.f).length&&await this.j(g),L.Iterable.reduce(this.g.entries(),(S,[m,l])=>({...S,[m]:l}),{})}getPolicyValue(g){return this.g.get(g)}serialize(){return L.Iterable.reduce(Object.entries(this.f),(g,[C,S])=>({...g,[C]:{definition:S,value:this.g.get(C)}}),{})}}e.$Kn=I;class P{constructor(){this.onDidChange=O.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$Ln=P}),define(le[205],he([0,1,3,2,58]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$h_b=e.$g_b=void 0;class A{constructor(k){this.b=k,this.a=new L.$Sc}listen(k,g){switch(g){case"onDidChange":return O.Event.map(this.b.onDidChange,C=>C.reduce((S,m)=>({...S,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${g}`)}call(k,g,C){switch(g){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(C)}throw new Error(`Call not found: ${g}`)}dispose(){this.a.dispose()}}e.$g_b=A;class I extends D.$Kn{constructor(k,g){super(),this.a=g;for(const C in k){const{definition:S,value:m}=k[C];this.f[C]=S,m!==void 0&&this.g.set(C,m)}this.a.listen("onDidChange")(C=>{for(const S in C){const m=C[S];m===null?this.g.delete(S):this.g.set(S,m)}this.h.fire(Object.keys(C))})}async j(k){const g=await this.a.call("updatePolicyDefinitions",k);for(const C in g)this.g.set(C,g[C])}}e.$h_b=I}),define(le[102],he([0,1,37]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const D=globalThis.vscode;if(typeof D<"u"&&typeof D.context<"u"){const A=D.context.configuration();if(A)L=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,O.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:A.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(le[24],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,O.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"}),define(le[206],he([0,1,6,7,2,16,31,8,24]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0_b=void 0;let g=class extends D.$Tc{constructor(S,m,l){super(),this.b=m,this.c=l,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,S&&this.B(new O.$fh(()=>{this.f(S)},3e4)).schedule()}async f(S){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),l=(0,A.$mc)(S),$=(0,A.$nc)(S),b=await I.Promises.readdir(l);await Promise.all(b.map(async w=>{if(w===$)return;const h=(0,A.$jc)(l,w),f=await I.Promises.stat(h);if(f.isDirectory()&&m-f.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${w}.`),I.Promises.rm(h)}))}catch(m){(0,L.$1)(m)}}};e.$0_b=g,e.$0_b=g=pe([X(1,k.$Fj),X(2,P.$nj)],g)}),define(le[207],he([0,1,6,7,2,16,31,15,8,24]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$_b=void 0;let C=class extends D.$Tc{constructor(m,l,$){super(),this.b=m,this.c=l,this.f=$,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new O.$fh(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),l=JSON.parse(await I.Promises.readFile((0,A.$jc)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const f of Object.keys(l)){const d=l[f];m[`${d.hash}.${f}`]=!0}const $=(0,A.$jc)(this.b.userDataPath,"clp");if(!await I.Promises.exists($))return;const w=await I.Promises.readdir($);for(const f of w){if(m[f]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${f}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${f}`),await I.Promises.rm((0,A.$jc)($,f))}const h=Date.now();for(const f of Object.keys(m)){const d=(0,A.$jc)($,f),c=await I.Promises.readdir(d);for(const v of c){if(v==="tcf.json")continue;const i=(0,A.$jc)(d,v),o=await I.Promises.stat(i);o.isDirectory()&&h-o.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,A.$jc)(f,v)}`),await I.Promises.rm(i))}}}catch(m){(0,L.$1)(m)}}};e.$$_b=C,e.$$_b=C=pe([X(0,P.$bi),X(1,k.$nj),X(2,g.$Fj)],C)}),define(le[208],he([0,1,16,4]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.$mF=void 0,e.$mF=(0,L.$6h)("IV8InspectProfilingService");var D;(function(A){function I(k){return!!(k.samples&&k.timeDeltas)}A.isValidProfile=I;function P(k,g="noAbsolutePaths"){for(const C of k.nodes)C.callFrame&&C.callFrame.url&&((0,O.$ic)(C.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(C.callFrame.url))&&(C.callFrame.url=(0,O.$jc)(g,(0,O.$nc)(C.callFrame.url)));return k}A.rewriteAbsolutePaths=P})(D||(e.Utils=D={}))}),define(le[209],he([0,1,32]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pac=void 0;class L{constructor(){this.a=new Map}async startProfiling(A){const P=await(await new Promise((g,C)=>{se(["v8-inspect-profiler"],g,C)})).startProfiling({port:A.port,checkForPaused:!0}),k=(0,O.$qg)();return this.a.set(k,P),k}async stopProfiling(A){const I=this.a.get(A);if(!I)throw new Error(`UNKNOWN session '${A}'`);const P=await I.stop();return this.a.delete(A),P.profile}}e.$pac=L}),define(le[41],he([0,1,127,12]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class D{constructor(){this.a=new Map}add(I,P){O.ok(L.$If(I)),O.ok(L.$Kf(P)),O.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,P)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$Hn=new D}),define(le[103],he([0,1,3,41]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function D(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class A{constructor(){this.b=new O.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(k,g){this.a[D(k)]=g,this.b.fire(k)}notifySchemaChanged(k){this.b.fire(k)}getSchemaContributions(){return{schemas:this.a}}}const I=new A;L.$Hn.add(e.$In.JSONContribution,I)}),define(le[44],he([0,1,17,3,12,149,21,103,41]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var g;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(g||(e.EditPresentationTypes=g={})),e.$Mn={Configuration:"base.contributions.configuration"};var C;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C||(e.ConfigurationScope=C={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const S=k.$Hn.as(P.$In.JSONContribution);class m{constructor(){this.h=new Set,this.i=new L.$Vd,this.onDidSchemaChange=this.i.event,this.j=new L.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:A.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(i,o=!0){this.registerConfigurations([i],o)}registerConfigurations(i,o=!0){const n=new Set;this.n(i,o,n),S.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:n})}deregisterConfigurations(i){const o=new Set;this.o(i,o),S.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:o})}updateConfigurations({add:i,remove:o}){const n=new Set;this.o(o,n),this.n(i,!1,n),S.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:n})}registerDefaultConfigurations(i){const o=new Set;this.k(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}k(i,o){const n=[];for(const{overrides:s,source:t}of i)for(const r in s)if(o.add(r),e.$Wn.test(r)){const a=this.a.get(r),E=a?.valuesSources??new Map;if(t)for(const R of Object.keys(s[r]))E.set(R,t);const y={...a?.value||{},...s[r]};this.a.set(r,{source:t,value:y,valuesSources:E});const u=(0,I.$Ji)(r),p={type:"object",default:y,description:A.localize(1,null,u),$ref:e.$Tn,defaultDefaultValue:y,source:D.$If(t)?void 0:t,defaultValueSource:t};n.push(...b(r)),this.d[r]=p,this.b.properties[r]=p}else{this.a.set(r,{value:s[r],source:t});const a=this.d[r];a&&(this.w(r,a),this.r(r,a))}this.m(n)}deregisterDefaultConfigurations(i){const o=new Set;this.l(i,o),this.i.fire(),this.j.fire({properties:o,defaultsOverrides:!0})}l(i,o){for(const{overrides:n,source:s}of i)for(const t in n){const r=this.a.get(t),a=D.$If(s)?s:s?.id,E=D.$If(r?.source)?r?.source:r?.source?.id;if(a===E)if(o.add(t),this.a.delete(t),e.$Wn.test(t))delete this.d[t],delete this.b.properties[t];else{const y=this.d[t];y&&(this.w(t,y),this.r(t,y))}}this.u()}deltaConfiguration(i){let o=!1;const n=new Set;i.removedDefaults&&(this.l(i.removedDefaults,n),o=!0),i.addedDefaults&&(this.k(i.addedDefaults,n),o=!0),i.removedConfigurations&&this.o(i.removedConfigurations,n),i.addedConfigurations&&this.n(i.addedConfigurations,!1,n),this.i.fire(),this.j.fire({properties:n,defaultsOverrides:o})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const o of i)this.h.add(o);this.u()}n(i,o,n){i.forEach(s=>{this.p(s,o,s.extensionInfo,s.restrictedProperties,void 0,n),this.c.push(s),this.q(s)})}o(i,o){const n=s=>{if(s.properties)for(const t in s.properties){o.add(t);const r=this.d[t];r?.policy?.name&&this.e.delete(r.policy.name),delete this.d[t],this.s(t,s.properties[t])}s.allOf?.forEach(t=>n(t))};for(const s of i){n(s);const t=this.c.indexOf(s);t!==-1&&this.c.splice(t,1)}}p(i,o=!0,n,s,t=3,r){t=D.$Rf(i.scope)?t:i.scope;const a=i.properties;if(a)for(const y in a){const u=a[y];if(o&&d(y,u)){delete a[y];continue}if(u.source=n,u.defaultDefaultValue=a[y].default,this.w(y,u),e.$Wn.test(y)?u.scope=void 0:(u.scope=D.$Rf(u.scope)?t:u.scope,u.restricted=D.$Rf(u.restricted)?!!s?.includes(y):u.restricted),a[y].hasOwnProperty("included")&&!a[y].included){this.f[y]=a[y],delete a[y];continue}else this.d[y]=a[y],a[y].policy?.name&&this.e.set(a[y].policy.name,y);!a[y].deprecationMessage&&a[y].markdownDeprecationMessage&&(a[y].deprecationMessage=a[y].markdownDeprecationMessage),r.add(y)}const E=i.allOf;if(E)for(const y of E)this.p(y,o,n,s,t,r)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const o=n=>{const s=n.properties;if(s)for(const r in s)this.r(r,s[r]);n.allOf?.forEach(o)};o(i)}r(i,o){switch(e.$Nn.properties[i]=o,o.scope){case 1:e.$On.properties[i]=o;break;case 2:e.$Pn.properties[i]=o;break;case 6:e.$Qn.properties[i]=o;break;case 3:e.$Rn.properties[i]=o;break;case 4:e.$Sn.properties[i]=o;break;case 5:e.$Sn.properties[i]=o,this.g.properties[i]=o;break}}s(i,o){switch(delete e.$Nn.properties[i],o.scope){case 1:delete e.$On.properties[i];break;case 2:delete e.$Pn.properties[i];break;case 6:delete e.$Qn.properties[i];break;case 3:delete e.$Rn.properties[i];break;case 4:case 5:delete e.$Sn.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const o=`[${i}]`,n={type:"object",description:A.localize(2,null),errorMessage:A.localize(3,null),$ref:e.$Tn};this.w(o,n),e.$Nn.properties[o]=n,e.$On.properties[o]=n,e.$Pn.properties[o]=n,e.$Qn.properties[o]=n,e.$Rn.properties[o]=n,e.$Sn.properties[o]=n}}v(){const i={type:"object",description:A.localize(4,null),errorMessage:A.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=i,e.$On.patternProperties[e.$Vn]=i,e.$Pn.patternProperties[e.$Vn]=i,e.$Qn.patternProperties[e.$Vn]=i,e.$Rn.patternProperties[e.$Vn]=i,e.$Sn.patternProperties[e.$Vn]=i,this.i.fire()}w(i,o){const n=this.a.get(i);let s=n?.value,t=n?.source;D.$Pf(s)&&(s=o.defaultDefaultValue,t=void 0),D.$Pf(s)&&(s=h(o.type)),o.default=s,o.defaultValueSource=t}}const l="\\[([^\\]]+)\\]",$=new RegExp(l,"g");e.$Vn=`^(${l})+$`,e.$Wn=new RegExp(e.$Vn);function b(v){const i=[];if(e.$Wn.test(v)){let o=$.exec(v);for(;o?.length;){const n=o[1].trim();n&&i.push(n),o=$.exec(v)}}return(0,O.$Mb)(i)}e.$Xn=b;function w(v){return v.reduce((i,o)=>`${i}[${o}]`,"")}e.$Yn=w;function h(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=h;const f=new m;k.$Hn.add(e.$Mn.Configuration,f);function d(v,i){return v.trim()?e.$Wn.test(v)?A.localize(7,null,v):f.getConfigurationProperties()[v]!==void 0?A.localize(8,null,v):i.policy?.name&&f.getPolicyConfigurations().get(i.policy?.name)!==void 0?A.localize(9,null,v,i.policy?.name,f.getPolicyConfigurations().get(i.policy?.name)):null:A.localize(6,null)}e.$1n=d;function c(){const v=[],i=f.getConfigurationProperties();for(const o of Object.keys(i))v.push([o,i[o].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.$2n=c}),define(le[76],he([0,1,17,3,34,2,35,30,12,10,21,44,41]),function(se,e,O,L,D,A,I,P,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function l(o){return Object.isFrozen(o)?o:P.$wn(o)}class ${constructor(n={},s=[],t=[],r){this.b=n,this.c=s,this.d=t,this.raw=r,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const n=this.raw.map(s=>{if(s instanceof $)return s;const t=new b("");return t.parseRaw(s),t.configurationModel});this.f=n.reduce((s,t)=>t===s?t:s.merge(t),n[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(n){return n?(0,C.$Hi)(this.contents,n):this.contents}inspect(n,s){const t=this.rawConfiguration.getValue(n),r=s?this.rawConfiguration.getOverrideValue(n,s):void 0,a=s?this.rawConfiguration.override(s).getValue(n):t;return{value:t,override:r,merged:a}}getOverrideValue(n,s){const t=this.i(s);return t?n?(0,C.$Hi)(t,n):t:void 0}getKeysForOverrideIdentifier(n){const s=[];for(const t of this.overrides)t.identifiers.includes(n)&&s.push(...t.keys);return O.$Mb(s)}getAllOverrideIdentifiers(){const n=[];for(const s of this.overrides)n.push(...s.identifiers);return O.$Mb(n)}override(n){let s=this.a.get(n);return s||(s=this.g(n),this.a.set(n,s)),s}merge(...n){const s=P.$vn(this.contents),t=P.$vn(this.overrides),r=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const E of n)if(a.push(...E.raw?.length?E.raw:[E]),!E.isEmpty()){this.h(s,E.contents);for(const y of E.overrides){const[u]=t.filter(p=>O.$ub(p.identifiers,y.identifiers));u?(this.h(u.contents,y.contents),u.keys.push(...y.keys),u.keys=O.$Mb(u.keys)):t.push(P.$vn(y))}for(const y of E.keys)r.indexOf(y)===-1&&r.push(y)}return new $(s,r,t,a.every(E=>E instanceof $)?void 0:a)}g(n){const s=this.i(n);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const t={};for(const r of O.$Mb([...Object.keys(this.contents),...Object.keys(s)])){let a=this.contents[r];const E=s[r];E&&(typeof a=="object"&&typeof E=="object"?(a=P.$vn(a),this.h(a,E)):a=E),t[r]=a}return new $(t,this.keys,this.overrides)}h(n,s){for(const t of Object.keys(s)){if(t in n&&k.$Kf(n[t])&&k.$Kf(s[t])){this.h(n[t],s[t]);continue}n[t]=P.$vn(s[t])}}i(n){let s=null,t=null;const r=a=>{a&&(t?this.h(t,a):t=P.$vn(a))};for(const a of this.overrides)a.identifiers.length===1&&a.identifiers[0]===n?s=a.contents:a.identifiers.includes(n)&&r(a.contents);return r(s),t}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(n,s){this.j(n,s,!0)}setValue(n,s){this.j(n,s,!1)}removeValue(n){const s=this.keys.indexOf(n);s!==-1&&(this.keys.splice(s,1),(0,C.$Gi)(this.contents,n),S.$Wn.test(n)&&this.overrides.splice(this.overrides.findIndex(t=>O.$ub(t.identifiers,(0,S.$Xn)(n))),1))}j(n,s,t){(0,C.$Fi)(this.contents,n,s,r=>console.error(r)),t=t||this.keys.indexOf(n)===-1,t&&this.keys.push(n),S.$Wn.test(n)&&this.overrides.push({identifiers:(0,S.$Xn)(n),keys:Object.keys(this.contents[n]),contents:(0,C.$Ei)(this.contents[n],r=>console.error(r))})}}e.$3n=$;class b{constructor(n){this.f=n,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new $}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(n,s){if(!k.$Rf(n)){const t=this.g(n);this.parseRaw(t,s)}}reparse(n){this.a&&this.parseRaw(this.a,n)}parseRaw(n,s){this.a=n;const{contents:t,keys:r,overrides:a,restricted:E,hasExcludedProperties:y}=this.h(n,s);this.b=new $(t,r,a,y?[n]:void 0),this.c=E||[]}g(n){let s={},t=null,r=[];const a=[],E=[];function y(p){Array.isArray(r)?r.push(p):t!==null&&(r[t]=p)}const u={onObjectBegin:()=>{const p={};y(p),a.push(r),r=p,t=null},onObjectProperty:p=>{t=p},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{const p=[];y(p),a.push(r),r=p,t=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:y,onError:(p,R,N)=>{E.push({error:p,offset:R,length:N})}};if(n)try{D.$jn(n,u),s=r[0]||{}}catch(p){console.error(`Error while parsing settings file ${this.f}: ${p}`),this.d=[p]}return s}h(n,s){const t=m.$Hn.as(S.$Mn.Configuration).getConfigurationProperties(),r=this.i(n,t,!0,s);n=r.raw;const a=(0,C.$Ei)(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`)),E=Object.keys(n),y=this.j(n,u=>console.error(`Conflict in settings file ${this.f}: ${u}`));return{contents:a,keys:E,overrides:y,restricted:r.restricted,hasExcludedProperties:r.hasExcludedProperties}}i(n,s,t,r){let a=!1;if(!r?.scopes&&!r?.skipRestricted&&!r?.exclude?.length)return{raw:n,restricted:[],hasExcludedProperties:a};const E={},y=[];for(const u in n)if(S.$Wn.test(u)&&t){const p=this.i(n[u],s,!1,r);E[u]=p.raw,a=a||p.hasExcludedProperties,y.push(...p.restricted)}else{const p=s[u],R=p?typeof p.scope<"u"?p.scope:3:void 0;p?.restricted&&y.push(u),!r.exclude?.includes(u)&&(r.include?.includes(u)||(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&!(r.skipRestricted&&p?.restricted))?E[u]=n[u]:a=!0}return{raw:E,restricted:y,hasExcludedProperties:a}}j(n,s){const t=[];for(const r of Object.keys(n))if(S.$Wn.test(r)){const a={};for(const E in n[r])a[E]=n[r][E];t.push({identifiers:(0,S.$Xn)(r),keys:Object.keys(a),contents:(0,C.$Ei)(a,s)})}return t}}e.$4n=b;class w extends A.$Tc{constructor(n,s,t,r){super(),this.c=n,this.f=s,this.g=r,this.b=this.B(new L.$Vd),this.onDidChange=this.b.event,this.a=new b(this.c.toString()),this.B(this.g.watch(t.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(L.Event.any(L.Event.filter(this.g.onDidFilesChange,a=>a.contains(this.c)),L.Event.filter(this.g.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&t.isEqual(a.resource,n)))(()=>this.b.fire()))}async loadConfiguration(){try{const n=await this.g.readFile(this.c);return this.a.parse(n.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new $}}reparse(n){return n&&(this.f=n),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=w;class h{constructor(n,s,t,r,a,E,y,u,p,R,N,T,M){this.a=n,this.b=s,this.c=t,this.overrideIdentifiers=r,this.d=a,this.f=E,this.g=y,this.h=u,this.i=p,this.j=R,this.k=N,this.l=T,this.m=M}get value(){return l(this.c)}n(n,s,t){const r=n.inspect(s,t);return{get value(){return l(r.value)},get override(){return l(r.override)},get merged(){return l(r.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class f{constructor(n,s,t,r,a=new $,E=new $,y=new I.$Ac,u=new $,p=new I.$Ac){this.c=n,this.d=s,this.f=t,this.g=r,this.h=a,this.i=E,this.j=y,this.l=u,this.m=p,this.a=null,this.b=new I.$Ac,this.n=null}getValue(n,s,t){return this.p(n,s,t).getValue(n)}updateValue(n,s,t={}){let r;t.resource?(r=this.m.get(t.resource),r||(r=new $,this.m.set(t.resource,r))):r=this.l,s===void 0?r.removeValue(n):r.setValue(n,s),t.resource||(this.a=null)}inspect(n,s,t){const r=this.p(n,s,t),a=this.t(s.resource,t),E=s.resource?this.m.get(s.resource)||this.l:this.l,y=new Set;for(const u of r.overrides)for(const p of u.identifiers)r.getOverrideValue(n,p)!==void 0&&y.add(p);return new h(n,s,r.getValue(n),y.size?[...y]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,t?this.i:void 0,a||void 0,E)}keys(n){const s=this.t(void 0,n);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(n){this.c=n,this.a=null,this.b.clear()}updatePolicyConfiguration(n){this.d=n}updateApplicationConfiguration(n){this.f=n,this.a=null,this.b.clear()}updateLocalUserConfiguration(n){this.g=n,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(n){this.h=n,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(n){this.i=n,this.a=null,this.b.clear()}updateFolderConfiguration(n,s){this.j.set(n,s),this.b.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this.b.delete(n)}compareAndUpdateDefaultConfiguration(n,s){const t=[];if(!s){const{added:r,updated:a,removed:E}=v(this.c,n);s=[...r,...a,...E]}for(const r of s)for(const a of(0,S.$Xn)(r)){const E=this.c.getKeysForOverrideIdentifier(a),y=n.getKeysForOverrideIdentifier(a),u=[...y.filter(p=>E.indexOf(p)===-1),...E.filter(p=>y.indexOf(p)===-1),...E.filter(p=>!P.$zn(this.c.override(a).getValue(p),n.override(a).getValue(p)))];t.push([a,u])}return this.updateDefaultConfiguration(n),{keys:s,overrides:t}}compareAndUpdatePolicyConfiguration(n){const{added:s,updated:t,removed:r}=v(this.d,n),a=[...s,...t,...r];return a.length&&this.updatePolicyConfiguration(n),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.applicationConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateApplicationConfiguration(n),{keys:E,overrides:a}}compareAndUpdateLocalUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.localUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateLocalUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.remoteUserConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateRemoteUserConfiguration(n),{keys:E,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:s,updated:t,removed:r,overrides:a}=v(this.workspaceConfiguration,n),E=[...s,...t,...r];return E.length&&this.updateWorkspaceConfiguration(n),{keys:E,overrides:a}}compareAndUpdateFolderConfiguration(n,s){const t=this.folderConfigurations.get(n),{added:r,updated:a,removed:E,overrides:y}=v(t,s),u=[...r,...a,...E];return(u.length||!t)&&this.updateFolderConfiguration(n,s),{keys:u,overrides:y}}compareAndDeleteFolderConfiguration(n){const s=this.folderConfigurations.get(n);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:t,updated:r,removed:a,overrides:E}=v(s,void 0);return{keys:[...t,...r,...a],overrides:E}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(n,s,t){let r=this.q(s,t);return s.overrideIdentifier&&(r=r.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(n)!==void 0&&(r=r.merge(this.d)),r}q({resource:n},s){let t=this.r();if(s&&n){const r=s.getFolder(n);r&&(t=this.s(r.uri)||t);const a=this.m.get(n);a&&(t=t.merge(a))}return t}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(n){let s=this.b.get(n);if(!s){const t=this.r(),r=this.j.get(n);r?(s=t.merge(r),this.b.set(n,s)):s=t}return s}t(n,s){if(s&&n){const t=s.getFolder(n);if(t)return this.j.get(t.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((n,s)=>{const{contents:t,overrides:r,keys:a}=this.j.get(s);return n.push([s,{contents:t,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this.c.keys.forEach(s=>n.add(s)),this.userConfiguration.keys.forEach(s=>n.add(s)),this.i.keys.forEach(s=>n.add(s)),this.j.forEach(s=>s.keys.forEach(t=>n.add(t))),[...n.values()]}u(){const n=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>n.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(t=>n.add(t))),[...n.values()]}v(n){const s=new Set;return this.c.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.i.getKeysForOverrideIdentifier(n).forEach(t=>s.add(t)),this.j.forEach(t=>t.getKeysForOverrideIdentifier(n).forEach(r=>s.add(r))),[...s.values()]}static parse(n){const s=this.w(n.defaults),t=this.w(n.policy),r=this.w(n.application),a=this.w(n.user),E=this.w(n.workspace),y=n.folders.reduce((u,p)=>(u.set(g.URI.revive(p[0]),this.w(p[1])),u),new I.$Ac);return new f(s,t,r,a,new $,E,y,new $,new I.$Ac)}static w(n){return new $(n.contents,n.keys,n.overrides)}}e.$6n=f;function d(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const n=new Set,s=new Map;for(const r of o)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,E])=>{const y=(0,I.$xc)(s,a,new Set);E.forEach(u=>y.add(u))});const t=[];return s.forEach((r,a)=>t.push([a,[...r.values()]])),{keys:[...n.values()],overrides:t}}e.$7n=d;class c{constructor(n,s,t,r){this.change=n,this.f=s,this.g=t,this.h=r,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of n.keys)this.affectedKeys.add(a);for(const[,a]of n.overrides)for(const E of a)this.affectedKeys.add(E);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=f.parse(this.f.data)),this.i}affectsConfiguration(n,s){const t=this.a+n,r=this.d.indexOf(t);if(r<0)return!1;const a=r+t.length;if(a>=this.d.length)return!1;const E=this.d.charCodeAt(a);if(E!==this.b&&E!==this.c)return!1;if(s){const y=this.previousConfiguration?this.previousConfiguration.getValue(n,s,this.f?.workspace):void 0,u=this.g.getValue(n,s,this.h);return!P.$zn(y,u)}return!0}}e.$8n=c;function v(o,n){const{added:s,removed:t,updated:r}=i(n?.rawConfiguration,o?.rawConfiguration),a=[],E=o?.getAllOverrideIdentifiers()||[],y=n?.getAllOverrideIdentifiers()||[];if(n){const u=y.filter(p=>!E.includes(p));for(const p of u)a.push([p,n.getKeysForOverrideIdentifier(p)])}if(o){const u=E.filter(p=>!y.includes(p));for(const p of u)a.push([p,o.getKeysForOverrideIdentifier(p)])}if(n&&o){for(const u of E)if(y.includes(u)){const p=i({contents:o.getOverrideValue(void 0,u)||{},keys:o.getKeysForOverrideIdentifier(u)},{contents:n.getOverrideValue(void 0,u)||{},keys:n.getKeysForOverrideIdentifier(u)});a.push([u,[...p.added,...p.removed,...p.updated]])}}return{added:s,removed:t,updated:r,overrides:a}}function i(o,n){const s=o?n?o.keys.filter(a=>n.keys.indexOf(a)===-1):[...o.keys]:[],t=n?o?n.keys.filter(a=>o.keys.indexOf(a)===-1):[...n.keys]:[],r=[];if(o&&n){for(const a of n.keys)if(o.keys.indexOf(a)!==-1){const E=(0,C.$Hi)(n.contents,a),y=(0,C.$Hi)(o.contents,a);P.$zn(E,y)||r.push(a)}}return{added:s,removed:t,updated:r}}}),define(le[210],he([0,1,17,3,2,30,12,76,44,8,58,41]),function(se,e,O,L,D,A,I,P,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$n=e.$0n=e.$9n=void 0;class m extends D.$Tc{constructor(){super(...arguments),this.a=this.B(new L.$Vd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$3n}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(S.$Hn.as(k.$Mn.Configuration).onDidUpdateConfiguration(({properties:w,defaultsOverrides:h})=>this.c(Array.from(w),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(w,h){this.h(w,S.$Hn.as(k.$Mn.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:w})}f(){return{}}g(){this.b=new P.$3n;const w=S.$Hn.as(k.$Mn.Configuration).getConfigurationProperties();this.h(Object.keys(w),w)}h(w,h){const f=this.f();for(const d of w){const c=f[d],v=h[d];c!==void 0?this.b.addValue(d,c):v?this.b.addValue(d,v.default):this.b.removeValue(d)}}}e.$9n=m;class l{constructor(){this.onDidChangeConfiguration=L.Event.None,this.configurationModel=new P.$3n}async initialize(){return this.configurationModel}}e.$0n=l;let $=class extends D.$Tc{get configurationModel(){return this.b}constructor(w,h,f){super(),this.c=w,this.f=h,this.g=f,this.a=this.B(new L.$Vd),this.onDidChangeConfiguration=this.a.event,this.b=new P.$3n}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(w=>this.j(w))),this.B(this.c.onDidChangeConfiguration(async({properties:w})=>this.m(await this.h(w),!0))),this.b}async h(w){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",w);const h={},f=[],d=S.$Hn.as(k.$Mn.Configuration).getConfigurationProperties();for(const c of w){const v=d[c];if(!v){f.push(c);continue}if(v.policy){if(v.type!=="string"&&v.type!=="number"){this.g.warn(`Policy ${v.policy.name} has unsupported type ${v.type}`);continue}f.push(c),h[v.policy.name]={type:v.type}}}return(0,I.$Vf)(h)||await this.f.updatePolicyDefinitions(h),f}j(w){this.g.trace("PolicyConfiguration#onDidChangePolicies",w);const h=S.$Hn.as(k.$Mn.Configuration).getPolicyConfigurations(),f=(0,O.$Hb)(w.map(d=>h.get(d)));this.m(f,!0)}m(w,h){this.g.trace("PolicyConfiguration#update",w);const f=S.$Hn.as(k.$Mn.Configuration).getConfigurationProperties(),d=[],c=this.b.isEmpty();for(const v of w){const i=f[v]?.policy?.name;if(i){const o=this.f.getPolicyValue(i);(c?o!==void 0:!(0,A.$zn)(this.b.getValue(v),o))&&d.push([v,o])}else this.b.getValue(v)!==void 0&&d.push([v,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const v=this.b;this.b=new P.$3n;for(const i of v.keys)this.b.setValue(i,v.getValue(i));for(const[i,o]of d)o===void 0?this.b.removeValue(i):this.b.setValue(i,o);h&&this.a.fire(this.b)}}};e.$$n=$,e.$$n=$=pe([X(1,C.$Jn),X(2,g.$nj)],$)}),define(le[211],he([0,1,17,6,14,3,34,62,2,30,5,20,21,76,44,210,58]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_n=void 0;class h extends k.$Tc{constructor(c,v,i,o){super(),this.m=c,this.h=this.B(new A.$Vd),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new b.$9n),this.c=i instanceof w.$Ln?new b.$0n:this.B(new b.$$n(this.b,i,o)),this.f=this.B(new l.$5n(this.m,{},S.$yg,v)),this.a=new l.$6n(this.b.configurationModel,this.c.configurationModel,new l.$3n,new l.$3n),this.j=new f(c,v,this),this.g=this.B(new L.$fh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:n,properties:s})=>this.r(n,s))),this.B(this.c.onDidChangeConfiguration(n=>this.s(n))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[c,v,i]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new l.$6n(c,v,new l.$3n,i)}getConfigurationData(){return this.a.toData()}getValue(c,v){const i=typeof c=="string"?c:void 0,o=(0,m.$Ai)(c)?c:(0,m.$Ai)(v)?v:{};return this.a.getValue(i,o,void 0)}async updateValue(c,v,i,o,n){const s=(0,m.$Bi)(i)?i:(0,m.$Ai)(i)?{resource:i.resource,overrideIdentifiers:i.overrideIdentifier?[i.overrideIdentifier]:void 0}:void 0,t=s?o:i;if(t!==void 0&&t!==3&&t!==2)throw new Error(`Unable to write ${c} to target ${t}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,O.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const r=this.inspect(c,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(r.policyValue!==void 0)throw new Error(`Unable to write ${c} because it is configured in system policy.`);if((0,g.$zn)(v,r.defaultValue)&&(v=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const E=s.overrideIdentifiers.sort(),y=this.a.localUserConfiguration.overrides.find(u=>(0,O.$ub)([...u.identifiers].sort(),E));y&&(s.overrideIdentifiers=y.identifiers)}const a=s?.overrideIdentifiers?.length?[(0,$.$Yn)(s.overrideIdentifiers),c]:[c];await this.j.write(a,v),await this.reloadConfiguration()}inspect(c,v={}){return this.a.inspect(c,v,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const c=await this.f.loadConfiguration();this.n(c)}n(c){const v=this.a.toData(),i=this.a.compareAndUpdateLocalUserConfiguration(c);this.t(i,v,2)}r(c,v){const i=this.a.toData(),o=this.a.compareAndUpdateDefaultConfiguration(c,v);this.t(o,i,7)}s(c){const v=this.a.toData(),i=this.a.compareAndUpdatePolicyConfiguration(c);this.t(i,v,7)}t(c,v,i){const o=new l.$8n(c,{data:v},this.a);o.source=i,this.h.fire(o)}}e.$_n=h;class f{constructor(c,v,i){this.b=c,this.c=v,this.d=i,this.a=new L.$ah}write(c,v){return this.a.queue(()=>this.e(c,v))}async e(c,v){let i;try{i=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)i="{}";else throw s}const o=[];if((0,I.$cn)(i,o,{allowTrailingComma:!0,allowEmptyContent:!0}),o.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const n=this.f(i,c,v);i=(0,P.$un)(i,n),await this.c.writeFile(this.b,D.$je.fromString(i))}f(c,v,i){const{tabSize:o,insertSpaces:n,eol:s}=this.h;if(!v.length){const t=JSON.stringify(i,null,n?" ".repeat(o):"	");return[{content:t,length:t.length,offset:0}]}return(0,P.$rn)(c,v,i,{tabSize:o,insertSpaces:n,eol:s})}get h(){if(!this.g){let c=C.OS===3||C.OS===2?`
`:`\r
`;const v=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});v&&typeof v=="string"&&v!=="auto"&&(c=v),this.g={eol:c,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(le[212],he([0,1,14,3,2,68]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rb=e.$8rb=e.$7rb=e.$6rb=void 0;const I=(g,C,S)=>{const m=new Uint8Array(16);for(let b=0;b<16;b++)m[b]=Math.round(Math.random()*256);const l=(0,O.$De)(O.$je.wrap(m));return[`GET ws://localhost${g}?${C}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${l}`].join(`\r
`)+`\r
\r
`};e.$6rb=I,e.$7rb=O.$je.fromString(`\r
\r
`);async function P(g,C,S,m,l){g.write(O.$je.fromString((0,e.$6rb)(C,S,m)));const $=new D.$Sc;try{return await new Promise((b,w)=>{let h;$.add(g.onData(f=>{h?h=O.$je.concat([h,f],h.byteLength+f.byteLength):h=f;const d=h.indexOf(e.$7rb);if(d===-1)return;b(g),g.pauseData();const c=h.slice(d+e.$7rb.byteLength);c.byteLength&&l.onData.fire(c)})),$.add(g.onClose(f=>w(f??new Error("socket closed")))),$.add(g.onEnd(()=>w(new Error("socket ended"))))})}catch(b){throw g.dispose(),b}finally{$.dispose()}}e.$8rb=P;class k extends D.$Tc{constructor(C,S){super(),this.g=C,this.a=this.B(new L.$Yd),this.onData=(...m)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...m)),this.b=this.B(new L.$Vd),this.onDidDispose=this.b.event,this.f=!1,this.B(S.onData),this.B(S.onData.event(m=>this.a.fire(m))),this.onClose=this.B(S.onClose).event,this.onEnd=this.B(S.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(C,S){A.SocketDiagnostics.traceSocketEvent(this,this.g,C,S)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$9rb=k}),define(le[213],he([0,1,7,4]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,L.$6h)("remoteAuthorityResolverService");var D;(function(C){C[C.WebSocket=0]="WebSocket",C[C.Managed=1]="Managed"})(D||(e.RemoteConnectionType=D={}));class A{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=A;class I{constructor(S,m){this.host=S,this.port=m,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=I;var P;(function(C){C.Unknown="Unknown",C.NotAvailable="NotAvailable",C.TemporarilyNotAvailable="TemporarilyNotAvailable",C.NoResolverFound="NoResolverFound",C.InvalidAuthority="InvalidAuthority"})(P||(e.RemoteAuthorityResolverErrorCode=P={}));class k extends O.$bb{static isNotAvailable(S){return S instanceof k&&S._code===P.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof k&&S._code===P.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof k&&S._code===P.NoResolverFound}static isInvalidAuthority(S){return S instanceof k&&S._code===P.InvalidAuthority}static isHandled(S){return S instanceof k&&S.isHandled}constructor(S,m=P.Unknown,l){super(S),this._message=S,this._code=m,this._detail=l,this.isHandled=m===P.NotAvailable&&l===!0,Object.setPrototypeOf(this,k.prototype)}}e.$$k=k;function g(C){const S=C.indexOf("+");return S===-1?C:C.substring(0,S)}e.$_k=g}),define(le[77],he([0,1,23]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function L(g){return g.scheme===O.Schemas.vscodeRemote?g.authority:void 0}e.$al=L;function D(g){if(!g)return;const C=g.indexOf("+");return C<0?g:g.substr(0,C)}e.$bl=D;function A(g){return`/${g.quality??"oss"}-${g.commit??"dev"}`}e.$cl=A;function I(g){const{host:C,port:S}=k(g);if(typeof S>"u")throw new Error(`Invalid remote authority: ${g}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:C,port:S}}e.$dl=I;function P(g,C){let{host:S,port:m}=k(g);return typeof m>"u"&&(m=C),{host:S,port:m}}e.$el=P;function k(g){const C=g.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const S=g.match(/^(\[[0-9a-z:]+\])$/);if(S)return{host:S[1],port:void 0};const m=g.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:g,port:void 0}}}),define(le[45],he([0,1,27,4,77]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function A(b){if(typeof b=="object"&&b!==null&&b.supported!==!0)return b.description}e.$jm=A,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(b){b[b.System=0]="System",b[b.User=1]="User"})(I||(e.ExtensionType=I={}));var P;(function(b){b.WIN32_X64="win32-x64",b.WIN32_ARM64="win32-arm64",b.LINUX_X64="linux-x64",b.LINUX_ARM64="linux-arm64",b.LINUX_ARMHF="linux-armhf",b.ALPINE_X64="alpine-x64",b.ALPINE_ARM64="alpine-arm64",b.DARWIN_X64="darwin-x64",b.DARWIN_ARM64="darwin-arm64",b.WEB="web",b.UNIVERSAL="universal",b.UNKNOWN="unknown",b.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class k{constructor(w){this.value=w,this._lower=w.toLowerCase()}static equals(w,h){if(typeof w>"u"||w===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof w=="string"||typeof h=="string"){const f=typeof w=="string"?w:w.value,d=typeof h=="string"?h:h.value;return O.$_e(f,d)}return w._lower===h._lower}static toKey(w){return typeof w=="string"?w.toLowerCase():w._lower}}e.$lm=k;class g{get size(){return this.c.size}constructor(w){if(this.c=new Set,w)for(const h of w)this.add(h)}add(w){this.c.add(k.toKey(w))}delete(w){return this.c.delete(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}}e.$mm=g;class C{constructor(){this.c=new Map}clear(){this.c.clear()}delete(w){this.c.delete(k.toKey(w))}get(w){return this.c.get(k.toKey(w))}has(w){return this.c.has(k.toKey(w))}set(w,h){this.c.set(k.toKey(w),h)}values(){return this.c.values()}forEach(w){this.c.forEach(w)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=C;function S(b){return m(b)}e.$om=S;function m(b){return b.contributes&&b.contributes.localizations?b.contributes.localizations.length>0:!1}e.$pm=m;function l(b){return b.contributes&&b.contributes.authentication?b.contributes.authentication.length>0:!1}e.$qm=l;function $(b,w){if(w){const h=`onResolveRemoteAuthority:${(0,D.$bl)(w)}`;return!!b.activationEvents?.includes(h)}return!1}e.$rm=$,e.$sm=(0,L.$6h)("IBuiltinExtensionsScannerService")}),define(le[214],he([0,1,2,45,11]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8p=void 0;class A extends O.$Tc{constructor(P,k,g,C,S){super(),this.a=P,this.b=k,this.c=g,this.f=S,this.B(C.onDidInstallExtensions(m=>this.g(m))),this.B(C.onDidUninstallExtension(m=>this.h(m)))}g(P){for(const k of P)k.local&&this.invalidate(k.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const k of this.a.profiles)this.c.extUri.isEqual(k.extensionsResource,P)&&await this.j(k);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,L.$fm))}catch(k){(0,D.$Hk)(k)!==1&&this.f.error(k)}}}e.$8p=A}),define(le[215],he([0,1,6,14,26,7,3,2,100,63,32,68,213,77]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.PersistentConnectionEventType=e.$ll=e.$kl=e.$jl=e.ConnectionType=void 0;const $=30*1e3;var b;(function(q){q[q.Management=1]="Management",q[q.ExtensionHost=2]="ExtensionHost",q[q.Tunnel=3]="Tunnel"})(b||(e.ConnectionType=b={}));function w(q){switch(q){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(q){const j=new D.$6d;return setTimeout(()=>j.cancel(),q),j.token}function f(q,j){if(q.isCancellationRequested||j.isCancellationRequested)return D.CancellationToken.Cancelled;const F=new D.$6d;return q.onCancellationRequested(()=>F.cancel()),j.onCancellationRequested(()=>F.cancel()),F.token}class d{get didTimeout(){return this.c==="timedout"}constructor(j){this.c="pending",this.d=new P.$Sc,this.promise=new Promise((F,B)=>{this.f=F,this.g=B}),j.isCancellationRequested?this.h():this.d.add(j.onCancellationRequested(()=>this.h()))}registerDisposable(j){this.c==="pending"?this.d.add(j):j.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const j=new Error("Time limit reached");return j.code="ETIMEDOUT",j.syscall="connect",j}resolve(j){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(j))}reject(j){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(j))}}function c(q,j){const F=new d(j);return F.registerDisposable(q.onControlMessage(B=>{const z=JSON.parse(B.toString()),_=V(z);_?F.reject(_):F.resolve(z)})),F.promise}function v(q,j,F,B,z,_,G,J){const te=new d(J),ne=g.$Rd.create(!1);return q.info(`Creating a socket (${G})...`),k.mark(`code/willCreateSocket/${_}`),j.connect(F,B,z,G).then(ce=>{te.didTimeout?(k.mark(`code/didCreateSocketError/${_}`),q.info(`Creating a socket (${G}) finished after ${ne.elapsed()} ms, but this is too late and has timed out already.`),ce?.dispose()):(k.mark(`code/didCreateSocketOK/${_}`),q.info(`Creating a socket (${G}) was successful after ${ne.elapsed()} ms.`),te.resolve(ce))},ce=>{k.mark(`code/didCreateSocketError/${_}`),q.info(`Creating a socket (${G}) returned an error after ${ne.elapsed()} ms.`),q.error(ce),te.reject(ce)}),te.promise}function i(q,j){const F=new d(j);return q.then(B=>{F.didTimeout||F.resolve(B)},B=>{F.didTimeout||F.reject(B)}),F.promise}async function o(q,j,F,B){const z=ae(q,j);q.logService.trace(`${z} 1/6. invoking socketFactory.connect().`);let _;try{_=await v(q.logService,q.remoteSocketFactoryService,q.connectTo,(0,l.$cl)(q),`reconnectionToken=${q.reconnectionToken}&reconnection=${q.reconnectionProtocol?"true":"false"}`,w(j),`renderer-${w(j)}-${q.reconnectionToken}`,B)}catch(ce){throw q.logService.error(`${z} socketFactory.connect() failed or timed out. Error:`),q.logService.error(ce),ce}q.logService.trace(`${z} 2/6. socketFactory.connect() was successful.`);let G,J;q.reconnectionProtocol?(q.reconnectionProtocol.beginAcceptReconnection(_,null),G=q.reconnectionProtocol,J=!1):(G=new S.$Th({socket:_}),J=!0),q.logService.trace(`${z} 3/6. sending AuthRequest control message.`);const te=await i(q.signService.createNewMessage((0,C.$qg)()),B),ne={type:"auth",auth:q.connectionToken||"00000000000000000000",data:te.data};G.sendControl(L.$je.fromString(JSON.stringify(ne)));try{const ce=await c(G,f(B,h(1e4)));if(ce.type!=="sign"||typeof ce.data!="string"){const Ee=new Error("Unexpected handshake message");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}if(q.logService.trace(`${z} 4/6. received SignRequest control message.`),!await i(q.signService.validate(te,ce.signedData),B)){const Ee=new Error("Refused to connect to unsupported server");throw Ee.code="VSCODE_CONNECTION_ERROR",Ee}const $e=await i(q.signService.sign(ce.data),B),me={type:"connectionType",commit:q.commit,signedData:$e,desiredConnectionType:j};return F&&(me.args=F),q.logService.trace(`${z} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(L.$je.fromString(JSON.stringify(me))),{protocol:G,ownsProtocol:J}}catch(ce){throw ce&&ce.code==="ETIMEDOUT"&&(q.logService.error(`${z} the handshake timed out. Error:`),q.logService.error(ce)),ce&&ce.code==="VSCODE_CONNECTION_ERROR"&&(q.logService.error(`${z} received error control message when negotiating connection. Error:`),q.logService.error(ce)),J&&W(G),ce}}async function n(q,j,F,B){const z=Date.now(),_=ae(q,j),{protocol:G,ownsProtocol:J}=await o(q,j,F,B),te=new d(B);return te.registerDisposable(G.onControlMessage(ne=>{const ce=JSON.parse(ne.toString()),de=V(ce);de?(q.logService.error(`${_} received error control message when negotiating connection. Error:`),q.logService.error(de),J&&W(G),te.reject(de)):(q.reconnectionProtocol?.endAcceptReconnection(),q.logService.trace(`${_} 6/6. handshake finished, connection is up and running after ${K(z)}!`),te.resolve({protocol:G,firstMessage:ce}))})),te.promise}async function s(q,j){const{protocol:F}=await n(q,1,void 0,j);return{protocol:F}}async function t(q,j,F){const{protocol:B,firstMessage:z}=await n(q,2,j,F),_=z&&z.debugPort;return{protocol:B,debugPort:_}}async function r(q,j,F){const B=Date.now(),z=ae(q,3),{protocol:_}=await o(q,3,j,F);return q.logService.trace(`${z} 6/6. handshake finished, connection is up and running after ${K(B)}!`),_}async function a(q,j,F){const{connectTo:B,connectionToken:z}=await q.addressProvider.getAddress();return{commit:q.commit,quality:q.quality,connectTo:B,connectionToken:z,reconnectionToken:j,reconnectionProtocol:F,remoteSocketFactoryService:q.remoteSocketFactoryService,signService:q.signService,logService:q.logService}}async function E(q,j,F){return u(q,async B=>{const{protocol:z}=await s(B,D.CancellationToken.None);return new H(q,j,F,B.reconnectionToken,z)})}e.$jl=E;async function y(q,j){return u(q,async F=>{const{protocol:B,debugPort:z}=await t(F,j,D.CancellationToken.None);return new Z(q,j,F.reconnectionToken,B,z)})}e.$kl=y;async function u(q,j){for(let B=1;;B++)try{const z=(0,C.$qg)(),_=await a(q,z,null);return await j(_)}catch(z){if(B<5)q.logService.error(`[remote-connection][attempt ${B}] An error occurred in initial connection! Will retry... Error:`),q.logService.error(z);else throw q.logService.error(`[remote-connection][attempt ${B}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),q.logService.error(z),x.triggerPermanentFailure(0,0,m.$$k.isHandled(z)),z}}async function p(q,j,F){const B=await a(q,(0,C.$qg)(),null);return await r(B,{host:j,port:F},D.CancellationToken.None)}e.$ll=p;function R(q){return(0,O.$Tg)(j=>new Promise((F,B)=>{const z=setTimeout(F,q*1e3);j.onCancellationRequested(()=>{clearTimeout(z),F()})}))}var N;(function(q){q[q.ConnectionLost=0]="ConnectionLost",q[q.ReconnectionWait=1]="ReconnectionWait",q[q.ReconnectionRunning=2]="ReconnectionRunning",q[q.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",q[q.ConnectionGain=4]="ConnectionGain"})(N||(e.PersistentConnectionEventType=N={}));class T{constructor(j,F){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.type=0}}e.$ml=T;class M{constructor(j,F,B,z){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.durationSeconds=B,this.c=z,this.type=1}skipWait(){this.c.cancel()}}e.$nl=M;class U{constructor(j,F,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=2}}e.$ol=U;class Y{constructor(j,F,B){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.type=4}}e.$pl=Y;class Q{constructor(j,F,B,z){this.reconnectionToken=j,this.millisSinceLastIncomingData=F,this.attempt=B,this.handled=z,this.type=3}}e.$ql=Q;class x extends P.$Tc{static triggerPermanentFailure(j,F,B){this._permanentFailure=!0,this.f=j,this.g=F,this.h=B,this.j.forEach(z=>z.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(j=>j.y())}static debugPauseSocketWriting(){this.j.forEach(j=>j.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||x._permanentFailure}constructor(j,F,B,z,_){super(),this.t=j,this.u=F,this.reconnectionToken=B,this.protocol=z,this.w=_,this.m=this.B(new I.$Vd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new Y(this.reconnectionToken,0,0)),this.B(z.onSocketClose(G=>{const J=ee(this.t,this.reconnectionToken,!0);G?G.type===0?(this.u.logService.info(`${J} received socket close event (hadError: ${G.hadError}).`),G.error&&this.u.logService.error(G.error)):(this.u.logService.info(`${J} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.u.logService.error(G.event)):this.u.logService.info(`${J} received socket close event.`),this.y()})),this.B(z.onSocketTimeout(G=>{const J=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${J} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.y()})),x.j.push(this),this.B((0,P.$Rc)(()=>{const G=x.j.indexOf(this);G>=0&&x.j.splice(G,1)})),this.n&&this.D(x.f,x.g,x.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const j=ee(this.t,this.reconnectionToken,!0);this.u.logService.info(`${j} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const F=[0,5,5,10,10,10,10,10,30];let B=-1;do{B++;const z=B<F.length?F[B]:F[F.length-1];try{if(z>0){const G=R(z);this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),z,G)),this.u.logService.info(`${j} waiting for ${z} seconds before reconnecting...`);try{await G}catch{}}if(this.n){this.u.logService.error(`${j} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new U(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1)),this.u.logService.info(`${j} resolving connection...`);const _=await a(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${j} connecting to ${_.connectTo}...`),await this.G(_,h($)),this.u.logService.info(`${j} reconnected!`),this.m.fire(new Y(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),B+1));break}catch(_){if(_.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${j} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(B>360){this.u.logService.error(`${j} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}if(m.$$k.isTemporarilyNotAvailable(_)){this.u.logService.info(`${j} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((_.code==="ETIMEDOUT"||_.code==="ENETUNREACH"||_.code==="ECONNREFUSED"||_.code==="ECONNRESET")&&_.syscall==="connect"){this.u.logService.info(`${j} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if((0,A.$4)(_)){this.u.logService.info(`${j} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(_);continue}if(_ instanceof m.$$k){this.u.logService.error(`${j} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,m.$$k.isHandled(_));break}this.u.logService.error(`${j} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(_),this.C(this.protocol.getMillisSinceLastIncomingData(),B+1,!1);break}}while(!this.n&&!this.s)}C(j,F,B){this.w?x.triggerPermanentFailure(j,F,B):this.D(j,F,B)}D(j,F,B){this.m.fire(new Q(this.reconnectionToken,j,F,B)),W(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$rl=x;class H extends x{constructor(j,F,B,z,_){super(1,j,z,_,!0),this.client=this.B(new S.$Rh(_,{remoteAuthority:F,clientId:B},j.ipcLogger))}async G(j,F){await s(j,F)}}e.$sl=H;class Z extends x{constructor(j,F,B,z,_){super(2,j,B,z,!1),this.H=F,this.debugPort=_}async G(j,F){await t(j,this.H,F)}}e.$tl=Z;function W(q){try{q.acceptDisconnect();const j=q.getSocket();q.dispose(),j.dispose()}catch(j){(0,A.$1)(j)}}function V(q){if(q&&q.type==="error"){const j=new Error(`Connection error: ${q.reason}`);return j.code="VSCODE_CONNECTION_ERROR",j}return null}function ie(q,j){for(;q.length<j;)q+=" ";return q}function re(q,j){return`[remote-connection][${ie(w(q),13)}][${j.substr(0,5)}\u2026]`}function ee(q,j,F){return`${re(q,j)}[${F?"reconnect":"initial"}]`}function ae(q,j){return`${ee(j,q.reconnectionToken,!!q.reconnectionProtocol)}[${q.connectTo}]`}function K(q){return`${Date.now()-q} ms`}}),define(le[104],he([0,1,2,4]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=void 0,e.$fl=(0,L.$6h)("remoteSocketFactoryService");class D{constructor(){this.a={}}register(I,P){return this.a[I]??=[],this.a[I].push(P),(0,O.$Rc)(()=>{const k=this.a[I]?.indexOf(P);typeof k=="number"&&k>=0&&this.a[I]?.splice(k,1)})}b(I){return(this.a[I.type]||[]).find(k=>k.supports(I))}connect(I,P,k,g){const C=this.b(I);if(!C)throw new Error(`No socket factory found for ${I}`);return C.connect(I,P,k,g)}}e.$gl=D}),define(le[216],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nac=e.$mac=void 0,e.$mac=(0,O.$6h)("sharedProcessTunnelService"),e.$nac="sharedProcessTunnel"}),define(le[105],he([0,1,4,164]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xac=e.$wac=e.$vac=e.$uac=e.$tac=e.TunnelStates=e.$sac=e.$rac=void 0,e.$rac=(0,O.$6h)("IRemoteTunnelService"),e.$sac={active:!1};var D;(function(A){A.disconnected=I=>({type:"disconnected",onTokenFailed:I}),A.connected=(I,P)=>({type:"connected",info:I,serviceInstallFailed:P}),A.connecting=I=>({type:"connecting",progress:I}),A.uninitialized={type:"uninitialized"}})(D||(e.TunnelStates=D={})),e.$tac="remote.tunnels.access",e.$uac=e.$tac+".hostNameOverride",e.$vac=e.$tac+".preventSleep",e.$wac="remoteTunnelService",e.$xac=(0,L.localize)(0,null)}),define(le[59],he([0,1,14,7,2,166,44,4,8,41]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=e.$ip=e.$hp=void 0,e.$hp=(0,P.$6h)("requestService");class C{constructor(v){this.b=v}toJSON(){if(!this.a){const v=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?v[i]="*****":v[i]=this.b[i];this.a=v}return this.a}}class S extends D.$Tc{constructor(v){super(),this.b=0,this.a=v.createLogger("network",{name:(0,A.localize)(0,null),when:k.$Ej.isEqualTo((0,k.$Cj)(k.LogLevel.Trace)).serialize()})}async c(v,i,o){const n=`${v} #${++this.b}: ${i.url}`;this.a.trace(`${n} - begin`,i.type,new C(i.headers??{}));try{const s=await o();return this.a.trace(`${n} - end`,i.type,s.res.statusCode,s.res.headers),s}catch(s){throw this.a.error(`${n} - error`,i.type,(0,L.$0)(s)),s}}}e.$ip=S;function m(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}e.$jp=m;function l(c){return c.res.statusCode===204}e.$kp=l;async function $(c){return l(c)?null:(await(0,O.$ve)(c.stream)).toString()}e.$lp=$;async function b(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);return $(c)}e.$mp=b;async function w(c){if(!m(c))throw new Error("Server returned "+c.res.statusCode);if(l(c))return null;const i=(await(0,O.$ve)(c.stream)).toString();try{return JSON.parse(i)}catch(o){throw o.message+=`:
`+i,o}}e.$np=w;function h(c){d(c)}e.$op=h;let f;function d(c){const v=g.$Hn.as(I.$Mn.Configuration),i=f;f={id:"http",order:15,title:(0,A.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,A.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(6,null),(0,A.localize)(7,null),(0,A.localize)(8,null),(0,A.localize)(9,null)],default:"override",description:(0,A.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,A.localize)(12,null),restricted:!0}}},v.updateConfigurations({add:[f],remove:i?[i]:[]})}d(1)}),define(le[217],he([0,1,26,23,11,59]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RO=void 0;let I=class{constructor(k,g){this.a=k,this.b=g}async download(k,g,C=O.CancellationToken.None){if(k.scheme===L.Schemas.file||k.scheme===L.Schemas.vscodeRemote){await this.b.copy(k,g);return}const S={type:"GET",url:k.toString(!0)},m=await this.a.request(S,C);if(m.res.statusCode===200)await this.b.writeFile(g,m.stream);else{const l=await(0,A.$mp)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${l}`)}}};e.$RO=I,e.$RO=I=pe([X(0,A.$hp),X(1,D.$qk)],I)}),define(le[218],he([0,1,14,26]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=e.$kr=void 0;class D{constructor(P){this.a=P}listen(P,k){throw new Error("Invalid listen")}call(P,k,g,C=L.CancellationToken.None){switch(k){case"request":return this.a.request(g[0],C).then(async({res:S,stream:m})=>{const l=await(0,O.$ve)(m);return[{statusCode:S.statusCode,headers:S.headers},l]});case"resolveProxy":return this.a.resolveProxy(g[0]);case"loadCertificates":return this.a.loadCertificates()}throw new Error("Invalid call")}}e.$kr=D;class A{constructor(P){this.a=P}async request(P,k){const[g,C]=await this.a.call("request",[P],k);return{res:g,stream:(0,O.$xe)(C)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}async loadCertificates(){return this.a.call("loadCertificates")}}e.$lr=A}),define(le[219],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$S$b=e.$R$b=e.$Q$b=void 0,e.$Q$b={exit:"vscode:electron-main->shared-process=exit",ipcReady:"vscode:shared-process->electron-main=ipc-ready",initDone:"vscode:shared-process->electron-main=init-done"},e.$R$b={request:"vscode:createSharedProcessChannelConnection",response:"vscode:createSharedProcessChannelConnectionResult"},e.$S$b={request:"vscode:createSharedProcessRawConnection",response:"vscode:createSharedProcessRawConnectionResult"}}),define(le[220],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;class O{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(D){try{const A=await this.c();if(A){const I=String(O.a++);return this.b.set(I,A),{id:I,data:A.createNewMessage(D)}}}catch{}return{id:"",data:D}}async validate(D,A){if(!D.id)return!0;const I=this.b.get(D.id);if(!I)return!1;this.b.delete(D.id);try{return I.validate(A)==="ok"}catch{return!1}finally{I.dispose?.()}}async sign(D){try{return await this.d(D)}catch{}return D}}e.$L7b=O}),define(le[106],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl="signService",e.$il=(0,O.$6h)(e.$hl)}),define(le[221],he([0,1,220]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=void 0;class L extends O.$L7b{c(){return this.h().then(A=>new A.validator)}d(A){return this.h().then(I=>new I.signer().sign(A))}h(){return new Promise((A,I)=>se(["vsda"],A,I))}}e.$G_b=L}),define(le[78],he([0,1,3,2]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bGb=e.$aGb=e.$_Fb=e.$$Fb=void 0;class D extends L.$Tc{constructor(S,m,l){super(),this.a=S,this.b=m,this.c=l}async getItems(){const S={profile:this.b,workspace:this.c},m=await this.a.call("getItems",S);return new Map(m)}updateItems(S){const m={profile:this.b,workspace:this.c};return S.insert&&(m.insert=Array.from(S.insert.entries())),S.delete&&(m.delete=Array.from(S.delete.values())),this.a.call("updateItems",m)}optimize(){const S={profile:this.b,workspace:this.c};return this.a.call("optimize",S)}}class A extends D{constructor(S,m){super(S,m,void 0),this.f=this.B(new O.$Vd),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(S=>this.h(S)))}h(S){(Array.isArray(S.changed)||Array.isArray(S.deleted))&&this.f.fire({changed:S.changed?new Map(S.changed):void 0,deleted:S.deleted?new Set(S.deleted):void 0})}}class I extends A{constructor(S){super(S,void 0)}async close(){this.dispose()}}e.$$Fb=I;class P extends A{constructor(S,m){super(S,m)}async close(){this.dispose()}}e.$_Fb=P;class k extends D{constructor(S,m){super(S,void 0,m),this.onDidChangeItemsExternal=O.Event.None}async close(){this.dispose()}}e.$aGb=k;class g{constructor(S){this.a=S}isUsed(S){const m={payload:S,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.$bGb=g}),define(le[107],he([0,1,5,37,32]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function A(k){if(O.$u===2&&/^penguin(\.|$)/i.test(k))return"chromebook"}function I(k,g,C,S,m,l,$,b,w){const h=Object.create(null);h["common.machineId"]=l,h["common.sqmId"]=$,h.sessionID=(0,D.$qg)()+Date.now(),h.commitHash=S,h.version=m,h["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=(0,O.$h)(O.$u),h["common.nodePlatform"]=L.$dc,h["common.nodeArch"]=C,h["common.product"]=w||"desktop",b&&(h["common.msftInternal"]=b);let f=0;const d=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>f++,enumerable:!0}}),O.$l&&(h["common.snap"]="true");const c=A(g);return c&&(h["common.platformDetail"]=c),h}e.$Jo=I;function P(k){const g=L.env.USERDNSDOMAIN;if(!g)return!1;const C=g.toLowerCase();return k.some(S=>C===S)}e.$Ko=P}),define(le[22],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,O.$6h)("telemetryService"),e.$vl=(0,O.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var L;(function(A){A[A.NONE=0]="NONE",A[A.CRASH=1]="CRASH",A[A.ERROR=2]="ERROR",A[A.USAGE=3]="USAGE"})(L||(e.TelemetryLevel=L={}));var D;(function(A){A.OFF="off",A.CRASH="crash",A.ERROR="error",A.ON="all"})(D||(e.TelemetryConfiguration=D={}))}),define(le[222],he([0,1,36,6,34,23,16,5,10,143,31,146,95,11,24,22]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9r=e.$8r=e.$7r=e.$6r=void 0;const w=new Map;async function h(i,o){const n=`${i}::${o.join(":")}`,s=w.get(n);if(s)return s;const t=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],r=new Map,a=new Map,E=2e4;function y(p,R,N,T){const M=R.substring(p.length+1);return L.Promises.withAsyncBody(async U=>{let Y;try{Y=await C.Promises.readdir(R,{withFileTypes:!0})}catch{U();return}if(T.count>=E){T.count+=Y.length,T.maxReached=!0,U();return}let Q=Y.length;if(Q===0){U();return}let x=Y;T.count+Y.length>E&&(T.maxReached=!0,Q=E-T.count,x=Y.slice(0,Q)),T.count+=Y.length;for(const H of x)if(H.isDirectory()){if(N.includes(H.name)||await y(p,(0,I.$jc)(R,H.name),N,T),--Q===0){U();return}}else{const Z=H.name.lastIndexOf(".");if(Z>=0){const W=H.name.substring(Z+1);W&&r.set(W,(r.get(W)??0)+1)}for(const W of t)W.relativePathPattern?.test(M)!==!1&&W.filePattern.test(H.name)&&a.set(W.tag,(a.get(W.tag)??0)+1);if(--Q===0){U();return}}})}const u=L.Promises.withAsyncBody(async p=>{const R={count:0,maxReached:!1};await y(i,i,o,R);const N=await c(i);p({configFiles:f(a),fileTypes:f(r),fileCount:R.count,maxFilesReached:R.maxReached,launchConfigFiles:N})});return w.set(n,u),u}e.$6r=h;function f(i){return Array.from(i.entries(),([o,n])=>({name:o,count:n})).sort((o,n)=>n.count-o.count)}function d(){const i={os:`${O.type()} ${O.arch()} ${O.release()}`,memory:`${(O.totalmem()/l.$Yk.GB).toFixed(2)}GB (${(O.freemem()/l.$Yk.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(g.$0m.value()*100)}%`},o=O.cpus();return o&&o.length>0&&(i.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),i}e.$7r=d;async function c(i){try{const o=new Map,n=(0,I.$jc)(i,".vscode","launch.json"),s=await C.Promises.readFile(n),t=[],r=(0,D.$cn)(s.toString(),t);if(t.length)return console.log(`Unable to parse ${n}`),[];if((0,D.$ln)(r)==="object"&&r.configurations)for(const a of r.configurations){const E=a.type;E&&(o.has(E)?o.set(E,o.get(E)+1):o.set(E,1))}return f(o)}catch{return[]}}e.$8r=c;let v=class{constructor(o,n){this.c=o,this.d=n}f(o){const n=[];return n.push(`OS Version:       ${o.os}`),n.push(`CPUs:             ${o.cpus}`),n.push(`Memory (System):  ${o.memory}`),n.push(`VM:               ${o.vmHint}`),n.join(`
`)}g(o){const n=[];n.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),n.push(`OS Version:       ${O.type()} ${O.arch()} ${O.release()}`);const s=O.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(O.totalmem()/l.$Yk.GB).toFixed(2)}GB (${(O.freemem()/l.$Yk.GB).toFixed(2)}GB free)`),P.$i||n.push(`Load (avg):       ${O.loadavg().map(t=>Math.round(t)).join(", ")}`),n.push(`VM:               ${Math.round(g.$0m.value()*100)}%`),n.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${o.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.j(o.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(o,n){return Promise.all([(0,S.$5r)(o.mainPID),this.k(o)]).then(async s=>{let[t,r]=s,a=this.m(o,t);return n.forEach(E=>{if((0,m.$Jm)(E))a+=`
${E.errorMessage}`,r+=`
${E.errorMessage}`;else if(a+=`

Remote: ${E.hostName}`,E.processes&&(a+=`
${this.m(o,E.processes)}`),E.workspaceMetadata){r+=`
|  Remote: ${E.hostName}`;for(const y of Object.keys(E.workspaceMetadata)){const u=E.workspaceMetadata[y];let p=`${u.fileCount} files`;u.maxFilesReached&&(p=`more than ${p}`),r+=`|    Folder (${y}): ${p}`,r+=this.h(u)}}}),{processInfo:a,workspaceInfo:r}})}async getSystemInfo(o,n){const{memory:s,vmHint:t,os:r,cpus:a}=d(),E={os:r,memory:s,cpus:a,vmHint:t,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:n};return P.$i||(E.load=`${O.loadavg().map(y=>Math.round(y)).join(", ")}`),P.$k&&(E.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(E)}async getDiagnostics(o,n){const s=[];return(0,S.$5r)(o.mainPID).then(async t=>(s.push(""),s.push(this.g(o)),s.push(""),s.push(this.m(o,t)),o.windows.some(r=>r.folderURIs&&r.folderURIs.length>0&&!r.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.k(o))),n.forEach(r=>{if((0,m.$Jm)(r))s.push(`
${r.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${r.hostName}`),s.push(this.f(r.machineInfo)),r.processes&&s.push(this.m(o,r.processes)),r.workspaceMetadata)for(const a of Object.keys(r.workspaceMetadata)){const E=r.workspaceMetadata[a];let y=`${E.fileCount} files`;E.maxFilesReached&&(y=`more than ${y}`),s.push(`Folder (${a}): ${y}`),s.push(this.h(E))}}),s.push(""),s.push(""),s.join(`
`)))}h(o){const n=[];let t=0;const r=(u,p)=>{const R=` ${u}(${p})`;t+R.length>60?(n.push(a),a="|                 ",t=a.length):t+=R.length,a+=R};let a="|      File types:";const E=10,y=o.fileTypes.length>E?E:o.fileTypes.length;for(let u=0;u<y;u++){const p=o.fileTypes[u];r(p.name,p.count)}if(n.push(a),o.configFiles.length>=0&&(a="|      Conf files:",t=0,o.configFiles.forEach(u=>{r(u.name,u.count)}),n.push(a)),o.launchConfigFiles.length>0){let u="|      Launch Configs:";o.launchConfigFiles.forEach(p=>{const R=p.count>1?` ${p.name}(${p.count})`:` ${p.name}`;u+=R}),n.push(u)}return n.join(`
`)}j(o){const n=Math.max(...Object.keys(o).map(s=>s.length));return Object.keys(o).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${o[s]}`).join(`
                  `)}k(o){const n=[],s=[];return o.windows.forEach(t=>{t.folderURIs.length===0||t.remoteAuthority||(n.push(`|  Window (${t.title})`),t.folderURIs.forEach(r=>{const a=k.URI.revive(r);if(a.scheme===A.Schemas.file){const E=a.fsPath;s.push(h(E,["node_modules",".git"]).then(y=>{let u=`${y.fileCount} files`;y.maxFilesReached&&(u=`more than ${u}`),n.push(`|    Folder (${(0,I.$nc)(E)}): ${u}`),n.push(this.h(y))}).catch(y=>{n.push(`|      Error: Unable to collect workspace stats for folder ${E} (${y.toString()})`)}))}else n.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(t=>n.join(`
`)).catch(t=>`Unable to collect workspace stats: ${t}`)}m(o,n){const s=new Map;o.windows.forEach(r=>s.set(r.pid,`window [${r.id}] (${r.title})`)),o.pidToNames.forEach(({pid:r,name:a})=>s.set(r,a));const t=[];return t.push("CPU %	Mem MB	   PID	Process"),n&&this.n(o.mainPID,s,t,n,0),t.join(`
`)}n(o,n,s,t,r){const a=r===0;let E;a?E=t.pid===o?`${this.d.applicationName} main`:"remote agent":n.has(t.pid)?E=n.get(t.pid):E=`${"  ".repeat(r)} ${t.name}`;const y=process.platform==="win32"?t.mem:O.totalmem()*(t.mem/100);s.push(`${t.load.toFixed(0).padStart(5," ")}	${(y/l.$Yk.MB).toFixed(0).padStart(6," ")}	${t.pid.toFixed(0).padStart(6," ")}	${E}`),Array.isArray(t.children)&&t.children.forEach(u=>this.n(o,n,s,u,r+1))}async getWorkspaceFileExtensions(o){const n=new Set;for(const{uri:s}of o.folders){const t=k.URI.revive(s);if(t.scheme!==A.Schemas.file)continue;const r=t.fsPath;try{(await h(r,["node_modules",".git"])).fileTypes.forEach(E=>n.add(E.name))}catch{}}return{extensions:[...n]}}async reportWorkspaceStats(o){for(const{uri:n}of o.folders){const s=k.URI.revive(n);if(s.scheme!==A.Schemas.file)continue;const t=s.fsPath;try{const r=await h(t,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),r.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})}),r.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};e.$9r=v,e.$9r=v=pe([X(0,b.$ul),X(1,$.$Fj)],v)}),define(le[108],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W$b=e.$V$b=void 0;class O{constructor(A){this.b=A}listen(A,I){throw new Error(`Event not found: ${I}`)}call(A,I,{eventName:P,data:k}){return this.b.forEach(g=>g.log(P,k)),Promise.resolve(null)}}e.$V$b=O;class L{constructor(A){this.b=A}log(A,I){return this.b.call("log",{eventName:A,data:I}).then(void 0,P=>`Failed to log telemetry: ${console.warn(P)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.$W$b=L}),define(le[46],he([0,1,30,12,77,107,22]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class P{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.$Lo=P;class k{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=k,e.$No=new k;class g{async publicLog(o,n,s){}async publicLogError(o,n,s){}}e.$Oo=g,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function C(i,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!i.enableTelemetry)}e.$So=C;function S(i,o){return o.extensionTestsLocationURI?!0:!(o.isBuilt||o.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.$To=S;function m(i){const o=i.getValue(I.$Cl),n=i.getValue(I.$Dl);if(i.getValue(I.$El)===!1||n===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=m;function l(i){const o={},n={},s={};w(i,s);for(let t in s){t=t.length>150?t.substr(t.length-149):t;const r=s[t];typeof r=="number"?n[t]=r:typeof r=="boolean"?n[t]=r?1:0:typeof r=="string"?(r.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${r.length}`),o[t]=r.substring(0,8191)):typeof r<"u"&&r!==null&&(o[t]=r)}return{properties:o,measurements:n}}e.$Vo=l;const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function b(i){if(!i)return"none";const o=(0,D.$bl)(i);return $.has(o)?o:"other"}e.$Wo=b;function w(i,o,n=0,s){if(i)for(const t of Object.getOwnPropertyNames(i)){const r=i[t],a=s?s+t:t;Array.isArray(r)?o[a]=(0,O.$An)(r):r instanceof Date?o[a]=r.toISOString():(0,L.$Kf)(r)?n<2?w(r,o,n+1,a+"."):o[a]=(0,O.$An)(r):o[a]=r}}function h(i,o){const n=i.msftInternalDomains||[],s=o.getValue("telemetry.internalTesting");return(0,A.$Ko)(n)||s}e.$Xo=h;function f(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.$Yo=f;function d(i,o){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let n=i;const s=[];for(const E of o)for(;;){const y=E.exec(i);if(!y)break;s.push([y.index,E.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,r=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let a=0;for(n="";;){const E=r.exec(i);if(!E)break;const y=s.some(([u,p])=>E.index<p&&u<r.lastIndex);!t.test(E[0])&&!y&&(n+=i.substring(a,E.index)+"<REDACTED: user-file-path>",a=r.lastIndex)}return a<i.length&&(n+=i.substr(a)),n}function c(i){if(!i)return i;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of o)if(n.regex.test(i))return`<REDACTED: ${n.label}>`;return i}function v(i,o){return(0,O.$xn)(i,n=>{if(n instanceof P||Object.hasOwnProperty.call(n,"isTrustedTelemetryValue"))return n.value;if(typeof n=="string"){let s=n.replaceAll("%20"," ");s=d(s,o);for(const t of o)s=s.replace(t,"");return s=c(s),s}})}e.$Zo=v}),define(le[33],he([0,1,27,29,45,5,10,7,37,46]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function C(n,s){return n.uuid&&s.uuid?n.uuid===s.uuid:n.id===s.id?!0:(0,O.$7e)(n.id,s.id)===0}e.$1o=C;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(s){const t=s.manifest?s.manifest.version:s.version,r=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new m(s.identifier,t,r)}static parse(s){const t=S.exec(s);return t&&t[1]&&t[2]?new m({id:t[1]},t[2],t[4]||void 0):null}constructor(s,t,r="undefined"){this.version=t,this.targetPlatform=r,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof m?C(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.$2o=m;const l=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(n){const s=l.exec(n);return s&&s[1]?[w(s[1]),s[2]]:[w(n),void 0]}e.$3o=$;function b(n,s){return`${n}.${s}`}e.$4o=b;function w(n){return n.toLowerCase()}e.$5o=w;function h(n,s){return w(b(n??D.$hm,s))}e.$6o=h;function f(n,s){const t=[],r=a=>{for(const E of t)if(E.some(y=>C(s(y),s(a))))return E;return null};for(const a of n){const E=r(a);E?E.push(a):t.push([a])}return t}e.$7o=f;function d(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}e.$8o=d;function c(n){return{id:new g.$Lo(n.identifier.id),name:new g.$Lo(n.name),galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),isSigned:n.isSigned,...n.telemetryData}}e.$9o=c,e.$0o=new D.$lm("pprice.better-merge");function v(n,s){const t=[],r=s.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const a=r.shift();if(a&&t.every(E=>!C(E.identifier,{id:a}))){const E=n.filter(y=>C(y.identifier,{id:a}));E.length===1&&(t.push(E[0]),r.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return t}e.$$o=v;async function i(n,s){if(!A.$k)return!1;let t;try{t=(await n.readFile(I.URI.file("/etc/os-release"))).value.toString()}catch{try{t=(await n.readFile(I.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){s.debug("Error while getting the os-release file.",(0,P.$0)(a))}}return!!t&&(t.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function o(n,s){const t=await i(n,s),r=(0,L.$uo)(t?"alpine":A.$u,k.$ec);return s.debug("ComputeTargetPlatform:",r),r}e.$_o=o}),define(le[223],he([0,1,17,2,20,10,11,24,6,3,16,5,37,33]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$T9b=e.$S9b=void 0;let $=class extends L.$Tc{constructor(d,c){super(),this.b=d,this.c=c,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,v])=>this.a.set(v.configPath,v))}getConfigBasedTips(d){return this.f(d)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(d){const c=[];for(const[v,i]of this.a)if(!(i.configScheme&&i.configScheme!==d.scheme))try{const o=(await this.b.readFile((0,D.$Hg)(d,v))).value.toString();for(const[n,s]of Object.entries(i.recommendations))(!s.contentPattern||new RegExp(s.contentPattern,"mig").test(o))&&c.push({extensionId:n,extensionName:s.name,configName:i.configName,important:!!s.important,isExtensionPack:!!s.isExtensionPack,whenNotInstalled:s.whenNotInstalled})}catch{}return c}};e.$S9b=$,e.$S9b=$=pe([X(0,I.$qk),X(1,P.$Fj)],$);const b="extensionTips/promptedExecutableTips",w="extensionTips/lastPromptedMediumImpExeTime";class h extends ${constructor(d,c,v,i,o,n,s,t){super(s,t),this.r=d,this.s=c,this.t=v,this.u=i,this.w=o,this.z=n,this.g=new Map,this.h=new Map,this.j=new Map,this.m=new Map,this.n=new Map,t.exeBasedExtensionTips&&Object.entries(t.exeBasedExtensionTips).forEach(([r,a])=>{const E=[],y=[],u=[];Object.entries(a.recommendations).forEach(([p,R])=>{R.important?a.important?E.push({extensionId:p,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):y.push({extensionId:p,extensionName:R.name,isExtensionPack:!!R.isExtensionPack}):u.push({extensionId:p,extensionName:R.name,isExtensionPack:!!R.isExtensionPack})}),E.length&&this.g.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:E}),y.length&&this.h.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:y}),u.length&&this.j.set(r,{exeFriendlyName:a.friendlyName,windowsPath:a.windowsPath,recommendations:u})}),(0,k.$8g)(async()=>{await this.C(),this.F(),this.G()},3e3,this.q)}async getImportantExecutableBasedTips(){const d=await this.O(this.g),c=await this.O(this.h);return[...d,...c]}getOtherExecutableBasedTips(){return this.O(this.j)}async C(){const d=await this.O(this.g),c=await this.O(this.h),v=await this.u.getInstalled();this.m=this.D(d,v),this.n=this.D(c,v)}D(d,c){const v=new Map;d.forEach(t=>v.set(t.extensionId.toLowerCase(),t));const{installed:i,uninstalled:o}=this.N([...v.keys()],c);for(const t of i){const r=v.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:t,exeName:r.exeName})}for(const t of o){const r=v.get(t);r&&this.t.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:t,exeName:r.exeName})}const n=this.L(),s=new Map;for(const t of o){const r=v.get(t);if(r&&(!n[r.exeName]||!n[r.exeName].includes(r.extensionId))){let a=s.get(r.exeName);a||(a=[],s.set(r.exeName,a)),a.push(r)}}return s}F(){if(this.m.size===0)return;const[d,c]=[...this.m.entries()][0];this.H(c).then(v=>{switch(v){case"reacted":this.M(c[0].exeName,c);break;case"ignored":this.m.delete(d);break;case"incompatibleWindow":{const i=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(i(()=>this.F()));break}case"toomany":{const i=this.B(new L.$Uc);i.value=(0,k.$8g)(()=>{i.dispose(),this.F()},60*60*1e3);break}}})}G(){if(this.n.size===0)return;const d=this.I(),c=Date.now()-d,v=7*24*60*60*1e3;if(c<v){const n=this.B(new L.$Uc);n.value=(0,k.$8g)(()=>{n.dispose(),this.G()},v-c);return}const[i,o]=[...this.n.entries()][0];this.H(o).then(n=>{switch(n){case"reacted":{this.J(Date.now()),this.n.delete(i),this.M(o[0].exeName,o);const s=this.B(new L.$Uc);s.value=(0,k.$8g)(()=>{s.dispose(),this.G()},v);break}case"ignored":this.n.delete(i),this.G();break;case"incompatibleWindow":{const s=g.Event.once(g.Event.latch(g.Event.any(this.s.onDidOpenMainWindow,this.s.onDidFocusMainWindow)));this.B(s(()=>this.G()));break}case"toomany":{const s=this.B(new L.$Uc);s.value=(0,k.$8g)(()=>{s.dispose(),this.G()},60*60*1e3);break}}})}async H(d){const c=await this.u.getInstalled(1),v=d.filter(i=>!i.whenNotInstalled||i.whenNotInstalled.every(o=>c.every(n=>!(0,l.$1o)(n.identifier,{id:o})))).map(({extensionId:i})=>i.toLowerCase());return this.z.promptImportantExtensionsInstallNotification({extensions:v,source:3,name:d[0].exeFriendlyName,searchValue:`@exe:"${d[0].exeName}"`})}I(){let d=this.w.getNumber(w,-1);return d||(d=Date.now(),this.J(d)),d}J(d){this.w.store(w,d,-1,1)}L(){return JSON.parse(this.w.get(b,-1,"{}"))}M(d,c){const v=this.L();v[d]=c.map(({extensionId:i})=>i.toLowerCase()),this.w.store(b,JSON.stringify(v),-1,0)}N(d,c){const v=[],i=[],o=c.reduce((n,s)=>(n.add(s.identifier.id.toLowerCase()),n),new Set);return d.forEach(n=>{o.has(n.toLowerCase())?v.push(n):i.push(n)}),{installed:v,uninstalled:i}}async O(d){const c=[],v=new Map;for(const i of d.keys()){const o=d.get(i);if(!o||!(0,O.$Lb)(o.recommendations))continue;const n=[];S.$i?o.windowsPath&&n.push(o.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(n.push((0,C.$jc)("/usr/local/bin",i)),n.push((0,C.$jc)("/usr/bin",i)),n.push((0,C.$jc)(this.r.fsPath,i)));for(const s of n){let t=v.get(s);if(t===void 0&&(t=await this.b.exists(A.URI.file(s)),v.set(s,t)),t)for(const{extensionId:r,extensionName:a,isExtensionPack:E,whenNotInstalled:y}of o.recommendations)c.push({extensionId:r,extensionName:a,isExtensionPack:E,exeName:i,exeFriendlyName:o.exeFriendlyName,windowsPath:o.windowsPath,whenNotInstalled:y})}}return c}}e.$T9b=h}),define(le[224],he([0,1,26,33]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0Zb=void 0;async function D(A,I,P,k,g){try{const C=await A.getExtensionsControlManifest();if(!C.deprecated)return;const S=await A.getInstalled(1);for(const[m,l]of Object.entries(C.deprecated)){if(!l?.extension)continue;const{id:$,autoMigrate:b,preRelease:w}=l.extension;if(!b)continue;const h=S.find(d=>(0,L.$1o)(d.identifier,{id:m}));if(!h)continue;const f=(await I.getExtensions([{id:$,preRelease:w}],{targetPlatform:await A.getTargetPlatform(),compatible:!0},O.CancellationToken.None))[0];if(!f){g.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${$}' extension is not found`);continue}try{g.info(`Migrating '${h.identifier.id}' extension to '${$}' extension...`);const d=!k.getDisabledExtensions().some(v=>(0,L.$1o)(v,h.identifier));await A.uninstall(h),g.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let c=S.find(v=>(0,L.$1o)(v.identifier,{id:$}));(!c||!c.isPreReleaseVersion&&d)&&(c=await A.installFromGallery(f,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),g.info(`Installed the pre-release extension '${c.identifier.id}'`),d||(await k.disableExtension(c.identifier),g.info(`Disabled the pre-release extension '${c.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),b.storage&&(P.addToMigrationList((0,L.$4o)(h.manifest.publisher,h.manifest.name),(0,L.$4o)(c.manifest.publisher,c.manifest.name)),g.info("Added pre-release extension to the storage migration list"))),g.info(`Migrated '${h.identifier.id}' extension to '${$}' extension.`)}catch(d){g.error(d)}}}catch(C){g.error(C)}}e.$0Zb=D}),define(le[225],he([0,1,6,7,2,23,20,55,12,32,31,70,21,15,29,33,99,11,8]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$5p=void 0;let c=class extends D.$Tc{static{d=this}static{this.c=".sigzip"}constructor(i,o,n,s,t,r){super(),this.h=o,this.j=n,this.m=s,this.n=t,this.r=r,this.extensionsDownloadDir=i.extensionsDownloadLocation,this.f=20,this.g=this.y()}async download(i,o,n){await this.g;const s=(0,I.$Hg)(this.extensionsDownloadDir,this.z(i));try{await this.w(i,s,r=>this.j.download(i,r,o))}catch(r){throw new $.$zo(r.message,$.ExtensionManagementErrorCode.Download)}let t=!1;if(n&&this.t(i)){const r=await this.u(i);try{t=await this.n.verify(s.fsPath,r.fsPath,this.r.getLevel()===f.LogLevel.Trace)}catch(a){const E=a;if(t=E.code,E.output&&this.r.trace(`Extension signature verification details for ${i.identifier.id} ${i.version}:
${E.output}`),t===$.ExtensionSignaturetErrorCode.PackageIsInvalidZip||t===$.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip){try{await this.delete(s)}catch(y){this.r.error(y)}throw new $.$zo(S.$Lp,$.ExtensionManagementErrorCode.CorruptZip)}}finally{try{await this.delete(r)}catch(a){this.r.error(a)}}}return t===!0?this.r.info(`Extension signature is verified: ${i.identifier.id}`):t===!1?this.r.info(`Extension signature verification is not done: ${i.identifier.id}`):this.r.warn(`Extension signature verification failed with error '${t}': ${i.identifier.id}`),{location:s,verificationStatus:t}}t(i){if(!i.isSigned)return this.r.info(`Extension is not signed: ${i.identifier.id}`),!1;const o=this.m.getValue("extensions.verifySignature");return(0,k.$Of)(o)?o:!0}async u(i){await this.g;const o=(0,I.$Hg)(this.extensionsDownloadDir,`${this.z(i)}${d.c}`);try{await this.w(i,o,n=>this.j.downloadSignatureArchive(i,n))}catch(n){throw new $.$zo(n.message,$.ExtensionManagementErrorCode.DownloadSignature)}return o}async w(i,o,n){if(await this.h.exists(o))return;if(o.scheme!==A.Schemas.file){await n(o);return}const s=(0,I.$Hg)(this.extensionsDownloadDir,`.${(0,g.$qg)()}`);await this.h.exists(s)||await n(s);try{await C.Promises.rename(s.fsPath,o.fsPath,2*60*1e3)}catch(t){try{await this.h.del(s)}catch{}if(t.code==="ENOTEMPTY")this.r.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",i.identifier.id,o.path);else throw this.r.info(`Rename failed because of ${(0,L.$0)(t)}. Deleted the file from downloaded location`,s.path),t}}async delete(i){await this.g,await this.h.del(i)}async y(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.r.trace("Extension VSIX downloads cache dir does not exist");return}const i=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(i.children){const o=[],n=[],s=[];for(const a of i.children)if(a.name.endsWith(d.c))s.push(a.resource);else{const E=b.$2o.parse(a.name);E&&n.push([E,a])}const t=(0,b.$7o)(n,([a])=>a),r=[];for(const a of t)a.sort((E,y)=>P.rcompare(E[0].version,y[0].version)),o.push(...a.slice(1).map(E=>E[1].resource)),r.push(a[0][1]);r.sort((a,E)=>a.mtime-E.mtime),o.push(...r.slice(0,Math.max(0,r.length-this.f)).map(a=>a.resource)),o.push(...s),await O.Promises.settled(o.map(a=>(this.r.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(i){this.r.error(i)}}z(i){return this.f?b.$2o.create(i).toString().toLowerCase():(0,g.$qg)()}};e.$5p=c,e.$5p=c=d=pe([X(0,l.$bi),X(1,h.$qk),X(2,$.$yo),X(3,m.$zi),X(4,w.$Fp),X(5,f.$nj)],c)}),define(le[226],he([0,1,3,2,35,33,45]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=void 0;class P extends L.$Tc{constructor(g,C,S,m,l,$,b){super(),this.f=g,this.g=C,this.h=S,this.j=m,this.m=l,this.n=$,this.r=b,this.a=this.B(new O.$Vd),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new L.$3c),this.s().then(null,w=>b.error(w))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(g=>this.u(g.added))),this.B(this.j.onAddExtensions(g=>this.w(g))),this.B(this.j.onDidAddExtensions(g=>this.y(g))),this.B(this.j.onRemoveExtensions(g=>this.z(g))),this.B(this.j.onDidRemoveExtensions(g=>this.C(g))),this.B(this.n.onDidFilesChange(g=>this.D(g)))}async u(g){try{g.length&&await Promise.all(g.map(C=>(this.c.set(C.id,(0,L.$Qc)(this.n.watch(this.m.extUri.dirname(C.extensionsResource)),this.n.watch(C.extensionsResource))),this.G(C.extensionsResource))))}catch(C){throw this.r.error(C),C}}async w(g){for(const C of g.extensions)this.I(this.L(C.identifier,C.version),g.profileLocation)}async y(g){for(const C of g.extensions){const S=this.L(C.identifier,C.version);g.error?this.J(S,g.profileLocation):this.I(S,g.profileLocation)}}async z(g){for(const C of g.extensions)this.J(this.L(C.identifier,C.version),g.profileLocation)}async C(g){const C=[],S=[];for(const m of g.extensions){const l=this.L(m.identifier,m.version);g.error?this.I(l,g.profileLocation):(this.J(l,g.profileLocation),this.b.has(l)||(this.r.debug("Extension is removed from all profiles",m.identifier.id,m.version),S.push(this.f.scanInstalledExtensionAtLocation(m.location).then($=>{$?C.push($):this.r.info("Extension not found at the location",m.location.toString())},$=>this.r.error($)))))}try{await Promise.all(S),C.length&&await this.H(C)}catch(m){this.r.error(m)}}D(g){for(const C of this.h.profiles)g.contains(C.extensionsResource,0,1)&&this.F(C.extensionsResource)}async F(g){const C=[],S=[],m=await this.j.scanProfileExtensions(g),l=new Set,$=new Set;for(const[b,w]of this.b)w.has(g)&&$.add(b);for(const b of m){const w=this.L(b.identifier,b.version);l.add(w),$.has(w)||(C.push(b.identifier),this.I(w,g))}for(const b of $)if(!l.has(b)){const w=this.M(b);w&&(S.push(w.identifier),this.J(b,g))}(C.length||S.length)&&this.a.fire({added:C.length?{extensions:C,profileLocation:g}:void 0,removed:S.length?{extensions:S,profileLocation:g}:void 0})}async G(g){const C=await this.j.scanProfileExtensions(g);for(const S of C)this.I(this.L(S.identifier,S.version),g)}async H(g){g||(g=(await this.f.scanAllUserInstalledExtensions()).filter(S=>!this.b.has(this.L(S.identifier,S.manifest.version)))),g.length&&await this.f.markAsUninstalled(...g)}I(g,C){let S=this.b.get(g);S||this.b.set(g,S=new D.$Bc(m=>this.m.extUri.getComparisonKey(m))),S.add(C)}J(g,C){const S=this.b.get(g);S&&S.delete(C),S?.size||this.b.delete(g)}L(g,C){return`${I.$lm.toKey(g.id)}@${C}`}M(g){const[C,S]=(0,A.$3o)(g);return S?{identifier:{id:C},version:S}:void 0}}e.$9p=P}),define(le[227],he([0,1,43,46]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bp=void 0;async function D(A,I,P,k,g,C,S){const m={"X-Market-Client-Id":`VSCode ${A}`,"User-Agent":`VSCode ${A} (${I.nameShort})`};if((0,L.$So)(I,P)&&(0,L.$Uo)(k)===3){const l=await(0,O.$Ap)(P,g,C);m["X-Market-User-Id"]=l,m["VSCode-SessionId"]=S.machineId||l}return m}e.$Bp=D}),define(le[228],he([0,1,73,17,6,2,23,16,31,15,29,33,8,75,10]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jr=void 0;let b=class extends l.$ir{constructor(d,c,v,i){super(v),this.h=d,this.j=i,this.g=this.B(new w(c,i)),this.h.registerParticipant({postInstall:async o=>this.m(o),postUninstall:async o=>this.n(o)})}async getBuiltInExtensionTranslationsUri(d,c){const i=(await this.g.getLanguagePacks())[c];if(!i){this.j.warn(`No language pack found for ${c}`);return}const o=i.translations[d];return o?$.URI.file(o):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),c=Object.keys(d).map(v=>{const i=d[v];return{...this.f(v,i.label),extensionId:i.extensions[0].extensionIdentifier.id}});return c.push(this.f("en","English")),c.sort((v,i)=>v.label.localeCompare(i.label)),c}async m(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",d.identifier.id),await this.update())}async n(d){const c=await this.g.getLanguagePacks();Object.keys(c).some(v=>c[v]&&c[v].extensions.some(i=>(0,S.$1o)(i.extensionIdentifier,d.identifier)))&&(this.j.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,c]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),v=await this.g.update(c);return!(0,L.$ub)(Object.keys(d),Object.keys(v))}};e.$jr=b,e.$jr=b=pe([X(0,C.$Bo),X(1,g.$bi),X(2,C.$yo),X(3,m.$nj)],b);let w=class extends A.$Tc{constructor(d,c){super(),this.j=c,this.c={},this.f=(0,P.$jc)(d.userDataPath,"languagepacks.json"),this.g=new D.$ah}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.s(c=>{Object.keys(c).forEach(v=>delete c[v]),this.m(c,...d)}).then(()=>this.c)}m(d,...c){for(const v of c)v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&this.n(d,v);Object.keys(d).forEach(v=>this.r(d[v]))}n(d,c){const v=c.identifier,i=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const o of i)if(c.location.scheme===I.Schemas.file&&h(o)){let n=d[o.languageId];n||(n={hash:"",extensions:[],translations:{},label:o.localizedLanguageName??o.languageName},d[o.languageId]=n);const s=n.extensions.filter(t=>(0,S.$1o)(t.extensionIdentifier,v))[0];s?s.version=c.manifest.version:n.extensions.push({extensionIdentifier:v,version:c.manifest.version});for(const t of o.translations)n.translations[t.id]=(0,P.$jc)(c.location.fsPath,t.path)}}r(d){if(d){const c=(0,O.createHash)("md5");for(const v of d.extensions)c.update(v.extensionIdentifier.uuid||v.extensionIdentifier.id).update(v.version);d.hash=c.digest("hex")}}s(d=()=>null){return this.g.queue(()=>{let c=null;return k.Promises.readFile(this.f,"utf8").then(void 0,v=>v.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(v)).then(v=>{try{return JSON.parse(v)}catch{return{}}}).then(v=>(c=d(v),v)).then(v=>{for(const o of Object.keys(v))v[o]||delete v[o];this.c=v,this.h=!0;const i=JSON.stringify(this.c);return this.j.debug("Writing language packs",i),k.Promises.writeFile(this.f,i)}).then(()=>c,v=>this.j.error(v))})}};w=pe([X(0,g.$bi),X(1,m.$nj)],w);function h(f){if(typeof f.languageId!="string"||!Array.isArray(f.translations)||f.translations.length===0)return!1;for(const d of f.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(f.languageName&&typeof f.languageName!="string"||f.localizedLanguageName&&typeof f.localizedLanguageName!="string")}}),define(le[229],he([0,1,142,7,30,46]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pO=void 0;const I="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function k(C,S,m){const l=await(0,O.$fD)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,O.$fD)("@microsoft/1ds-post-js","dist/ms.post.js"),b=new l.AppInsightsCore,w=new $.PostChannel,h={instrumentationKey:C,endpointUrl:I,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(m){h.extensionConfig={};const f={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:m};h.extensionConfig[w.identifier]=f}return b.initialize(h,[]),b.addTelemetryInitializer(f=>{f.ext=f.ext??{},f.ext.web=f.ext.web??{},f.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',S&&(f.ext.utc=f.ext.utc??{},f.ext.utc.flags=8462029)}),b}class g{constructor(S,m,l,$,b){this.e=S,this.f=m,this.g=l,this.h=b,this.c=I,this.d=P,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(S){if(this.a){if(typeof this.a!="string"){S(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(m=>{S(m)},m=>{(0,L.$1)(m),console.error(m)})}}log(S,m){if(!this.a)return;m=(0,D.$yn)(m,this.g),m=(0,A.$Vo)(m);const l=this.f+"/"+S;try{this.i($=>{$.pluginVersionString=m?.properties.version??"Unknown",$.track({name:l,baseData:{name:l,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(S=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,S(void 0)})})}):Promise.resolve(void 0)}}e.$pO=g}),define(le[109],he([0,1,2,167,15,8,24,46]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g9b=void 0;let k=class extends O.$Tc{constructor(C,S,m,l,$=""){super(),this.b=$;const b=S.getLogger(P.$Po);if(b)this.a=this.B(b);else{const h=(0,P.$To)(l,m)?" (Not Sent)":"",f=()=>(0,P.$So)(l,m)&&C.getLevel()===A.LogLevel.Trace;this.a=this.B(S.createLogger(P.$Po,{name:(0,L.localize)(0,null,h),hidden:!f()})),this.B(C.onDidChangeLogLevel(()=>S.setVisibility(P.$Po,f()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(C,S){this.a.trace(`${this.b}telemetry/${C}`,(0,P.$Vo)(S))}};e.$g9b=k,e.$g9b=k=pe([X(0,A.$nj),X(1,A.$oj),X(2,D.$ai),X(3,I.$Fj)],k)}),define(le[110],he([0,1,2,30,5,27,168,21,44,102,24,41,22,46]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pr=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(h,f,d){this.k=f,this.l=d,this.d={},this.i=new O.$Sc,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const c of this.f)this.j.push(new RegExp((0,A.$Oe)(c),"gi")),c.indexOf("\\")>=0&&this.j.push(new RegExp((0,A.$Oe)(c.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(c=>{(c.affectsConfiguration(m.$Cl)||c.affectsConfiguration(m.$El)||c.affectsConfiguration(m.$Dl))&&this.m()}))}setExperimentProperty(h,f){this.d[h]=f}m(){let h=(0,l.$Uo)(this.k);const f=this.l.enabledTelemetryLevels;if(f){this.h=this.sendErrorTelemetry?f.error:!1;const d=f.usage?3:f.error?2:0;h=Math.min(h,d)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,f,d){this.g<f||(d=(0,L.$yn)(d,this.d),d=(0,l.$Zo)(d,this.j),d=(0,L.$yn)(d,this.c),this.b.forEach(c=>c.log(h,d)))}publicLog(h,f){this.n(h,3,f)}publicLog2(h,f){this.publicLog(h,f)}publicLogError(h,f){this.h&&this.n(h,2,f)}publicLogError2(h,f){this.publicLogError(h,f)}};e.$pr=$,e.$pr=$=pe([X(1,P.$zi),X(2,C.$Fj)],$);function b(){const w=(0,I.localize)(0,null,g.default.nameLong),h=g.default.privacyStatementUrl?(0,I.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,I.localize)(1,null,"https://aka.ms/vscode-telemetry"),f=D.$o?"":(0,I.localize)(3,null),d=(0,I.localize)(4,null),c=(0,I.localize)(5,null),v=(0,I.localize)(6,null),i=(0,I.localize)(7,null),o=`
|       | ${d} | ${c} | ${v} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,n=(0,I.localize)(8,null);return`
${w} ${h} ${f}

&nbsp;

${i}
${o}

&nbsp;

${n}
`}S.$Hn.as(k.$Mn.Configuration).registerConfiguration({id:m.$Bl,order:1,type:"object",title:(0,I.localize)(9,null),properties:{[m.$Cl]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,I.localize)(10,null),(0,I.localize)(11,null),(0,I.localize)(12,null),(0,I.localize)(13,null)],markdownDescription:b(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),S.$Hn.as(k.$Mn.Configuration).registerConfiguration({id:m.$Bl,order:110,type:"object",title:(0,I.localize)(14,null),properties:{[m.$El]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,I.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,I.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,I.localize)(17,null,`\`#${m.$Cl}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(le[230],he([0,1,14,26,271,229]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qO=void 0;async function I(C,S){const m=await S.request(C,L.CancellationToken.None),l=(await(0,O.$ve)(m.stream)).toString(),$=m.res.statusCode??200;return{headers:m.res.headers,statusCode:$,responseData:l}}async function P(C){const S={method:C.type,headers:C.headers};return new Promise((l,$)=>{const b=D.request(C.url??"",S,w=>{w.on("data",function(h){l({headers:w.headers,statusCode:w.statusCode??200,responseData:h.toString()})}),w.on("error",function(h){$(h)})});b.write(C.data,w=>{w&&$(w)}),b.end()})}async function k(C,S,m){const l=typeof S.data=="string"?S.data:new TextDecoder().decode(S.data),$={type:"POST",headers:{...S.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(S.data).toString()},url:S.urlString,data:l};try{const b=C?await I($,C):await P($);m(b.statusCode,b.headers,b.responseData)}catch{m(0,{})}}class g extends A.$pO{constructor(S,m,l,$,b){const w={sendPOST:(h,f)=>{k(S,h,f)}};super(m,l,$,b,w)}}e.$qO=g}),define(le[231],he([0,1,23,93,21,15,8,24,22,108,109,110]),function(se,e,O,L,D,A,I,P,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eac=void 0;let m=class{constructor($,b,w,h,f,d){this.b=$,this.c=b,this.d=w,this.e=h,this.f=f,this.g=d,this.a=new Map}h($){if(!this.a.has($.id)){const b=Object.create(null);b["common.vscodemachineid"]=this.c.machineId,b["common.vscodesessionid"]=this.c.sessionId;const w=[$.id,JSON.stringify(b),$.aiKey],f=new L.$rq(O.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:w,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new g.$W$b(f),new C.$g9b(this.d,this.e,this.f,this.g,`[${$.id}] `)];this.a.set($.id,new S.$pr({appenders:d,sendErrorTelemetry:$.sendErrorTelemetry},this.b,this.g))}return this.a.get($.id)}publicLog($,b,w){this.h($).publicLog(b,w)}publicLogError($,b,w){this.h($).publicLogError(b,w)}};e.$eac=m,e.$eac=m=pe([X(0,D.$zi),X(1,k.$ul),X(2,I.$nj),X(3,I.$oj),X(4,A.$ai),X(5,P.$Fj)],m)}),define(le[79],he([0,1,3,21,4,8]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,D.$6h)("tunnelService"),e.$Bv=(0,D.$6h)("sharedTunnelsService");var I;(function(w){w.Http="http",w.Https="https"})(I||(e.TunnelProtocol=I={}));var P;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(P||(e.TunnelPrivacyId=P={}));function k(w){return!!w.forwardPort}e.$Cv=k;var g;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(g||(e.ProvidedOnAutoForward=g={}));function C(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(h)return{address:h[1],port:+h[2]}}e.$Dv=C,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function S(w){return e.$Ev.indexOf(w)>=0}e.$Fv=S,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(w){return e.$Gv.indexOf(w)>=0}e.$Hv=m;function l(w,h,f,d){if(f===1)return!1;if(f===2&&m(h)){const c=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(c?.length===4&&parseInt(c[1])>=18)return!1}return w<1024}e.$Iv=l;class ${constructor(h,f,d){this.remoteAddress=h,this.localAddress=f,this.b=d,this.a=new O.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=$;let b=class{constructor(h,f){this.k=h,this.l=f,this.a=new O.$Vd,this.onTunnelOpened=this.a.event,this.b=new O.$Vd,this.onTunnelClosed=this.b.event,this.c=new O.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const h=this.l.getValue("remote.localPortHost");return!h||h==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(h){return this.f=h,h?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(h){this.g=h.elevation,this.i=h.privacyOptions,this.h=h.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const h=[],f=Array.from(this.e.values());for(const d of f){const c=Array.from(d.values());for(const v of c){const i=await v.value;i&&typeof i!="string"&&h.push(i)}}return h}async dispose(){for(const h of this.e.values()){for(const{value:f}of h.values())await f.then(d=>typeof d!="string"?d?.dispose():void 0);h.clear()}this.e.clear()}setEnvironmentTunnel(h,f,d,c,v){this.q(h,f,Promise.resolve({tunnelRemoteHost:h,tunnelRemotePort:f,localAddress:d,privacy:c,protocol:v,dispose:()=>Promise.resolve()}))}async getExistingTunnel(h,f){(m(h)||S(h))&&(h=e.$Ev[0]);const d=this.s(h,f);if(d)return++d.refcount,d.value}openTunnel(h,f,d,c,v,i=!1,o,n){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${f}:${d} on local port ${v}.`);const s=this.f??h;if(!s)return;if(f||(f="localhost"),c||(c=this.m),this.f&&this.j.has(d)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.t(s,f,d,c,v,i,o,n);return t?t.then(r=>{if(r){if(typeof r=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(f,d),r}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(f,d);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const a=this.o(r);return(r.tunnelRemoteHost!==f||r.tunnelRemotePort!==d)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),o&&r.privacy!==o&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(a),a}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}o(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const f=this.e.get(h.tunnelRemoteHost);if(f){const d=f.get(h.tunnelRemotePort);d&&(d.refcount--,await this.p(h.tunnelRemoteHost,h.tunnelRemotePort,d))}}}}async p(h,f,d){if(d.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${f}.`);const c=d.value.then(async v=>{v&&typeof v!="string"&&(await v.dispose(!0),this.b.fire({host:v.tunnelRemoteHost,port:v.tunnelRemotePort}))});return this.e.has(h)&&this.e.get(h).delete(f),c}}async closeTunnel(h,f){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${f} `);const d=this.e.get(h);if(d&&d.has(f)){const c=d.get(f);c.refcount=0,await this.p(h,f,c)}}q(h,f,d){this.e.has(h)||this.e.set(h,new Map),this.e.get(h).set(f,{refcount:1,value:d})}async r(h,f){const d=this.e.get(h);if(d){const c=d.get(f),v=c?await c.value:void 0;(!v||typeof v=="string")&&d.delete(f),d.size===0&&this.e.delete(h)}}s(h,f){const d=[h];S(h)?(d.push(...e.$Ev),d.push(...e.$Gv)):m(h)&&d.push(...e.$Gv);const c=d.map(v=>this.e.get(v));for(const v of c){const i=v?.get(f);if(i)return i}}canTunnel(h){return!!C(h)}u(h,f,d,c,v,i,o){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${f}:${d} on local port ${c}.`);const n=d;this.j.add(n);const s=c===void 0?d:c,t={elevationRequired:v?this.isPortPrivileged(s):!1},r={remoteAddress:{host:f,port:d},localAddressPort:c,privacy:i,public:i?i!==P.Private:void 0,protocol:o},a=h.forwardPort(r,t);return a?(this.q(f,d,a),a.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(n)})):this.j.delete(n),a}};e.$Kv=b,e.$Kv=b=pe([X(0,A.$nj),X(1,L.$zi)],b)}),define(le[232],he([0,1,8,79,2,7,6]),function(se,e,O,L,D,A,I){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.$oac=void 0;class k extends D.$Tc{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new I.$qh),this.b.p)}setAddress(S){this.a=S,this.b&&(this.b.complete(S),this.b=null)}setTunnel(S){this.B(S)}}let g=class extends D.$Tc{static{P=this}static{this.a=0}constructor(S,m){super(),this.f=S,this.g=m,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(S=>S.dispose())}async createTunnel(){return{id:String(++P.a)}}async startTunnel(S,m,l,$,b,w,h){const f=new k,d=await Promise.resolve(this.f.openTunnel(S,f,l,$,b,w,h));if(!d||typeof d=="string")throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${l}:${$} (remote).`),f.dispose(),new Error("Could not create tunnel");if(this.c.has(m))throw this.c.delete(m),f.dispose(),await d.dispose(),(0,A.$6)();return f.setTunnel(d),this.b.set(m,f),this.g.info(`[SharedProcessTunnelService] Created tunnel ${m}: ${d.localAddress} (local) to ${l}:${$} (remote).`),{tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress}}async setAddress(S,m){const l=this.b.get(S);l&&l.setAddress(m)}async destroyTunnel(S){const m=this.b.get(S);if(m){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${S}.`),this.b.delete(S),await m.dispose();return}this.c.add(S)}};e.$oac=g,e.$oac=g=P=pe([X(0,L.$Bv),X(1,O.$nj)],g)}),define(le[28],he([0,1,4]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=void 0,e.$1k=(0,O.$6h)("IUriIdentityService")}),define(le[233],he([0,1,28,186,11,20,128,3,2]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=void 0;class g{static{this._clock=0}constructor(m){this.uri=m,this.time=g._clock++}touch(){return this.time=g._clock++,this}}let C=class{constructor(m){this.g=m,this.c=new k.$Sc,this.f=2**16;const l=new Map,$=b=>{let w=l.get(b.scheme);return w===void 0&&(w=m.hasProvider(b)&&!this.g.hasCapability(b,1024),l.set(b.scheme,w)),w};this.c.add(P.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(b=>{l.delete(b.scheme)})),this.extUri=new A.$wg($),this.d=new I.$1r((b,w)=>this.extUri.compare(b,w,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,A.$Ig)(m));const l=this.d.get(m);return l?l.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new g(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort(($,b)=>$[1].time<b[1].time?1:$[1].time>b[1].time?-1:0);g._clock=0,this.d.clear();const l=this.f*.5;for(let $=0;$<l;$++)this.d.set(m[$][0],m[$][1].touch())}};e.$2r=C,e.$2r=C=pe([X(0,D.$qk)],C),(0,L.$Yr)(O.$1k,C,1)}),define(le[234],he([0,1,3,2,11,48,35]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J_b=void 0;class P extends L.$Tc{constructor(g,C,S,m,l,$){super(),this.f=g,this.g=C,this.h=S,this.j=m,this.m=l,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new O.$Vd),this.onDidChangeFile=this.a.event,this.b=A.$_h.forUris(()=>!(this.capabilities&1024)),this.c=new I.$Bc(b=>this.m.extUri.getComparisonKey(this.t(b))),this.r(),this.B(m.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(b=>this.s(b)))}r(){this.c.clear();for(const g of this.j.profiles)this.c.add(g.settingsResource),this.c.add(g.keybindingsResource),this.c.add(g.tasksResource),this.c.add(g.extensionsResource)}open(g,C){return this.g.open(this.t(g),C)}close(g){return this.g.close(g)}read(g,C,S,m,l){return this.g.read(g,C,S,m,l)}write(g,C,S,m,l){return this.g.write(g,C,S,m,l)}watch(g,C){this.b.set(g,g);const S=this.g.watch(this.t(g),C);return(0,L.$Rc)(()=>{this.b.delete(g),S.dispose()})}stat(g){return this.g.stat(this.t(g))}mkdir(g){return this.g.mkdir(this.t(g))}rename(g,C,S){return this.g.rename(this.t(g),this.t(C),S)}readFile(g,C){return this.g.readFile(this.t(g),C)}readFileStream(g,C,S){return this.g.readFileStream(this.t(g),C,S)}readdir(g){return this.g.readdir(this.t(g))}enforceAtomicReadFile(g){return this.c.has(g)}writeFile(g,C,S){return this.g.writeFile(this.t(g),C,S)}enforceAtomicWriteFile(g){return this.c.has(g)?{postfix:".vsctmp"}:!1}delete(g,C){return this.g.delete(this.t(g),C)}copy(g,C,S){if((0,D.$uk)(this.g))return this.g.copy(this.t(g),this.t(C),S);throw new Error("copy not supported")}cloneFile(g,C){if((0,D.$vk)(this.g))return this.g.cloneFile(this.t(g),this.t(C));throw new Error("clone not supported")}s(g){const C=[];for(const S of g){if(S.resource.scheme!==this.f)continue;const m=this.u(S.resource);this.b.findSubstr(m)&&C.push({resource:m,type:S.type,cId:S.cId})}C.length&&(this.n.debug("User data changed"),this.a.fire(C))}t(g){return g.with({scheme:this.f})}u(g){return g.with({scheme:this.h})}}e.$J_b=P}),define(le[80],he([0,1,62]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RFb=e.$QFb=e.edit=void 0;function L(I,P,k,g){const C=(0,O.$rn)(I,P,k,g)[0];return C&&(I=I.substring(0,C.offset)+C.content+I.substring(C.offset+C.length)),I}e.edit=L;function D(I,P,k){let g=k;for(;g>=0;){if(I.charAt(g)===P.charAt(P.length-1)&&P.length===1)return g+1;if(g--,P.length===2&&g>=0&&I.charAt(g)===P.charAt(0))return g+2}return 0}e.$QFb=D;function A(I,P,k){let g=k;for(;g>=0;)if(I.charAt(g)===P.charAt(P.length-1)&&P.length===1||(g++,P.length===2&&g>=0&&I.charAt(g)===P.charAt(1)))return g;return I.length-1}e.$RFb=A}),define(le[235],he([0,1,30,55,12]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Y7b=void 0;function A(l,$,b,w,h,f){const d=[],c=[],v=[];if(!$){const U=l.filter(({identifier:Y})=>h.every(Q=>Q.toLowerCase()!==Y.id.toLowerCase()));return{local:{added:d,removed:c,updated:v},remote:U.length>0?{added:U,updated:[],removed:[],all:U}:null}}l=l.map(S),$=$.map(S),b=b?b.map(S):null;const i=new Map,o=U=>{U.uuid&&i.set(U.id.toLowerCase(),U.uuid)};l.forEach(({identifier:U})=>o(U)),$.forEach(({identifier:U})=>o(U)),b?.forEach(({identifier:U})=>o(U)),w?.forEach(({identifier:U})=>o(U)),f?.forEach(U=>o(U));const n=U=>{const Y=U.identifier.uuid||i.get(U.identifier.id.toLowerCase());return Y?`uuid:${Y}`:`id:${U.identifier.id.toLowerCase()}`},s=(U,Y)=>(U.set(n(Y),Y),U),t=l.reduce(s,new Map),r=$.reduce(s,new Map),a=$.reduce((U,Y)=>s(U,(0,O.$vn)(Y)),new Map),E=b?b.reduce(s,new Map):null,y=w.reduce(s,new Map),u=h.reduce((U,Y)=>{const Q=i.get(Y.toLowerCase());return U.add(Q?`uuid:${Q}`:`id:${Y.toLowerCase()}`)},new Set),p=f?f.reduce((U,{id:Y,uuid:Q})=>(Q=Q??i.get(Y.toLowerCase()),U.add(Q?`uuid:${Q}`:`id:${Y.toLowerCase()}`)),new Set):null,R=I(t,r,u,!1);if(R.added.size>0||R.removed.size>0||R.updated.size>0){const U=I(E,t,u,!1),Y=I(E,r,u,!0),Q=(x,H,Z,W)=>{let V,ie,re;return H.installed?(V=W.pinned,re=W.preRelease,V&&(ie=W.version)):(V=Z.pinned,re=Z.preRelease,V&&(ie=Z.version)),V===void 0&&(V=H.pinned,V&&(ie=H.version)),re===void 0&&(re=H.preRelease),{...W,installed:H.installed||Z.installed,pinned:V,preRelease:re,version:ie??(Z.version&&(!H.installed||L.gt(Z.version,H.version))?Z.version:H.version),state:k(H,Z,E?.get(x))}};for(const x of Y.removed.values()){const H=t.get(x);if(!H)continue;const Z=(0,D.$Tf)(E?.get(x)),W=p&&!p.has(x)&&Z.installed;H.installed&&W?c.push(H.identifier):a.set(x,H)}for(const x of Y.added.values()){const H=(0,D.$Tf)(r.get(x)),Z=t.get(x);if(Z){if(R.updated.has(x)){const W=Q(x,Z,H,H);P(Z,H,!1,!1)||v.push(m(W,x)),a.set(x,W)}}else H.installed&&d.push(m(H,x))}for(const x of Y.updated.values()){const H=(0,D.$Tf)(r.get(x)),Z=(0,D.$Tf)(E?.get(x)),W=t.get(x);if(W)if(p&&!p.has(x)&&Z.installed&&W.installed&&!H.installed)c.push(W.identifier);else{const ie=Q(x,W,H,H);v.push(m(ie,x)),a.set(x,ie)}else H.installed&&d.push(m(H,x))}for(const x of U.added.values())Y.added.has(x)||a.set(x,(0,D.$Tf)(t.get(x)));for(const x of U.updated.values()){if(Y.removed.has(x)||Y.updated.has(x))continue;const H=(0,D.$Tf)(t.get(x)),Z=(0,D.$Tf)(r.get(x));a.set(x,Q(x,H,Z,H))}for(const x of U.removed.values())Y.updated.has(x)||Y.removed.has(x)||y.has(x)||(0,D.$Tf)(r.get(x)).installed&&p&&(p.has(x)||!(0,D.$Tf)(E?.get(x)).installed||a.delete(x))}const N=[],T=I(r,a,new Set,!0),M=T.added.size>0||T.updated.size>0||T.removed.size>0;return M&&a.forEach((U,Y)=>N.push(m(U,Y))),{local:{added:d,removed:c,updated:v},remote:M?{added:[...T.added].map(U=>a.get(U)),updated:[...T.updated].map(U=>a.get(U)),removed:[...T.removed].map(U=>r.get(U)),all:N}:null}}e.$Y7b=A;function I(l,$,b,w){const h=l?[...l.keys()].filter(i=>!b.has(i)):[],f=[...$.keys()].filter(i=>!b.has(i)),d=f.filter(i=>!h.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),c=h.filter(i=>!f.includes(i)).reduce((i,o)=>(i.add(o),i),new Set),v=new Set;for(const i of h){if(c.has(i))continue;const o=l.get(i),n=$.get(i);(!n||!P(o,n,w,!0))&&v.add(i)}return{added:d,removed:c,updated:v}}function P(l,$,b,w){return!(l.disabled!==$.disabled||!!l.isApplicationScoped!=!!$.isApplicationScoped||w&&l.installed!==$.installed||l.installed&&$.installed&&(l.preRelease!==$.preRelease||l.pinned!==$.pinned||$.pinned&&l.version!==$.version)||!C(l.state,$.state)||b&&l.version!==$.version)}function k(l,$,b){const w=l.state,h=$.state,f=b?.state;if(!$.version||w&&L.gt(l.version,$.version))return w;if(h&&L.gt($.version,l.version)||!w)return h;if(!h)return w;const d=(0,O.$vn)(w),c=f?g(f,h):{added:Object.keys(h).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set},v=f?g(f,w):{added:Object.keys(w).reduce((i,o)=>(i.add(o),i),new Set),removed:new Set,updated:new Set};for(const i of[...c.added.values(),...c.updated.values()])d[i]=h[i];for(const i of c.removed.values())v.updated.has(i)||delete d[i];return d}function g(l,$){const b=Object.keys(l),w=Object.keys($),h=w.filter(c=>!b.includes(c)).reduce((c,v)=>(c.add(v),c),new Set),f=b.filter(c=>!w.includes(c)).reduce((c,v)=>(c.add(v),c),new Set),d=new Set;for(const c of b){if(f.has(c))continue;const v=l[c],i=$[c];(0,O.$zn)(v,i)||d.add(c)}return{added:h,removed:f,updated:d}}function C(l={},$={}){const{added:b,removed:w,updated:h}=g(l,$);return b.size===0&&w.size===0&&h.size===0}function S(l){return{...l,disabled:!!l.disabled,installed:!!l.installed}}function m(l,$){const b={...l,identifier:{id:l.identifier.id,uuid:$.startsWith("uuid:")?$.substring(5):void 0},preRelease:!!l.preRelease,pinned:!!l.pinned};return l.disabled||delete b.disabled,l.installed||delete b.installed,l.state||delete b.state,l.isApplicationScoped||delete b.isApplicationScoped,b}}),define(le[111],he([0,1,17,21,4]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VHb=e.$UHb=void 0,e.$UHb=(0,D.$6h)("IIgnoredExtensionsManagementService");let A=class{constructor(P){this.a=P}hasToNeverSyncExtension(P){return this.b().includes(P.toLowerCase())}hasToAlwaysSyncExtension(P){return this.b().includes(`-${P.toLowerCase()}`)}updateIgnoredExtensions(P,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==P&&C!==`-${P}`),k&&g.push(P.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}updateSynchronizedExtensions(P,k){let g=[...this.a.getValue("settingsSync.ignoredExtensions")].map(C=>C.toLowerCase());return g=g.filter(C=>C!==P&&C!==`-${P}`),k&&g.push(`-${P.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",g.length?g:void 0,2)}getIgnoredExtensions(P){const k=P.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),g=this.b().map(m=>m.toLowerCase()),C=[],S=[];if(Array.isArray(g))for(const m of g)m.startsWith("-")?S.push(m.substring(1)):C.push(m);return(0,O.$Mb)([...k,...C].filter(m=>!S.includes(m)))}b(){let P=this.a.inspect("settingsSync.ignoredExtensions").userValue;return P!==void 0||(P=this.a.inspect("sync.ignoredExtensions").userValue,P!==void 0)?P:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(k=>k.toLowerCase())}};e.$VHb=A,e.$VHb=A=pe([X(0,L.$zi)],A)}),define(le[236],he([0,1,17,34,30,94,80]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$57b=void 0;function P(c){return(0,L.$cn)(c)||[]}async function k(c,v,i,o,n){const s=P(c),t=P(v),r=i?P(i):null,a=[...s,...t,...r||[]].map(Q=>Q.key),E=await n.resolveUserBindings(a),y=C(s,t,r,E);if(!y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!1,hasConflicts:!1};if(!y.hasLocalForwarded&&y.hasRemoteForwarded)return{mergeContent:v,hasChanges:!0,hasConflicts:!1};if(y.hasLocalForwarded&&!y.hasRemoteForwarded)return{mergeContent:c,hasChanges:!0,hasConflicts:!1};const u=m(s),p=m(t),R=r?m(r):null,N=$(u,p,E),T=R?$(R,u,E):{added:[...u.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},M=R?$(R,p,E):{added:[...p.keys()].reduce((Q,x)=>(Q.add(x),Q),new Set),removed:new Set,updated:new Set},U=g(N,T,M);let Y=c;for(const Q of U.removed.values())U.conflicts.has(Q)||(Y=f(Y,Q,o));for(const Q of U.added.values()){if(U.conflicts.has(Q))continue;const x=p.get(Q);if(x.some(H=>H.command!==`-${Q}`&&y.conflicts.has(E[H.key]))){U.conflicts.add(Q);continue}Y=h(Y,x,o)}for(const Q of U.updated.values()){if(U.conflicts.has(Q))continue;const x=p.get(Q);if(x.some(H=>H.command!==`-${Q}`&&y.conflicts.has(E[H.key]))){U.conflicts.add(Q);continue}Y=d(Y,Q,x,o)}return{mergeContent:Y,hasChanges:!0,hasConflicts:U.conflicts.size>0}}e.$57b=k;function g(c,v,i){const o=new Set,n=new Set,s=new Set,t=new Set;for(const r of v.removed.values())i.updated.has(r)&&t.add(r);for(const r of i.removed.values())t.has(r)||(v.updated.has(r)?t.add(r):n.add(r));for(const r of v.added.values())t.has(r)||i.added.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.added.values())t.has(r)||(v.added.has(r)?c.updated.has(r)&&t.add(r):o.add(r));for(const r of v.updated.values())t.has(r)||i.updated.has(r)&&c.updated.has(r)&&t.add(r);for(const r of i.updated.values())t.has(r)||(v.updated.has(r)?c.updated.has(r)&&t.add(r):s.add(r));return{added:o,removed:n,updated:s,conflicts:t}}function C(c,v,i,o){const n=new Set,s=S(c,o),t=S(v,o),r=i?S(i,o):null,a=l(s,t);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const E=r?l(r,s):{added:[...s.keys()].reduce((T,M)=>(T.add(M),T),new Set),removed:new Set,updated:new Set};if(E.added.size===0&&E.removed.size===0&&E.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:n,removed:n,updated:n,conflicts:n};const y=r?l(r,t):{added:[...t.keys()].reduce((T,M)=>(T.add(M),T),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:n,removed:n,updated:n,conflicts:n};const{added:u,removed:p,updated:R,conflicts:N}=g(a,E,y);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:u,removed:p,updated:R,conflicts:N}}function S(c,v){const i=new Map;for(const o of c){const n=v[o.key];let s=i.get(n);s||(s=[],i.set(n,s)),s.push(o)}return i}function m(c){const v=new Map;for(const i of c){const o=i.command[0]==="-"?i.command.substring(1):i.command;let n=v.get(o);n||(n=[],v.set(o,n)),n.push(i)}return v}function l(c,v){const i=[...c.keys()],o=[...v.keys()],n=o.filter(r=>!i.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),s=i.filter(r=>!o.includes(r)).reduce((r,a)=>(r.add(a),r),new Set),t=new Set;for(const r of i){if(s.has(r))continue;const a=c.get(r).map(y=>({...y,key:r})),E=v.get(r).map(y=>({...y,key:r}));(0,O.$ub)(a,E,(y,u)=>w(y,u))||t.add(r)}return{added:n,removed:s,updated:t}}function $(c,v,i){const o=[...c.keys()],n=[...v.keys()],s=n.filter(a=>!o.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),t=o.filter(a=>!n.includes(a)).reduce((a,E)=>(a.add(E),a),new Set),r=new Set;for(const a of o){if(t.has(a))continue;const E=c.get(a).map(u=>({...u,key:i[u.key]})),y=v.get(a).map(u=>({...u,key:i[u.key]}));b(E,y)||r.add(a)}return{added:s,removed:t,updated:r}}function b(c,v){return!(!(0,O.$ub)(c.filter(({command:i})=>i[0]!=="-"),v.filter(({command:i})=>i[0]!=="-"),(i,o)=>w(i,o))||!(0,O.$ub)(c.filter(({command:i})=>i[0]==="-"),v.filter(({command:i})=>i[0]==="-"),(i,o)=>w(i,o)))}function w(c,v){if(c.command!==v.command||c.key!==v.key)return!1;const i=A.$4i.deserialize(c.when),o=A.$4i.deserialize(v.when);return!(i&&!o||!i&&o||i&&o&&!i.equals(o)||!D.$zn(c.args,v.args))}function h(c,v,i){for(const o of v)c=I.edit(c,[-1],o,i);return c}function f(c,v,i){const o=P(c);for(let n=o.length-1;n>=0;n--)(o[n].command===v||o[n].command===`-${v}`)&&(c=I.edit(c,[n],void 0,i));return c}function d(c,v,i,o){const n=P(c),s=n.findIndex(t=>t.command===v||t.command===`-${v}`);for(let t=n.length-1;t>=0;t--)(n[t].command===v||n[t].command===`-${v}`)&&(c=I.edit(c,[t],void 0,o));for(let t=i.length-1;t>=0;t--)c=I.edit(c,[s],i[t],o);return c}}),define(le[237],he([0,1]),function(se,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$a8b=e.$_7b=void 0;function O(A,I,P){const k={},g={},C=new Set;if(!I)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:A,updated:{},removed:[]},conflicts:[]};const S=L(A,I);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{local:{added:k,updated:g,removed:[...C.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=L(P,A),l=L(P,I),$={},b={},w=new Set,h=new Set;for(const f of m.removed.values())l.updated.has(f)?k[f]=I[f]:w.add(f);for(const f of l.removed.values())h.has(f)||(m.updated.has(f)?h.add(f):C.add(f));for(const f of m.updated.values())h.has(f)||(l.updated.has(f)?S.updated.has(f)&&h.add(f):b[f]=A[f]);for(const f of l.updated.values())h.has(f)||(m.updated.has(f)?S.updated.has(f)&&h.add(f):A[f]!==void 0&&(g[f]=I[f]));for(const f of m.added.values())h.has(f)||(l.added.has(f)?S.updated.has(f)&&h.add(f):$[f]=A[f]);for(const f of l.added.values())h.has(f)||(m.added.has(f)?S.updated.has(f)&&h.add(f):k[f]=I[f]);return{local:{added:k,removed:[...C.values()],updated:g},remote:{added:$,removed:[...w.values()],updated:b},conflicts:[...h.values()]}}e.$_7b=O;function L(A,I){const P=A?Object.keys(A):[],k=I?Object.keys(I):[],g=k.filter(m=>!P.includes(m)).reduce((m,l)=>(m.add(l),m),new Set),C=P.filter(m=>!k.includes(m)).reduce((m,l)=>(m.add(l),m),new Set),S=new Set;for(const m of P){if(C.has(m))continue;const l=A[m],$=I[m];l!==$&&S.add(m)}return{added:g,removed:C,updated:S}}function D(A,I){const{added:P,removed:k,updated:g}=L(A,I);return P.size===0&&k.size===0&&g.size===0}e.$a8b=D}),define(le[238],he([0,1,30]),function(se,e,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$W9b=void 0;function L(A,I,P,k){const g={added:[],removed:[],updated:[]};let C={added:[],removed:[],updated:[]};if(!I){const m=A.filter(({id:l})=>!k.includes(l));return m.length?C.added=m:C=null,{local:g,remote:C}}const S=D(A,I,k);if(S.added.length>0||S.removed.length>0||S.updated.length>0){const m=D(P,A,k),l=D(P,I,k);for(const $ of l.removed){const b=A.find(w=>w.id===$);b&&g.removed.push(b)}for(const $ of l.added){const b=I.find(w=>w.id===$);m.added.includes($)?S.updated.includes($)&&g.updated.push(b):g.added.push(b)}for(const $ of l.updated)g.updated.push(I.find(b=>b.id===$));for(const $ of m.added)l.added.includes($)||C.added.push(A.find(b=>b.id===$));for(const $ of m.updated)l.removed.includes($)||l.updated.includes($)||C.updated.push(A.find(b=>b.id===$));for(const $ of m.removed){const b=I.find(w=>w.id===$);b&&C.removed.push(b)}}return C.added.length===0&&C.removed.length===0&&C.updated.length===0&&(C=null),{local:g,remote:C}}e.$W9b=L;function D(A,I,P){A=A?A.filter(({id:l})=>!P.includes(l)):[],I=I.filter(({id:l})=>!P.includes(l));const k=A.map(({id:l})=>l),g=I.map(({id:l})=>l),C=g.filter(l=>!k.includes(l)),S=k.filter(l=>!g.includes(l)),m=[];for(const{id:l,name:$,shortName:b,icon:w,useDefaultFlags:h}of A){if(S.includes(l))continue;const f=I.find(d=>d.id===l);(!f||f.name!==$||f.shortName!==b||f.icon!==w||!(0,O.$zn)(f.useDefaultFlags,h))&&m.push(l)}return{added:C,removed:S,updated:m}}}),define(le[25],he([0,1,17,12,174,44,29,4,103,41]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4nb=e.$3nb=e.$2nb=e.$1nb=e.$Znb=e.$Ynb=e.$Xnb=e.$Wnb=e.$Vnb=e.$Unb=e.$Tnb=e.MergeState=e.Change=e.SyncStatus=e.$Snb=e.$Rnb=e.$Qnb=e.UserDataSyncErrorCode=e.$Pnb=e.$Onb=e.$Nnb=e.$Mnb=e.$Lnb=e.$Knb=e.$Jnb=e.$Inb=e.$Hnb=e.SyncResource=e.$Gnb=e.$Fnb=e.$Enb=e.$Dnb=e.$Cnb=e.$Bnb=void 0;function C(){const t=g.$Hn.as(A.$Mn.Configuration).getConfigurationProperties();return Object.keys(t).filter(r=>!!t[r].disallowSyncIgnore)}e.$Bnb=C;function S(){const t=g.$Hn.as(A.$Mn.Configuration).getConfigurationProperties(),r=Object.keys(t).filter(y=>!!t[y].ignoreSync),a=Object.keys(t).filter(y=>t[y].scope===2||t[y].scope===6),E=C();return(0,O.$Mb)([...r,...a,...E])}e.$Cnb=S,e.$Dnb="settingsSync",e.$Enb="settingsSync.keybindingsPerPlatform";function m(){const t="vscode://schemas/ignoredSettings",r=g.$Hn.as(A.$Mn.Configuration);r.registerConfiguration({id:"settingsSync",order:30,title:(0,D.localize)(0,null),type:"object",properties:{[e.$Enb]:{type:"boolean",description:(0,D.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,D.localize)(2,null),items:[{type:"string",pattern:I.$mo,errorMessage:(0,D.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,D.localize)(4,null),default:[],scope:1,$ref:t,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const a=g.$Hn.as(k.$In.JSONContribution),E=()=>{const y=C(),u=S(),p=Object.keys(A.$Nn.properties).filter(T=>!u.includes(T)),R=u.filter(T=>!y.includes(T)),N={items:{type:"string",enum:[...p,...R.map(T=>`-${T}`)]}};a.registerSchema(t,N)};return r.onDidUpdateConfiguration(()=>E())}e.$Fnb=m;function l(t){return t&&(0,L.$Kf)(t)&&(0,L.$If)(t.id)&&Array.isArray(t.scopes)}e.$Gnb=l;var $;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState",t.Profiles="profiles",t.WorkspaceState="workspaceState"})($||(e.SyncResource=$={})),e.$Hnb=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function b(t,...r){return t?[t,...r]:r}e.$Inb=b;function w(t,r,a,E){return E.joinPath(a.userDataSyncHome,...b(t,r,`lastSync${r}.json`))}e.$Jnb=w,e.$Knb=(0,P.$6h)("IUserDataSyncStoreManagementService"),e.$Lnb=(0,P.$6h)("IUserDataSyncStoreService"),e.$Mnb=(0,P.$6h)("IUserDataSyncLocalStoreService"),e.$Nnb="x-operation-id",e.$Onb="X-Execution-Id";function h(t){const r={};return r[e.$Onb]=t,r}e.$Pnb=h;var f;(function(t){t.Unauthorized="Unauthorized",t.Forbidden="Forbidden",t.NotFound="NotFound",t.MethodNotFound="MethodNotFound",t.Conflict="Conflict",t.Gone="Gone",t.PreconditionFailed="PreconditionFailed",t.TooLarge="TooLarge",t.UpgradeRequired="UpgradeRequired",t.PreconditionRequired="PreconditionRequired",t.TooManyRequests="RemoteTooManyRequests",t.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",t.RequestFailed="RequestFailed",t.RequestCanceled="RequestCanceled",t.RequestTimeout="RequestTimeout",t.RequestProtocolNotSupported="RequestProtocolNotSupported",t.RequestPathNotEscaped="RequestPathNotEscaped",t.RequestHeadersNotObject="RequestHeadersNotObject",t.NoCollection="NoCollection",t.NoRef="NoRef",t.EmptyResponse="EmptyResponse",t.TurnedOff="TurnedOff",t.SessionExpired="SessionExpired",t.ServiceChanged="ServiceChanged",t.DefaultServiceChanged="DefaultServiceChanged",t.LocalTooManyProfiles="LocalTooManyProfiles",t.LocalTooManyRequests="LocalTooManyRequests",t.LocalPreconditionFailed="LocalPreconditionFailed",t.LocalInvalidContent="LocalInvalidContent",t.LocalError="LocalError",t.IncompatibleLocalContent="IncompatibleLocalContent",t.IncompatibleRemoteContent="IncompatibleRemoteContent",t.Unknown="Unknown"})(f||(e.UserDataSyncErrorCode=f={}));class d extends Error{constructor(r,a,E,y){super(r),this.code=a,this.resource=E,this.operationId=y,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.$Qnb=d;class c extends d{constructor(r,a,E,y,u){super(r,E,void 0,u),this.url=a,this.serverCode=y}}e.$Rnb=c;class v extends d{constructor(r,a){super(r,a)}}e.$Snb=v,function(t){function r(a){if(a instanceof t)return a;const E=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(a.name);if(E&&E[1]){const y=E[2]==="unknown"?void 0:E[2],u=E[3]==="unknown"?void 0:E[3];return new t(a.message,E[1],y,u)}return new t(a.message,"Unknown")}t.toUserDataSyncError=r}(d||(e.$Qnb=d={}));var i;(function(t){t.Uninitialized="uninitialized",t.Idle="idle",t.Syncing="syncing",t.HasConflicts="hasConflicts"})(i||(e.SyncStatus=i={}));var o;(function(t){t[t.None=0]="None",t[t.Added=1]="Added",t[t.Modified=2]="Modified",t[t.Deleted=3]="Deleted"})(o||(e.Change=o={}));var n;(function(t){t.Preview="preview",t.Conflict="conflict",t.Accepted="accepted"})(n||(e.MergeState=n={})),e.$Tnb="sync.store.url.type";function s(t){return`sync.enable.${t}`}e.$Unb=s,e.$Vnb=(0,P.$6h)("IUserDataSyncEnablementService"),e.$Wnb=(0,P.$6h)("IUserDataSyncService"),e.$Xnb=(0,P.$6h)("IUserDataSyncResourceProviderService"),e.$Ynb=(0,P.$6h)("IUserDataAutoSyncService"),e.$Znb=(0,P.$6h)("IUserDataSyncUtilService"),e.$1nb=(0,P.$6h)("IUserDataSyncLogService"),e.$2nb="userDataSync",e.$3nb="vscode-userdata-sync",e.$4nb="preview"}),define(le[239],he([0,1,30,25]),function(se,e,O,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eHb=void 0;function D(I,P,k,g,C){if(!P)return{remote:{added:Object.keys(I),removed:[],updated:[],all:Object.keys(I).length>0?I:null},local:{added:{},removed:[],updated:{}}};const S=A(I,P);if(S.added.size===0&&S.removed.size===0&&S.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=k?A(k,P):{added:Object.keys(P).reduce((f,d)=>(f.add(d),f),new Set),removed:new Set,updated:new Set},l=k?A(k,I):{added:Object.keys(I).reduce((f,d)=>(f.add(d),f),new Set),removed:new Set,updated:new Set},$={added:{},removed:[],updated:{}},b=O.$vn(P),w=!k;for(const f of l.added.values())f!==L.$Tnb&&w&&m.added.has(f)||(b[f]=I[f]);for(const f of l.updated.values())b[f]=I[f];for(const f of l.removed.values())g.unregistered.includes(f)||delete b[f];for(const f of m.added.values()){const d=P[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped adding ${f} in local storage because it is declared as machine scoped.`);continue}if(k&&l.added.has(f))continue;const c=I[f];c&&c.value===d.value||f===L.$Tnb&&w&&l.added.has(f)||(c?$.updated[f]=d:$.added[f]=d)}for(const f of m.updated.values()){const d=P[f];if(g.machine.includes(f)){C.info(`GlobalState: Skipped updating ${f} in local storage because it is declared as machine scoped.`);continue}if(l.updated.has(f)||l.removed.has(f))continue;const c=I[f];c&&c.value===d.value||($.updated[f]=d)}for(const f of m.removed.values()){if(g.machine.includes(f)){C.trace(`GlobalState: Skipped removing ${f} in local storage because it is declared as machine scoped.`);continue}l.updated.has(f)||l.removed.has(f)||$.removed.push(f)}const h=A(P,b);return{local:$,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:b}}}e.$eHb=D;function A(I,P){const k=Object.keys(I),g=Object.keys(P),C=g.filter(l=>!k.includes(l)).reduce((l,$)=>(l.add($),l),new Set),S=k.filter(l=>!g.includes(l)).reduce((l,$)=>(l.add($),l),new Set),m=new Set;for(const l of k){if(S.has(l))continue;const $=I[l],b=P[l];O.$zn($,b)||m.add(l)}return{added:C,removed:S,updated:m}}}),define(le[240],he([0,1,17,34,62,42,30,80,25]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$XFb=e.$WFb=e.$VFb=e.$UFb=e.$TFb=e.$SFb=void 0;function g(a,E,y){let u=[];y?u=S(y):u=C(E);const p=[],R=[...(0,k.$Bnb)()];if(Array.isArray(u))for(const N of u)N.startsWith("-")?R.push(N.substring(1)):p.push(N);return(0,O.$Mb)([...a,...p].filter(N=>!R.includes(N)))}e.$SFb=g;function C(a){let E=a.inspect("settingsSync.ignoredSettings").userValue;return E!==void 0||(E=a.inspect("sync.ignoredSettings").userValue,E!==void 0)?E:a.getValue("settingsSync.ignoredSettings")||[]}function S(a){const E=(0,L.$cn)(a);return E?E["settingsSync.ignoredSettings"]||E["sync.ignoredSettings"]||[]:[]}function m(a,E){const y=(0,L.$cn)(a)||{};let u="{}";for(const p of Object.keys(y)){const R=(0,D.$rn)(u,[p],y[p],E);u=(0,D.$un)(u,R)}return u}e.$TFb=m;function l(a,E,y,u){if(y.length){const p=r(E),R=(0,L.$cn)(E)||{},N=(0,L.$cn)(a);if(!N)return a;const T=[];for(const M of y){const U=R[M],Y=N[M];U===void 0?a=P.edit(a,[M],void 0,u):Y!==void 0?a=P.edit(a,[M],U,u):T.push(i(M,p))}T.sort((M,U)=>M.startOffset-U.startOffset),T.forEach(M=>a=f(M.setting.key,E,a,u))}return a}e.$UFb=l;function $(a,E,y,u,p,R){const N=l(a,E,u,R),T=y!==N,M=y!==E;if(!T&&!M)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!M)return{conflictsSettings:[],localContent:null,remoteContent:N,hasConflicts:!1};if(M&&!T)return{conflictsSettings:[],localContent:l(E,a,u,R),remoteContent:null,hasConflicts:!1};if(y===null&&w(a)){const F=b(a,E,u)?null:l(E,a,u,R);return{conflictsSettings:[],localContent:F,remoteContent:null,hasConflicts:!1}}let U=a,Y=E;const Q=(0,L.$cn)(a),x=(0,L.$cn)(E),H=y?(0,L.$cn)(y):null,Z=u.reduce((F,B)=>(F.add(B),F),new Set),W=h(Q,x,Z),V=h(H,Q,Z),ie=h(H,x,Z),re=new Map,ee=new Set,ae=F=>{ee.add(F);const B=p.filter(({key:z})=>z===F)[0];B?(U=P.edit(U,[F],B.value,R),Y=P.edit(Y,[F],B.value,R)):re.set(F,{key:F,localValue:Q[F],remoteValue:x[F]})};for(const F of V.removed.values())ie.updated.has(F)?ae(F):Y=P.edit(Y,[F],void 0,R);for(const F of ie.removed.values())ee.has(F)||(V.updated.has(F)?ae(F):U=P.edit(U,[F],void 0,R));for(const F of V.updated.values())ee.has(F)||(ie.updated.has(F)?W.updated.has(F)&&ae(F):Y=P.edit(Y,[F],Q[F],R));for(const F of ie.updated.values())ee.has(F)||(V.updated.has(F)?W.updated.has(F)&&ae(F):U=P.edit(U,[F],x[F],R));for(const F of V.added.values())ee.has(F)||(ie.added.has(F)?W.updated.has(F)&&ae(F):Y=f(F,U,Y,R));for(const F of ie.added.values())ee.has(F)||(V.added.has(F)?W.updated.has(F)&&ae(F):U=f(F,Y,U,R));const K=re.size>0||!b(U,Y,u),q=K||!b(U,a,[]),j=K||!b(Y,E,[]);return{localContent:q?U:null,remoteContent:j?Y:null,conflictsSettings:[...re.values()],hasConflicts:K}}e.$VFb=$;function b(a,E,y){if(a===E)return!0;const u=(0,L.$cn)(a),p=(0,L.$cn)(E),R=y.reduce((M,U)=>(M.add(U),M),new Set),N=r(a).filter(M=>!(M.setting&&R.has(M.setting.key))),T=r(E).filter(M=>!(M.setting&&R.has(M.setting.key)));if(N.length!==T.length)return!1;for(let M=0;M<N.length;M++){const U=N[M],Y=T[M];if(U.setting&&Y.setting){if(U.setting.key!==Y.setting.key||!I.$zn(u[U.setting.key],p[U.setting.key]))return!1}else if(!U.setting&&!Y.setting){if(U.value!==Y.value)return!1}else return!1}return!0}function w(a){return a?r(a).length===0:!0}e.$WFb=w;function h(a,E,y){const u=a?Object.keys(a).filter(M=>!y.has(M)):[],p=Object.keys(E).filter(M=>!y.has(M)),R=p.filter(M=>!u.includes(M)).reduce((M,U)=>(M.add(U),M),new Set),N=u.filter(M=>!p.includes(M)).reduce((M,U)=>(M.add(U),M),new Set),T=new Set;if(a)for(const M of u){if(N.has(M))continue;const U=a[M],Y=E[M];I.$zn(U,Y)||T.add(M)}return{added:R,removed:N,updated:T}}function f(a,E,y,u){const p=(0,L.$cn)(E),R=r(E),N=r(y),T=d(a,R,N);return c(y,a,p[a],T,N,u)}e.$XFb=f;function d(a,E,y){const u=E.findIndex(R=>R.setting?.key===a),p=E[u-1];if(p){if(p.setting){const N=i(p.setting.key,y);if(N)return{index:y.indexOf(N),insertAfter:!0}}else{const N=o(u,E);if(N){const T=i(N.setting.key,y);if(T){const M=n(y.indexOf(T),y),U=s(E,N,E[u]);if(M){const Y=s(y,T,M),Q=t(U,Y);return Q?{index:y.indexOf(Q),insertAfter:!0}:{index:y.indexOf(M),insertAfter:!1}}else{const Y=s(y,T,y[y.length-1]),Q=t(U,Y);return Q?{index:y.indexOf(Q),insertAfter:!0}:{index:y.length-1,insertAfter:!0}}}}}const R=E[u+1];if(R)if(R.setting){const N=i(R.setting.key,y);if(N)return{index:y.indexOf(N),insertAfter:!1}}else{const N=n(u,E);if(N){const T=i(N.setting.key,y);if(T){const M=o(y.indexOf(T),y),U=s(E,E[u],N);if(M){const Y=s(y,M,T),Q=t(U.reverse(),Y.reverse());return Q?{index:y.indexOf(Q),insertAfter:!1}:{index:y.indexOf(M),insertAfter:!0}}else{const Y=s(y,y[0],T),Q=t(U.reverse(),Y.reverse());return Q?{index:y.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:y.length-1,insertAfter:!0}}function c(a,E,y,u,p,R){let N;return u.index===-1?N=(0,D.$rn)(a,[E],y,R):N=v(a,E,y,u,p,R).map(T=>(0,D.$sn)(a,T,R)[0]),(0,D.$un)(a,N)}function v(a,E,y,u,p,R){const N=`${JSON.stringify(E)}: ${JSON.stringify(y)}`,T=(0,A.$on)(R,a),M=p[u.index];if(u.insertAfter){const U=[];if(M.setting)U.push({offset:M.endOffset,length:0,content:","+N});else{const Y=n(u.index,p),Q=o(u.index,p),x=Q?.setting?.commaOffset;Q&&x===void 0&&U.push({offset:Q.endOffset,length:0,content:","});const H=x!==void 0&&x>M.endOffset;U.push({offset:H?x+1:M.endOffset,length:0,content:Y?T+N+",":T+N})}return U}else{if(M.setting)return[{offset:M.startOffset,length:0,content:N+","}];const U=(p[u.index-1]&&!p[u.index-1].setting?T:"")+N+(n(u.index,p)?",":"")+T;return[{offset:M.startOffset,length:0,content:U}]}}function i(a,E){return E.filter(y=>y.setting?.key===a)[0]}function o(a,E){for(let y=a-1;y>=0;y--)if(E[y].setting)return E[y]}function n(a,E){for(let y=a+1;y<E.length;y++)if(E[y].setting)return E[y]}function s(a,E,y){const u=a.indexOf(E),p=a.indexOf(y);return a.filter((R,N)=>u<N&&N<p)}function t(a,E){if(a.length&&E.length){let y=0;for(;y<E.length&&y<a.length;y++)if(a[y].value!==E[y].value)return E[y-1];return E[y-1]}}function r(a){const E=[];let y=-1,u,p;const R={onObjectBegin:N=>{y++},onObjectProperty:(N,T,M)=>{y===0&&(u=T,p=N)},onObjectEnd:(N,T)=>{y--,y===0&&E.push({startOffset:u,endOffset:N+T,value:a.substring(u,N+T),setting:{key:p,commaOffset:void 0}})},onArrayBegin:(N,T)=>{y++},onArrayEnd:(N,T)=>{y--,y===0&&E.push({startOffset:u,endOffset:N+T,value:a.substring(u,N+T),setting:{key:p,commaOffset:void 0}})},onLiteralValue:(N,T,M)=>{y===0&&E.push({startOffset:u,endOffset:T+M,value:a.substring(u,T+M),setting:{key:p,commaOffset:void 0}})},onSeparator:(N,T,M)=>{if(y===0&&N===","){let U=E.length-1;for(;U>=0&&!E[U].setting;U--);const Y=E[U];Y&&E.splice(U,1,{startOffset:Y.startOffset,endOffset:Y.endOffset,value:Y.value,setting:{key:Y.setting.key,commaOffset:T}})}},onComment:(N,T)=>{y===0&&E.push({startOffset:N,endOffset:N+T,value:a.substring(N,N+T)})}};return(0,L.$jn)(a,R),E}}),define(le[81],he([0,1,3,2,4,25]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$DFb=e.$CFb=void 0,e.$CFb=(0,D.$6h)("IUserDataSyncAccountService");let I=class extends L.$Tc{get account(){return this.a}constructor(k,g){super(),this.g=k,this.h=g,this.b=this.B(new O.$Vd),this.onDidChangeAccount=this.b.event,this.c=this.B(new O.$Vd),this.onTokenFailed=this.c.event,this.f=!1,this.B(k.onTokenFailed(C=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,C),this.updateAccount(void 0),C==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(k.onTokenSucceed(()=>this.f=!1))}async updateAccount(k){(k&&this.a?k.token!==this.a.token||k.authenticationProviderId!==this.a.authenticationProviderId:k!==this.a)&&(this.a=k,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(k))}};e.$DFb=I,e.$DFb=I=pe([X(0,A.$Lnb),X(1,A.$1nb)],I)}),define(le[241],he([0,1,20,175,15,8,25]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$WHb=void 0;let P=class extends A.$sj{constructor(g,C){super(),this.g=this.B(g.createLogger((0,O.$Hg)(C.logsHome,`${I.$2nb}.log`),{id:I.$2nb,name:(0,L.localize)(0,null)}))}trace(g,...C){this.g.trace(g,...C)}debug(g,...C){this.g.debug(g,...C)}info(g,...C){this.g.info(g,...C)}warn(g,...C){this.g.warn(g,...C)}error(g,...C){this.g.error(g,...C)}flush(){this.g.flush()}};e.$WHb=P,e.$WHb=P=pe([X(0,A.$oj),X(1,D.$ai)],P)}),define(le[242],he([0,1,6,3,2]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$e_b=void 0;class A extends D.$Tc{constructor({onDidOpenMainWindow:P,onDidFocusMainWindow:k,getActiveWindowId:g}){super(),this.a=this.B(new D.$Sc),L.Event.latch(L.Event.any(P,k))(this.f,this,this.a),this.b=(0,O.$Tg)(()=>g()),(async()=>{try{const S=await this.b;this.c=typeof this.c=="number"?this.c:S}catch{}finally{this.b=void 0}})()}f(P){this.b&&(this.b.cancel(),this.b=void 0),this.c=P}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.$e_b=A}),define(le[112],he([0,1,178,16,48,20,10,4,23]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,P.$6h)("contextService");function g(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.uri)}e.$di=g;function C(s){return typeof s?.id=="string"&&!g(s)&&!m(s)}e.$ei=C,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function S(s,t){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,L.$nc)(s)}:t?e.$fi:e.$gi;const r=s;return r.configuration?{id:r.id,configPath:r.configuration}:r.folders.length===1?{id:r.id,uri:r.folders[0].uri}:{id:r.id}}e.$hi=S;function m(s){const t=s;return typeof t?.id=="string"&&I.URI.isUri(t.configPath)}e.$ii=m;function l(s){const t=s;if(t?.uri)return{id:t.id,uri:I.URI.revive(t.uri)};const r=s;if(r?.configPath)return{id:r.id,configPath:I.URI.revive(r.configPath)};if(s?.id)return{id:s.id}}e.$ji=l;var $;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function b(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&Array.isArray(t.folders))}e.$ki=b;function w(s){const t=s;return!!(t&&typeof t=="object"&&I.URI.isUri(t.uri)&&typeof t.name=="string"&&typeof t.toResource=="function")}e.$li=w;class h{constructor(t,r,a,E,y){this.h=t,this.j=a,this.l=E,this.n=y,this.c=D.$_h.forUris(this.n,()=>!0),this.folders=r}update(t){this.h=t.id,this.l=t.configuration,this.j=t.transient,this.n=t.n,this.folders=t.folders}get folders(){return this.g}set folders(t){this.g=t,this.o()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.l}set configuration(t){this.l=t}getFolder(t){return t&&this.c.findSubstr(t)||null}o(){this.c=D.$_h.forUris(this.n,()=>!0);for(const t of this.folders)this.c.set(t.uri,t)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=h;class f{constructor(t,r){this.raw=r,this.uri=t.uri,this.index=t.index,this.name=t.name}toResource(t){return(0,A.$Hg)(this.uri,t)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=f;function d(s){return new f({uri:s,index:0,name:(0,A.$Dg)(s)},{uri:s.toString()})}e.$oi=d,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,O.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function c(s,t){return A.$yg.isEqualOrParent(s,t.untitledWorkspacesHome)}e.$ti=c;function v(s){let t;return I.URI.isUri(s)?t=s:t=s.configuration,t?.scheme===k.Schemas.tmp}e.$ui=v,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.$vi}e.$wi=i;function o(s,t){return!c(s,t)&&!v(s)}e.$xi=o;function n(s){return(typeof s=="string"?(0,L.$oc)(s):(0,A.$Fg)(s))===e.$qi}e.$yi=n}),define(le[18],he([0,1,53,3,2,20,10,169,15,11,4,8,112,35,28,6,32,27,12]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.ProfileResourceType=void 0;var d;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState"})(d||(e.ProfileResourceType=d={}));function c(s){const t=s;return!!(t&&typeof t=="object"&&typeof t.id=="string"&&typeof t.isDefault=="boolean"&&typeof t.name=="string"&&I.URI.isUri(t.location)&&I.URI.isUri(t.globalStorageHome)&&I.URI.isUri(t.settingsResource)&&I.URI.isUri(t.keybindingsResource)&&I.URI.isUri(t.tasksResource)&&I.URI.isUri(t.snippetsHome)&&I.URI.isUri(t.extensionsResource))}e.$2k=c,e.$3k=(0,C.$6h)("IUserDataProfilesService");function v(s,t){return{id:s.id,isDefault:s.isDefault,name:s.name,shortName:s.shortName,icon:s.icon,location:I.URI.revive(s.location).with({scheme:t}),globalStorageHome:I.URI.revive(s.globalStorageHome).with({scheme:t}),settingsResource:I.URI.revive(s.settingsResource).with({scheme:t}),keybindingsResource:I.URI.revive(s.keybindingsResource).with({scheme:t}),tasksResource:I.URI.revive(s.tasksResource).with({scheme:t}),snippetsHome:I.URI.revive(s.snippetsHome).with({scheme:t}),extensionsResource:I.URI.revive(s.extensionsResource).with({scheme:t}),cacheHome:I.URI.revive(s.cacheHome).with({scheme:t}),useDefaultFlags:s.useDefaultFlags,isTransient:s.isTransient}}e.$4k=v;function i(s,t,r,a,E,y){return{id:s,name:t,location:r,isDefault:!1,shortName:E?.shortName,icon:E?.icon,globalStorageHome:y&&E?.useDefaultFlags?.globalState?y.globalStorageHome:(0,A.$Hg)(r,"globalStorage"),settingsResource:y&&E?.useDefaultFlags?.settings?y.settingsResource:(0,A.$Hg)(r,"settings.json"),keybindingsResource:y&&E?.useDefaultFlags?.keybindings?y.keybindingsResource:(0,A.$Hg)(r,"keybindings.json"),tasksResource:y&&E?.useDefaultFlags?.tasks?y.tasksResource:(0,A.$Hg)(r,"tasks.json"),snippetsHome:y&&E?.useDefaultFlags?.snippets?y.snippetsHome:(0,A.$Hg)(r,"snippets"),extensionsResource:y&&E?.useDefaultFlags?.extensions?y.extensionsResource:(0,A.$Hg)(r,"extensions.json"),cacheHome:(0,A.$Hg)(a,s),useDefaultFlags:E?.useDefaultFlags,isTransient:E?.transient}}e.$5k=i;let o=class extends D.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(t,r,a,E){super(),this.t=t,this.u=r,this.w=a,this.y=E,this.f=!0,this.h=this.B(new L.$Vd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new L.$Vd),this.onWillCreateProfile=this.j.event,this.m=this.B(new L.$Vd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new L.$Vd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new l.$Ac,emptyWindows:new Map},this.profilesHome=(0,A.$Hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,A.$Hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(t){this.f!==t&&(this.z=void 0,this.f=t)}isEnabled(){return this.f}get C(){if(!this.z){const t=this.D(),r=[t];if(this.f)try{for(const y of this.O()){if(!y.name||!(0,f.$If)(y.name)||!y.location){this.y.warn("Skipping the invalid stored profile",y.location||y.name);continue}r.push(i((0,A.$Eg)(y.location),y.name,y.location,this.g,{shortName:y.shortName,icon:y.icon,useDefaultFlags:y.useDefaultFlags},t))}}catch(y){this.y.error(y)}const a=new l.$Ac,E=new Map;if(r.length)try{const y=this.Q();if(y.workspaces)for(const[u,p]of Object.entries(y.workspaces)){const R=I.URI.parse(u),N=r.find(T=>T.id===p);N&&a.set(R,N)}if(y.emptyWindows)for(const[u,p]of Object.entries(y.emptyWindows)){const R=r.find(N=>N.id===p);R&&E.set(u,R)}}catch(y){this.y.error(y)}this.z={profiles:r,workspaces:a,emptyWindows:E}}return this.z}D(){const t=i("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...t,extensionsResource:this.S()??t.extensionsResource,isDefault:!0}}async createTransientProfile(t){const r="Temp",a=new RegExp(`${(0,h.$Oe)(r)}\\s(\\d+)`);let E=0;for(const u of this.profiles){const p=a.exec(u.name),R=p?parseInt(p[1]):0;E=R>E?R:E}const y=`${r} ${E+1}`;return this.createProfile((0,O.$Ti)((0,w.$qg)()).toString(16),y,{transient:!0},t)}async createNamedProfile(t,r,a){return this.createProfile((0,O.$Ti)((0,w.$qg)()).toString(16),t,r,a)}async createProfile(t,r,a,E){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.F(t,r,a);return E&&await this.setProfileForWorkspace(E,y),y}async F(t,r,a){if(!(0,f.$If)(r)||!r)throw new Error("Name of the profile is mandatory and must be of type `string`");let E=this.r.get(r);return E||(E=(async()=>{try{const y=this.profiles.find(R=>R.name===r||R.id===t);if(y)return y;const u=i(t,r,(0,A.$Hg)(this.profilesHome,t),this.g,a,this.defaultProfile);await this.u.createFolder(u.location);const p=[];return this.j.fire({profile:u,join(R){p.push(R)}}),await b.Promises.settled(p),this.I([u],[],[]),u}finally{this.r.delete(r)}})(),this.r.set(r,E)),E}async updateProfile(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let a=this.profiles.find(E=>E.id===t.id);if(!a)throw new Error(`Profile '${t.name}' does not exist`);return a=i(a.id,r.name??a.name,a.location,this.g,{shortName:r.shortName??a.shortName,icon:r.icon===null?void 0:r.icon??a.icon,transient:r.transient??a.isTransient,useDefaultFlags:r.useDefaultFlags??a.useDefaultFlags},this.defaultProfile),this.I([],[],[a]),a}async removeProfile(t){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(t.isDefault)throw new Error("Cannot remove default profile");const r=this.profiles.find(E=>E.id===t.id);if(!r)throw new Error(`Profile '${t.name}' does not exist`);const a=[];this.m.fire({profile:r,join(E){a.push(E)}});try{await Promise.allSettled(a)}catch(E){this.y.error(E)}for(const E of[...this.C.emptyWindows.keys()])r.id===this.C.emptyWindows.get(E)?.id&&this.C.emptyWindows.delete(E);for(const E of[...this.C.workspaces.keys()])r.id===this.C.workspaces.get(E)?.id&&this.C.workspaces.delete(E);this.M(),this.I([],[r],[]);try{await this.u.del(r.cacheHome,{recursive:!0})}catch(E){(0,g.$Hk)(E)!==1&&this.y.error(E)}}async setProfileForWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const a=this.profiles.find(E=>E.id===r.id);if(!a)throw new Error(`Profile '${r.name}' does not exist`);this.L(t,a)}unsetWorkspace(t,r){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(t,void 0,r)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const t=await this.u.resolve(this.profilesHome);await Promise.all((t.children||[]).filter(r=>r.isDirectory&&this.profiles.every(a=>!this.w.extUri.isEqual(a.location,r.resource))).map(r=>this.u.del(r.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const t=this.s.profiles.filter(r=>!this.H(r));await Promise.allSettled(t.map(r=>this.removeProfile(r)))}getProfileForWorkspace(t){const r=this.G(t);return I.URI.isUri(r)?this.s.workspaces.get(r)??this.C.workspaces.get(r):this.s.emptyWindows.get(r)??this.C.emptyWindows.get(r)}G(t){return(0,m.$di)(t)?t.uri:(0,m.$ii)(t)?t.configPath:t.id}H(t){return!!([...this.s.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.s.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.emptyWindows.values()].some(r=>this.w.extUri.isEqual(r.location,t.location))||[...this.C.workspaces.values()].some(r=>this.w.extUri.isEqual(r.location,t.location)))}I(t,r,a){const E=[...this.profiles,...t],y=[];this.s.profiles=[];for(let u of E)u.isDefault||r.some(p=>u.id===p.id)||(u=a.find(p=>u.id===p.id)??u,u.isTransient?this.s.profiles.push(u):y.push({location:u.location,name:u.name,shortName:u.shortName,icon:u.icon,useDefaultFlags:u.useDefaultFlags}));this.P(y),this.z=void 0,this.J(t,r,a)}J(t,r,a){this.h.fire({added:t,removed:r,updated:a,all:this.profiles})}L(t,r,a){a=r?.isTransient?!0:a,a||this.L(t,void 0,!0);const E=this.G(t),y=a?this.s:this.C;I.URI.isUri(E)?(y.workspaces.delete(E),r&&y.workspaces.set(E,r)):(y.emptyWindows.delete(E),r&&y.emptyWindows.set(E,r)),a||this.M()}M(){const t={};for(const[a,E]of this.C.workspaces.entries())t[a.toString()]=E.id;const r={};for(const[a,E]of this.C.emptyWindows.entries())r[a.toString()]=E.id;this.R({workspaces:t,emptyWindows:r}),this.z=void 0}N(t){const r={},a=this.D();if(t.workspaces)for(const[y,u]of Object.entries(t.workspaces)){const p=I.URI.parse(u);r[y]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}const E={};if(t.emptyWindows)for(const[y,u]of Object.entries(t.emptyWindows)){const p=I.URI.parse(u);E[y]=this.w.extUri.isEqual(p,a.location)?a.id:this.w.extUri.basename(p)}return{workspaces:r,emptyWindows:E}}O(){return[]}P(t){throw new Error("not implemented")}Q(){return{}}R(t){throw new Error("not implemented")}S(){}};e.$6k=o,e.$6k=o=pe([X(0,k.$ai),X(1,g.$qk),X(2,$.$1k),X(3,S.$nj)],o);class n extends o{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(t){this.a=t}Q(){return this.X}R(t){this.X=t}}e.$7k=n}),define(le[243],he([0,1,6,2,18]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qac=void 0;let A=class extends L.$Tc{constructor(P){super(),this.B(new O.$fh(()=>{P.cleanUp()},10*1e3)).schedule()}};e.$qac=A,e.$qac=A=pe([X(0,D.$3k)],A)}),define(le[244],he([0,1,17,6,26,7,3,2,5,12,10,152,29,33,45,8,24,22,28,18]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tp=e.$Sp=e.$Rp=e.$Qp=void 0;let c=class extends P.$Tc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,r,a,E,y,u){super(),this.z=t,this.C=r,this.D=a,this.F=E,this.G=y,this.H=u,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new I.$Vd),this.s=this.B(new I.$Vd),this.t=this.B(new I.$Vd),this.u=this.B(new I.$Vd),this.w=this.B(new I.$Vd),this.y=[],this.B((0,P.$Rc)(()=>{this.j.forEach(({task:p})=>p.cancel()),this.m.forEach(p=>p.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const r=await this.getTargetPlatform();return t.allTargetPlatforms.some(a=>(0,m.$wo)(a,t.allTargetPlatforms,r))}async installFromGallery(t,r={}){try{const E=(await this.installGalleryExtensions([{extension:t,options:r}])).find(({identifier:y})=>(0,l.$1o)(y,t.identifier));if(E?.local)return E?.local;throw E?.error?E.error:new m.$zo(`Unknown error while installing extension ${t.identifier.id}`,m.ExtensionManagementErrorCode.Unknown)}catch(a){throw i(a)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new m.$zo(S.localize(0,null),m.ExtensionManagementErrorCode.NotAllowed);const r=[],a=[];await Promise.allSettled(t.map(async({extension:E,options:y})=>{try{const u=await this.O(E,!!y?.installGivenVersion,!!y?.installPreReleaseVersion);a.push({...u,options:y})}catch(u){r.push({identifier:E.identifier,operation:2,source:E,error:u})}})),a.length&&r.push(...await this.I(a));for(const E of r)E.error&&(this.F.error("Failed to install extension.",E.identifier.id),this.F.error(E.error),E.source&&!C.URI.isUri(E.source)&&o(this.C,"extensionGallery:install",{extensionData:(0,l.$9o)(E.source),error:E.error}));return r}async uninstall(t,r={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.Q(t,r)}async toggleAppliationScope(t,r){if((0,$.$om)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let a=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)||(a=await this.ab(t,this.H.defaultProfile.extensionsResource,r));for(const E of this.H.profiles){const y=(await this.getInstalled(1,E.extensionsResource)).find(u=>(0,l.$1o)(u.identifier,t.identifier));y?this.w.fire(y):this.u.fire({identifier:t.identifier,profileLocation:E.extensionsResource})}return a}else{const a=this.D.extUri.isEqual(r,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.ab(t,r,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:a.identifier,operation:2,local:a,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),a}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.X(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const r=[];return await Promise.allSettled(t.map(async a=>{try{const E=await this.J(a,(y,u)=>t.some(p=>(0,l.$5o)(u.identifier.id)===(0,l.$6o)(p.manifest.publisher,p.manifest.name))?!1:this.L(y,u));r.push(...E)}catch(E){r.push({identifier:{id:(0,l.$6o)(a.manifest.publisher,a.manifest.name)},operation:2,source:a.extension,error:E})}})),this.s.fire(r),r}async J({manifest:t,extension:r,options:a},E){const y=a.isApplicationScoped||a.isBuiltin||(0,$.$om)(t),u={...a,installOnlyNewlyAddedFromExtensionPack:C.URI.isUri(r)?a.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:y,profileLocation:y?this.H.defaultProfile.extensionsResource:a.profileLocation??this.Y()},p=Y=>`${l.$2o.create(Y).toString()}${u.profileLocation?`-${u.profileLocation.toString()}`:""}`;if(!C.URI.isUri(r)){const Y=this.j.get(p(r));if(Y)return this.F.info("Extensions is already requested to install",r.identifier.id),await Y.task.waitUntilTaskIsFinished(),[]}const R=[],N=[],T=[],M=this.Z(t,r,u);C.URI.isUri(r)||this.j.set(p(r),{task:M,waitingTasks:[]}),this.n.fire({identifier:M.identifier,source:r,profileLocation:u.profileLocation}),this.F.info("Installing extension:",M.identifier.id),R.push({task:M,manifest:t});let U=!1;try{if(u.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const Q=await this.N(M.identifier,t,!!u.installOnlyNewlyAddedFromExtensionPack,!!u.installPreReleaseVersion,u.profileLocation),x=await this.getInstalled(void 0,u.profileLocation),H={...u,donotIncludePackAndDependencies:!0,context:{...u.context,[m.$ro]:!0}};for(const{gallery:Z,manifest:W}of(0,O.$Mb)(Q,({gallery:V})=>V.identifier.id)){U=U||!!W.extensionDependencies?.some(re=>(0,l.$1o)({id:re},M.identifier));const V=p(Z),ie=this.j.get(V);if(ie){if(E(M,ie.task)){const re=ie.task.identifier;this.F.info("Waiting for already requested installing extension",re.id,M.identifier.id),ie.waitingTasks.push(M),N.push(I.Event.toPromise(I.Event.filter(this.onDidInstallExtensions,ee=>ee.some(ae=>(0,l.$1o)(ae.identifier,re)))).then(ee=>{if(this.F.info("Finished waiting for already requested installing extension",re.id,M.identifier.id),!ee.find(K=>(0,l.$1o)(K.identifier,re))?.local)throw new Error(`Extension ${re.id} is not installed`)}))}}else if(!x.some(({identifier:re})=>(0,l.$1o)(re,Z.identifier))){const re=this.Z(W,Z,H);this.j.set(V,{task:re,waitingTasks:[M]}),this.n.fire({identifier:re.identifier,source:Z,profileLocation:u.profileLocation}),this.F.info("Installing extension:",re.identifier.id,M.identifier.id),R.push({task:re,manifest:W})}}}catch(Q){if(C.URI.isUri(M.source))(0,O.$Lb)(t.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",M.identifier.id,Q.message),(0,O.$Lb)(t.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",M.identifier.id,Q.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),Q}const Y=R.reduce((Q,{task:x,manifest:H})=>(Q.set(x.identifier.id.toLowerCase(),{task:x,manifest:H}),Q),new Map);for(;Y.size;){let Q;const x=[...Y.values()].filter(({manifest:H})=>!H.extensionDependencies?.some(Z=>Y.has(Z.toLowerCase())));x.length?Q=Y.size===1?x:x.filter(({task:H})=>!(H===M&&!U)):(this.F.info("Found extensions with circular dependencies",x.map(({task:H})=>H.identifier.id)),Q=[...Y.values()]),await this.M(Q.map(async({task:H})=>{const Z=new Date().getTime();try{const W=await H.run();if(await this.M(this.y.map(V=>V.postInstall(W,H.source,u,D.CancellationToken.None))),!C.URI.isUri(H.source)){const V=H.operation===3,ie=V?void 0:(new Date().getTime()-H.source.lastUpdated)/1e3;if(o(this.C,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,l.$9o)(H.source),verificationStatus:H.verificationStatus,duration:new Date().getTime()-Z,durationSinceUpdate:ie}),k.$o&&H.operation!==3)try{await this.z.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}T.push({local:W,identifier:H.identifier,operation:H.operation,source:H.source,context:H.options.context,profileLocation:H.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw this.F.error("Error while installing the extension",H.identifier.id,(0,A.$0)(W)),W}finally{Y.delete(H.identifier.id.toLowerCase())}}))}return N.length&&await this.M(N),T.forEach(({identifier:Q})=>this.F.info("Extension installed successfully:",Q.id)),T}catch(Y){if(R.forEach(({task:Q})=>Q.cancel()),T.length)try{const Q=await Promise.allSettled(T.map(({local:x})=>this.$(x,{versionOnly:!0,profileLocation:u.profileLocation}).run()));for(let x=0;x<Q.length;x++){const H=Q[x],{identifier:Z}=T[x];H.status==="fulfilled"?this.F.info("Rollback: Uninstalled extension",Z.id):this.F.warn("Rollback: Error while uninstalling extension",Z.id,(0,A.$0)(H.reason))}}catch(Q){this.F.warn("Error while rolling back extensions",(0,A.$0)(Q),T.map(({identifier:x})=>x.id))}return R.map(({task:Q})=>({identifier:Q.identifier,operation:2,source:Q.source,context:u.context,profileLocation:u.profileLocation,error:Y}))}finally{for(const{task:Y}of R)Y.source&&!C.URI.isUri(Y.source)&&this.j.delete(p(Y.source))}}L(t,r){for(const[,{task:a,waitingTasks:E}]of this.j.entries())if(a===t&&(E.includes(r)||E.some(y=>this.L(y,r)))||a===r&&E[0]&&!this.L(t,E[0]))return!1;return!0}async M(t){const r=[],a=[],E=await Promise.allSettled(t);for(const y of E)y.status==="fulfilled"?r.push(y.value):a.push(y.reason);if(a.length)throw v(a);return r}async N(t,r,a,E,y){if(!this.z.isEnabled())return[];const u=await this.getInstalled(void 0,y),p=[],R=[],N=async(T,M)=>{p.push(T);const U=M.extensionDependencies||[],Y=[...U];if(M.extensionPack){const Q=a?u.find(x=>(0,l.$1o)(x.identifier,T)):void 0;for(const x of M.extensionPack)Q&&Q.manifest.extensionPack&&Q.manifest.extensionPack.some(H=>(0,l.$1o)({id:H},{id:x}))||Y.every(H=>!(0,l.$1o)({id:H},{id:x}))&&Y.push(x)}if(Y.length){const Q=Y.filter(x=>p.every(H=>!(0,l.$1o)(H,{id:x})));if(Q.length){const x=await this.z.getExtensions(Q.map(H=>({id:H,preRelease:E})),D.CancellationToken.None);for(const H of x){if(p.find(V=>(0,l.$1o)(V,H.identifier)))continue;const Z=U.some(V=>(0,l.$1o)({id:V},H.identifier));let W;try{W=await this.O(H,!1,E)}catch(V){if(Z)throw V;this.F.info("Skipping the packed extension as it cannot be installed",H.identifier.id,(0,A.$0)(V));continue}R.push({gallery:W.extension,manifest:W.manifest}),await N(W.extension.identifier,W.manifest)}}}};return await N(t,r),R}async O(t,r,a){let E;const y=await this.getExtensionsControlManifest();if(y.malicious.some(R=>(0,l.$1o)(t.identifier,R)))throw new m.$zo(S.localize(1,null,t.identifier.id),m.ExtensionManagementErrorCode.Malicious);const u=y.deprecated[t.identifier.id.toLowerCase()];if(u?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${u.extension.id}' extension instead.`),E=(await this.z.getExtensions([{id:u.extension.id,preRelease:u.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0],!E)throw new m.$zo(S.localize(2,null,t.identifier.id,u.extension.id),m.ExtensionManagementErrorCode.Deprecated)}else{if(!await this.canInstall(t)){const R=await this.getTargetPlatform();throw new m.$zo(S.localize(3,null,t.identifier.id,this.G.nameLong,(0,m.$so)(R)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}if(E=await this.P(t,r,a),!E)throw!a&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],D.CancellationToken.None))[0]?new m.$zo(S.localize(4,null,t.displayName??t.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.$zo(S.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),m.ExtensionManagementErrorCode.Incompatible)}this.F.info("Getting Manifest...",E.identifier.id);const p=await this.z.getManifest(E,D.CancellationToken.None);if(p===null)throw new m.$zo(`Missing manifest for extension ${E.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(p.version!==E.version)throw new m.$zo(`Cannot install '${E.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:p}}async P(t,r,a){const E=await this.getTargetPlatform();let y=null;return!r&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==a&&(y=(await this.z.getExtensions([{...t.identifier,preRelease:a}],{targetPlatform:E,compatible:!0},D.CancellationToken.None))[0]||null),!y&&await this.z.isExtensionCompatible(t,a,E)&&(y=t),y||(r?y=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:E,compatible:!0},D.CancellationToken.None))[0]||null:y=await this.z.getCompatibleExtension(t,a,E)),y}async Q(t,r){const a={...r,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:r.profileLocation??this.Y()},E=T=>`${T.id.toLowerCase()}${a.versionOnly?`-${t.manifest.version}`:""}${a.profileLocation?`@${a.profileLocation.toString()}`:""}`,y=this.m.get(E(t.identifier));if(y)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),y.waitUntilTaskIsFinished();const u=T=>{const M=this.$(T,a);return this.m.set(E(M.extension.identifier),M),a.profileLocation?this.F.info("Uninstalling extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Uninstalling extension:",`${T.identifier.id}@${T.manifest.version}`),this.t.fire({identifier:T.identifier,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped}),M},p=(T,M)=>{M?a.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString(),M.message):this.F.error("Failed to uninstall extension:",`${T.identifier.id}@${T.manifest.version}`,M.message):a.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${T.identifier.id}@${T.manifest.version}`,a.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${T.identifier.id}@${T.manifest.version}`),o(this.C,"extensionGallery:uninstall",{extensionData:(0,l.$8o)(T),error:M}),this.u.fire({identifier:T.identifier,error:M?.code,profileLocation:a.profileLocation,applicationScoped:T.isApplicationScoped})},R=[],N=[];try{R.push(u(t));const T=await this.getInstalled(1,a.profileLocation);if(a.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const M=this.U(t,T);for(const U of M)this.m.has(E(U.identifier))?this.F.info("Extensions is already requested to uninstall",U.identifier.id):R.push(u(U))}a.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.R(R.map(M=>M.extension),T,t),await this.M(R.map(async M=>{try{if(await M.run(),await this.M(this.y.map(U=>U.postUninstall(M.extension,a,D.CancellationToken.None))),M.extension.identifier.uuid)try{await this.z.reportStatistic(M.extension.manifest.publisher,M.extension.manifest.name,M.extension.manifest.version,"uninstall")}catch{}p(M.extension)}catch(U){const Y=U instanceof m.$zo?U:new m.$zo((0,A.$0)(U),m.ExtensionManagementErrorCode.Internal);throw p(M.extension,Y),Y}finally{N.push(M)}}))}catch(T){const M=T instanceof m.$zo?T:new m.$zo((0,A.$0)(T),m.ExtensionManagementErrorCode.Internal);for(const U of R){try{U.cancel()}catch{}N.includes(U)||p(U.extension,M)}throw M}finally{for(const T of R)this.m.delete(E(T.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",T.extension.identifier.id)}}R(t,r,a){for(const E of t){const y=this.W(E,r);if(y.length){const u=y.filter(p=>!t.some(R=>(0,l.$1o)(R.identifier,p.identifier)));if(u.length)throw new Error(this.S(E,u,a))}}}S(t,r,a){return a===t?r.length===1?S.localize(6,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(7,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(8,null,a.manifest.displayName||a.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?S.localize(9,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?S.localize(10,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):S.localize(11,null,a.manifest.displayName||a.manifest.name,t.manifest.displayName||t.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}U(t,r,a=[]){if(a.indexOf(t)!==-1)return[];a.push(t);const E=t.manifest.extensionPack?t.manifest.extensionPack:[];if(E.length){const y=r.filter(p=>!p.isBuiltin&&E.some(R=>(0,l.$1o)({id:R},p.identifier))),u=[];for(const p of y)u.push(...this.U(p,r,a));return[...y,...u]}return[]}W(t,r){return r.filter(a=>a.manifest.extensionDependencies&&a.manifest.extensionDependencies.some(E=>(0,l.$1o)({id:E},t.identifier)))}async X(){try{this.F.trace("ExtensionManagementService.refreshReportedCache");const t=await this.z.getExtensionsControlManifest();return this.F.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{},search:[]}}}};e.$Qp=c,e.$Qp=c=pe([X(0,m.$yo),X(1,h.$ul),X(2,f.$1k),X(3,b.$nj),X(4,w.$Fj),X(5,d.$3k)],c);function v(s){const t=Array.isArray(s)?s:[s];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((r,a)=>new Error(`${r.message}${r.message?",":""}${a instanceof Error?a.message:a}`),new Error(""))}e.$Rp=v;function i(s){if(s instanceof m.$zo)return s;if(s instanceof m.$Ao){const r=new m.$zo(s.message,m.ExtensionManagementErrorCode.Gallery);return r.stack=s.stack,r}const t=new m.$zo(s.message,m.ExtensionManagementErrorCode.Internal);return t.stack=s.stack,t}e.$Sp=i;function o(s,t,{extensionData:r,verificationStatus:a,duration:E,error:y,durationSinceUpdate:u}){let p,R;(0,g.$Qf)(a)&&(a===!0?a="Verified":(a===!1||(p=m.ExtensionManagementErrorCode.Signature,R=a),a="Unverified")),y&&(y instanceof m.$zo||y instanceof m.$Ao?(p=y.code,y.code===m.ExtensionManagementErrorCode.Signature&&(R=y.message)):p=m.ExtensionManagementErrorCode.Internal),s.publicLog(t,{...r,verificationStatus:a,success:!y,duration:E,errorcode:p,errorcodeDetail:R,durationSinceUpdate:u})}class n{constructor(){this.d=new L.$5g}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,L.$Tg)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,L.$Tg)(t=>new Promise((r,a)=>{const E=t.onCancellationRequested(()=>{E.dispose(),a(new A.$5)})})),this.d.open()),this.g.cancel()}}e.$Tp=n}),define(le[51],he([0,1,6,14,2,3,35,10,29,33,11,4,8,18,28,12,7,22]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wp=e.$Vp=e.$Up=e.ExtensionsProfileScanningErrorCode=void 0;var f;(function(o){o.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",o.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(f||(e.ExtensionsProfileScanningErrorCode=f={}));class d extends Error{constructor(n,s){super(n),this.code=s}}e.$Up=d,e.$Vp=(0,S.$6h)("IExtensionsProfileScannerService");let c=class extends D.$Tc{constructor(n,s,t,r,a,E){super(),this.j=n,this.m=s,this.n=t,this.r=r,this.s=a,this.t=E,this.b=this.B(new A.$Vd),this.onAddExtensions=this.b.event,this.c=this.B(new A.$Vd),this.onDidAddExtensions=this.c.event,this.f=this.B(new A.$Vd),this.onRemoveExtensions=this.f.event,this.g=this.B(new A.$Vd),this.onDidRemoveExtensions=this.g.event,this.h=new I.$Ac}scanProfileExtensions(n,s){return this.u(n,void 0,s)}async addExtensionsToProfile(n,s){const t=[],r=[];try{return await this.u(s,a=>{const E=[];for(const y of a)n.some(([u])=>(0,g.$1o)(u.identifier,y.identifier)&&u.manifest.version!==y.version)?t.push(y):E.push(y);for(const[y,u]of n){const p=E.findIndex(N=>(0,g.$1o)(N.identifier,y.identifier)&&N.version===y.manifest.version),R={identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:u};p===-1?(r.push(R),E.push(R)):E.splice(p,1,R)}return r.length&&this.b.fire({extensions:r,profileLocation:s}),t.length&&this.f.fire({extensions:t,profileLocation:s}),E}),r.length&&this.c.fire({extensions:r,profileLocation:s}),t.length&&this.g.fire({extensions:t,profileLocation:s}),r}catch(a){throw r.length&&this.c.fire({extensions:r,error:a,profileLocation:s}),t.length&&this.g.fire({extensions:t,error:a,profileLocation:s}),a}}async updateMetadata(n,s){const t=[];return await this.u(s,r=>{const a=[];for(const E of r){const y=n.find(([u])=>(0,g.$1o)(u.identifier,E.identifier)&&u.manifest.version===E.version);y&&(E.metadata={...E.metadata,...y[1]},t.push(E)),a.push(E)}return a}),t}async removeExtensionFromProfile(n,s){const t=[];try{await this.u(s,r=>{const a=[];for(const E of r)(0,g.$1o)(E.identifier,n.identifier)?t.push(E):a.push(E);return t.length&&this.f.fire({extensions:t,profileLocation:s}),a}),t.length&&this.g.fire({extensions:t,profileLocation:s})}catch(r){throw t.length&&this.g.fire({extensions:t,error:r,profileLocation:s}),r}}async u(n,s,t){return this.F(n).queue(async()=>{let r=[],a;try{const E=await this.m.readFile(n);a=JSON.parse(E.value.toString().trim()||"[]")}catch(E){if((0,C.$Hk)(E)!==1)throw E;if(this.r.extUri.isEqual(n,this.n.defaultProfile.extensionsResource)&&(a=await this.D()),!a&&t?.bailOutWhenFileNotFound)throw new d((0,w.$0)(E),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.w(n);let E=!1;for(const y of a){v(y)||this.w(n);let u;if((0,b.$If)(y.relativeLocation)&&y.relativeLocation)u=this.z(y.relativeLocation);else if((0,b.$If)(y.location))u=this.z(y.location),E=!0,y.relativeLocation=y.location,y.location=u.toJSON();else{u=P.URI.revive(y.location);const p=this.y(u);p&&(E=!0,y.relativeLocation=p)}r.push({identifier:y.identifier,location:u,version:y.version,metadata:y.metadata})}E&&await this.m.writeFile(n,L.$je.fromString(JSON.stringify(a)))}if(s){r=s(r);const E=r.map(y=>({identifier:y.identifier,version:y.version,location:y.location.toJSON(),relativeLocation:this.y(y.location),metadata:y.metadata}));await this.m.writeFile(n,L.$je.fromString(JSON.stringify(E)))}return r})}w(n){const s=new d(`Invalid extensions content in ${n.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:s.code}),s}y(n){return this.r.extUri.isEqual(this.r.extUri.dirname(n),this.j)?this.r.extUri.basename(n):void 0}z(n){return this.r.extUri.joinPath(this.j,n)}async D(){return this.C||(this.C=(async()=>{const n=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),s=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let t;try{t=(await this.m.readFile(n)).value.toString()}catch(a){if((0,C.$Hk)(a)===1)return;throw a}this.t.info("Migrating extensions from old default profile location",n.toString());let r;try{const a=JSON.parse(t);Array.isArray(a)&&a.every(E=>v(E))?r=a:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.t.error(a)}if(r)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,L.$je.fromString(JSON.stringify(r)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",n.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(a){if((0,C.$Hk)(a)===3)this.t.info("Migration from old default profile location to new location is done by another window",n.toString(),this.n.defaultProfile.extensionsResource.toString());else throw a}try{await this.m.del(n)}catch(a){(0,C.$Hk)(a)!==1&&this.t.error(a)}try{await this.m.del(s)}catch(a){(0,C.$Hk)(a)!==1&&this.t.error(a)}return r})()),this.C}F(n){let s=this.h.get(n);return s||(s=new O.$ah,this.h.set(n,s)),s}};e.$Wp=c,e.$Wp=c=pe([X(1,C.$qk),X(2,l.$3k),X(3,$.$1k),X(4,h.$ul),X(5,m.$nj)],c);function v(o){return(0,b.$Kf)(o)&&(0,k.$xo)(o.identifier)&&(i(o.location)||(0,b.$If)(o.location)&&o.location)&&((0,b.$Pf)(o.relativeLocation)||(0,b.$If)(o.relativeLocation))&&o.version&&(0,b.$If)(o.version)}function i(o){return o?(0,b.$If)(o.path)&&(0,b.$If)(o.scheme):!1}}),define(le[82],he([0,1,17,6,30,14,7,34,138,2,23,16,5,20,55,89,12,10,155,15,33,45,71,11,4,8,24,3,66,51,18,28,183]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v,i,o,n,s,t,r,a,E,y,u,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4p=e.$3p=e.$2p=e.$1p=e.$Zp=e.Translations=void 0;var R;(function(x){function H(Z,W){if(Z===W)return!0;const V=Object.keys(Z),ie=new Set;for(const re of Object.keys(W))ie.add(re);if(V.length!==ie.size)return!1;for(const re of V){if(Z[re]!==W[re])return!1;ie.delete(re)}return ie.size===0}x.equals=H})(R||(e.Translations=R={})),e.$Zp=(0,n.$6h)("IExtensionsScannerService");let N=class extends g.$Tc{constructor(H,Z,W,V,ie,re,ee,ae,K,q,j,F){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=Z,this.r=W,this.s=V,this.t=ie,this.u=re,this.w=ee,this.y=ae,this.z=K,this.C=q,this.D=j,this.F=F,this.g=this.B(new r.$Vd),this.onDidChangeCache=this.g.event,this.h=(0,l.$Hg)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(U,this.s,this.h)),this.m=this.B(this.F.createInstance(U,this.s,this.h)),this.n=this.B(this.F.createInstance(M,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,c.$_o)(this.w,this.y)),this.G}async scanAllExtensions(H,Z,W){const[V,ie]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(Z)]),re=W?await this.scanExtensionsUnderDevelopment(H,[...V,...ie]):[];return this.L(V,ie,re,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const Z=[];Z.push(this.M(!!H.useCache,H.language)),Z.push(this.N(H.language,!!H.checkControlFile));const[W,V]=await Promise.all(Z);return this.J([...W,...V],0,H,!1)}async scanUserExtensions(H){const Z=H.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const W=this.D.extUri.isEqual(H.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,V=await this.P(Z,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,W),ie=H.useCache&&!V.devMode&&V.excludeObsolete?this.m:this.n;let re;try{re=await ie.scanExtensions(V)}catch(ee){if(ee instanceof E.$Up&&ee.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),re=await ie.scanExtensions(V);else throw ee}return re=await this.J(re,1,H,!0),this.y.trace("Scanned user extensions:",re.length),re}async scanExtensionsUnderDevelopment(H,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const W=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(V=>V.scheme===C.Schemas.file).map(async V=>{const ie=await this.P(V,!1,1,!0,H.language,!1,void 0);return(await this.n.scanOneOrMultipleExtensions(ie)).map(ee=>(ee.type=Z.find(ae=>(0,c.$1o)(ae.identifier,ee.identifier))?.type??ee.type,this.n.validate(ee,ie)))}))).flat();return this.J(W,"development",H,!0)}return[]}async scanExistingExtension(H,Z,W){const V=await this.P(H,!1,Z,!0,W.language,!0,void 0),ie=await this.n.scanExtension(V);return!ie||!W.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(H,Z,W){const V=await this.P(H,!1,Z,!0,W.language,!0,void 0),ie=await this.n.scanOneOrMultipleExtensions(V);return this.J(ie,Z,W,!0)}async scanMetadata(H){const Z=(0,l.$Hg)(H,"package.json"),W=(await this.w.readFile(Z)).value.toString();return JSON.parse(W).__metadata}async updateMetadata(H,Z){const W=(0,l.$Hg)(H,"package.json"),V=(await this.w.readFile(W)).value.toString(),ie=JSON.parse(V);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,ie.__metadata={...ie.__metadata,...Z},await this.w.writeFile((0,l.$Hg)(H,"package.json"),A.$je.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof E.$Up&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw H}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.u.addExtensionsToProfile(H.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,A.$je.fromString(JSON.stringify([])))}catch(Z){(0,o.$Hk)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,I.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.y.error(H)}finally{this.H=void 0}})()),this.H}async J(H,Z,W,V){return W.includeAllVersions||(H=this.L(Z===0?H:void 0,Z===1?H:void 0,Z==="development"?H:void 0,await this.getTargetPlatform(),V)),W.includeInvalid||(H=H.filter(ie=>ie.isValid)),H.sort((ie,re)=>{const ee=S.$nc(ie.location.fsPath),ae=S.$nc(re.location.fsPath);return ee<ae?-1:ee>ae?1:0})}L(H,Z,W,V,ie){const re=(ae,K,q)=>{if(ae.isValid&&!K.isValid)return!1;if(ae.isValid===K.isValid){if(ie&&$.gt(ae.manifest.version,K.manifest.version))return this.y.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${ae.location.path} with version ${ae.manifest.version}`),!1;if($.eq(ae.manifest.version,K.manifest.version)){if(ae.type===0)return this.y.debug(`Skipping extension ${K.location.path} in favour of system extension ${ae.location.path} with same version`),!1;if(ae.targetPlatform===V)return this.y.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${ae.location.path} with ${K.location.path}.`):this.y.debug(`Overwriting user extension ${ae.location.path} with ${K.location.path}.`),!0},ee=new v.$nm;return H?.forEach(ae=>{const K=ee.get(ae.identifier.id);(!K||re(K,ae,!1))&&ee.set(ae.identifier.id,ae)}),Z?.forEach(ae=>{const K=ee.get(ae.identifier.id);if(!K&&H&&ae.type===0){this.y.debug(`Skipping obsolete system extension ${ae.location.path}.`);return}(!K||re(K,ae,!1))&&ee.set(ae.identifier.id,ae)}),W?.forEach(ae=>{const K=ee.get(ae.identifier.id);(!K||re(K,ae,!0))&&ee.set(ae.identifier.id,ae),ee.set(ae.identifier.id,ae)}),[...ee.values()]}async M(H,Z){this.y.trace("Started scanning system extensions");const W=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0),ie=await(H&&!W.devMode?this.j:this.n).scanExtensions(W);return this.y.trace("Scanned system extensions:",ie.length),ie}async N(H,Z){const W=this.z.isBuilt?[]:this.C.builtInExtensions;if(!W?.length)return[];this.y.trace("Started scanning dev system extensions");const V=Z?await this.O():{},ie=[],re=h.URI.file(S.$hc(S.$jc(C.$og.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const ae of W){const K=V[ae.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":ie.push((0,l.$Hg)(re,ae.name));break;default:ie.push(h.URI.file(K));break}}const ee=await Promise.all(ie.map(async ae=>this.n.scanExtension(await this.P(ae,!1,0,!0,H,!0,void 0))));return this.y.trace("Scanned dev system extensions:",ee.length),(0,O.$Hb)(ee)}async O(){try{const H=await this.w.readFile(this.r);return JSON.parse(H.value.toString())}catch{return{}}}async P(H,Z,W,V,ie,re,ee){const ae=await this.f(ie??m.$w),K=await this.Q(H),q=Z&&!this.D.extUri.isEqual(H,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,j=q?await this.Q(q):void 0;return new T(H,K,q,j,Z,ee,W,V,re,this.C.version,this.C.date,this.C.commit,!this.z.isBuilt,ie,ae)}async Q(H){try{const Z=await this.w.stat(H);if(typeof Z.mtime=="number")return Z.mtime}catch{}}};e.$1p=N,e.$1p=N=pe([X(4,y.$3k),X(5,E.$Vp),X(6,o.$qk),X(7,s.$nj),X(8,d.$ai),X(9,t.$Fj),X(10,u.$1k),X(11,n.$5h)],N);class T{constructor(H,Z,W,V,ie,re,ee,ae,K,q,j,F,B,z,_){this.location=H,this.mtime=Z,this.applicationExtensionslocation=W,this.applicationExtensionslocationMtime=V,this.profile=ie,this.profileScanOptions=re,this.type=ee,this.excludeObsolete=ae,this.validate=K,this.productVersion=q,this.productDate=j,this.productCommit=F,this.devMode=B,this.language=z,this.translations=_}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,Z){return(0,l.$Ag)(H.location,Z.location)&&H.mtime===Z.mtime&&(0,l.$Ag)(H.applicationExtensionslocation,Z.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&H.profile===Z.profile&&D.$zn(H.profileScanOptions,Z.profileScanOptions)&&H.type===Z.type&&H.excludeObsolete===Z.excludeObsolete&&H.validate===Z.validate&&H.productVersion===Z.productVersion&&H.productDate===Z.productDate&&H.productCommit===Z.productCommit&&H.devMode===Z.devMode&&H.language===Z.language&&R.equals(H.translations,Z.translations)}}e.$2p=T;let M=class extends g.$Tc{constructor(H,Z,W,V,ie){super(),this.f=H,this.g=Z,this.h=W,this.j=V,this.m=ie}async scanExtensions(H){const Z=H.profile?await this.r(H):await this.n(H);let W={};if(H.excludeObsolete&&H.type===1)try{const V=(await this.j.readFile(this.f)).value.toString();W=JSON.parse(V)}catch{}return(0,w.$Vf)(W)?Z:Z.filter(V=>!W[c.$2o.create(V).toString()])}async n(H){const Z=await this.j.resolve(H.location);if(!Z.children?.length)return[];const W=await Promise.all(Z.children.map(async V=>{if(!V.isDirectory||H.type===1&&(0,l.$Eg)(V.resource).indexOf(".")===0)return null;const ie=new T(V.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ie)}));return(0,O.$Hb)(W).sort((V,ie)=>V.location.path<ie.location.path?-1:1)}async r(H){let Z=await this.s(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){Z=Z.filter(V=>!V.metadata?.isApplicationScoped);const W=await this.s(H.applicationExtensionslocation,V=>!!V.metadata?.isBuiltin||!!V.metadata?.isApplicationScoped,H);Z.push(...W)}return Z}async s(H,Z,W){const V=await this.g.scanProfileExtensions(H,W.profileScanOptions);if(!V.length)return[];const ie=await Promise.all(V.map(async re=>{if(Z(re)){const ee=new T(re.location,W.mtime,W.applicationExtensionslocation,W.applicationExtensionslocationMtime,W.profile,W.profileScanOptions,W.type,W.excludeObsolete,W.validate,W.productVersion,W.productDate,W.productCommit,W.devMode,W.language,W.translations);return this.scanExtension(ee,re.metadata)}return null}));return(0,O.$Hb)(ie)}async scanOneOrMultipleExtensions(H){try{if(await this.j.exists((0,l.$Hg)(H.location,"package.json"))){const Z=await this.scanExtension(H);return Z?[Z]:[]}else return await this.scanExtensions(H)}catch(Z){return this.m.error(`Error scanning extensions at ${H.location.path}:`,(0,I.$0)(Z)),[]}}async scanExtension(H,Z){try{let W=await this.scanExtensionManifest(H.location);if(W){W.publisher||(W.publisher=v.$hm),Z=Z??W.__metadata,delete W.__metadata;const V=(0,c.$6o)(W.publisher,W.name),ie=Z?.id?{id:V,uuid:Z.id}:{id:V},re=Z?.isSystem?0:H.type,ee=re===0||!!Z?.isBuiltin;W=await this.t(H.location,W,T.createNlsConfiguration(H));const ae={type:re,identifier:ie,manifest:W,location:H.location,isBuiltin:ee,targetPlatform:Z?.targetPlatform??"undefined",metadata:Z,isValid:!0,validations:[]};return H.validate?this.validate(ae,H):ae}}catch(W){H.type!==0&&this.m.error(W)}return null}validate(H,Z){let W=!0;const V=(0,i.$ep)(Z.productVersion,Z.productDate,Z.location,H.manifest,H.isBuiltin);for(const[ie,re]of V)ie===b.default.Error&&(W=!1,this.m.error(this.z(Z.location,re)));return H.isValid=W,H.validations=V,H}async scanExtensionManifest(H){const Z=(0,l.$Hg)(H,"package.json");let W;try{W=(await this.j.readFile(Z)).value.toString()}catch(ie){return(0,o.$Hk)(ie)!==1&&this.m.error(this.z(H,(0,f.localize)(0,null,Z.path,ie.message))),null}let V;try{V=JSON.parse(W)}catch{const re=[];(0,P.$cn)(W,re);for(const ee of re)this.m.error(this.z(H,(0,f.localize)(1,null,Z.path,ee.offset,ee.length,(0,k.$Xp)(ee.error))));return null}return(0,P.$ln)(V)!=="object"?(this.m.error(this.z(H,(0,f.localize)(2,null,Z.path))),null):V}async t(H,Z,W){const V=await this.u(H,Z,W);if(V)try{const ie=[],re=await this.w(V.default,ie);if(ie.length>0)return ie.forEach(ae=>{this.m.error(this.z(H,(0,f.localize)(3,null,V.default?.path,(0,k.$Xp)(ae.error))))}),Z;if((0,P.$ln)(V)!=="object")return this.m.error(this.z(H,(0,f.localize)(4,null,V.default?.path))),Z;const ee=V.values||Object.create(null);return(0,p.$Yp)(this.m,Z,ee,re)}catch{}return Z}async u(H,Z,W){const V=(0,l.$Hg)(H,"package.nls.json"),ie=(K,q)=>{q.forEach(j=>{this.m.error(this.z(H,(0,f.localize)(5,null,K?.path,(0,k.$Xp)(j.error))))})},re=K=>{this.m.error(this.z(H,(0,f.localize)(6,null,K?.path)))},ee=`${Z.publisher}.${Z.name}`,ae=W.translations[ee];if(ae)try{const K=h.URI.file(ae),q=(await this.j.readFile(K)).value.toString(),j=[],F=(0,P.$cn)(q,j);return j.length>0?(ie(K,j),{values:void 0,default:V}):(0,P.$ln)(F)!=="object"?(re(K),{values:void 0,default:V}):{values:F.contents?F.contents.package:void 0,default:V}}catch{return{values:void 0,default:V}}else{if(!await this.j.exists(V))return;let q;try{q=await this.y(H,W)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const j=(await this.j.readFile(q.localized)).value.toString(),F=[],B=(0,P.$cn)(j,F);return F.length>0?(ie(q.localized,F),{values:void 0,default:q.original}):(0,P.$ln)(B)!=="object"?(re(q.localized),{values:void 0,default:q.original}):{values:B,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(H,Z){if(H)try{const W=(await this.j.readFile(H)).value.toString();return(0,P.$cn)(W,Z)}catch{}}y(H,Z){return new Promise((W,V)=>{const ie=re=>{const ee=(0,l.$Hg)(H,`package.nls.${re}.json`);this.j.exists(ee).then(ae=>{ae&&W({localized:ee,original:(0,l.$Hg)(H,"package.nls.json")});const K=re.lastIndexOf("-");K===-1?W({localized:(0,l.$Hg)(H,"package.nls.json"),original:null}):(re=re.substring(0,K),ie(re))})};if(Z.devMode||Z.pseudo||!Z.language)return W({localized:(0,l.$Hg)(H,"package.nls.json"),original:null});ie(Z.language)})}z(H,Z){return`[${H.path}]: ${Z}`}};M=pe([X(1,E.$Vp),X(2,u.$1k),X(3,o.$qk),X(4,s.$nj)],M);let U=class extends M{constructor(H,Z,W,V,ie,re,ee){super(Z,V,ie,re,ee),this.G=H,this.H=W,this.D=this.B(new L.$4g(3e3)),this.F=this.B(new r.$Vd),this.onDidChangeCache=this.F.event}async scanExtensions(H){const Z=this.M(H),W=await this.I(Z);if(this.C=H,W&&W.input&&T.equals(W.input,this.C))return this.m.debug("Using cached extensions scan result",H.location.toString()),this.D.trigger(()=>this.L()),W.result.map(ie=>(ie.location=h.URI.revive(ie.location),ie));const V=await super.scanExtensions(H);return await this.J(Z,{input:H,result:V}),V}async I(H){try{const Z=await this.j.readFile(H),W=JSON.parse(Z.value.toString());return{result:W.result,input:(0,a.$Ch)(W.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",H.path,(0,I.$0)(Z))}return null}async J(H,Z){try{await this.j.writeFile(H,A.$je.fromString(JSON.stringify(Z)))}catch(W){this.m.debug("Error while writing the extension cache file:",H.path,(0,I.$0)(W))}}async L(){if(!this.C)return;const H=this.M(this.C),Z=await this.I(H);if(!Z)return;const W=Z.result,V=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!D.$zn(V,W))try{this.m.info("Invalidating Cache",W,V),await this.j.del(H),this.F.fire()}catch(ie){this.m.error(ie)}}M(H){const Z=this.N(H);return this.h.extUri.joinPath(Z.cacheHome,H.type===0?v.$gm:v.$fm)}N(H){return H.type===0?this.H.defaultProfile:H.profile?this.h.extUri.isEqual(H.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(H.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};U=pe([X(2,y.$3k),X(3,E.$Vp),X(4,u.$1k),X(5,o.$qk),X(6,s.$nj)],U);function Y(x,H){const Z=(0,c.$4o)(x.manifest.publisher,x.manifest.name);return{id:Z,identifier:new v.$lm(Z),isBuiltin:x.type===0,isUserBuiltin:x.type===1&&x.isBuiltin,isUnderDevelopment:H,extensionLocation:x.location,uuid:x.identifier.uuid,targetPlatform:x.targetPlatform,...x.manifest}}e.$3p=Y;class Q extends N{constructor(H,Z,W,V,ie,re,ee,ae,K,q,j,F){super(H,Z,(0,l.$Hg)(W,".vscode-oss-dev","extensions","control.json"),V,ie,re,ee,ae,K,q,j,F),this.R=(async()=>{if(m.$z)try{const B=await this.w.readFile(h.URI.file(m.$z));return JSON.parse(B.value.toString())}catch{}return Object.create(null)})()}f(H){return this.R}}e.$4p=Q}),define(le[245],he([0,1,67,6,38,3,2,23,16,31,8,18]),function(se,e,O,L,D,A,I,P,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6p=void 0;let m=class extends I.$Tc{constructor($,b){super(),this.b=$,this.f=b,this.a=new L.$_g(5)}async postUninstall($){const b=this.g($,"uninstall");b&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(b.script,"uninstall",b.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(w){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(w)}}));try{await g.Promises.rm(this.m($))}catch(w){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(w)}}g($,b){const w=`vscode:${b}`;if($.location.scheme===P.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[w]=="string"){const h=$.manifest.scripts[w].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn($.identifier.id,$.manifest.version,`${w} should be a node script`),null):{script:(0,k.$jc)($.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h($,b,w,h,f){return new Promise((d,c)=>{const v=this.j($,b,w,f);let i;const o=n=>{i&&(clearTimeout(i),i=null),n?c(n):d(void 0)};v.on("error",n=>{o((0,D.$Qi)(n)||"Unknown")}),v.on("exit",(n,s)=>{o(n?`post-${b} process exited with code ${n}`:void 0)}),h&&(i=setTimeout(()=>{i=null,v.kill(),c("timed out")},5e3))})}j($,b,w,h){const f={silent:!0,execArgv:void 0},d=(0,O.fork)($,[`--type=extension-post-${b}`,...w],f);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const c=A.Event.fromNodeEventEmitter(d.stdout,"data"),v=A.Event.fromNodeEventEmitter(d.stderr,"data");c(n=>this.f.info(h.identifier.id,h.manifest.version,`post-${b}`,n)),v(n=>this.f.error(h.identifier.id,h.manifest.version,`post-${b}`,n));const i=A.Event.any(A.Event.map(c,n=>({data:`%c${n}`,format:[""]})),A.Event.map(v,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(i,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(h.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),d}m($){return(0,k.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$6p=m,e.$6p=m=pe([X(0,S.$3k),X(1,C.$nj)],m)}),define(le[113],he([0,1,6,14,26,38,7,3,53,2,35,23,16,20,55,12,10,32,31,70,156,96,15,244,29,33,51,82,225,245,184,214,226,71,11,4,8,24,22,28,18]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v,i,o,n,s,t,r,a,E,y,u,p,R,N,T,M,U,Y,Q,x){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aq=e.$_p=e.$$p=e.$0p=void 0,e.$0p=(0,T.$7h)(n.$Bo);const H=".vsctmp";let Z=class extends o.$Qp{constructor(K,q,j,F,B,z,_,G,J,te,ne,ce){super(K,q,ne,j,te,ce),this.fb=B,this.gb=z,this.hb=_,this.ib=J,this.eb=new Map,this.rb=new C.$Bc;const de=this.B(G.createInstance(E.$6p));this.bb=this.B(G.createInstance(W,me=>de.postUninstall(me))),this.cb=this.B(new u.$8p(ce,J,ne,this,this.F)),this.db=this.B(G.createInstance(a.$5p));const $e=this.B(new p.$9p(this,this.fb,ce,z,ne,J,j));this.B($e.onDidChangeExtensionsByAnotherSource(me=>this.qb(me))),this.sb()}getTargetPlatform(){return this.jb||(this.jb=(0,s.$_o)(this.ib,this.F)),this.jb}async zip(K){this.F.trace("ExtensionManagementService#zip",K.identifier.id);const q=await this.pb(K),j=await(0,d.zip)((0,l.$Hg)(this.db.extensionsDownloadDir,(0,h.$qg)()).fsPath,q);return w.URI.file(j)}async unzip(K){return this.F.trace("ExtensionManagementService#unzip",K.toString()),(await this.install(K)).identifier}async getManifest(K){const{location:q,cleanup:j}=await this.lb(K),F=m.$kc(q.fsPath);try{return await(0,y.$7p)(F)}finally{await j()}}getInstalled(K,q=this.H.defaultProfile.extensionsResource){return this.bb.scanExtensions(K??null,q)}scanAllUserInstalledExtensions(){return this.bb.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(K){return this.bb.scanUserExtensionAtLocation(K)}async install(K,q={}){this.F.trace("ExtensionManagementService#install",K.toString());const{location:j,cleanup:F}=await this.lb(K);try{const B=await(0,y.$7p)(m.$kc(j.fsPath)),z=(0,s.$6o)(B.publisher,B.name);if(B.engines&&B.engines.vscode&&!(0,R.$gp)(B.engines.vscode,this.G.version,this.G.date))throw new Error(c.localize(0,null,z,this.G.version));const G=(await this.I([{manifest:B,extension:j,options:q}])).find(({identifier:J})=>(0,s.$1o)(J,{id:z}));if(G?.local)return G.local;throw G?.error?G.error:(0,o.$Sp)(new Error(`Unknown error while installing extension ${z}`))}finally{await F()}}async installFromLocation(K,q){this.F.trace("ExtensionManagementService#installFromLocation",K.toString());const j=await this.bb.scanUserExtensionAtLocation(K);if(!j)throw new Error(`Cannot find a valid extension from the location ${K.toString()}`);return await this.ub([[j,void 0]],q),this.F.info("Successfully installed extension",j.identifier.id,q.toString()),j}async installExtensionsFromProfile(K,q,j){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",K,q.toString(),j.toString());const F=(await this.bb.scanExtensions(1,q)).filter(B=>K.some(z=>(0,s.$1o)(z,B.identifier)));if(F.length){const B=await Promise.all(F.map(z=>this.bb.scanMetadata(z,q)));await this.ub(F.map((z,_)=>[z,B[_]]),j),this.F.info("Successfully installed extensions",F.map(z=>z.identifier.id),j.toString())}return F}async updateMetadata(K,q,j=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",K.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),K=await this.bb.updateMetadata(K,q,j),this.cb.invalidate(j),this.w.fire(K),K}async reinstallFromGallery(K){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",K.identifier.id),!this.z.isEnabled())throw new Error(c.localize(1,null));const q=await this.getTargetPlatform(),[j]=await this.z.getExtensions([{...K.identifier,preRelease:K.preRelease}],{targetPlatform:q,compatible:!0},D.CancellationToken.None);if(!j)throw new Error(c.localize(2,null));await this.bb.setUninstalled(K);try{await this.bb.removeUninstalledExtension(K)}catch(F){throw new Error(c.localize(3,null,(0,A.$Qi)(F)))}return this.installFromGallery(j)}ab(K,q,j,F){return this.bb.copyExtension(K,q,j,F)}copyExtensions(K,q){return this.bb.copyExtensions(K,q)}markAsUninstalled(...K){return this.bb.setUninstalled(...K)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.bb.cleanUp()}catch(K){this.F.error(K)}}async download(K,q,j){const{location:F}=await this.db.download(K,q,!j);return F}async lb(K){if(K.scheme===S.Schemas.file)return{location:K,async cleanup(){}};this.F.trace("Downloading extension from",K.toString());const q=(0,l.$Hg)(this.db.extensionsDownloadDir,(0,h.$qg)());return await this.hb.download(K,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.ib.del(q)}catch(F){this.F.error(F)}}}}Y(){return this.H.defaultProfile.extensionsResource}Z(K,q,j){if(w.URI.isUri(q))return new re(K,q,j,this.z,this.bb,this.D,this.H,this.fb,this.gb,this.F);const F=s.$2o.create(q).toString();let B=this.eb.get(F);return B||(this.eb.set(F,B=new ie(K,q,j,this.db,this.bb,this.D,this.H,this.fb,this.gb,this.F)),B.waitUntilTaskIsFinished().finally(()=>this.eb.delete(F))),B}$(K,q){return new ee(K,q.profileLocation,this.gb)}async pb(K){const q=async F=>{let B=await f.Promises.readdir(F);B=B.map(G=>m.$jc(F,G));const z=await Promise.all(B.map(G=>f.Promises.stat(G)));let _=Promise.resolve([]);return z.forEach((G,J)=>{const te=B[J];G.isFile()&&(_=_.then(ne=>[...ne,te])),G.isDirectory()&&(_=_.then(ne=>q(te).then(ce=>[...ne,...ce])))}),_};return(await q(K.location.fsPath)).map(F=>({path:`extension/${m.$lc(K.location.fsPath,F)}`,localPath:F}))}async qb({added:K,removed:q}){if(q){const j=K&&this.D.extUri.isEqual(q.profileLocation,K.profileLocation)?q.extensions.filter(F=>K.extensions.every(B=>!(0,s.$1o)(B,F))):q.extensions;for(const F of j)this.F.info("Extensions removed from another source",F.id,q.profileLocation.toString()),this.u.fire({identifier:F,profileLocation:q.profileLocation})}if(K){const F=(await this.bb.scanExtensions(1,K.profileLocation)).filter(B=>K.extensions.some(z=>(0,s.$1o)(z,B.identifier)));this.s.fire(F.map(B=>(this.F.info("Extensions added from another source",B.identifier.id,K.profileLocation.toString()),{identifier:B.identifier,local:B,profileLocation:K.profileLocation,operation:1})))}}async sb(){this.B(this.bb.onExtract(q=>this.rb.add(q)));const K=await this.ib.resolve(this.fb.userExtensionsLocation);for(const q of K.children??[])q.isDirectory&&this.rb.add(q.resource);this.B(this.ib.watch(this.fb.userExtensionsLocation)),this.B(this.ib.onDidFilesChange(q=>this.tb(q)))}async tb(K){if(!K.affects(this.fb.userExtensionsLocation,1))return;const q=[];for(const j of K.rawAdded){if(this.rb.has(j)||!this.D.extUri.isEqual(this.D.extUri.dirname(j),this.fb.userExtensionsLocation)||this.D.extUri.isEqual(j,this.D.extUri.joinPath(this.fb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(j).startsWith(".")||!(await this.ib.stat(j)).isDirectory)continue;const F=await this.bb.scanUserExtensionAtLocation(j);F&&F.installedTimestamp===void 0&&(this.rb.add(j),q.push(F))}q.length&&(await this.ub(q.map(j=>[j,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(j=>j.identifier.id)))}async ub(K,q){const j=K.map(F=>F[0]);await this.vb(j),await this.gb.addExtensionsToProfile(K,q),this.s.fire(j.map(F=>({local:F,identifier:F.identifier,operation:1,profileLocation:q})))}async vb(K){const q=await this.bb.getUninstalledExtensions();for(const j of K){const F=s.$2o.create(j);q[F.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",F.id),await this.bb.setInstalled(F),this.F.info("Removed the extension from uninstalled list:",F.id))}}};e.$$p=Z,e.$$p=Z=pe([X(0,n.$yo),X(1,Y.$ul),X(2,M.$nj),X(3,i.$bi),X(4,r.$Zp),X(5,t.$Vp),X(6,v.$do),X(7,T.$5h),X(8,N.$qk),X(9,U.$Fj),X(10,Q.$1k),X(11,x.$3k)],Z);let W=class extends g.$Tc{constructor(K,q,j,F,B,z){super(),this.j=K,this.m=q,this.n=j,this.s=F,this.t=B,this.u=z,this.h=this.B(new P.$Vd),this.onExtract=this.h.event,this.c=(0,l.$Hg)(this.n.userExtensionsLocation,".obsolete"),this.g=new O.$ah}async cleanUp(){await this.H(),await this.G()}async scanExtensions(K,q){const j={includeInvalid:!0,profileLocation:q};let F=[];return K===null||K===0?F.push(...await this.n.scanAllExtensions({includeInvalid:!0},j,!1)):K===1&&F.push(...await this.n.scanUserExtensions(j)),F=K!==null?F.filter(B=>B.type===K):F,Promise.all(F.map(B=>this.F(B)))}async scanAllUserExtensions(K){const q=await this.n.scanUserExtensions({includeAllVersions:!K,includeInvalid:!0});return Promise.all(q.map(j=>this.F(j)))}async scanUserExtensionAtLocation(K){try{const q=await this.n.scanExistingExtension(K,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(K,q,j,F,B){const z=K.toString(),_=w.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,h.$qg)()}`)),G=w.URI.file(m.$jc(this.n.userExtensionsLocation.fsPath,z));let J=await this.m.exists(G);if(J&&F){try{await this.y(K.id,G,"removeExisting")}catch{throw new n.$zo(c.localize(4,null,G.fsPath,K.id),n.ExtensionManagementErrorCode.Delete)}J=!1}if(!J)try{try{this.u.trace(`Started extracting the extension from ${q} to ${G.fsPath}`),await(0,d.$Op)(q,_.fsPath,{sourcePath:"extension",overwrite:!0},B),this.u.info(`Extracted extension to ${G}:`,K.id)}catch(te){let ne=n.ExtensionManagementErrorCode.Extract;throw te instanceof d.$Mp&&(te.type==="CorruptZip"?ne=n.ExtensionManagementErrorCode.CorruptZip:te.type==="Incomplete"&&(ne=n.ExtensionManagementErrorCode.IncompleteZip)),new n.$zo(te.message,ne)}await this.n.updateMetadata(_,j);try{this.u.trace(`Started renaming the extension from ${_.fsPath} to ${G.fsPath}`),await this.C(_.fsPath,G.fsPath),this.u.info("Renamed to",G.fsPath)}catch(te){if(te.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",K.id);else throw this.u.info(`Rename failed because of ${(0,I.$0)(te)}. Deleted from extracted location`,_),te}this.h.fire(G)}catch(te){try{await this.m.del(_,{recursive:!0})}catch{}throw te}return this.D(G,1)}async scanMetadata(K,q){return q?(await this.w(K,q))?.metadata:this.n.scanMetadata(K.location)}async w(K,q){return(await this.s.scanProfileExtensions(q)).find(F=>(0,s.$1o)(F.identifier,K.identifier))}async updateMetadata(K,q,j){return j?await this.s.updateMetadata([[K,q]],j):await this.n.updateMetadata(K.location,q),this.D(K.location,K.type,j)}getUninstalledExtensions(){return this.z()}async setUninstalled(...K){const q=K.map(j=>s.$2o.create(j));await this.z(j=>q.forEach(F=>{j[F.toString()]=!0,this.u.info("Marked extension as uninstalled",F.toString())}))}async setInstalled(K){await this.z(q=>delete q[K.toString()])}async removeExtension(K,q){if(this.t.extUri.isEqualOrParent(K.location,this.n.userExtensionsLocation))return this.y(K.identifier.id,K.location,q)}async removeUninstalledExtension(K){await this.removeExtension(K,"uninstalled"),await this.z(q=>delete q[s.$2o.create(K).toString()])}async copyExtension(K,q,j,F){const B=await this.w(K,q),z=await this.w(K,j);return F={...B?.metadata,...F},z?await this.s.updateMetadata([[K,{...z.metadata,...F}]],j):await this.s.addExtensionsToProfile([[K,F]],j),this.D(K.location,K.type,j)}async copyExtensions(K,q){const j=await this.scanExtensions(1,K),F=await Promise.all(j.filter(B=>!B.isApplicationScoped).map(async B=>[B,await this.scanMetadata(B,K)]));await this.s.addExtensionsToProfile(F,q)}async y(K,q,j){this.u.trace(`Deleting ${j} extension from disk`,K,q.fsPath);const F=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,k.$Ti)((0,h.$qg)()).toString(16)}${H}`);await this.C(q.fsPath,F.fsPath),await this.m.del(F,{recursive:!0}),this.u.info(`Deleted ${j} extension from disk`,K,q.fsPath)}async z(K){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(F){if((0,N.$Hk)(F)!==1)throw F}let j={};if(q)try{j=JSON.parse(q)}catch{}return K&&(K(j),Object.keys(j).length?await this.m.writeFile(this.c,L.$je.fromString(JSON.stringify(j))):await this.m.del(this.c)),j})}async C(K,q){try{await f.Promises.rename(K,q,2*60*1e3)}catch(j){throw new n.$zo(j.message||c.localize(5,null,K,q),j.code||n.ExtensionManagementErrorCode.Rename)}}async D(K,q,j){if(j){const B=(await this.n.scanUserExtensions({profileLocation:j})).find(z=>this.t.extUri.isEqual(z.location,K));if(B)return this.F(B)}else{const F=await this.n.scanExistingExtension(K,q,{includeInvalid:!0});if(F)return this.F(F)}throw new Error(c.localize(6,null,K.path))}async F(K){const q=await this.m.resolve(K.location);let j,F;return q.children&&(j=q.children.find(({name:B})=>/^readme(\.txt|\.md|)$/i.test(B))?.resource,F=q.children.find(({name:B})=>/^changelog(\.txt|\.md|)$/i.test(B))?.resource),{identifier:K.identifier,type:K.type,isBuiltin:K.isBuiltin||!!K.metadata?.isBuiltin,location:K.location,manifest:K.manifest,targetPlatform:K.targetPlatform,validations:K.validations,isValid:K.isValid,readmeUrl:j,changelogUrl:F,publisherDisplayName:K.metadata?.publisherDisplayName||null,publisherId:K.metadata?.publisherId||null,isApplicationScoped:!!K.metadata?.isApplicationScoped,isMachineScoped:!!K.metadata?.isMachineScoped,isPreReleaseVersion:!!K.metadata?.isPreReleaseVersion,preRelease:!!K.metadata?.preRelease,installedTimestamp:K.metadata?.installedTimestamp,updated:!!K.metadata?.updated,pinned:!!K.metadata?.pinned}}async G(){const K=await this.getUninstalledExtensions();if(Object.keys(K).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(K));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),j=new Set;for(const B of q)K[s.$2o.create(B).toString()]||j.add(B.identifier.id.toLowerCase());try{const B=(0,s.$7o)(q,z=>z.identifier);await O.Promises.settled(B.map(async z=>{const _=z.sort((G,J)=>$.rcompare(G.manifest.version,J.manifest.version))[0];j.has(_.identifier.id.toLowerCase())||await this.j(await this.F(_))}))}catch(B){this.u.error(B)}const F=q.filter(B=>B.metadata&&K[s.$2o.create(B).toString()]);await Promise.allSettled(F.map(B=>this.removeUninstalledExtension(B)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let K;try{K=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,N.$Hk)(q)!==1&&this.u.error(q);return}if(K?.children)try{await Promise.allSettled(K.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(H))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(j){(0,N.$Hk)(j)!==1&&this.u.error(j)}}}))}catch{}}};e.$_p=W,e.$_p=W=pe([X(1,N.$qk),X(2,r.$Zp),X(3,t.$Vp),X(4,Q.$1k),X(5,M.$nj)],W);class V extends o.$Tp{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,b.$Pf)(this.options.operation)?this.l:this.options.operation}constructor(K,q,j,F,B,z,_,G,J){super(),this.identifier=K,this.source=q,this.options=j,this.m=F,this.n=B,this.o=z,this.p=_,this.q=G,this.s=J,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(K){const[q,j]=await this.x(K);return this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[q,j]],this.j),q}async u({zipPath:K,key:q,metadata:j},F,B){let z=await this.v(q);return z||(this.s.trace("Extracting extension...",q.id),z=await this.m.extractUserExtension(q,K,j,F,B),this.s.info("Extracting extension completed.",q.id)),z}async v(K){return await this.w(K)?(this.s.trace("Removing the extension from uninstalled list:",K.id),await this.m.setInstalled(K),this.s.info("Removed the extension from uninstalled list:",K.id),(await this.m.scanAllUserExtensions(!0)).find(F=>s.$2o.create(F).equals(K))):void 0}async w(K){return!!(await this.m.getUninstalledExtensions())[K.toString()]}}class ie extends V{constructor(K,q,j,F,B,z,_,G,J,te){super(q.identifier,q,j,B,z,_,G,J,te),this.y=q,this.z=F}async x(K){let q;try{q=await this.m.scanExtensions(null,this.options.profileLocation)}catch(_){throw new n.$zo(_,n.ExtensionManagementErrorCode.Scanning)}const j=q.find(_=>(0,s.$1o)(_.identifier,this.y.identifier));j&&(this.l=3);const F={id:this.y.identifier.uuid,publisherId:this.y.publisherId,publisherDisplayName:this.y.publisherDisplayName,targetPlatform:this.y.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||j?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||j?.isMachineScoped,isBuiltin:this.options.isBuiltin||j?.isBuiltin,isSystem:j?.type===0?!0:void 0,updated:!!j,isPreReleaseVersion:this.y.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??j?.pinned,preRelease:this.y.properties.isPreReleaseVersion||((0,b.$Of)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:j?.preRelease)};if(j?.manifest.version===this.y.version)try{return[await this.m.updateMetadata(j,F),F]}catch(_){throw new n.$zo((0,I.$0)(_),n.ExtensionManagementErrorCode.UpdateMetadata)}const{location:B,verificationStatus:z}=await this.z.download(this.y,this.l,!this.options.donotVerifySignature);try{return this.k=z,this.B(B.fsPath),[await this.u({zipPath:B.fsPath,key:s.$2o.create(this.y),metadata:F},!1,K),F]}catch(_){try{await this.z.delete(B)}catch(G){this.s.warn("Error while deleting the downloaded file",B.toString(),(0,I.$0)(G))}throw _}}async B(K){try{await(0,y.$7p)(K)}catch(q){throw new n.$zo((0,o.$Rp)(q).message,n.ExtensionManagementErrorCode.Invalid)}}}e.$aq=ie;class re extends V{constructor(K,q,j,F,B,z,_,G,J,te){super({id:(0,s.$6o)(K.publisher,K.name)},q,j,B,z,_,G,J,te),this.y=K,this.z=q,this.A=F}async h(K){const q=await super.h(K);return this.D(q,K),q}async x(K){const q=new s.$2o(this.identifier,this.y.version),F=(await this.m.scanExtensions(1,this.options.profileLocation)).find(_=>(0,s.$1o)(this.identifier,_.identifier)),B={isApplicationScoped:this.options.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||F?.isMachineScoped,isBuiltin:this.options.isBuiltin||F?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??F?.pinned};if(F)if(this.l=3,q.equals(new s.$2o(F.identifier,F.manifest.version)))try{await this.m.removeExtension(F,"existing")}catch{throw new Error(c.localize(7,null,this.y.displayName||this.y.name))}else!this.options.profileLocation&&$.gt(F.manifest.version,this.y.version)&&await this.m.setUninstalled(F);else{const _=await this.v(q);if(_)try{await this.m.removeExtension(_,"existing")}catch{throw new Error(c.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:m.$kc(this.z.fsPath),key:q,metadata:B},!0,K),B]}async D(K,q){try{let[j]=await this.A.getExtensions([{id:K.identifier.id,version:K.manifest.version}],q);if(j||([j]=await this.A.getExtensions([{id:K.identifier.id}],q)),j){const F={id:j.identifier.uuid,publisherDisplayName:j.publisherDisplayName,publisherId:j.publisherId,isPreReleaseVersion:j.properties.isPreReleaseVersion,preRelease:j.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(K,F,this.options.profileLocation)}}catch{}}}class ee extends o.$Tp{constructor(K,q,j){super(),this.extension=K,this.j=q,this.k=j}async h(K){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(le[246],he([0,1,8,18,28,22,51,11,15,10]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BO=void 0;let C=class extends I.$Wp{constructor(m,l,$,b,w,h){super(g.URI.file(m.extensionsPath),l,$,b,w,h)}};e.$BO=C,e.$BO=C=pe([X(0,k.$bi),X(1,P.$qk),X(2,L.$3k),X(3,D.$1k),X(4,A.$ul),X(5,O.$nj)],C)}),define(le[247],he([0,1,10,15,51,82,11,4,8,24,28,18]),function(se,e,O,L,D,A,I,P,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$i_b=void 0;let m=class extends A.$4p{constructor($,b,w,h,f,d,c,v){super(O.URI.file(f.builtinExtensionsPath),O.URI.file(f.extensionsPath),f.userHome,$.defaultProfile,$,b,w,h,f,d,c,v)}};e.$i_b=m,e.$i_b=m=pe([X(0,S.$3k),X(1,D.$Vp),X(2,I.$qk),X(3,k.$nj),X(4,L.$bi),X(5,g.$Fj),X(6,C.$1k),X(7,P.$5h)],m)}),define(le[19],he([0,1,6,3,2,100,12,69,4,18]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$up=e.$tp=e.$sp=void 0,e.$sp="__$__isNewStorageMarker",e.$tp="__$__targetStorageMarker",e.$up=(0,k.$6h)("storageService");var C;(function(f){f[f.NONE=0]="NONE",f[f.SHUTDOWN=1]="SHUTDOWN"})(C||(e.WillSaveStateReason=C={}));var S;(function(f){f[f.APPLICATION=-1]="APPLICATION",f[f.PROFILE=0]="PROFILE",f[f.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var m;(function(f){f[f.USER=0]="USER",f[f.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function l(f){const d=f.get(e.$tp);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.$vp=l;class $ extends D.$Tc{static{this.a=60*1e3}constructor(d={flushInterval:$.a}){super(),this.m=d,this.b=this.B(new L.$Yd),this.c=this.B(new L.$Yd),this.onDidChangeTarget=this.c.event,this.f=this.B(new L.$Vd),this.onWillSaveState=this.f.event,this.h=this.B(new O.$fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new D.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(d,c,v){return L.Event.filter(this.b.event,i=>i.scope===d&&(c===void 0||i.key===c),v)}n(){this.j.value=(0,O.$jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,D.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,A.mark)("code/willInitStorage");try{await this.O()}finally{(0,A.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(d,c){const{key:v,external:i}=c;if(v===e.$tp){switch(d){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:v,target:this.J(d)[v],external:i})}w(d){this.f.fire({reason:d})}get(d,c,v){return this.P(c)?.get(d,v)}getBoolean(d,c,v){return this.P(c)?.getBoolean(d,v)}getNumber(d,c,v){return this.P(c)?.getNumber(d,v)}getObject(d,c,v){return this.P(c)?.getObject(d,v)}storeAll(d,c){this.y(()=>{for(const v of d)this.store(v.key,v.value,v.scope,v.target,c)})}store(d,c,v,i,o=!1){if((0,I.$Rf)(c)){this.remove(d,v,o);return}this.y(()=>{this.z(d,v,i),this.P(v)?.set(d,c,o)})}remove(d,c,v=!1){this.y(()=>{this.z(d,c,void 0),this.P(c)?.delete(d,v)})}y(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,c){const v=[],i=this.J(d);for(const o of Object.keys(i))i[o]===c&&v.push(o);return v}z(d,c,v,i=!1){const o=this.J(c);typeof v=="number"?o[d]!==v&&(o[d]=v,this.P(c)?.set(e.$tp,JSON.stringify(o),i)):typeof o[d]=="number"&&(delete o[d],this.P(c)?.set(e.$tp,JSON.stringify(o),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(d){switch(d){case-1:return this.I;case 0:return this.G;default:return this.D}}L(d){const c=this.P(d);return c?l(c):Object.create(null)}isNew(d){return this.getBoolean(e.$sp,d)===!0}async flush(d=C.NONE){this.f.fire({reason:d});const c=this.P(-1),v=this.P(0),i=this.P(1);switch(d){case C.NONE:await O.Promises.settled([c?.whenFlushed()??Promise.resolve(),v?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case C.SHUTDOWN:await O.Promises.settled([c?.flush(0)??Promise.resolve(),v?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,v=this.P(1)?.items??new Map;return h(d,c,v,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(d){return await this.flush(),this.P(d)?.optimize()}async switch(d,c){return this.w(C.NONE),(0,g.$2k)(d)?this.R(d,c):this.S(d,c)}M(d,c){return!(d.id===c.id||b(c)&&b(d))}N(d,c,v){this.y(()=>{const i=new Set;for(const[o,n]of d)i.add(o),c.get(o)!==n&&this.u(v,{key:o,external:!0});for(const[o]of c.items)i.has(o)||this.u(v,{key:o,external:!0})})}}e.$wp=$;function b(f){return f.isDefault||!!f.useDefaultFlags?.globalState}e.$xp=b;class w extends ${constructor(){super(),this.U=this.B(new P.$qp(new P.$rp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$qp(new P.$rp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$qp(new P.$rp,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(d=>this.u(1,d))),this.B(this.W.onDidChangeStorage(d=>this.u(0,d))),this.B(this.U.onDidChangeStorage(d=>this.u(-1,d)))}P(d){switch(d){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(d){return!1}}e.$yp=w;async function h(f,d,c,v,i,o){const n=R=>{try{return JSON.parse(R)}catch{return R}},s=new Map,t=new Map;f.forEach((R,N)=>{s.set(N,R),t.set(N,n(R))});const r=new Map,a=new Map;d.forEach((R,N)=>{r.set(N,R),a.set(N,n(R))});const E=new Map,y=new Map;c.forEach((R,N)=>{E.set(N,R),y.set(N,n(R))}),console.group(v!==i?`Storage: Application (path: ${v})`:`Storage: Application & Profile (path: ${v}, default profile)`);const u=[];if(s.forEach((R,N)=>{u.push({key:N,value:R})}),console.table(u),console.groupEnd(),console.log(t),v!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const R=[];r.forEach((N,T)=>{R.push({key:T,value:N})}),console.table(R),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${o})`);const p=[];E.forEach((R,N)=>{p.push({key:N,value:R})}),console.table(p),console.groupEnd(),console.log(y)}e.$zp=h}),define(le[114],he([0,1,3,2,12,29,33,19]),function(se,e,O,L,D,A,I,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BFb=e.$AFb=void 0;let k=class extends L.$Tc{constructor(S,m){super(),this.a=new O.$Vd,this.onDidChangeEnablement=this.a.event,this.b=this.B(new g(S)),this.B(this.b.onDidChange(l=>this.a.fire({extensions:l,source:"storage"}))),this.B(m.onDidInstallExtensions(l=>l.forEach(({local:$,operation:b})=>{$&&b===4&&this.f($.identifier)})))}async enableExtension(S,m){return this.f(S)?(this.a.fire({extensions:[S],source:m}),!0):!1}async disableExtension(S,m){return this.c(S)?(this.a.fire({extensions:[S],source:m}),!0):!1}getDisabledExtensions(){return this.h(A.$Co)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(S){const m=this.getDisabledExtensions();return m.every(l=>!(0,I.$1o)(l,S))?(m.push(S),this.g(m),!0):!1}f(S){const m=this.getDisabledExtensions();for(let l=0;l<m.length;l++){const $=m[l];if((0,I.$1o)($,S))return m.splice(l,1),this.g(m),!0}return!1}g(S){this.j(A.$Co,S)}h(S){return this.b.get(S,0)}j(S,m){this.b.set(S,m,0)}};e.$AFb=k,e.$AFb=k=pe([X(0,P.$up),X(1,A.$Bo)],k);class g extends L.$Tc{constructor(S){super(),this.c=S,this.a=Object.create(null),this.b=this.B(new O.$Vd),this.onDidChange=this.b.event,this.B(S.onDidChangeValue(0,void 0,this.B(new L.$Sc))(m=>this.f(m)))}get(S,m){let l;return m===0?((0,D.$Rf)(this.a[S])&&(this.a[S]=this.g(S,m)),l=this.a[S]):l=this.g(S,m),JSON.parse(l)}set(S,m,l){const $=JSON.stringify(m.map(({id:w,uuid:h})=>({id:w,uuid:h})));this.g(S,l)!==$&&(l===0&&(m.length?this.a[S]=$:delete this.a[S]),this.h(S,m.length?$:void 0,l))}f(S){if(!(0,D.$Rf)(this.a[S.key])&&this.g(S.key,S.scope)!==this.a[S.key]){const l=this.get(S.key,S.scope);delete this.a[S.key];const $=this.get(S.key,S.scope),b=l.filter(h=>!$.some(f=>(0,I.$1o)(h,f))),w=$.filter(h=>!l.some(f=>(0,I.$1o)(f,h)));(b.length||w.length)&&this.b.fire([...b,...w])}}g(S,m){return this.c.get(S,m,"[]")}h(S,m,l){m?this.c.store(S,m,l,1):this.c.remove(S,l)}}e.$BFb=g}),define(le[248],he([0,1,17,26,7,5,37,12,10,21,15,29,33,71,11,8,24,59,227,19,22,63]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ep=e.$Dp=e.$Cp=void 0;const i=A.$o?"web":(0,S.$uo)(A.$u,I.$ec),o="X-Market-Search-Activity-Id";var n;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(n||(n={}));function s(...F){return String(F.reduce((B,z)=>B|z,0))}var t;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},a={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:n.None,criteria:[],assetTypes:[]};class u{constructor(B=y){this.d=B}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(B,z=this.d.pageSize){return new u({...this.d,pageNumber:B,pageSize:z})}withFilter(B,...z){const _=[...this.d.criteria,...z.length?z.map(G=>({filterType:B,value:G})):[{filterType:B}]];return new u({...this.d,criteria:_})}withSortBy(B){return new u({...this.d,sortBy:B})}withSortOrder(B){return new u({...this.d,sortOrder:B})}withFlags(...B){return new u({...this.d,flags:B.reduce((z,_)=>z|_,0)})}withAssetTypes(...B){return new u({...this.d,assetTypes:B})}withSource(B){return new u({...this.d,source:B})}get raw(){const{criteria:B,pageNumber:z,pageSize:_,sortBy:G,sortOrder:J,flags:te,assetTypes:ne}=this.d;return{filters:[{criteria:B,pageNumber:z,pageSize:_,sortBy:G,sortOrder:J}],assetTypes:ne,flags:te}}get searchText(){const B=this.d.criteria.filter(z=>z.filterType===t.SearchText)[0];return B&&B.value?B.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(B=>String(B.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function p(F,B){const z=(F||[]).filter(_=>_.statisticName===B)[0];return z?z.value:0}function R(F){const B="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(_=>_.assetType.indexOf(B)===0).reduce((_,G)=>{const J=M(F,G.assetType);return J&&_.push([G.assetType.substring(B.length),J]),_},[])}function N(F){if(F.properties){const B=F.properties.filter(G=>G.key===r.Repository),z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),_=B.filter(G=>z.test(G.value))[0];return _?{uri:_.value,fallbackUri:_.value}:null}return M(F,r.Repository)}function T(F){return{uri:`${F.fallbackAssetUri}/${r.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${r.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function M(F,B){return F.files.filter(_=>_.assetType===B)[0]?{uri:`${F.assetUri}/${B}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${B}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function U(F,B){const z=F.properties?F.properties.filter(G=>G.key===B):[],_=z.length>0&&z[0].value;return _?_.split(",").map(G=>(0,m.$5o)(G)):[]}function Y(F){const B=F.properties?F.properties.filter(z=>z.key===a.Engine):[];return B.length>0&&B[0].value||""}function Q(F){const B=F.properties?F.properties.filter(z=>z.key===a.PreRelease):[];return B.length>0&&B[0].value==="true"}function x(F){const B=F.properties?F.properties.filter(_=>_.key===a.LocalizedLanguages):[],z=B.length>0&&B[0].value||"";return z?z.split(","):[]}function H(F){return F.properties?.find(B=>B.key===a.SponsorLink)?.value}function Z(F){return F.properties?.find(B=>B.key===a.SupportLink)?.value}function W(F){return F.indexOf("preview")!==-1}function V(F){return F.targetPlatform?(0,S.$to)(F.targetPlatform):"undefined"}function ie(F){const B=(0,O.$Mb)(F.versions.map(V)),z=!!F.tags?.includes(S.$oo),_=B.indexOf("web");return z?_===-1&&B.push("web"):_!==-1&&B.splice(_,1),B}function re(F,B){for(let z=0;z<F.length;z++){const _=F[z];if(_.version===F[z-1]?.version){let G=z;if(V(_)===B)for(;G>0&&F[G-1].version===_.version;)G--;G!==z&&(F.splice(z,1),F.splice(G,0,_))}}return F}e.$Cp=re;function ee(F,B,z){F.telemetryData={index:B,querySource:z,queryActivityId:F.queryContext?.[o]}}function ae(F,B,z,_){const G=F.versions[0],J={manifest:M(B,r.Manifest),readme:M(B,r.Details),changelog:M(B,r.Changelog),license:M(B,r.License),repository:N(B),download:T(B),icon:M(B,r.Icon),signature:M(B,r.Signature),coreTranslations:R(B)};return{identifier:{id:(0,m.$6o)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:B.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:H(G),description:F.shortDescription||"",installCount:p(F.statistics,"install"),rating:p(F.statistics,"averagerating"),ratingCount:p(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:z,assets:J,properties:{dependencies:U(B,a.Dependency),extensionPack:U(B,a.ExtensionPack),engine:Y(B),localizedLanguages:x(B),targetPlatform:V(B),isPreReleaseVersion:Q(B)},hasPreReleaseVersion:Q(G),hasReleaseVersion:!0,preview:W(F.flags),isSigned:!!J.signature,queryContext:_,supportLink:Z(G)}}let K=class{constructor(B,z,_,G,J,te,ne,ce){this.k=z,this.l=_,this.n=G,this.o=J,this.q=te,this.u=ne,this.w=ce;const de=ne.extensionsGallery,$e=de?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=$e?de.servicePPEUrl:de?.serviceUrl,this.g=$e?void 0:de?.searchUrl,this.h=de?.controlUrl,this.j=(0,f.$Bp)(ne.version,ne,this.n,this.w,this.q,B,this.o)}x(B=""){return`${this.d}${B}`}isEnabled(){return!!this.d}async getExtensions(B,z,_){const G=L.CancellationToken.isCancellationToken(z)?{}:z,J=L.CancellationToken.isCancellationToken(z)?z:_,te=[],ne=[],ce=[],de=[];let $e=!0;for(const Re of B){Re.uuid?ne.push(Re.uuid):te.push(Re.id);const Oe=!!(Re.version||Re.preRelease);ce.push({id:Re.id,uuid:Re.uuid,includePreRelease:Oe}),Re.version&&de.push({id:Re.id,uuid:Re.uuid,version:Re.version}),$e=$e&&!!Re.hasPreRelease&&!Oe}if(!ne.length&&!te.length)return[];let me=new u().withPage(1,B.length);ne.length&&(me=me.withFilter(t.ExtensionId,...ne)),te.length&&(me=me.withFilter(t.ExtensionName,...te)),(G.queryAllVersions||$e)&&(me=me.withFlags(me.flags,n.IncludeVersions)),G.source&&(me=me.withSource(G.source));const{extensions:Ee}=await this.z(me,{targetPlatform:G.targetPlatform??i,includePreRelease:ce,versions:de,compatible:!!G.compatible},J);return G.source&&Ee.forEach((Re,Oe)=>ee(Re,Oe,G.source)),Ee}async getCompatibleExtension(B,z,_){if((0,S.$vo)(B.allTargetPlatforms,_))return null;if(await this.isExtensionCompatible(B,z,_))return B;const G=new u().withFlags(n.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,B.identifier.uuid),{extensions:J}=await this.z(G,{targetPlatform:_,compatible:!0,includePreRelease:z},L.CancellationToken.None);return J[0]||null}async isExtensionCompatible(B,z,_){if(!(0,S.$wo)(B.properties.targetPlatform,B.allTargetPlatforms,_)||!z&&B.properties.isPreReleaseVersion)return!1;let G=B.properties.engine;if(!G){const J=await this.getManifest(B,L.CancellationToken.None);if(!J)throw new Error("Manifest was not found");G=J.engines.vscode}return(0,l.$gp)(G,this.u.version,this.u.date)}async y(B,z,_,G,J){if(!(0,S.$wo)(V(B),G,J)||z!=="any"&&Q(B)!==(z==="prerelease"))return!1;if(_)try{const te=await this.E(B);if(!(0,l.$gp)(te,this.u.version,this.u.date))return!1}catch(te){return this.l.error(`Error while getting the engine for the version ${B.version}.`,(0,D.$0)(te)),!1}return!0}async query(B,z){let _=B.text||"";const G=B.pageSize??50;let J=new u().withPage(1,G);_?(_=_.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,me,Ee)=>(J=J.withFilter(t.Category,Ee||me),"")),_=_.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,($e,me,Ee)=>(J=J.withFilter(t.Tag,Ee||me),"")),_=_.replace(/\bfeatured(\s+|\b|$)/g,()=>(J=J.withFilter(t.Featured),"")),_=_.trim(),_&&(_=_.length<200?_:_.substring(0,200),J=J.withFilter(t.SearchText,_)),J=J.withSortBy(0)):B.ids?J=J.withFilter(t.ExtensionId,...B.ids):B.names?J=J.withFilter(t.ExtensionName,...B.names):J=J.withSortBy(4),typeof B.sortBy=="number"&&(J=J.withSortBy(B.sortBy)),typeof B.sortOrder=="number"&&(J=J.withSortOrder(B.sortOrder)),B.source&&(J=J.withSource(B.source));const te=async($e,me)=>{const{extensions:Ee,total:Re}=await this.z($e,{targetPlatform:i,compatible:!1,includePreRelease:!!B.includePreRelease},me);return Ee.forEach((Oe,Ne)=>ee(Oe,($e.pageNumber-1)*$e.pageSize+Ne,B.source)),{extensions:Ee,total:Re}},{extensions:ne,total:ce}=await te(J,z),de=async($e,me)=>{if(me.isCancellationRequested)throw new D.$5;const{extensions:Ee}=await te(J.withPage($e+1),me);return Ee};return{firstPage:ne,total:ce,pageSize:J.pageSize,getPage:de}}async z(B,z,_){const G=B.flags;B.flags&n.IncludeLatestVersionOnly&&B.flags&n.IncludeVersions&&(B=B.withFlags(B.flags&~n.IncludeVersions,n.IncludeLatestVersionOnly)),!(B.flags&n.IncludeLatestVersionOnly)&&!(B.flags&n.IncludeVersions)&&(B=B.withFlags(B.flags,n.IncludeLatestVersionOnly)),z.versions?.length&&(B=B.withFlags(B.flags&~n.IncludeLatestVersionOnly,n.IncludeVersions)),B=B.withFlags(B.flags,n.IncludeAssetUri,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeStatistics,n.IncludeVersionProperties);const{galleryExtensions:J,total:te,context:ne}=await this.B(B,_);if(!(B.flags&n.IncludeLatestVersionOnly)){const me=[];for(const Ee of J){const Re=await this.A(Ee,z,ne);Re&&me.push(Re)}return{extensions:me,total:te}}const de=[],$e=new Map;for(let me=0;me<J.length;me++){const Ee=J[me],Re={id:(0,m.$6o)(Ee.publisher.publisherName,Ee.extensionName),uuid:Ee.extensionId},Oe=(0,P.$Of)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(ue=>(0,m.$1o)(ue,Re))?.includePreRelease;if(z.compatible&&(0,S.$vo)(ie(Ee),z.targetPlatform))continue;const Ne=await this.A(Ee,z,ne);!Ne||Ne.properties.isPreReleaseVersion&&(!Oe||!Ne.hasReleaseVersion)||!Ne.properties.isPreReleaseVersion&&Ne.properties.targetPlatform!==z.targetPlatform&&Ne.hasPreReleaseVersion?$e.set(Ee.extensionId,me):de.push([me,Ne])}if($e.size){const me=new v.$Rd,Ee=new u().withFlags(G&~n.IncludeLatestVersionOnly,n.IncludeVersions).withPage(1,$e.size).withFilter(t.ExtensionId,...$e.keys()),{extensions:Re}=await this.z(Ee,z,_);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:$e.size});for(const Oe of Re){const Ne=$e.get(Oe.identifier.uuid);de.push([Ne,Oe])}}return{extensions:de.sort((me,Ee)=>me[0]-Ee[0]).map(([,me])=>me),total:te}}async A(B,z,_){const G={id:(0,m.$6o)(B.publisher.publisherName,B.extensionName),uuid:B.extensionId},J=z.versions?.find(de=>(0,m.$1o)(de,G))?.version,te=(0,P.$Of)(z.includePreRelease)?z.includePreRelease:!!z.includePreRelease.find(de=>(0,m.$1o)(de,G))?.includePreRelease,ne=ie(B),ce=re(B.versions,z.targetPlatform);if(z.compatible&&(0,S.$vo)(ne,z.targetPlatform))return null;for(let de=0;de<ce.length;de++){const $e=ce[de];if(!(J&&$e.version!==J)){if(await this.y($e,te?"any":"release",z.compatible,ne,z.targetPlatform))return ae(B,$e,ne,_);if(J&&$e.version===J)return null}}return J||z.compatible?null:ae(B,B.versions[0],ne)}async B(B,z){if(!this.isEnabled())throw new Error("No extension gallery service configured.");B=B.withFlags(B.flags,n.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,s(n.Unpublished));const _=await this.j,G=JSON.stringify(B.raw),J={..._,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},te=new v.$Rd;let ne,ce,de=0;try{if(ne=await this.k.request({type:"POST",url:this.g&&B.criteria.some(me=>me.filterType===t.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:J},z),ne.res.statusCode&&ne.res.statusCode>=400&&ne.res.statusCode<500)return{galleryExtensions:[],total:de};const $e=await(0,h.$np)(ne);if($e){const me=$e.results[0],Ee=me.extensions,Re=me.resultMetadata&&me.resultMetadata.filter(Oe=>Oe.metadataType==="ResultCount")[0];return de=Re&&Re.metadataItems.filter(Oe=>Oe.name==="TotalCount")[0].count||0,{galleryExtensions:Ee,total:de,context:{[o]:ne.res.headers.activityid}}}return{galleryExtensions:[],total:de}}catch($e){const me=(0,D.$4)($e)?S.ExtensionGalleryErrorCode.Cancelled:(0,D.$0)($e).startsWith("XHR timeout")?S.ExtensionGalleryErrorCode.Timeout:S.ExtensionGalleryErrorCode.Failed;throw ce=new S.$Ao((0,D.$0)($e),me),ce}finally{this.o.publicLog2("galleryService:query",{...B.telemetryData,requestBodySize:String(G.length),duration:te.elapsed(),success:!!ne&&(0,h.$jp)(ne),responseBodySize:ne?.res.headers["Content-Length"],statusCode:ne?String(ne.res.statusCode):void 0,errorCode:ce?.code,count:String(de)})}}async reportStatistic(B,z,_,G){if(!this.isEnabled())return;const J=A.$o?this.x(`/itemName/${B}.${z}/version/${_}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${B}/extensions/${z}/${_}/stats?statType=${G}`),te=A.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:te};try{await this.k.request({type:"POST",url:J,headers:ce},L.CancellationToken.None)}catch{}}async download(B,z,_){this.l.trace("ExtensionGalleryService#download",B.identifier.id);const G=(0,m.$9o)(B),J=new Date().getTime(),te=me=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:me}),ne=_===2?"install":_===3?"update":"",ce=ne?{uri:`${B.assets.download.uri}${k.URI.parse(B.assets.download.uri).query?"&":"?"}${ne}=true`,fallbackUri:`${B.assets.download.fallbackUri}${k.URI.parse(B.assets.download.fallbackUri).query?"&":"?"}${ne}=true`}:B.assets.download,de=B.queryContext?.[o]?{[o]:B.queryContext[o]}:void 0,$e=await this.D(ce,de?{headers:de}:void 0);await this.q.writeFile(z,$e.stream),te(new Date().getTime()-J)}async downloadSignatureArchive(B,z){if(!B.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",B.identifier.id);const _=await this.D(B.assets.signature);await this.q.writeFile(z,_.stream)}async getReadme(B,z){if(B.assets.readme){const _=await this.D(B.assets.readme,{},z);return await(0,h.$mp)(_)||""}return""}async getManifest(B,z){if(B.assets.manifest){const _=await this.D(B.assets.manifest,{},z),G=await(0,h.$mp)(_);return G?JSON.parse(G):null}return null}async C(B,z){const _=M(B,r.Manifest);if(!_)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},J=await this.D(_,{headers:G});return await(0,h.$np)(J)}async getCoreTranslation(B,z){const _=B.assets.coreTranslations.filter(G=>G[0]===z.toUpperCase())[0];if(_){const G=await this.D(_[1]),J=await(0,h.$mp)(G);return J?JSON.parse(J):null}return null}async getChangelog(B,z){if(B.assets.changelog){const _=await this.D(B.assets.changelog,{},z);return await(0,h.$mp)(_)||""}return""}async getAllCompatibleVersions(B,z,_){let G=new u().withFlags(n.IncludeVersions,n.IncludeCategoryAndTags,n.IncludeFiles,n.IncludeVersionProperties).withPage(1,1);B.identifier.uuid?G=G.withFilter(t.ExtensionId,B.identifier.uuid):G=G.withFilter(t.ExtensionName,B.identifier.id);const{galleryExtensions:J}=await this.B(G,L.CancellationToken.None);if(!J.length)return[];const te=ie(J[0]);if((0,S.$vo)(te,_))return[];const ne=[];await Promise.all(J[0].versions.map(async $e=>{try{await this.y($e,z?"any":"release",!0,te,_)&&ne.push($e)}catch{}}));const ce=[],de=new Set;for(const $e of re(ne,_))de.has($e.version)||(de.add($e.version),ce.push({version:$e.version,date:$e.lastUpdated,isPreReleaseVersion:Q($e)}));return ce}async D(B,z={},_=L.CancellationToken.None){const G=await this.j,J={type:"GET"},te={...G,...z.headers||{}};z={...z,...J,headers:te};const ne=B.uri,ce=B.fallbackUri,de={...z,url:ne};try{const $e=await this.k.request(de,_);if($e.res.statusCode===200)return $e;const me=await(0,h.$mp)($e);throw new Error(`Expected 200, got back ${$e.res.statusCode} instead.

${me}`)}catch($e){if((0,D.$4)($e))throw $e;const me=(0,D.$0)($e);this.o.publicLog2("galleryService:cdnFallback",{url:ne,message:me});const Ee={...z,url:ce};return this.k.request(Ee,_)}}async E(B){let z=Y(B);if(!z){const _=await this.C(B,L.CancellationToken.None);if(!_)throw new Error("Manifest was not found");z=_.engines.vscode}return z}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const B=await this.k.request({type:"GET",url:this.h},L.CancellationToken.None);if(B.res.statusCode!==200)throw new Error("Could not get extensions report.");const z=await(0,h.$np)(B),_=[],G={},J=[];if(z){for(const te of z.malicious)_.push({id:te});if(z.migrateToPreRelease)for(const[te,ne]of Object.entries(z.migrateToPreRelease))(!ne.engine||(0,l.$gp)(ne.engine,this.u.version,this.u.date))&&(G[te.toLowerCase()]={disallowInstall:!0,extension:{id:ne.id,displayName:ne.displayName,autoMigrate:{storage:!!ne.migrateStorage},preRelease:!0}});if(z.deprecated)for(const[te,ne]of Object.entries(z.deprecated))ne&&(G[te.toLowerCase()]=(0,P.$Of)(ne)?{}:ne);if(z.search)for(const te of z.search)J.push(te)}return{malicious:_,deprecated:G,search:J}}};K=pe([X(1,h.$hp),X(2,b.$nj),X(3,C.$ai),X(4,c.$ul),X(5,$.$qk),X(6,w.$Fj),X(7,g.$zi)],K);let q=class extends K{constructor(B,z,_,G,J,te,ne,ce){super(B,z,_,G,J,te,ne,ce)}};e.$Dp=q,e.$Dp=q=pe([X(0,d.$up),X(1,h.$hp),X(2,b.$nj),X(3,C.$ai),X(4,c.$ul),X(5,$.$qk),X(6,w.$Fj),X(7,g.$zi)],q);let j=class extends K{constructor(B,z,_,G,J,te,ne){super(void 0,B,z,_,G,J,te,ne)}};e.$Ep=j,e.$Ep=j=pe([X(0,h.$hp),X(1,b.$nj),X(2,C.$ai),X(3,c.$ul),X(4,$.$qk),X(5,w.$Fj),X(6,g.$zi)],j)}),define(le[83],he([0,1,4,3,2,19,33,24,17,8,12]),function(se,e,O,L,D,A,I,P,k,g,C){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$nv=e.$mv=void 0,e.$mv=(0,O.$6h)("IExtensionStorageService");const m=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let l=class extends D.$Tc{static{S=this}static{this.a=512*1024}static b(b){return`extensionKeys/${(0,I.$5o)(b.id)}@${b.version}`}static c(b){const w=m.exec(b);if(w&&w[1])return{id:w[1],version:w[2]}}static async removeOutdatedExtensionVersions(b,w){const h=await b.getInstalled(),f=[];for(const[d,c]of S.f(w)){const v=h.find(i=>(0,I.$1o)(i.identifier,{id:d}))?.manifest.version;for(const i of c)v!==i&&f.push(S.b({id:d,version:i}))}for(const d of f)w.remove(d,0)}static f(b){const w=new Map,h=b.keys(0,1);for(const f of h){const d=S.c(f);if(d){let c=w.get(d.id.toLowerCase());c||w.set(d.id.toLowerCase(),c=[]),c.push(d.version)}}return w}constructor(b,w,h){super(),this.j=b,this.m=w,this.n=h,this.g=this.B(new L.$Vd),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=S.f(b),this.B(this.j.onDidChangeValue(0,void 0,this.B(new D.$Sc))(f=>this.r(f)))}r(b){if(this.h.has(b.key.toLowerCase())){this.g.fire();return}const w=S.c(b.key);if(w){if(this.j.get(b.key,0)===void 0)this.h.delete(w.id.toLowerCase());else{let h=this.h.get(w.id.toLowerCase());h||this.h.set(w.id.toLowerCase(),h=[]),h.push(w.version),this.g.fire()}return}}s(b){if((0,C.$If)(b))return b;const w=b.manifest?b.manifest.publisher:b.publisher,h=b.manifest?b.manifest.name:b.name;return(0,I.$4o)(w,h)}getExtensionState(b,w){const h=this.s(b),f=this.getExtensionStateRaw(b,w);if(f)try{return JSON.parse(f)}catch(d){this.n.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${h}, global: ${w}): ${d}`)}}getExtensionStateRaw(b,w){const h=this.s(b),f=this.j.get(h,w?0:1);return f&&f?.length>S.a&&this.n.warn(`[mainThreadStorage] large extension state detected (extensionId: ${h}, global: ${w}): ${f.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),f}setExtensionState(b,w,h){const f=this.s(b);w===void 0?this.j.remove(f,h?0:1):this.j.store(f,JSON.stringify(w),h?0:1,1)}setKeysForSync(b,w){this.j.store(S.b(b),JSON.stringify(w),0,1)}getKeysForSync(b){const w=this.m.extensionSyncedKeys?.[b.id.toLowerCase()],h=this.j.get(S.b(b),0),f=h?JSON.parse(h):void 0;return f&&w?(0,k.$Mb)([...f,...w]):f||w}addToMigrationList(b,w){if(b!==w){const h=this.t.filter(f=>!f.includes(b)&&!f.includes(w));h.push([b,w]),this.t=h}}getSourceExtensionToMigrate(b){const w=this.t.find(([,h])=>b===h);return w?w[0]:void 0}get t(){const b=this.j.get("extensionStorage.migrationList",-1,"[]");try{const w=JSON.parse(b);if(Array.isArray(w))return w}catch{}return[]}set t(b){b.length?this.j.store("extensionStorage.migrationList",JSON.stringify(b),-1,1):this.j.remove("extensionStorage.migrationList",-1)}};e.$nv=l,e.$nv=l=S=pe([X(0,A.$up),X(1,P.$Fj),X(2,g.$nj)],l)}),define(le[249],he([0,1,2,29,83,224,113,8,19]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yac=void 0;let g=class extends O.$Tc{constructor(S,m,l,$,b,w){super(),S.cleanUp(),(0,A.$0Zb)(S,m,l,$,w),D.$nv.removeOutdatedExtensionVersions(S,b)}};e.$yac=g,e.$yac=g=pe([X(0,I.$0p),X(1,L.$yo),X(2,D.$mv),X(3,L.$Eo),X(4,k.$up),X(5,P.$nj)],g)}),define(le[250],he([0,1,29,11,24,15,97,57,19,22,223]),function(se,e,O,L,D,A,I,P,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fac=void 0;let S=class extends C.$T9b{constructor(l,$,b,w,h,f,d,c){super(l.userHome,h,$,b,w,f,d,c)}};e.$Fac=S,e.$Fac=S=pe([X(0,A.$bi),X(1,g.$ul),X(2,O.$Bo),X(3,k.$up),X(4,P.$w$b),X(5,I.$TZb),X(6,L.$qk),X(7,D.$Fj)],S)}),define(le[251],he([0,1,105,3,22,15,2,8,16,67,24,5,6,101,21,165,36,19,12,132,20]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bac=void 0;const v=[O.$uac,O.$vac],i="remoteTunnelSession",o="remoteTunnelIsService";let n=class extends I.$Tc{constructor(a,E,y,u,p,R,N){super(),this.y=a,this.z=E,this.C=y,this.D=R,this.F=N,this.f=new L.$Vd,this.onDidTokenFailed=this.f.event,this.g=new L.$Vd,this.onDidChangeTunnelStatus=this.g.event,this.h=new L.$Vd,this.onDidChangeMode=this.h.event,this.n=O.$sac,this.w=!1,this.I=(T,M)=>{M?this.j.error(T):this.j.info(T)},this.j=this.B(u.createLogger((0,c.$Hg)(y.logsHome,`${O.$wac}.log`),{id:O.$wac,name:O.$xac})),this.t=new m.$3g(100),this.B(this.j.onDidChangeLogLevel(T=>this.j.info("Log level changed to "+(0,P.$Cj)(T)))),this.B(p.onWillShutdown(()=>{this.r?.cancel(),this.r=void 0,this.dispose()})),this.B(R.onDidChangeConfiguration(T=>{v.some(M=>T.affectsConfiguration(M))&&this.t.trigger(()=>this.L())})),this.n=this.R(),this.s=O.TunnelStates.uninitialized}async getTunnelStatus(){return this.s}G(a){this.s=a,this.g.fire(a)}H(a){t(this.n,a)||(this.n=a,this.S(a),this.h.fire(this.n),a.active?(this.j.info(`Session updated: ${a.session.accountLabel} (${a.session.providerId}) (service=${a.asService})`),a.session.token&&this.j.info(`Session token updated: ${a.session.accountLabel} (${a.session.providerId})`)):this.j.info("Session reset"))}getMode(){return Promise.resolve(this.n)}async initialize(a){if(this.w)return this.s;this.w=!0,this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}J(){if(!this.u){let a;S.$j?a=this.C.appRoot:a=(0,k.$mc)((0,k.$mc)(this.C.appRoot)),this.u=(0,k.$jc)(a,"bin",`${this.z.tunnelApplicationName}${S.$i?".exe":""}`)}return this.u}async startTunnel(a){if(t(this.n,a)&&this.s.type!=="disconnected")return this.s;this.H(a);try{await this.t.trigger(()=>this.L())}catch(E){this.j.error(E)}return this.s}async stopTunnel(){if(this.r&&(this.r.cancel(),this.r=void 0),this.n.active){const a=this.n.asService;this.H(O.$sac);try{a&&this.O("uninstallService",["service","uninstall"])}catch(E){this.j.error(E)}}try{await this.O("stop",["kill"])}catch(a){this.j.error(a)}this.G(O.TunnelStates.disconnected())}async L(){this.y.publicLog2("remoteTunnel.enablement",{enabled:this.n.active,service:this.n.active&&this.n.asService}),this.r&&(this.r.cancel(),this.r=void 0);let a="",E=!1;const y=(M,U)=>{U?this.j.error(M):a+=M,!this.C.isBuilt&&M.startsWith("   Compiling")&&this.G(O.TunnelStates.connecting((0,b.localize)(0,null)))},u=this.O("status",["status"],y);this.r=u;try{if(await u,this.r!==u)return;let M;try{M=JSON.parse(a.trim().split(`
`).find(U=>U.startsWith("{")))}catch{this.j.error(`Could not parse status output: ${JSON.stringify(a.trim())}`),this.G(O.TunnelStates.disconnected());return}if(E=M.service_installed,this.j.info(M.tunnel?"Other tunnel running, attaching...":"No other tunnel running"),!M.tunnel&&!this.n.active){this.G(O.TunnelStates.disconnected());return}}catch(M){this.j.error(M),this.G(O.TunnelStates.disconnected());return}finally{this.r===u&&(this.r=void 0)}const p=this.n.active?this.n.session:void 0;if(p&&p.token){const M=p.token;this.G(O.TunnelStates.connecting((0,b.localize)(1,null,p.accountLabel,p.providerId)));const U=(Q,x)=>{Q=Q.replaceAll(M,"*".repeat(4)),y(Q,x)},Y=this.O("login",["user","login","--provider",p.providerId,"--access-token",M,"--log",(0,P.$Cj)(this.j.getLevel())],U);this.r=Y;try{if(await Y,this.r!==Y)return}catch(Q){this.j.error(Q),this.r=void 0,this.f.fire(p),this.G(O.TunnelStates.disconnected(p));return}}const R=this.Q();R?this.G(O.TunnelStates.connecting((0,b.localize)(2,null,R))):this.G(O.TunnelStates.connecting((0,b.localize)(3,null)));const N=["--accept-server-license-terms","--log",(0,P.$Cj)(this.j.getLevel())];R?N.push("--name",R):N.push("--random-name");let T=!1;return this.n.active&&this.n.asService&&!E&&(T=await this.M(N)===!1),this.N(p,N,T)}async M(a){let E;try{E=await this.O("serviceInstall",["service","install",...a])}catch(y){this.j.error(y),E=1}if(E!==0){const y=(0,b.localize)(4,null);return this.j.warn(y),this.G(O.TunnelStates.connecting(y)),!1}return!0}async N(a,E,y){E.push("--parent-process-id",String(process.pid)),this.P()&&E.push("--no-sleep");let u=!1;const p=this.O("tunnel",E,(R,N)=>{N?this.j.error(R):this.j.info(R),R.includes("Connected to an existing tunnel process")&&(u=!0);const T=R.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(T){const M={link:T[1],domain:T[2],tunnelName:T[4],isAttached:u};this.G(O.TunnelStates.connected(M,y))}else R.match(/error refreshing token/)&&(p.cancel(),this.f.fire(a),this.G(O.TunnelStates.disconnected(a)))});this.r=p,p.finally(()=>{p===this.r&&(this.j.info("tunnel process terminated"),this.r=void 0,this.n=O.$sac,this.G(O.TunnelStates.disconnected()))})}O(a,E,y=this.I){return(0,m.$Tg)(u=>new Promise((p,R)=>{u.isCancellationRequested&&p(-1);let N;const T=["ignore","pipe","pipe"];if(u.onCancellationRequested(()=>{N&&(this.j.info(`${a} terminating(${N.pid})`),N.kill())}),!this.C.isBuilt)y(`Building tunnel CLI from sources and run
`,!1),y(`${a} Spawning: cargo run -- tunnel ${E.join(" ")}
`,!1),N=(0,g.spawn)("cargo",["run","--","tunnel",...E],{cwd:(0,k.$jc)(this.C.appRoot,"cli"),stdio:T});else{y(`Running tunnel CLI
`,!1);const M=this.J();y(`${a} Spawning: ${M} tunnel ${E.join(" ")}
`,!1),N=(0,g.spawn)(M,["tunnel",...E],{cwd:(0,w.homedir)(),stdio:T})}N.stdout.pipe(new d.$wU(`
`)).on("data",M=>{if(N){const U=M.toString();y(U,!1)}}),N.stderr.pipe(new d.$wU(`
`)).on("data",M=>{if(N){const U=M.toString();y(U,!0)}}),N.on("exit",M=>{N&&(y(`${a} exit(${N.pid}): + ${M} `,!1),N=void 0,p(M||0))}),N.on("error",M=>{N&&(y(`${a} error(${N.pid}): + ${M} `,!0),N=void 0,R())})}))}async getTunnelName(){return this.Q()}P(){return!!this.D.getValue(O.$vac)}Q(){let a=this.D.getValue(O.$uac)||(0,w.hostname)();return a=a.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),a||void 0}R(){try{const a=this.F.get(i,-1),E=this.F.getBoolean(o,-1,!1);if(a){const y=JSON.parse(a);if(y&&(0,f.$If)(y.accountLabel)&&(0,f.$If)(y.sessionId)&&(0,f.$If)(y.providerId))return{active:!0,session:y,asService:E};this.j.error("Problems restoring session from storage, invalid format",y)}}catch(a){this.j.error("Problems restoring session from storage",a)}return O.$sac}S(a){if(a.active){const E={providerId:a.session.providerId,sessionId:a.session.sessionId,accountLabel:a.session.accountLabel};this.F.store(i,JSON.stringify(E),-1,1),this.F.store(o,a.asService,-1,1)}else this.F.remove(i,-1),this.F.remove(o,-1)}};e.$Bac=n,e.$Bac=n=pe([X(0,D.$ul),X(1,C.$Fj),X(2,A.$bi),X(3,P.$oj),X(4,l.$zac),X(5,$.$zi),X(6,h.$up)],n);function s(r,a){return r&&a?r.sessionId===a.sessionId&&r.providerId===a.providerId&&r.token===a.token:r===a}const t=(r,a)=>r.active!==a.active?!1:r.active&&a.active?r.asService===a.asService&&s(r.session,a.session):!0}),define(le[252],he([0,1,6,2,23,20,69,19,78,18]),function(se,e,O,L,D,A,I,P,k,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gac=void 0;class C extends P.$wp{constructor(m,l,$,b){super(),this.bb=m,this.cb=l,this.db=$,this.eb=b,this.s=this.cb.defaultProfile,this.U=this.fb(),this.W=this.cb.currentProfile,this.X=this.B(new L.$Sc),this.Y=this.gb(this.W),this.Z=this.bb?.id,this.$=this.B(new L.$Sc),this.ab=this.hb(this.bb)}fb(){const m=this.B(new k.$$Fb(this.db.getChannel("storage"))),l=this.B(new I.$qp(m));return this.B(l.onDidChangeStorage($=>this.u(-1,$))),l}gb(m){this.X.clear(),this.W=m;let l;if((0,P.$xp)(m))l=this.U;else{const $=this.X.add(new k.$_Fb(this.db.getChannel("storage"),m));l=this.X.add(new I.$qp($))}return this.X.add(l.onDidChangeStorage($=>this.u(0,$))),l}hb(m){this.$.clear(),this.Z=m?.id;let l;if(m){const $=this.$.add(new k.$aGb(this.db.getChannel("storage"),m));l=this.$.add(new I.$qp($)),this.$.add(l.onDidChangeStorage(b=>this.u(1,b)))}return l}async O(){await O.Promises.settled([this.U.init(),this.Y.init(),this.ab?.init()??Promise.resolve()])}P(m){switch(m){case-1:return this.U;case 0:return this.Y;default:return this.ab}}Q(m){switch(m){case-1:return this.s.globalStorageHome.with({scheme:D.Schemas.file}).fsPath;case 0:return this.W?.globalStorageHome.with({scheme:D.Schemas.file}).fsPath;default:return this.Z?`${(0,A.$Hg)(this.eb.workspaceStorageHome,this.Z,"state.vscdb").with({scheme:D.Schemas.file}).fsPath}`:void 0}}async close(){this.t(),this.w(P.WillSaveStateReason.SHUTDOWN),await O.Promises.settled([this.U.close(),this.Y.close(),this.ab?.close()??Promise.resolve()])}async R(m){if(!this.M(this.W,m))return;const l=this.Y,$=l.items;l!==this.U&&await l.close(),this.Y=this.gb(m),await this.Y.init(),this.N($,this.Y,0)}async S(m,l){const $=this.ab,b=$?.items??new Map;await $?.close(),this.ab=this.hb(m),await this.ab.init(),this.N(b,this.ab,1)}hasScope(m){return(0,g.$2k)(m)?this.W.id===m.id:this.Z===m.id}}e.$Gac=C}),define(le[253],he([0,1,3,2,18,92]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=void 0;class I{constructor(g,C){this.a=g,this.b=C}listen(g,C){const S=this.b(g);switch(C){case"onDidChangeProfiles":return O.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(l=>(0,A.$6m)({...l},S)),added:m.added.map(l=>(0,A.$6m)({...l},S)),removed:m.removed.map(l=>(0,A.$6m)({...l},S)),updated:m.updated.map(l=>(0,A.$6m)({...l},S))}))}throw new Error(`Invalid listen ${C}`)}async call(g,C,S){const m=this.b(g);switch(C){case"createProfile":{const l=await this.a.createProfile(S[0],S[1],S[2]);return(0,A.$6m)({...l},m)}case"updateProfile":{let l=(0,D.$4k)((0,A.$7m)(S[0],m),this.a.profilesHome.scheme);return l=await this.a.updateProfile(l,S[1]),(0,A.$6m)({...l},m)}case"removeProfile":{const l=(0,D.$4k)((0,A.$7m)(S[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(l)}}throw new Error(`Invalid call ${C}`)}}e.$IO=I;class P extends L.$Tc{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(g,C,S){super(),this.profilesHome=C,this.f=S,this.a=[],this.b=this.B(new O.$Vd),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=g.map(m=>(0,D.$4k)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const l=m.added.map(w=>(0,D.$4k)(w,this.profilesHome.scheme)),$=m.removed.map(w=>(0,D.$4k)(w,this.profilesHome.scheme)),b=m.updated.map(w=>(0,D.$4k)(w,this.profilesHome.scheme));this.a=m.all.map(w=>(0,D.$4k)(w,this.profilesHome.scheme)),this.b.fire({added:l,removed:$,updated:b,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(g){this.c=g}isEnabled(){return this.c}async createNamedProfile(g,C,S){const m=await this.f.call("createNamedProfile",[g,C,S]);return(0,D.$4k)(m,this.profilesHome.scheme)}async createProfile(g,C,S,m){const l=await this.f.call("createProfile",[g,C,S,m]);return(0,D.$4k)(l,this.profilesHome.scheme)}async createTransientProfile(g){const C=await this.f.call("createTransientProfile",[g]);return(0,D.$4k)(C,this.profilesHome.scheme)}async setProfileForWorkspace(g,C){await this.f.call("setProfileForWorkspace",[g,C])}removeProfile(g){return this.f.call("removeProfile",[g])}async updateProfile(g,C){const S=await this.f.call("updateProfile",[g,C]);return(0,D.$4k)(S,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.$JO=P}),define(le[60],he([0,1,2,69,4,19,3,78,18]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eGb=e.$dGb=e.$cGb=void 0,e.$cGb=(0,D.$6h)("IUserDataProfileStorageService");let g=class extends O.$Tc{constructor(l){super(),this.a=l}async readStorageData(l){return this.withProfileScopedStorageService(l,async $=>this.b($))}async updateStorageData(l,$,b){return this.withProfileScopedStorageService(l,async w=>this.c(w,$,b))}async withProfileScopedStorageService(l,$){if(this.a.hasScope(l))return $(this.a);const b=await this.g(l),w=new S(b);try{await w.initialize();const h=await $(w);return await w.flush(),h}finally{w.dispose(),await this.f(b)}}b(l){const $=new Map,b=w=>{for(const h of l.keys(0,w))$.set(h,{value:l.get(h,0),target:w})};return b(0),b(1),$}c(l,$,b){l.storeAll(Array.from($.entries()).map(([w,h])=>({key:w,value:h,scope:0,target:b})),!0)}async f(l){try{await l.close()}finally{(0,O.$Nc)(l)&&l.dispose()}}};e.$dGb=g,e.$dGb=g=pe([X(0,A.$up)],g);class C extends g{constructor(l,$,b,w){super(b),this.j=l;const h=l.getChannel("profileStorageListener"),f=this.B(new O.$Uc);this.h=this.B(new I.$Vd({onWillAddFirstListener:()=>{f.value=h.listen("onDidChange")(d=>{w.trace("profile storage changes",d),this.h.fire({targetChanges:d.targetChanges.map(c=>(0,k.$4k)(c,$.profilesHome.scheme)),valueChanges:d.valueChanges.map(c=>({...c,profile:(0,k.$4k)(c.profile,$.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>f.value=void 0})),this.onDidChange=this.h.event}async g(l){const $=this.j.getChannel("storage");return(0,A.$xp)(l)?new P.$$Fb($):new P.$_Fb($,l)}}e.$eGb=C;class S extends A.$wp{constructor(l){super({flushInterval:100}),this.s=this.B(new L.$qp(l))}O(){return this.s.init()}P(l){return l===0?this.s:void 0}Q(){}async R(){}async S(){}hasScope(){return!1}}}),define(le[254],he([0,1,19,8,18,56,60]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lac=void 0;let P=class extends I.$eGb{constructor(g,C,S,m){super(g,C,S,m)}};e.$lac=P,e.$lac=P=pe([X(0,A.$K_b),X(1,D.$3k),X(2,O.$up),X(3,L.$nj)],P)}),define(le[39],he([0,1,17,6,14,26,3,34,2,27,12,170,21,15,11,8,43,19,22,28,25,18]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dHb=e.$cHb=e.$bHb=e.$aHb=e.$_Gb=e.$$Gb=e.$0Gb=void 0;function i(E){return!!(E&&E.ref!==void 0&&typeof E.ref=="string"&&E.ref!==""&&E.syncData!==void 0&&(E.syncData===null||o(E.syncData)))}e.$0Gb=i;function o(E){return!!(E&&E.version!==void 0&&typeof E.version=="number"&&E.content!==void 0&&typeof E.content=="string"&&(Object.keys(E).length===2||Object.keys(E).length===3&&E.machineId!==void 0&&typeof E.machineId=="string"))}e.$$Gb=o;function n(E,y){return`${(0,g.$Af)(E)}${y.isDefault?"":` (${y.name})`}`}e.$_Gb=n;let s=class extends k.$Tc{get status(){return this.m}get conflicts(){return{...this.syncResource,conflicts:this.s}}constructor(y,u,p,R,N,T,M,U,Y,Q,x,H){super(),this.syncResource=y,this.collection=u,this.G=p,this.H=R,this.I=N,this.J=T,this.L=M,this.M=U,this.N=Y,this.O=Q,this.P=x,this.c=null,this.m="idle",this.n=this.B(new I.$Vd),this.onDidChangeStatus=this.n.event,this.s=[],this.t=this.B(new I.$Vd),this.onDidChangeConflicts=this.t.event,this.u=this.B(new L.$4g(50)),this.w=this.B(new I.$Vd),this.onDidChangeLocal=this.w.event,this.z=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.C=!1,this.F={},this.resource=this.syncResource.syncResource,this.D=n(y.syncResource,y.profile),this.h=H.extUri,this.f=this.h.joinPath(R.userDataSyncHome,...(0,c.$Inb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource)),this.g=this.h.joinPath(this.f,c.$4nb),this.y=(0,c.$Jnb)(y.profile.isDefault?void 0:y.profile.id,y.syncResource,R,this.h),this.j=(0,w.$Ap)(R,p,N)}Q(){this.u.trigger(()=>this.R())}async R(){if(this.status==="hasConflicts"){this.O.info(`${this.D}: In conflicts state and local change detected. Syncing again...`);const y=await this.c;this.c=null;const u=await this.Y(y.remoteUserData,y.lastSyncUserData,!0,this.ob());this.S(u)}else{this.O.trace(`${this.D}: Checking for local changes...`);const y=await this.getLastSyncUserData();(y?await this.ub(y):!0)&&this.w.fire()}}S(y){this.m!==y&&(this.m=y,this.n.fire(y))}async sync(y,u={}){await this.U(y,!0,this.ob(),u)}async preview(y,u,p={}){return this.U(y,!1,u,p)}async apply(y,u={}){try{this.F={...u};const p=await this.ab(y);return this.S(p),this.c}finally{this.F={}}}async U(y,u,p,R){try{if(this.F={...R},this.status==="hasConflicts")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.O.info(`${this.D}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.O.trace(`${this.D}: Started synchronizing ${this.resource.toLowerCase()}...`),this.S("syncing");let N="idle";try{const T=await this.getLastSyncUserData(),M=await this.X(y,T);return N=await this.Y(M,T,u,p),N==="hasConflicts"?this.O.info(`${this.D}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):N==="idle"&&this.O.trace(`${this.D}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.S(N)}}finally{this.F={}}}async replace(y){const u=this.kb(y);if(!u)return!1;await this.stop();try{this.O.trace(`${this.D}: Started resetting ${this.resource.toLowerCase()}...`),this.S("syncing");const p=await this.getLastSyncUserData(),R=await this.X(null,p),N=await this.W(R),T=await this.qb({ref:R.ref,syncData:u},p,N,this.ob(),A.CancellationToken.None),M=[];for(const U of T){const Y=await this.sb(U,U.remoteResource,void 0,A.CancellationToken.None),{remoteChange:Q}=await this.sb(U,U.previewResource,U.remoteContent,A.CancellationToken.None);M.push([U,{...Y,remoteChange:Q!==0?Q:2}])}await this.tb(R,p,M,!1),this.O.info(`${this.D}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.S("idle")}return!0}async W(y){const u=await this.j;return!!y.syncData?.machineId&&y.syncData.machineId===u}async X(y,u){if(u){const p=y?y[this.resource]:void 0;if(u.ref===p||p===void 0&&u.syncData===null)return u}return this.getRemoteUserData(u)}async Y(y,u,p,R){if(y.syncData&&y.syncData.version>this.pb)throw this.N.publicLog2("sync/incompatible",{source:this.resource}),new c.$Qnb((0,S.localize)(0,null,this.resource,this.pb,y.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.Z(y,u,p,R)}catch(N){if(N instanceof c.$Qnb)switch(N.code){case"LocalPreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize ${this.D} as there is a new local version available. Synchronizing again...`),this.Y(y,u,p,R);case"Conflict":case"PreconditionFailed":return this.O.info(`${this.D}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),y=await this.getRemoteUserData(null),u=await this.getLastSyncUserData(),this.Y(y,u,p,R)}throw N}}async Z(y,u,p,R){try{const N=await this.W(y),T=!N&&u===null&&this.gb()!==void 0,M=p&&!T;this.c||(this.c=(0,L.$Tg)(Y=>this.eb(y,u,N,M,R,Y)));let U=await this.c;if(p&&T){this.O.info(`${this.D}: Accepting remote because it was synced before and the last sync data is not available.`);for(const Y of U.resourcePreviews)U=await this.accept(Y.remoteResource)||U}return this.cb(U.resourcePreviews),U.resourcePreviews.some(({mergeState:Y})=>Y==="conflict")?"hasConflicts":p?await this.ab(!1):"syncing"}catch(N){throw this.c=null,N}}async merge(y){return await this.$(y,async u=>{const p=await this.rb(u,A.CancellationToken.None);await this.G.writeFile(u.previewResource,D.$je.fromString(p?.content||""));const R=p&&!p.hasConflicts?await this.sb(u,u.previewResource,void 0,A.CancellationToken.None):void 0;return u.acceptResult=R,u.mergeState=p.hasConflicts?"conflict":R?"accepted":"preview",u.localChange=R?R.localChange:p.localChange,u.remoteChange=R?R.remoteChange:p.remoteChange,u}),this.c}async accept(y,u){return await this.$(y,async p=>{const R=await this.sb(p,y,u,A.CancellationToken.None);return p.acceptResult=R,p.mergeState="accepted",p.localChange=R.localChange,p.remoteChange=R.remoteChange,p}),this.c}async discard(y){return await this.$(y,async u=>{const p=await this.rb(u,A.CancellationToken.None);return await this.G.writeFile(u.previewResource,D.$je.fromString(p.content||"")),u.acceptResult=void 0,u.mergeState="preview",u.localChange=p.localChange,u.remoteChange=p.remoteChange,u}),this.c}async $(y,u){if(!this.c)return;let p=await this.c;const R=p.resourcePreviews.findIndex(({localResource:N,remoteResource:T,previewResource:M})=>this.h.isEqual(N,y)||this.h.isEqual(T,y)||this.h.isEqual(M,y));R!==-1&&(this.c=(0,L.$Tg)(async N=>{const T=[...p.resourcePreviews];return T[R]=await u(T[R]),{...p,resourcePreviews:T}}),p=await this.c,this.cb(p.resourcePreviews),p.resourcePreviews.some(({mergeState:N})=>N==="conflict")?this.S("hasConflicts"):this.S("syncing"))}async ab(y){if(!this.c)return"idle";const u=await this.c;return u.resourcePreviews.some(({mergeState:p})=>p==="conflict")?"hasConflicts":u.resourcePreviews.some(({mergeState:p})=>p!=="accepted")?"syncing":(await this.tb(u.remoteUserData,u.lastSyncUserData,u.resourcePreviews.map(p=>[p,p.acceptResult]),y),this.c=null,await this.bb(),"idle")}async bb(){try{await this.G.del(this.g,{recursive:!0})}catch{}}cb(y){const u=y.filter(({mergeState:p})=>p==="conflict");(0,O.$ub)(this.s,u,(p,R)=>this.h.isEqual(p.previewResource,R.previewResource))||(this.s=u,this.t.fire(this.conflicts))}async hasPreviouslySynced(){const y=await this.getLastSyncUserData();return!!y&&y.syncData!==null}async db(y){const u=this.c?await this.c:null;if(u)for(const p of u.resourcePreviews){if(this.h.isEqual(p.acceptedResource,y))return p.acceptResult?p.acceptResult.content:null;if(this.h.isEqual(p.remoteResource,y))return p.remoteContent;if(this.h.isEqual(p.localResource,y))return p.localContent;if(this.h.isEqual(p.baseResource,y))return p.baseContent}return null}async resetLocal(){this.I.remove(this.z,-1);try{await this.G.del(this.y)}catch(y){(0,$.$Hk)(y)!==1&&this.O.error(y)}}async eb(y,u,p,R,N,T){const M=await this.qb(y,u,p,N,T),U=[];for(const Y of M){const Q=Y.previewResource.with({scheme:c.$3nb,authority:"accepted"});if(Y.localChange===0&&Y.remoteChange===0)U.push({...Y,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const x=R?await this.rb(Y,T):void 0;if(T.isCancellationRequested)break;await this.G.writeFile(Y.previewResource,D.$je.fromString(x?.content||""));const H=x&&!x.hasConflicts?await this.sb(Y,Y.previewResource,void 0,T):void 0;U.push({...Y,acceptResult:H,mergeState:x?.hasConflicts?"conflict":H?"accepted":"preview",localChange:H?H.localChange:x?x.localChange:Y.localChange,remoteChange:H?H.remoteChange:x?x.remoteChange:Y.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:y,lastSyncUserData:u,resourcePreviews:U,isLastSyncFromCurrentMachine:p}}async getLastSyncUserData(){let y=this.gb();if(y||(y=await this.jb()),!y)return this.O.info(`${this.D}: Last sync data state does not exist.`),null;const u=JSON.parse(y),p=this.M.getResourceSyncStateVersion(this.resource);if(this.C=!!u.version&&!!p&&u.version!==p,this.C)return this.O.info(`${this.D}: Reset last sync state because last sync state version ${u.version} is not compatible with current sync state version ${p}.`),await this.resetLocal(),null;let R,N=1;for(;R===void 0&&N++<6;)try{const T=await this.hb();T&&(T.ref===u.ref?R=T.syncData:this.O.info(`${this.D}: Last sync data stored locally is not same as the last sync state.`));break}catch(T){if(T instanceof $.$Lk&&T.fileOperationResult===1){this.O.info(`${this.D}: Last sync resource does not exist locally.`);break}else{if(T instanceof c.$Qnb)throw T;this.O.error(T,N)}}if(R===void 0)try{const T=await this.J.resolveResourceContent(this.resource,u.ref,this.collection,this.F);R=T===null?null:this.kb(T),await this.ib({ref:u.ref,syncData:R})}catch(T){if(T instanceof c.$Qnb&&T.code==="NotFound")this.O.info(`${this.D}: Last sync resource does not exist remotely.`);else throw T}return R===void 0?null:{...u,syncData:R}}async fb(y,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p=this.M.getResourceSyncStateVersion(this.resource),R={ref:y.ref,version:p,...u};this.I.store(this.z,JSON.stringify(R),-1,1),await this.ib(y)}gb(){return this.I.get(this.z,-1)}async hb(){const y=(await this.G.readFile(this.y)).value.toString();try{const u=y?JSON.parse(y):void 0;if(i(u))return u}catch(u){this.O.error(u)}}async ib(y){await this.G.writeFile(this.y,D.$je.fromString(JSON.stringify(y)))}async jb(){try{const y=await this.G.readFile(this.y),u=JSON.parse(y.value.toString());await this.G.del(this.y),u.ref&&u.content!==void 0?(this.I.store(this.z,JSON.stringify({...u,content:void 0}),-1,1),await this.ib({ref:u.ref,syncData:u.content===null?null:JSON.parse(u.content)})):this.O.info(`${this.D}: Migrating last sync user data. Invalid data.`,u)}catch(y){y instanceof $.$Lk&&y.fileOperationResult===1?this.O.info(`${this.D}: Migrating last sync user data. Resource does not exist.`):this.O.error(y)}return this.I.get(this.z,-1)}async getRemoteUserData(y){const{ref:u,content:p}=await this.lb(y);let R=null;return p!==null&&(R=this.kb(p)),{ref:u,syncData:R}}kb(y){try{const u=JSON.parse(y);if(o(u))return u}catch(u){this.O.error(u)}throw new c.$Qnb((0,S.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async lb(y){const u=y?{ref:y.ref,content:y.syncData?JSON.stringify(y.syncData):null}:null;return this.J.readResource(this.resource,u,this.collection,this.F)}async mb(y,u){const p=await this.j,R={version:this.pb,machineId:p,content:y};try{return u=await this.J.writeResource(this.resource,JSON.stringify(R),u,this.collection,this.F),{ref:u,syncData:R}}catch(N){throw N instanceof c.$Qnb&&N.code==="TooLarge"&&(N=new c.$Qnb(N.message,N.code,this.resource)),N}}async nb(y){const u={version:this.pb,content:y};return this.L.writeResource(this.resource,JSON.stringify(u),new Date,this.syncResource.profile.isDefault?void 0:this.syncResource.profile.id)}async stop(){this.status!=="idle"&&(this.O.trace(`${this.D}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.cb([]),await this.bb(),this.S("idle"),this.O.info(`${this.D}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}ob(){return this.P.getValue(c.$Dnb)}};e.$aHb=s,e.$aHb=s=pe([X(2,$.$qk),X(3,l.$ai),X(4,h.$up),X(5,c.$Lnb),X(6,c.$Mnb),X(7,c.$Vnb),X(8,f.$ul),X(9,c.$1nb),X(10,m.$zi),X(11,d.$1k)],s);let t=class extends s{constructor(y,u,p,R,N,T,M,U,Y,Q,x,H,Z){super(u,p,R,N,T,M,U,Y,Q,x,H,Z),this.r=y,this.B(this.G.watch(this.h.dirname(y))),this.B(this.G.onDidFilesChange(W=>this.yb(W)))}async vb(){try{return await this.G.readFile(this.r)}catch{return null}}async wb(y,u,p){try{u?await this.G.writeFile(this.r,D.$je.fromString(y),p?void 0:u):await this.G.createFile(this.r,D.$je.fromString(y),{overwrite:p})}catch(R){throw R instanceof $.$Lk&&R.fileOperationResult===1||R instanceof $.$Lk&&R.fileOperationResult===3?new c.$Qnb(R.message,"LocalPreconditionFailed"):R}}async xb(){try{await this.G.del(this.r)}catch(y){if(!(y instanceof $.$Lk&&y.fileOperationResult===1))throw y}}yb(y){y.contains(this.r)&&this.Q()}};e.$bHb=t,e.$bHb=t=pe([X(3,$.$qk),X(4,l.$ai),X(5,h.$up),X(6,c.$Lnb),X(7,c.$Mnb),X(8,c.$Vnb),X(9,f.$ul),X(10,c.$1nb),X(11,m.$zi),X(12,d.$1k)],t);let r=class extends t{constructor(y,u,p,R,N,T,M,U,Y,Q,x,H,Z,W){super(y,u,p,R,N,T,M,U,Y,Q,x,Z,W),this.zb=H,this.Bb=void 0}Ab(y,u){const p=[],R=(0,P.$cn)(y,p,{allowEmptyContent:!0,allowTrailingComma:!0});return p.length>0||!(0,C.$Pf)(R)&&u!==Array.isArray(R)}Cb(){return this.Bb||(this.Bb=this.zb.resolveFormattingOptions(this.r)),this.Bb}};e.$cHb=r,e.$cHb=r=pe([X(3,$.$qk),X(4,l.$ai),X(5,h.$up),X(6,c.$Lnb),X(7,c.$Mnb),X(8,c.$Vnb),X(9,f.$ul),X(10,c.$1nb),X(11,c.$Znb),X(12,m.$zi),X(13,d.$1k)],r);let a=class{constructor(y,u,p,R,N,T,M){this.resource=y,this.g=u,this.h=p,this.j=R,this.k=N,this.l=T,this.d=M.extUri,this.f=(0,c.$Jnb)(void 0,this.resource,p,this.d)}async initialize({ref:y,content:u}){if(!u){this.j.info("Remote content does not exist.",this.resource);return}const p=this.m(u);if(p)try{await this.o({ref:y,syncData:p})}catch(R){this.j.error(R)}}m(y){try{const u=JSON.parse(y);if(o(u))return u}catch(u){this.j.error(u)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(y,u={}){if(u.ref||u.version)throw new Error("Cannot have core properties as additional");const p={ref:y.ref,version:void 0,...u};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(p),-1,1),await this.k.writeFile(this.f,D.$je.fromString(JSON.stringify(y)))}};e.$dHb=a,e.$dHb=a=pe([X(1,v.$3k),X(2,l.$ai),X(3,b.$nj),X(4,$.$qk),X(5,h.$up),X(6,d.$1k)],a)}),define(le[115],he([0,1,6,26,7,3,42,2,27,21,15,114,29,33,83,45,11,4,74,8,19,22,28,18,39,235,111,25,60]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v,i,o,n,s,t,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$47b=e.$37b=e.$27b=e.$17b=e.$Z7b=void 0;async function E(T,M){const U=JSON.parse(T.content);if(T.version===1||T.version===2){const Y=(await M.getInstalled(0)).filter(Q=>Q.isBuiltin);for(const Q of U)T.version===1&&(Q.enabled===!1&&(Q.disabled=!0),delete Q.enabled),T.version===2&&Y.every(x=>!(0,l.$1o)(x.identifier,Q.identifier))&&(Q.installed=!0)}return U}function y(T){return JSON.parse(T.content)}e.$Z7b=y;function u(T,M){return T.sort((U,Y)=>!U.identifier.uuid&&Y.identifier.uuid?-1:U.identifier.uuid&&!Y.identifier.uuid?1:(0,k.$5e)(U.identifier.id,Y.identifier.id)),M?(0,I.$nn)(T,{}):JSON.stringify(T)}e.$17b=u;let p=class extends n.$aHb{constructor(M,U,Y,Q,x,H,Z,W,V,ie,re,ee,ae,K,q,j,F){super({syncResource:"extensions",profile:M},U,Q,Y,x,H,Z,ee,ae,ie,re,q),this.Cb=W,this.Db=V,this.Eb=F,this.pb=6,this.wb=this.h.joinPath(this.g,"extensions.json"),this.xb=this.wb.with({scheme:r.$3nb,authority:"base"}),this.yb=this.wb.with({scheme:r.$3nb,authority:"local"}),this.zb=this.wb.with({scheme:r.$3nb,authority:"remote"}),this.Ab=this.wb.with({scheme:r.$3nb,authority:"accepted"}),this.Bb=this.Eb.createInstance(R),this.B(A.Event.any(A.Event.filter(this.Cb.onDidInstallExtensions,B=>B.some(({local:z})=>!!z)),A.Event.filter(this.Cb.onDidUninstallExtension,B=>!B.error),A.Event.filter(j.onDidChange,B=>B.valueChanges.some(({profile:z,changes:_})=>this.syncResource.profile.id===z.id&&_.some(G=>G.key===m.$Co))),K.onDidChangeExtensionStorageToSync)(()=>this.Q()))}async qb(M,U){const Y=M.syncData?await E(M.syncData,this.Cb):null,Q=U?.skippedExtensions??[],x=U?.builtinExtensions??null,H=U?.syncData?await E(U.syncData,this.Cb):null,{localExtensions:Z,ignoredExtensions:W}=await this.Bb.getLocalExtensions(this.syncResource.profile);Y?this.O.trace(`${this.D}: Merging remote extensions with local extensions...`):this.O.trace(`${this.D}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:V,remote:ie}=(0,s.$Y7b)(Z,Y,H,Q,W,x),re={local:V,remote:ie,content:this.Hb(Z,V.added,V.updated,V.removed),localChange:V.added.length>0||V.removed.length>0||V.updated.length>0?2:0,remoteChange:ie!==null?2:0},ee=this.Ob(Z,!1);return[{skippedExtensions:Q,builtinExtensions:x,baseResource:this.xb,baseContent:H?this.Ob(H,!1):ee,localResource:this.yb,localContent:ee,localExtensions:Z,remoteResource:this.zb,remoteExtensions:Y,remoteContent:Y?this.Ob(Y,!1):null,previewResource:this.wb,previewResult:re,localChange:re.localChange,remoteChange:re.remoteChange,acceptedResource:this.Ab}]}async ub(M){const U=M.syncData?await E(M.syncData,this.Cb):null,{localExtensions:Y,ignoredExtensions:Q}=await this.Bb.getLocalExtensions(this.syncResource.profile),{remote:x}=(0,s.$Y7b)(Y,U,U,M.skippedExtensions||[],Q,M.builtinExtensions||[]);return x!==null}Hb(M,U,Y,Q){const x=[...U,...Y],H=new Set,Z=W=>{H.add(W.id.toLowerCase()),W.uuid&&H.add(W.uuid)};x.forEach(({identifier:W})=>Z(W)),Q.forEach(Z);for(const W of M)H.has(W.identifier.id.toLowerCase())||W.identifier.uuid&&H.has(W.identifier.uuid)||x.push(W);return this.Ob(x,!1)}async rb(M,U){return{...M.previewResult,hasConflicts:!1}}async sb(M,U,Y,Q){if(this.h.isEqual(U,this.yb))return this.Kb(M);if(this.h.isEqual(U,this.zb))return this.Lb(M);if(this.h.isEqual(U,this.wb))return M.previewResult;throw new Error(`Invalid Resource: ${U.toString()}`)}async Kb(M){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(U),Q=(0,s.$Y7b)(M.localExtensions,null,null,M.skippedExtensions,Y,M.builtinExtensions),{local:x,remote:H}=Q;return{content:M.localContent,local:x,remote:H,localChange:x.added.length>0||x.removed.length>0||x.updated.length>0?2:0,remoteChange:H!==null?2:0}}async Lb(M){const U=await this.Cb.getInstalled(void 0,this.syncResource.profile.extensionsResource),Y=this.Db.getIgnoredExtensions(U),Q=M.remoteContent?JSON.parse(M.remoteContent):null;if(Q!==null){const x=(0,s.$Y7b)(M.localExtensions,Q,M.localExtensions,[],Y,M.builtinExtensions),{local:H,remote:Z}=x;return{content:M.remoteContent,local:H,remote:Z,localChange:H.added.length>0||H.removed.length>0||H.updated.length>0?2:0,remoteChange:Z!==null?2:0}}else return{content:M.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(M,U,Y,Q){let{skippedExtensions:x,builtinExtensions:H,localExtensions:Z}=Y[0][0];const{local:W,remote:V,localChange:ie,remoteChange:re}=Y[0][1];if(ie===0&&re===0&&this.O.info(`${this.D}: No changes found during synchronizing extensions.`),ie!==0&&(await this.nb(JSON.stringify(Z)),x=await this.Bb.updateLocalExtensions(W.added,W.removed,W.updated,x,this.syncResource.profile)),V){this.O.trace(`${this.D}: Updating remote extensions...`);const ee=JSON.stringify(V.all);M=await this.mb(ee,Q?null:M.ref),this.O.info(`${this.D}: Updated remote extensions.${V.added.length?` Added: ${JSON.stringify(V.added.map(ae=>ae.identifier.id))}.`:""}${V.updated.length?` Updated: ${JSON.stringify(V.updated.map(ae=>ae.identifier.id))}.`:""}${V.removed.length?` Removed: ${JSON.stringify(V.removed.map(ae=>ae.identifier.id))}.`:""}`)}U?.ref!==M.ref&&(this.O.trace(`${this.D}: Updating last synchronized extensions...`),H=this.Nb(Z,H),await this.fb(M,{skippedExtensions:x,builtinExtensions:H}),this.O.info(`${this.D}: Updated last synchronized extensions.${x.length?` Skipped: ${JSON.stringify(x.map(ee=>ee.identifier.id))}.`:""}`))}Nb(M,U){const Y=new Set,Q=[];for(const x of M)Y.add(x.identifier.id.toLowerCase()),x.installed||Q.push(x.identifier);if(U)for(const x of U)Y.has(x.id.toLowerCase())||Q.push(x);return Q}async resolveContent(M){if(this.h.isEqual(this.zb,M)||this.h.isEqual(this.xb,M)||this.h.isEqual(this.yb,M)||this.h.isEqual(this.Ab,M)){const U=await this.db(M);return U&&this.Ob(JSON.parse(U),!0)}return null}Ob(M,U){return u(M,U)}async hasLocalData(){try{const{localExtensions:M}=await this.Bb.getLocalExtensions(this.syncResource.profile);if(M.some(U=>U.installed||U.disabled))return!0}catch{}return!1}};e.$27b=p,e.$27b=p=pe([X(2,C.$ai),X(3,w.$qk),X(4,c.$up),X(5,r.$Lnb),X(6,r.$Mnb),X(7,m.$Bo),X(8,t.$UHb),X(9,r.$1nb),X(10,g.$zi),X(11,r.$Vnb),X(12,v.$ul),X(13,$.$mv),X(14,i.$1k),X(15,a.$cGb),X(16,h.$5h)],p);let R=class{constructor(M,U,Y,Q,x,H){this.a=M,this.b=U,this.c=Y,this.d=Q,this.f=x,this.g=H}async getLocalExtensions(M){const U=await this.a.getInstalled(void 0,M.extensionsResource),Y=this.d.getIgnoredExtensions(U);return{localExtensions:await this.j(M,async(x,H)=>{const Z=x.getDisabledExtensions();return U.map(W=>{const{identifier:V,isBuiltin:ie,manifest:re,preRelease:ee,pinned:ae,isApplicationScoped:K}=W,q={identifier:V,preRelease:ee,version:re.version,pinned:!!ae};K&&!(0,b.$om)(re)&&(q.isApplicationScoped=K),Z.some(j=>(0,l.$1o)(j,V))&&(q.disabled=!0),ie||(q.installed=!0);try{const j=H.getKeysForSync({id:V.id,version:re.version});if(j){const F=H.getExtensionState(W,!0)||{};q.state=Object.keys(F).reduce((B,z)=>(j.includes(z)&&(B[z]=F[z]),B),{})}}catch(j){this.g.info(`${(0,n.$_Gb)("extensions",M)}: Error while parsing extension state`,(0,D.$0)(j))}return q})}),ignoredExtensions:Y}}async updateLocalExtensions(M,U,Y,Q,x){const H=(0,n.$_Gb)("extensions",x),Z=[],W=new Map,V=[],ie=[],re=await this.a.getInstalled(void 0,x.extensionsResource);if((M.length||Y.length)&&await this.j(x,async(K,q)=>{await O.Promises.settled([...M,...Y].map(async j=>{const F=re.find(_=>(0,l.$1o)(_.identifier,j.identifier));if(F&&F.isBuiltin){j.state&&F.manifest.version===j.version&&this.h(j.state,F,F.manifest.version,q),K.getDisabledExtensions().some(G=>(0,l.$1o)(G,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${H}: Disabling extension...`,j.identifier.id),await K.disableExtension(j.identifier),this.g.info(`${H}: Disabled extension`,j.identifier.id)):(this.g.trace(`${H}: Enabling extension...`,j.identifier.id),await K.enableExtension(j.identifier),this.g.info(`${H}: Enabled extension`,j.identifier.id))),V.push(j.identifier);return}const B=j.pinned?j.version:void 0,z=(await this.c.getExtensions([{...j.identifier,version:B,preRelease:B?void 0:j.preRelease}],L.CancellationToken.None))[0];if(j.state&&(F?F.manifest.version===j.version:z)&&this.h(j.state,F||z,F?.manifest.version,q),z)try{K.getDisabledExtensions().some(G=>(0,l.$1o)(G,j.identifier))!==!!j.disabled&&(j.disabled?(this.g.trace(`${H}: Disabling extension...`,j.identifier.id,z.version),await K.disableExtension(z.identifier),this.g.info(`${H}: Disabled extension`,j.identifier.id,z.version)):(this.g.trace(`${H}: Enabling extension...`,j.identifier.id,z.version),await K.enableExtension(z.identifier),this.g.info(`${H}: Enabled extension`,j.identifier.id,z.version))),(!F||F.preRelease!==j.preRelease||F.pinned!==j.pinned||B&&F.manifest.version!==B)&&(await this.a.canInstall(z)?(Z.push({extension:z,options:{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:j.pinned&&!!j.version,installPreReleaseVersion:j.preRelease,profileLocation:x.extensionsResource,isApplicationScoped:j.isApplicationScoped,context:{[m.$po]:!0,[m.$qo]:!0}}}),W.set(z.identifier.id.toLowerCase(),j)):(this.g.info(`${H}: Skipped synchronizing extension because it cannot be installed.`,z.displayName||z.identifier.id),ie.push(j)))}catch(_){ie.push(j),this.g.error(_),this.g.info(`${H}: Skipped synchronizing extension`,z.displayName||z.identifier.id)}else ie.push(j),this.g.info(`${H}: Skipped synchronizing extension because the extension is not found.`,j.identifier.id)}))}),U.length){const K=re.filter(({identifier:q,isBuiltin:j})=>!j&&U.some(F=>(0,l.$1o)(q,F)));await O.Promises.settled(K.map(async q=>{this.g.trace(`${H}: Uninstalling local extension...`,q.identifier.id),await this.a.uninstall(q,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:x.extensionsResource}),this.g.info(`${H}: Uninstalled local extension.`,q.identifier.id),V.push(q.identifier)}))}const ee=await this.a.installGalleryExtensions(Z);for(const{identifier:K,local:q,error:j,source:F}of ee){const B=F;if(q)this.g.info(`${H}: Installed extension.`,K.id,B.version),V.push(K);else{const z=W.get(K.id.toLowerCase());z&&(ie.push(z),this.g.info(`${H}: Skipped synchronizing extension`,B.displayName||B.identifier.id)),j instanceof m.$zo&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(j.code)?this.g.info(`${H}: Skipped synchronizing extension because the compatible extension is not found.`,B.displayName||B.identifier.id):j&&this.g.error(j)}}const ae=[];for(const K of Q)V.some(q=>(0,l.$1o)(q,K.identifier))||ae.push(K);for(const K of ie)ae.some(q=>(0,l.$1o)(q.identifier,K.identifier))||ae.push(K);return ae}h(M,U,Y,Q){const x=Q.getExtensionState(U,!0)||{},H=Y?Q.getKeysForSync({id:U.identifier.id,version:Y}):void 0;H?H.forEach(Z=>{x[Z]=M[Z]}):Object.keys(M).forEach(Z=>x[Z]=M[Z]),Q.setExtensionState(U,x,!0)}async j(M,U){return this.b.withProfileScopedStorageService(M,async Y=>{const Q=new P.$Sc,x=this.f.createChild(new f.$4h([c.$up,Y])),H=Q.add(x.createInstance(S.$AFb)),Z=Q.add(x.createInstance($.$nv));try{return await U(H,Z)}finally{Q.dispose()}})}};e.$37b=R,e.$37b=R=pe([X(0,m.$Bo),X(1,a.$cGb),X(2,m.$yo),X(3,t.$UHb),X(4,h.$5h),X(5,r.$1nb)],R);let N=class extends n.$dHb{constructor(M,U,Y,Q,x,H,Z,W){super("extensions",Q,x,H,Y,Z,W),this.p=M,this.q=U}async t(M){return M.syncData?await E(M.syncData,this.p):null}u(M,U){const Y=[],Q=[],x=[];for(const H of M){if(this.q.hasToNeverSyncExtension(H.identifier.id))continue;const Z=U.find(W=>(0,l.$1o)(W.identifier,H.identifier));Z?(Y.push(Z),H.disabled&&x.push(H.identifier)):H.installed&&(Q.push({...H.identifier,preRelease:!!H.preRelease}),H.disabled&&x.push(H.identifier))}return{installedExtensions:Y,newExtensions:Q,disabledExtensions:x,remoteExtensions:M}}};e.$47b=N,e.$47b=N=pe([X(0,m.$Bo),X(1,t.$UHb),X(2,w.$qk),X(3,o.$3k),X(4,C.$ai),X(5,d.$nj),X(6,c.$up),X(7,i.$1k)],N)}),define(le[116],he([0,1,14,7,3,34,42,5,32,21,15,11,8,43,19,22,28,39,80,239,25,18,60,4]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v,i,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jHb=e.$iHb=e.$hHb=e.$gHb=e.$fHb=void 0;const n="globalState.argv.",s=["locale"];function t(p,R){const N=p.storage?Object.keys(p.storage).sort():[],T={};return N.forEach(M=>T[M]=p.storage[M]),p.storage=T,R?(0,I.$nn)(p,{}):JSON.stringify(p)}e.$fHb=t;const r=1;let a=class extends h.$aHb{constructor(R,N,T,M,U,Y,Q,x,H,Z,W,V,ie,re){super({syncResource:"globalState",profile:R},N,M,x,V,U,Y,H,Z,Q,W,ie),this.Bb=T,this.pb=r,this.vb=this.h.joinPath(this.g,"globalState.json"),this.wb=this.vb.with({scheme:c.$3nb,authority:"base"}),this.xb=this.vb.with({scheme:c.$3nb,authority:"local"}),this.yb=this.vb.with({scheme:c.$3nb,authority:"remote"}),this.zb=this.vb.with({scheme:c.$3nb,authority:"accepted"}),this.Ab=re.createInstance(E),this.B(M.watch(this.h.dirname(this.H.argvResource))),this.B(D.Event.any(D.Event.filter(M.onDidFilesChange,ee=>ee.contains(this.H.argvResource)),D.Event.filter(T.onDidChange,ee=>!!(ee.targetChanges.some(ae=>this.syncResource.profile.id===ae.id)||ee.valueChanges.some(({profile:ae,changes:K})=>this.syncResource.profile.id===ae.id&&K.some(q=>q.target===0)))))(()=>this.Q()))}async qb(R,N,T){const M=R.syncData?JSON.parse(R.syncData.content):null;N=N===null&&T?R:N;const U=N&&N.syncData?JSON.parse(N.syncData.content):null,Y=await this.Ab.getLocalGlobalState(this.syncResource.profile);M?this.O.trace(`${this.D}: Merging remote ui state with local ui state...`):this.O.trace(`${this.D}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Jb(U),{local:x,remote:H}=(0,d.$eHb)(Y.storage,M?M.storage:null,U?U.storage:null,Q,this.O),Z={content:null,local:x,remote:H,localChange:Object.keys(x.added).length>0||Object.keys(x.updated).length>0||x.removed.length>0?2:0,remoteChange:H.all!==null?2:0},W=t(Y,!1);return[{baseResource:this.wb,baseContent:U?t(U,!1):W,localResource:this.xb,localContent:W,localUserData:Y,remoteResource:this.yb,remoteContent:M?t(M,!1):null,previewResource:this.vb,previewResult:Z,localChange:Z.localChange,remoteChange:Z.remoteChange,acceptedResource:this.zb,storageKeys:Q}]}async ub(R){const N=R.syncData?JSON.parse(R.syncData.content):null;if(N===null)return!0;const T=await this.Ab.getLocalGlobalState(this.syncResource.profile),M=await this.Jb(N),{remote:U}=(0,d.$eHb)(T.storage,N.storage,N.storage,M,this.O);return U.all!==null}async rb(R,N){return{...R.previewResult,hasConflicts:!1}}async sb(R,N,T,M){if(this.h.isEqual(N,this.xb))return this.Gb(R);if(this.h.isEqual(N,this.yb))return this.Hb(R);if(this.h.isEqual(N,this.vb))return R.previewResult;throw new Error(`Invalid Resource: ${N.toString()}`)}async Gb(R){return{content:R.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(R.localUserData.storage),removed:[],updated:[],all:R.localUserData.storage},localChange:0,remoteChange:2}}async Hb(R){if(R.remoteContent!==null){const N=JSON.parse(R.remoteContent),{local:T,remote:M}=(0,d.$eHb)(R.localUserData.storage,N.storage,null,R.storageKeys,this.O);return{content:R.remoteContent,local:T,remote:M,localChange:Object.keys(T.added).length>0||Object.keys(T.updated).length>0||T.removed.length>0?2:0,remoteChange:M!==null?2:0}}else return{content:R.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async tb(R,N,T,M){const{localUserData:U}=T[0][0],{local:Y,remote:Q,localChange:x,remoteChange:H}=T[0][1];if(x===0&&H===0&&this.O.info(`${this.D}: No changes found during synchronizing ui state.`),x!==0&&(this.O.trace(`${this.D}: Updating local ui state...`),await this.nb(JSON.stringify(U)),await this.Ab.writeLocalGlobalState(Y,this.syncResource.profile),this.O.info(`${this.D}: Updated local ui state`)),H!==0){this.O.trace(`${this.D}: Updating remote ui state...`);const Z=JSON.stringify({storage:Q.all});R=await this.mb(Z,M?null:R.ref),this.O.info(`${this.D}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}N?.ref!==R.ref&&(this.O.trace(`${this.D}: Updating last synchronized ui state...`),await this.fb(R),this.O.info(`${this.D}: Updated last synchronized ui state`))}async resolveContent(R){if(this.h.isEqual(this.yb,R)||this.h.isEqual(this.wb,R)||this.h.isEqual(this.xb,R)||this.h.isEqual(this.zb,R)){const N=await this.db(R);return N&&t(JSON.parse(N),!0)}return null}async hasLocalData(){try{const{storage:R}=await this.Ab.getLocalGlobalState(this.syncResource.profile);if(Object.keys(R).length>1||R[`${n}.locale`]?.value!=="en")return!0}catch{}return!1}async Jb(R){const N=await this.Bb.readStorageData(this.syncResource.profile),T=[],M=[];for(const[Q,x]of N)x.target===0?T.push(Q):x.target===1&&M.push(Q);const U=[...T,...M],Y=R?.storage?Object.keys(R.storage).filter(Q=>!Q.startsWith(n)&&!U.includes(Q)&&N.get(Q)!==void 0):[];if(!P.$o){const Q=[...c.$Hnb.map(x=>(0,c.$Unb)(x)),c.$Tnb];Y.push(...Q),M.push(...Q)}return{user:T,machine:M,unregistered:Y}}};e.$gHb=a,e.$gHb=a=pe([X(2,i.$cGb),X(3,S.$qk),X(4,c.$Lnb),X(5,c.$Mnb),X(6,c.$1nb),X(7,C.$ai),X(8,c.$Vnb),X(9,b.$ul),X(10,g.$zi),X(11,$.$up),X(12,w.$1k),X(13,o.$5h)],a);let E=class{constructor(R,N,T,M){this.a=R,this.b=N,this.c=T,this.d=M}async getLocalGlobalState(R){const N={};if(R.isDefault){const M=await this.f(),U=(0,A.$cn)(M);for(const Y of s)U[Y]!==void 0&&(N[`${n}${Y}`]={version:1,value:U[Y]})}const T=await this.c.readStorageData(R);for(const[M,U]of T)U.value&&U.target===0&&(N[M]={version:1,value:U.value});return{storage:N}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const R=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),R.value.toString()}catch(R){this.d.debug((0,L.$0)(R))}return"{}"}async writeLocalGlobalState({added:R,removed:N,updated:T},M){const U=(0,h.$_Gb)("globalState",M),Y={},Q=new Map,x=await this.c.readStorageData(M),H=(Z,W)=>{for(const V of Z){if(V.startsWith(n)){Y[V.substring(n.length)]=W?W[V].value:void 0;continue}if(W){const ie=W[V];ie.value!==x.get(V)?.value&&Q.set(V,ie.value)}else x.get(V)!==void 0&&Q.set(V,void 0)}};if(H(Object.keys(R),R),H(Object.keys(T),T),H(N),Object.keys(Y).length){this.d.trace(`${U}: Updating locale...`);const Z=await this.f();let W=Z;for(const V of Object.keys(Y))W=(0,f.edit)(W,[V],Y[V],{});Z!==W&&(this.d.trace(`${U}: Updating locale...`),await this.a.writeFile(this.b.argvResource,O.$je.fromString(W)),this.d.info(`${U}: Updated locale.`)),this.d.info(`${U}: Updated locale`)}Q.size&&(this.d.trace(`${U}: Updating global state...`),await this.c.updateStorageData(M,Q,0),this.d.info(`${U}: Updated global state`,[...Q.keys()]))}};e.$hHb=E,e.$hHb=E=pe([X(0,S.$qk),X(1,C.$ai),X(2,i.$cGb),X(3,c.$1nb)],E);let y=class extends h.$dHb{constructor(R,N,T,M,U,Y){super("globalState",T,M,U,N,R,Y)}async o(R){const N=R.syncData?JSON.parse(R.syncData.content):null;if(!N){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const T={},M={};for(const U of Object.keys(N.storage))U.startsWith(n)?T[U.substring(n.length)]=N.storage[U].value:this.l.get(U,0)===void 0&&(M[U]=N.storage[U].value);if(Object.keys(T).length){let U="{}";try{U=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const Y of Object.keys(T))U=(0,f.edit)(U,[Y],T[Y],{});await this.k.writeFile(this.h.argvResource,O.$je.fromString(U))}if(Object.keys(M).length){const U=[];for(const Y of Object.keys(M))U.push({key:Y,value:M[Y],scope:0,target:0});this.l.storeAll(U,!0)}}};e.$iHb=y,e.$iHb=y=pe([X(0,$.$up),X(1,S.$qk),X(2,v.$3k),X(3,C.$ai),X(4,c.$1nb),X(5,w.$1k)],y);let u=class{constructor(R,N,T,M,U){this.a=R,this.b=N,this.c=T,this.d=M,this.f=U}getSyncStoreType(R){return this.h(R)?.storage[c.$Tnb]?.value}async sync(R){const N=(0,c.$Pnb)((0,k.$qg)());try{return await this.g(R,N)}catch(T){if(T instanceof c.$Qnb)switch(T.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(R,N)}throw T}}async g(R,N){const T=await this.a.readResource("globalState",null,void 0,N),M=this.h(T)||{storage:{}};M.storage[c.$Tnb]={value:R,version:r};const U=await(0,l.$Ap)(this.c,this.d,this.b),Y={version:r,machineId:U,content:t(M,!1)};await this.a.writeResource("globalState",JSON.stringify(Y),T.ref,void 0,N)}h({content:R}){if(!R)return null;const N=JSON.parse(R);if((0,h.$$Gb)(N))return N?JSON.parse(N.content):null;throw new Error("Invalid remote data")}};e.$jHb=u,e.$jHb=u=pe([X(1,$.$up),X(2,C.$ai),X(3,S.$qk),X(4,m.$nj)],u)}),define(le[117],he([0,1,17,14,3,34,5,12,171,21,15,11,19,22,28,18,39,236,25]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$87b=e.$77b=e.$67b=void 0;function d(i,o,n){try{const s=JSON.parse(i);if(!o)return(0,P.$Pf)(s.all)?null:s.all;switch(I.OS){case 2:return(0,P.$Pf)(s.mac)?null:s.mac;case 3:return(0,P.$Pf)(s.linux)?null:s.linux;case 1:return(0,P.$Pf)(s.windows)?null:s.windows}}catch(s){return n.error(s),null}}e.$67b=d;let c=class extends w.$cHb{constructor(o,n,s,t,r,a,E,y,u,p,R,N,T){super(o.keybindingsResource,{syncResource:"keybindings",profile:o},n,y,u,p,s,t,E,N,r,R,a,T),this.pb=2,this.Eb=this.h.joinPath(this.g,"keybindings.json"),this.Fb=this.Eb.with({scheme:f.$3nb,authority:"base"}),this.Gb=this.Eb.with({scheme:f.$3nb,authority:"local"}),this.Hb=this.Eb.with({scheme:f.$3nb,authority:"remote"}),this.Ib=this.Eb.with({scheme:f.$3nb,authority:"accepted"}),this.B(D.Event.filter(a.onDidChangeConfiguration,M=>M.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.Q()))}async qb(o,n,s,t){const r=o.syncData?d(o.syncData.content,t.keybindingsPerPlatform??this.Qb(),this.O):null;n=n===null&&s?o:n;const a=n?this.Ob(n):null,E=await this.vb(),y=await this.Cb();let u=null,p=!1,R=!1,N=!1;if(r){let U=E?E.value.toString():"[]";if(U=U||"[]",this.Ab(U,!0))throw new f.$Qnb((0,k.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==U||a!==r){this.O.trace(`${this.D}: Merging remote keybindings with local keybindings...`);const Y=await(0,h.$57b)(U,r,a,y,this.zb);Y.hasChanges&&(u=Y.mergeContent,N=Y.hasConflicts,p=N||Y.mergeContent!==U,R=N||Y.mergeContent!==r)}}else E&&(this.O.trace(`${this.D}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),u=E.value.toString(),R=!0);const T={content:N?a:u,localChange:p?E?2:1:0,remoteChange:R?2:0,hasConflicts:N},M=E?E.value.toString():null;return[{fileContent:E,baseResource:this.Fb,baseContent:a,localResource:this.Gb,localContent:M,localChange:T.localChange,remoteResource:this.Hb,remoteContent:r,remoteChange:T.remoteChange,previewResource:this.Eb,previewResult:T,acceptedResource:this.Ib}]}async ub(o){const n=this.Ob(o);if(n===null)return!0;const s=await this.vb(),t=s?s.value.toString():"",r=await this.Cb(),a=await(0,h.$57b)(t||"[]",n,n,r,this.zb);return a.hasConflicts||a.mergeContent!==n}async rb(o,n){return o.previewResult}async sb(o,n,s,t){if(this.h.isEqual(n,this.Gb))return{content:o.fileContent?o.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(n,this.Hb))return{content:o.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(n,this.Eb))return s===void 0?{content:o.previewResult.content,localChange:o.previewResult.localChange,remoteChange:o.previewResult.remoteChange}:{content:s,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${n.toString()}`)}async tb(o,n,s,t){const{fileContent:r}=s[0][0];let{content:a,localChange:E,remoteChange:y}=s[0][1];if(E===0&&y===0&&this.O.info(`${this.D}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.Ab(a,!0)))throw new f.$Qnb((0,k.localize)(1,null),"LocalInvalidContent",this.resource);if(E!==0&&(this.O.trace(`${this.D}: Updating local keybindings...`),r&&await this.nb(this.Pb(r.value.toString())),await this.wb(a||"[]",r,t),this.O.info(`${this.D}: Updated local keybindings`)),y!==0){this.O.trace(`${this.D}: Updating remote keybindings...`);const u=this.Pb(a||"[]",o.syncData?.content);o=await this.mb(u,t?null:o.ref),this.O.info(`${this.D}: Updated remote keybindings`)}try{await this.G.del(this.Eb)}catch{}n?.ref!==o.ref&&(this.O.trace(`${this.D}: Updating last synchronized keybindings...`),await this.fb(o,{platformSpecific:this.Qb()}),this.O.info(`${this.D}: Updated last synchronized keybindings`))}async hasLocalData(){try{const o=await this.vb();if(o){const n=(0,A.$cn)(o.value.toString());if((0,O.$Lb)(n))return!0}}catch(o){if(o.fileOperationResult!==1)return!0}return!1}async resolveContent(o){return this.h.isEqual(this.Hb,o)||this.h.isEqual(this.Fb,o)||this.h.isEqual(this.Gb,o)||this.h.isEqual(this.Ib,o)?this.db(o):null}Ob(o){return!o.syncData||o.platformSpecific!==void 0&&o.platformSpecific!==this.Qb()?null:d(o.syncData.content,this.Qb(),this.O)}Pb(o,n){let s={};try{s=JSON.parse(n||"{}")}catch(t){this.O.error(t)}switch(this.Qb()?delete s.all:s.all=o,I.OS){case 2:s.mac=o;break;case 3:s.linux=o;break;case 1:s.windows=o;break}return JSON.stringify(s)}Qb(){return!!this.P.getValue(f.$Enb)}};e.$77b=c,e.$77b=c=pe([X(2,f.$Lnb),X(3,f.$Mnb),X(4,f.$1nb),X(5,g.$zi),X(6,f.$Vnb),X(7,S.$qk),X(8,C.$ai),X(9,m.$up),X(10,f.$Znb),X(11,l.$ul),X(12,$.$1k)],c);let v=class extends w.$dHb{constructor(o,n,s,t,r,a){super("keybindings",n,s,t,o,r,a)}async o(o){const n=o.syncData?this.p(o.syncData.content):null;if(!n){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,L.$je.fromString(n)),await this.n(o)}async i(){try{const o=await this.k.readFile(this.g.defaultProfile.settingsResource),n=(0,A.$cn)(o.value.toString());return!(0,O.$Lb)(n)}catch(o){return o.fileOperationResult===1}}p(o){try{return d(o,!0,this.j)}catch(n){return this.j.error(n),null}}};e.$87b=v,e.$87b=v=pe([X(0,S.$qk),X(1,b.$3k),X(2,C.$ai),X(3,f.$1nb),X(4,m.$up),X(5,$.$1k)],v)}),define(le[118],he([0,1,14,3,172,21,76,15,29,11,19,22,28,18,39,240,25]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$7b=e.$07b=e.$97b=void 0;function h(v){return v&&v.settings&&typeof v.settings=="string"&&Object.keys(v).length===1}function f(v){const i=JSON.parse(v);return h(i)?i:{settings:v}}e.$97b=f;let d=class extends $.$cHb{constructor(i,o,n,s,t,r,a,E,y,u,p,R,N,T){super(i.settingsResource,{syncResource:"settings",profile:i},o,n,s,t,r,a,p,R,E,y,u,T),this.Eb=N,this.pb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:w.$3nb,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.$3nb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.$3nb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.$3nb,authority:"accepted"}),this.Ob=void 0}async getRemoteUserDataSyncConfiguration(i){const o=await this.getLastSyncUserData(),n=await this.X(i,o),s=this.Lb(n),t=new I.$4n(w.$Dnb);return s?.settings&&t.parse(s.settings),t.configurationModel.getValue(w.$Dnb)||{}}async qb(i,o,n){const s=await this.vb(),t=await this.Cb(),r=this.Lb(i);o=o===null&&n?i:o;const a=o?this.Lb(o):null,E=await this.Pb();let y=null,u=!1,p=!1,R=!1;if(r){let U=s?s.value.toString().trim():"{}";U=U||"{}",this.Qb(U),this.O.trace(`${this.D}: Merging remote settings with local settings...`);const Y=(0,b.$VFb)(U,r.settings,a?a.settings:null,E,[],t);y=Y.localContent||Y.remoteContent,u=Y.localContent!==null,p=Y.remoteContent!==null,R=Y.hasConflicts}else s&&(this.O.trace(`${this.D}: Remote settings does not exist. Synchronizing settings for the first time.`),y=s.value.toString().trim()||"{}",this.Qb(y),p=!0);const N=s?s.value.toString():null,T=a?.settings??null,M={content:R?T:y,localChange:u?2:0,remoteChange:p?2:0,hasConflicts:R};return[{fileContent:s,baseResource:this.baseResource,baseContent:T,localResource:this.localResource,localContent:N,localChange:M.localChange,remoteResource:this.remoteResource,remoteContent:r?r.settings:null,remoteChange:M.remoteChange,previewResource:this.previewResource,previewResult:M,acceptedResource:this.acceptedResource}]}async ub(i){const o=this.Lb(i);if(o===null)return!0;const n=await this.vb(),s=n?n.value.toString().trim():"",t=await this.Pb(),r=await this.Cb();return(0,b.$VFb)(s||"{}",o.settings,o.settings,t,[],r).remoteContent!==null}async rb(i,o){const n=await this.Cb(),s=await this.Pb();return{...i.previewResult,content:i.previewResult.content?(0,b.$UFb)(i.previewResult.content,"{}",s,n):null}}async sb(i,o,n,s){const t=await this.Cb(),r=await this.Pb();if(this.h.isEqual(o,this.localResource))return{content:i.fileContent?(0,b.$UFb)(i.fileContent.value.toString(),"{}",r,t):null,localChange:0,remoteChange:2};if(this.h.isEqual(o,this.remoteResource))return{content:i.remoteContent!==null?(0,b.$UFb)(i.remoteContent,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:0};if(this.h.isEqual(o,this.previewResource))return n===void 0?{content:i.previewResult.content,localChange:i.previewResult.localChange,remoteChange:i.previewResult.remoteChange}:{content:n!==null?(0,b.$UFb)(n,i.fileContent?i.fileContent.value.toString():"{}",r,t):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${o.toString()}`)}async tb(i,o,n,s){const{fileContent:t}=n[0][0];let{content:r,localChange:a,remoteChange:E}=n[0][1];if(a===0&&E===0&&this.O.info(`${this.D}: No changes found during synchronizing settings.`),r=r?r.trim():"{}",r=r||"{}",this.Qb(r),a!==0&&(this.O.trace(`${this.D}: Updating local settings...`),t&&await this.nb(JSON.stringify(this.Nb(t.value.toString()))),await this.wb(r,t,s),await this.P.reloadConfiguration(3),this.O.info(`${this.D}: Updated local settings`)),E!==0){const y=await this.Cb(),u=this.Lb(i),p=await this.Pb(r);r=(0,b.$UFb)(r,u?u.settings:"{}",p,y),this.O.trace(`${this.D}: Updating remote settings...`),i=await this.mb(JSON.stringify(this.Nb(r)),s?null:i.ref),this.O.info(`${this.D}: Updated remote settings`)}try{await this.G.del(this.previewResource)}catch{}o?.ref!==i.ref&&(this.O.trace(`${this.D}: Updating last synchronized settings...`),await this.fb(i),this.O.info(`${this.D}: Updated last synchronized settings`))}async hasLocalData(){try{const i=await this.vb();if(i)return!(0,b.$WFb)(i.value.toString())}catch(i){if(i.fileOperationResult!==1)return!0}return!1}async resolveContent(i){return this.h.isEqual(this.remoteResource,i)||this.h.isEqual(this.localResource,i)||this.h.isEqual(this.acceptedResource,i)||this.h.isEqual(this.baseResource,i)?this.db(i):null}async db(i){let o=await super.db(i);if(o){const n=await this.Cb(),s=await this.Pb();o=(0,b.$UFb)(o,"{}",s,n)}return o}Lb(i){return i.syncData?this.Mb(i.syncData.content):null}Mb(i){try{return f(i)}catch(o){this.O.error(o)}return null}Nb(i){return{settings:i}}async Pb(i){if(!this.Ob){this.Ob=this.zb.resolveDefaultIgnoredSettings();const n=this.B(L.Event.any(L.Event.filter(this.Eb.onDidInstallExtensions,s=>s.some(({local:t})=>!!t)),L.Event.filter(this.Eb.onDidUninstallExtension,s=>!s.error))(()=>{n.dispose(),this.Ob=void 0}))}const o=await this.Ob;return(0,b.$SFb)(o,this.P,i)}Qb(i){if(this.Ab(i,!1))throw new w.$Qnb((0,D.localize)(0,null),"LocalInvalidContent",this.resource)}};e.$07b=d,e.$07b=d=pe([X(2,g.$qk),X(3,P.$ai),X(4,C.$up),X(5,w.$Lnb),X(6,w.$Mnb),X(7,w.$1nb),X(8,w.$Znb),X(9,A.$zi),X(10,w.$Vnb),X(11,S.$ul),X(12,k.$Bo),X(13,m.$1k)],d);let c=class extends $.$dHb{constructor(i,o,n,s,t,r){super("settings",o,n,s,i,t,r)}async o(i){const o=i.syncData?this.p(i.syncData.content):null;if(!o){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,O.$je.fromString(o.settings)),await this.n(i)}async i(){try{const i=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,b.$WFb)(i.value.toString().trim())}catch(i){return i.fileOperationResult===1}}p(i){try{return f(i)}catch(o){this.j.error(o)}return null}};e.$$7b=c,e.$$7b=c=pe([X(0,g.$qk),X(1,l.$3k),X(2,P.$ai),X(3,w.$1nb),X(4,C.$up),X(5,m.$1k)],c)}),define(le[119],he([0,1,14,3,30,21,15,11,19,22,28,18,39,237,25]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$d8b=e.$c8b=e.$b8b=void 0;function b(f){return JSON.parse(f.content)}e.$b8b=b;let w=class extends m.$aHb{constructor(d,c,v,i,o,n,s,t,r,a,E,y){super({syncResource:"snippets",profile:d},c,i,v,o,n,s,a,E,t,r,y),this.pb=1,this.vb=d.snippetsHome,this.B(this.G.watch(v.userRoamingDataHome)),this.B(this.G.watch(this.vb)),this.B(L.Event.filter(this.G.onDidFilesChange,u=>u.affects(this.vb))(()=>this.Q()))}async qb(d,c,v){const i=await this.Hb(),o=this.Gb(i),n=d.syncData?this.Fb(d.syncData):null;c=c===null&&v?d:c;const s=c&&c.syncData?this.Fb(c.syncData):null;n?this.O.trace(`${this.D}: Merging remote snippets with local snippets...`):this.O.trace(`${this.D}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const t=(0,l.$_7b)(o,n,s);return this.Bb(t,i,n||{},s||{})}async ub(d){const c=d.syncData?this.Fb(d.syncData):null;if(c===null)return!0;const v=await this.Hb(),i=this.Gb(v),o=(0,l.$_7b)(i,c,c);return Object.keys(o.remote.added).length>0||Object.keys(o.remote.updated).length>0||o.remote.removed.length>0||o.conflicts.length>0}async rb(d,c){return d.previewResult}async sb(d,c,v,i){if(this.h.isEqualOrParent(c,this.g.with({scheme:$.$3nb,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(c,this.g.with({scheme:$.$3nb,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(c,this.g))return v===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:v,localChange:v===null?d.fileContent!==null?3:0:2,remoteChange:v===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async tb(d,c,v,i){const o=v.map(([n,s])=>({...n,acceptResult:s}));o.every(({localChange:n,remoteChange:s})=>n===0&&s===0)&&this.O.info(`${this.D}: No changes found during synchronizing snippets.`),o.some(({localChange:n})=>n!==0)&&(await this.Cb(o),await this.Db(o,i)),o.some(({remoteChange:n})=>n!==0)&&(d=await this.Eb(o,d,i)),c?.ref!==d.ref&&(this.O.trace(`${this.D}: Updating last synchronized snippets...`),await this.fb(d),this.O.info(`${this.D}: Updated last synchronized snippets`));for(const{previewResource:n}of o)try{await this.G.del(n)}catch{}}Bb(d,c,v,i){const o=new Map;for(const n of Object.keys(d.local.added)){const s={content:d.local.added[n],hasConflicts:!1,localChange:1,remoteChange:0};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"accepted"})})}for(const n of Object.keys(d.local.updated)){const s={content:d.local.updated[n],hasConflicts:!1,localChange:2,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"accepted"})})}for(const n of d.local.removed){const s={content:null,hasConflicts:!1,localChange:3,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"accepted"})})}for(const n of Object.keys(d.remote.added)){const s={content:d.remote.added[n],hasConflicts:!1,localChange:0,remoteChange:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"accepted"})})}for(const n of Object.keys(d.remote.updated)){const s={content:d.remote.updated[n],hasConflicts:!1,localChange:0,remoteChange:2},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"local"}),fileContent:c[n],localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"accepted"})})}for(const n of d.remote.removed){const s={content:null,hasConflicts:!1,localChange:0,remoteChange:3};o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"remote"}),remoteContent:v[n],previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"accepted"})})}for(const n of d.conflicts){const s={content:i[n]??null,hasConflicts:!0,localChange:c[n]?2:1,remoteChange:v[n]?2:1},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"remote"}),remoteContent:v[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"accepted"})})}for(const n of Object.keys(c))if(!o.has(n)){const s={content:c[n]?c[n].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},t=c[n]?c[n].value.toString():null;o.set(n,{baseResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"base"}),baseContent:i[n]??null,localResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"local"}),fileContent:c[n]||null,localContent:t,remoteResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"remote"}),remoteContent:v[n]||null,previewResource:this.h.joinPath(this.g,n),previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.h.joinPath(this.g,n).with({scheme:$.$3nb,authority:"accepted"})})}return[...o.values()]}async resolveContent(d){return this.h.isEqualOrParent(d,this.g.with({scheme:$.$3nb,authority:"remote"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$3nb,authority:"local"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$3nb,authority:"base"}))||this.h.isEqualOrParent(d,this.g.with({scheme:$.$3nb,authority:"accepted"}))?this.db(d):null}async hasLocalData(){try{const d=await this.Hb();if(Object.keys(d).length)return!0}catch{}return!1}async Cb(d){const c={};for(const v of d)v.fileContent&&(c[this.h.basename(v.localResource)]=v.fileContent);await this.nb(JSON.stringify(this.Gb(c)))}async Db(d,c){for(const{fileContent:v,acceptResult:i,localResource:o,remoteResource:n,localChange:s}of d)if(s!==0){const t=n?this.h.basename(n):this.h.basename(o),r=this.h.joinPath(this.vb,t);s===3?(this.O.trace(`${this.D}: Deleting snippet...`,this.h.basename(r)),await this.G.del(r),this.O.info(`${this.D}: Deleted snippet`,this.h.basename(r))):s===1?(this.O.trace(`${this.D}: Creating snippet...`,this.h.basename(r)),await this.G.createFile(r,O.$je.fromString(i.content),{overwrite:c}),this.O.info(`${this.D}: Created snippet`,this.h.basename(r))):(this.O.trace(`${this.D}: Updating snippet...`,this.h.basename(r)),await this.G.writeFile(r,O.$je.fromString(i.content),c?void 0:v),this.O.info(`${this.D}: Updated snippet`,this.h.basename(r)))}}async Eb(d,c,v){const i=c.syncData?this.Fb(c.syncData):{},o=(0,D.$vn)(i);for(const{acceptResult:n,localResource:s,remoteResource:t,remoteChange:r}of d)if(r!==0){const a=s?this.h.basename(s):this.h.basename(t);r===3?delete o[a]:o[a]=n.content}return(0,l.$a8b)(i,o)||(this.O.trace(`${this.D}: Updating remote snippets...`),c=await this.mb(JSON.stringify(o),v?null:c.ref),this.O.info(`${this.D}: Updated remote snippets`)),c}Fb(d){return b(d)}Gb(d){const c={};for(const v of Object.keys(d))c[v]=d[v].value.toString();return c}async Hb(){const d={};let c;try{c=await this.G.resolve(this.vb)}catch(v){if(v instanceof P.$Lk&&v.fileOperationResult===1)return d;throw v}for(const v of c.children||[]){const i=v.resource,o=this.h.extname(i);if(o===".json"||o===".code-snippets"){const n=this.h.relativePath(this.vb,i),s=await this.G.readFile(i);d[n]=s}}return d}};e.$c8b=w,e.$c8b=w=pe([X(2,I.$ai),X(3,P.$qk),X(4,k.$up),X(5,$.$Lnb),X(6,$.$Mnb),X(7,$.$1nb),X(8,A.$zi),X(9,$.$Vnb),X(10,g.$ul),X(11,C.$1k)],w);let h=class extends m.$dHb{constructor(d,c,v,i,o,n){super("snippets",c,v,i,d,o,n)}async o(d){const c=d.syncData?JSON.parse(d.syncData.content):null;if(!c){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const i of Object.keys(c)){const o=c[i];if(o){const n=this.d.joinPath(this.g.defaultProfile.snippetsHome,i);await this.k.createFile(n,O.$je.fromString(o)),this.j.info("Created snippet",this.d.basename(n))}}await this.n(d)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};e.$d8b=h,e.$d8b=h=pe([X(0,P.$qk),X(1,S.$3k),X(2,I.$ai),X(3,$.$1nb),X(4,k.$up),X(5,C.$1k)],h)}),define(le[120],he([0,1,14,21,15,11,19,22,28,18,39,25]),function(se,e,O,L,D,A,I,P,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$g8b=e.$f8b=e.$e8b=void 0;function m(w,h){try{return JSON.parse(w).tasks??null}catch(f){return h.error(f),null}}e.$e8b=m;let l=class extends C.$bHb{constructor(h,f,d,c,v,i,o,n,s,t,r,a){super(h.tasksResource,{syncResource:"tasks",profile:h},f,n,s,t,d,c,o,r,v,i,a),this.pb=1,this.Ab=this.h.joinPath(this.g,"tasks.json"),this.Bb=this.Ab.with({scheme:S.$3nb,authority:"base"}),this.Cb=this.Ab.with({scheme:S.$3nb,authority:"local"}),this.Db=this.Ab.with({scheme:S.$3nb,authority:"remote"}),this.Eb=this.Ab.with({scheme:S.$3nb,authority:"accepted"})}async qb(h,f,d,c){const v=h.syncData?m(h.syncData.content,this.O):null;f=f===null&&d?h:f;const i=f?.syncData?m(f.syncData.content,this.O):null,o=await this.vb();let n=null,s=!1,t=!1,r=!1;if(h.syncData){const y=o?o.value.toString():null;if(!i||i!==y||i!==v){this.O.trace(`${this.D}: Merging remote tasks with local tasks...`);const u=b(y,v,i);n=u.content,r=u.hasConflicts,s=u.hasLocalChanged,t=u.hasRemoteChanged}}else o&&(this.O.trace(`${this.D}: Remote tasks does not exist. Synchronizing tasks for the first time.`),n=o.value.toString(),t=!0);const a={content:r?i:n,localChange:s?o?2:1:0,remoteChange:t?2:0,hasConflicts:r},E=o?o.value.toString():null;return[{fileContent:o,baseResource:this.Bb,baseContent:i,localResource:this.Cb,localContent:E,localChange:a.localChange,remoteResource:this.Db,remoteContent:v,remoteChange:a.remoteChange,previewResource:this.Ab,previewResult:a,acceptedResource:this.Eb}]}async ub(h){const f=h?.syncData?m(h.syncData.content,this.O):null;if(f===null)return!0;const d=await this.vb(),c=d?d.value.toString():null,v=b(c,f,f);return v.hasLocalChanged||v.hasRemoteChanged}async rb(h,f){return h.previewResult}async sb(h,f,d,c){if(this.h.isEqual(f,this.Cb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(f,this.Db))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(f,this.Ab))return d===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:d,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${f.toString()}`)}async tb(h,f,d,c){const{fileContent:v}=d[0][0],{content:i,localChange:o,remoteChange:n}=d[0][1];if(o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing tasks.`),o!==0&&(this.O.trace(`${this.D}: Updating local tasks...`),v&&await this.nb(JSON.stringify(this.Kb(v.value.toString()))),i?await this.wb(i,v,c):await this.xb(),this.O.info(`${this.D}: Updated local tasks`)),n!==0){this.O.trace(`${this.D}: Updating remote tasks...`);const s=JSON.stringify(this.Kb(i));h=await this.mb(s,c?null:h.ref),this.O.info(`${this.D}: Updated remote tasks`)}try{await this.G.del(this.Ab)}catch{}f?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized tasks...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized tasks`))}async hasLocalData(){return this.G.exists(this.r)}async resolveContent(h){return this.h.isEqual(this.Db,h)||this.h.isEqual(this.Bb,h)||this.h.isEqual(this.Cb,h)||this.h.isEqual(this.Eb,h)?this.db(h):null}Kb(h){return h?{tasks:h}:{}}};e.$f8b=l,e.$f8b=l=pe([X(2,S.$Lnb),X(3,S.$Mnb),X(4,S.$1nb),X(5,L.$zi),X(6,S.$Vnb),X(7,A.$qk),X(8,D.$ai),X(9,I.$up),X(10,P.$ul),X(11,k.$1k)],l);let $=class extends C.$dHb{constructor(h,f,d,c,v,i){super("tasks",f,d,c,h,v,i),this.c=this.g.defaultProfile.tasksResource}async o(h){const f=h.syncData?m(h.syncData.content,this.j):null;if(!f){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,O.$je.fromString(f)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.$g8b=$,e.$g8b=$=pe([X(0,A.$qk),X(1,g.$3k),X(2,D.$ai),X(3,S.$1nb),X(4,I.$up),X(5,k.$1k)],$);function b(w,h,f){if(w===null&&h===null&&f===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(w===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const d=f!==w,c=f!==h;return!d&&!c?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:d&&!c?{content:w,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:c&&!d?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:w,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(le[121],he([0,1,42,21,15,11,19,22,28,18,39,238,25]),function(se,e,O,L,D,A,I,P,k,g,C,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z9b=e.$Y9b=e.$X9b=void 0;let l=class extends C.$aHb{constructor(h,f,d,c,v,i,o,n,s,t,r,a,E){super({syncResource:"profiles",profile:h},f,c,v,i,o,n,r,a,s,t,E),this.vb=d,this.pb=2,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.$3nb,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.$3nb,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.$3nb,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.$3nb,authority:"accepted"}),this.B(d.onDidChangeProfiles(()=>this.Q()))}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?b(h.syncData):null}async getRemoteSyncedProfiles(h){const f=await this.getLastSyncUserData(),d=await this.X(h,f);return d?.syncData?b(d.syncData):null}async qb(h,f,d){if(!this.vb.isEnabled())throw new m.$Qnb("Cannot sync profiles because they are disabled","LocalError");const c=h.syncData?b(h.syncData):null,v=f?.syncData?b(f.syncData):null,i=this.Db(),{local:o,remote:n}=(0,S.$W9b)(i,c,v,[]),s={local:o,remote:n,content:v?this.Eb(v):null,localChange:o.added.length>0||o.removed.length>0||o.updated.length>0?2:0,remoteChange:n!==null?2:0},t=$(i,!1);return[{baseResource:this.baseResource,baseContent:v?this.Eb(v):null,localResource:this.localResource,localContent:t,remoteResource:this.remoteResource,remoteContent:c?this.Eb(c):null,remoteProfiles:c,previewResource:this.previewResource,previewResult:s,localChange:s.localChange,remoteChange:s.remoteChange,acceptedResource:this.acceptedResource}]}async ub(h){const f=h?.syncData?b(h.syncData):null,d=this.Db(),{remote:c}=(0,S.$W9b)(d,f,f,[]);return!!c?.added.length||!!c?.removed.length||!!c?.updated.length}async rb(h,f){return{...h.previewResult,hasConflicts:!1}}async sb(h,f,d,c){if(this.h.isEqual(f,this.localResource))return this.Ab(h);if(this.h.isEqual(f,this.remoteResource))return this.Bb(h);if(this.h.isEqual(f,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${f.toString()}`)}async Ab(h){const f=this.Db(),d=(0,S.$W9b)(f,null,null,[]),{local:c,remote:v}=d;return{content:h.localContent,local:c,remote:v,localChange:c.added.length>0||c.removed.length>0||c.updated.length>0?2:0,remoteChange:v!==null?2:0}}async Bb(h){const f=h.remoteContent?JSON.parse(h.remoteContent):null,d=[],c=[];for(const v of this.Db()){const i=f?.find(o=>o.id===v.id);i&&(d.push({id:v.id,name:v.name,collection:i.collection}),c.push(v))}if(f!==null){const v=(0,S.$W9b)(c,f,d,[]),{local:i,remote:o}=v;return{content:h.remoteContent,local:i,remote:o,localChange:i.added.length>0||i.removed.length>0||i.updated.length>0?2:0,remoteChange:o!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async tb(h,f,d,c){const{local:v,remote:i,localChange:o,remoteChange:n}=d[0][1];o===0&&n===0&&this.O.info(`${this.D}: No changes found during synchronizing profiles.`);const s=d[0][0].remoteProfiles||[];if(s.length+(i?.added.length??0)-(i?.removed.length??0)>20)throw new m.$Qnb("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(o!==0){await this.nb($(this.Db(),!1));const t=[];for(const r of v.added)t.push((async()=>{this.O.trace(`${this.D}: Creating '${r.name}' profile...`),await this.vb.createProfile(r.id,r.name,{shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Created profile '${r.name}'.`)})());for(const r of v.removed)t.push((async()=>{this.O.trace(`${this.D}: Removing '${r.name}' profile...`),await this.vb.removeProfile(r),this.O.info(`${this.D}: Removed profile '${r.name}'.`)})());for(const r of v.updated){const a=this.vb.profiles.find(E=>E.id===r.id);a?t.push((async()=>{this.O.trace(`${this.D}: Updating '${r.name}' profile...`),await this.vb.updateProfile(a,{name:r.name,shortName:r.shortName,icon:r.icon,useDefaultFlags:r.useDefaultFlags}),this.O.info(`${this.D}: Updated profile '${r.name}'.`)})()):this.O.info(`${this.D}: Could not find profile with id '${r.id}' to update.`)}await Promise.all(t)}if(n!==0){this.O.trace(`${this.D}: Updating remote profiles...`);const t=[],r=s.length+(i?.added.length??0)<=20;if(r)for(const a of i?.added||[]){const E=await this.J.createCollection(this.F);t.push(E),s.push({id:a.id,name:a.name,collection:E,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}else this.O.info(`${this.D}: Could not create remote profiles as there are too many profiles.`);for(const a of i?.removed||[])s.splice(s.findIndex(({id:E})=>a.id===E),1);for(const a of i?.updated||[]){const E=s.find(({id:y})=>a.id===y);E&&s.splice(s.indexOf(E),1,{...E,id:a.id,name:a.name,shortName:a.shortName,icon:a.icon,useDefaultFlags:a.useDefaultFlags})}try{h=await this.updateRemoteProfiles(s,c?null:h.ref),this.O.info(`${this.D}: Updated remote profiles.${r&&i?.added.length?` Added: ${JSON.stringify(i.added.map(a=>a.name))}.`:""}${i?.updated.length?` Updated: ${JSON.stringify(i.updated.map(a=>a.name))}.`:""}${i?.removed.length?` Removed: ${JSON.stringify(i.removed.map(a=>a.name))}.`:""}`)}catch(a){if(t.length){this.O.info(`${this.D}: Failed to update remote profiles. Cleaning up added collections...`);for(const E of t)await this.J.deleteCollection(E,this.F)}throw a}for(const a of i?.removed||[])await this.J.deleteCollection(a.collection,this.F)}f?.ref!==h.ref&&(this.O.trace(`${this.D}: Updating last synchronized profiles...`),await this.fb(h),this.O.info(`${this.D}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,f){return this.mb(this.Eb(h),f)}async hasLocalData(){return this.Db().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const f=await this.db(h);return f&&(0,O.$nn)(JSON.parse(f),{})}return null}Db(){return this.vb.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Eb(h){return JSON.stringify([...h].sort((f,d)=>f.name.localeCompare(d.name)))}};e.$X9b=l,e.$X9b=l=pe([X(2,g.$3k),X(3,A.$qk),X(4,D.$ai),X(5,I.$up),X(6,m.$Lnb),X(7,m.$Mnb),X(8,m.$1nb),X(9,L.$zi),X(10,m.$Vnb),X(11,P.$ul),X(12,k.$1k)],l);function $(w,h){const f=[...w].sort((d,c)=>d.name.localeCompare(c.name)).map(d=>({id:d.id,name:d.name}));return h?(0,O.$nn)(f,{}):JSON.stringify(f)}e.$Y9b=$;function b(w){return JSON.parse(w.content)}e.$Z9b=b}),define(le[255],he([0,1,3,2,5,15,19,22,25]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$K9b=void 0;const g="sync.enable";let C=class extends L.$Tc{constructor(m,l,$,b){super(),this.c=m,this.f=l,this.g=$,this.h=b,this.a=new O.$Vd,this.onDidChangeEnablement=this.a.event,this.b=new O.$Vd,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(-1,void 0,this.B(new L.$Sc))(w=>this.m(w)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(g,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(g,{enabled:m}),this.c.store(g,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,k.$Unb)(m),-1,!0)}setResourceEnablement(m,l){if(this.isResourceEnabled(m)!==l){const $=(0,k.$Unb)(m);this.j($,l)}}getResourceSyncStateVersion(m){}j(m,l){this.c.store(m,l,-1,D.$o?0:1)}m(m){if(g===m.key){this.a.fire(this.isEnabled());return}const l=k.$Hnb.filter($=>(0,k.$Unb)($)===m.key)[0];if(l){this.b.fire([l,this.isResourceEnabled(l)]);return}}};e.$K9b=C,e.$K9b=C=pe([X(0,I.$up),X(1,P.$ul),X(2,A.$ai),X(3,k.$Knb)],C)}),define(le[256],he([0,1,6,14,65,2,20,21,15,11,18,25]),function(se,e,O,L,D,A,I,P,k,g,C,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V9b=void 0;let m=class extends A.$Tc{constructor($,b,w,h,f){super(),this.a=$,this.b=b,this.c=w,this.f=h,this.g=f,this.h()}async h(){for(const b of this.g.profiles)for(const w of S.$Hnb)try{await this.m(this.j(w,b.isDefault?void 0:b.id))}catch(h){this.f.error(h)}let $;try{$=await this.b.resolve(this.a.userDataSyncHome)}catch(b){(0,g.$Hk)(b)!==1&&this.f.error(b);return}if($.children){for(const b of $.children)if(b.isDirectory&&!this.g.profiles.some(w=>w.id===b.name))try{this.f.info("Deleting non existing profile from backup",b.resource.path),await this.b.del(b.resource,{recursive:!0})}catch(w){this.f.error(w)}}}async getAllResourceRefs($,b,w){const h=this.j($,b,w);try{const f=await this.b.resolve(h);if(f.children)return f.children.filter(c=>c.isFile&&!c.name.startsWith("lastSync")).sort().reverse().map(c=>({ref:c.name,created:this.n(c)}))}catch(f){if((0,g.$Hk)(f)!==1)throw f}return[]}async resolveResourceContent($,b,w,h){const f=this.j($,w,h),d=(0,I.$Hg)(f,b);try{return(await this.b.readFile(d)).value.toString()}catch(c){return this.f.error(c),null}}async writeResource($,b,w,h,f){const d=this.j($,h,f),c=(0,I.$Hg)(d,`${(0,D.$wm)(w).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(c,L.$je.fromString(b))}catch(v){this.f.error(v)}}j($,b,w=this.a.userDataSyncHome){return(0,I.$Hg)(w,...b?[b,$]:[$])}async m($){try{try{if(!await this.b.exists($))return}catch{return}const b=await this.b.resolve($);if(b.children){const w=b.children.filter(c=>c.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(c.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let f=w.filter(c=>Date.now()-this.n(c)>h);const d=w.length-f.length;d<10&&(f=f.slice(10-d)),await O.Promises.settled(f.map(async c=>{this.f.info("Deleting from backup",c.resource.path),await this.b.del(c.resource)}))}}catch(b){this.f.error(b)}}n($){return new Date(parseInt($.name.substring(0,4)),parseInt($.name.substring(4,6))-1,parseInt($.name.substring(6,8)),parseInt($.name.substring(9,11)),parseInt($.name.substring(11,13)),parseInt($.name.substring(13,15))).getTime()}};e.$V9b=m,e.$V9b=m=pe([X(0,k.$ai),X(1,g.$qk),X(2,P.$zi),X(3,S.$1nb),X(4,C.$3k)],m)}),define(le[84],he([0,1,3,2,5,27,176,15,11,4,24,43,19,25]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l){"use strict";var $;Object.defineProperty(e,"__esModule",{value:!0}),e.$Anb=e.$znb=e.$ynb=void 0,e.$ynb=(0,g.$6h)("IUserDataSyncMachinesService");const b="sync.currentMachineName",w="Safari",h="Chrome",f="Edge",d="Firefox",c="Android";function v(n){switch(n){case w:case h:case f:case d:case c:case(0,D.$h)(0):return!0}return!1}e.$znb=v;function i(){return D.$G?w:D.$E?h:D.$H?f:D.$F?d:D.$I?c:(0,D.$h)(D.$o?0:D.$u)}let o=class extends L.$Tc{static{$=this}static{this.a=1}static{this.b="machines"}constructor(s,t,r,a,E,y){super(),this.h=r,this.j=a,this.m=E,this.n=y,this.c=this.B(new O.$Vd),this.onDidChange=this.c.event,this.g=null,this.f=(0,S.$Ap)(s,t,r)}async getMachines(s){const t=await this.f;return(await this.s(s)).machines.map(a=>({...a,isCurrent:a.id===t}))}async addCurrentMachine(s){const t=await this.f,r=await this.s(s);r.machines.some(({id:a})=>a===t)||(r.machines.push({id:t,name:this.r(r.machines),platform:i()}),await this.t(r))}async removeCurrentMachine(s){const t=await this.f,r=await this.s(s),a=r.machines.filter(({id:E})=>E!==t);a.length!==r.machines.length&&(r.machines=a,await this.t(r))}async renameMachine(s,t,r){const a=await this.s(r),E=a.machines.find(({id:y})=>y===s);if(E){E.name=t,await this.t(a);const y=await this.f;s===y&&this.h.store(b,t,-1,1)}}async setEnablements(s){const t=await this.s();for(const[r,a]of s){const E=t.machines.find(y=>y.id===r);E&&(E.disabled=a?void 0:!0)}await this.t(t)}r(s){const t=this.h.get(b,-1);if(t)return t;const r=`${this.n.embedderIdentifier?`${this.n.embedderIdentifier} - `:""}${i()} (${this.n.nameShort})`,a=new RegExp(`${(0,A.$Oe)(r)}\\s#(\\d+)`);let E=0;for(const y of s){const u=a.exec(y.name),p=u?parseInt(u[1]):0;E=p>E?p:E}return`${r} #${E+1}`}async s(s){this.g=await this.u(s);const t=this.w(this.g);if(t.version!==$.a)throw new Error((0,I.localize)(0,null,this.n.nameLong));return t}async t(s){const t=JSON.stringify(s),r=await this.j.writeResource($.b,t,this.g?.ref||null);this.g={ref:r,content:t},this.c.fire()}async u(s){if(this.g){const t=s&&s.latest?s.latest[$.b]:void 0;if(this.g.ref===t)return this.g;if(t===void 0&&this.g.content===null)return this.g}return this.j.readResource($.b,this.g)}w(s){if(s.content!==null)try{return JSON.parse(s.content)}catch(t){this.m.error(t)}return{version:$.a,machines:[]}}};e.$Anb=o,e.$Anb=o=$=pe([X(0,P.$ai),X(1,k.$qk),X(2,m.$up),X(3,l.$Lnb),X(4,l.$1nb),X(5,C.$Fj)],o)}),define(le[257],he([0,1,6,65,38,7,3,2,5,20,10,173,24,19,22,25,81,84]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$29b=void 0;const f="sync.disableMachineEventually",d="sync.sessionId",c="sync.storeUrl",v="sync.productQuality";let i=class extends P.$Tc{get n(){const s=this.H.get(c,-1);return s?C.URI.parse(s):void 0}set n(s){s?this.H.store(c,s.toString(),-1,1):this.H.remove(c,-1)}get s(){return this.H.get(v,-1)}set s(s){s?this.H.store(v,s,-1,1):this.H.remove(v,-1)}constructor(s,t,r,a,E,y,u,p,R,N){super(),this.u=t,this.w=r,this.y=a,this.z=E,this.C=y,this.D=u,this.F=p,this.G=R,this.H=N,this.a=this.B(new P.$Uc),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new I.$Vd),this.onError=this.h.event,this.S=[],this.f=this.B(new O.$4g(this.U())),this.j=this.n,this.n=t.userDataSyncStore?.url,this.r=this.s,this.s=s.quality,this.n&&(this.C.info("Using settings sync service",this.n.toString()),this.B(t.onDidChangeUserDataSyncStore(()=>{(0,g.$Ag)(this.n,t.userDataSyncStore?.url)||(this.j=this.n,this.n=t.userDataSyncStore?.url,this.n&&this.C.info("Using settings sync service",this.n.toString()))})),this.y.isEnabled()?this.C.info("Auto Sync is enabled."):this.C.info("Auto Sync is disabled."),this.I(),this.Q()&&this.P(),this.B(u.onDidChangeAccount(()=>this.I())),this.B(r.onDidChangeDonotMakeRequestsUntil(()=>this.I())),this.B(E.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this.B(I.Event.filter(this.y.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.u.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}I(){const{enabled:s,message:t}=this.L();s?this.a.value===void 0&&(this.a.value=new o(this.j,1e3*60*5,this.u,this.w,this.z,this.G,this.C,this.F,this.H),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(r=>this.O(r))),this.J()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(t&&this.C.info(t),this.a.clear()):t&&this.y.isEnabled()&&this.C.info(t))}J(){return!0}L(){return this.y.isEnabled()?this.D.account?this.w.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,L.$wm)(this.w.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.R(),this.j=this.n,this.M(!0)}async turnOff(s,t,r){try{this.D.account&&!r&&await this.G.removeCurrentMachine(),this.M(!1),this.H.remove(d,-1),s?(this.F.publicLog2("sync/turnOffEveryWhere"),await this.z.reset()):await this.z.resetLocal()}catch(a){if(this.C.error(a),t)this.M(!1);else throw a}}M(s){this.y.isEnabled()!==s&&(this.y.setEnablement(s),this.I())}N(){return!!this.r&&!!this.s&&this.r!==this.s}async O(s){if(!s){this.b=0;return}const t=b.$Qnb.toUserDataSyncError(s);t instanceof b.$Snb&&this.F.publicLog2("autosync/error",{code:t.code,service:this.u.userDataSyncStore.url.toString()}),t.code==="SessionExpired"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current session is expired")):t.code==="TurnedOff"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):t.code==="LocalTooManyRequests"?(this.g=!0,this.C.info("Auto Sync: Suspended sync because of making too many requests to server"),this.I()):t.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because of making too many requests to server")):t.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):t.code==="UpgradeRequired"||t.code==="Gone"?(await this.turnOff(!1,!0,!0),this.P(),this.C.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):t.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with newer version than of client. Requires client upgrade.`)):t.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.C.info(`Auto Sync: Turned off sync because server has ${t.resource} content with older version than of client. Requires server reset.`)):t.code==="ServiceChanged"||t.code==="DefaultServiceChanged"?k.$o&&t.code==="DefaultServiceChanged"&&!this.N()?(await this.turnOff(!1,!0),this.C.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.C.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.C.error(t),this.b++),this.h.fire(t)}async P(){this.H.store(f,!0,-1,1),await(0,O.$7g)(1e3*60*10),this.Q()&&(this.R(),!this.y.isEnabled()&&this.D.account&&await this.G.removeCurrentMachine())}Q(){return this.H.getBoolean(f,-1,!1)}R(){this.H.remove(f,-1)}async triggerSync(s,t,r){if(this.a.value===void 0)return this.f.cancel();if(t&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.C.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.S.push(...s),this.f.trigger(async()=>{this.C.trace("activity sources",...this.S);const a=this.D.account?.authenticationProviderId||"";this.F.publicLog2("sync/triggered",{sources:this.S,providerId:a}),this.S=[],this.a.value&&await this.a.value.sync("Activity",r)},this.b?this.U()*1*Math.min(Math.pow(2,this.b),60):this.U())}U(){return 2e3}};e.$29b=i,e.$29b=i=pe([X(0,m.$Fj),X(1,b.$Knb),X(2,b.$Lnb),X(3,b.$Vnb),X(4,b.$Wnb),X(5,b.$1nb),X(6,w.$CFb),X(7,$.$ul),X(8,h.$ynb),X(9,l.$up)],i);class o extends P.$Tc{static{this.a="Interval"}constructor(s,t,r,a,E,y,u,p,R){super(),this.m=s,this.n=t,this.r=r,this.s=a,this.u=E,this.w=y,this.y=u,this.z=p,this.C=R,this.b=this.B(new P.$Uc),this.c=this.B(new I.$Vd),this.onDidStartSync=this.c.event,this.f=this.B(new I.$Vd),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.D())),this.B((0,P.$Rc)(()=>{this.j&&(this.j.cancel(),this.y.info("Auto sync: Cancelled sync that is in progress"),this.j=void 0),this.h?.stop(),this.y.info("Auto Sync: Stopped")})),this.sync(o.a,!1)}D(){this.b.value=(0,O.$8g)(()=>{this.sync(o.a,!1),this.b.value=void 0},this.n)}sync(s,t){const r=(0,O.$Tg)(async a=>{if(this.j)try{this.y.debug("Auto Sync: Waiting until sync is finished."),await this.j}catch(E){if((0,A.$4)(E))return}return this.H(s,t,a)});return this.j=r,this.j.finally(()=>this.j=void 0),this.j}F(){return this.m!==void 0&&!(0,g.$Ag)(this.m,this.r.userDataSyncStore?.url)}async G(){const s=await this.r.getPreviousUserDataSyncStore(),t=this.r.userDataSyncStore;return!!t&&!!s&&(!(0,g.$Ag)(t.defaultUrl,s.defaultUrl)||!(0,g.$Ag)(t.insidersUrl,s.insidersUrl)||!(0,g.$Ag)(t.stableUrl,s.stableUrl))}async H(s,t,r){this.y.info(`Auto Sync: Triggered by ${s}`),this.c.fire();let a;try{await this.I(t,r)}catch(E){if(this.y.error(E),a=E,b.$Qnb.toUserDataSyncError(E).code==="MethodNotFound")try{this.y.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.u.cleanUpRemoteData(),this.y.info("Auto Sync: Retrying sync..."),await this.I(t,r),a=void 0}catch(y){this.y.error(y),a=y}}this.f.fire(a)}async I(s,t){if(this.h=await this.u.createSyncTask(this.g,s),t.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.u.hasPreviouslySynced())throw this.F()?await this.G()?new b.$Snb((0,S.localize)(0,null),"DefaultServiceChanged"):new b.$Snb((0,S.localize)(1,null),"ServiceChanged"):new b.$Snb((0,S.localize)(2,null),"TurnedOff");const r=this.C.get(d,-1);if(r&&this.g&&r!==this.g.session)throw this.F()?await this.G()?new b.$Snb((0,S.localize)(3,null),"DefaultServiceChanged"):new b.$Snb((0,S.localize)(4,null),"ServiceChanged"):new b.$Snb((0,S.localize)(5,null),"SessionExpired");const a=await this.w.getMachines(this.g||void 0);if(t.isCancellationRequested)return;const E=a.find(u=>u.isCurrent);if(E?.disabled)throw new b.$Snb((0,S.localize)(6,null),"TurnedOff");const y=new Date().getTime();if(await this.h.run(),this.z.publicLog2("settingsSync:sync",{duration:new Date().getTime()-y}),this.g===null)try{this.g=await this.s.manifest(null)}catch(u){throw new b.$Snb((0,D.$Qi)(u),u instanceof b.$Qnb?u.code:"Unknown")}this.g&&this.g.session!==r&&this.C.store(d,this.g.session,-1,1),!t.isCancellationRequested&&(E||await this.w.addCurrentMachine(this.g||void 0))}register(s){return super.B(s)}}}),define(le[258],he([0,1,10,177,15,11,43,19,28,25,18,39,119,118,117,21,120,115,116,4,121,42,27]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v,i){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$x0b=void 0;let n=class{static{o=this}static{this.a="not-existing-resource"}static{this.b="remote-backup"}static{this.c="local-backup"}constructor(t,r,a,E,y,u,p,R,N,T){this.e=t,this.f=r,this.g=a,this.h=y,this.i=u,this.j=p,this.k=R,this.l=N,this.n=T,this.d=E.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const r=this.L(t.content,"profiles");return(0,c.$Z9b)(r)}return[]}async getLocalSyncedProfiles(t){const r=await this.f.getAllResourceRefs("profiles",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("profiles",r[0].ref,void 0,t);if(a){const E=this.L(a,"profiles");return(0,c.$Z9b)(E)}}return[]}async getLocalSyncedMachines(t){const r=await this.f.getAllResourceRefs("machines",void 0,t);if(r.length){const a=await this.f.resolveResourceContent("machines",r[0].ref,void 0,t);if(a)return JSON.parse(a).machines.map(y=>({...y,isCurrent:!1}))}return[]}async getRemoteSyncResourceHandles(t,r){return(await this.e.getAllResourceRefs(t,r?.collection)).map(({created:E,ref:y})=>({created:E,uri:this.J({remote:!0,syncResource:t,profile:r?.id??this.k.defaultProfile.id,location:void 0,collection:r?.collection,ref:y,node:void 0})}))}async getLocalSyncResourceHandles(t,r,a){return(await this.f.getAllResourceRefs(t,r?.collection,a)).map(({created:y,ref:u})=>({created:y,uri:this.J({remote:!1,syncResource:t,profile:r?.id??this.k.defaultProfile.id,collection:r?.collection,ref:u,node:void 0,location:a})}))}resolveUserDataSyncResource({uri:t}){const r=this.K(t),a=r?this.k.profiles.find(E=>E.id===r.profile):void 0;return r&&a?{profile:a,syncResource:r?.syncResource}:void 0}async getAssociatedResources({uri:t}){const r=this.K(t);if(!r)return[];const a=this.k.profiles.find(E=>E.id===r.profile);switch(r.syncResource){case"settings":return this.s(t,a);case"keybindings":return this.u(t,a);case"tasks":return this.w(t,a);case"snippets":return this.y(t,a);case"globalState":return this.D(t,a);case"extensions":return this.A(t,a);case"profiles":return this.G(t,a);case"workspaceState":return[]}}async getMachineId({uri:t}){const r=this.K(t);if(r){if(r.remote){if(r.ref){const{content:a}=await this.M(r.syncResource,r.ref,r.collection);if(a)return this.L(a,r.syncResource)?.machineId}return}if(r.location){if(r.ref){const a=await this.f.resolveResourceContent(r.syncResource,r.ref,r.collection,r.location);if(a)return this.L(a,r.syncResource)?.machineId}return}return(0,I.$Ap)(this.h,this.j,this.i)}}async resolveContent(t){const r=this.K(t);if(!r||r.node===o.a)return null;if(r.ref){const a=await this.o(r.remote,r.syncResource,r.collection,r.ref,r.location);return r.node&&a?this.q(r.syncResource,a,r.node):a}return!r.remote&&!r.node?this.r(r.syncResource,r.profile):null}async o(t,r,a,E,y){if(t){const{content:u}=await this.M(r,E,a);return u}return this.f.resolveResourceContent(r,E,a,y)}q(t,r,a){const E=this.L(r,t);switch(t){case"settings":return this.t(E,a);case"keybindings":return this.v(E,a);case"tasks":return this.x(E,a);case"snippets":return this.z(E,a);case"globalState":return this.E(E,a);case"extensions":return this.B(E,a);case"profiles":return this.H(E,a);case"workspaceState":return null}}async r(t,r){const a=this.k.profiles.find(E=>E.id===r);if(!a)return null;switch(t){case"globalState":return this.F(a);case"extensions":return this.C(a);case"profiles":return this.I(a);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null;case"workspaceState":return null}}s(t,r){const a=this.d.joinPath(t,"settings.json"),E=r?r.settingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}t(t,r){switch(r){case"settings.json":return(0,l.$97b)(t.content).settings}return null}u(t,r){const a=this.d.joinPath(t,"keybindings.json"),E=r?r.keybindingsResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}v(t,r){switch(r){case"keybindings.json":return(0,$.$67b)(t.content,!!this.l.getValue(g.$Enb),this.g)}return null}w(t,r){const a=this.d.joinPath(t,"tasks.json"),E=r?r.tasksResource:this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}x(t,r){switch(r){case"tasks.json":return(0,w.$e8b)(t.content,this.g)}return null}async y(t,r){const a=await this.resolveContent(t);if(a){const E=this.L(a,"snippets");if(E){const y=(0,m.$b8b)(E),u=[];for(const p of Object.keys(y)){const R=this.d.joinPath(t,p),N=r?this.d.joinPath(r.snippetsHome,p):this.d.joinPath(t,o.a);u.push({resource:R,comparableResource:N})}return u}}return[]}z(t,r){return(0,m.$b8b)(t)[r]||null}A(t,r){const a=this.d.joinPath(t,"extensions.json"),E=r?this.J({remote:!1,syncResource:"extensions",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}B(t,r){switch(r){case"extensions.json":return(0,h.$17b)((0,h.$Z7b)(t),!0)}return null}async C(t){const{localExtensions:r}=await this.n.createInstance(h.$37b).getLocalExtensions(t);return(0,h.$17b)(r,!0)}D(t,r){const a=this.d.joinPath(t,"globalState.json"),E=r?this.J({remote:!1,syncResource:"globalState",profile:r.id,location:void 0,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,o.a);return[{resource:a,comparableResource:E}]}E(t,r){switch(r){case"globalState.json":return(0,f.$fHb)(JSON.parse(t.content),!0)}return null}async F(t){const r=await this.n.createInstance(f.$hHb).getLocalGlobalState(t);return(0,f.$fHb)(r,!0)}G(t,r){const a=this.d.joinPath(t,"profiles.json"),E=this.J({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,location:void 0,collection:void 0,ref:void 0,node:void 0});return[{resource:a,comparableResource:E}]}H(t,r){switch(r){case"profiles.json":return(0,v.$nn)(JSON.parse(t.content),{})}return null}async I(t){return(0,c.$Y9b)(this.k.profiles.filter(r=>!r.isDefault&&!r.isTransient),!0)}J(t){const r=t.remote?o.b:o.c,a=[];return t.location&&(a.push(`scheme:${t.location.scheme}`),a.push(`authority:${t.location.authority}`),a.push((0,i.$Se)(t.location.path,"/"))),a.push(`syncResource:${t.syncResource}`),a.push(`profile:${t.profile}`),t.collection&&a.push(`collection:${t.collection}`),t.ref&&a.push(`ref:${t.ref}`),t.node&&a.push(t.node),this.d.joinPath(O.URI.from({scheme:g.$3nb,authority:r,path:"/",query:t.location?.query,fragment:t.location?.fragment}),...a)}K(t){if(t.scheme!==g.$3nb)return;const r=[];for(;t.path!=="/";)r.unshift(this.d.basename(t)),t=this.d.dirname(t);if(r.length<2)return;const a=t.authority===o.b;let E,y;const u=[];let p,R,N,T,M;for(;r.length;){const U=r.shift();U.startsWith("scheme:")?E=U.substring(7):U.startsWith("authority:")?y=U.substring(10):U.startsWith("syncResource:")?p=U.substring(13):U.startsWith("profile:")?R=U.substring(8):U.startsWith("collection:")?N=U.substring(11):U.startsWith("ref:")?T=U.substring(4):p?M=U:u.push(U)}return{remote:a,syncResource:p,profile:R,collection:N,ref:T,node:M,location:E&&y!==void 0?this.d.joinPath(O.URI.from({scheme:E,authority:y,query:t.query,fragment:t.fragment,path:"/"}),...u):void 0}}L(t,r){try{const a=JSON.parse(t);if((0,S.$$Gb)(a))return a}catch(a){this.g.error(a)}throw new g.$Qnb((0,L.localize)(0,null),"IncompatibleRemoteContent",r)}async M(t,r,a){const E=await this.e.resolveResourceContent(t,r,a);return{ref:r,content:E}}};e.$x0b=n,e.$x0b=n=o=pe([X(0,g.$Lnb),X(1,g.$Mnb),X(2,g.$1nb),X(3,k.$1k),X(4,D.$ai),X(5,P.$up),X(6,A.$qk),X(7,C.$3k),X(8,b.$zi),X(9,d.$5h)],n)}),define(le[259],he([0,1,17,6,26,38,3,2,20,12,32,21,29,11,4,19,22,18,115,116,117,118,119,120,121,25]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v,i,o,n,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$19b=void 0;const t="sync.lastSyncTime";let r=class extends P.$Tc{get status(){return this.f}get conflicts(){return this.j}get lastSyncTime(){return this.t}constructor(p,R,N,T,M,U,Y,Q,x,H,Z){super(),this.C=p,this.D=R,this.F=N,this.G=T,this.H=M,this.I=U,this.J=Y,this.L=Q,this.M=x,this.N=H,this.O=Z,this.f="uninitialized",this.g=this.B(new I.$Vd),this.onDidChangeStatus=this.g.event,this.h=this.B(new I.$Vd),this.onDidChangeLocal=this.h.event,this.j=[],this.m=this.B(new I.$Vd),this.onDidChangeConflicts=this.m.event,this.n=[],this.r=this.B(new I.$Vd),this.onSyncErrors=this.r.event,this.t=void 0,this.u=this.B(new I.$Vd),this.onDidChangeLastSyncTime=this.u.event,this.w=this.B(new I.$Vd),this.onDidResetLocal=this.w.event,this.y=this.B(new I.$Vd),this.onDidResetRemote=this.y.event,this.z=new Map,this.f=N.userDataSyncStore?"idle":"uninitialized",this.t=this.J.getNumber(t,-1,void 0),this.B((0,P.$Rc)(()=>this.bb()))}async createSyncTask(p,R){this.cb(),this.H.info("Sync started.");const N=new Date().getTime(),T=(0,C.$qg)();try{const Q=(0,s.$Pnb)(T);R&&(Q["Cache-Control"]="no-cache"),p=await this.D.manifest(p,Q)}catch(Q){const x=s.$Qnb.toUserDataSyncError(Q);throw y(x,T,this.F,this.I),x}const M=!1,U=this;let Y;return{manifest:p,async run(){if(M)throw new Error("Can run a task only once");Y=(0,L.$Tg)(Q=>U.P(p,!1,T,Q)),await Y.finally(()=>Y=void 0),U.H.info(`Sync done. Took ${new Date().getTime()-N}ms`),U.$()},stop(){return Y?.cancel(),U.U()}}}async createManualSyncTask(){if(this.cb(),this.L.isEnabled())throw new s.$Qnb("Cannot start manual sync when sync is enabled","LocalError");this.H.info("Sync started.");const p=new Date().getTime(),R=(0,C.$qg)(),N=(0,s.$Pnb)(R);let T;try{T=await this.D.manifest(null,N)}catch(Y){const Q=s.$Qnb.toUserDataSyncError(Y);throw y(Q,R,this.F,this.I),Q}await this.resetLocal();const M=this,U=new D.$6d;return{id:R,async merge(){return M.P(T,!0,R,U.token)},async apply(){try{try{await M.R(T,R,U.token)}catch(Y){if(s.$Qnb.toUserDataSyncError(Y).code==="MethodNotFound")M.H.info("Client is making invalid requests. Cleaning up data..."),await M.cleanUpRemoteData(),M.H.info("Applying manual sync again..."),await M.R(T,R,U.token);else throw Y}}catch(Y){throw M.H.error(Y),Y}M.H.info(`Sync done. Took ${new Date().getTime()-p}ms`),M.$()},async stop(){U.cancel(),await M.U(),await M.resetLocal()}}}async P(p,R,N,T){this.n=[];try{this.status!=="hasConflicts"&&this.Y("syncing");const M=this.getOrCreateActiveProfileSynchronizer(this.M.defaultProfile,void 0);this.n.push(...await this.S(M,p,R,N,T));const U=M.enabled.find(Y=>Y.resource==="profiles");if(U){const Y=await U.getLastSyncedProfiles()||[];if(T.isCancellationRequested)return;await this.Q(Y,p,R,N,T)}}finally{this.status!=="hasConflicts"&&this.Y("idle"),this.r.fire(this.n)}}async Q(p,R,N,T,M){for(const U of p){if(M.isCancellationRequested)return;const Y=this.M.profiles.find(x=>x.id===U.id);if(!Y){this.H.error(`Profile with id:${U.id} and name: ${U.name} does not exist locally to sync.`);continue}this.H.info("Syncing profile.",U.name);const Q=this.getOrCreateActiveProfileSynchronizer(Y,U);this.n.push(...await this.S(Q,R,N,T,M))}for(const[U,Y]of this.z.entries())this.M.profiles.some(Q=>Q.id===Y[0].profile.id)||(Y[1].dispose(),this.z.delete(U))}async R(p,R,N){const T=this.ab();for(const x of T){if(N.isCancellationRequested)return;await x.apply(R,N)}const M=T.find(x=>x.profile.isDefault);if(!M)return;const U=M.enabled.find(x=>x.resource==="profiles");if(!U)return;const Q=(await U.getRemoteSyncedProfiles(p?.latest??null)||[]).filter(x=>T.every(H=>H.profile.id!==x.id));Q.length&&await this.Q(Q,p,!1,R,N)}async S(p,R,N,T,M){return(await p.sync(R,N,T,M)).map(([Y,Q])=>({profile:p.profile,syncResource:Y,error:Q}))}async U(){this.status!=="idle"&&await Promise.allSettled(this.ab().map(p=>p.stop()))}async resolveContent(p){const R=await this.N.resolveContent(p);if(R)return R;for(const N of this.ab())for(const T of N.enabled){const M=await T.resolveContent(p);if(M)return M}return null}async replace(p){this.cb();const R=this.N.resolveUserDataSyncResource(p);if(!R)return;const N=await this.resolveContent(p.uri);N&&await this.W(R.profile,async T=>{if(R.syncResource===T.resource)return await T.replace(N),!0})}async accept(p,R,N,T){this.cb(),await this.W(p.profile,async M=>{if(p.syncResource===M.resource)return await M.accept(R,N),T&&await M.apply((0,g.$Of)(T)?!1:T.force,(0,s.$Pnb)((0,C.$qg)())),!0})}async hasLocalData(){return!!await this.W(this.M.defaultProfile,async R=>{if(R.resource!=="globalState"&&await R.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.W(this.M.defaultProfile,async R=>{if(await R.hasPreviouslySynced())return!0})}async reset(){this.cb(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.cb();try{await this.D.clear(),this.H.info("Cleared data on server")}catch(p){this.H.error(p)}this.y.fire()}async resetLocal(){this.cb(),this.t=void 0,this.J.remove(t,-1);for(const[p]of this.z.values())try{await p.resetLocal()}catch(R){this.H.error(R)}this.bb(),this.w.fire(),this.H.info("Did reset the local sync state.")}async cleanUpRemoteData(){const p=await this.N.getRemoteSyncedProfiles(),R=p.map(U=>U.collection),N=await this.D.getAllCollections(),T=N.filter(U=>!R.includes(U));T.length&&(this.H.info(`Deleting ${T.length} redundant collections on server`),await Promise.allSettled(T.map(U=>this.D.deleteCollection(U))),this.H.info("Deleted redundant collections on server"));const M=p.filter(U=>N.includes(U.collection));if(M.length!==p.length){const U=this.G.createInstance(n.$X9b,this.M.defaultProfile,void 0);try{this.H.info("Resetting the last synced state of profiles"),await U.resetLocal(),this.H.info("Did reset the last synced state of profiles"),this.H.info("Updating remote profiles with invalid collections on server"),await U.updateRemoteProfiles(M,null),this.H.info("Updated remote profiles on server")}finally{U.dispose()}}}async saveRemoteActivityData(p){this.cb();const R=await this.D.getActivityData();await this.C.writeFile(p,R)}async extractActivityData(p,R){const N=(await this.C.readFile(p)).value.toString(),T=JSON.parse(N);if(T.resources)for(const M in T.resources)for(const U of T.resources[M])await this.O.writeResource(M,U.content,new Date(U.created*1e3),void 0,R);if(T.collections)for(const M in T.collections)for(const U in T.collections[M].resources)for(const Y of T.collections[M].resources?.[U]??[])await this.O.writeResource(U,Y.content,new Date(Y.created*1e3),M,R)}async W(p,R){const N=new P.$Sc;try{const T=this.z.get(p.id);if(T){const x=await this.X(T[0],R,N);return(0,g.$Pf)(x)?null:x}if(p.isDefault){const x=N.add(this.G.createInstance(a,p,void 0)),H=await this.X(x,R,N);return(0,g.$Pf)(H)?null:H}if(this.M.isEnabled())return null;const M=N.add(this.G.createInstance(n.$X9b,p,void 0)),U=await this.D.manifest(null),Q=(await M.getRemoteSyncedProfiles(U?.latest??null)||[]).find(x=>x.id===p.id);if(Q){const x=N.add(this.G.createInstance(a,p,Q.collection)),H=await this.X(x,R,N);return(0,g.$Pf)(H)?null:H}return null}finally{N.dispose()}}async X(p,R,N){const T=[...p.enabled,...p.disabled.reduce((M,U)=>(U!=="workspaceState"&&M.push(N.add(p.createSynchronizer(U))),M),[])];for(const M of T){const U=await R(M);if(!(0,g.$Pf)(U))return U}}Y(p){const R=this.f;this.f!==p&&(this.f=p,this.g.fire(p),R==="hasConflicts"&&this.$())}Z(){const p=this.ab().map(R=>R.conflicts).flat();(0,O.$ub)(this.j,p,(R,N)=>R.profile.id===N.profile.id&&R.syncResource===N.syncResource&&(0,O.$ub)(R.conflicts,N.conflicts,(T,M)=>(0,k.$Ag)(T.previewResource,M.previewResource)))||(this.j=p,this.m.fire(p))}$(){this.status==="idle"&&(this.t=new Date().getTime(),this.J.store(t,this.t,-1,1),this.u.fire(this.t))}getOrCreateActiveProfileSynchronizer(p,R){let N=this.z.get(p.id);if(N&&N[0].collection!==R?.collection&&(this.H.error("Profile synchronizer collection does not match with the remote sync profile collection"),N[1].dispose(),N=void 0,this.z.delete(p.id)),!N){const T=new P.$Sc,M=T.add(this.G.createInstance(a,p,R?.collection));T.add(M.onDidChangeStatus(U=>this.Y(U))),T.add(M.onDidChangeConflicts(U=>this.Z())),T.add(M.onDidChangeLocal(U=>this.h.fire(U))),this.z.set(p.id,N=[M,T])}return N[0]}ab(){const p=[];for(const[R]of this.z.values())p.push(R);return p}bb(){this.z.forEach(([,p])=>p.dispose()),this.z.clear()}cb(){if(!this.F.userDataSyncStore)throw new Error("Not enabled")}};e.$19b=r,e.$19b=r=pe([X(0,l.$qk),X(1,s.$Lnb),X(2,s.$Knb),X(3,$.$5h),X(4,s.$1nb),X(5,w.$ul),X(6,b.$up),X(7,s.$Vnb),X(8,h.$3k),X(9,s.$Xnb),X(10,s.$Mnb)],r);let a=class extends P.$Tc{get enabled(){return this.f.sort((p,R)=>p[1]-R[1]).map(([p])=>p)}get disabled(){return s.$Hnb.filter(p=>!this.r.isResourceEnabled(p))}get status(){return this.g}get conflicts(){return this.m}constructor(p,R,N,T,M,U,Y,Q,x,H){super(),this.profile=p,this.collection=R,this.r=N,this.t=T,this.u=M,this.w=U,this.y=Y,this.z=Q,this.C=x,this.D=H,this.f=[],this.g="idle",this.h=this.B(new I.$Vd),this.onDidChangeStatus=this.h.event,this.j=this.B(new I.$Vd),this.onDidChangeLocal=this.j.event,this.m=[],this.n=this.B(new I.$Vd),this.onDidChangeConflicts=this.n.event,this.B(N.onDidChangeResourceEnablement(([Z,W])=>this.F(Z,W))),this.B((0,P.$Rc)(()=>this.f.splice(0,this.f.length).forEach(([,,Z])=>Z.dispose())));for(const Z of s.$Hnb)N.isResourceEnabled(Z)&&this.G(Z)}F(p,R){R?this.G(p):this.H(p)}G(p){if(this.f.some(([M])=>M.resource===p))return;if(p==="extensions"&&!this.u.isEnabled()){this.z.info("Skipping extensions sync because gallery is not configured");return}if(p==="profiles"&&(!this.profile.isDefault||!this.C.isEnabled())||p==="workspaceState")return;if(p!=="profiles"&&this.profile.useDefaultFlags?.[p]){this.z.debug(`Skipping syncing ${p} in ${this.profile.name} because it is already synced by default profile`);return}const R=new P.$Sc,N=R.add(this.createSynchronizer(p));R.add(N.onDidChangeStatus(()=>this.L())),R.add(N.onDidChangeConflicts(()=>this.M())),R.add(N.onDidChangeLocal(()=>this.j.fire(p)));const T=this.N(p);this.f.push([N,T,R])}H(p){const R=this.f.findIndex(([N])=>N.resource===p);if(R!==-1){const[[N,,T]]=this.f.splice(R,1);T.dispose(),this.L(),Promise.allSettled([N.stop(),N.resetLocal()]).then(null,M=>this.z.error(M))}}createSynchronizer(p){switch(p){case"settings":return this.t.createInstance(v.$07b,this.profile,this.collection);case"keybindings":return this.t.createInstance(c.$77b,this.profile,this.collection);case"snippets":return this.t.createInstance(i.$c8b,this.profile,this.collection);case"tasks":return this.t.createInstance(o.$f8b,this.profile,this.collection);case"globalState":return this.t.createInstance(d.$gHb,this.profile,this.collection);case"extensions":return this.t.createInstance(f.$27b,this.profile,this.collection);case"profiles":return this.t.createInstance(n.$X9b,this.profile,this.collection)}}async sync(p,R,N,T){if(T.isCancellationRequested)return[];const M=this.enabled;if(!M.length)return[];try{const U=[],Y=(0,s.$Pnb)(N),Q=(this.collection?p?.collections?.[this.collection]?.latest:p?.latest)??null,x=R?await this.I(Q):{};for(const H of M){if(T.isCancellationRequested)return[];if(!this.r.isResourceEnabled(H.resource))return[];try{if(R){const Z=await H.preview(Q,x,Y);if(Z)for(const W of Z.resourcePreviews)(W.localChange!==0||W.remoteChange!==0)&&W.mergeState==="preview"&&await H.merge(W.previewResource)}else await H.sync(Q,Y)}catch(Z){const W=s.$Qnb.toUserDataSyncError(Z);if(y(W,N,this.w,this.y),E(Z))throw W;this.z.error(Z),this.z.error(`${H.resource}: ${(0,A.$Qi)(Z)}`),U.push([H.resource,W])}}return U}finally{this.L()}}async apply(p,R){const N=(0,s.$Pnb)(p);for(const T of this.enabled){if(R.isCancellationRequested)return;try{await T.apply(!1,N)}catch(M){const U=s.$Qnb.toUserDataSyncError(M);if(y(U,p,this.w,this.y),E(M))throw U;this.z.error(M),this.z.error(`${T.resource}: ${(0,A.$Qi)(M)}`)}}}async stop(){for(const p of this.enabled)try{p.status!=="idle"&&await p.stop()}catch(R){this.z.error(R)}}async resetLocal(){for(const p of this.enabled)try{await p.resetLocal()}catch(R){this.z.error(`${p.resource}: ${(0,A.$Qi)(R)}`),this.z.error(R)}}async I(p){if(!this.profile.isDefault)return{};const R=this.D.getValue(s.$Dnb),N=this.enabled.find(T=>T instanceof v.$07b);if(N){const T=await N.getRemoteUserDataSyncConfiguration(p);return{...R,...T}}return R}J(p){this.g!==p&&(this.g=p,this.h.fire(p))}L(){return this.M(),this.enabled.some(p=>p.status==="hasConflicts")?this.J("hasConflicts"):this.enabled.some(p=>p.status==="syncing")?this.J("syncing"):this.J("idle")}M(){const p=this.enabled.filter(R=>R.status==="hasConflicts").filter(R=>R.conflicts.conflicts.length>0).map(R=>R.conflicts);(0,O.$ub)(this.m,p,(R,N)=>R.syncResource===N.syncResource&&(0,O.$ub)(R.conflicts,N.conflicts,(T,M)=>(0,k.$Ag)(T.previewResource,M.previewResource)))||(this.m=p,this.n.fire(p))}N(p){switch(p){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6;case"workspaceState":return 7}}};a=pe([X(2,s.$Vnb),X(3,$.$5h),X(4,m.$yo),X(5,s.$Knb),X(6,w.$ul),X(7,s.$1nb),X(8,h.$3k),X(9,S.$zi)],a);function E(u){if(u instanceof s.$Qnb)switch(u.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(u,p,R,N){N.publicLog2("sync/error",{code:u.code,serverCode:u instanceof s.$Rnb?String(u.serverCode):void 0,url:u instanceof s.$Rnb?u.url:void 0,resource:u.resource,executionId:p,service:R.userDataSyncStore.url.toString()})}}),define(le[260],he([0,1,3,2,10,18,25]),function(se,e,O,L,D,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kac=e.$jac=void 0;function P(m,l){return{...m,profile:(0,A.$4k)(m.profile,l.profilesHome.scheme)}}function k(m){return{created:m.created,uri:D.URI.revive(m.uri)}}class g{constructor(l,$,b){this.c=l,this.d=$,this.f=b,this.a=new Map,this.b=new O.$Vd}listen(l,$){switch($){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${$}`)}async call(l,$,b){try{return await this.g(l,$,b)}catch(w){throw this.f.error(w),w}}async g(l,$,b){switch($){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(D.URI.revive(b[0]));case"accept":return this.c.accept(P(b[0],this.d),D.URI.revive(b[1]),b[2],b[3]);case"replace":return this.c.replace(k(b[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"getRemoteActivityData":return this.c.saveRemoteActivityData(D.URI.revive(b[0]));case"extractActivityData":return this.c.extractActivityData(D.URI.revive(b[0]),D.URI.revive(b[1]));case"createManualSyncTask":return this.i()}if($.startsWith("manualSync/")){const w=$.substring(11),h=b[0],f=this.h(h);switch(b=b.slice(1),w){case"merge":return f.merge();case"apply":return f.apply().then(()=>this.a.delete(this.j(f.id)));case"stop":return f.stop().finally(()=>this.a.delete(this.j(f.id)))}}throw new Error("Invalid call")}h(l){const $=this.a.get(this.j(l));if(!$)throw new Error(`Manual sync taks not found: ${l}`);return $}async i(){const l=await this.c.createManualSyncTask();return this.a.set(this.j(l.id),l),l.id}j(l){return`manualSyncTask-${l}`}}e.$jac=g;let C=class extends L.$Tc{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(l,$){super(),this.n=$,this.b="uninitialized",this.c=this.B(new O.$Vd),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new O.$Vd),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.j=this.B(new O.$Vd),this.onDidChangeLastSyncTime=this.j.event,this.m=this.B(new O.$Vd),this.onSyncErrors=this.m.event,this.a={call(b,w,h){return l.call(b,w,h).then(null,f=>{throw I.$Qnb.toUserDataSyncError(f)})},listen(b,w){return l.listen(b,w)}},this.a.call("_getInitialData").then(([b,w,h])=>{this.s(b),this.t(w),h&&this.u(h),this.B(this.a.listen("onDidChangeStatus")(f=>this.s(f))),this.B(this.a.listen("onDidChangeLastSyncTime")(f=>this.u(f)))}),this.B(this.a.listen("onDidChangeConflicts")(b=>this.t(b))),this.B(this.a.listen("onSyncErrors")(b=>this.m.fire(b.map(w=>({...w,error:I.$Qnb.toUserDataSyncError(w.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const l=await this.a.call("createManualSyncTask"),$=this;return new S(l,{async call(w,h,f){return $.a.call(`manualSync/${w}`,[l,...Array.isArray(h)?h:[h]],f)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(l,$,b,w){return this.a.call("accept",[l,$,b,w])}resolveContent(l){return this.a.call("resolveContent",[l])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(l){return this.a.call("replace",[l])}saveRemoteActivityData(l){return this.a.call("getRemoteActivityData",[l])}extractActivityData(l,$){return this.a.call("extractActivityData",[l,$])}async s(l){this.b=l,this.c.fire(l)}async t(l){this.f=l.map($=>({syncResource:$.syncResource,profile:(0,A.$4k)($.profile,this.n.profilesHome.scheme),conflicts:$.conflicts.map(b=>({...b,baseResource:D.URI.revive(b.baseResource),localResource:D.URI.revive(b.localResource),remoteResource:D.URI.revive(b.remoteResource),previewResource:D.URI.revive(b.previewResource)}))})),this.g.fire(this.f)}u(l){this.h!==l&&(this.h=l,this.j.fire(l))}};e.$kac=C,e.$kac=C=pe([X(1,A.$3k)],C);class S extends L.$Tc{constructor(l,$){super(),this.id=l,this.a=$}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose"),super.dispose()}}}),define(le[122],he([0,1,6,26,7,3,2,140,5,20,12,10,32,21,15,11,24,59,43,19,25]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9Gb=e.$8Gb=e.$7Gb=e.$6Gb=e.$5Gb=void 0;const v="configurationSync.store",i="sync.previous.store",o="sync.donot-make-requests-until",n="sync.user-session-id",s="sync.machine-session-id",t=100,r=1e3*60*5;let a=class extends I.$Tc{get userDataSyncStore(){return this.b}get c(){return this.h.get(c.$Tnb,-1)}set c(N){this.h.store(c.$Tnb,N,-1,k.$o?0:1)}constructor(N,T,M){super(),this.f=N,this.g=T,this.h=M,this.a=this.B(new A.$Vd),this.onDidChangeUserDataSyncStore=this.a.event,this.j();const U=this.B(new I.$Sc);this.B(A.Event.filter(M.onDidChangeValue(-1,c.$Tnb,U),()=>this.c!==this.userDataSyncStore?.type,U)(()=>this.j()))}j(){this.b=this.m(this.f[v]),this.a.fire()}m(N){if(N&&(N=k.$o&&N.web?{...N,...N.web}:N,(0,C.$If)(N.url)&&(0,C.$Kf)(N.authenticationProviders)&&Object.keys(N.authenticationProviders).every(T=>Array.isArray(N.authenticationProviders[T].scopes)))){const T=N,M=!!T.canSwitch,U=T.url===T.insidersUrl?"insiders":"stable",Y=(M?this.c:void 0)||U,Q=Y==="insiders"?T.insidersUrl:Y==="stable"?T.stableUrl:T.url;return{url:S.URI.parse(Q),type:Y,defaultType:U,defaultUrl:S.URI.parse(T.url),stableUrl:S.URI.parse(T.stableUrl),insidersUrl:S.URI.parse(T.insidersUrl),canSwitch:M,authenticationProviders:Object.keys(T.authenticationProviders).reduce((x,H)=>(x.push({id:H,scopes:T.authenticationProviders[H].scopes}),x),[])}}}};e.$5Gb=a,e.$5Gb=a=pe([X(0,w.$Fj),X(1,l.$zi),X(2,d.$up)],a);let E=class extends a{constructor(N,T,M){super(N,T,M);const U=this.h.get(i,-1);U&&(this.n=JSON.parse(U));const Y=this.f[v];Y?this.h.store(i,JSON.stringify(Y),-1,1):this.h.remove(i,-1)}async switch(N){N!==this.c&&(this.c=N,this.j())}async getPreviousUserDataSyncStore(){return this.m(this.n)}};e.$6Gb=E,e.$6Gb=E=pe([X(0,w.$Fj),X(1,l.$zi),X(2,d.$up)],E);let y=class extends I.$Tc{get donotMakeRequestsUntil(){return this.j}constructor(N,T,M,U,Y,Q,x){super(),this.n=M,this.r=U,this.s=x,this.g=this.B(new A.$Vd),this.onTokenFailed=this.g.event,this.h=this.B(new A.$Vd),this.onTokenSucceed=this.h.event,this.j=void 0,this.m=this.B(new A.$Vd),this.onDidChangeDonotMakeRequestsUntil=this.m.event,this.w=void 0,this.t(N),this.c=(0,f.$Ap)(Y,Q,x).then(H=>{const Z={"X-Client-Name":`${T.applicationName}${k.$o?"-web":""}`,"X-Client-Version":T.version};return T.commit&&(Z["X-Client-Commit"]=T.commit),Z}),this.f=new p(t,r,this.n,this.r),this.u(),this.B((0,I.$Rc)(()=>{this.w&&(this.w.cancel(),this.w=void 0)}))}setAuthToken(N,T){this.b={token:N,type:T}}t(N){this.a=N?(0,g.$Hg)(N,"v1"):void 0}u(){const N=this.s.getNumber(o,-1);N&&Date.now()<N&&this.y(new Date(N))}y(N){this.j?.getTime()!==N?.getTime()&&(this.j=N,this.w&&(this.w.cancel(),this.w=void 0),this.j?(this.s.store(o,this.j.getTime(),-1,1),this.w=(0,O.$Tg)(T=>(0,O.$7g)(this.j.getTime()-Date.now(),T).then(()=>this.y(void 0))),this.w.then(null,T=>null)):this.s.remove(o,-1),this.m.fire())}async getAllCollections(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$Hg)(this.a,"collection").toString();N={...N},N["Content-Type"]="application/json";const M=await this.D(T,{type:"GET",headers:N},[],L.CancellationToken.None);return(await(0,h.$np)(M))?.map(({id:U})=>U)||[]}async createCollection(N={}){if(!this.a)throw new Error("No settings sync store url configured.");const T=(0,g.$Hg)(this.a,"collection").toString();N={...N},N["Content-Type"]=P.$fs.text;const M=await this.D(T,{type:"POST",headers:N},[],L.CancellationToken.None),U=await(0,h.$mp)(M);if(!U)throw new c.$Rnb("Server did not return the collection id",T,"NoCollection",M.res.statusCode,M.res.headers[c.$Nnb]);return U}async deleteCollection(N,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=N?(0,g.$Hg)(this.a,"collection",N).toString():(0,g.$Hg)(this.a,"collection").toString();T={...T},await this.D(M,{type:"DELETE",headers:T},[],L.CancellationToken.None)}async getAllResourceRefs(N,T){if(!this.a)throw new Error("No settings sync store url configured.");const M=this.z(this.a,T,N),U={},Y=await this.D(M.toString(),{type:"GET",headers:U},[],L.CancellationToken.None);return(await(0,h.$np)(Y)||[]).map(({url:x,created:H})=>({ref:(0,g.$Jg)(M,M.with({path:x})),created:H*1e3}))}async resolveResourceContent(N,T,M,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Hg)(this.z(this.a,M,N),T).toString();U={...U},U["Cache-Control"]="no-cache";const Q=await this.D(Y,{type:"GET",headers:U},[],L.CancellationToken.None);return await(0,h.$mp)(Q)}async deleteResource(N,T,M){if(!this.a)throw new Error("No settings sync store url configured.");const U=T!==null?(0,g.$Hg)(this.z(this.a,M,N),T).toString():this.z(this.a,M,N).toString(),Y={};await this.D(U,{type:"DELETE",headers:Y},[],L.CancellationToken.None)}async deleteResources(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Hg)(this.a,"resource").toString(),T={"Content-Type":P.$fs.text};await this.D(N,{type:"DELETE",headers:T},[],L.CancellationToken.None)}async readResource(N,T,M,U={}){if(!this.a)throw new Error("No settings sync store url configured.");const Y=(0,g.$Hg)(this.z(this.a,M,N),"latest").toString();U={...U},U["Cache-Control"]="no-cache",T&&(U["If-None-Match"]=T.ref);const Q=await this.D(Y,{type:"GET",headers:U},[304],L.CancellationToken.None);let x=null;if(Q.res.statusCode===304&&(x=T),x===null){const H=Q.res.headers.etag;if(!H)throw new c.$Rnb("Server did not return the ref",Y,"NoRef",Q.res.statusCode,Q.res.headers[c.$Nnb]);const Z=await(0,h.$mp)(Q);if(!Z&&Q.res.statusCode===304)throw new c.$Rnb("Empty response",Y,"EmptyResponse",Q.res.statusCode,Q.res.headers[c.$Nnb]);x={ref:H,content:Z}}return x}async writeResource(N,T,M,U,Y={}){if(!this.a)throw new Error("No settings sync store url configured.");const Q=this.z(this.a,U,N).toString();Y={...Y},Y["Content-Type"]=P.$fs.text,M&&(Y["If-Match"]=M);const x=await this.D(Q,{type:"POST",data:T,headers:Y},[],L.CancellationToken.None),H=x.res.headers.etag;if(!H)throw new c.$Rnb("Server did not return the ref",Q,"NoRef",x.res.statusCode,x.res.headers[c.$Nnb]);return H}async manifest(N,T={}){if(!this.a)throw new Error("No settings sync store url configured.");const M=(0,g.$Hg)(this.a,"manifest").toString();T={...T},T["Content-Type"]="application/json",N&&(T["If-None-Match"]=N.ref);const U=await this.D(M,{type:"GET",headers:T},[304],L.CancellationToken.None);let Y=null;if(U.res.statusCode===304&&(Y=N),!Y){const x=U.res.headers.etag;if(!x)throw new c.$Rnb("Server did not return the ref",M,"NoRef",U.res.statusCode,U.res.headers[c.$Nnb]);const H=await(0,h.$mp)(U);if(!H&&U.res.statusCode===304)throw new c.$Rnb("Empty response",M,"EmptyResponse",U.res.statusCode,U.res.headers[c.$Nnb]);H&&(Y={...JSON.parse(H),ref:x})}const Q=this.s.get(n,-1);return Q&&Y&&Q!==Y.session&&this.C(),Y===null&&Q&&this.C(),Y&&this.s.store(n,Y.session,-1,1),Y}async clear(){if(!this.a)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.C()}async getActivityData(){if(!this.a)throw new Error("No settings sync store url configured.");const N=(0,g.$Hg)(this.a,"download").toString(),T={},M=await this.D(N,{type:"GET",headers:T},[],L.CancellationToken.None);if(!(0,h.$jp)(M))throw new c.$Rnb("Server returned "+M.res.statusCode,N,"EmptyResponse",M.res.statusCode,M.res.headers[c.$Nnb]);if((0,h.$kp)(M))throw new c.$Rnb("Empty response",N,"EmptyResponse",M.res.statusCode,M.res.headers[c.$Nnb]);return M.stream}z(N,T,M){return T?(0,g.$Hg)(N,"collection",T,"resource",M):(0,g.$Hg)(N,"resource",M)}C(){this.s.remove(n,-1),this.s.remove(s,-1)}async D(N,T,M,U){if(!this.b)throw new c.$Rnb("No Auth Token Available",N,"Unauthorized",void 0,void 0);if(this.j&&Date.now()<this.j.getTime())throw new c.$Rnb(`${T.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",void 0,void 0);this.y(void 0);const Y=await this.c;T.headers={...T.headers||{},...Y,"X-Account-Type":this.b.type,authorization:`Bearer ${this.b.token}`},this.F(T.headers),this.r.trace("Sending request to server",{url:N,type:T.type,headers:{...T.headers,authorization:void 0}});let Q;try{Q=await this.f.request(N,T,U)}catch(V){if(!(V instanceof c.$Rnb)){let ie="RequestFailed";const re=(0,D.$0)(V).toLowerCase();re.includes("xhr timeout")?ie="RequestTimeout":re.includes("protocol")&&re.includes("not supported")?ie="RequestProtocolNotSupported":re.includes("request path contains unescaped characters")?ie="RequestPathNotEscaped":re.includes("headers must be an object")?ie="RequestHeadersNotObject":(0,D.$4)(V)&&(ie="RequestCanceled"),V=new c.$Rnb(`Connection refused for the request '${N}'.`,N,ie,void 0,void 0)}throw this.r.info("Request failed",N),V}const x=Q.res.headers[c.$Nnb],H={url:N,status:Q.res.statusCode,"execution-id":T.headers[c.$Onb],"operation-id":x},Z=(0,h.$jp)(Q)||Q.res.statusCode&&M.includes(Q.res.statusCode);let W="";if(Z?this.r.trace("Request succeeded",H):(W=await(0,h.$lp)(Q)||"",this.r.info("Request failed",H,W)),Q.res.statusCode===401||Q.res.statusCode===403){if(this.b=void 0,Q.res.statusCode===401)throw this.g.fire("Unauthorized"),new c.$Rnb(`${T.type} request '${N}' failed because of Unauthorized (401).`,N,"Unauthorized",Q.res.statusCode,x);if(Q.res.statusCode===403)throw this.g.fire("Forbidden"),new c.$Rnb(`${T.type} request '${N}' failed because the access is forbidden (403).`,N,"Forbidden",Q.res.statusCode,x)}if(this.h.fire(),Q.res.statusCode===404)throw new c.$Rnb(`${T.type} request '${N}' failed because the requested resource is not found (404).`,N,"NotFound",Q.res.statusCode,x);if(Q.res.statusCode===405)throw new c.$Rnb(`${T.type} request '${N}' failed because the requested endpoint is not found (405). ${W}`,N,"MethodNotFound",Q.res.statusCode,x);if(Q.res.statusCode===409)throw new c.$Rnb(`${T.type} request '${N}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,N,"Conflict",Q.res.statusCode,x);if(Q.res.statusCode===410)throw new c.$Rnb(`${T.type} request '${N}' failed because the requested resource is not longer available (410).`,N,"Gone",Q.res.statusCode,x);if(Q.res.statusCode===412)throw new c.$Rnb(`${T.type} request '${N}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,N,"PreconditionFailed",Q.res.statusCode,x);if(Q.res.statusCode===413)throw new c.$Rnb(`${T.type} request '${N}' failed because of too large payload (413).`,N,"TooLarge",Q.res.statusCode,x);if(Q.res.statusCode===426)throw new c.$Rnb(`${T.type} request '${N}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,N,"UpgradeRequired",Q.res.statusCode,x);if(Q.res.statusCode===429){const V=Q.res.headers["retry-after"];throw V?(this.y(new Date(Date.now()+parseInt(V)*1e3)),new c.$Rnb(`${T.type} request '${N}' failed because of too many requests (429).`,N,"TooManyRequestsAndRetryAfter",Q.res.statusCode,x)):new c.$Rnb(`${T.type} request '${N}' failed because of too many requests (429).`,N,"RemoteTooManyRequests",Q.res.statusCode,x)}if(!Z)throw new c.$Rnb("Server returned "+Q.res.statusCode,N,"Unknown",Q.res.statusCode,x);return Q}F(N){let T=this.s.get(s,-1);T===void 0&&(T=(0,m.$qg)(),this.s.store(s,T,-1,1)),N["X-Machine-Session-Id"]=T;const M=this.s.get(n,-1);M!==void 0&&(N["X-User-Session-Id"]=M)}};e.$7Gb=y,e.$7Gb=y=pe([X(1,w.$Fj),X(2,h.$hp),X(3,c.$1nb),X(4,$.$ai),X(5,b.$qk),X(6,d.$up)],y);let u=class extends y{constructor(N,T,M,U,Y,Q,x){super(N.userDataSyncStore?.url,T,M,U,Y,Q,x),this.B(N.onDidChangeUserDataSyncStore(()=>this.t(N.userDataSyncStore?.url)))}};e.$8Gb=u,e.$8Gb=u=pe([X(0,c.$Knb),X(1,w.$Fj),X(2,h.$hp),X(3,c.$1nb),X(4,$.$ai),X(5,b.$qk),X(6,d.$up)],u);class p{constructor(N,T,M,U){this.c=N,this.d=T,this.f=M,this.g=U,this.a=[],this.b=void 0}request(N,T,M){if(this.h()&&this.i(),T.url=N,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new c.$Rnb(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,N,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(N),this.f.request(T,M)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.$9Gb=p}),define(le[261],he([0,1,3,2,10,21,24,19,122]),function(se,e,O,L,D,A,I,P,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iac=e.$hac=e.$gac=e.$fac=void 0;class g{constructor($){this.a=$}listen($,b){switch(b){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${b}`)}call($,b,w){switch(b){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(w)}throw new Error("Invalid call")}}e.$fac=g;class C extends L.$Tc{get account(){return this.a}get onTokenFailed(){return this.c.listen("onTokenFailed")}constructor($){super(),this.c=$,this.b=this.B(new O.$Vd),this.onDidChangeAccount=this.b.event,this.c.call("_getInitialData").then(b=>{this.a=b,this.B(this.c.listen("onDidChangeAccount")(w=>{this.a=w,this.b.fire(w)}))})}updateAccount($){return this.c.call("updateAccount",$)}}e.$gac=C;class S{constructor($){this.a=$}listen($,b){switch(b){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${b}`)}call($,b,w){switch(b){case"switch":return this.a.switch(w[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.$hac=S;let m=class extends k.$5Gb{constructor($,b,w,h){super(b,w,h),this.n=$,this.B(this.n.listen("onDidChangeUserDataSyncStore")(()=>this.j()))}async switch($){return this.n.call("switch",[$])}async getPreviousUserDataSyncStore(){const $=await this.n.call("getPreviousUserDataSyncStore");return this.r($)}r($){return{url:D.URI.revive($.url),type:$.type,defaultUrl:D.URI.revive($.defaultUrl),insidersUrl:D.URI.revive($.insidersUrl),stableUrl:D.URI.revive($.stableUrl),canSwitch:$.canSwitch,authenticationProviders:$.authenticationProviders}}};e.$iac=m,e.$iac=m=pe([X(1,I.$Fj),X(2,A.$zi),X(3,P.$up)],m)}),define(le[262],he([0,1,3,57,24,19,22,257,25,81,84]),function(se,e,O,L,D,A,I,P,k,g,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eac=void 0;let S=class extends P.$29b{constructor(l,$,b,w,h,f,d,c,v,i,o){super(l,$,b,w,h,d,c,v,i,o),this.B(O.Event.debounce(O.Event.any(O.Event.map(f.onDidFocusMainWindow,()=>"windowFocus"),O.Event.map(f.onDidOpenMainWindow,()=>"windowOpen")),(n,s)=>n?[...n,s]:[s],1e3)(n=>this.triggerSync(n,!0,!1)))}};e.$Eac=S,e.$Eac=S=pe([X(0,D.$Fj),X(1,k.$Knb),X(2,k.$Lnb),X(3,k.$Vnb),X(4,k.$Wnb),X(5,L.$w$b),X(6,k.$1nb),X(7,g.$CFb),X(8,I.$ul),X(9,C.$ynb),X(10,A.$up)],S)}),define(le[263],he([0,1,73,23,5,20]),function(se,e,O,L,D,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Z0b=e.$Y0b=e.$X0b=e.$W0b=void 0,e.$W0b=128/4;function I(g){function C(){let S=g.scheme===L.Schemas.file?(0,A.$vg)(g):g.toString();return D.$k||(S=S.toLowerCase()),(0,O.createHash)("md5").update(S).digest("hex")}return{id:C(),configPath:g}}e.$X0b=I;function P(g,C){function S(){if(g.scheme!==L.Schemas.file)return(0,O.createHash)("md5").update(g.toString()).digest("hex");if(!C)return;let l;return D.$k?l=C.ino:D.$j?l=C.birthtime.getTime():D.$i&&(typeof C.birthtimeMs=="number"?l=Math.floor(C.birthtimeMs):l=C.birthtime.getTime()),(0,O.createHash)("md5").update(g.fsPath).update(l?String(l):"").digest("hex")}const m=S();if(typeof m=="string")return{id:m,uri:g}}e.$Y0b=P;function k(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.$Z0b=k}),define(le[264],he([0,1,6,7,2,16,31,15,8,78,112,263,57,56,23]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bac=void 0;let b=class extends D.$Tc{constructor(h,f,d,c){super(),this.a=h,this.b=f,this.c=d,this.f=c,this.B(new O.$fh(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const h=this.a.workspaceStorageHome.with({scheme:$.Schemas.file}).fsPath,f=await I.Promises.readdir(h),d=new g.$bGb(this.f.getChannel("storage"));await Promise.all(f.map(async c=>{const v=(0,A.$jc)(h,c);c.length===S.$W0b||c===C.$fi.id||(await this.c.getWindows({includeAuxiliaryWindows:!1})).some(n=>n.workspace?.id===c)||await d.isUsed(v)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${c} as it seems to be an unused empty workspace.`),await I.Promises.rm(v))}))}catch(h){(0,L.$1)(h)}}};e.$bac=b,e.$bac=b=pe([X(0,P.$bi),X(1,k.$nj),X(2,m.$w$b),X(3,l.$K_b)],b)}),define(le[123],he([0,1,73,64,36,272,14,7,3,2,16,5,32,40,68]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class b{traceSocketEvent(u,p){$.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,u,p)}constructor(u,p=""){this.f=!0,this.debugLabel=p,this.socket=u,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=R=>{if(this.traceSocketEvent("error",{code:R?.code,message:R?.message}),R){if(R.code==="EPIPE")return;(0,P.$1)(R)}},this.socket.on("error",this.a),this.b=R=>{this.traceSocketEvent("close",{hadError:R}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(u){const p=R=>{this.traceSocketEvent("read",R),u(I.$je.wrap(R))};return this.socket.on("data",p),{dispose:()=>this.socket.off("data",p)}}onClose(u){const p=R=>{u({type:0,hadError:R,error:void 0})};return this.socket.on("close",p),{dispose:()=>this.socket.off("close",p)}}onEnd(u){const p=()=>{u()};return this.socket.on("end",p),{dispose:()=>this.socket.off("end",p)}}write(u){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",u),this.socket.write(u.buffer,p=>{if(p){if(p.code==="EPIPE")return;(0,P.$1)(p)}})}catch(p){if(p.code==="EPIPE")return;(0,P.$1)(p)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((u,p)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),u();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),this.traceSocketEvent("nodeDrainEnd"),u()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.$Uh=b;var w;(function(y){y[y.MinHeaderByteSize=2]="MinHeaderByteSize",y[y.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(w||(w={}));var h;(function(y){y[y.PeekHeader=1]="PeekHeader",y[y.ReadHeader=2]="ReadHeader",y[y.ReadBody=3]="ReadBody",y[y.Fin=4]="Fin"})(h||(h={}));class f extends g.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(u,p){this.socket.traceSocketEvent(u,p)}constructor(u,p,R,N){super(),this.f=this.B(new k.$Vd),this.g=this.B(new k.$Vd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=u,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:p,inflateBytesLength:R?.byteLength||0,recordInflateBytes:N}),this.a=this.B(new d(this,p,R,N,this.f,(T,M)=>this.m(T,M))),this.B(this.a.onError(T=>{console.error(T),(0,P.$1)(T),this.g.fire({type:0,hadError:!0,error:T})})),this.b=new $.$Ph,this.B(this.socket.onData(T=>this.n(T))),this.B(this.socket.onClose(async T=>{this.a.isProcessingReadQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(T)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(u){return this.f.event(u)}onClose(u){return this.g.event(u)}onEnd(u){return this.socket.onEnd(u)}write(u){let p=0;for(;p<u.byteLength;)this.a.writeMessage(u.slice(p,Math.min(p+262144,u.byteLength)),{compressed:!0,opcode:2}),p+=262144}m(u,{compressed:p,opcode:R}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",u);let N=2;u.byteLength<126?N+=0:u.byteLength<2**16?N+=2:N+=8;const T=I.$je.alloc(N),M=p?64:0,U=R&15;if(T.writeUInt8(128|M|U,0),u.byteLength<126)T.writeUInt8(u.byteLength,1);else if(u.byteLength<2**16){T.writeUInt8(126,1);let Y=1;T.writeUInt8(u.byteLength>>>8&255,++Y),T.writeUInt8(u.byteLength>>>0&255,++Y)}else{T.writeUInt8(127,1);let Y=1;T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(0,++Y),T.writeUInt8(u.byteLength>>>24&255,++Y),T.writeUInt8(u.byteLength>>>16&255,++Y),T.writeUInt8(u.byteLength>>>8&255,++Y),T.writeUInt8(u.byteLength>>>0&255,++Y)}this.socket.write(I.$je.concat([T,u]))}end(){this.h=!0,this.socket.end()}n(u){if(u.byteLength!==0){for(this.b.acceptChunk(u);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const p=this.b.peek(this.j.readLen),R=p.readUInt8(0),N=(R&128)>>>7,T=(R&64)>>>6,M=R&15,U=p.readUInt8(1),Y=(U&128)>>>7,Q=U&127;this.j.state=2,this.j.readLen=2+(Y?4:0)+(Q===126?2:0)+(Q===127?8:0),this.j.fin=N,this.j.firstFrameOfMessage&&(this.j.compressed=!!T),this.j.firstFrameOfMessage=!!N,this.j.mask=0,this.j.opcode=M,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const p=this.b.read(this.j.readLen),R=p.readUInt8(1),N=(R&128)>>>7;let T=R&127,M=1;T===126?T=p.readUInt8(++M)*2**8+p.readUInt8(++M):T===127&&(T=p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*0+p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M));let U=0;N&&(U=p.readUInt8(++M)*2**24+p.readUInt8(++M)*2**16+p.readUInt8(++M)*2**8+p.readUInt8(++M)),this.j.state=3,this.j.readLen=T,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const p=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",p),i(p,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",p),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(p,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(p,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await k.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Vh=f;class d extends g.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:I.$je.alloc(0)}constructor(u,p,R,N,T,M){super(),this.n=u,this.r=T,this.s=M,this.a=this.B(new k.$Vd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new k.$Vd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new k.$Vd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,p?(this.b=this.B(new c(this.n,N,R,{windowBits:15})),this.f=this.B(new v(this.n,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(u,p){this.g.push({data:u,options:p}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:u,options:p}=this.g.shift();if(this.f&&p.compressed){const R=await this.w(this.f,u);this.s(R,p)}else this.s(u,{...p,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(u,p){return new Promise((R,N)=>{u.write(p),u.flush(T=>R(T))})}acceptFrame(u,p,R){this.h.push({data:u,isCompressed:p,isLastFrameOfMessage:R}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const u=this.h.shift();if(this.b&&u.isCompressed){const p=await this.C(this.b,u.data,u.isLastFrameOfMessage);this.r.fire(p)}else this.r.fire(u.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(u,p,R){return new Promise((N,T)=>{u.write(p),R&&u.write(I.$je.fromByteArray([0,0,255,255])),u.flush(M=>N(M))})}}class c extends g.$Tc{get recordedInflateBytes(){return this.j?I.$je.concat(this.f):I.$je.alloc(0)}constructor(u,p,R,N){super(),this.h=u,this.j=p,this.a=this.B(new k.$Vd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,A.createInflateRaw)(N),this.b.on("error",T=>{this.h.traceSocketEvent("zlibInflateError",{message:T?.message,code:T?.code}),this.a.fire(T)}),this.b.on("data",T=>{this.h.traceSocketEvent("zlibInflateData",T),this.g.push(I.$je.wrap(T))}),R&&(this.h.traceSocketEvent("zlibInflateInitialWrite",R.buffer),this.b.write(R.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(u){this.j&&this.f.push(u.clone()),this.h.traceSocketEvent("zlibInflateWrite",u),this.b.write(u.buffer)}flush(u){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const p=I.$je.concat(this.g);this.g.length=0,u(p)})}}class v extends g.$Tc{constructor(u,p){super(),this.g=u,this.a=this.B(new k.$Vd),this.onError=this.a.event,this.f=[],this.b=(0,A.createDeflateRaw)({windowBits:15}),this.b.on("error",R=>{this.g.traceSocketEvent("zlibDeflateError",{message:R?.message,code:R?.code}),this.a.fire(R)}),this.b.on("data",R=>{this.g.traceSocketEvent("zlibDeflateData",R),this.f.push(I.$je.wrap(R))})}write(u){this.g.traceSocketEvent("zlibDeflateWrite",u.buffer),this.b.write(u.buffer)}flush(u){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let p=I.$je.concat(this.f);this.f.length=0,p=p.slice(0,p.byteLength-4),u(p)})}}function i(y,u){if(u===0)return;const p=y.byteLength>>>2;for(let Y=0;Y<p;Y++){const Q=y.readUInt32BE(Y*4);y.writeUInt32BE(Q^u,Y*4)}const R=p*4,N=y.byteLength-R,T=u>>>24&255,M=u>>>16&255,U=u>>>8&255;N>=1&&y.writeUInt8(y.readUInt8(R)^T,R),N>=2&&y.writeUInt8(y.readUInt8(R+1)^M,R+1),N>=3&&y.writeUInt8(y.readUInt8(R+2)^U,R+2)}e.$Wh=process.env.XDG_RUNTIME_DIR;const o={[2]:107,[1]:103};function n(){const y=(0,m.$qg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${y}-sock`;const u=process.platform!=="darwin"&&e.$Wh?e.$Wh:(0,D.tmpdir)(),p=(0,C.$jc)(u,`vscode-ipc-${y}.sock`);return t(p),p}e.$Xh=n;function s(y,u,p){const N=(0,O.createHash)("sha256").update(y).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${N}-${p}-${u}-sock`;const T=p.substr(0,4),M=u.substr(0,6);let U;return process.platform!=="darwin"&&e.$Wh&&!process.env.VSCODE_PORTABLE?U=(0,C.$jc)(e.$Wh,`vscode-${N}-${T}-${M}.sock`):U=(0,C.$jc)(y,`${T}-${M}.sock`),t(U),U}e.$Yh=s;function t(y){const u=o[S.$u];typeof u=="number"&&y.length>=u&&console.warn(`WARNING: IPC handle "${y}" is longer than ${u} chars, try a shorter --user-data-dir`)}class r extends l.$Jh{static b(u){const p=k.Event.fromNodeEventEmitter(u,"connection");return k.Event.map(p,R=>({protocol:new $.$Qh(new b(R,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(R,"close"))}))}constructor(u){super(r.b(u)),this.d=u}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Zh=r;function a(y){return new Promise((u,p)=>{const R=(0,L.createServer)();R.on("error",p),R.listen(y,()=>{R.removeListener("error",p),u(new r(R))})})}e.$1h=a;function E(y,u){return new Promise((p,R)=>{const N=(0,L.createConnection)(y,()=>{N.removeListener("error",R),p($.$Rh.fromSocket(new b(N,`ipc-client${u}`),u))});N.once("error",R)})}e.$2h=E}),define(le[265],he([0,1,64,123,212]),function(se,e,O,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hac=void 0,e.$Hac=new class{supports(A){return!0}connect({host:A,port:I},P,k,g){return new Promise((C,S)=>{const m=O.createConnection({host:A,port:I},()=>{m.removeListener("error",S),m.write((0,D.$6rb)(P,k,g));const l=$=>{$.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",l),C(new L.$Uh(m,g)))};m.on("data",l)});m.setNoDelay(!0),m.once("error",S)})}}}),define(le[266],he([0,1,64,36,133,123,6,2,5,21,8,24,215,104,106,79,14]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=e.$D_b=e.$C_b=e.$B_b=void 0;async function h(i,o,n,s,t){let r;for(let a=3;a&&(r?.dispose(),r=await new f(i,o,n,s,t).waitForReady(),!(t&&D.$tg[t]||!D.$tg[r.tunnelLocalPort]));a--);return r}class f extends P.$Tc{constructor(o,n,s,t,r){super(),this.m=n,this.n=r,this.privacy=b.TunnelPrivacyId.Private,this.j=new Map,this.a=o,this.b=O.createServer(),this.c=new I.$5g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=a=>this.r(a),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=s}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(n=>{n()})}async waitForReady(){const o=this.n??this.tunnelRemotePort,n=(0,b.$Hv)(this.m)?"0.0.0.0":"127.0.0.1";let s=await(0,D.$ug)(o,2,1e3,n),t=null;return this.b.listen(s,this.m),await this.c.wait(),t=this.b.address(),t||(s=0,this.b.listen(s,this.m),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async r(o){o.pause();const n=(0,b.$Fv)(this.tunnelRemoteHost)||(0,b.$Hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,s=await(0,m.$ll)(this.a,n,this.tunnelRemotePort),t=s.getSocket(),r=s.readEntireBuffer();s.dispose(),r.byteLength>0&&o.write(r.buffer),o.on("end",()=>{o.localAddress&&this.j.delete(o.localAddress),t.end()}),o.on("close",()=>t.end()),o.on("error",()=>{o.localAddress&&this.j.delete(o.localAddress),t instanceof A.$Uh?t.socket.destroy():t.end()}),t instanceof A.$Uh?this.t(o,t):this.s(o,t),o.localAddress&&this.j.set(o.localAddress,()=>{o.end(),t.end()})}s(o,n){n.onClose(()=>o.destroy()),n.onEnd(()=>o.end()),n.onData(s=>o.write(s.buffer)),o.on("data",s=>n.write(w.$je.wrap(s))),o.resume()}t(o,n){const s=n.socket;s.on("end",()=>o.end()),s.on("close",()=>o.end()),s.on("error",()=>{o.destroy()}),s.pipe(o),o.pipe(s)}}e.$B_b=f;let d=class extends b.$Kv{constructor(o,n,s,t,r){super(n,r),this.v=o,this.w=s,this.y=t}isPortPrivileged(o){return(0,b.$Iv)(o,this.m,k.OS,L.release())}t(o,n,s,t,r,a,E,y){const u=this.s(n,s);if(u)return++u.refcount,u.value;if((0,b.$Cv)(o))return this.u(o,n,s,r,a,E,y);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${s} on local port ${r}.`);const p={commit:this.y.commit,quality:this.y.quality,addressProvider:o,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},R=h(p,t,n,s,r);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(n,s,R),R}}};e.$C_b=d,e.$C_b=d=pe([X(0,l.$fl),X(1,C.$nj),X(2,$.$il),X(3,S.$Fj),X(4,g.$zi)],d);let c=class extends d{constructor(o,n,s,t,r){super(o,n,s,t,r)}};e.$D_b=c,e.$D_b=c=pe([X(0,l.$fl),X(1,C.$nj),X(2,$.$il),X(3,S.$Fj),X(4,g.$zi)],c);let v=class extends P.$Tc{constructor(o,n,s,t,r){super(),this.b=o,this.c=n,this.f=s,this.g=t,this.h=r,this.a=new Map}async openTunnel(o,n,s,t,r,a,E,y,u){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${s}:${t} on local port ${a}.`),!this.a.has(o)){const p=new c(this.b,this.c,this.g,this.f,this.h);this.B(p),this.a.set(o,p),p.onTunnelClosed(async()=>{(await p.tunnels).length===0&&(p.dispose(),this.a.delete(o))})}return this.a.get(o).openTunnel(n,s,t,r,a,E,y,u)}};e.$E_b=v,e.$E_b=v=pe([X(0,l.$fl),X(1,C.$nj),X(2,S.$Fj),X(3,$.$il),X(4,g.$zi)],v)}),define(le[273],he([0,1,36,38,7,2,23,10,17,3,40,147,206,207,197,198,264,188,190,21,211,95,222,96,217,15,114,248,29,99,189,113,97,11,200,201,72,4,196,74,75,228,8,202,102,24,59,19,107,22,108,109,110,46,231,83,111,25,81,256,261,241,84,255,259,260,122,60,254,242,106,221,79,266,216,232,28,233,5,234,191,209,208,82,247,18,51,205,58,253,230,243,105,258,249,9,203,101,251,246,218,185,57,204,262,250,56,252,104,265,182,219]),function(se,e,O,L,D,A,I,P,k,g,C,S,m,l,$,b,w,h,f,d,c,v,i,o,n,s,t,r,a,E,y,u,p,R,N,T,M,U,Y,Q,x,H,Z,W,V,ie,re,ee,ae,K,q,j,F,B,z,_,G,J,te,ne,ce,de,$e,me,Ee,Re,Oe,Ne,ue,ge,we,Ce,Pe,Me,je,qe,Fe,Te,Ue,oe,fe,be,ve,ye,ke,Ie,De,Le,Ve,ze,Be,We,Ze,et,vt,Et,St,dt,kt,Ct,Pt,Rt,It,Ot,jt,Dt,$t,At,gt,Lt,Nt,nt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends A.$Tc{constructor(Se){super(),this.f=Se,this.a=this.B(new S.$NU(this)),this.b=void 0,this.c=this.B(new g.$Vd),this.g()}g(){let Se=!1;const Ae=()=>{Se||(Se=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ae),(0,S.$OU)(process.parentPort,nt.$Q$b.exit,Ae)}async init(){const Se=await this.h();(0,J.$Fnb)(),Se.invokeFunction(Ae=>{const Qe=Ae.get(Z.$nj),He=Ae.get(K.$ul),Xe=Ae.get(Ie.$3k);Qe.trace("sharedProcess configuration",JSON.stringify(this.f)),this.j(Ae),this.m(Qe),this.n(He,Xe),this.B(Xe.onDidChangeProfiles(()=>this.n(He,Xe)))}),this.B((0,A.$Qc)(Se.createInstance(m.$0_b,this.f.codeCachePath),Se.createInstance(l.$$_b),Se.createInstance(w.$bac),Se.createInstance(b.$aac),Se.createInstance($.$__b),Se.createInstance(vt.$yac),Se.createInstance(We.$qac)))}async h(){const Se=new Q.$4h,Ae={_serviceBrand:void 0,...V.default};Se.set(ie.$Fj,Ae);const Qe=new C.$Nh(Ge=>Ge==="main"),He=new $t.$L_b(this.a,Qe);Se.set($t.$K_b,He);const Xe=this.f.policiesData?new Le.$h_b(this.f.policiesData,He.getChannel("policy")):new Ve.$Ln;Se.set(Ve.$Jn,Xe);const Je=new Nt.$Bm(this.f.args,Ae);Se.set(s.$bi,Je);const _e=new W.$Ar(void 0,this.f.logLevel,Je.logsHome,this.f.loggers.map(Ge=>({...Ge,resource:P.URI.revive(Ge.resource)})),He.getChannel("logger"));Se.set(Z.$oj,_e);const rt=this.B(_e.createLogger("sharedprocess",{name:(0,Et.localize)(0,null)})),lt=this.B(new Z.$vj(rt.getLevel())),Ke=this.B(new St.$CO(rt,[lt]));Se.set(Z.$nj,Ke),this.b=this.B(new dt.$Aac(Ke)),Se.set(dt.$zac,this.b);const Ye=this.B(new N.$cq(Ke));Se.set(R.$qk,Ye);const ht=this.B(new T.$Bq(Ke));Ye.registerProvider(I.Schemas.file,ht);const ot=new Te.$2r(Ye);Se.set(Fe.$1k,ot);const xe=this.B(new ze.$JO(this.f.profiles.all,P.URI.revive(this.f.profiles.home).with({scheme:Je.userRoamingDataHome.scheme}),He.getChannel("userDataProfiles")));Se.set(Ie.$3k,xe);const ut=this.B(new oe.$J_b(I.Schemas.file,this.B(new fe.$lO(He.getChannel(fe.$kO),{pathCaseSensitive:Ue.$k})),I.Schemas.vscodeUserData,xe,ot,Ke));Ye.registerProvider(I.Schemas.vscodeUserData,ut);const tt=this.B(new c.$_n(xe.defaultProfile.settingsResource,Ye,Xe,Ke));Se.set(d.$zi,tt);const ft=new At.$Gac(void 0,{defaultProfile:xe.defaultProfile,currentProfile:xe.defaultProfile},He,Je);Se.set(ee.$up,ft),this.B((0,A.$Rc)(()=>ft.flush())),await Promise.all([tt.initialize(),ft.initialize()]);const wt=new Pt.$lr(He.getChannel("request"));Se.set(re.$hp,wt),Se.set(h.$cac,new M.$3h(f.$dac,void 0,!1)),Se.set(ve.$mF,new M.$3h(be.$pac,void 0,!1));const bt=new Ot.$Q_b(-1,He);Se.set(It.$w$b,bt),Se.set(o.$do,new M.$3h(n.$RO,void 0,!0));const Tt=this.B(new ge.$e_b(bt)),Mt=new C.$Nh(Ge=>Tt.getActiveClientId().then(ct=>Ge===ct));Se.set(p.$TZb,new Rt.$Cac(this.a.getChannel("extensionRecommendationNotification",Mt)));let at;const it=[],pt=(0,B.$Xo)(Ae,tt);if((0,B.$So)(Ae,Je)){const Ge=new j.$g9b(Ke,_e,Je,Ae);if(it.push(Ge),!(0,B.$To)(Ae,Je)&&Ae.aiConfig?.ariaKey){const ct=new Be.$qO(wt,pt,"monacoworkbench",null,Ae.aiConfig.ariaKey);this.B((0,A.$Rc)(()=>ct.flush())),it.push(ct)}at=new F.$pr({appenders:it,commonProperties:(0,ae.$Jo)((0,O.release)(),(0,O.hostname)(),process.arch,Ae.commit,Ae.version,this.f.machineId,this.f.sqmId,pt),sendErrorTelemetry:!0,piiPaths:(0,B.$Yo)(Je)},tt,Ae)}else{at=B.$No;const Ge=B.$Ro;it.push(Ge)}this.a.registerChannel("telemetryAppender",new q.$V$b(it)),Se.set(K.$ul,at);const zt=new z.$eac(tt,at,Ke,_e,Je,Ae);Se.set(K.$vl,zt),Se.set(De.$Vp,new M.$3h(Ct.$BO,void 0,!0)),Se.set(ye.$Zp,new M.$3h(ke.$i_b,void 0,!0)),Se.set(E.$Fp,new M.$3h(E.$Gp,void 0,!0)),Se.set(u.$0p,new M.$3h(u.$$p,void 0,!0)),Se.set(a.$yo,new M.$3h(r.$Dp,void 0,!0)),Se.set(a.$Fo,new M.$3h(Dt.$Fac,void 0,!1)),Se.set(x.$hr,new M.$3h(H.$jr,void 0,!1)),Se.set(v.$Im,new M.$3h(i.$9r,void 0,!1)),Se.set(te.$CFb,new M.$3h(te.$DFb,void 0,!0)),Se.set(J.$1nb,new M.$3h(de.$WHb,void 0,!0)),Se.set(J.$Znb,C.ProxyChannel.toService(this.a.getChannel("userDataSyncUtil",Ge=>Ge.ctx!=="main"))),Se.set(a.$Eo,new M.$3h(t.$AFb,void 0,!1)),Se.set(G.$UHb,new M.$3h(G.$VHb,void 0,!0)),Se.set(_.$mv,new M.$3h(_.$nv)),Se.set(J.$Knb,new M.$3h(Oe.$6Gb,void 0,!0)),Se.set(J.$Lnb,new M.$3h(Oe.$8Gb,void 0,!0)),Se.set($e.$ynb,new M.$3h($e.$Anb,void 0,!0)),Se.set(J.$Mnb,new M.$3h(ne.$V9b,void 0,!1)),Se.set(J.$Vnb,new M.$3h(me.$K9b,void 0,!0)),Se.set(J.$Wnb,new M.$3h(Ee.$19b,void 0,!1)),Se.set(Ne.$cGb,new M.$3h(ue.$lac,void 0,!0)),Se.set(J.$Xnb,new M.$3h(et.$x0b,void 0,!0)),Se.set(we.$il,new M.$3h(Ce.$G_b,void 0,!1));const yt=new gt.$gl;return Se.set(gt.$fl,yt),yt.register(0,Lt.$Hac),Se.set(Pe.$Bv,new M.$3h(Me.$E_b)),Se.set(je.$mac,new M.$3h(qe.$oac)),Se.set(Ze.$rac,new M.$3h(kt.$Bac)),new Y.$Eq(Se)}j(Se){const Ae=new y.$Ip(Se.get(a.$Bo),()=>null);this.a.registerChannel("extensions",Ae);const Qe=C.ProxyChannel.fromService(Se.get(x.$hr),this.q);this.a.registerChannel("languagePacks",Qe);const He=C.ProxyChannel.fromService(Se.get(v.$Im),this.q);this.a.registerChannel("diagnostics",He);const Xe=new y.$Kp(Se.get(a.$Fo));this.a.registerChannel("extensionTipsService",Xe);const Je=C.ProxyChannel.fromService(Se.get(h.$cac),this.q);this.a.registerChannel("checksum",Je);const _e=C.ProxyChannel.fromService(Se.get(ve.$mF),this.q);this.a.registerChannel("v8InspectProfiling",_e);const rt=C.ProxyChannel.fromService(Se.get($e.$ynb),this.q);this.a.registerChannel("userDataSyncMachines",rt);const lt=C.ProxyChannel.fromService(Se.get(K.$vl),this.q);this.a.registerChannel("customEndpointTelemetry",lt);const Ke=new ce.$fac(Se.get(te.$CFb));this.a.registerChannel("userDataSyncAccount",Ke);const Ye=new ce.$hac(Se.get(J.$Knb));this.a.registerChannel("userDataSyncStoreManagement",Ye);const ht=new Re.$jac(Se.get(J.$Wnb),Se.get(Ie.$3k),Se.get(Z.$nj));this.a.registerChannel("userDataSync",ht);const ot=this.B(Se.get(U.$5h).createInstance(jt.$Eac));this.a.registerChannel("userDataAutoSync",C.ProxyChannel.fromService(ot,this.q)),this.a.registerChannel("IUserDataSyncResourceProviderService",C.ProxyChannel.fromService(Se.get(J.$Xnb),this.q));const xe=C.ProxyChannel.fromService(Se.get(je.$mac),this.q);this.a.registerChannel(je.$nac,xe);const ut=C.ProxyChannel.fromService(Se.get(Ze.$rac),this.q);this.a.registerChannel("remoteTunnel",ut)}m(Se){process.on("uncaughtException",Ae=>(0,D.$1)(Ae)),process.on("unhandledRejection",Ae=>(0,D.$1)(Ae)),(0,D.setUnexpectedErrorHandler)(Ae=>{const Qe=(0,L.$Qi)(Ae,!0);Qe&&Se.error(`[uncaught exception in sharedProcess]: ${Qe}`)})}n(Se,Ae){Se.publicLog2("profilesInfo",{count:Ae.profiles.length})}handledClientConnection(Se){if(Se.data!==nt.$S$b.response)return!1;const Ae=(0,k.$Ob)(Se.ports);return Ae?(this.c.fire(Ae),!0):!1}}async function mt(st){const Se=new Ft(st);process.parentPort.postMessage(nt.$Q$b.ipcReady),await Se.init(),process.parentPort.postMessage(nt.$Q$b.initDone)}e.main=mt,process.parentPort.once("message",st=>{mt(st.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/271fb7fbd599b49a1482ea7284a50b3229317f96/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
