/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/base/common/uri","vs/base/common/errors","vs/base/common/path","vs/base/common/types","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/nls!vs/platform/terminal/node/ptyHostMain","vs/nls","vs/base/common/decorators","vs/base/common/process","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/network","os","vs/platform/instantiation/common/instantiation","vs/base/common/lazy","vs/base/common/resources","vs/base/node/pfs","vs/base/common/map","child_process","vs/base/parts/ipc/common/ipc","vs/platform/terminal/common/terminal","vs/base/common/functional","vs/base/common/objects","vs/base/parts/sandbox/node/electronTypes","vs/base/common/extpath","vs/base/common/processes","vs/base/node/processes","vs/platform/contextkey/common/contextkey","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/node/childProcessMonitor","vs/platform/terminal/node/terminalEnvironment","vs/base/common/arraysFind","vs/base/common/collections","vs/base/common/assert","vs/base/common/iterator","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/stream","vs/base/common/hash","vs/base/common/symbols","vs/base/common/ternarySearchTree","vs/base/common/uuid","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/base/common/marshalling","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/terminal/node/ptyService","vs/nls!vs/platform/terminal/node/terminalProcess","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/files/common/files","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/registry/common/platform","vs/platform/terminal/common/capabilities/bufferMarkCapability","vs/platform/terminal/common/capabilities/commandDetection/terminalCommand","vs/platform/terminal/common/capabilities/commandDetectionCapability","vs/platform/terminal/common/capabilities/cwdDetectionCapability","vs/platform/terminal/common/capabilities/partialCommandDetectionCapability","vs/platform/terminal/common/capabilities/terminalCapabilityStore","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalAutoResponder","vs/platform/terminal/common/terminalDataBuffering","vs/platform/terminal/common/terminalProcess","vs/platform/terminal/common/terminalStrings","vs/platform/terminal/common/xterm/shellIntegrationAddon","vs/platform/terminal/node/heartbeatService","vs/platform/terminal/node/windowsShellHelper","vs/platform/terminal/node/terminalProcess","vs/platform/terminal/node/ptyService","fs","util","minimist","node-pty","@xterm/headless","vs/base/common/performance","vs/platform/terminal/node/ptyHostMain"],he=function(oe){for(var e=[],y=0,L=oe.length;y<L;y++)e[y]=le[oe[y]];return e};define(le[40],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function y(l,a,r){const o=L(l,a);if(o!==-1)return l[o]}e.$fb=y;function L(l,a,r=l.length-1){for(let o=r;o>=0;o--){const d=l[o];if(a(d))return o}return-1}e.$gb=L;function k(l,a){const r=A(l,a);return r===-1?void 0:l[r]}e.$hb=k;function A(l,a,r=0,o=l.length){let d=r,n=o;for(;d<n;){const t=Math.floor((d+n)/2);a(l[t])?d=t+1:n=t}return d-1}e.$ib=A;function I(l,a){const r=E(l,a);return r===l.length?void 0:l[r]}e.$jb=I;function E(l,a,r=0,o=l.length){let d=r,n=o;for(;d<n;){const t=Math.floor((d+n)/2);a(l[t])?n=t:d=t+1}return d}e.$kb=E;function h(l,a,r=0,o=l.length){const d=E(l,a,r,o);return d===l.length?-1:d}e.$lb=h;class u{static{this.assertInvariants=!1}constructor(a){this.e=a,this.c=0}findLastMonotonous(a){if(u.assertInvariants){if(this.d){for(const o of this.e)if(this.d(o)&&!a(o))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=a}const r=A(this.e,a,this.c);return this.c=r+1,r===-1?void 0:this.e[r]}}e.$mb=u;function P(l,a){if(l.length===0)return;let r=l[0];for(let o=1;o<l.length;o++){const d=l[o];a(d,r)>0&&(r=d)}return r}e.$nb=P;function m(l,a){if(l.length===0)return;let r=l[0];for(let o=1;o<l.length;o++){const d=l[o];a(d,r)>=0&&(r=d)}return r}e.$ob=m;function p(l,a){return P(l,(r,o)=>-a(r,o))}e.$pb=p;function s(l,a){if(l.length===0)return-1;let r=0;for(let o=1;o<l.length;o++){const d=l[o];a(d,l[r])>0&&(r=o)}return r}e.$qb=s;function $(l,a){for(const r of l){const o=a(r);if(o!==void 0)return o}}e.$rb=$}),define(le[41],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function y(I,E){const h=Object.create(null);for(const u of I){const P=E(u);let m=h[P];m||(m=h[P]=[]),m.push(u)}return h}e.$K=y;function L(I,E){const h=[],u=[];for(const P of I)E.has(P)||h.push(P);for(const P of E)I.has(P)||u.push(P);return{removed:h,added:u}}e.$L=L;function k(I,E){const h=[],u=[];for(const[P,m]of I)E.has(P)||h.push(m);for(const[P,m]of E)I.has(P)||u.push(m);return{removed:h,added:u}}e.$M=k;function A(I,E){const h=new Set;for(const u of E)I.has(u)&&h.add(u);return h}e.$N=A}),define(le[14],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function y(I){return(E,h,u)=>{let P=null,m=null;if(typeof u.value=="function"?(P="value",m=u.value):typeof u.get=="function"&&(P="get",m=u.get),!m)throw new Error("not supported");u[P]=I(m,h)}}function L(I,E,h){let u=null,P=null;if(typeof h.value=="function"?(u="value",P=h.value,P.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(u="get",P=h.get),!P)throw new Error("not supported");const m=`$memoize$${E}`;h[u]=function(...p){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:P.apply(this,p)}),this[m]}}e.$xh=L;function k(I,E,h){return y((u,P)=>{const m=`$debounce$${P}`,p=`$debounce$result$${P}`;return function(...s){this[p]||(this[p]=h?h():void 0),clearTimeout(this[m]),E&&(this[p]=E(this[p],...s),s=[this[p]]),this[m]=setTimeout(()=>{u.apply(this,s),this[p]=h?h():void 0},I)}})}e.$yh=k;function A(I,E,h){return y((u,P)=>{const m=`$throttle$timer$${P}`,p=`$throttle$result$${P}`,s=`$throttle$lastRun$${P}`,$=`$throttle$pending$${P}`;return function(...l){if(this[p]||(this[p]=h?h():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),E&&(this[p]=E(this[p],...l)),this[$])return;const a=this[s]+I;a<=Date.now()?(this[s]=Date.now(),u.apply(this,[this[p]]),this[p]=h?h():void 0):(this[$]=!0,this[m]=setTimeout(()=>{this[$]=!1,this[s]=Date.now(),u.apply(this,[this[p]]),this[p]=h?h():void 0},a-Date.now()))}})}e.$zh=A}),define(le[6],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class y{constructor(){this.b=[],this.a=function(i){setTimeout(()=>{throw i.stack?d.isErrorNoTelemetry(i)?new d(i.message+`

`+i.stack):new Error(i.message+`

`+i.stack):i},0)}}addListener(i){return this.b.push(i),()=>{this.d(i)}}c(i){this.b.forEach(w=>{w(i)})}d(i){this.b.splice(this.b.indexOf(i),1)}setUnexpectedErrorHandler(i){this.a=i}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(i){this.a(i),this.c(i)}onUnexpectedExternalError(i){this.a(i)}}e.$W=y,e.$X=new y;function L(t){e.$X.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=L;function k(t){if(!t||typeof t!="object")return!1;const i=t;return i.code==="EPIPE"&&i.syscall?.toUpperCase()==="WRITE"}e.$Z=k;function A(t){u(t)||e.$X.onUnexpectedError(t)}e.$1=A;function I(t){u(t)||e.$X.onUnexpectedExternalError(t)}e.$2=I;function E(t){if(t instanceof Error){const{name:i,message:w}=t,j=t.stacktrace||t.stack;return{$isError:!0,name:i,message:w,stack:j,noTelemetry:d.isErrorNoTelemetry(t)}}return t}e.$3=E;const h="Canceled";function u(t){return t instanceof P?!0:t instanceof Error&&t.name===h&&t.message===h}e.$4=u;class P extends Error{constructor(){super(h),this.name=this.message}}e.$5=P;function m(){const t=new Error(h);return t.name=t.message,t}e.$6=m;function p(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.$7=p;function s(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.$8=s;class $ extends TypeError{constructor(i){super(i?`${i} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=$;function l(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.$0=l;class a extends Error{constructor(i){super("NotImplemented"),i&&(this.message=i)}}e.$$=a;class r extends Error{constructor(i){super("NotSupported"),i&&(this.message=i)}}e.$_=r;class o extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=o;class d extends Error{constructor(i){super(i),this.name="CodeExpectedError"}static fromError(i){if(i instanceof d)return i;const w=new d;return w.message=i.message,w.stack=i.stack,w}static isErrorNoTelemetry(i){return i.name==="CodeExpectedError"}}e.$bb=d;class n extends Error{constructor(i){super(i||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(le[16],he([0,1,6,40]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function k(F,J=0){return F[F.length-(1+J)]}e.$sb=k;function A(F){if(F.length===0)throw new Error("Invalid tail call");return[F.slice(0,F.length-1),F[F.length-1]]}e.$tb=A;function I(F,J,R=(O,N)=>O===N){if(F===J)return!0;if(!F||!J||F.length!==J.length)return!1;for(let O=0,N=F.length;O<N;O++)if(!R(F[O],J[O]))return!1;return!0}e.$ub=I;function E(F,J){const R=F.length-1;J<R&&(F[J]=F[R]),F.pop()}e.$vb=E;function h(F,J,R){return u(F.length,O=>R(F[O],J))}e.$wb=h;function u(F,J){let R=0,O=F-1;for(;R<=O;){const N=(R+O)/2|0,G=J(N);if(G<0)R=N+1;else if(G>0)O=N-1;else return N}return-(R+1)}e.$xb=u;function P(F,J,R){if(F=F|0,F>=J.length)throw new TypeError("invalid index");const O=J[Math.floor(J.length*Math.random())],N=[],G=[],Q=[];for(const ie of J){const ue=R(ie,O);ue<0?N.push(ie):ue>0?G.push(ie):Q.push(ie)}return F<N.length?P(F,N,R):F<N.length+Q.length?Q[0]:P(F-(N.length+Q.length),G,R)}e.$yb=P;function m(F,J){const R=[];let O;for(const N of F.slice(0).sort(J))!O||J(O[0],N)!==0?(O=[N],R.push(O)):O.push(N);return R}e.$zb=m;function*p(F,J){let R,O;for(const N of F)O!==void 0&&J(O,N)?R.push(N):(R&&(yield R),R=[N]),O=N;R&&(yield R)}e.$Ab=p;function s(F,J){for(let R=0;R<=F.length;R++)J(R===0?void 0:F[R-1],R===F.length?void 0:F[R])}e.$Bb=s;function $(F,J){for(let R=0;R<F.length;R++)J(R===0?void 0:F[R-1],F[R],R+1===F.length?void 0:F[R+1])}e.$Cb=$;function l(F,J,R){const O=[];function N(ie,ue,$e){if(ue===0&&$e.length===0)return;const we=O[O.length-1];we&&we.start+we.deleteCount===ie?(we.deleteCount+=ue,we.toInsert.push(...$e)):O.push({start:ie,deleteCount:ue,toInsert:$e})}let G=0,Q=0;for(;;){if(G===F.length){N(G,0,J.slice(Q));break}if(Q===J.length){N(G,F.length-G,[]);break}const ie=F[G],ue=J[Q],$e=R(ie,ue);$e===0?(G+=1,Q+=1):$e<0?(N(G,1,[]),G+=1):$e>0&&(N(G,0,[ue]),Q+=1)}return O}e.$Db=l;function a(F,J,R){const O=l(F,J,R),N=[],G=[];for(const Q of O)N.push(...F.slice(Q.start,Q.start+Q.deleteCount)),G.push(...Q.toInsert);return{removed:N,added:G}}e.$Eb=a;function r(F,J,R){if(R===0)return[];const O=F.slice(0,R).sort(J);return d(F,J,O,R,F.length),O}e.top=r;function o(F,J,R,O,N){return R===0?Promise.resolve([]):new Promise((G,Q)=>{(async()=>{const ie=F.length,ue=F.slice(0,R).sort(J);for(let $e=R,we=Math.min(R+O,ie);$e<ie;$e=we,we=Math.min(we+O,ie)){if($e>R&&await new Promise(ve=>setTimeout(ve)),N&&N.isCancellationRequested)throw new y.$5;d(F,J,ue,$e,we)}return ue})().then(G,Q)})}e.$Gb=o;function d(F,J,R,O,N){for(const G=R.length;O<N;O++){const Q=F[O];if(J(Q,R[G-1])<0){R.pop();const ie=(0,L.$kb)(R,ue=>J(Q,ue)<0);R.splice(ie,0,Q)}}}function n(F){return F.filter(J=>!!J)}e.$Hb=n;function t(F){let J=0;for(let R=0;R<F.length;R++)F[R]&&(F[J]=F[R],J+=1);F.length=J}e.$Ib=t;function i(F,J,R){F.splice(R,0,F.splice(J,1)[0])}e.$Jb=i;function w(F){return!Array.isArray(F)||F.length===0}e.$Kb=w;function j(F){return Array.isArray(F)&&F.length>0}e.$Lb=j;function g(F,J=R=>R){const R=new Set;return F.filter(O=>{const N=J(O);return R.has(N)?!1:(R.add(N),!0)})}e.$Mb=g;function C(F){const J=new Set;return R=>{const O=F(R);return J.has(O)?!1:(J.add(O),!0)}}e.$Nb=C;function v(F,J){return F.length>0?F[0]:J}e.$Ob=v;function D(F,J){return F.length>0?F[F.length-1]:J}e.$Pb=D;function W(F,J,R=(O,N)=>O===N){let O=0;for(let N=0,G=Math.min(F.length,J.length);N<G&&R(F[N],J[N]);N++)O++;return O}e.$Qb=W;function q(F){return[].concat(...F)}e.$Rb=q;function c(F,J){let R=typeof J=="number"?F:0;typeof J=="number"?R=F:(R=0,J=F);const O=[];if(R<=J)for(let N=R;N<J;N++)O.push(N);else for(let N=R;N>J;N--)O.push(N);return O}e.$Sb=c;function b(F,J,R){return F.reduce((O,N)=>(O[J(N)]=R?R(N):N,O),Object.create(null))}e.$Tb=b;function S(F,J){return F.push(J),()=>B(F,J)}e.$Ub=S;function B(F,J){const R=F.indexOf(J);if(R>-1)return F.splice(R,1),J}e.$Vb=B;function M(F,J,R){const O=F.slice(0,J),N=F.slice(J);return O.concat(R,N)}e.$Wb=M;function z(F,J){let R;if(typeof J=="number"){let O=J;R=()=>{const N=Math.sin(O++)*179426549;return N-Math.floor(N)}}else R=Math.random;for(let O=F.length-1;O>0;O-=1){const N=Math.floor(R()*(O+1)),G=F[O];F[O]=F[N],F[N]=G}}e.$Xb=z;function ee(F,J){const R=F.indexOf(J);R>-1&&(F.splice(R,1),F.unshift(J))}e.$Yb=ee;function ne(F,J){const R=F.indexOf(J);R>-1&&(F.splice(R,1),F.push(J))}e.$Zb=ne;function Y(F,J){for(const R of J)F.push(R)}e.$1b=Y;function se(F,J){return Array.isArray(F)?F.map(J):J(F)}e.$2b=se;function ce(F){return Array.isArray(F)?F:[F]}e.$3b=ce;function fe(F){return F[Math.floor(Math.random()*F.length)]}e.$4b=fe;function X(F,J,R){const O=K(F,J),N=F.length,G=R.length;F.length=N+G;for(let Q=N-1;Q>=O;Q--)F[Q+G]=F[Q];for(let Q=0;Q<G;Q++)F[Q+O]=R[Q]}e.$5b=X;function V(F,J,R,O){const N=K(F,J);let G=F.splice(N,R);return G===void 0&&(G=[]),X(F,N,O),G}e.$6b=V;function K(F,J){return J<0?Math.max(J+F.length,0):Math.min(J,F.length)}var te;(function(F){function J(G){return G<0}F.isLessThan=J;function R(G){return G<=0}F.isLessThanOrEqual=R;function O(G){return G>0}F.isGreaterThan=O;function N(G){return G===0}F.isNeitherLessOrGreaterThan=N,F.greaterThan=1,F.lessThan=-1,F.neitherLessOrGreaterThan=0})(te||(e.CompareResult=te={}));function H(F,J){return(R,O)=>J(F(R),F(O))}e.$7b=H;function x(...F){return(J,R)=>{for(const O of F){const N=O(J,R);if(!te.isNeitherLessOrGreaterThan(N))return N}return te.neitherLessOrGreaterThan}}e.$8b=x;const ge=(F,J)=>F-J;e.$9b=ge;const _=(F,J)=>(0,e.$9b)(F?1:0,J?1:0);e.$0b=_;function f(F){return(J,R)=>-F(J,R)}e.$$b=f;class U{constructor(J){this.g=J,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(J){let R=this.c;for(;R<this.g.length&&J(this.g[R]);)R++;const O=R===this.c?null:this.g.slice(this.c,R);return this.c=R,O}takeFromEndWhile(J){let R=this.d;for(;R>=0&&J(this.g[R]);)R--;const O=R===this.d?null:this.g.slice(R+1,this.d+1);return this.d=R,O}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const J=this.g[this.c];return this.c++,J}removeLast(){const J=this.g[this.d];return this.d--,J}takeCount(J){const R=this.g.slice(this.c,this.c+J);return this.c+=J,R}}e.$_b=U;class re{static{this.empty=new re(J=>{})}constructor(J){this.iterate=J}forEach(J){this.iterate(R=>(J(R),!0))}toArray(){const J=[];return this.iterate(R=>(J.push(R),!0)),J}filter(J){return new re(R=>this.iterate(O=>J(O)?R(O):!0))}map(J){return new re(R=>this.iterate(O=>R(J(O))))}some(J){let R=!1;return this.iterate(O=>(R=J(O),!R)),R}findFirst(J){let R;return this.iterate(O=>J(O)?(R=O,!1):!0),R}findLast(J){let R;return this.iterate(O=>(J(O)&&(R=O),!0)),R}findLastMaxBy(J){let R,O=!0;return this.iterate(N=>((O||te.isGreaterThan(J(N,R)))&&(O=!1,R=N),!0)),R}}e.$ac=re}),define(le[42],he([0,1,6]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function L(h,u){if(!h)throw new Error(u?`Assertion failed (${u})`:"Assertion Failed")}e.ok=L;function k(h,u="Unreachable"){throw new Error(u)}e.$6c=k;function A(h){if(!h)throw new y.$cb("Assertion Failed")}e.$7c=A;function I(h){if(!h()){debugger;h(),(0,y.$1)(new y.$cb("Assertion Failed"))}}e.$8c=I;function E(h,u){let P=0;for(;P<h.length-1;){const m=h[P],p=h[P+1];if(!u(m,p))return!1;P++}return!0}e.$9c=E}),define(le[29],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function y(L,k){const A=this;let I=!1,E;return function(){if(I)return E;if(I=!0,k)try{E=L.apply(A,arguments)}finally{k()}else E=L.apply(A,arguments);return E}}e.$db=y}),define(le[43],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var y;(function(L){function k(i){return i&&typeof i=="object"&&typeof i[Symbol.iterator]=="function"}L.is=k;const A=Object.freeze([]);function I(){return A}L.empty=I;function*E(i){yield i}L.single=E;function h(i){return k(i)?i:E(i)}L.wrap=h;function u(i){return i||A}L.from=u;function*P(i){for(let w=i.length-1;w>=0;w--)yield i[w]}L.reverse=P;function m(i){return!i||i[Symbol.iterator]().next().done===!0}L.isEmpty=m;function p(i){return i[Symbol.iterator]().next().value}L.first=p;function s(i,w){for(const j of i)if(w(j))return!0;return!1}L.some=s;function $(i,w){for(const j of i)if(w(j))return j}L.find=$;function*l(i,w){for(const j of i)w(j)&&(yield j)}L.filter=l;function*a(i,w){let j=0;for(const g of i)yield w(g,j++)}L.map=a;function*r(...i){for(const w of i)yield*w}L.concat=r;function o(i,w,j){let g=j;for(const C of i)g=w(g,C);return g}L.reduce=o;function*d(i,w,j=i.length){for(w<0&&(w+=i.length),j<0?j+=i.length:j>i.length&&(j=i.length);w<j;w++)yield i[w]}L.slice=d;function n(i,w=Number.POSITIVE_INFINITY){const j=[];if(w===0)return[j,i];const g=i[Symbol.iterator]();for(let C=0;C<w;C++){const v=g.next();if(v.done)return[j,L.empty()];j.push(v.value)}return[j,{[Symbol.iterator](){return g}}]}L.consume=n;async function t(i){const w=[];for await(const j of i)w.push(j);return Promise.resolve(w)}L.asyncToArray=t})(y||(e.Iterable=y={}))}),define(le[22],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class y{constructor(k){this.d=k,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(k){this.c=k}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=y}),define(le[44],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class y{static{this.Undefined=new y(void 0)}constructor(A){this.element=A,this.next=y.Undefined,this.prev=y.Undefined}}class L{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let A=this.a;for(;A!==y.Undefined;){const I=A.next;A.prev=y.Undefined,A.next=y.Undefined,A=I}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(A){return this.d(A,!1)}push(A){return this.d(A,!0)}d(A,I){const E=new y(A);if(this.a===y.Undefined)this.a=E,this.b=E;else if(I){const u=this.b;this.b=E,E.prev=u,u.next=E}else{const u=this.a;this.a=E,E.next=u,u.prev=E}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(E))}}shift(){if(this.a!==y.Undefined){const A=this.a.element;return this.e(this.a),A}}pop(){if(this.b!==y.Undefined){const A=this.b.element;return this.e(this.b),A}}e(A){if(A.prev!==y.Undefined&&A.next!==y.Undefined){const I=A.prev;I.next=A.next,A.next.prev=I}else A.prev===y.Undefined&&A.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):A.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):A.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let A=this.a;for(;A!==y.Undefined;)yield A.element,A=A.next}}e.$4c=L}),define(le[25],he([0,1]),function(oe,e){"use strict";var y,L,k;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function A(d,n,t){let i=d.get(n);return i===void 0&&(i=t,d.set(n,i)),i}e.$xc=A;function I(d){const n=[];return d.forEach((t,i)=>{n.push(`${i} => ${t}`)}),`Map(${d.size}) {${n.join(", ")}}`}e.$yc=I;function E(d){const n=[];return d.forEach(t=>{n.push(t)}),`Set(${d.size}) {${n.join(", ")}}`}e.$zc=E;class h{constructor(n,t){this.uri=n,this.value=t}}function u(d){return Array.isArray(d)}class P{static{this.c=n=>n.toString()}constructor(n,t){if(this[y]="ResourceMap",n instanceof P)this.d=new Map(n.d),this.e=t??P.c;else if(u(n)){this.d=new Map,this.e=t??P.c;for(const[i,w]of n)this.set(i,w)}else this.d=new Map,this.e=n??P.c}set(n,t){return this.d.set(this.e(n),new h(n,t)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,t){typeof t<"u"&&(n=n.bind(t));for(const[i,w]of this.d)n(w.value,w.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=P;class m{constructor(n,t){this[L]="ResourceSet",!n||typeof n=="function"?this.c=new P(n):(this.c=new P(t),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,t){this.c.forEach((i,w)=>n.call(t,w,w,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=m;var p;(function(d){d[d.None=0]="None",d[d.AsOld=1]="AsOld",d[d.AsNew=2]="AsNew"})(p||(e.Touch=p={}));class s{constructor(){this[k]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,t=0){const i=this.c.get(n);if(i)return t!==0&&this.l(i,t),i.value}set(n,t,i=0){let w=this.c.get(n);if(w)w.value=t,i!==0&&this.l(w,i);else{switch(w={key:n,value:t,next:void 0,previous:void 0},i){case 0:this.j(w);break;case 1:this.i(w);break;case 2:this.j(w);break;default:this.j(w);break}this.c.set(n,w),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const t=this.c.get(n);if(t)return this.c.delete(n),this.k(t),this.f--,t.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,t){const i=this.g;let w=this.d;for(;w;){if(t?n.bind(t)(w.value,w.key,this):n(w.value,w.key,this),this.g!==i)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const n=this,t=this.g;let i=this.d;const w={[Symbol.iterator](){return w},next(){if(n.g!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const j={value:i.key,done:!1};return i=i.next,j}else return{value:void 0,done:!0}}};return w}values(){const n=this,t=this.g;let i=this.d;const w={[Symbol.iterator](){return w},next(){if(n.g!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const j={value:i.value,done:!1};return i=i.next,j}else return{value:void 0,done:!0}}};return w}entries(){const n=this,t=this.g;let i=this.d;const w={[Symbol.iterator](){return w},next(){if(n.g!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const j={value:[i.key,i.value],done:!1};return i=i.next,j}else return{value:void 0,done:!0}}};return w}[(k=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let t=this.d,i=this.size;for(;t&&i>n;)this.c.delete(t.key),t=t.next,i--;this.d=t,this.f=i,t&&(t.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const t=n.next,i=n.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}n.next=void 0,n.previous=void 0,this.g++}l(n,t){if(!this.d||!this.e)throw new Error("Invalid list");if(!(t!==1&&t!==2)){if(t===1){if(n===this.d)return;const i=n.next,w=n.previous;n===this.e?(w.next=void 0,this.e=w):(i.previous=w,w.next=i),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(t===2){if(n===this.e)return;const i=n.next,w=n.previous;n===this.d?(i.previous=void 0,this.d=i):(i.previous=w,w.next=i),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((t,i)=>{n.push([i,t])}),n}fromJSON(n){this.clear();for(const[t,i]of n)this.set(t,i)}}e.$Cc=s;class $ extends s{constructor(n,t=1){super(),this.m=n,this.n=Math.min(Math.max(0,t),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,t=2){return super.get(n,t)}peek(n){return super.get(n,0)}set(n,t){return super.set(n,t,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=$;class l{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let t=this.c.get(n)||0;return t===0?!1:(t--,t===0?this.c.delete(n):this.c.set(n,t),!0)}has(n){return this.c.has(n)}}e.$Ec=l;class a{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[t,i]of n)this.set(t,i)}clear(){this.c.clear(),this.d.clear()}set(n,t){this.c.set(n,t),this.d.set(t,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const t=this.c.get(n);return t===void 0?!1:(this.c.delete(n),this.d.delete(t),!0)}forEach(n,t){this.c.forEach((i,w)=>{n.call(t,i,w,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=a;class r{constructor(){this.c=new Map}add(n,t){let i=this.c.get(n);i||(i=new Set,this.c.set(n,i)),i.add(t)}delete(n,t){const i=this.c.get(n);i&&(i.delete(t),i.size===0&&this.c.delete(n))}forEach(n,t){const i=this.c.get(n);i&&i.forEach(t)}get(n){const t=this.c.get(n);return t||new Set}}e.$Gc=r;function o(d,n){if(d===n)return!0;if(d.size!==n.size)return!1;for(const[t,i]of d)if(!n.has(t)||n.get(t)!==i)return!1;for(const[t]of n)if(!d.has(t))return!1;return!0}e.$Hc=o}),define(le[2],he([0,1,16,41,25,29,43]),function(oe,e,y,L,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const E=!1;let h=null;class u{constructor(){this.b=new Map}static{this.a=0}c(S){let B=this.b.get(S);return B||(B={parent:null,source:null,isSingleton:!1,value:S,idx:u.a++},this.b.set(S,B)),B}trackDisposable(S){const B=this.c(S);B.source||(B.source=new Error().stack)}setParent(S,B){const M=this.c(S);M.parent=B}markAsDisposed(S){this.b.delete(S)}markAsSingleton(S){this.c(S).isSingleton=!0}f(S,B){const M=B.get(S);if(M)return M;const z=S.parent?this.f(this.c(S.parent),B):S;return B.set(S,z),z}getTrackedDisposables(){const S=new Map;return[...this.b.entries()].filter(([,M])=>M.source!==null&&!this.f(M,S).isSingleton).flatMap(([M])=>M)}computeLeakingDisposables(S=10,B){let M;if(B)M=B;else{const se=new Map,ce=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,se).isSingleton);if(ce.length===0)return;const fe=new Set(ce.map(X=>X.value));if(M=ce.filter(X=>!(X.parent&&fe.has(X.parent))),M.length===0)throw new Error("There are cyclic diposable chains!")}if(!M)return;function z(se){function ce(X,V){for(;X.length>0&&V.some(K=>typeof K=="string"?K===X[0]:X[0].match(K));)X.shift()}const fe=se.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return ce(fe,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),fe.reverse()}const ee=new k.$Gc;for(const se of M){const ce=z(se);for(let fe=0;fe<=ce.length;fe++)ee.add(ce.slice(0,fe).join(`
`),se)}M.sort((0,y.$7b)(se=>se.idx,y.$9b));let ne="",Y=0;for(const se of M.slice(0,S)){Y++;const ce=z(se),fe=[];for(let X=0;X<ce.length;X++){let V=ce[X];V=`(shared with ${ee.get(ce.slice(0,X+1).join(`
`)).size}/${M.length} leaks) at ${V}`;const te=ee.get(ce.slice(0,X).join(`
`)),H=(0,L.$K)([...te].map(x=>z(x)[X]),x=>x);delete H[ce[X]];for(const[x,ge]of Object.entries(H))fe.unshift(`    - stacktraces of ${ge.length} other leaks continue with ${x}`);fe.unshift(V)}ne+=`


==================== Leaking disposable ${Y}/${M.length}: ${se.value.constructor.name} ====================
${fe.join(`
`)}
============================================================

`}return M.length>S&&(ne+=`


... and ${M.length-S} more leaking disposables

`),{leaks:M,details:ne}}}e.$Ic=u;function P(b){h=b}if(e.$Jc=P,E){const b="__is_disposable_tracked__";P(new class{trackDisposable(S){const B=new Error("Potentially leaked disposable").stack;setTimeout(()=>{S[b]||console.log(B)},3e3)}setParent(S,B){if(S&&S!==i.None)try{S[b]=!0}catch{}}markAsDisposed(S){if(S&&S!==i.None)try{S[b]=!0}catch{}}markAsSingleton(S){}})}function m(b){return h?.trackDisposable(b),b}e.$Kc=m;function p(b){h?.markAsDisposed(b)}e.$Lc=p;function s(b,S){h?.setParent(b,S)}function $(b,S){if(h)for(const B of b)h.setParent(B,S)}function l(b){return h?.markAsSingleton(b),b}e.$Mc=l;function a(b){return typeof b.dispose=="function"&&b.dispose.length===0}e.$Nc=a;function r(b){if(I.Iterable.is(b)){const S=[];for(const B of b)if(B)try{B.dispose()}catch(M){S.push(M)}if(S.length===1)throw S[0];if(S.length>1)throw new AggregateError(S,"Encountered errors while disposing of store");return Array.isArray(b)?[]:b}else if(b)return b.dispose(),b}e.$Oc=r;function o(b){for(const S of b)a(S)&&S.dispose();return[]}e.$Pc=o;function d(...b){const S=n(()=>r(b));return $(b,S),S}e.$Qc=d;function n(b){const S=m({dispose:(0,A.$db)(()=>{p(S),b()})});return S}e.$Rc=n;class t{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,m(this)}dispose(){this.g||(p(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{r(this.f)}finally{this.f.clear()}}add(S){if(!S)return S;if(S===this)throw new Error("Cannot register a disposable on itself!");return s(S,this),this.g?t.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(S),S}delete(S){if(S){if(S===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(S),S.dispose()}}deleteAndLeak(S){S&&this.f.has(S)&&(this.f.delete(S),s(S,null))}}e.$Sc=t;class i{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new t,m(this),s(this.q,this)}dispose(){p(this),this.q.dispose()}B(S){if(S===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(S)}}e.$Tc=i;class w{constructor(){this.b=!1,m(this)}get value(){return this.b?void 0:this.a}set value(S){this.b||S===this.a||(this.a?.dispose(),S&&s(S,this),this.a=S)}clear(){this.value=void 0}dispose(){this.b=!0,p(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const S=this.a;return this.a=void 0,S&&s(S,null),S}}e.$Uc=w;class j{constructor(S){this.a=new w,this.b=!1,this.a.value=S}get value(){return this.a.value}set value(S){this.b||S===this.a.value||(this.a.value=S)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=j;class g{constructor(S){this.b=S,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=g;class C{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,m(this)}set(S){let B=S;return this.unset=()=>B=void 0,this.isset=()=>B!==void 0,this.dispose=()=>{B&&(B(),B=void 0,p(this))},this}}e.$Xc=C;class v{constructor(){this.a=new Map}acquire(S,...B){let M=this.a.get(S);M||(M={counter:0,object:this.b(S,...B)},this.a.set(S,M));const{object:z}=M,ee=(0,A.$db)(()=>{--M.counter===0&&(this.c(S,M.object),this.a.delete(S))});return M.counter++,{object:z,dispose:ee}}}e.$Yc=v;class D{constructor(S){this.a=S}async acquire(S,...B){const M=this.a.acquire(S,...B);try{return{object:await M.object,dispose:()=>M.dispose()}}catch(z){throw M.dispose(),z}}}e.$Zc=D;class W{constructor(S){this.object=S}dispose(){}}e.$1c=W;function q(b){const S=new t;try{b(S)}finally{S.dispose()}}e.$2c=q;class c{constructor(){this.a=new Map,this.b=!1,m(this)}dispose(){p(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{r(this.a.values())}finally{this.a.clear()}}has(S){return this.a.has(S)}get size(){return this.a.size}get(S){return this.a.get(S)}set(S,B,M=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),M||this.a.get(S)?.dispose(),this.a.set(S,B)}deleteAndDispose(S){this.a.get(S)?.dispose(),this.a.delete(S)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=c}),define(le[45],he([0,1,25]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=void 0;const L=new y.$Dc(1e4);function k(u){return h(u,"NFC",L)}e.$Gl=k;const A=new y.$Dc(1e4);function I(u){return h(u,"NFD",A)}e.$Hl=I;const E=/[^\u0000-\u0080]/;function h(u,P,m){if(!u)return u;const p=m.get(u);if(p)return p;let s;return E.test(u)?s=u.normalize(P):s=u,m.set(u,s),s}e.$Il=function(){const u=/[\u0300-\u036f]/g;return function(P){return I(P).replace(u,"")}}()}),function(){function oe(k){const A=[];typeof k=="number"&&A.push("code/timeOrigin",k);function I(h){A.push(h,Date.now())}function E(){const h=[];for(let u=0;u<A.length;u+=2)h.push({name:A[u],startTime:A[u+1]});return h}return{mark:I,getMarks:E}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const I of performance.getEntriesByType("mark"))A.push({name:I.name,startTime:Math.round(k+I.startTime)});return A}};if(typeof process=="object"){const k=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function y(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return y(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=y(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=y(L))}(),define(le[46],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0;const y=globalThis.performance&&typeof globalThis.performance.now=="function";class L{static create(A){return new L(A)}constructor(A){this.c=y&&A===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Rd=L}),define(le[4],he([0,1,6,29,2,44,46]),function(oe,e,y,L,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.Event=void 0;const E=!1,h=!1;var u;(function(q){q.None=()=>k.$Tc.None;function c(N){if(h){const{onDidAddListener:G}=N,Q=$.create();let ie=0;N.onDidAddListener=()=>{++ie===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Q.print()),G?.()}}}function b(N,G){return fe(N,()=>{},0,void 0,!0,void 0,G)}q.defer=b;function S(N){return(G,Q=null,ie)=>{let ue=!1,$e;return $e=N(we=>{if(!ue)return $e?$e.dispose():ue=!0,G.call(Q,we)},null,ie),ue&&$e.dispose(),$e}}q.once=S;function B(N,G,Q){return se((ie,ue=null,$e)=>N(we=>ie.call(ue,G(we)),null,$e),Q)}q.map=B;function M(N,G,Q){return se((ie,ue=null,$e)=>N(we=>{G(we),ie.call(ue,we)},null,$e),Q)}q.forEach=M;function z(N,G,Q){return se((ie,ue=null,$e)=>N(we=>G(we)&&ie.call(ue,we),null,$e),Q)}q.filter=z;function ee(N){return N}q.signal=ee;function ne(...N){return(G,Q=null,ie)=>{const ue=(0,k.$Qc)(...N.map($e=>$e(we=>G.call(Q,we))));return ce(ue,ie)}}q.any=ne;function Y(N,G,Q,ie){let ue=Q;return B(N,$e=>(ue=G(ue,$e),ue),ie)}q.reduce=Y;function se(N,G){let Q;const ie={onWillAddFirstListener(){Q=N(ue.fire,ue)},onDidRemoveLastListener(){Q?.dispose()}};G||c(ie);const ue=new d(ie);return G?.add(ue),ue.event}function ce(N,G){return G instanceof Array?G.push(N):G&&G.add(N),N}function fe(N,G,Q=100,ie=!1,ue=!1,$e,we){let ve,pe,Me,Ie=0,Oe;const je={leakWarningThreshold:$e,onWillAddFirstListener(){ve=N(Te=>{Ie++,pe=G(pe,Te),ie&&!Me&&(ke.fire(pe),pe=void 0),Oe=()=>{const ze=pe;pe=void 0,Me=void 0,(!ie||Ie>1)&&ke.fire(ze),Ie=0},typeof Q=="number"?(clearTimeout(Me),Me=setTimeout(Oe,Q)):Me===void 0&&(Me=0,queueMicrotask(Oe))})},onWillRemoveListener(){ue&&Ie>0&&Oe?.()},onDidRemoveLastListener(){Oe=void 0,ve.dispose()}};we||c(je);const ke=new d(je);return we?.add(ke),ke.event}q.debounce=fe;function X(N,G=0,Q){return q.debounce(N,(ie,ue)=>ie?(ie.push(ue),ie):[ue],G,void 0,!0,void 0,Q)}q.accumulate=X;function V(N,G=(ie,ue)=>ie===ue,Q){let ie=!0,ue;return z(N,$e=>{const we=ie||!G($e,ue);return ie=!1,ue=$e,we},Q)}q.latch=V;function K(N,G,Q){return[q.filter(N,G,Q),q.filter(N,ie=>!G(ie),Q)]}q.split=K;function te(N,G=!1,Q=[],ie){let ue=Q.slice(),$e=N(pe=>{ue?ue.push(pe):ve.fire(pe)});ie&&ie.add($e);const we=()=>{ue?.forEach(pe=>ve.fire(pe)),ue=null},ve=new d({onWillAddFirstListener(){$e||($e=N(pe=>ve.fire(pe)),ie&&ie.add($e))},onDidAddFirstListener(){ue&&(G?setTimeout(we):we())},onDidRemoveLastListener(){$e&&$e.dispose(),$e=null}});return ie&&ie.add(ve),ve.event}q.buffer=te;function H(N,G){return(ie,ue,$e)=>{const we=G(new ge);return N(function(ve){const pe=we.evaluate(ve);pe!==x&&ie.call(ue,pe)},void 0,$e)}}q.chain=H;const x=Symbol("HaltChainable");class ge{constructor(){this.f=[]}map(G){return this.f.push(G),this}forEach(G){return this.f.push(Q=>(G(Q),Q)),this}filter(G){return this.f.push(Q=>G(Q)?Q:x),this}reduce(G,Q){let ie=Q;return this.f.push(ue=>(ie=G(ie,ue),ie)),this}latch(G=(Q,ie)=>Q===ie){let Q=!0,ie;return this.f.push(ue=>{const $e=Q||!G(ue,ie);return Q=!1,ie=ue,$e?ue:x}),this}evaluate(G){for(const Q of this.f)if(G=Q(G),G===x)break;return G}}function _(N,G,Q=ie=>ie){const ie=(...ve)=>we.fire(Q(...ve)),ue=()=>N.on(G,ie),$e=()=>N.removeListener(G,ie),we=new d({onWillAddFirstListener:ue,onDidRemoveLastListener:$e});return we.event}q.fromNodeEventEmitter=_;function f(N,G,Q=ie=>ie){const ie=(...ve)=>we.fire(Q(...ve)),ue=()=>N.addEventListener(G,ie),$e=()=>N.removeEventListener(G,ie),we=new d({onWillAddFirstListener:ue,onDidRemoveLastListener:$e});return we.event}q.fromDOMEventEmitter=f;function U(N){return new Promise(G=>S(N)(G))}q.toPromise=U;function re(N){const G=new d;return N.then(Q=>{G.fire(Q)},()=>{G.fire(void 0)}).finally(()=>{G.dispose()}),G.event}q.fromPromise=re;function F(N,G,Q){return G(Q),N(ie=>G(ie))}q.runAndSubscribe=F;class J{constructor(G,Q){this._observable=G,this.f=0,this.g=!1;const ie={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};Q||c(ie),this.emitter=new d(ie),Q&&Q.add(this.emitter)}beginUpdate(G){this.f++}handlePossibleChange(G){}handleChange(G,Q){this.g=!0}endUpdate(G){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function R(N,G){return new J(N,G).emitter.event}q.fromObservable=R;function O(N){return(G,Q,ie)=>{let ue=0,$e=!1;const we={beginUpdate(){ue++},endUpdate(){ue--,ue===0&&(N.reportChanges(),$e&&($e=!1,G.call(Q)))},handlePossibleChange(){},handleChange(){$e=!0}};N.addObserver(we),N.reportChanges();const ve={dispose(){N.removeObserver(we)}};return ie instanceof k.$Sc?ie.add(ve):Array.isArray(ie)&&ie.push(ve),ve}}q.fromObservableLight=O})(u||(e.Event=u={}));class P{static{this.all=new Set}static{this.f=0}constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${P.f++}`,P.all.add(this)}start(c){this.g=new I.$Rd,this.listenerCount=c}stop(){if(this.g){const c=this.g.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this.g=void 0}}}e.$Td=P;let m=-1;function p(q){const c=m;return m=q,{dispose(){m=c}}}e.$Ud=p;class s{constructor(c,b=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=b,this.g=0}dispose(){this.f?.clear()}check(c,b){const S=this.threshold;if(S<=0||b<S)return;this.f||(this.f=new Map);const B=this.f.get(c.value)||0;if(this.f.set(c.value,B+1),this.g-=1,this.g<=0){this.g=S*.5;let M,z=0;for(const[ee,ne]of this.f)(!M||z<ne)&&(M=ee,z=ne);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${z}):`),console.warn(M)}return()=>{const M=this.f.get(c.value)||0;this.f.set(c.value,M-1)}}}class ${static create(){return new $(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let l=0;class a{constructor(c){this.value=c,this.id=l++}}const r=2,o=(q,c)=>{if(q instanceof a)c(q);else for(let b=0;b<q.length;b++){const S=q[b];S&&c(S)}};class d{constructor(c){this.w=0,this.f=c,this.g=m>0||this.f?.leakWarningThreshold?new s(this.f?.leakWarningThreshold??m):void 0,this.j=this.f?._profName?new P(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(E){const c=this.t;queueMicrotask(()=>{o(c,b=>b.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(c,b,S)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),k.$Tc.None;if(this.m)return k.$Tc.None;b&&(c=c.bind(b));const B=new a(c);let M,z;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(B.stack=$.create(),M=this.g.check(B.stack,this.w+1)),E&&(B.stack=z??$.create()),this.t?this.t instanceof a?(this.u??=new t,this.t=[this.t,B]):this.t.push(B):(this.f?.onWillAddFirstListener?.(this),this.t=B,this.f?.onDidAddFirstListener?.(this)),this.w++;const ee=(0,k.$Rc)(()=>{M?.(),this.x(B)});return S instanceof k.$Sc?S.add(ee):Array.isArray(S)&&S.push(ee),ee},this.q}x(c){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const b=this.t,S=b.indexOf(c);if(S===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,b[S]=void 0;const B=this.u.current===this;if(this.w*r<=b.length){let M=0;for(let z=0;z<b.length;z++)b[z]?b[M++]=b[z]:B&&(this.u.end--,M<this.u.i&&this.u.i--);b.length=M}}y(c,b){if(!c)return;const S=this.f?.onListenerError||y.$1;if(!S){c.value(b);return}try{c.value(b)}catch(B){S(B)}}z(c){const b=c.current.t;for(;c.i<c.end;)this.y(b[c.i++],c.value);c.reset()}fire(c){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof a)this.y(this.t,c);else{const b=this.u;b.enqueue(this,c,this.t.length),this.z(b)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Vd=d;const n=()=>new t;e.$Wd=n;class t{constructor(){this.i=-1,this.end=0}enqueue(c,b,S){this.i=0,this.end=S,this.current=c,this.value=b}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class i extends d{async fireAsync(c,b,S){if(this.t)for(this.h||(this.h=new A.$4c),o(this.t,B=>this.h.push([B.value,c]));this.h.size>0&&!b.isCancellationRequested;){const[B,M]=this.h.shift(),z=[],ee={...M,token:b,waitUntil:ne=>{if(Object.isFrozen(z))throw new Error("waitUntil can NOT be called asynchronous");S&&(ne=S(ne,B)),z.push(ne)}};try{B(ee)}catch(ne){(0,y.$1)(ne);continue}Object.freeze(z),await Promise.allSettled(z).then(ne=>{for(const Y of ne)Y.status==="rejected"&&(0,y.$1)(Y.reason)})}}}e.$Xd=i;class w extends d{get isPaused(){return this.h!==0}constructor(c){super(c),this.h=0,this.s=new A.$4c,this.A=c?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const c=Array.from(this.s);this.s.clear(),super.fire(this.A(c))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(c){this.w&&(this.h!==0?this.s.push(c):super.fire(c))}}e.$Yd=w;class j extends w{constructor(c){super(c),this.k=c.delay??100}fire(c){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(c)}}e.$Zd=j;class g extends d{constructor(c){super(c),this.h=[],this.k=c?.merge}fire(c){this.hasListeners()&&(this.h.push(c),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(b=>super.fire(b)),this.h=[]}))}}e.$1d=g;class C{constructor(){this.g=!1,this.h=[],this.f=new d({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(c){const b={event:c,listener:null};this.h.push(b),this.g&&this.m(b);const S=()=>{this.g&&this.o(b);const B=this.h.indexOf(b);this.h.splice(B,1)};return(0,k.$Rc)((0,L.$db)(S))}j(){this.g=!0,this.h.forEach(c=>this.m(c))}k(){this.g=!1,this.h.forEach(c=>this.o(c))}m(c){c.listener=c.event(b=>this.f.fire(b))}o(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.f.dispose()}}e.$2d=C;class v{constructor(c,b,S,B){this.f=new k.$Sc;const M=this.f.add(new C),z=this.f.add(new k.$3c);function ee(ne){z.set(ne,M.add(B(ne)))}for(const ne of c)ee(ne);this.f.add(b(ne=>{ee(ne)})),this.f.add(S(ne=>{z.deleteAndDispose(ne)})),this.event=M.event}dispose(){this.f.dispose()}}e.$3d=v;class D{constructor(){this.f=[]}wrapEvent(c){return(b,S,B)=>c(M=>{const z=this.f[this.f.length-1];z?z.push(()=>b.call(S,M)):b.call(S,M)},void 0,B)}bufferEvents(c){const b=[];this.f.push(b);const S=c();return this.f.pop(),b.forEach(B=>B()),S}}e.$4d=D;class W{constructor(){this.f=!1,this.g=u.None,this.h=k.$Tc.None,this.j=new d({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(c){this.g=c,this.f&&(this.h.dispose(),this.h=c(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$5d=W}),define(le[17],he([0,1,4]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.CancellationToken=void 0;const L=Object.freeze(function(E,h){const u=setTimeout(E.bind(h),0);return{dispose(){clearTimeout(u)}}});var k;(function(E){function h(u){return u===E.None||u===E.Cancelled||u instanceof A?!0:!u||typeof u!="object"?!1:typeof u.isCancellationRequested=="boolean"&&typeof u.onCancellationRequested=="function"}E.isCancellationToken=h,E.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),E.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(k||(e.CancellationToken=k={}));class A{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new y.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class I{constructor(h){this.f=void 0,this.g=void 0,this.g=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new A),this.f}cancel(){this.f?this.f instanceof A&&this.f.cancel():this.f=k.Cancelled}dispose(h=!1){h&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof A&&this.f.dispose():this.f=k.None}}e.$6d=I}),define(le[47],he([0,1,17]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=void 0;class L{constructor(E){this.b=E,this.a=null}get(){if(this.a)return this.a;const E=new y.$6d,h=this.b(E.token);return this.a={promise:h,dispose:()=>{this.a=null,E.cancel(),E.dispose()}},this.a}}e.$Ee=L;class k{constructor(E){this.c=E,this.a=void 0,this.b=void 0}get(E){const h=JSON.stringify(E);return this.b!==h&&(this.b=h,this.a=this.c(E)),this.a}}e.$Fe=k;class A{get cachedValues(){return this.a}constructor(E){this.b=E,this.a=new Map}get(E){if(this.a.has(E))return this.a.get(E);const h=this.b(E);return this.a.set(E,h),h}}e.$Ge=A}),define(le[48],he([0,1,6,2]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function k(n){const t=n;return t?typeof t.read=="function":!1}e.$7d=k;function A(n){const t=n;return t?[t.on,t.pause,t.resume,t.destroy].every(i=>typeof i=="function"):!1}e.$8d=A;function I(n){const t=n;return t?A(t.stream)&&Array.isArray(t.buffer)&&typeof t.ended=="boolean":!1}e.$9d=I;function E(n,t){return new h(n,t)}e.$0d=E;class h{constructor(t,i){this.e=t,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(t){if(!this.a.destroyed){if(this.a.flowing)this.g(t);else if(this.b.data.push(t),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(t){this.a.destroyed||(this.a.flowing?this.h(t):this.b.error.push(t))}end(t){this.a.destroyed||(typeof t<"u"&&this.write(t),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(t){this.c.data.slice(0).forEach(i=>i(t))}h(t){this.c.error.length===0?(0,y.$1)(t):this.c.error.slice(0).forEach(i=>i(t))}i(){this.c.end.slice(0).forEach(t=>t())}on(t,i){if(!this.a.destroyed)switch(t){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(t,i){if(this.a.destroyed)return;let w;switch(t){case"data":w=this.c.data;break;case"end":w=this.c.end;break;case"error":w=this.c.error;break}if(w){const j=w.indexOf(i);j>=0&&w.splice(j,1)}}j(){if(this.b.data.length>0){const t=this.e(this.b.data);this.g(t),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(w=>w())}}k(){if(this.c.error.length>0){for(const t of this.b.error)this.h(t);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function u(n,t){const i=[];let w;for(;(w=n.read())!==null;)i.push(w);return t(i)}e.$$d=u;function P(n,t,i){const w=[];let j;for(;(j=n.read())!==null&&w.length<i;)w.push(j);return j===null&&w.length>0?t(w):{read:()=>{if(w.length>0)return w.shift();if(typeof j<"u"){const g=j;return j=void 0,g}return n.read()}}}e.$_d=P;function m(n,t){return new Promise((i,w)=>{const j=[];p(n,{onData:g=>{t&&j.push(g)},onError:g=>{t?w(g):i(void 0)},onEnd:()=>{i(t?t(j):void 0)}})})}e.$ae=m;function p(n,t,i){n.on("error",w=>{i?.isCancellationRequested||t.onError(w)}),n.on("end",()=>{i?.isCancellationRequested||t.onEnd()}),n.on("data",w=>{i?.isCancellationRequested||t.onData(w)})}e.$be=p;function s(n,t){return new Promise((i,w)=>{const j=new L.$Sc,g=[],C=W=>{if(g.push(W),g.length>t)return j.dispose(),n.pause(),i({stream:n,buffer:g,ended:!1})},v=W=>(j.dispose(),w(W)),D=()=>(j.dispose(),i({stream:n,buffer:g,ended:!0}));j.add((0,L.$Rc)(()=>n.removeListener("error",v))),n.on("error",v),j.add((0,L.$Rc)(()=>n.removeListener("end",D))),n.on("end",D),j.add((0,L.$Rc)(()=>n.removeListener("data",C))),n.on("data",C)})}e.$ce=s;function $(n,t){const i=E(t);return i.end(n),i}e.$de=$;function l(){const n=E(()=>{throw new Error("not supported")});return n.end(),n}e.$ee=l;function a(n){let t=!1;return{read:()=>t?null:(t=!0,n)}}e.$fe=a;function r(n,t,i){const w=E(i);return p(n,{onData:j=>w.write(t.data(j)),onError:j=>w.error(t.error?t.error(j):j),onEnd:()=>w.end()}),w}e.$ge=r;function o(n,t,i){let w=!1;return{read:()=>{const j=t.read();return w?j:(w=!0,j!==null?i([n,j]):n)}}}e.$he=o;function d(n,t,i){let w=!1;const j=E(i);return p(t,{onData:g=>w?j.write(g):(w=!0,j.write(i([n,g]))),onError:g=>j.error(g),onEnd:()=>{w||(w=!0,j.write(n)),j.end()}}),j}e.$ie=d}),define(le[18],he([0,1,22,48]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const k=typeof Buffer<"u",A=new y.$V(()=>new Uint8Array(256));let I,E;class h{static alloc(b){return k?new h(Buffer.allocUnsafe(b)):new h(new Uint8Array(b))}static wrap(b){return k&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new h(b)}static fromString(b,S){return!(S?.dontUseNodeBuffer||!1)&&k?new h(Buffer.from(b)):(I||(I=new TextEncoder),new h(I.encode(b)))}static fromByteArray(b){const S=h.alloc(b.length);for(let B=0,M=b.length;B<M;B++)S.buffer[B]=b[B];return S}static concat(b,S){if(typeof S>"u"){S=0;for(let z=0,ee=b.length;z<ee;z++)S+=b[z].byteLength}const B=h.alloc(S);let M=0;for(let z=0,ee=b.length;z<ee;z++){const ne=b[z];B.set(ne,M),M+=ne.byteLength}return B}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=h.alloc(this.byteLength);return b.set(this),b}toString(){return k?this.buffer.toString():(E||(E=new TextDecoder),E.decode(this.buffer))}slice(b,S){return new h(this.buffer.subarray(b,S))}set(b,S){if(b instanceof h)this.buffer.set(b.buffer,S);else if(b instanceof Uint8Array)this.buffer.set(b,S);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),S);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),S);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return p(this.buffer,b)}writeUInt32BE(b,S){s(this.buffer,b,S)}readUInt32LE(b){return $(this.buffer,b)}writeUInt32LE(b,S){l(this.buffer,b,S)}readUInt8(b){return a(this.buffer,b)}writeUInt8(b,S){r(this.buffer,b,S)}indexOf(b,S=0){return u(this.buffer,b instanceof h?b.buffer:b,S)}}e.$je=h;function u(c,b,S=0){const B=b.byteLength,M=c.byteLength;if(B===0)return 0;if(B===1)return c.indexOf(b[0]);if(B>M-S)return-1;const z=A.value;z.fill(b.length);for(let se=0;se<b.length;se++)z[b[se]]=b.length-se-1;let ee=S+b.length-1,ne=ee,Y=-1;for(;ee<M;)if(c[ee]===b[ne]){if(ne===0){Y=ee;break}ee--,ne--}else ee+=Math.max(b.length-ne,z[c[ee]]),ne=b.length-1;return Y}e.$ke=u;function P(c,b){return c[b+0]<<0>>>0|c[b+1]<<8>>>0}e.$le=P;function m(c,b,S){c[S+0]=b&255,b=b>>>8,c[S+1]=b&255}e.$me=m;function p(c,b){return c[b]*2**24+c[b+1]*2**16+c[b+2]*2**8+c[b+3]}e.$ne=p;function s(c,b,S){c[S+3]=b,b=b>>>8,c[S+2]=b,b=b>>>8,c[S+1]=b,b=b>>>8,c[S]=b}e.$oe=s;function $(c,b){return c[b+0]<<0>>>0|c[b+1]<<8>>>0|c[b+2]<<16>>>0|c[b+3]<<24>>>0}e.$pe=$;function l(c,b,S){c[S+0]=b&255,b=b>>>8,c[S+1]=b&255,b=b>>>8,c[S+2]=b&255,b=b>>>8,c[S+3]=b&255}e.$qe=l;function a(c,b){return c[b]}e.$re=a;function r(c,b,S){c[S]=b}e.$se=r;function o(c){return L.$$d(c,b=>h.concat(b))}e.$te=o;function d(c){return L.$fe(c)}e.$ue=d;function n(c){return L.$ae(c,b=>h.concat(b))}e.$ve=n;async function t(c){return c.ended?h.concat(c.buffer):h.concat([...c.buffer,await n(c.stream)])}e.$we=t;function i(c){return L.$de(c,b=>h.concat(b))}e.$xe=i;function w(c){return L.$ge(c,{data:b=>typeof b=="string"?h.fromString(b):h.wrap(b)},b=>h.concat(b))}e.$ye=w;function j(c){return L.$0d(b=>h.concat(b),c)}e.$ze=j;function g(c,b){return L.$he(c,b,S=>h.concat(S))}e.$Ae=g;function C(c,b){return L.$ie(c,b,S=>h.concat(S))}e.$Be=C;function v(c){let b=0,S=0,B=0;const M=new Uint8Array(Math.floor(c.length/4*3)),z=ne=>{switch(S){case 3:M[B++]=b|ne,S=0;break;case 2:M[B++]=b|ne>>>2,b=ne<<6,S=3;break;case 1:M[B++]=b|ne>>>4,b=ne<<4,S=2;break;default:b=ne<<2,S=1}};for(let ne=0;ne<c.length;ne++){const Y=c.charCodeAt(ne);if(Y>=65&&Y<=90)z(Y-65);else if(Y>=97&&Y<=122)z(Y-97+26);else if(Y>=48&&Y<=57)z(Y-48+52);else if(Y===43||Y===45)z(62);else if(Y===47||Y===95)z(63);else{if(Y===61)break;throw new SyntaxError(`Unexpected base64 character ${c[ne]}`)}}const ee=B;for(;S>0;)z(0);return h.wrap(M).slice(0,ee)}e.$Ce=v;const D="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",W="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function q({buffer:c},b=!0,S=!1){const B=S?W:D;let M="";const z=c.byteLength%3;let ee=0;for(;ee<c.byteLength-z;ee+=3){const ne=c[ee+0],Y=c[ee+1],se=c[ee+2];M+=B[ne>>>2],M+=B[(ne<<4|Y>>>4)&63],M+=B[(Y<<2|se>>>6)&63],M+=B[se&63]}if(z===1){const ne=c[ee+0];M+=B[ne>>>2],M+=B[ne<<4&63],b&&(M+="==")}else if(z===2){const ne=c[ee+0],Y=c[ee+1];M+=B[ne>>>2],M+=B[(ne<<4|Y>>>4)&63],M+=B[Y<<2&63],b&&(M+="=")}return M}e.$De=q}),define(le[11],he([0,1,47,22]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.GraphemeBreakType=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=void 0;function k(T){return!T||typeof T!="string"?!0:T.trim().length===0}e.$Je=k;const A=/{(\d+)}/g;function I(T,...Z){return Z.length===0?T:T.replace(A,function(ae,de){const be=parseInt(de,10);return isNaN(be)||be<0||be>=Z.length?ae:Z[be]})}e.$Ke=I;const E=/{([^}]+)}/g;function h(T,Z){return Object.keys(Z).length===0?T:T.replace(E,(ae,de)=>Z[de]??ae)}e.$Le=h;function u(T){return T.replace(/[<>"'&]/g,Z=>{switch(Z){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return Z})}e.$Me=u;function P(T){return T.replace(/[<>&]/g,function(Z){switch(Z){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return Z}})}e.$Ne=P;function m(T){return T.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Oe=m;function p(T,Z){let ae=0;const de=Z.charCodeAt(0);for(let be=T.length-1;be>=0;be--)T.charCodeAt(be)===de&&ae++;return ae}e.$Pe=p;function s(T,Z,ae="\u2026"){return T.length<=Z?T:`${T.substr(0,Z)}${ae}`}e.$Qe=s;function $(T,Z,ae="\u2026"){if(T.length<=Z)return T;const de=Math.ceil(Z/2)-ae.length/2,be=Math.floor(Z/2)-ae.length/2;return`${T.substr(0,de)}${ae}${T.substr(T.length-be)}`}e.$Re=$;function l(T,Z=" "){const ae=a(T,Z);return r(ae,Z)}e.$Se=l;function a(T,Z){if(!T||!Z)return T;const ae=Z.length;if(ae===0||T.length===0)return T;let de=0;for(;T.indexOf(Z,de)===de;)de=de+ae;return T.substring(de)}e.$Te=a;function r(T,Z){if(!T||!Z)return T;const ae=Z.length,de=T.length;if(ae===0||de===0)return T;let be=de,ye=-1;for(;ye=T.lastIndexOf(Z,be-1),!(ye===-1||ye+ae!==be);){if(ye===0)return"";be=ye}return T.substring(0,be)}e.$Ue=r;function o(T){return T.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ve=o;function d(T){return T.replace(/\*/g,"")}e.$We=d;function n(T,Z,ae={}){if(!T)throw new Error("Cannot create regex from empty string");Z||(T=m(T)),ae.wholeWord&&(/\B/.test(T.charAt(0))||(T="\\b"+T),/\B/.test(T.charAt(T.length-1))||(T=T+"\\b"));let de="";return ae.global&&(de+="g"),ae.matchCase||(de+="i"),ae.multiline&&(de+="m"),ae.unicode&&(de+="u"),new RegExp(T,de)}e.$Xe=n;function t(T){return T.source==="^"||T.source==="^$"||T.source==="$"||T.source==="^\\s*$"?!1:!!(T.exec("")&&T.lastIndex===0)}e.$Ye=t;function i(T){return T.split(/\r\n|\r|\n/)}e.$Ze=i;function w(T){for(let Z=0,ae=T.length;Z<ae;Z++){const de=T.charCodeAt(Z);if(de!==32&&de!==9)return Z}return-1}e.$1e=w;function j(T,Z=0,ae=T.length){for(let de=Z;de<ae;de++){const be=T.charCodeAt(de);if(be!==32&&be!==9)return T.substring(Z,de)}return T.substring(Z,ae)}e.$2e=j;function g(T,Z=T.length-1){for(let ae=Z;ae>=0;ae--){const de=T.charCodeAt(ae);if(de!==32&&de!==9)return ae}return-1}e.$3e=g;function C(T,Z,ae){const de=[];let be=0;for(const ye of T.matchAll(Z)){if(de.push(T.slice(be,ye.index)),ye.index===void 0)throw new Error("match.index should be defined");be=ye.index+ye[0].length,de.push(ae(ye[0],...ye.slice(1),ye.index,T,ye.groups))}return de.push(T.slice(be)),Promise.all(de).then(ye=>ye.join(""))}e.$4e=C;function v(T,Z){return T<Z?-1:T>Z?1:0}e.$5e=v;function D(T,Z,ae=0,de=T.length,be=0,ye=Z.length){for(;ae<de&&be<ye;ae++,be++){const Pe=T.charCodeAt(ae),Se=Z.charCodeAt(be);if(Pe<Se)return-1;if(Pe>Se)return 1}const Ce=de-ae,De=ye-be;return Ce<De?-1:Ce>De?1:0}e.$6e=D;function W(T,Z){return q(T,Z,0,T.length,0,Z.length)}e.$7e=W;function q(T,Z,ae=0,de=T.length,be=0,ye=Z.length){for(;ae<de&&be<ye;ae++,be++){let Pe=T.charCodeAt(ae),Se=Z.charCodeAt(be);if(Pe===Se)continue;if(Pe>=128||Se>=128)return D(T.toLowerCase(),Z.toLowerCase(),ae,de,be,ye);b(Pe)&&(Pe-=32),b(Se)&&(Se-=32);const Ee=Pe-Se;if(Ee!==0)return Ee}const Ce=de-ae,De=ye-be;return Ce<De?-1:Ce>De?1:0}e.$8e=q;function c(T){return T>=48&&T<=57}e.$9e=c;function b(T){return T>=97&&T<=122}e.$0e=b;function S(T){return T>=65&&T<=90}e.$$e=S;function B(T,Z){return T.length===Z.length&&q(T,Z)===0}e.$_e=B;function M(T,Z){const ae=Z.length;return Z.length>T.length?!1:q(T,Z,0,ae)===0}e.$af=M;function z(T,Z){const ae=Math.min(T.length,Z.length);let de;for(de=0;de<ae;de++)if(T.charCodeAt(de)!==Z.charCodeAt(de))return de;return ae}e.$bf=z;function ee(T,Z){const ae=Math.min(T.length,Z.length);let de;const be=T.length-1,ye=Z.length-1;for(de=0;de<ae;de++)if(T.charCodeAt(be-de)!==Z.charCodeAt(ye-de))return de;return ae}e.$cf=ee;function ne(T){return 55296<=T&&T<=56319}e.$df=ne;function Y(T){return 56320<=T&&T<=57343}e.$ef=Y;function se(T,Z){return(T-55296<<10)+(Z-56320)+65536}e.$ff=se;function ce(T,Z,ae){const de=T.charCodeAt(ae);if(ne(de)&&ae+1<Z){const be=T.charCodeAt(ae+1);if(Y(be))return se(de,be)}return de}e.$gf=ce;function fe(T,Z){const ae=T.charCodeAt(Z-1);if(Y(ae)&&Z>1){const de=T.charCodeAt(Z-2);if(ne(de))return se(de,ae)}return ae}class X{get offset(){return this.e}constructor(Z,ae=0){this.c=Z,this.d=Z.length,this.e=ae}setOffset(Z){this.e=Z}prevCodePoint(){const Z=fe(this.c,this.e);return this.e-=Z>=65536?2:1,Z}nextCodePoint(){const Z=ce(this.c,this.d,this.e);return this.e+=Z>=65536?2:1,Z}eol(){return this.e>=this.d}}e.$hf=X;class V{get offset(){return this.c.offset}constructor(Z,ae=0){this.c=new X(Z,ae)}nextGraphemeLength(){const Z=ke.getInstance(),ae=this.c,de=ae.offset;let be=Z.getGraphemeBreakType(ae.nextCodePoint());for(;!ae.eol();){const ye=ae.offset,Ce=Z.getGraphemeBreakType(ae.nextCodePoint());if(Oe(be,Ce)){ae.setOffset(ye);break}be=Ce}return ae.offset-de}prevGraphemeLength(){const Z=ke.getInstance(),ae=this.c,de=ae.offset;let be=Z.getGraphemeBreakType(ae.prevCodePoint());for(;ae.offset>0;){const ye=ae.offset,Ce=Z.getGraphemeBreakType(ae.prevCodePoint());if(Oe(Ce,be)){ae.setOffset(ye);break}be=Ce}return de-ae.offset}eol(){return this.c.eol()}}e.$if=V;function K(T,Z){return new V(T,Z).nextGraphemeLength()}e.$jf=K;function te(T,Z){return new V(T,Z).prevGraphemeLength()}e.$kf=te;function H(T,Z){Z>0&&Y(T.charCodeAt(Z))&&Z--;const ae=Z+K(T,Z);return[ae-te(T,ae),ae]}e.$lf=H;function x(T){const Z=new V(T);let ae=0;for(;!Z.eol();)ae++,Z.nextGraphemeLength();return ae}e.$mf=x;let ge;function _(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function f(T){return ge||(ge=_()),ge.test(T)}e.$nf=f;const U=/^[\t\n\r\x20-\x7E]*$/;function re(T){return U.test(T)}e.$of=re,e.$pf=/[\u2028\u2029]/;function F(T){return e.$pf.test(T)}e.$qf=F;function J(T){return T>=11904&&T<=55215||T>=63744&&T<=64255||T>=65281&&T<=65374}e.$rf=J;function R(T){return T>=127462&&T<=127487||T===8986||T===8987||T===9200||T===9203||T>=9728&&T<=10175||T===11088||T===11093||T>=127744&&T<=128591||T>=128640&&T<=128764||T>=128992&&T<=129008||T>=129280&&T<=129535||T>=129648&&T<=129782}e.$sf=R;function O(T,Z,ae=""){const de=T.trimStart();if(de.length<Z)return de;const be=/\b/g;let ye=0;for(;be.test(de)&&!(de.length-be.lastIndex<Z);)ye=be.lastIndex,be.lastIndex+=1;return ye===0?de:ae+de.substring(ye).trimStart()}e.$tf=O;const N=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,G=/\x1b\].*?\x07/g;function Q(T){return T&&(T=T.replace(N,"").replace(G,"")),T}e.$uf=Q,e.$vf=String.fromCharCode(65279);function ie(T){return!!(T&&T.length>0&&T.charCodeAt(0)===65279)}e.$wf=ie;function ue(T){return ie(T)?T.substr(1):T}e.$xf=ue;function $e(T,Z){if(!T||!Z||T.length<Z.length)return!1;const ae=Z.length,de=T.toLowerCase();let be=0,ye=-1;for(;be<ae;){const Ce=de.indexOf(Z[be],ye+1);if(Ce<0)return!1;ye=Ce,be++}return!0}e.$yf=$e;function we(T,Z=!1){return T?(Z&&(T=T.replace(/\\./g,"")),T.toLowerCase()!==T):!1}e.$zf=we;function ve(T){return T.charAt(0).toUpperCase()+T.slice(1)}e.$Af=ve;function pe(T,Z=1){if(Z===0)return"";let ae=-1;do ae=T.indexOf(`
`,ae+1),Z--;while(Z>0&&ae>=0);return ae===-1?T:(T[ae-1]==="\r"&&ae--,T.substr(0,ae))}e.$Bf=pe;function Me(T){return T=T%(2*26),T<26?String.fromCharCode(97+T):String.fromCharCode(65+T-26)}e.$Cf=Me;function Ie(T){return ke.getInstance().getGraphemeBreakType(T)}e.$Df=Ie;function Oe(T,Z){return T===0?Z!==5&&Z!==7:T===2&&Z===3?!1:T===4||T===2||T===3||Z===4||Z===2||Z===3?!0:!(T===8&&(Z===8||Z===9||Z===11||Z===12)||(T===11||T===9)&&(Z===9||Z===10)||(T===12||T===10)&&Z===10||Z===5||Z===13||Z===7||T===1||T===13&&Z===14||T===6&&Z===6)}var je;(function(T){T[T.Other=0]="Other",T[T.Prepend=1]="Prepend",T[T.CR=2]="CR",T[T.LF=3]="LF",T[T.Control=4]="Control",T[T.Extend=5]="Extend",T[T.Regional_Indicator=6]="Regional_Indicator",T[T.SpacingMark=7]="SpacingMark",T[T.L=8]="L",T[T.V=9]="V",T[T.T=10]="T",T[T.LV=11]="LV",T[T.LVT=12]="LVT",T[T.ZWJ=13]="ZWJ",T[T.Extended_Pictographic=14]="Extended_Pictographic"})(je||(e.GraphemeBreakType=je={}));class ke{static{this.c=null}static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=Te()}getGraphemeBreakType(Z){if(Z<32)return Z===10?3:Z===13?2:4;if(Z<127)return 0;const ae=this.d,de=ae.length/3;let be=1;for(;be<=de;)if(Z<ae[3*be])be=2*be;else if(Z>ae[3*be+1])be=2*be+1;else return ae[3*be+2];return 0}}function Te(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(T,Z){if(T===0)return 0;const ae=Ve(T,Z);if(ae!==void 0)return ae;const de=new X(Z,T);return de.prevCodePoint(),de.offset}e.$Ef=ze;function Ve(T,Z){const ae=new X(Z,T);let de=ae.prevCodePoint();for(;We(de)||de===65039||de===8419;){if(ae.offset===0)return;de=ae.prevCodePoint()}if(!R(de))return;let be=ae.offset;return be>0&&ae.prevCodePoint()===8205&&(be=ae.offset),be}function We(T){return 127995<=T&&T<=127999}var qe;(function(T){T[T.zwj=8205]="zwj",T[T.emojiVariantSelector=65039]="emojiVariantSelector",T[T.enclosingKeyCap=8419]="enclosingKeyCap"})(qe||(qe={})),e.$Ff="\xA0";class Re{static{this.c=new L.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new y.$Fe(Z=>{function ae(Ee){const Ae=new Map;for(let Le=0;Le<Ee.length;Le+=2)Ae.set(Ee[Le],Ee[Le+1]);return Ae}function de(Ee,Ae){const Le=new Map(Ee);for(const[Ue,Be]of Ae)Le.set(Ue,Be);return Le}function be(Ee,Ae){if(!Ee)return Ae;const Le=new Map;for(const[Ue,Be]of Ee)Ae.has(Ue)&&Le.set(Ue,Be);return Le}const ye=this.c.value;let Ce=Z.filter(Ee=>!Ee.startsWith("_")&&Ee in ye);Ce.length===0&&(Ce=["_default"]);let De;for(const Ee of Ce){const Ae=ae(ye[Ee]);De=be(De,Ae)}const Pe=ae(ye._common),Se=de(Pe,De);return new Re(Se)})}static getInstance(Z){return Re.d.get(Array.from(Z))}static{this.e=new L.$V(()=>Object.keys(Re.c.value).filter(Z=>!Z.startsWith("_")))}static getLocales(){return Re.e.value}constructor(Z){this.f=Z}isAmbiguous(Z){return this.f.has(Z)}getPrimaryConfusable(Z){return this.f.get(Z)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Gf=Re;class Fe{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(Fe.c())),this.d}static isInvisibleCharacter(Z){return Fe.e().has(Z)}static get codePoints(){return Fe.e()}}e.$Hf=Fe}),define(le[49],he([0,1,11]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function L(r){return k(r,0)}e.$Ti=L;function k(r,o){switch(typeof r){case"object":return r===null?A(349,o):Array.isArray(r)?h(r,o):u(r,o);case"string":return E(r,o);case"boolean":return I(r,o);case"number":return A(r,o);case"undefined":return A(937,o);default:return A(617,o)}}e.$Ui=k;function A(r,o){return(o<<5)-o+r|0}e.$Vi=A;function I(r,o){return A(r?433:863,o)}function E(r,o){o=A(149417,o);for(let d=0,n=r.length;d<n;d++)o=A(r.charCodeAt(d),o);return o}e.$Wi=E;function h(r,o){return o=A(104579,o),r.reduce((d,n)=>k(n,d),o)}function u(r,o){return o=A(181387,o),Object.keys(r).sort().reduce((d,n)=>(d=E(n,d),k(r[n],d)),o)}class P{constructor(){this.g=0}get value(){return this.g}hash(o){return this.g=k(o,this.g),this.g}}e.$Xi=P;var m;(function(r){r[r.BLOCK_SIZE=64]="BLOCK_SIZE",r[r.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function p(r,o,d=32){const n=d-o,t=~((1<<n)-1);return(r<<o|(t&r)>>>n)>>>0}function s(r,o=0,d=r.byteLength,n=0){for(let t=0;t<d;t++)r[o+t]=n}function $(r,o,d="0"){for(;r.length<o;)r=d+r;return r}function l(r,o=32){return r instanceof ArrayBuffer?Array.from(new Uint8Array(r)).map(d=>d.toString(16).padStart(2,"0")).join(""):$((r>>>0).toString(16),o/4)}e.$Yi=l;class a{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(o){const d=o.length;if(d===0)return;const n=this.p;let t=this.r,i=this.u,w,j;for(i!==0?(w=i,j=-1,i=0):(w=o.charCodeAt(0),j=0);;){let g=w;if(y.$df(w))if(j+1<d){const C=o.charCodeAt(j+1);y.$ef(C)?(j++,g=y.$ff(w,C)):g=65533}else{i=w;break}else y.$ef(w)&&(g=65533);if(t=this.w(n,t,g),j++,j<d)w=o.charCodeAt(j);else break}this.r=t,this.u=i}w(o,d,n){return n<128?o[d++]=n:n<2048?(o[d++]=192|(n&1984)>>>6,o[d++]=128|(n&63)>>>0):n<65536?(o[d++]=224|(n&61440)>>>12,o[d++]=128|(n&4032)>>>6,o[d++]=128|(n&63)>>>0):(o[d++]=240|(n&1835008)>>>18,o[d++]=128|(n&258048)>>>12,o[d++]=128|(n&4032)>>>6,o[d++]=128|(n&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,o[0]=o[64+0],o[1]=o[64+1],o[2]=o[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),l(this.h)+l(this.l)+l(this.m)+l(this.n)+l(this.o)}x(){this.p[this.r++]=128,s(this.p,this.r),this.r>56&&(this.y(),s(this.p));const o=8*this.t;this.q.setUint32(56,Math.floor(o/4294967296),!1),this.q.setUint32(60,o%4294967296,!1),this.y()}y(){const o=a.g,d=this.q;for(let D=0;D<64;D+=4)o.setUint32(D,d.getUint32(D,!1),!1);for(let D=64;D<320;D+=4)o.setUint32(D,p(o.getUint32(D-12,!1)^o.getUint32(D-32,!1)^o.getUint32(D-56,!1)^o.getUint32(D-64,!1),1),!1);let n=this.h,t=this.l,i=this.m,w=this.n,j=this.o,g,C,v;for(let D=0;D<80;D++)D<20?(g=t&i|~t&w,C=1518500249):D<40?(g=t^i^w,C=1859775393):D<60?(g=t&i|t&w|i&w,C=2400959708):(g=t^i^w,C=3395469782),v=p(n,5)+g+j+C+o.getUint32(D*4,!1)&4294967295,j=w,w=i,i=p(t,30),t=n,n=v;this.h=this.h+n&4294967295,this.l=this.l+t&4294967295,this.m=this.m+i&4294967295,this.n=this.n+w&4294967295,this.o=this.o+j&4294967295}}e.$Zi=a}),define(le[50],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(le[51],he([0,1,16,11]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class k{constructor(){this.b="",this.c=0}reset(s){return this.b=s,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(s){const $=s.charCodeAt(0),l=this.b.charCodeAt(this.c);return $-l}value(){return this.b[this.c]}}e.$8h=k;class A{constructor(s=!0){this.e=s}reset(s){return this.b=s,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let s=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(s)this.c++;else break;else s=!1;return this}cmp(s){return this.e?(0,L.$6e)(s,this.b,0,s.length,this.c,this.d):(0,L.$8e)(s,this.b,0,s.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=A;class I{constructor(s=!0,$=!0){this.f=s,this.g=$}reset(s){this.d=0,this.e=0,this.b=s,this.c=s.length;for(let $=s.length-1;$>=0;$--,this.c--){const l=this.b.charCodeAt($);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let s=!0;for(;this.e<this.c;this.e++){const $=this.b.charCodeAt(this.e);if($===47||this.f&&$===92)if(s)this.d++;else break;else s=!1}return this}cmp(s){return this.g?(0,L.$6e)(s,this.b,0,s.length,this.d,this.e):(0,L.$8e)(s,this.b,0,s.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=I;var E;(function(p){p[p.Scheme=1]="Scheme",p[p.Authority=2]="Authority",p[p.Path=3]="Path",p[p.Query=4]="Query",p[p.Fragment=5]="Fragment"})(E||(E={}));class h{constructor(s,$){this.f=s,this.g=$,this.d=[],this.e=0}reset(s){return this.c=s,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new I(!1,!this.f(s)),this.b.reset(s.path),this.b.value()&&this.d.push(3)),this.g(s)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(s){if(this.d[this.e]===1)return(0,L.$7e)(s,this.c.scheme);if(this.d[this.e]===2)return(0,L.$7e)(s,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(s);if(this.d[this.e]===4)return(0,L.$5e)(s,this.c.query);if(this.d[this.e]===5)return(0,L.$5e)(s,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=h;class u{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const s=this.right;return this.right=s.left,s.left=this,this.updateHeight(),s.updateHeight(),s}rotateRight(){const s=this.left;return this.left=s.right,s.right=this,this.updateHeight(),s.updateHeight(),s}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var P;(function(p){p[p.Left=-1]="Left",p[p.Mid=0]="Mid",p[p.Right=1]="Right"})(P||(P={}));class m{static forUris(s=()=>!1,$=()=>!1){return new m(new h(s,$))}static forPaths(s=!1){return new m(new I(void 0,!s))}static forStrings(){return new m(new k)}static forConfigKeys(){return new m(new A)}constructor(s){this.b=s}clear(){this.c=void 0}fill(s,$){if($){const l=$.slice(0);(0,y.$Xb)(l);for(const a of l)this.set(a,s)}else{const l=s.slice(0);(0,y.$Xb)(l);for(const a of l)this.set(a[0],a[1])}}set(s,$){const l=this.b.reset(s);let a;this.c||(this.c=new u,this.c.segment=l.value());const r=[];for(a=this.c;;){const d=l.cmp(a.segment);if(d>0)a.left||(a.left=new u,a.left.segment=l.value()),r.push([-1,a]),a=a.left;else if(d<0)a.right||(a.right=new u,a.right.segment=l.value()),r.push([1,a]),a=a.right;else if(l.hasNext())l.next(),a.mid||(a.mid=new u,a.mid.segment=l.value()),r.push([0,a]),a=a.mid;else break}const o=a.value;a.value=$,a.key=s;for(let d=r.length-1;d>=0;d--){const n=r[d][1];n.updateHeight();const t=n.balanceFactor();if(t<-1||t>1){const i=r[d][0],w=r[d+1][0];if(i===1&&w===1)r[d][1]=n.rotateLeft();else if(i===-1&&w===-1)r[d][1]=n.rotateRight();else if(i===1&&w===-1)n.right=r[d+1][1]=r[d+1][1].rotateRight(),r[d][1]=n.rotateLeft();else if(i===-1&&w===1)n.left=r[d+1][1]=r[d+1][1].rotateLeft(),r[d][1]=n.rotateRight();else throw new Error;if(d>0)switch(r[d-1][0]){case-1:r[d-1][1].left=r[d][1];break;case 1:r[d-1][1].right=r[d][1];break;case 0:r[d-1][1].mid=r[d][1];break}else this.c=r[0][1]}}return o}get(s){return this.d(s)?.value}d(s){const $=this.b.reset(s);let l=this.c;for(;l;){const a=$.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if($.hasNext())$.next(),l=l.mid;else break}return l}has(s){const $=this.d(s);return!($?.value===void 0&&$?.mid===void 0)}delete(s){return this.e(s,!1)}deleteSuperstr(s){return this.e(s,!0)}e(s,$){const l=this.b.reset(s),a=[];let r=this.c;for(;r;){const o=l.cmp(r.segment);if(o>0)a.push([-1,r]),r=r.left;else if(o<0)a.push([1,r]),r=r.right;else if(l.hasNext())l.next(),a.push([0,r]),r=r.mid;else break}if(r){if($?(r.left=void 0,r.mid=void 0,r.right=void 0,r.height=1):(r.key=void 0,r.value=void 0),!r.mid&&!r.value)if(r.left&&r.right){const o=this.f(r.right);if(o.key){const{key:d,value:n,segment:t}=o;this.e(o.key,!1),r.key=d,r.value=n,r.segment=t}}else{const o=r.left??r.right;if(a.length>0){const[d,n]=a[a.length-1];switch(d){case-1:n.left=o;break;case 0:n.mid=o;break;case 1:n.right=o;break}}else this.c=o}for(let o=a.length-1;o>=0;o--){const d=a[o][1];d.updateHeight();const n=d.balanceFactor();if(n>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),a[o][1]=d.rotateLeft()):n<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),a[o][1]=d.rotateRight()),o>0)switch(a[o-1][0]){case-1:a[o-1][1].left=a[o][1];break;case 1:a[o-1][1].right=a[o][1];break;case 0:a[o-1][1].mid=a[o][1];break}else this.c=a[0][1]}}}f(s){for(;s.left;)s=s.left;return s}findSubstr(s){const $=this.b.reset(s);let l=this.c,a;for(;l;){const r=$.cmp(l.segment);if(r>0)l=l.left;else if(r<0)l=l.right;else if($.hasNext())$.next(),a=l.value||a,l=l.mid;else break}return l&&l.value||a}findSuperstr(s){return this.g(s,!1)}g(s,$){const l=this.b.reset(s);let a=this.c;for(;a;){const r=l.cmp(a.segment);if(r>0)a=a.left;else if(r<0)a=a.right;else if(l.hasNext())l.next(),a=a.mid;else return a.mid?this.h(a.mid):$?a.value:void 0}}hasElementOrSubtree(s){return this.g(s,!0)!==void 0}forEach(s){for(const[$,l]of this)s(l,$)}*[Symbol.iterator](){yield*this.h(this.c)}h(s){const $=[];return this.j(s,$),$[Symbol.iterator]()}j(s,$){s&&(s.left&&this.j(s.left,$),s.value&&$.push([s.key,s.value]),s.mid&&this.j(s.mid,$),s.right&&this.j(s.right,$))}_isBalanced(){const s=$=>{if(!$)return!0;const l=$.balanceFactor();return l<-1||l>1?!1:s($.left)&&s($.right)};return s(this.c)}}e.$_h=m}),define(le[8],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=void 0;function y(t){return typeof t=="string"}e.$If=y;function L(t){return Array.isArray(t)&&t.every(i=>y(i))}e.$Jf=L;function k(t){return typeof t=="object"&&t!==null&&!Array.isArray(t)&&!(t instanceof RegExp)&&!(t instanceof Date)}e.$Kf=k;function A(t){const i=Object.getPrototypeOf(Uint8Array);return typeof t=="object"&&t instanceof i}e.$Lf=A;function I(t){return typeof t=="number"&&!isNaN(t)}e.$Mf=I;function E(t){return!!t&&typeof t[Symbol.iterator]=="function"}e.$Nf=E;function h(t){return t===!0||t===!1}e.$Of=h;function u(t){return typeof t>"u"}e.$Pf=u;function P(t){return!m(t)}e.$Qf=P;function m(t){return u(t)||t===null}e.$Rf=m;function p(t,i){if(!t)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.$Sf=p;function s(t){if(m(t))throw new Error("Assertion Failed: argument is undefined or null");return t}e.$Tf=s;function $(...t){const i=[];for(let w=0;w<t.length;w++){const j=t[w];if(m(j))throw new Error(`Assertion Failed: argument at index ${w} is undefined or null`);i.push(j)}return i}e.$Uf=$;const l=Object.prototype.hasOwnProperty;function a(t){if(!k(t))return!1;for(const i in t)if(l.call(t,i))return!1;return!0}e.$Vf=a;function r(t){return typeof t=="function"}e.$Wf=r;function o(...t){return t.length>0&&t.every(r)}e.$Xf=o;function d(t,i){const w=Math.min(t.length,i.length);for(let j=0;j<w;j++)n(t[j],i[j])}e.$Yf=d;function n(t,i){if(y(i)){if(typeof t!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(r(i)){try{if(t instanceof i)return}catch{}if(!m(t)&&t.constructor===i||i.length===1&&i.call(void 0,t)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Zf=n}),define(le[30],he([0,1,8]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function L(r){if(!r||typeof r!="object"||r instanceof RegExp)return r;const o=Array.isArray(r)?[]:{};return Object.entries(r).forEach(([d,n])=>{o[d]=n&&typeof n=="object"?L(n):n}),o}e.$vn=L;function k(r){if(!r||typeof r!="object")return r;const o=[r];for(;o.length>0;){const d=o.shift();Object.freeze(d);for(const n in d)if(A.call(d,n)){const t=d[n];typeof t=="object"&&!Object.isFrozen(t)&&!(0,y.$Lf)(t)&&o.push(t)}}return r}e.$wn=k;const A=Object.prototype.hasOwnProperty;function I(r,o){return E(r,o,new Set)}e.$xn=I;function E(r,o,d){if((0,y.$Rf)(r))return r;const n=o(r);if(typeof n<"u")return n;if(Array.isArray(r)){const t=[];for(const i of r)t.push(E(i,o,d));return t}if((0,y.$Kf)(r)){if(d.has(r))throw new Error("Cannot clone recursive data-structure");d.add(r);const t={};for(const i in r)A.call(r,i)&&(t[i]=E(r[i],o,d));return d.delete(r),t}return r}function h(r,o,d=!0){return(0,y.$Kf)(r)?((0,y.$Kf)(o)&&Object.keys(o).forEach(n=>{n in r?d&&((0,y.$Kf)(r[n])&&(0,y.$Kf)(o[n])?h(r[n],o[n],d):r[n]=o[n]):r[n]=o[n]}),r):o}e.$yn=h;function u(r,o){if(r===o)return!0;if(r==null||o===null||o===void 0||typeof r!=typeof o||typeof r!="object"||Array.isArray(r)!==Array.isArray(o))return!1;let d,n;if(Array.isArray(r)){if(r.length!==o.length)return!1;for(d=0;d<r.length;d++)if(!u(r[d],o[d]))return!1}else{const t=[];for(n in r)t.push(n);t.sort();const i=[];for(n in o)i.push(n);if(i.sort(),!u(t,i))return!1;for(d=0;d<t.length;d++)if(!u(r[t[d]],o[t[d]]))return!1}return!0}e.$zn=u;function P(r){const o=new Set;return JSON.stringify(r,(d,n)=>{if((0,y.$Kf)(n)||Array.isArray(n)){if(o.has(n))return"[Circular]";o.add(n)}return n})}e.$An=P;function m(r,o){const d=Object.create(null);return!r||!o||Object.keys(o).forEach(t=>{const i=r[t],w=o[t];u(i,w)||(d[t]=w)}),d}e.$Bn=m;function p(r,o){const d=o.toLowerCase(),n=Object.keys(r).find(t=>t.toLowerCase()===d);return n?r[n]:r[o]}e.$Cn=p;function s(r,o){const d=Object.create(null);for(const[n,t]of Object.entries(r))o(n,t)&&(d[n]=t);return d}e.$Dn=s;function $(r){let o=[];for(;Object.prototype!==r;)o=o.concat(Object.getOwnPropertyNames(r)),r=Object.getPrototypeOf(r);return o}e.$En=$;function l(r){const o=[];for(const d of $(r))typeof r[d]=="function"&&o.push(d);return o}e.$Fn=l;function a(r,o){const d=t=>function(){const i=Array.prototype.slice.call(arguments,0);return o(t,i)},n={};for(const t of r)n[t]=d(t);return n}e.$Gn=a}),define(le[52],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const y=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(k){return y.test(k)}e.$pg=L,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(E){for(let h=0;h<E.length;h++)E[h]=Math.floor(Math.random()*256);return E};const A=new Uint8Array(16),I=[];for(let E=0;E<256;E++)I.push(E.toString(16).padStart(2,"0"));return function(){k(A),A[6]=A[6]&15|64,A[8]=A[8]&63|128;let h=0,u="";return u+=I[A[h++]],u+=I[A[h++]],u+=I[A[h++]],u+=I[A[h++]],u+="-",u+=I[A[h++]],u+=I[A[h++]],u+="-",u+=I[A[h++]],u+=I[A[h++]],u+="-",u+=I[A[h++]],u+=I[A[h++]],u+="-",u+=I[A[h++]],u+=I[A[h++]],u+=I[A[h++]],u+=I[A[h++]],u+=I[A[h++]],u+=I[A[h++]],u}}()}),define(le[31],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$MU=void 0;function y(L){return!!L.parentPort}e.$MU=y}),define(le[53],he([13,12]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(le[54],he([0,1,53]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const L=60,k=L*60,A=k*24,I=A*7,E=A*30,h=A*365;function u(m,p,s,$){typeof m!="number"&&(m=m.getTime());const l=Math.round((new Date().getTime()-m)/1e3);if(l<-30)return(0,y.localize)(0,null,u(new Date().getTime()+l*1e3,!1));if(!$&&l<30)return(0,y.localize)(1,null);let a;return l<L?(a=l,p?a===1?s?(0,y.localize)(2,null,a):(0,y.localize)(3,null,a):s?(0,y.localize)(4,null,a):(0,y.localize)(5,null,a):a===1?s?(0,y.localize)(6,null,a):(0,y.localize)(7,null,a):s?(0,y.localize)(8,null,a):(0,y.localize)(9,null,a)):l<k?(a=Math.floor(l/L),p?a===1?s?(0,y.localize)(10,null,a):(0,y.localize)(11,null,a):s?(0,y.localize)(12,null,a):(0,y.localize)(13,null,a):a===1?s?(0,y.localize)(14,null,a):(0,y.localize)(15,null,a):s?(0,y.localize)(16,null,a):(0,y.localize)(17,null,a)):l<A?(a=Math.floor(l/k),p?a===1?s?(0,y.localize)(18,null,a):(0,y.localize)(19,null,a):s?(0,y.localize)(20,null,a):(0,y.localize)(21,null,a):a===1?s?(0,y.localize)(22,null,a):(0,y.localize)(23,null,a):s?(0,y.localize)(24,null,a):(0,y.localize)(25,null,a)):l<I?(a=Math.floor(l/A),p?a===1?(0,y.localize)(26,null,a):(0,y.localize)(27,null,a):a===1?(0,y.localize)(28,null,a):(0,y.localize)(29,null,a)):l<E?(a=Math.floor(l/I),p?a===1?s?(0,y.localize)(30,null,a):(0,y.localize)(31,null,a):s?(0,y.localize)(32,null,a):(0,y.localize)(33,null,a):a===1?s?(0,y.localize)(34,null,a):(0,y.localize)(35,null,a):s?(0,y.localize)(36,null,a):(0,y.localize)(37,null,a)):l<h?(a=Math.floor(l/E),p?a===1?s?(0,y.localize)(38,null,a):(0,y.localize)(39,null,a):s?(0,y.localize)(40,null,a):(0,y.localize)(41,null,a):a===1?s?(0,y.localize)(42,null,a):(0,y.localize)(43,null,a):s?(0,y.localize)(44,null,a):(0,y.localize)(45,null,a)):(a=Math.floor(l/h),p?a===1?s?(0,y.localize)(46,null,a):(0,y.localize)(47,null,a):s?(0,y.localize)(48,null,a):(0,y.localize)(49,null,a):a===1?s?(0,y.localize)(50,null,a):(0,y.localize)(51,null,a):s?(0,y.localize)(52,null,a):(0,y.localize)(53,null,a))}e.$vm=u;function P(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=P}),define(le[55],he([13,12]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(le[56],he([0,1,16,8,55]),function(oe,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function A(m,p){return p&&(m.stack||m.stacktrace)?k.localize(0,null,E(m),I(m.stack)||I(m.stacktrace)):E(m)}function I(m){return Array.isArray(m)?m.join(`
`):m}function E(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?k.localize(1,null,m.message):m.message||k.localize(2,null)}function h(m=null,p=!1){if(!m)return k.localize(3,null);if(Array.isArray(m)){const s=y.$Hb(m),$=h(s[0],p);return s.length>1?k.localize(4,null,$,s.length):$}if(L.$If(m))return m;if(m.detail){const s=m.detail;if(s.error)return A(s.error,p);if(s.exception)return A(s.exception,p)}return m.stack?A(m,p):m.message?m.message:k.localize(5,null)}e.$Qi=h;function u(m){const p=m;return p instanceof Error&&Array.isArray(p.actions)}e.$Ri=u;function P(m,p){let s;return typeof m=="string"?s=new Error(m):s=m,s.actions=p,s}e.$Si=P}),define(le[57],he([13,12]),function(oe,e){return oe.create("vs/base/common/platform",e)}),define(le[3],he([0,1,57]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let L=!1,k=!1,A=!1,I=!1,E=!1,h=!1,u=!1,P=!1,m=!1,p=!1,s,$=e.$g,l=e.$g,a,r;const o=globalThis;let d;typeof o.vscode<"u"&&typeof o.vscode.process<"u"?d=o.vscode.process:typeof process<"u"&&(d=process);const n=typeof d?.versions?.electron=="string",t=n&&d?.type==="renderer";if(typeof d=="object"){L=d.platform==="win32",k=d.platform==="darwin",A=d.platform==="linux",I=A&&!!d.env.SNAP&&!!d.env.SNAP_REVISION,u=n,m=!!d.env.CI||!!d.env.BUILD_ARTIFACTSTAGINGDIRECTORY,s=e.$g,$=e.$g;const c=d.env.VSCODE_NLS_CONFIG;if(c)try{const b=JSON.parse(c),S=b.availableLanguages["*"];s=b.locale,l=b.osLocale,$=S||e.$g,a=b._translationsConfigFile}catch{}E=!0}else typeof navigator=="object"&&!t?(r=navigator.userAgent,L=r.indexOf("Windows")>=0,k=r.indexOf("Macintosh")>=0,P=(r.indexOf("Macintosh")>=0||r.indexOf("iPad")>=0||r.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=r.indexOf("Linux")>=0,p=r?.indexOf("Mobi")>=0,h=!0,s=y.getConfiguredDefaultLocale(y.localize(0,null))||e.$g,$=s,l=navigator.language):console.error("Unable to resolve platform.");var i;(function(c){c[c.Web=0]="Web",c[c.Mac=1]="Mac",c[c.Linux=2]="Linux",c[c.Windows=3]="Windows"})(i||(e.Platform=i={}));function w(c){switch(c){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=w;let j=0;k?j=1:L?j=3:A&&(j=2),e.$i=L,e.$j=k,e.$k=A,e.$l=I,e.$m=E,e.$n=u,e.$o=h,e.$p=h&&typeof o.importScripts=="function",e.$q=e.$p?o.origin:void 0,e.$r=P,e.$s=p,e.$t=m,e.$u=j,e.$v=r,e.$w=$;var g;(function(c){function b(){return e.$w}c.value=b;function S(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}c.isDefaultVariant=S;function B(){return e.$w==="en"}c.isDefault=B})(g||(e.Language=g={})),e.$x=s,e.$y=l,e.$z=a,e.$A=typeof o.postMessage=="function"&&!o.importScripts,e.$B=(()=>{if(e.$A){const c=[];o.addEventListener("message",S=>{if(S.data&&S.data.vscodeScheduleAsyncWork)for(let B=0,M=c.length;B<M;B++){const z=c[B];if(z.id===S.data.vscodeScheduleAsyncWork){c.splice(B,1),z.callback();return}}});let b=0;return S=>{const B=++b;c.push({id:B,callback:S}),o.postMessage({vscodeScheduleAsyncWork:B},"*")}}return c=>setTimeout(c)})();var C;(function(c){c[c.Windows=1]="Windows",c[c.Macintosh=2]="Macintosh",c[c.Linux=3]="Linux"})(C||(e.OperatingSystem=C={})),e.OS=k||P?2:L?1:3;let v=!0,D=!1;function W(){if(!D){D=!0;const c=new Uint8Array(2);c[0]=1,c[1]=2,v=new Uint16Array(c.buffer)[0]===(2<<8)+1}return v}e.$D=W,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function q(c){return parseFloat(c)>=20}e.$J=q}),define(le[15],he([0,1,3]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let L;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.process<"u"){const A=k.process;L={get platform(){return A.platform},get arch(){return A.arch},get env(){return A.env},cwd(){return A.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return y.$i?"win32":y.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.$dc=L.platform,e.$ec=L.arch}),define(le[7],he([0,1,15]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const L=65,k=97,A=90,I=122,E=46,h=47,u=92,P=58,m=63;class p extends Error{constructor(w,j,g){let C;typeof j=="string"&&j.indexOf("not ")===0?(C="must not be",j=j.replace(/^not /,"")):C="must be";const v=w.indexOf(".")!==-1?"property":"argument";let D=`The "${w}" ${v} ${C} of type ${j}`;D+=`. Received type ${typeof g}`,super(D),this.code="ERR_INVALID_ARG_TYPE"}}function s(i,w){if(i===null||typeof i!="object")throw new p(w,"Object",i)}function $(i,w){if(typeof i!="string")throw new p(w,"string",i)}const l=y.$dc==="win32";function a(i){return i===h||i===u}function r(i){return i===h}function o(i){return i>=L&&i<=A||i>=k&&i<=I}function d(i,w,j,g){let C="",v=0,D=-1,W=0,q=0;for(let c=0;c<=i.length;++c){if(c<i.length)q=i.charCodeAt(c);else{if(g(q))break;q=h}if(g(q)){if(!(D===c-1||W===1))if(W===2){if(C.length<2||v!==2||C.charCodeAt(C.length-1)!==E||C.charCodeAt(C.length-2)!==E){if(C.length>2){const b=C.lastIndexOf(j);b===-1?(C="",v=0):(C=C.slice(0,b),v=C.length-1-C.lastIndexOf(j)),D=c,W=0;continue}else if(C.length!==0){C="",v=0,D=c,W=0;continue}}w&&(C+=C.length>0?`${j}..`:"..",v=2)}else C.length>0?C+=`${j}${i.slice(D+1,c)}`:C=i.slice(D+1,c),v=c-D-1;D=c,W=0}else q===E&&W!==-1?++W:W=-1}return C}function n(i,w){s(w,"pathObject");const j=w.dir||w.root,g=w.base||`${w.name||""}${w.ext||""}`;return j?j===w.root?`${j}${g}`:`${j}${i}${g}`:g}e.$fc={resolve(...i){let w="",j="",g=!1;for(let C=i.length-1;C>=-1;C--){let v;if(C>=0){if(v=i[C],$(v,"path"),v.length===0)continue}else w.length===0?v=y.cwd():(v=y.env[`=${w}`]||y.cwd(),(v===void 0||v.slice(0,2).toLowerCase()!==w.toLowerCase()&&v.charCodeAt(2)===u)&&(v=`${w}\\`));const D=v.length;let W=0,q="",c=!1;const b=v.charCodeAt(0);if(D===1)a(b)&&(W=1,c=!0);else if(a(b))if(c=!0,a(v.charCodeAt(1))){let S=2,B=S;for(;S<D&&!a(v.charCodeAt(S));)S++;if(S<D&&S!==B){const M=v.slice(B,S);for(B=S;S<D&&a(v.charCodeAt(S));)S++;if(S<D&&S!==B){for(B=S;S<D&&!a(v.charCodeAt(S));)S++;(S===D||S!==B)&&(q=`\\\\${M}\\${v.slice(B,S)}`,W=S)}}}else W=1;else o(b)&&v.charCodeAt(1)===P&&(q=v.slice(0,2),W=2,D>2&&a(v.charCodeAt(2))&&(c=!0,W=3));if(q.length>0)if(w.length>0){if(q.toLowerCase()!==w.toLowerCase())continue}else w=q;if(g){if(w.length>0)break}else if(j=`${v.slice(W)}\\${j}`,g=c,c&&w.length>0)break}return j=d(j,!g,"\\",a),g?`${w}\\${j}`:`${w}${j}`||"."},normalize(i){$(i,"path");const w=i.length;if(w===0)return".";let j=0,g,C=!1;const v=i.charCodeAt(0);if(w===1)return r(v)?"\\":i;if(a(v))if(C=!0,a(i.charCodeAt(1))){let W=2,q=W;for(;W<w&&!a(i.charCodeAt(W));)W++;if(W<w&&W!==q){const c=i.slice(q,W);for(q=W;W<w&&a(i.charCodeAt(W));)W++;if(W<w&&W!==q){for(q=W;W<w&&!a(i.charCodeAt(W));)W++;if(W===w)return`\\\\${c}\\${i.slice(q)}\\`;W!==q&&(g=`\\\\${c}\\${i.slice(q,W)}`,j=W)}}}else j=1;else o(v)&&i.charCodeAt(1)===P&&(g=i.slice(0,2),j=2,w>2&&a(i.charCodeAt(2))&&(C=!0,j=3));let D=j<w?d(i.slice(j),!C,"\\",a):"";return D.length===0&&!C&&(D="."),D.length>0&&a(i.charCodeAt(w-1))&&(D+="\\"),g===void 0?C?`\\${D}`:D:C?`${g}\\${D}`:`${g}${D}`},isAbsolute(i){$(i,"path");const w=i.length;if(w===0)return!1;const j=i.charCodeAt(0);return a(j)||w>2&&o(j)&&i.charCodeAt(1)===P&&a(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let w,j;for(let v=0;v<i.length;++v){const D=i[v];$(D,"path"),D.length>0&&(w===void 0?w=j=D:w+=`\\${D}`)}if(w===void 0)return".";let g=!0,C=0;if(typeof j=="string"&&a(j.charCodeAt(0))){++C;const v=j.length;v>1&&a(j.charCodeAt(1))&&(++C,v>2&&(a(j.charCodeAt(2))?++C:g=!1))}if(g){for(;C<w.length&&a(w.charCodeAt(C));)C++;C>=2&&(w=`\\${w.slice(C)}`)}return e.$fc.normalize(w)},relative(i,w){if($(i,"from"),$(w,"to"),i===w)return"";const j=e.$fc.resolve(i),g=e.$fc.resolve(w);if(j===g||(i=j.toLowerCase(),w=g.toLowerCase(),i===w))return"";let C=0;for(;C<i.length&&i.charCodeAt(C)===u;)C++;let v=i.length;for(;v-1>C&&i.charCodeAt(v-1)===u;)v--;const D=v-C;let W=0;for(;W<w.length&&w.charCodeAt(W)===u;)W++;let q=w.length;for(;q-1>W&&w.charCodeAt(q-1)===u;)q--;const c=q-W,b=D<c?D:c;let S=-1,B=0;for(;B<b;B++){const z=i.charCodeAt(C+B);if(z!==w.charCodeAt(W+B))break;z===u&&(S=B)}if(B!==b){if(S===-1)return g}else{if(c>b){if(w.charCodeAt(W+B)===u)return g.slice(W+B+1);if(B===2)return g.slice(W+B)}D>b&&(i.charCodeAt(C+B)===u?S=B:B===2&&(S=3)),S===-1&&(S=0)}let M="";for(B=C+S+1;B<=v;++B)(B===v||i.charCodeAt(B)===u)&&(M+=M.length===0?"..":"\\..");return W+=S,M.length>0?`${M}${g.slice(W,q)}`:(g.charCodeAt(W)===u&&++W,g.slice(W,q))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const w=e.$fc.resolve(i);if(w.length<=2)return i;if(w.charCodeAt(0)===u){if(w.charCodeAt(1)===u){const j=w.charCodeAt(2);if(j!==m&&j!==E)return`\\\\?\\UNC\\${w.slice(2)}`}}else if(o(w.charCodeAt(0))&&w.charCodeAt(1)===P&&w.charCodeAt(2)===u)return`\\\\?\\${w}`;return i},dirname(i){$(i,"path");const w=i.length;if(w===0)return".";let j=-1,g=0;const C=i.charCodeAt(0);if(w===1)return a(C)?i:".";if(a(C)){if(j=g=1,a(i.charCodeAt(1))){let W=2,q=W;for(;W<w&&!a(i.charCodeAt(W));)W++;if(W<w&&W!==q){for(q=W;W<w&&a(i.charCodeAt(W));)W++;if(W<w&&W!==q){for(q=W;W<w&&!a(i.charCodeAt(W));)W++;if(W===w)return i;W!==q&&(j=g=W+1)}}}}else o(C)&&i.charCodeAt(1)===P&&(j=w>2&&a(i.charCodeAt(2))?3:2,g=j);let v=-1,D=!0;for(let W=w-1;W>=g;--W)if(a(i.charCodeAt(W))){if(!D){v=W;break}}else D=!1;if(v===-1){if(j===-1)return".";v=j}return i.slice(0,v)},basename(i,w){w!==void 0&&$(w,"ext"),$(i,"path");let j=0,g=-1,C=!0,v;if(i.length>=2&&o(i.charCodeAt(0))&&i.charCodeAt(1)===P&&(j=2),w!==void 0&&w.length>0&&w.length<=i.length){if(w===i)return"";let D=w.length-1,W=-1;for(v=i.length-1;v>=j;--v){const q=i.charCodeAt(v);if(a(q)){if(!C){j=v+1;break}}else W===-1&&(C=!1,W=v+1),D>=0&&(q===w.charCodeAt(D)?--D===-1&&(g=v):(D=-1,g=W))}return j===g?g=W:g===-1&&(g=i.length),i.slice(j,g)}for(v=i.length-1;v>=j;--v)if(a(i.charCodeAt(v))){if(!C){j=v+1;break}}else g===-1&&(C=!1,g=v+1);return g===-1?"":i.slice(j,g)},extname(i){$(i,"path");let w=0,j=-1,g=0,C=-1,v=!0,D=0;i.length>=2&&i.charCodeAt(1)===P&&o(i.charCodeAt(0))&&(w=g=2);for(let W=i.length-1;W>=w;--W){const q=i.charCodeAt(W);if(a(q)){if(!v){g=W+1;break}continue}C===-1&&(v=!1,C=W+1),q===E?j===-1?j=W:D!==1&&(D=1):j!==-1&&(D=-1)}return j===-1||C===-1||D===0||D===1&&j===C-1&&j===g+1?"":i.slice(j,C)},format:n.bind(null,"\\"),parse(i){$(i,"path");const w={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return w;const j=i.length;let g=0,C=i.charCodeAt(0);if(j===1)return a(C)?(w.root=w.dir=i,w):(w.base=w.name=i,w);if(a(C)){if(g=1,a(i.charCodeAt(1))){let S=2,B=S;for(;S<j&&!a(i.charCodeAt(S));)S++;if(S<j&&S!==B){for(B=S;S<j&&a(i.charCodeAt(S));)S++;if(S<j&&S!==B){for(B=S;S<j&&!a(i.charCodeAt(S));)S++;S===j?g=S:S!==B&&(g=S+1)}}}}else if(o(C)&&i.charCodeAt(1)===P){if(j<=2)return w.root=w.dir=i,w;if(g=2,a(i.charCodeAt(2))){if(j===3)return w.root=w.dir=i,w;g=3}}g>0&&(w.root=i.slice(0,g));let v=-1,D=g,W=-1,q=!0,c=i.length-1,b=0;for(;c>=g;--c){if(C=i.charCodeAt(c),a(C)){if(!q){D=c+1;break}continue}W===-1&&(q=!1,W=c+1),C===E?v===-1?v=c:b!==1&&(b=1):v!==-1&&(b=-1)}return W!==-1&&(v===-1||b===0||b===1&&v===W-1&&v===D+1?w.base=w.name=i.slice(D,W):(w.name=i.slice(D,v),w.base=i.slice(D,W),w.ext=i.slice(v,W))),D>0&&D!==g?w.dir=i.slice(0,D-1):w.dir=w.root,w},sep:"\\",delimiter:";",win32:null,posix:null};const t=(()=>{if(l){const i=/\\/g;return()=>{const w=y.cwd().replace(i,"/");return w.slice(w.indexOf("/"))}}return()=>y.cwd()})();e.$gc={resolve(...i){let w="",j=!1;for(let g=i.length-1;g>=-1&&!j;g--){const C=g>=0?i[g]:t();$(C,"path"),C.length!==0&&(w=`${C}/${w}`,j=C.charCodeAt(0)===h)}return w=d(w,!j,"/",r),j?`/${w}`:w.length>0?w:"."},normalize(i){if($(i,"path"),i.length===0)return".";const w=i.charCodeAt(0)===h,j=i.charCodeAt(i.length-1)===h;return i=d(i,!w,"/",r),i.length===0?w?"/":j?"./":".":(j&&(i+="/"),w?`/${i}`:i)},isAbsolute(i){return $(i,"path"),i.length>0&&i.charCodeAt(0)===h},join(...i){if(i.length===0)return".";let w;for(let j=0;j<i.length;++j){const g=i[j];$(g,"path"),g.length>0&&(w===void 0?w=g:w+=`/${g}`)}return w===void 0?".":e.$gc.normalize(w)},relative(i,w){if($(i,"from"),$(w,"to"),i===w||(i=e.$gc.resolve(i),w=e.$gc.resolve(w),i===w))return"";const j=1,g=i.length,C=g-j,v=1,D=w.length-v,W=C<D?C:D;let q=-1,c=0;for(;c<W;c++){const S=i.charCodeAt(j+c);if(S!==w.charCodeAt(v+c))break;S===h&&(q=c)}if(c===W)if(D>W){if(w.charCodeAt(v+c)===h)return w.slice(v+c+1);if(c===0)return w.slice(v+c)}else C>W&&(i.charCodeAt(j+c)===h?q=c:c===0&&(q=0));let b="";for(c=j+q+1;c<=g;++c)(c===g||i.charCodeAt(c)===h)&&(b+=b.length===0?"..":"/..");return`${b}${w.slice(v+q)}`},toNamespacedPath(i){return i},dirname(i){if($(i,"path"),i.length===0)return".";const w=i.charCodeAt(0)===h;let j=-1,g=!0;for(let C=i.length-1;C>=1;--C)if(i.charCodeAt(C)===h){if(!g){j=C;break}}else g=!1;return j===-1?w?"/":".":w&&j===1?"//":i.slice(0,j)},basename(i,w){w!==void 0&&$(w,"ext"),$(i,"path");let j=0,g=-1,C=!0,v;if(w!==void 0&&w.length>0&&w.length<=i.length){if(w===i)return"";let D=w.length-1,W=-1;for(v=i.length-1;v>=0;--v){const q=i.charCodeAt(v);if(q===h){if(!C){j=v+1;break}}else W===-1&&(C=!1,W=v+1),D>=0&&(q===w.charCodeAt(D)?--D===-1&&(g=v):(D=-1,g=W))}return j===g?g=W:g===-1&&(g=i.length),i.slice(j,g)}for(v=i.length-1;v>=0;--v)if(i.charCodeAt(v)===h){if(!C){j=v+1;break}}else g===-1&&(C=!1,g=v+1);return g===-1?"":i.slice(j,g)},extname(i){$(i,"path");let w=-1,j=0,g=-1,C=!0,v=0;for(let D=i.length-1;D>=0;--D){const W=i.charCodeAt(D);if(W===h){if(!C){j=D+1;break}continue}g===-1&&(C=!1,g=D+1),W===E?w===-1?w=D:v!==1&&(v=1):w!==-1&&(v=-1)}return w===-1||g===-1||v===0||v===1&&w===g-1&&w===j+1?"":i.slice(w,g)},format:n.bind(null,"/"),parse(i){$(i,"path");const w={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return w;const j=i.charCodeAt(0)===h;let g;j?(w.root="/",g=1):g=0;let C=-1,v=0,D=-1,W=!0,q=i.length-1,c=0;for(;q>=g;--q){const b=i.charCodeAt(q);if(b===h){if(!W){v=q+1;break}continue}D===-1&&(W=!1,D=q+1),b===E?C===-1?C=q:c!==1&&(c=1):C!==-1&&(c=-1)}if(D!==-1){const b=v===0&&j?1:v;C===-1||c===0||c===1&&C===D-1&&C===v+1?w.base=w.name=i.slice(b,D):(w.name=i.slice(b,C),w.base=i.slice(b,D),w.ext=i.slice(C,D))}return v>0?w.dir=i.slice(0,v-1):j&&(w.dir="/"),w},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=l?e.$fc.normalize:e.$gc.normalize,e.$ic=l?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=l?e.$fc.join:e.$gc.join,e.$kc=l?e.$fc.resolve:e.$gc.resolve,e.$lc=l?e.$fc.relative:e.$gc.relative,e.$mc=l?e.$fc.dirname:e.$gc.dirname,e.$nc=l?e.$fc.basename:e.$gc.basename,e.$oc=l?e.$fc.extname:e.$gc.extname,e.$pc=l?e.$fc.format:e.$gc.format,e.$qc=l?e.$fc.parse:e.$gc.parse,e.$rc=l?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=l?e.$fc.sep:e.$gc.sep,e.$tc=l?e.$fc.delimiter:e.$gc.delimiter}),define(le[32],he([0,1,7,3,11,8]),function(oe,e,y,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function I(v){return v===47||v===92}e.$1f=I;function E(v){return v.replace(/[\\/]/g,y.$gc.sep)}e.$2f=E;function h(v){return v.indexOf("/")===-1&&(v=E(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}e.$3f=h;function u(v,D=y.$gc.sep){if(!v)return"";const W=v.length,q=v.charCodeAt(0);if(I(q)){if(I(v.charCodeAt(1))&&!I(v.charCodeAt(2))){let b=3;const S=b;for(;b<W&&!I(v.charCodeAt(b));b++);if(S!==b&&!I(v.charCodeAt(b+1))){for(b+=1;b<W;b++)if(I(v.charCodeAt(b)))return v.slice(0,b+1).replace(/[\\/]/g,D)}}return D}else if(r(q)&&v.charCodeAt(1)===58)return I(v.charCodeAt(2))?v.slice(0,2)+D:v.slice(0,2);let c=v.indexOf("://");if(c!==-1){for(c+=3;c<W;c++)if(I(v.charCodeAt(c)))return v.slice(0,c+1)}return""}e.$4f=u;function P(v){if(!L.$i||!v||v.length<5)return!1;let D=v.charCodeAt(0);if(D!==92||(D=v.charCodeAt(1),D!==92))return!1;let W=2;const q=W;for(;W<v.length&&(D=v.charCodeAt(W),D!==92);W++);return!(q===W||(D=v.charCodeAt(W+1),isNaN(D)||D===92))}e.$5f=P;const m=/[\\/:\*\?"<>\|]/g,p=/[\\/]/g,s=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function $(v,D=L.$i){const W=D?m:p;return!(!v||v.length===0||/^\s+$/.test(v)||(W.lastIndex=0,W.test(v))||D&&s.test(v)||v==="."||v===".."||D&&v[v.length-1]==="."||D&&v.length!==v.trim().length||v.length>255)}e.$6f=$;function l(v,D,W){const q=v===D;return!W||q?q:!v||!D?!1:(0,k.$_e)(v,D)}e.$7f=l;function a(v,D,W,q=y.sep){if(v===D)return!0;if(!v||!D||D.length>v.length)return!1;if(W){if(!(0,k.$af)(v,D))return!1;if(D.length===v.length)return!0;let b=D.length;return D.charAt(D.length-1)===q&&b--,v.charAt(b)===q}return D.charAt(D.length-1)!==q&&(D+=q),v.indexOf(D)===0}e.$8f=a;function r(v){return v>=65&&v<=90||v>=97&&v<=122}e.$9f=r;function o(v,D){return L.$i&&v.endsWith(":")&&(v+=y.sep),(0,y.$ic)(v)||(v=(0,y.$jc)(D,v)),v=(0,y.$hc)(v),L.$i?(v=(0,k.$Ue)(v,y.sep),v.endsWith(":")&&(v+=y.sep)):(v=(0,k.$Ue)(v,y.sep),v||(v=y.sep)),v}e.$0f=o;function d(v){const D=(0,y.$hc)(v);return L.$i?v.length>3?!1:n(D)&&(v.length===2||D.charCodeAt(2)===92):D===y.$gc.sep}e.$$f=d;function n(v,D=L.$i){return D?r(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}e.$_f=n;function t(v,D=L.$i){return n(v,D)?v[0]:void 0}e.$ag=t;function i(v,D,W){return D.length>v.length?-1:v===D?0:(W&&(v=v.toLowerCase(),D=D.toLowerCase()),v.indexOf(D))}e.$bg=i;function w(v){const D=v.split(":");let W,q,c;for(const b of D){const S=Number(b);(0,A.$Mf)(S)?q===void 0?q=S:c===void 0&&(c=S):W=W?[W,b].join(":"):b}if(!W)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:W,line:q!==void 0?q:void 0,column:c!==void 0?c:q!==void 0?1:void 0}}e.$cg=w;const j="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function C(v,D,W=8){let q="";for(let b=0;b<W;b++){let S;b===0&&L.$i&&!D&&(W===3||W===4)?S=g:S=j,q+=S.charAt(Math.floor(Math.random()*S.length))}let c;return D?c=`${D}-${q}`:c=q,v?(0,y.$jc)(v,c):c}e.$dg=C}),define(le[33],he([0,1,3]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var L;(function(E){E[E.stdout=0]="stdout",E[E.stderr=1]="stderr"})(L||(e.Source=L={}));var k;(function(E){E[E.Success=0]="Success",E[E.Unknown=1]="Unknown",E[E.AccessDenied=2]="AccessDenied",E[E.ProcessNotFound=3]="ProcessNotFound"})(k||(e.TerminateResponseCode=k={}));function A(E,...h){const u=h.reduce((p,s)=>(p[s]=!0,p),{}),P=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(E).filter(p=>!u[p]).forEach(p=>{for(let s=0;s<P.length;s++)if(p.search(P[s])!==-1){delete E[p];break}})}e.$Rl=A;function I(E){E&&(delete E.DEBUG,y.$j&&delete E.DYLD_LIBRARY_PATH,y.$k&&delete E.LD_PRELOAD)}e.$Sl=I}),define(le[5],he([0,1,7,3]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,A=/^\//,I=/^\/\//;function E(g,C){if(!g.scheme&&C)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${g.authority}", path: "${g.path}", query: "${g.query}", fragment: "${g.fragment}"}`);if(g.scheme&&!k.test(g.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(g.path){if(g.authority){if(!A.test(g.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(g.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(g,C){return!g&&!C?"file":g}function u(g,C){switch(g){case"https":case"http":case"file":C?C[0]!==m&&(C=m+C):C=m;break}return C}const P="",m="/",p=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{static isUri(C){return C instanceof s?!0:C?typeof C.authority=="string"&&typeof C.fragment=="string"&&typeof C.path=="string"&&typeof C.query=="string"&&typeof C.scheme=="string"&&typeof C.fsPath=="string"&&typeof C.with=="function"&&typeof C.toString=="function":!1}constructor(C,v,D,W,q,c=!1){typeof C=="object"?(this.scheme=C.scheme||P,this.authority=C.authority||P,this.path=C.path||P,this.query=C.query||P,this.fragment=C.fragment||P):(this.scheme=h(C,c),this.authority=v||P,this.path=u(this.scheme,D||P),this.query=W||P,this.fragment=q||P,E(this,c))}get fsPath(){return n(this,!1)}with(C){if(!C)return this;let{scheme:v,authority:D,path:W,query:q,fragment:c}=C;return v===void 0?v=this.scheme:v===null&&(v=P),D===void 0?D=this.authority:D===null&&(D=P),W===void 0?W=this.path:W===null&&(W=P),q===void 0?q=this.query:q===null&&(q=P),c===void 0?c=this.fragment:c===null&&(c=P),v===this.scheme&&D===this.authority&&W===this.path&&q===this.query&&c===this.fragment?this:new a(v,D,W,q,c)}static parse(C,v=!1){const D=p.exec(C);return D?new a(D[2]||P,j(D[4]||P),j(D[5]||P),j(D[7]||P),j(D[9]||P),v):new a(P,P,P,P,P)}static file(C){let v=P;if(L.$i&&(C=C.replace(/\\/g,m)),C[0]===m&&C[1]===m){const D=C.indexOf(m,2);D===-1?(v=C.substring(2),C=m):(v=C.substring(2,D),C=C.substring(D)||m)}return new a("file",v,C,P,P)}static from(C,v){return new a(C.scheme,C.authority,C.path,C.query,C.fragment,v)}static joinPath(C,...v){if(!C.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let D;return L.$i&&C.scheme==="file"?D=s.file(y.$fc.join(n(C,!0),...v)).path:D=y.$gc.join(C.path,...v),C.with({path:D})}toString(C=!1){return t(this,C)}toJSON(){return this}static revive(C){if(C){if(C instanceof s)return C;{const v=new a(C);return v._formatted=C.external??null,v._fsPath=C._sep===l?C.fsPath??null:null,v}}else return C}}e.URI=s;function $(g){return!g||typeof g!="object"?!1:typeof g.scheme=="string"&&(typeof g.authority=="string"||typeof g.authority>"u")&&(typeof g.path=="string"||typeof g.path>"u")&&(typeof g.query=="string"||typeof g.query>"u")&&(typeof g.fragment=="string"||typeof g.fragment>"u")}e.$vc=$;const l=L.$i?1:void 0;class a extends s{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(C=!1){return C?t(this,!0):(this._formatted||(this._formatted=t(this,!1)),this._formatted)}toJSON(){const C={$mid:1};return this._fsPath&&(C.fsPath=this._fsPath,C._sep=l),this._formatted&&(C.external=this._formatted),this.path&&(C.path=this.path),this.scheme&&(C.scheme=this.scheme),this.authority&&(C.authority=this.authority),this.query&&(C.query=this.query),this.fragment&&(C.fragment=this.fragment),C}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function o(g,C,v){let D,W=-1;for(let q=0;q<g.length;q++){const c=g.charCodeAt(q);if(c>=97&&c<=122||c>=65&&c<=90||c>=48&&c<=57||c===45||c===46||c===95||c===126||C&&c===47||v&&c===91||v&&c===93||v&&c===58)W!==-1&&(D+=encodeURIComponent(g.substring(W,q)),W=-1),D!==void 0&&(D+=g.charAt(q));else{D===void 0&&(D=g.substr(0,q));const b=r[c];b!==void 0?(W!==-1&&(D+=encodeURIComponent(g.substring(W,q)),W=-1),D+=b):W===-1&&(W=q)}}return W!==-1&&(D+=encodeURIComponent(g.substring(W))),D!==void 0?D:g}function d(g){let C;for(let v=0;v<g.length;v++){const D=g.charCodeAt(v);D===35||D===63?(C===void 0&&(C=g.substr(0,v)),C+=r[D]):C!==void 0&&(C+=g[v])}return C!==void 0?C:g}function n(g,C){let v;return g.authority&&g.path.length>1&&g.scheme==="file"?v=`//${g.authority}${g.path}`:g.path.charCodeAt(0)===47&&(g.path.charCodeAt(1)>=65&&g.path.charCodeAt(1)<=90||g.path.charCodeAt(1)>=97&&g.path.charCodeAt(1)<=122)&&g.path.charCodeAt(2)===58?C?v=g.path.substr(1):v=g.path[1].toLowerCase()+g.path.substr(2):v=g.path,L.$i&&(v=v.replace(/\//g,"\\")),v}e.$wc=n;function t(g,C){const v=C?d:o;let D="",{scheme:W,authority:q,path:c,query:b,fragment:S}=g;if(W&&(D+=W,D+=":"),(q||W==="file")&&(D+=m,D+=m),q){let B=q.indexOf("@");if(B!==-1){const M=q.substr(0,B);q=q.substr(B+1),B=M.lastIndexOf(":"),B===-1?D+=v(M,!1,!1):(D+=v(M.substr(0,B),!1,!1),D+=":",D+=v(M.substr(B+1),!1,!0)),D+="@"}q=q.toLowerCase(),B=q.lastIndexOf(":"),B===-1?D+=v(q,!1,!0):(D+=v(q.substr(0,B),!1,!0),D+=q.substr(B))}if(c){if(c.length>=3&&c.charCodeAt(0)===47&&c.charCodeAt(2)===58){const B=c.charCodeAt(1);B>=65&&B<=90&&(c=`/${String.fromCharCode(B+32)}:${c.substr(3)}`)}else if(c.length>=2&&c.charCodeAt(1)===58){const B=c.charCodeAt(0);B>=65&&B<=90&&(c=`${String.fromCharCode(B+32)}:${c.substr(2)}`)}D+=v(c,!0,!1)}return b&&(D+="?",D+=v(b,!1,!1)),S&&(D+="#",D+=C?S:o(S,!1,!1)),D}function i(g){try{return decodeURIComponent(g)}catch{return g.length>3?g.substr(0,3)+i(g.substr(3)):g}}const w=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function j(g){return g.match(w)?g.replace(w,C=>i(C)):g}}),define(le[58],he([0,1,5]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function L(u){const P=u;return P&&typeof P.type=="string"&&typeof P.severity=="string"}e.$mq=L;function k(u){const P=[];let m;try{const p=JSON.parse(u.arguments),s=p[p.length-1];s&&s.__$stack&&(p.pop(),m=s.__$stack),P.push(...p)}catch{P.push("Unable to log remote console arguments",u.arguments)}return{args:P,stack:m}}e.$nq=k;function A(u){if(typeof u!="string")return A(k(u).stack);const P=u;if(P){const m=I(P),p=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(p&&p.length===4)return{uri:y.URI.file(p[1]),line:Number(p[2]),column:Number(p[3])}}}e.$oq=A;function I(u){if(!u)return u;const P=u.indexOf(`
`);return P===-1?u:u.substring(0,P)}function E(u,P){const{args:m,stack:p}=k(u),s=typeof m[0]=="string"&&m.length===1;let $=I(p);$&&($=`(${$.trim()})`);let l=[];if(typeof m[0]=="string"?$&&s?l=[`%c[${P}] %c${m[0]} %c${$}`,h("blue"),h(""),h("grey")]:l=[`%c[${P}] %c${m[0]}`,h("blue"),h(""),...m.slice(1)]:l=[`%c[${P}]%`,h("blue"),...m],$&&!s&&l.push($),typeof console[u.severity]!="function")throw new Error("Unknown console method");console[u.severity].apply(console,l)}e.log=E;function h(u){return`color: ${u}`}}),define(le[59],he([0,1,18,5]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function k(h){return JSON.stringify(h,I)}e.$Ah=k;function A(h){let u=JSON.parse(h);return u=E(u),u}e.$Bh=A;function I(h,u){return u instanceof RegExp?{$mid:2,source:u.source,flags:u.flags}:u}function E(h,u=0){if(!h||u>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return L.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 17:return new Date(h.source)}if(h instanceof y.$je||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let P=0;P<h.length;++P)h[P]=E(h[P],u+1);else for(const P in h)Object.hasOwnProperty.call(h,P)&&(h[P]=E(h[P],u+1))}return h}e.$Ch=E}),define(le[19],he([0,1,6,3,11,5]),function(oe,e,y,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var I;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeManagedRemoteResource="vscode-managed-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeChatSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={}));function E(p,s){return A.URI.isUri(p)?(0,k.$_e)(p.scheme,s):(0,k.$af)(p,s+":")}e.$eg=E;function h(p,...s){return s.some($=>E(p,$))}e.$fg=h,e.$gg="vscode-tkn",e.$hg="tkn";class u{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(s){this.d=s}setDelegate(s){this.e=s}setServerRootPath(s){this.f=`${s}/${I.vscodeRemoteResource}`}set(s,$,l){this.a[s]=$,this.b[s]=l}setConnectionToken(s,$){this.c[s]=$}getPreferredWebSchema(){return this.d}rewrite(s){if(this.e)try{return this.e(s)}catch(d){return y.$1(d),s}const $=s.authority;let l=this.a[$];l&&l.indexOf(":")!==-1&&l.indexOf("[")===-1&&(l=`[${l}]`);const a=this.b[$],r=this.c[$];let o=`path=${encodeURIComponent(s.path)}`;return typeof r=="string"&&(o+=`&${e.$hg}=${encodeURIComponent(r)}`),A.URI.from({scheme:L.$o?this.d:I.vscodeRemoteResource,authority:`${l}:${a}`,path:this.f,query:o})}}e.$ig=new u,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class P{static{this.a=e.$ng}asBrowserUri(s){const $=this.b(s,oe);return this.uriToBrowserUri($)}uriToBrowserUri(s){return s.scheme===I.vscodeRemote?e.$ig.rewrite(s):s.scheme===I.file&&(L.$m||L.$q===`${I.vscodeFileResource}://${P.a}`)?s.with({scheme:I.vscodeFileResource,authority:s.authority||P.a,query:null,fragment:null}):s}asFileUri(s){const $=this.b(s,oe);return this.uriToFileUri($)}uriToFileUri(s){return s.scheme===I.vscodeFileResource?s.with({scheme:I.file,authority:s.authority!==P.a?s.authority:null,query:null,fragment:null}):s}b(s,$){return A.URI.isUri(s)?s:A.URI.parse($.toUrl(s))}}e.$og=new P;var m;(function(p){const s=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(s.get("3"));const $="vscode-coi";function l(r){let o;typeof r=="string"?o=new URL(r).searchParams:r instanceof URL?o=r.searchParams:A.URI.isUri(r)&&(o=new URL(r.toString(!0)).searchParams);const d=o?.get($);if(d)return s.get(d)}p.getHeadersFromQuery=l;function a(r,o,d){if(!globalThis.crossOriginIsolated)return;const n=o&&d?"3":d?"2":"1";r instanceof URLSearchParams?r.set($,n):r[$]=n}p.addSearchParam=a})(m||(e.COI=m={}))}),define(le[23],he([0,1,32,19,7,3,11,5]),function(oe,e,y,L,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function h(s){return(0,E.$wc)(s,!0)}e.$vg=h;class u{constructor($){this.a=$}compare($,l,a=!1){return $===l?0:(0,I.$5e)(this.getComparisonKey($,a),this.getComparisonKey(l,a))}isEqual($,l,a=!1){return $===l?!0:!$||!l?!1:this.getComparisonKey($,a)===this.getComparisonKey(l,a)}getComparisonKey($,l=!1){return $.with({path:this.a($)?$.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing($){return this.a($)}isEqualOrParent($,l,a=!1){if($.scheme===l.scheme){if($.scheme===L.Schemas.file)return y.$8f(h($),h(l),this.a($))&&$.query===l.query&&(a||$.fragment===l.fragment);if((0,e.$Mg)($.authority,l.authority))return y.$8f($.path,l.path,this.a($),"/")&&$.query===l.query&&(a||$.fragment===l.fragment)}return!1}joinPath($,...l){return E.URI.joinPath($,...l)}basenameOrAuthority($){return(0,e.$Eg)($)||$.authority}basename($){return k.$gc.basename($.path)}extname($){return k.$gc.extname($.path)}dirname($){if($.path.length===0)return $;let l;return $.scheme===L.Schemas.file?l=E.URI.file(k.$mc(h($))).path:(l=k.$gc.dirname($.path),$.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${$.toString})) resulted in a relative path`),l="/")),$.with({path:l})}normalizePath($){if(!$.path.length)return $;let l;return $.scheme===L.Schemas.file?l=E.URI.file(k.$hc(h($))).path:l=k.$gc.normalize($.path),$.with({path:l})}relativePath($,l){if($.scheme!==l.scheme||!(0,e.$Mg)($.authority,l.authority))return;if($.scheme===L.Schemas.file){const o=k.$lc(h($),h(l));return A.$i?y.$2f(o):o}let a=$.path||"/";const r=l.path||"/";if(this.a($)){let o=0;for(const d=Math.min(a.length,r.length);o<d&&!(a.charCodeAt(o)!==r.charCodeAt(o)&&a.charAt(o).toLowerCase()!==r.charAt(o).toLowerCase());o++);a=r.substr(0,o)+a.substr(o)}return k.$gc.relative(a,r)}resolvePath($,l){if($.scheme===L.Schemas.file){const a=E.URI.file(k.$kc(h($),l));return $.with({authority:a.authority,path:a.path})}return l=y.$3f(l),$.with({path:k.$gc.resolve($.path,l)})}isAbsolutePath($){return!!$.path&&$.path[0]==="/"}isEqualAuthority($,l){return $===l||$!==void 0&&l!==void 0&&(0,I.$_e)($,l)}hasTrailingPathSeparator($,l=k.sep){if($.scheme===L.Schemas.file){const a=h($);return a.length>y.$4f(a).length&&a[a.length-1]===l}else{const a=$.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test($.fsPath)}}removeTrailingPathSeparator($,l=k.sep){return(0,e.$Ng)($,l)?$.with({path:$.path.substr(0,$.path.length-1)}):$}addTrailingPathSeparator($,l=k.sep){let a=!1;if($.scheme===L.Schemas.file){const r=h($);a=r!==void 0&&r.length===y.$4f(r).length&&r[r.length-1]===l}else{l="/";const r=$.path;a=r.length===1&&r.charCodeAt(r.length-1)===47}return!a&&!(0,e.$Ng)($,l)?$.with({path:$.path+"/"}):$}}e.$wg=u,e.$xg=new u(()=>!1),e.$yg=new u(s=>s.scheme===L.Schemas.file?!A.$k:!0),e.$zg=new u(s=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function P(s,$){const l=[];for(let a=0;a<s.length;a++){const r=$(s[a]);s.some((o,d)=>d===a?!1:(0,e.$Bg)(r,$(o)))||l.push(s[a])}return l}e.$Qg=P;var m;(function(s){s.META_DATA_LABEL="label",s.META_DATA_DESCRIPTION="description",s.META_DATA_SIZE="size",s.META_DATA_MIME="mime";function $(l){const a=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(d=>{const[n,t]=d.split(":");n&&t&&a.set(n,t)});const o=l.path.substring(0,l.path.indexOf(";"));return o&&a.set(s.META_DATA_MIME,o),a}s.parseMetaData=$})(m||(e.DataUri=m={}));function p(s,$,l){if($){let a=s.path;return a&&a[0]!==k.$gc.sep&&(a=k.$gc.sep+a),s.with({scheme:l,authority:$,path:a})}return s.with({scheme:l})}e.$Rg=p}),define(le[9],he([0,1,17,6,4,2,23,3,50,22]),function(oe,e,y,L,k,A,I,E,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function P(R){return!!R&&typeof R.then=="function"}e.$Sg=P;function m(R){const O=new y.$6d,N=R(O.token),G=new Promise((Q,ie)=>{const ue=O.token.onCancellationRequested(()=>{ue.dispose(),ie(new L.$5)});Promise.resolve(N).then($e=>{ue.dispose(),O.dispose(),Q($e)},$e=>{ue.dispose(),O.dispose(),ie($e)})});return new class{cancel(){O.cancel(),O.dispose()}then(Q,ie){return G.then(Q,ie)}catch(Q){return this.then(void 0,Q)}finally(Q){return G.finally(Q)}}}e.$Tg=m;function p(R,O,N){return new Promise((G,Q)=>{const ie=O.onCancellationRequested(()=>{ie.dispose(),G(N)});R.then(G,Q).finally(()=>ie.dispose())})}e.$Ug=p;function s(R,O){return new Promise((N,G)=>{const Q=O.onCancellationRequested(()=>{Q.dispose(),G(new L.$5)});R.then(N,G).finally(()=>Q.dispose())})}e.$Vg=s;async function $(R){let O=-1;const N=R.map((G,Q)=>G.then(ie=>(O=Q,ie)));try{return await Promise.race(N)}finally{R.forEach((G,Q)=>{Q!==O&&G.cancel()})}}e.$Wg=$;function l(R,O,N){let G;const Q=setTimeout(()=>{G?.(void 0),N?.()},O);return Promise.race([R.finally(()=>clearTimeout(Q)),new Promise(ie=>G=ie)])}e.$Xg=l;function a(R){return new Promise((O,N)=>{const G=R();P(G)?G.then(O,N):O(G)})}e.$Yg=a;class r{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(O){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=O,!this.b){const N=()=>{if(this.b=null,this.f)return;const G=this.queue(this.d);return this.d=null,G};this.b=new Promise(G=>{this.a.then(N,N).then(G)})}return new Promise((N,G)=>{this.b.then(N,G)})}return this.a=O(),new Promise((N,G)=>{this.a.then(Q=>{this.a=null,N(Q)},Q=>{this.a=null,G(Q)})})}dispose(){this.f=!0}}e.$Zg=r;class o{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.$1g=o;class d{constructor(){this.a=new Map}queue(O,N){const Q=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(N).finally(()=>{this.a.get(O)===Q&&this.a.delete(O)});return this.a.set(O,Q),Q}}e.$2g=d;const n=(R,O)=>{let N=!0;const G=setTimeout(()=>{N=!1,O()},R);return{isTriggered:()=>N,dispose:()=>{clearTimeout(G),N=!1}}},t=R=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,R())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class i{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,N=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((Q,ie)=>{this.d=Q,this.f=ie}).then(()=>{if(this.b=null,this.d=null,this.g){const Q=this.g;return this.g=null,Q()}}));const G=()=>{this.a=null,this.d?.(null)};return this.a=N===h.$Sd?t(G):n(N,G),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=i;class w{constructor(O){this.a=new i(O),this.b=new r}trigger(O,N){return this.a.trigger(()=>this.b.queue(O),N)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=w;class j{constructor(){this.a=!1,this.b=new Promise((O,N)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=j;class g extends j{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.$6g=g;function C(R,O){return O?new Promise((N,G)=>{const Q=setTimeout(()=>{ie.dispose(),N()},R),ie=O.onCancellationRequested(()=>{clearTimeout(Q),ie.dispose(),G(new L.$5)})}):m(N=>C(R,N))}e.$7g=C;function v(R,O=0,N){const G=setTimeout(()=>{R(),N&&Q.dispose()},O),Q=(0,A.$Rc)(()=>{clearTimeout(G),N?.deleteAndLeak(Q)});return N?.add(Q),Q}e.$8g=v;function D(R){const O=[];let N=0;const G=R.length;function Q(){return N<G?R[N++]():null}function ie(ue){ue!=null&&O.push(ue);const $e=Q();return $e?$e.then(ie):Promise.resolve(O)}return Promise.resolve(null).then(ie)}e.$9g=D;function W(R,O=G=>!!G,N=null){let G=0;const Q=R.length,ie=()=>{if(G>=Q)return Promise.resolve(N);const ue=R[G++];return Promise.resolve(ue()).then(we=>O(we)?Promise.resolve(we):ie())};return ie()}e.$0g=W;function q(R,O=G=>!!G,N=null){if(R.length===0)return Promise.resolve(N);let G=R.length;const Q=()=>{G=-1;for(const ie of R)ie.cancel?.()};return new Promise((ie,ue)=>{for(const $e of R)$e.then(we=>{--G>=0&&O(we)?(Q(),ie(we)):G===0&&ie(N)}).catch(we=>{--G>=0&&(Q(),ue(we))})})}e.$$g=q;class c{constructor(O){this.a=0,this.b=!1,this.f=O,this.g=[],this.d=0,this.h=new k.$Vd}whenIdle(){return this.size>0?k.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(O){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((N,G)=>{this.g.push({factory:O,c:N,e:G}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const O=this.g.shift();this.d++;const N=O.factory();N.then(O.c,O.e),N.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=c;class b extends c{constructor(){super(1)}}e.$ah=b;class S{constructor(){this.a=new V,this.b=0}queue(O){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,O())):this.a.run(this.b++,O())}}e.$bh=S;class B{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const O=new H;return this.b.add(O),O.p}g(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueSize(O,N=I.$xg){const G=N.getComparisonKey(O);return this.a.get(G)?.size??0}queueFor(O,N,G=I.$xg){const Q=G.getComparisonKey(O);let ie=this.a.get(Q);if(!ie){ie=new b;const ue=this.f++,$e=k.Event.once(ie.onDrained)(()=>{ie?.dispose(),this.a.delete(Q),this.h(),this.d?.deleteAndDispose(ue),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new A.$3c),this.d.set(ue,$e),this.a.set(Q,ie)}return ie.queue(N)}h(){this.g()&&this.j()}j(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=B;class M{constructor(O,N){this.a=-1,typeof O=="function"&&typeof N=="number"&&this.setIfNotSet(O,N)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,N){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},N)}setIfNotSet(O,N){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},N))}}e.$dh=M;class z{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(O,N,G=globalThis){this.cancel();const Q=G.setInterval(()=>{O()},N);this.d=(0,A.$Rc)(()=>{G.clearInterval(Q),this.d=void 0})}dispose(){this.cancel()}}e.$eh=z;class ee{constructor(O,N){this.b=-1,this.a=O,this.d=N,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=ee;class ne{constructor(O,N){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.a=O,this.b=N,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=ne;class Y extends ee{constructor(O,N){super(O,N),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.$hh=Y;class se extends A.$Tc{constructor(O,N){super(),this.g=O,this.h=N,this.a=[],this.b=this.B(new A.$Uc),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const N of O)this.a.push(N);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ee(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=se,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(R,O)=>{(0,E.$B)(()=>{if(N)return;const G=Date.now()+15;O(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,G-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.$kh=(R,O,N)=>{const G=R.requestIdleCallback(O,typeof N=="number"?{timeout:N}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,R.cancelIdleCallback(G))}}},e.$jh=R=>(0,e.$kh)(globalThis,R)}();class ce{constructor(O,N){this.g=!1,this.d=()=>{try{this.j=N()}catch(G){this.l=G}finally{this.g=!0}},this.f=(0,e.$kh)(O,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=ce;class fe extends ce{constructor(O){super(globalThis,O)}}e.$mh=fe;async function X(R,O,N){let G;for(let Q=0;Q<N;Q++)try{return await R()}catch(ie){G=ie,await C(O)}throw G}e.$nh=X;class V{isRunning(O){return typeof O=="number"?this.a?.taskId===O:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(O,N,G){return this.a={taskId:O,cancel:()=>G?.(),promise:N},N.then(()=>this.d(O),()=>this.d(O)),N}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}queue(O){if(this.b)this.b.run=O;else{let N,G;const Q=new Promise((ie,ue)=>{N=ie,G=ue});this.b={run:O,promise:Q,promiseResolve:N,promiseReject:G}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=V;class K{constructor(O,N=()=>Date.now()){this.d=O,this.f=N,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.$ph=K;var te;(function(R){R[R.Resolved=0]="Resolved",R[R.Rejected=1]="Rejected"})(te||(te={}));class H{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((O,N)=>{this.a=O,this.b=N})}complete(O){return new Promise(N=>{this.a(O),this.d={outcome:0,value:O},N()})}error(O){return new Promise(N=>{this.b(O),this.d={outcome:1,value:O},N()})}cancel(){return this.error(new L.$5)}}e.$qh=H;var x;(function(R){async function O(G){let Q;const ie=await Promise.all(G.map(ue=>ue.then($e=>$e,$e=>{Q||(Q=$e)})));if(typeof Q<"u")throw Q;return ie}R.settled=O;function N(G){return new Promise(async(Q,ie)=>{try{await G(Q,ie)}catch(ue){ie(ue)}})}R.withAsyncBody=N})(x||(e.Promises=x={}));class ge{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(O){this.a=void 0,this.b=void 0,this.d=!1,this.promise=O.then(N=>(this.a=N,this.d=!0,N),N=>{throw this.b=N,this.d=!0,N})}requireValue(){if(!this.d)throw new L.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=ge;class _{constructor(O){this.b=O,this.a=new u.$V(()=>new ge(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=_;var f;(function(R){R[R.Initial=0]="Initial",R[R.DoneOK=1]="DoneOK",R[R.DoneError=2]="DoneError"})(f||(f={}));class U{static fromArray(O){return new U(N=>{N.emitMany(O)})}static fromPromise(O){return new U(async N=>{N.emitMany(await O)})}static fromPromises(O){return new U(async N=>{await Promise.all(O.map(async G=>N.emitOne(await G)))})}static merge(O){return new U(async N=>{await Promise.all(O.map(async G=>{for await(const Q of G)N.emitOne(Q)}))})}static{this.EMPTY=U.fromArray([])}constructor(O){this.a=0,this.b=[],this.d=null,this.f=new k.$Vd,queueMicrotask(async()=>{const N={emitOne:G=>this.g(G),emitMany:G=>this.h(G),reject:G=>this.k(G)};try{await Promise.resolve(O(N)),this.j()}catch(G){this.k(G)}finally{N.emitOne=void 0,N.emitMany=void 0,N.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await k.Event.toPromise(this.f.event)}while(!0)}}}static map(O,N){return new U(async G=>{for await(const Q of O)G.emitOne(N(Q))})}map(O){return U.map(this,O)}static filter(O,N){return new U(async G=>{for await(const Q of O)N(Q)&&G.emitOne(Q)})}filter(O){return U.filter(this,O)}static coalesce(O){return U.filter(O,N=>!!N)}coalesce(){return U.coalesce(this)}static async toPromise(O){const N=[];for await(const G of O)N.push(G);return N}toPromise(){return U.toPromise(this)}g(O){this.a===0&&(this.b.push(O),this.f.fire())}h(O){this.a===0&&(this.b=this.b.concat(O),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(O){this.a===0&&(this.a=2,this.d=O,this.f.fire())}}e.$th=U;class re extends U{constructor(O,N){super(N),this.l=O}cancel(){this.l.cancel()}}e.$uh=re;function F(R){const O=new y.$6d,N=R(O.token);return new re(O,async G=>{const Q=O.token.onCancellationRequested(()=>{Q.dispose(),O.dispose(),G.reject(new L.$5)});try{for await(const ie of N){if(O.token.isCancellationRequested)return;G.emitOne(ie)}Q.dispose(),O.dispose()}catch(ie){Q.dispose(),O.dispose(),G.reject(ie)}})}e.$vh=F;class J{constructor(){this.a=new H,this.b=new U(G=>{if(O){G.reject(O);return}return N&&G.emitMany(N),this.d=Q=>G.reject(Q),this.f=Q=>G.emitOne(Q),this.a.p});let O,N;this.f=G=>{N||(N=[]),N.push(G)},this.d=G=>{O||(O=G)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(O){this.d(O),this.a.complete()}emitOne(O){this.f(O)}}e.$wh=J}),define(le[60],he([0,1,18,5]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function k(m){return m.toJSON()}class A{constructor(p){this.a=p}transformIncoming(p){const s=this.a.transformIncoming(p);return s===p?p:k(L.URI.from(s))}transformOutgoing(p){const s=this.a.transformOutgoing(p);return s===p?p:k(L.URI.from(s))}transformOutgoingURI(p){const s=this.a.transformOutgoing(p);return s===p?p:L.URI.from(s)}transformOutgoingScheme(p){return this.a.transformOutgoingScheme(p)}}e.$4m=A,e.$5m=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function I(m,p,s){if(!m||s>200)return null;if(typeof m=="object"){if(m instanceof L.URI)return p.transformOutgoing(m);for(const $ in m)if(Object.hasOwnProperty.call(m,$)){const l=I(m[$],p,s+1);l!==null&&(m[$]=l)}}return null}function E(m,p){const s=I(m,p,0);return s===null?m:s}e.$6m=E;function h(m,p,s,$){if(!m||$>200)return null;if(typeof m=="object"){if(m.$mid===1)return s?L.URI.revive(p.transformIncoming(m)):p.transformIncoming(m);if(m instanceof y.$je)return null;for(const l in m)if(Object.hasOwnProperty.call(m,l)){const a=h(m[l],p,s,$+1);a!==null&&(m[l]=a)}}return null}function u(m,p){const s=h(m,p,!1,0);return s===null?m:s}e.$7m=u;function P(m,p){const s=h(m,p,!0,0);return s===null?m:s}e.$8m=P}),define(le[24],he([0,1,104,20,105,9,32,45,7,3,23,5]),function(oe,e,y,L,k,A,I,E,h,u,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var p;(function(Y){Y[Y.UNLINK=0]="UNLINK",Y[Y.MOVE=1]="MOVE"})(p||(e.RimRafMode=p={}));async function s(Y,se=p.UNLINK,ce){if((0,I.$$f)(Y))throw new Error("rimraf - will refuse to recursively delete root");return se===p.UNLINK?l(Y):$(Y,ce)}async function $(Y,se=(0,I.$dg)((0,L.tmpdir)())){try{try{await y.promises.rename(Y,se)}catch(ce){return ce.code==="ENOENT"?void 0:l(Y)}l(se).catch(ce=>{})}catch(ce){if(ce.code!=="ENOENT")throw ce}}async function l(Y){return(0,k.promisify)(y.rm)(Y,{recursive:!0,force:!0,maxRetries:3})}function a(Y){if((0,I.$$f)(Y))throw new Error("rimraf - will refuse to recursively delete root");y.rmSync(Y,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function r(Y,se){return n(await(se?o(Y):(0,k.promisify)(y.readdir)(Y)))}async function o(Y){try{return await(0,k.promisify)(y.readdir)(Y,{withFileTypes:!0})}catch(fe){console.warn("[node.js fs] readdir with filetypes failed with error: ",fe)}const se=[],ce=await r(Y);for(const fe of ce){let X=!1,V=!1,K=!1;try{const te=await e.Promises.lstat((0,h.$jc)(Y,fe));X=te.isFile(),V=te.isDirectory(),K=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}se.push({name:fe,isFile:()=>X,isDirectory:()=>V,isSymbolicLink:()=>K})}return se}function d(Y){return n(y.readdirSync(Y))}e.readdirSync=d;function n(Y){return Y.map(se=>typeof se=="string"?u.$j?(0,E.$Gl)(se):se:(se.name=u.$j?(0,E.$Gl)(se.name):se.name,se))}async function t(Y){const se=await r(Y),ce=[];for(const fe of se)await w.existsDirectory((0,h.$jc)(Y,fe))&&ce.push(fe);return ce}function i(Y,se=1e3){return new Promise(ce=>{let fe=!1;const X=setInterval(()=>{fe||(fe=!0,y.access(Y,V=>{fe=!1,V&&(clearInterval(X),ce(void 0))}))},se)})}e.whenDeleted=i;var w;(function(Y){async function se(X){let V;try{if(V=await e.Promises.lstat(X),!V.isSymbolicLink())return{stat:V}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:V?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};if(u.$i&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&V)return{stat:V,symbolicLink:{dangling:!0}};throw te}throw K}}Y.stat=se;async function ce(X){try{const{stat:V,symbolicLink:K}=await Y.stat(X);return V.isFile()&&K?.dangling!==!0}catch{}return!1}Y.existsFile=ce;async function fe(X){try{const{stat:V,symbolicLink:K}=await Y.stat(X);return V.isDirectory()&&K?.dangling!==!0}catch{}return!1}Y.existsDirectory=fe})(w||(e.SymlinkSupport=w={}));const j=new A.$ch;function g(Y,se,ce){return j.queueFor(m.URI.file(Y),()=>{const fe=q(ce);return new Promise((X,V)=>D(Y,se,fe,K=>K?V(K):X()))},P.$yg)}let C=!0;function v(Y){C=Y}e.configureFlushOnWrite=v;function D(Y,se,ce,fe){if(!C)return y.writeFile(Y,se,{mode:ce.mode,flag:ce.flag},fe);y.open(Y,ce.flag,ce.mode,(X,V)=>{if(X)return fe(X);y.writeFile(V,se,K=>{if(K)return y.close(V,()=>fe(K));y.fdatasync(V,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),v(!1)),y.close(V,H=>fe(H))))})})}function W(Y,se,ce){const fe=q(ce);if(!C)return y.writeFileSync(Y,se,{mode:fe.mode,flag:fe.flag});const X=y.openSync(Y,fe.flag,fe.mode);try{y.writeFileSync(X,se);try{y.fdatasyncSync(X)}catch(V){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",V),v(!1)}}finally{y.closeSync(X)}}e.writeFileSync=W;function q(Y){return Y?{mode:typeof Y.mode=="number"?Y.mode:438,flag:typeof Y.flag=="string"?Y.flag:"w"}:{mode:438,flag:"w"}}async function c(Y,se,ce=6e4){if(Y!==se)try{u.$i&&typeof ce=="number"?await b(Y,se,Date.now(),ce):await(0,k.promisify)(y.rename)(Y,se)}catch(fe){if(Y.toLowerCase()!==se.toLowerCase()&&fe.code==="EXDEV"||Y.endsWith("."))await S(Y,se,{preserveSymlinks:!1}),await s(Y,p.MOVE);else throw fe}}async function b(Y,se,ce,fe,X=0){try{return await(0,k.promisify)(y.rename)(Y,se)}catch(V){if(V.code!=="EACCES"&&V.code!=="EPERM"&&V.code!=="EBUSY")throw V;if(Date.now()-ce>=fe)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${V}`),V;if(X===0){let K=!1;try{const{stat:te}=await w.stat(se);te.isFile()||(K=!0)}catch{}if(K)throw V}return await(0,A.$7g)(Math.min(100,X*10)),b(Y,se,ce,fe,X+1)}}async function S(Y,se,ce){return M(Y,se,{root:{source:Y,target:se},options:ce,handledSourcePaths:new Set})}const B=511;async function M(Y,se,ce){if(ce.handledSourcePaths.has(Y))return;ce.handledSourcePaths.add(Y);const{stat:fe,symbolicLink:X}=await w.stat(Y);if(X){if(ce.options.preserveSymlinks)try{return await ne(Y,se,ce)}catch{}if(X.dangling)return}return fe.isDirectory()?z(Y,se,fe.mode&B,ce):ee(Y,se,fe.mode&B)}async function z(Y,se,ce,fe){await e.Promises.mkdir(se,{recursive:!0,mode:ce});const X=await r(Y);for(const V of X)await M((0,h.$jc)(Y,V),(0,h.$jc)(se,V),fe)}async function ee(Y,se,ce){await e.Promises.copyFile(Y,se),await e.Promises.chmod(se,ce)}async function ne(Y,se,ce){let fe=await e.Promises.readlink(Y);(0,I.$8f)(fe,ce.root.source,!u.$k)&&(fe=(0,h.$jc)(ce.root.target,fe.substr(ce.root.source.length+1))),await e.Promises.symlink(fe,se)}e.Promises=new class{get access(){return(0,k.promisify)(y.access)}get stat(){return(0,k.promisify)(y.stat)}get lstat(){return(0,k.promisify)(y.lstat)}get utimes(){return(0,k.promisify)(y.utimes)}get read(){return(Y,se,ce,fe,X)=>new Promise((V,K)=>{y.read(Y,se,ce,fe,X,(te,H,x)=>te?K(te):V({bytesRead:H,buffer:x}))})}get readFile(){return(0,k.promisify)(y.readFile)}get write(){return(Y,se,ce,fe,X)=>new Promise((V,K)=>{y.write(Y,se,ce,fe,X,(te,H,x)=>te?K(te):V({bytesWritten:H,buffer:x}))})}get appendFile(){return(0,k.promisify)(y.appendFile)}get fdatasync(){return(0,k.promisify)(y.fdatasync)}get truncate(){return(0,k.promisify)(y.truncate)}get copyFile(){return(0,k.promisify)(y.copyFile)}get open(){return(0,k.promisify)(y.open)}get close(){return(0,k.promisify)(y.close)}get symlink(){return(0,k.promisify)(y.symlink)}get readlink(){return(0,k.promisify)(y.readlink)}get chmod(){return(0,k.promisify)(y.chmod)}get mkdir(){return(0,k.promisify)(y.mkdir)}get unlink(){return(0,k.promisify)(y.unlink)}get rmdir(){return(0,k.promisify)(y.rmdir)}get realpath(){return(0,k.promisify)(y.realpath)}async exists(Y){try{return await e.Promises.access(Y),!0}catch{return!1}}get readdir(){return r}get readDirsInDir(){return t}get writeFile(){return g}get rm(){return s}get rename(){return c}get copy(){return S}}}),define(le[61],he([0,1,20,7,24]),function(oe,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ql=e.$Pl=void 0;const A=/^\d+$/,I=/^Microsoft.PowerShell_.*/,E=/^Microsoft.PowerShellPreview_.*/;var h;(function(n){n[n.x64=0]="x64",n[n.x86=1]="x86",n[n.ARM=2]="ARM"})(h||(h={}));let u;switch(process.arch){case"ia32":u=1;break;case"arm":case"arm64":u=2;break;default:u=0;break}let P;process.env.PROCESSOR_ARCHITEW6432?P=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?P=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?P=1:P=0;class m{constructor(t,i,w){this.exePath=t,this.displayName=i,this.a=w}async exists(){return this.a===void 0&&(this.a=await k.SymlinkSupport.existsFile(this.exePath)),this.a}}function p({useAlternateBitness:n=!1}={}){return n?u===0?process.env["ProgramFiles(x86)"]||null:P===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function s({useAlternateBitness:n=!1,findPreview:t=!1}={}){const i=p({useAlternateBitness:n});if(!i)return null;const w=L.$jc(i,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(w))return null;let j=-1,g=null;for(const D of await k.Promises.readdir(w)){let W=-1;if(t){const c=D.indexOf("-");if(c<0)continue;const b=D.substring(0,c);if(!A.test(b)||D.substring(c+1)!=="preview")continue;W=parseInt(b,10)}else{if(!A.test(D))continue;W=parseInt(D,10)}if(W<=j)continue;const q=L.$jc(w,D,"pwsh.exe");await k.SymlinkSupport.existsFile(q)&&(g=q,j=W)}if(!g)return null;const C=i.includes("x86")?" (x86)":"",v=t?" Preview":"";return new m(g,`PowerShell${v}${C}`,!0)}async function $({findPreview:n}={}){if(!process.env.LOCALAPPDATA)return null;const t=L.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(t))return null;const{pwshMsixDirRegex:i,pwshMsixName:w}=n?{pwshMsixDirRegex:E,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const j of await k.Promises.readdir(t))if(i.test(j)){const g=L.$jc(t,j,"pwsh.exe");return new m(g,w)}return null}function l(){const n=L.$jc(y.homedir(),".dotnet","tools","pwsh.exe");return new m(n,".NET Core PowerShell Global Tool")}function a(){const n=L.$jc(process.env.windir,u===1&&P!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(n,"Windows PowerShell",!0)}async function*r(){let n=await s();n&&(yield n),n=await s({useAlternateBitness:!0}),n&&(yield n),n=await $(),n&&(yield n),n=l(),n&&(yield n),n=await s({findPreview:!0}),n&&(yield n),n=await $({findPreview:!0}),n&&(yield n),n=await s({useAlternateBitness:!0,findPreview:!0}),n&&(yield n),n=a(),n&&(yield n)}async function*o(){for await(const n of r())await n.exists()&&(yield n)}e.$Pl=o;async function d(){for await(const n of o())return n;return null}e.$Ql=d}),define(le[34],he([0,1,7,3,15,33,8,24]),function(oe,e,y,L,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return A.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return A.TerminateResponseCode}});function h(m=k.env){return m.comspec||"cmd.exe"}e.$Tl=h;function u(m){let p=[],s=!1;const $=function(l){if(s){p.push(l);return}(!m.send(l,r=>{if(r&&console.error(r),s=!1,p.length>0){const o=p.slice(0);p=[],o.forEach(d=>$(d))}})||L.$i)&&(s=!0)};return{send:$}}e.$Ul=u;var P;(function(m){async function p(s,$,l){if(y.$ic(s))return s;if($===void 0&&($=k.cwd()),y.$mc(s)!=="."||(l===void 0&&I.$If(k.env.PATH)&&(l=k.env.PATH.split(y.$tc)),l===void 0||l.length===0))return y.$jc($,s);async function r(o){if(await E.Promises.exists(o)){let d;try{d=await E.Promises.stat(o)}catch(n){n.message.startsWith("EACCES")&&(d=await E.Promises.lstat(o))}return d?!d.isDirectory():!1}return!1}for(const o of l){let d;if(y.$ic(o)?d=y.$jc(o,s):d=y.$jc($,o,s),await r(d))return d;let n=d+".com";if(await r(n)||(n=d+".exe",await r(n)))return n}return y.$jc($,s)}m.findExecutable=p})(P||(e.win32=P={}))}),define(le[62],he([0,1,26,19]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;function k(I){return new Promise((E,h)=>{let u;const P=new Map;function m(s,$,l,a,r){const o=P.get($);if(s===I||o){const d={name:p(l),cmd:l,pid:s,ppid:$,load:a,mem:r};P.set(s,d),s===I&&(u=d),o&&(o.children||(o.children=[]),o.children.push(d),o.children.length>1&&(o.children=o.children.sort((n,t)=>n.pid-t.pid)))}}function p(s){const $=/--utility-sub-type=network/i,l=/--crashes-directory/i,a=/\\pipe\\winpty-control/i,r=/conhost\.exe.+--headless/i,o=/--type=([a-zA-Z-]+)/;if(l.exec(s))return"electron-crash-reporter";if(a.exec(s))return"winpty-agent";if(r.exec(s))return"conpty-agent";let d=o.exec(s);if(d&&d.length===2)return d[1]==="renderer"?"window":d[1]==="utility"?$.exec(s)?"utility-network-service":"utility-process":d[1]==="extensionHost"?"extension-host":d[1];const n=/[a-zA-Z-]+\.js/g;let t="";do d=n.exec(s),d&&(t+=d+" ");while(d);return t&&s.indexOf("node ")<0&&s.indexOf("node.exe")<0?`electron-nodejs (${t})`:s}if(process.platform==="win32"){const s=$=>$.indexOf("\\\\?\\")===0||$.indexOf("\\??\\")===0?$.substring(4):$.indexOf('"\\\\?\\')===0||$.indexOf('"\\??\\')===0?'"'+$.substring(5):$;new Promise(($,l)=>{oe(["@vscode/windows-process-tree"],$,l)}).then($=>{$.getProcessList(I,l=>{if(!l){h(new Error(`Root process ${I} not found`));return}$.getProcessCpuUsage(l,a=>{const r=new Map;a.forEach(o=>{const d=s(o.commandLine||"");r.set(o.pid,{name:p(d),cmd:d,pid:o.pid,ppid:o.ppid,load:o.cpu||0,mem:o.memory||0})}),u=r.get(I),u?(r.forEach(o=>{const d=r.get(o.ppid);d&&(d.children||(d.children=[]),d.children.push(o))}),r.forEach(o=>{o.children&&(o.children=o.children.sort((d,n)=>d.pid-n.pid))}),E(u)):h(new Error(`Root process ${I} not found`))})},$.ProcessDataFlag.CommandLine|$.ProcessDataFlag.Memory)})}else{let s=function(){let $=[u];const l=[];for(;$.length;){const r=$.shift();r&&(l.push(r.pid),r.children&&($=$.concat(r.children)))}let a=JSON.stringify(L.$og.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+l.join(" "),(0,y.exec)(a,{},(r,o,d)=>{if(r||d)h(r||new Error(d.toString()));else{const n=o.toString().split(`
`);for(let t=0;t<l.length;t++){const i=P.get(l[t]);i.load=parseFloat(n[t])}if(!u){h(new Error(`Root process ${I} not found`));return}E(u)}})};(0,y.exec)("which ps",{},($,l,a)=>{if($||a)if(process.platform!=="linux")h($||new Error(a.toString()));else{const r=JSON.stringify(L.$og.asFileUri("vs/base/node/ps.sh").fsPath);(0,y.exec)(r,{},(o,d,n)=>{o||n?h(o||new Error(n.toString())):(A(d,m),s())})}else{const r=l.toString().trim(),o="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,y.exec)(`${r} ${o}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,n,t)=>{d||t&&!t.includes("screen size is bogus")?h(d||new Error(t.toString())):(A(n,m),process.platform==="linux"?s():u?E(u):h(new Error(`Root process ${I} not found`)))})}})}})}e.$5r=k;function A(I,E){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,u=I.toString().split(`
`);for(const P of u){const m=h.exec(P.trim());m&&m.length===6&&E(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(le[63],he([0,1,20,3,61,34]),function(oe,e,y,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vl=void 0;async function I(m,p){return m===1?L.$i?P():A.$Tl(p):h(m,p)}e.$Vl=I;let E=null;function h(m,p){if(L.$k&&m===2||L.$j&&m===3)return"/bin/bash";if(!E){let s;if(L.$i)s="/bin/bash";else{if(s=p.SHELL,!s)try{s=(0,y.userInfo)().shell}catch{}s||(s="sh"),s==="/bin/false"&&(s="/bin/bash")}E=s}return E}let u=null;async function P(){return u||(u=(await(0,k.$Ql)()).exePath),u}});var me=this&&this.__decorate||function(oe,e,y,L){var k=arguments.length,A=k<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,y):L,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(oe,e,y,L);else for(var E=oe.length-1;E>=0;E--)(I=oe[E])&&(A=(k<3?I(A):k>3?I(e,y,A):I(e,y))||A);return k>3&&A&&Object.defineProperty(e,y,A),A};define(le[27],he([0,1,16,9,18,17,14,6,4,2,59,11,8]),function(oe,e,y,L,k,A,I,E,h,u,P,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var s;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(s||(s={}));function $(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var l;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(l||(l={}));function a(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var r;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(r||(r={}));function o(X){let V=0;for(let K=0;;K+=7){const te=X.read(1);if(V|=(te.buffer[0]&127)<<K,!(te.buffer[0]&128))return V}}const d=j(0);function n(X,V){if(V===0){X.write(d);return}let K=0;for(let H=V;H!==0;H=H>>>7)K++;const te=k.$je.alloc(K);for(let H=0;V!==0;H++)te.buffer[H]=V&127,V=V>>>7,V>0&&(te.buffer[H]|=128);X.write(te)}class t{constructor(V){this.b=V,this.a=0}read(V){const K=this.b.slice(this.a,this.a+V);return this.a+=K.byteLength,K}}e.$Dh=t;class i{constructor(){this.a=[]}get buffer(){return k.$je.concat(this.a)}write(V){this.a.push(V)}}e.$Eh=i;var w;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(w||(w={}));function j(X){const V=k.$je.alloc(1);return V.writeUInt8(X,0),V}const g={Undefined:j(w.Undefined),String:j(w.String),Buffer:j(w.Buffer),VSBuffer:j(w.VSBuffer),Array:j(w.Array),Object:j(w.Object),Uint:j(w.Int)},C=typeof Buffer<"u";function v(X,V){if(typeof V>"u")X.write(g.Undefined);else if(typeof V=="string"){const K=k.$je.fromString(V);X.write(g.String),n(X,K.byteLength),X.write(K)}else if(C&&Buffer.isBuffer(V)){const K=k.$je.wrap(V);X.write(g.Buffer),n(X,K.byteLength),X.write(K)}else if(V instanceof k.$je)X.write(g.VSBuffer),n(X,V.byteLength),X.write(V);else if(Array.isArray(V)){X.write(g.Array),n(X,V.length);for(const K of V)v(X,K)}else if(typeof V=="number"&&(V|0)===V)X.write(g.Uint),n(X,V);else{const K=k.$je.fromString(JSON.stringify(V));X.write(g.Object),n(X,K.byteLength),X.write(K)}}e.$Fh=v;function D(X){switch(X.read(1).readUInt8(0)){case w.Undefined:return;case w.String:return X.read(o(X)).toString();case w.Buffer:return X.read(o(X)).buffer;case w.VSBuffer:return X.read(o(X));case w.Array:{const K=o(X),te=[];for(let H=0;H<K;H++)te.push(D(X));return te}case w.Object:return JSON.parse(X.read(o(X)).toString());case w.Int:return o(X)}}e.$Gh=D;class W{constructor(V,K,te=null,H=1e3){this.h=V,this.j=K,this.k=te,this.l=H,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(x=>this.q(x)),this.m({type:200})}registerChannel(V,K){this.b.set(V,K),setTimeout(()=>this.w(V),0)}m(V){switch(V.type){case 200:{const K=this.o([V.type]);this.k?.logOutgoing(K,0,1,a(V.type));return}case 201:case 202:case 204:case 203:{const K=this.o([V.type,V.id],V.data);this.k?.logOutgoing(K,V.id,1,a(V.type),V.data);return}}}o(V,K=void 0){const te=new i;return v(te,V),v(te,K),this.p(te.buffer)}p(V){try{return this.h.send(V),V.byteLength}catch{return 0}}q(V){const K=new t(V),te=D(K),H=D(K),x=te[0];switch(x){case 100:return this.k?.logIncoming(V.byteLength,te[1],1,`${$(x)}: ${te[2]}.${te[3]}`,H),this.s({type:x,id:te[1],channelName:te[2],name:te[3],arg:H});case 102:return this.k?.logIncoming(V.byteLength,te[1],1,`${$(x)}: ${te[2]}.${te[3]}`,H),this.t({type:x,id:te[1],channelName:te[2],name:te[3],arg:H});case 101:return this.k?.logIncoming(V.byteLength,te[1],1,`${$(x)}`),this.u({type:x,id:te[1]});case 103:return this.k?.logIncoming(V.byteLength,te[1],1,`${$(x)}`),this.u({type:x,id:te[1]})}}s(V){const K=this.b.get(V.channelName);if(!K){this.v(V);return}const te=new A.$6d;let H;try{H=K.call(this.j,V.name,V.arg,te.token)}catch(_){H=Promise.reject(_)}const x=V.id;H.then(_=>{this.m({id:x,data:_,type:201})},_=>{_ instanceof Error?this.m({id:x,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.m({id:x,data:_,type:203})}).finally(()=>{ge.dispose(),this.d.delete(V.id)});const ge=(0,u.$Rc)(()=>te.cancel());this.d.set(V.id,ge)}t(V){const K=this.b.get(V.channelName);if(!K){this.v(V);return}const te=V.id,x=K.listen(this.j,V.name,V.arg)(ge=>this.m({id:te,data:ge,type:204}));this.d.set(V.id,x)}u(V){const K=this.d.get(V.id);K&&(K.dispose(),this.d.delete(V.id))}v(V){let K=this.g.get(V.channelName);K||(K=[],this.g.set(V.channelName,K));const te=setTimeout(()=>{console.error(`Unknown channel: ${V.channelName}`),V.type===100&&this.m({id:V.id,data:{name:"Unknown channel",message:`Channel name '${V.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);K.push({request:V,timeoutTimer:te})}w(V){const K=this.g.get(V);if(K){for(const te of K)switch(clearTimeout(te.timeoutTimer),te.request.type){case 100:this.s(te.request);break;case 102:this.t(te.request);break}this.g.delete(V)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,u.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=W;var q;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(q||(e.RequestInitiator=q={}));class c{constructor(V,K=null){this.l=V,this.a=!1,this.b=r.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(te=>this.s(te)),this.j=K}getChannel(V){const K=this;return{call(te,H,x){return K.a?Promise.reject(new E.$5):K.m(V,te,H,x)},listen(te,H){return K.a?h.Event.None:K.o(V,te,H)}}}m(V,K,te,H=A.CancellationToken.None){const x=this.g++,_={id:x,type:100,channelName:V,name:K,arg:te};if(H.isCancellationRequested)return Promise.reject(new E.$5);let f;return new Promise((re,F)=>{if(H.isCancellationRequested)return F(new E.$5);const J=()=>{const G=Q=>{switch(Q.type){case 201:this.f.delete(x),re(Q.data);break;case 202:{this.f.delete(x);const ie=new Error(Q.data.message);ie.stack=Array.isArray(Q.data.stack)?Q.data.stack.join(`
`):Q.data.stack,ie.name=Q.data.name,F(ie);break}case 203:this.f.delete(x),F(Q.data);break}};this.f.set(x,G),this.p(_)};let R=null;this.b===r.Idle?J():(R=(0,L.$Tg)(G=>this.u()),R.then(()=>{R=null,J()}));const O=()=>{R?(R.cancel(),R=null):this.p({id:x,type:101}),F(new E.$5)},N=H.onCancellationRequested(O);f=(0,u.$Qc)((0,u.$Rc)(O),N),this.d.add(f)}).finally(()=>{f.dispose(),this.d.delete(f)})}o(V,K,te){const H=this.g++,ge={id:H,type:102,channelName:V,name:K,arg:te};let _=null;const f=new h.$Vd({onWillAddFirstListener:()=>{_=(0,L.$Tg)(re=>this.u()),_.then(()=>{_=null,this.d.add(f),this.p(ge)})},onDidRemoveLastListener:()=>{_?(_.cancel(),_=null):(this.d.delete(f),this.p({id:H,type:103}))}}),U=re=>f.fire(re.data);return this.f.set(H,U),f.event}p(V){switch(V.type){case 100:case 102:{const K=this.q([V.type,V.id,V.channelName,V.name],V.arg);this.j?.logOutgoing(K,V.id,0,`${$(V.type)}: ${V.channelName}.${V.name}`,V.arg);return}case 101:case 103:{const K=this.q([V.type,V.id]);this.j?.logOutgoing(K,V.id,0,$(V.type));return}}}q(V,K=void 0){const te=new i;return v(te,V),v(te,K),this.r(te.buffer)}r(V){try{return this.l.send(V),V.byteLength}catch{return 0}}s(V){const K=new t(V),te=D(K),H=D(K),x=te[0];switch(x){case 200:return this.j?.logIncoming(V.byteLength,0,0,a(x)),this.t({type:te[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(V.byteLength,te[1],0,a(x),H),this.t({type:te[0],id:te[1],data:H})}}t(V){if(V.type===200){this.b=r.Idle,this.k.fire();return}this.f.get(V.id)?.(V)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===r.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,u.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=c,me([I.$xh],c.prototype,"onDidInitializePromise",null);class b{get connections(){const V=[];return this.f.forEach(K=>V.push(K)),V}constructor(V){this.a=new Map,this.f=new Set,this.g=new h.$Vd,this.onDidAddConnection=this.g.event,this.h=new h.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new u.$Sc,this.j.add(V(({protocol:K,onDidClientDisconnect:te})=>{const H=h.Event.once(K.onMessage);this.j.add(H(x=>{const ge=new t(x),_=D(ge),f=new W(K,_),U=new c(K);this.a.forEach((F,J)=>f.registerChannel(J,F));const re={channelServer:f,channelClient:U,ctx:_};this.f.add(re),this.g.fire(re),this.j.add(te(()=>{f.dispose(),U.dispose(),this.f.delete(re),this.h.fire(re)}))}))}))}getChannel(V,K){const te=this;return{call(H,x,ge){let _;if((0,p.$Wf)(K)){const U=(0,y.$4b)(te.connections.filter(K));_=U?Promise.resolve(U):h.Event.toPromise(h.Event.filter(te.onDidAddConnection,K))}else _=K.routeCall(te,H,x);const f=_.then(U=>U.channelClient.getChannel(V));return B(f).call(H,x,ge)},listen(H,x){if((0,p.$Wf)(K))return te.k(V,K,H,x);const ge=K.routeEvent(te,H,x).then(_=>_.channelClient.getChannel(V));return B(ge).listen(H,x)}}}k(V,K,te,H){const x=this;let ge;const _=new h.$Vd({onWillAddFirstListener:()=>{ge=new u.$Sc;const f=new h.$2d,U=new Map,re=J=>{const O=J.channelClient.getChannel(V).listen(te,H),N=f.add(O);U.set(J,N)},F=J=>{const R=U.get(J);R&&(R.dispose(),U.delete(J))};x.connections.filter(K).forEach(re),h.Event.filter(x.onDidAddConnection,K)(re,void 0,ge),x.onDidRemoveConnection(F,void 0,ge),f.event(_.fire,_,ge),ge.add(f)},onDidRemoveLastListener:()=>{ge?.dispose(),ge=void 0}});return _.event}registerChannel(V,K){this.a.set(V,K);for(const te of this.f)te.channelServer.registerChannel(V,K)}dispose(){this.j.dispose();for(const V of this.f)V.channelClient.dispose(),V.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=b;class S{constructor(V,K,te=null){const H=new i;v(H,K),V.send(H.buffer),this.a=new c(V,te),this.d=new W(V,K,te)}getChannel(V){return this.a.getChannel(V)}registerChannel(V,K){this.d.registerChannel(V,K)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=S;function B(X){return{call(V,K,te){return X.then(H=>H.call(V,K,te))},listen(V,K){const te=new h.$5d;return X.then(H=>te.input=H.listen(V,K)),te.event}}}e.$Lh=B;function M(X){let V=!1;return{call(K,te,H){return V?X.call(K,te,H):(0,L.$7g)(0).then(()=>V=!0).then(()=>X.call(K,te,H))},listen(K,te){if(V)return X.listen(K,te);const H=new h.$5d;return(0,L.$7g)(0).then(()=>V=!0).then(()=>H.input=X.listen(K,te)),H.event}}}e.$Mh=M;class z{constructor(V){this.a=V}routeCall(V){return this.b(V)}routeEvent(V){return this.b(V)}async b(V){for(const K of V.connections)if(await Promise.resolve(this.a(K.ctx)))return Promise.resolve(K);return await h.Event.toPromise(V.onDidAddConnection),await this.b(V)}}e.$Nh=z;var ee;(function(X){function V(x,ge,_){const f=x,U=_&&_.disableMarshalling,re=new Map;for(const F in f)te(F)&&re.set(F,h.Event.buffer(f[F],!0,void 0,ge));return new class{listen(F,J,R){const O=re.get(J);if(O)return O;if(H(J)){const N=f[J];if(typeof N=="function")return N.call(f,R)}throw new E.$bb(`Event not found: ${J}`)}call(F,J,R){const O=f[J];if(typeof O=="function"){if(!U&&Array.isArray(R))for(let G=0;G<R.length;G++)R[G]=(0,P.$Ch)(R[G]);let N=O.apply(f,R);return N instanceof Promise||(N=Promise.resolve(N)),N}throw new E.$bb(`Method not found: ${J}`)}}}X.fromService=V;function K(x,ge){const _=ge&&ge.disableMarshalling;return new Proxy({},{get(f,U){if(typeof U=="string")return ge?.properties?.has(U)?ge.properties.get(U):H(U)?function(re){return x.listen(U,re)}:te(U)?x.listen(U):async function(...re){let F;ge&&!(0,p.$Rf)(ge.context)?F=[ge.context,...re]:F=re;const J=await x.call(U,F);return _?J:(0,P.$Ch)(J)};throw new E.$bb(`Property not found: ${String(U)}`)}})}X.toService=K;function te(x){return x[0]==="o"&&x[1]==="n"&&m.$$e(x.charCodeAt(2))}function H(x){return/^onDynamic/.test(x)&&m.$$e(x.charCodeAt(9))}})(ee||(e.ProxyChannel=ee={}));const ne=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Y(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const V=X.toString();if(V!=="[object Object]")return V}return X}function se(X){return Array.isArray(X)?X.map(Y):Y(X)}function ce(X,V,K,te,H,x,ge){ge=se(ge);const _=ne[H],f=_[te%_.length];let U=[`%c[${X}]%c[${String(V).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(te).padStart(5," ")} - ${x}`,"color: darkgreen","color: grey","color: grey",`color: ${f}`];/\($/.test(x)?(U=U.concat(ge),U.push(")")):U.push(ge),console.log.apply(console,U)}class fe{constructor(V,K){this.d=V,this.f=K,this.a=0,this.b=0}logOutgoing(V,K,te,H,x){this.b+=V,ce(this.d,this.b,V,K,te,H,x)}logIncoming(V,K,te,H,x){this.a+=V,ce(this.f,this.a,V,K,te,H,x)}}e.$Oh=fe}),define(le[64],he([0,1,26,9,18,17,58,6,4,2,30,34,33,27]),function(oe,e,y,L,k,A,I,E,h,u,P,m,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class $ extends s.$Hh{constructor(r){super({send:o=>{try{process.send?.(o.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",o=>k.$je.wrap(Buffer.from(o,"base64")))},r),process.once("disconnect",()=>this.dispose())}}e.$qq=$;class l{constructor(r,o){this.i=r,this.j=o,this.c=new Set,this.g=new Map,this.h=new h.$Vd,this.onDidProcessExit=this.h.event;const d=o&&o.timeout?o.timeout:6e4;this.b=new L.$3g(d),this.d=null,this.f=null}getChannel(r){const o=this;return{call(d,n,t){return o.k(r,d,n,t)},listen(d,n){return o.l(r,d,n)}}}k(r,o,d,n=A.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(E.$6());this.b.cancel();const t=this.n(r),i=(0,L.$Tg)(g=>t.call(o,d,g)),w=n.onCancellationRequested(()=>i.cancel()),j=(0,u.$Rc)(()=>i.cancel());return this.c.add(j),i.finally(()=>{w.dispose(),this.c.delete(j),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),i}l(r,o,d){if(!this.b)return h.Event.None;this.b.cancel();let n;const t=new h.$Vd({onWillAddFirstListener:()=>{n=this.n(r).listen(o,d)(t.fire,t),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return t.event}get m(){if(!this.f){const r=this.j&&this.j.args?this.j.args:[],o=Object.create(null);o.env={...(0,P.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(o.env={...o.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(o.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(o.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(o.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),o.execArgv===void 0&&(o.execArgv=process.execArgv.filter(C=>!/^--inspect(-brk)?=/.test(C)).filter(C=>!C.startsWith("--vscode-"))),(0,p.$Sl)(o.env),this.d=(0,y.fork)(this.i,r,o);const d=new h.$Vd;h.Event.fromNodeEventEmitter(this.d,"message",C=>C)(C=>{if((0,I.$mq)(C)){(0,I.log)(C,`IPC Library: ${this.j.serverName}`);return}d.fire(k.$je.wrap(Buffer.from(C,"base64")))});const t=this.j.useQueue?(0,m.$Ul)(this.d):this.d,i=C=>this.d&&this.d.connected&&t.send(C.buffer.toString("base64")),w=d.event,j={send:i,onMessage:w};this.f=new s.$Ih(j);const g=()=>this.o();process.once("exit",g),this.d.on("error",C=>console.warn('IPC "'+this.j.serverName+'" errored with '+C)),this.d.on("exit",(C,v)=>{process.removeListener("exit",g),this.c.forEach(D=>(0,u.$Oc)(D)),this.c.clear(),C!==0&&v!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+C+" and signal "+v),this.b?.cancel(),this.o(),this.h.fire({code:C,signal:v})})}return this.f}n(r){let o=this.g.get(r);return o||(o=this.m.getChannel(r),this.g.set(r,o)),o}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=l}),define(le[65],he([0,1,31,18,27,4,8,16]),function(oe,e,y,L,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$OU=e.$NU=void 0;class h{constructor(p){this.a=p,this.onMessage=A.Event.fromNodeEventEmitter(this.a,"message",s=>s.data?L.$je.wrap(s.data):L.$je.alloc(0)),p.start()}send(p){this.a.postMessage(p.buffer)}disconnect(){this.a.close()}}class u extends k.$Jh{static b(p){(0,I.$Sf)((0,y.$MU)(process),"Electron Utility Process");const s=new A.$Vd;return process.parentPort.on("message",$=>{if(p?.handledClientConnection($))return;const l=(0,E.$Ob)($.ports);l&&s.fire(l)}),A.Event.map(s.event,$=>({protocol:new h($),onDidClientDisconnect:A.Event.fromNodeEventEmitter($,"close")}))}constructor(p){super(u.b(p))}}e.$NU=u;function P(m,p,s){const $=l=>{l.data===p&&(m.removeListener("message",$),s())};m.on("message",$)}e.$OU=P}),define(le[66],he([13,12]),function(oe,e){return oe.create("vs/platform/contextkey/common/contextkey",e)}),define(le[67],he([13,12]),function(oe,e){return oe.create("vs/platform/contextkey/common/scanner",e)}),define(le[68],he([13,12]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(le[69],he([13,12]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(le[70],he([13,12]),function(oe,e){return oe.create("vs/platform/terminal/node/ptyService",e)}),define(le[71],he([13,12]),function(oe,e){return oe.create("vs/platform/terminal/node/terminalProcess",e)}),define(le[72],he([0,1,6,67]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var k;(function(u){u[u.LParen=0]="LParen",u[u.RParen=1]="RParen",u[u.Neg=2]="Neg",u[u.Eq=3]="Eq",u[u.NotEq=4]="NotEq",u[u.Lt=5]="Lt",u[u.LtEq=6]="LtEq",u[u.Gt=7]="Gt",u[u.GtEq=8]="GtEq",u[u.RegexOp=9]="RegexOp",u[u.RegexStr=10]="RegexStr",u[u.True=11]="True",u[u.False=12]="False",u[u.In=13]="In",u[u.Not=14]="Not",u[u.And=15]="And",u[u.Or=16]="Or",u[u.Str=17]="Str",u[u.QuotedStr=18]="QuotedStr",u[u.Error=19]="Error",u[u.EOF=20]="EOF"})(k||(e.TokenType=k={}));function A(...u){switch(u.length){case 1:return(0,L.localize)(0,null,u[0]);case 2:return(0,L.localize)(1,null,u[0],u[1]);case 3:return(0,L.localize)(2,null,u[0],u[1],u[2]);default:return}}const I=(0,L.localize)(3,null),E=(0,L.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(P){switch(P.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return P.isTripleEq?"===":"==";case 4:return P.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return P.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return P.lexeme;case 18:return P.lexeme;case 19:return P.lexeme;case 20:return"EOF";default:throw(0,y.$8)(`unhandled token type: ${JSON.stringify(P)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(P=>P.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(P){return this.c=P,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const m=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:m})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const m=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:m})}else this.h(126)?this.k(9):this.l(A("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(A("&&"));break;case 124:this.h(124)?this.k(16):this.l(A("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(P){return this.r()||this.c.charCodeAt(this.e)!==P?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(P){this.f.push({type:P,offset:this.d})}l(P){const m=this.d,p=this.c.substring(this.d,this.e),s={type:19,offset:this.d,lexeme:p};this.g.push({offset:m,lexeme:p,additionalInfo:P}),this.f.push(s)}n(){this.m.lastIndex=this.d;const P=this.m.exec(this.c);if(P){this.e=this.d+P[0].length;const m=this.c.substring(this.d,this.e),p=h.b.get(m);p?this.k(p):this.f.push({type:17,lexeme:m,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(I);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let P=this.e,m=!1,p=!1;for(;;){if(P>=this.c.length){this.e=P,this.l(E);return}const $=this.c.charCodeAt(P);if(m)m=!1;else if($===47&&!p){P++;break}else $===91?p=!0:$===92?m=!0:$===93&&(p=!1);P++}for(;P<this.c.length&&h.a.has(this.c.charCodeAt(P));)P++;this.e=P;const s=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:s,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=h}),define(le[73],he([0,1,54,14,19,7,15,23,5]),function(oe,e,y,L,k,A,I,E,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Am=e.$zm=e.$ym=e.$xm=void 0,e.$xm=/^([^.]+\..+)[:=](.+)$/;class u{get appRoot(){return(0,A.$mc)(k.$og.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,E.$Hg)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:k.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,E.$Hg)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const s=(0,y.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.$jc)(this.userDataPath,"logs",s)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,E.$Hg)(h.URI.file((0,A.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,E.$Hg)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,E.$Hg)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,E.$Hg)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const s=I.env.VSCODE_PORTABLE;return s?h.URI.file((0,A.$jc)(s,"argv.json")):(0,E.$Hg)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,A.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const s=this.args["builtin-extensions-dir"];return s?(0,A.$kc)(s):(0,A.$hc)((0,A.$jc)(k.$og.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const s=this.args["extensions-download-dir"];return s?h.URI.file((0,A.$kc)(s)):h.URI.file((0,A.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const s=this.args["extensions-dir"];if(s)return(0,A.$kc)(s);const $=I.env.VSCODE_EXTENSIONS;if($)return $;const l=I.env.VSCODE_PORTABLE;return l?(0,A.$jc)(l,"extensions"):(0,E.$Hg)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const s=this.args.extensionDevelopmentPath;if(Array.isArray(s))return s.map($=>/^[^:/?#]+?:\/\//.test($)?h.URI.parse($):h.URI.file((0,A.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(s=>s==="ui"||s==="workspace"||s==="web"?s:"workspace")}get extensionTestsLocationURI(){const s=this.args.extensionTestsPath;if(s)return/^[^:/?#]+?:\/\//.test(s)?h.URI.parse(s):h.URI.file((0,A.$hc)(s))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const s=this.args["disable-extension"];if(s){if(typeof s=="string")return[s];if(Array.isArray(s)&&s.length>0)return s}return!1}get debugExtensionHost(){return P(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!I.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(s=>!e.$xm.test(s))}get extensionLogLevel(){const s=[];for(const $ of this.args.log||[]){const l=e.$xm.exec($);l&&l[1]&&l[2]&&s.push([l[1],l[2]])}return s.length?s:void 0}get serviceMachineIdResource(){return(0,E.$Hg)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const s=I.env.VSCODE_PORTABLE;return s?h.URI.file((0,A.$jc)(s,"policy.json")):(0,E.$Hg)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(s){this.args.continueOn=s}get args(){return this.a}constructor(s,$,l){this.a=s,this.b=$,this.c=l,this.editSessionId=this.args.editSessionId}}e.$ym=u,me([L.$xh],u.prototype,"appRoot",null),me([L.$xh],u.prototype,"userHome",null),me([L.$xh],u.prototype,"userDataPath",null),me([L.$xh],u.prototype,"appSettingsHome",null),me([L.$xh],u.prototype,"tmpDir",null),me([L.$xh],u.prototype,"cacheHome",null),me([L.$xh],u.prototype,"stateResource",null),me([L.$xh],u.prototype,"userRoamingDataHome",null),me([L.$xh],u.prototype,"userDataSyncHome",null),me([L.$xh],u.prototype,"sync",null),me([L.$xh],u.prototype,"machineSettingsResource",null),me([L.$xh],u.prototype,"workspaceStorageHome",null),me([L.$xh],u.prototype,"localHistoryHome",null),me([L.$xh],u.prototype,"keyboardLayoutResource",null),me([L.$xh],u.prototype,"argvResource",null),me([L.$xh],u.prototype,"isExtensionDevelopment",null),me([L.$xh],u.prototype,"untitledWorkspacesHome",null),me([L.$xh],u.prototype,"builtinExtensionsPath",null),me([L.$xh],u.prototype,"extensionsPath",null),me([L.$xh],u.prototype,"extensionDevelopmentLocationURI",null),me([L.$xh],u.prototype,"extensionDevelopmentKind",null),me([L.$xh],u.prototype,"extensionTestsLocationURI",null),me([L.$xh],u.prototype,"debugExtensionHost",null),me([L.$xh],u.prototype,"logLevel",null),me([L.$xh],u.prototype,"extensionLogLevel",null),me([L.$xh],u.prototype,"serviceMachineIdResource",null),me([L.$xh],u.prototype,"disableTelemetry",null),me([L.$xh],u.prototype,"disableWorkspaceTrust",null),me([L.$xh],u.prototype,"useInMemorySecretStorage",null),me([L.$xh],u.prototype,"policyFile",null);function P(p,s){return m(p["inspect-extensions"],p["inspect-brk-extensions"],5870,s,p.debugId,p.extensionEnvironment)}e.$zm=P;function m(p,s,$,l,a,r){const d=Number(s||p)||(l?null:$),n=d?!!s:!1;let t;if(r)try{t=JSON.parse(r)}catch{}return{port:d,break:n,debugId:a,env:t}}e.$Am=m}),define(le[74],he([0,1,106,3,68]),function(oe,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2l=e.$1l=e.$Zl=e.$Yl=e.$Xl=e.$Wl=void 0;const A={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.$Wl=["tunnel","serve-web"],e.$Xl={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},"serve-web":{type:"subcommand",description:"Run a server that displays the editor UI in browsers.",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,k.localize)(4,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(5,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(6,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(7,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(8,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(9,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(10,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(11,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(12,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(13,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,k.localize)(14,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(15,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(16,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(17,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},category:{type:"string",allowEmptyValue:!0,cat:"e",description:(0,k.localize)(19,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(20,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(21,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(22,null)},"update-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(23,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(24,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(25,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,k.localize)(26,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,k.localize)(27,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(28,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(29,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(30,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(31,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(32,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(33,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(34,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(35,null)},"disable-chromium-sandbox":{type:"boolean",cat:"t",description:(0,k.localize)(36,null)},sandbox:{type:"boolean"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(37,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"use-inmemory-secretstorage":{type:"boolean",deprecates:["disable-keytar"]},"password-store":{type:"string"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"preserve-env":{type:"boolean"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function E(l,a,r=I){const o=l.find(v=>v.length>0&&v[0]!=="-"),d={},n=["_"],t=[],i={};let w;for(const v in a){const D=a[v];D.type==="subcommand"?v===o&&(w=D):(D.alias&&(d[v]=D.alias),D.type==="string"||D.type==="string[]"?(n.push(v),D.deprecates&&n.push(...D.deprecates)):D.type==="boolean"&&(t.push(v),D.deprecates&&t.push(...D.deprecates)),D.global&&(i[v]=D))}if(w&&o){const v=i;for(const c in w.options)v[c]=w.options[c];const D=l.filter(c=>c!==o),W=r.getSubcommandReporter?r.getSubcommandReporter(o):void 0,q=E(D,v,W);return{[o]:q,_:[]}}const j=y(l,{string:n,boolean:t,alias:d}),g={},C=j;g._=j._.map(v=>String(v)).filter(v=>v.length>0),delete C._;for(const v in a){const D=a[v];if(D.type==="subcommand")continue;D.alias&&delete C[D.alias];let W=C[v];if(D.deprecates)for(const q of D.deprecates)C.hasOwnProperty(q)&&(W||(W=C[q],W&&r.onDeprecatedOption(q,D.deprecationMessage||(0,k.localize)(38,null,v))),delete C[q]);if(typeof W<"u"){if(D.type==="string[]"){if(Array.isArray(W)||(W=[W]),!D.allowEmptyValue){const q=W.filter(c=>c.length>0);q.length!==W.length&&(r.onEmptyValue(v),W=q.length>0?q:void 0)}}else D.type==="string"&&(Array.isArray(W)?(W=W.pop(),r.onMultipleValues(v,W)):!W&&!D.allowEmptyValue&&(r.onEmptyValue(v),W=void 0));g[v]=W,D.deprecationMessage&&r.onDeprecatedOption(v,D.deprecationMessage)}delete C[v]}for(const v in C)r.onUnknownOption(v);return g}e.$Yl=E;function h(l,a){let r="";return a.args&&(Array.isArray(a.args)?r=` <${a.args.join("> <")}>`:r=` <${a.args}>`),a.alias?`-${a.alias} --${l}${r}`:`--${l}${r}`}function u(l,a){const r=[];for(const o in l){const d=l[o],n=h(o,d);r.push([n,d.description])}return P(r,a)}e.$Zl=u;function P(l,a){const o=l.reduce((t,i)=>Math.max(t,i[0].length),12)+2+1;if(a-o<25)return l.reduce((t,i)=>t.concat([`  ${i[0]}`,`      ${i[1]}`]),[]);const d=a-o-1,n=[];for(const t of l){const i=t[0],w=p(t[1],d),j=m(o-i.length-2);n.push("  "+i+j+w[0]);for(let g=1;g<w.length;g++)n.push(m(o)+w[g])}return n}function m(l){return" ".repeat(l)}function p(l,a){const r=[];for(;l.length;){const o=l.length<a?l.length:l.lastIndexOf(" ",a),d=l.slice(0,o).trim();l=l.slice(o),r.push(d)}return r}function s(l,a,r,o,d){const n=process.stdout.isTTY&&process.stdout.columns||80,t=d?.noInputFiles!==!0?`[${(0,k.localize)(39,null)}...]`:"",i=[`${l} ${r}`];i.push(""),i.push(`${(0,k.localize)(40,null)}: ${a} [${(0,k.localize)(41,null)}]${t}`),i.push(""),d?.noPipe!==!0&&(L.$i?i.push((0,k.localize)(42,null,a)):i.push((0,k.localize)(43,null,a)),i.push(""));const w={},j=[];for(const g in o){const C=o[g];if(C.type==="subcommand")C.description&&j.push({command:g,description:C.description});else if(C.description&&C.cat){let v=w[C.cat];v||(w[C.cat]=v={}),v[g]=C}}for(const g in w){const C=g,v=w[C];v&&(i.push(A[C]),i.push(...u(v,n)),i.push(""))}return j.length&&(i.push((0,k.localize)(44,null)),i.push(...P(j.map(g=>[g.command,g.description]),n)),i.push("")),i.join(`
`)}e.$1l=s;function $(l,a){return`${l||(0,k.localize)(45,null)}
${a||(0,k.localize)(46,null)}
${process.arch}`}e.$2l=$}),function(){"use strict";function oe(e,y,L){function k(I,E){const h=A(I,E),u=[h];return e.isAbsolute(h)||u.unshift(L),e.resolve(...u)}function A(I,E){process.env.VSCODE_DEV&&(E="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let u=process.env.VSCODE_APPDATA;if(u)return e.join(u,E);const P=I["user-data-dir"];if(P)return P;switch(process.platform){case"win32":if(u=process.env.APPDATA,!u){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");u=e.join(m,"AppData","Roaming")}break;case"darwin":u=e.join(y.homedir(),"Library","Application Support");break;case"linux":u=process.env.XDG_CONFIG_HOME||e.join(y.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(u,E)}return{getUserDataPath:k}}if(typeof define=="function")define(le[75],he([76,20,15]),function(e,y,L){return oe(e,y,L.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),y=require("os");module.exports=oe(e,y,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[77],he([0,1,20,73,75]),function(oe,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dm=e.$Cm=e.$Bm=void 0;class A extends L.$ym{constructor(u,P){super(u,{homeDir:(0,y.homedir)(),tmpDir:(0,y.tmpdir)(),userDataDir:(0,k.getUserDataPath)(u,P.nameShort)},P)}}e.$Bm=A;function I(h,u){return(0,L.$Am)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,u,h.extensionEnvironment)}e.$Cm=I;function E(h,u){return(0,L.$Am)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,u,h.extensionEnvironment)}e.$Dm=E}),define(le[21],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var y;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function E(h){return h[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=E})(y||(e._util=y={})),e.$5h=k("instantiationService");function L(I,E,h){E[y.DI_TARGET]===E?E[y.DI_DEPENDENCIES].push({id:I,index:h}):(E[y.DI_DEPENDENCIES]=[{id:I,index:h}],E[y.DI_TARGET]=E)}function k(I){if(y.serviceIds.has(I))return y.serviceIds.get(I);const E=function(h,u,P){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(E,h,P)};return E.toString=()=>I,y.serviceIds.set(I,E),E}e.$6h=k;function A(I){return I}e.$7h=A}),define(le[35],he([0,1,3,11,72,21,66,6]),function(oe,e,y,L,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",y.$j),h.set("isLinux",y.$k),h.set("isWindows",y.$i),h.set("isWeb",y.$o),h.set("isMacNative",y.$j&&!y.$o),h.set("isEdge",y.$H),h.set("isFirefox",y.$F),h.set("isChrome",y.$E),h.set("isSafari",y.$G);function u(_,f){if(h.get(_)!==void 0)throw(0,E.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(_,f)}e.$2i=u;const P=Object.prototype.hasOwnProperty;var m;(function(_){_[_.False=0]="False",_[_.True=1]="True",_[_.Defined=2]="Defined",_[_.Not=3]="Not",_[_.Equals=4]="Equals",_[_.NotEquals=5]="NotEquals",_[_.And=6]="And",_[_.Regex=7]="Regex",_[_.NotRegex=8]="NotRegex",_[_.Or=9]="Or",_[_.In=10]="In",_[_.NotIn=11]="NotIn",_[_.Greater=12]="Greater",_[_.GreaterEquals=13]="GreaterEquals",_[_.Smaller=14]="Smaller",_[_.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const p={regexParsingWithErrorRecovery:!0},s=(0,I.localize)(0,null),$=(0,I.localize)(1,null),l=(0,I.localize)(2,null),a=(0,I.localize)(3,null),r=(0,I.localize)(4,null),o=(0,I.localize)(5,null),d=(0,I.localize)(6,null),n=(0,I.localize)(7,null);class t{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(f=p){this.k=f,this.d=new k.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(f){if(f===""){this.h.push({message:s,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(f).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const re=this.D(),F=re.type===17?o:void 0;throw this.h.push({message:r,offset:re.offset,lexeme:k.$1i.getLexeme(re),additionalInfo:F}),t.c}return U}catch(U){if(U!==t.c)throw U;return}}l(){return this.m()}m(){const f=[this.o()];for(;this.y(16);){const U=this.o();f.push(U)}return f.length===1?f[0]:i.or(...f)}o(){const f=[this.s()];for(;this.y(15);){const U=this.s();f.push(U)}return f.length===1?f[0]:i.and(...f)}s(){if(this.y(2)){const f=this.D();switch(f.type){case 11:return this.z(),C.INSTANCE;case 12:return this.z(),v.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,a),U?.negate()}case 17:return this.z(),S.create(f.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",f)}}return this.t()}t(){const f=this.D();switch(f.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const U=this.l();return this.A(1,a),U}case 17:{const U=f.lexeme;if(this.z(),this.y(9)){const F=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),F.type!==10)throw this.B("REGEX",F);const J=F.lexeme,R=J.lastIndexOf("/"),O=R===J.length-1?void 0:this.w(J.substring(R+1));let N;try{N=new RegExp(J.substring(1,R),O)}catch{throw this.B("REGEX",F)}return Y.create(U,N)}switch(F.type){case 10:case 19:{const J=[F.lexeme];this.z();let R=this.D(),O=0;for(let ue=0;ue<F.lexeme.length;ue++)F.lexeme.charCodeAt(ue)===40?O++:F.lexeme.charCodeAt(ue)===41&&O--;for(;!this.E()&&R.type!==15&&R.type!==16;){switch(R.type){case 0:O++;break;case 1:O--;break;case 10:case 18:for(let ue=0;ue<R.lexeme.length;ue++)R.lexeme.charCodeAt(ue)===40?O++:F.lexeme.charCodeAt(ue)===41&&O--}if(O<0)break;J.push(k.$1i.getLexeme(R)),this.z(),R=this.D()}const N=J.join(""),G=N.lastIndexOf("/"),Q=G===N.length-1?void 0:this.w(N.substring(G+1));let ie;try{ie=new RegExp(N.substring(1,G),Q)}catch{throw this.B("REGEX",F)}return i.regex(U,ie)}case 18:{const J=F.lexeme;this.z();let R=null;if(!(0,L.$Je)(J)){const O=J.indexOf("/"),N=J.lastIndexOf("/");if(O!==N&&O>=0){const G=J.slice(O+1,N),Q=J[N+1]==="i"?"i":"";try{R=new RegExp(G,Q)}catch{throw this.B("REGEX",F)}}}if(R===null)throw this.B("REGEX",F);return Y.create(U,R)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const F=this.u();return i.notIn(U,F)}switch(this.D().type){case 3:{this.z();const F=this.u();if(this.x().type===18)return i.equals(U,F);switch(F){case"true":return i.has(U);case"false":return i.not(U);default:return i.equals(U,F)}}case 4:{this.z();const F=this.u();if(this.x().type===18)return i.notEquals(U,F);switch(F){case"true":return i.not(U);case"false":return i.has(U);default:return i.notEquals(U,F)}}case 5:return this.z(),ee.create(U,this.u());case 6:return this.z(),ne.create(U,this.u());case 7:return this.z(),M.create(U,this.u());case 8:return this.z(),z.create(U,this.u());case 13:return this.z(),i.in(U,this.u());default:return i.has(U)}}case 20:throw this.h.push({message:d,offset:f.offset,lexeme:"",additionalInfo:n}),t.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const f=this.D();switch(f.type){case 17:case 18:return this.z(),f.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(f){return f.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(f){return this.C(f)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(f,U){if(this.C(f))return this.z();throw this.B(U,this.D())}B(f,U,re){const F=(0,I.localize)(8,null,f,k.$1i.getLexeme(U)),J=U.offset,R=k.$1i.getLexeme(U);return this.h.push({message:F,offset:J,lexeme:R,additionalInfo:re}),t.c}C(f){return this.D().type===f}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=t;class i{static false(){return C.INSTANCE}static true(){return v.INSTANCE}static has(f){return D.create(f)}static equals(f,U){return W.create(f,U)}static notEquals(f,U){return b.create(f,U)}static regex(f,U){return Y.create(f,U)}static in(f,U){return q.create(f,U)}static notIn(f,U){return c.create(f,U)}static not(f){return S.create(f)}static and(...f){return fe.create(f,null,!0)}static or(...f){return X.create(f,null,!0)}static greater(f,U){return M.create(f,U)}static greaterEquals(f,U){return z.create(f,U)}static smaller(f,U){return ee.create(f,U)}static smallerEquals(f,U){return ne.create(f,U)}static{this.c=new t({regexParsingWithErrorRecovery:!1})}static deserialize(f){return f==null?void 0:this.c.parse(f)}}e.$4i=i;function w(_){const f=new t({regexParsingWithErrorRecovery:!1});return _.map(U=>(f.parse(U),f.lexingErrors.length>0?f.lexingErrors.map(re=>({errorMessage:re.additionalInfo?(0,I.localize)(9,null,re.additionalInfo):(0,I.localize)(10,null),offset:re.offset,length:re.lexeme.length})):f.parsingErrors.length>0?f.parsingErrors.map(re=>({errorMessage:re.additionalInfo?`${re.message}. ${re.additionalInfo}`:re.message,offset:re.offset,length:re.lexeme.length})):[]))}e.$5i=w;function j(_,f){const U=_?_.substituteConstants():void 0,re=f?f.substituteConstants():void 0;return!U&&!re?!0:!U||!re?!1:U.equals(re)}e.$6i=j;function g(_,f){return _.cmp(f)}class C{static{this.INSTANCE=new C}constructor(){this.type=0}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!1}serialize(){return"false"}keys(){return[]}map(f){return this}negate(){return v.INSTANCE}}e.$7i=C;class v{static{this.INSTANCE=new v}constructor(){this.type=1}cmp(f){return this.type-f.type}equals(f){return f.type===this.type}substituteConstants(){return this}evaluate(f){return!0}serialize(){return"true"}keys(){return[]}map(f){return this}negate(){return C.INSTANCE}}e.$8i=v;class D{static create(f,U=null){const re=h.get(f);return typeof re=="boolean"?re?v.INSTANCE:C.INSTANCE:new D(f,U)}constructor(f,U){this.key=f,this.c=U,this.type=2}cmp(f){return f.type!==this.type?this.type-f.type:K(this.key,f.key)}equals(f){return f.type===this.type?this.key===f.key:!1}substituteConstants(){const f=h.get(this.key);return typeof f=="boolean"?f?v.INSTANCE:C.INSTANCE:this}evaluate(f){return!!f.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(f){return f.mapDefined(this.key)}negate(){return this.c||(this.c=S.create(this.key,this)),this.c}}e.$9i=D;class W{static create(f,U,re=null){if(typeof U=="boolean")return U?D.create(f,re):S.create(f,re);const F=h.get(f);return typeof F=="boolean"?U===(F?"true":"false")?v.INSTANCE:C.INSTANCE:new W(f,U,re)}constructor(f,U,re){this.c=f,this.d=U,this.f=re,this.type=4}cmp(f){return f.type!==this.type?this.type-f.type:te(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=h.get(this.c);if(typeof f=="boolean"){const U=f?"true":"false";return this.d===U?v.INSTANCE:C.INSTANCE}return this}evaluate(f){return f.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(f){return f.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=b.create(this.c,this.d,this)),this.f}}e.$0i=W;class q{static create(f,U){return new q(f,U)}constructor(f,U){this.d=f,this.f=U,this.type=10,this.c=null}cmp(f){return f.type!==this.type?this.type-f.type:te(this.d,this.f,f.d,f.f)}equals(f){return f.type===this.type?this.d===f.d&&this.f===f.f:!1}substituteConstants(){return this}evaluate(f){const U=f.getValue(this.f),re=f.getValue(this.d);return Array.isArray(U)?U.includes(re):typeof re=="string"&&typeof U=="object"&&U!==null?P.call(U,re):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(f){return f.mapIn(this.d,this.f)}negate(){return this.c||(this.c=c.create(this.d,this.f)),this.c}}e.$$i=q;class c{static create(f,U){return new c(f,U)}constructor(f,U){this.d=f,this.f=U,this.type=11,this.c=q.create(f,U)}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(f){return f.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=c;class b{static create(f,U,re=null){if(typeof U=="boolean")return U?S.create(f,re):D.create(f,re);const F=h.get(f);return typeof F=="boolean"?U===(F?"true":"false")?C.INSTANCE:v.INSTANCE:new b(f,U,re)}constructor(f,U,re){this.c=f,this.d=U,this.f=re,this.type=5}cmp(f){return f.type!==this.type?this.type-f.type:te(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){const f=h.get(this.c);if(typeof f=="boolean"){const U=f?"true":"false";return this.d===U?C.INSTANCE:v.INSTANCE}return this}evaluate(f){return f.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(f){return f.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$aj=b;class S{static create(f,U=null){const re=h.get(f);return typeof re=="boolean"?re?C.INSTANCE:v.INSTANCE:new S(f,U)}constructor(f,U){this.c=f,this.d=U,this.type=3}cmp(f){return f.type!==this.type?this.type-f.type:K(this.c,f.c)}equals(f){return f.type===this.type?this.c===f.c:!1}substituteConstants(){const f=h.get(this.c);return typeof f=="boolean"?f?C.INSTANCE:v.INSTANCE:this}evaluate(f){return!f.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(f){return f.mapNot(this.c)}negate(){return this.d||(this.d=D.create(this.c,this)),this.d}}e.$bj=S;function B(_,f){if(typeof _=="string"){const U=parseFloat(_);isNaN(U)||(_=U)}return typeof _=="string"||typeof _=="number"?f(_):C.INSTANCE}class M{static create(f,U,re=null){return B(U,F=>new M(f,F,re))}constructor(f,U,re){this.c=f,this.d=U,this.f=re,this.type=12}cmp(f){return f.type!==this.type?this.type-f.type:te(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$cj=M;class z{static create(f,U,re=null){return B(U,F=>new z(f,F,re))}constructor(f,U,re){this.c=f,this.d=U,this.f=re,this.type=13}cmp(f){return f.type!==this.type?this.type-f.type:te(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(f){return f.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ee.create(this.c,this.d,this)),this.f}}e.$dj=z;class ee{static create(f,U,re=null){return B(U,F=>new ee(f,F,re))}constructor(f,U,re){this.c=f,this.d=U,this.f=re,this.type=14}cmp(f){return f.type!==this.type?this.type-f.type:te(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$ej=ee;class ne{static create(f,U,re=null){return B(U,F=>new ne(f,F,re))}constructor(f,U,re){this.c=f,this.d=U,this.f=re,this.type=15}cmp(f){return f.type!==this.type?this.type-f.type:te(this.c,this.d,f.c,f.d)}equals(f){return f.type===this.type?this.c===f.c&&this.d===f.d:!1}substituteConstants(){return this}evaluate(f){return typeof this.d=="string"?!1:parseFloat(f.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(f){return f.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$fj=ne;class Y{static create(f,U){return new Y(f,U)}constructor(f,U){this.d=f,this.f=U,this.type=7,this.c=null}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.d<f.d)return-1;if(this.d>f.d)return 1;const U=this.f?this.f.source:"",re=f.f?f.f.source:"";return U<re?-1:U>re?1:0}equals(f){if(f.type===this.type){const U=this.f?this.f.source:"",re=f.f?f.f.source:"";return this.d===f.d&&U===re}return!1}substituteConstants(){return this}evaluate(f){const U=f.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const f=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${f}`}keys(){return[this.d]}map(f){return f.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=se.create(this)),this.c}}e.$gj=Y;class se{static create(f){return new se(f)}constructor(f){this.c=f,this.type=8}cmp(f){return f.type!==this.type?this.type-f.type:this.c.cmp(f.c)}equals(f){return f.type===this.type?this.c.equals(f.c):!1}substituteConstants(){return this}evaluate(f){return!this.c.evaluate(f)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(f){return new se(this.c.map(f))}negate(){return this.c}}e.$hj=se;function ce(_){let f=null;for(let U=0,re=_.length;U<re;U++){const F=_[U].substituteConstants();if(_[U]!==F&&f===null){f=[];for(let J=0;J<U;J++)f[J]=_[J]}f!==null&&(f[U]=F)}return f===null?_:f}class fe{static create(f,U,re){return fe.d(f,U,re)}constructor(f,U){this.expr=f,this.c=U,this.type=6}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let U=0,re=this.expr.length;U<re;U++){const F=g(this.expr[U],f.expr[U]);if(F!==0)return F}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let U=0,re=this.expr.length;U<re;U++)if(!this.expr[U].equals(f.expr[U]))return!1;return!0}return!1}substituteConstants(){const f=ce(this.expr);return f===this.expr?this:fe.create(f,this.c,!1)}evaluate(f){for(let U=0,re=this.expr.length;U<re;U++)if(!this.expr[U].evaluate(f))return!1;return!0}static d(f,U,re){const F=[];let J=!1;for(const R of f)if(R){if(R.type===1){J=!0;continue}if(R.type===0)return C.INSTANCE;if(R.type===6){F.push(...R.expr);continue}F.push(R)}if(F.length===0&&J)return v.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];F.sort(g);for(let R=1;R<F.length;R++)F[R-1].equals(F[R])&&(F.splice(R,1),R--);if(F.length===1)return F[0];for(;F.length>1;){const R=F[F.length-1];if(R.type!==9)break;F.pop();const O=F.pop(),N=F.length===0,G=X.create(R.expr.map(Q=>fe.create([Q,O],null,re)),null,N);G&&(F.push(G),F.sort(g))}if(F.length===1)return F[0];if(re){for(let R=0;R<F.length;R++)for(let O=R+1;O<F.length;O++)if(F[R].negate().equals(F[O]))return C.INSTANCE;if(F.length===1)return F[0]}return new fe(F,U)}}serialize(){return this.expr.map(f=>f.serialize()).join(" && ")}keys(){const f=[];for(const U of this.expr)f.push(...U.keys());return f}map(f){return new fe(this.expr.map(U=>U.map(f)),null)}negate(){if(!this.c){const f=[];for(const U of this.expr)f.push(U.negate());this.c=X.create(f,this,!0)}return this.c}}e.$ij=fe;class X{static create(f,U,re){return X.d(f,U,re)}constructor(f,U){this.expr=f,this.c=U,this.type=9}cmp(f){if(f.type!==this.type)return this.type-f.type;if(this.expr.length<f.expr.length)return-1;if(this.expr.length>f.expr.length)return 1;for(let U=0,re=this.expr.length;U<re;U++){const F=g(this.expr[U],f.expr[U]);if(F!==0)return F}return 0}equals(f){if(f.type===this.type){if(this.expr.length!==f.expr.length)return!1;for(let U=0,re=this.expr.length;U<re;U++)if(!this.expr[U].equals(f.expr[U]))return!1;return!0}return!1}substituteConstants(){const f=ce(this.expr);return f===this.expr?this:X.create(f,this.c,!1)}evaluate(f){for(let U=0,re=this.expr.length;U<re;U++)if(this.expr[U].evaluate(f))return!0;return!1}static d(f,U,re){let F=[],J=!1;if(f){for(let R=0,O=f.length;R<O;R++){const N=f[R];if(N){if(N.type===0){J=!0;continue}if(N.type===1)return v.INSTANCE;if(N.type===9){F=F.concat(N.expr);continue}F.push(N)}}if(F.length===0&&J)return C.INSTANCE;F.sort(g)}if(F.length!==0){if(F.length===1)return F[0];for(let R=1;R<F.length;R++)F[R-1].equals(F[R])&&(F.splice(R,1),R--);if(F.length===1)return F[0];if(re){for(let R=0;R<F.length;R++)for(let O=R+1;O<F.length;O++)if(F[R].negate().equals(F[O]))return v.INSTANCE;if(F.length===1)return F[0]}return new X(F,U)}}serialize(){return this.expr.map(f=>f.serialize()).join(" || ")}keys(){const f=[];for(const U of this.expr)f.push(...U.keys());return f}map(f){return new X(this.expr.map(U=>U.map(f)),null)}negate(){if(!this.c){const f=[];for(const U of this.expr)f.push(U.negate());for(;f.length>1;){const U=f.shift(),re=f.shift(),F=[];for(const J of ge(U))for(const R of ge(re))F.push(fe.create([J,R],null,!1));f.unshift(X.create(F,null,!1))}this.c=X.create(f,this,!0)}return this.c}}e.$jj=X;class V extends D{static{this.d=[]}static all(){return V.d.values()}constructor(f,U,re){super(f,null),this.f=U,typeof re=="object"?V.d.push({...re,key:f}):re!==!0&&V.d.push({key:f,description:re,type:U!=null?typeof U:void 0})}bindTo(f){return f.createKey(this.key,this.f)}getValue(f){return f.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(f){return W.create(this.key,f)}notEqualsTo(f){return b.create(this.key,f)}}e.$kj=V,e.$lj=(0,A.$6h)("contextKeyService");function K(_,f){return _<f?-1:_>f?1:0}function te(_,f,U,re){return _<U?-1:_>U?1:f<re?-1:f>re?1:0}function H(_,f){if(_.type===0||f.type===1)return!0;if(_.type===9)return f.type===9?x(_.expr,f.expr):!1;if(f.type===9){for(const U of f.expr)if(H(_,U))return!0;return!1}if(_.type===6){if(f.type===6)return x(f.expr,_.expr);for(const U of _.expr)if(H(U,f))return!0;return!1}return _.equals(f)}e.$mj=H;function x(_,f){let U=0,re=0;for(;U<_.length&&re<f.length;){const F=_[U].cmp(f[re]);if(F<0)return!1;F===0&&U++,re++}return U===_.length}function ge(_){return _.type===9?_.expr:[_]}}),define(le[78],he([0,1,51,7,11,8,5,69,21,3,19,22]),function(oe,e,y,L,k,A,I,E,h,u,P,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,h.$6h)("fileService");function p(H){return H.create===!0}e.$rk=p;var s;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(s||(e.FileType=s={}));var $;(function(H){H[H.Readonly=1]="Readonly",H[H.Locked=2]="Locked"})($||(e.FilePermission=$={}));function l(H){const x=H;return!!x&&typeof x.onDidChange=="function"}e.$sk=l;var a;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileAtomicWrite=32768]="FileAtomicWrite",H[H.FileAtomicDelete=65536]="FileAtomicDelete",H[H.FileClone=131072]="FileClone"})(a||(e.FileSystemProviderCapabilities=a={}));function r(H){return!!(H.capabilities&2)}e.$tk=r;function o(H){return!!(H.capabilities&8)}e.$uk=o;function d(H){return!!(H.capabilities&131072)}e.$vk=d;function n(H){return!!(H.capabilities&4)}e.$wk=n;function t(H){return!!(H.capabilities&16)}e.$xk=t;function i(H){return r(H)?!!(H.capabilities&16384):!1}e.$yk=i;function w(H){return r(H)?!!(H.capabilities&32768):!1}e.$zk=w;function j(H){return!!(H.capabilities&65536)}e.$Ak=j;function g(H){return!!(H.capabilities&2048)}e.$Bk=g;var C;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsStorageQuota="EntryExceedsStorageQuota",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(C||(e.FileSystemProviderErrorCode=C={}));class v extends Error{static create(x,ge){const _=new v(x.toString(),ge);return q(_,ge),_}constructor(x,ge){super(x),this.code=ge}}e.$Ck=v;function D(H,x){return v.create(H,x)}e.$Dk=D;function W(H){return H||D((0,E.localize)(0,null),C.Unknown)}e.$Ek=W;function q(H,x){return H.name=x?`${x} (FileSystemError)`:"FileSystemError",H}e.$Fk=q;function c(H){if(!H)return C.Unknown;if(H instanceof v)return H.code;const x=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!x)return C.Unknown;switch(x[1]){case C.FileExists:return C.FileExists;case C.FileIsADirectory:return C.FileIsADirectory;case C.FileNotADirectory:return C.FileNotADirectory;case C.FileNotFound:return C.FileNotFound;case C.FileTooLarge:return C.FileTooLarge;case C.FileWriteLocked:return C.FileWriteLocked;case C.NoPermissions:return C.NoPermissions;case C.Unavailable:return C.Unavailable}return C.Unknown}e.$Gk=c;function b(H){if(H instanceof ne)return H.fileOperationResult;switch(c(H)){case C.FileNotFound:return 1;case C.FileIsADirectory:return 0;case C.FileNotADirectory:return 9;case C.FileWriteLocked:return 5;case C.NoPermissions:return 6;case C.FileExists:return 4;case C.FileTooLarge:return 7;default:return 10}}e.$Hk=b;var S;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(S||(e.FileOperation=S={}));class B{constructor(x,ge,_){this.resource=x,this.operation=ge,this.target=_}isOperation(x){return this.operation===x}}e.$Ik=B;var M;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(M||(e.FileChangeType=M={}));class z{static{this.a=null}constructor(x,ge){this.c=ge,this.b=void 0,this.d=new m.$V(()=>{const _=y.$_h.forUris(()=>this.c);return _.fill(this.rawAdded.map(f=>[f,!0])),_}),this.f=new m.$V(()=>{const _=y.$_h.forUris(()=>this.c);return _.fill(this.rawUpdated.map(f=>[f,!0])),_}),this.g=new m.$V(()=>{const _=y.$_h.forUris(()=>this.c);return _.fill(this.rawDeleted.map(f=>[f,!0])),_}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const _ of x){switch(_.type){case 1:this.rawAdded.push(_.resource);break;case 0:this.rawUpdated.push(_.resource);break;case 2:this.rawDeleted.push(_.resource);break}this.b!==z.a&&(typeof _.cId=="number"?this.b===void 0?this.b=_.cId:this.b!==_.cId&&(this.b=z.a):this.b!==void 0&&(this.b=z.a))}}contains(x,...ge){return this.h(x,{includeChildren:!1},...ge)}affects(x,...ge){return this.h(x,{includeChildren:!0},...ge)}h(x,ge,..._){if(!x)return!1;const f=_.length>0;return!!((!f||_.includes(1))&&(this.d.value.get(x)||ge.includeChildren&&this.d.value.findSuperstr(x))||(!f||_.includes(0))&&(this.f.value.get(x)||ge.includeChildren&&this.f.value.findSuperstr(x))||(!f||_.includes(2))&&(this.g.value.findSubstr(x)||ge.includeChildren&&this.g.value.findSuperstr(x)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(x){return this.b===x}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=z;function ee(H,x,ge){return!H||!x||H===x||x.length>H.length?!1:(x.charAt(x.length-1)!==L.sep&&(x+=L.sep),ge?(0,k.$af)(H,x):H.indexOf(x)===0)}e.$Kk=ee;class ne extends Error{constructor(x,ge,_){super(x),this.fileOperationResult=ge,this.options=_}}e.$Lk=ne;class Y extends ne{constructor(x,ge,_,f){super(x,ge,f),this.fileOperationResult=ge,this.size=_}}e.$Mk=Y;class se extends ne{constructor(x,ge,_){super(x,2,_),this.stat=ge}}e.$Nk=se;var ce;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ce||(e.FileOperationResult=ce={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var fe;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(fe||(e.FileKind=fe={})),e.$Vk="";function X(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.$Wk=X;async function V(H,x){if(!x.hasProvider(I.URI.from({scheme:H.scheme})))return new Promise(ge=>{const _=x.onDidChangeFileSystemProviderRegistrations(f=>{f.scheme===H.scheme&&f.added&&(_.dispose(),ge())})})}e.$Xk=V;class K{static{this.KB=1024}static{this.MB=K.KB*K.KB}static{this.GB=K.MB*K.KB}static{this.TB=K.GB*K.KB}static formatSize(x){return(0,A.$Mf)(x)||(x=0),x<K.KB?(0,E.localize)(1,null,x.toFixed(0)):x<K.MB?(0,E.localize)(2,null,(x/K.KB).toFixed(2)):x<K.GB?(0,E.localize)(3,null,(x/K.MB).toFixed(2)):x<K.TB?(0,E.localize)(4,null,(x/K.GB).toFixed(2)):(0,E.localize)(5,null,(x/K.TB).toFixed(2))}}e.$Yk=K;function te(H){const x=typeof H=="string"||H?.scheme===P.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===P.Schemas.file?1024*K.MB:x?10*K.MB:u.$o?50*K.MB:1024*K.MB}e.$Zk=te}),define(le[10],he([0,1,56,4,49,2,25,3,23,8,5,35,21]),function(oe,e,y,L,k,A,I,E,h,u,P,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,p.$6h)("logService"),e.$oj=(0,p.$6h)("loggerService");function s(){return new Date().toISOString()}function $(q){return(0,u.$Mf)(q)}e.$pj=$;var l;(function(q){q[q.Off=0]="Off",q[q.Trace=1]="Trace",q[q.Debug=2]="Debug",q[q.Info=3]="Info",q[q.Warning=4]="Warning",q[q.Error=5]="Error"})(l||(e.LogLevel=l={})),e.$qj=l.Info;function a(q,c,b){switch(c){case l.Trace:q.trace(b);break;case l.Debug:q.debug(b);break;case l.Info:q.info(b);break;case l.Warning:q.warn(b);break;case l.Error:q.error(b);break;case l.Off:break;default:throw new Error(`Invalid log level ${c}`)}}e.log=a;function r(q,c=!1){let b="";for(let S=0;S<q.length;S++){let B=q[S];if(B instanceof Error&&(B=(0,y.$Qi)(B,c)),typeof B=="object")try{B=JSON.stringify(B)}catch{}b+=(S>0?" ":"")+B}return b}class o extends A.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new L.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(c){this.b!==c&&(this.b=c,this.c.fire(this.b))}getLevel(){return this.b}f(c){return this.b!==l.Off&&this.b<=c}}e.$sj=o;class d extends o{constructor(c){super(),this.h=c}f(c){return this.h||super.f(c)}trace(c,...b){this.f(l.Trace)&&this.g(l.Trace,r([c,...b],!0))}debug(c,...b){this.f(l.Debug)&&this.g(l.Debug,r([c,...b]))}info(c,...b){this.f(l.Info)&&this.g(l.Info,r([c,...b]))}warn(c,...b){this.f(l.Warning)&&this.g(l.Warning,r([c,...b]))}error(c,...b){if(this.f(l.Error))if(c instanceof Error){const S=Array.prototype.slice.call(arguments);S[0]=c.stack,this.g(l.Error,r(S))}else this.g(l.Error,r([c,...b]))}flush(){}}e.$tj=d;class n extends o{constructor(c=e.$qj){super(),this.setLevel(c),this.g=!E.$i}trace(c,...b){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,c,...b):console.log(`[main ${s()}]`,c,...b))}debug(c,...b){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,c,...b):console.log(`[main ${s()}]`,c,...b))}info(c,...b){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${s()}]\x1B[0m`,c,...b):console.log(`[main ${s()}]`,c,...b))}warn(c,...b){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${s()}]\x1B[0m`,c,...b):console.warn(`[main ${s()}]`,c,...b))}error(c,...b){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${s()}]\x1B[0m`,c,...b):console.error(`[main ${s()}]`,c,...b))}flush(){}}e.$uj=n;class t extends o{constructor(c=e.$qj,b=!0){super(),this.g=b,this.setLevel(c)}trace(c,...b){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",c,...b):console.log(c,...b))}debug(c,...b){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",c,...b):console.log(c,...b))}info(c,...b){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",c,...b):console.log(c,...b))}warn(c,...b){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",c,...b):console.log(c,...b))}error(c,...b){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",c,...b):console.error(c,...b))}flush(){}}e.$vj=t;class i extends o{constructor(c,b=e.$qj){super(),this.g=c,this.setLevel(b)}trace(c,...b){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(c),...b])}debug(c,...b){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(c),...b])}info(c,...b){this.f(l.Info)&&this.g.log(l.Info,[this.h(c),...b])}warn(c,...b){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(c),...b])}error(c,...b){this.f(l.Error)&&this.g.log(l.Error,[this.h(c),...b])}h(c){return typeof c=="string"?c:(0,y.$Qi)(c,this.f(l.Trace))}flush(){}}e.$wj=i;class w extends o{constructor(c){super(),this.g=c,c.length&&this.setLevel(c[0].getLevel())}setLevel(c){for(const b of this.g)b.setLevel(c);super.setLevel(c)}trace(c,...b){for(const S of this.g)S.trace(c,...b)}debug(c,...b){for(const S of this.g)S.debug(c,...b)}info(c,...b){for(const S of this.g)S.info(c,...b)}warn(c,...b){for(const S of this.g)S.warn(c,...b)}error(c,...b){for(const S of this.g)S.error(c,...b)}flush(){for(const c of this.g)c.flush()}dispose(){for(const c of this.g)c.dispose();super.dispose()}}e.$xj=w;class j extends A.$Tc{constructor(c,b,S){if(super(),this.h=c,this.j=b,this.b=new I.$Ac,this.c=this.B(new L.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new L.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new L.$Vd),this.onDidChangeVisibility=this.g.event,S)for(const B of S)this.b.set(B.resource,{logger:void 0,info:B})}m(c){return(0,u.$If)(c)?[...this.b.values()].find(b=>b.info.id===c):this.b.get(c)}getLogger(c){return this.m(c)?.logger}createLogger(c,b){const S=this.n(c),B=(0,u.$If)(c)?c:b?.id??(0,k.$Ti)(S.toString()).toString(16);let M=this.b.get(S)?.logger;const z=b?.logLevel==="always"?l.Trace:b?.logLevel;M||(M=this.s(S,z??this.getLogLevel(S)??this.h,{...b,id:B}));const ee={logger:M,info:{resource:S,id:B,logLevel:z,name:b?.name,hidden:b?.hidden,extensionId:b?.extensionId,when:b?.when}};return this.registerLogger(ee.info),this.b.set(S,ee),M}n(c){return(0,u.$If)(c)?(0,h.$Hg)(this.j,`${c}.log`):c}setLogLevel(c,b){if(P.URI.isUri(c)){const S=c,B=b,M=this.b.get(S);M&&B!==M.info.logLevel&&(M.info.logLevel=B===this.h?void 0:B,M.logger?.setLevel(B),this.b.set(M.info.resource,M),this.f.fire([S,B]))}else{this.h=c;for(const[S,B]of this.b.entries())this.b.get(S)?.info.logLevel===void 0&&B.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(c,b){const S=this.m(c);S&&b!==!S.info.hidden&&(S.info.hidden=!b,this.b.set(S.info.resource,S),this.g.fire([S.info.resource,b]))}getLogLevel(c){let b;return c&&(b=this.b.get(c)?.info.logLevel),b??this.h}registerLogger(c){const b=this.b.get(c.resource);b?b.info.hidden!==c.hidden&&this.setVisibility(c.resource,!c.hidden):(this.b.set(c.resource,{info:c,logger:void 0}),this.c.fire({added:[c],removed:[]}))}deregisterLogger(c){const b=this.b.get(c);b&&(b.logger&&b.logger.dispose(),this.b.delete(c),this.c.fire({added:[],removed:[b.info]}))}*getRegisteredLoggers(){for(const c of this.b.values())yield c.info}getRegisteredLogger(c){return this.b.get(c)?.info}dispose(){this.b.forEach(c=>c.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=j;class g{constructor(){this.onDidChangeLogLevel=new L.$Vd().event}setLevel(c){}getLevel(){return l.Info}trace(c,...b){}debug(c,...b){}info(c,...b){}warn(c,...b){}error(c,...b){}critical(c,...b){}dispose(){}flush(){}}e.$zj=g;class C extends g{}e.$Aj=C;function v(q){if(q.verbose)return l.Trace;if(typeof q.logLevel=="string"){const c=W(q.logLevel.toLowerCase());if(c!==void 0)return c}return e.$qj}e.$Bj=v;function D(q){switch(q){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.$Cj=D;function W(q){switch(q){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.$Dj=W,e.$Ej=new m.$kj("logLevel",D(l.Info))}),define(le[79],he([0,1,5,4,10,2]),function(oe,e,y,L,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cr=e.$Br=e.$Ar=void 0;class I extends k.$yj{constructor(m,p,s,$,l){super(p,s,$),this.r=m,this.t=l,this.B(l.listen("onDidChangeLogLevel",m)(a=>{(0,k.$pj)(a)?super.setLogLevel(a):super.setLogLevel(y.URI.revive(a[0]),a[1])})),this.B(l.listen("onDidChangeVisibility",m)(([a,r])=>super.setVisibility(y.URI.revive(a),r))),this.B(l.listen("onDidChangeLoggers",m)(({added:a,removed:r})=>{for(const o of a)super.registerLogger({...o,resource:y.URI.revive(o.resource)});for(const o of r)super.deregisterLogger(o.resource)}))}createConsoleMainLogger(){return new k.$wj({log:(m,p)=>{this.t.call("consoleLog",[m,p])}})}registerLogger(m){super.registerLogger(m),this.t.call("registerLogger",[m,this.r])}deregisterLogger(m){super.deregisterLogger(m),this.t.call("deregisterLogger",[m,this.r])}setLogLevel(m,p){super.setLogLevel(m,p),this.t.call("setLogLevel",[m,p])}setVisibility(m,p){super.setVisibility(m,p),this.t.call("setVisibility",[this.n(m),p])}s(m,p,s){return new E(this.t,m,p,s,this.r)}static setLogLevel(m,p,s){return m.call("setLogLevel",[p,s])}}e.$Ar=I;class E extends k.$tj{constructor(m,p,s,$,l){super($?.logLevel==="always"),this.r=m,this.s=p,this.m=!1,this.n=[],this.setLevel(s),this.r.call("createLogger",[p,$,l]).then(()=>{this.u(this.n),this.m=!0})}g(m,p){const s=[[m,p]];this.m?this.u(s):this.n.push(...s)}u(m){this.r.call("log",[this.s,m])}}class h{constructor(m,p){this.a=m,this.b=p}listen(m,p){const s=this.b(m);switch(p){case"onDidChangeLoggers":return L.Event.map(this.a.onDidChangeLoggers,$=>({added:[...$.added].map(l=>this.c(l,s)),removed:[...$.removed].map(l=>this.c(l,s))}));case"onDidChangeVisibility":return L.Event.map(this.a.onDidChangeVisibility,$=>[s.transformOutgoingURI($[0]),$[1]]);case"onDidChangeLogLevel":return L.Event.map(this.a.onDidChangeLogLevel,$=>(0,k.$pj)($)?$:[s.transformOutgoingURI($[0]),$[1]])}throw new Error(`Event not found: ${p}`)}async call(m,p,s){const $=this.b(m);switch(p){case"setLogLevel":return(0,k.$pj)(s[0])?this.a.setLogLevel(s[0]):this.a.setLogLevel(y.URI.revive($.transformIncoming(s[0][0])),s[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(l=>this.c(l,$)))}throw new Error(`Call not found: ${p}`)}c(m,p){return{...m,resource:p.transformOutgoingURI(m.resource)}}}e.$Br=h;class u extends A.$Tc{constructor(m,p){super(),p.call("setLogLevel",[m.getLogLevel()]),this.B(m.onDidChangeLogLevel(s=>p.call("setLogLevel",[s]))),p.call("getRegisteredLoggers").then(s=>{for(const $ of s)m.registerLogger({...$,resource:y.URI.revive($.resource)})}),this.B(p.listen("onDidChangeVisibility")(([s,$])=>m.setVisibility(y.URI.revive(s),$))),this.B(p.listen("onDidChangeLoggers")(({added:s,removed:$})=>{for(const l of s)m.registerLogger({...l,resource:y.URI.revive(l.resource)});for(const l of $)m.deregisterLogger(l.resource)}))}}e.$Cr=u}),define(le[80],he([0,1,2,10]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=void 0;class k extends y.$Tc{constructor(I,E=[]){super(),this.a=new L.$xj([I,...E]),this.B(I.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(I){this.a.setLevel(I)}getLevel(){return this.a.getLevel()}trace(I,...E){this.a.trace(I,...E)}debug(I,...E){this.a.debug(I,...E)}info(I,...E){this.a.info(I,...E)}warn(I,...E){this.a.warn(I,...E)}error(I,...E){this.a.error(I,...E)}flush(){this.a.flush()}}e.$CO=k}),define(le[81],he([0,1,78,10]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=void 0;var k;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(k||(k={}));async function A(u,P,m,p,s){try{const $=await new Promise((a,r)=>{oe(["@vscode/spdlog"],a,r)});$.setFlushOn(k.Trace);const l=await $.createAsyncRotatingLogger(u,P,m,p);return s?l.clearFormatters():l.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),l}catch($){console.error($)}return null}function I(u,P,m){switch(P){case L.LogLevel.Trace:u.trace(m);break;case L.LogLevel.Debug:u.debug(m);break;case L.LogLevel.Info:u.info(m);break;case L.LogLevel.Warning:u.warn(m);break;case L.LogLevel.Error:u.error(m);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${P}`)}}function E(u,P){switch(P){case L.LogLevel.Trace:u.setLevel(k.Trace);break;case L.LogLevel.Debug:u.setLevel(k.Debug);break;case L.LogLevel.Info:u.setLevel(k.Info);break;case L.LogLevel.Warning:u.setLevel(k.Warning);break;case L.LogLevel.Error:u.setLevel(k.Error);break;case L.LogLevel.Off:u.setLevel(k.Off);break;default:throw new Error(`Invalid log level ${P}`)}}class h extends L.$tj{constructor(P,m,p,s,$){super(),this.m=[],this.setLevel($),this.n=this.s(P,m,p,s),this.B(this.onDidChangeLogLevel(l=>{this.r&&E(this.r,l)}))}async s(P,m,p,s){const $=p?6:1,l=30/$*y.$Yk.MB,a=await A(P,m,l,$,s);if(a){this.r=a,E(this.r,this.getLevel());for(const{level:r,message:o}of this.m)I(this.r,r,o);this.m=[]}}g(P,m){this.r?I(this.r,P,m):this.getLevel()<=P&&this.m.push({level:P,message:m})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$rO=h}),define(le[82],he([0,1,52,10,81]),function(oe,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sO=void 0;class A extends L.$yj{s(E,h,u){return new k.$rO((0,y.$qg)(),E.fsPath,!u?.donotRotate,!!u?.donotUseFormatters,h)}}e.$sO=A}),define(le[83],he([0,1,15]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let L;const k=globalThis.vscode;if(typeof k<"u"&&typeof k.context<"u"){const A=k.context.configuration();if(A)L=A.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(L=globalThis._VSCODE_PRODUCT_JSON,y.env.VSCODE_DEV&&Object.assign(L,{nameShort:`${L.nameShort} Dev`,nameLong:`${L.nameLong} Dev`,dataFolderName:`${L.dataFolderName}-dev`,serverDataFolderName:L.serverDataFolderName?`${L.serverDataFolderName}-dev`:void 0}),!L.version){const A=globalThis._VSCODE_PACKAGE_JSON;Object.assign(L,{version:A.version})}}else L={},Object.keys(L).length===0&&Object.assign(L,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=L}),define(le[84],he([0,1,21]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,y.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"}),define(le[85],he([0,1,42,8]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class k{constructor(){this.a=new Map}add(I,E){y.ok(L.$If(I)),y.ok(L.$Kf(E)),y.ok(!this.a.has(I),"There is already an extension with this id"),this.a.set(I,E)}knows(I){return this.a.has(I)}as(I){return this.a.get(I)||null}}e.$Hn=new k}),define(le[86],he([0,1,4,2]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rpb=void 0;class k extends L.$Tc{constructor(I){super(),this.f=I,this.type=4,this.a=new Map,this.b=new Map,this.c=this.B(new y.$Vd),this.onMarkAdded=this.c.event}*markers(){for(const I of this.a.values())yield I;for(const I of this.b.values())yield I}addMark(I){const E=I?.marker||this.f.registerMarker(),h=I?.id;E&&(h?(this.a.set(h,E),E.onDispose(()=>this.a.delete(h))):(this.b.set(E.id,E),E.onDispose(()=>this.b.delete(E.id))),this.c.fire({marker:E,id:h,hidden:I?.hidden,hoverMessage:I?.hoverMessage}))}getMark(I){return this.a.get(I)}}e.$Rpb=k}),define(le[87],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tr=e.$sr=void 0;class y{get command(){return this.b.command}get isTrusted(){return this.b.isTrusted}get timestamp(){return this.b.timestamp}get promptStartMarker(){return this.b.promptStartMarker}get marker(){return this.b.marker}get endMarker(){return this.b.endMarker}set endMarker(u){this.b.endMarker=u}get executedMarker(){return this.b.executedMarker}get aliases(){return this.b.aliases}get wasReplayed(){return this.b.wasReplayed}get cwd(){return this.b.cwd}get exitCode(){return this.b.exitCode}get commandStartLineContent(){return this.b.commandStartLineContent}get markProperties(){return this.b.markProperties}get executedX(){return this.b.executedX}get startX(){return this.b.startX}constructor(u,P){this.a=u,this.b=P}static deserialize(u,P,m){const p=u.buffer.normal,s=P.startLine!==void 0?u.registerMarker(P.startLine-(p.baseY+p.cursorY)):void 0;if(!s)return;const $=P.promptStartLine!==void 0?u.registerMarker(P.promptStartLine-(p.baseY+p.cursorY)):void 0,l=P.endLine!==void 0?u.registerMarker(P.endLine-(p.baseY+p.cursorY)):void 0,a=P.executedLine!==void 0?u.registerMarker(P.executedLine-(p.baseY+p.cursorY)):void 0;return new y(u,{command:m?"":P.command,isTrusted:P.isTrusted,promptStartMarker:$,marker:s,startX:P.startX,endMarker:l,executedMarker:a,executedX:P.executedX,timestamp:P.timestamp,cwd:P.cwd,commandStartLineContent:P.commandStartLineContent,exitCode:P.exitCode,markProperties:P.markProperties,aliases:void 0,wasReplayed:!0})}serialize(u){return{promptStartLine:this.promptStartMarker?.line,startLine:this.marker?.line,startX:void 0,endLine:this.endMarker?.line,executedLine:this.executedMarker?.line,executedX:this.executedX,command:u?"":this.command,isTrusted:this.isTrusted,cwd:this.cwd,exitCode:this.exitCode,commandStartLineContent:this.commandStartLineContent,timestamp:this.timestamp,markProperties:this.markProperties}}getOutput(){if(!this.executedMarker||!this.endMarker)return;const u=this.executedMarker.line,P=this.endMarker.line;if(u===P)return;let m="",p;for(let s=u;s<P;s++)p=this.a.buffer.active.getLine(s),p&&(m+=p.translateToString(!p.isWrapped)+(p.isWrapped?"":`
`));return m===""?void 0:m}getOutputMatch(u){if(!this.executedMarker||!this.endMarker)return;const P=this.endMarker.line;if(P===-1)return;const m=this.a.buffer.active,p=Math.max(this.executedMarker.line,0),s=u.lineMatcher,$=typeof s=="string"?1:u.length||A(s),l=[];let a;if(u.anchor==="bottom")for(let r=P-(u.offset||0);r>=p;r--){let o=r;const d=r;for(;o>=p&&m.getLine(o)?.isWrapped;)o--;if(r=o,l.unshift(k(m,o,d,this.a.cols)),a||(a=l[0].match(s)),l.length>=$)break}else for(let r=p+(u.offset||0);r<P;r++){const o=r;let d=r;for(;d+1<P&&m.getLine(d+1)?.isWrapped;)d++;if(r=d,l.push(k(m,o,d,this.a.cols)),a||(a=l[l.length-1].match(s)),l.length>=$)break}return a?{regexMatch:a,outputLines:l}:void 0}hasOutput(){return!this.executedMarker?.isDisposed&&!this.endMarker?.isDisposed&&!!(this.executedMarker&&this.endMarker&&this.executedMarker.line<this.endMarker.line)}getPromptRowCount(){return I(this,this.a.buffer.active)}getCommandRowCount(){return E(this)}}e.$sr=y;class L{constructor(u){this.a=u}serialize(u){if(this.commandStartMarker)return{promptStartLine:this.promptStartMarker?.line,startLine:this.commandStartMarker.line,startX:this.commandStartX,endLine:void 0,executedLine:void 0,executedX:void 0,command:"",isTrusted:!0,cwd:u,exitCode:void 0,commandStartLineContent:void 0,timestamp:0,markProperties:void 0}}promoteToFullCommand(u,P,m,p){if(P===void 0&&this.command===void 0&&(this.command=""),this.command!==void 0&&!this.command.startsWith("\\")||m)return new y(this.a,{command:m?"":this.command||"",isTrusted:!!this.isTrusted,promptStartMarker:this.promptStartMarker,marker:this.commandStartMarker,startX:this.commandStartX,endMarker:this.commandFinishedMarker,executedMarker:this.commandExecutedMarker,executedX:this.commandExecutedX,timestamp:Date.now(),cwd:u,exitCode:P,commandStartLineContent:this.commandStartLineContent,markProperties:p})}getPromptRowCount(){return I(this,this.a.buffer.active)}getCommandRowCount(){return E(this)}}e.$tr=L;function k(h,u,P,m){const p=Math.max(2048/m*2);P=Math.min(P,u+p);let s="";for(let $=u;$<=P;$++){const l=h.getLine($);l&&(s+=l.translateToString(!0,0,m))}return s}function A(h){if(!h.multiline)return 1;const u=h.source;let P=1,m=u.indexOf("\\n");for(;m!==-1;)P++,m=u.indexOf("\\n",m+1);return P}function I(h,u){const P="hasOutput"in h?h.marker:h.commandStartMarker;if(!P||!h.promptStartMarker)return 1;let m=1,p=h.promptStartMarker.line;for(;p<P.line&&(u.getLine(p)?.translateToString(!0)??"").length===0;)p++;return m=P.line-p+1,m}function E(h){const u="hasOutput"in h?h.marker:h.commandStartMarker,P="hasOutput"in h?h.executedMarker:h.commandExecutedMarker;if(!u||!P)return 1;let p=Math.max(P.line,u.line)-u.line+1;return("hasOutput"in h?h.executedX:h.commandExecutedX)===0&&p--,p}});var Ne=this&&this.__param||function(oe,e){return function(y,L){e(y,L,oe)}};define(le[88],he([0,1,9,14,4,2,10,87]),function(oe,e,y,L,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Opb=e.$Npb=void 0;class h extends A.$Tc{get commands(){return this.c}get executingCommand(){return this.g.command}get executingCommandObject(){if(this.g.commandStartMarker)return{marker:this.g.commandStartMarker}}get currentCommand(){return this.g}get cwd(){return this.f}get z(){return!!(this.g.commandStartMarker&&!this.g.commandExecutedMarker)}get hasInput(){if(!(!this.z||!this.g?.commandStartMarker)){if(this.J.buffer.active.baseY+this.J.buffer.active.cursorY===this.g.commandStartMarker?.line){const a=this.J.buffer.active.getLine(this.J.buffer.active.cursorY)?.translateToString(!0,this.g.commandStartX);return a===void 0?void 0:a.length>0}return!0}}constructor(a,r){super(),this.J=a,this.L=r,this.type=2,this.c=[],this.g=new E.$tr(this.J),this.h=[],this.r=!1,this.C=this.B(new k.$Vd),this.onCommandStarted=this.C.event,this.D=this.B(new k.$Vd),this.onBeforeCommandFinished=this.D.event,this.F=this.B(new k.$Vd),this.onCommandFinished=this.F.event,this.G=this.B(new k.$Vd),this.onCommandExecuted=this.G.event,this.H=this.B(new k.$Vd),this.onCommandInvalidated=this.H.event,this.I=this.B(new k.$Vd),this.onCurrentCommandInvalidated=this.I.event;const o=this;this.u=new class{get onCurrentCommandInvalidatedEmitter(){return o.I}get onCommandStartedEmitter(){return o.C}get onCommandExecutedEmitter(){return o.G}get dimensions(){return o.n}get isCommandStorageDisabled(){return o.r}get commandMarkers(){return o.h}set commandMarkers(d){o.h=d}get clearCommandsInViewport(){return o.O.bind(o)}commitCommandFinished(){o.t?.flush(),o.t=void 0}},this.w=this.B(new A.$Vc(new u(this.J,this,this.u,this.L))),this.n={cols:this.J.cols,rows:this.J.rows},this.B(this.J.onResize(d=>this.M(d))),this.B(this.J.onCursorMove(()=>this.N()))}M(a){this.w.value.preHandleResize?.(a),this.n.cols=a.cols,this.n.rows=a.rows}N(){this.J.buffer.active===this.J.buffer.normal&&this.g.commandStartMarker&&this.J.buffer.active.baseY+this.J.buffer.active.cursorY<this.g.commandStartMarker.line&&(this.O(),this.g.isInvalid=!0,this.I.fire({reason:"windows"}))}O(){let a=0;for(let r=this.c.length-1;r>=0;r--){const o=this.c[r].marker?.line;if(o&&o<this.J.buffer.active.baseY)break;a++}a>0&&this.H.fire(this.c.splice(this.c.length-a,a))}setCwd(a){this.f=a}setIsWindowsPty(a){if(a&&!(this.w.value instanceof m)){const r=this;this.w.value=new m(this.J,this,new class{get onCurrentCommandInvalidatedEmitter(){return r.I}get onCommandStartedEmitter(){return r.C}get onCommandExecutedEmitter(){return r.G}get dimensions(){return r.n}get isCommandStorageDisabled(){return r.r}get commandMarkers(){return r.h}set commandMarkers(o){r.h=o}get clearCommandsInViewport(){return r.O.bind(r)}commitCommandFinished(){r.t?.flush(),r.t=void 0}},this.L)}else!a&&!(this.w.value instanceof u)&&(this.w.value=new u(this.J,this,this.u,this.L))}setIsCommandStorageDisabled(){this.r=!0}getCommandForLine(a){if(this.g.promptStartMarker&&a>=this.g.promptStartMarker?.line)return this.g;if(this.c.length!==0&&!((this.c[0].promptStartMarker??this.c[0].marker).line>a)){for(let r=this.commands.length-1;r>=0;r--)if((this.commands[r].promptStartMarker??this.commands[r].marker).line<=a)return this.commands[r]}}getCwdForLine(a){if(this.g.promptStartMarker&&a>=this.g.promptStartMarker?.line)return this.f;const r=this.getCommandForLine(a);if(r&&"cwd"in r)return r.cwd}handlePromptStart(a){const r=this.commands.at(-1);r?.endMarker&&r?.executedMarker&&r.endMarker.line===r.executedMarker.line&&(this.L.debug("CommandDetectionCapability#handlePromptStart adjusted commandFinished",`${r.endMarker.line} -> ${r.executedMarker.line+1}`),r.endMarker=$(this.J,r.executedMarker,1)),this.g.promptStartMarker=a?.marker||(r?.endMarker?$(this.J,r.endMarker):this.J.registerMarker(0)),this.L.debug("CommandDetectionCapability#handlePromptStart",this.J.buffer.active.cursorX,this.g.promptStartMarker?.line)}handleContinuationStart(){this.g.currentContinuationMarker=this.J.registerMarker(0),this.L.debug("CommandDetectionCapability#handleContinuationStart",this.g.currentContinuationMarker)}handleContinuationEnd(){if(!this.g.currentContinuationMarker){this.L.warn("CommandDetectionCapability#handleContinuationEnd Received continuation end without start");return}this.g.continuations||(this.g.continuations=[]),this.g.continuations.push({marker:this.g.currentContinuationMarker,end:this.J.buffer.active.cursorX}),this.g.currentContinuationMarker=void 0,this.L.debug("CommandDetectionCapability#handleContinuationEnd",this.g.continuations[this.g.continuations.length-1])}handleRightPromptStart(){this.g.commandRightPromptStartX=this.J.buffer.active.cursorX,this.L.debug("CommandDetectionCapability#handleRightPromptStart",this.g.commandRightPromptStartX)}handleRightPromptEnd(){this.g.commandRightPromptEndX=this.J.buffer.active.cursorX,this.L.debug("CommandDetectionCapability#handleRightPromptEnd",this.g.commandRightPromptEndX)}handleCommandStart(a){if(this.s=a,this.g.commandStartMarker=a?.marker||this.g.commandStartMarker,this.g.commandStartMarker?.line===this.J.buffer.active.cursorY){this.g.commandStartX=this.J.buffer.active.cursorX,this.L.debug("CommandDetectionCapability#handleCommandStart",this.g.commandStartX,this.g.commandStartMarker?.line);return}this.w.value.handleCommandStart(a)}handleGenericCommand(a){a?.markProperties?.disableCommandStorage&&this.setIsCommandStorageDisabled(),this.handlePromptStart(a),this.handleCommandStart(a),this.handleCommandExecuted(a),this.handleCommandFinished(void 0,a)}handleCommandExecuted(a){this.w.value.handleCommandExecuted(a)}handleCommandFinished(a,r){if(this.w.value.preHandleCommandFinished?.(),this.L.debug("CommandDetectionCapability#handleCommandFinished",this.J.buffer.active.cursorX,r?.marker?.line,this.g.command,this.g),a===void 0){const d=this.commands.length>0?this.commands[this.commands.length-1]:void 0;this.g.command&&this.g.command.length>0&&d?.command===this.g.command&&(a=d.exitCode)}if(this.g.commandStartMarker===void 0||!this.J.buffer.active)return;this.g.commandFinishedMarker=r?.marker||this.J.registerMarker(0),this.w.value.postHandleCommandFinished?.();const o=this.g.promoteToFullCommand(this.f,a,this.s?.ignoreCommandLine??!1,r?.markProperties);o&&(this.c.push(o),this.t=new y.$fh(()=>{this.D.fire(o),this.g.isInvalid||(this.L.debug("CommandDetectionCapability#onCommandFinished",o),this.F.fire(o))},50),this.t.schedule()),this.g=new E.$tr(this.J),this.s=void 0}setCommandLine(a,r){this.L.debug("CommandDetectionCapability#setCommandLine",a,r),this.g.command=a,this.g.isTrusted=r}serialize(){const a=this.commands.map(o=>o.serialize(this.r)),r=this.g.serialize(this.f);return r&&a.push(r),{isWindowsPty:this.w.value instanceof m,commands:a}}deserialize(a){a.isWindowsPty&&this.setIsWindowsPty(a.isWindowsPty);const r=this.J.buffer.normal;for(const o of a.commands){if(!o.endLine){const n=o.startLine!==void 0?this.J.registerMarker(o.startLine-(r.baseY+r.cursorY)):void 0;if(!n)continue;this.g.commandStartMarker=o.startLine!==void 0?this.J.registerMarker(o.startLine-(r.baseY+r.cursorY)):void 0,this.g.commandStartX=o.startX,this.g.promptStartMarker=o.promptStartLine!==void 0?this.J.registerMarker(o.promptStartLine-(r.baseY+r.cursorY)):void 0,this.f=o.cwd,this.C.fire({marker:n});continue}const d=E.$sr.deserialize(this.J,o,this.r);d&&(this.c.push(d),this.L.debug("CommandDetectionCapability#onCommandFinished",d),this.F.fire(d))}}}e.$Npb=h,me([(0,L.$yh)(500)],h.prototype,"N",null);class u extends A.$Tc{constructor(a,r,o,d){super(),this.c=a,this.f=r,this.g=o,this.h=d,this.B(a.parser.registerCsiHandler({final:"J"},n=>(n.length>=1&&(n[0]===2||n[0]===3)&&o.clearCommandsInViewport(),!1)))}async handleCommandStart(a){this.g.commitCommandFinished();const r=this.f.currentCommand;r.commandStartX=this.c.buffer.active.cursorX,r.commandStartMarker=a?.marker||this.c.registerMarker(0),r.commandExecutedMarker?.dispose(),r.commandExecutedMarker=void 0,r.commandExecutedX=void 0;for(const o of this.g.commandMarkers)o.dispose();this.g.commandMarkers.length=0,this.g.onCommandStartedEmitter.fire({marker:a?.marker||r.commandStartMarker,markProperties:a?.markProperties}),this.h.debug("CommandDetectionCapability#handleCommandStart",r.commandStartX,r.commandStartMarker?.line)}handleCommandExecuted(a){const r=this.f.currentCommand;if(r.commandExecutedMarker=a?.marker||this.c.registerMarker(0),r.commandExecutedX=this.c.buffer.active.cursorX,this.h.debug("CommandDetectionCapability#handleCommandExecuted",r.commandExecutedX,r.commandExecutedMarker?.line),!r.commandStartMarker||!r.commandExecutedMarker||r.commandStartX===void 0)return;r.command=this.g.isCommandStorageDisabled?"":this.c.buffer.active.getLine(r.commandStartMarker.line)?.translateToString(!0,r.commandStartX,r.commandRightPromptStartX).trim();let o=r.commandStartMarker.line+1;const d=r.commandExecutedMarker.line;for(;o<d;o++){const n=this.c.buffer.active.getLine(o);if(n){const t=r.continuations?.find(w=>w.marker.line===o);t&&(r.command+=`
`);const i=t?.end??0;r.command+=n.translateToString(!0,i)}}o===d&&(r.command+=this.c.buffer.active.getLine(d)?.translateToString(!0,void 0,r.commandExecutedX)||""),this.g.onCommandExecutedEmitter.fire()}}var P;(function(l){l[l.MaxCheckLineCount=5]="MaxCheckLineCount",l[l.Interval=20]="Interval",l[l.MaximumPollCount=50]="MaximumPollCount"})(P||(P={}));let m=class extends A.$Tc{constructor(a,r,o,d){super(),this.r=a,this.s=r,this.t=o,this.u=d,this.c=this.B(new A.$Uc),this.f=!1,this.h=0,this.n=0,this.B(a.parser.registerCsiHandler({final:"J"},n=>(n.length>=1&&(n[0]===2||n[0]===3)&&(this.f=!0,this.t.clearCommandsInViewport()),!1))),this.B(this.s.onBeforeCommandFinished(n=>{if(this.f){this.f=!1;return}(n.command.trim().toLowerCase()==="clear"||n.command.trim().toLowerCase()==="cls")&&(this.g?.cancel(),this.g=void 0,this.t.clearCommandsInViewport(),this.s.currentCommand.isInvalid=!0,this.t.onCurrentCommandInvalidatedEmitter.fire({reason:"windows"}))}))}preHandleResize(a){const r=this.r.buffer.active.baseY,o=a.rows-this.t.dimensions.rows;o>0&&this.F().then(()=>{const d=Math.min(o,r);for(let n=this.s.commands.length-1;n>=0;n--){const t=this.s.commands[n];if(!t.marker||t.marker.line<r||t.commandStartLineContent===void 0)break;const i=this.r.buffer.active.getLine(t.marker.line);if(!i||i.translateToString(!0)===t.commandStartLineContent)continue;const w=t.marker.line-d;this.r.buffer.active.getLine(w)?.translateToString(!0)===t.commandStartLineContent&&this.r._core._bufferService.buffer.lines.onDeleteEmitter.fire({index:this.r.buffer.active.baseY,amount:d})}})}async handleCommandStart(){this.s.currentCommand.commandStartX=this.r.buffer.active.cursorX,this.t.commandMarkers.length=0;const a=this.s.currentCommand.commandStartMarker=this.s.currentCommand.promptStartMarker?$(this.r,this.s.currentCommand.promptStartMarker):this.r.registerMarker(0);this.s.currentCommand.commandStartX=0,this.h=0,this.n=0,this.g=new y.$fh(()=>this.w(a),20),this.g.schedule()}w(a){if(this.q.isDisposed)return;const r=this.r.buffer.active;let o=this.h;for(;o<5&&a.line+o<r.baseY+this.r.rows;){if(this.D()){const d=this.G(a.line+o);if(d){const n=typeof d=="string"?d:d.prompt;if(this.s.currentCommand.commandStartMarker=this.r.registerMarker(0),typeof d=="object"&&d.likelySingleLine){this.u.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted promptStart",`${this.s.currentCommand.promptStartMarker?.line} -> ${this.s.currentCommand.commandStartMarker.line}`),this.s.currentCommand.promptStartMarker?.dispose(),this.s.currentCommand.promptStartMarker=$(this.r,this.s.currentCommand.commandStartMarker);const t=this.s.commands.at(-1);t&&this.s.currentCommand.commandStartMarker.line!==t.endMarker?.line&&(t.endMarker?.dispose(),t.endMarker=$(this.r,this.s.currentCommand.commandStartMarker))}this.s.currentCommand.commandStartX=n.length,this.u.debug("CommandDetectionCapability#_tryAdjustCommandStartMarker adjusted commandStart",`${a.line} -> ${this.s.currentCommand.commandStartMarker.line}:${this.s.currentCommand.commandStartX}`),this.z();return}}o++}o<5?(this.h=o,this.n<50?this.g?.schedule():this.z()):this.z()}z(){if(this.g&&(this.n=50,this.g.flush(),this.g=void 0),this.t.commitCommandFinished(),this.s.currentCommand.commandExecutedMarker||(this.c.value=this.r.onCursorMove(()=>{if(this.t.commandMarkers.length===0||this.t.commandMarkers[this.t.commandMarkers.length-1].line!==this.r.buffer.active.cursorY){const a=this.r.registerMarker(0);a&&this.t.commandMarkers.push(a)}})),this.s.currentCommand.commandStartMarker){const a=this.r.buffer.active.getLine(this.s.currentCommand.commandStartMarker.line);a&&(this.s.currentCommand.commandStartLineContent=a.translateToString(!0))}this.t.onCommandStartedEmitter.fire({marker:this.s.currentCommand.commandStartMarker}),this.u.debug("CommandDetectionCapability#_handleCommandStartWindows",this.s.currentCommand.commandStartX,this.s.currentCommand.commandStartMarker?.line)}handleCommandExecuted(a){this.g&&this.z(),this.c.clear(),this.C(),this.s.currentCommand.commandExecutedX=this.r.buffer.active.cursorX,this.t.onCommandExecutedEmitter.fire(),this.u.debug("CommandDetectionCapability#handleCommandExecuted",this.s.currentCommand.commandExecutedX,this.s.currentCommand.commandExecutedMarker?.line)}preHandleCommandFinished(){this.s.currentCommand.commandExecutedMarker||(this.t.commandMarkers.length===0&&(this.s.currentCommand.commandStartMarker||(this.s.currentCommand.commandStartMarker=this.r.registerMarker(0)),this.s.currentCommand.commandStartMarker&&this.t.commandMarkers.push(this.s.currentCommand.commandStartMarker)),this.C())}postHandleCommandFinished(){const a=this.s.currentCommand,r=a.command,o=a.commandStartMarker?.line,d=a.commandExecutedMarker?.line;if(!r||r.length===0||o===void 0||o===-1||d===void 0||d===-1)return;let n=0,t=!1;for(let i=o;i<=d;i++){const w=this.r.buffer.active.getLine(i);if(!w)break;const j=w.translateToString(!0);for(let g=0;g<j.length;g++){for(;r.length<n&&r[n]===" ";)n++;if(j[g]===r[n]&&n++,n===r.length){const C=g>=this.r.cols-1;a.commandExecutedMarker=this.r.registerMarker(i-(this.r.buffer.active.baseY+this.r.buffer.active.cursorY)+(C?1:0)),a.commandExecutedX=C?0:g+1,t=!0;break}}if(t)break}}C(){if(this.t.commandMarkers.length!==0){if(this.t.commandMarkers=this.t.commandMarkers.sort((a,r)=>a.line-r.line),this.s.currentCommand.commandStartMarker=this.t.commandMarkers[0],this.s.currentCommand.commandStartMarker){const a=this.r.buffer.active.getLine(this.s.currentCommand.commandStartMarker.line);a&&(this.s.currentCommand.commandStartLineContent=a.translateToString(!0))}this.s.currentCommand.commandExecutedMarker=this.t.commandMarkers[this.t.commandMarkers.length-1],this.t.onCommandExecutedEmitter.fire()}}D(){const a=this.s.commands.at(-1);if(!a)return!0;const r=this.r.buffer.active.baseY+this.r.buffer.active.cursorY,o=(a.endMarker?a.endMarker.line:a.marker?.line)??-1;return r>o}F(){const a=this.r.buffer.active.cursorX,r=this.r.buffer.active.cursorY;let o=0;return new Promise((d,n)=>{const t=setInterval(()=>{if(a!==this.r.buffer.active.cursorX||r!==this.r.buffer.active.cursorY){d(),clearInterval(t);return}o+=10,o>1e3&&(clearInterval(t),d())},10)})}G(a=this.r.buffer.active.baseY+this.r.buffer.active.cursorY){const r=this.r.buffer.active.getLine(a);if(!r)return;const o=r.translateToString(!0);if(!o)return;const d=o.match(/(?<prompt>(\(.+\)\s)?(?:PS.+>\s?))/)?.groups?.prompt;if(d){const i=this.H(d,o,">");if(i)return{prompt:i,likelySingleLine:!0}}const n=o.match(/.*\u276f(?=[^\u276f]*$)/g)?.[0];if(n){const i=this.H(n,o,"\u276F");if(i)return i}const t=o.match(/^(?<prompt>(\(.+\)\s)?(?:[A-Z]:\\.*>))/);return t?.groups?.prompt?{prompt:t.groups.prompt,likelySingleLine:!0}:void 0}H(a,r,o){if(a)return r===a&&a.endsWith(o)&&(a+=" "),a}};m=me([Ne(3,I.$nj)],m);function p(l,a,r,o){if(!o)return;const d=a.executedMarker,n=a.endMarker;if(!d||!n)return;const t=d.line,i=n.line,w=o.length,j=[];if(o.anchor==="bottom")for(let g=i-(o.offset||0);g>=t;g--){let C=g;const v=g;for(;C>=t&&l.getLine(C)?.isWrapped;)C--;g=C,j.unshift(s(l,C,v,r)),j.length>w&&j.pop()}else for(let g=t+(o.offset||0);g<i;g++){const C=g;let v=g;for(;v+1<i&&l.getLine(v+1)?.isWrapped;)v++;g=v,j.push(s(l,C,v,r)),j.length===w&&j.shift()}return j}e.$Opb=p;function s(l,a,r,o){const d=Math.max(2048/o*2);r=Math.min(r,a+d);let n="";for(let t=a;t<=r;t++){const i=l.getLine(t);i&&(n+=i.translateToString(!0,0,o))}return n}function $(l,a,r=0){return l.registerMarker(a.line-(l.buffer.active.baseY+l.buffer.active.cursorY)+r)}}),define(le[89],he([0,1,4,2]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ppb=void 0;class k extends L.$Tc{constructor(){super(...arguments),this.type=0,this.a="",this.b=new Map,this.c=this.B(new y.$Vd),this.onDidChangeCwd=this.c.event}get cwds(){return Array.from(this.b.keys())}getCwd(){return this.a}updateCwd(I){const E=this.a!==I;this.a=I;const h=this.b.get(this.a)||0;this.b.delete(this.a),this.b.set(this.a,h+1),E&&this.c.fire(I)}}e.$Ppb=k}),define(le[90],he([0,1,4,2]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qpb=void 0;var k;(function(I){I[I.MinimumPromptLength=2]="MinimumPromptLength"})(k||(k={}));class A extends L.$Sc{get commands(){return this.a}constructor(E){super(),this.c=E,this.type=3,this.a=[],this.b=this.add(new y.$Vd),this.onCommandFinished=this.b.event,this.add(this.c.onData(h=>this.h(h))),this.add(this.c.parser.registerCsiHandler({final:"J"},h=>(h.length>=1&&(h[0]===2||h[0]===3)&&this.m(),!1)))}h(E){E==="\r"&&this.j()}j(){if(this.c&&this.c.buffer.active.cursorX>=2){const E=this.c.registerMarker(0);E&&(this.a.push(E),this.b.fire(E))}}m(){let E=0;for(let h=this.a.length-1;h>=0&&!(this.a[h].line<this.c.buffer.active.baseY);h--)E++;this.a.splice(this.a.length-E,E)}}e.$Qpb=A}),define(le[91],he([0,1,4,2]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mpb=e.$Lpb=void 0;class k extends L.$Tc{constructor(){super(...arguments),this.a=new Map,this.b=this.B(new y.$Vd),this.onDidRemoveCapabilityType=this.b.event,this.f=this.B(new y.$Vd),this.onDidAddCapabilityType=this.f.event,this.g=this.B(new y.$Vd),this.onDidRemoveCapability=this.g.event,this.h=this.B(new y.$Vd),this.onDidAddCapability=this.h.event}get items(){return this.a.keys()}add(E,h){this.a.set(E,h),this.f.fire(E),this.h.fire({id:E,capability:h})}get(E){return this.a.get(E)}remove(E){const h=this.a.get(E);h&&(this.a.delete(E),this.b.fire(E),this.h.fire({id:E,capability:h}))}has(E){return this.a.has(E)}}e.$Lpb=k;class A extends L.$Tc{constructor(){super(...arguments),this._stores=[],this.a=this.B(new y.$Vd),this.onDidRemoveCapabilityType=this.a.event,this.b=this.B(new y.$Vd),this.onDidAddCapabilityType=this.b.event,this.f=this.B(new y.$Vd),this.onDidRemoveCapability=this.f.event,this.g=this.B(new y.$Vd),this.onDidAddCapability=this.g.event}get items(){return this.h()}*h(){for(const E of this._stores)for(const h of E.items)yield h}has(E){for(const h of this._stores)for(const u of h.items)if(u===E)return!0;return!1}get(E){for(const h of this._stores){const u=h.get(E);if(u)return u}}add(E){this._stores.push(E);for(const h of E.items)this.b.fire(h),this.g.fire({id:h,capability:E.get(h)});this.B(E.onDidAddCapabilityType(h=>this.b.fire(h))),this.B(E.onDidAddCapability(h=>this.g.fire(h))),this.B(E.onDidRemoveCapabilityType(h=>this.a.fire(h))),this.B(E.onDidRemoveCapability(h=>this.f.fire(h)))}}e.$Mpb=A}),define(le[36],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var y;(function(L){L[L.Replace=1]="Replace",L[L.Append=2]="Append",L[L.Prepend=3]="Prepend"})(y||(e.EnvironmentVariableMutatorType=y={}))}),define(le[92],he([0,1,3,36]),function(oe,e,y,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sr=void 0;const k=new Map([[L.EnvironmentVariableMutatorType.Append,"APPEND"],[L.EnvironmentVariableMutatorType.Prepend,"PREPEND"],[L.EnvironmentVariableMutatorType.Replace,"REPLACE"]]);class A{constructor(P){this.collections=P,this.a=new Map,this.b=new Map,P.forEach((m,p)=>{this.d(m,p);const s=m.map.entries();let $=s.next();for(;!$.done;){const l=$.value[1],a=$.value[0];let r=this.a.get(a);if(r||(r=[],this.a.set(a,r)),r.length>0&&r[0].type===L.EnvironmentVariableMutatorType.Replace){$=s.next();continue}const o={extensionIdentifier:p,value:l.value,type:l.type,scope:l.scope,variable:l.variable,options:l.options};o.scope||delete o.scope,r.unshift(o),$=s.next()}})}async applyToProcessEnvironment(P,m,p){let s;y.$i&&(s={},Object.keys(P).forEach($=>s[$.toLowerCase()]=$));for(const[$,l]of this.getVariableMap(m)){const a=y.$i&&s[$.toLowerCase()]||$;for(const r of l){const o=p?await p(r.value):r.value;if(r.options?.applyAtProcessCreation??!0)switch(r.type){case L.EnvironmentVariableMutatorType.Append:P[a]=(P[a]||"")+o;break;case L.EnvironmentVariableMutatorType.Prepend:P[a]=o+(P[a]||"");break;case L.EnvironmentVariableMutatorType.Replace:P[a]=o;break}if(r.options?.applyAtShellIntegration??!1){const d=`VSCODE_ENV_${k.get(r.type)}`;P[d]=(P[d]?P[d]+":":"")+$+"="+this.c(o)}}}}c(P){return P.replaceAll(":","\\x3a")}diff(P,m){const p=new Map,s=new Map,$=new Map;if(P.getVariableMap(m).forEach((l,a)=>{const r=this.getVariableMap(m).get(a),o=E(l,r);o&&p.set(a,o)}),this.getVariableMap(m).forEach((l,a)=>{const r=P.getVariableMap(m).get(a),o=E(l,r);o&&$.set(a,o)}),this.getVariableMap(m).forEach((l,a)=>{const r=P.getVariableMap(m).get(a),o=h(l,r);o&&s.set(a,o)}),!(p.size===0&&s.size===0&&$.size===0))return{added:p,changed:s,removed:$}}getVariableMap(P){const m=new Map;for(const p of this.a.values()){const s=p.filter($=>I($,P));s.length>0&&m.set(s[0].variable,s)}return m}getDescriptionMap(P){const m=new Map;for(const p of this.b.values()){const s=p.filter($=>I($,P,!0));for(const $ of s)m.set($.extensionIdentifier,$.description)}return m}d(P,m){if(!P.descriptionMap)return;const p=P.descriptionMap.entries();let s=p.next();for(;!s.done;){const $=s.value[1],l=s.value[0];let a=this.b.get(l);a||(a=[],this.b.set(l,a));const r={extensionIdentifier:m,scope:$.scope,description:$.description};r.scope||delete r.scope,a.push(r),s=p.next()}}}e.$Sr=A;function I(u,P,m=!1){return u.scope?!!(u.scope.workspaceFolder&&P?.workspaceFolder&&u.scope.workspaceFolder.index===P.workspaceFolder.index):m?P===u.scope:!0}function E(u,P){if(!P)return u;const m=new Set;P.forEach(s=>m.add(s.extensionIdentifier));const p=[];return u.forEach(s=>{m.has(s.extensionIdentifier)||p.push(s)}),p.length===0?void 0:p}function h(u,P){if(!P)return;const m=new Map;P.forEach(s=>m.set(s.extensionIdentifier,s));const p=[];return u.forEach(s=>{const $=m.get(s.extensionIdentifier);$&&(s.type!==$.type||s.value!==$.value||s.scope?.workspaceFolder?.index!==$.scope?.workspaceFolder?.index)&&p.push($)}),p.length===0?void 0:p}}),define(le[93],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function y(h){return[...h.entries()]}e.$Mr=y;function L(h){return h?[...h.entries()]:[]}e.$Nr=L;function k(h){return new Map(h)}e.$Or=k;function A(h){return new Map(h??[])}e.$Pr=A;function I(h){return Array.from(h.entries()).map(u=>[u[0],y(u[1].map),L(u[1].descriptionMap)])}e.$Qr=I;function E(h){return new Map(h.map(u=>[u[0],{map:k(u[1]),descriptionMap:A(u[2])}]))}e.$Rr=E}),define(le[94],he([0,1,9,17,4,2,10]),function(oe,e,y,L,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dr=void 0;let E=class extends A.$Tc{constructor(u,P){super(),this.h=P,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new k.$Vd),this.onCreateRequest=this.g.event,this.b=u===void 0?15e3:u,this.B((0,A.$Rc)(()=>{for(const m of this.f.values())(0,A.$Oc)(m)}))}createRequest(u){return new Promise((P,m)=>{const p=++this.a;this.c.set(p,P),this.g.fire({requestId:p,...u});const s=new L.$6d;(0,y.$7g)(this.b,s.token).then(()=>m(`Request ${p} timed out (${this.b}ms)`)),this.f.set(p,[(0,A.$Rc)(()=>s.cancel())])})}acceptReply(u,P){const m=this.c.get(u);m?(this.c.delete(u),(0,A.$Oc)(this.f.get(u)||[]),this.f.delete(u),m(P)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${u}`)}};e.$Dr=E,e.$Dr=E=me([Ne(1,I.$nj)],E)}),define(le[28],he([0,1,21,35,85]),function(oe,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zr=e.$yr=e.$xr=e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.$wr=e.ProcessPropertyType=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.$vr=void 0,e.$vr=new L.$kj("terminalTabFocusMode",!1,!0);var A;(function(t){t.AutomationProfile="terminal.integrated.automationProfile.",t.DefaultProfile="terminal.integrated.defaultProfile.",t.Profiles="terminal.integrated.profiles."})(A||(e.TerminalSettingPrefix=A={}));var I;(function(t){t.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",t.AutomationProfileLinux="terminal.integrated.automationProfile.linux",t.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",t.AutomationProfileWindows="terminal.integrated.automationProfile.windows",t.ProfilesWindows="terminal.integrated.profiles.windows",t.ProfilesMacOs="terminal.integrated.profiles.osx",t.ProfilesLinux="terminal.integrated.profiles.linux",t.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",t.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",t.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",t.UseWslProfiles="terminal.integrated.useWslProfiles",t.TabsDefaultColor="terminal.integrated.tabs.defaultColor",t.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",t.TabsEnabled="terminal.integrated.tabs.enabled",t.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",t.TabsHideCondition="terminal.integrated.tabs.hideCondition",t.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",t.TabsShowActions="terminal.integrated.tabs.showActions",t.TabsLocation="terminal.integrated.tabs.location",t.TabsFocusMode="terminal.integrated.tabs.focusMode",t.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",t.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",t.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",t.CopyOnSelection="terminal.integrated.copyOnSelection",t.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",t.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",t.FontFamily="terminal.integrated.fontFamily",t.FontSize="terminal.integrated.fontSize",t.LetterSpacing="terminal.integrated.letterSpacing",t.LineHeight="terminal.integrated.lineHeight",t.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",t.TabStopWidth="terminal.integrated.tabStopWidth",t.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",t.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",t.BellDuration="terminal.integrated.bellDuration",t.FontWeight="terminal.integrated.fontWeight",t.FontWeightBold="terminal.integrated.fontWeightBold",t.CursorBlinking="terminal.integrated.cursorBlinking",t.CursorStyle="terminal.integrated.cursorStyle",t.CursorStyleInactive="terminal.integrated.cursorStyleInactive",t.CursorWidth="terminal.integrated.cursorWidth",t.Scrollback="terminal.integrated.scrollback",t.DetectLocale="terminal.integrated.detectLocale",t.DefaultLocation="terminal.integrated.defaultLocation",t.GpuAcceleration="terminal.integrated.gpuAcceleration",t.TerminalTitleSeparator="terminal.integrated.tabs.separator",t.TerminalTitle="terminal.integrated.tabs.title",t.TerminalDescription="terminal.integrated.tabs.description",t.RightClickBehavior="terminal.integrated.rightClickBehavior",t.Cwd="terminal.integrated.cwd",t.ConfirmOnExit="terminal.integrated.confirmOnExit",t.ConfirmOnKill="terminal.integrated.confirmOnKill",t.EnableBell="terminal.integrated.enableBell",t.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",t.AllowChords="terminal.integrated.allowChords",t.AllowMnemonics="terminal.integrated.allowMnemonics",t.TabFocusMode="terminal.integrated.tabFocusMode",t.EnvMacOs="terminal.integrated.env.osx",t.EnvLinux="terminal.integrated.env.linux",t.EnvWindows="terminal.integrated.env.windows",t.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",t.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",t.ShowExitAlert="terminal.integrated.showExitAlert",t.SplitCwd="terminal.integrated.splitCwd",t.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",t.WordSeparators="terminal.integrated.wordSeparators",t.EnableFileLinks="terminal.integrated.enableFileLinks",t.UnicodeVersion="terminal.integrated.unicodeVersion",t.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",t.LocalEchoEnabled="terminal.integrated.localEchoEnabled",t.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",t.LocalEchoStyle="terminal.integrated.localEchoStyle",t.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",t.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",t.HideOnStartup="terminal.integrated.hideOnStartup",t.CustomGlyphs="terminal.integrated.customGlyphs",t.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",t.InheritEnv="terminal.integrated.inheritEnv",t.ShowLinkHover="terminal.integrated.showLinkHover",t.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",t.AutoReplies="terminal.integrated.autoReplies",t.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",t.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",t.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",t.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",t.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",t.EnableImages="terminal.integrated.enableImages",t.SmoothScrolling="terminal.integrated.smoothScrolling",t.IgnoreBracketedPasteMode="terminal.integrated.ignoreBracketedPasteMode",t.FocusAfterRun="terminal.integrated.focusAfterRun",t.AccessibleViewPreserveCursorPosition="terminal.integrated.accessibleViewPreserveCursorPosition",t.AccessibleViewFocusOnCommandExecution="terminal.integrated.accessibleViewFocusOnCommandExecution",t.StickyScrollEnabled="terminal.integrated.stickyScroll.enabled",t.StickyScrollMaxLineCount="terminal.integrated.stickyScroll.maxLineCount",t.MouseWheelZoom="terminal.integrated.mouseWheelZoom",t.DeveloperPtyHostLatency="terminal.integrated.developer.ptyHost.latency",t.DeveloperPtyHostStartupDelay="terminal.integrated.developer.ptyHost.startupDelay",t.DevMode="terminal.integrated.developer.devMode"})(I||(e.TerminalSettingId=I={}));var E;(function(t){t.PowerShell="pwsh",t.Bash="bash",t.Fish="fish",t.Sh="sh",t.Csh="csh",t.Ksh="ksh",t.Zsh="zsh"})(E||(e.PosixShellType=E={}));var h;(function(t){t.CommandPrompt="cmd",t.PowerShell="pwsh",t.Wsl="wsl",t.GitBash="gitbash"})(h||(e.WindowsShellType=h={}));var u;(function(t){t[t.Api=0]="Api",t[t.Process=1]="Process",t[t.Sequence=2]="Sequence",t[t.Config=3]="Config"})(u||(e.TitleEventSource=u={}));var P;(function(t){t.LocalPty="localPty",t.PtyHost="ptyHost",t.PtyHostWindow="ptyHostWindow",t.Logger="logger",t.Heartbeat="heartbeat"})(P||(e.TerminalIpcChannels=P={}));var m;(function(t){t.Cwd="cwd",t.InitialCwd="initialCwd",t.FixedDimensions="fixedDimensions",t.Title="title",t.ShellType="shellType",t.HasChildProcesses="hasChildProcesses",t.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",t.OverrideDimensions="overrideDimensions",t.FailedShellIntegrationActivation="failedShellIntegrationActivation",t.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(m||(e.ProcessPropertyType=m={})),e.$wr=(0,y.$6h)("ptyService");var p;(function(t){t[t.BeatInterval=5e3]="BeatInterval",t[t.ConnectingBeatInterval=2e4]="ConnectingBeatInterval",t[t.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",t[t.SecondWaitMultiplier=1]="SecondWaitMultiplier",t[t.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(p||(e.HeartbeatConstants=p={}));var s;(function(t){t[t.Panel=1]="Panel",t[t.Editor=2]="Editor"})(s||(e.TerminalLocation=s={}));var $;(function(t){t.TerminalView="view",t.Editor="editor"})($||(e.TerminalLocationString=$={}));var l;(function(t){t[t.GraceTime=6e4]="GraceTime",t[t.ShortGraceTime=6e3]="ShortGraceTime"})(l||(e.LocalReconnectConstants=l={}));var a;(function(t){t[t.HighWatermarkChars=1e5]="HighWatermarkChars",t[t.LowWatermarkChars=5e3]="LowWatermarkChars",t[t.CharCountAckSize=5e3]="CharCountAckSize"})(a||(e.FlowControlConstants=a={}));var r;(function(t){t.GitBash="Git Bash",t.Pwsh="PowerShell"})(r||(e.ProfileSource=r={}));var o;(function(t){t[t.Off=0]="Off",t[t.FinalTerm=1]="FinalTerm",t[t.VSCode=2]="VSCode"})(o||(e.ShellIntegrationStatus=o={}));var d;(function(t){t[t.Unknown=0]="Unknown",t[t.Shutdown=1]="Shutdown",t[t.Process=2]="Process",t[t.User=3]="User",t[t.Extension=4]="Extension"})(d||(e.TerminalExitReason=d={})),e.$xr={Backend:"workbench.contributions.terminal.processBackend"};class n{constructor(){this.a=new Map}get backends(){return this.a}registerTerminalBackend(i){const w=this.b(i.remoteAuthority);if(this.a.has(w))throw new Error(`A terminal backend with remote authority '${w}' was already registered.`);this.a.set(w,i)}getTerminalBackend(i){return this.a.get(this.b(i))}b(i){return i?.toLowerCase()??""}}k.$Hn.add(e.$xr.Backend,new n),e.$yr=(0,y.$6h)("localPtyService"),e.$zr=(0,y.$6h)("terminalLogService")}),define(le[95],he([0,1,9,2,3]),function(oe,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6dc=void 0;class A extends L.$Tc{constructor(E,h,u,P){super(),this.a=0,this.b=!1,this.c=!1,this.B(E.onProcessData(m=>{if(this.b||this.c)return;const p=typeof m=="string"?m:m.data;for(let s=0;s<p.length;s++)p[s]===h[this.a]?this.a++:this.f(),this.a===h.length&&(P.debug(`Auto reply match: "${h}", response: "${u}"`),E.input(u),this.c=!0,(0,y.$7g)(1e3).then(()=>this.c=!1),this.f())}))}f(){this.a=0}handleResize(){k.$i&&(this.b=!0)}handleInput(){this.b=!1}}e.$6dc=A}),define(le[96],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsb=void 0;class y{constructor(k){this.b=k,this.a=new Map}dispose(){for(const k of this.a.values())k.dispose()}startBuffering(k,A,I=5){const E=A(h=>{const u=typeof h=="string"?h:h.data;let P=this.a.get(k);if(P){P.data.push(u);return}const m=setTimeout(()=>this.flushBuffer(k),I);P={data:[u],timeoutId:m,dispose:()=>{clearTimeout(m),this.flushBuffer(k),E.dispose()}},this.a.set(k,P)});return E}stopBuffering(k){this.a.get(k)?.dispose()}flushBuffer(k){const A=this.a.get(k);A&&(this.a.delete(k),this.b(k,A.data.join("")))}}e.$nsb=y}),define(le[37],he([0,1,3]),function(oe,e,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8N=e.$7N=e.$6N=void 0;function L(I){let E=I;E.includes("\\")&&(E=E.replace(/\\/g,"\\\\"));const h=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return E=E.replace(h,""),`'${E}'`}e.$6N=L;function k(I,E,h){if(!I)return"";if(!E)return I;E.match(/[\/\\]$/)&&(E=E.slice(0,E.length-1));const u=I.replace(/\\/g,"/").toLowerCase(),P=E.replace(/\\/g,"/").toLowerCase();return u.includes(P)?`~${h}${I.slice(E.length+1)}`:I}e.$7N=k;function A(I){return I.match(/^['"].*['"]$/)&&(I=I.substring(1,I.length-1)),y.OS===1&&I&&I[1]===":"?I[0].toUpperCase()+I.substring(1):I}e.$8N=A}),define(le[97],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ur=void 0;var y;(function(k){k[k.WriteMaxChunkSize=50]="WriteMaxChunkSize"})(y||(y={}));function L(k){const A=[];let I=0;for(let E=0;E<k.length-1;E++)(E-I+1>=50||k[E+1]==="\x1B")&&(A.push(k.substring(I,E+1)),I=E+1,E++);return I!==k.length&&A.push(k.substring(I)),A}e.$ur=L}),define(le[98],he([0,1]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QOb=void 0;function y(L,k={}){let A="";return k.excludeLeadingNewLine||(A+=`\r
`),A+="\x1B[0m\x1B[7m * ",k.loudFormatting?A+="\x1B[0;104m":A+="\x1B[0m",A+=` ${L} \x1B[0m
\r`,A}e.$QOb=y}),define(le[99],he([0,1,2,91,88,89,90,4,86,5,37]),function(oe,e,y,L,k,A,I,E,h,u,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vpb=e.$Upb=e.$Tpb=e.$Spb=void 0;var m;(function(o){o[o.FinalTerm=133]="FinalTerm",o[o.VSCode=633]="VSCode",o[o.ITerm=1337]="ITerm",o[o.SetCwd=7]="SetCwd",o[o.SetWindowsFriendlyCwd=9]="SetWindowsFriendlyCwd"})(m||(m={}));var p;(function(o){o.PromptStart="A",o.CommandStart="B",o.CommandExecuted="C",o.CommandFinished="D",o.CommandLine="E",o.ContinuationStart="F",o.ContinuationEnd="G",o.RightPromptStart="H",o.RightPromptEnd="I",o.Property="P",o.SetMark="SetMark"})(p||(p={}));var s;(function(o){o.SetMark="SetMark",o.CurrentDir="CurrentDir"})(s||(s={}));class $ extends y.$Tc{get status(){return this.g}constructor(d,n,t,i){super(),this.j=d,this.m=n,this.n=t,this.r=i,this.capabilities=this.B(new L.$Lpb),this.b=!1,this.f=[],this.g=0,this.h=new E.$Vd,this.onDidChangeStatus=this.h.event,this.B((0,y.$Rc)(()=>{this.z(),this.s()}))}s(){(0,y.$Oc)(this.f),this.f.length=0}activate(d){this.a=d,this.capabilities.add(3,this.B(new I.$Qpb(this.a))),this.B(d.parser.registerOscHandler(633,n=>this.w(n))),this.B(d.parser.registerOscHandler(1337,n=>this.F(n))),this.f.push(d.parser.registerOscHandler(133,n=>this.t(n))),this.B(d.parser.registerOscHandler(7,n=>this.H(n))),this.B(d.parser.registerOscHandler(9,n=>this.G(n))),this.y()}getMarkerId(d,n){this.L(d).getMark(n)}t(d){const n=this.u(d);return this.g===0&&(this.g=1,this.h.fire(this.g)),n}u(d){if(!this.a)return!1;const[n,...t]=d.split(";");switch(n){case"A":return this.J(this.a).handlePromptStart(),!0;case"B":return this.J(this.a).handleCommandStart({ignoreCommandLine:!0}),!0;case"C":return this.J(this.a).handleCommandExecuted(),!0;case"D":{const i=t.length===1?parseInt(t[0]):void 0;return this.J(this.a).handleCommandFinished(i),!0}}return!1}w(d){const n=this.C(d);return!this.b&&n&&(this.n?.publicLog2("terminal/shellIntegrationActivationSucceeded"),this.b=!0,this.z()),this.g!==2&&(this.g=2,this.h.fire(this.g)),n}async y(){!this.n||this.m||(this.c=setTimeout(()=>{!this.capabilities.get(2)&&!this.capabilities.get(0)&&(this.n?.publicLog2("terminal/shellIntegrationActivationTimeout"),this.r.warn("Shell integration failed to add capabilities within 10 seconds")),this.b=!0},1e4))}z(){this.c!==void 0&&(clearTimeout(this.c),this.c=void 0)}C(d){if(!this.a)return!1;const n=d.indexOf(";"),t=n===-1?d:d.substring(0,n),i=n===-1?[]:d.substring(n+1).split(";");switch(t){case"A":return this.J(this.a).handlePromptStart(),!0;case"B":return this.J(this.a).handleCommandStart(),!0;case"C":return this.J(this.a).handleCommandExecuted(),!0;case"D":{const w=i[0],j=w!==void 0?parseInt(w):void 0;return this.J(this.a).handleCommandFinished(j),!0}case"E":{const w=i[0],j=i[1];let g;return w!==void 0?g=l(w):g="",this.J(this.a).setCommandLine(g,j===this.j),!0}case"F":return this.J(this.a).handleContinuationStart(),!0;case"G":return this.J(this.a).handleContinuationEnd(),!0;case"H":return this.J(this.a).handleRightPromptStart(),!0;case"I":return this.J(this.a).handleRightPromptEnd(),!0;case"P":{const w=i[0],j=w!==void 0?l(w):"",{key:g,value:C}=a(j);if(C===void 0)return!0;switch(g){case"Cwd":return this.D(C),!0;case"IsWindows":return this.J(this.a).setIsWindowsPty(C==="True"),!0;case"Task":return this.L(this.a),this.capabilities.get(2)?.setIsCommandStorageDisabled(),!0}}case"SetMark":return this.L(this.a).addMark(r(i)),!0}return!1}D(d){d=(0,P.$8N)(d),this.I().updateCwd(d),this.capabilities.get(2)?.setCwd(d)}F(d){if(!this.a)return!1;const[n]=d.split(";");switch(n){case"SetMark":this.L(this.a).addMark();default:{const{key:t,value:i}=a(n);if(i===void 0)return!0;switch(t){case"CurrentDir":return this.D(i),!0}}}return!1}G(d){if(!this.a)return!1;const[n,...t]=d.split(";");switch(n){case"9":return t.length&&this.D(t[0]),!0}return!1}H(d){if(!this.a)return!1;const[n]=d.split(";");if(n.match(/^file:\/\/.*\//)){const t=u.URI.parse(n);if(t.path&&t.path.length>0)return this.D(t.path),!0}return!1}serialize(){return!this.a||!this.capabilities.has(2)?{isWindowsPty:!1,commands:[]}:this.J(this.a).serialize()}deserialize(d){if(!this.a)throw new Error("Cannot restore commands before addon is activated");this.J(this.a).deserialize(d)}I(){let d=this.capabilities.get(0);return d||(d=this.B(new A.$Ppb),this.capabilities.add(0,d)),d}J(d){let n=this.capabilities.get(2);return n||(n=this.B(new k.$Npb(d,this.r)),this.capabilities.add(2,n)),n}L(d){let n=this.capabilities.get(4);return n||(n=this.B(new h.$Rpb(d)),this.capabilities.add(4,n)),n}}e.$Spb=$;function l(o){return o.replaceAll(/\\(\\|x([0-9a-f]{2}))/gi,(d,n,t)=>t?String.fromCharCode(parseInt(t,16)):n)}e.$Tpb=l;function a(o){const d=o.indexOf("=");return d===-1?{key:o,value:void 0}:{key:o.substring(0,d),value:o.substring(1+d)}}e.$Upb=a;function r(o){let d,n=!1;for(const t of o)t!==void 0&&(t==="Hidden"&&(n=!0),t.startsWith("Id=")&&(d=t.substring(3)));return{id:d,hidden:n}}e.$Vpb=r}),define(le[38],he([0,1,7,14,4,2,62,10]),function(oe,e,y,L,k,A,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8dc=e.$7dc=void 0;var h;(function(P){P[P.InactiveThrottleDuration=5e3]="InactiveThrottleDuration",P[P.ActiveDebounceDuration=1e3]="ActiveDebounceDuration"})(h||(h={})),e.$7dc=[];let u=class extends A.$Tc{set hasChildProcesses(m){this.a!==m&&(this.a=m,this.f.debug("ChildProcessMonitor: Has child processes changed",m),this.b.fire(m))}get hasChildProcesses(){return this.a}constructor(m,p){super(),this.c=m,this.f=p,this.a=!1,this.b=this.B(new k.$Vd),this.onDidChangeHasChildProcesses=this.b.event}handleInput(){this.g()}handleOutput(){this.h()}async g(){if(!this.q.isDisposed)try{const m=await(0,I.$5r)(this.c);this.hasChildProcesses=this.j(m)}catch(m){this.f.debug("ChildProcessMonitor: Fetching process tree failed",m)}}h(){this.g()}j(m){if(!m.children)return!1;if(m.children.length===1){const p=m.children[0];let s;if(p.cmd.startsWith('"'))s=p.cmd.substring(1,p.cmd.indexOf('"',1));else{const $=p.cmd.indexOf(" ");$===-1?s=p.cmd:s=p.cmd.substring(0,$)}return e.$7dc.indexOf((0,y.$qc)(s).name)===-1}return m.children.length>0}};e.$8dc=u,me([(0,L.$yh)(1e3)],u.prototype,"g",null),me([(0,L.$zh)(5e3)],u.prototype,"h",null),e.$8dc=u=me([Ne(1,E.$nj)],u)}),define(le[100],he([0,1,4,2,28]),function(oe,e,y,L,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9dc=void 0;class A extends L.$Tc{constructor(){super(),this.a=this.B(new y.$Vd),this.onBeat=this.a.event;const E=setInterval(()=>{this.a.fire()},k.HeartbeatConstants.BeatInterval);this.B((0,L.$Rc)(()=>clearInterval(E)))}}e.$9dc=A}),define(le[39],he([0,1,20,19,30,7,3,15,11,8,24,36,93,92]),function(oe,e,y,L,k,A,I,E,h,u,P,m,p,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vr=e.$Ur=e.$Tr=void 0;function $(){const g=/(\d+)\.(\d+)\.(\d+)/g.exec(y.release());let C=0;return g&&g.length===4&&(C=parseInt(g[3])),C}e.$Tr=$;async function l(g,C,v,D=E.env,W=P.Promises.exists){if(A.$ic(g))return await W(g)?g:void 0;if(C===void 0&&(C=E.cwd()),A.$mc(g)!=="."){const S=A.$jc(C,g);return await W(S)?S:void 0}const c=(0,k.$Cn)(D,"PATH");if(v===void 0&&(0,u.$If)(c)&&(v=c.split(A.$tc)),v===void 0||v.length===0){const S=A.$jc(C,g);return await W(S)?S:void 0}for(const S of v){let B;if(A.$ic(S)?B=A.$jc(S,g):B=A.$jc(C,S,g),await W(B))return B;if(I.$i){let M=B+".com";if(await W(M)||(M=B+".exe",await W(M)))return M}}const b=A.$jc(C,g);return await W(b)?b:void 0}e.$Ur=l;function a(g,C,v,D,W){const q=I.$i&&(!C.windowsEnableConpty||$()<18309);if(!C.shellIntegration.enabled||!g.executable||g.isFeatureTerminal||g.hideFromUser||g.ignoreShellIntegration||q)return;const c=g.args,b=E.$dc==="win32"?A.$nc(g.executable).toLowerCase():A.$nc(g.executable),S=A.$mc(L.$og.asFileUri("").fsPath);let B;const M={VSCODE_INJECTION:"1"};if(C.shellIntegration.nonce&&(M.VSCODE_NONCE=C.shellIntegration.nonce),I.$i){if(b==="pwsh.exe"||b==="powershell.exe")return!c||w(c)?B=d.get(o.WindowsPwsh):i(c)&&(B=d.get(o.WindowsPwshLogin)),B?(B=[...B],B[B.length-1]=(0,h.$Ke)(B[B.length-1],S,""),C.shellIntegration.suggestEnabled&&(M.VSCODE_SUGGEST="1"),{newArgs:B,envMixin:M}):void 0;D.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args);return}switch(b){case"bash":return!c||c.length===0?B=d.get(o.Bash):j(c)&&(M.VSCODE_SHELL_LOGIN="1",r(C,M),B=d.get(o.Bash)),B?(B=[...B],B[B.length-1]=(0,h.$Ke)(B[B.length-1],S),{newArgs:B,envMixin:M}):void 0;case"fish":{const z=v?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ee=A.$jc(S,"out/vs/workbench/contrib/terminal/browser/media/fish_xdg_data");return M.XDG_DATA_DIRS=`${z}:${ee}`,r(C,M),{newArgs:void 0,envMixin:M}}case"pwsh":return!c||w(c)?B=d.get(o.Pwsh):i(c)&&(B=d.get(o.PwshLogin)),B?(C.shellIntegration.suggestEnabled&&(M.VSCODE_SUGGEST="1"),B=[...B],B[B.length-1]=(0,h.$Ke)(B[B.length-1],S,""),{newArgs:B,envMixin:M}):void 0;case"zsh":{if(!c||c.length===0?B=d.get(o.Zsh):j(c)?(B=d.get(o.ZshLogin),r(C,M)):(c===d.get(o.Zsh)||c===d.get(o.ZshLogin))&&(B=c),!B)return;B=[...B],B[B.length-1]=(0,h.$Ke)(B[B.length-1],S);let z;try{z=y.userInfo().username}catch{z="unknown"}const ee=A.$jc(y.tmpdir(),`${z}-${W.applicationName}-zsh`);M.ZDOTDIR=ee;const ne=v?.ZDOTDIR??y.homedir()??"~";M.USER_ZDOTDIR=ne;const Y=[];return Y.push({source:A.$jc(S,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:A.$jc(ee,".zshrc")}),Y.push({source:A.$jc(S,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:A.$jc(ee,".zprofile")}),Y.push({source:A.$jc(S,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:A.$jc(ee,".zshenv")}),Y.push({source:A.$jc(S,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:A.$jc(ee,".zlogin")}),{newArgs:B,envMixin:M,filesToCopy:Y}}}D.warn(`Shell integration cannot be enabled for executable "${g.executable}" and args`,g.args)}e.$Vr=a;function r(g,C){if(I.$j&&g.environmentVariableCollections){const v=(0,p.$Rr)(g.environmentVariableCollections),W=new s.$Sr(v).getVariableMap({workspaceFolder:g.workspaceFolder}).get("PATH"),q=[];if(W)for(const c of W)c.type===m.EnvironmentVariableMutatorType.Prepend&&q.push(c.value);q.length>0&&(C.VSCODE_PATH_PREFIX=q.join(""))}}var o;(function(g){g.WindowsPwsh="windows-pwsh",g.WindowsPwshLogin="windows-pwsh-login",g.Pwsh="pwsh",g.PwshLogin="pwsh-login",g.Zsh="zsh",g.ZshLogin="zsh-login",g.Bash="bash"})(o||(o={}));const d=new Map;d.set(o.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(o.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(o.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(o.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(o.Zsh,["-i"]),d.set(o.ZshLogin,["-il"]),d.set(o.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const n=["-login","-l"],t=["-nol","-nologo"];function i(g){return typeof g=="string"?n.includes(g.toLowerCase()):g.length===1&&n.includes(g[0].toLowerCase())||g.length===2&&(n.includes(g[0].toLowerCase())||n.includes(g[1].toLowerCase()))&&(t.includes(g[0].toLowerCase())||t.includes(g[1].toLowerCase()))}function w(g){return typeof g=="string"?t.includes(g.toLowerCase()):g.length===0||g?.length===1&&t.includes(g[0].toLowerCase())}function j(g){return g==="string"&&n.includes(g.toLowerCase())||typeof g!="string"&&g.length===1&&n.includes(g[0].toLowerCase())}}),define(le[101],he([0,1,9,14,4,2,3]),function(oe,e,y,L,k,A,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0dc=void 0;const E=["cmd.exe","powershell.exe","pwsh.exe","bash.exe","wsl.exe","ubuntu.exe","ubuntu1804.exe","kali.exe","debian.exe","opensuse-42.exe","sles-12.exe"];let h;class u extends A.$Tc{get shellType(){return this.b}get shellTitle(){return this.c}get onShellNameChanged(){return this.f.event}get onShellTypeChanged(){return this.g.event}constructor(m){if(super(),this.h=m,this.c="",this.f=new k.$Vd,this.g=new k.$Vd,!I.$i)throw new Error(`WindowsShellHelper cannot be instantiated on ${I.$u}`);this.j()}async j(){this.q.isDisposed||this.checkShell()}async checkShell(){I.$i&&(await(0,y.$7g)(300),this.getShellName().then(m=>{const p=this.getShellType(m);p!==this.b&&(this.g.fire(p),this.f.fire(m),this.b=p,this.c=m)}))}m(m){if(!m)return"";if(E.indexOf(m.name)===-1||!m.children||m.children.length===0)return m.name;let p=0;for(;p<m.children.length;p++){const s=m.children[p];if(!s.children||s.children.length===0||s.children[0].name!=="conhost.exe")break}return p>=m.children.length?m.name:this.m(m.children[p])}async getShellName(){return this.q.isDisposed?Promise.resolve(""):this.a?this.a:(h||(h=await new Promise((m,p)=>{oe(["@vscode/windows-process-tree"],m,p)})),this.a=new Promise(m=>{h.getProcessTree(this.h,p=>{const s=this.m(p);this.a=void 0,m(s)})}),this.a)}getShellType(m){switch(m.toLowerCase()){case"cmd.exe":return"cmd";case"powershell.exe":case"pwsh.exe":return"pwsh";case"bash.exe":case"git-cmd.exe":return"gitbash";case"wsl.exe":case"ubuntu.exe":case"ubuntu1804.exe":case"kali.exe":case"debian.exe":case"opensuse-42.exe":case"sles-12.exe":return"wsl";default:return}}}e.$0dc=u,me([(0,L.$yh)(500)],u.prototype,"checkShell",null)}),define(le[102],he([0,1,26,9,4,2,7,3,5,24,71,10,84,38,39,101,107,97]),function(oe,e,y,L,k,A,I,E,h,u,P,m,p,s,$,l,a,r){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$$dc=void 0;var d;(function(j){j[j.DataFlushTimeout=250]="DataFlushTimeout",j[j.MaximumShutdownTime=5e3]="MaximumShutdownTime"})(d||(d={}));var n;(function(j){j[j.KillSpawnThrottleInterval=250]="KillSpawnThrottleInterval",j[j.KillSpawnSpacingDuration=50]="KillSpawnSpacingDuration",j[j.WriteInterval=5]="WriteInterval"})(n||(n={}));const t=new Map([["bash","bash"],["csh","csh"],["fish","fish"],["ksh","ksh"],["sh","sh"],["pwsh","pwsh"],["zsh","zsh"]]);let i=class extends A.$Tc{static{o=this}static{this.b=0}get exitMessage(){return this.h}get currentTitle(){return this.t?.shellTitle||this.n}get shellType(){return E.$i?this.t?.shellType:t.get(this.n)}get hasChildProcesses(){return this.u?.hasChildProcesses||!1}constructor(g,C,v,D,W,q,c,b,S){super(),this.shellLaunchConfig=g,this.N=q,this.O=c,this.P=b,this.Q=S,this.id=0,this.shouldPersist=!1,this.a={cwd:"",initialCwd:"",fixedDimensions:{cols:void 0,rows:void 0},title:"",shellType:void 0,hasChildProcesses:!0,resolvedShellLaunchConfig:{},overrideDimensions:void 0,failedShellIntegrationActivation:!1,usedShellIntegrationInjection:void 0},this.n="",this.w=null,this.y=[],this.G=!1,this.H=0,this.I=this.B(new k.$Vd),this.onProcessData=this.I.event,this.J=this.B(new k.$Vd),this.onProcessReady=this.J.event,this.L=this.B(new k.$Vd),this.onDidChangeProperty=this.L.event,this.M=this.B(new k.$Vd),this.onProcessExit=this.M.event;let B;E.$i?B=I.$nc(this.shellLaunchConfig.executable||""):B="xterm-256color",this.D=C,this.a.initialCwd=this.D,this.a.cwd=this.D;const M=this.O.windowsEnableConpty&&process.platform==="win32"&&(0,$.$Tr)()>=18309;this.F={name:B,cwd:C,env:W,cols:v,rows:D,useConpty:M,conptyInheritCursor:M&&!!g.initialText},E.$i&&(M&&v===0&&D===0&&this.shellLaunchConfig.executable?.endsWith("Git\\bin\\bash.exe")&&(this.C=new w,this.B(this.C.onTrigger(z=>{this.C?.dispose(),this.C=void 0,z.cols&&z.rows&&this.resize(z.cols,z.rows)}))),this.onProcessReady(z=>{this.t=this.B(new l.$0dc(z.pid)),this.B(this.t.onShellTypeChanged(ee=>this.L.fire({type:"shellType",value:ee}))),this.B(this.t.onShellNameChanged(ee=>this.L.fire({type:"title",value:ee})))})),this.B((0,A.$Rc)(()=>{this.w&&(clearInterval(this.w),this.w=null)}))}async start(){const C=(await Promise.all([this.R(),this.S()])).find(D=>D!==void 0);if(C)return C;let v;if(this.O.shellIntegration.enabled)if(v=(0,$.$Vr)(this.shellLaunchConfig,this.O,this.F.env,this.P,this.Q),v){if(this.L.fire({type:"usedShellIntegrationInjection",value:!0}),v.envMixin)for(const[D,W]of Object.entries(v.envMixin))this.F.env||={},this.F.env[D]=W;if(v.filesToCopy)for(const D of v.filesToCopy){await u.Promises.mkdir(I.$mc(D.dest),{recursive:!0});try{await u.Promises.copyFile(D.source,D.dest)}catch{}}}else this.L.fire({type:"failedShellIntegrationActivation",value:!0});try{return await this.U(this.shellLaunchConfig,this.F,v),v?.newArgs?{injectedArgs:v.newArgs}:void 0}catch(D){return this.P.trace("node-pty.node-pty.IPty#spawn native exception",D),{message:`A native exception occurred during launch (${D.message})`}}}async R(){try{if(!(await u.Promises.stat(this.D)).isDirectory())return{message:(0,P.localize)(0,null,this.D.toString())}}catch(g){if(g?.code==="ENOENT")return{message:(0,P.localize)(1,null,this.D.toString())}}this.L.fire({type:"initialCwd",value:this.D})}async S(){const g=this.shellLaunchConfig;if(!g.executable)throw new Error("IShellLaunchConfig.executable not set");const C=g.cwd instanceof h.URI?g.cwd.path:g.cwd,v=g.env&&g.env.PATH?g.env.PATH.split(I.$tc):void 0,D=await(0,$.$Ur)(g.executable,C,v,this.N);if(!D)return{message:(0,P.localize)(2,null,g.executable)};try{const W=await u.Promises.stat(D);if(!W.isFile()&&!W.isSymbolicLink())return{message:(0,P.localize)(3,null,g.executable)};g.executable=D}catch(W){if(W?.code!=="EACCES")throw W}}async U(g,C,v){const D=v?.newArgs||g.args||[];await this.Z(),this.P.trace("node-pty.IPty#spawn",g.executable,D,C);const W=(0,a.spawn)(g.executable,D,C);this.m=W,this.u=this.B(new s.$8dc(W.pid,this.P)),this.u.onDidChangeHasChildProcesses(q=>this.L.fire({type:"hasChildProcesses",value:q})),this.s=new Promise(q=>{this.onProcessReady(()=>q())}),W.onData(q=>{this.H+=q.length,!this.G&&this.H>1e5&&(this.P.trace(`Flow control: Pause (${this.H} > 100000)`),this.G=!0,W.pause()),this.P.trace("node-pty.IPty#onData",q),this.I.fire(q),this.j&&this.X(),this.t?.checkShell(),this.u?.handleOutput()}),W.onExit(q=>{this.g=q.exitCode,this.X()}),this.$(W.pid),this.W(W)}W(g){setTimeout(()=>this.ab(g)),E.$i||(this.w=setInterval(()=>{this.n!==g.process&&this.ab(g)},200))}X(){this.P.getLevel()===m.LogLevel.Trace&&this.P.trace("TerminalProcess#_queueProcessExit",new Error().stack?.replace(/^Error/,"")),this.j&&clearTimeout(this.j),this.j=setTimeout(()=>{this.j=void 0,this.Y()},250)}async Y(){if(await this.s,!this.q.isDisposed){try{this.m&&(await this.Z(),this.P.trace("node-pty.IPty#kill"),this.m.kill())}catch{}this.M.fire(this.g||0),this.dispose()}}async Z(){if(!(!E.$i||!("useConpty"in this.F)||!this.F.useConpty)){for(;Date.now()-o.b<250;)this.P.trace("Throttling kill/spawn call"),await(0,L.$7g)(250-(Date.now()-o.b)+50);o.b=Date.now()}}$(g){this.J.fire({pid:g,cwd:this.D,windowsPty:this.getWindowsPty()})}ab(g){if(this.q.isDisposed)return;this.n=g.process,this.L.fire({type:"title",value:this.n});const C=this.currentTitle.replace(/ \(figterm\)$/g,"");this.L.fire({type:"shellType",value:t.get(C)})}shutdown(g){this.P.getLevel()===m.LogLevel.Trace&&this.P.trace("TerminalProcess#shutdown",new Error().stack?.replace(/^Error/,"")),g&&!E.$i?this.Y():!this.j&&!this.q.isDisposed&&(this.X(),setTimeout(()=>{this.j&&!this.q.isDisposed&&(this.j=void 0,this.Y())},5e3))}input(g,C=!1){this.q.isDisposed||!this.m||(this.y.push(...(0,r.$ur)(g).map(v=>({isBinary:C,data:v}))),this.bb())}async processBinary(g){this.input(g,!0)}async refreshProperty(g){switch(g){case"cwd":{const C=await this.getCwd();return C!==this.a.cwd&&(this.a.cwd=C,this.L.fire({type:"cwd",value:this.a.cwd})),C}case"initialCwd":{const C=await this.getInitialCwd();return C!==this.a.initialCwd&&(this.a.initialCwd=C,this.L.fire({type:"initialCwd",value:this.a.initialCwd})),C}case"title":return this.currentTitle;default:return this.shellType}}async updateProperty(g,C){g==="fixedDimensions"&&(this.a.fixedDimensions=C)}bb(){if(!(this.z!==void 0||this.y.length===0)){if(this.cb(),this.y.length===0){this.z=void 0;return}this.z=setTimeout(()=>{this.z=void 0,this.bb()},5)}}cb(){const g=this.y.shift();this.P.trace("node-pty.IPty#write",g.data),g.isBinary?this.m.write(Buffer.from(g.data,"binary")):this.m.write(g.data),this.u?.handleInput()}resize(g,C){if(!this.q.isDisposed&&!(typeof g!="number"||typeof C!="number"||isNaN(g)||isNaN(C))&&this.m){if(g=Math.max(g,1),C=Math.max(C,1),this.C){this.C.cols=g,this.C.rows=C;return}this.P.trace("node-pty.IPty#resize",g,C);try{this.m.resize(g,C)}catch(v){if(this.P.trace("node-pty.IPty#resize exception "+v.message),this.g!==void 0&&v.message!=="ioctl(2) failed, EBADF"&&v.message!=="Cannot resize a pty that has already exited")throw v}}}clearBuffer(){this.m?.clear()}acknowledgeDataEvent(g){this.H=Math.max(this.H-g,0),this.P.trace(`Flow control: Ack ${g} chars (unacknowledged: ${this.H})`),this.G&&this.H<5e3&&(this.P.trace(`Flow control: Resume (${this.H} < 5000)`),this.m?.resume(),this.G=!1)}clearUnacknowledgedChars(){this.H=0,this.P.trace("Flow control: Cleared all unacknowledged chars, forcing resume"),this.G&&(this.m?.resume(),this.G=!1)}async setUnicodeVersion(g){}getInitialCwd(){return Promise.resolve(this.D)}async getCwd(){if(E.$j)return new Promise(g=>{if(!this.m){g(this.D);return}this.P.trace("node-pty.IPty#pid"),(0,y.exec)("lsof -OPln -p "+this.m.pid+" | grep cwd",{env:{...process.env,LANG:"en_US.UTF-8"}},(C,v,D)=>{!C&&v!==""?g(v.substring(v.indexOf("/"),v.length-1)):(this.P.error("lsof did not run successfully, it may not be on the $PATH?",C,v,D),g(this.D))})});if(E.$k){if(!this.m)return this.D;this.P.trace("node-pty.IPty#pid");try{return await u.Promises.readlink(`/proc/${this.m.pid}/cwd`)}catch{return this.D}}return this.D}getWindowsPty(){return E.$i?{backend:"useConpty"in this.F&&this.F.useConpty?"conpty":"winpty",buildNumber:(0,$.$Tr)()}:void 0}};e.$$dc=i,e.$$dc=i=o=me([Ne(7,m.$nj),Ne(8,p.$Fj)],i);class w extends A.$Tc{get onTrigger(){return this.b.event}constructor(){super(),this.b=this.B(new k.$Vd),this.a=setTimeout(()=>{this.b.fire({rows:this.rows,cols:this.cols})},1e3),this.B((0,A.$Rc)(()=>clearTimeout(this.a)))}}}),define(le[103],he([0,1,26,9,4,2,3,63,10,94,28,96,37,108,39,102,70,38,95,6,99,98,76,14,109]),function(oe,e,y,L,k,A,I,E,h,u,P,m,p,s,$,l,a,r,o,d,n,t,i,w,j){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aec=e.$_dc=void 0;function g(B,M,z){if(typeof z.value!="function")throw new Error("not supported");const ee="value",ne=z.value;z[ee]=async function(...Y){this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Request] PtyService#${ne.name}(${Y.map(ce=>JSON.stringify(ce)).join(", ")})`),this.traceRpcArgs.simulatedLatency&&await(0,L.$7g)(this.traceRpcArgs.simulatedLatency);let se;try{se=await ne.apply(this,Y)}catch(ce){throw this.traceRpcArgs.logService.error(`[RPC Response] PtyService#${ne.name}`,ce),ce}return this.traceRpcArgs.logService.getLevel()===h.LogLevel.Trace&&this.traceRpcArgs.logService.trace(`[RPC Response] PtyService#${ne.name}`,se),se}}e.$_dc=g;let C,v;class D extends A.$Tc{H(M,z){return z(ee=>{this.I.getLevel()===h.LogLevel.Trace&&this.I.trace(`[RPC Event] PtyService#${M}.fire(${JSON.stringify(ee)})`)}),z}get traceRpcArgs(){return{logService:this.I,simulatedLatency:this.M}}constructor(M,z,ee,ne){super(),this.I=M,this.J=z,this.L=ee,this.M=ne,this.a=new Map,this.b=new Map,this.g=new Map,this.j=new Map,this.n=0,this.u=this.B(new k.$Vd),this.onHeartbeat=this.H("_onHeartbeat",this.u.event),this.w=this.B(new k.$Vd),this.onProcessData=this.H("_onProcessData",this.w.event),this.y=this.B(new k.$Vd),this.onProcessReplay=this.H("_onProcessReplay",this.y.event),this.z=this.B(new k.$Vd),this.onProcessReady=this.H("_onProcessReady",this.z.event),this.C=this.B(new k.$Vd),this.onProcessExit=this.H("_onProcessExit",this.C.event),this.D=this.B(new k.$Vd),this.onProcessOrphanQuestion=this.H("_onProcessOrphanQuestion",this.D.event),this.F=this.B(new k.$Vd),this.onDidRequestDetach=this.H("_onDidRequestDetach",this.F.event),this.G=this.B(new k.$Vd),this.onDidChangeProperty=this.H("_onDidChangeProperty",this.G.event),this.B((0,A.$Rc)(()=>{for(const Y of this.a.values())Y.shutdown(!0);this.a.clear()})),this.f=this.B(new u.$Dr(void 0,this.I)),this.f.onCreateRequest(this.F.fire,this.F)}async refreshIgnoreProcessNames(M){r.$7dc.length=0,r.$7dc.push(...M)}async requestDetachInstance(M,z){return this.f.createRequest({workspaceId:M,instanceId:z})}async acceptDetachInstanceReply(M,z){let ee;const ne=this.a.get(z);ne&&(ee=await this.S(z,ne)),this.f.acceptReply(M,ee)}async freePortKillProcess(M){const ee=(await new Promise((ne,Y)=>{(0,y.exec)(I.$i?`netstat -ano | findstr "${M}"`:`lsof -nP -iTCP -sTCP:LISTEN | grep ${M}`,{},(se,ce)=>{if(se)return Y("Problem occurred when listing active processes");ne(ce)})})).split(/\r?\n/).filter(ne=>!!ne.trim());if(ee.length>=1){const ne=/\s+(\d+)(?:\s+|$)/,Y=ee[0].match(ne)?.[1];if(Y)try{process.kill(Number.parseInt(Y))}catch{}else throw new Error(`Processes for port ${M} were not found`);return{port:M,processId:Y}}throw new Error(`Could not kill process with port ${M}`)}async serializeTerminalState(M){const z=[];for(const[ne,Y]of this.a.entries())Y.hasWrittenData&&M.indexOf(ne)!==-1&&z.push(L.Promises.withAsyncBody(async se=>{se({id:ne,shellLaunchConfig:Y.shellLaunchConfig,processDetails:await this.S(ne,Y),processLaunchConfig:Y.processLaunchOptions,unicodeVersion:Y.unicodeVersion,replayEvent:await Y.serializeNormalBuffer(),timestamp:Date.now()})}));const ee={version:1,state:await Promise.all(z)};return JSON.stringify(ee)}async reviveTerminalProcesses(M,z,ee){const ne=[];for(const Y of z)ne.push(this.N(M,Y));await Promise.all(ne)}async N(M,z){const ee=(0,a.localize)(0,null),ne=await this.createProcess({...z.shellLaunchConfig,cwd:z.processDetails.cwd,color:z.processDetails.color,icon:z.processDetails.icon,name:z.processDetails.titleSource===P.TitleEventSource.Api?z.processDetails.title:void 0,initialText:z.replayEvent.events[0].data+(0,t.$QOb)(ee,{loudFormatting:!0})},z.processDetails.cwd,z.replayEvent.events[0].cols,z.replayEvent.events[0].rows,z.unicodeVersion,z.processLaunchConfig.env,z.processLaunchConfig.executableEnv,z.processLaunchConfig.options,!0,z.processDetails.workspaceId,z.processDetails.workspaceName,!0,z.replayEvent.events[0].data),Y=this.R(M,z.id);this.g.set(Y,{newId:ne,state:z}),this.I.info(`Revived process, old id ${Y} -> new id ${ne}`)}async shutdownAll(){this.dispose()}async createProcess(M,z,ee,ne,Y,se,ce,fe,X,V,K,te,H){if(M.attachPersistentProcess)throw new Error("Attempt to create a process when attach object was provided");const x=++this.n,ge=new l.$$dc(M,z,ee,ne,se,ce,fe,this.I,this.J),_={env:se,executableEnv:ce,options:fe},f=new q(x,ge,V,K,X,ee,ne,_,Y,this.L,this.I,te&&typeof M.initialText=="string"?M.initialText:void 0,H,M.icon,M.color,M.name,M.fixedDimensions);return ge.onProcessExit(U=>{f.dispose(),this.a.delete(x),this.C.fire({id:x,event:U})}),f.onProcessData(U=>this.w.fire({id:x,event:U})),f.onProcessReplay(U=>this.y.fire({id:x,event:U})),f.onProcessReady(U=>this.z.fire({id:x,event:U})),f.onProcessOrphanQuestion(()=>this.D.fire({id:x})),f.onDidChangeProperty(U=>this.G.fire({id:x,property:U})),f.onPersistentProcessReady(()=>{for(const U of this.j.entries())f.installAutoReply(U[0],U[1])}),this.a.set(x,f),x}async attachToProcess(M){try{await this.U(M).attach(),this.I.info(`Persistent process reconnection "${M}"`)}catch(z){throw this.I.warn(`Persistent process reconnection "${M}" failed`,z.message),z}}async updateTitle(M,z,ee){this.U(M).setTitle(z,ee)}async updateIcon(M,z,ee,ne){this.U(M).setIcon(z,ee,ne)}async clearBuffer(M){this.U(M).clearBuffer()}async refreshProperty(M,z){return this.U(M).refreshProperty(z)}async updateProperty(M,z,ee){return this.U(M).updateProperty(z,ee)}async detachFromProcess(M,z){return this.U(M).detach(z)}async reduceConnectionGraceTime(){for(const M of this.a.values())M.reduceGraceTime()}async listProcesses(){const M=Array.from(this.a.entries()).filter(([ne,Y])=>Y.shouldPersistTerminal);this.I.info(`Listing ${M.length} persistent terminals, ${this.a.size} total terminals`);const z=M.map(async([ne,Y])=>this.S(ne,Y));return(await Promise.all(z)).filter(ne=>ne.isOrphan)}async getPerformanceMarks(){return j.getMarks()}async start(M){const z=this.a.get(M);return z?z.start():{message:`Could not find pty with id "${M}"`}}async shutdown(M,z){return this.a.get(M)?.shutdown(z)}async input(M,z){return this.U(M).input(z)}async processBinary(M,z){return this.U(M).writeBinary(z)}async resize(M,z,ee){return this.U(M).resize(z,ee)}async getInitialCwd(M){return this.U(M).getInitialCwd()}async getCwd(M){return this.U(M).getCwd()}async acknowledgeDataEvent(M,z){return this.U(M).acknowledgeDataEvent(z)}async setUnicodeVersion(M,z){return this.U(M).setUnicodeVersion(z)}async getLatency(){return[]}async orphanQuestionReply(M){return this.U(M).orphanQuestionReply()}async installAutoReply(M,z){this.j.set(M,z);for(const ee of this.a.values())ee.installAutoReply(M,z)}async uninstallAllAutoReplies(){for(const M of this.j.keys())for(const z of this.a.values())z.uninstallAutoReply(M)}async uninstallAutoReply(M){for(const z of this.a.values())z.uninstallAutoReply(M)}async getDefaultSystemShell(M=I.OS){return(0,E.$Vl)(M,process.env)}async getEnvironment(){return{...process.env}}async getWslPath(M,z){if(z==="win-to-unix"){if(!I.$i)return M;if((0,$.$Tr)()<17063)return M.replace(/\\/g,"/");const ee=this.O();return ee?new Promise(ne=>{(0,y.execFile)(ee,["-e","wslpath",M],{},(se,ce,fe)=>{ne(se?M:(0,p.$6N)(ce.trim()))}).stdin.end()}):M}if(z==="unix-to-win"&&I.$i){if((0,$.$Tr)()<17063)return M;const ee=this.O();return ee?new Promise(ne=>{(0,y.execFile)(ee,["-e","wslpath","-w",M],{},(se,ce,fe)=>{ne(se?M:ce.trim())}).stdin.end()}):M}return M}O(){const M=(0,$.$Tr)()>=16299,z=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),ee=process.env.SystemRoot;if(ee)return(0,i.join)(ee,z?"Sysnative":"System32",M?"wsl.exe":"bash.exe")}async getRevivedPtyNewId(M,z){try{return this.g.get(this.R(M,z))?.newId}catch(ee){this.I.warn(`Couldn't find terminal ID ${M}-${z}`,ee.message)}}async setTerminalLayoutInfo(M){this.b.set(M.workspaceId,M)}async getTerminalLayoutInfo(M){j.mark("code/willGetTerminalLayoutInfo");const z=this.b.get(M.workspaceId);if(z){const ee=new Set,Y=(await Promise.all(z.tabs.map(async se=>this.P(M.workspaceId,se,ee)))).filter(se=>se.terminals.length>0);return j.mark("code/didGetTerminalLayoutInfo"),{tabs:Y}}j.mark("code/didGetTerminalLayoutInfo")}async P(M,z,ee){const Y=(await Promise.all(z.terminals.map(se=>this.Q(M,se,ee)))).filter(se=>se.terminal!==null);return{isActive:z.isActive,activePersistentProcessId:z.activePersistentProcessId,terminals:Y}}async Q(M,z,ee){try{const ne=this.R(M,z.terminal),Y=this.g.get(ne)?.newId;this.I.info(`Expanding terminal instance, old id ${ne} -> new id ${Y}`),this.g.delete(ne);const se=Y??z.terminal;if(ee.has(se))throw new Error(`Terminal ${se} has already been expanded`);ee.add(se);const ce=this.U(se);return{terminal:{...ce&&await this.S(z.terminal,ce,Y!==void 0),id:se},relativeSize:z.relativeSize}}catch(ne){return this.I.warn("Couldn't get layout info, a terminal was probably disconnected",ne.message),this.I.debug("Reattach to wrong terminal debug info - layout info by id",z),this.I.debug("Reattach to wrong terminal debug info - _revivePtyIdMap",Array.from(this.g.values())),this.I.debug("Reattach to wrong terminal debug info - _ptys ids",Array.from(this.a.keys())),{terminal:null,relativeSize:z.relativeSize}}}R(M,z){return`${M}-${z}`}async S(M,z,ee=!1){j.mark(`code/willBuildProcessDetails/${M}`);const[ne,Y]=await Promise.all([z.getCwd(),ee?!0:z.isOrphaned()]),se={id:M,title:z.title,titleSource:z.titleSource,pid:z.pid,workspaceId:z.workspaceId,workspaceName:z.workspaceName,cwd:ne,isOrphan:Y,icon:z.icon,color:z.color,fixedDimensions:z.fixedDimensions,environmentVariableCollections:z.processLaunchOptions.options.environmentVariableCollections,reconnectionProperties:z.shellLaunchConfig.reconnectionProperties,waitOnExit:z.shellLaunchConfig.waitOnExit,hideFromUser:z.shellLaunchConfig.hideFromUser,isFeatureTerminal:z.shellLaunchConfig.isFeatureTerminal,type:z.shellLaunchConfig.type,hasChildProcesses:z.hasChildProcesses,shellIntegrationNonce:z.processLaunchOptions.options.shellIntegration.nonce};return j.mark(`code/didBuildProcessDetails/${M}`),se}U(M){const z=this.a.get(M);if(!z)throw new d.$bb("Could not find pty on pty host");return z}}e.$aec=D,me([w.$xh],D.prototype,"traceRpcArgs",null),me([g],D.prototype,"refreshIgnoreProcessNames",null),me([g],D.prototype,"requestDetachInstance",null),me([g],D.prototype,"acceptDetachInstanceReply",null),me([g],D.prototype,"freePortKillProcess",null),me([g],D.prototype,"serializeTerminalState",null),me([g],D.prototype,"reviveTerminalProcesses",null),me([g],D.prototype,"shutdownAll",null),me([g],D.prototype,"createProcess",null),me([g],D.prototype,"attachToProcess",null),me([g],D.prototype,"updateTitle",null),me([g],D.prototype,"updateIcon",null),me([g],D.prototype,"clearBuffer",null),me([g],D.prototype,"refreshProperty",null),me([g],D.prototype,"updateProperty",null),me([g],D.prototype,"detachFromProcess",null),me([g],D.prototype,"reduceConnectionGraceTime",null),me([g],D.prototype,"listProcesses",null),me([g],D.prototype,"getPerformanceMarks",null),me([g],D.prototype,"start",null),me([g],D.prototype,"shutdown",null),me([g],D.prototype,"input",null),me([g],D.prototype,"processBinary",null),me([g],D.prototype,"resize",null),me([g],D.prototype,"getInitialCwd",null),me([g],D.prototype,"getCwd",null),me([g],D.prototype,"acknowledgeDataEvent",null),me([g],D.prototype,"setUnicodeVersion",null),me([g],D.prototype,"getLatency",null),me([g],D.prototype,"orphanQuestionReply",null),me([g],D.prototype,"installAutoReply",null),me([g],D.prototype,"uninstallAllAutoReplies",null),me([g],D.prototype,"uninstallAutoReply",null),me([g],D.prototype,"getDefaultSystemShell",null),me([g],D.prototype,"getEnvironment",null),me([g],D.prototype,"getWslPath",null),me([g],D.prototype,"getRevivedPtyNewId",null),me([g],D.prototype,"setTerminalLayoutInfo",null),me([g],D.prototype,"getTerminalLayoutInfo",null);var W;(function(B){B.None="None",B.ReplayOnly="ReplayOnly",B.Session="Session"})(W||(W={}));class q extends A.$Tc{get pid(){return this.L}get shellLaunchConfig(){return this.W.shellLaunchConfig}get hasWrittenData(){return this.j.value!=="None"}get title(){return this.N||this.W.currentTitle}get titleSource(){return this.O}get icon(){return this.Y}get color(){return this.Z}get fixedDimensions(){return this.R}get hasChildProcesses(){return this.W.hasChildProcesses}setTitle(M,z){z===P.TitleEventSource.Api&&(this.j.setValue("Session","setTitle"),this.P.freeRawReviveBuffer()),this.N=M,this.O=z}setIcon(M,z,ee){(!this.Y||"id"in z&&"id"in this.Y&&z.id!==this.Y.id||!this.color||ee!==this.Z)&&(this.P.freeRawReviveBuffer(),M&&this.j.setValue("Session","setIcon")),this.Y=z,this.Z=ee}S(M){this.R=M}constructor(M,z,ee,ne,Y,se,ce,fe,X,V,K,te,H,x,ge,_,f){super(),this.U=M,this.W=z,this.workspaceId=ee,this.workspaceName=ne,this.shouldPersistTerminal=Y,this.processLaunchOptions=fe,this.unicodeVersion=X,this.X=K,this.Y=x,this.Z=ge,this.b=new Map,this.f=new Map,this.g=!1,this.w=new L.$ah,this.C=this.B(new k.$Vd),this.onProcessReplay=this.C.event,this.D=this.B(new k.$Vd),this.onProcessReady=this.D.event,this.F=this.B(new k.$Vd),this.onPersistentProcessReady=this.F.event,this.G=this.B(new k.$Vd),this.onProcessData=this.G.event,this.H=this.B(new k.$Vd),this.onProcessOrphanQuestion=this.H.event,this.I=this.B(new k.$Vd),this.onDidChangeProperty=this.I.event,this.J=!1,this.L=-1,this.M="",this.O=P.TitleEventSource.Process,this.j=new c(`Persistent process "${this.U}" interaction state`,"None",this.X),this.Q=te!==void 0,this.P=new b(se,ce,V.scrollback,X,te,fe.options.shellIntegration.nonce,Y?H:void 0,this.X),_&&this.setTitle(_,P.TitleEventSource.Api),this.R=f,this.n=null,this.u=0,this.y=this.B(new L.$gh(()=>{this.X.info(`Persistent process "${this.U}": The reconnection grace time of ${S(V.graceTime)} has expired, shutting down pid "${this.L}"`),this.shutdown(!0)},V.graceTime)),this.z=this.B(new L.$gh(()=>{this.X.info(`Persistent process "${this.U}": The short reconnection grace time of ${S(V.shortGraceTime)} has expired, shutting down pid ${this.L}`),this.shutdown(!0)},V.shortGraceTime)),this.B(this.W.onProcessExit(()=>this.a.stopBuffering(this.U))),this.B(this.W.onProcessReady(U=>{this.L=U.pid,this.M=U.cwd,this.D.fire(U)})),this.B(this.W.onDidChangeProperty(U=>{this.I.fire(U)})),this.a=new m.$nsb((U,re)=>this.G.fire(re)),this.B(this.a.startBuffering(this.U,this.W.onProcessData)),this.B(this.onProcessData(U=>this.P.handleData(U))),this.B((0,A.$Rc)(()=>{for(const U of this.b.values())U.dispose();this.b.clear()}))}async attach(){!this.y.isScheduled()&&!this.z.isScheduled()&&this.X.warn(`Persistent process "${this.U}": Process had no disconnect runners but was an orphan`),this.y.cancel(),this.z.cancel()}async detach(M){this.shouldPersistTerminal&&(this.j.value!=="None"||M)?this.y.schedule():this.shutdown(!0)}serializeNormalBuffer(){return this.P.generateReplayEvent(!0,this.j.value!=="Session")}async refreshProperty(M){return this.W.refreshProperty(M)}async updateProperty(M,z){if(M==="fixedDimensions")return this.S(z)}async start(){if(!this.g){const M=await this.W.start();return M&&"message"in M||(this.g=!0,this.Q?this.triggerReplay():this.F.fire()),M}this.D.fire({pid:this.L,cwd:this.M,windowsPty:this.W.getWindowsPty()}),this.I.fire({type:"title",value:this.W.currentTitle}),this.I.fire({type:"shellType",value:this.W.shellType}),this.triggerReplay()}shutdown(M){return this.W.shutdown(M)}input(M){if(this.j.setValue("Session","input"),this.P.freeRawReviveBuffer(),!this.J){for(const z of this.b.values())z.handleInput();return this.W.input(M)}}writeBinary(M){return this.W.processBinary(M)}resize(M,z){if(!this.J){this.P.handleResize(M,z),this.a.flushBuffer(this.U);for(const ee of this.b.values())ee.handleResize();return this.W.resize(M,z)}}async clearBuffer(){this.P.clearBuffer(),this.W.clearBuffer()}setUnicodeVersion(M){this.unicodeVersion=M,this.P.setUnicodeVersion?.(M)}acknowledgeDataEvent(M){if(!this.J)return this.W.acknowledgeDataEvent(M)}getInitialCwd(){return this.W.getInitialCwd()}getCwd(){return this.W.getCwd()}async triggerReplay(){this.j.value==="None"&&this.j.setValue("ReplayOnly","triggerReplay");const M=await this.P.generateReplayEvent();let z=0;for(const ee of M.events)z+=ee.data.length;this.X.info(`Persistent process "${this.U}": Replaying ${z} chars and ${M.events.length} size events`),this.C.fire(M),this.W.clearUnacknowledgedChars(),this.F.fire()}installAutoReply(M,z){this.b.get(M)?.dispose(),this.b.set(M,new o.$6dc(this.W,M,z,this.X))}uninstallAutoReply(M){this.b.get(M)?.dispose(),this.b.delete(M)}sendCommandResult(M,z,ee){this.f.get(M)&&this.f.delete(M)}orphanQuestionReply(){if(this.u=Date.now(),this.n){const M=this.n;this.n=null,M.open()}}reduceGraceTime(){this.z.isScheduled()||this.y.isScheduled()&&this.z.schedule()}async isOrphaned(){return await this.w.queue(async()=>this.$())}async $(){return this.y.isScheduled()||this.z.isScheduled()?!0:(this.n||(this.n=new L.$6g(4e3),this.u=0,this.H.fire()),await this.n.wait(),Date.now()-this.u>500)}}class c{get value(){return this.b}setValue(M,z){this.b!==M&&(this.b=M,this.f(z))}constructor(M,z,ee){this.a=M,this.b=z,this.d=ee,this.f("initialized")}f(M){this.d.debug(`MutationLogger "${this.a}" set to "${this.b}", reason: ${M}`)}}class b{constructor(M,z,ee,ne,Y,se,ce,fe){this.f=ce,this.a=new s.Terminal({cols:M,rows:z,scrollback:ee,allowProposedApi:!0}),Y&&this.a.writeln(Y),this.setUnicodeVersion(ne),this.b=new n.$Spb(se,!0,void 0,fe),this.a.loadAddon(this.b)}freeRawReviveBuffer(){this.f=void 0}handleData(M){this.a.write(M)}handleResize(M,z){this.a.resize(M,z)}clearBuffer(){this.a.clear()}async generateReplayEvent(M,z){const ee=new(await this._getSerializeConstructor());this.a.loadAddon(ee);const ne={scrollback:this.a.options.scrollback};M&&(ne.excludeAltBuffer=!0,ne.excludeModes=!0);let Y;return z&&this.f?Y=this.f:Y=ee.serialize(ne),{events:[{cols:this.a.cols,rows:this.a.rows,data:Y}],commands:this.b.serialize()}}async setUnicodeVersion(M){this.a.unicode.activeVersion!==M&&(M==="11"?(this.d=new(await this._getUnicode11Constructor()),this.a.loadAddon(this.d)):(this.d?.dispose(),this.d=void 0),this.a.unicode.activeVersion=M)}async _getUnicode11Constructor(){return v||(v=(await new Promise((M,z)=>{oe(["@xterm/addon-unicode11"],M,z)})).Unicode11Addon),v}async _getSerializeConstructor(){return C||(C=(await new Promise((M,z)=>{oe(["@xterm/addon-serialize"],M,z)})).SerializeAddon),C}}function S(B){let M=0,z=0,ee=0;B>=1e3&&(ee=Math.floor(B/1e3),B-=ee*1e3),ee>=60&&(z=Math.floor(ee/60),ee-=z*60),z>=60&&(M=Math.floor(z/60),z-=M*60);const ne=M?`${M}h`:"",Y=z?`${z}m`:"",se=ee?`${ee}s`:"",ce=B?`${B}ms`:"";return`${ne}${Y}${se}${ce}`}}),define(le[110],he([0,1,60,27,64,65,12,74,77,10,79,80,82,83,28,100,103,31,9,2]),function(oe,e,y,L,k,A,I,E,h,u,P,m,p,s,$,l,a,r,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),n();async function n(){const t=parseInt(process.env.VSCODE_STARTUP_DELAY??"0"),i=parseInt(process.env.VSCODE_LATENCY??"0"),w={graceTime:parseInt(process.env.VSCODE_RECONNECT_GRACE_TIME||"0"),shortGraceTime:parseInt(process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME||"0"),scrollback:parseInt(process.env.VSCODE_RECONNECT_SCROLLBACK||"100")};delete process.env.VSCODE_RECONNECT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SHORT_GRACE_TIME,delete process.env.VSCODE_RECONNECT_SCROLLBACK,delete process.env.VSCODE_LATENCY,delete process.env.VSCODE_STARTUP_DELAY,t&&await(0,o.$7g)(t);const j=(0,r.$MU)(process);let g;j?g=new A.$NU:g=new k.$qq($.TerminalIpcChannels.PtyHost);const C={_serviceBrand:void 0,...s.default},v=new h.$Bm((0,E.$Yl)(process.argv,E.$Xl),C),D=new p.$sO((0,u.$Bj)(v),v.logsHome);g.registerChannel($.TerminalIpcChannels.Logger,new P.$Br(D,()=>y.$5m));const W=D.createLogger("ptyhost",{name:(0,I.localize)(0,null)}),q=new m.$CO(W);t&&q.warn(`Pty Host startup is delayed ${t}ms`),i&&q.warn(`Pty host is simulating ${i}ms latency`);const c=new d.$Sc,b=new l.$9dc;g.registerChannel($.TerminalIpcChannels.Heartbeat,L.ProxyChannel.fromService(b,c));const S=new a.$aec(q,C,w,i),B=L.ProxyChannel.fromService(S,c);g.registerChannel($.TerminalIpcChannels.PtyHost,B),j&&g.registerChannel($.TerminalIpcChannels.PtyHostWindow,B),process.once("exit",()=>{q.trace("Pty host exiting"),q.dispose(),b.dispose(),S.dispose()})}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/271fb7fbd599b49a1482ea7284a50b3229317f96/core/vs/platform/terminal/node/ptyHostMain.js.map
