/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ke=["exports","require","vs/base/common/uri","vs/base/common/lifecycle","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/async","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/errors","vs/workbench/api/common/extHostTypeConverters","vs/base/common/network","vs/base/common/path","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/editor/common/core/range","vs/base/common/uuid","vs/base/node/pfs","vs/platform/files/common/files","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/base/common/glob","vs/workbench/services/search/common/search","vs/platform/registry/common/platform","vs/base/common/stopwatch","vs/base/common/severity","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/lazy","vs/base/common/errorMessage","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/editor/common/core/position","vs/base/common/process","child_process","vs/platform/configuration/common/configuration","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/hash","vs/base/common/themables","vs/base/common/marshalling","fs","vs/base/common/performance","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","net","os","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/collections","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/editor/common/model","vs/base/common/htmlContent","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/languages","vs/platform/instantiation/common/extensions","vs/platform/files/common/watcher","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/stream","vs/editor/common/model/textModelSearch","vs/base/common/mime","vs/base/common/processes","vs/base/common/labels","vs/base/node/extpath","vs/base/node/processes","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/sign/common/sign","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/parts/ipc/node/ipc.net","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/filters","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/base/common/comparers","vs/base/common/fuzzyScorer","vs/base/common/uriIpc","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/sign/node/signService","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/amd","vs/base/common/arraysFind","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/base/node/ports","vs/editor/common/core/eolCounter","vs/editor/common/core/editOperation","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/services/treeViewsDnd","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/console","vs/amdX","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/editor/common/languages","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostChatAgents2","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/remote/common/tunnelModel","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/dialogs/common/dialogs","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/io","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/managedSocket","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/remoteSocketFactoryService","vs/platform/sign/common/abstractSignService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostLoggerService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChat","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatProvider","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInlineChat","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostDiskFileSystemProvider","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/services/remote/common/tunnelModel","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/platform/tunnel/node/tunnelService","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHostTunnelService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","graceful-fs","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],Se=function(ge){for(var e=[],C=0,N=ge.length;C<N;C++)e[C]=ke[ge[C]];return e};define(ke[157],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class C{static get(){const f=new Map,P=new Map,R=new Map,v=new Map;function $(E,S){E.has(S.detail)||E.set(S.detail,-S.timestamp)}function k(E,S){const c=E.get(S.detail);c&&(c>=0||E.set(S.detail,c+S.timestamp))}let A=[];typeof ge=="function"&&typeof ge.getStats=="function"&&(A=ge.getStats().slice(0).sort((E,S)=>E.timestamp-S.timestamp));for(const E of A)switch(E.type){case 10:$(f,E);break;case 11:case 12:k(f,E);break;case 21:$(P,E);break;case 22:k(P,E);break;case 33:$(R,E);break;case 34:k(R,E);break;case 31:$(v,E);break;case 32:k(v,E);break}let D=0;R.forEach(E=>D+=E);function w(E){const S=[];return E.forEach((c,g)=>S.push([g,c])),S}return{amdLoad:w(f),amdInvoke:w(P),nodeRequire:w(R),nodeEval:w(v),nodeRequireTotal:D}}static toMarkdownTable(f,P){let R="";const v=[];return f.forEach(($,k)=>{v[k]=$.length}),P.forEach($=>{$.forEach((k,A)=>{typeof k>"u"&&(k=$[A]="-");const D=k.toString().length;v[A]=Math.max(D,v[A])})}),f.forEach(($,k)=>{R+=`| ${$+" ".repeat(v[k]-$.toString().length)} `}),R+=`|
`,f.forEach(($,k)=>{R+=`| ${"-".repeat(v[k])} `}),R+=`|
`,P.forEach($=>{$.forEach((k,A)=>{typeof k<"u"&&(R+=`| ${k+" ".repeat(v[A]-k.toString().length)} `)}),R+=`|
`}),R}}e.$U=C}),define(ke[158],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rb=e.$qb=e.$pb=e.$ob=e.$nb=e.$mb=e.$lb=e.$kb=e.$jb=e.$ib=e.$hb=e.$gb=e.$fb=void 0;function C(c,g,o){const i=N(c,g);if(i!==-1)return c[i]}e.$fb=C;function N(c,g,o=c.length-1){for(let i=o;i>=0;i--){const r=c[i];if(g(r))return i}return-1}e.$gb=N;function f(c,g){const o=P(c,g);return o===-1?void 0:c[o]}e.$hb=f;function P(c,g,o=0,i=c.length){let r=o,n=i;for(;r<n;){const a=Math.floor((r+n)/2);g(c[a])?r=a+1:n=a}return r-1}e.$ib=P;function R(c,g){const o=v(c,g);return o===c.length?void 0:c[o]}e.$jb=R;function v(c,g,o=0,i=c.length){let r=o,n=i;for(;r<n;){const a=Math.floor((r+n)/2);g(c[a])?n=a:r=a+1}return r}e.$kb=v;function $(c,g,o=0,i=c.length){const r=v(c,g,o,i);return r===c.length?-1:r}e.$lb=$;class k{static{this.assertInvariants=!1}constructor(g){this.e=g,this.c=0}findLastMonotonous(g){if(k.assertInvariants){if(this.d){for(const i of this.e)if(this.d(i)&&!g(i))throw new Error("MonotonousArray: current predicate must be weaker than (or equal to) the previous predicate.")}this.d=g}const o=P(this.e,g,this.c);return this.c=o+1,o===-1?void 0:this.e[o]}}e.$mb=k;function A(c,g){if(c.length===0)return;let o=c[0];for(let i=1;i<c.length;i++){const r=c[i];g(r,o)>0&&(o=r)}return o}e.$nb=A;function D(c,g){if(c.length===0)return;let o=c[0];for(let i=1;i<c.length;i++){const r=c[i];g(r,o)>=0&&(o=r)}return o}e.$ob=D;function w(c,g){return A(c,(o,i)=>-g(o,i))}e.$pb=w;function E(c,g){if(c.length===0)return-1;let o=0;for(let i=1;i<c.length;i++){const r=c[i];g(r,c[o])>0&&(o=i)}return o}e.$qb=E;function S(c,g){for(const o of c){const i=g(o);if(i!==void 0)return i}}e.$rb=S}),define(ke[73],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$N=e.$M=e.$L=e.$K=void 0;function C(R,v){const $=Object.create(null);for(const k of R){const A=v(k);let D=$[A];D||(D=$[A]=[]),D.push(k)}return $}e.$K=C;function N(R,v){const $=[],k=[];for(const A of R)v.has(A)||$.push(A);for(const A of v)R.has(A)||k.push(A);return{removed:$,added:k}}e.$L=N;function f(R,v){const $=[],k=[];for(const[A,D]of R)v.has(A)||$.push(D);for(const[A,D]of v)R.has(A)||k.push(D);return{removed:$,added:k}}e.$M=f;function P(R,v){const $=new Set;for(const k of v)R.has(k)&&$.add(k);return $}e.$N=P}),define(ke[52],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zh=e.$yh=e.$xh=void 0;function C(R){return(v,$,k)=>{let A=null,D=null;if(typeof k.value=="function"?(A="value",D=k.value):typeof k.get=="function"&&(A="get",D=k.get),!D)throw new Error("not supported");k[A]=R(D,$)}}function N(R,v,$){let k=null,A=null;if(typeof $.value=="function"?(k="value",A=$.value,A.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof $.get=="function"&&(k="get",A=$.get),!A)throw new Error("not supported");const D=`$memoize$${v}`;$[k]=function(...w){return this.hasOwnProperty(D)||Object.defineProperty(this,D,{configurable:!1,enumerable:!1,writable:!1,value:A.apply(this,w)}),this[D]}}e.$xh=N;function f(R,v,$){return C((k,A)=>{const D=`$debounce$${A}`,w=`$debounce$result$${A}`;return function(...E){this[w]||(this[w]=$?$():void 0),clearTimeout(this[D]),v&&(this[w]=v(this[w],...E),E=[this[w]]),this[D]=setTimeout(()=>{k.apply(this,E),this[w]=$?$():void 0},R)}})}e.$yh=f;function P(R,v,$){return C((k,A)=>{const D=`$throttle$timer$${A}`,w=`$throttle$result$${A}`,E=`$throttle$lastRun$${A}`,S=`$throttle$pending$${A}`;return function(...c){if(this[w]||(this[w]=$?$():void 0),(this[E]===null||this[E]===void 0)&&(this[E]=-Number.MAX_VALUE),v&&(this[w]=v(this[w],...c)),this[S])return;const g=this[E]+R;g<=Date.now()?(this[E]=Date.now(),k.apply(this,[this[w]]),this[w]=$?$():void 0):(this[S]=!0,this[D]=setTimeout(()=>{this[S]=!1,this[E]=Date.now(),k.apply(this,[this[w]]),this[w]=$?$():void 0},g-Date.now()))}})}e.$zh=P}),define(ke[14],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cb=e.$bb=e.$ab=e.$_=e.$$=e.$0=e.$9=e.$8=e.$7=e.$6=e.$5=e.$4=e.$3=e.$2=e.$1=e.$Z=e.setUnexpectedErrorHandler=e.$X=e.$W=void 0;class C{constructor(){this.b=[],this.a=function(t){setTimeout(()=>{throw t.stack?r.isErrorNoTelemetry(t)?new r(t.message+`

`+t.stack):new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.b.push(t),()=>{this.d(t)}}c(t){this.b.forEach(h=>{h(t)})}d(t){this.b.splice(this.b.indexOf(t),1)}setUnexpectedErrorHandler(t){this.a=t}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(t){this.a(t),this.c(t)}onUnexpectedExternalError(t){this.a(t)}}e.$W=C,e.$X=new C;function N(a){e.$X.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=N;function f(a){if(!a||typeof a!="object")return!1;const t=a;return t.code==="EPIPE"&&t.syscall?.toUpperCase()==="WRITE"}e.$Z=f;function P(a){k(a)||e.$X.onUnexpectedError(a)}e.$1=P;function R(a){k(a)||e.$X.onUnexpectedExternalError(a)}e.$2=R;function v(a){if(a instanceof Error){const{name:t,message:h}=a,s=a.stacktrace||a.stack;return{$isError:!0,name:t,message:h,stack:s,noTelemetry:r.isErrorNoTelemetry(a)}}return a}e.$3=v;const $="Canceled";function k(a){return a instanceof A?!0:a instanceof Error&&a.name===$&&a.message===$}e.$4=k;class A extends Error{constructor(){super($),this.name=this.message}}e.$5=A;function D(){const a=new Error($);return a.name=a.message,a}e.$6=D;function w(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.$7=w;function E(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.$8=E;class S extends TypeError{constructor(t){super(t?`${t} is read-only and cannot be changed`:"Cannot change read-only property")}}e.$9=S;function c(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.$0=c;class g extends Error{constructor(t){super("NotImplemented"),t&&(this.message=t)}}e.$$=g;class o extends Error{constructor(t){super("NotSupported"),t&&(this.message=t)}}e.$_=o;class i extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.$ab=i;class r extends Error{constructor(t){super(t),this.name="CodeExpectedError"}static fromError(t){if(t instanceof r)return t;const h=new r;return h.message=t.message,h.stack=t.stack,h}static isErrorNoTelemetry(t){return t.name==="CodeExpectedError"}}e.$bb=r;class n extends Error{constructor(t){super(t||"An unexpected bug occurred."),Object.setPrototypeOf(this,n.prototype)}}e.$cb=n}),define(ke[19],Se([1,0,14,158]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ac=e.$_b=e.$$b=e.$0b=e.$9b=e.$8b=e.$7b=e.CompareResult=e.$6b=e.$5b=e.$4b=e.$3b=e.$2b=e.$1b=e.$Zb=e.$Yb=e.$Xb=e.$Wb=e.$Vb=e.$Ub=e.$Tb=e.$Sb=e.$Rb=e.$Qb=e.$Pb=e.$Ob=e.$Nb=e.$Mb=e.$Lb=e.$Kb=e.$Jb=e.$Ib=e.$Hb=e.$Gb=e.top=e.$Eb=e.$Db=e.$Cb=e.$Bb=e.$Ab=e.$zb=e.$yb=e.$xb=e.$wb=e.$vb=e.$ub=e.$tb=e.$sb=void 0;function f(de,fe=0){return de[de.length-(1+fe)]}e.$sb=f;function P(de){if(de.length===0)throw new Error("Invalid tail call");return[de.slice(0,de.length-1),de[de.length-1]]}e.$tb=P;function R(de,fe,_=(ee,G)=>ee===G){if(de===fe)return!0;if(!de||!fe||de.length!==fe.length)return!1;for(let ee=0,G=de.length;ee<G;ee++)if(!_(de[ee],fe[ee]))return!1;return!0}e.$ub=R;function v(de,fe){const _=de.length-1;fe<_&&(de[fe]=de[_]),de.pop()}e.$vb=v;function $(de,fe,_){return k(de.length,ee=>_(de[ee],fe))}e.$wb=$;function k(de,fe){let _=0,ee=de-1;for(;_<=ee;){const G=(_+ee)/2|0,x=fe(G);if(x<0)_=G+1;else if(x>0)ee=G-1;else return G}return-(_+1)}e.$xb=k;function A(de,fe,_){if(de=de|0,de>=fe.length)throw new TypeError("invalid index");const ee=fe[Math.floor(fe.length*Math.random())],G=[],x=[],me=[];for(const pe of fe){const Re=_(pe,ee);Re<0?G.push(pe):Re>0?x.push(pe):me.push(pe)}return de<G.length?A(de,G,_):de<G.length+me.length?me[0]:A(de-(G.length+me.length),x,_)}e.$yb=A;function D(de,fe){const _=[];let ee;for(const G of de.slice(0).sort(fe))!ee||fe(ee[0],G)!==0?(ee=[G],_.push(ee)):ee.push(G);return _}e.$zb=D;function*w(de,fe){let _,ee;for(const G of de)ee!==void 0&&fe(ee,G)?_.push(G):(_&&(yield _),_=[G]),ee=G;_&&(yield _)}e.$Ab=w;function E(de,fe){for(let _=0;_<=de.length;_++)fe(_===0?void 0:de[_-1],_===de.length?void 0:de[_])}e.$Bb=E;function S(de,fe){for(let _=0;_<de.length;_++)fe(_===0?void 0:de[_-1],de[_],_+1===de.length?void 0:de[_+1])}e.$Cb=S;function c(de,fe,_){const ee=[];function G(pe,Re,ve){if(Re===0&&ve.length===0)return;const Ie=ee[ee.length-1];Ie&&Ie.start+Ie.deleteCount===pe?(Ie.deleteCount+=Re,Ie.toInsert.push(...ve)):ee.push({start:pe,deleteCount:Re,toInsert:ve})}let x=0,me=0;for(;;){if(x===de.length){G(x,0,fe.slice(me));break}if(me===fe.length){G(x,de.length-x,[]);break}const pe=de[x],Re=fe[me],ve=_(pe,Re);ve===0?(x+=1,me+=1):ve<0?(G(x,1,[]),x+=1):ve>0&&(G(x,0,[Re]),me+=1)}return ee}e.$Db=c;function g(de,fe,_){const ee=c(de,fe,_),G=[],x=[];for(const me of ee)G.push(...de.slice(me.start,me.start+me.deleteCount)),x.push(...me.toInsert);return{removed:G,added:x}}e.$Eb=g;function o(de,fe,_){if(_===0)return[];const ee=de.slice(0,_).sort(fe);return r(de,fe,ee,_,de.length),ee}e.top=o;function i(de,fe,_,ee,G){return _===0?Promise.resolve([]):new Promise((x,me)=>{(async()=>{const pe=de.length,Re=de.slice(0,_).sort(fe);for(let ve=_,Ie=Math.min(_+ee,pe);ve<pe;ve=Ie,Ie=Math.min(Ie+ee,pe)){if(ve>_&&await new Promise(B=>setTimeout(B)),G&&G.isCancellationRequested)throw new C.$5;r(de,fe,Re,ve,Ie)}return Re})().then(x,me)})}e.$Gb=i;function r(de,fe,_,ee,G){for(const x=_.length;ee<G;ee++){const me=de[ee];if(fe(me,_[x-1])<0){_.pop();const pe=(0,N.$kb)(_,Re=>fe(me,Re)<0);_.splice(pe,0,me)}}}function n(de){return de.filter(fe=>!!fe)}e.$Hb=n;function a(de){let fe=0;for(let _=0;_<de.length;_++)de[_]&&(de[fe]=de[_],fe+=1);de.length=fe}e.$Ib=a;function t(de,fe,_){de.splice(_,0,de.splice(fe,1)[0])}e.$Jb=t;function h(de){return!Array.isArray(de)||de.length===0}e.$Kb=h;function s(de){return Array.isArray(de)&&de.length>0}e.$Lb=s;function d(de,fe=_=>_){const _=new Set;return de.filter(ee=>{const G=fe(ee);return _.has(G)?!1:(_.add(G),!0)})}e.$Mb=d;function u(de){const fe=new Set;return _=>{const ee=de(_);return fe.has(ee)?!1:(fe.add(ee),!0)}}e.$Nb=u;function l(de,fe){return de.length>0?de[0]:fe}e.$Ob=l;function p(de,fe){return de.length>0?de[de.length-1]:fe}e.$Pb=p;function I(de,fe,_=(ee,G)=>ee===G){let ee=0;for(let G=0,x=Math.min(de.length,fe.length);G<x&&_(de[G],fe[G]);G++)ee++;return ee}e.$Qb=I;function b(de){return[].concat(...de)}e.$Rb=b;function m(de,fe){let _=typeof fe=="number"?de:0;typeof fe=="number"?_=de:(_=0,fe=de);const ee=[];if(_<=fe)for(let G=_;G<fe;G++)ee.push(G);else for(let G=_;G>fe;G--)ee.push(G);return ee}e.$Sb=m;function y(de,fe,_){return de.reduce((ee,G)=>(ee[fe(G)]=_?_(G):G,ee),Object.create(null))}e.$Tb=y;function L(de,fe){return de.push(fe),()=>F(de,fe)}e.$Ub=L;function F(de,fe){const _=de.indexOf(fe);if(_>-1)return de.splice(_,1),fe}e.$Vb=F;function z(de,fe,_){const ee=de.slice(0,fe),G=de.slice(fe);return ee.concat(_,G)}e.$Wb=z;function T(de,fe){let _;if(typeof fe=="number"){let ee=fe;_=()=>{const G=Math.sin(ee++)*179426549;return G-Math.floor(G)}}else _=Math.random;for(let ee=de.length-1;ee>0;ee-=1){const G=Math.floor(_()*(ee+1)),x=de[ee];de[ee]=de[G],de[G]=x}}e.$Xb=T;function O(de,fe){const _=de.indexOf(fe);_>-1&&(de.splice(_,1),de.unshift(fe))}e.$Yb=O;function M(de,fe){const _=de.indexOf(fe);_>-1&&(de.splice(_,1),de.push(fe))}e.$Zb=M;function j(de,fe){for(const _ of fe)de.push(_)}e.$1b=j;function U(de,fe){return Array.isArray(de)?de.map(fe):fe(de)}e.$2b=U;function K(de){return Array.isArray(de)?de:[de]}e.$3b=K;function ue(de){return de[Math.floor(Math.random()*de.length)]}e.$4b=ue;function X(de,fe,_){const ee=Z(de,fe),G=de.length,x=_.length;de.length=G+x;for(let me=G-1;me>=ee;me--)de[me+x]=de[me];for(let me=0;me<x;me++)de[me+ee]=_[me]}e.$5b=X;function Q(de,fe,_,ee){const G=Z(de,fe);let x=de.splice(G,_);return x===void 0&&(x=[]),X(de,G,ee),x}e.$6b=Q;function Z(de,fe){return fe<0?Math.max(fe+de.length,0):Math.min(fe,de.length)}var le;(function(de){function fe(x){return x<0}de.isLessThan=fe;function _(x){return x<=0}de.isLessThanOrEqual=_;function ee(x){return x>0}de.isGreaterThan=ee;function G(x){return x===0}de.isNeitherLessOrGreaterThan=G,de.greaterThan=1,de.lessThan=-1,de.neitherLessOrGreaterThan=0})(le||(e.CompareResult=le={}));function re(de,fe){return(_,ee)=>fe(de(_),de(ee))}e.$7b=re;function $e(...de){return(fe,_)=>{for(const ee of de){const G=ee(fe,_);if(!le.isNeitherLessOrGreaterThan(G))return G}return le.neitherLessOrGreaterThan}}e.$8b=$e;const oe=(de,fe)=>de-fe;e.$9b=oe;const J=(de,fe)=>(0,e.$9b)(de?1:0,fe?1:0);e.$0b=J;function V(de){return(fe,_)=>-de(fe,_)}e.$$b=V;class ie{constructor(fe){this.g=fe,this.c=0,this.d=this.g.length-1}get length(){return this.d-this.c+1}takeWhile(fe){let _=this.c;for(;_<this.g.length&&fe(this.g[_]);)_++;const ee=_===this.c?null:this.g.slice(this.c,_);return this.c=_,ee}takeFromEndWhile(fe){let _=this.d;for(;_>=0&&fe(this.g[_]);)_--;const ee=_===this.d?null:this.g.slice(_+1,this.d+1);return this.d=_,ee}peek(){if(this.length!==0)return this.g[this.c]}peekLast(){if(this.length!==0)return this.g[this.d]}dequeue(){const fe=this.g[this.c];return this.c++,fe}removeLast(){const fe=this.g[this.d];return this.d--,fe}takeCount(fe){const _=this.g.slice(this.c,this.c+fe);return this.c+=fe,_}}e.$_b=ie;class ye{static{this.empty=new ye(fe=>{})}constructor(fe){this.iterate=fe}forEach(fe){this.iterate(_=>(fe(_),!0))}toArray(){const fe=[];return this.iterate(_=>(fe.push(_),!0)),fe}filter(fe){return new ye(_=>this.iterate(ee=>fe(ee)?_(ee):!0))}map(fe){return new ye(_=>this.iterate(ee=>_(fe(ee))))}some(fe){let _=!1;return this.iterate(ee=>(_=fe(ee),!_)),_}findFirst(fe){let _;return this.iterate(ee=>fe(ee)?(_=ee,!1):!0),_}findLast(fe){let _;return this.iterate(ee=>(fe(ee)&&(_=ee),!0)),_}findLastMaxBy(fe){let _,ee=!0;return this.iterate(G=>((ee||le.isGreaterThan(fe(G,_)))&&(ee=!1,_=G),!0)),_}}e.$ac=ye}),define(ke[61],Se([1,0,14]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9c=e.$8c=e.$7c=e.$6c=e.ok=void 0;function N($,k){if(!$)throw new Error(k?`Assertion failed (${k})`:"Assertion Failed")}e.ok=N;function f($,k="Unreachable"){throw new Error(k)}e.$6c=f;function P($){if(!$)throw new C.$cb("Assertion Failed")}e.$7c=P;function R($){if(!$()){debugger;$(),(0,C.$1)(new C.$cb("Assertion Failed"))}}e.$8c=R;function v($,k){let A=0;for(;A<$.length-1;){const D=$[A],w=$[A+1];if(!k(D,w))return!1;A++}return!0}e.$9c=v}),define(ke[74],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$db=void 0;function C(N,f){const P=this;let R=!1,v;return function(){if(R)return v;if(R=!0,f)try{v=N.apply(P,arguments)}finally{f()}else v=N.apply(P,arguments);return v}}e.$db=C}),define(ke[121],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lN=e.$kN=void 0;class C{constructor(f){this.a=f,this.b=0}nextId(){return this.a+ ++this.b}}e.$kN=C,e.$lN=new C("id#")}),define(ke[53],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var C;(function(N){function f(t){return t&&typeof t=="object"&&typeof t[Symbol.iterator]=="function"}N.is=f;const P=Object.freeze([]);function R(){return P}N.empty=R;function*v(t){yield t}N.single=v;function $(t){return f(t)?t:v(t)}N.wrap=$;function k(t){return t||P}N.from=k;function*A(t){for(let h=t.length-1;h>=0;h--)yield t[h]}N.reverse=A;function D(t){return!t||t[Symbol.iterator]().next().done===!0}N.isEmpty=D;function w(t){return t[Symbol.iterator]().next().value}N.first=w;function E(t,h){for(const s of t)if(h(s))return!0;return!1}N.some=E;function S(t,h){for(const s of t)if(h(s))return s}N.find=S;function*c(t,h){for(const s of t)h(s)&&(yield s)}N.filter=c;function*g(t,h){let s=0;for(const d of t)yield h(d,s++)}N.map=g;function*o(...t){for(const h of t)yield*h}N.concat=o;function i(t,h,s){let d=s;for(const u of t)d=h(d,u);return d}N.reduce=i;function*r(t,h,s=t.length){for(h<0&&(h+=t.length),s<0?s+=t.length:s>t.length&&(s=t.length);h<s;h++)yield t[h]}N.slice=r;function n(t,h=Number.POSITIVE_INFINITY){const s=[];if(h===0)return[s,t];const d=t[Symbol.iterator]();for(let u=0;u<h;u++){const l=d.next();if(l.done)return[s,N.empty()];s.push(l.value)}return[s,{[Symbol.iterator](){return d}}]}N.consume=n;async function a(t){const h=[];for await(const s of t)h.push(s);return Promise.resolve(h)}N.asyncToArray=a})(C||(e.Iterable=C={}))}),define(ke[159],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ln=e.$kn=e.$jn=e.$in=e.$hn=e.$gn=e.$fn=e.$en=e.$dn=e.$cn=e.$bn=e.$an=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var C;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var N;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var f;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(f||(e.ParseErrorCode=f={}));var P;(function(t){t.DEFAULT={allowTrailingComma:!0}})(P||(e.ParseOptions=P={}));function R(t,h=!1){let s=0;const d=t.length;let u="",l=0,p=16,I=0;function b(O){let M=0,j=0;for(;M<O;){const U=t.charCodeAt(s);if(U>=48&&U<=57)j=j*16+U-48;else if(U>=65&&U<=70)j=j*16+U-65+10;else if(U>=97&&U<=102)j=j*16+U-97+10;else break;s++,M++}return M<O&&(j=-1),j}function m(O){s=O,u="",l=0,p=16,I=0}function y(){const O=s;if(t.charCodeAt(s)===48)s++;else for(s++;s<t.length&&k(t.charCodeAt(s));)s++;if(s<t.length&&t.charCodeAt(s)===46)if(s++,s<t.length&&k(t.charCodeAt(s)))for(s++;s<t.length&&k(t.charCodeAt(s));)s++;else return I=3,t.substring(O,s);let M=s;if(s<t.length&&(t.charCodeAt(s)===69||t.charCodeAt(s)===101))if(s++,(s<t.length&&t.charCodeAt(s)===43||t.charCodeAt(s)===45)&&s++,s<t.length&&k(t.charCodeAt(s))){for(s++;s<t.length&&k(t.charCodeAt(s));)s++;M=s}else I=3;return t.substring(O,M)}function L(){let O="",M=s;for(;;){if(s>=d){O+=t.substring(M,s),I=2;break}const j=t.charCodeAt(s);if(j===34){O+=t.substring(M,s),s++;break}if(j===92){if(O+=t.substring(M,s),s++,s>=d){I=2;break}switch(t.charCodeAt(s++)){case 34:O+='"';break;case 92:O+="\\";break;case 47:O+="/";break;case 98:O+="\b";break;case 102:O+="\f";break;case 110:O+=`
`;break;case 114:O+="\r";break;case 116:O+="	";break;case 117:{const K=b(4);K>=0?O+=String.fromCharCode(K):I=4;break}default:I=5}M=s;continue}if(j>=0&&j<=31)if($(j)){O+=t.substring(M,s),I=2;break}else I=6;s++}return O}function F(){if(u="",I=0,l=s,s>=d)return l=d,p=17;let O=t.charCodeAt(s);if(v(O)){do s++,u+=String.fromCharCode(O),O=t.charCodeAt(s);while(v(O));return p=15}if($(O))return s++,u+=String.fromCharCode(O),O===13&&t.charCodeAt(s)===10&&(s++,u+=`
`),p=14;switch(O){case 123:return s++,p=1;case 125:return s++,p=2;case 91:return s++,p=3;case 93:return s++,p=4;case 58:return s++,p=6;case 44:return s++,p=5;case 34:return s++,u=L(),p=10;case 47:{const M=s-1;if(t.charCodeAt(s+1)===47){for(s+=2;s<d&&!$(t.charCodeAt(s));)s++;return u=t.substring(M,s),p=12}if(t.charCodeAt(s+1)===42){s+=2;const j=d-1;let U=!1;for(;s<j;){if(t.charCodeAt(s)===42&&t.charCodeAt(s+1)===47){s+=2,U=!0;break}s++}return U||(s++,I=1),u=t.substring(M,s),p=13}return u+=String.fromCharCode(O),s++,p=16}case 45:if(u+=String.fromCharCode(O),s++,s===d||!k(t.charCodeAt(s)))return p=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=y(),p=11;default:for(;s<d&&z(O);)s++,O=t.charCodeAt(s);if(l!==s){switch(u=t.substring(l,s),u){case"true":return p=8;case"false":return p=9;case"null":return p=7}return p=16}return u+=String.fromCharCode(O),s++,p=16}}function z(O){if(v(O)||$(O))return!1;switch(O){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function T(){let O;do O=F();while(O>=12&&O<=15);return O}return{setPosition:m,getPosition:()=>s,scan:h?T:F,getToken:()=>p,getTokenValue:()=>u,getTokenOffset:()=>l,getTokenLength:()=>s-l,getTokenError:()=>I}}e.$an=R;function v(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function $(t){return t===10||t===13||t===8232||t===8233}function k(t){return t>=48&&t<=57}var A;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(A||(A={}));function D(t,h){const s=[],d=new Object;let u;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let p=!1;function I(b,m,y,L){l.value=b,l.offset=m,l.length=y,l.type=L,l.colonOffset=void 0,u=l}try{r(t,{onObjectBegin:(b,m)=>{if(h<=b)throw d;u=void 0,p=h>b,s.push("")},onObjectProperty:(b,m,y)=>{if(h<m||(I(b,m,y,"property"),s[s.length-1]=b,h<=m+y))throw d},onObjectEnd:(b,m)=>{if(h<=b)throw d;u=void 0,s.pop()},onArrayBegin:(b,m)=>{if(h<=b)throw d;u=void 0,s.push(0)},onArrayEnd:(b,m)=>{if(h<=b)throw d;u=void 0,s.pop()},onLiteralValue:(b,m,y)=>{if(h<m||(I(b,m,y,a(b)),h<=m+y))throw d},onSeparator:(b,m,y)=>{if(h<=m)throw d;if(b===":"&&u&&u.type==="property")u.colonOffset=m,p=!1,u=void 0;else if(b===","){const L=s[s.length-1];typeof L=="number"?s[s.length-1]=L+1:(p=!0,s[s.length-1]=""),u=void 0}}})}catch(b){if(b!==d)throw b}return{path:s,previousNode:u,isAtPropertyKey:p,matches:b=>{let m=0;for(let y=0;m<b.length&&y<s.length;y++)if(b[m]===s[y]||b[m]==="*")m++;else if(b[m]!=="**")return!1;return m===b.length}}}e.$bn=D;function w(t,h=[],s=P.DEFAULT){let d=null,u=[];const l=[];function p(b){Array.isArray(u)?u.push(b):d!==null&&(u[d]=b)}return r(t,{onObjectBegin:()=>{const b={};p(b),l.push(u),u=b,d=null},onObjectProperty:b=>{d=b},onObjectEnd:()=>{u=l.pop()},onArrayBegin:()=>{const b=[];p(b),l.push(u),u=b,d=null},onArrayEnd:()=>{u=l.pop()},onLiteralValue:p,onError:(b,m,y)=>{h.push({error:b,offset:m,length:y})}},s),u[0]}e.$cn=w;function E(t,h=[],s=P.DEFAULT){let d={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(b){d.type==="property"&&(d.length=b-d.offset,d=d.parent)}function l(b){return d.children.push(b),b}r(t,{onObjectBegin:b=>{d=l({type:"object",offset:b,length:-1,parent:d,children:[]})},onObjectProperty:(b,m,y)=>{d=l({type:"property",offset:m,length:-1,parent:d,children:[]}),d.children.push({type:"string",value:b,offset:m,length:y,parent:d})},onObjectEnd:(b,m)=>{d.length=b+m-d.offset,d=d.parent,u(b+m)},onArrayBegin:(b,m)=>{d=l({type:"array",offset:b,length:-1,parent:d,children:[]})},onArrayEnd:(b,m)=>{d.length=b+m-d.offset,d=d.parent,u(b+m)},onLiteralValue:(b,m,y)=>{l({type:a(b),offset:m,length:y,parent:d,value:b}),u(m+y)},onSeparator:(b,m,y)=>{d.type==="property"&&(b===":"?d.colonOffset=m:b===","&&u(m))},onError:(b,m,y)=>{h.push({error:b,offset:m,length:y})}},s);const I=d.children[0];return I&&delete I.parent,I}e.$dn=E;function S(t,h){if(!t)return;let s=t;for(const d of h)if(typeof d=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let u=!1;for(const l of s.children)if(Array.isArray(l.children)&&l.children[0].value===d){s=l.children[1],u=!0;break}if(!u)return}else{const u=d;if(s.type!=="array"||u<0||!Array.isArray(s.children)||u>=s.children.length)return;s=s.children[u]}return s}e.$en=S;function c(t){if(!t.parent||!t.parent.children)return[];const h=c(t.parent);if(t.parent.type==="property"){const s=t.parent.children[0].value;h.push(s)}else if(t.parent.type==="array"){const s=t.parent.children.indexOf(t);s!==-1&&h.push(s)}return h}e.$fn=c;function g(t){switch(t.type){case"array":return t.children.map(g);case"object":{const h=Object.create(null);for(const s of t.children){const d=s.children[1];d&&(h[s.children[0].value]=g(d))}return h}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.$gn=g;function o(t,h,s=!1){return h>=t.offset&&h<t.offset+t.length||s&&h===t.offset+t.length}e.$hn=o;function i(t,h,s=!1){if(o(t,h,s)){const d=t.children;if(Array.isArray(d))for(let u=0;u<d.length&&d[u].offset<=h;u++){const l=i(d[u],h,s);if(l)return l}return t}}e.$in=i;function r(t,h,s=P.DEFAULT){const d=R(t,!1);function u(re){return re?()=>re(d.getTokenOffset(),d.getTokenLength()):()=>!0}function l(re){return re?$e=>re($e,d.getTokenOffset(),d.getTokenLength()):()=>!0}const p=u(h.onObjectBegin),I=l(h.onObjectProperty),b=u(h.onObjectEnd),m=u(h.onArrayBegin),y=u(h.onArrayEnd),L=l(h.onLiteralValue),F=l(h.onSeparator),z=u(h.onComment),T=l(h.onError),O=s&&s.disallowComments,M=s&&s.allowTrailingComma;function j(){for(;;){const re=d.scan();switch(d.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:O||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(re){case 12:case 13:O?U(10):z();break;case 16:U(1);break;case 15:case 14:break;default:return re}}}function U(re,$e=[],oe=[]){if(T(re),$e.length+oe.length>0){let J=d.getToken();for(;J!==17;){if($e.indexOf(J)!==-1){j();break}else if(oe.indexOf(J)!==-1)break;J=j()}}}function K(re){const $e=d.getTokenValue();return re?L($e):I($e),j(),!0}function ue(){switch(d.getToken()){case 11:{let re=0;try{re=JSON.parse(d.getTokenValue()),typeof re!="number"&&(U(2),re=0)}catch{U(2)}L(re);break}case 7:L(null);break;case 8:L(!0);break;case 9:L(!1);break;default:return!1}return j(),!0}function X(){return d.getToken()!==10?(U(3,[],[2,5]),!1):(K(!1),d.getToken()===6?(F(":"),j(),le()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Q(){p(),j();let re=!1;for(;d.getToken()!==2&&d.getToken()!==17;){if(d.getToken()===5){if(re||U(4,[],[]),F(","),j(),d.getToken()===2&&M)break}else re&&U(6,[],[]);X()||U(4,[],[2,5]),re=!0}return b(),d.getToken()!==2?U(7,[2],[]):j(),!0}function Z(){m(),j();let re=!1;for(;d.getToken()!==4&&d.getToken()!==17;){if(d.getToken()===5){if(re||U(4,[],[]),F(","),j(),d.getToken()===4&&M)break}else re&&U(6,[],[]);le()||U(4,[],[4,5]),re=!0}return y(),d.getToken()!==4?U(8,[4],[]):j(),!0}function le(){switch(d.getToken()){case 3:return Z();case 1:return Q();case 10:return K(!0);default:return ue()}}return j(),d.getToken()===17?s.allowEmptyContent?!0:(U(4,[],[]),!1):le()?(d.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.$jn=r;function n(t,h){const s=R(t),d=[];let u,l=0,p;do switch(p=s.getPosition(),u=s.scan(),u){case 12:case 13:case 17:l!==p&&d.push(t.substring(l,p)),h!==void 0&&d.push(s.getTokenValue().replace(/[^\r\n]/g,h)),l=s.getPosition();break}while(u!==17);return d.join("")}e.$kn=n;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.$ln=a}),define(ke[43],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$V=void 0;class C{constructor(f){this.d=f,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(f){this.c=f}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.$V=C}),define(ke[75],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4c=void 0;class C{static{this.Undefined=new C(void 0)}constructor(P){this.element=P,this.next=C.Undefined,this.prev=C.Undefined}}class N{constructor(){this.a=C.Undefined,this.b=C.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===C.Undefined}clear(){let P=this.a;for(;P!==C.Undefined;){const R=P.next;P.prev=C.Undefined,P.next=C.Undefined,P=R}this.a=C.Undefined,this.b=C.Undefined,this.c=0}unshift(P){return this.d(P,!1)}push(P){return this.d(P,!0)}d(P,R){const v=new C(P);if(this.a===C.Undefined)this.a=v,this.b=v;else if(R){const k=this.b;this.b=v,v.prev=k,k.next=v}else{const k=this.a;this.a=v,v.next=k,k.prev=v}this.c+=1;let $=!1;return()=>{$||($=!0,this.e(v))}}shift(){if(this.a!==C.Undefined){const P=this.a.element;return this.e(this.a),P}}pop(){if(this.b!==C.Undefined){const P=this.b.element;return this.e(this.b),P}}e(P){if(P.prev!==C.Undefined&&P.next!==C.Undefined){const R=P.prev;R.next=P.next,P.next.prev=R}else P.prev===C.Undefined&&P.next===C.Undefined?(this.a=C.Undefined,this.b=C.Undefined):P.next===C.Undefined?(this.b=this.b.prev,this.b.next=C.Undefined):P.prev===C.Undefined&&(this.a=this.a.next,this.a.prev=C.Undefined);this.c-=1}*[Symbol.iterator](){let P=this.a;for(;P!==C.Undefined;)yield P.element,P=P.next}}e.$4c=N}),define(ke[28],Se([1,0]),function(ge,e){"use strict";var C,N,f;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hc=e.$Gc=e.$Fc=e.$Ec=e.$Dc=e.$Cc=e.Touch=e.$Bc=e.$Ac=e.$zc=e.$yc=e.$xc=void 0;function P(r,n,a){let t=r.get(n);return t===void 0&&(t=a,r.set(n,t)),t}e.$xc=P;function R(r){const n=[];return r.forEach((a,t)=>{n.push(`${t} => ${a}`)}),`Map(${r.size}) {${n.join(", ")}}`}e.$yc=R;function v(r){const n=[];return r.forEach(a=>{n.push(a)}),`Set(${r.size}) {${n.join(", ")}}`}e.$zc=v;class ${constructor(n,a){this.uri=n,this.value=a}}function k(r){return Array.isArray(r)}class A{static{this.c=n=>n.toString()}constructor(n,a){if(this[C]="ResourceMap",n instanceof A)this.d=new Map(n.d),this.e=a??A.c;else if(k(n)){this.d=new Map,this.e=a??A.c;for(const[t,h]of n)this.set(t,h)}else this.d=new Map,this.e=n??A.c}set(n,a){return this.d.set(this.e(n),new $(n,a)),this}get(n){return this.d.get(this.e(n))?.value}has(n){return this.d.has(this.e(n))}get size(){return this.d.size}clear(){this.d.clear()}delete(n){return this.d.delete(this.e(n))}forEach(n,a){typeof a<"u"&&(n=n.bind(a));for(const[t,h]of this.d)n(h.value,h.uri,this)}*values(){for(const n of this.d.values())yield n.value}*keys(){for(const n of this.d.values())yield n.uri}*entries(){for(const n of this.d.values())yield[n.uri,n.value]}*[(C=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.d)yield[n.uri,n.value]}}e.$Ac=A;class D{constructor(n,a){this[N]="ResourceSet",!n||typeof n=="function"?this.c=new A(n):(this.c=new A(a),n.forEach(this.add,this))}get size(){return this.c.size}add(n){return this.c.set(n,n),this}clear(){this.c.clear()}delete(n){return this.c.delete(n)}forEach(n,a){this.c.forEach((t,h)=>n.call(a,h,h,this))}has(n){return this.c.has(n)}entries(){return this.c.entries()}keys(){return this.c.keys()}values(){return this.c.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.$Bc=D;var w;(function(r){r[r.None=0]="None",r[r.AsOld=1]="AsOld",r[r.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class E{constructor(){this[f]="LinkedMap",this.c=new Map,this.d=void 0,this.e=void 0,this.f=0,this.g=0}clear(){this.c.clear(),this.d=void 0,this.e=void 0,this.f=0,this.g++}isEmpty(){return!this.d&&!this.e}get size(){return this.f}get first(){return this.d?.value}get last(){return this.e?.value}has(n){return this.c.has(n)}get(n,a=0){const t=this.c.get(n);if(t)return a!==0&&this.l(t,a),t.value}set(n,a,t=0){let h=this.c.get(n);if(h)h.value=a,t!==0&&this.l(h,t);else{switch(h={key:n,value:a,next:void 0,previous:void 0},t){case 0:this.j(h);break;case 1:this.i(h);break;case 2:this.j(h);break;default:this.j(h);break}this.c.set(n,h),this.f++}return this}delete(n){return!!this.remove(n)}remove(n){const a=this.c.get(n);if(a)return this.c.delete(n),this.k(a),this.f--,a.value}shift(){if(!this.d&&!this.e)return;if(!this.d||!this.e)throw new Error("Invalid list");const n=this.d;return this.c.delete(n.key),this.k(n),this.f--,n.value}forEach(n,a){const t=this.g;let h=this.d;for(;h;){if(a?n.bind(a)(h.value,h.key,this):n(h.value,h.key,this),this.g!==t)throw new Error("LinkedMap got modified during iteration.");h=h.next}}keys(){const n=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.key,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}values(){const n=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:t.value,done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}entries(){const n=this,a=this.g;let t=this.d;const h={[Symbol.iterator](){return h},next(){if(n.g!==a)throw new Error("LinkedMap got modified during iteration.");if(t){const s={value:[t.key,t.value],done:!1};return t=t.next,s}else return{value:void 0,done:!0}}};return h}[(f=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}h(n){if(n>=this.size)return;if(n===0){this.clear();return}let a=this.d,t=this.size;for(;a&&t>n;)this.c.delete(a.key),a=a.next,t--;this.d=a,this.f=t,a&&(a.previous=void 0),this.g++}i(n){if(!this.d&&!this.e)this.e=n;else if(this.d)n.next=this.d,this.d.previous=n;else throw new Error("Invalid list");this.d=n,this.g++}j(n){if(!this.d&&!this.e)this.d=n;else if(this.e)n.previous=this.e,this.e.next=n;else throw new Error("Invalid list");this.e=n,this.g++}k(n){if(n===this.d&&n===this.e)this.d=void 0,this.e=void 0;else if(n===this.d){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.d=n.next}else if(n===this.e){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.e=n.previous}else{const a=n.next,t=n.previous;if(!a||!t)throw new Error("Invalid list");a.previous=t,t.next=a}n.next=void 0,n.previous=void 0,this.g++}l(n,a){if(!this.d||!this.e)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(n===this.d)return;const t=n.next,h=n.previous;n===this.e?(h.next=void 0,this.e=h):(t.previous=h,h.next=t),n.previous=void 0,n.next=this.d,this.d.previous=n,this.d=n,this.g++}else if(a===2){if(n===this.e)return;const t=n.next,h=n.previous;n===this.d?(t.previous=void 0,this.d=t):(t.previous=h,h.next=t),n.next=void 0,n.previous=this.e,this.e.next=n,this.e=n,this.g++}}}toJSON(){const n=[];return this.forEach((a,t)=>{n.push([t,a])}),n}fromJSON(n){this.clear();for(const[a,t]of n)this.set(a,t)}}e.$Cc=E;class S extends E{constructor(n,a=1){super(),this.m=n,this.n=Math.min(Math.max(0,a),1)}get limit(){return this.m}set limit(n){this.m=n,this.o()}get ratio(){return this.n}set ratio(n){this.n=Math.min(Math.max(0,n),1),this.o()}get(n,a=2){return super.get(n,a)}peek(n){return super.get(n,0)}set(n,a){return super.set(n,a,2),this.o(),this}o(){this.size>this.m&&this.h(Math.round(this.m*this.n))}}e.$Dc=S;class c{constructor(){this.c=new Map}add(n){return this.c.set(n,(this.c.get(n)||0)+1),this}delete(n){let a=this.c.get(n)||0;return a===0?!1:(a--,a===0?this.c.delete(n):this.c.set(n,a),!0)}has(n){return this.c.has(n)}}e.$Ec=c;class g{constructor(n){if(this.c=new Map,this.d=new Map,n)for(const[a,t]of n)this.set(a,t)}clear(){this.c.clear(),this.d.clear()}set(n,a){this.c.set(n,a),this.d.set(a,n)}get(n){return this.c.get(n)}getKey(n){return this.d.get(n)}delete(n){const a=this.c.get(n);return a===void 0?!1:(this.c.delete(n),this.d.delete(a),!0)}forEach(n,a){this.c.forEach((t,h)=>{n.call(a,t,h,this)})}keys(){return this.c.keys()}values(){return this.c.values()}}e.$Fc=g;class o{constructor(){this.c=new Map}add(n,a){let t=this.c.get(n);t||(t=new Set,this.c.set(n,t)),t.add(a)}delete(n,a){const t=this.c.get(n);t&&(t.delete(a),t.size===0&&this.c.delete(n))}forEach(n,a){const t=this.c.get(n);t&&t.forEach(a)}get(n){const a=this.c.get(n);return a||new Set}}e.$Gc=o;function i(r,n){if(r===n)return!0;if(r.size!==n.size)return!1;for(const[a,t]of r)if(!n.has(a)||n.get(a)!==t)return!1;for(const[a]of n)if(!r.has(a))return!1;return!0}e.$Hc=i}),define(ke[3],Se([1,0,19,73,28,74,53]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3c=e.$2c=e.$1c=e.$Zc=e.$Yc=e.$Xc=e.$Wc=e.$Vc=e.$Uc=e.$Tc=e.$Sc=e.$Rc=e.$Qc=e.$Pc=e.$Oc=e.$Nc=e.$Mc=e.$Lc=e.$Kc=e.$Jc=e.$Ic=void 0;const v=!1;let $=null;class k{constructor(){this.b=new Map}static{this.a=0}c(L){let F=this.b.get(L);return F||(F={parent:null,source:null,isSingleton:!1,value:L,idx:k.a++},this.b.set(L,F)),F}trackDisposable(L){const F=this.c(L);F.source||(F.source=new Error().stack)}setParent(L,F){const z=this.c(L);z.parent=F}markAsDisposed(L){this.b.delete(L)}markAsSingleton(L){this.c(L).isSingleton=!0}f(L,F){const z=F.get(L);if(z)return z;const T=L.parent?this.f(this.c(L.parent),F):L;return F.set(L,T),T}getTrackedDisposables(){const L=new Map;return[...this.b.entries()].filter(([,z])=>z.source!==null&&!this.f(z,L).isSingleton).flatMap(([z])=>z)}computeLeakingDisposables(L=10,F){let z;if(F)z=F;else{const U=new Map,K=[...this.b.values()].filter(X=>X.source!==null&&!this.f(X,U).isSingleton);if(K.length===0)return;const ue=new Set(K.map(X=>X.value));if(z=K.filter(X=>!(X.parent&&ue.has(X.parent))),z.length===0)throw new Error("There are cyclic diposable chains!")}if(!z)return;function T(U){function K(X,Q){for(;X.length>0&&Q.some(Z=>typeof Z=="string"?Z===X[0]:X[0].match(Z));)X.shift()}const ue=U.source.split(`
`).map(X=>X.trim().replace("at ","")).filter(X=>X!=="");return K(ue,["Error",/^trackDisposable \(.*\)$/,/^DisposableTracker.trackDisposable \(.*\)$/]),ue.reverse()}const O=new f.$Gc;for(const U of z){const K=T(U);for(let ue=0;ue<=K.length;ue++)O.add(K.slice(0,ue).join(`
`),U)}z.sort((0,C.$7b)(U=>U.idx,C.$9b));let M="",j=0;for(const U of z.slice(0,L)){j++;const K=T(U),ue=[];for(let X=0;X<K.length;X++){let Q=K[X];Q=`(shared with ${O.get(K.slice(0,X+1).join(`
`)).size}/${z.length} leaks) at ${Q}`;const le=O.get(K.slice(0,X).join(`
`)),re=(0,N.$K)([...le].map($e=>T($e)[X]),$e=>$e);delete re[K[X]];for(const[$e,oe]of Object.entries(re))ue.unshift(`    - stacktraces of ${oe.length} other leaks continue with ${$e}`);ue.unshift(Q)}M+=`


==================== Leaking disposable ${j}/${z.length}: ${U.value.constructor.name} ====================
${ue.join(`
`)}
============================================================

`}return z.length>L&&(M+=`


... and ${z.length-L} more leaking disposables

`),{leaks:z,details:M}}}e.$Ic=k;function A(y){$=y}if(e.$Jc=A,v){const y="__is_disposable_tracked__";A(new class{trackDisposable(L){const F=new Error("Potentially leaked disposable").stack;setTimeout(()=>{L[y]||console.log(F)},3e3)}setParent(L,F){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsDisposed(L){if(L&&L!==t.None)try{L[y]=!0}catch{}}markAsSingleton(L){}})}function D(y){return $?.trackDisposable(y),y}e.$Kc=D;function w(y){$?.markAsDisposed(y)}e.$Lc=w;function E(y,L){$?.setParent(y,L)}function S(y,L){if($)for(const F of y)$.setParent(F,L)}function c(y){return $?.markAsSingleton(y),y}e.$Mc=c;function g(y){return typeof y.dispose=="function"&&y.dispose.length===0}e.$Nc=g;function o(y){if(R.Iterable.is(y)){const L=[];for(const F of y)if(F)try{F.dispose()}catch(z){L.push(z)}if(L.length===1)throw L[0];if(L.length>1)throw new AggregateError(L,"Encountered errors while disposing of store");return Array.isArray(y)?[]:y}else if(y)return y.dispose(),y}e.$Oc=o;function i(y){for(const L of y)g(L)&&L.dispose();return[]}e.$Pc=i;function r(...y){const L=n(()=>o(y));return S(y,L),L}e.$Qc=r;function n(y){const L=D({dispose:(0,P.$db)(()=>{w(L),y()})});return L}e.$Rc=n;class a{static{this.DISABLE_DISPOSED_WARNING=!1}constructor(){this.f=new Set,this.g=!1,D(this)}dispose(){this.g||(w(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{o(this.f)}finally{this.f.clear()}}add(L){if(!L)return L;if(L===this)throw new Error("Cannot register a disposable on itself!");return E(L,this),this.g?a.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(L),L}delete(L){if(L){if(L===this)throw new Error("Cannot dispose a disposable on itself!");this.f.delete(L),L.dispose()}}deleteAndLeak(L){L&&this.f.has(L)&&(this.f.delete(L),E(L,null))}}e.$Sc=a;class t{static{this.None=Object.freeze({dispose(){}})}constructor(){this.q=new a,D(this),E(this.q,this)}dispose(){w(this),this.q.dispose()}B(L){if(L===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(L)}}e.$Tc=t;class h{constructor(){this.b=!1,D(this)}get value(){return this.b?void 0:this.a}set value(L){this.b||L===this.a||(this.a?.dispose(),L&&E(L,this),this.a=L)}clear(){this.value=void 0}dispose(){this.b=!0,w(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const L=this.a;return this.a=void 0,L&&E(L,null),L}}e.$Uc=h;class s{constructor(L){this.a=new h,this.b=!1,this.a.value=L}get value(){return this.a.value}set value(L){this.b||L===this.a.value||(this.a.value=L)}dispose(){this.b=!0,this.a.dispose()}}e.$Vc=s;class d{constructor(L){this.b=L,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.$Wc=d;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,D(this)}set(L){let F=L;return this.unset=()=>F=void 0,this.isset=()=>F!==void 0,this.dispose=()=>{F&&(F(),F=void 0,w(this))},this}}e.$Xc=u;class l{constructor(){this.a=new Map}acquire(L,...F){let z=this.a.get(L);z||(z={counter:0,object:this.b(L,...F)},this.a.set(L,z));const{object:T}=z,O=(0,P.$db)(()=>{--z.counter===0&&(this.c(L,z.object),this.a.delete(L))});return z.counter++,{object:T,dispose:O}}}e.$Yc=l;class p{constructor(L){this.a=L}async acquire(L,...F){const z=this.a.acquire(L,...F);try{return{object:await z.object,dispose:()=>z.dispose()}}catch(T){throw z.dispose(),T}}}e.$Zc=p;class I{constructor(L){this.object=L}dispose(){}}e.$1c=I;function b(y){const L=new a;try{y(L)}finally{L.dispose()}}e.$2c=b;class m{constructor(){this.a=new Map,this.b=!1,D(this)}dispose(){w(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{o(this.a.values())}finally{this.a.clear()}}has(L){return this.a.has(L)}get size(){return this.a.size}get(L){return this.a.get(L)}set(L,F,z=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),z||this.a.get(L)?.dispose(),this.a.set(L,F)}deleteAndDispose(L){this.a.get(L)?.dispose(),this.a.delete(L)}keys(){return this.a.keys()}values(){return this.a.values()}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.$3c=m}),function(ge,e){typeof define=="function"&&define.amd?define(ke[160],Se([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ge=typeof globalThis<"u"?globalThis:ge||self,e(ge.marked={}))}(this,function(ge){"use strict";function e(fe,_){for(var ee=0;ee<_.length;ee++){var G=_[ee];G.enumerable=G.enumerable||!1,G.configurable=!0,"value"in G&&(G.writable=!0),Object.defineProperty(fe,G.key,G)}}function C(fe,_,ee){return _&&e(fe.prototype,_),ee&&e(fe,ee),Object.defineProperty(fe,"prototype",{writable:!1}),fe}function N(fe,_){if(fe){if(typeof fe=="string")return f(fe,_);var ee=Object.prototype.toString.call(fe).slice(8,-1);if(ee==="Object"&&fe.constructor&&(ee=fe.constructor.name),ee==="Map"||ee==="Set")return Array.from(fe);if(ee==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ee))return f(fe,_)}}function f(fe,_){(_==null||_>fe.length)&&(_=fe.length);for(var ee=0,G=new Array(_);ee<_;ee++)G[ee]=fe[ee];return G}function P(fe,_){var ee=typeof Symbol<"u"&&fe[Symbol.iterator]||fe["@@iterator"];if(ee)return(ee=ee.call(fe)).next.bind(ee);if(Array.isArray(fe)||(ee=N(fe))||_&&fe&&typeof fe.length=="number"){ee&&(fe=ee);var G=0;return function(){return G>=fe.length?{done:!0}:{done:!1,value:fe[G++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ge.defaults=R();function v(fe){ge.defaults=fe}var $=/[&<>"']/,k=/[&<>"']/g,A=/[<>"']|&(?!#?\w+;)/,D=/[<>"']|&(?!#?\w+;)/g,w={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},E=function(_){return w[_]};function S(fe,_){if(_){if($.test(fe))return fe.replace(k,E)}else if(A.test(fe))return fe.replace(D,E);return fe}var c=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function g(fe){return fe.replace(c,function(_,ee){return ee=ee.toLowerCase(),ee==="colon"?":":ee.charAt(0)==="#"?ee.charAt(1)==="x"?String.fromCharCode(parseInt(ee.substring(2),16)):String.fromCharCode(+ee.substring(1)):""})}var o=/(^|[^\[])\^/g;function i(fe,_){fe=typeof fe=="string"?fe:fe.source,_=_||"";var ee={replace:function(x,me){return me=me.source||me,me=me.replace(o,"$1"),fe=fe.replace(x,me),ee},getRegex:function(){return new RegExp(fe,_)}};return ee}var r=/[^\w:]/g,n=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function a(fe,_,ee){if(fe){var G;try{G=decodeURIComponent(g(ee)).replace(r,"").toLowerCase()}catch{return null}if(G.indexOf("javascript:")===0||G.indexOf("vbscript:")===0||G.indexOf("data:")===0)return null}_&&!n.test(ee)&&(ee=u(_,ee));try{ee=encodeURI(ee).replace(/%25/g,"%")}catch{return null}return ee}var t={},h=/^[^:]+:\/*[^/]*$/,s=/^([^:]+:)[\s\S]*$/,d=/^([^:]+:\/*[^/]*)[\s\S]*$/;function u(fe,_){t[" "+fe]||(h.test(fe)?t[" "+fe]=fe+"/":t[" "+fe]=b(fe,"/",!0)),fe=t[" "+fe];var ee=fe.indexOf(":")===-1;return _.substring(0,2)==="//"?ee?_:fe.replace(s,"$1")+_:_.charAt(0)==="/"?ee?_:fe.replace(d,"$1")+_:fe+_}var l={exec:function(){}};function p(fe){for(var _=1,ee,G;_<arguments.length;_++){ee=arguments[_];for(G in ee)Object.prototype.hasOwnProperty.call(ee,G)&&(fe[G]=ee[G])}return fe}function I(fe,_){var ee=fe.replace(/\|/g,function(me,pe,Re){for(var ve=!1,Ie=pe;--Ie>=0&&Re[Ie]==="\\";)ve=!ve;return ve?"|":" |"}),G=ee.split(/ \|/),x=0;if(G[0].trim()||G.shift(),G.length>0&&!G[G.length-1].trim()&&G.pop(),G.length>_)G.splice(_);else for(;G.length<_;)G.push("");for(;x<G.length;x++)G[x]=G[x].trim().replace(/\\\|/g,"|");return G}function b(fe,_,ee){var G=fe.length;if(G===0)return"";for(var x=0;x<G;){var me=fe.charAt(G-x-1);if(me===_&&!ee)x++;else if(me!==_&&ee)x++;else break}return fe.slice(0,G-x)}function m(fe,_){if(fe.indexOf(_[1])===-1)return-1;for(var ee=fe.length,G=0,x=0;x<ee;x++)if(fe[x]==="\\")x++;else if(fe[x]===_[0])G++;else if(fe[x]===_[1]&&(G--,G<0))return x;return-1}function y(fe){fe&&fe.sanitize&&!fe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function L(fe,_){if(_<1)return"";for(var ee="";_>1;)_&1&&(ee+=fe),_>>=1,fe+=fe;return ee+fe}function F(fe,_,ee,G){var x=_.href,me=_.title?S(_.title):null,pe=fe[1].replace(/\\([\[\]])/g,"$1");if(fe[0].charAt(0)!=="!"){G.state.inLink=!0;var Re={type:"link",raw:ee,href:x,title:me,text:pe,tokens:G.inlineTokens(pe)};return G.state.inLink=!1,Re}return{type:"image",raw:ee,href:x,title:me,text:S(pe)}}function z(fe,_){var ee=fe.match(/^(\s+)(?:```)/);if(ee===null)return _;var G=ee[1];return _.split(`
`).map(function(x){var me=x.match(/^\s+/);if(me===null)return x;var pe=me[0];return pe.length>=G.length?x.slice(G.length):x}).join(`
`)}var T=function(){function fe(ee){this.options=ee||ge.defaults}var _=fe.prototype;return _.space=function(G){var x=this.rules.block.newline.exec(G);if(x&&x[0].length>0)return{type:"space",raw:x[0]}},_.code=function(G){var x=this.rules.block.code.exec(G);if(x){var me=x[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:x[0],codeBlockStyle:"indented",text:this.options.pedantic?me:b(me,`
`)}}},_.fences=function(G){var x=this.rules.block.fences.exec(G);if(x){var me=x[0],pe=z(me,x[3]||"");return{type:"code",raw:me,lang:x[2]?x[2].trim():x[2],text:pe}}},_.heading=function(G){var x=this.rules.block.heading.exec(G);if(x){var me=x[2].trim();if(/#$/.test(me)){var pe=b(me,"#");(this.options.pedantic||!pe||/ $/.test(pe))&&(me=pe.trim())}return{type:"heading",raw:x[0],depth:x[1].length,text:me,tokens:this.lexer.inline(me)}}},_.hr=function(G){var x=this.rules.block.hr.exec(G);if(x)return{type:"hr",raw:x[0]}},_.blockquote=function(G){var x=this.rules.block.blockquote.exec(G);if(x){var me=x[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:x[0],tokens:this.lexer.blockTokens(me,[]),text:me}}},_.list=function(G){var x=this.rules.block.list.exec(G);if(x){var me,pe,Re,ve,Ie,B,Y,te,q,ae,he,Ae,je=x[1].trim(),He=je.length>1,Qe={type:"list",raw:"",ordered:He,start:He?+je.slice(0,-1):"",loose:!1,items:[]};je=He?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=He?je:"[*+-]");for(var _e=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");G&&(Ae=!1,!(!(x=_e.exec(G))||this.rules.block.hr.test(G)));){if(me=x[0],G=G.substring(me.length),te=x[2].split(`
`,1)[0],q=G.split(`
`,1)[0],this.options.pedantic?(ve=2,he=te.trimLeft()):(ve=x[2].search(/[^ ]/),ve=ve>4?1:ve,he=te.slice(ve),ve+=x[1].length),B=!1,!te&&/^ *$/.test(q)&&(me+=q+`
`,G=G.substring(q.length+1),Ae=!0),!Ae)for(var at=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),st=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),rt=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),Pe=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");G&&(ae=G.split(`
`,1)[0],te=ae,this.options.pedantic&&(te=te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(rt.test(te)||Pe.test(te)||at.test(te)||st.test(G)));){if(te.search(/[^ ]/)>=ve||!te.trim())he+=`
`+te.slice(ve);else if(!B)he+=`
`+te;else break;!B&&!te.trim()&&(B=!0),me+=ae+`
`,G=G.substring(ae.length+1)}Qe.loose||(Y?Qe.loose=!0:/\n *\n *$/.test(me)&&(Y=!0)),this.options.gfm&&(pe=/^\[[ xX]\] /.exec(he),pe&&(Re=pe[0]!=="[ ] ",he=he.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:me,task:!!pe,checked:Re,loose:!1,text:he}),Qe.raw+=me}Qe.items[Qe.items.length-1].raw=me.trimRight(),Qe.items[Qe.items.length-1].text=he.trimRight(),Qe.raw=Qe.raw.trimRight();var ze=Qe.items.length;for(Ie=0;Ie<ze;Ie++){this.lexer.state.top=!1,Qe.items[Ie].tokens=this.lexer.blockTokens(Qe.items[Ie].text,[]);var Le=Qe.items[Ie].tokens.filter(function(ne){return ne.type==="space"}),Ye=Le.every(function(ne){for(var se=ne.raw.split(""),Ce=0,qe=P(se),Ze;!(Ze=qe()).done;){var it=Ze.value;if(it===`
`&&(Ce+=1),Ce>1)return!0}return!1});!Qe.loose&&Le.length&&Ye&&(Qe.loose=!0,Qe.items[Ie].loose=!0)}return Qe}},_.html=function(G){var x=this.rules.block.html.exec(G);if(x){var me={type:"html",raw:x[0],pre:!this.options.sanitizer&&(x[1]==="pre"||x[1]==="script"||x[1]==="style"),text:x[0]};if(this.options.sanitize){var pe=this.options.sanitizer?this.options.sanitizer(x[0]):S(x[0]);me.type="paragraph",me.text=pe,me.tokens=this.lexer.inline(pe)}return me}},_.def=function(G){var x=this.rules.block.def.exec(G);if(x){x[3]&&(x[3]=x[3].substring(1,x[3].length-1));var me=x[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:me,raw:x[0],href:x[2],title:x[3]}}},_.table=function(G){var x=this.rules.block.table.exec(G);if(x){var me={type:"table",header:I(x[1]).map(function(Y){return{text:Y}}),align:x[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:x[3]&&x[3].trim()?x[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(me.header.length===me.align.length){me.raw=x[0];var pe=me.align.length,Re,ve,Ie,B;for(Re=0;Re<pe;Re++)/^ *-+: *$/.test(me.align[Re])?me.align[Re]="right":/^ *:-+: *$/.test(me.align[Re])?me.align[Re]="center":/^ *:-+ *$/.test(me.align[Re])?me.align[Re]="left":me.align[Re]=null;for(pe=me.rows.length,Re=0;Re<pe;Re++)me.rows[Re]=I(me.rows[Re],me.header.length).map(function(Y){return{text:Y}});for(pe=me.header.length,ve=0;ve<pe;ve++)me.header[ve].tokens=this.lexer.inline(me.header[ve].text);for(pe=me.rows.length,ve=0;ve<pe;ve++)for(B=me.rows[ve],Ie=0;Ie<B.length;Ie++)B[Ie].tokens=this.lexer.inline(B[Ie].text);return me}}},_.lheading=function(G){var x=this.rules.block.lheading.exec(G);if(x)return{type:"heading",raw:x[0],depth:x[2].charAt(0)==="="?1:2,text:x[1],tokens:this.lexer.inline(x[1])}},_.paragraph=function(G){var x=this.rules.block.paragraph.exec(G);if(x){var me=x[1].charAt(x[1].length-1)===`
`?x[1].slice(0,-1):x[1];return{type:"paragraph",raw:x[0],text:me,tokens:this.lexer.inline(me)}}},_.text=function(G){var x=this.rules.block.text.exec(G);if(x)return{type:"text",raw:x[0],text:x[0],tokens:this.lexer.inline(x[0])}},_.escape=function(G){var x=this.rules.inline.escape.exec(G);if(x)return{type:"escape",raw:x[0],text:S(x[1])}},_.tag=function(G){var x=this.rules.inline.tag.exec(G);if(x)return!this.lexer.state.inLink&&/^<a /i.test(x[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(x[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(x[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(x[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:x[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(x[0]):S(x[0]):x[0]}},_.link=function(G){var x=this.rules.inline.link.exec(G);if(x){var me=x[2].trim();if(!this.options.pedantic&&/^</.test(me)){if(!/>$/.test(me))return;var pe=b(me.slice(0,-1),"\\");if((me.length-pe.length)%2===0)return}else{var Re=m(x[2],"()");if(Re>-1){var ve=x[0].indexOf("!")===0?5:4,Ie=ve+x[1].length+Re;x[2]=x[2].substring(0,Re),x[0]=x[0].substring(0,Ie).trim(),x[3]=""}}var B=x[2],Y="";if(this.options.pedantic){var te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(B);te&&(B=te[1],Y=te[3])}else Y=x[3]?x[3].slice(1,-1):"";return B=B.trim(),/^</.test(B)&&(this.options.pedantic&&!/>$/.test(me)?B=B.slice(1):B=B.slice(1,-1)),F(x,{href:B&&B.replace(this.rules.inline._escapes,"$1"),title:Y&&Y.replace(this.rules.inline._escapes,"$1")},x[0],this.lexer)}},_.reflink=function(G,x){var me;if((me=this.rules.inline.reflink.exec(G))||(me=this.rules.inline.nolink.exec(G))){var pe=(me[2]||me[1]).replace(/\s+/g," ");if(pe=x[pe.toLowerCase()],!pe||!pe.href){var Re=me[0].charAt(0);return{type:"text",raw:Re,text:Re}}return F(me,pe,me[0],this.lexer)}},_.emStrong=function(G,x,me){me===void 0&&(me="");var pe=this.rules.inline.emStrong.lDelim.exec(G);if(pe&&!(pe[3]&&me.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Re=pe[1]||pe[2]||"";if(!Re||Re&&(me===""||this.rules.inline.punctuation.exec(me))){var ve=pe[0].length-1,Ie,B,Y=ve,te=0,q=pe[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(q.lastIndex=0,x=x.slice(-1*G.length+ve);(pe=q.exec(x))!=null;)if(Ie=pe[1]||pe[2]||pe[3]||pe[4]||pe[5]||pe[6],!!Ie){if(B=Ie.length,pe[3]||pe[4]){Y+=B;continue}else if((pe[5]||pe[6])&&ve%3&&!((ve+B)%3)){te+=B;continue}if(Y-=B,!(Y>0)){if(B=Math.min(B,B+Y+te),Math.min(ve,B)%2){var ae=G.slice(1,ve+pe.index+B);return{type:"em",raw:G.slice(0,ve+pe.index+B+1),text:ae,tokens:this.lexer.inlineTokens(ae)}}var he=G.slice(2,ve+pe.index+B-1);return{type:"strong",raw:G.slice(0,ve+pe.index+B+1),text:he,tokens:this.lexer.inlineTokens(he)}}}}}},_.codespan=function(G){var x=this.rules.inline.code.exec(G);if(x){var me=x[2].replace(/\n/g," "),pe=/[^ ]/.test(me),Re=/^ /.test(me)&&/ $/.test(me);return pe&&Re&&(me=me.substring(1,me.length-1)),me=S(me,!0),{type:"codespan",raw:x[0],text:me}}},_.br=function(G){var x=this.rules.inline.br.exec(G);if(x)return{type:"br",raw:x[0]}},_.del=function(G){var x=this.rules.inline.del.exec(G);if(x)return{type:"del",raw:x[0],text:x[2],tokens:this.lexer.inlineTokens(x[2])}},_.autolink=function(G,x){var me=this.rules.inline.autolink.exec(G);if(me){var pe,Re;return me[2]==="@"?(pe=S(this.options.mangle?x(me[1]):me[1]),Re="mailto:"+pe):(pe=S(me[1]),Re=pe),{type:"link",raw:me[0],text:pe,href:Re,tokens:[{type:"text",raw:pe,text:pe}]}}},_.url=function(G,x){var me;if(me=this.rules.inline.url.exec(G)){var pe,Re;if(me[2]==="@")pe=S(this.options.mangle?x(me[0]):me[0]),Re="mailto:"+pe;else{var ve;do ve=me[0],me[0]=this.rules.inline._backpedal.exec(me[0])[0];while(ve!==me[0]);pe=S(me[0]),me[1]==="www."?Re="http://"+pe:Re=pe}return{type:"link",raw:me[0],text:pe,href:Re,tokens:[{type:"text",raw:pe,text:pe}]}}},_.inlineText=function(G,x){var me=this.rules.inline.text.exec(G);if(me){var pe;return this.lexer.state.inRawBlock?pe=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(me[0]):S(me[0]):me[0]:pe=S(this.options.smartypants?x(me[0]):me[0]),{type:"text",raw:me[0],text:pe}}},fe}(),O={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:l,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};O._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,O._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,O.def=i(O.def).replace("label",O._label).replace("title",O._title).getRegex(),O.bullet=/(?:[*+-]|\d{1,9}[.)])/,O.listItemStart=i(/^( *)(bull) */).replace("bull",O.bullet).getRegex(),O.list=i(O.list).replace(/bull/g,O.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+O.def.source+")").getRegex(),O._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",O._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,O.html=i(O.html,"i").replace("comment",O._comment).replace("tag",O._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),O.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.blockquote=i(O.blockquote).replace("paragraph",O.paragraph).getRegex(),O.normal=p({},O),O.gfm=p({},O.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),O.gfm.table=i(O.gfm.table).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.gfm.paragraph=i(O._paragraph).replace("hr",O.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",O.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",O._tag).getRegex(),O.pedantic=p({},O.normal,{html:i(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",O._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:l,paragraph:i(O.normal._paragraph).replace("hr",O.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",O.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var M={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:l,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:l,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};M._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",M.punctuation=i(M.punctuation).replace(/punctuation/g,M._punctuation).getRegex(),M.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,M.escapedEmSt=/\\\*|\\_/g,M._comment=i(O._comment).replace("(?:-->|$)","-->").getRegex(),M.emStrong.lDelim=i(M.emStrong.lDelim).replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimAst=i(M.emStrong.rDelimAst,"g").replace(/punct/g,M._punctuation).getRegex(),M.emStrong.rDelimUnd=i(M.emStrong.rDelimUnd,"g").replace(/punct/g,M._punctuation).getRegex(),M._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,M._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,M._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,M.autolink=i(M.autolink).replace("scheme",M._scheme).replace("email",M._email).getRegex(),M._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,M.tag=i(M.tag).replace("comment",M._comment).replace("attribute",M._attribute).getRegex(),M._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,M._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,M._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,M.link=i(M.link).replace("label",M._label).replace("href",M._href).replace("title",M._title).getRegex(),M.reflink=i(M.reflink).replace("label",M._label).replace("ref",O._label).getRegex(),M.nolink=i(M.nolink).replace("ref",O._label).getRegex(),M.reflinkSearch=i(M.reflinkSearch,"g").replace("reflink",M.reflink).replace("nolink",M.nolink).getRegex(),M.normal=p({},M),M.pedantic=p({},M.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:i(/^!?\[(label)\]\((.*?)\)/).replace("label",M._label).getRegex(),reflink:i(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",M._label).getRegex()}),M.gfm=p({},M.normal,{escape:i(M.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),M.gfm.url=i(M.gfm.url,"i").replace("email",M.gfm._extended_email).getRegex(),M.breaks=p({},M.gfm,{br:i(M.br).replace("{2,}","*").getRegex(),text:i(M.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function j(fe){return fe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(fe){var _="",ee,G,x=fe.length;for(ee=0;ee<x;ee++)G=fe.charCodeAt(ee),Math.random()>.5&&(G="x"+G.toString(16)),_+="&#"+G+";";return _}var K=function(){function fe(ee){this.tokens=[],this.tokens.links=Object.create(null),this.options=ee||ge.defaults,this.options.tokenizer=this.options.tokenizer||new T,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var G={block:O.normal,inline:M.normal};this.options.pedantic?(G.block=O.pedantic,G.inline=M.pedantic):this.options.gfm&&(G.block=O.gfm,this.options.breaks?G.inline=M.breaks:G.inline=M.gfm),this.tokenizer.rules=G}fe.lex=function(G,x){var me=new fe(x);return me.lex(G)},fe.lexInline=function(G,x){var me=new fe(x);return me.inlineTokens(G)};var _=fe.prototype;return _.lex=function(G){G=G.replace(/\r\n|\r/g,`
`),this.blockTokens(G,this.tokens);for(var x;x=this.inlineQueue.shift();)this.inlineTokens(x.src,x.tokens);return this.tokens},_.blockTokens=function(G,x){var me=this;x===void 0&&(x=[]),this.options.pedantic?G=G.replace(/\t/g,"    ").replace(/^ +$/gm,""):G=G.replace(/^( *)(\t+)/gm,function(Y,te,q){return te+"    ".repeat(q.length)});for(var pe,Re,ve,Ie;G;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Y){return(pe=Y.call({lexer:me},G,x))?(G=G.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.space(G)){G=G.substring(pe.raw.length),pe.raw.length===1&&x.length>0?x[x.length-1].raw+=`
`:x.push(pe);continue}if(pe=this.tokenizer.code(G)){G=G.substring(pe.raw.length),Re=x[x.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+pe.raw,Re.text+=`
`+pe.text,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):x.push(pe);continue}if(pe=this.tokenizer.fences(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.heading(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.hr(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.blockquote(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.list(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.html(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.def(G)){G=G.substring(pe.raw.length),Re=x[x.length-1],Re&&(Re.type==="paragraph"||Re.type==="text")?(Re.raw+=`
`+pe.raw,Re.text+=`
`+pe.raw,this.inlineQueue[this.inlineQueue.length-1].src=Re.text):this.tokens.links[pe.tag]||(this.tokens.links[pe.tag]={href:pe.href,title:pe.title});continue}if(pe=this.tokenizer.table(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.lheading(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(ve=G,this.options.extensions&&this.options.extensions.startBlock&&function(){var Y=1/0,te=G.slice(1),q=void 0;me.options.extensions.startBlock.forEach(function(ae){q=ae.call({lexer:this},te),typeof q=="number"&&q>=0&&(Y=Math.min(Y,q))}),Y<1/0&&Y>=0&&(ve=G.substring(0,Y+1))}(),this.state.top&&(pe=this.tokenizer.paragraph(ve))){Re=x[x.length-1],Ie&&Re.type==="paragraph"?(Re.raw+=`
`+pe.raw,Re.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):x.push(pe),Ie=ve.length!==G.length,G=G.substring(pe.raw.length);continue}if(pe=this.tokenizer.text(G)){G=G.substring(pe.raw.length),Re=x[x.length-1],Re&&Re.type==="text"?(Re.raw+=`
`+pe.raw,Re.text+=`
`+pe.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Re.text):x.push(pe);continue}if(G){var B="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(B);break}else throw new Error(B)}}return this.state.top=!0,x},_.inline=function(G,x){return x===void 0&&(x=[]),this.inlineQueue.push({src:G,tokens:x}),x},_.inlineTokens=function(G,x){var me=this;x===void 0&&(x=[]);var pe,Re,ve,Ie=G,B,Y,te;if(this.tokens.links){var q=Object.keys(this.tokens.links);if(q.length>0)for(;(B=this.tokenizer.rules.inline.reflinkSearch.exec(Ie))!=null;)q.includes(B[0].slice(B[0].lastIndexOf("[")+1,-1))&&(Ie=Ie.slice(0,B.index)+"["+L("a",B[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(B=this.tokenizer.rules.inline.blockSkip.exec(Ie))!=null;)Ie=Ie.slice(0,B.index)+"["+L("a",B[0].length-2)+"]"+Ie.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(B=this.tokenizer.rules.inline.escapedEmSt.exec(Ie))!=null;)Ie=Ie.slice(0,B.index)+"++"+Ie.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;G;)if(Y||(te=""),Y=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(he){return(pe=he.call({lexer:me},G,x))?(G=G.substring(pe.raw.length),x.push(pe),!0):!1}))){if(pe=this.tokenizer.escape(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.tag(G)){G=G.substring(pe.raw.length),Re=x[x.length-1],Re&&pe.type==="text"&&Re.type==="text"?(Re.raw+=pe.raw,Re.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.link(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.reflink(G,this.tokens.links)){G=G.substring(pe.raw.length),Re=x[x.length-1],Re&&pe.type==="text"&&Re.type==="text"?(Re.raw+=pe.raw,Re.text+=pe.text):x.push(pe);continue}if(pe=this.tokenizer.emStrong(G,Ie,te)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.codespan(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.br(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.del(G)){G=G.substring(pe.raw.length),x.push(pe);continue}if(pe=this.tokenizer.autolink(G,U)){G=G.substring(pe.raw.length),x.push(pe);continue}if(!this.state.inLink&&(pe=this.tokenizer.url(G,U))){G=G.substring(pe.raw.length),x.push(pe);continue}if(ve=G,this.options.extensions&&this.options.extensions.startInline&&function(){var he=1/0,Ae=G.slice(1),je=void 0;me.options.extensions.startInline.forEach(function(He){je=He.call({lexer:this},Ae),typeof je=="number"&&je>=0&&(he=Math.min(he,je))}),he<1/0&&he>=0&&(ve=G.substring(0,he+1))}(),pe=this.tokenizer.inlineText(ve,j)){G=G.substring(pe.raw.length),pe.raw.slice(-1)!=="_"&&(te=pe.raw.slice(-1)),Y=!0,Re=x[x.length-1],Re&&Re.type==="text"?(Re.raw+=pe.raw,Re.text+=pe.text):x.push(pe);continue}if(G){var ae="Infinite loop on byte: "+G.charCodeAt(0);if(this.options.silent){console.error(ae);break}else throw new Error(ae)}}return x},C(fe,null,[{key:"rules",get:function(){return{block:O,inline:M}}}]),fe}(),ue=function(){function fe(ee){this.options=ee||ge.defaults}var _=fe.prototype;return _.code=function(G,x,me){var pe=(x||"").match(/\S*/)[0];if(this.options.highlight){var Re=this.options.highlight(G,pe);Re!=null&&Re!==G&&(me=!0,G=Re)}return G=G.replace(/\n$/,"")+`
`,pe?'<pre><code class="'+this.options.langPrefix+S(pe,!0)+'">'+(me?G:S(G,!0))+`</code></pre>
`:"<pre><code>"+(me?G:S(G,!0))+`</code></pre>
`},_.blockquote=function(G){return`<blockquote>
`+G+`</blockquote>
`},_.html=function(G){return G},_.heading=function(G,x,me,pe){if(this.options.headerIds){var Re=this.options.headerPrefix+pe.slug(me);return"<h"+x+' id="'+Re+'">'+G+"</h"+x+`>
`}return"<h"+x+">"+G+"</h"+x+`>
`},_.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},_.list=function(G,x,me){var pe=x?"ol":"ul",Re=x&&me!==1?' start="'+me+'"':"";return"<"+pe+Re+`>
`+G+"</"+pe+`>
`},_.listitem=function(G){return"<li>"+G+`</li>
`},_.checkbox=function(G){return"<input "+(G?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},_.paragraph=function(G){return"<p>"+G+`</p>
`},_.table=function(G,x){return x&&(x="<tbody>"+x+"</tbody>"),`<table>
<thead>
`+G+`</thead>
`+x+`</table>
`},_.tablerow=function(G){return`<tr>
`+G+`</tr>
`},_.tablecell=function(G,x){var me=x.header?"th":"td",pe=x.align?"<"+me+' align="'+x.align+'">':"<"+me+">";return pe+G+("</"+me+`>
`)},_.strong=function(G){return"<strong>"+G+"</strong>"},_.em=function(G){return"<em>"+G+"</em>"},_.codespan=function(G){return"<code>"+G+"</code>"},_.br=function(){return this.options.xhtml?"<br/>":"<br>"},_.del=function(G){return"<del>"+G+"</del>"},_.link=function(G,x,me){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var pe='<a href="'+S(G)+'"';return x&&(pe+=' title="'+x+'"'),pe+=">"+me+"</a>",pe},_.image=function(G,x,me){if(G=a(this.options.sanitize,this.options.baseUrl,G),G===null)return me;var pe='<img src="'+G+'" alt="'+me+'"';return x&&(pe+=' title="'+x+'"'),pe+=this.options.xhtml?"/>":">",pe},_.text=function(G){return G},fe}(),X=function(){function fe(){}var _=fe.prototype;return _.strong=function(G){return G},_.em=function(G){return G},_.codespan=function(G){return G},_.del=function(G){return G},_.html=function(G){return G},_.text=function(G){return G},_.link=function(G,x,me){return""+me},_.image=function(G,x,me){return""+me},_.br=function(){return""},fe}(),Q=function(){function fe(){this.seen={}}var _=fe.prototype;return _.serialize=function(G){return G.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},_.getNextSafeSlug=function(G,x){var me=G,pe=0;if(this.seen.hasOwnProperty(me)){pe=this.seen[G];do pe++,me=G+"-"+pe;while(this.seen.hasOwnProperty(me))}return x||(this.seen[G]=pe,this.seen[me]=0),me},_.slug=function(G,x){x===void 0&&(x={});var me=this.serialize(G);return this.getNextSafeSlug(me,x.dryrun)},fe}(),Z=function(){function fe(ee){this.options=ee||ge.defaults,this.options.renderer=this.options.renderer||new ue,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new Q}fe.parse=function(G,x){var me=new fe(x);return me.parse(G)},fe.parseInline=function(G,x){var me=new fe(x);return me.parseInline(G)};var _=fe.prototype;return _.parse=function(G,x){x===void 0&&(x=!0);var me="",pe,Re,ve,Ie,B,Y,te,q,ae,he,Ae,je,He,Qe,_e,at,st,rt,Pe,ze=G.length;for(pe=0;pe<ze;pe++){if(he=G[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[he.type]&&(Pe=this.options.extensions.renderers[he.type].call({parser:this},he),Pe!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(he.type))){me+=Pe||"";continue}switch(he.type){case"space":continue;case"hr":{me+=this.renderer.hr();continue}case"heading":{me+=this.renderer.heading(this.parseInline(he.tokens),he.depth,g(this.parseInline(he.tokens,this.textRenderer)),this.slugger);continue}case"code":{me+=this.renderer.code(he.text,he.lang,he.escaped);continue}case"table":{for(q="",te="",Ie=he.header.length,Re=0;Re<Ie;Re++)te+=this.renderer.tablecell(this.parseInline(he.header[Re].tokens),{header:!0,align:he.align[Re]});for(q+=this.renderer.tablerow(te),ae="",Ie=he.rows.length,Re=0;Re<Ie;Re++){for(Y=he.rows[Re],te="",B=Y.length,ve=0;ve<B;ve++)te+=this.renderer.tablecell(this.parseInline(Y[ve].tokens),{header:!1,align:he.align[ve]});ae+=this.renderer.tablerow(te)}me+=this.renderer.table(q,ae);continue}case"blockquote":{ae=this.parse(he.tokens),me+=this.renderer.blockquote(ae);continue}case"list":{for(Ae=he.ordered,je=he.start,He=he.loose,Ie=he.items.length,ae="",Re=0;Re<Ie;Re++)_e=he.items[Re],at=_e.checked,st=_e.task,Qe="",_e.task&&(rt=this.renderer.checkbox(at),He?_e.tokens.length>0&&_e.tokens[0].type==="paragraph"?(_e.tokens[0].text=rt+" "+_e.tokens[0].text,_e.tokens[0].tokens&&_e.tokens[0].tokens.length>0&&_e.tokens[0].tokens[0].type==="text"&&(_e.tokens[0].tokens[0].text=rt+" "+_e.tokens[0].tokens[0].text)):_e.tokens.unshift({type:"text",text:rt}):Qe+=rt),Qe+=this.parse(_e.tokens,He),ae+=this.renderer.listitem(Qe,st,at);me+=this.renderer.list(ae,Ae,je);continue}case"html":{me+=this.renderer.html(he.text);continue}case"paragraph":{me+=this.renderer.paragraph(this.parseInline(he.tokens));continue}case"text":{for(ae=he.tokens?this.parseInline(he.tokens):he.text;pe+1<ze&&G[pe+1].type==="text";)he=G[++pe],ae+=`
`+(he.tokens?this.parseInline(he.tokens):he.text);me+=x?this.renderer.paragraph(ae):ae;continue}default:{var Le='Token with "'+he.type+'" type was not found.';if(this.options.silent){console.error(Le);return}else throw new Error(Le)}}}return me},_.parseInline=function(G,x){x=x||this.renderer;var me="",pe,Re,ve,Ie=G.length;for(pe=0;pe<Ie;pe++){if(Re=G[pe],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Re.type]&&(ve=this.options.extensions.renderers[Re.type].call({parser:this},Re),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Re.type))){me+=ve||"";continue}switch(Re.type){case"escape":{me+=x.text(Re.text);break}case"html":{me+=x.html(Re.text);break}case"link":{me+=x.link(Re.href,Re.title,this.parseInline(Re.tokens,x));break}case"image":{me+=x.image(Re.href,Re.title,Re.text);break}case"strong":{me+=x.strong(this.parseInline(Re.tokens,x));break}case"em":{me+=x.em(this.parseInline(Re.tokens,x));break}case"codespan":{me+=x.codespan(Re.text);break}case"br":{me+=x.br();break}case"del":{me+=x.del(this.parseInline(Re.tokens,x));break}case"text":{me+=x.text(Re.text);break}default:{var B='Token with "'+Re.type+'" type was not found.';if(this.options.silent){console.error(B);return}else throw new Error(B)}}}return me},fe}();function le(fe,_,ee){if(typeof fe>"u"||fe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");if(typeof _=="function"&&(ee=_,_=null),_=p({},le.defaults,_||{}),y(_),ee){var G=_.highlight,x;try{x=K.lex(fe,_)}catch(Ie){return ee(Ie)}var me=function(B){var Y;if(!B)try{_.walkTokens&&le.walkTokens(x,_.walkTokens),Y=Z.parse(x,_)}catch(te){B=te}return _.highlight=G,B?ee(B):ee(null,Y)};if(!G||G.length<3||(delete _.highlight,!x.length))return me();var pe=0;le.walkTokens(x,function(Ie){Ie.type==="code"&&(pe++,setTimeout(function(){G(Ie.text,Ie.lang,function(B,Y){if(B)return me(B);Y!=null&&Y!==Ie.text&&(Ie.text=Y,Ie.escaped=!0),pe--,pe===0&&me()})},0))}),pe===0&&me();return}function Re(Ie){if(Ie.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(Ie.message+"",!0)+"</pre>";throw Ie}try{var ve=K.lex(fe,_);if(_.walkTokens){if(_.async)return Promise.all(le.walkTokens(ve,_.walkTokens)).then(function(){return Z.parse(ve,_)}).catch(Re);le.walkTokens(ve,_.walkTokens)}return Z.parse(ve,_)}catch(Ie){Re(Ie)}}le.options=le.setOptions=function(fe){return p(le.defaults,fe),v(le.defaults),le},le.getDefaults=R,le.defaults=ge.defaults,le.use=function(){for(var fe=arguments.length,_=new Array(fe),ee=0;ee<fe;ee++)_[ee]=arguments[ee];var G=p.apply(void 0,[{}].concat(_)),x=le.defaults.extensions||{renderers:{},childTokens:{}},me;_.forEach(function(pe){if(pe.extensions&&(me=!0,pe.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var Ie=x.renderers?x.renderers[ve.name]:null;Ie?x.renderers[ve.name]=function(){for(var B=arguments.length,Y=new Array(B),te=0;te<B;te++)Y[te]=arguments[te];var q=ve.renderer.apply(this,Y);return q===!1&&(q=Ie.apply(this,Y)),q}:x.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");x[ve.level]?x[ve.level].unshift(ve.tokenizer):x[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?x.startBlock?x.startBlock.push(ve.start):x.startBlock=[ve.start]:ve.level==="inline"&&(x.startInline?x.startInline.push(ve.start):x.startInline=[ve.start]))}ve.childTokens&&(x.childTokens[ve.name]=ve.childTokens)})),pe.renderer&&function(){var ve=le.defaults.renderer||new ue,Ie=function(te){var q=ve[te];ve[te]=function(){for(var ae=arguments.length,he=new Array(ae),Ae=0;Ae<ae;Ae++)he[Ae]=arguments[Ae];var je=pe.renderer[te].apply(ve,he);return je===!1&&(je=q.apply(ve,he)),je}};for(var B in pe.renderer)Ie(B);G.renderer=ve}(),pe.tokenizer&&function(){var ve=le.defaults.tokenizer||new T,Ie=function(te){var q=ve[te];ve[te]=function(){for(var ae=arguments.length,he=new Array(ae),Ae=0;Ae<ae;Ae++)he[Ae]=arguments[Ae];var je=pe.tokenizer[te].apply(ve,he);return je===!1&&(je=q.apply(ve,he)),je}};for(var B in pe.tokenizer)Ie(B);G.tokenizer=ve}(),pe.walkTokens){var Re=le.defaults.walkTokens;G.walkTokens=function(ve){var Ie=[];return Ie.push(pe.walkTokens.call(this,ve)),Re&&(Ie=Ie.concat(Re.call(this,ve))),Ie}}me&&(G.extensions=x),le.setOptions(G)})},le.walkTokens=function(fe,_){for(var ee=[],G=function(){var Re=me.value;switch(ee=ee.concat(_.call(le,Re)),Re.type){case"table":{for(var ve=P(Re.header),Ie;!(Ie=ve()).done;){var B=Ie.value;ee=ee.concat(le.walkTokens(B.tokens,_))}for(var Y=P(Re.rows),te;!(te=Y()).done;)for(var q=te.value,ae=P(q),he;!(he=ae()).done;){var Ae=he.value;ee=ee.concat(le.walkTokens(Ae.tokens,_))}break}case"list":{ee=ee.concat(le.walkTokens(Re.items,_));break}default:le.defaults.extensions&&le.defaults.extensions.childTokens&&le.defaults.extensions.childTokens[Re.type]?le.defaults.extensions.childTokens[Re.type].forEach(function(je){ee=ee.concat(le.walkTokens(Re[je],_))}):Re.tokens&&(ee=ee.concat(le.walkTokens(Re.tokens,_)))}},x=P(fe),me;!(me=x()).done;)G();return ee},le.parseInline=function(fe,_){if(typeof fe>"u"||fe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof fe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(fe)+", string expected");_=p({},le.defaults,_||{}),y(_);try{var ee=K.lexInline(fe,_);return _.walkTokens&&le.walkTokens(ee,_.walkTokens),Z.parseInline(ee,_)}catch(G){if(G.message+=`
Please report this to https://github.com/markedjs/marked.`,_.silent)return"<p>An error occurred:</p><pre>"+S(G.message+"",!0)+"</pre>";throw G}},le.Parser=Z,le.parser=Z.parse,le.Renderer=ue,le.TextRenderer=X,le.Lexer=K,le.lexer=K.lex,le.Tokenizer=T,le.Slugger=Q,le.parse=le;var re=le.options,$e=le.setOptions,oe=le.use,J=le.walkTokens,V=le.parseInline,ie=le,ye=Z.parse,de=K.lex;ge.Lexer=K,ge.Parser=Z,ge.Renderer=ue,ge.Slugger=Q,ge.TextRenderer=X,ge.Tokenizer=T,ge.getDefaults=R,ge.lexer=de,ge.marked=le,ge.options=re,ge.parse=ie,ge.parseInline=V,ge.parser=ye,ge.setOptions=$e,ge.use=oe,ge.walkTokens=J,Object.defineProperty(ge,"__esModule",{value:!0})}),define(ke[161],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rj=void 0;function C(c){const g=P(c);if(g&&g.length>0)return new Uint32Array(g)}e.$Rj=C;let N=0;const f=new Uint32Array(10);function P(c){if(N=0,R(c,D,4352),N>0||(R(c,w,4449),N>0)||(R(c,E,4520),N>0)||(R(c,S,12593),N))return f.subarray(0,N);if(c>=44032&&c<=55203){const g=c-44032,o=g%588,i=Math.floor(g/588),r=Math.floor(o/28),n=o%28-1;if(i<D.length?R(i,D,0):4352+i-12593<S.length&&R(4352+i,S,12593),r<w.length?R(r,w,0):4449+r-12593<S.length&&R(4449+r-12593,S,12593),n>=0&&(n<E.length?R(n,E,0):4520+n-12593<S.length&&R(4520+n-12593,S,12593)),N>0)return f.subarray(0,N)}}function R(c,g,o){c>=o&&c<o+g.length&&v(g[c-o])}function v(c){c!==0&&(f[N++]=c&255,c>>8&&(f[N++]=c>>8&255),c>>16&&(f[N++]=c>>16&255))}var $;(function(c){c[c.InitialConsonant=4352]="InitialConsonant",c[c.Vowel=4449]="Vowel",c[c.FinalConsonant=4520]="FinalConsonant",c[c.CompatibilityJamo=12593]="CompatibilityJamo"})($||($={}));var k;(function(c){c[c.NUL=0]="NUL",c[c.A=65]="A",c[c.B=66]="B",c[c.C=67]="C",c[c.D=68]="D",c[c.E=69]="E",c[c.F=70]="F",c[c.G=71]="G",c[c.H=72]="H",c[c.I=73]="I",c[c.J=74]="J",c[c.K=75]="K",c[c.L=76]="L",c[c.M=77]="M",c[c.N=78]="N",c[c.O=79]="O",c[c.P=80]="P",c[c.Q=81]="Q",c[c.R=82]="R",c[c.S=83]="S",c[c.T=84]="T",c[c.U=85]="U",c[c.V=86]="V",c[c.W=87]="W",c[c.X=88]="X",c[c.Y=89]="Y",c[c.Z=90]="Z",c[c.a=97]="a",c[c.b=98]="b",c[c.c=99]="c",c[c.d=100]="d",c[c.e=101]="e",c[c.f=102]="f",c[c.g=103]="g",c[c.h=104]="h",c[c.i=105]="i",c[c.j=106]="j",c[c.k=107]="k",c[c.l=108]="l",c[c.m=109]="m",c[c.n=110]="n",c[c.o=111]="o",c[c.p=112]="p",c[c.q=113]="q",c[c.r=114]="r",c[c.s=115]="s",c[c.t=116]="t",c[c.u=117]="u",c[c.v=118]="v",c[c.w=119]="w",c[c.x=120]="x",c[c.y=121]="y",c[c.z=122]="z"})(k||(k={}));var A;(function(c){c[c.fa=24934]="fa",c[c.fg=26470]="fg",c[c.fq=29030]="fq",c[c.fr=29286]="fr",c[c.ft=29798]="ft",c[c.fv=30310]="fv",c[c.fx=30822]="fx",c[c.hk=27496]="hk",c[c.hl=27752]="hl",c[c.ho=28520]="ho",c[c.ml=27757]="ml",c[c.nj=27246]="nj",c[c.nl=27758]="nl",c[c.np=28782]="np",c[c.qt=29809]="qt",c[c.rt=29810]="rt",c[c.sg=26483]="sg",c[c.sw=30579]="sw"})(A||(A={}));const D=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),w=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),E=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),S=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(ke[76],Se([1,0,28]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$Gl=void 0;const N=new C.$Dc(1e4);function f(k){return $(k,"NFC",N)}e.$Gl=f;const P=new C.$Dc(1e4);function R(k){return $(k,"NFD",P)}e.$Hl=R;const v=/[^\u0000-\u0080]/;function $(k,A,D){if(!k)return k;const w=D.get(k);if(w)return w;let E;return v.test(k)?E=k.normalize(A):E=k,D.set(k,E),E}e.$Il=function(){const k=/[\u0300-\u036f]/g;return function(A){return R(A).replace(k,"")}}()}),define(ke[122],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$l=e.$0l=e.$9l=e.rot=e.$7l=void 0;function C(v,$,k){return Math.min(Math.max(v,$),k)}e.$7l=C;function N(v,$){return($+v%$)%$}e.rot=N;class f{constructor(){this.a=0}getNext(){return this.a++}}e.$9l=f;class P{constructor(){this.a=1,this.b=0}update($){return this.b=this.b+($-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$0l=P;class R{constructor($){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array($),this.c.fill(0,0,$)}update($){const k=this.c[this.d];return this.c[this.d]=$,this.d=(this.d+1)%this.c.length,this.e-=k,this.e+=$,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$$l=R}),function(){function ge(f){const P=[];typeof f=="number"&&P.push("code/timeOrigin",f);function R($){P.push($,Date.now())}function v(){const $=[];for(let k=0;k<P.length;k+=2)$.push({name:P[k],startTime:P[k+1]});return $}return{mark:R,getMarks:v}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ge():{mark(f){performance.mark(f)},getMarks(){let f=performance.timeOrigin;typeof f!="number"&&(f=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const P=[{name:"code/timeOrigin",startTime:Math.round(f)}];for(const R of performance.getEntriesByType("mark"))P.push({name:R.name,startTime:Math.round(f+R.startTime)});return P}};if(typeof process=="object"){const f=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ge(f)}else return console.trace("perf-util loaded in UNKNOWN environment"),ge()}function C(f){return f.MonacoPerformanceMarks||(f.MonacoPerformanceMarks=e()),f.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=C(N))}(),function(ge,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var N in C)(typeof exports=="object"?exports:ge)[N]=C[N]}}(typeof self<"u"?self:this,function(){return function(ge){var e={};function C(N){if(e[N])return e[N].exports;var f=e[N]={i:N,l:!1,exports:{}};return ge[N].call(f.exports,f,f.exports,C),f.l=!0,f.exports}return C.m=ge,C.c=e,C.d=function(N,f,P){C.o(N,f)||Object.defineProperty(N,f,{enumerable:!0,get:P})},C.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},C.t=function(N,f){if(1&f&&(N=C(N)),8&f||4&f&&typeof N=="object"&&N&&N.__esModule)return N;var P=Object.create(null);if(C.r(P),Object.defineProperty(P,"default",{enumerable:!0,value:N}),2&f&&typeof N!="string")for(var R in N)C.d(P,R,function(v){return N[v]}.bind(null,R));return P},C.n=function(N){var f=N&&N.__esModule?function(){return N.default}:function(){return N};return C.d(f,"a",f),f},C.o=function(N,f){return Object.prototype.hasOwnProperty.call(N,f)},C.p="",C(C.s=0)}([function(ge,e,C){(function(N){var f;e=ge.exports=oe,f=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var q=Array.prototype.slice.call(arguments,0);q.unshift("SEMVER"),console.log.apply(console,q)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var P=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,v=e.re=[],$=e.src=[],k=0,A=k++;$[A]="0|[1-9]\\d*";var D=k++;$[D]="[0-9]+";var w=k++;$[w]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var E=k++;$[E]="("+$[A]+")\\.("+$[A]+")\\.("+$[A]+")";var S=k++;$[S]="("+$[D]+")\\.("+$[D]+")\\.("+$[D]+")";var c=k++;$[c]="(?:"+$[A]+"|"+$[w]+")";var g=k++;$[g]="(?:"+$[D]+"|"+$[w]+")";var o=k++;$[o]="(?:-("+$[c]+"(?:\\."+$[c]+")*))";var i=k++;$[i]="(?:-?("+$[g]+"(?:\\."+$[g]+")*))";var r=k++;$[r]="[0-9A-Za-z-]+";var n=k++;$[n]="(?:\\+("+$[r]+"(?:\\."+$[r]+")*))";var a=k++,t="v?"+$[E]+$[o]+"?"+$[n]+"?";$[a]="^"+t+"$";var h="[v=\\s]*"+$[S]+$[i]+"?"+$[n]+"?",s=k++;$[s]="^"+h+"$";var d=k++;$[d]="((?:<|>)?=?)";var u=k++;$[u]=$[D]+"|x|X|\\*";var l=k++;$[l]=$[A]+"|x|X|\\*";var p=k++;$[p]="[v=\\s]*("+$[l]+")(?:\\.("+$[l]+")(?:\\.("+$[l]+")(?:"+$[o]+")?"+$[n]+"?)?)?";var I=k++;$[I]="[v=\\s]*("+$[u]+")(?:\\.("+$[u]+")(?:\\.("+$[u]+")(?:"+$[i]+")?"+$[n]+"?)?)?";var b=k++;$[b]="^"+$[d]+"\\s*"+$[p]+"$";var m=k++;$[m]="^"+$[d]+"\\s*"+$[I]+"$";var y=k++;$[y]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var L=k++;$[L]="(?:~>?)";var F=k++;$[F]="(\\s*)"+$[L]+"\\s+",v[F]=new RegExp($[F],"g");var z=k++;$[z]="^"+$[L]+$[p]+"$";var T=k++;$[T]="^"+$[L]+$[I]+"$";var O=k++;$[O]="(?:\\^)";var M=k++;$[M]="(\\s*)"+$[O]+"\\s+",v[M]=new RegExp($[M],"g");var j=k++;$[j]="^"+$[O]+$[p]+"$";var U=k++;$[U]="^"+$[O]+$[I]+"$";var K=k++;$[K]="^"+$[d]+"\\s*("+h+")$|^$";var ue=k++;$[ue]="^"+$[d]+"\\s*("+t+")$|^$";var X=k++;$[X]="(\\s*)"+$[d]+"\\s*("+h+"|"+$[p]+")",v[X]=new RegExp($[X],"g");var Q=k++;$[Q]="^\\s*("+$[p]+")\\s+-\\s+("+$[p]+")\\s*$";var Z=k++;$[Z]="^\\s*("+$[I]+")\\s+-\\s+("+$[I]+")\\s*$";var le=k++;$[le]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)f(re,$[re]),v[re]||(v[re]=new RegExp($[re]));function $e(q,ae){if(q instanceof oe)return q;if(typeof q!="string"||q.length>P||!(ae?v[s]:v[a]).test(q))return null;try{return new oe(q,ae)}catch{return null}}function oe(q,ae){if(q instanceof oe){if(q.loose===ae)return q;q=q.version}else if(typeof q!="string")throw new TypeError("Invalid Version: "+q);if(q.length>P)throw new TypeError("version is longer than "+P+" characters");if(!(this instanceof oe))return new oe(q,ae);f("SemVer",q,ae),this.loose=ae;var he=q.trim().match(ae?v[s]:v[a]);if(!he)throw new TypeError("Invalid Version: "+q);if(this.raw=q,this.major=+he[1],this.minor=+he[2],this.patch=+he[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");he[4]?this.prerelease=he[4].split(".").map(function(Ae){if(/^[0-9]+$/.test(Ae)){var je=+Ae;if(je>=0&&je<R)return je}return Ae}):this.prerelease=[],this.build=he[5]?he[5].split("."):[],this.format()}e.parse=$e,e.valid=function(q,ae){var he=$e(q,ae);return he?he.version:null},e.clean=function(q,ae){var he=$e(q.trim().replace(/^[=v]+/,""),ae);return he?he.version:null},e.SemVer=oe,oe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},oe.prototype.toString=function(){return this.version},oe.prototype.compare=function(q){return f("SemVer.compare",this.version,this.loose,q),q instanceof oe||(q=new oe(q,this.loose)),this.compareMain(q)||this.comparePre(q)},oe.prototype.compareMain=function(q){return q instanceof oe||(q=new oe(q,this.loose)),V(this.major,q.major)||V(this.minor,q.minor)||V(this.patch,q.patch)},oe.prototype.comparePre=function(q){if(q instanceof oe||(q=new oe(q,this.loose)),this.prerelease.length&&!q.prerelease.length)return-1;if(!this.prerelease.length&&q.prerelease.length)return 1;if(!this.prerelease.length&&!q.prerelease.length)return 0;var ae=0;do{var he=this.prerelease[ae],Ae=q.prerelease[ae];if(f("prerelease compare",ae,he,Ae),he===void 0&&Ae===void 0)return 0;if(Ae===void 0)return 1;if(he===void 0)return-1;if(he!==Ae)return V(he,Ae)}while(++ae)},oe.prototype.inc=function(q,ae){switch(q){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ae);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ae);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ae),this.inc("pre",ae);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ae),this.inc("pre",ae);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var he=this.prerelease.length;--he>=0;)typeof this.prerelease[he]=="number"&&(this.prerelease[he]++,he=-2);he===-1&&this.prerelease.push(0)}ae&&(this.prerelease[0]===ae?isNaN(this.prerelease[1])&&(this.prerelease=[ae,0]):this.prerelease=[ae,0]);break;default:throw new Error("invalid increment argument: "+q)}return this.format(),this.raw=this.version,this},e.inc=function(q,ae,he,Ae){typeof he=="string"&&(Ae=he,he=void 0);try{return new oe(q,he).inc(ae,Ae).version}catch{return null}},e.diff=function(q,ae){if(fe(q,ae))return null;var he=$e(q),Ae=$e(ae);if(he.prerelease.length||Ae.prerelease.length){for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Ae[je])return"pre"+je;return"prerelease"}for(var je in he)if((je==="major"||je==="minor"||je==="patch")&&he[je]!==Ae[je])return je},e.compareIdentifiers=V;var J=/^[0-9]+$/;function V(q,ae){var he=J.test(q),Ae=J.test(ae);return he&&Ae&&(q=+q,ae=+ae),he&&!Ae?-1:Ae&&!he?1:q<ae?-1:q>ae?1:0}function ie(q,ae,he){return new oe(q,he).compare(new oe(ae,he))}function ye(q,ae,he){return ie(q,ae,he)>0}function de(q,ae,he){return ie(q,ae,he)<0}function fe(q,ae,he){return ie(q,ae,he)===0}function _(q,ae,he){return ie(q,ae,he)!==0}function ee(q,ae,he){return ie(q,ae,he)>=0}function G(q,ae,he){return ie(q,ae,he)<=0}function x(q,ae,he,Ae){var je;switch(ae){case"===":typeof q=="object"&&(q=q.version),typeof he=="object"&&(he=he.version),je=q===he;break;case"!==":typeof q=="object"&&(q=q.version),typeof he=="object"&&(he=he.version),je=q!==he;break;case"":case"=":case"==":je=fe(q,he,Ae);break;case"!=":je=_(q,he,Ae);break;case">":je=ye(q,he,Ae);break;case">=":je=ee(q,he,Ae);break;case"<":je=de(q,he,Ae);break;case"<=":je=G(q,he,Ae);break;default:throw new TypeError("Invalid operator: "+ae)}return je}function me(q,ae){if(q instanceof me){if(q.loose===ae)return q;q=q.value}if(!(this instanceof me))return new me(q,ae);f("comparator",q,ae),this.loose=ae,this.parse(q),this.semver===pe?this.value="":this.value=this.operator+this.semver.version,f("comp",this)}e.rcompareIdentifiers=function(q,ae){return V(ae,q)},e.major=function(q,ae){return new oe(q,ae).major},e.minor=function(q,ae){return new oe(q,ae).minor},e.patch=function(q,ae){return new oe(q,ae).patch},e.compare=ie,e.compareLoose=function(q,ae){return ie(q,ae,!0)},e.rcompare=function(q,ae,he){return ie(ae,q,he)},e.sort=function(q,ae){return q.sort(function(he,Ae){return e.compare(he,Ae,ae)})},e.rsort=function(q,ae){return q.sort(function(he,Ae){return e.rcompare(he,Ae,ae)})},e.gt=ye,e.lt=de,e.eq=fe,e.neq=_,e.gte=ee,e.lte=G,e.cmp=x,e.Comparator=me;var pe={};function Re(q,ae){if(q instanceof Re)return q.loose===ae?q:new Re(q.raw,ae);if(q instanceof me)return new Re(q.value,ae);if(!(this instanceof Re))return new Re(q,ae);if(this.loose=ae,this.raw=q,this.set=q.split(/\s*\|\|\s*/).map(function(he){return this.parseRange(he.trim())},this).filter(function(he){return he.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+q);this.format()}function ve(q){return!q||q.toLowerCase()==="x"||q==="*"}function Ie(q,ae,he,Ae,je,He,Qe,_e,at,st,rt,Pe,ze){return((ae=ve(he)?"":ve(Ae)?">="+he+".0.0":ve(je)?">="+he+"."+Ae+".0":">="+ae)+" "+(_e=ve(at)?"":ve(st)?"<"+(+at+1)+".0.0":ve(rt)?"<"+at+"."+(+st+1)+".0":Pe?"<="+at+"."+st+"."+rt+"-"+Pe:"<="+_e)).trim()}function B(q,ae){for(var he=0;he<q.length;he++)if(!q[he].test(ae))return!1;if(ae.prerelease.length){for(he=0;he<q.length;he++)if(f(q[he].semver),q[he].semver!==pe&&q[he].semver.prerelease.length>0){var Ae=q[he].semver;if(Ae.major===ae.major&&Ae.minor===ae.minor&&Ae.patch===ae.patch)return!0}return!1}return!0}function Y(q,ae,he){try{ae=new Re(ae,he)}catch{return!1}return ae.test(q)}function te(q,ae,he,Ae){var je,He,Qe,_e,at;switch(q=new oe(q,Ae),ae=new Re(ae,Ae),he){case">":je=ye,He=G,Qe=de,_e=">",at=">=";break;case"<":je=de,He=ee,Qe=ye,_e="<",at="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Y(q,ae,Ae))return!1;for(var st=0;st<ae.set.length;++st){var rt=ae.set[st],Pe=null,ze=null;if(rt.forEach(function(Le){Le.semver===pe&&(Le=new me(">=0.0.0")),Pe=Pe||Le,ze=ze||Le,je(Le.semver,Pe.semver,Ae)?Pe=Le:Qe(Le.semver,ze.semver,Ae)&&(ze=Le)}),Pe.operator===_e||Pe.operator===at||(!ze.operator||ze.operator===_e)&&He(q,ze.semver)||ze.operator===at&&Qe(q,ze.semver))return!1}return!0}me.prototype.parse=function(q){var ae=this.loose?v[K]:v[ue],he=q.match(ae);if(!he)throw new TypeError("Invalid comparator: "+q);this.operator=he[1],this.operator==="="&&(this.operator=""),he[2]?this.semver=new oe(he[2],this.loose):this.semver=pe},me.prototype.toString=function(){return this.value},me.prototype.test=function(q){return f("Comparator.test",q,this.loose),this.semver===pe||(typeof q=="string"&&(q=new oe(q,this.loose)),x(q,this.operator,this.semver,this.loose))},me.prototype.intersects=function(q,ae){if(!(q instanceof me))throw new TypeError("a Comparator is required");var he;if(this.operator==="")return he=new Re(q.value,ae),Y(this.value,he,ae);if(q.operator==="")return he=new Re(this.value,ae),Y(q.semver,he,ae);var Ae=!(this.operator!==">="&&this.operator!==">"||q.operator!==">="&&q.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||q.operator!=="<="&&q.operator!=="<"),He=this.semver.version===q.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||q.operator!==">="&&q.operator!=="<="),_e=x(this.semver,"<",q.semver,ae)&&(this.operator===">="||this.operator===">")&&(q.operator==="<="||q.operator==="<"),at=x(this.semver,">",q.semver,ae)&&(this.operator==="<="||this.operator==="<")&&(q.operator===">="||q.operator===">");return Ae||je||He&&Qe||_e||at},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(q){return q.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(q){var ae=this.loose;q=q.trim(),f("range",q,ae);var he=ae?v[Z]:v[Q];q=q.replace(he,Ie),f("hyphen replace",q),q=q.replace(v[X],"$1$2$3"),f("comparator trim",q,v[X]),q=(q=(q=q.replace(v[F],"$1~")).replace(v[M],"$1^")).split(/\s+/).join(" ");var Ae=ae?v[K]:v[ue],je=q.split(" ").map(function(He){return function(Qe,_e){return f("comp",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Pe,ze){f("caret",Pe,ze);var Le=ze?v[U]:v[j];return Pe.replace(Le,function(Ye,ne,se,Ce,qe){var Ze;return f("caret",Pe,Ye,ne,se,Ce,qe),ve(ne)?Ze="":ve(se)?Ze=">="+ne+".0.0 <"+(+ne+1)+".0.0":ve(Ce)?Ze=ne==="0"?">="+ne+"."+se+".0 <"+ne+"."+(+se+1)+".0":">="+ne+"."+se+".0 <"+(+ne+1)+".0.0":qe?(f("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ze=ne==="0"?se==="0"?">="+ne+"."+se+"."+Ce+qe+" <"+ne+"."+se+"."+(+Ce+1):">="+ne+"."+se+"."+Ce+qe+" <"+ne+"."+(+se+1)+".0":">="+ne+"."+se+"."+Ce+qe+" <"+(+ne+1)+".0.0"):(f("no pr"),Ze=ne==="0"?se==="0"?">="+ne+"."+se+"."+Ce+" <"+ne+"."+se+"."+(+Ce+1):">="+ne+"."+se+"."+Ce+" <"+ne+"."+(+se+1)+".0":">="+ne+"."+se+"."+Ce+" <"+(+ne+1)+".0.0"),f("caret return",Ze),Ze})}(rt,st)}).join(" ")}(Qe,_e),f("caret",Qe),Qe=function(at,st){return at.trim().split(/\s+/).map(function(rt){return function(Pe,ze){var Le=ze?v[T]:v[z];return Pe.replace(Le,function(Ye,ne,se,Ce,qe){var Ze;return f("tilde",Pe,Ye,ne,se,Ce,qe),ve(ne)?Ze="":ve(se)?Ze=">="+ne+".0.0 <"+(+ne+1)+".0.0":ve(Ce)?Ze=">="+ne+"."+se+".0 <"+ne+"."+(+se+1)+".0":qe?(f("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ze=">="+ne+"."+se+"."+Ce+qe+" <"+ne+"."+(+se+1)+".0"):Ze=">="+ne+"."+se+"."+Ce+" <"+ne+"."+(+se+1)+".0",f("tilde return",Ze),Ze})}(rt,st)}).join(" ")}(Qe,_e),f("tildes",Qe),Qe=function(at,st){return f("replaceXRanges",at,st),at.split(/\s+/).map(function(rt){return function(Pe,ze){Pe=Pe.trim();var Le=ze?v[m]:v[b];return Pe.replace(Le,function(Ye,ne,se,Ce,qe,Ze){f("xRange",Pe,Ye,ne,se,Ce,qe,Ze);var it=ve(se),nt=it||ve(Ce),Oe=nt||ve(qe);return ne==="="&&Oe&&(ne=""),it?Ye=ne===">"||ne==="<"?"<0.0.0":"*":ne&&Oe?(nt&&(Ce=0),Oe&&(qe=0),ne===">"?(ne=">=",nt?(se=+se+1,Ce=0,qe=0):Oe&&(Ce=+Ce+1,qe=0)):ne==="<="&&(ne="<",nt?se=+se+1:Ce=+Ce+1),Ye=ne+se+"."+Ce+"."+qe):nt?Ye=">="+se+".0.0 <"+(+se+1)+".0.0":Oe&&(Ye=">="+se+"."+Ce+".0 <"+se+"."+(+Ce+1)+".0"),f("xRange return",Ye),Ye})}(rt,st)}).join(" ")}(Qe,_e),f("xrange",Qe),Qe=function(at,st){return f("replaceStars",at,st),at.trim().replace(v[le],"")}(Qe,_e),f("stars",Qe),Qe}(He,ae)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(He){return!!He.match(Ae)})),je=je.map(function(He){return new me(He,ae)})},Re.prototype.intersects=function(q,ae){if(!(q instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(he){return he.every(function(Ae){return q.set.some(function(je){return je.every(function(He){return Ae.intersects(He,ae)})})})})},e.toComparators=function(q,ae){return new Re(q,ae).set.map(function(he){return he.map(function(Ae){return Ae.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(q){if(!q)return!1;typeof q=="string"&&(q=new oe(q,this.loose));for(var ae=0;ae<this.set.length;ae++)if(B(this.set[ae],q))return!0;return!1},e.satisfies=Y,e.maxSatisfying=function(q,ae,he){var Ae=null,je=null;try{var He=new Re(ae,he)}catch{return null}return q.forEach(function(Qe){He.test(Qe)&&(Ae&&je.compare(Qe)!==-1||(je=new oe(Ae=Qe,he)))}),Ae},e.minSatisfying=function(q,ae,he){var Ae=null,je=null;try{var He=new Re(ae,he)}catch{return null}return q.forEach(function(Qe){He.test(Qe)&&(Ae&&je.compare(Qe)!==1||(je=new oe(Ae=Qe,he)))}),Ae},e.validRange=function(q,ae){try{return new Re(q,ae).range||"*"}catch{return null}},e.ltr=function(q,ae,he){return te(q,ae,"<",he)},e.gtr=function(q,ae,he){return te(q,ae,">",he)},e.outside=te,e.prerelease=function(q,ae){var he=$e(q,ae);return he&&he.prerelease.length?he.prerelease:null},e.intersects=function(q,ae,he){return q=new Re(q,he),ae=new Re(ae,he),q.intersects(ae)},e.coerce=function(q){if(q instanceof oe)return q;if(typeof q!="string")return null;var ae=q.match(v[y]);return ae==null?null:$e((ae[1]||"0")+"."+(ae[2]||"0")+"."+(ae[3]||"0"))}}).call(this,C(1))},function(ge,e){var C,N,f=ge.exports={};function P(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function v(g){if(C===setTimeout)return setTimeout(g,0);if((C===P||!C)&&setTimeout)return C=setTimeout,setTimeout(g,0);try{return C(g,0)}catch{try{return C.call(null,g,0)}catch{return C.call(this,g,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:P}catch{C=P}try{N=typeof clearTimeout=="function"?clearTimeout:R}catch{N=R}})();var $,k=[],A=!1,D=-1;function w(){A&&$&&(A=!1,$.length?k=$.concat(k):D=-1,k.length&&E())}function E(){if(!A){var g=v(w);A=!0;for(var o=k.length;o;){for($=k,k=[];++D<o;)$&&$[D].run();D=-1,o=k.length}$=null,A=!1,function(i){if(N===clearTimeout)return clearTimeout(i);if((N===R||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(i);try{N(i)}catch{try{return N.call(null,i)}catch{return N.call(this,i)}}}(g)}}function S(g,o){this.fun=g,this.array=o}function c(){}f.nextTick=function(g){var o=new Array(arguments.length-1);if(arguments.length>1)for(var i=1;i<arguments.length;i++)o[i-1]=arguments[i];k.push(new S(g,o)),k.length!==1||A||v(E)},S.prototype.run=function(){this.fun.apply(null,this.array)},f.title="browser",f.browser=!0,f.env={},f.argv=[],f.version="",f.versions={},f.on=c,f.addListener=c,f.once=c,f.off=c,f.removeListener=c,f.removeAllListeners=c,f.emit=c,f.prependListener=c,f.prependOnceListener=c,f.listeners=function(g){return[]},f.binding=function(g){throw new Error("process.binding is not supported")},f.cwd=function(){return"/"},f.chdir=function(g){throw new Error("process.chdir is not supported")},f.umask=function(){return 0}}])}),define(ke[38],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rd=void 0;const C=globalThis.performance&&typeof globalThis.performance.now=="function";class N{static create(P){return new N(P)}constructor(P){this.c=C&&P===!1?Date.now:globalThis.performance.now.bind(globalThis.performance),this.a=this.c(),this.b=-1}stop(){this.b=this.c()}reset(){this.a=this.c(),this.b=-1}elapsed(){return this.b!==-1?this.b-this.a:this.c()-this.a}}e.$Rd=N}),define(ke[4],Se([1,0,14,74,3,75,38]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5d=e.$4d=e.$3d=e.$2d=e.$1d=e.$Zd=e.$Yd=e.$Xd=e.$Wd=e.$Vd=e.$Ud=e.$Td=e.Event=void 0;const v=!1,$=!1;var k;(function(b){b.None=()=>f.$Tc.None;function m(G){if($){const{onDidAddListener:x}=G,me=S.create();let pe=0;G.onDidAddListener=()=>{++pe===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),me.print()),x?.()}}}function y(G,x){return ue(G,()=>{},0,void 0,!0,void 0,x)}b.defer=y;function L(G){return(x,me=null,pe)=>{let Re=!1,ve;return ve=G(Ie=>{if(!Re)return ve?ve.dispose():Re=!0,x.call(me,Ie)},null,pe),Re&&ve.dispose(),ve}}b.once=L;function F(G,x,me){return U((pe,Re=null,ve)=>G(Ie=>pe.call(Re,x(Ie)),null,ve),me)}b.map=F;function z(G,x,me){return U((pe,Re=null,ve)=>G(Ie=>{x(Ie),pe.call(Re,Ie)},null,ve),me)}b.forEach=z;function T(G,x,me){return U((pe,Re=null,ve)=>G(Ie=>x(Ie)&&pe.call(Re,Ie),null,ve),me)}b.filter=T;function O(G){return G}b.signal=O;function M(...G){return(x,me=null,pe)=>{const Re=(0,f.$Qc)(...G.map(ve=>ve(Ie=>x.call(me,Ie))));return K(Re,pe)}}b.any=M;function j(G,x,me,pe){let Re=me;return F(G,ve=>(Re=x(Re,ve),Re),pe)}b.reduce=j;function U(G,x){let me;const pe={onWillAddFirstListener(){me=G(Re.fire,Re)},onDidRemoveLastListener(){me?.dispose()}};x||m(pe);const Re=new r(pe);return x?.add(Re),Re.event}function K(G,x){return x instanceof Array?x.push(G):x&&x.add(G),G}function ue(G,x,me=100,pe=!1,Re=!1,ve,Ie){let B,Y,te,q=0,ae;const he={leakWarningThreshold:ve,onWillAddFirstListener(){B=G(je=>{q++,Y=x(Y,je),pe&&!te&&(Ae.fire(Y),Y=void 0),ae=()=>{const He=Y;Y=void 0,te=void 0,(!pe||q>1)&&Ae.fire(He),q=0},typeof me=="number"?(clearTimeout(te),te=setTimeout(ae,me)):te===void 0&&(te=0,queueMicrotask(ae))})},onWillRemoveListener(){Re&&q>0&&ae?.()},onDidRemoveLastListener(){ae=void 0,B.dispose()}};Ie||m(he);const Ae=new r(he);return Ie?.add(Ae),Ae.event}b.debounce=ue;function X(G,x=0,me){return b.debounce(G,(pe,Re)=>pe?(pe.push(Re),pe):[Re],x,void 0,!0,void 0,me)}b.accumulate=X;function Q(G,x=(pe,Re)=>pe===Re,me){let pe=!0,Re;return T(G,ve=>{const Ie=pe||!x(ve,Re);return pe=!1,Re=ve,Ie},me)}b.latch=Q;function Z(G,x,me){return[b.filter(G,x,me),b.filter(G,pe=>!x(pe),me)]}b.split=Z;function le(G,x=!1,me=[],pe){let Re=me.slice(),ve=G(Y=>{Re?Re.push(Y):B.fire(Y)});pe&&pe.add(ve);const Ie=()=>{Re?.forEach(Y=>B.fire(Y)),Re=null},B=new r({onWillAddFirstListener(){ve||(ve=G(Y=>B.fire(Y)),pe&&pe.add(ve))},onDidAddFirstListener(){Re&&(x?setTimeout(Ie):Ie())},onDidRemoveLastListener(){ve&&ve.dispose(),ve=null}});return pe&&pe.add(B),B.event}b.buffer=le;function re(G,x){return(pe,Re,ve)=>{const Ie=x(new oe);return G(function(B){const Y=Ie.evaluate(B);Y!==$e&&pe.call(Re,Y)},void 0,ve)}}b.chain=re;const $e=Symbol("HaltChainable");class oe{constructor(){this.f=[]}map(x){return this.f.push(x),this}forEach(x){return this.f.push(me=>(x(me),me)),this}filter(x){return this.f.push(me=>x(me)?me:$e),this}reduce(x,me){let pe=me;return this.f.push(Re=>(pe=x(pe,Re),pe)),this}latch(x=(me,pe)=>me===pe){let me=!0,pe;return this.f.push(Re=>{const ve=me||!x(Re,pe);return me=!1,pe=Re,ve?Re:$e}),this}evaluate(x){for(const me of this.f)if(x=me(x),x===$e)break;return x}}function J(G,x,me=pe=>pe){const pe=(...B)=>Ie.fire(me(...B)),Re=()=>G.on(x,pe),ve=()=>G.removeListener(x,pe),Ie=new r({onWillAddFirstListener:Re,onDidRemoveLastListener:ve});return Ie.event}b.fromNodeEventEmitter=J;function V(G,x,me=pe=>pe){const pe=(...B)=>Ie.fire(me(...B)),Re=()=>G.addEventListener(x,pe),ve=()=>G.removeEventListener(x,pe),Ie=new r({onWillAddFirstListener:Re,onDidRemoveLastListener:ve});return Ie.event}b.fromDOMEventEmitter=V;function ie(G){return new Promise(x=>L(G)(x))}b.toPromise=ie;function ye(G){const x=new r;return G.then(me=>{x.fire(me)},()=>{x.fire(void 0)}).finally(()=>{x.dispose()}),x.event}b.fromPromise=ye;function de(G,x,me){return x(me),G(pe=>x(pe))}b.runAndSubscribe=de;class fe{constructor(x,me){this._observable=x,this.f=0,this.g=!1;const pe={onWillAddFirstListener:()=>{x.addObserver(this)},onDidRemoveLastListener:()=>{x.removeObserver(this)}};me||m(pe),this.emitter=new r(pe),me&&me.add(this.emitter)}beginUpdate(x){this.f++}handlePossibleChange(x){}handleChange(x,me){this.g=!0}endUpdate(x){this.f--,this.f===0&&(this._observable.reportChanges(),this.g&&(this.g=!1,this.emitter.fire(this._observable.get())))}}function _(G,x){return new fe(G,x).emitter.event}b.fromObservable=_;function ee(G){return(x,me,pe)=>{let Re=0,ve=!1;const Ie={beginUpdate(){Re++},endUpdate(){Re--,Re===0&&(G.reportChanges(),ve&&(ve=!1,x.call(me)))},handlePossibleChange(){},handleChange(){ve=!0}};G.addObserver(Ie),G.reportChanges();const B={dispose(){G.removeObserver(Ie)}};return pe instanceof f.$Sc?pe.add(B):Array.isArray(pe)&&pe.push(B),B}}b.fromObservableLight=ee})(k||(e.Event=k={}));class A{static{this.all=new Set}static{this.f=0}constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${A.f++}`,A.all.add(this)}start(m){this.g=new R.$Rd,this.listenerCount=m}stop(){if(this.g){const m=this.g.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.g=void 0}}}e.$Td=A;let D=-1;function w(b){const m=D;return D=b,{dispose(){D=m}}}e.$Ud=w;class E{constructor(m,y=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=y,this.g=0}dispose(){this.f?.clear()}check(m,y){const L=this.threshold;if(L<=0||y<L)return;this.f||(this.f=new Map);const F=this.f.get(m.value)||0;if(this.f.set(m.value,F+1),this.g-=1,this.g<=0){this.g=L*.5;let z,T=0;for(const[O,M]of this.f)(!z||T<M)&&(z=O,T=M);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${T}):`),console.warn(z)}return()=>{const z=this.f.get(m.value)||0;this.f.set(m.value,z-1)}}}class S{static create(){return new S(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}let c=0;class g{constructor(m){this.value=m,this.id=c++}}const o=2,i=(b,m)=>{if(b instanceof g)m(b);else for(let y=0;y<b.length;y++){const L=b[y];L&&m(L)}};class r{constructor(m){this.w=0,this.f=m,this.g=D>0||this.f?.leakWarningThreshold?new E(this.f?.leakWarningThreshold??D):void 0,this.j=this.f?._profName?new A(this.f._profName):void 0,this.u=this.f?.deliveryQueue}dispose(){if(!this.m){if(this.m=!0,this.u?.current===this&&this.u.reset(),this.t){if(v){const m=this.t;queueMicrotask(()=>{i(m,y=>y.stack?.print())})}this.t=void 0,this.w=0}this.f?.onDidRemoveLastListener?.(),this.g?.dispose()}}get event(){return this.q??=(m,y,L)=>{if(this.g&&this.w>this.g.threshold*3)return console.warn(`[${this.g.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),f.$Tc.None;if(this.m)return f.$Tc.None;y&&(m=m.bind(y));const F=new g(m);let z,T;this.g&&this.w>=Math.ceil(this.g.threshold*.2)&&(F.stack=S.create(),z=this.g.check(F.stack,this.w+1)),v&&(F.stack=T??S.create()),this.t?this.t instanceof g?(this.u??=new a,this.t=[this.t,F]):this.t.push(F):(this.f?.onWillAddFirstListener?.(this),this.t=F,this.f?.onDidAddFirstListener?.(this)),this.w++;const O=(0,f.$Rc)(()=>{z?.(),this.x(F)});return L instanceof f.$Sc?L.add(O):Array.isArray(L)&&L.push(O),O},this.q}x(m){if(this.f?.onWillRemoveListener?.(this),!this.t)return;if(this.w===1){this.t=void 0,this.f?.onDidRemoveLastListener?.(this),this.w=0;return}const y=this.t,L=y.indexOf(m);if(L===-1)throw console.log("disposed?",this.m),console.log("size?",this.w),console.log("arr?",JSON.stringify(this.t)),new Error("Attempted to dispose unknown listener");this.w--,y[L]=void 0;const F=this.u.current===this;if(this.w*o<=y.length){let z=0;for(let T=0;T<y.length;T++)y[T]?y[z++]=y[T]:F&&(this.u.end--,z<this.u.i&&this.u.i--);y.length=z}}y(m,y){if(!m)return;const L=this.f?.onListenerError||C.$1;if(!L){m.value(y);return}try{m.value(y)}catch(F){L(F)}}z(m){const y=m.current.t;for(;m.i<m.end;)this.y(y[m.i++],m.value);m.reset()}fire(m){if(this.u?.current&&(this.z(this.u),this.j?.stop()),this.j?.start(this.w),this.t)if(this.t instanceof g)this.y(this.t,m);else{const y=this.u;y.enqueue(this,m,this.t.length),this.z(y)}this.j?.stop()}hasListeners(){return this.w>0}}e.$Vd=r;const n=()=>new a;e.$Wd=n;class a{constructor(){this.i=-1,this.end=0}enqueue(m,y,L){this.i=0,this.end=L,this.current=m,this.value=y}reset(){this.i=this.end,this.current=void 0,this.value=void 0}}class t extends r{async fireAsync(m,y,L){if(this.t)for(this.h||(this.h=new P.$4c),i(this.t,F=>this.h.push([F.value,m]));this.h.size>0&&!y.isCancellationRequested;){const[F,z]=this.h.shift(),T=[],O={...z,token:y,waitUntil:M=>{if(Object.isFrozen(T))throw new Error("waitUntil can NOT be called asynchronous");L&&(M=L(M,F)),T.push(M)}};try{F(O)}catch(M){(0,C.$1)(M);continue}Object.freeze(T),await Promise.allSettled(T).then(M=>{for(const j of M)j.status==="rejected"&&(0,C.$1)(j.reason)})}}}e.$Xd=t;class h extends r{get isPaused(){return this.h!==0}constructor(m){super(m),this.h=0,this.s=new P.$4c,this.A=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.A){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.A(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.w&&(this.h!==0?this.s.push(m):super.fire(m))}}e.$Yd=h;class s extends h{constructor(m){super(m),this.k=m.delay??100}fire(m){this.o||(this.pause(),this.o=setTimeout(()=>{this.o=void 0,this.resume()},this.k)),super.fire(m)}}e.$Zd=s;class d extends r{constructor(m){super(m),this.h=[],this.k=m?.merge}fire(m){this.hasListeners()&&(this.h.push(m),this.h.length===1&&queueMicrotask(()=>{this.k?super.fire(this.k(this.h)):this.h.forEach(y=>super.fire(y)),this.h=[]}))}}e.$1d=d;class u{constructor(){this.g=!1,this.h=[],this.f=new r({onWillAddFirstListener:()=>this.j(),onDidRemoveLastListener:()=>this.k()})}get event(){return this.f.event}add(m){const y={event:m,listener:null};this.h.push(y),this.g&&this.m(y);const L=()=>{this.g&&this.o(y);const F=this.h.indexOf(y);this.h.splice(F,1)};return(0,f.$Rc)((0,N.$db)(L))}j(){this.g=!0,this.h.forEach(m=>this.m(m))}k(){this.g=!1,this.h.forEach(m=>this.o(m))}m(m){m.listener=m.event(y=>this.f.fire(y))}o(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.f.dispose()}}e.$2d=u;class l{constructor(m,y,L,F){this.f=new f.$Sc;const z=this.f.add(new u),T=this.f.add(new f.$3c);function O(M){T.set(M,z.add(F(M)))}for(const M of m)O(M);this.f.add(y(M=>{O(M)})),this.f.add(L(M=>{T.deleteAndDispose(M)})),this.event=z.event}dispose(){this.f.dispose()}}e.$3d=l;class p{constructor(){this.f=[]}wrapEvent(m){return(y,L,F)=>m(z=>{const T=this.f[this.f.length-1];T?T.push(()=>y.call(L,z)):y.call(L,z)},void 0,F)}bufferEvents(m){const y=[];this.f.push(y);const L=m();return this.f.pop(),y.forEach(F=>F()),L}}e.$4d=p;class I{constructor(){this.f=!1,this.g=k.None,this.h=f.$Tc.None,this.j=new r({onDidAddFirstListener:()=>{this.f=!0,this.h=this.g(this.j.fire,this.j)},onDidRemoveLastListener:()=>{this.f=!1,this.h.dispose()}}),this.event=this.j.event}set input(m){this.g=m,this.f&&(this.h.dispose(),this.h=m(this.j.fire,this.j))}dispose(){this.h.dispose(),this.j.dispose()}}e.$5d=I}),define(ke[21],Se([1,0,4]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6d=e.CancellationToken=void 0;const N=Object.freeze(function(v,$){const k=setTimeout(v.bind($),0);return{dispose(){clearTimeout(k)}}});var f;(function(v){function $(k){return k===v.None||k===v.Cancelled||k instanceof P?!0:!k||typeof k!="object"?!1:typeof k.isCancellationRequested=="boolean"&&typeof k.onCancellationRequested=="function"}v.isCancellationToken=$,v.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:C.Event.None}),v.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(f||(e.CancellationToken=f={}));class P{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new C.$Vd),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor($){this.f=void 0,this.g=void 0,this.g=$&&$.onCancellationRequested(this.cancel,this)}get token(){return this.f||(this.f=new P),this.f}cancel(){this.f?this.f instanceof P&&this.f.cancel():this.f=f.Cancelled}dispose($=!1){$&&this.cancel(),this.g?.dispose(),this.f?this.f instanceof P&&this.f.dispose():this.f=f.None}}e.$6d=R}),define(ke[162],Se([1,0,21]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ge=e.$Fe=e.$Ee=void 0;class N{constructor(v){this.b=v,this.a=null}get(){if(this.a)return this.a;const v=new C.$6d,$=this.b(v.token);return this.a={promise:$,dispose:()=>{this.a=null,v.cancel(),v.dispose()}},this.a}}e.$Ee=N;class f{constructor(v){this.c=v,this.a=void 0,this.b=void 0}get(v){const $=JSON.stringify(v);return this.b!==$&&(this.b=$,this.a=this.c(v)),this.a}}e.$Fe=f;class P{get cachedValues(){return this.a}constructor(v){this.b=v,this.a=new Map}get(v){if(this.a.has(v))return this.a.get(v);const $=this.b(v);return this.a.set(v,$),$}}e.$Ge=P}),define(ke[99],Se([1,0,14,3]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function f(n){const a=n;return a?typeof a.read=="function":!1}e.$7d=f;function P(n){const a=n;return a?[a.on,a.pause,a.resume,a.destroy].every(t=>typeof t=="function"):!1}e.$8d=P;function R(n){const a=n;return a?P(a.stream)&&Array.isArray(a.buffer)&&typeof a.ended=="boolean":!1}e.$9d=R;function v(n,a){return new $(n,a)}e.$0d=v;class ${constructor(a,t){this.e=a,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(a){if(!this.a.destroyed){if(this.a.flowing)this.g(a);else if(this.b.data.push(a),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(a){this.a.destroyed||(this.a.flowing?this.h(a):this.b.error.push(a))}end(a){this.a.destroyed||(typeof a<"u"&&this.write(a),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(a){this.c.data.slice(0).forEach(t=>t(a))}h(a){this.c.error.length===0?(0,C.$1)(a):this.c.error.slice(0).forEach(t=>t(a))}i(){this.c.end.slice(0).forEach(a=>a())}on(a,t){if(!this.a.destroyed)switch(a){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(a,t){if(this.a.destroyed)return;let h;switch(a){case"data":h=this.c.data;break;case"end":h=this.c.end;break;case"error":h=this.c.error;break}if(h){const s=h.indexOf(t);s>=0&&h.splice(s,1)}}j(){if(this.b.data.length>0){const a=this.e(this.b.data);this.g(a),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(h=>h())}}k(){if(this.c.error.length>0){for(const a of this.b.error)this.h(a);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function k(n,a){const t=[];let h;for(;(h=n.read())!==null;)t.push(h);return a(t)}e.$$d=k;function A(n,a,t){const h=[];let s;for(;(s=n.read())!==null&&h.length<t;)h.push(s);return s===null&&h.length>0?a(h):{read:()=>{if(h.length>0)return h.shift();if(typeof s<"u"){const d=s;return s=void 0,d}return n.read()}}}e.$_d=A;function D(n,a){return new Promise((t,h)=>{const s=[];w(n,{onData:d=>{a&&s.push(d)},onError:d=>{a?h(d):t(void 0)},onEnd:()=>{t(a?a(s):void 0)}})})}e.$ae=D;function w(n,a,t){n.on("error",h=>{t?.isCancellationRequested||a.onError(h)}),n.on("end",()=>{t?.isCancellationRequested||a.onEnd()}),n.on("data",h=>{t?.isCancellationRequested||a.onData(h)})}e.$be=w;function E(n,a){return new Promise((t,h)=>{const s=new N.$Sc,d=[],u=I=>{if(d.push(I),d.length>a)return s.dispose(),n.pause(),t({stream:n,buffer:d,ended:!1})},l=I=>(s.dispose(),h(I)),p=()=>(s.dispose(),t({stream:n,buffer:d,ended:!0}));s.add((0,N.$Rc)(()=>n.removeListener("error",l))),n.on("error",l),s.add((0,N.$Rc)(()=>n.removeListener("end",p))),n.on("end",p),s.add((0,N.$Rc)(()=>n.removeListener("data",u))),n.on("data",u)})}e.$ce=E;function S(n,a){const t=v(a);return t.end(n),t}e.$de=S;function c(){const n=v(()=>{throw new Error("not supported")});return n.end(),n}e.$ee=c;function g(n){let a=!1;return{read:()=>a?null:(a=!0,n)}}e.$fe=g;function o(n,a,t){const h=v(t);return w(n,{onData:s=>h.write(a.data(s)),onError:s=>h.error(a.error?a.error(s):s),onEnd:()=>h.end()}),h}e.$ge=o;function i(n,a,t){let h=!1;return{read:()=>{const s=a.read();return h?s:(h=!0,s!==null?t([n,s]):n)}}}e.$he=i;function r(n,a,t){let h=!1;const s=v(t);return w(a,{onData:d=>h?s.write(d):(h=!0,s.write(t([n,d]))),onError:d=>s.error(d),onEnd:()=>{h||(h=!0,s.write(n)),s.end()}}),s}e.$ie=r}),define(ke[22],Se([1,0,43,99]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const f=typeof Buffer<"u",P=new C.$V(()=>new Uint8Array(256));let R,v;class ${static alloc(y){return f?new $(Buffer.allocUnsafe(y)):new $(new Uint8Array(y))}static wrap(y){return f&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new $(y)}static fromString(y,L){return!(L?.dontUseNodeBuffer||!1)&&f?new $(Buffer.from(y)):(R||(R=new TextEncoder),new $(R.encode(y)))}static fromByteArray(y){const L=$.alloc(y.length);for(let F=0,z=y.length;F<z;F++)L.buffer[F]=y[F];return L}static concat(y,L){if(typeof L>"u"){L=0;for(let T=0,O=y.length;T<O;T++)L+=y[T].byteLength}const F=$.alloc(L);let z=0;for(let T=0,O=y.length;T<O;T++){const M=y[T];F.set(M,z),z+=M.byteLength}return F}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=$.alloc(this.byteLength);return y.set(this),y}toString(){return f?this.buffer.toString():(v||(v=new TextDecoder),v.decode(this.buffer))}slice(y,L){return new $(this.buffer.subarray(y,L))}set(y,L){if(y instanceof $)this.buffer.set(y.buffer,L);else if(y instanceof Uint8Array)this.buffer.set(y,L);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),L);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),L);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return w(this.buffer,y)}writeUInt32BE(y,L){E(this.buffer,y,L)}readUInt32LE(y){return S(this.buffer,y)}writeUInt32LE(y,L){c(this.buffer,y,L)}readUInt8(y){return g(this.buffer,y)}writeUInt8(y,L){o(this.buffer,y,L)}indexOf(y,L=0){return k(this.buffer,y instanceof $?y.buffer:y,L)}}e.$je=$;function k(m,y,L=0){const F=y.byteLength,z=m.byteLength;if(F===0)return 0;if(F===1)return m.indexOf(y[0]);if(F>z-L)return-1;const T=P.value;T.fill(y.length);for(let U=0;U<y.length;U++)T[y[U]]=y.length-U-1;let O=L+y.length-1,M=O,j=-1;for(;O<z;)if(m[O]===y[M]){if(M===0){j=O;break}O--,M--}else O+=Math.max(y.length-M,T[m[O]]),M=y.length-1;return j}e.$ke=k;function A(m,y){return m[y+0]<<0>>>0|m[y+1]<<8>>>0}e.$le=A;function D(m,y,L){m[L+0]=y&255,y=y>>>8,m[L+1]=y&255}e.$me=D;function w(m,y){return m[y]*2**24+m[y+1]*2**16+m[y+2]*2**8+m[y+3]}e.$ne=w;function E(m,y,L){m[L+3]=y,y=y>>>8,m[L+2]=y,y=y>>>8,m[L+1]=y,y=y>>>8,m[L]=y}e.$oe=E;function S(m,y){return m[y+0]<<0>>>0|m[y+1]<<8>>>0|m[y+2]<<16>>>0|m[y+3]<<24>>>0}e.$pe=S;function c(m,y,L){m[L+0]=y&255,y=y>>>8,m[L+1]=y&255,y=y>>>8,m[L+2]=y&255,y=y>>>8,m[L+3]=y&255}e.$qe=c;function g(m,y){return m[y]}e.$re=g;function o(m,y,L){m[L]=y}e.$se=o;function i(m){return N.$$d(m,y=>$.concat(y))}e.$te=i;function r(m){return N.$fe(m)}e.$ue=r;function n(m){return N.$ae(m,y=>$.concat(y))}e.$ve=n;async function a(m){return m.ended?$.concat(m.buffer):$.concat([...m.buffer,await n(m.stream)])}e.$we=a;function t(m){return N.$de(m,y=>$.concat(y))}e.$xe=t;function h(m){return N.$ge(m,{data:y=>typeof y=="string"?$.fromString(y):$.wrap(y)},y=>$.concat(y))}e.$ye=h;function s(m){return N.$0d(y=>$.concat(y),m)}e.$ze=s;function d(m,y){return N.$he(m,y,L=>$.concat(L))}e.$Ae=d;function u(m,y){return N.$ie(m,y,L=>$.concat(L))}e.$Be=u;function l(m){let y=0,L=0,F=0;const z=new Uint8Array(Math.floor(m.length/4*3)),T=M=>{switch(L){case 3:z[F++]=y|M,L=0;break;case 2:z[F++]=y|M>>>2,y=M<<6,L=3;break;case 1:z[F++]=y|M>>>4,y=M<<4,L=2;break;default:y=M<<2,L=1}};for(let M=0;M<m.length;M++){const j=m.charCodeAt(M);if(j>=65&&j<=90)T(j-65);else if(j>=97&&j<=122)T(j-97+26);else if(j>=48&&j<=57)T(j-48+52);else if(j===43||j===45)T(62);else if(j===47||j===95)T(63);else{if(j===61)break;throw new SyntaxError(`Unexpected base64 character ${m[M]}`)}}const O=F;for(;L>0;)T(0);return $.wrap(z).slice(0,O)}e.$Ce=l;const p="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",I="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function b({buffer:m},y=!0,L=!1){const F=L?I:p;let z="";const T=m.byteLength%3;let O=0;for(;O<m.byteLength-T;O+=3){const M=m[O+0],j=m[O+1],U=m[O+2];z+=F[M>>>2],z+=F[(M<<4|j>>>4)&63],z+=F[(j<<2|U>>>6)&63],z+=F[U&63]}if(T===1){const M=m[O+0];z+=F[M>>>2],z+=F[M<<4&63],y&&(z+="==")}else if(T===2){const M=m[O+0],j=m[O+1];z+=F[M>>>2],z+=F[(M<<4|j>>>4)&63],z+=F[j<<2&63],y&&(z+="=")}return z}e.$De=b}),define(ke[12],Se([1,0,162,43]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hf=e.$Gf=e.$Ff=e.$Ef=e.GraphemeBreakType=e.$Df=e.$Cf=e.$Bf=e.$Af=e.$zf=e.$yf=e.$xf=e.$wf=e.$vf=e.$uf=e.$tf=e.$sf=e.$rf=e.$qf=e.$pf=e.$of=e.$nf=e.$mf=e.$lf=e.$kf=e.$jf=e.$if=e.$hf=e.$gf=e.$ff=e.$ef=e.$df=e.$cf=e.$bf=e.$af=e.$_e=e.$$e=e.$0e=e.$9e=e.$8e=e.$7e=e.$6e=e.$5e=e.$4e=e.$3e=e.$2e=e.$1e=e.$Ze=e.$Ye=e.$Xe=e.$We=e.$Ve=e.$Ue=e.$Te=e.$Se=e.$Re=e.$Qe=e.$Pe=e.$Oe=e.$Ne=e.$Me=e.$Le=e.$Ke=e.$Je=void 0;function f(Pe){return!Pe||typeof Pe!="string"?!0:Pe.trim().length===0}e.$Je=f;const P=/{(\d+)}/g;function R(Pe,...ze){return ze.length===0?Pe:Pe.replace(P,function(Le,Ye){const ne=parseInt(Ye,10);return isNaN(ne)||ne<0||ne>=ze.length?Le:ze[ne]})}e.$Ke=R;const v=/{([^}]+)}/g;function $(Pe,ze){return Object.keys(ze).length===0?Pe:Pe.replace(v,(Le,Ye)=>ze[Ye]??Le)}e.$Le=$;function k(Pe){return Pe.replace(/[<>"'&]/g,ze=>{switch(ze){case"<":return"&lt;";case">":return"&gt;";case'"':return"&quot;";case"'":return"&apos;";case"&":return"&amp;"}return ze})}e.$Me=k;function A(Pe){return Pe.replace(/[<>&]/g,function(ze){switch(ze){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ze}})}e.$Ne=A;function D(Pe){return Pe.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.$Oe=D;function w(Pe,ze){let Le=0;const Ye=ze.charCodeAt(0);for(let ne=Pe.length-1;ne>=0;ne--)Pe.charCodeAt(ne)===Ye&&Le++;return Le}e.$Pe=w;function E(Pe,ze,Le="\u2026"){return Pe.length<=ze?Pe:`${Pe.substr(0,ze)}${Le}`}e.$Qe=E;function S(Pe,ze,Le="\u2026"){if(Pe.length<=ze)return Pe;const Ye=Math.ceil(ze/2)-Le.length/2,ne=Math.floor(ze/2)-Le.length/2;return`${Pe.substr(0,Ye)}${Le}${Pe.substr(Pe.length-ne)}`}e.$Re=S;function c(Pe,ze=" "){const Le=g(Pe,ze);return o(Le,ze)}e.$Se=c;function g(Pe,ze){if(!Pe||!ze)return Pe;const Le=ze.length;if(Le===0||Pe.length===0)return Pe;let Ye=0;for(;Pe.indexOf(ze,Ye)===Ye;)Ye=Ye+Le;return Pe.substring(Ye)}e.$Te=g;function o(Pe,ze){if(!Pe||!ze)return Pe;const Le=ze.length,Ye=Pe.length;if(Le===0||Ye===0)return Pe;let ne=Ye,se=-1;for(;se=Pe.lastIndexOf(ze,ne-1),!(se===-1||se+Le!==ne);){if(se===0)return"";ne=se}return Pe.substring(0,ne)}e.$Ue=o;function i(Pe){return Pe.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.$Ve=i;function r(Pe){return Pe.replace(/\*/g,"")}e.$We=r;function n(Pe,ze,Le={}){if(!Pe)throw new Error("Cannot create regex from empty string");ze||(Pe=D(Pe)),Le.wholeWord&&(/\B/.test(Pe.charAt(0))||(Pe="\\b"+Pe),/\B/.test(Pe.charAt(Pe.length-1))||(Pe=Pe+"\\b"));let Ye="";return Le.global&&(Ye+="g"),Le.matchCase||(Ye+="i"),Le.multiline&&(Ye+="m"),Le.unicode&&(Ye+="u"),new RegExp(Pe,Ye)}e.$Xe=n;function a(Pe){return Pe.source==="^"||Pe.source==="^$"||Pe.source==="$"||Pe.source==="^\\s*$"?!1:!!(Pe.exec("")&&Pe.lastIndex===0)}e.$Ye=a;function t(Pe){return Pe.split(/\r\n|\r|\n/)}e.$Ze=t;function h(Pe){for(let ze=0,Le=Pe.length;ze<Le;ze++){const Ye=Pe.charCodeAt(ze);if(Ye!==32&&Ye!==9)return ze}return-1}e.$1e=h;function s(Pe,ze=0,Le=Pe.length){for(let Ye=ze;Ye<Le;Ye++){const ne=Pe.charCodeAt(Ye);if(ne!==32&&ne!==9)return Pe.substring(ze,Ye)}return Pe.substring(ze,Le)}e.$2e=s;function d(Pe,ze=Pe.length-1){for(let Le=ze;Le>=0;Le--){const Ye=Pe.charCodeAt(Le);if(Ye!==32&&Ye!==9)return Le}return-1}e.$3e=d;function u(Pe,ze,Le){const Ye=[];let ne=0;for(const se of Pe.matchAll(ze)){if(Ye.push(Pe.slice(ne,se.index)),se.index===void 0)throw new Error("match.index should be defined");ne=se.index+se[0].length,Ye.push(Le(se[0],...se.slice(1),se.index,Pe,se.groups))}return Ye.push(Pe.slice(ne)),Promise.all(Ye).then(se=>se.join(""))}e.$4e=u;function l(Pe,ze){return Pe<ze?-1:Pe>ze?1:0}e.$5e=l;function p(Pe,ze,Le=0,Ye=Pe.length,ne=0,se=ze.length){for(;Le<Ye&&ne<se;Le++,ne++){const Ze=Pe.charCodeAt(Le),it=ze.charCodeAt(ne);if(Ze<it)return-1;if(Ze>it)return 1}const Ce=Ye-Le,qe=se-ne;return Ce<qe?-1:Ce>qe?1:0}e.$6e=p;function I(Pe,ze){return b(Pe,ze,0,Pe.length,0,ze.length)}e.$7e=I;function b(Pe,ze,Le=0,Ye=Pe.length,ne=0,se=ze.length){for(;Le<Ye&&ne<se;Le++,ne++){let Ze=Pe.charCodeAt(Le),it=ze.charCodeAt(ne);if(Ze===it)continue;if(Ze>=128||it>=128)return p(Pe.toLowerCase(),ze.toLowerCase(),Le,Ye,ne,se);y(Ze)&&(Ze-=32),y(it)&&(it-=32);const nt=Ze-it;if(nt!==0)return nt}const Ce=Ye-Le,qe=se-ne;return Ce<qe?-1:Ce>qe?1:0}e.$8e=b;function m(Pe){return Pe>=48&&Pe<=57}e.$9e=m;function y(Pe){return Pe>=97&&Pe<=122}e.$0e=y;function L(Pe){return Pe>=65&&Pe<=90}e.$$e=L;function F(Pe,ze){return Pe.length===ze.length&&b(Pe,ze)===0}e.$_e=F;function z(Pe,ze){const Le=ze.length;return ze.length>Pe.length?!1:b(Pe,ze,0,Le)===0}e.$af=z;function T(Pe,ze){const Le=Math.min(Pe.length,ze.length);let Ye;for(Ye=0;Ye<Le;Ye++)if(Pe.charCodeAt(Ye)!==ze.charCodeAt(Ye))return Ye;return Le}e.$bf=T;function O(Pe,ze){const Le=Math.min(Pe.length,ze.length);let Ye;const ne=Pe.length-1,se=ze.length-1;for(Ye=0;Ye<Le;Ye++)if(Pe.charCodeAt(ne-Ye)!==ze.charCodeAt(se-Ye))return Ye;return Le}e.$cf=O;function M(Pe){return 55296<=Pe&&Pe<=56319}e.$df=M;function j(Pe){return 56320<=Pe&&Pe<=57343}e.$ef=j;function U(Pe,ze){return(Pe-55296<<10)+(ze-56320)+65536}e.$ff=U;function K(Pe,ze,Le){const Ye=Pe.charCodeAt(Le);if(M(Ye)&&Le+1<ze){const ne=Pe.charCodeAt(Le+1);if(j(ne))return U(Ye,ne)}return Ye}e.$gf=K;function ue(Pe,ze){const Le=Pe.charCodeAt(ze-1);if(j(Le)&&ze>1){const Ye=Pe.charCodeAt(ze-2);if(M(Ye))return U(Ye,Le)}return Le}class X{get offset(){return this.e}constructor(ze,Le=0){this.c=ze,this.d=ze.length,this.e=Le}setOffset(ze){this.e=ze}prevCodePoint(){const ze=ue(this.c,this.e);return this.e-=ze>=65536?2:1,ze}nextCodePoint(){const ze=K(this.c,this.d,this.e);return this.e+=ze>=65536?2:1,ze}eol(){return this.e>=this.d}}e.$hf=X;class Q{get offset(){return this.c.offset}constructor(ze,Le=0){this.c=new X(ze,Le)}nextGraphemeLength(){const ze=Ae.getInstance(),Le=this.c,Ye=Le.offset;let ne=ze.getGraphemeBreakType(Le.nextCodePoint());for(;!Le.eol();){const se=Le.offset,Ce=ze.getGraphemeBreakType(Le.nextCodePoint());if(ae(ne,Ce)){Le.setOffset(se);break}ne=Ce}return Le.offset-Ye}prevGraphemeLength(){const ze=Ae.getInstance(),Le=this.c,Ye=Le.offset;let ne=ze.getGraphemeBreakType(Le.prevCodePoint());for(;Le.offset>0;){const se=Le.offset,Ce=ze.getGraphemeBreakType(Le.prevCodePoint());if(ae(Ce,ne)){Le.setOffset(se);break}ne=Ce}return Ye-Le.offset}eol(){return this.c.eol()}}e.$if=Q;function Z(Pe,ze){return new Q(Pe,ze).nextGraphemeLength()}e.$jf=Z;function le(Pe,ze){return new Q(Pe,ze).prevGraphemeLength()}e.$kf=le;function re(Pe,ze){ze>0&&j(Pe.charCodeAt(ze))&&ze--;const Le=ze+Z(Pe,ze);return[Le-le(Pe,Le),Le]}e.$lf=re;function $e(Pe){const ze=new Q(Pe);let Le=0;for(;!ze.eol();)Le++,ze.nextGraphemeLength();return Le}e.$mf=$e;let oe;function J(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function V(Pe){return oe||(oe=J()),oe.test(Pe)}e.$nf=V;const ie=/^[\t\n\r\x20-\x7E]*$/;function ye(Pe){return ie.test(Pe)}e.$of=ye,e.$pf=/[\u2028\u2029]/;function de(Pe){return e.$pf.test(Pe)}e.$qf=de;function fe(Pe){return Pe>=11904&&Pe<=55215||Pe>=63744&&Pe<=64255||Pe>=65281&&Pe<=65374}e.$rf=fe;function _(Pe){return Pe>=127462&&Pe<=127487||Pe===8986||Pe===8987||Pe===9200||Pe===9203||Pe>=9728&&Pe<=10175||Pe===11088||Pe===11093||Pe>=127744&&Pe<=128591||Pe>=128640&&Pe<=128764||Pe>=128992&&Pe<=129008||Pe>=129280&&Pe<=129535||Pe>=129648&&Pe<=129782}e.$sf=_;function ee(Pe,ze,Le=""){const Ye=Pe.trimStart();if(Ye.length<ze)return Ye;const ne=/\b/g;let se=0;for(;ne.test(Ye)&&!(Ye.length-ne.lastIndex<ze);)se=ne.lastIndex,ne.lastIndex+=1;return se===0?Ye:Le+Ye.substring(se).trimStart()}e.$tf=ee;const G=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,x=/\x1b\].*?\x07/g;function me(Pe){return Pe&&(Pe=Pe.replace(G,"").replace(x,"")),Pe}e.$uf=me,e.$vf=String.fromCharCode(65279);function pe(Pe){return!!(Pe&&Pe.length>0&&Pe.charCodeAt(0)===65279)}e.$wf=pe;function Re(Pe){return pe(Pe)?Pe.substr(1):Pe}e.$xf=Re;function ve(Pe,ze){if(!Pe||!ze||Pe.length<ze.length)return!1;const Le=ze.length,Ye=Pe.toLowerCase();let ne=0,se=-1;for(;ne<Le;){const Ce=Ye.indexOf(ze[ne],se+1);if(Ce<0)return!1;se=Ce,ne++}return!0}e.$yf=ve;function Ie(Pe,ze=!1){return Pe?(ze&&(Pe=Pe.replace(/\\./g,"")),Pe.toLowerCase()!==Pe):!1}e.$zf=Ie;function B(Pe){return Pe.charAt(0).toUpperCase()+Pe.slice(1)}e.$Af=B;function Y(Pe,ze=1){if(ze===0)return"";let Le=-1;do Le=Pe.indexOf(`
`,Le+1),ze--;while(ze>0&&Le>=0);return Le===-1?Pe:(Pe[Le-1]==="\r"&&Le--,Pe.substr(0,Le))}e.$Bf=Y;function te(Pe){return Pe=Pe%(2*26),Pe<26?String.fromCharCode(97+Pe):String.fromCharCode(65+Pe-26)}e.$Cf=te;function q(Pe){return Ae.getInstance().getGraphemeBreakType(Pe)}e.$Df=q;function ae(Pe,ze){return Pe===0?ze!==5&&ze!==7:Pe===2&&ze===3?!1:Pe===4||Pe===2||Pe===3||ze===4||ze===2||ze===3?!0:!(Pe===8&&(ze===8||ze===9||ze===11||ze===12)||(Pe===11||Pe===9)&&(ze===9||ze===10)||(Pe===12||Pe===10)&&ze===10||ze===5||ze===13||ze===7||Pe===1||Pe===13&&ze===14||Pe===6&&ze===6)}var he;(function(Pe){Pe[Pe.Other=0]="Other",Pe[Pe.Prepend=1]="Prepend",Pe[Pe.CR=2]="CR",Pe[Pe.LF=3]="LF",Pe[Pe.Control=4]="Control",Pe[Pe.Extend=5]="Extend",Pe[Pe.Regional_Indicator=6]="Regional_Indicator",Pe[Pe.SpacingMark=7]="SpacingMark",Pe[Pe.L=8]="L",Pe[Pe.V=9]="V",Pe[Pe.T=10]="T",Pe[Pe.LV=11]="LV",Pe[Pe.LVT=12]="LVT",Pe[Pe.ZWJ=13]="ZWJ",Pe[Pe.Extended_Pictographic=14]="Extended_Pictographic"})(he||(e.GraphemeBreakType=he={}));class Ae{static{this.c=null}static getInstance(){return Ae.c||(Ae.c=new Ae),Ae.c}constructor(){this.d=je()}getGraphemeBreakType(ze){if(ze<32)return ze===10?3:ze===13?2:4;if(ze<127)return 0;const Le=this.d,Ye=Le.length/3;let ne=1;for(;ne<=Ye;)if(ze<Le[3*ne])ne=2*ne;else if(ze>Le[3*ne+1])ne=2*ne+1;else return Le[3*ne+2];return 0}}function je(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function He(Pe,ze){if(Pe===0)return 0;const Le=Qe(Pe,ze);if(Le!==void 0)return Le;const Ye=new X(ze,Pe);return Ye.prevCodePoint(),Ye.offset}e.$Ef=He;function Qe(Pe,ze){const Le=new X(ze,Pe);let Ye=Le.prevCodePoint();for(;_e(Ye)||Ye===65039||Ye===8419;){if(Le.offset===0)return;Ye=Le.prevCodePoint()}if(!_(Ye))return;let ne=Le.offset;return ne>0&&Le.prevCodePoint()===8205&&(ne=Le.offset),ne}function _e(Pe){return 127995<=Pe&&Pe<=127999}var at;(function(Pe){Pe[Pe.zwj=8205]="zwj",Pe[Pe.emojiVariantSelector=65039]="emojiVariantSelector",Pe[Pe.enclosingKeyCap=8419]="enclosingKeyCap"})(at||(at={})),e.$Ff="\xA0";class st{static{this.c=new N.$V(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}'))}static{this.d=new C.$Fe(ze=>{function Le(nt){const Oe=new Map;for(let yt=0;yt<nt.length;yt+=2)Oe.set(nt[yt],nt[yt+1]);return Oe}function Ye(nt,Oe){const yt=new Map(nt);for(const[Dt,Nt]of Oe)yt.set(Dt,Nt);return yt}function ne(nt,Oe){if(!nt)return Oe;const yt=new Map;for(const[Dt,Nt]of nt)Oe.has(Dt)&&yt.set(Dt,Nt);return yt}const se=this.c.value;let Ce=ze.filter(nt=>!nt.startsWith("_")&&nt in se);Ce.length===0&&(Ce=["_default"]);let qe;for(const nt of Ce){const Oe=Le(se[nt]);qe=ne(qe,Oe)}const Ze=Le(se._common),it=Ye(Ze,qe);return new st(it)})}static getInstance(ze){return st.d.get(Array.from(ze))}static{this.e=new N.$V(()=>Object.keys(st.c.value).filter(ze=>!ze.startsWith("_")))}static getLocales(){return st.e.value}constructor(ze){this.f=ze}isAmbiguous(ze){return this.f.has(ze)}getPrimaryConfusable(ze){return this.f.get(ze)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.$Gf=st;class rt{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static{this.d=void 0}static e(){return this.d||(this.d=new Set(rt.c())),this.d}static isInvisibleCharacter(ze){return rt.e().has(ze)}static get codePoints(){return rt.e()}}e.$Hf=rt}),define(ke[123],Se([1,0,28,161,12]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9j=e.$8j=e.$7j=e.$6j=e.FuzzyScore=e.$5j=e.$4j=e.$3j=e.$2j=e.$1j=e.$Zj=e.$Yj=e.$Xj=e.$Wj=e.$Vj=e.$Uj=e.$Tj=e.or=void 0;function P(...ve){return function(Ie,B){for(let Y=0,te=ve.length;Y<te;Y++){const q=ve[Y](Ie,B);if(q)return q}return null}}e.or=P,e.$Tj=R.bind(void 0,!1),e.$Uj=R.bind(void 0,!0);function R(ve,Ie,B){if(!B||B.length<Ie.length)return null;let Y;return ve?Y=f.$af(B,Ie):Y=B.indexOf(Ie)===0,Y?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function v(ve,Ie){const B=Ie.toLowerCase().indexOf(ve.toLowerCase());return B===-1?null:[{start:B,end:B+ve.length}]}e.$Vj=v;function $(ve,Ie){return k(ve.toLowerCase(),Ie.toLowerCase(),0,0)}e.$Wj=$;function k(ve,Ie,B,Y){if(B===ve.length)return[];if(Y===Ie.length)return null;if(ve[B]===Ie[Y]){let te=null;return(te=k(ve,Ie,B+1,Y+1))?n({start:Y,end:Y+1},te):null}return k(ve,Ie,B,Y+1)}function A(ve){return 97<=ve&&ve<=122}function D(ve){return 65<=ve&&ve<=90}e.$Xj=D;function w(ve){return 48<=ve&&ve<=57}function E(ve){return ve===32||ve===9||ve===10||ve===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ve=>S.add(ve.charCodeAt(0)));function c(ve){return E(ve)||S.has(ve)}function g(ve,Ie){return ve===Ie||c(ve)&&c(Ie)}const o=new Map;function i(ve){if(o.has(ve))return o.get(ve);let Ie;const B=(0,N.$Rj)(ve);return B&&(Ie=B),o.set(ve,Ie),Ie}function r(ve){return A(ve)||D(ve)||w(ve)}function n(ve,Ie){return Ie.length===0?Ie=[ve]:ve.end===Ie[0].start?Ie[0].start=ve.start:Ie.unshift(ve),Ie}function a(ve,Ie){for(let B=Ie;B<ve.length;B++){const Y=ve.charCodeAt(B);if(D(Y)||w(Y)||B>0&&!r(ve.charCodeAt(B-1)))return B}return ve.length}function t(ve,Ie,B,Y){if(B===ve.length)return[];if(Y===Ie.length)return null;if(ve[B]!==Ie[Y].toLowerCase())return null;{let te=null,q=Y+1;for(te=t(ve,Ie,B+1,Y+1);!te&&(q=a(Ie,q))<Ie.length;)te=t(ve,Ie,B+1,q),q++;return te===null?null:n({start:Y,end:Y+1},te)}}function h(ve){let Ie=0,B=0,Y=0,te=0,q=0;for(let He=0;He<ve.length;He++)q=ve.charCodeAt(He),D(q)&&Ie++,A(q)&&B++,r(q)&&Y++,w(q)&&te++;const ae=Ie/ve.length,he=B/ve.length,Ae=Y/ve.length,je=te/ve.length;return{upperPercent:ae,lowerPercent:he,alphaPercent:Ae,numericPercent:je}}function s(ve){const{upperPercent:Ie,lowerPercent:B}=ve;return B===0&&Ie>.6}function d(ve){const{upperPercent:Ie,lowerPercent:B,alphaPercent:Y,numericPercent:te}=ve;return B>.2&&Ie<.8&&Y>.6&&te<.2}function u(ve){let Ie=0,B=0,Y=0,te=0;for(let q=0;q<ve.length;q++)Y=ve.charCodeAt(q),D(Y)&&Ie++,A(Y)&&B++,E(Y)&&te++;return(Ie===0||B===0)&&te===0?ve.length<=30:Ie<=5}function l(ve,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!u(ve)||Ie.length>60)return null;const B=h(Ie);if(!d(B)){if(!s(B))return null;Ie=Ie.toLowerCase()}let Y=null,te=0;for(ve=ve.toLowerCase();te<Ie.length&&(Y=t(ve,Ie,0,te))===null;)te=a(Ie,te+1);return Y}e.$Yj=l;function p(ve,Ie,B=!1){if(!Ie||Ie.length===0)return null;let Y=null,te=0;for(ve=ve.toLowerCase(),Ie=Ie.toLowerCase();te<Ie.length&&(Y=I(ve,Ie,0,te,B),Y===null);)te=b(Ie,te+1);return Y}e.$Zj=p;function I(ve,Ie,B,Y,te){let q=0;if(B===ve.length)return[];if(Y===Ie.length)return null;if(!g(ve.charCodeAt(B),Ie.charCodeAt(Y))){const Ae=i(ve.charCodeAt(B));if(!Ae)return null;for(let je=0;je<Ae.length;je++)if(!g(Ae[je],Ie.charCodeAt(Y+je)))return null;q+=Ae.length-1}let ae=null,he=Y+q+1;if(ae=I(ve,Ie,B+1,he,te),!te)for(;!ae&&(he=b(Ie,he))<Ie.length;)ae=I(ve,Ie,B+1,he,te),he++;if(!ae)return null;if(ve.charCodeAt(B)!==Ie.charCodeAt(Y)){const Ae=i(ve.charCodeAt(B));if(!Ae)return ae;for(let je=0;je<Ae.length;je++)if(Ae[je]!==Ie.charCodeAt(Y+je))return ae}return n({start:Y,end:Y+q+1},ae)}function b(ve,Ie){for(let B=Ie;B<ve.length;B++)if(c(ve.charCodeAt(B))||B>0&&c(ve.charCodeAt(B-1)))return B;return ve.length}const m=P(e.$Uj,l,v),y=P(e.$Uj,l,$),L=new C.$Dc(1e4);function F(ve,Ie,B=!1){if(typeof ve!="string"||typeof Ie!="string")return null;let Y=L.get(ve);Y||(Y=new RegExp(f.$Ve(ve),"i"),L.set(ve,Y));const te=Y.exec(Ie);return te?[{start:te.index,end:te.index+te[0].length}]:B?y(ve,Ie):m(ve,Ie)}e.$1j=F;function z(ve,Ie){const B=_(ve,ve.toLowerCase(),0,Ie,Ie.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return B?O(B):null}e.$2j=z;function T(ve,Ie,B,Y,te,q){const ae=Math.min(13,ve.length);for(;B<ae;B++){const he=_(ve,Ie,B,Y,te,q,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(he)return he}return[0,q]}e.$3j=T;function O(ve){if(typeof ve>"u")return[];const Ie=[],B=ve[1];for(let Y=ve.length-1;Y>1;Y--){const te=ve[Y]+B,q=Ie[Ie.length-1];q&&q.end===te?q.end=te+1:Ie.push({start:te,end:te+1})}return Ie}e.$4j=O;const M=128;function j(){const ve=[],Ie=[];for(let B=0;B<=M;B++)Ie[B]=0;for(let B=0;B<=M;B++)ve.push(Ie.slice(0));return ve}function U(ve){const Ie=[];for(let B=0;B<=ve;B++)Ie[B]=0;return Ie}const K=U(2*M),ue=U(2*M),X=j(),Q=j(),Z=j(),le=!1;function re(ve,Ie,B,Y,te){function q(he,Ae,je=" "){for(;he.length<Ae;)he=je+he;return he}let ae=` |   |${Y.split("").map(he=>q(he,3)).join("|")}
`;for(let he=0;he<=B;he++)he===0?ae+=" |":ae+=`${Ie[he-1]}|`,ae+=ve[he].slice(0,te+1).map(Ae=>q(Ae.toString(),3)).join("|")+`
`;return ae}function $e(ve,Ie,B,Y){ve=ve.substr(Ie),B=B.substr(Y),console.log(re(Q,ve,ve.length,B,B.length)),console.log(re(Z,ve,ve.length,B,B.length)),console.log(re(X,ve,ve.length,B,B.length))}function oe(ve,Ie){if(Ie<0||Ie>=ve.length)return!1;const B=ve.codePointAt(Ie);switch(B){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!f.$sf(B)}}function J(ve,Ie){if(Ie<0||Ie>=ve.length)return!1;switch(ve.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function V(ve,Ie,B){return Ie[ve]!==B[ve]}function ie(ve,Ie,B,Y,te,q,ae=!1){for(;Ie<B&&te<q;)ve[Ie]===Y[te]&&(ae&&(K[Ie]=te),Ie+=1),te+=1;return Ie===B}e.$5j=ie;var ye;(function(ve){ve[ve.Diag=1]="Diag",ve[ve.Left=2]="Left",ve[ve.LeftLeft=3]="LeftLeft"})(ye||(ye={}));var de;(function(ve){ve.Default=[-100,0];function Ie(B){return!B||B.length===2&&B[0]===-100&&B[1]===0}ve.isDefault=Ie})(de||(e.FuzzyScore=de={}));class fe{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Ie,B){this.firstMatchCanBeWeak=Ie,this.boostFullMatch=B}}e.$6j=fe;function _(ve,Ie,B,Y,te,q,ae=fe.default){const he=ve.length>M?M:ve.length,Ae=Y.length>M?M:Y.length;if(B>=he||q>=Ae||he-B>Ae-q||!ie(Ie,B,he,te,q,Ae,!0))return;ee(he,Ae,B,q,Ie,te);let je=1,He=1,Qe=B,_e=q;const at=[!1];for(je=1,Qe=B;Qe<he;je++,Qe++){const Le=K[Qe],Ye=ue[Qe],ne=Qe+1<he?ue[Qe+1]:Ae;for(He=Le-q+1,_e=Le;_e<ne;He++,_e++){let se=Number.MIN_SAFE_INTEGER,Ce=!1;_e<=Ye&&(se=G(ve,Ie,Qe,B,Y,te,_e,Ae,q,X[je-1][He-1]===0,at));let qe=0;se!==Number.MAX_SAFE_INTEGER&&(Ce=!0,qe=se+Q[je-1][He-1]);const Ze=_e>Le,it=Ze?Q[je][He-1]+(X[je][He-1]>0?-5:0):0,nt=_e>Le+1&&X[je][He-1]>0,Oe=nt?Q[je][He-2]+(X[je][He-2]>0?-5:0):0;if(nt&&(!Ze||Oe>=it)&&(!Ce||Oe>=qe))Q[je][He]=Oe,Z[je][He]=3,X[je][He]=0;else if(Ze&&(!Ce||it>=qe))Q[je][He]=it,Z[je][He]=2,X[je][He]=0;else if(Ce)Q[je][He]=qe,Z[je][He]=1,X[je][He]=X[je-1][He-1]+1;else throw new Error("not possible")}}if(le&&$e(ve,B,Y,q),!at[0]&&!ae.firstMatchCanBeWeak)return;je--,He--;const st=[Q[je][He],q];let rt=0,Pe=0;for(;je>=1;){let Le=He;do{const Ye=Z[je][Le];if(Ye===3)Le=Le-2;else if(Ye===2)Le=Le-1;else break}while(Le>=1);rt>1&&Ie[B+je-1]===te[q+He-1]&&!V(Le+q-1,Y,te)&&rt+1>X[je][Le]&&(Le=He),Le===He?rt++:rt=1,Pe||(Pe=Le),je--,He=Le-1,st.push(He)}Ae===he&&ae.boostFullMatch&&(st[0]+=2);const ze=Pe-he;return st[0]-=ze,st}e.$7j=_;function ee(ve,Ie,B,Y,te,q){let ae=ve-1,he=Ie-1;for(;ae>=B&&he>=Y;)te[ae]===q[he]&&(ue[ae]=he,ae--),he--}function G(ve,Ie,B,Y,te,q,ae,he,Ae,je,He){if(Ie[B]!==q[ae])return Number.MIN_SAFE_INTEGER;let Qe=1,_e=!1;return ae===B-Y?Qe=ve[B]===te[ae]?7:5:V(ae,te,q)&&(ae===0||!V(ae-1,te,q))?(Qe=ve[B]===te[ae]?7:5,_e=!0):oe(q,ae)&&(ae===0||!oe(q,ae-1))?Qe=5:(oe(q,ae-1)||J(q,ae-1))&&(Qe=5,_e=!0),Qe>1&&B===Y&&(He[0]=!0),_e||(_e=V(ae,te,q)||oe(q,ae-1)||J(q,ae-1)),B===Y?ae>Ae&&(Qe-=_e?3:5):je?Qe+=_e?2:0:Qe+=_e?0:1,ae+1===he&&(Qe-=_e?3:5),Qe}function x(ve,Ie,B,Y,te,q,ae){return pe(ve,Ie,B,Y,te,q,!0,ae)}e.$8j=x;function me(ve,Ie,B,Y,te,q,ae){return pe(ve,Ie,B,Y,te,q,!1,ae)}e.$9j=me;function pe(ve,Ie,B,Y,te,q,ae,he){let Ae=_(ve,Ie,B,Y,te,q,he);if(Ae&&!ae)return Ae;if(ve.length>=3){const je=Math.min(7,ve.length-1);for(let He=B+1;He<je;He++){const Qe=Re(ve,He);if(Qe){const _e=_(Qe,Qe.toLowerCase(),B,Y,te,q,he);_e&&(_e[0]-=3,(!Ae||_e[0]>Ae[0])&&(Ae=_e))}}}return Ae}function Re(ve,Ie){if(Ie+1>=ve.length)return;const B=ve[Ie],Y=ve[Ie+1];if(B!==Y)return ve.slice(0,Ie)+Y+B+ve.slice(Ie+2)}}),define(ke[54],Se([1,0,12]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zi=e.$Yi=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Ti=void 0;function N(o){return f(o,0)}e.$Ti=N;function f(o,i){switch(typeof o){case"object":return o===null?P(349,i):Array.isArray(o)?$(o,i):k(o,i);case"string":return v(o,i);case"boolean":return R(o,i);case"number":return P(o,i);case"undefined":return P(937,i);default:return P(617,i)}}e.$Ui=f;function P(o,i){return(i<<5)-i+o|0}e.$Vi=P;function R(o,i){return P(o?433:863,i)}function v(o,i){i=P(149417,i);for(let r=0,n=o.length;r<n;r++)i=P(o.charCodeAt(r),i);return i}e.$Wi=v;function $(o,i){return i=P(104579,i),o.reduce((r,n)=>f(n,r),i)}function k(o,i){return i=P(181387,i),Object.keys(o).sort().reduce((r,n)=>(r=v(n,r),f(o[n],r)),i)}class A{constructor(){this.g=0}get value(){return this.g}hash(i){return this.g=f(i,this.g),this.g}}e.$Xi=A;var D;(function(o){o[o.BLOCK_SIZE=64]="BLOCK_SIZE",o[o.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(D||(D={}));function w(o,i,r=32){const n=r-i,a=~((1<<n)-1);return(o<<i|(a&o)>>>n)>>>0}function E(o,i=0,r=o.byteLength,n=0){for(let a=0;a<r;a++)o[i+a]=n}function S(o,i,r="0"){for(;o.length<i;)o=r+o;return o}function c(o,i=32){return o instanceof ArrayBuffer?Array.from(new Uint8Array(o)).map(r=>r.toString(16).padStart(2,"0")).join(""):S((o>>>0).toString(16),i/4)}e.$Yi=c;class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(i){const r=i.length;if(r===0)return;const n=this.p;let a=this.r,t=this.u,h,s;for(t!==0?(h=t,s=-1,t=0):(h=i.charCodeAt(0),s=0);;){let d=h;if(C.$df(h))if(s+1<r){const u=i.charCodeAt(s+1);C.$ef(u)?(s++,d=C.$ff(h,u)):d=65533}else{t=h;break}else C.$ef(h)&&(d=65533);if(a=this.w(n,a,d),s++,s<r)h=i.charCodeAt(s);else break}this.r=a,this.u=t}w(i,r,n){return n<128?i[r++]=n:n<2048?(i[r++]=192|(n&1984)>>>6,i[r++]=128|(n&63)>>>0):n<65536?(i[r++]=224|(n&61440)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0):(i[r++]=240|(n&1835008)>>>18,i[r++]=128|(n&258048)>>>12,i[r++]=128|(n&4032)>>>6,i[r++]=128|(n&63)>>>0),r>=64&&(this.y(),r-=64,this.t+=64,i[0]=i[64+0],i[1]=i[64+1],i[2]=i[64+2]),r}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),c(this.h)+c(this.l)+c(this.m)+c(this.n)+c(this.o)}x(){this.p[this.r++]=128,E(this.p,this.r),this.r>56&&(this.y(),E(this.p));const i=8*this.t;this.q.setUint32(56,Math.floor(i/4294967296),!1),this.q.setUint32(60,i%4294967296,!1),this.y()}y(){const i=g.g,r=this.q;for(let p=0;p<64;p+=4)i.setUint32(p,r.getUint32(p,!1),!1);for(let p=64;p<320;p+=4)i.setUint32(p,w(i.getUint32(p-12,!1)^i.getUint32(p-32,!1)^i.getUint32(p-56,!1)^i.getUint32(p-64,!1),1),!1);let n=this.h,a=this.l,t=this.m,h=this.n,s=this.o,d,u,l;for(let p=0;p<80;p++)p<20?(d=a&t|~a&h,u=1518500249):p<40?(d=a^t^h,u=1859775393):p<60?(d=a&t|a&h|t&h,u=2400959708):(d=a^t^h,u=3395469782),l=w(n,5)+d+s+u+i.getUint32(p*4,!1)&4294967295,s=h,h=t,t=w(a,30),a=n,n=l;this.h=this.h+n&4294967295,this.l=this.l+a&4294967295,this.m=this.m+t&4294967295,this.n=this.n+h&4294967295,this.o=this.o+s&4294967295}}e.$Zi=g}),define(ke[39],Se([1,0,12]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(f){f[f.Ignore=0]="Ignore",f[f.Info=1]="Info",f[f.Warning=2]="Warning",f[f.Error=3]="Error"})(N||(N={})),function(f){const P="error",R="warning",v="warn",$="info",k="ignore";function A(w){return w?C.$_e(P,w)?f.Error:C.$_e(R,w)||C.$_e(v,w)?f.Warning:C.$_e($,w)?f.Info:f.Ignore:f.Ignore}f.fromValue=A;function D(w){switch(w){case f.Error:return P;case f.Warning:return R;case f.Info:return $;default:return k}}f.toString=D}(N||(N={})),e.default=N}),define(ke[163],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(ke[77],Se([1,0,19,12]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_h=e.$$h=e.$0h=e.$9h=e.$8h=void 0;class f{constructor(){this.b="",this.c=0}reset(E){return this.b=E,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(E){const S=E.charCodeAt(0),c=this.b.charCodeAt(this.c);return S-c}value(){return this.b[this.c]}}e.$8h=f;class P{constructor(E=!0){this.e=E}reset(E){return this.b=E,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let E=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(E)this.c++;else break;else E=!1;return this}cmp(E){return this.e?(0,N.$6e)(E,this.b,0,E.length,this.c,this.d):(0,N.$8e)(E,this.b,0,E.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$9h=P;class R{constructor(E=!0,S=!0){this.f=E,this.g=S}reset(E){this.d=0,this.e=0,this.b=E,this.c=E.length;for(let S=E.length-1;S>=0;S--,this.c--){const c=this.b.charCodeAt(S);if(!(c===47||this.f&&c===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let E=!0;for(;this.e<this.c;this.e++){const S=this.b.charCodeAt(this.e);if(S===47||this.f&&S===92)if(E)this.d++;else break;else E=!1}return this}cmp(E){return this.g?(0,N.$6e)(E,this.b,0,E.length,this.d,this.e):(0,N.$8e)(E,this.b,0,E.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$0h=R;var v;(function(w){w[w.Scheme=1]="Scheme",w[w.Authority=2]="Authority",w[w.Path=3]="Path",w[w.Query=4]="Query",w[w.Fragment=5]="Fragment"})(v||(v={}));class ${constructor(E,S){this.f=E,this.g=S,this.d=[],this.e=0}reset(E){return this.c=E,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(E)),this.b.reset(E.path),this.b.value()&&this.d.push(3)),this.g(E)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(E){if(this.d[this.e]===1)return(0,N.$7e)(E,this.c.scheme);if(this.d[this.e]===2)return(0,N.$7e)(E,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(E);if(this.d[this.e]===4)return(0,N.$5e)(E,this.c.query);if(this.d[this.e]===5)return(0,N.$5e)(E,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$$h=$;class k{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const E=this.right;return this.right=E.left,E.left=this,this.updateHeight(),E.updateHeight(),E}rotateRight(){const E=this.left;return this.left=E.right,E.right=this,this.updateHeight(),E.updateHeight(),E}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var A;(function(w){w[w.Left=-1]="Left",w[w.Mid=0]="Mid",w[w.Right=1]="Right"})(A||(A={}));class D{static forUris(E=()=>!1,S=()=>!1){return new D(new $(E,S))}static forPaths(E=!1){return new D(new R(void 0,!E))}static forStrings(){return new D(new f)}static forConfigKeys(){return new D(new P)}constructor(E){this.b=E}clear(){this.c=void 0}fill(E,S){if(S){const c=S.slice(0);(0,C.$Xb)(c);for(const g of c)this.set(g,E)}else{const c=E.slice(0);(0,C.$Xb)(c);for(const g of c)this.set(g[0],g[1])}}set(E,S){const c=this.b.reset(E);let g;this.c||(this.c=new k,this.c.segment=c.value());const o=[];for(g=this.c;;){const r=c.cmp(g.segment);if(r>0)g.left||(g.left=new k,g.left.segment=c.value()),o.push([-1,g]),g=g.left;else if(r<0)g.right||(g.right=new k,g.right.segment=c.value()),o.push([1,g]),g=g.right;else if(c.hasNext())c.next(),g.mid||(g.mid=new k,g.mid.segment=c.value()),o.push([0,g]),g=g.mid;else break}const i=g.value;g.value=S,g.key=E;for(let r=o.length-1;r>=0;r--){const n=o[r][1];n.updateHeight();const a=n.balanceFactor();if(a<-1||a>1){const t=o[r][0],h=o[r+1][0];if(t===1&&h===1)o[r][1]=n.rotateLeft();else if(t===-1&&h===-1)o[r][1]=n.rotateRight();else if(t===1&&h===-1)n.right=o[r+1][1]=o[r+1][1].rotateRight(),o[r][1]=n.rotateLeft();else if(t===-1&&h===1)n.left=o[r+1][1]=o[r+1][1].rotateLeft(),o[r][1]=n.rotateRight();else throw new Error;if(r>0)switch(o[r-1][0]){case-1:o[r-1][1].left=o[r][1];break;case 1:o[r-1][1].right=o[r][1];break;case 0:o[r-1][1].mid=o[r][1];break}else this.c=o[0][1]}}return i}get(E){return this.d(E)?.value}d(E){const S=this.b.reset(E);let c=this.c;for(;c;){const g=S.cmp(c.segment);if(g>0)c=c.left;else if(g<0)c=c.right;else if(S.hasNext())S.next(),c=c.mid;else break}return c}has(E){const S=this.d(E);return!(S?.value===void 0&&S?.mid===void 0)}delete(E){return this.e(E,!1)}deleteSuperstr(E){return this.e(E,!0)}e(E,S){const c=this.b.reset(E),g=[];let o=this.c;for(;o;){const i=c.cmp(o.segment);if(i>0)g.push([-1,o]),o=o.left;else if(i<0)g.push([1,o]),o=o.right;else if(c.hasNext())c.next(),g.push([0,o]),o=o.mid;else break}if(o){if(S?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const i=this.f(o.right);if(i.key){const{key:r,value:n,segment:a}=i;this.e(i.key,!1),o.key=r,o.value=n,o.segment=a}}else{const i=o.left??o.right;if(g.length>0){const[r,n]=g[g.length-1];switch(r){case-1:n.left=i;break;case 0:n.mid=i;break;case 1:n.right=i;break}}else this.c=i}for(let i=g.length-1;i>=0;i--){const r=g[i][1];r.updateHeight();const n=r.balanceFactor();if(n>1?(r.right.balanceFactor()>=0||(r.right=r.right.rotateRight()),g[i][1]=r.rotateLeft()):n<-1&&(r.left.balanceFactor()<=0||(r.left=r.left.rotateLeft()),g[i][1]=r.rotateRight()),i>0)switch(g[i-1][0]){case-1:g[i-1][1].left=g[i][1];break;case 1:g[i-1][1].right=g[i][1];break;case 0:g[i-1][1].mid=g[i][1];break}else this.c=g[0][1]}}}f(E){for(;E.left;)E=E.left;return E}findSubstr(E){const S=this.b.reset(E);let c=this.c,g;for(;c;){const o=S.cmp(c.segment);if(o>0)c=c.left;else if(o<0)c=c.right;else if(S.hasNext())S.next(),g=c.value||g,c=c.mid;else break}return c&&c.value||g}findSuperstr(E){return this.g(E,!1)}g(E,S){const c=this.b.reset(E);let g=this.c;for(;g;){const o=c.cmp(g.segment);if(o>0)g=g.left;else if(o<0)g=g.right;else if(c.hasNext())c.next(),g=g.mid;else return g.mid?this.h(g.mid):S?g.value:void 0}}hasElementOrSubtree(E){return this.g(E,!0)!==void 0}forEach(E){for(const[S,c]of this)E(c,S)}*[Symbol.iterator](){yield*this.h(this.c)}h(E){const S=[];return this.j(E,S),S[Symbol.iterator]()}j(E,S){E&&(E.left&&this.j(E.left,S),E.value&&S.push([E.key,E.value]),E.mid&&this.j(E.mid,S),E.right&&this.j(E.right,S))}_isBalanced(){const E=S=>{if(!S)return!0;const c=S.balanceFactor();return c<-1||c>1?!1:E(S.left)&&E(S.right)};return E(this.c)}}e.$_h=D}),define(ke[18],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zf=e.$Yf=e.$Xf=e.$Wf=e.$Vf=e.$Uf=e.$Tf=e.$Sf=e.$Rf=e.$Qf=e.$Pf=e.$Of=e.$Nf=e.$Mf=e.$Lf=e.$Kf=e.$Jf=e.$If=void 0;function C(a){return typeof a=="string"}e.$If=C;function N(a){return Array.isArray(a)&&a.every(t=>C(t))}e.$Jf=N;function f(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.$Kf=f;function P(a){const t=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof t}e.$Lf=P;function R(a){return typeof a=="number"&&!isNaN(a)}e.$Mf=R;function v(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.$Nf=v;function $(a){return a===!0||a===!1}e.$Of=$;function k(a){return typeof a>"u"}e.$Pf=k;function A(a){return!D(a)}e.$Qf=A;function D(a){return k(a)||a===null}e.$Rf=D;function w(a,t){if(!a)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.$Sf=w;function E(a){if(D(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.$Tf=E;function S(...a){const t=[];for(let h=0;h<a.length;h++){const s=a[h];if(D(s))throw new Error(`Assertion Failed: argument at index ${h} is undefined or null`);t.push(s)}return t}e.$Uf=S;const c=Object.prototype.hasOwnProperty;function g(a){if(!f(a))return!1;for(const t in a)if(c.call(a,t))return!1;return!0}e.$Vf=g;function o(a){return typeof a=="function"}e.$Wf=o;function i(...a){return a.length>0&&a.every(o)}e.$Xf=i;function r(a,t){const h=Math.min(a.length,t.length);for(let s=0;s<h;s++)n(a[s],t[s])}e.$Yf=r;function n(a,t){if(C(t)){if(typeof a!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(o(t)){try{if(a instanceof t)return}catch{}if(!D(a)&&a.constructor===t||t.length===1&&t.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.$Zf=n}),define(ke[78],Se([1,0,18]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_j=e.$$j=e.$0j=void 0;const N=Object.create(null);function f(v,$){if((0,C.$If)($)){const k=N[$];if(k===void 0)throw new Error(`${v} references an unknown codicon: ${$}`);$=k}return N[v]=$,{id:v}}function P(){return N}e.$0j=P;function R(){return Object.values(e.$_j)}e.$$j=R,e.$_j={add:f("add",6e4),plus:f("plus",6e4),gistNew:f("gist-new",6e4),repoCreate:f("repo-create",6e4),lightbulb:f("lightbulb",60001),lightBulb:f("light-bulb",60001),repo:f("repo",60002),repoDelete:f("repo-delete",60002),gistFork:f("gist-fork",60003),repoForked:f("repo-forked",60003),gitPullRequest:f("git-pull-request",60004),gitPullRequestAbandoned:f("git-pull-request-abandoned",60004),recordKeys:f("record-keys",60005),keyboard:f("keyboard",60005),tag:f("tag",60006),tagAdd:f("tag-add",60006),tagRemove:f("tag-remove",60006),gitPullRequestLabel:f("git-pull-request-label",60006),person:f("person",60007),personFollow:f("person-follow",60007),personOutline:f("person-outline",60007),personFilled:f("person-filled",60007),gitBranch:f("git-branch",60008),gitBranchCreate:f("git-branch-create",60008),gitBranchDelete:f("git-branch-delete",60008),sourceControl:f("source-control",60008),mirror:f("mirror",60009),mirrorPublic:f("mirror-public",60009),star:f("star",60010),starAdd:f("star-add",60010),starDelete:f("star-delete",60010),starEmpty:f("star-empty",60010),comment:f("comment",60011),commentAdd:f("comment-add",60011),alert:f("alert",60012),warning:f("warning",60012),search:f("search",60013),searchSave:f("search-save",60013),logOut:f("log-out",60014),signOut:f("sign-out",60014),logIn:f("log-in",60015),signIn:f("sign-in",60015),eye:f("eye",60016),eyeUnwatch:f("eye-unwatch",60016),eyeWatch:f("eye-watch",60016),circleFilled:f("circle-filled",60017),primitiveDot:f("primitive-dot",60017),closeDirty:f("close-dirty",60017),debugBreakpoint:f("debug-breakpoint",60017),debugBreakpointDisabled:f("debug-breakpoint-disabled",60017),debugBreakpointPending:f("debug-breakpoint-pending",60377),debugHint:f("debug-hint",60017),primitiveSquare:f("primitive-square",60018),edit:f("edit",60019),pencil:f("pencil",60019),info:f("info",60020),issueOpened:f("issue-opened",60020),gistPrivate:f("gist-private",60021),gitForkPrivate:f("git-fork-private",60021),lock:f("lock",60021),mirrorPrivate:f("mirror-private",60021),close:f("close",60022),removeClose:f("remove-close",60022),x:f("x",60022),repoSync:f("repo-sync",60023),sync:f("sync",60023),clone:f("clone",60024),desktopDownload:f("desktop-download",60024),beaker:f("beaker",60025),microscope:f("microscope",60025),vm:f("vm",60026),deviceDesktop:f("device-desktop",60026),file:f("file",60027),fileText:f("file-text",60027),more:f("more",60028),ellipsis:f("ellipsis",60028),kebabHorizontal:f("kebab-horizontal",60028),mailReply:f("mail-reply",60029),reply:f("reply",60029),organization:f("organization",60030),organizationFilled:f("organization-filled",60030),organizationOutline:f("organization-outline",60030),newFile:f("new-file",60031),fileAdd:f("file-add",60031),newFolder:f("new-folder",60032),fileDirectoryCreate:f("file-directory-create",60032),trash:f("trash",60033),trashcan:f("trashcan",60033),history:f("history",60034),clock:f("clock",60034),folder:f("folder",60035),fileDirectory:f("file-directory",60035),symbolFolder:f("symbol-folder",60035),logoGithub:f("logo-github",60036),markGithub:f("mark-github",60036),github:f("github",60036),terminal:f("terminal",60037),console:f("console",60037),repl:f("repl",60037),zap:f("zap",60038),symbolEvent:f("symbol-event",60038),error:f("error",60039),stop:f("stop",60039),variable:f("variable",60040),symbolVariable:f("symbol-variable",60040),array:f("array",60042),symbolArray:f("symbol-array",60042),symbolModule:f("symbol-module",60043),symbolPackage:f("symbol-package",60043),symbolNamespace:f("symbol-namespace",60043),symbolObject:f("symbol-object",60043),symbolMethod:f("symbol-method",60044),symbolFunction:f("symbol-function",60044),symbolConstructor:f("symbol-constructor",60044),symbolBoolean:f("symbol-boolean",60047),symbolNull:f("symbol-null",60047),symbolNumeric:f("symbol-numeric",60048),symbolNumber:f("symbol-number",60048),symbolStructure:f("symbol-structure",60049),symbolStruct:f("symbol-struct",60049),symbolParameter:f("symbol-parameter",60050),symbolTypeParameter:f("symbol-type-parameter",60050),symbolKey:f("symbol-key",60051),symbolText:f("symbol-text",60051),symbolReference:f("symbol-reference",60052),goToFile:f("go-to-file",60052),symbolEnum:f("symbol-enum",60053),symbolValue:f("symbol-value",60053),symbolRuler:f("symbol-ruler",60054),symbolUnit:f("symbol-unit",60054),activateBreakpoints:f("activate-breakpoints",60055),archive:f("archive",60056),arrowBoth:f("arrow-both",60057),arrowDown:f("arrow-down",60058),arrowLeft:f("arrow-left",60059),arrowRight:f("arrow-right",60060),arrowSmallDown:f("arrow-small-down",60061),arrowSmallLeft:f("arrow-small-left",60062),arrowSmallRight:f("arrow-small-right",60063),arrowSmallUp:f("arrow-small-up",60064),arrowUp:f("arrow-up",60065),bell:f("bell",60066),bold:f("bold",60067),book:f("book",60068),bookmark:f("bookmark",60069),debugBreakpointConditionalUnverified:f("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:f("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:f("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:f("debug-breakpoint-data-unverified",60072),debugBreakpointData:f("debug-breakpoint-data",60073),debugBreakpointDataDisabled:f("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:f("debug-breakpoint-log-unverified",60074),debugBreakpointLog:f("debug-breakpoint-log",60075),debugBreakpointLogDisabled:f("debug-breakpoint-log-disabled",60075),briefcase:f("briefcase",60076),broadcast:f("broadcast",60077),browser:f("browser",60078),bug:f("bug",60079),calendar:f("calendar",60080),caseSensitive:f("case-sensitive",60081),check:f("check",60082),checklist:f("checklist",60083),chevronDown:f("chevron-down",60084),dropDownButton:f("drop-down-button",60084),chevronLeft:f("chevron-left",60085),chevronRight:f("chevron-right",60086),chevronUp:f("chevron-up",60087),chromeClose:f("chrome-close",60088),chromeMaximize:f("chrome-maximize",60089),chromeMinimize:f("chrome-minimize",60090),chromeRestore:f("chrome-restore",60091),circle:f("circle",60092),circleOutline:f("circle-outline",60092),debugBreakpointUnverified:f("debug-breakpoint-unverified",60092),circleSlash:f("circle-slash",60093),circuitBoard:f("circuit-board",60094),clearAll:f("clear-all",60095),clippy:f("clippy",60096),closeAll:f("close-all",60097),cloudDownload:f("cloud-download",60098),cloudUpload:f("cloud-upload",60099),code:f("code",60100),collapseAll:f("collapse-all",60101),colorMode:f("color-mode",60102),commentDiscussion:f("comment-discussion",60103),compareChanges:f("compare-changes",60157),creditCard:f("credit-card",60105),dash:f("dash",60108),dashboard:f("dashboard",60109),database:f("database",60110),debugContinue:f("debug-continue",60111),debugDisconnect:f("debug-disconnect",60112),debugPause:f("debug-pause",60113),debugRestart:f("debug-restart",60114),debugStart:f("debug-start",60115),debugStepInto:f("debug-step-into",60116),debugStepOut:f("debug-step-out",60117),debugStepOver:f("debug-step-over",60118),debugStop:f("debug-stop",60119),debug:f("debug",60120),deviceCameraVideo:f("device-camera-video",60121),deviceCamera:f("device-camera",60122),deviceMobile:f("device-mobile",60123),diffAdded:f("diff-added",60124),diffIgnored:f("diff-ignored",60125),diffModified:f("diff-modified",60126),diffRemoved:f("diff-removed",60127),diffRenamed:f("diff-renamed",60128),diff:f("diff",60129),discard:f("discard",60130),editorLayout:f("editor-layout",60131),emptyWindow:f("empty-window",60132),exclude:f("exclude",60133),extensions:f("extensions",60134),eyeClosed:f("eye-closed",60135),fileBinary:f("file-binary",60136),fileCode:f("file-code",60137),fileMedia:f("file-media",60138),filePdf:f("file-pdf",60139),fileSubmodule:f("file-submodule",60140),fileSymlinkDirectory:f("file-symlink-directory",60141),fileSymlinkFile:f("file-symlink-file",60142),fileZip:f("file-zip",60143),files:f("files",60144),filter:f("filter",60145),flame:f("flame",60146),foldDown:f("fold-down",60147),foldUp:f("fold-up",60148),fold:f("fold",60149),folderActive:f("folder-active",60150),folderOpened:f("folder-opened",60151),gear:f("gear",60152),gift:f("gift",60153),gistSecret:f("gist-secret",60154),gist:f("gist",60155),gitCommit:f("git-commit",60156),gitCompare:f("git-compare",60157),gitMerge:f("git-merge",60158),githubAction:f("github-action",60159),githubAlt:f("github-alt",60160),globe:f("globe",60161),grabber:f("grabber",60162),graph:f("graph",60163),gripper:f("gripper",60164),heart:f("heart",60165),home:f("home",60166),horizontalRule:f("horizontal-rule",60167),hubot:f("hubot",60168),inbox:f("inbox",60169),issueClosed:f("issue-closed",60324),issueReopened:f("issue-reopened",60171),issues:f("issues",60172),italic:f("italic",60173),jersey:f("jersey",60174),json:f("json",60175),bracket:f("bracket",60175),kebabVertical:f("kebab-vertical",60176),key:f("key",60177),law:f("law",60178),lightbulbAutofix:f("lightbulb-autofix",60179),linkExternal:f("link-external",60180),link:f("link",60181),listOrdered:f("list-ordered",60182),listUnordered:f("list-unordered",60183),liveShare:f("live-share",60184),loading:f("loading",60185),location:f("location",60186),mailRead:f("mail-read",60187),mail:f("mail",60188),markdown:f("markdown",60189),megaphone:f("megaphone",60190),mention:f("mention",60191),milestone:f("milestone",60192),gitPullRequestMilestone:f("git-pull-request-milestone",60192),mortarBoard:f("mortar-board",60193),move:f("move",60194),multipleWindows:f("multiple-windows",60195),mute:f("mute",60196),noNewline:f("no-newline",60197),note:f("note",60198),octoface:f("octoface",60199),openPreview:f("open-preview",60200),package:f("package",60201),paintcan:f("paintcan",60202),pin:f("pin",60203),play:f("play",60204),run:f("run",60204),plug:f("plug",60205),preserveCase:f("preserve-case",60206),preview:f("preview",60207),project:f("project",60208),pulse:f("pulse",60209),question:f("question",60210),quote:f("quote",60211),radioTower:f("radio-tower",60212),reactions:f("reactions",60213),references:f("references",60214),refresh:f("refresh",60215),regex:f("regex",60216),remoteExplorer:f("remote-explorer",60217),remote:f("remote",60218),remove:f("remove",60219),replaceAll:f("replace-all",60220),replace:f("replace",60221),repoClone:f("repo-clone",60222),repoForcePush:f("repo-force-push",60223),repoPull:f("repo-pull",60224),repoPush:f("repo-push",60225),report:f("report",60226),requestChanges:f("request-changes",60227),rocket:f("rocket",60228),rootFolderOpened:f("root-folder-opened",60229),rootFolder:f("root-folder",60230),rss:f("rss",60231),ruby:f("ruby",60232),saveAll:f("save-all",60233),saveAs:f("save-as",60234),save:f("save",60235),screenFull:f("screen-full",60236),screenNormal:f("screen-normal",60237),searchStop:f("search-stop",60238),server:f("server",60240),settingsGear:f("settings-gear",60241),settings:f("settings",60242),shield:f("shield",60243),smiley:f("smiley",60244),sortPrecedence:f("sort-precedence",60245),splitHorizontal:f("split-horizontal",60246),splitVertical:f("split-vertical",60247),squirrel:f("squirrel",60248),starFull:f("star-full",60249),starHalf:f("star-half",60250),symbolClass:f("symbol-class",60251),symbolColor:f("symbol-color",60252),symbolCustomColor:f("symbol-customcolor",60252),symbolConstant:f("symbol-constant",60253),symbolEnumMember:f("symbol-enum-member",60254),symbolField:f("symbol-field",60255),symbolFile:f("symbol-file",60256),symbolInterface:f("symbol-interface",60257),symbolKeyword:f("symbol-keyword",60258),symbolMisc:f("symbol-misc",60259),symbolOperator:f("symbol-operator",60260),symbolProperty:f("symbol-property",60261),wrench:f("wrench",60261),wrenchSubaction:f("wrench-subaction",60261),symbolSnippet:f("symbol-snippet",60262),tasklist:f("tasklist",60263),telescope:f("telescope",60264),textSize:f("text-size",60265),threeBars:f("three-bars",60266),thumbsdown:f("thumbsdown",60267),thumbsup:f("thumbsup",60268),tools:f("tools",60269),triangleDown:f("triangle-down",60270),triangleLeft:f("triangle-left",60271),triangleRight:f("triangle-right",60272),triangleUp:f("triangle-up",60273),twitter:f("twitter",60274),unfold:f("unfold",60275),unlock:f("unlock",60276),unmute:f("unmute",60277),unverified:f("unverified",60278),verified:f("verified",60279),versions:f("versions",60280),vmActive:f("vm-active",60281),vmOutline:f("vm-outline",60282),vmRunning:f("vm-running",60283),watch:f("watch",60284),whitespace:f("whitespace",60285),wholeWord:f("whole-word",60286),window:f("window",60287),wordWrap:f("word-wrap",60288),zoomIn:f("zoom-in",60289),zoomOut:f("zoom-out",60290),listFilter:f("list-filter",60291),listFlat:f("list-flat",60292),listSelection:f("list-selection",60293),selection:f("selection",60293),listTree:f("list-tree",60294),debugBreakpointFunctionUnverified:f("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:f("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:f("debug-breakpoint-function-disabled",60296),debugStackframeActive:f("debug-stackframe-active",60297),circleSmallFilled:f("circle-small-filled",60298),debugStackframeDot:f("debug-stackframe-dot",60298),debugStackframe:f("debug-stackframe",60299),debugStackframeFocused:f("debug-stackframe-focused",60299),debugBreakpointUnsupported:f("debug-breakpoint-unsupported",60300),symbolString:f("symbol-string",60301),debugReverseContinue:f("debug-reverse-continue",60302),debugStepBack:f("debug-step-back",60303),debugRestartFrame:f("debug-restart-frame",60304),callIncoming:f("call-incoming",60306),callOutgoing:f("call-outgoing",60307),menu:f("menu",60308),expandAll:f("expand-all",60309),feedback:f("feedback",60310),gitPullRequestReviewer:f("git-pull-request-reviewer",60310),groupByRefType:f("group-by-ref-type",60311),ungroupByRefType:f("ungroup-by-ref-type",60312),account:f("account",60313),gitPullRequestAssignee:f("git-pull-request-assignee",60313),bellDot:f("bell-dot",60314),debugConsole:f("debug-console",60315),library:f("library",60316),output:f("output",60317),runAll:f("run-all",60318),syncIgnored:f("sync-ignored",60319),pinned:f("pinned",60320),githubInverted:f("github-inverted",60321),debugAlt:f("debug-alt",60305),serverProcess:f("server-process",60322),serverEnvironment:f("server-environment",60323),pass:f("pass",60324),stopCircle:f("stop-circle",60325),playCircle:f("play-circle",60326),record:f("record",60327),debugAltSmall:f("debug-alt-small",60328),vmConnect:f("vm-connect",60329),cloud:f("cloud",60330),merge:f("merge",60331),exportIcon:f("export",60332),graphLeft:f("graph-left",60333),magnet:f("magnet",60334),notebook:f("notebook",60335),redo:f("redo",60336),checkAll:f("check-all",60337),pinnedDirty:f("pinned-dirty",60338),passFilled:f("pass-filled",60339),circleLargeFilled:f("circle-large-filled",60340),circleLarge:f("circle-large",60341),circleLargeOutline:f("circle-large-outline",60341),combine:f("combine",60342),gather:f("gather",60342),table:f("table",60343),variableGroup:f("variable-group",60344),typeHierarchy:f("type-hierarchy",60345),typeHierarchySub:f("type-hierarchy-sub",60346),typeHierarchySuper:f("type-hierarchy-super",60347),gitPullRequestCreate:f("git-pull-request-create",60348),runAbove:f("run-above",60349),runBelow:f("run-below",60350),notebookTemplate:f("notebook-template",60351),debugRerun:f("debug-rerun",60352),workspaceTrusted:f("workspace-trusted",60353),workspaceUntrusted:f("workspace-untrusted",60354),workspaceUnspecified:f("workspace-unspecified",60355),terminalCmd:f("terminal-cmd",60356),terminalDebian:f("terminal-debian",60357),terminalLinux:f("terminal-linux",60358),terminalPowershell:f("terminal-powershell",60359),terminalTmux:f("terminal-tmux",60360),terminalUbuntu:f("terminal-ubuntu",60361),terminalBash:f("terminal-bash",60362),arrowSwap:f("arrow-swap",60363),copy:f("copy",60364),personAdd:f("person-add",60365),filterFilled:f("filter-filled",60366),wand:f("wand",60367),debugLineByLine:f("debug-line-by-line",60368),inspect:f("inspect",60369),layers:f("layers",60370),layersDot:f("layers-dot",60371),layersActive:f("layers-active",60372),compass:f("compass",60373),compassDot:f("compass-dot",60374),compassActive:f("compass-active",60375),azure:f("azure",60376),issueDraft:f("issue-draft",60377),gitPullRequestClosed:f("git-pull-request-closed",60378),gitPullRequestDraft:f("git-pull-request-draft",60379),debugAll:f("debug-all",60380),debugCoverage:f("debug-coverage",60381),runErrors:f("run-errors",60382),folderLibrary:f("folder-library",60383),debugContinueSmall:f("debug-continue-small",60384),beakerStop:f("beaker-stop",60385),graphLine:f("graph-line",60386),graphScatter:f("graph-scatter",60387),pieChart:f("pie-chart",60388),bracketDot:f("bracket-dot",60389),bracketError:f("bracket-error",60390),lockSmall:f("lock-small",60391),azureDevops:f("azure-devops",60392),verifiedFilled:f("verified-filled",60393),newLine:f("newline",60394),layout:f("layout",60395),layoutActivitybarLeft:f("layout-activitybar-left",60396),layoutActivitybarRight:f("layout-activitybar-right",60397),layoutPanelLeft:f("layout-panel-left",60398),layoutPanelCenter:f("layout-panel-center",60399),layoutPanelJustify:f("layout-panel-justify",60400),layoutPanelRight:f("layout-panel-right",60401),layoutPanel:f("layout-panel",60402),layoutSidebarLeft:f("layout-sidebar-left",60403),layoutSidebarRight:f("layout-sidebar-right",60404),layoutStatusbar:f("layout-statusbar",60405),layoutMenubar:f("layout-menubar",60406),layoutCentered:f("layout-centered",60407),layoutSidebarRightOff:f("layout-sidebar-right-off",60416),layoutPanelOff:f("layout-panel-off",60417),layoutSidebarLeftOff:f("layout-sidebar-left-off",60418),target:f("target",60408),indent:f("indent",60409),recordSmall:f("record-small",60410),errorSmall:f("error-small",60411),arrowCircleDown:f("arrow-circle-down",60412),arrowCircleLeft:f("arrow-circle-left",60413),arrowCircleRight:f("arrow-circle-right",60414),arrowCircleUp:f("arrow-circle-up",60415),heartFilled:f("heart-filled",60420),map:f("map",60421),mapFilled:f("map-filled",60422),circleSmall:f("circle-small",60423),bellSlash:f("bell-slash",60424),bellSlashDot:f("bell-slash-dot",60425),commentUnresolved:f("comment-unresolved",60426),gitPullRequestGoToChanges:f("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:f("git-pull-request-new-changes",60428),searchFuzzy:f("search-fuzzy",60429),commentDraft:f("comment-draft",60430),send:f("send",60431),sparkle:f("sparkle",60432),insert:f("insert",60433),mic:f("mic",60434),thumbsDownFilled:f("thumbsdown-filled",60435),thumbsUpFilled:f("thumbsup-filled",60436),coffee:f("coffee",60437),snake:f("snake",60438),game:f("game",60439),vr:f("vr",60440),chip:f("chip",60441),piano:f("piano",60442),music:f("music",60443),micFilled:f("mic-filled",60444),gitFetch:f("git-fetch",60445),copilot:f("copilot",60446),lightbulbSparkle:f("lightbulb-sparkle",60447),lightbulbSparkleAutofix:f("lightbulb-sparkle-autofix",60447),robot:f("robot",60448),sparkleFilled:f("sparkle-filled",60449),diffSingle:f("diff-single",60450),diffMultiple:f("diff-multiple",60451),surroundWith:f("surround-with",60452),gitStash:f("git-stash",60454),gitStashApply:f("git-stash-apply",60455),gitStashPop:f("git-stash-pop",60456),dialogError:f("dialog-error","error"),dialogWarning:f("dialog-warning","warning"),dialogInfo:f("dialog-info","info"),dialogClose:f("dialog-close","close"),treeItemExpanded:f("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:f("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:f("tree-filter-on-type-off","list-selection"),treeFilterClear:f("tree-filter-clear","close"),treeItemLoading:f("tree-item-loading","loading"),menuSelection:f("menu-selection","check"),menuSubmenu:f("menu-submenu","chevron-right"),menuBarMore:f("menubar-more","more"),scrollbarButtonLeft:f("scrollbar-button-left","triangle-left"),scrollbarButtonRight:f("scrollbar-button-right","triangle-right"),scrollbarButtonUp:f("scrollbar-button-up","triangle-up"),scrollbarButtonDown:f("scrollbar-button-down","triangle-down"),toolBarMore:f("toolbar-more","more"),quickInputBack:f("quick-input-back","arrow-left")}}),define(ke[24],Se([1,0,18]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=e.$Fn=e.$En=e.$Dn=e.$Cn=e.$Bn=e.$An=e.$zn=e.$yn=e.$xn=e.$wn=e.$vn=void 0;function N(o){if(!o||typeof o!="object"||o instanceof RegExp)return o;const i=Array.isArray(o)?[]:{};return Object.entries(o).forEach(([r,n])=>{i[r]=n&&typeof n=="object"?N(n):n}),i}e.$vn=N;function f(o){if(!o||typeof o!="object")return o;const i=[o];for(;i.length>0;){const r=i.shift();Object.freeze(r);for(const n in r)if(P.call(r,n)){const a=r[n];typeof a=="object"&&!Object.isFrozen(a)&&!(0,C.$Lf)(a)&&i.push(a)}}return o}e.$wn=f;const P=Object.prototype.hasOwnProperty;function R(o,i){return v(o,i,new Set)}e.$xn=R;function v(o,i,r){if((0,C.$Rf)(o))return o;const n=i(o);if(typeof n<"u")return n;if(Array.isArray(o)){const a=[];for(const t of o)a.push(v(t,i,r));return a}if((0,C.$Kf)(o)){if(r.has(o))throw new Error("Cannot clone recursive data-structure");r.add(o);const a={};for(const t in o)P.call(o,t)&&(a[t]=v(o[t],i,r));return r.delete(o),a}return o}function $(o,i,r=!0){return(0,C.$Kf)(o)?((0,C.$Kf)(i)&&Object.keys(i).forEach(n=>{n in o?r&&((0,C.$Kf)(o[n])&&(0,C.$Kf)(i[n])?$(o[n],i[n],r):o[n]=i[n]):o[n]=i[n]}),o):i}e.$yn=$;function k(o,i){if(o===i)return!0;if(o==null||i===null||i===void 0||typeof o!=typeof i||typeof o!="object"||Array.isArray(o)!==Array.isArray(i))return!1;let r,n;if(Array.isArray(o)){if(o.length!==i.length)return!1;for(r=0;r<o.length;r++)if(!k(o[r],i[r]))return!1}else{const a=[];for(n in o)a.push(n);a.sort();const t=[];for(n in i)t.push(n);if(t.sort(),!k(a,t))return!1;for(r=0;r<a.length;r++)if(!k(o[a[r]],i[a[r]]))return!1}return!0}e.$zn=k;function A(o){const i=new Set;return JSON.stringify(o,(r,n)=>{if((0,C.$Kf)(n)||Array.isArray(n)){if(i.has(n))return"[Circular]";i.add(n)}return n})}e.$An=A;function D(o,i){const r=Object.create(null);return!o||!i||Object.keys(i).forEach(a=>{const t=o[a],h=i[a];k(t,h)||(r[a]=h)}),r}e.$Bn=D;function w(o,i){const r=i.toLowerCase(),n=Object.keys(o).find(a=>a.toLowerCase()===r);return n?o[n]:o[i]}e.$Cn=w;function E(o,i){const r=Object.create(null);for(const[n,a]of Object.entries(o))i(n,a)&&(r[n]=a);return r}e.$Dn=E;function S(o){let i=[];for(;Object.prototype!==o;)i=i.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return i}e.$En=S;function c(o){const i=[];for(const r of S(o))typeof o[r]=="function"&&i.push(r);return i}e.$Fn=c;function g(o,i){const r=a=>function(){const t=Array.prototype.slice.call(arguments,0);return i(a,t)},n={};for(const a of o)n[a]=r(a);return n}e.$Gn=g}),define(ke[55],Se([1,0,78]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.$ak=e.ThemeColor=void 0;var N;(function(R){function v($){return $&&typeof $=="object"&&typeof $.id=="string"}R.isThemeColor=v})(N||(e.ThemeColor=N={}));function f(R){return{id:R}}e.$ak=f;var P;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const v=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function $(i){const r=v.exec(i.id);if(!r)return $(C.$_j.error);const[,n,a]=r,t=["codicon","codicon-"+n];return a&&t.push("codicon-modifier-"+a.substring(1)),t}R.asClassNameArray=$;function k(i){return $(i).join(" ")}R.asClassName=k;function A(i){return"."+$(i).join(".")}R.asCSSSelector=A;function D(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color>"u"||N.isThemeColor(i.color))}R.isThemeIcon=D;const w=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function E(i){const r=w.exec(i);if(!r)return;const[,n]=r;return{id:n}}R.fromString=E;function S(i){return{id:i}}R.fromId=S;function c(i,r){let n=i.id;const a=n.lastIndexOf("~");return a!==-1&&(n=n.substring(0,a)),r&&(n=`${n}~${r}`),{id:n}}R.modify=c;function g(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}R.getModifier=g;function o(i,r){return i.id===r.id&&i.color?.id===r.color?.id}R.isEqual=o})(P||(e.ThemeIcon=P={}))}),define(ke[164],Se([1,0,123,12,55]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=void 0;const P="$(",R=new RegExp(`\\$\\(${f.ThemeIcon.iconNameExpression}(?:${f.ThemeIcon.iconModifierExpression})?\\)`,"g"),v=new RegExp(`(\\\\)?${R.source}`,"g");function $(o){return o.replace(v,(i,r)=>r?i:`\\${i}`)}e.$bk=$;const k=new RegExp(`\\\\${R.source}`,"g");function A(o){return o.replace(k,i=>`\\${i}`)}e.$ck=A;const D=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function w(o){return o.indexOf(P)===-1?o:o.replace(D,(i,r,n,a)=>n?i:r||a||"")}e.$dk=w;function E(o){return o?o.replace(/\$\((.*?)\)/g,(i,r)=>` ${r} `).trim():""}e.$ek=E;const S=new RegExp(`\\$\\(${f.ThemeIcon.iconNameCharacter}+\\)`,"g");function c(o){S.lastIndex=0;let i="";const r=[];let n=0;for(;;){const a=S.lastIndex,t=S.exec(o),h=o.substring(a,t?.index);if(h.length>0){i+=h;for(let s=0;s<h.length;s++)r.push(n)}if(!t)break;n+=t[0].length}return{text:i,iconOffsets:r}}e.$fk=c;function g(o,i,r=!1){const{text:n,iconOffsets:a}=i;if(!a||a.length===0)return(0,C.$1j)(o,n,r);const t=(0,N.$Te)(n," "),h=n.length-t.length,s=(0,C.$1j)(o,t,r);if(s)for(const d of s){const u=a[d.start+h]+h;d.start+=u,d.end+=u}return s}e.$gk=g}),define(ke[124],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ie=e.$He=e.Constants=void 0;var C;(function(P){P[P.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",P[P.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",P[P.MAX_UINT_8=255]="MAX_UINT_8",P[P.MAX_UINT_16=65535]="MAX_UINT_16",P[P.MAX_UINT_32=4294967295]="MAX_UINT_32",P[P.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(C||(e.Constants=C={}));function N(P){return P<0?0:P>255?255:P|0}e.$He=N;function f(P){return P<0?0:P>4294967295?4294967295:P|0}e.$Ie=f}),define(ke[30],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=e.$pg=void 0;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(f){return C.test(f)}e.$pg=N,e.$qg=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let f;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?f=crypto.getRandomValues.bind(crypto):f=function(v){for(let $=0;$<v.length;$++)v[$]=Math.floor(Math.random()*256);return v};const P=new Uint8Array(16),R=[];for(let v=0;v<256;v++)R.push(v.toString(16).padStart(2,"0"));return function(){f(P),P[6]=P[6]&15|64,P[8]=P[8]&63|128;let $=0,k="";return k+=R[P[$++]],k+=R[P[$++]],k+=R[P[$++]],k+=R[P[$++]],k+="-",k+=R[P[$++]],k+=R[P[$++]],k+="-",k+=R[P[$++]],k+=R[P[$++]],k+="-",k+=R[P[$++]],k+=R[P[$++]],k+="-",k+=R[P[$++]],k+=R[P[$++]],k+=R[P[$++]],k+=R[P[$++]],k+=R[P[$++]],k+=R[P[$++]],k}}()}),define(ke[165],Se([1,0,19,53,30]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rt=e.$qt=e.$pt=e.$ot=e.$nt=void 0;function P(D){return{asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.$nt=P;function R(D,w,E){const S={id:(0,f.$qg)(),name:D,uri:w,data:E};return{asString:async()=>"",asFile:()=>S,value:void 0}}e.$ot=R;class v{constructor(){this.a=new Map}get size(){let w=0;for(const E of this.a)w++;return w}has(w){return this.a.has(this.b(w))}matches(w){const E=[...this.a.keys()];return N.Iterable.some(this,([S,c])=>c.asFile())&&E.push("files"),A($(w),E)}get(w){return this.a.get(this.b(w))?.[0]}append(w,E){const S=this.a.get(w);S?S.push(E):this.a.set(this.b(w),[E])}replace(w,E){this.a.set(this.b(w),[E])}delete(w){this.a.delete(this.b(w))}*[Symbol.iterator](){for(const[w,E]of this.a)for(const S of E)yield[w,S]}b(w){return $(w)}}e.$pt=v;function $(D){return D.toLowerCase()}function k(D,w){return A($(D),w.map($))}e.$qt=k;function A(D,w){if(D==="*/*")return w.length>0;if(w.includes(D))return!0;const E=D.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!E)return!1;const[S,c,g]=E;return g==="*"?w.some(o=>o.startsWith(c+"/")):!1}e.$rt=Object.freeze({create:D=>(0,C.$Mb)(D.map(w=>w.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.$rt.split(D).filter(w=>!w.startsWith("#"))})}),define(ke[166],Se([1,0,62]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ug=e.$tg=e.$sg=void 0;function N(v,$,k,A=1){let D=!1;return new Promise(w=>{const E=setTimeout(()=>{if(!D)return D=!0,w(0)},k);f(v,$,A,S=>{if(!D)return D=!0,clearTimeout(E),w(S)})})}e.$sg=N;function f(v,$,k,A){if($===0)return A(0);const D=new C.Socket;D.once("connect",()=>(R(D),f(v+k,$-1,k,A))),D.once("data",()=>{}),D.once("error",w=>(R(D),w.code!=="ECONNREFUSED"?f(v+k,$-1,k,A):A(v))),D.connect(v,"127.0.0.1")}e.$tg={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function P(v,$,k,A="127.0.0.1"){let D=!1,w,E=1;const S=C.createServer({pauseOnConnect:!0});function c(g,o){D||(D=!0,S.removeAllListeners(),S.close(),w&&clearTimeout(w),o(g))}return new Promise(g=>{w=setTimeout(()=>{c(0,g)},k),S.on("listening",()=>{c(v,g)}),S.on("error",o=>{o&&(o.code==="EADDRINUSE"||o.code==="EACCES")&&E<$?(v++,E++,S.listen(v,A)):c(0,g)}),S.on("close",()=>{c(0,g)}),S.listen(v,A)})}e.$ug=P;function R(v){try{v.removeAllListeners("connect"),v.removeAllListeners("error"),v.end(),v.destroy(),v.unref()}catch($){console.error($)}}}),define(ke[125],Se([1,0,124]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gt=e.$ft=void 0;class N{constructor(v){const $=(0,C.$He)(v);this.c=$,this.a=N.d($),this.b=new Map}static d(v){const $=new Uint8Array(256);return $.fill(v),$}set(v,$){const k=(0,C.$He)($);v>=0&&v<256?this.a[v]=k:this.b.set(v,k)}get(v){return v>=0&&v<256?this.a[v]:this.b.get(v)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.$ft=N;var f;(function(R){R[R.False=0]="False",R[R.True=1]="True"})(f||(f={}));class P{constructor(){this.a=new N(0)}add(v){this.a.set(v,1)}has(v){return this.a.get(v)===1}clear(){return this.a.clear()}}e.$gt=P}),define(ke[167],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var C;(function(f){f[f.Unknown=0]="Unknown",f[f.Invalid=3]="Invalid",f[f.LF=1]="LF",f[f.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function N(f){let P=0,R=0,v=0,$=0;for(let k=0,A=f.length;k<A;k++){const D=f.charCodeAt(k);D===13?(P===0&&(R=k),P++,k+1<A&&f.charCodeAt(k+1)===10?($|=2,k++):$|=3,v=k+1):D===10&&($|=1,P===0&&(R=k),P++,v=k+1)}return P===0&&(R=f.length),[P,R,f.length-v,$]}e.$ut=N}),define(ke[48],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ts=void 0;class C{constructor(f,P){this.lineNumber=f,this.column=P}with(f=this.lineNumber,P=this.column){return f===this.lineNumber&&P===this.column?this:new C(f,P)}delta(f=0,P=0){return this.with(this.lineNumber+f,this.column+P)}equals(f){return C.equals(this,f)}static equals(f,P){return!f&&!P?!0:!!f&&!!P&&f.lineNumber===P.lineNumber&&f.column===P.column}isBefore(f){return C.isBefore(this,f)}static isBefore(f,P){return f.lineNumber<P.lineNumber?!0:P.lineNumber<f.lineNumber?!1:f.column<P.column}isBeforeOrEqual(f){return C.isBeforeOrEqual(this,f)}static isBeforeOrEqual(f,P){return f.lineNumber<P.lineNumber?!0:P.lineNumber<f.lineNumber?!1:f.column<=P.column}static compare(f,P){const R=f.lineNumber|0,v=P.lineNumber|0;if(R===v){const $=f.column|0,k=P.column|0;return $-k}return R-v}clone(){return new C(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(f){return new C(f.lineNumber,f.column)}static isIPosition(f){return f&&typeof f.lineNumber=="number"&&typeof f.column=="number"}toJSON(){return{lineNumber:this.lineNumber,column:this.column}}}e.$Ts=C}),define(ke[29],Se([1,0,48]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Us=void 0;class N{constructor(P,R,v,$){P>v||P===v&&R>$?(this.startLineNumber=v,this.startColumn=$,this.endLineNumber=P,this.endColumn=R):(this.startLineNumber=P,this.startColumn=R,this.endLineNumber=v,this.endColumn=$)}isEmpty(){return N.isEmpty(this)}static isEmpty(P){return P.startLineNumber===P.endLineNumber&&P.startColumn===P.endColumn}containsPosition(P){return N.containsPosition(this,P)}static containsPosition(P,R){return!(R.lineNumber<P.startLineNumber||R.lineNumber>P.endLineNumber||R.lineNumber===P.startLineNumber&&R.column<P.startColumn||R.lineNumber===P.endLineNumber&&R.column>P.endColumn)}static strictContainsPosition(P,R){return!(R.lineNumber<P.startLineNumber||R.lineNumber>P.endLineNumber||R.lineNumber===P.startLineNumber&&R.column<=P.startColumn||R.lineNumber===P.endLineNumber&&R.column>=P.endColumn)}containsRange(P){return N.containsRange(this,P)}static containsRange(P,R){return!(R.startLineNumber<P.startLineNumber||R.endLineNumber<P.startLineNumber||R.startLineNumber>P.endLineNumber||R.endLineNumber>P.endLineNumber||R.startLineNumber===P.startLineNumber&&R.startColumn<P.startColumn||R.endLineNumber===P.endLineNumber&&R.endColumn>P.endColumn)}strictContainsRange(P){return N.strictContainsRange(this,P)}static strictContainsRange(P,R){return!(R.startLineNumber<P.startLineNumber||R.endLineNumber<P.startLineNumber||R.startLineNumber>P.endLineNumber||R.endLineNumber>P.endLineNumber||R.startLineNumber===P.startLineNumber&&R.startColumn<=P.startColumn||R.endLineNumber===P.endLineNumber&&R.endColumn>=P.endColumn)}plusRange(P){return N.plusRange(this,P)}static plusRange(P,R){let v,$,k,A;return R.startLineNumber<P.startLineNumber?(v=R.startLineNumber,$=R.startColumn):R.startLineNumber===P.startLineNumber?(v=R.startLineNumber,$=Math.min(R.startColumn,P.startColumn)):(v=P.startLineNumber,$=P.startColumn),R.endLineNumber>P.endLineNumber?(k=R.endLineNumber,A=R.endColumn):R.endLineNumber===P.endLineNumber?(k=R.endLineNumber,A=Math.max(R.endColumn,P.endColumn)):(k=P.endLineNumber,A=P.endColumn),new N(v,$,k,A)}intersectRanges(P){return N.intersectRanges(this,P)}static intersectRanges(P,R){let v=P.startLineNumber,$=P.startColumn,k=P.endLineNumber,A=P.endColumn;const D=R.startLineNumber,w=R.startColumn,E=R.endLineNumber,S=R.endColumn;return v<D?(v=D,$=w):v===D&&($=Math.max($,w)),k>E?(k=E,A=S):k===E&&(A=Math.min(A,S)),v>k||v===k&&$>A?null:new N(v,$,k,A)}equalsRange(P){return N.equalsRange(this,P)}static equalsRange(P,R){return!P&&!R?!0:!!P&&!!R&&P.startLineNumber===R.startLineNumber&&P.startColumn===R.startColumn&&P.endLineNumber===R.endLineNumber&&P.endColumn===R.endColumn}getEndPosition(){return N.getEndPosition(this)}static getEndPosition(P){return new C.$Ts(P.endLineNumber,P.endColumn)}getStartPosition(){return N.getStartPosition(this)}static getStartPosition(P){return new C.$Ts(P.startLineNumber,P.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(P,R){return new N(this.startLineNumber,this.startColumn,P,R)}setStartPosition(P,R){return new N(P,R,this.endLineNumber,this.endColumn)}collapseToStart(){return N.collapseToStart(this)}static collapseToStart(P){return new N(P.startLineNumber,P.startColumn,P.startLineNumber,P.startColumn)}collapseToEnd(){return N.collapseToEnd(this)}static collapseToEnd(P){return new N(P.endLineNumber,P.endColumn,P.endLineNumber,P.endColumn)}delta(P){return new N(this.startLineNumber+P,this.startColumn,this.endLineNumber+P,this.endColumn)}static fromPositions(P,R=P){return new N(P.lineNumber,P.column,R.lineNumber,R.column)}static lift(P){return P?new N(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):null}static isIRange(P){return P&&typeof P.startLineNumber=="number"&&typeof P.startColumn=="number"&&typeof P.endLineNumber=="number"&&typeof P.endColumn=="number"}static areIntersectingOrTouching(P,R){return!(P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<R.startColumn||R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<P.startColumn)}static areIntersecting(P,R){return!(P.endLineNumber<R.startLineNumber||P.endLineNumber===R.startLineNumber&&P.endColumn<=R.startColumn||R.endLineNumber<P.startLineNumber||R.endLineNumber===P.startLineNumber&&R.endColumn<=P.startColumn)}static compareRangesUsingStarts(P,R){if(P&&R){const k=P.startLineNumber|0,A=R.startLineNumber|0;if(k===A){const D=P.startColumn|0,w=R.startColumn|0;if(D===w){const E=P.endLineNumber|0,S=R.endLineNumber|0;if(E===S){const c=P.endColumn|0,g=R.endColumn|0;return c-g}return E-S}return D-w}return k-A}return(P?1:0)-(R?1:0)}static compareRangesUsingEnds(P,R){return P.endLineNumber===R.endLineNumber?P.endColumn===R.endColumn?P.startLineNumber===R.startLineNumber?P.startColumn-R.startColumn:P.startLineNumber-R.startLineNumber:P.endColumn-R.endColumn:P.endLineNumber-R.endLineNumber}static spansMultipleLines(P){return P.endLineNumber>P.startLineNumber}toJSON(){return this}}e.$Us=N}),define(ke[168],Se([1,0,29]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0;class N{static insert(P,R){return{range:new C.$Us(P.lineNumber,P.column,P.lineNumber,P.column),text:R,forceMoveMarkers:!0}}static delete(P){return{range:P,text:null}}static replace(P,R){return{range:P,text:R}}static replaceMove(P,R){return{range:P,text:R,forceMoveMarkers:!0}}}e.$Vs=N}),define(ke[169],Se([1,0,48,29]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ws=e.SelectionDirection=void 0;var f;(function(R){R[R.LTR=0]="LTR",R[R.RTL=1]="RTL"})(f||(e.SelectionDirection=f={}));class P extends N.$Us{constructor(v,$,k,A){super(v,$,k,A),this.selectionStartLineNumber=v,this.selectionStartColumn=$,this.positionLineNumber=k,this.positionColumn=A}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(v){return P.selectionsEqual(this,v)}static selectionsEqual(v,$){return v.selectionStartLineNumber===$.selectionStartLineNumber&&v.selectionStartColumn===$.selectionStartColumn&&v.positionLineNumber===$.positionLineNumber&&v.positionColumn===$.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(v,$){return this.getDirection()===0?new P(this.startLineNumber,this.startColumn,v,$):new P(v,$,this.startLineNumber,this.startColumn)}getPosition(){return new C.$Ts(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new C.$Ts(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(v,$){return this.getDirection()===0?new P(v,$,this.endLineNumber,this.endColumn):new P(this.endLineNumber,this.endColumn,v,$)}static fromPositions(v,$=v){return new P(v.lineNumber,v.column,$.lineNumber,$.column)}static fromRange(v,$){return $===0?new P(v.startLineNumber,v.startColumn,v.endLineNumber,v.endColumn):new P(v.endLineNumber,v.endColumn,v.startLineNumber,v.startColumn)}static liftSelection(v){return new P(v.selectionStartLineNumber,v.selectionStartColumn,v.positionLineNumber,v.positionColumn)}static selectionsArrEqual(v,$){if(v&&!$||!v&&$)return!1;if(!v&&!$)return!0;if(v.length!==$.length)return!1;for(let k=0,A=v.length;k<A;k++)if(!this.selectionsEqual(v[k],$[k]))return!1;return!0}static isISelection(v){return v&&typeof v.selectionStartLineNumber=="number"&&typeof v.selectionStartColumn=="number"&&typeof v.positionLineNumber=="number"&&typeof v.positionColumn=="number"}static createWithDirection(v,$,k,A,D){return D===0?new P(v,$,k,A):new P(k,A,v,$)}}e.$Ws=P}),define(ke[170],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ss=void 0,e.$ss={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ke[171],Se([1,0,125]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$it=e.$ht=e.WordCharacterClass=void 0;var N;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(N||(e.WordCharacterClass=N={}));class f extends C.$ft{constructor(v){super(0);for(let $=0,k=v.length;$<k;$++)this.set(v.charCodeAt($),2);this.set(32,1),this.set(9,1)}}e.$ht=f;function P(R){const v={};return $=>(v.hasOwnProperty($)||(v[$]=R($)),v[$])}e.$it=P(R=>new f(R))}),define(ke[126],Se([1,0,53,3,75]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xs=e.$ws=e.$vs=e.$us=e.$ts=void 0,e.$ts="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function P(D=""){let w="(-?\\d*\\.\\d\\w*)|([^";for(const E of e.$ts)D.indexOf(E)>=0||(w+="\\"+E);return w+="\\s]+)",new RegExp(w,"g")}e.$us=P();function R(D){let w=e.$us;if(D&&D instanceof RegExp)if(D.global)w=D;else{let E="g";D.ignoreCase&&(E+="i"),D.multiline&&(E+="m"),D.unicode&&(E+="u"),w=new RegExp(D.source,E)}return w.lastIndex=0,w}e.$vs=R;const v=new f.$4c;v.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function $(D){const w=v.unshift(D);return(0,N.$Rc)(w)}e.$ws=$;function k(D,w,E,S,c){if(w=R(w),c||(c=C.Iterable.first(v)),E.length>c.maxLen){let n=D-c.maxLen/2;return n<0?n=0:S+=n,E=E.substring(n,D+c.maxLen/2),k(D,w,E,S,c)}const g=Date.now(),o=D-1-S;let i=-1,r=null;for(let n=1;!(Date.now()-g>=c.timeBudget);n++){const a=o-c.windowSize*n;w.lastIndex=Math.max(0,a);const t=A(w,E,o,i);if(!t&&r||(r=t,a<=0))break;i=a}if(r){const n={word:r[0],startColumn:S+1+r.index,endColumn:S+1+r.index+r[0].length};return w.lastIndex=0,n}return null}e.$xs=k;function A(D,w,E,S){let c;for(;c=D.exec(w);){const g=c.index||0;if(g<=E&&D.lastIndex>=E)return c;if(S>0&&g>S)return null}return null}}),define(ke[172],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$St=e.$Rt=e.IndentAction=void 0;var C;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class N{constructor(v){if(this.e=null,this.f=!1,this.open=v.open,this.close=v.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(v.notIn))for(let $=0,k=v.notIn.length;$<k;$++)switch(v.notIn[$]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(v){switch(v){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(v,$){if(v.getTokenCount()===0)return!0;const k=v.findTokenIndexAtOffset($-2),A=v.getStandardTokenType(k);return this.isOK(A)}g(v,$){for(let k=v;k<=$;k++){const A=String.fromCharCode(k);if(!this.open.includes(A)&&!this.close.includes(A))return A}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Rt=N;class f{constructor(v){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const $ of v)P(this.autoClosingPairsOpenByStart,$.open.charAt(0),$),P(this.autoClosingPairsOpenByEnd,$.open.charAt($.open.length-1),$),P(this.autoClosingPairsCloseByStart,$.close.charAt(0),$),P(this.autoClosingPairsCloseByEnd,$.close.charAt($.close.length-1),$),$.close.length===1&&$.open.length===1&&P(this.autoClosingPairsCloseSingleChar,$.close,$)}}e.$St=f;function P(R,v,$){R.has(v)?R.get(v).push($):R.set(v,[$])}}),define(ke[173],Se([1,0,125]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FZ=e.$EZ=e.$DZ=e.State=void 0;var N;(function(E){E[E.Invalid=0]="Invalid",E[E.Start=1]="Start",E[E.H=2]="H",E[E.HT=3]="HT",E[E.HTT=4]="HTT",E[E.HTTP=5]="HTTP",E[E.F=6]="F",E[E.FI=7]="FI",E[E.FIL=8]="FIL",E[E.BeforeColon=9]="BeforeColon",E[E.AfterColon=10]="AfterColon",E[E.AlmostThere=11]="AlmostThere",E[E.End=12]="End",E[E.Accept=13]="Accept",E[E.LastKnownState=14]="LastKnownState"})(N||(e.State=N={}));class f{constructor(S,c,g){const o=new Uint8Array(S*c);for(let i=0,r=S*c;i<r;i++)o[i]=g;this.a=o,this.rows=S,this.cols=c}get(S,c){return this.a[S*this.cols+c]}set(S,c,g){this.a[S*this.cols+c]=g}}class P{constructor(S){let c=0,g=0;for(let i=0,r=S.length;i<r;i++){const[n,a,t]=S[i];a>c&&(c=a),n>g&&(g=n),t>g&&(g=t)}c++,g++;const o=new f(g,c,0);for(let i=0,r=S.length;i<r;i++){const[n,a,t]=S[i];o.set(n,a,t)}this.a=o,this.b=c}nextState(S,c){return c<0||c>=this.b?0:this.a.get(S,c)}}e.$DZ=P;let R=null;function v(){return R===null&&(R=new P([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),R}var $;(function(E){E[E.None=0]="None",E[E.ForceTermination=1]="ForceTermination",E[E.CannotEndIn=2]="CannotEndIn"})($||($={}));let k=null;function A(){if(k===null){k=new C.$ft(0);const E=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let c=0;c<E.length;c++)k.set(E.charCodeAt(c),1);const S=".,;:";for(let c=0;c<S.length;c++)k.set(S.charCodeAt(c),2)}return k}class D{static a(S,c,g,o,i){let r=i-1;do{const n=c.charCodeAt(r);if(S.get(n)!==2)break;r--}while(r>o);if(o>0){const n=c.charCodeAt(o-1),a=c.charCodeAt(r);(n===40&&a===41||n===91&&a===93||n===123&&a===125)&&r--}return{range:{startLineNumber:g,startColumn:o+1,endLineNumber:g,endColumn:r+2},url:c.substring(o,r+1)}}static computeLinks(S,c=v()){const g=A(),o=[];for(let i=1,r=S.getLineCount();i<=r;i++){const n=S.getLineContent(i),a=n.length;let t=0,h=0,s=0,d=1,u=!1,l=!1,p=!1,I=!1;for(;t<a;){let b=!1;const m=n.charCodeAt(t);if(d===13){let y;switch(m){case 40:u=!0,y=0;break;case 41:y=u?0:1;break;case 91:p=!0,l=!0,y=0;break;case 93:p=!1,y=l?0:1;break;case 123:I=!0,y=0;break;case 125:y=I?0:1;break;case 39:case 34:case 96:s===m?y=1:s===39||s===34||s===96?y=0:y=1;break;case 42:y=s===42?1:0;break;case 124:y=s===124?1:0;break;case 32:y=p?0:1;break;default:y=g.get(m)}y===1&&(o.push(D.a(g,n,i,h,t)),b=!0)}else if(d===12){let y;m===91?(l=!0,y=0):y=g.get(m),y===1?b=!0:d=13}else d=c.nextState(d,m),d===0&&(b=!0);b&&(d=1,u=!1,l=!1,I=!1,h=t+1,s=m),t++}d===13&&o.push(D.a(g,n,i,h,a))}return o}}e.$EZ=D;function w(E){return!E||typeof E.getLineCount!="function"||typeof E.getLineContent!="function"?[]:D.computeLinks(E)}e.$FZ=w}),define(ke[79],Se([1,0,24]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fv=e.$ev=e.$dv=e.$cv=e.ModelConstants=e.PositionAffinity=e.$bv=e.TrackedRangeStickiness=e.$av=e.$_u=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var N;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=4]="Right",n[n.Full=7]="Full"})(N||(e.OverviewRulerLane=N={}));var f;(function(n){n[n.Left=1]="Left",n[n.Center=2]="Center",n[n.Right=3]="Right"})(f||(e.GlyphMarginLane=f={}));var P;(function(n){n[n.Inline=1]="Inline",n[n.Gutter=2]="Gutter"})(P||(e.MinimapPosition=P={}));var R;(function(n){n[n.Both=0]="Both",n[n.Right=1]="Right",n[n.Left=2]="Left",n[n.None=3]="None"})(R||(e.InjectedTextCursorStops=R={}));var v;(function(n){n[n.TextDefined=0]="TextDefined",n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})(v||(e.EndOfLinePreference=v={}));var $;(function(n){n[n.LF=1]="LF",n[n.CRLF=2]="CRLF"})($||(e.DefaultEndOfLine=$={}));var k;(function(n){n[n.LF=0]="LF",n[n.CRLF=1]="CRLF"})(k||(e.EndOfLineSequence=k={}));class A{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(a){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,a.tabSize|0),a.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,a.indentSize|0),this.a=!1),this.insertSpaces=!!a.insertSpaces,this.defaultEOL=a.defaultEOL|0,this.trimAutoWhitespace=!!a.trimAutoWhitespace,this.bracketPairColorizationOptions=a.bracketPairColorizationOptions}equals(a){return this.tabSize===a.tabSize&&this.a===a.a&&this.indentSize===a.indentSize&&this.insertSpaces===a.insertSpaces&&this.defaultEOL===a.defaultEOL&&this.trimAutoWhitespace===a.trimAutoWhitespace&&(0,C.$zn)(this.bracketPairColorizationOptions,a.bracketPairColorizationOptions)}createChangeEvent(a){return{tabSize:this.tabSize!==a.tabSize,indentSize:this.indentSize!==a.indentSize,insertSpaces:this.insertSpaces!==a.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==a.trimAutoWhitespace}}}e.$_u=A;class D{constructor(a,t){this._findMatchBrand=void 0,this.range=a,this.matches=t}}e.$av=D;var w;(function(n){n[n.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",n[n.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",n[n.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",n[n.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(w||(e.TrackedRangeStickiness=w={}));function E(n){return n&&typeof n.read=="function"}e.$bv=E;var S;(function(n){n[n.Left=0]="Left",n[n.Right=1]="Right",n[n.None=2]="None",n[n.LeftOfInjectedText=3]="LeftOfInjectedText",n[n.RightOfInjectedText=4]="RightOfInjectedText"})(S||(e.PositionAffinity=S={}));var c;(function(n){n[n.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(c||(e.ModelConstants=c={}));class g{constructor(a,t,h,s,d,u){this.identifier=a,this.range=t,this.text=h,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=d,this._isTracked=u}}e.$cv=g;class o{constructor(a,t,h){this.regex=a,this.wordSeparators=t,this.simpleSearch=h}}e.$dv=o;class i{constructor(a,t,h){this.reverseEdits=a,this.changes=t,this.trimAutoWhitespaceLineNumbers=h}}e.$ev=i;function r(n){return!n.isTooLargeForSyncing()&&!n.isForSimpleWidget}e.$fv=r}),define(ke[174],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2B=e.$1B=e.$ZB=e.$YB=e.$XB=e.$WB=e.$VB=e.$UB=e.$TB=e.NodeColor=e.$SB=void 0;class C{constructor(g,o){this.piece=g,this.color=o,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$TB)return f(this.right);let g=this;for(;g.parent!==e.$TB&&g.parent.left!==g;)g=g.parent;return g.parent===e.$TB?e.$TB:g.parent}prev(){if(this.left!==e.$TB)return P(this.left);let g=this;for(;g.parent!==e.$TB&&g.parent.right!==g;)g=g.parent;return g.parent===e.$TB?e.$TB:g.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$SB=C;var N;(function(c){c[c.Black=0]="Black",c[c.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$TB=new C(null,0),e.$TB.parent=e.$TB,e.$TB.left=e.$TB,e.$TB.right=e.$TB,e.$TB.color=0;function f(c){for(;c.left!==e.$TB;)c=c.left;return c}e.$UB=f;function P(c){for(;c.right!==e.$TB;)c=c.right;return c}e.$VB=P;function R(c){return c===e.$TB?0:c.size_left+c.piece.length+R(c.right)}function v(c){return c===e.$TB?0:c.lf_left+c.piece.lineFeedCnt+v(c.right)}function $(){e.$TB.parent=e.$TB}function k(c,g){const o=g.right;o.size_left+=g.size_left+(g.piece?g.piece.length:0),o.lf_left+=g.lf_left+(g.piece?g.piece.lineFeedCnt:0),g.right=o.left,o.left!==e.$TB&&(o.left.parent=g),o.parent=g.parent,g.parent===e.$TB?c.root=o:g.parent.left===g?g.parent.left=o:g.parent.right=o,o.left=g,g.parent=o}e.$WB=k;function A(c,g){const o=g.left;g.left=o.right,o.right!==e.$TB&&(o.right.parent=g),o.parent=g.parent,g.size_left-=o.size_left+(o.piece?o.piece.length:0),g.lf_left-=o.lf_left+(o.piece?o.piece.lineFeedCnt:0),g.parent===e.$TB?c.root=o:g===g.parent.right?g.parent.right=o:g.parent.left=o,o.right=g,g.parent=o}e.$XB=A;function D(c,g){let o,i;if(g.left===e.$TB?(i=g,o=i.right):g.right===e.$TB?(i=g,o=i.left):(i=f(g.right),o=i.right),i===c.root){c.root=o,o.color=0,g.detach(),$(),c.root.parent=e.$TB;return}const r=i.color===1;if(i===i.parent.left?i.parent.left=o:i.parent.right=o,i===g?(o.parent=i.parent,S(c,o)):(i.parent===g?o.parent=i:o.parent=i.parent,S(c,o),i.left=g.left,i.right=g.right,i.parent=g.parent,i.color=g.color,g===c.root?c.root=i:g===g.parent.left?g.parent.left=i:g.parent.right=i,i.left!==e.$TB&&(i.left.parent=i),i.right!==e.$TB&&(i.right.parent=i),i.size_left=g.size_left,i.lf_left=g.lf_left,S(c,i)),g.detach(),o.parent.left===o){const a=R(o),t=v(o);if(a!==o.parent.size_left||t!==o.parent.lf_left){const h=a-o.parent.size_left,s=t-o.parent.lf_left;o.parent.size_left=a,o.parent.lf_left=t,E(c,o.parent,h,s)}}if(S(c,o.parent),r){$();return}let n;for(;o!==c.root&&o.color===0;)o===o.parent.left?(n=o.parent.right,n.color===1&&(n.color=0,o.parent.color=1,k(c,o.parent),n=o.parent.right),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.right.color===0&&(n.left.color=0,n.color=1,A(c,n),n=o.parent.right),n.color=o.parent.color,o.parent.color=0,n.right.color=0,k(c,o.parent),o=c.root)):(n=o.parent.left,n.color===1&&(n.color=0,o.parent.color=1,A(c,o.parent),n=o.parent.left),n.left.color===0&&n.right.color===0?(n.color=1,o=o.parent):(n.left.color===0&&(n.right.color=0,n.color=1,k(c,n),n=o.parent.left),n.color=o.parent.color,o.parent.color=0,n.left.color=0,A(c,o.parent),o=c.root));o.color=0,$()}e.$YB=D;function w(c,g){for(S(c,g);g!==c.root&&g.parent.color===1;)if(g.parent===g.parent.parent.left){const o=g.parent.parent.right;o.color===1?(g.parent.color=0,o.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.right&&(g=g.parent,k(c,g)),g.parent.color=0,g.parent.parent.color=1,A(c,g.parent.parent))}else{const o=g.parent.parent.left;o.color===1?(g.parent.color=0,o.color=0,g.parent.parent.color=1,g=g.parent.parent):(g===g.parent.left&&(g=g.parent,A(c,g)),g.parent.color=0,g.parent.parent.color=1,k(c,g.parent.parent))}c.root.color=0}e.$ZB=w;function E(c,g,o,i){for(;g!==c.root&&g!==e.$TB;)g.parent.left===g&&(g.parent.size_left+=o,g.parent.lf_left+=i),g=g.parent}e.$1B=E;function S(c,g){let o=0,i=0;if(g!==c.root){for(;g!==c.root&&g===g.parent.right;)g=g.parent;if(g!==c.root)for(g=g.parent,o=R(g.left)-g.size_left,i=v(g.left)-g.lf_left,g.size_left+=o,g.lf_left+=i;g!==c.root&&(o!==0||i!==0);)g.parent.left===g&&(g.parent.size_left+=o,g.parent.lf_left+=i),g=g.parent}}e.$2B=S}),define(ke[175],Se([1,0,19,124]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kv=e.$jv=e.$iv=void 0;class f{constructor($){this.a=$,this.b=new Uint32Array($.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues($,k){$=(0,N.$Ie)($);const A=this.a,D=this.b,w=k.length;return w===0?!1:(this.a=new Uint32Array(A.length+w),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($),$+w),this.a.set(k,$),$-1<this.c[0]&&(this.c[0]=$-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}setValue($,k){return $=(0,N.$Ie)($),k=(0,N.$Ie)(k),this.a[$]===k?!1:(this.a[$]=k,$-1<this.c[0]&&(this.c[0]=$-1),!0)}removeValues($,k){$=(0,N.$Ie)($),k=(0,N.$Ie)(k);const A=this.a,D=this.b;if($>=A.length)return!1;const w=A.length-$;return k>=w&&(k=w),k===0?!1:(this.a=new Uint32Array(A.length-k),this.a.set(A.subarray(0,$),0),this.a.set(A.subarray($+k),$),this.b=new Uint32Array(this.a.length),$-1<this.c[0]&&(this.c[0]=$-1),this.c[0]>=0&&this.b.set(D.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum($){return $<0?0:($=(0,N.$Ie)($),this.d($))}d($){if($<=this.c[0])return this.b[$];let k=this.c[0]+1;k===0&&(this.b[0]=this.a[0],k++),$>=this.a.length&&($=this.a.length-1);for(let A=k;A<=$;A++)this.b[A]=this.b[A-1]+this.a[A];return this.c[0]=Math.max(this.c[0],$),this.b[$]}getIndexOf($){$=Math.floor($),this.getTotalSum();let k=0,A=this.a.length-1,D=0,w=0,E=0;for(;k<=A;)if(D=k+(A-k)/2|0,w=this.b[D],E=w-this.a[D],$<E)A=D-1;else if($>=w)k=D+1;else break;return new R(D,$-E)}}e.$iv=f;class P{constructor($){this.a=$,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum($){return this.g(),$===0?0:this.d[$-1]}getIndexOf($){this.g();const k=this.e[$],A=k>0?this.d[k-1]:0;return new R(k,$-A)}removeValues($,k){this.a.splice($,k),this.f($)}insertValues($,k){this.a=(0,C.$Wb)(this.a,$,k),this.f($)}f($){this.b=!1,this.c=Math.min(this.c,$-1)}g(){if(!this.b){for(let $=this.c+1,k=this.a.length;$<k;$++){const A=this.a[$],D=$>0?this.d[$-1]:0;this.d[$]=D+A;for(let w=0;w<A;w++)this.e[D+w]=$}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue($,k){this.a[$]!==k&&(this.a[$]=k,this.f($))}}e.$jv=P;class R{constructor($,k){this.index=$,this.remainder=k,this._prefixSumIndexOfResultBrand=void 0,this.index=$,this.remainder=k}}e.$kv=R}),define(ke[176],Se([1,0,12,48,175]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lv=void 0;class P{constructor(v,$,k,A){this.d=v,this.f=$,this.g=k,this.h=A,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(v){v.eol&&v.eol!==this.g&&(this.g=v.eol,this.j=null);const $=v.changes;for(const k of $)this.o(k.range),this.p(new N.$Ts(k.range.startLineNumber,k.range.startColumn),k.text);this.h=v.versionId,this.k=null}l(){if(!this.j){const v=this.g.length,$=this.f.length,k=new Uint32Array($);for(let A=0;A<$;A++)k[A]=this.f[A].length+v;this.j=new f.$iv(k)}}n(v,$){this.f[v]=$,this.j&&this.j.setValue(v,this.f[v].length+this.g.length)}o(v){if(v.startLineNumber===v.endLineNumber){if(v.startColumn===v.endColumn)return;this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.startLineNumber-1].substring(v.endColumn-1));return}this.n(v.startLineNumber-1,this.f[v.startLineNumber-1].substring(0,v.startColumn-1)+this.f[v.endLineNumber-1].substring(v.endColumn-1)),this.f.splice(v.startLineNumber,v.endLineNumber-v.startLineNumber),this.j&&this.j.removeValues(v.startLineNumber,v.endLineNumber-v.startLineNumber)}p(v,$){if($.length===0)return;const k=(0,C.$Ze)($);if(k.length===1){this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+k[0]+this.f[v.lineNumber-1].substring(v.column-1));return}k[k.length-1]+=this.f[v.lineNumber-1].substring(v.column-1),this.n(v.lineNumber-1,this.f[v.lineNumber-1].substring(0,v.column-1)+k[0]);const A=new Uint32Array(k.length-1);for(let D=1;D<k.length;D++)this.f.splice(v.lineNumber+D-1,0,k[D]),A[D-1]=k[D].length+this.g.length;this.j&&this.j.insertValues(v.lineNumber,A)}}e.$lv=P}),define(ke[100],Se([1,0,12,171,48,29,79]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8B=e.$7B=e.$6B=e.$5B=e.$4B=e.$3B=void 0;const v=999;class ${constructor(i,r,n,a){this.searchString=i,this.isRegex=r,this.matchCase=n,this.wordSeparators=a}parseSearchRequest(){if(this.searchString==="")return null;let i;this.isRegex?i=k(this.searchString):i=this.searchString.indexOf(`
`)>=0;let r=null;try{r=C.$Xe(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:i,global:!0,unicode:!0})}catch{return null}if(!r)return null;let n=!this.isRegex&&!i;return n&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(n=this.matchCase),new R.$dv(r,this.wordSeparators?(0,N.$it)(this.wordSeparators):null,n?this.searchString:null)}}e.$3B=$;function k(o){if(!o||o.length===0)return!1;for(let i=0,r=o.length;i<r;i++){const n=o.charCodeAt(i);if(n===10)return!0;if(n===92){if(i++,i>=r)break;const a=o.charCodeAt(i);if(a===110||a===114||a===87)return!0}}return!1}e.$4B=k;function A(o,i,r){if(!r)return new R.$av(o,null);const n=[];for(let a=0,t=i.length;a<t;a++)n[a]=i[a];return new R.$av(o,n)}e.$5B=A;class D{constructor(i){const r=[];let n=0;for(let a=0,t=i.length;a<t;a++)i.charCodeAt(a)===10&&(r[n++]=a);this.a=r}findLineFeedCountBeforeOffset(i){const r=this.a;let n=0,a=r.length-1;if(a===-1||i<=r[0])return 0;for(;n<a;){const t=n+((a-n)/2>>0);r[t]>=i?a=t-1:r[t+1]>=i?(n=t,a=t):n=t+1}return n+1}}class w{static findMatches(i,r,n,a,t){const h=r.parseSearchRequest();return h?h.regex.multiline?this.b(i,n,new g(h.wordSeparators,h.regex),a,t):this.c(i,n,h,a,t):[]}static a(i,r,n,a,t,h){let s,d=0;a?(d=a.findLineFeedCountBeforeOffset(t),s=r+t+d):s=r+t;let u;if(a){const b=a.findLineFeedCountBeforeOffset(t+h.length)-d;u=s+h.length+b}else u=s+h.length;const l=i.getPositionAt(s),p=i.getPositionAt(u);return new P.$Us(l.lineNumber,l.column,p.lineNumber,p.column)}static b(i,r,n,a,t){const h=i.getOffsetAt(r.getStartPosition()),s=i.getValueInRange(r,1),d=i.getEOL()===`\r
`?new D(s):null,u=[];let l=0,p;for(n.reset(0);p=n.next(s);)if(u[l++]=A(this.a(i,h,s,d,p.index,p[0]),p,a),l>=t)return u;return u}static c(i,r,n,a,t){const h=[];let s=0;if(r.startLineNumber===r.endLineNumber){const u=i.getLineContent(r.startLineNumber).substring(r.startColumn-1,r.endColumn-1);return s=this.d(n,u,r.startLineNumber,r.startColumn-1,s,h,a,t),h}const d=i.getLineContent(r.startLineNumber).substring(r.startColumn-1);s=this.d(n,d,r.startLineNumber,r.startColumn-1,s,h,a,t);for(let u=r.startLineNumber+1;u<r.endLineNumber&&s<t;u++)s=this.d(n,i.getLineContent(u),u,0,s,h,a,t);if(s<t){const u=i.getLineContent(r.endLineNumber).substring(0,r.endColumn-1);s=this.d(n,u,r.endLineNumber,0,s,h,a,t)}return h}static d(i,r,n,a,t,h,s,d){const u=i.wordSeparators;if(!s&&i.simpleSearch){const I=i.simpleSearch,b=I.length,m=r.length;let y=-b;for(;(y=r.indexOf(I,y+b))!==-1;)if((!u||c(u,r,m,y,b))&&(h[t++]=new R.$av(new P.$Us(n,y+1+a,n,y+1+b+a),null),t>=d))return t;return t}const l=new g(i.wordSeparators,i.regex);let p;l.reset(0);do if(p=l.next(r),p&&(h[t++]=A(new P.$Us(n,p.index+1+a,n,p.index+1+p[0].length+a),p,s),t>=d))return t;while(p);return t}static findNextMatch(i,r,n,a){const t=r.parseSearchRequest();if(!t)return null;const h=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.e(i,n,h,a):this.f(i,n,h,a)}static e(i,r,n,a){const t=new f.$Ts(r.lineNumber,1),h=i.getOffsetAt(t),s=i.getLineCount(),d=i.getValueInRange(new P.$Us(t.lineNumber,t.column,s,i.getLineMaxColumn(s)),1),u=i.getEOL()===`\r
`?new D(d):null;n.reset(r.column-1);const l=n.next(d);return l?A(this.a(i,h,d,u,l.index,l[0]),l,a):r.lineNumber!==1||r.column!==1?this.e(i,new f.$Ts(1,1),n,a):null}static f(i,r,n,a){const t=i.getLineCount(),h=r.lineNumber,s=i.getLineContent(h),d=this.g(n,s,h,r.column,a);if(d)return d;for(let u=1;u<=t;u++){const l=(h+u-1)%t,p=i.getLineContent(l+1),I=this.g(n,p,l+1,1,a);if(I)return I}return null}static g(i,r,n,a,t){i.reset(a-1);const h=i.next(r);return h?A(new P.$Us(n,h.index+1,n,h.index+1+h[0].length),h,t):null}static findPreviousMatch(i,r,n,a){const t=r.parseSearchRequest();if(!t)return null;const h=new g(t.wordSeparators,t.regex);return t.regex.multiline?this.h(i,n,h,a):this.j(i,n,h,a)}static h(i,r,n,a){const t=this.b(i,new P.$Us(1,1,r.lineNumber,r.column),n,a,10*v);if(t.length>0)return t[t.length-1];const h=i.getLineCount();return r.lineNumber!==h||r.column!==i.getLineMaxColumn(h)?this.h(i,new f.$Ts(h,i.getLineMaxColumn(h)),n,a):null}static j(i,r,n,a){const t=i.getLineCount(),h=r.lineNumber,s=i.getLineContent(h).substring(0,r.column-1),d=this.k(n,s,h,a);if(d)return d;for(let u=1;u<=t;u++){const l=(t+h-u-1)%t,p=i.getLineContent(l+1),I=this.k(n,p,l+1,a);if(I)return I}return null}static k(i,r,n,a){let t=null,h;for(i.reset(0);h=i.next(r);)t=A(new P.$Us(n,h.index+1,n,h.index+1+h[0].length),h,a);return t}}e.$6B=w;function E(o,i,r,n,a){if(n===0)return!0;const t=i.charCodeAt(n-1);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const h=i.charCodeAt(n);if(o.get(h)!==0)return!0}return!1}function S(o,i,r,n,a){if(n+a===r)return!0;const t=i.charCodeAt(n+a);if(o.get(t)!==0||t===13||t===10)return!0;if(a>0){const h=i.charCodeAt(n+a-1);if(o.get(h)!==0)return!0}return!1}function c(o,i,r,n,a){return E(o,i,r,n,a)&&S(o,i,r,n,a)}e.$7B=c;class g{constructor(i,r){this._wordSeparators=i,this.a=r,this.b=-1,this.c=0}reset(i){this.a.lastIndex=i,this.b=-1,this.c=0}next(i){const r=i.length;let n;do{if(this.b+this.c===r||(n=this.a.exec(i),!n))return null;const a=n.index,t=n[0].length;if(a===this.b&&t===this.c){if(t===0){C.$gf(i,r,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=a,this.c=t,!this._wordSeparators||c(this._wordSeparators,i,r,a,t))return n}while(n);return null}}e.$8B=g}),define(ke[127],Se([1,0,48,29,79,174,100]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aC=e.$_B=e.$$B=e.$0B=e.$9B=void 0;const v=65535;function $(o){let i;return o[o.length-1]<65536?i=new Uint16Array(o.length):i=new Uint32Array(o.length),i.set(o,0),i}class k{constructor(i,r,n,a,t){this.lineStarts=i,this.cr=r,this.lf=n,this.crlf=a,this.isBasicASCII=t}}function A(o,i=!0){const r=[0];let n=1;for(let a=0,t=o.length;a<t;a++){const h=o.charCodeAt(a);h===13?a+1<t&&o.charCodeAt(a+1)===10?(r[n++]=a+2,a++):r[n++]=a+1:h===10&&(r[n++]=a+1)}return i?$(r):r}e.$9B=A;function D(o,i){o.length=0,o[0]=0;let r=1,n=0,a=0,t=0,h=!0;for(let d=0,u=i.length;d<u;d++){const l=i.charCodeAt(d);l===13?d+1<u&&i.charCodeAt(d+1)===10?(t++,o[r++]=d+2,d++):(n++,o[r++]=d+1):l===10?(a++,o[r++]=d+1):h&&l!==9&&(l<32||l>126)&&(h=!1)}const s=new k($(o),n,a,t,h);return o.length=0,s}e.$0B=D;class w{constructor(i,r,n,a,t){this.bufferIndex=i,this.start=r,this.end=n,this.lineFeedCnt=a,this.length=t}}e.$$B=w;class E{constructor(i,r){this.buffer=i,this.lineStarts=r}}e.$_B=E;class S{constructor(i,r){this.a=[],this.c=i,this.d=r,this.b=0,i.root!==P.$TB&&i.iterate(i.root,n=>(n!==P.$TB&&this.a.push(n.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class c{constructor(i){this.a=i,this.b=[]}get(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartOffset<=i&&n.nodeStartOffset+n.node.piece.length>=i)return n}return null}get2(i){for(let r=this.b.length-1;r>=0;r--){const n=this.b[r];if(n.nodeStartLineNumber&&n.nodeStartLineNumber<i&&n.nodeStartLineNumber+n.node.piece.lineFeedCnt>=i)return n}return null}set(i){this.b.length>=this.a&&this.b.shift(),this.b.push(i)}validate(i){let r=!1;const n=this.b;for(let a=0;a<n.length;a++){const t=n[a];if(t.node.parent===null||t.nodeStartOffset>=i){n[a]=null,r=!0;continue}}if(r){const a=[];for(const t of n)t!==null&&a.push(t);this.b=a}}}class g{constructor(i,r,n){this.create(i,r,n)}create(i,r,n){this.a=[new E("",[0])],this.g={line:0,column:0},this.root=P.$TB,this.b=1,this.c=0,this.d=r,this.e=r.length,this.f=n;let a=null;for(let t=0,h=i.length;t<h;t++)if(i[t].buffer.length>0){i[t].lineStarts||(i[t].lineStarts=A(i[t].buffer));const s=new w(t+1,{line:0,column:0},{line:i[t].lineStarts.length-1,column:i[t].buffer.length-i[t].lineStarts[i[t].lineStarts.length-1]},i[t].lineStarts.length-1,i[t].buffer.length);this.a.push(i[t]),a=this.S(a,s)}this.h=new c(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(i){const r=v,n=r-Math.floor(r/3),a=n*2;let t="",h=0;const s=[];if(this.iterate(this.root,d=>{const u=this.R(d),l=u.length;if(h<=n||h+l<a)return t+=u,h+=l,!0;const p=t.replace(/\r\n|\r|\n/g,i);return s.push(new E(p,A(p))),t=u,h=l,!0}),h>0){const d=t.replace(/\r\n|\r|\n/g,i);s.push(new E(d,A(d)))}this.create(s,i,!0)}getEOL(){return this.d}setEOL(i){this.d=i,this.e=this.d.length,this.normalizeEOL(i)}createSnapshot(i){return new S(this,i)}equal(i){if(this.getLength()!==i.getLength()||this.getLineCount()!==i.getLineCount())return!1;let r=0;return this.iterate(this.root,a=>{if(a===P.$TB)return!0;const t=this.R(a),h=t.length,s=i.G(r),d=i.G(r+h),u=i.getValueInRange2(s,d);return r+=h,t===u})}getOffsetAt(i,r){let n=0,a=this.root;for(;a!==P.$TB;)if(a.left!==P.$TB&&a.lf_left+1>=i)a=a.left;else if(a.lf_left+a.piece.lineFeedCnt+1>=i){n+=a.size_left;const t=this.B(a,i-a.lf_left-2);return n+=t+r-1}else i-=a.lf_left+a.piece.lineFeedCnt,n+=a.size_left+a.piece.length,a=a.right;return n}getPositionAt(i){i=Math.floor(i),i=Math.max(0,i);let r=this.root,n=0;const a=i;for(;r!==P.$TB;)if(r.size_left!==0&&r.size_left>=i)r=r.left;else if(r.size_left+r.piece.length>=i){const t=this.A(r,i-r.size_left);if(n+=r.lf_left+t.index,t.index===0){const h=this.getOffsetAt(n+1,1),s=a-h;return new C.$Ts(n+1,s+1)}return new C.$Ts(n+1,t.remainder+1)}else if(i-=r.size_left+r.piece.length,n+=r.lf_left+r.piece.lineFeedCnt,r.right===P.$TB){const t=this.getOffsetAt(n+1,1),h=a-i-t;return new C.$Ts(n+1,h+1)}else r=r.right;return new C.$Ts(1,1)}getValueInRange(i,r){if(i.startLineNumber===i.endLineNumber&&i.startColumn===i.endColumn)return"";const n=this.H(i.startLineNumber,i.startColumn),a=this.H(i.endLineNumber,i.endColumn),t=this.getValueInRange2(n,a);return r?r!==this.d||!this.f?t.replace(/\r\n|\r|\n/g,r):r===this.getEOL()&&this.f?t:t.replace(/\r\n|\r|\n/g,r):t}getValueInRange2(i,r){if(i.node===r.node){const s=i.node,d=this.a[s.piece.bufferIndex].buffer,u=this.u(s.piece.bufferIndex,s.piece.start);return d.substring(u+i.remainder,u+r.remainder)}let n=i.node;const a=this.a[n.piece.bufferIndex].buffer,t=this.u(n.piece.bufferIndex,n.piece.start);let h=a.substring(t+i.remainder,t+n.piece.length);for(n=n.next();n!==P.$TB;){const s=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);if(n===r.node){h+=s.substring(d,d+r.remainder);break}else h+=s.substr(d,n.piece.length);n=n.next()}return h}getLinesContent(){const i=[];let r=0,n="",a=!1;return this.iterate(this.root,t=>{if(t===P.$TB)return!0;const h=t.piece;let s=h.length;if(s===0)return!0;const d=this.a[h.bufferIndex].buffer,u=this.a[h.bufferIndex].lineStarts,l=h.start.line,p=h.end.line;let I=u[l]+h.start.column;if(a&&(d.charCodeAt(I)===10&&(I++,s--),i[r++]=n,n="",a=!1,s===0))return!0;if(l===p)return!this.f&&d.charCodeAt(I+s-1)===13?(a=!0,n+=d.substr(I,s-1)):n+=d.substr(I,s),!0;n+=this.f?d.substring(I,Math.max(I,u[l+1]-this.e)):d.substring(I,u[l+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;for(let b=l+1;b<p;b++)n=this.f?d.substring(u[b],u[b+1]-this.e):d.substring(u[b],u[b+1]).replace(/(\r\n|\r|\n)$/,""),i[r++]=n;return!this.f&&d.charCodeAt(u[p]+h.end.column-1)===13?(a=!0,h.end.column===0?r--:n=d.substr(u[p],h.end.column-1)):n=d.substr(u[p],h.end.column),!0}),a&&(i[r++]=n,n=""),i[r++]=n,i}getLength(){return this.c}getLineCount(){return this.b}getLineContent(i){return this.j.lineNumber===i?this.j.value:(this.j.lineNumber=i,i===this.b?this.j.value=this.getLineRawContent(i):this.f?this.j.value=this.getLineRawContent(i,this.e):this.j.value=this.getLineRawContent(i).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(i){if(i.remainder===i.node.piece.length){const r=i.node.next();if(!r)return 0;const n=this.a[r.piece.bufferIndex],a=this.u(r.piece.bufferIndex,r.piece.start);return n.buffer.charCodeAt(a)}else{const r=this.a[i.node.piece.bufferIndex],a=this.u(i.node.piece.bufferIndex,i.node.piece.start)+i.remainder;return r.buffer.charCodeAt(a)}}getLineCharCode(i,r){const n=this.H(i,r+1);return this.l(n)}getLineLength(i){if(i===this.getLineCount()){const r=this.getOffsetAt(i,1);return this.getLength()-r}return this.getOffsetAt(i+1,1)-this.getOffsetAt(i,1)-this.e}getCharCode(i){const r=this.G(i);return this.l(r)}findMatchesInNode(i,r,n,a,t,h,s,d,u,l,p){const I=this.a[i.piece.bufferIndex],b=this.u(i.piece.bufferIndex,i.piece.start),m=this.u(i.piece.bufferIndex,t),y=this.u(i.piece.bufferIndex,h);let L;const F={line:0,column:0};let z,T;r._wordSeparators?(z=I.buffer.substring(m,y),T=O=>O+m,r.reset(0)):(z=I.buffer,T=O=>O,r.reset(m));do if(L=r.next(z),L){if(T(L.index)>=y)return l;this.s(i,T(L.index)-b,F);const O=this.t(i.piece.bufferIndex,t,F),M=F.line===t.line?F.column-t.column+a:F.column+1,j=M+L[0].length;if(p[l++]=(0,R.$5B)(new N.$Us(n+O,M,n+O,j),L,d),T(L.index)+L[0].length>=y||l>=u)return l}while(L);return l}findMatchesLineByLine(i,r,n,a){const t=[];let h=0;const s=new R.$8B(r.wordSeparators,r.regex);let d=this.H(i.startLineNumber,i.startColumn);if(d===null)return[];const u=this.H(i.endLineNumber,i.endColumn);if(u===null)return[];let l=this.s(d.node,d.remainder);const p=this.s(u.node,u.remainder);if(d.node===u.node)return this.findMatchesInNode(d.node,s,i.startLineNumber,i.startColumn,l,p,r,n,a,h,t),t;let I=i.startLineNumber,b=d.node;for(;b!==u.node;){const y=this.t(b.piece.bufferIndex,l,b.piece.end);if(y>=1){const F=this.a[b.piece.bufferIndex].lineStarts,z=this.u(b.piece.bufferIndex,b.piece.start),T=F[l.line+y],O=I===i.startLineNumber?i.startColumn:1;if(h=this.findMatchesInNode(b,s,I,O,l,this.s(b,T-z),r,n,a,h,t),h>=a)return t;I+=y}const L=I===i.startLineNumber?i.startColumn-1:0;if(I===i.endLineNumber){const F=this.getLineContent(I).substring(L,i.endColumn-1);return h=this.n(r,s,F,i.endLineNumber,L,h,t,n,a),t}if(h=this.n(r,s,this.getLineContent(I).substr(L),I,L,h,t,n,a),h>=a)return t;I++,d=this.H(I,1),b=d.node,l=this.s(d.node,d.remainder)}if(I===i.endLineNumber){const y=I===i.startLineNumber?i.startColumn-1:0,L=this.getLineContent(I).substring(y,i.endColumn-1);return h=this.n(r,s,L,i.endLineNumber,y,h,t,n,a),t}const m=I===i.startLineNumber?i.startColumn:1;return h=this.findMatchesInNode(u.node,s,I,m,l,p,r,n,a,h,t),t}n(i,r,n,a,t,h,s,d,u){const l=i.wordSeparators;if(!d&&i.simpleSearch){const I=i.simpleSearch,b=I.length,m=n.length;let y=-b;for(;(y=n.indexOf(I,y+b))!==-1;)if((!l||(0,R.$7B)(l,n,m,y,b))&&(s[h++]=new f.$av(new N.$Us(a,y+1+t,a,y+1+b+t),null),h>=u))return h;return h}let p;r.reset(0);do if(p=r.next(n),p&&(s[h++]=(0,R.$5B)(new N.$Us(a,p.index+1+t,a,p.index+1+p[0].length+t),p,d),h>=u))return h;while(p);return h}insert(i,r,n=!1){if(this.f=this.f&&n,this.j.lineNumber=0,this.j.value="",this.root!==P.$TB){const{node:a,remainder:t,nodeStartOffset:h}=this.G(i),s=a.piece,d=s.bufferIndex,u=this.s(a,t);if(a.piece.bufferIndex===0&&s.end.line===this.g.line&&s.end.column===this.g.column&&h+s.length===i&&r.length<v){this.F(a,r),this.y();return}if(h===i)this.o(r,a),this.h.validate(i);else if(h+a.piece.length>i){const l=[];let p=new w(s.bufferIndex,u,s.end,this.t(s.bufferIndex,u,s.end),this.u(d,s.end)-this.u(d,u));if(this.K()&&this.M(r)&&this.I(a,t)===10){const y={line:p.start.line+1,column:0};p=new w(p.bufferIndex,y,p.end,this.t(p.bufferIndex,y,p.end),p.length-1),r+=`
`}if(this.K()&&this.L(r))if(this.I(a,t-1)===13){const y=this.s(a,t-1);this.C(a,y),r="\r"+r,a.piece.length===0&&l.push(a)}else this.C(a,u);else this.C(a,u);const I=this.w(r);p.length>0&&this.S(a,p);let b=a;for(let m=0;m<I.length;m++)b=this.S(b,I[m]);this.v(l)}else this.q(r,a)}else{const a=this.w(r);let t=this.T(null,a[0]);for(let h=1;h<a.length;h++)t=this.S(t,a[h])}this.y()}delete(i,r){if(this.j.lineNumber=0,this.j.value="",r<=0||this.root===P.$TB)return;const n=this.G(i),a=this.G(i+r),t=n.node,h=a.node;if(t===h){const I=this.s(t,n.remainder),b=this.s(t,a.remainder);if(n.nodeStartOffset===i){if(r===t.piece.length){const m=t.next();(0,P.$YB)(this,t),this.N(m),this.y();return}this.D(t,b),this.h.validate(i),this.N(t),this.y();return}if(n.nodeStartOffset+t.piece.length===i+r){this.C(t,I),this.O(t),this.y();return}this.E(t,I,b),this.y();return}const s=[],d=this.s(t,n.remainder);this.C(t,d),this.h.validate(i),t.piece.length===0&&s.push(t);const u=this.s(h,a.remainder);this.D(h,u),h.piece.length===0&&s.push(h);const l=t.next();for(let I=l;I!==P.$TB&&I!==h;I=I.next())s.push(I);const p=t.piece.length===0?t.prev():t;this.v(s),this.O(p),this.y()}o(i,r){const n=[];if(this.K()&&this.M(i)&&this.L(r)){const h=r.piece,s={line:h.start.line+1,column:0},d=new w(h.bufferIndex,s,h.end,this.t(h.bufferIndex,s,h.end),h.length-1);r.piece=d,i+=`
`,(0,P.$1B)(this,r,-1,-1),r.piece.length===0&&n.push(r)}const a=this.w(i);let t=this.T(r,a[a.length-1]);for(let h=a.length-2;h>=0;h--)t=this.T(t,a[h]);this.N(t),this.v(n)}q(i,r){this.Q(i,r)&&(i+=`
`);const n=this.w(i),a=this.S(r,n[0]);let t=a;for(let h=1;h<n.length;h++)t=this.S(t,n[h]);this.N(a)}s(i,r,n){const a=i.piece,t=i.piece.bufferIndex,h=this.a[t].lineStarts,d=h[a.start.line]+a.start.column+r;let u=a.start.line,l=a.end.line,p=0,I=0,b=0;for(;u<=l&&(p=u+(l-u)/2|0,b=h[p],p!==l);)if(I=h[p+1],d<b)l=p-1;else if(d>=I)u=p+1;else break;return n?(n.line=p,n.column=d-b,null):{line:p,column:d-b}}t(i,r,n){if(n.column===0)return n.line-r.line;const a=this.a[i].lineStarts;if(n.line===a.length-1)return n.line-r.line;const t=a[n.line+1],h=a[n.line]+n.column;if(t>h+1)return n.line-r.line;const s=h-1;return this.a[i].buffer.charCodeAt(s)===13?n.line-r.line+1:n.line-r.line}u(i,r){return this.a[i].lineStarts[r.line]+r.column}v(i){for(let r=0;r<i.length;r++)(0,P.$YB)(this,i[r])}w(i){if(i.length>v){const l=[];for(;i.length>v;){const I=i.charCodeAt(v-1);let b;I===13||I>=55296&&I<=56319?(b=i.substring(0,v-1),i=i.substring(v-1)):(b=i.substring(0,v),i=i.substring(v));const m=A(b);l.push(new w(this.a.length,{line:0,column:0},{line:m.length-1,column:b.length-m[m.length-1]},m.length-1,b.length)),this.a.push(new E(b,m))}const p=A(i);return l.push(new w(this.a.length,{line:0,column:0},{line:p.length-1,column:i.length-p[p.length-1]},p.length-1,i.length)),this.a.push(new E(i,p)),l}let r=this.a[0].buffer.length;const n=A(i,!1);let a=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===r&&r!==0&&this.L(i)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},a=this.g;for(let l=0;l<n.length;l++)n[l]+=r+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+="_"+i,r+=1}else{if(r!==0)for(let l=0;l<n.length;l++)n[l]+=r;this.a[0].lineStarts=this.a[0].lineStarts.concat(n.slice(1)),this.a[0].buffer+=i}const t=this.a[0].buffer.length,h=this.a[0].lineStarts.length-1,s=t-this.a[0].lineStarts[h],d={line:h,column:s},u=new w(0,a,d,this.t(0,a,d),t-r);return this.g=d,[u]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(i,r=0){let n=this.root,a="";const t=this.h.get2(i);if(t){n=t.node;const h=this.B(n,i-t.nodeStartLineNumber-1),s=this.a[n.piece.bufferIndex].buffer,d=this.u(n.piece.bufferIndex,n.piece.start);if(t.nodeStartLineNumber+n.piece.lineFeedCnt===i)a=s.substring(d+h,d+n.piece.length);else{const u=this.B(n,i-t.nodeStartLineNumber);return s.substring(d+h,d+u-r)}}else{let h=0;const s=i;for(;n!==P.$TB;)if(n.left!==P.$TB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const d=this.B(n,i-n.lf_left-2),u=this.B(n,i-n.lf_left-1),l=this.a[n.piece.bufferIndex].buffer,p=this.u(n.piece.bufferIndex,n.piece.start);return h+=n.size_left,this.h.set({node:n,nodeStartOffset:h,nodeStartLineNumber:s-(i-1-n.lf_left)}),l.substring(p+d,p+u-r)}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const d=this.B(n,i-n.lf_left-2),u=this.a[n.piece.bufferIndex].buffer,l=this.u(n.piece.bufferIndex,n.piece.start);a=u.substring(l+d,l+n.piece.length);break}else i-=n.lf_left+n.piece.lineFeedCnt,h+=n.size_left+n.piece.length,n=n.right}for(n=n.next();n!==P.$TB;){const h=this.a[n.piece.bufferIndex].buffer;if(n.piece.lineFeedCnt>0){const s=this.B(n,0),d=this.u(n.piece.bufferIndex,n.piece.start);return a+=h.substring(d,d+s-r),a}else{const s=this.u(n.piece.bufferIndex,n.piece.start);a+=h.substr(s,n.piece.length)}n=n.next()}return a}y(){let i=this.root,r=1,n=0;for(;i!==P.$TB;)r+=i.lf_left+i.piece.lineFeedCnt,n+=i.size_left+i.piece.length,i=i.right;this.b=r,this.c=n,this.h.validate(this.c)}A(i,r){const n=i.piece,a=this.s(i,r),t=a.line-n.start.line;if(this.u(n.bufferIndex,n.end)-this.u(n.bufferIndex,n.start)===r){const h=this.t(i.piece.bufferIndex,n.start,a);if(h!==t)return{index:h,remainder:0}}return{index:t,remainder:a.column}}B(i,r){if(r<0)return 0;const n=i.piece,a=this.a[n.bufferIndex].lineStarts,t=n.start.line+r+1;return t>n.end.line?a[n.end.line]+n.end.column-a[n.start.line]-n.start.column:a[t]-a[n.start.line]-n.start.column}C(i,r){const n=i.piece,a=n.lineFeedCnt,t=this.u(n.bufferIndex,n.end),h=r,s=this.u(n.bufferIndex,h),d=this.t(n.bufferIndex,n.start,h),u=d-a,l=s-t,p=n.length+l;i.piece=new w(n.bufferIndex,n.start,h,d,p),(0,P.$1B)(this,i,l,u)}D(i,r){const n=i.piece,a=n.lineFeedCnt,t=this.u(n.bufferIndex,n.start),h=r,s=this.t(n.bufferIndex,h,n.end),d=this.u(n.bufferIndex,h),u=s-a,l=t-d,p=n.length+l;i.piece=new w(n.bufferIndex,h,n.end,s,p),(0,P.$1B)(this,i,l,u)}E(i,r,n){const a=i.piece,t=a.start,h=a.end,s=a.length,d=a.lineFeedCnt,u=r,l=this.t(a.bufferIndex,a.start,u),p=this.u(a.bufferIndex,r)-this.u(a.bufferIndex,t);i.piece=new w(a.bufferIndex,a.start,u,l,p),(0,P.$1B)(this,i,p-s,l-d);const I=new w(a.bufferIndex,n,h,this.t(a.bufferIndex,n,h),this.u(a.bufferIndex,h)-this.u(a.bufferIndex,n)),b=this.S(i,I);this.N(b)}F(i,r){this.Q(r,i)&&(r+=`
`);const n=this.K()&&this.L(r)&&this.M(i),a=this.a[0].buffer.length;this.a[0].buffer+=r;const t=A(r,!1);for(let b=0;b<t.length;b++)t[b]+=a;if(n){const b=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:a-b}}this.a[0].lineStarts=this.a[0].lineStarts.concat(t.slice(1));const h=this.a[0].lineStarts.length-1,s=this.a[0].buffer.length-this.a[0].lineStarts[h],d={line:h,column:s},u=i.piece.length+r.length,l=i.piece.lineFeedCnt,p=this.t(0,i.piece.start,d),I=p-l;i.piece=new w(i.piece.bufferIndex,i.piece.start,d,p,u),this.g=d,(0,P.$1B)(this,i,r.length,I)}G(i){let r=this.root;const n=this.h.get(i);if(n)return{node:n.node,nodeStartOffset:n.nodeStartOffset,remainder:i-n.nodeStartOffset};let a=0;for(;r!==P.$TB;)if(r.size_left>i)r=r.left;else if(r.size_left+r.piece.length>=i){a+=r.size_left;const t={node:r,remainder:i-r.size_left,nodeStartOffset:a};return this.h.set(t),t}else i-=r.size_left+r.piece.length,a+=r.size_left+r.piece.length,r=r.right;return null}H(i,r){let n=this.root,a=0;for(;n!==P.$TB;)if(n.left!==P.$TB&&n.lf_left>=i-1)n=n.left;else if(n.lf_left+n.piece.lineFeedCnt>i-1){const t=this.B(n,i-n.lf_left-2),h=this.B(n,i-n.lf_left-1);return a+=n.size_left,{node:n,remainder:Math.min(t+r-1,h),nodeStartOffset:a}}else if(n.lf_left+n.piece.lineFeedCnt===i-1){const t=this.B(n,i-n.lf_left-2);if(t+r-1<=n.piece.length)return{node:n,remainder:t+r-1,nodeStartOffset:a};r-=n.piece.length-t;break}else i-=n.lf_left+n.piece.lineFeedCnt,a+=n.size_left+n.piece.length,n=n.right;for(n=n.next();n!==P.$TB;){if(n.piece.lineFeedCnt>0){const t=this.B(n,0),h=this.J(n);return{node:n,remainder:Math.min(r-1,t),nodeStartOffset:h}}else if(n.piece.length>=r-1){const t=this.J(n);return{node:n,remainder:r-1,nodeStartOffset:t}}else r-=n.piece.length;n=n.next()}return null}I(i,r){if(i.piece.lineFeedCnt<1)return-1;const n=this.a[i.piece.bufferIndex],a=this.u(i.piece.bufferIndex,i.piece.start)+r;return n.buffer.charCodeAt(a)}J(i){if(!i)return 0;let r=i.size_left;for(;i!==this.root;)i.parent.right===i&&(r+=i.parent.size_left+i.parent.piece.length),i=i.parent;return r}K(){return!(this.f&&this.d===`
`)}L(i){if(typeof i=="string")return i.charCodeAt(0)===10;if(i===P.$TB||i.piece.lineFeedCnt===0)return!1;const r=i.piece,n=this.a[r.bufferIndex].lineStarts,a=r.start.line,t=n[a]+r.start.column;return a===n.length-1||n[a+1]>t+1?!1:this.a[r.bufferIndex].buffer.charCodeAt(t)===10}M(i){return typeof i=="string"?i.charCodeAt(i.length-1)===13:i===P.$TB||i.piece.lineFeedCnt===0?!1:this.I(i,i.piece.length-1)===13}N(i){if(this.K()&&this.L(i)){const r=i.prev();this.M(r)&&this.P(r,i)}}O(i){if(this.K()&&this.M(i)){const r=i.next();this.L(r)&&this.P(i,r)}}P(i,r){const n=[],a=this.a[i.piece.bufferIndex].lineStarts;let t;i.piece.end.column===0?t={line:i.piece.end.line-1,column:a[i.piece.end.line]-a[i.piece.end.line-1]-1}:t={line:i.piece.end.line,column:i.piece.end.column-1};const h=i.piece.length-1,s=i.piece.lineFeedCnt-1;i.piece=new w(i.piece.bufferIndex,i.piece.start,t,s,h),(0,P.$1B)(this,i,-1,-1),i.piece.length===0&&n.push(i);const d={line:r.piece.start.line+1,column:0},u=r.piece.length-1,l=this.t(r.piece.bufferIndex,d,r.piece.end);r.piece=new w(r.piece.bufferIndex,d,r.piece.end,l,u),(0,P.$1B)(this,r,-1,-1),r.piece.length===0&&n.push(r);const p=this.w(`\r
`);this.S(i,p[0]);for(let I=0;I<n.length;I++)(0,P.$YB)(this,n[I])}Q(i,r){if(this.K()&&this.M(i)){const n=r.next();if(this.L(n)){if(i+=`
`,n.piece.length===1)(0,P.$YB)(this,n);else{const a=n.piece,t={line:a.start.line+1,column:0},h=a.length-1,s=this.t(a.bufferIndex,t,a.end);n.piece=new w(a.bufferIndex,t,a.end,s,h),(0,P.$1B)(this,n,-1,-1)}return!0}}return!1}iterate(i,r){if(i===P.$TB)return r(P.$TB);const n=this.iterate(i.left,r);return n&&r(i)&&this.iterate(i.right,r)}R(i){if(i===P.$TB)return"";const r=this.a[i.piece.bufferIndex],n=i.piece,a=this.u(n.bufferIndex,n.start),t=this.u(n.bufferIndex,n.end);return r.buffer.substring(a,t)}getPieceContent(i){const r=this.a[i.bufferIndex],n=this.u(i.bufferIndex,i.start),a=this.u(i.bufferIndex,i.end);return r.buffer.substring(n,a)}S(i,r){const n=new P.$SB(r,1);if(n.left=P.$TB,n.right=P.$TB,n.parent=P.$TB,n.size_left=0,n.lf_left=0,this.root===P.$TB)this.root=n,n.color=0;else if(i.right===P.$TB)i.right=n,n.parent=i;else{const t=(0,P.$UB)(i.right);t.left=n,n.parent=t}return(0,P.$ZB)(this,n),n}T(i,r){const n=new P.$SB(r,1);if(n.left=P.$TB,n.right=P.$TB,n.parent=P.$TB,n.size_left=0,n.lf_left=0,this.root===P.$TB)this.root=n,n.color=0;else if(i.left===P.$TB)i.left=n,n.parent=i;else{const a=(0,P.$VB)(i.left);a.right=n,n.parent=a}return(0,P.$ZB)(this,n),n}U(i){let r="";return this.iterate(i,n=>(r+=this.R(n),!0)),r}}e.$aC=g}),define(ke[177],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$t8=e.$s8=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(P){if(P&&this.a.has(P)){const R=this.a.get(P);return this.a.delete(P),R}}addDragOperationTransfer(P,R){this.a.set(P,R)}}e.$s8=C;class N{constructor(P){this.identifier=P}}e.$t8=N}),define(ke[178],Se([1,0,4,3]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tt=void 0;class f{constructor(){this.a=new Map,this.b=new Map,this.c=new C.$Vd,this.onDidChange=this.c.event,this.d=null}handleChange(v){this.c.fire({changedLanguages:v,changedColorMap:!1})}register(v,$){return this.a.set(v,$),this.handleChange([v]),(0,N.$Rc)(()=>{this.a.get(v)===$&&(this.a.delete(v),this.handleChange([v]))})}get(v){return this.a.get(v)||null}registerFactory(v,$){this.b.get(v)?.dispose();const k=new P(this,v,$);return this.b.set(v,k),(0,N.$Rc)(()=>{const A=this.b.get(v);!A||A!==k||(this.b.delete(v),A.dispose())})}async getOrCreate(v){const $=this.get(v);if($)return $;const k=this.b.get(v);return!k||k.isResolved?null:(await k.resolve(),this.get(v))}isResolved(v){if(this.get(v))return!0;const k=this.b.get(v);return!!(!k||k.isResolved)}setColorMap(v){this.d=v,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.$tt=f;class P extends N.$Tc{get isResolved(){return this.c}constructor(v,$,k){super(),this.f=v,this.g=$,this.h=k,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.j()),this.b}async j(){const v=await this.h.tokenizationSupport;this.c=!0,v&&!this.a&&this.B(this.f.register(this.g,v))}}}),define(ke[179],Se([8,9]),function(ge,e){return ge.create("vs/base/common/actions",e)}),define(ke[180],Se([1,0,4,3,179]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pi=e.$Oi=e.$Ni=e.$Mi=e.$Li=e.$Ki=void 0;class P extends N.$Tc{constructor(w,E="",S="",c=!0,g){super(),this.h=this.B(new C.$Vd),this.onDidChange=this.h.event,this.w=!0,this.j=w,this.m=E,this.u=S,this.w=c,this.C=g}get id(){return this.j}get label(){return this.m}set label(w){this.D(w)}D(w){this.m!==w&&(this.m=w,this.h.fire({label:w}))}get tooltip(){return this.n||""}set tooltip(w){this.F(w)}F(w){this.n!==w&&(this.n=w,this.h.fire({tooltip:w}))}get class(){return this.u}set class(w){this.G(w)}G(w){this.u!==w&&(this.u=w,this.h.fire({class:w}))}get enabled(){return this.w}set enabled(w){this.H(w)}H(w){this.w!==w&&(this.w=w,this.h.fire({enabled:w}))}get checked(){return this.z}set checked(w){this.I(w)}I(w){this.z!==w&&(this.z=w,this.h.fire({checked:w}))}async run(w,E){this.C&&await this.C(w)}}e.$Ki=P;class R extends N.$Tc{constructor(){super(...arguments),this.f=this.B(new C.$Vd),this.onWillRun=this.f.event,this.m=this.B(new C.$Vd),this.onDidRun=this.m.event}async run(w,E){if(!w.enabled)return;this.f.fire({action:w});let S;try{await this.u(w,E)}catch(c){S=c}this.m.fire({action:w,error:S})}async u(w,E){await w.run(E)}}e.$Li=R;class v{constructor(){this.id=v.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...w){let E=[];for(const S of w)S.length&&(E.length?E=[...E,new v,...S]:E=S);return E}static{this.ID="vs.actions.separator"}async run(){}}e.$Mi=v;class ${get actions(){return this.a}constructor(w,E,S,c){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=w,this.label=E,this.class=c,this.a=S}async run(){}}e.$Ni=$;class k extends P{static{this.ID="vs.actions.empty"}constructor(){super(k.ID,f.localize(0,null),void 0,!1)}}e.$Oi=k;function A(D){return{id:D.id,label:D.label,class:D.class,enabled:D.enabled??!0,checked:D.checked??!1,run:async(...w)=>D.run(...w),tooltip:D.label}}e.$Pi=A}),define(ke[181],Se([8,9]),function(ge,e){return ge.create("vs/base/common/date",e)}),define(ke[182],Se([1,0,181]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wm=e.$vm=void 0;const N=60,f=N*60,P=f*24,R=P*7,v=P*30,$=P*365;function k(D,w,E,S){typeof D!="number"&&(D=D.getTime());const c=Math.round((new Date().getTime()-D)/1e3);if(c<-30)return(0,C.localize)(0,null,k(new Date().getTime()+c*1e3,!1));if(!S&&c<30)return(0,C.localize)(1,null);let g;return c<N?(g=c,w?g===1?E?(0,C.localize)(2,null,g):(0,C.localize)(3,null,g):E?(0,C.localize)(4,null,g):(0,C.localize)(5,null,g):g===1?E?(0,C.localize)(6,null,g):(0,C.localize)(7,null,g):E?(0,C.localize)(8,null,g):(0,C.localize)(9,null,g)):c<f?(g=Math.floor(c/N),w?g===1?E?(0,C.localize)(10,null,g):(0,C.localize)(11,null,g):E?(0,C.localize)(12,null,g):(0,C.localize)(13,null,g):g===1?E?(0,C.localize)(14,null,g):(0,C.localize)(15,null,g):E?(0,C.localize)(16,null,g):(0,C.localize)(17,null,g)):c<P?(g=Math.floor(c/f),w?g===1?E?(0,C.localize)(18,null,g):(0,C.localize)(19,null,g):E?(0,C.localize)(20,null,g):(0,C.localize)(21,null,g):g===1?E?(0,C.localize)(22,null,g):(0,C.localize)(23,null,g):E?(0,C.localize)(24,null,g):(0,C.localize)(25,null,g)):c<R?(g=Math.floor(c/P),w?g===1?(0,C.localize)(26,null,g):(0,C.localize)(27,null,g):g===1?(0,C.localize)(28,null,g):(0,C.localize)(29,null,g)):c<v?(g=Math.floor(c/R),w?g===1?E?(0,C.localize)(30,null,g):(0,C.localize)(31,null,g):E?(0,C.localize)(32,null,g):(0,C.localize)(33,null,g):g===1?E?(0,C.localize)(34,null,g):(0,C.localize)(35,null,g):E?(0,C.localize)(36,null,g):(0,C.localize)(37,null,g)):c<$?(g=Math.floor(c/v),w?g===1?E?(0,C.localize)(38,null,g):(0,C.localize)(39,null,g):E?(0,C.localize)(40,null,g):(0,C.localize)(41,null,g):g===1?E?(0,C.localize)(42,null,g):(0,C.localize)(43,null,g):E?(0,C.localize)(44,null,g):(0,C.localize)(45,null,g)):(g=Math.floor(c/$),w?g===1?E?(0,C.localize)(46,null,g):(0,C.localize)(47,null,g):E?(0,C.localize)(48,null,g):(0,C.localize)(49,null,g):g===1?E?(0,C.localize)(50,null,g):(0,C.localize)(51,null,g):E?(0,C.localize)(52,null,g):(0,C.localize)(53,null,g))}e.$vm=k;function A(D){return D.getFullYear()+"-"+String(D.getMonth()+1).padStart(2,"0")+"-"+String(D.getDate()).padStart(2,"0")+"T"+String(D.getHours()).padStart(2,"0")+":"+String(D.getMinutes()).padStart(2,"0")+":"+String(D.getSeconds()).padStart(2,"0")+"."+(D.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.$wm=A}),define(ke[183],Se([8,9]),function(ge,e){return ge.create("vs/base/common/errorMessage",e)}),define(ke[44],Se([1,0,19,18,183]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Si=e.$Ri=e.$Qi=void 0;function P(D,w){return w&&(D.stack||D.stacktrace)?f.localize(0,null,v(D),R(D.stack)||R(D.stacktrace)):v(D)}function R(D){return Array.isArray(D)?D.join(`
`):D}function v(D){return D.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${D.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof D.code=="string"&&typeof D.errno=="number"&&typeof D.syscall=="string"?f.localize(1,null,D.message):D.message||f.localize(2,null)}function $(D=null,w=!1){if(!D)return f.localize(3,null);if(Array.isArray(D)){const E=C.$Hb(D),S=$(E[0],w);return E.length>1?f.localize(4,null,S,E.length):S}if(N.$If(D))return D;if(D.detail){const E=D.detail;if(E.error)return P(E.error,w);if(E.exception)return P(E.exception,w)}return D.stack?P(D,w):D.message?D.message:f.localize(5,null)}e.$Qi=$;function k(D){const w=D;return w instanceof Error&&Array.isArray(w.actions)}e.$Ri=k;function A(D,w){let E;return typeof D=="string"?E=new Error(D):E=D,E.actions=w,E}e.$Si=A}),define(ke[184],Se([8,9]),function(ge,e){return ge.create("vs/base/common/platform",e)}),define(ke[10],Se([1,0,184]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$J=e.$I=e.$H=e.$G=e.$F=e.$E=e.$D=e.OS=e.OperatingSystem=e.$B=e.$A=e.$z=e.$y=e.$x=e.Language=e.$w=e.$v=e.$u=e.$t=e.$s=e.$r=e.$q=e.$p=e.$o=e.$n=e.$m=e.$l=e.$k=e.$j=e.$i=e.$h=e.Platform=e.$g=void 0,e.$g="en";let N=!1,f=!1,P=!1,R=!1,v=!1,$=!1,k=!1,A=!1,D=!1,w=!1,E,S=e.$g,c=e.$g,g,o;const i=globalThis;let r;typeof i.vscode<"u"&&typeof i.vscode.process<"u"?r=i.vscode.process:typeof process<"u"&&(r=process);const n=typeof r?.versions?.electron=="string",a=n&&r?.type==="renderer";if(typeof r=="object"){N=r.platform==="win32",f=r.platform==="darwin",P=r.platform==="linux",R=P&&!!r.env.SNAP&&!!r.env.SNAP_REVISION,k=n,D=!!r.env.CI||!!r.env.BUILD_ARTIFACTSTAGINGDIRECTORY,E=e.$g,S=e.$g;const m=r.env.VSCODE_NLS_CONFIG;if(m)try{const y=JSON.parse(m),L=y.availableLanguages["*"];E=y.locale,c=y.osLocale,S=L||e.$g,g=y._translationsConfigFile}catch{}v=!0}else typeof navigator=="object"&&!a?(o=navigator.userAgent,N=o.indexOf("Windows")>=0,f=o.indexOf("Macintosh")>=0,A=(o.indexOf("Macintosh")>=0||o.indexOf("iPad")>=0||o.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,P=o.indexOf("Linux")>=0,w=o?.indexOf("Mobi")>=0,$=!0,E=C.getConfiguredDefaultLocale(C.localize(0,null))||e.$g,S=E,c=navigator.language):console.error("Unable to resolve platform.");var t;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(t||(e.Platform=t={}));function h(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.$h=h;let s=0;f?s=1:N?s=3:P&&(s=2),e.$i=N,e.$j=f,e.$k=P,e.$l=R,e.$m=v,e.$n=k,e.$o=$,e.$p=$&&typeof i.importScripts=="function",e.$q=e.$p?i.origin:void 0,e.$r=A,e.$s=w,e.$t=D,e.$u=s,e.$v=o,e.$w=S;var d;(function(m){function y(){return e.$w}m.value=y;function L(){return e.$w.length===2?e.$w==="en":e.$w.length>=3?e.$w[0]==="e"&&e.$w[1]==="n"&&e.$w[2]==="-":!1}m.isDefaultVariant=L;function F(){return e.$w==="en"}m.isDefault=F})(d||(e.Language=d={})),e.$x=E,e.$y=c,e.$z=g,e.$A=typeof i.postMessage=="function"&&!i.importScripts,e.$B=(()=>{if(e.$A){const m=[];i.addEventListener("message",L=>{if(L.data&&L.data.vscodeScheduleAsyncWork)for(let F=0,z=m.length;F<z;F++){const T=m[F];if(T.id===L.data.vscodeScheduleAsyncWork){m.splice(F,1),T.callback();return}}});let y=0;return L=>{const F=++y;m.push({id:F,callback:L}),i.postMessage({vscodeScheduleAsyncWork:F},"*")}}return m=>setTimeout(m)})();var u;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(u||(e.OperatingSystem=u={})),e.OS=f||A?2:N?1:3;let l=!0,p=!1;function I(){if(!p){p=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,l=new Uint16Array(m.buffer)[0]===(2<<8)+1}return l}e.$D=I,e.$E=!!(e.$v&&e.$v.indexOf("Chrome")>=0),e.$F=!!(e.$v&&e.$v.indexOf("Firefox")>=0),e.$G=!!(!e.$E&&e.$v&&e.$v.indexOf("Safari")>=0),e.$H=!!(e.$v&&e.$v.indexOf("Edg/")>=0),e.$I=!!(e.$v&&e.$v.indexOf("Android")>=0);function b(m){return parseFloat(m)>=20}e.$J=b}),define(ke[49],Se([1,0,10]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ec=e.$dc=e.env=e.cwd=void 0;let N;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.process<"u"){const P=f.process;N={get platform(){return P.platform},get arch(){return P.arch},get env(){return P.env},cwd(){return P.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return C.$i?"win32":C.$j?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.$dc=N.platform,e.$ec=N.arch}),define(ke[17],Se([1,0,49]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tc=e.sep=e.$rc=e.$qc=e.$pc=e.$oc=e.$nc=e.$mc=e.$lc=e.$kc=e.$jc=e.$ic=e.$hc=e.$gc=e.$fc=void 0;const N=65,f=97,P=90,R=122,v=46,$=47,k=92,A=58,D=63;class w extends Error{constructor(h,s,d){let u;typeof s=="string"&&s.indexOf("not ")===0?(u="must not be",s=s.replace(/^not /,"")):u="must be";const l=h.indexOf(".")!==-1?"property":"argument";let p=`The "${h}" ${l} ${u} of type ${s}`;p+=`. Received type ${typeof d}`,super(p),this.code="ERR_INVALID_ARG_TYPE"}}function E(t,h){if(t===null||typeof t!="object")throw new w(h,"Object",t)}function S(t,h){if(typeof t!="string")throw new w(h,"string",t)}const c=C.$dc==="win32";function g(t){return t===$||t===k}function o(t){return t===$}function i(t){return t>=N&&t<=P||t>=f&&t<=R}function r(t,h,s,d){let u="",l=0,p=-1,I=0,b=0;for(let m=0;m<=t.length;++m){if(m<t.length)b=t.charCodeAt(m);else{if(d(b))break;b=$}if(d(b)){if(!(p===m-1||I===1))if(I===2){if(u.length<2||l!==2||u.charCodeAt(u.length-1)!==v||u.charCodeAt(u.length-2)!==v){if(u.length>2){const y=u.lastIndexOf(s);y===-1?(u="",l=0):(u=u.slice(0,y),l=u.length-1-u.lastIndexOf(s)),p=m,I=0;continue}else if(u.length!==0){u="",l=0,p=m,I=0;continue}}h&&(u+=u.length>0?`${s}..`:"..",l=2)}else u.length>0?u+=`${s}${t.slice(p+1,m)}`:u=t.slice(p+1,m),l=m-p-1;p=m,I=0}else b===v&&I!==-1?++I:I=-1}return u}function n(t,h){E(h,"pathObject");const s=h.dir||h.root,d=h.base||`${h.name||""}${h.ext||""}`;return s?s===h.root?`${s}${d}`:`${s}${t}${d}`:d}e.$fc={resolve(...t){let h="",s="",d=!1;for(let u=t.length-1;u>=-1;u--){let l;if(u>=0){if(l=t[u],S(l,"path"),l.length===0)continue}else h.length===0?l=C.cwd():(l=C.env[`=${h}`]||C.cwd(),(l===void 0||l.slice(0,2).toLowerCase()!==h.toLowerCase()&&l.charCodeAt(2)===k)&&(l=`${h}\\`));const p=l.length;let I=0,b="",m=!1;const y=l.charCodeAt(0);if(p===1)g(y)&&(I=1,m=!0);else if(g(y))if(m=!0,g(l.charCodeAt(1))){let L=2,F=L;for(;L<p&&!g(l.charCodeAt(L));)L++;if(L<p&&L!==F){const z=l.slice(F,L);for(F=L;L<p&&g(l.charCodeAt(L));)L++;if(L<p&&L!==F){for(F=L;L<p&&!g(l.charCodeAt(L));)L++;(L===p||L!==F)&&(b=`\\\\${z}\\${l.slice(F,L)}`,I=L)}}}else I=1;else i(y)&&l.charCodeAt(1)===A&&(b=l.slice(0,2),I=2,p>2&&g(l.charCodeAt(2))&&(m=!0,I=3));if(b.length>0)if(h.length>0){if(b.toLowerCase()!==h.toLowerCase())continue}else h=b;if(d){if(h.length>0)break}else if(s=`${l.slice(I)}\\${s}`,d=m,m&&h.length>0)break}return s=r(s,!d,"\\",g),d?`${h}\\${s}`:`${h}${s}`||"."},normalize(t){S(t,"path");const h=t.length;if(h===0)return".";let s=0,d,u=!1;const l=t.charCodeAt(0);if(h===1)return o(l)?"\\":t;if(g(l))if(u=!0,g(t.charCodeAt(1))){let I=2,b=I;for(;I<h&&!g(t.charCodeAt(I));)I++;if(I<h&&I!==b){const m=t.slice(b,I);for(b=I;I<h&&g(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&!g(t.charCodeAt(I));)I++;if(I===h)return`\\\\${m}\\${t.slice(b)}\\`;I!==b&&(d=`\\\\${m}\\${t.slice(b,I)}`,s=I)}}}else s=1;else i(l)&&t.charCodeAt(1)===A&&(d=t.slice(0,2),s=2,h>2&&g(t.charCodeAt(2))&&(u=!0,s=3));let p=s<h?r(t.slice(s),!u,"\\",g):"";return p.length===0&&!u&&(p="."),p.length>0&&g(t.charCodeAt(h-1))&&(p+="\\"),d===void 0?u?`\\${p}`:p:u?`${d}\\${p}`:`${d}${p}`},isAbsolute(t){S(t,"path");const h=t.length;if(h===0)return!1;const s=t.charCodeAt(0);return g(s)||h>2&&i(s)&&t.charCodeAt(1)===A&&g(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let h,s;for(let l=0;l<t.length;++l){const p=t[l];S(p,"path"),p.length>0&&(h===void 0?h=s=p:h+=`\\${p}`)}if(h===void 0)return".";let d=!0,u=0;if(typeof s=="string"&&g(s.charCodeAt(0))){++u;const l=s.length;l>1&&g(s.charCodeAt(1))&&(++u,l>2&&(g(s.charCodeAt(2))?++u:d=!1))}if(d){for(;u<h.length&&g(h.charCodeAt(u));)u++;u>=2&&(h=`\\${h.slice(u)}`)}return e.$fc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h)return"";const s=e.$fc.resolve(t),d=e.$fc.resolve(h);if(s===d||(t=s.toLowerCase(),h=d.toLowerCase(),t===h))return"";let u=0;for(;u<t.length&&t.charCodeAt(u)===k;)u++;let l=t.length;for(;l-1>u&&t.charCodeAt(l-1)===k;)l--;const p=l-u;let I=0;for(;I<h.length&&h.charCodeAt(I)===k;)I++;let b=h.length;for(;b-1>I&&h.charCodeAt(b-1)===k;)b--;const m=b-I,y=p<m?p:m;let L=-1,F=0;for(;F<y;F++){const T=t.charCodeAt(u+F);if(T!==h.charCodeAt(I+F))break;T===k&&(L=F)}if(F!==y){if(L===-1)return d}else{if(m>y){if(h.charCodeAt(I+F)===k)return d.slice(I+F+1);if(F===2)return d.slice(I+F)}p>y&&(t.charCodeAt(u+F)===k?L=F:F===2&&(L=3)),L===-1&&(L=0)}let z="";for(F=u+L+1;F<=l;++F)(F===l||t.charCodeAt(F)===k)&&(z+=z.length===0?"..":"\\..");return I+=L,z.length>0?`${z}${d.slice(I,b)}`:(d.charCodeAt(I)===k&&++I,d.slice(I,b))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const h=e.$fc.resolve(t);if(h.length<=2)return t;if(h.charCodeAt(0)===k){if(h.charCodeAt(1)===k){const s=h.charCodeAt(2);if(s!==D&&s!==v)return`\\\\?\\UNC\\${h.slice(2)}`}}else if(i(h.charCodeAt(0))&&h.charCodeAt(1)===A&&h.charCodeAt(2)===k)return`\\\\?\\${h}`;return t},dirname(t){S(t,"path");const h=t.length;if(h===0)return".";let s=-1,d=0;const u=t.charCodeAt(0);if(h===1)return g(u)?t:".";if(g(u)){if(s=d=1,g(t.charCodeAt(1))){let I=2,b=I;for(;I<h&&!g(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&g(t.charCodeAt(I));)I++;if(I<h&&I!==b){for(b=I;I<h&&!g(t.charCodeAt(I));)I++;if(I===h)return t;I!==b&&(s=d=I+1)}}}}else i(u)&&t.charCodeAt(1)===A&&(s=h>2&&g(t.charCodeAt(2))?3:2,d=s);let l=-1,p=!0;for(let I=h-1;I>=d;--I)if(g(t.charCodeAt(I))){if(!p){l=I;break}}else p=!1;if(l===-1){if(s===-1)return".";l=s}return t.slice(0,l)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let s=0,d=-1,u=!0,l;if(t.length>=2&&i(t.charCodeAt(0))&&t.charCodeAt(1)===A&&(s=2),h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let p=h.length-1,I=-1;for(l=t.length-1;l>=s;--l){const b=t.charCodeAt(l);if(g(b)){if(!u){s=l+1;break}}else I===-1&&(u=!1,I=l+1),p>=0&&(b===h.charCodeAt(p)?--p===-1&&(d=l):(p=-1,d=I))}return s===d?d=I:d===-1&&(d=t.length),t.slice(s,d)}for(l=t.length-1;l>=s;--l)if(g(t.charCodeAt(l))){if(!u){s=l+1;break}}else d===-1&&(u=!1,d=l+1);return d===-1?"":t.slice(s,d)},extname(t){S(t,"path");let h=0,s=-1,d=0,u=-1,l=!0,p=0;t.length>=2&&t.charCodeAt(1)===A&&i(t.charCodeAt(0))&&(h=d=2);for(let I=t.length-1;I>=h;--I){const b=t.charCodeAt(I);if(g(b)){if(!l){d=I+1;break}continue}u===-1&&(l=!1,u=I+1),b===v?s===-1?s=I:p!==1&&(p=1):s!==-1&&(p=-1)}return s===-1||u===-1||p===0||p===1&&s===u-1&&s===d+1?"":t.slice(s,u)},format:n.bind(null,"\\"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.length;let d=0,u=t.charCodeAt(0);if(s===1)return g(u)?(h.root=h.dir=t,h):(h.base=h.name=t,h);if(g(u)){if(d=1,g(t.charCodeAt(1))){let L=2,F=L;for(;L<s&&!g(t.charCodeAt(L));)L++;if(L<s&&L!==F){for(F=L;L<s&&g(t.charCodeAt(L));)L++;if(L<s&&L!==F){for(F=L;L<s&&!g(t.charCodeAt(L));)L++;L===s?d=L:L!==F&&(d=L+1)}}}}else if(i(u)&&t.charCodeAt(1)===A){if(s<=2)return h.root=h.dir=t,h;if(d=2,g(t.charCodeAt(2))){if(s===3)return h.root=h.dir=t,h;d=3}}d>0&&(h.root=t.slice(0,d));let l=-1,p=d,I=-1,b=!0,m=t.length-1,y=0;for(;m>=d;--m){if(u=t.charCodeAt(m),g(u)){if(!b){p=m+1;break}continue}I===-1&&(b=!1,I=m+1),u===v?l===-1?l=m:y!==1&&(y=1):l!==-1&&(y=-1)}return I!==-1&&(l===-1||y===0||y===1&&l===I-1&&l===p+1?h.base=h.name=t.slice(p,I):(h.name=t.slice(p,l),h.base=t.slice(p,I),h.ext=t.slice(l,I))),p>0&&p!==d?h.dir=t.slice(0,p-1):h.dir=h.root,h},sep:"\\",delimiter:";",win32:null,posix:null};const a=(()=>{if(c){const t=/\\/g;return()=>{const h=C.cwd().replace(t,"/");return h.slice(h.indexOf("/"))}}return()=>C.cwd()})();e.$gc={resolve(...t){let h="",s=!1;for(let d=t.length-1;d>=-1&&!s;d--){const u=d>=0?t[d]:a();S(u,"path"),u.length!==0&&(h=`${u}/${h}`,s=u.charCodeAt(0)===$)}return h=r(h,!s,"/",o),s?`/${h}`:h.length>0?h:"."},normalize(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$,s=t.charCodeAt(t.length-1)===$;return t=r(t,!h,"/",o),t.length===0?h?"/":s?"./":".":(s&&(t+="/"),h?`/${t}`:t)},isAbsolute(t){return S(t,"path"),t.length>0&&t.charCodeAt(0)===$},join(...t){if(t.length===0)return".";let h;for(let s=0;s<t.length;++s){const d=t[s];S(d,"path"),d.length>0&&(h===void 0?h=d:h+=`/${d}`)}return h===void 0?".":e.$gc.normalize(h)},relative(t,h){if(S(t,"from"),S(h,"to"),t===h||(t=e.$gc.resolve(t),h=e.$gc.resolve(h),t===h))return"";const s=1,d=t.length,u=d-s,l=1,p=h.length-l,I=u<p?u:p;let b=-1,m=0;for(;m<I;m++){const L=t.charCodeAt(s+m);if(L!==h.charCodeAt(l+m))break;L===$&&(b=m)}if(m===I)if(p>I){if(h.charCodeAt(l+m)===$)return h.slice(l+m+1);if(m===0)return h.slice(l+m)}else u>I&&(t.charCodeAt(s+m)===$?b=m:m===0&&(b=0));let y="";for(m=s+b+1;m<=d;++m)(m===d||t.charCodeAt(m)===$)&&(y+=y.length===0?"..":"/..");return`${y}${h.slice(l+b)}`},toNamespacedPath(t){return t},dirname(t){if(S(t,"path"),t.length===0)return".";const h=t.charCodeAt(0)===$;let s=-1,d=!0;for(let u=t.length-1;u>=1;--u)if(t.charCodeAt(u)===$){if(!d){s=u;break}}else d=!1;return s===-1?h?"/":".":h&&s===1?"//":t.slice(0,s)},basename(t,h){h!==void 0&&S(h,"ext"),S(t,"path");let s=0,d=-1,u=!0,l;if(h!==void 0&&h.length>0&&h.length<=t.length){if(h===t)return"";let p=h.length-1,I=-1;for(l=t.length-1;l>=0;--l){const b=t.charCodeAt(l);if(b===$){if(!u){s=l+1;break}}else I===-1&&(u=!1,I=l+1),p>=0&&(b===h.charCodeAt(p)?--p===-1&&(d=l):(p=-1,d=I))}return s===d?d=I:d===-1&&(d=t.length),t.slice(s,d)}for(l=t.length-1;l>=0;--l)if(t.charCodeAt(l)===$){if(!u){s=l+1;break}}else d===-1&&(u=!1,d=l+1);return d===-1?"":t.slice(s,d)},extname(t){S(t,"path");let h=-1,s=0,d=-1,u=!0,l=0;for(let p=t.length-1;p>=0;--p){const I=t.charCodeAt(p);if(I===$){if(!u){s=p+1;break}continue}d===-1&&(u=!1,d=p+1),I===v?h===-1?h=p:l!==1&&(l=1):h!==-1&&(l=-1)}return h===-1||d===-1||l===0||l===1&&h===d-1&&h===s+1?"":t.slice(h,d)},format:n.bind(null,"/"),parse(t){S(t,"path");const h={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return h;const s=t.charCodeAt(0)===$;let d;s?(h.root="/",d=1):d=0;let u=-1,l=0,p=-1,I=!0,b=t.length-1,m=0;for(;b>=d;--b){const y=t.charCodeAt(b);if(y===$){if(!I){l=b+1;break}continue}p===-1&&(I=!1,p=b+1),y===v?u===-1?u=b:m!==1&&(m=1):u!==-1&&(m=-1)}if(p!==-1){const y=l===0&&s?1:l;u===-1||m===0||m===1&&u===p-1&&u===l+1?h.base=h.name=t.slice(y,p):(h.name=t.slice(y,u),h.base=t.slice(y,p),h.ext=t.slice(u,p))}return l>0?h.dir=t.slice(0,l-1):s&&(h.dir="/"),h},sep:"/",delimiter:":",win32:null,posix:null},e.$gc.win32=e.$fc.win32=e.$fc,e.$gc.posix=e.$fc.posix=e.$gc,e.$hc=c?e.$fc.normalize:e.$gc.normalize,e.$ic=c?e.$fc.isAbsolute:e.$gc.isAbsolute,e.$jc=c?e.$fc.join:e.$gc.join,e.$kc=c?e.$fc.resolve:e.$gc.resolve,e.$lc=c?e.$fc.relative:e.$gc.relative,e.$mc=c?e.$fc.dirname:e.$gc.dirname,e.$nc=c?e.$fc.basename:e.$gc.basename,e.$oc=c?e.$fc.extname:e.$gc.extname,e.$pc=c?e.$fc.format:e.$gc.format,e.$qc=c?e.$fc.parse:e.$gc.parse,e.$rc=c?e.$fc.toNamespacedPath:e.$gc.toNamespacedPath,e.sep=c?e.$fc.sep:e.$gc.sep,e.$tc=c?e.$fc.delimiter:e.$gc.delimiter}),define(ke[128],Se([1,0,43,17]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uq=e.$Tq=e.$Sq=e.$Rq=e.$Qq=e.$Pq=e.$Oq=e.$Nq=e.$Mq=e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0;const f=new C.$V(()=>{const I=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:I,collatorIsNumeric:I.resolvedOptions().numeric}}),P=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function v(I,b,m=!1){const y=I||"",L=b||"",F=f.value.collator.compare(y,L);return f.value.collatorIsNumeric&&F===0&&y!==L?y<L?-1:1:F}e.$Iq=v;function $(I,b){const m=P.value.collator;return I=I||"",b=b||"",n(m,I,b)}e.$Jq=$;function k(I,b){const m=P.value.collator;return I=I||"",b=b||"",s(I,b)||n(m,I,b)}e.$Kq=k;function A(I,b){const m=P.value.collator;return I=I||"",b=b||"",h(I,b)||n(m,I,b)}e.$Lq=A;function D(I,b){return I=I||"",b=b||"",I===b?0:I<b?-1:1}e.$Mq=D;function w(I,b){const[m,y]=i(I),[L,F]=i(b);let z=f.value.collator.compare(y,F);if(z===0){if(f.value.collatorIsNumeric&&y!==F)return y<F?-1:1;if(z=f.value.collator.compare(m,L),f.value.collatorIsNumeric&&z===0&&m!==L)return m<L?-1:1}return z}e.$Nq=w;function E(I,b){I=I||"",b=b||"";const m=r(I),y=r(b),L=P.value.collator,F=R.value.collator;return n(F,m,y)||n(L,I,b)}e.$Oq=E;function S(I,b){I=I||"",b=b||"";const m=r(I),y=r(b),L=P.value.collator,F=R.value.collator;return n(F,m,y)||s(I,b)||n(L,I,b)}e.$Pq=S;function c(I,b){I=I||"",b=b||"";const m=r(I),y=r(b),L=P.value.collator,F=R.value.collator;return n(F,m,y)||h(I,b)||n(L,I,b)}e.$Qq=c;function g(I,b){I=I||"",b=b||"";const m=r(I).toLowerCase(),y=r(b).toLowerCase();return m!==y?m<y?-1:1:I!==b?I<b?-1:1:0}e.$Rq=g;const o=/^(.*?)(\.([^.]*))?$/;function i(I,b=!1){const m=I?o.exec(I):[];let y=[m&&m[1]||"",m&&m[3]||""];return b&&(!y[0]&&y[1]||y[0]&&y[0].charAt(0)===".")&&(y=[y[0]+"."+y[1],""]),y}function r(I){const b=I?o.exec(I):[];return b&&b[1]&&b[1].charAt(0)!=="."&&b[3]||""}function n(I,b,m){const y=I.compare(b,m);return y!==0?y:b.length!==m.length?b.length<m.length?-1:1:0}function a(I){const b=I.charAt(0);return b.toLocaleUpperCase()!==b}function t(I){const b=I.charAt(0);return b.toLocaleLowerCase()!==b}function h(I,b){return a(I)&&t(b)?-1:t(I)&&a(b)?1:0}function s(I,b){return t(I)&&a(b)?-1:a(I)&&t(b)?1:0}function d(I,b,m=!1){return m||(I=I&&I.toLowerCase(),b=b&&b.toLowerCase()),I===b?0:I<b?-1:1}function u(I,b,m=!1){const y=I.split(N.sep),L=b.split(N.sep),F=y.length-1,z=L.length-1;let T,O;for(let M=0;;M++){if(T=F===M,O=z===M,T&&O)return v(y[M],L[M],m);if(T)return-1;if(O)return 1;const j=d(y[M],L[M],m);if(j!==0)return j}}e.$Sq=u;function l(I,b,m){const y=I.toLowerCase(),L=b.toLowerCase(),F=p(I,b,m);if(F)return F;const z=y.endsWith(m),T=L.endsWith(m);if(z!==T)return z?-1:1;const O=v(y,L);return O!==0?O:y.localeCompare(L)}e.$Tq=l;function p(I,b,m){const y=I.toLowerCase(),L=b.toLowerCase(),F=y.startsWith(m),z=L.startsWith(m);if(F!==z)return F?-1:1;if(F&&z){if(y.length<L.length)return-1;if(y.length>L.length)return 1}return 0}e.$Uq=p}),define(ke[34],Se([1,0,17,10,12,18]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function R(l){return l===47||l===92}e.$1f=R;function v(l){return l.replace(/[\\/]/g,C.$gc.sep)}e.$2f=v;function $(l){return l.indexOf("/")===-1&&(l=v(l)),/^[a-zA-Z]:(\/|$)/.test(l)&&(l="/"+l),l}e.$3f=$;function k(l,p=C.$gc.sep){if(!l)return"";const I=l.length,b=l.charCodeAt(0);if(R(b)){if(R(l.charCodeAt(1))&&!R(l.charCodeAt(2))){let y=3;const L=y;for(;y<I&&!R(l.charCodeAt(y));y++);if(L!==y&&!R(l.charCodeAt(y+1))){for(y+=1;y<I;y++)if(R(l.charCodeAt(y)))return l.slice(0,y+1).replace(/[\\/]/g,p)}}return p}else if(o(b)&&l.charCodeAt(1)===58)return R(l.charCodeAt(2))?l.slice(0,2)+p:l.slice(0,2);let m=l.indexOf("://");if(m!==-1){for(m+=3;m<I;m++)if(R(l.charCodeAt(m)))return l.slice(0,m+1)}return""}e.$4f=k;function A(l){if(!N.$i||!l||l.length<5)return!1;let p=l.charCodeAt(0);if(p!==92||(p=l.charCodeAt(1),p!==92))return!1;let I=2;const b=I;for(;I<l.length&&(p=l.charCodeAt(I),p!==92);I++);return!(b===I||(p=l.charCodeAt(I+1),isNaN(p)||p===92))}e.$5f=A;const D=/[\\/:\*\?"<>\|]/g,w=/[\\/]/g,E=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function S(l,p=N.$i){const I=p?D:w;return!(!l||l.length===0||/^\s+$/.test(l)||(I.lastIndex=0,I.test(l))||p&&E.test(l)||l==="."||l===".."||p&&l[l.length-1]==="."||p&&l.length!==l.trim().length||l.length>255)}e.$6f=S;function c(l,p,I){const b=l===p;return!I||b?b:!l||!p?!1:(0,f.$_e)(l,p)}e.$7f=c;function g(l,p,I,b=C.sep){if(l===p)return!0;if(!l||!p||p.length>l.length)return!1;if(I){if(!(0,f.$af)(l,p))return!1;if(p.length===l.length)return!0;let y=p.length;return p.charAt(p.length-1)===b&&y--,l.charAt(y)===b}return p.charAt(p.length-1)!==b&&(p+=b),l.indexOf(p)===0}e.$8f=g;function o(l){return l>=65&&l<=90||l>=97&&l<=122}e.$9f=o;function i(l,p){return N.$i&&l.endsWith(":")&&(l+=C.sep),(0,C.$ic)(l)||(l=(0,C.$jc)(p,l)),l=(0,C.$hc)(l),N.$i?(l=(0,f.$Ue)(l,C.sep),l.endsWith(":")&&(l+=C.sep)):(l=(0,f.$Ue)(l,C.sep),l||(l=C.sep)),l}e.$0f=i;function r(l){const p=(0,C.$hc)(l);return N.$i?l.length>3?!1:n(p)&&(l.length===2||p.charCodeAt(2)===92):p===C.$gc.sep}e.$$f=r;function n(l,p=N.$i){return p?o(l.charCodeAt(0))&&l.charCodeAt(1)===58:!1}e.$_f=n;function a(l,p=N.$i){return n(l,p)?l[0]:void 0}e.$ag=a;function t(l,p,I){return p.length>l.length?-1:l===p?0:(I&&(l=l.toLowerCase(),p=p.toLowerCase()),l.indexOf(p))}e.$bg=t;function h(l){const p=l.split(":");let I,b,m;for(const y of p){const L=Number(y);(0,P.$Mf)(L)?b===void 0?b=L:m===void 0&&(m=L):I=I?[I,y].join(":"):y}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:b!==void 0?b:void 0,column:m!==void 0?m:b!==void 0?1:void 0}}e.$cg=h;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",d="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function u(l,p,I=8){let b="";for(let y=0;y<I;y++){let L;y===0&&N.$i&&!p&&(I===3||I===4)?L=d:L=s,b+=L.charAt(Math.floor(Math.random()*L.length))}let m;return p?m=`${p}-${b}`:m=b,l?(0,C.$jc)(l,m):m}e.$dg=u}),define(ke[129],Se([1,0,128,123,54,17,10,12]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=e.$Zq=e.$Yq=e.$Xq=e.$Wq=e.$Vq=void 0;const $=0,k=[$,[]];function A(U,K,ue,X){if(!U||!K)return k;const Q=U.length,Z=K.length;if(Q<Z)return k;const le=U.toLowerCase();return D(K,ue,Z,U,le,Q,X)}e.$Vq=A;function D(U,K,ue,X,Q,Z,le){const re=[],$e=[];for(let ie=0;ie<ue;ie++){const ye=ie*Z,de=ye-Z,fe=ie>0,_=U[ie],ee=K[ie];for(let G=0;G<Z;G++){const x=G>0,me=ye+G,pe=me-1,Re=de+G-1,ve=x?re[pe]:0,Ie=fe&&x?re[Re]:0,B=fe&&x?$e[Re]:0;let Y;!Ie&&fe?Y=0:Y=w(_,ee,X,Q,G,B),Y&&Ie+Y>=ve&&(le||fe||Q.startsWith(K,G))?($e[me]=B+1,re[me]=Ie+Y):($e[me]=$,re[me]=ve)}}const oe=[];let J=ue-1,V=Z-1;for(;J>=0&&V>=0;){const ie=J*Z+V;$e[ie]===$||(oe.push(V),J--),V--}return[re[ue*Z-1],oe.reverse()]}function w(U,K,ue,X,Q,Z){let le=0;if(!E(K,X[Q]))return le;if(le+=1,Z>0&&(le+=Z*5),U===ue[Q]&&(le+=1),Q===0)le+=8;else{const re=S(ue.charCodeAt(Q-1));re?le+=re:(0,N.$Xj)(ue.charCodeAt(Q))&&Z===0&&(le+=2)}return le}function E(U,K){return U===K?!0:U==="/"||U==="\\"?K==="/"||K==="\\":!1}function S(U){switch(U){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const c=[void 0,[]];function g(U,K,ue=0,X=0){const Q=K;return Q.values&&Q.values.length>1?o(U,Q.values,ue,X):i(U,K,ue,X)}e.$Wq=g;function o(U,K,ue,X){let Q=0;const Z=[];for(const le of K){const[re,$e]=i(U,le,ue,X);if(typeof re!="number")return c;Q+=re,Z.push(...$e)}return[Q,I(Z)]}function i(U,K,ue,X){const Q=(0,N.$7j)(K.original,K.originalLowercase,ue,U,U.toLowerCase(),X,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,N.$4j)(Q)]:c}const r=Object.freeze({score:0}),n=1<<18,a=1<<17,t=1<<16;function h(U,K,ue,X){const Q=X.values?X.values:[X];return(0,f.$Ti)({[X.normalized]:{values:Q.map(le=>({value:le.normalized,expectContiguousMatch:le.expectContiguousMatch})),label:U,description:K,allowNonContiguousMatches:ue}})}function s(U,K,ue,X,Q){if(!U||!K.normalized)return r;const Z=X.getItemLabel(U);if(!Z)return r;const le=X.getItemDescription(U),re=h(Z,le,ue,K),$e=Q[re];if($e)return $e;const oe=d(Z,le,X.getItemPath(U),K,ue);return Q[re]=oe,oe}e.$Xq=s;function d(U,K,ue,X,Q){const Z=!ue||!X.containsPathSeparator;return ue&&(R.$k?X.pathNormalized===ue:(0,v.$_e)(X.pathNormalized,ue))?{score:n,labelMatch:[{start:0,end:U.length}],descriptionMatch:K?[{start:0,end:K.length}]:void 0}:X.values&&X.values.length>1?u(U,K,ue,X.values,Z,Q):l(U,K,ue,X,Z,Q)}function u(U,K,ue,X,Q,Z){let le=0;const re=[],$e=[];for(const oe of X){const{score:J,labelMatch:V,descriptionMatch:ie}=l(U,K,ue,oe,Q,Z);if(J===$)return r;le+=J,V&&re.push(...V),ie&&$e.push(...ie)}return{score:le,labelMatch:I(re),descriptionMatch:I($e)}}function l(U,K,ue,X,Q,Z){if(Q||!K){const[le,re]=A(U,X.normalized,X.normalizedLowercase,Z&&!X.expectContiguousMatch);if(le){const $e=(0,N.$Uj)(X.normalized,U);let oe;if($e){oe=a;const J=Math.round(X.normalized.length/U.length*100);oe+=J}else oe=t;return{score:oe+le,labelMatch:$e||p(re)}}}if(K){let le=K;ue&&(le=`${K}${P.sep}`);const re=le.length,$e=`${le}${U}`,[oe,J]=A($e,X.normalized,X.normalizedLowercase,Z&&!X.expectContiguousMatch);if(oe){const V=p(J),ie=[],ye=[];return V.forEach(de=>{de.start<re&&de.end>re?(ie.push({start:0,end:de.end-re}),ye.push({start:de.start,end:re})):de.start>=re?ie.push({start:de.start-re,end:de.end-re}):ye.push(de)}),{score:oe,labelMatch:ie,descriptionMatch:ye}}}return r}function p(U){const K=[];if(!U)return K;let ue;for(const X of U)ue&&ue.end===X?ue.end+=1:(ue={start:X,end:X+1},K.push(ue));return K}function I(U){const K=U.sort((Q,Z)=>Q.start-Z.start),ue=[];let X;for(const Q of K)!X||!b(X,Q)?(X=Q,ue.push(Q)):(X.start=Math.min(X.start,Q.start),X.end=Math.max(X.end,Q.end));return ue}function b(U,K){return!(U.end<K.start||K.end<U.start)}function m(U,K,ue,X,Q,Z){const le=s(U,ue,X,Q,Z),re=s(K,ue,X,Q,Z),$e=le.score,oe=re.score;if(($e===n||oe===n)&&$e!==oe)return $e===n?-1:1;if($e>t||oe>t){if($e!==oe)return $e>oe?-1:1;if($e<a&&oe<a){const _=L(le.labelMatch,re.labelMatch);if(_!==0)return _}const de=Q.getItemLabel(U)||"",fe=Q.getItemLabel(K)||"";if(de.length!==fe.length)return de.length-fe.length}if($e!==oe)return $e>oe?-1:1;const J=Array.isArray(le.labelMatch)&&le.labelMatch.length>0,V=Array.isArray(re.labelMatch)&&re.labelMatch.length>0;if(J&&!V)return-1;if(V&&!J)return 1;const ie=y(U,le,Q),ye=y(K,re,Q);return ie&&ye&&ie!==ye?ye>ie?-1:1:F(U,K,ue,Q)}e.$Yq=m;function y(U,K,ue){let X=-1,Q=-1;if(K.descriptionMatch&&K.descriptionMatch.length?X=K.descriptionMatch[0].start:K.labelMatch&&K.labelMatch.length&&(X=K.labelMatch[0].start),K.labelMatch&&K.labelMatch.length){if(Q=K.labelMatch[K.labelMatch.length-1].end,K.descriptionMatch&&K.descriptionMatch.length){const Z=ue.getItemDescription(U);Z&&(Q+=Z.length)}}else K.descriptionMatch&&K.descriptionMatch.length&&(Q=K.descriptionMatch[K.descriptionMatch.length-1].end);return Q-X}function L(U,K){if(!U&&!K||(!U||!U.length)&&(!K||!K.length))return 0;if(!K||!K.length)return-1;if(!U||!U.length)return 1;const ue=U[0].start,Q=U[U.length-1].end-ue,Z=K[0].start,re=K[K.length-1].end-Z;return Q===re?0:re<Q?1:-1}function F(U,K,ue,X){const Q=X.getItemLabel(U)||"",Z=X.getItemLabel(K)||"",le=X.getItemDescription(U),re=X.getItemDescription(K),$e=Q.length+(le?le.length:0),oe=Z.length+(re?re.length:0);if($e!==oe)return $e-oe;const J=X.getItemPath(U),V=X.getItemPath(K);return J&&V&&J.length!==V.length?J.length-V.length:Q!==Z?(0,C.$Tq)(Q,Z,ue.normalized):le&&re&&le!==re?(0,C.$Tq)(le,re,ue.normalized):J&&V&&J!==V?(0,C.$Tq)(J,V,ue.normalized):0}function z(U){return U.startsWith('"')&&U.endsWith('"')}const T=" ";function O(U){typeof U!="string"&&(U="");const K=U.toLowerCase(),{pathNormalized:ue,normalized:X,normalizedLowercase:Q}=M(U),Z=ue.indexOf(P.sep)>=0,le=z(U);let re;const $e=U.split(T);if($e.length>1)for(const oe of $e){const J=z(oe),{pathNormalized:V,normalized:ie,normalizedLowercase:ye}=M(oe);ie&&(re||(re=[]),re.push({original:oe,originalLowercase:oe.toLowerCase(),pathNormalized:V,normalized:ie,normalizedLowercase:ye,expectContiguousMatch:J}))}return{original:U,originalLowercase:K,pathNormalized:ue,normalized:X,normalizedLowercase:Q,values:re,containsPathSeparator:Z,expectContiguousMatch:le}}e.$Zq=O;function M(U){let K;R.$i?K=U.replace(/\//g,P.sep):K=U.replace(/\\/g,P.sep);const ue=(0,v.$We)(K).replace(/\s|"/g,"");return{pathNormalized:K,normalized:ue,normalizedLowercase:ue.toLowerCase()}}function j(U){return Array.isArray(U)?O(U.map(K=>K.original).join(T)):O(U.original)}e.$1q=j}),define(ke[101],Se([1,0,17]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$js=e.$is=e.$hs=e.$gs=e.$fs=void 0,e.$fs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},f={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function P(A){const D=(0,C.$oc)(A),w=N[D.toLowerCase()];return w!==void 0?w:R(A)}e.$gs=P;function R(A){const D=(0,C.$oc)(A);return f[D.toLowerCase()]}e.$hs=R;function v(A){for(const D in f)if(f[D]===A)return D}e.$is=v;const $=/^(.+)\/(.+?)(;.+)?$/;function k(A,D){const w=$.exec(A);return w?`${w[1].toLowerCase()}/${w[2].toLowerCase()}${w[3]??""}`:D?void 0:A}e.$js=k}),define(ke[102],Se([1,0,10]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sl=e.$Rl=e.TerminateResponseCode=e.Source=void 0;var N;(function(v){v[v.stdout=0]="stdout",v[v.stderr=1]="stderr"})(N||(e.Source=N={}));var f;(function(v){v[v.Success=0]="Success",v[v.Unknown=1]="Unknown",v[v.AccessDenied=2]="AccessDenied",v[v.ProcessNotFound=3]="ProcessNotFound"})(f||(e.TerminateResponseCode=f={}));function P(v,...$){const k=$.reduce((w,E)=>(w[E]=!0,w),{}),A=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(v).filter(w=>!k[w]).forEach(w=>{for(let E=0;E<A.length;E++)if(w.search(A[E])!==-1){delete v[w];break}})}e.$Rl=P;function R(v){v&&(delete v.DEBUG,C.$j&&delete v.DYLD_LIBRARY_PATH,C.$k&&delete v.LD_PRELOAD)}e.$Sl=R}),define(ke[2],Se([1,0,17,10]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wc=e.$vc=e.URI=void 0;const f=/^\w[\w\d+.-]*$/,P=/^\//,R=/^\/\//;function v(d,u){if(!d.scheme&&u)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${d.authority}", path: "${d.path}", query: "${d.query}", fragment: "${d.fragment}"}`);if(d.scheme&&!f.test(d.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(d.path){if(d.authority){if(!P.test(d.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(d.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function $(d,u){return!d&&!u?"file":d}function k(d,u){switch(d){case"https":case"http":case"file":u?u[0]!==D&&(u=D+u):u=D;break}return u}const A="",D="/",w=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class E{static isUri(u){return u instanceof E?!0:u?typeof u.authority=="string"&&typeof u.fragment=="string"&&typeof u.path=="string"&&typeof u.query=="string"&&typeof u.scheme=="string"&&typeof u.fsPath=="string"&&typeof u.with=="function"&&typeof u.toString=="function":!1}constructor(u,l,p,I,b,m=!1){typeof u=="object"?(this.scheme=u.scheme||A,this.authority=u.authority||A,this.path=u.path||A,this.query=u.query||A,this.fragment=u.fragment||A):(this.scheme=$(u,m),this.authority=l||A,this.path=k(this.scheme,p||A),this.query=I||A,this.fragment=b||A,v(this,m))}get fsPath(){return n(this,!1)}with(u){if(!u)return this;let{scheme:l,authority:p,path:I,query:b,fragment:m}=u;return l===void 0?l=this.scheme:l===null&&(l=A),p===void 0?p=this.authority:p===null&&(p=A),I===void 0?I=this.path:I===null&&(I=A),b===void 0?b=this.query:b===null&&(b=A),m===void 0?m=this.fragment:m===null&&(m=A),l===this.scheme&&p===this.authority&&I===this.path&&b===this.query&&m===this.fragment?this:new g(l,p,I,b,m)}static parse(u,l=!1){const p=w.exec(u);return p?new g(p[2]||A,s(p[4]||A),s(p[5]||A),s(p[7]||A),s(p[9]||A),l):new g(A,A,A,A,A)}static file(u){let l=A;if(N.$i&&(u=u.replace(/\\/g,D)),u[0]===D&&u[1]===D){const p=u.indexOf(D,2);p===-1?(l=u.substring(2),u=D):(l=u.substring(2,p),u=u.substring(p)||D)}return new g("file",l,u,A,A)}static from(u,l){return new g(u.scheme,u.authority,u.path,u.query,u.fragment,l)}static joinPath(u,...l){if(!u.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let p;return N.$i&&u.scheme==="file"?p=E.file(C.$fc.join(n(u,!0),...l)).path:p=C.$gc.join(u.path,...l),u.with({path:p})}toString(u=!1){return a(this,u)}toJSON(){return this}static revive(u){if(u){if(u instanceof E)return u;{const l=new g(u);return l._formatted=u.external??null,l._fsPath=u._sep===c?u.fsPath??null:null,l}}else return u}}e.URI=E;function S(d){return!d||typeof d!="object"?!1:typeof d.scheme=="string"&&(typeof d.authority=="string"||typeof d.authority>"u")&&(typeof d.path=="string"||typeof d.path>"u")&&(typeof d.query=="string"||typeof d.query>"u")&&(typeof d.fragment=="string"||typeof d.fragment>"u")}e.$vc=S;const c=N.$i?1:void 0;class g extends E{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=n(this,!1)),this._fsPath}toString(u=!1){return u?a(this,!0):(this._formatted||(this._formatted=a(this,!1)),this._formatted)}toJSON(){const u={$mid:1};return this._fsPath&&(u.fsPath=this._fsPath,u._sep=c),this._formatted&&(u.external=this._formatted),this.path&&(u.path=this.path),this.scheme&&(u.scheme=this.scheme),this.authority&&(u.authority=this.authority),this.query&&(u.query=this.query),this.fragment&&(u.fragment=this.fragment),u}}const o={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function i(d,u,l){let p,I=-1;for(let b=0;b<d.length;b++){const m=d.charCodeAt(b);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||u&&m===47||l&&m===91||l&&m===93||l&&m===58)I!==-1&&(p+=encodeURIComponent(d.substring(I,b)),I=-1),p!==void 0&&(p+=d.charAt(b));else{p===void 0&&(p=d.substr(0,b));const y=o[m];y!==void 0?(I!==-1&&(p+=encodeURIComponent(d.substring(I,b)),I=-1),p+=y):I===-1&&(I=b)}}return I!==-1&&(p+=encodeURIComponent(d.substring(I))),p!==void 0?p:d}function r(d){let u;for(let l=0;l<d.length;l++){const p=d.charCodeAt(l);p===35||p===63?(u===void 0&&(u=d.substr(0,l)),u+=o[p]):u!==void 0&&(u+=d[l])}return u!==void 0?u:d}function n(d,u){let l;return d.authority&&d.path.length>1&&d.scheme==="file"?l=`//${d.authority}${d.path}`:d.path.charCodeAt(0)===47&&(d.path.charCodeAt(1)>=65&&d.path.charCodeAt(1)<=90||d.path.charCodeAt(1)>=97&&d.path.charCodeAt(1)<=122)&&d.path.charCodeAt(2)===58?u?l=d.path.substr(1):l=d.path[1].toLowerCase()+d.path.substr(2):l=d.path,N.$i&&(l=l.replace(/\//g,"\\")),l}e.$wc=n;function a(d,u){const l=u?r:i;let p="",{scheme:I,authority:b,path:m,query:y,fragment:L}=d;if(I&&(p+=I,p+=":"),(b||I==="file")&&(p+=D,p+=D),b){let F=b.indexOf("@");if(F!==-1){const z=b.substr(0,F);b=b.substr(F+1),F=z.lastIndexOf(":"),F===-1?p+=l(z,!1,!1):(p+=l(z.substr(0,F),!1,!1),p+=":",p+=l(z.substr(F+1),!1,!0)),p+="@"}b=b.toLowerCase(),F=b.lastIndexOf(":"),F===-1?p+=l(b,!1,!0):(p+=l(b.substr(0,F),!1,!0),p+=b.substr(F))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const F=m.charCodeAt(1);F>=65&&F<=90&&(m=`/${String.fromCharCode(F+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const F=m.charCodeAt(0);F>=65&&F<=90&&(m=`${String.fromCharCode(F+32)}:${m.substr(2)}`)}p+=l(m,!0,!1)}return y&&(p+="?",p+=l(y,!1,!1)),L&&(p+="#",p+=u?L:i(L,!1,!1)),p}function t(d){try{return decodeURIComponent(d)}catch{return d.length>3?d.substr(0,3)+t(d.substr(3)):d}}const h=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(d){return d.match(h)?d.replace(h,u=>t(u)):d}}),define(ke[185],Se([1,0,2]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.$oq=e.$nq=e.$mq=void 0;function N(k){const A=k;return A&&typeof A.type=="string"&&typeof A.severity=="string"}e.$mq=N;function f(k){const A=[];let D;try{const w=JSON.parse(k.arguments),E=w[w.length-1];E&&E.__$stack&&(w.pop(),D=E.__$stack),A.push(...w)}catch{A.push("Unable to log remote console arguments",k.arguments)}return{args:A,stack:D}}e.$nq=f;function P(k){if(typeof k!="string")return P(f(k).stack);const A=k;if(A){const D=R(A),w=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(D||"");if(w&&w.length===4)return{uri:C.URI.file(w[1]),line:Number(w[2]),column:Number(w[3])}}}e.$oq=P;function R(k){if(!k)return k;const A=k.indexOf(`
`);return A===-1?k:k.substring(0,A)}function v(k,A){const{args:D,stack:w}=f(k),E=typeof D[0]=="string"&&D.length===1;let S=R(w);S&&(S=`(${S.trim()})`);let c=[];if(typeof D[0]=="string"?S&&E?c=[`%c[${A}] %c${D[0]} %c${S}`,$("blue"),$(""),$("grey")]:c=[`%c[${A}] %c${D[0]}`,$("blue"),$(""),...D.slice(1)]:c=[`%c[${A}]%`,$("blue"),...D],S&&!E&&c.push(S),typeof console[k.severity]!="function")throw new Error("Unknown console method");console[k.severity].apply(console,c)}e.log=v;function $(k){return`color: ${k}`}}),define(ke[56],Se([1,0,22,2]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ch=e.$Bh=e.$Ah=void 0;function f($){return JSON.stringify($,R)}e.$Ah=f;function P($){let k=JSON.parse($);return k=v(k),k}e.$Bh=P;function R($,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:k.flags}:k}function v($,k=0){if(!$||k>200)return $;if(typeof $=="object"){switch($.$mid){case 1:return N.URI.revive($);case 2:return new RegExp($.source,$.flags);case 17:return new Date($.source)}if($ instanceof C.$je||$ instanceof Uint8Array)return $;if(Array.isArray($))for(let A=0;A<$.length;++A)$[A]=v($[A],k+1);else for(const A in $)Object.hasOwnProperty.call($,A)&&($[A]=v($[A],k+1))}return $}e.$Ch=v}),define(ke[16],Se([1,0,14,10,12,2]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var R;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeManagedRemoteResource="vscode-managed-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.vscodeChatSesssion="vscode-chat-editor",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(R||(e.Schemas=R={}));function v(w,E){return P.URI.isUri(w)?(0,f.$_e)(w.scheme,E):(0,f.$af)(w,E+":")}e.$eg=v;function $(w,...E){return E.some(S=>v(w,S))}e.$fg=$,e.$gg="vscode-tkn",e.$hg="tkn";class k{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(E){this.d=E}setDelegate(E){this.e=E}setServerRootPath(E){this.f=`${E}/${R.vscodeRemoteResource}`}set(E,S,c){this.a[E]=S,this.b[E]=c}setConnectionToken(E,S){this.c[E]=S}getPreferredWebSchema(){return this.d}rewrite(E){if(this.e)try{return this.e(E)}catch(r){return C.$1(r),E}const S=E.authority;let c=this.a[S];c&&c.indexOf(":")!==-1&&c.indexOf("[")===-1&&(c=`[${c}]`);const g=this.b[S],o=this.c[S];let i=`path=${encodeURIComponent(E.path)}`;return typeof o=="string"&&(i+=`&${e.$hg}=${encodeURIComponent(o)}`),P.URI.from({scheme:N.$o?this.d:R.vscodeRemoteResource,authority:`${c}:${g}`,path:this.f,query:i})}}e.$ig=new k,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class A{static{this.a=e.$ng}asBrowserUri(E){const S=this.b(E,ge);return this.uriToBrowserUri(S)}uriToBrowserUri(E){return E.scheme===R.vscodeRemote?e.$ig.rewrite(E):E.scheme===R.file&&(N.$m||N.$q===`${R.vscodeFileResource}://${A.a}`)?E.with({scheme:R.vscodeFileResource,authority:E.authority||A.a,query:null,fragment:null}):E}asFileUri(E){const S=this.b(E,ge);return this.uriToFileUri(S)}uriToFileUri(E){return E.scheme===R.vscodeFileResource?E.with({scheme:R.file,authority:E.authority!==A.a?E.authority:null,query:null,fragment:null}):E}b(E,S){return P.URI.isUri(E)?E:P.URI.parse(S.toUrl(E))}}e.$og=new A;var D;(function(w){const E=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);w.CoopAndCoep=Object.freeze(E.get("3"));const S="vscode-coi";function c(o){let i;typeof o=="string"?i=new URL(o).searchParams:o instanceof URL?i=o.searchParams:P.URI.isUri(o)&&(i=new URL(o.toString(!0)).searchParams);const r=i?.get(S);if(r)return E.get(r)}w.getHeadersFromQuery=c;function g(o,i,r){if(!globalThis.crossOriginIsolated)return;const n=i&&r?"3":r?"2":"1";o instanceof URLSearchParams?o.set(S,n):o[S]=n}w.addSearchParam=g})(D||(e.COI=D={}))}),define(ke[186],Se([1,0,157,16,10,2]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0;class R{constructor(w,E,S){this.id=w,this.dependencies=E,this.callback=S}}class v{static{this.INSTANCE=new v}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(w,E,S)=>{typeof w!="string"&&(S=E,E=w,w=null),(typeof E!="object"||!Array.isArray(E))&&(S=E,E=null),this.c.push(new R(w,E,S))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){if(w.startsWith(window.location.origin)||w.startsWith("vscode-file://vscode-app"))return w;throw new Error(`[trusted_script_src] Invalid script url: ${w}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(w){return w}})))}async load(w){this.g();const E=await(this.a?this.i(w):this.b?this.h(w):this.j(w));if(!E)throw new Error(`Did not receive a define call from script ${w}`);if(Array.isArray(E.dependencies)&&E.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${w}. The dependencies are: ${E.dependencies.join(", ")}`);return typeof E.callback=="function"?E.callback([]):E.callback}h(w){return new Promise((E,S)=>{const c=document.createElement("script");c.setAttribute("async","async"),c.setAttribute("type","text/javascript");const g=()=>{c.removeEventListener("load",o),c.removeEventListener("error",i)},o=r=>{g(),E(this.c.pop())},i=r=>{g(),S(r)};c.addEventListener("load",o),c.addEventListener("error",i),this.f&&(w=this.f.createScriptURL(w)),c.setAttribute("src",w),window.document.getElementsByTagName("head")[0].appendChild(c)})}i(w){return new Promise((E,S)=>{try{this.f&&(w=this.f.createScriptURL(w)),importScripts(w),E(this.c.pop())}catch(c){S(c)}})}async j(w){try{const E=globalThis._VSCODE_NODE_MODULES.fs,S=globalThis._VSCODE_NODE_MODULES.vm,c=globalThis._VSCODE_NODE_MODULES.module,g=P.URI.parse(w).fsPath,o=E.readFileSync(g).toString(),i=c.wrap(o.replace(/^#!.*/,""));return new S.Script(i).runInThisContext().apply(),this.c.pop()}catch(E){throw E}}}const $=new Map;let k={};typeof globalThis.require=="object"&&(k=globalThis.require.paths??{});async function A(D,w,E){if(C.$T){E===void 0&&(E=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),k[D]&&(D=k[D]);const S=`${D}/${w}`;if($.has(S))return $.get(S);let c;if(/^\w[\w\d+.-]*:\/\//.test(S))c=S;else{const r=`${E&&!f.$o?N.$lg:N.$kg}/${S}`;c=N.$og.asBrowserUri(r).toString(!0)}const g=v.INSTANCE.load(c);return $.set(S,g),g}else return await new Promise((S,c)=>{ge([D],S,c)})}e.$fD=A}),define(ke[23],Se([1,0,34,16,17,10,12,2]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function $(E){return(0,v.$wc)(E,!0)}e.$vg=$;class k{constructor(S){this.a=S}compare(S,c,g=!1){return S===c?0:(0,R.$5e)(this.getComparisonKey(S,g),this.getComparisonKey(c,g))}isEqual(S,c,g=!1){return S===c?!0:!S||!c?!1:this.getComparisonKey(S,g)===this.getComparisonKey(c,g)}getComparisonKey(S,c=!1){return S.with({path:this.a(S)?S.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(S){return this.a(S)}isEqualOrParent(S,c,g=!1){if(S.scheme===c.scheme){if(S.scheme===N.Schemas.file)return C.$8f($(S),$(c),this.a(S))&&S.query===c.query&&(g||S.fragment===c.fragment);if((0,e.$Mg)(S.authority,c.authority))return C.$8f(S.path,c.path,this.a(S),"/")&&S.query===c.query&&(g||S.fragment===c.fragment)}return!1}joinPath(S,...c){return v.URI.joinPath(S,...c)}basenameOrAuthority(S){return(0,e.$Eg)(S)||S.authority}basename(S){return f.$gc.basename(S.path)}extname(S){return f.$gc.extname(S.path)}dirname(S){if(S.path.length===0)return S;let c;return S.scheme===N.Schemas.file?c=v.URI.file(f.$mc($(S))).path:(c=f.$gc.dirname(S.path),S.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${S.toString})) resulted in a relative path`),c="/")),S.with({path:c})}normalizePath(S){if(!S.path.length)return S;let c;return S.scheme===N.Schemas.file?c=v.URI.file(f.$hc($(S))).path:c=f.$gc.normalize(S.path),S.with({path:c})}relativePath(S,c){if(S.scheme!==c.scheme||!(0,e.$Mg)(S.authority,c.authority))return;if(S.scheme===N.Schemas.file){const i=f.$lc($(S),$(c));return P.$i?C.$2f(i):i}let g=S.path||"/";const o=c.path||"/";if(this.a(S)){let i=0;for(const r=Math.min(g.length,o.length);i<r&&!(g.charCodeAt(i)!==o.charCodeAt(i)&&g.charAt(i).toLowerCase()!==o.charAt(i).toLowerCase());i++);g=o.substr(0,i)+g.substr(i)}return f.$gc.relative(g,o)}resolvePath(S,c){if(S.scheme===N.Schemas.file){const g=v.URI.file(f.$kc($(S),c));return S.with({authority:g.authority,path:g.path})}return c=C.$3f(c),S.with({path:f.$gc.resolve(S.path,c)})}isAbsolutePath(S){return!!S.path&&S.path[0]==="/"}isEqualAuthority(S,c){return S===c||S!==void 0&&c!==void 0&&(0,R.$_e)(S,c)}hasTrailingPathSeparator(S,c=f.sep){if(S.scheme===N.Schemas.file){const g=$(S);return g.length>C.$4f(g).length&&g[g.length-1]===c}else{const g=S.path;return g.length>1&&g.charCodeAt(g.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(S.fsPath)}}removeTrailingPathSeparator(S,c=f.sep){return(0,e.$Ng)(S,c)?S.with({path:S.path.substr(0,S.path.length-1)}):S}addTrailingPathSeparator(S,c=f.sep){let g=!1;if(S.scheme===N.Schemas.file){const o=$(S);g=o!==void 0&&o.length===C.$4f(o).length&&o[o.length-1]===c}else{c="/";const o=S.path;g=o.length===1&&o.charCodeAt(o.length-1)===47}return!g&&!(0,e.$Ng)(S,c)?S.with({path:S.path+"/"}):S}}e.$wg=k,e.$xg=new k(()=>!1),e.$yg=new k(E=>E.scheme===N.Schemas.file?!P.$k:!0),e.$zg=new k(E=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function A(E,S){const c=[];for(let g=0;g<E.length;g++){const o=S(E[g]);E.some((i,r)=>r===g?!1:(0,e.$Bg)(o,S(i)))||c.push(E[g])}return c}e.$Qg=A;var D;(function(E){E.META_DATA_LABEL="label",E.META_DATA_DESCRIPTION="description",E.META_DATA_SIZE="size",E.META_DATA_MIME="mime";function S(c){const g=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(r=>{const[n,a]=r.split(":");n&&a&&g.set(n,a)});const i=c.path.substring(0,c.path.indexOf(";"));return i&&g.set(E.META_DATA_MIME,i),g}E.parseMetaData=S})(D||(e.DataUri=D={}));function w(E,S,c){if(S){let g=E.path;return g&&g[0]!==f.$gc.sep&&(g=f.$gc.sep+g),E.with({scheme:c,authority:S,path:g})}return E.with({scheme:c})}e.$Rg=w}),define(ke[11],Se([1,0,21,14,4,3,23,10,163,43]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function A(_){return!!_&&typeof _.then=="function"}e.$Sg=A;function D(_){const ee=new C.$6d,G=_(ee.token),x=new Promise((me,pe)=>{const Re=ee.token.onCancellationRequested(()=>{Re.dispose(),pe(new N.$5)});Promise.resolve(G).then(ve=>{Re.dispose(),ee.dispose(),me(ve)},ve=>{Re.dispose(),ee.dispose(),pe(ve)})});return new class{cancel(){ee.cancel(),ee.dispose()}then(me,pe){return x.then(me,pe)}catch(me){return this.then(void 0,me)}finally(me){return x.finally(me)}}}e.$Tg=D;function w(_,ee,G){return new Promise((x,me)=>{const pe=ee.onCancellationRequested(()=>{pe.dispose(),x(G)});_.then(x,me).finally(()=>pe.dispose())})}e.$Ug=w;function E(_,ee){return new Promise((G,x)=>{const me=ee.onCancellationRequested(()=>{me.dispose(),x(new N.$5)});_.then(G,x).finally(()=>me.dispose())})}e.$Vg=E;async function S(_){let ee=-1;const G=_.map((x,me)=>x.then(pe=>(ee=me,pe)));try{return await Promise.race(G)}finally{_.forEach((x,me)=>{me!==ee&&x.cancel()})}}e.$Wg=S;function c(_,ee,G){let x;const me=setTimeout(()=>{x?.(void 0),G?.()},ee);return Promise.race([_.finally(()=>clearTimeout(me)),new Promise(pe=>x=pe)])}e.$Xg=c;function g(_){return new Promise((ee,G)=>{const x=_();A(x)?x.then(ee,G):ee(x)})}e.$Yg=g;class o{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(ee){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=ee,!this.b){const G=()=>{if(this.b=null,this.f)return;const x=this.queue(this.d);return this.d=null,x};this.b=new Promise(x=>{this.a.then(G,G).then(x)})}return new Promise((G,x)=>{this.b.then(G,x)})}return this.a=ee(),new Promise((G,x)=>{this.a.then(me=>{this.a=null,G(me)},me=>{this.a=null,x(me)})})}dispose(){this.f=!0}}e.$Zg=o;class i{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.$1g=i;class r{constructor(){this.a=new Map}queue(ee,G){const me=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(G).finally(()=>{this.a.get(ee)===me&&this.a.delete(ee)});return this.a.set(ee,me),me}}e.$2g=r;const n=(_,ee)=>{let G=!0;const x=setTimeout(()=>{G=!1,ee()},_);return{isTriggered:()=>G,dispose:()=>{clearTimeout(x),G=!1}}},a=_=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,_())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class t{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,G=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((me,pe)=>{this.d=me,this.f=pe}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const x=()=>{this.a=null,this.d?.(null)};return this.a=G===$.$Sd?a(x):n(G,x),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=t;class h{constructor(ee){this.a=new t(ee),this.b=new o}trigger(ee,G){return this.a.trigger(()=>this.b.queue(ee),G)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=h;class s{constructor(){this.a=!1,this.b=new Promise((ee,G)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=s;class d extends s{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.$6g=d;function u(_,ee){return ee?new Promise((G,x)=>{const me=setTimeout(()=>{pe.dispose(),G()},_),pe=ee.onCancellationRequested(()=>{clearTimeout(me),pe.dispose(),x(new N.$5)})}):D(G=>u(_,G))}e.$7g=u;function l(_,ee=0,G){const x=setTimeout(()=>{_(),G&&me.dispose()},ee),me=(0,P.$Rc)(()=>{clearTimeout(x),G?.deleteAndLeak(me)});return G?.add(me),me}e.$8g=l;function p(_){const ee=[];let G=0;const x=_.length;function me(){return G<x?_[G++]():null}function pe(Re){Re!=null&&ee.push(Re);const ve=me();return ve?ve.then(pe):Promise.resolve(ee)}return Promise.resolve(null).then(pe)}e.$9g=p;function I(_,ee=x=>!!x,G=null){let x=0;const me=_.length,pe=()=>{if(x>=me)return Promise.resolve(G);const Re=_[x++];return Promise.resolve(Re()).then(Ie=>ee(Ie)?Promise.resolve(Ie):pe())};return pe()}e.$0g=I;function b(_,ee=x=>!!x,G=null){if(_.length===0)return Promise.resolve(G);let x=_.length;const me=()=>{x=-1;for(const pe of _)pe.cancel?.()};return new Promise((pe,Re)=>{for(const ve of _)ve.then(Ie=>{--x>=0&&ee(Ie)?(me(),pe(Ie)):x===0&&pe(G)}).catch(Ie=>{--x>=0&&(me(),Re(Ie))})})}e.$$g=b;class m{constructor(ee){this.a=0,this.b=!1,this.f=ee,this.g=[],this.d=0,this.h=new f.$Vd}whenIdle(){return this.size>0?f.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(ee){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((G,x)=>{this.g.push({factory:ee,c:G,e:x}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const ee=this.g.shift();this.d++;const G=ee.factory();G.then(ee.c,ee.e),G.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=m;class y extends m{constructor(){super(1)}}e.$ah=y;class L{constructor(){this.a=new Q,this.b=0}queue(ee){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,ee())):this.a.run(this.b++,ee())}}e.$bh=L;class F{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const ee=new re;return this.b.add(ee),ee.p}g(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueSize(ee,G=R.$xg){const x=G.getComparisonKey(ee);return this.a.get(x)?.size??0}queueFor(ee,G,x=R.$xg){const me=x.getComparisonKey(ee);let pe=this.a.get(me);if(!pe){pe=new y;const Re=this.f++,ve=f.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(me),this.h(),this.d?.deleteAndDispose(Re),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new P.$3c),this.d.set(Re,ve),this.a.set(me,pe)}return pe.queue(G)}h(){this.g()&&this.j()}j(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=F;class z{constructor(ee,G){this.a=-1,typeof ee=="function"&&typeof G=="number"&&this.setIfNotSet(ee,G)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,G){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},G)}setIfNotSet(ee,G){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},G))}}e.$dh=z;class T{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(ee,G,x=globalThis){this.cancel();const me=x.setInterval(()=>{ee()},G);this.d=(0,P.$Rc)(()=>{x.clearInterval(me),this.d=void 0})}dispose(){this.cancel()}}e.$eh=T;class O{constructor(ee,G){this.b=-1,this.a=ee,this.d=G,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=O;class M{constructor(ee,G){G%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${G}ms is not a multiple of 1000ms.`),this.a=ee,this.b=G,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=M;class j extends O{constructor(ee,G){super(ee,G),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.$hh=j;class U extends P.$Tc{constructor(ee,G){super(),this.g=ee,this.h=G,this.a=[],this.b=this.B(new P.$Uc),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const G of ee)this.a.push(G);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new O(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=U,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(_,ee)=>{(0,v.$B)(()=>{if(G)return;const x=Date.now()+15;ee(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,x-Date.now())}}))});let G=!1;return{dispose(){G||(G=!0)}}}:e.$kh=(_,ee,G)=>{const x=_.requestIdleCallback(ee,typeof G=="number"?{timeout:G}:void 0);let me=!1;return{dispose(){me||(me=!0,_.cancelIdleCallback(x))}}},e.$jh=_=>(0,e.$kh)(globalThis,_)}();class K{constructor(ee,G){this.g=!1,this.d=()=>{try{this.j=G()}catch(x){this.l=x}finally{this.g=!0}},this.f=(0,e.$kh)(ee,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=K;class ue extends K{constructor(ee){super(globalThis,ee)}}e.$mh=ue;async function X(_,ee,G){let x;for(let me=0;me<G;me++)try{return await _()}catch(pe){x=pe,await u(ee)}throw x}e.$nh=X;class Q{isRunning(ee){return typeof ee=="number"?this.a?.taskId===ee:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(ee,G,x){return this.a={taskId:ee,cancel:()=>x?.(),promise:G},G.then(()=>this.d(ee),()=>this.d(ee)),G}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}queue(ee){if(this.b)this.b.run=ee;else{let G,x;const me=new Promise((pe,Re)=>{G=pe,x=Re});this.b={run:ee,promise:me,promiseResolve:G,promiseReject:x}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=Q;class Z{constructor(ee,G=()=>Date.now()){this.d=ee,this.f=G,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.$ph=Z;var le;(function(_){_[_.Resolved=0]="Resolved",_[_.Rejected=1]="Rejected"})(le||(le={}));class re{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((ee,G)=>{this.a=ee,this.b=G})}complete(ee){return new Promise(G=>{this.a(ee),this.d={outcome:0,value:ee},G()})}error(ee){return new Promise(G=>{this.b(ee),this.d={outcome:1,value:ee},G()})}cancel(){return this.error(new N.$5)}}e.$qh=re;var $e;(function(_){async function ee(x){let me;const pe=await Promise.all(x.map(Re=>Re.then(ve=>ve,ve=>{me||(me=ve)})));if(typeof me<"u")throw me;return pe}_.settled=ee;function G(x){return new Promise(async(me,pe)=>{try{await x(me,pe)}catch(Re){pe(Re)}})}_.withAsyncBody=G})($e||(e.Promises=$e={}));class oe{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(ee){this.a=void 0,this.b=void 0,this.d=!1,this.promise=ee.then(G=>(this.a=G,this.d=!0,G),G=>{throw this.b=G,this.d=!0,G})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=oe;class J{constructor(ee){this.b=ee,this.a=new k.$V(()=>new oe(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=J;var V;(function(_){_[_.Initial=0]="Initial",_[_.DoneOK=1]="DoneOK",_[_.DoneError=2]="DoneError"})(V||(V={}));class ie{static fromArray(ee){return new ie(G=>{G.emitMany(ee)})}static fromPromise(ee){return new ie(async G=>{G.emitMany(await ee)})}static fromPromises(ee){return new ie(async G=>{await Promise.all(ee.map(async x=>G.emitOne(await x)))})}static merge(ee){return new ie(async G=>{await Promise.all(ee.map(async x=>{for await(const me of x)G.emitOne(me)}))})}static{this.EMPTY=ie.fromArray([])}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new f.$Vd,queueMicrotask(async()=>{const G={emitOne:x=>this.g(x),emitMany:x=>this.h(x),reject:x=>this.k(x)};try{await Promise.resolve(ee(G)),this.j()}catch(x){this.k(x)}finally{G.emitOne=void 0,G.emitMany=void 0,G.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await f.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,G){return new ie(async x=>{for await(const me of ee)x.emitOne(G(me))})}map(ee){return ie.map(this,ee)}static filter(ee,G){return new ie(async x=>{for await(const me of ee)G(me)&&x.emitOne(me)})}filter(ee){return ie.filter(this,ee)}static coalesce(ee){return ie.filter(ee,G=>!!G)}coalesce(){return ie.coalesce(this)}static async toPromise(ee){const G=[];for await(const x of ee)G.push(x);return G}toPromise(){return ie.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}e.$th=ie;class ye extends ie{constructor(ee,G){super(G),this.l=ee}cancel(){this.l.cancel()}}e.$uh=ye;function de(_){const ee=new C.$6d,G=_(ee.token);return new ye(ee,async x=>{const me=ee.token.onCancellationRequested(()=>{me.dispose(),ee.dispose(),x.reject(new N.$5)});try{for await(const pe of G){if(ee.token.isCancellationRequested)return;x.emitOne(pe)}me.dispose(),ee.dispose()}catch(pe){me.dispose(),ee.dispose(),x.reject(pe)}})}e.$vh=de;class fe{constructor(){this.a=new re,this.b=new ie(x=>{if(ee){x.reject(ee);return}return G&&x.emitMany(G),this.d=me=>x.reject(me),this.f=me=>x.emitOne(me),this.a.p});let ee,G;this.f=x=>{G||(G=[]),G.push(x)},this.d=x=>{ee||(ee=x)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(ee){this.d(ee),this.a.complete()}emitOne(ee){this.f(ee)}}e.$wh=fe}),define(ke[35],Se([1,0,19,11,34,28,17,10,12]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=void 0;function k(){return Object.create(null)}e.$Hj=k,e.$Ij="**",e.$Jj="/";const A="[/\\\\]",D="[^/\\\\]",w=/\//g;function E(ue,X){switch(ue){case 0:return"";case 1:return`${D}*?`;default:return`(?:${A}|${D}+${A}${X?`|${A}${D}+`:""})*?`}}function S(ue,X){if(!ue)return[];const Q=[];let Z=!1,le=!1,re="";for(const $e of ue){switch($e){case X:if(!Z&&!le){Q.push(re),re="";continue}break;case"{":Z=!0;break;case"}":Z=!1;break;case"[":le=!0;break;case"]":le=!1;break}re+=$e}return re&&Q.push(re),Q}e.$Kj=S;function c(ue){if(!ue)return"";let X="";const Q=S(ue,e.$Jj);if(Q.every(Z=>Z===e.$Ij))X=".*";else{let Z=!1;Q.forEach((le,re)=>{if(le===e.$Ij){if(Z)return;X+=E(2,re===Q.length-1)}else{let $e=!1,oe="",J=!1,V="";for(const ie of le){if(ie!=="}"&&$e){oe+=ie;continue}if(J&&(ie!=="]"||!V)){let ye;ie==="-"?ye=ie:(ie==="^"||ie==="!")&&!V?ye="^":ie===e.$Jj?ye="":ye=(0,$.$Oe)(ie),V+=ye;continue}switch(ie){case"{":$e=!0;continue;case"[":J=!0;continue;case"}":{const de=`(?:${S(oe,",").map(fe=>c(fe)).join("|")})`;X+=de,$e=!1,oe="";break}case"]":{X+="["+V+"]",J=!1,V="";break}case"?":X+=D;continue;case"*":X+=E(1);continue;default:X+=(0,$.$Oe)(ie)}}re<Q.length-1&&(Q[re+1]!==e.$Ij||re+2<Q.length)&&(X+=A)}Z=le===e.$Ij})}return X}const g=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,i=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,r=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,n=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new P.$Dc(1e4),h=function(){return!1},s=function(){return null};function d(ue,X){if(!ue)return s;let Q;typeof ue!="string"?Q=ue.pattern:Q=ue,Q=Q.trim();const Z=`${Q}_${!!X.trimForExclusions}`;let le=t.get(Z);if(le)return u(le,ue);let re;return g.test(Q)?le=p(Q.substr(4),Q):(re=o.exec(l(Q,X)))?le=I(re[1],Q):(X.trimForExclusions?r:i).test(Q)?le=b(Q,X):(re=n.exec(l(Q,X)))?le=m(re[1].substr(1),Q,!0):(re=a.exec(l(Q,X)))?le=m(re[1],Q,!1):le=y(Q),t.set(Z,le),u(le,ue)}function u(ue,X){if(typeof X=="string")return ue;const Q=function(Z,le){return(0,f.$8f)(Z,X.base,!v.$k)?ue((0,$.$Te)(Z.substr(X.base.length),R.sep),le):null};return Q.allBasenames=ue.allBasenames,Q.allPaths=ue.allPaths,Q.basenames=ue.basenames,Q.patterns=ue.patterns,Q}function l(ue,X){return X.trimForExclusions&&ue.endsWith("/**")?ue.substr(0,ue.length-2):ue}function p(ue,X){return function(Q,Z){return typeof Q=="string"&&Q.endsWith(ue)?X:null}}function I(ue,X){const Q=`/${ue}`,Z=`\\${ue}`,le=function($e,oe){return typeof $e!="string"?null:oe?oe===ue?X:null:$e===ue||$e.endsWith(Q)||$e.endsWith(Z)?X:null},re=[ue];return le.basenames=re,le.patterns=[X],le.allBasenames=re,le}function b(ue,X){const Q=U(ue.slice(1,-1).split(",").map(oe=>d(oe,X)).filter(oe=>oe!==s),ue),Z=Q.length;if(!Z)return s;if(Z===1)return Q[0];const le=function(oe,J){for(let V=0,ie=Q.length;V<ie;V++)if(Q[V](oe,J))return ue;return null},re=Q.find(oe=>!!oe.allBasenames);re&&(le.allBasenames=re.allBasenames);const $e=Q.reduce((oe,J)=>J.allPaths?oe.concat(J.allPaths):oe,[]);return $e.length&&(le.allPaths=$e),le}function m(ue,X,Q){const Z=R.sep===R.$gc.sep,le=Z?ue:ue.replace(w,R.sep),re=R.sep+le,$e=R.$gc.sep+ue;let oe;return Q?oe=function(J,V){return typeof J=="string"&&(J===le||J.endsWith(re)||!Z&&(J===ue||J.endsWith($e)))?X:null}:oe=function(J,V){return typeof J=="string"&&(J===le||!Z&&J===ue)?X:null},oe.allPaths=[(Q?"*/":"./")+ue],oe}function y(ue){try{const X=new RegExp(`^${c(ue)}$`);return function(Q){return X.lastIndex=0,typeof Q=="string"&&X.test(Q)?ue:null}}catch{return s}}function L(ue,X,Q){return!ue||typeof X!="string"?!1:F(ue)(X,void 0,Q)}e.$Lj=L;function F(ue,X={}){if(!ue)return h;if(typeof ue=="string"||z(ue)){const Q=d(ue,X);if(Q===s)return h;const Z=function(le,re){return!!Q(le,re)};return Q.allBasenames&&(Z.allBasenames=Q.allBasenames),Q.allPaths&&(Z.allPaths=Q.allPaths),Z}return M(ue,X)}e.$Mj=F;function z(ue){const X=ue;return X?typeof X.base=="string"&&typeof X.pattern=="string":!1}e.$Nj=z;function T(ue){return ue.allBasenames||[]}e.$Oj=T;function O(ue){return ue.allPaths||[]}e.$Pj=O;function M(ue,X){const Q=U(Object.getOwnPropertyNames(ue).map(oe=>j(oe,ue[oe],X)).filter(oe=>oe!==s)),Z=Q.length;if(!Z)return s;if(!Q.some(oe=>!!oe.requiresSiblings)){if(Z===1)return Q[0];const oe=function(ie,ye){let de;for(let fe=0,_=Q.length;fe<_;fe++){const ee=Q[fe](ie,ye);if(typeof ee=="string")return ee;(0,N.$Sg)(ee)&&(de||(de=[]),de.push(ee))}return de?(async()=>{for(const fe of de){const _=await fe;if(typeof _=="string")return _}return null})():null},J=Q.find(ie=>!!ie.allBasenames);J&&(oe.allBasenames=J.allBasenames);const V=Q.reduce((ie,ye)=>ye.allPaths?ie.concat(ye.allPaths):ie,[]);return V.length&&(oe.allPaths=V),oe}const le=function(oe,J,V){let ie,ye;for(let de=0,fe=Q.length;de<fe;de++){const _=Q[de];_.requiresSiblings&&V&&(J||(J=(0,R.$nc)(oe)),ie||(ie=J.substr(0,J.length-(0,R.$oc)(oe).length)));const ee=_(oe,J,ie,V);if(typeof ee=="string")return ee;(0,N.$Sg)(ee)&&(ye||(ye=[]),ye.push(ee))}return ye?(async()=>{for(const de of ye){const fe=await de;if(typeof fe=="string")return fe}return null})():null},re=Q.find(oe=>!!oe.allBasenames);re&&(le.allBasenames=re.allBasenames);const $e=Q.reduce((oe,J)=>J.allPaths?oe.concat(J.allPaths):oe,[]);return $e.length&&(le.allPaths=$e),le}function j(ue,X,Q){if(X===!1)return s;const Z=d(ue,Q);if(Z===s)return s;if(typeof X=="boolean")return Z;if(X){const le=X.when;if(typeof le=="string"){const re=($e,oe,J,V)=>{if(!V||!Z($e,oe))return null;const ie=le.replace("$(basename)",()=>J),ye=V(ie);return(0,N.$Sg)(ye)?ye.then(de=>de?ue:null):ye?ue:null};return re.requiresSiblings=!0,re}}return Z}function U(ue,X){const Q=ue.filter(oe=>!!oe.basenames);if(Q.length<2)return ue;const Z=Q.reduce((oe,J)=>{const V=J.basenames;return V?oe.concat(V):oe},[]);let le;if(X){le=[];for(let oe=0,J=Z.length;oe<J;oe++)le.push(X)}else le=Q.reduce((oe,J)=>{const V=J.patterns;return V?oe.concat(V):oe},[]);const re=function(oe,J){if(typeof oe!="string")return null;if(!J){let ie;for(ie=oe.length;ie>0;ie--){const ye=oe.charCodeAt(ie-1);if(ye===47||ye===92)break}J=oe.substr(ie)}const V=Z.indexOf(J);return V!==-1?le[V]:null};re.basenames=Z,re.patterns=le,re.allBasenames=Z;const $e=ue.filter(oe=>!oe.basenames);return $e.push(re),$e}function K(ue,X){return(0,C.$ub)(ue,X,(Q,Z)=>typeof Q=="string"&&typeof Z=="string"?Q===Z:typeof Q!="string"&&typeof Z!="string"?Q.base===Z.base&&Q.pattern===Z.pattern:!1)}e.$Qj=K}),define(ke[80],Se([1,0,14,164,23,12,2]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=e.$nk=e.$mk=e.$lk=e.$kk=e.$jk=e.$ik=e.$hk=e.MarkdownStringTextNewlineStyle=void 0;var v;(function(o){o[o.Paragraph=0]="Paragraph",o[o.Break=1]="Break"})(v||(e.MarkdownStringTextNewlineStyle=v={}));class ${constructor(i="",r=!1){if(this.value=i,typeof this.value!="string")throw(0,C.$7)("value");typeof r=="boolean"?(this.isTrusted=r,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=r.isTrusted??void 0,this.supportThemeIcons=r.supportThemeIcons??!1,this.supportHtml=r.supportHtml??!1)}appendText(i,r=0){return this.value+=w(this.supportThemeIcons?(0,N.$bk)(i):i).replace(/([ \t]+)/g,(n,a)=>"&nbsp;".repeat(a.length)).replace(/\>/gm,"\\>").replace(/\n/g,r===1?`\\
`:`

`),this}appendMarkdown(i){return this.value+=i,this}appendCodeblock(i,r){return this.value+=`
${E(r,i)}
`,this}appendLink(i,r,n){return this.value+="[",this.value+=this.c(r,"]"),this.value+="](",this.value+=this.c(String(i),")"),n&&(this.value+=` "${this.c(this.c(n,'"'),")")}"`),this.value+=")",this}c(i,r){const n=new RegExp((0,P.$Oe)(r),"g");return i.replace(n,(a,t)=>i.charAt(t-1)!=="\\"?`\\${a}`:a)}}e.$hk=$;function k(o){return A(o)?!o.value:Array.isArray(o)?o.every(k):!0}e.$ik=k;function A(o){return o instanceof $?!0:o&&typeof o=="object"?typeof o.value=="string"&&(typeof o.isTrusted=="boolean"||typeof o.isTrusted=="object"||o.isTrusted===void 0)&&(typeof o.supportThemeIcons=="boolean"||o.supportThemeIcons===void 0):!1}e.$jk=A;function D(o,i){return o===i?!0:!o||!i?!1:o.value===i.value&&o.isTrusted===i.isTrusted&&o.supportThemeIcons===i.supportThemeIcons&&o.supportHtml===i.supportHtml&&(o.baseUri===i.baseUri||!!o.baseUri&&!!i.baseUri&&(0,f.$Ag)(R.URI.from(o.baseUri),R.URI.from(i.baseUri)))}e.$kk=D;function w(o){return o.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.$lk=w;function E(o,i){const r=o.match(/^`+/gm)?.reduce((a,t)=>a.length>t.length?a:t).length??0,n=r>=3?r+1:3;return[`${"`".repeat(n)}${i}`,o,`${"`".repeat(n)}`].join(`
`)}e.$mk=E;function S(o){return o.replace(/"/g,"&quot;")}e.$nk=S;function c(o){return o&&o.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.$ok=c;function g(o){const i=[],r=o.split("|").map(a=>a.trim());o=r[0];const n=r[1];if(n){const a=/height=(\d+)/.exec(n),t=/width=(\d+)/.exec(n),h=a?a[1]:"",s=t?t[1]:"",d=isFinite(parseInt(s)),u=isFinite(parseInt(h));d&&i.push(`width="${s}"`),u&&i.push(`height="${h}"`)}return{href:o,dimensions:i}}e.$pk=g}),define(ke[103],Se([1,0,19,34,17,10,23,12]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5v=e.$4v=e.$3v=e.$2v=e.$1v=e.$Zv=e.$Yv=e.$Xv=e.$Wv=e.$Vv=void 0;function $(d,u){const{os:l,tildify:p,relative:I}=u;if(I){const y=k(d,I,l);if(typeof y=="string")return y}let b=d.fsPath;if(l===1&&!P.$i?b=b.replace(/\//g,"\\"):l!==1&&P.$i&&(b=b.replace(/\\/g,"/")),l!==1&&p?.userHome){const y=p.userHome.fsPath;let L;d.scheme!==p.userHome.scheme&&d.path[0]===f.$gc.sep&&d.path[1]!==f.$gc.sep?L=p.userHome.with({path:d.path}).fsPath:L=b,b=w(L,y,l)}return(l===1?f.$fc:f.$gc).normalize(A(b,l===1))}e.$Vv=$;function k(d,u,l){const p=l===1?f.$fc:f.$gc,I=l===3?R.$xg:R.$zg,b=u.getWorkspace(),m=(0,C.$Ob)(b.folders);if(!m)return;d.scheme!==m.uri.scheme&&d.path[0]===f.$gc.sep&&d.path[1]!==f.$gc.sep&&(d=m.uri.with({path:d.path}));const y=u.getWorkspaceFolder(d);if(!y)return;let L;if(I.isEqual(y.uri,d)?L="":L=I.relativePath(y.uri,d)??"",L&&(L=p.normalize(L)),b.folders.length>1&&!u.noPrefix){const F=y.name?y.name:I.basenameOrAuthority(y.uri);L=L?`${F} \u2022 ${L}`:F}return L}function A(d,u=P.$i){return(0,N.$_f)(d,u)?d.charAt(0).toUpperCase()+d.slice(1):d}e.$Wv=A;let D=Object.create(null);function w(d,u,l=P.OS){if(l===1||!d||!u)return d;let p=D.original===u?D.normalized:void 0;p||(p=u,P.$i&&(p=(0,N.$2f)(p)),p=`${(0,v.$Ue)(p,f.$gc.sep)}${f.$gc.sep}`,D={original:u,normalized:p});let I=d;return P.$i&&(I=(0,N.$2f)(I)),(l===3?I.startsWith(p):(0,v.$af)(I,p))?`~/${I.substr(p.length)}`:d}e.$Xv=w;function E(d,u){return d.replace(/^~($|\/|\\)/,`${u}$1`)}e.$Yv=E;const S="\u2026",c="\\\\",g="~";function o(d,u=f.sep){const l=new Array(d.length);let p=!1;for(let I=0;I<d.length;I++){const b=d[I];if(b===""){l[I]=`.${u}`;continue}if(!b){l[I]=b;continue}p=!0;let m="",y=b;y.indexOf(c)===0?(m=y.substr(0,y.indexOf(c)+c.length),y=y.substr(y.indexOf(c)+c.length)):y.indexOf(u)===0?(m=y.substr(0,y.indexOf(u)+u.length),y=y.substr(y.indexOf(u)+u.length)):y.indexOf(g)===0&&(m=y.substr(0,y.indexOf(g)+g.length),y=y.substr(y.indexOf(g)+g.length));const L=y.split(u);for(let F=1;p&&F<=L.length;F++)for(let z=L.length-F;p&&z>=0;z--){p=!1;let T=L.slice(z,z+F).join(u);for(let O=0;!p&&O<d.length;O++)if(O!==I&&d[O]&&d[O].indexOf(T)>-1){const M=z+F===L.length,j=z>0&&d[O].indexOf(u)>-1?u+T:T,U=d[O].endsWith(j);p=!M||U}if(!p){let O="";(L[0].endsWith(":")||m!=="")&&(z===1&&(z=0,F++,T=L[0]+u+T),z>0&&(O=L[0]+u),O=m+O),z>0&&(O=O+S+u),O=O+T,z+F<L.length&&(O=O+u+S),l[I]=O}}p&&(l[I]=b)}return l}e.$Zv=o;var i;(function(d){d[d.TEXT=0]="TEXT",d[d.VARIABLE=1]="VARIABLE",d[d.SEPARATOR=2]="SEPARATOR"})(i||(i={}));function r(d,u=Object.create(null)){const l=[];let p=!1,I="";for(const b of d)if(b==="$"||p&&b==="{")I&&l.push({value:I,type:i.TEXT}),I="",p=!0;else if(b==="}"&&p){const m=u[I];if(typeof m=="string")m.length&&l.push({value:m,type:i.VARIABLE});else if(m){const y=l[l.length-1];(!y||y.type!==i.SEPARATOR)&&l.push({value:m.label,type:i.SEPARATOR})}I="",p=!1}else I+=b;return I&&!p&&l.push({value:I,type:i.TEXT}),l.filter((b,m)=>{if(b.type===i.SEPARATOR){const y=l[m-1],L=l[m+1];return[y,L].every(F=>F&&(F.type===i.VARIABLE||F.type===i.TEXT)&&F.value.length>0)}return!0}).map(b=>b.value).join("")}e.$1v=r;function n(d,u){return P.$j||u?d.replace(/\(&&\w\)|&&/g,"").replace(/&/g,P.$j?"&":"&&"):d.replace(/&&|&/g,l=>l==="&"?"&&":"&")}e.$2v=n;function a(d,u){return P.$j||u?d.replace(/\(&&\w\)|&&/g,""):P.$i?d.replace(/&&|&/g,l=>l==="&"?"&&":"&"):d.replace(/&&/g,"_")}e.$3v=a;function t(d){return d.replace(/&/g,"&&")}e.$4v=t;function h(d){if(d.endsWith("]")){const u=d.lastIndexOf(" [",d.length-2);if(u!==-1){const l=s(d.substring(0,u)),p=d.substring(u);return{name:l.name+p,parentPath:l.parentPath}}}return s(d)}e.$5v=h;function s(d){const u=d.indexOf("/")!==-1?f.$gc:f.$fc,l=u.basename(d),p=u.dirname(d);return l.length?{name:l,parentPath:p}:{name:p,parentPath:""}}}),define(ke[130],Se([1,0,22,2]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=e.$6m=e.$5m=e.$4m=void 0;function f(D){return D.toJSON()}class P{constructor(w){this.a=w}transformIncoming(w){const E=this.a.transformIncoming(w);return E===w?w:f(N.URI.from(E))}transformOutgoing(w){const E=this.a.transformOutgoing(w);return E===w?w:f(N.URI.from(E))}transformOutgoingURI(w){const E=this.a.transformOutgoing(w);return E===w?w:N.URI.from(E)}transformOutgoingScheme(w){return this.a.transformOutgoingScheme(w)}}e.$4m=P,e.$5m=new class{transformIncoming(D){return D}transformOutgoing(D){return D}transformOutgoingURI(D){return D}transformOutgoingScheme(D){return D}};function R(D,w,E){if(!D||E>200)return null;if(typeof D=="object"){if(D instanceof N.URI)return w.transformOutgoing(D);for(const S in D)if(Object.hasOwnProperty.call(D,S)){const c=R(D[S],w,E+1);c!==null&&(D[S]=c)}}return null}function v(D,w){const E=R(D,w,0);return E===null?D:E}e.$6m=v;function $(D,w,E,S){if(!D||S>200)return null;if(typeof D=="object"){if(D.$mid===1)return E?N.URI.revive(w.transformIncoming(D)):w.transformIncoming(D);if(D instanceof C.$je)return null;for(const c in D)if(Object.hasOwnProperty.call(D,c)){const g=$(D[c],w,E,S+1);g!==null&&(D[c]=g)}}return null}function k(D,w){const E=$(D,w,!1,0);return E===null?D:E}e.$7m=k;function A(D,w){const E=$(D,w,!0,0);return E===null?D:E}e.$8m=A}),define(ke[31],Se([1,0,57,63,386,11,34,76,17,10,23,2]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var w;(function(j){j[j.UNLINK=0]="UNLINK",j[j.MOVE=1]="MOVE"})(w||(e.RimRafMode=w={}));async function E(j,U=w.UNLINK,K){if((0,R.$$f)(j))throw new Error("rimraf - will refuse to recursively delete root");return U===w.UNLINK?c(j):S(j,K)}async function S(j,U=(0,R.$dg)((0,N.tmpdir)())){try{try{await C.promises.rename(j,U)}catch(K){return K.code==="ENOENT"?void 0:c(j)}c(U).catch(K=>{})}catch(K){if(K.code!=="ENOENT")throw K}}async function c(j){return(0,f.promisify)(C.rm)(j,{recursive:!0,force:!0,maxRetries:3})}function g(j){if((0,R.$$f)(j))throw new Error("rimraf - will refuse to recursively delete root");C.rmSync(j,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=g;async function o(j,U){return n(await(U?i(j):(0,f.promisify)(C.readdir)(j)))}async function i(j){try{return await(0,f.promisify)(C.readdir)(j,{withFileTypes:!0})}catch(ue){console.warn("[node.js fs] readdir with filetypes failed with error: ",ue)}const U=[],K=await o(j);for(const ue of K){let X=!1,Q=!1,Z=!1;try{const le=await e.Promises.lstat((0,$.$jc)(j,ue));X=le.isFile(),Q=le.isDirectory(),Z=le.isSymbolicLink()}catch(le){console.warn("[node.js fs] unexpected error from lstat after readdir: ",le)}U.push({name:ue,isFile:()=>X,isDirectory:()=>Q,isSymbolicLink:()=>Z})}return U}function r(j){return n(C.readdirSync(j))}e.readdirSync=r;function n(j){return j.map(U=>typeof U=="string"?k.$j?(0,v.$Gl)(U):U:(U.name=k.$j?(0,v.$Gl)(U.name):U.name,U))}async function a(j){const U=await o(j),K=[];for(const ue of U)await h.existsDirectory((0,$.$jc)(j,ue))&&K.push(ue);return K}function t(j,U=1e3){return new Promise(K=>{let ue=!1;const X=setInterval(()=>{ue||(ue=!0,C.access(j,Q=>{ue=!1,Q&&(clearInterval(X),K(void 0))}))},U)})}e.whenDeleted=t;var h;(function(j){async function U(X){let Q;try{if(Q=await e.Promises.lstat(X),!Q.isSymbolicLink())return{stat:Q}}catch{}try{return{stat:await e.Promises.stat(X),symbolicLink:Q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Z){if(Z.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};if(k.$i&&Z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(X)),symbolicLink:{dangling:!1}}}catch(le){if(le.code==="ENOENT"&&Q)return{stat:Q,symbolicLink:{dangling:!0}};throw le}throw Z}}j.stat=U;async function K(X){try{const{stat:Q,symbolicLink:Z}=await j.stat(X);return Q.isFile()&&Z?.dangling!==!0}catch{}return!1}j.existsFile=K;async function ue(X){try{const{stat:Q,symbolicLink:Z}=await j.stat(X);return Q.isDirectory()&&Z?.dangling!==!0}catch{}return!1}j.existsDirectory=ue})(h||(e.SymlinkSupport=h={}));const s=new P.$ch;function d(j,U,K){return s.queueFor(D.URI.file(j),()=>{const ue=b(K);return new Promise((X,Q)=>p(j,U,ue,Z=>Z?Q(Z):X()))},A.$yg)}let u=!0;function l(j){u=j}e.configureFlushOnWrite=l;function p(j,U,K,ue){if(!u)return C.writeFile(j,U,{mode:K.mode,flag:K.flag},ue);C.open(j,K.flag,K.mode,(X,Q)=>{if(X)return ue(X);C.writeFile(Q,U,Z=>{if(Z)return C.close(Q,()=>ue(Z));C.fdatasync(Q,le=>(le&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",le),l(!1)),C.close(Q,re=>ue(re))))})})}function I(j,U,K){const ue=b(K);if(!u)return C.writeFileSync(j,U,{mode:ue.mode,flag:ue.flag});const X=C.openSync(j,ue.flag,ue.mode);try{C.writeFileSync(X,U);try{C.fdatasyncSync(X)}catch(Q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",Q),l(!1)}}finally{C.closeSync(X)}}e.writeFileSync=I;function b(j){return j?{mode:typeof j.mode=="number"?j.mode:438,flag:typeof j.flag=="string"?j.flag:"w"}:{mode:438,flag:"w"}}async function m(j,U,K=6e4){if(j!==U)try{k.$i&&typeof K=="number"?await y(j,U,Date.now(),K):await(0,f.promisify)(C.rename)(j,U)}catch(ue){if(j.toLowerCase()!==U.toLowerCase()&&ue.code==="EXDEV"||j.endsWith("."))await L(j,U,{preserveSymlinks:!1}),await E(j,w.MOVE);else throw ue}}async function y(j,U,K,ue,X=0){try{return await(0,f.promisify)(C.rename)(j,U)}catch(Q){if(Q.code!=="EACCES"&&Q.code!=="EPERM"&&Q.code!=="EBUSY")throw Q;if(Date.now()-K>=ue)throw console.error(`[node.js fs] rename failed after ${X} retries with error: ${Q}`),Q;if(X===0){let Z=!1;try{const{stat:le}=await h.stat(U);le.isFile()||(Z=!0)}catch{}if(Z)throw Q}return await(0,P.$7g)(Math.min(100,X*10)),y(j,U,K,ue,X+1)}}async function L(j,U,K){return z(j,U,{root:{source:j,target:U},options:K,handledSourcePaths:new Set})}const F=511;async function z(j,U,K){if(K.handledSourcePaths.has(j))return;K.handledSourcePaths.add(j);const{stat:ue,symbolicLink:X}=await h.stat(j);if(X){if(K.options.preserveSymlinks)try{return await M(j,U,K)}catch{}if(X.dangling)return}return ue.isDirectory()?T(j,U,ue.mode&F,K):O(j,U,ue.mode&F)}async function T(j,U,K,ue){await e.Promises.mkdir(U,{recursive:!0,mode:K});const X=await o(j);for(const Q of X)await z((0,$.$jc)(j,Q),(0,$.$jc)(U,Q),ue)}async function O(j,U,K){await e.Promises.copyFile(j,U),await e.Promises.chmod(U,K)}async function M(j,U,K){let ue=await e.Promises.readlink(j);(0,R.$8f)(ue,K.root.source,!k.$k)&&(ue=(0,$.$jc)(K.root.target,ue.substr(K.root.source.length+1))),await e.Promises.symlink(ue,U)}e.Promises=new class{get access(){return(0,f.promisify)(C.access)}get stat(){return(0,f.promisify)(C.stat)}get lstat(){return(0,f.promisify)(C.lstat)}get utimes(){return(0,f.promisify)(C.utimes)}get read(){return(j,U,K,ue,X)=>new Promise((Q,Z)=>{C.read(j,U,K,ue,X,(le,re,$e)=>le?Z(le):Q({bytesRead:re,buffer:$e}))})}get readFile(){return(0,f.promisify)(C.readFile)}get write(){return(j,U,K,ue,X)=>new Promise((Q,Z)=>{C.write(j,U,K,ue,X,(le,re,$e)=>le?Z(le):Q({bytesWritten:re,buffer:$e}))})}get appendFile(){return(0,f.promisify)(C.appendFile)}get fdatasync(){return(0,f.promisify)(C.fdatasync)}get truncate(){return(0,f.promisify)(C.truncate)}get copyFile(){return(0,f.promisify)(C.copyFile)}get open(){return(0,f.promisify)(C.open)}get close(){return(0,f.promisify)(C.close)}get symlink(){return(0,f.promisify)(C.symlink)}get readlink(){return(0,f.promisify)(C.readlink)}get chmod(){return(0,f.promisify)(C.chmod)}get mkdir(){return(0,f.promisify)(C.mkdir)}get unlink(){return(0,f.promisify)(C.unlink)}get rmdir(){return(0,f.promisify)(C.rmdir)}get realpath(){return(0,f.promisify)(C.realpath)}async exists(j){try{return await e.Promises.access(j),!0}catch{return!1}}get readdir(){return o}get readDirsInDir(){return a}get writeFile(){return d}get rm(){return E}get rename(){return m}get copy(){return L}}}),define(ke[104],Se([1,0,57,17,10,12,31]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=e.$vq=e.$uq=e.$tq=void 0;function v(w){if(f.$k)return w;const E=(0,N.$mc)(w);if(w===E)return w;const S=((0,N.$nc)(w)||w).toLowerCase();try{const g=(0,R.readdirSync)(E).filter(o=>o.toLowerCase()===S);if(g.length===1){const o=v(E);if(o)return(0,N.$jc)(o,g[0])}else if(g.length>1){const o=g.indexOf(S);if(o>=0){const i=v(E);if(i)return(0,N.$jc)(i,g[o])}}}catch{}return null}e.$tq=v;async function $(w){if(f.$k)return w;const E=(0,N.$mc)(w);if(w===E)return w;const S=((0,N.$nc)(w)||w).toLowerCase();try{const g=(await R.Promises.readdir(E)).filter(o=>o.toLowerCase()===S);if(g.length===1){const o=await $(E);if(o)return(0,N.$jc)(o,g[0])}else if(g.length>1){const o=g.indexOf(S);if(o>=0){const i=await $(E);if(i)return(0,N.$jc)(i,g[o])}}}catch{}return null}e.$uq=$;async function k(w){try{return await R.Promises.realpath(w)}catch{const S=D(w);return await R.Promises.access(S,C.constants.R_OK),S}}e.$vq=k;function A(w){try{return C.realpathSync(w)}catch{const S=D(w);return C.accessSync(S,C.constants.R_OK),S}}e.$wq=A;function D(w){return(0,P.$Ue)((0,N.$hc)(w),N.sep)}}),define(ke[105],Se([1,0,17,10,49,102,18,31]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.$Ul=e.$Tl=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return P.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return P.TerminateResponseCode}});function $(D=f.env){return D.comspec||"cmd.exe"}e.$Tl=$;function k(D){let w=[],E=!1;const S=function(c){if(E){w.push(c);return}(!D.send(c,o=>{if(o&&console.error(o),E=!1,w.length>0){const i=w.slice(0);w=[],i.forEach(r=>S(r))}})||N.$i)&&(E=!0)};return{send:S}}e.$Ul=k;var A;(function(D){async function w(E,S,c){if(C.$ic(E))return E;if(S===void 0&&(S=f.cwd()),C.$mc(E)!=="."||(c===void 0&&R.$If(f.env.PATH)&&(c=f.env.PATH.split(C.$tc)),c===void 0||c.length===0))return C.$jc(S,E);async function o(i){if(await v.Promises.exists(i)){let r;try{r=await v.Promises.stat(i)}catch(n){n.message.startsWith("EACCES")&&(r=await v.Promises.lstat(i))}return r?!r.isDirectory():!1}return!1}for(const i of c){let r;if(C.$ic(i)?r=C.$jc(i,E):r=C.$jc(S,i,E),await o(r))return r;let n=r+".com";if(await o(n)||(n=r+".exe",await o(n)))return n}return C.$jc(S,E)}D.findExecutable=w})(A||(e.win32=A={}))});var Ge=this&&this.__decorate||function(ge,e,C,N){var f=arguments.length,P=f<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,C):N,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")P=Reflect.decorate(ge,e,C,N);else for(var v=ge.length-1;v>=0;v--)(R=ge[v])&&(P=(f<3?R(P):f>3?R(e,C,P):R(e,C))||P);return f>3&&P&&Object.defineProperty(e,C,P),P};define(ke[81],Se([1,0,19,11,22,21,52,14,4,3,56,12,18]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oh=e.ProxyChannel=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.RequestInitiator=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$Dh=void 0;var E;(function(X){X[X.Promise=100]="Promise",X[X.PromiseCancel=101]="PromiseCancel",X[X.EventListen=102]="EventListen",X[X.EventDispose=103]="EventDispose"})(E||(E={}));function S(X){switch(X){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(X){X[X.Initialize=200]="Initialize",X[X.PromiseSuccess=201]="PromiseSuccess",X[X.PromiseError=202]="PromiseError",X[X.PromiseErrorObj=203]="PromiseErrorObj",X[X.EventFire=204]="EventFire"})(c||(c={}));function g(X){switch(X){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var o;(function(X){X[X.Uninitialized=0]="Uninitialized",X[X.Idle=1]="Idle"})(o||(o={}));function i(X){let Q=0;for(let Z=0;;Z+=7){const le=X.read(1);if(Q|=(le.buffer[0]&127)<<Z,!(le.buffer[0]&128))return Q}}const r=s(0);function n(X,Q){if(Q===0){X.write(r);return}let Z=0;for(let re=Q;re!==0;re=re>>>7)Z++;const le=f.$je.alloc(Z);for(let re=0;Q!==0;re++)le.buffer[re]=Q&127,Q=Q>>>7,Q>0&&(le.buffer[re]|=128);X.write(le)}class a{constructor(Q){this.b=Q,this.a=0}read(Q){const Z=this.b.slice(this.a,this.a+Q);return this.a+=Z.byteLength,Z}}e.$Dh=a;class t{constructor(){this.a=[]}get buffer(){return f.$je.concat(this.a)}write(Q){this.a.push(Q)}}e.$Eh=t;var h;(function(X){X[X.Undefined=0]="Undefined",X[X.String=1]="String",X[X.Buffer=2]="Buffer",X[X.VSBuffer=3]="VSBuffer",X[X.Array=4]="Array",X[X.Object=5]="Object",X[X.Int=6]="Int"})(h||(h={}));function s(X){const Q=f.$je.alloc(1);return Q.writeUInt8(X,0),Q}const d={Undefined:s(h.Undefined),String:s(h.String),Buffer:s(h.Buffer),VSBuffer:s(h.VSBuffer),Array:s(h.Array),Object:s(h.Object),Uint:s(h.Int)},u=typeof Buffer<"u";function l(X,Q){if(typeof Q>"u")X.write(d.Undefined);else if(typeof Q=="string"){const Z=f.$je.fromString(Q);X.write(d.String),n(X,Z.byteLength),X.write(Z)}else if(u&&Buffer.isBuffer(Q)){const Z=f.$je.wrap(Q);X.write(d.Buffer),n(X,Z.byteLength),X.write(Z)}else if(Q instanceof f.$je)X.write(d.VSBuffer),n(X,Q.byteLength),X.write(Q);else if(Array.isArray(Q)){X.write(d.Array),n(X,Q.length);for(const Z of Q)l(X,Z)}else if(typeof Q=="number"&&(Q|0)===Q)X.write(d.Uint),n(X,Q);else{const Z=f.$je.fromString(JSON.stringify(Q));X.write(d.Object),n(X,Z.byteLength),X.write(Z)}}e.$Fh=l;function p(X){switch(X.read(1).readUInt8(0)){case h.Undefined:return;case h.String:return X.read(i(X)).toString();case h.Buffer:return X.read(i(X)).buffer;case h.VSBuffer:return X.read(i(X));case h.Array:{const Z=i(X),le=[];for(let re=0;re<Z;re++)le.push(p(X));return le}case h.Object:return JSON.parse(X.read(i(X)).toString());case h.Int:return i(X)}}e.$Gh=p;class I{constructor(Q,Z,le=null,re=1e3){this.h=Q,this.j=Z,this.k=le,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage($e=>this.q($e)),this.m({type:200})}registerChannel(Q,Z){this.b.set(Q,Z),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const Z=this.o([Q.type]);this.k?.logOutgoing(Z,0,1,g(Q.type));return}case 201:case 202:case 204:case 203:{const Z=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(Z,Q.id,1,g(Q.type),Q.data);return}}}o(Q,Z=void 0){const le=new t;return l(le,Q),l(le,Z),this.p(le.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const Z=new a(Q),le=p(Z),re=p(Z),$e=le[0];switch($e){case 100:return this.k?.logIncoming(Q.byteLength,le[1],1,`${S($e)}: ${le[2]}.${le[3]}`,re),this.s({type:$e,id:le[1],channelName:le[2],name:le[3],arg:re});case 102:return this.k?.logIncoming(Q.byteLength,le[1],1,`${S($e)}: ${le[2]}.${le[3]}`,re),this.t({type:$e,id:le[1],channelName:le[2],name:le[3],arg:re});case 101:return this.k?.logIncoming(Q.byteLength,le[1],1,`${S($e)}`),this.u({type:$e,id:le[1]});case 103:return this.k?.logIncoming(Q.byteLength,le[1],1,`${S($e)}`),this.u({type:$e,id:le[1]})}}s(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const le=new P.$6d;let re;try{re=Z.call(this.j,Q.name,Q.arg,le.token)}catch(J){re=Promise.reject(J)}const $e=Q.id;re.then(J=>{this.m({id:$e,data:J,type:201})},J=>{J instanceof Error?this.m({id:$e,data:{message:J.message,name:J.name,stack:J.stack?J.stack.split?J.stack.split(`
`):J.stack:void 0},type:202}):this.m({id:$e,data:J,type:203})}).finally(()=>{oe.dispose(),this.d.delete(Q.id)});const oe=(0,k.$Rc)(()=>le.cancel());this.d.set(Q.id,oe)}t(Q){const Z=this.b.get(Q.channelName);if(!Z){this.v(Q);return}const le=Q.id,$e=Z.listen(this.j,Q.name,Q.arg)(oe=>this.m({id:le,data:oe,type:204}));this.d.set(Q.id,$e)}u(Q){const Z=this.d.get(Q.id);Z&&(Z.dispose(),this.d.delete(Q.id))}v(Q){let Z=this.g.get(Q.channelName);Z||(Z=[],this.g.set(Q.channelName,Z));const le=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Z.push({request:Q,timeoutTimer:le})}w(Q){const Z=this.g.get(Q);if(Z){for(const le of Z)switch(clearTimeout(le.timeoutTimer),le.request.type){case 100:this.s(le.request);break;case 102:this.t(le.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Hh=I;var b;(function(X){X[X.LocalSide=0]="LocalSide",X[X.OtherSide=1]="OtherSide"})(b||(e.RequestInitiator=b={}));class m{constructor(Q,Z=null){this.l=Q,this.a=!1,this.b=o.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new $.$Vd,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(le=>this.s(le)),this.j=Z}getChannel(Q){const Z=this;return{call(le,re,$e){return Z.a?Promise.reject(new v.$5):Z.m(Q,le,re,$e)},listen(le,re){return Z.a?$.Event.None:Z.o(Q,le,re)}}}m(Q,Z,le,re=P.CancellationToken.None){const $e=this.g++,J={id:$e,type:100,channelName:Q,name:Z,arg:le};if(re.isCancellationRequested)return Promise.reject(new v.$5);let V;return new Promise((ye,de)=>{if(re.isCancellationRequested)return de(new v.$5);const fe=()=>{const x=me=>{switch(me.type){case 201:this.f.delete($e),ye(me.data);break;case 202:{this.f.delete($e);const pe=new Error(me.data.message);pe.stack=Array.isArray(me.data.stack)?me.data.stack.join(`
`):me.data.stack,pe.name=me.data.name,de(pe);break}case 203:this.f.delete($e),de(me.data);break}};this.f.set($e,x),this.p(J)};let _=null;this.b===o.Idle?fe():(_=(0,N.$Tg)(x=>this.u()),_.then(()=>{_=null,fe()}));const ee=()=>{_?(_.cancel(),_=null):this.p({id:$e,type:101}),de(new v.$5)},G=re.onCancellationRequested(ee);V=(0,k.$Qc)((0,k.$Rc)(ee),G),this.d.add(V)}).finally(()=>{V.dispose(),this.d.delete(V)})}o(Q,Z,le){const re=this.g++,oe={id:re,type:102,channelName:Q,name:Z,arg:le};let J=null;const V=new $.$Vd({onWillAddFirstListener:()=>{J=(0,N.$Tg)(ye=>this.u()),J.then(()=>{J=null,this.d.add(V),this.p(oe)})},onDidRemoveLastListener:()=>{J?(J.cancel(),J=null):(this.d.delete(V),this.p({id:re,type:103}))}}),ie=ye=>V.fire(ye.data);return this.f.set(re,ie),V.event}p(Q){switch(Q.type){case 100:case 102:{const Z=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(Z,Q.id,0,`${S(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const Z=this.q([Q.type,Q.id]);this.j?.logOutgoing(Z,Q.id,0,S(Q.type));return}}}q(Q,Z=void 0){const le=new t;return l(le,Q),l(le,Z),this.r(le.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const Z=new a(Q),le=p(Z),re=p(Z),$e=le[0];switch($e){case 200:return this.j?.logIncoming(Q.byteLength,0,0,g($e)),this.t({type:le[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,le[1],0,g($e),re),this.t({type:le[0],id:le[1],data:re})}}t(Q){if(Q.type===200){this.b=o.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return $.Event.toPromise(this.onDidInitialize)}u(){return this.b===o.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,k.$Oc)(this.d.values()),this.d.clear()}}e.$Ih=m,Ge([R.$xh],m.prototype,"onDidInitializePromise",null);class y{get connections(){const Q=[];return this.f.forEach(Z=>Q.push(Z)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new $.$Vd,this.onDidAddConnection=this.g.event,this.h=new $.$Vd,this.onDidRemoveConnection=this.h.event,this.j=new k.$Sc,this.j.add(Q(({protocol:Z,onDidClientDisconnect:le})=>{const re=$.Event.once(Z.onMessage);this.j.add(re($e=>{const oe=new a($e),J=p(oe),V=new I(Z,J),ie=new m(Z);this.a.forEach((de,fe)=>V.registerChannel(fe,de));const ye={channelServer:V,channelClient:ie,ctx:J};this.f.add(ye),this.g.fire(ye),this.j.add(le(()=>{V.dispose(),ie.dispose(),this.f.delete(ye),this.h.fire(ye)}))}))}))}getChannel(Q,Z){const le=this;return{call(re,$e,oe){let J;if((0,w.$Wf)(Z)){const ie=(0,C.$4b)(le.connections.filter(Z));J=ie?Promise.resolve(ie):$.Event.toPromise($.Event.filter(le.onDidAddConnection,Z))}else J=Z.routeCall(le,re,$e);const V=J.then(ie=>ie.channelClient.getChannel(Q));return F(V).call(re,$e,oe)},listen(re,$e){if((0,w.$Wf)(Z))return le.k(Q,Z,re,$e);const oe=Z.routeEvent(le,re,$e).then(J=>J.channelClient.getChannel(Q));return F(oe).listen(re,$e)}}}k(Q,Z,le,re){const $e=this;let oe;const J=new $.$Vd({onWillAddFirstListener:()=>{oe=new k.$Sc;const V=new $.$2d,ie=new Map,ye=fe=>{const ee=fe.channelClient.getChannel(Q).listen(le,re),G=V.add(ee);ie.set(fe,G)},de=fe=>{const _=ie.get(fe);_&&(_.dispose(),ie.delete(fe))};$e.connections.filter(Z).forEach(ye),$.Event.filter($e.onDidAddConnection,Z)(ye,void 0,oe),$e.onDidRemoveConnection(de,void 0,oe),V.event(J.fire,J,oe),oe.add(V)},onDidRemoveLastListener:()=>{oe?.dispose(),oe=void 0}});return J.event}registerChannel(Q,Z){this.a.set(Q,Z);for(const le of this.f)le.channelServer.registerChannel(Q,Z)}dispose(){this.j.dispose();for(const Q of this.f)Q.channelClient.dispose(),Q.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$Jh=y;class L{constructor(Q,Z,le=null){const re=new t;l(re,Z),Q.send(re.buffer),this.a=new m(Q,le),this.d=new I(Q,Z,le)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,Z){this.d.registerChannel(Q,Z)}dispose(){this.a.dispose(),this.d.dispose()}}e.$Kh=L;function F(X){return{call(Q,Z,le){return X.then(re=>re.call(Q,Z,le))},listen(Q,Z){const le=new $.$5d;return X.then(re=>le.input=re.listen(Q,Z)),le.event}}}e.$Lh=F;function z(X){let Q=!1;return{call(Z,le,re){return Q?X.call(Z,le,re):(0,N.$7g)(0).then(()=>Q=!0).then(()=>X.call(Z,le,re))},listen(Z,le){if(Q)return X.listen(Z,le);const re=new $.$5d;return(0,N.$7g)(0).then(()=>Q=!0).then(()=>re.input=X.listen(Z,le)),re.event}}}e.$Mh=z;class T{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const Z of Q.connections)if(await Promise.resolve(this.a(Z.ctx)))return Promise.resolve(Z);return await $.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.$Nh=T;var O;(function(X){function Q($e,oe,J){const V=$e,ie=J&&J.disableMarshalling,ye=new Map;for(const de in V)le(de)&&ye.set(de,$.Event.buffer(V[de],!0,void 0,oe));return new class{listen(de,fe,_){const ee=ye.get(fe);if(ee)return ee;if(re(fe)){const G=V[fe];if(typeof G=="function")return G.call(V,_)}throw new v.$bb(`Event not found: ${fe}`)}call(de,fe,_){const ee=V[fe];if(typeof ee=="function"){if(!ie&&Array.isArray(_))for(let x=0;x<_.length;x++)_[x]=(0,A.$Ch)(_[x]);let G=ee.apply(V,_);return G instanceof Promise||(G=Promise.resolve(G)),G}throw new v.$bb(`Method not found: ${fe}`)}}}X.fromService=Q;function Z($e,oe){const J=oe&&oe.disableMarshalling;return new Proxy({},{get(V,ie){if(typeof ie=="string")return oe?.properties?.has(ie)?oe.properties.get(ie):re(ie)?function(ye){return $e.listen(ie,ye)}:le(ie)?$e.listen(ie):async function(...ye){let de;oe&&!(0,w.$Rf)(oe.context)?de=[oe.context,...ye]:de=ye;const fe=await $e.call(ie,de);return J?fe:(0,A.$Ch)(fe)};throw new v.$bb(`Property not found: ${String(ie)}`)}})}X.toService=Z;function le($e){return $e[0]==="o"&&$e[1]==="n"&&D.$$e($e.charCodeAt(2))}function re($e){return/^onDynamic/.test($e)&&D.$$e($e.charCodeAt(9))}})(O||(e.ProxyChannel=O={}));const M=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function j(X){if(Array.isArray(X))return X;if(X&&typeof X=="object"&&typeof X.toString=="function"){const Q=X.toString();if(Q!=="[object Object]")return Q}return X}function U(X){return Array.isArray(X)?X.map(j):j(X)}function K(X,Q,Z,le,re,$e,oe){oe=U(oe);const J=M[re],V=J[le%J.length];let ie=[`%c[${X}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(Z).padStart(5," ")}]%c${String(le).padStart(5," ")} - ${$e}`,"color: darkgreen","color: grey","color: grey",`color: ${V}`];/\($/.test($e)?(ie=ie.concat(oe),ie.push(")")):ie.push(oe),console.log.apply(console,ie)}class ue{constructor(Q,Z){this.d=Q,this.f=Z,this.a=0,this.b=0}logOutgoing(Q,Z,le,re,$e){this.b+=Q,K(this.d,this.b,Q,Z,le,re,$e)}logIncoming(Q,Z,le,re,$e){this.a+=Q,K(this.f,this.a,Q,Z,le,re,$e)}}e.$Oh=ue}),define(ke[82],Se([1,0,22,4,3,81]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Th=e.$Sh=e.$Rh=e.$Qh=e.ProtocolConstants=e.$Ph=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var R;(function(d){d.Created="created",d.Read="read",d.Write="write",d.Open="open",d.Error="error",d.Close="close",d.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",d.NodeEndReceived="nodeEndReceived",d.NodeEndSent="nodeEndSent",d.NodeDrainBegin="nodeDrainBegin",d.NodeDrainEnd="nodeDrainEnd",d.zlibInflateError="zlibInflateError",d.zlibInflateData="zlibInflateData",d.zlibInflateInitialWrite="zlibInflateInitialWrite",d.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",d.zlibInflateWrite="zlibInflateWrite",d.zlibInflateFlushFired="zlibInflateFlushFired",d.zlibDeflateError="zlibDeflateError",d.zlibDeflateData="zlibDeflateData",d.zlibDeflateWrite="zlibDeflateWrite",d.zlibDeflateFlushFired="zlibDeflateFlushFired",d.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",d.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",d.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",d.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",d.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",d.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",d.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",d.ProtocolHeaderRead="protocolHeaderRead",d.ProtocolMessageRead="protocolMessageRead",d.ProtocolHeaderWrite="protocolHeaderWrite",d.ProtocolMessageWrite="protocolMessageWrite",d.ProtocolWrite="protocolWrite"})(R||(e.SocketDiagnosticsEventType=R={}));var v;(function(d){d.enableDiagnostics=!1,d.records=[];const u=new WeakMap;let l=0;function p(b,m){if(!u.has(b)){const y=String(++l);u.set(b,y)}return u.get(b)}function I(b,m,y,L){if(!d.enableDiagnostics)return;const F=p(b,m);if(L instanceof C.$je||L instanceof Uint8Array||L instanceof ArrayBuffer||ArrayBuffer.isView(L)){const z=C.$je.alloc(L.byteLength);z.set(L),d.records.push({timestamp:Date.now(),id:F,label:m,type:y,buff:z})}else d.records.push({timestamp:Date.now(),id:F,label:m,type:y,data:L})}d.traceSocketEvent=I})(v||(e.SocketDiagnostics=v={}));var $;(function(d){d[d.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",d[d.WebSocketCloseEvent=1]="WebSocketCloseEvent"})($||(e.SocketCloseEventType=$={}));let k=null;function A(){return k||(k=C.$je.alloc(0)),k}class D{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(u){this.a.push(u),this.b+=u.byteLength}read(u){return this.c(u,!0)}peek(u){return this.c(u,!1)}c(u,l){if(u===0)return A();if(u>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===u){const m=this.a[0];return l&&(this.a.shift(),this.b-=u),m}if(this.a[0].byteLength>u){const m=this.a[0].slice(0,u);return l&&(this.a[0]=this.a[0].slice(u),this.b-=u),m}const p=C.$je.alloc(u);let I=0,b=0;for(;u>0;){const m=this.a[b];if(m.byteLength>u){const y=m.slice(0,u);p.set(y,I),I+=u,l&&(this.a[b]=m.slice(u),this.b-=u),u-=u}else p.set(m,I),I+=m.byteLength,l?(this.a.shift(),this.b-=m.byteLength):b++,u-=m.byteLength}return p}}e.$Ph=D;var w;(function(d){d[d.None=0]="None",d[d.Regular=1]="Regular",d[d.Control=2]="Control",d[d.Ack=3]="Ack",d[d.Disconnect=5]="Disconnect",d[d.ReplayRequest=6]="ReplayRequest",d[d.Pause=7]="Pause",d[d.Resume=8]="Resume",d[d.KeepAlive=9]="KeepAlive"})(w||(w={}));function E(d){switch(d){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive"}}var S;(function(d){d[d.HeaderLength=13]="HeaderLength",d[d.AcknowledgeTime=2e3]="AcknowledgeTime",d[d.TimeoutTime=2e4]="TimeoutTime",d[d.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",d[d.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",d[d.KeepAliveSendTime=5e3]="KeepAliveSendTime"})(S||(e.ProtocolConstants=S={}));class c{constructor(u,l,p,I){this.type=u,this.id=l,this.ack=p,this.data=I,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends f.$Tc{constructor(u){super(),this.f=this.B(new N.$Vd),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=u,this.b=!1,this.c=new D,this.B(this.a.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(u){if(!(!u||u.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(u);this.c.byteLength>=this.g.readLen;){const l=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=l.readUInt32BE(9),this.g.messageType=l.readUInt8(0),this.g.id=l.readUInt32BE(1),this.g.ack=l.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:E(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const p=this.g.messageType,I=this.g.id,b=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",l),this.f.fire(new c(p,I,b,l)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class o{constructor(u){this.k=null,this.a=!1,this.b=!1,this.c=u,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(u){if(this.a)return;u.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=C.$je.alloc(13);l.writeUInt8(u.type,0),l.writeUInt32BE(u.id,1),l.writeUInt32BE(u.ack,5),l.writeUInt32BE(u.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:E(u.type),id:u.id,ack:u.ack,messageSize:u.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",u.data),this.j(l,u.data)}g(u,l){const p=this.f===0;return this.d.push(u,l),this.f+=u.byteLength+l.byteLength,p}h(){const u=C.$je.concat(this.d,this.f);return this.d.length=0,this.f=0,u}j(u,l){this.g(u,l)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const u=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:u.byteLength}),this.c.write(u)}}class i extends f.$Tc{constructor(u){super(),this.f=new N.$Vd,this.onMessage=this.f.event,this.g=new N.$Vd,this.onDidDispose=this.g.event,this.a=u,this.b=this.B(new o(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(l=>{l.type===1&&this.f.fire(l.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(u){this.b.write(new c(1,0,0,u))}}e.$Qh=i;class r extends P.$Kh{static fromSocket(u,l){return new r(new i(u),l)}get onDidDispose(){return this.b.onDidDispose}constructor(u,l,p=null){super(u,l,p),this.b=u}dispose(){super.dispose();const u=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),u.end()}}e.$Rh=r;class n{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new N.$Vd({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(u){this.b?this.d.length>0?this.d.push(u):this.a.fire(u):this.d.push(u)}flushBuffer(){this.d=[]}}e.$Sh=n;class a{constructor(u){this.data=u,this.next=null}}class t{constructor(){this.a=null,this.b=null}length(){let u=0,l=this.a;for(;l;)l=l.next,u++;return u}peek(){return this.a?this.a.data:null}toArray(){const u=[];let l=0,p=this.a;for(;p;)u[l++]=p.data,p=p.next;return u}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(u){const l=new a(u);if(!this.a){this.a=l,this.b=l;return}this.b.next=l,this.b=l}}class h{static{this.a=10}static{this.b=null}static getInstance(){return h.b||(h.b=new h),h.b}constructor(){this.c=[];const u=Date.now();for(let l=0;l<h.a;l++)this.c[l]=u-1e3*l;setInterval(()=>{for(let l=h.a;l>=1;l--)this.c[l]=this.c[l-1];this.c[0]=Date.now()},1e3)}d(){const u=Date.now(),l=(1+h.a)*1e3;let p=0;for(let I=0;I<h.a;I++)u-this.c[I]<=l&&p++;return 1-p/h.a}hasHighLoad(){return this.d()>=.5}}class s{get unacknowledgedCount(){return this.c-this.d}constructor(u){this.u=new n,this.onControlMessage=this.u.event,this.v=new n,this.onMessage=this.v.event,this.w=new n,this.onDidDispose=this.w.event,this.x=new n,this.onSocketClose=this.x.event,this.y=new n,this.onSocketTimeout=this.y.event,this.s=u.loadEstimator??h.getInstance(),this.t=u.sendKeepAlive??!0,this.a=!1,this.b=new t,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.r=new f.$Sc,this.o=u.socket,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(l=>this.z(l))),this.r.add(this.o.onClose(l=>this.x.fire(l))),u.initialChunk&&this.q.acceptChunk(u.initialChunk),this.t?this.l=setInterval(()=>{this.D()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.r.dispose()}drain(){return this.p.drain()}sendDisconnect(){const u=new c(5,0,0,A());this.p.write(u),this.p.flush()}sendPause(){const u=new c(7,0,0,A());this.p.write(u)}sendResume(){const u=new c(8,0,0,A());this.p.write(u)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(u,l){this.a=!0,this.r.dispose(),this.r=new f.$Sc,this.u.flushBuffer(),this.x.flushBuffer(),this.y.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=u,this.p=this.r.add(new o(this.o)),this.q=this.r.add(new g(this.o)),this.r.add(this.q.onMessage(p=>this.z(p))),this.r.add(this.o.onClose(p=>this.x.fire(p))),this.q.acceptChunk(l)}endAcceptReconnection(){this.a=!1,this.h=this.g;const u=new c(3,0,this.h,A());this.p.write(u);const l=this.b.toArray();for(let p=0,I=l.length;p<I;p++)this.p.write(l[p]);this.B()}acceptDisconnect(){this.w.fire()}z(u){if(u.ack>this.d){this.d=u.ack;do{const l=this.b.peek();if(l&&l.id<=u.ack)this.b.pop();else break}while(!0)}switch(u.type){case 0:break;case 1:{if(u.id>this.g)if(u.id!==this.g+1){const l=Date.now();l-this.m>1e4&&(this.m=l,this.p.write(new c(6,0,0,A())))}else this.g=u.id,this.j=Date.now(),this.A(),this.v.fire(u.data);break}case 2:{this.u.fire(u.data);break}case 3:break;case 5:{this.w.fire();break}case 6:{const l=this.b.toArray();for(let p=0,I=l.length;p<I;p++)this.p.write(l[p]);this.B();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(u){const l=++this.c;this.h=this.g;const p=new c(1,l,this.h,u);this.b.push(p),this.a||(this.p.write(p),this.B())}sendControl(u){const l=new c(2,0,0,u);this.p.write(l)}A(){if(this.g<=this.h||this.k)return;const u=Date.now()-this.j;if(u>=2e3){this.C();return}this.k=setTimeout(()=>{this.k=null,this.A()},2e3-u+5)}B(){if(this.c<=this.d||this.f||this.a)return;const u=this.b.peek(),l=Date.now()-u.writtenTime,p=Date.now()-this.q.lastReadTime,I=Date.now()-this.n;if(l>=2e4&&p>=2e4&&I>=2e4&&!this.s.hasHighLoad()){this.n=Date.now(),this.y.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:p});return}const b=Math.max(2e4-l,2e4-p,2e4-I,500);this.f=setTimeout(()=>{this.f=null,this.B()},b)}C(){if(this.g<=this.h)return;this.h=this.g;const u=new c(3,0,this.h,A());this.p.write(u)}D(){this.h=this.g;const u=new c(9,0,this.h,A());this.p.write(u)}}e.$Th=s}),define(ke[187],Se([1,0,50,11,22,21,185,14,4,3,24,105,102,81]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$qq=void 0;class S extends E.$Hh{constructor(o){super({send:i=>{try{process.send?.(i.buffer.toString("base64"))}catch{}},onMessage:$.Event.fromNodeEventEmitter(process,"message",i=>f.$je.wrap(Buffer.from(i,"base64")))},o),process.once("disconnect",()=>this.dispose())}}e.$qq=S;class c{constructor(o,i){this.i=o,this.j=i,this.c=new Set,this.g=new Map,this.h=new $.$Vd,this.onDidProcessExit=this.h.event;const r=i&&i.timeout?i.timeout:6e4;this.b=new N.$3g(r),this.d=null,this.f=null}getChannel(o){const i=this;return{call(r,n,a){return i.k(o,r,n,a)},listen(r,n){return i.l(o,r,n)}}}k(o,i,r,n=P.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(n.isCancellationRequested)return Promise.reject(v.$6());this.b.cancel();const a=this.n(o),t=(0,N.$Tg)(d=>a.call(i,r,d)),h=n.onCancellationRequested(()=>t.cancel()),s=(0,k.$Rc)(()=>t.cancel());return this.c.add(s),t.finally(()=>{h.dispose(),this.c.delete(s),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(o,i,r){if(!this.b)return $.Event.None;this.b.cancel();let n;const a=new $.$Vd({onWillAddFirstListener:()=>{n=this.n(o).listen(i,r)(a.fire,a),this.c.add(n)},onDidRemoveLastListener:()=>{this.c.delete(n),n.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return a.event}get m(){if(!this.f){const o=this.j&&this.j.args?this.j.args:[],i=Object.create(null);i.env={...(0,A.$vn)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(i.env={...i.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(i.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(i.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(i.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),i.execArgv===void 0&&(i.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u)).filter(u=>!u.startsWith("--vscode-"))),(0,w.$Sl)(i.env),this.d=(0,C.fork)(this.i,o,i);const r=new $.$Vd;$.Event.fromNodeEventEmitter(this.d,"message",u=>u)(u=>{if((0,R.$mq)(u)){(0,R.log)(u,`IPC Library: ${this.j.serverName}`);return}r.fire(f.$je.wrap(Buffer.from(u,"base64")))});const a=this.j.useQueue?(0,D.$Ul)(this.d):this.d,t=u=>this.d&&this.d.connected&&a.send(u.buffer.toString("base64")),h=r.event,s={send:t,onMessage:h};this.f=new E.$Ih(s);const d=()=>this.o();process.once("exit",d),this.d.on("error",u=>console.warn('IPC "'+this.j.serverName+'" errored with '+u)),this.d.on("exit",(u,l)=>{process.removeListener("exit",d),this.c.forEach(p=>(0,k.$Oc)(p)),this.c.clear(),u!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+u+" and signal "+l),this.b?.cancel(),this.o(),this.h.fire({code:u,signal:l})})}return this.f}n(o){let i=this.g.get(o);return i||(i=this.m.getChannel(o),this.g.set(o,i)),i}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$rq=c}),define(ke[188],Se([1,0,11,4,3,56,18]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rp=e.$qp=e.StorageState=e.$pp=e.StorageHint=void 0;var v;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",w[w.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(v||(e.StorageHint=v={}));function $(w){const E=w;return E?.changed instanceof Map||E?.deleted instanceof Set}e.$pp=$;var k;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(k||(e.StorageState=k={}));class A extends f.$Tc{static{this.a=100}constructor(E,S=Object.create(null)){super(),this.r=E,this.s=S,this.b=this.B(new N.$Yd),this.onDidChangeStorage=this.b.event,this.c=k.None,this.f=new Map,this.g=this.B(new C.$4g(A.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(E=>this.u(E)))}u(E){this.b.pause();try{E.changed?.forEach((S,c)=>this.w(c,S)),E.deleted?.forEach(S=>this.w(S,void 0))}finally{this.b.resume()}}w(E,S){if(this.c===k.Closed)return;let c=!1;(0,R.$Rf)(S)?c=this.f.delete(E):this.f.get(E)!==S&&(this.f.set(E,S),c=!0),c&&this.b.fire({key:E,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===k.None&&(this.c=k.Initialized,this.s.hint!==v.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(E,S){const c=this.f.get(E);return(0,R.$Rf)(c)?S:c}getBoolean(E,S){const c=this.get(E);return(0,R.$Rf)(c)?S:c==="true"}getNumber(E,S){const c=this.get(E);return(0,R.$Rf)(c)?S:parseInt(c,10)}getObject(E,S){const c=this.get(E);return(0,R.$Rf)(c)?S:(0,P.$Bh)(c)}async set(E,S,c=!1){if(this.c===k.Closed)return;if((0,R.$Rf)(S))return this.delete(E,c);const g=(0,R.$Kf)(S)||Array.isArray(S)?(0,P.$Ah)(S):String(S);if(this.f.get(E)!==g)return this.f.set(E,g),this.j.set(E,g),this.h.delete(E),this.b.fire({key:E,external:c}),this.D()}async delete(E,S=!1){if(!(this.c===k.Closed||!this.f.delete(E)))return this.h.has(E)||this.h.add(E),this.j.delete(E),this.b.fire({key:E,external:S}),this.D()}async optimize(){if(this.c!==k.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=k.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const E={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(E).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(E){if(this.z)return this.D(E)}async D(E){return this.s.hint===v.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),E)}async whenFlushed(){if(this.z)return new Promise(E=>this.n.push(E))}isInMemory(){return this.s.hint===v.STORAGE_IN_MEMORY}}e.$qp=A;class D{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(E){E.insert?.forEach((S,c)=>this.a.set(c,S)),E.delete?.forEach(S=>this.a.delete(S))}async optimize(){}async close(){}}e.$rp=D}),define(ke[189],Se([1,0,12,10,22]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ct=e.$bt=e.$at=void 0;let P;function R(){return P||(P=new TextDecoder("UTF-16LE")),P}let v;function $(){return v||(v=new TextDecoder("UTF-16BE")),v}let k;function A(){return k||(k=N.$D()?R():$()),k}e.$at=A;function D(S,c,g){const o=new Uint16Array(S.buffer,c,g);return g>0&&(o[0]===65279||o[0]===65534)?w(S,c,g):R().decode(o)}e.$bt=D;function w(S,c,g){const o=[];let i=0;for(let r=0;r<g;r++){const n=f.$le(S,c);c+=2,o[i++]=String.fromCharCode(n)}return o.join("")}class E{constructor(c){this.a=c|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const c=new Uint16Array(this.b.buffer,0,this.d);return A().decode(c)}f(){const c=this.e();this.d=0,this.c===null?this.c=[c]:this.c[this.c.length]=c}appendCharCode(c){const g=this.a-this.d;g<=1&&(g===0||C.$df(c))&&this.f(),this.b[this.d++]=c}appendASCIICharCode(c){this.d===this.a&&this.f(),this.b[this.d++]=c}appendString(c){const g=c.length;if(this.d+g>=this.a){this.f(),this.c[this.c.length]=c;return}for(let o=0;o<g;o++)this.b[this.d++]=c.charCodeAt(o)}}e.$ct=E}),define(ke[190],Se([1,0,22,189]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$et=e.$dt=void 0;function f($){return $.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class P{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(k,A,D,w){this.oldPosition=k,this.oldText=A,this.newPosition=D,this.newText=w}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${f(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${f(this.oldText)}")`:`(replace@${this.oldPosition} "${f(this.oldText)}" with "${f(this.newText)}")`}static a(k){return 4+2*k.length}static c(k,A,D){const w=A.length;C.$oe(k,w,D),D+=4;for(let E=0;E<w;E++)C.$me(k,A.charCodeAt(E),D),D+=2;return D}static d(k,A){const D=C.$ne(k,A);return A+=4,(0,N.$bt)(k,A,D)}writeSize(){return 4+4+P.a(this.oldText)+P.a(this.newText)}write(k,A){return C.$oe(k,this.oldPosition,A),A+=4,C.$oe(k,this.newPosition,A),A+=4,A=P.c(k,this.oldText,A),A=P.c(k,this.newText,A),A}static read(k,A,D){const w=C.$ne(k,A);A+=4;const E=C.$ne(k,A);A+=4;const S=P.d(k,A);A+=P.a(S);const c=P.d(k,A);return A+=P.a(c),D.push(new P(w,S,E,c)),A}}e.$dt=P;function R($,k){return $===null||$.length===0?k:new v($,k).compress()}e.$et=R;class v{constructor(k,A){this.a=k,this.c=A,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let k=0,A=0,D=this.n(k),w=this.l(A);for(;k<this.f||A<this.h;){if(D===null){this.k(w),w=this.l(++A);continue}if(w===null){this.m(D),D=this.n(++k);continue}if(w.oldEnd<=D.newPosition){this.k(w),w=this.l(++A);continue}if(D.newEnd<=w.oldPosition){this.m(D),D=this.n(++k);continue}if(w.oldPosition<D.newPosition){const[o,i]=v.r(w,D.newPosition-w.oldPosition);this.k(o),w=i;continue}if(D.newPosition<w.oldPosition){const[o,i]=v.q(D,w.oldPosition-D.newPosition);this.m(o),D=i;continue}let c,g;if(w.oldEnd===D.newEnd)c=D,g=w,D=this.n(++k),w=this.l(++A);else if(w.oldEnd<D.newEnd){const[o,i]=v.q(D,w.oldLength);c=o,g=w,D=i,w=this.l(++A)}else{const[o,i]=v.r(w,D.newLength);c=D,g=o,D=this.n(++k),w=i}this.d[this.e++]=new P(c.oldPosition,c.oldText,g.newPosition,g.newText),this.g+=c.newLength-c.oldLength,this.j+=g.newLength-g.oldLength}const E=v.s(this.d);return v.t(E)}k(k){this.d[this.e++]=v.o(this.g,k),this.j+=k.newLength-k.oldLength}l(k){return k<this.h?this.c[k]:null}m(k){this.d[this.e++]=v.p(this.j,k),this.g+=k.newLength-k.oldLength}n(k){return k<this.f?this.a[k]:null}static o(k,A){return new P(A.oldPosition-k,A.oldText,A.newPosition,A.newText)}static p(k,A){return new P(A.oldPosition,A.oldText,A.newPosition+k,A.newText)}static q(k,A){const D=k.newText.substr(0,A),w=k.newText.substr(A);return[new P(k.oldPosition,k.oldText,k.newPosition,D),new P(k.oldEnd,"",k.newPosition+A,w)]}static r(k,A){const D=k.oldText.substr(0,A),w=k.oldText.substr(A);return[new P(k.oldPosition,D,k.newPosition,k.newText),new P(k.oldPosition+A,w,k.newEnd,"")]}static s(k){if(k.length===0)return k;const A=[];let D=0,w=k[0];for(let E=1;E<k.length;E++){const S=k[E];w.oldEnd===S.oldPosition?w=new P(w.oldPosition,w.oldText+S.oldText,w.newPosition,w.newText+S.newText):(A[D++]=w,w=S)}return A[D++]=w,A}static t(k){if(k.length===0)return k;const A=[];let D=0;for(let w=0;w<k.length;w++){const E=k[w];E.oldText!==E.newText&&(A[D++]=E)}return A}}}),define(ke[191],Se([1,0,35,17]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bt=void 0;function f(P,R,v,$,k,A){if(Array.isArray(P)){let D=0;for(const w of P){const E=f(w,R,v,$,k,A);if(E===10)return E;E>D&&(D=E)}return D}else{if(typeof P=="string")return $?P==="*"?5:P===v?10:0:0;if(P){const{language:D,pattern:w,scheme:E,hasAccessToAllModels:S,notebookType:c}=P;if(!$&&!S)return 0;c&&k&&(R=k);let g=0;if(E)if(E===R.scheme)g=10;else if(E==="*")g=5;else return 0;if(D)if(D===v)g=10;else if(D==="*")g=Math.max(g,5);else return 0;if(c)if(c===A)g=10;else if(c==="*"&&A!==void 0)g=Math.max(g,5);else return 0;if(w){let o;if(typeof w=="string"?o=w:o={...w,base:(0,N.$hc)(w.base)},o===R.fsPath||(0,C.$Lj)(o,R.fsPath))g=10;else return 0}return g}else return 0}}e.$Bt=f}),define(ke[192],Se([1,0,4,12,29,79,127,167,190,3]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bC=void 0;class A extends k.$Tc{constructor(w,E,S,c,g,o,i){super(),this.m=this.B(new C.$Vd),this.onDidChangeContent=this.m.event,this.f=E,this.j=!o,this.g=c,this.h=g,this.c=new R.$aC(w,S,i)}equals(w){return!(w instanceof A)||this.f!==w.f||this.getEOL()!==w.getEOL()?!1:this.c.equal(w.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(w){return this.c.createSnapshot(w?this.f:"")}getOffsetAt(w,E){return this.c.getOffsetAt(w,E)}getPositionAt(w){return this.c.getPositionAt(w)}getRangeAt(w,E){const S=w+E,c=this.getPositionAt(w),g=this.getPositionAt(S);return new f.$Us(c.lineNumber,c.column,g.lineNumber,g.column)}getValueInRange(w,E=0){if(w.isEmpty())return"";const S=this.n(E);return this.c.getValueInRange(w,S)}getValueLengthInRange(w,E=0){if(w.isEmpty())return 0;if(w.startLineNumber===w.endLineNumber)return w.endColumn-w.startColumn;const S=this.getOffsetAt(w.startLineNumber,w.startColumn),c=this.getOffsetAt(w.endLineNumber,w.endColumn);let g=0;const o=this.n(E),i=this.getEOL();if(o.length!==i.length){const r=o.length-i.length,n=w.endLineNumber-w.startLineNumber;g=r*n}return c-S+g}getCharacterCountInRange(w,E=0){if(this.j){let S=0;const c=w.startLineNumber,g=w.endLineNumber;for(let o=c;o<=g;o++){const i=this.getLineContent(o),r=o===c?w.startColumn-1:0,n=o===g?w.endColumn-1:i.length;for(let a=r;a<n;a++)N.$df(i.charCodeAt(a))?(S=S+1,a=a+1):S=S+1}return S+=this.n(E).length*(g-c),S}return this.getValueLengthInRange(w,E)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(w){return this.c.getLineContent(w)}getLineCharCode(w,E){return this.c.getLineCharCode(w,E)}getCharCode(w){return this.c.getCharCode(w)}getLineLength(w){return this.c.getLineLength(w)}getLineMinColumn(w){return 1}getLineMaxColumn(w){return this.getLineLength(w)+1}getLineFirstNonWhitespaceColumn(w){const E=N.$1e(this.getLineContent(w));return E===-1?0:E+1}getLineLastNonWhitespaceColumn(w){const E=N.$3e(this.getLineContent(w));return E===-1?0:E+2}n(w){switch(w){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(w){this.c.setEOL(w)}applyEdits(w,E,S){let c=this.g,g=this.h,o=this.j,i=!0,r=[];for(let u=0;u<w.length;u++){const l=w[u];i&&l._isTracked&&(i=!1);const p=l.range;if(l.text){let L=!0;o||(L=!N.$of(l.text),o=L),!c&&L&&(c=N.$nf(l.text)),!g&&L&&(g=N.$qf(l.text))}let I="",b=0,m=0,y=0;if(l.text){let L;[b,m,y,L]=(0,v.$ut)(l.text);const F=this.getEOL();L===0||L===(F===`\r
`?2:1)?I=l.text:I=l.text.replace(/\r\n|\r|\n/g,F)}r[u]={sortIndex:u,identifier:l.identifier||null,range:p,rangeOffset:this.getOffsetAt(p.startLineNumber,p.startColumn),rangeLength:this.getValueLengthInRange(p),text:I,eolCount:b,firstLineLength:m,lastLineLength:y,forceMoveMarkers:!!l.forceMoveMarkers,isAutoWhitespaceEdit:l.isAutoWhitespaceEdit||!1}}r.sort(A.u);let n=!1;for(let u=0,l=r.length-1;u<l;u++){const p=r[u].range.getEndPosition(),I=r[u+1].range.getStartPosition();if(I.isBeforeOrEqual(p)){if(I.isBefore(p))throw new Error("Overlapping ranges are not allowed!");n=!0}}i&&(r=this.s(r));const a=S||E?A._getInverseEditRanges(r):[],t=[];if(E)for(let u=0;u<r.length;u++){const l=r[u],p=a[u];if(l.isAutoWhitespaceEdit&&l.range.isEmpty())for(let I=p.startLineNumber;I<=p.endLineNumber;I++){let b="";I===p.startLineNumber&&(b=this.getLineContent(l.range.startLineNumber),N.$1e(b)!==-1)||t.push({lineNumber:I,oldContent:b})}}let h=null;if(S){let u=0;h=[];for(let l=0;l<r.length;l++){const p=r[l],I=a[l],b=this.getValueInRange(p.range),m=p.rangeOffset+u;u+=p.text.length-b.length,h[l]={sortIndex:p.sortIndex,identifier:p.identifier,range:I,text:b,textChange:new $.$dt(p.rangeOffset,b,m,p.text)}}n||h.sort((l,p)=>l.sortIndex-p.sortIndex)}this.g=c,this.h=g,this.j=o;const s=this.t(r);let d=null;if(E&&t.length>0){t.sort((u,l)=>l.lineNumber-u.lineNumber),d=[];for(let u=0,l=t.length;u<l;u++){const p=t[u].lineNumber;if(u>0&&t[u-1].lineNumber===p)continue;const I=t[u].oldContent,b=this.getLineContent(p);b.length===0||b===I||N.$1e(b)!==-1||d.push(p)}}return this.m.fire(),new P.$ev(h,s,d)}s(w){return w.length<1e3?w:[this._toSingleEditOperation(w)]}_toSingleEditOperation(w){let E=!1;const S=w[0].range,c=w[w.length-1].range,g=new f.$Us(S.startLineNumber,S.startColumn,c.endLineNumber,c.endColumn);let o=S.startLineNumber,i=S.startColumn;const r=[];for(let s=0,d=w.length;s<d;s++){const u=w[s],l=u.range;E=E||u.forceMoveMarkers,r.push(this.getValueInRange(new f.$Us(o,i,l.startLineNumber,l.startColumn))),u.text.length>0&&r.push(u.text),o=l.endLineNumber,i=l.endColumn}const n=r.join(""),[a,t,h]=(0,v.$ut)(n);return{sortIndex:0,identifier:w[0].identifier,range:g,rangeOffset:this.getOffsetAt(g.startLineNumber,g.startColumn),rangeLength:this.getValueLengthInRange(g,0),text:n,eolCount:a,firstLineLength:t,lastLineLength:h,forceMoveMarkers:E,isAutoWhitespaceEdit:!1}}t(w){w.sort(A.w);const E=[];for(let S=0;S<w.length;S++){const c=w[S],g=c.range.startLineNumber,o=c.range.startColumn,i=c.range.endLineNumber,r=c.range.endColumn;if(g===i&&o===r&&c.text.length===0)continue;c.text?(this.c.delete(c.rangeOffset,c.rangeLength),this.c.insert(c.rangeOffset,c.text,!0)):this.c.delete(c.rangeOffset,c.rangeLength);const n=new f.$Us(g,o,i,r);E.push({range:n,rangeLength:c.rangeLength,text:c.text,rangeOffset:c.rangeOffset,forceMoveMarkers:c.forceMoveMarkers})}return E}findMatchesLineByLine(w,E,S,c){return this.c.findMatchesLineByLine(w,E,S,c)}getPieceTree(){return this.c}static _getInverseEditRange(w,E){const S=w.startLineNumber,c=w.startColumn,[g,o,i]=(0,v.$ut)(E);let r;if(E.length>0){const n=g+1;n===1?r=new f.$Us(S,c,S,c+o):r=new f.$Us(S,c,S+n-1,i+1)}else r=new f.$Us(S,c,S,c);return r}static _getInverseEditRanges(w){const E=[];let S=0,c=0,g=null;for(let o=0,i=w.length;o<i;o++){const r=w[o];let n,a;g?g.range.endLineNumber===r.range.startLineNumber?(n=S,a=c+(r.range.startColumn-g.range.endColumn)):(n=S+(r.range.startLineNumber-g.range.endLineNumber),a=r.range.startColumn):(n=r.range.startLineNumber,a=r.range.startColumn);let t;if(r.text.length>0){const h=r.eolCount+1;h===1?t=new f.$Us(n,a,n,a+r.firstLineLength):t=new f.$Us(n,a,n+h-1,r.lastLineLength+1)}else t=new f.$Us(n,a,n,a);S=t.endLineNumber,c=t.endColumn,E.push(t),g=r}return E}static u(w,E){const S=f.$Us.compareRangesUsingEnds(w.range,E.range);return S===0?w.sortIndex-E.sortIndex:S}static w(w,E){const S=f.$Us.compareRangesUsingEnds(w.range,E.range);return S===0?E.sortIndex-w.sortIndex:-S}}e.$bC=A}),define(ke[193],Se([1,0,12,127,192]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cC=void 0;class P{constructor($,k,A,D,w,E,S,c,g){this.a=$,this.b=k,this.c=A,this.d=D,this.e=w,this.f=E,this.g=S,this.h=c,this.j=g}k($){const k=this.c+this.d+this.e,A=this.c+this.e;return k===0?$===1?`
`:`\r
`:A>k/2?`\r
`:`
`}create($){const k=this.k($),A=this.a;if(this.j&&(k===`\r
`&&(this.c>0||this.d>0)||k===`
`&&(this.c>0||this.e>0)))for(let w=0,E=A.length;w<E;w++){const S=A[w].buffer.replace(/\r\n|\r|\n/g,k),c=(0,N.$9B)(S);A[w]=new N.$_B(S,c)}const D=new f.$bC(A,this.b,k,this.f,this.g,this.h,this.j);return{textBuffer:D,disposable:D}}getFirstLineText($){return this.a[0].buffer.substr(0,$).split(/\r\n|\r|\n/)[0]}}class R{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk($){if($.length===0)return;this.a.length===0&&C.$wf($)&&(this.b=C.$vf,$=$.substr(1));const k=$.charCodeAt($.length-1);k===13||k>=55296&&k<=56319?(this.m($.substr(0,$.length-1),!1),this.c=!0,this.d=k):(this.m($,!1),this.c=!1,this.d=k)}m($,k){!k&&$.length===0||(this.c?this.n(String.fromCharCode(this.d)+$):this.n($))}n($){const k=(0,N.$0B)(this.e,$);this.a.push(new N.$_B($,k.lineStarts)),this.f+=k.cr,this.g+=k.lf,this.h+=k.crlf,k.isBasicASCII||(this.l=!1,this.j||(this.j=C.$nf($)),this.k||(this.k=C.$qf($)))}finish($=!0){return this.o(),new P(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,$)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const $=this.a[this.a.length-1];$.buffer+=String.fromCharCode(this.d);const k=(0,N.$9B)($.buffer);$.lineStarts=k,this.d===13&&this.f++}}}e.$cC=R}),define(ke[131],Se([1,0,22,10]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$C$=e.$B$=void 0;var f;(function(D){D[D.Full=1]="Full",D[D.Delta=2]="Delta"})(f||(f={}));function P(D){for(let w=0,E=D.length;w<E;w+=4){const S=D[w+0],c=D[w+1],g=D[w+2],o=D[w+3];D[w+0]=o,D[w+1]=g,D[w+2]=c,D[w+3]=S}}function R(D){const w=new Uint8Array(D.buffer,D.byteOffset,D.length*4);return N.$D()||P(w),C.$je.wrap(w)}function v(D){const w=D.buffer;if(N.$D()||P(w),w.byteOffset%4===0)return new Uint32Array(w.buffer,w.byteOffset,w.length/4);{const E=new Uint8Array(w.byteLength);return E.set(w),new Uint32Array(E.buffer,E.byteOffset,E.length/4)}}function $(D){const w=new Uint32Array(k(D));let E=0;if(w[E++]=D.id,D.type==="full")w[E++]=1,w[E++]=D.data.length,w.set(D.data,E),E+=D.data.length;else{w[E++]=2,w[E++]=D.deltas.length;for(const S of D.deltas)w[E++]=S.start,w[E++]=S.deleteCount,S.data?(w[E++]=S.data.length,w.set(S.data,E),E+=S.data.length):w[E++]=0}return R(w)}e.$B$=$;function k(D){let w=0;if(w+=1+1,D.type==="full")w+=1+D.data.length;else{w+=1,w+=(1+1+1)*D.deltas.length;for(const E of D.deltas)E.data&&(w+=E.data.length)}return w}function A(D){const w=v(D);let E=0;const S=w[E++];if(w[E++]===1){const i=w[E++],r=w.subarray(E,E+i);return E+=i,{id:S,type:"full",data:r}}const g=w[E++],o=[];for(let i=0;i<g;i++){const r=w[E++],n=w[E++],a=w[E++];let t;a>0&&(t=w.subarray(E,E+a),E+=a),o[i]={start:r,deleteCount:n,data:t}}return{id:S,type:"delta",deltas:o}}e.$C$=A}),define(ke[194],Se([8,9]),function(ge,e){return ge.create("vs/editor/common/config/editorOptions",e)}),define(ke[132],Se([1,0,19,24,10,170,126,194]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Keep=1]="Keep",ne[ne.Brackets=2]="Brackets",ne[ne.Advanced=3]="Advanced",ne[ne.Full=4]="Full"})($||(e.EditorAutoIndentStrategy=$={})),e.MINIMAP_GUTTER_WIDTH=8;class k{constructor(se){this.c=se}hasChanged(se){return this.c[se]}}e.ConfigurationChangedEvent=k;class A{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=A;class D{constructor(se,Ce,qe,Ze){this.id=se,this.name=Ce,this.defaultValue=qe,this.schema=Ze}applyUpdate(se,Ce){return E(se,Ce)}compute(se,Ce,qe){return qe}}class w{constructor(se,Ce){this.newValue=se,this.didChange=Ce}}e.ApplyUpdateResult=w;function E(ne,se){if(typeof ne!="object"||typeof se!="object"||!ne||!se)return new w(se,ne!==se);if(Array.isArray(ne)||Array.isArray(se)){const qe=Array.isArray(ne)&&Array.isArray(se)&&C.$ub(ne,se);return new w(se,!qe)}let Ce=!1;for(const qe in se)if(se.hasOwnProperty(qe)){const Ze=E(ne[qe],se[qe]);Ze.didChange&&(ne[qe]=Ze.newValue,Ce=!0)}return new w(ne,Ce)}class S{constructor(se){this.schema=void 0,this.id=se,this.name="_never_",this.defaultValue=void 0}applyUpdate(se,Ce){return E(se,Ce)}validate(se){return this.defaultValue}}class c{constructor(se,Ce,qe,Ze){this.id=se,this.name=Ce,this.defaultValue=qe,this.schema=Ze}applyUpdate(se,Ce){return E(se,Ce)}validate(se){return typeof se>"u"?this.defaultValue:se}compute(se,Ce,qe){return qe}}function g(ne,se){return typeof ne>"u"?se:ne==="false"?!1:!!ne}e.boolean=g;class o extends c{constructor(se,Ce,qe,Ze=void 0){typeof Ze<"u"&&(Ze.type="boolean",Ze.default=qe),super(se,Ce,qe,Ze)}validate(se){return g(se,this.defaultValue)}}function i(ne,se,Ce,qe){if(typeof ne>"u")return se;let Ze=parseInt(ne,10);return isNaN(Ze)?se:(Ze=Math.max(Ce,Ze),Ze=Math.min(qe,Ze),Ze|0)}e.clampedInt=i;class r extends c{static clampedInt(se,Ce,qe,Ze){return i(se,Ce,qe,Ze)}constructor(se,Ce,qe,Ze,it,nt=void 0){typeof nt<"u"&&(nt.type="integer",nt.default=qe,nt.minimum=Ze,nt.maximum=it),super(se,Ce,qe,nt),this.minimum=Ze,this.maximum=it}validate(se){return r.clampedInt(se,this.defaultValue,this.minimum,this.maximum)}}function n(ne,se,Ce,qe){if(typeof ne>"u")return se;const Ze=a.float(ne,se);return a.clamp(Ze,Ce,qe)}e.clampedFloat=n;class a extends c{static clamp(se,Ce,qe){return se<Ce?Ce:se>qe?qe:se}static float(se,Ce){if(typeof se=="number")return se;if(typeof se>"u")return Ce;const qe=parseFloat(se);return isNaN(qe)?Ce:qe}constructor(se,Ce,qe,Ze,it){typeof it<"u"&&(it.type="number",it.default=qe),super(se,Ce,qe,it),this.validationFn=Ze}validate(se){return this.validationFn(a.float(se,this.defaultValue))}}class t extends c{static string(se,Ce){return typeof se!="string"?Ce:se}constructor(se,Ce,qe,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.default=qe),super(se,Ce,qe,Ze)}validate(se){return t.string(se,this.defaultValue)}}function h(ne,se,Ce,qe){return typeof ne!="string"?se:qe&&ne in qe?qe[ne]:Ce.indexOf(ne)===-1?se:ne}e.stringSet=h;class s extends c{constructor(se,Ce,qe,Ze,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Ze,it.default=qe),super(se,Ce,qe,it),this.c=Ze}validate(se){return h(se,this.defaultValue,this.c)}}class d extends D{constructor(se,Ce,qe,Ze,it,nt,Oe=void 0){typeof Oe<"u"&&(Oe.type="string",Oe.enum=it,Oe.default=Ze),super(se,Ce,qe,Oe),this.c=it,this.d=nt}validate(se){return typeof se!="string"?this.defaultValue:this.c.indexOf(se)===-1?this.defaultValue:this.d(se)}}function u(ne){switch(ne){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class l extends D{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[v.localize(0,null),v.localize(1,null),v.localize(2,null)],default:"auto",tags:["accessibility"],description:v.localize(3,null)})}validate(se){switch(se){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(se,Ce,qe){return qe===0?se.accessibilitySupport:qe}}class p extends D{constructor(){const se={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",se,{"editor.comments.insertSpace":{type:"boolean",default:se.insertSpace,description:v.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:se.ignoreEmptyLines,description:v.localize(5,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{insertSpace:g(Ce.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:g(Ce.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var I;(function(ne){ne[ne.Hidden=0]="Hidden",ne[ne.Blink=1]="Blink",ne[ne.Smooth=2]="Smooth",ne[ne.Phase=3]="Phase",ne[ne.Expand=4]="Expand",ne[ne.Solid=5]="Solid"})(I||(e.TextEditorCursorBlinkingStyle=I={}));function b(ne){switch(ne){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var m;(function(ne){ne[ne.Line=1]="Line",ne[ne.Block=2]="Block",ne[ne.Underline=3]="Underline",ne[ne.LineThin=4]="LineThin",ne[ne.BlockOutline=5]="BlockOutline",ne[ne.UnderlineThin=6]="UnderlineThin"})(m||(e.TextEditorCursorStyle=m={}));function y(ne){switch(ne){case m.Line:return"line";case m.Block:return"block";case m.Underline:return"underline";case m.LineThin:return"line-thin";case m.BlockOutline:return"block-outline";case m.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=y;function L(ne){switch(ne){case"line":return m.Line;case"block":return m.Block;case"underline":return m.Underline;case"line-thin":return m.LineThin;case"block-outline":return m.BlockOutline;case"underline-thin":return m.UnderlineThin}}class F extends S{constructor(){super(140)}compute(se,Ce,qe){const Ze=["monaco-editor"];return Ce.get(39)&&Ze.push(Ce.get(39)),se.extraEditorClassName&&Ze.push(se.extraEditorClassName),Ce.get(73)==="default"?Ze.push("mouse-default"):Ce.get(73)==="copy"&&Ze.push("mouse-copy"),Ce.get(110)&&Ze.push("showUnused"),Ce.get(138)&&Ze.push("showDeprecated"),Ze.join(" ")}}class z extends o{constructor(){super(37,"emptySelectionClipboard",!0,{description:v.localize(6,null)})}compute(se,Ce,qe){return qe&&se.emptySelectionClipboard}}class T extends D{constructor(){const se={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",se,{"editor.find.cursorMoveOnType":{type:"boolean",default:se.cursorMoveOnType,description:v.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:se.seedSearchStringFromSelection,enumDescriptions:[v.localize(8,null),v.localize(9,null),v.localize(10,null)],description:v.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:se.autoFindInSelection,enumDescriptions:[v.localize(12,null),v.localize(13,null),v.localize(14,null)],description:v.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:se.globalFindClipboard,description:v.localize(16,null),included:f.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:se.addExtraSpaceOnTop,description:v.localize(17,null)},"editor.find.loop":{type:"boolean",default:se.loop,description:v.localize(18,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{cursorMoveOnType:g(Ce.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof se.seedSearchStringFromSelection=="boolean"?se.seedSearchStringFromSelection?"always":"never":h(Ce.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof se.autoFindInSelection=="boolean"?se.autoFindInSelection?"always":"never":h(Ce.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:g(Ce.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:g(Ce.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:g(Ce.loop,this.defaultValue.loop)}}}class O extends D{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",O.OFF,{anyOf:[{type:"boolean",description:v.localize(19,null)},{type:"string",description:v.localize(20,null)}],description:v.localize(21,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"||se.length===0?O.OFF:se==="true"?O.ON:se:se?O.ON:O.OFF}}e.EditorFontLigatures=O;class M extends D{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",M.OFF,{anyOf:[{type:"boolean",description:v.localize(22,null)},{type:"string",description:v.localize(23,null)}],description:v.localize(24,null),default:!1})}validate(se){return typeof se>"u"?this.defaultValue:typeof se=="string"?se==="false"?M.OFF:se==="true"?M.TRANSLATE:se:se?M.TRANSLATE:M.OFF}compute(se,Ce,qe){return se.fontInfo.fontVariationSettings}}e.EditorFontVariations=M;class j extends S{constructor(){super(50)}compute(se,Ce,qe){return se.fontInfo}}class U extends c{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:v.localize(25,null)})}validate(se){const Ce=a.float(se,this.defaultValue);return Ce===0?e.EDITOR_FONT_DEFAULTS.fontSize:a.clamp(Ce,6,100)}compute(se,Ce,qe){return se.fontInfo.fontSize}}class K extends D{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.d,maximum:K.e,errorMessage:v.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:v.localize(27,null)})}validate(se){return se==="normal"||se==="bold"?se:String(r.clampedInt(se,e.EDITOR_FONT_DEFAULTS.fontWeight,K.d,K.e))}}class ue extends D{constructor(){const se={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Ce={type:"string",enum:["peek","gotoAndPeek","goto"],default:se.multiple,enumDescriptions:[v.localize(28,null),v.localize(29,null),v.localize(30,null)]},qe=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",se,{"editor.gotoLocation.multiple":{deprecationMessage:v.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:v.localize(32,null),...Ce},"editor.gotoLocation.multipleTypeDefinitions":{description:v.localize(33,null),...Ce},"editor.gotoLocation.multipleDeclarations":{description:v.localize(34,null),...Ce},"editor.gotoLocation.multipleImplementations":{description:v.localize(35,null),...Ce},"editor.gotoLocation.multipleReferences":{description:v.localize(36,null),...Ce},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:se.alternativeDefinitionCommand,enum:qe,description:v.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:se.alternativeTypeDefinitionCommand,enum:qe,description:v.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:se.alternativeDeclarationCommand,enum:qe,description:v.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:se.alternativeImplementationCommand,enum:qe,description:v.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:se.alternativeReferenceCommand,enum:qe,description:v.localize(41,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{multiple:h(Ce.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Ce.multipleDefinitions??h(Ce.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Ce.multipleTypeDefinitions??h(Ce.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Ce.multipleDeclarations??h(Ce.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Ce.multipleImplementations??h(Ce.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Ce.multipleReferences??h(Ce.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(Ce.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(Ce.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(Ce.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(Ce.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(Ce.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class X extends D{constructor(){const se={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",se,{"editor.hover.enabled":{type:"boolean",default:se.enabled,description:v.localize(42,null)},"editor.hover.delay":{type:"number",default:se.delay,minimum:0,maximum:1e4,description:v.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:se.sticky,description:v.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:se.hidingDelay,description:v.localize(45,null)},"editor.hover.above":{type:"boolean",default:se.above,description:v.localize(46,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),delay:r.clampedInt(Ce.delay,this.defaultValue.delay,0,1e4),sticky:g(Ce.sticky,this.defaultValue.sticky),hidingDelay:r.clampedInt(Ce.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:g(Ce.above,this.defaultValue.above)}}}var Q;(function(ne){ne[ne.None=0]="None",ne[ne.Text=1]="Text",ne[ne.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class Z extends S{constructor(){super(143)}compute(se,Ce,qe){return Z.computeLayout(Ce,{memory:se.memory,outerWidth:se.outerWidth,outerHeight:se.outerHeight,isDominatedByLongLines:se.isDominatedByLongLines,lineHeight:se.fontInfo.lineHeight,viewLineCount:se.viewLineCount,lineNumbersDigitCount:se.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:se.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:se.fontInfo.maxDigitWidth,pixelRatio:se.pixelRatio,glyphMarginDecorationLaneCount:se.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(se){const Ce=se.height/se.lineHeight,qe=Math.floor(se.paddingTop/se.lineHeight);let Ze=Math.floor(se.paddingBottom/se.lineHeight);se.scrollBeyondLastLine&&(Ze=Math.max(Ze,Ce-1));const it=(qe+se.viewLineCount+Ze)/(se.pixelRatio*se.height),nt=Math.floor(se.viewLineCount/it);return{typicalViewportLineCount:Ce,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:Ze,desiredRatio:it,minimapLineCount:nt}}static c(se,Ce){const qe=se.outerWidth,Ze=se.outerHeight,it=se.pixelRatio;if(!se.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(it*Ze),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ze};const nt=Ce.stableMinimapLayoutInput,Oe=nt&&se.outerHeight===nt.outerHeight&&se.lineHeight===nt.lineHeight&&se.typicalHalfwidthCharacterWidth===nt.typicalHalfwidthCharacterWidth&&se.pixelRatio===nt.pixelRatio&&se.scrollBeyondLastLine===nt.scrollBeyondLastLine&&se.paddingTop===nt.paddingTop&&se.paddingBottom===nt.paddingBottom&&se.minimap.enabled===nt.minimap.enabled&&se.minimap.side===nt.minimap.side&&se.minimap.size===nt.minimap.size&&se.minimap.showSlider===nt.minimap.showSlider&&se.minimap.renderCharacters===nt.minimap.renderCharacters&&se.minimap.maxColumn===nt.minimap.maxColumn&&se.minimap.scale===nt.minimap.scale&&se.verticalScrollbarWidth===nt.verticalScrollbarWidth&&se.isViewportWrapping===nt.isViewportWrapping,yt=se.lineHeight,Dt=se.typicalHalfwidthCharacterWidth,Nt=se.scrollBeyondLastLine,Tt=se.minimap.renderCharacters;let Et=it>=2?Math.round(se.minimap.scale*2):se.minimap.scale;const Ht=se.minimap.maxColumn,Ot=se.minimap.size,Zt=se.minimap.side,Wt=se.verticalScrollbarWidth,Ut=se.viewLineCount,et=se.remainingWidth,Gt=se.isViewportWrapping,Kt=Tt?2:3;let ht=Math.floor(it*Ze);const $t=ht/it;let Bt=!1,Qt=!1,kt=Kt*Et,ft=Et/it,It=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:gt,extraLinesBeforeFirstLine:Ft,extraLinesBeyondLastLine:Rt,desiredRatio:Vt,minimapLineCount:Me}=Z.computeContainedMinimapLineCount({viewLineCount:Ut,scrollBeyondLastLine:Nt,paddingTop:se.paddingTop,paddingBottom:se.paddingBottom,height:Ze,lineHeight:yt,pixelRatio:it});if(Ut/Me>1)Bt=!0,Qt=!0,Et=1,kt=1,ft=Et/it;else{let De=!1,ce=Et+1;if(Ot==="fit"){const Ne=Math.ceil((Ft+Ut+Rt)*kt);Gt&&Oe&&et<=Ce.stableFitRemainingWidth?(De=!0,ce=Ce.stableFitMaxMinimapScale):De=Ne>ht}if(Ot==="fill"||De){Bt=!0;const Ne=Et;kt=Math.min(yt*it,Math.max(1,Math.floor(1/Vt))),Gt&&Oe&&et<=Ce.stableFitRemainingWidth&&(ce=Ce.stableFitMaxMinimapScale),Et=Math.min(ce,Math.max(1,Math.floor(kt/Kt))),Et>Ne&&(It=Math.min(2,Et/Ne)),ft=Et/it/It,ht=Math.ceil(Math.max(gt,Ft+Ut+Rt)*kt),Gt?(Ce.stableMinimapLayoutInput=se,Ce.stableFitRemainingWidth=et,Ce.stableFitMaxMinimapScale=Et):(Ce.stableMinimapLayoutInput=null,Ce.stableFitRemainingWidth=0)}}}const _t=Math.floor(Ht*ft),Lt=Math.min(_t,Math.max(0,Math.floor((et-Wt-2)*ft/(Dt+ft)))+e.MINIMAP_GUTTER_WIDTH);let Ke=Math.floor(it*Lt);const Mt=Ke/it;Ke=Math.floor(Ke*It);const jt=Tt?1:2,Yt=Zt==="left"?0:qe-Lt-Wt;return{renderMinimap:jt,minimapLeft:Yt,minimapWidth:Lt,minimapHeightIsEditorHeight:Bt,minimapIsSampling:Qt,minimapScale:Et,minimapLineHeight:kt,minimapCanvasInnerWidth:Ke,minimapCanvasInnerHeight:ht,minimapCanvasOuterWidth:Mt,minimapCanvasOuterHeight:$t}}static computeLayout(se,Ce){const qe=Ce.outerWidth|0,Ze=Ce.outerHeight|0,it=Ce.lineHeight|0,nt=Ce.lineNumbersDigitCount|0,Oe=Ce.typicalHalfwidthCharacterWidth,yt=Ce.maxDigitWidth,Dt=Ce.pixelRatio,Nt=Ce.viewLineCount,Tt=se.get(135),Et=Tt==="inherit"?se.get(134):Tt,Ht=Et==="inherit"?se.get(130):Et,Ot=se.get(133),Zt=Ce.isDominatedByLongLines,Wt=se.get(57),Ut=se.get(67).renderType!==0,et=se.get(68),Gt=se.get(104),Kt=se.get(83),ht=se.get(72),$t=se.get(102),Bt=$t.verticalScrollbarSize,Qt=$t.verticalHasArrows,kt=$t.arrowSize,ft=$t.horizontalScrollbarSize,It=se.get(43),_t=se.get(109)!=="never";let Lt=se.get(65);It&&_t&&(Lt+=16);let Ke=0;if(Ut){const xe=Math.max(nt,et);Ke=Math.round(xe*yt)}let Mt=0;Wt&&(Mt=it*Ce.glyphMarginDecorationLaneCount);let jt=0,Yt=jt+Mt,gt=Yt+Ke,Ft=gt+Lt;const Rt=qe-Mt-Ke-Lt;let Vt=!1,Me=!1,Te=-1;Et==="inherit"&&Zt?(Vt=!0,Me=!0):Ht==="on"||Ht==="bounded"?Me=!0:Ht==="wordWrapColumn"&&(Te=Ot);const De=Z.c({outerWidth:qe,outerHeight:Ze,lineHeight:it,typicalHalfwidthCharacterWidth:Oe,pixelRatio:Dt,scrollBeyondLastLine:Gt,paddingTop:Kt.top,paddingBottom:Kt.bottom,minimap:ht,verticalScrollbarWidth:Bt,viewLineCount:Nt,remainingWidth:Rt,isViewportWrapping:Me},Ce.memory||new A);De.renderMinimap!==0&&De.minimapLeft===0&&(jt+=De.minimapWidth,Yt+=De.minimapWidth,gt+=De.minimapWidth,Ft+=De.minimapWidth);const ce=Rt-De.minimapWidth,Ne=Math.max(1,Math.floor((ce-Bt-2)/Oe)),Be=Qt?kt:0;return Me&&(Te=Math.max(1,Ne),Ht==="bounded"&&(Te=Math.min(Te,Ot))),{width:qe,height:Ze,glyphMarginLeft:jt,glyphMarginWidth:Mt,glyphMarginDecorationLaneCount:Ce.glyphMarginDecorationLaneCount,lineNumbersLeft:Yt,lineNumbersWidth:Ke,decorationsLeft:gt,decorationsWidth:Lt,contentLeft:Ft,contentWidth:ce,minimap:De,viewportColumn:Ne,isWordWrapMinified:Vt,isViewportWrapping:Me,wrappingColumn:Te,verticalScrollbarWidth:Bt,horizontalScrollbarHeight:ft,overviewRuler:{top:Be,width:Bt,height:Ze-2*Be,right:0}}}}e.EditorLayoutInfoComputer=Z;class le extends D{constructor(){super(137,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[v.localize(47,null),v.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:v.localize(49,null)}})}validate(se){return h(se,"simple",["simple","advanced"])}compute(se,Ce,qe){return Ce.get(2)===2?"advanced":qe}}var re;(function(ne){ne.Off="off",ne.OnCode="onCode",ne.On="on"})(re||(e.ShowLightbulbIconMode=re={}));class $e extends D{constructor(){const se={enabled:re.On};super(64,"lightbulb",se,{"editor.lightbulb.enabled":{type:"string",enum:[re.Off,re.OnCode,re.On],default:se.enabled,enumDescriptions:[v.localize(50,null),v.localize(51,null),v.localize(52,null)],description:v.localize(53,null)}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{enabled:h(se.enabled,this.defaultValue.enabled,[re.Off,re.OnCode,re.On])}}}class oe extends D{constructor(){const se={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(114,"stickyScroll",se,{"editor.stickyScroll.enabled":{type:"boolean",default:se.enabled,description:v.localize(54,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:se.maxLineCount,minimum:1,maximum:10,description:v.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:se.defaultModel,description:v.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:se.scrollWithEditor,description:v.localize(57,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),maxLineCount:r.clampedInt(Ce.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:h(Ce.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:g(Ce.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class J extends D{constructor(){const se={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(139,"inlayHints",se,{"editor.inlayHints.enabled":{type:"string",default:se.enabled,description:v.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[v.localize(59,null),v.localize(60,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(61,null,f.$j?"Ctrl+Option":"Ctrl+Alt"),v.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:se.fontSize,markdownDescription:v.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:se.fontFamily,markdownDescription:v.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:se.padding,description:v.localize(65,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return typeof Ce.enabled=="boolean"&&(Ce.enabled=Ce.enabled?"on":"off"),{enabled:h(Ce.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:r.clampedInt(Ce.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily),padding:g(Ce.padding,this.defaultValue.padding)}}}class V extends D{constructor(){super(65,"lineDecorationsWidth",10)}validate(se){return typeof se=="string"&&/^\d+(\.\d+)?ch$/.test(se)?-parseFloat(se.substring(0,se.length-2)):r.clampedInt(se,this.defaultValue,0,1e3)}compute(se,Ce,qe){return qe<0?r.clampedInt(-qe*se.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):qe}}class ie extends a{constructor(){super(66,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,se=>a.clamp(se,0,150),{markdownDescription:v.localize(66,null)})}compute(se,Ce,qe){return se.fontInfo.lineHeight}}class ye extends D{constructor(){const se={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(72,"minimap",se,{"editor.minimap.enabled":{type:"boolean",default:se.enabled,description:v.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:se.autohide,description:v.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[v.localize(69,null),v.localize(70,null),v.localize(71,null)],default:se.size,description:v.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:se.side,description:v.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:se.showSlider,description:v.localize(74,null)},"editor.minimap.scale":{type:"number",default:se.scale,minimum:1,maximum:3,enum:[1,2,3],description:v.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:se.renderCharacters,description:v.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:se.maxColumn,description:v.localize(77,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),autohide:g(Ce.autohide,this.defaultValue.autohide),size:h(Ce.size,this.defaultValue.size,["proportional","fill","fit"]),side:h(Ce.side,this.defaultValue.side,["right","left"]),showSlider:h(Ce.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:g(Ce.renderCharacters,this.defaultValue.renderCharacters),scale:r.clampedInt(Ce.scale,1,1,3),maxColumn:r.clampedInt(Ce.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function de(ne){return ne==="ctrlCmd"?f.$j?"metaKey":"ctrlKey":"altKey"}class fe extends D{constructor(){super(83,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(78,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:v.localize(79,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{top:r.clampedInt(Ce.top,0,0,1e3),bottom:r.clampedInt(Ce.bottom,0,0,1e3)}}}class _ extends D{constructor(){const se={enabled:!0,cycle:!0};super(85,"parameterHints",se,{"editor.parameterHints.enabled":{type:"boolean",default:se.enabled,description:v.localize(80,null)},"editor.parameterHints.cycle":{type:"boolean",default:se.cycle,description:v.localize(81,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),cycle:g(Ce.cycle,this.defaultValue.cycle)}}}class ee extends S{constructor(){super(141)}compute(se,Ce,qe){return se.pixelRatio}}class G extends D{constructor(){const se={other:"on",comments:"off",strings:"off"},Ce=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[v.localize(82,null),v.localize(83,null),v.localize(84,null)]}];super(88,"quickSuggestions",se,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Ce,default:se.strings,description:v.localize(85,null)},comments:{anyOf:Ce,default:se.comments,description:v.localize(86,null)},other:{anyOf:Ce,default:se.other,description:v.localize(87,null)}},default:se,markdownDescription:v.localize(88,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=se}validate(se){if(typeof se=="boolean"){const Dt=se?"on":"off";return{comments:Dt,strings:Dt,other:Dt}}if(!se||typeof se!="object")return this.defaultValue;const{other:Ce,comments:qe,strings:Ze}=se,it=["on","inline","off"];let nt,Oe,yt;return typeof Ce=="boolean"?nt=Ce?"on":"off":nt=h(Ce,this.defaultValue.other,it),typeof qe=="boolean"?Oe=qe?"on":"off":Oe=h(qe,this.defaultValue.comments,it),typeof Ze=="boolean"?yt=Ze?"on":"off":yt=h(Ze,this.defaultValue.strings,it),{other:nt,comments:Oe,strings:yt}}}var x;(function(ne){ne[ne.Off=0]="Off",ne[ne.On=1]="On",ne[ne.Relative=2]="Relative",ne[ne.Interval=3]="Interval",ne[ne.Custom=4]="Custom"})(x||(e.RenderLineNumbersType=x={}));class me extends D{constructor(){super(67,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[v.localize(89,null),v.localize(90,null),v.localize(91,null),v.localize(92,null)],default:"on",description:v.localize(93,null)})}validate(se){let Ce=this.defaultValue.renderType,qe=this.defaultValue.renderFn;return typeof se<"u"&&(typeof se=="function"?(Ce=4,qe=se):se==="interval"?Ce=3:se==="relative"?Ce=2:se==="on"?Ce=1:Ce=0),{renderType:Ce,renderFn:qe}}}function pe(ne){const se=ne.get(97);return se==="editable"?ne.get(90):se!=="on"}e.filterValidationDecorations=pe;class Re extends D{constructor(){const se=[],Ce={type:"number",description:v.localize(94,null)};super(101,"rulers",se,{type:"array",items:{anyOf:[Ce,{type:["object"],properties:{column:Ce,color:{type:"string",description:v.localize(95,null),format:"color-hex"}}}]},default:se,description:v.localize(96,null)})}validate(se){if(Array.isArray(se)){const Ce=[];for(const qe of se)if(typeof qe=="number")Ce.push({column:r.clampedInt(qe,0,0,1e4),color:null});else if(qe&&typeof qe=="object"){const Ze=qe;Ce.push({column:r.clampedInt(Ze.column,0,0,1e4),color:Ze.color})}return Ce.sort((qe,Ze)=>qe.column-Ze.column),Ce}return this.defaultValue}}class ve extends D{constructor(){super(91,"readOnlyMessage",void 0)}validate(se){return!se||typeof se!="object"?this.defaultValue:se}}function Ie(ne,se){if(typeof ne!="string")return se;switch(ne){case"hidden":return 2;case"visible":return 3;default:return 1}}class B extends D{constructor(){const se={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(102,"scrollbar",se,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(97,null),v.localize(98,null),v.localize(99,null)],default:"auto",description:v.localize(100,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[v.localize(101,null),v.localize(102,null),v.localize(103,null)],default:"auto",description:v.localize(104,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:se.verticalScrollbarSize,description:v.localize(105,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:se.horizontalScrollbarSize,description:v.localize(106,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:se.scrollByPage,description:v.localize(107,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:se.ignoreHorizontalScrollbarInContentHeight,description:v.localize(108,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se,qe=r.clampedInt(Ce.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ze=r.clampedInt(Ce.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:r.clampedInt(Ce.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Ie(Ce.vertical,this.defaultValue.vertical),horizontal:Ie(Ce.horizontal,this.defaultValue.horizontal),useShadows:g(Ce.useShadows,this.defaultValue.useShadows),verticalHasArrows:g(Ce.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:g(Ce.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:g(Ce.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:g(Ce.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:qe,horizontalSliderSize:r.clampedInt(Ce.horizontalSliderSize,qe,0,1e3),verticalScrollbarSize:Ze,verticalSliderSize:r.clampedInt(Ce.verticalSliderSize,Ze,0,1e3),scrollByPage:g(Ce.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:g(Ce.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class Y extends D{constructor(){const se={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(124,"unicodeHighlight",se,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.nonBasicASCII,description:v.localize(109,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:se.invisibleCharacters,description:v.localize(110,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:se.ambiguousCharacters,description:v.localize(111,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeComments,description:v.localize(112,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:se.includeStrings,description:v.localize(113,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:se.allowedCharacters,description:v.localize(114,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:se.allowedLocales,description:v.localize(115,null)}})}applyUpdate(se,Ce){let qe=!1;Ce.allowedCharacters&&se&&(N.$zn(se.allowedCharacters,Ce.allowedCharacters)||(se={...se,allowedCharacters:Ce.allowedCharacters},qe=!0)),Ce.allowedLocales&&se&&(N.$zn(se.allowedLocales,Ce.allowedLocales)||(se={...se,allowedLocales:Ce.allowedLocales},qe=!0));const Ze=super.applyUpdate(se,Ce);return qe?new w(Ze.newValue,!0):Ze}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{nonBasicASCII:he(Ce.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:g(Ce.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:g(Ce.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:he(Ce.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:he(Ce.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(se.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(se.allowedLocales,this.defaultValue.allowedLocales)}}c(se,Ce){if(typeof se!="object"||!se)return Ce;const qe={};for(const[Ze,it]of Object.entries(se))it===!0&&(qe[Ze]=!0);return qe}}class te extends D{constructor(){const se={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",se,{"editor.inlineSuggest.enabled":{type:"boolean",default:se.enabled,description:v.localize(116,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:se.showToolbar,enum:["always","onHover","never"],enumDescriptions:[v.localize(117,null),v.localize(118,null),v.localize(119,null)],description:v.localize(120,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:se.suppressSuggestions,description:v.localize(121,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:se.fontFamily,description:v.localize(122,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),mode:h(Ce.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:h(Ce.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:g(Ce.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:g(Ce.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:t.string(Ce.fontFamily,this.defaultValue.fontFamily)}}}class q extends D{constructor(){const se={enabled:P.$ss.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.$ss.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",se,{"editor.bracketPairColorization.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(123,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:se.independentColorPoolPerBracketType,description:v.localize(124,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:g(Ce.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ae extends D{constructor(){const se={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",se,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(125,null),v.localize(126,null),v.localize(127,null)],default:se.bracketPairs,description:v.localize(128,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[v.localize(129,null),v.localize(130,null),v.localize(131,null)],default:se.bracketPairsHorizontal,description:v.localize(132,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:se.highlightActiveBracketPair,description:v.localize(133,null)},"editor.guides.indentation":{type:"boolean",default:se.indentation,description:v.localize(134,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[v.localize(135,null),v.localize(136,null),v.localize(137,null)],default:se.highlightActiveIndentation,description:v.localize(138,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{bracketPairs:he(Ce.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:he(Ce.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:g(Ce.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:g(Ce.indentation,this.defaultValue.indentation),highlightActiveIndentation:he(Ce.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function he(ne,se,Ce){const qe=Ce.indexOf(ne);return qe===-1?se:Ce[qe]}class Ae extends D{constructor(){const se={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(117,"suggest",se,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[v.localize(139,null),v.localize(140,null)],default:se.insertMode,description:v.localize(141,null)},"editor.suggest.filterGraceful":{type:"boolean",default:se.filterGraceful,description:v.localize(142,null)},"editor.suggest.localityBonus":{type:"boolean",default:se.localityBonus,description:v.localize(143,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:se.shareSuggestSelections,markdownDescription:v.localize(144,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[v.localize(145,null),v.localize(146,null),v.localize(147,null),v.localize(148,null)],default:se.selectionMode,markdownDescription:v.localize(149,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:se.snippetsPreventQuickSuggestions,description:v.localize(150,null)},"editor.suggest.showIcons":{type:"boolean",default:se.showIcons,description:v.localize(151,null)},"editor.suggest.showStatusBar":{type:"boolean",default:se.showStatusBar,description:v.localize(152,null)},"editor.suggest.preview":{type:"boolean",default:se.preview,description:v.localize(153,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:se.showInlineDetails,description:v.localize(154,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:v.localize(155,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:v.localize(156,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:v.localize(157,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:v.localize(158,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:v.localize(159,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:v.localize(160,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:v.localize(161,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:v.localize(162,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:v.localize(163,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:v.localize(164,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:v.localize(165,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:v.localize(166,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:v.localize(167,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:v.localize(168,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:v.localize(169,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:v.localize(170,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:v.localize(171,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:v.localize(172,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:v.localize(173,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:v.localize(174,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:v.localize(175,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:v.localize(176,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:v.localize(177,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:v.localize(178,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:v.localize(179,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:v.localize(180,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:v.localize(181,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:v.localize(182,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:v.localize(183,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:v.localize(184,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:v.localize(185,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:v.localize(186,null)}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{insertMode:h(Ce.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:g(Ce.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:g(Ce.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:g(Ce.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:g(Ce.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:h(Ce.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:g(Ce.showIcons,this.defaultValue.showIcons),showStatusBar:g(Ce.showStatusBar,this.defaultValue.showStatusBar),preview:g(Ce.preview,this.defaultValue.preview),previewMode:h(Ce.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:g(Ce.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:g(Ce.showMethods,this.defaultValue.showMethods),showFunctions:g(Ce.showFunctions,this.defaultValue.showFunctions),showConstructors:g(Ce.showConstructors,this.defaultValue.showConstructors),showDeprecated:g(Ce.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:g(Ce.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:g(Ce.showFields,this.defaultValue.showFields),showVariables:g(Ce.showVariables,this.defaultValue.showVariables),showClasses:g(Ce.showClasses,this.defaultValue.showClasses),showStructs:g(Ce.showStructs,this.defaultValue.showStructs),showInterfaces:g(Ce.showInterfaces,this.defaultValue.showInterfaces),showModules:g(Ce.showModules,this.defaultValue.showModules),showProperties:g(Ce.showProperties,this.defaultValue.showProperties),showEvents:g(Ce.showEvents,this.defaultValue.showEvents),showOperators:g(Ce.showOperators,this.defaultValue.showOperators),showUnits:g(Ce.showUnits,this.defaultValue.showUnits),showValues:g(Ce.showValues,this.defaultValue.showValues),showConstants:g(Ce.showConstants,this.defaultValue.showConstants),showEnums:g(Ce.showEnums,this.defaultValue.showEnums),showEnumMembers:g(Ce.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:g(Ce.showKeywords,this.defaultValue.showKeywords),showWords:g(Ce.showWords,this.defaultValue.showWords),showColors:g(Ce.showColors,this.defaultValue.showColors),showFiles:g(Ce.showFiles,this.defaultValue.showFiles),showReferences:g(Ce.showReferences,this.defaultValue.showReferences),showFolders:g(Ce.showFolders,this.defaultValue.showFolders),showTypeParameters:g(Ce.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:g(Ce.showSnippets,this.defaultValue.showSnippets),showUsers:g(Ce.showUsers,this.defaultValue.showUsers),showIssues:g(Ce.showIssues,this.defaultValue.showIssues)}}}class je extends D{constructor(){super(112,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:v.localize(187,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:v.localize(188,null),default:!0,type:"boolean"}})}validate(se){return!se||typeof se!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:g(se.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:g(se.selectSubwords,this.defaultValue.selectSubwords)}}}var He;(function(ne){ne[ne.None=0]="None",ne[ne.Same=1]="Same",ne[ne.Indent=2]="Indent",ne[ne.DeepIndent=3]="DeepIndent"})(He||(e.WrappingIndent=He={}));class Qe extends D{constructor(){super(136,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[v.localize(189,null),v.localize(190,null),v.localize(191,null),v.localize(192,null)],description:v.localize(193,null),default:"same"}})}validate(se){switch(se){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(se,Ce,qe){return Ce.get(2)===2?0:qe}}class _e extends S{constructor(){super(144)}compute(se,Ce,qe){const Ze=Ce.get(143);return{isDominatedByLongLines:se.isDominatedByLongLines,isWordWrapMinified:Ze.isWordWrapMinified,isViewportWrapping:Ze.isViewportWrapping,wrappingColumn:Ze.wrappingColumn}}}class at extends D{constructor(){const se={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",se,{"editor.dropIntoEditor.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(194,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:v.localize(195,null),enum:["afterDrop","never"],enumDescriptions:[v.localize(196,null),v.localize(197,null)],default:"afterDrop"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showDropSelector:h(Ce.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class st extends D{constructor(){const se={enabled:!0,showPasteSelector:"afterPaste"};super(84,"pasteAs",se,{"editor.pasteAs.enabled":{type:"boolean",default:se.enabled,markdownDescription:v.localize(198,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:v.localize(199,null),enum:["afterPaste","never"],enumDescriptions:[v.localize(200,null),v.localize(201,null)],default:"afterPaste"}})}validate(se){if(!se||typeof se!="object")return this.defaultValue;const Ce=se;return{enabled:g(Ce.enabled,this.defaultValue.enabled),showPasteSelector:h(Ce.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const rt="Consolas, 'Courier New', monospace",Pe="Menlo, Monaco, 'Courier New', monospace",ze="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:f.$j?Pe:f.$k?ze:rt,fontWeight:"normal",fontSize:f.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Le(ne){return e.editorOptionsRegistry[ne.id]=ne,ne}var Ye;(function(ne){ne[ne.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",ne[ne.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",ne[ne.accessibilitySupport=2]="accessibilitySupport",ne[ne.accessibilityPageSize=3]="accessibilityPageSize",ne[ne.ariaLabel=4]="ariaLabel",ne[ne.ariaRequired=5]="ariaRequired",ne[ne.autoClosingBrackets=6]="autoClosingBrackets",ne[ne.autoClosingComments=7]="autoClosingComments",ne[ne.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",ne[ne.autoClosingDelete=9]="autoClosingDelete",ne[ne.autoClosingOvertype=10]="autoClosingOvertype",ne[ne.autoClosingQuotes=11]="autoClosingQuotes",ne[ne.autoIndent=12]="autoIndent",ne[ne.automaticLayout=13]="automaticLayout",ne[ne.autoSurround=14]="autoSurround",ne[ne.bracketPairColorization=15]="bracketPairColorization",ne[ne.guides=16]="guides",ne[ne.codeLens=17]="codeLens",ne[ne.codeLensFontFamily=18]="codeLensFontFamily",ne[ne.codeLensFontSize=19]="codeLensFontSize",ne[ne.colorDecorators=20]="colorDecorators",ne[ne.colorDecoratorsLimit=21]="colorDecoratorsLimit",ne[ne.columnSelection=22]="columnSelection",ne[ne.comments=23]="comments",ne[ne.contextmenu=24]="contextmenu",ne[ne.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",ne[ne.cursorBlinking=26]="cursorBlinking",ne[ne.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",ne[ne.cursorStyle=28]="cursorStyle",ne[ne.cursorSurroundingLines=29]="cursorSurroundingLines",ne[ne.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",ne[ne.cursorWidth=31]="cursorWidth",ne[ne.disableLayerHinting=32]="disableLayerHinting",ne[ne.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",ne[ne.domReadOnly=34]="domReadOnly",ne[ne.dragAndDrop=35]="dragAndDrop",ne[ne.dropIntoEditor=36]="dropIntoEditor",ne[ne.emptySelectionClipboard=37]="emptySelectionClipboard",ne[ne.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",ne[ne.extraEditorClassName=39]="extraEditorClassName",ne[ne.fastScrollSensitivity=40]="fastScrollSensitivity",ne[ne.find=41]="find",ne[ne.fixedOverflowWidgets=42]="fixedOverflowWidgets",ne[ne.folding=43]="folding",ne[ne.foldingStrategy=44]="foldingStrategy",ne[ne.foldingHighlight=45]="foldingHighlight",ne[ne.foldingImportsByDefault=46]="foldingImportsByDefault",ne[ne.foldingMaximumRegions=47]="foldingMaximumRegions",ne[ne.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",ne[ne.fontFamily=49]="fontFamily",ne[ne.fontInfo=50]="fontInfo",ne[ne.fontLigatures=51]="fontLigatures",ne[ne.fontSize=52]="fontSize",ne[ne.fontWeight=53]="fontWeight",ne[ne.fontVariations=54]="fontVariations",ne[ne.formatOnPaste=55]="formatOnPaste",ne[ne.formatOnType=56]="formatOnType",ne[ne.glyphMargin=57]="glyphMargin",ne[ne.gotoLocation=58]="gotoLocation",ne[ne.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",ne[ne.hover=60]="hover",ne[ne.inDiffEditor=61]="inDiffEditor",ne[ne.inlineSuggest=62]="inlineSuggest",ne[ne.letterSpacing=63]="letterSpacing",ne[ne.lightbulb=64]="lightbulb",ne[ne.lineDecorationsWidth=65]="lineDecorationsWidth",ne[ne.lineHeight=66]="lineHeight",ne[ne.lineNumbers=67]="lineNumbers",ne[ne.lineNumbersMinChars=68]="lineNumbersMinChars",ne[ne.linkedEditing=69]="linkedEditing",ne[ne.links=70]="links",ne[ne.matchBrackets=71]="matchBrackets",ne[ne.minimap=72]="minimap",ne[ne.mouseStyle=73]="mouseStyle",ne[ne.mouseWheelScrollSensitivity=74]="mouseWheelScrollSensitivity",ne[ne.mouseWheelZoom=75]="mouseWheelZoom",ne[ne.multiCursorMergeOverlapping=76]="multiCursorMergeOverlapping",ne[ne.multiCursorModifier=77]="multiCursorModifier",ne[ne.multiCursorPaste=78]="multiCursorPaste",ne[ne.multiCursorLimit=79]="multiCursorLimit",ne[ne.occurrencesHighlight=80]="occurrencesHighlight",ne[ne.overviewRulerBorder=81]="overviewRulerBorder",ne[ne.overviewRulerLanes=82]="overviewRulerLanes",ne[ne.padding=83]="padding",ne[ne.pasteAs=84]="pasteAs",ne[ne.parameterHints=85]="parameterHints",ne[ne.peekWidgetDefaultFocus=86]="peekWidgetDefaultFocus",ne[ne.definitionLinkOpensInPeek=87]="definitionLinkOpensInPeek",ne[ne.quickSuggestions=88]="quickSuggestions",ne[ne.quickSuggestionsDelay=89]="quickSuggestionsDelay",ne[ne.readOnly=90]="readOnly",ne[ne.readOnlyMessage=91]="readOnlyMessage",ne[ne.renameOnType=92]="renameOnType",ne[ne.renderControlCharacters=93]="renderControlCharacters",ne[ne.renderFinalNewline=94]="renderFinalNewline",ne[ne.renderLineHighlight=95]="renderLineHighlight",ne[ne.renderLineHighlightOnlyWhenFocus=96]="renderLineHighlightOnlyWhenFocus",ne[ne.renderValidationDecorations=97]="renderValidationDecorations",ne[ne.renderWhitespace=98]="renderWhitespace",ne[ne.revealHorizontalRightPadding=99]="revealHorizontalRightPadding",ne[ne.roundedSelection=100]="roundedSelection",ne[ne.rulers=101]="rulers",ne[ne.scrollbar=102]="scrollbar",ne[ne.scrollBeyondLastColumn=103]="scrollBeyondLastColumn",ne[ne.scrollBeyondLastLine=104]="scrollBeyondLastLine",ne[ne.scrollPredominantAxis=105]="scrollPredominantAxis",ne[ne.selectionClipboard=106]="selectionClipboard",ne[ne.selectionHighlight=107]="selectionHighlight",ne[ne.selectOnLineNumbers=108]="selectOnLineNumbers",ne[ne.showFoldingControls=109]="showFoldingControls",ne[ne.showUnused=110]="showUnused",ne[ne.snippetSuggestions=111]="snippetSuggestions",ne[ne.smartSelect=112]="smartSelect",ne[ne.smoothScrolling=113]="smoothScrolling",ne[ne.stickyScroll=114]="stickyScroll",ne[ne.stickyTabStops=115]="stickyTabStops",ne[ne.stopRenderingLineAfter=116]="stopRenderingLineAfter",ne[ne.suggest=117]="suggest",ne[ne.suggestFontSize=118]="suggestFontSize",ne[ne.suggestLineHeight=119]="suggestLineHeight",ne[ne.suggestOnTriggerCharacters=120]="suggestOnTriggerCharacters",ne[ne.suggestSelection=121]="suggestSelection",ne[ne.tabCompletion=122]="tabCompletion",ne[ne.tabIndex=123]="tabIndex",ne[ne.unicodeHighlighting=124]="unicodeHighlighting",ne[ne.unusualLineTerminators=125]="unusualLineTerminators",ne[ne.useShadowDOM=126]="useShadowDOM",ne[ne.useTabStops=127]="useTabStops",ne[ne.wordBreak=128]="wordBreak",ne[ne.wordSeparators=129]="wordSeparators",ne[ne.wordWrap=130]="wordWrap",ne[ne.wordWrapBreakAfterCharacters=131]="wordWrapBreakAfterCharacters",ne[ne.wordWrapBreakBeforeCharacters=132]="wordWrapBreakBeforeCharacters",ne[ne.wordWrapColumn=133]="wordWrapColumn",ne[ne.wordWrapOverride1=134]="wordWrapOverride1",ne[ne.wordWrapOverride2=135]="wordWrapOverride2",ne[ne.wrappingIndent=136]="wrappingIndent",ne[ne.wrappingStrategy=137]="wrappingStrategy",ne[ne.showDeprecated=138]="showDeprecated",ne[ne.inlayHints=139]="inlayHints",ne[ne.editorClassName=140]="editorClassName",ne[ne.pixelRatio=141]="pixelRatio",ne[ne.tabFocusMode=142]="tabFocusMode",ne[ne.layoutInfo=143]="layoutInfo",ne[ne.wrappingInfo=144]="wrappingInfo",ne[ne.defaultColorDecorators=145]="defaultColorDecorators",ne[ne.colorDecoratorsActivatedOn=146]="colorDecoratorsActivatedOn",ne[ne.inlineCompletionsAccessibilityVerbose=147]="inlineCompletionsAccessibilityVerbose"})(Ye||(e.EditorOption=Ye={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Le(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:v.localize(202,null)})),acceptSuggestionOnEnter:Le(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",v.localize(203,null),""],markdownDescription:v.localize(204,null)})),accessibilitySupport:Le(new l),accessibilityPageSize:Le(new r(3,"accessibilityPageSize",10,1,1073741824,{description:v.localize(205,null),tags:["accessibility"]})),ariaLabel:Le(new t(4,"ariaLabel",v.localize(206,null))),ariaRequired:Le(new o(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Le(new o(8,"screenReaderAnnounceInlineSuggestion",!0,{description:v.localize(207,null),tags:["accessibility"]})),autoClosingBrackets:Le(new s(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(208,null),v.localize(209,null),""],description:v.localize(210,null)})),autoClosingComments:Le(new s(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(211,null),v.localize(212,null),""],description:v.localize(213,null)})),autoClosingDelete:Le(new s(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",v.localize(214,null),""],description:v.localize(215,null)})),autoClosingOvertype:Le(new s(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",v.localize(216,null),""],description:v.localize(217,null)})),autoClosingQuotes:Le(new s(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",v.localize(218,null),v.localize(219,null),""],description:v.localize(220,null)})),autoIndent:Le(new d(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],u,{enumDescriptions:[v.localize(221,null),v.localize(222,null),v.localize(223,null),v.localize(224,null),v.localize(225,null)],description:v.localize(226,null)})),automaticLayout:Le(new o(13,"automaticLayout",!1)),autoSurround:Le(new s(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[v.localize(227,null),v.localize(228,null),v.localize(229,null),""],description:v.localize(230,null)})),bracketPairColorization:Le(new q),bracketPairGuides:Le(new ae),stickyTabStops:Le(new o(115,"stickyTabStops",!1,{description:v.localize(231,null)})),codeLens:Le(new o(17,"codeLens",!0,{description:v.localize(232,null)})),codeLensFontFamily:Le(new t(18,"codeLensFontFamily","",{description:v.localize(233,null)})),codeLensFontSize:Le(new r(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:v.localize(234,null)})),colorDecorators:Le(new o(20,"colorDecorators",!0,{description:v.localize(235,null)})),colorDecoratorActivatedOn:Le(new s(146,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[v.localize(236,null),v.localize(237,null),v.localize(238,null)],description:v.localize(239,null)})),colorDecoratorsLimit:Le(new r(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:v.localize(240,null)})),columnSelection:Le(new o(22,"columnSelection",!1,{description:v.localize(241,null)})),comments:Le(new p),contextmenu:Le(new o(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Le(new o(25,"copyWithSyntaxHighlighting",!0,{description:v.localize(242,null)})),cursorBlinking:Le(new d(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],b,{description:v.localize(243,null)})),cursorSmoothCaretAnimation:Le(new s(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[v.localize(244,null),v.localize(245,null),v.localize(246,null)],description:v.localize(247,null)})),cursorStyle:Le(new d(28,"cursorStyle",m.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],L,{description:v.localize(248,null)})),cursorSurroundingLines:Le(new r(29,"cursorSurroundingLines",0,0,1073741824,{description:v.localize(249,null)})),cursorSurroundingLinesStyle:Le(new s(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[v.localize(250,null),v.localize(251,null)],markdownDescription:v.localize(252,null)})),cursorWidth:Le(new r(31,"cursorWidth",0,0,1073741824,{markdownDescription:v.localize(253,null)})),disableLayerHinting:Le(new o(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Le(new o(33,"disableMonospaceOptimizations",!1)),domReadOnly:Le(new o(34,"domReadOnly",!1)),dragAndDrop:Le(new o(35,"dragAndDrop",!0,{description:v.localize(254,null)})),emptySelectionClipboard:Le(new z),dropIntoEditor:Le(new at),stickyScroll:Le(new oe),experimentalWhitespaceRendering:Le(new s(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[v.localize(255,null),v.localize(256,null),v.localize(257,null)],description:v.localize(258,null)})),extraEditorClassName:Le(new t(39,"extraEditorClassName","")),fastScrollSensitivity:Le(new a(40,"fastScrollSensitivity",5,ne=>ne<=0?5:ne,{markdownDescription:v.localize(259,null)})),find:Le(new T),fixedOverflowWidgets:Le(new o(42,"fixedOverflowWidgets",!1)),folding:Le(new o(43,"folding",!0,{description:v.localize(260,null)})),foldingStrategy:Le(new s(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[v.localize(261,null),v.localize(262,null)],description:v.localize(263,null)})),foldingHighlight:Le(new o(45,"foldingHighlight",!0,{description:v.localize(264,null)})),foldingImportsByDefault:Le(new o(46,"foldingImportsByDefault",!1,{description:v.localize(265,null)})),foldingMaximumRegions:Le(new r(47,"foldingMaximumRegions",5e3,10,65e3,{description:v.localize(266,null)})),unfoldOnClickAfterEndOfLine:Le(new o(48,"unfoldOnClickAfterEndOfLine",!1,{description:v.localize(267,null)})),fontFamily:Le(new t(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:v.localize(268,null)})),fontInfo:Le(new j),fontLigatures2:Le(new O),fontSize:Le(new U),fontWeight:Le(new K),fontVariations:Le(new M),formatOnPaste:Le(new o(55,"formatOnPaste",!1,{description:v.localize(269,null)})),formatOnType:Le(new o(56,"formatOnType",!1,{description:v.localize(270,null)})),glyphMargin:Le(new o(57,"glyphMargin",!0,{description:v.localize(271,null)})),gotoLocation:Le(new ue),hideCursorInOverviewRuler:Le(new o(59,"hideCursorInOverviewRuler",!1,{description:v.localize(272,null)})),hover:Le(new X),inDiffEditor:Le(new o(61,"inDiffEditor",!1)),letterSpacing:Le(new a(63,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,ne=>a.clamp(ne,-5,20),{description:v.localize(273,null)})),lightbulb:Le(new $e),lineDecorationsWidth:Le(new V),lineHeight:Le(new ie),lineNumbers:Le(new me),lineNumbersMinChars:Le(new r(68,"lineNumbersMinChars",5,1,300)),linkedEditing:Le(new o(69,"linkedEditing",!1,{description:v.localize(274,null)})),links:Le(new o(70,"links",!0,{description:v.localize(275,null)})),matchBrackets:Le(new s(71,"matchBrackets","always",["always","near","never"],{description:v.localize(276,null)})),minimap:Le(new ye),mouseStyle:Le(new s(73,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Le(new a(74,"mouseWheelScrollSensitivity",1,ne=>ne===0?1:ne,{markdownDescription:v.localize(277,null)})),mouseWheelZoom:Le(new o(75,"mouseWheelZoom",!1,{markdownDescription:f.$j?v.localize(278,null):v.localize(279,null)})),multiCursorMergeOverlapping:Le(new o(76,"multiCursorMergeOverlapping",!0,{description:v.localize(280,null)})),multiCursorModifier:Le(new d(77,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],de,{markdownEnumDescriptions:[v.localize(281,null),v.localize(282,null)],markdownDescription:v.localize(283,null)})),multiCursorPaste:Le(new s(78,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[v.localize(284,null),v.localize(285,null)],markdownDescription:v.localize(286,null)})),multiCursorLimit:Le(new r(79,"multiCursorLimit",1e4,1,1e5,{markdownDescription:v.localize(287,null)})),occurrencesHighlight:Le(new s(80,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[v.localize(288,null),v.localize(289,null),v.localize(290,null)],markdownDescription:v.localize(291,null)})),overviewRulerBorder:Le(new o(81,"overviewRulerBorder",!0,{description:v.localize(292,null)})),overviewRulerLanes:Le(new r(82,"overviewRulerLanes",3,0,3)),padding:Le(new fe),pasteAs:Le(new st),parameterHints:Le(new _),peekWidgetDefaultFocus:Le(new s(86,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[v.localize(293,null),v.localize(294,null)],description:v.localize(295,null)})),definitionLinkOpensInPeek:Le(new o(87,"definitionLinkOpensInPeek",!1,{description:v.localize(296,null)})),quickSuggestions:Le(new G),quickSuggestionsDelay:Le(new r(89,"quickSuggestionsDelay",10,0,1073741824,{description:v.localize(297,null)})),readOnly:Le(new o(90,"readOnly",!1)),readOnlyMessage:Le(new ve),renameOnType:Le(new o(92,"renameOnType",!1,{description:v.localize(298,null),markdownDeprecationMessage:v.localize(299,null)})),renderControlCharacters:Le(new o(93,"renderControlCharacters",!0,{description:v.localize(300,null),restricted:!0})),renderFinalNewline:Le(new s(94,"renderFinalNewline",f.$k?"dimmed":"on",["off","on","dimmed"],{description:v.localize(301,null)})),renderLineHighlight:Le(new s(95,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",v.localize(302,null)],description:v.localize(303,null)})),renderLineHighlightOnlyWhenFocus:Le(new o(96,"renderLineHighlightOnlyWhenFocus",!1,{description:v.localize(304,null)})),renderValidationDecorations:Le(new s(97,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Le(new s(98,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",v.localize(305,null),v.localize(306,null),v.localize(307,null),""],description:v.localize(308,null)})),revealHorizontalRightPadding:Le(new r(99,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Le(new o(100,"roundedSelection",!0,{description:v.localize(309,null)})),rulers:Le(new Re),scrollbar:Le(new B),scrollBeyondLastColumn:Le(new r(103,"scrollBeyondLastColumn",4,0,1073741824,{description:v.localize(310,null)})),scrollBeyondLastLine:Le(new o(104,"scrollBeyondLastLine",!0,{description:v.localize(311,null)})),scrollPredominantAxis:Le(new o(105,"scrollPredominantAxis",!0,{description:v.localize(312,null)})),selectionClipboard:Le(new o(106,"selectionClipboard",!0,{description:v.localize(313,null),included:f.$k})),selectionHighlight:Le(new o(107,"selectionHighlight",!0,{description:v.localize(314,null)})),selectOnLineNumbers:Le(new o(108,"selectOnLineNumbers",!0)),showFoldingControls:Le(new s(109,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[v.localize(315,null),v.localize(316,null),v.localize(317,null)],description:v.localize(318,null)})),showUnused:Le(new o(110,"showUnused",!0,{description:v.localize(319,null)})),showDeprecated:Le(new o(138,"showDeprecated",!0,{description:v.localize(320,null)})),inlayHints:Le(new J),snippetSuggestions:Le(new s(111,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[v.localize(321,null),v.localize(322,null),v.localize(323,null),v.localize(324,null)],description:v.localize(325,null)})),smartSelect:Le(new je),smoothScrolling:Le(new o(113,"smoothScrolling",!1,{description:v.localize(326,null)})),stopRenderingLineAfter:Le(new r(116,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Le(new Ae),inlineSuggest:Le(new te),inlineCompletionsAccessibilityVerbose:Le(new o(147,"inlineCompletionsAccessibilityVerbose",!1,{description:v.localize(327,null)})),suggestFontSize:Le(new r(118,"suggestFontSize",0,0,1e3,{markdownDescription:v.localize(328,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Le(new r(119,"suggestLineHeight",0,0,1e3,{markdownDescription:v.localize(329,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Le(new o(120,"suggestOnTriggerCharacters",!0,{description:v.localize(330,null)})),suggestSelection:Le(new s(121,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[v.localize(331,null),v.localize(332,null),v.localize(333,null)],description:v.localize(334,null)})),tabCompletion:Le(new s(122,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[v.localize(335,null),v.localize(336,null),v.localize(337,null)],description:v.localize(338,null)})),tabIndex:Le(new r(123,"tabIndex",0,-1,1073741824)),unicodeHighlight:Le(new Y),unusualLineTerminators:Le(new s(125,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[v.localize(339,null),v.localize(340,null),v.localize(341,null)],description:v.localize(342,null)})),useShadowDOM:Le(new o(126,"useShadowDOM",!0)),useTabStops:Le(new o(127,"useTabStops",!0,{description:v.localize(343,null)})),wordBreak:Le(new s(128,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[v.localize(344,null),v.localize(345,null)],description:v.localize(346,null)})),wordSeparators:Le(new t(129,"wordSeparators",R.$ts,{description:v.localize(347,null)})),wordWrap:Le(new s(130,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[v.localize(348,null),v.localize(349,null),v.localize(350,null),v.localize(351,null)],description:v.localize(352,null)})),wordWrapBreakAfterCharacters:Le(new t(131,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Le(new t(132,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Le(new r(133,"wordWrapColumn",80,1,1073741824,{markdownDescription:v.localize(353,null)})),wordWrapOverride1:Le(new s(134,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Le(new s(135,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Le(new F),defaultColorDecorators:Le(new o(145,"defaultColorDecorators",!1,{markdownDescription:v.localize(354,null)})),pixelRatio:Le(new ee),tabFocusMode:Le(new o(142,"tabFocusMode",!1,{markdownDescription:v.localize(355,null)})),layoutInfo:Le(new Z),wrappingInfo:Le(new _e),wrappingIndent:Le(new Qe),wrappingStrategy:Le(new le)}}),define(ke[195],Se([8,9]),function(ge,e){return ge.create("vs/editor/common/languages",e)}),define(ke[83],Se([1,0,78,2,168,29,178,195]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.$Mt=e.$Lt=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.$Kt=e.$Jt=e.SymbolKinds=e.SymbolTag=e.$It=e.$Ht=e.SymbolKind=e.$Gt=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.$Ft=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.$Et=e.$Dt=e.$Ct=void 0;class ${constructor(O,M,j){this.offset=O,this.type=M,this.language=j,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.$Ct=$;class k{constructor(O,M){this.tokens=O,this.endState=M,this._tokenizationResultBrand=void 0}}e.$Dt=k;class A{constructor(O,M){this.tokens=O,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.$Et=A;var D;(function(T){T[T.Method=0]="Method",T[T.Function=1]="Function",T[T.Constructor=2]="Constructor",T[T.Field=3]="Field",T[T.Variable=4]="Variable",T[T.Class=5]="Class",T[T.Struct=6]="Struct",T[T.Interface=7]="Interface",T[T.Module=8]="Module",T[T.Property=9]="Property",T[T.Event=10]="Event",T[T.Operator=11]="Operator",T[T.Unit=12]="Unit",T[T.Value=13]="Value",T[T.Constant=14]="Constant",T[T.Enum=15]="Enum",T[T.EnumMember=16]="EnumMember",T[T.Keyword=17]="Keyword",T[T.Text=18]="Text",T[T.Color=19]="Color",T[T.File=20]="File",T[T.Reference=21]="Reference",T[T.Customcolor=22]="Customcolor",T[T.Folder=23]="Folder",T[T.TypeParameter=24]="TypeParameter",T[T.User=25]="User",T[T.Issue=26]="Issue",T[T.Snippet=27]="Snippet"})(D||(e.CompletionItemKind=D={}));var w;(function(T){const O=new Map;O.set(0,C.$_j.symbolMethod),O.set(1,C.$_j.symbolFunction),O.set(2,C.$_j.symbolConstructor),O.set(3,C.$_j.symbolField),O.set(4,C.$_j.symbolVariable),O.set(5,C.$_j.symbolClass),O.set(6,C.$_j.symbolStruct),O.set(7,C.$_j.symbolInterface),O.set(8,C.$_j.symbolModule),O.set(9,C.$_j.symbolProperty),O.set(10,C.$_j.symbolEvent),O.set(11,C.$_j.symbolOperator),O.set(12,C.$_j.symbolUnit),O.set(13,C.$_j.symbolValue),O.set(15,C.$_j.symbolEnum),O.set(14,C.$_j.symbolConstant),O.set(15,C.$_j.symbolEnum),O.set(16,C.$_j.symbolEnumMember),O.set(17,C.$_j.symbolKeyword),O.set(27,C.$_j.symbolSnippet),O.set(18,C.$_j.symbolText),O.set(19,C.$_j.symbolColor),O.set(20,C.$_j.symbolFile),O.set(21,C.$_j.symbolReference),O.set(22,C.$_j.symbolCustomColor),O.set(23,C.$_j.symbolFolder),O.set(24,C.$_j.symbolTypeParameter),O.set(25,C.$_j.account),O.set(26,C.$_j.issues);function M(K){let ue=O.get(K);return ue||(console.info("No codicon found for CompletionItemKind "+K),ue=C.$_j.symbolProperty),ue}T.toIcon=M;const j=new Map;j.set("method",0),j.set("function",1),j.set("constructor",2),j.set("field",3),j.set("variable",4),j.set("class",5),j.set("struct",6),j.set("interface",7),j.set("module",8),j.set("property",9),j.set("event",10),j.set("operator",11),j.set("unit",12),j.set("value",13),j.set("constant",14),j.set("enum",15),j.set("enum-member",16),j.set("enumMember",16),j.set("keyword",17),j.set("snippet",27),j.set("text",18),j.set("color",19),j.set("file",20),j.set("reference",21),j.set("customcolor",22),j.set("folder",23),j.set("type-parameter",24),j.set("typeParameter",24),j.set("account",25),j.set("issue",26);function U(K,ue){let X=j.get(K);return typeof X>"u"&&!ue&&(X=9),X}T.fromString=U})(w||(e.CompletionItemKinds=w={}));var E;(function(T){T[T.Deprecated=1]="Deprecated"})(E||(e.CompletionItemTag=E={}));var S;(function(T){T[T.None=0]="None",T[T.KeepWhitespace=1]="KeepWhitespace",T[T.InsertAsSnippet=4]="InsertAsSnippet"})(S||(e.CompletionItemInsertTextRule=S={}));var c;(function(T){T[T.Invoke=0]="Invoke",T[T.TriggerCharacter=1]="TriggerCharacter",T[T.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(c||(e.CompletionTriggerKind=c={}));var g;(function(T){T[T.Automatic=0]="Automatic",T[T.Explicit=1]="Explicit"})(g||(e.InlineCompletionTriggerKind=g={}));class o{constructor(O,M,j,U){this.range=O,this.text=M,this.completionKind=j,this.isSnippetText=U}equals(O){return P.$Us.lift(this.range).equalsRange(O.range)&&this.text===O.text&&this.completionKind===O.completionKind&&this.isSnippetText===O.isSnippetText}}e.$Ft=o;var i;(function(T){T[T.Invoke=1]="Invoke",T[T.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var r;(function(T){T[T.Invoke=1]="Invoke",T[T.TriggerCharacter=2]="TriggerCharacter",T[T.ContentChange=3]="ContentChange"})(r||(e.SignatureHelpTriggerKind=r={}));var n;(function(T){T[T.Text=0]="Text",T[T.Read=1]="Read",T[T.Write=2]="Write"})(n||(e.DocumentHighlightKind=n={}));function a(T){return T&&N.URI.isUri(T.uri)&&P.$Us.isIRange(T.range)&&(P.$Us.isIRange(T.originSelectionRange)||P.$Us.isIRange(T.targetSelectionRange))}e.$Gt=a;var t;(function(T){T[T.File=0]="File",T[T.Module=1]="Module",T[T.Namespace=2]="Namespace",T[T.Package=3]="Package",T[T.Class=4]="Class",T[T.Method=5]="Method",T[T.Property=6]="Property",T[T.Field=7]="Field",T[T.Constructor=8]="Constructor",T[T.Enum=9]="Enum",T[T.Interface=10]="Interface",T[T.Function=11]="Function",T[T.Variable=12]="Variable",T[T.Constant=13]="Constant",T[T.String=14]="String",T[T.Number=15]="Number",T[T.Boolean=16]="Boolean",T[T.Array=17]="Array",T[T.Object=18]="Object",T[T.Key=19]="Key",T[T.Null=20]="Null",T[T.EnumMember=21]="EnumMember",T[T.Struct=22]="Struct",T[T.Event=23]="Event",T[T.Operator=24]="Operator",T[T.TypeParameter=25]="TypeParameter"})(t||(e.SymbolKind=t={})),e.$Ht={[17]:(0,v.localize)(0,null),[16]:(0,v.localize)(1,null),[4]:(0,v.localize)(2,null),[13]:(0,v.localize)(3,null),[8]:(0,v.localize)(4,null),[9]:(0,v.localize)(5,null),[21]:(0,v.localize)(6,null),[23]:(0,v.localize)(7,null),[7]:(0,v.localize)(8,null),[0]:(0,v.localize)(9,null),[11]:(0,v.localize)(10,null),[10]:(0,v.localize)(11,null),[19]:(0,v.localize)(12,null),[5]:(0,v.localize)(13,null),[1]:(0,v.localize)(14,null),[2]:(0,v.localize)(15,null),[20]:(0,v.localize)(16,null),[15]:(0,v.localize)(17,null),[18]:(0,v.localize)(18,null),[24]:(0,v.localize)(19,null),[3]:(0,v.localize)(20,null),[6]:(0,v.localize)(21,null),[14]:(0,v.localize)(22,null),[22]:(0,v.localize)(23,null),[25]:(0,v.localize)(24,null),[12]:(0,v.localize)(25,null)};function h(T,O){return(0,v.localize)(26,null,T,e.$Ht[O])}e.$It=h;var s;(function(T){T[T.Deprecated=1]="Deprecated"})(s||(e.SymbolTag=s={}));var d;(function(T){const O=new Map;O.set(0,C.$_j.symbolFile),O.set(1,C.$_j.symbolModule),O.set(2,C.$_j.symbolNamespace),O.set(3,C.$_j.symbolPackage),O.set(4,C.$_j.symbolClass),O.set(5,C.$_j.symbolMethod),O.set(6,C.$_j.symbolProperty),O.set(7,C.$_j.symbolField),O.set(8,C.$_j.symbolConstructor),O.set(9,C.$_j.symbolEnum),O.set(10,C.$_j.symbolInterface),O.set(11,C.$_j.symbolFunction),O.set(12,C.$_j.symbolVariable),O.set(13,C.$_j.symbolConstant),O.set(14,C.$_j.symbolString),O.set(15,C.$_j.symbolNumber),O.set(16,C.$_j.symbolBoolean),O.set(17,C.$_j.symbolArray),O.set(18,C.$_j.symbolObject),O.set(19,C.$_j.symbolKey),O.set(20,C.$_j.symbolNull),O.set(21,C.$_j.symbolEnumMember),O.set(22,C.$_j.symbolStruct),O.set(23,C.$_j.symbolEvent),O.set(24,C.$_j.symbolOperator),O.set(25,C.$_j.symbolTypeParameter);function M(j){let U=O.get(j);return U||(console.info("No codicon found for SymbolKind "+j),U=C.$_j.symbolProperty),U}T.toIcon=M})(d||(e.SymbolKinds=d={}));class u{static asEditOperation(O){return f.$Vs.replace(P.$Us.lift(O.range),O.text)}}e.$Jt=u;class l{static{this.Comment=new l("comment")}static{this.Imports=new l("imports")}static{this.Region=new l("region")}static fromValue(O){switch(O){case"comment":return l.Comment;case"imports":return l.Imports;case"region":return l.Region}return new l(O)}constructor(O){this.value=O}}e.$Kt=l;var p;(function(T){function O(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}T.is=O})(p||(e.Command=p={}));var I;(function(T){T[T.Collapsed=0]="Collapsed",T[T.Expanded=1]="Expanded"})(I||(e.CommentThreadCollapsibleState=I={}));var b;(function(T){T[T.Unresolved=0]="Unresolved",T[T.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var m;(function(T){T[T.Editing=0]="Editing",T[T.Preview=1]="Preview"})(m||(e.CommentMode=m={}));var y;(function(T){T[T.Published=0]="Published",T[T.Draft=1]="Draft"})(y||(e.CommentState=y={}));var L;(function(T){T[T.Type=1]="Type",T[T.Parameter=2]="Parameter"})(L||(e.InlayHintKind=L={}));class F{constructor(O){this.b=O,this.a=null}dispose(){this.a&&this.a.then(O=>{O&&O.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.$Lt=F,e.$Mt=new R.$tt;var z;(function(T){T[T.None=0]="None",T[T.Option=1]="Option",T[T.Default=2]="Default",T[T.Preferred=3]="Preferred"})(z||(e.ExternalUriOpenerPriority=z={}))}),define(ke[196],Se([8,9]),function(ge,e){return ge.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ke[197],Se([8,9]),function(ge,e){return ge.create("vs/platform/contextkey/common/contextkey",e)}),define(ke[198],Se([8,9]),function(ge,e){return ge.create("vs/platform/contextkey/common/scanner",e)}),define(ke[199],Se([8,9]),function(ge,e){return ge.create("vs/platform/dialogs/common/dialogs",e)}),define(ke[200],Se([8,9]),function(ge,e){return ge.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ke[201],Se([8,9]),function(ge,e){return ge.create("vs/platform/extensions/common/extensionValidator",e)}),define(ke[202],Se([8,9]),function(ge,e){return ge.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ke[203],Se([8,9]),function(ge,e){return ge.create("vs/platform/files/common/files",e)}),define(ke[204],Se([8,9]),function(ge,e){return ge.create("vs/platform/files/common/io",e)}),define(ke[205],Se([8,9]),function(ge,e){return ge.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(ke[206],Se([8,9]),function(ge,e){return ge.create("vs/platform/markers/common/markers",e)}),define(ke[207],Se([8,9]),function(ge,e){return ge.create("vs/platform/theme/common/iconRegistry",e)}),define(ke[208],Se([8,9]),function(ge,e){return ge.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(ke[209],Se([8,9]),function(ge,e){return ge.create("vs/platform/workspace/common/workspace",e)}),define(ke[210],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostChatAgents2",e)}),define(ke[211],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ke[212],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ke[213],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(ke[214],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostLogService",e)}),define(ke[215],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostNotebook",e)}),define(ke[216],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ke[217],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ke[218],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ke[219],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ke[220],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostTunnelService",e)}),define(ke[221],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ke[222],Se([8,9]),function(ge,e){return ge.create("vs/workbench/api/node/extHostDebugService",e)}),define(ke[223],Se([8,9]),function(ge,e){return ge.create("vs/workbench/common/configuration",e)}),define(ke[224],Se([8,9]),function(ge,e){return ge.create("vs/workbench/common/editor",e)}),define(ke[225],Se([8,9]),function(ge,e){return ge.create("vs/workbench/common/views",e)}),define(ke[226],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ke[227],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/debug/common/debug",e)}),define(ke[228],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ke[229],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ke[230],Se([8,9]),function(ge,e){return ge.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ke[231],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ke[232],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(ke[233],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ke[234],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/remote/common/tunnelModel",e)}),define(ke[235],Se([8,9]),function(ge,e){return ge.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ke[236],Se([1,0,14,198]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.TokenType=void 0;var f;(function(k){k[k.LParen=0]="LParen",k[k.RParen=1]="RParen",k[k.Neg=2]="Neg",k[k.Eq=3]="Eq",k[k.NotEq=4]="NotEq",k[k.Lt=5]="Lt",k[k.LtEq=6]="LtEq",k[k.Gt=7]="Gt",k[k.GtEq=8]="GtEq",k[k.RegexOp=9]="RegexOp",k[k.RegexStr=10]="RegexStr",k[k.True=11]="True",k[k.False=12]="False",k[k.In=13]="In",k[k.Not=14]="Not",k[k.And=15]="And",k[k.Or=16]="Or",k[k.Str=17]="Str",k[k.QuotedStr=18]="QuotedStr",k[k.Error=19]="Error",k[k.EOF=20]="EOF"})(f||(e.TokenType=f={}));function P(...k){switch(k.length){case 1:return(0,N.localize)(0,null,k[0]);case 2:return(0,N.localize)(1,null,k[0],k[1]);case 3:return(0,N.localize)(2,null,k[0],k[1],k[2]);default:return}}const R=(0,N.localize)(3,null),v=(0,N.localize)(4,null);class ${constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(A){switch(A.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return A.isTripleEq?"===":"==";case 4:return A.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return A.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return A.lexeme;case 18:return A.lexeme;case 19:return A.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(A)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(A=>A.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(A){return this.c=A,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const D=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:D})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const D=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:D})}else this.h(126)?this.k(9):this.l(P("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(P("&&"));break;case 124:this.h(124)?this.k(16):this.l(P("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(A){return this.r()||this.c.charCodeAt(this.e)!==A?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(A){this.f.push({type:A,offset:this.d})}l(A){const D=this.d,w=this.c.substring(this.d,this.e),E={type:19,offset:this.d,lexeme:w};this.g.push({offset:D,lexeme:w,additionalInfo:A}),this.f.push(E)}n(){this.m.lastIndex=this.d;const A=this.m.exec(this.c);if(A){this.e=this.d+A[0].length;const D=this.c.substring(this.d,this.e),w=$.b.get(D);w?this.k(w):this.f.push({type:17,lexeme:D,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let A=this.e,D=!1,w=!1;for(;;){if(A>=this.c.length){this.e=A,this.l(v);return}const S=this.c.charCodeAt(A);if(D)D=!1;else if(S===47&&!w){A++;break}else S===91?w=!0:S===92?D=!0:S===93&&(w=!1);A++}for(;A<this.c.length&&$.a.has(this.c.charCodeAt(A));)A++;this.e=A;const E=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:E,offset:this.d})}r(){return this.e>=this.c.length}}e.$1i=$}),define(ke[237],Se([1,0,23,39,201,387]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,v=/^-(\d{4})(\d{2})(\d{2})$/;function $(o){return o=o.trim(),o==="*"||R.test(o)}e.$ap=$;function k(o){if(!$(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const i=o.match(R);return i?{hasCaret:i[1]==="^",hasGreaterEquals:i[1]===">=",majorBase:i[2]==="x"?0:parseInt(i[2],10),majorMustEqual:i[2]!=="x",minorBase:i[4]==="x"?0:parseInt(i[4],10),minorMustEqual:i[4]!=="x",patchBase:i[6]==="x"?0:parseInt(i[6],10),patchMustEqual:i[6]!=="x",preRelease:i[8]||null}:null}e.$bp=k;function A(o){if(!o)return null;const i=o.majorBase,r=o.majorMustEqual,n=o.minorBase;let a=o.minorMustEqual;const t=o.patchBase;let h=o.patchMustEqual;o.hasCaret&&(i===0||(a=!1),h=!1);let s=0;if(o.preRelease){const d=v.exec(o.preRelease);if(d){const[,u,l,p]=d;s=Date.UTC(Number(u),Number(l)-1,Number(p))}}return{majorBase:i,majorMustEqual:r,minorBase:n,minorMustEqual:a,patchBase:t,patchMustEqual:h,isMinimum:o.hasGreaterEquals,notBefore:s}}e.$cp=A;function D(o,i,r){let n;typeof o=="string"?n=A(k(o)):n=o;let a;i instanceof Date?a=i.getTime():typeof i=="string"&&(a=new Date(i).getTime());let t;if(typeof r=="string"?t=A(k(r)):t=r,!n||!t)return!1;const h=n.majorBase,s=n.minorBase,d=n.patchBase;let u=t.majorBase,l=t.minorBase,p=t.patchBase;const I=t.notBefore;let b=t.majorMustEqual,m=t.minorMustEqual,y=t.patchMustEqual;return t.isMinimum?h>u?!0:h<u?!1:s>l?!0:s<l||a&&a<I?!1:d>=p:(h===1&&u===0&&(!b||!m||!y)&&(u=1,l=0,p=0,b=!0,m=!1,y=!1),h<u?!1:h>u?!b:s<l?!1:s>l?!m:d<p?!1:d>p?!y:!(a&&a<I))}e.$dp=D;function w(o,i,r,n,a){const t=[];if(typeof n.publisher<"u"&&typeof n.publisher!="string")return t.push([N.default.Error,f.localize(0,null)]),t;if(typeof n.name!="string")return t.push([N.default.Error,f.localize(1,null,"name")]),t;if(typeof n.version!="string")return t.push([N.default.Error,f.localize(2,null,"version")]),t;if(!n.engines)return t.push([N.default.Error,f.localize(3,null,"engines")]),t;if(typeof n.engines.vscode!="string")return t.push([N.default.Error,f.localize(4,null,"engines.vscode")]),t;if(typeof n.extensionDependencies<"u"&&!g(n.extensionDependencies))return t.push([N.default.Error,f.localize(5,null,"extensionDependencies")]),t;if(typeof n.activationEvents<"u"){if(!g(n.activationEvents))return t.push([N.default.Error,f.localize(6,null,"activationEvents")]),t;if(typeof n.main>"u"&&typeof n.browser>"u")return t.push([N.default.Error,f.localize(7,null,"activationEvents","main","browser")]),t}if(typeof n.extensionKind<"u"&&typeof n.main>"u"&&t.push([N.default.Warning,f.localize(8,null,"extensionKind")]),typeof n.main<"u"){if(typeof n.main!="string")return t.push([N.default.Error,f.localize(9,null,"main")]),t;{const d=(0,C.$Hg)(r,n.main);(0,C.$Bg)(d,r)||t.push([N.default.Warning,f.localize(10,null,d.path,r.path)])}}if(typeof n.browser<"u"){if(typeof n.browser!="string")return t.push([N.default.Error,f.localize(11,null,"browser")]),t;{const d=(0,C.$Hg)(r,n.browser);(0,C.$Bg)(d,r)||t.push([N.default.Warning,f.localize(12,null,d.path,r.path)])}}if(!P.valid(n.version))return t.push([N.default.Error,f.localize(13,null)]),t;const h=[];if(!E(o,i,n,a,h))for(const d of h)t.push([N.default.Error,d]);return t}e.$ep=w;function E(o,i,r,n,a){return n||typeof r.main>"u"&&typeof r.browser>"u"?!0:c(o,i,r.engines.vscode,a)}e.$fp=E;function S(o,i,r){return o==="*"||c(i,r,o)}e.$gp=S;function c(o,i,r,n=[]){const a=A(k(r));if(!a)return n.push(f.localize(14,null,r)),!1;if(a.majorBase===0){if(!a.majorMustEqual||!a.minorMustEqual)return n.push(f.localize(15,null,r)),!1}else if(!a.majorMustEqual)return n.push(f.localize(16,null,r)),!1;return D(o,i,a)?!0:(n.push(f.localize(17,null,o,r)),!1)}function g(o){if(!Array.isArray(o))return!1;for(let i=0,r=o.length;i<r;i++)if(typeof o[i]!="string")return!1;return!0}}),define(ke[106],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=void 0;class C{constructor(f,P=[],R=!1){this.ctor=f,this.staticArguments=P,this.supportsDelayedInstantiation=R}}e.$3h=C}),define(ke[84],Se([1,0,106]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zr=e.$Yr=e.InstantiationType=void 0;const N=[];var f;(function(v){v[v.Eager=0]="Eager",v[v.Delayed=1]="Delayed"})(f||(e.InstantiationType=f={}));function P(v,$,k){$ instanceof C.$3h||($=new C.$3h($,[],!!k)),N.push([v,$])}e.$Yr=P;function R(){return N}e.$Zr=R}),define(ke[238],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dq=e.$Cq=void 0;class C{constructor(P,R){this.key=P,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.$Cq=C;class N{constructor(P){this.b=P,this.a=new Map}roots(){const P=[];for(const R of this.a.values())R.outgoing.size===0&&P.push(R);return P}insertEdge(P,R){const v=this.lookupOrInsertNode(P),$=this.lookupOrInsertNode(R);v.outgoing.set($.key,$),$.incoming.set(v.key,v)}removeNode(P){const R=this.b(P);this.a.delete(R);for(const v of this.a.values())v.outgoing.delete(R),v.incoming.delete(R)}lookupOrInsertNode(P){const R=this.b(P);let v=this.a.get(R);return v||(v=new C(R,P),this.a.set(R,v)),v}lookup(P){return this.a.get(this.b(P))}isEmpty(){return this.a.size===0}toString(){const P=[];for(const[R,v]of this.a)P.push(`${R}
	(-> incoming)[${[...v.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...v.outgoing.keys()].join(",")}]
`);return P.join(`
`)}findCycleSlow(){for(const[P,R]of this.a){const v=new Set([P]),$=this.c(R,v);if($)return $}}c(P,R){for(const[v,$]of P.outgoing){if(R.has(v))return[...R,v].join(" -> ");R.add(v);const k=this.c($,R);if(k)return k;R.delete(v)}}}e.$Dq=N}),define(ke[5],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7h=e.$6h=e.$5h=e._util=void 0;var C;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function v($){return $[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=v})(C||(e._util=C={})),e.$5h=f("instantiationService");function N(R,v,$){v[C.DI_TARGET]===v?v[C.DI_DEPENDENCIES].push({id:R,index:$}):(v[C.DI_DEPENDENCIES]=[{id:R,index:$}],v[C.DI_TARGET]=v)}function f(R){if(C.serviceIds.has(R))return C.serviceIds.get(R);const v=function($,k,A){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(v,$,A)};return v.toString=()=>R,C.serviceIds.set(R,v),v}e.$6h=f;function P(R){return R}e.$7h=P}),define(ke[51],Se([1,0,18,2,5]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ji=e.$Ii=e.$Hi=e.$Gi=e.$Fi=e.$Ei=e.$Di=e.$Ci=e.ConfigurationTarget=e.$Bi=e.$Ai=e.$zi=void 0,e.$zi=(0,f.$6h)("configurationService");function P(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof N.URI)}e.$Ai=P;function R(o){return o&&typeof o=="object"&&(!o.overrideIdentifiers||Array.isArray(o.overrideIdentifiers))&&!o.overrideIdentifier&&(!o.resource||o.resource instanceof N.URI)}e.$Bi=R;var v;(function(o){o[o.APPLICATION=1]="APPLICATION",o[o.USER=2]="USER",o[o.USER_LOCAL=3]="USER_LOCAL",o[o.USER_REMOTE=4]="USER_REMOTE",o[o.WORKSPACE=5]="WORKSPACE",o[o.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",o[o.DEFAULT=7]="DEFAULT",o[o.MEMORY=8]="MEMORY"})(v||(e.ConfigurationTarget=v={}));function $(o){switch(o){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.$Ci=$;function k(o){return o.applicationValue!==void 0||o.userValue!==void 0||o.userLocalValue!==void 0||o.userRemoteValue!==void 0||o.workspaceValue!==void 0||o.workspaceFolderValue!==void 0}e.$Di=k;function A(o,i){const r=Object.create(null);for(const n in o)D(r,n,o[n],i);return r}e.$Ei=A;function D(o,i,r,n){const a=i.split("."),t=a.pop();let h=o;for(let s=0;s<a.length;s++){const d=a[s];let u=h[d];switch(typeof u){case"undefined":u=h[d]=Object.create(null);break;case"object":break;default:n(`Ignoring ${i} as ${a.slice(0,s+1).join(".")} is ${JSON.stringify(u)}`);return}h=u}if(typeof h=="object"&&h!==null)try{h[t]=r}catch{n(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(h)}`)}else n(`Ignoring ${i} as ${a.join(".")} is ${JSON.stringify(h)}`)}e.$Fi=D;function w(o,i){const r=i.split(".");E(o,r)}e.$Gi=w;function E(o,i){const r=i.shift();if(i.length===0){delete o[r];return}if(Object.keys(o).indexOf(r)!==-1){const n=o[r];typeof n=="object"&&!Array.isArray(n)&&(E(n,i),Object.keys(n).length===0&&delete o[r])}}function S(o,i,r){function n(h,s){let d=h;for(const u of s){if(typeof d!="object"||d===null)return;d=d[u]}return d}const a=i.split("."),t=n(o,a);return typeof t>"u"?r:t}e.$Hi=S;function c(o,i,r){Object.keys(i).forEach(n=>{n!=="__proto__"&&(n in o?C.$Kf(o[n])&&C.$Kf(i[n])?c(o[n],i[n],r):r&&(o[n]=i[n]):o[n]=i[n])})}e.$Ii=c;function g(o){return o.replace(/[\[\]]/g,"")}e.$Ji=g}),define(ke[45],Se([1,0,10,12,236,5,197,14]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mj=e.$lj=e.$kj=e.$jj=e.$ij=e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=e.$cj=e.$bj=e.$aj=e.$_i=e.$$i=e.$0i=e.$9i=e.$8i=e.$7i=e.$6i=e.$5i=e.$4i=e.$3i=e.ContextKeyExprType=e.$2i=void 0;const $=new Map;$.set("false",!1),$.set("true",!0),$.set("isMac",C.$j),$.set("isLinux",C.$k),$.set("isWindows",C.$i),$.set("isWeb",C.$o),$.set("isMacNative",C.$j&&!C.$o),$.set("isEdge",C.$H),$.set("isFirefox",C.$F),$.set("isChrome",C.$E),$.set("isSafari",C.$G);function k(J,V){if($.get(J)!==void 0)throw(0,v.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");$.set(J,V)}e.$2i=k;const A=Object.prototype.hasOwnProperty;var D;(function(J){J[J.False=0]="False",J[J.True=1]="True",J[J.Defined=2]="Defined",J[J.Not=3]="Not",J[J.Equals=4]="Equals",J[J.NotEquals=5]="NotEquals",J[J.And=6]="And",J[J.Regex=7]="Regex",J[J.NotRegex=8]="NotRegex",J[J.Or=9]="Or",J[J.In=10]="In",J[J.NotIn=11]="NotIn",J[J.Greater=12]="Greater",J[J.GreaterEquals=13]="GreaterEquals",J[J.Smaller=14]="Smaller",J[J.SmallerEquals=15]="SmallerEquals"})(D||(e.ContextKeyExprType=D={}));const w={regexParsingWithErrorRecovery:!0},E=(0,R.localize)(0,null),S=(0,R.localize)(1,null),c=(0,R.localize)(2,null),g=(0,R.localize)(3,null),o=(0,R.localize)(4,null),i=(0,R.localize)(5,null),r=(0,R.localize)(6,null),n=(0,R.localize)(7,null);class a{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(V=w){this.k=V,this.d=new f.$1i,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(V){if(V===""){this.h.push({message:E,offset:0,lexeme:"",additionalInfo:S});return}this.f=this.d.reset(V).scan(),this.g=0,this.h=[];try{const ie=this.l();if(!this.E()){const ye=this.D(),de=ye.type===17?i:void 0;throw this.h.push({message:o,offset:ye.offset,lexeme:f.$1i.getLexeme(ye),additionalInfo:de}),a.c}return ie}catch(ie){if(ie!==a.c)throw ie;return}}l(){return this.m()}m(){const V=[this.o()];for(;this.y(16);){const ie=this.o();V.push(ie)}return V.length===1?V[0]:t.or(...V)}o(){const V=[this.s()];for(;this.y(15);){const ie=this.s();V.push(ie)}return V.length===1?V[0]:t.and(...V)}s(){if(this.y(2)){const V=this.D();switch(V.type){case 11:return this.z(),u.INSTANCE;case 12:return this.z(),l.INSTANCE;case 0:{this.z();const ie=this.l();return this.A(1,g),ie?.negate()}case 17:return this.z(),L.create(V.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",V)}}return this.t()}t(){const V=this.D();switch(V.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const ie=this.l();return this.A(1,g),ie}case 17:{const ie=V.lexeme;if(this.z(),this.y(9)){const de=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),de.type!==10)throw this.B("REGEX",de);const fe=de.lexeme,_=fe.lastIndexOf("/"),ee=_===fe.length-1?void 0:this.w(fe.substring(_+1));let G;try{G=new RegExp(fe.substring(1,_),ee)}catch{throw this.B("REGEX",de)}return j.create(ie,G)}switch(de.type){case 10:case 19:{const fe=[de.lexeme];this.z();let _=this.D(),ee=0;for(let Re=0;Re<de.lexeme.length;Re++)de.lexeme.charCodeAt(Re)===40?ee++:de.lexeme.charCodeAt(Re)===41&&ee--;for(;!this.E()&&_.type!==15&&_.type!==16;){switch(_.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let Re=0;Re<_.lexeme.length;Re++)_.lexeme.charCodeAt(Re)===40?ee++:de.lexeme.charCodeAt(Re)===41&&ee--}if(ee<0)break;fe.push(f.$1i.getLexeme(_)),this.z(),_=this.D()}const G=fe.join(""),x=G.lastIndexOf("/"),me=x===G.length-1?void 0:this.w(G.substring(x+1));let pe;try{pe=new RegExp(G.substring(1,x),me)}catch{throw this.B("REGEX",de)}return t.regex(ie,pe)}case 18:{const fe=de.lexeme;this.z();let _=null;if(!(0,N.$Je)(fe)){const ee=fe.indexOf("/"),G=fe.lastIndexOf("/");if(ee!==G&&ee>=0){const x=fe.slice(ee+1,G),me=fe[G+1]==="i"?"i":"";try{_=new RegExp(x,me)}catch{throw this.B("REGEX",de)}}}if(_===null)throw this.B("REGEX",de);return j.create(ie,_)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,c);const de=this.u();return t.notIn(ie,de)}switch(this.D().type){case 3:{this.z();const de=this.u();if(this.x().type===18)return t.equals(ie,de);switch(de){case"true":return t.has(ie);case"false":return t.not(ie);default:return t.equals(ie,de)}}case 4:{this.z();const de=this.u();if(this.x().type===18)return t.notEquals(ie,de);switch(de){case"true":return t.not(ie);case"false":return t.has(ie);default:return t.notEquals(ie,de)}}case 5:return this.z(),O.create(ie,this.u());case 6:return this.z(),M.create(ie,this.u());case 7:return this.z(),z.create(ie,this.u());case 8:return this.z(),T.create(ie,this.u());case 13:return this.z(),t.in(ie,this.u());default:return t.has(ie)}}case 20:throw this.h.push({message:r,offset:V.offset,lexeme:"",additionalInfo:n}),a.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const V=this.D();switch(V.type){case 17:case 18:return this.z(),V.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(V){return V.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(V){return this.C(V)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(V,ie){if(this.C(V))return this.z();throw this.B(ie,this.D())}B(V,ie,ye){const de=(0,R.localize)(8,null,V,f.$1i.getLexeme(ie)),fe=ie.offset,_=f.$1i.getLexeme(ie);return this.h.push({message:de,offset:fe,lexeme:_,additionalInfo:ye}),a.c}C(V){return this.D().type===V}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$3i=a;class t{static false(){return u.INSTANCE}static true(){return l.INSTANCE}static has(V){return p.create(V)}static equals(V,ie){return I.create(V,ie)}static notEquals(V,ie){return y.create(V,ie)}static regex(V,ie){return j.create(V,ie)}static in(V,ie){return b.create(V,ie)}static notIn(V,ie){return m.create(V,ie)}static not(V){return L.create(V)}static and(...V){return ue.create(V,null,!0)}static or(...V){return X.create(V,null,!0)}static greater(V,ie){return z.create(V,ie)}static greaterEquals(V,ie){return T.create(V,ie)}static smaller(V,ie){return O.create(V,ie)}static smallerEquals(V,ie){return M.create(V,ie)}static{this.c=new a({regexParsingWithErrorRecovery:!1})}static deserialize(V){return V==null?void 0:this.c.parse(V)}}e.$4i=t;function h(J){const V=new a({regexParsingWithErrorRecovery:!1});return J.map(ie=>(V.parse(ie),V.lexingErrors.length>0?V.lexingErrors.map(ye=>({errorMessage:ye.additionalInfo?(0,R.localize)(9,null,ye.additionalInfo):(0,R.localize)(10,null),offset:ye.offset,length:ye.lexeme.length})):V.parsingErrors.length>0?V.parsingErrors.map(ye=>({errorMessage:ye.additionalInfo?`${ye.message}. ${ye.additionalInfo}`:ye.message,offset:ye.offset,length:ye.lexeme.length})):[]))}e.$5i=h;function s(J,V){const ie=J?J.substituteConstants():void 0,ye=V?V.substituteConstants():void 0;return!ie&&!ye?!0:!ie||!ye?!1:ie.equals(ye)}e.$6i=s;function d(J,V){return J.cmp(V)}class u{static{this.INSTANCE=new u}constructor(){this.type=0}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!1}serialize(){return"false"}keys(){return[]}map(V){return this}negate(){return l.INSTANCE}}e.$7i=u;class l{static{this.INSTANCE=new l}constructor(){this.type=1}cmp(V){return this.type-V.type}equals(V){return V.type===this.type}substituteConstants(){return this}evaluate(V){return!0}serialize(){return"true"}keys(){return[]}map(V){return this}negate(){return u.INSTANCE}}e.$8i=l;class p{static create(V,ie=null){const ye=$.get(V);return typeof ye=="boolean"?ye?l.INSTANCE:u.INSTANCE:new p(V,ie)}constructor(V,ie){this.key=V,this.c=ie,this.type=2}cmp(V){return V.type!==this.type?this.type-V.type:Z(this.key,V.key)}equals(V){return V.type===this.type?this.key===V.key:!1}substituteConstants(){const V=$.get(this.key);return typeof V=="boolean"?V?l.INSTANCE:u.INSTANCE:this}evaluate(V){return!!V.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(V){return V.mapDefined(this.key)}negate(){return this.c||(this.c=L.create(this.key,this)),this.c}}e.$9i=p;class I{static create(V,ie,ye=null){if(typeof ie=="boolean")return ie?p.create(V,ye):L.create(V,ye);const de=$.get(V);return typeof de=="boolean"?ie===(de?"true":"false")?l.INSTANCE:u.INSTANCE:new I(V,ie,ye)}constructor(V,ie,ye){this.c=V,this.d=ie,this.f=ye,this.type=4}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=$.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?l.INSTANCE:u.INSTANCE}return this}evaluate(V){return V.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(V){return V.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$0i=I;class b{static create(V,ie){return new b(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=10,this.c=null}cmp(V){return V.type!==this.type?this.type-V.type:le(this.d,this.f,V.d,V.f)}equals(V){return V.type===this.type?this.d===V.d&&this.f===V.f:!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.f),ye=V.getValue(this.d);return Array.isArray(ie)?ie.includes(ye):typeof ye=="string"&&typeof ie=="object"&&ie!==null?A.call(ie,ye):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(V){return V.mapIn(this.d,this.f)}negate(){return this.c||(this.c=m.create(this.d,this.f)),this.c}}e.$$i=b;class m{static create(V,ie){return new m(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=11,this.c=b.create(V,ie)}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(V){return V.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$_i=m;class y{static create(V,ie,ye=null){if(typeof ie=="boolean")return ie?L.create(V,ye):p.create(V,ye);const de=$.get(V);return typeof de=="boolean"?ie===(de?"true":"false")?u.INSTANCE:l.INSTANCE:new y(V,ie,ye)}constructor(V,ie,ye){this.c=V,this.d=ie,this.f=ye,this.type=5}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){const V=$.get(this.c);if(typeof V=="boolean"){const ie=V?"true":"false";return this.d===ie?u.INSTANCE:l.INSTANCE}return this}evaluate(V){return V.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(V){return V.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.$aj=y;class L{static create(V,ie=null){const ye=$.get(V);return typeof ye=="boolean"?ye?u.INSTANCE:l.INSTANCE:new L(V,ie)}constructor(V,ie){this.c=V,this.d=ie,this.type=3}cmp(V){return V.type!==this.type?this.type-V.type:Z(this.c,V.c)}equals(V){return V.type===this.type?this.c===V.c:!1}substituteConstants(){const V=$.get(this.c);return typeof V=="boolean"?V?u.INSTANCE:l.INSTANCE:this}evaluate(V){return!V.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(V){return V.mapNot(this.c)}negate(){return this.d||(this.d=p.create(this.c,this)),this.d}}e.$bj=L;function F(J,V){if(typeof J=="string"){const ie=parseFloat(J);isNaN(ie)||(J=ie)}return typeof J=="string"||typeof J=="number"?V(J):u.INSTANCE}class z{static create(V,ie,ye=null){return F(ie,de=>new z(V,de,ye))}constructor(V,ie,ye){this.c=V,this.d=ie,this.f=ye,this.type=12}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=M.create(this.c,this.d,this)),this.f}}e.$cj=z;class T{static create(V,ie,ye=null){return F(ie,de=>new T(V,de,ye))}constructor(V,ie,ye){this.c=V,this.d=ie,this.f=ye,this.type=13}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(V){return V.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=O.create(this.c,this.d,this)),this.f}}e.$dj=T;class O{static create(V,ie,ye=null){return F(ie,de=>new O(V,de,ye))}constructor(V,ie,ye){this.c=V,this.d=ie,this.f=ye,this.type=14}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.$ej=O;class M{static create(V,ie,ye=null){return F(ie,de=>new M(V,de,ye))}constructor(V,ie,ye){this.c=V,this.d=ie,this.f=ye,this.type=15}cmp(V){return V.type!==this.type?this.type-V.type:le(this.c,this.d,V.c,V.d)}equals(V){return V.type===this.type?this.c===V.c&&this.d===V.d:!1}substituteConstants(){return this}evaluate(V){return typeof this.d=="string"?!1:parseFloat(V.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(V){return V.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.$fj=M;class j{static create(V,ie){return new j(V,ie)}constructor(V,ie){this.d=V,this.f=ie,this.type=7,this.c=null}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.d<V.d)return-1;if(this.d>V.d)return 1;const ie=this.f?this.f.source:"",ye=V.f?V.f.source:"";return ie<ye?-1:ie>ye?1:0}equals(V){if(V.type===this.type){const ie=this.f?this.f.source:"",ye=V.f?V.f.source:"";return this.d===V.d&&ie===ye}return!1}substituteConstants(){return this}evaluate(V){const ie=V.getValue(this.d);return this.f?this.f.test(ie):!1}serialize(){const V=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${V}`}keys(){return[this.d]}map(V){return V.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.$gj=j;class U{static create(V){return new U(V)}constructor(V){this.c=V,this.type=8}cmp(V){return V.type!==this.type?this.type-V.type:this.c.cmp(V.c)}equals(V){return V.type===this.type?this.c.equals(V.c):!1}substituteConstants(){return this}evaluate(V){return!this.c.evaluate(V)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(V){return new U(this.c.map(V))}negate(){return this.c}}e.$hj=U;function K(J){let V=null;for(let ie=0,ye=J.length;ie<ye;ie++){const de=J[ie].substituteConstants();if(J[ie]!==de&&V===null){V=[];for(let fe=0;fe<ie;fe++)V[fe]=J[fe]}V!==null&&(V[ie]=de)}return V===null?J:V}class ue{static create(V,ie,ye){return ue.d(V,ie,ye)}constructor(V,ie){this.expr=V,this.c=ie,this.type=6}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,ye=this.expr.length;ie<ye;ie++){const de=d(this.expr[ie],V.expr[ie]);if(de!==0)return de}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=K(this.expr);return V===this.expr?this:ue.create(V,this.c,!1)}evaluate(V){for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].evaluate(V))return!1;return!0}static d(V,ie,ye){const de=[];let fe=!1;for(const _ of V)if(_){if(_.type===1){fe=!0;continue}if(_.type===0)return u.INSTANCE;if(_.type===6){de.push(..._.expr);continue}de.push(_)}if(de.length===0&&fe)return l.INSTANCE;if(de.length!==0){if(de.length===1)return de[0];de.sort(d);for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];for(;de.length>1;){const _=de[de.length-1];if(_.type!==9)break;de.pop();const ee=de.pop(),G=de.length===0,x=X.create(_.expr.map(me=>ue.create([me,ee],null,ye)),null,G);x&&(de.push(x),de.sort(d))}if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let ee=_+1;ee<de.length;ee++)if(de[_].negate().equals(de[ee]))return u.INSTANCE;if(de.length===1)return de[0]}return new ue(de,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" && ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new ue(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());this.c=X.create(V,this,!0)}return this.c}}e.$ij=ue;class X{static create(V,ie,ye){return X.d(V,ie,ye)}constructor(V,ie){this.expr=V,this.c=ie,this.type=9}cmp(V){if(V.type!==this.type)return this.type-V.type;if(this.expr.length<V.expr.length)return-1;if(this.expr.length>V.expr.length)return 1;for(let ie=0,ye=this.expr.length;ie<ye;ie++){const de=d(this.expr[ie],V.expr[ie]);if(de!==0)return de}return 0}equals(V){if(V.type===this.type){if(this.expr.length!==V.expr.length)return!1;for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(!this.expr[ie].equals(V.expr[ie]))return!1;return!0}return!1}substituteConstants(){const V=K(this.expr);return V===this.expr?this:X.create(V,this.c,!1)}evaluate(V){for(let ie=0,ye=this.expr.length;ie<ye;ie++)if(this.expr[ie].evaluate(V))return!0;return!1}static d(V,ie,ye){let de=[],fe=!1;if(V){for(let _=0,ee=V.length;_<ee;_++){const G=V[_];if(G){if(G.type===0){fe=!0;continue}if(G.type===1)return l.INSTANCE;if(G.type===9){de=de.concat(G.expr);continue}de.push(G)}}if(de.length===0&&fe)return u.INSTANCE;de.sort(d)}if(de.length!==0){if(de.length===1)return de[0];for(let _=1;_<de.length;_++)de[_-1].equals(de[_])&&(de.splice(_,1),_--);if(de.length===1)return de[0];if(ye){for(let _=0;_<de.length;_++)for(let ee=_+1;ee<de.length;ee++)if(de[_].negate().equals(de[ee]))return l.INSTANCE;if(de.length===1)return de[0]}return new X(de,ie)}}serialize(){return this.expr.map(V=>V.serialize()).join(" || ")}keys(){const V=[];for(const ie of this.expr)V.push(...ie.keys());return V}map(V){return new X(this.expr.map(ie=>ie.map(V)),null)}negate(){if(!this.c){const V=[];for(const ie of this.expr)V.push(ie.negate());for(;V.length>1;){const ie=V.shift(),ye=V.shift(),de=[];for(const fe of oe(ie))for(const _ of oe(ye))de.push(ue.create([fe,_],null,!1));V.unshift(X.create(de,null,!1))}this.c=X.create(V,this,!0)}return this.c}}e.$jj=X;class Q extends p{static{this.d=[]}static all(){return Q.d.values()}constructor(V,ie,ye){super(V,null),this.f=ie,typeof ye=="object"?Q.d.push({...ye,key:V}):ye!==!0&&Q.d.push({key:V,description:ye,type:ie!=null?typeof ie:void 0})}bindTo(V){return V.createKey(this.key,this.f)}getValue(V){return V.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(V){return I.create(this.key,V)}notEqualsTo(V){return y.create(this.key,V)}}e.$kj=Q,e.$lj=(0,P.$6h)("contextKeyService");function Z(J,V){return J<V?-1:J>V?1:0}function le(J,V,ie,ye){return J<ie?-1:J>ie?1:V<ye?-1:V>ye?1:0}function re(J,V){if(J.type===0||V.type===1)return!0;if(J.type===9)return V.type===9?$e(J.expr,V.expr):!1;if(V.type===9){for(const ie of V.expr)if(re(J,ie))return!0;return!1}if(J.type===6){if(V.type===6)return $e(V.expr,J.expr);for(const ie of J.expr)if(re(ie,V))return!0;return!1}return J.equals(V)}e.$mj=re;function $e(J,V){let ie=0,ye=0;for(;ie<J.length&&ye<V.length;){const de=J[ie].cmp(V[ye]);if(de<0)return!1;de===0&&ie++,ye++}return ie===J.length}function oe(J){return J.type===9?J.expr:[J]}}),define(ke[239],Se([1,0,23,39,199,5,103,10,24]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0v=e.$9v=e.ConfirmResult=e.$8v=e.$7v=e.$6v=void 0,e.$6v=(0,P.$6h)("dialogService");var k;(function(c){c[c.Confirmation=1]="Confirmation",c[c.Prompt=2]="Prompt",c[c.Input=3]="Input"})(k||(k={}));class A{a(g){return this.d(g,k.Confirmation)}b(g){return this.d(g,k.Prompt)}c(g){return this.d(g,k.Input)}d(g,o){const i=[];switch(o){case k.Confirmation:{const r=g;r.primaryButton?i.push(r.primaryButton):i.push((0,f.localize)(0,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,f.localize)(1,null));break}case k.Prompt:{const r=g;Array.isArray(r.buttons)&&r.buttons.length>0&&i.push(...r.buttons.map(n=>n.label)),r.cancelButton&&(r.cancelButton===!0?i.push((0,f.localize)(2,null)):typeof r.cancelButton=="string"?i.push(r.cancelButton):r.cancelButton.label?i.push(r.cancelButton.label):i.push((0,f.localize)(3,null))),i.length===0&&i.push((0,f.localize)(4,null));break}case k.Input:{const r=g;r.primaryButton?i.push(r.primaryButton):i.push((0,f.localize)(5,null)),r.cancelButton?i.push(r.cancelButton):i.push((0,f.localize)(6,null));break}}return i}e(g){if(typeof g=="string")return g;if(typeof g=="number")return g===N.default.Info?"info":g===N.default.Error?"error":g===N.default.Warning?"warning":"none"}f(g,o,i){const r=[...g.buttons??[]];g.cancelButton&&typeof g.cancelButton!="string"&&typeof g.cancelButton!="boolean"&&r.push(g.cancelButton);let n=r[o]?.run({checkboxChecked:i});return n instanceof Promise||(n=Promise.resolve(n)),{result:n,checkboxChecked:i}}}e.$7v=A,e.$8v=(0,P.$6h)("fileDialogService");var D;(function(c){c[c.SAVE=0]="SAVE",c[c.DONT_SAVE=1]="DONT_SAVE",c[c.CANCEL=2]="CANCEL"})(D||(e.ConfirmResult=D={}));const w=10;function E(c){const g=[];return g.push(...c.slice(0,w).map(o=>typeof o=="string"?o:(0,C.$Eg)(o))),c.length>w&&(c.length-w===1?g.push((0,f.localize)(7,null)):g.push((0,f.localize)(8,null,c.length-w))),g.push(""),g.join(`
`)}e.$9v=E;function S(c,g){const o=(0,$.$vn)(c);let i=(o.buttons??[]).map(t=>(0,R.$3v)(t)),r=(c.buttons||[]).map((t,h)=>h),n=0,a=o.cancelId??i.length-1;if(i.length>1){const t=typeof a=="number"?i[a]:void 0;if(v.$k||v.$j){if(typeof t=="string"&&i.length>1&&a!==1){i.splice(a,1),i.splice(1,0,t);const h=r[a];r.splice(a,1),r.splice(1,0,h),a=1}v.$k&&i.length>1&&(i=i.reverse(),r=r.reverse(),n=i.length-1,typeof t=="string"&&(a=n-1))}else if(v.$i&&typeof t=="string"&&i.length>1&&a!==i.length-1){i.splice(a,1),i.push(t);const h=r[a];r.splice(a,1),r.push(h),a=i.length-1}}return o.buttons=i,o.defaultId=n,o.cancelId=a,o.noLink=!0,o.title=o.title||g.nameLong,{options:o,buttonIndeces:r}}e.$0v=S}),define(ke[133],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bi=e.$ai=void 0,e.$ai=(0,C.$6h)("environmentService"),e.$bi=(0,C.$7h)(e.$ai)}),define(ke[134],Se([1,0,200,5]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=e.$Fo=e.$Eo=e.$Do=e.$Co=e.$Bo=e.$Ao=e.ExtensionGalleryErrorCode=e.$zo=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.$yo=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.$xo=e.$wo=e.$vo=e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=void 0,e.$mo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$no=new RegExp(e.$mo),e.$oo="__web_extension",e.$po="skipWalkthrough",e.$qo="extensionsSync",e.$ro="dependecyOrPackExtensionInstall";function f(r){switch(r){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.$so=f;function P(r){switch(r){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.$to=P;function R(r,n){switch(r){case 3:return n==="x64"?"win32-x64":n==="arm64"?"win32-arm64":"unknown";case 2:return n==="x64"?"linux-x64":n==="arm64"?"linux-arm64":n==="arm"?"linux-armhf":"unknown";case"alpine":return n==="x64"?"alpine-x64":n==="arm64"?"alpine-arm64":"unknown";case 1:return n==="x64"?"darwin-x64":n==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.$uo=R;function v(r,n){return n==="web"&&!r.includes("web")}e.$vo=v;function $(r,n,a){return v(n,a)?!1:r==="undefined"||r==="universal"?!0:r==="unknown"?!1:r===a}e.$wo=$;function k(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.$xo=k;var A;(function(r){r[r.NoneOrRelevance=0]="NoneOrRelevance",r[r.LastUpdatedDate=1]="LastUpdatedDate",r[r.Title=2]="Title",r[r.PublisherName=3]="PublisherName",r[r.InstallCount=4]="InstallCount",r[r.PublishedDate=10]="PublishedDate",r[r.AverageRating=6]="AverageRating",r[r.WeightedRating=12]="WeightedRating"})(A||(e.SortBy=A={}));var D;(function(r){r[r.Default=0]="Default",r[r.Ascending=1]="Ascending",r[r.Descending=2]="Descending"})(D||(e.SortOrder=D={}));var w;(function(r){r.Install="install",r.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var E;(function(r){r[r.None=1]="None",r[r.Install=2]="Install",r[r.Update=3]="Update",r[r.Migrate=4]="Migrate"})(E||(e.InstallOperation=E={})),e.$yo=(0,N.$6h)("extensionGalleryService");var S;(function(r){r.Unsupported="Unsupported",r.Deprecated="Deprecated",r.Malicious="Malicious",r.Incompatible="Incompatible",r.IncompatibleTargetPlatform="IncompatibleTargetPlatform",r.ReleaseVersionNotFound="ReleaseVersionNotFound",r.Invalid="Invalid",r.Download="Download",r.DownloadSignature="DownloadSignature",r.UpdateMetadata="UpdateMetadata",r.Extract="Extract",r.Scanning="Scanning",r.Delete="Delete",r.Rename="Rename",r.CorruptZip="CorruptZip",r.IncompleteZip="IncompleteZip",r.Signature="Signature",r.NotAllowed="NotAllowed",r.Gallery="Gallery",r.Unknown="Unknown",r.Internal="Internal"})(S||(e.ExtensionManagementErrorCode=S={}));var c;(function(r){r.UnknownError="UnknownError",r.PackageIsInvalidZip="PackageIsInvalidZip",r.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(c||(e.ExtensionSignaturetErrorCode=c={}));class g extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$zo=g;var o;(function(r){r.Timeout="Timeout",r.Cancelled="Cancelled",r.Failed="Failed"})(o||(e.ExtensionGalleryErrorCode=o={}));class i extends Error{constructor(n,a){super(n),this.code=a,this.name=a}}e.$Ao=i,e.$Bo=(0,N.$6h)("extensionManagementService"),e.$Co="extensionsIdentifiers/disabled",e.$Do="extensionsIdentifiers/enabled",e.$Eo=(0,N.$6h)("IGlobalExtensionEnablementService"),e.$Fo=(0,N.$6h)("IExtensionTipsService"),e.$Go=(0,C.localize)(0,null),e.$Ho={value:e.$Go,original:"Extensions"},e.$Io=(0,C.localize2)(1,"Preferences")}),define(ke[240],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$v3b=e.$u3b=void 0,e.$u3b=(0,C.$6h)("externalTerminal"),e.$v3b="Terminal.app"}),define(ke[241],Se([1,0,50,52,16,17,10,102,31,105,202,240]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$u$b=e.$t$b=e.$s$b=void 0;const w=A.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:S.getDefaultTerminalWindows(),linux:await g.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class S extends E{static{this.b="cmd.exe"}openTerminal(a,t){return this.spawnTerminal(C,a,k.$Tl(),t)}spawnTerminal(a,t,h,s){const d=t.windowsExec||S.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const u=P.$nc(d,".exe").toLowerCase();if(u==="cmder")return a.spawn(d,s?[s]:void 0),Promise.resolve(void 0);const l=["/c","start","/wait"];return d.indexOf(" ")>=0&&l.push('""'),l.push(d),u==="wt"&&l.push("-d ."),new Promise((p,I)=>{const b=o(process),m=a.spawn(h,l,{cwd:s,env:b,detached:!0});m.on("error",I),m.on("exit",()=>p())})}async runInTerminal(a,t,h,s,d){const u="windowsExec"in d&&d.windowsExec?d.windowsExec:S.getDefaultTerminalWindows(),l=await S.f();return new Promise((p,I)=>{const b=`"${t} - ${w}"`,m=`""${h.join('" "')}" & pause"`,y=Object.assign({},o(process),s);Object.keys(y).filter(O=>y[O]===null).forEach(O=>delete y[O]);const L={cwd:t,env:y,windowsVerbatimArguments:!0};let F,z;P.$nc(u,".exe")==="wt"?(F=u,z=["-d",".",S.b,"/c",m]):l?(F=l,z=["-d",t,u,"/c",m]):(F=S.b,z=["/c","start",b,"/wait",u,"/c",m]),C.spawn(F,z,L).on("error",O=>{I(i(O))}),p(void 0)})}static getDefaultTerminalWindows(){if(!S.d){const a=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");S.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${a?"Sysnative":"System32"}\\cmd.exe`}return S.d}static async f(){try{const a=await k.win32.findExecutable("wt");return await $.Promises.exists(a)?a:void 0}catch{return}}}e.$s$b=S,Ge([N.$xh],S,"f",null);class c extends E{static{this.b="/usr/bin/osascript"}openTerminal(a,t){return this.spawnTerminal(C,a,t)}runInTerminal(a,t,h,s,d){const u=d.osxExec||D.$v3b;return new Promise((l,p)=>{if(u===D.$v3b||u==="iTerm.app"){const I=u===D.$v3b?"TerminalHelper":"iTermHelper",m=[f.$og.asFileUri(`vs/workbench/contrib/externalTerminal/node/${I}.scpt`).fsPath,"-t",a||w,"-w",t];for(const F of h)m.push("-a"),m.push(F);if(s){const F=Object.assign({},o(process),s);for(const z in F){const T=F[z];T===null?(m.push("-u"),m.push(z)):(m.push("-e"),m.push(`${z}=${T}`))}}let y="";const L=C.spawn(c.b,m);L.on("error",F=>{p(i(F))}),L.stderr.on("data",F=>{y+=F.toString()}),L.on("exit",F=>{if(F===0)l(void 0);else if(y){const z=y.split(`
`,1);p(new Error(z[0]))}else p(new Error(A.localize(1,null,I,F)))})}else p(new Error(A.localize(2,null,u)))})}spawnTerminal(a,t,h){const s=t.osxExec||D.$v3b;return new Promise((d,u)=>{const l=["-a",s];h&&l.push(h);const p=o(process),I=a.spawn("/usr/bin/open",l,{cwd:h,env:p});I.on("error",u),I.on("exit",()=>d())})}}e.$t$b=c;class g extends E{static{this.b=A.localize(3,null)}openTerminal(a,t){return this.spawnTerminal(C,a,t)}runInTerminal(a,t,h,s,d){const u=d.linuxExec?Promise.resolve(d.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((l,p)=>{const I=[];u.then(b=>{b.indexOf("gnome-terminal")>=0?I.push("-x"):I.push("-e"),I.push("bash"),I.push("-c");const m=`${r(h)}; echo; read -p "${g.b}" -n1;`;I.push(`''${m}''`);const y=Object.assign({},o(process),s);Object.keys(y).filter(T=>y[T]===null).forEach(T=>delete y[T]);const L={cwd:t,env:y};let F="";const z=C.spawn(b,I,L);z.on("error",T=>{p(i(T))}),z.stderr.on("data",T=>{F+=T.toString()}),z.on("exit",T=>{if(T===0)l(void 0);else if(F){const O=F.split(`
`,1);p(new Error(O[0]))}else p(new Error(A.localize(4,null,b,T)))})})})}static async getDefaultTerminalLinuxReady(){if(!g.d)if(!R.$k)g.d=Promise.resolve("xterm");else{const a=await $.Promises.exists("/etc/debian_version");g.d=new Promise(t=>{a?t("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?t("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?t("konsole"):process.env.COLORTERM?t(process.env.COLORTERM):process.env.TERM?t(process.env.TERM):t("xterm")})}return g.d}spawnTerminal(a,t,h){const s=t.linuxExec?Promise.resolve(t.linuxExec):g.getDefaultTerminalLinuxReady();return new Promise((d,u)=>{s.then(l=>{const p=o(process),I=a.spawn(l,[],{cwd:h,env:p});I.on("error",u),I.on("exit",()=>d())})})}}e.$u$b=g;function o(n){const a={...n.env};return(0,v.$Rl)(a),a}function i(n){return"errno"in n&&n.errno==="ENOENT"&&"path"in n&&typeof n.path=="string"?new Error(A.localize(5,null,n.path)):n}function r(n){let a="";for(const t of n)t.indexOf(" ")>=0?a+='"'+t+'"':a+=t,a+=" ";return a}}),define(ke[32],Se([1,0,77,17,12,18,2,203,5,10,16,43]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zk=e.$Yk=e.$Xk=e.$Wk=e.$Vk=e.FileKind=e.$Uk=e.$Tk=e.$Sk=e.$Rk=e.$Qk=e.$Pk=e.$Ok=e.FileOperationResult=e.$Nk=e.$Mk=e.$Lk=e.$Kk=e.$Jk=e.FileChangeType=e.$Ik=e.FileOperation=e.$Hk=e.$Gk=e.$Fk=e.$Ek=e.$Dk=e.$Ck=e.FileSystemProviderErrorCode=e.$Bk=e.$Ak=e.$zk=e.$yk=e.$xk=e.$wk=e.$vk=e.$uk=e.$tk=e.FileSystemProviderCapabilities=e.$sk=e.FilePermission=e.FileType=e.$rk=e.$qk=void 0,e.$qk=(0,$.$6h)("fileService");function w(re){return re.create===!0}e.$rk=w;var E;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var S;(function(re){re[re.Readonly=1]="Readonly",re[re.Locked=2]="Locked"})(S||(e.FilePermission=S={}));function c(re){const $e=re;return!!$e&&typeof $e.onDidChange=="function"}e.$sk=c;var g;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileAtomicWrite=32768]="FileAtomicWrite",re[re.FileAtomicDelete=65536]="FileAtomicDelete",re[re.FileClone=131072]="FileClone"})(g||(e.FileSystemProviderCapabilities=g={}));function o(re){return!!(re.capabilities&2)}e.$tk=o;function i(re){return!!(re.capabilities&8)}e.$uk=i;function r(re){return!!(re.capabilities&131072)}e.$vk=r;function n(re){return!!(re.capabilities&4)}e.$wk=n;function a(re){return!!(re.capabilities&16)}e.$xk=a;function t(re){return o(re)?!!(re.capabilities&16384):!1}e.$yk=t;function h(re){return o(re)?!!(re.capabilities&32768):!1}e.$zk=h;function s(re){return!!(re.capabilities&65536)}e.$Ak=s;function d(re){return!!(re.capabilities&2048)}e.$Bk=d;var u;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(u||(e.FileSystemProviderErrorCode=u={}));class l extends Error{static create($e,oe){const J=new l($e.toString(),oe);return b(J,oe),J}constructor($e,oe){super($e),this.code=oe}}e.$Ck=l;function p(re,$e){return l.create(re,$e)}e.$Dk=p;function I(re){return re||p((0,v.localize)(0,null),u.Unknown)}e.$Ek=I;function b(re,$e){return re.name=$e?`${$e} (FileSystemError)`:"FileSystemError",re}e.$Fk=b;function m(re){if(!re)return u.Unknown;if(re instanceof l)return re.code;const $e=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!$e)return u.Unknown;switch($e[1]){case u.FileExists:return u.FileExists;case u.FileIsADirectory:return u.FileIsADirectory;case u.FileNotADirectory:return u.FileNotADirectory;case u.FileNotFound:return u.FileNotFound;case u.FileTooLarge:return u.FileTooLarge;case u.FileWriteLocked:return u.FileWriteLocked;case u.NoPermissions:return u.NoPermissions;case u.Unavailable:return u.Unavailable}return u.Unknown}e.$Gk=m;function y(re){if(re instanceof M)return re.fileOperationResult;switch(m(re)){case u.FileNotFound:return 1;case u.FileIsADirectory:return 0;case u.FileNotADirectory:return 9;case u.FileWriteLocked:return 5;case u.NoPermissions:return 6;case u.FileExists:return 4;case u.FileTooLarge:return 7;default:return 10}}e.$Hk=y;var L;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(L||(e.FileOperation=L={}));class F{constructor($e,oe,J){this.resource=$e,this.operation=oe,this.target=J}isOperation($e){return this.operation===$e}}e.$Ik=F;var z;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(z||(e.FileChangeType=z={}));class T{static{this.a=null}constructor($e,oe){this.c=oe,this.b=void 0,this.d=new D.$V(()=>{const J=C.$_h.forUris(()=>this.c);return J.fill(this.rawAdded.map(V=>[V,!0])),J}),this.f=new D.$V(()=>{const J=C.$_h.forUris(()=>this.c);return J.fill(this.rawUpdated.map(V=>[V,!0])),J}),this.g=new D.$V(()=>{const J=C.$_h.forUris(()=>this.c);return J.fill(this.rawDeleted.map(V=>[V,!0])),J}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const J of $e){switch(J.type){case 1:this.rawAdded.push(J.resource);break;case 0:this.rawUpdated.push(J.resource);break;case 2:this.rawDeleted.push(J.resource);break}this.b!==T.a&&(typeof J.cId=="number"?this.b===void 0?this.b=J.cId:this.b!==J.cId&&(this.b=T.a):this.b!==void 0&&(this.b=T.a))}}contains($e,...oe){return this.h($e,{includeChildren:!1},...oe)}affects($e,...oe){return this.h($e,{includeChildren:!0},...oe)}h($e,oe,...J){if(!$e)return!1;const V=J.length>0;return!!((!V||J.includes(1))&&(this.d.value.get($e)||oe.includeChildren&&this.d.value.findSuperstr($e))||(!V||J.includes(0))&&(this.f.value.get($e)||oe.includeChildren&&this.f.value.findSuperstr($e))||(!V||J.includes(2))&&(this.g.value.findSubstr($e)||oe.includeChildren&&this.g.value.findSuperstr($e)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates($e){return this.b===$e}hasCorrelation(){return typeof this.b=="number"}}e.$Jk=T;function O(re,$e,oe){return!re||!$e||re===$e||$e.length>re.length?!1:($e.charAt($e.length-1)!==N.sep&&($e+=N.sep),oe?(0,f.$af)(re,$e):re.indexOf($e)===0)}e.$Kk=O;class M extends Error{constructor($e,oe,J){super($e),this.fileOperationResult=oe,this.options=J}}e.$Lk=M;class j extends M{constructor($e,oe,J,V){super($e,oe,V),this.fileOperationResult=oe,this.size=J}}e.$Mk=j;class U extends M{constructor($e,oe,J){super($e,2,J),this.stat=oe}}e.$Nk=U;var K;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(K||(e.FileOperationResult=K={})),e.$Ok={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$Pk={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$Qk="files.associations",e.$Rk="files.exclude",e.$Sk="files.readonlyInclude",e.$Tk="files.readonlyExclude",e.$Uk="files.readonlyFromPermissions";var ue;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(ue||(e.FileKind=ue={})),e.$Vk="";function X(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}e.$Wk=X;async function Q(re,$e){if(!$e.hasProvider(R.URI.from({scheme:re.scheme})))return new Promise(oe=>{const J=$e.onDidChangeFileSystemProviderRegistrations(V=>{V.scheme===re.scheme&&V.added&&(J.dispose(),oe())})})}e.$Xk=Q;class Z{static{this.KB=1024}static{this.MB=Z.KB*Z.KB}static{this.GB=Z.MB*Z.KB}static{this.TB=Z.GB*Z.KB}static formatSize($e){return(0,P.$Mf)($e)||($e=0),$e<Z.KB?(0,v.localize)(1,null,$e.toFixed(0)):$e<Z.MB?(0,v.localize)(2,null,($e/Z.KB).toFixed(2)):$e<Z.GB?(0,v.localize)(3,null,($e/Z.MB).toFixed(2)):$e<Z.TB?(0,v.localize)(4,null,($e/Z.GB).toFixed(2)):(0,v.localize)(5,null,($e/Z.TB).toFixed(2))}}e.$Yk=Z;function le(re){const $e=typeof re=="string"||re?.scheme===A.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===A.Schemas.file?1024*Z.MB:$e?10*Z.MB:k.$o?50*Z.MB:1024*Z.MB}e.$Zk=le}),define(ke[242],Se([1,0,22,14,204,32]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bq=void 0;async function R(A,D,w,E,S,c){let g;try{await v(A,D,w,E,S,c)}catch(o){g=o}finally{g&&S.errorTransformer&&(g=S.errorTransformer(g)),typeof g<"u"&&w.error(g),w.end()}}e.$bq=R;async function v(A,D,w,E,S,c){$(c);const g=await A.open(D,{create:!1});try{$(c);let o=0,i=0,r=S&&typeof S.length=="number"?S.length:void 0,n=C.$je.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),a=S&&typeof S.position=="number"?S.position:0,t=0;do i=await A.read(g,a,n.buffer,t,n.byteLength-t),a+=i,t+=i,o+=i,typeof r=="number"&&(r-=i),t===n.byteLength&&(await w.write(E(n)),n=C.$je.alloc(Math.min(S.bufferSize,typeof r=="number"?r:S.bufferSize)),t=0);while(i>0&&(typeof r!="number"||r>0)&&$(c)&&k(o,S));if(t>0){let h=t;typeof r=="number"&&(h=Math.min(t,r)),w.write(E(n.slice(0,h)))}}catch(o){throw(0,P.$Ek)(o)}finally{await A.close(g)}}function $(A){if(A.isCancellationRequested)throw(0,N.$6)();return!0}function k(A,D){if(typeof D?.limits?.size=="number"&&A>D.limits.size)throw(0,P.$Dk)((0,f.localize)(0,null),P.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(ke[85],Se([1,0,35,3,17,10,2,32]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kq=e.$jq=e.$iq=e.$hq=e.$gq=e.$fq=e.$eq=e.$dq=void 0;function $(o){return o.recursive===!0}e.$dq=$;class k extends N.$Tc{static{this.a=5}constructor(i,r,n,a){super(),this.h=i,this.j=r,this.m=n,this.n=a,this.c=this.B(new N.$Uc),this.f=void 0,this.g=0}s(){const i=new N.$Sc;this.c.value=i,this.b=this.r(i),this.b.setVerboseLogging(this.m),i.add(this.b.onDidChangeFile(r=>this.h(r))),i.add(this.b.onDidLogMessage(r=>this.j(r))),i.add(this.b.onDidError(r=>this.t(r)))}t(i){this.n.restartOnError?this.g<k.a&&this.f?(this.w(`restarting watcher after error: ${i}`),this.u(this.f)):this.w(`gave up attempting to restart watcher after error: ${i}`):this.w(i)}u(i){this.g++,this.s(),this.watch(i)}async watch(i){this.f=i,await this.b?.watch(i)}async setVerboseLogging(i){this.m=i,await this.b?.setVerboseLogging(i)}w(i){this.j({type:"error",message:`[File Watcher (${this.n.type})] ${i}`})}y(i){this.j({type:"trace",message:`[File Watcher (${this.n.type})] ${i}`})}dispose(){return this.b=void 0,super.dispose()}}e.$eq=k;class A extends k{constructor(i,r,n){super(i,r,n,{type:"node.js",restartOnError:!1})}}e.$fq=A;class D extends k{constructor(i,r,n){super(i,r,n,{type:"universal",restartOnError:!0})}}e.$gq=D;function w(o){return o.map(i=>({type:i.type,resource:R.URI.revive(i.resource),cId:i.cId}))}e.$hq=w;function E(o){const i=new g;for(const r of o)i.processEvent(r);return i.coalesce()}e.$iq=E;function S(o,i){return typeof i=="string"&&!i.startsWith(C.$Ij)&&!(0,f.$ic)(i)?{base:o,pattern:i}:i}e.$jq=S;function c(o,i){const r=[];for(const n of i)r.push((0,C.$Mj)(S(o,n)));return r}e.$kq=c;class g{constructor(){this.a=new Set,this.b=new Map}c(i){return P.$k?i.resource.fsPath:i.resource.fsPath.toLowerCase()}processEvent(i){const r=this.b.get(this.c(i));let n=!1;if(r){const a=r.type,t=i.type;r.resource.fsPath!==i.resource.fsPath&&(i.type===2||i.type===1)?n=!0:a===1&&t===2?(this.b.delete(this.c(i)),this.a.delete(r)):a===2&&t===1?r.type=0:a===1&&t===0||(r.type=t)}else n=!0;n&&(this.a.add(i),this.b.set(this.c(i),i))}coalesce(){const i=[],r=[];return Array.from(this.a).filter(n=>n.type!==2?(i.push(n),!1):!0).sort((n,a)=>n.resource.fsPath.length-a.resource.fsPath.length).filter(n=>r.some(a=>(0,v.$Kk)(n.resource.fsPath,a,!P.$k))?!1:(r.push(n.resource.fsPath),!0)).concat(i)}}}),define(ke[243],Se([1,0,57,11,21,34,3,76,17,10,23,2,104,31,85]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yq=e.$xq=void 0;class c extends R.$Tc{static{this.a=100}static{this.b=75}constructor(i,r,n,a){super(),this.m=i,this.n=r,this.r=n,this.s=a,this.c=this.B(new N.$ih({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},t=>this.n(t))),this.f=this.B(new N.$hh(t=>this.z(t),c.b)),this.g=(0,S.$kq)(this.m.path,this.m.excludes),this.h=this.m.includes?(0,S.$kq)(this.m.path,this.m.includes):void 0,this.j=new f.$6d,this.ready=this.t()}async t(){try{const i=await this.u(this.m);if(this.j.token.isCancellationRequested)return;const r=await E.Promises.stat(i);this.B(await this.w(i,r.isDirectory()))}catch(i){i.code!=="ENOENT"?this.D(i):this.G(i)}}async u(i){let r=i.path;try{r=await E.Promises.realpath(i.path),i.path===r&&(r=await(0,w.$uq)(i.path)??i.path),i.path!==r&&this.G(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${i.path}, real: ${r})`)}catch{}return r}async w(i,r){if(k.$j&&(0,P.$8f)(i,"/Volumes/",!0))return this.D(`Refusing to watch ${i} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.$Tc.None;const n=new f.$6d(this.j.token),a=new R.$Sc;try{const t=D.URI.file(this.m.path),h=(0,$.$nc)(i),s=(0,C.watch)(i);a.add((0,R.$Rc)(()=>{s.removeAllListeners(),s.close()})),this.G(`Started watching: '${i}'`);const d=new Set;if(r)try{for(const l of await E.Promises.readdir(i))d.add(l)}catch(l){this.D(l)}const u=new Map;a.add((0,R.$Rc)(()=>{for(const[,l]of u)l.dispose();u.clear()})),s.on("error",(l,p)=>{this.D(`Failed to watch ${i} for changes using fs.watch() (${l}, ${p})`),this.dispose()}),s.on("change",(l,p)=>{if(n.token.isCancellationRequested)return;this.G(`[raw] ["${l}"] ${p}`);let I="";if(p&&(I=p.toString(),k.$j&&(I=(0,v.$Gl)(I))),!(!I||l!=="change"&&l!=="rename"))if(r)if(l==="rename"){u.get(I)?.dispose();const b=setTimeout(async()=>{if(u.delete(I),I===h&&!await E.Promises.exists(i)){this.F("Watcher shutdown because watched path got deleted"),this.dispose();return}const m=await this.C((0,$.$jc)(i,I));if(n.token.isCancellationRequested)return;let y;m?d.has(I)?y=0:(y=1,d.add(I)):(d.delete(I),y=2),this.y({resource:(0,A.$Hg)(t,I),type:y,cId:this.m.correlationId})},c.a);u.set(I,(0,R.$Rc)(()=>clearTimeout(b)))}else{let b;d.has(I)?b=0:(b=1,d.add(I)),this.y({resource:(0,A.$Hg)(t,I),type:b,cId:this.m.correlationId})}else if(l==="rename"||I!==h){const b=setTimeout(async()=>{const m=await E.Promises.exists(i);n.token.isCancellationRequested||(m?(this.y({resource:t,type:0,cId:this.m.correlationId},!0),a.add(await this.w(i,!1))):(this.y({resource:t,type:2,cId:this.m.correlationId},!0),this.f.flush(),this.dispose()))},c.a);a.clear(),a.add((0,R.$Rc)(()=>clearTimeout(b)))}else this.y({resource:t,type:0,cId:this.m.correlationId},!0)})}catch(t){await E.Promises.exists(i)&&!n.token.isCancellationRequested&&this.D(`Failed to watch ${i} for changes using fs.watch() (${t.toString()})`)}return(0,R.$Rc)(()=>{n.dispose(!0),a.dispose()})}y(i,r=!1){this.j.token.isCancellationRequested||(this.s&&this.G(`${i.type===1?"[ADDED]":i.type===2?"[DELETED]":"[CHANGED]"} ${i.resource.fsPath}`),!r&&this.g.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (excluded) ${i.resource.fsPath}`):!r&&this.h&&this.h.length>0&&!this.h.some(n=>n(i.resource.fsPath))?this.s&&this.G(` >> ignored (not included) ${i.resource.fsPath}`):this.f.work(i))}z(i){const r=(0,S.$iq)(i);if(r.length>0){if(this.s)for(const a of r)this.G(` >> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.resource.fsPath}`);this.c.work(r)?this.c.pending>0&&this.G(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.F(`started ignoring events due to too many file change events at once (incoming: ${r.length}, most recent change: ${r[0].resource.fsPath}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async C(i){if(k.$k)return E.Promises.exists(i);try{const r=(0,$.$nc)(i);return(await E.Promises.readdir((0,$.$mc)(i))).some(a=>a===r)}catch(r){return this.G(r),!1}}setVerboseLogging(i){this.s=i}D(i){this.j.token.isCancellationRequested||this.r?.({type:"error",message:`[File Watcher (node.js)] ${i}`})}F(i){this.j.token.isCancellationRequested||this.r?.({type:"warn",message:`[File Watcher (node.js)] ${i}`})}G(i){!this.j.token.isCancellationRequested&&this.s&&this.r?.({type:"trace",message:`[File Watcher (node.js)] ${i}`})}dispose(){this.G(`stopping file watcher on ${this.m.path}`),this.j.dispose(!0),super.dispose()}}e.$xq=c;async function g(o,i,r,n,a=512){const t=await E.Promises.open(o,"r"),h=Buffer.allocUnsafe(a),s=new f.$6d(n);let d,u=!1;const l={path:o,excludes:[],recursive:!1},p=new c(l,I=>{(async()=>{for(const{type:b}of I)if(b===0){if(u)return;u=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:m}=await E.Promises.read(t,h,0,a,null);if(!m||s.token.isCancellationRequested)break;i(h.slice(0,m))}}catch(m){d=new Error(m),s.dispose(!0)}finally{u=!1}}})()});return await p.ready,r(),new Promise((I,b)=>{s.token.onCancellationRequested(async()=>{p.dispose();try{await E.Promises.close(t)}catch(m){d=new Error(m)}d?b(d):I()})})}e.$yq=g}),define(ke[244],Se([1,0,4,35,3,10,243]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zq=void 0;class v extends f.$Tc{constructor(){super(...arguments),this.a=this.B(new C.$Vd),this.onDidChangeFile=this.a.event,this.b=this.B(new C.$Vd),this.onDidLogMessage=this.b.event,this.onDidError=C.Event.None,this.c=new Map,this.f=!1}async watch(k){const A=this.j(k),D=A.filter(E=>{const S=this.c.get(E.path);return S?!(0,N.$Qj)(S.request.excludes,E.excludes)||!(0,N.$Qj)(S.request.includes,E.includes):!0}),w=Array.from(this.c.values()).filter(({request:E})=>!A.find(S=>S.path===E.path&&(0,N.$Qj)(S.excludes,E.excludes)&&(0,N.$Qj)(S.includes,E.includes))).map(({request:E})=>E.path);D.length&&this.m(`Request to start watching: ${D.map(E=>`${E.path} (excludes: ${E.excludes.length>0?E.excludes:"<none>"}, includes: ${E.includes&&E.includes.length>0?JSON.stringify(E.includes):"<all>"}, correlationId: ${typeof E.correlationId=="number"?E.correlationId:"<none>"})`).join(",")}`),w.length&&this.m(`Request to stop watching: ${w.join(",")}`);for(const E of w)this.h(E);for(const E of D)this.g(E)}g(k){const A=new R.$xq(k,w=>this.a.fire(w),w=>this.b.fire(w),this.f),D={request:k,instance:A};this.c.set(k.path,D)}async stop(){for(const[k]of this.c)this.h(k);this.c.clear()}h(k){const A=this.c.get(k);A&&(this.c.delete(k),A.instance.dispose())}j(k){const A=new Map;for(const D of k){const w=P.$k?D.path:D.path.toLowerCase();let E=A.get(D.correlationId);E||(E=new Map,A.set(D.correlationId,E)),E.set(w,D)}return Array.from(A.values()).map(D=>Array.from(D.values())).flat()}async setVerboseLogging(k){this.f=k;for(const[,A]of this.c)A.instance.setVerboseLogging(k)}m(k){this.f&&this.b.fire({type:"trace",message:this.n(k)})}n(k,A){return A?`[File Watcher (node.js)] ${k} (path: ${A.request.path})`:`[File Watcher (node.js)] ${k}`}}e.$zq=v}),define(ke[245],Se([1,0,85,244]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Aq=void 0;class f extends C.$fq{constructor(R,v,$){super(R,v,$),this.s()}r(R){return R.add(new N.$zq)}}e.$Aq=f}),define(ke[246],Se([1,0,16,81,187,85]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sq=void 0;class R extends P.$gq{constructor($,k,A){super($,k,A),this.s()}r($){const k=$.add(new f.$rq(C.$og.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return $.add(k.onDidProcessExit(({code:A,signal:D})=>this.t(`terminated by itself with code ${A}, signal: ${D}`))),N.ProxyChannel.toService((0,N.$Mh)(k.getChannel("watcher")))}}e.$sq=R}),define(ke[107],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4h=void 0;class C{constructor(...f){this.a=new Map;for(const[P,R]of f)this.set(P,R)}set(f,P){const R=this.a.get(f);return this.a.set(f,P),R}has(f){return this.a.has(f)}get(f){return this.a.get(f)}}e.$4h=C}),define(ke[247],Se([1,0,11,14,3,106,238,5,107,75]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=e.$Eq=void 0;const A=!1;class D extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class w{constructor(g=new $.$4h,o=!1,i,r=A){this.f=g,this.g=o,this.h=i,this.i=r,this.o=new Set,this.f.set(v.$5h,this),this._globalGraph=r?i?._globalGraph??new R.$Dq(n=>n):void 0}createChild(g){return new w(g,this.g,this,this.i)}invokeFunction(g,...o){const i=S.traceInvocation(this.i,g);let r=!1;try{return g({get:a=>{if(r)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const t=this.m(a,i);if(!t)throw new Error(`[invokeFunction] unknown service '${a}'`);return t}},...o)}finally{r=!0,i.stop()}}createInstance(g,...o){let i,r;return g instanceof P.$3h?(i=S.traceCreation(this.i,g.ctor),r=this.j(g.ctor,g.staticArguments.concat(o),i)):(i=S.traceCreation(this.i,g),r=this.j(g,o,i)),i.stop(),r}j(g,o=[],i){const r=v._util.getServiceDependencies(g).sort((t,h)=>t.index-h.index),n=[];for(const t of r){const h=this.m(t.id,i);h||this.u(`[createInstance] ${g.name} depends on UNKNOWN service ${t.id}.`,!1),n.push(h)}const a=r.length>0?r[0].index:o.length;if(o.length!==a){console.trace(`[createInstance] First service dependency of ${g.name} at position ${a+1} conflicts with ${o.length} static arguments`);const t=a-o.length;t>0?o=o.concat(new Array(t)):o=o.slice(0,a)}return Reflect.construct(g,o.concat(n))}k(g,o){if(this.f.get(g)instanceof P.$3h)this.f.set(g,o);else if(this.h)this.h.k(g,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(g){const o=this.f.get(g);return!o&&this.h?this.h.l(g):o}m(g,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const i=this.l(g);return i instanceof P.$3h?this.q(g,i,o.branch(g,!0)):(o.branch(g,!1),i)}q(g,o,i){if(this.o.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.o.add(g);try{return this.r(g,o,i)}finally{this.o.delete(g)}}r(g,o,i){const r=new R.$Dq(t=>t.id.toString());let n=0;const a=[{id:g,desc:o,_trace:i}];for(;a.length;){const t=a.pop();if(r.lookupOrInsertNode(t),n++>1e3)throw new D(r);for(const h of v._util.getServiceDependencies(t.desc.ctor)){const s=this.l(h.id);if(s||this.u(`[createInstance] ${g} depends on ${h.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(h.id)),s instanceof P.$3h){const d={id:h.id,desc:s,_trace:t._trace.branch(h.id,!0)};r.insertEdge(t,d),a.push(d)}}}for(;;){const t=r.roots();if(t.length===0){if(!r.isEmpty())throw new D(r);break}for(const{data:h}of t){if(this.l(h.id)instanceof P.$3h){const d=this.s(h.id,h.desc.ctor,h.desc.staticArguments,h.desc.supportsDelayedInstantiation,h._trace);this.k(h.id,d)}r.removeNode(h)}}return this.l(g)}s(g,o,i=[],r,n){if(this.f.get(g)instanceof P.$3h)return this.t(g,o,i,r,n);if(this.h)return this.h.s(g,o,i,r,n);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(g,o,i=[],r,n){if(r){const a=new w(void 0,this.g,this,this.i);a.c=String(g);const t=new Map,h=new C.$mh(()=>{const s=a.j(o,i,n);for(const[d,u]of t){const l=s[d];if(typeof l=="function")for(const p of u)p.disposable=l.apply(s,p.listener)}return t.clear(),s});return new Proxy(Object.create(null),{get(s,d){if(!h.isInitialized&&typeof d=="string"&&(d.startsWith("onDid")||d.startsWith("onWill"))){let p=t.get(d);return p||(p=new k.$4c,t.set(d,p)),(b,m,y)=>{if(h.isInitialized)return h.value[d](b,m,y);{const L={listener:[b,m,y],disposable:void 0},F=p.push(L);return(0,f.$Rc)(()=>{F(),L.disposable?.dispose()})}}}if(d in s)return s[d];const u=h.value;let l=u[d];return typeof l!="function"||(l=l.bind(u),s[d]=l),l},set(s,d,u){return h.value[d]=u,!0},getPrototypeOf(s){return o.prototype}})}else return this.j(o,i,n)}u(g,o){if(o&&console.warn(g),this.g)throw new Error(g)}}e.$Eq=w;var E;(function(c){c[c.None=0]="None",c[c.Creation=1]="Creation",c[c.Invocation=2]="Invocation",c[c.Branch=3]="Branch"})(E||(E={}));class S{static{this.all=new Set}static{this.c=new class extends S{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,o){return g?new S(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):S.c}static traceCreation(g,o){return g?new S(1,o.name):S.c}static{this.f=0}constructor(g,o){this.type=g,this.name=o,this.g=Date.now(),this.h=[]}branch(g,o){const i=new S(3,g.toString());return this.h.push([g,o,i]),i}stop(){const g=Date.now()-this.g;S.f+=g;let o=!1;function i(n,a){const t=[],h=new Array(n+1).join("	");for(const[s,d,u]of a.h)if(d&&u){o=!0,t.push(`${h}CREATES -> ${s}`);const l=i(n+1,u);l&&t.push(l)}else t.push(`${h}uses -> ${s}`);return t.join(`
`)}const r=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${i(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${S.f.toFixed(2)}ms)`];(g>2||o)&&S.all.add(r.join(`
`))}}e.$Fq=S}),define(ke[13],Se([1,0,44,4,54,3,28,10,23,18,2,45,5]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$yj=e.$xj=e.$wj=e.$vj=e.$uj=e.$tj=e.$sj=e.log=e.$qj=e.LogLevel=e.$pj=e.$oj=e.$nj=void 0,e.$nj=(0,w.$6h)("logService"),e.$oj=(0,w.$6h)("loggerService");function E(){return new Date().toISOString()}function S(b){return(0,k.$Mf)(b)}e.$pj=S;var c;(function(b){b[b.Off=0]="Off",b[b.Trace=1]="Trace",b[b.Debug=2]="Debug",b[b.Info=3]="Info",b[b.Warning=4]="Warning",b[b.Error=5]="Error"})(c||(e.LogLevel=c={})),e.$qj=c.Info;function g(b,m,y){switch(m){case c.Trace:b.trace(y);break;case c.Debug:b.debug(y);break;case c.Info:b.info(y);break;case c.Warning:b.warn(y);break;case c.Error:b.error(y);break;case c.Off:break;default:throw new Error(`Invalid log level ${m}`)}}e.log=g;function o(b,m=!1){let y="";for(let L=0;L<b.length;L++){let F=b[L];if(F instanceof Error&&(F=(0,C.$Qi)(F,m)),typeof F=="object")try{F=JSON.stringify(F)}catch{}y+=(L>0?" ":"")+F}return y}class i extends P.$Tc{constructor(){super(...arguments),this.b=e.$qj,this.c=this.B(new N.$Vd),this.onDidChangeLogLevel=this.c.event}setLevel(m){this.b!==m&&(this.b=m,this.c.fire(this.b))}getLevel(){return this.b}f(m){return this.b!==c.Off&&this.b<=m}}e.$sj=i;class r extends i{constructor(m){super(),this.h=m}f(m){return this.h||super.f(m)}trace(m,...y){this.f(c.Trace)&&this.g(c.Trace,o([m,...y],!0))}debug(m,...y){this.f(c.Debug)&&this.g(c.Debug,o([m,...y]))}info(m,...y){this.f(c.Info)&&this.g(c.Info,o([m,...y]))}warn(m,...y){this.f(c.Warning)&&this.g(c.Warning,o([m,...y]))}error(m,...y){if(this.f(c.Error))if(m instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=m.stack,this.g(c.Error,o(L))}else this.g(c.Error,o([m,...y]))}flush(){}}e.$tj=r;class n extends i{constructor(m=e.$qj){super(),this.setLevel(m),this.g=!v.$i}trace(m,...y){this.f(c.Trace)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,m,...y):console.log(`[main ${E()}]`,m,...y))}debug(m,...y){this.f(c.Debug)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,m,...y):console.log(`[main ${E()}]`,m,...y))}info(m,...y){this.f(c.Info)&&(this.g?console.log(`\x1B[90m[main ${E()}]\x1B[0m`,m,...y):console.log(`[main ${E()}]`,m,...y))}warn(m,...y){this.f(c.Warning)&&(this.g?console.warn(`\x1B[93m[main ${E()}]\x1B[0m`,m,...y):console.warn(`[main ${E()}]`,m,...y))}error(m,...y){this.f(c.Error)&&(this.g?console.error(`\x1B[91m[main ${E()}]\x1B[0m`,m,...y):console.error(`[main ${E()}]`,m,...y))}flush(){}}e.$uj=n;class a extends i{constructor(m=e.$qj,y=!0){super(),this.g=y,this.setLevel(m)}trace(m,...y){this.f(c.Trace)&&(this.g?console.log("%cTRACE","color: #888",m,...y):console.log(m,...y))}debug(m,...y){this.f(c.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",m,...y):console.log(m,...y))}info(m,...y){this.f(c.Info)&&(this.g?console.log("%c INFO","color: #33f",m,...y):console.log(m,...y))}warn(m,...y){this.f(c.Warning)&&(this.g?console.log("%c WARN","color: #993",m,...y):console.log(m,...y))}error(m,...y){this.f(c.Error)&&(this.g?console.log("%c  ERR","color: #f33",m,...y):console.error(m,...y))}flush(){}}e.$vj=a;class t extends i{constructor(m,y=e.$qj){super(),this.g=m,this.setLevel(y)}trace(m,...y){this.f(c.Trace)&&this.g.log(c.Trace,[this.h(m),...y])}debug(m,...y){this.f(c.Debug)&&this.g.log(c.Debug,[this.h(m),...y])}info(m,...y){this.f(c.Info)&&this.g.log(c.Info,[this.h(m),...y])}warn(m,...y){this.f(c.Warning)&&this.g.log(c.Warning,[this.h(m),...y])}error(m,...y){this.f(c.Error)&&this.g.log(c.Error,[this.h(m),...y])}h(m){return typeof m=="string"?m:(0,C.$Qi)(m,this.f(c.Trace))}flush(){}}e.$wj=t;class h extends i{constructor(m){super(),this.g=m,m.length&&this.setLevel(m[0].getLevel())}setLevel(m){for(const y of this.g)y.setLevel(m);super.setLevel(m)}trace(m,...y){for(const L of this.g)L.trace(m,...y)}debug(m,...y){for(const L of this.g)L.debug(m,...y)}info(m,...y){for(const L of this.g)L.info(m,...y)}warn(m,...y){for(const L of this.g)L.warn(m,...y)}error(m,...y){for(const L of this.g)L.error(m,...y)}flush(){for(const m of this.g)m.flush()}dispose(){for(const m of this.g)m.dispose();super.dispose()}}e.$xj=h;class s extends P.$Tc{constructor(m,y,L){if(super(),this.h=m,this.j=y,this.b=new R.$Ac,this.c=this.B(new N.$Vd),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.$Vd),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.$Vd),this.onDidChangeVisibility=this.g.event,L)for(const F of L)this.b.set(F.resource,{logger:void 0,info:F})}m(m){return(0,k.$If)(m)?[...this.b.values()].find(y=>y.info.id===m):this.b.get(m)}getLogger(m){return this.m(m)?.logger}createLogger(m,y){const L=this.n(m),F=(0,k.$If)(m)?m:y?.id??(0,f.$Ti)(L.toString()).toString(16);let z=this.b.get(L)?.logger;const T=y?.logLevel==="always"?c.Trace:y?.logLevel;z||(z=this.s(L,T??this.getLogLevel(L)??this.h,{...y,id:F}));const O={logger:z,info:{resource:L,id:F,logLevel:T,name:y?.name,hidden:y?.hidden,extensionId:y?.extensionId,when:y?.when}};return this.registerLogger(O.info),this.b.set(L,O),z}n(m){return(0,k.$If)(m)?(0,$.$Hg)(this.j,`${m}.log`):m}setLogLevel(m,y){if(A.URI.isUri(m)){const L=m,F=y,z=this.b.get(L);z&&F!==z.info.logLevel&&(z.info.logLevel=F===this.h?void 0:F,z.logger?.setLevel(F),this.b.set(z.info.resource,z),this.f.fire([L,F]))}else{this.h=m;for(const[L,F]of this.b.entries())this.b.get(L)?.info.logLevel===void 0&&F.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(m,y){const L=this.m(m);L&&y!==!L.info.hidden&&(L.info.hidden=!y,this.b.set(L.info.resource,L),this.g.fire([L.info.resource,y]))}getLogLevel(m){let y;return m&&(y=this.b.get(m)?.info.logLevel),y??this.h}registerLogger(m){const y=this.b.get(m.resource);y?y.info.hidden!==m.hidden&&this.setVisibility(m.resource,!m.hidden):(this.b.set(m.resource,{info:m,logger:void 0}),this.c.fire({added:[m],removed:[]}))}deregisterLogger(m){const y=this.b.get(m);y&&(y.logger&&y.logger.dispose(),this.b.delete(m),this.c.fire({added:[],removed:[y.info]}))}*getRegisteredLoggers(){for(const m of this.b.values())yield m.info}getRegisteredLogger(m){return this.b.get(m)?.info}dispose(){this.b.forEach(m=>m.logger?.dispose()),this.b.clear(),super.dispose()}}e.$yj=s;class d{constructor(){this.onDidChangeLogLevel=new N.$Vd().event}setLevel(m){}getLevel(){return c.Info}trace(m,...y){}debug(m,...y){}info(m,...y){}warn(m,...y){}error(m,...y){}critical(m,...y){}dispose(){}flush(){}}e.$zj=d;class u extends d{}e.$Aj=u;function l(b){if(b.verbose)return c.Trace;if(typeof b.logLevel=="string"){const m=I(b.logLevel.toLowerCase());if(m!==void 0)return m}return e.$qj}e.$Bj=l;function p(b){switch(b){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Off:return"off"}}e.$Cj=p;function I(b){switch(b){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Error;case"off":return c.Off}}e.$Dj=I,e.$Ej=new D.$kj("logLevel",p(c.Info))}),define(ke[248],Se([1,0,19,11,14,4,3,17,85,13]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=void 0;class A extends R.$Tc{constructor(w,E){super(),this.a=w,this.b=E,this.c=this.B(new P.$Vd),this.onDidChangeFile=this.c.event,this.g=this.B(new P.$Vd),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new N.$4g(0)),this.w=[],this.y=this.B(new N.$4g(0))}watch(w,E){return E.recursive||this.b?.watcher?.forceUniversal?this.n(w,E):this.z(w,E)}n(w,E){const S={path:this.H(w),excludes:E.excludes,includes:E.includes,recursive:E.recursive,correlationId:E.correlationId},c=(0,C.$Ub)(this.j,S);return this.r(),(0,R.$Rc)(()=>{c(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(w=>(0,f.$1)(w))}s(){this.h||(this.h=this.B(this.t(E=>this.c.fire((0,$.$hq)(E)),E=>this.G(E),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)})));const w=this.b?.watcher?.recursive?.usePolling;if(w===!0)for(const E of this.j)(0,$.$dq)(E)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(w))for(const E of this.j)(0,$.$dq)(E)&&w.includes(E.path)&&(E.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(w,E){const S={path:this.H(w),excludes:E.excludes,includes:E.includes,recursive:!1,correlationId:E.correlationId},c=(0,C.$Ub)(this.w,S);return this.C(),(0,R.$Rc)(()=>{c(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(w=>(0,f.$1)(w))}D(){return this.u||(this.u=this.B(this.F(w=>this.c.fire((0,$.$hq)(w)),w=>this.G(w),this.a.getLevel()===k.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===k.LogLevel.Trace)}))),this.u.watch(this.w)}G(w){w.type==="error"&&this.g.fire(w.message),this.a[w.type](w.message)}H(w){return(0,v.$hc)(w.fsPath)}}e.$lq=A}),define(ke[249],Se([1,0,57,388,11,28,22,4,34,3,17,10,23,99,31,205,32,242,248,44,246,245]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=void 0,(()=>{try{(0,N.gracefulify)(C)}catch(h){console.error(`Error enabling graceful-fs: ${(0,r.$Qi)(h)}`)}})();class t extends i.$lq{static{this.I=!1}constructor(s,d){super(s,d),this.onDidChangeCapabilities=v.Event.None,this.N=new P.$Ac(u=>w.$yg.getComparisonKey(u)),this.U=new Map,this.W=new Map,this.X=new Map}get capabilities(){return this.J||(this.J=253982,D.$k&&(this.J|=1024)),this.J}async stat(s){try{const{stat:d,symbolicLink:u}=await S.SymlinkSupport.stat(this.H(s));return{type:this.M(d,u),ctime:d.birthtime.getTime(),mtime:d.mtime.getTime(),size:d.size,permissions:d.mode&128?void 0:g.FilePermission.Locked}}catch(d){throw this.fb(d)}}async L(s){try{return await this.stat(s)}catch{return}}async readdir(s){try{const d=await S.Promises.readdir(this.H(s),{withFileTypes:!0}),u=[];return await Promise.all(d.map(async l=>{try{let p;l.isSymbolicLink()?p=(await this.stat((0,w.$Hg)(s,l.name))).type:p=this.M(l),u.push([l.name,p])}catch(p){this.a.trace(p)}})),u}catch(d){throw this.fb(d)}}M(s,d){let u;return d?.dangling?u=g.FileType.Unknown:s.isFile()?u=g.FileType.File:s.isDirectory()?u=g.FileType.Directory:u=g.FileType.Unknown,d&&(u|=g.FileType.SymbolicLink),u}async O(s){const d=this.H(s);this.P(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${d})`);let u;for(;u=this.N.get(s);)this.P(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${d})`),await u.wait();const l=new f.$5g;return this.N.set(s,l),this.P(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${d})`),(0,k.$Rc)(()=>{this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${d})`),this.N.get(s)===l&&(this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${d})`),this.N.delete(s)),this.P(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${d})`),l.open()})}async readFile(s,d){let u;try{d?.atomic&&(this.P(`[Disk FileSystemProvider]: atomic read operation started (${this.H(s)})`),u=await this.O(s));const l=this.H(s);return await S.Promises.readFile(l)}catch(l){throw this.fb(l)}finally{u?.dispose()}}P(s){t.I&&this.a.trace(s)}readFileStream(s,d,u){const l=(0,E.$0d)(p=>R.$je.concat(p.map(I=>R.$je.wrap(I))).buffer);return(0,o.$bq)(this,s,l,p=>p.buffer,{...d,bufferSize:256*1024},u),l}async writeFile(s,d,u){return u?.atomic!==!1&&u?.atomic?.postfix&&await this.Q(s)?this.R(s,(0,w.$Hg)((0,w.$Gg)(s),`${(0,w.$Eg)(s)}${u.atomic.postfix}`),d,u):this.S(s,d,u)}async Q(s){try{const d=this.H(s),{symbolicLink:u}=await S.SymlinkSupport.stat(d);if(u)return!1}catch{}return!0}async R(s,d,u,l){const p=new k.$Sc;try{p.add(await this.O(s)),p.add(await this.O(d)),await this.S(d,u,l,!0);try{await this.rename(d,s,{overwrite:!0})}catch(I){try{await this.delete(d,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw I}}finally{p.dispose()}}async S(s,d,u,l){let p;try{const I=this.H(s);if(!u.create||!u.overwrite){if(await S.Promises.exists(I)){if(!u.overwrite)throw(0,g.$Dk)((0,c.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw(0,g.$Dk)((0,c.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}p=await this.open(s,{create:!0,unlock:u.unlock},l),await this.write(p,0,d,0,d.byteLength)}catch(I){throw await this.gb(s,I)}finally{typeof p=="number"&&await this.close(p)}}static{this.Y=!0}static configureFlushOnWrite(s){t.Y=s}async open(s,d,u){const l=this.H(s);let p;(0,g.$rk)(d)&&!u&&(p=await this.O(s));let I;try{if((0,g.$rk)(d)&&d.unlock)try{const{stat:m}=await S.SymlinkSupport.stat(l);m.mode&128||await S.Promises.chmod(l,m.mode|128)}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}let b;if((0,g.$rk)(d)){if(D.$i)try{await S.Promises.truncate(l,0),b="r+"}catch(m){m.code!=="ENOENT"&&this.a.trace(m)}b||(b="w")}else b="r";I=await S.Promises.open(l,b)}catch(b){throw p?.dispose(),(0,g.$rk)(d)?await this.gb(s,b):this.fb(b)}if(this.U.set(I,0),(0,g.$rk)(d)&&this.X.set(I,s),p){const b=this.W.get(I);this.P(`[Disk FileSystemProvider]: open() - storing lock for handle ${I} (${l})`),this.W.set(I,p),b&&(this.P(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${I} (${l})`),b.dispose())}return I}async close(s){const d=this.W.get(s);try{if(this.U.delete(s),this.X.delete(s)&&t.Y)try{await S.Promises.fdatasync(s)}catch(u){t.configureFlushOnWrite(!1),this.a.error(u)}return await S.Promises.close(s)}catch(u){throw this.fb(u)}finally{d&&(this.W.get(s)===d&&(this.P(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${s}`),this.W.delete(s)),this.P(`[Disk FileSystemProvider]: close() - disposing lock for handle ${s}`),d.dispose())}}async read(s,d,u,l,p){const I=this.Z(s,d);let b=null;try{b=(await S.Promises.read(s,u,l,p,I)).bytesRead}catch(m){throw this.fb(m)}finally{this.$(s,I,b)}return b}Z(s,d){return d===this.U.get(s)?null:d}$(s,d,u){const l=this.U.get(s);typeof l=="number"&&(typeof d=="number"||(typeof u=="number"?this.U.set(s,l+u):this.U.delete(s)))}async write(s,d,u,l,p){return(0,f.$nh)(()=>this.ab(s,d,u,l,p),100,3)}async ab(s,d,u,l,p){const I=this.Z(s,d);let b=null;try{b=(await S.Promises.write(s,u,l,p,I)).bytesWritten}catch(m){throw await this.gb(this.X.get(s),m)}finally{this.$(s,I,b)}return b}async mkdir(s){try{await S.Promises.mkdir(this.H(s))}catch(d){throw this.fb(d)}}async delete(s,d){try{const u=this.H(s);if(d.recursive){let l;d?.atomic!==!1&&d.atomic.postfix&&(l=(0,A.$jc)((0,A.$mc)(u),`${(0,A.$nc)(u)}${d.atomic.postfix}`)),await S.Promises.rm(u,S.RimRafMode.MOVE,l)}else try{await S.Promises.unlink(u)}catch(l){if(l.code==="EPERM"||l.code==="EISDIR"){let p=!1;try{const{stat:I,symbolicLink:b}=await S.SymlinkSupport.stat(u);p=I.isDirectory()&&!b}catch{}if(p)await S.Promises.rmdir(u);else throw l}else throw l}}catch(u){throw this.fb(u)}}async rename(s,d,u){const l=this.H(s),p=this.H(d);if(l!==p)try{await this.bb(s,d,"move",u.overwrite),await S.Promises.rename(l,p)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,c.localize)(2,null,(0,A.$nc)(l),(0,A.$nc)((0,A.$mc)(p)),I.toString()))),this.fb(I)}}async copy(s,d,u){const l=this.H(s),p=this.H(d);if(l!==p)try{await this.bb(s,d,"copy",u.overwrite),await S.Promises.copy(l,p,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,c.localize)(3,null,(0,A.$nc)(l),(0,A.$nc)((0,A.$mc)(p)),I.toString()))),this.fb(I)}}async bb(s,d,u,l){const p=this.H(s),I=this.H(d);let b=!1;if(!!(this.capabilities&1024)||(b=(0,$.$7f)(p,I,!0)),b){if(u==="copy")throw(0,g.$Dk)((0,c.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(u==="move")return}const y=await this.L(s);if(!y)throw(0,g.$Dk)((0,c.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const L=await this.L(d);if(L){if(!l)throw(0,g.$Dk)((0,c.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);y.type&g.FileType.File&&L.type&g.FileType.File||await this.delete(d,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(s,d){return this.cb(s,d,!1)}async cb(s,d,u){const l=this.H(s),p=this.H(d),I=!!(this.capabilities&1024);if((0,$.$7f)(l,p,!I))return;const b=new k.$Sc;try{b.add(await this.O(s)),b.add(await this.O(d)),u&&await S.Promises.mkdir((0,A.$mc)(p),{recursive:!0}),await S.Promises.copyFile(l,p)}catch(m){if(m.code==="ENOENT"&&!u)return this.cb(s,d,!0);throw this.fb(m)}finally{b.dispose()}}t(s,d,u){return new n.$sq(l=>s(l),l=>d(l),u)}F(s,d,u){return new a.$Aq(l=>s(l),l=>d(l),u)}fb(s){if(s instanceof g.$Ck)return s;let d=s,u;switch(s.code){case"ENOENT":u=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":u=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":u=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":u=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":u=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":d=`${s.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,u=g.FileSystemProviderErrorCode.Unknown;break;default:u=g.FileSystemProviderErrorCode.Unknown}return(0,g.$Dk)(d,u)}async gb(s,d){let u=this.fb(d);if(s&&u.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await S.SymlinkSupport.stat(this.H(s));l.mode&128||(u=(0,g.$Dk)(d,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.a.trace(l)}return u}}e.$Bq=t}),define(ke[250],Se([1,0,3,13]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CO=void 0;class f extends C.$Tc{constructor(R,v=[]){super(),this.a=new N.$xj([R,...v]),this.B(R.onDidChangeLogLevel($=>this.setLevel($)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...v){this.a.trace(R,...v)}debug(R,...v){this.a.debug(R,...v)}info(R,...v){this.a.info(R,...v)}warn(R,...v){this.a.warn(R,...v)}error(R,...v){this.a.error(R,...v)}flush(){this.a.flush()}}e.$CO=f}),define(ke[251],Se([1,0,32,13]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rO=void 0;var f;(function(k){k[k.Trace=0]="Trace",k[k.Debug=1]="Debug",k[k.Info=2]="Info",k[k.Warning=3]="Warning",k[k.Error=4]="Error",k[k.Critical=5]="Critical",k[k.Off=6]="Off"})(f||(f={}));async function P(k,A,D,w,E){try{const S=await new Promise((g,o)=>{ge(["@vscode/spdlog"],g,o)});S.setFlushOn(f.Trace);const c=await S.createAsyncRotatingLogger(k,A,D,w);return E?c.clearFormatters():c.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),c}catch(S){console.error(S)}return null}function R(k,A,D){switch(A){case N.LogLevel.Trace:k.trace(D);break;case N.LogLevel.Debug:k.debug(D);break;case N.LogLevel.Info:k.info(D);break;case N.LogLevel.Warning:k.warn(D);break;case N.LogLevel.Error:k.error(D);break;case N.LogLevel.Off:break;default:throw new Error(`Invalid log level ${A}`)}}function v(k,A){switch(A){case N.LogLevel.Trace:k.setLevel(f.Trace);break;case N.LogLevel.Debug:k.setLevel(f.Debug);break;case N.LogLevel.Info:k.setLevel(f.Info);break;case N.LogLevel.Warning:k.setLevel(f.Warning);break;case N.LogLevel.Error:k.setLevel(f.Error);break;case N.LogLevel.Off:k.setLevel(f.Off);break;default:throw new Error(`Invalid log level ${A}`)}}class $ extends N.$tj{constructor(A,D,w,E,S){super(),this.m=[],this.setLevel(S),this.n=this.s(A,D,w,E),this.B(this.onDidChangeLogLevel(c=>{this.r&&v(this.r,c)}))}async s(A,D,w,E){const S=w?6:1,c=30/S*C.$Yk.MB,g=await P(A,D,c,S,E);if(g){this.r=g,v(this.r,this.getLevel());for(const{level:o,message:i}of this.m)R(this.r,o,i);this.m=[]}}g(A,D){this.r?R(this.r,A,D):this.getLevel()<=A&&this.m.push({level:A,message:D})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$rO=$}),define(ke[135],Se([1,0,39,206,5]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$At=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var P;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(P||(e.MarkerTag=P={}));var R;(function($){$[$.Hint=1]="Hint",$[$.Info=2]="Info",$[$.Warning=4]="Warning",$[$.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function($){function k(S,c){return c-S}$.compare=k;const A=Object.create(null);A[$.Error]=(0,N.localize)(0,null),A[$.Warning]=(0,N.localize)(1,null),A[$.Info]=(0,N.localize)(2,null);function D(S){return A[S]||""}$.toString=D;function w(S){switch(S){case C.default.Error:return $.Error;case C.default.Warning:return $.Warning;case C.default.Info:return $.Info;case C.default.Ignore:return $.Hint}}$.fromSeverity=w;function E(S){switch(S){case $.Error:return C.default.Error;case $.Warning:return C.default.Warning;case $.Info:return C.default.Info;case $.Hint:return C.default.Ignore}}$.toSeverity=E}(R||(e.MarkerSeverity=R={}));var v;(function($){const k="";function A(w){return D(w,!0)}$.makeKey=A;function D(w,E){const S=[k];return w.source?S.push(w.source.replace("\xA6","\\\xA6")):S.push(k),w.code?typeof w.code=="string"?S.push(w.code.replace("\xA6","\\\xA6")):S.push(w.code.value.replace("\xA6","\\\xA6")):S.push(k),w.severity!==void 0&&w.severity!==null?S.push(R.toString(w.severity)):S.push(k),w.message&&E?S.push(w.message.replace("\xA6","\\\xA6")):S.push(k),w.startLineNumber!==void 0&&w.startLineNumber!==null?S.push(w.startLineNumber.toString()):S.push(k),w.startColumn!==void 0&&w.startColumn!==null?S.push(w.startColumn.toString()):S.push(k),w.endLineNumber!==void 0&&w.endLineNumber!==null?S.push(w.endLineNumber.toString()):S.push(k),w.endColumn!==void 0&&w.endColumn!==null?S.push(w.endColumn.toString()):S.push(k),S.push(k),S.join("\xA6")}$.makeKeyOptionalMessage=D})(v||(e.IMarkerData=v={})),e.$At=(0,f.$6h)("markerService")}),define(ke[252],Se([1,0,4,39,5]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sv=e.$rv=e.NotificationsFilter=e.$qv=e.NeverShowAgainScope=e.NotificationPriority=e.$pv=e.Severity=void 0,e.Severity=N.default,e.$pv=(0,f.$6h)("notificationService");var P;(function(D){D[D.DEFAULT=0]="DEFAULT",D[D.SILENT=1]="SILENT",D[D.URGENT=2]="URGENT"})(P||(e.NotificationPriority=P={}));var R;(function(D){D[D.WORKSPACE=0]="WORKSPACE",D[D.PROFILE=1]="PROFILE",D[D.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));function v(D){if(D){const w=D;return typeof w.id=="string"&&typeof w.label=="string"}return!1}e.$qv=v;var $;(function(D){D[D.OFF=0]="OFF",D[D.ERROR=1]="ERROR"})($||(e.NotificationsFilter=$={}));class k{constructor(){this.progress=new A,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(w){}updateMessage(w){}updateActions(w){}close(){}}e.$rv=k;class A{infinite(){}done(){}total(w){}worked(w){}}e.$sv=A}),define(ke[253],Se([1,0,49]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let N;const f=globalThis.vscode;if(typeof f<"u"&&typeof f.context<"u"){const P=f.context.configuration();if(P)N=P.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(N=globalThis._VSCODE_PRODUCT_JSON,C.env.VSCODE_DEV&&Object.assign(N,{nameShort:`${N.nameShort} Dev`,nameLong:`${N.nameLong} Dev`,dataFolderName:`${N.dataFolderName}-dev`,serverDataFolderName:N.serverDataFolderName?`${N.serverDataFolderName}-dev`:void 0}),!N.version){const P=globalThis._VSCODE_PACKAGE_JSON;Object.assign(N,{version:P.version})}}else N={},Object.keys(N).length===0&&Object.assign(N,{version:"1.82.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=N}),define(ke[136],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gj=e.$Fj=void 0,e.$Fj=(0,C.$6h)("productService"),e.$Gj="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ge,e){return function(C,N){e(C,N,ge)}};define(ke[86],Se([1,0,11,21,3,5]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zv=e.$yv=e.$xv=e.$wv=e.$vv=e.$uv=e.ProgressLocation=e.$tv=void 0,e.$tv=(0,P.$6h)("progressService");var R;(function(D){D[D.Explorer=1]="Explorer",D[D.Scm=3]="Scm",D[D.Extensions=5]="Extensions",D[D.Window=10]="Window",D[D.Notification=15]="Notification",D[D.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.$uv=Object.freeze({total(){},worked(){},done(){}});class v{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.$vv=v;class ${get value(){return this.a}constructor(w){this.e=w}report(w){this.b?this.b.push(w):this.b=[w],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const w=this.b.shift();this.a=w,await this.e(this.a)}}finally{this.c=!1;const w=this.d;this.d=void 0,w?.()}}drain(){return this.c?new Promise(w=>{const E=this.d;this.d=()=>{E?.(),w()}}):Promise.resolve()}}e.$wv=$;let k=class extends f.$Tc{constructor(w,E){super(),this.a=new C.$qh,E.withProgress(w,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,f.$Rc)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};e.$xv=k,e.$xv=k=Ge([We(1,e.$tv)],k);class A extends f.$Tc{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new f.$Sc)}start(w){this.stop();const E=++this.a,S=new N.$6d;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,f.$Rc)(()=>clearTimeout(this.f))),this.b.add((0,f.$Rc)(()=>S.cancel())),this.b.add((0,f.$Rc)(()=>this.c?this.c.done():void 0)),{id:E,token:S.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.$yv=A,e.$zv=(0,P.$6h)("editorProgressService")}),define(ke[37],Se([1,0,61,18]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hn=void 0;class f{constructor(){this.a=new Map}add(R,v){C.ok(N.$If(R)),C.ok(N.$Kf(v)),C.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,v)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.$Hn=new f}),define(ke[108],Se([1,0,4,37]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$In=void 0,e.$In={JSONContribution:"base.contributions.json"};function f(v){return v.length>0&&v.charAt(v.length-1)==="#"?v.substring(0,v.length-1):v}class P{constructor(){this.b=new C.$Vd,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema($,k){this.a[f($)]=k,this.b.fire($)}notifySchemaChanged($){this.b.fire($)}getSchemaContributions(){return{schemas:this.a}}}const R=new P;N.$Hn.add(e.$In.JSONContribution,R)}),define(ke[87],Se([1,0,19,4,18,196,51,108,37]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2n=e.$1n=e.$Zn=e.$Yn=e.$Xn=e.$Wn=e.$Vn=e.$Un=e.$Tn=e.$Sn=e.$Rn=e.$Qn=e.$Pn=e.$On=e.$Nn=e.ConfigurationScope=e.$Mn=e.EditPresentationTypes=void 0;var k;(function(a){a.Multiline="multilineText",a.Singleline="singlelineText"})(k||(e.EditPresentationTypes=k={})),e.$Mn={Configuration:"base.contributions.configuration"};var A;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.MACHINE=2]="MACHINE",a[a.WINDOW=3]="WINDOW",a[a.RESOURCE=4]="RESOURCE",a[a.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",a[a.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(A||(e.ConfigurationScope=A={})),e.$Nn={properties:{},patternProperties:{}},e.$On={properties:{},patternProperties:{}},e.$Pn={properties:{},patternProperties:{}},e.$Qn={properties:{},patternProperties:{}},e.$Rn={properties:{},patternProperties:{}},e.$Sn={properties:{},patternProperties:{}},e.$Tn="vscode://schemas/settings/resourceLanguage",e.$Un="vscode://schemas/settings/configurationDefaults";const D=$.$Hn.as(v.$In.JSONContribution);class w{constructor(){this.h=new Set,this.i=new N.$Vd,this.onDidSchemaChange=this.i.event,this.j=new N.$Vd,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:P.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},D.registerSchema(e.$Tn,this.g),this.v()}registerConfiguration(t,h=!0){this.registerConfigurations([t],h)}registerConfigurations(t,h=!0){const s=new Set;this.n(t,h,s),D.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:s})}deregisterConfigurations(t){const h=new Set;this.o(t,h),D.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:h})}updateConfigurations({add:t,remove:h}){const s=new Set;this.o(h,s),this.n(t,!1,s),D.registerSchema(e.$Tn,this.g),this.i.fire(),this.j.fire({properties:s})}registerDefaultConfigurations(t){const h=new Set;this.k(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}k(t,h){const s=[];for(const{overrides:d,source:u}of t)for(const l in d)if(h.add(l),e.$Wn.test(l)){const p=this.a.get(l),I=p?.valuesSources??new Map;if(u)for(const L of Object.keys(d[l]))I.set(L,u);const b={...p?.value||{},...d[l]};this.a.set(l,{source:u,value:b,valuesSources:I});const m=(0,R.$Ji)(l),y={type:"object",default:b,description:P.localize(1,null,m),$ref:e.$Tn,defaultDefaultValue:b,source:f.$If(u)?void 0:u,defaultValueSource:u};s.push(...c(l)),this.d[l]=y,this.b.properties[l]=y}else{this.a.set(l,{value:d[l],source:u});const p=this.d[l];p&&(this.w(l,p),this.r(l,p))}this.m(s)}deregisterDefaultConfigurations(t){const h=new Set;this.l(t,h),this.i.fire(),this.j.fire({properties:h,defaultsOverrides:!0})}l(t,h){for(const{overrides:s,source:d}of t)for(const u in s){const l=this.a.get(u),p=f.$If(d)?d:d?.id,I=f.$If(l?.source)?l?.source:l?.source?.id;if(p===I)if(h.add(u),this.a.delete(u),e.$Wn.test(u))delete this.d[u],delete this.b.properties[u];else{const b=this.d[u];b&&(this.w(u,b),this.r(u,b))}}this.u()}deltaConfiguration(t){let h=!1;const s=new Set;t.removedDefaults&&(this.l(t.removedDefaults,s),h=!0),t.addedDefaults&&(this.k(t.addedDefaults,s),h=!0),t.removedConfigurations&&this.o(t.removedConfigurations,s),t.addedConfigurations&&this.n(t.addedConfigurations,!1,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:h})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const h of t)this.h.add(h);this.u()}n(t,h,s){t.forEach(d=>{this.p(d,h,d.extensionInfo,d.restrictedProperties,void 0,s),this.c.push(d),this.q(d)})}o(t,h){const s=d=>{if(d.properties)for(const u in d.properties){h.add(u);const l=this.d[u];l?.policy?.name&&this.e.delete(l.policy.name),delete this.d[u],this.s(u,d.properties[u])}d.allOf?.forEach(u=>s(u))};for(const d of t){s(d);const u=this.c.indexOf(d);u!==-1&&this.c.splice(u,1)}}p(t,h=!0,s,d,u=3,l){u=f.$Rf(t.scope)?u:t.scope;const p=t.properties;if(p)for(const b in p){const m=p[b];if(h&&r(b,m)){delete p[b];continue}if(m.source=s,m.defaultDefaultValue=p[b].default,this.w(b,m),e.$Wn.test(b)?m.scope=void 0:(m.scope=f.$Rf(m.scope)?u:m.scope,m.restricted=f.$Rf(m.restricted)?!!d?.includes(b):m.restricted),p[b].hasOwnProperty("included")&&!p[b].included){this.f[b]=p[b],delete p[b];continue}else this.d[b]=p[b],p[b].policy?.name&&this.e.set(p[b].policy.name,b);!p[b].deprecationMessage&&p[b].markdownDeprecationMessage&&(p[b].deprecationMessage=p[b].markdownDeprecationMessage),l.add(b)}const I=t.allOf;if(I)for(const b of I)this.p(b,h,s,d,u,l)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const h=s=>{const d=s.properties;if(d)for(const l in d)this.r(l,d[l]);s.allOf?.forEach(h)};h(t)}r(t,h){switch(e.$Nn.properties[t]=h,h.scope){case 1:e.$On.properties[t]=h;break;case 2:e.$Pn.properties[t]=h;break;case 6:e.$Qn.properties[t]=h;break;case 3:e.$Rn.properties[t]=h;break;case 4:e.$Sn.properties[t]=h;break;case 5:e.$Sn.properties[t]=h,this.g.properties[t]=h;break}}s(t,h){switch(delete e.$Nn.properties[t],h.scope){case 1:delete e.$On.properties[t];break;case 2:delete e.$Pn.properties[t];break;case 6:delete e.$Qn.properties[t];break;case 3:delete e.$Rn.properties[t];break;case 4:case 5:delete e.$Sn.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const h=`[${t}]`,s={type:"object",description:P.localize(2,null),errorMessage:P.localize(3,null),$ref:e.$Tn};this.w(h,s),e.$Nn.properties[h]=s,e.$On.properties[h]=s,e.$Pn.properties[h]=s,e.$Qn.properties[h]=s,e.$Rn.properties[h]=s,e.$Sn.properties[h]=s}}v(){const t={type:"object",description:P.localize(4,null),errorMessage:P.localize(5,null),$ref:e.$Tn};e.$Nn.patternProperties[e.$Vn]=t,e.$On.patternProperties[e.$Vn]=t,e.$Pn.patternProperties[e.$Vn]=t,e.$Qn.patternProperties[e.$Vn]=t,e.$Rn.patternProperties[e.$Vn]=t,e.$Sn.patternProperties[e.$Vn]=t,this.i.fire()}w(t,h){const s=this.a.get(t);let d=s?.value,u=s?.source;f.$Pf(d)&&(d=h.defaultDefaultValue,u=void 0),f.$Pf(d)&&(d=o(h.type)),h.default=d,h.defaultValueSource=u}}const E="\\[([^\\]]+)\\]",S=new RegExp(E,"g");e.$Vn=`^(${E})+$`,e.$Wn=new RegExp(e.$Vn);function c(a){const t=[];if(e.$Wn.test(a)){let h=S.exec(a);for(;h?.length;){const s=h[1].trim();s&&t.push(s),h=S.exec(a)}}return(0,C.$Mb)(t)}e.$Xn=c;function g(a){return a.reduce((t,h)=>`${t}[${h}]`,"")}e.$Yn=g;function o(a){switch(Array.isArray(a)?a[0]:a){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.$Zn=o;const i=new w;$.$Hn.add(e.$Mn.Configuration,i);function r(a,t){return a.trim()?e.$Wn.test(a)?P.localize(7,null,a):i.getConfigurationProperties()[a]!==void 0?P.localize(8,null,a):t.policy?.name&&i.getPolicyConfigurations().get(t.policy?.name)!==void 0?P.localize(9,null,a,t.policy?.name,i.getPolicyConfigurations().get(t.policy?.name)):null:P.localize(6,null)}e.$1n=r;function n(){const a=[],t=i.getConfigurationProperties();for(const h of Object.keys(t))a.push([h,t[h].scope]);return a.push(["launch",4]),a.push(["task",4]),a}e.$2n=n}),define(ke[254],Se([1,0,19,4,159,3,28,24,18,2,51,87,37]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8n=e.$7n=e.$6n=e.$5n=e.$4n=e.$3n=void 0;function E(h){return Object.isFrozen(h)?h:v.$wn(h)}class S{constructor(s={},d=[],u=[],l){this.b=s,this.c=d,this.d=u,this.raw=l,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const s=this.raw.map(d=>{if(d instanceof S)return d;const u=new c("");return u.parseRaw(d),u.configurationModel});this.f=s.reduce((d,u)=>u===d?u:d.merge(u),s[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(s){return s?(0,A.$Hi)(this.contents,s):this.contents}inspect(s,d){const u=this.rawConfiguration.getValue(s),l=d?this.rawConfiguration.getOverrideValue(s,d):void 0,p=d?this.rawConfiguration.override(d).getValue(s):u;return{value:u,override:l,merged:p}}getOverrideValue(s,d){const u=this.i(d);return u?s?(0,A.$Hi)(u,s):u:void 0}getKeysForOverrideIdentifier(s){const d=[];for(const u of this.overrides)u.identifiers.includes(s)&&d.push(...u.keys);return C.$Mb(d)}getAllOverrideIdentifiers(){const s=[];for(const d of this.overrides)s.push(...d.identifiers);return C.$Mb(s)}override(s){let d=this.a.get(s);return d||(d=this.g(s),this.a.set(s,d)),d}merge(...s){const d=v.$vn(this.contents),u=v.$vn(this.overrides),l=[...this.keys],p=this.raw?.length?[...this.raw]:[this];for(const I of s)if(p.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(d,I.contents);for(const b of I.overrides){const[m]=u.filter(y=>C.$ub(y.identifiers,b.identifiers));m?(this.h(m.contents,b.contents),m.keys.push(...b.keys),m.keys=C.$Mb(m.keys)):u.push(v.$vn(b))}for(const b of I.keys)l.indexOf(b)===-1&&l.push(b)}return new S(d,l,u,p.every(I=>I instanceof S)?void 0:p)}g(s){const d=this.i(s);if(!d||typeof d!="object"||!Object.keys(d).length)return this;const u={};for(const l of C.$Mb([...Object.keys(this.contents),...Object.keys(d)])){let p=this.contents[l];const I=d[l];I&&(typeof p=="object"&&typeof I=="object"?(p=v.$vn(p),this.h(p,I)):p=I),u[l]=p}return new S(u,this.keys,this.overrides)}h(s,d){for(const u of Object.keys(d)){if(u in s&&$.$Kf(s[u])&&$.$Kf(d[u])){this.h(s[u],d[u]);continue}s[u]=v.$vn(d[u])}}i(s){let d=null,u=null;const l=p=>{p&&(u?this.h(u,p):u=v.$vn(p))};for(const p of this.overrides)p.identifiers.length===1&&p.identifiers[0]===s?d=p.contents:p.identifiers.includes(s)&&l(p.contents);return l(d),u}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(s,d){this.j(s,d,!0)}setValue(s,d){this.j(s,d,!1)}removeValue(s){const d=this.keys.indexOf(s);d!==-1&&(this.keys.splice(d,1),(0,A.$Gi)(this.contents,s),D.$Wn.test(s)&&this.overrides.splice(this.overrides.findIndex(u=>C.$ub(u.identifiers,(0,D.$Xn)(s))),1))}j(s,d,u){(0,A.$Fi)(this.contents,s,d,l=>console.error(l)),u=u||this.keys.indexOf(s)===-1,u&&this.keys.push(s),D.$Wn.test(s)&&this.overrides.push({identifiers:(0,D.$Xn)(s),keys:Object.keys(this.contents[s]),contents:(0,A.$Ei)(this.contents[s],l=>console.error(l))})}}e.$3n=S;class c{constructor(s){this.f=s,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new S}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(s,d){if(!$.$Rf(s)){const u=this.g(s);this.parseRaw(u,d)}}reparse(s){this.a&&this.parseRaw(this.a,s)}parseRaw(s,d){this.a=s;const{contents:u,keys:l,overrides:p,restricted:I,hasExcludedProperties:b}=this.h(s,d);this.b=new S(u,l,p,b?[s]:void 0),this.c=I||[]}g(s){let d={},u=null,l=[];const p=[],I=[];function b(y){Array.isArray(l)?l.push(y):u!==null&&(l[u]=y)}const m={onObjectBegin:()=>{const y={};b(y),p.push(l),l=y,u=null},onObjectProperty:y=>{u=y},onObjectEnd:()=>{l=p.pop()},onArrayBegin:()=>{const y=[];b(y),p.push(l),l=y,u=null},onArrayEnd:()=>{l=p.pop()},onLiteralValue:b,onError:(y,L,F)=>{I.push({error:y,offset:L,length:F})}};if(s)try{f.$jn(s,m),d=l[0]||{}}catch(y){console.error(`Error while parsing settings file ${this.f}: ${y}`),this.d=[y]}return d}h(s,d){const u=w.$Hn.as(D.$Mn.Configuration).getConfigurationProperties(),l=this.i(s,u,!0,d);s=l.raw;const p=(0,A.$Ei)(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`)),I=Object.keys(s),b=this.j(s,m=>console.error(`Conflict in settings file ${this.f}: ${m}`));return{contents:p,keys:I,overrides:b,restricted:l.restricted,hasExcludedProperties:l.hasExcludedProperties}}i(s,d,u,l){let p=!1;if(!l?.scopes&&!l?.skipRestricted&&!l?.exclude?.length)return{raw:s,restricted:[],hasExcludedProperties:p};const I={},b=[];for(const m in s)if(D.$Wn.test(m)&&u){const y=this.i(s[m],d,!1,l);I[m]=y.raw,p=p||y.hasExcludedProperties,b.push(...y.restricted)}else{const y=d[m],L=y?typeof y.scope<"u"?y.scope:3:void 0;y?.restricted&&b.push(m),!l.exclude?.includes(m)&&(l.include?.includes(m)||(L===void 0||l.scopes===void 0||l.scopes.includes(L))&&!(l.skipRestricted&&y?.restricted))?I[m]=s[m]:p=!0}return{raw:I,restricted:b,hasExcludedProperties:p}}j(s,d){const u=[];for(const l of Object.keys(s))if(D.$Wn.test(l)){const p={};for(const I in s[l])p[I]=s[l][I];u.push({identifiers:(0,D.$Xn)(l),keys:Object.keys(p),contents:(0,A.$Ei)(p,d)})}return u}}e.$4n=c;class g extends P.$Tc{constructor(s,d,u,l){super(),this.c=s,this.f=d,this.g=l,this.b=this.B(new N.$Vd),this.onDidChange=this.b.event,this.a=new c(this.c.toString()),this.B(this.g.watch(u.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,p=>p.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,p=>(p.isOperation(0)||p.isOperation(3)||p.isOperation(1)||p.isOperation(4))&&u.isEqual(p.resource,s)))(()=>this.b.fire()))}async loadConfiguration(){try{const s=await this.g.readFile(this.c);return this.a.parse(s.value.toString()||"{}",this.f),this.a.configurationModel}catch{return new S}}reparse(s){return s&&(this.f=s),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$5n=g;class o{constructor(s,d,u,l,p,I,b,m,y,L,F,z,T){this.a=s,this.b=d,this.c=u,this.overrideIdentifiers=l,this.d=p,this.f=I,this.g=b,this.h=m,this.i=y,this.j=L,this.k=F,this.l=z,this.m=T}get value(){return E(this.c)}n(s,d,u){const l=s.inspect(d,u);return{get value(){return E(l.value)},get override(){return E(l.override)},get merged(){return E(l.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class i{constructor(s,d,u,l,p=new S,I=new S,b=new R.$Ac,m=new S,y=new R.$Ac){this.c=s,this.d=d,this.f=u,this.g=l,this.h=p,this.i=I,this.j=b,this.l=m,this.m=y,this.a=null,this.b=new R.$Ac,this.n=null}getValue(s,d,u){return this.p(s,d,u).getValue(s)}updateValue(s,d,u={}){let l;u.resource?(l=this.m.get(u.resource),l||(l=new S,this.m.set(u.resource,l))):l=this.l,d===void 0?l.removeValue(s):l.setValue(s,d),u.resource||(this.a=null)}inspect(s,d,u){const l=this.p(s,d,u),p=this.t(d.resource,u),I=d.resource?this.m.get(d.resource)||this.l:this.l,b=new Set;for(const m of l.overrides)for(const y of m.identifiers)l.getOverrideValue(s,y)!==void 0&&b.add(y);return new o(s,d,l.getValue(s),b.size?[...b]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,u?this.i:void 0,p||void 0,I)}keys(s){const d=this.t(void 0,s);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:d?d.keys.slice(0):[]}}updateDefaultConfiguration(s){this.c=s,this.a=null,this.b.clear()}updatePolicyConfiguration(s){this.d=s}updateApplicationConfiguration(s){this.f=s,this.a=null,this.b.clear()}updateLocalUserConfiguration(s){this.g=s,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(s){this.h=s,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(s){this.i=s,this.a=null,this.b.clear()}updateFolderConfiguration(s,d){this.j.set(s,d),this.b.delete(s)}deleteFolderConfiguration(s){this.folderConfigurations.delete(s),this.b.delete(s)}compareAndUpdateDefaultConfiguration(s,d){const u=[];if(!d){const{added:l,updated:p,removed:I}=a(this.c,s);d=[...l,...p,...I]}for(const l of d)for(const p of(0,D.$Xn)(l)){const I=this.c.getKeysForOverrideIdentifier(p),b=s.getKeysForOverrideIdentifier(p),m=[...b.filter(y=>I.indexOf(y)===-1),...I.filter(y=>b.indexOf(y)===-1),...I.filter(y=>!v.$zn(this.c.override(p).getValue(y),s.override(p).getValue(y)))];u.push([p,m])}return this.updateDefaultConfiguration(s),{keys:d,overrides:u}}compareAndUpdatePolicyConfiguration(s){const{added:d,updated:u,removed:l}=a(this.d,s),p=[...d,...u,...l];return p.length&&this.updatePolicyConfiguration(s),{keys:p,overrides:[]}}compareAndUpdateApplicationConfiguration(s){const{added:d,updated:u,removed:l,overrides:p}=a(this.applicationConfiguration,s),I=[...d,...u,...l];return I.length&&this.updateApplicationConfiguration(s),{keys:I,overrides:p}}compareAndUpdateLocalUserConfiguration(s){const{added:d,updated:u,removed:l,overrides:p}=a(this.localUserConfiguration,s),I=[...d,...u,...l];return I.length&&this.updateLocalUserConfiguration(s),{keys:I,overrides:p}}compareAndUpdateRemoteUserConfiguration(s){const{added:d,updated:u,removed:l,overrides:p}=a(this.remoteUserConfiguration,s),I=[...d,...u,...l];return I.length&&this.updateRemoteUserConfiguration(s),{keys:I,overrides:p}}compareAndUpdateWorkspaceConfiguration(s){const{added:d,updated:u,removed:l,overrides:p}=a(this.workspaceConfiguration,s),I=[...d,...u,...l];return I.length&&this.updateWorkspaceConfiguration(s),{keys:I,overrides:p}}compareAndUpdateFolderConfiguration(s,d){const u=this.folderConfigurations.get(s),{added:l,updated:p,removed:I,overrides:b}=a(u,d),m=[...l,...p,...I];return(m.length||!u)&&this.updateFolderConfiguration(s,d),{keys:m,overrides:b}}compareAndDeleteFolderConfiguration(s){const d=this.folderConfigurations.get(s);if(!d)throw new Error("Unknown folder");this.deleteFolderConfiguration(s);const{added:u,updated:l,removed:p,overrides:I}=a(d,void 0);return{keys:[...u,...l,...p],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get folderConfigurations(){return this.j}p(s,d,u){let l=this.q(d,u);return d.overrideIdentifier&&(l=l.override(d.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(s)!==void 0&&(l=l.merge(this.d)),l}q({resource:s},d){let u=this.r();if(d&&s){const l=d.getFolder(s);l&&(u=this.s(l.uri)||u);const p=this.m.get(s);p&&(u=u.merge(p))}return u}r(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}s(s){let d=this.b.get(s);if(!d){const u=this.r(),l=this.j.get(s);l?(d=u.merge(l),this.b.set(s,d)):d=u}return d}t(s,d){if(d&&s){const u=d.getFolder(s);if(u)return this.j.get(u.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((s,d)=>{const{contents:u,overrides:l,keys:p}=this.j.get(d);return s.push([d,{contents:u,overrides:l,keys:p}]),s},[])}}allKeys(){const s=new Set;return this.c.keys.forEach(d=>s.add(d)),this.userConfiguration.keys.forEach(d=>s.add(d)),this.i.keys.forEach(d=>s.add(d)),this.j.forEach(d=>d.keys.forEach(u=>s.add(u))),[...s.values()]}u(){const s=new Set;return this.c.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.userConfiguration.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.i.getAllOverrideIdentifiers().forEach(d=>s.add(d)),this.j.forEach(d=>d.getAllOverrideIdentifiers().forEach(u=>s.add(u))),[...s.values()]}v(s){const d=new Set;return this.c.getKeysForOverrideIdentifier(s).forEach(u=>d.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(s).forEach(u=>d.add(u)),this.i.getKeysForOverrideIdentifier(s).forEach(u=>d.add(u)),this.j.forEach(u=>u.getKeysForOverrideIdentifier(s).forEach(l=>d.add(l))),[...d.values()]}static parse(s){const d=this.w(s.defaults),u=this.w(s.policy),l=this.w(s.application),p=this.w(s.user),I=this.w(s.workspace),b=s.folders.reduce((m,y)=>(m.set(k.URI.revive(y[0]),this.w(y[1])),m),new R.$Ac);return new i(d,u,l,p,new S,I,b,new S,new R.$Ac)}static w(s){return new S(s.contents,s.keys,s.overrides)}}e.$6n=i;function r(...h){if(h.length===0)return{keys:[],overrides:[]};if(h.length===1)return h[0];const s=new Set,d=new Map;for(const l of h)l.keys.forEach(p=>s.add(p)),l.overrides.forEach(([p,I])=>{const b=(0,R.$xc)(d,p,new Set);I.forEach(m=>b.add(m))});const u=[];return d.forEach((l,p)=>u.push([p,[...l.values()]])),{keys:[...s.values()],overrides:u}}e.$7n=r;class n{constructor(s,d,u,l){this.change=s,this.f=d,this.g=u,this.h=l,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const p of s.keys)this.affectedKeys.add(p);for(const[,p]of s.overrides)for(const I of p)this.affectedKeys.add(I);this.d=this.a;for(const p of this.affectedKeys)this.d+=p+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=i.parse(this.f.data)),this.i}affectsConfiguration(s,d){const u=this.a+s,l=this.d.indexOf(u);if(l<0)return!1;const p=l+u.length;if(p>=this.d.length)return!1;const I=this.d.charCodeAt(p);if(I!==this.b&&I!==this.c)return!1;if(d){const b=this.previousConfiguration?this.previousConfiguration.getValue(s,d,this.f?.workspace):void 0,m=this.g.getValue(s,d,this.h);return!v.$zn(b,m)}return!0}}e.$8n=n;function a(h,s){const{added:d,removed:u,updated:l}=t(s?.rawConfiguration,h?.rawConfiguration),p=[],I=h?.getAllOverrideIdentifiers()||[],b=s?.getAllOverrideIdentifiers()||[];if(s){const m=b.filter(y=>!I.includes(y));for(const y of m)p.push([y,s.getKeysForOverrideIdentifier(y)])}if(h){const m=I.filter(y=>!b.includes(y));for(const y of m)p.push([y,h.getKeysForOverrideIdentifier(y)])}if(s&&h){for(const m of I)if(b.includes(m)){const y=t({contents:h.getOverrideValue(void 0,m)||{},keys:h.getKeysForOverrideIdentifier(m)},{contents:s.getOverrideValue(void 0,m)||{},keys:s.getKeysForOverrideIdentifier(m)});p.push([m,[...y.added,...y.removed,...y.updated]])}}return{added:d,removed:u,updated:l,overrides:p}}function t(h,s){const d=h?s?h.keys.filter(p=>s.keys.indexOf(p)===-1):[...h.keys]:[],u=s?h?s.keys.filter(p=>h.keys.indexOf(p)===-1):[...s.keys]:[],l=[];if(h&&s){for(const p of s.keys)if(h.keys.indexOf(p)!==-1){const I=(0,A.$Hi)(s.contents,p),b=(0,A.$Hi)(h.contents,p);v.$zn(I,b)||l.push(p)}}return{added:d,removed:u,updated:l}}}),define(ke[255],Se([1,0,22,4,3,82]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9rb=e.$8rb=e.$7rb=e.$6rb=void 0;const R=(k,A,D)=>{const w=new Uint8Array(16);for(let c=0;c<16;c++)w[c]=Math.round(Math.random()*256);const E=(0,C.$De)(C.$je.wrap(w));return[`GET ws://localhost${k}?${A}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${E}`].join(`\r
`)+`\r
\r
`};e.$6rb=R,e.$7rb=C.$je.fromString(`\r
\r
`);async function v(k,A,D,w,E){k.write(C.$je.fromString((0,e.$6rb)(A,D,w)));const S=new f.$Sc;try{return await new Promise((c,g)=>{let o;S.add(k.onData(i=>{o?o=C.$je.concat([o,i],o.byteLength+i.byteLength):o=i;const r=o.indexOf(e.$7rb);if(r===-1)return;c(k),k.pauseData();const n=o.slice(r+e.$7rb.byteLength);n.byteLength&&E.onData.fire(n)})),S.add(k.onClose(i=>g(i??new Error("socket closed")))),S.add(k.onEnd(()=>g(new Error("socket ended"))))})}catch(c){throw k.dispose(),c}finally{S.dispose()}}e.$8rb=v;class $ extends f.$Tc{constructor(A,D){super(),this.g=A,this.a=this.B(new N.$Yd),this.onData=(...w)=>(this.a.isPaused&&queueMicrotask(()=>this.a.resume()),this.a.event(...w)),this.b=this.B(new N.$Vd),this.onDidDispose=this.b.event,this.f=!1,this.B(D.onData),this.B(D.onData.event(w=>this.a.fire(w))),this.onClose=this.B(D.onClose).event,this.onEnd=this.B(D.onEnd).event}pauseData(){this.a.pause()}drain(){return Promise.resolve()}end(){this.f=!0,this.h()}traceSocketEvent(A,D){P.SocketDiagnostics.traceSocketEvent(this,this.g,A,D)}dispose(){this.f||this.h(),this.b.fire(),super.dispose()}}e.$9rb=$}),define(ke[64],Se([1,0,14,5]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_k=e.$$k=e.RemoteAuthorityResolverErrorCode=e.$0k=e.$9k=e.RemoteConnectionType=e.$8k=void 0,e.$8k=(0,N.$6h)("remoteAuthorityResolverService");var f;(function(A){A[A.WebSocket=0]="WebSocket",A[A.Managed=1]="Managed"})(f||(e.RemoteConnectionType=f={}));class P{constructor(D){this.id=D,this.type=1}toString(){return`Managed(${this.id})`}}e.$9k=P;class R{constructor(D,w){this.host=D,this.port=w,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$0k=R;var v;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound",A.InvalidAuthority="InvalidAuthority"})(v||(e.RemoteAuthorityResolverErrorCode=v={}));class $ extends C.$bb{static isNotAvailable(D){return D instanceof $&&D._code===v.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof $&&D._code===v.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof $&&D._code===v.NoResolverFound}static isInvalidAuthority(D){return D instanceof $&&D._code===v.InvalidAuthority}static isHandled(D){return D instanceof $&&D.isHandled}constructor(D,w=v.Unknown,E){super(D),this._message=D,this._code=w,this._detail=E,this.isHandled=w===v.NotAvailable&&E===!0,Object.setPrototypeOf(this,$.prototype)}}e.$$k=$;function k(A){const D=A.indexOf("+");return D===-1?A:A.substring(0,D)}e.$_k=k}),define(ke[65],Se([1,0,16]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$el=e.$dl=e.$cl=e.$bl=e.$al=void 0;function N(k){return k.scheme===C.Schemas.vscodeRemote?k.authority:void 0}e.$al=N;function f(k){if(!k)return;const A=k.indexOf("+");return A<0?k:k.substr(0,A)}e.$bl=f;function P(k){return`/${k.quality??"oss"}-${k.commit??"dev"}`}e.$cl=P;function R(k){const{host:A,port:D}=$(k);if(typeof D>"u")throw new Error(`Invalid remote authority: ${k}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:A,port:D}}e.$dl=R;function v(k,A){let{host:D,port:w}=$(k);return typeof w>"u"&&(w=A),{host:D,port:w}}e.$el=v;function $(k){const A=k.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(A)return{host:A[1],port:parseInt(A[2],10)};const D=k.match(/^(\[[0-9a-z:]+\])$/);if(D)return{host:D[1],port:void 0};const w=k.match(/(.*):(\d+)$/);return w?{host:w[1],port:parseInt(w[2],10)}:{host:k,port:void 0}}}),define(ke[25],Se([1,0,12,5,65]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=e.$rm=e.$qm=e.$pm=e.$om=e.$nm=e.$mm=e.$lm=e.TargetPlatform=e.ExtensionType=e.$km=e.$jm=e.$im=e.$hm=e.$gm=e.$fm=void 0,e.$fm="extensions.user.cache",e.$gm="extensions.builtin.cache",e.$hm="undefined_publisher",e.$im=["ui","workspace","web"];function P(c){if(typeof c=="object"&&c!==null&&c.supported!==!0)return c.description}e.$jm=P,e.$km=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(c){c[c.System=0]="System",c[c.User=1]="User"})(R||(e.ExtensionType=R={}));var v;(function(c){c.WIN32_X64="win32-x64",c.WIN32_ARM64="win32-arm64",c.LINUX_X64="linux-x64",c.LINUX_ARM64="linux-arm64",c.LINUX_ARMHF="linux-armhf",c.ALPINE_X64="alpine-x64",c.ALPINE_ARM64="alpine-arm64",c.DARWIN_X64="darwin-x64",c.DARWIN_ARM64="darwin-arm64",c.WEB="web",c.UNIVERSAL="universal",c.UNKNOWN="unknown",c.UNDEFINED="undefined"})(v||(e.TargetPlatform=v={}));class ${constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,o){if(typeof g>"u"||g===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof g=="string"||typeof o=="string"){const i=typeof g=="string"?g:g.value,r=typeof o=="string"?o:o.value;return C.$_e(i,r)}return g._lower===o._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$lm=$;class k{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const o of g)this.add(o)}add(g){this.c.add($.toKey(g))}delete(g){return this.c.delete($.toKey(g))}has(g){return this.c.has($.toKey(g))}}e.$mm=k;class A{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete($.toKey(g))}get(g){return this.c.get($.toKey(g))}has(g){return this.c.has($.toKey(g))}set(g,o){this.c.set($.toKey(g),o)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$nm=A;function D(c){return w(c)}e.$om=D;function w(c){return c.contributes&&c.contributes.localizations?c.contributes.localizations.length>0:!1}e.$pm=w;function E(c){return c.contributes&&c.contributes.authentication?c.contributes.authentication.length>0:!1}e.$qm=E;function S(c,g){if(g){const o=`onResolveRemoteAuthority:${(0,f.$bl)(g)}`;return!!c.activationEvents?.includes(o)}return!1}e.$rm=S,e.$sm=(0,N.$6h)("IBuiltinExtensionsScannerService")}),define(ke[137],Se([1,0,14,25]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lF=e.$kF=void 0;class f{constructor(){this.a=new Map,this.b=new WeakMap}register(R,v){this.a.set(R,v)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const v=Object.create(null);for(const $ of R){const k=this.readActivationEvents($);k.length>0&&(v[N.$lm.toKey($.identifier)]=k)}return v}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const v=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];for(let $=0;$<v.length;$++)v[$]==="onUri"&&(v[$]=`onUri:${N.$lm.toKey(R.identifier)}`);if(!R.contributes)return v;for(const $ in R.contributes){const k=this.a.get($);if(!k)continue;const A=R.contributes[$],D=Array.isArray(A)?A:[A];try{k(D,v)}catch(w){(0,C.$1)(w)}}return v}}e.$kF=f,e.$lF=new f}),define(ke[256],Se([1,0,11,22,21,14,4,3,58,38,30,82,64,65]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tl=e.$sl=e.$rl=e.$ql=e.$pl=e.$ol=e.$nl=e.$ml=e.PersistentConnectionEventType=e.$ll=e.$kl=e.$jl=e.ConnectionType=void 0;const S=30*1e3;var c;(function(J){J[J.Management=1]="Management",J[J.ExtensionHost=2]="ExtensionHost",J[J.Tunnel=3]="Tunnel"})(c||(e.ConnectionType=c={}));function g(J){switch(J){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function o(J){const V=new f.$6d;return setTimeout(()=>V.cancel(),J),V.token}function i(J,V){if(J.isCancellationRequested||V.isCancellationRequested)return f.CancellationToken.Cancelled;const ie=new f.$6d;return J.onCancellationRequested(()=>ie.cancel()),V.onCancellationRequested(()=>ie.cancel()),ie.token}class r{get didTimeout(){return this.c==="timedout"}constructor(V){this.c="pending",this.d=new v.$Sc,this.promise=new Promise((ie,ye)=>{this.f=ie,this.g=ye}),V.isCancellationRequested?this.h():this.d.add(V.onCancellationRequested(()=>this.h()))}registerDisposable(V){this.c==="pending"?this.d.add(V):V.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const V=new Error("Time limit reached");return V.code="ETIMEDOUT",V.syscall="connect",V}resolve(V){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(V))}reject(V){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(V))}}function n(J,V){const ie=new r(V);return ie.registerDisposable(J.onControlMessage(ye=>{const de=JSON.parse(ye.toString()),fe=Q(de);fe?ie.reject(fe):ie.resolve(de)})),ie.promise}function a(J,V,ie,ye,de,fe,_,ee){const G=new r(ee),x=k.$Rd.create(!1);return J.info(`Creating a socket (${_})...`),$.mark(`code/willCreateSocket/${fe}`),V.connect(ie,ye,de,_).then(me=>{G.didTimeout?($.mark(`code/didCreateSocketError/${fe}`),J.info(`Creating a socket (${_}) finished after ${x.elapsed()} ms, but this is too late and has timed out already.`),me?.dispose()):($.mark(`code/didCreateSocketOK/${fe}`),J.info(`Creating a socket (${_}) was successful after ${x.elapsed()} ms.`),G.resolve(me))},me=>{$.mark(`code/didCreateSocketError/${fe}`),J.info(`Creating a socket (${_}) returned an error after ${x.elapsed()} ms.`),J.error(me),G.reject(me)}),G.promise}function t(J,V){const ie=new r(V);return J.then(ye=>{ie.didTimeout||ie.resolve(ye)},ye=>{ie.didTimeout||ie.reject(ye)}),ie.promise}async function h(J,V,ie,ye){const de=$e(J,V);J.logService.trace(`${de} 1/6. invoking socketFactory.connect().`);let fe;try{fe=await a(J.logService,J.remoteSocketFactoryService,J.connectTo,(0,E.$cl)(J),`reconnectionToken=${J.reconnectionToken}&reconnection=${J.reconnectionProtocol?"true":"false"}`,g(V),`renderer-${g(V)}-${J.reconnectionToken}`,ye)}catch(me){throw J.logService.error(`${de} socketFactory.connect() failed or timed out. Error:`),J.logService.error(me),me}J.logService.trace(`${de} 2/6. socketFactory.connect() was successful.`);let _,ee;J.reconnectionProtocol?(J.reconnectionProtocol.beginAcceptReconnection(fe,null),_=J.reconnectionProtocol,ee=!1):(_=new D.$Th({socket:fe}),ee=!0),J.logService.trace(`${de} 3/6. sending AuthRequest control message.`);const G=await t(J.signService.createNewMessage((0,A.$qg)()),ye),x={type:"auth",auth:J.connectionToken||"00000000000000000000",data:G.data};_.sendControl(N.$je.fromString(JSON.stringify(x)));try{const me=await n(_,i(ye,o(1e4)));if(me.type!=="sign"||typeof me.data!="string"){const Ie=new Error("Unexpected handshake message");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}if(J.logService.trace(`${de} 4/6. received SignRequest control message.`),!await t(J.signService.validate(G,me.signedData),ye)){const Ie=new Error("Refused to connect to unsupported server");throw Ie.code="VSCODE_CONNECTION_ERROR",Ie}const Re=await t(J.signService.sign(me.data),ye),ve={type:"connectionType",commit:J.commit,signedData:Re,desiredConnectionType:V};return ie&&(ve.args=ie),J.logService.trace(`${de} 5/6. sending ConnectionTypeRequest control message.`),_.sendControl(N.$je.fromString(JSON.stringify(ve))),{protocol:_,ownsProtocol:ee}}catch(me){throw me&&me.code==="ETIMEDOUT"&&(J.logService.error(`${de} the handshake timed out. Error:`),J.logService.error(me)),me&&me.code==="VSCODE_CONNECTION_ERROR"&&(J.logService.error(`${de} received error control message when negotiating connection. Error:`),J.logService.error(me)),ee&&X(_),me}}async function s(J,V,ie,ye){const de=Date.now(),fe=$e(J,V),{protocol:_,ownsProtocol:ee}=await h(J,V,ie,ye),G=new r(ye);return G.registerDisposable(_.onControlMessage(x=>{const me=JSON.parse(x.toString()),pe=Q(me);pe?(J.logService.error(`${fe} received error control message when negotiating connection. Error:`),J.logService.error(pe),ee&&X(_),G.reject(pe)):(J.reconnectionProtocol?.endAcceptReconnection(),J.logService.trace(`${fe} 6/6. handshake finished, connection is up and running after ${oe(de)}!`),G.resolve({protocol:_,firstMessage:me}))})),G.promise}async function d(J,V){const{protocol:ie}=await s(J,1,void 0,V);return{protocol:ie}}async function u(J,V,ie){const{protocol:ye,firstMessage:de}=await s(J,2,V,ie),fe=de&&de.debugPort;return{protocol:ye,debugPort:fe}}async function l(J,V,ie){const ye=Date.now(),de=$e(J,3),{protocol:fe}=await h(J,3,V,ie);return J.logService.trace(`${de} 6/6. handshake finished, connection is up and running after ${oe(ye)}!`),fe}async function p(J,V,ie){const{connectTo:ye,connectionToken:de}=await J.addressProvider.getAddress();return{commit:J.commit,quality:J.quality,connectTo:ye,connectionToken:de,reconnectionToken:V,reconnectionProtocol:ie,remoteSocketFactoryService:J.remoteSocketFactoryService,signService:J.signService,logService:J.logService}}async function I(J,V,ie){return m(J,async ye=>{const{protocol:de}=await d(ye,f.CancellationToken.None);return new K(J,V,ie,ye.reconnectionToken,de)})}e.$jl=I;async function b(J,V){return m(J,async ie=>{const{protocol:ye,debugPort:de}=await u(ie,V,f.CancellationToken.None);return new ue(J,V,ie.reconnectionToken,ye,de)})}e.$kl=b;async function m(J,V){for(let ye=1;;ye++)try{const de=(0,A.$qg)(),fe=await p(J,de,null);return await V(fe)}catch(de){if(ye<5)J.logService.error(`[remote-connection][attempt ${ye}] An error occurred in initial connection! Will retry... Error:`),J.logService.error(de);else throw J.logService.error(`[remote-connection][attempt ${ye}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),J.logService.error(de),U.triggerPermanentFailure(0,0,w.$$k.isHandled(de)),de}}async function y(J,V,ie){const ye=await p(J,(0,A.$qg)(),null);return await l(ye,{host:V,port:ie},f.CancellationToken.None)}e.$ll=y;function L(J){return(0,C.$Tg)(V=>new Promise((ie,ye)=>{const de=setTimeout(ie,J*1e3);V.onCancellationRequested(()=>{clearTimeout(de),ie()})}))}var F;(function(J){J[J.ConnectionLost=0]="ConnectionLost",J[J.ReconnectionWait=1]="ReconnectionWait",J[J.ReconnectionRunning=2]="ReconnectionRunning",J[J.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",J[J.ConnectionGain=4]="ConnectionGain"})(F||(e.PersistentConnectionEventType=F={}));class z{constructor(V,ie){this.reconnectionToken=V,this.millisSinceLastIncomingData=ie,this.type=0}}e.$ml=z;class T{constructor(V,ie,ye,de){this.reconnectionToken=V,this.millisSinceLastIncomingData=ie,this.durationSeconds=ye,this.c=de,this.type=1}skipWait(){this.c.cancel()}}e.$nl=T;class O{constructor(V,ie,ye){this.reconnectionToken=V,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.type=2}}e.$ol=O;class M{constructor(V,ie,ye){this.reconnectionToken=V,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.type=4}}e.$pl=M;class j{constructor(V,ie,ye,de){this.reconnectionToken=V,this.millisSinceLastIncomingData=ie,this.attempt=ye,this.handled=de,this.type=3}}e.$ql=j;class U extends v.$Tc{static triggerPermanentFailure(V,ie,ye){this._permanentFailure=!0,this.f=V,this.g=ie,this.h=ye,this.j.forEach(de=>de.D(this.f,this.g,this.h))}static debugTriggerReconnection(){this.j.forEach(V=>V.y())}static debugPauseSocketWriting(){this.j.forEach(V=>V.F())}static{this._permanentFailure=!1}static{this.f=0}static{this.g=0}static{this.h=!1}static{this.j=[]}get n(){return this.c||U._permanentFailure}constructor(V,ie,ye,de,fe){super(),this.t=V,this.u=ie,this.reconnectionToken=ye,this.protocol=de,this.w=fe,this.m=this.B(new R.$Vd),this.onDidStateChange=this.m.event,this.c=!1,this.r=!1,this.s=!1,this.m.fire(new M(this.reconnectionToken,0,0)),this.B(de.onSocketClose(_=>{const ee=re(this.t,this.reconnectionToken,!0);_?_.type===0?(this.u.logService.info(`${ee} received socket close event (hadError: ${_.hadError}).`),_.error&&this.u.logService.error(_.error)):(this.u.logService.info(`${ee} received socket close event (wasClean: ${_.wasClean}, code: ${_.code}, reason: ${_.reason}).`),_.event&&this.u.logService.error(_.event)):this.u.logService.info(`${ee} received socket close event.`),this.y()})),this.B(de.onSocketTimeout(_=>{const ee=re(this.t,this.reconnectionToken,!0);this.u.logService.info(`${ee} received socket timeout event (unacknowledgedMsgCount: ${_.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${_.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${_.timeSinceLastReceivedSomeData}).`),this.y()})),U.j.push(this),this.B((0,v.$Rc)(()=>{const _=U.j.indexOf(this);_>=0&&U.j.splice(_,1)})),this.n&&this.D(U.f,U.g,U.h)}dispose(){super.dispose(),this.s=!0}async y(){if(!this.r)try{this.r=!0,await this.z()}finally{this.r=!1}}async z(){if(this.n||this.s)return;const V=re(this.t,this.reconnectionToken,!0);this.u.logService.info(`${V} starting reconnecting loop. You can get more information with the trace log level.`),this.m.fire(new z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const ie=[0,5,5,10,10,10,10,10,30];let ye=-1;do{ye++;const de=ye<ie.length?ie[ye]:ie[ie.length-1];try{if(de>0){const _=L(de);this.m.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),de,_)),this.u.logService.info(`${V} waiting for ${de} seconds before reconnecting...`);try{await _}catch{}}if(this.n){this.u.logService.error(`${V} permanent failure occurred while running the reconnecting loop.`);break}this.m.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1)),this.u.logService.info(`${V} resolving connection...`);const fe=await p(this.u,this.reconnectionToken,this.protocol);this.u.logService.info(`${V} connecting to ${fe.connectTo}...`),await this.G(fe,o(S)),this.u.logService.info(`${V} reconnected!`),this.m.fire(new M(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),ye+1));break}catch(fe){if(fe.code==="VSCODE_CONNECTION_ERROR"){this.u.logService.error(`${V} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(ye>360){this.u.logService.error(`${V} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}if(w.$$k.isTemporarilyNotAvailable(fe)){this.u.logService.info(`${V} A temporarily not available error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if((fe.code==="ETIMEDOUT"||fe.code==="ENETUNREACH"||fe.code==="ECONNREFUSED"||fe.code==="ECONNRESET")&&fe.syscall==="connect"){this.u.logService.info(`${V} A network error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if((0,P.$4)(fe)){this.u.logService.info(`${V} A promise cancelation error occurred while trying to reconnect, will try again...`),this.u.logService.trace(fe);continue}if(fe instanceof w.$$k){this.u.logService.error(`${V} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,w.$$k.isHandled(fe));break}this.u.logService.error(`${V} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.u.logService.error(fe),this.C(this.protocol.getMillisSinceLastIncomingData(),ye+1,!1);break}}while(!this.n&&!this.s)}C(V,ie,ye){this.w?U.triggerPermanentFailure(V,ie,ye):this.D(V,ie,ye)}D(V,ie,ye){this.m.fire(new j(this.reconnectionToken,V,ie,ye)),X(this.protocol)}F(){this.protocol.pauseSocketWriting()}}e.$rl=U;class K extends U{constructor(V,ie,ye,de,fe){super(1,V,de,fe,!0),this.client=this.B(new D.$Rh(fe,{remoteAuthority:ie,clientId:ye},V.ipcLogger))}async G(V,ie){await d(V,ie)}}e.$sl=K;class ue extends U{constructor(V,ie,ye,de,fe){super(2,V,ye,de,!1),this.H=ie,this.debugPort=fe}async G(V,ie){await u(V,this.H,ie)}}e.$tl=ue;function X(J){try{J.acceptDisconnect();const V=J.getSocket();J.dispose(),V.dispose()}catch(V){(0,P.$1)(V)}}function Q(J){if(J&&J.type==="error"){const V=new Error(`Connection error: ${J.reason}`);return V.code="VSCODE_CONNECTION_ERROR",V}return null}function Z(J,V){for(;J.length<V;)J+=" ";return J}function le(J,V){return`[remote-connection][${Z(g(J),13)}][${V.substr(0,5)}\u2026]`}function re(J,V,ie){return`${le(J,V)}[${ie?"reconnect":"initial"}]`}function $e(J,V){return`${re(V,J.reconnectionToken,!!J.reconnectionProtocol)}[${J.connectTo}]`}function oe(J){return`${Date.now()-J} ms`}}),define(ke[257],Se([1,0,3,5]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gl=e.$fl=void 0,e.$fl=(0,N.$6h)("remoteSocketFactoryService");class f{constructor(){this.a={}}register(R,v){return this.a[R]??=[],this.a[R].push(v),(0,C.$Rc)(()=>{const $=this.a[R]?.indexOf(v);typeof $=="number"&&$>=0&&this.a[R]?.splice($,1)})}b(R){return(this.a[R.type]||[]).find($=>$.supports(R))}connect(R,v,$,k){const A=this.b(R);if(!A)throw new Error(`No socket factory found for ${R}`);return A.connect(R,v,$,k)}}e.$gl=f}),define(ke[258],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$L7b=void 0;class C{constructor(){this.b=new Map}static{this.a=1}async createNewMessage(f){try{const P=await this.c();if(P){const R=String(C.a++);return this.b.set(R,P),{id:R,data:P.createNewMessage(f)}}}catch{}return{id:"",data:f}}async validate(f,P){if(!f.id)return!0;const R=this.b.get(f.id);if(!R)return!1;this.b.delete(f.id);try{return R.validate(P)==="ok"}catch{return!1}finally{R.dispose?.()}}async sign(f){try{return await this.d(f)}catch{}return f}}e.$L7b=C}),define(ke[109],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$il=e.$hl=void 0,e.$hl="signService",e.$il=(0,C.$6h)(e.$hl)}),define(ke[138],Se([1,0,258]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$G_b=void 0;class N extends C.$L7b{c(){return this.h().then(P=>new P.validator)}d(P){return this.h().then(R=>new R.signer().sign(P))}h(){return new Promise((P,R)=>ge(["vsda"],P,R))}}e.$G_b=N}),define(ke[259],Se([1,0,10,49,30]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ko=e.$Jo=void 0;function P($){if(C.$u===2&&/^penguin(\.|$)/i.test($))return"chromebook"}function R($,k,A,D,w,E,S,c,g){const o=Object.create(null);o["common.machineId"]=E,o["common.sqmId"]=S,o.sessionID=(0,f.$qg)()+Date.now(),o.commitHash=D,o.version=w,o["common.platformVersion"]=($||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),o["common.platform"]=(0,C.$h)(C.$u),o["common.nodePlatform"]=N.$dc,o["common.nodeArch"]=A,o["common.product"]=g||"desktop",c&&(o["common.msftInternal"]=c);let i=0;const r=Date.now();Object.defineProperties(o,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-r,enumerable:!0},"common.sequence":{get:()=>i++,enumerable:!0}}),C.$l&&(o["common.snap"]="true");const n=P(k);return n&&(o["common.platformDetail"]=n),o}e.$Jo=R;function v($){const k=N.env.USERDNSDOMAIN;if(!k)return!1;const A=k.toLowerCase();return $.some(D=>A===D)}e.$Ko=v}),define(ke[260],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$El=e.$Dl=e.$Cl=e.$Bl=e.$Al=e.$zl=e.$yl=e.$xl=e.$wl=e.$vl=e.$ul=void 0,e.$ul=(0,C.$6h)("telemetryService"),e.$vl=(0,C.$6h)("customEndpointTelemetryService"),e.$wl="telemetry.currentSessionDate",e.$xl="telemetry.firstSessionDate",e.$yl="telemetry.lastSessionDate",e.$zl="telemetry.machineId",e.$Al="telemetry.sqmId",e.$Bl="telemetry",e.$Cl="telemetry.telemetryLevel",e.$Dl="telemetry.enableCrashReporter",e.$El="telemetry.enableTelemetry";var N;(function(P){P[P.NONE=0]="NONE",P[P.CRASH=1]="CRASH",P[P.ERROR=2]="ERROR",P[P.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var f;(function(P){P.OFF="off",P.CRASH="crash",P.ERROR="error",P.ON="all"})(f||(e.TelemetryConfiguration=f={}))}),define(ke[88],Se([1,0,24,18,65,259,260]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zo=e.$Yo=e.$Xo=e.$Wo=e.$Vo=e.$Uo=e.$To=e.$So=e.$Ro=e.$Qo=e.$Po=e.$Oo=e.$No=e.$Mo=e.$Lo=void 0;class v{constructor(h){this.value=h,this.isTrustedTelemetryValue=!0}}e.$Lo=v;class ${constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$Mo=$,e.$No=new $;class k{async publicLog(h,s,d){}async publicLogError(h,s,d){}}e.$Oo=k,e.$Po="telemetry",e.$Qo="extensionTelemetryLog",e.$Ro={log:()=>null,flush:()=>Promise.resolve(null)};function A(t,h){return!h.isBuilt&&!h.disableTelemetry?!0:!(h.disableTelemetry||!t.enableTelemetry)}e.$So=A;function D(t,h){return h.extensionTestsLocationURI?!0:!(h.isBuilt||h.disableTelemetry||t.enableTelemetry&&t.aiConfig?.ariaKey)}e.$To=D;function w(t){const h=t.getValue(R.$Cl),s=t.getValue(R.$Dl);if(t.getValue(R.$El)===!1||s===!1)return 0;switch(h??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.$Uo=w;function E(t){const h={},s={},d={};g(t,d);for(let u in d){u=u.length>150?u.substr(u.length-149):u;const l=d[u];typeof l=="number"?s[u]=l:typeof l=="boolean"?s[u]=l?1:0:typeof l=="string"?(l.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${l.length}`),h[u]=l.substring(0,8191)):typeof l<"u"&&l!==null&&(h[u]=l)}return{properties:h,measurements:s}}e.$Vo=E;const S=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(t){if(!t)return"none";const h=(0,f.$bl)(t);return S.has(h)?h:"other"}e.$Wo=c;function g(t,h,s=0,d){if(t)for(const u of Object.getOwnPropertyNames(t)){const l=t[u],p=d?d+u:u;Array.isArray(l)?h[p]=(0,C.$An)(l):l instanceof Date?h[p]=l.toISOString():(0,N.$Kf)(l)?s<2?g(l,h,s+1,p+"."):h[p]=(0,C.$An)(l):h[p]=l}}function o(t,h){const s=t.msftInternalDomains||[],d=h.getValue("telemetry.internalTesting");return(0,P.$Ko)(s)||d}e.$Xo=o;function i(t){return[t.appRoot,t.extensionsPath,t.userHome.fsPath,t.tmpDir.fsPath,t.userDataPath]}e.$Yo=i;function r(t,h){if(!t||!t.includes("/")&&!t.includes("\\"))return t;let s=t;const d=[];for(const I of h)for(;;){const b=I.exec(t);if(!b)break;d.push([b.index,I.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let p=0;for(s="";;){const I=l.exec(t);if(!I)break;const b=d.some(([m,y])=>I.index<y&&m<l.lastIndex);!u.test(I[0])&&!b&&(s+=t.substring(p,I.index)+"<REDACTED: user-file-path>",p=l.lastIndex)}return p<t.length&&(s+=t.substr(p)),s}function n(t){if(!t)return t;const h=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const s of h)if(s.regex.test(t))return`<REDACTED: ${s.label}>`;return t}function a(t,h){return(0,C.$xn)(t,s=>{if(s instanceof v||Object.hasOwnProperty.call(s,"isTrustedTelemetryValue"))return s.value;if(typeof s=="string"){let d=s.replaceAll("%20"," ");d=r(d,h);for(const u of h)d=d.replace(u,"");return d=n(d),d}})}e.$Zo=a}),define(ke[261],Se([1,0,12,134,25,10,2,14,49,88]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_o=e.$$o=e.$0o=e.$9o=e.$8o=e.$7o=e.$6o=e.$5o=e.$4o=e.$3o=e.$2o=e.$1o=void 0;function A(s,d){return s.uuid&&d.uuid?s.uuid===d.uuid:s.id===d.id?!0:(0,C.$7e)(s.id,d.id)===0}e.$1o=A;const D=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{static create(d){const u=d.manifest?d.manifest.version:d.version,l=d.manifest?d.targetPlatform:d.properties.targetPlatform;return new w(d.identifier,u,l)}static parse(d){const u=D.exec(d);return u&&u[1]&&u[2]?new w({id:u[1]},u[2],u[4]||void 0):null}constructor(d,u,l="undefined"){this.version=u,this.targetPlatform=l,this.id=d.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(d){return d instanceof w?A(this,d)&&this.version===d.version&&this.targetPlatform===d.targetPlatform:!1}}e.$2o=w;const E=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function S(s){const d=E.exec(s);return d&&d[1]?[g(d[1]),d[2]]:[g(s),void 0]}e.$3o=S;function c(s,d){return`${s}.${d}`}e.$4o=c;function g(s){return s.toLowerCase()}e.$5o=g;function o(s,d){return g(c(s??f.$hm,d))}e.$6o=o;function i(s,d){const u=[],l=p=>{for(const I of u)if(I.some(b=>A(d(b),d(p))))return I;return null};for(const p of s){const I=l(p);I?I.push(p):u.push([p])}return u}e.$7o=i;function r(s){return{id:s.identifier.id,name:s.manifest.name,galleryId:null,publisherId:s.publisherId,publisherName:s.manifest.publisher,publisherDisplayName:s.publisherDisplayName,dependencies:s.manifest.extensionDependencies&&s.manifest.extensionDependencies.length>0}}e.$8o=r;function n(s){return{id:new k.$Lo(s.identifier.id),name:new k.$Lo(s.name),galleryId:s.identifier.uuid,publisherId:s.publisherId,publisherName:s.publisher,publisherDisplayName:s.publisherDisplayName,isPreReleaseVersion:s.properties.isPreReleaseVersion,dependencies:!!(s.properties.dependencies&&s.properties.dependencies.length>0),isSigned:s.isSigned,...s.telemetryData}}e.$9o=n,e.$0o=new f.$lm("pprice.better-merge");function a(s,d){const u=[],l=d.manifest.extensionDependencies?.slice(0)??[];for(;l.length;){const p=l.shift();if(p&&u.every(I=>!A(I.identifier,{id:p}))){const I=s.filter(b=>A(b.identifier,{id:p}));I.length===1&&(u.push(I[0]),l.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return u}e.$$o=a;async function t(s,d){if(!P.$k)return!1;let u;try{u=(await s.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{u=(await s.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(p){d.debug("Error while getting the os-release file.",(0,v.$0)(p))}}return!!u&&(u.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function h(s,d){const u=await t(s,d),l=(0,N.$uo)(u?"alpine":P.$u,$.$ec);return d.debug("ComputeTargetPlatform:",l),l}e.$_o=h}),define(ke[262],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rr=e.$Qr=e.$Pr=e.$Or=e.$Nr=e.$Mr=void 0;function C($){return[...$.entries()]}e.$Mr=C;function N($){return $?[...$.entries()]:[]}e.$Nr=N;function f($){return new Map($)}e.$Or=f;function P($){return new Map($??[])}e.$Pr=P;function R($){return Array.from($.entries()).map(k=>[k[0],C(k[1].map),N(k[1].descriptionMap)])}e.$Qr=R;function v($){return new Map($.map(k=>[k[0],{map:f(k[1]),descriptionMap:P(k[2])}]))}e.$Rr=v}),define(ke[263],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nsb=void 0;class C{constructor(f){this.b=f,this.a=new Map}dispose(){for(const f of this.a.values())f.dispose()}startBuffering(f,P,R=5){const v=P($=>{const k=typeof $=="string"?$:$.data;let A=this.a.get(f);if(A){A.data.push(k);return}const D=setTimeout(()=>this.flushBuffer(f),R);A={data:[k],timeoutId:D,dispose:()=>{clearTimeout(D),this.flushBuffer(f),v.dispose()}},this.a.set(f,A)});return v}stopBuffering(f){this.a.get(f)?.dispose()}flushBuffer(f){const P=this.a.get(f);P&&(this.a.delete(f),this.b(f,P.data.join("")))}}e.$nsb=C}),define(ke[264],Se([1,0,11,78,55,4,18,2,207,108,37]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ew=e.$Dw=e.$Cw=e.$Bw=e.$Aw=e.$zw=e.$yw=e.$xw=e.IconFontDefinition=e.IconContribution=e.$ww=void 0,e.$ww={IconContribution:"base.contributions.icons"};var D;(function(n){function a(t,h){let s=t.defaults;for(;f.ThemeIcon.isThemeIcon(s);){const d=S.getIcon(s.id);if(!d)return;s=d.defaults}return s}n.getDefinition=a})(D||(e.IconContribution=D={}));var w;(function(n){function a(h){return{weight:h.weight,style:h.style,src:h.src.map(s=>({format:s.format,location:s.location.toString()}))}}n.toJSONObject=a;function t(h){const s=d=>(0,R.$If)(d)?d:void 0;if(h&&Array.isArray(h.src)&&h.src.every(d=>(0,R.$If)(d.format)&&(0,R.$If)(d.location)))return{weight:s(h.weight),style:s(h.style),src:h.src.map(d=>({format:d.format,location:v.URI.parse(d.location)}))}}n.fromJSONObject=t})(w||(e.IconFontDefinition=w={}));class E{constructor(){this.a=new P.$Vd,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,$.localize)(0,null)},fontCharacter:{type:"string",description:(0,$.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${f.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(a,t,h,s){const d=this.b[a];if(d){if(h&&!d.description){d.description=h,this.d.properties[a].markdownDescription=`${h} $(${a})`;const p=this.e.enum.indexOf(a);p!==-1&&(this.e.enumDescriptions[p]=h),this.a.fire()}return d}const u={id:a,description:h,defaults:t,deprecationMessage:s};this.b[a]=u;const l={$ref:"#/definitions/icons"};return s&&(l.deprecationMessage=s),h&&(l.markdownDescription=`${h}: $(${a})`),this.d.properties[a]=l,this.e.enum.push(a),this.e.enumDescriptions.push(h||""),this.a.fire(),{id:a}}deregisterIcon(a){delete this.b[a],delete this.d.properties[a];const t=this.e.enum.indexOf(a);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(a=>this.b[a])}getIcon(a){return this.b[a]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(a,t){const h=this.f[a];return h||(this.f[a]=t,this.a.fire(),t)}deregisterIconFont(a){delete this.f[a]}getIconFont(a){return this.f[a]}toString(){const a=(d,u)=>d.id.localeCompare(u.id),t=d=>{for(;f.ThemeIcon.isThemeIcon(d.defaults);)d=this.b[d.defaults.id];return`codicon codicon-${d?d.id:""}`},h=[];h.push("| preview     | identifier                        | default codicon ID                | description"),h.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const s=Object.keys(this.b).map(d=>this.b[d]);for(const d of s.filter(u=>!!u.description).sort(a))h.push(`|<i class="${t(d)}"></i>|${d.id}|${f.ThemeIcon.isThemeIcon(d.defaults)?d.defaults.id:d.id}|${d.description||""}|`);h.push("| preview     | identifier                        "),h.push("| ----------- | --------------------------------- |");for(const d of s.filter(u=>!f.ThemeIcon.isThemeIcon(u.defaults)).sort(a))h.push(`|<i class="${t(d)}"></i>|${d.id}|`);return h.join(`
`)}}const S=new E;A.$Hn.add(e.$ww.IconContribution,S);function c(n,a,t,h){return S.registerIcon(n,a,t,h)}e.$xw=c;function g(){return S}e.$yw=g;function o(){const n=(0,N.$0j)();for(const a in n){const t="\\"+n[a].toString(16);S.registerIcon(a,{fontCharacter:t})}}o(),e.$zw="vscode://schemas/icons";const i=A.$Hn.as(k.$In.JSONContribution);i.registerSchema(e.$zw,S.getIconSchema());const r=new C.$fh(()=>i.notifySchemaChanged(e.$zw),200);S.onDidChange(()=>{r.isScheduled()||r.schedule()}),e.$Aw=c("widget-close",N.$_j.close,(0,$.localize)(2,null)),e.$Bw=c("goto-previous-location",N.$_j.arrowUp,(0,$.localize)(3,null)),e.$Cw=c("goto-next-location",N.$_j.arrowDown,(0,$.localize)(4,null)),e.$Dw=f.ThemeIcon.modify(N.$_j.sync,"spin"),e.$Ew=f.ThemeIcon.modify(N.$_j.loading,"spin")}),define(ke[89],Se([1,0,4,51,5,13]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kv=e.$Jv=e.$Iv=e.$Hv=e.$Gv=e.$Fv=e.$Ev=e.$Dv=e.ProvidedOnAutoForward=e.$Cv=e.TunnelPrivacyId=e.TunnelProtocol=e.$Bv=e.$Av=void 0,e.$Av=(0,f.$6h)("tunnelService"),e.$Bv=(0,f.$6h)("sharedTunnelsService");var R;(function(g){g.Http="http",g.Https="https"})(R||(e.TunnelProtocol=R={}));var v;(function(g){g.ConstantPrivate="constantPrivate",g.Private="private",g.Public="public"})(v||(e.TunnelPrivacyId=v={}));function $(g){return!!g.forwardPort}e.$Cv=$;var k;(function(g){g[g.Notify=1]="Notify",g[g.OpenBrowser=2]="OpenBrowser",g[g.OpenPreview=3]="OpenPreview",g[g.Silent=4]="Silent",g[g.Ignore=5]="Ignore",g[g.OpenBrowserOnce=6]="OpenBrowserOnce"})(k||(e.ProvidedOnAutoForward=k={}));function A(g){if(g.scheme!=="http"&&g.scheme!=="https")return;const o=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(g.authority);if(o)return{address:o[1],port:+o[2]}}e.$Dv=A,e.$Ev=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function D(g){return e.$Ev.indexOf(g)>=0}e.$Fv=D,e.$Gv=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(g){return e.$Gv.indexOf(g)>=0}e.$Hv=w;function E(g,o,i,r){if(i===1)return!1;if(i===2&&w(o)){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(r);if(n?.length===4&&parseInt(n[1])>=18)return!1}return g<1024}e.$Iv=E;class S{constructor(o,i,r){this.remoteAddress=o,this.localAddress=i,this.b=r,this.a=new C.$Vd,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$Jv=S;let c=class{constructor(o,i){this.k=o,this.l=i,this.a=new C.$Vd,this.onTunnelOpened=this.a.event,this.b=new C.$Vd,this.onTunnelClosed=this.b.event,this.c=new C.$Vd,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const o=this.l.getValue("remote.localPortHost");return!o||o==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(o){return this.f=o,o?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(o){this.g=o.elevation,this.i=o.privacyOptions,this.h=o.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const o=[],i=Array.from(this.e.values());for(const r of i){const n=Array.from(r.values());for(const a of n){const t=await a.value;t&&typeof t!="string"&&o.push(t)}}return o}async dispose(){for(const o of this.e.values()){for(const{value:i}of o.values())await i.then(r=>typeof r!="string"?r?.dispose():void 0);o.clear()}this.e.clear()}setEnvironmentTunnel(o,i,r,n,a){this.q(o,i,Promise.resolve({tunnelRemoteHost:o,tunnelRemotePort:i,localAddress:r,privacy:n,protocol:a,dispose:()=>Promise.resolve()}))}async getExistingTunnel(o,i){(w(o)||D(o))&&(o=e.$Ev[0]);const r=this.s(o,i);if(r)return++r.refcount,r.value}openTunnel(o,i,r,n,a,t=!1,h,s){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${i}:${r} on local port ${a}.`);const d=this.f??o;if(!d)return;if(i||(i="localhost"),n||(n=this.m),this.f&&this.j.has(r)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.t(d,i,r,n,a,t,h,s);return u?u.then(l=>{if(l){if(typeof l=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(i,r),l}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(i,r);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const p=this.o(l);return(l.tunnelRemoteHost!==i||l.tunnelRemotePort!==r)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),h&&l.privacy!==h&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(p),p}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}o(o){return{tunnelRemotePort:o.tunnelRemotePort,tunnelRemoteHost:o.tunnelRemoteHost,tunnelLocalPort:o.tunnelLocalPort,localAddress:o.localAddress,privacy:o.privacy,protocol:o.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${o.tunnelRemoteHost}:${o.tunnelRemotePort} `);const i=this.e.get(o.tunnelRemoteHost);if(i){const r=i.get(o.tunnelRemotePort);r&&(r.refcount--,await this.p(o.tunnelRemoteHost,o.tunnelRemotePort,r))}}}}async p(o,i,r){if(r.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${o}:${i}.`);const n=r.value.then(async a=>{a&&typeof a!="string"&&(await a.dispose(!0),this.b.fire({host:a.tunnelRemoteHost,port:a.tunnelRemotePort}))});return this.e.has(o)&&this.e.get(o).delete(i),n}}async closeTunnel(o,i){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${o}:${i} `);const r=this.e.get(o);if(r&&r.has(i)){const n=r.get(i);n.refcount=0,await this.p(o,i,n)}}q(o,i,r){this.e.has(o)||this.e.set(o,new Map),this.e.get(o).set(i,{refcount:1,value:r})}async r(o,i){const r=this.e.get(o);if(r){const n=r.get(i),a=n?await n.value:void 0;(!a||typeof a=="string")&&r.delete(i),r.size===0&&this.e.delete(o)}}s(o,i){const r=[o];D(o)?(r.push(...e.$Ev),r.push(...e.$Gv)):w(o)&&r.push(...e.$Gv);const n=r.map(a=>this.e.get(a));for(const a of n){const t=a?.get(i);if(t)return t}}canTunnel(o){return!!A(o)}u(o,i,r,n,a,t,h){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${i}:${r} on local port ${n}.`);const s=r;this.j.add(s);const d=n===void 0?r:n,u={elevationRequired:a?this.isPortPrivileged(d):!1},l={remoteAddress:{host:i,port:r},localAddressPort:n,privacy:t,public:t?t!==v.Private:void 0,protocol:h},p=o.forwardPort(l,u);return p?(this.q(i,r,p),p.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(s)})):this.j.delete(s),p}};e.$Kv=c,e.$Kv=c=Ge([We(0,P.$nj),We(1,N.$zi)],c)}),define(ke[265],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1k=void 0,e.$1k=(0,C.$6h)("IUriIdentityService")}),define(ke[266],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$Lv=void 0,e.$Lv=(0,C.$6h)("editSessionIdentityService");var N;(function(f){f[f.Complete=100]="Complete",f[f.Partial=50]="Partial",f[f.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(ke[267],Se([1,0,16]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NK=e.$MK=e.$LK=e.$KK=e.$JK=void 0;function N($){return $.scheme!==C.Schemas.file&&$.scheme!==C.Schemas.vscodeRemote}e.$JK=N;function f($){if($.folders.length)return $.folders.every(k=>N(k.uri))?$.folders[0].uri:void 0;if($.configuration&&N($.configuration))return $.configuration}e.$KK=f;function P($){return f($)?.scheme}e.$LK=P;function R($){return f($)?.authority}e.$MK=R;function v($){return f($)!==void 0}e.$NK=v}),define(ke[40],Se([1,0,209,17,77,23,2,5,16]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yi=e.$xi=e.$wi=e.$vi=e.$ui=e.$ti=e.$si=e.$ri=e.$qi=e.$pi=e.$oi=e.$ni=e.$mi=e.$li=e.$ki=e.WorkbenchState=e.$ji=e.$ii=e.$hi=e.$gi=e.$fi=e.$ei=e.$di=e.$ci=void 0,e.$ci=(0,v.$6h)("contextService");function k(d){const u=d;return typeof u?.id=="string"&&R.URI.isUri(u.uri)}e.$di=k;function A(d){return typeof d?.id=="string"&&!k(d)&&!w(d)}e.$ei=A,e.$fi={id:"ext-dev"},e.$gi={id:"empty-window"};function D(d,u){if(typeof d=="string"||typeof d>"u")return typeof d=="string"?{id:(0,N.$nc)(d)}:u?e.$fi:e.$gi;const l=d;return l.configuration?{id:l.id,configPath:l.configuration}:l.folders.length===1?{id:l.id,uri:l.folders[0].uri}:{id:l.id}}e.$hi=D;function w(d){const u=d;return typeof u?.id=="string"&&R.URI.isUri(u.configPath)}e.$ii=w;function E(d){const u=d;if(u?.uri)return{id:u.id,uri:R.URI.revive(u.uri)};const l=d;if(l?.configPath)return{id:l.id,configPath:R.URI.revive(l.configPath)};if(d?.id)return{id:d.id}}e.$ji=E;var S;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(S||(e.WorkbenchState=S={}));function c(d){const u=d;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&Array.isArray(u.folders))}e.$ki=c;function g(d){const u=d;return!!(u&&typeof u=="object"&&R.URI.isUri(u.uri)&&typeof u.name=="string"&&typeof u.toResource=="function")}e.$li=g;class o{constructor(u,l,p,I,b){this.h=u,this.j=p,this.l=I,this.n=b,this.c=f.$_h.forUris(this.n,()=>!0),this.folders=l}update(u){this.h=u.id,this.l=u.configuration,this.j=u.transient,this.n=u.n,this.folders=u.folders}get folders(){return this.g}set folders(u){this.g=u,this.o()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.l}set configuration(u){this.l=u}getFolder(u){return u&&this.c.findSubstr(u)||null}o(){this.c=f.$_h.forUris(this.n,()=>!0);for(const u of this.folders)this.c.set(u.uri,u)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$mi=o;class i{constructor(u,l){this.raw=l,this.uri=u.uri,this.index=u.index,this.name=u.name}toResource(u){return(0,P.$Hg)(this.uri,u)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$ni=i;function r(d){return new i({uri:d,index:0,name:(0,P.$Dg)(d)},{uri:d.toString()})}e.$oi=r,e.$pi="code-workspace",e.$qi=`.${e.$pi}`,e.$ri=[{name:(0,C.localize)(0,null),extensions:[e.$pi]}],e.$si="workspace.json";function n(d,u){return P.$yg.isEqualOrParent(d,u.untitledWorkspacesHome)}e.$ti=n;function a(d){let u;return R.URI.isUri(d)?u=d:u=d.configuration,u?.scheme===$.Schemas.tmp}e.$ui=a,e.$vi="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(d){return d.id===e.$vi}e.$wi=t;function h(d,u){return!n(d,u)&&!a(d)}e.$xi=h;function s(d){return(typeof d=="string"?(0,N.$oc)(d):(0,P.$Fg)(d))===e.$qi}e.$yi=s}),define(ke[268],Se([1,0,54,4,3,23,2,208,133,32,5,13,40,28,265,11,30,12,18]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7k=e.$6k=e.$5k=e.$4k=e.$3k=e.$2k=e.ProfileResourceType=void 0;var r;(function(d){d.Settings="settings",d.Keybindings="keybindings",d.Snippets="snippets",d.Tasks="tasks",d.Extensions="extensions",d.GlobalState="globalState"})(r||(e.ProfileResourceType=r={}));function n(d){const u=d;return!!(u&&typeof u=="object"&&typeof u.id=="string"&&typeof u.isDefault=="boolean"&&typeof u.name=="string"&&R.URI.isUri(u.location)&&R.URI.isUri(u.globalStorageHome)&&R.URI.isUri(u.settingsResource)&&R.URI.isUri(u.keybindingsResource)&&R.URI.isUri(u.tasksResource)&&R.URI.isUri(u.snippetsHome)&&R.URI.isUri(u.extensionsResource))}e.$2k=n,e.$3k=(0,A.$6h)("IUserDataProfilesService");function a(d,u){return{id:d.id,isDefault:d.isDefault,name:d.name,shortName:d.shortName,icon:d.icon,location:R.URI.revive(d.location).with({scheme:u}),globalStorageHome:R.URI.revive(d.globalStorageHome).with({scheme:u}),settingsResource:R.URI.revive(d.settingsResource).with({scheme:u}),keybindingsResource:R.URI.revive(d.keybindingsResource).with({scheme:u}),tasksResource:R.URI.revive(d.tasksResource).with({scheme:u}),snippetsHome:R.URI.revive(d.snippetsHome).with({scheme:u}),extensionsResource:R.URI.revive(d.extensionsResource).with({scheme:u}),cacheHome:R.URI.revive(d.cacheHome).with({scheme:u}),useDefaultFlags:d.useDefaultFlags,isTransient:d.isTransient}}e.$4k=a;function t(d,u,l,p,I,b){return{id:d,name:u,location:l,isDefault:!1,shortName:I?.shortName,icon:I?.icon,globalStorageHome:b&&I?.useDefaultFlags?.globalState?b.globalStorageHome:(0,P.$Hg)(l,"globalStorage"),settingsResource:b&&I?.useDefaultFlags?.settings?b.settingsResource:(0,P.$Hg)(l,"settings.json"),keybindingsResource:b&&I?.useDefaultFlags?.keybindings?b.keybindingsResource:(0,P.$Hg)(l,"keybindings.json"),tasksResource:b&&I?.useDefaultFlags?.tasks?b.tasksResource:(0,P.$Hg)(l,"tasks.json"),snippetsHome:b&&I?.useDefaultFlags?.snippets?b.snippetsHome:(0,P.$Hg)(l,"snippets"),extensionsResource:b&&I?.useDefaultFlags?.extensions?b.extensionsResource:(0,P.$Hg)(l,"extensions.json"),cacheHome:(0,P.$Hg)(p,d),useDefaultFlags:I?.useDefaultFlags,isTransient:I?.transient}}e.$5k=t;let h=class extends f.$Tc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(u,l,p,I){super(),this.t=u,this.u=l,this.w=p,this.y=I,this.f=!0,this.h=this.B(new N.$Vd),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$Vd),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$Vd),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$Vd),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new E.$Ac,emptyWindows:new Map},this.profilesHome=(0,P.$Hg)(this.t.userRoamingDataHome,"profiles"),this.g=(0,P.$Hg)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(u){this.f!==u&&(this.z=void 0,this.f=u)}isEnabled(){return this.f}get C(){if(!this.z){const u=this.D(),l=[u];if(this.f)try{for(const b of this.O()){if(!b.name||!(0,i.$If)(b.name)||!b.location){this.y.warn("Skipping the invalid stored profile",b.location||b.name);continue}l.push(t((0,P.$Eg)(b.location),b.name,b.location,this.g,{shortName:b.shortName,icon:b.icon,useDefaultFlags:b.useDefaultFlags},u))}}catch(b){this.y.error(b)}const p=new E.$Ac,I=new Map;if(l.length)try{const b=this.Q();if(b.workspaces)for(const[m,y]of Object.entries(b.workspaces)){const L=R.URI.parse(m),F=l.find(z=>z.id===y);F&&p.set(L,F)}if(b.emptyWindows)for(const[m,y]of Object.entries(b.emptyWindows)){const L=l.find(F=>F.id===y);L&&I.set(m,L)}}catch(b){this.y.error(b)}this.z={profiles:l,workspaces:p,emptyWindows:I}}return this.z}D(){const u=t("__default__profile__",(0,v.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...u,extensionsResource:this.S()??u.extensionsResource,isDefault:!0}}async createTransientProfile(u){const l="Temp",p=new RegExp(`${(0,o.$Oe)(l)}\\s(\\d+)`);let I=0;for(const m of this.profiles){const y=p.exec(m.name),L=y?parseInt(y[1]):0;I=L>I?L:I}const b=`${l} ${I+1}`;return this.createProfile((0,C.$Ti)((0,g.$qg)()).toString(16),b,{transient:!0},u)}async createNamedProfile(u,l,p){return this.createProfile((0,C.$Ti)((0,g.$qg)()).toString(16),u,l,p)}async createProfile(u,l,p,I){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const b=await this.F(u,l,p);return I&&await this.setProfileForWorkspace(I,b),b}async F(u,l,p){if(!(0,i.$If)(l)||!l)throw new Error("Name of the profile is mandatory and must be of type `string`");let I=this.r.get(l);return I||(I=(async()=>{try{const b=this.profiles.find(L=>L.name===l||L.id===u);if(b)return b;const m=t(u,l,(0,P.$Hg)(this.profilesHome,u),this.g,p,this.defaultProfile);await this.u.createFolder(m.location);const y=[];return this.j.fire({profile:m,join(L){y.push(L)}}),await c.Promises.settled(y),this.I([m],[],[]),m}finally{this.r.delete(l)}})(),this.r.set(l,I)),I}async updateProfile(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let p=this.profiles.find(I=>I.id===u.id);if(!p)throw new Error(`Profile '${u.name}' does not exist`);return p=t(p.id,l.name??p.name,p.location,this.g,{shortName:l.shortName??p.shortName,icon:l.icon===null?void 0:l.icon??p.icon,transient:l.transient??p.isTransient,useDefaultFlags:l.useDefaultFlags??p.useDefaultFlags},this.defaultProfile),this.I([],[],[p]),p}async removeProfile(u){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(u.isDefault)throw new Error("Cannot remove default profile");const l=this.profiles.find(I=>I.id===u.id);if(!l)throw new Error(`Profile '${u.name}' does not exist`);const p=[];this.m.fire({profile:l,join(I){p.push(I)}});try{await Promise.allSettled(p)}catch(I){this.y.error(I)}for(const I of[...this.C.emptyWindows.keys()])l.id===this.C.emptyWindows.get(I)?.id&&this.C.emptyWindows.delete(I);for(const I of[...this.C.workspaces.keys()])l.id===this.C.workspaces.get(I)?.id&&this.C.workspaces.delete(I);this.M(),this.I([],[l],[]);try{await this.u.del(l.cacheHome,{recursive:!0})}catch(I){(0,k.$Hk)(I)!==1&&this.y.error(I)}}async setProfileForWorkspace(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const p=this.profiles.find(I=>I.id===l.id);if(!p)throw new Error(`Profile '${l.name}' does not exist`);this.L(u,p)}unsetWorkspace(u,l){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(u,void 0,l)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const u=await this.u.resolve(this.profilesHome);await Promise.all((u.children||[]).filter(l=>l.isDirectory&&this.profiles.every(p=>!this.w.extUri.isEqual(p.location,l.resource))).map(l=>this.u.del(l.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const u=this.s.profiles.filter(l=>!this.H(l));await Promise.allSettled(u.map(l=>this.removeProfile(l)))}getProfileForWorkspace(u){const l=this.G(u);return R.URI.isUri(l)?this.s.workspaces.get(l)??this.C.workspaces.get(l):this.s.emptyWindows.get(l)??this.C.emptyWindows.get(l)}G(u){return(0,w.$di)(u)?u.uri:(0,w.$ii)(u)?u.configPath:u.id}H(u){return!!([...this.s.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.s.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.C.emptyWindows.values()].some(l=>this.w.extUri.isEqual(l.location,u.location))||[...this.C.workspaces.values()].some(l=>this.w.extUri.isEqual(l.location,u.location)))}I(u,l,p){const I=[...this.profiles,...u],b=[];this.s.profiles=[];for(let m of I)m.isDefault||l.some(y=>m.id===y.id)||(m=p.find(y=>m.id===y.id)??m,m.isTransient?this.s.profiles.push(m):b.push({location:m.location,name:m.name,shortName:m.shortName,icon:m.icon,useDefaultFlags:m.useDefaultFlags}));this.P(b),this.z=void 0,this.J(u,l,p)}J(u,l,p){this.h.fire({added:u,removed:l,updated:p,all:this.profiles})}L(u,l,p){p=l?.isTransient?!0:p,p||this.L(u,void 0,!0);const I=this.G(u),b=p?this.s:this.C;R.URI.isUri(I)?(b.workspaces.delete(I),l&&b.workspaces.set(I,l)):(b.emptyWindows.delete(I),l&&b.emptyWindows.set(I,l)),p||this.M()}M(){const u={};for(const[p,I]of this.C.workspaces.entries())u[p.toString()]=I.id;const l={};for(const[p,I]of this.C.emptyWindows.entries())l[p.toString()]=I.id;this.R({workspaces:u,emptyWindows:l}),this.z=void 0}N(u){const l={},p=this.D();if(u.workspaces)for(const[b,m]of Object.entries(u.workspaces)){const y=R.URI.parse(m);l[b]=this.w.extUri.isEqual(y,p.location)?p.id:this.w.extUri.basename(y)}const I={};if(u.emptyWindows)for(const[b,m]of Object.entries(u.emptyWindows)){const y=R.URI.parse(m);I[b]=this.w.extUri.isEqual(y,p.location)?p.id:this.w.extUri.basename(y)}return{workspaces:l,emptyWindows:I}}O(){return[]}P(u){throw new Error("not implemented")}Q(){return{}}R(u){throw new Error("not implemented")}S(){}};e.$6k=h,e.$6k=h=Ge([We(0,$.$ai),We(1,k.$qk),We(2,S.$1k),We(3,D.$nj)],h);class s extends h{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(u){this.a=u}Q(){return this.X}R(u){this.X=u}}e.$7k=s}),define(ke[269],Se([1,0,11,4,3,58,18,188,5,268]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zp=e.$yp=e.$xp=e.$wp=e.$vp=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$up=e.$tp=e.$sp=void 0,e.$sp="__$__isNewStorageMarker",e.$tp="__$__targetStorageMarker",e.$up=(0,$.$6h)("storageService");var A;(function(i){i[i.NONE=0]="NONE",i[i.SHUTDOWN=1]="SHUTDOWN"})(A||(e.WillSaveStateReason=A={}));var D;(function(i){i[i.APPLICATION=-1]="APPLICATION",i[i.PROFILE=0]="PROFILE",i[i.WORKSPACE=1]="WORKSPACE"})(D||(e.StorageScope=D={}));var w;(function(i){i[i.USER=0]="USER",i[i.MACHINE=1]="MACHINE"})(w||(e.StorageTarget=w={}));function E(i){const r=i.get(e.$tp);if(r)try{return JSON.parse(r)}catch{}return Object.create(null)}e.$vp=E;class S extends f.$Tc{static{this.a=60*1e3}constructor(r={flushInterval:S.a}){super(),this.m=r,this.b=this.B(new N.$Yd),this.c=this.B(new N.$Yd),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$Vd),this.onWillSaveState=this.f.event,this.h=this.B(new C.$fh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new f.$Uc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(r,n,a){return N.Event.filter(this.b.event,t=>t.scope===r&&(n===void 0||t.key===n),a)}n(){this.j.value=(0,C.$jh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,f.$Oc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,P.mark)("code/willInitStorage");try{await this.O()}finally{(0,P.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(r,n){const{key:a,external:t}=n;if(a===e.$tp){switch(r){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:r})}else this.b.fire({scope:r,key:a,target:this.J(r)[a],external:t})}w(r){this.f.fire({reason:r})}get(r,n,a){return this.P(n)?.get(r,a)}getBoolean(r,n,a){return this.P(n)?.getBoolean(r,a)}getNumber(r,n,a){return this.P(n)?.getNumber(r,a)}getObject(r,n,a){return this.P(n)?.getObject(r,a)}storeAll(r,n){this.y(()=>{for(const a of r)this.store(a.key,a.value,a.scope,a.target,n)})}store(r,n,a,t,h=!1){if((0,R.$Rf)(n)){this.remove(r,a,h);return}this.y(()=>{this.z(r,a,t),this.P(a)?.set(r,n,h)})}remove(r,n,a=!1){this.y(()=>{this.z(r,n,void 0),this.P(n)?.delete(r,a)})}y(r){this.b.pause(),this.c.pause();try{r()}finally{this.b.resume(),this.c.resume()}}keys(r,n){const a=[],t=this.J(r);for(const h of Object.keys(t))t[h]===n&&a.push(h);return a}z(r,n,a,t=!1){const h=this.J(n);typeof a=="number"?h[r]!==a&&(h[r]=a,this.P(n)?.set(e.$tp,JSON.stringify(h),t)):typeof h[r]=="number"&&(delete h[r],this.P(n)?.set(e.$tp,JSON.stringify(h),t))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(r){switch(r){case-1:return this.I;case 0:return this.G;default:return this.D}}L(r){const n=this.P(r);return n?E(n):Object.create(null)}isNew(r){return this.getBoolean(e.$sp,r)===!0}async flush(r=A.NONE){this.f.fire({reason:r});const n=this.P(-1),a=this.P(0),t=this.P(1);switch(r){case A.NONE:await C.Promises.settled([n?.whenFlushed()??Promise.resolve(),a?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case A.SHUTDOWN:await C.Promises.settled([n?.flush(0)??Promise.resolve(),a?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const r=this.P(-1)?.items??new Map,n=this.P(0)?.items??new Map,a=this.P(1)?.items??new Map;return o(r,n,a,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(r){return await this.flush(),this.P(r)?.optimize()}async switch(r,n){return this.w(A.NONE),(0,k.$2k)(r)?this.R(r,n):this.S(r,n)}M(r,n){return!(r.id===n.id||c(n)&&c(r))}N(r,n,a){this.y(()=>{const t=new Set;for(const[h,s]of r)t.add(h),n.get(h)!==s&&this.u(a,{key:h,external:!0});for(const[h]of n.items)t.has(h)||this.u(a,{key:h,external:!0})})}}e.$wp=S;function c(i){return i.isDefault||!!i.useDefaultFlags?.globalState}e.$xp=c;class g extends S{constructor(){super(),this.U=this.B(new v.$qp(new v.$rp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new v.$qp(new v.$rp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new v.$qp(new v.$rp,{hint:v.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(r=>this.u(1,r))),this.B(this.W.onDidChangeStorage(r=>this.u(0,r))),this.B(this.U.onDidChangeStorage(r=>this.u(-1,r)))}P(r){switch(r){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(r){switch(r){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(r){return!1}}e.$yp=g;async function o(i,r,n,a,t,h){const s=L=>{try{return JSON.parse(L)}catch{return L}},d=new Map,u=new Map;i.forEach((L,F)=>{d.set(F,L),u.set(F,s(L))});const l=new Map,p=new Map;r.forEach((L,F)=>{l.set(F,L),p.set(F,s(L))});const I=new Map,b=new Map;n.forEach((L,F)=>{I.set(F,L),b.set(F,s(L))}),console.group(a!==t?`Storage: Application (path: ${a})`:`Storage: Application & Profile (path: ${a}, default profile)`);const m=[];if(d.forEach((L,F)=>{m.push({key:F,value:L})}),console.table(m),console.groupEnd(),console.log(u),a!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const L=[];l.forEach((F,z)=>{L.push({key:z,value:F})}),console.table(L),console.groupEnd(),console.log(p)}console.group(`Storage: Workspace (path: ${h})`);const y=[];I.forEach((L,F)=>{y.push({key:F,value:L})}),console.table(y),console.groupEnd(),console.log(b)}e.$zp=o}),define(ke[110],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Egc=void 0;class C{static{this.a=!1}constructor(f){this.d=f,this.b=new Map,this.c=1}add(f){const P=this.c++;return this.b.set(P,f),this.e(),P}get(f,P){return this.b.has(f)?this.b.get(f)[P]:void 0}delete(f){this.b.delete(f),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$Egc=C}),define(ke[59],Se([1,0,16,23,5]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Igc=e.$Hgc=void 0;class P{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new N.$wg(v=>{const $=this.b.get(v.scheme);return!($===void 0||$&1024)})}$acceptProviderInfos(v,$){$===null?this.b.delete(v.scheme):this.b.set(v.scheme,$)}isFreeScheme(v){return!this.b.has(v)&&!this.a.has(v)}getCapabilities(v){return this.b.get(v)}}e.$Hgc=P,e.$Igc=(0,f.$6h)("IExtHostFileSystemInfo")}),define(ke[27],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vN=void 0,e.$vN=(0,C.$6h)("IExtHostInitDataService")}),define(ke[270],Se([1,0,214,13,250,27]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Oic=void 0;let R=class extends f.$CO{constructor($,k,A){const D=A.remote.isRemote?"remoteexthost":$?"workerexthost":"exthost",w=A.remote.isRemote?(0,C.localize)(0,null):$?(0,C.localize)(1,null):(0,C.localize)(2,null);super(k.createLogger(D,{name:w}))}};e.$Oic=R,e.$Oic=R=Ge([We(1,N.$oj),We(2,P.$vN)],R)}),define(ke[271],Se([1,0,11]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rhc=e.$qhc=void 0;class N{constructor(R,v,$){this.h=new Map,this.a=R,this.b=v,this.c=$,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(k=>(this.f=k,this)),this.g=this.c.onDidChangeStorage(k=>{k.shared===this.b&&k.key===this.a&&(this.f=k.value)}),this.i=new C.$fh(()=>{const k=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const A of k.values())A.complete()}catch(A){for(const D of k.values())D.error(A)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,v){let $=this.f[R];return typeof $>"u"&&($=v),$}update(R,v){this.f[R]=v;const $=this.h.get(R);if($!==void 0)return $.p;const k=new C.$qh;return this.h.set(R,k),this.i.isScheduled()||this.i.schedule(),k.p}dispose(){this.g.dispose()}}e.$qhc=N;class f extends N{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,v){super(R.identifier.value,!0,v),this.j=R}}e.$rhc=f}),define(ke[272],Se([1,0,4,2]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eic=void 0;class f{constructor(R){this.c=R,this.a=new C.$Vd,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$Vd,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,v,$,k){const D=this.c.getNotebookDocument(N.URI.revive(R)).acceptModelChanged(v.value,$,k);this.b.fire(D)}$acceptDirtyStateChanged(R,v){this.c.getNotebookDocument(N.URI.revive(R)).acceptDirty(v)}$acceptModelSaved(R){const v=this.c.getNotebookDocument(N.URI.revive(R));this.a.fire(v.apiNotebook)}}e.$eic=f}),define(ke[20],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gN=e.$fN=void 0,e.$fN=(0,C.$6h)("IExtHostRpcService");class N{constructor(P){this.getProxy=P.getProxy.bind(P),this.set=P.set.bind(P),this.dispose=P.dispose.bind(P),this.assertRegistered=P.assertRegistered.bind(P),this.drain=P.drain.bind(P)}}e.$gN=N}),define(ke[273],Se([1,0,25,4]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yhc=void 0;class f{#e;constructor(R,v){this.b=new N.$Vd,this.onDidChange=this.b.event,this.a=C.$lm.toKey(R.identifier),this.#e=v,this.#e.onDidChangePassword($=>{$.extensionId===this.a&&this.b.fire({key:$.key})})}get(R){return this.#e.get(this.a,R)}store(R,v){return this.#e.store(this.a,R,v)}delete(R){return this.#e.delete(this.a,R)}}e.$yhc=f}),define(ke[66],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2gc=e.$1gc=void 0,e.$1gc=(0,C.$6h)("IURITransformerService");class N{constructor(P){P?(this.transformIncoming=P.transformIncoming.bind(P),this.transformOutgoing=P.transformOutgoing.bind(P),this.transformOutgoingURI=P.transformOutgoingURI.bind(P),this.transformOutgoingScheme=P.transformOutgoingScheme.bind(P)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.$2gc=N}),define(ke[274],Se([1,0,22]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ulb=e.$tlb=void 0;class N{constructor(){this.buffers=[]}add($){let k=this.buffers.indexOf($);return k<0&&(k=this.buffers.length,this.buffers.push($)),k}}function f(v,$){if($.serializeBuffersForPostMessage){const k=new N,D=JSON.stringify(v,(E,S)=>{if(S instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:k.add(S)};if(ArrayBuffer.isView(S)){const c=P(S);if(c)return{$$vscode_array_buffer_reference$$:!0,index:k.add(S.buffer),view:{type:c,byteLength:S.byteLength,byteOffset:S.byteOffset}}}return S}),w=k.buffers.map(E=>{const S=new Uint8Array(E);return C.$je.wrap(S)});return{message:D,buffers:w}}else return{message:JSON.stringify(v),buffers:[]}}e.$tlb=f;function P(v){switch(v.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(v,$){const k=$.map(w=>{const E=new ArrayBuffer(w.byteLength);return new Uint8Array(E).set(w.buffer),E}),A=$.length?(w,E)=>{if(E&&typeof E=="object"&&E.$$vscode_array_buffer_reference$$){const S=E,{index:c}=S,g=k[c];if(S.view)switch(S.view.type){case 1:return new Int8Array(g,S.view.byteOffset,S.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(g,S.view.byteOffset,S.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(g,S.view.byteOffset,S.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(g,S.view.byteOffset,S.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(g,S.view.byteOffset,S.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(g,S.view.byteOffset,S.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(g,S.view.byteOffset,S.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(g,S.view.byteOffset,S.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(g,S.view.byteOffset,S.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(g,S.view.byteOffset,S.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(g,S.view.byteOffset,S.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return g}return E}:void 0;return{message:JSON.parse(v,A),arrayBuffers:k}}e.$ulb=R}),define(ke[275],Se([1,0,276,389,390,62,2,13,391]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kjc=void 0;const k=!1;function A(r,n,a,t,h,s){const d=s.environment.useHostProxy,u=typeof d=="boolean"?d:!s.remote.isRemote,l={resolveProxy:b=>r.resolveProxy(b),lookupProxyAuthorization:g.bind(void 0,t,h,n,{},s.remote.isRemote),getProxyURL:()=>n.getConfiguration("http").get("proxy"),getProxySupport:()=>n.getConfiguration("http").get("proxySupport")||"off",addCertificatesV1:()=>w(n),addCertificatesV2:()=>E(n),log:t,getLogLevel:()=>{const b=t.getLevel();switch(b){case v.LogLevel.Trace:return $.LogLevel.Trace;case v.LogLevel.Debug:return $.LogLevel.Debug;case v.LogLevel.Info:return $.LogLevel.Info;case v.LogLevel.Warning:return $.LogLevel.Warning;case v.LogLevel.Error:return $.LogLevel.Error;case v.LogLevel.Off:return $.LogLevel.Off;default:return m(b)}function m(y){return t.error("Unknown log level",y),$.LogLevel.Debug}},proxyResolveTelemetry:()=>{},useHostProxy:u,loadAdditionalCertificates:async()=>{const b=[];if(s.remote.isRemote&&b.push((0,$.loadSystemCertificates)({log:t})),u){t.trace("ProxyResolver#loadAdditionalCertificates: Loading certificates from main process");const m=r.loadCertificates();m.then(y=>t.trace("ProxyResolver#loadAdditionalCertificates: Loaded certificates from main process",y.length)),b.push(m)}return(await Promise.all(b)).flat()},env:process.env},p=(0,$.createProxyResolver)(l),I=D(l,p);return c(a,I)}e.$kjc=A;function D(r,n){return{http:Object.assign(C,(0,$.createHttpPatch)(r,C,n)),https:Object.assign(N,(0,$.createHttpPatch)(r,N,n)),net:Object.assign(P,(0,$.createNetPatch)(r,P)),tls:Object.assign(f,(0,$.createTlsPatch)(r,f))}}function w(r){const n=r.getConfiguration("http");return!n.get("experimental.systemCertificatesV2",k)&&!!n.get("systemCertificates")}function E(r){const n=r.getConfiguration("http");return!!n.get("experimental.systemCertificatesV2",k)&&!!n.get("systemCertificates")}const S=new Map;function c(r,n){return r.getExtensionPathIndex().then(a=>{const t=globalThis._VSCODE_NODE_MODULES.module,h=t._load;t._load=function(d,u,l){if(d==="net")return n.net;if(d==="tls")return n.tls;if(d!=="http"&&d!=="https")return h.apply(this,arguments);const p=a.findSubstr(R.URI.file(u.filename));let I=S.get(p);if(I||S.set(p,I={}),!I[d]){const b=n[d];I[d]={...b}}return I[d]}})}async function g(r,n,a,t,h,s,d,u){const l=t[s];d&&(t[s]=d),r.trace("ProxyResolver#lookupProxyAuthorization callback",`proxyURL:${s}`,`proxyAuthenticate:${d}`,`proxyAuthenticateCache:${l}`);const p=d||l,I=Array.isArray(p)?p:typeof p=="string"?[p]:[];if(i(n,I,h),I.some(b=>/^(Negotiate|Kerberos)( |$)/i.test(b))&&!u.kerberosRequested)try{u.kerberosRequested=!0;const b=await new Promise((z,T)=>{ge(["kerberos"],z,T)}),m=new URL(s),y=a.getConfiguration("http").get("proxyKerberosServicePrincipal")||(process.platform==="win32"?`HTTP/${m.hostname}`:`HTTP@${m.hostname}`);return r.debug("ProxyResolver#lookupProxyAuthorization Kerberos authentication lookup",`proxyURL:${s}`,`spn:${y}`),"Negotiate "+await(await b.initializeClient(y)).step("")}catch(b){r.error("ProxyResolver#lookupProxyAuthorization Kerberos authentication failed",b)}}let o=!1;function i(r,n,a){o||!n.length||(o=!0,r.$publicLog2("proxyAuthenticationRequest",{authenticationType:n.map(t=>t.split(" ")[0]).join(","),extensionHostType:a?"remote":"local"}))}}),define(ke[277],Se([1,0,130]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0;function N(P){return{transformIncoming:R=>R.scheme==="vscode-remote"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="file"?{scheme:"vscode-local",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoing:R=>R.scheme==="file"?{scheme:"vscode-remote",authority:P,path:R.path,query:R.query,fragment:R.fragment}:R.scheme==="vscode-local"?{scheme:"file",path:R.path,query:R.query,fragment:R.fragment}:R,transformOutgoingScheme:R=>R==="file"?"vscode-remote":R==="vscode-local"?"file":R}}function f(P){return new C.$4m(N(P))}e.$3r=f}),define(ke[139],Se([1,0,224,18,2,3,5,37,32,16,44,180,39]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5E=e.$4E=e.$3E=e.EditorsOrder=e.$2E=e.CloseDirection=e.$1E=e.$ZE=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$YE=e.$XE=e.$WE=e.$VE=e.$UE=e.$TE=e.$SE=e.$RE=e.EditorInputCapabilities=e.$QE=e.SaveReason=e.Verbosity=e.$PE=e.$OE=e.$NE=e.$ME=e.$LE=e.$KE=e.$JE=e.$IE=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$HE=e.$GE=e.$FE=e.$EE=e.$DE=void 0,e.$DE={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$EE={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$FE="workbench.editor.sidebysideEditor",e.$GE="workbench.editors.textDiffEditor",e.$HE="workbench.editors.binaryResourceDiffEditor";var E;(function(oe){oe[oe.PROGRAMMATIC=1]="PROGRAMMATIC",oe[oe.USER=2]="USER",oe[oe.EDIT=3]="EDIT",oe[oe.NAVIGATION=4]="NAVIGATION",oe[oe.JUMP=5]="JUMP"})(E||(e.EditorPaneSelectionChangeReason=E={}));var S;(function(oe){oe[oe.IDENTICAL=1]="IDENTICAL",oe[oe.SIMILAR=2]="SIMILAR",oe[oe.DIFFERENT=3]="DIFFERENT"})(S||(e.EditorPaneSelectionCompareResult=S={}));function c(oe){const J=oe;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.$IE=c;function g(oe,J,V){for(const ie of V.visibleEditorPanes)if(ie.group.id===J&&oe.matches(ie.input))return ie.getViewState()}e.$JE=g;function o(oe){if(p(oe))return!1;const J=oe;return f.URI.isUri(J?.resource)}e.$KE=o;function i(oe){if(p(oe))return!1;const J=oe;return J?.original!==void 0&&J.modified!==void 0}e.$LE=i;function r(oe){if(p(oe))return!1;const J=oe;return!J||J.resources&&!Array.isArray(J.resources)?!1:!!J.resources||!!J.multiDiffSource}e.$ME=r;function n(oe){if(p(oe)||i(oe))return!1;const J=oe;return J?.primary!==void 0&&J.secondary!==void 0}e.$NE=n;function a(oe){if(p(oe))return!1;const J=oe;return J?J.resource===void 0||J.resource.scheme===k.Schemas.untitled||J.forceUntitled===!0:!1}e.$OE=a;function t(oe){if(p(oe))return!1;const J=oe;return f.URI.isUri(J?.base?.resource)&&f.URI.isUri(J?.input1?.resource)&&f.URI.isUri(J?.input2?.resource)&&f.URI.isUri(J?.result?.resource)}e.$PE=t;var h;(function(oe){oe[oe.SHORT=0]="SHORT",oe[oe.MEDIUM=1]="MEDIUM",oe[oe.LONG=2]="LONG"})(h||(e.Verbosity=h={}));var s;(function(oe){oe[oe.EXPLICIT=1]="EXPLICIT",oe[oe.AUTO=2]="AUTO",oe[oe.FOCUS_CHANGE=3]="FOCUS_CHANGE",oe[oe.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class d{constructor(){this.a=new Map}registerSource(J,V){let ie=this.a.get(J);return ie||(ie={source:J,label:V},this.a.set(J,ie)),ie.source}getSourceLabel(J){return this.a.get(J)?.label??J}}e.$QE=new d;var u;(function(oe){oe[oe.None=0]="None",oe[oe.Readonly=2]="Readonly",oe[oe.Untitled=4]="Untitled",oe[oe.Singleton=8]="Singleton",oe[oe.RequiresTrust=16]="RequiresTrust",oe[oe.CanSplitInGroup=32]="CanSplitInGroup",oe[oe.ForceDescription=64]="ForceDescription",oe[oe.CanDropIntoEditor=128]="CanDropIntoEditor",oe[oe.MultipleEditors=256]="MultipleEditors",oe[oe.Scratchpad=512]="Scratchpad",oe[oe.AuxWindowUnsupported=1024]="AuxWindowUnsupported"})(u||(e.EditorInputCapabilities=u={}));class l extends P.$Tc{}e.$RE=l;function p(oe){return oe instanceof l}e.$SE=p;function I(oe){const J=oe;return f.URI.isUri(J?.preferredResource)}function b(oe){const J=oe;return p(J?.primary)&&p(J?.secondary)}e.$TE=b;function m(oe){const J=oe;return p(J?.modified)&&p(J?.original)}e.$UE=m;function y(oe,J,V,ie,ye){return $e(ie,[(0,D.$Pi)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const de={...V,limits:{size:Number.MAX_VALUE}};oe.openEditor(J,de)}}),(0,D.$Pi)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>ye.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:w.default.Warning})}e.$VE=y;function L(oe){return p(oe?.editor)}e.$WE=L;function F(oe){const J=oe;return L(oe)&&J?.group!==void 0}e.$XE=F;function z(oe){const J=oe;return typeof J?.groupId=="number"&&p(J.editor)}e.$YE=z;var T;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.REPLACE=1]="REPLACE",oe[oe.MOVE=2]="MOVE",oe[oe.UNPIN=3]="UNPIN"})(T||(e.EditorCloseContext=T={}));var O;(function(oe){oe[oe.GROUP_ACTIVE=0]="GROUP_ACTIVE",oe[oe.GROUP_INDEX=1]="GROUP_INDEX",oe[oe.GROUP_LABEL=2]="GROUP_LABEL",oe[oe.GROUP_LOCKED=3]="GROUP_LOCKED",oe[oe.EDITOR_OPEN=4]="EDITOR_OPEN",oe[oe.EDITOR_CLOSE=5]="EDITOR_CLOSE",oe[oe.EDITOR_MOVE=6]="EDITOR_MOVE",oe[oe.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",oe[oe.EDITOR_LABEL=8]="EDITOR_LABEL",oe[oe.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",oe[oe.EDITOR_PIN=10]="EDITOR_PIN",oe[oe.EDITOR_STICKY=11]="EDITOR_STICKY",oe[oe.EDITOR_DIRTY=12]="EDITOR_DIRTY",oe[oe.EDITOR_WILL_DISPOSE=13]="EDITOR_WILL_DISPOSE"})(O||(e.GroupModelChangeKind=O={}));var M;(function(oe){oe[oe.PRIMARY=1]="PRIMARY",oe[oe.SECONDARY=2]="SECONDARY",oe[oe.BOTH=3]="BOTH",oe[oe.ANY=4]="ANY"})(M||(e.SideBySideEditor=M={}));class j{getOriginalUri(J,V){if(!J)return;if(t(J))return e.$1E.getOriginalUri(J.result,V);if(V?.supportSideBySide){const{primary:ye,secondary:de}=this.a(J);if(ye&&de){if(V?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(ye,{filterByScheme:V.filterByScheme}),secondary:this.getOriginalUri(de,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===M.ANY)return this.getOriginalUri(ye,{filterByScheme:V.filterByScheme})??this.getOriginalUri(de,{filterByScheme:V.filterByScheme});J=V.supportSideBySide===M.PRIMARY?ye:de}}if(i(J)||r(J)||n(J)||t(J))return;const ie=I(J)?J.preferredResource:J.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}a(J){return b(J)||n(J)?{primary:J.primary,secondary:J.secondary}:m(J)||i(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,V){if(!J)return;if(t(J))return e.$1E.getCanonicalUri(J.result,V);if(V?.supportSideBySide){const{primary:ye,secondary:de}=this.a(J);if(ye&&de){if(V?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(ye,{filterByScheme:V.filterByScheme}),secondary:this.getCanonicalUri(de,{filterByScheme:V.filterByScheme})};if(V?.supportSideBySide===M.ANY)return this.getCanonicalUri(ye,{filterByScheme:V.filterByScheme})??this.getCanonicalUri(de,{filterByScheme:V.filterByScheme});J=V.supportSideBySide===M.PRIMARY?ye:de}}if(i(J)||r(J)||n(J)||t(J))return;const ie=J.resource;return!ie||!V||!V.filterByScheme?ie:this.b(ie,V.filterByScheme)}b(J,V){if(Array.isArray(V)){if(V.some(ie=>J.scheme===ie))return J}else if(V===J.scheme)return J}}var U;(function(oe){oe[oe.UNKNOWN=0]="UNKNOWN",oe[oe.KEYBOARD=1]="KEYBOARD",oe[oe.MOUSE=2]="MOUSE"})(U||(e.EditorCloseMethod=U={}));function K(oe,J,V,ie){if(!oe.isSticky(J))return!1;switch(ie.preventPinnedEditorClose){case"keyboardAndMouse":return V===U.MOUSE||V===U.KEYBOARD;case"mouse":return V===U.MOUSE;case"keyboard":return V===U.KEYBOARD}return!1}e.$ZE=K,e.$1E=new j;var ue;(function(oe){oe[oe.LEFT=0]="LEFT",oe[oe.RIGHT=1]="RIGHT"})(ue||(e.CloseDirection=ue={}));class X{constructor(){this.c=new Map,this.d=new Map}start(J){const V=this.a=J.get(R.$5h);for(const[ie,ye]of this.c)this.e(ie,ye,V);this.c.clear()}e(J,V,ie){const ye=ie.createInstance(V);this.d.set(J,ye)}registerFileEditorFactory(J){if(this.b)throw new Error("Can only register one file editor factory.");this.b=J}getFileEditorFactory(){return(0,N.$Tf)(this.b)}registerEditorSerializer(J,V){if(this.c.has(J)||this.d.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.a?this.e(J,V,this.a):this.c.set(J,V),(0,P.$Rc)(()=>{this.c.delete(J),this.d.delete(J)})}getEditorSerializer(J){return this.d.get(typeof J=="string"?J:J.typeId)}}v.$Hn.add(e.$DE.EditorFactory,new X);async function Q(oe,J,V){return!oe||!oe.length?[]:await Promise.all(oe.map(async ie=>{const ye=f.URI.revive(ie.fileUri);if(!ye){V.info("Cannot resolve the path because it is not valid.",ie);return}if(!await J.canHandleResource(ye)){V.info("Cannot resolve the path because it cannot be handled",ie);return}let fe=ie.exists,_=ie.type;if(typeof fe!="boolean"||typeof _!="number")try{_=(await J.stat(ye)).isDirectory?$.FileType.Directory:$.FileType.Unknown,fe=!0}catch(G){V.error(G),fe=!1}if(!fe&&ie.openOnlyIfExists){V.info("Cannot resolve the path because it does not exist",ie);return}if(_===$.FileType.Directory){V.info("Cannot resolve the path because it is a directory",ie);return}const ee={...ie.options,pinned:!0};return fe?{resource:ye,options:ee}:{resource:ye,options:ee,forceUntitled:!0}}))}e.$2E=Q;var Z;(function(oe){oe[oe.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",oe[oe.SEQUENTIAL=1]="SEQUENTIAL"})(Z||(e.EditorsOrder=Z={}));function le(oe){const J=oe;if(!J)return!1;const V=J;if(V.modified)return le(V.modified);const ie=J;return!!(ie.contributionsState&&ie.viewState&&Array.isArray(ie.cursorState))}e.$3E=le;function re(oe){return(0,A.$Ri)(oe)}e.$4E=re;function $e(oe,J,V){const ie=(0,A.$Si)(oe,J);return ie.forceMessage=V?.forceMessage,ie.forceSeverity=V?.forceSeverity,ie.allowDialog=V?.allowDialog,ie}e.$5E=$e}),define(ke[278],Se([1,0,4,225,5,3,28,37,19,24,78,264]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aF=e.$_E=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$$E=e.ViewContentGroups=e.$0E=e.$9E=e.ViewContainerLocation=e.Extensions=e.$8E=e.$7E=e.$6E=void 0,e.$6E="views",e.$7E=(0,N.localize)(0,null),e.$8E=(0,D.$xw)("default-view-icon",A.$_j.window,(0,N.localize)(1,null));var w;(function(h){h.ViewContainersRegistry="workbench.registry.view.containers",h.ViewsRegistry="workbench.registry.view"})(w||(e.Extensions=w={}));var E;(function(h){h[h.Sidebar=0]="Sidebar",h[h.Panel=1]="Panel",h[h.AuxiliaryBar=2]="AuxiliaryBar"})(E||(e.ViewContainerLocation=E={})),e.$9E=[0,1,2];function S(h){switch(h){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.$0E=S;class c extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new C.$Vd),this.onDidRegister=this.c.event,this.f=this.B(new C.$Vd),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,$.$Rb)([...this.g.values()])}registerViewContainer(s,d,u){const l=this.get(s.id);if(l)return l;const p=s;return p.openCommandActionDescriptor=u?.doNotRegisterOpenCommand?void 0:p.openCommandActionDescriptor??{id:p.id},(0,R.$xc)(this.g,d,[]).push(p),u?.isDefault&&this.h.push(p),this.c.fire({viewContainer:p,viewContainerLocation:d}),p}deregisterViewContainer(s){for(const d of this.g.keys()){const u=this.g.get(d),l=u?.indexOf(s);if(l!==-1){u?.splice(l,1),u.length===0&&this.g.delete(d),this.f.fire({viewContainer:s,viewContainerLocation:d});return}}}get(s){return this.all.filter(d=>d.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(d=>this.getViewContainers(d).filter(u=>u?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(d=>this.getViewContainerLocation(d)===s)}}v.$Hn.add(w.ViewContainersRegistry,new c);var g;(function(h){h.Open="2_open",h.Debug="4_debug",h.SCM="5_scm",h.More="9_more"})(g||(e.ViewContentGroups=g={}));function o(h,s){const d=h.group??g.More,u=s.group??g.More;return d!==u?d.localeCompare(u):(h.order??5)-(s.order??5)}class i extends P.$Tc{constructor(){super(...arguments),this.c=this.B(new C.$Vd),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$Vd),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$Vd),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$Vd),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new R.$Gc}registerViews(s,d){this.registerViews2([{views:s,viewContainer:d}])}registerViews2(s){s.forEach(({views:d,viewContainer:u})=>this.r(d,u)),this.c.fire(s)}deregisterViews(s,d){const u=this.s(s,d);u.length&&this.f.fire({views:u,viewContainer:d})}moveViews(s,d){for(const u of this.m.keys())if(u!==d){const l=this.s(s,u);l.length&&(this.r(l,d),this.g.fire({views:l,from:u,to:d}))}}getViews(s){return this.m.get(s)||[]}getView(s){for(const d of this.j){const u=(this.m.get(d)||[]).filter(l=>l.id===s)[0];if(u)return u}return null}getViewContainer(s){for(const d of this.j)if((this.m.get(d)||[]).filter(l=>l.id===s)[0])return d;return null}registerViewWelcomeContent(s,d){return this.n.add(s,d),this.h.fire(s),(0,P.$Rc)(()=>{this.n.delete(s,d),this.h.fire(s)})}registerViewWelcomeContent2(s,d){const u=new Map;for(const[l,p]of d)this.n.add(s,p),u.set(l,(0,P.$Rc)(()=>{this.n.delete(s,p),this.h.fire(s)}));return this.h.fire(s),u}getViewWelcomeContent(s){const d=[];return this.n.forEach(s,u=>d.push(u)),d.sort(o)}r(s,d){let u=this.m.get(d);u||(u=[],this.m.set(d,u),this.j.push(d));for(const l of s){if(this.getView(l.id)!==null)throw new Error((0,N.localize)(2,null,l.id));u.push(l)}}s(s,d){const u=this.m.get(d);if(!u)return[];const l=[],p=[];for(const I of u)s.includes(I)?l.push(I):p.push(I);return l.length&&(p.length?this.m.set(d,p):(this.m.delete(d),this.j.splice(this.j.indexOf(d),1))),l}}v.$Hn.add(w.ViewsRegistry,new i),e.$$E=(0,f.$6h)("viewDescriptorService");var r;(function(h){h[h.Default=0]="Default",h[h.Expand=1]="Expand"})(r||(e.ViewVisibilityState=r={}));var n;(function(h){h[h.None=0]="None",h[h.Collapsed=1]="Collapsed",h[h.Expanded=2]="Expanded"})(n||(e.TreeItemCollapsibleState=n={}));class a{constructor(s,d){this.c=!1,this.d=!1,(0,k.$yn)(this,s),this.d=!!d,this.resolve=async u=>{if(d&&!this.c){const l=await d(u);l&&(this.tooltip=this.tooltip??l.tooltip,this.command=this.command??l.command)}u.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$_E=a;class t extends Error{constructor(s){super((0,N.localize)(3,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.$aF=t}),define(ke[279],Se([1,0,2,29,5]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jF=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$iF=e.$hF=void 0;function P(k){return!!k&&typeof k=="object"&&"uri"in k&&k.uri instanceof C.URI&&"version"in k&&typeof k.version=="number"&&"ranges"in k&&Array.isArray(k.ranges)&&k.ranges.every(N.$Us.isIRange)}e.$hF=P;function R(k){return!!k&&typeof k=="object"&&"documents"in k&&Array.isArray(k.documents)&&k.documents.every(P)}e.$iF=R;var v;(function(k){k[k.Down=0]="Down",k[k.Up=1]="Up"})(v||(e.InteractiveSessionVoteDirection=v={}));var $;(function(k){k[k.Action=1]="Action",k[k.Toolbar=2]="Toolbar"})($||(e.ChatAgentCopyKind=$={})),e.$jF=(0,f.$6h)("IChatService")}),define(ke[140],Se([1,0,4,11,226]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zlb=void 0;class P{constructor(){this.f=new Map,this.k=[],this.m=new C.$Vd,this.n=new C.$Vd,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(v){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=v}onEvent(v){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=v}onRequest(v){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=v}sendResponse(v){v.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${v.command}`)):this.s("response",v)}sendRequest(v,$,k,A){const D={command:v};if($&&Object.keys($).length>0&&(D.arguments=$),this.s("request",D),typeof A=="number"){const w=setTimeout(()=>{clearTimeout(w);const E=this.f.get(D.seq);if(E){this.f.delete(D.seq);const S={type:"response",seq:0,request_seq:D.seq,success:!1,command:v,message:(0,f.localize)(0,null,A,v)};E(S)}},A)}return k&&this.f.set(D.seq,k),D.seq}acceptMessage(v){this.j?this.j(v):(this.k.push(v),this.k.length===1&&this.q())}o(v,$){return v.type!=="event"||$.type!=="event"}async q(){let v;for(;this.k.length;){if((!v||this.o(this.k[0],v))&&await(0,N.$7g)(0),v=this.k.shift(),!v)return;switch(v.type){case"event":this.i?.(v);break;case"request":this.g?.(v);break;case"response":{const $=v,k=this.f.get($.request_seq);k&&(this.f.delete($.request_seq),k($));break}}}}s(v,$){$.type=v,$.seq=this.d++,this.sendMessage($)}async u(){if(this.f.size===0)return Promise.resolve();const v=new Map;this.f.forEach(($,k)=>v.set(k,$)),await(0,N.$7g)(500),v.forEach(($,k)=>{$({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.f.delete(k)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.$Zlb=P}),define(ke[280],Se([1,0,2,227,45,5]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$QH=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.$PH=e.MemoryRangeType=e.$OH=e.State=e.$NH=e.$MH=e.$LH=e.$KH=e.$JH=e.$IH=e.$HH=e.$GH=e.$FH=e.$EH=e.$DH=e.$CH=e.$BH=e.$AH=e.$zH=e.$yH=e.$xH=e.$wH=e.$vH=e.$uH=e.$tH=e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.$nH=e.$mH=e.$lH=e.$kH=e.$jH=e.$iH=e.$hH=e.$gH=e.$fH=e.$eH=e.$dH=e.$cH=e.$bH=e.$aH=e.$_G=e.$$G=e.$0G=e.$9G=e.$8G=e.$7G=e.$6G=e.$5G=e.$4G=e.$3G=e.$2G=e.$1G=e.$ZG=e.$YG=e.$XG=e.$WG=e.$VG=e.$UG=e.$TG=e.$SG=e.$RG=e.$QG=e.$PG=e.$OG=e.$NG=e.$MG=e.$LG=e.$KG=e.$JG=e.$IG=void 0,e.$IG="workbench.view.debug",e.$JG="workbench.debug.variablesView",e.$KG="workbench.debug.watchExpressionsView",e.$LG="workbench.debug.callStackView",e.$MG="workbench.debug.loadedScriptsView",e.$NG="workbench.debug.breakPointsView",e.$OG="workbench.debug.disassemblyView",e.$PG="workbench.panel.repl",e.$QG="workbench.panel.repl.view",e.$RG=new f.$kj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$SG=new f.$kj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$TG=new f.$kj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$UG="debugUx",e.$VG=new f.$kj(e.$UG,"default",{type:"string",description:N.localize(3,null)}),e.$WG=new f.$kj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$XG=new f.$kj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$YG=new f.$kj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$ZG=new f.$kj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$1G=new f.$kj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$2G=new f.$kj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$3G=new f.$kj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$4G=new f.$kj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$5G=new f.$kj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$6G=new f.$kj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$7G=new f.$kj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$8G=new f.$kj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$9G=new f.$kj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$0G=new f.$kj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$$G=new f.$kj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$_G=new f.$kj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$aH=new f.$kj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$bH=new f.$kj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$cH=new f.$kj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(22,null)}),e.$dH=new f.$kj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(23,null)}),e.$eH=new f.$kj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(24,null)}),e.$fH=new f.$kj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(25,null)}),e.$gH=new f.$kj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(26,null)}),e.$hH=new f.$kj("stepBackSupported",!1,{type:"boolean",description:N.localize(27,null)}),e.$iH=new f.$kj("restartFrameSupported",!1,{type:"boolean",description:N.localize(28,null)}),e.$jH=new f.$kj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(29,null)}),e.$kH=new f.$kj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$lH=new f.$kj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(31,null)}),e.$mH=new f.$kj("breakpointsExist",!1,{type:"boolean",description:N.localize(32,null)}),e.$nH=new f.$kj("debuggersAvailable",!1,{type:"boolean",description:N.localize(33,null)}),e.$oH=new f.$kj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(34,null)}),e.$pH=new f.$kj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(35,null)}),e.$qH=new f.$kj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(36,null)}),e.$rH=new f.$kj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(37,null)}),e.$sH=new f.$kj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$tH=new f.$kj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$uH=new f.$kj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$vH=new f.$kj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$wH=new f.$kj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$xH=new f.$kj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(43,null)}),e.$yH=new f.$kj("variableIsReadonly",!1,{type:"boolean",description:N.localize(44,null)}),e.$zH=new f.$kj("variableValue",!1,{type:"string",description:N.localize(45,null)}),e.$AH=new f.$kj("variableType",!1,{type:"string",description:N.localize(46,null)}),e.$BH=new f.$kj("variableName",!1,{type:"string",description:N.localize(47,null)}),e.$CH=new f.$kj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(48,null)}),e.$DH=new f.$kj("multiSessionRepl",!1,{type:"boolean",description:N.localize(49,null)}),e.$EH=new f.$kj("multiSessionDebug",!1,{type:"boolean",description:N.localize(50,null)}),e.$FH=new f.$kj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(51,null)}),e.$GH=new f.$kj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(52,null)}),e.$HH=new f.$kj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(53,null)}),e.$IH=new f.$kj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(54,null)});const R=c=>N.localize(55,null,c);e.$JH=R,e.$KH="editor.contrib.debug",e.$LH="editor.contrib.breakpoint",e.$MH="debug",e.$NH={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(56,null)};var v;(function(c){c[c.Inactive=0]="Inactive",c[c.Initializing=1]="Initializing",c[c.Stopped=2]="Stopped",c[c.Running=3]="Running"})(v||(e.State=v={}));function $(c){switch(c){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.$OH=$;var k;(function(c){c[c.Valid=0]="Valid",c[c.Unreadable=1]="Unreadable",c[c.Error=2]="Error"})(k||(e.MemoryRangeType=k={})),e.$PH="vscode-debug-memory";var A;(function(c){c[c.Initial=1]="Initial",c[c.Dynamic=2]="Dynamic"})(A||(e.DebugConfigurationProviderTriggerKind=A={}));var D;(function(c){c.UnverifiedBreakpoints="unverifiedBreakpoints"})(D||(e.DebuggerString=D={})),e.$QH=(0,P.$6h)("debugService");var w;(function(c){c[c.CONDITION=0]="CONDITION",c[c.HIT_COUNT=1]="HIT_COUNT",c[c.LOG_MESSAGE=2]="LOG_MESSAGE",c[c.TRIGGER_POINT=3]="TRIGGER_POINT"})(w||(e.BreakpointWidgetContext=w={}));var E;(function(c){c[c.Command=0]="Command",c[c.Tree=1]="Tree"})(E||(e.DebugVisualizationType=E={}));var S;(function(c){c.deserialize=g=>({id:g.id,name:g.name,iconPath:g.iconPath&&{light:C.URI.revive(g.iconPath.light),dark:C.URI.revive(g.iconPath.dark)},iconClass:g.iconClass,visualization:g.visualization}),c.serialize=g=>g})(S||(e.IDebugVisualization=S={}))}),define(ke[281],Se([1,0,12,2,17,24,16,29,21,19]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=e.$_F=e.$$F=e.$0F=void 0;const A=/{([^}]+)}/g;function D(I,b,m){return I.replace(A,function(y,L){return b&&L.length>0&&L[0]!=="_"?y:m&&m.hasOwnProperty(L)?m[L]:y})}e.$0F=D;function w(I){const b={};for(const m of Object.keys(I))m.startsWith("!")||(b[m]=I[m]);return b}e.$$F=w;function E(I){return I.configuration.request==="attach"&&!S(I)&&(!I.parentSession||E(I.parentSession))}e.$_F=E;function S(I){let b=I.configuration.type;if(b)return b==="vslsShare"&&(b=I.configuration.adapterProxy.configuration.type),(0,C.$_e)(b,"extensionhost")||(0,C.$_e)(b,"pwa-extensionhost")?I:I.parentSession?S(I.parentSession):void 0}e.$aG=S;function c(I){return I.type&&(I.label||I.program||I.runtime)}e.$bG=c;function g(I,b,m){let y,L=0;const F=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let z=null;for(;z=F.exec(I);){const T=z.index+1,O=T+z[0].length;if(T<=b&&O>=m){y=z[0],L=T;break}}if(y){const T=/\w+/g;let O=null;for(;(O=T.exec(y))&&!(O.index+1+L+O[0].length>=m););O&&(y=y.substring(0,T.lastIndex))}return y?{start:L,end:L+y.length-1}:{start:0,end:0}}e.$cG=g;async function o(I,b,m,y){if(I.evaluatableExpressionProvider.has(b)){const L=I.evaluatableExpressionProvider.ordered(b),F=(0,k.$Hb)(await Promise.all(L.map(async z=>{try{return await z.provideEvaluatableExpression(b,m,y??$.CancellationToken.None)}catch{return}})));if(F.length>0){let z=F[0].expression;const T=F[0].range;return z||(z=b.getLineContent(m.lineNumber).substring(T.startColumn-1,T.endColumn-1)),{range:T,matchingExpression:z}}}else{const L=b.getLineContent(m.lineNumber),{start:F,end:z}=g(L,m.column,m.column),T=L.substring(F-1,z);return{matchingExpression:T,range:new v.$Us(m.lineNumber,F,m.lineNumber,F+T.length)}}return null}e.$dG=o;const i=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function r(I){return!!(I&&I.match(i))}e.$eG=r;function n(I){if(typeof I.path=="string"&&!(typeof I.sourceReference=="number"&&I.sourceReference>0)){if(r(I.path))return N.URI.parse(I.path);if((0,f.$ic)(I.path))return N.URI.file(I.path)}return I.path}function a(I){if(typeof I.path=="object"){const b=N.URI.revive(I.path);if(b)return b.scheme===R.Schemas.file?b.fsPath:b.toString()}return I.path}function t(I,b){const m=b?n:a,y=(0,P.$vn)(I);return s(y,(L,F)=>{L&&F&&(F.path=m(F))}),y}e.$fG=t;function h(I,b){const m=b?n:a,y=(0,P.$vn)(I);return s(y,(L,F)=>{!L&&F&&(F.path=m(F))}),y}e.$gG=h;function s(I,b){switch(I.type){case"event":{const m=I;switch(m.event){case"output":b(!1,m.body.source);break;case"loadedSource":b(!1,m.body.source);break;case"breakpoint":b(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=I;switch(m.command){case"setBreakpoints":b(!0,m.arguments.source);break;case"breakpointLocations":b(!0,m.arguments.source);break;case"source":b(!0,m.arguments.source);break;case"gotoTargets":b(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(y=>b(!1,y));break;default:break}break}case"response":{const m=I;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(y=>b(!1,y.source));break;case"loadedSources":m.body.sources.forEach(y=>b(!1,y));break;case"scopes":m.body.scopes.forEach(y=>b(!1,y.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(y=>b(!1,y.source));break;case"setBreakpoints":m.body.breakpoints.forEach(y=>b(!1,y.source));break;case"disassemble":m.body?.instructions.forEach(L=>b(!1,L.location));break;default:break}break}}}function d(I){return I.filter(b=>!b.presentation?.hidden).sort((b,m)=>b.presentation?m.presentation?b.presentation.group?m.presentation.group?b.presentation.group!==m.presentation.group?b.presentation.group.localeCompare(m.presentation.group):u(b.presentation.order,m.presentation.order):-1:m.presentation.group?1:u(b.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.$hG=d;function u(I,b){return typeof I!="number"?typeof b!="number"?0:1:typeof b!="number"?-1:I-b}async function l(I,b){const m=I.getValue("debug.saveBeforeStart",{overrideIdentifier:b.activeTextEditorLanguageId});if(m!=="none"&&(await b.saveAll(),m==="allEditorsInActiveGroup")){const y=b.activeEditorPane;y&&y.input.resource?.scheme===R.Schemas.untitled&&await b.save({editor:y.input,groupId:y.group.id})}await I.reloadConfiguration()}e.$iG=l;const p=(I,b)=>!I||!b?I===b:I.name===b.name&&I.path===b.path&&I.sourceReference===b.sourceReference;e.$jG=p}),define(ke[282],Se([1,0,50,62,24,17,10,12,31,228,140]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yic=e.$Xic=e.$Wic=e.$Vic=e.$Uic=void 0;class D extends A.$Zlb{static{this.a=`\r
\r
`}static{this.b=/\r?\n/}static{this.l=/: */}constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(o,i){this.p=i,this.r=Buffer.allocUnsafe(0),this.t=-1,o.on("data",r=>this.w(r))}sendMessage(o){if(this.p){const i=JSON.stringify(o);this.p.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${D.a}${i}`,"utf8")}}w(o){for(this.r=Buffer.concat([this.r,o]);;){if(this.t>=0){if(this.r.length>=this.t){const i=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,i.length>0)try{this.acceptMessage(JSON.parse(i))}catch(r){this.m.fire(new Error((r.message||r)+`
`+i))}continue}}else{const i=this.r.indexOf(D.a);if(i!==-1){const n=this.r.toString("utf8",0,i).split(D.b);for(const a of n){const t=a.split(D.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(i+D.a.length);continue}}break}}}e.$Uic=D;class w extends D{startSession(){return new Promise((o,i)=>{let r=!1;this.x=this.y(()=>{this.v(this.x,this.x),o(),r=!0}),this.x.on("close",()=>{r?this.m.fire(new Error("connection closed")):i(new Error("connection closed"))}),this.x.on("error",n=>{r?this.m.fire(n):i(n)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.$Vic=w;class E extends w{constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.port,this.z.host||"127.0.0.1",o)}}e.$Wic=E;class S extends w{constructor(o){super(),this.z=o}y(o){return N.createConnection(this.z.path,o)}}e.$Xic=S;class c extends D{constructor(o,i){super(),this.y=o,this.z=i}async startSession(){const o=this.y.command,i=this.y.args,r=this.y.options||{};try{if(o)if(P.$ic(o)){if(!await $.Promises.exists(o))throw new Error(k.localize(0,null,o))}else o.indexOf("/")<0&&o.indexOf("\\")<0;else throw new Error(k.localize(1,null,this.z));let n=process.env;if(r.env&&Object.keys(r.env).length>0&&(n=f.$yn(f.$vn(process.env),r.env)),o==="node")if(Array.isArray(i)&&i.length>0){const a=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:n,execArgv:a?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};r.cwd&&(t.cwd=r.cwd);const h=C.fork(i[0],i.slice(1),t);if(!h.pid)throw new Error(k.localize(2,null,i[0]));this.x=h}else throw new Error(k.localize(3,null));else{const a={env:n};r.cwd&&(a.cwd=r.cwd),this.x=C.spawn(o,i,a)}this.x.on("error",a=>{this.m.fire(a)}),this.x.on("exit",(a,t)=>{this.n.fire(a)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",a=>{this.m.fire(a)}),this.x.stdin.on("error",a=>{this.m.fire(a)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(n){this.m.fire(n)}}async stopSession(){return this.x?(await this.u(),R.$i?new Promise((o,i)=>{const r=C.exec(`taskkill /F /T /PID ${this.x.pid}`,function(n,a,t){if(n)return i(n)});r.on("exit",o),r.on("error",i)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(o,i){if(!o)return;const r=Object.create(null);o.runtime&&(o.runtime.indexOf("./")===0?r.runtime=P.$jc(i,o.runtime):r.runtime=o.runtime),o.runtimeArgs&&(r.runtimeArgs=o.runtimeArgs),o.program&&(P.$ic(o.program)?r.program=o.program:r.program=P.$jc(i,o.program)),o.args&&(r.args=o.args);const n=o;return n.win&&(r.win=c.A(n.win,i)),n.winx86&&(r.winx86=c.A(n.winx86,i)),n.windows&&(r.windows=c.A(n.windows,i)),n.osx&&(r.osx=c.A(n.osx,i)),n.linux&&(r.linux=c.A(n.linux,i)),r}static platformAdapterExecutable(o,i){let r=Object.create(null);i=i.toLowerCase();for(const d of o)if(d.contributes){const u=d.contributes.debuggers;u&&u.length>0&&u.filter(l=>typeof l.type=="string"&&v.$_e(l.type,i)).forEach(l=>{const p=c.A(l,d.extensionLocation.fsPath);r=f.$yn(r,p,d.isBuiltin)})}let n;R.$i&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?n=r.winx86||r.win||r.windows:R.$i?n=r.win||r.windows:R.$j?n=r.osx:R.$k&&(n=r.linux),n=n||r;const a=n.program||r.program,t=n.args||r.args,h=n.runtime||r.runtime,s=n.runtimeArgs||r.runtimeArgs;if(h)return{type:"executable",command:h,args:(s||[]).concat(typeof a=="string"?[a]:[]).concat(t||[])};if(a)return{type:"executable",command:a,args:t||[]}}}e.$Yic=c}),define(ke[283],Se([1,0,50,34,10]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1ic=e.$Zic=void 0;function P(k,A){return new Promise((D,w)=>{let E="";const S=C.spawn(k,A);S.pid&&S.stdout.on("data",c=>{E+=c.toString()}),S.on("error",c=>{w(c)}),S.on("close",c=>{D(E)})})}async function R(k){if(k)if(f.$i){const A=await new Promise((D,w)=>{ge(["@vscode/windows-process-tree"],D,w)});return new Promise(D=>{A.getProcessTree(k,w=>{D(!!w&&w.children.length>0)})})}else return P("/usr/bin/pgrep",["-lP",String(k)]).then(A=>{const D=A.trim();return!(D.length===0||D.indexOf(" tmux")>=0)},A=>!0);return Promise.resolve(!0)}e.$Zic=R;var v;(function(k){k[k.cmd=0]="cmd",k[k.powershell=1]="powershell",k[k.bash=2]="bash"})(v||(v={}));function $(k,A,D,w,E){k=k.trim().toLowerCase();let S;k.indexOf("powershell")>=0||k.indexOf("pwsh")>=0?S=1:k.indexOf("cmd.exe")>=0?S=0:k.indexOf("bash")>=0?S=2:f.$i?S=0:S=2;let c,g=" ";switch(S){case 1:if(c=o=>(o=o.replace(/\'/g,"''"),o.length>0&&o.charAt(o.length-1)==="\\"?`'${o}\\'`:`'${o}'`),w){const o=(0,N.$ag)(w);o&&(g+=`${o}:; `),g+=`cd ${c(w)}; `}if(E)for(const o in E){const i=E[o];i===null?g+=`Remove-Item env:${o}; `:g+=`\${env:${o}}='${i}'; `}if(A.length>0){const o=A.shift(),i=D?o:c(o);g+=i[0]==="'"?`& ${i} `:`${i} `;for(const r of A)g+=r==="<"||r===">"||D?r:c(r),g+=" "}break;case 0:if(c=o=>(o=o.replace(/\"/g,'""'),o=o.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(i=>o.includes(i))||o.length===0?`"${o}"`:o),w){const o=(0,N.$ag)(w);o&&(g+=`${o}: && `),g+=`cd ${c(w)} && `}if(E){g+='cmd /C "';for(const o in E){let i=E[o];i===null?g+=`set "${o}=" && `:(i=i.replace(/[&^|<>]/g,r=>`^${r}`),g+=`set "${o}=${i}" && `)}}for(const o of A)g+=o==="<"||o===">"||D?o:c(o),g+=" ";E&&(g+='"');break;case 2:{c=i=>(i=i.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),i.length===0?'""':i);const o=i=>/[^\w@%\/+=,.:^-]/.test(i)?`'${i.replace(/'/g,"'\\''")}'`:i;if(w&&(g+=`cd ${c(w)} ; `),E){g+="/usr/bin/env";for(const i in E){const r=E[i];r===null?g+=` -u ${o(i)}`:g+=` ${o(`${i}=${r}`)}`}g+=" "}for(const i of A)g+=i==="<"||i===">"||D?i:c(i),g+=" ";break}}return g}e.$1ic=$}),define(ke[284],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iJ=e.CellExecutionUpdateType=void 0;var N;(function(f){f[f.Output=1]="Output",f[f.OutputItems=2]="OutputItems",f[f.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$iJ=(0,C.$6h)("INotebookExecutionService")}),define(ke[285],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qfb=e.$pfb=e.ProxyKernelState=e.$ofb=void 0,e.$ofb=100;var N;(function(f){f[f.Disconnected=1]="Disconnected",f[f.Connected=2]="Connected",f[f.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$pfb=(0,C.$6h)("INotebookKernelService"),e.$qfb=(0,C.$6h)("INotebookKernelHistoryService")}),define(ke[286],Se([1,0,3,29,193,100]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bRb=void 0;class R extends C.$Tc{constructor($,k,A){super(),this._source=$,this.b=k,this.c=A,this.a=void 0}f($){const k=$.getLineCount();return new N.$Us(1,1,k,this.g($,k))}g($,k){if(k<1||k>$.getLineCount())throw new Error("Illegal value for lineNumber");return $.getLineLength(k)+1}get inputTextBuffer(){if(!this.b){const $=new f.$cC;$.acceptChunk(this._source);const k=$.finish(!0),{textBuffer:A,disposable:D}=k.create(1);this.b=A,this.B(D)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map($=>{const k=new f.$cC;k.acceptChunk($);const A=k.finish(!0),{textBuffer:D,disposable:w}=A.create(1);return this.B(w),D})),this.a}findInInputs($){const A=new P.$3B($,!1,!1,null).parseSearchRequest();if(!A)return[];const D=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(D,A,!0,5e3)}findInOutputs($){const A=new P.$3B($,!1,!1,null).parseSearchRequest();return A?this.outputTextBuffers.map(D=>{const w=D.findMatchesLineByLine(this.f(D),A,!0,5e3);if(w.length!==0)return{textBuffer:D,matches:w}}).filter(D=>!!D):[]}}e.$bRb=R}),define(ke[67],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5J=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(P){P.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var N;(function(P){P[P.IsSame=0]="IsSame",P[P.Disconnected=1]="Disconnected",P[P.IsChild=2]="IsChild",P[P.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class f{static fromExtHostTestItem(R,v,$=R.parent){if(R._isRoot)return new f([v]);const k=[R.id];for(let A=$;A&&A.id!==v;A=A.parent)k.push(A.id);return k.push(v),new f(k.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const v=R.indexOf("\0");return v===-1?R:R.slice(0,v)}static fromString(R){return new f(R.split("\0"))}static join(R,v){return new f([...R.path,v])}static joinToString(R,v){return R.toString()+"\0"+v}static parentId(R){const v=R.lastIndexOf("\0");return v===-1?void 0:R.slice(0,v)}static localId(R){const v=R.lastIndexOf("\0");return v===-1?R:R.slice(v+1)}static isChild(R,v){return v.startsWith(R)&&v[R.length]==="\0"}static compare(R,v){return R===v?0:f.isChild(R,v)?2:f.isChild(v,R)?3:1}constructor(R,v=R.length){if(this.path=R,this.d=v,R.length===0||v<1)throw new Error("cannot create test with empty path")}get rootId(){return new f(this.path,1)}get parentId(){return this.d>1?new f(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new f(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new f(this.path,R)}compare(R){if(typeof R=="string")return f.compare(this.toString(),R);for(let v=0;v<R.d&&v<this.d;v++)if(R.path[v]!==this.path[v])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.$5J=f}),define(ke[90],Se([1,0,2,48,29,67]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aK=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IFunctionCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$_J=e.IFileCoverage=e.ICoveredCount=e.TestResultItem=e.$$J=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$0J=e.$9J=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$8J=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$7J=e.$6J=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var R;(function(M){M[M.Unset=0]="Unset",M[M.Queued=1]="Queued",M[M.Running=2]="Running",M[M.Passed=3]="Passed",M[M.Failed=4]="Failed",M[M.Skipped=5]="Skipped",M[M.Errored=6]="Errored"})(R||(e.TestResultState=R={}));var v;(function(M){M[M.Run=1]="Run",M[M.Debug=2]="Debug",M[M.Coverage=3]="Coverage"})(v||(e.ExtTestRunProfileKind=v={}));var $;(function(M){M[M.Run=2]="Run",M[M.Debug=4]="Debug",M[M.Coverage=8]="Coverage",M[M.HasNonDefaultProfile=16]="HasNonDefaultProfile",M[M.HasConfigurable=32]="HasConfigurable",M[M.SupportsContinuousRun=64]="SupportsContinuousRun"})($||(e.TestRunProfileBitset=$={})),e.$6J=[2,4,8,16,32,64];const k=M=>"runId"in M;e.$7J=k;var A;(function(M){M.serialize=j=>({range:j.range.toJSON(),uri:j.uri.toJSON()}),M.deserialize=(j,U)=>({range:f.$Us.lift(U.range),uri:j.asCanonicalUri(C.URI.revive(U.uri))})})(A||(e.IRichLocation=A={}));var D;(function(M){M[M.Error=0]="Error",M[M.Output=1]="Output"})(D||(e.TestMessageType=D={}));var w;(function(M){M.serialize=j=>({message:j.message,type:0,expected:j.expected,actual:j.actual,contextValue:j.contextValue,location:j.location&&A.serialize(j.location)}),M.deserialize=(j,U)=>({message:U.message,type:0,expected:U.expected,actual:U.actual,contextValue:U.contextValue,location:U.location&&A.deserialize(j,U.location)})})(w||(e.ITestErrorMessage=w={}));const E=(M,j)=>`${j?"s":"e"}${M}`;e.$8J=E;var S;(function(M){M.serialize=j=>({message:j.message,type:1,offset:j.offset,length:j.length,location:j.location&&A.serialize(j.location)}),M.deserialize=(j,U)=>({message:U.message,type:1,offset:U.offset,length:U.length,location:U.location&&A.deserialize(j,U.location)})})(S||(e.ITestOutputMessage=S={}));var c;(function(M){M.serialize=j=>j.type===0?w.serialize(j):S.serialize(j),M.deserialize=(j,U)=>U.type===0?w.deserialize(j,U):S.deserialize(j,U)})(c||(e.ITestMessage=c={}));var g;(function(M){M.serializeWithoutMessages=j=>({state:j.state,duration:j.duration,messages:[]}),M.serialize=j=>({state:j.state,duration:j.duration,messages:j.messages.map(c.serialize)}),M.deserialize=(j,U)=>({state:U.state,duration:U.duration,messages:U.messages.map(K=>c.deserialize(j,K))})})(g||(e.ITestTaskState=g={}));const o="\0",i=(M,j)=>M+o+j;e.$9J=i;const r=M=>{const j=M.indexOf(o);return{ctrlId:M.slice(0,j),tagId:M.slice(j+1)}};e.$0J=r;var n;(function(M){M.serialize=j=>({extId:j.extId,label:j.label,tags:j.tags,busy:j.busy,children:void 0,uri:j.uri?.toJSON(),range:j.range?.toJSON()||null,description:j.description,error:j.error,sortText:j.sortText}),M.deserialize=(j,U)=>({extId:U.extId,label:U.label,tags:U.tags,busy:U.busy,children:void 0,uri:U.uri?j.asCanonicalUri(C.URI.revive(U.uri)):void 0,range:U.range?f.$Us.lift(U.range):null,description:U.description,error:U.error,sortText:U.sortText})})(n||(e.ITestItem=n={}));var a;(function(M){M[M.NotExpandable=0]="NotExpandable",M[M.Expandable=1]="Expandable",M[M.BusyExpanding=2]="BusyExpanding",M[M.Expanded=3]="Expanded"})(a||(e.TestItemExpandState=a={}));var t;(function(M){M.serialize=j=>({expand:j.expand,item:n.serialize(j.item)}),M.deserialize=(j,U)=>({controllerId:P.$5J.root(U.item.extId),expand:U.expand,item:n.deserialize(j,U.item)})})(t||(e.InternalTestItem=t={}));var h;(function(M){M.serialize=j=>{let U;return j.item&&(U={},j.item.label!==void 0&&(U.label=j.item.label),j.item.tags!==void 0&&(U.tags=j.item.tags),j.item.busy!==void 0&&(U.busy=j.item.busy),j.item.uri!==void 0&&(U.uri=j.item.uri?.toJSON()),j.item.range!==void 0&&(U.range=j.item.range?.toJSON()),j.item.description!==void 0&&(U.description=j.item.description),j.item.error!==void 0&&(U.error=j.item.error),j.item.sortText!==void 0&&(U.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:U}},M.deserialize=j=>{let U;return j.item&&(U={},j.item.label!==void 0&&(U.label=j.item.label),j.item.tags!==void 0&&(U.tags=j.item.tags),j.item.busy!==void 0&&(U.busy=j.item.busy),j.item.range!==void 0&&(U.range=j.item.range?f.$Us.lift(j.item.range):null),j.item.description!==void 0&&(U.description=j.item.description),j.item.error!==void 0&&(U.error=j.item.error),j.item.sortText!==void 0&&(U.sortText=j.item.sortText)),{extId:j.extId,expand:j.expand,item:U}}})(h||(e.ITestItemUpdate=h={}));const s=(M,j)=>{j.expand!==void 0&&(M.expand=j.expand),j.item!==void 0&&(M.item=M.item?Object.assign(M.item,j.item):j.item)};e.$$J=s;var d;(function(M){M.serializeWithoutMessages=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(g.serializeWithoutMessages)}),M.serialize=j=>({...t.serialize(j),ownComputedState:j.ownComputedState,computedState:j.computedState,tasks:j.tasks.map(g.serialize)}),M.deserialize=(j,U)=>({...t.deserialize(j,U),ownComputedState:U.ownComputedState,computedState:U.computedState,tasks:U.tasks.map(K=>g.deserialize(j,K)),retired:!0})})(d||(e.TestResultItem=d={}));var u;(function(M){M.empty=()=>({covered:0,total:0}),M.sum=(j,U)=>{j.covered+=U.covered,j.total+=U.total}})(u||(e.ICoveredCount=u={}));var l;(function(M){M.serialize=j=>({statement:j.statement,branch:j.branch,function:j.function,details:j.details?.map(m.serialize),uri:j.uri.toJSON()}),M.deserialize=(j,U)=>({statement:U.statement,branch:U.branch,function:U.function,details:U.details?.map(m.deserialize),uri:j.asCanonicalUri(C.URI.revive(U.uri))})})(l||(e.IFileCoverage=l={}));function p(M){return{...M,location:M.location?.toJSON()}}function I(M){return M.location=M.location?N.$Ts.isIPosition(M.location)?N.$Ts.lift(M.location):f.$Us.lift(M.location):void 0,M}e.$_J=3;var b;(function(M){M[M.Function=0]="Function",M[M.Statement=1]="Statement",M[M.Branch=2]="Branch"})(b||(e.DetailType=b={}));var m;(function(M){M.serialize=j=>j.type===0?L.serialize(j):F.serialize(j),M.deserialize=j=>j.type===0?L.deserialize(j):F.deserialize(j)})(m||(e.CoverageDetails=m={}));var y;(function(M){M.serialize=p,M.deserialize=I})(y||(e.IBranchCoverage=y={}));var L;(function(M){M.serialize=p,M.deserialize=I})(L||(e.IFunctionCoverage=L={}));var F;(function(M){M.serialize=j=>({...p(j),branches:j.branches?.map(y.serialize)}),M.deserialize=j=>({...I(j),branches:j.branches?.map(y.deserialize)})})(F||(e.IStatementCoverage=F={}));var z;(function(M){M[M.Add=0]="Add",M[M.Update=1]="Update",M[M.DocumentSynced=2]="DocumentSynced",M[M.Remove=3]="Remove",M[M.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",M[M.Retire=5]="Retire",M[M.AddTag=6]="AddTag",M[M.RemoveTag=7]="RemoveTag"})(z||(e.TestDiffOpType=z={}));var T;(function(M){M.deserialize=(j,U)=>U.op===0?{op:U.op,item:t.deserialize(j,U.item)}:U.op===1?{op:U.op,item:h.deserialize(U.item)}:U.op===2?{op:U.op,uri:j.asCanonicalUri(C.URI.revive(U.uri)),docv:U.docv}:U,M.serialize=j=>j.op===0?{op:j.op,item:t.serialize(j.item)}:j.op===1?{op:j.op,item:h.serialize(j.item)}:j})(T||(e.TestsDiffOp=T={}));class O{constructor(j){this.k=j,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(j){const U=this.v();for(const K of j)switch(K.op){case 0:this.l(t.deserialize(this.k,K.item),U);break;case 1:this.o(h.deserialize(K.item),U);break;case 3:this.p(K.itemId,U);break;case 5:this.q(K.itemId);break;case 4:this.updatePendingRoots(K.amount);break;case 6:this.c.set(K.tag.id,K.tag);break;case 7:this.c.delete(K.id);break}U.complete?.()}l(j,U){const K=P.$5J.parentId(j.item.extId)?.toString();let ue;if(!K)ue=this.w(j),this.g.add(ue),this.f.set(j.item.extId,ue);else if(this.f.has(K)){const X=this.f.get(K);X.children.add(j.item.extId),ue=this.w(j,X),this.f.set(j.item.extId,ue)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(j)}`);return}return U.add?.(ue),j.expand===2&&this.h++,ue}o(j,U){const K=this.f.get(j.extId);if(K)return j.expand!==void 0&&(K.expand===2&&this.h--,j.expand===2&&this.h++),(0,e.$$J)(K,j),U.update?.(K),K}p(j,U){const K=this.f.get(j);if(!K)return;const ue=P.$5J.parentId(K.item.extId)?.toString();ue?this.f.get(ue).children.delete(K.item.extId):this.g.delete(K);const X=[[j]];for(;X.length;)for(const Q of X.pop()){const Z=this.f.get(Q);Z&&(X.push(Z.children),this.f.delete(Q),U.remove?.(Z,Z!==K),Z.expand===2&&this.h--)}}q(j){}updatePendingRoots(j){this.j+=j}v(){return{}}}e.$aK=O}),define(ke[111],Se([1,0,11,4,3,61,90,67]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_M=e.$$M=e.$0M=e.$9M=e.$8M=e.TestItemEventOp=void 0;var $;(function(i){i[i.Upsert=0]="Upsert",i[i.SetTags=1]="SetTags",i[i.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",i[i.RemoveChild=3]="RemoveChild",i[i.SetProp=4]="SetProp",i[i.Bulk=5]="Bulk",i[i.DocumentSynced=6]="DocumentSynced"})($||(e.TestItemEventOp=$={}));const k=(i,r)=>i===r,D=Object.entries({range:(i,r)=>i===r?!0:!i||!r?!1:i.equalsRange(r),busy:k,label:k,description:k,error:k,sortText:k,tags:(i,r)=>!(i.length!==r.length||i.some(n=>!r.includes(n)))}),w=(i,r)=>{let n;for(const[a,t]of D)t(i[a],r[a])||(n?n[a]=r[a]:n={[a]:r[a]});return n};class E extends f.$Tc{get root(){return this.s.root}constructor(r){super(),this.s=r,this.f=this.B(new C.$fh(()=>this.flushDiff(),200)),this.g=this.B(new N.$Vd),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(r){this.h=r;for(const n of this.tree.values())this.J(n)}get resolveHandler(){return this.h}collectDiff(){const r=this.m;return this.m=[],r}pushDiff(r){switch(r.op){case 2:{for(const n of this.m)if(n.op===2&&n.uri===r.uri){n.docv=r.docv;return}break}case 1:{const n=this.m[this.m.length-1];if(n){if(n.op===1&&n.item.extId===r.item.extId){(0,R.$$J)(n.item,r.item);return}if(n.op===0&&n.item.item.extId===r.item.extId){(0,R.$$J)(n.item,r.item);return}}break}}this.m.push(r),this.f.isScheduled()||this.f.schedule()}expand(r,n){const a=this.tree.get(r);if(a){if((a.expandLevels===void 0||n>a.expandLevels)&&(a.expandLevels=n),a.expand===1){const t=this.M(a);return t.isOpen()?this.L(a,n-1):t.wait().then(()=>this.L(a,n-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.L(a,n-1)):this.L(a,n-1)}}dispose(){for(const r of this.tree.values())this.s.getApiFor(r.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(r,n){switch(n.op){case 3:this.O(v.$5J.joinToString(r.fullId,n.id));break;case 0:this.z(n.item,r);break;case 5:for(const a of n.ops)this.w(r,a);break;case 1:this.C(n.new,n.old,r.fullId.toString());break;case 2:this.J(r);break;case 4:this.pushDiff({op:1,item:{extId:r.fullId.toString(),item:n.update}});break;case 6:this.y(r.actual.uri);break;default:(0,P.$6c)(n)}}y(r){r&&this.pushDiff({op:2,uri:r,docv:this.s.getDocumentVersion(r)})}z(r,n){const a=v.$5J.fromExtHostTestItem(r,this.root.id,n?.actual),t=this.s.getApiFor(r);t.parent&&t.parent!==n?.actual&&this.s.getChildren(t.parent).delete(r.id);let h=this.tree.get(a.toString());if(!h){h={fullId:a,actual:r,expandLevels:n?.expandLevels?n.expandLevels-1:void 0,expand:0},r.tags.forEach(this.D,this),this.tree.set(h.fullId.toString(),h),this.G(r,n),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:h.expand,item:this.s.toITestItem(r)}}),this.I(r,h,n);return}if(h.actual===r){this.H(r,h,n);return}if(h.actual.uri?.toString()!==r.uri?.toString())return this.O(a.toString()),this.z(r,n);const s=this.s.getChildren(h.actual),d=h.actual,u=w(this.s.toITestItem(d),this.s.toITestItem(r));this.s.getApiFor(d).listener=void 0,h.actual=r,h.expand=0,u&&(u.hasOwnProperty("tags")&&(this.C(r.tags,d.tags,a.toString()),delete u.tags),this.w(h,{op:4,update:u})),this.I(r,h,n);for(const[l,p]of s)this.s.getChildren(r).get(p.id)||this.O(v.$5J.joinToString(a,p.id));this.y(h.actual.uri)}C(r,n,a){const t=new Set(n.map(h=>h.id));for(const h of r)t.delete(h.id)||this.D(h);this.pushDiff({op:1,item:{extId:a,item:{tags:r.map(h=>(0,R.$9J)(this.s.controllerId,h.id))}}}),t.forEach(this.F,this)}D(r){const n=this.j.get(r.id);n?n.refCount++:(this.j.set(r.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.$9J)(this.s.controllerId,r.id)}}))}F(r){const n=this.j.get(r);n&&!--n.refCount&&(this.j.delete(r),this.pushDiff({op:7,id:(0,R.$9J)(this.s.controllerId,r)}))}G(r,n){this.s.getApiFor(r).parent=n&&n.actual!==this.root?n.actual:void 0}H(r,n,a){this.G(r,a);const t=this.s.getApiFor(r);t.parent=a?.actual,t.listener=h=>this.w(n,h),this.J(n)}I(r,n,a){this.H(r,n,a);for(const[t,h]of this.s.getChildren(r))this.z(h,n)}J(r){let n;this.h?r.resolveBarrier?n=r.resolveBarrier.isOpen()?3:2:n=r.actual.canResolveChildren?1:0:n=0,n!==r.expand&&(r.expand=n,this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:n}}),n===1&&r.expandLevels!==void 0&&this.M(r))}L(r,n){if(n<0)return;const a=[];for(const[t,h]of this.s.getChildren(r.actual)){const s=this.expand(v.$5J.joinToString(r.fullId,h.id),n);(0,C.$Sg)(s)&&a.push(s)}if(a.length)return Promise.all(a).then(()=>{})}M(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this.h){const h=new C.$5g;return h.open(),h}r.expand=2,this.N(r);const n=r.resolveBarrier=new C.$5g,a=h=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,h)};let t;try{t=this.h(r.actual===this.root?void 0:r.actual)}catch(h){a(h)}return(0,C.$Sg)(t)?t.catch(a).then(()=>{n.open(),this.J(r)}):(n.open(),this.J(r)),r.resolveBarrier}N(r){this.pushDiff({op:1,item:{extId:r.fullId.toString(),expand:r.expand}})}O(r){const n=this.tree.get(r);if(!n)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:r});const a=[n];for(;a.length;){const t=a.pop();if(t){this.s.getApiFor(t.actual).listener=void 0;for(const h of t.actual.tags)this.F(h.id);this.tree.delete(t.fullId.toString());for(const[h,s]of this.s.getChildren(t.actual))a.push(this.tree.get(v.$5J.joinToString(t.fullId,s.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.g.fire(r)}}e.$8M=E;class S extends Error{constructor(r){super(`Attempted to insert a duplicate test item ID ${r}`)}}e.$9M=S;class c extends Error{constructor(r){super(`TestItem with ID "${r}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$0M=c;class g extends Error{constructor(r,n,a){super(`TestItem with ID "${r}" is from controller "${n}" and cannot be added as a child of an item from controller "${a}".`)}}e.$$M=g;const o=(i,r,n)=>{let a=new Map;return{get size(){return a.size},forEach(t,h){for(const s of a.values())t.call(h,s,this)},[Symbol.iterator](){return a.entries()},replace(t){const h=new Map,s=new Set(a.keys()),d={op:5,ops:[]};for(const u of t){if(!(u instanceof n))throw new c(u.id);const l=r(u).controllerId;if(l!==i.controllerId)throw new g(u.id,l,i.controllerId);if(h.has(u.id))throw new S(u.id);h.set(u.id,u),s.delete(u.id),d.ops.push({op:0,item:u})}for(const u of s.keys())d.ops.push({op:3,id:u});i.listener?.(d),a=h},add(t){if(!(t instanceof n))throw new c(t.id);a.set(t.id,t),i.listener?.({op:0,item:t})},delete(t){a.delete(t)&&i.listener?.({op:3,id:t})},get(t){return a.get(t)},toJSON(){return Array.from(a.values())}}};e.$_M=o}),define(ke[141],Se([1,0,111]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bN=e.$aN=void 0;const N=new WeakMap,f=(R,v)=>{const $={controllerId:v};return N.set(R,$),$};e.$aN=f;const P=R=>{const v=N.get(R);if(!v)throw new C.$0M(R?.id||"<unknown>");return v};e.$bN=P}),define(ke[112],Se([1,0,16,2]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cwb=e.$bwb=e.$awb=e.$_vb=e.$$vb=void 0,e.$$vb="vscode-cdn.net",e.$_vb=`vscode-resource.${e.$$vb}`,e.$awb=`'self' https://*.${e.$$vb}`;function f(v,$){return v.scheme===C.Schemas.http||v.scheme===C.Schemas.https?v:($&&$.authority&&$.isRemote&&v.scheme===C.Schemas.file&&(v=N.URI.from({scheme:C.Schemas.vscodeRemote,authority:$.authority,path:v.path})),N.URI.from({scheme:C.Schemas.https,authority:`${v.scheme}+${P(v.authority)}.${e.$_vb}`,path:v.path,fragment:v.fragment,query:v.query}))}e.$bwb=f;function P(v){return v.replace(/./g,$=>{const k=$.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?$:"-"+k.toString(16).padStart(4,"0")})}function R(v){return v.replace(/-([0-9a-f]{4})/g,($,k)=>String.fromCharCode(parseInt(k,16)))}e.$cwb=R}),define(ke[287],Se([1,0,4,3,112]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ygc=void 0;class P{constructor(v,$,k){this.d=v,this.e=$,this.f=k,this.a=0,this.b=new N.$Sc,this.c=new Map,this.b.add($.onDidChangeVisibleTextEditors(()=>{const A=$.getVisibleTextEditors();for(const D of this.c.values())A.indexOf(D.editor)<0&&D.inset.dispose()}))}dispose(){this.c.forEach(v=>v.inset.dispose()),this.b.dispose()}createWebviewEditorInset(v,$,k,A,D){let w;for(const r of this.e.getVisibleTextEditors(!0))if(r.value===v){w=r;break}if(!w)throw new Error("not a visible editor");const E=this,S=this.a++,c=new C.$Vd,g=new C.$Vd,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(r){return(0,f.$bwb)(r,E.f)}get cspSource(){return f.$awb}set options(r){this.b=r,E.d.$setOptions(S,r)}get options(){return this.b}set html(r){this.a=r,E.d.$setHtml(S,r)}get html(){return this.a}get onDidReceiveMessage(){return c.event}postMessage(r){return E.d.$postMessage(S,r)}},i=new class{constructor(){this.editor=v,this.line=$,this.height=k,this.webview=o,this.onDidDispose=g.event}dispose(){E.c.has(S)&&(E.c.delete(S),E.d.$disposeEditorInset(S),g.fire(),g.dispose(),c.dispose())}};return this.d.$createEditorInset(S,w.id,w.value.document.uri,$+1,k,A||{},D.identifier,D.extensionLocation),this.c.set(S,{editor:v,inset:i,onDidReceiveMessage:c}),i}$onDidDispose(v){const $=this.c.get(v);$&&$.inset.dispose()}$onDidReceiveMessage(v,$){this.c.get(v)?.onDidReceiveMessage.fire($)}}e.$Ygc=P}),define(ke[288],Se([1,0,5]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5N=e.VariableKind=e.$4N=void 0,e.$4N=(0,C.$6h)("configurationResolverService");var N;(function(P){P.Unknown="unknown",P.Env="env",P.Config="config",P.Command="command",P.Input="input",P.ExtensionInstallFolder="extensionInstallFolder",P.WorkspaceFolder="workspaceFolder",P.Cwd="cwd",P.WorkspaceFolderBasename="workspaceFolderBasename",P.UserHome="userHome",P.LineNumber="lineNumber",P.SelectedText="selectedText",P.File="file",P.FileWorkspaceFolder="fileWorkspaceFolder",P.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",P.RelativeFile="relativeFile",P.RelativeFileDirname="relativeFileDirname",P.FileDirname="fileDirname",P.FileExtname="fileExtname",P.FileBasename="fileBasename",P.FileBasenameNoExtension="fileBasenameNoExtension",P.FileDirnameBasename="fileDirnameBasename",P.ExecPath="execPath",P.ExecInstallFolder="execInstallFolder",P.PathSeparator="pathSeparator",P.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class f extends Error{constructor(R,v){super(v),this.variable=R}}e.$5N=f}),define(ke[289],Se([1,0,17,49,18,24,10,103,231,288,12]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gO=void 0;class D{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(E,S,c,g){this.h=new Map,this.a=E,this.b=S,this.g=c,g&&(this.c=g.then(o=>this.i(o)))}i(E){if(R.$i){const S=Object.create(null);return Object.keys(E).forEach(c=>{S[c.toLowerCase()]=E[c]}),S}return E}resolveWithEnvironment(E,S,c){return this.l({env:this.i(E),userHome:void 0},S?S.uri:void 0,c)}async resolveAsync(E,S){const c={env:await this.c,userHome:await this.g};return this.l(c,E?E.uri:void 0,S)}async j(E,S,c,g){const o=P.$vn(S);R.$i&&o.windows?Object.keys(o.windows).forEach(r=>o[r]=o.windows[r]):R.$j&&o.osx?Object.keys(o.osx).forEach(r=>o[r]=o.osx[r]):R.$k&&o.linux&&Object.keys(o.linux).forEach(r=>o[r]=o.linux[r]),delete o.windows,delete o.osx,delete o.linux;const i={env:await this.c,userHome:await this.g};return this.l(i,E?E.uri:void 0,o,c,g)}async resolveAnyAsync(E,S,c){return this.j(E,S,c)}async resolveAnyMap(E,S,c){const g=new Map;return{newConfig:await this.j(E,S,c,g),resolvedVariables:g}}resolveWithInteractionReplace(E,S,c,g){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(E,S,c,g){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(E,S){if(this.h.has(E))throw new Error("Variable "+E+" is contributed twice.");this.h.set(E,S)}async l(E,S,c,g,o){if(f.$If(c))return this.m(E,S,c,g,o);if(Array.isArray(c))return Promise.all(c.map(i=>this.l(E,S,i,g,o)));if(f.$Kf(c)){const i=Object.create(null),r=await Promise.all(Object.keys(c).map(async n=>[await this.m(E,S,n,g,o),await this.l(E,S,c[n],g,o)]));for(const[n,a]of r)i[n]=a;return i}return c}m(E,S,c,g,o){return(0,A.$4e)(c,D.VARIABLE_REGEXP,async(i,r)=>{if(r.includes(D.VARIABLE_LHS))return i;let n=await this.o(E,i,r,S,g);return o?.set(r,n),n!==i&&f.$If(n)&&n.match(D.VARIABLE_REGEXP)&&(n=await this.m(E,S,n,g,o)),n})}n(E){return this.b?this.b.getUriLabel(E,{noPrefix:!0}):E.fsPath}async o(E,S,c,g,o){let i;const r=c.split(":");r.length>1&&(c=r[0],i=r[1]);const n=h=>{const s=this.a.getFilePath();if(s)return(0,v.$Wv)(s);throw new k.$5N(h,(0,$.localize)(0,null,S))},a=h=>{const s=n(h);if(this.a.getWorkspaceFolderPathForFile){const d=this.a.getWorkspaceFolderPathForFile();if(d)return(0,v.$Wv)(d)}throw new k.$5N(h,(0,$.localize)(1,null,S,C.$nc(s)))},t=h=>{if(i){const s=this.a.getFolderUri(i);if(s)return s;throw new k.$5N(h,(0,$.localize)(2,null,S,i))}if(g)return g;throw this.a.getWorkspaceFolderCount()>1?new k.$5N(h,(0,$.localize)(3,null,S)):new k.$5N(h,(0,$.localize)(4,null,S))};switch(c){case"env":if(i){if(E.env){const h=E.env[R.$i?i.toLowerCase():i];if(f.$If(h))return h}return""}throw new k.$5N(k.VariableKind.Env,(0,$.localize)(5,null,S));case"config":if(i){const h=this.a.getConfigurationValue(g,i);if(f.$Rf(h))throw new k.$5N(k.VariableKind.Config,(0,$.localize)(6,null,S,i));if(f.$Kf(h))throw new k.$5N(k.VariableKind.Config,(0,$.localize)(7,null,S,i));return h}throw new k.$5N(k.VariableKind.Config,(0,$.localize)(8,null,S));case"command":return this.p(k.VariableKind.Command,S,i,o,"command");case"input":return this.p(k.VariableKind.Input,S,i,o,"input");case"extensionInstallFolder":if(i){const h=await this.a.getExtension(i);if(!h)throw new k.$5N(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(9,null,S,i));return this.n(h.extensionLocation)}throw new k.$5N(k.VariableKind.ExtensionInstallFolder,(0,$.localize)(10,null,S));default:switch(c){case"workspaceRoot":case"workspaceFolder":return(0,v.$Wv)(this.n(t(k.VariableKind.WorkspaceFolder)));case"cwd":return g||i?(0,v.$Wv)(this.n(t(k.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,v.$Wv)(C.$nc(this.n(t(k.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(E.userHome)return E.userHome;throw new k.$5N(k.VariableKind.UserHome,(0,$.localize)(11,null,S))}case"lineNumber":{const h=this.a.getLineNumber();if(h)return h;throw new k.$5N(k.VariableKind.LineNumber,(0,$.localize)(12,null,S))}case"selectedText":{const h=this.a.getSelectedText();if(h)return h;throw new k.$5N(k.VariableKind.SelectedText,(0,$.localize)(13,null,S))}case"file":return n(k.VariableKind.File);case"fileWorkspaceFolder":return a(k.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$nc(a(k.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return g||i?C.$lc(this.n(t(k.VariableKind.RelativeFile)),n(k.VariableKind.RelativeFile)):n(k.VariableKind.RelativeFile);case"relativeFileDirname":{const h=C.$mc(n(k.VariableKind.RelativeFileDirname));if(g||i){const s=C.$lc(this.n(t(k.VariableKind.RelativeFileDirname)),h);return s.length===0?".":s}return h}case"fileDirname":return C.$mc(n(k.VariableKind.FileDirname));case"fileExtname":return C.$oc(n(k.VariableKind.FileExtname));case"fileBasename":return C.$nc(n(k.VariableKind.FileBasename));case"fileBasenameNoExtension":{const h=C.$nc(n(k.VariableKind.FileBasenameNoExtension));return h.slice(0,h.length-C.$oc(h).length)}case"fileDirnameBasename":return C.$nc(C.$mc(n(k.VariableKind.FileDirnameBasename)));case"execPath":{const h=this.a.getExecPath();return h||S}case"execInstallFolder":{const h=this.a.getAppRoot();return h||S}case"pathSeparator":case"/":return C.sep;default:try{const h=i?`${c}:${i}`:c;return this.p(k.VariableKind.Unknown,S,h,o,void 0)}catch{return S}}}}p(E,S,c,g,o){if(c&&g){const i=o===void 0?g[c]:g[o+":"+c];if(typeof i=="string")return i;throw new k.$5N(E,(0,$.localize)(14,null,S))}return S}}e.$gO=D}),define(ke[142],Se([1,0,5,139]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_C=e.$$C=e.OpenEditorContext=e.GroupsOrder=e.$0C=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$9C=void 0,e.$9C=(0,C.$6h)("editorGroupsService");var f;(function(S){S[S.UP=0]="UP",S[S.DOWN=1]="DOWN",S[S.LEFT=2]="LEFT",S[S.RIGHT=3]="RIGHT"})(f||(e.GroupDirection=f={}));var P;(function(S){S[S.HORIZONTAL=0]="HORIZONTAL",S[S.VERTICAL=1]="VERTICAL"})(P||(e.GroupOrientation=P={}));var R;(function(S){S[S.FIRST=0]="FIRST",S[S.LAST=1]="LAST",S[S.NEXT=2]="NEXT",S[S.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var v;(function(S){S[S.MAXIMIZE=0]="MAXIMIZE",S[S.EXPAND=1]="EXPAND",S[S.EVEN=2]="EVEN"})(v||(e.GroupsArrangement=v={}));var $;(function(S){S[S.COPY_EDITORS=0]="COPY_EDITORS",S[S.MOVE_EDITORS=1]="MOVE_EDITORS"})($||(e.MergeGroupMode=$={}));function k(S){const c=S;return(0,N.$SE)(c?.editor)&&(0,N.$SE)(c?.replacement)}e.$0C=k;var A;(function(S){S[S.CREATION_TIME=0]="CREATION_TIME",S[S.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",S[S.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(A||(e.GroupsOrder=A={}));var D;(function(S){S[S.NEW_EDITOR=1]="NEW_EDITOR",S[S.MOVE_EDITOR=2]="MOVE_EDITOR",S[S.COPY_EDITOR=3]="COPY_EDITOR"})(D||(e.OpenEditorContext=D={}));function w(S){const c=S;return!!c&&typeof c.id=="number"&&Array.isArray(c.editors)}e.$$C=w;function E(S){return S.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.$_C=E}),define(ke[290],Se([1,0,5,142]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eD=e.$dD=e.$cD=e.$bD=e.$aD=void 0,e.$aD=(0,C.$6h)("editorService"),e.$bD=-1,e.$cD=-2,e.$dD=-3;function f(P){const R=P;return typeof P=="number"||(0,N.$$C)(R)}e.$eD=f}),define(ke[143],Se([1,0,5,133]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xK=void 0,e.$xK=(0,C.$7h)(N.$ai)}),define(ke[144],Se([1,0,25,4,17,3]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$O8b=e.$N8b=e.$M8b=e.$L8b=e.$K8b=void 0;class R{constructor(o,i){this.versionId=o,this.removedDueToLooping=i}}e.$K8b=R;class v{static isHostExtension(o,i,r){if(i.getExtensionDescription(o))return!1;const n=r.getExtensionDescription(o);return n?!!((n.main||n.browser)&&n.api==="none"):!1}constructor(o,i){this.j=o,this.c=new N.$Vd,this.onDidChange=this.c.event,this.d=0,this.e=i,this.k()}k(){this.e.sort(S),this.f=new C.$nm,this.g=[],this.h=new Map;for(const o of this.e){if(this.f.has(o.identifier)){console.error("Extension `"+o.identifier.value+"` is already registered");continue}this.f.set(o.identifier,o),this.g.push(o);const i=this.j.readActivationEvents(o);for(const r of i)this.h.has(r)||this.h.set(r,[]),this.h.get(r).push(o)}}set(o){return this.e=o,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(o,i){this.e=c(this.e,i),this.e=this.e.concat(o);const r=v.l(this.e);return this.e=c(this.e,r.map(n=>n.identifier)),this.k(),this.d++,this.c.fire(void 0),new R(this.d,r)}static l(o){const i=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,s){this.addNode(h),this.addNode(s),this.c.has(h)?this.c.get(h).push(s):this.c.set(h,[s])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,s){const d=i.getArcs(h);for(let u=0;u<d.length;u++)if(!s.has(d[u]))return!1;return!0}getNodes(){return this.e}},r=new C.$nm;for(const h of o)if(r.set(h.identifier,h),h.extensionDependencies)for(const s of h.extensionDependencies)i.addArc(C.$lm.toKey(h.identifier),C.$lm.toKey(s));const n=new Set;i.getNodes().filter(h=>i.getArcs(h).length===0).forEach(h=>n.add(h));const a=i.getNodes().filter(h=>!n.has(h));let t;do{t=!1;for(let h=0;h<a.length;h++){const s=a[h];i.hasOnlyGoodArcs(s,n)&&(a.splice(h,1),h--,n.add(s),t=!0)}}while(t);return a.map(h=>r.get(h))}containsActivationEvent(o){return this.h.has(o)}containsExtension(o){return this.f.has(o)}getExtensionDescriptionsForActivationEvent(o){const i=this.h.get(o);return i?i.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new $(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(o){const i=this.f.get(o);return i||void 0}getExtensionDescriptionByUUID(o){for(const i of this.g)if(i.uuid===o)return i}getExtensionDescriptionByIdOrUUID(o,i){return this.getExtensionDescription(o)??(i?this.getExtensionDescriptionByUUID(i):void 0)}}e.$L8b=v;class ${constructor(o,i){this.versionId=o,this.extensions=i}}e.$M8b=$;class k{constructor(o){this.d=new w,this.c=new v(o,[])}async acquireLock(o){const i=await this.d.acquire(o);return new A(this,i)}deltaExtensions(o,i,r){if(!o.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(i,r)}containsActivationEvent(o){return this.c.containsActivationEvent(o)}containsExtension(o){return this.c.containsExtension(o)}getExtensionDescriptionsForActivationEvent(o){return this.c.getExtensionDescriptionsForActivationEvent(o)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(o){return this.c.getExtensionDescription(o)}getExtensionDescriptionByUUID(o){return this.c.getExtensionDescriptionByUUID(o)}getExtensionDescriptionByIdOrUUID(o,i){return this.c.getExtensionDescriptionByIdOrUUID(o,i)}}e.$N8b=k;class A extends P.$Tc{constructor(o,i){super(),this.f=o,this.c=!1,this.B(i)}isAcquiredFor(o){return!this.c&&this.f===o}}e.$O8b=A;class D{constructor(o){this.name=o,this.promise=new Promise((i,r)=>{this.c=i})}resolve(o){this.c(o)}}class w{constructor(){this.c=[],this.d=!1}async acquire(o){const i=new D(o);return this.c.push(i),this.e(),i.promise}e(){if(this.d||this.c.length===0)return;const o=this.c.shift();this.d=!0;let i=!0;const r=setTimeout(()=>{i&&console.warn(`The customer named ${o.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),n=()=>{i&&(clearTimeout(r),i=!1,this.d=!1,this.e())};o.resolve((0,P.$Rc)(n))}}var E;(function(g){g[g.Builtin=0]="Builtin",g[g.User=1]="User",g[g.Dev=2]="Dev"})(E||(E={}));function S(g,o){const i=g.isBuiltin?0:g.isUnderDevelopment?2:1,r=o.isBuiltin?0:o.isUnderDevelopment?2:1;if(i!==r)return i-r;const n=f.$gc.basename(g.extensionLocation.path),a=f.$gc.basename(o.extensionLocation.path);return n<a?-1:n>a?1:0}function c(g,o){const i=new C.$mm(o);return g.filter(r=>!i.has(r.identifier))}}),define(ke[291],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tm=e.$Sm=e.$Rm=e.$Qm=e.$Pm=e.ExtHostConnectionType=void 0;var C;(function(A){A[A.IPC=1]="IPC",A[A.Socket=2]="Socket",A[A.MessagePort=3]="MessagePort"})(C||(e.ExtHostConnectionType=C={}));class N{static{this.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK"}constructor(D){this.pipeName=D,this.type=1}serialize(D){D[N.ENV_KEY]=this.pipeName}}e.$Pm=N;class f{constructor(){this.type=2}static{this.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET"}serialize(D){D[f.ENV_KEY]="1"}}e.$Qm=f;class P{constructor(){this.type=3}static{this.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT"}serialize(D){D[P.ENV_KEY]="1"}}e.$Rm=P;function R(A){delete A[N.ENV_KEY],delete A[f.ENV_KEY],delete A[P.ENV_KEY]}function v(A,D){R(D),A.serialize(D)}e.$Sm=v;function $(A){if(A[N.ENV_KEY])return k(A,new N(A[N.ENV_KEY]));if(A[f.ENV_KEY])return k(A,new f);if(A[P.ENV_KEY])return k(A,new P);throw new Error("No connection information defined in environment!")}e.$Tm=$;function k(A,D){return R(A),D}}),define(ke[113],Se([1,0,22]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.$um=e.$tm=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var N;(function(k){k[k.Desktop=1]="Desktop",k[k.Web=2]="Web"})(N||(e.UIKind=N={}));var f;(function(k){k[k.VersionMismatch=55]="VersionMismatch",k[k.UnexpectedError=81]="UnexpectedError"})(f||(e.ExtensionHostExitCode=f={}));var P;(function(k){k[k.Initialized=0]="Initialized",k[k.Ready=1]="Ready",k[k.Terminate=2]="Terminate"})(P||(e.MessageType=P={}));function R(k){const A=C.$je.alloc(1);switch(k){case 0:A.writeUInt8(1,0);break;case 1:A.writeUInt8(2,0);break;case 2:A.writeUInt8(3,0);break}return A}e.$tm=R;function v(k,A){if(k.byteLength!==1)return!1;switch(k.readUInt8(0)){case 1:return A===0;case 2:return A===1;case 3:return A===2;default:return!1}}e.$um=v;var $;(function(k){k.Start="START_NATIVE_LOG",k.End="END_NATIVE_LOG"})($||(e.NativeLogMarkers=$={}))}),define(ke[91],Se([1,0,5,4,13,27,113,65,88,24,2,3,217]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zN=e.$yN=e.$xN=e.$wN=void 0;let E=class extends D.$Tc{constructor(o,i){super(),this.s=o,this.t=i,this.a=this.B(new N.$Vd),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$Vd),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=A.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=i.createLogger(this.m,{id:$.$Qo,name:(0,w.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(i.onDidChangeLogLevel(r=>{(0,f.$pj)(r)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===f.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,i,r){const n=this.getTelemetryDetails(),a=new S(i,r,o,this.n,this.j,this.getBuiltInCommonProperties(o),{isUsageEnabled:n.isUsageEnabled,isErrorsEnabled:n.isErrorsEnabled}),t=this.r.get(o.identifier.value)??[];return this.r.set(o.identifier.value,[...t,a]),a.apiTelemetryLogger}$initializeTelemetryLevel(o,i,r){this.f=o,this.g=i,this.c=r??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(o){const i=Object.create(null);switch(i["common.extname"]=`${o.publisher}.${o.name}`,i["common.extversion"]=o.version,i["common.vscodemachineid"]=this.s.telemetryInfo.machineId,i["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,i["common.sqmid"]=this.s.telemetryInfo.sqmId,i["common.vscodeversion"]=this.s.version,i["common.isnewappinstall"]=c(this.s.telemetryInfo.firstSessionDate),i["common.product"]=this.s.environment.appHost,this.s.uiKind){case R.UIKind.Web:i["common.uikind"]="web";break;case R.UIKind.Desktop:i["common.uikind"]="desktop";break;default:i["common.uikind"]="unknown"}return i["common.remotename"]=(0,v.$bl)((0,$.$Wo)(this.s.remote.authority)),i}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const i=this.getTelemetryDetails();this.r.forEach((r,n)=>{const a=r.filter(t=>!t.isDisposed);a.length===0?this.r.delete(n):this.r.set(n,a)}),this.r.forEach(r=>{for(const n of r)n.updateTelemetryEnablements(i.isUsageEnabled,i.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(o,i){const n=this.r.get(o.value)?.filter(t=>!t.isDisposed);if(!n)return this.r.delete(o.value),!1;let a=!1;for(const t of n)t.ignoreUnhandledExtHostErrors||(t.logError(i),a=!0);return a}};e.$wN=E,e.$wN=E=Ge([We(0,P.$vN),We(1,f.$oj)],E);class S{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,i,r,n,a,t,h){this.g=r,this.h=n,this.i=a,this.j=t,this.a=new N.$Vd,this.ignoreUnhandledExtHostErrors=i?.ignoreUnhandledErrors??!1,this.b=i?.ignoreBuiltInCommonProperties??!1,this.c=i?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:h.isUsageEnabled,isErrorsEnabled:h.isErrorsEnabled}}updateTelemetryEnablements(o,i){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:i},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let i="properties"in o?o.properties??{}:o;return i=(0,$.$Zo)(i,[]),this.c&&(i=(0,k.$yn)(i,this.c)),this.b||(i=(0,k.$yn)(i,this.j)),"properties"in o?o.properties=i:o=i,o}k(o,i){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f?.sendEventData(o,i),this.h.trace(o,i))}logUsage(o,i){this.d.isUsageEnabled&&this.k(o,i)}logError(o,i){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof o=="string")this.k(o,i);else{const r={name:o.name,message:o.message,stack:o.stack,cause:o.cause},n=(0,$.$Zo)(r,[]),a=new Error(n.message,{cause:n.cause});a.stack=n.stack,a.name=n.name,i=this.mixInCommonPropsAndCleanData(i||{}),this.i||this.f.sendErrorData(a,i),this.h.trace("exception",i)}}get apiTelemetryLogger(){if(!this.e){const o=this,i={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(i)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.$xN=S;function c(g){const o=Date.now()-new Date(g).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.$yN=c,e.$zN=(0,C.$6h)("IExtHostTelemetry")}),define(ke[26],Se([1,0,4,2,261,137,25,5]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LF=e.$KF=e.$JF=e.ActivationKind=e.$IF=e.$HF=e.$GF=e.$FF=e.$EF=e.ExtensionHostStartup=e.$DF=e.$CF=e.$BF=e.$AF=void 0,e.$AF=Object.freeze({identifier:new R.$lm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$BF="extensions.webWorker",e.$CF=(0,v.$6h)("extensionService");class ${constructor(a){this.dependency=a}}e.$DF=$;var k;(function(n){n[n.EagerAutoStart=1]="EagerAutoStart",n[n.EagerManualStart=2]="EagerManualStart",n[n.Lazy=3]="Lazy"})(k||(e.ExtensionHostStartup=k={}));class A{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(a,t,h){this.c=a,this.d=t.slice(0),this.e=h.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:P.$lF.createActivationEventsMap(this.d)}}set(a,t,h){if(this.c>a)throw new Error(`ExtensionHostExtensions: invalid versionId ${a} (current: ${this.c})`);const s=[],d=[],u=[],l=[],p=D(this.d),I=D(t),b=(z,T)=>z.extensionLocation.toString()===T.extensionLocation.toString()||z.isBuiltin===T.isBuiltin||z.isUserBuiltin===T.isUserBuiltin||z.isUnderDevelopment===T.isUnderDevelopment;for(const z of this.d){const T=I.get(z.identifier);if(!T){s.push(z.identifier),p.delete(z.identifier);continue}if(!b(z,T)){s.push(z.identifier),p.delete(z.identifier);continue}}for(const z of t){const T=p.get(z.identifier);if(!T){d.push(z);continue}if(!b(T,z)){s.push(T.identifier),p.delete(T.identifier);continue}}const m=new R.$mm(this.e),y=new R.$mm(h);for(const z of this.e)y.has(z)||u.push(z);for(const z of h)m.has(z)||l.push(z);const L=P.$lF.createActivationEventsMap(d),F={versionId:a,toRemove:s,toAdd:d,addActivationEvents:L,myToRemove:u,myToAdd:l};return this.delta(F),F}delta(a){if(this.c>=a.versionId)return null;const{toRemove:t,toAdd:h,myToRemove:s,myToAdd:d}=a,u=new R.$mm(t),l=new R.$mm(s);for(let p=0;p<this.d.length;p++)u.has(this.d[p].identifier)&&(this.d.splice(p,1),p--);for(let p=0;p<this.e.length;p++)l.has(this.e[p])&&(this.e.splice(p,1),p--);for(const p of h)this.d.push(p);for(const p of d)this.e.push(p);return this.f=null,a}containsExtension(a){for(const t of this.e)if(R.$lm.equals(t,a))return!0;return!1}containsActivationEvent(a){return this.f||(this.f=this.g()),this.f.has(a)}g(){const a=new Set;for(const t of this.d){if(!this.containsExtension(t.identifier))continue;const h=P.$lF.readActivationEvents(t);for(const s of h)a.add(s)}return a}}e.$EF=A;function D(n){const a=new R.$nm;for(const t of n)a.set(t.identifier,t);return a}function w(n,a){return n.enabledApiProposals?n.enabledApiProposals.includes(a):!1}e.$FF=w;function E(n,a){if(!w(n,a))throw new Error(`Extension '${n.identifier.value}' CANNOT use API proposal: ${a}.
Its package.json#enabledApiProposals-property declares: ${n.enabledApiProposals?.join(", ")??"[]"} but NOT ${a}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${n.identifier.value}`)}e.$GF=E;class S{constructor(a,t,h,s){this.codeLoadingTime=a,this.activateCallTime=t,this.activateResolvedTime=h,this.activationReason=s}}e.$HF=S;class c{constructor(a,t){this.description=a,this.value=t}}e.$IF=c;var g;(function(n){n[n.Normal=0]="Normal",n[n.Immediate=1]="Immediate"})(g||(e.ActivationKind=g={}));function o(n){return{type:n.isBuiltin?0:1,isBuiltin:n.isBuiltin||n.isUserBuiltin,identifier:{id:(0,f.$6o)(n.publisher,n.name),uuid:n.uuid},manifest:n,location:n.extensionLocation,targetPlatform:n.targetPlatform,validations:[],isValid:!0}}e.$JF=o;function i(n,a){return{identifier:new R.$lm((0,f.$4o)(n.manifest.publisher,n.manifest.name)),isBuiltin:n.type===0,isUserBuiltin:n.type===1&&n.isBuiltin,isUnderDevelopment:!!a,extensionLocation:n.location,...n.manifest,uuid:n.identifier.uuid,targetPlatform:n.targetPlatform}}e.$KF=i;class r{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(a){return Promise.resolve(void 0)}activateById(a,t){return Promise.resolve(void 0)}activationEventIsDone(a){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(a){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(a,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(a){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$LF=r}),define(ke[292],Se([1,0,14,144,25,26,13,11]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nhc=e.$mhc=e.$lhc=e.$khc=e.$jhc=e.$ihc=void 0;class ${static{this.NONE=new $(!1,-1,-1,-1)}constructor(o,i,r,n){this.startup=o,this.codeLoadingTime=i,this.activateCallTime=r,this.activateResolvedTime=n}}e.$ihc=$;class k{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,i){return o===-1||i===-1?-1:i-o}build(){return new $(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$jhc=k;class A{constructor(o,i,r,n,a,t){this.activationFailed=o,this.activationFailedError=i,this.activationTimes=r,this.module=n,this.exports=a,this.subscriptions=t}}e.$khc=A;class D extends A{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.$lhc=D;class w extends A{constructor(){super(!1,null,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$mhc=w;class E extends A{constructor(o){super(!0,o,$.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let S=class{constructor(o,i,r,n){this.g=n,this.a=o,this.b=i,this.c=r,this.d=new f.$nm,this.f=Object.create(null)}dispose(){for(const[o,i]of this.d)i.dispose()}async waitForActivatingExtensions(){const o=[];for(const[i,r]of this.d)o.push(r.wait());await Promise.all(o)}isActivated(o){const i=this.d.get(o);return!!(i&&i.value)}getActivatedExtension(o){const i=this.d.get(o);if(!i||!i.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return i.value}async activateByEvent(o,i){if(this.f[o])return;const r=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(r.map(n=>({id:n.identifier,reason:{startup:i,extensionId:n.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,i){const r=this.a.getExtensionDescription(o);if(!r)throw new Error(`Extension '${o}' is not known`);return this.h([{id:r.identifier,reason:i}])}async h(o){const i=o.filter(r=>!this.isActivated(r.id)).map(r=>this.j(r));await Promise.all(i.map(r=>r.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const i=this.a.getExtensionDescription(o.id);if(!i){const a=new Error(`Cannot activate unknown extension '${o.id.value}'`),t=this.k(o,null,[],new E(a));return this.c.onExtensionActivationError(o.id,a,new P.$DF(o.id.value)),t}const r=[],n=typeof i.extensionDependencies>"u"?[]:i.extensionDependencies;for(const a of n){if(this.m(a))continue;const t=this.d.get(a);if(t){r.push(t);continue}if(this.l(a)){r.push(this.j({id:this.b.getExtensionDescription(a).identifier,reason:o.reason}));continue}const h=this.a.getExtensionDescription(a);if(h){if(!h.main&&!h.browser)continue;r.push(this.j({id:h.identifier,reason:o.reason}));continue}const s=i.displayName||i.identifier.value,d=new Error(`Cannot activate the '${s}' extension because it depends on unknown extension '${a}'`),u=this.k(o,i.displayName,[],new E(d));return this.c.onExtensionActivationError(i.identifier,d,new P.$DF(a)),u}return this.k(o,i.displayName,r,null)}k(o,i,r,n){const a=new c(o.id,i,o.reason,r,n,this.c,this.g);return this.d.set(o.id,a),a}l(o){return N.$L8b.isHostExtension(o,this.a,this.b)}m(o){const i=this.b.getExtensionDescription(o);return i?!i.main&&!i.browser:!1}};e.$nhc=S,e.$nhc=S=Ge([We(3,R.$nj)],S);let c=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,i,r,n,a,t,h){this.c=o,this.d=i,this.f=r,this.g=n,this.h=a,this.j=t,this.k=h,this.a=new v.$5g,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const i=this.g[o];if(i.value&&!i.value.activationFailed){this.g.splice(o,1),o--;continue}if(i.value&&i.value.activationFailed){const r=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${i.friendlyName}' failed to activate`);r.detail=i.value.activationFailedError,this.h=new E(r),this.j.onExtensionActivationError(this.c,r,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const i=new Error;if(o&&o.name&&(i.name=o.name),o&&o.message?i.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:i.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(i.stack=o.stack),this.h=new E(i),this.b&&C.$4(o))return;this.j.onExtensionActivationError(this.c,i,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};c=Ge([We(6,R.$nj)],c)}),define(ke[293],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chat:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chat.d.ts",chatAgents2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2.d.ts",chatAgents2Additions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatAgents2Additions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatRequestAccess:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatRequestAccess.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatAgent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatAgent.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",testingActiveProfile:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testingActiveProfile.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",windowActivity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.windowActivity.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ke[294],Se([1,0,233,14,39,134,108,37,25,293,136,137]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zF=e.$yF=e.$xF=e.$wF=e.$vF=e.$uF=void 0;const w=v.$Hn.as(R.$In.JSONContribution);class E{constructor(a,t,h){this.a=a,this.b=t,this.c=h}d(a,t){this.a({type:a,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(a){this.d(f.default.Error,a)}warn(a){this.d(f.default.Warning,a)}info(a){this.d(f.default.Info,a)}}e.$uF=E;class S{static a(a){const t=new $.$mm;for(let h=0,s=a.length;h<s;h++)t.add(a[h].description.identifier);return t}static compute(a,t){if(!a||!a.length)return new S(t,[]);if(!t||!t.length)return new S([],a);const h=this.a(a),s=this.a(t),d=t.filter(l=>!h.has(l.description.identifier)),u=a.filter(l=>!s.has(l.description.identifier));return new S(d,u)}constructor(a,t){this.added=a,this.removed=t}}e.$vF=S;class c{constructor(a,t){this.name=a,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(a){if(this.a!==null)throw new Error("Handler already set!");this.a=a,this.d()}acceptUsers(a){this.c=S.compute(this.b,a),this.b=a,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(a){(0,N.$1)(a)}}}e.$wF=c;const g={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.$xF={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:$.$km},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$mo}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:P.$mo}},extensionKind:{description:C.localize(52,null),type:"array",items:g,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class i{constructor(){this.a=new Map}registerExtensionPoint(a){if(this.a.has(a.extensionPoint))throw new Error("Duplicate extension point: "+a.extensionPoint);const t=new c(a.extensionPoint,a.defaultExtensionKind);return this.a.set(a.extensionPoint,t),a.activationEventsGenerator&&D.$lF.register(a.extensionPoint,a.activationEventsGenerator),e.$xF.properties.contributes.properties[a.extensionPoint]=a.jsonSchema,w.registerSchema(o,e.$xF),t}getExtensionPoints(){return Array.from(this.a.values())}}e.$yF=i;const r={ExtensionsRegistry:"ExtensionsRegistry"};v.$Hn.add(r.ExtensionsRegistry,new i),e.$zF=v.$Hn.as(r.ExtensionsRegistry),w.registerSchema(o,e.$xF),w.registerSchema(A.$Gj,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(k.allApiProposals),markdownEnumDescriptions:Object.values(k.allApiProposals)}}]}}}})}),define(ke[295],Se([1,0,229,18,24,294,45,4]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xG=void 0;const $={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var k;(function(w){function E(S,c,g){if(!S)return;const o=N.$If(S.type)?S.type:void 0;if(!o||o.length===0){g.error(C.localize(3,null));return}const i=[];if(Array.isArray(S.required))for(const r of S.required)N.$If(r)&&i.push(r);return{extensionId:c.value,taskType:o,required:i,properties:S.properties?f.$vn(S.properties):{},when:S.when?R.$4i.deserialize(S.when):void 0}}w.from=E})(k||(k={}));const A=P.$zF.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(w,E)=>{for(const S of w)S.type&&E.push(`onTaskType:${S.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:$}});class D{constructor(){this.d=new v.$Vd,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((E,S)=>{A.setHandler((c,g)=>{this.c=void 0;try{for(const o of g.removed){const i=o.value;for(const r of i)this.a&&r.type&&this.a[r.type]&&delete this.a[r.type]}for(const o of g.added){const i=o.value;for(const r of i){const n=k.from(r,o.description.identifier,o.collector);n&&(this.a[n.taskType]=n)}}(g.removed.length>0||g.added.length>0)&&this.d.fire()}catch{}E(void 0)})})}onReady(){return this.b}get(E){return this.a[E]}all(){return Object.keys(this.a).map(E=>this.a[E])}getJsonSchema(){if(this.c===void 0){const E=[];for(const S of this.all()){const c={type:"object",additionalProperties:!1};S.required.length>0&&(c.required=S.required.slice(0)),S.properties!==void 0?c.properties=f.$vn(S.properties):c.properties=Object.create(null),c.properties.type={type:"string",enum:[S.taskType]},E.push(c)}this.c={oneOf:E}}return this.c}}e.$xG=new D}),define(ke[296],Se([1,0,230,18,23,24,45,295]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$HG=e.JsonSchemaVersion=e.ExecutionEngine=e.$GG=e.$FG=e.$EG=e.$DG=e.$CG=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$BG=e.ShellQuoting=e.$AG=e.$zG=e.$yG=void 0,e.$yG="settings",e.$zG=new R.$kj("taskRunning",!1,C.localize(0,null)),e.$AG={value:C.localize(1,null),original:"Tasks"};var $;(function(M){M[M.Escape=1]="Escape",M[M.Strong=2]="Strong",M[M.Weak=3]="Weak"})($||(e.ShellQuoting=$={})),e.$BG="$customized",function(M){function j(U){if(!U)return M.Strong;switch(U.toLowerCase()){case"escape":return M.Escape;case"strong":return M.Strong;case"weak":return M.Weak;default:return M.Strong}}M.from=j}($||(e.ShellQuoting=$={}));var k;(function(M){M.defaults={cwd:"${workspaceFolder}"}})(k||(e.CommandOptions=k={}));var A;(function(M){M[M.Always=1]="Always",M[M.Silent=2]="Silent",M[M.Never=3]="Never"})(A||(e.RevealKind=A={})),function(M){function j(U){switch(U.toLowerCase()){case"always":return M.Always;case"silent":return M.Silent;case"never":return M.Never;default:return M.Always}}M.fromString=j}(A||(e.RevealKind=A={}));var D;(function(M){M[M.Never=1]="Never",M[M.OnProblem=2]="OnProblem",M[M.Always=3]="Always"})(D||(e.RevealProblemKind=D={})),function(M){function j(U){switch(U.toLowerCase()){case"always":return M.Always;case"never":return M.Never;case"onproblem":return M.OnProblem;default:return M.OnProblem}}M.fromString=j}(D||(e.RevealProblemKind=D={}));var w;(function(M){M[M.Shared=1]="Shared",M[M.Dedicated=2]="Dedicated",M[M.New=3]="New"})(w||(e.PanelKind=w={})),function(M){function j(U){switch(U.toLowerCase()){case"shared":return M.Shared;case"dedicated":return M.Dedicated;case"new":return M.New;default:return M.Shared}}M.fromString=j}(w||(e.PanelKind=w={}));var E;(function(M){M.defaults={echo:!0,reveal:A.Always,revealProblems:D.Never,focus:!1,panel:w.Shared,showReuseMessage:!0,clear:!1}})(E||(e.PresentationOptions=E={}));var S;(function(M){M[M.Shell=1]="Shell",M[M.Process=2]="Process",M[M.CustomExecution=3]="CustomExecution"})(S||(e.RuntimeType=S={})),function(M){function j(K){switch(K.toLowerCase()){case"shell":return M.Shell;case"process":return M.Process;case"customExecution":return M.CustomExecution;default:return M.Process}}M.fromString=j;function U(K){switch(K){case M.Shell:return"shell";case M.Process:return"process";case M.CustomExecution:return"customExecution";default:return"process"}}M.toString=U}(S||(e.RuntimeType=S={}));var c;(function(M){function j(U){return N.$If(U)?U:U.value}M.value=j})(c||(e.CommandString=c={}));var g;(function(M){M.Clean={_id:"clean",isDefault:!1},M.Build={_id:"build",isDefault:!1},M.Rebuild={_id:"rebuild",isDefault:!1},M.Test={_id:"test",isDefault:!1};function j(K){return K===M.Clean._id||K===M.Build._id||K===M.Rebuild._id||K===M.Test._id}M.is=j;function U(K){if(K!==void 0)return N.$If(K)?j(K)?{_id:K,isDefault:!1}:void 0:K}M.from=U})(g||(e.TaskGroup=g={}));var o;(function(M){M[M.Global=1]="Global",M[M.Workspace=2]="Workspace",M[M.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var i;(function(M){M.Workspace="workspace",M.Extension="extension",M.InMemory="inMemory",M.WorkspaceFile="workspaceFile",M.User="user";function j(U){switch(U){case M.User:return 2;case M.WorkspaceFile:return 5;default:return 6}}M.toConfigurationTarget=j})(i||(e.TaskSourceKind=i={}));var r;(function(M){M.parallel="parallel",M.sequence="sequence"})(r||(e.DependsOrder=r={}));var n;(function(M){M[M.default=1]="default",M[M.folderOpen=2]="folderOpen"})(n||(e.RunOnOptions=n={}));var a;(function(M){M.defaults={reevaluateOnRerun:!0,runOn:n.default,instanceLimit:1}})(a||(e.RunOptions=a={}));class t{constructor(j,U,K,ue,X,Q){this._label="",this._id=j,U&&(this._label=U),K&&(this.type=K),this.runOptions=ue,this.configurationProperties=X,this._source=Q}getDefinition(j){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const j={folder:this.d(),id:this._id};return JSON.stringify(j)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(j,U=!1){if(j===void 0)return!1;if(N.$If(j))return j===this._label||j===this.configurationProperties.identifier||U&&j===this._id;const K=this.getDefinition(!0);return K!==void 0&&K._key===j._key}getQualifiedLabel(){const j=this.getWorkspaceFolder();return j?`${this._label} (${j.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(j){this.c===void 0&&(this.c=[]),j&&(this.c=this.c.concat(j))}get taskLoadMessages(){return this.c}}e.$CG=t;class h extends t{constructor(j,U,K,ue,X,Q,Z,le){super(j,K,void 0,Z,le,U),this.command={},this._source=U,this.hasDefinedMatchers=Q,X&&(this.command=X)}clone(){return new h(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(j=!1){if(j&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case S.Shell:U="shell";break;case S.Process:U="process";break;case S.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(j){return j instanceof h}getMapKey(){const j=this._source.config.workspaceFolder;return j?`${j.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===i.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const K={type:e.$BG,folder:j,id:U};return JSON.stringify(K)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Eg(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(j){return new h(j._id,j._source,j._label,j.type,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$DG=h;class s extends t{constructor(j,U,K,ue,X,Q,Z){super(j,K,ue,Q,Z,U),this._source=U,this.configures=X}static is(j){return j instanceof s}f(j){return j}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?f.$Eg(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===i.User?e.$yG:this._source.config.workspaceFolder?.uri.toString()}getKey(){const j=this.d();if(!j)return;let U=this.configurationProperties.identifier;this._source.kind!==i.Workspace&&(U+=this._source.kind);const K={type:e.$BG,folder:j,id:U};return JSON.stringify(K)}}e.$EG=s;class d extends t{constructor(j,U,K,ue,X,Q,Z,le,re){super(j,K,ue,le,re,U),this.defines=X,this.hasDefinedMatchers=Z,this.command=Q,this.icon=re.icon,this.hide=re.hide}clone(){return new d(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(j){return j instanceof d}getMapKey(){const j=this._source.workspaceFolder;return j?`${this._source.scope.toString()}|${j.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const j={type:"contributed",scope:this._source.scope,id:this._id};return j.folder=this.d(),JSON.stringify(j)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(j){return new d(j._id,j._source,j._label,j.type,j.defines,j.command,j.hasDefinedMatchers,j.runOptions,j.configurationProperties)}}e.$FG=d;class u extends t{constructor(j,U,K,ue,X,Q){super(j,K,ue,X,Q,U),this._source=U}clone(){return new u(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(j){return j instanceof u}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(j){return new u(j._id,j._source,j._label,j.type,j.runOptions,j.configurationProperties)}}e.$GG=u;var l;(function(M){M[M.Process=1]="Process",M[M.Terminal=2]="Terminal"})(l||(e.ExecutionEngine=l={})),function(M){M._default=M.Terminal}(l||(e.ExecutionEngine=l={}));var p;(function(M){M[M.V0_1_0=1]="V0_1_0",M[M.V2_0_0=2]="V2_0_0"})(p||(e.JsonSchemaVersion=p={}));class I{constructor(j){this.c=new Map;for(let U=0;U<j.length;U++)this.c.set(j[U].uri.toString(),U)}compare(j,U){const K=j.getWorkspaceFolder(),ue=U.getWorkspaceFolder();if(K&&ue){let X=this.c.get(K.uri.toString());X=X===void 0?0:X+1;let Q=this.c.get(ue.uri.toString());return Q=Q===void 0?0:Q+1,X===Q?j._label.localeCompare(U._label):X-Q}else return!K&&ue?-1:K&&!ue?1:0}}e.$HG=I;var b;(function(M){M.DependsOnStarted="dependsOnStarted",M.AcquiredInput="acquiredInput",M.Start="start",M.ProcessStarted="processStarted",M.Active="active",M.Inactive="inactive",M.Changed="changed",M.Terminated="terminated",M.ProcessEnded="processEnded",M.End="end"})(b||(e.TaskEventKind=b={}));var m;(function(M){M.SingleRun="singleRun",M.Background="background"})(m||(e.TaskRunType=m={}));var y;(function(M){M[M.System=0]="System",M[M.User=1]="User",M[M.FolderOpen=2]="FolderOpen",M[M.ConfigurationChange=3]="ConfigurationChange",M[M.Reconnect=4]="Reconnect"})(y||(e.TaskRunSource=y={}));var L;(function(M){function j(le){return{taskId:le._id,taskName:le.configurationProperties.name,runType:le.configurationProperties.isBackground?"background":"singleRun",group:le.configurationProperties.group,__task:le}}function U(le,re,$e){return{...j(le),kind:"start",terminalId:re,resolvedVariables:$e}}M.start=U;function K(le,re,$e){return{...j(le),kind:"processStarted",terminalId:re,processId:$e}}M.processStarted=K;function ue(le,re,$e){return{...j(le),kind:"processEnded",terminalId:re,exitCode:$e}}M.processEnded=ue;function X(le,re,$e){return{...j(le),kind:"terminated",exitReason:$e,terminalId:re}}M.terminated=X;function Q(le,re,$e){return{...j(re),kind:le,terminalId:$e}}M.general=Q;function Z(){return{kind:"changed"}}M.changed=Z})(L||(e.TaskEvent=L={}));var F;(function(M){function j(K){const ue=Object.keys(K).sort();let X="";for(const Q of ue){let Z=K[Q];Z instanceof Object?Z=j(Z):typeof Z=="string"&&(Z=Z.replace(/,/g,",,")),X+=Q+","+Z+","}return X}function U(K){const X={_key:j(K),type:K.taskType};return Object.assign(X,K),X}M.create=U})(F||(e.KeyedTaskIdentifier=F={}));var z;(function(M){M.AutoDetect="task.autoDetect",M.SaveBeforeRun="task.saveBeforeRun",M.ShowDecorations="task.showDecorations",M.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",M.SlowProviderWarning="task.slowProviderWarning",M.QuickOpenHistory="task.quickOpen.history",M.QuickOpenDetail="task.quickOpen.detail",M.QuickOpenSkip="task.quickOpen.skip",M.QuickOpenShowAll="task.quickOpen.showAll",M.AllowAutomaticTasks="task.allowAutomaticTasks",M.Reconnection="task.reconnection",M.VerboseLogging="task.verboseLogging"})(z||(e.TaskSettingId=z={}));var T;(function(M){M.Tasks="tasks",M.SuppressTaskName="tasks.suppressTaskName",M.Windows="tasks.windows",M.Osx="tasks.osx",M.Linux="tasks.linux",M.ShowOutput="tasks.showOutput",M.IsShellCommand="tasks.isShellCommand",M.ServiceTestSetting="tasks.service.testSetting"})(T||(e.TasksSchemaProperties=T={}));var O;(function(M){function j(U,K){const ue=v.$xG.get(U.type);if(ue===void 0){const le=P.$vn(U);return delete le._key,F.create(le)}const X=Object.create(null);X.type=ue.taskType;const Q=new Set;ue.required.forEach(le=>Q.add(le));const Z=ue.properties;for(const le of Object.keys(Z)){const re=U[le];if(re!=null)X[le]=re;else if(Q.has(le)){const $e=Z[le];if($e.default!==void 0)X[le]=P.$vn($e.default);else switch($e.type){case"boolean":X[le]=!1;break;case"number":case"integer":X[le]=0;break;case"string":X[le]="";break;default:K.error(C.localize(2,null,JSON.stringify(U,void 0,0),le));return}}}return F.create(X)}M.createTaskIdentifier=j})(O||(e.TaskDefinition=O={}))}),define(ke[297],Se([1,0,14]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Q8b=e.$P8b=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,v)=>{this.b=R,this.d=v,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,C.$1)(R))}then(R,v){return this.j().then(R,v)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.$P8b=N;class f extends N{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$Q8b=f}),define(ke[68],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tv=e.$Sv=e.$Rv=e.$Qv=void 0;class C{static{this.count=0}constructor($){this._proxyIdentifierBrand=void 0,this.sid=$,this.nid=++C.count}}e.$Qv=C;const N=[];function f(v){const $=new C(v);return N[$.nid]=$,$}e.$Rv=f;function P(v){return N[v].sid}e.$Sv=P;class R{constructor($){this.value=$}}e.$Tv=R}),define(ke[6],Se([1,0,68]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bL=e.$aL=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$_K=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var f;(function(c){c[c.UnknownInput=0]="UnknownInput",c[c.TextInput=1]="TextInput",c[c.TextDiffInput=2]="TextDiffInput",c[c.TextMergeInput=3]="TextMergeInput",c[c.NotebookInput=4]="NotebookInput",c[c.NotebookDiffInput=5]="NotebookDiffInput",c[c.CustomEditorInput=6]="CustomEditorInput",c[c.WebviewEditorInput=7]="WebviewEditorInput",c[c.TerminalEditorInput=8]="TerminalEditorInput",c[c.InteractiveEditorInput=9]="InteractiveEditorInput",c[c.ChatEditorInput=10]="ChatEditorInput"})(f||(e.TabInputKind=f={}));var P;(function(c){c[c.TAB_OPEN=0]="TAB_OPEN",c[c.TAB_CLOSE=1]="TAB_CLOSE",c[c.TAB_UPDATE=2]="TAB_UPDATE",c[c.TAB_MOVE=3]="TAB_MOVE"})(P||(e.TabModelOperationKind=P={}));var R;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var v;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(v||(e.WebviewMessageArrayBufferViewType=v={}));var $;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})($||(e.CellOutputKind=$={}));var k;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(k||(e.NotebookEditorRevealType=k={}));var A;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(A||(e.CandidatePortSource=A={}));class D{static{this.a=0}static mixin(g){return g._id=D.a++,g}}e.$_K=D;var w;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.kindModifier="m",c.commandIdent="n",c.commandId="o",c.commandArguments="p"})(w||(e.ISuggestDataDtoField=w={}));var E;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(E||(e.ISuggestResultDtoField=E={}));var S;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(S||(e.ExtHostTestingResource=S={})),e.$aL={MainThreadAuthentication:(0,C.$Rv)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$Rv)("MainThreadBulkEdits"),MainThreadChatProvider:(0,C.$Rv)("MainThreadChatProvider"),MainThreadChatAgents2:(0,C.$Rv)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$Rv)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$Rv)("MainThreadClipboard"),MainThreadCommands:(0,C.$Rv)("MainThreadCommands"),MainThreadComments:(0,C.$Rv)("MainThreadComments"),MainThreadConfiguration:(0,C.$Rv)("MainThreadConfiguration"),MainThreadConsole:(0,C.$Rv)("MainThreadConsole"),MainThreadDebugService:(0,C.$Rv)("MainThreadDebugService"),MainThreadDecorations:(0,C.$Rv)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$Rv)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$Rv)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$Rv)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$Rv)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$Rv)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$Rv)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$Rv)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$Rv)("MainThreadErrors"),MainThreadTreeViews:(0,C.$Rv)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$Rv)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$Rv)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$Rv)("MainThreadLanguages"),MainThreadLogger:(0,C.$Rv)("MainThreadLogger"),MainThreadMessageService:(0,C.$Rv)("MainThreadMessageService"),MainThreadOutputService:(0,C.$Rv)("MainThreadOutputService"),MainThreadProgress:(0,C.$Rv)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$Rv)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$Rv)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$Rv)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$Rv)("MainThreadSecretState"),MainThreadStorage:(0,C.$Rv)("MainThreadStorage"),MainThreadSpeech:(0,C.$Rv)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$Rv)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$Rv)("MainThreadTerminalService"),MainThreadWebviews:(0,C.$Rv)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$Rv)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$Rv)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$Rv)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$Rv)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$Rv)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$Rv)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$Rv)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$Rv)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$Rv)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$Rv)("MainThreadExtensionService"),MainThreadSCM:(0,C.$Rv)("MainThreadSCM"),MainThreadSearch:(0,C.$Rv)("MainThreadSearch"),MainThreadShare:(0,C.$Rv)("MainThreadShare"),MainThreadTask:(0,C.$Rv)("MainThreadTask"),MainThreadWindow:(0,C.$Rv)("MainThreadWindow"),MainThreadLabelService:(0,C.$Rv)("MainThreadLabelService"),MainThreadNotebook:(0,C.$Rv)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$Rv)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$Rv)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$Rv)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$Rv)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$Rv)("MainThreadInteractive"),MainThreadChat:(0,C.$Rv)("MainThreadChat"),MainThreadInlineChat:(0,C.$Rv)("MainThreadInlineChatShape"),MainThreadTheming:(0,C.$Rv)("MainThreadTheming"),MainThreadTunnelService:(0,C.$Rv)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$Rv)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$Rv)("MainThreadTimeline"),MainThreadTesting:(0,C.$Rv)("MainThreadTesting"),MainThreadLocalization:(0,C.$Rv)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$Rv)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$Rv)("MainThreadAiEmbeddingVector"),MainThreadIssueReporter:(0,C.$Rv)("MainThreadIssueReporter")},e.$bL={ExtHostCommands:(0,C.$Rv)("ExtHostCommands"),ExtHostConfiguration:(0,C.$Rv)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$Rv)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$Rv)("ExtHostDebugService"),ExtHostDecorations:(0,C.$Rv)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$Rv)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$Rv)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$Rv)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$Rv)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$Rv)("ExtHostEditors"),ExtHostTreeViews:(0,C.$Rv)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$Rv)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$Rv)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$Rv)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$Rv)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$Rv)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$Rv)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$Rv)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$Rv)("ExtHostStatusBar"),ExtHostShare:(0,C.$Rv)("ExtHostShare"),ExtHostExtensionService:(0,C.$Rv)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$Rv)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$Rv)("ExtHostTerminalService"),ExtHostSCM:(0,C.$Rv)("ExtHostSCM"),ExtHostSearch:(0,C.$Rv)("ExtHostSearch"),ExtHostTask:(0,C.$Rv)("ExtHostTask"),ExtHostWorkspace:(0,C.$Rv)("ExtHostWorkspace"),ExtHostWindow:(0,C.$Rv)("ExtHostWindow"),ExtHostWebviews:(0,C.$Rv)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$Rv)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$Rv)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$Rv)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$Rv)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$Rv)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$Rv)("ExtHostProgress"),ExtHostComments:(0,C.$Rv)("ExtHostComments"),ExtHostSecretState:(0,C.$Rv)("ExtHostSecretState"),ExtHostStorage:(0,C.$Rv)("ExtHostStorage"),ExtHostUrls:(0,C.$Rv)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$Rv)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$Rv)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$Rv)("ExtHostOutputService"),ExtHostLabelService:(0,C.$Rv)("ExtHostLabelService"),ExtHostNotebook:(0,C.$Rv)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$Rv)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$Rv)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$Rv)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$Rv)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$Rv)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$Rv)("ExtHostInteractive"),ExtHostInlineChat:(0,C.$Rv)("ExtHostInlineChatShape"),ExtHostChat:(0,C.$Rv)("ExtHostChat"),ExtHostChatAgents2:(0,C.$Rv)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$Rv)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$Rv)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$Rv)("ExtHostSpeech"),ExtHostAiRelatedInformation:(0,C.$Rv)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$Rv)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$Rv)("ExtHostTheming"),ExtHostTunnelService:(0,C.$Rv)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$Rv)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$Rv)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$Rv)("ExtHostTimeline"),ExtHostTesting:(0,C.$Rv)("ExtHostTesting"),ExtHostTelemetry:(0,C.$Rv)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$Rv)("ExtHostLocalization"),ExtHostIssueReporter:(0,C.$Rv)("ExtHostIssueReporter")}}),define(ke[92],Se([1,0,5,13,6,20]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ngc=e.$Mgc=e.$Lgc=void 0,e.$Lgc=(0,C.$6h)("IExtHostApiDeprecationService");let R=class{constructor($,k){this.c=k,this.a=new Set,this.b=$.getProxy(f.$aL.MainThreadTelemetry)}report($,k,A){const D=this.d($,k);this.a.has(D)||(this.a.add(D),k.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${$}' is deprecated. ${A}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:$}))}d($,k){return`${$}-${k.identifier.value}`}};e.$Mgc=R,e.$Mgc=R=Ge([We(0,P.$fN),We(1,N.$nj)],R),e.$Ngc=Object.freeze(new class{report(v,$,k){}})}),define(ke[298],Se([1,0,6]),function(ge,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgc=void 0;class N{constructor(P){const R=P.getProxy(C.$aL.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(v){return R.$writeText(v)}})}}e.$Wgc=N}),define(ke[299],Se([1,0,24,6,27,20]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nic=void 0;let R=class{constructor(A,D){this.a=A.getProxy(N.$aL.MainThreadConsole),this.b=D.consoleForward.includeStack,this.c=D.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(A,D){const w=this,E=console[A];Object.defineProperty(console,A,{set:()=>{},get:()=>function(){w.e(A,D,E,arguments)}})}e(A,D,w,E){this.a.$logExtensionHostMessage({type:"__$console",severity:D,arguments:$(E,this.b)}),this.c&&this.f(A,w,E)}};e.$Nic=R,e.$Nic=R=Ge([We(0,P.$fN),We(1,f.$vN)],R);const v=1e5;function $(k,A){const D=[];if(k.length)for(let w=0;w<k.length;w++){let E=k[w];if(typeof E>"u")E="undefined";else if(E instanceof Error){const S=E;S.stack?E=S.stack:E=S.toString()}D.push(E)}if(A){const w=new Error().stack;w&&D.push({__$stack:w.split(`
`).slice(3).join(`
`)})}try{const w=(0,C.$An)(D);return w.length>v?"Output omitted for a large object that exceeds the limits":w}catch(w){return`Output omitted for an object that cannot be inspected ('${w.toString()}')`}}}),define(ke[300],Se([1,0,2,6,26]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rhc=void 0;class P{constructor(v){this.a=v.getProxy(N.$aL.MainThreadDialogs)}showOpenDialog(v,$){return $?.allowUIResources&&(0,f.$GF)(v,"showLocal"),this.a.$showOpenDialog($).then(k=>k?k.map(A=>C.URI.revive(A)):void 0)}showSaveDialog(v){return this.a.$showSaveDialog(v).then($=>$?C.URI.revive($):void 0)}}e.$Rhc=P}),define(ke[301],Se([1,0,3,6]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aic=void 0;class f{constructor(R){this.b=0,this.a=R.getProxy(N.$aL.MainThreadLabelService)}$registerResourceLabelFormatter(R){const v=this.b++;return this.a.$registerResourceLabelFormatter(v,R),(0,C.$Rc)(()=>{this.a.$unregisterResourceLabelFormatter(v)})}}e.$aic=f}),define(ke[114],Se([1,0,10,12,2,5,13,6,27,20]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ahc=e.$zhc=void 0;let A=class{constructor(w,E,S){this.f=S,this.d=new Map,this.a=E.getProxy(v.$aL.MainThreadLocalization),this.b=w.environment.appLanguage,this.c=this.b===C.$g}getMessage(w,E){const{message:S,args:c,comment:g}=E;if(this.c)return(0,N.$Le)(S,c??{});let o=S;g&&g.length>0&&(o+=`/${Array.isArray(g)?g.join(""):g}`);const i=this.d.get(w)?.contents[o];return i||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,N.$Le)(i??S,c??{})}getBundle(w){return this.d.get(w)?.contents}getBundleUri(w){return this.d.get(w)?.uri}async initializeLocalizedMessages(w){if(this.c||!w.l10n&&!w.isBuiltin||this.d.has(w.identifier.value))return;let E;const S=await this.g(w);if(!S){this.f.error(`No bundle location found for extension ${w.identifier.value}`);return}try{const c=await this.a.$fetchBundleContents(S),g=JSON.parse(c);E=w.isBuiltin?g.contents?.bundle:g}catch(c){this.f.error(`Failed to load translations for ${w.identifier.value} from ${S}: ${c.message}`);return}E&&this.d.set(w.identifier.value,{contents:E,uri:S})}async g(w){if(w.isBuiltin){const E=await this.a.$fetchBuiltInBundleUri(w.identifier.value,this.b);return f.URI.revive(E)}return w.l10n?f.URI.joinPath(w.extensionLocation,w.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$zhc=A,e.$zhc=A=Ge([We(0,$.$vN),We(1,k.$fN),We(2,R.$nj)],A),e.$Ahc=(0,P.$6h)("IExtHostLocalizationService")}),define(ke[145],Se([1,0,13,6,27,20,2,56]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mic=void 0;let $=class extends C.$yj{constructor(D,w){super(w.logLevel,w.logsLocation,w.loggers.map(E=>(0,v.$Ch)(E))),this.r=D.getProxy(N.$aL.MainThreadLogger)}$setLogLevel(D,w){w?this.setLogLevel(R.URI.revive(w),D):this.setLogLevel(D)}setVisibility(D,w){super.setVisibility(D,w),this.r.$setVisibility(D,w)}s(D,w,E){return new k(this.r,D,w,E)}};e.$Mic=$,e.$Mic=$=Ge([We(0,P.$fN),We(1,f.$vN)],$);class k extends C.$tj{constructor(D,w,E,S){super(S?.logLevel==="always"),this.r=D,this.s=w,this.m=!1,this.n=[],this.setLevel(E),this.r.$createLogger(w,S).then(()=>{this.u(this.n),this.m=!0})}g(D,w){const E=[[D,w]];this.m?this.u(E):this.n.push(...E)}u(D){this.r.$log(this.s,D)}flush(){this.r.$flush(this.s)}}}),define(ke[115],Se([1,0,6,5,3,20,22]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Chc=e.$Bhc=void 0,e.$Bhc=(0,N.$6h)("IExtHostManagedSockets");let v=class{constructor(D){this.b=0,this.c=null,this.d=new Map,this.a=D.getProxy(C.$aL.MainThreadManagedSockets)}setFactory(D,w){for(const E of this.d.values())E.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new $(D,w),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(D){if(!this.c||this.c.socketFactoryId!==D)throw new Error(`No socket factory with id ${D}`);const w=++this.b,E=await this.c.makeConnection(),S=new f.$Sc;return this.d.set(w,new k(w,E,S)),S.add((0,f.$Rc)(()=>this.d.delete(w))),S.add(E.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(w),S.dispose()})),S.add(E.onDidClose(c=>{this.a.$onDidManagedSocketClose(w,c?.stack??c?.message),S.dispose()})),S.add(E.onDidReceiveMessage(c=>this.a.$onDidManagedSocketHaveData(w,R.$je.wrap(c)))),w}$remoteSocketWrite(D,w){this.d.get(D)?.actual.send(w.buffer)}$remoteSocketEnd(D){const w=this.d.get(D);w&&(w.actual.end(),w.dispose())}async $remoteSocketDrain(D){await this.d.get(D)?.actual.drain?.()}};e.$Chc=v,e.$Chc=v=Ge([We(0,P.$fN)],v);class ${constructor(D,w){this.socketFactoryId=D,this.makeConnection=w}}class k extends f.$Tc{constructor(D,w,E){super(),this.socketId=D,this.actual=w,this.B(E)}}}),define(ke[302],Se([1,0,6,13,26]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cic=void 0;function P(v){return v&&v.title}let R=class{constructor($,k){this.b=k,this.a=$.getProxy(C.$aL.MainThreadMessageService)}showMessage($,k,A,D,w){const E={source:{identifier:$.identifier,label:$.displayName||$.name}};let S;typeof D=="string"||P(D)?S=[D,...w]:(E.modal=D?.modal,E.useCustom=D?.useCustom,E.detail=D?.detail,S=w),E.useCustom&&(0,f.$GF)($,"resolvers");const c=[];let g=!1;for(let o=0;o<S.length;o++){const i=S[o];if(typeof i=="string")c.push({title:i,handle:o,isCloseAffordance:!1});else if(typeof i=="object"){const{title:r,isCloseAffordance:n}=i;c.push({title:r,isCloseAffordance:!!n,handle:o}),n&&(g?this.b.warn(`[${$.identifier}] Only one message item can have 'isCloseAffordance':`,i):g=!0)}else this.b.warn(`[${$.identifier}] Invalid message item:`,i)}return this.a.$showMessage(k,A,E,c).then(o=>{if(typeof o=="number")return S[o]})}};e.$cic=R,e.$cic=R=Ge([We(1,N.$nj)],R)}),define(ke[303],Se([1,0,3,18,2,26,6]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lic=void 0;class v{constructor(k){this.b=new Map,this.a=k.getProxy(R.$aL.MainThreadProfileContentHandlers)}registerProfileContentHandler(k,A,D){if((0,P.$GF)(k,"profileContentHandlers"),this.b.has(A))throw new Error(`Handler with id '${A}' already registered`);return this.b.set(A,D),this.a.$registerProfileContentHandler(A,D.name,D.description,k.identifier.value),(0,C.$Rc)(()=>{this.b.delete(A),this.a.$unregisterProfileContentHandler(A)})}async $saveProfile(k,A,D,w){const E=this.b.get(k);if(!E)throw new Error(`Unknown handler with id: ${k}`);return E.saveProfile(A,D,w)}async $readProfile(k,A,D){const w=this.b.get(k);if(!w)throw new Error(`Unknown handler with id: ${k}`);return w.readProfile((0,N.$If)(A)?A:f.URI.revive(A),D)}}e.$lic=v}),define(ke[116],Se([1,0,6,4,5]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xhc=e.$whc=void 0;class P{constructor(v){this.b=new N.$Vd,this.onDidChangePassword=this.b.event,this.a=v.getProxy(C.$aL.MainThreadSecretState)}async $onDidChangePassword(v){this.b.fire(v)}get(v,$){return this.a.$getPassword(v,$)}store(v,$,k){return this.a.$setPassword(v,$,k)}delete(v,$){return this.a.$deletePassword(v,$)}}e.$whc=P,e.$xhc=(0,f.$6h)("IExtHostSecretState")}),define(ke[304],Se([1,0,21,3,6]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sic=void 0;class P{static{this.a=1}constructor(v){this.c=new Map,this.d=new Map,this.b=v.getProxy(f.$aL.MainThreadSpeech)}async $createSpeechToTextSession(v,$){const k=this.c.get(v);if(!k)return;const A=new N.$Sc,D=new C.$6d;this.d.set($,D);const w=A.add(k.provideSpeechToTextSession(D.token));A.add(w.onDidChange(E=>{D.token.isCancellationRequested||this.b.$emitSpeechToTextEvent($,E)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelSpeechToTextSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}async $createKeywordRecognitionSession(v,$){const k=this.c.get(v);if(!k)return;const A=new N.$Sc,D=new C.$6d;this.d.set($,D);const w=A.add(k.provideKeywordRecognitionSession(D.token));A.add(w.onDidChange(E=>{D.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent($,E)})),A.add(D.token.onCancellationRequested(()=>A.dispose()))}async $cancelKeywordRecognitionSession(v){this.d.get(v)?.dispose(!0),this.d.delete(v)}registerProvider(v,$,k){const A=P.a++;return this.c.set(A,k),this.b.$registerProvider(A,$,{extension:v,displayName:v.value}),(0,N.$Rc)(()=>{this.b.$unregisterProvider(A),this.c.delete(A)})}}e.$sic=P}),define(ke[117],Se([1,0,6,4,5]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$phc=e.$ohc=void 0;class P{constructor(v,$){this.c=$,this.b=new N.$Vd,this.onDidChangeStorage=this.b.event,this.a=v.getProxy(C.$aL.MainThreadStorage)}registerExtensionStorageKeysToSync(v,$){this.a.$registerExtensionStorageKeysToSync(v,$)}async initializeExtensionStorage(v,$,k){const A=await this.a.$initializeExtensionStorage(v,$);let D;return A&&(D=this.d(v,$,A)),D||k}setValue(v,$,k){return this.a.$setValue(v,$,k)}$acceptValue(v,$,k){const A=this.d(v,$,k);A&&this.b.fire({shared:v,key:$,value:A})}d(v,$,k){try{return JSON.parse(k)}catch(A){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${$}, global: ${v}): ${A}`)}}}e.$ohc=P,e.$phc=(0,f.$6h)("IExtHostStorage")}),define(ke[305],Se([1,0,3,16,2,6]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gic=void 0;class R{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor($){this.c=new Map,this.b=$.getProxy(P.$aL.MainThreadUriOpeners)}registerExternalUriOpener($,k,A,D){if(this.c.has(k))throw new Error(`Opener with id '${k}' already registered`);const w=D.schemes.find(E=>!R.a.has(E));if(w)throw new Error(`Scheme '${w}' is not supported. Only http and https are currently supported.`);return this.c.set(k,A),this.b.$registerUriOpener(k,D.schemes,$,D.label),(0,C.$Rc)(()=>{this.c.delete(k),this.b.$unregisterUriOpener(k)})}async $canOpenUri($,k,A){const D=this.c.get($);if(!D)throw new Error(`Unknown opener with id: ${$}`);const w=f.URI.revive(k);return D.canOpenExternalUri(w,A)}async $openUri($,k,A){const D=this.c.get($);if(!D)throw new Error(`Unknown opener id: '${$}'`);return D.openExternalUri(f.URI.revive(k.resolvedUri),{sourceUri:f.URI.revive(k.sourceUri)},A)}}e.$Gic=R}),define(ke[306],Se([1,0,6,2,3,14,25]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hic=void 0;class v{static{this.a=0}constructor(k){this.c=new R.$mm,this.d=new Map,this.b=k.getProxy(C.$aL.MainThreadUrls)}registerUriHandler(k,A){const D=k.identifier;if(this.c.has(D))throw new Error(`Protocol handler already registered for extension ${D}`);const w=v.a++;return this.c.add(D),this.d.set(w,A),this.b.$registerUriHandler(w,D,k.displayName||k.name),(0,f.$Rc)(()=>{this.c.delete(D),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(k,A){const D=this.d.get(k);if(!D)return Promise.resolve(void 0);try{D.handleUri(N.URI.revive(A))}catch(w){(0,P.$1)(w)}return Promise.resolve(void 0)}async createAppUri(k){return N.URI.revive(await this.b.$createAppUri(k))}}e.$Hic=v}),define(ke[93],Se([1,0,4,3,16,24,2,237,274,112,6]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dhc=e.$chc=e.$bhc=e.$ahc=e.$_gc=void 0;class D{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;constructor(n,a,t,h,s,d,u){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$Vd,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$Vd,this._onDidDispose=this.#h.event,this.#e=n,this.#t=a,this.#s=t,this.#o=h,this.#n=s,this.#r=d,this.#l=w(d),this.#d=E(d),this.#i=u}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return this.#u=!0,(0,k.$bwb)(n,this.#o)}get cspSource(){const n=this.#r.extensionLocation;if(n.scheme===f.Schemas.https||n.scheme===f.Schemas.http){let a=n.toString();return a.endsWith("/")||(a+="/"),a+" "+k.$awb}return k.$awb}get html(){return this.a(),this.#a}set html(n){this.a(),this.#a!==n&&(this.#a=n,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(n)))}get options(){return this.a(),this.#s}set options(n){this.a(),P.$zn(this.#s,n)||this.#t.$setOptions(this.#e,g(this.#r,this.#n,n)),this.#s=n}async postMessage(n){if(this.#c)return!1;const a=(0,$.$tlb)(n,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,a.message,...a.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(n){if(!this.#d)return n;const a=this.#r.extensionLocation?.scheme===f.Schemas.vscodeRemote,t=this.#r.extensionLocation.scheme===f.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,d,u,l,p)=>{const I=R.URI.from({scheme:u||"file",path:decodeURIComponent(l)}),b=(0,k.$bwb)(I,{isRemote:a,authority:t}).toString();return`${s}${b}${p}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(h,s,d,u,l,p)=>{const I=R.URI.from({scheme:u||"file",path:decodeURIComponent(l)}),b=(0,k.$bwb)(I,{isRemote:a,authority:t}).toString();return`${s}${b}${p}`})}}e.$_gc=D;function w(r){try{const n=(0,v.$cp)((0,v.$bp)(r.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.$ahc=w;function E(r){try{const n=(0,v.$cp)((0,v.$bp)(r.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class S extends N.$Tc{constructor(n,a,t,h,s){super(),this.c=a,this.f=t,this.g=h,this.h=s,this.b=new Map,this.a=n.getProxy(A.$aL.MainThreadWebviews)}dispose(){super.dispose();for(const n of this.b.values())n.dispose();this.b.clear()}$onMessage(n,a,t){const h=this.j(n);if(h){const{message:s}=(0,$.$ulb)(a,t.value);h._onMessageEmitter.fire(s)}}$onMissingCsp(n,a){this.g.warn(`${a} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,a,t){const h=new D(n,this.a,o(a),this.c,this.f,t,this.h);this.b.set(n,h);const s=h._onDidDispose(()=>{s.dispose(),this.deleteWebview(n)});return h}deleteWebview(n){this.b.delete(n)}j(n){return this.b.get(n)}}e.$bhc=S;function c(r){return{id:r.identifier,location:r.extensionLocation}}e.$chc=c;function g(r,n,a){return{enableCommandUris:a.enableCommandUris,enableScripts:a.enableScripts,enableForms:a.enableForms,portMapping:a.portMapping,localResourceRoots:a.localResourceRoots||i(r,n)}}e.$dhc=g;function o(r){return{enableCommandUris:r.enableCommandUris,enableScripts:r.enableScripts,enableForms:r.enableForms,portMapping:r.portMapping,localResourceRoots:r.localResourceRoots?.map(n=>R.URI.from(n))}}function i(r,n){return[...(n?.getWorkspaceFolders()||[]).map(a=>a.uri),r.extensionLocation]}}),define(ke[146],Se([1,0,4,6,2,16,12,5,20,26]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kic=e.$Jic=void 0;let D=class{static{A=this}static{this.a={focused:!0,active:!0}}getState(E){const S=this.d;return{get focused(){return S.focused},get active(){return(0,k.$GF)(E,"windowActivity"),S.active}}}constructor(E){this.c=new C.$Vd,this.onDidChangeWindowState=this.c.event,this.d=A.a,this.b=E.getProxy(N.$aL.MainThreadWindow),this.b.$getInitialState().then(({isFocused:S,isActive:c})=>{this.onDidChangeWindowProperty("focused",S),this.onDidChangeWindowProperty("active",c)})}$onDidChangeWindowFocus(E){this.onDidChangeWindowProperty("focused",E)}$onDidChangeWindowActive(E){this.onDidChangeWindowProperty("active",E)}onDidChangeWindowProperty(E,S){S!==this.d[E]&&(this.d={...this.d,[E]:S},this.c.fire(this.d))}openUri(E,S){let c;if(typeof E=="string"){c=E;try{E=f.URI.parse(E)}catch{return Promise.reject(`Invalid uri - '${E}'`)}}return(0,R.$Je)(E.scheme)?Promise.reject("Invalid scheme - cannot be empty"):E.scheme===P.Schemas.command?Promise.reject(`Invalid scheme '${E.scheme}'`):this.b.$openUri(E,c,S)}async asExternalUri(E,S){if((0,R.$Je)(E.scheme))return Promise.reject("Invalid scheme - cannot be empty");const c=await this.b.$asExternalUri(E,S);return f.URI.from(c)}};e.$Jic=D,e.$Jic=D=A=Ge([We(0,$.$fN)],D),e.$Kic=(0,v.$6h)("IExtHostWindow")}),define(ke[307],Se([1,0,299,27,20]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mjc=void 0;const P=1024*1024;let R=class extends C.$Nic{constructor($,k){super($,k),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f($,k,A){const D=$==="error"||$==="warn"?process.stderr:process.stdout;this.g=!0,D.write(`
START_NATIVE_LOG
`),k.apply(console,A),D.write(`
END_NATIVE_LOG
`),this.g=!1}j($,k){const A=process[$],D=A.write;let w="";Object.defineProperty(A,"write",{set:()=>{},get:()=>(E,S,c)=>{if(!this.g){w+=E.toString(S);const g=w.length>P?w.length:w.lastIndexOf(`
`);g!==-1&&(console[k](w.slice(0,g)),w=w.slice(g+1))}D.call(A,E,S,c)}})}};e.$mjc=R,e.$mjc=R=Ge([We(0,f.$fN),We(1,N.$vN)],R)}),define(ke[308],Se([1,0,145,16,251,30]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yjc=void 0;class R extends C.$Mic{s($,k,A){return $.scheme===N.Schemas.file?new f.$rO(A?.name||(0,P.$qg)(),$.fsPath,!A?.donotRotate,!!A?.donotUseFormatters,k):super.s($,k,A)}registerLogger($){super.registerLogger($),this.r.$registerLogger($)}deregisterLogger($){super.deregisterLogger($),this.r.$deregisterLogger($)}}e.$yjc=R}),define(ke[309],Se([1,0,11,22,21,14,4,3,130,297,68]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$T8b=e.ResponsiveState=e.RequestInitiator=e.$S8b=e.$R8b=void 0;function w(y,L){try{return JSON.stringify(y,L)}catch{return"null"}}const E="$$ref$$",S={[E]:-1};class c{constructor(L,F){this.jsonString=L,this.referencedBuffers=F}}function g(y,L=null,F=!1){const z=[];return{jsonString:(F?w:JSON.stringify)(y,(O,M)=>{if(typeof M>"u")return S;if(typeof M=="object"){if(M instanceof N.$je){const j=z.push(M)-1;return{[E]:j}}if(L)return L(O,M)}return M}),referencedBuffers:z}}e.$R8b=g;function o(y,L,F){return JSON.parse(y,(z,T)=>{if(T){const O=T[E];if(typeof O=="number")return L[O];if(F&&T.$mid===1)return F.transformIncoming(T)}return T})}e.$S8b=o;function i(y,L){return JSON.stringify(y,L)}function r(y){return y?(L,F)=>F&&F.$mid===1?y.transformOutgoing(F):F:null}var n;(function(y){y[y.LocalSide=0]="LocalSide",y[y.OtherSide=1]="OtherSide"})(n||(e.RequestInitiator=n={}));var a;(function(y){y[y.Responsive=0]="Responsive",y[y.Unresponsive=1]="Unresponsive"})(a||(e.ResponsiveState=a={}));const t=()=>{},h=Symbol.for("rpcProtocol"),s=Symbol.for("rpcProxy");class d extends v.$Tc{static{D=h}static{this.a=3*1e3}constructor(L,F=null,z=null){super(),this[D]=!0,this.b=this.B(new R.$Vd),this.onDidChangeResponsiveState=this.b.event,this.c=L,this.f=F,this.g=z,this.h=r(this.g),this.j=!1,this.m=[],this.s=[];for(let T=0,O=A.$Qv.count;T<O;T++)this.m[T]=null,this.s[T]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$fh(()=>this.H(),1e3)),this.c.onMessage(T=>this.L(T))}dispose(){this.j=!0,Object.keys(this.w).forEach(L=>{const F=this.w[L];delete this.w[L],F.resolveErr(P.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(L){this.z===0&&(this.C=Date.now()+d.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(L){this.C=Date.now()+d.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(L){this.y!==L&&(this.y=L,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(L){return this.g?(0,$.$7m)(L,this.g):L}getProxy(L){const{nid:F,sid:z}=L;return this.s[F]||(this.s[F]=this.J(F,z)),this.s[F]}J(L,F){const z={get:(T,O)=>(typeof O=="string"&&!T[O]&&O.charCodeAt(0)===36&&(T[O]=(...M)=>this.U(L,O,M)),O===s?F:T[O])};return new Proxy(Object.create(null),z)}set(L,F){return this.m[L.nid]=F,F}assertRegistered(L){for(let F=0,z=L.length;F<z;F++){const T=L[F];if(!this.m[T.nid])throw new Error(`Missing proxy instance ${T.sid}`)}}L(L){if(this.j)return;const F=L.byteLength,z=l.read(L,0),T=z.readUInt8(),O=z.readUInt32();switch(T){case 1:case 2:{let{rpcId:M,method:j,args:U}=I.deserializeRequestJSONArgs(z);this.g&&(U=(0,$.$7m)(U,this.g)),this.M(F,O,M,j,U,T===2);break}case 3:case 4:{let{rpcId:M,method:j,args:U}=I.deserializeRequestMixedArgs(z);this.g&&(U=(0,$.$7m)(U,this.g)),this.M(F,O,M,j,U,T===4);break}case 5:{this.f?.logIncoming(F,O,0,"ack"),this.G(O);break}case 6:{this.N(F,O);break}case 7:{this.O(F,O,void 0);break}case 9:{let M=I.deserializeReplyOKJSON(z);this.g&&(M=(0,$.$7m)(M,this.g)),this.O(F,O,M);break}case 10:{const M=I.deserializeReplyOKJSONWithBuffers(z,this.g);this.O(F,O,M);break}case 8:{const M=I.deserializeReplyOKVSBuffer(z);this.O(F,O,M);break}case 11:{let M=I.deserializeReplyErrError(z);this.g&&(M=(0,$.$7m)(M,this.g)),this.P(F,O,M);break}case 12:{this.P(F,O,void 0);break}default:console.error("received unexpected message"),console.error(L)}}M(L,F,z,T,O,M){this.f?.logIncoming(L,F,1,`receiveRequest ${(0,A.$Sv)(z)}.${T}(`,O);const j=String(F);let U,K;if(M){const X=new f.$6d;O.push(X.token),U=this.Q(z,T,O),K=()=>X.cancel()}else U=this.Q(z,T,O),K=t;this.u[j]=K;const ue=I.serializeAcknowledged(F);this.f?.logOutgoing(ue.byteLength,F,1,"ack"),this.c.send(ue),U.then(X=>{delete this.u[j];const Q=I.serializeReplyOK(F,X,this.h);this.f?.logOutgoing(Q.byteLength,F,1,"reply:",X),this.c.send(Q)},X=>{delete this.u[j];const Q=I.serializeReplyErr(F,X);this.f?.logOutgoing(Q.byteLength,F,1,"replyErr:",X),this.c.send(Q)})}N(L,F){this.f?.logIncoming(L,F,1,"receiveCancel");const z=String(F);this.u[z]?.()}O(L,F,z){this.f?.logIncoming(L,F,0,"receiveReply:",z);const T=String(F);if(!this.w.hasOwnProperty(T))return;const O=this.w[T];delete this.w[T],O.resolveOk(z)}P(L,F,z){this.f?.logIncoming(L,F,0,"receiveReplyErr:",z);const T=String(F);if(!this.w.hasOwnProperty(T))return;const O=this.w[T];delete this.w[T];let M;z&&(z.$isError?(M=new Error,M.name=z.name,M.message=z.message,M.stack=z.stack):M=z),O.resolveErr(M)}Q(L,F,z){try{return Promise.resolve(this.S(L,F,z))}catch(T){return Promise.reject(T)}}S(L,F,z){const T=this.m[L];if(!T)throw new Error("Unknown actor "+(0,A.$Sv)(L));const O=T[F];if(typeof O!="function")throw new Error("Unknown method "+F+" on actor "+(0,A.$Sv)(L));return O.apply(T,z)}U(L,F,z){if(this.j)return new k.$Q8b;let T=null;if(z.length>0&&f.CancellationToken.isCancellationToken(z[z.length-1])&&(T=z.pop()),T&&T.isCancellationRequested)return Promise.reject(P.$6());const O=I.serializeRequestArguments(z,this.h),M=++this.t,j=String(M),U=new k.$P8b,K=new v.$Sc;T&&K.add(T.onCancellationRequested(()=>{const X=I.serializeCancel(M);this.f?.logOutgoing(X.byteLength,M,0,"cancel"),this.c.send(I.serializeCancel(M))})),this.w[j]=new u(U,K),this.F(M);const ue=I.serializeRequest(M,L,F,O,!!T);return this.f?.logOutgoing(ue.byteLength,M,0,`request: ${(0,A.$Sv)(L)}.${F}(`,z),this.c.send(ue),U}}e.$T8b=d;class u{constructor(L,F){this.a=L,this.b=F}resolveOk(L){this.a.resolveOk(L),this.b.dispose()}resolveErr(L){this.a.resolveErr(L),this.b.dispose()}}class l{static alloc(L,F,z){const T=new l(N.$je.alloc(z+1+4),0);return T.writeUInt8(L),T.writeUInt32(F),T}static read(L,F){return new l(L,F)}get buffer(){return this.a}constructor(L,F){this.a=L,this.b=F}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(L){this.a.writeUInt8(L,this.b),this.b+=1}readUInt8(){const L=this.a.readUInt8(this.b);return this.b+=1,L}writeUInt32(L){this.a.writeUInt32BE(L,this.b),this.b+=4}readUInt32(){const L=this.a.readUInt32BE(this.b);return this.b+=4,L}static sizeShortString(L){return 1+L.byteLength}writeShortString(L){this.a.writeUInt8(L.byteLength,this.b),this.b+=1,this.a.set(L,this.b),this.b+=L.byteLength}readShortString(){const L=this.a.readUInt8(this.b);this.b+=1;const z=this.a.slice(this.b,this.b+L).toString();return this.b+=L,z}static sizeLongString(L){return 4+L.byteLength}writeLongString(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readLongString(){const L=this.a.readUInt32BE(this.b);this.b+=4;const z=this.a.slice(this.b,this.b+L).toString();return this.b+=L,z}writeBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}static sizeVSBuffer(L){return 4+L.byteLength}writeVSBuffer(L){this.a.writeUInt32BE(L.byteLength,this.b),this.b+=4,this.a.set(L,this.b),this.b+=L.byteLength}readVSBuffer(){const L=this.a.readUInt32BE(this.b);this.b+=4;const F=this.a.slice(this.b,this.b+L);return this.b+=L,F}static sizeMixedArray(L){let F=0;F+=1;for(let z=0,T=L.length;z<T;z++){const O=L[z];switch(F+=1,O.type){case 1:F+=this.sizeLongString(O.value);break;case 2:F+=this.sizeVSBuffer(O.value);break;case 3:F+=this.sizeUInt32,F+=this.sizeLongString(O.value);for(let M=0;M<O.buffers.length;++M)F+=this.sizeVSBuffer(O.buffers[M]);break;case 4:break}}return F}writeMixedArray(L){this.a.writeUInt8(L.length,this.b),this.b+=1;for(let F=0,z=L.length;F<z;F++){const T=L[F];switch(T.type){case 1:this.writeUInt8(1),this.writeLongString(T.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(T.value);break;case 3:this.writeUInt8(3),this.writeUInt32(T.buffers.length),this.writeLongString(T.value);for(let O=0;O<T.buffers.length;++O)this.writeBuffer(T.buffers[O]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const L=this.a.readUInt8(this.b);this.b+=1;const F=new Array(L);for(let z=0;z<L;z++)switch(this.readUInt8()){case 1:F[z]=this.readLongString();break;case 2:F[z]=this.readVSBuffer();break;case 3:{const O=this.readUInt32(),M=this.readLongString(),j=[];for(let U=0;U<O;++U)j.push(this.readVSBuffer());F[z]=new A.$Tv(o(M,j,null));break}case 4:F[z]=void 0;break}return F}}var p;(function(y){y[y.Simple=0]="Simple",y[y.Mixed=1]="Mixed"})(p||(p={}));class I{static a(L){for(let F=0,z=L.length;F<z;F++)if(L[F]instanceof N.$je||L[F]instanceof A.$Tv||typeof L[F]>"u")return!0;return!1}static serializeRequestArguments(L,F){if(this.a(L)){const z=[];for(let T=0,O=L.length;T<O;T++){const M=L[T];if(M instanceof N.$je)z[T]={type:2,value:M};else if(typeof M>"u")z[T]={type:4};else if(M instanceof A.$Tv){const{jsonString:j,referencedBuffers:U}=g(M.value,F);z[T]={type:3,value:N.$je.fromString(j),buffers:U}}else z[T]={type:1,value:N.$je.fromString(i(M,F))}}return{type:1,args:z}}return{type:0,args:i(L,F)}}static serializeRequest(L,F,z,T,O){switch(T.type){case 0:return this.b(L,F,z,T.args,O);case 1:return this.c(L,F,z,T.args,O)}}static b(L,F,z,T,O){const M=N.$je.fromString(z),j=N.$je.fromString(T);let U=0;U+=l.sizeUInt8(),U+=l.sizeShortString(M),U+=l.sizeLongString(j);const K=l.alloc(O?2:1,L,U);return K.writeUInt8(F),K.writeShortString(M),K.writeLongString(j),K.buffer}static deserializeRequestJSONArgs(L){const F=L.readUInt8(),z=L.readShortString(),T=L.readLongString();return{rpcId:F,method:z,args:JSON.parse(T)}}static c(L,F,z,T,O){const M=N.$je.fromString(z);let j=0;j+=l.sizeUInt8(),j+=l.sizeShortString(M),j+=l.sizeMixedArray(T);const U=l.alloc(O?4:3,L,j);return U.writeUInt8(F),U.writeShortString(M),U.writeMixedArray(T),U.buffer}static deserializeRequestMixedArgs(L){const F=L.readUInt8(),z=L.readShortString(),T=L.readMixedArray(),O=new Array(T.length);for(let M=0,j=T.length;M<j;M++){const U=T[M];typeof U=="string"?O[M]=JSON.parse(U):O[M]=U}return{rpcId:F,method:z,args:O}}static serializeAcknowledged(L){return l.alloc(5,L,0).buffer}static serializeCancel(L){return l.alloc(6,L,0).buffer}static serializeReplyOK(L,F,z){if(typeof F>"u")return this.d(L);if(F instanceof N.$je)return this.e(L,F);if(F instanceof A.$Tv){const{jsonString:T,referencedBuffers:O}=g(F.value,z,!0);return this.g(L,T,O)}else return this.f(L,w(F,z))}static d(L){return l.alloc(7,L,0).buffer}static e(L,F){let z=0;z+=l.sizeVSBuffer(F);const T=l.alloc(8,L,z);return T.writeVSBuffer(F),T.buffer}static deserializeReplyOKVSBuffer(L){return L.readVSBuffer()}static f(L,F){const z=N.$je.fromString(F);let T=0;T+=l.sizeLongString(z);const O=l.alloc(9,L,T);return O.writeLongString(z),O.buffer}static g(L,F,z){const T=N.$je.fromString(F);let O=0;O+=l.sizeUInt32,O+=l.sizeLongString(T);for(const j of z)O+=l.sizeVSBuffer(j);const M=l.alloc(10,L,O);M.writeUInt32(z.length),M.writeLongString(T);for(const j of z)M.writeBuffer(j);return M.buffer}static deserializeReplyOKJSON(L){const F=L.readLongString();return JSON.parse(F)}static deserializeReplyOKJSONWithBuffers(L,F){const z=L.readUInt32(),T=L.readLongString(),O=[];for(let M=0;M<z;++M)O.push(L.readVSBuffer());return new A.$Tv(o(T,O,F))}static serializeReplyErr(L,F){const z=F?w(P.$3(F),null):void 0;if(typeof z!="string")return this.h(L);const T=N.$je.fromString(z);let O=0;O+=l.sizeLongString(T);const M=l.alloc(11,L,O);return M.writeLongString(T),M.buffer}static deserializeReplyErrError(L){const F=L.readLongString();return JSON.parse(F)}static h(L){return l.alloc(12,L,0).buffer}}var b;(function(y){y[y.RequestJSONArgs=1]="RequestJSONArgs",y[y.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",y[y.RequestMixedArgs=3]="RequestMixedArgs",y[y.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",y[y.Acknowledged=5]="Acknowledged",y[y.Cancel=6]="Cancel",y[y.ReplyOKEmpty=7]="ReplyOKEmpty",y[y.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",y[y.ReplyOKJSON=9]="ReplyOKJSON",y[y.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",y[y.ReplyErrError=11]="ReplyErrError",y[y.ReplyErrEmpty=12]="ReplyErrEmpty"})(b||(b={}));var m;(function(y){y[y.String=1]="String",y[y.VSBuffer=2]="VSBuffer",y[y.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",y[y.Undefined=4]="Undefined"})(m||(m={}))}),define(ke[310],Se([1,0,22,28,16,84,5]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1I=e.$ZI=e.$YI=e.$XI=void 0,e.$XI=(0,R.$6h)("notebookDocumentService");const v=["W","X","Y","Z","a","b","c","d","e","f"],$=new RegExp(`^[${v.join("")}]+`),k=7;function A(E){if(E.scheme!==f.Schemas.vscodeNotebookCell)return;const S=E.fragment.indexOf("s");if(S<0)return;const c=parseInt(E.fragment.substring(0,S).replace($,""),k),g=(0,C.$Ce)(E.fragment.substring(S+1)).toString();if(!isNaN(c))return{handle:c,notebook:E.with({scheme:g,fragment:null})}}e.$YI=A;function D(E,S){const c=S.toString(k),o=`${c.length<v.length?v[c.length-1]:"z"}${c}s${(0,C.$De)(C.$je.fromString(E.scheme),!0,!0)}`;return E.with({scheme:f.Schemas.vscodeNotebookCell,fragment:o})}e.$ZI=D;class w{constructor(){this.a=new N.$Ac}getNotebook(S){if(S.scheme===f.Schemas.vscodeNotebookCell){const c=A(S);if(c){const g=this.a.get(c.notebook);if(g)return g}}return this.a.get(S)}addNotebookDocument(S){this.a.set(S.uri,S)}removeNotebookDocument(S){this.a.delete(S.uri)}}e.$1I=w,(0,P.$Yr)(e.$XI,w,1)}),define(ke[118],Se([1,0,22,35,53,101,16,17,10,45,310]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.CellStatusbarAlignment=e.$cJ=e.$bJ=e.$aJ=e.NotebookEditorPriority=e.$_I=e.$$I=e.$0I=e.$9I=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$8I=e.$7I=e.$6I=e.$5I=e.CellKind=e.$4I=e.$3I=e.$2I=void 0,e.$2I="workbench.editor.notebook",e.$3I="workbench.editor.notebookTextDiffEditor",e.$4I="workbench.editor.interactive";var D;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(D||(e.CellKind=D={})),e.$5I=["application/json","application/javascript","text/html","image/svg+xml",P.$fs.latex,P.$fs.markdown,"image/png","image/jpeg",P.$fs.text],e.$6I=[P.$fs.latex,P.$fs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",P.$fs.text],e.$7I=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$8I="_notAvailable";var w;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var E;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var S;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var c;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(c||(e.NotebookRendererMatch=c={}));var g;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(g||(e.RendererMessagingSpec=g={}));var o;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(o||(e.NotebookCellsChangeType=o={}));var i;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(i||(e.SelectionStateType=i={}));var r;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(r||(e.CellEditType=r={}));var n;(function(U){U.scheme=R.Schemas.vscodeNotebookCell;function K(re,$e){return(0,A.$ZI)(re,$e)}U.generate=K;function ue(re){return(0,A.$YI)(re)}U.parse=ue;function X(re,$e){return re.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${$e??""},${re.scheme!==R.Schemas.file?re.scheme:""}`})}U.generateCellOutputUri=X;function Q(re){if(re.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const $e=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(re.fragment);if(!$e)return;const oe=$e[1]&&$e[1]!==""?$e[1]:void 0,J=$e[2];return{outputId:oe,notebook:re.with({scheme:J||R.Schemas.file,fragment:null})}}U.parseCellOutputUri=Q;function Z(re,$e,oe){return U.generate(re,$e).with({scheme:oe})}U.generateCellPropertyUri=Z;function le(re,$e){if(re.scheme===$e)return U.parse(re.with({scheme:U.scheme}))}U.parseCellPropertyUri=le})(n||(e.CellUri=n={}));const a=U=>$.$i?U.replace(/\//g,"\\"):U;class t{constructor(K=[],ue=e.$5I){this.e=ue,this.d=[...new Set(K)].map(X=>({pattern:X,matches:N.$Mj(a(X))}))}sort(K){const ue=new Map(f.Iterable.map(K,Q=>[Q,a(Q)]));let X=[];for(const{matches:Q}of this.d)for(const[Z,le]of ue)if(Q(le)){X.push(Z),ue.delete(Z);break}return ue.size&&(X=X.concat([...ue.keys()].sort((Q,Z)=>this.e.indexOf(Q)-this.e.indexOf(Z)))),X}prioritize(K,ue){const X=this.f(K);if(X===-1){this.d.unshift({pattern:K,matches:N.$Mj(a(K))});return}const Q=new Set(ue.map(le=>this.f(le,X)));Q.delete(-1);const Z=Array.from(Q).sort();this.d.splice(X+1,0,...Z.map(le=>this.d[le]));for(let le=Z.length-1;le>=0;le--)this.d.splice(Z[le],1)}toArray(){return this.d.map(K=>K.pattern)}f(K,ue=this.d.length){const X=a(K);for(let Q=0;Q<ue;Q++)if(this.d[Q].matches(X))return Q;return-1}}e.$9I=t;function h(U,K,ue,X=(Q,Z)=>Q===Z){const Q=[];function Z($e,oe,J){if(oe===0&&J.length===0)return;const V=Q[Q.length-1];V&&V.start+V.deleteCount===$e?(V.deleteCount+=oe,V.toInsert.push(...J)):Q.push({start:$e,deleteCount:oe,toInsert:J})}let le=0,re=0;for(;;){if(le===U.length){Z(le,0,K.slice(re));break}if(re===K.length){Z(le,U.length-le,[]);break}const $e=U[le],oe=K[re];if(X($e,oe)){le+=1,re+=1;continue}ue(oe)?(Z(le,1,[]),le+=1):(Z(le,0,[oe]),re+=1)}return Q}e.$0I=h,e.$$I=new k.$kj("notebookEditorCursorAtBoundary","none"),e.$_I=new k.$kj("notebookEditorCursorAtLineBoundary","none");var s;(function(U){U.default="default",U.option="option"})(s||(e.NotebookEditorPriority=s={}));function d(U){const K=U;return!!((typeof K.include=="string"||N.$Nj(K.include))&&(typeof K.exclude=="string"||N.$Nj(K.exclude)))}e.$aJ=d;function u(U,K,ue){if(Array.isArray(U.viewType)&&U.viewType.indexOf(K)>=0||U.viewType===K)return!0;if(U.filenamePattern){const X=d(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,Q=d(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(N.$Lj(X,(0,v.$nc)(ue.fsPath).toLowerCase()))return!(Q&&N.$Lj(Q,(0,v.$nc)(ue.fsPath).toLowerCase()))}return!1}e.$bJ=u,e.$cJ={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScroll:"notebook.stickyScroll.enabled",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",anchorToFocusedCell:"notebook.scrolling.experimental.anchorToFocusedCell",cellChat:"notebook.experimental.cellChat"};var l;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(l||(e.CellStatusbarAlignment=l={}));class p{static{this.d="notebook/"}static create(K){return`${p.d}${K}`}static parse(K){if(K.startsWith(p.d))return K.substring(p.d.length)}}e.$dJ=p;function I(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.$eJ=I;const b=new TextDecoder;function m(U){const K=[];let ue=!1;for(const le of U)(K.length===0||ue)&&(K.push(le),ue=!0);let X=F(K);const Q=C.$je.concat(K.map(le=>C.$je.wrap(le))),Z=j(Q);return X=X||Z.byteLength!==Q.byteLength,{data:Z,didCompression:X}}e.$fJ=m,e.$gJ=`${String.fromCharCode(27)}[A`;const y=e.$gJ.split("").map(U=>U.charCodeAt(0)),L=10;function F(U){let K=!1;return U.forEach((ue,X)=>{if(X===0||ue.length<e.$gJ.length)return;const Q=U[X-1],Z=ue.subarray(0,e.$gJ.length);if(Z[0]===y[0]&&Z[1]===y[1]&&Z[2]===y[2]){const le=Q.lastIndexOf(L);if(le===-1)return;K=!0,U[X-1]=Q.subarray(0,le),U[X]=ue.subarray(e.$gJ.length)}}),K}function z(U){let K=U;do U=K,K=U.replace(/[^\n]\x08/gm,"");while(K.length<U.length);return U}function T(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const K=U.match(/^(.*)\r+/m)[1];let ue=U.match(/\r+(.*)$/m)[1];ue=ue+K.slice(ue.length,K.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,ue)}return U}const O="\b".charCodeAt(0),M="\r".charCodeAt(0);function j(U){return!U.buffer.includes(O)&&!U.buffer.includes(M)?U:C.$je.fromString(T(z(b.decode(U.buffer))))}}),define(ke[7],Se([1,0,19,14,80,28,101,12,18,2,30,25,32,64,118]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S){"use strict";var c,g,o,i,r,n,a,t,h,s,d,u,l,p,I,b,m;Object.defineProperty(e,"__esModule",{value:!0}),e.KeywordRecognitionStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.ChatAgentResultFeedbackKind=e.$7M=e.ChatMessageRole=e.InteractiveEditorResponseFeedbackKind=e.$6M=e.ChatVariableLevel=e.ChatAgentCopyKind=e.InteractiveSessionVoteDirection=e.$5M=e.$4M=e.$3M=e.$2M=e.$1M=e.$ZM=e.$YM=e.$XM=e.$WM=e.$VM=e.$UM=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$TM=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.$NM=e.$MM=e.TestRunProfileKind=e.TestResultState=e.$LM=e.$KM=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$JM=e.NotebookVariablesRequestKind=e.$IM=e.$HM=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$GM=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$FM=e.$EM=e.$DM=e.$CM=e.$BM=e.ColorThemeKind=e.$AM=e.$zM=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$yM=e.$xM=e.DebugConsoleMode=e.$wM=e.$vM=e.$uM=e.$tM=e.$sM=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$rM=e.$qM=e.FileChangeType=e.$pM=e.$oM=e.$nM=e.$mM=e.InlineCompletionTriggerKind=e.$lM=e.$kM=e.$jM=e.$iM=e.$hM=e.$gM=e.$fM=e.$eM=e.$dM=e.$cM=e.$bM=e.$aM=e.$_L=e.ConfigurationTarget=e.$$L=e.$0L=e.$9L=e.$8L=e.$7L=e.$6L=e.$5L=e.$4L=e.$3L=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$2L=e.ViewBadge=e.ProgressLocation=e.$1L=e.$ZL=e.TaskScope=e.ShellQuoting=e.$YL=e.$XL=e.$WL=e.TaskPanelKind=e.TaskRevealKind=e.$VL=e.TerminalLocation=e.$UL=e.$TL=e.$SL=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$RL=e.$QL=e.$PL=e.$OL=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.$NL=e.StatusBarAlignment=e.ViewColumn=e.$ML=e.$LL=e.$KL=e.$JL=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$IL=e.$HL=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$GL=e.$FL=e.$EL=e.$DL=e.$CL=e.LanguageStatusSeverity=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.CodeActionTriggerKind=e.$vL=e.$uL=e.SymbolTag=e.SymbolKind=e.$tL=e.$sL=e.DocumentHighlightKind=e.$rL=e.$qL=e.$pL=e.$oL=e.DiagnosticSeverity=e.DiagnosticTag=e.$nL=e.$mL=e.FileEditType=e.$lL=e.$kL=e.$jL=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$iL=e.$hL=e.$gL=e.$fL=e.$eL=e.$dL=e.$cL=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function y(H){return Object.assign(H,{apply:function(...we){if(we.length===0)return Reflect.construct(H,[]);{const Fe=we.length===1?[]:we[1];return Reflect.construct(H,Fe,we[0].constructor)}},call:function(...we){if(we.length===0)return Reflect.construct(H,[]);{const[Fe,...Xe]=we;return Reflect.construct(H,Xe,Fe.constructor)}}})}var L;(function(H){H[H.Top=0]="Top",H[H.Bottom=1]="Bottom"})(L||(e.TerminalOutputAnchor=L={}));var F;(function(H){H[H.TerminalCommand=0]="TerminalCommand",H[H.Opener=1]="Opener",H[H.Command=3]="Command"})(F||(e.TerminalQuickFixType=F={}));let z=c=class{static from(...W){let we=W;return new c(function(){if(we){for(const Fe of we)Fe&&typeof Fe.dispose=="function"&&Fe.dispose();we=void 0}})}#e;constructor(W){this.#e=W}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$cL=z,e.$cL=z=c=Ge([y],z);let T=g=class{static Min(...W){if(W.length===0)throw new TypeError;let we=W[0];for(let Fe=1;Fe<W.length;Fe++){const Xe=W[Fe];Xe.isBefore(we)&&(we=Xe)}return we}static Max(...W){if(W.length===0)throw new TypeError;let we=W[0];for(let Fe=1;Fe<W.length;Fe++){const Xe=W[Fe];Xe.isAfter(we)&&(we=Xe)}return we}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:we,character:Fe}=W;return typeof we=="number"&&typeof Fe=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,we){if(W<0)throw(0,N.$7)("line must be non-negative");if(we<0)throw(0,N.$7)("character must be non-negative");this.c=W,this.e=we}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,we=0){if(W===null||we===null)throw(0,N.$7)();let Fe;return typeof W>"u"?Fe=0:typeof W=="number"?Fe=W:(Fe=typeof W.lineDelta=="number"?W.lineDelta:0,we=typeof W.characterDelta=="number"?W.characterDelta:0),Fe===0&&we===0?this:new g(this.line+Fe,this.character+we)}with(W,we=this.character){if(W===null||we===null)throw(0,N.$7)();let Fe;return typeof W>"u"?Fe=this.line:typeof W=="number"?Fe=W:(Fe=typeof W.line=="number"?W.line:this.line,we=typeof W.character=="number"?W.character:this.character),Fe===this.line&&we===this.character?this:new g(Fe,we)}toJSON(){return{line:this.line,character:this.character}}};e.$dL=T,e.$dL=T=g=Ge([y],T);let O=o=class{static isRange(W){return W instanceof o?!0:W?T.isPosition(W.start)&&T.isPosition(W.end):!1}static of(W){if(W instanceof o)return W;if(this.isRange(W))return new o(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,we,Fe,Xe){let tt,lt;if(typeof W=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Xe=="number"?(tt=new T(W,we),lt=new T(Fe,Xe)):T.isPosition(W)&&T.isPosition(we)&&(tt=T.of(W),lt=T.of(we)),!tt||!lt)throw new Error("Invalid arguments");tt.isBefore(lt)?(this.c=tt,this.e=lt):(this.c=lt,this.e=tt)}contains(W){return o.isRange(W)?this.contains(W.start)&&this.contains(W.end):T.isPosition(W)?!(T.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const we=T.Max(W.start,this.c),Fe=T.Min(W.end,this.e);if(!we.isAfter(Fe))return new o(we,Fe)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const we=T.Min(W.start,this.c),Fe=T.Max(W.end,this.end);return new o(we,Fe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,we=this.end){if(W===null||we===null)throw(0,N.$7)();let Fe;return W?T.isPosition(W)?Fe=W:(Fe=W.start||this.start,we=W.end||this.end):Fe=this.start,Fe.isEqual(this.c)&&we.isEqual(this.end)?this:new o(Fe,we)}toJSON(){return[this.start,this.end]}};e.$eL=O,e.$eL=O=o=Ge([y],O);let M=i=class extends O{static isSelection(W){return W instanceof i?!0:W?O.isRange(W)&&T.isPosition(W.anchor)&&T.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,we,Fe,Xe){let tt,lt;if(typeof W=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Xe=="number"?(tt=new T(W,we),lt=new T(Fe,Xe)):T.isPosition(W)&&T.isPosition(we)&&(tt=T.of(W),lt=T.of(we)),!tt||!lt)throw new Error("Invalid arguments");super(tt,lt),this.f=tt,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$fL=M,e.$fL=M=i=Ge([y],M);const j=H=>{if(typeof H!="string"||H.length===0||!/^[0-9A-Za-z_\-]+$/.test(H))throw(0,N.$7)("connectionToken")};class U{static isResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.host=="string"&&typeof W.port=="number"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,we,Fe){if(typeof W!="string"||W.length===0)throw(0,N.$7)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,N.$7)("port");typeof Fe<"u"&&j(Fe),this.host=W,this.port=Math.round(we),this.connectionToken=Fe}}e.$gL=U;class K{static isManagedResolvedAuthority(W){return W&&typeof W=="object"&&typeof W.makeConnection=="function"&&(W.connectionToken===void 0||typeof W.connectionToken=="string")}constructor(W,we){this.makeConnection=W,this.connectionToken=we,typeof we<"u"&&j(we)}}e.$hL=K;class ue extends Error{static NotAvailable(W,we){return new ue(W,E.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(W){return new ue(W,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,we=E.RemoteAuthorityResolverErrorCode.Unknown,Fe){super(W),this._message=W,this._code=we,this._detail=Fe,Object.setPrototypeOf(this,ue.prototype)}}e.$iL=ue;var X;(function(H){H[H.LF=1]="LF",H[H.CRLF=2]="CRLF"})(X||(e.EndOfLine=X={}));var Q;(function(H){H[H.Replace=1]="Replace",H[H.Append=2]="Append",H[H.Prepend=3]="Prepend"})(Q||(e.EnvironmentVariableMutatorType=Q={}));let Z=r=class{static isTextEdit(W){return W instanceof r?!0:W?O.isRange(W)&&typeof W.newText=="string":!1}static replace(W,we){return new r(W,we)}static insert(W,we){return r.replace(new O(W,W),we)}static delete(W){return r.replace(W,"")}static setEndOfLine(W){const we=new r(new O(new T(0,0),new T(0,0)),"");return we.newEol=W,we}get range(){return this.c}set range(W){if(W&&!O.isRange(W))throw(0,N.$7)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,N.$7)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,N.$7)("newEol");this.f=W}constructor(W,we){this.c=W,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$jL=Z,e.$jL=Z=r=Ge([y],Z);let le=n=class{static isNotebookCellEdit(W){return W instanceof n?!0:W?ni.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,we){return new n(W,we)}static insertCells(W,we){return new n(new ni(W,W),we)}static deleteCells(W){return new n(W,[])}static updateCellMetadata(W,we){const Fe=new n(new ni(W,W),[]);return Fe.newCellMetadata=we,Fe}static updateNotebookMetadata(W){const we=new n(new ni(0,0),[]);return we.newNotebookMetadata=W,we}constructor(W,we){this.range=W,this.newCells=we}};e.$kL=le,e.$kL=le=n=Ge([y],le);class re{static isSnippetTextEdit(W){return W instanceof re?!0:W?O.isRange(W.range)&&J.isSnippetString(W.snippet):!1}static replace(W,we){return new re(W,we)}static insert(W,we){return re.replace(new O(W,W),we)}constructor(W,we){this.range=W,this.snippet=we}}e.$lL=re;var $e;(function(H){H[H.File=1]="File",H[H.Text=2]="Text",H[H.Cell=3]="Cell",H[H.CellReplace=5]="CellReplace",H[H.Snippet=6]="Snippet"})($e||(e.FileEditType=$e={}));let oe=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,we,Fe,Xe){this.c.push({_type:1,from:W,to:we,options:Fe,metadata:Xe})}createFile(W,we,Fe){this.c.push({_type:1,from:void 0,to:W,options:we,metadata:Fe})}deleteFile(W,we,Fe){this.c.push({_type:1,from:W,to:void 0,options:we,metadata:Fe})}e(W,we,Fe){this.c.push({_type:3,metadata:Fe,uri:W,edit:{editType:5,metadata:we},notebookMetadata:we})}f(W,we,Fe,Xe){const tt=we.start,lt=we.end;(tt!==lt||Fe.length>0)&&this.c.push({_type:5,uri:W,index:tt,count:lt-tt,cells:Fe,metadata:Xe})}g(W,we,Fe,Xe){this.c.push({_type:3,metadata:Xe,uri:W,edit:{editType:3,index:we,metadata:Fe}})}replace(W,we,Fe,Xe){this.c.push({_type:2,uri:W,edit:new Z(we,Fe),metadata:Xe})}insert(W,we,Fe,Xe){this.replace(W,new O(we,we),Fe,Xe)}delete(W,we,Fe){this.replace(W,we,"",Fe)}has(W){return this.c.some(we=>we._type===2&&we.uri.toString()===W.toString())}set(W,we){if(we)for(const Fe of we){if(!Fe)continue;let Xe,tt;Array.isArray(Fe)?(Xe=Fe[0],tt=Fe[1]):Xe=Fe,le.isNotebookCellEdit(Xe)?Xe.newCellMetadata?this.g(W,Xe.range.start,Xe.newCellMetadata,tt):Xe.newNotebookMetadata?this.e(W,Xe.newNotebookMetadata,tt):this.f(W,Xe.range,Xe.newCells,tt):re.isSnippetTextEdit(Xe)?this.c.push({_type:6,uri:W,range:Xe.range,edit:Xe.snippet,metadata:tt}):this.c.push({_type:2,uri:W,edit:Xe,metadata:tt})}else{for(let Fe=0;Fe<this.c.length;Fe++){const Xe=this.c[Fe];switch(Xe._type){case 2:case 6:case 3:case 5:Xe.uri.toString()===W.toString()&&(this.c[Fe]=void 0);break}}(0,C.$Ib)(this.c)}}get(W){const we=[];for(const Fe of this.c)Fe._type===2&&Fe.uri.toString()===W.toString()&&we.push(Fe.edit);return we}entries(){const W=new P.$Ac;for(const we of this.c)if(we._type===2){let Fe=W.get(we.uri);Fe||(Fe=[we.uri,[]],W.set(we.uri,Fe)),Fe[1].push(we.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$mL=oe,e.$mL=oe=Ge([y],oe);let J=a=class{static isSnippetString(W){return W instanceof a?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=a.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,we=this.e++){if(typeof W=="function"){const Fe=new a;Fe.e=this.e,W(Fe),this.e=Fe.e,W=Fe.value}else W=a.c(W);return this.value+="${",this.value+=we,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,we=this.e++){const Fe=W.map(Xe=>Xe.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Fe,this.value+="|}",this}appendVariable(W,we){if(typeof we=="function"){const Fe=new a;Fe.e=this.e,we(Fe),this.e=Fe.e,we=Fe.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.$nL=J,e.$nL=J=a=Ge([y],J);var V;(function(H){H[H.Unnecessary=1]="Unnecessary",H[H.Deprecated=2]="Deprecated"})(V||(e.DiagnosticTag=V={}));var ie;(function(H){H[H.Hint=3]="Hint",H[H.Information=2]="Information",H[H.Warning=1]="Warning",H[H.Error=0]="Error"})(ie||(e.DiagnosticSeverity=ie={}));let ye=t=class{static isLocation(W){return W instanceof t?!0:W?O.isRange(W.range)&&k.URI.isUri(W.uri):!1}constructor(W,we){if(this.uri=W,we)if(O.isRange(we))this.range=O.of(we);else if(T.isPosition(we))this.range=new O(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$oL=ye,e.$oL=ye=t=Ge([y],ye);let de=class{static is(W){return W?typeof W.message=="string"&&W.location&&O.isRange(W.location.range)&&k.URI.isUri(W.location.uri):!1}constructor(W,we){this.location=W,this.message=we}static isEqual(W,we){return W===we?!0:!W||!we?!1:W.message===we.message&&W.location.range.isEqual(we.location.range)&&W.location.uri.toString()===we.location.uri.toString()}};e.$pL=de,e.$pL=de=Ge([y],de);let fe=class{constructor(W,we,Fe=ie.Error){if(!O.isRange(W))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=W,this.message=we,this.severity=Fe}toJSON(){return{severity:ie[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,we){return W===we?!0:!W||!we?!1:W.message===we.message&&W.severity===we.severity&&W.code===we.code&&W.severity===we.severity&&W.source===we.source&&W.range.isEqual(we.range)&&(0,C.$ub)(W.tags,we.tags)&&(0,C.$ub)(W.relatedInformation,we.relatedInformation,de.isEqual)}};e.$qL=fe,e.$qL=fe=Ge([y],fe);let _=class{constructor(W,we){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=we}};e.$rL=_,e.$rL=_=Ge([y],_);var ee;(function(H){H[H.Text=0]="Text",H[H.Read=1]="Read",H[H.Write=2]="Write"})(ee||(e.DocumentHighlightKind=ee={}));let G=class{constructor(W,we=ee.Text){this.range=W,this.kind=we}toJSON(){return{range:this.range,kind:ee[this.kind]}}};e.$sL=G,e.$sL=G=Ge([y],G);let x=class{constructor(W,we){this.uri=W,this.highlights=we}toJSON(){return{uri:this.uri,highlights:this.highlights.map(W=>W.toJSON())}}};e.$tL=x,e.$tL=x=Ge([y],x);var me;(function(H){H[H.File=0]="File",H[H.Module=1]="Module",H[H.Namespace=2]="Namespace",H[H.Package=3]="Package",H[H.Class=4]="Class",H[H.Method=5]="Method",H[H.Property=6]="Property",H[H.Field=7]="Field",H[H.Constructor=8]="Constructor",H[H.Enum=9]="Enum",H[H.Interface=10]="Interface",H[H.Function=11]="Function",H[H.Variable=12]="Variable",H[H.Constant=13]="Constant",H[H.String=14]="String",H[H.Number=15]="Number",H[H.Boolean=16]="Boolean",H[H.Array=17]="Array",H[H.Object=18]="Object",H[H.Key=19]="Key",H[H.Null=20]="Null",H[H.EnumMember=21]="EnumMember",H[H.Struct=22]="Struct",H[H.Event=23]="Event",H[H.Operator=24]="Operator",H[H.TypeParameter=25]="TypeParameter"})(me||(e.SymbolKind=me={}));var pe;(function(H){H[H.Deprecated=1]="Deprecated"})(pe||(e.SymbolTag=pe={}));let Re=h=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,we,Fe,Xe,tt){this.name=W,this.kind=we,this.containerName=tt,typeof Fe=="string"&&(this.containerName=Fe),Xe instanceof ye?this.location=Xe:Fe instanceof O&&(this.location=new ye(Xe,Fe)),h.validate(this)}toJSON(){return{name:this.name,kind:me[this.kind],location:this.location,containerName:this.containerName}}};e.$uL=Re,e.$uL=Re=h=Ge([y],Re);let ve=s=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(s.validate)}constructor(W,we,Fe,Xe,tt){this.name=W,this.detail=we,this.kind=Fe,this.range=Xe,this.selectionRange=tt,this.children=[],s.validate(this)}};e.$vL=ve,e.$vL=ve=s=Ge([y],ve);var Ie;(function(H){H[H.Invoke=1]="Invoke",H[H.Automatic=2]="Automatic"})(Ie||(e.CodeActionTriggerKind=Ie={}));let B=class{constructor(W,we){this.title=W,this.kind=we}};e.$wL=B,e.$wL=B=Ge([y],B);let Y=class{static{d=this}static{this.c="."}constructor(W){this.value=W}append(W){return new d(this.value?this.value+d.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+d.c)}};e.$xL=Y,e.$xL=Y=d=Ge([y],Y),Y.Empty=new Y(""),Y.QuickFix=Y.Empty.append("quickfix"),Y.Refactor=Y.Empty.append("refactor"),Y.RefactorExtract=Y.Refactor.append("extract"),Y.RefactorInline=Y.Refactor.append("inline"),Y.RefactorMove=Y.Refactor.append("move"),Y.RefactorRewrite=Y.Refactor.append("rewrite"),Y.Source=Y.Empty.append("source"),Y.SourceOrganizeImports=Y.Source.append("organizeImports"),Y.SourceFixAll=Y.Source.append("fixAll"),Y.Notebook=Y.Empty.append("notebook");let te=class{constructor(W,we){if(this.range=W,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$yL=te,e.$yL=te=Ge([y],te);class q{constructor(W,we,Fe,Xe,tt,lt){this.kind=W,this.name=we,this.detail=Fe,this.uri=Xe,this.range=tt,this.selectionRange=lt}}e.$zL=q;class ae{constructor(W,we){this.fromRanges=we,this.from=W}}e.$AL=ae;class he{constructor(W,we){this.fromRanges=we,this.to=W}}e.$BL=he;var Ae;(function(H){H[H.Information=0]="Information",H[H.Warning=1]="Warning",H[H.Error=2]="Error"})(Ae||(e.LanguageStatusSeverity=Ae={}));let je=class{constructor(W,we){this.range=W,this.command=we}get isResolved(){return!!this.command}};e.$CL=je,e.$CL=je=Ge([y],je);let He=u=class{#e;static isMarkdownString(W){return W instanceof u?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,we=!1){this.#e=new f.$hk(W,{supportThemeIcons:we})}get value(){return this.#e.value}set value(W){this.#e.value=W}get isTrusted(){return this.#e.isTrusted}set isTrusted(W){this.#e.isTrusted=W}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(W){this.#e.supportThemeIcons=W}get supportHtml(){return this.#e.supportHtml}set supportHtml(W){this.#e.supportHtml=W}get baseUri(){return this.#e.baseUri}set baseUri(W){this.#e.baseUri=W}appendText(W){return this.#e.appendText(W),this}appendMarkdown(W){return this.#e.appendMarkdown(W),this}appendCodeblock(W,we){return this.#e.appendCodeblock(we??"",W),this}};e.$DL=He,e.$DL=He=u=Ge([y],He);let Qe=class{constructor(W,we){this.label=W,this.documentation=we}};e.$EL=Qe,e.$EL=Qe=Ge([y],Qe);let _e=class{constructor(W,we){this.label=W,this.documentation=we,this.parameters=[]}};e.$FL=_e,e.$FL=_e=Ge([y],_e);let at=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$GL=at,e.$GL=at=Ge([y],at);var st;(function(H){H[H.Invoke=1]="Invoke",H[H.TriggerCharacter=2]="TriggerCharacter",H[H.ContentChange=3]="ContentChange"})(st||(e.SignatureHelpTriggerKind=st={}));var rt;(function(H){H[H.Type=1]="Type",H[H.Parameter=2]="Parameter"})(rt||(e.InlayHintKind=rt={}));let Pe=class{constructor(W){this.value=W}};e.$HL=Pe,e.$HL=Pe=Ge([y],Pe);let ze=class{constructor(W,we,Fe){this.position=W,this.label=we,this.kind=Fe}};e.$IL=ze,e.$IL=ze=Ge([y],ze);var Le;(function(H){H[H.Invoke=0]="Invoke",H[H.TriggerCharacter=1]="TriggerCharacter",H[H.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Le||(e.CompletionTriggerKind=Le={}));var Ye;(function(H){H[H.Text=0]="Text",H[H.Method=1]="Method",H[H.Function=2]="Function",H[H.Constructor=3]="Constructor",H[H.Field=4]="Field",H[H.Variable=5]="Variable",H[H.Class=6]="Class",H[H.Interface=7]="Interface",H[H.Module=8]="Module",H[H.Property=9]="Property",H[H.Unit=10]="Unit",H[H.Value=11]="Value",H[H.Enum=12]="Enum",H[H.Keyword=13]="Keyword",H[H.Snippet=14]="Snippet",H[H.Color=15]="Color",H[H.File=16]="File",H[H.Reference=17]="Reference",H[H.Folder=18]="Folder",H[H.EnumMember=19]="EnumMember",H[H.Constant=20]="Constant",H[H.Struct=21]="Struct",H[H.Event=22]="Event",H[H.Operator=23]="Operator",H[H.TypeParameter=24]="TypeParameter",H[H.User=25]="User",H[H.Issue=26]="Issue"})(Ye||(e.CompletionItemKind=Ye={}));var ne;(function(H){H[H.Deprecated=1]="Deprecated"})(ne||(e.CompletionItemTag=ne={}));let se=class{constructor(W,we){this.label=W,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&Ye[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$JL=se,e.$JL=se=Ge([y],se);let Ce=class{constructor(W=[],we=!1){this.items=W,this.isIncomplete=we}};e.$KL=Ce,e.$KL=Ce=Ge([y],Ce);let qe=class{constructor(W,we,Fe){this.insertText=W,this.range=we,this.command=Fe}};e.$LL=qe,e.$LL=qe=Ge([y],qe);let Ze=class{constructor(W){this.commands=void 0,this.suppressSuggestions=void 0,this.items=W}};e.$ML=Ze,e.$ML=Ze=Ge([y],Ze);var it;(function(H){H[H.Active=-1]="Active",H[H.Beside=-2]="Beside",H[H.One=1]="One",H[H.Two=2]="Two",H[H.Three=3]="Three",H[H.Four=4]="Four",H[H.Five=5]="Five",H[H.Six=6]="Six",H[H.Seven=7]="Seven",H[H.Eight=8]="Eight",H[H.Nine=9]="Nine"})(it||(e.ViewColumn=it={}));var nt;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(nt||(e.StatusBarAlignment=nt={}));function Oe(H,W){return`${D.$lm.toKey(H)}.${W}`}e.$NL=Oe;var yt;(function(H){H[H.Off=0]="Off",H[H.On=1]="On",H[H.Relative=2]="Relative"})(yt||(e.TextEditorLineNumbersStyle=yt={}));var Dt;(function(H){H[H.Manual=1]="Manual",H[H.AfterDelay=2]="AfterDelay",H[H.FocusOut=3]="FocusOut"})(Dt||(e.TextDocumentSaveReason=Dt={}));var Nt;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(Nt||(e.TextEditorRevealType=Nt={}));var Tt;(function(H){H[H.Keyboard=1]="Keyboard",H[H.Mouse=2]="Mouse",H[H.Command=3]="Command"})(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Et;(function(H){H[H.Undo=1]="Undo",H[H.Redo=2]="Redo"})(Et||(e.TextDocumentChangeReason=Et={}));var Ht;(function(H){H[H.OpenOpen=0]="OpenOpen",H[H.ClosedClosed=1]="ClosedClosed",H[H.OpenClosed=2]="OpenClosed",H[H.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(H){function W(we){switch(we){case"keyboard":return H.Keyboard;case"mouse":return H.Mouse;case"api":return H.Command}}H.fromValue=W}(Tt||(e.TextEditorSelectionChangeKind=Tt={}));var Ot;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(Ot||(e.SyntaxTokenType=Ot={})),function(H){function W(we){switch(we){case H.Other:return"other";case H.Comment:return"comment";case H.String:return"string";case H.RegEx:return"regex"}return"other"}H.toString=W}(Ot||(e.SyntaxTokenType=Ot={}));let Zt=class{constructor(W,we){if(we&&!k.URI.isUri(we))throw(0,N.$7)("target");if(!O.isRange(W)||W.isEmpty)throw(0,N.$7)("range");this.range=W,this.target=we}};e.$OL=Zt,e.$OL=Zt=Ge([y],Zt);let Wt=class{constructor(W,we,Fe,Xe){this.red=W,this.green=we,this.blue=Fe,this.alpha=Xe}};e.$PL=Wt,e.$PL=Wt=Ge([y],Wt);let Ut=class{constructor(W,we){if(we&&!(we instanceof Wt))throw(0,N.$7)("color");if(!O.isRange(W)||W.isEmpty)throw(0,N.$7)("range");this.range=W,this.color=we}};e.$QL=Ut,e.$QL=Ut=Ge([y],Ut);let et=class{constructor(W){if(!W||typeof W!="string")throw(0,N.$7)("label");this.label=W}};e.$RL=et,e.$RL=et=Ge([y],et);var Gt;(function(H){H[H.RGB=0]="RGB",H[H.HEX=1]="HEX",H[H.HSL=2]="HSL"})(Gt||(e.ColorFormat=Gt={}));var Kt;(function(H){H[H.Error=0]="Error",H[H.Warning=1]="Warning",H[H.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var ht;(function(H){H[H.Unknown=0]="Unknown",H[H.Shutdown=1]="Shutdown",H[H.Process=2]="Process",H[H.User=3]="User",H[H.Extension=4]="Extension"})(ht||(e.TerminalExitReason=ht={}));class $t{constructor(W,we,Fe){if(this.startIndex=W,this.length=we,this.tooltip=Fe,typeof W!="number"||W<0)throw(0,N.$7)("startIndex");if(typeof we!="number"||we<1)throw(0,N.$7)("length");if(Fe!==void 0&&typeof Fe!="string")throw(0,N.$7)("tooltip")}}e.$SL=$t;class Bt{constructor(W){this.uri=W}}e.$TL=Bt;class Qt{constructor(W){this.terminalCommand=W}}e.$UL=Qt;var kt;(function(H){H[H.Panel=1]="Panel",H[H.Editor=2]="Editor"})(kt||(e.TerminalLocation=kt={}));class ft{constructor(W){if(this.options=W,typeof W!="object")throw(0,N.$7)("options")}}e.$VL=ft;var It;(function(H){H[H.Always=1]="Always",H[H.Silent=2]="Silent",H[H.Never=3]="Never"})(It||(e.TaskRevealKind=It={}));var _t;(function(H){H[H.Shared=1]="Shared",H[H.Dedicated=2]="Dedicated",H[H.New=3]="New"})(_t||(e.TaskPanelKind=_t={}));let Lt=class{static{l=this}static{this.Clean=new l("clean","Clean")}static{this.Build=new l("build","Build")}static{this.Rebuild=new l("rebuild","Rebuild")}static{this.Test=new l("test","Test")}static from(W){switch(W){case"clean":return l.Clean;case"build":return l.Build;case"rebuild":return l.Rebuild;case"test":return l.Test;default:return}}constructor(W,we){if(this.label=we,typeof W!="string"||typeof we!="string")throw(0,N.$7)("name");this.c=W}get id(){return this.c}};e.$WL=Lt,e.$WL=Lt=l=Ge([y],Lt);function Ke(H){let W="";for(let we=0;we<H.length;we++)W+=H[we].replace(/,/g,",,")+",";return W}let Mt=class{constructor(W,we,Fe){if(typeof W!="string")throw(0,N.$7)("process");this.e=[],this.c=W,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Fe):this.f=we)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,N.$7)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const we of this.e)W.push(we);return Ke(W)}};e.$XL=Mt,e.$XL=Mt=Ge([y],Mt);let jt=class{constructor(W,we,Fe){if(this.f=[],Array.isArray(we)){if(!W)throw(0,N.$7)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,N.$7)("command");this.e=W,this.f=we,this.g=Fe}else{if(typeof W!="string")throw(0,N.$7)("commandLine");this.c=W,this.g=we}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,N.$7)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,N.$7)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)W.push(typeof we=="string"?we:we.value);return Ke(W)}};e.$YL=jt,e.$YL=jt=Ge([y],jt);var Yt;(function(H){H[H.Escape=1]="Escape",H[H.Strong=2]="Strong",H[H.Weak=3]="Weak"})(Yt||(e.ShellQuoting=Yt={}));var gt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace"})(gt||(e.TaskScope=gt={}));class Ft{constructor(W){this.c=W}computeId(){return"customExecution"+(0,A.$qg)()}set callback(W){this.c=W}get callback(){return this.c}}e.$ZL=Ft;let Rt=class{static{p=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(W,we,Fe,Xe,tt,lt){this.k=!1,this.l=this.definition=W;let mt;typeof we=="string"?(this.n=this.name=we,this.u=this.source=Fe,this.execution=Xe,mt=tt,this.k=!0):we===gt.Global||we===gt.Workspace?(this.target=we,this.n=this.name=Fe,this.u=this.source=Xe,this.execution=tt,mt=lt):(this.target=we,this.n=this.name=Fe,this.u=this.source=Xe,this.execution=tt,mt=lt),typeof mt=="string"?(this.q=[mt],this.r=!0):Array.isArray(mt)?(this.q=mt,this.r=!0):(this.q=[],this.r=!1),this.t=!1,this.x=Object.create(null),this.y=Object.create(null)}get _id(){return this.j}set _id(W){this.j=W}get _deprecated(){return this.k}A(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.B())}B(){this.o instanceof Mt?this.l={type:p.e,id:this.o.computeId()}:this.o instanceof jt?this.l={type:p.f,id:this.o.computeId()}:this.o instanceof Ft?this.l={type:p.c,id:this.o.computeId()}:this.l={type:p.g,id:(0,A.$qg)()}}get definition(){return this.l}set definition(W){if(W==null)throw(0,N.$7)("Kind can't be undefined or null");this.A(),this.l=W}get scope(){return this.m}set target(W){this.A(),this.m=W}get name(){return this.n}set name(W){if(typeof W!="string")throw(0,N.$7)("name");this.A(),this.n=W}get execution(){return this.o}set execution(W){W===null&&(W=void 0),this.A(),this.o=W;const we=this.l.type;(p.g===we||p.e===we||p.f===we||p.c===we)&&this.B()}get problemMatchers(){return this.q}set problemMatchers(W){if(Array.isArray(W))this.A(),this.q=W,this.r=!0;else{this.A(),this.q=[],this.r=!1;return}}get hasDefinedMatchers(){return this.r}get isBackground(){return this.t}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.A(),this.t=W}get source(){return this.u}set source(W){if(typeof W!="string"||W.length===0)throw(0,N.$7)("source must be a string of length > 0");this.A(),this.u=W}get group(){return this.w}set group(W){W===null&&(W=void 0),this.A(),this.w=W}get detail(){return this.z}set detail(W){W===null&&(W=void 0),this.z=W}get presentationOptions(){return this.x}set presentationOptions(W){W==null&&(W=Object.create(null)),this.A(),this.x=W}get runOptions(){return this.y}set runOptions(W){W==null&&(W=Object.create(null)),this.A(),this.y=W}};e.$1L=Rt,e.$1L=Rt=p=Ge([y],Rt);var Vt;(function(H){H[H.SourceControl=1]="SourceControl",H[H.Window=10]="Window",H[H.Notification=15]="Notification"})(Vt||(e.ProgressLocation=Vt={}));var Me;(function(H){function W(we){const Fe=we;return(0,$.$Mf)(Fe.value)?Fe.tooltip&&!(0,$.$If)(Fe.tooltip)?(console.log("INVALID view badge, invalid tooltip",Fe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Fe.value),!1)}H.isViewBadge=W})(Me||(e.ViewBadge=Me={}));let Te=I=class{static isTreeItem(W,we){const Fe=W;if(Fe.checkboxState!==void 0){const Xe=(0,$.$Mf)(Fe.checkboxState)?Fe.checkboxState:(0,$.$Kf)(Fe.checkboxState)&&(0,$.$Mf)(Fe.checkboxState.state)?Fe.checkboxState.state:void 0,tt=!(0,$.$Mf)(Fe.checkboxState)&&(0,$.$Kf)(Fe.checkboxState)?Fe.checkboxState.tooltip:void 0;if(Xe===void 0||Xe!==ce.Checked&&Xe!==ce.Unchecked||tt!==void 0&&!(0,$.$If)(tt))return console.log("INVALID tree item, invalid checkboxState",Fe.checkboxState),!1}if(W instanceof I)return!0;if(Fe.label!==void 0&&!(0,$.$If)(Fe.label)&&!Fe.label?.label)return console.log("INVALID tree item, invalid label",Fe.label),!1;if(Fe.id!==void 0&&!(0,$.$If)(Fe.id))return console.log("INVALID tree item, invalid id",Fe.id),!1;if(Fe.iconPath!==void 0&&!(0,$.$If)(Fe.iconPath)&&!k.URI.isUri(Fe.iconPath)&&(!Fe.iconPath||!(0,$.$If)(Fe.iconPath.id))){const Xe=Fe.iconPath;if(!Xe||!(0,$.$If)(Xe.light)&&!k.URI.isUri(Xe.light)&&!(0,$.$If)(Xe.dark)&&!k.URI.isUri(Xe.dark))return console.log("INVALID tree item, invalid iconPath",Fe.iconPath),!1}return Fe.description!==void 0&&!(0,$.$If)(Fe.description)&&typeof Fe.description!="boolean"?(console.log("INVALID tree item, invalid description",Fe.description),!1):Fe.resourceUri!==void 0&&!k.URI.isUri(Fe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Fe.resourceUri),!1):Fe.tooltip!==void 0&&!(0,$.$If)(Fe.tooltip)&&!(Fe.tooltip instanceof He)?(console.log("INVALID tree item, invalid tooltip",Fe.tooltip),!1):Fe.command!==void 0&&!Fe.command.command?(console.log("INVALID tree item, invalid command",Fe.command),!1):Fe.collapsibleState!==void 0&&Fe.collapsibleState<De.None&&Fe.collapsibleState>De.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Fe.collapsibleState),!1):Fe.contextValue!==void 0&&!(0,$.$If)(Fe.contextValue)?(console.log("INVALID tree item, invalid contextValue",Fe.contextValue),!1):Fe.accessibilityInformation!==void 0&&!Fe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Fe.accessibilityInformation),!1):!0}constructor(W,we=De.None){this.collapsibleState=we,k.URI.isUri(W)?this.resourceUri=W:this.label=W}};e.$2L=Te,e.$2L=Te=I=Ge([y],Te);var De;(function(H){H[H.None=0]="None",H[H.Collapsed=1]="Collapsed",H[H.Expanded=2]="Expanded"})(De||(e.TreeItemCollapsibleState=De={}));var ce;(function(H){H[H.Unchecked=0]="Unchecked",H[H.Checked=1]="Checked"})(ce||(e.TreeItemCheckboxState=ce={}));let Ne=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W){this.value=W}};e.$3L=Ne,e.$3L=Ne=Ge([y],Ne);class Be extends Ne{}e.$4L=Be;class xe extends Be{#e;constructor(W){super(""),this.#e=W}asFile(){return this.#e}}e.$5L=xe;class Je{constructor(W,we,Fe,Xe){this.name=W,this.uri=we,this._itemId=Fe,this.c=Xe}data(){return this.c()}}e.$6L=Je;let ct=class{#e=new Map;constructor(W){for(const[we,Fe]of W??[]){const Xe=this.#e.get(this.#t(we));Xe?Xe.push(Fe):this.#e.set(this.#t(we),[Fe])}}get(W){return this.#e.get(this.#t(W))?.[0]}set(W,we){this.#e.set(this.#t(W),[we])}forEach(W,we){for(const[Fe,Xe]of this.#e)for(const tt of Xe)W.call(we,tt,Fe,this)}*[Symbol.iterator](){for(const[W,we]of this.#e)for(const Fe of we)yield[W,Fe]}#t(W){return W.toLowerCase()}};e.$7L=ct,e.$7L=ct=Ge([y],ct);let pt=class{constructor(W){this.insertText=W}};e.$8L=pt,e.$8L=pt=Ge([y],pt);let Jt=class{constructor(W,we){this.label=we,this.insertText=W}};e.$9L=Jt,e.$9L=Jt=Ge([y],Jt);let St=class{constructor(W,we){this.id=W,this.color=we}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};e.$0L=St,e.$0L=St=Ge([y],St),St.File=new St("file"),St.Folder=new St("folder");let Ct=class{constructor(W){this.id=W}};e.$$L=Ct,e.$$L=Ct=Ge([y],Ct);var vt;(function(H){H[H.Global=1]="Global",H[H.Workspace=2]="Workspace",H[H.WorkspaceFolder=3]="WorkspaceFolder"})(vt||(e.ConfigurationTarget=vt={}));let Si=class{get base(){return this.c}set base(W){this.c=W,this.e=k.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,we){if(typeof W!="string"&&(!W||!k.URI.isUri(W)&&!k.URI.isUri(W.uri)))throw(0,N.$7)("base");if(typeof we!="string")throw(0,N.$7)("pattern");typeof W=="string"?this.baseUri=k.URI.file(W):k.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$_L=Si,e.$_L=Si=Ge([y],Si);const Ji=new WeakMap;function Pt(H,W){Ji.set(H,W)}e.$aM=Pt;let si=class{constructor(W,we,Fe,Xe){this.enabled=typeof W=="boolean"?W:!0,typeof we=="string"&&(this.condition=we),typeof Fe=="string"&&(this.hitCondition=Fe),typeof Xe=="string"&&(this.logMessage=Xe)}get id(){return this.c||(this.c=Ji.get(this)??(0,A.$qg)()),this.c}};e.$bM=si,e.$bM=si=Ge([y],si);let mi=class extends si{constructor(W,we,Fe,Xe,tt){if(super(we,Fe,Xe,tt),W===null)throw(0,N.$7)("location");this.location=W}};e.$cM=mi,e.$cM=mi=Ge([y],mi);let ui=class extends si{constructor(W,we,Fe,Xe,tt){super(we,Fe,Xe,tt),this.functionName=W}};e.$dM=ui,e.$dM=ui=Ge([y],ui);let Di=class extends si{constructor(W,we,Fe,Xe,tt,lt,mt){if(super(Xe,tt,lt,mt),!we)throw(0,N.$7)("dataId");this.label=W,this.dataId=we,this.canPersist=Fe}};e.$eM=Di,e.$eM=Di=Ge([y],Di);let Ci=class{constructor(W,we,Fe){this.command=W,this.args=we||[],this.options=Fe}};e.$fM=Ci,e.$fM=Ci=Ge([y],Ci);let zt=class{constructor(W,we){this.port=W,this.host=we}};e.$gM=zt,e.$gM=zt=Ge([y],zt);let $i=class{constructor(W){this.path=W}};e.$hM=$i,e.$hM=$i=Ge([y],$i);let Ii=class{constructor(W){this.implementation=W}};e.$iM=Ii,e.$iM=Ii=Ge([y],Ii);let li=class{constructor(W,we,Fe){this.session=W,this.threadId=we,this.frameId=Fe}};e.$jM=li,e.$jM=li=Ge([y],li);let hi=class{constructor(W,we){this.session=W,this.threadId=we}};e.$kM=hi,e.$kM=hi=Ge([y],hi);let dt=class{constructor(W,we){this.range=W,this.expression=we}};e.$lM=dt,e.$lM=dt=Ge([y],dt);var Ki;(function(H){H[H.Invoke=0]="Invoke",H[H.Automatic=1]="Automatic"})(Ki||(e.InlineCompletionTriggerKind=Ki={}));let ei=class{constructor(W,we){this.range=W,this.text=we}};e.$mM=ei,e.$mM=ei=Ge([y],ei);let oi=class{constructor(W,we,Fe=!0){this.range=W,this.variableName=we,this.caseSensitiveLookup=Fe}};e.$nM=oi,e.$nM=oi=Ge([y],oi);let bi=class{constructor(W,we){this.range=W,this.expression=we}};e.$oM=bi,e.$oM=bi=Ge([y],bi);let Pi=class{constructor(W,we){this.frameId=W,this.stoppedLocation=we}};e.$pM=Pi,e.$pM=Pi=Ge([y],Pi);var Qi;(function(H){H[H.Changed=1]="Changed",H[H.Created=2]="Created",H[H.Deleted=3]="Deleted"})(Qi||(e.FileChangeType=Qi={}));let Li=b=class extends Error{static FileExists(W){return new b(W,w.FileSystemProviderErrorCode.FileExists,b.FileExists)}static FileNotFound(W){return new b(W,w.FileSystemProviderErrorCode.FileNotFound,b.FileNotFound)}static FileNotADirectory(W){return new b(W,w.FileSystemProviderErrorCode.FileNotADirectory,b.FileNotADirectory)}static FileIsADirectory(W){return new b(W,w.FileSystemProviderErrorCode.FileIsADirectory,b.FileIsADirectory)}static NoPermissions(W){return new b(W,w.FileSystemProviderErrorCode.NoPermissions,b.NoPermissions)}static Unavailable(W){return new b(W,w.FileSystemProviderErrorCode.Unavailable,b.Unavailable)}constructor(W,we=w.FileSystemProviderErrorCode.Unknown,Fe){super(k.URI.isUri(W)?W.toString(!0):W),this.code=Fe?.name??"Unknown",(0,w.$Fk)(this,we),Object.setPrototypeOf(this,b.prototype),typeof Error.captureStackTrace=="function"&&typeof Fe=="function"&&Error.captureStackTrace(this,Fe)}};e.$qM=Li,e.$qM=Li=b=Ge([y],Li);let wi=class{constructor(W,we,Fe){this.start=W,this.end=we,this.kind=Fe}};e.$rM=wi,e.$rM=wi=Ge([y],wi);var Yi;(function(H){H[H.Comment=1]="Comment",H[H.Imports=2]="Imports",H[H.Region=3]="Region"})(Yi||(e.FoldingRangeKind=Yi={}));var Ri;(function(H){H[H.Collapsed=0]="Collapsed",H[H.Expanded=1]="Expanded"})(Ri||(e.CommentThreadCollapsibleState=Ri={}));var di;(function(H){H[H.Editing=0]="Editing",H[H.Preview=1]="Preview"})(di||(e.CommentMode=di={}));var Zi;(function(H){H[H.Published=0]="Published",H[H.Draft=1]="Draft"})(Zi||(e.CommentState=Zi={}));var vi;(function(H){H[H.Unresolved=0]="Unresolved",H[H.Resolved=1]="Resolved"})(vi||(e.CommentThreadState=vi={}));class Ai{constructor(W,we=[]){this.tokenTypes=W,this.tokenModifiers=we}}e.$sM=Ai;function ln(H){return typeof H>"u"||(0,$.$Jf)(H)}class Mi{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,W){this.m=!0;for(let we=0,Fe=W.tokenTypes.length;we<Fe;we++)this.k.set(W.tokenTypes[we],we);for(let we=0,Fe=W.tokenModifiers.length;we<Fe;we++)this.l.set(W.tokenModifiers[we],we)}}push(W,we,Fe,Xe,tt){if(typeof W=="number"&&typeof we=="number"&&typeof Fe=="number"&&typeof Xe=="number"&&(typeof tt=="number"||typeof tt>"u"))return typeof tt>"u"&&(tt=0),this.o(W,we,Fe,Xe,tt);if(O.isRange(W)&&typeof we=="string"&&ln(Fe))return this.n(W,we,Fe);throw(0,N.$7)()}n(W,we,Fe){if(!this.m)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(we))throw new Error("`tokenType` is not in the provided legend");const Xe=W.start.line,tt=W.start.character,lt=W.end.character-W.start.character,mt=this.k.get(we);let qt=0;if(Fe)for(const xt of Fe){if(!this.l.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const ii=this.l.get(xt);qt|=1<<ii>>>0}this.o(Xe,tt,lt,mt,qt)}o(W,we,Fe,Xe,tt){if(this.f&&(W<this.c||W===this.c&&we<this.e)){this.f=!1;const qt=this.g.length/5|0;let xt=0,ii=0;for(let ri=0;ri<qt;ri++){let ci=this.g[5*ri],Hi=this.g[5*ri+1];ci===0?(ci=xt,Hi+=ii):ci+=xt,this.g[5*ri]=ci,this.g[5*ri+1]=Hi,xt=ci,ii=Hi}}let lt=W,mt=we;this.f&&this.j>0&&(lt-=this.c,lt===0&&(mt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=mt,this.g[this.j++]=Fe,this.g[this.j++]=Xe,this.g[this.j++]=tt,this.c=W,this.e=we}static q(W){const we=[],Fe=W.length/5|0;for(let mt=0;mt<Fe;mt++)we[mt]=mt;we.sort((mt,qt)=>{const xt=W[5*mt],ii=W[5*qt];if(xt===ii){const ri=W[5*mt+1],ci=W[5*qt+1];return ri-ci}return xt-ii});const Xe=new Uint32Array(W.length);let tt=0,lt=0;for(let mt=0;mt<Fe;mt++){const qt=5*we[mt],xt=W[qt+0],ii=W[qt+1],ri=W[qt+2],ci=W[qt+3],Hi=W[qt+4],In=xt-tt,Un=In===0?ii-lt:ii,Gi=5*mt;Xe[Gi+0]=In,Xe[Gi+1]=Un,Xe[Gi+2]=ri,Xe[Gi+3]=ci,Xe[Gi+4]=Hi,tt=xt,lt=ii}return Xe}build(W){return this.f?new ai(new Uint32Array(this.g),W):new ai(Mi.q(this.g),W)}}e.$tM=Mi;class ai{constructor(W,we){this.resultId=we,this.data=W}}e.$uM=ai;class hn{constructor(W,we,Fe){this.start=W,this.deleteCount=we,this.data=Fe}}e.$vM=hn;class dn{constructor(W,we){this.resultId=we,this.edits=W}}e.$wM=dn;var Xi;(function(H){H[H.Separate=0]="Separate",H[H.MergeWithParent=1]="MergeWithParent"})(Xi||(e.DebugConsoleMode=Xi={}));class Fi{constructor(W){this.name=W}}e.$xM=Fi;let Ni=class{static{this.Back={iconPath:new St("arrow-left")}}constructor(){}};e.$yM=Ni,e.$yM=Ni=Ge([y],Ni);var xi;(function(H){H[H.Separator=-1]="Separator",H[H.Default=0]="Default"})(xi||(e.QuickPickItemKind=xi={}));var pi;(function(H){H[H.Info=1]="Info",H[H.Warning=2]="Warning",H[H.Error=3]="Error"})(pi||(e.InputBoxValidationSeverity=pi={}));var Ti;(function(H){H[H.UI=1]="UI",H[H.Workspace=2]="Workspace"})(Ti||(e.ExtensionKind=Ti={}));class fn{static validate(W){if(typeof W.badge=="string"){let we=(0,v.$jf)(W.badge,0);if(we<W.badge.length&&(we+=(0,v.$jf)(W.badge,we)),W.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!St.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,we,Fe){this.badge=W,this.tooltip=we,this.color=Fe}}e.$zM=fn;let yi=class{constructor(W){this.kind=W}};e.$AM=yi,e.$AM=yi=Ge([y],yi);var Oi;(function(H){H[H.Light=1]="Light",H[H.Dark=2]="Dark",H[H.HighContrast=3]="HighContrast",H[H.HighContrastLight=4]="HighContrastLight"})(Oi||(e.ColorThemeKind=Oi={}));class ni{static isNotebookRange(W){return W instanceof ni?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,we){if(W<0)throw(0,N.$7)("start must be positive");if(we<0)throw(0,N.$7)("end must be positive");W<=we?(this.c=W,this.e=we):(this.c=we,this.e=W)}with(W){let we=this.c,Fe=this.e;return W.start!==void 0&&(we=W.start),W.end!==void 0&&(Fe=W.end),we===this.c&&Fe===this.e?this:new ni(we,Fe)}}e.$BM=ni;class Ei{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(we=>Ei.isNotebookCellData(we))}static isNotebookCellData(W){return!0}constructor(W,we,Fe,Xe,tt,lt,mt){this.kind=W,this.value=we,this.languageId=Fe,this.mime=Xe,this.outputs=tt??[],this.metadata=lt,this.executionSummary=mt,Ei.validate(this)}}e.$CM=Ei;class gn{constructor(W){this.cells=W}}e.$DM=gn;class Xt{static isNotebookCellOutputItem(W){return W instanceof Xt?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const we={name:W.name,message:W.message,stack:W.stack};return Xt.json(we,"application/vnd.code.notebook.error")}static stdout(W){return Xt.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return Xt.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,we="application/octet-stream"){return new Xt(W,we)}static#e=new TextEncoder;static text(W,we=R.$fs.text){const Fe=Xt.#e.encode(String(W));return new Xt(Fe,we)}static json(W,we="text/x-json"){const Fe=JSON.stringify(W,void 0,"	");return Xt.text(Fe,we)}constructor(W,we){this.data=W,this.mime=we;const Fe=(0,R.$js)(we,!0);if(!Fe)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Fe}}e.$EM=Xt;class fi{static isNotebookCellOutput(W){return W instanceof fi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,we=!1){const Fe=new Set,Xe=new Set;for(let tt=0;tt<W.length;tt++){const lt=W[tt],mt=(0,R.$js)(lt.mime);if(!Fe.has(mt)||(0,S.$eJ)(mt)){Fe.add(mt);continue}Xe.add(tt),we&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Xe.size===0?W:W.filter((tt,lt)=>!Xe.has(lt))}constructor(W,we,Fe){this.items=fi.ensureUniqueMimeTypes(W,!0),typeof we=="string"?(this.id=we,this.metadata=Fe):(this.id=(0,A.$qg)(),this.metadata=we??Fe)}}e.$FM=fi;var ji;(function(H){H[H.Markup=1]="Markup",H[H.Code=2]="Code"})(ji||(e.NotebookCellKind=ji={}));var Ve;(function(H){H[H.Idle=1]="Idle",H[H.Pending=2]="Pending",H[H.Executing=3]="Executing"})(Ve||(e.NotebookCellExecutionState=Ve={}));var ti;(function(H){H[H.Left=1]="Left",H[H.Right=2]="Right"})(ti||(e.NotebookCellStatusBarAlignment=ti={}));var zi;(function(H){H[H.Default=0]="Default",H[H.InCenter=1]="InCenter",H[H.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",H[H.AtTop=3]="AtTop"})(zi||(e.NotebookEditorRevealType=zi={}));class ot{constructor(W,we){this.text=W,this.alignment=we}}e.$GM=ot;var bt;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred"})(bt||(e.NotebookControllerAffinity=bt={}));var _i;(function(H){H[H.Default=1]="Default",H[H.Preferred=2]="Preferred",H[H.Hidden=-1]="Hidden"})(_i||(e.NotebookControllerAffinity2=_i={}));class mn{constructor(W,we=[]){this.uri=W,this.provides=(0,C.$3b)(we)}}e.$HM=mn;class en{constructor(W){this.label=W}}e.$IM=en;var tn;(function(H){H[H.Named=1]="Named",H[H.Indexed=2]="Indexed"})(tn||(e.NotebookVariablesRequestKind=tn={}));let gi=class{constructor(W,we){this.label=W,this.timestamp=we}};e.$JM=gi,e.$JM=gi=Ge([y],gi);var nn;(function(H){H[H.Production=1]="Production",H[H.Development=2]="Development",H[H.Test=3]="Test"})(nn||(e.ExtensionMode=nn={}));var rn;(function(H){H[H.Node=1]="Node",H[H.Webworker=2]="Webworker"})(rn||(e.ExtensionRuntime=rn={}));var sn;(function(H){H[H.Other=0]="Other",H[H.Comment=1]="Comment",H[H.String=2]="String",H[H.RegEx=3]="RegEx"})(sn||(e.StandardTokenType=sn={}));class on{constructor(W,we){this.ranges=W,this.wordPattern=we}}e.$KM=on;class $n{constructor(W){this.c=W}get autoForwardAction(){return this.c}}e.$LM=$n;var an;(function(H){H[H.Queued=1]="Queued",H[H.Running=2]="Running",H[H.Passed=3]="Passed",H[H.Failed=4]="Failed",H[H.Skipped=5]="Skipped",H[H.Errored=6]="Errored"})(an||(e.TestResultState=an={}));var cn;(function(H){H[H.Run=1]="Run",H[H.Debug=2]="Debug",H[H.Coverage=3]="Coverage"})(cn||(e.TestRunProfileKind=cn={}));let Ui=class{constructor(W=void 0,we=void 0,Fe=void 0,Xe=!1){this.include=W,this.exclude=we,this.profile=Fe,this.continuous=Xe}};e.$MM=Ui,e.$MM=Ui=Ge([y],Ui);let Bi=m=class{static diff(W,we,Fe){const Xe=new m(W);return Xe.expectedOutput=we,Xe.actualOutput=Fe,Xe}constructor(W){this.message=W}};e.$NM=Bi,e.$NM=Bi=m=Ge([y],Bi);let Vi=class{constructor(W){this.id=W}};e.$OM=Vi,e.$OM=Vi=Ge([y],Vi);class ki{constructor(W,we){this.covered=W,this.total=we}}e.$PM=ki;const Wi=H=>{if(H&&H.covered>H.total)throw new Error(`The total number of covered items (${H.covered}) cannot be greater than the total (${H.total})`)};class qi{static fromDetails(W,we){const Fe=new ki(0,0),Xe=new ki(0,0),tt=new ki(0,0);for(const mt of we)if("branches"in mt){Fe.total+=1,Fe.covered+=mt.executionCount>0?1:0;for(const qt of mt.branches)Xe.total+=1,Xe.covered+=qt.executionCount>0?1:0}else tt.total+=1,tt.covered+=mt.executionCount>0?1:0;const lt=new qi(W,Fe,Xe.total>0?Xe:void 0,tt.total>0?tt:void 0);return lt.detailedCoverage=we,lt}constructor(W,we,Fe,Xe){this.uri=W,this.statementCoverage=we,this.branchCoverage=Fe,this.functionCoverage=Xe,Wi(we),Wi(Fe),Wi(Xe)}}e.$QM=qi;class bn{constructor(W,we,Fe=[]){this.executionCount=W,this.location=we,this.branches=Fe}}e.$RM=bn;class be{constructor(W,we,Fe){this.executionCount=W,this.location=we,this.label=Fe}}e.$SM=be;class Ee{constructor(W,we,Fe){this.name=W,this.executionCount=we,this.location=Fe}}e.$TM=Ee;var Ue;(function(H){H[H.None=0]="None",H[H.Option=1]="Option",H[H.Default=2]="Default",H[H.Preferred=3]="Preferred"})(Ue||(e.ExternalUriOpenerPriority=Ue={}));var ut;(function(H){H[H.Untrusted=0]="Untrusted",H[H.Trusted=1]="Trusted",H[H.Unspecified=2]="Unspecified"})(ut||(e.WorkspaceTrustState=ut={}));var wt;(function(H){H[H.Notify=1]="Notify",H[H.OpenBrowser=2]="OpenBrowser",H[H.OpenPreview=3]="OpenPreview",H[H.Silent=4]="Silent",H[H.Ignore=5]="Ignore",H[H.OpenBrowserOnce=6]="OpenBrowserOnce"})(wt||(e.PortAutoForwardAction=wt={}));class At{constructor(W,we,Fe,Xe,tt,lt){this.kind=W,this.name=we,this.detail=Fe,this.uri=Xe,this.range=tt,this.selectionRange=lt}}e.$UM=At;class un{constructor(W){this.uri=W}}e.$VM=un;class Pn{constructor(W,we){this.original=W,this.modified=we}}e.$WM=Pn;class Ln{constructor(W,we,Fe,Xe){this.base=W,this.input1=we,this.input2=Fe,this.result=Xe}}e.$XM=Ln;class Rn{constructor(W,we){this.uri=W,this.viewType=we}}e.$YM=Rn;class An{constructor(W){this.viewType=W}}e.$ZM=An;class Mn{constructor(W,we){this.uri=W,this.notebookType=we}}e.$1M=Mn;class Fn{constructor(W,we,Fe){this.original=W,this.modified=we,this.notebookType=Fe}}e.$2M=Fn;class Nn{constructor(){}}e.$3M=Nn;class Tn{constructor(W,we){this.uri=W,this.inputBoxUri=we}}e.$4M=Tn;class On{constructor(W){this.providerId=W}}e.$5M=On;var wn;(function(H){H[H.Down=0]="Down",H[H.Up=1]="Up"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var vn;(function(H){H[H.Action=1]="Action",H[H.Toolbar=2]="Toolbar"})(vn||(e.ChatAgentCopyKind=vn={}));var pn;(function(H){H[H.Short=1]="Short",H[H.Medium=2]="Medium",H[H.Full=3]="Full"})(pn||(e.ChatVariableLevel=pn={}));class jn{constructor(W,we){this.label=W,this.values=we}}e.$6M=jn;var yn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful",H[H.Undone=2]="Undone",H[H.Accepted=3]="Accepted",H[H.Bug=4]="Bug"})(yn||(e.InteractiveEditorResponseFeedbackKind=yn={}));var En;(function(H){H[H.System=0]="System",H[H.User=1]="User",H[H.Assistant=2]="Assistant",H[H.Function=3]="Function"})(En||(e.ChatMessageRole=En={}));class zn{constructor(W,we){this.role=W,this.content=we}}e.$7M=zn;var kn;(function(H){H[H.Unhelpful=0]="Unhelpful",H[H.Helpful=1]="Helpful"})(kn||(e.ChatAgentResultFeedbackKind=kn={}));var Sn;(function(H){H[H.SymbolInformation=1]="SymbolInformation",H[H.CommandInformation=2]="CommandInformation",H[H.SearchInformation=3]="SearchInformation",H[H.SettingInformation=4]="SettingInformation"})(Sn||(e.RelatedInformationType=Sn={}));var Dn;(function(H){H[H.Started=1]="Started",H[H.Recognizing=2]="Recognizing",H[H.Recognized=3]="Recognized",H[H.Stopped=4]="Stopped"})(Dn||(e.SpeechToTextStatus=Dn={}));var Cn;(function(H){H[H.Recognized=1]="Recognized",H[H.Stopped=2]="Stopped"})(Cn||(e.KeywordRecognitionStatus=Cn={}))}),define(ke[311],Se([1,0,6,7]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fgc=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$aL.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(R,v,$){if(this.a.size===0)throw new Error("No related information providers registered");const k=this.a.get(R);if(!k)throw new Error("related information provider not found");return await k.provideRelatedInformation(v,$)??[]}getRelatedInformation(R,v,$){return this.c.$getAiRelatedInformation(v,$)}registerRelatedInformationProvider(R,v,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiRelatedInformationProvider(k,v),new N.$cL(()=>{this.c.$unregisterAiRelatedInformationProvider(k),this.a.delete(k)})}}e.$Fgc=f}),define(ke[312],Se([1,0,4,6,7,25]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qgc=void 0;class R{constructor(k){this.b=new Map,this.c=new C.$Vd,this.onDidChangeSessions=this.c.event,this.d=new v,this.f=new v,this.a=k.getProxy(N.$aL.MainThreadAuthentication)}async getSession(k,A,D,w={}){const E=P.$lm.toKey(k.identifier),S=[...D].sort().join(" ");return await this.d.getOrCreate(`${E} ${A} ${S}`,async()=>{await this.a.$ensureProvider(A);const c=k.displayName||k.name;return this.a.$getSession(A,D,E,c,w)})}async getSessions(k,A,D){const w=P.$lm.toKey(k.identifier),E=[...D].sort().join(" ");return await this.f.getOrCreate(`${w} ${E}`,async()=>{await this.a.$ensureProvider(A);const S=k.displayName||k.name;return this.a.$getSessions(A,D,w,S)})}async removeSession(k,A){const D=this.b.get(k);return D?D.provider.removeSession(A):this.a.$removeSession(k,A)}registerAuthenticationProvider(k,A,D,w){if(this.b.get(k))throw new Error(`An authentication provider with id '${k}' is already registered.`);this.b.set(k,{label:A,provider:D,options:w??{supportsMultipleAccounts:!1}});const E=D.onDidChangeSessions(S=>this.a.$sendDidChangeSessions(k,S));return this.a.$registerAuthenticationProvider(k,A,w?.supportsMultipleAccounts??!1),new f.$cL(()=>{E.dispose(),this.b.delete(k),this.a.$unregisterAuthenticationProvider(k)})}$createSession(k,A,D){const w=this.b.get(k);if(w)return Promise.resolve(w.provider.createSession(A,D));throw new Error(`Unable to find authentication provider with handle: ${k}`)}$removeSession(k,A){const D=this.b.get(k);if(D)return Promise.resolve(D.provider.removeSession(A));throw new Error(`Unable to find authentication provider with handle: ${k}`)}$getSessions(k,A){const D=this.b.get(k);if(D)return Promise.resolve(D.provider.getSessions(A));throw new Error(`Unable to find authentication provider with handle: ${k}`)}$onDidChangeAuthenticationSessions(k,A){return this.c.fire({provider:{id:k,label:A}}),Promise.resolve()}}e.$Qgc=R;class v{constructor(){this.a=new Map}getOrCreate(k,A){const D=this.a.get(k);if(D)return D;const w=A().finally(()=>this.a.delete(k));return this.a.set(k,w),w}}}),define(ke[147],Se([1,0,2,6,7,5,20,13,19,12,17,26]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Qhc=e.$Phc=void 0;let E=class{static{w=this}static{this.c=0}static{this.d=250}constructor(c,g){this.h=g,this.f=new Map,this.g=c.getProxy(N.$aL.MainThreadDecorations)}registerFileDecorationProvider(c,g){const o=w.c++;this.f.set(o,{provider:c,extensionDescription:g}),this.g.$registerDecorationProvider(o,g.identifier.value);const i=c.onDidChangeFileDecorations&&c.onDidChangeFileDecorations(r=>{if(!r){this.g.$onDidChange(o,null);return}const n=(0,$.$3b)(r);if(n.length<=w.d){this.g.$onDidChange(o,n);return}this.h.warn("[Decorations] CAPPING events from decorations provider",g.identifier.value,n.length);const a=n.map(s=>({uri:s,rank:(0,k.$Pe)(s.path,"/")})),t=(0,$.$zb)(a,(s,d)=>s.rank-d.rank||(0,k.$5e)(s.uri.path,d.uri.path)),h=[];e:for(const s of t){let d;for(const u of s){const l=(0,A.$mc)(u.uri.path);if(d!==l&&(d=l,h.push(u.uri)>=w.d))break e}}this.g.$onDidChange(o,h)});return new f.$cL(()=>{i?.dispose(),this.g.$unregisterDecorationProvider(o),this.f.delete(o)})}async $provideDecorations(c,g,o){if(!this.f.has(c))return Object.create(null);const i=Object.create(null),{provider:r,extensionDescription:n}=this.f.get(c);return await Promise.all(g.map(async a=>{try{const{uri:t,id:h}=a,s=await Promise.resolve(r.provideFileDecoration(C.URI.revive(t),o));if(!s)return;try{f.$zM.validate(s),s.badge&&typeof s.badge!="string"&&(0,D.$GF)(n,"codiconDecoration"),i[h]=[s.propagate,s.tooltip,s.badge,s.color]}catch(d){this.h.warn(`INVALID decoration from extension '${n.identifier.value}': ${d}`)}}catch(t){this.h.error(t)}})),i}};e.$Phc=E,e.$Phc=E=w=Ge([We(0,R.$fN),We(1,v.$nj)],E),e.$Qhc=(0,P.$6h)("IExtHostDecorations")}),define(ke[313],Se([1,0,14,2,7,6,16,21,12]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Shc=void 0;class k{static{this.a=0}constructor(D,w,E){this.d=w,this.e=E,this.b=new Map,this.c=D.getProxy(P.$aL.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(D,w){if(Object.keys(R.Schemas).indexOf(D)>=0)throw new Error(`scheme '${D}' already registered`);const E=k.a++;this.b.set(E,w),this.c.$registerTextContentProvider(E,D);let S;if(typeof w.onDidChange=="function"){let c;S=w.onDidChange(async g=>{if(g.scheme!==D){this.e.warn(`Provider for scheme '${D}' is firing event for schema '${g.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(g))return;c&&await c;const o=this.$provideTextDocumentContent(E,g).then(async i=>{if(!i&&typeof i!="string")return;const r=this.d.getDocument(g);if(!r)return;const n=(0,$.$Ze)(i);if(!r.equalLines(n))return this.c.$onVirtualDocumentChange(g,i)}).catch(C.$1).finally(()=>{c===o&&(c=void 0)});c=o})}return new f.$cL(()=>{this.b.delete(E)&&this.c.$unregisterTextContentProvider(E),S&&(S.dispose(),S=void 0)})}$provideTextDocumentContent(D,w){const E=this.b.get(D);return E?Promise.resolve(E.provideTextDocumentContent(N.URI.revive(w),v.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${w.scheme}`))}}e.$Shc=k}),define(ke[148],Se([1,0,61,16,12,176,126,7,19]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jN=e.$iN=e.$hN=void 0;const k=new Map;function A(S,c){c?k.set(S,c):k.delete(S)}e.$hN=A;function D(S){return k.get(S)}class w extends P.$lv{constructor(c,g,o,i,r,n,a,t){super(g,o,i,r),this.c=c,this.m=n,this.q=a,this.notebook=t,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(c){return(0,$.$ub)(this.f,c)}get document(){if(!this.a){const c=this;this.a={get uri(){return c.d},get fileName(){return c.d.fsPath},get isUntitled(){return c.d.scheme===N.Schemas.untitled},get languageId(){return c.m},get version(){return c.h},get isClosed(){return c.b},get isDirty(){return c.q},save(){return c.r()},getText(g){return g?c.s(g):c.getText()},get eol(){return c.g===`
`?v.EndOfLine.LF:v.EndOfLine.CRLF},get lineCount(){return c.f.length},lineAt(g){return c.t(g)},offsetAt(g){return c.u(g)},positionAt(g){return c.v(g)},validateRange(g){return c.w(g)},validatePosition(g){return c.x(g)},getWordRangeAtPosition(g,o){return c.y(g,o)}}}return Object.freeze(this.a)}_acceptLanguageId(c){(0,C.ok)(!this.b),this.m=c}_acceptIsDirty(c){(0,C.ok)(!this.b),this.q=c}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(c){const g=this.w(c);if(g.isEmpty)return"";if(g.isSingleLine)return this.f[g.start.line].substring(g.start.character,g.end.character);const o=this.g,i=g.start.line,r=g.end.line,n=[];n.push(this.f[i].substring(g.start.character));for(let a=i+1;a<r;a++)n.push(this.f[a]);return n.push(this.f[r].substring(0,g.end.character)),n.join(o)}t(c){let g;if(c instanceof v.$dL?g=c.line:typeof c=="number"&&(g=c),typeof g!="number"||g<0||g>=this.f.length||Math.floor(g)!==g)throw new Error("Illegal value for `line`");return new E(g,this.f[g],g===this.f.length-1)}u(c){return c=this.x(c),this.l(),this.j.getPrefixSum(c.line-1)+c.character}v(c){c=Math.floor(c),c=Math.max(0,c),this.l();const g=this.j.getIndexOf(c),o=this.f[g.index].length;return new v.$dL(g.index,Math.min(g.remainder,o))}w(c){if(!(c instanceof v.$eL))throw new Error("Invalid argument");const g=this.x(c.start),o=this.x(c.end);return g===c.start&&o===c.end?c:new v.$eL(g.line,g.character,o.line,o.character)}x(c){if(!(c instanceof v.$dL))throw new Error("Invalid argument");if(this.f.length===0)return c.with(0,0);let{line:g,character:o}=c,i=!1;if(g<0)g=0,o=0,i=!0;else if(g>=this.f.length)g=this.f.length-1,o=this.f[g].length,i=!0;else{const r=this.f[g].length;o<0?(o=0,i=!0):o>r&&(o=r,i=!0)}return i?new v.$dL(g,o):c}y(c,g){const o=this.x(c);if(!g)g=D(this.m);else if((0,f.$Ye)(g))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${g.source}' because it matches the empty string.`);const i=(0,R.$xs)(o.character+1,(0,R.$vs)(g),this.f[o.line],0);if(i)return new v.$eL(o.line,i.startColumn-1,o.line,i.endColumn-1)}}e.$iN=w;class E{constructor(c,g,o){this.a=c,this.b=g,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new v.$eL(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new v.$eL(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$jN=E}),define(ke[314],Se([1,0,6,7]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Uhc=void 0;class f{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(C.$aL.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(R,v,$){if(this.a.size===0)throw new Error("No embedding vector providers registered");const k=this.a.get(R);if(!k)throw new Error("Embedding vector provider not found");const A=await k.provideEmbeddingVector(v,$);if(!A)throw new Error("Embedding vector provider returned undefined");return A}registerEmbeddingVectorProvider(R,v,$){const k=this.b;return this.b++,this.a.set(k,$),this.c.$registerAiEmbeddingVectorProvider(v,k),new N.$cL(()=>{this.c.$unregisterAiEmbeddingVectorProvider(k),this.a.delete(k)})}}e.$Uhc=f}),define(ke[69],Se([1,0,6,32,7,22,5,20,59,3,11,23,16]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$9gc=e.$8gc=void 0;let S=E=class{constructor(g,o){this.b=new Map,this.c=new A.$ch,this.a=g.getProxy(C.$aL.MainThreadFileSystem);const i=this;this.value=Object.freeze({async stat(r){try{let n;const a=i.b.get(r.scheme);return a?(await i.a.$ensureActivation(r.scheme),n=await a.impl.stat(r)):n=await i.a.$stat(r),{type:n.type,ctime:n.ctime,mtime:n.mtime,size:n.size,permissions:n.permissions===N.FilePermission.Readonly?1:void 0}}catch(n){E.e(n)}},async readDirectory(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readDirectory(r)).slice()):await i.a.$readdir(r)}catch(n){return E.e(n)}},async createDirectory(r){try{const n=i.b.get(r.scheme);return n&&!n.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(n.impl,n.extUri,r)):await i.a.$mkdir(r)}catch(n){return E.e(n)}},async readFile(r){try{const n=i.b.get(r.scheme);return n?(await i.a.$ensureActivation(r.scheme),(await n.impl.readFile(r)).slice()):(await i.a.$readFile(r)).buffer}catch(n){return E.e(n)}},async writeFile(r,n){try{const a=i.b.get(r.scheme);return a&&!a.isReadonly?(await i.a.$ensureActivation(r.scheme),await i.d(a.impl,a.extUri,a.extUri.dirname(r)),await i.c.queueFor(r,()=>Promise.resolve(a.impl.writeFile(r,n,{create:!0,overwrite:!0})))):await i.a.$writeFile(r,P.$je.wrap(n))}catch(a){return E.e(a)}},async delete(r,n){try{const a=i.b.get(r.scheme);return a&&!a.isReadonly&&!n?.useTrash?(await i.a.$ensureActivation(r.scheme),await a.impl.delete(r,{recursive:!1,...n})):await i.a.$delete(r,{recursive:!1,useTrash:!1,atomic:!1,...n})}catch(a){return E.e(a)}},async rename(r,n,a){try{return await i.a.$rename(r,n,{overwrite:!1,...a})}catch(t){return E.e(t)}},async copy(r,n,a){try{return await i.a.$copy(r,n,{overwrite:!1,...a})}catch(t){return E.e(t)}},isWritableFileSystem(r){const n=o.getCapabilities(r);if(typeof n=="number")return!(n&2048)}})}async d(g,o,i){const r=[];for(;!o.isEqual(i,o.dirname(i));)try{if(!((await g.stat(i)).type&N.FileType.Directory))throw f.$qM.FileExists(`Unable to create folder '${i.scheme===w.Schemas.file?i.fsPath:i.toString(!0)}' that already exists but is not a directory`);break}catch(n){if(N.$Gk(n)!==N.FileSystemProviderErrorCode.FileNotFound)throw n;r.push(o.basename(i)),i=o.dirname(i)}for(let n=r.length-1;n>=0;n--){i=o.joinPath(i,r[n]);try{await g.createDirectory(i)}catch(a){if(N.$Gk(a)!==N.FileSystemProviderErrorCode.FileExists)throw a}}}static e(g){if(g instanceof f.$qM)throw g;if(g instanceof N.$Ck)switch(g.code){case N.FileSystemProviderErrorCode.FileExists:throw f.$qM.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw f.$qM.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw f.$qM.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw f.$qM.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw f.$qM.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw f.$qM.Unavailable(g.message);default:throw new f.$qM(g.message,g.name)}if(!(g instanceof Error))throw new f.$qM(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw f.$qM.Unavailable(g.message);switch(g.name){case N.FileSystemProviderErrorCode.FileExists:throw f.$qM.FileExists(g.message);case N.FileSystemProviderErrorCode.FileNotFound:throw f.$qM.FileNotFound(g.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw f.$qM.FileNotADirectory(g.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw f.$qM.FileIsADirectory(g.message);case N.FileSystemProviderErrorCode.NoPermissions:throw f.$qM.NoPermissions(g.message);case N.FileSystemProviderErrorCode.Unavailable:throw f.$qM.Unavailable(g.message);default:throw new f.$qM(g.message,g.name)}}addFileSystemProvider(g,o,i){return this.b.set(g,{impl:o,extUri:i?.isCaseSensitive?D.$xg:D.$zg,isReadonly:!!i?.isReadonly}),(0,k.$Rc)(()=>this.b.delete(g))}getFileSystemProviderExtUri(g){return this.b.get(g)?.extUri??D.$xg}};e.$8gc=S,e.$8gc=S=E=Ge([We(0,v.$fN),We(1,$.$Igc)],S),e.$9gc=(0,R.$6h)("IExtHostConsumerFileSystem")}),define(ke[315],Se([1,0,6,7]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_hc=void 0;class f{constructor(R){this.a=new Map,this.b=new Map,this.c=R.getProxy(C.$aL.MainThreadIssueReporter)}async $getIssueReporterUri(R,v){if(this.a.size===0)throw new Error("No issue request handlers registered");const $=this.a.get(R);if(!$)throw new Error("Issue request handler not found");const k=await $.handleIssueUrlRequest();if(!k)throw new Error("Issue request handler returned no result");return k}async $getIssueReporterData(R,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const k=await $.provideIssueData(v);if(!k)throw new Error("Issue data provider returned no result");return k}async $getIssueReporterTemplate(R,v){if(this.b.size===0)throw new Error("No issue request handlers registered");const $=this.b.get(R);if(!$)throw new Error("Issue data provider not found");const k=await $.provideIssueTemplate(v);if(!k)throw new Error("Issue template provider returned no result");return k}registerIssueUriRequestHandler(R,v){const $=R.identifier.value;return this.a.set($,v),this.c.$registerIssueUriRequestHandler($),new N.$cL(()=>{this.c.$unregisterIssueUriRequestHandler($),this.a.delete($)})}registerIssueDataProvider(R,v){const $=R.identifier.value;return this.b.set($,v),this.c.$registerIssueDataProvider($),new N.$cL(()=>{this.c.$unregisterIssueDataProvider($),this.b.delete($)})}}e.$_hc=f}),define(ke[94],Se([1,0,5,27,13,69,2]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$gc=e.$0gc=void 0,e.$0gc=(0,C.$6h)("IExtensionStoragePaths");let v=class{constructor(k,A,D){this.d=A,this.f=D,this.a=k.workspace??void 0,this.b=k.environment,this.whenReady=this.h().then(w=>this.c=w)}async g(k){return R.URI.joinPath(this.b.workspaceStorageHome,k)}async h(){if(!this.a)return Promise.resolve(void 0);const k=this.a.id,A=await this.g(k);try{return await this.f.value.stat(A),this.d.trace("[ExtHostStorage] storage dir already exists",A),A}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",A),await this.f.value.createDirectory(A),await this.f.value.writeFile(R.URI.joinPath(A,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),A}catch(D){this.d.error("[ExtHostStorage]",D);return}}workspaceValue(k){if(this.c)return R.URI.joinPath(this.c,k.identifier.value)}globalValue(k){return R.URI.joinPath(this.b.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$$gc=v,e.$$gc=v=Ge([We(0,N.$vN),We(1,f.$nj),We(2,P.$9gc)],v)}),define(ke[316],Se([1,0,7,20,4]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cic=void 0;let P=class{constructor(v){this.a=new C.$AM(C.ColorThemeKind.Dark),this.b=new f.$Vd}get activeColorTheme(){return this.a}$onColorThemeChange(v){let $;switch(v){case"light":$=C.ColorThemeKind.Light;break;case"hcDark":$=C.ColorThemeKind.HighContrast;break;case"hcLight":$=C.ColorThemeKind.HighContrastLight;break;default:$=C.ColorThemeKind.Dark}this.a=new C.$AM($),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$Cic=P,e.$Cic=P=Ge([We(0,N.$fN)],P)}),define(ke[70],Se([1,0,21,4,3,220,5,13,89,6,27,20,7]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7yb=e.$6yb=e.TunnelDtoConverter=void 0;class E extends $.$Jv{}var S;(function(g){function o(r){return{remoteAddress:r.remoteAddress,localAddress:r.localAddress,public:!!r.public,privacy:r.privacy??(r.public?$.TunnelPrivacyId.Public:$.TunnelPrivacyId.Private),protocol:r.protocol}}g.fromApiTunnel=o;function i(r){return{remoteAddress:{host:r.tunnelRemoteHost,port:r.tunnelRemotePort},localAddress:r.localAddress,public:r.privacy!==$.TunnelPrivacyId.ConstantPrivate&&r.privacy!==$.TunnelPrivacyId.ConstantPrivate,privacy:r.privacy,protocol:r.protocol}}g.fromServiceTunnel=i})(S||(e.TunnelDtoConverter=S={})),e.$6yb=(0,R.$6h)("IExtHostTunnelService");let c=class extends f.$Tc{constructor(o,i,r){super(),this.s=r,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$Vd,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=o.getProxy(k.$aL.MainThreadTunnelService)}async openTunnel(o,i){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${o.identifier.value} called openTunnel API for ${i.remoteAddress.host}:${i.remoteAddress.port}.`);const r=await this.a.$openTunnel(i,o.displayName);if(r){const n=new E(r.remoteAddress,r.localAddress,()=>this.a.$closeTunnel(r.remoteAddress));return this.B(n),n}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(o,i){const r=this.u();return this.r.set(r,{selector:o,provider:i}),this.a.$registerPortsAttributesProvider(o,r),new w.$cL(()=>{this.r.delete(r),this.a.$unregisterPortsAttributesProvider(r)})}async $providePortAttributes(o,i,r,n,a){const t=[];for(const s of o){const d=this.r.get(s);if(!d)return[];t.push(...await Promise.all(i.map(async u=>{let l;try{l=await d.provider.providePortAttributes({port:u,pid:r,commandLine:n},a)}catch{l=await d.provider.providePortAttributes(u,r,n,a)}return{providedAttributes:l,port:u}})))}const h=t.filter(s=>!!s.providedAttributes);return h.length>0?h.map(s=>({autoForwardAction:s.providedAttributes.autoForwardAction,port:s.port})):[]}async $registerCandidateFinder(o){}registerTunnelProvider(o,i){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(n,a)=>await o.provideTunnel(n,a,new C.$6d().token)??void 0;const r=i.tunnelFeatures?{elevation:!!i.tunnelFeatures?.elevation,privacyOptions:i.tunnelFeatures?.privacyOptions,protocol:i.tunnelFeatures.protocol===void 0?!0:i.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(r),Promise.resolve((0,f.$Rc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(o,i){if(o){o.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(o.candidatePortSource),o.showCandidatePort&&(this.f=o.showCandidatePort,this.a.$setCandidateFilter());const r=o.tunnelFactory??(i?this.w(i):void 0);if(r){this.b=r;let n=o.tunnelFeatures?.privacyOptions??[];o.tunnelFeatures?.public&&n.length===0&&(n=[{id:"private",label:P.localize(0,null),themeIcon:"lock"},{id:"public",label:P.localize(1,null),themeIcon:"eye"}]);const a=o.tunnelFeatures?{elevation:!!o.tunnelFeatures?.elevation,public:!!o.tunnelFeatures?.public,privacyOptions:n,protocol:!0}:void 0;this.a.$setTunnelProvider(a)}}else this.b=void 0;return(0,f.$Rc)(()=>{this.b=void 0})}w(o){}async $closeTunnel(o,i){if(this.g.has(o.host)){const r=this.g.get(o.host);r.has(o.port)&&(i&&r.get(o.port).disposeListener.dispose(),await r.get(o.port).tunnel.dispose(),r.delete(o.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(o,i){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const r=this.b(o,i);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),r!==void 0){const n=await r;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),n===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(o.remoteAddress.host)||this.g.set(o.remoteAddress.host,new Map);const a=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(o.remoteAddress.host).set(o.remoteAddress.port,{tunnel:n,disposeListener:a}),S.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(r){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),r instanceof Error)return r.message}}async $applyCandidateFilter(o){const i=await Promise.all(o.map(n=>this.f(n.host,n.port,n.detail??""))),r=o.filter((n,a)=>i[a]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${o.map(n=>n.port).join(", ")} to ${r.map(n=>n.port).join(", ")}`),r}};e.$7yb=c,e.$7yb=c=Ge([We(0,D.$fN),We(1,A.$vN),We(2,v.$nj)],c)}),define(ke[15],Se([1,0,19,22,165,74,80,28,160,56,101,24,18,2,29,83,135,141,139,118,67,90,290,26,7]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalQuickFix=e.ChatAgentCompletionItem=e.ChatAgentRequest=e.ChatResponseProgress=e.InteractiveEditorResponseFeedbackKind=e.ChatVariableLevel=e.ChatVariable=e.ChatMessageRole=e.ChatMessage=e.ChatFollowup=e.ChatReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.$eN=e.$dN=e.MarkdownString=e.$cN=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0;var d;(function(Me){function Te(ce){const{selectionStartLineNumber:Ne,selectionStartColumn:Be,positionLineNumber:xe,positionColumn:Je}=ce,ct=new s.$dL(Ne-1,Be-1),pt=new s.$dL(xe-1,Je-1);return new s.$fL(ct,pt)}Me.to=Te;function De(ce){const{anchor:Ne,active:Be}=ce;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Me.from=De})(d||(e.Selection=d={}));var u;(function(Me){function Te(ce){if(!ce)return;const{start:Ne,end:Be}=ce;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Me.from=Te;function De(ce){if(!ce)return;const{startLineNumber:Ne,startColumn:Be,endLineNumber:xe,endColumn:Je}=ce;return new s.$eL(Ne-1,Be-1,xe-1,Je-1)}Me.to=De})(u||(e.Range=u={}));var l;(function(Me){function Te(De){return new s.$oL(E.URI.revive(De.uri),u.to(De.range))}Me.to=Te})(l||(e.Location=l={}));var p;(function(Me){function Te(De){switch(De){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Me.to=Te})(p||(e.TokenType=p={}));var I;(function(Me){function Te(ce){return new s.$dL(ce.lineNumber-1,ce.column-1)}Me.to=Te;function De(ce){return{lineNumber:ce.line+1,column:ce.character+1}}Me.from=De})(I||(e.Position=I={}));var b;(function(Me){function Te(Ne,Be,xe){return(0,C.$Hb)((0,C.$3b)(Ne).map(Je=>De(Je,Be,xe)))}Me.from=Te;function De(Ne,Be,xe){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:xe?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:ce(Ne.scheme,Be),pattern:se.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:xe?.isBuiltin}}function ce(Ne,Be){return Be&&typeof Ne=="string"?Be.transformOutgoingScheme(Ne):Ne}})(b||(e.DocumentSelector=b={}));var m;(function(Me){function Te(ce){switch(ce){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Me.from=Te;function De(ce){switch(ce){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Me.to=De})(m||(e.DiagnosticTag=m={}));var y;(function(Me){function Te(ce){let Ne;return ce.code&&((0,w.$If)(ce.code)||(0,w.$Mf)(ce.code)?Ne=String(ce.code):Ne={value:String(ce.code.value),target:ce.code.target}),{...u.from(ce.range),message:ce.message,source:ce.source,code:Ne,severity:F.from(ce.severity),relatedInformation:ce.relatedInformation&&ce.relatedInformation.map(L.from),tags:Array.isArray(ce.tags)?(0,C.$Hb)(ce.tags.map(m.from)):void 0}}Me.from=Te;function De(ce){const Ne=new s.$qL(u.to(ce),ce.message,F.to(ce.severity));return Ne.source=ce.source,Ne.code=(0,w.$If)(ce.code)?ce.code:ce.code?.value,Ne.relatedInformation=ce.relatedInformation&&ce.relatedInformation.map(L.to),Ne.tags=ce.tags&&(0,C.$Hb)(ce.tags.map(m.to)),Ne}Me.to=De})(y||(e.Diagnostic=y={}));var L;(function(Me){function Te(ce){return{...u.from(ce.location.range),message:ce.message,resource:ce.location.uri}}Me.from=Te;function De(ce){return new s.$pL(new s.$oL(ce.resource,u.to(ce)),ce.message)}Me.to=De})(L||(e.DiagnosticRelatedInformation=L={}));var F;(function(Me){function Te(ce){switch(ce){case s.DiagnosticSeverity.Error:return g.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return g.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return g.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return g.MarkerSeverity.Hint}return g.MarkerSeverity.Error}Me.from=Te;function De(ce){switch(ce){case g.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case g.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case g.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case g.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Me.to=De})(F||(e.DiagnosticSeverity=F={}));var z;(function(Me){function Te(ce){return typeof ce=="number"&&ce>=s.ViewColumn.One?ce-1:ce===s.ViewColumn.Beside?t.$cD:t.$bD}Me.from=Te;function De(ce){if(typeof ce=="number"&&ce>=0)return ce+1;throw new Error("invalid 'EditorGroupColumn'")}Me.to=De})(z||(e.ViewColumn=z={}));function T(Me){return typeof Me.range<"u"}function O(Me){return Me.length===0?!0:!!T(Me[0])}e.$cN=O;var M;(function(Me){function Te(Je){return Je.map(Me.from)}Me.fromMany=Te;function De(Je){return Je&&typeof Je=="object"&&typeof Je.language=="string"&&typeof Je.value=="string"}function ce(Je){let ct;if(De(Je)){const{language:Ct,value:vt}=Je;ct={value:"```"+Ct+`
`+vt+"\n```\n"}}else s.$DL.isMarkdownString(Je)?ct={value:Je.value,isTrusted:Je.isTrusted,supportThemeIcons:Je.supportThemeIcons,supportHtml:Je.supportHtml,baseUri:Je.baseUri}:typeof Je=="string"?ct={value:Je}:ct={value:""};const pt=Object.create(null);ct.uris=pt;const Jt=Ct=>{try{let vt=E.URI.parse(Ct,!0);vt=vt.with({query:Ne(vt.query,pt)}),pt[Ct]=vt}catch{}return""},St=new $.marked.Renderer;return St.link=Jt,St.image=Ct=>typeof Ct=="string"?Jt(R.$pk(Ct).href):"",(0,$.marked)(ct.value,{renderer:St}),ct}Me.from=ce;function Ne(Je,ct){if(!Je)return Je;let pt;try{pt=(0,k.$Bh)(Je)}catch{}if(!pt)return Je;let Jt=!1;return pt=(0,D.$xn)(pt,St=>{if(E.URI.isUri(St)){const Ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return ct[Ct]=St,Jt=!0,Ct}else return}),Jt?JSON.stringify(pt):Je}function Be(Je){const ct=new s.$DL(Je.value,Je.supportThemeIcons);return ct.isTrusted=Je.isTrusted,ct.supportHtml=Je.supportHtml,ct.baseUri=Je.baseUri?E.URI.from(Je.baseUri):void 0,ct}Me.to=Be;function xe(Je){if(Je)return typeof Je=="string"?Je:Me.from(Je)}Me.fromStrict=xe})(M||(e.MarkdownString=M={}));function j(Me){return O(Me)?Me.map(Te=>({range:u.from(Te.range),hoverMessage:Array.isArray(Te.hoverMessage)?M.fromMany(Te.hoverMessage):Te.hoverMessage?M.from(Te.hoverMessage):void 0,renderOptions:Te.renderOptions})):Me.map(Te=>({range:u.from(Te)}))}e.$dN=j;function U(Me){return typeof Me>"u"?Me:typeof Me=="string"?E.URI.file(Me):Me}e.$eN=U;var K;(function(Me){function Te(De){return typeof De>"u"?De:{contentText:De.contentText,contentIconPath:De.contentIconPath?U(De.contentIconPath):void 0,border:De.border,borderColor:De.borderColor,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,color:De.color,backgroundColor:De.backgroundColor,margin:De.margin,width:De.width,height:De.height}}Me.from=Te})(K||(e.ThemableDecorationAttachmentRenderOptions=K={}));var ue;(function(Me){function Te(De){return typeof De>"u"?De:{backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?U(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?K.from(De.before):void 0,after:De.after?K.from(De.after):void 0}}Me.from=Te})(ue||(e.ThemableDecorationRenderOptions=ue={}));var X;(function(Me){function Te(De){if(typeof De>"u")return De;switch(De){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Me.from=Te})(X||(e.DecorationRangeBehavior=X={}));var Q;(function(Me){function Te(De){return{isWholeLine:De.isWholeLine,rangeBehavior:De.rangeBehavior?X.from(De.rangeBehavior):void 0,overviewRulerLane:De.overviewRulerLane,light:De.light?ue.from(De.light):void 0,dark:De.dark?ue.from(De.dark):void 0,backgroundColor:De.backgroundColor,outline:De.outline,outlineColor:De.outlineColor,outlineStyle:De.outlineStyle,outlineWidth:De.outlineWidth,border:De.border,borderColor:De.borderColor,borderRadius:De.borderRadius,borderSpacing:De.borderSpacing,borderStyle:De.borderStyle,borderWidth:De.borderWidth,fontStyle:De.fontStyle,fontWeight:De.fontWeight,textDecoration:De.textDecoration,cursor:De.cursor,color:De.color,opacity:De.opacity,letterSpacing:De.letterSpacing,gutterIconPath:De.gutterIconPath?U(De.gutterIconPath):void 0,gutterIconSize:De.gutterIconSize,overviewRulerColor:De.overviewRulerColor,before:De.before?K.from(De.before):void 0,after:De.after?K.from(De.after):void 0}}Me.from=Te})(Q||(e.DecorationRenderOptions=Q={}));var Z;(function(Me){function Te(ce){return{text:ce.newText,eol:ce.newEol&&Pe.from(ce.newEol),range:u.from(ce.range)}}Me.from=Te;function De(ce){const Ne=new s.$jL(u.to(ce.range),ce.text);return Ne.newEol=typeof ce.eol>"u"?void 0:Pe.to(ce.eol),Ne}Me.to=De})(Z||(e.TextEdit=Z={}));var le;(function(Me){function Te(ce,Ne){const Be={edits:[]};if(ce instanceof s.$mL){const xe=new v.$Bc;for(const Je of ce._allEntries())Je._type===1&&E.URI.isUri(Je.to)&&Je.from===void 0&&xe.add(Je.to);for(const Je of ce._allEntries())if(Je._type===1){let ct;Je.options?.contents&&(ArrayBuffer.isView(Je.options.contents)?ct={type:"base64",value:(0,N.$De)(N.$je.wrap(Je.options.contents))}:ct={type:"dataTransferItem",id:Je.options.contents._itemId}),Be.edits.push({oldResource:Je.from,newResource:Je.to,options:{...Je.options,contents:ct},metadata:Je.metadata})}else Je._type===2?Be.edits.push({resource:Je.uri,textEdit:Z.from(Je.edit),versionId:xe.has(Je.uri)?void 0:Ne?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===6?Be.edits.push({resource:Je.uri,textEdit:{range:u.from(Je.range),text:Je.edit.value,insertAsSnippet:!0},versionId:xe.has(Je.uri)?void 0:Ne?.getTextDocumentVersion(Je.uri),metadata:Je.metadata}):Je._type===3?Be.edits.push({metadata:Je.metadata,resource:Je.uri,cellEdit:Je.edit,notebookMetadata:Je.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(Je.uri)}):Je._type===5&&Be.edits.push({metadata:Je.metadata,resource:Je.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(Je.uri),cellEdit:{editType:1,index:Je.index,count:Je.count,cells:Je.cells.map(Dt.from)}})}return Be}Me.from=Te;function De(ce){const Ne=new s.$mL,Be=new v.$Ac;for(const xe of ce.edits)if(xe.textEdit){const Je=xe,ct=E.URI.revive(Je.resource),pt=u.to(Je.textEdit.range),Jt=Je.textEdit.text,St=Je.textEdit.insertAsSnippet;let Ct;St?Ct=s.$lL.replace(pt,new s.$nL(Jt)):Ct=s.$jL.replace(pt,Jt);const vt=Be.get(ct);vt?vt.push(Ct):Be.set(ct,[Ct])}else Ne.renameFile(E.URI.revive(xe.oldResource),E.URI.revive(xe.newResource),xe.options);for(const[xe,Je]of Be)Ne.set(xe,Je);return Ne}Me.to=De})(le||(e.WorkspaceEdit=le={}));var re;(function(Me){const Te=Object.create(null);Te[s.SymbolKind.File]=0,Te[s.SymbolKind.Module]=1,Te[s.SymbolKind.Namespace]=2,Te[s.SymbolKind.Package]=3,Te[s.SymbolKind.Class]=4,Te[s.SymbolKind.Method]=5,Te[s.SymbolKind.Property]=6,Te[s.SymbolKind.Field]=7,Te[s.SymbolKind.Constructor]=8,Te[s.SymbolKind.Enum]=9,Te[s.SymbolKind.Interface]=10,Te[s.SymbolKind.Function]=11,Te[s.SymbolKind.Variable]=12,Te[s.SymbolKind.Constant]=13,Te[s.SymbolKind.String]=14,Te[s.SymbolKind.Number]=15,Te[s.SymbolKind.Boolean]=16,Te[s.SymbolKind.Array]=17,Te[s.SymbolKind.Object]=18,Te[s.SymbolKind.Key]=19,Te[s.SymbolKind.Null]=20,Te[s.SymbolKind.EnumMember]=21,Te[s.SymbolKind.Struct]=22,Te[s.SymbolKind.Event]=23,Te[s.SymbolKind.Operator]=24,Te[s.SymbolKind.TypeParameter]=25;function De(Ne){return typeof Te[Ne]=="number"?Te[Ne]:6}Me.from=De;function ce(Ne){for(const Be in Te)if(Te[Be]===Ne)return Number(Be);return s.SymbolKind.Property}Me.to=ce})(re||(e.SymbolKind=re={}));var $e;(function(Me){function Te(ce){switch(ce){case s.SymbolTag.Deprecated:return 1}}Me.from=Te;function De(ce){switch(ce){case 1:return s.SymbolTag.Deprecated}}Me.to=De})($e||(e.SymbolTag=$e={}));var oe;(function(Me){function Te(ce){return{name:ce.name,kind:re.from(ce.kind),tags:ce.tags&&ce.tags.map($e.from),containerName:ce.containerName,location:de.from(ce.location)}}Me.from=Te;function De(ce){const Ne=new s.$uL(ce.name,re.to(ce.kind),ce.containerName,de.to(ce.location));return Ne.tags=ce.tags&&ce.tags.map($e.to),Ne}Me.to=De})(oe||(e.WorkspaceSymbol=oe={}));var J;(function(Me){function Te(ce){const Ne={name:ce.name||"!!MISSING: name!!",detail:ce.detail,range:u.from(ce.range),selectionRange:u.from(ce.selectionRange),kind:re.from(ce.kind),tags:ce.tags?.map($e.from)??[]};return ce.children&&(Ne.children=ce.children.map(Te)),Ne}Me.from=Te;function De(ce){const Ne=new s.$vL(ce.name,ce.detail,re.to(ce.kind),u.to(ce.range),u.to(ce.selectionRange));return(0,C.$Lb)(ce.tags)&&(Ne.tags=ce.tags.map($e.to)),ce.children&&(Ne.children=ce.children.map(De)),Ne}Me.to=De})(J||(e.DocumentSymbol=J={}));var V;(function(Me){function Te(ce){const Ne=new s.$zL(re.to(ce.kind),ce.name,ce.detail||"",E.URI.revive(ce.uri),u.to(ce.range),u.to(ce.selectionRange));return Ne._sessionId=ce._sessionId,Ne._itemId=ce._itemId,Ne}Me.to=Te;function De(ce,Ne,Be){if(Ne=Ne??ce._sessionId,Be=Be??ce._itemId,Ne===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Be,name:ce.name,detail:ce.detail,kind:re.from(ce.kind),uri:ce.uri,range:u.from(ce.range),selectionRange:u.from(ce.selectionRange),tags:ce.tags?.map($e.from)}}Me.from=De})(V||(e.CallHierarchyItem=V={}));var ie;(function(Me){function Te(De){return new s.$AL(V.to(De.from),De.fromRanges.map(ce=>u.to(ce)))}Me.to=Te})(ie||(e.CallHierarchyIncomingCall=ie={}));var ye;(function(Me){function Te(De){return new s.$BL(V.to(De.to),De.fromRanges.map(ce=>u.to(ce)))}Me.to=Te})(ye||(e.CallHierarchyOutgoingCall=ye={}));var de;(function(Me){function Te(ce){return{range:ce.range&&u.from(ce.range),uri:ce.uri}}Me.from=Te;function De(ce){return new s.$oL(E.URI.revive(ce.uri),u.to(ce.range))}Me.to=De})(de||(e.location=de={}));var fe;(function(Me){function Te(ce){const Ne=ce,Be=ce;return{originSelectionRange:Ne.originSelectionRange?u.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:Be.uri,range:u.from(Ne.targetRange?Ne.targetRange:Be.range),targetSelectionRange:Ne.targetSelectionRange?u.from(Ne.targetSelectionRange):void 0}}Me.from=Te;function De(ce){return{targetUri:E.URI.revive(ce.uri),targetRange:u.to(ce.range),targetSelectionRange:ce.targetSelectionRange?u.to(ce.targetSelectionRange):void 0,originSelectionRange:ce.originSelectionRange?u.to(ce.originSelectionRange):void 0}}Me.to=De})(fe||(e.DefinitionLink=fe={}));var _;(function(Me){function Te(ce){return{range:u.from(ce.range),contents:M.fromMany(ce.contents)}}Me.from=Te;function De(ce){return new s.$rL(ce.contents.map(M.to),u.to(ce.range))}Me.to=De})(_||(e.Hover=_={}));var ee;(function(Me){function Te(ce){return{range:u.from(ce.range),expression:ce.expression}}Me.from=Te;function De(ce){return new s.$lM(u.to(ce.range),ce.expression)}Me.to=De})(ee||(e.EvaluatableExpression=ee={}));var G;(function(Me){function Te(ce){if(ce instanceof s.$mM)return{type:"text",range:u.from(ce.range),text:ce.text};if(ce instanceof s.$nM)return{type:"variable",range:u.from(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};if(ce instanceof s.$oM)return{type:"expression",range:u.from(ce.range),expression:ce.expression};throw new Error("Unknown 'InlineValue' type")}Me.from=Te;function De(ce){switch(ce.type){case"text":return{range:u.to(ce.range),text:ce.text};case"variable":return{range:u.to(ce.range),variableName:ce.variableName,caseSensitiveLookup:ce.caseSensitiveLookup};case"expression":return{range:u.to(ce.range),expression:ce.expression}}}Me.to=De})(G||(e.InlineValue=G={}));var x;(function(Me){function Te(ce){return{frameId:ce.frameId,stoppedLocation:u.from(ce.stoppedLocation)}}Me.from=Te;function De(ce){return new s.$pM(ce.frameId,u.to(ce.stoppedLocation))}Me.to=De})(x||(e.InlineValueContext=x={}));var me;(function(Me){function Te(ce){return{range:u.from(ce.range),kind:ce.kind}}Me.from=Te;function De(ce){return new s.$sL(u.to(ce.range),ce.kind)}Me.to=De})(me||(e.DocumentHighlight=me={}));var pe;(function(Me){function Te(ce){return{uri:ce.uri,highlights:ce.highlights.map(me.from)}}Me.from=Te;function De(ce){return new s.$tL(E.URI.revive(ce.uri),ce.highlights.map(me.to))}Me.to=De})(pe||(e.MultiDocumentHighlight=pe={}));var Re;(function(Me){function Te(De){switch(De){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Me.to=Te})(Re||(e.CompletionTriggerKind=Re={}));var ve;(function(Me){function Te(De){return{triggerKind:Re.to(De.triggerKind),triggerCharacter:De.triggerCharacter}}Me.to=Te})(ve||(e.CompletionContext=ve={}));var Ie;(function(Me){function Te(ce){switch(ce){case s.CompletionItemTag.Deprecated:return 1}}Me.from=Te;function De(ce){switch(ce){case 1:return s.CompletionItemTag.Deprecated}}Me.to=De})(Ie||(e.CompletionItemTag=Ie={}));var B;(function(Me){const Te=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function De(Be){return Te.get(Be)??9}Me.from=De;const ce=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ne(Be){return ce.get(Be)??s.CompletionItemKind.Property}Me.to=Ne})(B||(e.CompletionItemKind=B={}));var Y;(function(Me){function Te(De,ce){const Ne=new s.$JL(De.label);return Ne.insertText=De.insertText,Ne.kind=B.to(De.kind),Ne.tags=De.tags?.map(Ie.to),Ne.detail=De.detail,Ne.documentation=R.$jk(De.documentation)?M.to(De.documentation):De.documentation,Ne.sortText=De.sortText,Ne.filterText=De.filterText,Ne.preselect=De.preselect,Ne.commitCharacters=De.commitCharacters,S.$Us.isIRange(De.range)?Ne.range=u.to(De.range):typeof De.range=="object"&&(Ne.range={inserting:u.to(De.range.insert),replacing:u.to(De.range.replace)}),Ne.keepWhitespace=typeof De.insertTextRules>"u"?!1:!!(De.insertTextRules&1),typeof De.insertTextRules<"u"&&De.insertTextRules&4?Ne.insertText=new s.$nL(De.insertText):(Ne.insertText=De.insertText,Ne.textEdit=Ne.range instanceof s.$eL?new s.$jL(Ne.range,Ne.insertText):void 0),De.additionalTextEdits&&De.additionalTextEdits.length>0&&(Ne.additionalTextEdits=De.additionalTextEdits.map(Be=>Z.to(Be))),Ne.command=ce&&De.command?ce.fromInternal(De.command):void 0,Ne}Me.to=Te})(Y||(e.CompletionItem=Y={}));var te;(function(Me){function Te(ce){if(typeof ce.label!="string"&&!Array.isArray(ce.label))throw new TypeError("Invalid label");return{label:ce.label,documentation:M.fromStrict(ce.documentation)}}Me.from=Te;function De(ce){return{label:ce.label,documentation:R.$jk(ce.documentation)?M.to(ce.documentation):ce.documentation}}Me.to=De})(te||(e.ParameterInformation=te={}));var q;(function(Me){function Te(ce){return{label:ce.label,documentation:M.fromStrict(ce.documentation),parameters:Array.isArray(ce.parameters)?ce.parameters.map(te.from):[],activeParameter:ce.activeParameter}}Me.from=Te;function De(ce){return{label:ce.label,documentation:R.$jk(ce.documentation)?M.to(ce.documentation):ce.documentation,parameters:Array.isArray(ce.parameters)?ce.parameters.map(te.to):[],activeParameter:ce.activeParameter}}Me.to=De})(q||(e.SignatureInformation=q={}));var ae;(function(Me){function Te(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(q.from):[]}}Me.from=Te;function De(ce){return{activeSignature:ce.activeSignature,activeParameter:ce.activeParameter,signatures:Array.isArray(ce.signatures)?ce.signatures.map(q.to):[]}}Me.to=De})(ae||(e.SignatureHelp=ae={}));var he;(function(Me){function Te(De,ce){const Ne=new s.$IL(I.to(ce.position),typeof ce.label=="string"?ce.label:ce.label.map(Ae.to.bind(void 0,De)),ce.kind&&je.to(ce.kind));return Ne.textEdits=ce.textEdits&&ce.textEdits.map(Z.to),Ne.tooltip=R.$jk(ce.tooltip)?M.to(ce.tooltip):ce.tooltip,Ne.paddingLeft=ce.paddingLeft,Ne.paddingRight=ce.paddingRight,Ne}Me.to=Te})(he||(e.InlayHint=he={}));var Ae;(function(Me){function Te(De,ce){const Ne=new s.$HL(ce.label);return Ne.tooltip=R.$jk(ce.tooltip)?M.to(ce.tooltip):ce.tooltip,c.Command.is(ce.command)&&(Ne.command=De.fromInternal(ce.command)),ce.location&&(Ne.location=de.to(ce.location)),Ne}Me.to=Te})(Ae||(e.InlayHintLabelPart=Ae={}));var je;(function(Me){function Te(ce){return ce}Me.from=Te;function De(ce){return ce}Me.to=De})(je||(e.InlayHintKind=je={}));var He;(function(Me){function Te(ce){return{range:u.from(ce.range),url:ce.target,tooltip:ce.tooltip}}Me.from=Te;function De(ce){let Ne;if(ce.url)try{Ne=typeof ce.url=="string"?E.URI.parse(ce.url,!0):E.URI.revive(ce.url)}catch{}return new s.$OL(u.to(ce.range),Ne)}Me.to=De})(He||(e.DocumentLink=He={}));var Qe;(function(Me){function Te(ce){const Ne=new s.$RL(ce.label);return ce.textEdit&&(Ne.textEdit=Z.to(ce.textEdit)),ce.additionalTextEdits&&(Ne.additionalTextEdits=ce.additionalTextEdits.map(Be=>Z.to(Be))),Ne}Me.to=Te;function De(ce){return{label:ce.label,textEdit:ce.textEdit?Z.from(ce.textEdit):void 0,additionalTextEdits:ce.additionalTextEdits?ce.additionalTextEdits.map(Ne=>Z.from(Ne)):void 0}}Me.from=De})(Qe||(e.ColorPresentation=Qe={}));var _e;(function(Me){function Te(ce){return new s.$PL(ce[0],ce[1],ce[2],ce[3])}Me.to=Te;function De(ce){return[ce.red,ce.green,ce.blue,ce.alpha]}Me.from=De})(_e||(e.Color=_e={}));var at;(function(Me){function Te(ce){return{range:u.from(ce.range)}}Me.from=Te;function De(ce){return new s.$yL(u.to(ce.range))}Me.to=De})(at||(e.SelectionRange=at={}));var st;(function(Me){function Te(De){switch(De){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Me.to=Te})(st||(e.TextDocumentSaveReason=st={}));var rt;(function(Me){function Te(ce){switch(ce){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Me.from=Te;function De(ce){switch(ce){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Me.to=De})(rt||(e.TextEditorLineNumbersStyle=rt={}));var Pe;(function(Me){function Te(ce){if(ce===s.EndOfLine.CRLF)return 1;if(ce===s.EndOfLine.LF)return 0}Me.from=Te;function De(ce){if(ce===1)return s.EndOfLine.CRLF;if(ce===0)return s.EndOfLine.LF}Me.to=De})(Pe||(e.EndOfLine=Pe={}));var ze;(function(Me){function Te(De){if(typeof De=="object")return De.viewId;switch(De){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Me.from=Te})(ze||(e.ProgressLocation=ze={}));var Le;(function(Me){function Te(ce){const Ne={start:ce.start+1,end:ce.end+1};return ce.kind&&(Ne.kind=Ye.from(ce.kind)),Ne}Me.from=Te;function De(ce){const Ne={start:ce.start-1,end:ce.end-1};return ce.kind&&(Ne.kind=Ye.to(ce.kind)),Ne}Me.to=De})(Le||(e.FoldingRange=Le={}));var Ye;(function(Me){function Te(ce){if(ce)switch(ce){case s.FoldingRangeKind.Comment:return c.$Kt.Comment;case s.FoldingRangeKind.Imports:return c.$Kt.Imports;case s.FoldingRangeKind.Region:return c.$Kt.Region}}Me.from=Te;function De(ce){if(ce)switch(ce.value){case c.$Kt.Comment.value:return s.FoldingRangeKind.Comment;case c.$Kt.Imports.value:return s.FoldingRangeKind.Imports;case c.$Kt.Region.value:return s.FoldingRangeKind.Region}}Me.to=De})(Ye||(e.FoldingRangeKind=Ye={}));var ne;(function(Me){function Te(De){if(De)return{pinned:typeof De.preview=="boolean"?!De.preview:void 0,inactive:De.background,preserveFocus:De.preserveFocus,selection:typeof De.selection=="object"?u.from(De.selection):void 0,override:typeof De.override=="boolean"?i.$EE.id:void 0}}Me.from=Te})(ne||(e.TextEditorOpenOptions=ne={}));var se;(function(Me){function Te(Be){return Be instanceof s.$_L?Be.toJSON():typeof Be=="string"?Be:De(Be)||ce(Be)?new s.$_L(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Me.from=Te;function De(Be){const xe=Be;return xe?E.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function ce(Be){const xe=Be;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ne(Be){return typeof Be=="string"?Be:new s.$_L(E.URI.revive(Be.baseUri),Be.pattern)}Me.to=Ne})(se||(e.GlobPattern=se={}));var Ce;(function(Me){function Te(De){if(De){if(Array.isArray(De))return De.map(Te);if(typeof De=="string")return De;{const ce=De;return{language:ce.language,scheme:ce.scheme,pattern:se.from(ce.pattern),exclusive:ce.exclusive,notebookType:ce.notebookType}}}else return}Me.from=Te})(Ce||(e.LanguageSelector=Ce={}));var qe;(function(Me){function Te(ce){return!!ce&&typeof ce=="object"&&"documents"in ce&&Array.isArray(ce.documents)&&ce.documents.every(Ne=>Array.isArray(Ne)&&Ne.every(Be=>Be&&typeof Be=="object"&&"uri"in Be&&E.URI.isUri(Be.uri)&&"version"in Be&&typeof Be.version=="number"&&"ranges"in Be&&Array.isArray(Be.ranges)&&Be.ranges.every(xe=>xe instanceof s.$eL)))}Me.is=Te;function De(ce){return{documents:ce.documents.map(Ne=>Ne.map(Be=>({uri:E.URI.from(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>u.from(xe))})))}}Me.from=De})(qe||(e.MappedEditsContext=qe={}));var Ze;(function(Me){function Te(ce){return{start:ce.start,end:ce.end}}Me.from=Te;function De(ce){return new s.$BM(ce.start,ce.end)}Me.to=De})(Ze||(e.NotebookRange=Ze={}));var it;(function(Me){function Te(ce){return{timing:typeof ce.runStartTime=="number"&&typeof ce.runEndTime=="number"?{startTime:ce.runStartTime,endTime:ce.runEndTime}:void 0,executionOrder:ce.executionOrder,success:ce.lastRunSuccess}}Me.to=Te;function De(ce){return{lastRunSuccess:ce.success,runStartTime:ce.timing?.startTime,runEndTime:ce.timing?.endTime,executionOrder:ce.executionOrder}}Me.from=De})(it||(e.NotebookCellExecutionSummary=it={}));var nt;(function(Me){function Te(De){if(De===r.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(De===r.NotebookCellExecutionState.Pending)return;if(De===r.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${De}`)}Me.to=Te})(nt||(e.NotebookCellExecutionState=nt={}));var Oe;(function(Me){function Te(ce){switch(ce){case s.NotebookCellKind.Markup:return r.CellKind.Markup;case s.NotebookCellKind.Code:default:return r.CellKind.Code}}Me.from=Te;function De(ce){switch(ce){case r.CellKind.Markup:return s.NotebookCellKind.Markup;case r.CellKind.Code:default:return s.NotebookCellKind.Code}}Me.to=De})(Oe||(e.NotebookCellKind=Oe={}));var yt;(function(Me){function Te(ce){const Ne={metadata:ce.metadata??Object.create(null),cells:[]};for(const Be of ce.cells)s.$CM.validate(Be),Ne.cells.push(Dt.from(Be));return Ne}Me.from=Te;function De(ce){const Ne=new s.$DM(ce.cells.map(Dt.to));return(0,w.$Vf)(ce.metadata)||(Ne.metadata=ce.metadata),Ne}Me.to=De})(yt||(e.NotebookData=yt={}));var Dt;(function(Me){function Te(ce){return{cellKind:Oe.from(ce.kind),language:ce.languageId,mime:ce.mime,source:ce.value,metadata:ce.metadata,internalMetadata:it.from(ce.executionSummary??{}),outputs:ce.outputs?ce.outputs.map(Tt.from):[]}}Me.from=Te;function De(ce){return new s.$CM(Oe.to(ce.cellKind),ce.source,ce.language,ce.mime,ce.outputs?ce.outputs.map(Tt.to):void 0,ce.metadata,ce.internalMetadata?it.to(ce.internalMetadata):void 0)}Me.to=De})(Dt||(e.NotebookCellData=Dt={}));var Nt;(function(Me){function Te(ce){return{mime:ce.mime,valueBytes:N.$je.wrap(ce.data)}}Me.from=Te;function De(ce){return new s.$EM(ce.valueBytes.buffer,ce.mime)}Me.to=De})(Nt||(e.NotebookCellOutputItem=Nt={}));var Tt;(function(Me){function Te(ce){return{outputId:ce.id,items:ce.items.map(Nt.from),metadata:ce.metadata}}Me.from=Te;function De(ce){const Ne=ce.items.map(Nt.to);return new s.$FM(Ne,ce.outputId,ce.metadata)}Me.to=De})(Tt||(e.NotebookCellOutput=Tt={}));var Et;(function(Me){function Te(Ne){return ce(Ne)?{include:se.from(Ne.include)??void 0,exclude:se.from(Ne.exclude)??void 0}:se.from(Ne)??void 0}Me.from=Te;function De(Ne){return ce(Ne)?{include:se.to(Ne.include),exclude:se.to(Ne.exclude)}:se.to(Ne)}Me.to=De;function ce(Ne){const Be=Ne;return Be?!(0,w.$Rf)(Be.include)&&!(0,w.$Rf)(Be.exclude):!1}})(Et||(e.NotebookExclusiveDocumentPattern=Et={}));var Ht;(function(Me){function Te(De,ce,Ne){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{alignment:De.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:ce.toInternal(Be,Ne),text:De.text,tooltip:De.tooltip,accessibilityInformation:De.accessibilityInformation,priority:De.priority}}Me.from=Te})(Ht||(e.NotebookStatusBarItem=Ht={}));var Ot;(function(Me){function Te(De,ce,Ne){const Be=typeof De.command=="string"?{title:"",command:De.command}:De.command;return{command:ce.toInternal(Be,Ne),label:De.label,description:De.description,detail:De.detail,documentation:De.documentation}}Me.from=Te})(Ot||(e.NotebookKernelSourceAction=Ot={}));var Zt;(function(Me){function Te(De){return{transientOutputs:De?.transientOutputs??!1,transientCellMetadata:De?.transientCellMetadata??{},transientDocumentMetadata:De?.transientDocumentMetadata??{},cellContentMetadata:De?.cellContentMetadata??{}}}Me.from=Te})(Zt||(e.NotebookDocumentContentOptions=Zt={}));var Wt;(function(Me){function Te(ce){return{uri:ce.uri,provides:ce.provides}}Me.from=Te;function De(ce){return new s.$HM(E.URI.revive(ce.uri),ce.provides)}Me.to=De})(Wt||(e.NotebookRendererScript=Wt={}));var Ut;(function(Me){function Te(ce){return{message:M.fromStrict(ce.message)||"",type:0,expected:ce.expectedOutput,actual:ce.actualOutput,contextValue:ce.contextValue,location:ce.location&&{range:u.from(ce.location.range),uri:ce.location.uri}}}Me.from=Te;function De(ce){const Ne=new s.$NM(typeof ce.message=="string"?ce.message:M.to(ce.message));return Ne.actualOutput=ce.actual,Ne.expectedOutput=ce.expected,Ne.contextValue=ce.contextValue,Ne.location=ce.location?de.to(ce.location):void 0,Ne}Me.to=De})(Ut||(e.TestMessage=Ut={}));var et;(function(Me){Me.namespace=a.$9J,Me.denamespace=a.$0J})(et||(e.TestTag=et={}));var Gt;(function(Me){function Te(ce){const Ne=(0,o.$bN)(ce).controllerId;return{extId:n.$5J.fromExtHostTestItem(ce,Ne).toString(),label:ce.label,uri:E.URI.revive(ce.uri),busy:ce.busy,tags:ce.tags.map(Be=>et.namespace(Ne,Be.id)),range:S.$Us.lift(u.from(ce.range)),description:ce.description||null,sortText:ce.sortText||null,error:ce.error&&M.fromStrict(ce.error)||null}}Me.from=Te;function De(ce){return{parent:void 0,error:void 0,id:n.$5J.fromString(ce.extId).localId,label:ce.label,uri:E.URI.revive(ce.uri),tags:(ce.tags||[]).map(Ne=>{const{tagId:Be}=et.denamespace(Ne);return new s.$OM(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(ce.range||void 0),canResolveChildren:!1,busy:ce.busy,description:ce.description||void 0,sortText:ce.sortText||void 0}}Me.toPlain=De})(Gt||(e.TestItem=Gt={})),function(Me){function Te(ce){return{id:ce.id}}Me.from=Te;function De(ce){return new s.$OM(ce.id)}Me.to=De}(et||(e.TestTag=et={}));var Kt;(function(Me){const Te=(ce,Ne)=>{const Be=[];for(const[Je,ct]of Ne)n.$5J.compare(ct.item.extId,Je)===2&&(Ne.delete(Je),Be.push(ct));const xe={...Gt.toPlain(ce.item),parent:void 0,taskStates:ce.tasks.map(Je=>({state:Je.state,duration:Je.duration,messages:Je.messages.filter(ct=>ct.type===0).map(Ut.to)})),children:Be.map(Je=>Te(Je,Ne))};for(const Je of xe.children)Je.parent=xe;return xe};function De(ce){const Ne=[],Be=new Map;for(const xe of ce.items){Be.set(xe.item.extId,xe);const Je=n.$5J.root(xe.item.extId);ce.request.targets.some(ct=>ct.controllerId===Je&&ct.testIds.includes(xe.item.extId))&&Ne.push(xe)}return{completedAt:ce.completedAt,results:Ne.map(xe=>Te(xe,Be))}}Me.to=De})(Kt||(e.TestResults=Kt={}));var ht;(function(Me){function Te(Be){return{covered:Be.covered,total:Be.total}}function De(Be){return"line"in Be?I.from(Be):u.from(Be)}function ce(Be){return"branches"in Be?{count:Be.executionCount,location:De(Be.location),type:1,branches:Be.branches.length?Be.branches.map(xe=>({count:xe.executionCount,location:xe.location&&De(xe.location),label:xe.label})):void 0}:{type:0,name:Be.name,count:Be.executionCount,location:De(Be.location)}}Me.fromDetailed=ce;function Ne(Be){return{uri:Be.uri,statement:Te(Be.statementCoverage),branch:Be.branchCoverage&&Te(Be.branchCoverage),function:Be.functionCoverage&&Te(Be.functionCoverage),details:Be.detailedCoverage?.map(ce)}}Me.fromFile=Ne})(ht||(e.TestCoverage=ht={}));var $t;(function(Me){function Te(De){switch(De){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Me.to=Te})($t||(e.CodeActionTriggerKind=$t={}));var Bt;(function(Me){function Te(ce){const Ne=new s.$UM(re.to(ce.kind),ce.name,ce.detail||"",E.URI.revive(ce.uri),u.to(ce.range),u.to(ce.selectionRange));return Ne._sessionId=ce._sessionId,Ne._itemId=ce._itemId,Ne}Me.to=Te;function De(ce,Ne,Be){if(Ne=Ne??ce._sessionId,Be=Be??ce._itemId,Ne===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:Be,kind:re.from(ce.kind),name:ce.name,detail:ce.detail??"",uri:ce.uri,range:u.from(ce.range),selectionRange:u.from(ce.selectionRange),tags:ce.tags?.map($e.from)}}Me.from=De})(Bt||(e.TypeHierarchyItem=Bt={}));var Qt;(function(Me){function Te(De){if(De)return{value:De.value,tooltip:De.tooltip}}Me.from=Te})(Qt||(e.ViewBadge=Qt={}));var kt;(function(Me){function Te(Be,xe,Je){const ct=xe.fileData;return ct?new s.$5L(new s.$6L(ct.name,E.URI.revive(ct.uri),ct.id,(0,P.$db)(()=>Je(ct.id)))):Be===A.$fs.uriList&&xe.uriListData?new s.$4L(Ne(xe.uriListData)):new s.$4L(xe.asString)}Me.to=Te;async function De(Be,xe){const Je=await xe.asString();if(Be===A.$fs.uriList)return{asString:Je,fileData:void 0,uriListData:ce(Je)};const ct=xe.asFile();return{asString:Je,fileData:ct?{name:ct.name,uri:ct.uri,id:ct._itemId??ct.id}:void 0}}Me.from=De;function ce(Be){return f.$rt.split(Be).map(xe=>{if(xe.startsWith("#"))return xe;try{return E.URI.parse(xe)}catch{}return xe})}function Ne(Be){return f.$rt.create(Be.map(xe=>typeof xe=="string"?xe:E.URI.revive(xe)))}})(kt||(e.DataTransferItem=kt={}));var ft;(function(Me){function Te(ce,Ne){const Be=ce.items.map(([xe,Je])=>[xe,kt.to(xe,Je,Ne)]);return new s.$7L(Be)}Me.toDataTransfer=Te;async function De(ce){const Ne={items:[]},Be=[];for(const[xe,Je]of ce)Be.push((async()=>{Ne.items.push([xe,await kt.from(xe,Je)])})());return await Promise.all(Be),Ne}Me.from=De})(ft||(e.DataTransfer=ft={}));var It;(function(Me){function Te(De){return{kind:"reply",message:De.message,title:De.title,tooltip:De.tooltip}}Me.from=Te})(It||(e.ChatReplyFollowup=It={}));var _t;(function(Me){function Te(De){return typeof De=="string"?{title:De,message:De,kind:"reply"}:"commandId"in De?{kind:"command",title:De.title??"",commandId:De.commandId??"",when:De.when??"",args:De.args}:It.from(De)}Me.from=Te})(_t||(e.ChatFollowup=_t={}));var Lt;(function(Me){function Te(ce){const Ne=new s.$7M(Ke.to(ce.role),ce.content);return Ne.name=ce.name,Ne}Me.to=Te;function De(ce){return{role:Ke.from(ce.role),content:ce.content,name:ce.name}}Me.from=De})(Lt||(e.ChatMessage=Lt={}));var Ke;(function(Me){function Te(ce){switch(ce){case 0:return s.ChatMessageRole.System;case 1:return s.ChatMessageRole.User;case 2:return s.ChatMessageRole.Assistant;case 3:return s.ChatMessageRole.Function}}Me.to=Te;function De(ce){switch(ce){case s.ChatMessageRole.System:return 0;case s.ChatMessageRole.Assistant:return 2;case s.ChatMessageRole.Function:return 3;case s.ChatMessageRole.User:default:return 1}}Me.from=De})(Ke||(e.ChatMessageRole=Ke={}));var Mt;(function(Me){function Te(Ne){const Be={};for(const xe of Object.keys(Ne))Be[xe]=Ne[xe].map(Me.to);return Be}Me.objectTo=Te;function De(Ne){return{level:jt.to(Ne.level),kind:Ne.kind,value:(0,E.$vc)(Ne.value)?E.URI.revive(Ne.value):Ne.value,description:Ne.description}}Me.to=De;function ce(Ne){return{level:jt.from(Ne.level),kind:Ne.kind,value:Ne.value,description:Ne.description}}Me.from=ce})(Mt||(e.ChatVariable=Mt={}));var jt;(function(Me){function Te(ce){switch(ce){case"short":return s.ChatVariableLevel.Short;case"medium":return s.ChatVariableLevel.Medium;case"full":default:return s.ChatVariableLevel.Full}}Me.to=Te;function De(ce){switch(ce){case s.ChatVariableLevel.Short:return"short";case s.ChatVariableLevel.Medium:return"medium";case s.ChatVariableLevel.Full:default:return"full"}}Me.from=De})(jt||(e.ChatVariableLevel=jt={}));var Yt;(function(Me){function Te(De){switch(De){case 1:return s.InteractiveEditorResponseFeedbackKind.Helpful;case 0:return s.InteractiveEditorResponseFeedbackKind.Unhelpful;case 2:return s.InteractiveEditorResponseFeedbackKind.Undone;case 3:return s.InteractiveEditorResponseFeedbackKind.Accepted;case 4:return s.InteractiveEditorResponseFeedbackKind.Bug}}Me.to=Te})(Yt||(e.InteractiveEditorResponseFeedbackKind=Yt={}));var gt;(function(Me){function Te(Ne,Be){return"markdownContent"in Be?((0,h.$GF)(Ne,"chatAgents2Additions"),{content:M.from(Be.markdownContent),kind:"markdownContent"}):"content"in Be?"vulnerabilities"in Be&&Be.vulnerabilities?((0,h.$GF)(Ne,"chatAgents2Additions"),{content:Be.content,vulnerabilities:Be.vulnerabilities,kind:"vulnerability"}):typeof Be.content=="string"?{content:Be.content,kind:"content"}:((0,h.$GF)(Ne,"chatAgents2Additions"),{content:M.from(Be.content),kind:"markdownContent"}):"documents"in Be?{documents:Be.documents.map(xe=>({uri:xe.uri,version:xe.version,ranges:xe.ranges.map(Je=>u.from(Je))})),kind:"usedContext"}:"reference"in Be?{reference:"uri"in Be.reference?{uri:Be.reference.uri,range:u.from(Be.reference.range)}:Be.reference,kind:"reference"}:"inlineReference"in Be?{inlineReference:"uri"in Be.inlineReference?{uri:Be.inlineReference.uri,range:u.from(Be.inlineReference.range)}:Be.inlineReference,name:Be.title,kind:"inlineReference"}:"agentName"in Be?((0,h.$GF)(Ne,"chatAgents2Additions"),{agentName:Be.agentName,command:Be.command,kind:"agentDetection"}):"treeData"in Be?{treeData:Be.treeData,kind:"treeData"}:"message"in Be?{content:M.from(Be.message),kind:"progressMessage"}:void 0}Me.from=Te;function De(Ne){switch(Ne.kind){case"markdownContent":case"inlineReference":case"treeData":return Me.to(Ne);case"content":return{content:Ne.content};case"usedContext":return{documents:Ne.documents.map(Be=>({uri:E.URI.revive(Be.uri),version:Be.version,ranges:Be.ranges.map(xe=>u.to(xe))}))};case"reference":return{reference:(0,E.$vc)(Ne.reference)?E.URI.revive(Ne.reference):l.to(Ne.reference)};case"agentDetection":return;case"progressMessage":return{message:Ne.content.value};case"vulnerability":return{content:Ne.content,vulnerabilities:Ne.vulnerabilities};default:return}}Me.to=De;function ce(Ne){switch(Ne.kind){case"markdownContent":return{content:Ne.content.value};case"inlineReference":return{inlineReference:(0,E.$vc)(Ne.inlineReference)?E.URI.revive(Ne.inlineReference):l.to(Ne.inlineReference),title:Ne.name};case"treeData":return{treeData:(0,k.$Ch)(Ne.treeData)};default:return}}Me.toProgressContent=ce})(gt||(e.ChatResponseProgress=gt={}));var Ft;(function(Me){function Te(De,ce){return{prompt:De.message,variables:Mt.objectTo(De.variables),slashCommand:ce,subCommand:De.command,agentId:De.agentId}}Me.to=Te})(Ft||(e.ChatAgentRequest=Ft={}));var Rt;(function(Me){function Te(De){return{label:De.label,values:De.values.map(Mt.from),insertText:De.insertText,detail:De.detail,documentation:De.documentation}}Me.from=Te})(Rt||(e.ChatAgentCompletionItem=Rt={}));var Vt;(function(Me){function Te(De,ce,Ne){return"terminalCommand"in De?{terminalCommand:De.terminalCommand,shouldExecute:De.shouldExecute}:"uri"in De?{uri:De.uri}:ce.toInternal(De,Ne)}Me.from=Te})(Vt||(e.TerminalQuickFix=Vt={}))}),define(ke[317],Se([1,0,6,20,15]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rgc=void 0;let P=class{constructor(v,$){this.a=v.getProxy(C.$aL.MainThreadBulkEdits),this.b={getTextDocumentVersion:k=>$.getDocument(k)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(v,$,k){const A=f.WorkspaceEdit.from(v,this.b);return this.a.$tryApplyWorkspaceEdit(A,void 0,k?.isRefactoring??!1)}};e.$Rgc=P,e.$Rgc=P=Ge([We(0,N.$fN)],P)}),define(ke[318],Se([1,0,53,3,6,15]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sgc=void 0;class R{static{this.a=0}constructor(k,A){this.extension=k,this.provider=A,this.handle=R.a++}}class v{static{this.a=0}constructor(k){this.b=new Map,this.c=new Map,this.d=k.getProxy(f.$aL.MainThreadChat)}registerChatProvider(k,A,D){const w=new R(k,D);return this.b.set(w.handle,w),this.d.$registerChatProvider(w.handle,A),(0,N.$Rc)(()=>{this.d.$unregisterChatProvider(w.handle),this.b.delete(w.handle)})}transferChatSession(k,A){const D=C.Iterable.find(this.c.keys(),w=>this.c.get(w)===k)??0;typeof D=="number"&&this.d.$transferChatSession(D,A)}sendInteractiveRequestToProvider(k,A){this.d.$sendRequestToProvider(k,A)}async $prepareChat(k,A){const D=this.b.get(k);if(!D)return;const w=await D.provider.prepareSession(A);if(!w)return;const E=v.a++;return this.c.set(E,w),{id:E,requesterUsername:w.requester?.name,requesterAvatarIconUri:w.requester?.icon,responderUsername:w.responder?.name,responderAvatarIconUri:w.responder?.icon,inputPlaceholder:w.inputPlaceholder}}async $provideWelcomeMessage(k,A){const D=this.b.get(k);if(!D||!D.provider.provideWelcomeMessage)return;const w=await D.provider.provideWelcomeMessage(A);if(w)return w.map(E=>typeof E=="string"?E:Array.isArray(E)?E.map(S=>P.ChatReplyFollowup.from(S)):P.MarkdownString.from(E))}async $provideSampleQuestions(k,A){const D=this.b.get(k);if(!D||!D.provider.provideSampleQuestions)return;const w=await D.provider.provideSampleQuestions(A);if(w)return w?.map(E=>P.ChatReplyFollowup.from(E))}$releaseSession(k){this.c.delete(k)}}e.$Sgc=v}),define(ke[319],Se([1,0,19,11,21,44,4,38,18,2,210,86,6,15,7,279,26]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ugc=void 0;class o{static{this.a=0}constructor(n,a,t){this.j=a,this.k=t,this.b=new Map,this.g=new Map,this.i=new Map,this.d=n.getProxy(w.$aL.MainThreadChatAgents2)}createChatAgent(n,a,t){const h=o.a++,s=new i(n,a,this.d,h,t);return this.b.set(h,s),this.d.$registerAgent(h,a,{}),s.apiAgent}async $invokeAgent(n,a,t,h){this.g.delete(a.sessionId);const s=this.b.get(n);if(!s)throw new Error(`[CHAT](${n}) CANNOT invoke agent because the agent is not registered`);let d=!1;function u(){if(d)throw new Error("Only valid while executing the command")}const l=new N.$qh;h.onCancellationRequested(()=>l.complete()),this.j.allowListExtensionWhile(s.extension.identifier,l.p);const p=a.command?await s.validateSlashCommand(a.command):void 0,I=v.$Rd.create(!1);let b;try{const m=await this.l(s,a,t),y=s.invoke(E.ChatAgentRequest.to(a,p),{history:m},new D.$vv(L=>{u(),typeof b>"u"&&"content"in L&&(b=I.elapsed());const F=E.ChatResponseProgress.from(s.extension,L);if(!F){this.k.error("Unknown progress type: "+JSON.stringify(L));return}"placeholder"in L&&"resolvedContent"in L||this.d.$handleProgressChunk(a.requestId,F)}),h);return await(0,N.$Ug)(Promise.resolve(y).then(L=>{if(L){this.g.set(a.sessionId,L);let F=this.i.get(a.sessionId);F||(F=new Map,this.i.set(a.sessionId,F)),F.set(a.requestId,L);const z={firstProgress:b,totalElapsed:I.elapsed()};return{errorDetails:L.errorDetails,timings:z}}else this.g.delete(a.sessionId)}),h)}catch(m){return this.k.error(m,s.extension),{errorDetails:{message:(0,A.localize)(0,null,(0,P.$Qi)(m)),responseIsIncomplete:!0}}}finally{d=!0,l.complete()}}async l(n,a,t){return(0,C.$Hb)(await Promise.all(t.history.map(async h=>{const s=a.agentId===h.request.agentId&&this.i.get(a.sessionId)?.get(h.request.requestId)||h.result;return{request:E.ChatAgentRequest.to(h.request,void 0),response:(0,C.$Hb)(h.response.map(d=>E.ChatResponseProgress.toProgressContent(d))),result:s}})))}$releaseSession(n){this.g.delete(n),this.i.delete(n)}async $provideSlashCommands(n,a){const t=this.b.get(n);return t?t.provideSlashCommand(a):[]}$provideFollowups(n,a,t){const h=this.b.get(n);if(!h)return Promise.resolve([]);const s=this.g.get(a);return s?h.provideFollowups(s,t):Promise.resolve([])}$acceptFeedback(n,a,t,h,s){const d=this.b.get(n);if(!d)return;const u=this.i.get(a)?.get(t);if(!u)return;let l;switch(h){case c.InteractiveSessionVoteDirection.Down:l=S.ChatAgentResultFeedbackKind.Unhelpful;break;case c.InteractiveSessionVoteDirection.Up:l=S.ChatAgentResultFeedbackKind.Helpful;break}d.acceptFeedback(Object.freeze(s?{result:u,kind:l,reportIssue:s}:{result:u,kind:l}))}$acceptAction(n,a,t,h){const s=this.b.get(n);if(!s)return;const d=this.i.get(a)?.get(t);d&&h.action.kind!=="vote"&&s.acceptAction(Object.freeze({action:h.action,result:d}))}async $invokeCompletionProvider(n,a,t){const h=this.b.get(n);return h?(await h.invokeCompletionProvider(a,t)).map(E.ChatAgentCompletionItem.from):[]}}e.$Ugc=o;class i{constructor(n,a,t,h,s){this.extension=n,this.id=a,this.w=t,this.x=h,this.y=s,this.q=new R.$Vd,this.s=new R.$Vd}acceptFeedback(n){this.q.fire(n)}acceptAction(n){this.s.fire(n)}async invokeCompletionProvider(n,a){return this.u?await this.u.provider.provideCompletionItems(n,a)??[]:[]}async validateSlashCommand(n){this.b||(await this.provideSlashCommand(f.CancellationToken.None),(0,$.$Sf)(this.b));const a=this.b.find(t=>t.name===n);if(!a)throw new Error(`Unknown slashCommand: ${n}`);return a}async provideSlashCommand(n){if(!this.a)return[];const a=await this.a.provideSubCommands(n);return a?(this.b=a,a.map(t=>({name:t.name,description:t.description,followupPlaceholder:t.followupPlaceholder,shouldRepopulate:t.shouldRepopulate,sampleRequest:t.sampleRequest}))):[]}async provideFollowups(n,a){if(!this.d)return[];const t=await this.d.provideFollowups(n,a);return t?t.map(h=>E.ChatFollowup.from(h)):[]}get apiAgent(){let n=!1,a=!1;const t=()=>{n||a||(a=!0,queueMicrotask(()=>{this.w.$updateAgent(this.x,{description:this.g??"",fullName:this.i,icon:this.j?this.j instanceof k.URI?this.j:"light"in this.j?this.j.light:void 0:void 0,iconDark:this.j&&"dark"in this.j?this.j.dark:void 0,themeIcon:this.j instanceof S.$0L?this.j:void 0,hasSlashCommands:this.a!==void 0,hasFollowups:this.d!==void 0,isDefault:this.k,isSecondary:this.o,helpTextPrefix:!this.l||typeof this.l=="string"?this.l:E.MarkdownString.from(this.l),helpTextPostfix:!this.m||typeof this.m=="string"?this.m:E.MarkdownString.from(this.m),sampleRequest:this.n,supportIssueReporting:this.t}),a=!1}))},h=this;return{get name(){return h.id},get description(){return h.g??""},set description(s){h.g=s,t()},get fullName(){return h.i??h.extension.displayName??h.extension.name},set fullName(s){h.i=s,t()},get iconPath(){return h.j},set iconPath(s){h.j=s,t()},get subCommandProvider(){return h.a},set subCommandProvider(s){h.a=s,t()},get followupProvider(){return h.d},set followupProvider(s){h.d=s,t()},get isDefault(){return(0,g.$GF)(h.extension,"defaultChatAgent"),h.k},set isDefault(s){(0,g.$GF)(h.extension,"defaultChatAgent"),h.k=s,t()},get helpTextPrefix(){return(0,g.$GF)(h.extension,"defaultChatAgent"),h.l},set helpTextPrefix(s){if((0,g.$GF)(h.extension,"defaultChatAgent"),!h.k)throw new Error("helpTextPrefix is only available on the default chat agent");h.l=s,t()},get helpTextPostfix(){return(0,g.$GF)(h.extension,"defaultChatAgent"),h.m},set helpTextPostfix(s){if((0,g.$GF)(h.extension,"defaultChatAgent"),!h.k)throw new Error("helpTextPostfix is only available on the default chat agent");h.m=s,t()},get isSecondary(){return(0,g.$GF)(h.extension,"defaultChatAgent"),h.o},set isSecondary(s){(0,g.$GF)(h.extension,"defaultChatAgent"),h.o=s,t()},get sampleRequest(){return h.n},set sampleRequest(s){h.n=s,t()},get supportIssueReporting(){return(0,g.$GF)(h.extension,"chatAgents2Additions"),h.t},set supportIssueReporting(s){(0,g.$GF)(h.extension,"chatAgents2Additions"),h.t=s,t()},get onDidReceiveFeedback(){return h.q.event},set agentVariableProvider(s){if(h.u=s,s){if(!s.triggerCharacters.length)throw new Error("triggerCharacters are required");h.w.$registerAgentCompletionsProvider(h.x,s.triggerCharacters)}else h.w.$unregisterAgentCompletionsProvider(h.x)},get agentVariableProvider(){return h.u},onDidPerformAction:(0,g.$FF)(this.extension,"chatAgents2Additions")?this.s.event:void 0,dispose(){n=!0,h.a=void 0,h.d=void 0,h.q.dispose(),h.w.$unregisterAgent(h.x)}}}invoke(n,a,t,h){return this.y(n,a,t,h)}}}),define(ke[320],Se([1,0,21,3,6,15,86,25,11,4]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tgc=void 0;class A{constructor(S,c){this.stream=new $.$wh,this.stream=c??new $.$wh;const g=this;this.apiObj={option:S,response:g.stream.asyncIterable}}}class D{constructor(S,c){this.a=new k.$Vd,this.b=new Map,this.c=new $.$wh,this.d=!1;const g=this;this.apiObject={result:S,response:g.c.asyncIterable,onDidStartResponseStream:g.a.event,cancel(){c.cancel()}},S.finally(()=>{if(this.d=!0,this.b.size>0)for(const[,o]of this.b)o.stream.resolve();else this.c.resolve()})}handleFragment(S){if(this.d)return;let c=this.b.get(S.index);c||(this.b.size===0?c=new A(S.index,this.c):c=new A(S.index),this.b.set(S.index,c),this.a.fire(c.apiObj)),c.stream.emitOne(S.part)}}class w{static{this.a=1}constructor(S,c){this.d=c,this.c=new Map,this.e=new Map,this.f=new v.$nm,this.b=S.getProxy(f.$aL.MainThreadChatProvider)}registerProvider(S,c,g,o){const i=w.a++;return this.c.set(i,{extension:S,provider:g}),this.b.$registerProvider(i,c,{extension:S,model:o.name??""}),(0,N.$Rc)(()=>{this.b.$unregisterProvider(i),this.c.delete(i)})}async $provideChatResponse(S,c,g,o,i){const r=this.c.get(S);if(!r)return;const n=new R.$vv(async a=>{if(i.isCancellationRequested){this.d.warn(`[CHAT](${r.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(c,{index:a.index,part:a.part})});return r.provider.provideChatResponse(g.map(P.ChatMessage.to),o,n,i)}allowListExtensionWhile(S,c){this.f.set(S,c),c.finally(()=>this.f.delete(S))}async requestChatResponseProvider(S,c){if(!this.f.has(S))throw new Error("Extension is NOT allowed to make chat requests");const g=await this.b.$prepareChatAccess(c);if(!g)throw new Error(`ChatAccess '${c}' NOT found`);const o=this;return{get model(){return g.model},get isRevoked(){return!o.f.has(S)},makeRequest(i,r,n){if(!o.f.has(S))throw new Error("Access to chat has been revoked");const a=new C.$6d(n),t=Math.random()*1e6|0,h=o.b.$fetchResponse(S,c,t,i.map(P.ChatMessage.from),r??{},a.token),s=new D(h,a);return o.e.set(t,{res:s}),h.finally(()=>{o.e.delete(t)}),s.apiObject}}}async $handleResponseFragment(S,c){const g=this.e.get(S);g&&g.res.handleFragment(c)}}e.$Tgc=w}),define(ke[321],Se([1,0,3,6,14,15]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vgc=void 0;class R{static{this.a=0}constructor($){this.b=new Map,this.c=$.getProxy(N.$aL.MainThreadChatVariables)}async $resolveVariable($,k,A){const D=this.b.get($);if(D)try{const w=await D.resolver.resolve(D.data.name,{prompt:k},A);if(w)return w.map(P.ChatVariable.from)}catch(w){(0,f.$2)(w)}}registerVariableResolver($,k,A,D){const w=R.a++;return this.b.set(w,{extension:$.identifier,data:{name:k,description:A},resolver:D}),this.c.$registerVariable(w,{name:k,description:A}),(0,C.$Rc)(()=>{this.b.delete(w),this.c.$unregisterVariable(w)})}}e.$Vgc=R}),define(ke[322],Se([1,0,11,52,4,3,2,83,25,15,7,6,26]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zgc=void 0;function E(S,c,g){const o=S.getProxy(D.$aL.MainThreadComments);class i{static{this.a=0}constructor(){this.b=new Map,this.c=new $.$nm,c.registerArgumentProcessor({processArgument:l=>{if(l&&l.$mid===6){const p=this.b.get(l.handle);return p?p.value:l}else if(l&&l.$mid===7){const p=this.b.get(l.commentControlHandle);if(!p)return l;const I=p.getCommentThread(l.commentThreadHandle);return I?I.value:l}else if(l&&(l.$mid===9||l.$mid===8)){const p=this.b.get(l.thread.commentControlHandle);if(!p)return l;const I=p.getCommentThread(l.thread.commentThreadHandle);return I?l.$mid===8?I.value:{thread:I.value,text:l.text}:l}else if(l&&l.$mid===10){const p=this.b.get(l.thread.commentControlHandle);if(!p)return l;const I=p.getCommentThread(l.thread.commentThreadHandle);if(!I)return l;const b=l.commentUniqueId,m=I.getCommentByUniqueId(b);return m||l}else if(l&&l.$mid===11){const p=this.b.get(l.thread.commentControlHandle);if(!p)return l;const I=p.getCommentThread(l.thread.commentThreadHandle);if(!I)return l;const b=l.text,m=l.commentUniqueId,y=I.getCommentByUniqueId(m);return y?(typeof y.body=="string"?y.body=b:y.body=new A.$DL(b),y):l}return l}})}createCommentController(l,p,I){const b=i.a++,m=new n(l,b,p,I);this.b.set(m.handle,m);const y=this.c.get(l.identifier)||[];return y.push(m),this.c.set(l.identifier,y),m.value}async $createCommentThreadTemplate(l,p,I){const b=this.b.get(l);b&&b.$createCommentThreadTemplate(p,I)}async $updateCommentThreadTemplate(l,p,I){const b=this.b.get(l);b&&b.$updateCommentThreadTemplate(p,I)}$deleteCommentThread(l,p){this.b.get(l)?.$deleteCommentThread(p)}$provideCommentingRanges(l,p,I){const b=this.b.get(l);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const m=g.getDocument(R.URI.revive(p));return(0,C.$Yg)(async()=>{const y=await b.commentingRangeProvider.provideCommentingRanges(m,I);let L;return Array.isArray(y)?L={ranges:y,fileComments:!1}:y?L={ranges:y.ranges||[],fileComments:y.fileComments||!1}:L=y??void 0,L}).then(y=>{let L;return y&&(L={ranges:y.ranges.map(F=>k.Range.from(F)),fileComments:y.fileComments}),L})}$toggleReaction(l,p,I,b,m){const y=this.b.get(l);return!y||!y.reactionHandler?Promise.resolve(void 0):(0,C.$Yg)(()=>{const L=y.getCommentThread(p);if(L){const F=L.getCommentByUniqueId(b.uniqueIdInThread);if(y!==void 0&&F&&y.reactionHandler)return y.reactionHandler(F,h(m))}return Promise.resolve(void 0)})}}class r{static{this.a=0}set threadId(l){this.n=l}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(l){(l===void 0!=(this.p===void 0)||!l||!this.p||!l.isEqual(this.p))&&(this.p=l,this.b.range=l,this.c.fire())}get range(){return this.p}set canReply(l){this.d!==l&&(this.d=l,this.b.canReply=l,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(l){this.e=l,this.b.label=l,this.c.fire()}get contextValue(){return this.f}set contextValue(l){this.f=l,this.b.contextValue=l,this.c.fire()}get comments(){return this.q}set comments(l){this.q=l,this.b.comments=l,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(l){this.g=l,this.b.collapsibleState=l,this.c.fire()}get state(){return this.h}set state(l){this.h=l,this.b.state=l,this.c.fire()}get isDisposed(){return this.j}constructor(l,p,I,b,m,y,L,F){this.m=p,this.n=I,this.o=b,this.p=m,this.q=y,this.extensionDescription=L,this.r=F,this.handle=r.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new f.$Vd,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new P.$Uc,this.l.value=new P.$Sc,this.n===void 0&&(this.n=`${l}.${this.handle}`),o.$createCommentThread(p,this.handle,this.n,this.o,k.Range.from(this.p),L.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=y,this.i.push({dispose:()=>{o.$deleteCommentThread(p,this.handle)}});const z=this;this.value={get uri(){return z.uri},get range(){return z.range},set range(T){z.range=T},get comments(){return z.comments},set comments(T){z.comments=T},get collapsibleState(){return z.collapsibleState},set collapsibleState(T){z.collapsibleState=T},get canReply(){return z.canReply},set canReply(T){z.canReply=T},get contextValue(){return z.contextValue},set contextValue(T){z.contextValue=T},get label(){return z.label},set label(T){z.label=T},get state(){return z.state},set state(T){z.state=T},dispose:()=>{z.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new P.$Sc);const l=I=>Object.prototype.hasOwnProperty.call(this.b,I),p={};l("range")&&(p.range=k.Range.from(this.p)),l("label")&&(p.label=this.label),l("contextValue")&&(p.contextValue=this.contextValue??null),l("comments")&&(p.comments=this.q.map(I=>a(this,I,this.k,this.extensionDescription))),l("collapsibleState")&&(p.collapseState=s(this.g)),l("canReply")&&(p.canReply=this.canReply),l("state")&&(p.state=d(this.h)),l("isTemplate")&&(p.isTemplate=this.r),this.b={},o.$updateCommentThread(this.m,this.handle,this.n,this.o,p)}getCommentByUniqueId(l){for(const p of this.k){const I=p[0],b=p[1];if(l===b)return I}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(l=>l.dispose())}}Ge([(0,N.$yh)(100)],r.prototype,"eventuallyUpdateCommentThread",null);class n{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(l){this.b=l,o.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(l){this.c=l,o.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!l})}get options(){return this.d}set options(l){this.d=l,o.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(l,p,I,b){this.f=l,this.g=p,this.h=I,this.i=b,this.a=new Map,o.$registerCommentController(this.handle,I,b,this.f.identifier.value);const m=this;this.value=Object.freeze({id:m.id,label:m.label,get options(){return m.options},set options(y){m.options=y},get commentingRangeProvider(){return m.commentingRangeProvider},set commentingRangeProvider(y){m.commentingRangeProvider=y},get reactionHandler(){return m.reactionHandler},set reactionHandler(y){m.reactionHandler=y},createCommentThread(y,L,F){return m.createCommentThread(y,L,F).value},dispose:()=>{m.dispose()}}),this.e=[],this.e.push({dispose:()=>{o.$unregisterCommentController(this.handle)}})}createCommentThread(l,p,I){p===void 0&&(0,w.$GF)(this.f,"fileComments");const b=new r(this.id,this.handle,void 0,l,p,I,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(l,p){const I=new r(this.id,this.handle,void 0,R.URI.revive(l),k.Range.to(p),[],this.f,!0);return I.collapsibleState=v.CommentThreadCollapsibleState.Expanded,this.a.set(I.handle,I),I}$updateCommentThreadTemplate(l,p){const I=this.a.get(l);I&&(I.range=k.Range.to(p))}$deleteCommentThread(l){this.a.get(l)?.dispose(),this.a.delete(l)}getCommentThread(l){return this.a.get(l)}dispose(){this.a.forEach(l=>{l.dispose()}),this.e.forEach(l=>l.dispose())}}function a(u,l,p,I){let b=p.get(l);return b||(b=++u.commentHandle,p.set(l,b)),l.state!==void 0&&(0,w.$GF)(I,"commentsDraftState"),l.reactions?.some(m=>m.reactors!==void 0)&&(0,w.$GF)(I,"commentReactor"),{mode:l.mode,contextValue:l.contextValue,uniqueIdInThread:b,body:typeof l.body=="string"?l.body:k.MarkdownString.from(l.body),userName:l.author.name,userIconPath:l.author.iconPath,label:l.label,commentReactions:l.reactions?l.reactions.map(m=>t(m)):void 0,state:l.state,timestamp:l.timestamp?.toJSON()}}function t(u){return{label:u.label,iconPath:u.iconPath?k.$eN(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted,reactors:u.reactors&&u.reactors.length>0&&typeof u.reactors[0]!="string"?u.reactors.map(l=>l.name):u.reactors}}function h(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?R.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1,reactors:u.reactors?.map(l=>({name:l}))}}function s(u){if(u!==void 0)switch(u){case A.CommentThreadCollapsibleState.Expanded:return v.CommentThreadCollapsibleState.Expanded;case A.CommentThreadCollapsibleState.Collapsed:return v.CommentThreadCollapsibleState.Collapsed}return v.CommentThreadCollapsibleState.Collapsed}function d(u){if(u!==void 0)switch(u){case A.CommentThreadState.Unresolved:return v.CommentThreadState.Unresolved;case A.CommentThreadState.Resolved:return v.CommentThreadState.Resolved}return v.CommentThreadState.Unresolved}return new i}e.$Zgc=E}),define(ke[323],Se([1,0,21,54,3,16,23,2,15,93,110,6,7]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fhc=void 0;class E{constructor(h,s){this.document=h,this.b=s,this.a=1,this.c=new A.$Egc("custom documents")}addEdit(h){return this.c.add([h])}async undo(h,s){await this.f(h).undo(),s||this.disposeBackup()}async redo(h,s){await this.f(h).redo(),s||this.disposeBackup()}disposeEdits(h){for(const s of h)this.c.delete(s)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const h=a(this.document.uri)+this.a++;return(0,R.$Hg)(this.b,h)}updateBackup(h){this.d?.delete(),this.d=h}disposeBackup(){this.d?.delete(),this.d=void 0}f(h){const s=this.c.get(h,0);if(!s)throw new Error("No edit found");return s}}class S{constructor(){this.a=new Map}get(h,s){return this.a.get(this.b(h,s))}add(h,s,d){const u=this.b(h,s.uri);if(this.a.has(u))throw new Error(`Document already exists for viewType:${h} resource:${s.uri}`);const l=new E(s,d);return this.a.set(u,l),l}delete(h,s){const d=this.b(h,s.uri);this.a.delete(d)}b(h,s){return`${h}@@@${s}`}}var c;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(c||(c={}));class g{constructor(){this.a=new Map}addTextProvider(h,s,d){return this.b(0,h,s,d)}addCustomProvider(h,s,d){return this.b(1,h,s,d)}get(h){return this.a.get(h)}b(h,s,d,u){if(this.a.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this.a.set(s,{type:h,extension:d,provider:u}),new w.$cL(()=>this.a.delete(s))}}class o{constructor(h,s,d,u,l){this.d=s,this.f=d,this.g=u,this.h=l,this.b=new g,this.c=new S,this.a=h.getProxy(D.$aL.MainThreadCustomEditors)}registerCustomEditorProvider(h,s,d,u){const l=new f.$Sc;return r(d)?(l.add(this.b.addTextProvider(s,h,d)),this.a.$registerTextEditorProvider((0,k.$chc)(h),s,u.webviewOptions||{},{supportsMove:!!d.moveCustomTextEditor},(0,k.$ahc)(h))):(l.add(this.b.addCustomProvider(s,h,d)),i(d)&&l.add(d.onDidChangeCustomDocument(p=>{const I=this.i(s,p.document.uri);if(n(p)){const b=I.addEdit(p);this.a.$onDidEdit(p.document.uri,s,b,p.label)}else this.a.$onContentChange(p.document.uri,s)})),this.a.$registerCustomEditorProvider((0,k.$chc)(h),s,u.webviewOptions||{},!!u.supportsMultipleEditorsPerDocument,(0,k.$ahc)(h))),w.$cL.from(l,new w.$cL(()=>{this.a.$unregisterEditorProvider(s)}))}async $createCustomDocument(h,s,d,u,l){const p=this.b.get(s);if(!p)throw new Error(`No provider found for '${s}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${s}'`);const I=v.URI.revive(h),b=await p.provider.openCustomDocument(I,{backupId:d,untitledDocumentData:u?.buffer},l);let m;return i(p.provider)&&this.f&&(m=this.f.workspaceValue(p.extension)??this.f.globalValue(p.extension)),this.c.add(s,b,m),{editable:i(p.provider)}}async $disposeCustomDocument(h,s){const d=this.b.get(s);if(!d)throw new Error(`No provider found for '${s}'`);if(d.type!==1)throw new Error(`Invalid provider type for '${s}'`);const u=v.URI.revive(h),{document:l}=this.i(s,u);this.c.delete(s,l),l.dispose()}async $resolveCustomEditor(h,s,d,u,l,p){const I=this.b.get(d);if(!I)throw new Error(`No provider found for '${d}'`);const b=$.ViewColumn.to(l),m=this.g.createNewWebview(s,u.contentOptions,I.extension),y=this.h.createNewWebviewPanel(s,d,u.title,b,u.options,m,u.active),L=v.URI.revive(h);switch(I.type){case 1:{const{document:F}=this.i(d,L);return I.provider.resolveCustomEditor(F,y,p)}case 0:{const F=this.d.getDocument(L);return I.provider.resolveCustomTextEditor(F,y,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(h,s,d){this.i(s,h).disposeEdits(d)}async $onMoveCustomEditor(h,s,d){const u=this.b.get(d);if(!u)throw new Error(`No provider found for '${d}'`);if(!u.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${d}'`);const l=this.h.getWebviewPanel(h);if(!l)throw new Error("No webview found");const p=v.URI.revive(s),I=this.d.getDocument(p);await u.provider.moveCustomTextEditor(I,l,C.CancellationToken.None)}async $undo(h,s,d,u){return this.i(s,h).undo(d,u)}async $redo(h,s,d,u){return this.i(s,h).redo(d,u)}async $revert(h,s,d){const u=this.i(s,h);await this.j(s).revertCustomDocument(u.document,d),u.disposeBackup()}async $onSave(h,s,d){const u=this.i(s,h);await this.j(s).saveCustomDocument(u.document,d),u.disposeBackup()}async $onSaveAs(h,s,d,u){const l=this.i(s,h);return this.j(s).saveCustomDocumentAs(l.document,v.URI.revive(d),u)}async $backup(h,s,d){const u=this.i(s,h),p=await this.j(s).backupCustomDocument(u.document,{destination:u.getNewBackupUri()},d);return u.updateBackup(p),p.id}i(h,s){const d=this.c.get(h,v.URI.revive(s));if(!d)throw new Error("No custom document found");return d}j(h){const d=this.b.get(h)?.provider;if(!d||!i(d))throw new Error("Custom document is not editable");return d}}e.$fhc=o;function i(t){return!!t.onDidChangeCustomDocument}function r(t){return typeof t.resolveCustomTextEditor=="function"}function n(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function a(t){const h=t.scheme===P.Schemas.file||t.scheme===P.Schemas.untitled?t.fsPath:t.toString();return(0,N.$Ti)(h)+""}}),define(ke[324],Se([1,0,211,135,2,6,7,15,4,13,28,59]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$Kgc=e.$Jgc=void 0;class E{#e;#t;#i;constructor(g,o,i,r,n,a,t,h){this.d=g,this.e=o,this.f=i,this.g=r,this.h=n,this.c=!1,this.f=Math.max(r,i),this.#i=new A.$Ac(s=>a.getComparisonKey(s)),this.#e=t,this.#t=h}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(g,o){if(!g){this.clear();return}this.j();let i=[];if(f.URI.isUri(g)){if(!o){this.delete(g);return}this.#i.set(g,o.slice()),i=[g]}else if(Array.isArray(g)){i=[];let a;g=[...g].sort(E.k);for(const t of g){const[h,s]=t;if((!a||h.toString()!==a.toString())&&(a&&this.#i.get(a).length===0&&this.#i.delete(a),a=h,i.push(h),this.#i.set(h,[])),s)this.#i.get(h)?.push(...s);else{const d=this.#i.get(h);d&&(d.length=0)}}}if(this.#t.fire(i),!this.#e)return;const r=[];let n=0;for(const a of i){let t=[];const h=this.#i.get(a);if(h)if(h.length>this.g){t=[];const s=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let d=0;d<4;d++)for(const u of h)if(u.severity===s[d]&&t.push({...v.Diagnostic.from(u),modelVersionId:this.h(a)})===this.g)break e;t.push({severity:N.MarkerSeverity.Info,message:(0,C.localize)(0,null,h.length-this.g),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=h.map(s=>({...v.Diagnostic.from(s),modelVersionId:this.h(a)}));if(r.push([a,t]),n+=t.length,n>this.f)break}this.#e.$changeMany(this.e,r)}delete(g){this.j(),this.#t.fire([g]),this.#i.delete(g),this.#e?.$changeMany(this.e,[[g,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(g,o){this.j();for(const[i,r]of this)g.call(o,i,r,this)}*[Symbol.iterator](){this.j();for(const g of this.#i.keys())yield[g,this.get(g)]}get(g){this.j();const o=this.#i.get(g);return Array.isArray(o)?Object.freeze(o.slice(0)):[]}has(g){return this.j(),Array.isArray(this.#i.get(g))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(g,o){return g[0].toString()<o[0].toString()?-1:g[0].toString()>o[0].toString()?1:0}}e.$Jgc=E;let S=class{static{w=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*w.d}static _mapper(g){const o=new A.$Ac;for(const i of g)o.set(i,i);return{uris:Object.freeze(Array.from(o.values()))}}constructor(g,o,i,r){this.j=o,this.k=i,this.l=r,this.g=new Map,this.h=new $.$Zd({merge:n=>n.flat(),delay:50}),this.onDidChangeDiagnostics=$.Event.map(this.h.event,w._mapper),this.f=g.getProxy(P.$aL.MainThreadDiagnostics)}createDiagnosticCollection(g,o){const{g:i,f:r,h:n,j:a,k:t,l:h}=this,s=new class{$changeMany(l,p){r.$changeMany(l,p),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",g.value,l,p.length===0?"CLEARING":p)}$clear(l){r.$clear(l),a.trace("[DiagnosticCollection] remove all (extension, owner)",g.value,l)}dispose(){r.dispose()}};let d;if(!o)o="_generated_diagnostic_collection_name_#"+w.c++,d=o;else if(!i.has(o))d=o;else{this.j.warn(`DiagnosticCollection with name '${o}' does already exist.`);do d=o+w.c++;while(i.has(d))}return new class extends E{constructor(){super(o,d,w.e,w.d,l=>h.getDocument(l)?.version,t.extUri,s,n),i.set(d,this)}dispose(){super.dispose(),i.delete(d)}}}getDiagnostics(g){if(g)return this.m(g);{const o=new Map,i=[];for(const r of this.g.values())r.forEach((n,a)=>{let t=o.get(n.toString());typeof t>"u"&&(t=i.length,o.set(n.toString(),t),i.push([n,[]])),i[t][1]=i[t][1].concat(...a)});return i}}m(g){let o=[];for(const i of this.g.values())i.has(g)&&(o=o.concat(i.get(g)));return o}$acceptMarkersChange(g){if(!this.n){const o="_generated_mirror",i=new E(o,o,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,r=>{},this.k.extUri,void 0,this.h);this.g.set(o,i),this.n=i}for(const[o,i]of g)this.n.set(f.URI.revive(o),i.map(v.Diagnostic.to))}};e.$Kgc=S,e.$Kgc=S=w=Ge([We(1,k.$nj),We(2,D.$Igc)],S)}),define(ke[325],Se([1,0,2,14,7,15,75]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Thc=void 0;class v{constructor(k,A,D,w={timeout:1500,errors:3}){this.c=k,this.d=A,this.f=D,this.g=w,this.a=new R.$4c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(k){return(A,D,w)=>{const S={dispose:this.a.push([A,D,k])};return Array.isArray(w)&&w.push(S),S}}async $participateInSave(k,A){const D=C.URI.revive(k);let w=!1;const E=setTimeout(()=>w=!0,this.g.timeout),S=[];try{for(const c of[...this.a]){if(w)break;const g=this.d.getDocument(D),o=await this.h(c,{document:g,reason:P.TextDocumentSaveReason.to(A)});S.push(o)}}finally{clearTimeout(E)}return S}h([k,A,D],w){const E=this.b.get(k);return typeof E=="number"&&E>this.g.errors?Promise.resolve(!1):this.i(D,k,A,w).then(()=>!0,S=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' threw ERROR`),this.c.error(S),!(S instanceof Error)||S.message!=="concurrent_edits"){const c=this.b.get(k);this.b.set(k,c?c+1:1),typeof c=="number"&&c>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${D.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(k,A,D,w){const E=[],S=Date.now(),{document:c,reason:g}=w,{version:o}=c,i=Object.freeze({document:c,reason:g,waitUntil(r){if(Object.isFrozen(E))throw(0,N.$8)("waitUntil can not be called async");E.push(Promise.resolve(r))}});try{A.apply(D,[i])}catch(r){return Promise.reject(r)}return Object.freeze(E),new Promise((r,n)=>{const a=setTimeout(()=>n(new Error("timeout")),this.g.timeout);return Promise.all(E).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-S}ms`),clearTimeout(a),r(t)}).catch(t=>{clearTimeout(a),n(t)})}).then(r=>{const n={edits:[]};for(const a of r)if(Array.isArray(a)&&a.every(t=>t instanceof f.$jL))for(const{newText:t,newEol:h,range:s}of a)n.edits.push({resource:c.uri,versionId:void 0,textEdit:{range:s&&P.Range.from(s),text:t,eol:h&&P.EndOfLine.from(h)}});if(n.edits.length!==0)return o===c.version?this.f.$tryApplyWorkspaceEdit(n):Promise.reject(new Error("concurrent_edits"))})}}e.$Thc=v}),define(ke[326],Se([1,0,4,3,2,6,148,15,18,24,7]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ggc=void 0;class D{constructor(E,S){this.a=new C.$Vd,this.b=new C.$Vd,this.c=new C.$Vd,this.d=new C.$Vd,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Sc,this.h=new Map,this.f=E.getProxy(P.$aL.MainThreadDocuments),this.g=S,this.g.onDidRemoveDocuments(c=>{for(const g of c)this.b.fire(g.document)},void 0,this.e),this.g.onDidAddDocuments(c=>{for(const g of c)this.a.fire(g.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(E){if(!E)return;const S=this.g.getDocument(E);if(S)return S}getDocument(E){const S=this.getDocumentData(E);if(!S?.document)throw new Error(`Unable to retrieve document from URI '${E}'`);return S.document}ensureDocumentData(E){const S=this.g.getDocument(E);if(S)return Promise.resolve(S);let c=this.h.get(E.toString());return c||(c=this.f.$tryOpenDocument(E).then(g=>{this.h.delete(E.toString());const o=f.URI.revive(g);return(0,$.$Tf)(this.g.getDocument(o))},g=>(this.h.delete(E.toString()),Promise.reject(g))),this.h.set(E.toString(),c)),c}createDocumentData(E){return this.f.$tryCreateDocument(E).then(S=>f.URI.revive(S))}$acceptModelLanguageChanged(E,S){const c=f.URI.revive(E),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");this.b.fire(g.document),g._acceptLanguageId(S),this.a.fire(g.document)}$acceptModelSaved(E){const S=f.URI.revive(E),c=this.g.getDocument(S);if(!c)throw new Error("unknown document");this.$acceptDirtyStateChanged(E,!1),this.d.fire(c.document)}$acceptDirtyStateChanged(E,S){const c=f.URI.revive(E),g=this.g.getDocument(c);if(!g)throw new Error("unknown document");g._acceptIsDirty(S),this.c.fire({document:g.document,contentChanges:[],reason:void 0})}$acceptModelChanged(E,S,c){const g=f.URI.revive(E),o=this.g.getDocument(g);if(!o)throw new Error("unknown document");o._acceptIsDirty(c),o.onEvents(S);let i;S.isUndoing?i=A.TextDocumentChangeReason.Undo:S.isRedoing&&(i=A.TextDocumentChangeReason.Redo),this.c.fire((0,k.$wn)({document:o.document,contentChanges:S.changes.map(r=>({range:v.Range.to(r.range),rangeOffset:r.rangeOffset,rangeLength:r.rangeLength,text:r.text})),reason:i}))}setWordDefinitionFor(E,S){(0,R.$hN)(E,S)}}e.$Ggc=D}),define(ke[71],Se([1,0,73,4,18,2,5,6,20,15,7]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hhc=e.$ghc=void 0,e.$ghc=(0,R.$6h)("IExtHostEditorTabs");class D{constructor(g,o,i){this.e=i,this.d=o,this.acceptDtoUpdate(g)}get apiObject(){if(!this.a){const g=this,o={get isActive(){return g.b.id===g.e()},get label(){return g.b.label},get input(){return g.c},get isDirty(){return g.b.isDirty},get isPinned(){return g.b.isPinned},get isPreview(){return g.b.isPreview},get group(){return g.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(g){this.b=g,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.$VM(P.URI.revive(this.b.input.uri));case 2:return new A.$WM(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified));case 3:return new A.$XM(P.URI.revive(this.b.input.base),P.URI.revive(this.b.input.input1),P.URI.revive(this.b.input.input2),P.URI.revive(this.b.input.result));case 6:return new A.$YM(P.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.$ZM(this.b.input.viewType);case 4:return new A.$1M(P.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.$2M(P.URI.revive(this.b.input.original),P.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.$3M;case 9:return new A.$4M(P.URI.revive(this.b.input.uri),P.URI.revive(this.b.input.inputBoxUri));case 10:return new A.$5M(this.b.input.providerId);default:return}}}class w{constructor(g,o){this.c=[],this.d="",this.b=g,this.e=o;for(const i of g.tabs)i.isActive&&(this.d=i.id),this.c.push(new D(i,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const g=this,o={get isActive(){return g.b.groupId===g.e()},get viewColumn(){return k.ViewColumn.to(g.b.viewColumn)},get activeTab(){return g.c.find(i=>i.tabId===g.d)?.apiObject},get tabs(){return Object.freeze(g.c.map(i=>i.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(g){this.b=g}acceptTabOperation(g){if(g.kind===0){const i=new D(g.tabDto,this,()=>this.activeTabId());return this.c.splice(g.index,0,i),g.tabDto.isActive&&(this.d=i.tabId),i}else if(g.kind===1){const i=this.c.splice(g.index,1)[0];if(!i)throw new Error(`Tab close updated received for index ${g.index} which does not exist`);return i.tabId===this.d&&(this.d=""),i}else if(g.kind===3){if(g.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const i=this.c.splice(g.oldIndex,1)[0];if(!i)throw new Error(`Tab move updated received for index ${g.oldIndex} which does not exist`);return this.c.splice(g.index,0,i),i}const o=this.c.find(i=>i.tabId===g.tabDto.id);if(!o)throw new Error("INVALID tab");return g.tabDto.isActive?this.d=g.tabDto.id:this.d===g.tabDto.id&&!g.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(g.tabDto),o}activeTabId(){return this.d}}let E=class{constructor(g){this.b=new N.$Vd,this.c=new N.$Vd,this.e=[],this.a=g.getProxy(v.$aL.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const g=this,o={onDidChangeTabGroups:g.c.event,onDidChangeTabs:g.b.event,get all(){return Object.freeze(g.e.map(i=>i.apiObject))},get activeTabGroup(){const i=g.d;return(0,f.$Tf)(g.e.find(n=>n.groupId===i)?.apiObject)},close:async(i,r)=>{const n=Array.isArray(i)?i:[i];return n.length?S(n[0])?this.j(n,r):this.i(n,r):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(g){const o=new Set(this.e.map(s=>s.groupId)),i=new Set(g.map(s=>s.groupId)),r=(0,C.$L)(o,i),n=this.e.filter(s=>r.removed.includes(s.groupId)).map(s=>s.apiObject),a=[],t=[];this.e=g.map(s=>{const d=new w(s,()=>this.d);return r.added.includes(d.groupId)?a.push(d.apiObject):t.push(d.apiObject),d});const h=(0,f.$Tf)(g.find(s=>s.isActive===!0)?.groupId);h!==void 0&&this.d!==h&&(this.d=h),this.c.fire(Object.freeze({opened:a,closed:n,changed:t}))}$acceptTabGroupUpdate(g){const o=this.e.find(i=>i.groupId===g.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(g),g.isActive&&(this.d=g.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(g){const o=this.e.find(r=>r.groupId===g.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const i=o.acceptTabOperation(g);switch(g.kind){case 0:this.b.fire(Object.freeze({opened:[i.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[i.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[i.apiObject]}));return}}g(g){for(const o of this.e)for(const i of o.tabs)if(i.apiObject===g)return i}h(g){return this.e.find(o=>o.apiObject===g)}async i(g,o){const i=[];for(const r of g){const n=this.g(r);if(!n)throw new Error("Tab close: Invalid tab not found!");i.push(n.tabId)}return this.a.$closeTab(i,o)}async j(g,o){const i=[];for(const r of g){const n=this.h(r);if(!n)throw new Error("Group close: Invalid group not found!");i.push(n.groupId)}return this.a.$closeGroup(i,o)}};e.$hhc=E,e.$hhc=E=Ge([We(0,$.$fN)],E);function S(c){return c.tabs!==void 0}}),define(ke[327],Se([1,0,2,6,3,7,15,173,12,22,26,80]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vhc=void 0;class w{constructor(){this.a=[]}add(c){this.b=void 0,this.a.push(c)}delete(c){const g=this.a.indexOf(c);g>=0&&(this.a.splice(g,1),this.b=void 0)}c(){if(!this.b){const c=this.a.sort(),g=[];let o,i,r=14,n=14;for(const a of c){let t=o?(0,$.$bf)(o,a):0;for(t===0?i=1:i=n;t<a.length;t++)t+1===a.length?(r=n,n=9):n+=1,g.push([i,a.toUpperCase().charCodeAt(t),n]),g.push([i,a.toLowerCase().charCodeAt(t),n]),i=n;o=a,n=r}g.push([9,58,10]),g.push([10,47,12]),this.b=new v.$DZ(g)}}provideDocumentLinks(c){this.c();const g=[],o=v.$EZ.computeLinks({getLineContent(i){return c.lineAt(i-1).text},getLineCount(){return c.lineCount}},this.b);for(const i of o){const r=R.DocumentLink.to(i);r.target&&g.push(r)}return g}}class E{constructor(c,g){this.i=g,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=c.getProxy(N.$aL.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(c,g,o,i={}){if(E.j(o),this.d.has(g))throw new Error(`a provider for the scheme '${g}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(c,"*",this.b));const r=this.h++;this.b.add(g),this.d.add(g),this.c.set(r,o);let n=2;i.isCaseSensitive&&(n+=1024),i.isReadonly&&(n+=2048),typeof o.copy=="function"&&(n+=8),typeof o.open=="function"&&typeof o.close=="function"&&typeof o.read=="function"&&typeof o.write=="function"&&((0,A.$GF)(c,"fsChunks"),n+=4);let a;i.isReadonly&&(0,D.$jk)(i.isReadonly)&&(a={value:i.isReadonly.value,isTrusted:i.isReadonly.isTrusted,supportThemeIcons:i.isReadonly.supportThemeIcons,supportHtml:i.isReadonly.supportHtml,baseUri:i.isReadonly.baseUri,uris:i.isReadonly.uris}),this.a.$registerFileSystemProvider(r,g,n,a).catch(h=>{console.error(`FAILED to register filesystem provider of ${c.identifier.value}-extension for the scheme ${g}`),console.error(h)});const t=o.onDidChangeFile(h=>{const s=[];for(const d of h){const{uri:u,type:l}=d;if(u.scheme!==g)continue;let p;switch(l){case P.FileChangeType.Changed:p=0;break;case P.FileChangeType.Created:p=1;break;case P.FileChangeType.Deleted:p=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:u,type:p})}this.a.$onFileSystemChange(r,s)});return(0,f.$Rc)(()=>{t.dispose(),this.b.delete(g),this.d.delete(g),this.c.delete(r),this.a.$unregisterProvider(r)})}static j(c){if(!c)throw new Error("MISSING provider");if(typeof c.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof c.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof c.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof c.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof c.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof c.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof c.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof c.rename!="function")throw new Error("Provider does NOT implement rename")}static k(c){const{type:g,ctime:o,mtime:i,size:r,permissions:n}=c;return{type:g,ctime:o,mtime:i,size:r,permissions:n}}$stat(c,g){return Promise.resolve(this.l(c).stat(C.URI.revive(g))).then(o=>E.k(o))}$readdir(c,g){return Promise.resolve(this.l(c).readDirectory(C.URI.revive(g)))}$readFile(c,g){return Promise.resolve(this.l(c).readFile(C.URI.revive(g))).then(o=>k.$je.wrap(o))}$writeFile(c,g,o,i){return Promise.resolve(this.l(c).writeFile(C.URI.revive(g),o.buffer,i))}$delete(c,g,o){return Promise.resolve(this.l(c).delete(C.URI.revive(g),o))}$rename(c,g,o,i){return Promise.resolve(this.l(c).rename(C.URI.revive(g),C.URI.revive(o),i))}$copy(c,g,o,i){const r=this.l(c);if(!r.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(r.copy(C.URI.revive(g),C.URI.revive(o),i))}$mkdir(c,g){return Promise.resolve(this.l(c).createDirectory(C.URI.revive(g)))}$watch(c,g,o,i){const r=this.l(c).watch(C.URI.revive(o),i);this.f.set(g,r)}$unwatch(c,g){const o=this.f.get(g);o&&(o.dispose(),this.f.delete(g))}$open(c,g,o){const i=this.l(c);if(!i.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(i.open(C.URI.revive(g),o))}$close(c,g){const o=this.l(c);if(!o.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(o.close(g))}$read(c,g,o,i){const r=this.l(c);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const n=k.$je.alloc(i);return Promise.resolve(r.read(g,o,n.buffer,0,i)).then(a=>n.slice(0,a))}$write(c,g,o,i){const r=this.l(c);if(!r.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(r.write(g,o,i.buffer,0,i.byteLength))}l(c){const g=this.c.get(c);if(!g){const o=new Error;throw o.name="ENOPRO",o.message="no provider",o}return g}}e.$Vhc=E}),define(ke[328],Se([1,0,4,35,2,6,15,7,43]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Whc=void 0;class k{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(E,S,c,g,o,i){this.a=Math.random(),this.b=new C.$Vd,this.c=new C.$Vd,this.d=new C.$Vd,this.h=0,i?.ignoreCreateEvents&&(this.h+=1),i?.ignoreChangeEvents&&(this.h+=2),i?.ignoreDeleteEvents&&(this.h+=4);const r=(0,N.$Mj)(o),n=typeof o=="string",a=i?.correlate,t=g(h=>{if(!(typeof h.session=="number"&&h.session!==this.a)&&!(a&&typeof h.session>"u")){if(!i?.ignoreCreateEvents)for(const s of h.created){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.b.fire(d)}if(!i?.ignoreChangeEvents)for(const s of h.changed){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.c.fire(d)}if(!i?.ignoreDeleteEvents)for(const s of h.deleted){const d=f.URI.revive(s);r(d.fsPath)&&(!n||S.getWorkspaceFolder(d))&&this.d.fire(d)}}});this.g=v.$cL.from(this.i(E,c,o,i,i?.correlate),this.b,this.c,this.d,t)}i(E,S,c,g,o){const i=v.$cL.from();if(typeof c=="string")return i;const r=E.getProxy(P.$aL.MainThreadFileSystemEventService);let n=!1;return(c.pattern.includes(N.$Ij)||c.pattern.includes(N.$Jj))&&(n=!0),r.$watch(S.identifier.value,this.a,c.baseUri,{recursive:n,excludes:g?.excludes??[]},!!o),v.$cL.from({dispose:()=>r.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class A{constructor(E){this.a=E,this.session=this.a.session,this.b=new $.$V(()=>this.a.created.map(f.URI.revive)),this.c=new $.$V(()=>this.a.changed.map(f.URI.revive)),this.d=new $.$V(()=>this.a.deleted.map(f.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class D{constructor(E,S,c){this.j=E,this.k=S,this.l=c,this.a=new C.$Vd,this.b=new C.$Vd,this.c=new C.$Vd,this.d=new C.$Vd,this.g=new C.$Xd,this.h=new C.$Xd,this.i=new C.$Xd,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(E,S,c,g){return new k(this.j,E,S,this.a.event,R.GlobPattern.from(c),g)}$onFileEvent(E){this.a.fire(new A(E))}$onDidRunFileOperation(E,S){switch(E){case 2:this.b.fire(Object.freeze({files:S.map(c=>({oldUri:f.URI.revive(c.source),newUri:f.URI.revive(c.target)}))}));break;case 1:this.d.fire(Object.freeze({files:S.map(c=>f.URI.revive(c.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:S.map(c=>f.URI.revive(c.target))}));break;default:}}getOnWillRenameFileEvent(E){return this.m(E,this.g)}getOnWillCreateFileEvent(E){return this.m(E,this.h)}getOnWillDeleteFileEvent(E){return this.m(E,this.i)}m(E,S){return(c,g,o)=>{const i=function(n){c.call(g,n)};return i.extension=E,S.event(i,void 0,o)}}async $onWillRunFileOperation(E,S,c,g){switch(E){case 2:return await this.n(this.g,{files:S.map(o=>({oldUri:f.URI.revive(o.source),newUri:f.URI.revive(o.target)}))},c,g);case 1:return await this.n(this.i,{files:S.map(o=>f.URI.revive(o.target))},c,g);case 0:case 3:return await this.n(this.h,{files:S.map(o=>f.URI.revive(o.target))},c,g)}}async n(E,S,c,g){const o=new Set,i=[];if(await E.fireAsync(S,g,async(n,a)=>{const t=Date.now(),h=await Promise.resolve(n);h instanceof v.$mL&&(i.push([a.extension,h]),o.add(a.extension.displayName??a.extension.identifier.value)),Date.now()-t>c&&this.k.warn("SLOW file-participant",a.extension.identifier)}),g.isCancellationRequested||i.length===0)return;const r={edits:[]};for(const[,n]of i){const{edits:a}=R.WorkspaceEdit.from(n,{getTextDocumentVersion:t=>this.l.getDocument(t)?.version,getNotebookDocumentVersion:()=>{}});r.edits=r.edits.concat(a)}return{edit:r,extensionNames:Array.from(o)}}}e.$Whc=D}),define(ke[329],Se([1,0,2,24,15,7,83,6,12,29,19,18,169,21,25,3,131,121,110,38,14,11,26,213]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ogc=void 0;class s{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentSymbols(B,Y){const te=this.d.getDocument(B),q=await this.e.provideDocumentSymbols(te,Y);if(!(0,A.$Kb)(q))return q[0]instanceof P.$vL?q.map(f.DocumentSymbol.from):s.f(q)}static f(B){B=B.slice(0).sort((q,ae)=>{let he=q.location.range.start.compareTo(ae.location.range.start);return he===0&&(he=ae.location.range.end.compareTo(q.location.range.end)),he});const Y=[],te=[];for(const q of B){const ae={name:q.name||"!!MISSING: name!!",kind:f.SymbolKind.from(q.kind),tags:q.tags?.map(f.SymbolTag.from)||[],detail:"",containerName:q.containerName,range:f.Range.from(q.location.range),selectionRange:f.Range.from(q.location.range),children:[]};for(;;){if(te.length===0){te.push(ae),Y.push(ae);break}const he=te[te.length-1];if(k.$Us.containsRange(he.range,ae.range)&&!k.$Us.equalsRange(he.range,ae.range)){he.children?.push(ae),te.push(ae);break}te.pop()}}return Y}}class d{constructor(B,Y,te,q,ae,he){this.f=B,this.g=Y,this.h=te,this.j=q,this.k=ae,this.l=he,this.d=new i.$Egc("CodeLens"),this.e=new Map}async provideCodeLenses(B,Y){const te=this.f.getDocument(B),q=await this.h.provideCodeLenses(te,Y);if(!q||Y.isCancellationRequested)return;const ae=this.d.add(q),he=new c.$Sc;this.e.set(ae,he);const Ae={cacheId:ae,lenses:[]};for(let je=0;je<q.length;je++)Ae.lenses.push({cacheId:[ae,je],range:f.Range.from(q[je].range),command:this.g.toInternal(q[je].command,he)});return Ae}async resolveCodeLens(B,Y){const te=B.cacheId&&this.d.get(...B.cacheId);if(!te)return;let q;if(typeof this.h.resolveCodeLens!="function"||te.isResolved?q=te:q=await this.h.resolveCodeLens(te,Y),q||(q=te),Y.isCancellationRequested)return;const ae=B.cacheId&&this.e.get(B.cacheId[0]);if(ae){if(!q.command){const he=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,he),this.l.error(he);return}return B.command=this.g.toInternal(q.command,ae),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function u(Ie){return Array.isArray(Ie)?Ie.map(f.DefinitionLink.from):Ie?[f.DefinitionLink.from(Ie)]:[]}class l{constructor(B,Y){this.d=B,this.e=Y}async provideDefinition(B,Y,te){const q=this.d.getDocument(B),ae=f.Position.to(Y),he=await this.e.provideDefinition(q,ae,te);return u(he)}}class p{constructor(B,Y){this.d=B,this.e=Y}async provideDeclaration(B,Y,te){const q=this.d.getDocument(B),ae=f.Position.to(Y),he=await this.e.provideDeclaration(q,ae,te);return u(he)}}class I{constructor(B,Y){this.d=B,this.e=Y}async provideImplementation(B,Y,te){const q=this.d.getDocument(B),ae=f.Position.to(Y),he=await this.e.provideImplementation(q,ae,te);return u(he)}}class b{constructor(B,Y){this.d=B,this.e=Y}async provideTypeDefinition(B,Y,te){const q=this.d.getDocument(B),ae=f.Position.to(Y),he=await this.e.provideTypeDefinition(q,ae,te);return u(he)}}class m{constructor(B,Y){this.d=B,this.e=Y}async provideHover(B,Y,te){const q=this.d.getDocument(B),ae=f.Position.to(Y),he=await this.e.provideHover(q,ae,te);if(!(!he||(0,A.$Kb)(he.contents)))return he.range||(he.range=q.getWordRangeAtPosition(ae)),he.range||(he.range=new P.$eL(ae,ae)),f.Hover.from(he)}}class y{constructor(B,Y){this.d=B,this.e=Y}async provideEvaluatableExpression(B,Y,te){const q=this.d.getDocument(B),ae=f.Position.to(Y),he=await this.e.provideEvaluatableExpression(q,ae,te);if(he)return f.EvaluatableExpression.from(he)}}class L{constructor(B,Y){this.d=B,this.e=Y}async provideInlineValues(B,Y,te,q){const ae=this.d.getDocument(B),he=await this.e.provideInlineValues(ae,f.Range.to(Y),f.InlineValueContext.to(te),q);if(Array.isArray(he))return he.map(Ae=>f.InlineValue.from(Ae))}}class F{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentHighlights(B,Y,te){const q=this.d.getDocument(B),ae=f.Position.to(Y),he=await this.e.provideDocumentHighlights(q,ae,te);if(Array.isArray(he))return he.map(f.DocumentHighlight.from)}}class z{constructor(B,Y){this.d=B,this.e=Y}async provideMultiDocumentHighlights(B,Y,te,q){const ae=this.d.getDocument(B),he=te.map(He=>this.d.getDocument(He)),Ae=f.Position.to(Y),je=await this.e.provideMultiDocumentHighlights(ae,Ae,he,q);if(Array.isArray(je))return je.map(f.MultiDocumentHighlight.from)}}class T{constructor(B,Y){this.d=B,this.e=Y}async provideLinkedEditingRanges(B,Y,te){const q=this.d.getDocument(B),ae=f.Position.to(Y),he=await this.e.provideLinkedEditingRanges(q,ae,te);if(he&&Array.isArray(he.ranges))return{ranges:(0,A.$Hb)(he.ranges.map(f.Range.from)),wordPattern:he.wordPattern}}}class O{constructor(B,Y){this.d=B,this.e=Y}async provideReferences(B,Y,te,q){const ae=this.d.getDocument(B),he=f.Position.to(Y),Ae=await this.e.provideReferences(ae,he,te,q);if(Array.isArray(Ae))return Ae.map(f.location.from)}}class M{static{this.d=1e3}constructor(B,Y,te,q,ae,he,Ae){this.g=B,this.h=Y,this.j=te,this.k=q,this.l=ae,this.m=he,this.n=Ae,this.e=new i.$Egc("CodeAction"),this.f=new Map}async provideCodeActions(B,Y,te,q){const ae=this.g.getDocument(B),he=w.$Ws.isISelection(Y)?f.Selection.to(Y):f.Range.to(Y),Ae=[];for(const st of this.j.getDiagnostics(B))if(he.intersection(st.range)&&Ae.push(st)>M.d)break;const je={diagnostics:Ae,only:te.only?new P.$xL(te.only):void 0,triggerKind:f.CodeActionTriggerKind.to(te.trigger)},He=await this.k.provideCodeActions(ae,he,je,q);if(!(0,A.$Lb)(He)||q.isCancellationRequested)return;const Qe=this.e.add(He),_e=new c.$Sc;this.f.set(Qe,_e);const at=[];for(let st=0;st<He.length;st++){const rt=He[st];if(rt)if(M.o(rt))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),at.push({_isSynthetic:!0,title:rt.title,command:this.h.toInternal(rt,_e)});else{je.only&&(rt.kind?je.only.contains(rt.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action is of kind '${rt.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${je.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const Pe=rt.ranges??[];at.push({cacheId:[Qe,st],title:rt.title,command:rt.command&&this.h.toInternal(rt.command,_e),diagnostics:rt.diagnostics&&rt.diagnostics.map(f.Diagnostic.from),edit:rt.edit&&f.WorkspaceEdit.from(rt.edit,void 0),kind:rt.kind&&rt.kind.value,isPreferred:rt.isPreferred,isAI:(0,t.$FF)(this.m,"codeActionAI")?rt.isAI:!1,ranges:(0,t.$FF)(this.m,"codeActionRanges")?(0,A.$Hb)(Pe.map(f.Range.from)):void 0,disabled:rt.disabled?.reason})}}return{cacheId:Qe,actions:at}}async resolveCodeAction(B,Y){const[te,q]=B,ae=this.e.get(te,q);if(!ae||M.o(ae))return{};if(!this.k.resolveCodeAction)return{};const he=await this.k.resolveCodeAction(ae,Y)??ae;let Ae;he.edit&&(Ae=f.WorkspaceEdit.from(he.edit,void 0));let je;if(he.command){const He=this.f.get(te);He&&(je=this.h.toInternal(he.command,He))}return{edit:Ae,command:je}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class j{static toInternalProviderId(B,Y){return B+"."+Y}constructor(B,Y,te,q,ae){this.d=B,this.e=Y,this.f=te,this.g=q,this.h=ae}async prepareDocumentPaste(B,Y,te,q){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(B),he=Y.map(He=>f.Range.to(He)),Ae=f.DataTransfer.toDataTransfer(te,()=>{throw new n.$$});if(await this.f.prepareDocumentPaste(ae,he,Ae,q),q.isCancellationRequested)return;const je=Array.from(Ae).filter(([,He])=>!(He instanceof P.$4L));return f.DataTransfer.from(je)}async providePasteEdits(B,Y,te,q,ae){if(!this.f.provideDocumentPasteEdits)return;const he=this.e.getDocument(Y),Ae=te.map(Qe=>f.Range.to(Qe)),je=f.DataTransfer.toDataTransfer(q,async Qe=>(await this.d.$resolvePasteFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentPasteEdits(he,Ae,je,ae);if(He)return{label:He.label??(0,h.localize)(0,null,this.h.displayName||this.h.name),detail:this.h.displayName||this.h.name,yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:j.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?f.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class U{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentFormattingEdits(B,Y,te){const q=this.d.getDocument(B),ae=await this.e.provideDocumentFormattingEdits(q,Y,te);if(Array.isArray(ae))return ae.map(f.TextEdit.from)}}class K{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentRangeFormattingEdits(B,Y,te,q){const ae=this.d.getDocument(B),he=f.Range.to(Y),Ae=await this.e.provideDocumentRangeFormattingEdits(ae,he,te,q);if(Array.isArray(Ae))return Ae.map(f.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,Y,te,q){(0,D.$Sf)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(B),he=Y.map(f.Range.to),Ae=await this.e.provideDocumentRangesFormattingEdits(ae,he,te,q);if(Array.isArray(Ae))return Ae.map(f.TextEdit.from)}}class ue{constructor(B,Y){this.d=B,this.e=Y,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,Y,te,q,ae){const he=this.d.getDocument(B),Ae=f.Position.to(Y),je=await this.e.provideOnTypeFormattingEdits(he,Ae,te,q,ae);if(Array.isArray(je))return je.map(f.TextEdit.from)}}class X{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$Egc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,Y){const te=await this.e.provideWorkspaceSymbols(B,Y);if(!(0,A.$Lb)(te))return{symbols:[]};const q=this.d.add(te),ae={cacheId:q,symbols:[]};for(let he=0;he<te.length;he++){const Ae=te[he];if(!Ae||!Ae.name){this.f.warn("INVALID SymbolInformation",Ae);continue}ae.symbols.push({...f.WorkspaceSymbol.from(Ae),cacheId:[q,he]})}return ae}async resolveWorkspaceSymbol(B,Y){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const te=this.d.get(...B.cacheId);if(te){const q=await this.e.resolveWorkspaceSymbol(te,Y);return q&&(0,N.$yn)(B,f.WorkspaceSymbol.from(q),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class Q{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,Y,te){this.d=B,this.e=Y,this.f=te}async provideRenameEdits(B,Y,te,q){const ae=this.d.getDocument(B),he=f.Position.to(Y);try{const Ae=await this.e.provideRenameEdits(ae,he,te,q);return Ae?f.WorkspaceEdit.from(Ae):void 0}catch(Ae){const je=Q.g(Ae);return je?{rejectReason:je,edits:void 0}:Promise.reject(Ae)}}async resolveRenameLocation(B,Y,te){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const q=this.d.getDocument(B),ae=f.Position.to(Y);try{const he=await this.e.prepareRename(q,ae,te);let Ae,je;if(P.$eL.isRange(he)?(Ae=he,je=q.getText(he)):(0,D.$Kf)(he)&&(Ae=he.range,je=he.placeholder),!Ae||!je)return;if(Ae.start.line>ae.line||Ae.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:f.Range.from(Ae),text:je}}catch(he){const Ae=Q.g(he);return Ae?{rejectReason:Ae,range:void 0,text:void 0}:Promise.reject(he)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class Z{constructor(B,Y){this.resultId=B,this.tokens=Y}}class le{constructor(B,Y){this.f=B,this.g=Y,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,Y,te){const q=this.f.getDocument(B),ae=Y!==0?this.d.get(Y):null;let he=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(q,ae.resultId,te):await this.g.provideDocumentSemanticTokens(q,te);return ae&&this.d.delete(Y),he?(he=le.h(he),this.o(le.n(ae,he),he)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return le.j(B)?le.k(B)?B:new P.$uM(new Uint32Array(B.data),B.resultId):le.l(B)?le.m(B)?B:new P.$wM(B.edits.map(Y=>new P.$vM(Y.start,Y.deleteCount,Y.data?new Uint32Array(Y.data):Y.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const Y of B.edits)if(!(Y.data instanceof Uint32Array))return!1;return!0}static n(B,Y){if(!le.j(Y)||!B||!B.tokens)return Y;const te=B.tokens,q=te.length,ae=Y.data,he=ae.length;let Ae=0;const je=Math.min(q,he);for(;Ae<je&&te[Ae]===ae[Ae];)Ae++;if(Ae===q&&Ae===he)return new P.$wM([],Y.resultId);let He=0;const Qe=je-Ae;for(;He<Qe&&te[q-He-1]===ae[he-He-1];)He++;return new P.$wM([{start:Ae,deleteCount:q-Ae-He,data:ae.subarray(Ae,he-He)}],Y.resultId)}o(B,Y){if(le.j(B)){const te=this.e++;return this.d.set(te,new Z(B.resultId,B.data)),(0,g.$B$)({id:te,type:"full",data:B.data})}if(le.l(B)){const te=this.e++;return le.j(Y)?this.d.set(te,new Z(Y.resultId,Y.data)):this.d.set(te,new Z(B.resultId)),(0,g.$B$)({id:te,type:"delta",deltas:(B.edits||[]).map(q=>({start:q.start,deleteCount:q.deleteCount,data:q.data}))})}return null}}class re{constructor(B,Y){this.d=B,this.e=Y}async provideDocumentRangeSemanticTokens(B,Y,te){const q=this.d.getDocument(B),ae=await this.e.provideDocumentRangeSemanticTokens(q,f.Range.to(Y),te);return ae?this.f(ae):null}f(B){return(0,g.$B$)({id:0,type:"full",data:B.data})}}class $e{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,Y,te,q,ae){this.f=B,this.g=Y,this.h=te,this.j=q,this.k=ae,this.d=new i.$Egc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,Y,te,q){const ae=this.f.getDocument(B),he=f.Position.to(Y),Ae=ae.getWordRangeAtPosition(he)||new P.$eL(he,he),je=Ae.with({end:he}),He=new r.$Rd,Qe=await this.h.provideCompletionItems(ae,he,q,f.CompletionContext.to(te));if(!Qe||q.isCancellationRequested)return;const _e=Array.isArray(Qe)?new P.$KL(Qe):Qe,at=$e.supportsResolving(this.h)?this.d.add(_e.items):this.d.add([]),st=new c.$Sc;this.e.set(at,st);const rt=[],Pe={x:at,b:rt,a:{replace:f.Range.from(Ae),insert:f.Range.from(je)},c:_e.isIncomplete||void 0,d:He.elapsed()};for(let ze=0;ze<_e.items.length;ze++){const Le=_e.items[ze],Ye=this.l(Le,[at,ze],je,Ae);rt.push(Ye)}return Pe}async resolveCompletionItem(B,Y){if(typeof this.h.resolveCompletionItem!="function")return;const te=this.d.get(...B);if(!te)return;const q=this.l(te,B),ae=await this.h.resolveCompletionItem(te,Y);if(!ae)return;const he=this.l(ae,B);return(q.h!==he.h||q.i!==he.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(q.n!==he.n||q.o!==he.o||!(0,N.$zn)(q.p,he.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...q,d:he.d,c:he.c,l:he.l,h:he.h,i:he.i,n:he.n,o:he.o,p:he.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Y,te,q){const ae=this.e.get(Y[0]);if(!ae)throw Error("DisposableStore is missing...");const he=this.g.toInternal(B.command,ae),Ae={x:Y,a:B.label,b:B.kind!==void 0?f.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(f.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:f.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(f.TextEdit.from),n:he?.$ident,o:he?.id,p:he?.$ident?void 0:he?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Ae.h=B.textEdit.newText):typeof B.insertText=="string"?Ae.h=B.insertText:B.insertText instanceof P.$nL&&(Ae.h=B.insertText.value,Ae.i|=4);let je;return B.textEdit?je=B.textEdit.range:B.range&&(je=B.range),P.$eL.isRange(je)?Ae.j=f.Range.from(je):je&&(!te?.isEqual(je.inserting)||!q?.isEqual(je.replacing))&&(Ae.j={insert:f.Range.from(je.inserting),replace:f.Range.from(je.replacing)}),Ae}}class oe{async provideInlineCompletions(B,Y,te,q){}disposeCompletions(B){}handleDidShowCompletionItem(B,Y,te){}handlePartialAccept(B,Y,te){}}class J extends oe{constructor(B,Y,te,q){super(),this.f=B,this.g=Y,this.h=te,this.j=q,this.d=new V,this.e=(0,t.$FF)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:P.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:P.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,t.$FF)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,Y,te,q){const ae=this.g.getDocument(B),he=f.Position.to(Y),Ae=await this.h.provideInlineCompletionItems(ae,he,{selectedCompletionInfo:te.selectedSuggestionInfo?{range:f.Range.to(te.selectedSuggestionInfo.range),text:te.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[te.triggerKind]},q);if(!Ae||q.isCancellationRequested)return;const je=Array.isArray(Ae)?Ae:Ae.items,He=this.e?Array.isArray(Ae)?[]:Ae.commands||[]:[],Qe=this.e&&!Array.isArray(Ae)?Ae.enableForwardStability:void 0;let _e;return{pid:this.d.createReferenceId({dispose(){_e?.dispose()},items:je}),items:je.map((st,rt)=>{let Pe;st.command&&(_e||(_e=new c.$Sc),Pe=this.j.toInternal(st.command,_e));const ze=st.insertText;return{insertText:typeof ze=="string"?ze:{snippet:ze.value},filterText:st.filterText,range:st.range?f.Range.from(st.range):void 0,command:Pe,idx:rt,completeBracketPairs:this.e?st.completeBracketPairs:!1}}),commands:He.map(st=>(_e||(_e=new c.$Sc),this.j.toInternal(st,_e))),suppressSuggestions:!1,enableForwardStability:Qe}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,Y,te){const q=this.d.get(B)?.items[Y];q&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(q,te)}handlePartialAccept(B,Y,te){const q=this.d.get(B)?.items[Y];q&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(q,te)}}class V{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const Y=this.e++;return this.d.set(Y,B),Y}disposeReferenceId(B){const Y=this.d.get(B);return this.d.delete(B),Y}get(B){return this.d.get(B)}}class ie{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$Egc("SignatureHelp")}async provideSignatureHelp(B,Y,te,q){const ae=this.e.getDocument(B),he=f.Position.to(Y),Ae=this.g(te),je=await this.f.provideSignatureHelp(ae,he,q,Ae);if(je){const He=this.d.add([je]);return{...f.SignatureHelp.from(je),id:He}}}g(B){let Y;if(B.activeSignatureHelp){const te=f.SignatureHelp.to(B.activeSignatureHelp),q=this.d.get(B.activeSignatureHelp.id,0);q?(Y=q,Y.activeSignature=te.activeSignature,Y.activeParameter=te.activeParameter):Y=te}return{...B,activeSignatureHelp:Y}}releaseSignatureHelp(B){this.d.delete(B)}}class ye{constructor(B,Y,te,q,ae){this.f=B,this.g=Y,this.h=te,this.j=q,this.k=ae,this.d=new i.$Egc("InlayHints"),this.e=new Map}async provideInlayHints(B,Y,te){const q=this.f.getDocument(B),ae=f.Range.to(Y),he=await this.h.provideInlayHints(q,ae,te);if(!Array.isArray(he)||he.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Y)}`);return}if(te.isCancellationRequested)return;const Ae=this.d.add(he);this.e.set(Ae,new c.$Sc);const je={hints:[],cacheId:Ae};for(let He=0;He<he.length;He++)this.l(he[He],ae)&&je.hints.push(this.m(he[He],[Ae,He]));return this.j.trace(`[InlayHints] ${je.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(Y)}`),je}async resolveInlayHint(B,Y){if(typeof this.h.resolveInlayHint!="function")return;const te=this.d.get(...B);if(!te)return;const q=await this.h.resolveInlayHint(te,Y);if(q&&this.l(q))return this.m(q,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,Y){return B.label.length===0||Array.isArray(B.label)&&B.label.every(te=>te.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(Y&&!Y.contains(B.position))}m(B,Y){const te=this.e.get(Y[0]);if(!te)throw Error("DisposableStore is missing...");const q={label:"",cacheId:Y,tooltip:f.MarkdownString.fromStrict(B.tooltip),position:f.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(f.TextEdit.from),kind:B.kind&&f.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")q.label=B.label;else{const ae=[];q.label=ae;for(const he of B.label){if(!he.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Ae={label:he.value,tooltip:f.MarkdownString.fromStrict(he.tooltip)};P.$oL.isLocation(he.location)&&(Ae.location=f.location.from(he.location)),he.command&&(Ae.command=this.g.toInternal(he.command,te)),ae.push(Ae)}}return q}}class de{constructor(B,Y){this.e=B,this.f=Y,this.d=new i.$Egc("DocumentLink")}async provideLinks(B,Y){const te=this.e.getDocument(B),q=await this.f.provideDocumentLinks(te,Y);if(!(!Array.isArray(q)||q.length===0)&&!Y.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:q.filter(de.g).map(f.DocumentLink.from)};{const ae=this.d.add(q),he={links:[],cacheId:ae};for(let Ae=0;Ae<q.length;Ae++){if(!de.g(q[Ae]))continue;const je=f.DocumentLink.from(q[Ae]);je.cacheId=[ae,Ae],he.links.push(je)}return he}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,Y){if(typeof this.f.resolveDocumentLink!="function")return;const te=this.d.get(...B);if(!te)return;const q=await this.f.resolveDocumentLink(te,Y);if(!(!q||!de.g(q)))return f.DocumentLink.from(q)}releaseLinks(B){this.d.delete(B)}}class fe{constructor(B,Y){this.d=B,this.e=Y}async provideColors(B,Y){const te=this.d.getDocument(B),q=await this.e.provideDocumentColors(te,Y);return Array.isArray(q)?q.map(he=>({color:f.Color.from(he.color),range:f.Range.from(he.range)})):[]}async provideColorPresentations(B,Y,te){const q=this.d.getDocument(B),ae=f.Range.to(Y.range),he=f.Color.to(Y.color),Ae=await this.e.provideColorPresentations(he,{document:q,range:ae},te);if(Array.isArray(Ae))return Ae.map(f.ColorPresentation.from)}}class _{constructor(B,Y){this.d=B,this.e=Y}async provideFoldingRanges(B,Y,te){const q=this.d.getDocument(B),ae=await this.e.provideFoldingRanges(q,Y,te);if(Array.isArray(ae))return ae.map(f.FoldingRange.from)}}class ee{constructor(B,Y,te){this.d=B,this.e=Y,this.f=te}async provideSelectionRanges(B,Y,te){const q=this.d.getDocument(B),ae=Y.map(f.Position.to),he=await this.e.provideSelectionRanges(q,ae,te);if(!(0,A.$Lb)(he))return[];if(he.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Ae=[];for(let je=0;je<ae.length;je++){const He=[];Ae.push(He);let Qe=ae[je],_e=he[je];for(;;){if(!_e.range.contains(Qe))throw new Error("INVALID selection range, must contain the previous range");if(He.push(f.SelectionRange.from(_e)),!_e.parent)break;Qe=_e.range,_e=_e.parent}}return Ae}}class G{constructor(B,Y){this.f=B,this.g=Y,this.d=new o.$kN(""),this.e=new Map}async prepareSession(B,Y,te){const q=this.f.getDocument(B),ae=f.Position.to(Y),he=await this.g.prepareCallHierarchy(q,ae,te);if(!he)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(he)?he.map(je=>this.h(Ae,je)):[this.h(Ae,he)]}async provideCallsTo(B,Y,te){const q=this.j(B,Y);if(!q)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(q,te);if(ae)return ae.map(he=>({from:this.h(B,he.from),fromRanges:he.fromRanges.map(Ae=>f.Range.from(Ae))}))}async provideCallsFrom(B,Y,te){const q=this.j(B,Y);if(!q)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(q,te);if(ae)return ae.map(he=>({to:this.h(B,he.to),fromRanges:he.fromRanges.map(Ae=>f.Range.from(Ae))}))}releaseSession(B){this.e.delete(B)}h(B,Y){const te=this.e.get(B),q=f.CallHierarchyItem.from(Y,B,te.size.toString(36));return te.set(q._itemId,Y),q}j(B,Y){return this.e.get(B)?.get(Y)}}class x{constructor(B,Y){this.f=B,this.g=Y,this.d=new o.$kN(""),this.e=new Map}async prepareSession(B,Y,te){const q=this.f.getDocument(B),ae=f.Position.to(Y),he=await this.g.prepareTypeHierarchy(q,ae,te);if(!he)return;const Ae=this.d.nextId();return this.e.set(Ae,new Map),Array.isArray(he)?he.map(je=>this.h(Ae,je)):[this.h(Ae,he)]}async provideSupertypes(B,Y,te){const q=this.j(B,Y);if(!q)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(q,te);if(ae)return ae.map(he=>this.h(B,he))}async provideSubtypes(B,Y,te){const q=this.j(B,Y);if(!q)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(q,te);if(ae)return ae.map(he=>this.h(B,he))}releaseSession(B){this.e.delete(B)}h(B,Y){const te=this.e.get(B),q=f.TypeHierarchyItem.from(Y,B,te.size.toString(36));return te.set(q._itemId,Y),q}j(B,Y){return this.e.get(B)?.get(Y)}}class me{static toInternalProviderId(B,Y){return B+"."+Y}constructor(B,Y,te,q,ae){this.d=B,this.e=Y,this.f=te,this.g=q,this.h=ae}async provideDocumentOnDropEdits(B,Y,te,q,ae){const he=this.e.getDocument(Y),Ae=f.Position.to(te),je=f.DataTransfer.toDataTransfer(q,async Qe=>(await this.d.$resolveDocumentOnDropFileData(this.g,B,Qe)).buffer),He=await this.f.provideDocumentDropEdits(he,Ae,je,ae);if(He)return{label:He.label??(0,h.localize)(1,null,this.h.displayName||this.h.name),yieldTo:He.yieldTo?.map(Qe=>"mimeType"in Qe?Qe:{providerId:me.toInternalProviderId(Qe.extensionId,Qe.providerId)}),insertText:typeof He.insertText=="string"?He.insertText:{snippet:He.insertText.value},additionalEdit:He.additionalEdit?f.WorkspaceEdit.from(He.additionalEdit,void 0):void 0}}}class pe{constructor(B,Y){this.d=B,this.e=Y}async provideMappedEdits(B,Y,te,q){const ae=C.URI.revive(B),he=this.d.getDocument(ae),Ae=te.documents.map(Qe=>Qe.map(_e=>({uri:C.URI.revive(_e.uri),version:_e.version,ranges:_e.ranges.map(at=>f.Range.to(at))}))),je={documents:Ae,selections:Ae[0]?.[0]?.ranges??[]},He=await this.e.provideMappedEdits(he,Y,je,q);return He?f.WorkspaceEdit.from(He):null}}class Re{constructor(B,Y){this.adapter=B,this.extension=Y}}class ve{static{this.d=0}constructor(B,Y,te,q,ae,he,Ae,je){this.g=Y,this.h=te,this.j=q,this.k=ae,this.l=he,this.m=Ae,this.n=je,this.f=new Map,this.e=B.getProxy(v.$aL.MainThreadLanguageFeatures)}o(B,Y){return f.DocumentSelector.from(B,this.g,Y)}p(B){return new P.$cL(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return ve.d++}async s(B,Y,te,q,ae,he=!1){const Ae=this.f.get(B);if(!Ae||!(Ae.adapter instanceof Y))return q;const je=Date.now();he||this.l.trace(`[${Ae.extension.identifier.value}] INVOKE provider '${te.toString().replace(/[\r\n]/g,"")}'`);const He=te(Ae.adapter,Ae.extension);return Promise.resolve(He).catch(Qe=>{(0,n.$4)(Qe)||(this.l.error(`[${Ae.extension.identifier.value}] provider FAILED`),this.l.error(Qe),this.n.onExtensionError(Ae.extension.identifier,Qe))}).finally(()=>{he||this.l.trace(`[${Ae.extension.identifier.value}] provider DONE after ${Date.now()-je}ms`)}),E.CancellationToken.isCancellationToken(ae)?(0,a.$Vg)(He,ae):He}t(B,Y){const te=this.q();return this.f.set(te,new Re(B,Y)),te}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,Y,te,q){const ae=this.t(new s(this.h,te),B),he=q&&q.label||ve.u(B);return this.e.$registerDocumentSymbolProvider(ae,this.o(Y,B),he),this.p(ae)}$provideDocumentSymbols(B,Y,te){return this.s(B,s,q=>q.provideDocumentSymbols(C.URI.revive(Y),te),void 0,te)}registerCodeLensProvider(B,Y,te){const q=this.q(),ae=typeof te.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(q,new Re(new d(this.h,this.j.converter,te,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(q,this.o(Y,B),ae);let he=this.p(q);if(ae!==void 0){const Ae=te.onDidChangeCodeLenses(je=>this.e.$emitCodeLensEvent(ae));he=P.$cL.from(he,Ae)}return he}$provideCodeLenses(B,Y,te){return this.s(B,d,q=>q.provideCodeLenses(C.URI.revive(Y),te),void 0,te)}$resolveCodeLens(B,Y,te){return this.s(B,d,q=>q.resolveCodeLens(Y,te),void 0,void 0)}$releaseCodeLenses(B,Y){this.s(B,d,te=>Promise.resolve(te.releaseCodeLenses(Y)),void 0,void 0)}registerDefinitionProvider(B,Y,te){const q=this.t(new l(this.h,te),B);return this.e.$registerDefinitionSupport(q,this.o(Y,B)),this.p(q)}$provideDefinition(B,Y,te,q){return this.s(B,l,ae=>ae.provideDefinition(C.URI.revive(Y),te,q),[],q)}registerDeclarationProvider(B,Y,te){const q=this.t(new p(this.h,te),B);return this.e.$registerDeclarationSupport(q,this.o(Y,B)),this.p(q)}$provideDeclaration(B,Y,te,q){return this.s(B,p,ae=>ae.provideDeclaration(C.URI.revive(Y),te,q),[],q)}registerImplementationProvider(B,Y,te){const q=this.t(new I(this.h,te),B);return this.e.$registerImplementationSupport(q,this.o(Y,B)),this.p(q)}$provideImplementation(B,Y,te,q){return this.s(B,I,ae=>ae.provideImplementation(C.URI.revive(Y),te,q),[],q)}registerTypeDefinitionProvider(B,Y,te){const q=this.t(new b(this.h,te),B);return this.e.$registerTypeDefinitionSupport(q,this.o(Y,B)),this.p(q)}$provideTypeDefinition(B,Y,te,q){return this.s(B,b,ae=>ae.provideTypeDefinition(C.URI.revive(Y),te,q),[],q)}registerHoverProvider(B,Y,te,q){const ae=this.t(new m(this.h,te),B);return this.e.$registerHoverProvider(ae,this.o(Y,B)),this.p(ae)}$provideHover(B,Y,te,q){return this.s(B,m,ae=>ae.provideHover(C.URI.revive(Y),te,q),void 0,q)}registerEvaluatableExpressionProvider(B,Y,te,q){const ae=this.t(new y(this.h,te),B);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(Y,B)),this.p(ae)}$provideEvaluatableExpression(B,Y,te,q){return this.s(B,y,ae=>ae.provideEvaluatableExpression(C.URI.revive(Y),te,q),void 0,q)}registerInlineValuesProvider(B,Y,te,q){const ae=typeof te.onDidChangeInlineValues=="function"?this.q():void 0,he=this.t(new L(this.h,te),B);this.e.$registerInlineValuesProvider(he,this.o(Y,B),ae);let Ae=this.p(he);if(ae!==void 0){const je=te.onDidChangeInlineValues(He=>this.e.$emitInlineValuesEvent(ae));Ae=P.$cL.from(Ae,je)}return Ae}$provideInlineValues(B,Y,te,q,ae){return this.s(B,L,he=>he.provideInlineValues(C.URI.revive(Y),te,q,ae),void 0,ae)}registerDocumentHighlightProvider(B,Y,te){const q=this.t(new F(this.h,te),B);return this.e.$registerDocumentHighlightProvider(q,this.o(Y,B)),this.p(q)}registerMultiDocumentHighlightProvider(B,Y,te){const q=this.t(new z(this.h,te),B);return this.e.$registerMultiDocumentHighlightProvider(q,this.o(Y,B)),this.p(q)}$provideDocumentHighlights(B,Y,te,q){return this.s(B,F,ae=>ae.provideDocumentHighlights(C.URI.revive(Y),te,q),void 0,q)}$provideMultiDocumentHighlights(B,Y,te,q,ae){return this.s(B,z,he=>he.provideMultiDocumentHighlights(C.URI.revive(Y),te,q.map(Ae=>C.URI.revive(Ae)),ae),void 0,ae)}registerLinkedEditingRangeProvider(B,Y,te){const q=this.t(new T(this.h,te),B);return this.e.$registerLinkedEditingRangeProvider(q,this.o(Y,B)),this.p(q)}$provideLinkedEditingRanges(B,Y,te,q){return this.s(B,T,async ae=>{const he=await ae.provideLinkedEditingRanges(C.URI.revive(Y),te,q);if(he)return{ranges:he.ranges,wordPattern:he.wordPattern?ve.w(he.wordPattern):void 0}},void 0,q)}registerReferenceProvider(B,Y,te){const q=this.t(new O(this.h,te),B);return this.e.$registerReferenceSupport(q,this.o(Y,B)),this.p(q)}$provideReferences(B,Y,te,q,ae){return this.s(B,O,he=>he.provideReferences(C.URI.revive(Y),te,q,ae),void 0,ae)}registerCodeActionProvider(B,Y,te,q){const ae=new c.$Sc,he=this.t(new M(this.h,this.j.converter,this.k,te,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(he,this.o(Y,B),{providedKinds:q?.providedCodeActionKinds?.map(Ae=>Ae.value),documentation:q?.documentation?.map(Ae=>({kind:Ae.kind.value,command:this.j.converter.toInternal(Ae.command,ae)}))},ve.u(B),!!te.resolveCodeAction),ae.add(this.p(he)),ae}$provideCodeActions(B,Y,te,q,ae){return this.s(B,M,he=>he.provideCodeActions(C.URI.revive(Y),te,q,ae),void 0,ae)}$resolveCodeAction(B,Y,te){return this.s(B,M,q=>q.resolveCodeAction(Y,te),{},void 0)}$releaseCodeActions(B,Y){this.s(B,M,te=>Promise.resolve(te.releaseCodeActions(Y)),void 0,void 0)}registerDocumentFormattingEditProvider(B,Y,te){const q=this.t(new U(this.h,te),B);return this.e.$registerDocumentFormattingSupport(q,this.o(Y,B),B.identifier,B.displayName||B.name),this.p(q)}$provideDocumentFormattingEdits(B,Y,te,q){return this.s(B,U,ae=>ae.provideDocumentFormattingEdits(C.URI.revive(Y),te,q),void 0,q)}registerDocumentRangeFormattingEditProvider(B,Y,te){const q=typeof te.provideDocumentRangesFormattingEdits=="function",ae=this.t(new K(this.h,te),B);return this.e.$registerRangeFormattingSupport(ae,this.o(Y,B),B.identifier,B.displayName||B.name,q),this.p(ae)}$provideDocumentRangeFormattingEdits(B,Y,te,q,ae){return this.s(B,K,he=>he.provideDocumentRangeFormattingEdits(C.URI.revive(Y),te,q,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(B,Y,te,q,ae){return this.s(B,K,he=>he.provideDocumentRangesFormattingEdits(C.URI.revive(Y),te,q,ae),void 0,ae)}registerOnTypeFormattingEditProvider(B,Y,te,q){const ae=this.t(new ue(this.h,te),B);return this.e.$registerOnTypeFormattingSupport(ae,this.o(Y,B),q,B.identifier),this.p(ae)}$provideOnTypeFormattingEdits(B,Y,te,q,ae,he){return this.s(B,ue,Ae=>Ae.provideOnTypeFormattingEdits(C.URI.revive(Y),te,q,ae,he),void 0,he)}registerWorkspaceSymbolProvider(B,Y){const te=this.t(new X(Y,this.l),B);return this.e.$registerNavigateTypeSupport(te,typeof Y.resolveWorkspaceSymbol=="function"),this.p(te)}$provideWorkspaceSymbols(B,Y,te){return this.s(B,X,q=>q.provideWorkspaceSymbols(Y,te),{symbols:[]},te)}$resolveWorkspaceSymbol(B,Y,te){return this.s(B,X,q=>q.resolveWorkspaceSymbol(Y,te),void 0,void 0)}$releaseWorkspaceSymbols(B,Y){this.s(B,X,te=>te.releaseWorkspaceSymbols(Y),void 0,void 0)}registerRenameProvider(B,Y,te){const q=this.t(new Q(this.h,te,this.l),B);return this.e.$registerRenameSupport(q,this.o(Y,B),Q.supportsResolving(te)),this.p(q)}$provideRenameEdits(B,Y,te,q,ae){return this.s(B,Q,he=>he.provideRenameEdits(C.URI.revive(Y),te,q,ae),void 0,ae)}$resolveRenameLocation(B,Y,te,q){return this.s(B,Q,ae=>ae.resolveRenameLocation(C.URI.revive(Y),te,q),void 0,q)}registerDocumentSemanticTokensProvider(B,Y,te,q){const ae=this.t(new le(this.h,te),B),he=typeof te.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(Y,B),q,he);let Ae=this.p(ae);if(he){const je=te.onDidChangeSemanticTokens(He=>this.e.$emitDocumentSemanticTokensEvent(he));Ae=P.$cL.from(Ae,je)}return Ae}$provideDocumentSemanticTokens(B,Y,te,q){return this.s(B,le,ae=>ae.provideDocumentSemanticTokens(C.URI.revive(Y),te,q),null,q)}$releaseDocumentSemanticTokens(B,Y){this.s(B,le,te=>te.releaseDocumentSemanticColoring(Y),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,Y,te,q){const ae=this.t(new re(this.h,te),B);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(Y,B),q),this.p(ae)}$provideDocumentRangeSemanticTokens(B,Y,te,q){return this.s(B,re,ae=>ae.provideDocumentRangeSemanticTokens(C.URI.revive(Y),te,q),null,q)}registerCompletionItemProvider(B,Y,te,q){const ae=this.t(new $e(this.h,this.j.converter,te,this.m,B),B);return this.e.$registerCompletionsProvider(ae,this.o(Y,B),q,$e.supportsResolving(te),B.identifier),this.p(ae)}$provideCompletionItems(B,Y,te,q,ae){return this.s(B,$e,he=>he.provideCompletionItems(C.URI.revive(Y),te,q,ae),void 0,ae)}$resolveCompletionItem(B,Y,te){return this.s(B,$e,q=>q.resolveCompletionItem(Y,te),void 0,te)}$releaseCompletionItems(B,Y){this.s(B,$e,te=>te.releaseCompletionItems(Y),void 0,void 0)}registerInlineCompletionsProvider(B,Y,te,q){const ae=new J(B,this.h,te,this.j.converter),he=this.t(ae,B);return this.e.$registerInlineCompletionsSupport(he,this.o(Y,B),ae.supportsHandleEvents,S.$lm.toKey(B.identifier.value),q?.yieldTo?.map(Ae=>S.$lm.toKey(Ae))||[]),this.p(he)}$provideInlineCompletions(B,Y,te,q,ae){return this.s(B,oe,he=>he.provideInlineCompletions(C.URI.revive(Y),te,q,ae),void 0,ae)}$handleInlineCompletionDidShow(B,Y,te,q){this.s(B,oe,async ae=>{ae.handleDidShowCompletionItem(Y,te,q)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,Y,te,q){this.s(B,oe,async ae=>{ae.handlePartialAccept(Y,te,q)},void 0,void 0)}$freeInlineCompletionsList(B,Y){this.s(B,oe,async te=>{te.disposeCompletions(Y)},void 0,void 0)}registerSignatureHelpProvider(B,Y,te,q){const ae=Array.isArray(q)?{triggerCharacters:q,retriggerCharacters:[]}:q,he=this.t(new ie(this.h,te),B);return this.e.$registerSignatureHelpProvider(he,this.o(Y,B),ae),this.p(he)}$provideSignatureHelp(B,Y,te,q,ae){return this.s(B,ie,he=>he.provideSignatureHelp(C.URI.revive(Y),te,q,ae),void 0,ae)}$releaseSignatureHelp(B,Y){this.s(B,ie,te=>te.releaseSignatureHelp(Y),void 0,void 0)}registerInlayHintsProvider(B,Y,te){const q=typeof te.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new ye(this.h,this.j.converter,te,this.l,B),B);this.e.$registerInlayHintsProvider(ae,this.o(Y,B),typeof te.resolveInlayHint=="function",q,ve.u(B));let he=this.p(ae);if(q!==void 0){const Ae=te.onDidChangeInlayHints(je=>this.e.$emitInlayHintsEvent(q));he=P.$cL.from(he,Ae)}return he}$provideInlayHints(B,Y,te,q){return this.s(B,ye,ae=>ae.provideInlayHints(C.URI.revive(Y),te,q),void 0,q)}$resolveInlayHint(B,Y,te){return this.s(B,ye,q=>q.resolveInlayHint(Y,te),void 0,te)}$releaseInlayHints(B,Y){this.s(B,ye,te=>te.releaseHints(Y),void 0,void 0)}registerDocumentLinkProvider(B,Y,te){const q=this.t(new de(this.h,te),B);return this.e.$registerDocumentLinkProvider(q,this.o(Y,B),typeof te.resolveDocumentLink=="function"),this.p(q)}$provideDocumentLinks(B,Y,te){return this.s(B,de,q=>q.provideLinks(C.URI.revive(Y),te),void 0,te,Y.scheme==="output")}$resolveDocumentLink(B,Y,te){return this.s(B,de,q=>q.resolveLink(Y,te),void 0,void 0,!0)}$releaseDocumentLinks(B,Y){this.s(B,de,te=>te.releaseLinks(Y),void 0,void 0,!0)}registerColorProvider(B,Y,te){const q=this.t(new fe(this.h,te),B);return this.e.$registerDocumentColorProvider(q,this.o(Y,B)),this.p(q)}$provideDocumentColors(B,Y,te){return this.s(B,fe,q=>q.provideColors(C.URI.revive(Y),te),[],te)}$provideColorPresentations(B,Y,te,q){return this.s(B,fe,ae=>ae.provideColorPresentations(C.URI.revive(Y),te,q),void 0,q)}registerFoldingRangeProvider(B,Y,te){const q=this.q(),ae=typeof te.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(q,new Re(new _(this.h,te),B)),this.e.$registerFoldingRangeProvider(q,this.o(Y,B),B.identifier,ae);let he=this.p(q);if(ae!==void 0){const Ae=te.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));he=P.$cL.from(he,Ae)}return he}$provideFoldingRanges(B,Y,te,q){return this.s(B,_,ae=>ae.provideFoldingRanges(C.URI.revive(Y),te,q),void 0,q)}registerSelectionRangeProvider(B,Y,te){const q=this.t(new ee(this.h,te,this.l),B);return this.e.$registerSelectionRangeProvider(q,this.o(Y,B)),this.p(q)}$provideSelectionRanges(B,Y,te,q){return this.s(B,ee,ae=>ae.provideSelectionRanges(C.URI.revive(Y),te,q),[],q)}registerCallHierarchyProvider(B,Y,te){const q=this.t(new G(this.h,te),B);return this.e.$registerCallHierarchyProvider(q,this.o(Y,B)),this.p(q)}$prepareCallHierarchy(B,Y,te,q){return this.s(B,G,ae=>Promise.resolve(ae.prepareSession(C.URI.revive(Y),te,q)),void 0,q)}$provideCallHierarchyIncomingCalls(B,Y,te,q){return this.s(B,G,ae=>ae.provideCallsTo(Y,te,q),void 0,q)}$provideCallHierarchyOutgoingCalls(B,Y,te,q){return this.s(B,G,ae=>ae.provideCallsFrom(Y,te,q),void 0,q)}$releaseCallHierarchy(B,Y){this.s(B,G,te=>Promise.resolve(te.releaseSession(Y)),void 0,void 0)}registerTypeHierarchyProvider(B,Y,te){const q=this.t(new x(this.h,te),B);return this.e.$registerTypeHierarchyProvider(q,this.o(Y,B)),this.p(q)}$prepareTypeHierarchy(B,Y,te,q){return this.s(B,x,ae=>Promise.resolve(ae.prepareSession(C.URI.revive(Y),te,q)),void 0,q)}$provideTypeHierarchySupertypes(B,Y,te,q){return this.s(B,x,ae=>ae.provideSupertypes(Y,te,q),void 0,q)}$provideTypeHierarchySubtypes(B,Y,te,q){return this.s(B,x,ae=>ae.provideSubtypes(Y,te,q),void 0,q)}$releaseTypeHierarchy(B,Y){this.s(B,x,te=>Promise.resolve(te.releaseSession(Y)),void 0,void 0)}registerDocumentOnDropEditProvider(B,Y,te,q){const ae=this.q();this.f.set(ae,new Re(new me(this.e,this.h,te,ae,B),B));const he=(0,t.$FF)(B,"dropMetadata")&&q?me.toInternalProviderId(B.identifier.value,q.id):void 0;return this.e.$registerDocumentOnDropEditProvider(ae,this.o(Y,B),he,(0,t.$FF)(B,"dropMetadata")?q:void 0),this.p(ae)}$provideDocumentOnDropEdits(B,Y,te,q,ae,he){return this.s(B,me,Ae=>Promise.resolve(Ae.provideDocumentOnDropEdits(Y,C.URI.revive(te),q,ae,he)),void 0,void 0)}registerMappedEditsProvider(B,Y,te){const q=this.t(new pe(this.h,te),B);return this.e.$registerMappedEditsProvider(q,this.o(Y,B)),this.p(q)}$provideMappedEdits(B,Y,te,q,ae){return this.s(B,pe,he=>Promise.resolve(he.provideMappedEdits(Y,te,q,ae)),null,ae)}registerDocumentPasteEditProvider(B,Y,te,q){const ae=this.q();this.f.set(ae,new Re(new j(this.e,this.h,te,ae,B),B));const he=j.toInternalProviderId(B.identifier.value,q.id);return this.e.$registerPasteEditProvider(ae,this.o(Y,B),he,{supportsCopy:!!te.prepareDocumentPaste,supportsPaste:!!te.provideDocumentPasteEdits,copyMimeTypes:q.copyMimeTypes,pasteMimeTypes:q.pasteMimeTypes}),this.p(ae)}$prepareDocumentPaste(B,Y,te,q,ae){return this.s(B,j,he=>he.prepareDocumentPaste(C.URI.revive(Y),te,q,ae),void 0,ae)}$providePasteEdits(B,Y,te,q,ae,he){return this.s(B,j,Ae=>Ae.providePasteEdits(Y,C.URI.revive(te),q,ae,he),void 0,he)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:ve.w(B.decreaseIndentPattern),increaseIndentPattern:ve.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?ve.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?ve.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:ve.w(B.beforeText),afterText:B.afterText?ve.w(B.afterText):void 0,previousLineText:B.previousLineText?ve.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(ve.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(Y=>P.SyntaxTokenType.toString(Y)):void 0}}static D(B){return B.map(ve.C)}setLanguageConfiguration(B,Y,te){const{wordPattern:q}=te;if(q&&(0,$.$Ye)(q))throw new Error(`Invalid language configuration: wordPattern '${q}' is not allowed to match the empty string.`);q?this.h.setWordDefinitionFor(Y,q):this.h.setWordDefinitionFor(Y,void 0),te.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),te.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const ae=this.q(),he={comments:te.comments,brackets:te.brackets,wordPattern:te.wordPattern?ve.w(te.wordPattern):void 0,indentationRules:te.indentationRules?ve.y(te.indentationRules):void 0,onEnterRules:te.onEnterRules?ve.B(te.onEnterRules):void 0,__electricCharacterSupport:te.__electricCharacterSupport,__characterPairSupport:te.__characterPairSupport,autoClosingPairs:te.autoClosingPairs?ve.D(te.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(ae,Y,he),this.p(ae)}$setWordDefinitions(B){for(const Y of B)this.h.setWordDefinitionFor(Y.languageId,new RegExp(Y.regexSource,Y.regexFlags))}}e.$Ogc=ve}),define(ke[330],Se([1,0,6,15,7,39,11,3,26]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$bic=void 0;class k{constructor(D,w,E,S){this.c=w,this.d=E,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=D.getProxy(C.$aL.MainThreadLanguages)}$acceptLanguageIds(D){this.b=D}async getLanguages(){return this.b.slice(0)}async changeLanguage(D,w){await this.a.$changeLanguage(D,w);const E=this.c.getDocumentData(D);if(!E)throw new Error(`document '${D.toString()}' NOT found`);return E.document}async tokenAtPosition(D,w){const E=D.version,S=N.Position.from(w),c=await this.a.$tokensAtPosition(D.uri,S),g={type:f.StandardTokenType.Other,range:D.getWordRangeAtPosition(w)??new f.$eL(w.line,w.character,w.line,w.character)};if(!c)return g;const o={range:N.Range.to(c.range),type:N.TokenType.to(c.type)};return!o.range.contains(w)||E!==D.version?g:o}createLanguageStatusItem(D,w,E){const S=this.f++,c=this.a,g=this.g,o=`${D.identifier.value}/${w}`;if(g.has(o))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);g.add(o);const i={selector:E,id:w,name:D.displayName??D.name,severity:f.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let r;const n=new v.$Sc,a=()=>{if(r?.dispose(),!g.has(o)){console.warn(`LanguageStatusItem (${w}) from ${D.identifier.value} has been disposed and CANNOT be updated anymore`);return}r=(0,R.$8g)(()=>{n.clear(),this.a.$setLanguageStatus(S,{id:o,name:i.name??D.displayName??D.name,source:D.displayName??D.name,selector:N.DocumentSelector.from(i.selector,this.e),label:i.text,detail:i.detail??"",severity:i.severity===f.LanguageStatusSeverity.Error?P.default.Error:i.severity===f.LanguageStatusSeverity.Warning?P.default.Warning:P.default.Info,command:i.command&&this.d.toInternal(i.command,n),accessibilityInfo:i.accessibilityInformation,busy:i.busy})},0)},t={dispose(){n.dispose(),r?.dispose(),c.$removeLanguageStatus(S),g.delete(o)},get id(){return i.id},get name(){return i.name},set name(h){i.name=h,a()},get selector(){return i.selector},set selector(h){i.selector=h,a()},get text(){return i.text},set text(h){i.text=h,a()},set text2(h){(0,$.$GF)(D,"languageStatusText"),i.text=h,a()},get text2(){return(0,$.$GF)(D,"languageStatusText"),i.text},get detail(){return i.detail},set detail(h){i.detail=h,a()},get severity(){return i.severity},set severity(h){i.severity=h,a()},get accessibilityInformation(){return i.accessibilityInformation},set accessibilityInformation(h){i.accessibilityInformation=h,a()},get command(){return i.command},set command(h){i.command=h,a()},get busy(){return i.busy},set busy(h){i.busy=h,a()}};return a(),t}}e.$bic=k}),define(ke[331],Se([1,0,16,2,15,7,118]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zhc=e.$Yhc=void 0;class v{constructor(D,w,E,S){this.start=D,this.deletedCount=w,this.deletedItems=E,this.items=S}asApiEvent(){return{range:new P.$BM(this.start,this.start+this.deletedCount),addedCells:this.items.map(D=>D.apiCell),removedCells:this.deletedItems}}}class ${static asModelAddData(D,w){return{EOL:w.eol,lines:w.source,languageId:w.language,uri:w.uri,isDirty:!1,versionId:1,notebook:D}}constructor(D,w,E){this.notebook=D,this.h=w,this.j=E,this.handle=E.handle,this.uri=N.URI.revive(E.uri),this.cellKind=E.cellKind,this.a=E.outputs.map(f.NotebookCellOutput.to),this.e=E.internalMetadata??{},this.b=Object.freeze(E.metadata??{}),this.d=Object.freeze(f.NotebookCellExecutionSummary.to(E.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const D=this,w=this.h.getDocument(this.uri);if(!w)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const E={get index(){return D.notebook.getCellIndex(D)},notebook:D.notebook.apiNotebook,kind:f.NotebookCellKind.to(this.j.cellKind),document:w.document,get mime(){return D.g},set mime(S){D.g=S},get outputs(){return D.a.slice(0)},get metadata(){return D.b},get executionSummary(){return D.d}};this.f=Object.freeze(E)}return this.f}setOutputs(D){this.a=D.map(f.NotebookCellOutput.to)}setOutputItems(D,w,E){const S=E.map(f.NotebookCellOutputItem.to),c=this.a.find(g=>g.id===D);if(c&&(w||(c.items.length=0),c.items.push(...S),c.items.length>1&&c.items.every(g=>R.$eJ(g.mime)))){const g=new Map,o=[];c.items.forEach(i=>{let r;g.has(i.mime)?r=g.get(i.mime):(r=[],g.set(i.mime,r),o.push(i.mime)),r.push(i.data)}),c.items.length=0,o.forEach(i=>{const r=R.$fJ(g.get(i));c.items.push({mime:i,data:r.data.buffer})})}}setMetadata(D){this.b=Object.freeze(D)}setInternalMetadata(D){this.e=D,this.d=Object.freeze(f.NotebookCellExecutionSummary.to(D))}setMime(D){}}e.$Yhc=$;class k{static{this.a=0}constructor(D,w,E,S,c){this.k=D,this.l=w,this.m=E,this.uri=S,this.handle=k.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=c.viewType,this.f=Object.freeze(c.metadata??Object.create(null)),this.r([[0,0,c.cells]],!0,void 0),this.g=c.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const D=this,w={get uri(){return D.uri},get version(){return D.g},get notebookType(){return D.d},get isDirty(){return D.h},get isUntitled(){return D.uri.scheme===C.Schemas.untitled},get isClosed(){return D.j},get metadata(){return D.f},get cellCount(){return D.b.length},cellAt(E){return E=D.n(E),D.b[E].apiCell},getCells(E){return(E?D.p(E):D.b).map(c=>c.apiCell)},save(){return D.q()}};this.e=Object.freeze(w)}return this.e}acceptDocumentPropertiesChanged(D){D.metadata&&(this.f=Object.freeze({...this.f,...D.metadata}))}acceptDirty(D){this.h=D}acceptModelChanged(D,w,E){this.g=D.versionId,this.h=w,this.acceptDocumentPropertiesChanged({metadata:E});const S={notebook:this.apiNotebook,metadata:E,cellChanges:[],contentChanges:[]},c=[];for(const o of D.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,S.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,S.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),c.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),c.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),c.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?c.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),c.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),c.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const g=new Map;for(let o=0;o<c.length;o++){const i=c[o],r=g.get(i.cell);if(r===void 0){const n=S.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...i});g.set(i.cell,n-1)}else S.cellChanges[r]={...S.cellChanges[r],...i}}return Object.freeze(S),Object.freeze(S.cellChanges),Object.freeze(S.contentChanges),S}n(D){return D=D|0,D<0?0:D>=this.b.length?this.b.length-1:D}o(D){let w=D.start|0,E=D.end|0;return w<0&&(w=0),E>this.b.length&&(E=this.b.length),D.with({start:w,end:E})}p(D){D=this.o(D);const w=[];for(let E=D.start;E<D.end;E++)w.push(this.b[E]);return w}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(D,w,E){if(this.j)return;const S=[],c=[],g=[];if(D.reverse().forEach(o=>{const r=o[2].map(t=>{const h=new $(this,this.l,t);return w||c.push($.asModelAddData(this.apiNotebook,t)),h}),n=new v(o[0],o[1],[],r),a=this.b.splice(o[0],o[1],...r);for(const t of a)g.push(t.uri),n.deletedItems.push(t.apiCell);S.push(n)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:c,removedDocuments:g}),E)for(const o of S)E.push(o.asApiEvent())}s(D,w,E,S){const c=this.b.splice(D,w);this.b.splice(E,0,...c);const g=[new v(D,w,c.map(o=>o.apiCell),[]),new v(E,0,[],c)];for(const o of g)S.push(o.asApiEvent())}t(D,w){this.b[D].setOutputs(w)}u(D,w,E,S){this.b[D].setOutputItems(w,E,S)}v(D,w){const E=this.b[D];E.apiCell.document.languageId!==w&&this.m.$acceptModelLanguageChanged(E.uri,w)}w(D,w){const E=this.b[D];E.apiCell.mime=w}x(D,w){this.b[D].setMetadata(w)}y(D,w){this.b[D].setInternalMetadata(w)}getCellFromApiCell(D){return this.b.find(w=>w.apiCell===D)}getCellFromIndex(D){return this.b[D]}getCell(D){return this.b.find(w=>w.handle===D)}getCellIndex(D){return this.b.indexOf(D)}}e.$Zhc=k}),define(ke[332],Se([1,0,4,2,15,7]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dic=void 0;class R{constructor($,k,A,D={timeout:1500,errors:3}){this.b=$,this.c=k,this.d=A,this.f=D,this.a=new C.$Xd}dispose(){}getOnWillSaveNotebookDocumentEvent($){return(k,A,D)=>{const w=function(S){k.call(A,S)};return w.extension=$,this.a.event(w,void 0,D)}}async $participateInSave($,k,A){const D=N.URI.revive($),w=this.c.getNotebookDocument(D);if(!w)throw new Error("Unable to resolve notebook document");const E=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:f.TextDocumentSaveReason.to(k)},A,async(c,g)=>{const o=Date.now(),i=await await Promise.resolve(c);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier),!A.isCancellationRequested&&i&&(i instanceof P.$mL?E.push(i):this.b.warn("onWillSaveNotebookDocument-listener from extension",g.extension.identifier,"ignored due to invalid data"))}),A.isCancellationRequested)return!1;if(E.length===0)return!0;const S={edits:[]};for(const c of E){const{edits:g}=f.WorkspaceEdit.from(c);S.edits=S.edits.concat(g)}return this.d.$tryApplyWorkspaceEdit(S)}}e.$dic=R}),define(ke[149],Se([1,0,14,15,7]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1hc=void 0;class P{static{this.apiEditorsToExtHost=new WeakMap}constructor(v,$,k,A,D,w){this.id=v,this.f=$,this.notebookData=k,this.a=[],this.b=[],this.d=!1,this.a=D,this.b=A,this.c=w}get apiEditor(){if(!this.e){const v=this;this.e={get notebook(){return v.notebookData.apiNotebook},get selection(){return v.a[0]},set selection($){this.selections=[$]},get selections(){return v.a},set selections($){if(!Array.isArray($)||!$.every(f.$BM.isNotebookRange))throw(0,C.$7)("selections");v.a=$,v.g($)},get visibleRanges(){return v.b},revealRange($,k){v.f.$tryRevealRange(v.id,N.NotebookRange.from($),k??f.NotebookEditorRevealType.Default)},get viewColumn(){return v.c}},P.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(v){this.d=v}_acceptVisibleRanges(v){this.b=v}_acceptSelections(v){this.a=v}g(v){this.f.$trySetSelections(this.id,v.map(N.NotebookRange.from))}_acceptViewColumn(v){this.c=v}}e.$1hc=P}),define(ke[333],Se([1,0,4,13,15]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fic=void 0;let P=class{constructor(v,$){this.c=v,this.d=$,this.a=new C.$Vd,this.b=new C.$Vd,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(v,$){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",v,$);const k=this.d.getEditorById(v);$.visibleRanges&&k._acceptVisibleRanges($.visibleRanges.ranges.map(f.NotebookRange.to)),$.selections&&k._acceptSelections($.selections.selections.map(f.NotebookRange.to)),$.visibleRanges&&this.b.fire({notebookEditor:k.apiEditor,visibleRanges:k.apiEditor.visibleRanges}),$.selections&&this.a.fire(Object.freeze({notebookEditor:k.apiEditor,selections:k.apiEditor.selections}))}$acceptEditorViewColumns(v){for(const $ in v)this.d.getEditorById($)._acceptViewColumn(f.ViewColumn.to(v[$]))}};e.$fic=P,e.$fic=P=Ge([We(0,N.$nj)],P)}),define(ke[334],Se([1,0,4,6,149]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$iic=void 0;class P{constructor(v,$){this.c=$,this.a=new Map,this.b=v.getProxy(N.$aL.MainThreadNotebookRenderers)}$postRendererMessage(v,$,k){const A=this.c.getEditorById(v);this.a.get($)?.fire({editor:A.apiEditor,message:k})}createRendererMessaging(v,$){if(!v.contributes?.notebookRenderer?.some(A=>A.id===$))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${$})`);return{onDidReceiveMessage:(A,D,w)=>this.d($).event(A,D,w),postMessage:(A,D)=>{f.$1hc.apiEditorsToExtHost.has(A)&&([A,D]=[D,A]);const w=D&&f.$1hc.apiEditorsToExtHost.get(D);return this.b.$postMessage(w?.id,$,A)}}}d(v){let $=this.a.get(v);return $||($=new C.$Vd({onDidRemoveLastListener:()=>{$?.dispose(),this.a.delete(v)}}),this.a.set(v,$),$)}}e.$iic=P}),define(ke[335],Se([1,0,15,86,21,52,14]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mic=void 0;class v{constructor(D){this.b=0,this.c=new Map,this.a=D}async withProgress(D,w,E){const S=this.b++,{title:c,location:g,cancellable:o}=w,i={label:D.displayName||D.name,id:D.identifier.value};return this.a.$startProgress(S,{location:C.ProgressLocation.from(g),title:c,source:i,cancellable:o},D.isUnderDevelopment?void 0:D.identifier.value).catch(R.$2),this.d(S,E,!!o)}d(D,w,E){let S;E&&(S=new f.$6d,this.c.set(D,S));const c=o=>{this.a.$progressEnd(o),this.c.delete(o),S?.dispose()};let g;try{g=w(new k(this.a,D),E&&S?S.token:f.CancellationToken.None)}catch(o){throw c(D),o}return g.then(o=>c(D),o=>c(D)),g}$acceptProgressCanceled(D){const w=this.c.get(D);w&&(w.cancel(),this.c.delete(D))}}e.$mic=v;function $(A,D){return A.message=D.message,typeof D.increment=="number"&&(typeof A.increment=="number"?A.increment+=D.increment:A.increment=D.increment),A}class k extends N.$vv{constructor(D,w){super(E=>this.throttledReport(E)),this.c=D,this.d=w}throttledReport(D){this.c.$progressReport(this.d,D)}}Ge([(0,P.$zh)(100,(A,D)=>$(A,D),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(ke[336],Se([1,0,2,6,11,15]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nic=void 0;class R{static{this.a=0}constructor($,k){this.d=k,this.c=new Map,this.b=$.getProxy(N.$aL.MainThreadQuickDiff)}$provideOriginalResource($,k,A){const D=C.URI.revive(k),w=this.c.get($);return w?(0,f.$Yg)(()=>w.provideOriginalResource(D,A)).then(E=>E||null):Promise.resolve(null)}registerQuickDiffProvider($,k,A,D){const w=R.a++;return this.c.set(w,k),this.b.$registerQuickDiffProvider(w,P.DocumentSelector.from($,this.d),A,D),{dispose:()=>{this.b.$unregisterQuickDiffProvider(w),this.c.delete(w)}}}}e.$nic=R}),define(ke[337],Se([1,0,21,4,3,6,2,7,14,19,39,55,26,15]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oic=void 0;function S(c,g,o){const i=c.getProxy(P.$aL.MainThreadQuickOpen);class r{constructor(p,I){this.e=new Map,this.f=0,this.a=p,this.b=I}showQuickPick(p,I,b,m=C.CancellationToken.None){this.c=void 0;const y=Promise.resolve(I),L=++this.f,F=i.$show(L,{title:b?.title,placeHolder:b?.placeHolder,matchOnDescription:b?.matchOnDescription,matchOnDetail:b?.matchOnDetail,ignoreFocusLost:b?.ignoreFocusOut,canPickMany:b?.canPickMany},m),z={},T=F.then(()=>z);return Promise.race([T,y]).then(O=>{if(O===z)return;const M=(0,w.$FF)(p,"quickPickItemTooltip");return y.then(j=>{const U=[];for(let K=0;K<j.length;K++){const ue=j[K];if(typeof ue=="string")U.push({label:ue,handle:K});else if(ue.kind===v.QuickPickItemKind.Separator)U.push({type:"separator",label:ue.label});else{ue.tooltip&&!M&&console.warn(`Extension '${p.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${p.identifier.value}`);const X=ue.iconPath?s(ue.iconPath):void 0;U.push({label:ue.label,iconPath:X?.iconPath,iconClass:X?.iconClass,description:ue.description,detail:ue.detail,picked:ue.picked,alwaysShow:ue.alwaysShow,tooltip:M?E.MarkdownString.fromStrict(ue.tooltip):void 0,handle:K})}}return b&&typeof b.onDidSelectItem=="function"&&(this.c=K=>{b.onDidSelectItem(j[K])}),i.$setItems(L,U),F.then(K=>{if(typeof K=="number")return j[K];if(Array.isArray(K))return K.map(ue=>j[ue])})})}).then(void 0,O=>{if(!(0,$.$4)(O))return i.$setError(L,O),Promise.reject(O)})}$onItemSelected(p){this.c?.(p)}showInput(p,I=C.CancellationToken.None){return this.d=p?.validateInput,i.$input(p,typeof this.d=="function",I).then(void 0,b=>{if(!(0,$.$4)(b))return Promise.reject(b)})}async $validateInput(p){if(!this.d)return;const I=await this.d(p);if(!I||typeof I=="string")return I;let b;switch(I.severity){case v.InputBoxValidationSeverity.Info:b=A.default.Info;break;case v.InputBoxValidationSeverity.Warning:b=A.default.Warning;break;case v.InputBoxValidationSeverity.Error:b=A.default.Error;break;default:b=I.message?A.default.Error:A.default.Ignore;break}return{content:I.message,severity:b}}async showWorkspaceFolderPick(p,I=C.CancellationToken.None){const b=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[p]);if(!b)return;const m=await this.a.getWorkspaceFolders2();if(m)return m.find(y=>y.uri.toString()===b.uri.toString())}createQuickPick(p){const I=new d(p,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}createInputBox(p){const I=new u(p,()=>this.e.delete(I._id));return this.e.set(I._id,I),I}$onDidChangeValue(p,I){this.e.get(p)?._fireDidChangeValue(I)}$onDidAccept(p){this.e.get(p)?._fireDidAccept()}$onDidChangeActive(p,I){const b=this.e.get(p);b instanceof d&&b._fireDidChangeActive(I)}$onDidChangeSelection(p,I){const b=this.e.get(p);b instanceof d&&b._fireDidChangeSelection(I)}$onDidTriggerButton(p,I){this.e.get(p)?._fireDidTriggerButton(I)}$onDidTriggerItemButton(p,I,b){const m=this.e.get(p);m instanceof d&&m._fireDidTriggerItemButton(I,b)}$onDidHide(p){this.e.get(p)?._fireDidHide()}}class n{static{this.a=1}constructor(p,I){this.x=p,this.y=I,this._id=d.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$Vd,this.q=new N.$Vd,this.r=new N.$Vd,this.s=new N.$Vd,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(p){this.b=p,this.z({title:p})}get step(){return this.c}set step(p){this.c=p,this.z({step:p})}get totalSteps(){return this.d}set totalSteps(p){this.d=p,this.z({totalSteps:p})}get enabled(){return this.g}set enabled(p){this.g=p,this.z({enabled:p})}get busy(){return this.j}set busy(p){this.j=p,this.z({busy:p})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(p){this.k=p,this.z({ignoreFocusOut:p})}get value(){return this.l}set value(p){this.l=p,this.z({value:p})}get placeholder(){return this.m}set placeholder(p){this.m=p,this.z({placeholder:p})}get buttons(){return this.n}set buttons(p){this.n=p.slice(),this.o.clear(),p.forEach((I,b)=>{const m=I===v.$yM.Back?-1:b;this.o.set(m,I)}),this.z({buttons:p.map((I,b)=>({...s(I.iconPath),tooltip:I.tooltip,handle:I===v.$yM.Back?-1:b}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(p){this.l=p,this.q.fire(p)}_fireDidTriggerButton(p){const I=this.o.get(p);I&&this.r.fire(I)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,f.$Oc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),i.$dispose(this._id))}z(p){if(!this.v){for(const I of Object.keys(p)){const b=p[I];this.u[I]=b===void 0?null:b}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){i.$createOrUpdate(this.u),this.u={id:this._id}}}function a(l){if(l instanceof v.$0L)return{id:l.id};const p=h(l),I=t(l);return{dark:typeof p=="string"?R.URI.file(p):p,light:typeof I=="string"?R.URI.file(I):I}}function t(l){return typeof l=="object"&&"light"in l?l.light:l}function h(l){return typeof l=="object"&&"dark"in l?l.dark:l}function s(l){const p=a(l);let I,b;return"id"in p?b=D.ThemeIcon.asClassName(p):I=p,{iconPath:I,iconClass:b}}class d extends n{constructor(p,I){super(p.identifier,I),this.O=p,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$Vd,this.L=[],this.M=new N.$Vd,this.N=new N.$Vd,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(p){this.B=p.slice(),this.C.clear(),this.D.clear(),p.forEach((m,y)=>{this.C.set(y,m),this.D.set(m,y)});const I=(0,w.$FF)(this.O,"quickPickItemTooltip"),b=[];for(let m=0;m<p.length;m++){const y=p[m];if(y.kind===v.QuickPickItemKind.Separator)b.push({type:"separator",label:y.label});else{y.tooltip&&!I&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const L=y.iconPath?s(y.iconPath):void 0;b.push({handle:m,label:y.label,iconPath:L?.iconPath,iconClass:L?.iconClass,description:y.description,detail:y.detail,picked:y.picked,alwaysShow:y.alwaysShow,tooltip:I?E.MarkdownString.fromStrict(y.tooltip):void 0,buttons:y.buttons?.map((F,z)=>({...s(F.iconPath),tooltip:F.tooltip,handle:z}))})}}this.z({items:b})}get canSelectMany(){return this.E}set canSelectMany(p){this.E=p,this.z({canSelectMany:p})}get matchOnDescription(){return this.F}set matchOnDescription(p){this.F=p,this.z({matchOnDescription:p})}get matchOnDetail(){return this.G}set matchOnDetail(p){this.G=p,this.z({matchOnDetail:p})}get sortByLabel(){return this.H}set sortByLabel(p){this.H=p,this.z({sortByLabel:p})}get keepScrollPosition(){return this.I}set keepScrollPosition(p){this.I=p,this.z({keepScrollPosition:p})}get activeItems(){return this.J}set activeItems(p){this.J=p.filter(I=>this.D.has(I)),this.z({activeItems:this.J.map(I=>this.D.get(I))})}get selectedItems(){return this.L}set selectedItems(p){this.L=p.filter(I=>this.D.has(I)),this.z({selectedItems:this.L.map(I=>this.D.get(I))})}_fireDidChangeActive(p){const I=(0,k.$Hb)(p.map(b=>this.C.get(b)));this.J=I,this.K.fire(I)}_fireDidChangeSelection(p){const I=(0,k.$Hb)(p.map(b=>this.C.get(b)));this.L=I,this.M.fire(I)}_fireDidTriggerItemButton(p,I){const b=this.C.get(p);if(!b||!b.buttons||!b.buttons.length)return;const m=b.buttons[I];m&&this.N.fire({button:m,item:b})}}class u extends n{constructor(p,I){super(p.identifier,I),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(p){this.B=p,this.z({password:p})}get prompt(){return this.C}set prompt(p){this.C=p,this.z({prompt:p})}get valueSelection(){return this.D}set valueSelection(p){this.D=p,this.z({valueSelection:p})}get validationMessage(){return this.E}set validationMessage(p){this.E=p,p?typeof p=="string"?this.z({validationMessage:p,severity:A.default.Error}):this.z({validationMessage:p.message,severity:p.severity??A.default.Error}):this.z({validationMessage:void 0,severity:A.default.Ignore})}}return new r(g,o)}e.$oic=S}),define(ke[338],Se([1,0,2,4,52,3,11,6,19,128,13,25,55,15,26,16,10]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g){"use strict";var o;Object.defineProperty(e,"__esModule",{value:!0}),e.$qic=e.$pic=void 0;function i(L){return L instanceof C.URI}function r(L,F){return L.scheme===c.Schemas.file&&F.scheme===c.Schemas.file&&g.$k?L.toString()===F.toString():L.toString().toLowerCase()===F.toString().toLowerCase()}function n(L){if(L)return typeof L.iconPath=="string"?C.URI.file(L.iconPath):C.URI.isUri(L.iconPath)||w.ThemeIcon.isThemeIcon(L.iconPath)?L.iconPath:void 0}function a(L){if(L.icon){if(C.URI.isUri(L.icon))return L.icon;if(w.ThemeIcon.isThemeIcon(L.icon))return L.icon;{const F=L.icon;return{light:F.light,dark:F.dark}}}else return}function t(L,F){if(!L.iconPath&&!F.iconPath)return 0;if(L.iconPath){if(!F.iconPath)return 1}else return-1;const z=typeof L.iconPath=="string"?L.iconPath:C.URI.isUri(L.iconPath)?L.iconPath.fsPath:L.iconPath.id,T=typeof F.iconPath=="string"?F.iconPath:C.URI.isUri(F.iconPath)?F.iconPath.fsPath:F.iconPath.id;return(0,k.$Sq)(z,T)}function h(L,F){let z=0;if(L.strikeThrough!==F.strikeThrough)return L.strikeThrough?1:-1;if(L.faded!==F.faded)return L.faded?1:-1;if(L.tooltip!==F.tooltip)return(L.tooltip||"").localeCompare(F.tooltip||"");if(z=t(L,F),z!==0)return z;if(L.light&&F.light)z=t(L.light,F.light);else{if(L.light)return 1;if(F.light)return-1}if(z!==0)return z;if(L.dark&&F.dark)z=t(L.dark,F.dark);else{if(L.dark)return 1;if(F.dark)return-1}return z}function s(L,F){if(L.command!==F.command)return L.command<F.command?-1:1;if(L.title!==F.title)return L.title<F.title?-1:1;if(L.tooltip!==F.tooltip){if(L.tooltip!==void 0&&F.tooltip!==void 0)return L.tooltip<F.tooltip?-1:1;if(L.tooltip!==void 0)return 1;if(F.tooltip!==void 0)return-1}if(L.arguments===F.arguments)return 0;if(L.arguments)if(F.arguments){if(L.arguments.length!==F.arguments.length)return L.arguments.length-F.arguments.length}else return 1;else return-1;for(let z=0;z<L.arguments.length;z++){const T=L.arguments[z],O=F.arguments[z];if(T!==O&&!(i(T)&&i(O)&&r(T,O)))return T<O?-1:1}return 0}function d(L,F){let z=(0,k.$Sq)(L.resourceUri.fsPath,F.resourceUri.fsPath,!0);if(z!==0)return z;if(L.command&&F.command)z=s(L.command,F.command);else{if(L.command)return 1;if(F.command)return-1}if(z!==0)return z;if(L.decorations&&F.decorations)z=h(L.decorations,F.decorations);else{if(L.decorations)return 1;if(F.decorations)return-1}if(L.multiFileDiffEditorModifiedUri&&F.multiFileDiffEditorModifiedUri)z=(0,k.$Sq)(L.multiFileDiffEditorModifiedUri.fsPath,F.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(L.multiFileDiffEditorModifiedUri)return 1;if(F.multiFileDiffEditorModifiedUri)return-1}if(L.multiDiffEditorOriginalUri&&F.multiDiffEditorOriginalUri)z=(0,k.$Sq)(L.multiDiffEditorOriginalUri.fsPath,F.multiDiffEditorOriginalUri.fsPath,!0);else{if(L.multiDiffEditorOriginalUri)return 1;if(F.multiDiffEditorOriginalUri)return-1}return z}function u(L,F){for(let z=0;z<L.length;z++)if(L[z]!==F[z])return!1;return!0}function l(L,F){return L.command===F.command&&L.title===F.title&&L.tooltip===F.tooltip&&(L.arguments&&F.arguments?u(L.arguments,F.arguments):L.arguments===F.arguments)}function p(L,F){return(0,$.$ub)(L,F,l)}class I{#e;#t;get value(){return this.d}set value(F){F=F??"",this.#e.$setInputBoxValue(this.l,F),this.n(F)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(F){this.#e.$setInputBoxPlaceholder(this.l,F),this.f=F}get validateInput(){return(0,S.$GF)(this.k,"scmValidation"),this.g}set validateInput(F){if((0,S.$GF)(this.k,"scmValidation"),F&&typeof F!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=F,this.#e.$setValidationProviderIsEnabled(this.l,!!F)}get enabled(){return this.h}set enabled(F){F=!!F,this.h!==F&&(this.h=F,this.#e.$setInputBoxEnablement(this.l,F))}get visible(){return this.j}set visible(F){F=!!F,this.j!==F&&(this.j=F,this.#e.$setInputBoxVisibility(this.l,F))}get document(){return(0,S.$GF)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(F,z,T,O,M){this.k=F,this.l=O,this.m=M,this.d="",this.e=new N.$Vd,this.f="",this.h=!0,this.j=!0,this.#t=z,this.#e=T}showValidationMessage(F,z){(0,S.$GF)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,F,z)}$onInputBoxValueChange(F){this.n(F)}n(F){this.d=F,this.e.fire(F)}}e.$pic=I;class b{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(F){this.v=F,this.q.$updateGroupLabel(this.t,this.handle,F)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(F){this.p=F,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(F){this.f=[...F],this.k.fire()}constructor(F,z,T,O,M,j,U){this.q=F,this.s=z,this.t=T,this.u=O,this.v=M,this.multiDiffEditorEnableViewChanges=j,this.w=U,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$Vd,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$Vd,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=b.d++}getResourceState(F){return this.g.get(F)}$executeResourceCommand(F,z){const T=this.h.get(F);return T?(0,R.$Yg)(()=>this.s.executeCommand(T.command,...T.arguments||[],z)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const F=[...this.f].sort(d),T=(0,$.$Db)(this.o,F,d).map(j=>{const U=j.toInsert.map(K=>{const ue=this.e++;this.g.set(ue,K);const X=K.resourceUri;let Q;if(K.command)if(K.command.command==="vscode.open"||K.command.command==="vscode.diff"||K.command.command==="vscode.changes"){const ee=new P.$Sc;Q=this.s.converter.toInternal(K.command,ee),this.j.set(ue,ee)}else this.h.set(ue,K.command);const Z=(0,S.$FF)(this.w,"scmMultiDiffEditor"),le=Z?K.multiDiffEditorOriginalUri:void 0,re=Z?K.multiFileDiffEditorModifiedUri:void 0,$e=n(K.decorations),oe=K.decorations&&n(K.decorations.light)||$e,J=K.decorations&&n(K.decorations.dark)||$e,V=[oe,J],ie=K.decorations&&K.decorations.tooltip||"",ye=K.decorations&&!!K.decorations.strikeThrough,de=K.decorations&&!!K.decorations.faded,fe=K.contextValue||"";return{rawResource:[ue,X,V,ie,ye,de,fe,Q,le,re],handle:ue}});return{start:j.start,deleteCount:j.deleteCount,toInsert:U}}),O=T.map(({start:j,deleteCount:U,toInsert:K})=>[j,U,K.map(ue=>ue.rawResource)]),M=T.reverse();for(const{start:j,deleteCount:U,toInsert:K}of M){const ue=K.map(Q=>Q.handle),X=this.n.splice(j,U,...ue);for(const Q of X)this.g.delete(Q),this.h.delete(Q),this.j.get(Q)?.dispose(),this.j.delete(Q)}return this.o=F,O}dispose(){this.l=!0,this.m.fire()}}class m{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(F){this.g!==F&&(this.g=F,this.#e.$updateSourceControl(this.w,{count:F}))}get quickDiffProvider(){return this.h}set quickDiffProvider(F){this.h=F;let z;(0,S.$FF)(this.x,"quickDiffProvider")&&(z=F?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!F,quickDiffLabel:z})}get historyProvider(){return(0,S.$GF)(this.x,"scmHistoryProvider"),this.j}set historyProvider(F){(0,S.$GF)(this.x,"scmHistoryProvider"),this.j=F,this.k.value=new P.$Sc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!F}),F&&this.k.value.add(F.onDidChangeCurrentHistoryItemGroup(()=>{this.l=F?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(F){F!==this.m&&(this.m=F,this.#e.$updateSourceControl(this.w,{commitTemplate:F}))}get acceptInputCommand(){return this.o}set acceptInputCommand(F){this.n.value=new P.$Sc,this.o=F;const z=this.y.converter.toInternal(F,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:z})}get actionButton(){return(0,S.$GF)(this.x,"scmActionButton"),this.q}set actionButton(F){(0,S.$GF)(this.x,"scmActionButton"),this.p.value=new P.$Sc,this.q=F;const z=F!==void 0?{command:this.y.converter.toInternal(F.command,this.p.value),secondaryCommands:F.secondaryCommands?.map(T=>T.map(O=>this.y.converter.toInternal(O,this.p.value))),description:F.description,enabled:F.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:z??null})}get statusBarCommands(){return this.t}set statusBarCommands(F){if(this.t&&F&&p(this.t,F))return;this.s.value=new P.$Sc,this.t=F;const z=(F||[]).map(T=>this.y.converter.toInternal(T,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:z})}get selected(){return this.u}constructor(F,z,T,O,M,j,U){this.x=F,this.y=O,this.z=M,this.A=j,this.B=U,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new P.$Uc,this.m=void 0,this.n=new P.$Uc,this.o=void 0,this.p=new P.$Uc,this.s=new P.$Uc,this.t=void 0,this.u=!1,this.v=new N.$Vd,this.onDidChangeSelection=this.v.event,this.w=m.d++,this.C=new Map,this.D=new Set,this.#e=T;const K=C.URI.from({scheme:c.Schemas.vscodeSourceControl,path:`${M}/scm${this.w}/input`,query:U?`rootUri=${encodeURIComponent(U.toString())}`:void 0});this.f=new I(F,z,this.#e,this.w,K),this.#e.$registerSourceControl(this.w,M,j,U,K)}createResourceGroup(F,z,T){const O=(0,S.$FF)(this.x,"scmMultiDiffEditor")&&T?.multiDiffEditorEnableViewChanges===!0,M=new b(this.#e,this.y,this.w,F,z,O,this.x),j=N.Event.once(M.onDidDispose)(()=>this.C.delete(M));return this.C.set(M,j),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const F=[],z=[];for(const[T,O]of this.C){O.dispose();const M=T.onDidUpdateResourceStates(()=>{this.D.add(T),this.eventuallyUpdateResourceStates()});N.Event.once(T.onDidDispose)(()=>{this.D.delete(T),M.dispose(),this.e.delete(T.handle),this.#e.$unregisterGroup(this.w,T.handle)}),F.push([T.handle,T.id,T.label,T.features,T.multiDiffEditorEnableViewChanges]);const j=T._takeResourceStateSnapshot();j.length>0&&z.push([T.handle,j]),this.e.set(T.handle,T)}this.#e.$registerGroups(this.w,F,z),this.C.clear()}eventuallyUpdateResourceStates(){const F=[];this.D.forEach(z=>{const T=z._takeResourceStateSnapshot();T.length!==0&&F.push([z.handle,T])}),F.length>0&&this.#e.$spliceResourceStates(this.w,F),this.D.clear()}getResourceGroup(F){return this.e.get(F)}setSelectionState(F){this.u=F,this.v.fire(F)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(F=>F.dispose()),this.#e.$unregisterSourceControl(this.w)}}Ge([(0,f.$yh)(100)],m.prototype,"eventuallyAddResourceGroups",null),Ge([(0,f.$yh)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let y=class{static{o=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(F,z,T,O){this.l=z,this.m=T,this.n=O,this.g=new Map,this.h=new D.$nm,this.j=new N.$Vd,this.e=F.getProxy(v.$aL.MainThreadSCM),this.f=F.getProxy(v.$aL.MainThreadTelemetry),z.registerArgumentProcessor({processArgument:M=>{if(M&&M.$mid===3){const j=this.g.get(M.sourceControlHandle);if(!j)return M;const U=j.getResourceGroup(M.groupHandle);return U?U.getResourceState(M.handle):M}else if(M&&M.$mid===4){const j=this.g.get(M.sourceControlHandle);return j?j.getResourceGroup(M.groupHandle):M}else if(M&&M.$mid===5){const j=this.g.get(M.handle);return j||M}return M}})}createSourceControl(F,z,T,O){this.n.trace("ExtHostSCM#createSourceControl",F.identifier.value,z,T,O),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:F.identifier.value});const M=o.d++,j=new m(F,this.m,this.e,this.l,z,T,O);this.g.set(M,j);const U=this.h.get(F.identifier)||[];return U.push(j),this.h.set(F.identifier,U),j}getLastInputBox(F){this.n.trace("ExtHostSCM#getLastInputBox",F.identifier.value);const z=this.h.get(F.identifier),T=z&&z[z.length-1];return T&&T.inputBox}$provideOriginalResource(F,z,T){const O=C.URI.revive(z);this.n.trace("ExtHostSCM#$provideOriginalResource",F,O.toString());const M=this.g.get(F);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.$Yg)(()=>M.quickDiffProvider.provideOriginalResource(O,T)).then(j=>j||null)}$onInputBoxValueChange(F,z){this.n.trace("ExtHostSCM#$onInputBoxValueChange",F);const T=this.g.get(F);return T&&T.inputBox.$onInputBoxValueChange(z),Promise.resolve(void 0)}$executeResourceCommand(F,z,T,O){this.n.trace("ExtHostSCM#$executeResourceCommand",F,z,T);const M=this.g.get(F);if(!M)return Promise.resolve(void 0);const j=M.getResourceGroup(z);return j?j.$executeResourceCommand(T,O):Promise.resolve(void 0)}$validateInput(F,z,T){this.n.trace("ExtHostSCM#$validateInput",F);const O=this.g.get(F);return!O||!O.inputBox.validateInput?Promise.resolve(void 0):(0,R.$Yg)(()=>O.inputBox.validateInput(z,T)).then(M=>{if(!M)return Promise.resolve(void 0);const j=E.MarkdownString.fromStrict(M.message);return j?Promise.resolve([j,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(F){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",F),F!==void 0&&this.g.get(F)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=F,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(F,z,T,O){return await this.g.get(F)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(z,T,O)??void 0}async $provideHistoryItems(F,z,T,O){return(await this.g.get(F)?.historyProvider?.provideHistoryItems(z,T,O))?.map(U=>({...U,icon:a(U)}))??void 0}async $provideHistoryItemSummary(F,z,T,O){const M=this.g.get(F)?.historyProvider;if(typeof M?.provideHistoryItemSummary!="function")return;const j=await M.provideHistoryItemSummary(z,T,O);return j?{...j,icon:a(j)}:void 0}async $provideHistoryItemChanges(F,z,T,O){return await this.g.get(F)?.historyProvider?.provideHistoryItemChanges(z,T,O)??void 0}};e.$qic=y,e.$qic=y=o=Ge([We(3,A.$nj)],y)}),define(ke[339],Se([1,0,6,15,2]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ric=void 0;class P{static{this.a=0}constructor(v,$){this.d=$,this.c=new Map,this.b=v.getProxy(C.$aL.MainThreadShare)}async $provideShare(v,$,k){return await this.c.get(v)?.provideShare({selection:N.Range.to($.selection),resourceUri:f.URI.revive($.resourceUri)},k)??void 0}registerShareProvider(v,$){const k=P.a++;return this.c.set(k,$),this.b.$registerShareProvider(k,N.DocumentSelector.from(v,this.d),$.id,$.label,$.priority),{dispose:()=>{this.b.$unregisterShareProvider(k),this.c.delete(k)}}}}e.$ric=P}),define(ke[340],Se([1,0,7,6,216,3,15,18]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uic=e.$tic=void 0;class ${static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$$L("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$$L("statusBarItem.warningForeground")]])}#e;#t;constructor(w,E,S,c,g,o=C.StatusBarAlignment.Left,i){if(this.i=!1,this.k="",this.q=new P.$Sc,this.#e=w,this.#t=E,g&&c){this.c=(0,C.$NL)(c.identifier,g);const r=S.get(this.c);r&&(o=r.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,i=r.priority,this.j=!0,this.name=r.name,this.text=r.text,this.tooltip=r.tooltip,this.command=r.command,this.accessibilityInformation=r.accessibilityInformation)}else this.c=String($.a++);this.e=c,this.f=g,this.g=o,this.h=this.u(i)}u(w){if((0,v.$Mf)(w))return w===Number.POSITIVE_INFINITY?Number.MAX_VALUE:w===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:w}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(w){this.k=w,this.v()}set name(w){this.m=w,this.v()}set tooltip(w){this.l=w,this.v()}set color(w){this.n=w,this.v()}set backgroundColor(w){w&&!$.b.has(w.id)&&(w=void 0),this.o=w,this.v()}set command(w){this.r?.fromApi!==w&&(this.p&&this.q.add(this.p),this.p=new P.$Sc,typeof w=="string"?this.r={fromApi:w,internal:this.#t.toInternal({title:"",command:w},this.p)}:w?this.r={fromApi:w,internal:this.#t.toInternal(w,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(w){this.t=w,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let w;this.e?this.f?w=`${this.e.identifier.value}.${this.f}`:w=this.e.identifier.value:w=this.f;let E;this.m?E=this.m:E=(0,f.localize)(0,null,this.e.displayName||this.e.name);let S=this.n;this.o&&(S=$.b.get(this.o.id));const c=R.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,w,this.e?.identifier.value,E,this.k,c,this.r?.internal,S,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$tic=$;class k{constructor(w){this.b=[],this.a=w.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,f.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(w){const E={message:w};return this.b.unshift(E),this.c(),new C.$cL(()=>{const S=this.b.indexOf(E);S>=0&&(this.b.splice(S,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class A{constructor(w,E){this.e=new Map,this.a=w.getProxy(N.$aL.MainThreadStatusBar),this.b=E,this.c=new k(this)}$acceptStaticEntries(w){for(const E of w)this.e.set(E.entryId,E)}createStatusBarEntry(w,E,S,c){return new $(this.a,this.b,this.e,w,E,S,c)}setStatusBarMessage(w,E){const S=this.c.setMessage(w);let c;return typeof E=="number"?c=setTimeout(()=>S.dispose(),E):typeof E<"u"&&E.then(()=>S.dispose(),()=>S.dispose()),new C.$cL(()=>{S.dispose(),clearTimeout(c)})}}e.$uic=A}),define(ke[150],Se([1,0,29,141,67,111,90,15,2]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uN=e.$tN=e.$sN=e.$rN=void 0;const k=(r,n,a,t)=>{let h=n;return{enumerable:!0,configurable:!1,get(){return h},set(s){if(!a(h,s)){const d=h;h=s,r.listener?.(t(s,d))}}}},A=(r,n)=>r===n,D={range:(r,n)=>r===n?!0:!r||!n?!1:r.isEqual(n),label:A,description:A,sortText:A,busy:A,error:A,canResolveChildren:A,tags:(r,n)=>!(r.length!==n.length||r.some(a=>!n.find(t=>a.id===t.id)))},w=r=>n=>({op:4,update:r(n)}),E=(r,n)=>({range:(()=>{let a;const t=w(h=>({range:C.$Us.lift(v.Range.from(h))}));return{enumerable:!0,configurable:!1,get(){return a},set(h){r.listener?.({op:6}),D.range(a,h)||(a=h,r.listener?.(t(h)))}}})(),label:k(r,n,D.label,w(a=>({label:a}))),description:k(r,void 0,D.description,w(a=>({description:a}))),sortText:k(r,void 0,D.sortText,w(a=>({sortText:a}))),canResolveChildren:k(r,!1,D.canResolveChildren,a=>({op:2,state:a})),busy:k(r,!1,D.busy,w(a=>({busy:a}))),error:k(r,void 0,D.error,w(a=>({error:v.MarkdownString.fromStrict(a)||null}))),tags:k(r,[],D.tags,(a,t)=>({op:1,new:a.map(v.TestTag.from),old:t.map(v.TestTag.from)}))}),S=r=>{const n=f.$5J.fromString(r.extId),a=new g(n.controllerId,n.localId,r.label,$.URI.revive(r.uri)||void 0);return a.range=v.Range.to(r.range||void 0),a.description=r.description||void 0,a.sortText=r.sortText||void 0,a.tags=r.tags.map(t=>v.TestTag.to({id:(0,R.$0J)(t).tagId})),a},c=r=>{let n;for(const a of r.tests){const t=S(a.item);(0,N.$bN)(t).parent=n,n=t}return n};e.$rN=c;class g{constructor(n,a,t,h){if(a.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(a)} symbol`);const s=(0,N.$aN)(this,n);Object.defineProperties(this,{id:{value:a,enumerable:!0,writable:!1},uri:{value:h,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof o?void 0:s.parent}},children:{value:(0,P.$_M)(s,N.$bN,g),enumerable:!0,writable:!1},...E(s,t)})}}e.$sN=g;class o extends g{constructor(n,a){super(n,n,a,void 0),this._isRoot=!0}}e.$tN=o;class i extends P.$8M{constructor(n,a,t){super({controllerId:n,getDocumentVersion:h=>h&&t.getDocument(h)?.version,getApiFor:N.$bN,getChildren:h=>h.children,root:new o(n,a),toITestItem:v.TestItem.from})}}e.$uN=i}),define(ke[33],Se([1,0,18,7,15,24,6,19,13,56,29,48,2,3,5,20,150,22,68,44,38,88,91,30]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FN=e.$EN=e.$DN=e.$CN=e.$BN=e.$AN=void 0;let s=class{#e;#t;#i;constructor(b,m,y){this.b=new Map,this.c=new Map,this.#e=b.getProxy(R.$aL.MainThreadCommands),this.d=m,this.#i=y,this.#t=b.getProxy(R.$aL.MainThreadTelemetry),this.converter=new d(this,L=>{const F=this.c.get(L);return F?.result===l.Void?F:void 0},m),this.f=[{processArgument(L){return(0,k.$Ch)(L)}},{processArgument(L){return(0,P.$xn)(L,function(F){if(A.$Us.isIRange(F))return f.Range.to(F);if(D.$Ts.isIPosition(F))return f.Position.to(F);if(A.$Us.isIRange(F.range)&&w.URI.isUri(F.uri))return f.location.to(F);if(F instanceof o.$je)return F.buffer.buffer;if(!Array.isArray(F))return F})}}]}registerArgumentProcessor(b){this.f.push(b)}registerApiCommand(b){const m=this.registerCommand(!1,b.id,async(...y)=>{const L=b.args.map((z,T)=>{if(!z.validate(y[T]))throw new Error(`Invalid argument '${z.name}' when running '${b.id}', received: ${typeof y[T]=="object"?JSON.stringify(y[T],null,"	"):y[T]} `);return z.convert(y[T])}),F=await this.executeCommand(b.internalId,...L);return b.result.convert(F,y,this.converter)},void 0,{description:b.description,args:b.args,returns:b.result.description});return this.c.set(b.id,b),new N.$cL(()=>{m.dispose(),this.c.delete(b.id)})}registerCommand(b,m,y,L,F,z){if(this.d.trace("ExtHostCommands#registerCommand",m),!m.trim().length)throw new Error("invalid id");if(this.b.has(m))throw new Error(`command '${m}' already exists`);return this.b.set(m,{callback:y,thisArg:L,metadata:F,extension:z}),b&&this.#e.$registerCommand(m),new N.$cL(()=>{this.b.delete(m)&&b&&this.#e.$unregisterCommand(m)})}executeCommand(b,...m){return this.d.trace("ExtHostCommands#executeCommand",b),this.g(b,m,!0)}async g(b,m,y){if(this.b.has(b))return this.#e.$fireCommandActivationEvent(b),this.h(b,m,!1);{let L=!1;const F=(0,P.$xn)(m,function(z){if(z instanceof N.$dL)return f.Position.from(z);if(z instanceof N.$eL)return f.Range.from(z);if(z instanceof N.$oL)return f.location.from(z);if(N.$BM.isNotebookRange(z))return f.NotebookRange.from(z);if(z instanceof ArrayBuffer)return L=!0,o.$je.wrap(new Uint8Array(z));if(z instanceof Uint8Array)return L=!0,o.$je.wrap(z);if(z instanceof o.$je)return L=!0,z;if(!Array.isArray(z))return z});try{const z=await this.#e.$executeCommand(b,L?new i.$Tv(F):F,y);return(0,k.$Ch)(z)}catch(z){if(z instanceof Error&&z.message==="$executeCommand:retry")return this.g(b,m,!1);throw z}}}async h(b,m,y){const L=this.b.get(b);if(!L)throw new Error("Unknown command");const{callback:F,thisArg:z,metadata:T}=L;if(T?.args)for(let M=0;M<T.args.length;M++)try{(0,C.$Zf)(m[M],T.args[M].constraint)}catch{throw new Error(`Running the contributed command: '${b}' failed. Illegal argument '${T.args[M].name}' - ${T.args[M].description}`)}const O=n.$Rd.create();try{return await F.apply(z,m)}catch(M){if(b===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...m);j&&(b=j.command)}if(this.d.error(M,b,L.extension?.identifier),!y)throw M;if(L.extension?.identifier){const j=this.#i.onExtensionError(L.extension.identifier,M);this.d.trace("forwarded error to extension?",j,L.extension?.identifier)}throw new class extends Error{constructor(){super((0,r.$Qi)(M)),this.id=b,this.source=L.extension?.displayName??L.extension?.name}}}finally{this.j(L,b,O.elapsed())}}j(b,m,y){b.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:b.extension.identifier.value,id:new a.$Lo(m),duration:y})}$executeContributedCommand(b,...m){this.d.trace("ExtHostCommands#$executeContributedCommand",b);const y=this.b.get(b);return y?(m=m.map(L=>this.f.reduce((F,z)=>z.processArgument(F,y.extension?.identifier),L)),this.h(b,m,!0)):Promise.reject(new Error(`Contributed command '${b}' does not exist.`))}getCommands(b=!1){return this.d.trace("ExtHostCommands#getCommands",b),this.#e.$getCommands().then(m=>(b&&(m=m.filter(y=>y[0]!=="_")),m))}$getContributedCommandMetadata(){const b=Object.create(null);for(const[m,y]of this.b){const{metadata:L}=y;L&&(b[m]=L)}return Promise.resolve(b)}};e.$AN=s,e.$AN=s=Ge([We(0,c.$fN),We(1,$.$nj),We(2,t.$zN)],s),e.$BN=(0,S.$6h)("IExtHostCommands");class d{constructor(b,m,y){this.d=b,this.f=m,this.g=y,this.delegatingCommandId=`__vsc${(0,h.$qg)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(b,m){if(!b)return;const y={$ident:void 0,id:b.command,title:b.title,tooltip:b.tooltip};if(!b.command)return y;const L=this.f(b.command);if(L)y.id=L.internalId,y.arguments=L.args.map((F,z)=>F.convert(b.arguments&&b.arguments[z]));else if((0,v.$Lb)(b.arguments)){const F=`${b.command} /${++this.c}`;this.b.set(F,b),m.add((0,E.$Rc)(()=>{this.b.delete(F),this.g.trace("CommandsConverter#DISPOSE",F)})),y.$ident=F,y.id=this.delegatingCommandId,y.arguments=[F],this.g.trace("CommandsConverter#CREATE",b.command,F)}return y}fromInternal(b){return typeof b.$ident=="string"?this.b.get(b.$ident):{command:b.id,title:b.title,arguments:b.arguments}}getActualCommand(...b){return this.b.get(b[0])}h(...b){const m=this.getActualCommand(...b);return this.g.trace("CommandsConverter#EXECUTE",b[0],m?m.command:"MISSING"),m?this.d.executeCommand(m.command,...m.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${b[0]}`)}}e.$CN=d;class u{static{this.Uri=new u("uri","Uri of a text document",b=>w.URI.isUri(b),b=>b)}static{this.Position=new u("position","A position in a text document",b=>N.$dL.isPosition(b),f.Position.from)}static{this.Range=new u("range","A range in a text document",b=>N.$eL.isRange(b),f.Range.from)}static{this.Selection=new u("selection","A selection in a text document",b=>N.$fL.isSelection(b),f.Selection.from)}static{this.Number=new u("number","",b=>typeof b=="number",b=>b)}static{this.String=new u("string","",b=>typeof b=="string",b=>b)}static{this.StringArray=u.Arr(u.String)}static Arr(b){return new u(`${b.name}_array`,`Array of ${b.name}, ${b.description}`,m=>Array.isArray(m)&&m.every(y=>b.validate(y)),m=>m.map(y=>b.convert(y)))}static{this.CallHierarchyItem=new u("item","A call hierarchy item",b=>b instanceof N.$zL,f.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new u("item","A type hierarchy item",b=>b instanceof N.$UM,f.TypeHierarchyItem.from)}static{this.TestItem=new u("testItem","A VS Code TestItem",b=>b instanceof g.$sN,f.TestItem.from)}constructor(b,m,y,L){this.name=b,this.description=m,this.validate=y,this.convert=L}optional(){return new u(this.name,`(optional) ${this.description}`,b=>b==null||this.validate(b),b=>b===void 0?void 0:b===null?null:this.convert(b))}with(b,m){return new u(b??this.name,m??this.description,this.validate,this.convert)}}e.$DN=u;class l{static{this.Void=new l("no result",b=>b)}constructor(b,m){this.description=b,this.convert=m}}e.$EN=l;class p{constructor(b,m,y,L,F){this.id=b,this.internalId=m,this.description=y,this.args=L,this.result=F}}e.$FN=p}),define(ke[341],Se([1,0,19,16,2,83,131,45,33,15,7]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pgc=void 0;const D=[new $.$FN("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of DocumentHighlight-instances.",E(k.DocumentHighlight.to))),new $.$FN("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[$.$DN.Uri],new $.$EN("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(c,g)=>{if((0,C.$Kb)(c))return;class o extends A.$uL{static to(r){const n=new o(r.name,k.SymbolKind.to(r.kind),r.containerName||"",new A.$oL(g[0],k.Range.to(r.range)));return n.detail=r.detail,n.range=n.location.range,n.selectionRange=k.Range.to(r.selectionRange),n.children=r.children?r.children.map(o.to):[],n}}return c.map(o.to)})),new $.$FN("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[$.$DN.Uri,new $.$DN("options","Formatting options",c=>!0,c=>c)],new $.$EN("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$FN("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[$.$DN.Uri,$.$DN.Range,new $.$DN("options","Formatting options",c=>!0,c=>c)],new $.$EN("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$FN("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[$.$DN.Uri,$.$DN.Position,new $.$DN("ch","Trigger character",c=>typeof c=="string",c=>c),new $.$DN("options","Formatting options",c=>!0,c=>c)],new $.$EN("A promise that resolves to an array of TextEdits.",E(k.TextEdit.to))),new $.$FN("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$FN("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$FN("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$FN("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of Location or LocationLink instances.",S)),new $.$FN("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of Location-instances.",E(k.location.to))),new $.$FN("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of Hover-instances.",E(k.Hover.to))),new $.$FN("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[$.$DN.Uri,new $.$DN("position","A position in a text document",c=>Array.isArray(c)&&c.every(g=>A.$dL.isPosition(g)),c=>c.map(k.Position.from))],new $.$EN("A promise that resolves to an array of ranges.",c=>c.map(g=>{let o;for(const i of g.reverse())o=new A.$yL(k.Range.to(i),o);return o}))),new $.$FN("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[$.$DN.String.with("query","Search string")],new $.$EN("A promise that resolves to an array of SymbolInformation-instances.",c=>c.map(k.WorkspaceSymbol.to))),new $.$FN("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of CallHierarchyItem-instances",c=>c.map(k.CallHierarchyItem.to))),new $.$FN("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[$.$DN.CallHierarchyItem],new $.$EN("A promise that resolves to an array of CallHierarchyIncomingCall-instances",c=>c.map(k.CallHierarchyIncomingCall.to))),new $.$FN("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[$.$DN.CallHierarchyItem],new $.$EN("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",c=>c.map(k.CallHierarchyOutgoingCall.to))),new $.$FN("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to a range and placeholder text.",c=>{if(c)return{range:k.Range.to(c.range),placeholder:c.text}})),new $.$FN("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[$.$DN.Uri,$.$DN.Position,$.$DN.String.with("newName","The new symbol name")],new $.$EN("A promise that resolves to a WorkspaceEdit.",c=>{if(c){if(c.rejectReason)throw new Error(c.rejectReason);return k.WorkspaceEdit.to(c)}})),new $.$FN("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[$.$DN.Uri,$.$DN.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new $.$EN("A promise that resolves to an array of DocumentLink-instances.",c=>c.map(k.DocumentLink.to))),new $.$FN("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[$.$DN.Uri],new $.$EN("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new A.$sM(c.tokenTypes,c.tokenModifiers)})),new $.$FN("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[$.$DN.Uri],new $.$EN("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,R.$C$)(c);if(g.type==="full")return new A.$uM(g.data,void 0)})),new $.$FN("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[$.$DN.Uri,$.$DN.Range.optional()],new $.$EN("A promise that resolves to SemanticTokensLegend.",c=>{if(c)return new A.$sM(c.tokenTypes,c.tokenModifiers)})),new $.$FN("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[$.$DN.Uri,$.$DN.Range],new $.$EN("A promise that resolves to SemanticTokens.",c=>{if(!c)return;const g=(0,R.$C$)(c);if(g.type==="full")return new A.$uM(g.data,void 0)})),new $.$FN("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[$.$DN.Uri,$.$DN.Position,$.$DN.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),$.$DN.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new $.$EN("A promise that resolves to a CompletionList-instance.",(c,g,o)=>{if(!c)return new A.$KL([]);const i=c.suggestions.map(r=>k.CompletionItem.to(r,o));return new A.$KL(i,c.incomplete)})),new $.$FN("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[$.$DN.Uri,$.$DN.Position,$.$DN.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new $.$EN("A promise that resolves to SignatureHelp.",c=>{if(c)return k.SignatureHelp.to(c)})),new $.$FN("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[$.$DN.Uri,$.$DN.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new $.$EN("A promise that resolves to an array of CodeLens-instances.",(c,g,o)=>E(i=>new A.$CL(k.Range.to(i.range),i.command&&o.fromInternal(i.command)))(c))),new $.$FN("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[$.$DN.Uri,new $.$DN("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",c=>A.$eL.isRange(c),c=>A.$fL.isSelection(c)?k.Selection.from(c):k.Range.from(c)),$.$DN.String.with("kind","Code action kind to return code actions for").optional(),$.$DN.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new $.$EN("A promise that resolves to an array of Command-instances.",(c,g,o)=>E(i=>{if(i._isSynthetic){if(!i.command)throw new Error("Synthetic code actions must have a command");return o.fromInternal(i.command)}else{const r=new A.$wL(i.title,i.kind?new A.$xL(i.kind):void 0);return i.edit&&(r.edit=k.WorkspaceEdit.to(i.edit)),i.command&&(r.command=o.fromInternal(i.command)),r.isPreferred=i.isPreferred,r}})(c))),new $.$FN("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[$.$DN.Uri],new $.$EN("A promise that resolves to an array of ColorInformation objects.",c=>c?c.map(g=>new A.$QL(k.Range.to(g.range),k.Color.to(g.color))):[])),new $.$FN("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new $.$DN("color","The color to show and insert",c=>c instanceof A.$PL,k.Color.from),new $.$DN("context","Context object with uri and range",c=>!0,c=>({uri:c.uri,range:k.Range.from(c.range)}))],new $.$EN("A promise that resolves to an array of ColorPresentation objects.",c=>c?c.map(k.ColorPresentation.to):[])),new $.$FN("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[$.$DN.Uri,$.$DN.Range],new $.$EN("A promise that resolves to an array of Inlay objects",(c,g,o)=>c.map(k.InlayHint.to.bind(void 0,o)))),new $.$FN("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[$.$DN.Uri],new $.$EN("A promise that resolves to an array of FoldingRange objects",(c,g)=>{if(c)return c.map(k.FoldingRange.to)})),new $.$FN("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new $.$EN("A promise that resolves to an array of NotebookContentProvider static info objects.",E(c=>({viewType:c.viewType,displayName:c.displayName,options:{transientOutputs:c.options.transientOutputs,transientCellMetadata:c.options.transientCellMetadata,transientDocumentMetadata:c.options.transientDocumentMetadata},filenamePattern:c.filenamePattern.map(g=>k.NotebookExclusiveDocumentPattern.to(g))})))),new $.$FN("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[$.$DN.Uri,$.$DN.Range,new $.$DN("context","An InlineValueContext",c=>c&&typeof c.frameId=="number"&&c.stoppedLocation instanceof A.$eL,c=>k.InlineValueContext.from(c))],new $.$EN("A promise that resolves to an array of InlineValue objects",c=>c.map(k.InlineValue.to))),new $.$FN("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new $.$DN("uriOrString","Uri-instance or string (only http/https)",c=>f.URI.isUri(c)||typeof c=="string"&&(0,N.$fg)(c,N.Schemas.http,N.Schemas.https),c=>c),new $.$DN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[k.ViewColumn.from(c),void 0]:[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)])).optional(),$.$DN.String.with("label","").optional()],$.$EN.Void),new $.$FN("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[$.$DN.Uri.with("resource","Resource to open"),$.$DN.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new $.$DN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="number"||typeof c=="object",c=>c&&(typeof c=="number"?[k.ViewColumn.from(c),void 0]:[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)])).optional()],$.$EN.Void),new $.$FN("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[$.$DN.Uri.with("left","Left-hand side resource of the diff editor"),$.$DN.Uri.with("right","Right-hand side resource of the diff editor"),$.$DN.String.with("title","Human readable title for the diff editor").optional(),new $.$DN("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",c=>c===void 0||typeof c=="object",c=>c&&[k.ViewColumn.from(c.viewColumn),k.TextEditorOpenOptions.from(c)]).optional()],$.$EN.Void),new $.$FN("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[$.$DN.String.with("title","Human readable title for the changes editor"),new $.$DN("resourceList","List of resources to compare",c=>{for(const g of c){if(g.length!==3)return!1;const[o,i,r]=g;if(!f.URI.isUri(o)||!f.URI.isUri(i)&&i!==void 0&&i!==null||!f.URI.isUri(r)&&r!==void 0&&r!==null)return!1}return!0},c=>c)],$.$EN.Void),new $.$FN("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[$.$DN.Uri,$.$DN.Position],new $.$EN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new $.$FN("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[$.$DN.TypeHierarchyItem],new $.$EN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new $.$FN("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[$.$DN.TypeHierarchyItem],new $.$EN("A promise that resolves to an array of TypeHierarchyItem-instances",c=>c.map(k.TypeHierarchyItem.to))),new $.$FN("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[$.$DN.TestItem],$.$EN.Void),new $.$FN("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[$.$DN.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],$.$EN.Void),new $.$FN("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[$.$DN.String.with("name","The context key name"),new $.$DN("value","The context key value",()=>!0,c=>c)],$.$EN.Void),new $.$FN("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[$.$DN.Uri,$.$DN.StringArray,new $.$DN("MappedEditsContext","Mapped Edits Context",c=>k.MappedEditsContext.is(c),c=>k.MappedEditsContext.from(c))],new $.$EN("A promise that resolves to a workspace edit or null",c=>c?k.WorkspaceEdit.to(c):null))];class w{static register(g){D.forEach(g.registerApiCommand,g),this.a(g)}static a(g){g.registerCommand(!1,"_validateWhenClauses",v.$5i)}}e.$Pgc=w;function E(c){return g=>{if(Array.isArray(g))return g.map(c)}}function S(c){if(!Array.isArray(c))return;const g=[];for(const o of c)P.$Gt(o)?g.push(k.DefinitionLink.to(o)):g.push(k.location.to(o));return g}}),define(ke[342],Se([1,0,3,2,6,15,7,33,11]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xhc=void 0;class k{static{this.a=0}constructor(E,S){this.extension=E,this.provider=S,this.handle=k.a++}}class A{constructor(E){this.session=E,this.responses=[]}}class D{static{this.a=0}constructor(E,S,c,g){this.f=c,this.g=g,this.b=new Map,this.d=new Map,this.e=E.getProxy(f.$aL.MainThreadInlineChat),S.registerApiCommand(new v.$FN("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new v.$DN("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?P.Range.from(o.initialRange):void 0,initialSelection:o.initialSelection?P.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?P.Position.from(o.position):void 0}})],v.$EN.Void))}registerProvider(E,S,c){const g=new k(E,S);return this.b.set(g.handle,g),this.e.$registerInteractiveEditorProvider(g.handle,c?.label??E.displayName??E.name,E.identifier.value,typeof S.handleInteractiveEditorResponseFeedback=="function",typeof S.provideFollowups=="function",c?.supportReportIssue??!1),(0,C.$Rc)(()=>{this.e.$unregisterInteractiveEditorProvider(g.handle),this.b.delete(g.handle)})}async $prepareSession(E,S,c,g){const o=this.b.get(E);if(!o){this.g.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.f.getDocument(N.URI.revive(S)),r=P.Selection.to(c),n=await o.provider.prepareInteractiveEditorSession({document:i,selection:r},g);if(!n)return;if(n.wholeRange&&!n.wholeRange.contains(r))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const a=D.a++;return this.d.set(a,new A(n)),{id:a,placeholder:n.placeholder,input:n.input,slashCommands:n.slashCommands?.map(t=>({command:t.command,detail:t.detail,refer:t.refer,executeImmediately:t.executeImmediately})),wholeRange:P.Range.from(n.wholeRange),message:n.message}}async $provideResponse(E,S,c,g){const o=this.b.get(E);if(!o)return;const i=this.d.get(S.id);if(!i)return;const r={prompt:c.prompt,selection:P.Selection.to(c.selection),wholeRange:P.Range.to(c.wholeRange),attempt:c.attempt,live:c.live,withIntentDetection:c.withIntentDetection};let n=!1;const a={report:async I=>{if(!c.live&&I.edits?.length)throw new Error("Progress reporting is only supported for live sessions");n||g.isCancellationRequested||await this.e.$handleProgressChunk(c.requestId,{message:I.message,edits:I.edits?.map(P.TextEdit.from),editsShouldBeInstant:I.editsShouldBeInstant,slashCommand:I.slashCommand?.command,markdownFragment:R.$DL.isMarkdownString(I.content)?I.content.value:I.content})}},t=Promise.resolve(o.provider.provideInteractiveEditorResponse(i.session,r,a,g));let h;try{h=await(0,$.$Ug)(t,g)}finally{n=!0}if(!h)return;const s=i.responses.push(h)-1,d={wholeRange:P.Range.from(h.wholeRange),placeholder:h.placeholder};if(!D.h(h))return{...d,id:s,type:"editorEdit",message:P.MarkdownString.from(h.contents),edits:[]};const{edits:u,contents:l}=h,p=l!==void 0?P.MarkdownString.from(l):void 0;return u instanceof R.$mL?{...d,id:s,type:"bulkEdit",edits:P.WorkspaceEdit.from(u),message:p}:{...d,id:s,type:"editorEdit",edits:u.map(P.TextEdit.from),message:p}}async $provideFollowups(E,S,c,g){const o=this.b.get(E),i=this.d.get(S),r=i?.responses[c];if(o&&r&&o.provider.provideFollowups){const n=Promise.resolve(o.provider.provideFollowups(i.session,r,g));return(await(0,$.$Ug)(n,g))?.map(P.ChatFollowup.from)}}$handleFeedback(E,S,c,g){const o=this.b.get(E),i=this.d.get(S),r=i?.responses[c];if(o&&r){const n=P.InteractiveEditorResponseFeedbackKind.to(g);o.provider.handleInteractiveEditorResponseFeedback?.(i.session,r,n)}}$releaseSession(E,S){}static h(E){return typeof E=="object"&&typeof E.edits=="object"}}e.$Xhc=D}),define(ke[343],Se([1,0,2,33]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$hc=void 0;class f{constructor(R,v,$,k,A){this.a=v,this.b=$,this.c=k;const D=new N.$FN("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$DN("showOptions","Show Options",w=>!0,w=>w),new N.$DN("resource","Interactive resource Uri",w=>!0,w=>w),new N.$DN("controllerId","Notebook controller Id",w=>!0,w=>w),new N.$DN("title","Interactive editor title",w=>!0,w=>w)],new N.$EN("Notebook and input URI",w=>{if(A.debug("[ExtHostInteractive] open iw with notebook editor id",w.notebookEditorId),w.notebookEditorId!==void 0){const E=this.a.getEditorById(w.notebookEditorId);return A.debug("[ExtHostInteractive] notebook editor found",E.id),{notebookUri:C.URI.revive(w.notebookUri),inputUri:C.URI.revive(w.inputUri),notebookEditor:E.apiEditor}}return A.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",w.notebookUri,w.inputUri),{notebookUri:C.URI.revive(w.notebookUri),inputUri:C.URI.revive(w.inputUri)}}));this.c.registerApiCommand(D)}$willAddInteractiveDocument(R,v,$,k){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:v,lines:[""],languageId:$,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(C.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,v){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.$$hc=f}),define(ke[344],Se([1,0,19,11,21,4,3,28,2,25,13,6,33,15,7,112,284,26,68,285]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hic=e.$gic=void 0;let n=class{constructor(p,I,b,m,y){this.m=I,this.n=b,this.o=m,this.q=y,this.b=new v.$Ac,this.c=new v.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new P.$Vd,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=p.getProxy(D.$aL.MainThreadNotebookKernels);const L=new w.$FN("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new w.$DN("options","Select kernel options",F=>!0,F=>{if(F&&"notebookEditor"in F&&"id"in F){const z=this.n.getIdByEditor(F.notebookEditor);return{id:F.id,extension:F.extension,notebookEditorId:z}}else if(F&&"notebookEditor"in F){const z=this.n.getIdByEditor(F.notebookEditor);if(z===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${F.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:z}}return F})],w.$EN.Void);this.o.registerApiCommand(L)}createNotebookController(p,I,b,m,y,L){for(const $e of this.j.values())if($e.controller.id===I&&k.$lm.equals(p.identifier,$e.extensionId))throw new Error(`notebook controller with id '${I}' ALREADY exist`);const F=this.k++,z=this;this.q.trace(`NotebookController[${F}], CREATED by ${p.identifier.value}, ${I}`);const T=()=>console.warn(`NO execute handler from notebook controller '${U.id}' of extension: '${p.identifier}'`);let O=!1;const M=new P.$Vd,j=new P.$Vd,U={id:u(p.identifier,I),notebookType:b,extensionId:p.identifier,extensionLocation:p.extensionLocation,label:m||p.identifier.value,preloads:L?L.map(E.NotebookRendererScript.from):[]};let K=y??T,ue,X;this.a.$addKernel(F,U).catch($e=>{console.log($e),O=!0});let Q=0;const Z=()=>{if(O)return;const $e=++Q;Promise.resolve().then(()=>{$e===Q&&this.a.$updateKernel(F,U)})},le=new v.$Ac,re={get id(){return I},get notebookType(){return U.notebookType},onDidChangeSelectedNotebooks:M.event,get label(){return U.label},set label($e){U.label=$e??p.displayName??p.name,Z()},get detail(){return U.detail??""},set detail($e){U.detail=$e,Z()},get description(){return U.description??""},set description($e){U.description=$e,Z()},get supportedLanguages(){return U.supportedLanguages},set supportedLanguages($e){U.supportedLanguages=$e,Z()},get supportsExecutionOrder(){return U.supportsExecutionOrder??!1},set supportsExecutionOrder($e){U.supportsExecutionOrder=$e,Z()},get rendererScripts(){return U.preloads?U.preloads.map(E.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler($e){K=$e??T},get interruptHandler(){return ue},set interruptHandler($e){ue=$e,U.supportsInterrupt=!!$e,Z()},set variableProvider($e){(0,o.$GF)(p,"notebookVariableProvider"),X=$e,U.hasVariableProvider=!!$e,$e?.onDidChangeVariables(oe=>z.a.$variablesUpdated(oe.uri)),Z()},get variableProvider(){return X},createNotebookCellExecution($e){if(O)throw new Error("notebook controller is DISPOSED");if(!le.has($e.notebook.uri))throw z.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.notebook.uri.toString()}`);return z._createNotebookCellExecution($e,u(p.identifier,this.id))},createNotebookExecution($e){if((0,o.$GF)(p,"notebookExecution"),O)throw new Error("notebook controller is DISPOSED");if(!le.has($e.uri))throw z.q.trace(`NotebookController[${F}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(le.keys()).map(oe=>oe.toString())),new Error(`notebook controller is NOT associated to notebook: ${$e.uri.toString()}`);return z._createNotebookExecution($e,u(p.identifier,this.id))},dispose:()=>{O||(this.q.trace(`NotebookController[${F}], DISPOSED`),O=!0,this.j.delete(F),M.dispose(),j.dispose(),this.a.$removeKernel(F))},updateNotebookAffinity($e,oe){oe===S.NotebookControllerAffinity2.Hidden&&(0,o.$GF)(p,"notebookControllerAffinityHidden"),z.a.$updateNotebookPriority(F,$e.uri,oe)},onDidReceiveMessage:j.event,postMessage($e,oe){return(0,o.$GF)(p,"notebookMessaging"),z.a.$postMessage(F,oe&&z.n.getIdByEditor(oe),$e)},asWebviewUri($e){return(0,o.$GF)(p,"notebookMessaging"),(0,c.$bwb)($e,z.m.remote)}};return this.j.set(F,{extensionId:p.identifier,controller:re,onDidReceiveMessage:j,onDidChangeSelection:M,associatedNotebooks:le}),re}getIdByController(p){for(const[I,b]of this.j)if(b.controller===p)return u(b.extensionId,p.id);return null}createNotebookControllerDetectionTask(p,I){const b=this.g++,m=this;this.q.trace(`NotebookControllerDetectionTask[${b}], CREATED by ${p.identifier.value}`),this.a.$addKernelDetectionTask(b,I);const y={dispose:()=>{this.f.delete(b),m.a.$removeKernelDetectionTask(b)}};return this.f.set(b,y),y}registerKernelSourceActionProvider(p,I,b){const m=this.i++,y=typeof b.onDidChangeNotebookKernelSourceActions=="function"?m:void 0,L=this;this.h.set(m,b),this.q.trace(`NotebookKernelSourceActionProvider[${m}], CREATED by ${p.identifier.value}`),this.a.$addKernelSourceActionProvider(m,m,I);let F;return y!==void 0&&(F=b.onDidChangeNotebookKernelSourceActions(z=>this.a.$emitNotebookKernelSourceActionsChangeEvent(y))),{dispose:()=>{this.h.delete(m),L.a.$removeKernelSourceActionProvider(m,m),F?.dispose()}}}async $provideKernelSourceActions(p,I){const b=this.h.get(p);if(b){const m=new R.$Sc;return(await b.provideNotebookKernelSourceActions(I)??[]).map(L=>E.NotebookKernelSourceAction.from(L,this.o.converter,m))}return[]}$acceptNotebookAssociation(p,I,b){const m=this.j.get(p);if(m){const y=this.n.getNotebookDocument($.URI.revive(I));b?m.associatedNotebooks.set(y.uri,!0):m.associatedNotebooks.delete(y.uri),this.q.trace(`NotebookController[${p}] ASSOCIATE notebook`,y.uri.toString(),b),m.onDidChangeSelection.fire({selected:b,notebook:y.apiNotebook})}}async $executeCells(p,I,b){const m=this.j.get(p);if(!m)return;const y=this.n.getNotebookDocument($.URI.revive(I)),L=[];for(const F of b){const z=y.getCell(F);z&&L.push(z.apiCell)}try{this.q.trace(`NotebookController[${p}] EXECUTE cells`,y.uri.toString(),L.length),await m.controller.executeHandler.call(m.controller,L,y.apiNotebook,m.controller)}catch(F){this.q.error(`NotebookController[${p}] execute cells FAILED`,F),console.error(F)}}async $cancelCells(p,I,b){const m=this.j.get(p);if(!m)return;const y=this.n.getNotebookDocument($.URI.revive(I));if(m.controller.interruptHandler)await m.controller.interruptHandler.call(m.controller,y.apiNotebook);else for(const L of b){const F=y.getCell(L);F&&this.b.get(F.uri)?.cancel()}if(m.controller.interruptHandler){const L=this.c.get(y.uri);b.length&&Array.isArray(L)&&L.length&&L.forEach(F=>F.dispose())}}async $provideVariables(p,I,b,m,y,L,F){const z=this.j.get(p);if(!z)return;const T=this.n.getNotebookDocument($.URI.revive(b)),O=z.controller.variableProvider;if(!O)return;let M;if(m!==void 0){if(M=this.s[m],!M)return}else this.s={};const j=y==="named"?S.NotebookVariablesRequestKind.Named:S.NotebookVariablesRequestKind.Indexed,U=O.provideVariables(T.apiNotebook,M,j,L,F);let K=0;for await(const ue of U){if(F.isCancellationRequested)return;const X={id:this.r++,name:ue.variable.name,value:ue.variable.value,hasNamedChildren:ue.hasNamedChildren,indexedChildrenCount:ue.indexedChildrenCount};if(this.s[X.id]=ue.variable,this.a.$receiveVariable(I,X),K++>=r.$ofb)return}}$acceptKernelMessageFromRenderer(p,I,b){const m=this.j.get(p);if(!m)return;const y=this.n.getEditorById(I);m.onDidReceiveMessage.fire(Object.freeze({editor:y.apiEditor,message:b}))}$cellExecutionChanged(p,I,b){const y=this.n.getNotebookDocument($.URI.revive(p)).getCell(I);if(y){const L=b?E.NotebookCellExecutionState.to(b):S.NotebookCellExecutionState.Idle;L!==void 0&&this.l.fire({cell:y.apiCell,state:L})}}_createNotebookCellExecution(p,I){if(p.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const m=this.n.getNotebookDocument(p.notebook.uri).getCellFromApiCell(p);if(!m)throw new Error("invalid cell");if(this.b.has(m.uri))throw new Error(`duplicate execution for ${m.uri}`);const y=new t(I,m,this.a);this.b.set(m.uri,y);const L=y.onDidChangeState(()=>{y.state===a.Resolved&&(y.dispose(),L.dispose(),this.b.delete(m.uri))});return y.asApiObject()}_createNotebookExecution(p,I){const b=this.n.getNotebookDocument(p.uri),m=p.getCells().find(F=>{const z=b.getCellFromApiCell(F);return z&&this.b.has(z.uri)});if(m)throw new Error(`duplicate cell execution for ${m.document.uri}`);if(this.c.has(b.uri))throw new Error(`duplicate notebook execution for ${b.uri}`);const y=new s(I,b,this.a),L=y.onDidChangeState(()=>{y.state===h.Resolved&&(y.dispose(),L.dispose(),this.c.delete(b.uri))});return this.c.set(b.uri,[y,L]),y.asApiObject()}};e.$gic=n,e.$gic=n=Ge([We(4,A.$nj)],n);var a;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(a||(a={}));class t extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(p,I,b){super(),this.m=I,this.n=b,this.b=t.a++,this.c=new P.$Vd,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new f.$6d),this.h=new d(10,m=>this.s(m)),this.j=I.internalMetadata.executionOrder,this.n.$createExecution(this.b,p,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(p){await this.h.addItem(p)}async s(p){const I=Array.isArray(p)?p:[p];return this.n.$updateExecution(this.b,new i.$Tv(I))}t(){if(this.f===a.Init)throw new Error("Must call start before modifying cell output");if(this.f===a.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(p){let I=this.m;if(p&&(I=this.m.notebook.getCellFromApiCell(p)),!I)throw new Error("INVALID cell");return I.handle}y(p){return p.map(I=>{const b=S.$FM.ensureUniqueMimeTypes(I.items,!0);return b===I.items?E.NotebookCellOutput.from(I):E.NotebookCellOutput.from({items:b,id:I.id,metadata:I.metadata})})}async z(p,I,b){const m=this.w(I),y=this.y((0,C.$3b)(p));return this.r({editType:g.CellExecutionUpdateType.Output,cellHandle:m,append:b,outputs:y})}async C(p,I,b){return p=S.$FM.ensureUniqueMimeTypes((0,C.$3b)(p),!0),this.r({editType:g.CellExecutionUpdateType.OutputItems,items:p.map(E.NotebookCellOutputItem.from),outputId:I.id,append:b})}asApiObject(){const p=this;return Object.freeze({get token(){return p.g.token},get cell(){return p.m.apiCell},get executionOrder(){return p.j},set executionOrder(b){p.j=b,p.s([{editType:g.CellExecutionUpdateType.ExecutionState,executionOrder:p.j}])},start(b){if(p.f===a.Resolved||p.f===a.Started)throw new Error("Cannot call start again");p.f=a.Started,p.c.fire(),p.s({editType:g.CellExecutionUpdateType.ExecutionState,runStartTime:b})},end(b,m){if(p.f===a.Resolved)throw new Error("Cannot call resolve twice");p.f=a.Resolved,p.c.fire(),p.h.flush(),p.n.$completeExecution(p.b,new i.$Tv({runEndTime:m,lastRunSuccess:b}))},clearOutput(b){return p.t(),p.z([],b,!1)},appendOutput(b,m){return p.t(),p.z(b,m,!0)},replaceOutput(b,m){return p.t(),p.z(b,m,!1)},appendOutputItems(b,m){return p.t(),p.C(b,m,!0)},replaceOutputItems(b,m){return p.t(),p.C(b,m,!1)}})}}var h;(function(l){l[l.Init=0]="Init",l[l.Started=1]="Started",l[l.Resolved=2]="Resolved"})(h||(h={}));class s extends R.$Tc{static{this.a=0}get state(){return this.f}constructor(p,I,b){super(),this.h=I,this.j=b,this.b=s.a++,this.c=new P.$Vd,this.onDidChangeState=this.c.event,this.f=h.Init,this.g=this.B(new f.$6d),this.j.$createNotebookExecution(this.b,p,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===h.Resolved||this.f===h.Started)throw new Error("Cannot call start again");this.f=h.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===h.Resolved)throw new Error("Cannot call resolve twice");this.f=h.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class d{constructor(p,I){this.f=p,this.g=I,this.a=[],this.b=Date.now()}addItem(p){return this.a.push(p),this.c||(this.c=new N.$qh,this.b=Date.now(),(0,N.$7g)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const p=this.c;this.c=void 0;const I=this.a;return this.a=[],this.g(I).finally(()=>p.complete())}}function u(l,p){return`${l.value}/${p}`}e.$hic=u}),define(ke[46],Se([1,0,4,6,5,2,20,3,7,218,14,262,21,30,263,55,11,15,33]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vhc=e.$uhc=e.$thc=e.$shc=void 0,e.$shc=(0,f.$6h)("IExtHostTerminalService");class r{constructor(b,m,y,L){this.l=b,this._id=m,this.m=y,this.n=L,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.m=Object.freeze(this.m),this.b=new Promise(z=>this.f=z);const F=this;this.value={get name(){return F.n||""},get processId(){return F.b},get creationOptions(){return F.m},get exitStatus(){return F.h},get state(){return F.j},get selection(){return F.k},sendText(z,T=!0){F.q(),F.l.$sendText(F._id,z,T)},show(z){F.q(),F.l.$show(F._id,z)},hide(){F.q(),F.l.$hide(F._id)},dispose(){F.a||(F.a=!0,F.l.$dispose(F._id))},get dimensions(){if(!(F.d===void 0||F.g===void 0))return{columns:F.d,rows:F.g}}}}async create(b,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.l.$createTerminal(this._id,{name:b.name,shellPath:b.shellPath??void 0,shellArgs:b.shellArgs??void 0,cwd:b.cwd??m?.cwd??void 0,env:b.env??void 0,icon:u(b.iconPath)??void 0,color:c.ThemeColor.isThemeColor(b.color)?b.color.id:void 0,initialText:b.message??void 0,strictEnv:b.strictEnv??void 0,hideFromUser:b.hideFromUser??void 0,isFeatureTerminal:m?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:m?.useShellEnvironment??void 0,location:m?.location||this.o(b.location,m?.resolvedExtHostIdentifier),isTransient:b.isTransient??void 0})}async createExtensionTerminal(b,m,y,L,F){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.l.$createTerminal(this._id,{name:this.n,isExtensionCustomPtyTerminal:!0,icon:L,color:c.ThemeColor.isThemeColor(F)?F.id:void 0,location:m?.location||this.o(b,y),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}o(b,m){return typeof b=="object"?"parentTerminal"in b&&b.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in b?{viewColumn:o.ViewColumn.from(b.viewColumn),preserveFocus:b.preserveFocus}:void 0:b}q(){if(this.a)throw new Error("Terminal has already been disposed")}set name(b){this.n=b}setExitStatus(b,m){this.h=Object.freeze({code:b,reason:m})}setDimensions(b,m){return b===this.d&&m===this.g||b===0||m===0?!1:(this.d=b,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}setSelection(b){this.k=b}_setProcessId(b){this.f?(this.f(b),this.f=void 0):this.b.then(m=>{m!==b&&(this.b=Promise.resolve(b))})}}e.$thc=r;class n{get onProcessReady(){return this.b.event}constructor(b){this.g=b,this.id=0,this.shouldPersist=!1,this.a=new C.$Vd,this.onProcessData=this.a.event,this.b=new C.$Vd,this.d=new C.$Vd,this.onDidChangeProperty=this.d.event,this.f=new C.$Vd,this.onProcessExit=this.f.event}refreshProperty(b){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${b}`)}updateProperty(b,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${b}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(b){this.g.handleInput?.(b)}resize(b,m){this.g.setDimensions?.({columns:b,rows:m})}clearBuffer(){}async processBinary(b){}acknowledgeDataEvent(b){}async setUnicodeVersion(b){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(b){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(b||void 0),b&&this.g.setDimensions?.(b),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let a=1,t=class extends v.$Tc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(b=>b.value)}constructor(b,m,y){super(),this.Q=m,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new v.$Uc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$Vd,this.onDidCloseTerminal=this.H.event,this.I=new C.$Vd,this.onDidOpenTerminal=this.I.event,this.J=new C.$Vd,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$Vd,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$Vd,this.onDidChangeTerminalState=this.M.event,this.N=new C.$Vd,this.onDidChangeShell=this.N.event,this.O=new C.$Vd({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$Vd({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=y.getProxy(N.$aL.MainThreadTerminalService),this.y=new S.$nsb(this.a.$sendProcessData),this.a.$registerProcessSupport(b),this.Q.registerArgumentProcessor({processArgument:L=>{const F=z=>{const T=z;return this.W(T.instanceId)?.value};switch(L?.$mid){case 15:return F(L);default:{if(Array.isArray(L))for(let z=0;z<L.length&&L[z].$mid===15;z++)L[z]=F(L[z]);return L}}}}),this.B({dispose:()=>{for(const[L,F]of this.g)F.shutdown(!0)}})}getDefaultShell(b){return(b?this.u:this.s)?.path||""}getDefaultShellArgs(b){return(b?this.u:this.s)?.args||[]}createExtensionTerminal(b,m){const y=new r(this.a,(0,E.$qg)(),b,b.name),L=new n(b.pty);return y.createExtensionTerminal(b.location,m,this.R(b,m).resolvedExtHostIdentifier,u(b.iconPath),l(b.color)).then(F=>{const z=this.S(F,L);this.h[F]=z}),this.f.push(y),y.value}R(b,m){if(m=m||{},b.location&&typeof b.location=="object"&&"parentTerminal"in b.location){const y=b.location.parentTerminal;if(y){const L=this.f.find(F=>F.value===y);L&&(m.resolvedExtHostIdentifier=L._id)}}else b.location&&typeof b.location!="object"?m.location=b.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(b,m){if(!this.W(b))throw new Error(`Cannot resolve terminal with id ${b} for virtual process`);const L=new n(m),F=this.S(b,L);this.h[b]=F}async $acceptActiveTerminalChanged(b){const m=this.b;if(b===null){this.b=void 0,m!==this.b&&this.J.fire(this.b);return}const y=this.W(b);y&&(this.b=y,m!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(b,m){const y=this.W(b);y&&this.O.fire({terminal:y.value,data:m})}async $acceptTerminalDimensions(b,m,y){const L=this.W(b);L&&L.setDimensions(m,y)&&this.L.fire({terminal:L.value,dimensions:L.value.dimensions})}async $acceptDidExecuteCommand(b,m){const y=this.W(b);y&&this.P.fire({terminal:y.value,...m})}async $acceptTerminalMaximumDimensions(b,m,y){this.g.get(b)?.resize(m,y)}async $acceptTerminalTitleChange(b,m){const y=this.W(b);y&&(y.name=m)}async $acceptTerminalClosed(b,m,y){const L=this.Y(this.f,b);if(L!==null){const F=this.f.splice(L,1)[0];F.setExitStatus(m,y),this.H.fire(F.value)}}$acceptTerminalOpened(b,m,y,L){if(m){const T=this.Y(this.f,m);if(T!==null){this.f[T]._id=b,this.I.fire(this.terminals[T]),this.f[T].isOpen=!0;return}}const F={name:L.name,shellPath:L.executable,shellArgs:L.args,cwd:typeof L.cwd=="string"?L.cwd:P.URI.revive(L.cwd),env:L.env,hideFromUser:L.hideFromUser},z=new r(this.a,b,F,y);this.f.push(z),this.I.fire(z.value),z.isOpen=!0}async $acceptTerminalProcessId(b,m){this.W(b)?._setProcessId(m)}async $startExtensionTerminal(b,m){const y=this.W(b);if(!y)return{message:(0,k.localize)(0,null,b)};y.isOpen||await new Promise(F=>{const z=this.onDidOpenTerminal(async T=>{T===y.value&&(z.dispose(),F())})});const L=this.g.get(b);L?L.startSendingEvents(m):this.j[b]={initialDimensions:m}}S(b,m){const y=new v.$Sc;y.add(m.onProcessReady(F=>this.a.$sendProcessReady(b,F.pid,F.cwd,F.windowsPty))),y.add(m.onDidChangeProperty(F=>this.a.$sendProcessProperty(b,F))),this.y.startBuffering(b,m.onProcessData),y.add(m.onProcessExit(F=>this.U(b,F))),this.g.set(b,m);const L=this.j[b];return L&&m instanceof n&&(m.startSendingEvents(L.initialDimensions),delete this.j[b]),y}$acceptProcessAckDataEvent(b,m){this.g.get(b)?.acknowledgeDataEvent(m)}$acceptProcessInput(b,m){this.g.get(b)?.input(m)}$acceptTerminalInteraction(b){const m=this.W(b);m?.setInteractedWith()&&this.M.fire(m.value)}$acceptTerminalSelection(b,m){this.W(b)?.setSelection(m)}$acceptProcessResize(b,m,y){try{this.g.get(b)?.resize(m,y)}catch(L){if(L.code!=="EPIPE"&&L.code!=="ERR_IPC_CHANNEL_CLOSED")throw L}}$acceptProcessShutdown(b,m){this.g.get(b)?.shutdown(m)}$acceptProcessRequestInitialCwd(b){this.g.get(b)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(b,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(b){this.g.get(b)?.getCwd().then(m=>this.a.$sendProcessProperty(b,{type:"cwd",value:m}))}$acceptProcessRequestLatency(b){return Promise.resolve(b)}registerLinkProvider(b){return this.z.add(b),this.z.size===1&&this.a.$startLinkProvider(),new $.$cL(()=>{this.z.delete(b),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(b,m,y){if(this.C.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.C.set(m,y),this.a.$registerProfileProvider(m,b.identifier.value),new $.$cL(()=>{this.C.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(b,m,y){if(this.D.has(b))throw new Error(`Terminal quick fix provider "${b}" is already registered`);return this.D.set(b,y),this.a.$registerQuickFixProvider(b,m),new $.$cL(()=>{this.D.delete(b),this.a.$unregisterQuickFixProvider(b)})}async $provideTerminalQuickFixes(b,m){const y=new w.$6d().token;if(y.isCancellationRequested)return;const L=this.D.get(b);if(!L)return;const F=await L.provideTerminalQuickFixes(m,y);if(F===null||Array.isArray(F)&&F.length===0)return;const z=new v.$Sc;if(this.w.value=z,!Array.isArray(F))return F?o.TerminalQuickFix.from(F,this.Q.converter,z):void 0;const T=[];for(const O of F){const M=o.TerminalQuickFix.from(O,this.Q.converter,z);M&&T.push(M)}return T}async $createContributedProfileTerminal(b,m){const y=new w.$6d().token;let L=await this.C.get(b)?.provideTerminalProfile(y);if(!y.isCancellationRequested){if(L&&!("options"in L)&&(L={options:L}),!L||!("options"in L))throw new Error(`No terminal profile options provided for id "${b}"`);if("pty"in L.options){this.createExtensionTerminal(L.options,m);return}this.createTerminalFromOptions(L.options,m)}}async $provideLinks(b,m){const y=this.W(b);if(!y)return[];this.F.delete(b),this.G.get(b)?.dispose(!0);const F=new w.$6d;this.G.set(b,F);const z=[],T={terminal:y.value,line:m},O=[];for(const U of this.z)O.push(g.Promises.withAsyncBody(async K=>{F.token.onCancellationRequested(()=>K({provider:U,links:[]}));const ue=await U.provideTerminalLinks(T,F.token)||[];F.token.isCancellationRequested||K({provider:U,links:ue})}));const M=await Promise.all(O);if(F.token.isCancellationRequested)return[];const j=new Map;for(const U of M)U&&U.links.length>0&&z.push(...U.links.map(K=>{const ue={id:a++,startIndex:K.startIndex,length:K.length,label:K.tooltip};return j.set(ue.id,{provider:U.provider,link:K}),ue}));return this.F.set(b,j),z}$activateLink(b,m){const y=this.F.get(b)?.get(m);y&&y.provider.handleTerminalLink(y.link)}U(b,m){this.y.stopBuffering(b),this.g.delete(b),delete this.j[b];const y=this.h[b];y&&(y.dispose(),delete this.h[b]),this.a.$sendProcessExit(b,m)}W(b){return this.X(this.f,b)}X(b,m){const y=this.Y(b,m);return y!==null?b[y]:null}Y(b,m){const y=b.findIndex(L=>L._id===m);return y===-1?null:y}getEnvironmentVariableCollection(b){let m=this.n.get(b.identifier.value);return m||(m=new h,this.$(b.identifier.value,m)),m.getScopedEnvironmentVariableCollection(void 0)}Z(b,m){const y=(0,D.$Mr)(m.map),L=(0,D.$Nr)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(b,m.persistent,y.length===0?void 0:y,L)}$initEnvironmentVariableCollections(b){b.forEach(m=>{const y=m[0],L=new h(m[1]);this.$(y,L)})}$acceptDefaultProfile(b,m){const y=this.s;this.s=b,this.u=m,y?.path!==b.path&&this.N.fire(b.path)}$(b,m){this.n.set(b,m),m.onDidChangeCollection(()=>{this.Z(b,m)})}};e.$uhc=t,e.$uhc=t=Ge([We(1,i.$BN),We(2,R.$fN)],t);class h{get persistent(){return this.b}set persistent(b){this.b=b,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(b){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$Vd,this.map=new Map(b)}getScopedEnvironmentVariableCollection(b){const m=this.h(b);let y=this.a.get(m);return y||(y=new s(this,b),this.a.set(m,y),y.onDidChangeCollection(()=>this.d.fire())),y}replace(b,m,y,L){this.f(b,{value:m,type:$.EnvironmentVariableMutatorType.Replace,options:y??{applyAtProcessCreation:!0},scope:L})}append(b,m,y,L){this.f(b,{value:m,type:$.EnvironmentVariableMutatorType.Append,options:y??{applyAtProcessCreation:!0},scope:L})}prepend(b,m,y,L){this.f(b,{value:m,type:$.EnvironmentVariableMutatorType.Prepend,options:y??{applyAtProcessCreation:!0},scope:L})}f(b,m){if(m.options&&m.options.applyAtProcessCreation===!1&&!m.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const y=this.g(b,m.scope),L=this.map.get(y),F=m.options?{applyAtProcessCreation:m.options.applyAtProcessCreation??!1,applyAtShellIntegration:m.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!L||L.value!==m.value||L.type!==m.type||L.options?.applyAtProcessCreation!==F.applyAtProcessCreation||L.options?.applyAtShellIntegration!==F.applyAtShellIntegration||L.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const z=this.g(b,m.scope),T={variable:b,...m,options:F};this.map.set(z,T),this.d.fire()}}get(b,m){const y=this.g(b,m),L=this.map.get(y);return L?p(L):void 0}g(b,m){const y=this.h(m);return y.length?`${b}:::${y}`:b}h(b){return this.j(b?.workspaceFolder)??""}j(b){return b?b.uri.toString():void 0}getVariableMap(b){const m=new Map;for(const[y,L]of this.map)this.h(L.scope)===this.h(b)&&m.set(L.variable,p(L));return m}delete(b,m){const y=this.g(b,m);this.map.delete(y),this.d.fire()}clear(b){if(b?.workspaceFolder){for(const[m,y]of this.map)y.scope?.workspaceFolder?.index===b.workspaceFolder.index&&this.map.delete(m);this.k(b)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(b,m){const y=this.h(m),L=this.descriptionMap.get(y);if(!L||L.description!==b){let F;typeof b=="string"?F=b:F=b?.value.split(`

`)[0];const z={description:F,scope:m};this.descriptionMap.set(y,z),this.d.fire()}}getDescription(b){const m=this.h(b);return this.descriptionMap.get(m)?.description}k(b){const m=this.h(b);this.descriptionMap.delete(m)}}class s{get persistent(){return this.b.persistent}set persistent(b){this.b.persistent=b}get onDidChangeCollection(){return this.a&&this.a.event}constructor(b,m){this.b=b,this.d=m,this.a=new C.$Vd}getScoped(b){return this.b.getScopedEnvironmentVariableCollection(b)}replace(b,m,y){this.b.replace(b,m,y,this.d)}append(b,m,y){this.b.append(b,m,y,this.d)}prepend(b,m,y){this.b.prepend(b,m,y,this.d)}get(b){return this.b.get(b,this.d)}forEach(b,m){this.b.getVariableMap(this.d).forEach((y,L)=>b.call(m,L,y,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(b){this.b.delete(b,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(b){this.b.setDescription(b,this.d)}get description(){return this.b.getDescription(this.d)}}let d=class extends t{constructor(b,m){super(!1,b,m)}createTerminal(b,m,y){throw new A.$_}createTerminalFromOptions(b,m){throw new A.$_}};e.$vhc=d,e.$vhc=d=Ge([We(0,i.$BN),We(1,R.$fN)],d);function u(I){if(!(!I||typeof I=="string"))return"id"in I?{id:I.id,color:I.color}:I}function l(I){return c.ThemeColor.isThemeColor(I)?I:void 0}function p(I){const b={...I};return delete b.scope,b.options=b.options??void 0,delete b.variable,b}}),define(ke[345],Se([1,0,11,22,21,4,74,54,3,24,18,30,13,6,20,150,15,7,67,111,90,26]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bic=e.$Aic=e.$zic=e.$yic=void 0;let t=class extends $.$Tc{constructor(O,M,j,U){super(),this.w=U,this.f=this.B(new P.$Vd),this.g=new Map,this.s=this.B(new P.$Vd),this.onResultsChanged=this.f.event,this.results=[],this.h=O.getProxy(E.$aL.MainThreadTesting),this.m=new y(this.h),this.j=new u(this.h,M),j.registerArgumentProcessor({processArgument:K=>{switch(K?.$mid){case 16:{const ue=K,X=ue.tests[ue.tests.length-1].item.extId;return this.g.get(i.$5J.root(X))?.collection.tree.get(X)?.actual??(0,c.$rN)(K)}case 18:{const{extId:ue,message:X}=K;return{test:this.g.get(i.$5J.root(ue))?.collection.tree.get(ue)?.actual,message:g.TestMessage.to(X)}}default:return K}}}),j.registerCommand(!1,"testing.getExplorerSelection",async()=>{const K=await j.executeCommand("_testing.getExplorerSelection"),ue=X=>{const Q=this.g.get(i.$5J.root(X));if(Q)return i.$5J.isRoot(X)?Q.controller:Q.collection.tree.get(X)?.actual};return{include:K?.include.map(ue).filter(A.$Qf)||[],exclude:K?.exclude.map(ue).filter(A.$Qf)||[]}})}createTestController(O,M,j,U){if(this.g.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const K=new $.$Sc,ue=K.add(new c.$uN(M,j,this.w));ue.root.label=j;const X=new Map,Q=new Set,Z=this.h,le={items:ue.root.children,get label(){return j},set label($e){j=$e,ue.root.label=$e,Z.$updateController(M,{label:j})},get refreshHandler(){return U},set refreshHandler($e){U=$e,Z.$updateController(M,{canRefresh:!!$e})},get id(){return M},createRunProfile:($e,oe,J,V,ie,ye)=>{let de=(0,v.$Ti)($e);for(;X.has(de);)de++;return new F(this.h,X,O,Q,this.s.event,M,de,$e,oe,J,V,ie,ye)},createTestItem($e,oe,J){return new c.$sN(M,$e,oe,J)},createTestRun:($e,oe,J=!0)=>this.j.createTestRun(O,M,ue,$e,oe,J),invalidateTestResults:$e=>{if($e===void 0)this.h.$markTestRetired(void 0);else{const oe=$e instanceof Array?$e:[$e];this.h.$markTestRetired(oe.map(J=>i.$5J.fromExtHostTestItem(J,M).toString()))}},set resolveHandler($e){ue.resolveHandler=$e},get resolveHandler(){return ue.resolveHandler},dispose:()=>{K.dispose()}};Z.$registerTestController(M,j,!!U),K.add((0,$.$Rc)(()=>Z.$unregisterTestController(M)));const re={controller:le,collection:ue,profiles:X,extension:O,activeProfiles:Q};return this.g.set(M,re),K.add((0,$.$Rc)(()=>this.g.delete(M))),K.add(ue.onDidGenerateDiff($e=>Z.$publishDiff(M,$e.map(n.TestsDiffOp.serialize)))),le}createTestObserver(){return this.m.checkout()}async runTests(O,M=f.CancellationToken.None){const j=l(O);if(!j)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.g.get(j.controllerId);if(!U)throw new Error("Controller not found");await this.h.$runTests({isUiTriggered:!1,targets:[{testIds:O.include?.map(K=>i.$5J.fromExtHostTestItem(K,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:z[j.kind],profileId:j.profileId,controllerId:j.controllerId}],exclude:O.exclude?.map(K=>K.id)},M)}$syncTests(){for(const{collection:O}of this.g.values())O.flushDiff();return Promise.resolve()}async $provideFileCoverage(O,M,j){return await this.j.getCoverageReport(O,M)?.provideFileCoverage(j)??[]}async $resolveFileCoverage(O,M,j,U){return await this.j.getCoverageReport(O,M)?.resolveFileCoverage(j,U)??[]}$configureRunProfile(O,M){this.g.get(O)?.profiles.get(M)?.configureHandler?.()}$setDefaultRunProfiles(O){const M=new Map;for(const[j,U]of Object.entries(O)){const K=this.g.get(j);if(!K)continue;const ue=new Map,X=U.filter(Z=>!K.activeProfiles.has(Z)),Q=[...K.activeProfiles].filter(Z=>!U.includes(Z));for(const Z of X)ue.set(Z,!0),K.activeProfiles.add(Z);for(const Z of Q)ue.set(Z,!1),K.activeProfiles.delete(Z);ue.size&&M.set(j,ue)}this.s.fire(M)}async $refreshTests(O,M){await this.g.get(O)?.controller.refreshHandler?.(M)}$publishTestResults(O){this.results=Object.freeze(O.map(M=>(0,k.$wn)(g.TestResults.to(M))).concat(this.results).sort((M,j)=>j.completedAt-M.completedAt).slice(0,32)),this.f.fire()}async $expandTest(O,M){const j=this.g.get(i.$5J.fromString(O).controllerId)?.collection;j&&(await j.expand(O,M<0?1/0:M),j.flushDiff())}$acceptDiff(O){this.m.applyDiff(O.map(M=>n.TestsDiffOp.deserialize({asCanonicalUri:j=>j},M)))}async $runControllerTests(O,M){return Promise.all(O.map(j=>this.y(j,!1,M)))}async $startContinuousRun(O,M){const j=new f.$6d(M),U=await Promise.all(O.map(K=>this.y(K,!0,j.token)));return!M.isCancellationRequested&&!U.some(K=>K.error)&&await new Promise(K=>M.onCancellationRequested(K)),j.dispose(!0),U}async y(O,M,j){const U=this.g.get(O.controllerId);if(!U)return{};const{collection:K,profiles:ue,extension:X}=U,Q=ue.get(O.profileId);if(!Q)return{};const Z=O.testIds.map(oe=>K.tree.get(oe)).filter(A.$Qf),le=O.excludeExtIds.map(oe=>U.collection.tree.get(oe)).filter(A.$Qf).filter(oe=>Z.some(J=>J.fullId.compare(oe.fullId)===2));if(!Z.length)return{};const re=new o.$MM(Z.some(oe=>oe.actual instanceof c.$tN)?void 0:Z.map(oe=>oe.actual),le.map(oe=>oe.actual),Q,M),$e=(0,n.$7J)(O)&&this.j.prepareForMainThreadTestRun(re,p.fromInternal(O,U.collection),X,j);try{return await Q.runHandler(re,j),{}}catch(oe){return{error:String(oe)}}finally{$e&&($e.hasRunningTasks&&!j.isCancellationRequested&&await P.Event.toPromise($e.onEnd),$e.dispose())}}$cancelExtensionTestRun(O){O===void 0?this.j.cancelAllRuns():this.j.cancelRunById(O)}};e.$yic=t,e.$yic=t=Ge([We(0,S.$fN),We(1,w.$nj)],t);const h=1e4;var s;(function(T){T[T.Running=0]="Running",T[T.Cancelling=1]="Cancelling",T[T.Ended=2]="Ended"})(s||(s={}));class d extends $.$Tc{get hasRunningTasks(){return this.f.size>0}get id(){return this.s.id}constructor(O,M,j,U,K){super(),this.s=O,this.w=M,this.y=j,this.z=U,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new P.$Vd),this.m=this.B(new P.$Vd),this.onDidCoverage=this.m.event,this.onEnd=this.j.event,this.h=this.B(new f.$6d(K));const ue=this.B(new C.$fh(()=>this.C(),h));this.B(this.h.token.onCancellationRequested(()=>ue.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.C()}createRun(O){const M=this.s.id,j=this.s.controllerId,U=(0,D.$qg)(),K=this.y,ue=this.m;let X;const Q=$e=>(oe,...J)=>{if(le){this.z.warn(`Setting the state of test "${oe.id}" is a no-op after the run ends.`);return}this.s.isIncluded(oe)&&(this.F(oe),$e(oe,...J))},Z=($e,oe)=>{const J=oe instanceof Array?oe.map(g.TestMessage.from):[g.TestMessage.from(oe)];if($e.uri&&$e.range){const V={range:g.Range.from($e.range),uri:$e.uri};for(const ie of J)ie.location=ie.location||V}this.w.$appendTestMessagesInRun(M,U,i.$5J.fromExtHostTestItem($e,j).toString(),J)};let le=!1;const re={isPersisted:this.s.isPersisted,token:this.h.token,name:O,get coverageProvider(){return X?.provider},set coverageProvider($e){(0,a.$GF)(K,"testCoverage"),X=$e&&new I($e),ue.fire({taskId:U,runId:M,coverage:X})},enqueued:Q($e=>{this.w.$updateTestStateInRun(M,U,i.$5J.fromExtHostTestItem($e,j).toString(),1)}),skipped:Q($e=>{this.w.$updateTestStateInRun(M,U,i.$5J.fromExtHostTestItem($e,j).toString(),5)}),started:Q($e=>{this.w.$updateTestStateInRun(M,U,i.$5J.fromExtHostTestItem($e,j).toString(),2)}),errored:Q(($e,oe,J)=>{Z($e,oe),this.w.$updateTestStateInRun(M,U,i.$5J.fromExtHostTestItem($e,j).toString(),6,J)}),failed:Q(($e,oe,J)=>{Z($e,oe),this.w.$updateTestStateInRun(M,U,i.$5J.fromExtHostTestItem($e,j).toString(),4,J)}),passed:Q(($e,oe)=>{this.w.$updateTestStateInRun(M,U,i.$5J.fromExtHostTestItem($e,this.s.controllerId).toString(),3,oe)}),appendOutput:($e,oe,J)=>{le||(J&&(this.s.isIncluded(J)?this.F(J):J=void 0),this.w.$appendOutputToRun(M,U,N.$je.fromString($e),oe&&g.location.from(oe),J&&i.$5J.fromExtHostTestItem(J,j).toString()))},end:()=>{le||(le=!0,this.w.$finishedTestRunTask(M,U),this.f.delete(U),this.f.size||this.D())}};return this.f.set(U,{run:re}),this.w.$startedTestRunTask(M,{id:U,name:O,running:!0}),re}C(){for(const{run:O}of this.f.values())O.end()}D(){this.c!==2&&(this.c=2,this.j.fire())}F(O){if(!(O instanceof c.$sN))throw new r.$0M(O.id);if(this.g.has(i.$5J.fromExtHostTestItem(O,this.s.controllerId).toString()))return;const M=[],j=this.s.colllection.root;for(;;){const U=g.TestItem.from(O);if(M.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),O===j))break;O=O.parent||j}this.w.$addTestsToRun(this.s.controllerId,this.s.id,M)}dispose(){this.D(),super.dispose()}}class u{get trackers(){return this.c.values()}constructor(O,M){this.g=O,this.h=M,this.c=new Map,this.f=[]}getCoverageReport(O,M){return this.f.find(j=>j.runId===O)?.coverage.get(M)}prepareForMainThreadTestRun(O,M,j,U){return this.j(O,M,j,U)}cancelRunById(O){for(const M of this.c.values())if(M.id===O){M.cancel();return}}cancelAllRuns(){for(const O of this.c.values())O.cancel()}createTestRun(O,M,j,U,K,ue){const X=this.c.get(U);if(X)return X.createRun(K);const Q=p.fromPublic(M,j,U,ue),Z=l(U);this.g.$startedExtensionTestRun({controllerId:M,continuous:!!U.continuous,profile:Z&&{group:z[Z.kind],id:Z.profileId},exclude:U.exclude?.map(re=>i.$5J.fromExtHostTestItem(re,j.root.id).toString())??[],id:Q.id,include:U.include?.map(re=>i.$5J.fromExtHostTestItem(re,j.root.id).toString())??[j.root.id],persist:ue});const le=this.j(U,Q,O);return P.Event.once(le.onEnd)(()=>{this.g.$finishedExtensionTestRun(Q.id),le.dispose()}),le.createRun(K)}j(O,M,j,U){const K=new d(M,this.g,j,this.h,U);this.c.set(O,K);let ue;const X=K.onDidCoverage(({runId:Q,taskId:Z,coverage:le})=>{ue||(ue={runId:Q,coverage:new Map},this.f.unshift(ue),this.f.length>n.$_J&&this.f.pop()),ue.coverage.set(Z,le),this.g.$signalCoverageAvailable(Q,Z,!!le)});return P.Event.once(K.onEnd)(()=>{this.c.delete(O),X.dispose()}),K}}e.$zic=u;const l=T=>{if(T.profile){if(!(T.profile instanceof F))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return T.profile}};class p{static fromPublic(O,M,j,U){return new p(O,(0,D.$qg)(),j.include?.map(K=>i.$5J.fromExtHostTestItem(K,O).toString())??[O],j.exclude?.map(K=>i.$5J.fromExtHostTestItem(K,O).toString())??[],U,M)}static fromInternal(O,M){return new p(O.controllerId,O.runId,O.testIds,O.excludeExtIds,!0,M)}constructor(O,M,j,U,K,ue){this.controllerId=O,this.id=M,this.isPersisted=K,this.colllection=ue,this.c=j.map(X=>X+"\0"),this.f=U.map(X=>X+"\0")}isIncluded(O){const M=i.$5J.fromExtHostTestItem(O,this.controllerId).toString()+"\0";for(const j of this.f)if(M===j||M.startsWith(j))return!1;for(const j of this.c)if(M===j||M.startsWith(j))return!0;return!1}}e.$Aic=p;class I{constructor(O){this.provider=O}async provideFileCoverage(O){this.c||(this.c=(async()=>this.provider.provideFileCoverage(O))());try{return(await this.c)?.map(g.TestCoverage.fromFile)??[]}catch(M){throw this.c=void 0,M}}async resolveFileCoverage(O,M){const j=await this.c;let U=j?.[O];return!this.provider||!j||!U?[]:(U.detailedCoverage||(U=j[O]=await this.provider.resolveFileCoverage?.(U,M)??U),U.detailedCoverage?.map(g.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(O){this.j=O,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(O){this.c.add(O)}update(O){Object.assign(O.revived,g.TestItem.toPlain(O.item)),this.c.has(O)||this.f.add(O)}remove(O){if(this.c.has(O)){this.c.delete(O);return}this.f.delete(O);const M=i.$5J.parentId(O.item.extId);if(M&&this.h.has(M.toString())){this.h.add(O.item.extId);return}this.g.add(O)}getChangeEvent(){const{c:O,f:M,g:j}=this;return{get added(){return[...O].map(U=>U.revived)},get updated(){return[...M].map(U=>U.revived)},get removed(){return[...j].map(U=>U.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class m extends n.$aK{constructor(){super(...arguments),this.s=new P.$Vd,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(O){return this.f.get(O)}getMirroredTestDataByReference(O){return this.f.get(O.id)}w(O,M){return{...O,revived:g.TestItem.toPlain(O.item),depth:M?M.depth+1:0,children:new Set}}v(){return new b(this.s)}}class y{constructor(O){this.f=O}checkout(){this.c||(this.c=this.g());const O=this.c;return O.observers++,{onDidChangeTest:O.tests.onDidChangeTests,get tests(){return[...O.tests.rootTests].map(M=>M.revived)},dispose:(0,R.$db)(()=>{--O.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(O){return this.c?.tests.getMirroredTestDataByReference(O)}applyDiff(O){this.c?.tests.apply(O)}g(){const O=new m({asCanonicalUri:M=>M});return this.f.$subscribeToDiffs(),{observers:0,tests:O}}}const L=(T,O,M,j)=>{M?Object.assign(M,j):O.$updateTestRunConfig(T.controllerId,T.profileId,j)};class F{#e;#t;#i;#o;#n;#r;get label(){return this.f}set label(O){O!==this.f&&(this.f=O,L(this,this.#e,this.#n,{label:O}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(O){O!==this.g&&(this.g=O,L(this,this.#e,this.#n,{supportsContinuousRun:O}))}get isDefault(){return this.#i.has(this.profileId)}set isDefault(O){O!==this.isDefault&&(O?this.#i.add(this.profileId):this.#i.delete(this.profileId),L(this,this.#e,this.#n,{isDefault:O}))}get tag(){return this._tag}set tag(O){O?.id!==this._tag?.id&&(this._tag=O,L(this,this.#e,this.#n,{tag:O?g.TestTag.namespace(this.controllerId,O.id):null}))}get configureHandler(){return this.c}set configureHandler(O){O!==this.c&&(this.c=O,L(this,this.#e,this.#n,{hasConfigurationHandler:!!O}))}get onDidChangeDefault(){return(0,a.$GF)(this.#t,"testingActiveProfile"),P.Event.chain(this.#o,O=>O.map(M=>M.get(this.controllerId)?.get(this.profileId)).filter(A.$Qf))}constructor(O,M,j,U,K,ue,X,Q,Z,le,re=!1,$e=void 0,oe=!1){this.controllerId=ue,this.profileId=X,this.f=Q,this.kind=Z,this.runHandler=le,this._tag=$e,this.g=oe,this.#e=O,this.#r=M,this.#t=j,this.#i=U,this.#o=K,M.set(X,this);const J=z[Z];if(typeof J!="number")throw new Error(`Unknown TestRunProfile.group ${Z}`);re&&U.add(X),this.#n={profileId:X,controllerId:ue,tag:$e?g.TestTag.namespace(this.controllerId,$e.id):null,label:Q,group:J,isDefault:re,hasConfigurationHandler:!1,supportsContinuousRun:oe},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#r?.delete(this.profileId)&&(this.#r=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$Bic=F;const z={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(ke[151],Se([1,0,61,14,121,15,7]),function(ge,e,C,N,f,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oN=e.$nN=e.$mN=void 0;class v{static{this.c=new f.$kN("TextEditorDecorationType")}constructor(w,E,S){const c=v.c.nextId();w.$registerTextEditorDecorationType(E.identifier,c,P.DecorationRenderOptions.from(S)),this.value=Object.freeze({key:c,dispose(){w.$removeTextEditorDecorationType(c)}})}}e.$mN=v;class ${constructor(w,E){this.g=[],this.h=void 0,this.j=!1,this.c=w,this.d=w.version,this.e=E.undoStopBefore,this.f=E.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(w,E){this.k();let S=null;if(w instanceof R.$dL)S=new R.$eL(w,w);else if(w instanceof R.$eL)S=w;else throw new Error("Unrecognized location");this.l(S,E,!1)}insert(w,E){this.k(),this.l(new R.$eL(w,w),E,!0)}delete(w){this.k();let E=null;if(w instanceof R.$eL)E=w;else throw new Error("Unrecognized location");this.l(E,null,!0)}l(w,E,S){const c=this.c.validateRange(w);this.g.push({range:c,text:E,forceMoveMarkers:S})}setEndOfLine(w){if(this.k(),w!==R.EndOfLine.LF&&w!==R.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=w}}class k{constructor(w,E,S,c){this.c=w,this.d=E,this._accept(S),this.e=c;const g=this;this.value={get tabSize(){return g.f},set tabSize(o){g.n(o)},get indentSize(){return g.g},set indentSize(o){g.p(o)},get insertSpaces(){return g.j},set insertSpaces(o){g.s(o)},get cursorStyle(){return g.k},set cursorStyle(o){g.t(o)},get lineNumbers(){return g.l},set lineNumbers(o){g.u(o)}}}_accept(w){this.f=w.tabSize,this.g=w.indentSize,this.h=w.originalIndentSize,this.j=w.insertSpaces,this.k=w.cursorStyle,this.l=P.TextEditorLineNumbersStyle.to(w.lineNumbers)}m(w){if(w==="auto")return"auto";if(typeof w=="number"){const E=Math.floor(w);return E>0?E:null}if(typeof w=="string"){const E=parseInt(w,10);return isNaN(E)?null:E>0?E:null}return null}n(w){const E=this.m(w);if(E!==null){if(typeof E=="number"){if(this.f===E)return;this.f=E}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:E}))}}o(w){if(w==="tabSize")return"tabSize";if(typeof w=="number"){const E=Math.floor(w);return E>0?E:null}if(typeof w=="string"){const E=parseInt(w,10);return isNaN(E)?null:E>0?E:null}return null}p(w){const E=this.o(w);if(E!==null){if(typeof E=="number"){if(this.h===E)return;this.g=E,this.h=E}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:E}))}}q(w){return w==="auto"?"auto":w==="false"?!1:!!w}s(w){const E=this.q(w);if(typeof E=="boolean"){if(this.j===E)return;this.j=E}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:E}))}t(w){this.k!==w&&(this.k=w,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:w})))}u(w){this.l!==w&&(this.l=w,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:P.TextEditorLineNumbersStyle.from(w)})))}assign(w){const E={};let S=!1;if(typeof w.tabSize<"u"){const c=this.m(w.tabSize);c==="auto"?(S=!0,E.tabSize=c):typeof c=="number"&&this.f!==c&&(this.f=c,S=!0,E.tabSize=c)}if(typeof w.indentSize<"u"){const c=this.o(w.indentSize);c==="tabSize"?(S=!0,E.indentSize=c):typeof c=="number"&&this.h!==c&&(this.g=c,this.h=c,S=!0,E.indentSize=c)}if(typeof w.insertSpaces<"u"){const c=this.q(w.insertSpaces);c==="auto"?(S=!0,E.insertSpaces=c):this.j!==c&&(this.j=c,S=!0,E.insertSpaces=c)}typeof w.cursorStyle<"u"&&this.k!==w.cursorStyle&&(this.k=w.cursorStyle,S=!0,E.cursorStyle=w.cursorStyle),typeof w.lineNumbers<"u"&&this.l!==w.lineNumbers&&(this.l=w.lineNumbers,S=!0,E.lineNumbers=P.TextEditorLineNumbersStyle.from(w.lineNumbers)),S&&this.v("setOptions",this.c.$trySetOptions(this.d,E))}v(w,E){E.catch(S=>{this.e.warn(`ExtHostTextEditorOptions '${w}' failed:'`),this.e.warn(S)})}}e.$nN=k;class A{constructor(w,E,S,c,g,o,i,r){this.id=w,this.j=E,this.k=S,this.g=!1,this.h=new Set,this.c=g,this.d=new k(this.j,this.id,o,S),this.e=i,this.f=r;const n=this;this.value=Object.freeze({get document(){return c.value},set document(a){throw new N.$9("document")},get selection(){return n.c&&n.c[0]},set selection(a){if(!(a instanceof R.$fL))throw(0,N.$7)("selection");n.c=[a],n.l()},get selections(){return n.c},set selections(a){if(!Array.isArray(a)||a.some(t=>!(t instanceof R.$fL)))throw(0,N.$7)("selections");n.c=a,n.l()},get visibleRanges(){return n.e},set visibleRanges(a){throw new N.$9("visibleRanges")},get options(){return n.d.value},set options(a){n.g||n.d.assign(a)},get viewColumn(){return n.f},set viewColumn(a){throw new N.$9("viewColumn")},edit(a,t={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const h=new $(c.value,t);return a(h),n.m(h)},insertSnippet(a,t,h={undoStopBefore:!0,undoStopAfter:!0}){if(n.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let s;if(!t||Array.isArray(t)&&t.length===0)s=n.c.map(d=>P.Range.from(d));else if(t instanceof R.$dL){const{lineNumber:d,column:u}=P.Position.from(t);s=[{startLineNumber:d,startColumn:u,endLineNumber:d,endColumn:u}]}else if(t instanceof R.$eL)s=[P.Range.from(t)];else{s=[];for(const d of t)if(d instanceof R.$eL)s.push(P.Range.from(d));else{const{lineNumber:u,column:l}=P.Position.from(d);s.push({startLineNumber:u,startColumn:l,endLineNumber:u,endColumn:l})}}return E.$tryInsertSnippet(w,c.value.version,a.value,s,h)},setDecorations(a,t){const h=t.length===0;h&&!n.h.has(a.key)||(h?n.h.delete(a.key):n.h.add(a.key),n.n(()=>{if(P.$cN(t))return E.$trySetDecorations(w,a.key,P.$dN(t));{const s=new Array(4*t.length);for(let d=0,u=t.length;d<u;d++){const l=t[d];s[4*d]=l.start.line+1,s[4*d+1]=l.start.character+1,s[4*d+2]=l.end.line+1,s[4*d+3]=l.end.character+1}return E.$trySetDecorationsFast(w,a.key,s)}}))},revealRange(a,t){n.n(()=>E.$tryRevealRange(w,P.Range.from(a),t||R.TextEditorRevealType.Default))},show(a){E.$tryShowEditor(w,P.ViewColumn.from(a))},hide(){E.$tryHideEditor(w)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(w){(0,C.ok)(!this.g),this.d._accept(w)}_acceptVisibleRanges(w){(0,C.ok)(!this.g),this.e=w}_acceptViewColumn(w){(0,C.ok)(!this.g),this.f=w}_acceptSelections(w){(0,C.ok)(!this.g),this.c=w}async l(){const w=this.c.map(P.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,w)),this.value}m(w){const E=w.finalize();if(E.edits.length===0&&!E.setEndOfLine)return Promise.resolve(!0);const S=E.edits.map(g=>g.range);S.sort((g,o)=>g.end.line===o.end.line?g.end.character===o.end.character?g.start.line===o.start.line?g.start.character-o.start.character:g.start.line-o.start.line:g.end.character-o.end.character:g.end.line-o.end.line);for(let g=0,o=S.length-1;g<o;g++){const i=S[g].end;if(S[g+1].start.isBefore(i))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const c=E.edits.map(g=>({range:P.Range.from(g.range),text:g.text,forceMoveMarkers:g.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,E.documentVersionId,c,{setEndOfLine:typeof E.setEndOfLine=="number"?P.EndOfLine.from(E.setEndOfLine):void 0,undoStopBefore:E.undoStopBefore,undoStopAfter:E.undoStopAfter})}n(w){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):w().then(()=>this,E=>(E instanceof Error&&E.name==="DISPOSED"||this.k.warn(E),null))}}e.$oN=A}),define(ke[72],Se([1,0,61,4,3,2,5,6,148,20,151,15,13,28,16,53,43]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qN=e.$pN=void 0;class o{constructor(n){this.value=n,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let i=class{constructor(n,a){this.h=n,this.i=a,this.a=null,this.b=new Map,this.c=new E.$Ac,this.d=new N.$Vd,this.e=new N.$Vd,this.f=new N.$Vd,this.g=new N.$Vd,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(n){this.acceptDocumentsAndEditorsDelta(n)}acceptDocumentsAndEditorsDelta(n){const a=[],t=[],h=[];if(n.removedDocuments)for(const s of n.removedDocuments){const d=P.URI.revive(s),u=this.c.get(d);u?.unref()&&(this.c.delete(d),a.push(u.value))}if(n.addedDocuments)for(const s of n.addedDocuments){const d=P.URI.revive(s.uri);let u=this.c.get(d);if(u&&d.scheme!==S.Schemas.vscodeNotebookCell&&d.scheme!==S.Schemas.vscodeInteractiveInput)throw new Error(`document '${d} already exists!'`);u||(u=new o(new $.$iN(this.h.getProxy(v.$aL.MainThreadDocuments),d,s.lines,s.EOL,s.versionId,s.languageId,s.isDirty,s.notebook)),this.c.set(d,u),t.push(u.value)),u.ref()}if(n.removedEditors)for(const s of n.removedEditors){const d=this.b.get(s);this.b.delete(s),d&&h.push(d)}if(n.addedEditors)for(const s of n.addedEditors){const d=P.URI.revive(s.documentUri);C.ok(this.c.has(d),`document '${d}' does not exist`),C.ok(!this.b.has(s.id),`editor '${s.id}' already exists!`);const u=this.c.get(d).value,l=new A.$oN(s.id,this.h.getProxy(v.$aL.MainThreadTextEditors),this.i,new g.$V(()=>u.document),s.selections.map(D.Selection.to),s.options,s.visibleRanges.map(p=>D.Range.to(p)),typeof s.editorPosition=="number"?D.ViewColumn.to(s.editorPosition):void 0);this.b.set(s.id,l)}n.newActiveEditor!==void 0&&(C.ok(n.newActiveEditor===null||this.b.has(n.newActiveEditor),`active editor '${n.newActiveEditor}' does not exist`),this.a=n.newActiveEditor),(0,f.$Oc)(a),(0,f.$Oc)(h),n.removedDocuments&&this.e.fire(a),n.addedDocuments&&this.d.fire(t),(n.removedEditors||n.addedEditors)&&this.f.fire(this.allEditors().map(s=>s.value)),n.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(n){return this.c.get(n)?.value}allDocuments(){return c.Iterable.map(this.c.values(),n=>n.value)}getEditor(n){return this.b.get(n)}activeEditor(n){if(!this.a)return;const a=this.b.get(this.a);return n?a:a?.value}allEditors(){return[...this.b.values()]}};e.$pN=i,e.$pN=i=Ge([We(0,k.$fN),We(1,w.$nj)],i),e.$qN=(0,R.$6h)("IExtHostDocumentsAndEditors")}),define(ke[346],Se([1,0,19,4,6,151,15,7]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xgc=void 0;class ${constructor(A,D){this.i=D,this.a=new N.$Vd,this.b=new N.$Vd,this.c=new N.$Vd,this.d=new N.$Vd,this.f=new N.$Vd,this.g=new N.$Vd,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=A.getProxy(f.$aL.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(w=>this.g.fire(w)),this.i.onDidChangeActiveTextEditor(w=>this.f.fire(w))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(A){const D=this.i.allEditors();return A?D:D.map(w=>w.value)}async showTextDocument(A,D,w){let E;typeof D=="number"?E={position:R.ViewColumn.from(D),preserveFocus:w}:typeof D=="object"?E={position:R.ViewColumn.from(D.viewColumn),preserveFocus:D.preserveFocus,selection:typeof D.selection=="object"?R.Range.from(D.selection):void 0,pinned:typeof D.preview=="boolean"?!D.preview:void 0}:E={preserveFocus:!1};const S=await this.h.$tryShowTextDocument(A.uri,E),c=S&&this.i.getEditor(S);if(c)return c.value;throw S?new Error(`Could NOT open editor for "${A.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${A.uri.toString()}".`)}createTextEditorDecorationType(A,D){return new P.$mN(this.h,A,D).value}$acceptEditorPropertiesChanged(A,D){const w=this.i.getEditor(A);if(!w)throw new Error("unknown text editor");if(D.options&&w._acceptOptions(D.options),D.selections){const E=D.selections.selections.map(R.Selection.to);w._acceptSelections(E)}if(D.visibleRanges){const E=C.$Hb(D.visibleRanges.map(R.Range.to));w._acceptVisibleRanges(E)}if(D.options&&this.b.fire({textEditor:w.value,options:{...D.options,lineNumbers:R.TextEditorLineNumbersStyle.to(D.options.lineNumbers)}}),D.selections){const E=v.TextEditorSelectionChangeKind.fromValue(D.selections.source),S=D.selections.selections.map(R.Selection.to);this.a.fire({textEditor:w.value,selections:S,kind:E})}if(D.visibleRanges){const E=C.$Hb(D.visibleRanges.map(R.Range.to));this.c.fire({textEditor:w.value,visibleRanges:E})}}$acceptEditorPositionData(A){for(const D in A){const w=this.i.getEditor(D);if(!w)throw new Error("Unknown text editor");const E=R.ViewColumn.to(A[D]);w.value.viewColumn!==E&&(w._acceptViewColumn(E),this.d.fire({textEditor:w.value,viewColumn:E}))}}getDiffInformation(A){return Promise.resolve(this.h.$getDiffInformation(A))}}e.$Xgc=$}),define(ke[347],Se([1,0,2,5,6,3,7,15,25,18]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eic=e.$Dic=void 0,e.$Dic=(0,N.$6h)("IExtHostTimeline");class A{constructor(E,S){this.b=new Map,this.c=new Map,this.a=E.getProxy(f.$aL.MainThreadTimeline),S.registerArgumentProcessor({processArgument:(c,g)=>{if(c&&c.$mid===12)if(this.b.get(c.source)&&$.$lm.equals(g,this.b.get(c.source)?.extension)){const o=c.uri===void 0?void 0:C.URI.revive(c.uri);return this.c.get(c.source)?.get(D(o))?.get(c.handle)}else return;return c}})}async $getTimeline(E,S,c,g){return this.b.get(E)?.provider.provideTimeline(C.URI.revive(S),c,g)}registerTimelineProvider(E,S,c,g){const o=new P.$Sc,i=this.d(S.id,g,o).bind(this);let r;S.onDidChange&&(r=S.onDidChange(a=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...a,id:S.id}),this));const n=this.c;return this.f({...S,scheme:E,onDidChange:void 0,async provideTimeline(a,t,h){t?.resetCache&&(o.clear(),n.get(S.id)?.clear());const s=await S.provideTimeline(a,t,h);if(s==null)return;const d=i(a,t);return{...s,source:S.id,items:s.items.map(d)}},dispose(){for(const a of n.values())a.get(S.id)?.clear();r?.dispose(),o.dispose()}},c)}d(E,S,c){return(g,o)=>{let i;if(o?.cacheResults){let r=this.c.get(E);r===void 0&&(r=new Map,this.c.set(E,r));const n=D(g);i=r.get(n),i===void 0&&(i=new Map,r.set(n,i))}return r=>{const{iconPath:n,...a}=r,t=`${E}|${r.id??r.timestamp}`;i?.set(t,r);let h,s,d;r.iconPath&&(n instanceof R.$0L?d={id:n.id,color:n.color}:C.URI.isUri(n)?(h=n,s=n):{light:h,dark:s}=n);let u;return R.$DL.isMarkdownString(a.tooltip)?u=v.MarkdownString.from(a.tooltip):(0,k.$If)(a.tooltip)?u=a.tooltip:R.$DL.isMarkdownString(a.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=v.MarkdownString.from(a.detail)):(0,k.$If)(a.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),u=a.detail),{...a,id:a.id??void 0,handle:t,source:E,command:r.command?S.toInternal(r.command,c):void 0,icon:h,iconDark:s,themeIcon:d,tooltip:u,accessibilityInformation:r.accessibilityInformation}}}}f(E,S){if(this.b.get(E.id))throw new Error(`Timeline Provider ${E.id} already exists.`);return this.a.$registerTimelineProvider({id:E.id,label:E.label,scheme:E.scheme}),this.b.set(E.id,{provider:E,extension:S}),(0,P.$Rc)(()=>{for(const g of this.c.values())g.get(E.id)?.clear();this.b.delete(E.id),this.a.$unregisterTimelineProvider(E.id),E.dispose()})}}e.$Eic=A;function D(w){return w?.toString()}}),define(ke[348],Se([1,0,219,23,2,4,3,278,11,7,18,19,15,80,21,177,26]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fic=void 0;function o(n,a){if((0,A.$If)(n))return{label:n};if(n&&typeof n=="object"&&typeof n.label=="string"){let t;return Array.isArray(n.highlights)&&(t=n.highlights.filter(h=>h.length===2&&typeof h[0]=="number"&&typeof h[1]=="number"),t=t.length?t:void 0),{label:n.label,highlights:t}}}class i extends R.$Tc{constructor(a,t,h){super(),this.f=a,this.g=t,this.h=h,this.a=new Map,this.b=new c.$s8;function s(d){return d&&d.$treeViewId&&(d.$treeItemHandle||d.$selectedTreeItems||d.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:d=>s(d)?this.r(d):Array.isArray(d)&&d.length>0?d.map(u=>s(u)?this.r(u):u):d})}registerTreeDataProvider(a,t,h){const s=this.createTreeView(a,{treeDataProvider:t},h);return{dispose:()=>s.dispose()}}createTreeView(a,t,h){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const s=t.dragAndDropController?.dropMimeTypes??[],d=t.dragAndDropController?.dragMimeTypes??[],u=!!t.dragAndDropController?.handleDrag,l=!!t.dragAndDropController?.handleDrop,p=this.m(a,t,h),I={showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:s,dragMimeTypes:d,hasHandleDrag:u,hasHandleDrop:l,manuallyManageCheckboxes:!!t.manageCheckboxStateManually},b=this.f.$registerTreeViewDataProvider(a,I),m={get onDidCollapseElement(){return p.onDidCollapseElement},get onDidExpandElement(){return p.onDidExpandElement},get selection(){return p.selectedElements},get onDidChangeSelection(){return p.onDidChangeSelection},get activeItem(){return(0,g.$GF)(h,"treeViewActiveItem"),p.focusedElement},get onDidChangeActiveItem(){return(0,g.$GF)(h,"treeViewActiveItem"),p.onDidChangeActiveItem},get visible(){return p.visible},get onDidChangeVisibility(){return p.onDidChangeVisibility},get onDidChangeCheckboxState(){return p.onDidChangeCheckboxState},get message(){return p.message},set message(y){(0,E.$jk)(y)&&(0,g.$GF)(h,"treeViewMarkdownMessage"),p.message=y},get title(){return p.title},set title(y){p.title=y},get description(){return p.description},set description(y){p.description=y},get badge(){return p.badge},set badge(y){y!==void 0&&k.ViewBadge.isViewBadge(y)?p.badge={value:Math.floor(Math.abs(y.value)),tooltip:y.tooltip}:y===void 0&&(p.badge=void 0)},reveal:(y,L)=>p.reveal(y,L),dispose:async()=>{await b,this.a.delete(a),p.dispose()}};return this.B(m),m}$getChildren(a,t){const h=this.a.get(a);return h?h.getChildren(t):Promise.reject(new v.$aF(a))}async $handleDrop(a,t,h,s,d,u,l,p){const I=this.a.get(a);if(!I)return Promise.reject(new v.$aF(a));const b=w.DataTransfer.toDataTransfer(h,async m=>(await this.f.$resolveDropFileData(a,t,m)).buffer);return l===a&&p&&await this.j(b,I,p,d,u),I.onDrop(b,s,d)}async j(a,t,h,s,d){const u=this.b.removeDragOperationTransfer(d);if(u)(await u)?.forEach((l,p)=>{l&&a.set(p,l)});else if(d&&t.handleDrag){const l=t.handleDrag(h,a,s);this.b.addDragOperationTransfer(d,l),await l}return a}async $handleDrag(a,t,h,s){const d=this.a.get(a);if(!d)return Promise.reject(new v.$aF(a));const u=await this.j(new k.$7L,d,t,s,h);if(!(!u||s.isCancellationRequested))return w.DataTransfer.from(u)}async $hasResolve(a){const t=this.a.get(a);if(!t)throw new v.$aF(a);return t.hasResolve}$resolve(a,t,h){const s=this.a.get(a);if(!s)throw new v.$aF(a);return s.resolveTreeItem(t,h)}$setExpanded(a,t,h){const s=this.a.get(a);if(!s)throw new v.$aF(a);s.setExpanded(t,h)}$setSelectionAndFocus(a,t,h){const s=this.a.get(a);if(!s)throw new v.$aF(a);s.setSelectionAndFocus(t,h)}$setVisible(a,t){const h=this.a.get(a);if(!h){if(!t)return;throw new v.$aF(a)}h.setVisible(t)}$changeCheckboxState(a,t){const h=this.a.get(a);if(!h)throw new v.$aF(a);h.setCheckboxState(t)}m(a,t,h){const s=this.B(new r(a,t,this.f,this.g.converter,this.h,h));return this.a.set(a,s),s}r(a){const t=this.a.get(a.$treeViewId);return t&&"$treeItemHandle"in a?t.getExtensionElement(a.$treeItemHandle):t&&"$focusedTreeItem"in a&&a.$focusedTreeItem?t.focusedElement:null}}e.$Fic=i;class r extends R.$Tc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(a=>this.getExtensionElement(a)).filter(a=>!(0,A.$Rf)(a))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(a,t,h,s,d,u){if(super(),this.I=a,this.J=h,this.L=s,this.M=d,this.N=u,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new P.$Vd),this.onDidExpandElement=this.u.event,this.w=this.B(new P.$Vd),this.onDidCollapseElement=this.w.event,this.y=this.B(new P.$Vd),this.onDidChangeSelection=this.y.event,this.z=this.B(new P.$Vd),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new P.$Vd),this.onDidChangeVisibility=this.C.event,this.D=this.B(new P.$Vd),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new P.$Vd),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new S.$6d,u.contributes&&u.contributes.views)for(const b in u.contributes.views)for(const m of u.contributes.views[b])m.id===a&&(this.P=m.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(b=>this.F.fire({message:!1,element:b})));let l,p;const I=P.Event.debounce(this.F.event,(b,m)=>(b||(b={message:!1,elements:[]}),m.element!==!1&&(l||(l=new Promise(y=>p=y),this.G=this.G.then(()=>l)),Array.isArray(m.element)?b.elements.push(...m.element):b.elements.push(m.element)),m.message&&(b.message=!0),b),200,!0);this.B(I(({message:b,elements:m})=>{m.length&&(this.H=this.H.then(()=>{const y=p;return l=null,this.$(m).then(()=>y())})),b&&this.J.$setMessage(this.I,w.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(a){const t=a?this.getExtensionElement(a):void 0;if(a&&!t)return this.M.error(`No tree item with id '${a}' found.`),Promise.resolve([]);let h=this.X(a);return h||(h=await this.Y(t)),h?h.map(s=>s.item):void 0}getExtensionElement(a){return this.j.get(a)}reveal(a,t){t=t||{select:!0,focus:!1};const h=(0,A.$Rf)(t.select)?!0:t.select,s=(0,A.$Rf)(t.focus)?!1:t.focus,d=(0,A.$Rf)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):a?this.G.then(()=>this.S(a)).then(u=>this.W(a,u[u.length-1]).then(l=>this.J.$reveal(this.I,{item:l.item,parentChain:u.map(p=>p.item)},{select:h,focus:s,expand:d})),u=>this.M.error(u)):this.J.$reveal(this.I,void 0,{select:h,focus:s,expand:d})}get message(){return this.O}set message(a){this.O=a,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(a){this.P=a,this.J.$setTitle(this.I,a,this.Q)}get description(){return this.Q}set description(a){this.Q=a,this.J.$setTitle(this.I,this.P,a)}get badge(){return this.R}set badge(a){this.R?.value===a?.value&&this.R?.tooltip===a?.tooltip||(this.R=w.ViewBadge.from(a),this.J.$setBadge(this.I,a))}setExpanded(a,t){const h=this.getExtensionElement(a);h&&(t?this.u.fire(Object.freeze({element:h})):this.w.fire(Object.freeze({element:h})))}setSelectionAndFocus(a,t){const h=!(0,D.$ub)(this.s,a);this.s=a;const s=this.t!==t;this.t=t,h&&this.y.fire(Object.freeze({selection:this.selectedElements})),s&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(a){a!==this.r&&(this.r=a,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(a){const t=(await Promise.all(a.map(async h=>{const s=this.getExtensionElement(h.treeItemHandle);return s?{extensionItem:s,treeItem:await this.f.getTreeItem(s),newState:h.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(h=>h!==void 0);t.forEach(h=>{h.treeItem.checkboxState=h.newState?k.TreeItemCheckboxState.Checked:k.TreeItemCheckboxState.Unchecked}),this.D.fire({items:t.map(h=>[h.extensionItem,h.newState])})}async handleDrag(a,t,h){const s=[];for(const d of a){const u=this.getExtensionElement(d);u&&s.push(u)}if(!(!this.g?.handleDrag||s.length===0))return await this.g.handleDrag(s,t,h),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(a,t,h){const s=t?this.getExtensionElement(t):void 0;if(!(!s&&t||!this.g?.handleDrop))return(0,$.$Yg)(()=>this.g?.handleDrop?this.g.handleDrop(s,a,h):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(a,t){if(!this.f.resolveTreeItem)return;const h=this.j.get(a);if(h){const s=this.m.get(h);if(s){const d=await this.f.resolveTreeItem(s.extensionItem,h,t)??s.extensionItem;return this.hb(d),s.item.tooltip=this.eb(d.tooltip),s.item.command=this.fb(s.disposableStore,d.command),s.item}}}S(a){return this.U(a).then(t=>t?this.S(t).then(h=>this.W(t,h[h.length-1]).then(s=>(h.push(s),h))):Promise.resolve([]))}U(a){const t=this.m.get(a);return t?Promise.resolve(t.parent?this.j.get(t.parent.item.handle):void 0):(0,$.$Yg)(()=>this.f.getParent(a))}W(a,t){const h=this.m.get(a);return h?Promise.resolve(h):(0,$.$Yg)(()=>this.f.getTreeItem(a)).then(s=>this.kb(a,s,t,!0)).then(s=>this.getChildren(t?t.item.handle:void 0).then(()=>{const d=this.getExtensionElement(s);if(d){const u=this.m.get(d);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${s} from extension ${this.N.identifier.value}`)}))}X(a){if(a){let t;if(typeof a=="string"){const h=this.getExtensionElement(a);t=h?this.m.get(h):void 0}else t=a;return t&&t.children||void 0}return this.h}async Y(a){this.rb(a);const t=new S.$6d(this.Z.token);try{const h=a?this.m.get(a):void 0,s=await this.f.getChildren(a);if(t.token.isCancellationRequested)return;const d=(0,D.$Hb)(s||[]),u=await Promise.all((0,D.$Hb)(d).map(p=>this.f.getTreeItem(p)));if(t.token.isCancellationRequested)return;const l=u.map((p,I)=>p?this.db(d[I],p,h):null);return(0,D.$Hb)(l)}finally{t.dispose()}}$(a){if(a.some(h=>!h))return this.Z.dispose(!0),this.Z=new S.$6d,this.tb(),this.J.$refresh(this.I);{const h=this.ab(a);if(h.length)return this.bb(h)}return Promise.resolve(void 0)}ab(a){const t=new Set,h=a.map(d=>this.m.get(d));for(const d of h)if(d&&!t.has(d.item.handle)){let u=d;for(;u&&u.parent&&h.findIndex(l=>u&&u.parent&&l&&l.item.handle===u.parent.item.handle)===-1;){const l=this.j.get(u.parent.item.handle);u=l?this.m.get(l):void 0}u&&!u.parent&&t.add(d.item.handle)}const s=[];return t.forEach(d=>{const u=this.j.get(d);if(u){const l=this.m.get(u);l&&(!l.parent||!t.has(l.parent.item.handle))&&s.push(d)}}),s}bb(a){const t={};return Promise.all(a.map(h=>this.cb(h).then(s=>{s&&(t[h]=s.item)}))).then(()=>Object.keys(t).length?this.J.$refresh(this.I,t):void 0)}cb(a){const t=this.getExtensionElement(a);if(t){const h=this.m.get(t);if(h)return this.rb(t),(0,$.$Yg)(()=>this.f.getTreeItem(t)).then(s=>{if(s){const d=this.ib(t,s,h.parent);return this.pb(t,d,h,h.parent),h.dispose(),d}return null})}return Promise.resolve(null)}db(a,t,h){const s=this.ib(a,t,h);if(t.id&&this.j.has(s.item.handle))throw new Error((0,C.localize)(0,null,t.id));return this.ob(a,s),this.qb(s,h),s}eb(a){return k.$DL.isMarkdownString(a)?w.MarkdownString.from(a):a}fb(a,t){return t?{...this.L.toInternal(t,a),originalId:t.command}:void 0}gb(a){if(a.checkboxState===void 0)return;let t,h,s;return typeof a.checkboxState=="number"?t=a.checkboxState:(t=a.checkboxState.state,h=a.checkboxState.tooltip,s=a.checkboxState.accessibilityInformation),{isChecked:t===k.TreeItemCheckboxState.Checked,tooltip:h,accessibilityInformation:s}}hb(a){if(!k.$2L.isTreeItem(a,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(a,t,h){this.hb(t);const s=this.B(new R.$Sc),d=this.kb(a,t,h),u=this.lb(t);return{item:{handle:d,parentHandle:h?h.item.handle:void 0,label:o(t.label,this.N),description:t.description,resourceUri:t.resourceUri,tooltip:this.eb(t.tooltip),command:this.fb(s,t.command),contextValue:t.contextValue,icon:u,iconDark:this.mb(t)||u,themeIcon:this.jb(t),collapsibleState:(0,A.$Rf)(t.collapsibleState)?k.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.gb(t)},extensionItem:t,parent:h,children:void 0,disposableStore:s,dispose(){s.dispose()}}}jb(a){return a.iconPath instanceof k.$0L?a.iconPath:void 0}kb(a,{id:t,label:h,resourceUri:s},d,u){if(t)return`${r.b}/${t}`;const l=o(h,this.N),p=d?d.item.handle:r.a;let I=l?l.label:s?(0,N.$Eg)(s):"";I=I.indexOf("/")!==-1?I.replace("/","//"):I;const b=this.m.has(a)?this.m.get(a).item.handle:void 0,m=this.X(d)||[];let y,L=0;do{if(y=`${p}/${L}:${I}`,u||!this.j.has(y)||b===y)break;L++}while(L<=m.length);return y}lb(a){if(a.iconPath&&!(a.iconPath instanceof k.$0L))return typeof a.iconPath=="string"||f.URI.isUri(a.iconPath)?this.nb(a.iconPath):this.nb(a.iconPath.light)}mb(a){if(a.iconPath&&!(a.iconPath instanceof k.$0L)&&a.iconPath.dark)return this.nb(a.iconPath.dark)}nb(a){return f.URI.isUri(a)?a:f.URI.file(a)}ob(a,t){this.j.set(t.item.handle,a),this.m.set(a,t)}pb(a,t,h,s){this.j.delete(t.item.handle),this.m.delete(a),t.item.handle!==h.item.handle&&this.j.delete(h.item.handle),this.ob(a,t);const d=this.X(s)||[],u=d.filter(l=>l.item.handle===h.item.handle)[0];u&&d.splice(d.indexOf(u),1,t)}qb(a,t){t?(t.children||(t.children=[]),t.children.push(a)):(this.h||(this.h=[]),this.h.push(a))}rb(a){if(a){const t=this.m.get(a);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}t.children=void 0}}else this.tb()}sb(a){const t=this.m.get(a);if(t){if(t.children)for(const h of t.children){const s=this.j.get(h.item.handle);s&&this.sb(s)}this.m.delete(a),this.j.delete(t.item.handle),t.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(a=>a.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(ke[349],Se([1,0,4,3,2,30,15,93,6,7]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ehc=void 0;class A extends N.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;#u;#l;#d;#h;constructor(S,c,g,o){super(),this.#s=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$Vd),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$Vd),this.onDidChangeViewState=this.#h.event,this.#e=S,this.#t=c,this.#o=g,this.#i=o.viewType,this.#n=o.panelOptions,this.#s=o.viewColumn,this.#r=o.title,this.#u=o.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#o.dispose(),super.dispose())}get webview(){return this.c(),this.#o}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(S){this.c(),this.#r!==S&&(this.#r=S,this.#t.$setTitle(this.#e,S))}get iconPath(){return this.c(),this.#a}set iconPath(S){this.c(),this.#a!==S&&(this.#a=S,this.#t.$setIconPath(this.#e,f.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return this.#n}get viewColumn(){if(this.c(),!(typeof this.#s=="number"&&this.#s<0))return this.#s}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(S){this.#l||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(this.#u=S.active,this.#c=S.visible,this.#s=S.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(S,c){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof S>"u"?void 0:R.ViewColumn.from(S),preserveFocus:!!c})}c(){if(this.#l)throw new Error("Webview is disposed")}}class D extends N.$Tc{static c(){return(0,P.$qg)()}constructor(S,c,g){super(),this.j=c,this.m=g,this.g=new Map,this.h=new Map,this.f=S.getProxy($.$aL.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(S=>S.dispose()),this.g.clear()}createWebviewPanel(S,c,g,o,i={}){const r=typeof o=="object"?o.viewColumn:o,n={viewColumn:R.ViewColumn.from(r),preserveFocus:typeof o=="object"&&!!o.preserveFocus},a=(0,v.$ahc)(S),t=D.c();this.f.$createWebviewPanel((0,v.$chc)(S),t,c,{title:g,panelOptions:w(i),webviewOptions:(0,v.$dhc)(S,this.m,i),serializeBuffersForPostMessage:a},n);const h=this.j.createNewWebview(t,i,S);return this.createNewWebviewPanel(t,c,g,r,i,h,!0)}$onDidChangeWebviewPanelViewStates(S){const c=Object.keys(S);c.sort((g,o)=>{const i=S[g],r=S[o];return i.active?1:r.active?-1:+i.visible-+r.visible});for(const g of c){const o=this.getWebviewPanel(g);if(!o)continue;const i=S[g];o._updateViewState({active:i.active,visible:i.visible,viewColumn:R.ViewColumn.to(i.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.g.delete(S),this.j.deleteWebview(S)}registerWebviewPanelSerializer(S,c,g){if(this.h.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.h.set(c,{serializer:g,extension:S}),this.f.$registerSerializer(c,{serializeBuffersForPostMessage:(0,v.$ahc)(S)}),new k.$cL(()=>{this.h.delete(c),this.f.$unregisterSerializer(c)})}async $deserializeWebviewPanel(S,c,g,o){const i=this.h.get(c);if(!i)throw new Error(`No serializer found for '${c}'`);const{serializer:r,extension:n}=i,a=this.j.createNewWebview(S,g.webviewOptions,n),t=this.createNewWebviewPanel(S,c,g.title,o,g.panelOptions,a,g.active);await r.deserializeWebviewPanel(t,g.state)}createNewWebviewPanel(S,c,g,o,i,r,n){const a=new A(S,this.f,r,{viewType:c,title:g,viewColumn:o,panelOptions:i,active:n});return this.g.set(S,a),a}getWebviewPanel(S){return this.g.get(S)}}e.$ehc=D;function w(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}}),define(ke[350],Se([1,0,4,3,93,15,6,7]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iic=void 0;class $ extends N.$Tc{#e;#t;#i;#o;#n;#r;#a;#s;#c;constructor(D,w,E,S,c,g){super(),this.#n=!1,this.#u=this.B(new C.$Vd),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$Vd),this.onDidDispose=this.#l.event,this.#i=E,this.#a=S,this.#e=D,this.#t=w,this.#o=c,this.#r=g}dispose(){this.#n||(this.#n=!0,this.#l.fire(),this.#o.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(D){this.a(),this.#a!==D&&(this.#a=D,this.#t.$setWebviewViewTitle(this.#e,D))}get description(){return this.a(),this.#s}set description(D){this.a(),this.#s!==D&&(this.#s=D,this.#t.$setWebviewViewDescription(this.#e,D))}get visible(){return this.#r}get webview(){return this.#o}get viewType(){return this.#i}_setVisible(D){D===this.#r||this.#n||(this.#r=D,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(D){this.a(),!(D?.value===this.#c?.value&&D?.tooltip===this.#c?.tooltip)&&(this.#c=P.ViewBadge.from(D),this.#t.$setWebviewViewBadge(this.#e,D))}show(D){this.a(),this.#t.$show(this.#e,!!D)}a(){if(this.#n)throw new Error("Webview is disposed")}}class k{constructor(D,w){this.d=w,this.b=new Map,this.c=new Map,this.a=D.getProxy(R.$aL.MainThreadWebviewViews)}registerWebviewViewProvider(D,w,E,S){if(this.b.has(w))throw new Error(`View provider for '${w}' already registered`);return this.b.set(w,{provider:E,extension:D}),this.a.$registerWebviewViewProvider((0,f.$chc)(D),w,{retainContextWhenHidden:S?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,f.$ahc)(D)}),new v.$cL(()=>{this.b.delete(w),this.a.$unregisterWebviewViewProvider(w)})}async $resolveWebviewView(D,w,E,S,c){const g=this.b.get(w);if(!g)throw new Error(`No view provider found for '${w}'`);const{provider:o,extension:i}=g,r=this.d.createNewWebview(D,{},i),n=new $(D,this.a,w,E,r,!0);this.c.set(D,n),await o.resolveWebviewView(n,{state:S},c)}async $onDidChangeWebviewViewVisibility(D,w){this.e(D)._setVisible(w)}async $disposeWebviewView(D){const w=this.e(D);this.c.delete(D),w.dispose(),this.d.deleteWebview(D)}e(D){const w=this.c.get(D);if(!w)throw new Error("No webview found");return w}}e.$Iic=k}),define(ke[351],Se([1,0,69,16,13,249,32,10]),function(ge,e,C,N,f,P,R,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$njc=void 0;let $=class{constructor(D,w){D.addFileSystemProvider(N.Schemas.file,new k(w),{isCaseSensitive:v.$k})}};e.$njc=$,e.$njc=$=Ge([We(0,C.$9gc),We(1,f.$nj)],$);class k{constructor(D){this.b=D,this.a=new P.$Bq(this.b)}async stat(D){const w=await this.a.stat(D);return{type:w.type,ctime:w.ctime,mtime:w.mtime,size:w.size,permissions:w.permissions===R.FilePermission.Readonly?1:void 0}}readDirectory(D){return this.a.readdir(D)}createDirectory(D){return this.a.mkdir(D)}readFile(D){return this.a.readFile(D)}writeFile(D,w,E){return this.a.writeFile(D,w,{...E,unlock:!1,atomic:!1})}delete(D,w){return this.a.delete(D,{...w,useTrash:!1,atomic:!1})}rename(D,w,E){return this.a.rename(D,w,E)}copy(D,w,E){return this.a.copy(D,w,E)}get onDidChangeFile(){throw new Error("Method not implemented.")}watch(D,w){throw new Error("Method not implemented.")}}}),define(ke[352],Se([1,0,17,63,30,33,3,6,2,20]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ljc=void 0;let A=class extends R.$Tc{constructor(w,E){super();const S=w.getProxy(v.$aL.MainThreadDownloadService);E.registerCommand(!1,"_workbench.downloadResource",async c=>{const g=$.URI.file((0,C.$jc)((0,N.tmpdir)(),(0,f.$qg)()));return await S.$download(c,g),g})}};e.$ljc=A,e.$ljc=A=Ge([We(0,k.$fN),We(1,P.$BN)],A)}),define(ke[353],Se([1,0,57,17,2,94,3,16,11,31]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xjc=void 0;class A extends P.$$gc{constructor(){super(...arguments),this.i=null}async g(t){const h=await super.g(t);if(h.scheme!==v.Schemas.file)return h;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${h.fsPath}.`),h;const s=h.fsPath;let d=0;do{let u;d===0?u=s:u=/[/\\]$/.test(s)?`${s.substr(0,s.length-1)}-${d}`:`${s}-${d}`,await D(u);const l=N.$jc(u,"vscode.lock"),p=await c(this.d,l,!1);if(p)return this.i=p,process.on("exit",()=>{p.dispose()}),f.URI.file(u);d++}while(d<10);return h}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.$xjc=A;async function D(a){try{await k.Promises.stat(a);return}catch{}try{await k.Promises.mkdir(a,{recursive:!0})}catch{}}const w=1e3,E=10*60*1e3;class S extends R.$Tc{constructor(t,h){super(),this.b=t,this.c=h,this.a=this.B(new $.$eh),this.a.cancelAndSet(async()=>{const s=await g(t,h);(!s||s.pid!==process.pid)&&(t.info(`Lock '${h}': The lock was lost unexpectedly.`),this.a.cancel());try{await k.Promises.utimes(h,new Date,new Date)}catch(d){t.error(d),t.info(`Lock '${h}': Could not update mtime.`)}},w)}dispose(){super.dispose();try{C.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const h={pid:process.pid,willReleaseAt:Date.now()+t};await k.Promises.writeFile(this.c,JSON.stringify(h),{flag:"w"})}catch(h){this.b.error(h)}}}async function c(a,t,h){try{const d={pid:process.pid,willReleaseAt:0};await k.Promises.writeFile(t,JSON.stringify(d),{flag:"wx"})}catch(d){a.error(d)}const s=await g(a,t);return!s||s.pid!==process.pid?h?(a.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(a.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),r(a,t)):(a.info(`Lock '${t}': Lock acquired.`),new S(a,t))}async function g(a,t){let h;try{h=await k.Promises.readFile(t)}catch(s){return a.error(s),null}try{return JSON.parse(String(h))}catch(s){return a.error(s),null}}async function o(a,t){let h;try{h=await k.Promises.stat(t)}catch(s){return a.error(s),0}return h.mtime.getTime()}function i(a){try{return process.kill(a,0),!0}catch{return!1}}async function r(a,t){const h=await g(a,t);if(!h)return a.info(`Lock '${t}': Could not read pid of lock holder.`),n(a,t);if(h.willReleaseAt){let p=h.willReleaseAt-Date.now();if(p<5e3){for(p>0?a.info(`Lock '${t}': The lockfile is scheduled to be released in ${p} ms.`):a.info(`Lock '${t}': The lockfile is scheduled to have been released.`);p>0;){if(await(0,$.$7g)(Math.min(100,p)),await o(a,t)===0)return n(a,t);p=h.willReleaseAt-Date.now()}return n(a,t)}}if(!i(h.pid))return a.info(`Lock '${t}': The pid ${h.pid} appears to be gone.`),n(a,t);const s=await o(a,t),d=Date.now()-s;if(d<=E)return a.info(`Lock '${t}': The lock does not look stale, elapsed: ${d} ms, giving up.`),null;a.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,$.$7g)(2e3);const u=await o(a,t),l=Date.now()-u;return l<=E?(a.info(`Lock '${t}': The lock does not look stale, elapsed: ${l} ms, giving up.`),null):(a.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),n(a,t))}async function n(a,t){a.info(`Lock '${t}': Deleting a stale lock.`);try{await k.Promises.unlink(t)}catch{}return c(a,t,!0)}}),define(ke[354],Se([1,0,30,20,46,33]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sic=void 0;let R=class extends f.$uhc{constructor($,k){super(!0,$,k)}createTerminal($,k,A){return this.createTerminalFromOptions({name:$,shellPath:k,shellArgs:A})}createTerminalFromOptions($,k){const A=new f.$thc(this.a,(0,C.$qg)(),$,$.name);return this.f.push(A),A.create($,this.R($,k)),A.value}};e.$Sic=R,e.$Sic=R=Ge([We(0,P.$BN),We(1,N.$fN)],R)}),define(ke[355],Se([1,0,4,37,45,5]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wK=e.$vK=e.OutputChannelUpdateMode=e.$uK=e.$tK=e.$sK=e.$rK=e.$qK=e.$pK=e.$oK=e.$nK=e.$mK=e.$lK=void 0,e.$lK="text/x-code-output",e.$mK="output",e.$nK="Log",e.$oK="text/x-code-log-output",e.$pK="log",e.$qK="workbench.panel.output",e.$rK=new f.$kj("inOutput",!1),e.$sK=new f.$kj("activeLogOutput",!1),e.$tK=new f.$kj("outputView.scrollLock",!1),e.$uK=(0,P.$6h)("outputService");var R;(function($){$[$.Append=1]="Append",$[$.Replace=2]="Replace",$[$.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.$vK={OutputChannels:"workbench.contributions.outputChannels"};class v{constructor(){this.a=new Map,this.b=new C.$Vd,this.onDidRegisterChannel=this.b.event,this.c=new C.$Vd,this.onDidRemoveChannel=this.c.event}registerChannel(k){this.a.has(k.id)||(this.a.set(k.id,k),this.b.fire(k.id))}getChannels(){const k=[];return this.a.forEach(A=>k.push(A)),k}getChannel(k){return this.a.get(k)}removeChannel(k){this.a.delete(k),this.c.fire(k)}}N.$Hn.add(e.$vK.OutputChannels,new v),e.$wK=new f.$kj("activeOutputChannel","")}),define(ke[152],Se([1,0,6,5,20,25,13,355,69,27,59,182,22,18,32,4,3]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kic=e.$jic=void 0;class o extends R.$tj{get disposed(){return this.n}constructor(a,t,h,s,d){super(),this.id=a,this.name=t,this.r=h,this.s=s,this.extension=d,this.m=0,this.n=!1,this.visible=!1,this.setLevel(h.getLevel()),this.B(h.onDidChangeLogLevel(u=>this.setLevel(u)))}get logLevel(){return this.getLevel()}appendLine(a){this.append(a+`
`)}append(a){this.info(a)}clear(){const a=this.m;this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Clear,a)}replace(a){const t=this.m;this.info(a),this.s.$update(this.id,v.OutputChannelUpdateMode.Replace,t),this.visible&&this.r.flush()}show(a,t){this.r.flush(),this.s.$reveal(this.id,!!(typeof a=="boolean"?a:t))}hide(){this.s.$close(this.id)}g(a,t){this.m+=w.$je.fromString(t).byteLength,(0,R.log)(this.r,a,t),this.visible&&(this.r.flush(),this.s.$update(this.id,v.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class i extends o{appendLine(a){this.append(a)}}let r=class{constructor(a,t,h,s,d,u){this.i=t,this.j=h,this.k=s,this.l=d,this.m=u,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=a.getProxy(C.$aL.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,D.$wm)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.h=a;for(const[t,h]of this.g)h.visible=t===this.h}createOutputChannel(a,t,h){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");const s=typeof t=="object"&&t.log,d=(0,E.$If)(t)?t:void 0;if((0,E.$If)(d)&&!d.trim())throw new Error("illegal argument `languageId`. must not be empty");let u;const l=this.i.environment.extensionLogLevel?.find(([I])=>P.$lm.equals(h.identifier,I))?.[1];l&&(u=(0,R.$Dj)(l));const p=s?this.o(a,u,h):this.n(a,d,h);return p.then(I=>{this.g.set(I.id,I),I.visible=I.id===this.h}),s?this.r(a,u??this.m.getLevel(),p):this.q(a,p)}async n(a,t,h){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const s=await this.c,d=this.k.extUri.joinPath(s,`${this.f++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),u=this.l.createLogger(d,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),l=await this.a.$register(a,d,t,h.identifier.value);return new o(l,a,u,this.a,h)}async o(a,t,h){const s=await this.p(h),d=a.replace(/[\\/:\*\?"<>\|]/g,""),u=this.k.extUri.joinPath(s,`${d}.log`),l=`${h.identifier.value}.${d}`,p=this.l.createLogger(u,{id:l,name:a,logLevel:t,extensionId:h.identifier.value});return new i(l,a,p,this.a,h)}p(a){let t=this.d.get(a.identifier.value);if(!t){const h=this.k.extUri.joinPath(this.i.logsLocation,a.identifier.value);this.d.set(a.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(h)}catch(s){if((0,S.$Gk)(s)!==S.FileSystemProviderErrorCode.FileExists)throw s}return h})())}return t}q(a,t){let h=!1;const s=()=>{if(h)throw new Error("Channel has been closed")};return{get name(){return a},append(d){s(),t.then(u=>u.append(d))},appendLine(d){s(),t.then(u=>u.appendLine(d))},clear(){s(),t.then(d=>d.clear())},replace(d){s(),t.then(u=>u.replace(d))},show(d,u){s(),t.then(l=>l.show(d,u))},hide(){s(),t.then(d=>d.hide())},dispose(){h=!0,t.then(d=>d.dispose())}}}r(a,t,h){const s=new g.$Sc,d=()=>{if(s.isDisposed)throw new Error("Channel has been closed")},u=s.add(new c.$Vd);function l(p){t=p,u.fire(p)}return h.then(p=>{s.add(p),p.logLevel!==t&&l(p.logLevel),s.add(p.onDidChangeLogLevel(I=>l(I)))}),{...this.q(a,h),get logLevel(){return t},onDidChangeLogLevel:u.event,trace(p,...I){d(),h.then(b=>b.trace(p,...I))},debug(p,...I){d(),h.then(b=>b.debug(p,...I))},info(p,...I){d(),h.then(b=>b.info(p,...I))},warn(p,...I){d(),h.then(b=>b.warn(p,...I))},error(p,...I){d(),h.then(b=>b.error(p,...I))},dispose(){s.dispose()}}}};e.$jic=r,e.$jic=r=Ge([We(0,f.$fN),We(1,k.$vN),We(2,$.$9gc),We(3,A.$Igc),We(4,R.$oj),We(5,R.$nj)],r),e.$kic=(0,N.$6h)("IExtHostOutputService")}),define(ke[153],Se([1,0,5,11]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mm=e.$Lm=void 0,e.$Lm=(0,C.$6h)("remoteAgentService"),e.$Mm=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(f){let P=1/0;for(let v=0;v<this.maxSampleCount;v++){const $=await f.getRoundTripTime();if($===void 0)return;P=Math.min(P,$/2),await(0,N.$7g)(this.sampleDelay)}this.average.push(P),this.average.length>this.maxAverageCount&&this.average.shift();let R;return this.initial.length<this.maxInitialCount?this.initial.push(P):R=this.initial.reduce((v,$)=>v+$,0)/this.initial.length,this.lastMeasurement={initial:R,current:P,average:this.average.reduce((v,$)=>v+$,0)/this.average.length,high:(()=>typeof R>"u"?!1:P>this.highLatencyMaxThreshold||P>this.highLatencyMinThreshold&&P>R*this.highLatencyMultiple)()},this.lastMeasurement}}}),define(ke[356],Se([1,0,223,87,37,40,51,3,4,153,10,24]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1H=e.$ZH=e.$YH=e.$XH=e.$WH=e.$VH=e.$UH=void 0,e.$UH=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$VH=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$WH=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$XH=Object.freeze({id:"problems",title:(0,C.localize)(3,null),type:"object",order:101}),e.$YH={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new $.$Vd,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(o){this.migrations.push(...o)}}const E=new w;f.$Hn.add(e.$YH.ConfigurationMigration,E);let S=class extends v.$Tc{constructor(o,i){super(),this.a=o,this.b=i,this.B(this.b.onDidChangeWorkspaceFolders(async r=>{for(const n of r.added)await this.f(n,E.migrations)})),this.c(E.migrations),this.B(E.onDidRegisterConfigurationMigration(r=>this.c(r)))}async c(o){await this.f(void 0,o);for(const i of this.b.getWorkspace().folders)await this.f(i,o)}async f(o,i){await Promise.all([i.map(r=>this.g(r,o?.uri))])}async g(o,i){const r=this.a.inspect(o.key,{resource:i}),n=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[a,t]of n){const h=[];for(const d of r.overrideIdentifiers??[]){const u=await this.h(o,{resource:i,overrideIdentifier:d},a);for(const l of u??[]){let p=h.find(([[I,b]])=>I===l[0]&&(0,D.$zn)(b.value,l[1].value));p||h.push(p=[l,[]]),p[1].push(d)}}const s=await this.h(o,{resource:i},a,r);for(const d of s??[])h.push([d,[]]);h.length&&await Promise.allSettled(h.map(async([[d,u],l])=>this.a.updateValue(d,u.value,{resource:i,overrideIdentifiers:l},t)))}}async h(o,i,r,n){const a=d=>t(this.a.inspect(d,i)),t=d=>{const u=d[r];return i.overrideIdentifier?u?.override:u?.value},h=n?t(n):a(o.key);if(h===void 0)return;const s=await o.migrateFn(h,a);return Array.isArray(s)?s:[[o.key,s]]}};e.$ZH=S,e.$ZH=S=Ge([We(0,R.$zi),We(1,P.$ci)],S);let c=class extends v.$Tc{constructor(o){super(),(async()=>{if(!A.$i&&(await o.getEnvironment())?.os!==1)return;f.$Hn.as(N.$Mn.Configuration).registerConfiguration({...e.$WH,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(4,null)},default:[],markdownDescription:(0,C.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(6,null),scope:2}}})})()}};e.$1H=c,e.$1H=c=Ge([We(0,k.$Lm)],c)}),define(ke[357],Se([1,0,35,16,17,23,232,356,87,5,37]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sdb=e.$rdb=e.ResolvedStatus=e.RegisteredEditorPriority=e.$qdb=e.$pdb=void 0,e.$pdb=(0,k.$6h)("editorResolverService"),e.$qdb="workbench.editorAssociations";const D=A.$Hn.as($.$Mn.Configuration),w={...v.$VH,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,R.localize)(0,null),additionalProperties:{type:"string"}}}};D.registerConfiguration(w);var E;(function(o){o.builtin="builtin",o.option="option",o.exclusive="exclusive",o.default="default"})(E||(e.RegisteredEditorPriority=E={}));var S;(function(o){o[o.ABORT=1]="ABORT",o[o.NONE=2]="NONE"})(S||(e.ResolvedStatus=S={}));function c(o){switch(o){case E.exclusive:return 5;case E.default:return 4;case E.builtin:return 3;case E.option:default:return 1}}e.$rdb=c;function g(o,i){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(i.scheme))return!1;const a=typeof o=="string"&&o.indexOf(f.$gc.sep)>=0?`${i.scheme}:${i.path}`:(0,P.$Eg)(i);return C.$Lj(typeof o=="string"?o.toLowerCase():o,a.toLowerCase())}e.$sdb=g}),define(ke[358],Se([1,0,34,16,17,10,23,2,5,267,40,143,153]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.$PK=e.$OK=void 0,e.$OK=(0,$.$6h)("pathService");let S=E=class{constructor(g,o,i,r){this.d=g,this.e=o,this.f=i,this.g=r,this.a=(async()=>(await this.e.getEnvironment())?.os||P.OS)(),this.b=(async()=>{const n=await this.e.getEnvironment();return this.c=n?.userHome??g})()}hasValidBasename(g,o,i){return typeof o=="string"||typeof o>"u"?this.a.then(r=>this.h(g,r,o)):this.h(g,o,i)}h(g,o,i){return g.scheme===N.Schemas.file||g.scheme===N.Schemas.vscodeRemote?(0,C.$6f)(i??(0,R.$Eg)(g),o===1):!0}get defaultUriScheme(){return E.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(g,o){if(g.remoteAuthority)return N.Schemas.vscodeRemote;const i=(0,k.$LK)(o.getWorkspace());if(i)return i;const r=o.getWorkspace().folders[0];if(r)return r.uri.scheme;const n=o.getWorkspace().configuration;return n?n.scheme:N.Schemas.file}userHome(g){return g?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(g=>g===1?f.$fc:f.$gc)}async fileURI(g){let o="";if(await this.a===1&&(g=g.replace(/\\/g,"/")),g[0]==="/"&&g[1]==="/"){const r=g.indexOf("/",2);r===-1?(o=g.substring(2),g="/"):(o=g.substring(2,r),g=g.substring(r)||"/")}return v.URI.from({scheme:N.Schemas.file,authority:o,path:g,query:"",fragment:""})}};e.$PK=S,e.$PK=S=E=Ge([We(1,w.$Lm),We(2,D.$xK),We(3,A.$ci)],S)}),define(ke[359],Se([1,0,234,19,52,4,54,3,2,51,239,13,64,269,89,40,143,26,21,18,24,45]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IK=e.$HK=e.$GK=e.OnPortForward=e.$FK=e.$EK=e.$DK=e.$CK=e.$BK=e.TunnelSource=e.TunnelCloseReason=e.$AK=e.$zK=e.$yK=void 0;const t=10*1e3,h="remote.tunnels.toRestore";e.$yK="onTunnel",e.$zK=new a.$kj("forwardedPortsViewEnabled",!1,C.localize(0,null));function s(F){const z=F.match(/^([a-zA-Z0-9_-]+(?:\.[a-zA-Z0-9_-]+)*:)?([0-9]+)$/);if(z)return{host:z[1]?.substring(0,z[1].length-1)||"localhost",port:Number(z[2])}}e.$AK=s;var d;(function(F){F.Other="Other",F.User="User",F.AutoForwardEnd="AutoForwardEnd"})(d||(e.TunnelCloseReason=d={}));var u;(function(F){F[F.User=0]="User",F[F.Auto=1]="Auto",F[F.Extension=2]="Extension"})(u||(e.TunnelSource=u={})),e.$BK={source:u.User,description:C.localize(1,null)},e.$CK={source:u.Auto,description:C.localize(2,null)};function l(F,z,T){const O=F.get(I(z,T));if(O)return O;if((0,S.$Fv)(z))for(const M of S.$Ev){const j=I(M,T);if(F.has(j))return F.get(j)}else if((0,S.$Hv)(z))for(const M of S.$Gv){const j=I(M,T);if(F.has(j))return F.get(j)}}e.$DK=l;function p(F,z,T){const O=l(F,z,T);if(O)return O;const M=(0,S.$Hv)(z)?"localhost":(0,S.$Fv)(z)?"0.0.0.0":void 0;if(M)return l(F,M,T)}e.$EK=p;function I(F,z){return F+":"+z}e.$FK=I;var b;(function(F){F.Notify="notify",F.OpenBrowser="openBrowser",F.OpenBrowserOnce="openBrowserOnce",F.OpenPreview="openPreview",F.Silent="silent",F.Ignore="ignore"})(b||(e.OnPortForward=b={}));function m(F){return F&&"host"in F&&typeof F.host=="string"&&"port"in F&&typeof F.port=="number"&&(!("detail"in F)||typeof F.detail=="string")&&(!("pid"in F)||typeof F.pid=="string")}e.$GK=m;class y extends v.$Tc{static{this.c="remote.portsAttributes"}static{this.f="remote.otherPortsAttributes"}static{this.g=/^(\d+)\-(\d+)$/}static{this.h=/^([a-z0-9\-]+):(\d{1,5})$/}constructor(z){super(),this.r=z,this.j=[],this.n=new P.$Vd,this.onDidChangeAttributes=this.n.event,this.B(z.onDidChangeConfiguration(T=>{(T.affectsConfiguration(y.c)||T.affectsConfiguration(y.f))&&this.s()})),this.s()}s(){this.j=this.y(),this.n.fire()}getAttributes(z,T,O){let M=this.w(z,T,O,this.j,0);const j={label:void 0,onAutoForward:void 0,elevateIfNeeded:void 0,requireLocalPort:void 0,protocol:void 0};for(;M>=0;){const U=this.j[M];U.key===z?(j.onAutoForward=U.onAutoForward??j.onAutoForward,j.elevateIfNeeded=U.elevateIfNeeded!==void 0?U.elevateIfNeeded:j.elevateIfNeeded,j.label=U.label??j.label,j.requireLocalPort=U.requireLocalPort,j.protocol=U.protocol):(j.onAutoForward=j.onAutoForward??U.onAutoForward,j.elevateIfNeeded=j.elevateIfNeeded!==void 0?j.elevateIfNeeded:U.elevateIfNeeded,j.label=j.label??U.label,j.requireLocalPort=j.requireLocalPort!==void 0?j.requireLocalPort:void 0,j.protocol=j.protocol??U.protocol),M=this.w(z,T,O,this.j,M+1)}return j.onAutoForward!==void 0||j.elevateIfNeeded!==void 0||j.label!==void 0||j.requireLocalPort!==void 0||j.protocol!==void 0?j:this.C()}t(z){return z.start!==void 0&&z.end!==void 0}u(z){return z.host!==void 0&&z.port!==void 0&&(0,r.$If)(z.host)&&(0,r.$Mf)(z.port)}w(z,T,O,M,j){if(j>=M.length)return-1;const U=!(0,S.$Fv)(T)&&!(0,S.$Hv)(T),ue=M.slice(j).findIndex(X=>(0,r.$Mf)(X.key)?U?!1:X.key===z:this.t(X.key)?U?!1:z>=X.key.start&&z<=X.key.end:this.u(X.key)?z===X.key.port&&T===X.key.host:O?X.key.test(O):!1);return ue>=0?ue+j:-1}y(){const z=this.r.getValue(y.c);if(!z||!(0,r.$Kf)(z))return[];const T=[];for(const M in z){if(M===void 0)continue;const j=z[M];let U;if(Number(M))U=Number(M);else if((0,r.$If)(M))if(y.g.test(M)){const K=M.match(y.g);U={start:Number(K[1]),end:Number(K[2])}}else if(y.h.test(M)){const K=M.match(y.h);U={host:K[1],port:Number(K[2])}}else{let K;try{K=RegExp(M)}catch{}K&&(U=K)}U&&T.push({key:U,elevateIfNeeded:j.elevateIfNeeded,onAutoForward:j.onAutoForward,label:j.label,requireLocalPort:j.requireLocalPort,protocol:j.protocol})}const O=this.r.getValue(y.f);return O&&(this.m={elevateIfNeeded:O.elevateIfNeeded,label:O.label,onAutoForward:O.onAutoForward,requireLocalPort:O.requireLocalPort,protocol:O.protocol}),this.z(T)}z(z){function T(O,M){return(0,r.$Mf)(O.key)?O.key:M.t(O.key)?O.key.start:M.u(O.key)?O.key.port:Number.MAX_VALUE}return z.sort((O,M)=>T(O,this)-T(M,this))}C(){return this.m}static providedActionToAction(z){switch(z){case S.ProvidedOnAutoForward.Notify:return b.Notify;case S.ProvidedOnAutoForward.OpenBrowser:return b.OpenBrowser;case S.ProvidedOnAutoForward.OpenBrowserOnce:return b.OpenBrowserOnce;case S.ProvidedOnAutoForward.OpenPreview:return b.OpenPreview;case S.ProvidedOnAutoForward.Silent:return b.Silent;case S.ProvidedOnAutoForward.Ignore:return b.Ignore;default:return}}async addAttributes(z,T,O){const j=this.r.inspect(y.c).userRemoteValue;let U;!j||!(0,r.$Kf)(j)?U={}:U=(0,n.$vn)(j),U[`${z}`]||(U[`${z}`]={});for(const K in T)U[`${z}`][K]=T[K];return this.r.updateValue(y.c,U,O)}}e.$HK=y;let L=class extends v.$Tc{constructor(z,T,O,M,j,U,K,ue,X,Q){super(),this.H=z,this.I=T,this.J=O,this.L=M,this.M=j,this.N=U,this.O=K,this.P=ue,this.Q=X,this.R=Q,this.c=new Map,this.g=new P.$Vd,this.onForwardPort=this.g.event,this.h=new P.$Vd,this.onClosePort=this.h.event,this.j=new P.$Vd,this.onPortName=this.j.event,this.n=new P.$Vd,this.onCandidatesChanged=this.n.event,this.t=new P.$Vd,this.onEnvironmentTunnelsSet=this.t.event,this.u=!1,this.w=void 0,this.z=!1,this.C=new P.$Vd,this.D=new Map,this.F=new Map,this.G=[],this.ab=new Date,this.configPortsAttributes=new y(O),this.s=this.Z(),this.B(this.configPortsAttributes.onDidChangeAttributes(this.gb,this)),this.forwarded=new Map,this.f=new Map,this.H.tunnels.then(async Z=>{const le=await this.getAttributes(Z.map(re=>({port:re.tunnelRemotePort,host:re.tunnelRemoteHost})));for(const re of Z)if(re.localAddress){const $e=I(re.tunnelRemoteHost,re.tunnelRemotePort),oe=p(this.m??new Map,re.tunnelRemoteHost,re.tunnelRemotePort);this.forwarded.set($e,{remotePort:re.tunnelRemotePort,remoteHost:re.tunnelRemoteHost,localAddress:re.localAddress,protocol:le?.get(re.tunnelRemotePort)?.protocol??S.TunnelProtocol.Http,localUri:await this.X(re.localAddress,le?.get(re.tunnelRemotePort)),localPort:re.tunnelLocalPort,runningProcess:oe?.detail,hasRunningProcess:!!oe,pid:oe?.pid,privacy:re.privacy,source:e.$BK}),this.f.set($e,re)}}),this.detected=new Map,this.B(this.H.onTunnelOpened(async Z=>{const le=I(Z.tunnelRemoteHost,Z.tunnelRemotePort);if(!p(this.forwarded,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!p(this.detected,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&!p(this.c,Z.tunnelRemoteHost,Z.tunnelRemotePort)&&Z.localAddress){const re=p(this.m??new Map,Z.tunnelRemoteHost,Z.tunnelRemotePort),$e=(await this.getAttributes([{port:Z.tunnelRemotePort,host:Z.tunnelRemoteHost}]))?.get(Z.tunnelRemotePort);this.forwarded.set(le,{remoteHost:Z.tunnelRemoteHost,remotePort:Z.tunnelRemotePort,localAddress:Z.localAddress,protocol:$e?.protocol??S.TunnelProtocol.Http,localUri:await this.X(Z.localAddress,$e),localPort:Z.tunnelLocalPort,closeable:!0,runningProcess:re?.detail,hasRunningProcess:!!re,pid:re?.pid,privacy:Z.privacy,source:e.$BK})}await this.$(),this.f.set(le,Z),this.g.fire(this.forwarded.get(le))})),this.B(this.H.onTunnelClosed(Z=>this.W(Z,d.Other))),this.U()}S(){return this.Q.extensions.find(z=>z.activationEvents?.includes(e.$yK))?(this.R.createKey(e.$zK.key,!0),!0):!1}U(){if(this.S())return;const z=this.B(this.Q.onDidRegisterExtensions(()=>{this.S()&&z.dispose()}))}async W(z,T){const O=I(z.host,z.port);this.forwarded.has(O)&&(this.forwarded.delete(O),await this.$(),this.h.fire(z))}X(z,T){if(z.startsWith("http"))return $.URI.parse(z);const O=T?.protocol??"http";return $.URI.parse(`${O}://${z}`)}async Y(){const z=this.N.getWorkspace(),T=z.configuration?(0,R.$Ti)(z.configuration.path):z.folders.length>0?(0,R.$Ti)(z.folders[0].uri.path):void 0;if(T===void 0){this.O.debug("Could not get workspace hash for forwarded ports storage key.");return}return`${h}.${this.L.remoteAuthority}.${T}`}async Z(){const z=this.I.get(h,1);if(z)return this.I.remove(h,1),await this.$(),z;const T=await this.Y();if(T)return this.I.get(T,0)}async restoreForwarded(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=await this.s;if(z&&z!==this.y){const T=JSON.parse(z)??[];this.O.trace(`ForwardedPorts: (TunnelModel) restoring ports ${T.map(O=>O.remotePort).join(", ")}`);for(const O of T){const M=p(this.detected,O.remoteHost,O.remotePort);O.source.source!==u.Extension&&!M||O.source.source===u.Extension&&M?await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,privacy:O.privacy,elevateIfNeeded:!0,source:O.source}):O.source.source===u.Extension&&!M&&this.D.set(I(O.remoteHost,O.remotePort),O)}}}if(this.z=!0,this.C.fire(),!this.w){const z=await this.Y();this.w=this.B(new v.$Sc),this.w.add(this.I.onDidChangeValue(0,void 0,this.w)(async T=>{T.key===z&&(this.s=Promise.resolve(this.I.get(z,0)),await this.restoreForwarded())}))}}async $(){if(this.J.getValue("remote.restoreForwardedPorts")){const z=JSON.stringify(Array.from(this.forwarded.values()));if(z!==this.y){this.y=z;const T=await this.Y();T&&this.I.store(T,this.y,0,0)}}}async bb(z,T,O){if(!z.tunnelLocalPort||!O?.requireLocalPort||z.tunnelLocalPort===T)return;const M=new Date;if(this.ab.getTime()+t>M.getTime())return;this.ab=M;const j=C.localize(3,null,T,z.tunnelRemotePort,z.tunnelLocalPort);return this.P.info(j)}async forward(z,T){return!this.z&&this.L.remoteAuthority&&await P.Event.toPromise(this.C.event),this.cb(z,T)}async cb(z,T){await this.Q.activateByEvent(e.$yK);const O=p(this.forwarded,z.remote.host,z.remote.port);T=T??(T!==null?(await this.getAttributes([z.remote]))?.get(z.remote.port):void 0);const M=z.local!==void 0?z.local:z.remote.port;let j;if(O)return this.eb(O,z,T);{const U=this.L.remoteAuthority,K=U?{getAddress:async()=>(await this.M.resolveAuthority(U)).authority}:void 0,ue=I(z.remote.host,z.remote.port);this.c.set(ue,!0),z=this.db(ue,z);const X=await this.H.openTunnel(K,z.remote.host,z.remote.port,void 0,M,z.elevateIfNeeded?z.elevateIfNeeded:T?.elevateIfNeeded,z.privacy,T?.protocol);if(typeof X=="string")j=X;else if(X&&X.localAddress){const Q=p(this.m??new Map,z.remote.host,z.remote.port),Z=X.protocol?X.protocol===S.TunnelProtocol.Https?S.TunnelProtocol.Https:S.TunnelProtocol.Http:T?.protocol??S.TunnelProtocol.Http,le={remoteHost:X.tunnelRemoteHost,remotePort:X.tunnelRemotePort,localPort:X.tunnelLocalPort,name:T?.label??z.name,closeable:!0,localAddress:X.localAddress,protocol:Z,localUri:await this.X(X.localAddress,T),runningProcess:Q?.detail,hasRunningProcess:!!Q,pid:Q?.pid,source:z.source??e.$BK,privacy:X.privacy};return this.forwarded.set(ue,le),this.f.set(ue,X),this.c.delete(ue),await this.$(),await this.bb(X,M,T),this.g.fire(le),X}this.c.delete(ue)}return j}db(z,T){const O=this.D.has(z)?this.D:this.F.has(z)?this.F:void 0;if(O){const M=O.get(z);O.delete(z),M&&(T.name=M.name??T.name,T.local=("local"in M?M.local:"localPort"in M?M.localPort:void 0)??T.local,T.privacy=M.privacy??T.privacy)}return T}async eb(z,T,O){const M=O?.label??T.name;let j;(function(K){K[K.None=0]="None",K[K.Fire=1]="Fire",K[K.Reopen=2]="Reopen"})(j||(j={}));let U=j.None;switch(M!==z.name&&(z.name=M,U=j.Fire),(O?.protocol||z.protocol!==S.TunnelProtocol.Http)&&O?.protocol!==z.protocol&&(T.source=z.source,U=j.Reopen),T.privacy&&z.privacy!==T.privacy&&(U=j.Reopen),U){case j.Fire:{this.g.fire();break}case j.Reopen:await this.close(z.remoteHost,z.remotePort,d.User),await this.cb(T,O)}return p(this.f,T.remote.host,T.remote.port)}async name(z,T,O){const M=p(this.forwarded,z,T),j=I(z,T);if(M){M.name=O,await this.$(),this.j.fire({host:z,port:T});return}else this.detected.has(j)&&(this.detected.get(j).name=O,this.j.fire({host:z,port:T}))}async close(z,T,O){const M=I(z,T),j=this.forwarded.get(M);return O===d.AutoForwardEnd&&j&&j.source.source===u.Auto&&this.F.set(M,{local:j.localPort,name:j.name,privacy:j.privacy}),await this.H.closeTunnel(z,T),this.W({host:z,port:T},O)}address(z,T){const O=I(z,T);return(this.forwarded.get(O)||this.detected.get(O))?.localAddress}get environmentTunnelsSet(){return this.u}addEnvironmentTunnels(z){if(z)for(const T of z){const O=p(this.m??new Map,T.remoteAddress.host,T.remoteAddress.port),M=typeof T.localAddress=="string"?T.localAddress:I(T.localAddress.host,T.localAddress.port);this.detected.set(I(T.remoteAddress.host,T.remoteAddress.port),{remoteHost:T.remoteAddress.host,remotePort:T.remoteAddress.port,localAddress:M,protocol:S.TunnelProtocol.Http,localUri:this.X(M),closeable:!1,runningProcess:O?.detail,hasRunningProcess:!!O,pid:O?.pid,privacy:S.TunnelPrivacyId.ConstantPrivate,source:{source:u.Extension,description:C.localize(4,null)}}),this.H.setEnvironmentTunnel(T.remoteAddress.host,T.remoteAddress.port,M,S.TunnelPrivacyId.ConstantPrivate,S.TunnelProtocol.Http)}this.u=!0,this.t.fire(),this.g.fire()}setCandidateFilter(z){this.r=z}async setCandidates(z){let T=z;this.r&&(T=await this.r(z));const O=this.fb(T);this.O.trace(`ForwardedPorts: (TunnelModel) removed candidates ${Array.from(O.values()).map(M=>M.port).join(", ")}`),this.n.fire(O)}fb(z){const T=this.m??new Map,O=new Map;return this.m=O,z.forEach(M=>{const j=I(M.host,M.port);O.set(j,{host:M.host,port:M.port,detail:M.detail,pid:M.pid}),T.has(j)&&T.delete(j);const U=p(this.forwarded,M.host,M.port);U&&(U.runningProcess=M.detail,U.hasRunningProcess=!0,U.pid=M.pid)}),T.forEach((M,j)=>{const U=s(j);if(!U)return;const K=p(this.forwarded,U.host,U.port);K&&(K.runningProcess=void 0,K.hasRunningProcess=!1,K.pid=void 0);const ue=p(this.detected,U.host,U.port);ue&&(ue.runningProcess=void 0,ue.hasRunningProcess=!1,ue.pid=void 0)}),T}get candidates(){return this.m?Array.from(this.m.values()):[]}get candidatesOrUndefined(){return this.m?this.candidates:void 0}async gb(){const z=Array.from(this.forwarded.values()),T=await this.getAttributes(z.map(O=>({port:O.remotePort,host:O.remoteHost})),!1);if(T)for(const O of z){const M=T.get(O.remotePort);(M?.protocol||O.protocol!==S.TunnelProtocol.Http)&&M?.protocol!==O.protocol&&await this.cb({remote:{host:O.remoteHost,port:O.remotePort},local:O.localPort,name:O.name,source:O.source},M),M&&M.label&&M.label!==O.name&&await this.name(O.remoteHost,O.remotePort,M.label)}}async getAttributes(z,T=!0){const O=new Map,M=new Map;z.forEach(X=>{const Q=p(this.m??new Map,S.$Ev[0],X.port)??X;if(Q){O.set(X.port,Q);const Z=m(Q)?Q.pid:void 0;M.has(Z)||M.set(Z,[]),M.get(Z)?.push(X.port)}});const j=new Map;if(z.forEach(X=>{const Q=this.configPortsAttributes.getAttributes(X.port,X.host,O.get(X.port)?.detail);Q&&j.set(X.port,Q)}),this.G.length===0||!T)return j.size>0?j:void 0;const U=await Promise.all((0,N.$Rb)(this.G.map(X=>Array.from(M.entries()).map(Q=>{const Z=Q[1],le=O.get(Z[0]);return X.providePortAttributes(Z,le?.pid,le?.detail,new i.$6d().token)})))),K=new Map;if(U.forEach(X=>X.forEach(Q=>{Q&&K.set(Q.port,Q)})),!j&&!K)return;const ue=new Map;return z.forEach(X=>{const Q=j.get(X.port),Z=K.get(X.port);ue.set(X.port,{elevateIfNeeded:Q?.elevateIfNeeded,label:Q?.label,onAutoForward:Q?.onAutoForward??y.providedActionToAction(Z?.autoForwardAction),requireLocalPort:Q?.requireLocalPort,protocol:Q?.protocol})}),ue}addAttributesProvider(z){this.G.push(z)}};e.$IK=L,Ge([(0,f.$yh)(1e3)],L.prototype,"$",null),e.$IK=L=Ge([We(0,S.$Av),We(1,E.$up),We(2,k.$zi),We(3,g.$xK),We(4,w.$8k),We(5,c.$ci),We(6,D.$nj),We(7,A.$6v),We(8,o.$CF),We(9,a.$lj)],L)}),define(ke[95],Se([1,0]),function(ge,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$rJ=e.$qJ=void 0;class C{constructor(R,v){this.line=R,this.character=v}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,v){return new C(0,0)}with(R){return new C(0,0)}}e.$qJ=C;class N{constructor(R,v,$,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(R,v),this.end=new C($,k)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new N(0,0,0,0)}with(R){return new N(0,0,0,0)}}e.$rJ=N;var f;(function(P){P[P.Information=1]="Information",P[P.Warning=2]="Warning"})(f||(e.TextSearchCompleteMessageType=f={}))}),define(ke[36],Se([1,0,19,35,24,34,12,5,17,14,95,11]),function(ge,e,C,N,f,P,R,v,$,k,A,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$SJ=e.$RJ=e.$QJ=e.$PJ=e.$OJ=e.$NJ=e.$MJ=e.$LJ=e.$KJ=e.$JJ=e.$IJ=e.$HJ=e.SearchErrorCode=e.$GJ=e.$FJ=e.SearchSortOrder=e.ViewMode=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.SearchCompletionExitCode=e.$AJ=e.$zJ=e.$yJ=e.QueryType=e.SearchProviderType=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return A.TextSearchCompleteMessageType}}),e.$sJ="workbench.view.search",e.$tJ="workbench.panel.search",e.$uJ="workbench.view.search",e.$vJ="search-result",e.$wJ="search.exclude";const w="\u27EA ",E=" characters skipped \u27EB",S=(w.length+E.length+5)*2;e.$xJ=(0,v.$6h)("searchService");var c;(function(Z){Z[Z.file=0]="file",Z[Z.text=1]="text"})(c||(e.SearchProviderType=c={}));var g;(function(Z){Z[Z.File=1]="File",Z[Z.Text=2]="Text"})(g||(e.QueryType=g={}));function o(Z){return!!Z.preview}e.$yJ=o;function i(Z){return!!Z.resource}e.$zJ=i;function r(Z){return!!Z.message}e.$AJ=r;var n;(function(Z){Z[Z.Normal=0]="Normal",Z[Z.NewSearchStarted=1]="NewSearchStarted"})(n||(e.SearchCompletionExitCode=n={}));class a{constructor(le){this.resource=le,this.results=[]}}e.$BJ=a;class t{constructor(le,re,$e,oe){this.ranges=re,this.webviewIndex=oe;const J=Array.isArray(re)?re:[re];if($e&&$e.matchLines===1&&h(J)){le=(0,R.$Bf)(le,$e.matchLines);let V="",ie=0,ye=0;const de=Math.floor($e.charsPerLine/5),fe=[];for(const _ of J){const ee=Math.max(_.startColumn-de,0),G=_.startColumn+$e.charsPerLine;if(ee>ye+de+S){const x=w+(ee-ye)+E;V+=x+le.slice(ee,G),ie+=ee-(ye+x.length)}else V+=le.slice(ye,G);fe.push(new d(0,_.startColumn-ie,_.endColumn-ie)),ye=G}this.preview={text:V,matches:Array.isArray(this.ranges)?fe:fe[0]}}else{const V=Array.isArray(re)?re[0].startLineNumber:re.startLineNumber;this.preview={text:le,matches:(0,C.$2b)(re,ie=>new s(ie.startLineNumber-V,ie.startColumn,ie.endLineNumber-V,ie.endColumn))}}}}e.$CJ=t;function h(Z){const le=Z[0].startLineNumber;for(const re of Z)if(re.startLineNumber!==le||re.endLineNumber!==le)return!1;return!0}class s{constructor(le,re,$e,oe){this.startLineNumber=le,this.startColumn=re,this.endLineNumber=$e,this.endColumn=oe}}e.$DJ=s;class d extends s{constructor(le,re,$e){super(le,re,le,$e)}}e.$EJ=d;var u;(function(Z){Z.List="list",Z.Tree="tree"})(u||(e.ViewMode=u={}));var l;(function(Z){Z.Default="default",Z.FileNames="fileNames",Z.Type="type",Z.Modified="modified",Z.CountDescending="countDescending",Z.CountAscending="countAscending"})(l||(e.SearchSortOrder=l={}));function p(Z,le=!0){const re=Z&&Z.files&&Z.files.exclude,$e=le&&Z&&Z.search&&Z.search.exclude;if(!re&&!$e)return;if(!re||!$e)return re||$e;let oe=Object.create(null);return oe=f.$yn(oe,f.$vn(re)),oe=f.$yn(oe,f.$vn($e),!0),oe}e.$FJ=p;function I(Z,le){return Z.excludePattern&&N.$Lj(Z.excludePattern,le)?!1:Z.includePattern||Z.usingSearchPaths?Z.includePattern&&N.$Lj(Z.includePattern,le)?!0:Z.usingSearchPaths?!!Z.folderQueries&&Z.folderQueries.some(re=>{const $e=re.folder.fsPath;if(P.$8f(le,$e)){const oe=$.$lc($e,le);return!re.includePattern||!!N.$Lj(re.includePattern,oe)}else return!1}):!1:!0}e.$GJ=I;var b;(function(Z){Z[Z.unknownEncoding=1]="unknownEncoding",Z[Z.regexParseError=2]="regexParseError",Z[Z.globParseError=3]="globParseError",Z[Z.invalidLiteral=4]="invalidLiteral",Z[Z.rgProcessError=5]="rgProcessError",Z[Z.other=6]="other",Z[Z.canceled=7]="canceled"})(b||(e.SearchErrorCode=b={}));class m extends Error{constructor(le,re){super(le),this.code=re}}e.$HJ=m;function y(Z){const le=Z.message;if((0,k.$4)(Z))return new m(le,b.canceled);try{const re=JSON.parse(le);return new m(re.message,re.code)}catch{return new m(le,b.other)}}e.$IJ=y;function L(Z){const le={message:Z.message,code:Z.code};return new Error(JSON.stringify(le))}e.$JJ=L;function F(Z){return Z.type==="error"?!0:Z.type==="success"}e.$KJ=F;function z(Z){return Z.type==="success"}e.$LJ=z;function T(Z){return!!Z.path}e.$MJ=T;function O(Z,le){const re=Z.searchPath?Z.searchPath:Z.relativePath;return(0,R.$yf)(re,le)}e.$NJ=O;class M{constructor(le){this.path=le,this.results=[]}addMatch(le){this.results.push(le)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$OJ=M;function j(Z,le){const re={...Z||{},...le||{}};return Object.keys(re).filter($e=>{const oe=re[$e];return typeof oe=="boolean"&&oe})}e.$PJ=j;class U{constructor(le,re){this.c=null,this.a={...le.excludePattern||{},...re.excludePattern||{}},this.b=N.$Mj(this.a);let $e=le.includePattern;re.includePattern&&($e?$e={...$e,...re.includePattern}:$e=re.includePattern),$e&&(this.c=N.$Mj($e))}matchesExcludesSync(le,re,$e){return!!(this.b&&this.b(le,re,$e))}includedInQuerySync(le,re,$e){return!(this.b&&this.b(le,re,$e)||this.c&&!this.c(le,re,$e))}includedInQuery(le,re,$e){const oe=this.b(le,re,$e),J=()=>this.c?!!this.c(le,re,$e):!0;return(0,D.$Sg)(oe)?oe.then(V=>V?!1:J()):J()}hasSiblingExcludeClauses(){return K(this.a)}}e.$QJ=U;function K(Z){for(const le in Z)if(typeof Z[le]!="boolean")return!0;return!1}function ue(Z){if(!Z)return;let le;return re=>(le||(le=(Z()||Promise.resolve([])).then($e=>$e?Q($e):{})),le.then($e=>!!$e[re]))}e.$RJ=ue;function X(Z){if(!Z)return;let le;return re=>{if(!le){const $e=Z();le=$e?Q($e):{}}return!!le[re]}}e.$SJ=X;function Q(Z){const le={};for(const re of Z)le[re]=!0;return le}}),define(ke[41],Se([1,0,19,11,21,4,3,77,16,122,23,12,2,221,5,13,252,40,59,27,20,15,7,66,36,6,56]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h,s,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4gc=e.$3gc=void 0;function l(z,T,O){return new A.$wg(M=>m(M,O)).isEqual(z,T)}function p(z,T,O){return l(z.uri,T.uri,O)?0:(0,D.$5e)(z.uri.toString(),T.uri.toString())}function I(z,T,O){return z.index!==T.index?z.index<T.index?-1:1:l(z.uri,T.uri,O)?(0,D.$5e)(z.name,T.name):(0,D.$5e)(z.uri.toString(),T.uri.toString())}function b(z,T,O,M){const j=z.slice(0).sort((K,ue)=>O(K,ue,M)),U=T.slice(0).sort((K,ue)=>O(K,ue,M));return(0,C.$Eb)(j,U,(K,ue)=>O(K,ue,M))}function m(z,T){const O=T.getCapabilities(z.scheme);return!(O&&O&1024)}class y extends o.$mi{static toExtHostWorkspace(T,O,M,j){if(!T)return{workspace:null,added:[],removed:[]};const{id:U,name:K,folders:ue,configuration:X,transient:Q,isUntitled:Z}=T,le=[],re=O;O?ue.forEach((V,ie)=>{const ye=w.URI.revive(V.uri),de=y.k(M||O,ye,j);de?(de.name=V.name,de.index=V.index,le.push(de)):le.push({uri:ye,name:V.name,index:ie})}):le.push(...ue.map(({uri:V,name:ie,index:ye})=>({uri:w.URI.revive(V),name:ie,index:ye}))),le.sort((V,ie)=>V.index<ie.index?-1:1);const $e=new y(U,K,le,!!Q,X?w.URI.revive(X):null,!!Z,V=>m(V,j)),{added:oe,removed:J}=b(re?re.workspaceFolders:[],$e.workspaceFolders,p,j);return{workspace:$e,added:oe,removed:J}}static k(T,O,M){for(let j=0;j<T.folders.length;j++){const U=T.workspaceFolders[j];if(l(U.uri,O,M))return U}}constructor(T,O,M,j,U,K,ue){super(T,M.map(X=>new o.$ni(X)),j,U,ue),this.t=O,this.u=K,this.q=[],this.s=v.$_h.forUris(ue),M.forEach(X=>{this.q.push(X),this.s.set(X.uri,X)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(T,O){return O&&this.s.get(T)&&(T=(0,A.$Gg)(T)),this.s.findSubstr(T)}resolveWorkspaceFolder(T){return this.s.get(T)}}let L=class{constructor(T,O,M,j,U){this.c=new P.$Vd,this.onDidChangeWorkspace=this.c.event,this.g=new P.$Vd,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new P.$Xd,this.B=new Map,this.h=j,this.s=M,this.t=U,this.j=new k.$9l,this.k=new N.$5g,this.o=T.getProxy(d.$aL.MainThreadWorkspace),this.q=T.getProxy(d.$aL.MainThreadMessageService);const K=O.workspace;this.l=K?new y(K.id,K.name,[],!!K.transient,K.configuration?w.URI.revive(K.configuration):null,!!K.isUntitled,ue=>m(ue,M)):void 0}$initializeWorkspace(T,O){this.v=O,this.$acceptWorkspaceData(T),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?w.URI.from({scheme:$.Schemas.untitled,path:(0,A.$Eg)((0,A.$Gg)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(T,O,M,...j){const U=[];if(Array.isArray(j)&&j.forEach(Z=>{w.URI.isUri(Z.uri)&&!U.some(le=>l(le.uri,Z.uri,this.s))&&U.push({uri:Z.uri,name:Z.name||(0,A.$Dg)(Z.uri)})}),this.n||[O,M].some(Z=>typeof Z!="number"||Z<0)||M===0&&U.length===0)return!1;const K=this.x?this.x.workspaceFolders:[];if(O+M>K.length)return!1;const ue=K.slice(0);ue.splice(O,M,...U.map(Z=>({uri:Z.uri,name:Z.name||(0,A.$Dg)(Z.uri),index:void 0})));for(let Z=0;Z<ue.length;Z++){const le=ue[Z];if(ue.some((re,$e)=>$e!==Z&&l(le.uri,re.uri,this.s)))return!1}ue.forEach((Z,le)=>Z.index=le);const{added:X,removed:Q}=b(K,ue,I,this.s);if(X.length===0&&Q.length===0)return!1;if(this.o){const Z=T.displayName||T.name;this.o.$updateWorkspaceFolders(Z,O,M,U).then(void 0,le=>{this.n=void 0;const re={source:{identifier:T.identifier,label:T.displayName||T.name}};this.q.$showMessage(g.Severity.Error,(0,E.localize)(0,null,Z,le.toString()),re,[])})}return this.y(ue),!0}getWorkspaceFolder(T,O){if(this.x)return this.x.getWorkspaceFolder(T,O)}async getWorkspaceFolder2(T,O){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(T,O)}async resolveWorkspaceFolder(T){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(T)}getPath(){if(!this.x)return;const{folders:T}=this.x;if(T.length!==0)return T[0].uri.fsPath}getRelativePath(T,O){let M,j="";if(typeof T=="string"?(M=w.URI.file(T),j=T):typeof T<"u"&&(M=T,j=T.fsPath),!M)return j;const U=this.getWorkspaceFolder(M,!0);if(!U)return j;typeof O>"u"&&this.x&&(O=this.x.folders.length>1);let K=(0,A.$Jg)(U.uri,M);return O&&U.name&&(K=`${U.name}/${K}`),K}y(T){this.x&&(this.n=y.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:T,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(T){const{workspace:O,added:M,removed:j}=y.toExtHostWorkspace(T,this.l,this.n,this.s);this.l=O||void 0,this.n=void 0,this.c.fire(Object.freeze({added:M,removed:j}))}findFiles(T,O,M,j,U=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${j.value}, entryPoint: findFiles`);let K;if(O===null?K=!1:O&&(typeof O=="string"?K=O:K=O.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:ue,folder:X}=F(a.GlobPattern.from(T));return this.o.$startFileSearch(ue??null,X??null,K??null,M??null,U).then(Q=>Array.isArray(Q)?Q.map(Z=>w.URI.revive(Z)):[])}async findTextInFiles(T,O,M,j,U=f.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${j.value}, entryPoint: findTextInFiles`);const K=this.j.getNext(),ue=typeof O.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:X,folder:Q}=F(a.GlobPattern.from(O.include)),Z=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,le={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof O.useParentIgnoreFiles=="boolean"?!O.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:ue,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:X,excludePattern:Z},re=!1;if(this.u[K]=$e=>{if(re)return;const oe=w.URI.revive($e.resource);$e.results.forEach(J=>{const V=(0,u.$Ch)(J);(0,s.$yJ)(V)?M({uri:oe,preview:{text:V.preview.text,matches:(0,C.$2b)(V.preview.matches,ie=>new t.$eL(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))},ranges:(0,C.$2b)(V.ranges,ie=>new t.$eL(ie.startLineNumber,ie.startColumn,ie.endLineNumber,ie.endColumn))}):M({uri:oe,text:V.text,lineNumber:V.lineNumber})})},U.isCancellationRequested)return{};try{const $e=await this.o.$startTextSearch(T,Q??null,le,K,U);return delete this.u[K],$e||{}}catch($e){throw delete this.u[K],$e}}$handleTextSearchResult(T,O){this.u[O]?.(T)}async save(T){const O=await this.o.$save(T,{saveAs:!1});return w.URI.revive(O)}async saveAs(T){const O=await this.o.$save(T,{saveAs:!0});return w.URI.revive(O)}saveAll(T){return this.o.$saveAll(T)}resolveProxy(T){return this.o.$resolveProxy(T)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(T){return this.o.$requestWorkspaceTrust(T)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(T,O){if(this.w.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.w.set(T,O);const M=this.t.transformOutgoingScheme(T),j=this.z++;return this.o.$registerEditSessionIdentityProvider(j,M),(0,R.$Rc)(()=>{this.w.delete(T),this.o.$unregisterEditSessionIdentityProvider(j)})}async $getEditSessionIdentifier(T,O){this.h.info("Getting edit session identifier for workspaceFolder",T);const M=await this.resolveWorkspaceFolder(w.URI.revive(T));if(!M){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",M);const j=this.w.get(M.uri.scheme);if(this.h.info(`Provider for scheme ${M.uri.scheme} is defined: `,!!j),!j)return;const U=await j.provideEditSessionIdentity(M,O);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(T,O,M,j){this.h.info("Getting edit session identifier for workspaceFolder",T);const U=await this.resolveWorkspaceFolder(w.URI.revive(T));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const K=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!K),!K)return;const ue=await K.provideEditSessionIdentityMatch?.(O,M,j);if(this.h.info("Provider returned edit session identifier match result: ",ue),!!ue)return ue}getOnWillCreateEditSessionIdentityEvent(T){return(O,M,j)=>{const U=function(ue){O.call(M,ue)};return U.extension=T,this.A.event(U,void 0,j)}}async $onWillCreateEditSessionIdentity(T,O,M){const j=await this.resolveWorkspaceFolder(w.URI.revive(T));if(j===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:j},O,async(U,K)=>{const ue=Date.now();await Promise.resolve(U),Date.now()-ue>M&&this.h.warn("SLOW edit session create-participant",K.extension.identifier)}),O.isCancellationRequested}registerCanonicalUriProvider(T,O){if(this.B.has(T))throw new Error(`A provider has already been registered for scheme ${T}`);this.B.set(T,O);const M=this.t.transformOutgoingScheme(T),j=this.z++;return this.o.$registerCanonicalUriProvider(j,M),(0,R.$Rc)(()=>{this.B.delete(T),this.o.$unregisterCanonicalUriProvider(j)})}async provideCanonicalUri(T,O,M){const j=this.B.get(T.scheme);if(!j)return;const U=await j.provideCanonicalUri?.(w.URI.revive(T),O,M);if(U)return U}async $provideCanonicalUri(T,O,M){return this.provideCanonicalUri(w.URI.revive(T),{targetScheme:O},M)}};e.$3gc=L,e.$3gc=L=Ge([We(0,n.$fN),We(1,r.$vN),We(2,i.$Igc),We(3,c.$nj),We(4,h.$1gc)],L),e.$4gc=(0,S.$6h)("IExtHostWorkspace");function F(z){let T,O;return z&&(typeof z=="string"?T=z:(T=z.pattern,O=w.URI.revive(z.baseUri))),{includePattern:T,folder:O}}}),define(ke[42],Se([1,0,24,4,41,6,7,254,87,18,11,5,20,13,2]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7gc=e.$6gc=e.$5gc=void 0;function c(h,s){if(s){const d=s.split(".");let u=h;for(let l=0;u&&l<d.length;l++)u=u[d[l]];return u}}function g(h){return h instanceof S.URI}function o(h){return h&&h.uri instanceof S.URI&&h.languageId&&typeof h.languageId=="string"}function i(h){return h&&!h.uri&&h.languageId&&typeof h.languageId=="string"}function r(h){return h&&h.uri instanceof S.URI&&(!h.name||typeof h.name=="string")&&(!h.index||typeof h.index=="number")}function n(h){if(g(h))return{resource:h};if(o(h))return{resource:h.uri,overrideIdentifier:h.languageId};if(i(h))return{overrideIdentifier:h.languageId};if(r(h))return{resource:h.uri};if(h===null)return{resource:null}}let a=class{constructor(s,d,u){this.a=s.getProxy(P.$aL.MainThreadConfiguration),this.c=d,this.b=u,this.d=new A.$5g,this.e=null}getConfigProvider(){return this.d.wait().then(s=>this.e)}$initializeConfiguration(s){this.e=new t(this.a,this.c,s,this.b),this.d.open()}$acceptConfigurationChanged(s,d){this.getConfigProvider().then(u=>u.$acceptConfigurationChanged(s,d))}};e.$5gc=a,e.$5gc=a=Ge([We(0,w.$fN),We(1,f.$4gc),We(2,E.$nj)],a);class t{constructor(s,d,u,l){this.a=new N.$Vd,this.b=s,this.f=l,this.c=d,this.e=v.$6n.parse(u),this.d=this.k(u.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(s,d){const u={data:this.e.toData(),workspace:this.c.workspace};this.e=v.$6n.parse(s),this.d=this.k(s.configurationScopes),this.a.fire(this.j(d,u))}getConfiguration(s,d,u){const l=n(d)||{},p=this.g(s?c(this.e.getValue(void 0,l,this.c.workspace),s):this.e.getValue(void 0,l,this.c.workspace));s&&this.h(s,l,u?.identifier);function I(m){if(m==null)return null;if(typeof m=="boolean")return m?2:5;switch(m){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const b={has(m){return typeof c(p,m)<"u"},get:(m,y)=>{this.h(s?`${s}.${m}`:m,l,u?.identifier);let L=c(p,m);if(typeof L>"u")L=y;else{let F;const z=(T,O)=>{if((0,k.$Kf)(T)){let M;const j=()=>{F=F||(0,C.$vn)(p),M=M||c(F,O)};return new Proxy(T,{get:(U,K)=>{if(typeof K=="string"&&K.toLowerCase()==="tojson")return j(),()=>M;if(F)return M=M||c(F,O),M[K];const ue=U[K];return typeof K=="string"?z(ue,`${O}.${K}`):ue},set:(U,K,ue)=>(j(),M&&(M[K]=ue),!0),deleteProperty:(U,K)=>(j(),M&&delete M[K],!0),defineProperty:(U,K,ue)=>(j(),M&&Object.defineProperty(M,K,ue),!0)})}return Array.isArray(T)?(0,C.$vn)(T):T};L=z(L,m)}return L},update:(m,y,L,F)=>{m=s?`${s}.${m}`:m;const z=I(L);return y!==void 0?this.b.$updateConfigurationOption(z,m,y,l,F):this.b.$removeConfigurationOption(z,m,l,F)},inspect:m=>{m=s?`${s}.${m}`:m;const y=this.e.inspect(m,l,this.c.workspace);if(y)return{key:m,defaultValue:(0,C.$vn)(y.policy?.value??y.default?.value),globalValue:(0,C.$vn)(y.user?.value??y.application?.value),workspaceValue:(0,C.$vn)(y.workspace?.value),workspaceFolderValue:(0,C.$vn)(y.workspaceFolder?.value),defaultLanguageValue:(0,C.$vn)(y.default?.override),globalLanguageValue:(0,C.$vn)(y.user?.override??y.application?.override),workspaceLanguageValue:(0,C.$vn)(y.workspace?.override),workspaceFolderLanguageValue:(0,C.$vn)(y.workspaceFolder?.override),languageIds:(0,C.$vn)(y.overrideIdentifiers)}}};return typeof p=="object"&&(0,C.$yn)(b,p,!1),Object.freeze(b)}g(s){const d=u=>(0,k.$Kf)(u)?new Proxy(u,{get:(l,p)=>d(l[p]),set:(l,p,I)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(p)}' of object`)},deleteProperty:(l,p)=>{throw new Error(`TypeError: Cannot delete read only property '${String(p)}' of object`)},defineProperty:(l,p)=>{throw new Error(`TypeError: Cannot define property '${String(p)}' for a readonly object`)},setPrototypeOf:l=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):u;return d(s)}h(s,d,u){const l=$.$Wn.test(s)?4:this.d.get(s),p=u?`[${u.value}] `:"";if(l===4){typeof d?.resource>"u"&&this.f.warn(`${p}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${s}', provide the URI of a resource or 'null' for any resource.`);return}if(l===3){d?.resource&&this.f.warn(`${p}Accessing a window scoped configuration for a resource is not expected. To associate '${s}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(s,d){const u=new v.$8n(s,d,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(l,p)=>u.affectsConfiguration(l,n(p))})}k(s){return s.reduce((d,u)=>(d.set(u[0],u[1]),d),new Map)}}e.$6gc=t,e.$7gc=(0,D.$6h)("IExtHostConfiguration")}),define(ke[96],Se([1,0,2,11,4,6,7,41,72,42,21,46,20,27,5,16,10,13,92,296,14]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xic=e.$wic=e.$vic=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var a;(function(z){function T(M){if(M!=null)return M}z.from=T;function O(M){if(M!=null)return M}z.to=O})(a||(a={}));var t;(function(z){function T(M){if(M!=null)return M}z.from=T;function O(M){if(M!=null)return M}z.to=O})(t||(t={}));var h;(function(z){function T(M){if(M!=null)return M}z.from=T;function O(M){if(M!=null)return M}z.to=O})(h||(h={}));var s;(function(z){function T(j){if(j){const U=j;return U&&!!U.process}else return!1}z.is=T;function O(j){if(j==null)return;const U={process:j.process,args:j.args};return j.options&&(U.options=h.from(j.options)),U}z.from=O;function M(j){if(j!=null)return new R.$XL(j.process,j.args,j.options)}z.to=M})(s||(s={}));var d;(function(z){function T(M){if(M!=null)return M}z.from=T;function O(M){if(M!=null)return M}z.to=O})(d||(d={}));var u;(function(z){function T(j){if(j){const U=j;return U&&(!!U.commandLine||!!U.command)}else return!1}z.is=T;function O(j){if(j==null)return;const U={};return j.commandLine!==void 0?U.commandLine=j.commandLine:(U.command=j.command,U.args=j.args),j.options&&(U.options=d.from(j.options)),U}z.from=O;function M(j){if(!(j==null||j.command===void 0&&j.commandLine===void 0))return j.commandLine?new R.$YL(j.commandLine,j.options):new R.$YL(j.command,j.args?j.args:[],j.options)}z.to=M})(u||(u={}));var l;(function(z){function T(j){if(j){const U=j;return U&&U.customExecution==="customExecution"}else return!1}z.is=T;function O(j){return{customExecution:"customExecution"}}z.from=O;function M(j,U){return U.get(j)}z.to=M})(l||(e.CustomExecutionDTO=l={}));var p;(function(z){function T(O,M){let j;return O.scope!==void 0&&typeof O.scope!="number"?j=O.scope.uri:O.scope!==void 0&&typeof O.scope=="number"&&(O.scope===R.TaskScope.Workspace&&M&&M.workspaceFile?j=M.workspaceFile:j=r.$yG),{id:O._id,workspaceFolder:j}}z.from=T})(p||(e.TaskHandleDTO=p={}));var I;(function(z){function T(O){if(O!=null)return{_id:O.id,isDefault:O.isDefault}}z.from=T})(I||(I={}));var b;(function(z){function T(j,U){if(j==null)return[];const K=[];for(const ue of j){const X=O(ue,U);X&&K.push(X)}return K}z.fromMany=T;function O(j,U){if(j==null)return;let K;j.execution instanceof R.$XL?K=s.from(j.execution):j.execution instanceof R.$YL?K=u.from(j.execution):j.execution&&j.execution instanceof R.$ZL&&(K=l.from(j.execution));const ue=a.from(j.definition);let X;return j.scope?typeof j.scope=="number"?X=j.scope:X=j.scope.uri:X=R.TaskScope.Workspace,!ue||!X?void 0:{_id:j._id,definition:ue,name:j.name,source:{extensionId:U.identifier.value,label:j.source,scope:X},execution:K,isBackground:j.isBackground,group:I.from(j.group),presentationOptions:t.from(j.presentationOptions),problemMatchers:j.problemMatchers,hasDefinedMatchers:j.hasDefinedMatchers,runOptions:j.runOptions?j.runOptions:{reevaluateOnRerun:!0},detail:j.detail}}z.from=O;async function M(j,U,K){if(j==null)return;let ue;s.is(j.execution)?ue=s.to(j.execution):u.is(j.execution)?ue=u.to(j.execution):l.is(j.execution)&&(ue=l.to(j._id,K));const X=a.to(j.definition);let Q;if(j.source&&(j.source.scope!==void 0?typeof j.source.scope=="number"?Q=j.source.scope:Q=await U.resolveWorkspaceFolder(C.URI.revive(j.source.scope)):Q=R.TaskScope.Workspace),!X||!Q)return;const Z=new R.$1L(X,Q,j.name,j.source.label,ue,j.problemMatchers);return j.isBackground!==void 0&&(Z.isBackground=j.isBackground),j.group!==void 0&&(Z.group=R.$WL.from(j.group._id),Z.group&&j.group.isDefault&&(Z.group=new R.$WL(Z.group.id,Z.group.label),j.group.isDefault===!0&&(Z.group.isDefault=j.group.isDefault))),j.presentationOptions&&(Z.presentationOptions=t.to(j.presentationOptions)),j._id&&(Z._id=j._id),j.detail&&(Z.detail=j.detail),Z}z.to=M})(b||(e.TaskDTO=b={}));var m;(function(z){function T(M){return M}z.from=T;function O(M){if(M)return Object.assign(Object.create(null),M)}z.to=O})(m||(m={}));class y{#e;constructor(T,O,M){this._id=O,this.a=M,this.#e=T}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(T){}fireDidEndProcess(T){}}let L=class{constructor(T,O,M,j,U,K,ue,X){this.q=new f.$Vd,this.r=new f.$Vd,this.s=new f.$Vd,this.u=new f.$Vd,this.a=T.getProxy(P.$aL.MainThreadTask),this.b=M,this.c=j,this.d=U,this.e=K,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=ue,this.g=X,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(T,O,M){if(!M)return new R.$cL(()=>{});const j=this.x();return this.j.set(j,{type:O,provider:M,extension:T}),this.a.$registerTaskProvider(j,O),new R.$cL(()=>{this.j.delete(j),this.a.$unregisterTaskProvider(j)})}registerTaskSystem(T,O){this.a.$registerTaskSystem(T,O)}fetchTasks(T){return this.a.$fetchTasks(m.from(T)).then(async O=>{const M=[];for(const j of O){const U=await b.to(j,this.b,this.m);U&&M.push(U)}return M})}get taskExecutions(){const T=[];return this.k.forEach(O=>T.push(O)),T}terminateTask(T){if(!(T instanceof y))throw new Error("No valid task execution provided");return this.a.$terminateTask(T._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(T,O,M){const j=this.m.get(T.id);j&&(this.o.set(T.id,j),this.e.attachPtyToTerminal(O,await j.callback(M))),this.p=T.id,this.q.fire({execution:await this.z(T)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(T){if(!this.l.has(T.id))return;const O=await this.z(T);this.l.delete(T.id),this.k.delete(T.id),this.B(T),this.r.fire({execution:O})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(T){const O=await this.z(T.id);this.s.fire({execution:O,processId:T.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(T){const O=await this.z(T.id);this.u.fire({execution:O,exitCode:T.exitCode})}$provideTasks(T,O){const M=this.j.get(T);if(!M)return Promise.reject(new Error("no handler found"));const j=[],U=(0,N.$Yg)(()=>M.provider.provideTasks(A.CancellationToken.None)).then(K=>this.v(O,j,M,K));return new Promise(K=>{U.then(ue=>{Promise.all(j).then(()=>{K(ue)})})})}async $resolveTask(T,O){const M=this.j.get(T);if(!M)return Promise.reject(new Error("no handler found"));if(O.definition.type!==M.type)throw new Error(`Unexpected: Task of type [${O.definition.type}] cannot be resolved by provider of type [${M.type}].`);const j=await b.to(O,this.b,this.m);if(!j)throw new Error("Unexpected: Task cannot be resolved.");const U=await M.provider.resolveTask(j,A.CancellationToken.None);if(!U)return;this.A(U,M);const K=b.from(U,M.extension);if(!K)throw new Error("Unexpected: Task cannot be resolved.");if(U.definition!==j.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return l.is(K.execution)&&await this.y(K,U,!0),await this.w(K)}x(){return this.h++}async y(T,O,M){const j=await this.a.$createTaskId(T);!M&&!this.m.has(j)&&(this.n.add(j),this.o.set(j,O.execution)),this.m.set(j,O.execution)}async z(T,O){if(typeof T=="string"){const U=this.l.get(T);if(!U)throw new n.$bb("Unexpected: The specified task is missing an execution");return U}const M=this.l.get(T.id);if(M)return M;let j;return O?j=Promise.resolve(new y(this,T.id,O)):j=b.to(T.task,this.b,this.m).then(U=>{if(!U)throw new n.$bb("Unexpected: Task does not exist.");return new y(this,T.id,U)}),this.l.set(T.id,j),j.then(U=>(this.k.set(T.id,U),U))}A(T,O){T._deprecated&&this.g.report("Task.constructor",O.extension,"Use the Task constructor that takes a `scope` instead.")}B(T){this.o.get(T.id)&&this.o.delete(T.id),this.n.has(T.id)&&this.p!==T.id&&(this.m.delete(T.id),this.n.delete(T.id));const M=this.n.values();let j=M.next();for(;!j.done;)!this.o.has(j.value)&&this.p!==j.value&&(this.m.delete(j.value),this.n.delete(j.value)),j=M.next()}};e.$vic=L,e.$vic=L=Ge([We(0,w.$fN),We(1,E.$vN),We(2,v.$4gc),We(3,$.$qN),We(4,k.$7gc),We(5,D.$shc),We(6,o.$nj),We(7,i.$Lgc)],L);let F=class extends L{constructor(T,O,M,j,U,K,ue,X){super(T,O,M,j,U,K,ue,X),this.registerTaskSystem(c.Schemas.vscodeRemote,{scheme:c.Schemas.vscodeRemote,authority:"",platform:g.$h(0)})}async executeTask(T,O){if(!O.execution)throw new Error("Tasks to execute must include an execution");const M=b.from(O,T);if(M===void 0)throw new Error("Task is not valid");if(l.is(M.execution))await this.y(M,O,!1);else throw new n.$_;const j=await this.z(await this.a.$getTaskExecution(M),O);return this.a.$executeTask(M).catch(U=>{throw new Error(U)}),j}v(T,O,M,j){const U=[];if(j)for(const K of j){if(this.A(K,M),!K.definition||!T[K.definition.type]){const X=K.source?K.source:"No task source";this.f.warn(`The task [${X}, ${K.name}] uses an undefined task type. The task will be ignored in the future.`)}const ue=b.from(K,M.extension);ue&&l.is(ue.execution)?(U.push(ue),O.push(this.y(ue,K,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:U,extension:M.extension}}async w(T){if(l.is(T.execution))return T;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(T,O){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(T,O,M){}};e.$wic=F,e.$wic=F=Ge([We(0,w.$fN),We(1,E.$vN),We(2,v.$4gc),We(3,$.$qN),We(4,k.$7gc),We(5,D.$shc),We(6,o.$nj),We(7,i.$Lgc)],F),e.$xic=(0,S.$6h)("IExtHostTask")}),define(ke[360],Se([1,0,36,29]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1J=e.$ZJ=e.$YJ=void 0;function f(R){return"cellResults"in R}e.$YJ=f,e.$ZJ="rawCell#";function P(R,v){let $=-1;const k=[];let A=[];return R.forEach(w=>{w.range.startLineNumber!==$&&A.length>0&&(k.push([...A]),A=[]),A.push(w),$=w.range.endLineNumber}),A.length>0&&k.push([...A]),k.map(w=>{const E=[],S=w[0].range.startLineNumber,c=w[w.length-1].range.endLineNumber;for(let g=S;g<=c;g++)E.push(v.getLineContent(g));return new C.$CJ(E.join(`
`)+`
`,w.map(g=>new N.$Us(g.range.startLineNumber-1,g.range.startColumn-1,g.range.endLineNumber-1,g.range.endColumn-1)))})}e.$1J=P}),define(ke[361],Se([1,0,215,22,4,3,28,12,18,2,32,110,6,33,15,7,68,331,149,24,16,286,360,357]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0hc=void 0;class s{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(u=>u.apiEditor)}constructor(u,l,p,I,b,m){this.q=p,this.r=I,this.s=b,this.t=m,this.f=new Map,this.g=new R.$Ac,this.h=new Map,this.j=new f.$Vd,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new f.$Vd,this.onDidOpenNotebookDocument=this.m.event,this.n=new f.$Vd,this.onDidCloseNotebookDocument=this.n.event,this.o=new f.$Vd,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new D.$Egc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=u.getProxy(w.$aL.MainThreadNotebook),this.c=u.getProxy(w.$aL.MainThreadNotebookDocuments),this.d=u.getProxy(w.$aL.MainThreadNotebookEditors),this.i=l.converter,l.registerArgumentProcessor({processArgument:y=>{if(y&&y.$mid===13){const L=y.notebookEditor?.notebookUri,F=y.cell.handle,T=this.g.get(L)?.getCell(F);if(T)return T.apiCell}if(y&&y.$mid===14){const L=y.uri,F=this.g.get(L);if(F)return F.apiNotebook}return y}}),s.B(l)}getEditorById(u){const l=this.h.get(u);if(!l)throw new Error(`unknown text editor: ${u}. known editors: ${[...this.h.keys()]} `);return l}getIdByEditor(u){for(const[l,p]of this.h)if(p.apiEditor===u)return l}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(u,l){const p=this.g.get(u);if(!p&&!l)throw new Error(`NO notebook document for '${u}'`);return p}static u(u,l){if(!l)return;const p=l.filenamePattern.map(I=>S.NotebookExclusiveDocumentPattern.from(I)).filter(I=>I!==void 0);if(l.filenamePattern&&!p){console.warn(`Notebook content provider view options file name pattern is invalid ${l.filenamePattern}`);return}return{extension:u.identifier,providerDisplayName:u.displayName||u.name,displayName:l.displayName,filenamePattern:p,exclusive:l.exclusive||!1}}registerNotebookCellStatusBarItemProvider(u,l,p){const I=s.a++,b=typeof p.onDidChangeCellStatusBarItems=="function"?s.a++:void 0;this.f.set(I,p),this.b.$registerNotebookCellStatusBarItemProvider(I,b,l);let m;return b!==void 0&&(m=p.onDidChangeCellStatusBarItems(y=>this.b.$emitCellStatusBarEvent(b))),new c.$cL(()=>{this.f.delete(I),this.b.$unregisterNotebookCellStatusBarItemProvider(I,b),m?.dispose()})}async createNotebookDocument(u){const l=await this.c.$tryCreateNotebook({viewType:u.viewType,content:u.content&&S.NotebookData.from(u.content)});return k.URI.revive(l)}async openNotebookDocument(u){const l=this.g.get(u);if(l)return l.apiNotebook;const p=await this.c.$tryOpenNotebook(u),I=this.g.get(k.URI.revive(p));return(0,$.$Tf)(I?.apiNotebook)}async showNotebookDocument(u,l){k.URI.isUri(u)&&(u=await this.openNotebookDocument(u));let p;typeof l=="object"?p={position:S.ViewColumn.from(l.viewColumn),preserveFocus:l.preserveFocus,selections:l.selections&&l.selections.map(S.NotebookRange.from),pinned:typeof l.preview=="boolean"?!l.preview:void 0}:p={preserveFocus:!1};const I=await this.d.$tryShowNotebookDocument(u.uri,u.notebookType,p),b=I&&this.h.get(I)?.apiEditor;if(b)return b;throw I?new Error(`Could NOT open editor for "${u.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${u.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(u,l,p,I){const b=this.f.get(u),m=k.URI.revive(l),y=this.g.get(m);if(!y||!b)return;const L=y.getCellFromIndex(p);if(!L)return;const F=await b.provideCellStatusBarItems(L.apiCell,I);if(!F)return;const z=new P.$Sc,T=this.p.add([z]),M=(Array.isArray(F)?F:[F]).map(j=>S.NotebookStatusBarItem.from(j,this.i,z));return{cacheId:T,items:M}}$releaseNotebookCellStatusBarItems(u){this.p.delete(u)}registerNotebookSerializer(u,l,p,I,b){if((0,v.$Je)(l))throw new Error("viewType cannot be empty or just whitespace");const m=this.w++;return this.x.set(m,{viewType:l,serializer:p,options:I}),this.b.$registerNotebookSerializer(m,{id:u.identifier,location:u.extensionLocation},l,S.NotebookDocumentContentOptions.from(I),s.u(u,b)),(0,P.$Rc)(()=>{this.b.$unregisterNotebookSerializer(m)})}async $dataToNotebook(u,l,p){const I=this.x.get(u);if(!I)throw new Error("NO serializer found");const b=await I.serializer.deserializeNotebook(l.buffer,p);return new g.$Tv(S.NotebookData.from(b))}async $notebookToData(u,l,p){const I=this.x.get(u);if(!I)throw new Error("NO serializer found");const b=await I.serializer.serializeNotebook(S.NotebookData.to(l.value),p);return N.$je.wrap(b)}async $saveNotebook(u,l,p,I,b){const m=k.URI.revive(l),y=this.x.get(u);if(!y)throw new Error("NO serializer found");const L=this.g.get(m);if(!L)throw new Error("Document NOT found");if(L.versionId!==p)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(m.scheme))throw new A.$Lk((0,C.localize)(0,null,this.z(m)),6);await this.y(m,I);const F={metadata:(0,r.$Dn)(L.apiNotebook.metadata,j=>!(y.options?.transientDocumentMetadata??{})[j]),cells:[]};for(const j of L.apiNotebook.getCells()){const U=new c.$CM(j.kind,j.document.getText(),j.document.languageId,j.mime,y.options?.transientOutputs?[]:[...j.outputs],j.metadata,j.executionSummary);U.metadata=(0,r.$Dn)(j.metadata,K=>!(y.options?.transientCellMetadata??{})[K]),F.cells.push(U)}const z=await y.serializer.serializeNotebook(F,b);await this.s.value.writeFile(m,z);const T=this.s.getFileSystemProviderExtUri(m.scheme),O=await this.s.value.stat(m);return{name:T.basename(m),isFile:(O.type&A.FileType.File)!==0,isDirectory:(O.type&A.FileType.Directory)!==0,isSymbolicLink:(O.type&A.FileType.SymbolicLink)!==0,mtime:O.mtime,ctime:O.ctime,size:O.size,readonly:!!((O.permissions??0)&A.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(m.scheme),locked:!!((O.permissions??0)&A.FilePermission.Locked),etag:A.$Wk({mtime:O.mtime,size:O.size}),children:void 0}}async $searchInNotebooks(u,l,p,I,b){const m=this.x.get(u)?.serializer;if(!m)return{limitHit:!1,results:[]};const y=new R.$Bc;await(async(O,M,j)=>{await Promise.all(O.map(async U=>await Promise.all(U.filenamePatterns.map(K=>{const ue={_reason:j._reason,folderQueries:j.folderQueries,includePattern:j.includePattern,excludePattern:j.excludePattern,maxResults:j.maxResults,type:1,filePattern:K};return this.t.doInternalFileSearchWithCustomCallback(ue,M,X=>{X.forEach(Q=>{y.has(Q)||I.some(le=>U.isFromSettings&&!le.isFromSettings?!1:le.filenamePatterns.some(re=>(0,h.$sdb)(re,Q)))||y.add(Q)})})}))))})(p,b,l);const F=new R.$Ac;let z=!1;const T=Array.from(y).map(async O=>{const M=[];try{if(b.isCancellationRequested)return;if(l.maxResults&&[...F.values()].reduce((ue,X)=>ue+X.cellResults.length,0)>l.maxResults){z=!0;return}const j=[],U=this.g.get(O);if(U)U.apiNotebook.getCells().forEach(X=>j.push({input:X.document.getText(),outputs:X.outputs.flatMap(Q=>Q.items.map(Z=>Z.data.toString()))}));else{const ue=await this.s.value.readFile(O),X=N.$je.fromString(ue.toString()),Q=await m.deserializeNotebook(X.buffer,b);if(b.isCancellationRequested)return;S.NotebookData.from(Q).cells.forEach(le=>j.push({input:le.source,outputs:le.outputs.flatMap(re=>re.items.map($e=>$e.valueBytes.toString()))}))}if(b.isCancellationRequested)return;j.forEach((ue,X)=>{const Q=l.contentPattern.pattern,Z=new a.$bRb(ue.input,void 0,ue.outputs),le=Z.findInInputs(Q),re=Z.findInOutputs(Q),$e=re.flatMap(oe=>(0,t.$1J)(oe.matches,oe.textBuffer)).map((oe,J)=>(oe.webviewIndex=J,oe));if(le.length>0||re.length>0){const oe={index:X,contentResults:(0,t.$1J)(le,Z.inputTextBuffer),webviewResults:$e};M.push(oe)}});const K={resource:O,cellResults:M};F.set(O,K);return}catch{return}});return await Promise.all(T),{limitHit:z,results:[...F.values()]}}async y(u,l){const p=await this.s.value.stat(u);if(typeof l?.mtime=="number"&&typeof l.etag=="string"&&l.etag!==A.$Vk&&typeof p.mtime=="number"&&typeof p.size=="number"&&l.mtime<p.mtime&&l.etag!==A.$Wk({mtime:l.mtime,size:p.size}))throw new A.$Lk((0,C.localize)(1,null),3,l)}z(u){return u.scheme===n.Schemas.file?u.fsPath:u.toString()}A(u,l,p){if(this.h.has(l))throw new Error(`editor with id ALREADY EXSIST: ${l}`);const I=new i.$1hc(l,this.d,u,p.visibleRanges.map(S.NotebookRange.to),p.selections.map(S.NotebookRange.to),typeof p.viewColumn=="number"?S.ViewColumn.to(p.viewColumn):void 0);this.h.set(l,I)}$acceptDocumentAndEditorsDelta(u){if(u.value.removedDocuments)for(const p of u.value.removedDocuments){const I=k.URI.revive(p),b=this.g.get(I);b&&(b.dispose(),this.g.delete(I),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:b.apiNotebook.getCells().map(m=>m.document.uri)}),this.n.fire(b.apiNotebook));for(const m of this.h.values())m.notebookData.uri.toString()===I.toString()&&this.h.delete(m.id)}if(u.value.addedDocuments){const p=[];for(const I of u.value.addedDocuments){const b=k.URI.revive(I.uri);if(this.g.has(b))throw new Error(`adding EXISTING notebook ${b} `);const m=new o.$Zhc(this.c,this.q,this.r,b,I);p.push(...I.cells.map(y=>o.$Yhc.asModelAddData(m.apiNotebook,y))),this.g.get(b)?.dispose(),this.g.set(b,m),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:p}),this.m.fire(m.apiNotebook)}}if(u.value.addedEditors)for(const p of u.value.addedEditors){if(this.h.has(p.id))return;const I=k.URI.revive(p.documentUri),b=this.g.get(I);b&&this.A(b,p.id,p)}const l=[];if(u.value.removedEditors)for(const p of u.value.removedEditors){const I=this.h.get(p);I&&(this.h.delete(p),this.k?.id===I.id&&(this.k=void 0),l.push(I))}if(u.value.visibleEditors){this.l=u.value.visibleEditors.map(I=>this.h.get(I)).filter(I=>!!I);const p=new Set;this.l.forEach(I=>p.add(I.id));for(const I of this.h.values()){const b=p.has(I.id);I._acceptVisibility(b)}this.l=[...this.h.values()].map(I=>I).filter(I=>I.visible),this.o.fire(this.visibleNotebookEditors)}u.value.newActiveEditor===null?this.k=void 0:u.value.newActiveEditor&&(this.h.get(u.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${u.value.newActiveEditor}`),this.k=this.h.get(u.value.newActiveEditor)),u.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(u){const l=E.$DN.String.with("notebookType","A notebook type"),p=new E.$FN("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[l,new E.$DN("data","Bytes to convert to data",b=>b instanceof Uint8Array,b=>N.$je.wrap(b))],new E.$EN("Notebook Data",b=>S.NotebookData.to(b.value))),I=new E.$FN("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[l,new E.$DN("NotebookData","Notebook data to convert to bytes",b=>!0,b=>new g.$Tv(S.NotebookData.from(b)))],new E.$EN("Bytes",b=>b.buffer));u.registerApiCommand(p),u.registerApiCommand(I)}}e.$0hc=s}),define(ke[362],Se([1,0,17,21,44,35,23,38,36]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2hc=void 0;class k{constructor(w,E,S){this.k=w,this.l=E,this.o=S,this.e=!1,this.f=0,this.g=!1,this.a=w.filePattern,this.b=w.includePattern&&P.$Mj(w.includePattern),this.c=w.maxResults||void 0,this.d=w.exists,this.h=new Set,this.j=w.excludePattern&&P.$Mj(w.excludePattern)}cancel(){this.g=!0,this.h.forEach(w=>w.cancel()),this.h=new Set}search(w){const E=this.k.folderQueries||[];return new Promise((S,c)=>{const g=o=>{this.f++,w(o)};if(this.g)return S({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const i=o.toString(),r=C.$nc(i);this.j&&this.j(i,r)||this.v(g,{base:o,basename:r})}),Promise.all(E.map(o=>this.p(o,g))).then(o=>{S({limitHit:this.e,stats:o[0]||void 0})},o=>{c(new Error((0,f.$Qi)(o)))})})}async p(w,E){const S=new N.$6d,c=this.q(w),g=this.r(),o=new $.$QJ(this.k,w),i=!o.hasSiblingExcludeClauses();let r;try{this.h.add(S),r=v.$Rd.create();const n=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},c,S.token),a=r.elapsed(),t=v.$Rd.create();return this.g&&!this.e||(n&&n.forEach(h=>{const s=C.$gc.relative(w.folder.path,h.path);if(i){const d=C.$nc(h.path);this.v(E,{base:w.folder,relativePath:s,basename:d});return}this.s(g,w.folder,s,E)}),this.g&&!this.e)?null:(this.u(g,o,E),{providerTime:a,postProcessTime:t.elapsed()})}finally{S.dispose(),this.h.delete(S)}}q(w){const E=(0,$.$PJ)(this.k.includePattern,w.includePattern),S=(0,$.$PJ)(this.k.excludePattern,w.excludePattern);return{folder:w.folder,excludes:S,includes:E,useIgnoreFiles:!w.disregardIgnoreFiles,useGlobalIgnoreFiles:!w.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!w.disregardParentIgnoreFiles,followSymlinks:!w.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const w={rootEntries:[],pathToEntries:Object.create(null)};return w.pathToEntries["."]=w.rootEntries,w}s({pathToEntries:w},E,S,c){if(S===this.a){const o=C.$nc(this.a);this.v(c,{base:E,relativePath:this.a,basename:o})}function g(o){const i=C.$nc(o),r=C.$mc(o);let n=w[r];n||(n=w[r]=[],g(r)),n.push({base:E,relativePath:o,basename:i})}g(S)}u({rootEntries:w,pathToEntries:E},S,c){const g=this,o=this.a;function i(r){const n=(0,$.$SJ)(()=>r.map(a=>a.basename));for(let a=0,t=r.length;a<t;a++){const h=r[a],{relativePath:s,basename:d}=h;if(S.matchesExcludesSync(s,d,o!==d?n:void 0))continue;const u=E[s];if(u)i(u);else{if(s===o)continue;g.v(c,h)}if(g.e)break}}i(w)}v(w,E){(!this.b||E.relativePath&&this.b(E.relativePath,E.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||w(E))}}class A{constructor(){this.b=new Map}static{this.a=512}fileSearch(w,E,S,c){const g=this.c(w.cacheKey),o=new k(w,E,g&&g.token);let i=0;const r=n=>{i+=n.length,S(n.map(a=>this.d(a)))};return this.e(o,A.a,r,c).then(n=>({limitHit:n.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:i,detailStats:n.stats}}))}clearCache(w){this.c(w)?.cancel()}c(w){if(w)return this.b.has(w)||this.b.set(w,new N.$6d),this.b.get(w)}d(w){return w.relativePath?{resource:R.$Hg(w.base,w.relativePath)}:{resource:w.base}}e(w,E,S,c){const g=c.onCancellationRequested(()=>{w.cancel()}),o=r=>{r&&(i.push(r),E>0&&i.length>=E&&(S(i),i=[]))};let i=[];return w.search(o).then(r=>(i.length&&S(i),g.dispose(),r),r=>(i.length&&S(i),g.dispose(),Promise.reject(r)))}}e.$2hc=A}),define(ke[363],Se([1,0,19,73,35,103,28,16,17,23,12,18,2,100,235,51,13,40,142,358,36]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.$QK=void 0;let a=class{constructor(m,y,L,F,z){this.a=m,this.b=y,this.c=L,this.d=F,this.e=z}text(m,y,L={}){m=this.f(m,L);const F=this.a.getValue(),z=y&&y.some(O=>!this.a.getValue({resource:O}).search.useRipgrep);return{...this.h(y?.map(o.$oi),L),type:2,contentPattern:m,previewOptions:L.previewOptions,maxFileSize:L.maxFileSize,usePCRE2:F.search.usePCRE2||z||!1,beforeContext:L.beforeContext,afterContext:L.afterContext,userDisabledExcludesAndIgnoreFiles:L.disregardExcludeSettings&&L.disregardIgnoreFiles}}f(m,y){const L=this.a.getValue();m.isRegExp&&(m.pattern=m.pattern.replace(/\r?\n/g,"\\n"));const F={...m,wordSeparators:L.editor.wordSeparators};return this.j(m,y)&&(F.isCaseSensitive=!0),this.k(m)&&(F.isMultiline=!0),y.notebookSearchConfig?.includeMarkupInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownInput=y.notebookSearchConfig.includeMarkupInput),y.notebookSearchConfig?.includeMarkupPreview&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookMarkdownPreview=y.notebookSearchConfig.includeMarkupPreview),y.notebookSearchConfig?.includeCodeInput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellInput=y.notebookSearchConfig.includeCodeInput),y.notebookSearchConfig?.includeOutput&&(F.notebookInfo||(F.notebookInfo={}),F.notebookInfo.isInNotebookCellOutput=y.notebookSearchConfig.includeOutput),F}file(m,y={}){return{...this.h(m,y),type:1,filePattern:y.filePattern?y.filePattern.trim():y.filePattern,exists:y.exists,sortByScore:y.sortByScore,cacheKey:y.cacheKey}}g(m,y){return m?(m=Array.isArray(m)?m.map(u):u(m),y?this.parseSearchPaths(m):{pattern:h(...Array.isArray(m)?m:[m])}):{}}h(m=[],y={}){const L=this.g(y.includePattern,y.expandPatterns),F=this.g(y.excludePattern,y.expandPatterns),z=m.length>1,T=(L.searchPaths&&L.searchPaths.length?L.searchPaths.map(j=>this.q(j,y,F)):m.map(j=>this.r(j,y,F,z))).filter(j=>!!j),O={_reason:y._reason,folderQueries:T,usingSearchPaths:!!(L.searchPaths&&L.searchPaths.length),extraFileResources:y.extraFileResources,excludePattern:F.pattern,includePattern:L.pattern,onlyOpenEditors:y.onlyOpenEditors,maxResults:y.maxResults};if(y.onlyOpenEditors){const j=C.$Hb(C.$Rb(this.c.groups.map(ue=>ue.editors.map(X=>X.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(j));const U=j.filter(ue=>(0,n.$GJ)(O,ue.fsPath)),K=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(K)),{...O,...K}}const M=y.extraFileResources&&y.extraFileResources.filter(j=>(0,n.$GJ)(O,j.fsPath));return O.extraFileResources=M&&M.length?M:void 0,O}i(m){const y=[],L=new R.$Ac,F={};let z=!1;return m.forEach(T=>{if(T.scheme===v.Schemas.walkThrough)return;if((0,k.$Lg)(T)){const M=this.b.getWorkspaceFolder(T)?.uri??T.with({path:$.$mc(T.fsPath)});let j=L.get(M);j||(z=!0,j={folder:M,includePattern:{}},y.push(j),L.set(M,j));const U=$.$lc(M.fsPath,T.fsPath);(0,D.$Tf)(j.includePattern)[U.replace(/\\/g,"/")]=!0}else T.fsPath&&(z=!0,F[T.fsPath]=!0)}),{folderQueries:y,includePattern:F,usingSearchPaths:!0,excludePattern:z?void 0:{"**/*":!0}}}j(m,y){if(y.isSmartCase){if(m.isRegExp){if(A.$zf(m.pattern,!0))return!0}else if(A.$zf(m.pattern))return!0}return!!m.isCaseSensitive}k(m){return m.isMultiline||m.isRegExp&&(0,E.$4B)(m.pattern)||m.pattern.indexOf(`
`)>=0?!0:!!m.isMultiline}parseSearchPaths(m){const y=K=>$.$ic(K)||/^\.\.?([\/\\]|$)/.test(K),F=(Array.isArray(m)?m:s(m)).map(K=>{const ue=this.e.resolvedUserHome;return ue?(0,P.$Yv)(K,ue.scheme===v.Schemas.file?ue.fsPath:ue.path):K}),z=N.$K(F,K=>y(K)?"searchPaths":"exprSegments"),T=(z.exprSegments||[]).map(K=>A.$Ue(K,"/")).map(K=>A.$Ue(K,"\\")).map(K=>(K[0]==="."&&(K="*"+K),d(K))),O={},M=this.m(z.searchPaths||[]);M&&M.length&&(O.searchPaths=M);const j=C.$Rb(T),U=h(...j);return U&&(O.pattern=U),O}l(m,y){return y.disregardExcludeSettings?void 0:(0,n.$FJ)(m,!y.disregardSearchExcludeSettings)}m(m){if(!m||!m.length)return[];const y=m.flatMap(F=>{let{pathPortion:z,globPortion:T}=t(F);return T&&(T=l(T)),this.n(z).flatMap(M=>this.o(M,T))}),L=new Map;return y.forEach(F=>{const z=F.searchPath.toString(),T=L.get(z);T?F.pattern&&(T.pattern=T.pattern||{},T.pattern[F.pattern]=!0):L.set(z,{searchPath:F.searchPath,pattern:F.pattern?h(F.pattern):void 0})}),Array.from(L.values())}n(m){if($.$ic(m)){const y=this.b.getWorkspace().folders;return y[0]&&y[0].uri.scheme!==v.Schemas.file?[{searchPath:y[0].uri.with({path:m})}]:[{searchPath:w.URI.file($.$hc(m))}]}if(this.b.getWorkbenchState()===2){const y=this.b.getWorkspace().folders[0].uri;if(m=u(m),m.startsWith("../")||m===".."){const F=$.$gc.resolve(y.path,m);return[{searchPath:y.with({path:F})}]}const L=l(m);return[{searchPath:y,pattern:L}]}else{if(m==="./"||m===".\\")return[];{const y=m.replace(/^\.[\/\\]/,""),F=this.b.getWorkspace().folders.map(z=>{const T=y.match(new RegExp(`^${A.$Oe(z.name)}(?:/(.*)|$)`));return T?{match:T,folder:z}:null}).filter(D.$Qf);if(F.length)return F.map(z=>{const T=z.match[1];return{searchPath:z.folder.uri,pattern:T&&l(T)}});{const z=m.match(/\.[\/\\](.+)[\/\\]?/),T=z?z[1]:m,O=S.localize(0,null,T);throw new Error(O)}}}}o(m,y){const L=m.pattern&&y?`${m.pattern}/${y}`:m.pattern||y,F=[{searchPath:m.searchPath,pattern:L}];return L&&!L.endsWith("**")&&F.push({searchPath:m.searchPath,pattern:L+"/**"}),F}q(m,y,L){const F=this.r((0,o.$oi)(m.searchPath),y,L,!1);return F?{...F,includePattern:m.pattern}:null}r(m,y,L,F){let z;const T=w.URI.isUri(m)?m:m.uri;if(L.searchPaths){const K=L.searchPaths.filter(ue=>(0,k.$Ag)(ue.searchPath,T))[0];if(K&&!K.pattern)return null;K&&(z=K.pattern)}const O=this.a.getValue({resource:T}),j={...this.l(O,y)||{},...z||{}},U=w.URI.isUri(m)?(0,k.$Eg)(m):m.name;return{folder:T,folderName:F?U:void 0,excludePattern:Object.keys(j).length>0?j:void 0,fileEncoding:O.files&&O.files.encoding,disregardIgnoreFiles:typeof y.disregardIgnoreFiles=="boolean"?y.disregardIgnoreFiles:!O.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof y.disregardGlobalIgnoreFiles=="boolean"?y.disregardGlobalIgnoreFiles:!O.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof y.disregardParentIgnoreFiles=="boolean"?y.disregardParentIgnoreFiles:!O.search.useParentIgnoreFiles,ignoreSymlinks:typeof y.ignoreSymlinks=="boolean"?y.ignoreSymlinks:!O.search.followSymlinks}}};e.$QK=a,e.$QK=a=Ge([We(0,c.$zi),We(1,o.$ci),We(2,i.$9C),We(3,g.$nj),We(4,r.$OK)],a);function t(b){const m=b.match(/[\*\{\}\(\)\[\]\?]/);if(m){const y=m.index,L=b.substr(0,y).match(/[/|\\][^/\\]*$/);if(L){let F=b.substr(0,L.index);return F.match(/[/\\]/)||(F+="/"),{pathPortion:F,globPortion:b.substr((L.index||0)+1)}}}return{pathPortion:b}}function h(...b){return b.length?b.reduce((m,y)=>(m[y]=!0,m),Object.create(null)):void 0}function s(b){return f.$Kj(b,",").map(m=>m.trim()).filter(m=>!!m.length)}function d(b){return[`**/${b}/**`,`**/${b}`].map(y=>y.replace(/\*\*\/\*\*/g,"**"))}function u(b){return b.replace(/\\/g,"/")}function l(b){return u(b).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(b){return b.replace(/([?*[\]])/g,"[$1]")}function I(b,m){b=C.$Mb(b,F=>F.toString());const y=[],L=m.getWorkspace();return b&&b.forEach(F=>{let z;if(m.getWorkbenchState()===2)z=(0,k.$Jg)(L.folders[0].uri,F),z&&z!=="."&&(z="./"+z);else{const T=m.getWorkspaceFolder(F);if(T){const O=T.name;if(L.folders.filter(j=>j.name===O).length===1){const j=(0,k.$Jg)(T.uri,F);j===""?z=`./${T.name}`:z=`./${T.name}/${j}`}else z=F.fsPath}}z&&y.push(p(z))}),y}e.$RK=I}),define(ke[364],Se([1,0,23,2,21,14,5,363,36,40]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7sb=e.$6sb=void 0;const A=7e3;function D(c,g){const o=g.activationEvents;if(!o)return Promise.resolve(void 0);const i=[],r=[];for(const d of o)if(/^workspaceContains:/.test(d)){const u=d.substr(18);u.indexOf("*")>=0||u.indexOf("?")>=0||c.forceUsingSearch?r.push(u):i.push(u)}if(i.length===0&&r.length===0)return Promise.resolve(void 0);let n;const a=new Promise((d,u)=>{n=d}),t=d=>n({activationEvent:d}),h=Promise.all(i.map(d=>w(c,d,t))).then(()=>{}),s=E(c,g.identifier,r,t);return Promise.all([h,s]).then(()=>{n(void 0)}),a}e.$6sb=D;async function w(c,g,o){for(const i of c.folders)if(await c.exists(C.$Hg(N.URI.revive(i),g))){o(`workspaceContains:${g}`);return}}async function E(c,g,o,i){if(o.length===0)return Promise.resolve(void 0);const r=new f.$6d,n=c.checkExists(c.folders,o,r.token),a=setTimeout(async()=>{r.cancel(),c.logService.info(`Not activating extension '${g.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},A);let t=!1;try{t=await n}catch(h){P.$4(h)||P.$1(h)}r.dispose(),clearTimeout(a),t&&i(`workspaceContains:${o.join(",")}`)}function S(c,g,o,i){const r=c.get(R.$5h),n=c.get($.$xJ),t=r.createInstance(v.$QK).file(g.map(h=>(0,k.$oi)(N.URI.revive(h))),{_reason:"checkExists",includePattern:o,exists:!0});return n.fileSearch(t,i).then(h=>!!h.limitHit,h=>P.$4(h)?!1:Promise.reject(h))}e.$7sb=S}),define(ke[47],Se([1,0,212,17,58,23,11,3,77,2,13,6,42,292,117,41,26,144,14,25,22,271,7,64,5,27,94,20,107,70,46,4,364,116,273,16,114,38,10,115]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h,s,d,u,l,p,I,b,m,y,L,F,z,T,O,M,j){"use strict";var U;Object.defineProperty(e,"__esModule",{value:!0}),e.$Hhc=e.$Ghc=e.$Fhc=e.$Ehc=e.$Dhc=void 0,e.$Dhc=(0,s.$6h)("IHostUtils");let K=U=class extends v.$Tc{constructor(J,V,ie,ye,de,fe,_,ee,G,x,me,pe){super(),this.X=pe,this.a=this.B(new m.$Vd),this.onDidChangeRemoteConnectionData=this.a.event,this.U=!1,this.c=V,this.g=ie,this.f=_,this.j=ye,this.m=de,this.s=fe,this.t=G,this.u=x,this.w=me,this.y=this.g.getProxy(D.$aL.MainThreadWorkspace),this.z=this.g.getProxy(D.$aL.MainThreadTelemetry),this.C=this.g.getProxy(D.$aL.MainThreadExtensionService),this.D=new R.$5g,this.F=new R.$5g,this.G=new R.$5g,this.H=new R.$5g,this.I=new $e(this.f.extensions.activationEvents),this.L=new o.$L8b(this.I,this.f.extensions.allExtensions);const Re=new r.$mm(this.f.extensions.myExtensions);this.J=new o.$L8b(this.I,le(this.L,Re)),M.$t&&(this.s.info(`Creating extension host with the following global extensions: ${Q(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${Q(this.J)}`)),this.M=new S.$ohc(this.g,this.s),this.N=new L.$whc(this.g),this.O=ee,this.h=J.createChild(new p.$4h([S.$phc,this.M],[L.$xhc,this.N])),this.P=this.B(new E.$nhc(this.J,this.L,{onExtensionActivationError:(ve,Ie,B)=>{this.C.$onExtensionActivationError(ve,i.$3(Ie),B)},actualActivateExtension:async(ve,Ie)=>{if(o.$L8b.isHostExtension(ve,this.J,this.L))return await this.C.$activateExtension(ve,Ie),new E.$mhc;const B=this.J.getExtensionDescription(ve);return this.db(B,Ie)}},this.s)),this.Q=null,this.R=Object.create(null),this.S=!1,this.W=this.f.remote.connectionData}getRemoteConnectionData(){return this.W}async initialize(){try{await this.tb(),this.D.open(),await this.j.waitForInitializeCall(),f.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.rb()}catch(J){i.$1(J)}}async Y(){this.O.onWillDeactivateAll();let J=[];try{J=this.J.getAllExtensionDescriptions().map(de=>de.identifier).filter(de=>this.isActivated(de)).map(de=>this.cb(de))}catch{}await Promise.all(J)}terminate(J,V=0){if(this.U)return;this.U=!0,this.s.info(`Extension host terminating: ${J}`),this.s.flush(),this.u.dispose(),this.P.dispose(),i.setUnexpectedErrorHandler(ye=>{this.s.error(ye)}),this.g.dispose();const ie=this.Y();Promise.race([(0,R.$7g)(5e3),ie]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${V}`):this.s.info(`Extension host exiting with code ${V}`),this.s.flush(),this.s.dispose(),this.c.exit(V)})}isActivated(J){return this.G.isOpen()?this.P.isActivated(J):!1}async getExtension(J){const V=await this.C.$getExtension(J);return V&&{...V,identifier:new r.$lm(V.identifier.value),extensionLocation:k.URI.revive(V.extensionLocation)}}Z(J,V){return this.P.activateByEvent(J,V)}$(J,V){return this.P.activateById(J,V)}activateByIdWithErrors(J,V){return this.$(J,V).then(()=>{const ie=this.P.getActivatedExtension(J);if(ie.activationFailed)return Promise.reject(ie.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(J=>this.J)}getExtensionExports(J){if(this.G.isOpen())return this.P.getActivatedExtension(J).exports;try{return this.P.getActivatedExtension(J).exports}catch{return null}}async ab(J){if(J.scheme===z.Schemas.file&&this.c.fsRealpath){const V=await this.c.fsRealpath(J.fsPath);return k.URI.file(V)}return J}async getExtensionPathIndex(){return this.Q||(this.Q=this.bb(this.J.getAllExtensionDescriptions()).then(J=>new re(J))),this.Q}async bb(J){const V=$.$_h.forUris(ie=>P.$yg.ignorePathCasing(ie));return await Promise.all(J.map(async ie=>{if(this.ub(ie)){const ye=await this.ab(ie.extensionLocation);V.set(ye,ie)}})),V}cb(J){let V=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(J))return V;const ie=this.P.getActivatedExtension(J);if(!ie)return V;try{typeof ie.module.deactivate=="function"&&(V=Promise.resolve(ie.module.deactivate()).then(void 0,ye=>(this.s.error(ye),Promise.resolve(void 0))))}catch(ye){this.s.error(`An error occurred when deactivating the extension '${J.value}':`),this.s.error(ye)}try{(0,v.$Oc)(ie.subscriptions)}catch(ye){this.s.error(`An error occurred when deactivating the subscriptions for extension '${J.value}':`),this.s.error(ye)}return V}async db(J,V){return this.f.remote.isRemote?this.C.$onWillActivateExtension(J.identifier):await this.C.$onWillActivateExtension(J.identifier),this.fb(J,V).then(ie=>{const ye=ie.activationTimes;return this.C.$onDidActivateExtension(J.identifier,ye.codeLoadingTime,ye.activateCallTime,ye.activateResolvedTime,V),this.eb(J,V,"success",ye),ie},ie=>{throw this.eb(J,V,"failure"),ie})}eb(J,V,ie,ye){const de=X(J,V);this.z.$publicLog2("extensionActivationTimes",{...de,...ye||{},outcome:ie})}fb(J,V){const ie=X(J,V);this.z.$publicLog2("activatePlugin",ie);const ye=this.ub(J);if(!ye)return Promise.resolve(new E.$lhc(E.$ihc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${J.identifier.value}, startup: ${V.startup}, activationEvent: '${V.activationEvent}'${J.identifier.value!==V.extensionId.value?`, root cause: ${V.extensionId.value}`:""}`),this.s.flush();const de=new E.$jhc(V.startup);return Promise.all([this.vb(J,(0,P.$Hg)(J.extensionLocation,ye),de),this.gb(J)]).then(fe=>(f.mark(`code/extHost/willActivateExtension/${J.identifier.value}`),U.hb(this.s,J.identifier,fe[0],fe[1],de))).then(fe=>(f.mark(`code/extHost/didActivateExtension/${J.identifier.value}`),fe))}gb(J){const V=new a.$rhc(J,this.M),ie=new a.$qhc(J.identifier.value,!1,this.M),ye=new F.$yhc(J,this.N),de=J.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,fe=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${J.identifier.value}`),Promise.all([V.whenReady,ie.whenReady,this.O.whenReady]).then(()=>{const _=this;let ee,G;const x=(0,g.$FF)(J,"ipc")?this.f.messagePorts?.get(r.$lm.toKey(J.identifier)):void 0;return Object.freeze({globalState:V,workspaceState:ie,secrets:ye,subscriptions:[],get extensionUri(){return J.extensionLocation},get extensionPath(){return J.extensionLocation.fsPath},asAbsolutePath(me){return N.$jc(J.extensionLocation.fsPath,me)},get storagePath(){return _.O.workspaceValue(J)?.fsPath},get globalStoragePath(){return _.O.globalValue(J).fsPath},get logPath(){return N.$jc(_.f.logsLocation.fsPath,J.identifier.value)},get logUri(){return k.URI.joinPath(_.f.logsLocation,J.identifier.value)},get storageUri(){return _.O.workspaceValue(J)},get globalStorageUri(){return _.O.globalValue(J)},get extensionMode(){return de},get extension(){return ee===void 0&&(ee=new Z(_,J.identifier,J,fe,!1)),ee},get extensionRuntime(){return(0,g.$GF)(J,"extensionRuntime"),_.extensionRuntime},get environmentVariableCollection(){return _.u.getEnvironmentVariableCollection(J)},get messagePassingProtocol(){if(!G){if(!x)return;const me=m.Event.buffer(m.Event.fromDOMEventEmitter(x,"message",pe=>pe.data));x.start(),G={onDidReceiveMessage:me,postMessage:x.postMessage.bind(x)}}return G}})})}static hb(J,V,ie,ye,de){return ie=ie||{activate:void 0,deactivate:void 0},this.ib(J,V,ie,ye,de).then(fe=>new E.$khc(!1,null,de.build(),ie,fe,ye.subscriptions))}static ib(J,V,ie,ye,de){if(typeof ie.activate=="function")try{de.activateCallStart(),J.trace(`ExtensionService#_callActivateOptional ${V.value}`);const fe=typeof global=="object"?global:self,_=ie.activate.apply(fe,[ye]);return de.activateCallStop(),de.activateResolveStart(),Promise.resolve(_).then(ee=>(de.activateResolveStop(),ee))}catch(fe){return Promise.reject(fe)}else return Promise.resolve(ie)}jb(J,V){this.$(J.identifier,{startup:!1,extensionId:J.identifier,activationEvent:V}).then(void 0,ie=>{this.s.error(ie)})}kb(J,V=0){const ye=Date.now();(0,M.$B)(()=>{for(let de=V;de<J.length;de+=1){const fe=J[de];for(const _ of fe.activationEvents??[])if(_==="onStartupFinished")if(Date.now()-ye>50){this.kb(J,de);break}else this.jb(fe,_)}})}lb(){this.C.$setPerformanceMarks(f.getMarks()),this.m.getConfigProvider().then(J=>{const V=J.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ie=this.J.getAllExtensionDescriptions();if(V)this.kb(ie);else for(const ye of ie)if(ye.activationEvents)for(const de of ye.activationEvents)de==="onStartupFinished"&&this.jb(ye,de)})}mb(){const J=this.Z("*",!0).then(void 0,fe=>{this.s.error(fe)});this.B(this.j.onDidChangeWorkspace(fe=>this.nb(fe.added)));const V=this.j.workspace?this.j.workspace.folders:[],ie=this.nb(V),ye=this.pb(),de=Promise.all([ye,J,ie]).then(()=>{});return Promise.race([de,(0,R.$7g)(1e4)]).then(()=>{this.lb()}),de}nb(J){return J.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(V=>this.ob(J,V))).then(()=>{})}async ob(J,V){if(this.isActivated(V.identifier))return;const ie=!this.f.remote.isRemote&&!!this.f.remote.authority,ye={logService:this.s,folders:J.map(fe=>fe.uri),forceUsingSearch:ie||!this.c.fsExists,exists:fe=>this.c.fsExists(fe.fsPath),checkExists:(fe,_,ee)=>this.y.$checkExists(fe,_,ee)},de=await(0,y.$6sb)(ye,V);if(de)return this.$(V.identifier,{startup:!0,extensionId:V.identifier,activationEvent:de.activationEvent}).then(void 0,fe=>this.s.error(fe))}async pb(){if(this.f.remote.authority)return this.Z(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.qb()}catch(J){throw console.error(J),J}}async qb(){const{extensionDevelopmentLocationURI:J,extensionTestsLocationURI:V}=this.f.environment;if(!J||!V)throw new Error(C.localize(0,null));const ie=await this.vb(null,V,new E.$jhc(!1));if(!ie||typeof ie.run!="function")throw new Error(C.localize(1,null,V.toString()));return new Promise((ye,de)=>{const fe=(G,x)=>{G?(M.$t&&this.s.error("Test runner called back with error",G),de(G)):(M.$t&&(x?this.s.info(`Test runner called back with ${x} failures.`):this.s.info("Test runner called back with successful outcome.")),ye(typeof x=="number"&&x>0?1:0))},_=(0,P.$vg)(V),ee=ie.run(_,fe);ee&&ee.then&&ee.then(()=>{M.$t&&this.s.info("Test runner finished successfully."),ye(0)}).catch(G=>{M.$t&&this.s.error("Test runner finished with error",G),de(G instanceof Error&&G.stack?G.stack:String(G))})})}rb(){if(this.S)throw new Error("Extension host is already started!");return this.S=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,R.$7g)(1e3)])).then(()=>this.mb()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(J,V){return this.R[J]=V,(0,v.$Rc)(()=>{delete this.R[J]})}async getRemoteExecServer(J){const{resolver:V}=await this.sb(J);return V?.resolveExecServer?.(J,{resolveAttempt:0})}async sb(J){const V=J.indexOf("+");if(V===-1)throw new t.$iL("Not an authority that can be resolved!",h.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ie=J.substr(0,V);return await this.D.wait(),await this.Z(`onResolveRemoteAuthority:${ie}`,!1),{authorityPrefix:ie,resolver:this.R[ie]}}async $resolveAuthority(J,V){const ie=O.$Rd.create(!1),ye=()=>`[resolveAuthority(${(0,h.$_k)(J)},${V})][${ie.elapsed()}ms] `,de=te=>this.s.info(`${ye()}${te}`),fe=te=>this.s.warn(`${ye()}${te}`),_=(te,q=void 0)=>this.s.error(`${ye()}${te}`,q),ee=te=>{if(te instanceof t.$iL)return{type:"error",error:{code:te._code,message:te._message,detail:te._detail}};throw te},G=async te=>{de(`activating resolver for ${te}...`);const{resolver:q,authorityPrefix:ae}=await this.sb(te);if(!q)throw _(`no resolver for ${ae}`),new t.$iL(`No remote extension installed to resolve ${ae}.`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:q,authorityPrefix:ae,remoteAuthority:te}},x=J.split(/@|%40/g).reverse();de(`activating remote resolvers ${x.join(" -> ")}`);let me;try{me=await Promise.all(x.map(G)).catch(async te=>{if(!(te instanceof t.$iL)||te._code!==h.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw te;return fe(`resolving nested authorities failed: ${te.message}`),[await G(J)]})}catch(te){return ee(te)}const pe=new R.$eh;pe.cancelAndSet(()=>de("waiting..."),1e3);let Re,ve;for(const[te,{authorityPrefix:q,resolver:ae,remoteAuthority:he}]of me.entries())try{if(te===me.length-1)de("invoking final resolve()..."),f.mark(`code/extHost/willResolveAuthority/${q}`),Re=await ae.resolve(he,{resolveAttempt:V,execServer:ve}),f.mark(`code/extHost/didResolveAuthorityOK/${q}`),de("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(ae,t.$hL.isManagedResolvedAuthority(Re)?Re:void 0));else{if(de(`invoking resolveExecServer() for ${he}`),f.mark(`code/extHost/willResolveExecServer/${q}`),ve=await ae.resolveExecServer?.(he,{resolveAttempt:V,execServer:ve}),!ve)throw new t.$iL(`Exec server was not available for ${he}`,h.RemoteAuthorityResolverErrorCode.NoResolverFound);f.mark(`code/extHost/didResolveExecServerOK/${q}`)}}catch(Ae){return f.mark(`code/extHost/didResolveAuthorityError/${q}`),_("returned an error",Ae),pe.dispose(),ee(Ae)}pe.dispose();const Ie={environmentTunnels:Re.environmentTunnels,features:Re.tunnelFeatures?{elevation:Re.tunnelFeatures.elevation,privacyOptions:Re.tunnelFeatures.privacyOptions,protocol:Re.tunnelFeatures.protocol===void 0?!0:Re.tunnelFeatures.protocol}:void 0},B={extensionHostEnv:Re.extensionHostEnv,isTrusted:Re.isTrusted,authenticationSession:Re.authenticationSessionForInitializingExtensions?{id:Re.authenticationSessionForInitializingExtensions.id,providerId:Re.authenticationSessionForInitializingExtensions.providerId}:void 0};de(`returned ${t.$hL.isManagedResolvedAuthority(Re)?"managed authority":`${Re.host}:${Re.port}`}`);let Y;if(t.$hL.isManagedResolvedAuthority(Re)){const te=V;this.X.setFactory(te,Re.makeConnection),Y={authority:J,connectTo:new h.$9k(te),connectionToken:Re.connectionToken}}else Y={authority:J,connectTo:new h.$0k(Re.host,Re.port),connectionToken:Re.connectionToken};return{type:"ok",value:{authority:Y,options:B,tunnelInformation:Ie}}}async $getCanonicalURI(J,V){this.s.info(`$getCanonicalURI invoked for authority (${(0,h.$_k)(J)})`);const{resolver:ie}=await this.sb(J);if(!ie)return null;const ye=k.URI.revive(V);if(typeof ie.getCanonicalURI>"u")return ye;const de=await(0,R.$Yg)(()=>ie.getCanonicalURI(ye));return de||ye}$startExtensionHost(J){J.toAdd.forEach(ye=>ye.extensionLocation=k.URI.revive(ye.extensionLocation));const{globalRegistry:V,myExtensions:ie}=ue(this.I,this.L,this.J,J);return this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),M.$t&&(this.s.info(`$startExtensionHost: global extensions: ${Q(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${Q(this.J)}`)),this.rb()}$activateByEvent(J,V){return V===1?this.D.wait().then(ie=>this.Z(J,!1)):this.G.wait().then(ie=>this.Z(J,!1))}async $activate(J,V){return await this.G.wait(),this.J.getExtensionDescription(J)?(await this.$(J,V),!0):!1}async $deltaExtensions(J){J.toAdd.forEach(fe=>fe.extensionLocation=k.URI.revive(fe.extensionLocation));const{globalRegistry:V,myExtensions:ie}=ue(this.I,this.L,this.J,J),ye=await this.bb(ie);return(await this.getExtensionPathIndex()).setSearchTree(ye),this.L.set(V.getAllExtensionDescriptions()),this.J.set(ie),M.$t&&(this.s.info(`$deltaExtensions: global extensions: ${Q(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${Q(this.J)}`)),Promise.resolve(void 0)}async $test_latency(J){return J}async $test_up(J){return J.byteLength}async $test_down(J){const V=n.$je.alloc(J),ie=Math.random()%256;for(let ye=0;ye<J;ye++)V.writeUInt8(ie,ye);return V}async $updateRemoteConnectionData(J){this.W=J,this.a.fire()}};e.$Ehc=K,e.$Ehc=K=U=Ge([We(0,s.$5h),We(1,e.$Dhc),We(2,l.$fN),We(3,c.$4gc),We(4,w.$7gc),We(5,A.$nj),We(6,d.$vN),We(7,u.$0gc),We(8,I.$6yb),We(9,b.$shc),We(10,T.$Ahc),We(11,j.$Bhc)],K);function ue(oe,J,V,ie){oe.addActivationEvents(ie.addActivationEvents);const ye=new o.$L8b(oe,J.getAllExtensionDescriptions());ye.deltaExtensions(ie.toAdd,ie.toRemove);const de=new r.$mm(V.getAllExtensionDescriptions().map(_=>_.identifier));for(const _ of ie.myToRemove)de.delete(_);for(const _ of ie.myToAdd)de.add(_);const fe=le(ye,de);return{globalRegistry:ye,myExtensions:fe}}function X(oe,J){return{id:oe.identifier.value,name:oe.name,extensionVersion:oe.version,publisherDisplayName:oe.publisher,activationEvents:oe.activationEvents?oe.activationEvents.join(","):null,isBuiltin:oe.isBuiltin,reason:J.activationEvent,reasonId:J.extensionId.value}}function Q(oe){return oe.getAllExtensionDescriptions().map(J=>J.identifier.value).join(",")}e.$Fhc=(0,s.$6h)("IExtHostExtensionService");class Z{#e;#t;#i;constructor(J,V,ie,ye,de){this.#e=J,this.#t=V,this.#i=ie.identifier,this.id=ie.identifier.value,this.extensionUri=ie.extensionLocation,this.extensionPath=N.$hc((0,P.$vg)(ie.extensionLocation)),this.packageJSON=ie,this.extensionKind=ye,this.isFromDifferentExtensionHost=de}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$Ghc=Z;function le(oe,J){return oe.getAllExtensionDescriptions().filter(V=>J.has(V.identifier))}class re{constructor(J){this.a=J}setSearchTree(J){this.a=J}findSubstr(J){return this.a.findSubstr(J)}forEach(J){return this.a.forEach(J)}}e.$Hhc=re;class $e{constructor(J){this.a=new r.$nm,this.addActivationEvents(J)}readActivationEvents(J){return this.a.get(J.identifier)??[]}addActivationEvents(J){for(const V of Object.keys(J))this.a.set(V,J[V])}}}),define(ke[365],Se([1,0,58,2,6,42,26,25,20,27,5,47,13,12]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Pic=void 0;let c=class{constructor(n,a,t,h,s,d,u){this.c=n,this.d=a,this.e=t,this.f=h,this.g=s,this.h=d,this.i=u,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const n=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const a=await this.g.getExtensionPathIndex();this.register(new o(this.c,a,this.d,n,this.i)),this.register(this.e.createInstance(g)),this.h.remote.isRemote&&this.register(this.e.createInstance(i,a,this.h.environment.appUriScheme))}register(n){if("nodeModuleName"in n)if(Array.isArray(n.nodeModuleName))for(const a of n.nodeModuleName)this.a.set(a,n);else this.a.set(n.nodeModuleName,n);typeof n.alternativeModuleName=="function"&&this.b.push(a=>n.alternativeModuleName(a))}};e.$Pic=c,e.$Pic=c=Ge([We(2,A.$5h),We(3,P.$7gc),We(4,D.$Fhc),We(5,k.$vN),We(6,w.$nj)],c);let g=class{static{S=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(n){if(n.environment.appRoot&&S.a.size){const a=(0,E.$Oe)(this.c(n.environment.appRoot.fsPath)),t="[a-z0-9_.-]",h=`@${t}+\\/${t}+|${t}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${a}/${s}\\/)(${h})(.*)$`,"i")}}alternativeModuleName(n){if(!this.b)return;const a=this.b.exec(this.c(n));if(!a)return;const[,t,h,s]=a,d=S.a.get(h);if(d!==void 0)return console.warn(`${h} as been renamed to ${d}, please update your imports`),t+d+s}c(n){return n.replace(/\\/g,"/")}};g=S=Ge([We(0,k.$vN)],g);class o{constructor(n,a,t,h,s){this.c=n,this.d=a,this.e=t,this.f=h,this.g=s,this.nodeModuleName="vscode",this.a=new v.$nm}load(n,a){const t=this.d.findSubstr(a);if(t){let h=this.a.get(t.identifier);return h||(h=this.c(t,this.e,this.f),this.a.set(t.identifier,h)),h}if(!this.b){let h="";this.d.forEach((s,d)=>h+=`	${d} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${a}. These are the extension path mappings: 
${h}`),this.b=this.c(R.$AF,this.e,this.f)}return this.b}}let i=class{constructor(n,a,t){this.e=n,this.f=a,this.nodeModuleName=["open","opn"],this.d=t.getProxy(f.$aL.MainThreadTelemetry);const h=t.getProxy(f.$aL.MainThreadWindow);this.c=(s,d)=>{const u=N.URI.parse(s);return d?this.g(s,d):u.scheme==="http"||u.scheme==="https"?h.$openUri(u,s,{allowTunneling:!0}):u.scheme==="mailto"||u.scheme===this.f?h.$openUri(u,s,{}):this.g(s,d)}}load(n,a,t){const h=this.e.findSubstr(a);return h&&(this.a=h.identifier.value,this.h()),this.b=t(n),this.c}g(n,a){return this.i(),this.b(n,a)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};i=Ge([We(2,$.$fN)],i)}),define(ke[60],Se([1,0,43,3,17,49,5,72,71,47,7,41,289,42]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jhc=e.$Ihc=void 0,e.$Ihc=(0,R.$6h)("IExtHostVariableResolverProvider");class S extends w.$gO{constructor(o,i,r,n,a,t,h){function s(){if(r){const d=r.activeEditor();if(d)return d.document.uri;const u=n.tabGroups.all.find(l=>l.isActive)?.activeTab;if(u!==void 0){if(u.input instanceof A.$WM||u.input instanceof A.$2M)return u.input.modified;if(u.input instanceof A.$VM||u.input instanceof A.$1M||u.input instanceof A.$YM)return u.input.uri}}}super({getFolderUri:d=>{const u=t.folders.filter(l=>l.name===d);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(d,u)=>a.getConfiguration(void 0,d).get(u),getAppRoot:()=>P.cwd(),getExecPath:()=>P.env.VSCODE_EXEC_PATH,getFilePath:()=>{const d=s();if(d)return f.$hc(d.fsPath)},getWorkspaceFolderPathForFile:()=>{if(i){const d=s();if(d){const u=i.getWorkspaceFolder(d);if(u)return f.$hc(u.uri.fsPath)}}},getSelectedText:()=>{if(r){const d=r.activeEditor();if(d&&!d.selection.isEmpty)return d.document.getText(d.selection)}},getLineNumber:()=>{if(r){const d=r.activeEditor();if(d)return String(d.selection.end.line+1)}},getExtension:d=>o.getExtension(d)},void 0,h?Promise.resolve(h):void 0,Promise.resolve(P.env))}}let c=class extends N.$Tc{constructor(o,i,r,n,a){super(),this.b=o,this.c=i,this.g=r,this.h=n,this.j=a,this.a=new C.$V(async()=>{const t=await this.h.getConfigProvider(),s={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async d=>{s.folders=await this.c.getWorkspaceFolders2()||[]})),new S(this.b,this.c,this.g,this.j,t,s,this.m())})}getResolver(){return this.a.value}m(){}};e.$Jhc=c,e.$Jhc=c=Ge([We(0,k.$Fhc),We(1,D.$4gc),We(2,v.$qN),We(3,E.$7gc),We(4,$.$ghc)],c)}),define(ke[97],Se([1,0,11,4,2,25,5,6,71,47,20,7,41,140,281,42,60,3,55,33]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ohc=e.$Nhc=e.$Mhc=e.$Lhc=e.$Khc=void 0,e.$Khc=(0,R.$6h)("IExtHostDebugService");let n=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.w.value}constructor(l,p,I,b,m,y,L){this.I=p,this.J=I,this.K=b,this.L=m,this.M=y,this.N=L,this.l=new Map,this.E=new Map,this.G=new Map,this.H=0,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new N.$Vd,this.n=new N.$Vd,this.o=new N.$Vd,this.u=new N.$Vd,this.k=l.getProxy(v.$aL.MainThreadDebugService),this.z=new N.$Vd,this.B=new N.$Vd,this.w=new t(this.k),this.y=new Map,this.J.getExtensionRegistry().then(F=>{F.onDidChange(z=>{this.O(F)}),this.O(F)})}asDebugSourceUri(l,p){const I=l;if(typeof I.sourceReference=="number"&&I.sourceReference>0){let b=`debug:${encodeURIComponent(I.path||"")}`,m="?";return p&&(b+=`${m}session=${encodeURIComponent(p.id)}`,m="&"),b+=`${m}ref=${I.sourceReference}`,f.URI.parse(b)}else{if(I.path)return f.URI.file(I.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}O(l){const p=[];for(const I of l.getAllExtensionDescriptions())if(I.contributes){const b=I.contributes.debuggers;if(b&&b.length>0)for(const m of b)(0,S.$bG)(m)&&p.push(m.type)}this.k.$registerDebugTypes(p)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){const l=[];return this.y.forEach(p=>l.push(p)),l}async $resolveDebugVisualizer(l,p){const I=this.G.get(l);if(!I)throw new Error(`No debug visualizer found with id '${l}'`);let{v:b,provider:m}=I;if(b.visualization||(b=await m.resolveDebugVisualization?.(b,p)||b,I.v=b),!b.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${m}'`);return this.db(b.visualization)}async $executeDebugVisualizerCommand(l){const p=this.G.get(l);if(!p)throw new Error(`No debug visualizer found with id '${l}'`);const I=p.v.visualization;I&&"command"in I&&this.N.executeCommand(I.command,...I.arguments||[])}async $provideDebugVisualizers(l,p,I,b){const m=this.l.get(I.sessionId),y=this.cb(l,p),L=this.E.get(y);if(!m||!L)return[];const F=await L.provideDebugVisualization({session:m,variable:I.variable,containerId:I.containerId,frameId:I.frameId,threadId:I.threadId},b);return F?F.map(z=>{const T=++this.H;this.G.set(T,{v:z,provider:L});const O=z.iconPath?this.eb(z.iconPath):void 0;return{id:T,name:z.name,iconClass:O?.iconClass,iconPath:O?.iconPath,visualization:this.db(z.visualization)}}):[]}$disposeDebugVisualizers(l){for(const p of l)this.G.delete(p)}registerDebugVisualizationProvider(l,p,I){if(!l.contributes?.debugVisualizers?.some(y=>y.id===p))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${p})`);const b=P.$lm.toKey(l.identifier),m=this.cb(b,p);if(this.E.has(m))throw new Error(`A debug visualization provider with id '${p}' is already registered`);return this.E.set(m,I),this.k.$registerDebugVisualizer(b,p),(0,o.$Rc)(()=>{this.k.$unregisterDebugVisualizer(b,p),this.E.delete(p)})}addBreakpoints(l){const p=l.filter(m=>{const y=m.id;return this.y.has(y)?!1:(this.y.set(y,m),!0)});this.$(p,[],[]);const I=[],b=new Map;for(const m of p)if(m instanceof D.$cM){let y=b.get(m.location.uri.toString());y||(y={type:"sourceMulti",uri:m.location.uri,lines:[]},b.set(m.location.uri.toString(),y),I.push(y)),y.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof D.$dM&&I.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this.k.$registerBreakpoints(I)}removeBreakpoints(l){const p=l.filter(y=>this.y.delete(y.id));this.$([],p,[]);const I=p.filter(y=>y instanceof D.$cM).map(y=>y.id),b=p.filter(y=>y instanceof D.$dM).map(y=>y.id),m=p.filter(y=>y instanceof D.$eM).map(y=>y.id);return this.k.$unregisterBreakpoints(I,b,m)}startDebugging(l,p,I){return this.k.$startDebugging(l?l.uri:void 0,p,{parentSessionID:I.parentSession?I.parentSession.id:void 0,lifecycleManagedByParent:I.lifecycleManagedByParent,repl:I.consoleMode===D.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:I.noDebug,compact:I.compact,suppressSaveBeforeStart:I.suppressSaveBeforeStart,suppressDebugStatusbar:I.suppressDebugStatusbar??I.debugUI?.simple,suppressDebugToolbar:I.suppressDebugToolbar??I.debugUI?.simple,suppressDebugView:I.suppressDebugView??I.debugUI?.simple})}stopDebugging(l){return this.k.$stopDebugging(l?l.id:void 0)}registerDebugConfigurationProvider(l,p,I){if(!p)return new D.$cL(()=>{});const b=this.d++;return this.f.push({type:l,handle:b,provider:p}),this.k.$registerDebugConfigurationProvider(l,I,!!p.provideDebugConfigurations,!!p.resolveDebugConfiguration,!!p.resolveDebugConfigurationWithSubstitutedVariables,b),new D.$cL(()=>{this.f=this.f.filter(m=>m.provider!==p),this.k.$unregisterDebugConfigurationProvider(b)})}registerDebugAdapterDescriptorFactory(l,p,I){if(!I)return new D.$cL(()=>{});if(!this.W(l,p))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${p}' debugger.`);if(this.S(p))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const b=this.g++;return this.h.push({type:p,handle:b,factory:I}),this.k.$registerDebugAdapterDescriptorFactory(p,b),new D.$cL(()=>{this.h=this.h.filter(m=>m.factory!==I),this.k.$unregisterDebugAdapterDescriptorFactory(b)})}registerDebugAdapterTrackerFactory(l,p){if(!p)return new D.$cL(()=>{});const I=this.i++;return this.j.push({type:l,handle:I,factory:p}),new D.$cL(()=>{this.j=this.j.filter(b=>b.factory!==p)})}async $runInTerminal(l,p){return Promise.resolve(void 0)}async $substituteVariables(l,p){let I;const b=await this.bb(l);return b&&(I={uri:b.uri,name:b.name,index:b.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.M.getResolver()).resolveAnyAsync(I,p)}P(l,p){if(l.type==="implementation")return new s(l.implementation)}Q(){}async $startDASession(l,p){const I=this,b=await this.ab(p);return this.Y(this.S(b.type),b).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}' (extension might have failed to activate)`);const y=this.R(m),L=this.P(y,b);if(!L)throw new Error(`Couldn't create a debug adapter for type '${b.type}'.`);const F=L;return this.C.set(l,F),this.X(b).then(z=>(z&&this.D.set(l,z),F.onMessage(async T=>{if(T.type==="request"&&T.command==="handshake"){const O=T,M={type:"response",seq:0,command:O.command,request_seq:O.seq,success:!0};this.F||(this.F=this.Q());try{if(this.F){const j=await this.F.sign(O.arguments.value);M.body={signature:j},F.sendResponse(M)}else throw new Error("no signer")}catch(j){M.success=!1,M.message=j.message,F.sendResponse(M)}}else z&&z.onDidSendMessage&&z.onDidSendMessage(T),T=(0,S.$gG)(T,!0),I.k.$acceptDAMessage(l,T)}),F.onError(T=>{z&&z.onError&&z.onError(T),this.k.$acceptDAError(l,T.name,T.message,T.stack)}),F.onExit(T=>{z&&z.onExit&&z.onExit(T??void 0,void 0),this.k.$acceptDAExit(l,T??void 0,void 0)}),z&&z.onWillStartSession&&z.onWillStartSession(),F.startSession()))})}$sendDAMessage(l,p){p=(0,S.$fG)(p,!1);const I=this.D.get(l);I&&I.onWillReceiveMessage&&I.onWillReceiveMessage(p),this.C.get(l)?.sendMessage(p)}$stopDASession(l){const p=this.D.get(l);this.D.delete(l),p&&p.onWillStopSession&&p.onWillStopSession();const I=this.C.get(l);return this.C.delete(l),I?I.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(l){const p=[],I=[],b=[];if(l.added)for(const m of l.added){const y=m.id;if(y&&!this.y.has(y)){let L;if(m.type==="function")L=new D.$dM(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")L=new D.$eM(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const F=f.URI.revive(m.uri);L=new D.$cM(new D.$oL(F,new D.$dL(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}(0,D.$aM)(L,y),this.y.set(y,L),p.push(L)}}if(l.removed)for(const m of l.removed){const y=this.y.get(m);y&&(this.y.delete(m),I.push(y))}if(l.changed){for(const m of l.changed)if(m.id){const y=this.y.get(m.id);if(y){if(y instanceof D.$dM&&m.type==="function"){const L=y;L.enabled=m.enabled,L.condition=m.condition,L.hitCondition=m.hitCondition,L.logMessage=m.logMessage,L.functionName=m.functionName}else if(y instanceof D.$cM&&m.type==="source"){const L=y;L.enabled=m.enabled,L.condition=m.condition,L.hitCondition=m.hitCondition,L.logMessage=m.logMessage,L.location=new D.$oL(f.URI.revive(m.uri),new D.$dL(m.line,m.character))}b.push(y)}}}this.$(p,I,b)}async $acceptStackFrameFocus(l){let p;const I=l.sessionId?await this.ab(l.sessionId):void 0;if(!I)throw new Error("no DebugSession found for debug focus context");l.kind==="thread"?p=new D.$kM(I,l.threadId):p=new D.$jM(I,l.threadId,l.frameId),this.A=p,this.B.fire(this.A)}$provideDebugConfigurations(l,p,I){return(0,C.$Yg)(async()=>{const b=this.V(l);if(!b)throw new Error("no DebugConfigurationProvider found");if(!b.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.bb(p);return b.provideDebugConfigurations(m,I)}).then(b=>{if(!b)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return b})}$resolveDebugConfiguration(l,p,I,b){return(0,C.$Yg)(async()=>{const m=this.V(l);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const y=await this.bb(p);return m.resolveDebugConfiguration(y,I,b)})}$resolveDebugConfigurationWithSubstitutedVariables(l,p,I,b){return(0,C.$Yg)(async()=>{const m=this.V(l);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const y=await this.bb(p);return m.resolveDebugConfigurationWithSubstitutedVariables(y,I,b)})}async $provideDebugAdapter(l,p){const I=this.U(l);if(!I)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const b=await this.ab(p);return this.Y(I,b).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${b.type}'`);return this.R(m)})}async $acceptDebugSessionStarted(l){const p=await this.ab(l);this.m.fire(p)}async $acceptDebugSessionTerminated(l){const p=await this.ab(l);p&&(this.n.fire(p),this.l.delete(p.id))}async $acceptDebugSessionActiveChanged(l){this.q=l?await this.ab(l):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(l,p){(await this.ab(l))?._acceptNameChanged(p)}async $acceptDebugSessionCustomEvent(l,p){const b={session:await this.ab(l),event:p.event,body:p.body};this.u.fire(b)}R(l){if(l instanceof D.$fM)return{type:"executable",command:l.command,args:l.args,options:l.options};if(l instanceof D.$gM)return{type:"server",port:l.port,host:l.host};if(l instanceof D.$hM)return{type:"pipeServer",path:l.path};if(l instanceof D.$iM)return{type:"implementation",implementation:l.implementation};throw new Error("convertToDto unexpected type")}S(l){const p=this.h.filter(I=>I.type===l);if(p.length>0)return p[0].factory}U(l){const p=this.h.filter(I=>I.handle===l);if(p.length>0)return p[0].factory}V(l){const p=this.f.filter(I=>I.handle===l);if(p.length>0)return p[0].provider}W(l,p){if(l.contributes){const I=l.contributes.debuggers;if(I&&I.length>0){for(const b of I)if(b.label&&b.type&&b.type===p)return!0}}return!1}X(l){const I=l.configuration.type,b=this.j.filter(m=>m.type===I||m.type==="*").map(m=>(0,C.$Yg)(()=>m.factory.createDebugAdapterTracker(l)).then(y=>y,y=>null));return Promise.race([Promise.all(b).then(m=>{const y=m.filter(L=>!!L);if(y.length>0)return new h(y)}),new Promise(m=>setTimeout(()=>m(void 0),1e3))]).catch(m=>{})}async Y(l,p){const I=p.configuration.debugServer;if(typeof I=="number")return Promise.resolve(new D.$gM(I));if(l){const m=await this.J.getExtensionRegistry();return(0,C.$Yg)(()=>l.createDebugAdapterDescriptor(p,this.Z(p,m))).then(y=>{if(y)return y})}const b=await this.J.getExtensionRegistry();return Promise.resolve(this.Z(p,b))}Z(l,p){}$(l,p,I){(l.length>0||p.length>0||I.length>0)&&this.z.fire(Object.freeze({added:l,removed:p,changed:I}))}async ab(l){if(l)if(typeof l=="string"){const p=this.l.get(l);if(p)return p}else{let p=this.l.get(l.id);if(!p){const I=await this.bb(l.folderUri),b=l.parent?this.l.get(l.parent):void 0;p=new a(this.k,l.id,l.type,l.name,I,l.configuration,b),this.l.set(p.id,p),this.k.$sessionCached(p.id)}return p}throw new Error("cannot find session")}bb(l){if(l){const p=f.URI.revive(l);return this.I.resolveWorkspaceFolder(p)}return Promise.resolve(void 0)}cb(l,p){return`${l}\0${p}`}db(l){if(l){if("title"in l&&"command"in l)return{type:0};throw new Error("Unsupported debug visualization type")}}eb(l){const p=this.fb(l);let I,b;return"id"in p?b=i.ThemeIcon.asClassName(p):I=p,{iconPath:I,iconClass:b}}fb(l){if(l instanceof D.$0L)return{id:l.id};const p=typeof l=="object"&&"dark"in l?l.dark:l,I=typeof l=="object"&&"light"in l?l.light:l;return{dark:typeof p=="string"?f.URI.file(p):p,light:typeof I=="string"?f.URI.file(I):I}}};e.$Lhc=n,e.$Lhc=n=Ge([We(0,A.$fN),We(1,w.$4gc),We(2,k.$Fhc),We(3,c.$7gc),We(4,$.$ghc),We(5,g.$Ihc),We(6,r.$BN)],n);class a{constructor(l,p,I,b,m,y,L){this.d=l,this.f=p,this.g=I,this.h=b,this.i=m,this.j=y,this.k=L}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(l){this.h=l,this.d.$setDebugSessionName(this.f,l)}get parentSession(){return this.k}_acceptNameChanged(l){this.h=l}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(l,p){return this.d.$customDebugAdapterRequest(this.f,l,p)}getDebugProtocolBreakpoint(l){return this.d.$getDebugProtocolBreakpoint(this.f,l.id)}}e.$Mhc=a;class t{constructor(l){this.value=Object.freeze({append(p){l.$appendDebugConsole(p)},appendLine(p){this.append(p+`
`)}})}}e.$Nhc=t;class h{constructor(l){this.d=l}onWillStartSession(){this.d.forEach(l=>l.onWillStartSession?l.onWillStartSession():void 0)}onWillReceiveMessage(l){this.d.forEach(p=>p.onWillReceiveMessage?p.onWillReceiveMessage(l):void 0)}onDidSendMessage(l){this.d.forEach(p=>p.onDidSendMessage?p.onDidSendMessage(l):void 0)}onWillStopSession(){this.d.forEach(l=>l.onWillStopSession?l.onWillStopSession():void 0)}onError(l){this.d.forEach(p=>p.onError?p.onError(l):void 0)}onExit(l,p){this.d.forEach(I=>I.onExit?I.onExit(l,p):void 0)}}class s extends E.$Zlb{constructor(l){super(),this.h=l,l.onDidSendMessage(p=>{this.acceptMessage(p)})}startSession(){return Promise.resolve(void 0)}sendMessage(l){this.h.handleMessage(l)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let d=class extends n{constructor(l,p,I,b,m,y,L){super(l,p,I,b,m,y,L)}};e.$Ohc=d,e.$Ohc=d=Ge([We(0,A.$fN),We(1,w.$4gc),We(2,k.$Fhc),We(3,c.$7gc),We(4,$.$ghc),We(5,g.$Ihc),We(6,r.$BN)],d)}),define(ke[366],Se([1,0,14,58,2,6,309,13,84,107,27,247,20,66,47,91]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ric=e.$Qic=void 0;class g{static async installEarlyHandler(r){Error.stackTraceLimit=100;const n=r.get(v.$nj),t=r.get(w.$fN).getProxy(P.$aL.MainThreadErrors);C.setUnexpectedErrorHandler(h=>{n.error(h);const s=C.$3(h);t.$onUnexpectedError(s)})}static async installFullHandler(r){const n=r.get(v.$nj),a=r.get(w.$fN),t=r.get(S.$Fhc),h=r.get(c.$zN),s=a.getProxy(P.$aL.MainThreadExtensionService),d=a.getProxy(P.$aL.MainThreadErrors),u=await t.getExtensionPathIndex(),l=new WeakMap;function p(m,y){if(l.has(m))return l.get(m).stack;let L="",F,z;for(const O of y)L+=`
	at ${O.toString()}`,z=O.getFileName(),!F&&z&&(F=u.findSubstr(f.URI.file(z)));const T=`${m.name||"Error"}: ${m.message||""}${L}`;return l.set(m,{extensionIdentifier:F?.identifier,stack:T}),T}const I=Symbol("prepareStackTrace wrapped");let b=p;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return b},set(m){if(m===p||!m||m[I]){b=m||p;return}b=function(y,L){return p(y,L),m.call(Error,y,L)},Object.assign(b,{[I]:!0})}}),C.setUnexpectedErrorHandler(m=>{n.error(m);const y=C.$3(m),L=l.get(m);if(!L?.extensionIdentifier){d.$onUnexpectedError(y);return}s.$onExtensionRuntimeError(L.extensionIdentifier,y);const F=h.onExtensionError(L.extensionIdentifier,m);n.trace("forwarded error to extension?",F,L)})}}e.$Qic=g;class o{constructor(r,n,a,t,h){this.a=a,this.b=new R.$T8b(r,null,t),n=o.e(n,this.b);const s=new k.$4h(...(0,$.$Zr)());s.set(A.$vN,{_serviceBrand:void 0,...n,messagePorts:h}),s.set(w.$fN,new w.$gN(this.b)),s.set(E.$1gc,new E.$2gc(t)),s.set(S.$Dhc,a);const d=new D.$Eq(s,!0);d.invokeFunction(g.installEarlyHandler),this.d=d.invokeFunction(u=>u.get(v.$nj)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",n),this.c=d.invokeFunction(u=>u.get(S.$Fhc)),this.c.initialize(),d.invokeFunction(g.installFullHandler)}async asBrowserUri(r){const n=this.b.getProxy(P.$aL.MainThreadExtensionService);return f.URI.revive(await n.$asBrowserUri(r))}terminate(r){this.c.terminate(r)}static e(r,n){r.extensions.allExtensions.forEach(t=>{t.extensionLocation=f.URI.revive(n.transformIncomingURIs(t.extensionLocation))}),r.environment.appRoot=f.URI.revive(n.transformIncomingURIs(r.environment.appRoot));const a=r.environment.extensionDevelopmentLocationURI;return a&&(r.environment.extensionDevelopmentLocationURI=a.map(t=>f.URI.revive(n.transformIncomingURIs(t)))),r.environment.extensionTestsLocationURI=f.URI.revive(n.transformIncomingURIs(r.environment.extensionTestsLocationURI)),r.environment.globalStorageHome=f.URI.revive(n.transformIncomingURIs(r.environment.globalStorageHome)),r.environment.workspaceStorageHome=f.URI.revive(n.transformIncomingURIs(r.environment.workspaceStorageHome)),r.environment.extensionTelemetryLogResource=f.URI.revive(n.transformIncomingURIs(r.environment.extensionTelemetryLogResource)),r.nlsBaseUrl=f.URI.revive(n.transformIncomingURIs(r.nlsBaseUrl)),r.logsLocation=f.URI.revive(n.transformIncomingURIs(r.logsLocation)),r.workspace=n.transformIncomingURIs(r.workspace),r}}e.$Ric=o}),define(ke[367],Se([1,0,11,10,222,241,138,97,71,47,20,46,7,60,41,282,283,42,33]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2ic=void 0;let r=class extends v.$Lhc{constructor(s,d,u,l,p,I,b,m){super(s,d,u,l,I,b,m),this.ib=p,this.gb=new t}P(s,d){switch(s.type){case"server":return new c.$Wic(s);case"pipeServer":return new c.$Xic(s);case"executable":return new c.$Yic(s,d.type)}return super.P(s,d)}Z(s,d){const u=c.$Yic.platformAdapterExecutable(d.getAllExtensionDescriptions(),s.type);if(u)return new w.$fM(u.command,u.args,u.options)}Q(){return new R.$G_b}async $runInTerminal(s,d){if(s.kind==="integrated"){this.hb||(this.hb=this.ib.onDidCloseTerminal(O=>{this.gb.onTerminalClosed(O)}));const u=await this.K.getConfigProvider(),l=this.ib.getDefaultShell(!0),p=this.ib.getDefaultShellArgs(!0),I=s.title||f.localize(0,null),b=JSON.stringify({shell:l,shellArgs:p});let m=await this.gb.checkout(b,I),y,L=!1;if(m)y=s.cwd;else{const O={shellPath:l,shellArgs:p,cwd:s.cwd,name:I,iconPath:new w.$0L("debug")};L=!0,m=this.ib.createTerminalFromOptions(O,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.gb.insert(m,b)}m.show(!0);const F=await m.processId;L?await new Promise(O=>setTimeout(O,1e3)):u.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(l.indexOf("powershell")>=0||l.indexOf("pwsh")>=0||l.indexOf("cmd.exe")>=0?m.sendText("cls"):l.indexOf("bash")>=0?m.sendText("clear"):N.$i?m.sendText("cls"):m.sendText("clear"));const z=(0,g.$1ic)(l,s.args,!!s.argsCanBeInterpretedByShell,y,s.env);m.sendText(z);const T=this.onDidTerminateDebugSession(O=>{O.id===d&&(this.gb.free(m),T.dispose())});return F}else if(s.kind==="external")return a(s,await this.K.getConfigProvider());return super.$runInTerminal(s,d)}};e.$2ic=r,e.$2ic=r=Ge([We(0,A.$fN),We(1,S.$4gc),We(2,k.$Fhc),We(3,o.$7gc),We(4,D.$shc),We(5,$.$ghc),We(6,E.$Ihc),We(7,i.$BN)],r);let n;function a(h,s){if(!n)if(N.$i)n=new P.$s$b;else if(N.$j)n=new P.$t$b;else if(N.$k)n=new P.$u$b;else throw new Error("external terminals not supported on this platform");const d=s.getConfiguration("terminal");return n.runInTerminal(h.title,h.cwd,h.args,h.env||{},d.external||{})}class t{constructor(){this.b=new Map}static{this.a=1e3}async checkout(s,d){const l=[...this.b.entries()].map(([p,I])=>(0,C.$Tg)(async b=>{if(p.name!==d||I.lastUsedAt!==-1&&await(0,g.$Zic)(await p.processId))return null;const m=Date.now();return I.lastUsedAt+t.a>m||b.isCancellationRequested||I.config!==s?null:(I.lastUsedAt=m,p)}));return await(0,C.$$g)(l,p=>!!p)}insert(s,d){this.b.set(s,{lastUsedAt:Date.now(),config:d})}free(s){const d=this.b.get(s);d&&(d.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}}),define(ke[368],Se([1,0,17,2,105,41,72,42,40,46,20,27,96,16,13,92,23,63,60]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tic=void 0;let r=class extends w.$vic{constructor(a,t,h,s,d,u,l,p,I){super(a,t,h,s,d,u,l,p),this.C=h,this.D=I,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(E.Schemas.vscodeRemote,{scheme:E.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(E.Schemas.file,{scheme:E.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(a,t){const h=t;if(!t.execution&&h._id===void 0)throw new Error("Tasks to execute must include an execution");if(h._id!==void 0){const s=w.TaskHandleDTO.from(h,this.C),d=await this.a.$getTaskExecution(s);if(d.task===void 0)throw new Error("Task from execution DTO is undefined");const u=await this.z(d,t);return this.a.$executeTask(s).catch(()=>{}),u}else{const s=w.TaskDTO.from(t,a);if(s===void 0)return Promise.reject(new Error("Task is not valid"));w.CustomExecutionDTO.is(s.execution)&&await this.y(s,t,!1);const d=await this.z(await this.a.$getTaskExecution(s),t);return this.a.$executeTask(s).catch(()=>{}),d}}v(a,t,h,s){const d=[];if(s)for(const u of s){this.A(u,h),(!u.definition||!a[u.definition.type])&&this.f.warn(`The task [${u.source}, ${u.name}] uses an undefined task type. The task will be ignored in the future.`);const l=w.TaskDTO.from(u,h.extension);l&&(d.push(l),w.CustomExecutionDTO.is(l.execution)&&t.push(this.y(l,u,!0)))}return{tasks:d,extension:h.extension}}async w(a){return a}async G(a){let t=a&&a.length>0?a[0]:void 0;if(!t){const h=N.URI.file((0,o.homedir)());t=new $.$ni({uri:h,name:g.$Eg(h),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(a,t){const h=N.URI.revive(a),s={process:void 0,variables:Object.create(null)},d=await this.b.resolveWorkspaceFolder(h),u=await this.b.getWorkspaceFolders2()??[],l=await this.D.getResolver(),p=d?{uri:d.uri,name:d.name,index:d.index,toResource:()=>{throw new Error("Not implemented")}}:await this.G(u);for(const I of t.variables)s.variables[I]=await l.resolveAsync(p,I);if(t.process!==void 0){let I;if(t.process.path!==void 0){I=t.process.path.split(C.$tc);for(let b=0;b<I.length;b++)I[b]=await l.resolveAsync(p,I[b])}s.process=await f.win32.findExecutable(await l.resolveAsync(p,t.process.name),t.process.cwd!==void 0?await l.resolveAsync(p,t.process.cwd):void 0,I)}return s}async $jsonTasksSupported(){return!0}async $findExecutable(a,t,h){return f.win32.findExecutable(a,t,h)}};e.$Tic=r,e.$Tic=r=Ge([We(0,A.$fN),We(1,D.$vN),We(2,P.$4gc),We(3,R.$qN),We(4,v.$7gc),We(5,k.$shc),We(6,S.$nj),We(7,c.$Lgc),We(8,i.$Ihc)],r)}),define(ke[369],Se([1,0,63,60]),function(ge,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zjc=void 0;class f extends N.$Jhc{m(){return(0,C.homedir)()}}e.$zjc=f}),define(ke[154],Se([1,0,19,11,21,44,16,17,23,2,36]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6hc=e.$5hc=e.$4hc=e.$3hc=void 0;class D{constructor(i,r,n,a){this.d=i,this.e=r,this.f=n,this.g=a,this.a=null,this.b=!1,this.c=0}search(i,r){const n=this.d.folderQueries||[],a=new f.$6d(r);return new Promise((t,h)=>{this.a=new E(i);let s=!1;const d=(u,l)=>{if(!s&&!this.b){const p=this.h(u);c(u)&&typeof this.d.maxResults=="number"&&this.c+p>this.d.maxResults&&(this.b=!0,s=!0,a.cancel(),u=this.j(u,this.d.maxResults-this.c));const I=this.h(u);this.c+=I,(I>0||!c(u))&&this.a.add(u,l)}};Promise.all(n.map((u,l)=>this.k(u,p=>d(p,l),a.token))).then(u=>{a.dispose(),this.a.flush();const l=u.some(p=>!!p&&!!p.limitHit);t({limitHit:this.b||l,messages:(0,C.$Rb)(u.map(p=>p?.message?Array.isArray(p.message)?p.message:[p.message]:[])),stats:{type:this.g}})},u=>{a.dispose();const l=(0,P.$Qi)(u);h(new Error(l))})})}h(i){return c(i)?Array.isArray(i.ranges)?i.ranges.length:1:0}j(i,r){const n=Array.isArray(i.ranges)?i.ranges:[i.ranges],a=Array.isArray(i.preview.matches)?i.preview.matches:[i.preview.matches];return{ranges:n.slice(0,r),preview:{matches:a.slice(0,r),text:i.preview.text},uri:i.uri}}async k(i,r,n){const a=new A.$QJ(this.d,i),t=[],h={report:u=>{if(!this.l(u))return;const l=i.folder.scheme===R.Schemas.file?(0,A.$RJ)(()=>this.f.readdir($.$Gg(u.uri))):void 0,p=$.$Jg(i.folder,u.uri);if(p){const I=a.includedInQuery(p,v.$nc(p),l);(0,N.$Sg)(I)?t.push(I.then(b=>{b&&r(u)})):I&&r(u)}}},s=this.n(i),d=await this.e.provideTextSearchResults(w(this.d.contentPattern),s,h,n);return t.length&&await Promise.all(t),d}l(i){if(c(i)){if(Array.isArray(i.ranges)){if(!Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(i.preview.matches.length!==i.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(i.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(i){const r=(0,A.$PJ)(this.d.includePattern,i.includePattern),n=(0,A.$PJ)(this.d.excludePattern,i.excludePattern),a={folder:k.URI.from(i.folder),excludes:n,includes:r,useIgnoreFiles:!i.disregardIgnoreFiles,useGlobalIgnoreFiles:!i.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!i.disregardParentIgnoreFiles,followSymlinks:!i.ignoreSymlinks,encoding:i.fileEncoding&&this.f.toCanonicalName(i.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return a.usePCRE2=this.d.usePCRE2,a}}e.$3hc=D;function w(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class E{constructor(i){this.e=i,this.b=-1,this.d=null,this.a=new g(512,r=>this.g(r))}add(i,r){this.d&&(this.b!==r||!$.$Ag(this.c,i.uri))&&(this.f(),this.d=null),this.d||(this.b=r,this.d={resource:i.uri,results:[]}),this.d.results.push(S(i))}f(){const i=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,i)}flush(){this.f(),this.a.flush()}g(i){this.e(i)}}e.$4hc=E;function S(o){return c(o)?{preview:{matches:(0,C.$2b)(o.preview.matches,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character})),text:o.preview.text},ranges:(0,C.$2b)(o.ranges,i=>({startLineNumber:i.start.line,startColumn:i.start.character,endLineNumber:i.end.line,endColumn:i.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function c(o){return!!o.preview}e.$5hc=c;class g{static{this.a=4e3}static{this.b=50}constructor(i,r){this.g=i,this.h=r,this.c=0,this.d=[],this.e=0}addItem(i,r){i&&this.j(i,r)}addItems(i,r){i&&this.k(i,r)}j(i,r){this.d.push(i),this.e+=r,this.l()}k(i,r){this.d=this.d.concat(i),this.e+=r,this.l()}l(){this.c<g.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},g.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$6hc=g}),define(ke[98],Se([1,0,3,6,5,362,20,66,13,2,154]),function(ge,e,C,N,f,P,R,v,$,k,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9hc=e.$8hc=e.$7hc=void 0,e.$7hc=(0,f.$6h)("IExtHostSearch");let D=class{constructor(c,g,o){this.k=c,this.l=g,this.n=o,this.c=this.k.getProxy(N.$aL.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new P.$2hc}o(c){return this.l.transformOutgoingScheme(c)}registerTextSearchProvider(c,g){if(this.g.has(c))throw new Error(`a text search provider for the scheme '${c}' is already registered`);this.g.add(c);const o=this.d++;return this.e.set(o,g),this.c.$registerTextSearchProvider(o,this.o(c)),(0,C.$Rc)(()=>{this.g.delete(c),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(c,g){if(this.i.has(c))throw new Error(`a file search provider for the scheme '${c}' is already registered`);this.i.add(c);const o=this.d++;return this.h.set(o,g),this.c.$registerFileSearchProvider(o,this.o(c)),(0,C.$Rc)(()=>{this.i.delete(c),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(c,g,o,i){const r=w(o),n=this.h.get(c);if(n)return this.j.fileSearch(r,n,a=>{this.c.$handleFileMatch(c,g,a.map(t=>t.resource))},i);throw new Error("unknown provider: "+c)}async doInternalFileSearchWithCustomCallback(c,g,o){return{messages:[]}}$clearCache(c){return this.j.clearCache(c),Promise.resolve(void 0)}$provideTextSearchResults(c,g,o,i){const r=this.e.get(c);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${c}`);const n=w(o);return this.q(n,r).search(t=>this.c.$handleTextMatch(c,g,t),i)}$enableExtensionHostSearch(){}q(c,g){return new A.$3hc(c,g,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.$8hc=D,e.$8hc=D=Ge([We(0,R.$fN),We(1,v.$1gc),We(2,$.$nj)],D);function w(S){return{...S,folderQueries:S.folderQueries&&S.folderQueries.map(E),extraFileResources:S.extraFileResources&&S.extraFileResources.map(c=>k.URI.revive(c))}}e.$9hc=w;function E(S){return{...S,folder:k.URI.revive(S.folder)}}}),define(ke[370],Se([1,0,21,14,4,3,16,39,2,132,191,172,79,25,32,13,65,88,266,6,311,341,92,312,317,318,319,320,321,298,287,33,322,42,323,97,147,324,300,313,325,326,72,71,314,47,327,69,328,59,27,342,343,315,301,329,330,114,115,302,361,332,272,333,344,334,152,303,335,336,337,20,338,98,116,339,304,340,117,94,96,91,46,345,346,316,347,348,70,15,7,305,66,306,93,349,350,146,41,280,113,26,95]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h,s,d,u,l,p,I,b,m,y,L,F,z,T,O,M,j,U,K,ue,X,Q,Z,le,re,$e,oe,J,V,ie,ye,de,fe,_,ee,G,x,me,pe,Re,ve,Ie,B,Y,te,q,ae,he,Ae,je,He,Qe,_e,at,st,rt,Pe,ze,Le,Ye,ne,se,Ce,qe,Ze,it,nt,Oe,yt,Dt,Nt,Tt,Et,Ht,Ot,Zt,Wt,Ut,et,Gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lic=void 0;function Kt(ht){const $t=ht.get(J.$vN),Bt=ht.get(oe.$Igc),Qt=ht.get(re.$9gc),kt=ht.get(Z.$Fhc),ft=ht.get(Zt.$4gc),It=ht.get(Le.$zN),_t=ht.get(L.$7gc),Lt=ht.get(Dt.$1gc),Ke=ht.get(Ae.$fN),Mt=ht.get(rt.$phc),jt=ht.get(Pe.$0gc),Yt=ht.get(c.$oj),gt=ht.get(c.$nj),Ft=ht.get(it.$6yb),Rt=ht.get(t.$Lgc),Vt=ht.get(Ot.$Kic),Me=ht.get(Qe.$xhc),Te=ht.get(X.$ghc),De=ht.get(G.$Bhc);Ke.set(r.$bL.ExtHostFileSystemInfo,Bt),Ke.set(r.$bL.ExtHostLogLevelServiceShape,Yt),Ke.set(r.$bL.ExtHostWorkspace,ft),Ke.set(r.$bL.ExtHostConfiguration,_t),Ke.set(r.$bL.ExtHostExtensionService,kt),Ke.set(r.$bL.ExtHostStorage,Mt),Ke.set(r.$bL.ExtHostTunnelService,Ft),Ke.set(r.$bL.ExtHostWindow,Vt),Ke.set(r.$bL.ExtHostSecretState,Me),Ke.set(r.$bL.ExtHostTelemetry,It),Ke.set(r.$bL.ExtHostEditorTabs,Te),Ke.set(r.$bL.ExtHostManagedSockets,De);const ce=Ke.set(r.$bL.ExtHostDecorations,ht.get(T.$Qhc)),Ne=Ke.set(r.$bL.ExtHostDocumentsAndEditors,ht.get(ue.$qN)),Be=Ke.set(r.$bL.ExtHostCommands,ht.get(m.$BN)),xe=Ke.set(r.$bL.ExtHostTerminalService,ht.get(Ye.$shc)),Je=Ke.set(r.$bL.ExtHostDebugService,ht.get(z.$Khc)),ct=Ke.set(r.$bL.ExtHostSearch,ht.get(He.$7hc)),pt=Ke.set(r.$bL.ExtHostTask,ht.get(ze.$xic)),Jt=Ke.set(r.$bL.ExtHostOutputService,ht.get(Y.$kic)),St=Ke.set(r.$bL.ExtHostLocalization,ht.get(ee.$Ahc)),Ct=Ke.set(r.$bL.ExtHostUrls,new Nt.$Hic(Ke)),vt=Ke.set(r.$bL.ExtHostDocuments,new K.$Ggc(Ke,Ne)),Si=Ke.set(r.$bL.ExtHostDocumentContentProviders,new j.$Shc(Ke,Ne,gt)),Ji=Ke.set(r.$bL.ExtHostDocumentSaveParticipant,new U.$Thc(gt,vt,Ke.getProxy(r.$aL.MainThreadBulkEdits))),Pt=Ke.set(r.$bL.ExtHostNotebook,new me.$0hc(Ke,Be,Ne,vt,Qt,ct)),si=Ke.set(r.$bL.ExtHostNotebookDocuments,new Re.$eic(Pt)),mi=Ke.set(r.$bL.ExtHostNotebookEditors,new ve.$fic(gt,Pt)),ui=Ke.set(r.$bL.ExtHostNotebookKernels,new Ie.$gic(Ke,$t,Pt,Be,gt)),Di=Ke.set(r.$bL.ExtHostNotebookRenderers,new B.$iic(Ke,Pt)),Ci=Ke.set(r.$bL.ExtHostNotebookDocumentSaveParticipant,new pe.$dic(gt,Pt,Ke.getProxy(r.$aL.MainThreadBulkEdits))),zt=Ke.set(r.$bL.ExtHostEditors,new se.$Xgc(Ke,Ne)),$i=Ke.set(r.$bL.ExtHostTreeViews,new Ze.$Fic(Ke.getProxy(r.$aL.MainThreadTreeViews),Be,gt)),Ii=Ke.set(r.$bL.ExtHostEditorInsets,new b.$Ygc(Ke.getProxy(r.$aL.MainThreadEditorInsets),zt,$t.remote)),li=Ke.set(r.$bL.ExtHostDiagnostics,new O.$Kgc(Ke,gt,Bt,Ne)),hi=Ke.set(r.$bL.ExtHostLanguages,new _.$bic(Ke,vt,Be.converter,Lt)),dt=Ke.set(r.$bL.ExtHostLanguageFeatures,new fe.$Ogc(Ke,Lt,vt,Be,li,gt,Rt,It)),Ki=Ke.set(r.$bL.ExtHostFileSystem,new le.$Vhc(Ke,dt)),ei=Ke.set(r.$bL.ExtHostFileSystemEventService,new $e.$Whc(Ke,gt,Ne)),oi=Ke.set(r.$bL.ExtHostQuickOpen,(0,he.$oic)(Ke,ft,Be)),bi=Ke.set(r.$bL.ExtHostSCM,new je.$qic(Ke,Be,vt,gt)),Pi=Ke.set(r.$bL.ExtHostQuickDiff,new ae.$nic(Ke,Lt)),Qi=Ke.set(r.$bL.ExtHostShare,new _e.$ric(Ke,Lt)),Li=Ke.set(r.$bL.ExtHostComments,(0,y.$Zgc)(Ke,Be,vt)),wi=Ke.set(r.$bL.ExtHostProgress,new q.$mic(Ke.getProxy(r.$aL.MainThreadProgress))),Yi=Ke.set(r.$bL.ExtHostLabelService,new de.$aic(Ke)),Ri=Ke.set(r.$bL.ExtHostTheming,new Ce.$Cic(Ke)),di=Ke.set(r.$bL.ExtHostAuthentication,new h.$Qgc(Ke)),Zi=Ke.set(r.$bL.ExtHostTimeline,new qe.$Eic(Ke,Be)),vi=Ke.set(r.$bL.ExtHostWebviews,new Tt.$bhc(Ke,$t.remote,ft,gt,Rt)),Ai=Ke.set(r.$bL.ExtHostWebviewPanels,new Et.$ehc(Ke,vi,ft)),ln=Ke.set(r.$bL.ExtHostCustomEditors,new F.$fhc(Ke,vt,jt,vi,Ai)),Mi=Ke.set(r.$bL.ExtHostWebviewViews,new Ht.$Iic(Ke,vi)),ai=Ke.set(r.$bL.ExtHostTesting,new ne.$yic(Ke,gt,Be,Ne)),hn=Ke.set(r.$bL.ExtHostUriOpeners,new yt.$Gic(Ke)),dn=Ke.set(r.$bL.ExtHostProfileContentHandlers,new te.$lic(Ke));Ke.set(r.$bL.ExtHostInteractive,new ie.$$hc(Ke,Pt,Ne,Be,gt));const Xi=Ke.set(r.$bL.ExtHostInlineChat,new V.$Xhc(Ke,Be,vt,gt)),Fi=Ke.set(r.$bL.ExtHostChatProvider,new l.$Tgc(Ke,gt)),Ni=Ke.set(r.$bL.ExtHostChatAgents2,new u.$Ugc(Ke,Fi,gt)),xi=Ke.set(r.$bL.ExtHostChatVariables,new p.$Vgc(Ke)),pi=Ke.set(r.$bL.ExtHostChat,new d.$Sgc(Ke)),Ti=Ke.set(r.$bL.ExtHostAiRelatedInformation,new n.$Fgc(Ke)),fn=Ke.set(r.$bL.ExtHostAiEmbeddingVector,new Q.$Uhc(Ke)),yi=Ke.set(r.$bL.ExtHostIssueReporter,new ye.$_hc(Ke)),Oi=Ke.set(r.$bL.ExtHostStatusBar,new st.$uic(Ke,Be.converter)),ni=Ke.set(r.$bL.ExtHostSpeech,new at.$sic(Ke)),Ei=Object.values(r.$bL);Ke.assertRegistered(Ei);const gn=new s.$Rgc(Ke,Ne),Xt=new I.$Wgc(Ke),fi=new x.$cic(Ke,gt),ji=new M.$Rhc(Ke);return a.$Pgc.register(Be),function(Ve,ti,zi){function ot(be){return(Ee,Ue,ut)=>{const wt=be(At=>{try{Ee.call(Ue,At)}catch(un){N.$2(new Error(`[ExtensionListenerError] Extension '${Ve.identifier.value}' FAILED to handle event`,{cause:un})),It.onExtensionError(Ve.identifier,un)}});return ut?.push(wt),wt}}const bt=function(){let be=!Ve.isUnderDevelopment;function Ee(){be||(gt.info(`Extension '${Ve.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Ue(ut){if(Array.isArray(ut))ut.forEach(Ue);else if(typeof ut=="string")Ee();else{const wt=ut;typeof wt.scheme>"u"&&Ee(),typeof wt.exclusive=="boolean"&&(0,et.$GF)(Ve,"documentFiltersExclusive")}return ut}}(),_i={getSession(be,Ee,Ue){return di.getSession(Ve,be,Ee,Ue)},getSessions(be,Ee){return(0,et.$GF)(Ve,"authGetSessions"),di.getSessions(Ve,be,Ee)},async hasSession(be,Ee){return(0,et.$GF)(Ve,"authSession"),!!await di.getSession(Ve,be,Ee,{silent:!0})},get onDidChangeSessions(){return ot(di.onDidChangeSessions)},registerAuthenticationProvider(be,Ee,Ue,ut){return di.registerAuthenticationProvider(be,Ee,Ue,ut)}},mn={registerCommand(be,Ee,Ue){return Be.registerCommand(!0,be,Ee,Ue,void 0,Ve)},registerTextEditorCommand(be,Ee,Ue){return Be.registerCommand(!0,be,(...ut)=>{const wt=zt.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+be+" because there is no active text editor.");return}return wt.edit(At=>{Ee.apply(Ue,[wt,At,...ut])}).then(At=>{At||gt.warn("Edits from command "+be+" were not applied.")},At=>{gt.warn("An error occurred while running command "+be,At)})},void 0,void 0,Ve)},registerDiffInformationCommand:(be,Ee,Ue)=>((0,et.$GF)(Ve,"diffCommand"),Be.registerCommand(!0,be,async(...ut)=>{const wt=Ne.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+be+" because there is no active text editor.");return}const At=await zt.getDiffInformation(wt.id);Ee.apply(Ue,[At,...ut])},void 0,void 0,Ve)),executeCommand(be,...Ee){return Be.executeCommand(be,...Ee)},getCommands(be=!1){return Be.getCommands(be)}},en={get machineId(){return $t.telemetryInfo.machineId},get sessionId(){return $t.telemetryInfo.sessionId},get language(){return $t.environment.appLanguage},get appName(){return $t.environment.appName},get appRoot(){return $t.environment.appRoot?.fsPath??""},get appHost(){return $t.environment.appHost},get uriScheme(){return $t.environment.appUriScheme},get clipboard(){return Xt.value},get shell(){return xe.getDefaultShell(!1)},get onDidChangeShell(){return ot(xe.onDidChangeShell)},get isTelemetryEnabled(){return It.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return ot(It.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,et.$GF)(Ve,"telemetry"),It.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,et.$GF)(Ve,"telemetry"),ot(It.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,Le.$yN)($t.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,Ee){return Le.$xN.validateSender(be),It.instantiateLogger(Ve,be,Ee)},openExternal(be,Ee){return Vt.openUri(be,{allowTunneling:!!$t.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===$t.environment.appUriScheme)return Ct.createAppUri(be);try{return await Vt.asExternalUri(be,{allowTunneling:!!$t.remote.authority})}catch(Ee){if((0,R.$eg)(be,R.Schemas.http)||(0,R.$eg)(be,R.Schemas.https))return be;throw Ee}},get remoteName(){return(0,g.$bl)($t.remote.authority)},get remoteAuthority(){return(0,et.$GF)(Ve,"resolvers"),$t.remote.authority},get uiKind(){return $t.uiKind},get logLevel(){return gt.getLevel()},get onDidChangeLogLevel(){return ot(gt.onDidChangeLogLevel)},registerIssueUriRequestHandler(be){return(0,et.$GF)(Ve,"handleIssueUri"),yi.registerIssueUriRequestHandler(Ve,be)},registerIssueDataProvider(be){return(0,et.$GF)(Ve,"handleIssueUri"),yi.registerIssueDataProvider(Ve,be)},get appQuality(){return(0,et.$GF)(Ve,"resolvers"),$t.quality},get appCommit(){return(0,et.$GF)(Ve,"resolvers"),$t.commit}};$t.environment.extensionTestsLocationURI||Object.freeze(en);const tn={createTestController(be,Ee,Ue){return ai.createTestController(Ve,be,Ee,Ue)},createTestObserver(){return(0,et.$GF)(Ve,"testObserver"),ai.createTestObserver()},runTests(be){return(0,et.$GF)(Ve,"testObserver"),ai.runTests(be)},get onDidChangeTestResults(){return(0,et.$GF)(Ve,"testObserver"),ot(ai.onResultsChanged)},get testResults(){return(0,et.$GF)(Ve,"testObserver"),ai.results}},gi=$t.remote.isRemote?Oe.ExtensionKind.Workspace:Oe.ExtensionKind.UI,nn={getExtension(be,Ee){(0,et.$FF)(Ve,"extensionsAny")||(Ee=!1);const Ue=ti.mine.getExtensionDescription(be);if(Ue)return new Z.$Ghc(kt,Ve.identifier,Ue,gi,!1);if(Ee){const ut=ti.all.getExtensionDescription(be);if(ut)return new Z.$Ghc(kt,Ve.identifier,ut,gi,!0)}},get all(){const be=[];for(const Ee of ti.mine.getAllExtensionDescriptions())be.push(new Z.$Ghc(kt,Ve.identifier,Ee,gi,!1));return be},get allAcrossExtensionHosts(){(0,et.$GF)(Ve,"extensionsAny");const be=new E.$mm(ti.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),Ee=[];for(const Ue of ti.all.getAllExtensionDescriptions()){const ut=!be.has(Ue.identifier);Ee.push(new Z.$Ghc(kt,Ve.identifier,Ue,gi,ut))}return Ee},get onDidChange(){return(0,et.$FF)(Ve,"extensionsAny")?ot(f.Event.any(ti.mine.onDidChange,ti.all.onDidChange)):ot(ti.mine.onDidChange)}},rn={createDiagnosticCollection(be){return li.createDiagnosticCollection(Ve.identifier,be)},get onDidChangeDiagnostics(){return ot(li.onDidChangeDiagnostics)},getDiagnostics:be=>li.getDiagnostics(be),getLanguages(){return hi.getLanguages()},setTextDocumentLanguage(be,Ee){return hi.changeLanguage(be.uri,Ee)},match(be,Ee){const Ue=vt.getDocumentData(Ee.uri)?.notebook;return(0,A.$Bt)(nt.LanguageSelector.from(be),Ee.uri,Ee.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(be,Ee,Ue){return dt.registerCodeActionProvider(Ve,bt(be),Ee,Ue)},registerDocumentPasteEditProvider(be,Ee,Ue){return(0,et.$GF)(Ve,"documentPaste"),dt.registerDocumentPasteEditProvider(Ve,bt(be),Ee,Ue)},registerCodeLensProvider(be,Ee){return dt.registerCodeLensProvider(Ve,bt(be),Ee)},registerDefinitionProvider(be,Ee){return dt.registerDefinitionProvider(Ve,bt(be),Ee)},registerDeclarationProvider(be,Ee){return dt.registerDeclarationProvider(Ve,bt(be),Ee)},registerImplementationProvider(be,Ee){return dt.registerImplementationProvider(Ve,bt(be),Ee)},registerTypeDefinitionProvider(be,Ee){return dt.registerTypeDefinitionProvider(Ve,bt(be),Ee)},registerHoverProvider(be,Ee){return dt.registerHoverProvider(Ve,bt(be),Ee,Ve.identifier)},registerEvaluatableExpressionProvider(be,Ee){return dt.registerEvaluatableExpressionProvider(Ve,bt(be),Ee,Ve.identifier)},registerInlineValuesProvider(be,Ee){return dt.registerInlineValuesProvider(Ve,bt(be),Ee,Ve.identifier)},registerDocumentHighlightProvider(be,Ee){return dt.registerDocumentHighlightProvider(Ve,bt(be),Ee)},registerMultiDocumentHighlightProvider(be,Ee){return dt.registerMultiDocumentHighlightProvider(Ve,bt(be),Ee)},registerLinkedEditingRangeProvider(be,Ee){return dt.registerLinkedEditingRangeProvider(Ve,bt(be),Ee)},registerReferenceProvider(be,Ee){return dt.registerReferenceProvider(Ve,bt(be),Ee)},registerRenameProvider(be,Ee){return dt.registerRenameProvider(Ve,bt(be),Ee)},registerDocumentSymbolProvider(be,Ee,Ue){return dt.registerDocumentSymbolProvider(Ve,bt(be),Ee,Ue)},registerWorkspaceSymbolProvider(be){return dt.registerWorkspaceSymbolProvider(Ve,be)},registerDocumentFormattingEditProvider(be,Ee){return dt.registerDocumentFormattingEditProvider(Ve,bt(be),Ee)},registerDocumentRangeFormattingEditProvider(be,Ee){return dt.registerDocumentRangeFormattingEditProvider(Ve,bt(be),Ee)},registerOnTypeFormattingEditProvider(be,Ee,Ue,...ut){return dt.registerOnTypeFormattingEditProvider(Ve,bt(be),Ee,[Ue].concat(ut))},registerDocumentSemanticTokensProvider(be,Ee,Ue){return dt.registerDocumentSemanticTokensProvider(Ve,bt(be),Ee,Ue)},registerDocumentRangeSemanticTokensProvider(be,Ee,Ue){return dt.registerDocumentRangeSemanticTokensProvider(Ve,bt(be),Ee,Ue)},registerSignatureHelpProvider(be,Ee,Ue,...ut){return typeof Ue=="object"?dt.registerSignatureHelpProvider(Ve,bt(be),Ee,Ue):dt.registerSignatureHelpProvider(Ve,bt(be),Ee,typeof Ue>"u"?[]:[Ue,...ut])},registerCompletionItemProvider(be,Ee,...Ue){return dt.registerCompletionItemProvider(Ve,bt(be),Ee,Ue)},registerInlineCompletionItemProvider(be,Ee,Ue){return Ee.handleDidShowCompletionItem&&(0,et.$GF)(Ve,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,et.$GF)(Ve,"inlineCompletionsAdditions"),Ue&&(0,et.$GF)(Ve,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider(Ve,bt(be),Ee,Ue)},registerDocumentLinkProvider(be,Ee){return dt.registerDocumentLinkProvider(Ve,bt(be),Ee)},registerColorProvider(be,Ee){return dt.registerColorProvider(Ve,bt(be),Ee)},registerFoldingRangeProvider(be,Ee){return dt.registerFoldingRangeProvider(Ve,bt(be),Ee)},registerSelectionRangeProvider(be,Ee){return dt.registerSelectionRangeProvider(Ve,be,Ee)},registerCallHierarchyProvider(be,Ee){return dt.registerCallHierarchyProvider(Ve,be,Ee)},registerTypeHierarchyProvider(be,Ee){return dt.registerTypeHierarchyProvider(Ve,be,Ee)},setLanguageConfiguration:(be,Ee)=>dt.setLanguageConfiguration(Ve,be,Ee),getTokenInformationAtPosition(be,Ee){return(0,et.$GF)(Ve,"tokenInformation"),hi.tokenAtPosition(be,Ee)},registerInlayHintsProvider(be,Ee){return dt.registerInlayHintsProvider(Ve,be,Ee)},createLanguageStatusItem(be,Ee){return hi.createLanguageStatusItem(Ve,be,Ee)},registerDocumentDropEditProvider(be,Ee,Ue){return dt.registerDocumentOnDropEditProvider(Ve,be,Ee,(0,et.$FF)(Ve,"dropMetadata")?Ue:void 0)}},sn={get activeTextEditor(){return zt.getActiveTextEditor()},get visibleTextEditors(){return zt.getVisibleTextEditors()},get activeTerminal(){return xe.activeTerminal},get terminals(){return xe.terminals},async showTextDocument(be,Ee,Ue){const ut=await($.URI.isUri(be)?Promise.resolve(on.openTextDocument(be)):Promise.resolve(be));return zt.showTextDocument(ut,Ee,Ue)},createTextEditorDecorationType(be){return zt.createTextEditorDecorationType(Ve,be)},onDidChangeActiveTextEditor(be,Ee,Ue){return ot(zt.onDidChangeActiveTextEditor)(be,Ee,Ue)},onDidChangeVisibleTextEditors(be,Ee,Ue){return ot(zt.onDidChangeVisibleTextEditors)(be,Ee,Ue)},onDidChangeTextEditorSelection(be,Ee,Ue){return ot(zt.onDidChangeTextEditorSelection)(be,Ee,Ue)},onDidChangeTextEditorOptions(be,Ee,Ue){return ot(zt.onDidChangeTextEditorOptions)(be,Ee,Ue)},onDidChangeTextEditorVisibleRanges(be,Ee,Ue){return ot(zt.onDidChangeTextEditorVisibleRanges)(be,Ee,Ue)},onDidChangeTextEditorViewColumn(be,Ee,Ue){return ot(zt.onDidChangeTextEditorViewColumn)(be,Ee,Ue)},onDidCloseTerminal(be,Ee,Ue){return ot(xe.onDidCloseTerminal)(be,Ee,Ue)},onDidOpenTerminal(be,Ee,Ue){return ot(xe.onDidOpenTerminal)(be,Ee,Ue)},onDidChangeActiveTerminal(be,Ee,Ue){return ot(xe.onDidChangeActiveTerminal)(be,Ee,Ue)},onDidChangeTerminalDimensions(be,Ee,Ue){return(0,et.$GF)(Ve,"terminalDimensions"),ot(xe.onDidChangeTerminalDimensions)(be,Ee,Ue)},onDidChangeTerminalState(be,Ee,Ue){return ot(xe.onDidChangeTerminalState)(be,Ee,Ue)},onDidWriteTerminalData(be,Ee,Ue){return(0,et.$GF)(Ve,"terminalDataWriteEvent"),ot(xe.onDidWriteTerminalData)(be,Ee,Ue)},onDidExecuteTerminalCommand(be,Ee,Ue){return(0,et.$GF)(Ve,"terminalExecuteCommandEvent"),ot(xe.onDidExecuteTerminalCommand)(be,Ee,Ue)},get state(){return Vt.getState(Ve)},onDidChangeWindowState(be,Ee,Ue){return ot(Vt.onDidChangeWindowState)(be,Ee,Ue)},showInformationMessage(be,...Ee){return fi.showMessage(Ve,v.default.Info,be,Ee[0],Ee.slice(1))},showWarningMessage(be,...Ee){return fi.showMessage(Ve,v.default.Warning,be,Ee[0],Ee.slice(1))},showErrorMessage(be,...Ee){return fi.showMessage(Ve,v.default.Error,be,Ee[0],Ee.slice(1))},showQuickPick(be,Ee,Ue){return oi.showQuickPick(Ve,be,Ee,Ue)},showWorkspaceFolderPick(be){return oi.showWorkspaceFolderPick(be)},showInputBox(be,Ee){return oi.showInput(be,Ee)},showOpenDialog(be){return ji.showOpenDialog(Ve,be)},showSaveDialog(be){return ji.showSaveDialog(be)},createStatusBarItem(be,Ee,Ue){let ut,wt,At;return typeof be=="string"?(ut=be,wt=Ee,At=Ue):(wt=be,At=Ee),Oi.createStatusBarEntry(Ve,ut,wt,At)},setStatusBarMessage(be,Ee){return Oi.setStatusBarMessage(be,Ee)},withScmProgress(be){return Rt.report("window.withScmProgress",Ve,"Use 'withProgress' instead."),wi.withProgress(Ve,{location:Oe.ProgressLocation.SourceControl},(Ee,Ue)=>be({report(ut){}}))},withProgress(be,Ee){return wi.withProgress(Ve,be,Ee)},createOutputChannel(be,Ee){return Jt.createOutputChannel(be,Ee,Ve)},createWebviewPanel(be,Ee,Ue,ut){return Ai.createWebviewPanel(Ve,be,Ee,Ue,ut)},createWebviewTextEditorInset(be,Ee,Ue,ut){return(0,et.$GF)(Ve,"editorInsets"),Ii.createWebviewEditorInset(be,Ee,Ue,ut,Ve)},createTerminal(be,Ee,Ue){return typeof be=="object"?"pty"in be?xe.createExtensionTerminal(be):xe.createTerminalFromOptions(be):xe.createTerminal(be,Ee,Ue)},registerTerminalLinkProvider(be){return xe.registerLinkProvider(be)},registerTerminalProfileProvider(be,Ee){return xe.registerProfileProvider(Ve,be,Ee)},registerTerminalQuickFixProvider(be,Ee){return(0,et.$GF)(Ve,"terminalQuickFixProvider"),xe.registerTerminalQuickFixProvider(be,Ve.identifier.value,Ee)},registerTreeDataProvider(be,Ee){return $i.registerTreeDataProvider(be,Ee,Ve)},createTreeView(be,Ee){return $i.createTreeView(be,Ee,Ve)},registerWebviewPanelSerializer:(be,Ee)=>Ai.registerWebviewPanelSerializer(Ve,be,Ee),registerCustomEditorProvider:(be,Ee,Ue={})=>ln.registerCustomEditorProvider(Ve,be,Ee,Ue),registerFileDecorationProvider(be){return ce.registerFileDecorationProvider(be,Ve)},registerUriHandler(be){return Ct.registerUriHandler(Ve,be)},createQuickPick(){return oi.createQuickPick(Ve)},createInputBox(){return oi.createInputBox(Ve)},get activeColorTheme(){return Ri.activeColorTheme},onDidChangeActiveColorTheme(be,Ee,Ue){return ot(Ri.onDidChangeActiveColorTheme)(be,Ee,Ue)},registerWebviewViewProvider(be,Ee,Ue){return Mi.registerWebviewViewProvider(Ve,be,Ee,Ue?.webviewOptions)},get activeNotebookEditor(){return Pt.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,Ee,Ue){return ot(Pt.onDidChangeActiveNotebookEditor)(be,Ee,Ue)},get visibleNotebookEditors(){return Pt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return ot(Pt.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(be,Ee,Ue){return ot(mi.onDidChangeNotebookEditorSelection)(be,Ee,Ue)},onDidChangeNotebookEditorVisibleRanges(be,Ee,Ue){return ot(mi.onDidChangeNotebookEditorVisibleRanges)(be,Ee,Ue)},showNotebookDocument(be,Ee){return Pt.showNotebookDocument(be,Ee)},registerExternalUriOpener(be,Ee,Ue){return(0,et.$GF)(Ve,"externalUriOpener"),hn.registerExternalUriOpener(Ve.identifier,be,Ee,Ue)},registerProfileContentHandler(be,Ee){return(0,et.$GF)(Ve,"profileContentHandlers"),dn.registerProfileContentHandler(Ve,be,Ee)},registerQuickDiffProvider(be,Ee,Ue,ut){return(0,et.$GF)(Ve,"quickDiffProvider"),Pi.registerQuickDiffProvider(bt(be),Ee,Ue,ut)},get tabGroups(){return Te.tabGroups},registerShareProvider(be,Ee){return(0,et.$GF)(Ve,"shareProvider"),Qi.registerShareProvider(bt(be),Ee)}},on={get rootPath(){return Rt.report("workspace.rootPath",Ve,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(be){throw new N.$9("rootPath")},getWorkspaceFolder(be){return ft.getWorkspaceFolder(be)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(be){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(be){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(be,Ee,...Ue)=>ft.updateWorkspaceFolders(Ve,be,Ee||0,...Ue),onDidChangeWorkspaceFolders:function(be,Ee,Ue){return ot(ft.onDidChangeWorkspace)(be,Ee,Ue)},asRelativePath:(be,Ee)=>ft.getRelativePath(be,Ee),findFiles:(be,Ee,Ue,ut)=>ft.findFiles(be,Ee,Ue,Ve.identifier,ut),findTextInFiles:(be,Ee,Ue,ut)=>{(0,et.$GF)(Ve,"findTextInFiles");let wt,At;return typeof Ee=="object"?(wt=Ee,At=Ue):(wt={},At=Ee,ut=Ue),ft.findTextInFiles(be,wt||{},At,Ve.identifier,ut)},save:be=>ft.save(be),saveAs:be=>ft.saveAs(be),saveAll:be=>ft.saveAll(be),applyEdit(be,Ee){return gn.applyWorkspaceEdit(be,Ve,Ee)},createFileSystemWatcher:(be,Ee,Ue,ut)=>{let wt;return typeof Ee=="boolean"?wt={ignoreCreateEvents:!!Ee,ignoreChangeEvents:!!Ue,ignoreDeleteEvents:!!ut,correlate:!1}:Ee&&((0,et.$GF)(Ve,"createFileSystemWatcher"),wt={...Ee,correlate:!0}),ei.createFileSystemWatcher(ft,Ve,be,wt)},get textDocuments(){return vt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw new N.$9("textDocuments")},openTextDocument(be){let Ee;const Ue=be;if(typeof be=="string")Ee=Promise.resolve($.URI.file(be));else if($.URI.isUri(be))Ee=Promise.resolve(be);else if(!Ue||typeof Ue=="object")Ee=vt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ut=>vt.ensureDocumentData(ut).then(wt=>wt.document))},onDidOpenTextDocument:(be,Ee,Ue)=>ot(vt.onDidAddDocument)(be,Ee,Ue),onDidCloseTextDocument:(be,Ee,Ue)=>ot(vt.onDidRemoveDocument)(be,Ee,Ue),onDidChangeTextDocument:(be,Ee,Ue)=>ot(vt.onDidChangeDocument)(be,Ee,Ue),onDidSaveTextDocument:(be,Ee,Ue)=>ot(vt.onDidSaveDocument)(be,Ee,Ue),onWillSaveTextDocument:(be,Ee,Ue)=>ot(Ji.getOnWillSaveTextDocumentEvent(Ve))(be,Ee,Ue),get notebookDocuments(){return Pt.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,Ee){let Ue;if($.URI.isUri(be))Ue=be,await Pt.openNotebookDocument(be);else if(typeof be=="string")Ue=$.URI.revive(await Pt.createNotebookDocument({viewType:be,content:Ee}));else throw new Error("Invalid arguments");return Pt.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(be,Ee,Ue){return ot(si.onDidSaveNotebookDocument)(be,Ee,Ue)},onDidChangeNotebookDocument(be,Ee,Ue){return ot(si.onDidChangeNotebookDocument)(be,Ee,Ue)},onWillSaveNotebookDocument(be,Ee,Ue){return ot(Ci.getOnWillSaveNotebookDocumentEvent(Ve))(be,Ee,Ue)},get onDidOpenNotebookDocument(){return ot(Pt.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return ot(Pt.onDidCloseNotebookDocument)},registerNotebookSerializer(be,Ee,Ue,ut){return Pt.registerNotebookSerializer(Ve,be,Ee,Ue,(0,et.$FF)(Ve,"notebookLiveShare")?ut:void 0)},onDidChangeConfiguration:(be,Ee,Ue)=>ot(zi.onDidChangeConfiguration)(be,Ee,Ue),getConfiguration(be,Ee){return Ee=arguments.length===1?void 0:Ee,zi.getConfiguration(be,Ee,Ve)},registerTextDocumentContentProvider(be,Ee){return Si.registerTextDocumentContentProvider(be,Ee)},registerTaskProvider:(be,Ee)=>(Rt.report("window.registerTaskProvider",Ve,"Use the corresponding function on the 'tasks' namespace instead"),pt.registerTaskProvider(Ve,be,Ee)),registerFileSystemProvider(be,Ee,Ue){return(0,P.$Qc)(Ki.registerFileSystemProvider(Ve,be,Ee,Ue),Qt.addFileSystemProvider(be,Ee,Ue))},get fs(){return Qt.value},registerFileSearchProvider:(be,Ee)=>((0,et.$GF)(Ve,"fileSearchProvider"),ct.registerFileSearchProvider(be,Ee)),registerTextSearchProvider:(be,Ee)=>((0,et.$GF)(Ve,"textSearchProvider"),ct.registerTextSearchProvider(be,Ee)),registerRemoteAuthorityResolver:(be,Ee)=>((0,et.$GF)(Ve,"resolvers"),kt.registerRemoteAuthorityResolver(be,Ee)),registerResourceLabelFormatter:be=>((0,et.$GF)(Ve,"resolvers"),Yi.$registerResourceLabelFormatter(be)),getRemoteExecServer:be=>((0,et.$GF)(Ve,"resolvers"),kt.getRemoteExecServer(be)),onDidCreateFiles:(be,Ee,Ue)=>ot(ei.onDidCreateFile)(be,Ee,Ue),onDidDeleteFiles:(be,Ee,Ue)=>ot(ei.onDidDeleteFile)(be,Ee,Ue),onDidRenameFiles:(be,Ee,Ue)=>ot(ei.onDidRenameFile)(be,Ee,Ue),onWillCreateFiles:(be,Ee,Ue)=>ot(ei.getOnWillCreateFileEvent(Ve))(be,Ee,Ue),onWillDeleteFiles:(be,Ee,Ue)=>ot(ei.getOnWillDeleteFileEvent(Ve))(be,Ee,Ue),onWillRenameFiles:(be,Ee,Ue)=>ot(ei.getOnWillRenameFileEvent(Ve))(be,Ee,Ue),openTunnel:be=>((0,et.$GF)(Ve,"tunnels"),Ft.openTunnel(Ve,be).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,et.$GF)(Ve,"tunnels"),Ft.getTunnels()},onDidChangeTunnels:(be,Ee,Ue)=>((0,et.$GF)(Ve,"tunnels"),ot(Ft.onDidChangeTunnels)(be,Ee,Ue)),registerPortAttributesProvider:(be,Ee)=>((0,et.$GF)(Ve,"portsAttributes"),Ft.registerPortsAttributesProvider(be,Ee)),registerTunnelProvider:(be,Ee)=>((0,et.$GF)(Ve,"tunnelFactory"),Ft.registerTunnelProvider(be,Ee)),registerTimelineProvider:(be,Ee)=>((0,et.$GF)(Ve,"timeline"),Zi.registerTimelineProvider(be,Ee,Ve.identifier,Be.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:be=>((0,et.$GF)(Ve,"workspaceTrust"),ft.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,Ee,Ue)=>ot(ft.onDidGrantWorkspaceTrust)(be,Ee,Ue),registerEditSessionIdentityProvider:(be,Ee)=>((0,et.$GF)(Ve,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(be,Ee)),onWillCreateEditSessionIdentity:(be,Ee,Ue)=>((0,et.$GF)(Ve,"editSessionIdentityProvider"),ot(ft.getOnWillCreateEditSessionIdentityEvent(Ve))(be,Ee,Ue)),registerCanonicalUriProvider:(be,Ee)=>((0,et.$GF)(Ve,"canonicalUriProvider"),ft.registerCanonicalUriProvider(be,Ee)),getCanonicalUri:(be,Ee,Ue)=>((0,et.$GF)(Ve,"canonicalUriProvider"),ft.provideCanonicalUri(be,Ee,Ue))},$n={get inputBox(){return Rt.report("scm.inputBox",Ve,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox(Ve)},createSourceControl(be,Ee,Ue){return bi.createSourceControl(Ve,be,Ee,Ue)}},an={createCommentController(be,Ee){return Li.createCommentController(Ve,be,Ee)}},cn={get activeDebugSession(){return Je.activeDebugSession},get activeDebugConsole(){return Je.activeDebugConsole},get breakpoints(){return Je.breakpoints},get stackFrameFocus(){return Je.stackFrameFocus},registerDebugVisualizationProvider(be,Ee){return(0,et.$GF)(Ve,"debugVisualization"),Je.registerDebugVisualizationProvider(Ve,be,Ee)},onDidStartDebugSession(be,Ee,Ue){return ot(Je.onDidStartDebugSession)(be,Ee,Ue)},onDidTerminateDebugSession(be,Ee,Ue){return ot(Je.onDidTerminateDebugSession)(be,Ee,Ue)},onDidChangeActiveDebugSession(be,Ee,Ue){return ot(Je.onDidChangeActiveDebugSession)(be,Ee,Ue)},onDidReceiveDebugSessionCustomEvent(be,Ee,Ue){return ot(Je.onDidReceiveDebugSessionCustomEvent)(be,Ee,Ue)},onDidChangeBreakpoints(be,Ee,Ue){return ot(Je.onDidChangeBreakpoints)(be,Ee,Ue)},onDidChangeStackFrameFocus(be,Ee,Ue){return(0,et.$GF)(Ve,"debugFocus"),ot(Je.onDidChangeStackFrameFocus)(be,Ee,Ue)},registerDebugConfigurationProvider(be,Ee,Ue){return Je.registerDebugConfigurationProvider(be,Ee,Ue||Wt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,Ee){return Je.registerDebugAdapterDescriptorFactory(Ve,be,Ee)},registerDebugAdapterTrackerFactory(be,Ee){return Je.registerDebugAdapterTrackerFactory(be,Ee)},startDebugging(be,Ee,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?Je.startDebugging(be,Ee,{parentSession:Ue}):Je.startDebugging(be,Ee,Ue||{})},stopDebugging(be){return Je.stopDebugging(be)},addBreakpoints(be){return Je.addBreakpoints(be)},removeBreakpoints(be){return Je.removeBreakpoints(be)},asDebugSourceUri(be,Ee){return Je.asDebugSourceUri(be,Ee)}},Ui={registerTaskProvider:(be,Ee)=>pt.registerTaskProvider(Ve,be,Ee),fetchTasks:be=>pt.fetchTasks(be),executeTask:be=>pt.executeTask(Ve,be),get taskExecutions(){return pt.taskExecutions},onDidStartTask:(be,Ee,Ue)=>ot(pt.onDidStartTask)(be,Ee,Ue),onDidEndTask:(be,Ee,Ue)=>ot(pt.onDidEndTask)(be,Ee,Ue),onDidStartTaskProcess:(be,Ee,Ue)=>ot(pt.onDidStartTaskProcess)(be,Ee,Ue),onDidEndTaskProcess:(be,Ee,Ue)=>ot(pt.onDidEndTaskProcess)(be,Ee,Ue)},Bi={createNotebookController(be,Ee,Ue,ut,wt){return ui.createNotebookController(Ve,be,Ee,Ue,ut,(0,et.$FF)(Ve,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(be,Ee)=>Pt.registerNotebookCellStatusBarItemProvider(Ve,be,Ee),createRendererMessaging(be){return Di.createRendererMessaging(Ve,be)},createNotebookControllerDetectionTask(be){return(0,et.$GF)(Ve,"notebookKernelSource"),ui.createNotebookControllerDetectionTask(Ve,be)},registerKernelSourceActionProvider(be,Ee){return(0,et.$GF)(Ve,"notebookKernelSource"),ui.registerKernelSourceActionProvider(Ve,be,Ee)},onDidChangeNotebookCellExecutionState(be,Ee,Ue){return(0,et.$GF)(Ve,"notebookCellExecutionState"),ot(ui.onDidChangeNotebookCellExecutionState)(be,Ee,Ue)}},Vi={t(...be){if(typeof be[0]=="string"){const Ee=be.shift(),Ue=!be||typeof be[0]!="object"?be:be[0];return St.getMessage(Ve.identifier.value,{message:Ee,args:Ue})}return St.getMessage(Ve.identifier.value,be[0])},get bundle(){return St.getBundle(Ve.identifier.value)},get uri(){return St.getBundleUri(Ve.identifier.value)}},ki={_version:1,registerInteractiveEditorSessionProvider(be,Ee){return(0,et.$GF)(Ve,"interactive"),Xi.registerProvider(Ve,be,Ee)},registerInteractiveSessionProvider(be,Ee){return(0,et.$GF)(Ve,"interactive"),pi.registerChatProvider(Ve,be,Ee)},sendInteractiveRequestToProvider(be,Ee){return(0,et.$GF)(Ve,"interactive"),pi.sendInteractiveRequestToProvider(be,Ee)},transferChatSession(be,Ee){return(0,et.$GF)(Ve,"interactive"),pi.transferChatSession(be,Ee)}},Wi={getRelatedInformation(be,Ee){return(0,et.$GF)(Ve,"aiRelatedInformation"),Ti.getRelatedInformation(Ve,be,Ee)},registerRelatedInformationProvider(be,Ee){return(0,et.$GF)(Ve,"aiRelatedInformation"),Ti.registerRelatedInformationProvider(Ve,be,Ee)},registerEmbeddingVectorProvider(be,Ee){return(0,et.$GF)(Ve,"aiRelatedInformation"),fn.registerEmbeddingVectorProvider(Ve,be,Ee)}},qi={registerChatResponseProvider(be,Ee,Ue){return(0,et.$GF)(Ve,"chatProvider"),Fi.registerProvider(Ve.identifier,be,Ee,Ue)},requestChatAccess(be){return(0,et.$GF)(Ve,"chatRequestAccess"),Fi.requestChatResponseProvider(Ve.identifier,be)},registerVariable(be,Ee,Ue){return(0,et.$GF)(Ve,"chatAgents2"),xi.registerVariableResolver(Ve,be,Ee,Ue)},registerMappedEditsProvider(be,Ee){return(0,et.$GF)(Ve,"mappedEditsProvider"),dt.registerMappedEditsProvider(Ve,be,Ee)},createChatAgent(be,Ee){return(0,et.$GF)(Ve,"chatAgents2"),Ni.createChatAgent(Ve,be,Ee)}},bn={registerSpeechProvider(be,Ee){return(0,et.$GF)(Ve,"speech"),ni.registerProvider(Ve.identifier,be,Ee)}};return{version:$t.version,ai:Wi,authentication:_i,commands:mn,comments:an,chat:qi,debug:cn,env:en,extensions:nn,interactive:ki,l10n:Vi,languages:rn,notebooks:Bi,scm:$n,speech:bn,tasks:Ui,tests:tn,window:sn,workspace:on,Breakpoint:Oe.$bM,TerminalOutputAnchor:Oe.TerminalOutputAnchor,ChatAgentResultFeedbackKind:Oe.ChatAgentResultFeedbackKind,ChatMessage:Oe.$7M,ChatMessageRole:Oe.ChatMessageRole,ChatVariableLevel:Oe.ChatVariableLevel,ChatAgentCompletionItem:Oe.$6M,CallHierarchyIncomingCall:Oe.$AL,CallHierarchyItem:Oe.$zL,CallHierarchyOutgoingCall:Oe.$BL,CancellationError:N.$5,CancellationTokenSource:C.$6d,CandidatePortSource:r.CandidatePortSource,CodeAction:Oe.$wL,CodeActionKind:Oe.$xL,CodeActionTriggerKind:Oe.CodeActionTriggerKind,CodeLens:Oe.$CL,Color:Oe.$PL,ColorInformation:Oe.$QL,ColorPresentation:Oe.$RL,ColorThemeKind:Oe.ColorThemeKind,CommentMode:Oe.CommentMode,CommentState:Oe.CommentState,CommentThreadCollapsibleState:Oe.CommentThreadCollapsibleState,CommentThreadState:Oe.CommentThreadState,CompletionItem:Oe.$JL,CompletionItemKind:Oe.CompletionItemKind,CompletionItemTag:Oe.CompletionItemTag,CompletionList:Oe.$KL,CompletionTriggerKind:Oe.CompletionTriggerKind,ConfigurationTarget:Oe.ConfigurationTarget,CustomExecution:Oe.$ZL,DebugAdapterExecutable:Oe.$fM,DebugAdapterInlineImplementation:Oe.$iM,DebugAdapterNamedPipeServer:Oe.$hM,DebugAdapterServer:Oe.$gM,DebugConfigurationProviderTriggerKind:Wt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:Oe.DebugConsoleMode,DebugVisualization:Oe.$xM,DecorationRangeBehavior:Oe.DecorationRangeBehavior,Diagnostic:Oe.$qL,DiagnosticRelatedInformation:Oe.$pL,DiagnosticSeverity:Oe.DiagnosticSeverity,DiagnosticTag:Oe.DiagnosticTag,Disposable:Oe.$cL,DocumentHighlight:Oe.$sL,DocumentHighlightKind:Oe.DocumentHighlightKind,MultiDocumentHighlight:Oe.$tL,DocumentLink:Oe.$OL,DocumentSymbol:Oe.$vL,EndOfLine:Oe.EndOfLine,EnvironmentVariableMutatorType:Oe.EnvironmentVariableMutatorType,EvaluatableExpression:Oe.$lM,InlineValueText:Oe.$mM,InlineValueVariableLookup:Oe.$nM,InlineValueEvaluatableExpression:Oe.$oM,InlineCompletionTriggerKind:Oe.InlineCompletionTriggerKind,EventEmitter:f.$Vd,ExtensionKind:Oe.ExtensionKind,ExtensionMode:Oe.ExtensionMode,ExternalUriOpenerPriority:Oe.ExternalUriOpenerPriority,FileChangeType:Oe.FileChangeType,FileDecoration:Oe.$zM,FileDecoration2:Oe.$zM,FileSystemError:Oe.$qM,FileType:S.FileType,FilePermission:S.FilePermission,FoldingRange:Oe.$rM,FoldingRangeKind:Oe.FoldingRangeKind,FunctionBreakpoint:Oe.$dM,InlineCompletionItem:Oe.$LL,InlineCompletionList:Oe.$ML,Hover:Oe.$rL,IndentAction:D.IndentAction,Location:Oe.$oL,MarkdownString:Oe.$DL,OverviewRulerLane:w.OverviewRulerLane,ParameterInformation:Oe.$EL,PortAutoForwardAction:Oe.PortAutoForwardAction,Position:Oe.$dL,ProcessExecution:Oe.$XL,ProgressLocation:Oe.ProgressLocation,QuickInputButtons:Oe.$yM,Range:Oe.$eL,RelativePattern:Oe.$_L,Selection:Oe.$fL,SelectionRange:Oe.$yL,SemanticTokens:Oe.$uM,SemanticTokensBuilder:Oe.$tM,SemanticTokensEdit:Oe.$vM,SemanticTokensEdits:Oe.$wM,SemanticTokensLegend:Oe.$sM,ShellExecution:Oe.$YL,ShellQuoting:Oe.ShellQuoting,SignatureHelp:Oe.$GL,SignatureHelpTriggerKind:Oe.SignatureHelpTriggerKind,SignatureInformation:Oe.$FL,SnippetString:Oe.$nL,SourceBreakpoint:Oe.$cM,StandardTokenType:Oe.StandardTokenType,StatusBarAlignment:Oe.StatusBarAlignment,SymbolInformation:Oe.$uL,SymbolKind:Oe.SymbolKind,SymbolTag:Oe.SymbolTag,Task:Oe.$1L,TaskGroup:Oe.$WL,TaskPanelKind:Oe.TaskPanelKind,TaskRevealKind:Oe.TaskRevealKind,TaskScope:Oe.TaskScope,TerminalLink:Oe.$SL,TerminalQuickFixTerminalCommand:Oe.$UL,TerminalQuickFixOpener:Oe.$TL,TerminalLocation:Oe.TerminalLocation,TerminalProfile:Oe.$VL,TerminalExitReason:Oe.TerminalExitReason,TextDocumentSaveReason:Oe.TextDocumentSaveReason,TextEdit:Oe.$jL,SnippetTextEdit:Oe.$lL,TextEditorCursorStyle:k.TextEditorCursorStyle,TextEditorLineNumbersStyle:Oe.TextEditorLineNumbersStyle,TextEditorRevealType:Oe.TextEditorRevealType,TextEditorSelectionChangeKind:Oe.TextEditorSelectionChangeKind,SyntaxTokenType:Oe.SyntaxTokenType,TextDocumentChangeReason:Oe.TextDocumentChangeReason,ThemeColor:Oe.$$L,ThemeIcon:Oe.$0L,TreeItem:Oe.$2L,TreeItemCheckboxState:Oe.TreeItemCheckboxState,TreeItemCollapsibleState:Oe.TreeItemCollapsibleState,TypeHierarchyItem:Oe.$UM,UIKind:Ut.UIKind,Uri:$.URI,ViewColumn:Oe.ViewColumn,WorkspaceEdit:Oe.$mL,DocumentDropEdit:Oe.$8L,DocumentPasteEdit:Oe.$9L,InlayHint:Oe.$IL,InlayHintLabelPart:Oe.$HL,InlayHintKind:Oe.InlayHintKind,RemoteAuthorityResolverError:Oe.$iL,ResolvedAuthority:Oe.$gL,ManagedResolvedAuthority:Oe.$hL,SourceControlInputBoxValidationType:Oe.SourceControlInputBoxValidationType,ExtensionRuntime:Oe.ExtensionRuntime,TimelineItem:Oe.$JM,NotebookRange:Oe.$BM,NotebookCellKind:Oe.NotebookCellKind,NotebookCellExecutionState:Oe.NotebookCellExecutionState,NotebookCellData:Oe.$CM,NotebookData:Oe.$DM,NotebookRendererScript:Oe.$HM,NotebookCellStatusBarAlignment:Oe.NotebookCellStatusBarAlignment,NotebookEditorRevealType:Oe.NotebookEditorRevealType,NotebookCellOutput:Oe.$FM,NotebookCellOutputItem:Oe.$EM,NotebookCellStatusBarItem:Oe.$GM,NotebookControllerAffinity:Oe.NotebookControllerAffinity,NotebookControllerAffinity2:Oe.NotebookControllerAffinity2,NotebookEdit:Oe.$kL,NotebookKernelSourceAction:Oe.$IM,NotebookVariablesRequestKind:Oe.NotebookVariablesRequestKind,PortAttributes:Oe.$LM,LinkedEditingRanges:Oe.$KM,TestResultState:Oe.TestResultState,TestRunRequest:Oe.$MM,TestMessage:Oe.$NM,TestMessage2:Oe.$NM,TestTag:Oe.$OM,TestRunProfileKind:Oe.TestRunProfileKind,TextSearchCompleteMessageType:Gt.TextSearchCompleteMessageType,DataTransfer:Oe.$7L,DataTransferItem:Oe.$3L,CoveredCount:Oe.$PM,FileCoverage:Oe.$QM,StatementCoverage:Oe.$RM,BranchCoverage:Oe.$SM,FunctionCoverage:Oe.$TM,WorkspaceTrustState:Oe.WorkspaceTrustState,LanguageStatusSeverity:Oe.LanguageStatusSeverity,QuickPickItemKind:Oe.QuickPickItemKind,InputBoxValidationSeverity:Oe.InputBoxValidationSeverity,TabInputText:Oe.$VM,TabInputTextDiff:Oe.$WM,TabInputTextMerge:Oe.$XM,TabInputCustom:Oe.$YM,TabInputNotebook:Oe.$1M,TabInputNotebookDiff:Oe.$2M,TabInputWebview:Oe.$ZM,TabInputTerminal:Oe.$3M,TabInputInteractiveWindow:Oe.$4M,TabInputChat:Oe.$5M,TelemetryTrustedValue:o.$Lo,LogLevel:c.LogLevel,EditSessionIdentityMatch:i.EditSessionIdentityMatch,InteractiveSessionVoteDirection:Oe.InteractiveSessionVoteDirection,ChatAgentCopyKind:Oe.ChatAgentCopyKind,InteractiveEditorResponseFeedbackKind:Oe.InteractiveEditorResponseFeedbackKind,StackFrameFocus:Oe.$jM,ThreadFocus:Oe.$kM,RelatedInformationType:Oe.RelatedInformationType,SpeechToTextStatus:Oe.SpeechToTextStatus,KeywordRecognitionStatus:Oe.KeywordRecognitionStatus}}}e.$Lic=Kt}),define(ke[371],Se([1,0,84,152,41,147,42,33,72,46,96,97,98,117,70,92,146,69,59,116,91,71,145,13,60,114,115]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h,s,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Yr)(d.$Ahc,d.$zhc,1),(0,C.$Yr)(h.$oj,t.$Mic,1),(0,C.$Yr)(c.$Lgc,c.$Mgc,1),(0,C.$Yr)(v.$BN,v.$AN,0),(0,C.$Yr)(R.$7gc,R.$5gc,0),(0,C.$Yr)(o.$9gc,o.$8gc,0),(0,C.$Yr)(D.$Khc,D.$Ohc,0),(0,C.$Yr)(P.$Qhc,P.$Phc,0),(0,C.$Yr)($.$qN,$.$pN,0),(0,C.$Yr)(u.$Bhc,u.$Chc,0),(0,C.$Yr)(i.$Igc,i.$Hgc,0),(0,C.$Yr)(N.$kic,N.$jic,1),(0,C.$Yr)(w.$7hc,w.$8hc,0),(0,C.$Yr)(E.$phc,E.$ohc,0),(0,C.$Yr)(A.$xic,A.$wic,0),(0,C.$Yr)(k.$shc,k.$vhc,0),(0,C.$Yr)(S.$6yb,S.$7yb,0),(0,C.$Yr)(g.$Kic,g.$Jic,0),(0,C.$Yr)(f.$4gc,f.$3gc,0),(0,C.$Yr)(r.$xhc,r.$whc,0),(0,C.$Yr)(n.$zN,n.$wN,0),(0,C.$Yr)(a.$ghc,a.$hhc,0),(0,C.$Yr)(s.$Ihc,s.$Jhc,0)}),define(ke[119],Se([1,0,19,13,36,95]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5ic=e.$4ic=e.$3ic=void 0;function R(D){return D.startsWith("**")||D.startsWith("/")?D:`/${D}`}e.$3ic=R;function v(D,w,E,S){const c=(0,C.$2b)(E,$),g=new f.$CJ(w,c,S),o=g.preview.matches;return{ranges:(0,C.$2b)(c,k),uri:D,preview:{text:g.preview.text,matches:(0,C.$2b)(o,k)}}}e.$4ic=v;function $(D){return new f.$DJ(D.start.line,D.start.character,D.end.line,D.end.character)}function k(D){return new P.$rJ(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn)}let A=class{constructor(w,E){this.a=w,this.b=E}appendLine(w){this.b.debug(`${this.a}#search`,w)}};e.$5ic=A,e.$5ic=A=Ge([We(1,N.$nj)],A)}),define(ke[372],Se([1,0,50,17,76,34,10,12,119,373]),function(ge,e,C,N,f,P,R,v,$,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8ic=e.$7ic=e.$6ic=void 0;const A=k.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function D(r,n,a,t){const h=w(r,n,a,t),s=n.folder.fsPath;return{cmd:C.spawn(A,h.args,{cwd:s}),rgDiskPath:A,siblingClauses:h.siblingClauses,rgArgs:h,cwd:s}}e.$6ic=D;function w(r,n,a,t){const h=["--files","--hidden","--case-sensitive","--no-require-git"];S([n],a,!1).forEach(d=>{const u=(0,$.$3ic)(d);if(h.push("-g",u),R.$j){const l=(0,f.$Hl)(u);l!==u&&h.push("-g",l)}});const s=E([n],t,void 0,!1);return s.globArgs.forEach(d=>{const u=`!${(0,$.$3ic)(d)}`;if(h.push("-g",u),R.$j){const l=(0,f.$Hl)(u);l!==u&&h.push("-g",l)}}),n.disregardIgnoreFiles!==!1?h.push("--no-ignore"):n.disregardParentIgnoreFiles!==!1&&h.push("--no-ignore-parent"),n.ignoreSymlinks||h.push("--follow"),r.exists&&h.push("--quiet"),h.push("--no-config"),n.disregardGlobalIgnoreFiles&&h.push("--no-ignore-global"),{args:h,siblingClauses:s.siblingClauses}}function E(r,n,a,t=!0){const h=[];let s={};return r.forEach(d=>{const u=Object.assign({},d.excludePattern||{},n||{}),l=c(u,t?d.folder.fsPath:void 0,a);h.push(...l.globArgs),l.siblingClauses&&(s=Object.assign(s,l.siblingClauses))}),{globArgs:h,siblingClauses:s}}function S(r,n,a=!0){const t=[];return r.forEach(h=>{const s=Object.assign({},n||{},h.includePattern||{}),d=c(s,a?h.folder.fsPath:void 0);t.push(...d.globArgs)}),t}function c(r,n,a){const t=[],h={};return Object.keys(r).forEach(s=>{if(a&&a.has(s)||!s)return;const d=r[s];s=o(n?g(n,s):s),s.startsWith("\\\\")?s="\\\\"+s.substr(2).replace(/\\/g,"/"):s=s.replace(/\\/g,"/"),typeof d=="boolean"&&d?(s.startsWith("\\\\")&&(s+="**"),t.push(i(s))):d&&d.when&&(h[s]=d)}),{globArgs:t,siblingClauses:h}}function g(r,n){return N.$ic(n)?n:N.$jc(r,n)}e.$7ic=g;function o(r){return r=v.$Ue(r,"\\"),v.$Ue(r,"/")}function i(r){return P.$4f(r).toLowerCase()==="c:/"?r.replace(/^c:[/\\]/i,"/"):r}e.$8ic=i}),define(ke[374],Se([1,0,50,57,17,375,19,44,35,76,34,10,38,12,18,31,36,372,129]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0ic=e.$9ic=void 0;const r=new Set;process.on("exit",()=>{r.forEach(s=>s())});class n{constructor(d){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=d,this.b=d.filePattern||"",this.d=d.includePattern&&$.$Mj(d.includePattern),this.f=d.maxResults||null,this.g=!!d.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,i.$Zq)(this.b).normalizedLowercase),this.u=d.excludePattern&&$.$Mj(d.excludePattern),this.t=new Map,d.folderQueries.forEach(u=>{const l=Object.assign({},u.excludePattern||{},this.a.excludePattern||{}),p=u.folder.fsPath;d.folderQueries.map(I=>I.folder.fsPath).filter(I=>I!==p).forEach(I=>{(0,A.$8f)(I,p)&&(l[f.$lc(p,I)]=!0)}),this.t.set(p,new t(l,p))})}cancel(){this.l=!0,r.forEach(d=>d())}walk(d,u,l,p,I){if(this.m=w.$Rd.create(!1),this.l)return I(null,this.j);u.forEach(b=>{const m=f.$nc(b.fsPath);this.u&&this.u(b.fsPath,m)||this.J(l,{relativePath:b.fsPath,searchPath:void 0})}),this.r=w.$Rd.create(!1),this.w(d,(b,m)=>{this.x(this.y,this,b,l,p,y=>{if(y){const L=(0,v.$Qi)(y);console.error(L),this.q.push(L),m(y,void 0)}else m(null,void 0)})},(b,m)=>{this.m.stop();const y=b?R.$Hb(b)[0]:null;I(y,this.j)})}w(d,u,l){const p=new Array(d.length),I=new Array(d.length);let b=!1,m=0;if(d.length===0)return l(null,[]);d.forEach((y,L)=>{u(y,(F,z)=>{if(F?(b=!0,p[L]=null,I[L]=F):(p[L]=z,I[L]=null),++m===d.length)return l(b?I:null,p)})})}x(d,u,...l){try{d.apply(u,l)}catch(p){l[l.length-1](p)}}y(d,u,l,p){const I=d.folder.fsPath,b=D.$j,m=()=>T&&T.kill();r.add(m);let y=U=>{r.delete(m),y=()=>{},p(U)},L="";const F=this.D(),z=(0,o.$6ic)(this.a,d,this.a.includePattern,this.t.get(d.folder.fsPath).expression),T=z.cmd,O=!Object.keys(z.siblingClauses).length,M=z.rgArgs.args.map(U=>U.match(/^-/)?U:`'${U}'`).join(" ");let j=`${z.rgDiskPath} ${M}
 - cwd: ${z.cwd}`;z.rgArgs.siblingClauses&&(j+=`
 - Sibling clauses: ${JSON.stringify(z.rgArgs.siblingClauses)}`),l({message:j}),this.s=0,this.z(T,"utf8",l,(U,K,ue)=>{if(U){y(U);return}if(this.j){y();return}const Q=(L+(b?k.$Gl(K||""):K)).split(`
`);if(ue){const Z=Q.length;Q[Z-1]=Q[Z-1].trim(),Q[Z-1]||Q.pop()}else L=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){y(new Error("Splitting up files failed"));return}if(this.s+=Q.length,O){for(const Z of Q)if(this.J(u,{base:I,relativePath:Z,searchPath:this.N(d,Z)}),this.j){m();break}(ue||this.j)&&y();return}this.G(d,F,I,Q,u),ue&&(this.H(F,I,u),y())})}spawnFindCmd(d){const u=this.t.get(d.folder.fsPath),l=u.getBasenameTerms(),p=u.getPathTerms(),I=["-L","."];if(l.length||p.length){I.push("-not","(","(");for(const b of l)I.push("-name",b),I.push("-o");for(const b of p)I.push("-path",b),I.push("-o");I.pop(),I.push(")","-prune",")")}return I.push("-type","f"),C.spawn("find",I,{cwd:d.folder.fsPath})}readStdout(d,u,l){let p="";this.z(d,u,()=>{},(I,b,m)=>{if(I){l(I);return}p+=b,m&&l(null,p)})}z(d,u,l,p){let I=(y,L,F)=>{(y||F)&&(I=()=>{},this.r?.stop()),p(y,L,F)},b=!1;d.stdout?(this.A(d.stdout,u,I),d.stdout.once("data",()=>b=!0)):l({message:"stdout is null"});let m;d.stderr?m=this.B(d.stderr):l({message:"stderr is null"}),d.on("error",y=>{I(y)}),d.on("close",y=>{let L;!b&&(L=this.C(m,u))&&h(L)?I(new Error(`command failed with error code ${y}: ${this.C(m,u)}`)):(this.g&&y===0&&(this.j=!0),I(null,"",!0))})}A(d,u,l){const p=new P.StringDecoder(u);return d.on("data",I=>{l(null,p.write(I))}),p}B(d){const u=[];return d.on("data",l=>{u.push(l)}),u}C(d,u){const l=new P.StringDecoder(u);return d.map(p=>l.write(p)).join("")}D(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}G(d,{pathToEntries:u},l,p,I){p.indexOf(this.b)!==-1&&this.J(I,{base:l,relativePath:this.b,searchPath:this.N(d,this.b)});const b=m=>{const y=f.$nc(m),L=f.$mc(m);let F=u[L];F||(F=u[L]=[],b(L)),F.push({base:l,relativePath:m,basename:y,searchPath:this.N(d,m)})};p.forEach(b)}H({rootEntries:d,pathToEntries:u},l,p){const I=this,b=this.t.get(l),m=this.b;function y(L){I.o++;const F=(0,g.$SJ)(()=>L.map(z=>z.basename));for(let z=0,T=L.length;z<T;z++){const O=L[z],{relativePath:M,basename:j}=O;if(b.test(M,j,m!==j?F:void 0))continue;const U=u[M];if(U)y(U);else{if(I.p++,M===m)continue;I.J(p,O)}if(I.j)break}}y(d)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(d,u,l,p,I){const b=d.folder,m=(0,g.$SJ)(()=>l);this.w(l,(y,L)=>{if(this.l||this.j)return L(null);const F=u?[u,y].join(f.sep):y;if(this.t.get(d.folder.fsPath).test(F,y,this.a.filePattern!==y?m:void 0))return L(null);const z=[b.fsPath,F].join(f.sep);N.lstat(z,(T,O)=>{if(T||this.l||this.j)return L(null);this.L(z,O,(M,j)=>M||this.l||this.j?L(null):j.isDirectory()?(this.o++,this.M(z,O,(U,K)=>U||this.l||this.j||(K=K||"",this.v[K])?L(null):(this.v[K]=!0,c.Promises.readdir(z).then(ue=>{if(this.l||this.j)return L(null);this.I(d,F,ue,p,X=>L(X||null))},ue=>{L(null)})))):(this.p++,F===this.b||this.h&&S.$Mf(j.size)&&j.size>this.h||this.J(p,{base:b.fsPath,relativePath:F,searchPath:this.N(d,F)}),L(null,void 0)))})},y=>{const L=y&&R.$Hb(y);return I(L&&L.length>0?L[0]:void 0)})}J(d,u){this.K(u)&&(!this.d||this.d(u.relativePath,f.$nc(u.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||d(u))}K(d){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,g.$NJ)(d,this.c)}return!0}L(d,u,l){return u.isSymbolicLink()?N.stat(d,l):l(null,u)}M(d,u,l){return u.isSymbolicLink()?N.realpath(d,(p,I)=>p?l(p):l(null,I)):l(null,d)}N(d,u){return d.folderName?f.$jc(d.folderName,u):u}}e.$9ic=n;class a{constructor(d){this.a=d.folderQueries,this.b=d.extraFileResources||[],this.c=new n(d)}search(d,u,l){this.c.walk(this.a,this.b,d,u,(p,I)=>{l(p,{limitHit:I,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.$0ic=a;class t{constructor(d,u){this.expression=d,this.c=u,this.d(d)}d(d){let u,l;Object.keys(d).filter(p=>d[p]).forEach(p=>{f.$ic(p)?(u=u||$.$Hj(),u[p]=d[p]):(l=l||$.$Hj(),l[p]=d[p])}),this.a=u&&$.$Mj(u,{trimForExclusions:!0}),this.b=l&&$.$Mj(l,{trimForExclusions:!0})}test(d,u,l){return this.b&&this.b(d,u,l)||this.a&&this.a(f.$jc(this.c,d),u,l)}getBasenameTerms(){const d=[];return this.a&&d.push(...$.$Oj(this.a)),this.b&&d.push(...$.$Oj(this.b)),d}getPathTerms(){const d=[];return this.a&&d.push(...$.$Pj(this.a)),this.b&&d.push(...$.$Pj(this.b)),d}}function h(s){const d=s.trim().split(`
`),u=d[0].trim();if(u.startsWith("Error parsing regex"))return u;if(u.startsWith("regex parse error"))return E.$Af(d[d.length-1].trim());if(u.startsWith("error parsing glob")||u.startsWith("unsupported encoding"))return u.charAt(0).toUpperCase()+u.substr(1);if(u==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(u.startsWith("Literal "))return u}}),define(ke[376],Se([1,0,99,22,186,21]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wD=e.$vD=e.$uD=e.$tD=e.$sD=e.$rD=e.$qD=e.$pD=e.$oD=e.DecodeStreamErrorKind=e.$nD=e.$mD=e.$lD=e.$kD=e.$jD=e.$iD=e.$hD=e.$gD=void 0,e.$gD="utf8",e.$hD="utf8bom",e.$iD="utf16be",e.$jD="utf16le";function R(u){return[e.$gD,e.$hD,e.$iD,e.$jD].some(l=>l===u)}e.$kD=R,e.$lD=[254,255],e.$mD=[255,254],e.$nD=[239,187,191];const v=512,$=512,k=512*8,A=512*128;var D;(function(u){u[u.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(D||(e.DecodeStreamErrorKind=D={}));class w extends Error{constructor(l,p){super(l),this.decodeStreamErrorKind=p}}e.$oD=w;class E{static async create(l){let p;if(l!==e.$gD)p=(await(0,f.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getDecoder(o(l));else{const I=new TextDecoder;p={write(b){return I.decode(b,{stream:!0})},end(){return I.decode()}}}return new E(p)}constructor(l){this.a=l}write(l){return this.a.write(l)}end(){return this.a.end()}}function S(u,l){const p=l.minBytesRequiredForDetection??l.guessEncoding?k:$;return new Promise((I,b)=>{const m=(0,C.$0d)(O=>O.join("")),y=[];let L=0,F;const z=new P.$6d,T=async()=>{try{const O=await d({buffer:N.$je.concat(y),bytesRead:L},l.guessEncoding);if(O.seemsBinary&&l.acceptTextOnly)throw new w("Stream is binary but only text is accepted for decoding",1);O.encoding=await l.overwriteEncoding(O.encoding),F=await E.create(O.encoding);const M=F.write(N.$je.concat(y).buffer);m.write(M),y.length=0,L=0,I({stream:m,detected:O})}catch(O){z.cancel(),m.destroy(),b(O)}};(0,C.$be)(u,{onData:async O=>{F?m.write(F.write(O.buffer)):(y.push(O),L+=O.byteLength,L>=p&&(u.pause(),await T(),setTimeout(()=>u.resume())))},onError:O=>m.error(O),onEnd:async()=>{F||await T(),m.end(F?.end())}},z.token)})}e.$pD=S;async function c(u,l,p){const b=(await(0,f.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).getEncoder(o(l),p);let m=!1,y=!1;return{read(){if(y)return null;const L=u.read();if(typeof L!="string"){if(y=!0,!m&&p?.addBOM)switch(l){case e.$gD:case e.$hD:return N.$je.wrap(Uint8Array.from(e.$nD));case e.$iD:return N.$je.wrap(Uint8Array.from(e.$lD));case e.$jD:return N.$je.wrap(Uint8Array.from(e.$mD))}const F=b.end();return F&&F.length>0?(m=!0,N.$je.wrap(F)):null}return m=!0,N.$je.wrap(b.write(L))}}}e.$qD=c;async function g(u){return(await(0,f.$fD)("@vscode/iconv-lite-umd","lib/iconv-lite-umd.js")).encodingExists(o(u))}e.$rD=g;function o(u){return u===e.$hD||u===null?e.$gD:u}e.$sD=o;function i(u,l){if(!u||l<e.$lD.length)return null;const p=u.readUInt8(0),I=u.readUInt8(1);if(p===e.$lD[0]&&I===e.$lD[1])return e.$iD;if(p===e.$mD[0]&&I===e.$mD[1])return e.$jD;if(l<e.$nD.length)return null;const b=u.readUInt8(2);return p===e.$nD[0]&&I===e.$nD[1]&&b===e.$nD[2]?e.$hD:null}e.$tD=i;const r=["ascii","utf-16","utf-32"];async function n(u){const l=await(0,f.$fD)("jschardet","dist/jschardet.min.js"),p=u.slice(0,A),I=h(p.buffer),b=l.detect(I);if(!b||!b.encoding)return null;const m=b.encoding.toLowerCase();return 0<=r.indexOf(m)?null:t(b.encoding)}const a={ibm866:"cp866",big5:"cp950"};function t(u){const l=u.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return a[l]||l}function h(u){let l="";for(let p=0;p<u.length;p++)l+=String.fromCharCode(u[p]);return l}function s(u){switch(u){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const l=u.match(/windows(\d+)/);return l?"windows-"+l[1]:u}}}e.$uD=s;function d({buffer:u,bytesRead:l},p){let I=i(u,l),b=!1;if(I!==e.$iD&&I!==e.$jD&&u){let m=!0,y=!0,L=!1;for(let F=0;F<l&&F<v;F++){const z=F%2===1,T=u.readUInt8(F)===0;if(T&&(L=!0),m&&(z&&!T||!z&&T)&&(m=!1),y&&(z&&T||!z&&!T)&&(y=!1),T&&!m&&!y)break}L&&(m?I=e.$jD:y?I=e.$iD:b=!0)}return p&&!b&&!I&&u?n(u.slice(0,l)).then(m=>({seemsBinary:!1,encoding:m})):{seemsBinary:b,encoding:I}}e.$vD=d,e.$wD={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ke[155],Se([1,0,376,31,154]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fjc=void 0;class P extends f.$3hc{constructor(v,$,k=N,A="searchProcess"){super(v,$,{readdir:D=>k.Promises.readdir(D.fsPath),toCanonicalName:D=>(0,C.$uD)(D)},A)}}e.$fjc=P}),define(ke[156],Se([1,0,50,392,375,19,73,35,12,2,36,95,393,373,119]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ejc=e.$djc=e.$cjc=e.$bjc=e.$ajc=e.$_ic=e.$$ic=void 0;const c=E.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class g{constructor(m){this.a=m}provideTextSearchResults(m,y,L,F){return this.a.appendLine(`provideTextSearchResults ${m.pattern}, ${JSON.stringify({...y,folder:y.folder.toString()})}`),new Promise((z,T)=>{F.onCancellationRequested(()=>Q());const O=t(m,y),M=y.folder.fsPath,j=O.map(oe=>oe.match(/^-/)?oe:`'${oe}'`).join(" ");this.a.appendLine(`${c} ${j}
 - cwd: ${M}`);let U=C.spawn(c,O,{cwd:M});U.on("error",oe=>{console.error(oe),this.a.appendLine("Error: "+(oe&&oe.message)),T((0,A.$JJ)(new A.$HJ(oe&&oe.message,A.SearchErrorCode.rgProcessError)))});let K=!1;const ue=new r(y.maxResults,y.folder,y.previewOptions);ue.on("result",oe=>{K=!0,le="",L.report(oe)});let X=!1;const Q=()=>{X=!0,U?.kill(),ue?.cancel()};let Z=!1;ue.on("hitLimit",()=>{Z=!0,Q()});let le="";U.stdout.on("data",oe=>{ue.handleData(oe),K||(le+=oe)});let re=!1;U.stdout.once("data",()=>re=!0);let $e="";U.stderr.on("data",oe=>{const J=oe.toString();this.a.appendLine(J),$e.length+J.length<1e6&&($e+=J)}),U.on("close",()=>{if(this.a.appendLine(re?"Got data from stdout":"No data from stdout"),this.a.appendLine(K?"Got result from parser":"No result from parser"),le&&this.a.appendLine(`Got data without result: ${le}`),this.a.appendLine(""),X)z({limitHit:Z});else{ue.flush(),U=null;let oe;$e&&!re&&(oe=o($e))?T((0,A.$JJ)(new A.$HJ(oe.message,oe.code))):z({limitHit:Z})}})})}}e.$$ic=g;function o(b){const m=b.split(`
`),y=m[0].trim();if(m.some(F=>F.startsWith("regex parse error")))return new A.$HJ(i(m),A.SearchErrorCode.regexParseError);const L=y.match(/grep config error: unknown encoding: (.*)/);if(L)return new A.$HJ(`Unknown encoding: ${L[1]}`,A.SearchErrorCode.unknownEncoding);if(y.startsWith("error parsing glob"))return new A.$HJ(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.globParseError);if(y.startsWith("the literal"))return new A.$HJ(y.charAt(0).toUpperCase()+y.substr(1),A.SearchErrorCode.invalidLiteral);if(y.startsWith("PCRE2: error compiling pattern"))return new A.$HJ(y,A.SearchErrorCode.regexParseError)}function i(b){const m=["Regex parse error"],y=b.filter(L=>L.startsWith("PCRE2:"));if(y.length>=1){const L=y[0].replace("PCRE2:","");if(L.indexOf(":")!==-1&&L.split(":").length>=2){const F=L.split(":")[1];m.push(":"+F)}}return m.join("")}class r extends N.EventEmitter{constructor(m,y,L){super(),this.g=m,this.h=y,this.j=L,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new f.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(m,y){return super.on(m,y),this}handleData(m){if(this.b)return;const y=typeof m=="string"?m:this.d.write(m);this.k(y)}k(m){let y=m.indexOf(`
`);const L=this.a+m;if(y>=0)y+=this.a.length;else{this.a=L;return}let F=0;for(;y>=0;)this.m(L.substring(F,y).trim()),F=y+1,y=L.indexOf(`
`,F);this.a=L.substring(F)}m(m){if(this.b||!m)return;let y;try{y=JSON.parse(m)}catch{throw new Error(`malformed line from rg: ${m}`)}if(y.type==="match"){const L=n(y.data.path),F=k.URI.joinPath(this.h,L),z=this.n(y.data,F);this.p(z),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(y.type==="context"){const L=n(y.data.path),F=k.URI.joinPath(this.h,L);this.o(y.data,F).forEach(T=>this.p(T))}}n(m,y){const L=m.line_number-1,F=n(m.lines),z=Buffer.from(F);let T=0,O=0,M=L;m.submatches.length===0&&m.submatches.push(F.length?{start:0,end:1,match:{text:F[0]}}:{start:0,end:0,match:{text:""}});const j=(0,P.$Hb)(m.submatches.map((U,K)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const ue=n(U.match),X=z.slice(T,U.start).toString(),Q=a(X),Z=Q.numLines>0?Q.lastLineLength:Q.lastLineLength+O,le=a(ue),re=Q.numLines+M,$e=le.numLines+re,oe=le.numLines>0?le.lastLineLength:le.lastLineLength+Z;return T=U.end,O=oe,M=$e,new D.$rJ(re,Z,$e,oe)}));return(0,S.$4ic)(y,F,j,this.j)}o(m,y){const L=n(m.lines),F=m.line_number;return L.replace(/\r?\n$/,"").split(`
`).map((z,T)=>({text:z,uri:y,lineNumber:F+T}))}p(m){this.emit("result",m)}}e.$_ic=r;function n(b){return b.bytes?Buffer.from(b.bytes,"base64").toString():b.text}function a(b){const m=/\n/g;let y=0,L=-1,F;for(;F=m.exec(b);)y++,L=F.index;const z=L>=0?b.length-L-1:b.length;return{numLines:y,lastLineLength:z}}function t(b,m){const y=["--hidden","--no-require-git"];y.push(b.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:L,otherIncludes:F}=(0,R.$K)(m.includes,T=>T.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(F&&F.length){const T=new Set;F.forEach(O=>{T.add(O)}),y.push("-g","!*"),T.forEach(O=>{h(O).map(S.$3ic).forEach(M=>{y.push("-g",M)})})}L&&L.length&&L.forEach(T=>{y.push("-g",T)}),m.excludes.map(S.$3ic).forEach(T=>y.push("-g",`!${T}`)),m.maxFileSize&&y.push("--max-filesize",m.maxFileSize+""),m.useIgnoreFiles?m.useParentIgnoreFiles||y.push("--no-ignore-parent"):y.push("--no-ignore"),m.followSymlinks&&y.push("--follow"),m.encoding&&m.encoding!=="utf8"&&y.push("--encoding",m.encoding),b.pattern==="--"&&(b.isRegExp=!0,b.pattern="\\-\\-"),b.isMultiline&&!b.isRegExp&&(b.pattern=(0,$.$Oe)(b.pattern),b.isRegExp=!0),m.usePCRE2&&y.push("--pcre2"),y.push("--crlf"),b.isRegExp&&(b.pattern=s(b.pattern),y.push("--engine","auto"));let z;if(b.isWordMatch){const O=(0,$.$Xe)(b.pattern,!!b.isRegExp,{wholeWord:b.isWordMatch}).source.replace(/\\\//g,"/");y.push("--regexp",O)}else if(b.isRegExp){let T=u(b.pattern);T=l(T),y.push("--regexp",T)}else z=b.pattern,y.push("--fixed-strings");return y.push("--no-config"),m.useGlobalIgnoreFiles||y.push("--no-ignore-global"),y.push("--json"),b.isMultiline&&y.push("--multiline"),m.beforeContext&&y.push("--before-context",m.beforeContext+""),m.afterContext&&y.push("--after-context",m.afterContext+""),y.push("--"),z&&y.push(z),y.push("."),y}e.$ajc=t;function h(b){return I(b).flatMap(y=>{const L=(0,v.$Kj)(y,"/");return L.map((F,z)=>L.slice(0,z+1).join("/"))})}function s(b){const m=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;b.match(m);)b=b.replace(m,"$1\\x{$2}");const y=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;b.match(y);)b=b.replace(y,"$1\\x{$2}");return b}e.$bjc=s;const d=b=>b.type==="Assertion"&&b.kind==="lookbehind";function u(b){let m;try{m=new w.RegExpParser().parsePattern(b)}catch{return b}let y="",L=0;const F=(O,M,j)=>{y+=b.slice(L,O)+j,L=M},z=[];return new w.RegExpVisitor({onCharacterEnter(O){if(O.raw!=="\\n")return;const M=z[0];if(!M)F(O.start,O.end,"\\r?\\n");else if(!z.some(d))if(M.type==="CharacterClass")if(M.negate){const j=b.slice(M.start+2,O.start)+b.slice(O.end,M.end-1);M.parent?.type==="Quantifier"?F(M.start,M.end,j?`[^${j}]`:"."):F(M.start,M.end,"(?!\\r?\\n"+(j?`|[${j}]`:"")+")")}else{const j=b.slice(M.start+1,O.start)+b.slice(O.end,M.end-1);F(M.start,M.end,j===""?"\\r?\\n":`(?:[${j}]|\\r?\\n)`)}else M.type==="Quantifier"&&F(O.start,O.end,"(?:\\r?\\n)")},onQuantifierEnter(O){z.unshift(O)},onQuantifierLeave(){z.shift()},onCharacterClassRangeEnter(O){z.unshift(O)},onCharacterClassRangeLeave(){z.shift()},onCharacterClassEnter(O){z.unshift(O)},onCharacterClassLeave(){z.shift()},onAssertionEnter(O){d(O)&&z.push(O)},onAssertionLeave(O){z[0]===O&&z.shift()}}).visit(m),y+=b.slice(L),y}e.$cjc=u;function l(b){return b.replace(/\n/g,"\\r?\\n")}e.$djc=l;function p(b){let m=!1,y=!1,L="",F="";for(let z=0;z<b.length;z++){const T=b[z];switch(T){case"\\":y?(m?F+="\\"+T:L+="\\"+T,y=!1):y=!0;break;case"{":if(y)m?F+=T:L+=T,y=!1;else{if(m)return{strInBraces:L+"{"+F+"{"+b.substring(z+1)};m=!0}break;case"}":if(y)m?F+=T:L+=T,y=!1;else{if(m)return{fixedStart:L,strInBraces:F,fixedEnd:b.substring(z+1)};L+=T}break;default:m?F+=(y?"\\":"")+T:L+=(y?"\\":"")+T,y=!1;break}}return{strInBraces:L+(m?"{"+F:"")}}function I(b){const{fixedStart:m,strInBraces:y,fixedEnd:L}=p(b);if(m===void 0||L===void 0)return[y];let F=(0,v.$Kj)(y,",");F.length||(F=[""]);const z=I(L);return F.flatMap(T=>{const O=m+T;return z.map(M=>O+M)})}e.$ejc=I}),define(ke[377],Se([1,0,21,156,86,16]),function(ge,e,C,N,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ijc=void 0;class R{constructor(k){this.b=k,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(k,A,D,w){const E=new N.$$ic(this.b);if(A.folder.scheme===P.Schemas.vscodeUserData){const S={...A,folder:A.folder.with({scheme:P.Schemas.file})},c=new f.$vv(g=>D.report({...g,uri:g.uri.with({scheme:A.folder.scheme})}));return this.c(w,g=>E.provideTextSearchResults(k,S,c,g))}else return this.c(w,S=>E.provideTextSearchResults(k,A,D,S))}async c(k,A){const D=v(k);this.a.add(D);const w=await A(D.token);return this.a.delete(D),w}d(){this.a.forEach(k=>k.cancel())}}e.$ijc=R;function v($){const k=new C.$6d;return $.onCancellationRequested(()=>k.cancel()),k}}),define(ke[378],Se([1,0,31,156,155]),function(ge,e,C,N,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gjc=void 0;class P{constructor($){this.a=$}search($,k,A){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const D={appendLine(E){A({message:E})}},w=new f.$fjc(this.a,new N.$$ic(D),C);return new Promise((E,S)=>w.search(c=>{k(c.map(R))},$).then(c=>E({limitHit:c.limitHit,type:"success",stats:c.stats}),S))}}e.$gjc=P;function R(v){return{path:v.resource&&v.resource.fsPath,results:v.results,numMatches:(v.results||[]).reduce(($,k)=>{if(k.ranges){const A=k;return $+(Array.isArray(A.ranges)?A.ranges.length:1)}else return $+1},0)}}}),define(ke[379],Se([1,0,19,11,14,4,129,17,38,2,32,36,374,378]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hjc=void 0;class S{static{this.a=512}constructor(n="searchProcess"){this.d=n,this.b=Object.create(null)}fileSearch(n){let a;const t=o(n),h=new P.$Vd({onDidAddFirstListener:()=>{a=(0,N.$Tg)(s=>this.doFileSearchWithEngine(w.$0ic,t,d=>h.fire(d),s)),a.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return h.event}textSearch(n){let a;const t=o(n),h=new P.$Vd({onDidAddFirstListener:()=>{a=(0,N.$Tg)(s=>this.f(t,d=>h.fire(d),s)),a.then(s=>h.fire(s),s=>h.fire({type:"error",error:{message:s.message,stack:s.stack}}))},onDidRemoveLastListener:()=>{a.cancel()}});return h.event}f(n,a,t){return n.maxFileSize=this.g().maxFileSize,new E.$gjc(n).search(t,a,a)}g(){return{maxFileSize:16*A.$Yk.GB}}doFileSearch(n,a,t){return this.doFileSearchWithEngine(w.$0ic,n,a,t)}doFileSearchWithEngine(n,a,t,h,s=S.a){let d=0;const u=p=>{Array.isArray(p)?(d+=p.length,t(p.map(I=>this.h(I)))):p.relativePath?(d++,t(this.h(p))):t(p)};if(a.sortByScore){let p=this.l(a,u,h);if(!p){const I=a.maxResults?Object.assign({},a,{maxResults:null}):a,b=new n(I);p=this.j(b,a,t,u,h)}return new Promise((I,b)=>{p.then(([m,y])=>{const L=y.map(F=>this.h(F));this.o(L,t,s),I(m)},b)})}const l=new n(a);return this.r(l,u,s,h).then(p=>({limitHit:p.limitHit,type:"success",stats:{detailStats:p.stats,type:this.d,fromCache:!1,resultCount:d,sortingTime:void 0}}))}h(n){return{path:n.base?(0,v.$jc)(n.base,n.relativePath):n.relativePath}}j(n,a,t,h,s){const d=new P.$Vd;let u=(0,N.$Tg)(p=>{let I=[];const b=m=>{Array.isArray(m)?I=m:(h(m),d.fire(m))};return this.r(n,b,-1,p).then(m=>[m,I])}),l;if(a.cacheKey){l=this.k(a.cacheKey);const p={promise:u,event:d.event,resolved:!1};l.resultsToSearchCache[a.filePattern||""]=p,u.then(()=>{p.resolved=!0},I=>{delete l.resultsToSearchCache[a.filePattern||""]}),u=this.s(u)}return u.then(([p,I])=>{const b=l?l.scorerCache:Object.create(null),m=(typeof a.maxResults!="number"||a.maxResults>0)&&$.$Rd.create(!1);return this.n(a,I,b,s).then(y=>{const L=m?m.elapsed():-1;return[{type:"success",stats:{detailStats:p.stats,sortingTime:L,fromCache:!1,type:this.d,workspaceFolderCount:a.folderQueries.length,resultCount:y.length},messages:p.messages,limitHit:p.limitHit||typeof a.maxResults=="number"&&I.length>a.maxResults},y]})})}k(n){const a=this.b[n];return a||(this.b[n]=new c)}l(n,a,t){const h=n.cacheKey&&this.b[n.cacheKey];if(!h)return;const s=this.q(h,n.filePattern||"",a,t);if(s)return s.then(([d,u,l])=>{const p=$.$Rd.create(!1);return this.n(n,u,h.scorerCache,t).then(I=>{const b=p.elapsed(),m={fromCache:!0,detailStats:l,type:this.d,resultCount:u.length,sortingTime:b};return[{type:"success",limitHit:d.limitHit||typeof n.maxResults=="number"&&u.length>n.maxResults,stats:m},I]})})}n(n,a,t,h){const s=(0,R.$Zq)(n.filePattern||""),d=(l,p)=>(0,R.$Yq)(l,p,s,!0,g,t),u=typeof n.maxResults=="number"?n.maxResults:Number.MAX_VALUE;return C.$Gb(a,d,u,1e4,h)}o(n,a,t){if(t&&t>0)for(let h=0;h<n.length;h+=t)a(n.slice(h,h+t));else a(n)}q(n,a,t,h){const s=$.$Rd.create(!1),d=a.indexOf(v.sep)>=0;let u;for(const b in n.resultsToSearchCache)if(a.startsWith(b)){if(d&&b.indexOf(v.sep)<0&&b!=="")continue;const m=n.resultsToSearchCache[b];u={promise:this.s(m.promise),event:m.event,resolved:m.resolved};break}if(!u)return null;const l=s.elapsed(),p=$.$Rd.create(!1),I=u.event(t);return h&&h.onCancellationRequested(()=>{I.dispose()}),u.promise.then(([b,m])=>{if(h&&h.isCancellationRequested)throw(0,f.$6)();const y=[],L=(0,R.$Zq)(a).normalizedLowercase;for(const F of m)(0,D.$NJ)(F,L)&&y.push(F);return[b,y,{cacheWasResolved:u.resolved,cacheLookupTime:l,cacheFilterTime:p.elapsed(),cacheEntryCount:m.length}]})}r(n,a,t,h){return new Promise((s,d)=>{let u=[];h?.onCancellationRequested(()=>n.cancel()),n.search(l=>{l&&(t?(u.push(l),t>0&&u.length>=t&&(a(u),u=[])):a(l))},l=>{a(l)},(l,p)=>{u.length&&a(u),l?(a({message:"Search finished. Error: "+l.message}),d(l)):(a({message:"Search finished. Stats: "+JSON.stringify(p.stats)}),s(p))})})}clearCache(n){return delete this.b[n],Promise.resolve(void 0)}s(n){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(a,t){return n.then(a,t)}catch(a){return this.then(void 0,a)}finally(a){return n.finally(a)}}}}e.$hjc=S;class c{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const g=new class{getItemLabel(r){return(0,v.$nc)(r.relativePath)}getItemDescription(r){return(0,v.$mc)(r.relativePath)}getItemPath(r){return r.relativePath}};function o(r){return{...r,folderQueries:r.folderQueries&&r.folderQueries.map(i),extraFileResources:r.extraFileResources&&r.extraFileResources.map(n=>k.URI.revive(n))}}function i(r){return{...r,folder:k.URI.revive(r.folder)}}}),define(ke[380],Se([1,0,3,16,2,31,13,27,20,98,66,36,379,377,119,155]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jjc=void 0;let g=class extends k.$8hc{constructor(i,r,n,a){super(i,n,a),this.s=P,this.t=-1,this.v=null,this.w=!1,this.x=new C.$Sc;const t=new S.$5ic("RipgrepSearchUD",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.vscodeUserData,new E.$ijc(t))),r.remote.isRemote&&r.remote.authority&&this.y()}dispose(){this.x.dispose()}$enableExtensionHostSearch(){this.y()}y(){if(this.w)return;this.w=!0;const i=new S.$5ic("RipgrepSearchEH",this.n);this.x.add(this.registerTextSearchProvider(N.Schemas.file,new E.$ijc(i))),this.x.add(this.z(N.Schemas.file,new w.$hjc("fileSearchProvider")))}z(i,r){const n=this.d++;return this.v=r,this.t=n,this.c.$registerFileSearchProvider(n,this.o(i)),(0,C.$Rc)(()=>{this.v=null,this.c.$unregisterProvider(n)})}$provideFileSearchResults(i,r,n,a){const t=(0,k.$9hc)(n);if(i===this.t){const h=Date.now();return this.A(i,r,t,a).then(s=>{const d=Date.now()-h;return this.n.debug(`Ext host file search time: ${d}ms`),s})}return super.$provideFileSearchResults(i,r,n,a)}doInternalFileSearchWithCustomCallback(i,r,n){const a=t=>{if((0,D.$MJ)(t)&&(t=[t]),Array.isArray(t)){n(t.map(h=>f.URI.file(h.path)));return}t.message&&this.n.debug("ExtHostSearch",t.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(i,a,r)}async A(i,r,n,a){return this.doInternalFileSearchWithCustomCallback(n,a,t=>{this.c.$handleFileMatch(i,r,t)})}$clearCache(i){return this.v?.clearCache(i),super.$clearCache(i)}q(i,r){return new c.$fjc(i,r,void 0,"textSearchProvider")}};e.$jjc=g,e.$jjc=g=Ge([We(0,$.$fN),We(1,v.$vN),We(2,A.$1gc),We(3,R.$nj)],g)}),define(ke[120],Se([1,0,394,62,63,395,22,14,4,3,17,10,30,81,82]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$1h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.$Vh=e.$Uh=void 0;class c{traceSocketEvent(m,y){S.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,m,y)}constructor(m,y=""){this.f=!0,this.debugLabel=y,this.socket=m,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=L=>{if(this.traceSocketEvent("error",{code:L?.code,message:L?.message}),L){if(L.code==="EPIPE")return;(0,v.$1)(L)}},this.socket.on("error",this.a),this.b=L=>{this.traceSocketEvent("close",{hadError:L}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(m){const y=L=>{this.traceSocketEvent("read",L),m(R.$je.wrap(L))};return this.socket.on("data",y),{dispose:()=>this.socket.off("data",y)}}onClose(m){const y=L=>{m({type:0,hadError:L,error:void 0})};return this.socket.on("close",y),{dispose:()=>this.socket.off("close",y)}}onEnd(m){const y=()=>{m()};return this.socket.on("end",y),{dispose:()=>this.socket.off("end",y)}}write(m){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",m),this.socket.write(m.buffer,y=>{if(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}})}catch(y){if(y.code==="EPIPE")return;(0,v.$1)(y)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((m,y)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),m();return}const L=()=>{this.socket.off("close",L),this.socket.off("end",L),this.socket.off("error",L),this.socket.off("timeout",L),this.socket.off("drain",L),this.traceSocketEvent("nodeDrainEnd"),m()};this.socket.on("close",L),this.socket.on("end",L),this.socket.on("error",L),this.socket.on("timeout",L),this.socket.on("drain",L)})}}e.$Uh=c;var g;(function(b){b[b.MinHeaderByteSize=2]="MinHeaderByteSize",b[b.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(g||(g={}));var o;(function(b){b[b.PeekHeader=1]="PeekHeader",b[b.ReadHeader=2]="ReadHeader",b[b.ReadBody=3]="ReadBody",b[b.Fin=4]="Fin"})(o||(o={}));class i extends k.$Tc{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(m,y){this.socket.traceSocketEvent(m,y)}constructor(m,y,L,F){super(),this.f=this.B(new $.$Vd),this.g=this.B(new $.$Vd),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0,opcode:0},this.socket=m,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:y,inflateBytesLength:L?.byteLength||0,recordInflateBytes:F}),this.a=this.B(new r(this,y,L,F,this.f,(z,T)=>this.m(z,T))),this.B(this.a.onError(z=>{console.error(z),(0,v.$1)(z),this.g.fire({type:0,hadError:!0,error:z})})),this.b=new S.$Ph,this.B(this.socket.onData(z=>this.n(z))),this.B(this.socket.onClose(async z=>{this.a.isProcessingReadQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(z)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(m){return this.f.event(m)}onClose(m){return this.g.event(m)}onEnd(m){return this.socket.onEnd(m)}write(m){let y=0;for(;y<m.byteLength;)this.a.writeMessage(m.slice(y,Math.min(y+262144,m.byteLength)),{compressed:!0,opcode:2}),y+=262144}m(m,{compressed:y,opcode:L}){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",m);let F=2;m.byteLength<126?F+=0:m.byteLength<2**16?F+=2:F+=8;const z=R.$je.alloc(F),T=y?64:0,O=L&15;if(z.writeUInt8(128|T|O,0),m.byteLength<126)z.writeUInt8(m.byteLength,1);else if(m.byteLength<2**16){z.writeUInt8(126,1);let M=1;z.writeUInt8(m.byteLength>>>8&255,++M),z.writeUInt8(m.byteLength>>>0&255,++M)}else{z.writeUInt8(127,1);let M=1;z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(0,++M),z.writeUInt8(m.byteLength>>>24&255,++M),z.writeUInt8(m.byteLength>>>16&255,++M),z.writeUInt8(m.byteLength>>>8&255,++M),z.writeUInt8(m.byteLength>>>0&255,++M)}this.socket.write(R.$je.concat([z,m]))}end(){this.h=!0,this.socket.end()}n(m){if(m.byteLength!==0){for(this.b.acceptChunk(m);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const y=this.b.peek(this.j.readLen),L=y.readUInt8(0),F=(L&128)>>>7,z=(L&64)>>>6,T=L&15,O=y.readUInt8(1),M=(O&128)>>>7,j=O&127;this.j.state=2,this.j.readLen=2+(M?4:0)+(j===126?2:0)+(j===127?8:0),this.j.fin=F,this.j.firstFrameOfMessage&&(this.j.compressed=!!z),this.j.firstFrameOfMessage=!!F,this.j.mask=0,this.j.opcode=T,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,opcode:this.j.opcode})}else if(this.j.state===2){const y=this.b.read(this.j.readLen),L=y.readUInt8(1),F=(L&128)>>>7;let z=L&127,T=1;z===126?z=y.readUInt8(++T)*2**8+y.readUInt8(++T):z===127&&(z=y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*0+y.readUInt8(++T)*2**24+y.readUInt8(++T)*2**16+y.readUInt8(++T)*2**8+y.readUInt8(++T));let O=0;F&&(O=y.readUInt8(++T)*2**24+y.readUInt8(++T)*2**16+y.readUInt8(++T)*2**8+y.readUInt8(++T)),this.j.state=3,this.j.readLen=z,this.j.mask=O,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask,opcode:this.j.opcode})}else if(this.j.state===3){const y=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",y),t(y,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",y),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.j.opcode<=2?this.a.acceptFrame(y,this.j.compressed,!!this.j.fin):this.j.opcode===9&&this.a.writeMessage(y,{compressed:!1,opcode:10})}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await $.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.$Vh=i;class r extends k.$Tc{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.$je.alloc(0)}constructor(m,y,L,F,z,T){super(),this.n=m,this.r=z,this.s=T,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new $.$Vd),this.onDidFinishProcessingReadQueue=this.j.event,this.m=this.B(new $.$Vd),this.onDidFinishProcessingWriteQueue=this.m.event,this.t=!1,this.y=!1,y?(this.b=this.B(new n(this.n,F,L,{windowBits:15})),this.f=this.B(new a(this.n,{windowBits:15})),this.B(this.b.onError(O=>this.a.fire(O))),this.B(this.f.onError(O=>this.a.fire(O)))):(this.b=null,this.f=null)}writeMessage(m,y){this.g.push({data:m,options:y}),this.u()}async u(){if(!this.t){for(this.t=!0;this.g.length>0;){const{data:m,options:y}=this.g.shift();if(this.f&&y.compressed){const L=await this.w(this.f,m);this.s(L,y)}else this.s(m,{...y,compressed:!1})}this.t=!1,this.m.fire()}}isProcessingWriteQueue(){return this.t}w(m,y){return new Promise((L,F)=>{m.write(y),m.flush(z=>L(z))})}acceptFrame(m,y,L){this.h.push({data:m,isCompressed:y,isLastFrameOfMessage:L}),this.z()}async z(){if(!this.y){for(this.y=!0;this.h.length>0;){const m=this.h.shift();if(this.b&&m.isCompressed){const y=await this.C(this.b,m.data,m.isLastFrameOfMessage);this.r.fire(y)}else this.r.fire(m.data)}this.y=!1,this.j.fire()}}isProcessingReadQueue(){return this.y}C(m,y,L){return new Promise((F,z)=>{m.write(y),L&&m.write(R.$je.fromByteArray([0,0,255,255])),m.flush(T=>F(T))})}}class n extends k.$Tc{get recordedInflateBytes(){return this.j?R.$je.concat(this.f):R.$je.alloc(0)}constructor(m,y,L,F){super(),this.h=m,this.j=y,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,P.createInflateRaw)(F),this.b.on("error",z=>{this.h.traceSocketEvent("zlibInflateError",{message:z?.message,code:z?.code}),this.a.fire(z)}),this.b.on("data",z=>{this.h.traceSocketEvent("zlibInflateData",z),this.g.push(R.$je.wrap(z))}),L&&(this.h.traceSocketEvent("zlibInflateInitialWrite",L.buffer),this.b.write(L.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(m){this.j&&this.f.push(m.clone()),this.h.traceSocketEvent("zlibInflateWrite",m),this.b.write(m.buffer)}flush(m){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const y=R.$je.concat(this.g);this.g.length=0,m(y)})}}class a extends k.$Tc{constructor(m,y){super(),this.g=m,this.a=this.B(new $.$Vd),this.onError=this.a.event,this.f=[],this.b=(0,P.createDeflateRaw)({windowBits:15}),this.b.on("error",L=>{this.g.traceSocketEvent("zlibDeflateError",{message:L?.message,code:L?.code}),this.a.fire(L)}),this.b.on("data",L=>{this.g.traceSocketEvent("zlibDeflateData",L),this.f.push(R.$je.wrap(L))})}write(m){this.g.traceSocketEvent("zlibDeflateWrite",m.buffer),this.b.write(m.buffer)}flush(m){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let y=R.$je.concat(this.f);this.f.length=0,y=y.slice(0,y.byteLength-4),m(y)})}}function t(b,m){if(m===0)return;const y=b.byteLength>>>2;for(let M=0;M<y;M++){const j=b.readUInt32BE(M*4);b.writeUInt32BE(j^m,M*4)}const L=y*4,F=b.byteLength-L,z=m>>>24&255,T=m>>>16&255,O=m>>>8&255;F>=1&&b.writeUInt8(b.readUInt8(L)^z,L),F>=2&&b.writeUInt8(b.readUInt8(L+1)^T,L+1),F>=3&&b.writeUInt8(b.readUInt8(L+2)^O,L+2)}e.$Wh=process.env.XDG_RUNTIME_DIR;const h={[2]:107,[1]:103};function s(){const b=(0,w.$qg)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${b}-sock`;const m=process.platform!=="darwin"&&e.$Wh?e.$Wh:(0,f.tmpdir)(),y=(0,A.$jc)(m,`vscode-ipc-${b}.sock`);return u(y),y}e.$Xh=s;function d(b,m,y){const F=(0,C.createHash)("sha256").update(b).digest("hex").substr(0,8);if(process.platform==="win32")return`\\\\.\\pipe\\${F}-${y}-${m}-sock`;const z=y.substr(0,4),T=m.substr(0,6);let O;return process.platform!=="darwin"&&e.$Wh&&!process.env.VSCODE_PORTABLE?O=(0,A.$jc)(e.$Wh,`vscode-${F}-${z}-${T}.sock`):O=(0,A.$jc)(b,`${z}-${T}.sock`),u(O),O}e.$Yh=d;function u(b){const m=h[D.$u];typeof m=="number"&&b.length>=m&&console.warn(`WARNING: IPC handle "${b}" is longer than ${m} chars, try a shorter --user-data-dir`)}class l extends E.$Jh{static b(m){const y=$.Event.fromNodeEventEmitter(m,"connection");return $.Event.map(y,L=>({protocol:new S.$Qh(new c(L,"ipc-server-connection")),onDidClientDisconnect:$.Event.once($.Event.fromNodeEventEmitter(L,"close"))}))}constructor(m){super(l.b(m)),this.d=m}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.$Zh=l;function p(b){return new Promise((m,y)=>{const L=(0,N.createServer)();L.on("error",y),L.listen(b,()=>{L.removeListener("error",y),m(new l(L))})})}e.$1h=p;function I(b,m){return new Promise((y,L)=>{const F=(0,N.createConnection)(b,()=>{F.removeListener("error",L),y(S.$Rh.fromSocket(new c(F,`ipc-client${m}`),m))});F.once("error",L)})}e.$2h=I}),define(ke[381],Se([1,0,62,63,166,120,11,3,10,51,13,136,256,257,109,89,22]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$E_b=e.$D_b=e.$C_b=e.$B_b=void 0;async function o(t,h,s,d,u){let l;for(let p=3;p&&(l?.dispose(),l=await new i(t,h,s,d,u).waitForReady(),!(u&&f.$tg[u]||!f.$tg[l.tunnelLocalPort]));p--);return l}class i extends v.$Tc{constructor(h,s,d,u,l){super(),this.m=s,this.n=l,this.privacy=c.TunnelPrivacyId.Private,this.j=new Map,this.a=h,this.b=C.createServer(),this.c=new R.$5g,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=p=>this.r(p),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=u,this.tunnelRemoteHost=d}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.j.values()).forEach(s=>{s()})}async waitForReady(){const h=this.n??this.tunnelRemotePort,s=(0,c.$Hv)(this.m)?"0.0.0.0":"127.0.0.1";let d=await(0,f.$ug)(h,2,1e3,s),u=null;return this.b.listen(d,this.m),await this.c.wait(),u=this.b.address(),u||(d=0,this.b.listen(d,this.m),await this.c.wait(),u=this.b.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async r(h){h.pause();const s=(0,c.$Fv)(this.tunnelRemoteHost)||(0,c.$Hv)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,d=await(0,w.$ll)(this.a,s,this.tunnelRemotePort),u=d.getSocket(),l=d.readEntireBuffer();d.dispose(),l.byteLength>0&&h.write(l.buffer),h.on("end",()=>{h.localAddress&&this.j.delete(h.localAddress),u.end()}),h.on("close",()=>u.end()),h.on("error",()=>{h.localAddress&&this.j.delete(h.localAddress),u instanceof P.$Uh?u.socket.destroy():u.end()}),u instanceof P.$Uh?this.t(h,u):this.s(h,u),h.localAddress&&this.j.set(h.localAddress,()=>{h.end(),u.end()})}s(h,s){s.onClose(()=>h.destroy()),s.onEnd(()=>h.end()),s.onData(d=>h.write(d.buffer)),h.on("data",d=>s.write(g.$je.wrap(d))),h.resume()}t(h,s){const d=s.socket;d.on("end",()=>h.end()),d.on("close",()=>h.end()),d.on("error",()=>{h.destroy()}),d.pipe(h),h.pipe(d)}}e.$B_b=i;let r=class extends c.$Kv{constructor(h,s,d,u,l){super(s,l),this.v=h,this.w=d,this.y=u}isPortPrivileged(h){return(0,c.$Iv)(h,this.m,$.OS,N.release())}t(h,s,d,u,l,p,I,b){const m=this.s(s,d);if(m)return++m.refcount,m.value;if((0,c.$Cv)(h))return this.u(h,s,d,l,p,I,b);{this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${s}:${d} on local port ${l}.`);const y={commit:this.y.commit,quality:this.y.quality,addressProvider:h,remoteSocketFactoryService:this.v,signService:this.w,logService:this.k,ipcLogger:null},L=o(y,u,s,d,l);return this.k.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.q(s,d,L),L}}};e.$C_b=r,e.$C_b=r=Ge([We(0,E.$fl),We(1,A.$nj),We(2,S.$il),We(3,D.$Fj),We(4,k.$zi)],r);let n=class extends r{constructor(h,s,d,u,l){super(h,s,d,u,l)}};e.$D_b=n,e.$D_b=n=Ge([We(0,E.$fl),We(1,A.$nj),We(2,S.$il),We(3,D.$Fj),We(4,k.$zi)],n);let a=class extends v.$Tc{constructor(h,s,d,u,l){super(),this.b=h,this.c=s,this.f=d,this.g=u,this.h=l,this.a=new Map}async openTunnel(h,s,d,u,l,p,I,b,m){if(this.c.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${d}:${u} on local port ${p}.`),!this.a.has(h)){const y=new n(this.b,this.c,this.g,this.f,this.h);this.B(y),this.a.set(h,y),y.onTunnelClosed(async()=>{(await y.tunnels).length===0&&(y.dispose(),this.a.delete(h))})}return this.a.get(h).openTunnel(s,d,u,l,p,I,b,m)}};e.$E_b=a,e.$E_b=a=Ge([We(0,E.$fl),We(1,A.$nj),We(2,D.$Fj),We(3,S.$il),We(4,k.$zi)],a)}),define(ke[382],Se([1,0,120,276,57,33,2,13,40]),function(ge,e,C,N,f,P,R,v,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HN=e.$GN=void 0;class k{constructor(w,E,S){this.b=w,this.c=E,this.f=S,this.a=N.createServer((c,g)=>this.h(c,g)),this.g().catch(c=>(E.error(c),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",w=>this.c.error(w))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(w,E){const S=(g,o)=>{E.writeHead(g,{"content-type":"application/json"}),E.end(JSON.stringify(o||null),i=>i&&this.c.error(i))},c=[];w.setEncoding("utf8"),w.on("data",g=>c.push(g)),w.on("end",async()=>{try{const g=JSON.parse(c.join(""));let o;switch(g.type){case"open":o=await this.i(g);break;case"openExternal":o=await this.j(g);break;case"status":o=await this.l(g);break;case"extensionManagement":o=await this.k(g);break;default:S(404,`Unknown message type: ${g.type}`);break}S(200,o)}catch(g){const o=g instanceof Error?g.message:JSON.stringify(g);S(500,o),this.c.error("Error while processing pipe request",g)}})}async i(w){const{fileURIs:E,folderURIs:S,forceNewWindow:c,diffMode:g,mergeMode:o,addMode:i,forceReuseWindow:r,gotoLineMode:n,waitMarkerFilePath:a,remoteAuthority:t}=w,h=[];if(Array.isArray(S))for(const l of S)try{h.push({folderUri:R.URI.parse(l)})}catch{}if(Array.isArray(E))for(const l of E)try{(0,$.$yi)(l)?h.push({workspaceUri:R.URI.parse(l)}):h.push({fileUri:R.URI.parse(l)})}catch{}const s=a?R.URI.file(a):void 0,u={forceNewWindow:c,diffMode:g,mergeMode:o,addMode:i,gotoLineMode:n,forceReuseWindow:r,preferNewWindow:!r&&!s&&!i,waitMarkerFileURI:s,remoteAuthority:t};this.b.executeCommand("_remoteCLI.windowOpen",h,u)}async j(w){for(const E of w.uris){const S=R.URI.parse(E),c=S.scheme==="file"?S:E;await this.b.executeCommand("_remoteCLI.openExternal",c)}}async k(w){const E=c=>c?.map(g=>/\.vsix$/i.test(g)?R.URI.parse(g):g),S={list:w.list,install:E(w.install),uninstall:E(w.uninstall),force:w.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",S)}async l(w){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&f.existsSync(this.f)&&f.unlinkSync(this.f)}}e.$GN=k;let A=class extends k{constructor(w,E){super(w,E,(0,C.$Xh)())}};e.$HN=A,e.$HN=A=Ge([We(0,P.$BN),We(1,v.$nj)],A)}),define(ke[383],Se([1,0,58,370,365,275,47,352,2,16,7,382,104,307,351]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ojc=void 0;class c extends f.$Pic{j(){const i=this,r=globalThis._VSCODE_NODE_MODULES.module,n=r._load;r._load=function(s,d,u){return s=t(s),i.a.has(s)?i.a.get(s).load(s,$.URI.file((0,w.$wq)(d.filename)),l=>n.apply(this,[l,d,u])):n.apply(this,arguments)};const a=r._resolveLookupPaths;r._resolveLookupPaths=(h,s)=>a.call(this,t(h),s);const t=h=>{for(const s of i.b){const d=s(h);if(d){h=d;break}}return h}}}class g extends R.$Ehc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Node}async tb(){this.h.createInstance(E.$mjc);const i=this.h.invokeFunction(N.$Lic);if(this.h.createInstance(v.$ljc),this.f.remote.isRemote&&this.f.remote.authority){const a=this.h.createInstance(D.$HN);process.env.VSCODE_IPC_HOOK_CLI=a.ipcHandlePath}this.h.createInstance(S.$njc),await this.h.createInstance(c,i,{mine:this.J,all:this.L}).install(),C.mark("code/extHost/didInitAPI");const n=await this.m.getConfigProvider();await(0,P.$kjc)(this.j,n,this,this.s,this.z,this.f),C.mark("code/extHost/didInitProxyResolver")}ub(i){return i.main}async vb(i,r,n){if(r.scheme!==k.Schemas.file)throw new Error(`Cannot load URI: '${r}', must be of file-scheme`);let a=null;n.codeLoadingStart(),this.s.trace(`ExtensionService#loadCommonJSModule ${r.toString(!0)}`),this.s.flush();const t=i?.identifier.value;i&&await this.w.initializeLocalizedMessages(i);try{t&&C.mark(`code/extHost/willLoadExtensionCode/${t}`),a=ge.__$__nodeRequire(r.fsPath)}finally{t&&C.mark(`code/extHost/didLoadExtensionCode/${t}`),n.codeLoadingStop()}return a}async $setRemoteEnvironment(i){if(this.f.remote.isRemote)for(const r in i){const n=i[r];n===null?delete process.env[r]:process.env[r]=n}}}e.$ojc=g}),define(ke[384],Se([1,0,50,22,4,3,122,10,23,2,31,13,255,64,109,89,381,27,20,70,359]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wjc=e.$vjc=e.$ujc=e.$tjc=e.$sjc=e.$rjc=e.$qjc=e.$pjc=void 0;function a(m){const y=m.trim().split(`
`),L=[];return y.forEach(z=>{const T=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(z);T&&T.length>=3&&L.push({pid:parseInt(T[1],10),socket:parseInt(T[2],10)})}),L.reduce((z,T)=>(z[T.socket]=T,z),{})}e.$pjc=a;function t(...m){const y=[].concat(...m.map(s));return[...new Map(y.filter(L=>L.st==="0A").map(L=>{const F=L.local_address.split(":");return{socket:parseInt(L.inode,10),ip:h(F[0]),port:parseInt(F[1],16)}}).map(L=>[L.ip+":"+L.port,L])).values()]}e.$qjc=t;function h(m){let y="";if(m.length===8)for(let L=m.length-2;L>=0;L-=2)y+=parseInt(m.substr(L,2),16),L!==0&&(y+=".");else for(let L=0;L<m.length;L+=8){const F=m.substring(L,L+8);let z="";for(let T=8;T>=2;T-=2)z+=F.substring(T-2,T),(T===6||T===2)&&(z=parseInt(z,16).toString(16),y+=`${z}`,z="",L+T!==m.length-6&&(y+=":"))}return y}e.$rjc=h;function s(m){const y=m.trim().split(`
`),L=y.shift().trim().split(/\s+/).filter(z=>z!=="rx_queue"&&z!=="tm->when");return y.map(z=>z.trim().split(/\s+/).reduce((T,O,M)=>(T[L[M]||M]=O,T),{}))}e.$sjc=s;function d(m){return!!m.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||m.indexOf("out/server-main.js")!==-1||m.indexOf("_productName=VSCode")!==-1}function u(m){const y=m.trim().split(`
`),L=[];return y.forEach(F=>{const z=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(F);z&&z.length>=4&&L.push({pid:parseInt(z[1],10),ppid:parseInt(z[2]),cmd:z[3]})}),L}e.$tjc=u;async function l(m,y,L){const F=L.reduce((T,O)=>(T[O.pid]=O,T),{}),z=[];return m.forEach(({socket:T,ip:O,port:M})=>{const j=y[T]?y[T].pid:void 0,U=j?F[j]?.cmd:void 0;j&&U&&!d(U)&&z.push({host:O,port:M,detail:U,pid:j})}),z}e.$ujc=l;function p(m,y,L){const F=new Map,z=u(y);for(const T of m){const O=L.get(T.port);if(O){F.set(T.port,O);continue}const M=z.find(j=>j.cmd.includes(`${T.port}`));if(M){let j=M,U;do U=z.find(K=>K.ppid===j.pid),U&&(j=U);while(U);F.set(T.port,{host:T.ip,port:T.port,pid:j.pid,detail:j.cmd,ppid:j.ppid})}else F.set(T.port,{host:T.ip,port:T.port,ppid:Number.MAX_VALUE})}return F}e.$vjc=p;let I=class extends r.$7yb{constructor(y,L,F,z){super(y,L,F),this.D=L,this.F=z,this.y=void 0,this.z=new Map,this.C=!1,v.$k&&L.remote.isRemote&&L.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.H())}async $registerCandidateFinder(y){if(y&&this.C)return;this.C=y;let L;this.y&&(L=this.y,await this.a.$onFoundNewCandidates(this.y));const F=new R.$0l;let z=0;for(;this.C;){const T=new Date().getTime(),O=(await this.I()).filter(U=>(0,c.$Fv)(U.host)||(0,c.$Hv)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${O.map(U=>U.port).join(", ")}`);const M=new Date().getTime()-T;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${M} ms.`),z++>3&&F.update(M),(!L||JSON.stringify(L)!==JSON.stringify(O))&&(L=O,await this.a.$onFoundNewCandidates(L));const j=this.G(F.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${j} ms.`),await new Promise(U=>setTimeout(()=>U(),j))}}G(y){return Math.max(y*20,2e3)}async H(){this.y=await this.I(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.y.map(y=>y.port).join(", ")}`)}async I(){let y="",L="";try{y=await A.Promises.readFile("/proc/net/tcp","utf8"),L=await A.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const F=t(y,L),z=await new Promise(X=>{(0,C.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(Q,Z,le)=>{X(Z)})}),T=a(z),O=await A.Promises.readdir("/proc"),M=[];for(const X of O)try{const Q=Number(X),Z=$.$Hg(k.URI.file("/proc"),X);if((await A.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(Q)){const re=await A.Promises.readlink($.$Hg(Z,"cwd").fsPath),$e=await A.Promises.readFile($.$Hg(Z,"cmdline").fsPath,"utf8");M.push({pid:Q,cwd:re,cmd:$e})}}catch{}const j=[],U=F.filter(X=>{const Q=T[X.socket];return Q||j.push(X),Q}),K=l(U,T,M);let ue;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${j.length}`),j.length>0){const X=await new Promise(Q=>{(0,C.exec)("ps -F -A -l | grep root",(Z,le,re)=>{Q(le)})});this.z=p(j,X,this.z),ue=Array.from(this.z.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${ue.map(Q=>Q.port).join(", ")}`)}return K.then(X=>ue?X.concat(ue):X)}w(y){return async L=>{const F=new g.$B_b({commit:this.D.commit,quality:this.D.quality,logService:this.s,ipcLogger:null,remoteSocketFactoryService:{_serviceBrand:void 0,async connect(T,O,M,j){const U=await y.makeConnection();return b.connect(U,O,M,j)},register(){throw new Error("not implemented")}},addressProvider:{getAddress(){return Promise.resolve({connectTo:new E.$9k(0),connectionToken:y.connectionToken})}},signService:this.F},"localhost",L.remoteAddress.host||"localhost",L.remoteAddress.port,L.localAddressPort);await F.waitForReady();const z=new f.$Vd;return{localAddress:(0,n.$AK)(F.localAddress)??F.localAddress,remoteAddress:{port:F.tunnelRemotePort,host:F.tunnelRemoteHost},onDidDispose:z.event,dispose:()=>{F.dispose(),z.fire(),z.dispose()}}}}};e.$wjc=I,e.$wjc=I=Ge([We(0,i.$fN),We(1,o.$vN),We(2,D.$nj),We(3,S.$il)],I);class b extends w.$9rb{static connect(y,L,F,z){const T=new P.$Sc,O={onClose:T.add(new f.$Vd),onData:T.add(new f.$Vd),onEnd:T.add(new f.$Vd)};T.add(y.onDidReceiveMessage(j=>O.onData.fire(N.$je.wrap(j)))),T.add(y.onDidEnd(()=>O.onEnd.fire())),T.add(y.onDidClose(j=>O.onClose.fire({type:0,error:j,hadError:!!j})));const M=new b(y,z,O);return M.B(T),(0,w.$8rb)(M,L,F,z,O)}constructor(y,L,F){super(L,F),this.n=y}write(y){this.n.send(y.buffer)}h(){this.n.end()}async drain(){await this.n.drain?.()}}}),define(ke[385],Se([1,0,84,354,368,367,380,383,384,97,47,98,96,46,70,94,353,308,13,369,60,270,106,109,138]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o,i,r,n,a,t,h,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Yr)(A.$Fhc,v.$ojc,0),(0,C.$Yr)(i.$oj,o.$yjc,1),(0,C.$Yr)(i.$nj,new t.$3h(a.$Oic,[!1],!0)),(0,C.$Yr)(h.$il,s.$G_b,1),(0,C.$Yr)(c.$0gc,g.$xjc,0),(0,C.$Yr)(k.$Khc,P.$2ic,0),(0,C.$Yr)(D.$7hc,R.$jjc,0),(0,C.$Yr)(w.$xic,f.$Tic,0),(0,C.$Yr)(E.$shc,N.$Sic,0),(0,C.$Yr)(S.$6yb,$.$wjc,0),(0,C.$Yr)(n.$Ihc,r.$zjc,0)}),define(ke[396],Se([1,0,62,397,58,14,82,120,253,113,366,22,31,104,11,132,277,291,371,385]),function(ge,e,C,N,f,P,R,v,$,k,A,D,w,E,S,c,g,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let p=0;p<process.execArgv.length;p++)process.execArgv[p]==="--inspect-port=0"&&(process.execArgv.splice(p,1),p--)}();const i=N(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const l=globalThis._VSCODE_NODE_MODULES.module,p=l._load;l._load=function(I){if(I==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return p.apply(this,arguments)}})();const r=process.exit.bind(process),n=process.on.bind(process);function a(l){process.exit=function(p){if(l)r(p);else{const I=new Error("An extension called process.exit() and this was prevented.");console.warn(I.stack)}},process.crash=function(){const p=new Error("An extension called process.crash() and this was prevented.");console.warn(p.stack)},process.env.ELECTRON_RUN_AS_NODE="1",process.on=function(p,I){p==="uncaughtException"&&(I=function(){try{return I.call(void 0,arguments)}catch{}}),n(p,I)}}let t=function(l){r()};function h(){const l=(0,o.$Tm)(process.env);if(l.type===3)return new Promise((p,I)=>{const b=m=>{const y=m[0],L=new R.$Sh;y.on("message",F=>L.fire(D.$je.wrap(F.data))),y.on("close",()=>{t("renderer closed the MessagePort")}),y.start(),p({onMessage:L.event,send:F=>y.postMessage(F.buffer)})};process.parentPort.on("message",m=>b(m.ports))});if(l.type===2)return new Promise((p,I)=>{let b=null;const m=setTimeout(()=>{t("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),y=108e5,L=3e5,F=new S.$gh(()=>t("renderer disconnected for too long (1)"),y),z=new S.$gh(()=>t("renderer disconnected for too long (2)"),L);process.on("message",(O,M)=>{if(O&&O.type==="VSCODE_EXTHOST_IPC_SOCKET"){M.setNoDelay(!0);const j=D.$je.wrap(Buffer.from(O.initialDataChunk,"base64"));let U;if(O.skipWebSocketFrames)U=new v.$Uh(M,"extHost-socket");else{const K=D.$je.wrap(Buffer.from(O.inflateBytes,"base64"));U=new v.$Vh(new v.$Uh(M,"extHost-socket"),O.permessageDeflate,K,!1)}b?(F.cancel(),z.cancel(),b.beginAcceptReconnection(U,j),b.endAcceptReconnection(),b.sendResume()):(clearTimeout(m),b=new R.$Th({socket:U,initialChunk:j}),b.sendResume(),b.onDidDispose(()=>t("renderer disconnected")),p(b),b.onSocketClose(()=>{F.schedule()}))}if(O&&O.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(z.isScheduled())return;F.isScheduled()&&z.schedule()}});const T={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(T)});{const p=l.pipeName;return new Promise((I,b)=>{const m=C.createConnection(p,()=>{m.removeListener("error",b);const y=new R.$Th({socket:new v.$Uh(m,"extHost-renderer")});y.sendResume(),I(y)});m.once("error",b),m.on("close",()=>{t("renderer closed the socket")})})}}async function s(){const l=await h();return new class{constructor(){this.a=new R.$Sh,this.onMessage=this.a.event,this.b=!1,l.onMessage(p=>{(0,k.$um)(p,2)?(this.b=!0,t("received terminate message from renderer")):this.a.fire(p)})}send(p){this.b||l.send(p)}async drain(){if(l.drain)return l.drain()}}}function d(l){return new Promise(p=>{const I=l.onMessage(b=>{I.dispose();const m=JSON.parse(b.toString()),y=m.commit,L=$.default.commit;if(y&&L&&y!==L&&r(55),m.parentPid){let F=0;setInterval(function(){try{process.kill(m.parentPid,0),F=0}catch(T){T&&T.code==="EPERM"?(F++,F>=3&&t(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${T.message} (code: ${T.code}) (errno: ${T.errno})`)):t(`parent process ${m.parentPid} does not exist anymore: ${T.message} (code: ${T.code}) (errno: ${T.errno})`)}},1e3);let z;try{z=globalThis._VSCODE_NODE_MODULES["native-watchdog"],z.start(m.parentPid)}catch(T){(0,P.$1)(T)}}l.send((0,k.$tm)(0)),p({protocol:l,initData:m})});l.send((0,k.$tm)(1))})}async function u(){const l=[];process.on("unhandledRejection",(F,z)=>{l.push(z),setTimeout(()=>{const T=l.indexOf(z);T>=0&&z.catch(O=>{l.splice(T,1),(0,P.$4)(O)||(console.warn(`rejected promise not handled within 1 second: ${O}`),O&&O.stack&&console.warn(`stack trace: ${O.stack}`),F&&(0,P.$1)(F))})},1e3)}),process.on("rejectionHandled",F=>{const z=l.indexOf(F);z>=0&&l.splice(z,1)}),process.on("uncaughtException",function(F){(0,P.$Z)(F)||(0,P.$1)(F)}),f.mark("code/extHost/willConnectToRenderer");const p=await s();f.mark("code/extHost/didConnectToRenderer");const I=await d(p);f.mark("code/extHost/didWaitForInitData");const{initData:b}=I;a(!!b.environment.extensionTestsLocationURI),b.environment.useHostProxy=i.useHostProxy!==void 0?i.useHostProxy!=="false":void 0,b.environment.skipWorkspaceStorageLock=(0,c.boolean)(i.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(z){r(z)}fsExists(z){return w.Promises.exists(z)}fsRealpath(z){return(0,E.$vq)(z)}};let y=null;b.remote.authority&&i.transformURIs&&(y=(0,g.$3r)(b.remote.authority));const L=new A.$Ric(I.protocol,b,m,y);t=F=>L.terminate(F)}u().catch(l=>console.log(l))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/271fb7fbd599b49a1482ea7284a50b3229317f96/core/vs/workbench/api/node/extensionHostProcess.js.map
