/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var V=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/errors","vs/editor/common/tokens/lineTokens","vs/base/common/uri","vs/base/common/observableInternal/autorun","vs/base/common/observableInternal/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/strings","vs/base/common/network","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/amd","vs/base/common/assert","vs/base/common/observableInternal/utils","vs/base/common/stream","vs/base/common/lazy","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/amdX","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/base/common/stopwatch","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateWorkerTokenizer","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker"],p=function(H){for(var e=[],P=0,S=H.length;P<S;P++)e[P]=V[H[P]];return e};define(V[22],p([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class P{static get(){const v=new Map,N=new Map,s=new Map,f=new Map;function t(h,i){h.has(i.detail)||h.set(i.detail,-i.timestamp)}function d(h,i){const n=h.get(i.detail);n&&(n>=0||h.set(i.detail,n+i.timestamp))}let $=[];typeof H=="function"&&typeof H.getStats=="function"&&($=H.getStats().slice(0).sort((h,i)=>h.timestamp-i.timestamp));for(const h of $)switch(h.type){case 10:t(v,h);break;case 11:case 12:d(v,h);break;case 21:t(N,h);break;case 22:d(N,h);break;case 33:t(s,h);break;case 34:d(s,h);break;case 31:t(f,h);break;case 32:d(f,h);break}let l=0;s.forEach(h=>l+=h);function o(h){const i=[];return h.forEach((n,r)=>i.push([r,n])),i}return{amdLoad:o(v),amdInvoke:o(N),nodeRequire:o(s),nodeEval:o(f),nodeRequireTotal:l}}static toMarkdownTable(v,N){let s="";const f=[];return v.forEach((t,d)=>{f[d]=t.length}),N.forEach(t=>{t.forEach((d,$)=>{typeof d>"u"&&(d=t[$]="-");const l=d.toString().length;f[$]=Math.max(l,f[$])})}),v.forEach((t,d)=>{s+=`| ${t+" ".repeat(f[d]-t.toString().length)} `}),s+=`|
`,v.forEach((t,d)=>{s+=`| ${"-".repeat(f[d])} `}),s+=`|
`,N.forEach(t=>{t.forEach((d,$)=>{typeof d<"u"&&(s+=`| ${d+" ".repeat(f[$]-d.toString().length)} `)}),s+=`|
`}),s}}e.$U=P}),define(V[4],p([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ud=e.$td=e.$sd=void 0;let P;function S(n){P=n}e.$sd=S;function v(){return P}e.$td=v;class N{constructor(){this.a=0,this.d=new WeakMap}b(r){return s([f(h("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[f(" "),d($(r.oldValue,70),{color:"red",strikeThrough:!0}),f(" "),d($(r.newValue,60),{color:"green"})]:[f(" (unchanged)")]:[f(" "),d($(r.newValue,60),{color:"green"}),f(" (initial)")]}handleObservableChanged(r,m){console.log(...this.b([t("observable value changed"),d(r.debugName,{color:"BlueViolet"}),...this.c(m)]))}formatChanges(r){if(r.size!==0)return d(" (changed deps: "+[...r].map(m=>m.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const m=r.handleChange;this.d.set(r,new Set),r.handleChange=(E,R)=>(this.d.get(r).add(E),m.apply(r,[E,R]))}handleDerivedRecomputed(r,m){const E=this.d.get(r);console.log(...this.b([t("derived recomputed"),d(r.debugName,{color:"BlueViolet"}),...this.c(m),this.formatChanges(E),{data:[{fn:r._computeFn}]}])),E.clear()}handleFromEventObservableTriggered(r,m){console.log(...this.b([t("observable from event triggered"),d(r.debugName,{color:"BlueViolet"}),...this.c(m),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const m=r.handleChange;this.d.set(r,new Set),r.handleChange=(E,R)=>(this.d.get(r).add(E),m.apply(r,[E,R]))}handleAutorunTriggered(r){const m=this.d.get(r);console.log(...this.b([t("autorun"),d(r.debugName,{color:"BlueViolet"}),this.formatChanges(m),{data:[{fn:r._runFn}]}])),m.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let m=r.getDebugName();m===void 0&&(m=""),console.log(...this.b([t("transaction"),d(m,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$ud=N;function s(n){const r=new Array,m=[];let E="";function R(T){if("length"in T)for(const g of T)g&&R(g);else"text"in T?(E+=`%c${T.text}`,r.push(T.style),T.data&&m.push(...T.data)):"data"in T&&m.push(...T.data)}R(n);const L=[E,...r];return L.push(...m),L}function f(n){return d(n,{color:"black"})}function t(n){return d(i(`${n}: `,10),{color:"black",bold:!0})}function d(n,r={color:"black"}){function m(R){return Object.entries(R).reduce((L,[T,g])=>`${L}${T}:${g};`,"")}const E={color:r.color};return r.strikeThrough&&(E["text-decoration"]="line-through"),r.bold&&(E["font-weight"]="bold"),{text:n,style:m(E)}}function $(n,r){switch(typeof n){case"number":return""+n;case"string":return n.length+2<=r?`"${n}"`:`"${n.substr(0,r-7)}"+...`;case"boolean":return n?"true":"false";case"undefined":return"undefined";case"object":return n===null?"null":Array.isArray(n)?l(n,r):o(n,r);case"symbol":return n.toString();case"function":return`[[Function${n.name?" "+n.name:""}]]`;default:return""+n}}function l(n,r){let m="[ ",E=!0;for(const R of n){if(E||(m+=", "),m.length-5>r){m+="...";break}E=!1,m+=`${$(R,r-m.length)}`}return m+=" ]",m}function o(n,r){let m="{ ",E=!0;for(const[R,L]of Object.entries(n)){if(E||(m+=", "),m.length-5>r){m+="...";break}E=!1,m+=`${R}: ${$(L,r-m.length)}`}return m+=" }",m}function h(n,r){let m="";for(let E=1;E<=r;E++)m+=n;return m}function i(n,r){for(;n.length<r;)n+=" ";return n}}),define(V[5],p([0,1,4]),function(H,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qd=e.$Pd=e.$Od=e.$Nd=e.$Md=e.$Ld=e.$Kd=e.$Jd=e.$Id=e.$Hd=e.$Gd=e.$Fd=e.$Ed=e.$Dd=e.$Cd=e.$Bd=void 0;let S;function v(C){S=C}e.$Bd=v;let N;function s(C){N=C}e.$Cd=s;let f;function t(C){f=C}e.$Dd=t;class d{get TChange(){return null}reportChanges(){this.get()}read(b){return b?b.readObservable(this):this.get()}map(b,a){const I=a===void 0?void 0:b,z=a===void 0?b:a;return f({owner:I,debugName:()=>{const q=F(z);if(q!==void 0)return q;const K=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(z.toString());if(K)return`${this.debugName}.${K[2]}`;if(!I)return`${this.debugName} (mapped)`}},q=>z(this.read(q),q))}recomputeInitiallyAndOnChange(b,a){return b.add(S(this,a)),this}keepObserved(b){return b.add(N(this)),this}}e.$Ed=d;class $ extends d{constructor(){super(...arguments),this.c=new Set}addObserver(b){const a=this.c.size;this.c.add(b),a===0&&this.f()}removeObserver(b){this.c.delete(b)&&this.c.size===0&&this.g()}f(){}g(){}}e.$Fd=$;function l(C,b){const a=new r(C,b);try{C(a)}finally{a.finish()}}e.$Gd=l;let o;function h(C){if(o)C(o);else{const b=new r(C,void 0);o=b;try{C(b)}finally{b.finish(),o=void 0}}}e.$Hd=h;async function i(C,b){const a=new r(C,b);try{await C(a)}finally{a.finish()}}e.$Id=i;function n(C,b,a){C?b(C):l(b,a)}e.$Jd=n;class r{constructor(b,a){this._fn=b,this.b=a,this.a=[],(0,P.$td)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():F(this._fn)}updateObserver(b,a){this.a.push({observer:b,observable:a}),b.beginUpdate(a)}finish(){const b=this.a;for(let a=0;a<b.length;a++){const{observer:I,observable:z}=b[a];I.endUpdate(z)}this.a=null,(0,P.$td)()?.handleEndTransaction()}}e.$Kd=r;const m=new Map,E=new WeakMap;function R(C,b,a,I){const z=E.get(C);if(z)return z;const q=L(C,b,a,I);if(q){let W=m.get(q)??0;W++,m.set(q,W);const K=W===1?q:`${q}#${W}`;return E.set(C,K),K}}e.$Ld=R;function L(C,b,a,I){const z=E.get(C);if(z)return z;const q=I?y(I)+".":"";let W;if(b!==void 0)if(typeof b=="function"){if(W=b(),W!==void 0)return q+W}else return q+b;if(a!==void 0&&(W=F(a),W!==void 0))return q+W;if(I!==void 0){for(const K in I)if(I[K]===C)return q+K}}const T=new Map,g=new WeakMap;function y(C){const b=g.get(C);if(b)return b;const a=O(C);let I=T.get(a)??0;I++,T.set(a,I);const z=I===1?a:`${a}#${I}`;return g.set(C,z),z}function O(C){const b=C.constructor;return b?b.name:"Object"}function F(C){const b=C.toString(),I=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(b);return(I?I[1]:void 0)?.trim()}e.$Md=F;function D(C,b){return typeof C=="string"?new c(void 0,C,b):new c(C,void 0,b)}e.$Nd=D;class c extends ${get debugName(){return R(this,this.d,void 0,this.b)??"ObservableValue"}constructor(b,a,I){super(),this.b=b,this.d=a,this.a=I}get(){return this.a}set(b,a,I){if(this.a===b)return;let z;a||(a=z=new r(()=>{},()=>`Setting ${this.debugName}`));try{const q=this.a;this.e(b),(0,P.$td)()?.handleObservableChanged(this,{oldValue:q,newValue:b,change:I,didChange:!0,hadValue:!0});for(const W of this.c)a.updateObserver(W,this),W.handleChange(this,I)}finally{z&&z.finish()}}toString(){return`${this.debugName}: ${this.a}`}e(b){this.a=b}}e.$Od=c;function k(C,b){return typeof C=="string"?new M(void 0,C,b):new M(C,void 0,b)}e.$Pd=k;class M extends c{e(b){this.a!==b&&(this.a&&this.a.dispose(),this.a=b)}dispose(){this.a?.dispose()}}e.$Qd=M}),define(V[9],p([0,1,23,2,5,4]),function(H,e,P,S,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dd=e.$cd=e.$bd=e.$ad=e.$_c=e.$$c=e.$0c=void 0;function s(i){return new o(void 0,i,void 0,void 0)}e.$0c=s;function f(i,n){return new o(i.debugName,n,void 0,void 0)}e.$$c=f;function t(i,n){return new o(i.debugName,n,i.createEmptyChangeSummary,i.handleChange)}e.$_c=t;function d(i,n){const r=new S.$Sc,m=t({debugName:i.debugName??(()=>(0,v.$Md)(n)),createEmptyChangeSummary:i.createEmptyChangeSummary,handleChange:i.handleChange},(E,R)=>{r.clear(),n(E,R,r)});return(0,S.$Rc)(()=>{m.dispose(),r.dispose()})}e.$ad=d;function $(i){const n=new S.$Sc,r=f({debugName:()=>(0,v.$Md)(i)||"(anonymous)"},m=>{n.clear(),i(m,n)});return(0,S.$Rc)(()=>{r.dispose(),n.dispose()})}e.$bd=$;var l;(function(i){i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(l||(l={}));class o{get debugName(){if(typeof this.h=="string")return this.h;if(typeof this.h=="function"){const r=this.h();if(r!==void 0)return r}const n=(0,v.$Md)(this._runFn);return n!==void 0?n:"(anonymous)"}constructor(n,r,m,E){this.h=n,this._runFn=r,this.i=m,this.j=E,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,this.g=this.i?.(),(0,N.$td)()?.handleAutorunCreated(this),this.k(),(0,S.$Kc)(this)}dispose(){this.c=!0;for(const n of this.e)n.removeObserver(this);this.e.clear(),(0,S.$Lc)(this)}k(){if(this.a===3)return;const n=this.f;this.f=this.e,this.e=n,this.a=3;const r=this.c;try{if(!r){(0,N.$td)()?.handleAutorunTriggered(this);const m=this.g;this.g=this.i?.(),this._runFn(this,m)}}finally{r||(0,N.$td)()?.handleAutorunFinished(this);for(const m of this.f)m.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const n of this.e)if(n.reportChanges(),this.a===2)break}this.k()}while(this.a!==3);this.b--,(0,P.$8c)(()=>this.b>=0)}handlePossibleChange(n){this.a===3&&this.e.has(n)&&!this.f.has(n)&&(this.a=1)}handleChange(n,r){this.e.has(n)&&!this.f.has(n)&&(!this.j||this.j({changedObservable:n,change:r,didChange:E=>E===n},this.g))&&(this.a=2)}readObservable(n){if(this.c)return n.get();n.addObserver(this);const r=n.get();return this.e.add(n),this.f.delete(n),r}}e.$cd=o,function(i){i.Observer=o}(s||(e.$0c=s={}));function h(i,n){let r;return f({debugName:()=>(0,v.$Md)(n)},m=>{const E=i.read(m),R=r;r=E,n({lastValue:R,newValue:E})})}e.$dd=h}),define(V[10],p([0,1,23,2,5,4]),function(H,e,P,S,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ad=e.$zd=e.$yd=e.$xd=e.$wd=e.$vd=void 0;const s=(i,n)=>i===n;function f(i,n){return n!==void 0?new h(i,void 0,n,void 0,void 0,void 0,s):new h(void 0,void 0,i,void 0,void 0,void 0,s)}e.$vd=f;function t(i,n){return new h(i.owner,i.debugName,n,void 0,void 0,i.onLastObserverRemoved,i.equalityComparer??s)}e.$wd=t;function d(i,n){return new h(i.owner,i.debugName,n,i.createEmptyChangeSummary,i.handleChange,void 0,i.equalityComparer??s)}e.$xd=d;function $(i,n){let r,m;n===void 0?(r=i,m=void 0):(m=i,r=n);const E=new S.$Sc;return new h(m,()=>(0,v.$Md)(r)??"(anonymous)",R=>(E.clear(),r(R,E)),void 0,void 0,()=>E.dispose(),s)}e.$yd=$;function l(i,n){let r,m;n===void 0?(r=i,m=void 0):(m=i,r=n);const E=new S.$Sc;return new h(m,()=>(0,v.$Md)(r)??"(anonymous)",R=>{E.clear();const L=r(R);return L&&E.add(L),L},void 0,void 0,()=>E.dispose(),s)}e.$zd=l,(0,v.$Dd)(t);var o;(function(i){i[i.initial=0]="initial",i[i.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",i[i.stale=2]="stale",i[i.upToDate=3]="upToDate"})(o||(o={}));class h extends v.$Fd{get debugName(){return(0,v.$Ld)(this,this.p,this._computeFn,this.n)??"(anonymous)"}constructor(n,r,m,E,R,L=void 0,T){super(),this.n=n,this.p=r,this._computeFn=m,this.q=E,this.s=R,this.t=L,this.u=T,this.e=0,this.h=void 0,this.j=0,this.k=new Set,this.l=new Set,this.m=void 0,this.m=this.q?.(),(0,N.$td)()?.handleDerivedCreated(this)}g(){this.e=0,this.h=void 0;for(const n of this.k)n.removeObserver(this);this.k.clear(),this.t?.()}get(){if(this.c.size===0){const n=this._computeFn(this,this.q?.());return this.g(),n}else{do{if(this.e===1){for(const n of this.k)if(n.reportChanges(),this.e===2)break}this.e===1&&(this.e=3),this.w()}while(this.e!==3);return this.h}}w(){if(this.e===3)return;const n=this.l;this.l=this.k,this.k=n;const r=this.e!==0,m=this.h;this.e=3;const E=this.m;this.m=this.q?.();try{this.h=this._computeFn(this,E)}finally{for(const L of this.l)L.removeObserver(this);this.l.clear()}const R=r&&!this.u(m,this.h);if((0,N.$td)()?.handleDerivedRecomputed(this,{oldValue:m,newValue:this.h,change:void 0,didChange:R,hadValue:r}),R)for(const L of this.c)L.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(n){this.j++;const r=this.j===1;if(this.e===3&&(this.e=1,!r))for(const m of this.c)m.handlePossibleChange(this);if(r)for(const m of this.c)m.beginUpdate(this)}endUpdate(n){if(this.j--,this.j===0){const r=[...this.c];for(const m of r)m.endUpdate(this)}(0,P.$8c)(()=>this.j>=0)}handlePossibleChange(n){if(this.e===3&&this.k.has(n)&&!this.l.has(n)){this.e=1;for(const r of this.c)r.handlePossibleChange(this)}}handleChange(n,r){if(this.k.has(n)&&!this.l.has(n)){const m=this.s?this.s({changedObservable:n,change:r,didChange:R=>R===n},this.m):!0,E=this.e===3;if(m&&(this.e===1||E)&&(this.e=2,E))for(const R of this.c)R.handlePossibleChange(this)}}readObservable(n){n.addObserver(this);const r=n.get();return this.k.add(n),this.l.delete(n),r}addObserver(n){const r=!this.c.has(n)&&this.j>0;super.addObserver(n),r&&n.beginUpdate(this)}removeObserver(n){const r=this.c.has(n)&&this.j>0;super.removeObserver(n),r&&n.endUpdate(this)}}e.$Ad=h}),define(V[24],p([0,1,2,9,5,10,4]),function(H,e,P,S,v,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rd=e.$qd=e.$pd=e.$od=e.$nd=e.$md=e.$ld=e.$kd=e.$jd=e.$id=e.$hd=e.$gd=e.$fd=e.$ed=void 0;function f(D){return new t(D)}e.$ed=f;class t extends v.$Ed{constructor(c){super(),this.a=c}get debugName(){return this.toString()}get(){return this.a}addObserver(c){}removeObserver(c){}toString(){return`Const: ${this.a}`}}function d(D){const c=(0,v.$Nd)("promiseValue",{});return D.then(k=>{c.set({value:k},void 0)}),c}e.$fd=d;function $(D,c){return new Promise(k=>{let M=!1,C=!1;const b=D.map(I=>({isFinished:c(I),state:I})),a=(0,S.$0c)(I=>{const{isFinished:z,state:q}=b.read(I);z&&(M?a.dispose():C=!0,k(q))});M=!0,C&&a.dispose()})}e.$gd=$;function l(D,c){return new o(D,c)}e.$hd=l;class o extends v.$Fd{constructor(c,k){super(),this.h=c,this._getValue=k,this.b=!1,this.l=M=>{const C=this._getValue(M),b=this.a,a=!this.b||b!==C;let I=!1;a&&(this.a=C,this.b&&(I=!0,(0,v.$Jd)(o.globalTransaction,z=>{(0,s.$td)()?.handleFromEventObservableTriggered(this,{oldValue:b,newValue:C,change:void 0,didChange:a,hadValue:this.b});for(const q of this.c)z.updateObserver(q,this),q.handleChange(this,void 0)},()=>{const z=this.j();return"Event fired"+(z?`: ${z}`:"")})),this.b=!0),I||(0,s.$td)()?.handleFromEventObservableTriggered(this,{oldValue:b,newValue:C,change:void 0,didChange:a,hadValue:this.b})}}j(){return(0,v.$Md)(this._getValue)}get debugName(){const c=this.j();return"From Event"+(c?`: ${c}`:"")}f(){this.e=this.h(this.l)}g(){this.e.dispose(),this.e=void 0,this.b=!1,this.a=void 0}get(){return this.e?(this.b||this.l(void 0),this.a):this._getValue(void 0)}}e.$id=o,function(D){D.Observer=o;function c(k,M){let C=!1;o.globalTransaction===void 0&&(o.globalTransaction=k,C=!0);try{M()}finally{C&&(o.globalTransaction=void 0)}}D.batchEventsGlobally=c}(l||(e.$hd=l={}));function h(D,c){return new i(D,c)}e.$jd=h;class i extends v.$Fd{constructor(c,k){super(),this.debugName=c,this.b=k,this.h=()=>{(0,v.$Gd)(M=>{for(const C of this.c)M.updateObserver(C,this),C.handleChange(this,void 0)},()=>this.debugName)}}f(){this.a=this.b(this.h)}g(){this.a.dispose(),this.a=void 0}get(){}}function n(D){return typeof D=="string"?new r(D):new r(void 0,D)}e.$kd=n;class r extends v.$Fd{get debugName(){return(0,v.$Ld)(this,this.a,void 0,this.b)??"Observable Signal"}constructor(c,k){super(),this.a=c,this.b=k}trigger(c,k){if(!c){(0,v.$Gd)(M=>{this.trigger(M,k)},()=>`Trigger signal ${this.debugName}`);return}for(const M of this.c)c.updateObserver(M,this),M.handleChange(this,k)}get(){}}function m(D,c,k){const M=(0,v.$Nd)("debounced",void 0);let C;return k.add((0,S.$0c)(b=>{const a=D.read(b);C&&clearTimeout(C),C=setTimeout(()=>{(0,v.$Gd)(I=>{M.set(a,I)})},c)})),M}e.$ld=m;function E(D,c,k){const M=(0,v.$Nd)("triggeredRecently",!1);let C;return k.add(D(()=>{M.set(!0,void 0),C&&clearTimeout(C),C=setTimeout(()=>{M.set(!1,void 0)},c)})),M}e.$md=E;function R(D){const c=new T(!1,void 0);return D.addObserver(c),(0,P.$Rc)(()=>{D.removeObserver(c)})}e.$nd=R,(0,v.$Cd)(R);function L(D,c){const k=new T(!0,c);return D.addObserver(k),c?c(D.get()):D.reportChanges(),(0,P.$Rc)(()=>{D.removeObserver(k)})}e.$od=L,(0,v.$Bd)(L);class T{constructor(c,k){this.b=c,this.c=k,this.a=0}beginUpdate(c){this.a++}endUpdate(c){this.a--,this.a===0&&this.b&&(this.c?this.c(c.get()):c.reportChanges())}handlePossibleChange(c){}handleChange(c,k){}}function g(D){let c;return(0,N.$vd)(M=>(c=D(M,c),c))}e.$pd=g;function y(D,c){let k;const M=(0,v.$Nd)("derivedObservableWithWritableCache.counter",0),C=(0,N.$vd)(D,b=>(M.read(b),k=c(b,k),k));return Object.assign(C,{clearCache:b=>{k=void 0,M.set(M.get()+1,b)}})}e.$qd=y;function O(D,c,k,M){let C=new F(k,M);return(0,N.$wd)({debugName:()=>(0,v.$Ld)(C,void 0,k,D),owner:D,onLastObserverRemoved:()=>{C.dispose(),C=new F(k)}},a=>(C.setItems(c.read(a)),C.getItems()))}e.$rd=O;class F{constructor(c,k){this.c=c,this.e=k,this.a=new Map,this.b=[]}dispose(){this.a.forEach(c=>c.store.dispose()),this.a.clear()}setItems(c){const k=[],M=new Set(this.a.keys());for(const C of c){const b=this.e?this.e(C):C;let a=this.a.get(b);if(a)M.delete(b);else{const I=new P.$Sc;a={out:this.c(C,I),store:I},this.a.set(b,a)}k.push(a.out)}for(const C of M)this.a.get(C).store.dispose(),this.a.delete(C);this.b=k}getItems(){return this.b}}}),define(V[11],p([0,1,5,10,9,24,4]),function(H,e,P,S,v,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.wasEventTriggeredRecently=e.waitForState=e.observableSignalFromEvent=e.observableSignal=e.observableFromPromise=e.observableFromEvent=e.recomputeInitiallyAndOnChange=e.keepObserved=e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.debouncedObservable=e.constObservable=e.autorunWithStoreHandleChanges=e.autorunOpts=e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derivedWithStore=e.derivedHandleChanges=e.derivedOpts=e.derived=e.subtransaction=e.transaction=e.disposableObservableValue=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return P.$Nd}}),Object.defineProperty(e,"disposableObservableValue",{enumerable:!0,get:function(){return P.$Pd}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return P.$Gd}}),Object.defineProperty(e,"subtransaction",{enumerable:!0,get:function(){return P.$Jd}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return S.$vd}}),Object.defineProperty(e,"derivedOpts",{enumerable:!0,get:function(){return S.$wd}}),Object.defineProperty(e,"derivedHandleChanges",{enumerable:!0,get:function(){return S.$xd}}),Object.defineProperty(e,"derivedWithStore",{enumerable:!0,get:function(){return S.$yd}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return v.$0c}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return v.$dd}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return v.$_c}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return v.$bd}}),Object.defineProperty(e,"autorunOpts",{enumerable:!0,get:function(){return v.$$c}}),Object.defineProperty(e,"autorunWithStoreHandleChanges",{enumerable:!0,get:function(){return v.$ad}}),Object.defineProperty(e,"constObservable",{enumerable:!0,get:function(){return N.$ed}}),Object.defineProperty(e,"debouncedObservable",{enumerable:!0,get:function(){return N.$ld}}),Object.defineProperty(e,"derivedObservableWithCache",{enumerable:!0,get:function(){return N.$pd}}),Object.defineProperty(e,"derivedObservableWithWritableCache",{enumerable:!0,get:function(){return N.$qd}}),Object.defineProperty(e,"keepObserved",{enumerable:!0,get:function(){return N.$nd}}),Object.defineProperty(e,"recomputeInitiallyAndOnChange",{enumerable:!0,get:function(){return N.$od}}),Object.defineProperty(e,"observableFromEvent",{enumerable:!0,get:function(){return N.$hd}}),Object.defineProperty(e,"observableFromPromise",{enumerable:!0,get:function(){return N.$fd}}),Object.defineProperty(e,"observableSignal",{enumerable:!0,get:function(){return N.$kd}}),Object.defineProperty(e,"observableSignalFromEvent",{enumerable:!0,get:function(){return N.$jd}}),Object.defineProperty(e,"waitForState",{enumerable:!0,get:function(){return N.$gd}}),Object.defineProperty(e,"wasEventTriggeredRecently",{enumerable:!0,get:function(){return N.$md}}),!1&&(0,s.$sd)(new s.$ud)}),define(V[25],p([0,1,6,2]),function(H,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ie=e.$he=e.$ge=e.$fe=e.$ee=e.$de=e.$ce=e.$be=e.$ae=e.$_d=e.$$d=e.$0d=e.$9d=e.$8d=e.$7d=void 0;function v(L){const T=L;return T?typeof T.read=="function":!1}e.$7d=v;function N(L){const T=L;return T?[T.on,T.pause,T.resume,T.destroy].every(g=>typeof g=="function"):!1}e.$8d=N;function s(L){const T=L;return T?N(T.stream)&&Array.isArray(T.buffer)&&typeof T.ended=="boolean":!1}e.$9d=s;function f(L,T){return new t(L,T)}e.$0d=f;class t{constructor(T,g){this.e=T,this.f=g,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(T){if(!this.a.destroyed){if(this.a.flowing)this.g(T);else if(this.b.data.push(T),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(g=>this.d.push(g))}}error(T){this.a.destroyed||(this.a.flowing?this.h(T):this.b.error.push(T))}end(T){this.a.destroyed||(typeof T<"u"&&this.write(T),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(T){this.c.data.slice(0).forEach(g=>g(T))}h(T){this.c.error.length===0?(0,P.$1)(T):this.c.error.slice(0).forEach(g=>g(T))}i(){this.c.end.slice(0).forEach(T=>T())}on(T,g){if(!this.a.destroyed)switch(T){case"data":this.c.data.push(g),this.resume();break;case"end":this.c.end.push(g),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(g),this.a.flowing&&this.k();break}}removeListener(T,g){if(this.a.destroyed)return;let y;switch(T){case"data":y=this.c.data;break;case"end":y=this.c.end;break;case"error":y=this.c.error;break}if(y){const O=y.indexOf(g);O>=0&&y.splice(O,1)}}j(){if(this.b.data.length>0){const T=this.e(this.b.data);this.g(T),this.b.data.length=0;const g=[...this.d];this.d.length=0,g.forEach(y=>y())}}k(){if(this.c.error.length>0){for(const T of this.b.error)this.h(T);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function d(L,T){const g=[];let y;for(;(y=L.read())!==null;)g.push(y);return T(g)}e.$$d=d;function $(L,T,g){const y=[];let O;for(;(O=L.read())!==null&&y.length<g;)y.push(O);return O===null&&y.length>0?T(y):{read:()=>{if(y.length>0)return y.shift();if(typeof O<"u"){const F=O;return O=void 0,F}return L.read()}}}e.$_d=$;function l(L,T){return new Promise((g,y)=>{const O=[];o(L,{onData:F=>{T&&O.push(F)},onError:F=>{T?y(F):g(void 0)},onEnd:()=>{g(T?T(O):void 0)}})})}e.$ae=l;function o(L,T,g){L.on("error",y=>{g?.isCancellationRequested||T.onError(y)}),L.on("end",()=>{g?.isCancellationRequested||T.onEnd()}),L.on("data",y=>{g?.isCancellationRequested||T.onData(y)})}e.$be=o;function h(L,T){return new Promise((g,y)=>{const O=new S.$Sc,F=[],D=M=>{if(F.push(M),F.length>T)return O.dispose(),L.pause(),g({stream:L,buffer:F,ended:!1})},c=M=>(O.dispose(),y(M)),k=()=>(O.dispose(),g({stream:L,buffer:F,ended:!0}));O.add((0,S.$Rc)(()=>L.removeListener("error",c))),L.on("error",c),O.add((0,S.$Rc)(()=>L.removeListener("end",k))),L.on("end",k),O.add((0,S.$Rc)(()=>L.removeListener("data",D))),L.on("data",D)})}e.$ce=h;function i(L,T){const g=f(T);return g.end(L),g}e.$de=i;function n(){const L=f(()=>{throw new Error("not supported")});return L.end(),L}e.$ee=n;function r(L){let T=!1;return{read:()=>T?null:(T=!0,L)}}e.$fe=r;function m(L,T,g){const y=f(g);return o(L,{onData:O=>y.write(T.data(O)),onError:O=>y.error(T.error?T.error(O):O),onEnd:()=>y.end()}),y}e.$ge=m;function E(L,T,g){let y=!1;return{read:()=>{const O=T.read();return y?O:(y=!0,O!==null?g([L,O]):L)}}}e.$he=E;function R(L,T,g){let y=!1;const O=f(g);return o(T,{onData:F=>y?O.write(F):(y=!0,O.write(g([L,F]))),onError:F=>O.error(F),onEnd:()=>{y||(y=!0,O.write(L)),O.end()}}),O}e.$ie=R}),define(V[12],p([0,1,26,25]),function(H,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$De=e.$Ce=e.$Be=e.$Ae=e.$ze=e.$ye=e.$xe=e.$we=e.$ve=e.$ue=e.$te=e.$se=e.$re=e.$qe=e.$pe=e.$oe=e.$ne=e.$me=e.$le=e.$ke=e.$je=void 0;const v=typeof Buffer<"u",N=new P.$V(()=>new Uint8Array(256));let s,f;class t{static alloc(a){return v?new t(Buffer.allocUnsafe(a)):new t(new Uint8Array(a))}static wrap(a){return v&&!Buffer.isBuffer(a)&&(a=Buffer.from(a.buffer,a.byteOffset,a.byteLength)),new t(a)}static fromString(a,I){return!(I?.dontUseNodeBuffer||!1)&&v?new t(Buffer.from(a)):(s||(s=new TextEncoder),new t(s.encode(a)))}static fromByteArray(a){const I=t.alloc(a.length);for(let z=0,q=a.length;z<q;z++)I.buffer[z]=a[z];return I}static concat(a,I){if(typeof I>"u"){I=0;for(let W=0,K=a.length;W<K;W++)I+=a[W].byteLength}const z=t.alloc(I);let q=0;for(let W=0,K=a.length;W<K;W++){const G=a[W];z.set(G,q),q+=G.byteLength}return z}constructor(a){this.buffer=a,this.byteLength=this.buffer.byteLength}clone(){const a=t.alloc(this.byteLength);return a.set(this),a}toString(){return v?this.buffer.toString():(f||(f=new TextDecoder),f.decode(this.buffer))}slice(a,I){return new t(this.buffer.subarray(a,I))}set(a,I){if(a instanceof t)this.buffer.set(a.buffer,I);else if(a instanceof Uint8Array)this.buffer.set(a,I);else if(a instanceof ArrayBuffer)this.buffer.set(new Uint8Array(a),I);else if(ArrayBuffer.isView(a))this.buffer.set(new Uint8Array(a.buffer,a.byteOffset,a.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(a){return o(this.buffer,a)}writeUInt32BE(a,I){h(this.buffer,a,I)}readUInt32LE(a){return i(this.buffer,a)}writeUInt32LE(a,I){n(this.buffer,a,I)}readUInt8(a){return r(this.buffer,a)}writeUInt8(a,I){m(this.buffer,a,I)}indexOf(a,I=0){return d(this.buffer,a instanceof t?a.buffer:a,I)}}e.$je=t;function d(b,a,I=0){const z=a.byteLength,q=b.byteLength;if(z===0)return 0;if(z===1)return b.indexOf(a[0]);if(z>q-I)return-1;const W=N.value;W.fill(a.length);for(let J=0;J<a.length;J++)W[a[J]]=a.length-J-1;let K=I+a.length-1,G=K,_=-1;for(;K<q;)if(b[K]===a[G]){if(G===0){_=K;break}K--,G--}else K+=Math.max(a.length-G,W[b[K]]),G=a.length-1;return _}e.$ke=d;function $(b,a){return b[a+0]<<0>>>0|b[a+1]<<8>>>0}e.$le=$;function l(b,a,I){b[I+0]=a&255,a=a>>>8,b[I+1]=a&255}e.$me=l;function o(b,a){return b[a]*2**24+b[a+1]*2**16+b[a+2]*2**8+b[a+3]}e.$ne=o;function h(b,a,I){b[I+3]=a,a=a>>>8,b[I+2]=a,a=a>>>8,b[I+1]=a,a=a>>>8,b[I]=a}e.$oe=h;function i(b,a){return b[a+0]<<0>>>0|b[a+1]<<8>>>0|b[a+2]<<16>>>0|b[a+3]<<24>>>0}e.$pe=i;function n(b,a,I){b[I+0]=a&255,a=a>>>8,b[I+1]=a&255,a=a>>>8,b[I+2]=a&255,a=a>>>8,b[I+3]=a&255}e.$qe=n;function r(b,a){return b[a]}e.$re=r;function m(b,a,I){b[I]=a}e.$se=m;function E(b){return S.$$d(b,a=>t.concat(a))}e.$te=E;function R(b){return S.$fe(b)}e.$ue=R;function L(b){return S.$ae(b,a=>t.concat(a))}e.$ve=L;async function T(b){return b.ended?t.concat(b.buffer):t.concat([...b.buffer,await L(b.stream)])}e.$we=T;function g(b){return S.$de(b,a=>t.concat(a))}e.$xe=g;function y(b){return S.$ge(b,{data:a=>typeof a=="string"?t.fromString(a):t.wrap(a)},a=>t.concat(a))}e.$ye=y;function O(b){return S.$0d(a=>t.concat(a),b)}e.$ze=O;function F(b,a){return S.$he(b,a,I=>t.concat(I))}e.$Ae=F;function D(b,a){return S.$ie(b,a,I=>t.concat(I))}e.$Be=D;function c(b){let a=0,I=0,z=0;const q=new Uint8Array(Math.floor(b.length/4*3)),W=G=>{switch(I){case 3:q[z++]=a|G,I=0;break;case 2:q[z++]=a|G>>>2,a=G<<6,I=3;break;case 1:q[z++]=a|G>>>4,a=G<<4,I=2;break;default:a=G<<2,I=1}};for(let G=0;G<b.length;G++){const _=b.charCodeAt(G);if(_>=65&&_<=90)W(_-65);else if(_>=97&&_<=122)W(_-97+26);else if(_>=48&&_<=57)W(_-48+52);else if(_===43||_===45)W(62);else if(_===47||_===95)W(63);else{if(_===61)break;throw new SyntaxError(`Unexpected base64 character ${b[G]}`)}}const K=z;for(;I>0;)W(0);return t.wrap(q).slice(0,K)}e.$Ce=c;const k="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",M="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function C({buffer:b},a=!0,I=!1){const z=I?M:k;let q="";const W=b.byteLength%3;let K=0;for(;K<b.byteLength-W;K+=3){const G=b[K+0],_=b[K+1],J=b[K+2];q+=z[G>>>2],q+=z[(G<<4|_>>>4)&63],q+=z[(_<<2|J>>>6)&63],q+=z[J&63]}if(W===1){const G=b[K+0];q+=z[G>>>2],q+=z[G<<4&63],a&&(q+="==")}else if(W===2){const G=b[K+0],_=b[K+1];q+=z[G>>>2],q+=z[(G<<4|_>>>4)&63],q+=z[_<<2&63],a&&(q+="=")}return q}e.$De=C}),define(V[27],p([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sd=void 0,e.$Sd=Symbol("MicrotaskDelay")}),define(V[13],p([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ut=e.StringEOL=void 0;var P;(function(v){v[v.Unknown=0]="Unknown",v[v.Invalid=3]="Invalid",v[v.LF=1]="LF",v[v.CRLF=2]="CRLF"})(P||(e.StringEOL=P={}));function S(v){let N=0,s=0,f=0,t=0;for(let d=0,$=v.length;d<$;d++){const l=v.charCodeAt(d);l===13?(N===0&&(s=d),N++,d+1<$&&v.charCodeAt(d+1)===10?(t|=2,d++):t|=3,f=d+1):l===10&&(t|=1,N===0&&(s=d),N++,f=d+1)}return N===0&&(s=v.length),[N,s,v.length-f,t]}e.$ut=S}),define(V[14],p([0,1]),function(H,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$st=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var P;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(P||(e.LanguageId=P={}));var S;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(S||(e.FontStyle=S={}));var v;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(v||(e.ColorId=v={}));var N;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(N||(e.StandardTokenType=N={}));var s;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(s||(e.MetadataConsts=s={}));class f{static getLanguageId(d){return(d&255)>>>0}static getTokenType(d){return(d&768)>>>8}static containsBalancedBrackets(d){return(d&1024)!==0}static getFontStyle(d){return(d&30720)>>>11}static getForeground(d){return(d&16744448)>>>15}static getBackground(d){return(d&4278190080)>>>24}static getClassNameFromMetadata(d){let l="mtk"+this.getForeground(d);const o=this.getFontStyle(d);return o&1&&(l+=" mtki"),o&2&&(l+=" mtkb"),o&4&&(l+=" mtku"),o&8&&(l+=" mtks"),l}static getInlineStyleFromMetadata(d,$){const l=this.getForeground(d),o=this.getFontStyle(d);let h=`color: ${$[l]};`;o&1&&(h+="font-style: italic;"),o&2&&(h+="font-weight: bold;");let i="";return o&4&&(i+=" underline"),o&8&&(i+=" line-through"),i&&(h+=`text-decoration:${i};`),h}static getPresentationFromMetadata(d){const $=this.getForeground(d),l=this.getFontStyle(d);return{foreground:$,italic:!!(l&1),bold:!!(l&2),underline:!!(l&4),strikethrough:!!(l&8)}}}e.$st=f}),define(V[28],p([0,1,29]),function(H,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gC=void 0;class S{constructor(s){this.b=s,this.a=[]}get(s){return s<this.a.length?this.a[s]:this.b}set(s,f){for(;s>=this.a.length;)this.a[this.a.length]=this.b;this.a[s]=f}replace(s,f,t){if(s>=this.a.length)return;if(f===0){this.insert(s,t);return}else if(t===0){this.delete(s,f);return}const d=this.a.slice(0,s),$=this.a.slice(s+f),l=v(t,this.b);this.a=d.concat(l,$)}delete(s,f){f===0||s>=this.a.length||this.a.splice(s,f)}insert(s,f){if(f===0||s>=this.a.length)return;const t=[];for(let d=0;d<f;d++)t[d]=this.b;this.a=(0,P.$Wb)(this.a,s,t)}}e.$gC=S;function v(N,s){const f=[];for(let t=0;t<N;t++)f[t]=s;return f}}),define(V[7],p([0,1,14]),function(H,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vt=void 0;class S{static{this.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0}static createEmpty(s,f){const t=S.defaultTokenMetadata,d=new Uint32Array(2);return d[0]=s.length,d[1]=t,new S(d,s,f)}constructor(s,f,t){this._lineTokensBrand=void 0,this.a=s,this.b=this.a.length>>>1,this.c=f,this.d=t}equals(s){return s instanceof S?this.slicedEquals(s,0,this.b):!1}slicedEquals(s,f,t){if(this.c!==s.c||this.b!==s.b)return!1;const d=f<<1,$=d+(t<<1);for(let l=d;l<$;l++)if(this.a[l]!==s.a[l])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(s){return s>0?this.a[s-1<<1]:0}getMetadata(s){return this.a[(s<<1)+1]}getLanguageId(s){const f=this.a[(s<<1)+1],t=P.$st.getLanguageId(f);return this.d.decodeLanguageId(t)}getStandardTokenType(s){const f=this.a[(s<<1)+1];return P.$st.getTokenType(f)}getForeground(s){const f=this.a[(s<<1)+1];return P.$st.getForeground(f)}getClassName(s){const f=this.a[(s<<1)+1];return P.$st.getClassNameFromMetadata(f)}getInlineStyle(s,f){const t=this.a[(s<<1)+1];return P.$st.getInlineStyleFromMetadata(t,f)}getPresentation(s){const f=this.a[(s<<1)+1];return P.$st.getPresentationFromMetadata(f)}getEndOffset(s){return this.a[s<<1]}findTokenIndexAtOffset(s){return S.findIndexInTokensArray(this.a,s)}inflate(){return this}sliceAndInflate(s,f,t){return new v(this,s,f,t)}static convertToEndOffset(s,f){const d=(s.length>>>1)-1;for(let $=0;$<d;$++)s[$<<1]=s[$+1<<1];s[d<<1]=f}static findIndexInTokensArray(s,f){if(s.length<=2)return 0;let t=0,d=(s.length>>>1)-1;for(;t<d;){const $=t+Math.floor((d-t)/2),l=s[$<<1];if(l===f)return $+1;l<f?t=$+1:l>f&&(d=$)}return t}withInserted(s){if(s.length===0)return this;let f=0,t=0,d="";const $=new Array;let l=0;for(;;){const o=f<this.b?this.a[f<<1]:-1,h=t<s.length?s[t]:null;if(o!==-1&&(h===null||o<=h.offset)){d+=this.c.substring(l,o);const i=this.a[(f<<1)+1];$.push(d.length,i),f++,l=o}else if(h){if(h.offset>l){d+=this.c.substring(l,h.offset);const i=this.a[(f<<1)+1];$.push(d.length,i),l=h.offset}d+=h.text,$.push(d.length,h.tokenMetadata),t++}else break}return new S(new Uint32Array($),d,this.d)}}e.$vt=S;class v{constructor(s,f,t,d){this.a=s,this.b=f,this.c=t,this.d=d,this.e=s.findTokenIndexAtOffset(f),this.f=0;for(let $=this.e,l=s.getCount();$<l&&!(s.getStartOffset($)>=t);$++)this.f++}getMetadata(s){return this.a.getMetadata(this.e+s)}getLanguageId(s){return this.a.getLanguageId(this.e+s)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(s){return s instanceof v?this.b===s.b&&this.c===s.c&&this.d===s.d&&this.a.slicedEquals(s.a,this.e,this.f):!1}getCount(){return this.f}getForeground(s){return this.a.getForeground(this.e+s)}getEndOffset(s){const f=this.a.getEndOffset(this.e+s);return Math.min(this.c,f)-this.b+this.d}getClassName(s){return this.a.getClassName(this.e+s)}getInlineStyle(s,f){return this.a.getInlineStyle(this.e+s,f)}getPresentation(s){return this.a.getPresentation(this.e+s)}findTokenIndexAtOffset(s){return this.a.findTokenIndexAtOffset(s+this.b-this.d)-this.e}}}),define(V[30],p([0,1,7]),function(H,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yt=e.$xt=e.$wt=void 0,e.$wt=new Uint32Array(0).buffer;class S{static deleteBeginning(s,f){return s===null||s===e.$wt?s:S.delete(s,0,f)}static deleteEnding(s,f){if(s===null||s===e.$wt)return s;const t=v(s),d=t[t.length-2];return S.delete(s,f,d)}static delete(s,f,t){if(s===null||s===e.$wt||f===t)return s;const d=v(s),$=d.length>>>1;if(f===0&&d[d.length-2]===t)return e.$wt;const l=P.$vt.findIndexInTokensArray(d,f),o=l>0?d[l-1<<1]:0,h=d[l<<1];if(t<h){const E=t-f;for(let R=l;R<$;R++)d[R<<1]-=E;return s}let i,n;o!==f?(d[l<<1]=f,i=l+1<<1,n=f):(i=l<<1,n=o);const r=t-f;for(let E=l+1;E<$;E++){const R=d[E<<1]-r;R>n&&(d[i++]=R,d[i++]=d[(E<<1)+1],n=R)}if(i===d.length)return s;const m=new Uint32Array(i);return m.set(d.subarray(0,i),0),m.buffer}static append(s,f){if(f===e.$wt)return s;if(s===e.$wt)return f;if(s===null)return s;if(f===null)return null;const t=v(s),d=v(f),$=d.length>>>1,l=new Uint32Array(t.length+d.length);l.set(t,0);let o=t.length;const h=t[t.length-2];for(let i=0;i<$;i++)l[o++]=d[i<<1]+h,l[o++]=d[(i<<1)+1];return l.buffer}static insert(s,f,t){if(s===null||s===e.$wt)return s;const d=v(s),$=d.length>>>1;let l=P.$vt.findIndexInTokensArray(d,f);l>0&&d[l-1<<1]===f&&l--;for(let o=l;o<$;o++)d[o<<1]+=t;return s}}e.$xt=S;function v(N){return N instanceof Uint32Array?N:new Uint32Array(N)}e.$yt=v}),define(V[31],p([0,1,29,12,44,13,30,15]),function(H,e,P,S,v,N,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zt=void 0;class t{static deserialize($,l,o){const h=new Uint32Array($.buffer),i=(0,S.$ne)($,l);l+=4;const n=(0,S.$ne)($,l);l+=4;const r=[];for(let m=0;m<n;m++){const E=(0,S.$ne)($,l);l+=4,r.push(h.subarray(l/4,l/4+E/4)),l+=E}return o.push(new t(i,r)),l}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor($,l){this.a=$,this.b=l}getLineRange(){return new f.$4s(this.a,this.a+this.b.length)}getLineTokens($){return this.b[$-this.a]}appendLineTokens($){this.b.push($)}serializeSize(){let $=0;$+=4,$+=4;for(let l=0;l<this.b.length;l++){const o=this.b[l];if(!(o instanceof Uint32Array))throw new Error("Not supported!");$+=4,$+=o.byteLength}return $}serialize($,l){(0,S.$oe)($,this.a,l),l+=4,(0,S.$oe)($,this.b.length,l),l+=4;for(let o=0;o<this.b.length;o++){const h=this.b[o];if(!(h instanceof Uint32Array))throw new Error("Not supported!");(0,S.$oe)($,h.byteLength,l),l+=4,$.set(new Uint8Array(h.buffer),l),l+=h.byteLength}return l}applyEdit($,l){const[o,h]=(0,N.$ut)(l);this.c($),this.d(new v.$Ts($.startLineNumber,$.startColumn),o,h)}c($){if($.startLineNumber===$.endLineNumber&&$.startColumn===$.endColumn)return;const l=$.startLineNumber-this.a,o=$.endLineNumber-this.a;if(o<0){const h=o-l;this.a-=h;return}if(!(l>=this.b.length)){if(l<0&&o>=this.b.length){this.a=0,this.b=[];return}if(l===o){this.b[l]=s.$xt.delete(this.b[l],$.startColumn-1,$.endColumn-1);return}if(l>=0)if(this.b[l]=s.$xt.deleteEnding(this.b[l],$.startColumn-1),o<this.b.length){const h=s.$xt.deleteBeginning(this.b[o],$.endColumn-1);this.b[l]=s.$xt.append(this.b[l],h),this.b.splice(l+1,o-l)}else this.b[l]=s.$xt.append(this.b[l],null),this.b=this.b.slice(0,l+1);else{const h=-l;this.a-=h,this.b[o]=s.$xt.deleteBeginning(this.b[o],$.endColumn-1),this.b=this.b.slice(o)}}}d($,l,o){if(l===0&&o===0)return;const h=$.lineNumber-this.a;if(h<0){this.a+=l;return}if(!(h>=this.b.length)){if(l===0){this.b[h]=s.$xt.insert(this.b[h],$.column-1,o);return}this.b[h]=s.$xt.deleteEnding(this.b[h],$.column-1),this.b[h]=s.$xt.insert(this.b[h],$.column-1,o),this.e($.lineNumber,l)}}e($,l){if(l===0)return;const o=[];for(let h=0;h<l;h++)o[h]=null;this.b=P.$Wb(this.b,$,o)}}e.$zt=t}),define(V[16],p([0,1,12,31]),function(H,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hC=void 0;class v{static deserialize(s){let f=0;const t=(0,P.$ne)(s,f);f+=4;const d=[];for(let $=0;$<t;$++)f=S.$zt.deserialize(s,f,d);return d}constructor(){this.a=[]}add(s,f){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===s){t.appendLineTokens(f);return}}this.a.push(new S.$zt(s,[f]))}finalize(){return this.a}serialize(){const s=this.b(),f=new Uint8Array(s);return this.c(f),f}b(){let s=0;s+=4;for(let f=0;f<this.a.length;f++)s+=this.a[f].serializeSize();return s}c(s){let f=0;(0,P.$oe)(s,this.a.length,f),f+=4;for(let t=0;t<this.a.length;t++)f=this.a[t].serialize(s,f)}}e.$hC=v}),define(V[32],p([0,1,33,3,17,45]),function(H,e,P,S,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dg=e.$cg=e.$bg=e.$ag=e.$_f=e.$$f=e.$0f=e.$9f=e.$8f=e.$7f=e.$6f=e.$5f=e.$4f=e.$3f=e.$2f=e.$1f=void 0;function s(c){return c===47||c===92}e.$1f=s;function f(c){return c.replace(/[\\/]/g,P.$gc.sep)}e.$2f=f;function t(c){return c.indexOf("/")===-1&&(c=f(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.$3f=t;function d(c,k=P.$gc.sep){if(!c)return"";const M=c.length,C=c.charCodeAt(0);if(s(C)){if(s(c.charCodeAt(1))&&!s(c.charCodeAt(2))){let a=3;const I=a;for(;a<M&&!s(c.charCodeAt(a));a++);if(I!==a&&!s(c.charCodeAt(a+1))){for(a+=1;a<M;a++)if(s(c.charCodeAt(a)))return c.slice(0,a+1).replace(/[\\/]/g,k)}}return k}else if(m(C)&&c.charCodeAt(1)===58)return s(c.charCodeAt(2))?c.slice(0,2)+k:c.slice(0,2);let b=c.indexOf("://");if(b!==-1){for(b+=3;b<M;b++)if(s(c.charCodeAt(b)))return c.slice(0,b+1)}return""}e.$4f=d;function $(c){if(!S.$i||!c||c.length<5)return!1;let k=c.charCodeAt(0);if(k!==92||(k=c.charCodeAt(1),k!==92))return!1;let M=2;const C=M;for(;M<c.length&&(k=c.charCodeAt(M),k!==92);M++);return!(C===M||(k=c.charCodeAt(M+1),isNaN(k)||k===92))}e.$5f=$;const l=/[\\/:\*\?"<>\|]/g,o=/[\\/]/g,h=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function i(c,k=S.$i){const M=k?l:o;return!(!c||c.length===0||/^\s+$/.test(c)||(M.lastIndex=0,M.test(c))||k&&h.test(c)||c==="."||c===".."||k&&c[c.length-1]==="."||k&&c.length!==c.trim().length||c.length>255)}e.$6f=i;function n(c,k,M){const C=c===k;return!M||C?C:!c||!k?!1:(0,v.$_e)(c,k)}e.$7f=n;function r(c,k,M,C=P.sep){if(c===k)return!0;if(!c||!k||k.length>c.length)return!1;if(M){if(!(0,v.$af)(c,k))return!1;if(k.length===c.length)return!0;let a=k.length;return k.charAt(k.length-1)===C&&a--,c.charAt(a)===C}return k.charAt(k.length-1)!==C&&(k+=C),c.indexOf(k)===0}e.$8f=r;function m(c){return c>=65&&c<=90||c>=97&&c<=122}e.$9f=m;function E(c,k){return S.$i&&c.endsWith(":")&&(c+=P.sep),(0,P.$ic)(c)||(c=(0,P.$jc)(k,c)),c=(0,P.$hc)(c),S.$i?(c=(0,v.$Ue)(c,P.sep),c.endsWith(":")&&(c+=P.sep)):(c=(0,v.$Ue)(c,P.sep),c||(c=P.sep)),c}e.$0f=E;function R(c){const k=(0,P.$hc)(c);return S.$i?c.length>3?!1:L(k)&&(c.length===2||k.charCodeAt(2)===92):k===P.$gc.sep}e.$$f=R;function L(c,k=S.$i){return k?m(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.$_f=L;function T(c,k=S.$i){return L(c,k)?c[0]:void 0}e.$ag=T;function g(c,k,M){return k.length>c.length?-1:c===k?0:(M&&(c=c.toLowerCase(),k=k.toLowerCase()),c.indexOf(k))}e.$bg=g;function y(c){const k=c.split(":");let M,C,b;for(const a of k){const I=Number(a);(0,N.$Mf)(I)?C===void 0?C=I:b===void 0&&(b=I):M=M?[M,a].join(":"):a}if(!M)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:M,line:C!==void 0?C:void 0,column:b!==void 0?b:C!==void 0?1:void 0}}e.$cg=y;const O="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",F="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function D(c,k,M=8){let C="";for(let a=0;a<M;a++){let I;a===0&&S.$i&&!k&&(M===3||M===4)?I=F:I=O,C+=I.charAt(Math.floor(Math.random()*I.length))}let b;return k?b=`${k}-${C}`:b=C,c?(0,P.$jc)(c,b):b}e.$dg=D}),define(V[18],p([0,1,6,3,17,8]),function(H,e,P,S,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$og=e.$ng=e.$mg=e.$lg=e.$kg=e.$jg=e.$ig=e.$hg=e.$gg=e.$fg=e.$eg=e.Schemas=void 0;var s;(function(o){o.inMemory="inmemory",o.vscode="vscode",o.internal="private",o.walkThrough="walkThrough",o.walkThroughSnippet="walkThroughSnippet",o.http="http",o.https="https",o.file="file",o.mailto="mailto",o.untitled="untitled",o.data="data",o.command="command",o.vscodeRemote="vscode-remote",o.vscodeRemoteResource="vscode-remote-resource",o.vscodeManagedRemoteResource="vscode-managed-remote-resource",o.vscodeUserData="vscode-userdata",o.vscodeCustomEditor="vscode-custom-editor",o.vscodeNotebookCell="vscode-notebook-cell",o.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",o.vscodeNotebookCellOutput="vscode-notebook-cell-output",o.vscodeInteractiveInput="vscode-interactive-input",o.vscodeSettings="vscode-settings",o.vscodeWorkspaceTrust="vscode-workspace-trust",o.vscodeTerminal="vscode-terminal",o.vscodeChatSesssion="vscode-chat-editor",o.webviewPanel="webview-panel",o.vscodeWebview="vscode-webview",o.extension="extension",o.vscodeFileResource="vscode-file",o.tmp="tmp",o.vsls="vsls",o.vscodeSourceControl="vscode-scm"})(s||(e.Schemas=s={}));function f(o,h){return N.URI.isUri(o)?(0,v.$_e)(o.scheme,h):(0,v.$af)(o,h+":")}e.$eg=f;function t(o,...h){return h.some(i=>f(o,i))}e.$fg=t,e.$gg="vscode-tkn",e.$hg="tkn";class d{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${s.vscodeRemoteResource}`}setPreferredWebSchema(h){this.d=h}setDelegate(h){this.e=h}setServerRootPath(h){this.f=`${h}/${s.vscodeRemoteResource}`}set(h,i,n){this.a[h]=i,this.b[h]=n}setConnectionToken(h,i){this.c[h]=i}getPreferredWebSchema(){return this.d}rewrite(h){if(this.e)try{return this.e(h)}catch(R){return P.$1(R),h}const i=h.authority;let n=this.a[i];n&&n.indexOf(":")!==-1&&n.indexOf("[")===-1&&(n=`[${n}]`);const r=this.b[i],m=this.c[i];let E=`path=${encodeURIComponent(h.path)}`;return typeof m=="string"&&(E+=`&${e.$hg}=${encodeURIComponent(m)}`),N.URI.from({scheme:S.$o?this.d:s.vscodeRemoteResource,authority:`${n}:${r}`,path:this.f,query:E})}}e.$ig=new d,e.$jg="vs/../../extensions",e.$kg="vs/../../node_modules",e.$lg="vs/../../node_modules.asar",e.$mg="vs/../../node_modules.asar.unpacked",e.$ng="vscode-app";class ${static{this.a=e.$ng}asBrowserUri(h){const i=this.b(h,H);return this.uriToBrowserUri(i)}uriToBrowserUri(h){return h.scheme===s.vscodeRemote?e.$ig.rewrite(h):h.scheme===s.file&&(S.$m||S.$q===`${s.vscodeFileResource}://${$.a}`)?h.with({scheme:s.vscodeFileResource,authority:h.authority||$.a,query:null,fragment:null}):h}asFileUri(h){const i=this.b(h,H);return this.uriToFileUri(i)}uriToFileUri(h){return h.scheme===s.vscodeFileResource?h.with({scheme:s.file,authority:h.authority!==$.a?h.authority:null,query:null,fragment:null}):h}b(h,i){return N.URI.isUri(h)?h:N.URI.parse(i.toUrl(h))}}e.$og=new $;var l;(function(o){const h=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);o.CoopAndCoep=Object.freeze(h.get("3"));const i="vscode-coi";function n(m){let E;typeof m=="string"?E=new URL(m).searchParams:m instanceof URL?E=m.searchParams:N.URI.isUri(m)&&(E=new URL(m.toString(!0)).searchParams);const R=E?.get(i);if(R)return h.get(R)}o.getHeadersFromQuery=n;function r(m,E,R){if(!globalThis.crossOriginIsolated)return;const L=E&&R?"3":R?"2":"1";m instanceof URLSearchParams?m.set(i,L):m[i]=L}o.addSearchParam=r})(l||(e.COI=l={}))}),define(V[34],p([0,1,22,18,3,8]),function(H,e,P,S,v,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fD=void 0;class s{constructor(o,h,i){this.id=o,this.dependencies=h,this.callback=i}}class f{static{this.INSTANCE=new f}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(o,h,i)=>{typeof o!="string"&&(i=h,h=o,o=null),(typeof h!="object"||!Array.isArray(h))&&(i=h,h=null),this.c.push(new s(o,h,i))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){if(o.startsWith(window.location.origin)||o.startsWith("vscode-file://vscode-app"))return o;throw new Error(`[trusted_script_src] Invalid script url: ${o}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(o){return o}})))}async load(o){this.g();const h=await(this.a?this.i(o):this.b?this.h(o):this.j(o));if(!h)throw new Error(`Did not receive a define call from script ${o}`);if(Array.isArray(h.dependencies)&&h.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${o}. The dependencies are: ${h.dependencies.join(", ")}`);return typeof h.callback=="function"?h.callback([]):h.callback}h(o){return new Promise((h,i)=>{const n=document.createElement("script");n.setAttribute("async","async"),n.setAttribute("type","text/javascript");const r=()=>{n.removeEventListener("load",m),n.removeEventListener("error",E)},m=R=>{r(),h(this.c.pop())},E=R=>{r(),i(R)};n.addEventListener("load",m),n.addEventListener("error",E),this.f&&(o=this.f.createScriptURL(o)),n.setAttribute("src",o),window.document.getElementsByTagName("head")[0].appendChild(n)})}i(o){return new Promise((h,i)=>{try{this.f&&(o=this.f.createScriptURL(o)),importScripts(o),h(this.c.pop())}catch(n){i(n)}})}async j(o){try{const h=globalThis._VSCODE_NODE_MODULES.fs,i=globalThis._VSCODE_NODE_MODULES.vm,n=globalThis._VSCODE_NODE_MODULES.module,r=N.URI.parse(o).fsPath,m=h.readFileSync(r).toString(),E=n.wrap(m.replace(/^#!.*/,""));return new i.Script(E).runInThisContext().apply(),this.c.pop()}catch(h){throw h}}}const t=new Map;let d={};typeof globalThis.require=="object"&&(d=globalThis.require.paths??{});async function $(l,o,h){if(P.$T){h===void 0&&(h=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),d[l]&&(l=d[l]);const i=`${l}/${o}`;if(t.has(i))return t.get(i);let n;if(/^\w[\w\d+.-]*:\/\//.test(i))n=i;else{const R=`${h&&!v.$o?S.$lg:S.$kg}/${i}`;n=S.$og.asBrowserUri(R).toString(!0)}const r=f.INSTANCE.load(n);return t.set(i,r),r}else return await new Promise((i,n)=>{H([l],i,n)})}e.$fD=$}),define(V[19],p([0,1,32,18,33,3,17,8]),function(H,e,P,S,v,N,s,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rg=e.DataUri=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Mg=e.$Lg=e.$Kg=e.$Jg=e.$Ig=e.$Hg=e.$Gg=e.$Fg=e.$Eg=e.$Dg=e.$Cg=e.$Bg=e.$Ag=e.$zg=e.$yg=e.$xg=e.$wg=e.$vg=void 0;function t(h){return(0,f.$wc)(h,!0)}e.$vg=t;class d{constructor(i){this.a=i}compare(i,n,r=!1){return i===n?0:(0,s.$5e)(this.getComparisonKey(i,r),this.getComparisonKey(n,r))}isEqual(i,n,r=!1){return i===n?!0:!i||!n?!1:this.getComparisonKey(i,r)===this.getComparisonKey(n,r)}getComparisonKey(i,n=!1){return i.with({path:this.a(i)?i.path.toLowerCase():void 0,fragment:n?null:void 0}).toString()}ignorePathCasing(i){return this.a(i)}isEqualOrParent(i,n,r=!1){if(i.scheme===n.scheme){if(i.scheme===S.Schemas.file)return P.$8f(t(i),t(n),this.a(i))&&i.query===n.query&&(r||i.fragment===n.fragment);if((0,e.$Mg)(i.authority,n.authority))return P.$8f(i.path,n.path,this.a(i),"/")&&i.query===n.query&&(r||i.fragment===n.fragment)}return!1}joinPath(i,...n){return f.URI.joinPath(i,...n)}basenameOrAuthority(i){return(0,e.$Eg)(i)||i.authority}basename(i){return v.$gc.basename(i.path)}extname(i){return v.$gc.extname(i.path)}dirname(i){if(i.path.length===0)return i;let n;return i.scheme===S.Schemas.file?n=f.URI.file(v.$mc(t(i))).path:(n=v.$gc.dirname(i.path),i.authority&&n.length&&n.charCodeAt(0)!==47&&(console.error(`dirname("${i.toString})) resulted in a relative path`),n="/")),i.with({path:n})}normalizePath(i){if(!i.path.length)return i;let n;return i.scheme===S.Schemas.file?n=f.URI.file(v.$hc(t(i))).path:n=v.$gc.normalize(i.path),i.with({path:n})}relativePath(i,n){if(i.scheme!==n.scheme||!(0,e.$Mg)(i.authority,n.authority))return;if(i.scheme===S.Schemas.file){const E=v.$lc(t(i),t(n));return N.$i?P.$2f(E):E}let r=i.path||"/";const m=n.path||"/";if(this.a(i)){let E=0;for(const R=Math.min(r.length,m.length);E<R&&!(r.charCodeAt(E)!==m.charCodeAt(E)&&r.charAt(E).toLowerCase()!==m.charAt(E).toLowerCase());E++);r=m.substr(0,E)+r.substr(E)}return v.$gc.relative(r,m)}resolvePath(i,n){if(i.scheme===S.Schemas.file){const r=f.URI.file(v.$kc(t(i),n));return i.with({authority:r.authority,path:r.path})}return n=P.$3f(n),i.with({path:v.$gc.resolve(i.path,n)})}isAbsolutePath(i){return!!i.path&&i.path[0]==="/"}isEqualAuthority(i,n){return i===n||i!==void 0&&n!==void 0&&(0,s.$_e)(i,n)}hasTrailingPathSeparator(i,n=v.sep){if(i.scheme===S.Schemas.file){const r=t(i);return r.length>P.$4f(r).length&&r[r.length-1]===n}else{const r=i.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(i.fsPath)}}removeTrailingPathSeparator(i,n=v.sep){return(0,e.$Ng)(i,n)?i.with({path:i.path.substr(0,i.path.length-1)}):i}addTrailingPathSeparator(i,n=v.sep){let r=!1;if(i.scheme===S.Schemas.file){const m=t(i);r=m!==void 0&&m.length===P.$4f(m).length&&m[m.length-1]===n}else{n="/";const m=i.path;r=m.length===1&&m.charCodeAt(m.length-1)===47}return!r&&!(0,e.$Ng)(i,n)?i.with({path:i.path+"/"}):i}}e.$wg=d,e.$xg=new d(()=>!1),e.$yg=new d(h=>h.scheme===S.Schemas.file?!N.$k:!0),e.$zg=new d(h=>!0),e.$Ag=e.$xg.isEqual.bind(e.$xg),e.$Bg=e.$xg.isEqualOrParent.bind(e.$xg),e.$Cg=e.$xg.getComparisonKey.bind(e.$xg),e.$Dg=e.$xg.basenameOrAuthority.bind(e.$xg),e.$Eg=e.$xg.basename.bind(e.$xg),e.$Fg=e.$xg.extname.bind(e.$xg),e.$Gg=e.$xg.dirname.bind(e.$xg),e.$Hg=e.$xg.joinPath.bind(e.$xg),e.$Ig=e.$xg.normalizePath.bind(e.$xg),e.$Jg=e.$xg.relativePath.bind(e.$xg),e.$Kg=e.$xg.resolvePath.bind(e.$xg),e.$Lg=e.$xg.isAbsolutePath.bind(e.$xg),e.$Mg=e.$xg.isEqualAuthority.bind(e.$xg),e.$Ng=e.$xg.hasTrailingPathSeparator.bind(e.$xg),e.$Og=e.$xg.removeTrailingPathSeparator.bind(e.$xg),e.$Pg=e.$xg.addTrailingPathSeparator.bind(e.$xg);function $(h,i){const n=[];for(let r=0;r<h.length;r++){const m=i(h[r]);h.some((E,R)=>R===r?!1:(0,e.$Bg)(m,i(E)))||n.push(h[r])}return n}e.$Qg=$;var l;(function(h){h.META_DATA_LABEL="label",h.META_DATA_DESCRIPTION="description",h.META_DATA_SIZE="size",h.META_DATA_MIME="mime";function i(n){const r=new Map;n.path.substring(n.path.indexOf(";")+1,n.path.lastIndexOf(";")).split(";").forEach(R=>{const[L,T]=R.split(":");L&&T&&r.set(L,T)});const E=n.path.substring(0,n.path.indexOf(";"));return E&&r.set(h.META_DATA_MIME,E),r}h.parseMetaData=i})(l||(e.DataUri=l={}));function o(h,i,n){if(i){let r=h.path;return r&&r[0]!==v.$gc.sep&&(r=v.$gc.sep+r),h.with({scheme:n,authority:i,path:r})}return h.with({scheme:n})}e.$Rg=o}),define(V[20],p([0,1,46,6,35,2,19,3,27,26]),function(H,e,P,S,v,N,s,f,t,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wh=e.$vh=e.$uh=e.$th=e.$sh=e.$rh=e.Promises=e.$qh=e.$ph=e.$oh=e.$nh=e.$mh=e.$lh=e.$kh=e.$jh=e.$ih=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=e.$Zg=e.$Yg=e.$Xg=e.$Wg=e.$Vg=e.$Ug=e.$Tg=e.$Sg=void 0;function $(j){return!!j&&typeof j.then=="function"}e.$Sg=$;function l(j){const u=new P.$6d,w=j(u.token),A=new Promise((U,B)=>{const Y=u.token.onCancellationRequested(()=>{Y.dispose(),B(new S.$5)});Promise.resolve(w).then(Q=>{Y.dispose(),u.dispose(),U(Q)},Q=>{Y.dispose(),u.dispose(),B(Q)})});return new class{cancel(){u.cancel(),u.dispose()}then(U,B){return A.then(U,B)}catch(U){return this.then(void 0,U)}finally(U){return A.finally(U)}}}e.$Tg=l;function o(j,u,w){return new Promise((A,U)=>{const B=u.onCancellationRequested(()=>{B.dispose(),A(w)});j.then(A,U).finally(()=>B.dispose())})}e.$Ug=o;function h(j,u){return new Promise((w,A)=>{const U=u.onCancellationRequested(()=>{U.dispose(),A(new S.$5)});j.then(w,A).finally(()=>U.dispose())})}e.$Vg=h;async function i(j){let u=-1;const w=j.map((A,U)=>A.then(B=>(u=U,B)));try{return await Promise.race(w)}finally{j.forEach((A,U)=>{U!==u&&A.cancel()})}}e.$Wg=i;function n(j,u,w){let A;const U=setTimeout(()=>{A?.(void 0),w?.()},u);return Promise.race([j.finally(()=>clearTimeout(U)),new Promise(B=>A=B)])}e.$Xg=n;function r(j){return new Promise((u,w)=>{const A=j();$(A)?A.then(u,w):u(A)})}e.$Yg=r;class m{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(u){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=u,!this.b){const w=()=>{if(this.b=null,this.f)return;const A=this.queue(this.d);return this.d=null,A};this.b=new Promise(A=>{this.a.then(w,w).then(A)})}return new Promise((w,A)=>{this.b.then(w,A)})}return this.a=u(),new Promise((w,A)=>{this.a.then(U=>{this.a=null,w(U)},U=>{this.a=null,A(U)})})}dispose(){this.f=!0}}e.$Zg=m;class E{constructor(){this.a=Promise.resolve(null)}queue(u){return this.a=this.a.then(()=>u(),()=>u())}}e.$1g=E;class R{constructor(){this.a=new Map}queue(u,w){const U=(this.a.get(u)??Promise.resolve()).catch(()=>{}).then(w).finally(()=>{this.a.get(u)===U&&this.a.delete(u)});return this.a.set(u,U),U}}e.$2g=R;const L=(j,u)=>{let w=!0;const A=setTimeout(()=>{w=!1,u()},j);return{isTriggered:()=>w,dispose:()=>{clearTimeout(A),w=!1}}},T=j=>{let u=!0;return queueMicrotask(()=>{u&&(u=!1,j())}),{isTriggered:()=>u,dispose:()=>{u=!1}}};class g{constructor(u){this.defaultDelay=u,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(u,w=this.defaultDelay){this.g=u,this.h(),this.b||(this.b=new Promise((U,B)=>{this.d=U,this.f=B}).then(()=>{if(this.b=null,this.d=null,this.g){const U=this.g;return this.g=null,U()}}));const A=()=>{this.a=null,this.d?.(null)};return this.a=w===t.$Sd?T(A):L(w,A),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new S.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$3g=g;class y{constructor(u){this.a=new g(u),this.b=new m}trigger(u,w){return this.a.trigger(()=>this.b.queue(u),w)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$4g=y;class O{constructor(){this.a=!1,this.b=new Promise((u,w)=>{this.d=u})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$5g=O;class F extends O{constructor(u){super(),this.f=setTimeout(()=>this.open(),u)}open(){clearTimeout(this.f),super.open()}}e.$6g=F;function D(j,u){return u?new Promise((w,A)=>{const U=setTimeout(()=>{B.dispose(),w()},j),B=u.onCancellationRequested(()=>{clearTimeout(U),B.dispose(),A(new S.$5)})}):l(w=>D(j,w))}e.$7g=D;function c(j,u=0,w){const A=setTimeout(()=>{j(),w&&U.dispose()},u),U=(0,N.$Rc)(()=>{clearTimeout(A),w?.deleteAndLeak(U)});return w?.add(U),U}e.$8g=c;function k(j){const u=[];let w=0;const A=j.length;function U(){return w<A?j[w++]():null}function B(Y){Y!=null&&u.push(Y);const Q=U();return Q?Q.then(B):Promise.resolve(u)}return Promise.resolve(null).then(B)}e.$9g=k;function M(j,u=A=>!!A,w=null){let A=0;const U=j.length,B=()=>{if(A>=U)return Promise.resolve(w);const Y=j[A++];return Promise.resolve(Y()).then(X=>u(X)?Promise.resolve(X):B())};return B()}e.$0g=M;function C(j,u=A=>!!A,w=null){if(j.length===0)return Promise.resolve(w);let A=j.length;const U=()=>{A=-1;for(const B of j)B.cancel?.()};return new Promise((B,Y)=>{for(const Q of j)Q.then(X=>{--A>=0&&u(X)?(U(),B(X)):A===0&&B(w)}).catch(X=>{--A>=0&&(U(),Y(X))})})}e.$$g=C;class b{constructor(u){this.a=0,this.b=!1,this.f=u,this.g=[],this.d=0,this.h=new v.$Vd}whenIdle(){return this.size>0?v.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(u){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((w,A)=>{this.g.push({factory:u,c:w,e:A}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const u=this.g.shift();this.d++;const w=u.factory();w.then(u.c,u.e),w.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$_g=b;class a extends b{constructor(){super(1)}}e.$ah=a;class I{constructor(){this.a=new te,this.b=0}queue(u){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,u())):this.a.run(this.b++,u())}}e.$bh=I;class z{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const u=new x;return this.b.add(u),u.p}g(){for(const[,u]of this.a)if(u.size>0)return!1;return!0}queueSize(u,w=s.$xg){const A=w.getComparisonKey(u);return this.a.get(A)?.size??0}queueFor(u,w,A=s.$xg){const U=A.getComparisonKey(u);let B=this.a.get(U);if(!B){B=new a;const Y=this.f++,Q=v.Event.once(B.onDrained)(()=>{B?.dispose(),this.a.delete(U),this.h(),this.d?.deleteAndDispose(Y),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new N.$3c),this.d.set(Y,Q),this.a.set(U,B)}return B.queue(w)}h(){this.g()&&this.j()}j(){for(const u of this.b)u.complete();this.b.clear()}dispose(){for(const[,u]of this.a)u.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$ch=z;class q{constructor(u,w){this.a=-1,typeof u=="function"&&typeof w=="number"&&this.setIfNotSet(u,w)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(u,w){this.cancel(),this.a=setTimeout(()=>{this.a=-1,u()},w)}setIfNotSet(u,w){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,u()},w))}}e.$dh=q;class W{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(u,w,A=globalThis){this.cancel();const U=A.setInterval(()=>{u()},w);this.d=(0,N.$Rc)(()=>{A.clearInterval(U),this.d=void 0})}dispose(){this.cancel()}}e.$eh=W;class K{constructor(u,w){this.b=-1,this.a=u,this.d=w,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(u=this.d){this.cancel(),this.b=setTimeout(this.f,u)}get delay(){return this.d}set delay(u){this.d=u}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$fh=K;class G{constructor(u,w){w%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${w}ms is not a multiple of 1000ms.`),this.a=u,this.b=w,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(u=this.b){u%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${u}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(u/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$gh=G;class _ extends K{constructor(u,w){super(u,w),this.j=[]}work(u){this.j.push(u),this.isScheduled()||this.schedule()}h(){const u=this.j;this.j=[],this.a?.(u)}dispose(){this.j=[],super.dispose()}}e.$hh=_;class J extends N.$Tc{constructor(u,w){super(),this.g=u,this.h=w,this.a=[],this.b=this.B(new N.$Uc),this.f=!1}get pending(){return this.a.length}work(u){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+u.length>this.g.maxBufferedWork)return!1}else if(this.pending+u.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const w of u)this.a.push(w);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new K(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$ih=J,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$kh=(j,u)=>{(0,f.$B)(()=>{if(w)return;const A=Date.now()+15;u(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,A-Date.now())}}))});let w=!1;return{dispose(){w||(w=!0)}}}:e.$kh=(j,u,w)=>{const A=j.requestIdleCallback(u,typeof w=="number"?{timeout:w}:void 0);let U=!1;return{dispose(){U||(U=!0,j.cancelIdleCallback(A))}}},e.$jh=j=>(0,e.$kh)(globalThis,j)}();class ee{constructor(u,w){this.g=!1,this.d=()=>{try{this.j=w()}catch(A){this.l=A}finally{this.g=!0}},this.f=(0,e.$kh)(u,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$lh=ee;class he extends ee{constructor(u){super(globalThis,u)}}e.$mh=he;async function oe(j,u,w){let A;for(let U=0;U<w;U++)try{return await j()}catch(B){A=B,await D(u)}throw A}e.$nh=oe;class te{isRunning(u){return typeof u=="number"?this.a?.taskId===u:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(u,w,A){return this.a={taskId:u,cancel:()=>A?.(),promise:w},w.then(()=>this.d(u),()=>this.d(u)),w}d(u){this.a&&u===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const u=this.b;this.b=void 0,u.run().then(u.promiseResolve,u.promiseReject)}}queue(u){if(this.b)this.b.run=u;else{let w,A;const U=new Promise((B,Y)=>{w=B,A=Y});this.b={run:u,promise:U,promiseResolve:w,promiseReject:A}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$oh=te;class ue{constructor(u,w=()=>Date.now()){this.d=u,this.f=w,this.a=0,this.b=0}increment(){const u=this.f();return u-this.a>this.d&&(this.a=u,this.b=0),this.b++,this.b}}e.$ph=ue;var ne;(function(j){j[j.Resolved=0]="Resolved",j[j.Rejected=1]="Rejected"})(ne||(ne={}));class x{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((u,w)=>{this.a=u,this.b=w})}complete(u){return new Promise(w=>{this.a(u),this.d={outcome:0,value:u},w()})}error(u){return new Promise(w=>{this.b(u),this.d={outcome:1,value:u},w()})}cancel(){return this.error(new S.$5)}}e.$qh=x;var ie;(function(j){async function u(A){let U;const B=await Promise.all(A.map(Y=>Y.then(Q=>Q,Q=>{U||(U=Q)})));if(typeof U<"u")throw U;return B}j.settled=u;function w(A){return new Promise(async(U,B)=>{try{await A(U,B)}catch(Y){B(Y)}})}j.withAsyncBody=w})(ie||(e.Promises=ie={}));class se{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(u){this.a=void 0,this.b=void 0,this.d=!1,this.promise=u.then(w=>(this.a=w,this.d=!0,w),w=>{throw this.b=w,this.d=!0,w})}requireValue(){if(!this.d)throw new S.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$rh=se;class ce{constructor(u){this.b=u,this.a=new d.$V(()=>new se(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$sh=ce;var re;(function(j){j[j.Initial=0]="Initial",j[j.DoneOK=1]="DoneOK",j[j.DoneError=2]="DoneError"})(re||(re={}));class Z{static fromArray(u){return new Z(w=>{w.emitMany(u)})}static fromPromise(u){return new Z(async w=>{w.emitMany(await u)})}static fromPromises(u){return new Z(async w=>{await Promise.all(u.map(async A=>w.emitOne(await A)))})}static merge(u){return new Z(async w=>{await Promise.all(u.map(async A=>{for await(const U of A)w.emitOne(U)}))})}static{this.EMPTY=Z.fromArray([])}constructor(u){this.a=0,this.b=[],this.d=null,this.f=new v.$Vd,queueMicrotask(async()=>{const w={emitOne:A=>this.g(A),emitMany:A=>this.h(A),reject:A=>this.k(A)};try{await Promise.resolve(u(w)),this.j()}catch(A){this.k(A)}finally{w.emitOne=void 0,w.emitMany=void 0,w.reject=void 0}})}[Symbol.asyncIterator](){let u=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(u<this.b.length)return{done:!1,value:this.b[u++]};if(this.a===1)return{done:!0,value:void 0};await v.Event.toPromise(this.f.event)}while(!0)}}}static map(u,w){return new Z(async A=>{for await(const U of u)A.emitOne(w(U))})}map(u){return Z.map(this,u)}static filter(u,w){return new Z(async A=>{for await(const U of u)w(U)&&A.emitOne(U)})}filter(u){return Z.filter(this,u)}static coalesce(u){return Z.filter(u,w=>!!w)}coalesce(){return Z.coalesce(this)}static async toPromise(u){const w=[];for await(const A of u)w.push(A);return w}toPromise(){return Z.toPromise(this)}g(u){this.a===0&&(this.b.push(u),this.f.fire())}h(u){this.a===0&&(this.b=this.b.concat(u),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(u){this.a===0&&(this.a=2,this.d=u,this.f.fire())}}e.$th=Z;class ae extends Z{constructor(u,w){super(w),this.l=u}cancel(){this.l.cancel()}}e.$uh=ae;function de(j){const u=new P.$6d,w=j(u.token);return new ae(u,async A=>{const U=u.token.onCancellationRequested(()=>{U.dispose(),u.dispose(),A.reject(new S.$5)});try{for await(const B of w){if(u.token.isCancellationRequested)return;A.emitOne(B)}U.dispose(),u.dispose()}catch(B){U.dispose(),u.dispose(),A.reject(B)}})}e.$vh=de;class le{constructor(){this.a=new x,this.b=new Z(A=>{if(u){A.reject(u);return}return w&&A.emitMany(w),this.d=U=>A.reject(U),this.f=U=>A.emitOne(U),this.a.p});let u,w;this.f=A=>{w||(w=[]),w.push(A)},this.d=A=>{u||(u=A)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(u){this.d(u),this.a.complete()}emitOne(u){this.f(u)}}e.$wh=le}),define(V[21],p([0,1,36]),function(H,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fC=e.$eC=e.$dC=void 0,e.$dC=new class{clone(){return this}equals(N){return this===N}};function S(N,s){return new P.$Dt([new P.$Ct(0,"",N)],s)}e.$eC=S;function v(N,s){const f=new Uint32Array(2);return f[0]=0,f[1]=(N<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new P.$Et(f,s===null?e.$dC:s)}e.$fC=v}),define(V[37],p([0,1,20,6,3,38,13,15,47,21,28,16,7]),function(H,e,P,S,v,N,s,f,t,d,$,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nC=e.$mC=e.$lC=e.$kC=e.$jC=e.$iC=void 0;var h;(function(T){T[T.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(h||(h={}));class i{constructor(g,y){this.tokenizationSupport=y,this.a=this.tokenizationSupport.getInitialState(),this.store=new r(g)}getStartState(g){return this.store.getStartState(g,this.a)}getFirstInvalidLine(){return this.store.getFirstInvalidLine(this.a)}}e.$iC=i;class n extends i{constructor(g,y,O,F){super(g,y),this._textModel=O,this._languageIdCodec=F}updateTokensUntilLine(g,y){const O=this._textModel.getLanguageId();for(;;){const F=this.getFirstInvalidLine();if(!F||F.lineNumber>y)break;const D=this._textModel.getLineContent(F.lineNumber),c=R(this._languageIdCodec,O,this.tokenizationSupport,D,!0,F.startState);g.add(F.lineNumber,c.tokens),this.store.setEndState(F.lineNumber,c.endState)}}getTokenTypeIfInsertingCharacter(g,y){const O=this.getStartState(g.lineNumber);if(!O)return 0;const F=this._textModel.getLanguageId(),D=this._textModel.getLineContent(g.lineNumber),c=D.substring(0,g.column-1)+y+D.substring(g.column-1),k=R(this._languageIdCodec,F,this.tokenizationSupport,c,!0,O),M=new o.$vt(k.tokens,c,this._languageIdCodec);if(M.getCount()===0)return 0;const C=M.findTokenIndexAtOffset(g.column-1);return M.getStandardTokenType(C)}tokenizeLineWithEdit(g,y,O){const F=g.lineNumber,D=g.column,c=this.getStartState(F);if(!c)return null;const k=this._textModel.getLineContent(F),M=k.substring(0,D-1)+O+k.substring(D-1+y),C=this._textModel.getLanguageIdAtPosition(F,0),b=R(this._languageIdCodec,C,this.tokenizationSupport,M,!0,c);return new o.$vt(b.tokens,M,this._languageIdCodec)}isCheapToTokenize(g){const y=this.store.getFirstInvalidEndStateLineNumberOrMax();return g<y||g===y&&this._textModel.getLineLength(g)<2048}tokenizeHeuristically(g,y,O){if(O<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(y<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(g,O),{heuristicTokens:!1};let F=this.b(y);const D=this._textModel.getLanguageId();for(let c=y;c<=O;c++){const k=this._textModel.getLineContent(c),M=R(this._languageIdCodec,D,this.tokenizationSupport,k,!0,F);g.add(c,M.tokens),F=M.endState}return{heuristicTokens:!0}}b(g){let y=this._textModel.getLineFirstNonWhitespaceColumn(g);const O=[];let F=null;for(let k=g-1;y>1&&k>=1;k--){const M=this._textModel.getLineFirstNonWhitespaceColumn(k);if(M!==0&&M<y&&(O.push(this._textModel.getLineContent(k)),y=M,F=this.getStartState(k),F))break}F||(F=this.tokenizationSupport.getInitialState()),O.reverse();const D=this._textModel.getLanguageId();let c=F;for(const k of O)c=R(this._languageIdCodec,D,this.tokenizationSupport,k,!1,c).endState;return c}}e.$jC=n;class r{constructor(g){this.d=g,this.a=new m,this.b=new E,this.b.addRange(new t.$2s(1,g+1))}getEndState(g){return this.a.getEndState(g)}setEndState(g,y){if(!y)throw new S.$cb("Cannot set null/undefined state");this.b.delete(g);const O=this.a.setEndState(g,y);return O&&g<this.d&&this.b.addRange(new t.$2s(g+1,g+2)),O}acceptChange(g,y){this.d+=y-g.length,this.a.acceptChange(g,y),this.b.addRangeAndResize(new t.$2s(g.startLineNumber,g.endLineNumberExclusive),y)}acceptChanges(g){for(const y of g){const[O]=(0,s.$ut)(y.text);this.acceptChange(new f.$4s(y.range.startLineNumber,y.range.endLineNumber+1),O+1)}}invalidateEndStateRange(g){this.b.addRange(new t.$2s(g.startLineNumber,g.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.getFirstInvalidEndStateLineNumber()||Number.MAX_SAFE_INTEGER}allStatesValid(){return this.b.min===null}getStartState(g,y){return g===1?y:this.getEndState(g-1)}getFirstInvalidLine(g){const y=this.getFirstInvalidEndStateLineNumber();if(y===null)return null;const O=this.getStartState(y,g);if(!O)throw new S.$cb("Start state must be defined");return{lineNumber:y,startState:O}}}e.$kC=r;class m{constructor(){this.a=new $.$gC(null)}getEndState(g){return this.a.get(g)}setEndState(g,y){const O=this.a.get(g);return O&&O.equals(y)?!1:(this.a.set(g,y),!0)}acceptChange(g,y){let O=g.length;y>0&&O>0&&(O--,y--),this.a.replace(g.startLineNumber,O,y)}acceptChanges(g){for(const y of g){const[O]=(0,s.$ut)(y.text);this.acceptChange(new f.$4s(y.range.startLineNumber,y.range.endLineNumber+1),O+1)}}}e.$lC=m;class E{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const g=this.a[0];return g.start+1===g.endExclusive?this.a.shift():this.a[0]=new t.$2s(g.start+1,g.endExclusive),g.start}delete(g){const y=this.a.findIndex(O=>O.contains(g));if(y!==-1){const O=this.a[y];O.start===g?O.endExclusive===g+1?this.a.splice(y,1):this.a[y]=new t.$2s(g+1,O.endExclusive):O.endExclusive===g+1?this.a[y]=new t.$2s(O.start,g):this.a.splice(y,1,new t.$2s(O.start,g),new t.$2s(g+1,O.endExclusive))}}addRange(g){t.$2s.addRange(g,this.a)}addRangeAndResize(g,y){let O=0;for(;!(O>=this.a.length||g.start<=this.a[O].endExclusive);)O++;let F=O;for(;!(F>=this.a.length||g.endExclusive<this.a[F].start);)F++;const D=y-g.length;for(let c=F;c<this.a.length;c++)this.a[c]=this.a[c].delta(D);if(O===F){const c=new t.$2s(g.start,g.start+y);c.isEmpty||this.a.splice(O,0,c)}else{const c=Math.min(g.start,this.a[O].start),k=Math.max(g.endExclusive,this.a[F-1].endExclusive),M=new t.$2s(c,k+D);M.isEmpty?this.a.splice(O,F-O):this.a.splice(O,F-O,M)}}toString(){return this.a.map(g=>g.toString()).join(" + ")}}e.$mC=E;function R(T,g,y,O,F,D){let c=null;if(y)try{c=y.tokenizeEncoded(O,F,D.clone())}catch(k){(0,S.$1)(k)}return c||(c=(0,d.$fC)(T.encodeLanguageId(g),D)),o.$vt.convertToEndOffset(c.tokens,O.length),c}class L{constructor(g,y){this.b=g,this.d=y,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,P.$jh)(g=>{this.f=!1,this.h(g)}))}h(g){const y=Date.now()+g.timeRemaining(),O=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<y?(0,v.$B)(O):this.g())};O()}j(){const g=this.b._textModel.getLineCount(),y=new l.$hC,O=N.$Rd.create(!1);do if(O.elapsed()>1||this.l(y)>=g)break;while(this.k());this.d.setTokens(y.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.allStatesValid():!1}l(g){const y=this.b?.getFirstInvalidLine();return y?(this.b.updateTokensUntilLine(g,y.lineNumber),y.lineNumber):this.b._textModel.getLineCount()+1}checkFinished(){this.a||this.b.store.allStatesValid()&&this.d.backgroundTokenizationFinished()}requestTokens(g,y){this.b.store.invalidateEndStateRange(new f.$4s(g,y))}}e.$nC=L}),define(V[39],p([0,1,35,2,38,14,36]),function(H,e,P,S,v,N,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wHb=void 0;class f extends S.$Tc{constructor(d,$,l,o,h,i,n){super(),this.c=d,this.f=$,this.g=l,this.h=o,this.j=h,this.m=i,this.n=n,this.a=[],this.b=this.B(new P.$Vd),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(d,$,l){throw new Error("Not supported!")}createBackgroundTokenizer(d,$){if(this.h)return this.h(d,$)}tokenizeEncoded(d,$,l){const o=Math.random()*1e4<1,h=this.n||o,i=h?new v.$Rd(!0):void 0,n=this.c.tokenizeLine2(d,l,500);if(h){const m=i.elapsed();(o||m>32)&&this.m(m,d.length,o)}if(n.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${d.substring(0,100)}`),new s.$Et(n.tokens,l);if(this.g){const m=this.a,E=n.tokens;for(let R=0,L=E.length>>>1;R<L;R++){const T=E[(R<<1)+1],g=N.$st.getLanguageId(T);m[g]||(m[g]=!0,this.b.fire(g))}}let r;return l.equals(n.ruleStack)?r=l:r=n.ruleStack,new s.$Et(n.tokens,r)}}e.$wHb=f}),define(V[40],p([0,1,21,2,11]),function(H,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xHb=void 0;class N extends S.$Tc{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(f,t,d){super(),this.a=f,this.b=t,this.c=d,this.B((0,v.keepObserved)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(f,t,d){throw new Error("Not supported!")}tokenizeEncoded(f,t,d){return f.length>=this.c.get()?(0,P.$fC)(this.a,d):this.b.tokenizeEncoded(f,t,d)}createBackgroundTokenizer(f,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(f,t)}}e.$xHb=N}),define(V[41],p([0,1,34,20,11,3,15,48,37,16,7,39,40]),function(H,e,P,S,v,N,s,f,t,d,$,l,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$CHb=void 0;class h extends f.$lv{constructor(r,m,E,R,L,T,g,y){super(r,m,E,R),this.s=L,this.t=T,this.u=g,this.a=null,this.b=!1,this.c=(0,v.observableValue)(this,-1),this.q=new S.$fh(()=>this.w(),10),this.c.set(y,void 0),this.v()}dispose(){this.b=!0,super.dispose()}onLanguageId(r,m){this.t=r,this.u=m,this.v()}onEvents(r){super.onEvents(r),this.a?.store.acceptChanges(r.changes),this.q.schedule()}acceptMaxTokenizationLineLength(r){this.c.set(r,void 0)}retokenize(r,m){this.a&&(this.a.store.invalidateEndStateRange(new s.$4s(r,m)),this.q.schedule())}async v(){this.a=null;const r=this.t,m=this.u,E=await this.s.getOrCreateGrammar(r,m);if(!(this.b||r!==this.t||m!==this.u||!E)){if(E.grammar){const R=new o.$xHb(this.u,new l.$wHb(E.grammar,E.initialState,!1,void 0,()=>!1,(L,T,g)=>{this.s.reportTokenizationTime(L,r,E.sourceExtensionId,T,g)},!1),this.c);this.a=new t.$iC(this.f.length,R)}else this.a=null;this.w()}}async w(){if(this.b||!this.a)return;if(!this.m){const{diffStateStacksRefEq:m}=await(0,P.$fD)("vscode-textmate","release/main.js");this.m=m}const r=new Date().getTime();for(;;){let m=0;const E=new d.$hC,R=new i;for(;;){const g=this.a.getFirstInvalidLine();if(g===null||m>200)break;m++;const y=this.f[g.lineNumber-1],O=this.a.tokenizationSupport.tokenizeEncoded(y,!0,g.startState);if(this.a.store.setEndState(g.lineNumber,O.endState)){const D=this.m(g.startState,O.endState);R.setState(g.lineNumber,D)}else R.setState(g.lineNumber,null);if($.$vt.convertToEndOffset(O.tokens,y.length),E.add(g.lineNumber,O.tokens),new Date().getTime()-r>20)break}if(m===0)break;const L=R.getStateDeltas();if(this.s.setTokensAndStates(this.h,E.serialize(),L),new Date().getTime()-r>20){(0,N.$B)(()=>this.w());return}}}}e.$CHb=h;class i{constructor(){this.a=-1,this.b=[]}setState(r,m){r===this.a+1?this.b[this.b.length-1].stateDeltas.push(m):this.b.push({startLineNumber:r,stateDeltas:[m]}),this.a=r}getStateDeltas(){return this.b}}}),define(V[42],p([0,1,19]),function(H,e,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$zHb=void 0;class S{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(N){if(this.a[N.scopeName]){const s=this.a[N.scopeName];P.$Ag(s.location,N.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${N.scopeName}.
Old grammar file: ${s.location.toString()}.
New grammar file: ${N.location.toString()}`)}this.a[N.scopeName]=N}getGrammarDefinition(N){return this.a[N]||null}}e.$zHb=S}),define(V[43],p([0,1,2,42]),function(H,e,P,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$BHb=e.$AHb=void 0,e.$AHb="No TM Grammar registered for this language.";class v extends P.$Tc{constructor(s,f,t,d){super(),this.a=s,this.b=t.INITIAL,this.c=new S.$zHb,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:d,loadGrammar:async $=>{const l=this.c.getGrammarDefinition($);if(!l)return this.a.logTrace(`No grammar found for scope ${$}`),null;const o=l.location;try{const h=await this.a.readFile(o);return t.parseRawGrammar(h,o.path)}catch(h){return this.a.logError(`Unable to load and parse grammar for scope ${$} from ${o}`,h),null}},getInjections:$=>{const l=$.split(".");let o=[];for(let h=1;h<=l.length;h++){const i=l.slice(0,h).join(".");o=[...o,...this.f[i]||[]]}return o}}));for(const $ of f){if(this.c.register($),$.injectTo){for(const l of $.injectTo){let o=this.f[l];o||(this.f[l]=o=[]),o.push($.scopeName)}if($.embeddedLanguages)for(const l of $.injectTo){let o=this.g[l];o||(this.g[l]=o=[]),o.push($.embeddedLanguages)}}$.language&&this.h.set($.language,$.scopeName)}}has(s){return this.h.has(s)}setTheme(s,f){this.j.setTheme(s,f)}getColorMap(){return this.j.getColorMap()}async createGrammar(s,f){const t=this.h.get(s);if(typeof t!="string")throw new Error(e.$AHb);const d=this.c.getGrammarDefinition(t);if(!d)throw new Error(e.$AHb);const $=d.embeddedLanguages;if(this.g[t]){const h=this.g[t];for(const i of h)for(const n of Object.keys(i))$[n]=i[n]}const l=Object.keys($).length>0;let o;try{o=await this.j.loadGrammarWithConfiguration(t,f,{embeddedLanguages:$,tokenTypes:d.tokenTypes,balancedBracketSelectors:d.balancedBracketSelectors,unbalancedBracketSelectors:d.unbalancedBracketSelectors})}catch(h){throw h.message&&h.message.startsWith("No grammar provided for")?new Error(e.$AHb):h}return{languageId:s,grammar:o,initialState:this.b,containsEmbeddedLanguages:l,sourceExtensionId:d.sourceExtensionId}}}e.$BHb=v}),define(V[49],p([0,1,8,43,41]),function(H,e,P,S,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationWorker=e.create=void 0;function N(f,t){return new s(f,t)}e.create=N;class s{constructor(t,d){this.f=d,this.b=new Map,this.c=[],this.a=t.host;const $=d.grammarDefinitions.map(l=>({location:P.URI.revive(l.location),language:l.language,scopeName:l.scopeName,embeddedLanguages:l.embeddedLanguages,tokenTypes:l.tokenTypes,injectTo:l.injectTo,balancedBracketSelectors:l.balancedBracketSelectors,unbalancedBracketSelectors:l.unbalancedBracketSelectors,sourceExtensionId:l.sourceExtensionId}));this.d=this.g($)}async g(t){const d=this.f.textmateMainUri,$=await new Promise((n,r)=>{H([d],n,r)}),l=await new Promise((n,r)=>{H([this.f.onigurumaMainUri],n,r)}),h=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await l.loadWASM(h);const i=Promise.resolve({createOnigScanner:n=>l.createOnigScanner(n),createOnigString:n=>l.createOnigString(n)});return new S.$BHb({logTrace:n=>{},logError:(n,r)=>console.error(n,r),readFile:n=>this.a.readFile(n)},t,$,i)}acceptNewModel(t){const d=P.URI.revive(t.uri),$=this;this.b.set(t.controllerId,new v.$CHb(d,t.lines,t.EOL,t.versionId,{async getOrCreateGrammar(l,o){const h=await $.d;return h?($.c[o]||($.c[o]=h.createGrammar(l,o)),$.c[o]):Promise.resolve(null)},setTokensAndStates(l,o,h){$.a.setTokensAndStates(t.controllerId,l,o,h)},reportTokenizationTime(l,o,h,i,n){$.a.reportTokenizationTime(l,o,h,i,n)}},t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength))}acceptModelChanged(t,d){this.b.get(t).onEvents(d)}retokenize(t,d,$){this.b.get(t).retokenize(d,$)}acceptModelLanguageChanged(t,d,$){this.b.get(t).onLanguageId(d,$)}acceptRemovedModel(t){const d=this.b.get(t);d&&(d.dispose(),this.b.delete(t))}async acceptTheme(t,d){(await this.d)?.setTheme(t,d)}acceptMaxTokenizationLineLength(t,d){this.b.get(t).acceptMaxTokenizationLineLength(d)}}e.TextMateTokenizationWorker=s})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/271fb7fbd599b49a1482ea7284a50b3229317f96/core/vs/workbench/services/textMate/browser/backgroundTokenization/worker/textMateTokenizationWorker.worker.js.map
